/* DUPLICATOR-PRO (PHP MULTI-THREADED BUILD MODE) MYSQL SCRIPT CREATED ON : 2020-08-11 16:31:29 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `cerber_acl` (
  `ip` varchar(81) CHARACTER SET ascii NOT NULL,
  `ip_long_begin` bigint(20) unsigned NOT NULL DEFAULT '0',
  `ip_long_end` bigint(20) unsigned NOT NULL DEFAULT '0',
  `tag` char(1) NOT NULL COMMENT 'Type: B or W',
  `comments` varchar(250) NOT NULL,
  `acl_slice` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ver6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `v6range` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '',
  `req_uri` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '',
  KEY `main_for_selects` (`acl_slice`,`ver6`,`ip_long_begin`,`ip_long_end`,`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cerber IP Access Lists';

CREATE TABLE `cerber_blocks` (
  `ip` varchar(39) CHARACTER SET ascii NOT NULL COMMENT 'Remote IP',
  `block_until` bigint(20) unsigned NOT NULL COMMENT 'Unix timestamp',
  `reason` varchar(250) NOT NULL COMMENT 'Why IP was blocked',
  `reason_id` int(11) unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `ip` (`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cerber list of currently blocked IPs';

CREATE TABLE `cerber_countries` (
  `country` char(3) NOT NULL DEFAULT '' COMMENT 'Country code',
  `locale` char(10) NOT NULL DEFAULT '' COMMENT 'Locale i18n',
  `country_name` varchar(250) NOT NULL DEFAULT '' COMMENT 'Country name',
  PRIMARY KEY (`country`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `cerber_lab` (
  `ip` varchar(39) CHARACTER SET ascii NOT NULL COMMENT 'Remote IP',
  `reason_id` int(11) unsigned NOT NULL DEFAULT '0',
  `stamp` bigint(20) unsigned NOT NULL COMMENT 'Unix timestamp',
  `details` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cerber lab cache';

CREATE TABLE `cerber_lab_ip` (
  `ip` varchar(39) CHARACTER SET ascii NOT NULL COMMENT 'IP',
  `reputation` int(11) unsigned NOT NULL COMMENT 'Reputation of IP',
  `expires` int(11) unsigned NOT NULL COMMENT 'Unix timestamp',
  PRIMARY KEY (`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cerber lab IP cache';

CREATE TABLE `cerber_lab_net` (
  `ip` varchar(39) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'IP address',
  `ip_long_begin` bigint(20) unsigned NOT NULL DEFAULT '0',
  `ip_long_end` bigint(20) unsigned NOT NULL DEFAULT '0',
  `country` char(3) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Country code',
  `expires` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`ip`),
  UNIQUE KEY `begin_end` (`ip_long_begin`,`ip_long_end`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cerber lab network cache';

CREATE TABLE `cerber_log` (
  `ip` varchar(39) CHARACTER SET ascii NOT NULL COMMENT 'Remote IP',
  `ip_long` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_login` varchar(60) NOT NULL COMMENT 'Username from HTTP request',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `stamp` decimal(14,4) NOT NULL,
  `activity` int(10) unsigned NOT NULL DEFAULT '0',
  `session_id` char(32) CHARACTER SET ascii NOT NULL DEFAULT '',
  `country` char(3) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Country code',
  `details` varchar(250) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Details about HTTP request',
  KEY `ip` (`ip`),
  KEY `ip_long` (`ip_long`),
  KEY `session_index` (`session_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cerber activity log';

CREATE TABLE `cerber_qmem` (
  `ip` varchar(39) CHARACTER SET ascii NOT NULL,
  `http_code` int(10) unsigned NOT NULL,
  `stamp` int(10) unsigned NOT NULL,
  KEY `ip_stamp` (`ip`,`stamp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `cerber_traffic` (
  `ip` varchar(39) CHARACTER SET ascii NOT NULL,
  `ip_long` bigint(20) unsigned NOT NULL DEFAULT '0',
  `hostname` varchar(250) NOT NULL DEFAULT '',
  `uri` text NOT NULL,
  `request_fields` mediumtext NOT NULL,
  `request_details` mediumtext NOT NULL,
  `session_id` char(32) CHARACTER SET ascii NOT NULL,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `stamp` decimal(14,4) NOT NULL,
  `processing` int(10) NOT NULL DEFAULT '0',
  `country` char(3) CHARACTER SET ascii NOT NULL DEFAULT '',
  `request_method` char(8) CHARACTER SET ascii NOT NULL,
  `http_code` int(10) unsigned NOT NULL,
  `wp_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `wp_type` int(10) unsigned NOT NULL DEFAULT '0',
  `is_bot` int(10) unsigned NOT NULL DEFAULT '0',
  `blog_id` int(10) unsigned NOT NULL DEFAULT '0',
  `php_errors` text NOT NULL,
  `req_status` int(10) unsigned NOT NULL DEFAULT '0',
  KEY `stamp` (`stamp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_actionscheduler_actions` (
  `action_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `hook` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `scheduled_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `scheduled_date_local` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `args` varchar(191) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `schedule` longtext COLLATE utf8mb4_unicode_520_ci,
  `group_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `attempts` int(11) NOT NULL DEFAULT '0',
  `last_attempt_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_attempt_local` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `claim_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `extended_args` varchar(8000) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`action_id`),
  KEY `hook` (`hook`),
  KEY `status` (`status`),
  KEY `scheduled_date_gmt` (`scheduled_date_gmt`),
  KEY `args` (`args`),
  KEY `group_id` (`group_id`),
  KEY `last_attempt_gmt` (`last_attempt_gmt`),
  KEY `claim_id` (`claim_id`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_actionscheduler_claims` (
  `claim_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `date_created_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`claim_id`),
  KEY `date_created_gmt` (`date_created_gmt`)
) ENGINE=MyISAM AUTO_INCREMENT=269 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_actionscheduler_groups` (
  `group_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `slug` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`group_id`),
  KEY `slug` (`slug`(191))
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_actionscheduler_logs` (
  `log_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `action_id` bigint(20) unsigned NOT NULL,
  `message` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `log_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `log_date_local` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`log_id`),
  KEY `action_id` (`action_id`),
  KEY `log_date_gmt` (`log_date_gmt`)
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_booking` (
  `booking_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `trash` bigint(10) NOT NULL DEFAULT '0',
  `sync_gid` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `is_new` bigint(10) NOT NULL DEFAULT '1',
  `status` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `sort_date` datetime DEFAULT NULL,
  `modification_date` datetime DEFAULT NULL,
  `form` text COLLATE utf8mb4_unicode_520_ci,
  `booking_type` bigint(10) NOT NULL DEFAULT '1',
  PRIMARY KEY (`booking_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_bookingdates` (
  `booking_id` bigint(20) unsigned NOT NULL,
  `booking_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `approved` bigint(20) unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `booking_id_dates` (`booking_id`,`booking_date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_cerber_files` (
  `scan_id` int(10) unsigned NOT NULL,
  `scan_type` int(10) unsigned NOT NULL DEFAULT '1',
  `scan_mode` int(10) unsigned NOT NULL DEFAULT '0',
  `scan_status` int(10) unsigned NOT NULL DEFAULT '0',
  `file_status` int(10) unsigned NOT NULL DEFAULT '0',
  `file_name_hash` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '',
  `file_name` text NOT NULL,
  `file_type` int(10) unsigned NOT NULL DEFAULT '0',
  `file_hash` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '',
  `file_md5` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '',
  `file_hash_repo` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '',
  `hash_match` int(10) unsigned NOT NULL DEFAULT '0',
  `file_size` bigint(20) unsigned NOT NULL DEFAULT '0',
  `file_perms` int(11) NOT NULL DEFAULT '0',
  `file_writable` int(10) unsigned NOT NULL DEFAULT '0',
  `file_mtime` int(10) unsigned NOT NULL DEFAULT '0',
  `file_ext` varchar(255) NOT NULL DEFAULT '',
  `extra` text NOT NULL,
  PRIMARY KEY (`scan_id`,`file_name_hash`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_cerber_sets` (
  `the_key` varchar(255) CHARACTER SET ascii NOT NULL,
  `the_id` bigint(20) NOT NULL DEFAULT '0',
  `the_value` longtext NOT NULL,
  `expires` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`the_key`,`the_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_cerber_uss` (
  `user_id` bigint(20) unsigned NOT NULL,
  `ip` varchar(39) CHARACTER SET ascii NOT NULL,
  `country` char(3) CHARACTER SET ascii NOT NULL DEFAULT '',
  `started` int(10) unsigned NOT NULL,
  `expires` int(10) unsigned NOT NULL,
  `session_id` char(32) CHARACTER SET ascii NOT NULL DEFAULT '',
  `wp_session_token` varchar(250) CHARACTER SET ascii NOT NULL,
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10)),
  KEY `woo_idx_comment_type` (`comment_type`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_cuteslider` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `data` text NOT NULL,
  `date_c` int(10) NOT NULL,
  `date_m` int(11) NOT NULL,
  `flag_hidden` tinyint(1) NOT NULL DEFAULT '0',
  `flag_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_duplicator_pro_entities` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `data` text COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `type_idx` (`type`(250))
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_duplicator_pro_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) COLLATE utf8mb4_unicode_ci NOT NULL,
  `hash` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8mb4_unicode_ci NOT NULL,
  `package` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_hotel_booking_order_itemmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `hotel_booking_order_item_id` bigint(20) unsigned NOT NULL,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  UNIQUE KEY `meta_id` (`meta_id`),
  KEY `hotel_booking_order_item_id` (`hotel_booking_order_item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_hotel_booking_order_items` (
  `order_item_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `order_item_name` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `order_item_type` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `order_item_parent` bigint(20) DEFAULT NULL,
  `order_id` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`order_item_id`),
  UNIQUE KEY `order_item_id` (`order_item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_hotel_booking_plans` (
  `plan_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `room_id` bigint(20) unsigned NOT NULL,
  `start_time` timestamp NULL DEFAULT NULL,
  `end_time` timestamp NULL DEFAULT NULL,
  `pricing` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`plan_id`),
  UNIQUE KEY `plan_id` (`plan_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_mailchimp_carts` (
  `id` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` int(11) DEFAULT NULL,
  `cart` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`email`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_mailchimp_jobs` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `obj_id` text COLLATE utf8mb4_unicode_520_ci,
  `job` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_mp_timetable_data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `column_id` int(11) NOT NULL,
  `event_id` int(11) NOT NULL,
  `event_start` time NOT NULL,
  `event_end` time NOT NULL,
  `user_id` int(11) NOT NULL,
  `description` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_mphb_sync_logs` (
  `log_id` int(11) NOT NULL AUTO_INCREMENT,
  `queue_id` int(11) NOT NULL,
  `log_status` varchar(30) NOT NULL,
  `log_message` text NOT NULL,
  `log_context` text NOT NULL,
  PRIMARY KEY (`log_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_mphb_sync_queue` (
  `queue_id` int(11) NOT NULL AUTO_INCREMENT,
  `queue_name` tinytext NOT NULL,
  `queue_status` varchar(30) NOT NULL,
  PRIMARY KEY (`queue_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_mphb_sync_stats` (
  `stat_id` int(11) NOT NULL AUTO_INCREMENT,
  `queue_id` int(11) NOT NULL,
  `import_total` int(11) NOT NULL DEFAULT '0',
  `import_succeed` int(11) NOT NULL DEFAULT '0',
  `import_skipped` int(11) NOT NULL DEFAULT '0',
  `import_failed` int(11) NOT NULL DEFAULT '0',
  `clean_total` int(11) NOT NULL DEFAULT '0',
  `clean_done` int(11) NOT NULL DEFAULT '0',
  `clean_skipped` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`stat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_mphb_sync_urls` (
  `url_id` int(11) NOT NULL AUTO_INCREMENT,
  `room_id` int(11) NOT NULL,
  `sync_id` varchar(32) NOT NULL,
  `calendar_url` varchar(250) NOT NULL,
  PRIMARY KEY (`url_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=MyISAM AUTO_INCREMENT=1853 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM AUTO_INCREMENT=576 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=MyISAM AUTO_INCREMENT=169 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_css` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `handle` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` longtext COLLATE utf8mb4_unicode_ci,
  `hover` longtext COLLATE utf8mb4_unicode_ci,
  `advanced` longtext COLLATE utf8mb4_unicode_ci,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=117 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_css_bkp` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `handle` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` longtext COLLATE utf8mb4_unicode_ci,
  `hover` longtext COLLATE utf8mb4_unicode_ci,
  `advanced` longtext COLLATE utf8mb4_unicode_ci,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=48 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_layer_animations` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `handle` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `params` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_layer_animations_bkp` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `handle` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `params` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_navigations` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL,
  `handle` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL,
  `type` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL,
  `css` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `markup` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` longtext COLLATE utf8mb4_unicode_ci,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_navigations_bkp` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL,
  `handle` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL,
  `type` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL,
  `css` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `markup` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` longtext COLLATE utf8mb4_unicode_ci,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_sliders` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `title` tinytext COLLATE utf8mb4_unicode_ci NOT NULL,
  `alias` tinytext COLLATE utf8mb4_unicode_ci,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci,
  `type` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=46 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_sliders_bkp` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `title` tinytext COLLATE utf8mb4_unicode_ci NOT NULL,
  `alias` tinytext COLLATE utf8mb4_unicode_ci,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci,
  `type` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_slides` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `slider_id` int(9) NOT NULL,
  `slide_order` int(11) NOT NULL,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `layers` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=213 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_slides_bkp` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `slider_id` int(9) NOT NULL,
  `slide_order` int(11) NOT NULL,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `layers` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_static_slides` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `slider_id` int(9) NOT NULL,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `layers` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=22 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_revslider_static_slides_bkp` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `slider_id` int(9) NOT NULL,
  `params` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `layers` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `settings` text COLLATE utf8mb4_unicode_ci NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_sbi_instagram_feeds_posts` (
  `record_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `id` int(11) unsigned NOT NULL,
  `instagram_id` varchar(1000) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `feed_id` varchar(1000) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`record_id`),
  KEY `feed_id` (`feed_id`(100))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_sbi_instagram_posts` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `created_on` datetime DEFAULT NULL,
  `instagram_id` varchar(1000) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `time_stamp` datetime DEFAULT NULL,
  `top_time_stamp` datetime DEFAULT NULL,
  `json_data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `media_id` varchar(1000) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `sizes` varchar(1000) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `aspect_ratio` decimal(4,2) NOT NULL DEFAULT '0.00',
  `images_done` tinyint(1) NOT NULL DEFAULT '0',
  `last_requested` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=MyISAM AUTO_INCREMENT=520 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_tinvwl_analytics` (
  `ID` varchar(32) NOT NULL,
  `wishlist_id` bigint(20) NOT NULL DEFAULT '0',
  `product_id` bigint(20) NOT NULL DEFAULT '0',
  `variation_id` bigint(20) NOT NULL DEFAULT '0',
  `visite_author` bigint(20) NOT NULL DEFAULT '0',
  `visite` bigint(20) NOT NULL DEFAULT '0',
  `click_author` bigint(20) NOT NULL DEFAULT '0',
  `click` bigint(20) NOT NULL DEFAULT '0',
  `cart` bigint(20) NOT NULL DEFAULT '0',
  `sell_of_wishlist` bigint(20) NOT NULL DEFAULT '0',
  `sell_as_gift` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `unique_product` (`wishlist_id`,`product_id`,`variation_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_tinvwl_items` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `wishlist_id` bigint(20) NOT NULL DEFAULT '0',
  `product_id` bigint(20) NOT NULL DEFAULT '0',
  `variation_id` bigint(20) NOT NULL DEFAULT '0',
  `formdata` text,
  `author` bigint(20) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `quantity` bigint(20) NOT NULL DEFAULT '1',
  `price` varchar(255) NOT NULL DEFAULT '0',
  `in_stock` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_tinvwl_lists` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `author` bigint(20) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `title` text,
  `status` varchar(20) NOT NULL DEFAULT 'public',
  `type` varchar(20) NOT NULL DEFAULT 'list',
  `share_key` varchar(45) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM AUTO_INCREMENT=34 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp8b_wc_admin_note_actions` (
  `action_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `note_id` bigint(20) unsigned NOT NULL,
  `name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `label` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `query` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `status` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `is_primary` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`action_id`),
  KEY `note_id` (`note_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_admin_notes` (
  `note_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `locale` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `title` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `icon` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'info',
  `content_data` longtext COLLATE utf8mb4_unicode_520_ci,
  `status` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `source` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_reminder` datetime DEFAULT NULL,
  `is_snoozable` tinyint(1) NOT NULL DEFAULT '0',
  `layout` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `image` varchar(200) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `is_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`note_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_category_lookup` (
  `category_tree_id` bigint(20) unsigned NOT NULL,
  `category_id` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`category_tree_id`,`category_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_customer_lookup` (
  `customer_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned DEFAULT NULL,
  `username` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `first_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `last_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `email` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `date_last_active` timestamp NULL DEFAULT NULL,
  `date_registered` timestamp NULL DEFAULT NULL,
  `country` char(2) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `postcode` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `city` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `state` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`customer_id`),
  UNIQUE KEY `user_id` (`user_id`),
  KEY `email` (`email`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_download_log` (
  `download_log_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `timestamp` datetime NOT NULL,
  `permission_id` bigint(20) unsigned NOT NULL,
  `user_id` bigint(20) unsigned DEFAULT NULL,
  `user_ip_address` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  PRIMARY KEY (`download_log_id`),
  KEY `permission_id` (`permission_id`),
  KEY `timestamp` (`timestamp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_order_coupon_lookup` (
  `order_id` bigint(20) unsigned NOT NULL,
  `coupon_id` bigint(20) unsigned NOT NULL,
  `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `discount_amount` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`order_id`,`coupon_id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `date_created` (`date_created`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_order_product_lookup` (
  `order_item_id` bigint(20) unsigned NOT NULL,
  `order_id` bigint(20) unsigned NOT NULL,
  `product_id` bigint(20) unsigned NOT NULL,
  `variation_id` bigint(20) unsigned NOT NULL,
  `customer_id` bigint(20) unsigned DEFAULT NULL,
  `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `product_qty` int(11) NOT NULL,
  `product_net_revenue` double NOT NULL DEFAULT '0',
  `product_gross_revenue` double NOT NULL DEFAULT '0',
  `coupon_amount` double NOT NULL DEFAULT '0',
  `tax_amount` double NOT NULL DEFAULT '0',
  `shipping_amount` double NOT NULL DEFAULT '0',
  `shipping_tax_amount` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`order_item_id`),
  KEY `order_id` (`order_id`),
  KEY `product_id` (`product_id`),
  KEY `customer_id` (`customer_id`),
  KEY `date_created` (`date_created`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_order_stats` (
  `order_id` bigint(20) unsigned NOT NULL,
  `parent_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_created_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `num_items_sold` int(11) NOT NULL DEFAULT '0',
  `total_sales` double NOT NULL DEFAULT '0',
  `tax_total` double NOT NULL DEFAULT '0',
  `shipping_total` double NOT NULL DEFAULT '0',
  `net_total` double NOT NULL DEFAULT '0',
  `returning_customer` tinyint(1) DEFAULT NULL,
  `status` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `customer_id` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`order_id`),
  KEY `date_created` (`date_created`),
  KEY `customer_id` (`customer_id`),
  KEY `status` (`status`(191))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_order_tax_lookup` (
  `order_id` bigint(20) unsigned NOT NULL,
  `tax_rate_id` bigint(20) unsigned NOT NULL,
  `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `shipping_tax` double NOT NULL DEFAULT '0',
  `order_tax` double NOT NULL DEFAULT '0',
  `total_tax` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`order_id`,`tax_rate_id`),
  KEY `tax_rate_id` (`tax_rate_id`),
  KEY `date_created` (`date_created`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_product_meta_lookup` (
  `product_id` bigint(20) NOT NULL,
  `sku` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `virtual` tinyint(1) DEFAULT '0',
  `downloadable` tinyint(1) DEFAULT '0',
  `min_price` decimal(19,4) DEFAULT NULL,
  `max_price` decimal(19,4) DEFAULT NULL,
  `onsale` tinyint(1) DEFAULT '0',
  `stock_quantity` double DEFAULT NULL,
  `stock_status` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT 'instock',
  `rating_count` bigint(20) DEFAULT '0',
  `average_rating` decimal(3,2) DEFAULT '0.00',
  `total_sales` bigint(20) DEFAULT '0',
  `tax_status` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT 'taxable',
  `tax_class` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  PRIMARY KEY (`product_id`),
  KEY `virtual` (`virtual`),
  KEY `downloadable` (`downloadable`),
  KEY `stock_status` (`stock_status`),
  KEY `stock_quantity` (`stock_quantity`),
  KEY `onsale` (`onsale`),
  KEY `min_max_price` (`min_price`,`max_price`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_reserved_stock` (
  `order_id` bigint(20) NOT NULL,
  `product_id` bigint(20) NOT NULL,
  `stock_quantity` double NOT NULL DEFAULT '0',
  `timestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `expires` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`order_id`,`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_tax_rate_classes` (
  `tax_rate_class_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`tax_rate_class_id`),
  UNIQUE KEY `slug` (`slug`(191))
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wc_webhooks` (
  `webhook_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `status` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `name` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` bigint(20) unsigned NOT NULL,
  `delivery_url` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `secret` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `topic` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_created_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `api_version` smallint(4) NOT NULL,
  `failure_count` smallint(10) NOT NULL DEFAULT '0',
  `pending_delivery` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`webhook_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_wdi_feeds` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `feed_name` tinytext NOT NULL,
  `feed_thumb` varchar(800) NOT NULL,
  `thumb_user` varchar(30) NOT NULL,
  `published` varchar(1) NOT NULL,
  `theme_id` varchar(10) NOT NULL,
  `feed_users` varchar(2000) NOT NULL,
  `feed_display_view` varchar(30) NOT NULL,
  `sort_images_by` varchar(30) NOT NULL,
  `display_order` varchar(30) NOT NULL,
  `follow_on_instagram_btn` varchar(1) NOT NULL,
  `display_header` varchar(1) NOT NULL,
  `number_of_photos` varchar(10) NOT NULL,
  `load_more_number` varchar(10) NOT NULL,
  `pagination_per_page_number` varchar(10) NOT NULL,
  `pagination_preload_number` varchar(10) NOT NULL,
  `image_browser_preload_number` varchar(10) NOT NULL,
  `image_browser_load_number` varchar(10) NOT NULL,
  `number_of_columns` varchar(30) NOT NULL,
  `resort_after_load_more` varchar(1) NOT NULL,
  `show_likes` varchar(1) NOT NULL,
  `show_description` varchar(1) NOT NULL,
  `show_comments` varchar(1) NOT NULL,
  `show_usernames` varchar(1) NOT NULL,
  `display_user_info` varchar(1) NOT NULL,
  `display_user_post_follow_number` varchar(1) NOT NULL,
  `show_full_description` varchar(1) NOT NULL,
  `disable_mobile_layout` varchar(1) NOT NULL,
  `feed_type` varchar(30) NOT NULL,
  `feed_item_onclick` varchar(30) NOT NULL,
  `popup_fullscreen` varchar(1) NOT NULL,
  `popup_width` varchar(64) NOT NULL,
  `popup_height` varchar(64) NOT NULL,
  `popup_type` varchar(64) NOT NULL,
  `popup_autoplay` varchar(1) NOT NULL,
  `popup_interval` varchar(64) NOT NULL,
  `popup_enable_filmstrip` varchar(1) NOT NULL,
  `popup_filmstrip_height` varchar(64) NOT NULL,
  `autohide_lightbox_navigation` varchar(1) NOT NULL,
  `popup_enable_ctrl_btn` varchar(1) NOT NULL,
  `popup_enable_fullscreen` varchar(1) NOT NULL,
  `popup_enable_info` varchar(1) NOT NULL,
  `popup_info_always_show` varchar(1) NOT NULL,
  `popup_info_full_width` varchar(1) NOT NULL,
  `popup_enable_comment` varchar(1) NOT NULL,
  `popup_enable_fullsize_image` varchar(1) NOT NULL,
  `popup_enable_download` varchar(1) NOT NULL,
  `popup_enable_share_buttons` varchar(1) NOT NULL,
  `popup_enable_facebook` varchar(1) NOT NULL,
  `popup_enable_twitter` varchar(1) NOT NULL,
  `popup_enable_google` varchar(1) NOT NULL,
  `popup_enable_pinterest` varchar(1) NOT NULL,
  `popup_enable_tumblr` varchar(1) NOT NULL,
  `show_image_counts` varchar(1) NOT NULL,
  `enable_loop` varchar(1) NOT NULL,
  `popup_image_right_click` varchar(1) NOT NULL,
  `conditional_filters` varchar(10000) NOT NULL,
  `conditional_filter_type` varchar(32) NOT NULL,
  `show_username_on_thumb` varchar(32) NOT NULL,
  `conditional_filter_enable` varchar(1) NOT NULL,
  `liked_feed` varchar(30) NOT NULL,
  `mobile_breakpoint` varchar(10) NOT NULL,
  `redirect_url` varchar(255) NOT NULL,
  `feed_resolution` varchar(255) NOT NULL,
  `hashtag_top_recent` varchar(10) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wdi_themes` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `theme_name` tinytext COLLATE latin1_general_ci NOT NULL,
  `default_theme` varchar(1) COLLATE latin1_general_ci NOT NULL,
  `feed_container_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `feed_wrapper_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `feed_container_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `feed_wrapper_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `active_filter_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_position` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_img_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_text_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_font_weight` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_text_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `header_text_font_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_border_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_text_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `follow_btn_background_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_horizontal_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_img_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_background_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `users_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `users_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `users_background_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `users_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `users_font_weight` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `users_text_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `users_text_font_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `user_description_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_overlay_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_overlay_bg_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_btn_height` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_btn_margin_top` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_btn_margin_left` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_btn_pos` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_cont_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_cont_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_cont_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_btn_align` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_btn_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_ctrl_btn_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_toggle_btn_height` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_toggle_btn_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_border_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_border_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_box_shadow` varchar(128) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_height` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_top` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_right` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_full_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_btn_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_share_button_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_box_shadow` varchar(128) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_height` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_close_rl_btn_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_border_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_border_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_rl_btn_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_pos` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_margin` varchar(128) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_border_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_border_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_active_border_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_active_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_thumb_deactive_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_rl_btn_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_rl_btn_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_filmstrip_rl_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_pos` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_align` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_bg_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_border_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_border_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_title_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_title_font_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_title_font_weight` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_title_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_description_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_description_font_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_description_font_weight` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_description_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_info_height` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_pos` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_font_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_font_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_author_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_author_font_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_author_font_color_hover` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_date_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_body_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_input_border_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_input_border_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_input_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_input_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_input_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_input_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_button_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_button_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_button_border_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_button_border_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_button_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_button_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_separator_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_separator_style` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_separator_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_load_more_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `lightbox_comment_load_more_color_hover` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_wrap_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_wrap_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_wrap_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_img_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_wrap_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_meta_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_meta_one_line` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_like_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_comment_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_caption_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_caption_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_feed_item_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_caption_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_like_comm_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_overlay_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_overlay_hover_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_overlay_hover_icon_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_overlay_hover_icon_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_photo_img_hover_effect` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_wrap_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_wrap_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_wrap_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_img_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_wrap_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_meta_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_meta_one_line` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_like_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_comment_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_caption_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_caption_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_feed_item_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_caption_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_like_comm_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_overlay_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_overlay_hover_transparent` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_overlay_hover_icon_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_overlay_hover_icon_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_photo_img_hover_effect` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_wrap_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_wrap_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_wrap_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_img_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_wrap_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_meta_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_meta_one_line` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_like_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_comment_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_caption_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_caption_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_feed_item_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_photo_caption_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `blog_style_like_comm_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_wrap_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_wrap_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_wrap_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_img_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_wrap_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_meta_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_meta_one_line` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_like_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_comment_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_caption_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_caption_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_feed_item_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_photo_caption_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `image_browser_like_comm_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_position` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_padding` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_border_radius` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_height` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_width` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_border_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_border_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_text_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_text_font_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `load_more_wrap_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `pagination_ctrl_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `pagination_size` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `pagination_ctrl_margin` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `pagination_ctrl_hover_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `pagination_position` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `pagination_position_vert` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_thumb_user_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `th_thumb_user_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_thumb_user_bg_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  `mas_thumb_user_color` varchar(32) COLLATE latin1_general_ci NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

CREATE TABLE `wp8b_wfblockediplog` (
  `IP` binary(16) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `countryCode` varchar(2) NOT NULL,
  `blockCount` int(10) unsigned NOT NULL DEFAULT '0',
  `unixday` int(10) unsigned NOT NULL,
  `blockType` varchar(50) NOT NULL DEFAULT 'generic',
  PRIMARY KEY (`IP`,`unixday`,`blockType`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfblocks7` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `type` int(10) unsigned NOT NULL DEFAULT '0',
  `IP` binary(16) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `blockedTime` bigint(20) NOT NULL,
  `reason` varchar(255) NOT NULL,
  `lastAttempt` int(10) unsigned DEFAULT '0',
  `blockedHits` int(10) unsigned DEFAULT '0',
  `expiration` bigint(20) unsigned NOT NULL DEFAULT '0',
  `parameters` text,
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `IP` (`IP`),
  KEY `expiration` (`expiration`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfconfig` (
  `name` varchar(100) NOT NULL,
  `val` longblob,
  `autoload` enum('no','yes') NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfcrawlers` (
  `IP` binary(16) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `patternSig` binary(16) NOT NULL,
  `status` char(8) NOT NULL,
  `lastUpdate` int(10) unsigned NOT NULL,
  `PTR` varchar(255) DEFAULT '',
  PRIMARY KEY (`IP`,`patternSig`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wffilechanges` (
  `filenameHash` char(64) NOT NULL,
  `file` varchar(1000) NOT NULL,
  `md5` char(32) NOT NULL,
  PRIMARY KEY (`filenameHash`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wffilemods` (
  `filenameMD5` binary(16) NOT NULL,
  `filename` varchar(1000) NOT NULL,
  `knownFile` tinyint(3) unsigned NOT NULL,
  `oldMD5` binary(16) NOT NULL,
  `newMD5` binary(16) NOT NULL,
  `SHAC` binary(32) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `stoppedOnSignature` varchar(255) NOT NULL DEFAULT '',
  `stoppedOnPosition` int(10) unsigned NOT NULL DEFAULT '0',
  `isSafeFile` varchar(1) NOT NULL DEFAULT '?',
  PRIMARY KEY (`filenameMD5`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfhits` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `attackLogTime` double(17,6) unsigned NOT NULL,
  `ctime` double(17,6) unsigned NOT NULL,
  `IP` binary(16) DEFAULT NULL,
  `jsRun` tinyint(4) DEFAULT '0',
  `statusCode` int(11) NOT NULL DEFAULT '200',
  `isGoogle` tinyint(4) NOT NULL,
  `userID` int(10) unsigned NOT NULL,
  `newVisit` tinyint(3) unsigned NOT NULL,
  `URL` text,
  `referer` text,
  `UA` text,
  `action` varchar(64) NOT NULL DEFAULT '',
  `actionDescription` text,
  `actionData` text,
  PRIMARY KEY (`id`),
  KEY `k1` (`ctime`),
  KEY `k2` (`IP`,`ctime`),
  KEY `attackLogTime` (`attackLogTime`)
) ENGINE=MyISAM AUTO_INCREMENT=22 DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfhoover` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `owner` text,
  `host` text,
  `path` text,
  `hostKey` varbinary(124) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `k2` (`hostKey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfissues` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `time` int(10) unsigned NOT NULL,
  `lastUpdated` int(10) unsigned NOT NULL,
  `status` varchar(10) NOT NULL,
  `type` varchar(20) NOT NULL,
  `severity` tinyint(3) unsigned NOT NULL,
  `ignoreP` char(32) NOT NULL,
  `ignoreC` char(32) NOT NULL,
  `shortMsg` varchar(255) NOT NULL,
  `longMsg` text,
  `data` text,
  PRIMARY KEY (`id`),
  KEY `lastUpdated` (`lastUpdated`),
  KEY `status` (`status`),
  KEY `ignoreP` (`ignoreP`),
  KEY `ignoreC` (`ignoreC`)
) ENGINE=MyISAM AUTO_INCREMENT=33 DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfknownfilelist` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `path` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=14078 DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wflivetraffichuman` (
  `IP` binary(16) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `identifier` binary(32) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `expiration` int(10) unsigned NOT NULL,
  PRIMARY KEY (`IP`,`identifier`),
  KEY `expiration` (`expiration`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wflocs` (
  `IP` binary(16) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `ctime` int(10) unsigned NOT NULL,
  `failed` tinyint(3) unsigned NOT NULL,
  `city` varchar(255) DEFAULT '',
  `region` varchar(255) DEFAULT '',
  `countryName` varchar(255) DEFAULT '',
  `countryCode` char(2) DEFAULT '',
  `lat` float(10,7) DEFAULT '0.0000000',
  `lon` float(10,7) DEFAULT '0.0000000',
  PRIMARY KEY (`IP`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wflogins` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `hitID` int(11) DEFAULT NULL,
  `ctime` double(17,6) unsigned NOT NULL,
  `fail` tinyint(3) unsigned NOT NULL,
  `action` varchar(40) NOT NULL,
  `username` varchar(255) NOT NULL,
  `userID` int(10) unsigned NOT NULL,
  `IP` binary(16) DEFAULT NULL,
  `UA` text,
  PRIMARY KEY (`id`),
  KEY `k1` (`IP`,`fail`),
  KEY `hitID` (`hitID`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfls_2fa_secrets` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL,
  `secret` tinyblob NOT NULL,
  `recovery` blob NOT NULL,
  `ctime` int(10) unsigned NOT NULL,
  `vtime` int(10) unsigned NOT NULL,
  `mode` enum('authenticator') NOT NULL DEFAULT 'authenticator',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfls_settings` (
  `name` varchar(191) NOT NULL DEFAULT '',
  `value` longblob,
  `autoload` enum('no','yes') NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfnotifications` (
  `id` varchar(32) NOT NULL DEFAULT '',
  `new` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `category` varchar(255) NOT NULL,
  `priority` int(11) NOT NULL DEFAULT '1000',
  `ctime` int(10) unsigned NOT NULL,
  `html` text NOT NULL,
  `links` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfpendingissues` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `time` int(10) unsigned NOT NULL,
  `lastUpdated` int(10) unsigned NOT NULL,
  `status` varchar(10) NOT NULL,
  `type` varchar(20) NOT NULL,
  `severity` tinyint(3) unsigned NOT NULL,
  `ignoreP` char(32) NOT NULL,
  `ignoreC` char(32) NOT NULL,
  `shortMsg` varchar(255) NOT NULL,
  `longMsg` text,
  `data` text,
  PRIMARY KEY (`id`),
  KEY `lastUpdated` (`lastUpdated`),
  KEY `status` (`status`),
  KEY `ignoreP` (`ignoreP`),
  KEY `ignoreC` (`ignoreC`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfreversecache` (
  `IP` binary(16) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `host` varchar(255) NOT NULL,
  `lastUpdate` int(10) unsigned NOT NULL,
  PRIMARY KEY (`IP`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfsnipcache` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `IP` varchar(45) NOT NULL DEFAULT '',
  `expiration` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `body` varchar(255) NOT NULL DEFAULT '',
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  `type` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `expiration` (`expiration`),
  KEY `IP` (`IP`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wfstatus` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `ctime` double(17,6) unsigned NOT NULL,
  `level` tinyint(3) unsigned NOT NULL,
  `type` char(5) NOT NULL,
  `msg` varchar(1000) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `k1` (`ctime`),
  KEY `k2` (`type`)
) ENGINE=MyISAM AUTO_INCREMENT=6344 DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_wftrafficrates` (
  `eMin` int(10) unsigned NOT NULL,
  `IP` binary(16) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `hitType` enum('hit','404') NOT NULL DEFAULT 'hit',
  `hits` int(10) unsigned NOT NULL,
  PRIMARY KEY (`eMin`,`IP`,`hitType`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp8b_woocommerce_api_keys` (
  `key_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL,
  `description` varchar(200) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `permissions` varchar(10) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `consumer_key` char(64) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `consumer_secret` char(43) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `nonces` longtext COLLATE utf8mb4_unicode_520_ci,
  `truncated_key` char(7) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `last_access` datetime DEFAULT NULL,
  PRIMARY KEY (`key_id`),
  KEY `consumer_key` (`consumer_key`),
  KEY `consumer_secret` (`consumer_secret`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_attribute_taxonomies` (
  `attribute_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `attribute_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `attribute_label` varchar(200) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `attribute_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `attribute_orderby` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `attribute_public` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`attribute_id`),
  KEY `attribute_name` (`attribute_name`(20))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_downloadable_product_permissions` (
  `permission_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `download_id` varchar(36) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `product_id` bigint(20) unsigned NOT NULL,
  `order_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `order_key` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_email` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` bigint(20) unsigned DEFAULT NULL,
  `downloads_remaining` varchar(9) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `access_granted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access_expires` datetime DEFAULT NULL,
  `download_count` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`permission_id`),
  KEY `download_order_key_product` (`product_id`,`order_id`,`order_key`(16),`download_id`),
  KEY `download_order_product` (`download_id`,`order_id`,`product_id`),
  KEY `order_id` (`order_id`),
  KEY `user_order_remaining_expires` (`user_id`,`order_id`,`downloads_remaining`,`access_expires`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_log` (
  `log_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `timestamp` datetime NOT NULL,
  `level` smallint(4) NOT NULL,
  `source` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `message` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `context` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`log_id`),
  KEY `level` (`level`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_order_itemmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `order_item_id` bigint(20) unsigned NOT NULL,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `order_item_id` (`order_item_id`),
  KEY `meta_key` (`meta_key`(32))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_order_items` (
  `order_item_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `order_item_name` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `order_item_type` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `order_id` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`order_item_id`),
  KEY `order_id` (`order_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_payment_tokenmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `payment_token_id` bigint(20) unsigned NOT NULL,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `payment_token_id` (`payment_token_id`),
  KEY `meta_key` (`meta_key`(32))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_payment_tokens` (
  `token_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `gateway_id` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `token` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `type` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `is_default` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`token_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_sessions` (
  `session_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `session_key` char(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `session_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `session_expiry` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`session_id`),
  UNIQUE KEY `session_key` (`session_key`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_shipping_zone_locations` (
  `location_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `zone_id` bigint(20) unsigned NOT NULL,
  `location_code` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_type` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`location_id`),
  KEY `location_id` (`location_id`),
  KEY `location_type_code` (`location_type`(10),`location_code`(20))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_shipping_zone_methods` (
  `zone_id` bigint(20) unsigned NOT NULL,
  `instance_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `method_id` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `method_order` bigint(20) unsigned NOT NULL,
  `is_enabled` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`instance_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_shipping_zones` (
  `zone_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `zone_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `zone_order` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`zone_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_tax_rate_locations` (
  `location_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `location_code` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `tax_rate_id` bigint(20) unsigned NOT NULL,
  `location_type` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`location_id`),
  KEY `tax_rate_id` (`tax_rate_id`),
  KEY `location_type_code` (`location_type`(10),`location_code`(20))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp8b_woocommerce_tax_rates` (
  `tax_rate_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `tax_rate_country` varchar(2) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate_state` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate` varchar(8) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate_priority` bigint(20) unsigned NOT NULL,
  `tax_rate_compound` int(1) NOT NULL DEFAULT '0',
  `tax_rate_shipping` int(1) NOT NULL DEFAULT '1',
  `tax_rate_order` bigint(20) unsigned NOT NULL,
  `tax_rate_class` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`tax_rate_id`),
  KEY `tax_rate_country` (`tax_rate_country`),
  KEY `tax_rate_state` (`tax_rate_state`(2)),
  KEY `tax_rate_class` (`tax_rate_class`(10)),
  KEY `tax_rate_priority` (`tax_rate_priority`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;


 /* SQL Chunk Header Index 1 */ 

/* INSERT TABLE DATA: cerber_acl */
INSERT INTO `cerber_acl` VALUES('190.206.192.*', 3201220608, 3201220863, 'W', 'My subnet', 0, 0, '', '');

/* INSERT TABLE DATA: cerber_log */
INSERT INTO `cerber_log` VALUES('139.59.57.64', 2335914304, '', 0, '1594937146.3896', 70, 'V14qMzRb8EAjaXWPSyBNvtHI', '', '0|0|0|0|modelox.vico.digital///wp-json/wp/v2/users/'),
 ('89.36.224.7', 1495588871, '', 0, '1595080578.7905', 55, 'lBo1OR3cpmLSVKriM2t5ek9n', '', '19|0|0|0|modelox.vico.digital/adminer.php'),
 ('93.113.111.100', 1567715172, '', 0, '1594714433.7131', 55, 'JTGjQigbyDav4MnZBKCwH3Eh', '', '19|0|0|0|modelox.vico.digital/xmlrpc.php'),
 ('104.248.40.177', 1761093809, 'admin', 0, '1594776507.5107', 51, 'UtwyF6cuqsIH9Arvok7MWZhE', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('139.59.174.107', 2335944299, 'admin', 0, '1594786452.1223', 51, 'K3Wmbzap6J2oORtd0j85vNEr', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('142.4.7.212', 2382628820, 'admin', 0, '1594792955.9366', 51, 'PQWbnqUiHg79dj3NTh0xSrwv', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('104.199.101.230', 1757898214, '', 0, '1594800226.4204', 55, 'WRYsXZFM86ALO12zjkcVCdov', '', '19|0|0|0|modelox.vico.digital/xmlrpc.php'),
 ('62.210.89.3', 1053972739, '', 0, '1594802848.0725', 55, '1V8fKrG9bSDNnqp3h6xt2wUu', '', '19|0|0|0|modelox.vico.digital/wp-content/plugins/t_file_wp/t_file_wp.php'),
 ('148.72.210.140', 2487800460, '', 0, '1594808766.9696', 55, 'uMm4Un6IyRlBrpdgAOP0zh9S', '', '19|0|0|0|modelox.vico.digital/xmlrpc.php'),
 ('62.210.89.3', 1053972739, '', 0, '1594969484.6126', 70, 'eRNf810vXjPrwhxnt6OBSu5U', '', '0|0|0|0|modelox.vico.digital//wp-json/wp/v2/users/'),
 ('89.36.224.7', 1495588871, '', 0, '1595080581.1966', 55, '1Yv9PUklQN3s8bMrAhFcGgSi', '', '19|0|0|0|modelox.vico.digital/sql.php'),
 ('89.36.224.7', 1495588871, '', 0, '1595080582.9230', 55, 'w6kMEd4bGroLP1YvX0n2iaKO', '', '19|0|0|0|modelox.vico.digital/phpminiadmin.php'),
 ('103.133.114.31', 1736798751, '', 0, '1595098278.6632', 55, 'o20WYKvCgikU8yXcxnm6QPN1', '', '19|0|0|0|modelox.vico.digital/xmlrpc.php'),
 ('122.117.44.59', 2054499387, '', 0, '1595147653.6430', 55, 'M4NtvbBgWKzTI5x9R8FDXlaq', '', '19|0|0|0|modelox.vico.digital/xmlrpc.php'),
 ('67.205.14.147', 1137512083, '', 0, '1595164937.3026', 55, 'ftp80hDCkRxbn49MXyeOVHzT', '', '19|0|0|0|modelox.vico.digital/xmlrpc.php'),
 ('88.99.123.96', 1482914656, '', 0, '1596418810.7951', 55, 'I5NZdrl4VOD3QFjM0znWfTLx', '', '19|0|0|0|modelox.vico.digital/wp/wp-admin/setup-config.php'),
 ('88.99.123.96', 1482914656, '', 0, '1596418811.6861', 55, 'Qmhu1Jn3U9gpZi5GRtMTkrHj', '', '19|0|0|0|modelox.vico.digital/wordpress/wp-admin/setup-config.php'),
 ('201.243.46.194', 3388157634, 'demoweb', 1, '1596835696.6519', 5, 'wvOlV9YRBUtpAeIHhfiKksLy', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('186.167.242.223', 3131568863, 'manager', 0, '1596836675.5649', 51, 'UrbXoWYclqNn9eOGwp5fKVdI', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('186.167.242.223', 3131568863, 'manager', 0, '1596836691.9721', 51, '5EQkL3IUFMpjOwy9gYK4a8Cx', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('186.167.242.223', 3131568863, 'demoweb', 1, '1596836702.6536', 5, 'hgFEATVGsNItCRuBmSbQa4p5', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('201.243.46.194', 3388157634, 'demoweb', 1, '1596906760.0954', 5, '1QBeMjyFhWNOICm6EGHi9zdY', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('201.243.46.194', 3388157634, 'demoweb', 1, '1596907293.3398', 5, 'acS9frNk1VEhBGnsyWgD0HKp', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('201.243.46.194', 3388157634, 'demoweb', 0, '1596909266.6446', 7, '9Cqre5FlKJtz08WDa3Ax7i2v', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('201.243.46.194', 3388157634, 'demoweb', 1, '1596909279.0977', 5, 'wlVtMAgTf2vkxBWZPzFY1JLm', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('201.243.46.194', 3388157634, 'demoweb', 1, '1596909286.0982', 5, 'JltCmK62fopNG0DSMIdHbAFP', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('104.131.8.207', 1753417935, '', 0, '1596995010.1943', 55, '87blPcLg2Q9Ts1efYWCr3XNF', '', '19|0|0|0|www.modelox.vico.digital:80/sql.php'),
 ('186.167.250.237', 3131570925, 'manager', 0, '1597070405.8669', 51, 'KDNybmMrklGL40CgOeJcWPS3', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('186.167.250.237', 3131570925, 'demoweb', 1, '1597070421.0514', 5, 'igD8FZmos4pyErHb0VNRA6xf', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('186.167.250.237', 3131570925, 'demoweb', 1, '1597070585.9986', 5, 'w7ZpzASQUagKVdmCfjI6nbBu', '', '0|0|0|0|modelox.vico.digital/wp-login.php'),
 ('190.75.83.206', 3192607694, 'demoweb', 1, '1597160241.9959', 5, 'fagAwJ5cskuKC721mEdIMNUq', '', '0|0|0|0|modelox.vico.digital/wp-login.php');

/* INSERT TABLE DATA: cerber_traffic */
INSERT INTO `cerber_traffic` VALUES('139.59.57.64', 2335914304, '', 'http://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'flxOEI5DTRHdiBM0ePwQAvtC', 0, '1594937123.8830', 17787, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('89.36.224.7', 1495588871, '', 'http://modelox.vico.digital/adminer.php', '', 'a:1:{i:1;s:79:\"Opera/9.80 (Windows NT 6.1; MRA 8.0 (build 5981)) Presto/2.12.388 Version/12.15\";}', 'lBo1OR3cpmLSVKriM2t5ek9n', 0, '1595080578.2000', 591, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('89.36.224.7', 1495588871, '', 'http://modelox.vico.digital/sql.php', '', 'a:1:{i:1;s:136:\"Mozilla/5.0 (X11; Linux i686; Ubuntu 14.04 LTS) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/33.0.1750.0 Maxthon/1.0.3.10 Safari/537.36\";}', '1Yv9PUklQN3s8bMrAhFcGgSi', 0, '1595080579.9925', 1204, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'BhKg6GwXdUL53jZAPlQkabtm', 0, '1596268265.5592', 2808, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '3FW9bQyvMw6laD7kKhJ0YBjs', 0, '1596268316.1622', 2029, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'e9vyBDqTHO0htgV8LfuxGAio', 0, '1596399150.8616', 2706, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=0c434018b60908fab5f6e5606d263fa7&signature=5115e05cc7d520f3e0023d0079af65ec309e1add77fbe33dbb9b7b005c691a8a', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'fjuadcQMOZrpC3wKVyR6oseU', 0, '1596399153.6076', 1151, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=8b4450e71e', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=8b4450e71e\";}', '89LbpnKeJ5tw2UvWfsHhrFBS', 0, '1596399155.0468', 1246, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('88.99.123.96', 1482914656, '', 'https://modelox.vico.digital/wp/wp-admin/setup-config.php?step=1', '', 'a:1:{i:1;s:68:\"Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0\";}', 'I5NZdrl4VOD3QFjM0znWfTLx', 0, '1596418810.1794', 616, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('88.99.123.96', 1482914656, '', 'https://modelox.vico.digital/wordpress/wp-admin/setup-config.php?step=1', '', 'a:1:{i:1;s:68:\"Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0\";}', 'Qmhu1Jn3U9gpZi5GRtMTkrHj', 0, '1596418810.9405', 746, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'xvArq0cwBglU6H8jTyfXRG5u', 0, '1596596833.7032', 2542, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=69dc5cf4e3a70b1b23aad15c2870c6ca&signature=932135d2f7ffc6c7f705f5c5a294bdd6c6ec488a73da44c218e412ef3fff7e7f', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'wlTKr6RSk8zJC2WHD7u0tqYe', 0, '1596596836.2782', 1113, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Sjo6kXCQ0ZTyV9Bfae4ztcvb', 0, '1596811770.1845', 2311, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=5c410e80028d4600e5b0043050d28dbd&signature=41d51d85659809b96f0588a0ccebc49a9833d82da3351e5ff70e7096917d0b04', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '8aE4iuq1JFhOAfGLCl3Q29yc', 0, '1596811772.5920', 2188, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1', '', 'a:1:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";}', 'fNZQa415roUPKVSCAFBLhEdH', 0, '1596835672.0960', 1263, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:111:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1\";}', 'wvOlV9YRBUtpAeIHhfiKksLy', 1, '1596835694.6789', 7525, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'WZmI3ibXAQN70rTlh8OMcusL', 0, '1594776525.0977', 2152, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=2e4932c042c9605ec779a3cca6ad4df3&signature=7856d718f14947d3c4e7cd549773d7cb805c7557f5f98c333e91491e85253ff9', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'vpRNGmkZhQysDiFUwBEb1gnI', 0, '1594776527.3181', 1447, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'c9gxTp0KXvoHe14tAsFiqRaI', 0, '1594776518.5404', 3569, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('104.248.40.177', 1761093809, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'zcURoPs7Xvfb91EhCa0k3egt', 0, '1594776486.5796', 18327, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('104.248.40.177', 1761093809, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'UtwyF6cuqsIH9Arvok7MWZhE', 0, '1594776505.4444', 3351, '', 'POST', 503, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/?wordfence_syncAttackData=1594776519.8231', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:70:\"https://modelox.vico.digital/?wordfence_syncAttackData=1594776519.8231\";}', '7I3RNBtbDr0sFMip9uOWoCzg', 0, '1594776519.8517', 1041, '', 'POST', 200, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=338ae893b8716dbc24cb220e19b3ef0c&signature=e6c38132fde95ce9f6e3eb707189fe2d22e3b6c70da2ec207bd230b50b7f65fd', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'qhBPepgUDiV8GCMSr1TW7zo2', 0, '1594937151.5813', 2007, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'HFXiLA4CWUNBomnT9KaexJIk', 0, '1594937148.3222', 3175, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('139.59.57.64', 2335914304, '', 'http://modelox.vico.digital///wp-json/wp/v2/users/', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'V14qMzRb8EAjaXWPSyBNvtHI', 0, '1594937145.5801', 810, '', 'GET', 403, 0, 520, 0, 1, '', 0),
 ('139.59.57.64', 2335914304, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";i:2;s:40:\"http://modelox.vico.digital/wp-login.php\";}', 'cLbr5FKR9XfwVn8o1DxOaEtC', 0, '1594937142.4765', 1359, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('139.59.57.64', 2335914304, '', 'http://modelox.vico.digital///?author=1', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'Z4S3aIhGfsACMU5rQlO8P60D', 0, '1594937144.1863', 1319, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('89.36.224.7', 1495588871, '', 'http://modelox.vico.digital/phpmyadmin/', '', 'a:1:{i:1;s:86:\"Opera/9.80 (Windows NT 6.2; WOW64; MRA 6.0 (build 6089)) Presto/2.12.388 Version/12.16\";}', 'xET7zq40um8WwcbldAj9VyLN', 0, '1595080559.7494', 18235, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('65.154.226.109', 1100669549, '', 'http://modelox.vico.digital/wp-content/uploads/zn_fonts/Flaticon/Flaticon.ttf', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.71 Safari/537.36\";i:2;s:80:\"http://goctaprueba.vico.digital/wp-content/uploads/zn_dynamic.css?ver=1583000282\";}', 'GiJs8ZwpazLSV0cbyQuUNmH5', 0, '1595054380.5489', 1261, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('65.154.226.109', 1100669549, '', 'http://modelox.vico.digital/wp-content/uploads/zn_fonts/Flaticon/Flaticon.ttf', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.71 Safari/537.36\";i:2;s:80:\"http://goctaprueba.vico.digital/wp-content/uploads/zn_dynamic.css?ver=1583000282\";}', 'Rkh0gonbOflj3Fv8J5KQwzLZ', 0, '1595054380.5377', 1218, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('65.154.226.109', 1100669549, '', 'http://modelox.vico.digital/wp-content/uploads/zn_fonts/Flaticon/Flaticon.woff', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.71 Safari/537.36\";i:2;s:80:\"http://goctaprueba.vico.digital/wp-content/uploads/zn_dynamic.css?ver=1583000282\";}', 'OKLYSwzbJ7kCH3eDcRrB26qQ', 0, '1595054367.9348', 12613, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('65.154.226.109', 1100669549, '', 'http://modelox.vico.digital/wp-content/uploads/zn_fonts/Flaticon/Flaticon.woff', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.71 Safari/537.36\";i:2;s:80:\"http://goctaprueba.vico.digital/wp-content/uploads/zn_dynamic.css?ver=1583000282\";}', 'weM9LqBlOrYzpG3u1xDy75nI', 0, '1595054371.3916', 9156, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('75.119.215.210', 1266145234, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'i5h0mC8f7xjcrW3DHuMvdsKN', 0, '1595043236.4761', 18034, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'pcFDTdNraGC3ug4LI5xKPwzZ', 0, '1594993965.4884', 1239, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'hfvNwP5IlZ0uG2LcBUADqEaj', 0, '1594993963.6093', 1821, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'caPrI0Kju3ZRfoxYqO4TLtpw', 0, '1594993962.2808', 1272, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:66:\"https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit\";}', 'lO4fqMkNi3bw8saYpAnGSy1d', 0, '1594993958.3917', 3846, '', 'GET', 401, 0, 520, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=6480d35151', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=6480d35151\";}', 'kiDxelg7jsBNIdo6UpWJSqEv', 0, '1594993069.1935', 21040, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Gb3px2QokS6F89mXOZ51uEBf', 0, '1594993054.2519', 35228, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('69.46.36.28', 1160651804, '', 'http://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=8af18fff186a5d8614e22c4b120d07b9&signature=712ce93189c59e7ba72e70a4df22958dfd8d1ff1ab5a9c92993adf0a4694d7d6&remote=1', '', 'a:1:{i:1;s:120:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/33.0.1750.152 Safari/537.36\";}', 'RSvmwuea2HIhiPcMtglJoNTd', 0, '1594993068.0753', 21460, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=0376287a6d400f29a5c1b927b410944f&signature=d97ddbb9a131bf37f9eee8c2f73ab5809af031fad079ec14789127d154d8314b', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'hDpnwiaJfrQXCmZLeglOtvdP', 0, '1595253935.4686', 34281, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'VhgrYqH8vGDZOmf9BEIu6J7K', 0, '1595253932.2153', 3004, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=67423ffa8068a6ca439e207f97b4959f&signature=9fd2d833590e2ed74d0fa44394cb4c6ecf50bb75c94650a0545317f320799cf5', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'rb9NwIdoVOm5DvWKSYL721pP', 0, '1595253885.5538', 50699, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '7Gy3r5BpVFKwZeWQbknDaAvY', 0, '1595253883.1666', 2334, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=4ff7e5ea2f02347e59551eb8704c97d1&signature=3f008e61d0690bd1e0252e8d24edbc8ec693fba5b0b85ec635fc56430e016cdb', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '3h4Pk7X0FJdzSEQbHgRrIfnc', 0, '1595253834.5952', 51945, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=a2ff4dcf2ca73f5f47e0e1adf3c7827d&signature=8252391a46ff48972e5f08422701f023b3fedf1bd999001f8c900ba3f199b679', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'kJfLBSHrnaFmycVspNGiq1Ew', 0, '1595253784.0192', 51536, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', 'JI0v1WBiClkwGQhXAoanb9Oy', 0, '1595253802.4173', 2127, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'nye04QflROh8batHsK9M7xoE', 0, '1595253831.2206', 3296, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'FClWovqIxw8k3h15nsb9AyfU', 0, '1595253781.2334', 2750, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=671e0cc5d2edf7f1c45f3fd4a2802944&signature=88d11867a9f0c21c23f47d6ee037f18247e67c4b23135ce0d510c8e605c5e28d', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'dwbm6pEUhjAgBxC3fSvKaiJo', 0, '1595253734.4537', 50549, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'xFI6p2vRksQabV95XUAKyLEo', 0, '1595253732.2652', 2147, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=f0178938d85a967b877a6070664a2b78&signature=0a62c8963f17b8b5ca994c13f0db7474a2930db750a2a32005ada7997674ac44', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'K7SmQ8ytpXf3bCUkxvONE2sT', 0, '1595253683.6322', 51798, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=6016b3ce67', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=6016b3ce67\";}', 'WxBQFocDu3SXPpbG56n1def7', 0, '1595253689.4193', 1813, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('69.46.36.20', 1160651796, '', 'https://modelox.vico.digital/?_wfsf=detectProxy', '', 'a:1:{i:1;s:117:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.82 Safari/537.1\";}', '9upZFgcBb7QAUOqNzyMR1Yih', 0, '1595253693.6030', 836, '', 'POST', 200, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=b15db945eae886205f02cb63862bb62f&signature=eb1bcf51bef364762405aab978b11fd63856f49a3a8e58f8a5b368615979bbb3', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'IGAHwoZ9s5grDzJiBeavEbX1', 0, '1595253688.3606', 1963, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'SRJbfBo9TWvIXPM3q8lhitLU', 0, '1595253680.3578', 3211, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Y31IzEjQ06WtBSGXdmh4CRn8', 0, '1595253685.8133', 2454, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Q0Uv3Yw8sECyq5SVIpeb9Mna', 0, '1595353357.1175', 3317, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=3cd6c8b84a', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=3cd6c8b84a\";}', 'WFJfKrGI857iyHCs4BO9kAcv', 0, '1595751839.6021', 1175, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=10de66ac9f217856f09ce6b284c62a3d&signature=9c8d0bb5d42bf0aee23a962130ddf7ec9ab7d256355c3f0ff661d4cbad46964c', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'exQHRFfY93X5ioGvMmLKpUyO', 0, '1595751838.5808', 1031, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '1AdX64D9Og3mhJaRMxF8kpPI', 0, '1595751837.5032', 1043, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '0uBw9ZpDlXe2SyYRN3x8vAgc', 0, '1595751825.9636', 8725, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=25df297ffecdc5376899c13b8d5a3e8c&signature=3639ecc8926d921305c532caeebc9c1b14b1e94afa712cb892767e0b5d7179e9', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '7aNyIAsei61dvnUDuC2wLPtV', 0, '1595853384.8901', 1115, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'MJt7oE1vNwFPWkQqi4ruzg8j', 0, '1595853383.0186', 1838, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=f18838b1bb', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=f18838b1bb\";}', 'AkfE3aVrvdDoUe2FNPyYuRsx', 0, '1596149487.2527', 1063, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '4X7wtv9CYW65SqQlrcPhUTfi', 0, '1596149483.1109', 2659, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=4e3f0a1314a85f8085040109e02f9d78&signature=8a7f1d707937c9043c086cad3145176b8e98b6eb117bcc383ca3c537b454a637', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'TlPVkeLYbhA0iIKzwJ5osuE4', 0, '1596149485.8134', 1350, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=1f805441cd', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=1f805441cd\";}', 'fxGzcJXgd7epV2WihHoIErjO', 0, '1596218070.4987', 3343, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '5DCt09klaI42SHQz7wfghqmc', 0, '1596201099.2532', 2464, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=2a16c2d1fc63edbefddac8ebb9eb7d94&signature=913dc11e5a0e95391d603e0ee435834415865f4c34f05ca3a8df228fe111a923', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'REmzciwxJCnGfdWtOKM07BgU', 0, '1596201101.7604', 1126, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=6a49610dba21e82684cd1e846bd361ed&signature=1b4ab4941f9f5f3514d7cb3dc7dc069cfe2d74eb862f6d9434e5c3f7fa5ac54f', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'il0ZsmTx4VGnCX8quSBeL1jW', 0, '1596303571.4039', 1171, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=6c5c801cbb2b0c4d4c52a486b998744d&signature=56bfef412c86d2d8968b322288c2ecf0299a42f6d5f7d4fb204e1d4509484f63', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'Av6hPF78GZHgr2YKC9lbxRn4', 0, '1596906740.9464', 1763, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'aWVm7ZPMUDlJYBXhknrsRz8d', 0, '1596906739.0063', 1890, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1', '', 'a:1:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";}', 'qlVNtPzbTSMHoQmRyA5IK9W6', 0, '1596906736.1117', 1397, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('104.131.8.207', 1753417935, '', 'http://www.modelox.vico.digital:80/sql.php', '', 'a:1:{i:1;s:117:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15\";}', '87blPcLg2Q9Ts1efYWCr3XNF', 0, '1596995000.8832', 9312, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'jLeUSMN9mnzs68oqKwXud2xI', 0, '1594657418.9440', 2589, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=31a6155552a83a91136d8e2327c113dc&signature=f9e49473a86556cd4e2fb9153ee8357d38dbd83297bd21994b243ec7f37ae653', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'X8VM7LPUxvki5IZed0ozJNm6', 0, '1594657421.5688', 1347, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=e4f2ed8791', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=e4f2ed8791\";}', 'nzLoG7aT9Rs5iDO1JyA4ePQV', 0, '1594657422.6162', 1501, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('93.113.111.100', 1567715172, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'vNftqCkGRUbL4zjHM8QagrWT', 0, '1594714414.9849', 16164, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('93.113.111.100', 1567715172, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'c1DAOlZ9KwEuR2MyXtWbCNgs', 0, '1594714431.3156', 913, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('93.113.111.100', 1567715172, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'y5Du7ePsZhXzAYEiJfBjFcvI', 0, '1594714432.2727', 888, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('93.113.111.100', 1567715172, '', 'https://modelox.vico.digital/xmlrpc.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'JTGjQigbyDav4MnZBKCwH3Eh', 0, '1594714433.2014', 512, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=2218d19eed', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=2218d19eed\";}', 'ksefUI6AO3r40Ex8jKdYyW7P', 0, '1594776528.3467', 1339, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'ezbmPG4BI3yhSfkN08KdW1lJ', 0, '1594776570.1761', 2560, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=6338995fa8e2d3cf7cf18758bfecaf78&signature=b542dc9989b9b6fd1c4b92fc97bfe9fdd8cb186c5dfd27bf5faa663e5bea9bb5', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '58zRYhtvuTxlWcCKQ2AapXnH', 0, '1594776522.1637', 51605, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'QArHk3DbU9wjGfZNupdOV1zJ', 0, '1594776620.2877', 1714, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=8226617511283fdcf7da063c1abef683&signature=6b99be8180c0707a2a7a214fbce66e4cda04bd525f77926a43046c93020c280e', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'KQIyRNc0TD9HlBfodgO7jbqC', 0, '1594776572.8133', 50213, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', 'RTdqPp8uz0HLmwCvQBGAVZ3r', 0, '1594776637.2151', 2207, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '3sxAqrt16TEoVenSL9QyRkMz', 0, '1594776669.1551', 1250, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=ba74980c4f416114bd22e3a20056fc73&signature=3707c280773e96f35ae6a9a24295cfe137df45288284d95b3e45cb09dad7ff51', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'pR9vFu70sLYKDjbrQH6EnioG', 0, '1594776622.0529', 49369, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'q36o0h5kT9xnSYZ7iIPec2Rt', 0, '1594776718.7685', 2422, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=b3d509eb66e05d016730d00eff06f27b&signature=3b8de12efa64ae8f3dd83f529954c87272fa3f163d064905f5efb4dd2ed57917', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '7zWHmawBAPd18xboirIKCOXU', 0, '1594776670.4447', 51776, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=9e06235521ab463167a45fd1e8f8dad0&signature=0c32bacc3bbcb55dfd73bd8b578685c3676e4dc10b2208239d3c3bdbf529bc70', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'lYXoctE2MihZHCmPunsAf5bG', 0, '1594776721.2528', 45380, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('139.59.174.107', 2335944299, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'JQc9ByxM0dKkILSq6Vz7vhHO', 0, '1594786433.0806', 17346, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('139.59.174.107', 2335944299, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'K3Wmbzap6J2oORtd0j85vNEr', 0, '1594786450.6772', 2139, '', 'POST', 503, 0, 600, 0, 1, '', 0),
 ('142.4.7.212', 2382628820, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'LPQHG8Bon4zZj16VX5cbiktr', 0, '1594792950.5426', 2722, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/?wordfence_syncAttackData=1594792951.7821', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:70:\"https://modelox.vico.digital/?wordfence_syncAttackData=1594792951.7821\";}', 'YXb2pFOdMU7EvAqQPCa5LfGm', 0, '1594792951.8224', 2110, '', 'POST', 200, 0, 600, 0, 1, '', 0),
 ('142.4.7.212', 2382628820, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'PQWbnqUiHg79dj3NTh0xSrwv', 0, '1594792954.8967', 1694, '', 'POST', 503, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/?wordfence_syncAttackData=1594800216.7541', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:70:\"https://modelox.vico.digital/?wordfence_syncAttackData=1594800216.7541\";}', 'uqjKwk98SImRPxZneLypvYoH', 0, '1594800217.0297', 4384, '', 'POST', 200, 0, 600, 0, 1, '', 0),
 ('104.199.101.230', 1757898214, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'ZAHUQSlsvExMu5KFabzT3Ghf', 0, '1594800195.6106', 28054, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('104.199.101.230', 1757898214, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'IU8kbJmYpXtqO36ySFLMN5RQ', 0, '1594800223.9786', 910, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('104.199.101.230', 1757898214, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'hQZSTEbUwDg3Xnm8WsorPJ57', 0, '1594800224.9499', 880, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('104.199.101.230', 1757898214, '', 'https://modelox.vico.digital/xmlrpc.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'WRYsXZFM86ALO12zjkcVCdov', 0, '1594800225.8949', 526, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('62.210.89.3', 1053972739, '', 'http://modelox.vico.digital/wp-content/plugins/t_file_wp/t_file_wp.php?test=hello', '', 'a:1:{i:1;s:115:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.149 Safari/537.36\";}', '1V8fKrG9bSDNnqp3h6xt2wUu', 0, '1594802847.2697', 803, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('148.72.210.140', 2487800460, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'BJ6oRcpfI8bY1ZV75rLDiA9t', 0, '1594808744.0942', 16890, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('148.72.210.140', 2487800460, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'aevsnfdlCwQpRLWAVYEDMGK9', 0, '1594808762.3634', 992, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('148.72.210.140', 2487800460, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', '3PgLNjoa4OXWcMKC9G012STR', 0, '1594808764.3671', 982, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('148.72.210.140', 2487800460, '', 'https://modelox.vico.digital/xmlrpc.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'uMm4Un6IyRlBrpdgAOP0zh9S', 0, '1594808766.3722', 598, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=4d0e3fc256', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=4d0e3fc256\";}', 'YQopt5fdUe9LV3OliCjhRgSK', 0, '1594820295.4939', 3097, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=91fa7d7fd7', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=91fa7d7fd7\";}', 'm3NQMOVpPxU1aY947WHjgeTr', 0, '1594937153.0707', 2309, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('62.210.89.3', 1053972739, '', 'https://modelox.vico.digital//wp-json/wp/v2/users/', '', 'a:1:{i:1;s:115:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.149 Safari/537.36\";}', 'eRNf810vXjPrwhxnt6OBSu5U', 0, '1594969483.4701', 1143, '', 'GET', 403, 0, 520, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'ay7MNmzhLnPRA9WK6wjf1Y5t', 0, '1594969483.2283', 2579, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Z8ESNh7D5yMcY4vatfgOXpqF', 0, '1594969534.1609', 1942, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=54f2d24d62a40bd27856ea15ea5789dd&signature=cb6b4b34ed87eacc3e8a262f24237229eea03e2066822c5da2b5b59265b828bb', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'dfGtYv1aAJ278wqVPzo0egUF', 0, '1594969485.8483', 51272, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'eFOVblNALoTw5ZWPjyixdKfk', 0, '1594969583.4291', 1916, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=c19f454fedc2980ef3305c5e27dc6d19&signature=f119deb4397bc584fedc76e835001d3be786cef019ab2d2dd012c0297e0c0eb0', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '8Ahidl6tZkRDXQ9J4wvyFPWf', 0, '1594969536.1361', 50230, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', 'UGYrwP2MEC03lhJOBAWx9t1D', 0, '1594969592.4531', 1065, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'wPsqG3WIhROuYpDNZErycbnH', 0, '1594969633.1448', 1951, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=be23cec1173d484801f270fb2b55bec0&signature=be8ef63f509c183fab96437379f8693e952c5b3a112cae7ad6613f082a236f96', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'YJ64AITdqu0bnzBsQRp3PxVH', 0, '1594969585.3891', 50723, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'm8dcF2wLhSzKtRrHGljkIA0M', 0, '1594969682.1680', 1983, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=5c37ff345133f6f44587b16bfb45412d&signature=746f0fbb9c2293795056141182c4ad0f8ed43f78925cfbcf8666da7de8bc05d3', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'c9Xxkj6qs4SyZWn2Hh3wQYzT', 0, '1594969635.1286', 50042, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=37b6e35aabdf8944990e48bc5aa496cf&signature=8776a952405c6b4fc9304bc69603b3af3b711a013c770fb2a646464ec9422c1d', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '9dE5Ia0HxmDv3XZhzQyMqARn', 0, '1594969684.1865', 20632, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('89.36.224.7', 1495588871, '', 'http://modelox.vico.digital/phpminiadmin.php', '', 'a:1:{i:1;s:101:\"Mozilla/5.0 (Windows NT 6.3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.94 Safari/537.36\";}', 'w6kMEd4bGroLP1YvX0n2iaKO', 0, '1595080582.3944', 529, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'OGtSVahRQLMnHsTDvw2NW7Ko', 0, '1595080583.0633', 2584, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=cebd54454c', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=cebd54454c\";}', 'ePxK6j2EG4aAmTc3pINv0DCU', 0, '1595080587.2800', 1199, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=2d264c600033f05a7320109c376506e5&signature=7e3961824f588a72db8e6396698bea933c9eb24cae42452c9da0464e9deb6682', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'cUEB2aRKIuoyz4drk1nY5LCj', 0, '1595080585.7290', 5730, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('103.133.114.31', 1736798751, '', 'https://modelox.vico.digital/xmlrpc.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'o20WYKvCgikU8yXcxnm6QPN1', 0, '1595098268.1035', 10560, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('66.249.65.145', 1123631505, '', 'https://modelox.vico.digital/?wc-ajax=get_refreshed_fragments', '', 'a:2:{i:1;s:145:\"Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Chrome/83.0.4103.122 Safari/537.36\";i:2;s:63:\"https://modelox.vico.digital/producto/duvet-cover-set-in-white/\";}', 'p4W1If8N0tVnGhUzyxc2Sv6m', 0, '1595124259.2199', 2324, '', 'POST', 200, 2414, 500, 0, 1, '', 0),
 ('122.117.44.59', 2054499387, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'RApqPFLimX8BjUv5V4Zu2wf3', 0, '1595147631.2012', 17333, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('122.117.44.59', 2054499387, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'XIRS0B6tGxaV4if9oqwdr3jQ', 0, '1595147602.6017', 46129, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('122.117.44.59', 2054499387, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'hKjQDY29liURoM356B4w7ucC', 0, '1595147650.2943', 947, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('122.117.44.59', 2054499387, '', 'https://modelox.vico.digital/xmlrpc.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'M4NtvbBgWKzTI5x9R8FDXlaq', 0, '1595147653.1076', 536, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('67.205.14.147', 1137512083, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'mtzR4lVjuPpHSQrT50hqNikJ', 0, '1595164916.5155', 16532, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('67.205.14.147', 1137512083, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'PRlQoHdZNAyxCJ17hLDekazT', 0, '1595164933.6191', 908, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('67.205.14.147', 1137512083, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'sgnzbWrMYw2If6QBtaOxm4EX', 0, '1595164934.8585', 1441, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('67.205.14.147', 1137512083, '', 'https://modelox.vico.digital/xmlrpc.php', '', 'a:1:{i:1;s:76:\"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0\";}', 'ftp80hDCkRxbn49MXyeOVHzT', 0, '1595164936.7936', 509, '', 'GET', 403, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'epzVuNFl3c0MJQ2LKaTB6qDS', 0, '1595164938.4090', 3111, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=12150a8fa9e7a1428f2c6bd3f0827fab&signature=2ee6cfdada8937932bd52b4ccfa9bf7958a48ecdab15704bc5775de6420d041d', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'hmHsM6jFtD4CViweUNcqYuOo', 0, '1595164941.5528', 1080, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=c14763f9e5', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=c14763f9e5\";}', 'k4vxfju7ARE0woiMesFCYIHz', 0, '1595164942.9692', 1060, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=15a09e848c', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=15a09e848c\";}', 'DnmSLvNBO6XWFcGIKUJo7sMP', 0, '1595353361.5487', 1273, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=ae34acd803d911ce530a12588c049660&signature=346f4463e92d1bb0d01db7bd4185e25a8cf7a934bd18c74b2d4e2a30e7c0c55e', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'rzFcHdheXEv9b47nQ56IOiWG', 0, '1595353360.5375', 6362, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'vYhwL5yBa16ZHoSxXeEMr3cb', 0, '1595442341.4461', 2907, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=5962c3c6ba', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=5962c3c6ba\";}', 'Y18DXOxHf6307AmMGFwUqrtk', 0, '1595442345.8293', 1144, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=9db4821d56a5a3a9079cc8a8c08c4eae&signature=717ca827e9d1256b10a26e093162f64f479a6b10cc1deea2cb7348bcf6a9bcb7', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'zE7sJkIV1d3jw0uT48rlqmW6', 0, '1595442344.4018', 6061, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:66:\"https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit\";}', 'hcbQ5BfloFy3g2wYdjkRuSAx', 0, '1595751841.1459', 4018, '', 'GET', 401, 0, 520, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'C9IZMSspwcVnLl3WOxEHjD4A', 0, '1595751845.1963', 1092, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'PlwLdeQ2SrcjXTInAU9yDH37', 0, '1595751846.3229', 1053, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'NjS3IMVFyXP1fWBbO9rCGK7l', 0, '1595751847.4142', 1212, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'BX1lT8Ln5RYiQHchIeE7ow3j', 0, '1595751882.5438', 2274, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=b12849505d4e181a38b62fa96d7754a1&signature=90a5fb35e431b1ec14494ffd86c168df04e9aa056a6bd0ac025061eeba64ecc4', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'qAY16pskuQKOIw4NLRMrDCaf', 0, '1595751834.7228', 51113, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'u7VzorkmldK68CiUebBcOwMg', 0, '1595751932.1738', 1145, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=fb1a1414b742d32e7cadb2567a5284e6&signature=4ffdca687dec1e902792d410598503c4d301f2ffd6d673ef04e06d2578d9c4cd', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'yh4gH6NCRlv0tUEXkO1JdxQP', 0, '1595751884.8553', 49486, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '9bz6eSpgGxkRP8VF7tcL1d5A', 0, '1595751980.2055', 2261, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=9942aa5308c29d1dd86fb62836c5a3ff&signature=51521092e3b41769eb046eecfa7933ac1371e2c2205a20488096971c715f909b', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'JxfYeT250R3mDMz4kiab8ZhB', 0, '1595751933.3580', 50129, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'LSBnI7pjR6QzD0ZuGKy1P9i8', 0, '1595752029.1756', 1984, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=184ac0afc5926eb42665dfa3c98dc000&signature=b5d1849e3bf9f5b4dbdfd52b5fc4f31877a2870ec9b6e22884abc319fbd09aac', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'ysi2LZzKma56k9tIeUxNrjnX', 0, '1595751982.5038', 49675, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '8WbAODcUoZqEehJ7KtjPkgrl', 0, '1595752078.1636', 1998, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=d7b9e49719bedb4fec3d32c6e270af01&signature=c8a19f1378435a9c2964b96607859e56b075f95df5e07cf0623fcff1c574241e', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'RaMCQsxtWmdBZXAnzgw5jh7v', 0, '1595752031.1994', 49979, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', 'IDtdz7hWeEx5R26YjirsoBUO', 0, '1595752091.9217', 1155, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'kabfFzBRMr1pPl65SNL3whgV', 0, '1595752127.1714', 2324, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=4d96b5622907faf600a31a54676db7d7&signature=b8e18eb7b0dd499bae1f1156eb3da92df6cf86a5aabd46649c134adbd5ccb1eb', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'x5gzJZDhpcoHm7OX964rTK3A', 0, '1595752080.2015', 50317, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'wzh7NlEIvKGiTSRoLxOam4CF', 0, '1595752177.1476', 1954, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=ff946064877df69660fb1391bcec084f&signature=d763b3a04f53b1e227c2d9deb8f4b81c4b78fe115accbed6ed10471f77e0496e', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'Gf5KnAOygXjwE4N79SQMCdY0', 0, '1595752129.5521', 50567, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=cac395b751e8b42fa4a2a0e9c781ef1b&signature=e7983f4915fbeec96fe1988c27de29a3fd2deac9f01685f8516fa2ac5369603c', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'NF3nbkjVat7RMGJsPe1DITlx', 0, '1595752179.1393', 34823, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=f7edb11b3c', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=f7edb11b3c\";}', 'oireHqgDMlfK5ByVA67pbUs3', 0, '1595853386.3384', 1085, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=05f6e0d86f', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=05f6e0d86f\";}', 'ualLeor3AJDMB4pzk25dNSK1', 0, '1595967254.0008', 5031, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'drwzKYUFE9vWcJtAa0bZonSM', 0, '1595967267.3879', 1034, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=5bde37fb4e70651f79d888980e4e1e95&signature=eb942379f50fbd9c173d03f0a0995962381edaa01747ad7b0542d216b96c09ce', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '58Z1iV3pduUclzmnoJwSFDIy', 0, '1595967268.4640', 4871, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '4FUkBlscrdTMVezt7KRZ0haD', 0, '1595989041.6848', 3283, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('69.46.36.20', 1160651796, '', 'https://modelox.vico.digital/?_wfsf=detectProxy', '', 'a:1:{i:1;s:117:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.82 Safari/537.1\";}', 'IjQDW9gAJKGyurH0XPLOcfYZ', 0, '1595989056.4706', 1096, '', 'POST', 200, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '5E2xW0KbgJYlDV8NFfTBLtR1', 0, '1595989094.2039', 2809, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=0ccfc65c5709a31f32f23d761c610aeb&signature=7111c65bf501390c8a586456b5503778b42d763c8017027e08f23fdcd2eef373', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'dbm7FcVWwox9lHr1qRDUMe2h', 0, '1595989045.0415', 52993, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'YcoRu8JyImles2M7BGVgUf4d', 0, '1595989144.7773', 2793, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=02e858f4dbac044725c6f0770b9d96f1&signature=b2dd23a0c7435a5a256928be62afae718692661874755e31faf6c17605829866', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'sxU0PHMbK9zDhiCgeVZ6Jl2X', 0, '1595989097.0628', 51538, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', 'p7WhmiyP846bTCsaMZGFjltk', 0, '1595989178.0936', 2347, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'AMjegTOmQr896XRWqaZptnso', 0, '1595989195.3260', 2251, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=7687259b8199a6b89aad0405639c65e4&signature=1b5b9910d693038745436718a96dbbb34d5bac09237a34f8dc85a8af85ce8379', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '62plyNr5gqjn70aEF93hGBfL', 0, '1595989147.6283', 50973, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'dycKBjn4X7J1iEoDvrS8I52Y', 0, '1595989246.1984', 2336, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=0c7d84890583b6d22edb6c1ca4dec247&signature=6ddc9617ee746acbbc2afdc370ea07bdd8123480127acecf03dd6484f7337cc5', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '4xb0kginU3ETPdap8lOMfcy2', 0, '1595989197.6431', 51916, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'dKRrCyZMYfBb2o5xOkpGiEFU', 0, '1595989295.2786', 2658, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=b00d123b559c8343daa9841f770b92e5&signature=8a8cfef46f113cb355af3fea7a3a3e7609e08c060e1029e32047532ef55dc8b4', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'nXqLsxGE3Z9bPfiwFkM52cmH', 0, '1595989248.5823', 50386, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=6d02138a10cb6acf1012275059fcb94b&signature=f0e2fa07c84735afa7d131c11ed7f5e5ba10a848ee7abf073ab9bfc52a0900ed', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'IWgipkjx07tumysH24JrcTPU', 0, '1595989297.9905', 36130, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'hx6OEKN10YVFZys4neaT3z9r', 0, '1596059975.0309', 2469, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=9fb1f8c5f11d13aefb53502cefc60bc8&signature=ec80fad8a3ef392f7be3f06c9c6035cccdd0696eeb69e503d6cf450c1a817599', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'iEjJSAT74YvKCurlPfygs5w8', 0, '1596059977.5530', 1300, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=d1c4f66fce', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=d1c4f66fce\";}', 'e8tvFJSKDkTP7RBgUm5paXQI', 0, '1596059978.9810', 1560, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:66:\"https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit\";}', 'e9Ki6ZFm7dDyaEPQRvxIBU8b', 0, '1596218072.9873', 2891, '', 'GET', 401, 0, 520, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', '7x5t0bvTfZwsW34Nre9OdhCF', 0, '1596218076.0385', 1037, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'y5hIBCW34OUp6dLiN2JztADv', 0, '1596218077.1156', 1100, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'E9okHwZQgxXjsTIVhcYe1mfJ', 0, '1596218078.2496', 1094, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=b8df0640c36334375bd72b8f26d7dcbe&signature=901e1c377face9cda7a937e69a38dbfb5b50d985fb4c3cfdf7f43e56a68f8cc3', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'Lh6wZtzq4GYASiBOdbjUafQp', 0, '1596268268.4073', 50799, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'FXNK0H4WYi7vrSE6btjwaCLf', 0, '1596268365.4408', 2037, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=a2847b288dc0c76e2130b33f8f5712da&signature=76e7fc86891e8cbed161a9353fc87cf10fd987b8a4314ba04e7724de8bf76657', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'sLj60nW5AqRBypD9rKG8EYzk', 0, '1596268318.2243', 50274, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', '6vCgebhIVXYqpG13n4PtNMSj', 0, '1596268373.6647', 1127, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'hHLm9D0WX6oG5fje8UtSCKzB', 0, '1596268414.1496', 2018, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=a46a54869cde51ac7e97dec6735483d0&signature=2b6ee2299dc9d950621776bfd46739a9d43f5e49dd835d73ff8b5f235e73306f', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'oCjIe7imKTnMXbqEgOzVA4Y5', 0, '1596268367.5252', 49662, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'NRCy5JDxUwf2uMjL6H3pdlkW', 0, '1596268463.1455', 1048, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=e6e679015bab1252ff26c7b3fd6f67d8&signature=f8900204b5534cf21cd91048f549167bbdf2b90ee9002b39d514ea8e59a59011', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'rBzbwaWoR1YyD62V4FqeILQE', 0, '1596268416.2145', 49001, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=2610514e903e37c007a919ff4df3d6b1&signature=d83c6cf39678064c50349face067f211a5aacc245cf93af6f1c5c9e482ceecae', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'VJmXvMk2GH56EyWC1w3lUPDR', 0, '1596268464.2458', 17224, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'MwFdv3E0hXioIHSA4qjcrOtK', 0, '1596303568.9654', 2389, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=4c6c6a6eeb', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=4c6c6a6eeb\";}', 'AWei4gY5mpbjLh2ZSzwDqa6n', 0, '1596303572.9435', 1121, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('66.249.66.39', 1123631655, '', 'https://modelox.vico.digital/?wc-ajax=get_refreshed_fragments', '', 'a:2:{i:1;s:145:\"Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Chrome/84.0.4147.108 Safari/537.36\";i:2;s:34:\"https://modelox.vico.digital/shop/\";}', 'O4QRsvYCDibaoGLU2XZK1cJT', 0, '1596331092.4116', 1457, '', 'POST', 200, 2414, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=c5dbedb42d', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=c5dbedb42d\";}', 'nuy1TfDCU8Pxh4OamiZlAs5q', 0, '1596596837.8593', 1296, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'jnwQ0S5kZyszigd89tIKRCYT', 0, '1596596849.0465', 1100, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('69.46.36.20', 1160651796, '', 'https://modelox.vico.digital/?_wfsf=detectProxy', '', 'a:1:{i:1;s:117:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.82 Safari/537.1\";}', 'cEFUJ7XTd4uk6qO9wfCNeWIK', 0, '1596596859.3125', 558, '', 'POST', 200, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'nLlwWA0YOkeB6Qt3IyaZXdDc', 0, '1596596897.2335', 2025, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=5d30ab3edf8ef17125449fd481bc3588&signature=5357977dd7770b23bae48bad34b89fff62298f37dde9662f18e5902e09eeaa92', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '2Xd4oHkUZAcWMrKOTz0fCmGu', 0, '1596596850.1801', 50098, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Vkm0ngd9ADYEwi3fF5N4JyUW', 0, '1596596946.1912', 1041, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=f75dea12b701bd5adb8906f57a77e76c&signature=db9b17e22bd839552d1a2cadc99a7cffc4c1b48e67c295e180577d8bdb188681', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'SK2lPMfd40jqchLADmTiGEsy', 0, '1596596899.2916', 48957, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', 'P23qWX7Gnw4ELD5USryxfic9', 0, '1596596952.4240', 1195, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'BFWeHNd14uJthRDTgPLX3YUz', 0, '1596596994.1432', 1957, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=0d9478af1a683cbf90904d92ea501199&signature=8ba5294d1e9c7056b8443f3f8d560c968e80ed778400c392492d5142b92b602a', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'gUGAEZw0K1omLQ39iaqMynCv', 0, '1596596947.2720', 49848, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'PQbUYcVEZoeKSMCxTilI3Lgm', 0, '1596597043.1508', 2057, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=cbfa0025bfd4e50eedaf611b9a32a823&signature=c2134aef9e5b2378d8b6b00359b26ea1323501465813b244445065c8cf6f2b9d', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'dwDxrtgUeZb4Il9zsRaiYKE1', 0, '1596596996.1413', 50087, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=60f139f5f54d746bd87e8cb32853e093&signature=9113edbd5015d54083d98a45b796848e8ff69444b78b8add8fad5cb6e4ca61c0', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '7ghnReY5rpG4SHdQq0bik6Lf', 0, '1596597045.2576', 21996, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=63379de5cb', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=63379de5cb\";}', 'bSNPmzUo3LBswFDKVlrEaZCt', 0, '1596811774.2316', 2071, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'imR7vT3F1PVIGyw60l5fYZnC', 0, '1596811775.6800', 1977, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=35de2401f1f08050893e18345b35b2b8&signature=614891b4f0d4d9d970e35c35d41082dc5f45498ba15604ca0ecf4ffd9fcd6865', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'foRNCj0Jyptc914K2nauF7mL', 0, '1596811777.7200', 1752, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:66:\"https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit\";}', 'sqUk7EjDotWXBGIHa5iSNlx1', 0, '1596811779.0261', 2330, '', 'GET', 401, 0, 520, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'XkHwSUKRr5vVJOpqgcbox081', 0, '1596811781.4231', 1634, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'Lqk4MZ6AebI2pvxocjigJfnz', 0, '1596811783.1073', 1387, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'VvdKZTfXnxAzjyEQpa6D72I8', 0, '1596811784.5555', 1735, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('186.167.242.223', 3131568863, '', 'https://modelox.vico.digital/?wc-ajax=get_refreshed_fragments', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'TIcYHbzoGefU4gAqOMxW1vhn', 0, '1596836081.3375', 2653, '', 'POST', 200, 2414, 500, 0, 1, '', 0),
 ('186.167.242.223', 3131568863, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1', '', 'a:1:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";}', 'acz6UbN4fZqXSOky18pRKlms', 0, '1596836630.4170', 1006, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('186.167.242.223', 3131568863, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:111:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1\";}', 'UrbXoWYclqNn9eOGwp5fKVdI', 0, '1596836673.2757', 2941, '', 'POST', 403, 0, 600, 0, 1, '', 0),
 ('186.167.242.223', 3131568863, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', '5EQkL3IUFMpjOwy9gYK4a8Cx', 0, '1596836689.8738', 2112, '', 'POST', 403, 0, 600, 0, 1, '', 0),
 ('186.167.242.223', 3131568863, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'hgFEATVGsNItCRuBmSbQa4p5', 1, '1596836700.7866', 7786, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=0b2213187a', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=0b2213187a\";}', 'qTkX732ZMwn6DOdWJfgGhrUm', 0, '1596906742.0081', 1539, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:111:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1\";}', '1QBeMjyFhWNOICm6EGHi9zdY', 1, '1596906757.4865', 7818, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('69.46.36.20', 1160651796, '', 'https://modelox.vico.digital/?_wfsf=detectProxy', '', 'a:1:{i:1;s:117:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.82 Safari/537.1\";}', 'Tha1cmLJeI2Hwq6KMtsE8jNF', 0, '1596907211.5204', 15073, '', 'POST', 200, 0, 700, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'kDOWJtLlEAzMqc2XUKfpv8Ci', 0, '1596907202.7114', 25241, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php?interim-login=1&wp_lang=es_ES', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'wmE7FIL4otJghqQ0cG9kPDny', 0, '1596907230.9590', 9308, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'jxAnkuFy6v4rWpgoNfti8aLT', 0, '1596907262.3172', 1710, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'n1hyX8SNaiA70Yk2KVZDoju4', 0, '1596907271.4488', 890, '', 'GET', 302, 0, 501, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2Foptions-general.php%3Fpage%3Dupdraftplus%26updraft_restore_success%3D1%26pval%3D0&reauth=1', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'aIvuQNH2EGsKhTp7qDyBC6iO', 0, '1596907272.5920', 724, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:192:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2Foptions-general.php%3Fpage%3Dupdraftplus%26updraft_restore_success%3D1%26pval%3D0&reauth=1\";}', 'acS9frNk1VEhBGnsyWgD0HKp', 1, '1596907290.9903', 8320, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2Foptions-general.php%3Fpage%3Dupdraftplus%26updraft_restore_success%3D1%26pval%3D0&action=confirm_admin_email&wp_lang=es_ES', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:192:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2Foptions-general.php%3Fpage%3Dupdraftplus%26updraft_restore_success%3D1%26pval%3D0&reauth=1\";}', 'gmjREAya8qL4OPzp9fUlXo1d', 1, '1596907299.5916', 749, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:66:\"https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit\";}', 'g07svpQP1nCyEKqz954NVhiX', 0, '1596907302.4083', 722, '', 'GET', 401, 0, 520, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'eQyXpMIG7D8q3ilmL5uT0WxE', 0, '1596907303.1799', 908, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', '5kIw3QyOPNebh02LqXns7fVr', 0, '1596907304.1330', 1167, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2Foptions-general.php%3Fpage%3Dupdraftplus%26updraft_restore_success%3D1%26pval%3D0&action=confirm_admin_email&remind_me_later=173f5e4ab2', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:224:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2Foptions-general.php%3Fpage%3Dupdraftplus%26updraft_restore_success%3D1%26pval%3D0&action=confirm_admin_email&wp_lang=es_ES\";}', 'tmIaV4jK9LwzD1i7hSWFvdG0', 1, '1596907304.8809', 1292, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', '5bwhXHOvej1BxSQszIyJPgU6', 0, '1596907305.3618', 1587, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'cUTmYXEkpsK3tDoGngAa1ZRl', 1, '1596907325.0351', 1512, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Da3qzxQeEKLcJIGimr5UFtCs', 0, '1596907330.0238', 1335, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=e051a2cb03799e2549e85a90d91c955b&signature=c859c0886bb4fc23096d0efe82c8581eab363f7b98d852006af00ebfb0692c30', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'iXEaM6krQ0Dz7tKvxPjnUo8h', 0, '1596907331.4178', 6329, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0\";}', 'mW1yNkxhuSA49qn0CfbOPYtR', 1, '1596907349.1348', 904, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/login-customizer/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0\";}', '3QqXHSYnD8OjNh7vioKt9p1B', 1, '1596907350.7441', 804, '', 'GET', 302, 8, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0\";}', 'sPM8oNJ3x6hq7F0t2LE1muyb', 1, '1596907351.8233', 792, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/sample-page/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0\";}', 'CEuzBYKkajL0qUOpMgXxRrDT', 1, '1596907353.4515', 717, '', 'GET', 200, 2, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=0&pval=0\";}', '4WFsdhJQM6NRanx0YPzAtc82', 1, '1596907439.9178', 807, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/login-customizer/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=0&pval=0\";}', 'H6fXm4BPau3SC2FLWct8MAds', 1, '1596907483.7361', 1276, '', 'GET', 302, 8, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=0&pval=0\";}', '7kMim4o0962BdrVeOFyHcqC5', 1, '1596907486.8642', 1208, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/sample-page/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=0&pval=0\";}', 'v8sVRAMgdJeIf51Ymxwyj4Wb', 1, '1596907504.1792', 2035, '', 'GET', 200, 2, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0\";}', 'NfL19TXEVZRrxQIm3yusq6Yc', 1, '1596907548.2948', 893, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'VTxYsKWDClrNGyPegqOzHuSZ', 1, '1596907565.9368', 990, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', '6LUdP8NWSZj3YHJ0XxMf2GOA', 1, '1596907571.8800', 1125, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:61:\"https://modelox.vico.digital/wp-admin/admin.php?page=zn-about\";}', 'pGoJnV9HxkeMERuY1WtTrXQz', 1, '1596907688.8709', 741, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0\";}', 'Eokg34we10LDT2fbXYshxcWt', 1, '1596907696.5442', 1833, '', 'GET', 200, 115, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'Yxsv6yLIJHOm3uwr0TtagpNF', 1, '1596907707.2331', 762, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-minimal/portfolio-details/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'pmujMJtQeob6x0WPHOK2CdR9', 1, '1596907710.5099', 895, '', 'GET', 301, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'o5ZKrdHm1cDBWjEq23QvsNxk', 1, '1596907711.7344', 943, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'VrOsMCmFf1WUcPoqzj3RJ8XA', 1, '1596907741.1613', 1110, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:47:\"https://modelox.vico.digital/portfolio-details/\";}', 'o9a6CrAMilWq234fJn7XSc5D', 1, '1596907744.3055', 815, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:47:\"https://modelox.vico.digital/portfolio-details/\";}', 'SzEkFhwIctZdeaGDfJq7WXN5', 1, '1596907749.2857', 911, '', 'GET', 200, 115, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/?preview=true&zn_pb_edit=1', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'CXu0hDNMAbBrT53xmSv7WULj', 1, '1596907756.2585', 797, '', 'GET', 301, 115, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/?zn_pb_edit=1', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'p6qA7rIvhTSbBUKgucwoNWMk', 1, '1596907757.2988', 1183, '', 'GET', 200, 115, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-minimal/portfolio-details/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:42:\"https://modelox.vico.digital/?zn_pb_edit=1\";}', 'SRjGaikv5FIKly9Tbsut2Qzc', 1, '1596907865.0642', 3207, '', 'GET', 301, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:42:\"https://modelox.vico.digital/?zn_pb_edit=1\";}', '8hNqEWOKzygit7Jo3IxjUfva', 1, '1596907868.8952', 1073, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/?preview=true&zn_pb_edit=1', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:47:\"https://modelox.vico.digital/portfolio-details/\";}', 'Xrs5nyAqL9bVzCBOIaoxhMY2', 1, '1596908156.5752', 27511, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:73:\"https://modelox.vico.digital/portfolio-details/?preview=true&zn_pb_edit=1\";}', 'Uxz83CXShyNAe5RPTrKJ0Dsg', 0, '1596909054.7016', 2513, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/?preview=true&zn_pb_edit=1', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:47:\"https://modelox.vico.digital/portfolio-details/\";}', 'zQ7ATDxEO6vKtucf2bsMYqwe', 0, '1596909162.5726', 2320, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/?preview=true&zn_pb_edit=1', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:47:\"https://modelox.vico.digital/portfolio-details/\";}', 'oUeAIDrxgTmzCh82u7YQ9MEc', 0, '1596909198.8433', 1204, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1', '', 'a:1:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";}', 'J1XCIkKba4oYmZSOL5RWHAv7', 0, '1596909248.6182', 787, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:111:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1\";}', '9Cqre5FlKJtz08WDa3Ax7i2v', 0, '1596909265.8340', 1831, '', 'POST', 403, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'wlVtMAgTf2vkxBWZPzFY1JLm', 1, '1596909278.0912', 1015, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'JltCmK62fopNG0DSMIdHbAFP', 1, '1596909285.2830', 826, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:38:\"https://modelox.vico.digital/wp-admin/\";}', '0nwJYCeykpvbNqLXgi4Usxtf', 1, '1596909437.1710', 1012, '', 'GET', 200, 115, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-minimal/portfolio-details/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'FeoMq5cpTRAdS93YIOhP8xk6', 1, '1596909451.2553', 778, '', 'GET', 301, 0, 600, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'EFoRB1yLAgiDGNJ3YSW4Ujrk', 1, '1596909452.5608', 837, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('201.243.46.194', 3388157634, '', 'https://modelox.vico.digital/portfolio-details/?preview=true&zn_pb_edit=1', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:47:\"https://modelox.vico.digital/portfolio-details/\";}', 'c1SzhNKOIUtxmW2ZgDTY4FEG', 1, '1596909480.0215', 78373, '', 'GET', 200, 112, 601, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'bayIHxFGVmwpTSqUzOQRhrN6', 0, '1597070337.0097', 2155, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=785c98df348ddbe8b44e237e8ee2190c&signature=4d067bcf8752a2e99349d99a6ec7950ddb2efb6f1d75af200f2bbc48cef006b0', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'LyOrMeWPa0zKTgmwpxDXY1kN', 0, '1597070339.3703', 1597, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '9wvKs3no2ulH5VF6WCYAXijk', 0, '1597070340.3940', 1566, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1', '', 'a:1:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";}', 'XiULDM4y0kJ1hOGVzIeRZ29x', 0, '1597070386.3095', 1380, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'NuioKWyscA1fYBMCZG65ajwp', 0, '1597070390.1336', 818, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=standard&cronKey=f6cabf8b92a792ad665aa90324b58727&signature=8e041cadc14435a9e348099578756cb0ec88b88c636ef09cbec5a62c3fc2f36e', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'ojSyzWPNQXYp8VI3KfkrnvO4', 0, '1597070342.0163', 49955, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:111:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1\";}', 'KDNybmMrklGL40CgOeJcWPS3', 0, '1597070401.6199', 4788, '', 'POST', 403, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/.user.ini', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:38:\"https://modelox.vico.digital/.user.ini\";}', '7au6GcFrLD425EY3yUCtpSjK', 0, '1597070424.0773', 994, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'igD8FZmos4pyErHb0VNRA6xf', 1, '1597070416.5056', 10516, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'MXgwoAYjhuxkdasmE5tnUB47', 0, '1597070437.4126', 2772, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=ebad094eb2d042331d40269e0f94240e&signature=1099a492c30643ca914fe024a2af1e53d1eef35dffdc61cd4f41cf569ca202e3', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', '5aJgLCrXfDyUNhjBk1xIA3OE', 0, '1597070391.0088', 50200, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('69.46.36.20', 1160651796, '', 'https://modelox.vico.digital/?_wfsf=detectProxy', '', 'a:1:{i:1;s:117:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.82 Safari/537.1\";}', 'QvmkEq5hgUPBruX3Ysw9RTpK', 0, '1597070507.2455', 13765, '', 'POST', 200, 0, 700, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'Ku0I4r2y89P7cQYdljamShwN', 0, '1597070488.2272', 35740, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=c28b09a8e527d1514d6c20732f69f388&signature=1bcf4d4bdd380b06705f94a5ff22e4e59b6e2b955c585eeb26e97eb66a440827', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'fgA4BcuhR6xEvGyVwHCdl3j0', 0, '1597070440.2346', 84801, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=1&scanMode=standard&cronKey=23646ee31afe9b67ca576b5b285f400b&signature=6b66f24283f0496f49b38464979374957fe08eb26586ac790028a60d416c39c9', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'Q2awZ6BxOnLdTfUm9IEb7sMC', 0, '1597070525.0687', 14181, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'AxRG7jVeNDpHlSqM4PgkUzOn', 0, '1597070535.8508', 10633, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-login.php?interim-login=1&wp_lang=es_ES', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'W6KqfEmc2sC9dJTLOZ3Mzpko', 0, '1597070550.5412', 20045, '', 'GET', 500, 0, 600, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:74:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus\";}', 'lIDxLENyUq9jzsYhKM5rFG1m', 0, '1597070562.3894', 8586, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:66:\"https://modelox.vico.digital/wp-json/wp/v2/types/post?context=edit\";}', 'VeSzsm9riTovG7wjlnKD2kW6', 0, '1597070588.6803', 1081, '', 'GET', 401, 0, 520, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'w7ZpzASQUagKVdmCfjI6nbBu', 1, '1597070584.6323', 6026, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'odYjwXIVlcNE6G5kM0rUCSAW', 0, '1597070589.8021', 1141, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&action=confirm_admin_email&wp_lang=es_ES', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:41:\"https://modelox.vico.digital/wp-login.php\";}', 'vwKhtzfVUJlSBkx6Io14TF0p', 1, '1597070590.9348', 1098, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'JRBGrDiKlcX4Yj5keAw90ZHf', 0, '1597070591.0040', 1356, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:52:\"https://modelox.vico.digital/wp-admin/admin-ajax.php\";}', 'dgLEJ0XHmWMcz4wYFRroiAGO', 0, '1597070592.4837', 1277, '', 'POST', 400, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', 'dXTEoCkJQYH1UWiz5ql0jaeA', 0, '1597070614.9901', 1492, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=052c66d07b867893533431c6e26cb047&signature=43c0a93b93de776a57056bc35777b9e014c83786846fee111b5ddfeb8a14dd56', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'PdmkCaLfnR04V31SJiBNMWqO', 0, '1597070616.5769', 5667, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:107:\"https://modelox.vico.digital/wp-admin/options-general.php?page=updraftplus&updraft_restore_success=1&pval=0\";}', 'WgNTutGZhlYPrS17yJUHfEs4', 1, '1597070632.5213', 683, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('186.167.250.237', 3131570925, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";i:2;s:77:\"https://modelox.vico.digital/wp-admin/plugins.php?plugin_status=all&paged=1&s\";}', 'kM5U2xmT7bzVFRp3wcNoHfvd', 1, '1597070955.6702', 785, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:78:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_testAjax\";}', '4fmuCIEMNUtZ3FJBVxK0Sq81', 0, '1597160010.9604', 2691, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wordfence_doScan&isFork=0&scanMode=quick&cronKey=9a336383ad52d6d4ccb27df5d09dba55&signature=1b8c443c68f773ab25b0cdc9a21a1f3cb60d4218402b4b5e98328f52b9f7089d', '', 'a:1:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";}', 'k01gn3L9sxGjWPJZHE6FmyCr', 0, '1597160013.7144', 1766, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('190.75.83.206', 3192607694, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1', '', 'a:1:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";}', '8PaphcYbGMWLBtoHuOlXTmKd', 0, '1597160193.0712', 1560, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('190.75.83.206', 3192607694, '', 'https://modelox.vico.digital/wp-login.php', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:111:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1\";}', 'fagAwJ5cskuKC721mEdIMNUq', 1, '1597160239.0505', 10382, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('190.75.83.206', 3192607694, '', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&action=confirm_admin_email&wp_lang=es_ES', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:111:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1\";}', '7qjwVhzInTsAbSN8vyPmctu4', 1, '1597160249.7299', 1515, '', 'GET', 200, 0, 600, 0, 1, '', 0),
 ('190.75.83.206', 3192607694, '', 'https://modelox.vico.digital/wp-login.php?action=confirm_admin_email', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:143:\"https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&action=confirm_admin_email&wp_lang=es_ES\";}', '9eVmyIRspGPBc70wY5xOEKDz', 1, '1597160264.1378', 2033, '', 'POST', 302, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-content/uploads/woocommerce_uploads/', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:68:\"https://modelox.vico.digital/wp-content/uploads/woocommerce_uploads/\";}', 'S4tMfKXrqaG0jmRZQ17o5pci', 0, '1597160562.8475', 3773, '', 'GET', 404, 0, 600, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=5253e50224', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=5253e50224\";}', 'bDE9XlapQfOe0z5oKnmZFcGy', 0, '1597160573.2324', 4794, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=5253e50224', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:100:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=wp_1_wc_privacy_cleanup&nonce=5253e50224\";}', 'SZdv8P2oN67J3ymYgTwIcAfG', 0, '1597160589.7231', 2045, '', 'POST', 200, 0, 500, 0, 1, '', 0),
 ('190.75.83.206', 3192607694, '', 'https://modelox.vico.digital/favicon.ico', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:61:\"https://modelox.vico.digital/wp-admin/admin.php?page=zn-about\";}', 'jGoQqO8v5C3xkIY0esgFtznT', 1, '1597160662.3510', 2145, '', 'GET', 302, 0, 600, 0, 1, '', 0),
 ('190.75.83.206', 3192607694, '', 'https://modelox.vico.digital/', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:61:\"https://modelox.vico.digital/wp-admin/admin.php?page=zn-about\";}', 'szVYM4KIJ1thcdfGNx6yk5eF', 1, '1597160700.5776', 11661, '', 'GET', 200, 149, 601, 0, 1, '', 0),
 ('190.75.83.206', 3192607694, '', 'https://modelox.vico.digital/?wc-ajax=get_refreshed_fragments', '', 'a:2:{i:1;s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";i:2;s:29:\"https://modelox.vico.digital/\";}', 'L02eBP58y7mdHz9RA4X3KxrE', 1, '1597160734.8846', 3085, '', 'POST', 200, 149, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161286', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161286\";}', 'gZj7VmzHGCLK2l0h5pusTkc9', 0, '1597161286.7223', 6687, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161288', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161288\";}', 'EaMyb3Nw75x4nmKTS1oOgIl9', 0, '1597161288.4360', 6573, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161289', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161289\";}', 'RXiwd6oOGQk9HUsp7YKbBfNC', 0, '1597161290.0381', 8174, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161293', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161293\";}', 'vCxyp5UanQ7VZ1ihK4lNd9Aq', 0, '1597161293.2930', 12315, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161300', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161300\";}', '6COu0AgQrc85wPyxvVBnJmhF', 0, '1597161300.6112', 10221, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161303', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161303\";}', 'FKw3aqGMbQ97LST8ONfRxAhr', 0, '1597161303.2362', 20895, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161316', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161316\";}', 'zMQK76lk8YmyfEwiUun9TWeh', 0, '1597161316.9164', 18902, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161328', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161328\";}', 'mAtbLVOTrjX0Skl98eCxoW23', 0, '1597161328.2053', 16183, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161339', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161339\";}', 'GjLdb1cnl8FIeui5EYR4XHmh', 0, '1597161339.4134', 21546, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161354', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161354\";}', 'x5WTGmNMoAb7vfSyDwzFR29Q', 0, '1597161354.1124', 17397, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161366', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161366\";}', 'WfxXvCdhk6uNe0zyiPb87tTK', 0, '1597161366.1893', 17094, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161378', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161378\";}', 'S0acpdTJ8bjRIKUBmXOqFGty', 0, '1597161378.3039', 17852, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161390', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161390\";}', 'DeGklZazg8E3qx906iQfTR1K', 0, '1597161390.7378', 19381, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161415', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161415\";}', '6s7h8I3NdVYzZ9ftP2vGXjFy', 0, '1597161415.0669', 3788, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161402', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161402\";}', 'cxZzbHgi07kMWIv1jq8FAoXr', 0, '1597161402.5325', 16352, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161415', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161415\";}', 'edfb3JVA2xhX1uSY4ZwqGF0K', 0, '1597161415.1688', 17870, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161428', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161428\";}', 'dRnhaMO6B8XclLevupYf0H2t', 0, '1597161428.0912', 18948, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161442', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161442\";}', 'yZru4hTEeaJYQ0wfztOimxMV', 0, '1597161442.0623', 17590, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161454', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161454\";}', 'LVQo45CEmpnKSY903RP86DId', 0, '1597161454.6692', 16726, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161466', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161466\";}', 'T9Nh1gdmnUt30WJ4LKbHwivF', 0, '1597161466.3963', 6380, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161467', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161467\";}', 'kEGN4jMmhfJo7glpAyZHQacY', 0, '1597161467.7964', 6882, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161469', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161469\";}', 'OjaRVEpTY2L1HN076QclSJZ5', 0, '1597161469.7107', 7740, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161472', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161472\";}', 'GuWSrDn1YMRd8eTm23kLN7B0', 0, '1597161472.4892', 6504, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161484', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161484\";}', 'alHKLDIGAunR0Xrmtw3QNqvV', 0, '1597161484.9587', 3153, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161473', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161473\";}', 'BGT0nJf4y1zto6vlwFqLupc3', 0, '1597161474.0175', 14117, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161484', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597161484\";}', '06XDLgTiGsV4OqSylwJzZm7B', 0, '1597161485.0463', 3223, '', 'GET', 200, 0, 500, 0, 1, '', 0),
 ('51.91.128.199', 861634759, '', 'https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597163482', '', 'a:2:{i:1;s:45:\"WordPress/5.4.2; https://modelox.vico.digital\";i:2;s:104:\"https://modelox.vico.digital/wp-admin/admin-ajax.php?action=duplicator_pro_process_worker&now=1597163482\";}', 'jgw0T9CdX5rsluxnEAN2V3DR', 0, '1597163482.4365', 8223, '', 'GET', 200, 0, 500, 0, 1, '', 0);

/* INSERT TABLE DATA: wp8b_actionscheduler_actions */
INSERT INTO `wp8b_actionscheduler_actions` VALUES(20, 'action_scheduler/migration_hook', 'complete', '2020-08-11 15:43:53', '2020-08-11 15:43:53', '[]', 'O:30:\"ActionScheduler_SimpleSchedule\":2:{s:22:\"\0*\0scheduled_timestamp\";i:1597160633;s:41:\"\0ActionScheduler_SimpleSchedule\0timestamp\";i:1597160633;}', 1, 1, '2020-08-11 15:43:58', '2020-08-11 15:43:58', 0, NULL);

/* INSERT TABLE DATA: wp8b_actionscheduler_groups */
INSERT INTO `wp8b_actionscheduler_groups` VALUES(1, 'action-scheduler-migration');

/* INSERT TABLE DATA: wp8b_actionscheduler_logs */
INSERT INTO `wp8b_actionscheduler_logs` VALUES(15, 20, 'acción completa vía WP Cron', '2020-08-11 15:43:58', '2020-08-11 15:43:58'),
 (14, 20, 'acción empezada vía WP Cron', '2020-08-11 15:43:57', '2020-08-11 15:43:57'),
 (13, 20, 'acción creada', '2020-08-11 15:42:53', '2020-08-11 15:42:53');

/* INSERT TABLE DATA: wp8b_booking */
INSERT INTO `wp8b_booking` VALUES(1, 0, '', 1, '', '2020-01-18 00:00:00', '2020-01-16 19:20:39', 'text^name1^Jony~text^secondname1^Smith~text^email1^example-free@wpbookingcalendar.com~text^phone1^458-77-77~textarea^details1^Reserve a room with sea view', 1);

/* INSERT TABLE DATA: wp8b_bookingdates */
INSERT INTO `wp8b_bookingdates` VALUES(1, '2020-01-18 00:00:00', 0),
 (1, '2020-01-19 00:00:00', 0),
 (1, '2020-01-20 00:00:00', 0);

/* INSERT TABLE DATA: wp8b_cerber_sets */
INSERT INTO `wp8b_cerber_sets` VALUES('_cerberkey_', 0, 'a:3:{i:0;s:32:\"13bc103045e0c5ca40ea88334148417a\";i:1;i:1597070713;i:4;s:40:\"SK//OIL8PZMCAH7XQJ23WE64KYVGDF0RST5N91UB\";}', 0),
 ('admin_notice', 0, 'a:0:{}', 0),
 ('admin_message', 0, 'a:0:{}', 0),
 ('_cerber_mnemosyne', 0, 'a:3:{i:3;s:20:\"IAG9E4FBW7JSN16TPR2K\";i:4;i:6;i:6;s:16:\"7H1GXI0KWQEYUR8L\";}', 0),
 ('hash_pl_c86251ee8490a52c4fa644073ba03eed598555a8', 0, 'a:4:{s:4:\"name\";s:17:\"Slider Revolution\";s:3:\"ver\";s:5:\"6.1.8\";s:4:\"hash\";a:1620:{s:9:\"index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:16:\"release_log.html\";s:64:\"b9a60e72cfe90694d53551554a54d767fa4134ee84c82d33c41a0d3e3ea39480\";s:13:\"revslider.php\";s:64:\"e0ca29a52ca6c230653652fc90263b88947332d9233384ad7fd76fec68986f40\";s:13:\"uninstall.php\";s:64:\"d9c8a5801c741f9b8e7a9d333438a1109b15fe8ab9e19a41106d3e8841f394cc\";s:12:\"welcome.html\";s:64:\"2b2524c7dfa5c9f8a7c89444e6eba47ff5a225f74c4458fd7fa99b1057c03733\";s:15:\"admin/index.php\";s:64:\"ae6fc10874855daddd44765416e0f28da65a2b89e9e32802dd66e7fa6690d2d9\";s:31:\"admin/revslider-admin.class.php\";s:64:\"5f939196ce06b5ab6a121975f0a3460ee409898d77107e8fd09484a8f960987d\";s:22:\"admin/assets/index.php\";s:64:\"ae6fc10874855daddd44765416e0f28da65a2b89e9e32802dd66e7fa6690d2d9\";s:27:\"admin/assets/css/basics.css\";s:64:\"e5423c2dc742b4bdbf66c62dc70308d7733dcc6528e79f1f843c634d04e9af8a\";s:32:\"admin/assets/css/builder-rtl.css\";s:64:\"f814492ceeba94b6490a520e742a803d7b531a614b3a1de1876a1d48b3ff639c\";s:28:\"admin/assets/css/builder.css\";s:64:\"ad52898c5bd4b9a23ef9b926cc8d9e961b518b3be04e81ba2efc89efc02f7128\";s:31:\"admin/assets/css/codemirror.css\";s:64:\"2e11f933dfa7cf4af1e6c6dd8007d84b02a56b256d086003e3673cc8ff10f1a6\";s:25:\"admin/assets/css/help.css\";s:64:\"0bb2181f2f91524e22af3f5fc6e62075be9d44897d463c94a369de8ca29f001e\";s:26:\"admin/assets/css/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:30:\"admin/assets/css/select2RS.css\";s:64:\"56393588b984bde1ad4b56446439f1d82fbd06b37c666d1ce64a1be12bf6d002\";s:28:\"admin/assets/css/tooltip.css\";s:64:\"e7a0b0c3ea280a3dbf7ed15ced9355bf4442d7b8a5b04bf8262e1b169d3d73b3\";s:36:\"admin/assets/css/tp-color-picker.css\";s:64:\"5f4984d1249ae63a8c8ac52edff9aa358e7db194dd30dc1bb2429be4461ca753\";s:44:\"admin/assets/icons/MaterialIcons-Regular.eot\";s:64:\"8c998b4a9c0acbb9fe5dd572c206a5a33fdd5ca2b58db87fc3b893beac85068d\";s:46:\"admin/assets/icons/MaterialIcons-Regular.ijmap\";s:64:\"88182029715624355dbc49c97b3af61e311538ddd33d31c6f4d13b2937411d1d\";s:44:\"admin/assets/icons/MaterialIcons-Regular.svg\";s:64:\"8b922129360ee12051269278e95ccff05ab4a60ccd39b9117f8216ede63a91c0\";s:44:\"admin/assets/icons/MaterialIcons-Regular.ttf\";s:64:\"b7f4a3ab562048f28dd1fa691601bc43363a61d0f876d16d8316c52e4f32d696\";s:45:\"admin/assets/icons/MaterialIcons-Regular.woff\";s:64:\"c4a1baec300d09e03a8380b85918267ee80faae8e00c6c56b48e2e74b1d9b38d\";s:46:\"admin/assets/icons/MaterialIcons-Regular.woff2\";s:64:\"a87d66c91b2e7dc5530aef76c03bd6a3d25ea5826110bf4803b561b811cc8726\";s:28:\"admin/assets/icons/README.md\";s:64:\"402d2770ce34261fff627b7ca12775ad286be2d1e49a934d4bb9383139761ad2\";s:29:\"admin/assets/icons/codepoints\";s:64:\"dc0a89e73a83c4a4eeb14b9ae5a7bccb76f01fee1b13b243bfe9b266a249fc2d\";s:37:\"admin/assets/icons/material-icons.css\";s:64:\"afb727c828f3957ada8e546f9bce9c9c733bc1d2f09a83eb47f2114302cd9f2b\";s:36:\"admin/assets/images/UI-ICONS-BIG.png\";s:64:\"8309cde41bcb3a757d014256fb00609001b9a13789361d41b94a6d8f9a677bc6\";s:39:\"admin/assets/images/UI-ICONS-BIG_bg.png\";s:64:\"a224fc7c20a805a335e52897abea5d49c974ab496005080f15a294b79e289815\";s:32:\"admin/assets/images/UI-ICONS.png\";s:64:\"b8a3ec9b7472285c6be8764e8c79f3a9595f92f9f175d87a9760c40c713ace65\";s:35:\"admin/assets/images/UI-ICONS_bg.png\";s:64:\"1fcc2359e0afb275ad9faf97a924f5d5f2325864b5675afc10ddd83752b74305\";s:39:\"admin/assets/images/active_bg_modal.jpg\";s:64:\"17ecf0fc21e69374c4419e73d4325100ccda5c215115e3325dab66eb24f422ce\";s:29:\"admin/assets/images/check.png\";s:64:\"b29d8a045d0c404209dc1eb5ba7ac4a7c86fdd697373fd7c3f1c0ae97a5d47c4\";s:39:\"admin/assets/images/dark_pattern_2x.png\";s:64:\"f824a0fcfc076e3506c47181c0d47e34a69e9db58fd96ff4774d3f3b5b6d7338\";s:29:\"admin/assets/images/dummy.png\";s:64:\"69539b5b3777cffda28a66d7f2aa9b17c91ee1ec8fd50c00c442af91753a60f7\";s:32:\"admin/assets/images/gridtile.png\";s:64:\"71b8a238b9bd03570c3d2b5a6907d6db6e4ba6e1d8be7b454c69c4abbf31edc2\";s:36:\"admin/assets/images/gridtile_3x3.png\";s:64:\"71f4cfe8713e2d57e4cdf8e160f60e8df3cb64ada67962302308d8d32a6cc3f3\";s:42:\"admin/assets/images/gridtile_3x3_white.png\";s:64:\"27c29032de418b1950dba1efe909414e56142d088e3093307ed161ac072bff85\";s:38:\"admin/assets/images/gridtile_white.png\";s:64:\"1dd723b101f64f8555d58fbe4a7bf4781ec732fc162783c3a065d8485117fdbd\";s:28:\"admin/assets/images/hand.png\";s:64:\"defc640a8b92201ac144a8bf82c2469f58c386473edba5c10103f5d89693fd53\";s:40:\"admin/assets/images/light_pattern_2x.png\";s:64:\"3bc3620ff365e1140e8699bc4b8de2107be52e87338a5bfdf6bc59a2c6987e6b\";s:37:\"admin/assets/images/modal_asset2x.jpg\";s:64:\"9d3ed1573a9ff7b864ddd46fcd0248af7ee7e14333b1390f164ccfaa9275e9f4\";s:32:\"admin/assets/images/modal_bg.jpg\";s:64:\"6488a70995e61f41dca7acdd5ea3149aa379b381ba4becf78d8a89884a644948\";s:28:\"admin/assets/images/move.png\";s:64:\"7f5ad57e6db0f4817e5d7b6b061f88c860ba746d74734715753a5e6260949b28\";s:36:\"admin/assets/images/point_bottom.png\";s:64:\"34398b312ba7fe9c51fb94456214a7f4e6c03860218450be05ebe6040e2a2c6b\";s:33:\"admin/assets/images/point_top.png\";s:64:\"ab3a334761e0f1d22fa69ea22ac564e83a908674e8324e7add58d6c5990fb118\";s:31:\"admin/assets/images/rb_logo.png\";s:64:\"ad8daaf4061d9e29b6924e3a5d5933299bec8b0411b681adabb29969ffc13ab7\";s:34:\"admin/assets/images/red_diag2x.png\";s:64:\"3a4bc5b13f6bf517560b65d7721a1e8cafd89cd6a3807a05ea02b6d80b628b27\";s:30:\"admin/assets/images/resize.png\";s:64:\"f09329e7a74df8ae9a35aa80f620fe87a27f6e588c184352ba08d3cbee488e93\";s:34:\"admin/assets/images/resize_old.png\";s:64:\"3fff7f0227aa525da07b9ce5ba515ff07aacc02cef17d24b3820e00d59dc9a25\";s:30:\"admin/assets/images/return.png\";s:64:\"1ffe67dfdf227e584118a858ed95e6c3a2610d55f686ada9d99468e3ccdf2e70\";s:31:\"admin/assets/images/revlogo.png\";s:64:\"9b9f04e77c92b456d57e874eef47dca2ab7b6401d234d12a101146c60d0a90c9\";s:35:\"admin/assets/images/rs6_logo_2x.png\";s:64:\"cd445ca3726da218e9e1e1f00ac1f53e7ec46fab85da51bc535b9ad49bee228e\";s:37:\"admin/assets/images/rs6_number_2x.png\";s:64:\"ed896bd6f181c8a7c6c0255f9a197ec3b305ab5cb1a6e1ec78524b06e9ae8ca3\";s:38:\"admin/assets/images/tp-brokenimage.png\";s:64:\"1306aded900d43461c2b5a83bf17e15e27594e60d7fe37b48d438e2f8ff79794\";s:34:\"admin/assets/images/trans_tile.png\";s:64:\"de88c2c9dd9fd2c79a1702f3d78502982f311a0f1ee95f7af9a49c786467e81d\";s:35:\"admin/assets/images/transparent.png\";s:64:\"f1bd92c463d12ce6843f60eafdfae463c377da9e4384faf0ea7fd303f0f0eb2e\";s:47:\"admin/assets/images/transparent_placeholder.png\";s:64:\"b65d53c2ed7af699179f0226f75d3b873710996cd2a589ba5460bc771c5141da\";s:26:\"admin/assets/images/wc.jpg\";s:64:\"e81aa9b11b00f8f187b13cb527f6a2ae020e673262ec39ee0bbf8e3fdfe36433\";s:31:\"admin/assets/images/wc_logo.png\";s:64:\"ec1ee9b12a2defa72c1a931eb7bf60d5119dc2c03b54ebb725e0d6fbcb5c98dc\";s:30:\"admin/assets/images/wplogo.png\";s:64:\"292fdf705e6afff430f6c6940818b214fde96d816e8e795350d9f65b1ec3c4bc\";s:35:\"admin/assets/images/guide/guide.jpg\";s:64:\"d04a3ecc9f645b5271ec974db385e7b6aadd917db3bde141fc9bad5c04c552ab\";s:40:\"admin/assets/images/guide/guide_auto.jpg\";s:64:\"6211002a12349f4a6ec4ba5040daf53bfc34886811aeb2a3502e73b458febc97\";s:50:\"admin/assets/images/guide/guide_autoresponsive.jpg\";s:64:\"e55b9ca4d3cd8d621276dd5494dc2aaa876c7d14b7f3b377d56aa51c3d67f8c9\";s:44:\"admin/assets/images/guide/guide_carousel.jpg\";s:64:\"c7d11098a081465f21809756c851ceb73d6d235e167c759354f14e2d2387b149\";s:46:\"admin/assets/images/guide/guide_fullscreen.jpg\";s:64:\"5d8cff981422c79ba7fa17c5ab7696346744771249ab92d3e53ee17fa17e0870\";s:45:\"admin/assets/images/guide/guide_fullwidth.jpg\";s:64:\"60dc73ce677cf23014dc7a5dd87bd5119f43ef29ec08287920e2cfbd95349979\";s:47:\"admin/assets/images/guide/guide_intelligent.jpg\";s:64:\"e4e785915db415f6edeeb3b38a7ae9b3e785aff78cc4ca60c929844a8e03441a\";s:42:\"admin/assets/images/guide/guide_manual.jpg\";s:64:\"0c82ded71280094fc268d5cc4b35aa1bb73e97a4575e5c652c06d4b4eb5e3896\";s:41:\"admin/assets/images/guide/guide_scene.jpg\";s:64:\"98b3f28ebbfd27d59636948497867c6c3874c2a5d6f440ca6142320a5ac37c9e\";s:42:\"admin/assets/images/guide/guide_slider.jpg\";s:64:\"e863e4b5366136f6ab35e157408a32f65dfdd4c9d8b1edaa8638275ffdbb479f\";s:49:\"admin/assets/images/guide/video_addnavigation.jpg\";s:64:\"61d9d9a4bce6d3568f4df80bef4c83bd685eb07276fbcffd013bcd37a7268d2d\";s:51:\"admin/assets/images/guide/video_backgroundmedia.jpg\";s:64:\"b6f65a850eda05efa722eb962ebe74d2b7dc9d03d54a26abea972d2318dbda00\";s:44:\"admin/assets/images/guide/video_kenburns.jpg\";s:64:\"40c170d8660f52638fd26d456a1ec6aa16ca720c7d6a9059a877f1d4c58b16f5\";s:44:\"admin/assets/images/guide/video_parallax.jpg\";s:64:\"c35a2a49cde585257f8ea530974a6a9ab106ea3eb64511685afa5751f8126646\";s:45:\"admin/assets/images/guide/video_preloader.jpg\";s:64:\"dc75eae4dbe030addf108997cec65d1347b0179530a5e272399cc2fdd241cf67\";s:50:\"admin/assets/images/guide/video_slideanimation.jpg\";s:64:\"d3fdc3a270aafd14032674e6c9bc0e33d26c184acc6a056feeb787a65807e274\";s:40:\"admin/assets/images/socials/dribbble.png\";s:64:\"eccf6cd7d9c837658cdc7557c1a5cb568b217f4c5be678df085e756b59fc01d1\";s:40:\"admin/assets/images/socials/facebook.png\";s:64:\"8c1664480d3173a9589ed7715389accf7276360f3e10bc5a78cdd78971e7b9cf\";s:42:\"admin/assets/images/socials/googleplus.png\";s:64:\"871c106f57c031695b4fa87bdc2da257d6a63407027a5c5edd25f7fa930192f7\";s:41:\"admin/assets/images/socials/instagram.png\";s:64:\"fb55da35fd109dda13f151c16c10765ca4d18def3061785b0c66c7743040fdfd\";s:39:\"admin/assets/images/socials/twitter.png\";s:64:\"fdd2d2b2092974ddb05e35cd6c44871b4c0bad80ca8aa5a560f742511d63e5cb\";s:39:\"admin/assets/images/socials/youtube.png\";s:64:\"f9799e89df6a96ffced54075d23eaf47ad290c2a38bcb809ccb323e063ed6c4a\";s:40:\"admin/assets/images/sources/facebook.png\";s:64:\"202540c1f898c94e83b49038ceb28ec48e078f9460706244f7ca294e5b09c3b6\";s:38:\"admin/assets/images/sources/flickr.png\";s:64:\"351a3549e7c6b3d80ace1b2996acb7a1c5b1f17d51c62b5ce639eebf5b9cc2cd\";s:39:\"admin/assets/images/sources/gallery.png\";s:64:\"868cb041e5cd1d8c3dd980d0f2b63bec1d0db9ed1d2e667f6d47c807a38718c8\";s:37:\"admin/assets/images/sources/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:41:\"admin/assets/images/sources/instagram.png\";s:64:\"a4370783505a6a90f4c445ba3b7478baf852351c71deec6d797fe579bb6a9ae1\";s:38:\"admin/assets/images/sources/notice.txt\";s:64:\"126128e2388e7d373aa092a9c55f484ffeb2ddb0df66c10411594d40a1884c92\";s:36:\"admin/assets/images/sources/post.png\";s:64:\"bc7b40d886192b3ead79aedb2cd1855dba921cbd6c224b582f756a62f320c28f\";s:38:\"admin/assets/images/sources/static.png\";s:64:\"868cb041e5cd1d8c3dd980d0f2b63bec1d0db9ed1d2e667f6d47c807a38718c8\";s:39:\"admin/assets/images/sources/twitter.png\";s:64:\"4563c3ac62ea1a05c5b3f25eab448caa131f1bdbf8bc5b15e54a623436c2e58b\";s:37:\"admin/assets/images/sources/vimeo.png\";s:64:\"76c3a285ea36fa9170b76610cb4b41d447898fd55443edf618aad6b28086d400\";s:35:\"admin/assets/images/sources/woo.png\";s:64:\"7eda50bf7a85bf75e3cf2f332413cc2daabc147feaa393ae080b082114811528\";s:39:\"admin/assets/images/sources/youtube.png\";s:64:\"67419aec01cea6047a67ba733cdaaead38c9112da951be1f74007fc10ba6b89f\";s:36:\"admin/assets/js/modules/admin.min.js\";s:64:\"1b673f216e9b3e467dd0893024545cd893ed3bac8e6b8f923ea2e88b43050d34\";s:37:\"admin/assets/js/modules/editor.min.js\";s:64:\"9ae51f2c7f9978512eebb2e8087f30e404efe997c897755e9f67fee341cc1e66\";s:31:\"admin/assets/js/modules/help.js\";s:64:\"0666c042b16ba14de69119955c7c244a5833c25b3c6043be9c77501f87d35425\";s:39:\"admin/assets/js/modules/overview.min.js\";s:64:\"6ff64cbd0dd44e71528e5690e72581e13ce1a51b52a336046dd40212d8dcc314\";s:34:\"admin/assets/js/modules/tooltip.js\";s:64:\"bc6495f4dbf9bbbb477389d6efdae4d7bd060e7b6976b3de6a73bd4d4a7b95ad\";s:37:\"admin/assets/js/plugins/codemirror.js\";s:64:\"ba05e0676ebcbbaf34c2414c942ba2fa41946d6aeb0e0ddf1fc9423478014b5b\";s:40:\"admin/assets/js/plugins/penner-easing.js\";s:64:\"1a7ff16e46eede4a8dcd951acbdbd1cebff68a965f20050865cdc43418608af8\";s:36:\"admin/assets/js/plugins/utils.min.js\";s:64:\"eee6cf3efe3c8d25df41a9731759e94d7d559966e181d3a0fa151ded637b3395\";s:37:\"admin/assets/js/plugins/wavesurfer.js\";s:64:\"5b31e8381937f666e18cfb64d4613b6d30d1f752f0c7f09b2c8015ccd370db08\";s:58:\"admin/assets/js/shortcode_generator/shortcode_generator.js\";s:64:\"cef020ad02cb0c7a0735133b1d93c4c333cb22853914e59c0103bae1d47b741f\";s:46:\"admin/assets/js/shortcode_generator/tinymce.js\";s:64:\"bf06203d1152a3499349ea6d0500c91cfa25ba5d9cf3be29f220d3ad58fa559b\";s:41:\"admin/assets/js/shortcode_generator/vc.js\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:38:\"admin/assets/videos/hover_tutorial.mp4\";s:64:\"026c4a507f9431baa95c701c633fad5392f1c93e6aea6b4a2c95a9f766e7b8f3\";s:31:\"admin/includes/addons.class.php\";s:64:\"837b196340c9f7c323f017422edf3b8bc01dbf1b92cb816673b47546f70e40e3\";s:24:\"admin/includes/debug.php\";s:64:\"27b1f7b1180cd728beef64bfd791eea05f6e2fbdfb2c82fa36d2727df6aad5a5\";s:36:\"admin/includes/export-html.class.php\";s:64:\"d1ce2873bcf1de469a29194eced3dbf5b22d93c17fa0550cba5fdb677e3901e7\";s:31:\"admin/includes/export.class.php\";s:64:\"3bf3a0f939eee2be3c648b1b93c17612a7ab698f645729a17640d4930f8b72c4\";s:31:\"admin/includes/folder.class.php\";s:64:\"668880574463b53d46069a478a23ed894564096dca53e367f82035018e593bf9\";s:40:\"admin/includes/functions-admin.class.php\";s:64:\"e8ee9a300d5fbb8948a0b15c1ab047a1e4c66b2c0e0f5d42c9c440d739ede036\";s:29:\"admin/includes/help.class.php\";s:64:\"b2b3e002c96d5298d21aece7f6b97724cf35854ae83034a8c4d3928aa7c931c9\";s:31:\"admin/includes/import.class.php\";s:64:\"abe0960180bd749c5724a9db256321ad617912e715655d30240948dc20ef817b\";s:37:\"admin/includes/loadbalancer.class.php\";s:64:\"0cfd0162d0db6a3286862bf51bac5e3b512a268574c6f38c2310b4b2a2e80190\";s:35:\"admin/includes/newsletter.class.php\";s:64:\"22c72250809fe6adecafb577d34803d0e009b12b8ce05889deda2b6aea6dd716\";s:38:\"admin/includes/plugin-update.class.php\";s:64:\"ccb03d9a1295c03f1d3f234a5d2931c99e2041320d90046a578dcba3c82eb4ba\";s:33:\"admin/includes/template.class.php\";s:64:\"5a14b4eff2929b7be5b4eb460c3cc7a3d3a28044a268ead13f0a5cea37268a34\";s:33:\"admin/includes/tooltips.class.php\";s:64:\"575a99463b3448fa00374ae894fcc05e450518844910fc34ecf65aec449c5b22\";s:31:\"admin/includes/widget.class.php\";s:64:\"8be15b36cf1e5bd50a14e9071010e109cbb6f5dd3e91c0e8a0c1bc0892ab386b\";s:64:\"admin/includes/shortcode_generator/shortcode_generator.class.php\";s:64:\"9a12d09bb64a541f8dae304472a7ad16f12665cb9732d69e791f4b5b0f558662\";s:71:\"admin/includes/shortcode_generator/elementor/elementor-widget.class.php\";s:64:\"04e287a3268a772c562ca3c2c687ab4b54e88499d4342a621c2b7eb5b40ebf35\";s:64:\"admin/includes/shortcode_generator/elementor/elementor.class.php\";s:64:\"4fe51b8a1c9b7ddbf1657c8ed315d7863a123707f76f77c1bedd5bc97b985441\";s:72:\"admin/includes/shortcode_generator/fusionbuilder/fusionbuilder.class.php\";s:64:\"f9362da640300d8995fb78424143ffddb6a725dcd452c7551a42244fcce9ffac\";s:54:\"admin/includes/shortcode_generator/gutenberg/README.md\";s:64:\"2464d9cba2ec8666bd3412c3240dbe66c6bfbef4a6596cbf85455eac0c2fd0cf\";s:64:\"admin/includes/shortcode_generator/gutenberg/gutenberg-block.php\";s:64:\"65150faa09f88b8a71a0926139431ec61a44fc1193bbacb74344e16a48af6513\";s:57:\"admin/includes/shortcode_generator/gutenberg/package.json\";s:64:\"3dc1b828068b59d2b291a4528e9673fc099aad4e943816ca1a18c3af7c8f8ea9\";s:55:\"admin/includes/shortcode_generator/gutenberg/plugin.php\";s:64:\"ca5b977bb88f55c0f899ccbf5340dbb2aa8fc21e0a548dca7850863802b3851a\";s:65:\"admin/includes/shortcode_generator/gutenberg/dist/blocks.build.js\";s:64:\"2070a9dd0833a7b6a2499d02ee6ffb32d1ad3d1f8e07c7ddc731c2ad3be25b3d\";s:73:\"admin/includes/shortcode_generator/gutenberg/dist/blocks.editor.build.css\";s:64:\"6dbfdb3f0689e2ddf7df17dc958bb52a301e6d2288956656f6ff56f9a4d5f3f9\";s:72:\"admin/includes/shortcode_generator/gutenberg/dist/blocks.style.build.css\";s:64:\"634cb987a331fb17d0c89658e59fa14d57dd8de253d00295a811d6114ff5caeb\";s:72:\"admin/includes/shortcode_generator/gutenberg/dist/images/rs6_logo_2x.png\";s:64:\"cd445ca3726da218e9e1e1f00ac1f53e7ec46fab85da51bc535b9ad49bee228e\";s:74:\"admin/includes/shortcode_generator/gutenberg/dist/images/rs6_number_2x.png\";s:64:\"ed896bd6f181c8a7c6c0255f9a197ec3b305ab5cb1a6e1ec78524b06e9ae8ca3\";s:58:\"admin/includes/shortcode_generator/gutenberg/src/blocks.js\";s:64:\"efd8c7b995c1835886c682bea7a6e9df312f7b8e9634cc0f82e159d958e81ef8\";s:60:\"admin/includes/shortcode_generator/gutenberg/src/common.scss\";s:64:\"be5178bf1db137be216ce89aef3c1c8c9bc6f14fdcc17142a6deb9aa7c99c2e6\";s:68:\"admin/includes/shortcode_generator/gutenberg/src/gutenberg-block.php\";s:64:\"20a1ac155a9f56cd59f3fcfe9fdeb3b7d3e2143ee0a155a1ecced49b3b3073c2\";s:74:\"admin/includes/shortcode_generator/gutenberg/src/assets/images/esglogo.png\";s:64:\"fac10591d1459fa6b2f717f0f3c1d86434df1c648e0ac87c6b52c888ee923176\";s:75:\"admin/includes/shortcode_generator/gutenberg/src/assets/images/js-wapuu.svg\";s:64:\"61c447e08efea7e9c2a16852d5cee3353ea68c36ac6d1e279f1c3c1de702b657\";s:74:\"admin/includes/shortcode_generator/gutenberg/src/assets/images/revlogo.png\";s:64:\"9b9f04e77c92b456d57e874eef47dca2ab7b6401d234d12a101146c60d0a90c9\";s:78:\"admin/includes/shortcode_generator/gutenberg/src/assets/images/rs6_logo_2x.png\";s:64:\"cd445ca3726da218e9e1e1f00ac1f53e7ec46fab85da51bc535b9ad49bee228e\";s:80:\"admin/includes/shortcode_generator/gutenberg/src/assets/images/rs6_number_2x.png\";s:64:\"ed896bd6f181c8a7c6c0255f9a197ec3b305ab5cb1a6e1ec78524b06e9ae8ca3\";s:72:\"admin/includes/shortcode_generator/gutenberg/src/revslider/deprecated.js\";s:64:\"99457402ad4338fad79d5eabadab6af50b8591007d65229b97a226cdb7b1dbe2\";s:70:\"admin/includes/shortcode_generator/gutenberg/src/revslider/editor.scss\";s:64:\"7ef54f16537496b99a2d7cb1ae320feb363005812357537600afce2a68d768a5\";s:67:\"admin/includes/shortcode_generator/gutenberg/src/revslider/index.js\";s:64:\"892f4359a45b7d1010343fae3cc346bbfbd54412d7956084f0c086120011dda4\";s:76:\"admin/includes/shortcode_generator/gutenberg/src/revslider/revSliderImage.js\";s:64:\"e73cdb93818b7c8c3bada1ffe89b98713d4c7eccb1689ca93b0207555e3b397a\";s:71:\"admin/includes/shortcode_generator/gutenberg/src/revslider/revslider.js\";s:64:\"c4ce472f248058074e8bb65004599bc591fb499526aef631a2937689e37d31b5\";s:69:\"admin/includes/shortcode_generator/gutenberg/src/revslider/style.scss\";s:64:\"6360332bed614ce6a5887b91a76b790d04171b0f1b7ad91d11ad7ea013c8fb15\";s:62:\"admin/includes/shortcode_generator/wpbakery/wpbakery.class.php\";s:64:\"69dddadf7be06dd70691004db07d904b56f6ac47812320db3b5d34045623985b\";s:35:\"admin/views/builder-layer-forms.php\";s:64:\"a6878f891188dc3627a75de9859def02e490c92a255611c694f7a0e4bd7dca12\";s:33:\"admin/views/builder-nav-forms.php\";s:64:\"1120324f2c94b25bfcfc5617dd872ef259c3277d89334dd04bcc6612bd13d52a\";s:35:\"admin/views/builder-slide-forms.php\";s:64:\"feb3f12d764214a8dd73a19ff14eae3b51ad2921add6ae2696117bc32cbe9cb0\";s:36:\"admin/views/builder-slider-forms.php\";s:64:\"278a50aad3e8820b345e44af3ef19f7d955141cf0d428c673eba086a53fb36f7\";s:32:\"admin/views/builder-timeline.php\";s:64:\"e747ff11b902f347e814770017d581dbc1094f07de8cac2d9dea8edd4d2e4382\";s:23:\"admin/views/builder.php\";s:64:\"2140e3bc1b6eccfcc62ecce96f8427dfe4332df13a131ab8207dd1a0446563b3\";s:22:\"admin/views/footer.php\";s:64:\"01ba76fda5cc40f589b0531ec2c29815b7d357564d548261bb51f866b04d0652\";s:22:\"admin/views/header.php\";s:64:\"0cdaed45a07a4c124bb63948674527c825782466b08b8daa999606076805aea0\";s:21:\"admin/views/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:30:\"admin/views/modals-builder.php\";s:64:\"35469148acd36fa7078219d460c5ff858d367c2fc69ad625a8ef403db154625a\";s:32:\"admin/views/modals-copyright.php\";s:64:\"e1e3d4622c2237b115eb7e5a5b077e6c799f1461a08a2f520d27949e35aee975\";s:30:\"admin/views/modals-general.php\";s:64:\"a161ab24cd5c56cb8647ead4a899c72ff21ddeccf0ab374e9680dd9feee71c1e\";s:31:\"admin/views/modals-overview.php\";s:64:\"7ad1f963a81a332cf91205f8d0f4251ab780c9d9a257e402da7fc899cca50e21\";s:24:\"admin/views/overview.php\";s:64:\"9d9fd54829a2d71ce832e2d5c0fdb093ab9b396eecef3ab4802c5a5d34241447\";s:32:\"admin/views/features/add_ons.php\";s:64:\"2d6f9a15af937cfdcf605b022ad7a78ded85bcd89af7f9fdbb1023f9a1b41049\";s:30:\"admin/views/features/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:41:\"admin/views/features/layer_animations.php\";s:64:\"b0a3ffe1067725baae55595f35b2e729d005d1884ad7ad42e6c7926493cbd5f8\";s:39:\"admin/views/features/object_library.php\";s:64:\"7518e597c70510fec32933fa1debe3a674d70767f6f6f8932d693201d35508ac\";s:41:\"admin/views/features/premade_template.php\";s:64:\"4a2117abeee10db6f11f6dd39a7d37c842b5556a2b9332c6f7360cf23ddbbf3f\";s:32:\"admin/views/features/support.php\";s:64:\"5025ae9ed4e70b33e947920d34729685ab3d8dd688356d87ceafc72618e41b8c\";s:39:\"admin/views/features/assets/add_ons.png\";s:64:\"96fb6b841d2bc049fcba0fa80ef79de4ff77388dbf91d6ab6fc598e95f503a02\";s:38:\"admin/views/features/assets/addon1.jpg\";s:64:\"3c96a68fd78f03fc3e5410170fad75c91f738e0be582d9d8c54c167bd6faac71\";s:39:\"admin/views/features/assets/addon10.jpg\";s:64:\"5cff72c81bbf24757489f259f23300cc2ce1e24b9d95824d4f3a9b2d8f20a3cc\";s:39:\"admin/views/features/assets/addon11.jpg\";s:64:\"b19e4fa5383868c975e46e2691cde73c18d25a6fa166911c50ffef4aaf4fac14\";s:39:\"admin/views/features/assets/addon12.jpg\";s:64:\"97d66387851a59cbd865b1a6fee7484a4e4fa2a0f438a0e516a8a1543f48e497\";s:38:\"admin/views/features/assets/addon2.jpg\";s:64:\"b95f83b889b4d22f101494f10db3578caded883e7f09bed2a25f9dc3a166c6cd\";s:38:\"admin/views/features/assets/addon3.jpg\";s:64:\"bcf5f7bc1cf3fc2e2401bf626596f46fb7c966b40c110d570de4bf9e64905637\";s:38:\"admin/views/features/assets/addon4.jpg\";s:64:\"d2175d4787a5bc31d9ec691247004c4fe43b1e27ad247c5a73e92c985a2978c7\";s:38:\"admin/views/features/assets/addon5.jpg\";s:64:\"7c3d70a0629604ad7bed73446e938b079f1df559d117905ad4d0b8ba538e1560\";s:38:\"admin/views/features/assets/addon6.jpg\";s:64:\"d08bfca4bc79226fe9f9494c5e3ccd0a1f5ee720ca86b85a2cdb8d460194c6bf\";s:38:\"admin/views/features/assets/addon7.jpg\";s:64:\"3e0fbadec6e55daa136bb03f8b2cb442465984f80ef86501e9efc7de3a2ccd4a\";s:38:\"admin/views/features/assets/addon8.jpg\";s:64:\"f76ce3e794787a1550473e062c6c1683e426f702e3d5386ea676c7b50c85386d\";s:38:\"admin/views/features/assets/addon9.jpg\";s:64:\"7878375cc336a8341c30d96d978cc3051f78cb59d74759fd59285fcc66fd06e4\";s:43:\"admin/views/features/assets/addons_bg-2.jpg\";s:64:\"c53e7c20f2c1966ae5146d16dabb74b79530e5c3a5c4dd54bf05fb282252d2d9\";s:37:\"admin/views/features/assets/dummy.png\";s:64:\"17af9e65317bbbfbbd0bcdc729f14faadf37cd08cf30cc0fe0b72443e78cbffb\";s:48:\"admin/views/features/assets/layer_animations.png\";s:64:\"8b97dad548ecf3ad58e242e97d8a6f3c2a40862f5a8443da482d4c59090e4e17\";s:51:\"admin/views/features/assets/layer_animations_bg.jpg\";s:64:\"f1e60e1e34f8cfd1edac9ab4f6668d8f3f3293ccaca37123ca5900254bb322df\";s:41:\"admin/views/features/assets/layers_bg.jpg\";s:64:\"a2094004d1c3d41a5be38c934e377740e80738b39a5c64aa326200aa815915f6\";s:46:\"admin/views/features/assets/object_library.png\";s:64:\"75c5c9f4a02ae447dc1389073b0a368961d0329efe7ee745b5d66b3c9301ab4d\";s:51:\"admin/views/features/assets/object_library_bg-1.jpg\";s:64:\"233b17c0d88b2c69e1c8482c8ab468dc3a3bfeaf4da4184102bc71d315f97fcb\";s:57:\"admin/views/features/assets/object_library_headphones.png\";s:64:\"4a7cb601c92ea14a79c41c52fa61073941742256a9b39fcca5117ac377478edf\";s:52:\"admin/views/features/assets/object_library_phone.png\";s:64:\"e441a781269ad9a9f21f675007da81b6b49e3d6675523250d03202efadac6851\";s:44:\"admin/views/features/assets/premade_left.png\";s:64:\"d6262fc3ba8fffb98ff03130f887efc7041663ba6a6efdea76019e723a9357fb\";s:45:\"admin/views/features/assets/premade_right.png\";s:64:\"f1c1c7b56b43f9f7e3f714cfa453315620de6223857a7257312c6015d934118e\";s:49:\"admin/views/features/assets/premade_smallgird.jpg\";s:64:\"2feb8a6201d288b64e38fd8a070ec9511a5b6b6177ed3a8995e4fd32a5aad7ef\";s:39:\"admin/views/features/assets/support.png\";s:64:\"310257766bb9c53e37170d5f7fe1e49bed0a58a87ef0e807cb9bcbd4b59c4f02\";s:44:\"admin/views/features/assets/support_bg-1.jpg\";s:64:\"93b6687e1e441c7570e9f504751b663c6d6c3011f377d3eae0987e87309efa78\";s:43:\"admin/views/features/assets/support_bg2.jpg\";s:64:\"527bbcbd1c80b7138365ad99ea3a643f4d9dffec5ff4a6c8b2a650b0268900bb\";s:43:\"admin/views/features/assets/transparent.png\";s:64:\"8ea078292393a14a8e44be139a7fa6ed09d9c650e210eccca587045239b71cab\";s:16:\"backup/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:29:\"includes/InstagramScraper.php\";s:64:\"b6c1995afd7981b29cb5096ff99247251c60910f793fd22c23ff3c8d71b8c19c\";s:20:\"includes/Unirest.php\";s:64:\"87b480d091661be15d74c5e9c4b7b8852bf66d59e22fce81b291de085b72af9c\";s:29:\"includes/aq-resizer.class.php\";s:64:\"c76eb2a9d72dcb3390a68e696e1d2de0dff19615cc734eac5f80a3a7b46244c7\";s:22:\"includes/backwards.php\";s:64:\"8644bf563db4b7988aa4967fa2fcd08cf564d08a0c36bac4a78dcabb4630c6ab\";s:22:\"includes/basic-css.php\";s:64:\"f9a052ce264163ad9141a12d0503e144c0b98d9d2b626912f664a650ce2cd90a\";s:30:\"includes/coloreasing.class.php\";s:64:\"b9fae53a3df0b6e84467adee087091fb0e88690c4844ca38785337b2cb61c85d\";s:30:\"includes/colorpicker.class.php\";s:64:\"2b1b0a719f48fd92830dfddfc9097f92b7d638a18f9bb0807508ea1e8892c8a0\";s:28:\"includes/cssparser.class.php\";s:64:\"e0cb0f34262ec9580a8e11074f224533f18258c139f2f6adaf9278eb5c61af00\";s:23:\"includes/data.class.php\";s:64:\"2bc946e79c5369d5984418143e684cd825adb31907bc71705a49075670d1bda4\";s:33:\"includes/em-integration.class.php\";s:64:\"3ea8e4ef346b4599ee955abd00636cd8ebe0bf8c5dda6bebc3a6745e31496151\";s:28:\"includes/extension.class.php\";s:64:\"2c1186cabb51bbcafbf9ae8e409464821261bad96cb0ec1c1a4e7ad3ea408eb3\";s:35:\"includes/external-sources.class.php\";s:64:\"31c8fe12b8dd901629b07acb72c53afc005a71b97521e93f93387d5178824f18\";s:27:\"includes/favorite.class.php\";s:64:\"6abbd236e879d8f829fd8292436a89c8fb7e03fb3ac9f1fa3bade4b363f9eda9\";s:28:\"includes/functions.class.php\";s:64:\"54226614bda93517ee8e871ccd1b0eb4425412e36cfc173853d8c5620d2ad91d\";s:24:\"includes/googlefonts.php\";s:64:\"fe0349d84d40be776caf50008f49c019c2bc7707b25e918a4d1b4572ffb75edb\";s:29:\"includes/navigation.class.php\";s:64:\"6ea4d93939ce8d939b7e3e863aaa2d0c1dabedc14dcab13e002d3da3e6d0bda6\";s:24:\"includes/navigations.php\";s:64:\"1800f6eea89f7f88da09996e1a9c0eef8b920ed0c913deb266f2c66d69d0fcbe\";s:33:\"includes/object-library.class.php\";s:64:\"8d99362f536f44f54fb7ecad8249036190896360d7aa8ed7ecb547423481467f\";s:25:\"includes/output.class.php\";s:64:\"9b4ba502d033de7912eb4c3ceb3fa1432d544f1fdbf577920eb34ee185ad41b5\";s:32:\"includes/page-template.class.php\";s:64:\"0970d7f374a664c6f3f061b5820da24358b8aa50c228ff21a039cd0fbc5bf035\";s:24:\"includes/slide.class.php\";s:64:\"851164d4c70f3646bbeb02afb7d44def95eb222ff78a2ea759c471a75b998ef3\";s:25:\"includes/slider.class.php\";s:64:\"83ba0ac5da950c5c18a8ed60b0eeb1354144553fb69096e1fbb057cdb351054a\";s:25:\"includes/update.class.php\";s:64:\"6f7b1261f5f1fdf54fa3c0b48c1666df6ae3f73cc7041b94b7a048cb82f8b9b9\";s:30:\"includes/woocommerce.class.php\";s:64:\"1f1bc10faf857c06ffafe6740049f5da7e168213dea941bcbe8f6ff7166f8958\";s:23:\"includes/wpml.class.php\";s:64:\"a5f227b274467ceb0b478e55decfa246703341f61b809fdb3db8615b7a1e0227\";s:39:\"includes/InstagramScraper/Endpoints.php\";s:64:\"8f3591b3ffb5a1daca12467e8d7afc29435d1136b0b693e3eaa4ce0a02b1dcc0\";s:39:\"includes/InstagramScraper/Instagram.php\";s:64:\"5f546dac80cd784cb45fea3c54e52bb75f1f8e0f470e45117c44af4dc459e867\";s:46:\"includes/InstagramScraper/InstagramQueryId.php\";s:64:\"02d5c38d0b845e53141d357735e166069aa6cbf106318ca17b25346dccc720cf\";s:43:\"includes/InstagramScraper/Instagram_old.php\";s:64:\"580217260b9494cd773ddd3070173a18d3ebcea8964e4da709e7957936639b86\";s:62:\"includes/InstagramScraper/Exception/InstagramAuthException.php\";s:64:\"ad8a6ebe0eb4aff6b61f723516af75fe580e45f47ed9b67acb7a1dd4fac4eca7\";s:58:\"includes/InstagramScraper/Exception/InstagramException.php\";s:64:\"72570b2ba1943c9fbcb7ec601b2606b1b6245a44d61d1417ea293c357fda626c\";s:66:\"includes/InstagramScraper/Exception/InstagramNotFoundException.php\";s:64:\"6494e53fe7efe6d6336e114237365e84b1eea820d2c7ef1e8047246f517aa57d\";s:49:\"includes/InstagramScraper/Model/AbstractModel.php\";s:64:\"0669f393a8c3c7138239c11bd495a1e01cb5e38d524797bda0ae1182bed3f282\";s:43:\"includes/InstagramScraper/Model/Account.php\";s:64:\"f74753bdb4d6fa465dbb620cd88363cf59cb08988cf0ab90a2afd1ec3b71c5fb\";s:49:\"includes/InstagramScraper/Model/CarouselMedia.php\";s:64:\"9aeef630302bc13e4b0eb581d4fe5a028bfe482679c6c1de12c7f6bee36709d7\";s:43:\"includes/InstagramScraper/Model/Comment.php\";s:64:\"b229e099790d3091de53dc9dcd3224b43f6a3dbf3ccd3b1408844c4f180f7d6f\";s:40:\"includes/InstagramScraper/Model/Like.php\";s:64:\"2b817e2ac6b9e80382bd4107d6c00168b365eda3b5077126bccb1e77509ee0ce\";s:44:\"includes/InstagramScraper/Model/Location.php\";s:64:\"2bfab5fbab00843fde8874fac8649f43140fe350311fd3815a333615099cf75e\";s:41:\"includes/InstagramScraper/Model/Media.php\";s:64:\"4c4e061cc2fbf6ab48f8019317871f8bf1d95f7332356d214f1729acefd6964d\";s:41:\"includes/InstagramScraper/Model/Story.php\";s:64:\"bdc484342c42aa6998024920de5e2970b7b862c17fb0cb39490cd21165018c21\";s:39:\"includes/InstagramScraper/Model/Tag.php\";s:64:\"0544a543c1d346aa51fa72703f3b46d96546e20a50d01707d527c00e2018cbf0\";s:47:\"includes/InstagramScraper/Model/UserStories.php\";s:64:\"811c198285410b8e3804e5f6bb584f14aa06da42c8aa7fab00dcd3280d44c892\";s:51:\"includes/InstagramScraper/Traits/ArrayLikeTrait.php\";s:64:\"a5b63d339635e43f42af92613a7684c80cb3b158ad3510983aa88d5c68d57833\";s:53:\"includes/InstagramScraper/Traits/InitializerTrait.php\";s:64:\"d214374db156593dda9caaf70d36e0482fdda22ffe432358e935042a550dd9ec\";s:30:\"includes/Unirest/Exception.php\";s:64:\"d0806a98b6ebe83deedcbca2cd3262c1a572e0d41919fe53a4bcb393199fdba0\";s:27:\"includes/Unirest/Method.php\";s:64:\"264a8e8043fdd77153615feaecace61e8ad6a6006476eedde4c8edda9cfca826\";s:28:\"includes/Unirest/Request.php\";s:64:\"e5a75f5d02d44869616fab4c48b852fee79c39583f9ffe53198ba373f762ddf1\";s:29:\"includes/Unirest/Response.php\";s:64:\"5dee538c65123ac9d96c06696020685f1ddd66397f3d2c5a0847626c632cc08b\";s:33:\"includes/Unirest/Request/Body.php\";s:64:\"542d56094bcaff1b041d6d969334f7606091a5aa5166a97d052f57e1f31085f8\";s:19:\"languages/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:52:\"languages/revslider-de_DE-backup-201911120818060.po~\";s:64:\"0a4d4a438743ec2328dcc3211dbb7d432330fe585b0e2d4d02a8374cd4951da3\";s:28:\"languages/revslider-de_DE.mo\";s:64:\"8298c17a391fad96c417c894d3f23dec8d19345b0b30d387ba243938786c9f21\";s:28:\"languages/revslider-de_DE.po\";s:64:\"681cf3c73fb020f8b8f27ab1c46277a24869e0e38d02bd9f4cdcc71d0c2eb530\";s:28:\"languages/revslider-en_US.mo\";s:64:\"b25f5e9fcbbdd63dac695132b3d1c8328e3e4cb52957a53e9aaa6bbece7c3769\";s:28:\"languages/revslider-en_US.po\";s:64:\"bb2559430235c1165b075411e662318ed2e627a13a29abf9c62165ca0568f180\";s:28:\"languages/revslider-fr_FR.mo\";s:64:\"31527867138b40f6d4707890035dbe494419fe0f9984fcd10a87496f70e1797d\";s:28:\"languages/revslider-fr_FR.po\";s:64:\"0f461f184c6b478a841a98fb451e60d3c6698f978477060dff31426ac9ca098e\";s:28:\"languages/revslider-zh_CN.mo\";s:64:\"e67ebfae2cfc720c3469d745a57f0cc7b2cc8ffcb0c2fdf7d968f3dcdcec5896\";s:28:\"languages/revslider-zh_CN.po\";s:64:\"fcbc1a592e4390be364564f6bc05b672b9a228eb7083ee0d6c62ef9ffa0b2baa\";s:23:\"languages/revslider.pot\";s:64:\"cac3f197b6b33470b912c0ab0099f4a6d4d05d832513b17c65d6e57344037bd8\";s:32:\"languages/revsliderhelp-en_US.mo\";s:64:\"84c006116d561382ab453eb7756885fe458f50dd5359338973d1c0aaa1c7da51\";s:32:\"languages/revsliderhelp-en_US.po\";s:64:\"bd5cf09a6f5d98fec9f1465db30fd85eb4b0dc1ad9d6ded1da94918b7d9a0a1c\";s:27:\"languages/revsliderhelp.pot\";s:64:\"83b2a945105b0cabf0fd9699b5f6a3f144b9201e5990548b5aba740bb63e8fbe\";s:16:\"public/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:32:\"public/revslider-front.class.php\";s:64:\"23f60fb1c14e6c29edca1ee7d7b089348f406ae60e22cffd48be6787d4a92b15\";s:23:\"public/assets/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:22:\"public/assets/info.cfg\";s:64:\"2acc6ae56117f5c640a0b5538c2553b6ee62e959c648cb904f0761519f1bbccb\";s:38:\"public/assets/assets/coloredbg-old.png\";s:64:\"dbdeeafb5a38524899108cc99f5dc390e050c0efb3f9aec9d995c9642a179fae\";s:34:\"public/assets/assets/coloredbg.png\";s:64:\"a35f8bcd547ba482014e170e64c9ceb86269cbc46e1222ea46c750aa41cec584\";s:30:\"public/assets/assets/dummy.png\";s:64:\"69539b5b3777cffda28a66d7f2aa9b17c91ee1ec8fd50c00c442af91753a60f7\";s:33:\"public/assets/assets/gridtile.png\";s:64:\"663ccd5f5b33695f6f6384996bbb9601b1a7060570b8dcb5882329fbc40d6a01\";s:37:\"public/assets/assets/gridtile_3x3.png\";s:64:\"dbf0e6a761cf159977157dc42860a904a2d96e84780f2a370b4a693628a85334\";s:43:\"public/assets/assets/gridtile_3x3_white.png\";s:64:\"71912c3ae2c32be8756c13063cd63b54152bb8cbf9ac58e2e006791e7a2edc23\";s:39:\"public/assets/assets/gridtile_white.png\";s:64:\"ab8b528f64344e9e45af4eb7a89c9799e96e65feef2599e51ccda62f94655aed\";s:30:\"public/assets/assets/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:31:\"public/assets/assets/loader.gif\";s:64:\"9034d5d34015e4b05d2c1d1a8dc9f6ec9d59bd96d305eb9e24e24e65c591a645\";s:36:\"public/assets/assets/transparent.png\";s:64:\"9603ffeb6772f1cf745e0097d5d6c046eaf16151e5bc521f20764bba5ddb7713\";s:41:\"public/assets/assets/sources/facebook.png\";s:64:\"202540c1f898c94e83b49038ceb28ec48e078f9460706244f7ca294e5b09c3b6\";s:39:\"public/assets/assets/sources/flickr.png\";s:64:\"5f4dc5d6036da9259490b58f542e927d6285768455b7b4d3525849bbf386b1fe\";s:38:\"public/assets/assets/sources/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:42:\"public/assets/assets/sources/instagram.png\";s:64:\"0c55e02fc17a7501f3033cf44bf8d6532f9c6089aac2b075bc925ae1e00a9c4e\";s:37:\"public/assets/assets/sources/post.png\";s:64:\"dfee347a623d04a7765c852cc2bf5e1a5a1897b30ae06054c52982901bcf1382\";s:50:\"public/assets/assets/sources/revolution_slide1.png\";s:64:\"fe9ba6099a9529b202df00038a5e61471b41fe490233b3eeced40e0631abbcd4\";s:50:\"public/assets/assets/sources/revolution_slide2.png\";s:64:\"cb89209e783ff616e4374febbcd28a2bc295aea64ae129e40a8d4c5ed7e7d2c3\";s:40:\"public/assets/assets/sources/twitter.png\";s:64:\"7c6d27160cd71bbed952fc79a1293cd1e3e52e7a36fe9ba0fa63481b6bb3a95c\";s:38:\"public/assets/assets/sources/vimeo.png\";s:64:\"7f135deb73d2e7d541990ab631b50bf9e82c638d0eb80d0acd89bfe0a8c4d5db\";s:36:\"public/assets/assets/sources/woo.png\";s:64:\"ef678e063b89dcdfb42875ef59e71de8cce4b0f6851cd68c2020e36c34c32190\";s:40:\"public/assets/assets/sources/youtube.png\";s:64:\"67419aec01cea6047a67ba733cdaaead38c9112da951be1f74007fc10ba6b89f\";s:34:\"public/assets/assets/svg/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:55:\"public/assets/assets/svg/action/ic_3d_rotation_24px.svg\";s:64:\"2cd6f97c898a9d375f34c864b398dce61797ccbad9b029afa1389ed93d46eaaf\";s:57:\"public/assets/assets/svg/action/ic_accessibility_24px.svg\";s:64:\"8022b6ebeb57dbc9a8313fe6775ebaa492fac8d1ea231cb9f508a3d9d9a74386\";s:54:\"public/assets/assets/svg/action/ic_accessible_24px.svg\";s:64:\"19cd6de8ad01b6a137f55d1dd029d566d9b35d5f163682991980efd496ede79b\";s:59:\"public/assets/assets/svg/action/ic_account_balance_24px.svg\";s:64:\"b06a4de954f153bfe722612a7fc856e025959598ee90e6cbd5a5f2f9c225b609\";s:66:\"public/assets/assets/svg/action/ic_account_balance_wallet_24px.svg\";s:64:\"8040d187943fb04e23328da8717b770ac4199a9eb7eae3685760ea33847c45fa\";s:55:\"public/assets/assets/svg/action/ic_account_box_24px.svg\";s:64:\"8385158e8a78dc93defbfc368652061e8fcef6bf4dbb663aa953058e076a248e\";s:58:\"public/assets/assets/svg/action/ic_account_circle_24px.svg\";s:64:\"5307e5835c29e08a10ca5b9828f6b48b3c6c136e853e08b140c38035ab341aee\";s:61:\"public/assets/assets/svg/action/ic_add_shopping_cart_24px.svg\";s:64:\"ec4dafd78c83fa8adf012a9b2d3f1c5e30b60b781f4c5cf3f42caa89a6bd07ee\";s:49:\"public/assets/assets/svg/action/ic_alarm_24px.svg\";s:64:\"f5bb2755fe1c016cea33c93d636299a87e6f944591a13ee9528916a119ad6251\";s:53:\"public/assets/assets/svg/action/ic_alarm_add_24px.svg\";s:64:\"2506b8f9a82a215ed55397fc4bc604e7b801c3b2ba6eccaeee4645e258e8855b\";s:53:\"public/assets/assets/svg/action/ic_alarm_off_24px.svg\";s:64:\"ebc71479525918cae1910d65e4f325364dc17d8487c6a67ff01a9096c8ca36e8\";s:52:\"public/assets/assets/svg/action/ic_alarm_on_24px.svg\";s:64:\"001f268aaf3cc662a746d4b53acb3bc1ba410ff24647ab8a6567d81f615beb67\";s:51:\"public/assets/assets/svg/action/ic_all_out_24px.svg\";s:64:\"65294437f76fc07e83f0138807a4c52642dbdbf36694692e769cbe27fcbebd72\";s:51:\"public/assets/assets/svg/action/ic_android_24px.svg\";s:64:\"9393ba16bacc597817cad0aced2bb749231603a5a4a5358ec3f42ec731f7bc9e\";s:56:\"public/assets/assets/svg/action/ic_announcement_24px.svg\";s:64:\"cb4e608b2ec678d82a94536b54d15f5dc0b0dee41edf7fa77f15e6cda369b3c1\";s:56:\"public/assets/assets/svg/action/ic_aspect_ratio_24px.svg\";s:64:\"39654b5c3d466de4a1bd7bc73cdd23c4c4e469650978982d8b982f9c1e6db217\";s:54:\"public/assets/assets/svg/action/ic_assessment_24px.svg\";s:64:\"251b8d550df4665af92dd66a774ae43f0f002826a4b091b86c1310a28e9e8c87\";s:54:\"public/assets/assets/svg/action/ic_assignment_24px.svg\";s:64:\"8b17928ea973dc3769296238377ffab29faaeefc6e17eb0caaa81f1d49047232\";s:58:\"public/assets/assets/svg/action/ic_assignment_ind_24px.svg\";s:64:\"8f602235bf471c42c0fe83f545510b7ca9bef3a8e1cfa018276050117a87cf6a\";s:59:\"public/assets/assets/svg/action/ic_assignment_late_24px.svg\";s:64:\"b566a6525d683f2980095c36c7d96c57033420c2432a5d88d50e8945636355c6\";s:61:\"public/assets/assets/svg/action/ic_assignment_return_24px.svg\";s:64:\"39b57d9aec212b05a310f294d5f3e4f618e95cc590bc63eae78f28bbd7d494e6\";s:63:\"public/assets/assets/svg/action/ic_assignment_returned_24px.svg\";s:64:\"53fcee7ee684bc86e4ea9204359a3e898d1d9aa48eaa137a51c039754faa62f7\";s:64:\"public/assets/assets/svg/action/ic_assignment_turned_in_24px.svg\";s:64:\"85a808b5a8b2771f46e7fa89c097753f75ba394cfb666a6293acb021441f6c32\";s:53:\"public/assets/assets/svg/action/ic_autorenew_24px.svg\";s:64:\"aad13610f87f1111f68486d00deea78831d71a356ea8c938f1ecfd607e5a16f2\";s:50:\"public/assets/assets/svg/action/ic_backup_24px.svg\";s:64:\"dd4ebaae0dbf20252947784ca93dccd3a08b346d2b408c1469adad0c5b2749c0\";s:48:\"public/assets/assets/svg/action/ic_book_24px.svg\";s:64:\"8eedb182a120658c26b0f01aef92ce0ed278bb67edb6e0ad937578aa6ef958ce\";s:52:\"public/assets/assets/svg/action/ic_bookmark_24px.svg\";s:64:\"d0292992d4c29e0a16b288bbf994c2561caadcfd6d492d53d4b1571b84d4b6c5\";s:59:\"public/assets/assets/svg/action/ic_bookmark_border_24px.svg\";s:64:\"a9db5e689655829bec9e4e05e97f350183d8e6758ca63830707ec4a8ecd4f8e8\";s:54:\"public/assets/assets/svg/action/ic_bug_report_24px.svg\";s:64:\"166fdfbc7007b8a4f17b94e5ddaac10f16f563561e7fd1e93d4eafde5da6a73c\";s:49:\"public/assets/assets/svg/action/ic_build_24px.svg\";s:64:\"472cdcdc978ade62fdeb92002d62e4ade55808c9dbdf94b5c07f5a67102c28a8\";s:50:\"public/assets/assets/svg/action/ic_cached_24px.svg\";s:64:\"82644bc640d245152e2fb87a94d75b562fd2796c86511e2d9ba939274d8a2cb1\";s:58:\"public/assets/assets/svg/action/ic_camera_enhance_24px.svg\";s:64:\"3aea2383cfa246beaa2d0d62f8d0f78fbb7bbd555686a5e6d0d8e361fb5e8742\";s:57:\"public/assets/assets/svg/action/ic_card_giftcard_24px.svg\";s:64:\"3e2067fe21fa34db03b793148e4f3b2491c335003dc3719a114d9b9fe3281362\";s:59:\"public/assets/assets/svg/action/ic_card_membership_24px.svg\";s:64:\"e49e0e700795da64a8c8bfb20109a834bf497592bce5db6327cee827bf5f4403\";s:55:\"public/assets/assets/svg/action/ic_card_travel_24px.svg\";s:64:\"b4793ec7215a38ce4125291c07ad12c5b22d8f75c0b154a82ab9289dcdd767c5\";s:58:\"public/assets/assets/svg/action/ic_change_history_24px.svg\";s:64:\"93a10e36c7550ecd220d36c33ad822f2d31e520ee9fba0c9cb6c1eb44042e9f0\";s:56:\"public/assets/assets/svg/action/ic_check_circle_24px.svg\";s:64:\"01cdde3a2fcc3d3f0791e101ebef1cd4b1d6dfdc460130981b4542e8cc580e1e\";s:62:\"public/assets/assets/svg/action/ic_chrome_reader_mode_24px.svg\";s:64:\"5df175b40ca3de612ba119474c017e9135f2b32a9eb347345a54a1134e6512ae\";s:49:\"public/assets/assets/svg/action/ic_class_24px.svg\";s:64:\"8eedb182a120658c26b0f01aef92ce0ed278bb67edb6e0ad937578aa6ef958ce\";s:48:\"public/assets/assets/svg/action/ic_code_24px.svg\";s:64:\"110d861995707b4f598543260c3d2dfd3272c3cc8f195ca85f228c005c482fb7\";s:58:\"public/assets/assets/svg/action/ic_compare_arrows_24px.svg\";s:64:\"17be262944bf2d4e47016a25ecacb6971051dbbde49dd7b24f147150ab45c258\";s:53:\"public/assets/assets/svg/action/ic_copyright_24px.svg\";s:64:\"c38a054f660d70db2611e025a9c99f4d608c709ee42ae22a2e164f2ff0626ef5\";s:55:\"public/assets/assets/svg/action/ic_credit_card_24px.svg\";s:64:\"474f2dee5391671e3804e0f4852e069208bf9bee234ed66d058c3e287a452477\";s:53:\"public/assets/assets/svg/action/ic_dashboard_24px.svg\";s:64:\"ca2ad044eb803c6c5bf2a4725976880c492f5777174b7fed1794594b8a70698e\";s:54:\"public/assets/assets/svg/action/ic_date_range_24px.svg\";s:64:\"d01b507b8c688f789eee03e58e8a107460d7cabaf55623430f0b57e1930882ac\";s:50:\"public/assets/assets/svg/action/ic_delete_24px.svg\";s:64:\"40cfa49b563a8051443cd6dd3a0abc7ebb72d9b3edd17a32b4428f9b579146cd\";s:55:\"public/assets/assets/svg/action/ic_description_24px.svg\";s:64:\"0cb5a4634edb3203e6bff62ccb7de1c2bb017e79d5acfbfb5d72959d40a8bff4\";s:47:\"public/assets/assets/svg/action/ic_dns_24px.svg\";s:64:\"86419fc739623a45dc75963cddaa1ae0363de8a187cae06f48991a0b0de7e598\";s:48:\"public/assets/assets/svg/action/ic_done_24px.svg\";s:64:\"f1f1a9f32a0488db0541fc9a8b9475ea9739335aa022d69799f9f42859042761\";s:52:\"public/assets/assets/svg/action/ic_done_all_24px.svg\";s:64:\"3f16565700b11c685d8d7d9b624c9815bd65febcaaf22cdce12ea87b41b15259\";s:55:\"public/assets/assets/svg/action/ic_donut_large_24px.svg\";s:64:\"33be9532f60d90a76e87aad1608893b33e7cdcc95c1bd1486e54c6b7345a51d8\";s:55:\"public/assets/assets/svg/action/ic_donut_small_24px.svg\";s:64:\"6035acd879d4558cee4dd68a957621833ebae4a002479230fb5775081223d7fc\";s:49:\"public/assets/assets/svg/action/ic_eject_24px.svg\";s:64:\"80e3d48004058a83ebb77097a2d76a31d5140adde9d644c6739ccd3ddbaef603\";s:49:\"public/assets/assets/svg/action/ic_event_24px.svg\";s:64:\"b5d8a4f1247c3fc9e280c69763e3635b4331790f3b31d55ce02e4d2000c5f352\";s:54:\"public/assets/assets/svg/action/ic_event_seat_24px.svg\";s:64:\"c511a9da50df5f3471f7bd198b96c7dd4663c67c0ac4d69d124a5fb3b285e7e1\";s:55:\"public/assets/assets/svg/action/ic_exit_to_app_24px.svg\";s:64:\"6f44f4bd06a3b73c5b110c161b94f4498fb064859372acf010cc523e757474a2\";s:51:\"public/assets/assets/svg/action/ic_explore_24px.svg\";s:64:\"32136b5377d32476b0ef17039f3ec2e3205b9ad421e768f70ca1adcc3f2581cc\";s:53:\"public/assets/assets/svg/action/ic_extension_24px.svg\";s:64:\"3161d000350c7e92bbf84664a7e733f063d993f838bb88ae61de78acffcc2a36\";s:48:\"public/assets/assets/svg/action/ic_face_24px.svg\";s:64:\"1abe822e65e6fbd36ade6814465352770ae46d0abae49163ed7593163b09c9f0\";s:52:\"public/assets/assets/svg/action/ic_favorite_24px.svg\";s:64:\"9b33632e04c6f9daff1c924d88693e3747d6342d887ab504a500d18f539dc3ea\";s:59:\"public/assets/assets/svg/action/ic_favorite_border_24px.svg\";s:64:\"9662ae91a720bfb5e9e4a923fb703d38fc483c1bd8874a3037b48ab9faed90a5\";s:52:\"public/assets/assets/svg/action/ic_feedback_24px.svg\";s:64:\"595ba91ca31e088440162257d23e9088e10d5e275d14723a54c0bebcf7675af1\";s:56:\"public/assets/assets/svg/action/ic_find_in_page_24px.svg\";s:64:\"cb98fb75c16fd260fa14548788ebd52b05e81893e89314f7c55acd7a46b9a86d\";s:56:\"public/assets/assets/svg/action/ic_find_replace_24px.svg\";s:64:\"22a50a908f8341b6f2339f08336d292f29b60fa3c38513f3ea4f9f27dd0d4062\";s:55:\"public/assets/assets/svg/action/ic_fingerprint_24px.svg\";s:64:\"b628602ba26661a51043b8f2e89e332d612da2220d22c73e021eb19f8e020963\";s:55:\"public/assets/assets/svg/action/ic_flight_land_24px.svg\";s:64:\"f73c009fb011f4808fedccd90728dccdb47a781ce89e9b6506532d84bee61463\";s:58:\"public/assets/assets/svg/action/ic_flight_takeoff_24px.svg\";s:64:\"134c42726afb9a339563059edc24e7a356cd1538db6d89d281c4204bb9656724\";s:56:\"public/assets/assets/svg/action/ic_flip_to_back_24px.svg\";s:64:\"89fc12034a80435a9ab3c21e5576144917c8b2a4f8cc9cc96a90d3753134ac09\";s:57:\"public/assets/assets/svg/action/ic_flip_to_front_24px.svg\";s:64:\"d60331725abe254a22d65a7f87ee5789e051cecf117efe3ac19ed5a0b682af8b\";s:49:\"public/assets/assets/svg/action/ic_gavel_24px.svg\";s:64:\"0bf0ec8b469ac32679102aaa9300ddd682badd3e6282f228909f302fa6ca4a17\";s:51:\"public/assets/assets/svg/action/ic_get_app_24px.svg\";s:64:\"b887b20de9d7850bac7629bbc72519f5f76c1ae988c692f1970e70cec7498456\";s:47:\"public/assets/assets/svg/action/ic_gif_24px.svg\";s:64:\"20a65fbd5f8db4510c78a667e0607aeac979bebe029cb62229948043d5dde2c9\";s:49:\"public/assets/assets/svg/action/ic_grade_24px.svg\";s:64:\"831a2d3bc08e707d81bcc14c883e3142e7fc0c29237aa18efd0942f5477de5f3\";s:54:\"public/assets/assets/svg/action/ic_group_work_24px.svg\";s:64:\"e86bae3711b455b57ae55b588fab87e8975f04e8ac3c1451632236eb37da8f3b\";s:48:\"public/assets/assets/svg/action/ic_help_24px.svg\";s:64:\"1a580d7787bbf78c63954485d3315c666790c8eedb5a9566ebf0b7ba3ec312a8\";s:56:\"public/assets/assets/svg/action/ic_help_outline_24px.svg\";s:64:\"962aee2433f026ed7843790f6757dc3c25c34f349feb9b4fe816629b1b22442d\";s:57:\"public/assets/assets/svg/action/ic_highlight_off_24px.svg\";s:64:\"e67ffdde1b954ed3a1671d3c7ab14be81e44a124429a966d45236a6173f9746e\";s:51:\"public/assets/assets/svg/action/ic_history_24px.svg\";s:64:\"2894645dc9a542d65f105e3a7c263c5b8288972fdefd8d5eaac4bd8d5abc0a41\";s:48:\"public/assets/assets/svg/action/ic_home_24px.svg\";s:64:\"58f47974b72f8431037cffc73aa575dd8def0fadd76942eb131a7fd2e973d0a8\";s:59:\"public/assets/assets/svg/action/ic_hourglass_empty_24px.svg\";s:64:\"2bfd61b69bfa0009ebc4cd154d1ee7c65ec9812ab3b707db4f55b9d9bb154f01\";s:58:\"public/assets/assets/svg/action/ic_hourglass_full_24px.svg\";s:64:\"f7cb509b6a0a40c67dff93960707d5bb2ed3f86d96f8b5ead29848bff1f09467\";s:48:\"public/assets/assets/svg/action/ic_http_24px.svg\";s:64:\"d15dd7e1307af7a4eee3efeecd8dee817ef413a165d8f4134ac13ac73dd8f41a\";s:49:\"public/assets/assets/svg/action/ic_https_24px.svg\";s:64:\"020a1d8bb2f5067f85f46a1586e83f31d542ea1dceb752c511dda3710c3781ce\";s:61:\"public/assets/assets/svg/action/ic_important_devices_24px.svg\";s:64:\"7d09a7ca29b1528dd998a36b2558ea507c8c609cdee7d9384c9b297a574adbdb\";s:48:\"public/assets/assets/svg/action/ic_info_24px.svg\";s:64:\"2e1a5c0fc47b41204eccc4b45a4cb73e147d8e6f1c4dbbdebbe675b09a4eb82d\";s:56:\"public/assets/assets/svg/action/ic_info_outline_24px.svg\";s:64:\"f3d6e717a2d6fa6caec61221fb4b838663abbd1a58933dd7d2824b408932d3fe\";s:49:\"public/assets/assets/svg/action/ic_input_24px.svg\";s:64:\"5be6de945a729227c5b4bb62a07555c56982afb0f3704c2a6ad86aebf93432b7\";s:57:\"public/assets/assets/svg/action/ic_invert_colors_24px.svg\";s:64:\"66f787f1c3eeaf5ed97d1ff8493bb1841f802d3125ad153cd1601f8c9dac01ec\";s:49:\"public/assets/assets/svg/action/ic_label_24px.svg\";s:64:\"449267400a53003848a30f7beef9744baacb2ca6c201b5014ca9952898dc8c1d\";s:57:\"public/assets/assets/svg/action/ic_label_outline_24px.svg\";s:64:\"78c496e79bd3533896bb5ea56a5405dc2f5387fab74bce82f798c5d8417d80a9\";s:52:\"public/assets/assets/svg/action/ic_language_24px.svg\";s:64:\"0db467748c0aa4ef1bc7cb4b1f00e494d94d9b5a0594cc3deaef0b7202dc3f24\";s:50:\"public/assets/assets/svg/action/ic_launch_24px.svg\";s:64:\"6fff1248147a3d9126ce993e7e8f601f0d7dc20a5bfdb53f7c078509468ee43f\";s:61:\"public/assets/assets/svg/action/ic_lightbulb_outline_24px.svg\";s:64:\"3ce06b1e3f0410f3a0422c863da7c932efc76e398474850326d75cb16fde94a7\";s:54:\"public/assets/assets/svg/action/ic_line_style_24px.svg\";s:64:\"751b4e0fc4b016000b8c9c98f5c2b84268072615fd9498879cea696202e59c1b\";s:55:\"public/assets/assets/svg/action/ic_line_weight_24px.svg\";s:64:\"32d7865ef79ef4d116da510754c1579ff2fdccf70471db552350bb02d1fd39d8\";s:48:\"public/assets/assets/svg/action/ic_list_24px.svg\";s:64:\"c42e1da30a0f68437deb05c82d28bd2e85b7f90a2e9791a9a7cac6040dcafe33\";s:48:\"public/assets/assets/svg/action/ic_lock_24px.svg\";s:64:\"020a1d8bb2f5067f85f46a1586e83f31d542ea1dceb752c511dda3710c3781ce\";s:53:\"public/assets/assets/svg/action/ic_lock_open_24px.svg\";s:64:\"2dd4fba1808dbc69284a4413054386e63c7e097937252d5f3de424d62d637cac\";s:56:\"public/assets/assets/svg/action/ic_lock_outline_24px.svg\";s:64:\"37a12efbafa952d3cce85429621104544aed0834e2dab378068bb73dcda9ca2e\";s:51:\"public/assets/assets/svg/action/ic_loyalty_24px.svg\";s:64:\"544a694e424e88f12de457da0bd0bff938d4f56372e8b7806ed0ae3217e5750b\";s:62:\"public/assets/assets/svg/action/ic_markunread_mailbox_24px.svg\";s:64:\"a4911773cd3d4025631f6d72dcf2e8ce1f8a263b9414bea04a241de611fb7f68\";s:54:\"public/assets/assets/svg/action/ic_motorcycle_24px.svg\";s:64:\"1bab92d01aeabbb6ee02ad52f2f615bfb6efe0253ed806126395f293e852c7ab\";s:52:\"public/assets/assets/svg/action/ic_note_add_24px.svg\";s:64:\"50fc2f2a9ee8110b31b777a497cd795dbe02d5a8b92139fa5053fb824856206b\";s:55:\"public/assets/assets/svg/action/ic_offline_pin_24px.svg\";s:64:\"4026a4b4742574e50942b0a2c4faf2ff47c9c5915923aeff35cc2d37e8819b23\";s:51:\"public/assets/assets/svg/action/ic_opacity_24px.svg\";s:64:\"73f34a9d670810aa24e128b770124e5861edec135cc87cb3eec5bd1362583d00\";s:59:\"public/assets/assets/svg/action/ic_open_in_browser_24px.svg\";s:64:\"5000360064c22752607f6b19e3e8e432f9b56136d7e0c9679f5228ce0aaacb2f\";s:55:\"public/assets/assets/svg/action/ic_open_in_new_24px.svg\";s:64:\"6fff1248147a3d9126ce993e7e8f601f0d7dc20a5bfdb53f7c078509468ee43f\";s:53:\"public/assets/assets/svg/action/ic_open_with_24px.svg\";s:64:\"1a5b7f01f94b0ac4d93e157595020abc9b87eb3322a1684728209bc79615438c\";s:52:\"public/assets/assets/svg/action/ic_pageview_24px.svg\";s:64:\"47dddb8fe4f37a5790d5c7dc26806866bfb94b14d0a8ede0c71267291220a8d5\";s:52:\"public/assets/assets/svg/action/ic_pan_tool_24px.svg\";s:64:\"560bdfe0c2dee0cd1b5ac91a487f3437cb648317ac6c7acc23297a92a6dcd012\";s:51:\"public/assets/assets/svg/action/ic_payment_24px.svg\";s:64:\"474f2dee5391671e3804e0f4852e069208bf9bee234ed66d058c3e287a452477\";s:59:\"public/assets/assets/svg/action/ic_perm_camera_mic_24px.svg\";s:64:\"b79c03ef277c9605d41dfad9cfd014a3c2744f8889a8579f2be7d4e2fe02424c\";s:65:\"public/assets/assets/svg/action/ic_perm_contact_calendar_24px.svg\";s:64:\"1bb91282eb6563c9d1e027b52228ae41999676f27b98323311cd4f88e6bbeb7a\";s:61:\"public/assets/assets/svg/action/ic_perm_data_setting_24px.svg\";s:64:\"3547fea5a2b8bf3bda3c25b113739163e1894cd2689e876b36dac56ded7ff7b5\";s:67:\"public/assets/assets/svg/action/ic_perm_device_information_24px.svg\";s:64:\"1618bd3397443603722da3586f1a377f6db73ad2acf9e9bddc698cadb17bf560\";s:57:\"public/assets/assets/svg/action/ic_perm_identity_24px.svg\";s:64:\"4898e25f97f9ec192a657033130950a2501d4d9e3035591b0aee07cdff009d6f\";s:54:\"public/assets/assets/svg/action/ic_perm_media_24px.svg\";s:64:\"3a9ea15767047d9a233e387abe557036b0c2bda9072d71b2add7a7b8c1993cf8\";s:58:\"public/assets/assets/svg/action/ic_perm_phone_msg_24px.svg\";s:64:\"71b29338948d534d02e1f3447135537597c427e3eda1fe8e5b698cbf898340cf\";s:58:\"public/assets/assets/svg/action/ic_perm_scan_wifi_24px.svg\";s:64:\"870e44c9b73142c68dfdee8bde6bfa4eb2accf2bdf583be855dc61c0f5d07d2f\";s:48:\"public/assets/assets/svg/action/ic_pets_24px.svg\";s:64:\"20d0172a4d899f1f82f11205b7591d8d8c71e653aeb17948c2a0ac33ce89ab74\";s:62:\"public/assets/assets/svg/action/ic_picture_in_picture_24px.svg\";s:64:\"c1f8615d8f6359bd1bcdae0d5e735a20427e78292ee13f44ade63cd262e25219\";s:66:\"public/assets/assets/svg/action/ic_picture_in_picture_alt_24px.svg\";s:64:\"09f15e1791f0f6b08ad6e84acfd0d46a8331a50c4b5c2158cfa7f9565ea9858c\";s:57:\"public/assets/assets/svg/action/ic_play_for_work_24px.svg\";s:64:\"f0e45c3b5fa77396525b7dafd66d36cc55825734793304d86cf4d3607d823c30\";s:51:\"public/assets/assets/svg/action/ic_polymer_24px.svg\";s:64:\"4197307bbe73818ffcafb54b9c75ebb558c9907e7d2b7614c3b9b5bbcf6a6f5d\";s:62:\"public/assets/assets/svg/action/ic_power_settings_new_24px.svg\";s:64:\"2426eae67a7f97e8f4e4ab0729b5eaeb243f28cf188a5c380df2e281ae61411c\";s:58:\"public/assets/assets/svg/action/ic_pregnant_woman_24px.svg\";s:64:\"58d28196f780a3dc09e550ad84ff27cc0171a07e69c0a2d4cea3ee5afaac98f5\";s:49:\"public/assets/assets/svg/action/ic_print_24px.svg\";s:64:\"7ea1c5ab4938c31fff7349644e8181445d15a9576418e3ec0a5ff20ec4f3efd7\";s:57:\"public/assets/assets/svg/action/ic_query_builder_24px.svg\";s:64:\"c62263947febeef13f89926ef5a05b0eda6aeec920681de2af86ef07a1180bb3\";s:59:\"public/assets/assets/svg/action/ic_question_answer_24px.svg\";s:64:\"398cec3f2e81b31f36c273fe3610d985f103301925941df0260d09ec85092fd4\";s:51:\"public/assets/assets/svg/action/ic_receipt_24px.svg\";s:64:\"7a1f49481c6edd54f5f0adff914260f376860b27724523a2599775003300f4bb\";s:61:\"public/assets/assets/svg/action/ic_record_voice_over_24px.svg\";s:64:\"72dba1683877a7fd771c48b092b6200c3b8345421fd4a2a117e4bc84f79c2c7d\";s:50:\"public/assets/assets/svg/action/ic_redeem_24px.svg\";s:64:\"3e2067fe21fa34db03b793148e4f3b2491c335003dc3719a114d9b9fe3281362\";s:51:\"public/assets/assets/svg/action/ic_reorder_24px.svg\";s:64:\"5d2591bdb00660e261d0d15d2b813ecdbf3d4e97622a86a4c51d7eafbf271be6\";s:58:\"public/assets/assets/svg/action/ic_report_problem_24px.svg\";s:64:\"e800748c34aac0e0560a3bc3f98672243a35262ea64818e48832ce7094539eaf\";s:51:\"public/assets/assets/svg/action/ic_restore_24px.svg\";s:64:\"2894645dc9a542d65f105e3a7c263c5b8288972fdefd8d5eaac4bd8d5abc0a41\";s:48:\"public/assets/assets/svg/action/ic_room_24px.svg\";s:64:\"b989d3c8cfe19edd295378071c23de9c787cbc6ee66cc6a83023968837d0a88f\";s:58:\"public/assets/assets/svg/action/ic_rounded_corner_24px.svg\";s:64:\"3cfaf5d5834cd9c8d92fa077225626c63c6e25d24a90e5301b3830b580e539a2\";s:50:\"public/assets/assets/svg/action/ic_rowing_24px.svg\";s:64:\"6a9bbd1827eb34d8e0ee3762e570ce9ae7d42ffe0e19645c861a3172c2748c08\";s:52:\"public/assets/assets/svg/action/ic_schedule_24px.svg\";s:64:\"c62263947febeef13f89926ef5a05b0eda6aeec920681de2af86ef07a1180bb3\";s:50:\"public/assets/assets/svg/action/ic_search_24px.svg\";s:64:\"6105c83ef3637bbb1f1f8ceceacb51df818e867238ee6c49e0a8d1ca7f858b72\";s:52:\"public/assets/assets/svg/action/ic_settings_24px.svg\";s:64:\"d0872fb94037822164c8cea43a2ebeafdd1b664ff0fdc9387f0e1e1a7ee74628\";s:65:\"public/assets/assets/svg/action/ic_settings_applications_24px.svg\";s:64:\"3fd52f0ae491c017155008ffb5d2d008e15da6768b7ef9d73ed42943bd8597ae\";s:67:\"public/assets/assets/svg/action/ic_settings_backup_restore_24px.svg\";s:64:\"a4028f05e564ed5dad036779cd61db591577c2c558dc0f77acafb53712a95bd4\";s:62:\"public/assets/assets/svg/action/ic_settings_bluetooth_24px.svg\";s:64:\"c7c750f6e8155c45771fc6606b113bcbc0ea906de7e637f6c3448358f77b42ae\";s:63:\"public/assets/assets/svg/action/ic_settings_brightness_24px.svg\";s:64:\"83a5103a39cea5245f3cf0c2134eb1cc1a55092439251d11acdabe229134f2bc\";s:57:\"public/assets/assets/svg/action/ic_settings_cell_24px.svg\";s:64:\"4240ab860b6c3918b667705f3e7fd467c37d95c147acaa5ef1dc7cfdec5cb4ee\";s:61:\"public/assets/assets/svg/action/ic_settings_ethernet_24px.svg\";s:64:\"d055e53659a5b6a4fc64c054f5081da44616a333adc2a0249d03e01edbac5de1\";s:66:\"public/assets/assets/svg/action/ic_settings_input_antenna_24px.svg\";s:64:\"eb3fd523dcca534cc79a2789266846b67536fe17cc8f5886bf4a79123755b8d9\";s:68:\"public/assets/assets/svg/action/ic_settings_input_component_24px.svg\";s:64:\"2fa532bab05d6053811c4720f8c656b16dfc9c79ef6281d5f8e87c6718dfd542\";s:68:\"public/assets/assets/svg/action/ic_settings_input_composite_24px.svg\";s:64:\"2fa532bab05d6053811c4720f8c656b16dfc9c79ef6281d5f8e87c6718dfd542\";s:63:\"public/assets/assets/svg/action/ic_settings_input_hdmi_24px.svg\";s:64:\"4e67e33dba4111951d3e2fdf777d864993000936084e73d95118329f303d44d8\";s:65:\"public/assets/assets/svg/action/ic_settings_input_svideo_24px.svg\";s:64:\"a9d78b79f959631fcc745ed145a9cda9a9637177be5322eaecd6edeb887cf70e\";s:61:\"public/assets/assets/svg/action/ic_settings_overscan_24px.svg\";s:64:\"8b9f14c69b767957c13d47db813ff767731bc09e2c28b40cda73db09f1e3af70\";s:58:\"public/assets/assets/svg/action/ic_settings_phone_24px.svg\";s:64:\"23b112f8e7cd2e068019c927abbe3c20e720803444baf06bae5fbee1f3ba2e4a\";s:58:\"public/assets/assets/svg/action/ic_settings_power_24px.svg\";s:64:\"bef9bf5960b48c9be6e57c5b04fbcf5edd515782b8b759fda65ee2952eed20ec\";s:59:\"public/assets/assets/svg/action/ic_settings_remote_24px.svg\";s:64:\"e3bc91ecf41e10c0a8177e3ff7c81648b6eb786c64eec2d18b7d64e06d53fba5\";s:58:\"public/assets/assets/svg/action/ic_settings_voice_24px.svg\";s:64:\"957f0b30687763f12399cfbc927635d104c437ff194db8361a7a5b0da00df58c\";s:48:\"public/assets/assets/svg/action/ic_shop_24px.svg\";s:64:\"a923ac48e5f55e13e7d961b445974e0d09115de349360027ab8205b3a98426e5\";s:52:\"public/assets/assets/svg/action/ic_shop_two_24px.svg\";s:64:\"bfa899caac93fad623f9053cac0c2f2bced5540bb9735f9b04c288b8e79b90fe\";s:59:\"public/assets/assets/svg/action/ic_shopping_basket_24px.svg\";s:64:\"44d9968b0ea3bf9864a4668fe7119e1fd32abdafefeaedf9c5dcbeff371e4607\";s:57:\"public/assets/assets/svg/action/ic_shopping_cart_24px.svg\";s:64:\"0d5d165f3e9eea299e31d16c845eb305ba008dfe45f839619eb98ab0b229f34f\";s:57:\"public/assets/assets/svg/action/ic_speaker_notes_24px.svg\";s:64:\"d8a89ba474c600dbc9c2a5bf41cd92e85f32a948e0180604df5be69c433d992e\";s:54:\"public/assets/assets/svg/action/ic_spellcheck_24px.svg\";s:64:\"7f926aab657b75b779b84eb8cb20e1d0a803cd72623f911bb1b799b3e1b373cd\";s:49:\"public/assets/assets/svg/action/ic_stars_24px.svg\";s:64:\"43981f2a1fefa6ab98cb06185c46fffc910f9c74143b953d8b7ea17eef83a0f9\";s:49:\"public/assets/assets/svg/action/ic_store_24px.svg\";s:64:\"61aae36d8f51d94ffa1f6b35ef20d433d714158375d94ced41d74a92b46e09d8\";s:51:\"public/assets/assets/svg/action/ic_subject_24px.svg\";s:64:\"02064baf66c5048653894e41d692e09b516271ea9ee165079f851d2585d1ccec\";s:62:\"public/assets/assets/svg/action/ic_supervisor_account_24px.svg\";s:64:\"4fdfd3292b54dcbe52e59b84450bbf5c54c2df357cc7b8aad7b45ef048396e15\";s:54:\"public/assets/assets/svg/action/ic_swap_horiz_24px.svg\";s:64:\"c4c7779e94b9dc3b22c363de7c6f5d7e7bb3283e1d4de4a3800df37616eeac0e\";s:53:\"public/assets/assets/svg/action/ic_swap_vert_24px.svg\";s:64:\"8bf9f4dc84a011c1c4df0a7a5056bcd81727496495fbca0912b10cf9c891dc15\";s:64:\"public/assets/assets/svg/action/ic_swap_vertical_circle_24px.svg\";s:64:\"a8b74890a237d433fafeb97fc58a19828ef137b69701141990f79438a48d324e\";s:61:\"public/assets/assets/svg/action/ic_system_update_alt_24px.svg\";s:64:\"005c56e8e70b578c1df3d18d4f30ba0d26ae5def01783b1f5ded36c31787e42c\";s:47:\"public/assets/assets/svg/action/ic_tab_24px.svg\";s:64:\"f9c4af27982996283a56303996e24afb4e2b2dfc9b6b2611af0b0e160b7033e4\";s:58:\"public/assets/assets/svg/action/ic_tab_unselected_24px.svg\";s:64:\"c45500d4f4820f29f98e1443dda1c20ee3e80f4cee1e208479e50e377518fc2b\";s:52:\"public/assets/assets/svg/action/ic_theaters_24px.svg\";s:64:\"aacde086862a86f1d85daca021e414ae732e235e9ad09963d71520903bb8be4f\";s:54:\"public/assets/assets/svg/action/ic_thumb_down_24px.svg\";s:64:\"df1ed1d9f26cb121e9be865aec900a8c8be9e90314856ccbe478e52bf6803807\";s:52:\"public/assets/assets/svg/action/ic_thumb_up_24px.svg\";s:64:\"7d8bc098c000ed722c4e95d0cf743ca4d2db82d2970fb7aa5c44e55158c38cad\";s:58:\"public/assets/assets/svg/action/ic_thumbs_up_down_24px.svg\";s:64:\"0bce2d2a51d70fb90262e2dedd2d3ed8be8b4eff246174a6687bb9ee5373c21c\";s:52:\"public/assets/assets/svg/action/ic_timeline_24px.svg\";s:64:\"ad8e78763f70925d35df4b0cf4b6ca68caa9cc47dc479825acb025727b45d220\";s:47:\"public/assets/assets/svg/action/ic_toc_24px.svg\";s:64:\"0b5ae5bed340f38002d7ec1af09932f4263b6cf273a750997595400cc96c0ad7\";s:49:\"public/assets/assets/svg/action/ic_today_24px.svg\";s:64:\"41016b2e3a9ae4830eb32f90764802c967c8e6ee9dc153a2ebc0f1b9e2b9ff26\";s:48:\"public/assets/assets/svg/action/ic_toll_24px.svg\";s:64:\"54d68919f835f7400fe1f036c8ba8deabecb897ce5becc407552ef325c3ecd5c\";s:53:\"public/assets/assets/svg/action/ic_touch_app_24px.svg\";s:64:\"813b6dc3c359b3a67fc867bbbb64ddc30388eceff1649aef2c0626b31dbb1614\";s:57:\"public/assets/assets/svg/action/ic_track_changes_24px.svg\";s:64:\"56e65bf95be2fccb69f30c0e4019717baf18a49845014d053481fb6b9f27738d\";s:53:\"public/assets/assets/svg/action/ic_translate_24px.svg\";s:64:\"41fc130b717be1a3135c13f9e25ec1bbe238b085bfc133ac5c141898f31e3cb9\";s:57:\"public/assets/assets/svg/action/ic_trending_down_24px.svg\";s:64:\"6f71e01ed302c8683f13440d4cd1bf8463dbafc0a7eabec864917bcd2aff884d\";s:57:\"public/assets/assets/svg/action/ic_trending_flat_24px.svg\";s:64:\"915ede525d33cdcf4459563ea51c4f04d781de7dd99611f33c326b3febaf36b9\";s:55:\"public/assets/assets/svg/action/ic_trending_up_24px.svg\";s:64:\"317c33204739a14472a766f7e16861ad414a94f3718f0e46ef62ac454a64e0a8\";s:53:\"public/assets/assets/svg/action/ic_turned_in_24px.svg\";s:64:\"d0292992d4c29e0a16b288bbf994c2561caadcfd6d492d53d4b1571b84d4b6c5\";s:57:\"public/assets/assets/svg/action/ic_turned_in_not_24px.svg\";s:64:\"a9db5e689655829bec9e4e05e97f350183d8e6758ca63830707ec4a8ecd4f8e8\";s:50:\"public/assets/assets/svg/action/ic_update_24px.svg\";s:64:\"406de3533ca04bcf0aeb56954c5a4e3fcbf0921e1127b3b526913f5a3c0e7e6c\";s:57:\"public/assets/assets/svg/action/ic_verified_user_24px.svg\";s:64:\"97fa5a3e9dc2a0f97558fde82a523d2ac463911118ece99fed65585f1cbb7a50\";s:55:\"public/assets/assets/svg/action/ic_view_agenda_24px.svg\";s:64:\"f81cf055d77a00e08700c0818a64620c3e7fb9367d443fa43e3f8bfb03c9abd5\";s:54:\"public/assets/assets/svg/action/ic_view_array_24px.svg\";s:64:\"3ed4ae83d1ab5f95c8dbefe18e276634ed0b8e89c80ef2b0dd328204cee824c4\";s:57:\"public/assets/assets/svg/action/ic_view_carousel_24px.svg\";s:64:\"3d90db7f2cbbf01bdaf1e22ff55dc63b98d7dac3a5ff261eeaef88336f536c5c\";s:55:\"public/assets/assets/svg/action/ic_view_column_24px.svg\";s:64:\"58830764e6ac79ebeaa0072145c3ebcd9ee3561d0918c931c39788f006b34cec\";s:52:\"public/assets/assets/svg/action/ic_view_day_24px.svg\";s:64:\"51815603f490cd9c0465615593652daebf8bc6d4bca85190aa82be9e0bb601c1\";s:57:\"public/assets/assets/svg/action/ic_view_headline_24px.svg\";s:64:\"65ff18d7a57edbc1c19a86a0f4dfd4a00a2bc32d9044db0b52890e57ac7d7ff0\";s:53:\"public/assets/assets/svg/action/ic_view_list_24px.svg\";s:64:\"6c1cc758d53140efbf126fd615eda7d6c35a4acb4fa5fa5975d1bafeff7fac77\";s:55:\"public/assets/assets/svg/action/ic_view_module_24px.svg\";s:64:\"785d77f7d70ad29575e39a8f162675f1f72503755dc7db688a442a2d645b9c1f\";s:54:\"public/assets/assets/svg/action/ic_view_quilt_24px.svg\";s:64:\"cb55ba8c853aa72775d6e0e3948dccdb428236e57443916725113a31182551a5\";s:55:\"public/assets/assets/svg/action/ic_view_stream_24px.svg\";s:64:\"2aa1548a7e5f1f8101b10b7c30972e379d462523af66d9e0ad0e56275000259d\";s:53:\"public/assets/assets/svg/action/ic_view_week_24px.svg\";s:64:\"eaf19c02e55e7f76bb2bd45e15aeada3a0b4633eeee8b53584fe6dbd98edf184\";s:54:\"public/assets/assets/svg/action/ic_visibility_24px.svg\";s:64:\"5e2fc28ae621a18342caf71644f0b5725d9cbe377932db896a0009fa21250201\";s:58:\"public/assets/assets/svg/action/ic_visibility_off_24px.svg\";s:64:\"b1e7ec6fcc3a0aeefe585abd0860e60dabd39b884be8b52cd886acb3e0635ec3\";s:55:\"public/assets/assets/svg/action/ic_watch_later_24px.svg\";s:64:\"df75e4561457f52ea6fdc778acd2abaa7dbb730863a539d78792d4932fc55595\";s:48:\"public/assets/assets/svg/action/ic_work_24px.svg\";s:64:\"a5c19aa33beecc38eb8a25c87f009684e1161bb51c4072514147d0babcc523eb\";s:64:\"public/assets/assets/svg/action/ic_youtube_searched_for_24px.svg\";s:64:\"cdcd5dd8ea46efd70beca392d9fbe4966e0410ea38d9dd6cff8e716210e0cf80\";s:51:\"public/assets/assets/svg/action/ic_zoom_in_24px.svg\";s:64:\"409b79194243e3deefcbaded57a4539b19233de0db1c71b13f7ff2e025ceddc2\";s:52:\"public/assets/assets/svg/action/ic_zoom_out_24px.svg\";s:64:\"0162300846c6d6908e7c537ed701fbda0685290452907b65c42367d6fc904ed1\";s:52:\"public/assets/assets/svg/alert/ic_add_alert_24px.svg\";s:64:\"9c617ce39567153b0d9a28a88f767e0e5fd1208cfbad9d215021034dd4f3228d\";s:48:\"public/assets/assets/svg/alert/ic_error_24px.svg\";s:64:\"4ab47484995ab72bd8b7175bd36273d3e8787cf3e1e28a4f695fee07e8d0884d\";s:56:\"public/assets/assets/svg/alert/ic_error_outline_24px.svg\";s:64:\"bc2d656a0626a5859f6bce73e972e8f841b5c0f3cf43502e2bf4a1137704581a\";s:50:\"public/assets/assets/svg/alert/ic_warning_24px.svg\";s:64:\"e800748c34aac0e0560a3bc3f98672243a35262ea64818e48832ce7094539eaf\";s:52:\"public/assets/assets/svg/av/ic_add_to_queue_24px.svg\";s:64:\"6ecdda24cb184812d3f02772991d81287bd31c29e22fcc217bd21d6e3f5d68b5\";s:47:\"public/assets/assets/svg/av/ic_airplay_24px.svg\";s:64:\"81393da86075121cf7af7b5d9fd9218b6cd6da4c9a1fe6c62612fbb6a25f1875\";s:45:\"public/assets/assets/svg/av/ic_album_24px.svg\";s:64:\"972c1832668ead7eddd09dfeec59b1fb0602ee47baae4785127da3dbbbb3b34f\";s:49:\"public/assets/assets/svg/av/ic_art_track_24px.svg\";s:64:\"51cb99e4a078c0b103f6e16ad7c4de005586f89edad0b76a7598fc7379b6a729\";s:48:\"public/assets/assets/svg/av/ic_av_timer_24px.svg\";s:64:\"a9fcde09a80353c03ba3127d9a32441a7d33a27190d1d48cea5dd4b3043b895d\";s:54:\"public/assets/assets/svg/av/ic_closed_caption_24px.svg\";s:64:\"0b1e10ba4c813d636dfd1f0112c781299f1aaf944ba0fd9408e2a1d9efc74da3\";s:49:\"public/assets/assets/svg/av/ic_equalizer_24px.svg\";s:64:\"e028813a5f0fa89569beb1bc69c04268337d714ba77f136293b368e96b6dd2f0\";s:48:\"public/assets/assets/svg/av/ic_explicit_24px.svg\";s:64:\"292cdd9b632ed2e85a484eaa6221b864c2bf03539b20930dd60f76b574c58664\";s:52:\"public/assets/assets/svg/av/ic_fast_forward_24px.svg\";s:64:\"b39a2a4e4d36201ee17cd506fb369276849e6c952f644f5a9720b63d4b44d8d9\";s:51:\"public/assets/assets/svg/av/ic_fast_rewind_24px.svg\";s:64:\"b21d952289780119520a46f9a96511b8119b292d9990c45adfb24803a70ffe40\";s:49:\"public/assets/assets/svg/av/ic_fiber_dvr_24px.svg\";s:64:\"0ba6fd6e37c343439e887d7b1e57db2198d2d4574952343ce37a9b397fc3f94b\";s:59:\"public/assets/assets/svg/av/ic_fiber_manual_record_24px.svg\";s:64:\"a016ab5615ab36f49187c1726ad9c3032b6521f342d105144afe8e7c8c71769d\";s:49:\"public/assets/assets/svg/av/ic_fiber_new_24px.svg\";s:64:\"019f91835033bfedd9f52dcda9750060255bf19cf0d32b0b43d783a08b3e36a3\";s:49:\"public/assets/assets/svg/av/ic_fiber_pin_24px.svg\";s:64:\"11f74c1ce4bfba5c8d25686f12dac9eb29ff6d6faae38f8755a5aa3c87ae182b\";s:58:\"public/assets/assets/svg/av/ic_fiber_smart_record_24px.svg\";s:64:\"3c5a54c5d5e2260528cf8e8a6f5097ece0c3d7be3f9ed45d3d561e09c44a0971\";s:50:\"public/assets/assets/svg/av/ic_forward_10_24px.svg\";s:64:\"c832506e0e526cba812933d0e70ddf4edf364e6cca456e5ba9df6122236c20ec\";s:50:\"public/assets/assets/svg/av/ic_forward_30_24px.svg\";s:64:\"534b7e074aac4be8551997b75354ed5d6edfb4eb11d84ab225ce886039d0599d\";s:49:\"public/assets/assets/svg/av/ic_forward_5_24px.svg\";s:64:\"1d0cbc16a2ec77f495421eca8d2f9136f5a439710b75afe941b0dc323fe95340\";s:45:\"public/assets/assets/svg/av/ic_games_24px.svg\";s:64:\"3e850f0a5ebf1e0bfa149967352eff6c9f9ff7c7d262c570fb0bec99c9cda33a\";s:42:\"public/assets/assets/svg/av/ic_hd_24px.svg\";s:64:\"2cff875236651008df0e1003cbda45a642424887ae07938e98c18cb9fb35a798\";s:47:\"public/assets/assets/svg/av/ic_hearing_24px.svg\";s:64:\"3fd43722aaadad35379ba08d4c128eb3ef2313b8b628a55e2febcb11d900ec90\";s:52:\"public/assets/assets/svg/av/ic_high_quality_24px.svg\";s:64:\"1b8b37fa67be12e021865281b0608b019ec28e4d8e5b1a87ff87c188a5b03886\";s:51:\"public/assets/assets/svg/av/ic_library_add_24px.svg\";s:64:\"2057c6177d9cdc9f6154e9ee439ddd7a49dd9b9eafff5977aac46da6c154452b\";s:53:\"public/assets/assets/svg/av/ic_library_books_24px.svg\";s:64:\"e73fcd98a762a217049b28c2d023a5d240eb7294a10102db914025725260f0d8\";s:53:\"public/assets/assets/svg/av/ic_library_music_24px.svg\";s:64:\"46cba011cb13dbfa2fc46672c9fe69f2aea4fff36be86337470e836adad3dbc0\";s:44:\"public/assets/assets/svg/av/ic_loop_24px.svg\";s:64:\"d9efa9690a6a43ddb127ce41d3b5b05305c174e24776937718fe55eafe85d498\";s:43:\"public/assets/assets/svg/av/ic_mic_24px.svg\";s:64:\"3f1c2357dd8bc86ef9fa3adece98f15a51e81d553495df4473a174e4296b5211\";s:48:\"public/assets/assets/svg/av/ic_mic_none_24px.svg\";s:64:\"b14ce9c93e916d4bf6362db9066e04f718373b34ecc2f986294251b26ae339f9\";s:47:\"public/assets/assets/svg/av/ic_mic_off_24px.svg\";s:64:\"df347ed26ace976d932847ff337e86bb7c25b87fe10139380f57959c35717ba3\";s:45:\"public/assets/assets/svg/av/ic_movie_24px.svg\";s:64:\"f0d2c7e0515d6dace01851022d3cebce6dfbc95e0541a8bd26312b63306b2452\";s:51:\"public/assets/assets/svg/av/ic_music_video_24px.svg\";s:64:\"449f58f3bfff35ffbe54b15e8f5fe58c3925761c0e1df8fce2ce8de5b5604755\";s:52:\"public/assets/assets/svg/av/ic_new_releases_24px.svg\";s:64:\"6f5d9a3d3909e8766c752e9a97715795f6c0eae7a6c9cb86f190e09b53be6a2e\";s:54:\"public/assets/assets/svg/av/ic_not_interested_24px.svg\";s:64:\"1e87a9fc6d4fc9f66fa9eef5726764ab9a7afd32cc7eda04106bf8308007ed24\";s:45:\"public/assets/assets/svg/av/ic_pause_24px.svg\";s:64:\"dbd40f5581dcbad635d694bd1885b95aab53d6989827984d7646f5da2d59d367\";s:59:\"public/assets/assets/svg/av/ic_pause_circle_filled_24px.svg\";s:64:\"322ac92862767f7cbff27062745c99413fa1071657f26b541b7207b9c93d58ab\";s:60:\"public/assets/assets/svg/av/ic_pause_circle_outline_24px.svg\";s:64:\"a3b2c518d796564caa9a8277c9b9089ab41e894f719f376118691df7a01ca6e9\";s:50:\"public/assets/assets/svg/av/ic_play_arrow_24px.svg\";s:64:\"54077d93aca5c4b0dbc80d177dfe003e689ef3e6dfffdf306ee8027b53282c38\";s:58:\"public/assets/assets/svg/av/ic_play_circle_filled_24px.svg\";s:64:\"0a80ec6c1cb0ab52b42223000e681e15192d94d3a9a1f051c1a40011e5e6b982\";s:59:\"public/assets/assets/svg/av/ic_play_circle_outline_24px.svg\";s:64:\"00dd67c77ca21e6ca6ac11b8456d0eee65607444caf9c932b73044dc0ff7af57\";s:52:\"public/assets/assets/svg/av/ic_playlist_add_24px.svg\";s:64:\"bf7742a1b999ff0a084f6e57857910b4f0e4e7ee4bcc0b199627d0a34d8e3843\";s:58:\"public/assets/assets/svg/av/ic_playlist_add_check_24px.svg\";s:64:\"a9e09dd807901bc5f8e90dc77fbd77d212b6cc700d8934bf086e009f8f7d2976\";s:53:\"public/assets/assets/svg/av/ic_playlist_play_24px.svg\";s:64:\"cdc22ff6b84b77d41155f6eb36f27fa67738b009cc0151852b7b43f531ec6484\";s:45:\"public/assets/assets/svg/av/ic_queue_24px.svg\";s:64:\"2057c6177d9cdc9f6154e9ee439ddd7a49dd9b9eafff5977aac46da6c154452b\";s:51:\"public/assets/assets/svg/av/ic_queue_music_24px.svg\";s:64:\"fc269bb7535bccc2d9a1cc3c14648340d6dcb986425c910d8fd65c6c3da6ba9e\";s:55:\"public/assets/assets/svg/av/ic_queue_play_next_24px.svg\";s:64:\"75ab9e5cc5c8998e493732f875cec21dc07fa7d6717cb9375b39ac610302811e\";s:45:\"public/assets/assets/svg/av/ic_radio_24px.svg\";s:64:\"e30a53a4882be9d57a1f2a901660e5418d4020a46c34da2bd44ced17632b61be\";s:53:\"public/assets/assets/svg/av/ic_recent_actors_24px.svg\";s:64:\"8cf55f1bc9d26afa61ef44da184fc125592271ceb5c238f9afdaba54154a07ab\";s:57:\"public/assets/assets/svg/av/ic_remove_from_queue_24px.svg\";s:64:\"0c2f0152e63279c86eac50a6b7d977ced9369654c03302dab553054359f771ab\";s:46:\"public/assets/assets/svg/av/ic_repeat_24px.svg\";s:64:\"d3b967ec4b08f57d06bd84cc21475272c3457ad6284ff994842e8dddcc601ac1\";s:50:\"public/assets/assets/svg/av/ic_repeat_one_24px.svg\";s:64:\"e689b58af6944aa87146ab223ecfd4dd45ddce2d785ba2a3258b194e3aa1af9e\";s:49:\"public/assets/assets/svg/av/ic_replay_10_24px.svg\";s:64:\"477ba562ec28cb50780d7c196d47025b9c92880ab412a6c1becde4bcb987f66e\";s:46:\"public/assets/assets/svg/av/ic_replay_24px.svg\";s:64:\"9d2ddd56af8e4ae35ce3132f0f67bf92527451001284bfa9c18301c6a02dc8a7\";s:49:\"public/assets/assets/svg/av/ic_replay_30_24px.svg\";s:64:\"65b8b58fb625096978094cc23c078431531f36854ca26bd2097b93a6891a1750\";s:48:\"public/assets/assets/svg/av/ic_replay_5_24px.svg\";s:64:\"32dabbbbe4cf13321f111c2faa00d5fe680308df3e6106baadc20df5194730f4\";s:47:\"public/assets/assets/svg/av/ic_shuffle_24px.svg\";s:64:\"ef83a99f447d1979001dde7075939c33354972b8afd1b91f001fe5f50525740a\";s:49:\"public/assets/assets/svg/av/ic_skip_next_24px.svg\";s:64:\"f38f8615459381790ed142e8729a1a9e29710b85169c8d49cadeb6f0592e1e64\";s:53:\"public/assets/assets/svg/av/ic_skip_previous_24px.svg\";s:64:\"09244a94224a6b76c8b4bcf04fb6503378baff7bc4b13f84c9350326bcc3176a\";s:57:\"public/assets/assets/svg/av/ic_slow_motion_video_24px.svg\";s:64:\"d57c9707ade7e36709e4b7469a61af8928492e96496fa38510578aeb42709b4e\";s:46:\"public/assets/assets/svg/av/ic_snooze_24px.svg\";s:64:\"a183cee31844f977b16f0f8486d8972323e2ad687fbfffb5da88b1eec3dde0d0\";s:53:\"public/assets/assets/svg/av/ic_sort_by_alpha_24px.svg\";s:64:\"c87c1edd1e8ecc3195605c81d09ca81303201213647f5f63a52616b9c5a9c6af\";s:44:\"public/assets/assets/svg/av/ic_stop_24px.svg\";s:64:\"e827b7b17eaea2f4181dfb8d68d6a5813871ab051374c484ba9ed09589a24ce4\";s:53:\"public/assets/assets/svg/av/ic_subscriptions_24px.svg\";s:64:\"aaaf69582782c8af8e6d19f701c0ac8b446228d243794874561adf7ef670caa4\";s:49:\"public/assets/assets/svg/av/ic_subtitles_24px.svg\";s:64:\"b52f32b2c62a202ab6515d88d3d7b34be78c8019657344fd460e3d98da456c36\";s:54:\"public/assets/assets/svg/av/ic_surround_sound_24px.svg\";s:64:\"4aab19a5ea185e2be451f25f11116be5f47b7033bdb60d9ef5fbce5ee001ab45\";s:53:\"public/assets/assets/svg/av/ic_video_library_24px.svg\";s:64:\"b871451f431f71cd4b59398cf624eda5833892f221db237da8e5631fad19301f\";s:48:\"public/assets/assets/svg/av/ic_videocam_24px.svg\";s:64:\"2c24035292a25b8a48085e4a46c7aab8ef049a5b0999c3c4d9874743f172be93\";s:52:\"public/assets/assets/svg/av/ic_videocam_off_24px.svg\";s:64:\"aef175c4bb8e87826e5dd2a78474d75f8cd6ab07e759f6ed9faf0732fe919b10\";s:51:\"public/assets/assets/svg/av/ic_volume_down_24px.svg\";s:64:\"a1e651489af5feb4f9061d7795fca06b8ec77965a5d351f4bb5c694052fd4806\";s:51:\"public/assets/assets/svg/av/ic_volume_mute_24px.svg\";s:64:\"775e30c2eef3f744a824153c2b01a921b708d157f36623f9697bb7a13445b851\";s:50:\"public/assets/assets/svg/av/ic_volume_off_24px.svg\";s:64:\"72ad487d8ee7250ccc6f958b35b5005a3c75a868b2c6b9107276b2d9320e27d0\";s:49:\"public/assets/assets/svg/av/ic_volume_up_24px.svg\";s:64:\"bde5fafcc187a43dee9cc2b4457eab5e56cea79a25802a099bbefb88d0260ea7\";s:43:\"public/assets/assets/svg/av/ic_web_24px.svg\";s:64:\"982fd3f829fc2aa3ab0c72162de4dd120951fc2cac29e3634213022d48fb15cc\";s:49:\"public/assets/assets/svg/av/ic_web_asset_24px.svg\";s:64:\"99be0fc9b1ea8ad3f0b983c40536e43dd20e253a0727cf5ef6a4784f01ce3d2a\";s:50:\"public/assets/assets/svg/busy-icons-svg/NewTux.svg\";s:64:\"533bef67f47576927f4be3a1252749763c10e1644a8142f9ec86488cd71652db\";s:50:\"public/assets/assets/svg/busy-icons-svg/abacus.svg\";s:64:\"2c8fcdb9f11e1f547c0b27a36fdbc0544ffd9c3fb4940923382d2de8429edc74\";s:56:\"public/assets/assets/svg/busy-icons-svg/address-book.svg\";s:64:\"b63a29e7ba91d88139c3b8b0716c1979cb11d87fe800d03889ce0cf2aa06356c\";s:57:\"public/assets/assets/svg/busy-icons-svg/address-book2.svg\";s:64:\"f9690b79e77f2d3659c6a01a5b01f26d1659fd2c76d3d007a75f109a6f94a116\";s:47:\"public/assets/assets/svg/busy-icons-svg/aim.svg\";s:64:\"51dd3aadc20c41edd0987cdc53d382101825a5ce8ad938f48118090564c44a5d\";s:49:\"public/assets/assets/svg/busy-icons-svg/alarm.svg\";s:64:\"73f962236bf2c21b6f3df53bf3f6cef70ca2df82855e0c51b1d688c8bdc79260\";s:49:\"public/assets/assets/svg/busy-icons-svg/apple.svg\";s:64:\"948239ed19b3bc22e43b1c091ed620d6981bd1bc7780632b6e3e2bb26779c2f4\";s:54:\"public/assets/assets/svg/busy-icons-svg/arrow-left.svg\";s:64:\"b2b3a81db02ff6b703bad574de5deab2dc22c7225ac084fa0aa2d27acf1d729a\";s:55:\"public/assets/assets/svg/busy-icons-svg/arrow-right.svg\";s:64:\"fc86505b252b85474334bb474e3b58034cff744c5fbbae542896d7808d8875c1\";s:57:\"public/assets/assets/svg/busy-icons-svg/arrows-updown.svg\";s:64:\"7789e9d7ce373e5f223db9e067c8e235d7205fe346ae93fe2334a8b7ef9cc127\";s:52:\"public/assets/assets/svg/busy-icons-svg/atm-cash.svg\";s:64:\"7643ae344164cfe9de6ea6aeedb852d6904b5cc2989e073fc9c2f47ed85f87fe\";s:50:\"public/assets/assets/svg/busy-icons-svg/award1.svg\";s:64:\"2a41b0ae73e849e53e2cea117b89abd30ec7f76215c5315c4fe44b96dc16376e\";s:50:\"public/assets/assets/svg/busy-icons-svg/award2.svg\";s:64:\"076e6db108a783605f2e060f24790c65fc285ae3f6d99fec1a50a385fd8c27c2\";s:50:\"public/assets/assets/svg/busy-icons-svg/award3.svg\";s:64:\"419329beec3f766097355c2f2821c1397acfc1dcc2759e496a8eea7080f7acc3\";s:50:\"public/assets/assets/svg/busy-icons-svg/award4.svg\";s:64:\"12596fd63bd22de0c2ba0e597281c1c82e6fd12030a9ede5a1a665a42a103fc8\";s:50:\"public/assets/assets/svg/busy-icons-svg/award5.svg\";s:64:\"fc5830783f97ef7c67f7500526a79f2aab08e2ed18ceb7dcae386ca60ff37b08\";s:51:\"public/assets/assets/svg/busy-icons-svg/badge01.svg\";s:64:\"4767e3f81c5ab2df315b90f3f676066c4ec3738fdf416486e4c3bfd89793465f\";s:51:\"public/assets/assets/svg/busy-icons-svg/badge02.svg\";s:64:\"15efb4a50e18fc9e6d2fcf3528171d49faaee2be108063e0b95b36f2a41da5eb\";s:48:\"public/assets/assets/svg/busy-icons-svg/bank.svg\";s:64:\"a99c5b856e62497b7e778c4361f3b4eed6756e14b6feb58ca08fdbfbb4fc7e65\";s:49:\"public/assets/assets/svg/busy-icons-svg/bank2.svg\";s:64:\"e93449a52a20438000290edda3f0edb03380a1da37c25a728ff16df05ed67065\";s:48:\"public/assets/assets/svg/busy-icons-svg/bell.svg\";s:64:\"fb38d3e12f2615012bc1db73a8efba596f8a8f4393a1e3daabe8d7e9c4d01766\";s:54:\"public/assets/assets/svg/busy-icons-svg/binoculars.svg\";s:64:\"8b7fecc3d01871f343c5509c221ca19f12c7e59b00611826e6669abcdabffae2\";s:48:\"public/assets/assets/svg/busy-icons-svg/bomb.svg\";s:64:\"ee2064db9bc9a287abff736d0968ebe00c1923468abd60b5016c6cef2045b713\";s:50:\"public/assets/assets/svg/busy-icons-svg/bonsai.svg\";s:64:\"4810d95cf9f2e6f4d0fc98e802948ac0d0711a7aecab5e3556d9ebb99c2f7354\";s:54:\"public/assets/assets/svg/busy-icons-svg/book-apple.svg\";s:64:\"c9719b5697e8d9889539fa82c787b22d7b06d84c3d14c2a4d6a053a94f766ec4\";s:48:\"public/assets/assets/svg/busy-icons-svg/book.svg\";s:64:\"ae5b4bbc85d8da9ef0f82cc6fb6450a6b07481a7955a99bdab4374b208682879\";s:52:\"public/assets/assets/svg/busy-icons-svg/bookmark.svg\";s:64:\"6d7f87bcbf40ab5abc484048510fb3d25599dd01dc3932fb10df389f3fb5c989\";s:47:\"public/assets/assets/svg/busy-icons-svg/box.svg\";s:64:\"88ef3d60b8e3859ae78fc458add425de0ed9f49c7c252672f40414b51b9a3a47\";s:49:\"public/assets/assets/svg/busy-icons-svg/brain.svg\";s:64:\"6feffae9211bd25e71dfaa90039fc07bb9832e4a23878559d628599bc4f87ae8\";s:53:\"public/assets/assets/svg/busy-icons-svg/briefcase.svg\";s:64:\"d2b92e04722d95ab9449b5ab915da05148642d8d0a9bb57089be1d7c82fe4e20\";s:53:\"public/assets/assets/svg/busy-icons-svg/browser01.svg\";s:64:\"f3594b9488f4d551c79814fc98308863fcecee32d869c48325d92bf2a8cefbfb\";s:53:\"public/assets/assets/svg/busy-icons-svg/browser02.svg\";s:64:\"7db509080724d0b37d763046599d1132f93ab314b5ea4cc411a57df14ab29034\";s:53:\"public/assets/assets/svg/busy-icons-svg/buildings.svg\";s:64:\"1911b08ba44eafb23837cf6bbb3ff85ed84292335e2e81790fa900f0d1948c00\";s:52:\"public/assets/assets/svg/busy-icons-svg/buy-sign.svg\";s:64:\"34a9a436ce2d206ca7869685cd393340067c5ebed406d9e2cc553dfa08de0f18\";s:55:\"public/assets/assets/svg/busy-icons-svg/calculator1.svg\";s:64:\"70ba749d75b833df7c4f2c592164d8853fac7c56f97cd267117b06403ecb1eb4\";s:55:\"public/assets/assets/svg/busy-icons-svg/calculator2.svg\";s:64:\"b18f27690444ed3072a40729ba724393e21077736566eb35ab0379b8f34d7314\";s:55:\"public/assets/assets/svg/busy-icons-svg/calculator3.svg\";s:64:\"a2bd45518507a9fb34331bf63a331dd6e80dd1dbd169330707060c74193d16e2\";s:53:\"public/assets/assets/svg/busy-icons-svg/calendar1.svg\";s:64:\"e3560b15852dc2519a064111993d4719d4d355ab8745f11503a937bca489cbcb\";s:53:\"public/assets/assets/svg/busy-icons-svg/calendar2.svg\";s:64:\"e24c33ec574568b10ae7387a4a810602a26452a064be99d643c90a3e65910cfb\";s:53:\"public/assets/assets/svg/busy-icons-svg/calendar3.svg\";s:64:\"645db8395146ec55da1eec6ca300459f4765c60c4fd42c9963ae96a5ef22e21c\";s:53:\"public/assets/assets/svg/busy-icons-svg/calendar4.svg\";s:64:\"b06f066e64a10bfe0b2b1f6388dba0aaadbadcb63a8591165bab83a6edf84520\";s:53:\"public/assets/assets/svg/busy-icons-svg/calendar5.svg\";s:64:\"a8655ebcf239294597a5d134fb775d6cc8869357f320828e02d05e8307c09e3d\";s:55:\"public/assets/assets/svg/busy-icons-svg/certificate.svg\";s:64:\"43e5968c82f631d690829e69b089d69e40692e5fc1078accecf9c9192ace4c57\";s:53:\"public/assets/assets/svg/busy-icons-svg/champagne.svg\";s:64:\"7f9f00cc2095847ff065948749fc081352e070b95a1bf07be87e6c65bb96e8d3\";s:55:\"public/assets/assets/svg/busy-icons-svg/character01.svg\";s:64:\"e24c8f055f6d9de504d8a18f1a33e8635ed1bce95e6b57ded85327e4f4c233ba\";s:55:\"public/assets/assets/svg/busy-icons-svg/character02.svg\";s:64:\"b2dd0b68603f116dc7e5a81be26da0f2214310d982c99c92c8c774b3c3f78390\";s:55:\"public/assets/assets/svg/busy-icons-svg/character03.svg\";s:64:\"8be5eb81fcc67164fa59a51a55374f0da859061b9d0a267ac81cc801fc8c8a26\";s:55:\"public/assets/assets/svg/busy-icons-svg/character04.svg\";s:64:\"62de246e9b7073e36b4057a3409469f6c9107b8debfc46909d39aa426dd17c70\";s:55:\"public/assets/assets/svg/busy-icons-svg/character05.svg\";s:64:\"48a1575db0c86a853b78064cd17644f3ed0b6b6e355744b423a5d8208890f804\";s:55:\"public/assets/assets/svg/busy-icons-svg/character06.svg\";s:64:\"338451da63fc22eba588c76add1b45ecb069996258b7328bb1e74343e5fed26f\";s:55:\"public/assets/assets/svg/busy-icons-svg/character07.svg\";s:64:\"d60c68a0bd56fef8fdfa0e4130816c40c4a40095065d672b1bf7bd90a6924dc8\";s:55:\"public/assets/assets/svg/busy-icons-svg/character08.svg\";s:64:\"9e19091db350fecc5b6f71173ad5542b540251fbb42ec75e5e65eb64b4849db9\";s:58:\"public/assets/assets/svg/busy-icons-svg/chart-analysis.svg\";s:64:\"66038ac7f995fee7e19bc778e75dc04ade2d3f4271ac29eb2e8e6c2f51bf8fe5\";s:55:\"public/assets/assets/svg/busy-icons-svg/chart-board.svg\";s:64:\"88add3c757b74071cd9274a033f3c1706abe3de2382dae3635cb2b1e82fac9eb\";s:57:\"public/assets/assets/svg/busy-icons-svg/chart-pyramid.svg\";s:64:\"48bb5d31b6c02ec81e8aa37a7cd90c618e54fb564854bb856c11991fde4a65cf\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart01.svg\";s:64:\"2d3de4c84eb950d2fb7c42874a70b8530ed5ef319923d6af588157a4dadb6b80\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart02.svg\";s:64:\"370b5c8c08af1ec02d28303618608bc796d84a456e663b4ed29d1ff0b05ce68c\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart03.svg\";s:64:\"331274fb0126e095e5dffba5090e246e5420453ff27f1d6085be16cd92ecbc10\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart04.svg\";s:64:\"5f179a1e7902d66936a7df747a48de12704f76b6f51f83d9de77307aab9ee78b\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart05.svg\";s:64:\"40cdc6cf63e736e91196d906064a32c0861c12f8698b125a1e114881c549dfc7\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart06.svg\";s:64:\"7ffe973e81d8054a815d674678fe00c7f12ac71b78df7d49515b1dde7889608c\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart07.svg\";s:64:\"faeef6343ddab11b798a14e03ea4e6a7398ba54f141da0bc8764469e29ba7a37\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart08.svg\";s:64:\"a5e745d9c455a271b004f845b68244425fcbe35d29664dbf73704561a3bf9af4\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart09.svg\";s:64:\"703a3dea1474ced468642f1eb91557fbd71f67bfe7566d135b3c71c0e39d7c47\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart10.svg\";s:64:\"e5e7af29b42655374a6a055322efb3d2051a05875588e364834a2e45e10e3ccc\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart11.svg\";s:64:\"9b4c4435f665c1adef240ee74aa125946adfacceb8e8a7e79c0ec6c01fe48041\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart12.svg\";s:64:\"0597d605c6878dde16d6039f16c93885e5b2253d8c83be6bd8559da19d89f242\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart13.svg\";s:64:\"150037d5603f2f4624a0c22de79720bac086d5baedaf0361784dc686554a5e24\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart14.svg\";s:64:\"668560668a799622fbbcbf936c1ff1de189c5ede9b23e4d62e81ea0b2ee3a481\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart15.svg\";s:64:\"7758c3c426f2323d13268f462fc284660f84f764b1ebb645138e96ad84c8c513\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart16.svg\";s:64:\"a8c5290ddd5848a7f5cf8f10064aec106b02d4f7cdae38066bf2a61d69c55c6d\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart17.svg\";s:64:\"aa1f1c28306ee4bb6068efc32b65dc897dc1cee2f63975cfc339a4893c9f39b6\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart18.svg\";s:64:\"30f6b804b088029addb513b0caf513c00859a970adaa09a2162a3bddb786c3f6\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart19.svg\";s:64:\"92ee4aab883e355666c6ce54a60e2fcba19691ed98eac3fdd67feb7c6d13164b\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart20.svg\";s:64:\"59619b7b8174171ef01114e0424ddbc3a9b0bf0f362728c88d67937b36f8d2b0\";s:51:\"public/assets/assets/svg/busy-icons-svg/chart21.svg\";s:64:\"ab8b0e263cad17a944eb9f3276dbea526de072cc6b019f3eb01e2e240cad6182\";s:48:\"public/assets/assets/svg/busy-icons-svg/chat.svg\";s:64:\"c20700933be70ca86bfa395dac68ff711fafd8f3bb322759f7d849adb27262c8\";s:53:\"public/assets/assets/svg/busy-icons-svg/checklist.svg\";s:64:\"e9b74ba2d4909b995a39be37436fc030cb6c5d5eb7a9c8c14c9491e26dc8cc17\";s:54:\"public/assets/assets/svg/busy-icons-svg/checklist2.svg\";s:64:\"f8fc1e9232f223d1360d28ea9c0d27c4b58ec53fea8ba98730f0ee2ae0f537ad\";s:54:\"public/assets/assets/svg/busy-icons-svg/checklist3.svg\";s:64:\"df9cd20cfa10b02ca0eeaa50a8b44b20028fd4aa1665d2eab53e69e215bfdcf9\";s:53:\"public/assets/assets/svg/busy-icons-svg/chemistry.svg\";s:64:\"36423d098b41d049438ab24a5e514abccd5029829f1b1737279e9152ded0b2f7\";s:56:\"public/assets/assets/svg/busy-icons-svg/chess-knight.svg\";s:64:\"ae2a1b60189877f2613c59c86b8143bbae29e07a42276e11012fd940fd929edf\";s:54:\"public/assets/assets/svg/busy-icons-svg/chess-rook.svg\";s:64:\"38a3b176a78d1536b4310ddcfd5455b64434e720804ef38cf70cc2ee06726253\";s:49:\"public/assets/assets/svg/busy-icons-svg/chess.svg\";s:64:\"37efdb870c19a3c272410bfeb99ad5bb1cb5ebe6374f798046ffcd831425eb1a\";s:49:\"public/assets/assets/svg/busy-icons-svg/clock.svg\";s:64:\"bfb4574fcfa6a281499f1662d81f58fda619cb69693a5952db62452e8f120dbf\";s:55:\"public/assets/assets/svg/busy-icons-svg/closed-sign.svg\";s:64:\"09e7ca737f6dc9fcfa851506029e8217869186af26b518bc85f18a6aa04f1cf9\";s:55:\"public/assets/assets/svg/busy-icons-svg/cloud-coins.svg\";s:64:\"ab8c9a10ea77161bc58a2f02d1e19f886f39f0db37342f5e6935d859cb967aad\";s:54:\"public/assets/assets/svg/busy-icons-svg/cloud-down.svg\";s:64:\"29cd80c9b4bd5d45254306c94a5a3acb6cf501becc53180667ad413a07daf3e9\";s:52:\"public/assets/assets/svg/busy-icons-svg/cloud-up.svg\";s:64:\"bb3afa67a29e291e61fe25b20e08c586a96929ebe6b2c43adb1ee5f8f2649da4\";s:50:\"public/assets/assets/svg/busy-icons-svg/coffee.svg\";s:64:\"71eeef559a657b1b13a6428437372165de72d5c13de4765554008ad92b4bacc7\";s:54:\"public/assets/assets/svg/busy-icons-svg/conference.svg\";s:64:\"4ff2f27d4cb95c4874f3b52527e43e4be72cd7a373ee28fcde9fccf89bc722f2\";s:56:\"public/assets/assets/svg/busy-icons-svg/contact-book.svg\";s:64:\"37bc2c0b9c4a982debef2227b64d2f0aaf4cc661881e152980f8a2ddcfd6c6c7\";s:50:\"public/assets/assets/svg/busy-icons-svg/coupon.svg\";s:64:\"be6f9e5e17f8bc1bbd341b0be9b467245785a49d6505bff9e61d5b7c4f76db95\";s:55:\"public/assets/assets/svg/busy-icons-svg/credit-card.svg\";s:64:\"7226ff5a71d862dc5e8a51e086b1db81d1b713a9fd3b0f312c53c4e06dd37306\";s:49:\"public/assets/assets/svg/busy-icons-svg/crown.svg\";s:64:\"3d8f9fa5d394c64ef255d34aa62376fbeac31cb9bcf0befa129cf23df0095729\";s:54:\"public/assets/assets/svg/busy-icons-svg/currencies.svg\";s:64:\"3d04930635a23e3aa1f6a26610e2609220e993092e67c74deefce0c76b87c2a0\";s:52:\"public/assets/assets/svg/busy-icons-svg/database.svg\";s:64:\"5ee03018ab363c45ca9278a0b1012c6316e514a00416dfc620dbefefa6c77b81\";s:52:\"public/assets/assets/svg/busy-icons-svg/delivery.svg\";s:64:\"ca4e3596944038b76b1de9b65fed69bc8f21275b656f40c42075b043dd1c31ed\";s:61:\"public/assets/assets/svg/busy-icons-svg/diagram-hierarchy.svg\";s:64:\"2fcfeee9ac1f38303df063088a278fe1358e9522c05861022fc0b32245af2ac8\";s:51:\"public/assets/assets/svg/busy-icons-svg/diamond.svg\";s:64:\"5e226e8884e6ab1e24181f143425f9dbc2dbfe1e454b587fd0d354e8c49432e4\";s:50:\"public/assets/assets/svg/busy-icons-svg/dollar.svg\";s:64:\"834c9f9a38a5f86ff5492928a095f76199fd8b139f578d64fd6f169a6584c7bb\";s:50:\"public/assets/assets/svg/busy-icons-svg/drawer.svg\";s:64:\"f6b9baff5396a149ca20e5250b5ef26594c5274cf2569aa7bc8b1ce665421fff\";s:47:\"public/assets/assets/svg/busy-icons-svg/egg.svg\";s:64:\"4e63c6275af7f0ad77dd580c25ee8ac51b24091e2ef43c265610870f001daa81\";s:50:\"public/assets/assets/svg/busy-icons-svg/emblem.svg\";s:64:\"522cd1e75a856f03920b18113dc42e7bc2821519a817e16e4bd4a065109e7cc7\";s:58:\"public/assets/assets/svg/busy-icons-svg/envelope-money.svg\";s:64:\"75adcddf23a06001b72d10bc122383cda115a64755a13198ecbab452b10ca1e5\";s:53:\"public/assets/assets/svg/busy-icons-svg/envelopes.svg\";s:64:\"1e3968e350d4dd221851f61e0881fd1bcc07d69789300ab8f1bfac8eaef3cdaf\";s:48:\"public/assets/assets/svg/busy-icons-svg/euro.svg\";s:64:\"54db30d600e368d8c060b952ea2c6526a929b48ca02cff44840fc53790e15c02\";s:52:\"public/assets/assets/svg/busy-icons-svg/exchange.svg\";s:64:\"a2eb15b60e1565fd484a0b5bda48bba737198be2d49b85ccd7cb58e1cc9dec07\";s:48:\"public/assets/assets/svg/busy-icons-svg/exit.svg\";s:64:\"af189a07dc233f9afae899011285777dbcd59dc6426f1764bade17f04ac12563\";s:51:\"public/assets/assets/svg/busy-icons-svg/factory.svg\";s:64:\"c1002f8659b1be6de42e54a6d270cde922fbb94589a64f12cf4505923ddcf26e\";s:47:\"public/assets/assets/svg/busy-icons-svg/fax.svg\";s:64:\"036e082826dbb2bb9a0a88c38b3690f4d0f65642655fdc535331981bf2152166\";s:50:\"public/assets/assets/svg/busy-icons-svg/file01.svg\";s:64:\"01bbd954f334cf71339390f41a8c48444f5110c8870a0efcc5672666750d1159\";s:50:\"public/assets/assets/svg/busy-icons-svg/file02.svg\";s:64:\"373f2a96ad1309f4c8ffa4dac35d57666d1cd73fc94fd8ca240704ee77a5d8e4\";s:50:\"public/assets/assets/svg/busy-icons-svg/file03.svg\";s:64:\"2d4a9ef37a7a62a4bc93f81460e25511bc98fa285919f54e666a83a07a3d39e0\";s:50:\"public/assets/assets/svg/busy-icons-svg/file04.svg\";s:64:\"5c748275b6a21476b1c45f25c27cd18318fea3581312018f6458dbeae2332bb7\";s:50:\"public/assets/assets/svg/busy-icons-svg/file05.svg\";s:64:\"62391ed3eb1a074d7f4a0d1cfb690ec19aaed6f49ac4aa1e0257583314dc872c\";s:50:\"public/assets/assets/svg/busy-icons-svg/file06.svg\";s:64:\"ef8fe7424f515e2e501c44832de844ab612674d0ad4b87abe943b626c5b7a01e\";s:50:\"public/assets/assets/svg/busy-icons-svg/file07.svg\";s:64:\"4d8a0eb669d87bb47c80da17a13a4d6067bb1a400526ade1728f5059663e171c\";s:50:\"public/assets/assets/svg/busy-icons-svg/file08.svg\";s:64:\"e76b16efbb01f7c84c6881a54c0976827a9af260032c1001433db396419e2f47\";s:50:\"public/assets/assets/svg/busy-icons-svg/file09.svg\";s:64:\"d91d7d0959acf1616ca6ac820667c9c5f6d8d5f18b1b27cd96acb29924e09a24\";s:50:\"public/assets/assets/svg/busy-icons-svg/file10.svg\";s:64:\"c70b77d7c8badb11156a478d2eded3490aea32493834f5d3713c6f3c061d7e09\";s:49:\"public/assets/assets/svg/busy-icons-svg/files.svg\";s:64:\"2faa9776f2edfd6a304ad54b86f083f20cb369481815ded958cf03dfc9668227\";s:48:\"public/assets/assets/svg/busy-icons-svg/fire.svg\";s:64:\"9be1a8d3e3601ed99e98dc0496eb1afe340c7b6ebeffc16f99c26a359e24ed44\";s:48:\"public/assets/assets/svg/busy-icons-svg/fish.svg\";s:64:\"20da6f0d5bc0f350f5516a2ddb7e707bab08f5f1ae9681ccb9eb6cd1a088d693\";s:48:\"public/assets/assets/svg/busy-icons-svg/flag.svg\";s:64:\"442fe7ed76d7427e692dbab8db20b3e34fa5813ceb5fb6cd589c45c6a81a36e3\";s:54:\"public/assets/assets/svg/busy-icons-svg/folder-add.svg\";s:64:\"fb4f21cdba5d5290e0fe46b3b02e48846df8e49683caea6e93016f565a8c3faa\";s:57:\"public/assets/assets/svg/busy-icons-svg/folder-delete.svg\";s:64:\"30f3241541894f48a67e666b884a9cd91bad3694b23b650288773166794dd55f\";s:57:\"public/assets/assets/svg/busy-icons-svg/folder-online.svg\";s:64:\"65eb436c43605a9e42da8bc1eb20352160e3a431a330d301c073f5a52ad59779\";s:58:\"public/assets/assets/svg/busy-icons-svg/folder-private.svg\";s:64:\"61b9a6a67cb7c1d3f0361f0aaab8f0187b79d357f6defc2d389970c562a95f53\";s:57:\"public/assets/assets/svg/busy-icons-svg/folder-remove.svg\";s:64:\"1a5878cbce0bffab8c9d09e8359a2282462ed164f1e81633fa006f6e47a48ffc\";s:50:\"public/assets/assets/svg/busy-icons-svg/folder.svg\";s:64:\"70ff4a52bf2bdd27f8b82b428df7047b62ee77e7285d3403c8faf8ae8d19fd8e\";s:51:\"public/assets/assets/svg/busy-icons-svg/folders.svg\";s:64:\"f1e782e7523b22002d9a9cdbc192dd05a0b898e67c30c7ce17db78a3686dc149\";s:56:\"public/assets/assets/svg/busy-icons-svg/funnel-money.svg\";s:64:\"6e21a968a862aa5b53144d6ca0b9f6b52c25cd04b91609d8d30d566f28336583\";s:50:\"public/assets/assets/svg/busy-icons-svg/funnel.svg\";s:64:\"2593bdb8f6d671c5f3c298d9f9802449025155ea3476da814a4b5edc8d4eea92\";s:49:\"public/assets/assets/svg/busy-icons-svg/gauge.svg\";s:64:\"4483e634855b35127fbacc8fb6601319f7a757ae8efbc541dafb4bcc06b433c2\";s:50:\"public/assets/assets/svg/busy-icons-svg/gauge2.svg\";s:64:\"689c10140da140f3af2bbfa13f38de3928eb15d2696584c65421d012df5149bf\";s:50:\"public/assets/assets/svg/busy-icons-svg/gears1.svg\";s:64:\"4261c14aaf6d5d8cae144af73f76403b0d64b4dac4e7c91da81efa5ac5a09b76\";s:50:\"public/assets/assets/svg/busy-icons-svg/gears2.svg\";s:64:\"a67daa4a554d0e45e7fd54dc3244ffa703649aaca4355d6e1a9f30adf29941a0\";s:61:\"public/assets/assets/svg/busy-icons-svg/glasses-moustache.svg\";s:64:\"b5e282f5dfb4bad7b2c8c8a5a6bbcee0982403898c46ad23977230ce79e8ebfd\";s:55:\"public/assets/assets/svg/busy-icons-svg/globe-money.svg\";s:64:\"67af5d958b27d88cbf6d9c2a22fca699031826a66083393c61fbb03d039dbd3f\";s:49:\"public/assets/assets/svg/busy-icons-svg/globe.svg\";s:64:\"c8c9b739ea6e54340edc712800240516e1803e6948fe916c71dd64478e641d60\";s:50:\"public/assets/assets/svg/busy-icons-svg/globe2.svg\";s:64:\"294e7069020569f4d03bdce820f15cb8e56259135847f40f4bf8c40fe940d2a4\";s:58:\"public/assets/assets/svg/busy-icons-svg/graduation-hat.svg\";s:64:\"859699e88337270eaa398694ab374d42ca0b6cd2ddd67512b95df71394742b12\";s:54:\"public/assets/assets/svg/busy-icons-svg/hand-globe.svg\";s:64:\"77fb9367a4c2bbee03be26bd62adc50bf70e618939f1ceef6e169b49b0f802f2\";s:52:\"public/assets/assets/svg/busy-icons-svg/hand-key.svg\";s:64:\"c100b7b4e846d2972dc0d2d527b931de25edf6a58cf383ec50a8e9dd7e2fc976\";s:54:\"public/assets/assets/svg/busy-icons-svg/hand-money.svg\";s:64:\"ada05657bbfe7a6a68d7edf2e1f09d1d027192a4ee77defbd491091c06edd0dc\";s:55:\"public/assets/assets/svg/busy-icons-svg/hand-money2.svg\";s:64:\"4e6d718eec2e07d87171acc2ffcd53ec7d694a4d823d41cd840a92473010331e\";s:53:\"public/assets/assets/svg/busy-icons-svg/handshake.svg\";s:64:\"f435d0c8cc9f9665f70ffb8ac6238503d6cdb13599d9487ebf6621f58ae2ef99\";s:57:\"public/assets/assets/svg/busy-icons-svg/hat-moustache.svg\";s:64:\"f1b4136ca4054fbc9ef1e36bb87bb2aa1f71c9f5a5caa5c51df4291207434c5b\";s:47:\"public/assets/assets/svg/busy-icons-svg/hat.svg\";s:64:\"d7591c34734286221aec742cc832192fdeacf7da32c5a4e59b8af59cb0f44b52\";s:55:\"public/assets/assets/svg/busy-icons-svg/head-arrows.svg\";s:64:\"943d312c775edc358c0fd276bdbad1417bfae8947d5f5208bff66ee5a4c91aa2\";s:56:\"public/assets/assets/svg/busy-icons-svg/head-battery.svg\";s:64:\"84cc9f4f9870fd4cc42f23b64f1a20271f7091cab4b26d9abcc47069a7cd2a19\";s:54:\"public/assets/assets/svg/busy-icons-svg/head-check.svg\";s:64:\"4a1361104a0c053bfd4b01f2b003a5463e1fff8ba15d2f7dec791bcdad486c89\";s:56:\"public/assets/assets/svg/busy-icons-svg/head-compass.svg\";s:64:\"1274bef2383f640d2ab7471b33ecf35da373fcf2cc46bbe880ee03926bb66ec6\";s:55:\"public/assets/assets/svg/busy-icons-svg/head-dollar.svg\";s:64:\"12ee216f219d054f4584bb9c2ad14e10847791a91ca0073bb88a283890573ad4\";s:60:\"public/assets/assets/svg/busy-icons-svg/head-exclamation.svg\";s:64:\"9b0f49ddb0ca907ad75c590b947a4eb979706a65fabcf2e80cfbf614e0022093\";s:54:\"public/assets/assets/svg/busy-icons-svg/head-flash.svg\";s:64:\"4dff469f335d625f5566bf4e0ef6e9ad15bdc37e8b8138b18d3759e7784db830\";s:54:\"public/assets/assets/svg/busy-icons-svg/head-gauge.svg\";s:64:\"d90ab3f6c8cb773bb3dbeba89b661e960a24a1ad6e1e342fe83a70f6bc2a2159\";s:54:\"public/assets/assets/svg/busy-icons-svg/head-gears.svg\";s:64:\"cc3df32139638541b452508bc8098b795f93b6583181eef19ff74a4e0f61f7a7\";s:58:\"public/assets/assets/svg/busy-icons-svg/head-hourglass.svg\";s:64:\"a2114e23e5b256303f1a7ab1fc3e07687516d0805a4b688f62c4387970d83fa7\";s:53:\"public/assets/assets/svg/busy-icons-svg/head-idea.svg\";s:64:\"b7703545a4606d4d4411213bc3f3ace6a74da9c75b707e3046c6735c0c06b477\";s:57:\"public/assets/assets/svg/busy-icons-svg/head-question.svg\";s:64:\"3de3923c884bc00859e21029c82ec477eec282f4dd81a42da7c2bdbb40ad9a59\";s:58:\"public/assets/assets/svg/busy-icons-svg/head-structure.svg\";s:64:\"7c0913b4cd255b7a138bc5f7dc723a8fc826c03e466e7024a1fd870eeef4569a\";s:48:\"public/assets/assets/svg/busy-icons-svg/head.svg\";s:64:\"a298d0fc05e47d4628e7951f354d9bbdab308ce762c3253910f4528b835ca9d1\";s:56:\"public/assets/assets/svg/busy-icons-svg/headquarters.svg\";s:64:\"28871cf85ccea68ba78b5b0a5584ab9878a8cdbc4828d8284f83b0aae6523c69\";s:53:\"public/assets/assets/svg/busy-icons-svg/hourglass.svg\";s:64:\"c553021891322dfb7ba4282153f144b7aae8b301626703a3fe7bb1ee19bd1266\";s:49:\"public/assets/assets/svg/busy-icons-svg/hours.svg\";s:64:\"48b87c52949d5b8d4aa5e9ce81662037eee1e89c0632db0fd8758b499b88ea0f\";s:52:\"public/assets/assets/svg/busy-icons-svg/incoming.svg\";s:64:\"fded8b465fb284682b339e68a3d022db1350c9bc2fdafef012a703eb2ad9aab6\";s:50:\"public/assets/assets/svg/busy-icons-svg/ingots.svg\";s:64:\"8fcaa5efdae6a686b4e7420ed56d217be18de2a8e6a82892195ed5d32de7c785\";s:47:\"public/assets/assets/svg/busy-icons-svg/key.svg\";s:64:\"61418becc2fb046e3063a5cb4e6b727fb564bf2759dab73898664685613ab4f6\";s:48:\"public/assets/assets/svg/busy-icons-svg/key2.svg\";s:64:\"da8b590ba5ca9e16ca6139bb532597677319550b9fae6f3432953c25955f84c9\";s:52:\"public/assets/assets/svg/busy-icons-svg/keyboard.svg\";s:64:\"8105805d0693cc45015aec8ce128d97c818df29b009e8301ee717fb8a1755170\";s:49:\"public/assets/assets/svg/busy-icons-svg/label.svg\";s:64:\"913551fcb5ba79f3aea8d3f2c65940b379712ac220cb184754df196da5a75039\";s:48:\"public/assets/assets/svg/busy-icons-svg/lamp.svg\";s:64:\"f7e2614d3264e5f68f03536fd7f39cfaec5135f5042ec80df094fe1cc13e54f7\";s:58:\"public/assets/assets/svg/busy-icons-svg/laptop-article.svg\";s:64:\"93e38e8d1f6ce7e71ab823909450ff21b2ce3748e0539bd506ce17e7d1b092a8\";s:55:\"public/assets/assets/svg/busy-icons-svg/laptop-cart.svg\";s:64:\"9a1d3ff7d16c277f6438df97b440e097fc8d55e01fc715e3ee5af9616c104912\";s:56:\"public/assets/assets/svg/busy-icons-svg/laptop-chart.svg\";s:64:\"5e148653fe341bf8253671aaa74f7c7636a0d5ea771113be411b05583362a884\";s:57:\"public/assets/assets/svg/busy-icons-svg/laptop-chart2.svg\";s:64:\"c7bb3e8688c5a13d8ec1ad0aaf48d632b683d9be64120a85d1de60db94713a1d\";s:58:\"public/assets/assets/svg/busy-icons-svg/laptop-diagram.svg\";s:64:\"55fc8285b821b3d5fa0b571a9a88bd77087ebfa2720f58498a8936fef411f1e4\";s:59:\"public/assets/assets/svg/busy-icons-svg/laptop-envelope.svg\";s:64:\"55d7bffc2a888f8fd8bd2775343071751184c6d87af49970f5fff0bbb1a6bd49\";s:58:\"public/assets/assets/svg/busy-icons-svg/laptop-finance.svg\";s:64:\"3ce5d591447ff623a527c830b49f985f3e03f5eeac5af66a29f7515a1ec0beec\";s:58:\"public/assets/assets/svg/busy-icons-svg/laptop-privacy.svg\";s:64:\"9a2ea0681827cddf04cae9e323f13569f7ad623154d4a78c275d3ca65e955a74\";s:59:\"public/assets/assets/svg/busy-icons-svg/laptop-settings.svg\";s:64:\"f05331d144c97b42742ae47a22570efb0effd428698148ffdf4decd828eea604\";s:55:\"public/assets/assets/svg/busy-icons-svg/laptop-user.svg\";s:64:\"fbf18dfb15ab156969f8f819b1452b889005fde35ddc626d4cc3f423753e7b05\";s:50:\"public/assets/assets/svg/busy-icons-svg/laptop.svg\";s:64:\"c8d6a583c98776bedde473b68ff9fa1ced317cf631d4963419765b41abdcc025\";s:59:\"public/assets/assets/svg/busy-icons-svg/lightbulb-green.svg\";s:64:\"700eefae907d22fe99b626e612452c02e1de598985337c8d205159dde37813c0\";s:53:\"public/assets/assets/svg/busy-icons-svg/lightbulb.svg\";s:64:\"3a797af481234fe873caf056ad6422a4defc888fba43886d2165102fa31a6724\";s:53:\"public/assets/assets/svg/busy-icons-svg/lightning.svg\";s:64:\"e72db0bed9dc10c07796c20e67458634e132b0b5b027c88f2c81937e9274d9c5\";s:48:\"public/assets/assets/svg/busy-icons-svg/like.svg\";s:64:\"5ae9c84079d7100b9c12039c14bad1a9969c4e1f1ca0553a6aee9cfcc14c52f2\";s:48:\"public/assets/assets/svg/busy-icons-svg/lock.svg\";s:64:\"f403c42b716d6a73890c740806c4b50e35c34f63fee31ee09cee2b093012b7fe\";s:56:\"public/assets/assets/svg/busy-icons-svg/magnet-money.svg\";s:64:\"33a54170088674d6e5da70b8c704915405d036ae126818b77d7fc9b28e8f66ee\";s:60:\"public/assets/assets/svg/busy-icons-svg/magnifying-glass.svg\";s:64:\"df4c8cd180fa3b8f6ae2d7af66739d0ec47b280cd906c45ac7ddb78a4b5f2ed6\";s:57:\"public/assets/assets/svg/busy-icons-svg/manager-globe.svg\";s:64:\"bb3c3234d892199c37a4d4c04d2a628532c5ac016de931611096d1ec82da6844\";s:56:\"public/assets/assets/svg/busy-icons-svg/manager-idea.svg\";s:64:\"2a3c7e0dbc04889605ce8c553248528b10d90a6e1c761828f9120dda8c639e0c\";s:53:\"public/assets/assets/svg/busy-icons-svg/manager01.svg\";s:64:\"b2ba093291d267fed9d3bfc1bd82f5fac1fdcdf0d6a39a919e9afe49e4d8ba7d\";s:53:\"public/assets/assets/svg/busy-icons-svg/manager02.svg\";s:64:\"da20cdf4fc727b60f4aaaf23471ac933d78db281b7607fb339f78f2f9e1ed990\";s:54:\"public/assets/assets/svg/busy-icons-svg/meditation.svg\";s:64:\"267d38b8108beca8d9a94c598d5f0a06fddb4a7454a4c86c71b9d09d14f5931b\";s:53:\"public/assets/assets/svg/busy-icons-svg/megaphone.svg\";s:64:\"8b216c924cdff1e11efe4aa19a8de62fba918452daba00ba1ddb5162d531404f\";s:56:\"public/assets/assets/svg/busy-icons-svg/money-growth.svg\";s:64:\"be12fa628893cd534716b3a74776fa837a3273af46bd5df7625af0bcbe6cfe49\";s:56:\"public/assets/assets/svg/busy-icons-svg/money-scales.svg\";s:64:\"b948a4d0f828a98105472636a14cf81bb6a23f60ba074a287878c278b7af038a\";s:49:\"public/assets/assets/svg/busy-icons-svg/money.svg\";s:64:\"96b01a12dd3d1fed63ea67e89e3f9c9126a008a668ba9a21a9589cbb0bffd9a8\";s:50:\"public/assets/assets/svg/busy-icons-svg/money2.svg\";s:64:\"304e6d4f2b3cb6cf95a378cd8d6bf7458d0cc4d638f2b0b514c678035b61e1fe\";s:50:\"public/assets/assets/svg/busy-icons-svg/money3.svg\";s:64:\"72e8bf2f8d583934299fc60aeb22cc504ab4615f933ff41747476c15a7bcab3f\";s:50:\"public/assets/assets/svg/busy-icons-svg/money4.svg\";s:64:\"17cb90f05213d65aed600953f49674ea3eb2db3cae1afcd1b2e68f66eb84952d\";s:50:\"public/assets/assets/svg/busy-icons-svg/money5.svg\";s:64:\"2001200cfa05e277fab364329b323376db7d52e227e3bf45fbcd5eb01fa3aa03\";s:50:\"public/assets/assets/svg/busy-icons-svg/money6.svg\";s:64:\"9ccf0ec64c3ae22501b27ed496bfff9a380082e8ff89f02971bc3e427845cab6\";s:51:\"public/assets/assets/svg/busy-icons-svg/monitor.svg\";s:64:\"dcd7187ce0be4d50a9166bde3246f4f01ff4b04d2725469bd271aee6600b78ce\";s:49:\"public/assets/assets/svg/busy-icons-svg/mouse.svg\";s:64:\"ae406f24deeb22299f81cd939b2e0b40c3fe301965d65e1feb9ead0ead752cc3\";s:54:\"public/assets/assets/svg/busy-icons-svg/nest-money.svg\";s:64:\"87bd64a802a75896c8f019c85051abcd419627e23d9da4822f73248e0b91eb2a\";s:58:\"public/assets/assets/svg/busy-icons-svg/newspaper-jobs.svg\";s:64:\"56029e8a0ccb493c31b1808fe6b2753f5e6700ce6d29fc9dc4a83d84558baa16\";s:57:\"public/assets/assets/svg/busy-icons-svg/newspaper-pen.svg\";s:64:\"673eb89b5d37886fa731004bc3c858e536b816c1a25ba1abd1cba395fb130bcc\";s:53:\"public/assets/assets/svg/busy-icons-svg/newspaper.svg\";s:64:\"fcd46ce5100d6d3b03426f059916bce5d915ed5c6395ab9758c57432bd801c5a\";s:54:\"public/assets/assets/svg/busy-icons-svg/note-paper.svg\";s:64:\"608f3a0569c365af3a55ed60bf572190ecd83b165a09c81f502028fc1c538a41\";s:56:\"public/assets/assets/svg/busy-icons-svg/office-chair.svg\";s:64:\"1150cf91e260c1a35068e76dbfe4089e419866850f6adf589fcd222ed72d3271\";s:53:\"public/assets/assets/svg/busy-icons-svg/open-sign.svg\";s:64:\"1ce9d9cd8541439439116bbcdf5e69ceb2e7c87d966319dd073541e4ecb3201e\";s:52:\"public/assets/assets/svg/busy-icons-svg/outgoing.svg\";s:64:\"d867643711e9577e88582b26223a3f5858d009ddcd50b1a6bca964595e53cad9\";s:54:\"public/assets/assets/svg/busy-icons-svg/paper-clip.svg\";s:64:\"6152f2337ed932c75d7e24b70dd249126b78aa450721afafec14632323a470df\";s:55:\"public/assets/assets/svg/busy-icons-svg/paper-plane.svg\";s:64:\"6152f2337ed932c75d7e24b70dd249126b78aa450721afafec14632323a470df\";s:47:\"public/assets/assets/svg/busy-icons-svg/pen.svg\";s:64:\"8cda8d0bed689de759950a2993a937e8890bb9c0836fad3cee99499fef349802\";s:48:\"public/assets/assets/svg/busy-icons-svg/pen2.svg\";s:64:\"a23b1afc925fc98820049a59a50dff4594bf8bad5b899b48fc8e5e801eee0bb0\";s:50:\"public/assets/assets/svg/busy-icons-svg/pencil.svg\";s:64:\"527edcd79093bbe66252426a12fe3a90323f2f1d22bf9f132d5b8e3b2b768caf\";s:56:\"public/assets/assets/svg/busy-icons-svg/pens-pencils.svg\";s:64:\"02fdf6842584a17b72994fb959f8b9a2f17601a7ff3bc9fd9013796f2ebf225d\";s:59:\"public/assets/assets/svg/busy-icons-svg/people-arrows06.svg\";s:64:\"644ba52bc146cca3095e4438aaef4d8ba6a483051ccf4d4a8678c1efaf536c93\";s:56:\"public/assets/assets/svg/busy-icons-svg/people-gears.svg\";s:64:\"f73956a35f2b850fab9519179fffd1c30d8fbc6964329369fa928949228588a0\";s:60:\"public/assets/assets/svg/busy-icons-svg/people-handshake.svg\";s:64:\"6dcbb3054a3c81f18cedbc162d2b9adcebb7f382b922c3575bb8b08199196b96\";s:55:\"public/assets/assets/svg/busy-icons-svg/people-idea.svg\";s:64:\"a2aa5f73a1e7709ed758d20a4d02b8d4dc547c599ad92d92ccca9637e8c02946\";s:58:\"public/assets/assets/svg/busy-icons-svg/people-meeting.svg\";s:64:\"0acf6a6f9d4e20e492f1bd3f4d90a3fbc4f6ceeb648cfa8fc95515f6494014be\";s:60:\"public/assets/assets/svg/busy-icons-svg/people-meeting02.svg\";s:64:\"041ac93d2885efa150ccd8024fb68e77e68372f6eb99052ae51dc534cf766771\";s:59:\"public/assets/assets/svg/busy-icons-svg/people-search01.svg\";s:64:\"51dba30d97e73854f262da75394ada50ba85eb95b11414b063c9ada1fdf3e098\";s:59:\"public/assets/assets/svg/busy-icons-svg/people-search02.svg\";s:64:\"65a1d380f28c9dbe19357dc316693edccec96261ace5a1754a9d9fb3677a7ede\";s:60:\"public/assets/assets/svg/busy-icons-svg/people-structure.svg\";s:64:\"a3ad402df1c03a2b6e41f27971f3851e7342822296f5446cc9a983a3f1202d5a\";s:62:\"public/assets/assets/svg/busy-icons-svg/people-structure01.svg\";s:64:\"9940fcd5fe908e3d1c8b3e9b2bddce61d51e7ad28d69fe8a37f2a106d404f685\";s:62:\"public/assets/assets/svg/busy-icons-svg/people-structure02.svg\";s:64:\"3abc1e327b57be948ded61d537b811eb346b8101d3302f321fa38f848d4dd36d\";s:62:\"public/assets/assets/svg/busy-icons-svg/people-structure03.svg\";s:64:\"7ff22c89112e2bba485883d878db13db882d3ba5e75788364c894fea7e4675bc\";s:62:\"public/assets/assets/svg/busy-icons-svg/people-structure04.svg\";s:64:\"127010127c35785e38a03bc4757488a67efba252ada044ed776de18520c6d84a\";s:62:\"public/assets/assets/svg/busy-icons-svg/people-structure05.svg\";s:64:\"8dfb345e00e7f3dc47b02730ef13fab505ce14fb4dde76a41657812fcdb3f3fd\";s:62:\"public/assets/assets/svg/busy-icons-svg/people-structure06.svg\";s:64:\"c77fa508b9ca401238335f12d6c7bfbf4fba2de9d797e9191aa65bbceca6e982\";s:62:\"public/assets/assets/svg/busy-icons-svg/people-structure07.svg\";s:64:\"a952e4e7d05961daa17e9586ae2e97223430e7165f22f47d4c522a55dec272ac\";s:51:\"public/assets/assets/svg/busy-icons-svg/percent.svg\";s:64:\"9d8d95846c6546622aaf014b0430cb47e5fe770c3cd43b39b030173dde942a26\";s:58:\"public/assets/assets/svg/busy-icons-svg/periscopemoney.svg\";s:64:\"055b50e73c7a4b3413d98f71661aa2f427779ed865799f1085dfb4d66f55cbba\";s:59:\"public/assets/assets/svg/busy-icons-svg/person-arrows01.svg\";s:64:\"65c32d333c2415a643d1ddaf23dfa6aa6cda5675a25f0878c14ad5b3b93eb733\";s:60:\"public/assets/assets/svg/busy-icons-svg/person-arrows012.svg\";s:64:\"9d70a9728c1eaedcac8041d1b94886217dbbf323fa58d9e6d5ffa4159a6f5c39\";s:59:\"public/assets/assets/svg/busy-icons-svg/person-arrows02.svg\";s:64:\"ae74700fbb2b677e36900e6f6c383359546944ca8d90a10e9c2949ff07b6e9c2\";s:60:\"public/assets/assets/svg/busy-icons-svg/person-arrows022.svg\";s:64:\"998fda705762edeaec5893bd2ea4345d06671d7e1a114b97de989d78e621a2fb\";s:59:\"public/assets/assets/svg/busy-icons-svg/person-arrows03.svg\";s:64:\"7bb29b5671a483965506ad124f8bf08bc90eaa5373b7fdf751d519aa9abf21d4\";s:60:\"public/assets/assets/svg/busy-icons-svg/person-checkmark.svg\";s:64:\"74881b2f9915c7592292d9c65356f9e8cc33a2e5db48d8c7d740fb6fc7436688\";s:56:\"public/assets/assets/svg/busy-icons-svg/person-cross.svg\";s:64:\"8bfd782db79536dec93c3c20f0d65fe5ded4a20eb843e81af1e5eaad4d87ff3d\";s:55:\"public/assets/assets/svg/busy-icons-svg/person-data.svg\";s:64:\"08cda43f716660270ebf07b4fc57f5f206ff27a8c24616d5a639e8b0907b7626\";s:57:\"public/assets/assets/svg/busy-icons-svg/person-dollar.svg\";s:64:\"d1f50bd6745b51447e46e3d53d1d6d9a4483f8726cda7b64ecabbeaf4903f7fc\";s:58:\"public/assets/assets/svg/busy-icons-svg/person-finance.svg\";s:64:\"7edd195b55d5fbd0fd2a12d9be2a53019c26644cb8fa5e708fd95b264db4be39\";s:55:\"public/assets/assets/svg/busy-icons-svg/person-flag.svg\";s:64:\"ba12e061d4ba097199a2166aa5bee7eea2fe427dfc664a978f35c929b772712c\";s:56:\"public/assets/assets/svg/busy-icons-svg/person-globe.svg\";s:64:\"78ca8535f3879f86970b9d31c6efb596a4d6aa9fe7d79fc1d34b1801c56077d9\";s:57:\"public/assets/assets/svg/busy-icons-svg/person-idea02.svg\";s:64:\"892fd7af5c5158b964ca71328935523ec8cd31eaf71cfe62f531d033d055f4e6\";s:55:\"public/assets/assets/svg/busy-icons-svg/person-info.svg\";s:64:\"5a6a6d17ff125b23753aa0515f89b1532b92558e7911b0e0260f8914a793bf56\";s:57:\"public/assets/assets/svg/busy-icons-svg/person-puzzle.svg\";s:64:\"2b5083419230b5c913dc121bca6221e957493735aa9614997066881200ab95fa\";s:57:\"public/assets/assets/svg/busy-icons-svg/person-scales.svg\";s:64:\"738d6af39f4df64f11a06d147bb1a3f6187c0f86c722d7fb2bd1a78cdc5eb715\";s:55:\"public/assets/assets/svg/busy-icons-svg/person-time.svg\";s:64:\"623ea24d6849d3f846d0f8b6c9e67cb7d397c2142c873cbeb9f8440c9d9b9af6\";s:59:\"public/assets/assets/svg/busy-icons-svg/person-umbrella.svg\";s:64:\"d5f0616a6a68672d0153708e791247496d1db178dd40306a3b2afaf092eb5eca\";s:49:\"public/assets/assets/svg/busy-icons-svg/phone.svg\";s:64:\"f20ccb6a06329c76a19b3d9312e4760969a0f18685ee64657bc3e2c2801406a7\";s:55:\"public/assets/assets/svg/busy-icons-svg/pie-chart01.svg\";s:64:\"c4b0f404cab573ab80492d73415a70443a78c07dffa656213f2a314595fc7078\";s:55:\"public/assets/assets/svg/busy-icons-svg/pie-chart02.svg\";s:64:\"fb72a34884d5fb97197b332e7ac4449183e6374becc37af06900b7656998b482\";s:54:\"public/assets/assets/svg/busy-icons-svg/piggy-bank.svg\";s:64:\"ad472bc1be1e73c3e51d7001081b614f451c4cdb1c7839bd2328a55c4bb76a33\";s:47:\"public/assets/assets/svg/busy-icons-svg/pin.svg\";s:64:\"b11034e56963461396cbdaec8152ffe1f2f5b035c4d420b6a0bcc9c13b9cf6bf\";s:55:\"public/assets/assets/svg/busy-icons-svg/plant-money.svg\";s:64:\"7c5c17c54a899ea3a2f887ecd80be6e6a44566eb9539d4d64a27284d456070d3\";s:49:\"public/assets/assets/svg/busy-icons-svg/plant.svg\";s:64:\"f0f9b6bf7f76ed5fd2ac413e47f26230d6e37d681b0205cebdc9afec360d4101\";s:49:\"public/assets/assets/svg/busy-icons-svg/pound.svg\";s:64:\"fb47da2f307bbeeae4300ceaa716f898d91f35c2e620724c7288051bade5b522\";s:56:\"public/assets/assets/svg/busy-icons-svg/presentation.svg\";s:64:\"7b47536c137240fdbc7d54e6502cb5888fae67275505252419651920f47815d4\";s:58:\"public/assets/assets/svg/busy-icons-svg/presentation02.svg\";s:64:\"a443c5193d4be8f24e626c2e563562b9678d7429ca6846d1ffd1548ffb273b79\";s:58:\"public/assets/assets/svg/busy-icons-svg/preson-chart02.svg\";s:64:\"cfcfe6a89d816f5ef240eda38d68df44adcd49b01f17872b565362a32e22effa\";s:58:\"public/assets/assets/svg/busy-icons-svg/preson-chart03.svg\";s:64:\"006d747fc26bfcdd7eb922df9757e57548887295d9d618cb8fa8bc41682cf13b\";s:58:\"public/assets/assets/svg/busy-icons-svg/preson-chart04.svg\";s:64:\"aabceab237319b19ff332703d4643a9afcc172e36a7d2f0e421440746cd23fca\";s:58:\"public/assets/assets/svg/busy-icons-svg/preson-laurels.svg\";s:64:\"466bcd71a38d353ece0c98e646c8781716fd6090706ecb3b087f23f5670d5696\";s:60:\"public/assets/assets/svg/busy-icons-svg/preson-megaphone.svg\";s:64:\"e08414cf0806c013ebe9e629a9c0395bc49baf73a751273dbdd27bfddde8ab95\";s:57:\"public/assets/assets/svg/busy-icons-svg/preson-stairs.svg\";s:64:\"a5dd0399d7164ee38f6710814fbdb865b194db823125cc1c8e743b197ca0c2be\";s:51:\"public/assets/assets/svg/busy-icons-svg/printer.svg\";s:64:\"a6466afb429238ebc3d76c2ca4a80ab1003d72500f8c9f9e0ac64697d472428e\";s:51:\"public/assets/assets/svg/busy-icons-svg/profile.svg\";s:64:\"bbf828f1db18d6864c8f0912bf1435e5445b9197a52ebb84bb9c8781c57897f2\";s:49:\"public/assets/assets/svg/busy-icons-svg/pulse.svg\";s:64:\"b75281bd8ce9b87b83cc011cbd0be2824a329b223460e22342b7f8ee33e26599\";s:50:\"public/assets/assets/svg/busy-icons-svg/puzzle.svg\";s:64:\"da73a3f5c1c47891192248be7e0c5956b09182e9169ed5faedf433dbe47349a5\";s:49:\"public/assets/assets/svg/busy-icons-svg/quill.svg\";s:64:\"7aaca04298535c2d7a1bdd45cb4c419d3591aae9795f7dd30799a148865f44d2\";s:51:\"public/assets/assets/svg/busy-icons-svg/recycle.svg\";s:64:\"f1b8568e2346e8bf54ca754ceaf9a2aacf603e4b7dbb83584599c968dde890b1\";s:50:\"public/assets/assets/svg/busy-icons-svg/rocket.svg\";s:64:\"3c7ab5bba299bc8c4028e9094bb006322073b1e3842d1e5cb0481dbb6504b7c6\";s:51:\"public/assets/assets/svg/busy-icons-svg/rocket2.svg\";s:64:\"895ac6b2f0f1fee5d0a1fcdd5a72cfa6eca699dbc751ca63f629a045fbafd530\";s:49:\"public/assets/assets/svg/busy-icons-svg/ruble.svg\";s:64:\"a499338e8c305ad7744ab7b8a5f7b1e8ba49093d3ac1dfce7554a5aa3c22fb40\";s:59:\"public/assets/assets/svg/busy-icons-svg/ruler-compasses.svg\";s:64:\"7aeda665f61f4f5e4c6945eb9ce4cf5dbcf507a1d5de1a45b9dcc532c215d98b\";s:48:\"public/assets/assets/svg/busy-icons-svg/safe.svg\";s:64:\"34bc63f91fb49f814f0fd09537b5d73e9a9cd81d52a7e1edf255513bac27fa0f\";s:53:\"public/assets/assets/svg/busy-icons-svg/sale-sign.svg\";s:64:\"1c2cda9413f0c16c741dd4dd9030a1f6368431fca2f79e1cae34b6a5b2153a20\";s:58:\"public/assets/assets/svg/busy-icons-svg/satellite-dish.svg\";s:64:\"1a60cfcb728880bcbad110822b2ef47022bb277c4f60ac1af62b851ba3bab623\";s:50:\"public/assets/assets/svg/busy-icons-svg/scales.svg\";s:64:\"e98f27601c7bf2b26c65b91d32685190067fd5d6526f338a4012c3f74a0c2443\";s:52:\"public/assets/assets/svg/busy-icons-svg/scissors.svg\";s:64:\"a7f5670a9ef41c3d9f79af9db757883d3d3f7a0ac96ecd371a2837293e3cf450\";s:52:\"public/assets/assets/svg/busy-icons-svg/security.svg\";s:64:\"06deced612a11efae6f28bf4540ce2ef26061531693d2d711f3ec56d0a8c163f\";s:48:\"public/assets/assets/svg/busy-icons-svg/send.svg\";s:64:\"51c0609ab249da6bffd6172411d4f54e2ade61ebe8e1dd47b14682fbb3502049\";s:50:\"public/assets/assets/svg/busy-icons-svg/shield.svg\";s:64:\"2eb30baf95710c0dce408c58853d85a336c33aae414ac5033e9828d4905645da\";s:57:\"public/assets/assets/svg/busy-icons-svg/shopping-cart.svg\";s:64:\"d21f541a18ae17c2633244386b44ceffd4f1f7892bd534bee162e030b9f95b8a\";s:48:\"public/assets/assets/svg/busy-icons-svg/sign.svg\";s:64:\"510a9f1b6ea6d6ee934c7a742ab71a88839e639772f517538f4b333c591ee253\";s:60:\"public/assets/assets/svg/busy-icons-svg/smartphone-chart.svg\";s:64:\"bbb60cd54eb599eba1da9da38345976d96ae45aa889d3a543df458efb14fa349\";s:66:\"public/assets/assets/svg/busy-icons-svg/smartphone-exclamation.svg\";s:64:\"623c758b2b2e133a829c9f71b1cdec1e416feba138aef2f18ce884afe041c405\";s:60:\"public/assets/assets/svg/busy-icons-svg/smartphone-gears.svg\";s:64:\"71357355e6adc99f4ca784fc7a90efc42e59cb3cf1c4650ed4c95bd4fb3ea2e4\";s:61:\"public/assets/assets/svg/busy-icons-svg/smartphone-growth.svg\";s:64:\"e8304805928fb6554933542e2e79c7ed99d14ad9682ccbb17ae5ab0cb95d4e8e\";s:60:\"public/assets/assets/svg/busy-icons-svg/smartphone-money.svg\";s:64:\"436a1812c338cb7ab5f874c82501f8430135da3e201f5fe7d9da1c7ac6750577\";s:59:\"public/assets/assets/svg/busy-icons-svg/smartphone-user.svg\";s:64:\"9d946ff5f81edb4fdad3f06362af882e6219c80342e511933b67a0d3c160a7a1\";s:54:\"public/assets/assets/svg/busy-icons-svg/smartphone.svg\";s:64:\"ddf8fb992b4e5a96be559dd89b957f5a4814f33f06185bc74085bd78dd6e684c\";s:51:\"public/assets/assets/svg/busy-icons-svg/speaker.svg\";s:64:\"ae7458c4084ee69296e1254b5a9e0535ce8b2724e4499a9fcf073085c9b2a14c\";s:53:\"public/assets/assets/svg/busy-icons-svg/speaker02.svg\";s:64:\"dc0b16be1203daca54ac680380edfca63e51c17ea7ee1e21e956665a73f694c5\";s:57:\"public/assets/assets/svg/busy-icons-svg/speech-bubble.svg\";s:64:\"ae1f13b974973f1ffcbe649c1ffd45d7580c6e2dbf660bb1bdde2007eda0fd91\";s:49:\"public/assets/assets/svg/busy-icons-svg/stamp.svg\";s:64:\"f4ae3938ce0727bccc0eb8d74ab07f0a11ed9c8ae55347d9460865bf93ffc4b4\";s:48:\"public/assets/assets/svg/busy-icons-svg/star.svg\";s:64:\"6b1d65864e10c126b58783fc389bd58ddb0e52658650d34d721c9aaead94e295\";s:58:\"public/assets/assets/svg/busy-icons-svg/steering-wheel.svg\";s:64:\"363524229afedca47072895f78f2fb4e34283d6e05d323e98bec4699a93dee84\";s:54:\"public/assets/assets/svg/busy-icons-svg/strategy03.svg\";s:64:\"82ccf78ae3c84978440944cbbd0a6b9911b18b5ebb659745a9e092e6a61cef24\";s:53:\"public/assets/assets/svg/busy-icons-svg/strategy1.svg\";s:64:\"7326329ae56d2640845e7ffc7f01023a1b315483ea09177fe7525d43c189247e\";s:53:\"public/assets/assets/svg/busy-icons-svg/strategy2.svg\";s:64:\"1fa7692c2c42d437e0379cef665c79cc95f2edfab9b1d96d256bf48e1be0cd56\";s:58:\"public/assets/assets/svg/busy-icons-svg/support-person.svg\";s:64:\"99ca5a7deced71030dfa4d6b1cdea6f063c0b91f51b0fa8e8c7facce64dc1734\";s:58:\"public/assets/assets/svg/busy-icons-svg/tablet-article.svg\";s:64:\"7f8877e8ba47b464729a87fb2f1fc0b51da04eeb0010154fc92f616497e33da5\";s:56:\"public/assets/assets/svg/busy-icons-svg/tablet-chart.svg\";s:64:\"4bc390886fd8aea0da9dfcf026e9869fd40f27b11784ae743f566b8e1f6a1b7d\";s:57:\"public/assets/assets/svg/busy-icons-svg/tablet-chart2.svg\";s:64:\"8e836b6e5c59b2191c5d7c712e5218e5f6aa180585ec75cedd6baac536d8de44\";s:57:\"public/assets/assets/svg/busy-icons-svg/tablet-chart3.svg\";s:64:\"9b0975383962fd2d67f6a744d39a91a7a15aa7872c79965b0c840d7dc0dc7458\";s:60:\"public/assets/assets/svg/busy-icons-svg/tablet-pie-chart.svg\";s:64:\"772810bed7f4b1ca99cbb41689d2433a390a978327b0fcd6367dfe6a9cdf65d6\";s:61:\"public/assets/assets/svg/busy-icons-svg/tablet-pie-chart2.svg\";s:64:\"f94a8849e9078b9d000414d1a245d8cbf4c5d414c98ca5dfee3418d8eced6bd2\";s:50:\"public/assets/assets/svg/busy-icons-svg/tablet.svg\";s:64:\"1c861ca4f53575d5ca1498bed7d790517bc1ba88208bad641e820734dc8410f5\";s:50:\"public/assets/assets/svg/busy-icons-svg/target.svg\";s:64:\"f1dfd07fad7b1cffeb96ca740284f1a9688ce9a38ac1e580a7c11047cdcb598a\";s:48:\"public/assets/assets/svg/busy-icons-svg/team.svg\";s:64:\"6be39c6dd55d1a6765d6bf4a79e9f99acafadbed4c197817a7753b2feeacaafd\";s:53:\"public/assets/assets/svg/busy-icons-svg/telescope.svg\";s:64:\"76bbd60ebfe84d76a2c5c8f42d141103600684fedab9ef254d49581f48a3bd8b\";s:47:\"public/assets/assets/svg/busy-icons-svg/tie.svg\";s:64:\"6617dd1d3ff8f6170c975e88e3437198c93842a6404d38d3c77558da30e05dd5\";s:49:\"public/assets/assets/svg/busy-icons-svg/tools.svg\";s:64:\"5c79172cec45b7cf3e7575a17baf34d179cf8eee30ac8b868551e2b11d975901\";s:50:\"public/assets/assets/svg/busy-icons-svg/tools2.svg\";s:64:\"2804887b62e19a764ff2f874788e674b6c1d839bb239986e19cf75e0daf10d24\";s:53:\"public/assets/assets/svg/busy-icons-svg/trash-bin.svg\";s:64:\"a2b5ea1ed18e28f885d4a8c53e86ebdb40d5424bd090ef775b4c090e6adb7e50\";s:52:\"public/assets/assets/svg/busy-icons-svg/umbrella.svg\";s:64:\"090f0ce96965afe869455144c43a9a9113a3e024030b815688e8db1fa145ff48\";s:50:\"public/assets/assets/svg/busy-icons-svg/user01.svg\";s:64:\"62c21dba871eb013cbb8ba6291a5fb7eb4639a99bdefebd5ef55c849c2b96fea\";s:50:\"public/assets/assets/svg/busy-icons-svg/user02.svg\";s:64:\"d7fa7961eed76cdc402259d4da6cd46d3fc20a7382698e3c5987f74aa1d1af2a\";s:50:\"public/assets/assets/svg/busy-icons-svg/user03.svg\";s:64:\"13a315390826723c9f269458dfcd44e25e42f46e8aec90e7f820335a97995947\";s:50:\"public/assets/assets/svg/busy-icons-svg/user04.svg\";s:64:\"c7c3025901bf18dc4f1c51da55c6235f907eff4e1adb0a1d31a4bfc8604645ff\";s:50:\"public/assets/assets/svg/busy-icons-svg/user05.svg\";s:64:\"bf6067f0709a7efe8c61f6a489b49f5e69e487fa94fbfde329f716e172913fff\";s:50:\"public/assets/assets/svg/busy-icons-svg/user06.svg\";s:64:\"b8d37fee29053a2ddf9cd4ccd300c4f20ca65b5b3775e892fa2e648fefabdce3\";s:50:\"public/assets/assets/svg/busy-icons-svg/user07.svg\";s:64:\"19f99034bea0833d087bde20f7f0e63bb0efdd00050d969df7abc79022928316\";s:50:\"public/assets/assets/svg/busy-icons-svg/user08.svg\";s:64:\"d114513c3923fe8bb4cf12f29d5a665968754fc2125814b138fc1804485f22be\";s:50:\"public/assets/assets/svg/busy-icons-svg/user09.svg\";s:64:\"b8ce9bc6c29a53f12e15804683b721042aa7d4e73202c3e26a87121503624e86\";s:49:\"public/assets/assets/svg/busy-icons-svg/users.svg\";s:64:\"f56e0f7612bd86af4765b64d4310ecae8845cd0864c01d6f71e80440b8d3f8af\";s:56:\"public/assets/assets/svg/busy-icons-svg/venn-diagram.svg\";s:64:\"564dac74a353d82b3e8c51ca402f61aaf553ff4fcc086fb1ce70caef3ec09b95\";s:50:\"public/assets/assets/svg/busy-icons-svg/wallet.svg\";s:64:\"6bb34ae5c42a4233c1f817bd342e95ba2e6f025c571a1d7a676db31e1b7dcf21\";s:50:\"public/assets/assets/svg/busy-icons-svg/wrench.svg\";s:64:\"221cd9fa62623a232f7ab1d39af1cc51f21ba11050124a5738c827bbb5282f57\";s:47:\"public/assets/assets/svg/busy-icons-svg/yen.svg\";s:64:\"05717ee216465b10eec28ab4554cfc877940fcf9c8b9ce3ceb99cde7d7feac30\";s:51:\"public/assets/assets/svg/busy-icons-svg/yinyang.svg\";s:64:\"b41f7517201cf50ca526f32c3ece161ab0222f5101ae5f4d87d1896c375d40b3\";s:59:\"public/assets/assets/svg/communication/ic_business_24px.svg\";s:64:\"8e9c8f7a170c7c8e31e3f3e2012a8e9d8ba63e99617b9e2f5a6064ab52ec89c2\";s:55:\"public/assets/assets/svg/communication/ic_call_24px.svg\";s:64:\"90e91c5a06d5dd3138b6367236463d917fd7f7114d2e4b50ced8ac4d6bfc7672\";s:59:\"public/assets/assets/svg/communication/ic_call_end_24px.svg\";s:64:\"11ace18d0e7ff57fe1bbfb07094194b905bf6331ece7b8af8895ef96e95569db\";s:60:\"public/assets/assets/svg/communication/ic_call_made_24px.svg\";s:64:\"1cbab97025c30d76fad76ddca2c6ea101edb3b8257e3ffe1d234a89c6078a2a9\";s:61:\"public/assets/assets/svg/communication/ic_call_merge_24px.svg\";s:64:\"d2627e120e5048a0a0e194515378fefa6a4fb8503062df36227142eda186ebec\";s:62:\"public/assets/assets/svg/communication/ic_call_missed_24px.svg\";s:64:\"3958af915677dbf9929160d159508fba9ca77f8354ac597ea857de26d3f1cfdd\";s:71:\"public/assets/assets/svg/communication/ic_call_missed_outgoing_24px.svg\";s:64:\"d60bf801263fecb1353831c5eee084093f0ee0eb564126caf860d699fbb240bf\";s:64:\"public/assets/assets/svg/communication/ic_call_received_24px.svg\";s:64:\"0555e32aeca742372bfc4635051ca7947dad43989f16f63b525667e002c97e93\";s:61:\"public/assets/assets/svg/communication/ic_call_split_24px.svg\";s:64:\"72fddee2be7fd8a07d5b5f431f42c49b603437051caa3d7b72ac69858609a320\";s:55:\"public/assets/assets/svg/communication/ic_chat_24px.svg\";s:64:\"497d821d55b355fa77cf31cccd4333c517800cb7336d9257bdf46b4d47001b70\";s:62:\"public/assets/assets/svg/communication/ic_chat_bubble_24px.svg\";s:64:\"c5e5108c4a54079792345d2b2cd7d85bb6108af15b69ee056aab178278594d16\";s:70:\"public/assets/assets/svg/communication/ic_chat_bubble_outline_24px.svg\";s:64:\"08c08a7ce136523e76b40f1177a76b473f5a110c025e7668afbaa9314ca0a038\";s:60:\"public/assets/assets/svg/communication/ic_clear_all_24px.svg\";s:64:\"35ebb1e4cde6db93402b55d394e4090a21a1258873b8ee2ec64abb7b9e4d7698\";s:58:\"public/assets/assets/svg/communication/ic_comment_24px.svg\";s:64:\"71281f53a2ff6f7c5b7c14e7c4ec73f5be960e86d5266f189e12484c56ddc09d\";s:63:\"public/assets/assets/svg/communication/ic_contact_mail_24px.svg\";s:64:\"5630d82c6ec803237ecce82de4df1e84a1922834981b205e7f27e141231ecf9f\";s:64:\"public/assets/assets/svg/communication/ic_contact_phone_24px.svg\";s:64:\"3444048ce47a065a49c2cf78203f7535357cbd157283521c883eea0b4eb08ccd\";s:59:\"public/assets/assets/svg/communication/ic_contacts_24px.svg\";s:64:\"b8b319399019a871d9939af1414351f8fe192317c17b4ba190eb1f4f8c55ee57\";s:61:\"public/assets/assets/svg/communication/ic_dialer_sip_24px.svg\";s:64:\"5a30b114757aa99c3eb0bb20c1d22780a07840d713102f5b6c0390cbb6f9de58\";s:58:\"public/assets/assets/svg/communication/ic_dialpad_24px.svg\";s:64:\"6ce565cdbda7fb6455fc65f1865d8384084fb92abf502b0bb734022c0072c6f0\";s:56:\"public/assets/assets/svg/communication/ic_email_24px.svg\";s:64:\"36855acaeb73e1543f77500e12a3db813a0cf698a310e337306a9042dcf607ed\";s:56:\"public/assets/assets/svg/communication/ic_forum_24px.svg\";s:64:\"398cec3f2e81b31f36c273fe3610d985f103301925941df0260d09ec85092fd4\";s:66:\"public/assets/assets/svg/communication/ic_import_contacts_24px.svg\";s:64:\"305d9e3fcffd2604d59d4451579522ffac96e056401c0d394364ec364fc9175a\";s:64:\"public/assets/assets/svg/communication/ic_import_export_24px.svg\";s:64:\"fc0aabe8f8324ce4fee59499955cebbf101c54efd8e04995e0421016b0456c05\";s:68:\"public/assets/assets/svg/communication/ic_invert_colors_off_24px.svg\";s:64:\"33fc642acc55e516f22281809379b2d5eeec77547c9b5c6e2032761b32e398e0\";s:60:\"public/assets/assets/svg/communication/ic_live_help_24px.svg\";s:64:\"8caa502e5d1d86c43b8703d5d728b63ac57c3e1e5bb6827254372315e5c03ad4\";s:63:\"public/assets/assets/svg/communication/ic_location_off_24px.svg\";s:64:\"568e4e7e3fd70f39f261abfe0b0823fab530a32d63f0e0ce494ffaaf3d9a405b\";s:62:\"public/assets/assets/svg/communication/ic_location_on_24px.svg\";s:64:\"b989d3c8cfe19edd295378071c23de9c787cbc6ee66cc6a83023968837d0a88f\";s:63:\"public/assets/assets/svg/communication/ic_mail_outline_24px.svg\";s:64:\"e6bb13a283ab6f8060f55c00c4549687059070c6eeb9ade05e567fbedb96267a\";s:58:\"public/assets/assets/svg/communication/ic_message_24px.svg\";s:64:\"f1065e5ead5aeab0c17fd928b10015670071593da73659f6d9e2b142fab9c379\";s:57:\"public/assets/assets/svg/communication/ic_no_sim_24px.svg\";s:64:\"25b950b67877899a82b30ea0067a2cb40c3d55c37d006546a9c4dd41c2903b91\";s:56:\"public/assets/assets/svg/communication/ic_phone_24px.svg\";s:64:\"90e91c5a06d5dd3138b6367236463d917fd7f7114d2e4b50ced8ac4d6bfc7672\";s:66:\"public/assets/assets/svg/communication/ic_phonelink_erase_24px.svg\";s:64:\"a9ef1b4cfe564cb289efca71dfa3b9b18007c869eceeed790d130d043b3d55c7\";s:65:\"public/assets/assets/svg/communication/ic_phonelink_lock_24px.svg\";s:64:\"7bbdfa9da1819039090777f7d0296563c2ddceb007ae4abd57895e102409cad4\";s:65:\"public/assets/assets/svg/communication/ic_phonelink_ring_24px.svg\";s:64:\"2fe361a924220c2e138d8a6a89f220adaf0ce7b4fedc8c41d2c6fa11c38a7375\";s:66:\"public/assets/assets/svg/communication/ic_phonelink_setup_24px.svg\";s:64:\"088c98912def478fd332141e5c106debeffac34bd871362536cbae100256ff34\";s:68:\"public/assets/assets/svg/communication/ic_portable_wifi_off_24px.svg\";s:64:\"dbbc53a77e41355df1a39432ba581564426d62432c954f42cddcefd0689e39a2\";s:65:\"public/assets/assets/svg/communication/ic_present_to_all_24px.svg\";s:64:\"c72c408c2ae774cdb8c28049d6402bc7bb3aea74d44512f69c840811dfaf9c1c\";s:62:\"public/assets/assets/svg/communication/ic_ring_volume_24px.svg\";s:64:\"72a4ccd0cdc1be9501c77a27a436d7d45992296e02d195c8453322a02d0aa0a0\";s:63:\"public/assets/assets/svg/communication/ic_screen_share_24px.svg\";s:64:\"6258e87733e230d4e63068e249d49ae9080b812480a8f00d900925c4c19ece00\";s:64:\"public/assets/assets/svg/communication/ic_speaker_phone_24px.svg\";s:64:\"c0339d2ea91e6d2acd1d26ce0e35792b8217d82b7653fb1b3a4d80b38c47aad8\";s:73:\"public/assets/assets/svg/communication/ic_stay_current_landscape_24px.svg\";s:64:\"56ab6c7c1e8243657ca6bab8c22606c9c2914fa4b92622e9602f057fa885dc7d\";s:72:\"public/assets/assets/svg/communication/ic_stay_current_portrait_24px.svg\";s:64:\"88d265a414a3a15831054138c85d825fa6dcaa1a480af4f7b6cb7b9c2a7e3a35\";s:73:\"public/assets/assets/svg/communication/ic_stay_primary_landscape_24px.svg\";s:64:\"56ab6c7c1e8243657ca6bab8c22606c9c2914fa4b92622e9602f057fa885dc7d\";s:72:\"public/assets/assets/svg/communication/ic_stay_primary_portrait_24px.svg\";s:64:\"88d265a414a3a15831054138c85d825fa6dcaa1a480af4f7b6cb7b9c2a7e3a35\";s:68:\"public/assets/assets/svg/communication/ic_stop_screen_share_24px.svg\";s:64:\"311e33ba314d0febbe4ecea61a5a60731c8256aa902c2f91cd8c5fdf8b7f5eed\";s:61:\"public/assets/assets/svg/communication/ic_swap_calls_24px.svg\";s:64:\"4aaa62e95a6f53fd42cebe746f04c88224307f0148c6a9d4baf2bcd0b5676b7a\";s:58:\"public/assets/assets/svg/communication/ic_textsms_24px.svg\";s:64:\"df528d71ba49e60b247601e7d24dd171f3d803e978b4615e0e01a16a6ec1bcf7\";s:60:\"public/assets/assets/svg/communication/ic_voicemail_24px.svg\";s:64:\"4e95370e260b0f85bb36ae4aad1b3ee14deed1860af41532e0268550f2ad4a9a\";s:58:\"public/assets/assets/svg/communication/ic_vpn_key_24px.svg\";s:64:\"fbc7f1e13ede896120574dfe8e41fde4a42e493fccbe695a7cc4a5e892399fc8\";s:48:\"public/assets/assets/svg/content/ic_add_24px.svg\";s:64:\"4dc5547840d699651cf7d3059a91d575cddaf80451ab85a7c41ed1d7c7998b24\";s:52:\"public/assets/assets/svg/content/ic_add_box_24px.svg\";s:64:\"f62e8deb85a226dafc4e73ae8c6506451186bbf09c55acebeca15f5bbe417baf\";s:55:\"public/assets/assets/svg/content/ic_add_circle_24px.svg\";s:64:\"cfacf4398f71468c3a3b08eb0babd0ab121fbac981d017a3a5ea135472557d77\";s:63:\"public/assets/assets/svg/content/ic_add_circle_outline_24px.svg\";s:64:\"af03d496ca3677e7b741fbe9c3803c685b542dd82eba1eeccff0f7d5c8e126a9\";s:52:\"public/assets/assets/svg/content/ic_archive_24px.svg\";s:64:\"950ba84b916dd0d34d6eb040fe6a4360797d58e64a6f1885a1da840c0f90c330\";s:54:\"public/assets/assets/svg/content/ic_backspace_24px.svg\";s:64:\"1ec236e72ee705bf70eb29a2613499a1da4aa413d987673115e55874d8869a0c\";s:50:\"public/assets/assets/svg/content/ic_block_24px.svg\";s:64:\"47abe59201834a5ff2d5ac562c891a346ab3ff2952555844940f343587fcd57b\";s:50:\"public/assets/assets/svg/content/ic_clear_24px.svg\";s:64:\"6d4ccf520d400755057a1739a66c0feda3c98bbc34e8e7f79afa630b2e43f87e\";s:57:\"public/assets/assets/svg/content/ic_content_copy_24px.svg\";s:64:\"fa4ad2661739c9ecefa121c41f5c95de878d4990ee86413124585a3af7d7dffb\";s:56:\"public/assets/assets/svg/content/ic_content_cut_24px.svg\";s:64:\"df484339f6dc6092c32d1434b407673818fbffcc6a9400936af897be07989cfa\";s:58:\"public/assets/assets/svg/content/ic_content_paste_24px.svg\";s:64:\"6ee126c4f729d61c571d0514a52628c74046f6fcc405fb929e0eadc3673b0a5f\";s:51:\"public/assets/assets/svg/content/ic_create_24px.svg\";s:64:\"e421babfbbe69cd7e72fca2b85774b26ec4c9557384b9a3bbfb3d3cef031b4a0\";s:51:\"public/assets/assets/svg/content/ic_drafts_24px.svg\";s:64:\"53b24844172c2992f84c453929a90cde6595a103e4a0c32d8ea05b6fbeca86e9\";s:56:\"public/assets/assets/svg/content/ic_filter_list_24px.svg\";s:64:\"62517f12ccdaef9d5ffe156d7acff9b9a845c8f48e00eacfe6a9b3d8f8299265\";s:49:\"public/assets/assets/svg/content/ic_flag_24px.svg\";s:64:\"cbb30ec622923b6e0442d67277e30eaa1ba429223b132fde3289d125f2c62c88\";s:58:\"public/assets/assets/svg/content/ic_font_download_24px.svg\";s:64:\"94e8a2cd9b85df173be7f3a8212f5d144592e119a8257f724454b02ded4586a6\";s:52:\"public/assets/assets/svg/content/ic_forward_24px.svg\";s:64:\"463ebcb207246b8f41745085176d0bf277bd253351b3bd8f50e176f1334f928a\";s:52:\"public/assets/assets/svg/content/ic_gesture_24px.svg\";s:64:\"7b5dce0c1c0ad0562037b69bd70dea6942e82ca0bd9e9e4b5ed644d6b2766946\";s:50:\"public/assets/assets/svg/content/ic_inbox_24px.svg\";s:64:\"5b6064c5f8b2a04da2414b5d56e9a07f0f327b12b90918363bab94483c654bc6\";s:49:\"public/assets/assets/svg/content/ic_link_24px.svg\";s:64:\"76f4817ff3dc15862585d0f79b491f64c87d836b4c9216cb1be783e2ba714f06\";s:49:\"public/assets/assets/svg/content/ic_mail_24px.svg\";s:64:\"36855acaeb73e1543f77500e12a3db813a0cf698a310e337306a9042dcf607ed\";s:55:\"public/assets/assets/svg/content/ic_markunread_24px.svg\";s:64:\"36855acaeb73e1543f77500e12a3db813a0cf698a310e337306a9042dcf607ed\";s:58:\"public/assets/assets/svg/content/ic_move_to_inbox_24px.svg\";s:64:\"73868a7847e8126a3048015e32069324eb7097ae25b4eeeda6051366990e6846\";s:54:\"public/assets/assets/svg/content/ic_next_week_24px.svg\";s:64:\"80e242a0806debd1939746808921205e5208be7c67278f98fa3ea7a479a11540\";s:49:\"public/assets/assets/svg/content/ic_redo_24px.svg\";s:64:\"07548d839167082f7cf924130cbd4785816679872b4ad7fcbe216dd2107f10eb\";s:51:\"public/assets/assets/svg/content/ic_remove_24px.svg\";s:64:\"d7b1b4b4e65bc4d62714b3bc9d5183978389e64995ebca75ea6d4773ff6e17ce\";s:58:\"public/assets/assets/svg/content/ic_remove_circle_24px.svg\";s:64:\"8cdf4cce2be9bd306a573d48305391e2824d4fec2d8ab84795ba86e2f7be70e8\";s:66:\"public/assets/assets/svg/content/ic_remove_circle_outline_24px.svg\";s:64:\"6f7c0be01433d939fc6364cf1903ba390f11b5e7cdebb9a03f84b585ae4ec5a1\";s:50:\"public/assets/assets/svg/content/ic_reply_24px.svg\";s:64:\"bdae829ba44f83def0e28955b3290e9bcb99ad14886de70c21113f865a0566fd\";s:54:\"public/assets/assets/svg/content/ic_reply_all_24px.svg\";s:64:\"76795b312b3e927150b209bbdc67a93627ea906c5b6faf7a87d87d6aef24eff2\";s:51:\"public/assets/assets/svg/content/ic_report_24px.svg\";s:64:\"53a051dd6b0b1ac7eda3d88a95484d5b3122f2faa62a978c3c8313a054e0bf10\";s:49:\"public/assets/assets/svg/content/ic_save_24px.svg\";s:64:\"47bb956e475240ebad8d42df4e355340ef8c16aafddcebfa57f1d2890deac775\";s:55:\"public/assets/assets/svg/content/ic_select_all_24px.svg\";s:64:\"027c27edc3f9aeeea50e523dbe66a003ba716053d473c6eea2552c9773acaa2c\";s:49:\"public/assets/assets/svg/content/ic_send_24px.svg\";s:64:\"04566e9523723adf734dbc9dc3547b4adb71cbca596d5595535c951d4fae2b79\";s:49:\"public/assets/assets/svg/content/ic_sort_24px.svg\";s:64:\"c4434ace1d68a1c914f5f20cbcadb26e90066f6ae2b810677478399a6fa0ab1a\";s:56:\"public/assets/assets/svg/content/ic_text_format_24px.svg\";s:64:\"eca0608ef6db59934ecbd41ecbb5fbf6b3f5307d42ea625a7f027edd50ba49ae\";s:54:\"public/assets/assets/svg/content/ic_unarchive_24px.svg\";s:64:\"3294e48df5efcd880819794eaefdeb5ef567a4f5b6069b7d755faf7d9bb719d1\";s:49:\"public/assets/assets/svg/content/ic_undo_24px.svg\";s:64:\"b7356672bcd0d369d104c11020eee2d798bd416bf903e37ab10144079583df57\";s:52:\"public/assets/assets/svg/content/ic_weekend_24px.svg\";s:64:\"4067f2b7e603d744cb3829c4484f4d6f526cb2ccaf3d5c7873fa8b7372b83389\";s:56:\"public/assets/assets/svg/device/ic_access_alarm_24px.svg\";s:64:\"f5bb2755fe1c016cea33c93d636299a87e6f944591a13ee9528916a119ad6251\";s:57:\"public/assets/assets/svg/device/ic_access_alarms_24px.svg\";s:64:\"fd9ff1e1b11f0f537a664ab0e6d14c911ca48e184ae9b3073a99f33fa019aa23\";s:55:\"public/assets/assets/svg/device/ic_access_time_24px.svg\";s:64:\"c62263947febeef13f89926ef5a05b0eda6aeec920681de2af86ef07a1180bb3\";s:53:\"public/assets/assets/svg/device/ic_add_alarm_24px.svg\";s:64:\"2506b8f9a82a215ed55397fc4bc604e7b801c3b2ba6eccaeee4645e258e8855b\";s:63:\"public/assets/assets/svg/device/ic_airplanemode_active_24px.svg\";s:64:\"e36f1d063cc9ae3c0acd5b63cd747185b1ccbb0a4c9b571a235fe654b1a213b1\";s:65:\"public/assets/assets/svg/device/ic_airplanemode_inactive_24px.svg\";s:64:\"2991bf185c43de233a9649f1433bd53e52ef5ff8a737ad91e4548bbd03daffae\";s:54:\"public/assets/assets/svg/device/ic_battery_20_24px.svg\";s:64:\"daf99ac73179b17a96c65a7bcfc981419f21ca94c80cf23945afc7c66aa21ffd\";s:54:\"public/assets/assets/svg/device/ic_battery_30_24px.svg\";s:64:\"234c3c1d1442abdeecf225610d1a7e6ed53c69f017d1cd80571b273f0a56ffff\";s:54:\"public/assets/assets/svg/device/ic_battery_50_24px.svg\";s:64:\"915ebc9b80b4ba44814d95d061c825a7e6a9480771f074c0dfec019b0eb87de6\";s:54:\"public/assets/assets/svg/device/ic_battery_60_24px.svg\";s:64:\"f4cdca80372775f54244efb3d808a1df2d1b750aa84625b873e55843cb19ffe9\";s:54:\"public/assets/assets/svg/device/ic_battery_80_24px.svg\";s:64:\"d037ca180916cdefd0e20b2009cc48ae7c6a80f8cb768ab70e83f5e3ffd213cd\";s:54:\"public/assets/assets/svg/device/ic_battery_90_24px.svg\";s:64:\"d05dcc86a728bea59be9b88260ce634faa97af7cd118954a84cc0c7f3e857b20\";s:57:\"public/assets/assets/svg/device/ic_battery_alert_24px.svg\";s:64:\"aafdb7c23ddfe5048dcc3aadb9dffac00cffce51d2e51b90d716c2bbdcf8cde7\";s:63:\"public/assets/assets/svg/device/ic_battery_charging_20_24px.svg\";s:64:\"b9e4cfd1e3e628b66347ecd23de88175e5996eabc6c3969a3dc74fe5d1b20a23\";s:63:\"public/assets/assets/svg/device/ic_battery_charging_30_24px.svg\";s:64:\"1416623d138ecbd5702f1a288273220bbd53898754423d35777bf6cba4e47c70\";s:63:\"public/assets/assets/svg/device/ic_battery_charging_50_24px.svg\";s:64:\"d3734d1839ba5a8aeed21d1671c314f4438daa31ff982f7d2867ee058029379e\";s:63:\"public/assets/assets/svg/device/ic_battery_charging_60_24px.svg\";s:64:\"6d7222e70cc42c1fc482ea485f8971aa38d374e68d1797ac6339dd7b3fe1cdde\";s:63:\"public/assets/assets/svg/device/ic_battery_charging_80_24px.svg\";s:64:\"1cf1abbfe3e0fdf77b83cf0b5e672ad67ddd22257583e39259e3059c06f97634\";s:63:\"public/assets/assets/svg/device/ic_battery_charging_90_24px.svg\";s:64:\"f2669b04c3bfcc69ab9423ef652edefd8d168d446612c88703b406e6c22976de\";s:65:\"public/assets/assets/svg/device/ic_battery_charging_full_24px.svg\";s:64:\"99a7c5c052878add509e48f9b79c6a13b3c83d401a421af770b505a3a78deb32\";s:56:\"public/assets/assets/svg/device/ic_battery_full_24px.svg\";s:64:\"de631b4f54ba7b2e10092bf54be5f85c1542e1ba4ed8ea16a6f64d3f24a2a467\";s:55:\"public/assets/assets/svg/device/ic_battery_std_24px.svg\";s:64:\"de631b4f54ba7b2e10092bf54be5f85c1542e1ba4ed8ea16a6f64d3f24a2a467\";s:59:\"public/assets/assets/svg/device/ic_battery_unknown_24px.svg\";s:64:\"5d76d11e0a35c4ad0e92ab7d8c30c8d45ee9eff4f52560f755507f8657bd6d70\";s:53:\"public/assets/assets/svg/device/ic_bluetooth_24px.svg\";s:64:\"d2fb69008a07f1aab59b32e2c46ff833af9c3590364040137c35318e1fa6b640\";s:63:\"public/assets/assets/svg/device/ic_bluetooth_connected_24px.svg\";s:64:\"af8eb9315f3fb87ca86624c391a1eed597d0f7b4aebab1cf629b80bdd30d6cd5\";s:62:\"public/assets/assets/svg/device/ic_bluetooth_disabled_24px.svg\";s:64:\"37c16976af009d9a52f64d9c017875a7e7d82eff9f5cba7bb07d0c4c4155e600\";s:63:\"public/assets/assets/svg/device/ic_bluetooth_searching_24px.svg\";s:64:\"e6cc41bdf18f24f7f9dd00899ebc5e91e10268b2ec4c5426e84fc6b99539c27a\";s:59:\"public/assets/assets/svg/device/ic_brightness_auto_24px.svg\";s:64:\"4a74c4d2e8df52092b29017480ad9fc0f289228d473abc5e32c1e3e3bf410f7f\";s:59:\"public/assets/assets/svg/device/ic_brightness_high_24px.svg\";s:64:\"e9d4d6f8f068e875bb94666332c9e2d273a806028c5df9f64065d062917a6aad\";s:58:\"public/assets/assets/svg/device/ic_brightness_low_24px.svg\";s:64:\"d0655c2f58d3fd47c4f5bda9efcd64845e695c357221dbe97a82343585f01bc9\";s:61:\"public/assets/assets/svg/device/ic_brightness_medium_24px.svg\";s:64:\"7b248a3f7cd27cd31575fa060235a702e2daaf51490a173413e5a4ea90f9df68\";s:54:\"public/assets/assets/svg/device/ic_data_usage_24px.svg\";s:64:\"d90d02cae59b4f30ff2880a4b616ab36e2d1c6791862955ec1fac51865a32d86\";s:58:\"public/assets/assets/svg/device/ic_developer_mode_24px.svg\";s:64:\"15f55ab75c38b7bc6e52885534b4fe6d0be2b5a2aa649bcc46cc97e93416403a\";s:51:\"public/assets/assets/svg/device/ic_devices_24px.svg\";s:64:\"ff603e07968311f66ff514e30cf6f17f5d17d0e80e2b82a1beac4ed28336b30c\";s:47:\"public/assets/assets/svg/device/ic_dvr_24px.svg\";s:64:\"a938e785839b0eecf6c9c519562e2812eccb1bc7f325d62330322c58ef7d01b4\";s:53:\"public/assets/assets/svg/device/ic_gps_fixed_24px.svg\";s:64:\"5067b58e47e1b295b815c4218624d821702892d97e8ad8d6bb75837979a4237e\";s:57:\"public/assets/assets/svg/device/ic_gps_not_fixed_24px.svg\";s:64:\"03b363aa228d4235b9aae00bb270a620ad1f43e2019224ca9270f97f74c97492\";s:51:\"public/assets/assets/svg/device/ic_gps_off_24px.svg\";s:64:\"52ab21c191b6cd60dfd6698f5248b72a5b120cfac80baac792b01f8d686967bb\";s:54:\"public/assets/assets/svg/device/ic_graphic_eq_24px.svg\";s:64:\"10d4f5757f39772fb1dc38507d833fd8db237fee3f1b295832c9d526292009b1\";s:61:\"public/assets/assets/svg/device/ic_location_disabled_24px.svg\";s:64:\"52ab21c191b6cd60dfd6698f5248b72a5b120cfac80baac792b01f8d686967bb\";s:62:\"public/assets/assets/svg/device/ic_location_searching_24px.svg\";s:64:\"03b363aa228d4235b9aae00bb270a620ad1f43e2019224ca9270f97f74c97492\";s:56:\"public/assets/assets/svg/device/ic_network_cell_24px.svg\";s:64:\"077cb5b7683002d0e56dce6537b12977bc3cc8a2862ea21d63bfe55365222f8b\";s:56:\"public/assets/assets/svg/device/ic_network_wifi_24px.svg\";s:64:\"5a3cc3c902b719d6c073c915636c014ae523af9a14fab5e808242593b91fc8b4\";s:47:\"public/assets/assets/svg/device/ic_nfc_24px.svg\";s:64:\"b7eec9a0dcf1822b52ef3640947f416a5780bd463f935089819c4d207c8a1e97\";s:65:\"public/assets/assets/svg/device/ic_screen_lock_landscape_24px.svg\";s:64:\"4a14ebebd9394770f8fd5874da85b18918ac21e229a85d6f55241a9ec7ee2b65\";s:64:\"public/assets/assets/svg/device/ic_screen_lock_portrait_24px.svg\";s:64:\"d46c6719e5d28d3c4a1cb0ba31b0e34ae1214f000bc55ced4f09c156e133e5e1\";s:64:\"public/assets/assets/svg/device/ic_screen_lock_rotation_24px.svg\";s:64:\"572bd34740f075fba2f6a737989ac3727da2038fcb640d3fde397e31e8c2e502\";s:59:\"public/assets/assets/svg/device/ic_screen_rotation_24px.svg\";s:64:\"512ae6aacd7d207730b831cb89892261fcec4816c38c0b6666f86b481b1607ea\";s:54:\"public/assets/assets/svg/device/ic_sd_storage_24px.svg\";s:64:\"9f4cd0b97e1106e9016f54bcc3d02159cd0bf275110575f4d4497fdbbd2936e4\";s:68:\"public/assets/assets/svg/device/ic_settings_system_daydream_24px.svg\";s:64:\"ce4f575730373392aee5f3c82d666607bb49cebcb36f1874b30271366fc06682\";s:65:\"public/assets/assets/svg/device/ic_signal_cellular_0_bar_24px.svg\";s:64:\"e67fb56b0a397005cd49ed351daca53f41d8a4bf8ec26a7bbde963ef4dd50bab\";s:65:\"public/assets/assets/svg/device/ic_signal_cellular_1_bar_24px.svg\";s:64:\"99447279b189a3faca75569c8ecdeb9885f10fcab5c52d103481e8b01759523c\";s:65:\"public/assets/assets/svg/device/ic_signal_cellular_2_bar_24px.svg\";s:64:\"b156564909cedc28daf23bfe74c7b3cd1e077884ede04b6bbb25f273acb8be06\";s:65:\"public/assets/assets/svg/device/ic_signal_cellular_3_bar_24px.svg\";s:64:\"077cb5b7683002d0e56dce6537b12977bc3cc8a2862ea21d63bfe55365222f8b\";s:65:\"public/assets/assets/svg/device/ic_signal_cellular_4_bar_24px.svg\";s:64:\"0291f45ac5714b42bf7976b0dbaaf5bfd1d84491796aee98569589aa99487c6d\";s:87:\"public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_0_bar_24px.svg\";s:64:\"33dc55fc2009777c96594fa074932c1c405d1f353bd3a94b0fead27b477cbabd\";s:87:\"public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_1_bar_24px.svg\";s:64:\"8387d776d369fbda0a0c4d7bacd8635cea6e083e734b84c88ac5223639ad4d4e\";s:87:\"public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_2_bar_24px.svg\";s:64:\"71267f270aa60d93bbcc5cd4197e0e47cfc81a15786506659351cc6f1e5933d0\";s:87:\"public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_3_bar_24px.svg\";s:64:\"c00351c9a798a2bf26ead9c437ff7b978ff37c0baeecb03c9703fdb1ccf2f03b\";s:87:\"public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_4_bar_24px.svg\";s:64:\"a454753182fe9562eb204d551e8616282d31eafe533c90b8f96a48b9d52378ef\";s:66:\"public/assets/assets/svg/device/ic_signal_cellular_no_sim_24px.svg\";s:64:\"25b950b67877899a82b30ea0067a2cb40c3d55c37d006546a9c4dd41c2903b91\";s:64:\"public/assets/assets/svg/device/ic_signal_cellular_null_24px.svg\";s:64:\"b41897c015a953d131095043888be31db9771f25bd46c17e128532a3a10ee738\";s:63:\"public/assets/assets/svg/device/ic_signal_cellular_off_24px.svg\";s:64:\"ad46750af925c186285e3be095c758859f75924fd002aa1ea5cd0647f94f0663\";s:61:\"public/assets/assets/svg/device/ic_signal_wifi_0_bar_24px.svg\";s:64:\"cd4f2b992d85a64554c8b65c968aedb7c52f527ce59d7160f35685ff6f2322eb\";s:61:\"public/assets/assets/svg/device/ic_signal_wifi_1_bar_24px.svg\";s:64:\"a78aa5c5ad303d576b823915c0f3f86eda0cc65bf3c5207e218c240be343d53a\";s:66:\"public/assets/assets/svg/device/ic_signal_wifi_1_bar_lock_24px.svg\";s:64:\"41d06cee38ad6b535805aaec49695a29bd2be975a42dc8f5c892df068ed16064\";s:61:\"public/assets/assets/svg/device/ic_signal_wifi_2_bar_24px.svg\";s:64:\"623415f6ae50c833ac252612964d6705ded76185afaae14d66c6b4f1a261ad25\";s:66:\"public/assets/assets/svg/device/ic_signal_wifi_2_bar_lock_24px.svg\";s:64:\"a06f2095185d6323c17aee514552c14e8b8c7f988d60cc60393b84af06f50a21\";s:61:\"public/assets/assets/svg/device/ic_signal_wifi_3_bar_24px.svg\";s:64:\"5a3cc3c902b719d6c073c915636c014ae523af9a14fab5e808242593b91fc8b4\";s:66:\"public/assets/assets/svg/device/ic_signal_wifi_3_bar_lock_24px.svg\";s:64:\"692d87266675fc2bd7416de2200dd1d00c137301bfc90d8d5cf4b41694e95e9f\";s:61:\"public/assets/assets/svg/device/ic_signal_wifi_4_bar_24px.svg\";s:64:\"ddd369fafe50145f909624a9bbf7ac0c26206f12aca1c7a772a1708a69de99d0\";s:66:\"public/assets/assets/svg/device/ic_signal_wifi_4_bar_lock_24px.svg\";s:64:\"f1440c41e67cf7065b551d26d934227e4a4875e7c9f8f23416e5e876f034e5f5\";s:59:\"public/assets/assets/svg/device/ic_signal_wifi_off_24px.svg\";s:64:\"be0debc91dddaeb8dc14538a91835a906e3a05ce21bced5a309c9e850cee90c7\";s:74:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_1_bar_26x24px.svg\";s:64:\"58040d0c6fb01eba1cd76da0e5919fe27dced262d57a5067647e2c51af4f698e\";s:74:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_2_bar_26x24px.svg\";s:64:\"0e6dc02f60457c6f3696d94ceeec85a7d6f701a98149586a1247fed90a995b45\";s:74:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_3_bar_26x24px.svg\";s:64:\"5214ed6e490b62b4c501d5982aeb78b1afe10c3b6e1381e68253a97215ddb6e5\";s:74:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_4_bar_26x24px.svg\";s:64:\"c447fa69eb8ed961f085d3ed79cb912d7e2a13e933f5fc1e91f3f7367fbd98b3\";s:92:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_1_26x24px.svg\";s:64:\"18f945222bf23b7652c46a37595039c2863e8870497856e0dc08b5f819f8baaa\";s:90:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_26x24px.svg\";s:64:\"05fbaf001fdf008110fc4a19e45213af839f49dac4589b7968a847599750ea3e\";s:92:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_2_26x24px.svg\";s:64:\"88cef206c20102d30d016a30eaa7ad9bd1a2b8bab5db85cf25a008ef5c67e503\";s:92:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_3_26x24px.svg\";s:64:\"4829132f98bf4e5eb2c0d2b06da2aee42c3139b75050a4a1c550f05510e11783\";s:92:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_4_26x24px.svg\";s:64:\"0897b454494ca8e31457cf0f4318f0f5964877fb5ec09b5d233849d179b4b896\";s:82:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_not_connected_26x24px.svg\";s:64:\"882282c4d2ed48752474f640057602c5341fc32c36af52f2b370365ff9572e01\";s:73:\"public/assets/assets/svg/device/ic_signal_wifi_statusbar_null_26x24px.svg\";s:64:\"6745d4ec5917307dc2c5fd830d0728de8edc984bd1a83c8722ba0bb6533c67dd\";s:51:\"public/assets/assets/svg/device/ic_storage_24px.svg\";s:64:\"be32e6b9b8336d50c8115b9307280632b12006a92c7ee01e94ea9da60d6eb557\";s:47:\"public/assets/assets/svg/device/ic_usb_24px.svg\";s:64:\"8ffa7d6ac212b14fc3f4c3472ecd9261a298d14556366e97ecf9038b0413bba3\";s:53:\"public/assets/assets/svg/device/ic_wallpaper_24px.svg\";s:64:\"fe1b2934ba8e893fd8c616735b656039df8f17f9d94ff881d2fbe46169ba44d8\";s:51:\"public/assets/assets/svg/device/ic_widgets_24px.svg\";s:64:\"d097d13f77328fd8bede89c1badd498d9c7d46a1d025b251513ebd08164aa115\";s:53:\"public/assets/assets/svg/device/ic_wifi_lock_24px.svg\";s:64:\"257a347b1789eaa2878c50c39fd482b7c68c88f9120b83a8b838c8299a2c6a24\";s:58:\"public/assets/assets/svg/device/ic_wifi_tethering_24px.svg\";s:64:\"db7441d890d7fa2ed7ad3c01f1a5cbc55de01396bb6ce583ddf778903c8d1859\";s:55:\"public/assets/assets/svg/editor/ic_attach_file_24px.svg\";s:64:\"5dd22e10298cd409ffe4eba9dbf4560baf11887efc8fc69eb321cdf7bda0b3a6\";s:56:\"public/assets/assets/svg/editor/ic_attach_money_24px.svg\";s:64:\"de89a4828ec1f5681b5b3848819622cd65f685ae715d44555f34ab78f867657e\";s:54:\"public/assets/assets/svg/editor/ic_border_all_24px.svg\";s:64:\"ef682b811a6e8b455a1b2384d802c771318963abe093f6cf0483e352695bfa3f\";s:57:\"public/assets/assets/svg/editor/ic_border_bottom_24px.svg\";s:64:\"843afbed342821ba6ebfea33f574ce766d24ba1456997705cf3af91764c969f4\";s:56:\"public/assets/assets/svg/editor/ic_border_clear_24px.svg\";s:64:\"eab33d8cd525a4ea1f3a4e795d71a5a9e20628dd3a541f0cdafb7a990321fec9\";s:56:\"public/assets/assets/svg/editor/ic_border_color_24px.svg\";s:64:\"2e0722c7f2f7726f17f0ac5f54e9c757a0ddd27144ad7a87737df2de6ca2605e\";s:61:\"public/assets/assets/svg/editor/ic_border_horizontal_24px.svg\";s:64:\"60d07b8b69c2685f56a494bef06b7975a6261ce9c0fe2854741d786f60a47fcc\";s:56:\"public/assets/assets/svg/editor/ic_border_inner_24px.svg\";s:64:\"5b1d10c1a3abf2ec5b658f0d39116afbf50236b2c5a653cc0d67df75ad419e52\";s:55:\"public/assets/assets/svg/editor/ic_border_left_24px.svg\";s:64:\"54a452b24c824f9de4d3254448d2537b9256665a527abd69ee679bb3d61eba39\";s:56:\"public/assets/assets/svg/editor/ic_border_outer_24px.svg\";s:64:\"0adcc8c05753808a294828498f7899592bff7d117ee3d4dcaad434ac4e988cb9\";s:56:\"public/assets/assets/svg/editor/ic_border_right_24px.svg\";s:64:\"42ed10ad64ee6ad2f8ed224da6a2920f4053e8cbc9f1b974d04490a2a2ab7205\";s:56:\"public/assets/assets/svg/editor/ic_border_style_24px.svg\";s:64:\"e805faf4325564917774b1e8533c97a3812ef83490ce1fd25c9c0292ee340b82\";s:54:\"public/assets/assets/svg/editor/ic_border_top_24px.svg\";s:64:\"f172d58e3bc661d19ecd580613c13f723c763a0403be1f560bbdf610d73bdbff\";s:59:\"public/assets/assets/svg/editor/ic_border_vertical_24px.svg\";s:64:\"22c5c49a62ce7d9572aef3b0c92dfe8f437133d47242d70edbef7030ec9cafe0\";s:55:\"public/assets/assets/svg/editor/ic_drag_handle_24px.svg\";s:64:\"69d0d02cd6383dc13497c54ca3f78ca567c9d1950d073a212baba0a854a95d38\";s:63:\"public/assets/assets/svg/editor/ic_format_align_center_24px.svg\";s:64:\"d59c5220251fb7d5aa03bdfc7a8254d69dcd979ffbdce01a385ae47db225f1ed\";s:64:\"public/assets/assets/svg/editor/ic_format_align_justify_24px.svg\";s:64:\"ec14e8b0a63668976fb3422ef94220b8e95fdbdf963a9825964e65b5863b548e\";s:61:\"public/assets/assets/svg/editor/ic_format_align_left_24px.svg\";s:64:\"77878ab7bfed61963f388534c9f6906fc8fb7f03bdf9b033b0746d31e9987bf3\";s:62:\"public/assets/assets/svg/editor/ic_format_align_right_24px.svg\";s:64:\"13da283fdfae632966dbfbcaf23c2b649985205f65218dff53a0e17421d00368\";s:55:\"public/assets/assets/svg/editor/ic_format_bold_24px.svg\";s:64:\"ecb8716f2d78ca80edf5e48db912eef1287e0c8dd347c048c6274adcfc01c82c\";s:56:\"public/assets/assets/svg/editor/ic_format_clear_24px.svg\";s:64:\"e74f2a2d9a9ef941ae2c4a3b96438d5a4918daa987381023e07c3b000389ce6f\";s:61:\"public/assets/assets/svg/editor/ic_format_color_fill_24px.svg\";s:64:\"265a49a477901f4f73260226502df82326ffe3639c7fad51006683e673e406c2\";s:62:\"public/assets/assets/svg/editor/ic_format_color_reset_24px.svg\";s:64:\"f28dcc134a2b58e750f732f296460adc3c9be4cbc28f54b5ab47929231deecf7\";s:61:\"public/assets/assets/svg/editor/ic_format_color_text_24px.svg\";s:64:\"ed08115552a3a3d9fe5c44a5c72b5a129540bbaed0370c09b26f2e9a9ba7ac8c\";s:66:\"public/assets/assets/svg/editor/ic_format_indent_decrease_24px.svg\";s:64:\"dbc3919f71ff58b94a12155a424c8f295d3588791adaa06c0df956be5f9fa387\";s:66:\"public/assets/assets/svg/editor/ic_format_indent_increase_24px.svg\";s:64:\"e9c798a37a623e63951df9439b549a5a2d8439978f23e6e8da845797f1260e71\";s:57:\"public/assets/assets/svg/editor/ic_format_italic_24px.svg\";s:64:\"7bbce87338ed5ce0e35d1fefa0d41f62d5dfc6a31c8bc052e91f6ae7535abdb7\";s:63:\"public/assets/assets/svg/editor/ic_format_line_spacing_24px.svg\";s:64:\"d8f5b3011ea69eb863b7a32baa15127f456dea5856d6dd99899231c0e4710f52\";s:64:\"public/assets/assets/svg/editor/ic_format_list_bulleted_24px.svg\";s:64:\"e5120c96d4453f1521ffdb5c1b91832e297772dd1d9a40df2179853385888838\";s:64:\"public/assets/assets/svg/editor/ic_format_list_numbered_24px.svg\";s:64:\"3d2be5e9c4bf3fef59127d1c25e2e9f0d6441b608a610dd758791b74e6c38827\";s:56:\"public/assets/assets/svg/editor/ic_format_paint_24px.svg\";s:64:\"1e590f35a93b6fffc1e37884348075fedbdbb405ed0808d960d93d80eb25b854\";s:56:\"public/assets/assets/svg/editor/ic_format_quote_24px.svg\";s:64:\"b7ecd58048a6378a0ad3cb10bd37b84ac045e14336fb673c8a6e6f3655202437\";s:57:\"public/assets/assets/svg/editor/ic_format_shapes_24px.svg\";s:64:\"3345dbe2a4c9b12a1862e524ceb73e46d8fc06bec391db0676744217dc06e27a\";s:55:\"public/assets/assets/svg/editor/ic_format_size_24px.svg\";s:64:\"5fc2e44dc59b9a964fa3201b122c531f78d3a2875c19b72ef45086100cfeb071\";s:64:\"public/assets/assets/svg/editor/ic_format_strikethrough_24px.svg\";s:64:\"8d3943232b8ce2573106815af7abcc6934889974f9234a4e80a544afdf720ad0\";s:71:\"public/assets/assets/svg/editor/ic_format_textdirection_l_to_r_24px.svg\";s:64:\"e0925dbbe330a45628b66ba8005551de9f8831c8f628603e33de7dd5183120a5\";s:71:\"public/assets/assets/svg/editor/ic_format_textdirection_r_to_l_24px.svg\";s:64:\"0f97ab819d5504686e568eb9f6ce8b585ac9414a1d77246d76594200306ab00c\";s:61:\"public/assets/assets/svg/editor/ic_format_underlined_24px.svg\";s:64:\"2315327d177add381674d6c1312c755dbf0ba0232dc4c6d937591a9ebd57c8db\";s:53:\"public/assets/assets/svg/editor/ic_functions_24px.svg\";s:64:\"b43968e1ea308c32450ae47a20d61cc55d67335522a20be3d94270d0fe99209c\";s:53:\"public/assets/assets/svg/editor/ic_highlight_24px.svg\";s:64:\"ef312829b06795b06ec13526493508e2d589947495c762dbc512722f729b499b\";s:56:\"public/assets/assets/svg/editor/ic_insert_chart_24px.svg\";s:64:\"251b8d550df4665af92dd66a774ae43f0f002826a4b091b86c1310a28e9e8c87\";s:58:\"public/assets/assets/svg/editor/ic_insert_comment_24px.svg\";s:64:\"a2c7ceefc2216d2d9bd85d95944c655b5ac5400098234e85db4ba69cfb15c4f5\";s:61:\"public/assets/assets/svg/editor/ic_insert_drive_file_24px.svg\";s:64:\"b7a56b2ace1051167ee454a2f49e0db294c822fd370e79c3c7c00e3754058096\";s:59:\"public/assets/assets/svg/editor/ic_insert_emoticon_24px.svg\";s:64:\"975c5664d2b367f8a033b4eba9f34c6aafbad9b0b4cd25d5e5a1b122758a848a\";s:61:\"public/assets/assets/svg/editor/ic_insert_invitation_24px.svg\";s:64:\"b5d8a4f1247c3fc9e280c69763e3635b4331790f3b31d55ce02e4d2000c5f352\";s:55:\"public/assets/assets/svg/editor/ic_insert_link_24px.svg\";s:64:\"76f4817ff3dc15862585d0f79b491f64c87d836b4c9216cb1be783e2ba714f06\";s:56:\"public/assets/assets/svg/editor/ic_insert_photo_24px.svg\";s:64:\"671a02cb3a7a9c0553a56710d9abfa5bfaff8db9d22937a3b23c8be30f8ea7aa\";s:56:\"public/assets/assets/svg/editor/ic_linear_scale_24px.svg\";s:64:\"44f5f1c0e236df15d1557827871adca586398dd7456076652a0f913ddf4d3271\";s:54:\"public/assets/assets/svg/editor/ic_merge_type_24px.svg\";s:64:\"d2627e120e5048a0a0e194515378fefa6a4fb8503062df36227142eda186ebec\";s:56:\"public/assets/assets/svg/editor/ic_mode_comment_24px.svg\";s:64:\"c99a70527278d8cb07dcf6ebdb708bd36b7179184843d3cd6b2fbe2fa7d692c1\";s:53:\"public/assets/assets/svg/editor/ic_mode_edit_24px.svg\";s:64:\"e421babfbbe69cd7e72fca2b85774b26ec4c9557384b9a3bbfb3d3cef031b4a0\";s:53:\"public/assets/assets/svg/editor/ic_money_off_24px.svg\";s:64:\"80b1b9b2b9b12d23a61766d39bb0fdec7a547881e59f95643f819a136405cc73\";s:51:\"public/assets/assets/svg/editor/ic_publish_24px.svg\";s:64:\"7166d815729e58e5876f54da2fb7952ffbcd0416dbccaf65f708888220b81a08\";s:54:\"public/assets/assets/svg/editor/ic_short_text_24px.svg\";s:64:\"d411e4a4bd47c7b96041145ddc98abd6dbf6ce629cc451c733b3edb1cc785bd5\";s:53:\"public/assets/assets/svg/editor/ic_space_bar_24px.svg\";s:64:\"f7badb30f43620115598a703a8118e551639c82413abb6768594808ccd917283\";s:59:\"public/assets/assets/svg/editor/ic_strikethrough_s_24px.svg\";s:64:\"4e0faf0dbe503ef35e0a1d3c8aaa939ac52ab33f91a308464b811e2a96e85b82\";s:55:\"public/assets/assets/svg/editor/ic_text_fields_24px.svg\";s:64:\"79edc59515c2e37a818dd4a9147c696652b94df58ebafaf3bcc40908f75859da\";s:65:\"public/assets/assets/svg/editor/ic_vertical_align_bottom_24px.svg\";s:64:\"b1ae4b8b386753b5db3c6eb2c35eeb3bc09d2d0b159bb638fe0aae7652e0015e\";s:65:\"public/assets/assets/svg/editor/ic_vertical_align_center_24px.svg\";s:64:\"e139389be201e4d7198ee3a1a00e1b416942e3e3f39d89ed5886d315bde6cc75\";s:62:\"public/assets/assets/svg/editor/ic_vertical_align_top_24px.svg\";s:64:\"02460fd350ddf63e8d5db957f2c2d48cca0b9e4441b96644ec38b6682fbe95a5\";s:53:\"public/assets/assets/svg/editor/ic_wrap_text_24px.svg\";s:64:\"07218ac0f6ddce5948f9015c0020aa1a814a906def6de4b6e3ba049605b1dd2f\";s:52:\"public/assets/assets/svg/file/ic_attachment_24px.svg\";s:64:\"0c75d7eedc471d63354f6745fe2e6099e8d8d4e6956564859073e19c3793d9b4\";s:47:\"public/assets/assets/svg/file/ic_cloud_24px.svg\";s:64:\"efeea6e90b278c8d9199de26197ae8b198814abae672d22522cc1b925535cc96\";s:54:\"public/assets/assets/svg/file/ic_cloud_circle_24px.svg\";s:64:\"43ec9a5250be8ac9f9e501abd693a3d6b8bc95c4d0ee42f7c07c908de1fe9016\";s:52:\"public/assets/assets/svg/file/ic_cloud_done_24px.svg\";s:64:\"ac232d85225c34eff428c9ad5636bcced7bbfdbc62b919ad58b8ca338e6c1f04\";s:56:\"public/assets/assets/svg/file/ic_cloud_download_24px.svg\";s:64:\"381dc99d432cf55ee3d80fb717d0fdff2c1fe992649b55c9cc1594dd8f1b808e\";s:51:\"public/assets/assets/svg/file/ic_cloud_off_24px.svg\";s:64:\"715502c44c512ed88d28699768f0e7925fc60dfc65ccc5dcccd162f1072051a0\";s:53:\"public/assets/assets/svg/file/ic_cloud_queue_24px.svg\";s:64:\"e7d7494e63c21afe8ab8833b2fce9bd181a20cb4625a97ab3d22ee1b191e45ed\";s:54:\"public/assets/assets/svg/file/ic_cloud_upload_24px.svg\";s:64:\"dd4ebaae0dbf20252947784ca93dccd3a08b346d2b408c1469adad0c5b2749c0\";s:59:\"public/assets/assets/svg/file/ic_create_new_folder_24px.svg\";s:64:\"82b1e60efd9cac71491fde0af781fafad8caa9c913bc432ceedcce4153efa92e\";s:55:\"public/assets/assets/svg/file/ic_file_download_24px.svg\";s:64:\"b887b20de9d7850bac7629bbc72519f5f76c1ae988c692f1970e70cec7498456\";s:53:\"public/assets/assets/svg/file/ic_file_upload_24px.svg\";s:64:\"5dd98da44a81b5a2c430af52158959cc8f7ac9649b7c5a55a79e830b8accd555\";s:48:\"public/assets/assets/svg/file/ic_folder_24px.svg\";s:64:\"6fd163596302f902f0b52c168a367e02dafe72800bc169bc5a293b3e116256c9\";s:53:\"public/assets/assets/svg/file/ic_folder_open_24px.svg\";s:64:\"e8f2a20b5b3644d5b6b4ec4a0cb32bf51e5fdb5ba8ed3e0b515dc423fee6f573\";s:55:\"public/assets/assets/svg/file/ic_folder_shared_24px.svg\";s:64:\"5d5e33f385c481eb791ec73dc7f8de05bbd46152ee9b11fcd3e38ab6597223ed\";s:50:\"public/assets/assets/svg/hardware/ic_cast_24px.svg\";s:64:\"1d753fa5588099daa59b4fedde5781c61ff6e5e71ccdfa8dc333002a89faff19\";s:60:\"public/assets/assets/svg/hardware/ic_cast_connected_24px.svg\";s:64:\"2503e46da3ebd7e04648cd2a59ab0e9fe492db73e11039f90107aa6e2324a60c\";s:54:\"public/assets/assets/svg/hardware/ic_computer_24px.svg\";s:64:\"32fe80f9f3d86310dacf0df28c8720e55aa9b8dc07db2593bfcf63bea6d8bcff\";s:57:\"public/assets/assets/svg/hardware/ic_desktop_mac_24px.svg\";s:64:\"e57c29855f25917a830e1d68e4bbff0fc9d5d37167aa91dfe37a9601329e8459\";s:61:\"public/assets/assets/svg/hardware/ic_desktop_windows_24px.svg\";s:64:\"7bd00d8f25c80ef2b40816855428dd4a415e4fba41d14ea06500e41a2672de98\";s:61:\"public/assets/assets/svg/hardware/ic_developer_board_24px.svg\";s:64:\"941626c393631a4dbf0c2cf58eeb7b94dcc847ef5e2b498ded82edfb3189c6c8\";s:56:\"public/assets/assets/svg/hardware/ic_device_hub_24px.svg\";s:64:\"193f98a1fe680a48ec0a4345bf34860d49bbf70ff1d0d26cf9193089c1a9e4b1\";s:59:\"public/assets/assets/svg/hardware/ic_devices_other_24px.svg\";s:64:\"8078a45d2ddbac99becdb3a27445e78c026e741a70ccfb994600372c306b8454\";s:50:\"public/assets/assets/svg/hardware/ic_dock_24px.svg\";s:64:\"965910858b303d38b09aa46c215369e096618fcd0f776bb8d25476ab1290bd7a\";s:53:\"public/assets/assets/svg/hardware/ic_gamepad_24px.svg\";s:64:\"3e850f0a5ebf1e0bfa149967352eff6c9f9ff7c7d262c570fb0bec99c9cda33a\";s:53:\"public/assets/assets/svg/hardware/ic_headset_24px.svg\";s:64:\"1268bd5ad1c7c339be202cc4baca67f13d8d51c0b405d0bdd48cdd0aced11b98\";s:57:\"public/assets/assets/svg/hardware/ic_headset_mic_24px.svg\";s:64:\"892f8d67079f15a1d256eab665dc68b2055fa894911f17cb44668d98d14e165d\";s:54:\"public/assets/assets/svg/hardware/ic_keyboard_24px.svg\";s:64:\"211e47aef0b954dba38ab1549c11901255b5b0d8131056db1b39eae674971408\";s:65:\"public/assets/assets/svg/hardware/ic_keyboard_arrow_down_24px.svg\";s:64:\"5bb56392396df54f2fef737af5c4a1db53c8c2f2094cab6609fbe40871db3fb7\";s:65:\"public/assets/assets/svg/hardware/ic_keyboard_arrow_left_24px.svg\";s:64:\"1aeccc3fc200d2a9376cb1cdb7a98c4e337c9b19704d53168411d0150e13760e\";s:66:\"public/assets/assets/svg/hardware/ic_keyboard_arrow_right_24px.svg\";s:64:\"5e2d47bcb1b29ad75cd38794379b07a65398a983183f41d50e39dbf63ccd28ca\";s:63:\"public/assets/assets/svg/hardware/ic_keyboard_arrow_up_24px.svg\";s:64:\"00d8f7123bb5ef3f7fad786905f5407cc5fb8b4c55e1b0511803f6c8c01e3903\";s:64:\"public/assets/assets/svg/hardware/ic_keyboard_backspace_24px.svg\";s:64:\"2bbd845f280ad00b8a96804bab8db2ff00740eb4ab9f870e4a64a043c262f10f\";s:63:\"public/assets/assets/svg/hardware/ic_keyboard_capslock_24px.svg\";s:64:\"b4b76ebafbad449887b0e350f4b83e45036449e3e6284227a23ada345a0d32a0\";s:59:\"public/assets/assets/svg/hardware/ic_keyboard_hide_24px.svg\";s:64:\"69809155ec7d48e700a2c55152cf76fad788920b0e002ef62a81425f54efcd71\";s:61:\"public/assets/assets/svg/hardware/ic_keyboard_return_24px.svg\";s:64:\"628073a0ebc9e97b55f91d189f4d784596066e672fe7829bb507f135194da302\";s:58:\"public/assets/assets/svg/hardware/ic_keyboard_tab_24px.svg\";s:64:\"a03b1a14b4bfeb604f938dbc20c721a353be96b92fc0c883c0fb0f7b635a2446\";s:60:\"public/assets/assets/svg/hardware/ic_keyboard_voice_24px.svg\";s:64:\"608013b35d8e35fc1d651836cb057926d5604aec48d7ba32df581d53b12a893a\";s:52:\"public/assets/assets/svg/hardware/ic_laptop_24px.svg\";s:64:\"7ff4562d246007038bc8ea2a212e4f9ad7d3ad88f8fe46de3b7974f778d5576f\";s:63:\"public/assets/assets/svg/hardware/ic_laptop_chromebook_24px.svg\";s:64:\"c46ca0a1ed5975edcc49cb32cdb077e7c46c0c964fab1986f00435da087060dd\";s:56:\"public/assets/assets/svg/hardware/ic_laptop_mac_24px.svg\";s:64:\"fe0a0288cd3e94f31b078de241d6eb5e620a8fdbd74a924d744006cd1a69a422\";s:60:\"public/assets/assets/svg/hardware/ic_laptop_windows_24px.svg\";s:64:\"5b46b4975939fac6a7e9c3b774f05c58d96655f6c21276e386e8a3c56297947d\";s:52:\"public/assets/assets/svg/hardware/ic_memory_24px.svg\";s:64:\"d5f806ad64030d8c19188ac8add799e26f37f71bd2b10c7a32bc25769fd2a0a4\";s:51:\"public/assets/assets/svg/hardware/ic_mouse_24px.svg\";s:64:\"396a2266e2b3eedaaea2a6cc35da3b7a7bd934b1cdb21e4c9518eb1fbb21d49d\";s:59:\"public/assets/assets/svg/hardware/ic_phone_android_24px.svg\";s:64:\"4a15284d01c010d6ddb3a219045f25ec7f9924260aa5e40048b5cac83d5186b1\";s:58:\"public/assets/assets/svg/hardware/ic_phone_iphone_24px.svg\";s:64:\"ead5012394b90ef0bf39f499a3f45abab2124b929ffb6ea217693791881d2664\";s:55:\"public/assets/assets/svg/hardware/ic_phonelink_24px.svg\";s:64:\"ff603e07968311f66ff514e30cf6f17f5d17d0e80e2b82a1beac4ed28336b30c\";s:59:\"public/assets/assets/svg/hardware/ic_phonelink_off_24px.svg\";s:64:\"21b9024f4b52bbeb9a162238ad304ca8b98740780c71026159cdfe0d16be039d\";s:57:\"public/assets/assets/svg/hardware/ic_power_input_24px.svg\";s:64:\"c886c94e6ff36a8a21c3c944ab10b5032567ff57021d7a75a99e754b432b0f49\";s:52:\"public/assets/assets/svg/hardware/ic_router_24px.svg\";s:64:\"a3224c291ceffc7d953d1a94435456a75371f96e292181d0b7ca8a5443da8570\";s:53:\"public/assets/assets/svg/hardware/ic_scanner_24px.svg\";s:64:\"909e0857695026a4b7ea9db16e7ba2c12cf4ac6236b2e07553173664403080c1\";s:54:\"public/assets/assets/svg/hardware/ic_security_24px.svg\";s:64:\"f778dd116c1912f83e3a04675890d70e151f82189ddbc481b4026421aeb879ee\";s:54:\"public/assets/assets/svg/hardware/ic_sim_card_24px.svg\";s:64:\"0a1c80b771c01a3d2847f093a494173c2ae69034803fb63cc7824fa4a22d1d73\";s:56:\"public/assets/assets/svg/hardware/ic_smartphone_24px.svg\";s:64:\"2cda8927572e92b38e7ed94fbd4d8d4ffaaeb4bc1187125db4ca88da6bca2742\";s:53:\"public/assets/assets/svg/hardware/ic_speaker_24px.svg\";s:64:\"b32b12baf48ef24f05ebba385ffd8c4193d7917197e9e2f4ba6f394020831923\";s:59:\"public/assets/assets/svg/hardware/ic_speaker_group_24px.svg\";s:64:\"41833a1322d978a28a1968a63fb96ace4a502a63f976dc20cc54f74762138c82\";s:52:\"public/assets/assets/svg/hardware/ic_tablet_24px.svg\";s:64:\"60d8f7fff4bdf7a56e5e867458a598d5d5358517c3f163d17944384c71ebb72a\";s:60:\"public/assets/assets/svg/hardware/ic_tablet_android_24px.svg\";s:64:\"1c07ae860916f4c005b89468f2b7a8336cab7ef816a3866a1b59933c4bf8c9e3\";s:56:\"public/assets/assets/svg/hardware/ic_tablet_mac_24px.svg\";s:64:\"99aba9e7575bcdb7bf4286af1ce8b5a9160cb2c9f51bed8264de45ef31f0345f\";s:50:\"public/assets/assets/svg/hardware/ic_toys_24px.svg\";s:64:\"92220f21ebe3b399a6ea2c561959d261a1af0786a3fe376fd3c9b1e59d9bb434\";s:48:\"public/assets/assets/svg/hardware/ic_tv_24px.svg\";s:64:\"0278fb08c59bc5774294a851894332960068c13b36ff96ee207d6104a4e18951\";s:61:\"public/assets/assets/svg/hardware/ic_videogame_asset_24px.svg\";s:64:\"1e72ddb68f37e38c741f80ba1ed8599c2fe91e78dcb27b278c96ee6bf5b4b468\";s:51:\"public/assets/assets/svg/hardware/ic_watch_24px.svg\";s:64:\"1b22fa67a5a30e18d27418e91df20a52727bd03091ea380d07c577c6e1efeb39\";s:54:\"public/assets/assets/svg/image/ic_add_a_photo_24px.svg\";s:64:\"05f5db2f5d06b7c1ea6e5650262b29b166ffa71f69435e600965389340721585\";s:56:\"public/assets/assets/svg/image/ic_add_to_photos_24px.svg\";s:64:\"2057c6177d9cdc9f6154e9ee439ddd7a49dd9b9eafff5977aac46da6c154452b\";s:49:\"public/assets/assets/svg/image/ic_adjust_24px.svg\";s:64:\"50cedc221f18818328efcc710bd6fb7f6c6a2c33b888ed311f24780069044f39\";s:52:\"public/assets/assets/svg/image/ic_assistant_24px.svg\";s:64:\"d6c81bfbed6964aec30b3b9b86ff2b0e29787dc4b3658ff1d2bdaf7080ae7842\";s:58:\"public/assets/assets/svg/image/ic_assistant_photo_24px.svg\";s:64:\"cbb30ec622923b6e0442d67277e30eaa1ba429223b132fde3289d125f2c62c88\";s:53:\"public/assets/assets/svg/image/ic_audiotrack_24px.svg\";s:64:\"2d19fe8a34f497931c6606856f6cf002da95b3563b15280bc7c8f524018829b0\";s:56:\"public/assets/assets/svg/image/ic_blur_circular_24px.svg\";s:64:\"4da0e483dcdc6e31a76999acf4d8278f63776d1c44554d9debaaa0a2d5bf79c0\";s:54:\"public/assets/assets/svg/image/ic_blur_linear_24px.svg\";s:64:\"7136da487685ab87b30af98bf4aec7eb4d3ef4a6e3cc618f7a1f44b7fcfc8f53\";s:51:\"public/assets/assets/svg/image/ic_blur_off_24px.svg\";s:64:\"fdde52fa7432b4ccf30aabad9307b2146f55c2a2c2a341d23d0c44cf3fafbacc\";s:50:\"public/assets/assets/svg/image/ic_blur_on_24px.svg\";s:64:\"ae47cab9e4adeac358fe0d846c2c16909eb73805ad49791836a02c4b28cb92f0\";s:55:\"public/assets/assets/svg/image/ic_brightness_1_24px.svg\";s:64:\"5a119b27722ff80a801f50e83b4d78c78fe6002c513a037eb86ebccdb31f595a\";s:55:\"public/assets/assets/svg/image/ic_brightness_2_24px.svg\";s:64:\"923abe5df2ea16e95273f43c241ed1f86715c1e66184ea4e705cc61ce5be8c7d\";s:55:\"public/assets/assets/svg/image/ic_brightness_3_24px.svg\";s:64:\"5e0aa9434d2498076eeda61bb2ef7019ba97ae98b5ae91f77c204a57b0e9cde5\";s:55:\"public/assets/assets/svg/image/ic_brightness_4_24px.svg\";s:64:\"f313171cb4d6ab3ab7d4a635b22be00f8675f9a28f69d9e4a6f4f511b0107b3d\";s:55:\"public/assets/assets/svg/image/ic_brightness_5_24px.svg\";s:64:\"d0655c2f58d3fd47c4f5bda9efcd64845e695c357221dbe97a82343585f01bc9\";s:55:\"public/assets/assets/svg/image/ic_brightness_6_24px.svg\";s:64:\"7b248a3f7cd27cd31575fa060235a702e2daaf51490a173413e5a4ea90f9df68\";s:55:\"public/assets/assets/svg/image/ic_brightness_7_24px.svg\";s:64:\"e9d4d6f8f068e875bb94666332c9e2d273a806028c5df9f64065d062917a6aad\";s:55:\"public/assets/assets/svg/image/ic_broken_image_24px.svg\";s:64:\"7ffa61f2e3203e3097ccc706ad38fea5cb429b84ebb3313bee256f45d5fe7101\";s:48:\"public/assets/assets/svg/image/ic_brush_24px.svg\";s:64:\"7f269a46d7a942a72bb31e9c5427b2d5d22e473bf18f48aa98b87b02160362dc\";s:49:\"public/assets/assets/svg/image/ic_camera_24px.svg\";s:64:\"f8c3d560b0fe3d8d732a18cb3b7900eac9dae2777a8d056665577e4bdaebd1fa\";s:53:\"public/assets/assets/svg/image/ic_camera_alt_24px.svg\";s:64:\"752837fd86ca522bc055c564a6eac167fd011ea807a3a9ef86509b6eadeb015d\";s:55:\"public/assets/assets/svg/image/ic_camera_front_24px.svg\";s:64:\"059a95a1c77cf61574878a6f20b88ba0261b83f797557b81da48b43183a636bc\";s:54:\"public/assets/assets/svg/image/ic_camera_rear_24px.svg\";s:64:\"22c14e7e261250b874b237f3afa4f2429d3ceddee2928d9df16b4d91f5885811\";s:54:\"public/assets/assets/svg/image/ic_camera_roll_24px.svg\";s:64:\"258c18fe7ea0cc6cfe5cca9f1b83a383aedd4ef35ffdc06a8639eeeed2a98a47\";s:62:\"public/assets/assets/svg/image/ic_center_focus_strong_24px.svg\";s:64:\"897b692a5565b6ca2df37ad16714a6ca5e00a884fe77a870e3fb68456cacb250\";s:60:\"public/assets/assets/svg/image/ic_center_focus_weak_24px.svg\";s:64:\"c157a5df8bba18437b6c66144b25d87ed22542f6a333b53a4b909fbce1eceb58\";s:54:\"public/assets/assets/svg/image/ic_collections_24px.svg\";s:64:\"eb618dc1aab3fe560a3cee9c4626701e6451d8fd5c760d2fa7415efb75158fb9\";s:63:\"public/assets/assets/svg/image/ic_collections_bookmark_24px.svg\";s:64:\"2528414af7bdc861e1a418ff5a85e501675e644acb78ceb3d6368399533fca75\";s:53:\"public/assets/assets/svg/image/ic_color_lens_24px.svg\";s:64:\"db745aaa866a71056c8010d1bd9619612167f21a5ca24e691e36180283bc264b\";s:51:\"public/assets/assets/svg/image/ic_colorize_24px.svg\";s:64:\"0b2ba7c369e03e61bc6582090add0d452d2ea02350cff8ba70efc120d0279541\";s:50:\"public/assets/assets/svg/image/ic_compare_24px.svg\";s:64:\"f973668e0b367eba3da516ec97355beff11592842f772720810b62d20e6cd9f7\";s:56:\"public/assets/assets/svg/image/ic_control_point_24px.svg\";s:64:\"835a3568212151583dcf92e8aea0f01c378e527acdb384b812365c51d1f4a990\";s:66:\"public/assets/assets/svg/image/ic_control_point_duplicate_24px.svg\";s:64:\"49714bc3b17807071a6e0594c0972964afb106df43413c5a4426f16bba2b3162\";s:52:\"public/assets/assets/svg/image/ic_crop_16_9_24px.svg\";s:64:\"2fd6af1f67a4ad7ecafe96809fb3cbb1738106477133067b7c49b5b9640973ed\";s:47:\"public/assets/assets/svg/image/ic_crop_24px.svg\";s:64:\"19f0a7218634a715c5f8a415653d16b78a9e030a5a9e5ae9bff265e93c0ec431\";s:51:\"public/assets/assets/svg/image/ic_crop_3_2_24px.svg\";s:64:\"dda30ba0c5a371b9a4ee8a8893f08dd0961587527b56302435e078b5c697de0b\";s:51:\"public/assets/assets/svg/image/ic_crop_5_4_24px.svg\";s:64:\"7d13454d35b59cc1b6fc79a7ff7b94805522234424a6dee6c177936e38a39488\";s:51:\"public/assets/assets/svg/image/ic_crop_7_5_24px.svg\";s:64:\"32c95931ba1c0c508a3e2db3f44fe6e64f8af0bbb3c78083adf32d1dfe93d41e\";s:51:\"public/assets/assets/svg/image/ic_crop_din_24px.svg\";s:64:\"6bf3ebf6f495d1fa87f47aa4e97985f00f2d61cc2dbb18e8301228c07141679d\";s:52:\"public/assets/assets/svg/image/ic_crop_free_24px.svg\";s:64:\"1bc8298b0ceaf5654150eeb6da7d46db410923bb6bdecc83f5405378e326c336\";s:57:\"public/assets/assets/svg/image/ic_crop_landscape_24px.svg\";s:64:\"7d13454d35b59cc1b6fc79a7ff7b94805522234424a6dee6c177936e38a39488\";s:56:\"public/assets/assets/svg/image/ic_crop_original_24px.svg\";s:64:\"a12107990f15c01fcc2894713e72f28b11df97bffadbc02249a07ad3bd16d657\";s:56:\"public/assets/assets/svg/image/ic_crop_portrait_24px.svg\";s:64:\"aaeca5941d7cd902b55098f6f7af64d373c258f2d9a08838797d99c211f3cdea\";s:54:\"public/assets/assets/svg/image/ic_crop_rotate_24px.svg\";s:64:\"9bb39189c509c58f72e4edd3cc8cb9c312f58b48eb4a7c303fa1d21a2d78ca46\";s:54:\"public/assets/assets/svg/image/ic_crop_square_24px.svg\";s:64:\"b4f9019235eb0f80f4b00d7d5074d1d0391e701778d9eddfe061b102a66caab6\";s:49:\"public/assets/assets/svg/image/ic_dehaze_24px.svg\";s:64:\"beafab06427a5e62b4985e57c9083e1b3cfad635e7533002af84e7a963503f4a\";s:50:\"public/assets/assets/svg/image/ic_details_24px.svg\";s:64:\"8db56d6f321fdd301da92bc7b3a03631115efc183ac8eec3b41559c37c12e969\";s:47:\"public/assets/assets/svg/image/ic_edit_24px.svg\";s:64:\"e421babfbbe69cd7e72fca2b85774b26ec4c9557384b9a3bbfb3d3cef031b4a0\";s:51:\"public/assets/assets/svg/image/ic_exposure_24px.svg\";s:64:\"2159ad3156bd508ad39502c642f2efeda8e965b6e774c85dd8b4ccc3695ded98\";s:57:\"public/assets/assets/svg/image/ic_exposure_neg_1_24px.svg\";s:64:\"d6b59c28bd8fff8bfd201ae148c86981c6258c8640f8b75774ac44f8a415030a\";s:57:\"public/assets/assets/svg/image/ic_exposure_neg_2_24px.svg\";s:64:\"bc7aa945b286051333284c2ee5e99702432d7777c2849e5dd937cb4bf049262b\";s:58:\"public/assets/assets/svg/image/ic_exposure_plus_1_24px.svg\";s:64:\"36d67d5fef36cf77696057e506a58603f2b623f37c42acd86be415ecf2412a96\";s:58:\"public/assets/assets/svg/image/ic_exposure_plus_2_24px.svg\";s:64:\"b5a6209a7eef17e350377bc582965b77668062bffd9e1cedf8994d587ef541a4\";s:56:\"public/assets/assets/svg/image/ic_exposure_zero_24px.svg\";s:64:\"0957e6451e767ff4b81f13e3d69863fbeac1fa6926dbcb8828c778b97bc7ee96\";s:51:\"public/assets/assets/svg/image/ic_filter_1_24px.svg\";s:64:\"5af248a8a3c1c13b702ce0676bded165e181420a983f905e72b286fff5f18b6c\";s:49:\"public/assets/assets/svg/image/ic_filter_24px.svg\";s:64:\"9fd3cf3eea77f46c8dbcb63dee7b0aca5d29e9b7a079a4c89d7f585b33844e79\";s:51:\"public/assets/assets/svg/image/ic_filter_2_24px.svg\";s:64:\"8608e165b4fd5b834d1352bdcbb877b839b9ca99ee9d2ef36e2ed5a2ad2e01c4\";s:51:\"public/assets/assets/svg/image/ic_filter_3_24px.svg\";s:64:\"d5d13e11d001d9355f755cd317d95b0f26428482fc2bca0ad1e5afd451276fe6\";s:51:\"public/assets/assets/svg/image/ic_filter_4_24px.svg\";s:64:\"48c689190233b3c4440d2cc5d1f810065069db1a3924fe0d62b7d59ff9c55ca9\";s:51:\"public/assets/assets/svg/image/ic_filter_5_24px.svg\";s:64:\"6ddcc6f6d519c1f541ef87ca0cad9c0b43a0a856567c2a13f21e735979469937\";s:51:\"public/assets/assets/svg/image/ic_filter_6_24px.svg\";s:64:\"44258786dbb86b040fb4fba7da0de8f819e4c29c76e7d4c0454b2d491a241474\";s:51:\"public/assets/assets/svg/image/ic_filter_7_24px.svg\";s:64:\"56ad0a26ba4a7d4cb453d82fd4b0b6b5ce1c8f379d79bf2931581a4a49ed88a7\";s:51:\"public/assets/assets/svg/image/ic_filter_8_24px.svg\";s:64:\"01ea2aa8fc0008633cc2f56ed48f5086d32e1f26fc4e752050abfe8e92635066\";s:51:\"public/assets/assets/svg/image/ic_filter_9_24px.svg\";s:64:\"fa69cdb5dea15032f234d8bc8f89ff57014c90e1166538b33f1cac329f6a25e6\";s:56:\"public/assets/assets/svg/image/ic_filter_9_plus_24px.svg\";s:64:\"2d4fc474cdc3d2ede22208d66ac6ac97311f5e563bc4ee8b6f03c619dd6de3eb\";s:57:\"public/assets/assets/svg/image/ic_filter_b_and_w_24px.svg\";s:64:\"ff4668c169d8567de0846477ae0e6b451a06ae43859831d5f67a94f33006fbea\";s:62:\"public/assets/assets/svg/image/ic_filter_center_focus_24px.svg\";s:64:\"b561499a77947d87ea3b7a75b0b0007bd969b5ef5210c30c96d07016a0aaa704\";s:55:\"public/assets/assets/svg/image/ic_filter_drama_24px.svg\";s:64:\"68ac458d09d03737417cf66e3ed93baffd38c17ea0f00a07f331eea8ece34568\";s:56:\"public/assets/assets/svg/image/ic_filter_frames_24px.svg\";s:64:\"f3f7e9d502136a066ad8ad0303b17a3d6c398d772747c1c2f8442d26355d7ef8\";s:53:\"public/assets/assets/svg/image/ic_filter_hdr_24px.svg\";s:64:\"0a5c59a48aa9ee4e4be607609fce70e5ea694d775792f54a70e9ad144d054851\";s:54:\"public/assets/assets/svg/image/ic_filter_none_24px.svg\";s:64:\"e8e48ca7c38eb9aed542dcfd76b5acb23231803590e163bbb6a602229c8d0703\";s:60:\"public/assets/assets/svg/image/ic_filter_tilt_shift_24px.svg\";s:64:\"7edb7935beb6f97871ddc89a6eb1f55e7827890111b26deed636535161551c23\";s:57:\"public/assets/assets/svg/image/ic_filter_vintage_24px.svg\";s:64:\"215b5fb9ee6f493cabae75a912338412d718ad169670c871159ff633014fb0b1\";s:48:\"public/assets/assets/svg/image/ic_flare_24px.svg\";s:64:\"ef72e0f40a3e9a325428fde1680e253dea67a3874ad32dff7081da946dbbaf98\";s:53:\"public/assets/assets/svg/image/ic_flash_auto_24px.svg\";s:64:\"9c847b97e8ebe9c3942b3ec8eeff2f5e9331ccba10be8cc70bbadd5ac02f37f8\";s:52:\"public/assets/assets/svg/image/ic_flash_off_24px.svg\";s:64:\"a7a574e808dfc419ac451371049ded49718f425d833482a7907e9148e68c52dc\";s:51:\"public/assets/assets/svg/image/ic_flash_on_24px.svg\";s:64:\"006474f205048a7dc563a6b1729a2a3cdd896546b19e1c583c8be962e7b6964f\";s:47:\"public/assets/assets/svg/image/ic_flip_24px.svg\";s:64:\"ce0d4b20d4ddc719d3ee7777b281db9dc33f8e113335f93fadcef046c5269587\";s:51:\"public/assets/assets/svg/image/ic_gradient_24px.svg\";s:64:\"a081b8606c601df4cbfdbb69f1613a0c44ca6bbaf051c3a847081e884a856d63\";s:48:\"public/assets/assets/svg/image/ic_grain_24px.svg\";s:64:\"4530be4741ac9902bcbce258cf8548b86ec15bdef6b0a195038c7ebcd6384a4c\";s:51:\"public/assets/assets/svg/image/ic_grid_off_24px.svg\";s:64:\"6b4986199a820202f870965c91df85b525d5df294ec1deaa1393fc0d03ece81c\";s:50:\"public/assets/assets/svg/image/ic_grid_on_24px.svg\";s:64:\"7a7c2108c477f9eca82930302c1b0b1a1a9f4c5d6877d9b338929bbc108ee946\";s:50:\"public/assets/assets/svg/image/ic_hdr_off_24px.svg\";s:64:\"2ca63afa1c516b65c4807bd0814f648f8dff9b32125b21b5cf514ab40b1e564c\";s:49:\"public/assets/assets/svg/image/ic_hdr_on_24px.svg\";s:64:\"3fd1bf9e16aa092e9b32534fe66c4fc2db7435e38e43522499e757667a45fcf2\";s:53:\"public/assets/assets/svg/image/ic_hdr_strong_24px.svg\";s:64:\"0a26fba52d6c76ff8d850537be328772447fee1f525f608dff2f11199e016241\";s:51:\"public/assets/assets/svg/image/ic_hdr_weak_24px.svg\";s:64:\"a041e5f4fd5af4c7cc0e66898888039582cf9af7fd533de44f0a21515ccb8e8e\";s:50:\"public/assets/assets/svg/image/ic_healing_24px.svg\";s:64:\"c082ead5cfb5ce682aa5a3db82d247dc5265ca80993878b3fd041eff3102b60c\";s:48:\"public/assets/assets/svg/image/ic_image_24px.svg\";s:64:\"671a02cb3a7a9c0553a56710d9abfa5bfaff8db9d22937a3b23c8be30f8ea7aa\";s:61:\"public/assets/assets/svg/image/ic_image_aspect_ratio_24px.svg\";s:64:\"939821a7e396416e5ef8581b79d34db89e8b14ccdb41c8041640d527e2f426a6\";s:46:\"public/assets/assets/svg/image/ic_iso_24px.svg\";s:64:\"92e00417a55e8ae48837fd8f70405b5b226c2861de6ca4b221314bdee11e1e8d\";s:52:\"public/assets/assets/svg/image/ic_landscape_24px.svg\";s:64:\"0a5c59a48aa9ee4e4be607609fce70e5ea694d775792f54a70e9ad144d054851\";s:51:\"public/assets/assets/svg/image/ic_leak_add_24px.svg\";s:64:\"4444cba94792a7a7740baa6b86cdf87594c39e0f83159928a69246c827c80fbf\";s:54:\"public/assets/assets/svg/image/ic_leak_remove_24px.svg\";s:64:\"7ff1d06bb3841dd25f54333ed7f67c48b154789e0cb4e8dd0266cc0bcdee26cd\";s:47:\"public/assets/assets/svg/image/ic_lens_24px.svg\";s:64:\"ba021969f639f7ae307e708d92c058fdf1cd68304b214d5d11d9282b4670bfb1\";s:56:\"public/assets/assets/svg/image/ic_linked_camera_24px.svg\";s:64:\"18bc5da1690273f1485bfb21ae43d09bcf088bbb5715786e0892f2a69fbca421\";s:48:\"public/assets/assets/svg/image/ic_looks_24px.svg\";s:64:\"80d2fcca804f01b6904a81ce6b3c37a1eb25cd627422766ddf5d8045fd4bbf6c\";s:50:\"public/assets/assets/svg/image/ic_looks_3_24px.svg\";s:64:\"b6a0b82f369c2ccc01fd48793c6374c33beeed2b3b8612ed4e84b29eefa53a55\";s:50:\"public/assets/assets/svg/image/ic_looks_4_24px.svg\";s:64:\"6d75176283344fdf70b9c70b03bec118e3fb23b0382e7ed2ea105b9e390ca39d\";s:50:\"public/assets/assets/svg/image/ic_looks_5_24px.svg\";s:64:\"91760016a0f6959d6493d8b4b0a80e8f82a2886b8bcd042fed97ca49c6e64d01\";s:50:\"public/assets/assets/svg/image/ic_looks_6_24px.svg\";s:64:\"b8080689ac035abc6096bec09bfff0cf9b672511688c409f087423f9f02b5017\";s:52:\"public/assets/assets/svg/image/ic_looks_one_24px.svg\";s:64:\"64d4e9cafefae84e2ee4a8cdf4a43af90fdb53060c04a730e14b9ebc135b46a2\";s:52:\"public/assets/assets/svg/image/ic_looks_two_24px.svg\";s:64:\"dcf84b287e4e59e955c7a2e445cf3658671747d596475b09b200cd222897f6f8\";s:48:\"public/assets/assets/svg/image/ic_loupe_24px.svg\";s:64:\"506c39c16f65c64ccda81821f064bd79f8d58a97524d17760309d0ba41029900\";s:60:\"public/assets/assets/svg/image/ic_monochrome_photos_24px.svg\";s:64:\"cd15184b207620961df2513255bf0205a8d1e5bf8e16b8432c062c2485a901c8\";s:57:\"public/assets/assets/svg/image/ic_movie_creation_24px.svg\";s:64:\"f0d2c7e0515d6dace01851022d3cebce6dfbc95e0541a8bd26312b63306b2452\";s:55:\"public/assets/assets/svg/image/ic_movie_filter_24px.svg\";s:64:\"6f281ace9cdaadf91de572c175f2097728f51562c0814905ea95c01e6e3d1fba\";s:53:\"public/assets/assets/svg/image/ic_music_note_24px.svg\";s:64:\"2b5c610d246fc796dcd2385a5b058ae76ddaf65ccb93c18d5b13117417a6a1a8\";s:49:\"public/assets/assets/svg/image/ic_nature_24px.svg\";s:64:\"3a8d09d5664dfcfb9515dd9c1bdbba42393c000249b67b753d812d7c35e6a5e1\";s:56:\"public/assets/assets/svg/image/ic_nature_people_24px.svg\";s:64:\"845ccec72649d0e3c6aa1626e1289029c070e8ae4e452517f1b080f6bb4efed5\";s:58:\"public/assets/assets/svg/image/ic_navigate_before_24px.svg\";s:64:\"ad918f7ec0ff89298e84586b5b98cdf628c8457cd067dc592031fae783f71a1d\";s:56:\"public/assets/assets/svg/image/ic_navigate_next_24px.svg\";s:64:\"83f0da9735a4e475b0eca23b708ba09b2b7411e7d711b2d6be24bc2371d67ec8\";s:50:\"public/assets/assets/svg/image/ic_palette_24px.svg\";s:64:\"db745aaa866a71056c8010d1bd9619612167f21a5ca24e691e36180283bc264b\";s:51:\"public/assets/assets/svg/image/ic_panorama_24px.svg\";s:64:\"6132945672edd13d51b056ba8d3127dd15d4a0ff4dd5ff0e7867112a28e14f3b\";s:60:\"public/assets/assets/svg/image/ic_panorama_fish_eye_24px.svg\";s:64:\"90712781f09928f05ae42cdb09b273248719c717acc32d3311fa7f71fe69da40\";s:62:\"public/assets/assets/svg/image/ic_panorama_horizontal_24px.svg\";s:64:\"9dce30b26ec63f1c0fd1eea70c2fc7b989372a0100177be16a16ad33b999b5ee\";s:60:\"public/assets/assets/svg/image/ic_panorama_vertical_24px.svg\";s:64:\"7b0df6f1e3951f89849d3f014f6045f377d2ea46c8c7ba1733db19cdc6575194\";s:62:\"public/assets/assets/svg/image/ic_panorama_wide_angle_24px.svg\";s:64:\"1b83c5c99a29d66162fe1bb53cc86b1cb124e614001e52082cecaa9767e2287f\";s:48:\"public/assets/assets/svg/image/ic_photo_24px.svg\";s:64:\"671a02cb3a7a9c0553a56710d9abfa5bfaff8db9d22937a3b23c8be30f8ea7aa\";s:54:\"public/assets/assets/svg/image/ic_photo_album_24px.svg\";s:64:\"8c2675c5cf77d38d27381eca769f3182edb629af6212c65cd7e1cd79d02b3dbd\";s:55:\"public/assets/assets/svg/image/ic_photo_camera_24px.svg\";s:64:\"752837fd86ca522bc055c564a6eac167fd011ea807a3a9ef86509b6eadeb015d\";s:55:\"public/assets/assets/svg/image/ic_photo_filter_24px.svg\";s:64:\"62968b8d4458089756b1aff2c962fce039bcae7a95337a2814577ddac5bd9b84\";s:56:\"public/assets/assets/svg/image/ic_photo_library_24px.svg\";s:64:\"eb618dc1aab3fe560a3cee9c4626701e6451d8fd5c760d2fa7415efb75158fb9\";s:67:\"public/assets/assets/svg/image/ic_photo_size_select_actual_24px.svg\";s:64:\"6f8e3c4868ae5ef0e0be6c055c1240064cfb6116c5b5caf65e42ae520d5d8ff3\";s:66:\"public/assets/assets/svg/image/ic_photo_size_select_large_24px.svg\";s:64:\"ba354295f255827dcf3040cac6020ad813efe79603d23e200ec0997211094556\";s:66:\"public/assets/assets/svg/image/ic_photo_size_select_small_24px.svg\";s:64:\"7eeba2008c7c969000c14ce1288252f5467b6e63cd02471db25d157b67eb4123\";s:57:\"public/assets/assets/svg/image/ic_picture_as_pdf_24px.svg\";s:64:\"c5d404ff344246af8be939c7efcf4c7f5ab20f367cc616e5ed455bb709ea3719\";s:51:\"public/assets/assets/svg/image/ic_portrait_24px.svg\";s:64:\"9655d1ec45104d7f834b087930fc950ae580f268a4bc09bbdde9d2f33a50f007\";s:57:\"public/assets/assets/svg/image/ic_remove_red_eye_24px.svg\";s:64:\"5e2fc28ae621a18342caf71644f0b5725d9cbe377932db896a0009fa21250201\";s:64:\"public/assets/assets/svg/image/ic_rotate_90_degrees_ccw_24px.svg\";s:64:\"448c0b98c1795054c526b4905cd49903cc23c0d94ea673c8282b9443ff987330\";s:54:\"public/assets/assets/svg/image/ic_rotate_left_24px.svg\";s:64:\"254cc04b8cd845f4e17359e649bfa84a3c55d2ba9fe534a0aadbdc6a0214af8f\";s:55:\"public/assets/assets/svg/image/ic_rotate_right_24px.svg\";s:64:\"e1acb7373657e0d0b6b76611b042636181863feb70d447eed331fa1ef75af347\";s:52:\"public/assets/assets/svg/image/ic_slideshow_24px.svg\";s:64:\"a910a1f071e7d288803f9516fd5a312eb9fe1037bc9c4a8575ceda66f26e5136\";s:53:\"public/assets/assets/svg/image/ic_straighten_24px.svg\";s:64:\"faa637a71183f73c4307ba62e1b8e2a173f9dea1847c35070871b3f9c9357d55\";s:48:\"public/assets/assets/svg/image/ic_style_24px.svg\";s:64:\"232f1702bd366c5f470b7464385a23e2aa4ba088b95fd99abf16a1d333be6ac4\";s:56:\"public/assets/assets/svg/image/ic_switch_camera_24px.svg\";s:64:\"70551fbaa9ad60c496956e3d66db048adb19011592e976ed2c25aed62dda8ad4\";s:55:\"public/assets/assets/svg/image/ic_switch_video_24px.svg\";s:64:\"729dd60f9e92d170f7b24286b5f28c87e72682a684cd5303e7391cea5e353b14\";s:52:\"public/assets/assets/svg/image/ic_tag_faces_24px.svg\";s:64:\"975c5664d2b367f8a033b4eba9f34c6aafbad9b0b4cd25d5e5a1b122758a848a\";s:50:\"public/assets/assets/svg/image/ic_texture_24px.svg\";s:64:\"13d062c2113ba69a63568bf3e1ace05164a53e8738dd2050cc7f16dab5a2b392\";s:52:\"public/assets/assets/svg/image/ic_timelapse_24px.svg\";s:64:\"a888043c58bc4e6026e9519e07533a9c3768919f651350414dfc3d16a8dc7510\";s:51:\"public/assets/assets/svg/image/ic_timer_10_24px.svg\";s:64:\"d7720cba73531949693d88ee7f82ef5540d74c5fd7fb9823dd8b8aa9aebd9c76\";s:48:\"public/assets/assets/svg/image/ic_timer_24px.svg\";s:64:\"fa864ac5e99c2cddb3a7f8d6bd10f5ad3f15c71154ad77c593b8d6bb7152f516\";s:50:\"public/assets/assets/svg/image/ic_timer_3_24px.svg\";s:64:\"7dbe94b8c33865dcdc1c9b8a33467aa4682f539c18c0b20d5071bed7144fea48\";s:52:\"public/assets/assets/svg/image/ic_timer_off_24px.svg\";s:64:\"9ca9a3d736b970446e45ff6f7938a63c6f2f3cc3fe8eaa3abb46c1811b40ef5d\";s:51:\"public/assets/assets/svg/image/ic_tonality_24px.svg\";s:64:\"fe37322b694bfbfdd837f151f317751a864bfa0b679dddb3194a30538f227938\";s:52:\"public/assets/assets/svg/image/ic_transform_24px.svg\";s:64:\"ca307eadb86ba71f9102d87aea960d54144172bbded404e26419733e7ee46383\";s:47:\"public/assets/assets/svg/image/ic_tune_24px.svg\";s:64:\"da9e575b059e05491c555911fa0dfd0b340ad694fd83313769e41d329d826620\";s:53:\"public/assets/assets/svg/image/ic_view_comfy_24px.svg\";s:64:\"9125c262e9efb1df23d5f764ba0ab73964763f520e185c91c6d29a5141cbe173\";s:55:\"public/assets/assets/svg/image/ic_view_compact_24px.svg\";s:64:\"49048c901b81e15b0734e76075989311eab77e112cd81b7455dfbecfdfb72114\";s:51:\"public/assets/assets/svg/image/ic_vignette_24px.svg\";s:64:\"eaf464c2d6bd9f912de7bd7572770d29c8c309e1c75e33024bed0a8a74688c02\";s:50:\"public/assets/assets/svg/image/ic_wb_auto_24px.svg\";s:64:\"361ed4296eb64ddbfed92a4e5309e72d9126ad8133dce06a7e4adee136a78d11\";s:52:\"public/assets/assets/svg/image/ic_wb_cloudy_24px.svg\";s:64:\"b9f3295b533c64d3cb7ee7b0c35b7e9d35682d1a37274318d658ed41146f189e\";s:58:\"public/assets/assets/svg/image/ic_wb_incandescent_24px.svg\";s:64:\"1bc0aebc3e755e0ff863f3a2880f1903c5380bcc980f9dbe67c317205ebfe243\";s:56:\"public/assets/assets/svg/image/ic_wb_iridescent_24px.svg\";s:64:\"b4a11899836426d7f60e82b27c12933a35c9ad33857d675fa89be1cbd93bcc1b\";s:51:\"public/assets/assets/svg/image/ic_wb_sunny_24px.svg\";s:64:\"5f9bc00dec3b1ce3342d40a0a3b8cb14dc0efb8df4a45c67d32490acd3f7d699\";s:54:\"public/assets/assets/svg/maps/ic_add_location_24px.svg\";s:64:\"37c8875448cd80ab3eac5b719b736a3c24fffa4f7f10c6bd27b01c482ca909e2\";s:50:\"public/assets/assets/svg/maps/ic_beenhere_24px.svg\";s:64:\"15292394257011e63bbf7554c3d53334674b2c9381ee184f0de8b3a131e0250c\";s:52:\"public/assets/assets/svg/maps/ic_directions_24px.svg\";s:64:\"b2d77dfb880b70141c3bd19d0238efd649a75acdb963b98ef4119e142090d3a9\";s:57:\"public/assets/assets/svg/maps/ic_directions_bike_24px.svg\";s:64:\"7df1269c0c255f54892c083bd9c67db2fb8c5fa2f211587ac2645034e640da53\";s:57:\"public/assets/assets/svg/maps/ic_directions_boat_24px.svg\";s:64:\"90c77b241095dbc0949115f06a460bfaf587240a43dc7e579b614c3f3abd979d\";s:56:\"public/assets/assets/svg/maps/ic_directions_bus_24px.svg\";s:64:\"3d6da2f8585ce4332ccbd1f323288c7650625a8942860c9b098056686d03adc7\";s:56:\"public/assets/assets/svg/maps/ic_directions_car_24px.svg\";s:64:\"5e07d89850734743c0f201a6a17c53175701065245e558f96607091be477d242\";s:60:\"public/assets/assets/svg/maps/ic_directions_railway_24px.svg\";s:64:\"3c88917729445a1b570ff89a1ddce35c77cfff74a7d7296b2fae33f53960bb98\";s:56:\"public/assets/assets/svg/maps/ic_directions_run_24px.svg\";s:64:\"24b400f38b359203e86d9b9e0a44088822bb9f951dbf2d32109eaf4041551c0f\";s:59:\"public/assets/assets/svg/maps/ic_directions_subway_24px.svg\";s:64:\"c21348ccd68158842aebd40001e60df863ec05afedcef208e12bea1ca6d5851a\";s:60:\"public/assets/assets/svg/maps/ic_directions_transit_24px.svg\";s:64:\"c21348ccd68158842aebd40001e60df863ec05afedcef208e12bea1ca6d5851a\";s:57:\"public/assets/assets/svg/maps/ic_directions_walk_24px.svg\";s:64:\"099493269a0b49970d542dd7570fbedc59107c56c99d529ec85054e9dd16012e\";s:55:\"public/assets/assets/svg/maps/ic_edit_location_24px.svg\";s:64:\"eedc8aa35749d4f0ec443f9481a2e051db676249086b17f057a5c84f39358424\";s:48:\"public/assets/assets/svg/maps/ic_flight_24px.svg\";s:64:\"e36f1d063cc9ae3c0acd5b63cd747185b1ccbb0a4c9b571a235fe654b1a213b1\";s:47:\"public/assets/assets/svg/maps/ic_hotel_24px.svg\";s:64:\"212367d6b539a5948d0719396d9ae11692981f38182252a91b0209f4963eb350\";s:48:\"public/assets/assets/svg/maps/ic_layers_24px.svg\";s:64:\"bfa95b79775e5e549611a85cc586c60a28a23e83524f187c7c49c6e2ed448dd2\";s:54:\"public/assets/assets/svg/maps/ic_layers_clear_24px.svg\";s:64:\"351bbd17cce81422d572f76a18f4b593f5df96d114a6cb14741046a11635971e\";s:56:\"public/assets/assets/svg/maps/ic_local_activity_24px.svg\";s:64:\"0f4e3619863d3f0cd8314f5816104650b42c083a89bf6110f2c1607ff329008b\";s:55:\"public/assets/assets/svg/maps/ic_local_airport_24px.svg\";s:64:\"3ac3a72be56f0ecad93c896e296d982a5e56228865f45a8b2b7af731214ae429\";s:51:\"public/assets/assets/svg/maps/ic_local_atm_24px.svg\";s:64:\"9c67136fc66edc3cd76538bcb93353d0c1a9ce8d6c262a7fefccafbff44d347b\";s:51:\"public/assets/assets/svg/maps/ic_local_bar_24px.svg\";s:64:\"4b93ac6f31711ec4d1206ef5db33cb2148c3e53a765cab97f82c62b36ce878c9\";s:52:\"public/assets/assets/svg/maps/ic_local_cafe_24px.svg\";s:64:\"4d423d59fbd0d1f4eda69bf836a7959e66909e955863845ae0e89df34f0a9dc8\";s:56:\"public/assets/assets/svg/maps/ic_local_car_wash_24px.svg\";s:64:\"f832a1ff099e297b33eee0e8309e54b2eec369f1590b73fb0da3be6278aa3ff4\";s:65:\"public/assets/assets/svg/maps/ic_local_convenience_store_24px.svg\";s:64:\"9d22ce56c2ffd57cb0a09ccbbb2a40ba7c1d78a390605837ba1874156889bbfd\";s:54:\"public/assets/assets/svg/maps/ic_local_dining_24px.svg\";s:64:\"8c619a3dbfa9957d3237208556a03367fa099d5bf80b03e369328125e5ca1681\";s:53:\"public/assets/assets/svg/maps/ic_local_drink_24px.svg\";s:64:\"5639b8406fcbbb2caa680eb8d7344ecec8133506d2c0ef68c4be949e57b1bca9\";s:55:\"public/assets/assets/svg/maps/ic_local_florist_24px.svg\";s:64:\"6af2e59f1aaef801a7a6d47a214a714cf72021e033667e556402d5bb62ee1b65\";s:59:\"public/assets/assets/svg/maps/ic_local_gas_station_24px.svg\";s:64:\"9099cc34d4ecc0913f232b319febe7e13b7d96dc4eecd9694011815773d1e956\";s:61:\"public/assets/assets/svg/maps/ic_local_grocery_store_24px.svg\";s:64:\"0d5d165f3e9eea299e31d16c845eb305ba008dfe45f839619eb98ab0b229f34f\";s:56:\"public/assets/assets/svg/maps/ic_local_hospital_24px.svg\";s:64:\"e26882f6e0a1d4d584502be80a8d0b534faf41db37f7789f91bc67acc71c20d8\";s:53:\"public/assets/assets/svg/maps/ic_local_hotel_24px.svg\";s:64:\"212367d6b539a5948d0719396d9ae11692981f38182252a91b0209f4963eb350\";s:63:\"public/assets/assets/svg/maps/ic_local_laundry_service_24px.svg\";s:64:\"47b814c661fae38ab608d4203bf365d03efa398976cd43408c5c3726eb02ff71\";s:55:\"public/assets/assets/svg/maps/ic_local_library_24px.svg\";s:64:\"185a1c9b6b3d4c04f77d9eecf062f22ca088683d0c16040488b72ad18a865af1\";s:52:\"public/assets/assets/svg/maps/ic_local_mall_24px.svg\";s:64:\"7e3a51acabf987aedf3e44c96ea3178a9ce169c377bf341cb5f7184b7f97a8e4\";s:54:\"public/assets/assets/svg/maps/ic_local_movies_24px.svg\";s:64:\"aacde086862a86f1d85daca021e414ae732e235e9ad09963d71520903bb8be4f\";s:53:\"public/assets/assets/svg/maps/ic_local_offer_24px.svg\";s:64:\"2ed45b1d394e9e1bf7596f16462af322438f00b5deaf59a34afe39b19f95a18f\";s:55:\"public/assets/assets/svg/maps/ic_local_parking_24px.svg\";s:64:\"97806f50a2746ced6ba24943f6a452d87231968b10fa95e7eecf75de6be52d9c\";s:56:\"public/assets/assets/svg/maps/ic_local_pharmacy_24px.svg\";s:64:\"e1958f85ff5fd0228ed73a49486a965cb09ca525a7159b76fedaa8c13f11da5f\";s:53:\"public/assets/assets/svg/maps/ic_local_phone_24px.svg\";s:64:\"90e91c5a06d5dd3138b6367236463d917fd7f7114d2e4b50ced8ac4d6bfc7672\";s:53:\"public/assets/assets/svg/maps/ic_local_pizza_24px.svg\";s:64:\"6a48abd4760f5556baf986b4d16b80dfcbf898f6a1cf55bca8e7cb79ad7e25ee\";s:52:\"public/assets/assets/svg/maps/ic_local_play_24px.svg\";s:64:\"0f4e3619863d3f0cd8314f5816104650b42c083a89bf6110f2c1607ff329008b\";s:59:\"public/assets/assets/svg/maps/ic_local_post_office_24px.svg\";s:64:\"36855acaeb73e1543f77500e12a3db813a0cf698a310e337306a9042dcf607ed\";s:57:\"public/assets/assets/svg/maps/ic_local_printshop_24px.svg\";s:64:\"7ea1c5ab4938c31fff7349644e8181445d15a9576418e3ec0a5ff20ec4f3efd7\";s:51:\"public/assets/assets/svg/maps/ic_local_see_24px.svg\";s:64:\"752837fd86ca522bc055c564a6eac167fd011ea807a3a9ef86509b6eadeb015d\";s:56:\"public/assets/assets/svg/maps/ic_local_shipping_24px.svg\";s:64:\"99c1d7acde91364df2b3f239fc812639286cb27ce089290eea2ac6d5706ee553\";s:52:\"public/assets/assets/svg/maps/ic_local_taxi_24px.svg\";s:64:\"b919ea27f949fcb15a2522a45f2e641d962daa0e2dc60257121c4434ea8a7dfa\";s:45:\"public/assets/assets/svg/maps/ic_map_24px.svg\";s:64:\"db0a088d41c6c6fa198b1c78282640d473c21b6a38aefdc81d6d537ad29b3f21\";s:53:\"public/assets/assets/svg/maps/ic_my_location_24px.svg\";s:64:\"5067b58e47e1b295b815c4218624d821702892d97e8ad8d6bb75837979a4237e\";s:52:\"public/assets/assets/svg/maps/ic_navigation_24px.svg\";s:64:\"8c607d8e6e86a43ab6453439e82a206eba832b70e785f6bcd43ba5a0d5131922\";s:49:\"public/assets/assets/svg/maps/ic_near_me_24px.svg\";s:64:\"b5fe5fc7478a697901c31ee9188b1cb1f0bf80e4f3c82d93fb6b907a4f6a4fe3\";s:52:\"public/assets/assets/svg/maps/ic_person_pin_24px.svg\";s:64:\"0ceaa7e197c559a615af4fd5df1f8a7b591d50c703e1b914a3749ca3242d92a7\";s:59:\"public/assets/assets/svg/maps/ic_person_pin_circle_24px.svg\";s:64:\"4fba671b77369b1edecc5cbda1d57d9b1ad902f1614ac3b2820e6f43135d8934\";s:50:\"public/assets/assets/svg/maps/ic_pin_drop_24px.svg\";s:64:\"aaa411c0b6b2bf50c4bb5ed52e04c3d70957d8d27fcbd1d6b5029ff7c4588edb\";s:47:\"public/assets/assets/svg/maps/ic_place_24px.svg\";s:64:\"b989d3c8cfe19edd295378071c23de9c787cbc6ee66cc6a83023968837d0a88f\";s:53:\"public/assets/assets/svg/maps/ic_rate_review_24px.svg\";s:64:\"5fb92d258ba49e23ae9a58ba2c059d6374cff427a63e6a4b563f8f116437c0b9\";s:57:\"public/assets/assets/svg/maps/ic_restaurant_menu_24px.svg\";s:64:\"8c619a3dbfa9957d3237208556a03367fa099d5bf80b03e369328125e5ca1681\";s:51:\"public/assets/assets/svg/maps/ic_satellite_24px.svg\";s:64:\"8551b3ae4abd3e1b9e76efe114393dd1381a97d7b610e0cae92134427b67c43a\";s:62:\"public/assets/assets/svg/maps/ic_store_mall_directory_24px.svg\";s:64:\"61aae36d8f51d94ffa1f6b35ef20d433d714158375d94ced41d74a92b46e09d8\";s:49:\"public/assets/assets/svg/maps/ic_terrain_24px.svg\";s:64:\"0a5c59a48aa9ee4e4be607609fce70e5ea694d775792f54a70e9ad144d054851\";s:49:\"public/assets/assets/svg/maps/ic_traffic_24px.svg\";s:64:\"95c9b4610eea7ac052966bff64a7dceef6a8004bbf5e8226ae26b4494bf1d5d2\";s:54:\"public/assets/assets/svg/maps/ic_zoom_out_map_24px.svg\";s:64:\"d4847a4313cdb7492c29fde9608aba6b9ee591cf5a9f2d147fa81ee348604cbd\";s:52:\"public/assets/assets/svg/navigation/ic_apps_24px.svg\";s:64:\"3c1277e9cfc9c72963acd319a9452a7b93f805761159c1f614f8d2df913e55db\";s:52:\"public/assets/assets/svg/navigation/ic_apps_36px.svg\";s:64:\"8ca56bde95147ac71153f275894a9e54598af918961fab1672ad540f1e43c246\";s:58:\"public/assets/assets/svg/navigation/ic_arrow_back_24px.svg\";s:64:\"ad23ffb6d1c3708a262427c1e2241806d32d41246c248c79197ced6a5f091388\";s:58:\"public/assets/assets/svg/navigation/ic_arrow_back_36px.svg\";s:64:\"18ea6f93092f0e3e7d190826526cd5adefa2e97aef88e67ea16be021f3cc4c9f\";s:62:\"public/assets/assets/svg/navigation/ic_arrow_downward_24px.svg\";s:64:\"dd8deb85c82313c5aeb4936857fd99cb38a617507fb65afddf289941b99ae9f2\";s:63:\"public/assets/assets/svg/navigation/ic_arrow_drop_down_24px.svg\";s:64:\"628efa55ab34dc4b5d484da2d4ff2aebf9bf51f570d1adf827330185acbfe8d8\";s:63:\"public/assets/assets/svg/navigation/ic_arrow_drop_down_36px.svg\";s:64:\"0b237a12d712152381ac4827f0b5ee0df8c1332115963790ec450e0cc2945a6d\";s:70:\"public/assets/assets/svg/navigation/ic_arrow_drop_down_circle_24px.svg\";s:64:\"5c0648308c3cfc9d831728f7db8a8a290d8efea0fc5054eb9e02611d7b4db0c8\";s:61:\"public/assets/assets/svg/navigation/ic_arrow_drop_up_24px.svg\";s:64:\"f4e26b35598653ba5dfc0076ff043cb7210470046e975b20b6c9823ca36a24b9\";s:61:\"public/assets/assets/svg/navigation/ic_arrow_drop_up_36px.svg\";s:64:\"6ed7a19564036353f945265c0ad098660dd5b391ab26e7c4d768f5b069543f57\";s:61:\"public/assets/assets/svg/navigation/ic_arrow_forward_24px.svg\";s:64:\"a56f4833cc71247f85a97f4b29eb98e86061d0550736061b584e3a2b157da64c\";s:61:\"public/assets/assets/svg/navigation/ic_arrow_forward_36px.svg\";s:64:\"6b9cc0d066941fb9c53ad214fc29cf15feda380a2fe38a487d6c65c846d7b25f\";s:60:\"public/assets/assets/svg/navigation/ic_arrow_upward_24px.svg\";s:64:\"76d31a5591d1044d0461ee6dc482580e9797101dc96a47bbd53cef9930777f85\";s:54:\"public/assets/assets/svg/navigation/ic_cancel_24px.svg\";s:64:\"0ea7671d0b99f8245208eda58e3bc3c633f715bc8ceb9fb2cf60ea5eeda9bda9\";s:54:\"public/assets/assets/svg/navigation/ic_cancel_36px.svg\";s:64:\"7fc96469cbc28e2caa5953f1ded91f3be05ade1bc7823a45030eda3968f05017\";s:53:\"public/assets/assets/svg/navigation/ic_check_24px.svg\";s:64:\"86ece4b96d4a170c2ad15d07ab2ccf33fcbf4524bbee09e441fec8d5770cc78d\";s:53:\"public/assets/assets/svg/navigation/ic_check_36px.svg\";s:64:\"4bc96e11a03467805bbf9f11d171bfa48816fa9ba9ed770e9dab3c77994520e6\";s:60:\"public/assets/assets/svg/navigation/ic_chevron_left_24px.svg\";s:64:\"ad918f7ec0ff89298e84586b5b98cdf628c8457cd067dc592031fae783f71a1d\";s:60:\"public/assets/assets/svg/navigation/ic_chevron_left_36px.svg\";s:64:\"dc3d0b54480835cf5912005be8893af846ef23f7c1f07e39c3f68256e8930a13\";s:61:\"public/assets/assets/svg/navigation/ic_chevron_right_24px.svg\";s:64:\"83f0da9735a4e475b0eca23b708ba09b2b7411e7d711b2d6be24bc2371d67ec8\";s:61:\"public/assets/assets/svg/navigation/ic_chevron_right_36px.svg\";s:64:\"6aad996be11d984d5897c044cdeb74038b9c742e4e8ac19b708dbfdd056c8123\";s:53:\"public/assets/assets/svg/navigation/ic_close_24px.svg\";s:64:\"6d4ccf520d400755057a1739a66c0feda3c98bbc34e8e7f79afa630b2e43f87e\";s:53:\"public/assets/assets/svg/navigation/ic_close_36px.svg\";s:64:\"b8a5a6694734dea198ca4b7784aa675785a4d643e809dae49a1e53dddfd1d8a7\";s:59:\"public/assets/assets/svg/navigation/ic_expand_less_24px.svg\";s:64:\"e52d4acf9d020f85e9fc674479d3ed60ccdd1aa1e6ef3b75f8cd75f1c2284030\";s:59:\"public/assets/assets/svg/navigation/ic_expand_less_36px.svg\";s:64:\"4c18f894185ddc77351e5c61b523a8595847bfc8701006b3e368eba4eaa1f970\";s:59:\"public/assets/assets/svg/navigation/ic_expand_more_24px.svg\";s:64:\"f83d9a4e6a9af95c9321a34f2564e9d45483834fa17f5da5a3a403500636360a\";s:59:\"public/assets/assets/svg/navigation/ic_expand_more_36px.svg\";s:64:\"157af90b3af01c2f1abd4bfc3fdfefc5ec530e064876e0073ccd8628010e091e\";s:58:\"public/assets/assets/svg/navigation/ic_fullscreen_24px.svg\";s:64:\"258698b2e9e9f51626a59775e645a294128fd03efdc77664721bfbb202dacf61\";s:58:\"public/assets/assets/svg/navigation/ic_fullscreen_36px.svg\";s:64:\"59f546b013c18ba1ce00152a25844a9720b47444dba202d41fba13ce480b3b41\";s:63:\"public/assets/assets/svg/navigation/ic_fullscreen_exit_24px.svg\";s:64:\"b2564cb9d5f26ff700138df661467c100d08ab77ba71c865262e0bfc7a255588\";s:63:\"public/assets/assets/svg/navigation/ic_fullscreen_exit_36px.svg\";s:64:\"7f1ff197ca0b288051726acb8b5cb85592d66ea405a9b75c42fafaca4ee9698b\";s:52:\"public/assets/assets/svg/navigation/ic_menu_24px.svg\";s:64:\"caa8cc99e1be32ab478ebbe12f4515de429a57573bd718a80ffad6d37307368b\";s:52:\"public/assets/assets/svg/navigation/ic_menu_36px.svg\";s:64:\"e5e098b0ecf050285e46970f7fad066749330f2f77b8569db0392d8c0c0d6302\";s:58:\"public/assets/assets/svg/navigation/ic_more_horiz_24px.svg\";s:64:\"02f1d5a094ca801a1894b768a61fea2294bdb00e3c9770939b141d42cbd5c40d\";s:58:\"public/assets/assets/svg/navigation/ic_more_horiz_36px.svg\";s:64:\"838b27ffbc33501ddbd8b707e0fc8e6b13bf1b58a7a10896da1a752cc99e1be4\";s:57:\"public/assets/assets/svg/navigation/ic_more_vert_24px.svg\";s:64:\"6c7113da4bf372feb6c320a461f0c510fa8b92626a52b08cdeda3063070b3570\";s:57:\"public/assets/assets/svg/navigation/ic_more_vert_36px.svg\";s:64:\"9d0f32dc9d3c6aba915462ae6adf46f5a54cbb6aabb4473f3d9bdd0e6b6a6b7d\";s:55:\"public/assets/assets/svg/navigation/ic_refresh_24px.svg\";s:64:\"b4d30acd39de79f490eff59d72fb1f06502c117c8815359d539e4f20515494de\";s:55:\"public/assets/assets/svg/navigation/ic_refresh_36px.svg\";s:64:\"48ea4ac2eaefee7852891b5dfc92d46a4fca3a1cc147663ba61922601c3b65ad\";s:71:\"public/assets/assets/svg/navigation/ic_subdirectory_arrow_left_24px.svg\";s:64:\"137d2667f061fbfb52b38287d7bed7a918dddf13760b02f475c0464dd5aebaa0\";s:72:\"public/assets/assets/svg/navigation/ic_subdirectory_arrow_right_24px.svg\";s:64:\"a76af3d9a4a1122abf3d3150deaacdc9af4ec7f4472c623d98531cdd20f9977e\";s:59:\"public/assets/assets/svg/navigation/ic_unfold_less_24px.svg\";s:64:\"d2917fac8d78d65417ee51e4cc3464177b34a1e926d85e0cc2e27f23bb2c5c6d\";s:59:\"public/assets/assets/svg/navigation/ic_unfold_less_36px.svg\";s:64:\"f75b5b645f3beaa444f464e406f4eece7e81436cb5f8a73a6ecf4ba558054cdb\";s:59:\"public/assets/assets/svg/navigation/ic_unfold_more_24px.svg\";s:64:\"75b32d01d02abe6918e2c7f9dbadbd4251a4ebac04029c0e0a80d98fa686b2f2\";s:59:\"public/assets/assets/svg/navigation/ic_unfold_more_36px.svg\";s:64:\"28c460ce61e5231b92a7ee941d4f7977bce2f72100609b7763f254a94334a088\";s:53:\"public/assets/assets/svg/notification/ic_adb_24px.svg\";s:64:\"57742bad57f3e1caef545d2bb02eb64ba6b6264484245205964e3b44d9813954\";s:67:\"public/assets/assets/svg/notification/ic_airline_seat_flat_24px.svg\";s:64:\"0207a40e4cc3a1bcaf007ed27567adb7dc9f4244fe4410b77fbe7a926b5c82a6\";s:74:\"public/assets/assets/svg/notification/ic_airline_seat_flat_angled_24px.svg\";s:64:\"dea3962488758c18826bfab8659cfa819f56437b5db855c9a83a6f92f940de55\";s:79:\"public/assets/assets/svg/notification/ic_airline_seat_individual_suite_24px.svg\";s:64:\"3c7385ee8637236b7ec433c511de320743b4f17eb62d7c1326b4149eed4e8271\";s:76:\"public/assets/assets/svg/notification/ic_airline_seat_legroom_extra_24px.svg\";s:64:\"dc05fb697a75db2a6097f1b5b6bb173953c5d219cad9173be5215ceca2f89816\";s:77:\"public/assets/assets/svg/notification/ic_airline_seat_legroom_normal_24px.svg\";s:64:\"fef9f446181e41a2bc20d039fa1b98b4869baa4e1e868db4bc5adfe27fe0aca5\";s:78:\"public/assets/assets/svg/notification/ic_airline_seat_legroom_reduced_24px.svg\";s:64:\"b1be07066946cc32ce7931116776cc3371f89e47eb5b6122c5b64916fad514f1\";s:76:\"public/assets/assets/svg/notification/ic_airline_seat_recline_extra_24px.svg\";s:64:\"4826c12e47f559bed671f3c2a30eb87e61124849aa31249d1d3c07efc56f80bb\";s:77:\"public/assets/assets/svg/notification/ic_airline_seat_recline_normal_24px.svg\";s:64:\"367d631d822b7bbd704afcfc737eca91e7b1d5a27a776d56c69ff7859ebc9656\";s:65:\"public/assets/assets/svg/notification/ic_bluetooth_audio_24px.svg\";s:64:\"e6cc41bdf18f24f7f9dd00899ebc5e91e10268b2ec4c5426e84fc6b99539c27a\";s:69:\"public/assets/assets/svg/notification/ic_confirmation_number_24px.svg\";s:64:\"0d8e1e89708789afb596efaa3b61127208bc05fd019235b6acbc0c9b905cfb15\";s:59:\"public/assets/assets/svg/notification/ic_disc_full_24px.svg\";s:64:\"4af8e28fb9b73f1b62ba5c23ed1e6c46c01b3c01a7d4194c78b2015ce46c18e3\";s:64:\"public/assets/assets/svg/notification/ic_do_not_disturb_24px.svg\";s:64:\"1e87a9fc6d4fc9f66fa9eef5726764ab9a7afd32cc7eda04106bf8308007ed24\";s:68:\"public/assets/assets/svg/notification/ic_do_not_disturb_alt_24px.svg\";s:64:\"8c8126f2d347353820a76c680621ea35086b534a29d2bc605e14df75a29cea78\";s:59:\"public/assets/assets/svg/notification/ic_drive_eta_24px.svg\";s:64:\"1934626cab4bba2052ee003b226a6dc47026724a8da2a7c1b039af0095fc9ea6\";s:69:\"public/assets/assets/svg/notification/ic_enhanced_encryption_24px.svg\";s:64:\"317afd6384dca1e028843ecf978bd5d17839bf7e11974dc7db8e81b53adec70c\";s:65:\"public/assets/assets/svg/notification/ic_event_available_24px.svg\";s:64:\"4926ebf928d1ae5f6cd48493e383d838ae5187e6f301ed5a74fc0c6a7838ff7f\";s:60:\"public/assets/assets/svg/notification/ic_event_busy_24px.svg\";s:64:\"785f09db3b2e75f24c52f790972103d99059c9359fdd75001c37c86231307bae\";s:60:\"public/assets/assets/svg/notification/ic_event_note_24px.svg\";s:64:\"33d33c7817ff1c93add85d8121f802e949d76d93201bd4b40a5c33b185020e10\";s:64:\"public/assets/assets/svg/notification/ic_folder_special_24px.svg\";s:64:\"97da3ee3627726046cc9aa1dcf2ce9a607730f986f5eb37b9d2458a2a57a00f4\";s:57:\"public/assets/assets/svg/notification/ic_live_tv_24px.svg\";s:64:\"f56d36488b62417c06dcbcf0b06a4352f435177e53c4d2af46588613ecb001f0\";s:53:\"public/assets/assets/svg/notification/ic_mms_24px.svg\";s:64:\"de3c9f1230b7919cc9d9c944c426cb5bbefab1240bda15bbfafaf489e92ec901\";s:54:\"public/assets/assets/svg/notification/ic_more_24px.svg\";s:64:\"fab3c9939451898de27e76d871d7578253e112c06c49ccf022fc49fc58ac0025\";s:63:\"public/assets/assets/svg/notification/ic_network_check_24px.svg\";s:64:\"2fa319fd293a63aa641f5c7e91884ada4c8c66d56eccb744a63f0f84921386b9\";s:64:\"public/assets/assets/svg/notification/ic_network_locked_24px.svg\";s:64:\"6b435b0e033283ebc6f5736fb0ed6d898ad28d88ea8bbeafc2720b46655f81ea\";s:63:\"public/assets/assets/svg/notification/ic_no_encryption_24px.svg\";s:64:\"7ba0371db7fe10b3e6ea2eec340cf2cb6307a47579b1e10016da158c9d4178cb\";s:64:\"public/assets/assets/svg/notification/ic_ondemand_video_24px.svg\";s:64:\"4a2a449975c26d9048af2ae1f59421600959b93225d0bfa1cc3779fd6a5a867c\";s:64:\"public/assets/assets/svg/notification/ic_personal_video_24px.svg\";s:64:\"596a4e549512ae5fef4f81428d215d3b4e3f755a425c4725bb1b72945eeab717\";s:73:\"public/assets/assets/svg/notification/ic_phone_bluetooth_speaker_24px.svg\";s:64:\"c931e2d1a5888be8e5e7e846b3aff76831ee74ba3df8d2282643ff91643ecb65\";s:65:\"public/assets/assets/svg/notification/ic_phone_forwarded_24px.svg\";s:64:\"762b74421577d0dafc7d5b668722ddcdfb02181f78ad9123fdf4d47c130722f0\";s:63:\"public/assets/assets/svg/notification/ic_phone_in_talk_24px.svg\";s:64:\"fb76ccb286a0c152c4d41908554f0bbda206d657db45e82c80065a7d26f5079b\";s:62:\"public/assets/assets/svg/notification/ic_phone_locked_24px.svg\";s:64:\"43c9a07d5ceeef8c471d950bd3504e1d531f3023bc701a6cda7a77ed64a4d9c0\";s:62:\"public/assets/assets/svg/notification/ic_phone_missed_24px.svg\";s:64:\"b452651c07bc5c03a02fa689d63227dddff2e5eb5a32a9af2f9ab6f7c8b9ef93\";s:62:\"public/assets/assets/svg/notification/ic_phone_paused_24px.svg\";s:64:\"db524aabd3000d6b7eafe9d4feefa551c15b6d2b6f4037c91cf55941318405cd\";s:55:\"public/assets/assets/svg/notification/ic_power_24px.svg\";s:64:\"0b8b2a2e69e7f05bb2cb5b0c273762b558d160c76a2e17b143306aef47bb451a\";s:59:\"public/assets/assets/svg/notification/ic_rv_hookup_24px.svg\";s:64:\"ecc2730db3f9082d9fef02cd888e729f240735c8e325ef3fedfa32406d100e96\";s:57:\"public/assets/assets/svg/notification/ic_sd_card_24px.svg\";s:64:\"9f4cd0b97e1106e9016f54bcc3d02159cd0bf275110575f4d4497fdbbd2936e4\";s:64:\"public/assets/assets/svg/notification/ic_sim_card_alert_24px.svg\";s:64:\"3136d5bcd4c6d662913e22d6c2e5048c2d54324102c03f07bf22a700c556821b\";s:53:\"public/assets/assets/svg/notification/ic_sms_24px.svg\";s:64:\"df528d71ba49e60b247601e7d24dd171f3d803e978b4615e0e01a16a6ec1bcf7\";s:60:\"public/assets/assets/svg/notification/ic_sms_failed_24px.svg\";s:64:\"595ba91ca31e088440162257d23e9088e10d5e275d14723a54c0bebcf7675af1\";s:54:\"public/assets/assets/svg/notification/ic_sync_24px.svg\";s:64:\"d9efa9690a6a43ddb127ce41d3b5b05305c174e24776937718fe55eafe85d498\";s:63:\"public/assets/assets/svg/notification/ic_sync_disabled_24px.svg\";s:64:\"da659ba5ce01b77a5dc461a7f851df23344f203e26ebfc91eb3e0c09606b9ec2\";s:62:\"public/assets/assets/svg/notification/ic_sync_problem_24px.svg\";s:64:\"0bed029dcb98e0f7f7ab75750b385c567c409b93666f5403e7dbf28a5f993afc\";s:63:\"public/assets/assets/svg/notification/ic_system_update_24px.svg\";s:64:\"43c6fb6e5e577e53a3c9ac9f7efe043534f42b0f37333907648013f8d6c9ae47\";s:62:\"public/assets/assets/svg/notification/ic_tap_and_play_24px.svg\";s:64:\"9aaa7bb86e9bd46d3e9310f9adc89d1a099b86cb3577e3f0208e101cb0afde34\";s:63:\"public/assets/assets/svg/notification/ic_time_to_leave_24px.svg\";s:64:\"1934626cab4bba2052ee003b226a6dc47026724a8da2a7c1b039af0095fc9ea6\";s:59:\"public/assets/assets/svg/notification/ic_vibration_24px.svg\";s:64:\"dcc1994765a71d41e8906dd391e10be02e52a259a4e69b92aa3b4580f18fa076\";s:60:\"public/assets/assets/svg/notification/ic_voice_chat_24px.svg\";s:64:\"6d4a1b98a723a460a9a32b095da9bc5df749df39b6b9e0d50fb88b677fb57b3d\";s:58:\"public/assets/assets/svg/notification/ic_vpn_lock_24px.svg\";s:64:\"8e5a74342b8ba307072876895848e01e1e14ee1ecbbf38f695daa2f013b089d7\";s:52:\"public/assets/assets/svg/notification/ic_wc_24px.svg\";s:64:\"7c287b67fad3ff447e813efba3c83052bcf843cc3ba8d9de1420c4444f28be5d\";s:54:\"public/assets/assets/svg/notification/ic_wifi_24px.svg\";s:64:\"89b4ab6b61b4582f9a4bbd4f1f079a1eed09f4f8bfdb1d223d74401b14c225c7\";s:51:\"public/assets/assets/svg/places/ic_ac_unit_24px.svg\";s:64:\"8328495d30929ba2c4c7a392e1e3c0f834898ca468e4cacd361add0711253358\";s:59:\"public/assets/assets/svg/places/ic_airport_shuttle_24px.svg\";s:64:\"0615b389117c71a99d1ac6d3d22d4c4e299f106ae5307d2fbeecab1b300040d4\";s:57:\"public/assets/assets/svg/places/ic_all_inclusive_24px.svg\";s:64:\"4eeef528914c1bc78720fe1b5c7f32139166bd0d8c8d50c1494079da166e1813\";s:56:\"public/assets/assets/svg/places/ic_beach_access_24px.svg\";s:64:\"8de6baf2279778b827c9b91c4922a2768d6247e063101d969094f4fb667847e9\";s:59:\"public/assets/assets/svg/places/ic_business_center_24px.svg\";s:64:\"0b0a3b719761637240c05495f1b621bd033c48af368d70b8c3a4ecbc4be0cd00\";s:50:\"public/assets/assets/svg/places/ic_casino_24px.svg\";s:64:\"1eea8acf884ebefec936fca0bde9e6ecb235f6d1b54aed8728b0cc6bdcd76711\";s:54:\"public/assets/assets/svg/places/ic_child_care_24px.svg\";s:64:\"fd500c24ebcf200e699080c177c08ded5d607c35a8fe5051f79fef2c5bafa9f6\";s:58:\"public/assets/assets/svg/places/ic_child_friendly_24px.svg\";s:64:\"21ca7da9f2342241511e66b41acb43296e832e99a0f2eea8115dd3b817c52d8a\";s:58:\"public/assets/assets/svg/places/ic_fitness_center_24px.svg\";s:64:\"a189a5a954c1dd8a2689bb2bb620e617f1ae1f8ba2177c2eea12d5cdd56f4f15\";s:58:\"public/assets/assets/svg/places/ic_free_breakfast_24px.svg\";s:64:\"4559ed7ae22c215c73bdc839bae5adde38eab54a3318cb7b1bddc01b1b9eb17c\";s:55:\"public/assets/assets/svg/places/ic_golf_course_24px.svg\";s:64:\"a11a04580d76a17ef8e966f1ea02fbe2342ce2f1a5fb1c35bbba7a8ee64c15a6\";s:51:\"public/assets/assets/svg/places/ic_hot_tub_24px.svg\";s:64:\"1611b82df600962652d050bf2e1563895301761012a8769b77af56bf7fb0de92\";s:51:\"public/assets/assets/svg/places/ic_kitchen_24px.svg\";s:64:\"fcfa9a3d4ee79efc0e03e9f96bb95311be8341feea591e0809f88fb97dd24f0c\";s:48:\"public/assets/assets/svg/places/ic_pool_24px.svg\";s:64:\"c15f987c3543385951182fd0b525af4b00e01fccecf857111d8415eae8143c65\";s:56:\"public/assets/assets/svg/places/ic_room_service_24px.svg\";s:64:\"0b2b7982f481c6de35ca7b6913789c343be3a808bc8cf7bbd5149739edda3b03\";s:54:\"public/assets/assets/svg/places/ic_smoke_free_24px.svg\";s:64:\"91d969a9e8c3b490906e73201c5228bbff1229f40e547e4dd3c3eb7b1d65e68c\";s:57:\"public/assets/assets/svg/places/ic_smoking_rooms_24px.svg\";s:64:\"57863fc6c1c21834b1c416e43f419a243c85ddac3f390ca10370e0f7436251fe\";s:47:\"public/assets/assets/svg/places/ic_spa_24px.svg\";s:64:\"c87063487bcaaec840c542f11709144da26145b0381eeacd0ac5b08c68a66d8f\";s:48:\"public/assets/assets/svg/social/ic_cake_24px.svg\";s:64:\"7807dc4716aa3aeb1074e28bd546375c419d5ac7421d39db1ebc39877c730526\";s:50:\"public/assets/assets/svg/social/ic_domain_24px.svg\";s:64:\"8e9c8f7a170c7c8e31e3f3e2012a8e9d8ba63e99617b9e2f5a6064ab52ec89c2\";s:49:\"public/assets/assets/svg/social/ic_group_24px.svg\";s:64:\"c110bea10dff2f63fa3bd2da9e295be19721475e0848ca0a79422eb4b06f651e\";s:53:\"public/assets/assets/svg/social/ic_group_add_24px.svg\";s:64:\"99e7f96a91227e99b63914c6414e8fdf5f9f249343731c2367debea12b9174ba\";s:57:\"public/assets/assets/svg/social/ic_location_city_24px.svg\";s:64:\"e21ef38072992511457bf66f7539d193348ce9c90ddefa0db38448bc1239c408\";s:48:\"public/assets/assets/svg/social/ic_mood_24px.svg\";s:64:\"975c5664d2b367f8a033b4eba9f34c6aafbad9b0b4cd25d5e5a1b122758a848a\";s:52:\"public/assets/assets/svg/social/ic_mood_bad_24px.svg\";s:64:\"53dbf304a72ba6af32e34c5f2b6e1e79b2ddd040f4d41729c3340f1b9e165aa3\";s:57:\"public/assets/assets/svg/social/ic_notifications_24px.svg\";s:64:\"4c0f4c122621be3e94054e8146950bc1d925786d5ece13ab48cb3305e504ab34\";s:64:\"public/assets/assets/svg/social/ic_notifications_active_24px.svg\";s:64:\"831d99cb456fd15e7bba1b45e5cd8217c07b5df677e773b5b348ebd443f9ef9a\";s:62:\"public/assets/assets/svg/social/ic_notifications_none_24px.svg\";s:64:\"d3d47d3e3832b2be80ff2b96b014a8464eb1329e1f69c3f7443710d771ac634e\";s:61:\"public/assets/assets/svg/social/ic_notifications_off_24px.svg\";s:64:\"80ce6ff54e8587412b4888693b736523433daad7c073ea27b6cd56a96025f456\";s:64:\"public/assets/assets/svg/social/ic_notifications_paused_24px.svg\";s:64:\"52864efef61df051f7c7eaf21e51a70ec7a5c73eb732aa22d6a5c4a35b4fa100\";s:49:\"public/assets/assets/svg/social/ic_pages_24px.svg\";s:64:\"9e0c77ad7dde4bb3df66c9b6e8144852ebbda101ecdb75acc44a05a03ecb1649\";s:54:\"public/assets/assets/svg/social/ic_party_mode_24px.svg\";s:64:\"6ffeb0bafeb03d590ce975b59801c7be420e6adfab274d44ff09911a8dde15aa\";s:50:\"public/assets/assets/svg/social/ic_people_24px.svg\";s:64:\"c110bea10dff2f63fa3bd2da9e295be19721475e0848ca0a79422eb4b06f651e\";s:58:\"public/assets/assets/svg/social/ic_people_outline_24px.svg\";s:64:\"0627ad1ec839929e39e41f75405b04eb54060d114a5d16f34de570c0247aa2f9\";s:50:\"public/assets/assets/svg/social/ic_person_24px.svg\";s:64:\"ffdea6f91108e42ea3a7773a58789a4ae00d17fc16951c67c02361cd29aacfbf\";s:54:\"public/assets/assets/svg/social/ic_person_add_24px.svg\";s:64:\"0f54e3a55b97dc50b28150464605ed898796458d02befcfe0fcaef748e8a91ef\";s:58:\"public/assets/assets/svg/social/ic_person_outline_24px.svg\";s:64:\"4898e25f97f9ec192a657033130950a2501d4d9e3035591b0aee07cdff009d6f\";s:52:\"public/assets/assets/svg/social/ic_plus_one_24px.svg\";s:64:\"9e1c16a7396feed1c68333a54da3255f6297c9ceecde51f7887c7189476c7468\";s:48:\"public/assets/assets/svg/social/ic_poll_24px.svg\";s:64:\"251b8d550df4665af92dd66a774ae43f0f002826a4b091b86c1310a28e9e8c87\";s:50:\"public/assets/assets/svg/social/ic_public_24px.svg\";s:64:\"248fd4e58679a1adf37fe84451200807d8165ac3f2205cf8012e7a7d1454093c\";s:50:\"public/assets/assets/svg/social/ic_school_24px.svg\";s:64:\"dc1fd5e849487a9fe12feb5a3ffa4e5673a7a3872970bb9165b8a3ddd7b1ed35\";s:49:\"public/assets/assets/svg/social/ic_share_24px.svg\";s:64:\"b9661b194d213f72676b7e558f22a5470997b4f1e909cd4c103a7626149d1d57\";s:52:\"public/assets/assets/svg/social/ic_whatshot_24px.svg\";s:64:\"bceb20a8e489c7b415f2f0b73e818434d06992f247182a4ef8394faa20180b87\";s:53:\"public/assets/assets/svg/toggle/ic_check_box_24px.svg\";s:64:\"1b24ce514b9197e1fa046ee3cd440d4e90fdc2939c55f031bf19b6fa18fd090e\";s:67:\"public/assets/assets/svg/toggle/ic_check_box_outline_blank_24px.svg\";s:64:\"3080f6ead1244d6c0ed79481f7467109f1a6648e1c7d03f090715d8c828ce8b2\";s:67:\"public/assets/assets/svg/toggle/ic_indeterminate_check_box_24px.svg\";s:64:\"fc5d4fb68f3c9e0687bbc424194d61ce9902725d36cb3d647a8107eb898e7f8b\";s:64:\"public/assets/assets/svg/toggle/ic_radio_button_checked_24px.svg\";s:64:\"378662ea874451111a91a69b0df9b6c598e9f9408bc101a95ae44147223c6805\";s:66:\"public/assets/assets/svg/toggle/ic_radio_button_unchecked_24px.svg\";s:64:\"86b71e4b7190e7e4f11baf8fa051c9924154947e9512d4a4f3b41589337cae45\";s:48:\"public/assets/assets/svg/toggle/ic_star_24px.svg\";s:64:\"831a2d3bc08e707d81bcc14c883e3142e7fc0c29237aa18efd0942f5477de5f3\";s:55:\"public/assets/assets/svg/toggle/ic_star_border_24px.svg\";s:64:\"2b11172c0bc99e56230843bafd585be7f6fe24a2ac965a8838ef7542da3a1e2a\";s:53:\"public/assets/assets/svg/toggle/ic_star_half_24px.svg\";s:64:\"cd04fe9f671c9b1384b6908bac60ea2b7bb8da2ea265d2e52b62eea9a4a2adc5\";s:39:\"public/assets/css/captions-original.css\";s:64:\"8cb3f52aecde43da5f8e7a35916b85490c02f7d2dbcaef9324e8f75fbacf30d2\";s:32:\"public/assets/css/closedhand.cur\";s:64:\"d367ee0a4c16c7cebfdbf92c97a72ff63878e7f8be176ac8c5ede75a2265ec52\";s:27:\"public/assets/css/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:30:\"public/assets/css/openhand.cur\";s:64:\"080627fa359156339e79f118fa66a6937f09ff679fe87e8afa473b95c8168d35\";s:25:\"public/assets/css/rs6.css\";s:64:\"9883e503c2916e2bfa5aff13d031f28e0ca6124cf47ac81dc8013efe4e5d702c\";s:29:\"public/assets/fonts/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:42:\"public/assets/fonts/font-awesome/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:53:\"public/assets/fonts/font-awesome/css/font-awesome.css\";s:64:\"7cfd0c8f8464a7b46db267b79a793db18abed3247065a29933440eab1db6a8f9\";s:54:\"public/assets/fonts/font-awesome/fonts/FontAwesome.otf\";s:64:\"444dd4366615ffc4a16d012b2fa90137065d3ccb410fa6fd5e4ddd7b5e4ffcd5\";s:62:\"public/assets/fonts/font-awesome/fonts/fontawesome-webfont.eot\";s:64:\"7bfcab6db99d5cfbf1705ca0536ddc78585432cc5fa41bbd7ad0f009033b2979\";s:62:\"public/assets/fonts/font-awesome/fonts/fontawesome-webfont.svg\";s:64:\"ad6157926c1622ba4e1d03d478f1541368524bfc46f51e42fe0d945f7ef323e4\";s:62:\"public/assets/fonts/font-awesome/fonts/fontawesome-webfont.ttf\";s:64:\"aa58f33f239a0fb02f5c7a6c45c043d7a9ac9a093335806694ecd6d4edc0d6a8\";s:63:\"public/assets/fonts/font-awesome/fonts/fontawesome-webfont.woff\";s:64:\"ba0c59deb5450f5cb41b3f93609ee2d0d995415877ddfa223e8a8a7533474f07\";s:64:\"public/assets/fonts/font-awesome/fonts/fontawesome-webfont.woff2\";s:64:\"2adefcbc041e7d18fcf2d417879dc5a09997aa64d675b7a3c4b6ce33da13f3fe\";s:54:\"public/assets/fonts/material/MaterialIcons-Regular.eot\";s:64:\"8c998b4a9c0acbb9fe5dd572c206a5a33fdd5ca2b58db87fc3b893beac85068d\";s:56:\"public/assets/fonts/material/MaterialIcons-Regular.ijmap\";s:64:\"88182029715624355dbc49c97b3af61e311538ddd33d31c6f4d13b2937411d1d\";s:54:\"public/assets/fonts/material/MaterialIcons-Regular.svg\";s:64:\"8b922129360ee12051269278e95ccff05ab4a60ccd39b9117f8216ede63a91c0\";s:54:\"public/assets/fonts/material/MaterialIcons-Regular.ttf\";s:64:\"b7f4a3ab562048f28dd1fa691601bc43363a61d0f876d16d8316c52e4f32d696\";s:55:\"public/assets/fonts/material/MaterialIcons-Regular.woff\";s:64:\"c4a1baec300d09e03a8380b85918267ee80faae8e00c6c56b48e2e74b1d9b38d\";s:56:\"public/assets/fonts/material/MaterialIcons-Regular.woff2\";s:64:\"a87d66c91b2e7dc5530aef76c03bd6a3d25ea5826110bf4803b561b811cc8726\";s:38:\"public/assets/fonts/material/README.md\";s:64:\"402d2770ce34261fff627b7ca12775ad286be2d1e49a934d4bb9383139761ad2\";s:39:\"public/assets/fonts/material/codepoints\";s:64:\"dc0a89e73a83c4a4eeb14b9ae5a7bccb76f01fee1b13b243bfe9b266a249fc2d\";s:47:\"public/assets/fonts/material/material-icons.css\";s:64:\"afb727c828f3957ada8e546f9bce9c9c733bc1d2f09a83eb47f2114302cd9f2b\";s:46:\"public/assets/fonts/pe-icon-7-stroke/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:51:\"public/assets/fonts/pe-icon-7-stroke/css/helper.css\";s:64:\"9f41a375c19572ca63f812b33972ab31a732dc51a3e2a2995d7ef4ac54a48542\";s:50:\"public/assets/fonts/pe-icon-7-stroke/css/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:61:\"public/assets/fonts/pe-icon-7-stroke/css/pe-icon-7-stroke.css\";s:64:\"2121cf9366471712b8e93a1556848845b41507038288a68a667858d7a6a1178d\";s:63:\"public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.eot\";s:64:\"d9896922379aeb729a67c4bc12f2a51ee970c37ea079ee30f856fd2807fd3e9c\";s:63:\"public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.svg\";s:64:\"c869015d0bb7dc8dcc4bb372e60bee655a14199f6d370d12d762295ac7de721b\";s:63:\"public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.ttf\";s:64:\"99620ded1c4d61277630422146e2488b1afaef9be2dc0924ff3f75e2ecd71820\";s:64:\"public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.woff\";s:64:\"6fb4217048f333e23e0fd0ba2ab05e05fd7500f86a5a80a7cf04a2f94b257bec\";s:52:\"public/assets/fonts/pe-icon-7-stroke/fonts/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:38:\"public/assets/fonts/revicons/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:41:\"public/assets/fonts/revicons/revicons.eot\";s:64:\"9e4d4c6813568fdf70c61eca9446d1bb80f84e79e8f2e5ed177365b6d5de5fbf\";s:41:\"public/assets/fonts/revicons/revicons.svg\";s:64:\"80576a94aba7e5b97d33a3ebb50c0e656b2d8458a0ca38978216687f07d7a575\";s:41:\"public/assets/fonts/revicons/revicons.ttf\";s:64:\"4ca02b8a5c8034de8ddb76e33e50e8398758a83bd18a5073493cace46362780a\";s:42:\"public/assets/fonts/revicons/revicons.woff\";s:64:\"f7b9c3065e55fa3b9e320093612e7b30dcb14355a44ec461247b495a3e729686\";s:26:\"public/assets/js/index.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:40:\"public/assets/js/revolution.tools.min.js\";s:64:\"b7d24689b53d1b6aaf85a6aba13c1b9cd5bf0134c8cb0f8e666a0e71307961cf\";s:27:\"public/assets/js/rs6.min.js\";s:64:\"af3b949552b097c081fa4e8eef83f48fa62626b632de0d0027332733159c1c54\";s:42:\"public/includes/functions-public.class.php\";s:64:\"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855\";s:40:\"public/views/revslider-page-template.php\";s:64:\"955ddf273779cb261daf7e20ed4559986e2f4299c0c4644131aded0e367dc65b\";}s:4:\"time\";i:1581254182;}', 0),
 ('_activated', 0, 'a:3:{s:7:\"Version\";s:5:\"8.5.8\";s:4:\"time\";i:1581253928;s:4:\"user\";i:1;}', 0),
 ('cerber_user', 1, 'a:2:{s:10:\"last_login\";a:2:{s:2:\"ip\";s:13:\"190.75.83.206\";s:2:\"ua\";s:40:\"9f5da5cbbed810ff927fd5644f943514eb5a2e6d\";}s:11:\"2fa_history\";a:2:{i:0;i:7;i:1;i:1583409905;}}', 0),
 ('garbage_collector', 0, '1597163483', 0),
 ('cerber_admin_wide', 0, '', 0),
 ('refresh_add_on_list', 0, '0', 0),
 ('boot_cerber_addons', 0, 'a:0:{}', 0);

/* INSERT TABLE DATA: wp8b_cerber_uss */
INSERT INTO `wp8b_cerber_uss` VALUES(1, '186.167.250.237', '', 1597070585, 1597243385, 'w7ZpzASQUagKVdmCfjI6nbBu', 'b3c51eecdf892119f1305a2d40f43e5c9068aea8642578317dd20b9142d3916d'),
 (1, '190.75.83.206', '', 1597160241, 1597333041, 'fagAwJ5cskuKC721mEdIMNUq', 'c0413d98d51b1172459159e8ec41010d585c9919b40ce4d59d968f24fab8648c');

/* INSERT TABLE DATA: wp8b_comments */
INSERT INTO `wp8b_comments` VALUES(1, 1, 'A WordPress Commenter', 'wapuu@wordpress.example', 'https://wordpress.org/', '', '2020-01-06 12:44:36', '2020-01-06 12:44:36', 'Hi, this is a comment.\nTo get started with moderating, editing, and deleting comments, please visit the Comments screen in the dashboard.\nCommenter avatars come from <a href=\"https://gravatar.com\">Gravatar</a>.', 0, '1', '', '', 0, 0);

/* INSERT TABLE DATA: wp8b_duplicator_pro_entities */
INSERT INTO `wp8b_duplicator_pro_entities` VALUES(1, 'DUP_PRO_Global_Entity', '{\"uninstall_settings\":false,\"uninstall_packages\":false,\"uninstall_tables\":true,\"wpfront_integrate\":false,\"package_ui_created\":1,\"package_mysqldump\":0,\"package_mysqldump_path\":\"\",\"package_phpdump_mode\":0,\"package_phpdump_qrylimit\":500,\"package_php_chunking\":null,\"archive_build_mode\":2,\"archive_compression\":true,\"ziparchive_validation\":null,\"ziparchive_mode\":0,\"ziparchive_chunk_size_in_mb\":6,\"archive_build_mode_schedule\":-1,\"archive_compression_schedule\":true,\"server_load_reduction\":0,\"max_package_runtime_in_min\":90,\"php_max_worker_time_in_sec\":18,\"lock_mode\":1,\"json_mode\":0,\"ajax_protocol\":\"https\",\"custom_ajax_url\":\"http:\\/\\/modelox.vico.digital\\/wp-admin\\/admin-ajax.php\",\"server_kick_off_sslverify\":true,\"clientside_kickoff\":false,\"basic_auth_enabled\":false,\"basic_auth_user\":\"\",\"basic_auth_password\":\"\",\"installer_base_name\":\"installer.php\",\"chunk_size\":2048,\"skip_archive_scan\":false,\"send_email_on_build_mode\":1,\"notification_email_address\":\"\",\"storage_htaccess_off\":false,\"max_storage_retries\":10,\"max_default_store_files\":20,\"purge_default_package_record\":false,\"dropbox_upload_chunksize_in_kb\":2000,\"dropbox_transfer_mode\":1,\"gdrive_upload_chunksize_in_kb\":1000,\"s3_upload_part_size_in_kb\":6000,\"manual_mode_storage_ids\":[\"7\"],\"license_status\":0,\"license_expiration_time\":1578315559,\"license_no_activations_left\":false,\"license_key_visible\":true,\"lkp\":\"\",\"license_limit\":-1,\"last_edd_api_response\":null,\"last_edd_api_timestamp\":0,\"last_system_check_timestamp\":1597159999,\"initial_activation_timestamp\":1578315569,\"ssl_useservercerts\":true,\"ssl_disableverify\":true,\"ipv4_only\":false,\"debug_on\":false,\"trace_profiler_on\":false,\"profile_idea\":false,\"profile_beta\":false,\"dupHidePackagesGiftFeatures\":true,\"type\":\"DUP_PRO_Global_Entity\",\"notices\":{\"dupArchiveSwitch\":true}}'),
 (2, 'DUP_PRO_Secure_Global_Entity', '{\"basic_auth_password\":null,\"lkp\":\"\",\"type\":\"DUP_PRO_Secure_Global_Entity\"}'),
 (3, 'DUP_PRO_System_Global_Entity', '{\"recommended_fixes\":[],\"schedule_failed\":false,\"package_check_ts\":1597163482,\"type\":\"DUP_PRO_System_Global_Entity\"}'),
 (4, 'DUP_PRO_Package_Template_Entity', '{\"name\":\"Default\",\"notes\":\"The default template.\",\"filter_sites\":[],\"archive_export_onlydb\":0,\"archive_filter_on\":0,\"archive_filter_dirs\":\"\",\"archive_filter_exts\":\"\",\"archive_filter_files\":\"\",\"database_filter_on\":0,\"database_filter_tables\":\"\",\"database_compatibility_modes\":[],\"installer_opts_secure_on\":null,\"installer_opts_secure_pass\":null,\"installer_opts_skip_scan\":null,\"installer_opts_db_host\":null,\"installer_opts_db_name\":null,\"installer_opts_db_user\":null,\"installer_opts_cpnl_enable\":false,\"installer_opts_cpnl_host\":\"\",\"installer_opts_cpnl_user\":\"\",\"installer_opts_cpnl_pass\":\"\",\"installer_opts_cpnl_db_action\":\"create\",\"installer_opts_cpnl_db_host\":\"\",\"installer_opts_cpnl_db_name\":\"\",\"installer_opts_cpnl_db_user\":\"\",\"installer_opts_brand\":-2,\"is_default\":true,\"is_manual\":false,\"type\":\"DUP_PRO_Package_Template_Entity\"}'),
 (5, 'DUP_PRO_Package_Template_Entity', '{\"name\":\"[Manual Mode]\",\"notes\":\"\",\"filter_sites\":\"\",\"archive_export_onlydb\":0,\"archive_filter_on\":0,\"archive_filter_dirs\":\"\",\"archive_filter_exts\":\"\",\"archive_filter_files\":\"\",\"database_filter_on\":0,\"database_filter_tables\":\"\",\"database_compatibility_modes\":\"\",\"installer_opts_secure_on\":0,\"installer_opts_secure_pass\":\"\",\"installer_opts_skip_scan\":0,\"installer_opts_db_host\":\"\",\"installer_opts_db_name\":\"\",\"installer_opts_db_user\":\"\",\"installer_opts_cpnl_enable\":0,\"installer_opts_cpnl_host\":\"\",\"installer_opts_cpnl_user\":\"\",\"installer_opts_cpnl_pass\":\"\",\"installer_opts_cpnl_db_action\":\"create\",\"installer_opts_cpnl_db_host\":\"\",\"installer_opts_cpnl_db_name\":\"\",\"installer_opts_cpnl_db_user\":\"\",\"installer_opts_brand\":-2,\"is_default\":false,\"is_manual\":true,\"type\":\"DUP_PRO_Package_Template_Entity\"}'),
 (6, 'DUP_PRO_Storage_Entity', '{\"name\":\"Servidor Compralo\",\"notes\":\"\",\"storage_type\":\"2\",\"editable\":true,\"local_storage_folder\":\"\",\"local_max_files\":\"10\",\"local_filter_protection\":true,\"dropbox_access_token\":\"\",\"dropbox_access_token_secret\":\"\",\"dropbox_v2_access_token\":\"\",\"dropbox_storage_folder\":\"modelox.vico.digital\\/\",\"dropbox_max_files\":\"10\",\"dropbox_authorization_state\":0,\"onedrive_endpoint_url\":\"\",\"onedrive_resource_id\":\"\",\"onedrive_access_token\":\"\",\"onedrive_refresh_token\":\"\",\"onedrive_token_obtained\":\"\",\"onedrive_user_id\":\"\",\"onedrive_storage_folder\":\"modelox.vico.digital\\/\",\"onedrive_max_files\":\"10\",\"onedrive_storage_folder_id\":\"\",\"onedrive_authorization_state\":0,\"onedrive_storage_folder_web_url\":\"\",\"ftp_server\":\"51.91.128.199\",\"ftp_port\":\"21\",\"ftp_username\":\"compralo\",\"ftp_password\":\"WEBnet2020&%$\",\"ftp_storage_folder\":\"\\/desde_modelox\\/\",\"ftp_max_files\":\"10\",\"ftp_timeout_in_secs\":\"15\",\"ftp_ssl\":false,\"ftp_passive_mode\":false,\"sftp_server\":\"\",\"sftp_port\":22,\"sftp_username\":\"\",\"sftp_password\":\"\",\"sftp_private_key\":\"\",\"sftp_private_key_password\":\"\",\"sftp_storage_folder\":\"\\/\",\"sftp_timeout_in_secs\":15,\"sftp_max_files\":10,\"gdrive_access_token_set_json\":\"\",\"gdrive_refresh_token\":\"\",\"gdrive_storage_folder\":\"Duplicator Backups\\/modelox.vico.digital\\/\",\"gdrive_max_files\":\"10\",\"gdrive_authorization_state\":0,\"quick_connect\":false,\"s3_access_key\":\"\",\"s3_bucket\":\"\",\"s3_max_files\":\"10\",\"s3_provider\":\"amazon\",\"s3_region\":\"us-east-1\",\"s3_endpoint\":\"\",\"s3_secret_key\":\"\",\"s3_storage_class\":\"STANDARD\",\"s3_storage_folder\":\"Duplicator Backups\\/modelox.vico.digital\\/\",\"type\":\"DUP_PRO_Storage_Entity\"}'),
 (7, 'DUP_PRO_Storage_Entity', '{\"name\":\"iglesia uni\",\"notes\":\"\",\"storage_type\":\"2\",\"editable\":true,\"local_storage_folder\":\"\",\"local_max_files\":\"10\",\"local_filter_protection\":true,\"dropbox_access_token\":\"\",\"dropbox_access_token_secret\":\"\",\"dropbox_v2_access_token\":\"\",\"dropbox_storage_folder\":\"modelox.vico.digital\\/\",\"dropbox_max_files\":\"10\",\"dropbox_authorization_state\":0,\"onedrive_endpoint_url\":\"\",\"onedrive_resource_id\":\"\",\"onedrive_access_token\":\"\",\"onedrive_refresh_token\":\"\",\"onedrive_token_obtained\":\"\",\"onedrive_user_id\":\"\",\"onedrive_storage_folder\":\"modelox.vico.digital\\/\",\"onedrive_max_files\":\"10\",\"onedrive_storage_folder_id\":\"\",\"onedrive_authorization_state\":0,\"onedrive_storage_folder_web_url\":\"\",\"ftp_server\":\"51.91.128.199\",\"ftp_port\":\"21\",\"ftp_username\":\"promo\",\"ftp_password\":\"WEBnet2020$%&\",\"ftp_storage_folder\":\"\\/archivoiglesia\\/\",\"ftp_max_files\":\"10\",\"ftp_timeout_in_secs\":\"15\",\"ftp_ssl\":false,\"ftp_passive_mode\":false,\"sftp_server\":\"\",\"sftp_port\":22,\"sftp_username\":\"\",\"sftp_password\":\"\",\"sftp_private_key\":\"\",\"sftp_private_key_password\":\"\",\"sftp_storage_folder\":\"\\/\",\"sftp_timeout_in_secs\":15,\"sftp_max_files\":10,\"gdrive_access_token_set_json\":\"\",\"gdrive_refresh_token\":\"\",\"gdrive_storage_folder\":\"Duplicator Backups\\/modelox.vico.digital\\/\",\"gdrive_max_files\":\"10\",\"gdrive_authorization_state\":0,\"quick_connect\":false,\"s3_access_key\":\"\",\"s3_bucket\":\"\",\"s3_max_files\":\"10\",\"s3_provider\":\"amazon\",\"s3_region\":\"us-east-1\",\"s3_endpoint\":\"\",\"s3_secret_key\":\"\",\"s3_storage_class\":\"STANDARD\",\"s3_storage_folder\":\"Duplicator Backups\\/modelox.vico.digital\\/\",\"type\":\"DUP_PRO_Storage_Entity\"}'),
 (8, 'DUP_PRO_DupArchive_Expand_State_Entity', '{\"package_id\":\"1\",\"basePath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\\/validate\",\"archivePath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\\/20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327_archive.daf\",\"isCompressed\":true,\"currentFileOffset\":0,\"archiveOffset\":75181799,\"timeSliceInSecs\":10,\"working\":false,\"startTimestamp\":-1,\"throttleDelayInUs\":0,\"timeoutTimestamp\":1597161481,\"timerEnabled\":true,\"archiveHeaderString\":\"{\\\"version\\\":\\\"3.8.3.4\\\",\\\"isCompressed\\\":true}\",\"currentFileHeaderString\":null,\"failuresString\":\"[]\",\"validateOnly\":true,\"validationType\":1,\"fileWriteCount\":11482,\"directoryWriteCount\":1669,\"expectedFileCount\":11482,\"expectedDirectoryCount\":1669,\"isRobust\":false,\"type\":\"DUP_PRO_DupArchive_Expand_State_Entity\",\"currentFileHeader\":null,\"filteredDirectories\":[],\"filteredFiles\":[],\"includedFiles\":[],\"fileRenames\":[],\"directoryModeOverride\":-1,\"fileModeOverride\":-1,\"lastHeaderOffset\":-1,\"failures\":[]}');

/* INSERT TABLE DATA: wp8b_duplicator_pro_packages */
INSERT INTO `wp8b_duplicator_pro_packages` VALUES(1, '20200811_iglesiauniversitaria', 'ef8410f93c0e1aad7216_20200811155327', 100, '2020-08-11 15:54:32', 'unknown', '{\"Created\":\"2020-08-11 15:53:27\",\"Version\":\"3.8.3.4\",\"VersionWP\":\"5.4.2\",\"VersionDB\":\"5.7.31\",\"VersionPHP\":\"7.2.32\",\"VersionOS\":\"Linux\",\"ID\":\"1\",\"Name\":\"20200811_iglesiauniversitaria\",\"Hash\":\"ef8410f93c0e1aad7216_20200811155327\",\"NameHash\":\"20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327\",\"Type\":0,\"Notes\":\"\",\"StorePath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\",\"StoreURL\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/backups-dup-pro\\/\",\"ScanFile\":\"20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327_scan.json\",\"timer_start\":1597161288.3775470256805419921875,\"Runtime\":\"185.605 sec.\",\"ExeSize\":\"225.33KB\",\"ZipSize\":\"71.7MB\",\"Brand\":\"Default\",\"Brand_ID\":-2,\"ziparchive_mode\":0,\"Archive\":{\"ExportOnlyDB\":0,\"FilterDirs\":\"\",\"FilterExts\":\"\",\"FilterFiles\":\"\",\"FilterDirsAll\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/ai1wm-backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backupwordpress\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/contents\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/infinitewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/managewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/old-cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/wordfence\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/updraft\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/aiowps_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backup-guard\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_temp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/mainwp\\/backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/pb_backupbuddy\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/sucuri\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp-clone\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp_all_backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wpbackitup_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wfcache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wishlist-backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-snapshots\"],\"FilterExtsAll\":[],\"FilterFilesAll\":[\".DS_Store\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/zn_fonts\\/icomoon\\/icomoon\\/selection.json\",\"dbcache\",\"debug_log\",\"error.log\",\"error_log\",\"objectcache\",\"pgcache\",\"ws_ftp.log\"],\"FilterOn\":0,\"File\":\"20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327_archive.daf\",\"Format\":\"DAF\",\"PackDir\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"Size\":75181799,\"Dirs\":null,\"DirCount\":1649,\"RecursiveLinks\":[],\"Files\":null,\"FileCount\":11325,\"file_count\":12974,\"FilterInfo\":{\"Dirs\":{\"Warning\":[],\"Unreadable\":[],\"AddonSites\":[],\"Core\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\"],\"Global\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/ai1wm-backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backupwordpress\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/contents\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/infinitewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/managewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/old-cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/updraft\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wishlist-backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wfcache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/wordfence\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/aiowps_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_temp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/mainwp\\/backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/pb_backupbuddy\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/sucuri\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp-clone\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp_all_backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wpbackitup_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backup-guard\"],\"Instance\":[]},\"Files\":{\"Warning\":[],\"Unreadable\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/zn_fonts\\/icomoon\\/icomoon\\/selection.json\"],\"Size\":[],\"Core\":[],\"Global\":[\"error_log\",\"error.log\",\"debug_log\",\"ws_ftp.log\",\"dbcache\",\"pgcache\",\"objectcache\",\".DS_Store\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\"],\"Instance\":[]},\"Exts\":{\"Core\":[],\"Global\":[],\"Instance\":[]},\"TreeSize\":{\"tree\":{\"id\":\"0\",\"parentId\":\"\",\"name\":\"modelox\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"isDir\":true,\"childs\":{\"wp-blog-header.php\":{\"id\":\"0_0\",\"parentId\":\"0\",\"name\":\"wp-blog-header.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-blog-header.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".well-known\":{\"id\":\"0_1\",\"parentId\":\"0\",\"name\":\".well-known\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.well-known\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"error_log\":{\"id\":\"0_2\",\"parentId\":\"0\",\"name\":\"error_log\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/error_log\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-content\":{\"id\":\"0_3\",\"parentId\":\"0\",\"name\":\"wp-content\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"wp-signup.php\":{\"id\":\"0_4\",\"parentId\":\"0\",\"name\":\"wp-signup.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-signup.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".htaccess\":{\"id\":\"0_5\",\"parentId\":\"0\",\"name\":\".htaccess\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"cgi-bin\":{\"id\":\"0_6\",\"parentId\":\"0\",\"name\":\"cgi-bin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/cgi-bin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":false},\"wp-config.php\":{\"id\":\"0_7\",\"parentId\":\"0\",\"name\":\"wp-config.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-admin\":{\"id\":\"0_8\",\"parentId\":\"0\",\"name\":\"wp-admin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-admin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"php.ini\":{\"id\":\"0_9\",\"parentId\":\"0\",\"name\":\"php.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/php.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-mail.php\":{\"id\":\"0_10\",\"parentId\":\"0\",\"name\":\"wp-mail.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-mail.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"index.php\":{\"id\":\"0_11\",\"parentId\":\"0\",\"name\":\"index.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/index.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"xmlrpc.php\":{\"id\":\"0_12\",\"parentId\":\"0\",\"name\":\"xmlrpc.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/xmlrpc.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-config-sample.php\":{\"id\":\"0_13\",\"parentId\":\"0\",\"name\":\"wp-config-sample.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config-sample.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-trackback.php\":{\"id\":\"0_14\",\"parentId\":\"0\",\"name\":\"wp-trackback.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-trackback.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".user.ini\":{\"id\":\"0_15\",\"parentId\":\"0\",\"name\":\".user.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.user.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-login.php\":{\"id\":\"0_16\",\"parentId\":\"0\",\"name\":\"wp-login.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-login.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-settings.php\":{\"id\":\"0_17\",\"parentId\":\"0\",\"name\":\"wp-settings.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-settings.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-comments-post.php\":{\"id\":\"0_18\",\"parentId\":\"0\",\"name\":\"wp-comments-post.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-comments-post.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-load.php\":{\"id\":\"0_19\",\"parentId\":\"0\",\"name\":\"wp-load.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-load.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-links-opml.php\":{\"id\":\"0_20\",\"parentId\":\"0\",\"name\":\"wp-links-opml.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-links-opml.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"readme.html\":{\"id\":\"0_21\",\"parentId\":\"0\",\"name\":\"readme.html\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/readme.html\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"license.txt\":{\"id\":\"0_22\",\"parentId\":\"0\",\"name\":\"license.txt\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/license.txt\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-cron.php\":{\"id\":\"0_23\",\"parentId\":\"0\",\"name\":\"wp-cron.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-cron.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-activate.php\":{\"id\":\"0_24\",\"parentId\":\"0\",\"name\":\"wp-activate.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-activate.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-includes\":{\"id\":\"0_25\",\"parentId\":\"0\",\"name\":\"wp-includes\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-includes\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true}},\"data\":[],\"haveChildren\":true},\"rootPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\"},\"TreeWarning\":{\"tree\":{\"id\":\"0\",\"parentId\":\"\",\"name\":\"modelox\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"isDir\":true,\"childs\":{\"wp-blog-header.php\":{\"id\":\"0_0\",\"parentId\":\"0\",\"name\":\"wp-blog-header.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-blog-header.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".well-known\":{\"id\":\"0_1\",\"parentId\":\"0\",\"name\":\".well-known\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.well-known\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"error_log\":{\"id\":\"0_2\",\"parentId\":\"0\",\"name\":\"error_log\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/error_log\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-content\":{\"id\":\"0_3\",\"parentId\":\"0\",\"name\":\"wp-content\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"wp-signup.php\":{\"id\":\"0_4\",\"parentId\":\"0\",\"name\":\"wp-signup.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-signup.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".htaccess\":{\"id\":\"0_5\",\"parentId\":\"0\",\"name\":\".htaccess\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"cgi-bin\":{\"id\":\"0_6\",\"parentId\":\"0\",\"name\":\"cgi-bin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/cgi-bin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":false},\"wp-config.php\":{\"id\":\"0_7\",\"parentId\":\"0\",\"name\":\"wp-config.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-admin\":{\"id\":\"0_8\",\"parentId\":\"0\",\"name\":\"wp-admin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-admin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"php.ini\":{\"id\":\"0_9\",\"parentId\":\"0\",\"name\":\"php.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/php.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-mail.php\":{\"id\":\"0_10\",\"parentId\":\"0\",\"name\":\"wp-mail.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-mail.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"index.php\":{\"id\":\"0_11\",\"parentId\":\"0\",\"name\":\"index.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/index.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"xmlrpc.php\":{\"id\":\"0_12\",\"parentId\":\"0\",\"name\":\"xmlrpc.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/xmlrpc.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-config-sample.php\":{\"id\":\"0_13\",\"parentId\":\"0\",\"name\":\"wp-config-sample.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config-sample.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-trackback.php\":{\"id\":\"0_14\",\"parentId\":\"0\",\"name\":\"wp-trackback.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-trackback.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".user.ini\":{\"id\":\"0_15\",\"parentId\":\"0\",\"name\":\".user.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.user.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-login.php\":{\"id\":\"0_16\",\"parentId\":\"0\",\"name\":\"wp-login.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-login.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-settings.php\":{\"id\":\"0_17\",\"parentId\":\"0\",\"name\":\"wp-settings.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-settings.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-comments-post.php\":{\"id\":\"0_18\",\"parentId\":\"0\",\"name\":\"wp-comments-post.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-comments-post.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-load.php\":{\"id\":\"0_19\",\"parentId\":\"0\",\"name\":\"wp-load.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-load.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-links-opml.php\":{\"id\":\"0_20\",\"parentId\":\"0\",\"name\":\"wp-links-opml.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-links-opml.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"readme.html\":{\"id\":\"0_21\",\"parentId\":\"0\",\"name\":\"readme.html\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/readme.html\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"license.txt\":{\"id\":\"0_22\",\"parentId\":\"0\",\"name\":\"license.txt\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/license.txt\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-cron.php\":{\"id\":\"0_23\",\"parentId\":\"0\",\"name\":\"wp-cron.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-cron.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-activate.php\":{\"id\":\"0_24\",\"parentId\":\"0\",\"name\":\"wp-activate.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-activate.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-includes\":{\"id\":\"0_25\",\"parentId\":\"0\",\"name\":\"wp-includes\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-includes\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true}},\"data\":[],\"haveChildren\":true},\"rootPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\"}},\"ListDelimiter\":\";\\n\",\"isOuterWPContentDir\":false,\"wpContentDirNormalizePath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/\"},\"Multisite\":{\"FilterSites\":\"\"},\"Installer\":{\"File\":\"20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327_installer.php\",\"Size\":230742,\"OptsSecureOn\":0,\"OptsSecurePass\":\"\",\"OptsSkipScan\":0,\"OptsDBHost\":\"\",\"OptsDBName\":\"\",\"OptsDBUser\":\"\",\"OptsCPNLHost\":\"\",\"OptsCPNLUser\":\"\",\"OptsCPNLPass\":\"\",\"OptsCPNLEnable\":0,\"OptsCPNLConnect\":false,\"OptsCPNLDBAction\":\"create\",\"OptsCPNLDBHost\":\"\",\"OptsCPNLDBName\":\"\",\"OptsCPNLDBUser\":\"\",\"numFilesAdded\":156,\"numDirsAdded\":21},\"Database\":{\"info\":{\"buildMode\":\"PHPCHUNKING\",\"collationList\":[\"utf8_general_ci\",\"utf8mb4_unicode_520_ci\",\"utf8mb4_unicode_ci\",\"latin1_general_ci\"],\"isTablesUpperCase\":0,\"isNameUpperCase\":0,\"name\":\"vicodigi_wp642\",\"tablesBaseCount\":110,\"tablesFinalCount\":110,\"tablesRowCount\":31219,\"tablesSizeOnDisk\":8942363,\"varLowerCaseTables\":\"0\",\"version\":\"5.7.31\",\"versionComment\":\"MySQL Community Server - (GPL)\",\"tableWiseRowCounts\":{\"cerber_acl\":\"1\",\"cerber_blocks\":\"0\",\"cerber_countries\":\"0\",\"cerber_lab\":\"0\",\"cerber_lab_ip\":\"0\",\"cerber_lab_net\":\"0\",\"cerber_log\":\"31\",\"cerber_qmem\":\"0\",\"cerber_traffic\":\"321\",\"wp8b_actionscheduler_actions\":\"1\",\"wp8b_actionscheduler_claims\":\"0\",\"wp8b_actionscheduler_groups\":\"1\",\"wp8b_actionscheduler_logs\":\"3\",\"wp8b_booking\":\"1\",\"wp8b_bookingdates\":\"3\",\"wp8b_cerber_files\":\"0\",\"wp8b_cerber_sets\":\"11\",\"wp8b_cerber_uss\":\"2\",\"wp8b_commentmeta\":\"0\",\"wp8b_comments\":\"1\",\"wp8b_cuteslider\":\"0\",\"wp8b_duplicator_pro_entities\":\"7\",\"wp8b_duplicator_pro_packages\":\"1\",\"wp8b_hotel_booking_order_itemmeta\":\"0\",\"wp8b_hotel_booking_order_items\":\"0\",\"wp8b_hotel_booking_plans\":\"0\",\"wp8b_links\":\"0\",\"wp8b_mailchimp_carts\":\"0\",\"wp8b_mailchimp_jobs\":\"0\",\"wp8b_mp_timetable_data\":\"0\",\"wp8b_mphb_sync_logs\":\"0\",\"wp8b_mphb_sync_queue\":\"0\",\"wp8b_mphb_sync_stats\":\"0\",\"wp8b_mphb_sync_urls\":\"0\",\"wp8b_options\":\"443\",\"wp8b_postmeta\":\"559\",\"wp8b_posts\":\"48\",\"wp8b_revslider_css\":\"116\",\"wp8b_revslider_css_bkp\":\"47\",\"wp8b_revslider_layer_animations\":\"1\",\"wp8b_revslider_layer_animations_bkp\":\"1\",\"wp8b_revslider_navigations\":\"0\",\"wp8b_revslider_navigations_bkp\":\"5\",\"wp8b_revslider_sliders\":\"1\",\"wp8b_revslider_sliders_bkp\":\"1\",\"wp8b_revslider_slides\":\"9\",\"wp8b_revslider_slides_bkp\":\"2\",\"wp8b_revslider_static_slides\":\"1\",\"wp8b_revslider_static_slides_bkp\":\"4\",\"wp8b_sbi_instagram_feeds_posts\":\"0\",\"wp8b_sbi_instagram_posts\":\"0\",\"wp8b_term_relationships\":\"36\",\"wp8b_term_taxonomy\":\"24\",\"wp8b_termmeta\":\"10\",\"wp8b_terms\":\"24\",\"wp8b_tinvwl_analytics\":\"0\",\"wp8b_tinvwl_items\":\"0\",\"wp8b_tinvwl_lists\":\"1\",\"wp8b_usermeta\":\"24\",\"wp8b_users\":\"1\",\"wp8b_wc_admin_note_actions\":\"5\",\"wp8b_wc_admin_notes\":\"5\",\"wp8b_wc_category_lookup\":\"1\",\"wp8b_wc_customer_lookup\":\"1\",\"wp8b_wc_download_log\":\"0\",\"wp8b_wc_order_coupon_lookup\":\"0\",\"wp8b_wc_order_product_lookup\":\"1\",\"wp8b_wc_order_stats\":\"1\",\"wp8b_wc_order_tax_lookup\":\"0\",\"wp8b_wc_product_meta_lookup\":\"0\",\"wp8b_wc_reserved_stock\":\"0\",\"wp8b_wc_tax_rate_classes\":\"2\",\"wp8b_wc_webhooks\":\"0\",\"wp8b_wdi_feeds\":\"0\",\"wp8b_wdi_themes\":\"2\",\"wp8b_wfblockediplog\":\"0\",\"wp8b_wfblocks7\":\"0\",\"wp8b_wfconfig\":\"253\",\"wp8b_wfcrawlers\":\"0\",\"wp8b_wffilechanges\":\"0\",\"wp8b_wffilemods\":\"14077\",\"wp8b_wfhits\":\"3\",\"wp8b_wfhoover\":\"0\",\"wp8b_wfissues\":\"0\",\"wp8b_wfknownfilelist\":\"14077\",\"wp8b_wflivetraffichuman\":\"0\",\"wp8b_wflocs\":\"1\",\"wp8b_wflogins\":\"12\",\"wp8b_wfls_2fa_secrets\":\"0\",\"wp8b_wfls_settings\":\"19\",\"wp8b_wfnotifications\":\"11\",\"wp8b_wfpendingissues\":\"0\",\"wp8b_wfreversecache\":\"1\",\"wp8b_wfsnipcache\":\"0\",\"wp8b_wfstatus\":\"1007\",\"wp8b_wftrafficrates\":\"0\",\"wp8b_woocommerce_api_keys\":\"0\",\"wp8b_woocommerce_attribute_taxonomies\":\"0\",\"wp8b_woocommerce_downloadable_product_permissions\":\"0\",\"wp8b_woocommerce_log\":\"0\",\"wp8b_woocommerce_order_itemmeta\":\"0\",\"wp8b_woocommerce_order_items\":\"0\",\"wp8b_woocommerce_payment_tokenmeta\":\"0\",\"wp8b_woocommerce_payment_tokens\":\"0\",\"wp8b_woocommerce_sessions\":\"1\",\"wp8b_woocommerce_shipping_zone_locations\":\"0\",\"wp8b_woocommerce_shipping_zone_methods\":\"0\",\"wp8b_woocommerce_shipping_zones\":\"0\",\"wp8b_woocommerce_tax_rate_locations\":\"0\",\"wp8b_woocommerce_tax_rates\":\"0\"}},\"Type\":\"MySQL\",\"Size\":8283761,\"File\":\"20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327_database.sql\",\"FilterTables\":\"\",\"FilterOn\":0,\"DBMode\":\"PHPCHUNKING\",\"Compatible\":\"\",\"Comments\":\"MySQL Community Server - (GPL)\",\"dbStorePathPublic\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\\/20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327_database.sql\",\"sameNameTableExists\":false,\"indexProcessedSchemaSize\":[0,2100,3124,4148,5172,6196,7220,14984,16008,128096,147760,150846,160102,164974,167222,169336,171384,390724,393032,397128,405640,406664,422960,444960,445984,447008,448032,449056,451104,452128,453152,454176,455200,456224,457248,3037500,3259584,3291812,3391864,3407856,3410072,3412292,3413316,3427264,3440644,3449208,3494804,3546008,3568428,3570704,3572752,3573776,3577604,3582712,3593372,3607536,3608560,3609584,3611680,3623820,3632120,3635848,3639204,3641269,3647493,3648517,3649541,3655783,3667115,3668139,3670187,3671211,3680499,3681523,3682547,3689167,3690191,3691215,4369823,4370847,4371871,7269823,7275763,7276787,7286015,8752863,8753887,8756071,8762187,8794955,8811339,8815111,8816135,8818279,8819303,8943547,8944571,8946619,8947643,8948667,8949691,8950715,8951739,8952763,8953787,8958219,8959243,8960267,8961291,8962315]},\"Status\":100,\"schedule_id\":-1,\"build_progress\":{\"thread_start_time\":1597161473,\"initialized\":true,\"installer_built\":true,\"archive_started\":true,\"archive_has_database\":false,\"archive_built\":true,\"database_script_built\":true,\"failed\":false,\"next_archive_file_index\":11327,\"next_archive_dir_index\":1650,\"retries\":0,\"current_build_mode\":3,\"current_build_compression\":true,\"custom_data\":{\"archive_path\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\\/20200811_iglesiauniversitaria_ef8410f93c0e1aad7216_20200811155327_archive.daf\",\"time_slice_in_secs\":10,\"base_path\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"glob_size\":1048576,\"archive_offset\":73574173,\"failures\":[{\"type\":1,\"description\":\"Couldn\'t open \",\"subject\":\"\",\"isCritical\":false}],\"working\":false,\"is_compressed\":true,\"current_file_offset\":0,\"throttle_delay_in_us\":0,\"skipped_directory_count\":2,\"skipped_file_count\":1},\"warnings\":[\" : Couldn\'t open \"]},\"db_build_progress\":{\"tableIndex\":109,\"tableOffset\":0,\"totalRowOffset\":31222,\"chunkIndex\":1,\"validationStage1\":true,\"bulkOffset\":0,\"bulkSizeOffset\":0,\"doneInit\":true,\"doneFiltering\":true,\"doneCreates\":true,\"completed\":true,\"tablesToProcess\":[\"cerber_acl\",\"cerber_blocks\",\"cerber_countries\",\"cerber_lab\",\"cerber_lab_ip\",\"cerber_lab_net\",\"cerber_log\",\"cerber_qmem\",\"cerber_traffic\",\"wp8b_actionscheduler_actions\",\"wp8b_actionscheduler_claims\",\"wp8b_actionscheduler_groups\",\"wp8b_actionscheduler_logs\",\"wp8b_booking\",\"wp8b_bookingdates\",\"wp8b_cerber_files\",\"wp8b_cerber_sets\",\"wp8b_cerber_uss\",\"wp8b_commentmeta\",\"wp8b_comments\",\"wp8b_cuteslider\",\"wp8b_duplicator_pro_entities\",\"wp8b_duplicator_pro_packages\",\"wp8b_hotel_booking_order_itemmeta\",\"wp8b_hotel_booking_order_items\",\"wp8b_hotel_booking_plans\",\"wp8b_links\",\"wp8b_mailchimp_carts\",\"wp8b_mailchimp_jobs\",\"wp8b_mp_timetable_data\",\"wp8b_mphb_sync_logs\",\"wp8b_mphb_sync_queue\",\"wp8b_mphb_sync_stats\",\"wp8b_mphb_sync_urls\",\"wp8b_options\",\"wp8b_postmeta\",\"wp8b_posts\",\"wp8b_revslider_css\",\"wp8b_revslider_css_bkp\",\"wp8b_revslider_layer_animations\",\"wp8b_revslider_layer_animations_bkp\",\"wp8b_revslider_navigations\",\"wp8b_revslider_navigations_bkp\",\"wp8b_revslider_sliders\",\"wp8b_revslider_sliders_bkp\",\"wp8b_revslider_slides\",\"wp8b_revslider_slides_bkp\",\"wp8b_revslider_static_slides\",\"wp8b_revslider_static_slides_bkp\",\"wp8b_sbi_instagram_feeds_posts\",\"wp8b_sbi_instagram_posts\",\"wp8b_term_relationships\",\"wp8b_term_taxonomy\",\"wp8b_termmeta\",\"wp8b_terms\",\"wp8b_tinvwl_analytics\",\"wp8b_tinvwl_items\",\"wp8b_tinvwl_lists\",\"wp8b_usermeta\",\"wp8b_users\",\"wp8b_wc_admin_note_actions\",\"wp8b_wc_admin_notes\",\"wp8b_wc_category_lookup\",\"wp8b_wc_customer_lookup\",\"wp8b_wc_download_log\",\"wp8b_wc_order_coupon_lookup\",\"wp8b_wc_order_product_lookup\",\"wp8b_wc_order_stats\",\"wp8b_wc_order_tax_lookup\",\"wp8b_wc_product_meta_lookup\",\"wp8b_wc_reserved_stock\",\"wp8b_wc_tax_rate_classes\",\"wp8b_wc_webhooks\",\"wp8b_wdi_feeds\",\"wp8b_wdi_themes\",\"wp8b_wfblockediplog\",\"wp8b_wfblocks7\",\"wp8b_wfconfig\",\"wp8b_wfcrawlers\",\"wp8b_wffilechanges\",\"wp8b_wffilemods\",\"wp8b_wfhits\",\"wp8b_wfhoover\",\"wp8b_wfissues\",\"wp8b_wfknownfilelist\",\"wp8b_wflivetraffichuman\",\"wp8b_wflocs\",\"wp8b_wflogins\",\"wp8b_wfls_2fa_secrets\",\"wp8b_wfls_settings\",\"wp8b_wfnotifications\",\"wp8b_wfpendingissues\",\"wp8b_wfreversecache\",\"wp8b_wfsnipcache\",\"wp8b_wfstatus\",\"wp8b_wftrafficrates\",\"wp8b_woocommerce_api_keys\",\"wp8b_woocommerce_attribute_taxonomies\",\"wp8b_woocommerce_downloadable_product_permissions\",\"wp8b_woocommerce_log\",\"wp8b_woocommerce_order_itemmeta\",\"wp8b_woocommerce_order_items\",\"wp8b_woocommerce_payment_tokenmeta\",\"wp8b_woocommerce_payment_tokens\",\"wp8b_woocommerce_sessions\",\"wp8b_woocommerce_shipping_zone_locations\",\"wp8b_woocommerce_shipping_zone_methods\",\"wp8b_woocommerce_shipping_zones\",\"wp8b_woocommerce_tax_rate_locations\",\"wp8b_woocommerce_tax_rates\"],\"startTime\":1597161288.384251117706298828125,\"fileOffset\":8283761,\"wasInterrupted\":false,\"errorOut\":false,\"failureCount\":0,\"totalSchemaSize\":8963339,\"tablesSchemaSizes\":{\"cerber_acl\":2100,\"cerber_blocks\":1024,\"cerber_countries\":1024,\"cerber_lab\":1024,\"cerber_lab_ip\":1024,\"cerber_lab_net\":1024,\"cerber_log\":7764,\"cerber_qmem\":1024,\"cerber_traffic\":112088,\"wp8b_actionscheduler_actions\":19664,\"wp8b_actionscheduler_claims\":3086,\"wp8b_actionscheduler_groups\":9256,\"wp8b_actionscheduler_logs\":4872,\"wp8b_booking\":2248,\"wp8b_bookingdates\":2114,\"wp8b_cerber_files\":2048,\"wp8b_cerber_sets\":219340,\"wp8b_cerber_uss\":2308,\"wp8b_commentmeta\":4096,\"wp8b_comments\":8512,\"wp8b_cuteslider\":1024,\"wp8b_duplicator_pro_entities\":16296,\"wp8b_duplicator_pro_packages\":22000,\"wp8b_hotel_booking_order_itemmeta\":1024,\"wp8b_hotel_booking_order_items\":1024,\"wp8b_hotel_booking_plans\":1024,\"wp8b_links\":1024,\"wp8b_mailchimp_carts\":2048,\"wp8b_mailchimp_jobs\":1024,\"wp8b_mp_timetable_data\":1024,\"wp8b_mphb_sync_logs\":1024,\"wp8b_mphb_sync_queue\":1024,\"wp8b_mphb_sync_stats\":1024,\"wp8b_mphb_sync_urls\":1024,\"wp8b_options\":2580252,\"wp8b_postmeta\":222084,\"wp8b_posts\":32228,\"wp8b_revslider_css\":100052,\"wp8b_revslider_css_bkp\":15992,\"wp8b_revslider_layer_animations\":2216,\"wp8b_revslider_layer_animations_bkp\":2220,\"wp8b_revslider_navigations\":1024,\"wp8b_revslider_navigations_bkp\":13948,\"wp8b_revslider_sliders\":13380,\"wp8b_revslider_sliders_bkp\":8564,\"wp8b_revslider_slides\":45596,\"wp8b_revslider_slides_bkp\":51204,\"wp8b_revslider_static_slides\":22420,\"wp8b_revslider_static_slides_bkp\":2276,\"wp8b_sbi_instagram_feeds_posts\":2048,\"wp8b_sbi_instagram_posts\":1024,\"wp8b_term_relationships\":3828,\"wp8b_term_taxonomy\":5108,\"wp8b_termmeta\":10660,\"wp8b_terms\":14164,\"wp8b_tinvwl_analytics\":1024,\"wp8b_tinvwl_items\":1024,\"wp8b_tinvwl_lists\":2096,\"wp8b_usermeta\":12140,\"wp8b_users\":8300,\"wp8b_wc_admin_note_actions\":3728,\"wp8b_wc_admin_notes\":3356,\"wp8b_wc_category_lookup\":2065,\"wp8b_wc_customer_lookup\":6224,\"wp8b_wc_download_log\":1024,\"wp8b_wc_order_coupon_lookup\":1024,\"wp8b_wc_order_product_lookup\":6242,\"wp8b_wc_order_stats\":11332,\"wp8b_wc_order_tax_lookup\":1024,\"wp8b_wc_product_meta_lookup\":2048,\"wp8b_wc_reserved_stock\":1024,\"wp8b_wc_tax_rate_classes\":9288,\"wp8b_wc_webhooks\":1024,\"wp8b_wdi_feeds\":1024,\"wp8b_wdi_themes\":6620,\"wp8b_wfblockediplog\":1024,\"wp8b_wfblocks7\":1024,\"wp8b_wfconfig\":678608,\"wp8b_wfcrawlers\":1024,\"wp8b_wffilechanges\":1024,\"wp8b_wffilemods\":2897952,\"wp8b_wfhits\":5940,\"wp8b_wfhoover\":1024,\"wp8b_wfissues\":9228,\"wp8b_wfknownfilelist\":1466848,\"wp8b_wflivetraffichuman\":1024,\"wp8b_wflocs\":2184,\"wp8b_wflogins\":6116,\"wp8b_wfls_2fa_secrets\":32768,\"wp8b_wfls_settings\":16384,\"wp8b_wfnotifications\":3772,\"wp8b_wfpendingissues\":1024,\"wp8b_wfreversecache\":2144,\"wp8b_wfsnipcache\":1024,\"wp8b_wfstatus\":124244,\"wp8b_wftrafficrates\":1024,\"wp8b_woocommerce_api_keys\":2048,\"wp8b_woocommerce_attribute_taxonomies\":1024,\"wp8b_woocommerce_downloadable_product_permissions\":1024,\"wp8b_woocommerce_log\":1024,\"wp8b_woocommerce_order_itemmeta\":1024,\"wp8b_woocommerce_order_items\":1024,\"wp8b_woocommerce_payment_tokenmeta\":1024,\"wp8b_woocommerce_payment_tokens\":1024,\"wp8b_woocommerce_sessions\":4432,\"wp8b_woocommerce_shipping_zone_locations\":1024,\"wp8b_woocommerce_shipping_zone_methods\":1024,\"wp8b_woocommerce_shipping_zones\":1024,\"wp8b_woocommerce_tax_rate_locations\":1024,\"wp8b_woocommerce_tax_rates\":1024}},\"upload_infos\":[{\"storage_id\":\"7\",\"archive_offset\":75181799,\"copied_installer\":true,\"copied_archive\":true,\"progress\":100,\"num_failures\":0,\"failed\":false,\"cancelled\":false,\"upload_id\":null,\"failure_count\":0,\"data\":\"\",\"data2\":\"\",\"has_started\":true,\"status_message_details\":\"\",\"started_timestamp\":1597161475,\"stopped_timestamp\":1597161488}],\"active_storage_id\":7,\"template_id\":5}'),
 (2, '20200811_iglesiauniversitaria', '555d1b2a652911102415_20200811162716', 20, '2020-08-11 16:28:50', 'unknown', '{\"Created\":\"2020-08-11 16:27:16\",\"Version\":\"3.8.3.4\",\"VersionWP\":\"5.4.2\",\"VersionDB\":\"5.7.31\",\"VersionPHP\":\"7.2.32\",\"VersionOS\":\"Linux\",\"ID\":\"2\",\"Name\":\"20200811_iglesiauniversitaria\",\"Hash\":\"555d1b2a652911102415_20200811162716\",\"NameHash\":\"20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716\",\"Type\":0,\"Notes\":\"\",\"StorePath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\",\"StoreURL\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/backups-dup-pro\\/\",\"ScanFile\":\"20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716_scan.json\",\"timer_start\":1597163485.6333959102630615234375,\"Runtime\":null,\"ExeSize\":null,\"ZipSize\":0,\"Brand\":\"Default\",\"Brand_ID\":-2,\"ziparchive_mode\":0,\"Archive\":{\"ExportOnlyDB\":0,\"FilterDirs\":\"\",\"FilterExts\":\"\",\"FilterFiles\":\"\",\"FilterDirsAll\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/ai1wm-backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backupwordpress\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/contents\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/infinitewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/managewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/old-cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/wordfence\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/updraft\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/aiowps_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backup-guard\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_temp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/mainwp\\/backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/pb_backupbuddy\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/sucuri\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp-clone\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp_all_backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wpbackitup_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wfcache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wishlist-backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-snapshots\"],\"FilterExtsAll\":[],\"FilterFilesAll\":[\".DS_Store\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/zn_fonts\\/icomoon\\/icomoon\\/selection.json\",\"dbcache\",\"debug_log\",\"error.log\",\"error_log\",\"objectcache\",\"pgcache\",\"ws_ftp.log\"],\"FilterOn\":0,\"File\":\"20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716_archive.zip\",\"Format\":\"ZIP\",\"PackDir\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"Size\":200536945,\"Dirs\":null,\"DirCount\":1649,\"RecursiveLinks\":[],\"Files\":null,\"FileCount\":11325,\"file_count\":-1,\"FilterInfo\":{\"Dirs\":{\"Warning\":[],\"Unreadable\":[],\"AddonSites\":[],\"Core\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\"],\"Global\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/ai1wm-backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backupwordpress\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/contents\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/infinitewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/managewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/old-cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/updraft\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wishlist-backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wfcache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/wordfence\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/aiowps_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_temp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/mainwp\\/backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/pb_backupbuddy\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/sucuri\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp-clone\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp_all_backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wpbackitup_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backup-guard\"],\"Instance\":[]},\"Files\":{\"Warning\":[],\"Unreadable\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/zn_fonts\\/icomoon\\/icomoon\\/selection.json\"],\"Size\":[],\"Core\":[],\"Global\":[\"error_log\",\"error.log\",\"debug_log\",\"ws_ftp.log\",\"dbcache\",\"pgcache\",\"objectcache\",\".DS_Store\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\"],\"Instance\":[]},\"Exts\":{\"Core\":[],\"Global\":[],\"Instance\":[]},\"TreeSize\":{\"tree\":{\"id\":\"0\",\"parentId\":\"\",\"name\":\"modelox\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"isDir\":true,\"childs\":{\"wp-blog-header.php\":{\"id\":\"0_0\",\"parentId\":\"0\",\"name\":\"wp-blog-header.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-blog-header.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".well-known\":{\"id\":\"0_1\",\"parentId\":\"0\",\"name\":\".well-known\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.well-known\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"error_log\":{\"id\":\"0_2\",\"parentId\":\"0\",\"name\":\"error_log\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/error_log\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-content\":{\"id\":\"0_3\",\"parentId\":\"0\",\"name\":\"wp-content\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"wp-signup.php\":{\"id\":\"0_4\",\"parentId\":\"0\",\"name\":\"wp-signup.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-signup.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".htaccess\":{\"id\":\"0_5\",\"parentId\":\"0\",\"name\":\".htaccess\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"cgi-bin\":{\"id\":\"0_6\",\"parentId\":\"0\",\"name\":\"cgi-bin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/cgi-bin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":false},\"wp-config.php\":{\"id\":\"0_7\",\"parentId\":\"0\",\"name\":\"wp-config.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-admin\":{\"id\":\"0_8\",\"parentId\":\"0\",\"name\":\"wp-admin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-admin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"php.ini\":{\"id\":\"0_9\",\"parentId\":\"0\",\"name\":\"php.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/php.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-mail.php\":{\"id\":\"0_10\",\"parentId\":\"0\",\"name\":\"wp-mail.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-mail.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"index.php\":{\"id\":\"0_11\",\"parentId\":\"0\",\"name\":\"index.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/index.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"xmlrpc.php\":{\"id\":\"0_12\",\"parentId\":\"0\",\"name\":\"xmlrpc.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/xmlrpc.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-config-sample.php\":{\"id\":\"0_13\",\"parentId\":\"0\",\"name\":\"wp-config-sample.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config-sample.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-trackback.php\":{\"id\":\"0_14\",\"parentId\":\"0\",\"name\":\"wp-trackback.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-trackback.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".user.ini\":{\"id\":\"0_15\",\"parentId\":\"0\",\"name\":\".user.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.user.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-login.php\":{\"id\":\"0_16\",\"parentId\":\"0\",\"name\":\"wp-login.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-login.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-settings.php\":{\"id\":\"0_17\",\"parentId\":\"0\",\"name\":\"wp-settings.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-settings.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-comments-post.php\":{\"id\":\"0_18\",\"parentId\":\"0\",\"name\":\"wp-comments-post.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-comments-post.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-load.php\":{\"id\":\"0_19\",\"parentId\":\"0\",\"name\":\"wp-load.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-load.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-links-opml.php\":{\"id\":\"0_20\",\"parentId\":\"0\",\"name\":\"wp-links-opml.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-links-opml.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"readme.html\":{\"id\":\"0_21\",\"parentId\":\"0\",\"name\":\"readme.html\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/readme.html\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"license.txt\":{\"id\":\"0_22\",\"parentId\":\"0\",\"name\":\"license.txt\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/license.txt\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-cron.php\":{\"id\":\"0_23\",\"parentId\":\"0\",\"name\":\"wp-cron.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-cron.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-activate.php\":{\"id\":\"0_24\",\"parentId\":\"0\",\"name\":\"wp-activate.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-activate.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-includes\":{\"id\":\"0_25\",\"parentId\":\"0\",\"name\":\"wp-includes\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-includes\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true}},\"data\":[],\"haveChildren\":true},\"rootPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\"},\"TreeWarning\":{\"tree\":{\"id\":\"0\",\"parentId\":\"\",\"name\":\"modelox\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"isDir\":true,\"childs\":{\"wp-blog-header.php\":{\"id\":\"0_0\",\"parentId\":\"0\",\"name\":\"wp-blog-header.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-blog-header.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".well-known\":{\"id\":\"0_1\",\"parentId\":\"0\",\"name\":\".well-known\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.well-known\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"error_log\":{\"id\":\"0_2\",\"parentId\":\"0\",\"name\":\"error_log\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/error_log\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-content\":{\"id\":\"0_3\",\"parentId\":\"0\",\"name\":\"wp-content\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"wp-signup.php\":{\"id\":\"0_4\",\"parentId\":\"0\",\"name\":\"wp-signup.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-signup.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".htaccess\":{\"id\":\"0_5\",\"parentId\":\"0\",\"name\":\".htaccess\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"cgi-bin\":{\"id\":\"0_6\",\"parentId\":\"0\",\"name\":\"cgi-bin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/cgi-bin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":false},\"wp-config.php\":{\"id\":\"0_7\",\"parentId\":\"0\",\"name\":\"wp-config.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-admin\":{\"id\":\"0_8\",\"parentId\":\"0\",\"name\":\"wp-admin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-admin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"php.ini\":{\"id\":\"0_9\",\"parentId\":\"0\",\"name\":\"php.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/php.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-mail.php\":{\"id\":\"0_10\",\"parentId\":\"0\",\"name\":\"wp-mail.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-mail.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"index.php\":{\"id\":\"0_11\",\"parentId\":\"0\",\"name\":\"index.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/index.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"xmlrpc.php\":{\"id\":\"0_12\",\"parentId\":\"0\",\"name\":\"xmlrpc.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/xmlrpc.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-config-sample.php\":{\"id\":\"0_13\",\"parentId\":\"0\",\"name\":\"wp-config-sample.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config-sample.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-trackback.php\":{\"id\":\"0_14\",\"parentId\":\"0\",\"name\":\"wp-trackback.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-trackback.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".user.ini\":{\"id\":\"0_15\",\"parentId\":\"0\",\"name\":\".user.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.user.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-login.php\":{\"id\":\"0_16\",\"parentId\":\"0\",\"name\":\"wp-login.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-login.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-settings.php\":{\"id\":\"0_17\",\"parentId\":\"0\",\"name\":\"wp-settings.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-settings.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-comments-post.php\":{\"id\":\"0_18\",\"parentId\":\"0\",\"name\":\"wp-comments-post.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-comments-post.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-load.php\":{\"id\":\"0_19\",\"parentId\":\"0\",\"name\":\"wp-load.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-load.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-links-opml.php\":{\"id\":\"0_20\",\"parentId\":\"0\",\"name\":\"wp-links-opml.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-links-opml.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"readme.html\":{\"id\":\"0_21\",\"parentId\":\"0\",\"name\":\"readme.html\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/readme.html\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"license.txt\":{\"id\":\"0_22\",\"parentId\":\"0\",\"name\":\"license.txt\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/license.txt\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-cron.php\":{\"id\":\"0_23\",\"parentId\":\"0\",\"name\":\"wp-cron.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-cron.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-activate.php\":{\"id\":\"0_24\",\"parentId\":\"0\",\"name\":\"wp-activate.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-activate.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-includes\":{\"id\":\"0_25\",\"parentId\":\"0\",\"name\":\"wp-includes\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-includes\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true}},\"data\":[],\"haveChildren\":true},\"rootPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\"}},\"ListDelimiter\":\";\\n\",\"isOuterWPContentDir\":false},\"Multisite\":{\"FilterSites\":\"\"},\"Installer\":{\"File\":\"20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716_installer.php\",\"Size\":0,\"OptsSecureOn\":0,\"OptsSecurePass\":\"\",\"OptsSkipScan\":0,\"OptsDBHost\":\"\",\"OptsDBName\":\"\",\"OptsDBUser\":\"\",\"OptsCPNLHost\":\"\",\"OptsCPNLUser\":\"\",\"OptsCPNLPass\":\"\",\"OptsCPNLEnable\":0,\"OptsCPNLConnect\":false,\"OptsCPNLDBAction\":\"create\",\"OptsCPNLDBHost\":\"\",\"OptsCPNLDBName\":\"\",\"OptsCPNLDBUser\":\"\",\"numFilesAdded\":0,\"numDirsAdded\":0},\"Database\":{\"info\":{\"buildMode\":\"PHPCHUNKING\",\"collationList\":[\"utf8_general_ci\",\"utf8mb4_unicode_520_ci\",\"utf8mb4_unicode_ci\",\"latin1_general_ci\"],\"isTablesUpperCase\":0,\"isNameUpperCase\":0,\"name\":\"vicodigi_wp642\",\"tablesBaseCount\":110,\"tablesFinalCount\":110,\"tablesRowCount\":31245,\"tablesSizeOnDisk\":8991903,\"varLowerCaseTables\":\"0\",\"version\":\"5.7.31\",\"versionComment\":\"MySQL Community Server - (GPL)\",\"tableWiseRowCounts\":{\"cerber_acl\":\"1\",\"cerber_blocks\":\"0\",\"cerber_countries\":\"0\",\"cerber_lab\":\"0\",\"cerber_lab_ip\":\"0\",\"cerber_lab_net\":\"0\",\"cerber_log\":\"31\",\"cerber_qmem\":\"0\",\"cerber_traffic\":\"346\",\"wp8b_actionscheduler_actions\":\"1\",\"wp8b_actionscheduler_claims\":\"0\",\"wp8b_actionscheduler_groups\":\"1\",\"wp8b_actionscheduler_logs\":\"3\",\"wp8b_booking\":\"1\",\"wp8b_bookingdates\":\"3\",\"wp8b_cerber_files\":\"0\",\"wp8b_cerber_sets\":\"11\",\"wp8b_cerber_uss\":\"2\",\"wp8b_commentmeta\":\"0\",\"wp8b_comments\":\"1\",\"wp8b_cuteslider\":\"0\",\"wp8b_duplicator_pro_entities\":\"8\",\"wp8b_duplicator_pro_packages\":\"2\"}},\"Type\":\"MySQL\",\"Size\":null,\"File\":\"20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716_database.sql\",\"FilterTables\":\"\",\"FilterOn\":0,\"DBMode\":\"PHPCHUNKING\",\"Compatible\":\"\",\"Comments\":\"MySQL Community Server - (GPL)\",\"dbStorePathPublic\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\\/20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716_database.sql\",\"sameNameTableExists\":false,\"indexProcessedSchemaSize\":[0,2100,3124,4148,5172,6196,7220,14984,16008,137768,157432,160518,169774,174646,176894,179008,181056,400396,402704,406800,415312,416336,433704],\"intFieldsStruct\":{\"cerber_acl\":{\"ip_long_begin\":\"0\",\"ip_long_end\":\"0\",\"acl_slice\":\"0\",\"ver6\":\"0\"},\"cerber_blocks\":{\"block_until\":\"NULL\",\"reason_id\":\"0\"},\"cerber_countries\":[],\"cerber_lab\":{\"reason_id\":\"0\",\"stamp\":\"NULL\"},\"cerber_lab_ip\":{\"reputation\":\"NULL\",\"expires\":\"NULL\"},\"cerber_lab_net\":{\"ip_long_begin\":\"0\",\"ip_long_end\":\"0\",\"expires\":\"0\"},\"cerber_log\":{\"ip_long\":\"0\",\"user_id\":\"0\",\"activity\":\"0\"},\"cerber_qmem\":{\"http_code\":\"NULL\",\"stamp\":\"NULL\"},\"cerber_traffic\":{\"ip_long\":\"0\",\"user_id\":\"0\",\"processing\":\"0\",\"http_code\":\"NULL\",\"wp_id\":\"0\",\"wp_type\":\"0\",\"is_bot\":\"0\",\"blog_id\":\"0\",\"req_status\":\"0\"},\"wp8b_actionscheduler_actions\":{\"action_id\":\"NULL\",\"group_id\":\"0\",\"attempts\":\"0\",\"claim_id\":\"0\"},\"wp8b_actionscheduler_claims\":{\"claim_id\":\"NULL\"},\"wp8b_actionscheduler_groups\":{\"group_id\":\"NULL\"},\"wp8b_actionscheduler_logs\":{\"log_id\":\"NULL\",\"action_id\":\"NULL\"},\"wp8b_booking\":{\"booking_id\":\"NULL\",\"trash\":\"0\",\"is_new\":\"1\",\"booking_type\":\"1\"},\"wp8b_bookingdates\":{\"booking_id\":\"NULL\",\"approved\":\"0\"},\"wp8b_cerber_files\":{\"scan_id\":\"NULL\",\"scan_type\":\"1\",\"scan_mode\":\"0\",\"scan_status\":\"0\",\"file_status\":\"0\",\"file_type\":\"0\",\"hash_match\":\"0\",\"file_size\":\"0\",\"file_perms\":\"0\",\"file_writable\":\"0\",\"file_mtime\":\"0\"},\"wp8b_cerber_sets\":{\"the_id\":\"0\",\"expires\":\"0\"},\"wp8b_cerber_uss\":{\"user_id\":\"NULL\",\"started\":\"NULL\",\"expires\":\"NULL\"},\"wp8b_commentmeta\":{\"meta_id\":\"NULL\",\"comment_id\":\"0\"},\"wp8b_comments\":{\"comment_ID\":\"NULL\",\"comment_post_ID\":\"0\",\"comment_karma\":\"0\",\"comment_parent\":\"0\",\"user_id\":\"0\"},\"wp8b_cuteslider\":{\"id\":\"NULL\",\"date_c\":\"NULL\",\"date_m\":\"NULL\",\"flag_hidden\":\"0\",\"flag_deleted\":\"0\"},\"wp8b_duplicator_pro_entities\":{\"id\":\"NULL\"}}},\"Status\":20,\"schedule_id\":-1,\"build_progress\":{\"thread_start_time\":1597163491,\"initialized\":true,\"installer_built\":false,\"archive_started\":false,\"archive_has_database\":false,\"archive_built\":false,\"database_script_built\":false,\"failed\":false,\"next_archive_file_index\":0,\"next_archive_dir_index\":0,\"retries\":0,\"current_build_mode\":2,\"current_build_compression\":true,\"custom_data\":null,\"warnings\":[]},\"db_build_progress\":{\"tableIndex\":0,\"tableOffset\":0,\"totalRowOffset\":0,\"chunkIndex\":null,\"validationStage1\":false,\"bulkOffset\":0,\"bulkSizeOffset\":0,\"doneInit\":true,\"doneFiltering\":true,\"doneCreates\":true,\"completed\":false,\"tablesToProcess\":[\"cerber_acl\",\"cerber_blocks\",\"cerber_countries\",\"cerber_lab\",\"cerber_lab_ip\",\"cerber_lab_net\",\"cerber_log\",\"cerber_qmem\",\"cerber_traffic\",\"wp8b_actionscheduler_actions\",\"wp8b_actionscheduler_claims\",\"wp8b_actionscheduler_groups\",\"wp8b_actionscheduler_logs\",\"wp8b_booking\",\"wp8b_bookingdates\",\"wp8b_cerber_files\",\"wp8b_cerber_sets\",\"wp8b_cerber_uss\",\"wp8b_commentmeta\",\"wp8b_comments\",\"wp8b_cuteslider\",\"wp8b_duplicator_pro_entities\",\"wp8b_duplicator_pro_packages\",\"wp8b_hotel_booking_order_itemmeta\",\"wp8b_hotel_booking_order_items\",\"wp8b_hotel_booking_plans\",\"wp8b_links\",\"wp8b_mailchimp_carts\",\"wp8b_mailchimp_jobs\",\"wp8b_mp_timetable_data\",\"wp8b_mphb_sync_logs\",\"wp8b_mphb_sync_queue\",\"wp8b_mphb_sync_stats\",\"wp8b_mphb_sync_urls\",\"wp8b_options\",\"wp8b_postmeta\",\"wp8b_posts\",\"wp8b_revslider_css\",\"wp8b_revslider_css_bkp\",\"wp8b_revslider_layer_animations\",\"wp8b_revslider_layer_animations_bkp\",\"wp8b_revslider_navigations\",\"wp8b_revslider_navigations_bkp\",\"wp8b_revslider_sliders\",\"wp8b_revslider_sliders_bkp\",\"wp8b_revslider_slides\",\"wp8b_revslider_slides_bkp\",\"wp8b_revslider_static_slides\",\"wp8b_revslider_static_slides_bkp\",\"wp8b_sbi_instagram_feeds_posts\",\"wp8b_sbi_instagram_posts\",\"wp8b_term_relationships\",\"wp8b_term_taxonomy\",\"wp8b_termmeta\",\"wp8b_terms\",\"wp8b_tinvwl_analytics\",\"wp8b_tinvwl_items\",\"wp8b_tinvwl_lists\",\"wp8b_usermeta\",\"wp8b_users\",\"wp8b_wc_admin_note_actions\",\"wp8b_wc_admin_notes\",\"wp8b_wc_category_lookup\",\"wp8b_wc_customer_lookup\",\"wp8b_wc_download_log\",\"wp8b_wc_order_coupon_lookup\",\"wp8b_wc_order_product_lookup\",\"wp8b_wc_order_stats\",\"wp8b_wc_order_tax_lookup\",\"wp8b_wc_product_meta_lookup\",\"wp8b_wc_reserved_stock\",\"wp8b_wc_tax_rate_classes\",\"wp8b_wc_webhooks\",\"wp8b_wdi_feeds\",\"wp8b_wdi_themes\",\"wp8b_wfblockediplog\",\"wp8b_wfblocks7\",\"wp8b_wfconfig\",\"wp8b_wfcrawlers\",\"wp8b_wffilechanges\",\"wp8b_wffilemods\",\"wp8b_wfhits\",\"wp8b_wfhoover\",\"wp8b_wfissues\",\"wp8b_wfknownfilelist\",\"wp8b_wflivetraffichuman\",\"wp8b_wflocs\",\"wp8b_wflogins\",\"wp8b_wfls_2fa_secrets\",\"wp8b_wfls_settings\",\"wp8b_wfnotifications\",\"wp8b_wfpendingissues\",\"wp8b_wfreversecache\",\"wp8b_wfsnipcache\",\"wp8b_wfstatus\",\"wp8b_wftrafficrates\",\"wp8b_woocommerce_api_keys\",\"wp8b_woocommerce_attribute_taxonomies\",\"wp8b_woocommerce_downloadable_product_permissions\",\"wp8b_woocommerce_log\",\"wp8b_woocommerce_order_itemmeta\",\"wp8b_woocommerce_order_items\",\"wp8b_woocommerce_payment_tokenmeta\",\"wp8b_woocommerce_payment_tokens\",\"wp8b_woocommerce_sessions\",\"wp8b_woocommerce_shipping_zone_locations\",\"wp8b_woocommerce_shipping_zone_methods\",\"wp8b_woocommerce_shipping_zones\",\"wp8b_woocommerce_tax_rate_locations\",\"wp8b_woocommerce_tax_rates\"],\"startTime\":1597163485.6400089263916015625,\"fileOffset\":79041,\"wasInterrupted\":true,\"errorOut\":false,\"failureCount\":0,\"totalSchemaSize\":9003559,\"tablesSchemaSizes\":{\"cerber_acl\":2100,\"cerber_blocks\":1024,\"cerber_countries\":1024,\"cerber_lab\":1024,\"cerber_lab_ip\":1024,\"cerber_lab_net\":1024,\"cerber_log\":7764,\"cerber_qmem\":1024,\"cerber_traffic\":121760,\"wp8b_actionscheduler_actions\":19664,\"wp8b_actionscheduler_claims\":3086,\"wp8b_actionscheduler_groups\":9256,\"wp8b_actionscheduler_logs\":4872,\"wp8b_booking\":2248,\"wp8b_bookingdates\":2114,\"wp8b_cerber_files\":2048,\"wp8b_cerber_sets\":219340,\"wp8b_cerber_uss\":2308,\"wp8b_commentmeta\":4096,\"wp8b_comments\":8512,\"wp8b_cuteslider\":1024,\"wp8b_duplicator_pro_entities\":17368,\"wp8b_duplicator_pro_packages\":51476,\"wp8b_hotel_booking_order_itemmeta\":1024,\"wp8b_hotel_booking_order_items\":1024,\"wp8b_hotel_booking_plans\":1024,\"wp8b_links\":1024,\"wp8b_mailchimp_carts\":2048,\"wp8b_mailchimp_jobs\":1024,\"wp8b_mp_timetable_data\":1024,\"wp8b_mphb_sync_logs\":1024,\"wp8b_mphb_sync_queue\":1024,\"wp8b_mphb_sync_stats\":1024,\"wp8b_mphb_sync_urls\":1024,\"wp8b_options\":2580252,\"wp8b_postmeta\":222084,\"wp8b_posts\":32228,\"wp8b_revslider_css\":100052,\"wp8b_revslider_css_bkp\":15992,\"wp8b_revslider_layer_animations\":2216,\"wp8b_revslider_layer_animations_bkp\":2220,\"wp8b_revslider_navigations\":1024,\"wp8b_revslider_navigations_bkp\":13948,\"wp8b_revslider_sliders\":13380,\"wp8b_revslider_sliders_bkp\":8564,\"wp8b_revslider_slides\":45596,\"wp8b_revslider_slides_bkp\":51204,\"wp8b_revslider_static_slides\":22420,\"wp8b_revslider_static_slides_bkp\":2276,\"wp8b_sbi_instagram_feeds_posts\":2048,\"wp8b_sbi_instagram_posts\":1024,\"wp8b_term_relationships\":3828,\"wp8b_term_taxonomy\":5108,\"wp8b_termmeta\":10660,\"wp8b_terms\":14164,\"wp8b_tinvwl_analytics\":1024,\"wp8b_tinvwl_items\":1024,\"wp8b_tinvwl_lists\":2096,\"wp8b_usermeta\":12140,\"wp8b_users\":8300,\"wp8b_wc_admin_note_actions\":3728,\"wp8b_wc_admin_notes\":3356,\"wp8b_wc_category_lookup\":2065,\"wp8b_wc_customer_lookup\":6224,\"wp8b_wc_download_log\":1024,\"wp8b_wc_order_coupon_lookup\":1024,\"wp8b_wc_order_product_lookup\":6242,\"wp8b_wc_order_stats\":11332,\"wp8b_wc_order_tax_lookup\":1024,\"wp8b_wc_product_meta_lookup\":2048,\"wp8b_wc_reserved_stock\":1024,\"wp8b_wc_tax_rate_classes\":9288,\"wp8b_wc_webhooks\":1024,\"wp8b_wdi_feeds\":1024,\"wp8b_wdi_themes\":6620,\"wp8b_wfblockediplog\":1024,\"wp8b_wfblocks7\":1024,\"wp8b_wfconfig\":678608,\"wp8b_wfcrawlers\":1024,\"wp8b_wffilechanges\":1024,\"wp8b_wffilemods\":2897952,\"wp8b_wfhits\":5940,\"wp8b_wfhoover\":1024,\"wp8b_wfissues\":9228,\"wp8b_wfknownfilelist\":1466848,\"wp8b_wflivetraffichuman\":1024,\"wp8b_wflocs\":2184,\"wp8b_wflogins\":6116,\"wp8b_wfls_2fa_secrets\":32768,\"wp8b_wfls_settings\":16384,\"wp8b_wfnotifications\":3772,\"wp8b_wfpendingissues\":1024,\"wp8b_wfreversecache\":2144,\"wp8b_wfsnipcache\":1024,\"wp8b_wfstatus\":124244,\"wp8b_wftrafficrates\":1024,\"wp8b_woocommerce_api_keys\":2048,\"wp8b_woocommerce_attribute_taxonomies\":1024,\"wp8b_woocommerce_downloadable_product_permissions\":1024,\"wp8b_woocommerce_log\":1024,\"wp8b_woocommerce_order_itemmeta\":1024,\"wp8b_woocommerce_order_items\":1024,\"wp8b_woocommerce_payment_tokenmeta\":1024,\"wp8b_woocommerce_payment_tokens\":1024,\"wp8b_woocommerce_sessions\":4432,\"wp8b_woocommerce_shipping_zone_locations\":1024,\"wp8b_woocommerce_shipping_zone_methods\":1024,\"wp8b_woocommerce_shipping_zones\":1024,\"wp8b_woocommerce_tax_rate_locations\":1024,\"wp8b_woocommerce_tax_rates\":1024}},\"upload_infos\":[{\"storage_id\":\"7\",\"archive_offset\":0,\"copied_installer\":false,\"copied_archive\":false,\"progress\":0,\"num_failures\":0,\"failed\":false,\"cancelled\":false,\"upload_id\":null,\"failure_count\":0,\"data\":\"\",\"data2\":\"\",\"has_started\":false,\"status_message_details\":\"\",\"started_timestamp\":null,\"stopped_timestamp\":null}],\"active_storage_id\":-1,\"template_id\":5}');

/* INSERT TABLE DATA: wp8b_options */
INSERT INTO `wp8b_options` VALUES(1, 'siteurl', 'https://modelox.vico.digital', 'yes'),
 (2, 'home', 'https://modelox.vico.digital', 'yes'),
 (3, 'blogname', 'Sitio Demo', 'yes'),
 (4, 'blogdescription', 'Demostraci&oacute;n', 'yes'),
 (5, 'users_can_register', '0', 'yes'),
 (6, 'admin_email', 'vicosolutions.com@gmail.com', 'yes'),
 (7, 'start_of_week', '1', 'yes'),
 (8, 'use_balanceTags', '0', 'yes'),
 (9, 'use_smilies', '1', 'yes'),
 (10, 'require_name_email', '1', 'yes'),
 (11, 'comments_notify', '1', 'yes'),
 (12, 'posts_per_rss', '10', 'yes'),
 (13, 'rss_use_excerpt', '0', 'yes'),
 (14, 'mailserver_url', 'mail.example.com', 'yes'),
 (15, 'mailserver_login', 'login@example.com', 'yes'),
 (16, 'mailserver_pass', 'password', 'yes'),
 (17, 'mailserver_port', '110', 'yes'),
 (18, 'default_category', '1', 'yes'),
 (19, 'default_comment_status', 'open', 'yes'),
 (20, 'default_ping_status', 'open', 'yes'),
 (21, 'default_pingback_flag', '1', 'yes'),
 (22, 'posts_per_page', '10', 'yes'),
 (23, 'date_format', 'F j, Y', 'yes'),
 (24, 'time_format', 'g:i a', 'yes'),
 (25, 'links_updated_date_format', 'F j, Y g:i a', 'yes'),
 (26, 'comment_moderation', '0', 'yes'),
 (27, 'moderation_notify', '1', 'yes'),
 (28, 'permalink_structure', '/%year%/%monthnum%/%day%/%postname%/', 'yes'),
 (29, 'rewrite_rules', 'a:266:{s:24:\"^wc-auth/v([1]{1})/(.*)?\";s:63:\"index.php?wc-auth-version=$matches[1]&wc-auth-route=$matches[2]\";s:22:\"^wc-api/v([1-3]{1})/?$\";s:51:\"index.php?wc-api-version=$matches[1]&wc-api-route=/\";s:24:\"^wc-api/v([1-3]{1})(.*)?\";s:61:\"index.php?wc-api-version=$matches[1]&wc-api-route=$matches[2]\";s:7:\"shop/?$\";s:27:\"index.php?post_type=product\";s:37:\"shop/feed/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=product&feed=$matches[1]\";s:32:\"shop/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=product&feed=$matches[1]\";s:24:\"shop/page/([0-9]{1,})/?$\";s:45:\"index.php?post_type=product&paged=$matches[1]\";s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:12:\"portfolio/?$\";s:29:\"index.php?post_type=portfolio\";s:42:\"portfolio/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?post_type=portfolio&feed=$matches[1]\";s:37:\"portfolio/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?post_type=portfolio&feed=$matches[1]\";s:29:\"portfolio/page/([0-9]{1,})/?$\";s:47:\"index.php?post_type=portfolio&paged=$matches[1]\";s:16:\"documentation/?$\";s:33:\"index.php?post_type=documentation\";s:46:\"documentation/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_type=documentation&feed=$matches[1]\";s:41:\"documentation/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_type=documentation&feed=$matches[1]\";s:33:\"documentation/page/([0-9]{1,})/?$\";s:51:\"index.php?post_type=documentation&paged=$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:32:\"category/(.+?)/wc-api(/(.*))?/?$\";s:54:\"index.php?category_name=$matches[1]&wc-api=$matches[3]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:29:\"tag/([^/]+)/wc-api(/(.*))?/?$\";s:44:\"index.php?tag=$matches[1]&wc-api=$matches[3]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:63:\"documentation_category/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:61:\"index.php?documentation_category=$matches[1]&feed=$matches[2]\";s:58:\"documentation_category/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:61:\"index.php?documentation_category=$matches[1]&feed=$matches[2]\";s:39:\"documentation_category/([^/]+)/embed/?$\";s:55:\"index.php?documentation_category=$matches[1]&embed=true\";s:51:\"documentation_category/([^/]+)/page/?([0-9]{1,})/?$\";s:62:\"index.php?documentation_category=$matches[1]&paged=$matches[2]\";s:33:\"documentation_category/([^/]+)/?$\";s:44:\"index.php?documentation_category=$matches[1]\";s:57:\"project_category/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:55:\"index.php?project_category=$matches[1]&feed=$matches[2]\";s:52:\"project_category/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:55:\"index.php?project_category=$matches[1]&feed=$matches[2]\";s:33:\"project_category/([^/]+)/embed/?$\";s:49:\"index.php?project_category=$matches[1]&embed=true\";s:45:\"project_category/([^/]+)/page/?([0-9]{1,})/?$\";s:56:\"index.php?project_category=$matches[1]&paged=$matches[2]\";s:27:\"project_category/([^/]+)/?$\";s:38:\"index.php?project_category=$matches[1]\";s:57:\"categoria-producto/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_cat=$matches[1]&feed=$matches[2]\";s:52:\"categoria-producto/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_cat=$matches[1]&feed=$matches[2]\";s:33:\"categoria-producto/(.+?)/embed/?$\";s:44:\"index.php?product_cat=$matches[1]&embed=true\";s:45:\"categoria-producto/(.+?)/page/?([0-9]{1,})/?$\";s:51:\"index.php?product_cat=$matches[1]&paged=$matches[2]\";s:27:\"categoria-producto/(.+?)/?$\";s:33:\"index.php?product_cat=$matches[1]\";s:58:\"etiqueta-producto/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_tag=$matches[1]&feed=$matches[2]\";s:53:\"etiqueta-producto/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_tag=$matches[1]&feed=$matches[2]\";s:34:\"etiqueta-producto/([^/]+)/embed/?$\";s:44:\"index.php?product_tag=$matches[1]&embed=true\";s:46:\"etiqueta-producto/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?product_tag=$matches[1]&paged=$matches[2]\";s:28:\"etiqueta-producto/([^/]+)/?$\";s:33:\"index.php?product_tag=$matches[1]\";s:32:\"shop/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:42:\"shop/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:62:\"shop/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:57:\"shop/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:57:\"shop/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:38:\"shop/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:21:\"shop/([^/]+)/embed/?$\";s:40:\"index.php?product=$matches[1]&embed=true\";s:25:\"shop/([^/]+)/trackback/?$\";s:34:\"index.php?product=$matches[1]&tb=1\";s:45:\"shop/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?product=$matches[1]&feed=$matches[2]\";s:40:\"shop/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?product=$matches[1]&feed=$matches[2]\";s:33:\"shop/([^/]+)/page/?([0-9]{1,})/?$\";s:47:\"index.php?product=$matches[1]&paged=$matches[2]\";s:40:\"shop/([^/]+)/comment-page-([0-9]{1,})/?$\";s:47:\"index.php?product=$matches[1]&cpage=$matches[2]\";s:30:\"shop/([^/]+)/wc-api(/(.*))?/?$\";s:48:\"index.php?product=$matches[1]&wc-api=$matches[3]\";s:36:\"shop/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:47:\"shop/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:29:\"shop/([^/]+)(?:/([0-9]+))?/?$\";s:46:\"index.php?product=$matches[1]&page=$matches[2]\";s:21:\"shop/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:31:\"shop/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:51:\"shop/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:46:\"shop/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:46:\"shop/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:27:\"shop/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:42:\"layout_manager/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:52:\"layout_manager/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:72:\"layout_manager/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:67:\"layout_manager/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:67:\"layout_manager/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:48:\"layout_manager/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:31:\"layout_manager/([^/]+)/embed/?$\";s:42:\"index.php?zn_layout=$matches[1]&embed=true\";s:35:\"layout_manager/([^/]+)/trackback/?$\";s:36:\"index.php?zn_layout=$matches[1]&tb=1\";s:43:\"layout_manager/([^/]+)/page/?([0-9]{1,})/?$\";s:49:\"index.php?zn_layout=$matches[1]&paged=$matches[2]\";s:50:\"layout_manager/([^/]+)/comment-page-([0-9]{1,})/?$\";s:49:\"index.php?zn_layout=$matches[1]&cpage=$matches[2]\";s:40:\"layout_manager/([^/]+)/wc-api(/(.*))?/?$\";s:50:\"index.php?zn_layout=$matches[1]&wc-api=$matches[3]\";s:46:\"layout_manager/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:57:\"layout_manager/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:39:\"layout_manager/([^/]+)(?:/([0-9]+))?/?$\";s:48:\"index.php?zn_layout=$matches[1]&page=$matches[2]\";s:31:\"layout_manager/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:41:\"layout_manager/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:61:\"layout_manager/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\"layout_manager/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\"layout_manager/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:37:\"layout_manager/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:55:\"portfolio_tags/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:53:\"index.php?portfolio_tags=$matches[1]&feed=$matches[2]\";s:50:\"portfolio_tags/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:53:\"index.php?portfolio_tags=$matches[1]&feed=$matches[2]\";s:31:\"portfolio_tags/([^/]+)/embed/?$\";s:47:\"index.php?portfolio_tags=$matches[1]&embed=true\";s:43:\"portfolio_tags/([^/]+)/page/?([0-9]{1,})/?$\";s:54:\"index.php?portfolio_tags=$matches[1]&paged=$matches[2]\";s:25:\"portfolio_tags/([^/]+)/?$\";s:36:\"index.php?portfolio_tags=$matches[1]\";s:37:\"portfolio/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:47:\"portfolio/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:67:\"portfolio/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"portfolio/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"portfolio/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:43:\"portfolio/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:26:\"portfolio/([^/]+)/embed/?$\";s:42:\"index.php?portfolio=$matches[1]&embed=true\";s:30:\"portfolio/([^/]+)/trackback/?$\";s:36:\"index.php?portfolio=$matches[1]&tb=1\";s:50:\"portfolio/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?portfolio=$matches[1]&feed=$matches[2]\";s:45:\"portfolio/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?portfolio=$matches[1]&feed=$matches[2]\";s:38:\"portfolio/([^/]+)/page/?([0-9]{1,})/?$\";s:49:\"index.php?portfolio=$matches[1]&paged=$matches[2]\";s:45:\"portfolio/([^/]+)/comment-page-([0-9]{1,})/?$\";s:49:\"index.php?portfolio=$matches[1]&cpage=$matches[2]\";s:35:\"portfolio/([^/]+)/wc-api(/(.*))?/?$\";s:50:\"index.php?portfolio=$matches[1]&wc-api=$matches[3]\";s:41:\"portfolio/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:52:\"portfolio/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:34:\"portfolio/([^/]+)(?:/([0-9]+))?/?$\";s:48:\"index.php?portfolio=$matches[1]&page=$matches[2]\";s:26:\"portfolio/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:36:\"portfolio/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:56:\"portfolio/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"portfolio/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"portfolio/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:32:\"portfolio/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:41:\"documentation/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:51:\"documentation/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:71:\"documentation/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:66:\"documentation/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:66:\"documentation/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:47:\"documentation/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:30:\"documentation/([^/]+)/embed/?$\";s:46:\"index.php?documentation=$matches[1]&embed=true\";s:34:\"documentation/([^/]+)/trackback/?$\";s:40:\"index.php?documentation=$matches[1]&tb=1\";s:54:\"documentation/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?documentation=$matches[1]&feed=$matches[2]\";s:49:\"documentation/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?documentation=$matches[1]&feed=$matches[2]\";s:42:\"documentation/([^/]+)/page/?([0-9]{1,})/?$\";s:53:\"index.php?documentation=$matches[1]&paged=$matches[2]\";s:49:\"documentation/([^/]+)/comment-page-([0-9]{1,})/?$\";s:53:\"index.php?documentation=$matches[1]&cpage=$matches[2]\";s:39:\"documentation/([^/]+)/wc-api(/(.*))?/?$\";s:54:\"index.php?documentation=$matches[1]&wc-api=$matches[3]\";s:45:\"documentation/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:56:\"documentation/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:38:\"documentation/([^/]+)(?:/([0-9]+))?/?$\";s:52:\"index.php?documentation=$matches[1]&page=$matches[2]\";s:30:\"documentation/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:40:\"documentation/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:60:\"documentation/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:55:\"documentation/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:55:\"documentation/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:36:\"documentation/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:46:\"znpb_template_mngr/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:56:\"znpb_template_mngr/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:76:\"znpb_template_mngr/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:71:\"znpb_template_mngr/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:71:\"znpb_template_mngr/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:52:\"znpb_template_mngr/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:35:\"znpb_template_mngr/([^/]+)/embed/?$\";s:51:\"index.php?znpb_template_mngr=$matches[1]&embed=true\";s:39:\"znpb_template_mngr/([^/]+)/trackback/?$\";s:45:\"index.php?znpb_template_mngr=$matches[1]&tb=1\";s:47:\"znpb_template_mngr/([^/]+)/page/?([0-9]{1,})/?$\";s:58:\"index.php?znpb_template_mngr=$matches[1]&paged=$matches[2]\";s:54:\"znpb_template_mngr/([^/]+)/comment-page-([0-9]{1,})/?$\";s:58:\"index.php?znpb_template_mngr=$matches[1]&cpage=$matches[2]\";s:44:\"znpb_template_mngr/([^/]+)/wc-api(/(.*))?/?$\";s:59:\"index.php?znpb_template_mngr=$matches[1]&wc-api=$matches[3]\";s:50:\"znpb_template_mngr/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:61:\"znpb_template_mngr/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:43:\"znpb_template_mngr/([^/]+)(?:/([0-9]+))?/?$\";s:57:\"index.php?znpb_template_mngr=$matches[1]&page=$matches[2]\";s:35:\"znpb_template_mngr/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"znpb_template_mngr/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"znpb_template_mngr/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"znpb_template_mngr/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"znpb_template_mngr/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:41:\"znpb_template_mngr/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:13:\"favicon\\.ico$\";s:19:\"index.php?favicon=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:40:\"index.php?&page_id=149&cpage=$matches[1]\";s:17:\"wc-api(/(.*))?/?$\";s:29:\"index.php?&wc-api=$matches[2]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:26:\"comments/wc-api(/(.*))?/?$\";s:29:\"index.php?&wc-api=$matches[2]\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:29:\"search/(.+)/wc-api(/(.*))?/?$\";s:42:\"index.php?s=$matches[1]&wc-api=$matches[3]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:32:\"author/([^/]+)/wc-api(/(.*))?/?$\";s:52:\"index.php?author_name=$matches[1]&wc-api=$matches[3]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:54:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/wc-api(/(.*))?/?$\";s:82:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&wc-api=$matches[5]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:41:\"([0-9]{4})/([0-9]{1,2})/wc-api(/(.*))?/?$\";s:66:\"index.php?year=$matches[1]&monthnum=$matches[2]&wc-api=$matches[4]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:28:\"([0-9]{4})/wc-api(/(.*))?/?$\";s:45:\"index.php?year=$matches[1]&wc-api=$matches[3]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:64:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:53:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/embed/?$\";s:91:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/comment-page-([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&cpage=$matches[5]\";s:62:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/wc-api(/(.*))?/?$\";s:99:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&wc-api=$matches[6]\";s:62:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:73:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:61:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(?:/([0-9]+))?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:53:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&cpage=$matches[4]\";s:51:\"([0-9]{4})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&cpage=$matches[3]\";s:38:\"([0-9]{4})/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&cpage=$matches[2]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:25:\"(.?.+?)/wc-api(/(.*))?/?$\";s:49:\"index.php?pagename=$matches[1]&wc-api=$matches[3]\";s:28:\"(.?.+?)/order-pay(/(.*))?/?$\";s:52:\"index.php?pagename=$matches[1]&order-pay=$matches[3]\";s:33:\"(.?.+?)/order-received(/(.*))?/?$\";s:57:\"index.php?pagename=$matches[1]&order-received=$matches[3]\";s:25:\"(.?.+?)/orders(/(.*))?/?$\";s:49:\"index.php?pagename=$matches[1]&orders=$matches[3]\";s:29:\"(.?.+?)/view-order(/(.*))?/?$\";s:53:\"index.php?pagename=$matches[1]&view-order=$matches[3]\";s:28:\"(.?.+?)/downloads(/(.*))?/?$\";s:52:\"index.php?pagename=$matches[1]&downloads=$matches[3]\";s:31:\"(.?.+?)/edit-account(/(.*))?/?$\";s:55:\"index.php?pagename=$matches[1]&edit-account=$matches[3]\";s:31:\"(.?.+?)/edit-address(/(.*))?/?$\";s:55:\"index.php?pagename=$matches[1]&edit-address=$matches[3]\";s:34:\"(.?.+?)/payment-methods(/(.*))?/?$\";s:58:\"index.php?pagename=$matches[1]&payment-methods=$matches[3]\";s:32:\"(.?.+?)/lost-password(/(.*))?/?$\";s:56:\"index.php?pagename=$matches[1]&lost-password=$matches[3]\";s:34:\"(.?.+?)/customer-logout(/(.*))?/?$\";s:58:\"index.php?pagename=$matches[1]&customer-logout=$matches[3]\";s:37:\"(.?.+?)/add-payment-method(/(.*))?/?$\";s:61:\"index.php?pagename=$matches[1]&add-payment-method=$matches[3]\";s:40:\"(.?.+?)/delete-payment-method(/(.*))?/?$\";s:64:\"index.php?pagename=$matches[1]&delete-payment-method=$matches[3]\";s:45:\"(.?.+?)/set-default-payment-method(/(.*))?/?$\";s:69:\"index.php?pagename=$matches[1]&set-default-payment-method=$matches[3]\";s:31:\".?.+?/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:42:\".?.+?/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";}', 'yes'),
 (30, 'hack_file', '0', 'yes'),
 (31, 'blog_charset', 'UTF-8', 'yes'),
 (32, 'moderation_keys', '', 'no'),
 (33, 'active_plugins', 'a:7:{i:0;s:33:\"duplicator-pro/duplicator-pro.php\";i:1;s:37:\"login-customizer/login-customizer.php\";i:2;s:23:\"revslider/revslider.php\";i:3;s:27:\"updraftplus/updraftplus.php\";i:4;s:27:\"woocommerce/woocommerce.php\";i:5;s:23:\"wordfence/wordfence.php\";i:6;s:23:\"wp-cerber/wp-cerber.php\";}', 'yes'),
 (34, 'category_base', '', 'yes'),
 (35, 'ping_sites', 'http://rpc.pingomatic.com/', 'yes'),
 (36, 'comment_max_links', '2', 'yes'),
 (37, 'gmt_offset', '0', 'yes'),
 (38, 'default_email_category', '1', 'yes'),
 (39, 'recently_edited', '', 'no'),
 (40, 'template', 'kallyas', 'yes'),
 (41, 'stylesheet', 'kallyas-child', 'yes'),
 (42, 'comment_whitelist', '1', 'yes'),
 (43, 'blacklist_keys', '', 'no'),
 (44, 'comment_registration', '0', 'yes'),
 (45, 'html_type', 'text/html', 'yes'),
 (46, 'use_trackback', '0', 'yes'),
 (47, 'default_role', 'subscriber', 'yes'),
 (48, 'db_version', '47018', 'yes'),
 (49, 'uploads_use_yearmonth_folders', '1', 'yes'),
 (50, 'upload_path', '', 'yes'),
 (51, 'blog_public', '1', 'yes'),
 (52, 'default_link_category', '2', 'yes'),
 (53, 'show_on_front', 'page', 'yes'),
 (54, 'tag_base', '', 'yes'),
 (55, 'show_avatars', '1', 'yes'),
 (56, 'avatar_rating', 'G', 'yes'),
 (57, 'upload_url_path', '', 'yes'),
 (58, 'thumbnail_size_w', '150', 'yes'),
 (59, 'thumbnail_size_h', '150', 'yes'),
 (60, 'thumbnail_crop', '1', 'yes'),
 (61, 'medium_size_w', '300', 'yes'),
 (62, 'medium_size_h', '300', 'yes'),
 (63, 'avatar_default', 'mystery', 'yes'),
 (64, 'large_size_w', '1024', 'yes'),
 (65, 'large_size_h', '1024', 'yes'),
 (66, 'image_default_link_type', 'none', 'yes'),
 (67, 'image_default_size', '', 'yes'),
 (68, 'image_default_align', '', 'yes'),
 (69, 'close_comments_for_old_posts', '0', 'yes'),
 (70, 'close_comments_days_old', '14', 'yes'),
 (71, 'thread_comments', '1', 'yes'),
 (72, 'thread_comments_depth', '5', 'yes'),
 (73, 'page_comments', '0', 'yes'),
 (74, 'comments_per_page', '50', 'yes'),
 (75, 'default_comments_page', 'newest', 'yes'),
 (76, 'comment_order', 'asc', 'yes'),
 (77, 'sticky_posts', 'a:0:{}', 'yes'),
 (78, 'widget_categories', 'a:3:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}i:3;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (79, 'widget_text', 'a:0:{}', 'yes'),
 (80, 'widget_rss', 'a:0:{}', 'yes'),
 (81, 'uninstall_plugins', 'a:1:{s:23:\"wp-cerber/wp-cerber.php\";s:13:\"cerber_finito\";}', 'no'),
 (82, 'timezone_string', '', 'yes'),
 (83, 'page_for_posts', '0', 'yes'),
 (84, 'page_on_front', '149', 'yes'),
 (85, 'default_post_format', '0', 'yes'),
 (86, 'link_manager_enabled', '0', 'yes'),
 (87, 'finished_splitting_shared_terms', '1', 'yes'),
 (88, 'site_icon', '0', 'yes'),
 (89, 'medium_large_size_w', '768', 'yes'),
 (90, 'medium_large_size_h', '0', 'yes'),
 (91, 'wp_page_for_privacy_policy', '3', 'yes'),
 (92, 'show_comments_cookies_opt_in', '1', 'yes'),
 (93, 'admin_email_lifespan', '1612712266', 'yes'),
 (94, 'initial_db_version', '45805', 'yes'),
 (95, 'wp8b_user_roles', 'a:7:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:117:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:23:\"wf2fa_activate_2fa_self\";b:1;s:25:\"wf2fa_activate_2fa_others\";b:1;s:21:\"wf2fa_manage_settings\";b:1;s:18:\"manage_woocommerce\";b:1;s:24:\"view_woocommerce_reports\";b:1;s:12:\"edit_product\";b:1;s:12:\"read_product\";b:1;s:14:\"delete_product\";b:1;s:13:\"edit_products\";b:1;s:20:\"edit_others_products\";b:1;s:16:\"publish_products\";b:1;s:21:\"read_private_products\";b:1;s:15:\"delete_products\";b:1;s:23:\"delete_private_products\";b:1;s:25:\"delete_published_products\";b:1;s:22:\"delete_others_products\";b:1;s:21:\"edit_private_products\";b:1;s:23:\"edit_published_products\";b:1;s:20:\"manage_product_terms\";b:1;s:18:\"edit_product_terms\";b:1;s:20:\"delete_product_terms\";b:1;s:20:\"assign_product_terms\";b:1;s:15:\"edit_shop_order\";b:1;s:15:\"read_shop_order\";b:1;s:17:\"delete_shop_order\";b:1;s:16:\"edit_shop_orders\";b:1;s:23:\"edit_others_shop_orders\";b:1;s:19:\"publish_shop_orders\";b:1;s:24:\"read_private_shop_orders\";b:1;s:18:\"delete_shop_orders\";b:1;s:26:\"delete_private_shop_orders\";b:1;s:28:\"delete_published_shop_orders\";b:1;s:25:\"delete_others_shop_orders\";b:1;s:24:\"edit_private_shop_orders\";b:1;s:26:\"edit_published_shop_orders\";b:1;s:23:\"manage_shop_order_terms\";b:1;s:21:\"edit_shop_order_terms\";b:1;s:23:\"delete_shop_order_terms\";b:1;s:23:\"assign_shop_order_terms\";b:1;s:16:\"edit_shop_coupon\";b:1;s:16:\"read_shop_coupon\";b:1;s:18:\"delete_shop_coupon\";b:1;s:17:\"edit_shop_coupons\";b:1;s:24:\"edit_others_shop_coupons\";b:1;s:20:\"publish_shop_coupons\";b:1;s:25:\"read_private_shop_coupons\";b:1;s:19:\"delete_shop_coupons\";b:1;s:27:\"delete_private_shop_coupons\";b:1;s:29:\"delete_published_shop_coupons\";b:1;s:26:\"delete_others_shop_coupons\";b:1;s:25:\"edit_private_shop_coupons\";b:1;s:27:\"edit_published_shop_coupons\";b:1;s:24:\"manage_shop_coupon_terms\";b:1;s:22:\"edit_shop_coupon_terms\";b:1;s:24:\"delete_shop_coupon_terms\";b:1;s:24:\"assign_shop_coupon_terms\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}s:8:\"customer\";a:2:{s:4:\"name\";s:8:\"Customer\";s:12:\"capabilities\";a:1:{s:4:\"read\";b:1;}}s:12:\"shop_manager\";a:2:{s:4:\"name\";s:12:\"Shop manager\";s:12:\"capabilities\";a:92:{s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:4:\"read\";b:1;s:18:\"read_private_pages\";b:1;s:18:\"read_private_posts\";b:1;s:10:\"edit_posts\";b:1;s:10:\"edit_pages\";b:1;s:20:\"edit_published_posts\";b:1;s:20:\"edit_published_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"edit_private_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:17:\"edit_others_pages\";b:1;s:13:\"publish_posts\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_posts\";b:1;s:12:\"delete_pages\";b:1;s:20:\"delete_private_pages\";b:1;s:20:\"delete_private_posts\";b:1;s:22:\"delete_published_pages\";b:1;s:22:\"delete_published_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:19:\"delete_others_pages\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:17:\"moderate_comments\";b:1;s:12:\"upload_files\";b:1;s:6:\"export\";b:1;s:6:\"import\";b:1;s:10:\"list_users\";b:1;s:18:\"edit_theme_options\";b:1;s:18:\"manage_woocommerce\";b:1;s:24:\"view_woocommerce_reports\";b:1;s:12:\"edit_product\";b:1;s:12:\"read_product\";b:1;s:14:\"delete_product\";b:1;s:13:\"edit_products\";b:1;s:20:\"edit_others_products\";b:1;s:16:\"publish_products\";b:1;s:21:\"read_private_products\";b:1;s:15:\"delete_products\";b:1;s:23:\"delete_private_products\";b:1;s:25:\"delete_published_products\";b:1;s:22:\"delete_others_products\";b:1;s:21:\"edit_private_products\";b:1;s:23:\"edit_published_products\";b:1;s:20:\"manage_product_terms\";b:1;s:18:\"edit_product_terms\";b:1;s:20:\"delete_product_terms\";b:1;s:20:\"assign_product_terms\";b:1;s:15:\"edit_shop_order\";b:1;s:15:\"read_shop_order\";b:1;s:17:\"delete_shop_order\";b:1;s:16:\"edit_shop_orders\";b:1;s:23:\"edit_others_shop_orders\";b:1;s:19:\"publish_shop_orders\";b:1;s:24:\"read_private_shop_orders\";b:1;s:18:\"delete_shop_orders\";b:1;s:26:\"delete_private_shop_orders\";b:1;s:28:\"delete_published_shop_orders\";b:1;s:25:\"delete_others_shop_orders\";b:1;s:24:\"edit_private_shop_orders\";b:1;s:26:\"edit_published_shop_orders\";b:1;s:23:\"manage_shop_order_terms\";b:1;s:21:\"edit_shop_order_terms\";b:1;s:23:\"delete_shop_order_terms\";b:1;s:23:\"assign_shop_order_terms\";b:1;s:16:\"edit_shop_coupon\";b:1;s:16:\"read_shop_coupon\";b:1;s:18:\"delete_shop_coupon\";b:1;s:17:\"edit_shop_coupons\";b:1;s:24:\"edit_others_shop_coupons\";b:1;s:20:\"publish_shop_coupons\";b:1;s:25:\"read_private_shop_coupons\";b:1;s:19:\"delete_shop_coupons\";b:1;s:27:\"delete_private_shop_coupons\";b:1;s:29:\"delete_published_shop_coupons\";b:1;s:26:\"delete_others_shop_coupons\";b:1;s:25:\"edit_private_shop_coupons\";b:1;s:27:\"edit_published_shop_coupons\";b:1;s:24:\"manage_shop_coupon_terms\";b:1;s:22:\"edit_shop_coupon_terms\";b:1;s:24:\"delete_shop_coupon_terms\";b:1;s:24:\"assign_shop_coupon_terms\";b:1;}}}', 'yes'),
 (96, 'fresh_site', '0', 'yes'),
 (97, 'widget_search', 'a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (98, 'widget_recent-posts', 'a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (99, 'widget_recent-comments', 'a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (100, 'widget_archives', 'a:3:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}i:3;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (101, 'widget_meta', 'a:3:{i:2;a:1:{s:5:\"title\";s:0:\"\";}i:3;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (102, 'sidebars_widgets', 'a:9:{s:19:\"wp_inactive_widgets\";a:0:{}s:14:\"defaultsidebar\";a:11:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-3\";i:4;s:12:\"categories-3\";i:5;s:6:\"meta-3\";i:6;s:32:\"woocommerce_product_categories-1\";i:7;s:28:\"woocommerce_product_search-1\";i:8;s:26:\"woocommerce_price_filter-1\";i:9;s:25:\"woocommerce_widget_cart-1\";i:10;s:38:\"woocommerce_recently_viewed_products-1\";}s:19:\"hiddenpannelsidebar\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}s:8:\"znfooter\";a:0:{}s:10:\"znfooter-2\";a:0:{}s:10:\"znfooter-3\";a:0:{}s:10:\"znfooter-4\";a:0:{}s:10:\"znfooter-5\";a:0:{}s:13:\"array_version\";i:3;}', 'yes'),
 (103, 'cron', 'a:28:{i:1597163511;a:1:{s:26:\"action_scheduler_run_queue\";a:1:{s:32:\"0d04ed39571b55704c122d726248bbac\";a:3:{s:8:\"schedule\";s:12:\"every_minute\";s:4:\"args\";a:1:{i:0;s:7:\"WP Cron\";}s:8:\"interval\";i:60;}}}i:1597163529;a:1:{s:18:\"cerber_bg_launcher\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:8:\"crb_five\";s:4:\"args\";a:0:{}s:8:\"interval\";i:300;}}}i:1597164115;a:1:{s:21:\"wordfence_hourly_cron\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1597164160;a:1:{s:32:\"woocommerce_cancel_unpaid_orders\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:0:{}}}}i:1597164171;a:1:{s:33:\"wc_admin_process_orders_milestone\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1597164183;a:1:{s:29:\"wc_admin_unsnooze_admin_notes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1597164277;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1597165200;a:1:{s:15:\"cerber_hourly_1\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1597165542;a:1:{s:21:\"wordfence_ls_ntp_cron\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1597165800;a:1:{s:15:\"cerber_hourly_2\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1597171360;a:1:{s:24:\"woocommerce_cleanup_logs\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597182160;a:1:{s:28:\"woocommerce_cleanup_sessions\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1597190400;a:1:{s:27:\"woocommerce_scheduled_sales\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597193076;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1597236276;a:1:{s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597236367;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597236368;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597242000;a:1:{s:12:\"cerber_daily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597243300;a:1:{s:26:\"wordfence_daily_autoUpdate\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597243315;a:1:{s:20:\"wordfence_daily_cron\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597246970;a:2:{s:33:\"woocommerce_cleanup_personal_data\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:30:\"woocommerce_tracker_send_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597246971;a:1:{s:14:\"wc_admin_daily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1597282200;a:1:{s:30:\"wordfence_start_scheduled_scan\";a:1:{s:32:\"41adb985f99061351822e8c3a556c7f3\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:1597282200;}}}}i:1597413048;a:1:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1597541400;a:1:{s:30:\"wordfence_start_scheduled_scan\";a:1:{s:32:\"bda009ff82d4c0931441bdfb5e64a617\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:1597541400;}}}}i:1597680000;a:1:{s:31:\"wordfence_email_activity_report\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:0:{}}}}i:1598456620;a:1:{s:25:\"woocommerce_geoip_updater\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:11:\"fifteendays\";s:4:\"args\";a:0:{}s:8:\"interval\";i:1296000;}}}s:7:\"version\";i:2;}', 'yes'),
 (1541, '_site_transient_timeout_cerber_hourly_1', '1597168834', 'no'),
 (1542, '_site_transient_cerber_hourly_1', 'a:2:{i:0;i:1597161634;i:1;i:1597161634;}', 'no'),
 (467, 'recovery_mode_email_last_sent', '1597070562', 'yes'),
 (104, 'widget_pages', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (105, 'widget_calendar', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (106, 'widget_media_audio', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (107, 'widget_media_image', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (108, 'widget_media_gallery', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (109, 'widget_media_video', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (110, 'widget_tag_cloud', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (111, 'widget_nav_menu', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (112, 'widget_custom_html', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (113, 'recovery_keys', 'a:1:{s:22:\"Lzso8kHx73ljEklSq37z58\";a:2:{s:10:\"hashed_key\";s:34:\"$P$BMl3AqvjhfadoPa6QHLCbSec6dRcTI.\";s:10:\"created_at\";i:1597070562;}}', 'yes'),
 (114, 'theme_mods_twentytwenty', 'a:2:{s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1578315308;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}}}}', 'yes'),
 (1550, '_site_transient_timeout_theme_roots', '1597161810', 'no'),
 (1551, '_site_transient_theme_roots', 'a:2:{s:13:\"kallyas-child\";s:7:\"/themes\";s:7:\"kallyas\";s:7:\"/themes\";}', 'no'),
 (122, 'WPLANG', 'es_ES', 'yes'),
 (177, 'login_customizer_options', 'a:26:{i:0;s:14:\"logincust_logo\";i:1;s:20:\"logincust_logo_width\";i:2;s:21:\"logincust_logo_height\";i:3;s:22:\"logincust_logo_padding\";i:4;s:18:\"logincust_bg_image\";i:5;s:18:\"logincust_bg_color\";i:6;s:17:\"logincust_bg_size\";i:7;s:23:\"logincust_form_bg_image\";i:8;s:23:\"logincust_form_bg_color\";i:9;s:20:\"logincust_form_width\";i:10;s:21:\"logincust_form_height\";i:11;s:22:\"logincust_form_padding\";i:12;s:21:\"logincust_field_width\";i:13;s:22:\"logincust_field_margin\";i:14;s:18:\"logincust_field_bg\";i:15;s:21:\"logincust_field_color\";i:16;s:21:\"logincust_field_label\";i:17;s:19:\"logincust_button_bg\";i:18;s:23:\"logincust_button_border\";i:19;s:23:\"logincust_button_shadow\";i:20;s:22:\"logincust_button_color\";i:21;s:25:\"logincust_button_hover_bg\";i:22;s:29:\"logincust_button_hover_border\";i:23;s:21:\"logincust_other_color\";i:24;s:27:\"logincust_other_color_hover\";i:25;s:19:\"logincust_other_css\";}', 'yes'),
 (178, 'login_customizer_settings', 'a:2:{s:4:\"page\";i:8;s:7:\"version\";s:5:\"2.0.1\";}', 'yes'),
 (183, 'kallyas_hg_dash_api_key', '71B72-0084B-A0EAD-61066-8930C', 'yes'),
 (723, 'db_upgraded', '', 'yes'),
 (293, 'revslider-templates-check', '1597070494', 'yes'),
 (294, 'revslider-templates-hash', 'd18c36e2537bd40f9c1fd848b227cfb1', 'yes'),
 (295, 'rs-templates-new', '', 'no'),
 (358, 'theme_mods_colibri-wp', 'a:3:{i:0;b:0;s:18:\"nav_menu_locations\";a:0:{}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1580384436;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:17:\"colibri-sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:21:\"colibri-sidebar-woo-1\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}}}}', 'yes'),
 (624, 'revslider-valid', 'true', 'yes'),
 (625, 'revslider-code', '527f6eb2-6f47-405e-9fed-cd587c5ba0d7', 'yes'),
 (626, 'revslider-update-check', '1597070486', 'yes'),
 (627, 'revslider_update_info', 'O:8:\"stdClass\":3:{s:7:\"checked\";i:1597070486;s:5:\"basic\";O:8:\"stdClass\":7:{s:4:\"slug\";s:9:\"revslider\";s:7:\"version\";s:6:\"6.2.17\";s:7:\"package\";s:102:\"http://updates.themepunch-ext-b.tools/revslider/download.php?code=527f6eb2-6f47-405e-9fed-cd587c5ba0d7\";s:6:\"tested\";s:5:\"5.4.3\";s:5:\"icons\";a:1:{s:2:\"1x\";s:62:\"//updates.themepunch-ext-b.tools/revslider/logo.png?rev=6.2.17\";}s:3:\"url\";s:60:\"https://www.themepunch.com/links/slider_revolution_wordpress\";s:11:\"new_version\";s:6:\"6.2.17\";}s:4:\"full\";O:8:\"stdClass\":19:{s:7:\"banners\";a:2:{s:3:\"low\";s:64:\"//updates.themepunch-ext-b.tools/revslider/banner.png?rev=6.2.17\";s:4:\"high\";s:64:\"//updates.themepunch-ext-b.tools/revslider/banner.png?rev=6.2.17\";}s:4:\"name\";s:17:\"Slider Revolution\";s:4:\"slug\";s:9:\"revslider\";s:6:\"stable\";s:3:\"4.2\";s:7:\"version\";s:6:\"6.2.17\";s:6:\"tested\";s:5:\"5.4.3\";s:14:\"upgrade_notice\";a:0:{}s:11:\"last_update\";s:10:\"2020-07-17\";s:12:\"last_updated\";s:10:\"2020-07-17\";s:8:\"requires\";s:3:\"3.6\";s:6:\"author\";s:51:\"<a href=\"https://www.themepunch.com\">ThemePunch</a>\";s:7:\"package\";s:102:\"http://updates.themepunch-ext-b.tools/revslider/download.php?code=527f6eb2-6f47-405e-9fed-cd587c5ba0d7\";s:13:\"download_link\";s:102:\"http://updates.themepunch-ext-b.tools/revslider/download.php?code=527f6eb2-6f47-405e-9fed-cd587c5ba0d7\";s:9:\"file_name\";s:13:\"revslider.zip\";s:15:\"active_installs\";i:7000100;s:8:\"homepage\";s:33:\"https://revolution.themepunch.com\";s:8:\"sections\";a:3:{s:11:\"description\";s:497:\"<h4>Slider Revolution WordPress Builder Plugin</h4>\n	<p>Slider Revolution 6 is a new way to build rich & dynamic content for your websites. With our powerful visual editor, you can create modern designs in no time, and with no coding experience required.</p><p>Create Sliders & Carousels, Hero Headers, Content Modules, Full Websites, Dynamic Solutions and Special FX with our amazing Add-Ons.</p>\n	<p>200+ templates are included in our online library. Cutting edge designs. Easily customized.</p>\";s:9:\"changelog\";s:151:\"<p>For Slider Revolution\'s changelog, please visit <a href=\"https://www.themepunch.com/slider-revolution/changelog/\" target=\"_blank\">this</a> site!</p>\";s:3:\"faq\";s:2178:\"<div class=\"tp-faq-content\"><div class=\"tp-faq-column tp-faq-recent\"><h4>Recent Solutions</h4><ul class=\"tp-faq-recent-content ready\"><li><a href=\"https://www.youtube.com/watch?v=sCcnw5bZqYY&amp;list=PLSCdqDWVMJPPXEuOEqYEQMAsp0vAYw52_&amp;index=2&amp;t=111s\" target=\"_blank\" title=\"Video Tutorials\">Video Tutorials</a></li><li><a href=\"https://www.themepunch.com/faq/responsive-content/\" target=\"_blank\" title=\"Responsive Content Setup\">Responsive Content Setup</a></li><li><a href=\"https://www.themepunch.com/faq/video-content-mobile/\" target=\"_blank\" title=\"Video Content &amp; Mobile Considerations\">Video Content &amp; Mobile Considerations</a></li><li><a href=\"https://www.themepunch.com/faq/how-to-change-the-timing-of-slides/\" target=\"_blank\" title=\"How to change the timing of Slides\">How to change the timing of Slides</a></li><li><a href=\"https://www.themepunch.com/faq/mouse-hovers-for-layer-content/\" target=\"_blank\" title=\"Mouse Hovers for Layer Content\"> Mouse Hovers for Layer Content</a></li></ul></div><div class=\"tp-faq-column tp-faq-popular\"><h4>Popular Solutions</h4><ul class=\"tp-faq-popular-content ready\"><li><a href=\"https://www.themepunch.com/faq/after-updating-make-sure-to-clear-all-caches/\" target=\"_blank\" title=\"After updating – Make sure to clear all caches\">After updating – Make sure to clear all caches</a></li><li><a href=\"https://www.themepunch.com/faq/purchase-code-registration-faqs/\" target=\"_blank\" title=\"Purchase Code Registration FAQ’s\">Purchase Code Registration FAQ’s</a></li><li><a href=\"https://www.themepunch.com/faq/ideal-image-size/\" target=\"_blank\" title=\"Ideal Image Size\">Ideal Image Size</a></li><li><a href=\"https://www.themepunch.com/faq/add-links-to-slides-and-layers/\" target=\"_blank\" title=\"How to Hyperlink Slides and Layers\">How to Hyperlink Slides and Layers</a></li><li><a href=\"https://www.themepunch.com/faq/where-to-find-the-purchase-code/\" target=\"_blank\" title=\"Where to find the Purchase Code\">Where to find the Purchase Code</a></li></ul></div><div style=\"clear: both\"></div><p><a class=\"button button-primary\" href=\"https://themepunch.com/support-center\"><strong>See All Faq\'s</strong></a></p></div>\";}s:3:\"url\";s:60:\"https://www.themepunch.com/links/slider_revolution_wordpress\";s:8:\"external\";i:1;}}', 'yes'),
 (146, 'recently_activated', 'a:0:{}', 'yes'),
 (149, 'current_theme', 'Kallyas Child Theme', 'yes'),
 (150, 'theme_mods_kallyas', 'a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:0:{}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1585837054;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:14:\"defaultsidebar\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:19:\"hiddenpannelsidebar\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}s:8:\"znfooter\";a:0:{}s:10:\"znfooter-2\";a:0:{}s:10:\"znfooter-3\";a:0:{}s:10:\"znfooter-4\";a:0:{}s:10:\"znfooter-5\";a:0:{}}}}', 'yes'),
 (151, 'theme_switched', '', 'yes'),
 (152, 'widget_sbs_nav_menu', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (153, 'widget_tp_widget_recent_tweets', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (154, 'widget_text_contact', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (155, 'widget_zn_mailchimp', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (156, 'widget_social_buttons', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (157, 'widget_zn_flickr', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (160, 'znhgfw_current_domain', 'latigid.ociv.xoledom//:sptth', 'no'),
 (161, 'zn_kallyas_optionsv4', 'a:375:{i:0;a:7:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:16:\"GENERAL SETTINGS\";s:11:\"description\";s:49:\"These settings below are related to theme itself.\";s:2:\"id\";s:11:\"info_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:1;a:8:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"Use page preloader?\";s:11:\"description\";s:48:\"Choose yes if you want to show a page preloader.\";s:2:\"id\";s:14:\"page_preloader\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:7:{s:2:\"no\";s:2:\"No\";s:3:\"yes\";s:26:\"Pulsating-circle animation\";s:11:\"yes_spinner\";s:17:\"Spinner animation\";s:9:\"yes_persp\";s:28:\"Perspective-square animation\";s:13:\"yes_img_persp\";s:36:\"Custom Image & perspective animation\";s:14:\"yes_img_breath\";s:31:\"Custom Image & breath animation\";s:7:\"yes_img\";s:27:\"Custom Image & no animation\";}s:4:\"type\";s:6:\"select\";}i:2;a:9:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:34:\"Preloader overlay background color\";s:11:\"description\";s:193:\"Please choose a default color for the preloader\'s overlay background color. Please remember, if you\'re using large images or too many external resources, the preloader will take longer to hide.\";s:2:\"id\";s:17:\"page_preloader_bg\";s:5:\"alpha\";s:4:\"true\";s:3:\"std\";s:7:\"#ffffff\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:14:\"page_preloader\";s:5:\"value\";a:6:{i:0;s:3:\"yes\";i:1;s:11:\"yes_spinner\";i:2;s:9:\"yes_persp\";i:3;s:13:\"yes_img_persp\";i:4;s:14:\"yes_img_breath\";i:5;s:7:\"yes_img\";}}}i:3;a:8:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:41:\"Preloader Custom Image (.jpg, .gif, .svg)\";s:11:\"description\";s:55:\"Please choose image to be displayed into the preloader.\";s:2:\"id\";s:18:\"page_preloader_img\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"media\";s:10:\"dependency\";a:2:{s:7:\"element\";s:14:\"page_preloader\";s:5:\"value\";a:3:{i:0;s:7:\"yes_img\";i:1;s:13:\"yes_img_persp\";i:2;s:14:\"yes_img_breath\";}}}i:4;a:8:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Enable Smooth Scroll?\";s:11:\"description\";s:181:\"This option will hijack the page default scroll and add an ease effect. It\'s very appealing with parallax scrolls and general navigation. Do though that it\'s a performance consumer.\";s:2:\"id\";s:13:\"smooth_scroll\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:7:{s:3:\"0.1\";s:40:\"Yes - Ultra Fast speed (almost disabled)\";s:4:\"0.25\";s:16:\"Yes - Fast speed\";s:3:\"yes\";s:20:\"Yes - Moderate speed\";s:2:\"no\";s:13:\"No - Disabled\";s:4:\"0.75\";s:16:\"Yes - Slow speed\";i:1;s:22:\"Yes - Super Slow speed\";s:3:\"1.6\";s:17:\"Yes - Snail speed\";}s:4:\"type\";s:6:\"select\";}i:5;a:10:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:37:\"Disable Trackpad/Magic Mouse Support?\";s:11:\"description\";s:132:\"On *some* Macs the mouse wheel is recognized as a trackpad, therefore if this is disabled, it might not work at all. Use carefully! \";s:2:\"id\";s:17:\"smooth_scroll_osx\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:2:{s:3:\"yes\";s:3:\"Yes\";s:2:\"no\";s:2:\"No\";}s:4:\"type\";s:8:\"zn_radio\";s:5:\"class\";s:15:\"zn_radio--yesno\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"smooth_scroll\";s:5:\"value\";a:6:{i:0;s:3:\"0.1\";i:1;s:4:\"0.25\";i:2;s:3:\"yes\";i:3;s:4:\"0.75\";i:4;s:1:\"1\";i:5;s:3:\"1.6\";}}}i:6;a:7:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:8:\"go_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:7;a:7:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#u0uQWA-kJOY\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:8;a:7:{s:4:\"slug\";s:15:\"general_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:9;a:7:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:28:\"HEADER CUSTOMIZATION OPTIONS\";s:11:\"description\";s:53:\"These are header advanced options for customisations.\";s:2:\"id\";s:11:\"info_title2\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:10;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:34:\"Header over Subheader / Slideshow?\";s:11:\"description\";s:216:\"This will basically toggle the header\'s css position, from \'absolute\' to \'relative\'. If this option is disabled, the subheader or slideshow will go after the header. Don\'t foget to style the background of the header.\";s:2:\"id\";s:13:\"head_position\";s:3:\"std\";s:1:\"1\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";i:0;s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:11;a:7:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:14:\"STYLES OPTIONS\";s:11:\"description\";s:81:\"These options are dedicated to customizing the header background and text colors.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:12;a:8:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:12:\"Header Style\";s:11:\"description\";s:39:\"Select the desired style for the header\";s:2:\"id\";s:12:\"header_style\";s:3:\"std\";s:7:\"default\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:7:\"default\";s:7:\"Default\";s:11:\"image_color\";s:40:\"Custom ( Background Image, Color, Font )\";}}i:13;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:23:\"Header Background Image\";s:11:\"description\";s:59:\"Please choose your desired image to be used as a background\";s:2:\"id\";s:18:\"header_style_image\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:3:{s:6:\"repeat\";s:1:\"1\";s:8:\"position\";s:1:\"1\";s:10:\"attachment\";s:1:\"1\";}s:4:\"type\";s:10:\"background\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"header_style\";s:5:\"value\";a:1:{i:0;s:11:\"image_color\";}}}i:14;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:16:\"Background Color\";s:11:\"description\";s:58:\"Please choose your desired background color for the header\";s:2:\"id\";s:18:\"header_style_color\";s:5:\"alpha\";s:1:\"1\";s:3:\"std\";s:4:\"#000\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"header_style\";s:5:\"value\";a:1:{i:0;s:11:\"image_color\";}}}i:15;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Header Text Color\";s:11:\"description\";s:166:\"Please choose a text color scheme. This helps in case you add a dark background and you want light colors, or in case of light background - dark colors for the texts.\";s:2:\"id\";s:18:\"header_text_scheme\";s:3:\"std\";s:7:\"default\";s:7:\"options\";a:4:{s:7:\"default\";s:20:\"Header style default\";s:5:\"light\";s:11:\"Light color\";s:4:\"gray\";s:14:\"Grayish colors\";s:4:\"dark\";s:13:\"Darken colors\";}s:4:\"type\";s:6:\"select\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"header_style\";s:5:\"value\";a:1:{i:0;s:11:\"image_color\";}}}i:16;a:10:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:32:\"Sticky Header - Background Color\";s:11:\"description\";s:79:\"Please choose your desired background color for the header when in sticky mode.\";s:2:\"id\";s:25:\"sticky_header_style_color\";s:5:\"alpha\";s:1:\"1\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:5:\"class\";s:22:\"zn-top-separator--thin\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:12:\"header_style\";s:5:\"value\";a:1:{i:0;s:11:\"image_color\";}}i:1;a:2:{s:7:\"element\";s:11:\"menu_follow\";s:5:\"value\";a:1:{i:0;s:6:\"sticky\";}}}}i:17;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:33:\"Sticky Header - Header Text Color\";s:11:\"description\";s:54:\"Please choose a text color scheme when in sticky mode.\";s:2:\"id\";s:25:\"sticky_header_text_scheme\";s:3:\"std\";s:7:\"default\";s:7:\"options\";a:4:{s:7:\"default\";s:20:\"Header style default\";s:5:\"light\";s:11:\"Light color\";s:4:\"gray\";s:14:\"Grayish colors\";s:4:\"dark\";s:13:\"Darken colors\";}s:4:\"type\";s:6:\"select\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:12:\"header_style\";s:5:\"value\";a:1:{i:0;s:11:\"image_color\";}}i:1;a:2:{s:7:\"element\";s:11:\"menu_follow\";s:5:\"value\";a:1:{i:0;s:6:\"sticky\";}}}}i:18;a:10:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:22:\"Header\'s TOP Bar Style\";s:11:\"description\";s:50:\"Select the desired style for the header\'s top bar.\";s:2:\"id\";s:12:\"topbar_style\";s:3:\"std\";s:7:\"default\";s:4:\"type\";s:8:\"zn_radio\";s:5:\"class\";s:16:\"zn-non-dependent\";s:7:\"options\";a:2:{s:7:\"default\";s:7:\"Default\";s:6:\"custom\";s:30:\"Custom Size & Background Color\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"zn_header_layout\";s:5:\"value\";a:9:{i:0;s:6:\"style7\";i:1;s:6:\"style8\";i:2;s:6:\"style9\";i:3;s:7:\"style10\";i:4;s:7:\"style11\";i:5;s:7:\"style12\";i:6;s:7:\"style13\";i:7;s:7:\"style14\";i:8;s:7:\"style15\";}}}i:19;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:13:\"Top Bar Width\";s:11:\"description\";s:55:\"Please choose if you want the Top Bar to be full-width.\";s:2:\"id\";s:11:\"topbar_size\";s:3:\"std\";s:7:\"default\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:7:\"default\";s:20:\"Header style default\";s:6:\"normal\";s:6:\"Normal\";s:4:\"full\";s:10:\"Full width\";}s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:12:\"topbar_style\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}i:1;a:2:{s:7:\"element\";s:16:\"zn_header_layout\";s:5:\"value\";a:9:{i:0;s:6:\"style7\";i:1;s:6:\"style8\";i:2;s:6:\"style9\";i:3;s:7:\"style10\";i:4;s:7:\"style11\";i:5;s:7:\"style12\";i:6;s:7:\"style13\";i:7;s:7:\"style14\";i:8;s:7:\"style15\";}}}}i:20;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:26:\"Top Bar - Background Color\";s:11:\"description\";s:68:\"Please choose your desired background color for the header\'s Top Bar\";s:2:\"id\";s:15:\"topbar_bg_color\";s:5:\"alpha\";s:1:\"1\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:12:\"topbar_style\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}i:1;a:2:{s:7:\"element\";s:16:\"zn_header_layout\";s:5:\"value\";a:9:{i:0;s:6:\"style7\";i:1;s:6:\"style8\";i:2;s:6:\"style9\";i:3;s:7:\"style10\";i:4;s:7:\"style11\";i:5;s:7:\"style12\";i:6;s:7:\"style13\";i:7;s:7:\"style14\";i:8;s:7:\"style15\";}}}}i:21;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"Top Bar - Text Color\";s:11:\"description\";s:166:\"Please choose a text color scheme. This helps in case you add a dark background and you want light colors, or in case of light background - dark colors for the texts.\";s:2:\"id\";s:18:\"topbar_text_scheme\";s:3:\"std\";s:7:\"default\";s:7:\"options\";a:4:{s:7:\"default\";s:20:\"Header style default\";s:5:\"light\";s:11:\"Light color\";s:4:\"gray\";s:14:\"Grayish colors\";s:4:\"dark\";s:13:\"Darken colors\";}s:4:\"type\";s:6:\"select\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:12:\"topbar_style\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}i:1;a:2:{s:7:\"element\";s:16:\"zn_header_layout\";s:5:\"value\";a:9:{i:0;s:6:\"style7\";i:1;s:6:\"style8\";i:2;s:6:\"style9\";i:3;s:7:\"style10\";i:4;s:7:\"style11\";i:5;s:7:\"style12\";i:6;s:7:\"style13\";i:7;s:7:\"style14\";i:8;s:7:\"style15\";}}}}i:22;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:11:\"Header Font\";s:11:\"description\";s:40:\"Override the default font of the header.\";s:2:\"id\";s:11:\"topbar_font\";s:3:\"std\";s:0:\"\";s:8:\"supports\";a:1:{i:0;s:4:\"font\";}s:4:\"type\";s:4:\"font\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:12:\"topbar_style\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}i:1;a:2:{s:7:\"element\";s:16:\"zn_header_layout\";s:5:\"value\";a:9:{i:0;s:6:\"style7\";i:1;s:6:\"style8\";i:2;s:6:\"style9\";i:3;s:7:\"style10\";i:4;s:7:\"style11\";i:5;s:7:\"style12\";i:6;s:7:\"style13\";i:7;s:7:\"style14\";i:8;s:7:\"style15\";}}}}i:23;a:7:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:12:\"SIZE OPTIONS\";s:11:\"description\";s:60:\"These options are dedicated to customizing the header sizes.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:24;a:10:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:15:\"header_width_v2\";s:4:\"name\";s:12:\"Header Width\";s:11:\"description\";s:104:\"Choose the desired width for the header\'s container. It will be applied on Large breakpoints ( 1200px );\";s:4:\"type\";s:12:\"smart_slider\";s:3:\"std\";a:9:{s:11:\"breakpoints\";s:1:\"1\";s:2:\"lg\";s:4:\"1170\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:3:\"100\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:3:\"100\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:3:\"100\";s:7:\"unit_xs\";s:1:\"%\";}s:8:\"supports\";a:1:{i:0;s:11:\"breakpoints\";}s:5:\"units\";a:2:{i:0;s:2:\"px\";i:1;s:1:\"%\";}s:7:\"helpers\";a:2:{s:3:\"min\";s:2:\"20\";s:3:\"max\";s:4:\"1900\";}}i:25;a:8:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:13:\"Header Height\";s:11:\"description\";s:38:\"You can customize the header\'s height.\";s:2:\"id\";s:18:\"zn_head_height_enb\";s:3:\"std\";s:7:\"default\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:3:{s:7:\"default\";s:7:\"Default\";s:6:\"custom\";a:2:{s:5:\"title\";s:13:\"Custom Height\";s:3:\"tip\";s:32:\"It will maintain vertical ratio.\";}s:11:\"custom_rows\";a:2:{s:5:\"title\";s:22:\"Custom height per Rows\";s:3:\"tip\";s:42:\"Advanced options for full customisability.\";}}}i:26;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Header Height (in px)\";s:11:\"description\";s:88:\"Header\'s height. By default it\'s 100px. <strong>Leave empty if you\'re not sure!</strong>\";s:2:\"id\";s:14:\"zn_head_height\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:11:\"placeholder\";s:9:\"ex: 100px\";s:10:\"dependency\";a:2:{s:7:\"element\";s:18:\"zn_head_height_enb\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}}i:27;a:9:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:22:\"Custom height per Rows\";s:11:\"description\";s:39:\"You can customize any row of the header\";s:2:\"id\";s:19:\"zn_head_height_rows\";s:10:\"dependency\";a:2:{s:7:\"element\";s:18:\"zn_head_height_enb\";s:5:\"value\";a:1:{i:0;s:11:\"custom_rows\";}}s:4:\"type\";s:10:\"group_text\";s:3:\"std\";a:1:{s:6:\"others\";s:1:\"0\";}s:6:\"config\";a:2:{s:4:\"size\";s:8:\"zn_span3\";s:7:\"options\";a:4:{i:0;a:3:{s:4:\"name\";s:7:\"TOP ROW\";s:2:\"id\";s:3:\"top\";s:11:\"placeholder\";s:8:\"eg: 50px\";}i:1;a:3:{s:4:\"name\";s:8:\"MAIN ROW\";s:2:\"id\";s:4:\"main\";s:11:\"placeholder\";s:8:\"eg: 70px\";}i:2;a:3:{s:4:\"name\";s:10:\"BOTTOM ROW\";s:2:\"id\";s:6:\"bottom\";s:11:\"placeholder\";s:8:\"eg: 50px\";}i:3;a:3:{s:4:\"name\";s:6:\"OTHERS\";s:2:\"id\";s:6:\"others\";s:11:\"placeholder\";s:8:\"eg: 10px\";}}}}i:28;a:7:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:13:\"OTHER OPTIONS\";s:11:\"description\";s:42:\"These are various header advanced options.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:29;a:10:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:34:\"Page Scrolling - Custom Top Offset\";s:11:\"description\";s:158:\"You can adjust the top offset of the page when using a scroll to anchor functionality, such as one page scrolling. You can add 0 and it will reset the offset.\";s:2:\"id\";s:20:\"top_offset_tolerance\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:5:\"class\";s:11:\"zn_input_xs\";s:7:\"numeric\";s:1:\"1\";s:7:\"helpers\";a:3:{s:3:\"min\";s:4:\"-100\";s:3:\"max\";s:3:\"100\";s:4:\"step\";s:1:\"1\";}}i:30;a:7:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:8:\"ho_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:31;a:7:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#TuXcJu9jl7c\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:32;a:7:{s:4:\"slug\";s:16:\"head_adv_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:33;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:12:\"LOGO OPTIONS\";s:11:\"description\";s:155:\"These options below are related to site\'s logo. ( <a href=\"http://hogash.d.pr/108qR\" target=\"_blank\" title=\"Click to open screenshot\">Open screenshot</a>).\";s:2:\"id\";s:11:\"info_title3\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:34;a:9:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"Show LOGO in header\";s:11:\"description\";s:53:\"Please choose if you want to display the logo or not.\";s:2:\"id\";s:14:\"head_show_logo\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:35;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:11:\"Logo Upload\";s:11:\"description\";s:380:\"Upload your logo. <br><br> <span class=\'dashicons dashicons-editor-help\'></span> <strong>Logo not changing?</strong> Check if there\'s any <a href=\"https://modelox.vico.digital/wp-admin/edit.php?post_type=zn_layout\">page layout</a> assigned to the page you\'re working on, or <a href=\"https://my.hogash.com/documentation/logo-is-not-changing/\" target=\"_blank\">read this article</a>.\";s:2:\"id\";s:11:\"logo_upload\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"media\";}i:36;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:11:\"Logo Size :\";s:11:\"description\";s:194:\"Auto resize logo will use the image dimensions, Custom size let\'s you set the desired logo size and Contain in header will select the proper logo size so that it will be displayed in the header.\";s:2:\"id\";s:9:\"logo_size\";s:3:\"std\";s:7:\"contain\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:3:{s:3:\"yes\";s:16:\"Auto resize logo\";s:2:\"no\";s:11:\"Custom size\";s:7:\"contain\";s:17:\"Contain in header\";}}i:37;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Logo manual sizes\";s:11:\"description\";s:67:\"Please insert your desired logo size in pixels ( for example \"35\" )\";s:2:\"id\";s:16:\"logo_manual_size\";s:3:\"std\";a:2:{s:6:\"height\";s:2:\"55\";s:5:\"width\";s:3:\"125\";}s:4:\"type\";s:10:\"image_size\";s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"logo_size\";s:5:\"value\";a:1:{i:0;s:2:\"no\";}}}i:38;a:9:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:11:\"Sticky Logo\";s:11:\"description\";s:162:\"Will display a secondary logo when header is sticky and scrolling the page. <strong>ONLY</strong> available if you have Sticky Header enabled in General Options. \";s:2:\"id\";s:11:\"logo_sticky\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"media\";s:10:\"dependency\";a:2:{s:7:\"element\";s:11:\"menu_follow\";s:5:\"value\";a:1:{i:0;s:6:\"sticky\";}}s:5:\"class\";s:16:\"zn-non-dependent\";}i:39;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:14:\"Logo on Mobile\";s:11:\"description\";s:88:\"Upload your logo for displaying on viewports smaller than 767px (smartphones, phablets).\";s:2:\"id\";s:18:\"logo_upload_mobile\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"media\";}i:40;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:22:\"Logo TEXT Link Options\";s:11:\"description\";s:88:\"Specify the logo typography properties. Will only work if you don\'t upload a logo image.\";s:2:\"id\";s:9:\"logo_font\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"36px\";s:11:\"font-family\";s:9:\"Open Sans\";s:10:\"font-style\";s:6:\"normal\";s:5:\"color\";s:4:\"#000\";s:11:\"line-height\";s:4:\"40px\";}s:8:\"supports\";a:6:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:5:\"color\";i:4;s:4:\"line\";i:5;s:6:\"weight\";}s:4:\"type\";s:4:\"font\";}i:41;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:26:\"Logo TEXT Link Hover Color\";s:11:\"description\";s:79:\"Specify the logo hover color. Will only work if you don\'t upload a logo image. \";s:2:\"id\";s:10:\"logo_hover\";s:3:\"std\";a:1:{s:5:\"color\";s:7:\"#CD2122\";}s:8:\"supports\";a:1:{i:0;s:5:\"color\";}s:4:\"type\";s:4:\"font\";}i:42;a:9:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:15:\"Logo Background\";s:11:\"description\";s:43:\"Choose the logo container background color.\";s:2:\"id\";s:7:\"logo_bg\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:5:\"alpha\";s:4:\"true\";s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"zn_header_layout\";s:5:\"value\";a:1:{i:0;s:7:\"style14\";}}}i:43;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"LOGO INFOCARD OPTIONS\";s:11:\"description\";s:165:\"These options below are related to logo\'s info card panel. ( <a href=\"http://hogash.d.pr/TiFZ\" target=\"_blank\" title=\"Click to open screenshot\">Open screenshot</a>).\";s:2:\"id\";s:11:\"info_title5\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:44;a:9:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:43:\"Show Info Card when you hover over the logo\";s:11:\"description\";s:58:\"Please choose if you want to display the info card or not.\";s:2:\"id\";s:23:\"infocard_display_status\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:45;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:34:\"Set a background for the Info Card\";s:11:\"description\";s:45:\"Choose the background color for the Info Card\";s:2:\"id\";s:17:\"infocard_bg_color\";s:3:\"std\";s:7:\"#cd2122\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:46;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:34:\"Set a text color for the Info Card\";s:11:\"description\";s:39:\"Choose the text color for the Info Card\";s:2:\"id\";s:19:\"infocard_text_color\";s:3:\"std\";s:7:\"#ffffff\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:47;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"Choose company logo\";s:11:\"description\";s:55:\"Choose your company logo which will appear in info card\";s:2:\"id\";s:17:\"infocard_logo_url\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"media\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:48;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"Company Description\";s:11:\"description\";s:47:\"Please type a small description of your company\";s:2:\"id\";s:28:\"infocard_company_description\";s:3:\"std\";s:71:\"Kallyas is an ultra-premium, responsive theme built for today websites.\";s:4:\"type\";s:8:\"textarea\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:49;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:13:\"Company phone\";s:11:\"description\";s:37:\"Please type your company phone number\";s:2:\"id\";s:22:\"infocard_company_phone\";s:3:\"std\";s:17:\"T (212) 555 55 00\";s:4:\"type\";s:4:\"text\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:50;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:13:\"Company email\";s:11:\"description\";s:30:\"Please type your company email\";s:2:\"id\";s:22:\"infocard_company_email\";s:3:\"std\";s:21:\"sales@yourwebsite.com\";s:4:\"type\";s:4:\"text\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:51;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:12:\"Company name\";s:11:\"description\";s:27:\"Type your company name here\";s:2:\"id\";s:21:\"infocard_company_name\";s:3:\"std\";s:16:\"Your Company LTD\";s:4:\"type\";s:4:\"text\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:52;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:15:\"Company address\";s:11:\"description\";s:30:\"Type your company address here\";s:2:\"id\";s:24:\"infocard_company_address\";s:3:\"std\";s:35:\"Street nr 100, 4536534, Chicago, US\";s:4:\"type\";s:4:\"text\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:53;a:8:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:16:\"Company map link\";s:11:\"description\";s:33:\"Please enter you company map link\";s:2:\"id\";s:18:\"infocard_gmap_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:54;a:10:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:47:\"Show or hide the Social icons in the info card.\";s:11:\"description\";s:72:\"Please select the visibility status of the Social Icons in the Info card\";s:2:\"id\";s:33:\"social_icons_info_card_visibility\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";s:10:\"dependency\";a:2:{s:7:\"element\";s:23:\"infocard_display_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:55;a:9:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:22:\"Show \"Hover Me\" text .\";s:11:\"description\";s:65:\"Choose to display or hide the \'hover me\' text right next to logo.\";s:2:\"id\";s:16:\"infocard_hoverme\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:56;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"lgo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:57;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:235:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#m2dbZdeciZs\" target=\"_blank\">Click here to access video tutorial for LOGO OPTIONS.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:58;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:244:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#TuXcJu9jl7c\" target=\"_blank\">Click here to access video tutorial for LOGO INFOCARD OPTIONS.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:59;a:7:{s:4:\"slug\";s:12:\"logo_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:60;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:14:\"HEADER OPTIONS\";s:11:\"description\";s:156:\"These options below are related to site\'s header ( <a href=\"http://hogash.d.pr/1cv3m\" target=\"_blank\" title=\"Click to open screenshot\">Open screenshot</a>).\";s:2:\"id\";s:11:\"info_title2\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:61;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:13:\"Header Layout\";s:11:\"description\";s:40:\"Please choose the desired header layout.\";s:2:\"id\";s:16:\"zn_header_layout\";s:3:\"std\";s:6:\"style2\";s:4:\"type\";s:11:\"radio_image\";s:5:\"class\";s:37:\"zn_full ri-hover-line ri-5 ri-maxover\";s:7:\"options\";a:16:{i:0;a:3:{s:5:\"value\";s:6:\"style1\";s:4:\"name\";s:14:\"Style 1.1 (#1)\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style1.svg\";}i:1;a:3:{s:5:\"value\";s:6:\"style2\";s:4:\"name\";s:14:\"Style 1.2 (#2)\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style2.svg\";}i:2;a:3:{s:5:\"value\";s:6:\"style3\";s:4:\"name\";s:14:\"Style 1.3 (#3)\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style3.svg\";}i:3;a:3:{s:5:\"value\";s:6:\"style4\";s:4:\"name\";s:14:\"Style 1.4 (#4)\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style4.svg\";}i:4;a:3:{s:5:\"value\";s:6:\"style5\";s:4:\"name\";s:14:\"Style 1.5 (#5)\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style5.svg\";}i:5;a:3:{s:5:\"value\";s:6:\"style6\";s:4:\"name\";s:14:\"Style 1.6 (#6)\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style6.svg\";}i:6;a:3:{s:5:\"value\";s:6:\"style7\";s:4:\"name\";s:7:\"Style 7\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style7.svg\";}i:7;a:3:{s:5:\"value\";s:6:\"style8\";s:4:\"name\";s:7:\"Style 8\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style8.svg\";}i:8;a:3:{s:5:\"value\";s:6:\"style9\";s:4:\"name\";s:7:\"Style 9\";s:5:\"image\";s:92:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style9.svg\";}i:9;a:3:{s:5:\"value\";s:7:\"style10\";s:4:\"name\";s:8:\"Style 10\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style10.svg\";}i:10;a:3:{s:5:\"value\";s:7:\"style11\";s:4:\"name\";s:8:\"Style 11\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style11.png\";}i:11;a:3:{s:5:\"value\";s:7:\"style12\";s:4:\"name\";s:8:\"Style 12\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style12.png\";}i:12;a:3:{s:5:\"value\";s:7:\"style13\";s:4:\"name\";s:15:\"Style 13 (11.1)\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style13.png\";}i:13;a:3:{s:5:\"value\";s:7:\"style14\";s:4:\"name\";s:8:\"Style 14\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style14.png\";}i:14;a:3:{s:5:\"value\";s:7:\"style15\";s:4:\"name\";s:8:\"Style 15\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style15.png\";}i:15;a:3:{s:5:\"value\";s:7:\"style16\";s:4:\"name\";s:8:\"Style 16\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-styles/style16.png\";}}}i:62;a:8:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:27:\"Header state on page scroll\";s:11:\"description\";s:191:\"The scrolling menu will only display a simple cloned main navigation, upon scrolling.<br> The Sticky header, upon scrolling, will fix the entire menu to top even when scrolling to the bottom.\";s:2:\"id\";s:11:\"menu_follow\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:4:{i:0;a:4:{s:5:\"value\";s:3:\"yes\";s:4:\"name\";s:44:\"Scrolling Menu (a.k.a. Chaser / Follow menu)\";s:4:\"desc\";s:94:\"Upon scrolling, will display a bar aligned at the top of the website displaying the main menu.\";s:5:\"image\";s:110:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/scrolling-menu-1.gif\";}i:1;a:4:{s:5:\"value\";s:6:\"sticky\";s:4:\"name\";s:13:\"Sticky Header\";s:4:\"desc\";s:106:\"The entire site-header will be fixed to the top of the website when scrolling, and in some cases, resized.\";s:5:\"image\";s:110:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/scrolling-menu-2.gif\";}i:2;a:3:{s:5:\"value\";s:5:\"fixed\";s:4:\"name\";s:12:\"Fixed Header\";s:4:\"desc\";s:102:\"The entire site-header will be fixed to the top of the website when scrolling without resizing itself.\";}i:3;a:3:{s:5:\"value\";s:2:\"no\";s:4:\"name\";s:3:\"No.\";s:5:\"image\";s:110:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/scrolling-menu-3.gif\";}}s:4:\"type\";s:12:\"smart_select\";}i:63;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:25:\"Language selector options\";s:11:\"description\";s:63:\"These options are dedicated to the language selector in header.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:64;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Show WPML languages ?\";s:11:\"description\";s:106:\"Choose yes if you want to show WPML languages in header. Please note that you will\r\n		need WPML installed.\";s:2:\"id\";s:15:\"head_show_flags\";s:3:\"std\";s:1:\"1\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:4:\"Show\";i:0;s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:65;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:23:\"Language selector style\";s:11:\"description\";s:52:\"Choose the style of the multi-language selector box.\";s:2:\"id\";s:16:\"head_flags_style\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:5:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:4:\"name\";s:7:\"Inherit\";s:4:\"desc\";s:34:\"Will inherit from header\'s layout.\";}i:1;a:3:{s:5:\"value\";s:3:\"def\";s:4:\"name\";s:7:\"Default\";s:5:\"image\";s:112:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/smart_select/languages/languages_default.png\";}i:2;a:3:{s:5:\"value\";s:3:\"alt\";s:4:\"name\";s:11:\"Alternative\";s:5:\"image\";s:116:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/smart_select/languages/languages_alternative.png\";}i:3;a:3:{s:5:\"value\";s:5:\"flags\";s:4:\"name\";s:10:\"Just flags\";s:5:\"image\";s:110:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/smart_select/languages/languages_flags.png\";}i:4;a:3:{s:5:\"value\";s:4:\"text\";s:4:\"name\";s:11:\"Text Inline\";s:5:\"image\";s:109:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/smart_select/languages/languages_text.png\";}}s:4:\"type\";s:12:\"smart_select\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"head_show_flags\";s:5:\"value\";a:1:{i:0;s:1:\"1\";}}}i:66;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:28:\"Login button & panel options\";s:11:\"description\";s:120:\"These options are dedicated to the login button link in the header, but also Login/Register/Forgot password popup forms.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:67;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:27:\"Show \"Login\" link in Header\";s:11:\"description\";s:420:\"Choose yes if you want to show a link that will let users login/register or retrieve their lost password. Please note that in order to show the registration page, you need to allow user registration from General settings. <br> You can select the 3rd option, to hide the button, but enable the modal window to load. For example in case you want to link the hidden login panel from elsewhere (Main menu or Call to action).\";s:2:\"id\";s:15:\"head_show_login\";s:3:\"std\";s:1:\"1\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:3:{i:1;s:4:\"Show\";i:0;s:4:\"Hide\";i:2;s:42:\"Hide Button, but load Login Modal (Hidden)\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:68;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:40:\"Show \"Register / Sign up\" link in Header\";s:11:\"description\";s:423:\"Choose yes if you want to show a link that will let users login/register or retrieve their lost password. Please note that in order to show the registration page, you need to allow user registration from General settings. <br> You can select the 3rd option, to hide the button, but enable the modal window to load. For example in case you want to link the hidden register panel from elsewhere (Main menu or Call to action).\";s:2:\"id\";s:18:\"head_show_register\";s:3:\"std\";s:1:\"2\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:3:{i:1;s:4:\"Show\";i:0;s:4:\"Hide\";i:2;s:45:\"Hide Button, but load Register Modal (Hidden)\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:69;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"Search Box in Header\";s:11:\"description\";s:56:\"These options are dedicated to the search box in header.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:70;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Show SEARCH in header\";s:11:\"description\";s:62:\"Please choose if you want to display the search button or not.\";s:2:\"id\";s:16:\"head_show_search\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:71;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:16:\"Search Box style\";s:11:\"description\";s:55:\"Choose the style of the search box component in header.\";s:2:\"id\";s:17:\"head_search_style\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:6:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:4:\"name\";s:7:\"Inherit\";s:4:\"desc\";s:34:\"Will inherit from header\'s layout.\";}i:1;a:4:{s:5:\"value\";s:3:\"def\";s:4:\"name\";s:7:\"Compact\";s:4:\"desc\";s:20:\"Click-to-open button\";s:5:\"image\";s:111:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/searchbox-compact.gif\";}i:2;a:3:{s:5:\"value\";s:3:\"inp\";s:4:\"name\";s:12:\"Input Layout\";s:5:\"image\";s:109:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/searchbox-input.gif\";}i:3;a:3:{s:5:\"value\";s:4:\"bord\";s:4:\"name\";s:23:\"Bottom Bordered Minimal\";s:5:\"image\";s:127:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/searchbox-bottom-bordered-minimal.gif\";}i:4;a:3:{s:5:\"value\";s:5:\"bord2\";s:4:\"name\";s:25:\"Bottom Bordered Minimal 2\";s:5:\"image\";s:127:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/searchbox-bottom-bordered-minimal.gif\";}i:5;a:4:{s:5:\"value\";s:3:\"min\";s:4:\"name\";s:7:\"Minimal\";s:4:\"desc\";s:45:\"Loupe Icon that will expand the search field.\";s:5:\"image\";s:122:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/searchbox-minimal-loupe-icon.gif\";}}s:4:\"type\";s:12:\"smart_select\";s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"head_show_search\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:72;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Custom Text in Header\";s:11:\"description\";s:138:\"These options are dedicated to the header text in header. Please know that this text is only available for certain types of Header layouts\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:73;a:8:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:15:\"Top header text\";s:11:\"description\";s:41:\"Will display any text (ex: phone number).\";s:2:\"id\";s:18:\"zn_head_s7_toptext\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:5:\"class\";s:11:\"zn_input_xl\";}i:74;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:41:\"Hidden Panel options ( \"SUPPORT\" button )\";s:11:\"description\";s:428:\"<span class=\"dashicons dashicons-warning\"></span> <strong>To add content in the \"Support\" - Hidden panel, follow these steps:</strong><br> Go to <a href=\"https://modelox.vico.digital/wp-admin/widgets.php\">Appearance > Widgets</a> and inside the widgets position called \"Hidden panel sidebar\", make sure it has the Text widget inside, or add a new Text Widget ( <a href=\"http://hogash.d.pr/ypNB\" target=\"_blank\">screenshot</a> ).\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:75;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:28:\"Show SUPPORT panel in header\";s:11:\"description\";s:270:\"Please choose if you want to display the call to action button or not.<br> If you want to open the panel through the main menu, choose <strong>\'Load panel (closed), but Hide Button\'</strong> and add the class <code>show-top-hidden-panel</code> to the menu item you want.\";s:2:\"id\";s:21:\"head_show_support_pnl\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:3:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";s:4:\"load\";s:36:\"Load panel (closed), but Hide Button\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:76;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"Support content type\";s:11:\"description\";s:65:\"Select what type of content you want to show in the hidden panel.\";s:2:\"id\";s:25:\"hidden_panel_content_type\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:6:\"widget\";s:36:\"Widget area ( Hidden Panel Sidebar )\";s:11:\"pb_template\";s:22:\"Pagebuilder Smart Area\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:21:\"head_show_support_pnl\";s:5:\"value\";a:2:{i:0;s:3:\"yes\";i:1;s:4:\"load\";}}}i:77;a:8:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:24:\"hidden_panel_pb_template\";s:4:\"name\";s:29:\"Select Pagebuilder Smart Area\";s:11:\"description\";s:99:\"Using this option you can select a pre-built template made at Admin > Pagebuilder Smart Areas page.\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:1:{s:0:\"\";s:25:\"-- Select a smart area --\";}s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:21:\"head_show_support_pnl\";s:5:\"value\";a:2:{i:0;s:3:\"yes\";i:1;s:4:\"load\";}}i:1;a:2:{s:7:\"element\";s:25:\"hidden_panel_content_type\";s:5:\"value\";a:1:{i:0;s:11:\"pb_template\";}}}}i:78;a:8:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"Support button text\";s:11:\"description\";s:131:\"Enter the desired button text that will appear for the support button in header. If left blank, the Support word will be displayed.\";s:2:\"id\";s:18:\"hidden_panel_title\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:10:\"dependency\";a:2:{s:7:\"element\";s:21:\"head_show_support_pnl\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:79;a:8:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:23:\"Select background color\";s:11:\"description\";s:45:\"Select background color for the hidden panel.\";s:2:\"id\";s:15:\"hidden_panel_bg\";s:3:\"std\";s:7:\"#F0F0F0\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:21:\"head_show_support_pnl\";s:5:\"value\";a:2:{i:0;s:3:\"yes\";i:1;s:4:\"load\";}}}i:80;a:8:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Select font color\";s:11:\"description\";s:39:\"Select font color for the hidden panel.\";s:2:\"id\";s:15:\"hidden_panel_fg\";s:3:\"std\";s:7:\"#000000\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:21:\"head_show_support_pnl\";s:5:\"value\";a:2:{i:0;s:3:\"yes\";i:1;s:4:\"load\";}}}i:81;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:22:\"Social Icons in Header\";s:11:\"description\";s:64:\"These options are dedicated to the social icons group in header.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:82;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:44:\"Show or hide the Social icons in the header.\";s:11:\"description\";s:135:\"Please select the visibility status of the Social Icons(this setting will not affect the visibility of Social Icons from the info Card)\";s:2:\"id\";s:30:\"social_icons_visibility_status\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:83;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:35:\"Use normal or colored social icons?\";s:11:\"description\";s:90:\"Here you can choose to use the normal social icons or the colored version of each\r\n		icon.\";s:2:\"id\";s:22:\"header_which_icons_set\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:4:{i:0;a:3:{s:5:\"value\";s:6:\"normal\";s:4:\"name\";s:12:\"Normal Icons\";s:5:\"image\";s:98:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-social-icons/normal.png\";}i:1;a:3:{s:5:\"value\";s:7:\"colored\";s:4:\"name\";s:13:\"Colored icons\";s:5:\"image\";s:99:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-social-icons/colored.png\";}i:2;a:3:{s:5:\"value\";s:11:\"colored_hov\";s:4:\"name\";s:22:\"Colored on Hover icons\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-social-icons/colored_hov.png\";}i:3;a:3:{s:5:\"value\";s:5:\"clean\";s:4:\"name\";s:11:\"Clean icons\";s:5:\"image\";s:97:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-social-icons/clean.png\";}}s:4:\"type\";s:12:\"smart_select\";s:10:\"dependency\";a:2:{s:7:\"element\";s:30:\"social_icons_visibility_status\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:84;a:12:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:12:\"Social Icons\";s:11:\"description\";s:83:\"Here you can configure what social icons to appear on the right side of the header.\";s:2:\"id\";s:19:\"header_social_icons\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"group\";s:13:\"element_title\";s:19:\"header_social_title\";s:8:\"add_text\";s:11:\"Social Icon\";s:11:\"remove_text\";s:11:\"Social Icon\";s:11:\"subelements\";a:4:{i:0;a:5:{s:4:\"name\";s:10:\"Icon title\";s:11:\"description\";s:149:\"Here you can enter a title for this social icon.Please note that this is just\r\n				for your information as this text will not be visible on the site.\";s:2:\"id\";s:19:\"header_social_title\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:1;a:6:{s:4:\"name\";s:16:\"Social icon link\";s:11:\"description\";s:114:\"Please enter your desired link for the social icon. If this field is left\r\n				blank, the icon will not be linked.\";s:2:\"id\";s:18:\"header_social_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"link\";s:7:\"options\";a:2:{s:6:\"_blank\";s:10:\"New window\";s:5:\"_self\";s:11:\"Same window\";}}i:2;a:5:{s:4:\"name\";s:28:\"Social icon Background color\";s:11:\"description\";s:126:\"Select a background color for the icon (if you selected <strong>Colored</strong> or <strong>Colored on hover</strong> options)\";s:2:\"id\";s:19:\"header_social_color\";s:3:\"std\";s:4:\"#000\";s:4:\"type\";s:11:\"colorpicker\";}i:3;a:6:{s:4:\"name\";s:11:\"Social icon\";s:11:\"description\";s:32:\"Select your desired social icon.\";s:2:\"id\";s:18:\"header_social_icon\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:9:\"icon_list\";s:5:\"class\";s:7:\"zn_full\";}}s:5:\"class\";s:0:\"\";}i:85;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:37:\"Settings for mobiles (small viewport)\";s:11:\"description\";s:51:\"These options are applied to the header on mobiles.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:86;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:34:\"Header Background Color on Mobiles\";s:11:\"description\";s:129:\"This will change the existing <strong>background color</strong> on Mobile devices, more exactly for device width less than 480px.\";s:2:\"id\";s:20:\"zn_header_resp_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";}i:87;a:9:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:24:\"header_components_mobile\";s:4:\"name\";s:32:\"HIDE Header Components on Mobile\";s:11:\"description\";s:125:\"Select which components from the header you want to hide on mobiles or better said, viewports of maximum 767px (smartphones).\";s:4:\"type\";s:8:\"checkbox\";s:7:\"options\";a:10:{s:13:\"header-search\";s:10:\"Search Box\";s:12:\"topnav--lang\";s:17:\"Language selector\";s:11:\"topnav--log\";s:12:\"Login button\";s:11:\"topnav--reg\";s:15:\"Register button\";s:17:\"kl-header-toptext\";s:11:\"Custom Text\";s:21:\"topnav--sliding-panel\";s:29:\"Hidden Panel (Support Button)\";s:12:\"social-icons\";s:12:\"Social Icons\";s:25:\"zn_header_top_nav-wrapper\";s:22:\"Header Menu Navigation\";s:9:\"ctabutton\";s:21:\"Call To Action Button\";s:12:\"topnav--cart\";s:26:\"Shopping Cart Button/Panel\";}s:3:\"std\";s:0:\"\";s:5:\"class\";s:7:\"zn_full\";}i:88;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:8:\"ho_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:89;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#TuXcJu9jl7c\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:90;a:7:{s:4:\"slug\";s:14:\"header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:91;a:7:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:38:\"HEADER\'S CALL TO ACTION BUTTON OPTIONS\";s:11:\"description\";s:182:\"These options below are related to site\'s call to action button in header. ( <a href=\"http://hogash.d.pr/1leyL\" target=\"_blank\" title=\"Click to open screenshot\">Open screenshot</a>).\";s:2:\"id\";s:11:\"info_title6\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:92;a:9:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:36:\"Show Call to Action button in header\";s:11:\"description\";s:70:\"Please choose if you want to display the call to action button or not.\";s:2:\"id\";s:13:\"head_show_cta\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:93;a:9:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:27:\"Call to Action button style\";s:11:\"description\";s:15:\"Select a style.\";s:2:\"id\";s:19:\"head_show_cta_style\";s:3:\"std\";s:6:\"ribbon\";s:7:\"options\";a:3:{i:0;a:4:{s:5:\"value\";s:6:\"ribbon\";s:4:\"name\";s:12:\"Ribbon style\";s:4:\"desc\";s:38:\"Nice button which looks like a ribbon.\";s:5:\"image\";s:98:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-calltoaction/ribbon.png\";}i:1;a:4:{s:5:\"value\";s:6:\"custom\";s:4:\"name\";s:19:\"Custom Button Style\";s:4:\"desc\";s:64:\"Supports up to 3 buttons and they can all be different in style.\";s:5:\"image\";s:98:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/header-calltoaction/custom.png\";}i:2;a:3:{s:5:\"value\";s:5:\"lined\";s:4:\"name\";s:12:\"Lined button\";s:4:\"desc\";s:43:\"Not recommended, use Custom button instead.\";}}s:4:\"type\";s:12:\"smart_select\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:94;a:9:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:52:\"Set the link for the Call to Action button in header\";s:11:\"description\";s:49:\"Set the URL to link the Call to Action button to.\";s:2:\"id\";s:17:\"head_add_cta_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"link\";s:7:\"options\";a:6:{s:5:\"_self\";s:11:\"Same window\";s:6:\"_blank\";s:10:\"New window\";s:5:\"modal\";s:11:\"Modal Image\";s:12:\"modal_iframe\";s:12:\"Modal Iframe\";s:12:\"modal_inline\";s:20:\"Modal Inline content\";s:12:\"smoothscroll\";s:23:\"Smooth Scroll to Anchor\";}s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:19:\"head_show_cta_style\";s:5:\"value\";a:2:{i:0;s:6:\"ribbon\";i:1;s:5:\"lined\";}}i:1;a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}}i:95;a:9:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:42:\"Set the text for the Call to Action button\";s:11:\"description\";s:66:\"Select the text you want to display int the call to action button.\";s:2:\"id\";s:17:\"head_set_text_cta\";s:4:\"type\";s:4:\"text\";s:5:\"class\";s:11:\"zn_input_xl\";s:3:\"std\";s:26:\"<strong>FREE</strong>QUOTE\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:19:\"head_show_cta_style\";s:5:\"value\";a:2:{i:0;s:6:\"ribbon\";i:1;s:5:\"lined\";}}i:1;a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}}i:96;a:8:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:23:\"Select background color\";s:11:\"description\";s:54:\"Select Call to action (ribbon style) background color.\";s:2:\"id\";s:15:\"wpk_cs_bg_color\";s:3:\"std\";s:7:\"#cd2122\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:19:\"head_show_cta_style\";s:5:\"value\";a:2:{i:0;s:6:\"ribbon\";i:1;s:5:\"lined\";}}i:1;a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}}i:97;a:8:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Select text color\";s:11:\"description\";s:18:\"Select text color.\";s:2:\"id\";s:15:\"wpk_cs_fg_color\";s:3:\"std\";s:4:\"#fff\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:19:\"head_show_cta_style\";s:5:\"value\";a:2:{i:0;s:6:\"ribbon\";i:1;s:5:\"lined\";}}i:1;a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}}i:98;a:9:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:23:\"Hide button on mobiles?\";s:11:\"description\";s:68:\"Do you want to hide this button on mobile screens (-767px and below)\";s:2:\"id\";s:11:\"cta_hide_xs\";s:3:\"std\";s:0:\"\";s:5:\"value\";s:1:\"1\";s:4:\"type\";s:7:\"toggle2\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:19:\"head_show_cta_style\";s:5:\"value\";a:2:{i:0;s:6:\"ribbon\";i:1;s:5:\"lined\";}}i:1;a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}}i:99;a:9:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:26:\"Button display permissions\";s:11:\"description\";s:78:\"Using this option you can show/hide the button for different type of visitors.\";s:2:\"id\";s:8:\"cta_perm\";s:3:\"std\";s:3:\"all\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:3:\"all\";s:12:\"Show for all\";s:8:\"loggedin\";s:29:\"Show only for logged in users\";s:7:\"visitor\";s:40:\"Show only for visitors ( not logged in )\";}s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:19:\"head_show_cta_style\";s:5:\"value\";a:2:{i:0;s:6:\"ribbon\";i:1;s:5:\"lined\";}}i:1;a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}}i:100;a:14:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:7:\"Buttons\";s:11:\"description\";s:50:\"Here you can add up to <strong>3 Buttons</strong>.\";s:2:\"id\";s:10:\"cta_custom\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"group\";s:9:\"max_items\";s:1:\"3\";s:13:\"element_title\";s:8:\"cta_text\";s:8:\"add_text\";s:6:\"Button\";s:11:\"remove_text\";s:6:\"Button\";s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:19:\"head_show_cta_style\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}i:1;a:2:{s:7:\"element\";s:13:\"head_show_cta\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}s:11:\"subelements\";a:13:{i:0;a:6:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:22:\"Text inside the button\";s:2:\"id\";s:8:\"cta_text\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:5:\"class\";s:11:\"zn_input_xl\";}i:1;a:6:{s:4:\"name\";s:4:\"Link\";s:11:\"description\";s:27:\"Attach a link to the button\";s:2:\"id\";s:8:\"cta_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"link\";s:7:\"options\";a:6:{s:5:\"_self\";s:11:\"Same window\";s:6:\"_blank\";s:10:\"New window\";s:5:\"modal\";s:11:\"Modal Image\";s:12:\"modal_iframe\";s:12:\"Modal Iframe\";s:12:\"modal_inline\";s:20:\"Modal Inline content\";s:12:\"smoothscroll\";s:23:\"Smooth Scroll to Anchor\";}}i:2;a:6:{s:4:\"name\";s:5:\"Style\";s:11:\"description\";s:29:\"Select a style for the button\";s:2:\"id\";s:9:\"cta_style\";s:3:\"std\";s:13:\"btn-fullcolor\";s:4:\"type\";s:12:\"smart_select\";s:7:\"options\";a:31:{i:0;a:3:{s:5:\"value\";s:13:\"btn-fullcolor\";s:4:\"name\";s:17:\"Flat (main color)\";s:5:\"image\";s:101:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/01.flatmaincolor.jpg\";}i:1;a:3:{s:5:\"value\";s:30:\"btn-fullcolor btn-custom-color\";s:4:\"name\";s:19:\"Flat (custom color)\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/02.flatcustomcolor.jpg\";}i:2;a:3:{s:5:\"value\";s:13:\"btn-fullwhite\";s:4:\"name\";s:12:\"Flat (white)\";s:5:\"image\";s:97:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/03.flatwhite.jpg\";}i:3;a:3:{s:5:\"value\";s:13:\"btn-fullblack\";s:4:\"name\";s:12:\"Flat (black)\";s:5:\"image\";s:97:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/04.flatblack.jpg\";}i:4;a:3:{s:5:\"value\";s:9:\"btn-lined\";s:4:\"name\";s:13:\"Lined (light)\";s:5:\"image\";s:98:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/05.linedlight.jpg\";}i:5;a:3:{s:5:\"value\";s:20:\"btn-lined lined-dark\";s:4:\"name\";s:12:\"Lined (dark)\";s:5:\"image\";s:97:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/06.lineddark.jpg\";}i:6;a:3:{s:5:\"value\";s:20:\"btn-lined lined-gray\";s:4:\"name\";s:12:\"Lined (gray)\";s:5:\"image\";s:97:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/07.linedgrey.jpg\";}i:7;a:3:{s:5:\"value\";s:22:\"btn-lined lined-custom\";s:4:\"name\";s:18:\"Lined (main color)\";s:5:\"image\";s:102:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/08.linedmaincolor.jpg\";}i:8;a:3:{s:5:\"value\";s:26:\"btn-lined btn-custom-color\";s:4:\"name\";s:20:\"Lined (custom color)\";s:5:\"image\";s:104:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/09.linedcustomcolor.jpg\";}i:9;a:3:{s:5:\"value\";s:26:\"btn-lined lined-full-light\";s:4:\"name\";s:18:\"Lined-Full (light)\";s:5:\"image\";s:102:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/10.linedfulllight.jpg\";}i:10;a:3:{s:5:\"value\";s:25:\"btn-lined lined-full-dark\";s:4:\"name\";s:17:\"Lined-Full (dark)\";s:5:\"image\";s:101:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/11.linedfulldark.jpg\";}i:11;a:3:{s:5:\"value\";s:20:\"btn-lined btn-skewed\";s:4:\"name\";s:20:\"Lined-Skewed (light)\";s:5:\"image\";s:104:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/12.linedskewedlight.jpg\";}i:12;a:3:{s:5:\"value\";s:31:\"btn-lined btn-skewed lined-dark\";s:4:\"name\";s:19:\"Lined-Skewed (dark)\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/13.linedskeweddark.jpg\";}i:13;a:3:{s:5:\"value\";s:31:\"btn-lined btn-skewed lined-gray\";s:4:\"name\";s:19:\"Lined-Skewed (gray)\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/14.linedskewedgrey.jpg\";}i:14;a:3:{s:5:\"value\";s:24:\"btn-fullcolor btn-skewed\";s:4:\"name\";s:24:\"Flat-Skewed (main color)\";s:5:\"image\";s:107:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/15.flatskewedmaincolor.jpg\";}i:15;a:3:{s:5:\"value\";s:41:\"btn-fullcolor btn-skewed btn-custom-color\";s:4:\"name\";s:26:\"Flat-Skewed (custom color)\";s:5:\"image\";s:109:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/16.flatskewedcustomcolor.jpg\";}i:16;a:3:{s:5:\"value\";s:24:\"btn-fullwhite btn-skewed\";s:4:\"name\";s:19:\"Flat-Skewed (white)\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/17.flatskewedwhite.jpg\";}i:17;a:3:{s:5:\"value\";s:24:\"btn-fullblack btn-skewed\";s:4:\"name\";s:19:\"Flat-Skewed (black)\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/18.flatskewedblack.jpg\";}i:18;a:3:{s:5:\"value\";s:26:\"btn-fullcolor btn-bordered\";s:4:\"name\";s:26:\"Flat Bordered (main color)\";s:5:\"image\";s:108:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/19.flatborderdmaincolor.jpg\";}i:19;a:3:{s:5:\"value\";s:43:\"btn-fullcolor btn-bordered btn-custom-color\";s:4:\"name\";s:28:\"Flat Bordered (custom color)\";s:5:\"image\";s:110:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/20.flatborderdcustomcolor.jpg\";}i:20;a:3:{s:5:\"value\";s:11:\"btn-default\";s:4:\"name\";s:19:\"Bootstrap - Default\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/21.boostrapdefault.jpg\";}i:21;a:3:{s:5:\"value\";s:11:\"btn-primary\";s:4:\"name\";s:19:\"Bootstrap - Primary\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/22.boostrapprimary.jpg\";}i:22;a:3:{s:5:\"value\";s:11:\"btn-success\";s:4:\"name\";s:19:\"Bootstrap - Success\";s:5:\"image\";s:100:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/23.boostrapinfo.jpg\";}i:23;a:3:{s:5:\"value\";s:8:\"btn-info\";s:4:\"name\";s:16:\"Bootstrap - Info\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/24.boostrapsuccess.jpg\";}i:24;a:3:{s:5:\"value\";s:11:\"btn-warning\";s:4:\"name\";s:19:\"Bootstrap - Warning\";s:5:\"image\";s:103:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/25.boostrapwarning.jpg\";}i:25;a:3:{s:5:\"value\";s:10:\"btn-danger\";s:4:\"name\";s:18:\"Bootstrap - Danger\";s:5:\"image\";s:102:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/26.boostrapdanger.jpg\";}i:26;a:3:{s:5:\"value\";s:8:\"btn-link\";s:4:\"name\";s:16:\"Bootstrap - Link\";s:5:\"image\";s:100:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/27.boostraplink.jpg\";}i:27;a:3:{s:5:\"value\";s:8:\"btn-text\";s:4:\"name\";s:18:\"Simple linked text\";s:5:\"image\";s:102:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/28.simplelinktext.jpg\";}i:28;a:3:{s:5:\"value\";s:25:\"btn-text btn-custom-color\";s:4:\"name\";s:33:\"Simple linked text (Custom Color)\";s:5:\"image\";s:108:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/29.simplelinktextcustom.jpg\";}i:29;a:3:{s:5:\"value\";s:33:\"btn-underline btn-underline--thin\";s:4:\"name\";s:21:\"Simple Underline Thin\";s:5:\"image\";s:107:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/30.simpleunderlinethin.jpg\";}i:30;a:3:{s:5:\"value\";s:34:\"btn-underline btn-underline--thick\";s:4:\"name\";s:22:\"Simple Underline Thick\";s:5:\"image\";s:108:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/button_icons/31.simpleunderlinethick.jpg\";}}}i:3;a:7:{s:4:\"name\";s:19:\"Button Custom Color\";s:11:\"description\";s:27:\"Select button custom color.\";s:2:\"id\";s:16:\"cta_custom_color\";s:3:\"std\";s:7:\"#cd2122\";s:5:\"alpha\";s:1:\"1\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cta_style\";s:5:\"value\";a:4:{i:0;s:30:\"btn-fullcolor btn-custom-color\";i:1;s:26:\"btn-lined btn-custom-color\";i:2;s:41:\"btn-fullcolor btn-skewed btn-custom-color\";i:3;s:43:\"btn-fullcolor btn-bordered btn-custom-color\";}}}i:4;a:7:{s:4:\"name\";s:25:\"Button Custom Color HOVER\";s:11:\"description\";s:133:\"Select button custom color on hover. If not specified, the normal state color will be used with a 20% color adjustment in brightness.\";s:2:\"id\";s:20:\"cta_custom_color_hov\";s:3:\"std\";s:0:\"\";s:5:\"alpha\";s:1:\"1\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cta_style\";s:5:\"value\";a:4:{i:0;s:30:\"btn-fullcolor btn-custom-color\";i:1;s:26:\"btn-lined btn-custom-color\";i:2;s:41:\"btn-fullcolor btn-skewed btn-custom-color\";i:3;s:43:\"btn-fullcolor btn-bordered btn-custom-color\";}}}i:5;a:6:{s:4:\"name\";s:4:\"Size\";s:11:\"description\";s:28:\"Select a size for the button\";s:2:\"id\";s:8:\"cta_size\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:4:{s:0:\"\";s:7:\"Default\";s:6:\"btn-md\";s:6:\"Medium\";s:6:\"btn-sm\";s:5:\"Small\";s:6:\"btn-xs\";s:11:\"Extra small\";}}i:6;a:6:{s:4:\"name\";s:14:\"Button Corners\";s:11:\"description\";s:46:\"Select the button corners type for this button\";s:2:\"id\";s:11:\"cta_corners\";s:3:\"std\";s:12:\"btn--rounded\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:12:\"btn--rounded\";s:21:\"Smooth rounded corner\";s:10:\"btn--round\";s:13:\"Round corners\";s:11:\"btn--square\";s:14:\"Square corners\";}}i:7;a:6:{s:4:\"name\";s:19:\"Button text Options\";s:11:\"description\";s:49:\"Specify the typography properties for the button.\";s:2:\"id\";s:11:\"button_typo\";s:3:\"std\";s:0:\"\";s:8:\"supports\";a:8:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:4:\"line\";i:4;s:6:\"weight\";i:5;s:5:\"color\";i:6;s:7:\"spacing\";i:7;s:4:\"case\";}s:4:\"type\";s:4:\"font\";}i:8;a:7:{s:4:\"name\";s:9:\"Add icon?\";s:11:\"description\";s:26:\"Add an icon to the button?\";s:2:\"id\";s:15:\"cta_icon_enable\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";s:2:\"no\";s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:9;a:7:{s:4:\"name\";s:13:\"Icon position\";s:11:\"description\";s:31:\"Select the position of the icon\";s:2:\"id\";s:12:\"cta_icon_pos\";s:3:\"std\";s:6:\"before\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:6:\"before\";s:11:\"Before text\";s:5:\"after\";s:10:\"After text\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"cta_icon_enable\";s:5:\"value\";a:1:{i:0;s:1:\"1\";}}}i:10;a:8:{s:4:\"name\";s:11:\"Select icon\";s:11:\"description\";s:35:\"Select an icon to add to the button\";s:2:\"id\";s:8:\"cta_icon\";s:3:\"std\";s:1:\"0\";s:4:\"type\";s:9:\"icon_list\";s:5:\"class\";s:12:\"zn_icon_list\";s:7:\"compact\";s:1:\"1\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"cta_icon_enable\";s:5:\"value\";a:1:{i:0;s:1:\"1\";}}}i:11;a:6:{s:4:\"name\";s:26:\"Button display permissions\";s:11:\"description\";s:78:\"Using this option you can show/hide the button for different type of visitors.\";s:2:\"id\";s:8:\"cta_perm\";s:3:\"std\";s:3:\"all\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:3:\"all\";s:12:\"Show for all\";s:8:\"loggedin\";s:29:\"Show only for logged in users\";s:7:\"visitor\";s:40:\"Show only for visitors ( not logged in )\";}}i:12;a:6:{s:4:\"name\";s:23:\"Hide button on mobiles?\";s:11:\"description\";s:68:\"Do you want to hide this button on mobile screens (-767px and below)\";s:2:\"id\";s:11:\"cta_hide_xs\";s:3:\"std\";s:1:\"0\";s:5:\"value\";s:9:\"hidden-xs\";s:4:\"type\";s:7:\"toggle2\";}}s:5:\"class\";s:0:\"\";}i:101;a:7:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"cto_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:102;a:7:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#TuXcJu9jl7c\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:103;a:7:{s:4:\"slug\";s:11:\"cta_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:104;a:7:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:18:\"NAVIGATION OPTIONS\";s:11:\"description\";s:149:\"These options below are related to site\'s navigations. For example the header contains 2 registered menus: \"Main Navigation\" and \"Header Navigation\".\";s:2:\"id\";s:11:\"info_title7\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:105;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:29:\"Header Dropdowns color scheme\";s:11:\"description\";s:114:\"Select the color scheme for the dropdown menus in the site header (topnav, cart container, language dropdown etc.)\";s:2:\"id\";s:15:\"nav_color_theme\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:3:{s:0:\"\";s:63:\"Inherit from Kallyas options > Color Options [Requires refresh]\";s:5:\"light\";s:15:\"Light (default)\";s:4:\"dark\";s:4:\"Dark\";}s:4:\"type\";s:6:\"select\";}i:106;a:7:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:9:\"Main Menu\";s:11:\"description\";s:66:\"These options are dedicated to the Main Menu navigation in Header.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:107;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:35:\"Menu style for 1st level menu items\";s:11:\"description\";s:55:\"Specify the style of the Main Menu\'s first level links.\";s:2:\"id\";s:10:\"menu_style\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:4:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:4:\"name\";s:7:\"Inherit\";s:4:\"desc\";s:34:\"Will inherit from header\'s layout.\";}i:1;a:3:{s:5:\"value\";s:9:\"active-bg\";s:4:\"name\";s:32:\"Background Color on hover/active\";s:5:\"image\";s:123:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/nav-options-menustyle-bgcolor.gif\";}i:2;a:3:{s:5:\"value\";s:11:\"active-text\";s:4:\"name\";s:26:\"Text Color on hover/active\";s:5:\"image\";s:125:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/nav-options-menustyle-textcolor.gif\";}i:3;a:3:{s:5:\"value\";s:12:\"active-uline\";s:4:\"name\";s:30:\"Text Underline on hover/active\";s:5:\"image\";s:129:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/nav-options-menustyle-textunderline.gif\";}}s:4:\"type\";s:12:\"smart_select\";}i:108;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:42:\"Menu Font Options for 1st level menu items\";s:11:\"description\";s:72:\"Specify the typography properties for the Main Menu\'s first level links.\";s:2:\"id\";s:9:\"menu_font\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"14px\";s:11:\"font-family\";s:4:\"Lato\";s:11:\"line-height\";s:4:\"14px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"700\";}s:8:\"supports\";a:8:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:4:\"line\";i:3;s:5:\"color\";i:4;s:5:\"style\";i:5;s:6:\"weight\";i:6;s:7:\"spacing\";i:7;s:4:\"case\";}s:4:\"type\";s:4:\"font\";}i:109;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:45:\"Hover / Active color for 1st level menu items\";s:11:\"description\";s:71:\"Specify the hover or active color of the Main Menu\'s first level links.\";s:2:\"id\";s:16:\"menu_font_active\";s:3:\"std\";s:7:\"#cd2122\";s:5:\"alpha\";s:1:\"1\";s:4:\"type\";s:11:\"colorpicker\";}i:110;a:7:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:29:\"Main menu - Sub-menus options\";s:11:\"description\";s:76:\"These options are dedicated to the main menu\'s submenu navigation in Header.\";s:2:\"id\";s:9:\"hd_title3\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:29:\"zn_full zn-custom-title-large\";}i:111;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Sub-Menu Font Options\";s:11:\"description\";s:56:\"Specify the typography properties for the Main sub-menu.\";s:2:\"id\";s:13:\"menu_font_sub\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"14px\";s:11:\"font-family\";s:4:\"Lato\";s:11:\"line-height\";s:4:\"14px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"700\";}s:8:\"supports\";a:7:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:4:\"line\";i:3;s:5:\"color\";i:4;s:5:\"style\";i:5;s:6:\"weight\";i:6;s:4:\"case\";}s:4:\"type\";s:4:\"font\";}i:112;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:32:\"Main menu Dropdowns color scheme\";s:11:\"description\";s:60:\"Select the color scheme for the MAIN MENU in the site header\";s:2:\"id\";s:19:\"navmain_color_theme\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:3:{s:0:\"\";s:63:\"Inherit from Kallyas options > Color Options [Requires refresh]\";s:5:\"light\";s:15:\"Light (default)\";s:4:\"dark\";s:4:\"Dark\";}s:4:\"type\";s:6:\"select\";}i:113;a:7:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Mobile Navigation\";s:11:\"description\";s:75:\"These options are dedicated to the main menu\'s mobile navigation in Header.\";s:2:\"id\";s:9:\"hd_title3\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:29:\"zn_full zn-custom-title-large\";}i:114;a:9:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:16:\"header_res_width\";s:4:\"name\";s:34:\"Header responsive breakpoint-width\";s:11:\"description\";s:104:\"Choose the desired browser width (viewport) when the Mobile-menu and Hamburger-Icon should be displayed.\";s:4:\"type\";s:6:\"slider\";s:5:\"class\";s:7:\"zn_full\";s:3:\"std\";s:3:\"992\";s:7:\"helpers\";a:2:{s:3:\"min\";s:2:\"50\";s:3:\"max\";s:4:\"2561\";}}i:115;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:17:\"mobile_menu_theme\";s:4:\"name\";s:24:\"Mobile-Menu Colors Theme\";s:11:\"description\";s:201:\"Choose the theming colors style for the side menu theme eg: <a href=\"http://hogash.d.pr/xCqo\" target=\"_blank\">Light version</a> and <a href=\"http://hogash.d.pr/15l83\" target=\"_blank\">Dark version</a>. \";s:3:\"std\";s:5:\"light\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:5:\"light\";s:11:\"Light theme\";s:4:\"dark\";s:10:\"Dark theme\";}}i:116;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:12:\"burger_style\";s:4:\"name\";s:20:\"Hamburger-Icon Style\";s:11:\"description\";s:32:\"Choose the hamburger icon style.\";s:3:\"std\";s:4:\"3--s\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:8:{s:4:\"1--s\";s:15:\"Small 1px lines\";s:4:\"2--s\";s:15:\"Small 2px lines\";s:4:\"3--s\";s:15:\"Small 3px lines\";s:4:\"4--s\";s:15:\"Small 4px lines\";s:4:\"1--m\";s:16:\"Medium 1px lines\";s:4:\"2--m\";s:16:\"Medium 2px lines\";s:4:\"3--m\";s:16:\"Medium 3px lines\";s:4:\"4--m\";s:16:\"Medium 4px lines\";}}i:117;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:11:\"burger_anim\";s:4:\"name\";s:24:\"Hamburger-Icon Animation\";s:11:\"description\";s:37:\"Choose the hamburger animation style.\";s:3:\"std\";s:5:\"anim1\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:5:\"anim1\";s:13:\"Animation #1.\";s:5:\"anim2\";s:13:\"Animation #2.\";s:5:\"anim3\";s:13:\"Animation #3.\";}}i:118;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:12:\"burger_color\";s:4:\"name\";s:20:\"Hamburger-Icon Color\";s:11:\"description\";s:28:\"Choose the hamburger colors.\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:0:\"\";s:38:\"Inherit from Header\'s built-in styles.\";s:6:\"custom\";s:18:\"Force Custom Color\";}}i:119;a:9:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:29:\"Hamburger-Icon - Custom Color\";s:11:\"description\";s:15:\"Select a color.\";s:2:\"id\";s:19:\"burger_color_custom\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:5:\"alpha\";s:4:\"true\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"burger_color\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}}i:120;a:9:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:47:\"Hamburger-Icon - Custom Color for Sticky Header\";s:11:\"description\";s:65:\"Select a color for the hamburger icon when in sticky header mode.\";s:2:\"id\";s:19:\"burger_color_sticky\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:5:\"alpha\";s:4:\"true\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"burger_color\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}}i:121;a:9:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:55:\"Hamburger-Icon - Custom Color for Mobiles (under 767px)\";s:11:\"description\";s:61:\"Force a custom color for the hamburger icon, when on mobiles.\";s:2:\"id\";s:19:\"burger_color_mobile\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:5:\"alpha\";s:4:\"true\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"burger_color\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}}i:122;a:7:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:15:\"Top-Header Menu\";s:11:\"description\";s:67:\"These options are dedicated to the Header-Navigation in TOP-Header.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:123;a:8:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:40:\"Enable dropdown Top Header Navigation? .\";s:11:\"description\";s:229:\"Only available for smartphones and tablets. This option will enable a dropdown menu for the header-navigation (not main-menu!). If you have for example lots of menu items in header, this option will fallback nicely in the header.\";s:2:\"id\";s:16:\"header_topnav_dd\";s:3:\"std\";s:3:\"yes\";s:5:\"value\";s:3:\"yes\";s:4:\"type\";s:7:\"toggle2\";}i:124;a:7:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"nvo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:125;a:7:{s:4:\"slug\";s:11:\"nav_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:126;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"SITE FOOTER OPTIONS\";s:11:\"description\";s:157:\"These options below are related to site\'s footer. ( <a href=\"http://hogash.d.pr/10mXd\" target=\"_blank\" title=\"Click to open screenshot\">Open screenshot</a>).\";s:2:\"id\";s:11:\"info_title8\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:127;a:9:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:11:\"Show Footer\";s:11:\"description\";s:62:\"Using this option you can choose to display the footer or not.\";s:2:\"id\";s:11:\"footer_show\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:128;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Footer Rows Setup\";s:11:\"description\";s:70:\"These settings below will configure the 2 rows included in the footer.\";s:2:\"id\";s:13:\"footer_title3\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:129;a:9:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"Show Row 1 widgets ?\";s:11:\"description\";s:56:\"Select yes if you want to show the first row of widgets.\";s:2:\"id\";s:16:\"footer_row1_show\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:130;a:10:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:29:\"Footer Row 1 Widget positions\";s:11:\"description\";s:165:\"Here you can select how your footer row 1 widgets will be displayed. You can select to\r\n		                            use up to 4 widgets positions in various sizes.\";s:2:\"id\";s:28:\"footer_row1_widget_positions\";s:3:\"std\";s:21:\"{\"3\":[[\"4\",\"4\",\"4\"]]}\";s:4:\"type\";s:16:\"widget_positions\";s:17:\"number_of_columns\";s:1:\"4\";s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"footer_row1_show\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}s:17:\"columns_positions\";a:4:{i:1;a:1:{i:0;a:1:{i:0;s:2:\"12\";}}i:2;a:1:{i:0;a:2:{i:0;s:1:\"6\";i:1;s:1:\"6\";}}i:3;a:7:{i:0;a:3:{i:0;s:1:\"4\";i:1;s:1:\"4\";i:2;s:1:\"4\";}i:1;a:3:{i:0;s:1:\"5\";i:1;s:1:\"4\";i:2;s:1:\"3\";}i:2;a:3:{i:0;s:1:\"5\";i:1;s:1:\"3\";i:2;s:1:\"4\";}i:3;a:3:{i:0;s:1:\"4\";i:1;s:1:\"5\";i:2;s:1:\"3\";}i:4;a:3:{i:0;s:1:\"4\";i:1;s:1:\"3\";i:2;s:1:\"5\";}i:5;a:3:{i:0;s:1:\"3\";i:1;s:1:\"4\";i:2;s:1:\"5\";}i:6;a:3:{i:0;s:1:\"3\";i:1;s:1:\"5\";i:2;s:1:\"4\";}}i:4;a:2:{i:0;a:4:{i:0;s:1:\"3\";i:1;s:1:\"3\";i:2;s:1:\"3\";i:3;s:1:\"3\";}i:1;a:4:{i:0;s:1:\"5\";i:1;s:1:\"4\";i:2;s:1:\"2\";i:3;s:1:\"1\";}}}}i:131;a:9:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"Show Row 2 widgets ?\";s:11:\"description\";s:57:\"Select yes if you want to show the second row of widgets.\";s:2:\"id\";s:16:\"footer_row2_show\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:132;a:10:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:29:\"Footer Row 2 Widget positions\";s:11:\"description\";s:138:\"Here you can select how your footer row 2 widgets will be displayed. You can select to\r\n		 use up to 4 widgets positions in various sizes.\";s:2:\"id\";s:28:\"footer_row2_widget_positions\";s:3:\"std\";s:17:\"{\"2\":[[\"6\",\"6\"]]}\";s:4:\"type\";s:16:\"widget_positions\";s:17:\"number_of_columns\";s:1:\"4\";s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"footer_row2_show\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}s:17:\"columns_positions\";a:4:{i:1;a:1:{i:0;a:1:{i:0;s:2:\"12\";}}i:2;a:1:{i:0;a:2:{i:0;s:1:\"6\";i:1;s:1:\"6\";}}i:3;a:7:{i:0;a:3:{i:0;s:1:\"4\";i:1;s:1:\"4\";i:2;s:1:\"4\";}i:1;a:3:{i:0;s:1:\"5\";i:1;s:1:\"4\";i:2;s:1:\"3\";}i:2;a:3:{i:0;s:1:\"5\";i:1;s:1:\"3\";i:2;s:1:\"4\";}i:3;a:3:{i:0;s:1:\"4\";i:1;s:1:\"5\";i:2;s:1:\"3\";}i:4;a:3:{i:0;s:1:\"4\";i:1;s:1:\"3\";i:2;s:1:\"5\";}i:5;a:3:{i:0;s:1:\"3\";i:1;s:1:\"4\";i:2;s:1:\"5\";}i:6;a:3:{i:0;s:1:\"3\";i:1;s:1:\"5\";i:2;s:1:\"4\";}}i:4;a:2:{i:0;a:4:{i:0;s:1:\"3\";i:1;s:1:\"3\";i:2;s:1:\"3\";i:3;s:1:\"3\";}i:1;a:4:{i:0;s:1:\"5\";i:1;s:1:\"4\";i:2;s:1:\"2\";i:3;s:1:\"1\";}}}}i:133;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Footer Styles Options\";s:11:\"description\";s:49:\"These settings below are for the footer\'s styles.\";s:2:\"id\";s:13:\"footer_title2\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:134;a:8:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:5:\"Style\";s:11:\"description\";s:39:\"Select the desired style for the footer\";s:2:\"id\";s:12:\"footer_style\";s:3:\"std\";s:7:\"default\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:7:\"default\";s:7:\"Default\";s:11:\"image_color\";s:24:\"Background Image & color\";}}i:135;a:9:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:16:\"Background Image\";s:11:\"description\";s:59:\"Please choose your desired image to be used as a background\";s:2:\"id\";s:18:\"footer_style_image\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:3:{s:6:\"repeat\";s:1:\"1\";s:8:\"position\";s:1:\"1\";s:10:\"attachment\";s:1:\"1\";}s:4:\"type\";s:10:\"background\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"footer_style\";s:5:\"value\";a:1:{i:0;s:11:\"image_color\";}}}i:136;a:8:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:16:\"Background Color\";s:11:\"description\";s:58:\"Please choose your desired background color for the footer\";s:2:\"id\";s:18:\"footer_style_color\";s:3:\"std\";s:4:\"#000\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:12:\"footer_style\";s:5:\"value\";a:1:{i:0;s:11:\"image_color\";}}}i:137;a:8:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:25:\"Footer\'s Top Border Color\";s:11:\"description\";s:177:\"Please choose your desired color for the footer top border-color. To hide it, try matching the background color of the footer or just add some custom css into advanced settings.\";s:2:\"id\";s:23:\"footer_border_color_top\";s:3:\"std\";s:7:\"#FFFFFF\";s:5:\"alpha\";s:1:\"1\";s:4:\"type\";s:11:\"colorpicker\";}i:138;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:28:\"Bottom Footer\'s Border Color\";s:11:\"description\";s:181:\"Please choose your desired color for the bottom-footer area\'s border. To hide it, try matching the background color of the footer or just add some custom css into advanced settings.\";s:2:\"id\";s:19:\"footer_border_color\";s:3:\"std\";s:7:\"#484848\";s:4:\"type\";s:11:\"colorpicker\";}i:139;a:8:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:25:\"Footer\'s Top Padding (px)\";s:11:\"description\";s:48:\"Please add the top padding (px) for the footer. \";s:2:\"id\";s:18:\"footer_top_padding\";s:3:\"std\";s:2:\"60\";s:4:\"type\";s:4:\"text\";s:5:\"class\";s:11:\"zn_input_xs\";}i:140;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:21:\"Bottom Footer Options\";s:11:\"description\";s:77:\"These settings below are for the bottom non-widget part of the site\'s footer.\";s:2:\"id\";s:13:\"footer_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:141;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"Copyright Logo image\";s:11:\"description\";s:96:\"Upload your desired logo image that will appear on the left side of the copyright\r\n        text.\";s:2:\"id\";s:11:\"footer_logo\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"media\";}i:142;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:14:\"Copyright text\";s:11:\"description\";s:101:\"Enter your desired copyright text. Please note that you can copy \' &copy; \' and place it in the text.\";s:2:\"id\";s:14:\"copyright_text\";s:3:\"std\";s:151:\"&copy; 2015. All rights reserved. Buy <a href=\"http://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658/\">Kallyas Theme</a>.\";s:4:\"type\";s:8:\"textarea\";}i:143;a:9:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:44:\"Show or hide the Social icons in the footer.\";s:11:\"description\";s:41:\"Display the social icons list in footer?.\";s:2:\"id\";s:26:\"footer_social_icons_enable\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:144;a:9:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:35:\"Use normal or colored social icons?\";s:11:\"description\";s:87:\"Here you can choose to use the normal social icons or the colored version of each icon.\";s:2:\"id\";s:22:\"footer_which_icons_set\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:4:{s:6:\"normal\";s:12:\"Normal Icons\";s:7:\"colored\";s:13:\"Colored icons\";s:11:\"colored_hov\";s:22:\"Colored on Hover icons\";s:5:\"clean\";s:11:\"Clean icons\";}s:5:\"class\";s:0:\"\";}i:145;a:12:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:12:\"Social Icons\";s:11:\"description\";s:94:\"Here you can configure what social icons to appear on the right side of the copyright\r\n		text.\";s:2:\"id\";s:19:\"footer_social_icons\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"group\";s:13:\"element_title\";s:19:\"footer_social_title\";s:8:\"add_text\";s:11:\"Social Icon\";s:11:\"remove_text\";s:11:\"Social Icon\";s:11:\"subelements\";a:4:{i:0;a:5:{s:4:\"name\";s:10:\"Icon title\";s:11:\"description\";s:149:\"Here you can enter a title for this social icon.Please note that this is just\r\n				for your information as this text will not be visible on the site.\";s:2:\"id\";s:19:\"footer_social_title\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:1;a:6:{s:4:\"name\";s:16:\"Social icon link\";s:11:\"description\";s:114:\"Please enter your desired link for the social icon. If this field is left\r\n				blank, the icon will not be linked.\";s:2:\"id\";s:18:\"footer_social_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"link\";s:7:\"options\";a:2:{s:6:\"_blank\";s:10:\"New window\";s:5:\"_self\";s:11:\"Same window\";}}i:2;a:5:{s:4:\"name\";s:28:\"Social icon Background color\";s:11:\"description\";s:126:\"Select a background color for the icon (if you selected <strong>Colored</strong> or <strong>Colored on hover</strong> options)\";s:2:\"id\";s:19:\"footer_social_color\";s:3:\"std\";s:4:\"#000\";s:4:\"type\";s:11:\"colorpicker\";}i:3;a:6:{s:4:\"name\";s:11:\"Social icon\";s:11:\"description\";s:32:\"Select your desired social icon.\";s:2:\"id\";s:18:\"footer_social_icon\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:9:\"icon_list\";s:5:\"class\";s:7:\"zn_full\";}}s:5:\"class\";s:0:\"\";}i:146;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"fto_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:147;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#-jvG4qzNbBY\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:148;a:7:{s:4:\"slug\";s:14:\"footer_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:149;a:7:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:26:\"DEFAULT SUB-HEADER OPTIONS\";s:11:\"description\";s:175:\"These options below are related to site\'s default sub-header block. ( <a href=\"http://hogash.d.pr/14aJa\" target=\"_blank\" title=\"Click to open screenshot\">Open screenshot</a>).\";s:2:\"id\";s:11:\"info_title9\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:150;a:8:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"Hide page subheader?\";s:11:\"description\";s:139:\"Choose yes if you want to hide the page subheader ( including sliders ). Please note that this option can be overridden from each page/post\";s:2:\"id\";s:20:\"zn_disable_subheader\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:3:{s:3:\"yes\";s:11:\"Yes for all\";s:5:\"yespb\";s:33:\"Yes. only for dynamic sub-headers\";s:2:\"no\";s:2:\"No\";}s:4:\"type\";s:8:\"zn_radio\";}i:151;a:7:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:18:\"Background options\";s:11:\"description\";s:61:\"These options are applied to the background of the subheader.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:152;a:8:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:27:\"Sub-Header Background image\";s:11:\"description\";s:52:\"Upload your desired background image for the header.\";s:2:\"id\";s:17:\"def_header_bg_new\";s:3:\"std\";a:1:{s:5:\"image\";b:0;}s:4:\"type\";s:10:\"background\";s:7:\"options\";a:4:{s:6:\"repeat\";s:1:\"1\";s:8:\"position\";s:1:\"1\";s:10:\"attachment\";s:1:\"1\";s:4:\"size\";s:1:\"1\";}}i:153;a:8:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:27:\"Sub-Header Background Color\";s:11:\"description\";s:131:\"Here you can choose a default color for your header.If you do not select a background image, this color will be used as background.\";s:2:\"id\";s:16:\"def_header_color\";s:3:\"std\";s:7:\"#AAAAAA\";s:5:\"alpha\";s:1:\"1\";s:4:\"type\";s:11:\"colorpicker\";}i:154;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:24:\"Add gradient over color?\";s:11:\"description\";s:61:\"Select yes if you want add a gradient over the selected color\";s:2:\"id\";s:11:\"def_grad_bg\";s:3:\"std\";s:1:\"1\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";i:0;s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:155;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"Use animated header\";s:11:\"description\";s:66:\"Select if you want to add an animation on top of your image/color.\";s:2:\"id\";s:18:\"def_header_animate\";s:3:\"std\";s:1:\"0\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";i:0;s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:156;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Add Glare effect?\";s:11:\"description\";s:64:\"Select yes if you want to add a glare effect over the background\";s:2:\"id\";s:9:\"def_glare\";s:3:\"std\";s:1:\"0\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";i:0;s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:157;a:8:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:11:\"Bottom mask\";s:11:\"description\";s:57:\"The new masks are svg based, vectorial and color adapted.\";s:2:\"id\";s:16:\"def_bottom_style\";s:3:\"std\";s:4:\"none\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:20:{s:4:\"none\";s:5:\"None.\";s:6:\"custom\";s:6:\"Custom\";s:13:\"shadow_simple\";s:9:\"Shadow Up\";s:18:\"shadow_simple_down\";s:11:\"Shadow Down\";s:6:\"shadow\";s:39:\"Shadow Up (with border and small arrow)\";s:9:\"shadow_ud\";s:18:\"Shadow Up and down\";s:5:\"mask3\";s:20:\"Vector Mask 3 CENTER\";s:12:\"mask3 mask3l\";s:18:\"Vector Mask 3 LEFT\";s:12:\"mask3 mask3r\";s:19:\"Vector Mask 3 RIGHT\";s:5:\"mask4\";s:20:\"Vector Mask 4 CENTER\";s:12:\"mask4 mask4l\";s:18:\"Vector Mask 4 LEFT\";s:12:\"mask4 mask4r\";s:19:\"Vector Mask 4 RIGHT\";s:5:\"mask5\";s:13:\"Vector Mask 5\";s:5:\"mask6\";s:13:\"Vector Mask 6\";s:12:\"mask7 mask7l\";s:18:\"Mask 7 - Skew Left\";s:12:\"mask7 mask7r\";s:19:\"Mask 7 - Skew Right\";s:21:\"mask7 mask7big mask7l\";s:25:\"Mask 7 Bigger - Skew Left\";s:21:\"mask7 mask7big mask7r\";s:26:\"Mask 7 Bigger - Skew Right\";s:12:\"mask8 mask8s\";s:17:\"Mask 8 - V shaped\";s:12:\"mask8 mask8b\";s:24:\"Mask 8 Bigger - V shaped\";}}i:158;a:8:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:28:\"Bottom Mask Background Image\";s:11:\"description\";s:30:\"Select the image for the mask.\";s:2:\"id\";s:20:\"bottom_mask_bg_image\";s:4:\"type\";s:10:\"background\";s:7:\"options\";a:4:{s:6:\"repeat\";s:1:\"1\";s:8:\"position\";s:1:\"1\";s:10:\"attachment\";s:1:\"1\";s:4:\"size\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"def_bottom_style\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}}i:159;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:30:\"Custom Mask height (in pixels)\";s:11:\"description\";s:39:\"Specify the height for the custom mask.\";s:2:\"id\";s:21:\"bottom_mask_bg_height\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:3:\"100\";s:7:\"helpers\";a:2:{s:3:\"min\";s:1:\"1\";s:3:\"max\";s:3:\"200\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"def_bottom_style\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}}i:160;a:8:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:19:\"def_bottom_style_bg\";s:4:\"name\";s:28:\"Bottom Mask Background Color\";s:11:\"description\";s:203:\"If you need the mask to have a different color than the main site background, please choose the color. Usually this color is needed when the next section, under this one has a different background color.\";s:4:\"type\";s:11:\"colorpicker\";s:3:\"std\";s:0:\"\";s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"def_bottom_style\";s:5:\"value\";a:14:{i:0;s:5:\"mask3\";i:1;s:12:\"mask3 mask3l\";i:2;s:12:\"mask3 mask3r\";i:3;s:5:\"mask4\";i:4;s:12:\"mask4 mask4l\";i:5;s:12:\"mask4 mask4r\";i:6;s:5:\"mask5\";i:7;s:5:\"mask6\";i:8;s:12:\"mask7 mask7l\";i:9;s:12:\"mask7 mask7r\";i:10;s:21:\"mask7 mask7big mask7l\";i:11;s:21:\"mask7 mask7big mask7r\";i:12;s:12:\"mask8 mask8s\";i:13;s:12:\"mask8 mask8b\";}}}i:161;a:7:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:18:\"Components options\";s:11:\"description\";s:59:\"These options are applied to the contents of the subheader.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:162;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:16:\"Show Breadcrumbs\";s:11:\"description\";s:50:\"Select if you want to show the breadcrumbs or not.\";s:2:\"id\";s:16:\"def_header_bread\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:4:\"Show\";i:0;s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:163;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Breadcrumbs style\";s:11:\"description\";s:25:\"Select Breadcrumbs style.\";s:2:\"id\";s:18:\"def_subh_bread_stl\";s:3:\"std\";s:5:\"black\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:5:\"black\";s:9:\"Black Bar\";s:7:\"minimal\";s:7:\"Minimal\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:16:\"def_header_bread\";s:5:\"value\";a:1:{i:0;s:1:\"1\";}}}i:164;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:9:\"Show Date\";s:11:\"description\";s:69:\"Select if you want to show the current date under breadcrumbs or not.\";s:2:\"id\";s:15:\"def_header_date\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:4:\"Show\";i:0;s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:165;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:15:\"Show Page Title\";s:11:\"description\";s:49:\"Select if you want to show the page title or not.\";s:2:\"id\";s:16:\"def_header_title\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:4:\"Show\";i:0;s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:166;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:18:\"Show Page Subtitle\";s:11:\"description\";s:52:\"Select if you want to show the page subtitle or not.\";s:2:\"id\";s:19:\"def_header_subtitle\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:4:\"Show\";i:0;s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:167;a:9:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:31:\"Title & Subtitle text alignment\";s:11:\"description\";s:176:\"If you have disabled both Breadcrumbs & Date, you can choose to custom align the title and subtitle in subheader. You can override this setting in the Custom Subheader Element.\";s:2:\"id\";s:23:\"def_subheader_alignment\";s:3:\"std\";s:5:\"right\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:4:\"left\";s:4:\"Left\";s:6:\"center\";s:6:\"Center\";s:5:\"right\";s:5:\"Right\";}s:10:\"dependency\";a:2:{i:0;a:2:{s:7:\"element\";s:16:\"def_header_bread\";s:5:\"value\";a:1:{i:0;s:1:\"0\";}}i:1;a:2:{s:7:\"element\";s:15:\"def_header_date\";s:5:\"value\";a:1:{i:0;s:1:\"0\";}}}}i:168;a:8:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Text Color Scheme\";s:11:\"description\";s:29:\"Select the text color scheme.\";s:2:\"id\";s:18:\"def_subh_textcolor\";s:3:\"std\";s:5:\"light\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:5:\"light\";s:5:\"Light\";s:4:\"dark\";s:4:\"Dark\";}}i:169;a:7:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:24:\"Height / Padding options\";s:11:\"description\";s:73:\"These options are applied to the height and top padding of the subheader.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:170;a:10:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:25:\"Default Sub-Header Height\";s:11:\"description\";s:59:\"Please enter your desired height in pixels for this header.\";s:2:\"id\";s:27:\"def_header_custom_height_v2\";s:4:\"type\";s:12:\"smart_slider\";s:3:\"std\";a:9:{s:11:\"breakpoints\";i:0;s:2:\"lg\";s:3:\"300\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:3:\"300\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:3:\"300\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:3:\"300\";s:7:\"unit_xs\";s:2:\"px\";}s:8:\"supports\";a:1:{i:0;s:11:\"breakpoints\";}s:5:\"units\";a:1:{i:0;s:2:\"px\";}s:7:\"helpers\";a:3:{s:3:\"min\";s:1:\"1\";s:3:\"max\";s:4:\"1280\";s:4:\"step\";s:1:\"1\";}}i:171;a:10:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:2:\"id\";s:25:\"def_header_top_padding_v2\";s:4:\"name\";s:11:\"Top padding\";s:11:\"description\";s:56:\"Select the top padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:12:\"smart_slider\";s:3:\"std\";a:9:{s:11:\"breakpoints\";i:0;s:2:\"lg\";s:3:\"170\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:3:\"170\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:3:\"170\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:3:\"170\";s:7:\"unit_xs\";s:2:\"px\";}s:8:\"supports\";a:1:{i:0;s:11:\"breakpoints\";}s:5:\"units\";a:1:{i:0;s:2:\"px\";}s:7:\"helpers\";a:3:{s:3:\"min\";s:1:\"1\";s:3:\"max\";s:4:\"1280\";s:4:\"step\";s:1:\"1\";}}i:172;a:7:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"dfho_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:173;a:7:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#1olr-Oy_RD0\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:174;a:7:{s:4:\"slug\";s:22:\"default_header_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:175;a:7:{s:4:\"slug\";s:16:\"google_analytics\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:24:\"GOOGLE ANALYTICS OPTIONS\";s:11:\"description\";s:95:\"The options below are related to Google Analytics / Google Tag Manager integration in Kallyas. \";s:2:\"id\";s:12:\"info_title11\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:176;a:8:{s:4:\"slug\";s:16:\"google_analytics\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:42:\"Google Analytics / Google Tag Manager Code\";s:11:\"description\";s:158:\"Paste your Google Analytics generated Tracking code (or Google Tag Manager code) below. Don\'t forget to paste the to include the wrapping &lt;script&gt; tags.\";s:2:\"id\";s:16:\"google_analytics\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";s:5:\"class\";s:7:\"zn_full\";}i:177;a:7:{s:4:\"slug\";s:16:\"google_analytics\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"gao_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:178;a:7:{s:4:\"slug\";s:16:\"google_analytics\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#zxQaeY_bFxY\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:179;a:7:{s:4:\"slug\";s:16:\"google_analytics\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:230:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/google-analytics/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:180;a:7:{s:4:\"slug\";s:16:\"google_analytics\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:181;a:7:{s:4:\"slug\";s:11:\"google_maps\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"GOOGLE MAPS OPTIONS\";s:11:\"description\";s:77:\"The options below are related to Google Maps API key integration in Kallyas. \";s:2:\"id\";s:12:\"info_title11\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:182;a:8:{s:4:\"slug\";s:11:\"google_maps\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:19:\"Google Maps API Key\";s:11:\"description\";s:284:\"Add a Google Map Api Key. This key will be used by Page Builder elements that require a Google Map API Key, for example the Google Map element. More on <a target=\"_blank\" href=\"https://developers.google.com/maps/documentation/javascript/get-api-key#get-an-api-key\">Google Maps Key</a>\";s:2:\"id\";s:15:\"google_maps_key\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";s:5:\"class\";s:7:\"zn_full\";}i:183;a:7:{s:4:\"slug\";s:17:\"mailchimp_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"MAILCHIMP OPTIONS\";s:11:\"description\";s:101:\"The options below are related to Mailchimp (Online email marketing) platform integration in Kallyas. \";s:2:\"id\";s:12:\"info_title12\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:184;a:7:{s:4:\"slug\";s:17:\"mailchimp_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Mailchimp API KEY\";s:11:\"description\";s:71:\"Paste your mailchimp api key that will be used by the mailchimp widget.\";s:2:\"id\";s:13:\"mailchimp_api\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:185;a:8:{s:4:\"slug\";s:17:\"mailchimp_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"Secure Connection\";s:11:\"description\";s:209:\"In rare cases this needs to be enabled. MailChimp\'s API does supporting connecting via SSL for those worried about Man-in-the-Middle attacks/data collection. To use it in the MCAPI wrapper, simply enable this.\";s:2:\"id\";s:16:\"mailchimp_secure\";s:3:\"std\";s:2:\"no\";s:5:\"value\";s:3:\"yes\";s:4:\"type\";s:7:\"toggle2\";}i:186;a:7:{s:4:\"slug\";s:17:\"mailchimp_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"mco_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:187;a:7:{s:4:\"slug\";s:17:\"mailchimp_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#4zt7-E985Xw\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:188;a:7:{s:4:\"slug\";s:17:\"mailchimp_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:233:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/configure-mailchimp/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:189;a:7:{s:4:\"slug\";s:17:\"mailchimp_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:190;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:17:\"RECAPTCHA OPTIONS\";s:11:\"description\";s:151:\"The options below are related to <a href=\"http://www.google.com/recaptcha\" target=\"_blank\">Google ReCaptcha</a> security integration in Kallyas forms. \";s:2:\"id\";s:12:\"info_title13\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:47:\"zn_full zn-custom-title-large zn-toptabs-margin\";}i:191;a:8:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:15:\"Recaptcha style\";s:11:\"description\";s:35:\"Choose the desired recapthca style.\";s:2:\"id\";s:9:\"rec_theme\";s:3:\"std\";s:3:\"red\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:5:\"light\";s:11:\"Light theme\";s:4:\"dark\";s:10:\"Dark theme\";}}i:192;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:18:\"reCaptcha Site Key\";s:11:\"description\";s:73:\"Please enter the Site Key you\'ve got from http://www.google.com/recaptcha\";s:2:\"id\";s:11:\"rec_pub_key\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:193;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:20:\"reCaptcha Secret Key\";s:11:\"description\";s:75:\"Please enter the Secret Key you\'ve got from http://www.google.com/recaptcha\";s:2:\"id\";s:12:\"rec_priv_key\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:194;a:9:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:31:\"Use ReCaptcha for registration?\";s:11:\"description\";s:69:\"Choose yes if you want to display ReCaptcha on the registration form.\";s:2:\"id\";s:18:\"recaptcha_register\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:2:{s:3:\"yes\";s:3:\"Yes\";s:2:\"no\";s:2:\"No\";}s:4:\"type\";s:8:\"zn_radio\";s:5:\"class\";s:15:\"zn_radio--yesno\";}i:195;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:18:\"ReCaptcha language\";s:11:\"description\";s:166:\"Please specify the language to display the ReCaptcha in. You can get it from  <a href=\"https://developers.google.com/recaptcha/docs/language\" target=\"_blank\">here</a>\";s:2:\"id\";s:14:\"recaptcha_lang\";s:3:\"std\";s:2:\"en\";s:4:\"type\";s:4:\"text\";}i:196;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"rco_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:197;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#MXRAmRVaOaY\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:198;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:233:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/configure-recaptcha/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:199;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:200;a:8:{s:4:\"slug\";s:11:\"gfont_setup\";s:6:\"parent\";s:19:\"google_font_options\";s:2:\"id\";s:21:\"zn_google_fonts_setup\";s:4:\"name\";s:18:\"Google Fonts Setup\";s:11:\"description\";s:126:\"Here you can setup the <a href=\"//www.google.com/fonts\" target=\"blank\">Google web fonts</a> that you want to use in your site.\";s:4:\"type\";s:21:\"zn_google_fonts_setup\";s:3:\"std\";a:1:{s:6:\"Roboto\";a:2:{s:11:\"font_family\";s:6:\"Roboto\";s:13:\"font_variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"300\";i:2;s:3:\"700\";i:3;s:3:\"900\";}}}s:5:\"class\";s:7:\"zn_full\";}i:201;a:9:{s:4:\"slug\";s:11:\"gfont_setup\";s:6:\"parent\";s:19:\"google_font_options\";s:2:\"id\";s:23:\"zn_google_fonts_subsets\";s:4:\"name\";s:19:\"Google Fonts Subset\";s:11:\"description\";s:59:\"Select which subsets you want to load for the Google fonts.\";s:4:\"type\";s:8:\"checkbox\";s:7:\"options\";a:8:{s:5:\"latin\";s:5:\"Latin\";s:9:\"latin-ext\";s:9:\"Latin Ext\";s:5:\"greek\";s:5:\"Greek\";s:8:\"cyrillic\";s:8:\"Cyrillic\";s:12:\"cyrillic-ext\";s:12:\"Cyrillic Ext\";s:5:\"khmer\";s:5:\"Khmer\";s:9:\"greek-ext\";s:9:\"Greek Ext\";s:10:\"vietnamese\";s:10:\"Vietnamese\";}s:3:\"std\";s:0:\"\";s:5:\"class\";s:7:\"zn_full\";}i:202;a:8:{s:4:\"slug\";s:17:\"custom_font_setup\";s:6:\"parent\";s:19:\"google_font_options\";s:2:\"id\";s:15:\"zn_custom_fonts\";s:4:\"name\";s:18:\"Custom Fonts Setup\";s:11:\"description\";s:65:\"Using this option you can add your own custom fonts to the theme.\";s:4:\"type\";s:5:\"group\";s:13:\"element_title\";s:7:\"cf_name\";s:11:\"subelements\";a:6:{i:0;a:5:{s:4:\"name\";s:9:\"Font Name\";s:11:\"description\";s:50:\"Here you can type the font name that will be used.\";s:2:\"id\";s:7:\"cf_name\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:1;a:6:{s:4:\"name\";s:11:\"Font Weight\";s:11:\"description\";s:34:\"Assign a font weight to this font.\";s:2:\"id\";s:13:\"cf_fontweight\";s:3:\"std\";s:3:\"400\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:9:{i:100;s:3:\"100\";i:200;s:3:\"200\";i:300;s:3:\"300\";i:400;s:3:\"400\";i:500;s:3:\"500\";i:600;s:3:\"600\";i:700;s:3:\"700\";i:800;s:3:\"800\";i:900;s:3:\"900\";}}i:2;a:6:{s:4:\"name\";s:17:\"Custom font .woff\";s:11:\"description\";s:27:\"Upload the .woff font file.\";s:2:\"id\";s:7:\"cf_woff\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_media\";s:4:\"data\";a:10:{s:12:\"button_title\";s:14:\"Add .woff font\";s:10:\"media_type\";s:18:\"media_field_upload\";s:12:\"insert_title\";s:11:\"Select font\";s:5:\"title\";s:15:\"Add Custom Font\";s:4:\"type\";s:21:\"application/font-woff\";s:5:\"state\";s:7:\"library\";s:5:\"frame\";s:6:\"select\";s:5:\"class\";s:26:\"zn-media-video media-frame\";s:10:\"value_type\";s:3:\"url\";s:7:\"preview\";s:4:\"text\";}}i:3;a:6:{s:4:\"name\";s:16:\"Custom font .ttf\";s:11:\"description\";s:26:\"Upload the .ttf font file.\";s:2:\"id\";s:6:\"cf_ttf\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_media\";s:4:\"data\";a:10:{s:12:\"button_title\";s:13:\"Add .ttf font\";s:10:\"media_type\";s:18:\"media_field_upload\";s:12:\"insert_title\";s:11:\"Select font\";s:5:\"title\";s:15:\"Add Custom Font\";s:4:\"type\";s:8:\"font/ttf\";s:5:\"state\";s:7:\"library\";s:5:\"frame\";s:6:\"select\";s:5:\"class\";s:26:\"zn-media-video media-frame\";s:10:\"value_type\";s:3:\"url\";s:7:\"preview\";s:4:\"text\";}}i:4;a:6:{s:4:\"name\";s:16:\"Custom font .svg\";s:11:\"description\";s:26:\"Upload the .svg font file.\";s:2:\"id\";s:6:\"cf_svg\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_media\";s:4:\"data\";a:10:{s:12:\"button_title\";s:13:\"Add .svg font\";s:10:\"media_type\";s:18:\"media_field_upload\";s:12:\"insert_title\";s:11:\"Select font\";s:5:\"title\";s:15:\"Add Custom Font\";s:4:\"type\";s:13:\"image/svg+xml\";s:5:\"state\";s:7:\"library\";s:5:\"frame\";s:6:\"select\";s:5:\"class\";s:26:\"zn-media-video media-frame\";s:10:\"value_type\";s:3:\"url\";s:7:\"preview\";s:4:\"text\";}}i:5;a:6:{s:4:\"name\";s:16:\"Custom font .eot\";s:11:\"description\";s:26:\"Upload the .eot font file.\";s:2:\"id\";s:6:\"cf_eot\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_media\";s:4:\"data\";a:10:{s:12:\"button_title\";s:13:\"Add .eot font\";s:10:\"media_type\";s:18:\"media_field_upload\";s:12:\"insert_title\";s:11:\"Select font\";s:5:\"title\";s:15:\"Add Custom Font\";s:4:\"type\";s:29:\"application/vnd.ms-fontobject\";s:5:\"state\";s:7:\"library\";s:5:\"frame\";s:6:\"select\";s:5:\"class\";s:26:\"zn-media-video media-frame\";s:10:\"value_type\";s:3:\"url\";s:7:\"preview\";s:4:\"text\";}}}}i:203;a:7:{s:4:\"slug\";s:17:\"custom_font_setup\";s:6:\"parent\";s:19:\"google_font_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"gfto_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:204;a:7:{s:4:\"slug\";s:17:\"custom_font_setup\";s:6:\"parent\";s:19:\"google_font_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#ffnXlhSxpaI\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:205;a:7:{s:4:\"slug\";s:17:\"custom_font_setup\";s:6:\"parent\";s:19:\"google_font_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:206;a:8:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:13:\"H1 Typography\";s:11:\"description\";s:47:\"Specify the typography properties for headings.\";s:2:\"id\";s:7:\"h1_typo\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"36px\";s:11:\"font-family\";s:9:\"Open Sans\";s:11:\"line-height\";s:4:\"40px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"400\";}s:8:\"supports\";a:5:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:4:\"line\";i:4;s:6:\"weight\";}s:4:\"type\";s:4:\"font\";}i:207;a:8:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:16:\"Force Page-Title\";s:11:\"description\";s:166:\"Force page-title (eg: blog posts) to use <strong style=\'color:#000;\'>H1\'s font-family</strong> (options above), otherwise it\'ll use <strong>Alternative font</strong>.\";s:2:\"id\";s:10:\"h1_pgtitle\";s:3:\"std\";s:0:\"\";s:5:\"value\";s:1:\"1\";s:4:\"type\";s:7:\"toggle2\";}i:208;a:8:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:13:\"H2 Typography\";s:11:\"description\";s:47:\"Specify the typography properties for headings.\";s:2:\"id\";s:7:\"h2_typo\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"30px\";s:11:\"font-family\";s:9:\"Open Sans\";s:11:\"line-height\";s:4:\"40px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"400\";}s:8:\"supports\";a:5:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:4:\"line\";i:4;s:6:\"weight\";}s:4:\"type\";s:4:\"font\";}i:209;a:8:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:13:\"H3 Typography\";s:11:\"description\";s:47:\"Specify the typography properties for headings.\";s:2:\"id\";s:7:\"h3_typo\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"24px\";s:11:\"font-family\";s:9:\"Open Sans\";s:11:\"line-height\";s:4:\"40px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"400\";}s:8:\"supports\";a:5:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:4:\"line\";i:4;s:6:\"weight\";}s:4:\"type\";s:4:\"font\";}i:210;a:8:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:13:\"H4 Typography\";s:11:\"description\";s:47:\"Specify the typography properties for headings.\";s:2:\"id\";s:7:\"h4_typo\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"14px\";s:11:\"font-family\";s:9:\"Open Sans\";s:11:\"line-height\";s:4:\"20px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"400\";}s:8:\"supports\";a:5:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:4:\"line\";i:4;s:6:\"weight\";}s:4:\"type\";s:4:\"font\";}i:211;a:8:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:13:\"H5 Typography\";s:11:\"description\";s:47:\"Specify the typography properties for headings.\";s:2:\"id\";s:7:\"h5_typo\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"12px\";s:11:\"font-family\";s:9:\"Open Sans\";s:11:\"line-height\";s:4:\"20px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"400\";}s:8:\"supports\";a:5:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:4:\"line\";i:4;s:6:\"weight\";}s:4:\"type\";s:4:\"font\";}i:212;a:8:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:13:\"H6 Typography\";s:11:\"description\";s:47:\"Specify the typography properties for headings.\";s:2:\"id\";s:7:\"h6_typo\";s:3:\"std\";a:5:{s:9:\"font-size\";s:4:\"12px\";s:11:\"font-family\";s:9:\"Open Sans\";s:11:\"line-height\";s:4:\"20px\";s:10:\"font-style\";s:6:\"normal\";s:11:\"font-weight\";s:3:\"400\";}s:8:\"supports\";a:5:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:5:\"style\";i:3;s:4:\"line\";i:4;s:6:\"weight\";}s:4:\"type\";s:4:\"font\";}i:213;a:7:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"hdfo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:214;a:7:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#p-YITyC1ROU\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:215;a:7:{s:4:\"slug\";s:21:\"headings_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:216;a:8:{s:4:\"slug\";s:17:\"body_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:17:\"Body Font Options\";s:11:\"description\";s:376:\"Specify the typography properties for the body section ( this will apply to all the content on the page ). <br><br><strong>* Note:</strong> Don\'t use the colorpicker!! There is another color option in Kallyas options > Color Options > Text color. Make sure that one is used. We\'ll keep this one just for backwards compatibility only, but it will be removed in future versions.\";s:2:\"id\";s:9:\"body_font\";s:3:\"std\";a:3:{s:9:\"font-size\";s:4:\"13px\";s:11:\"font-family\";s:9:\"Open Sans\";s:5:\"color\";s:0:\"\";}s:8:\"supports\";a:4:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:4:\"line\";i:3;s:5:\"color\";}s:4:\"type\";s:4:\"font\";}i:217;a:8:{s:4:\"slug\";s:17:\"body_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:19:\"Footer Font Options\";s:11:\"description\";s:49:\"Specify the typography properties for the Footer.\";s:2:\"id\";s:11:\"footer_font\";s:3:\"std\";a:3:{s:9:\"font-size\";s:4:\"13px\";s:11:\"font-family\";s:9:\"Open Sans\";s:5:\"color\";s:0:\"\";}s:8:\"supports\";a:4:{i:0;s:4:\"size\";i:1;s:4:\"font\";i:2;s:4:\"line\";i:3;s:5:\"color\";}s:4:\"type\";s:4:\"font\";}i:218;a:7:{s:4:\"slug\";s:17:\"body_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"bfto_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:219;a:7:{s:4:\"slug\";s:17:\"body_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#p-YITyC1ROU\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:220;a:7:{s:4:\"slug\";s:17:\"body_font_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:221;a:8:{s:4:\"slug\";s:25:\"alternative_fonts_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:24:\"Custom Selectors Options\";s:11:\"description\";s:227:\"This font is used by various elements in the theme. To add other selectors using this font, use the Custom CSS feature in the page builder or CAREFULLY edit /css/dynamic_css.php file, by searching for \'alternative_font\' string.\";s:2:\"id\";s:16:\"alternative_font\";s:3:\"std\";a:1:{s:11:\"font-family\";s:4:\"Lato\";}s:8:\"supports\";a:1:{i:0;s:4:\"font\";}s:4:\"type\";s:4:\"font\";}i:222;a:7:{s:4:\"slug\";s:25:\"alternative_fonts_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"afo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:223;a:7:{s:4:\"slug\";s:25:\"alternative_fonts_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#p-YITyC1ROU\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:224;a:7:{s:4:\"slug\";s:25:\"alternative_fonts_options\";s:6:\"parent\";s:12:\"font_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:225;a:6:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:21:\"Blog Layout and style\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:226;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:11:\"Blog Layout\";s:11:\"description\";s:23:\"Select the blog layout.\";s:2:\"id\";s:11:\"blog_layout\";s:3:\"std\";s:11:\"def_classic\";s:7:\"options\";a:3:{i:0;a:3:{s:5:\"value\";s:11:\"def_classic\";s:4:\"name\";s:28:\"Generic Blog - Classic Style\";s:5:\"image\";s:88:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/blog_layouts/def.gif\";}i:1;a:3:{s:5:\"value\";s:10:\"def_modern\";s:4:\"name\";s:27:\"Generic Blog - Modern Style\";s:5:\"image\";s:95:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/blog_layouts/def-modern.gif\";}i:2;a:3:{s:5:\"value\";s:4:\"cols\";s:4:\"name\";s:18:\"Multi-columns blog\";s:5:\"image\";s:94:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/blog_layouts/multicols.gif\";}}s:4:\"type\";s:11:\"radio_image\";s:5:\"class\";s:18:\"ri-hover-line ri-3\";}i:227;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:12:\"Blog Columns\";s:11:\"description\";s:45:\"Select the number of columns you want to use.\";s:2:\"id\";s:17:\"blog_style_layout\";s:3:\"std\";s:1:\"1\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:6:{i:1;s:1:\"1\";i:2;s:1:\"2\";i:3;s:1:\"3\";i:4;s:1:\"4\";i:5;s:1:\"5\";i:6;s:1:\"6\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:11:\"blog_layout\";s:5:\"value\";a:1:{i:0;s:4:\"cols\";}}}i:228;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:15:\"Content to show\";s:11:\"description\";s:84:\"Choose what content you want to show <b>Important : This only works for 1 column</b>\";s:2:\"id\";s:23:\"sb_archive_content_type\";s:3:\"std\";s:4:\"full\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:7:\"excerpt\";s:7:\"Excerpt\";s:4:\"full\";s:12:\"Full content\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:11:\"blog_layout\";s:5:\"value\";a:2:{i:0;s:11:\"def_classic\";i:1;s:10:\"def_modern\";}}}i:229;a:8:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:2:\"id\";s:10:\"blog_style\";s:4:\"name\";s:17:\"Blog color scheme\";s:11:\"description\";s:28:\"Select the style of the blog\";s:4:\"type\";s:6:\"select\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:3:{s:0:\"\";s:35:\"Inherit from Global (Color options)\";s:5:\"light\";s:5:\"Light\";s:4:\"dark\";s:4:\"Dark\";}}i:230;a:6:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:13:\"Image options\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:29:\"zn_full zn-custom-title-large\";}i:231;a:8:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:20:\"Use full width image\";s:11:\"description\";s:114:\"Choose Use full width image option if you want the images to be full width rather then\r\n        the default layout\";s:2:\"id\";s:25:\"sb_archive_use_full_image\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:3:\"yes\";s:20:\"Use full width image\";s:2:\"no\";s:18:\"Use default layout\";}}i:232;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:24:\"Image Maximum Width (px)\";s:11:\"description\";s:103:\"Add a custom maximum width for the blog-post images in the blog archive. Leave blank for default value.\";s:2:\"id\";s:21:\"sb_archive_def_cwidth\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:11:\"placeholder\";s:9:\"eg: 400px\";s:10:\"dependency\";a:2:{s:7:\"element\";s:25:\"sb_archive_use_full_image\";s:5:\"value\";a:1:{i:0;s:2:\"no\";}}}i:233;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:26:\"Use first attached image ?\";s:11:\"description\";s:105:\"Choose yes if you want the theme to display the first image inside a page if no featured image is present\";s:2:\"id\";s:18:\"zn_use_first_image\";s:3:\"std\";s:3:\"yes\";s:7:\"options\";a:2:{s:3:\"yes\";s:3:\"Yes\";s:2:\"no\";s:2:\"No\";}s:4:\"type\";s:8:\"zn_radio\";s:5:\"class\";s:15:\"zn_radio--yesno\";}i:234;a:7:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:15:\"Blog Sub-header\";s:11:\"description\";s:57:\"These options are applied to the subheader in blog pages.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:235;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:18:\"Archive Page Title\";s:11:\"description\";s:55:\"Enter the desired page title for the blog archive page.\";s:2:\"id\";s:18:\"archive_page_title\";s:4:\"type\";s:4:\"text\";s:3:\"std\";s:13:\"BLOG & Gossip\";s:14:\"translate_name\";s:18:\"Archive Page Title\";s:5:\"class\";s:0:\"\";}i:236;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:21:\"Archive page subtitle\";s:11:\"description\";s:58:\"Enter the desired page subtitle for the blog archive page.\";s:2:\"id\";s:21:\"archive_page_subtitle\";s:4:\"type\";s:4:\"text\";s:3:\"std\";s:36:\"This would be the blog category page\";s:14:\"translate_name\";s:21:\"Archive Page Subtitle\";s:5:\"class\";s:0:\"\";}i:237;a:9:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:31:\"Header Style for main blog page\";s:11:\"description\";s:150:\"Select the background style you want to use.Please note that the styles can be created from the \"Unlimited Headers\" options in the theme admin\'s page.\";s:2:\"id\";s:15:\"blog_sub_header\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{i:0;s:4:\"None\";s:19:\"zn_def_header_style\";s:13:\"Default style\";}s:5:\"class\";s:0:\"\";}i:238;a:6:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:13:\"Other options\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:239;a:7:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:16:\"Blog date format\";s:11:\"description\";s:168:\"Enter your desired date format. More info about formatting the date can be found <a target=\"_blank\" href=\"https://codex.wordpress.org/Formatting_Date_and_Time\">here</a>\";s:2:\"id\";s:16:\"blog_date_format\";s:4:\"type\";s:11:\"date_format\";s:3:\"std\";s:8:\"l, d F Y\";}i:240;a:7:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"bgao_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:241;a:7:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#Kd0a0kDrg1s\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:242;a:7:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:229:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/setting-up-blog/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:243;a:7:{s:4:\"slug\";s:20:\"blog_archive_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:244;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:14:\"Article layout\";s:11:\"description\";s:35:\"Choose the blog item\'s page layout.\";s:2:\"id\";s:9:\"sg_layout\";s:3:\"std\";s:7:\"classic\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:7:\"classic\";s:31:\"Classic Layout (Older versions)\";s:6:\"modern\";s:13:\"Modern Layout\";}}i:245;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:18:\"Show author info ?\";s:11:\"description\";s:71:\"Choose if you want to show the author info section on single post item.\";s:2:\"id\";s:19:\"zn_show_author_info\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:7:\"toggle2\";s:5:\"value\";s:3:\"yes\";}i:246;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:20:\"Show related posts ?\";s:11:\"description\";s:49:\"Choose if you want to show related posts section.\";s:2:\"id\";s:21:\"zn_show_related_posts\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:7:\"toggle2\";s:5:\"value\";s:3:\"yes\";}i:247;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:26:\"Show Social Share Buttons?\";s:11:\"description\";s:78:\"Choose if you want to show the social share buttons bellow the post\'s content.\";s:2:\"id\";s:11:\"show_social\";s:3:\"std\";s:4:\"show\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:4:\"show\";s:46:\"Show Generic social buttons (Performance cost)\";s:11:\"show_custom\";s:26:\"Show Custom social buttons\";s:4:\"hide\";s:26:\"Do not show social buttons\";}}i:248;a:7:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:13:\"Image options\";s:11:\"description\";s:0:\"\";s:2:\"id\";s:14:\"sbo_title_main\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:249;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:20:\"Use full width image\";s:11:\"description\";s:105:\"Choose Use full width image option if you want the images to be full widht rather then the default layout\";s:2:\"id\";s:17:\"sb_use_full_image\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:3:\"yes\";s:20:\"Use full width image\";s:2:\"no\";s:18:\"Use default layout\";}}i:250;a:9:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:24:\"Image Maximum Width (px)\";s:11:\"description\";s:89:\"Add a custom maximum width for the image in the blog post. Leave blank for default value.\";s:2:\"id\";s:16:\"sb_bp_def_cwidth\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:11:\"placeholder\";s:9:\"eg: 400px\";s:10:\"dependency\";a:2:{s:7:\"element\";s:17:\"sb_use_full_image\";s:5:\"value\";a:1:{i:0;s:2:\"no\";}}}i:251;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:45:\"Open post\'s \"linked\" images with modal popup?\";s:11:\"description\";s:76:\"Choose if you want to open post\'s images with a lightbox modal image opener.\";s:2:\"id\";s:16:\"sb_link_post_img\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:7:\"toggle2\";s:5:\"value\";s:3:\"yes\";}i:252;a:7:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:13:\"Other options\";s:11:\"description\";s:0:\"\";s:2:\"id\";s:14:\"sbo_title_main\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:253;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:34:\"Display posts on multiple columns?\";s:11:\"description\";s:78:\"Please select if you want to display the single blog post on multiple columns.\";s:2:\"id\";s:16:\"sbo_multicolumns\";s:3:\"std\";s:1:\"1\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{i:1;s:18:\"1 Column (default)\";i:2;s:9:\"2 Columns\";}}i:254;a:8:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:21:\"Override page title ?\";s:11:\"description\";s:108:\"Choose if you want to show a custom title in the sub-header. Normally, the current post title will be shown.\";s:2:\"id\";s:24:\"zn_override_single_title\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:7:\"toggle2\";s:5:\"value\";s:3:\"yes\";}i:255;a:9:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:17:\"Single Page Title\";s:11:\"description\";s:55:\"Enter the desired page title for the blog single pages.\";s:2:\"id\";s:17:\"single_page_title\";s:4:\"type\";s:4:\"text\";s:3:\"std\";s:13:\"BLOG & Gossip\";s:5:\"class\";s:0:\"\";s:10:\"dependency\";a:2:{s:7:\"element\";s:24:\"zn_override_single_title\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:256;a:7:{s:4:\"slug\";s:19:\"single_blog_options\";s:6:\"parent\";s:12:\"blog_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"sbio_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:257;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#Kd0a0kDrg1s\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:258;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:229:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/setting-up-blog/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:259;a:7:{s:4:\"slug\";s:17:\"recaptcha_options\";s:6:\"parent\";s:15:\"general_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:260;a:7:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:24:\"Portfolio page (Archive)\";s:11:\"description\";s:58:\"These options are dedicated to the portfolio archive page.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:261;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:23:\"Portfolio Archive style\";s:11:\"description\";s:57:\"Select the desired style for the portfolio archive pages.\";s:2:\"id\";s:15:\"portfolio_style\";s:3:\"std\";s:18:\"portfolio_sortable\";s:7:\"options\";a:3:{i:0;a:3:{s:5:\"value\";s:18:\"portfolio_category\";s:4:\"name\";s:18:\"Portfolio Category\";s:5:\"image\";s:98:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/portfolio_layouts/category.gif\";}i:1;a:3:{s:5:\"value\";s:18:\"portfolio_sortable\";s:4:\"name\";s:18:\"Portfolio Sortable\";s:5:\"image\";s:98:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/portfolio_layouts/sortable.gif\";}i:2;a:3:{s:5:\"value\";s:18:\"portfolio_carousel\";s:4:\"name\";s:19:\"Portfolio Carousels\";s:5:\"image\";s:99:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/portfolio_layouts/carousels.gif\";}}s:4:\"type\";s:11:\"radio_image\";s:5:\"class\";s:18:\"ri-hover-line ri-3\";}i:262;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:31:\"Active Button in Portfolio Menu\";s:11:\"description\";s:74:\"Choose the active category or wether all should be displayed on page load.\";s:2:\"id\";s:21:\"ptf_sort_activebutton\";s:3:\"std\";s:1:\"*\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:0:{}s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"portfolio_style\";s:5:\"value\";a:1:{i:0;s:18:\"portfolio_sortable\";}}}i:263;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:21:\"Show load more button\";s:11:\"description\";s:55:\"Choose if you want to show the load more button or not.\";s:2:\"id\";s:17:\"ptf_sort_loadmore\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:7:\"toggle2\";s:5:\"value\";s:3:\"yes\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"portfolio_style\";s:5:\"value\";a:1:{i:0;s:18:\"portfolio_sortable\";}}}i:264;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:17:\"Number of columns\";s:11:\"description\";s:68:\"Please select on how many columns the portfolio should be displayed.\";s:2:\"id\";s:17:\"ports_num_columns\";s:3:\"std\";s:1:\"4\";s:7:\"options\";a:6:{i:1;s:1:\"1\";i:2;s:1:\"2\";i:3;s:1:\"3\";i:4;s:1:\"4\";i:5;s:1:\"5\";i:6;s:1:\"6\";}s:4:\"type\";s:6:\"select\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"portfolio_style\";s:5:\"value\";a:2:{i:0;s:18:\"portfolio_category\";i:1;s:18:\"portfolio_sortable\";}}}i:265;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:12:\"Images Width\";s:11:\"description\";s:188:\"This option will resize and cache the images in your portfolio listing page\'s items. Not specifying a width will result in full-width images that would slow down the loading of your page. \";s:2:\"id\";s:18:\"ptf_sort_img_width\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:11:\"placeholder\";s:9:\"eg: 600px\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"portfolio_style\";s:5:\"value\";a:1:{i:0;s:18:\"portfolio_sortable\";}}}i:266;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:11:\"Frame Style\";s:11:\"description\";s:41:\"Please choose which frame style to apply.\";s:2:\"id\";s:11:\"frame_style\";s:3:\"std\";s:7:\"classic\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:7:\"classic\";s:7:\"Classic\";s:6:\"modern\";s:6:\"Modern\";s:7:\"minimal\";s:7:\"Minimal\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"portfolio_style\";s:5:\"value\";a:1:{i:0;s:18:\"portfolio_carousel\";}}}i:267;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:39:\"Number of columns (Portfolio Carousels)\";s:11:\"description\";s:68:\"Please select on how many columns the portfolio should be displayed.\";s:2:\"id\";s:22:\"ports_carousel_columns\";s:3:\"std\";s:1:\"1\";s:7:\"options\";a:3:{i:1;s:1:\"1\";i:2;s:1:\"2\";i:3;s:1:\"3\";}s:4:\"type\";s:6:\"select\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"portfolio_style\";s:5:\"value\";a:1:{i:0;s:18:\"portfolio_carousel\";}}}i:268;a:10:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:37:\"Show item details bellow post content\";s:11:\"description\";s:150:\"Here, you can choose to show the portfolio item details like CLIENt, YEAR, etc. <b> Important : Will only work when you select 1 column layout </b> ).\";s:2:\"id\";s:19:\"ports_extra_content\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";s:4:\"type\";s:8:\"zn_radio\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"portfolio_style\";s:5:\"value\";a:1:{i:0;s:18:\"portfolio_category\";}}}i:269;a:8:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:20:\"Link Portfolio Media\";s:11:\"description\";s:124:\"Select Yes if you want your portfolio images to be linked to the portfolio item as\r\n		opposed to open the image in lightbox.\";s:2:\"id\";s:17:\"zn_link_portfolio\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:3:{s:3:\"yes\";s:26:\"Link all to portfolio item\";s:2:\"no\";s:57:\"Open the image in lightbox, title links to portfolio item\";s:6:\"no_all\";s:45:\"Open the image in lightbox, title is unlinked\";}s:4:\"type\";s:6:\"select\";}i:270;a:7:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:24:\"Portfolio items per page\";s:11:\"description\";s:84:\"Please enter the desired number of portfolio items that will be displayed on a page.\";s:2:\"id\";s:23:\"portfolio_per_page_show\";s:3:\"std\";s:1:\"4\";s:4:\"type\";s:4:\"text\";}i:271;a:8:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:2:\"id\";s:16:\"portfolio_scheme\";s:4:\"name\";s:22:\"Portfolio color scheme\";s:11:\"description\";s:40:\"Select the color scheme of the Portfolio\";s:4:\"type\";s:6:\"select\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:3:{s:0:\"\";s:35:\"Inherit from Global (Color options)\";s:5:\"light\";s:5:\"Light\";s:4:\"dark\";s:4:\"Dark\";}}i:272;a:7:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:28:\"Portfolio item page (Single)\";s:11:\"description\";s:55:\"These options are dedicated to the portfolio item page.\";s:2:\"id\";s:9:\"hd_title1\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:46:\"zn_full zn-custom-title-large zn-top-separator\";}i:273;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:32:\"Text content (description) style\";s:11:\"description\";s:54:\"Display the text content either collapsed or expanded.\";s:2:\"id\";s:22:\"portfolio_single_style\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:0:\"\";s:26:\"Show compacted description\";s:9:\"full_desc\";s:21:\"Show full description\";}s:5:\"class\";s:0:\"\";}i:274;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:27:\"Portfolio Images Width (px)\";s:11:\"description\";s:88:\"The width of the portfolio item images to resize, in pixels. Adding \'0\' means no resize.\";s:2:\"id\";s:24:\"portfolio_item_img_width\";s:3:\"std\";s:3:\"700\";s:4:\"type\";s:4:\"text\";s:6:\"dragup\";a:1:{s:3:\"min\";s:3:\"100\";}s:5:\"class\";s:11:\"zn_input_xs\";}i:275;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:29:\"Show related portfolio items?\";s:11:\"description\";s:118:\"Here, you can choose to show the portfolio related items or not. The related items are based on the portfolio tags. ).\";s:2:\"id\";s:18:\"ports_show_related\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";s:4:\"type\";s:8:\"zn_radio\";}i:276;a:9:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:20:\"Show portfolio tags?\";s:11:\"description\";s:55:\"Here, you can choose to show the portfolio tags or not.\";s:2:\"id\";s:15:\"ports_show_tags\";s:3:\"std\";s:2:\"no\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";s:4:\"type\";s:8:\"zn_radio\";}i:277;a:7:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"ptfo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:278;a:7:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#rVA576HZaYA\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:279;a:7:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:234:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/setting-up-portfolio/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:280;a:7:{s:4:\"slug\";s:17:\"portfolio_options\";s:6:\"parent\";s:17:\"portfolio_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:281;a:9:{s:4:\"slug\";s:21:\"documentation_options\";s:6:\"parent\";s:21:\"documentation_options\";s:4:\"name\";s:12:\"Header Style\";s:11:\"description\";s:135:\"Select the header style you want to use for this page. Please note that\r\n					header styles can be created from the theme\'s admin page.\";s:2:\"id\";s:19:\"zn_doc_header_style\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{i:0;s:4:\"None\";s:19:\"zn_def_header_style\";s:13:\"Default style\";}s:5:\"class\";s:0:\"\";}i:282;a:7:{s:4:\"slug\";s:21:\"documentation_options\";s:6:\"parent\";s:21:\"documentation_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"dcmo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:283;a:7:{s:4:\"slug\";s:21:\"documentation_options\";s:6:\"parent\";s:21:\"documentation_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:284;a:9:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:18:\"Choose Site Layout\";s:11:\"description\";s:52:\"Choose the type of layout you want pages to display.\";s:2:\"id\";s:15:\"zn_boxed_layout\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:11:\"radio_image\";s:5:\"class\";s:24:\"zn_full ri-2 ri-bg-hover\";s:7:\"options\";a:2:{i:0;a:3:{s:5:\"value\";s:2:\"no\";s:4:\"name\";s:10:\"Full-Width\";s:5:\"image\";s:93:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/site-layout/fullwidth.svg\";}i:1;a:3:{s:5:\"value\";s:3:\"yes\";s:4:\"name\";s:5:\"Boxed\";s:5:\"image\";s:89:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/site-layout/boxed.svg\";}}}i:285;a:9:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:16:\"Background Image\";s:11:\"description\";s:59:\"Please choose your desired image to be used as a background\";s:2:\"id\";s:17:\"boxed_style_image\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:3:{s:6:\"repeat\";s:1:\"1\";s:8:\"position\";s:1:\"1\";s:10:\"attachment\";s:1:\"1\";}s:4:\"type\";s:10:\"background\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"zn_boxed_layout\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:286;a:8:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:16:\"Background Color\";s:11:\"description\";s:43:\"Please choose your desired background color\";s:2:\"id\";s:17:\"boxed_style_color\";s:3:\"std\";s:4:\"#fff\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:15:\"zn_boxed_layout\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:287;a:9:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:21:\"Homepage Boxed Layout\";s:11:\"description\";s:108:\"Here you can choose a specific layout setting for the homepage that will override the\r\n		setting from above.\";s:2:\"id\";s:20:\"zn_home_boxed_layout\";s:3:\"std\";s:3:\"def\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:3:{s:3:\"def\";s:7:\"Default\";s:2:\"no\";s:2:\"No\";s:3:\"yes\";s:3:\"Yes\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:288;a:9:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:12:\"Content size\";s:11:\"description\";s:55:\"Please choose the desired default size for the content.\";s:2:\"id\";s:8:\"zn_width\";s:3:\"std\";s:4:\"1170\";s:7:\"options\";a:4:{i:0;a:3:{s:5:\"value\";s:4:\"1170\";s:4:\"name\";s:6:\"1170px\";s:5:\"image\";s:117:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/layout-contentsize-1170.gif\";}i:1;a:3:{s:5:\"value\";s:3:\"960\";s:4:\"name\";s:5:\"960px\";s:5:\"image\";s:116:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/layout-contentsize-960.gif\";}i:2;a:3:{s:5:\"value\";s:6:\"custom\";s:4:\"name\";s:12:\"Custom Width\";s:5:\"image\";s:119:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/layout-contentsize-custom.gif\";}i:3;a:3:{s:5:\"value\";s:11:\"custom_perc\";s:4:\"name\";s:23:\"Custom Percentage Width\";s:5:\"image\";s:124:\"https://modelox.vico.digital/wp-content/themes/kallyas/images/admin/various-theme-options/layout-contentsize-custom-perc.gif\";}}s:4:\"type\";s:11:\"radio_image\";s:5:\"class\";s:18:\"ri-hover-line ri-4\";}i:289;a:9:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:2:\"id\";s:12:\"custom_width\";s:4:\"name\";s:51:\"Site Container Width (on Large breakpoints, 1200px)\";s:11:\"description\";s:50:\"Choose the desired width for the site\'s container.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:4:\"1170\";s:7:\"helpers\";a:2:{s:3:\"min\";s:4:\"1170\";s:3:\"max\";s:4:\"1900\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:8:\"zn_width\";s:5:\"value\";a:1:{i:0;s:6:\"custom\";}}}i:290;a:11:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:2:\"id\";s:17:\"custom_perc_width\";s:4:\"name\";s:33:\"Site Container Percentage % Width\";s:11:\"description\";s:50:\"Choose the desired width for the site\'s container.\";s:4:\"type\";s:12:\"smart_slider\";s:3:\"std\";s:3:\"100\";s:8:\"supports\";a:1:{i:0;s:11:\"breakpoints\";}s:5:\"units\";a:1:{i:0;s:1:\"%\";}s:7:\"helpers\";a:2:{s:3:\"min\";s:2:\"10\";s:3:\"max\";s:3:\"100\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:8:\"zn_width\";s:5:\"value\";a:1:{i:0;s:11:\"custom_perc\";}}}i:291;a:9:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:31:\"Extend Element Entry Animations\";s:11:\"description\";s:243:\"Choose yes if you want to extend elements entry/reveal animations on page scroll. Each element will have Animation options in the Misc. tab. Please remember that it affects website performance and will load animate.css which is around 60-70kb.\";s:2:\"id\";s:13:\"zn_animations\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:3:\"Yes\";s:2:\"no\";s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:292;a:7:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"lto_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:293;a:7:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#X6qGyb6Bmaw\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:294;a:7:{s:4:\"slug\";s:14:\"layout_options\";s:6:\"parent\";s:14:\"layout_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:295;a:7:{s:4:\"slug\";s:19:\"general_pb_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:40:\"PageBuilder Smart Areas on GENERAL PAGES\";s:11:\"description\";s:88:\"Using these options you can replace some of the site areas with pagebuilder smart areas.\";s:2:\"id\";s:14:\"pbtmpl_general\";s:4:\"type\";s:12:\"group_select\";s:6:\"config\";a:2:{s:4:\"size\";s:8:\"zn_span6\";s:7:\"options\";a:6:{i:0;a:3:{s:4:\"name\";s:29:\"Smart Area location on header\";s:2:\"id\";s:15:\"header_location\";s:7:\"options\";a:3:{s:6:\"before\";s:13:\"Before header\";s:5:\"after\";s:12:\"After header\";s:7:\"replace\";s:14:\"Replace header\";}}i:1;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"header_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:2;a:3:{s:4:\"name\";s:32:\"Smart Area location on subheader\";s:2:\"id\";s:18:\"subheader_location\";s:7:\"options\";a:3:{s:6:\"before\";s:16:\"Before subheader\";s:5:\"after\";s:15:\"After subheader\";s:7:\"replace\";s:17:\"Replace subheader\";}}i:3;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:18:\"subheader_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:4;a:3:{s:4:\"name\";s:29:\"Smart Area location on footer\";s:2:\"id\";s:15:\"footer_location\";s:7:\"options\";a:3:{s:6:\"before\";s:13:\"Before footer\";s:5:\"after\";s:12:\"After footer\";s:7:\"replace\";s:14:\"Replace footer\";}}i:5;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"footer_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}}}}i:296;a:7:{s:4:\"slug\";s:21:\"single_pages_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:43:\"PageBuilder Smart Area on SINGLE BLOG PAGES\";s:11:\"description\";s:87:\"Using these options you can replace some of the site areas with pagebuilder smart area.\";s:2:\"id\";s:11:\"pbtmpl_post\";s:4:\"type\";s:12:\"group_select\";s:6:\"config\";a:2:{s:4:\"size\";s:8:\"zn_span6\";s:7:\"options\";a:6:{i:0;a:3:{s:4:\"name\";s:29:\"Smart Area location on header\";s:2:\"id\";s:15:\"header_location\";s:7:\"options\";a:3:{s:6:\"before\";s:13:\"Before header\";s:5:\"after\";s:12:\"After header\";s:7:\"replace\";s:14:\"Replace header\";}}i:1;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"header_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:2;a:3:{s:4:\"name\";s:32:\"Smart Area location on SUBHEADER\";s:2:\"id\";s:18:\"subheader_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:16:\"Before subheader\";s:5:\"after\";s:15:\"After subheader\";s:7:\"replace\";s:17:\"Replace subheader\";}}i:3;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:18:\"subheader_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:4;a:3:{s:4:\"name\";s:29:\"Smart Area location on FOOTER\";s:2:\"id\";s:15:\"footer_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:13:\"Before footer\";s:5:\"after\";s:12:\"After footer\";s:7:\"replace\";s:14:\"Replace footer\";}}i:5;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"footer_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}}}}i:297;a:7:{s:4:\"slug\";s:21:\"single_pages_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:48:\"PageBuilder Smart Area on SINGLE PORTFOLIO PAGES\";s:11:\"description\";s:87:\"Using these options you can replace some of the site areas with pagebuilder smart area.\";s:2:\"id\";s:16:\"pbtmpl_portfolio\";s:4:\"type\";s:12:\"group_select\";s:6:\"config\";a:2:{s:4:\"size\";s:8:\"zn_span6\";s:7:\"options\";a:6:{i:0;a:3:{s:4:\"name\";s:29:\"Smart Area location on header\";s:2:\"id\";s:15:\"header_location\";s:7:\"options\";a:3:{s:6:\"before\";s:13:\"Before header\";s:5:\"after\";s:12:\"After header\";s:7:\"replace\";s:14:\"Replace header\";}}i:1;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"header_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:2;a:3:{s:4:\"name\";s:32:\"Smart Area location on SUBHEADER\";s:2:\"id\";s:18:\"subheader_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:16:\"Before subheader\";s:5:\"after\";s:15:\"After subheader\";s:7:\"replace\";s:17:\"Replace subheader\";}}i:3;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:18:\"subheader_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:4;a:3:{s:4:\"name\";s:29:\"Smart Area location on FOOTER\";s:2:\"id\";s:15:\"footer_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:13:\"Before footer\";s:5:\"after\";s:12:\"After footer\";s:7:\"replace\";s:14:\"Replace footer\";}}i:5;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"footer_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}}}}i:298;a:7:{s:4:\"slug\";s:21:\"single_pages_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:43:\"PageBuilder Smart Area on SINGLE SHOP PAGES\";s:11:\"description\";s:87:\"Using these options you can replace some of the site areas with pagebuilder smart area.\";s:2:\"id\";s:14:\"pbtmpl_product\";s:4:\"type\";s:12:\"group_select\";s:6:\"config\";a:2:{s:4:\"size\";s:8:\"zn_span6\";s:7:\"options\";a:6:{i:0;a:3:{s:4:\"name\";s:29:\"Smart Area location on header\";s:2:\"id\";s:15:\"header_location\";s:7:\"options\";a:3:{s:6:\"before\";s:13:\"Before header\";s:5:\"after\";s:12:\"After header\";s:7:\"replace\";s:14:\"Replace header\";}}i:1;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"header_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:2;a:3:{s:4:\"name\";s:32:\"Smart Area location on SUBHEADER\";s:2:\"id\";s:18:\"subheader_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:16:\"Before subheader\";s:5:\"after\";s:15:\"After subheader\";s:7:\"replace\";s:17:\"Replace subheader\";}}i:3;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:18:\"subheader_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:4;a:3:{s:4:\"name\";s:29:\"Smart Area location on FOOTER\";s:2:\"id\";s:15:\"footer_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:13:\"Before footer\";s:5:\"after\";s:12:\"After footer\";s:7:\"replace\";s:14:\"Replace footer\";}}i:5;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"footer_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}}}}i:299;a:7:{s:4:\"slug\";s:22:\"archive_pages_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:55:\"PageBuilder Smart Area on BLOG ARCHIVE (Category) PAGES\";s:11:\"description\";s:87:\"Using these options you can replace some of the site areas with pagebuilder smart area.\";s:2:\"id\";s:15:\"pbtmpl_category\";s:4:\"type\";s:12:\"group_select\";s:6:\"config\";a:2:{s:4:\"size\";s:8:\"zn_span6\";s:7:\"options\";a:6:{i:0;a:3:{s:4:\"name\";s:29:\"Smart Area location on header\";s:2:\"id\";s:15:\"header_location\";s:7:\"options\";a:3:{s:6:\"before\";s:13:\"Before header\";s:5:\"after\";s:12:\"After header\";s:7:\"replace\";s:14:\"Replace header\";}}i:1;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"header_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:2;a:3:{s:4:\"name\";s:32:\"Smart Area location on SUBHEADER\";s:2:\"id\";s:18:\"subheader_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:16:\"Before subheader\";s:5:\"after\";s:15:\"After subheader\";s:7:\"replace\";s:17:\"Replace subheader\";}}i:3;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:18:\"subheader_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:4;a:3:{s:4:\"name\";s:29:\"Smart Area location on FOOTER\";s:2:\"id\";s:15:\"footer_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:13:\"Before footer\";s:5:\"after\";s:12:\"After footer\";s:7:\"replace\";s:14:\"Replace footer\";}}i:5;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"footer_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}}}}i:300;a:7:{s:4:\"slug\";s:22:\"archive_pages_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:55:\"PageBuilder Smart Area on SHOP ARCHIVE (Category) PAGES\";s:11:\"description\";s:87:\"Using these options you can replace some of the site areas with pagebuilder smart area.\";s:2:\"id\";s:18:\"pbtmpl_product_cat\";s:4:\"type\";s:12:\"group_select\";s:6:\"config\";a:2:{s:4:\"size\";s:8:\"zn_span6\";s:7:\"options\";a:6:{i:0;a:3:{s:4:\"name\";s:29:\"Smart Area location on header\";s:2:\"id\";s:15:\"header_location\";s:7:\"options\";a:3:{s:6:\"before\";s:13:\"Before header\";s:5:\"after\";s:12:\"After header\";s:7:\"replace\";s:14:\"Replace header\";}}i:1;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"header_template\";s:7:\"options\";a:1:{s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:2;a:3:{s:4:\"name\";s:32:\"Smart Area location on SUBHEADER\";s:2:\"id\";s:18:\"subheader_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:16:\"Before subheader\";s:5:\"after\";s:15:\"After subheader\";s:7:\"replace\";s:17:\"Replace subheader\";}}i:3;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:18:\"subheader_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}i:4;a:3:{s:4:\"name\";s:29:\"Smart Area location on FOOTER\";s:2:\"id\";s:15:\"footer_location\";s:7:\"options\";a:4:{s:0:\"\";s:25:\"-- Use general setting --\";s:6:\"before\";s:13:\"Before footer\";s:5:\"after\";s:12:\"After footer\";s:7:\"replace\";s:14:\"Replace footer\";}}i:5;a:3:{s:4:\"name\";s:17:\"Smart Area to use\";s:2:\"id\";s:15:\"footer_template\";s:7:\"options\";a:2:{s:0:\"\";s:28:\"-- Use general smart area --\";s:11:\"no_template\";s:19:\"-- No smart-area --\";}}}}}i:301;a:7:{s:4:\"slug\";s:19:\"general_pb_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"lto_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:302;a:7:{s:4:\"slug\";s:19:\"general_pb_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:238:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/page-builder-smart-areas/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:303;a:7:{s:4:\"slug\";s:19:\"general_pb_settings\";s:6:\"parent\";s:10:\"pb_layouts\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:304;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:10:\"MAIN COLOR\";s:11:\"description\";s:163:\"Please choose a main color for your site. This color will be used for various elements within the site, as text color (and hover) and background color (and hover).\";s:2:\"id\";s:13:\"zn_main_color\";s:3:\"std\";s:7:\"#cd2122\";s:4:\"type\";s:11:\"colorpicker\";}i:305;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:21:\"MAIN COLOR (Contrast)\";s:11:\"description\";s:308:\"This color is used exclusively where it\'s over or depends on the MAIN COLOR. For example default color is Red, this White color will be over it, for example active menu item in main menu, Full-Colored button, etc. This comes in need when you\'re using a main color that\'s too bright and it becomes unreadable.\";s:2:\"id\";s:22:\"zn_main_color_contrast\";s:3:\"std\";s:4:\"#fff\";s:4:\"type\";s:11:\"colorpicker\";}i:306;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:18:\"Global Site Colors\";s:11:\"description\";s:40:\"These are the global site color options.\";s:2:\"id\";s:14:\"clo_title_main\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:44:\"zn_full zn-custom-title-md zn-top-separator \";}i:307;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:10:\"THEME SKIN\";s:11:\"description\";s:233:\"Please select the skin of the theme, wether light or dark. <br>* Please know that customisations are still needed and most elements have their own customisation options (eg: colorprickers or even text color scheme light/dark preset).\";s:2:\"id\";s:13:\"zn_main_style\";s:3:\"std\";s:5:\"light\";s:7:\"options\";a:2:{s:5:\"light\";s:23:\"Light Style ( Default )\";s:4:\"dark\";s:10:\"Dark Style\";}s:4:\"type\";s:6:\"select\";}i:308;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:31:\"TEXT COLOR (Light - Theme Skin)\";s:11:\"description\";s:271:\"Please choose a default color for the site\'s general text color. <br>* Note: There is another color option in Kallyas options > Font options > Body Options. Make sure that option is empty. We\'ll keep that one just for backwards compatibility only, but it will be removed.\";s:2:\"id\";s:21:\"zn_body_def_textcolor\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"zn_main_style\";s:5:\"value\";a:1:{i:0;s:5:\"light\";}}}i:309;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:33:\"LINKS COLORS (Light - Theme Skin)\";s:11:\"description\";s:89:\"Please choose a default color for the site\'s general links color (mostly in post content)\";s:2:\"id\";s:22:\"zn_body_def_linkscolor\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"zn_main_style\";s:5:\"value\";a:1:{i:0;s:5:\"light\";}}}i:310;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:38:\"HOVER LINKS COLOR (Light - Theme Skin)\";s:11:\"description\";s:96:\"Please choose a default color for the site\'s general hover links color (mostly in post content).\";s:2:\"id\";s:26:\"zn_body_def_linkscolor_hov\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"zn_main_style\";s:5:\"value\";a:1:{i:0;s:5:\"light\";}}}i:311;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:30:\"TEXT COLOR (Dark - Theme Skin)\";s:11:\"description\";s:271:\"Please choose a default color for the site\'s general text color. <br>* Note: There is another color option in Kallyas options > Font options > Body Options. Make sure that option is empty. We\'ll keep that one just for backwards compatibility only, but it will be removed.\";s:2:\"id\";s:26:\"zn_body_def_textcolor_dark\";s:3:\"std\";s:7:\"#dcdcdc\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"zn_main_style\";s:5:\"value\";a:1:{i:0;s:4:\"dark\";}}}i:312;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:32:\"LINKS COLORS (Dark - Theme Skin)\";s:11:\"description\";s:90:\"Please choose a default color for the site\'s general links color (mostly in post content).\";s:2:\"id\";s:27:\"zn_body_def_linkscolor_dark\";s:3:\"std\";s:7:\"#ffffff\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"zn_main_style\";s:5:\"value\";a:1:{i:0;s:4:\"dark\";}}}i:313;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:37:\"HOVER LINKS COLOR (Dark - Theme Skin)\";s:11:\"description\";s:96:\"Please choose a default color for the site\'s general hover links color (mostly in post content).\";s:2:\"id\";s:31:\"zn_body_def_linkscolor_hov_dark\";s:3:\"std\";s:4:\"#eee\";s:4:\"type\";s:11:\"colorpicker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"zn_main_style\";s:5:\"value\";a:1:{i:0;s:4:\"dark\";}}}i:314;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:16:\"BACKGROUND COLOR\";s:11:\"description\";s:50:\"Please choose a default color for the site\'s body.\";s:2:\"id\";s:17:\"zn_body_def_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";}i:315;a:8:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:16:\"BACKGROUND IMAGE\";s:11:\"description\";s:66:\"Please choose your desired image to be used as as body background.\";s:2:\"id\";s:15:\"body_back_image\";s:3:\"std\";s:0:\"\";s:7:\"options\";a:4:{s:6:\"repeat\";s:1:\"1\";s:8:\"position\";s:1:\"1\";s:10:\"attachment\";s:1:\"1\";s:4:\"size\";s:1:\"1\";}s:4:\"type\";s:10:\"background\";}i:316;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:21:\"Various Color Options\";s:11:\"description\";s:59:\"These are various colors for different parts from the site.\";s:2:\"id\";s:17:\"clo_title_various\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:44:\"zn_full zn-custom-title-md zn-top-separator \";}i:317;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:21:\"Top Nav default Color\";s:11:\"description\";s:54:\"Please choose a color for the top nav links in header.\";s:2:\"id\";s:16:\"zn_top_nav_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";}i:318;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:19:\"Top Nav Hover Color\";s:11:\"description\";s:78:\"Please choose a color for the top nav links in header when hovering over them.\";s:2:\"id\";s:18:\"zn_top_nav_h_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";}i:319;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"clmo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:320;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#MkYR_3PYbXU\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:321;a:7:{s:4:\"slug\";s:13:\"color_options\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:322;a:12:{s:4:\"slug\";s:21:\"color_options_palette\";s:6:\"parent\";s:13:\"color_options\";s:4:\"name\";s:22:\"Add Colors for Palette\";s:11:\"description\";s:401:\"Here you can add colors that will be displayed in the <strong style=\"color:#121212\">bottom\'s colorpicker palette</strong>:<br><br> <img width=\"140\" src=\"https://modelox.vico.digital/wp-content/themes/kallyas/images/zn_add_pallette_lq.png\" alt=\"\">. <br><br>Color resources:<br><a href=\"http://colorhunt.co/tab/\" title=\"\">ColorHunt</a><br><a href=\"http://www.colourlovers.com/\" title=\"\">ColourLovers</a>\";s:2:\"id\";s:13:\"zn_add_colors\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"group\";s:13:\"element_title\";s:8:\"zn_color\";s:8:\"add_text\";s:5:\"Color\";s:11:\"remove_text\";s:5:\"Color\";s:11:\"subelements\";a:1:{i:0;a:5:{s:4:\"name\";s:9:\"Add Color\";s:11:\"description\";s:16:\"Choose the color\";s:2:\"id\";s:8:\"zn_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"colorpicker\";}}s:5:\"class\";s:11:\"zn_not_full\";}i:323;a:13:{s:4:\"slug\";s:24:\"unlimited_header_options\";s:6:\"parent\";s:24:\"unlimited_header_options\";s:4:\"name\";s:23:\"Header Styles Generator\";s:11:\"description\";s:74:\"Here you can create unlimited header styles to be used on different pages.\";s:2:\"id\";s:16:\"header_generator\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"group\";s:8:\"add_text\";s:12:\"Header Style\";s:11:\"remove_text\";s:12:\"Header Style\";s:13:\"element_title\";s:13:\"uh_style_name\";s:14:\"group_sortable\";b:0;s:11:\"subelements\";a:23:{i:0;a:6:{s:4:\"name\";s:17:\"Header Style Name\";s:11:\"description\";s:156:\"The name of this header style.Please note that all names must be unique. You can only use alphanumeric characters. Other character types can cause problems.\";s:2:\"id\";s:13:\"uh_style_name\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";s:8:\"supports\";s:5:\"block\";}i:1;a:6:{s:4:\"name\";s:15:\"Background Type\";s:11:\"description\";s:48:\"Please select the source type of the background.\";s:2:\"id\";s:10:\"uh_bg_type\";s:3:\"std\";s:9:\"simple_bg\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:9:\"simple_bg\";s:23:\"Simple Background Image\";s:11:\"advanced_bg\";s:34:\"Advanced Settings Background Image\";}}i:2;a:6:{s:2:\"id\";s:19:\"uh_background_image\";s:4:\"name\";s:16:\"Background image\";s:11:\"description\";s:128:\"Select a background image for your Sub-header. It will automatically be resized to fully stretch inside the subheader boundries.\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"media\";s:10:\"dependency\";a:2:{s:7:\"element\";s:10:\"uh_bg_type\";s:5:\"value\";a:1:{i:0;s:9:\"simple_bg\";}}}i:3;a:7:{s:2:\"id\";s:28:\"uh_background_image_advanced\";s:4:\"name\";s:16:\"Background image\";s:11:\"description\";s:80:\"Please choose a background image for this Subheader and select advanced options.\";s:4:\"type\";s:10:\"background\";s:7:\"options\";a:4:{s:6:\"repeat\";s:1:\"1\";s:8:\"position\";s:1:\"1\";s:10:\"attachment\";s:1:\"1\";s:4:\"size\";s:1:\"1\";}s:5:\"class\";s:7:\"zn_full\";s:10:\"dependency\";a:2:{s:7:\"element\";s:10:\"uh_bg_type\";s:5:\"value\";a:1:{i:0;s:11:\"advanced_bg\";}}}i:4;a:5:{s:4:\"name\";s:23:\"Header Background Color\";s:11:\"description\";s:136:\"Here you can choose a default color for your header.If you do not select a\r\n				background image, this color will be used as background.\";s:2:\"id\";s:15:\"uh_header_color\";s:3:\"std\";s:7:\"#AAAAAA\";s:4:\"type\";s:11:\"colorpicker\";}i:5;a:7:{s:4:\"name\";s:24:\"Add gradient over color?\";s:11:\"description\";s:61:\"Select yes if you want add a gradient over the selected color\";s:2:\"id\";s:10:\"uh_grad_bg\";s:3:\"std\";s:1:\"1\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";i:0;s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:6;a:7:{s:4:\"name\";s:19:\"Animate Background?\";s:11:\"description\";s:55:\"Select yes if you want to make your background animated\";s:2:\"id\";s:10:\"uh_anim_bg\";s:3:\"std\";s:1:\"0\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";i:0;s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:7;a:7:{s:4:\"name\";s:17:\"Add Glare effect?\";s:11:\"description\";s:64:\"Select yes if you want to add a glare effect over the background\";s:2:\"id\";s:8:\"uh_glare\";s:3:\"std\";s:1:\"0\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{i:1;s:3:\"Yes\";i:0;s:2:\"No\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:8;a:6:{s:4:\"name\";s:17:\"Text Color Scheme\";s:11:\"description\";s:29:\"Select the text color scheme.\";s:2:\"id\";s:12:\"uh_textcolor\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:3:{s:0:\"\";s:36:\"- Default - Set from theme options -\";s:5:\"light\";s:5:\"Light\";s:4:\"dark\";s:4:\"Dark\";}}i:9;a:6:{s:4:\"name\";s:11:\"Bottom mask\";s:11:\"description\";s:57:\"The new masks are svg based, vectorial and color adapted.\";s:2:\"id\";s:15:\"uh_bottom_style\";s:3:\"std\";s:4:\"none\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:13:{s:4:\"none\";s:5:\"None.\";s:6:\"shadow\";s:9:\"Shadow Up\";s:9:\"shadow_ud\";s:18:\"Shadow Up and down\";s:5:\"mask1\";s:36:\"Raster Mask 1 (Old, not recommended)\";s:5:\"mask2\";s:36:\"Raster Mask 2 (Old, not recommended)\";s:5:\"mask3\";s:37:\"Vector Mask 3 CENTER (New! From v4.0)\";s:12:\"mask3 mask3l\";s:35:\"Vector Mask 3 LEFT (New! From v4.0)\";s:12:\"mask3 mask3r\";s:36:\"Vector Mask 3 RIGHT (New! From v4.0)\";s:5:\"mask4\";s:37:\"Vector Mask 4 CENTER (New! From v4.0)\";s:12:\"mask4 mask4l\";s:35:\"Vector Mask 4 LEFT (New! From v4.0)\";s:12:\"mask4 mask4r\";s:36:\"Vector Mask 4 RIGHT (New! From v4.0)\";s:5:\"mask5\";s:30:\"Vector Mask 5 (New! From v4.0)\";s:5:\"mask6\";s:30:\"Vector Mask 6 (New! From v4.0)\";}}i:10;a:7:{s:4:\"name\";s:50:\"Edit height and padding for each device breakpoint\";s:11:\"description\";s:233:\"Edit the height and padding options for each breakpoint (device). This will enable you to have more control over the subheader on each device. For example you might want the subheader to be shorter on mobiles, but taller on desktops.\";s:2:\"id\";s:13:\"uh_br_options\";s:3:\"std\";s:2:\"lg\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:4:{s:2:\"lg\";s:5:\"LARGE\";s:2:\"md\";s:6:\"MEDIUM\";s:2:\"sm\";s:5:\"SMALL\";s:2:\"xs\";s:11:\"EXTRA SMALL\";}s:5:\"class\";s:22:\"zn_full zn_breakpoints\";}i:11;a:8:{s:2:\"id\";s:16:\"uh_header_height\";s:4:\"name\";s:36:\"Height on LARGE DEVICES ( Desktops )\";s:11:\"description\";s:59:\"Please enter your desired height in pixels for this header.\";s:3:\"std\";s:3:\"300\";s:4:\"type\";s:6:\"slider\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:3:\"150\";s:3:\"max\";s:4:\"1280\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"lg\";}}}i:12;a:8:{s:2:\"id\";s:14:\"uh_top_padding\";s:4:\"name\";s:41:\"Top Padding on LARGE DEVICES ( Desktops )\";s:11:\"description\";s:56:\"Select the top padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:3:\"170\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:2:\"50\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"lg\";}}}i:13;a:8:{s:2:\"id\";s:17:\"uh_bottom_padding\";s:4:\"name\";s:44:\"Bottom Padding on LARGE DEVICES ( Desktops )\";s:11:\"description\";s:59:\"Select the bottom padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:1:\"0\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:1:\"0\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"lg\";}}}i:14;a:8:{s:2:\"id\";s:19:\"uh_header_height_md\";s:4:\"name\";s:45:\"Height on MEDIUM DEVICES (Tablets, wide mode)\";s:11:\"description\";s:59:\"Please enter your desired height in pixels for this header.\";s:3:\"std\";s:3:\"300\";s:4:\"type\";s:6:\"slider\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:3:\"150\";s:3:\"max\";s:4:\"1280\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"md\";}}}i:15;a:8:{s:2:\"id\";s:17:\"uh_top_padding_md\";s:4:\"name\";s:50:\"Top Padding on MEDIUM DEVICES (Tablets, wide mode)\";s:11:\"description\";s:56:\"Select the top padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:3:\"170\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:2:\"50\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"md\";}}}i:16;a:8:{s:2:\"id\";s:20:\"uh_bottom_padding_md\";s:4:\"name\";s:53:\"Bottom Padding on MEDIUM DEVICES (Tablets, wide mode)\";s:11:\"description\";s:59:\"Select the bottom padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:1:\"0\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:1:\"0\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"md\";}}}i:17;a:8:{s:2:\"id\";s:19:\"uh_header_height_sm\";s:4:\"name\";s:48:\"Height on SMALL DEVICES (Tablets, portrait mode)\";s:11:\"description\";s:59:\"Please enter your desired height in pixels for this header.\";s:3:\"std\";s:3:\"300\";s:4:\"type\";s:6:\"slider\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:3:\"150\";s:3:\"max\";s:4:\"1280\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"sm\";}}}i:18;a:8:{s:2:\"id\";s:17:\"uh_top_padding_sm\";s:4:\"name\";s:53:\"Top Padding on SMALL DEVICES (Tablets, portrait mode)\";s:11:\"description\";s:56:\"Select the top padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:3:\"170\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:2:\"50\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"sm\";}}}i:19;a:8:{s:2:\"id\";s:20:\"uh_bottom_padding_sm\";s:4:\"name\";s:56:\"Bottom Padding on SMALL DEVICES (Tablets, portrait mode)\";s:11:\"description\";s:59:\"Select the bottom padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:1:\"0\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:1:\"0\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"sm\";}}}i:20;a:8:{s:2:\"id\";s:19:\"uh_header_height_xs\";s:4:\"name\";s:45:\"Height on EXTRA SMALL DEVICES ( SmartPhones )\";s:11:\"description\";s:59:\"Please enter your desired height in pixels for this header.\";s:3:\"std\";s:3:\"300\";s:4:\"type\";s:6:\"slider\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:3:\"150\";s:3:\"max\";s:4:\"1280\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"xs\";}}}i:21;a:8:{s:2:\"id\";s:17:\"uh_top_padding_xs\";s:4:\"name\";s:50:\"Top Padding on EXTRA SMALL DEVICES ( SmartPhones )\";s:11:\"description\";s:56:\"Select the top padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:3:\"170\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:2:\"50\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"xs\";}}}i:22;a:8:{s:2:\"id\";s:20:\"uh_bottom_padding_xs\";s:4:\"name\";s:53:\"Bottom Padding on EXTRA SMALL DEVICES ( SmartPhones )\";s:11:\"description\";s:59:\"Select the bottom padding ( in pixels ) for this Subheader.\";s:4:\"type\";s:6:\"slider\";s:3:\"std\";s:1:\"0\";s:5:\"class\";s:7:\"zn_full\";s:7:\"helpers\";a:3:{s:3:\"min\";s:1:\"0\";s:3:\"max\";s:3:\"350\";s:4:\"step\";s:1:\"1\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:13:\"uh_br_options\";s:5:\"value\";a:1:{i:0;s:2:\"xs\";}}}}s:5:\"class\";s:0:\"\";}i:324;a:7:{s:4:\"slug\";s:24:\"unlimited_header_options\";s:6:\"parent\";s:24:\"unlimited_header_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:9:\"uho_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:325;a:7:{s:4:\"slug\";s:24:\"unlimited_header_options\";s:6:\"parent\";s:24:\"unlimited_header_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#6T0VYHCS9mA\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:326;a:7:{s:4:\"slug\";s:24:\"unlimited_header_options\";s:6:\"parent\";s:24:\"unlimited_header_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:327;a:7:{s:4:\"slug\";s:15:\"sidebar_options\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:2:\"id\";s:12:\"sidebar_size\";s:4:\"name\";s:12:\"Sidebar Size\";s:11:\"description\";s:32:\"Select the desired sidebar size.\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{i:3;s:4:\"3/12\";i:4;s:4:\"4/12\";}}i:328;a:9:{s:4:\"slug\";s:18:\"unlimited_sidebars\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:2:\"id\";s:18:\"unlimited_sidebars\";s:4:\"name\";s:18:\"Unlimited Sidebars\";s:11:\"description\";s:75:\"Here you can create unlimited sidebars that you can use all over the theme.\";s:4:\"type\";s:5:\"group\";s:8:\"sortable\";b:0;s:13:\"element_title\";s:12:\"sidebar_name\";s:11:\"subelements\";a:1:{i:0;a:5:{s:2:\"id\";s:12:\"sidebar_name\";s:4:\"name\";s:12:\"Sidebar Name\";s:11:\"description\";s:107:\"Please enter a name for this sidebar. Please note that the name should only contain alphanumeric characters\";s:4:\"type\";s:4:\"text\";s:8:\"supports\";s:5:\"block\";}}}i:329;a:7:{s:4:\"slug\";s:18:\"unlimited_sidebars\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"usbo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:330;a:7:{s:4:\"slug\";s:18:\"unlimited_sidebars\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#M7TcpipwAKw\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:331;a:7:{s:4:\"slug\";s:18:\"unlimited_sidebars\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:332;a:9:{s:4:\"slug\";s:16:\"sidebar_settings\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:2:\"id\";s:15:\"archive_sidebar\";s:4:\"name\";s:24:\"Sidebar on archive pages\";s:11:\"description\";s:57:\"Please choose the sidebar position for the archive pages.\";s:4:\"type\";s:7:\"sidebar\";s:5:\"class\";s:7:\"zn_full\";s:3:\"std\";a:2:{s:6:\"layout\";s:13:\"sidebar_right\";s:7:\"sidebar\";s:15:\"default_sidebar\";}s:8:\"supports\";a:2:{s:15:\"default_sidebar\";s:14:\"defaultsidebar\";s:15:\"sidebar_options\";a:3:{s:13:\"right_sidebar\";s:13:\"Right sidebar\";s:12:\"left_sidebar\";s:12:\"Left sidebar\";s:10:\"no_sidebar\";s:10:\"No sidebar\";}}}i:333;a:9:{s:4:\"slug\";s:16:\"sidebar_settings\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:2:\"id\";s:12:\"blog_sidebar\";s:4:\"name\";s:15:\"Sidebar on Blog\";s:11:\"description\";s:53:\"Please choose the sidebar position for the blog page.\";s:4:\"type\";s:7:\"sidebar\";s:5:\"class\";s:7:\"zn_full\";s:3:\"std\";a:2:{s:6:\"layout\";s:13:\"sidebar_right\";s:7:\"sidebar\";s:15:\"default_sidebar\";}s:8:\"supports\";a:2:{s:15:\"default_sidebar\";s:14:\"defaultsidebar\";s:15:\"sidebar_options\";a:3:{s:13:\"right_sidebar\";s:13:\"Right sidebar\";s:12:\"left_sidebar\";s:12:\"Left sidebar\";s:10:\"no_sidebar\";s:10:\"No sidebar\";}}}i:334;a:9:{s:4:\"slug\";s:16:\"sidebar_settings\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:2:\"id\";s:14:\"single_sidebar\";s:4:\"name\";s:27:\"Sidebar on single blog post\";s:11:\"description\";s:61:\"Please choose the sidebar position for the single blog posts.\";s:4:\"type\";s:7:\"sidebar\";s:5:\"class\";s:7:\"zn_full\";s:3:\"std\";a:2:{s:6:\"layout\";s:13:\"sidebar_right\";s:7:\"sidebar\";s:15:\"default_sidebar\";}s:8:\"supports\";a:2:{s:15:\"default_sidebar\";s:14:\"defaultsidebar\";s:15:\"sidebar_options\";a:3:{s:13:\"right_sidebar\";s:13:\"Right sidebar\";s:12:\"left_sidebar\";s:12:\"Left sidebar\";s:10:\"no_sidebar\";s:10:\"No sidebar\";}}}i:335;a:9:{s:4:\"slug\";s:16:\"sidebar_settings\";s:6:\"parent\";s:18:\"unlimited_sidebars\";s:2:\"id\";s:12:\"page_sidebar\";s:4:\"name\";s:16:\"Sidebar on pages\";s:11:\"description\";s:49:\"Please choose the sidebar position for the pages.\";s:4:\"type\";s:7:\"sidebar\";s:5:\"class\";s:7:\"zn_full\";s:3:\"std\";a:2:{s:6:\"layout\";s:13:\"sidebar_right\";s:7:\"sidebar\";s:15:\"default_sidebar\";}s:8:\"supports\";a:2:{s:15:\"default_sidebar\";s:14:\"defaultsidebar\";s:15:\"sidebar_options\";a:3:{s:13:\"right_sidebar\";s:13:\"Right sidebar\";s:12:\"left_sidebar\";s:12:\"Left sidebar\";s:10:\"no_sidebar\";s:10:\"No sidebar\";}}}i:336;a:9:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:19:\"Enable Coming Soon?\";s:11:\"description\";s:141:\"If enabled, the visitors will be displayed the coming soon page. Please note that\r\n		all logged in users will still be able to see your site.\";s:2:\"id\";s:9:\"cs_enable\";s:3:\"std\";s:2:\"no\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:6:\"Enable\";s:2:\"no\";s:7:\"Disable\";}s:5:\"class\";s:15:\"zn_radio--yesno\";}i:337;a:9:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:63:\"Enter a description that will appear above the countdown clock.\";s:2:\"id\";s:7:\"cs_desc\";s:3:\"std\";s:142:\"We are currently working on a new website and won\'t take long. Please don\'t forget to check\r\n		out our tweets and to subscribe to be notified!\";s:4:\"type\";s:8:\"textarea\";s:14:\"translate_name\";s:28:\"Coming Soon Page Description\";s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cs_enable\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:338;a:8:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:11:\"Launch date\";s:11:\"description\";s:56:\"Please select the date when your site will be available.\";s:2:\"id\";s:7:\"cs_date\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:11:\"date_picker\";s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cs_enable\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:339;a:9:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:15:\"Select template\";s:11:\"description\";s:62:\"Please select the template to use or use the default template.\";s:2:\"id\";s:16:\"cs_page_template\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:11:\"data-source\";s:5:\"pages\";s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cs_enable\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:340;a:9:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:17:\"Mailchimp List ID\";s:11:\"description\";s:210:\"Please select the mailchimp list ID you want to use. Please note that in order for the theme to display your list id\'s ,you will need to enter your Mailchimp API id in the General options > Mailchimp API option\";s:2:\"id\";s:10:\"cs_lsit_id\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:1:{s:0:\"\";s:14:\"Select List ID\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cs_enable\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:341;a:10:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:29:\"Show or hide the Social icons\";s:11:\"description\";s:51:\"Display the social icons list in coming soon page?.\";s:2:\"id\";s:22:\"cs_social_icons_enable\";s:3:\"std\";s:3:\"yes\";s:4:\"type\";s:8:\"zn_radio\";s:7:\"options\";a:2:{s:3:\"yes\";s:4:\"Show\";s:2:\"no\";s:4:\"Hide\";}s:5:\"class\";s:15:\"zn_radio--yesno\";s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cs_enable\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:342;a:9:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:35:\"Use normal or colored social icons?\";s:11:\"description\";s:87:\"Here you can choose to use the normal social icons or the colored version of each icon.\";s:2:\"id\";s:18:\"cs_which_icons_set\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:4:{s:6:\"normal\";s:12:\"Normal Icons\";s:7:\"colored\";s:13:\"Colored icons\";s:11:\"colored_hov\";s:22:\"Colored on Hover icons\";s:5:\"clean\";s:11:\"Clean icons\";}s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cs_enable\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:343;a:12:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:12:\"Social Icons\";s:11:\"description\";s:94:\"Here you can configure what social icons to appear on the right side of the MailChimp\r\n		form.\";s:2:\"id\";s:15:\"cs_social_icons\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"group\";s:13:\"element_title\";s:15:\"cs_social_title\";s:8:\"add_text\";s:11:\"Social Icon\";s:11:\"remove_text\";s:11:\"Social Icon\";s:11:\"subelements\";a:4:{i:0;a:5:{s:4:\"name\";s:10:\"Icon title\";s:11:\"description\";s:149:\"Here you can enter a title for this social icon.Please note that this is just\r\n				for your information as this text will not be visible on the site.\";s:2:\"id\";s:15:\"cs_social_title\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:1;a:6:{s:4:\"name\";s:16:\"Social icon link\";s:11:\"description\";s:114:\"Please enter your desired link for the social icon. If this field is left\r\n				blank, the icon will not be linked.\";s:2:\"id\";s:14:\"cs_social_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"link\";s:7:\"options\";a:2:{s:6:\"_blank\";s:10:\"New window\";s:5:\"_self\";s:11:\"Same window\";}}i:2;a:5:{s:4:\"name\";s:28:\"Social icon Background color\";s:11:\"description\";s:126:\"Select a background color for the icon (if you selected <strong>Colored</strong> or <strong>Colored on hover</strong> options)\";s:2:\"id\";s:15:\"cs_social_color\";s:3:\"std\";s:4:\"#000\";s:4:\"type\";s:11:\"colorpicker\";}i:3;a:6:{s:4:\"name\";s:11:\"Social icon\";s:11:\"description\";s:32:\"Select your desired social icon.\";s:2:\"id\";s:14:\"cs_social_icon\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:9:\"icon_list\";s:5:\"class\";s:7:\"zn_full\";}}s:10:\"dependency\";a:2:{s:7:\"element\";s:9:\"cs_enable\";s:5:\"value\";a:1:{i:0;s:3:\"yes\";}}}i:344;a:7:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"cmso_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:345;a:7:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:249:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#7-u8q7VwPaA\" target=\"_blank\">Click here to access the video tutorial for this section\'s options.</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:346;a:7:{s:4:\"slug\";s:19:\"coming_soon_options\";s:6:\"parent\";s:19:\"coming_soon_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:347;a:8:{s:4:\"slug\";s:14:\"zn_404_options\";s:6:\"parent\";s:14:\"zn_404_options\";s:4:\"name\";s:13:\"404 page type\";s:11:\"description\";s:62:\"Select what type of content you want to display as a 404 page.\";s:2:\"id\";s:16:\"404_content_type\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{s:0:\"\";s:45:\"Standard ( will display header and 404 word )\";s:11:\"pb_template\";s:22:\"Pagebuilder Smart Area\";}}i:348;a:8:{s:4:\"slug\";s:14:\"zn_404_options\";s:6:\"parent\";s:14:\"zn_404_options\";s:2:\"id\";s:14:\"404_smart_area\";s:4:\"name\";s:29:\"Select Pagebuilder Smart Area\";s:11:\"description\";s:99:\"Using this option you can select a pre-built template made at Admin > Pagebuilder Smart Areas page.\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:1:{s:0:\"\";s:25:\"-- Select a smart area --\";}s:10:\"dependency\";a:1:{i:0;a:2:{s:7:\"element\";s:16:\"404_content_type\";s:5:\"value\";a:1:{i:0;s:11:\"pb_template\";}}}}i:349;a:10:{s:4:\"slug\";s:14:\"zn_404_options\";s:6:\"parent\";s:14:\"zn_404_options\";s:4:\"name\";s:12:\"Header Style\";s:11:\"description\";s:150:\"Select the background style you want to use.Please note that the styles can be created from the \"Unlimited Headers\" options in the theme admin\'s page.\";s:2:\"id\";s:16:\"404_header_style\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:2:{i:0;s:4:\"None\";s:19:\"zn_def_header_style\";s:13:\"Default style\";}s:5:\"class\";s:0:\"\";s:10:\"dependency\";a:1:{i:0;a:2:{s:7:\"element\";s:16:\"404_content_type\";s:5:\"value\";a:1:{i:0;s:0:\"\";}}}}i:350;a:7:{s:4:\"slug\";s:14:\"zn_404_options\";s:6:\"parent\";s:14:\"zn_404_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:11:\"zn404_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:351;a:7:{s:4:\"slug\";s:14:\"zn_404_options\";s:6:\"parent\";s:14:\"zn_404_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:352;a:7:{s:4:\"slug\";s:16:\"advanced_options\";s:6:\"parent\";s:16:\"advanced_options\";s:2:\"id\";s:13:\"font_uploader\";s:4:\"name\";s:18:\"Icon Font uploader\";s:11:\"description\";s:88:\"Please select a zip archive containing the font (generate it using http://fontello.com).\";s:4:\"type\";s:6:\"upload\";s:8:\"supports\";a:2:{s:14:\"file_extension\";s:3:\"zip\";s:9:\"file_type\";s:41:\"application/octet-stream, application/zip\";}}i:353;a:7:{s:4:\"slug\";s:16:\"advanced_options\";s:6:\"parent\";s:16:\"advanced_options\";s:2:\"id\";s:13:\"zn_refresh_pb\";s:4:\"name\";s:19:\"Clear Kallyas Cache\";s:11:\"description\";s:156:\"If you have made changes to the theme\'s page builder folder or files, you will need to press this button in order to refresh their css and folder structure.\";s:4:\"type\";s:12:\"zn_ajax_call\";s:15:\"ajax_call_setup\";a:2:{s:6:\"action\";s:13:\"zn_refresh_pb\";s:11:\"button_text\";s:19:\"Clear Kallyas Cache\";}}i:354;a:7:{s:4:\"slug\";s:16:\"advanced_options\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:10:\"advo_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:355;a:7:{s:4:\"slug\";s:16:\"advanced_options\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:201:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#F5bYMHBcHO0\" target=\"_blank\">Icon fonts uploader</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:356;a:7:{s:4:\"slug\";s:16:\"advanced_options\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:357;a:7:{s:4:\"slug\";s:10:\"custom_css\";s:6:\"parent\";s:16:\"advanced_options\";s:2:\"id\";s:10:\"custom_css\";s:4:\"name\";s:10:\"Custom css\";s:11:\"description\";s:66:\"Here you can enter your custom css that will be used by the theme.\";s:4:\"type\";s:10:\"custom_css\";s:5:\"class\";s:7:\"zn_full\";}i:358;a:7:{s:4:\"slug\";s:10:\"custom_css\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:15:\"adv_css_o_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:359;a:7:{s:4:\"slug\";s:10:\"custom_css\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:196:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#d4D9lAV8NEs\" target=\"_blank\">Add custom CSS</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:360;a:7:{s:4:\"slug\";s:10:\"custom_css\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:231:\"<span class=\"dashicons dashicons-format-aside u-v-mid\"></span> Written Documentation: <a href=\"https://my.hogash.com/documentation/adding-custom-css/\" target=\"_blank\">Click here to access documentation for this options section.</a>\";s:2:\"id\";s:9:\"docs_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:361;a:7:{s:4:\"slug\";s:10:\"custom_css\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}i:362;a:8:{s:4:\"slug\";s:9:\"custom_js\";s:6:\"parent\";s:16:\"advanced_options\";s:2:\"id\";s:9:\"custom_js\";s:4:\"name\";s:17:\"Custom Javascript\";s:11:\"description\";s:129:\"Here you can enter your custom javascript that will be added on all pages. <strong>Do NOT include &lt;SCRIPT&gt; tags</strong>!! \";s:4:\"type\";s:9:\"custom_js\";s:11:\"editor_type\";s:10:\"javascript\";s:5:\"class\";s:7:\"zn_full\";}i:363;a:7:{s:4:\"slug\";s:9:\"custom_js\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:59:\"<span class=\"dashicons dashicons-editor-help\"></span> HELP:\";s:11:\"description\";s:91:\"Below you can find quick access to documentation, video documentation or our support forum.\";s:2:\"id\";s:14:\"adv_js_o_title\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:55:\"zn_full zn-custom-title-md zn-top-separator zn-sep-dark\";}i:364;a:7:{s:4:\"slug\";s:19:\"theme_export_import\";s:6:\"parent\";s:16:\"advanced_options\";s:2:\"id\";s:19:\"theme_export_import\";s:4:\"name\";s:33:\"Import / Export the theme options\";s:11:\"description\";s:74:\"Here you can either import or export (Backup / Restore) the theme options.\";s:4:\"type\";s:19:\"theme_import_export\";s:5:\"class\";s:7:\"zn_full\";}i:365;a:7:{s:4:\"slug\";s:9:\"custom_js\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:195:\"<span class=\"dashicons dashicons-video-alt3 u-v-mid\"></span> Video Tutorials: <a href=\"https://my.hogash.com/video_category/kallyas-wordpress-theme/#DIvUKRBQ3BM\" target=\"_blank\">Add custom JS</a>\";s:2:\"id\";s:10:\"video_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:37:\"zn_full zn-admin-helplink zn_nomargin\";}i:366;a:7:{s:4:\"slug\";s:9:\"custom_js\";s:6:\"parent\";s:16:\"advanced_options\";s:4:\"name\";s:908:\"<a href=\"https://my.hogash.com/support/\" target=\"_blank\"  class=\"zn-helplink zn-helplink-support\">Support Dashboard</a> &nbsp; | &nbsp; <a href=\"https://my.hogash.com/docs/\" target=\"_blank\" class=\"zn-helplink zn-helplink-docs\">Kallyas Video Tutorials & Documentation</a> &nbsp; | &nbsp; <a href=\"https://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658\" target=\"_blank\" class=\"zn-helplink zn-helplink-rate stars-yellow\">Rate Kallyas <span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span><span class=\"dashicons dashicons-star-filled\"></span></a> <a class=\"zn-helplink zn-helplink-ratehelp\" href=\"http://hogash.d.pr/11vC3\" target=\"_blank\" data-tooltip=\"How to rate?\"><span class=\"dashicons dashicons-editor-help\"></span></a>\";s:2:\"id\";s:10:\"otherlinks\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"zn_title\";s:5:\"class\";s:56:\"zn_full zn-custom-title-sm zn_nomargin zn-admin-helplink\";}s:15:\"general_options\";a:127:{s:14:\"page_preloader\";s:2:\"no\";s:17:\"page_preloader_bg\";s:7:\"#ffffff\";s:18:\"page_preloader_img\";s:0:\"\";s:13:\"smooth_scroll\";s:2:\"no\";s:17:\"smooth_scroll_osx\";s:2:\"no\";s:13:\"head_position\";s:1:\"1\";s:12:\"header_style\";s:11:\"image_color\";s:18:\"header_style_image\";a:4:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}}s:18:\"header_style_color\";s:19:\"rgba(255,255,255,0)\";s:18:\"header_text_scheme\";s:7:\"default\";s:25:\"sticky_header_style_color\";s:0:\"\";s:25:\"sticky_header_text_scheme\";s:7:\"default\";s:12:\"topbar_style\";s:7:\"default\";s:11:\"topbar_size\";s:7:\"default\";s:15:\"topbar_bg_color\";s:0:\"\";s:18:\"topbar_text_scheme\";s:7:\"default\";s:11:\"topbar_font\";a:1:{s:11:\"font-family\";s:0:\"\";}s:15:\"header_width_v2\";a:9:{s:11:\"breakpoints\";s:1:\"1\";s:2:\"lg\";s:4:\"1170\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:3:\"100\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:3:\"100\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:3:\"100\";s:7:\"unit_xs\";s:1:\"%\";}s:18:\"zn_head_height_enb\";s:7:\"default\";s:14:\"zn_head_height\";s:0:\"\";s:19:\"zn_head_height_rows\";a:4:{s:3:\"top\";s:0:\"\";s:4:\"main\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:6:\"others\";s:1:\"0\";}s:20:\"top_offset_tolerance\";s:0:\"\";s:14:\"head_show_logo\";s:3:\"yes\";s:11:\"logo_upload\";s:64:\"https://modelox.vico.digital/wp-content/uploads/2017/09/logo.png\";s:9:\"logo_size\";s:3:\"yes\";s:16:\"logo_manual_size\";a:2:{s:5:\"width\";s:3:\"125\";s:6:\"height\";s:2:\"55\";}s:11:\"logo_sticky\";s:0:\"\";s:18:\"logo_upload_mobile\";s:0:\"\";s:9:\"logo_font\";a:6:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"36px\";s:11:\"line-height\";s:4:\"40px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:4:\"#000\";s:10:\"font-style\";s:6:\"normal\";}s:10:\"logo_hover\";a:1:{s:5:\"color\";s:7:\"#CD2122\";}s:7:\"logo_bg\";s:0:\"\";s:23:\"infocard_display_status\";s:2:\"no\";s:17:\"infocard_bg_color\";s:7:\"#cd2122\";s:19:\"infocard_text_color\";s:7:\"#ffffff\";s:17:\"infocard_logo_url\";s:0:\"\";s:28:\"infocard_company_description\";s:71:\"Kallyas is an ultra-premium, responsive theme built for today websites.\";s:22:\"infocard_company_phone\";s:17:\"T (212) 555 55 00\";s:22:\"infocard_company_email\";s:21:\"sales@yourwebsite.com\";s:21:\"infocard_company_name\";s:16:\"Your Company LTD\";s:24:\"infocard_company_address\";s:35:\"Street nr 100, 4536534, Chicago, US\";s:18:\"infocard_gmap_link\";s:0:\"\";s:33:\"social_icons_info_card_visibility\";s:3:\"yes\";s:16:\"infocard_hoverme\";s:3:\"yes\";s:16:\"zn_header_layout\";s:7:\"style13\";s:11:\"menu_follow\";s:2:\"no\";s:15:\"head_show_flags\";s:1:\"0\";s:16:\"head_flags_style\";s:0:\"\";s:15:\"head_show_login\";s:1:\"0\";s:18:\"head_show_register\";s:1:\"0\";s:16:\"head_show_search\";s:2:\"no\";s:17:\"head_search_style\";s:0:\"\";s:18:\"zn_head_s7_toptext\";s:0:\"\";s:21:\"head_show_support_pnl\";s:3:\"yes\";s:25:\"hidden_panel_content_type\";s:6:\"widget\";s:24:\"hidden_panel_pb_template\";s:0:\"\";s:18:\"hidden_panel_title\";s:0:\"\";s:15:\"hidden_panel_bg\";s:7:\"#F0F0F0\";s:15:\"hidden_panel_fg\";s:7:\"#000000\";s:30:\"social_icons_visibility_status\";s:3:\"yes\";s:22:\"header_which_icons_set\";s:6:\"normal\";s:20:\"zn_header_resp_color\";s:7:\"#ff5969\";s:13:\"head_show_cta\";s:3:\"yes\";s:19:\"head_show_cta_style\";s:6:\"custom\";s:17:\"head_add_cta_link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:17:\"head_set_text_cta\";s:8:\"Shop Now\";s:15:\"wpk_cs_bg_color\";s:7:\"#ff5969\";s:15:\"wpk_cs_fg_color\";s:4:\"#fff\";s:11:\"cta_hide_xs\";s:14:\"zn_dummy_value\";s:8:\"cta_perm\";s:3:\"all\";s:10:\"cta_custom\";a:1:{i:0;a:13:{s:8:\"cta_text\";s:4:\"Shop\";s:8:\"cta_link\";a:3:{s:3:\"url\";s:34:\"https://modelox.vico.digital/shop/\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:9:\"cta_style\";s:30:\"btn-fullcolor btn-custom-color\";s:16:\"cta_custom_color\";s:7:\"#ff5969\";s:20:\"cta_custom_color_hov\";s:7:\"#ff3a4e\";s:8:\"cta_size\";s:0:\"\";s:11:\"cta_corners\";s:12:\"btn--rounded\";s:11:\"button_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";}s:15:\"cta_icon_enable\";s:2:\"no\";s:12:\"cta_icon_pos\";s:6:\"before\";s:8:\"cta_icon\";a:2:{s:6:\"family\";s:0:\"\";s:7:\"unicode\";s:0:\"\";}s:8:\"cta_perm\";s:3:\"all\";s:11:\"cta_hide_xs\";s:14:\"zn_dummy_value\";}}s:15:\"nav_color_theme\";s:0:\"\";s:10:\"menu_style\";s:0:\"\";s:9:\"menu_font\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"14px\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:6:\"normal\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";}s:16:\"menu_font_active\";s:7:\"#ff5969\";s:13:\"menu_font_sub\";a:7:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"14px\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:6:\"normal\";s:14:\"text-transform\";s:0:\"\";}s:19:\"navmain_color_theme\";s:0:\"\";s:16:\"header_res_width\";s:3:\"992\";s:17:\"mobile_menu_theme\";s:5:\"light\";s:12:\"burger_style\";s:4:\"3--s\";s:11:\"burger_anim\";s:5:\"anim1\";s:12:\"burger_color\";s:0:\"\";s:19:\"burger_color_custom\";s:0:\"\";s:19:\"burger_color_sticky\";s:0:\"\";s:19:\"burger_color_mobile\";s:0:\"\";s:16:\"header_topnav_dd\";s:3:\"yes\";s:11:\"footer_show\";s:3:\"yes\";s:16:\"footer_row1_show\";s:3:\"yes\";s:28:\"footer_row1_widget_positions\";s:21:\"{\"3\":[[\"4\",\"4\",\"4\"]]}\";s:16:\"footer_row2_show\";s:3:\"yes\";s:28:\"footer_row2_widget_positions\";s:17:\"{\"2\":[[\"6\",\"6\"]]}\";s:12:\"footer_style\";s:7:\"default\";s:18:\"footer_style_image\";a:4:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}}s:18:\"footer_style_color\";s:4:\"#000\";s:23:\"footer_border_color_top\";s:7:\"#FFFFFF\";s:19:\"footer_border_color\";s:7:\"#484848\";s:18:\"footer_top_padding\";s:2:\"60\";s:11:\"footer_logo\";s:0:\"\";s:14:\"copyright_text\";s:147:\"© 2015. All rights reserved. Buy <a href=\"http://themeforest.net/item/kallyas-responsive-multipurpose-wordpress-theme/4091658/\">Kallyas Theme</a>.\";s:26:\"footer_social_icons_enable\";s:3:\"yes\";s:22:\"footer_which_icons_set\";s:6:\"normal\";s:20:\"zn_disable_subheader\";s:2:\"no\";s:17:\"def_header_bg_new\";a:5:{s:5:\"image\";s:79:\"https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:16:\"def_header_color\";s:7:\"#AAAAAA\";s:11:\"def_grad_bg\";s:1:\"0\";s:18:\"def_header_animate\";s:1:\"0\";s:9:\"def_glare\";s:1:\"0\";s:16:\"def_bottom_style\";s:4:\"none\";s:20:\"bottom_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:21:\"bottom_mask_bg_height\";s:3:\"100\";s:19:\"def_bottom_style_bg\";s:0:\"\";s:16:\"def_header_bread\";s:1:\"0\";s:18:\"def_subh_bread_stl\";s:5:\"black\";s:15:\"def_header_date\";s:1:\"0\";s:23:\"def_subheader_alignment\";s:6:\"center\";s:18:\"def_subh_textcolor\";s:5:\"light\";s:24:\"def_header_custom_height\";s:3:\"380\";s:22:\"def_header_top_padding\";s:3:\"240\";s:16:\"google_analytics\";s:0:\"\";s:15:\"google_maps_key\";s:0:\"\";s:13:\"mailchimp_api\";s:0:\"\";s:16:\"mailchimp_secure\";s:14:\"zn_dummy_value\";s:9:\"rec_theme\";s:5:\"light\";s:11:\"rec_pub_key\";s:0:\"\";s:12:\"rec_priv_key\";s:0:\"\";s:18:\"recaptcha_register\";s:2:\"no\";s:14:\"recaptcha_lang\";s:2:\"en\";s:15:\"zn_option_field\";s:15:\"general_options\";}s:22:\"zn_woocommerce_options\";a:28:{s:16:\"woo_catalog_mode\";s:2:\"no\";s:21:\"show_cart_to_visitors\";s:3:\"yes\";s:20:\"woo_site_search_type\";s:2:\"wp\";s:29:\"woo_single_product_smart_area\";s:11:\"no_template\";s:14:\"woo_sub_header\";s:19:\"zn_def_header_style\";s:19:\"woo_arch_page_title\";s:12:\"OUR PRODUCTS\";s:22:\"woo_arch_page_subtitle\";s:36:\"Shop category here with product list\";s:19:\"woo_hide_small_desc\";s:2:\"no\";s:26:\"woo_show_products_per_page\";s:1:\"9\";s:15:\"woo_num_columns\";s:1:\"3\";s:19:\"zn_use_second_image\";s:3:\"yes\";s:16:\"woo_img_lazyload\";s:2:\"no\";s:15:\"woo_prod_layout\";s:7:\"classic\";s:18:\"woo_cat_image_size\";a:2:{s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"566\";}s:20:\"woo_prod_page_layout\";s:7:\"classic\";s:29:\"zn_override_single_shop_title\";s:14:\"zn_dummy_value\";s:22:\"single_shop_page_title\";s:4:\"Shop\";s:20:\"zn_woo_enable_slider\";s:2:\"no\";s:18:\"zn_woo_enable_zoom\";s:2:\"no\";s:13:\"woo_show_cart\";s:1:\"1\";s:14:\"woo_cart_style\";s:6:\"style2\";s:16:\"woo_pages_layout\";s:7:\"classic\";s:13:\"woo_new_badge\";s:1:\"1\";s:18:\"woo_new_badge_days\";s:1:\"3\";s:14:\"woo_sale_badge\";s:1:\"1\";s:28:\"woo_show_sale_flash_discount\";s:2:\"no\";s:17:\"woo_soldout_badge\";s:2:\"no\";s:15:\"zn_option_field\";s:22:\"zn_woocommerce_options\";}s:16:\"advanced_options\";a:1:{s:15:\"zn_option_field\";s:16:\"advanced_options\";}s:19:\"google_font_options\";a:2:{s:21:\"zn_google_fonts_setup\";a:4:{s:6:\"Roboto\";a:2:{s:11:\"font_family\";s:6:\"Roboto\";s:13:\"font_variants\";a:4:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";i:3;s:3:\"900\";}}s:9:\"Open+Sans\";a:1:{s:11:\"font_family\";s:9:\"Open Sans\";}s:16:\"Playfair+Display\";a:1:{s:11:\"font_family\";s:16:\"Playfair Display\";}s:5:\"Prata\";a:1:{s:11:\"font_family\";s:5:\"Prata\";}}s:15:\"zn_option_field\";s:19:\"google_font_options\";}s:13:\"color_options\";a:14:{s:13:\"zn_main_color\";s:7:\"#ff5969\";s:22:\"zn_main_color_contrast\";s:4:\"#fff\";s:13:\"zn_main_style\";s:5:\"light\";s:21:\"zn_body_def_textcolor\";s:0:\"\";s:22:\"zn_body_def_linkscolor\";s:0:\"\";s:26:\"zn_body_def_linkscolor_hov\";s:0:\"\";s:26:\"zn_body_def_textcolor_dark\";s:7:\"#dcdcdc\";s:27:\"zn_body_def_linkscolor_dark\";s:7:\"#ffffff\";s:31:\"zn_body_def_linkscolor_hov_dark\";s:4:\"#eee\";s:17:\"zn_body_def_color\";s:7:\"#ffffff\";s:15:\"body_back_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:16:\"zn_top_nav_color\";s:0:\"\";s:18:\"zn_top_nav_h_color\";s:0:\"\";s:15:\"zn_option_field\";s:13:\"color_options\";}s:10:\"pb_layouts\";a:7:{s:14:\"pbtmpl_general\";a:6:{s:15:\"header_location\";s:6:\"before\";s:15:\"header_template\";s:11:\"no_template\";s:18:\"subheader_location\";s:6:\"before\";s:18:\"subheader_template\";s:11:\"no_template\";s:15:\"footer_location\";s:7:\"replace\";s:15:\"footer_template\";i:142;}s:11:\"pbtmpl_post\";a:6:{s:15:\"header_location\";s:6:\"before\";s:15:\"header_template\";s:11:\"no_template\";s:18:\"subheader_location\";s:0:\"\";s:18:\"subheader_template\";s:0:\"\";s:15:\"footer_location\";s:0:\"\";s:15:\"footer_template\";s:0:\"\";}s:16:\"pbtmpl_portfolio\";a:6:{s:15:\"header_location\";s:6:\"before\";s:15:\"header_template\";s:11:\"no_template\";s:18:\"subheader_location\";s:0:\"\";s:18:\"subheader_template\";s:0:\"\";s:15:\"footer_location\";s:0:\"\";s:15:\"footer_template\";s:0:\"\";}s:14:\"pbtmpl_product\";a:6:{s:15:\"header_location\";s:6:\"before\";s:15:\"header_template\";s:11:\"no_template\";s:18:\"subheader_location\";s:0:\"\";s:18:\"subheader_template\";s:0:\"\";s:15:\"footer_location\";s:0:\"\";s:15:\"footer_template\";s:0:\"\";}s:15:\"pbtmpl_category\";a:6:{s:15:\"header_location\";s:6:\"before\";s:15:\"header_template\";s:11:\"no_template\";s:18:\"subheader_location\";s:0:\"\";s:18:\"subheader_template\";s:0:\"\";s:15:\"footer_location\";s:0:\"\";s:15:\"footer_template\";s:0:\"\";}s:18:\"pbtmpl_product_cat\";a:6:{s:15:\"header_location\";s:6:\"before\";s:15:\"header_template\";s:11:\"no_template\";s:18:\"subheader_location\";s:0:\"\";s:18:\"subheader_template\";s:0:\"\";s:15:\"footer_location\";s:0:\"\";s:15:\"footer_template\";s:0:\"\";}s:15:\"zn_option_field\";s:10:\"pb_layouts\";}s:18:\"unlimited_sidebars\";a:8:{s:12:\"sidebar_size\";s:1:\"3\";s:15:\"archive_sidebar\";a:2:{s:6:\"layout\";s:10:\"no_sidebar\";s:7:\"sidebar\";s:14:\"defaultsidebar\";}s:12:\"blog_sidebar\";a:2:{s:6:\"layout\";s:10:\"no_sidebar\";s:7:\"sidebar\";s:14:\"defaultsidebar\";}s:14:\"single_sidebar\";a:2:{s:6:\"layout\";s:10:\"no_sidebar\";s:7:\"sidebar\";s:14:\"defaultsidebar\";}s:12:\"page_sidebar\";a:2:{s:6:\"layout\";s:10:\"no_sidebar\";s:7:\"sidebar\";s:14:\"defaultsidebar\";}s:19:\"woo_archive_sidebar\";a:2:{s:6:\"layout\";s:10:\"no_sidebar\";s:7:\"sidebar\";s:14:\"defaultsidebar\";}s:18:\"woo_single_sidebar\";a:2:{s:6:\"layout\";s:13:\"right_sidebar\";s:7:\"sidebar\";s:14:\"defaultsidebar\";}s:15:\"zn_option_field\";s:18:\"unlimited_sidebars\";}s:12:\"font_options\";a:11:{s:7:\"h1_typo\";a:5:{s:11:\"font-family\";s:5:\"Prata\";s:9:\"font-size\";s:4:\"36px\";s:11:\"line-height\";s:4:\"40px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:6:\"normal\";}s:10:\"h1_pgtitle\";s:14:\"zn_dummy_value\";s:7:\"h2_typo\";a:5:{s:11:\"font-family\";s:5:\"Prata\";s:9:\"font-size\";s:4:\"30px\";s:11:\"line-height\";s:4:\"40px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:6:\"normal\";}s:7:\"h3_typo\";a:5:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"40px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:6:\"normal\";}s:7:\"h4_typo\";a:5:{s:11:\"font-family\";s:5:\"Prata\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"20px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:6:\"normal\";}s:7:\"h5_typo\";a:5:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"12px\";s:11:\"line-height\";s:4:\"20px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:6:\"normal\";}s:7:\"h6_typo\";a:5:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"12px\";s:11:\"line-height\";s:4:\"20px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:6:\"normal\";}s:9:\"body_font\";a:4:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"13px\";s:11:\"line-height\";s:0:\"\";s:5:\"color\";s:0:\"\";}s:11:\"footer_font\";a:4:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"13px\";s:11:\"line-height\";s:0:\"\";s:5:\"color\";s:0:\"\";}s:16:\"alternative_font\";a:1:{s:11:\"font-family\";s:0:\"\";}s:15:\"zn_option_field\";s:12:\"font_options\";}}', 'yes'),
 (162, 'znb_css_compiled', '1', 'yes'),
 (163, 'kallyas_version', '4.17.5', 'no'),
 (164, 'znhgtfw_first_install_kallyas', '1', 'no'),
 (290, 'revslider-library-check', '1597070494', 'yes'),
 (291, 'revslider-library-hash', '182cddf4eb7341b26304629033cbbb48', 'yes'),
 (292, 'rs-library', 'a:3:{s:4:\"hash\";s:32:\"182cddf4eb7341b26304629033cbbb48\";s:7:\"objects\";a:417:{i:529;a:14:{s:2:\"id\";s:3:\"529\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Fitness-4.jpg\";s:5:\"video\";s:13:\"Fitness-4.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Fitness 4 \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:46:50\";s:6:\"active\";s:1:\"1\";}i:528;a:14:{s:2:\"id\";s:3:\"528\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Fitness-3.jpg\";s:5:\"video\";s:13:\"Fitness-3.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Fitness 3 \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:46:50\";s:6:\"active\";s:1:\"1\";}i:527;a:14:{s:2:\"id\";s:3:\"527\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Chess.jpg\";s:5:\"video\";s:9:\"Chess.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Chess \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:46:50\";s:6:\"active\";s:1:\"1\";}i:526;a:14:{s:2:\"id\";s:3:\"526\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Fitness-2.jpg\";s:5:\"video\";s:13:\"Fitness-2.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Fitness 2 \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:46:50\";s:6:\"active\";s:1:\"1\";}i:525;a:14:{s:2:\"id\";s:3:\"525\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Fitness.jpg\";s:5:\"video\";s:11:\"Fitness.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Fitness \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:46:50\";s:6:\"active\";s:1:\"1\";}i:524;a:14:{s:2:\"id\";s:3:\"524\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Earth.jpg\";s:5:\"video\";s:9:\"Earth.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Earth \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"29\";s:6:\"handle\";s:5:\"space\";s:4:\"name\";s:5:\"Space\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:44:06\";s:6:\"active\";s:1:\"1\";}i:523;a:14:{s:2:\"id\";s:3:\"523\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Space-2.jpg\";s:5:\"video\";s:11:\"Space-2.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Space 2 \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"29\";s:6:\"handle\";s:5:\"space\";s:4:\"name\";s:5:\"Space\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1440\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:44:06\";s:6:\"active\";s:1:\"1\";}i:522;a:14:{s:2:\"id\";s:3:\"522\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Asteroids.jpg\";s:5:\"video\";s:13:\"Asteroids.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Asteroids \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"29\";s:6:\"handle\";s:5:\"space\";s:4:\"name\";s:5:\"Space\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:44:06\";s:6:\"active\";s:1:\"1\";}i:521;a:14:{s:2:\"id\";s:3:\"521\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Space.jpg\";s:5:\"video\";s:9:\"Space.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Space \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"29\";s:6:\"handle\";s:5:\"space\";s:4:\"name\";s:5:\"Space\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:44:06\";s:6:\"active\";s:1:\"1\";}i:520;a:14:{s:2:\"id\";s:3:\"520\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:10:\"People.jpg\";s:5:\"video\";s:10:\"People.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"People \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:42:16\";s:6:\"active\";s:1:\"1\";}i:519;a:14:{s:2:\"id\";s:3:\"519\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Walking.jpg\";s:5:\"video\";s:11:\"Walking.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Walking \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:42:16\";s:6:\"active\";s:1:\"1\";}i:518;a:14:{s:2:\"id\";s:3:\"518\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:19:\"Double-Exposure.jpg\";s:5:\"video\";s:19:\"Double-Exposure.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Double Exposure \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:42:16\";s:6:\"active\";s:1:\"1\";}i:517;a:14:{s:2:\"id\";s:3:\"517\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:8:\"Girl.jpg\";s:5:\"video\";s:8:\"Girl.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Girl \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1088\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:42:16\";s:6:\"active\";s:1:\"1\";}i:516;a:14:{s:2:\"id\";s:3:\"516\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:17:\"Bengal-Lights.jpg\";s:5:\"video\";s:17:\"Bengal-Lights.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Bengal Lights \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:42:16\";s:6:\"active\";s:1:\"1\";}i:515;a:14:{s:2:\"id\";s:3:\"515\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Swiping-2.jpg\";s:5:\"video\";s:13:\"Swiping-2.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Swiping 2 \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:514;a:14:{s:2:\"id\";s:3:\"514\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Mock-Up.jpg\";s:5:\"video\";s:11:\"Mock-Up.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Mock Up \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:513;a:14:{s:2:\"id\";s:3:\"513\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Countdown.jpg\";s:5:\"video\";s:13:\"Countdown.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Countdown \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:512;a:14:{s:2:\"id\";s:3:\"512\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:18:\"Wall-Sketching.jpg\";s:5:\"video\";s:18:\"Wall-Sketching.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Wall Sketching \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:511;a:14:{s:2:\"id\";s:3:\"511\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:26:\"Typing-on-the-keyboard.jpg\";s:5:\"video\";s:26:\"Typing-on-the-keyboard.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Typing on the keyboard \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:510;a:14:{s:2:\"id\";s:3:\"510\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Meeting.jpg\";s:5:\"video\";s:11:\"Meeting.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Meeting \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:509;a:14:{s:2:\"id\";s:3:\"509\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Swiping.jpg\";s:5:\"video\";s:11:\"Swiping.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Swiping \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:508;a:14:{s:2:\"id\";s:3:\"508\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Alarm.jpg\";s:5:\"video\";s:9:\"Alarm.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Alarm \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1013\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:507;a:14:{s:2:\"id\";s:3:\"507\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Hey-World.jpg\";s:5:\"video\";s:13:\"Hey-World.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Hey World \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:506;a:14:{s:2:\"id\";s:3:\"506\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:28:\"Typing-on-the-keyboard-2.jpg\";s:5:\"video\";s:28:\"Typing-on-the-keyboard-2.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:25:\"Typing on the keyboard 2 \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:39:19\";s:6:\"active\";s:1:\"1\";}i:505;a:14:{s:2:\"id\";s:3:\"505\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:10:\"Valley.jpg\";s:5:\"video\";s:10:\"Valley.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Valley \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:35:27\";s:6:\"active\";s:1:\"1\";}i:504;a:14:{s:2:\"id\";s:3:\"504\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Stars.jpg\";s:5:\"video\";s:9:\"Stars.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Stars \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:35:27\";s:6:\"active\";s:1:\"1\";}i:503;a:14:{s:2:\"id\";s:3:\"503\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:21:\"Car-in-the-forest.jpg\";s:5:\"video\";s:21:\"Car-in-the-forest.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Car in the forest \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1012\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:35:27\";s:6:\"active\";s:1:\"1\";}i:502;a:14:{s:2:\"id\";s:3:\"502\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:15:\"Aerial-Shot.jpg\";s:5:\"video\";s:15:\"Aerial-Shot.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Aerial Shot \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:35:27\";s:6:\"active\";s:1:\"1\";}i:501;a:14:{s:2:\"id\";s:3:\"501\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:14:\"Disco-Ball.jpg\";s:5:\"video\";s:14:\"Disco-Ball.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Disco Ball \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:33:16\";s:6:\"active\";s:1:\"1\";}i:500;a:14:{s:2:\"id\";s:3:\"500\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:22:\"Man-Playing-Guitar.jpg\";s:5:\"video\";s:22:\"Man-Playing-Guitar.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Man Playing Guitar \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:33:16\";s:6:\"active\";s:1:\"1\";}i:499;a:14:{s:2:\"id\";s:3:\"499\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:14:\"Live-Music.jpg\";s:5:\"video\";s:14:\"Live-Music.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Live Music \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:33:16\";s:6:\"active\";s:1:\"1\";}i:498;a:14:{s:2:\"id\";s:3:\"498\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:12:\"Cheer-Up.jpg\";s:5:\"video\";s:12:\"Cheer-Up.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Cheer Up \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:33:16\";s:6:\"active\";s:1:\"1\";}i:497;a:14:{s:2:\"id\";s:3:\"497\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:14:\"Night-club.jpg\";s:5:\"video\";s:14:\"Night-club.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Night club \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:33:16\";s:6:\"active\";s:1:\"1\";}i:496;a:14:{s:2:\"id\";s:3:\"496\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:17:\"Cup-Of-Coffee.jpg\";s:5:\"video\";s:17:\"Cup-Of-Coffee.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Cup Of Coffee \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:30:48\";s:6:\"active\";s:1:\"1\";}i:495;a:14:{s:2:\"id\";s:3:\"495\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:7:\"Pot.jpg\";s:5:\"video\";s:7:\"Pot.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:4:\"Pot \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:30:48\";s:6:\"active\";s:1:\"1\";}i:494;a:14:{s:2:\"id\";s:3:\"494\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Grill-2.jpg\";s:5:\"video\";s:11:\"Grill-2.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Grill 2 \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:30:48\";s:6:\"active\";s:1:\"1\";}i:493;a:14:{s:2:\"id\";s:3:\"493\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Rice-Bowl.jpg\";s:5:\"video\";s:13:\"Rice-Bowl.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Rice Bowl \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1010\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:30:48\";s:6:\"active\";s:1:\"1\";}i:492;a:14:{s:2:\"id\";s:3:\"492\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Grill.jpg\";s:5:\"video\";s:9:\"Grill.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Grill \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:30:48\";s:6:\"active\";s:1:\"1\";}i:491;a:14:{s:2:\"id\";s:3:\"491\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Water.jpg\";s:5:\"video\";s:9:\"Water.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Water \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:24:15\";s:6:\"active\";s:1:\"1\";}i:490;a:14:{s:2:\"id\";s:3:\"490\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:17:\"Feet-and-Sand.jpg\";s:5:\"video\";s:17:\"Feet-and-Sand.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Feet and Sand \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:24:15\";s:6:\"active\";s:1:\"1\";}i:489;a:14:{s:2:\"id\";s:3:\"489\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Ocean.jpg\";s:5:\"video\";s:9:\"Ocean.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Ocean \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:24:15\";s:6:\"active\";s:1:\"1\";}i:488;a:14:{s:2:\"id\";s:3:\"488\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Waves.jpg\";s:5:\"video\";s:9:\"Waves.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Waves \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:24:15\";s:6:\"active\";s:1:\"1\";}i:487;a:14:{s:2:\"id\";s:3:\"487\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:10:\"Hearts.jpg\";s:5:\"video\";s:10:\"Hearts.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Hearts \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:486;a:14:{s:2:\"id\";s:3:\"486\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:12:\"Octagons.jpg\";s:5:\"video\";s:12:\"Octagons.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Octagons \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:485;a:14:{s:2:\"id\";s:3:\"485\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:11:\"Squares.jpg\";s:5:\"video\";s:11:\"Squares.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Squares \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:484;a:14:{s:2:\"id\";s:3:\"484\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:12:\"Pink-ink.jpg\";s:5:\"video\";s:12:\"Pink-ink.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Pink ink \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:483;a:14:{s:2:\"id\";s:3:\"483\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:22:\"Blurred-Background.jpg\";s:5:\"video\";s:22:\"Blurred-Background.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Blurred Background \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:482;a:14:{s:2:\"id\";s:3:\"482\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:20:\"Blinking-bubbles.jpg\";s:5:\"video\";s:20:\"Blinking-bubbles.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Blinking bubbles \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:481;a:14:{s:2:\"id\";s:3:\"481\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:13:\"Fireworks.jpg\";s:5:\"video\";s:13:\"Fireworks.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Fireworks \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:480;a:14:{s:2:\"id\";s:3:\"480\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:12:\"Dark-ink.jpg\";s:5:\"video\";s:12:\"Dark-ink.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Dark ink \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-23 11:20:38\";s:6:\"active\";s:1:\"1\";}i:479;a:13:{s:2:\"id\";s:3:\"479\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:31:\"Tram-beside-waiting-station.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:27:\"Tram beside waiting station\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1450\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:52:06\";s:6:\"active\";s:1:\"1\";}i:478;a:13:{s:2:\"id\";s:3:\"478\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Pulling-up.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Pulling up\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1297\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:41:20\";s:6:\"active\";s:1:\"1\";}i:477;a:13:{s:2:\"id\";s:3:\"477\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Snowboarding.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Snowboarding\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1290\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:41:20\";s:6:\"active\";s:1:\"1\";}i:476;a:13:{s:2:\"id\";s:3:\"476\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Morning-yoga.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Morning yoga\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1346\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:40:23\";s:6:\"active\";s:1:\"1\";}i:475;a:13:{s:2:\"id\";s:3:\"475\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:8:\"Yoga.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:4:\"Yoga\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1079\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:40:23\";s:6:\"active\";s:1:\"1\";}i:474;a:13:{s:2:\"id\";s:3:\"474\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Golf-balls.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Golf balls\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:40:23\";s:6:\"active\";s:1:\"1\";}i:473;a:13:{s:2:\"id\";s:3:\"473\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"Confident-Boxer.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Confident Boxer\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:40:23\";s:6:\"active\";s:1:\"1\";}i:472;a:13:{s:2:\"id\";s:3:\"472\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:11:\"Aerobic.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Aerobic\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:40:23\";s:6:\"active\";s:1:\"1\";}i:471;a:13:{s:2:\"id\";s:3:\"471\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Riding-bicycle.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Riding bicycle\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1358\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:470;a:13:{s:2:\"id\";s:3:\"470\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:27:\"woman-with-barbell-back.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"woman with barbell back\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:469;a:13:{s:2:\"id\";s:3:\"469\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:24:\"Woman-lying-on-floor.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Woman lying on floor\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1318\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:468;a:13:{s:2:\"id\";s:3:\"468\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:27:\"Holding-black-dumbbells.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Holding black dumbbells\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1275\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:467;a:13:{s:2:\"id\";s:3:\"467\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:25:\"Woman-using-dumbbells.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Woman using dumbbells\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1425\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:466;a:13:{s:2:\"id\";s:3:\"466\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Soccer-cleat.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Soccer cleat\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:465;a:13:{s:2:\"id\";s:3:\"465\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Soccer-field.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Soccer field\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:464;a:13:{s:2:\"id\";s:3:\"464\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"Man-tying-his-shoes.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Man tying his shoes\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1200\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:463;a:13:{s:2:\"id\";s:3:\"463\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:10:\"Boxing.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Boxing\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:462;a:13:{s:2:\"id\";s:3:\"462\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:22:\"woman-with-barbell.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"woman with barbell\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:461;a:13:{s:2:\"id\";s:3:\"461\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:12:\"Crossfit.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Crossfit\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:460;a:13:{s:2:\"id\";s:3:\"460\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:25:\"Man-and-woman-jogging.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Man and woman jogging\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:459;a:13:{s:2:\"id\";s:3:\"459\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Playing-golf.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Playing golf\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:458;a:13:{s:2:\"id\";s:3:\"458\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Surfer-in-wave.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Surfer in wave\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:457;a:13:{s:2:\"id\";s:3:\"457\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:25:\"Woman-lifting-barbell.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Woman lifting barbell\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:456;a:13:{s:2:\"id\";s:3:\"456\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Stretching.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Stretching\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1277\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:455;a:13:{s:2:\"id\";s:3:\"455\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Snowboarding-2.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Snowboarding 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:454;a:13:{s:2:\"id\";s:3:\"454\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:11:\"Balance.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Balance\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1920\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:453;a:13:{s:2:\"id\";s:3:\"453\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"Pool-meditation.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Pool meditation\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:452;a:13:{s:2:\"id\";s:3:\"452\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Soccer-stadium.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Soccer stadium\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:451;a:13:{s:2:\"id\";s:3:\"451\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:25:\"Soccer-field-top-view.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Soccer field top view\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:450;a:13:{s:2:\"id\";s:3:\"450\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Basketball.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Basketball\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:449;a:13:{s:2:\"id\";s:3:\"449\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"in-the-fog.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"in the fog\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:448;a:13:{s:2:\"id\";s:3:\"448\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:13:\"Handstand.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Handstand\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1079\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:38:24\";s:6:\"active\";s:1:\"1\";}i:447;a:13:{s:2:\"id\";s:3:\"447\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:11:\"Friends.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Friends\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:446;a:13:{s:2:\"id\";s:3:\"446\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:28:\"Sneakers-on-the-railroad.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:24:\"Sneakers on the railroad\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:445;a:13:{s:2:\"id\";s:3:\"445\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"Family-on-the-ocean.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Family on the ocean\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:444;a:13:{s:2:\"id\";s:3:\"444\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:10:\"Sunset.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Sunset\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:443;a:13:{s:2:\"id\";s:3:\"443\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:9:\"Books.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Books\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1275\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:442;a:13:{s:2:\"id\";s:3:\"442\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:25:\"Looking-at-the-window.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Looking at the window\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:441;a:13:{s:2:\"id\";s:3:\"441\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:48:\"woman-standing-near-buildings-during-daytime.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:44:\"woman standing near buildings during daytime\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1278\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:440;a:13:{s:2:\"id\";s:3:\"440\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:12:\"Lollipop.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Lollipop\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1395\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:439;a:13:{s:2:\"id\";s:3:\"439\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:26:\"People-crossing-street.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:22:\"People crossing street\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1278\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:438;a:13:{s:2:\"id\";s:3:\"438\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:24:\"Friends-on-the-shore.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Friends on the shore\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:437;a:13:{s:2:\"id\";s:3:\"437\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:13:\"Coworkers.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Coworkers\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:436;a:13:{s:2:\"id\";s:3:\"436\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:27:\"Hiking-in-the-Dolomites.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Hiking in the Dolomites\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:435;a:13:{s:2:\"id\";s:3:\"435\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Successful-man.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Successful man\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:434;a:13:{s:2:\"id\";s:3:\"434\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"Beautiful-sunny-day.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Beautiful sunny day\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:433;a:13:{s:2:\"id\";s:3:\"433\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:8:\"Guys.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:4:\"Guys\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:432;a:13:{s:2:\"id\";s:3:\"432\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"Confetti-Shower.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Confetti Shower\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:431;a:13:{s:2:\"id\";s:3:\"431\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:24:\"Sun-was-setting-down.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Sun was setting down\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:430;a:13:{s:2:\"id\";s:3:\"430\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:9:\"Jumps.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Jumps\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:429;a:13:{s:2:\"id\";s:3:\"429\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"Friends-by-the-fire.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Friends by the fire\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:428;a:13:{s:2:\"id\";s:3:\"428\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:21:\"Under-the-blanket.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Under the blanket\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1413\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:427;a:13:{s:2:\"id\";s:3:\"427\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Pretty-in-Pink.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Pretty in Pink\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1394\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:426;a:13:{s:2:\"id\";s:3:\"426\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:31:\"Discussions-at-a-long-table.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:27:\"Discussions at a long table\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1268\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:425;a:13:{s:2:\"id\";s:3:\"425\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Lost-in-Lemons.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Lost in Lemons\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:424;a:13:{s:2:\"id\";s:3:\"424\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:13:\"Team-work.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Team work\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1281\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:423;a:13:{s:2:\"id\";s:3:\"423\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:20:\"Romantic-evening.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Romantic evening\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1263\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:36:58\";s:6:\"active\";s:1:\"1\";}i:422;a:13:{s:2:\"id\";s:3:\"422\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"Crew-collective.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Crew collective\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1278\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:421;a:13:{s:2:\"id\";s:3:\"421\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:8:\"Code.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:4:\"Code\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:420;a:13:{s:2:\"id\";s:3:\"420\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:48:\"Yellow-ceramic-mug-beside-gray-aluminum-iMac.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:44:\"Yellow ceramic mug beside gray aluminum iMac\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:419;a:13:{s:2:\"id\";s:3:\"419\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:11:\"My-desk.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"My desk\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1315\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:418;a:13:{s:2:\"id\";s:3:\"418\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"Cooperation-2.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Cooperation 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:417;a:13:{s:2:\"id\";s:3:\"417\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:33:\"MacBook-on-top-of-brown-table.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:29:\"MacBook on top of brown table\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:416;a:13:{s:2:\"id\";s:3:\"416\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:27:\"Beautiful-working-place.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Beautiful working place\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:415;a:13:{s:2:\"id\";s:3:\"415\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Typewriter.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Typewriter\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:414;a:13:{s:2:\"id\";s:3:\"414\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"White-desk-lamp.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"White desk lamp\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:413;a:13:{s:2:\"id\";s:3:\"413\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Office-working.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Office working\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:412;a:13:{s:2:\"id\";s:3:\"412\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:36:\"Silver-iMac-on-brown-wooden-desk.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:32:\"Silver iMac on brown wooden desk\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1240\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:411;a:13:{s:2:\"id\";s:3:\"411\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"Working-in-progress.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Working in progress\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:410;a:13:{s:2:\"id\";s:3:\"410\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"Cooperation.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Cooperation\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:409;a:13:{s:2:\"id\";s:3:\"409\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"Working-place.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Working place\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1281\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:408;a:13:{s:2:\"id\";s:3:\"408\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Working-desk.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Working desk\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:33:11\";s:6:\"active\";s:1:\"1\";}i:407;a:13:{s:2:\"id\";s:3:\"407\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"low-angle-of-forest.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"low angle of forest\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:406;a:13:{s:2:\"id\";s:3:\"406\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"Lake-under-blue-sky.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Lake under blue sky\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1351\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:405;a:13:{s:2:\"id\";s:3:\"405\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:21:\"Blue-starry-night.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Blue starry night\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:404;a:13:{s:2:\"id\";s:3:\"404\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:22:\"Aerial-photography.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Aerial photography\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:403;a:13:{s:2:\"id\";s:3:\"403\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Red-clouds.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Red clouds\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:402;a:13:{s:2:\"id\";s:3:\"402\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Snow-field.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Snow field\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1227\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:401;a:13:{s:2:\"id\";s:3:\"401\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:13:\"White-sky.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"White sky\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1281\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:400;a:13:{s:2:\"id\";s:3:\"400\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:24:\"Trees-covered-by-fog.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Trees covered by fog\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1277\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:399;a:13:{s:2:\"id\";s:3:\"399\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:26:\"Red-and-white-mushroom.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:22:\"Red and white mushroom\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:398;a:13:{s:2:\"id\";s:3:\"398\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:24:\"Lake-near-pine-trees.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Lake near pine trees\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:397;a:13:{s:2:\"id\";s:3:\"397\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:35:\"After-a-long-day-of-backpacking.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:31:\"After a long day of backpacking\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:396;a:13:{s:2:\"id\";s:3:\"396\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:32:\"Mountains-during-golden-hour.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:28:\"Mountains during golden hour\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:395;a:13:{s:2:\"id\";s:3:\"395\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:27:\"Man-looking-on-mountain.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Man looking on mountain\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:394;a:13:{s:2:\"id\";s:3:\"394\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"Body-of-water-2.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Body of water 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:393;a:13:{s:2:\"id\";s:3:\"393\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"Brown-cliff.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Brown cliff\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:392;a:13:{s:2:\"id\";s:3:\"392\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:20:\"Green-foggy-tree.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Green foggy tree\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1417\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:391;a:13:{s:2:\"id\";s:3:\"391\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:32:\"Grayscale-photo-of-mountains.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:28:\"Grayscale photo of mountains\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:390;a:13:{s:2:\"id\";s:3:\"390\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"Under-sunny-sky.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Under sunny sky\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:31:55\";s:6:\"active\";s:1:\"1\";}i:389;a:13:{s:2:\"id\";s:3:\"389\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Rock-concert.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Rock concert\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1443\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:388;a:13:{s:2:\"id\";s:3:\"388\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:30:\"Group-of-people-in-concert.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:26:\"Group of people in concert\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:387;a:13:{s:2:\"id\";s:3:\"387\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:6:\"DJ.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:2:\"DJ\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:386;a:13:{s:2:\"id\";s:3:\"386\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:56:\"Woman-standing-watching-LED-light-musical-instrument.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:52:\"Woman standing watching LED light musical instrument\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:385;a:13:{s:2:\"id\";s:3:\"385\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Concert-hall.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Concert hall\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:384;a:13:{s:2:\"id\";s:3:\"384\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Concert-hall-2.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Concert hall 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:383;a:13:{s:2:\"id\";s:3:\"383\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:29:\"man-playing-upright-piano.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:25:\"man playing upright piano\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1340\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:382;a:13:{s:2:\"id\";s:3:\"382\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:30:\"person-performing-on-stage.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:26:\"person performing on stage\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:381;a:13:{s:2:\"id\";s:3:\"381\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:27:\"Brown-string-instrument.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Brown string instrument\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1272\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:380;a:13:{s:2:\"id\";s:3:\"380\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:36:\"silhouette-of-person-with-guitar.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:32:\"silhouette of person with guitar\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:379;a:13:{s:2:\"id\";s:3:\"379\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Party-fans.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Party fans\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:378;a:13:{s:2:\"id\";s:3:\"378\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:24:\"Condenser-microphone.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Condenser microphone\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:25:26\";s:6:\"active\";s:1:\"1\";}i:377;a:13:{s:2:\"id\";s:3:\"377\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:42:\"Low-angle-photo-of-high-rise-buildings.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:38:\"Low angle photo of high rise buildings\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:376;a:13:{s:2:\"id\";s:3:\"376\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"High-rise-buildings.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"High rise buildings\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:375;a:13:{s:2:\"id\";s:3:\"375\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Cable-bridge.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Cable bridge\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1272\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:374;a:13:{s:2:\"id\";s:3:\"374\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:35:\"Bokeh-effect-from-street-lights.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:31:\"Bokeh effect from street lights\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:373;a:13:{s:2:\"id\";s:3:\"373\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Low-angle-view.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Low angle view\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:372;a:13:{s:2:\"id\";s:3:\"372\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:21:\"Double-decker-bus.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Double decker bus\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1373\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:371;a:13:{s:2:\"id\";s:3:\"371\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:32:\"Buildings-near-body-of-water.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:28:\"Buildings near body of water\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1370\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:370;a:13:{s:2:\"id\";s:3:\"370\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Satellite-view.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Satellite view\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1278\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:369;a:13:{s:2:\"id\";s:3:\"369\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Twin-Tower.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Twin Tower\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:368;a:13:{s:2:\"id\";s:3:\"368\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:22:\"Two-person-walking.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Two person walking\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1345\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:367;a:13:{s:2:\"id\";s:3:\"367\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"Sears-Tower.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Sears Tower\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:366;a:13:{s:2:\"id\";s:3:\"366\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"Night-cityscape.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Night cityscape\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:365;a:13:{s:2:\"id\";s:3:\"365\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:25:\"Empire-State-Building.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Empire State Building\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:364;a:13:{s:2:\"id\";s:3:\"364\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:9:\"Paris.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Paris\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:363;a:13:{s:2:\"id\";s:3:\"363\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:31:\"Building-during-golden-hour.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:27:\"Building during golden hour\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1288\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:362;a:13:{s:2:\"id\";s:3:\"362\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:21:\"Afternoon-skyline.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Afternoon skyline\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:361;a:13:{s:2:\"id\";s:3:\"361\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:22:\"Concrete-buildings.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Concrete buildings\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:360;a:13:{s:2:\"id\";s:3:\"360\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:26:\"Architectural-building.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:22:\"Architectural building\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1382\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:359;a:13:{s:2:\"id\";s:3:\"359\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:23:\"Skyline-photography.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Skyline photography\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:358;a:13:{s:2:\"id\";s:3:\"358\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:38:\"People-standing-on-pedestrian-lane.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:34:\"People standing on pedestrian lane\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1154\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:357;a:13:{s:2:\"id\";s:3:\"357\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Burj-Khalifa.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Burj Khalifa\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:356;a:13:{s:2:\"id\";s:3:\"356\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:13:\"Skycraper.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Skycraper\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1281\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:355;a:13:{s:2:\"id\";s:3:\"355\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"Gray-tower.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Gray tower\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1433\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-16 10:24:11\";s:6:\"active\";s:1:\"1\";}i:354;a:13:{s:2:\"id\";s:3:\"354\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:28:\"One-fine-day-in-Maldives.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:24:\"One fine day in Maldives\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1116\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:353;a:13:{s:2:\"id\";s:3:\"353\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:25:\"Boat-on-body-of-water.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Boat on body of water\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:352;a:13:{s:2:\"id\";s:3:\"352\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:33:\"Aerial-photo-of-body-of-water.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:29:\"Aerial photo of body of water\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1078\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:351;a:13:{s:2:\"id\";s:3:\"351\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:31:\"Assorted-color-beach-houses.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:27:\"Assorted color beach houses\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1135\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:350;a:13:{s:2:\"id\";s:3:\"350\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:36:\"Woman-leaning-on-tree-near-beach.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:32:\"Woman leaning on tree near beach\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1559\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:349;a:13:{s:2:\"id\";s:3:\"349\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"Body-of-water.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Body of water\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1269\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:348;a:13:{s:2:\"id\";s:3:\"348\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"People-on-sea.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"People on sea\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1278\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:347;a:13:{s:2:\"id\";s:3:\"347\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:31:\"Man-sitting-beside-of-woman.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:27:\"Man sitting beside of woman\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1277\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:346;a:13:{s:2:\"id\";s:3:\"346\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:22:\"woman-in-the-water.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"woman in the water\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:345;a:13:{s:2:\"id\";s:3:\"345\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:39:\"Brown-stone-near-sea-at-golden-hour.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:35:\"Brown stone near sea at golden hour\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:344;a:13:{s:2:\"id\";s:3:\"344\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Birds-eye-view.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Birds eye view\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1079\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:343;a:13:{s:2:\"id\";s:3:\"343\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"Empty-seashore.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Empty seashore\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1365\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:342;a:13:{s:2:\"id\";s:3:\"342\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:31:\"Seashore-during-golden-hour.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:27:\"Seashore during golden hour\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1439\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:341;a:13:{s:2:\"id\";s:3:\"341\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"Coconut-tree.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Coconut tree\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1278\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:340;a:13:{s:2:\"id\";s:3:\"340\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:37:\"Aerial-photography-of-beach-shore.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:33:\"Aerial photography of beach shore\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1439\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-04-15 14:18:38\";s:6:\"active\";s:1:\"1\";}i:339;a:13:{s:2:\"id\";s:3:\"339\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"best_price_dark.jpg\";s:5:\"video\";s:19:\"best_price_dark.mp4\";s:4:\"name\";s:15:\"best_price_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"best_price_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-26 09:24:35\";s:6:\"active\";s:1:\"1\";}i:337;a:13:{s:2:\"id\";s:3:\"337\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:27:\"limited_time_offer_dark.jpg\";s:5:\"video\";s:27:\"limited_time_offer_dark.mp4\";s:4:\"name\";s:23:\"limited_time_offer_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:23:\"limited_time_offer_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-26 09:24:35\";s:6:\"active\";s:1:\"1\";}i:336;a:13:{s:2:\"id\";s:3:\"336\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:26:\"slider_revolution_dark.jpg\";s:5:\"video\";s:26:\"slider_revolution_dark.mp4\";s:4:\"name\";s:22:\"slider_revolution_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:22:\"slider_revolution_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-26 09:24:35\";s:6:\"active\";s:1:\"1\";}i:335;a:13:{s:2:\"id\";s:3:\"335\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"mick_brown_dark.jpg\";s:5:\"video\";s:19:\"mick_brown_dark.mp4\";s:4:\"name\";s:15:\"mick_brown_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"mick_brown_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-26 09:24:35\";s:6:\"active\";s:1:\"1\";}i:334;a:13:{s:2:\"id\";s:3:\"334\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:14:\"sales_dark.jpg\";s:5:\"video\";s:14:\"sales_dark.mp4\";s:4:\"name\";s:10:\"sales_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:10:\"sales_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-12 08:32:18\";s:6:\"active\";s:1:\"1\";}i:333;a:13:{s:2:\"id\";s:3:\"333\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"robert_smith_dark.jpg\";s:5:\"video\";s:21:\"robert_smith_dark.mp4\";s:4:\"name\";s:17:\"robert_smith_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"robert_smith_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-12 08:32:18\";s:6:\"active\";s:1:\"1\";}i:332;a:13:{s:2:\"id\";s:3:\"332\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"product_name_dark.jpg\";s:5:\"video\";s:21:\"product_name_dark.mp4\";s:4:\"name\";s:17:\"product_name_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"product_name_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-12 08:32:18\";s:6:\"active\";s:1:\"1\";}i:331;a:13:{s:2:\"id\";s:3:\"331\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"high_quality_dark.jpg\";s:5:\"video\";s:21:\"high_quality_dark.mp4\";s:4:\"name\";s:17:\"high_quality_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"high_quality_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-12 08:32:18\";s:6:\"active\";s:1:\"1\";}i:330;a:13:{s:2:\"id\";s:3:\"330\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:24:\"robert_johnson_light.jpg\";s:5:\"video\";s:24:\"robert_johnson_light.mp4\";s:4:\"name\";s:20:\"robert_johnson_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:20:\"robert_johnson_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-12 08:32:18\";s:6:\"active\";s:1:\"1\";}i:329;a:13:{s:2:\"id\";s:3:\"329\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"jake_collins_dark.jpg\";s:5:\"video\";s:21:\"jake_collins_dark.mp4\";s:4:\"name\";s:17:\"jake_collins_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"jake_collins_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-12 08:32:18\";s:6:\"active\";s:1:\"1\";}i:328;a:13:{s:2:\"id\";s:3:\"328\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"daniele_wood_light.jpg\";s:5:\"video\";s:22:\"daniele_wood_light.mp4\";s:4:\"name\";s:18:\"daniele_wood_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:18:\"daniele_wood_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-12 08:31:30\";s:6:\"active\";s:1:\"1\";}i:327;a:13:{s:2:\"id\";s:3:\"327\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:23:\"michael_blake_light.jpg\";s:5:\"video\";s:23:\"michael_blake_light.mp4\";s:4:\"name\";s:19:\"michael_blake_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:19:\"michael_blake_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-05 09:20:21\";s:6:\"active\";s:1:\"1\";}i:326;a:13:{s:2:\"id\";s:3:\"326\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"product_name_light.jpg\";s:5:\"video\";s:22:\"product_name_light.mp4\";s:4:\"name\";s:18:\"product_name_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:18:\"product_name_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-05 09:20:21\";s:6:\"active\";s:1:\"1\";}i:325;a:13:{s:2:\"id\";s:3:\"325\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:24:\"rebecca_cooper_light.jpg\";s:5:\"video\";s:24:\"rebecca_cooper_light.mp4\";s:4:\"name\";s:20:\"rebecca_cooper_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:20:\"rebecca_cooper_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-05 09:20:21\";s:6:\"active\";s:1:\"1\";}i:324;a:13:{s:2:\"id\";s:3:\"324\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:28:\"limited_time_offer_light.jpg\";s:5:\"video\";s:28:\"limited_time_offer_light.mp4\";s:4:\"name\";s:24:\"limited_time_offer_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:24:\"limited_time_offer_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-05 09:20:21\";s:6:\"active\";s:1:\"1\";}i:322;a:13:{s:2:\"id\";s:3:\"322\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"jake_michael_light.jpg\";s:5:\"video\";s:22:\"jake_michael_light.mp4\";s:4:\"name\";s:18:\"jake_michael_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:18:\"jake_michael_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-05 09:20:21\";s:6:\"active\";s:1:\"1\";}i:321;a:13:{s:2:\"id\";s:3:\"321\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:23:\"colin_johnson_light.jpg\";s:5:\"video\";s:23:\"colin_johnson_light.mp4\";s:4:\"name\";s:19:\"colin_johnson_light\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:19:\"colin_johnson_light\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-03-05 09:20:21\";s:6:\"active\";s:1:\"1\";}i:320;a:13:{s:2:\"id\";s:3:\"320\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"colin_morris_dark.jpg\";s:5:\"video\";s:21:\"colin_morris_dark.mp4\";s:4:\"name\";s:17:\"colin_morris_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"colin_morris_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:319;a:13:{s:2:\"id\";s:3:\"319\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"justin_cooper_dark.jpg\";s:5:\"video\";s:22:\"justin_cooper_dark.mp4\";s:4:\"name\";s:18:\"justin_cooper_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:18:\"justin_cooper_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:318;a:13:{s:2:\"id\";s:3:\"318\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"james-dodson_dark.jpg\";s:5:\"video\";s:21:\"james-dodson_dark.mp4\";s:4:\"name\";s:17:\"james-dodson_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"james-dodson_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:317;a:13:{s:2:\"id\";s:3:\"317\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:23:\"robert_sanders_dark.jpg\";s:5:\"video\";s:23:\"robert_sanders_dark.mp4\";s:4:\"name\";s:19:\"robert_sanders_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:19:\"robert_sanders_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:316;a:13:{s:2:\"id\";s:3:\"316\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"emily_carney_dark.jpg\";s:5:\"video\";s:21:\"emily_carney_dark.mp4\";s:4:\"name\";s:17:\"emily_carney_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"emily_carney_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:315;a:13:{s:2:\"id\";s:3:\"315\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"michael-smith_dark.jpg\";s:5:\"video\";s:22:\"michael-smith_dark.mp4\";s:4:\"name\";s:18:\"michael-smith_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:18:\"michael-smith_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:314;a:13:{s:2:\"id\";s:3:\"314\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:23:\"sandra_johnson_dark.jpg\";s:5:\"video\";s:23:\"sandra_johnson_dark.mp4\";s:4:\"name\";s:19:\"sandra_johnson_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:19:\"sandra_johnson_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:313;a:13:{s:2:\"id\";s:3:\"313\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"robert_bolton_dark.jpg\";s:5:\"video\";s:22:\"robert_bolton_dark.mp4\";s:4:\"name\";s:18:\"robert_bolton_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:18:\"robert_bolton_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-21 09:07:08\";s:6:\"active\";s:1:\"1\";}i:312;a:13:{s:2:\"id\";s:3:\"312\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:25:\"elegant_captions_dark.png\";s:5:\"video\";s:25:\"elegant_captions_dark.mp4\";s:4:\"name\";s:21:\"elegant_captions_dark\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:21:\"elegant_captions_dark\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-18 14:41:45\";s:6:\"active\";s:1:\"1\";}i:311;a:13:{s:2:\"id\";s:3:\"311\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Caption_Dark_06.png\";s:5:\"video\";s:19:\"Caption_Dark_06.mp4\";s:4:\"name\";s:15:\"Caption_Dark_06\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"Caption_Dark_06\";s:5:\"width\";s:3:\"414\";s:6:\"height\";s:3:\"225\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:310;a:13:{s:2:\"id\";s:3:\"310\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Header_Light_02.png\";s:5:\"video\";s:19:\"Header_Light_02.mp4\";s:4:\"name\";s:15:\"Header_Light_02\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:15:\"Header_Light_02\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:309;a:13:{s:2:\"id\";s:3:\"309\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"Columns_4_Dark_01.png\";s:5:\"video\";s:21:\"Columns_4_Dark_01.mp4\";s:4:\"name\";s:17:\"Columns_4_Dark_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"Columns_4_Dark_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:308;a:13:{s:2:\"id\";s:3:\"308\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:18:\"Header_Dark_01.png\";s:5:\"video\";s:18:\"Header_Dark_01.mp4\";s:4:\"name\";s:14:\"Header_Dark_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:14:\"Header_Dark_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:307;a:13:{s:2:\"id\";s:3:\"307\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Caption_Dark_03.png\";s:5:\"video\";s:19:\"Caption_Dark_03.mp4\";s:4:\"name\";s:15:\"Caption_Dark_03\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"Caption_Dark_03\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:306;a:13:{s:2:\"id\";s:3:\"306\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"Columns_3_Dark_01.png\";s:5:\"video\";s:21:\"Columns_3_Dark_01.mp4\";s:4:\"name\";s:17:\"Columns_3_Dark_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"Columns_3_Dark_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:305;a:13:{s:2:\"id\";s:3:\"305\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Caption_Dark_05.png\";s:5:\"video\";s:19:\"Caption_Dark_05.mp4\";s:4:\"name\";s:15:\"Caption_Dark_05\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"Caption_Dark_05\";s:5:\"width\";s:4:\"1104\";s:6:\"height\";s:3:\"600\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:304;a:13:{s:2:\"id\";s:3:\"304\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:20:\"Caption_Light_06.png\";s:5:\"video\";s:20:\"Caption_Light_06.mp4\";s:4:\"name\";s:16:\"Caption_Light_06\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:16:\"Caption_Light_06\";s:5:\"width\";s:3:\"828\";s:6:\"height\";s:3:\"450\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:303;a:13:{s:2:\"id\";s:3:\"303\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Header_Light_01.png\";s:5:\"video\";s:19:\"Header_Light_01.mp4\";s:4:\"name\";s:15:\"Header_Light_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:15:\"Header_Light_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:302;a:13:{s:2:\"id\";s:3:\"302\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:20:\"Caption_Light_03.png\";s:5:\"video\";s:20:\"Caption_Light_03.mp4\";s:4:\"name\";s:16:\"Caption_Light_03\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:16:\"Caption_Light_03\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:301;a:13:{s:2:\"id\";s:3:\"301\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Caption_Dark_01.png\";s:5:\"video\";s:19:\"Caption_Dark_01.mp4\";s:4:\"name\";s:15:\"Caption_Dark_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"Caption_Dark_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:300;a:13:{s:2:\"id\";s:3:\"300\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:21:\"PromoCode_Dark_01.png\";s:5:\"video\";s:21:\"PromoCode_Dark_01.mp4\";s:4:\"name\";s:17:\"PromoCode_Dark_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:17:\"PromoCode_Dark_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:299;a:13:{s:2:\"id\";s:3:\"299\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Caption_Dark_02.png\";s:5:\"video\";s:19:\"Caption_Dark_02.mp4\";s:4:\"name\";s:15:\"Caption_Dark_02\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"Caption_Dark_02\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:298;a:13:{s:2:\"id\";s:3:\"298\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:18:\"Header_Dark_02.png\";s:5:\"video\";s:18:\"Header_Dark_02.mp4\";s:4:\"name\";s:14:\"Header_Dark_02\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:14:\"Header_Dark_02\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:297;a:13:{s:2:\"id\";s:3:\"297\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"Columns_3_Light_01.png\";s:5:\"video\";s:22:\"Columns_3_Light_01.mp4\";s:4:\"name\";s:18:\"Columns_3_Light_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:18:\"Columns_3_Light_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:296;a:13:{s:2:\"id\";s:3:\"296\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:20:\"Caption_Light_01.png\";s:5:\"video\";s:20:\"Caption_Light_01.mp4\";s:4:\"name\";s:16:\"Caption_Light_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:16:\"Caption_Light_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:295;a:13:{s:2:\"id\";s:3:\"295\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:19:\"Caption_Dark_04.png\";s:5:\"video\";s:19:\"Caption_Dark_04.mp4\";s:4:\"name\";s:15:\"Caption_Dark_04\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}}s:11:\"description\";s:15:\"Caption_Dark_04\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:294;a:13:{s:2:\"id\";s:3:\"294\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:20:\"Caption_Light_02.png\";s:5:\"video\";s:20:\"Caption_Light_02.mp4\";s:4:\"name\";s:16:\"Caption_Light_02\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:16:\"Caption_Light_02\";s:5:\"width\";s:3:\"828\";s:6:\"height\";s:3:\"450\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:293;a:13:{s:2:\"id\";s:3:\"293\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:20:\"Caption_Light_04.png\";s:5:\"video\";s:20:\"Caption_Light_04.mp4\";s:4:\"name\";s:16:\"Caption_Light_04\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:16:\"Caption_Light_04\";s:5:\"width\";s:4:\"1104\";s:6:\"height\";s:3:\"600\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:292;a:13:{s:2:\"id\";s:3:\"292\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"Columns_4_Light_01.png\";s:5:\"video\";s:22:\"Columns_4_Light_01.mp4\";s:4:\"name\";s:18:\"Columns_4_Light_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:18:\"Columns_4_Light_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:291;a:13:{s:2:\"id\";s:3:\"291\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:20:\"Caption_Light_05.png\";s:5:\"video\";s:20:\"Caption_Light_05.mp4\";s:4:\"name\";s:16:\"Caption_Light_05\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:16:\"Caption_Light_05\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:290;a:13:{s:2:\"id\";s:3:\"290\";s:4:\"type\";s:1:\"4\";s:6:\"handle\";s:22:\"PromoCode_Light_01.png\";s:5:\"video\";s:22:\"PromoCode_Light_01.mp4\";s:4:\"name\";s:18:\"PromoCode_Light_01\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}}s:11:\"description\";s:18:\"PromoCode_Light_01\";s:5:\"width\";s:3:\"552\";s:6:\"height\";s:3:\"300\";s:14:\"plugin_version\";s:5:\"6.0.0\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2019-02-14 13:18:35\";s:6:\"active\";s:1:\"1\";}i:238;a:14:{s:2:\"id\";s:3:\"238\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:12:\"Mt_Baker.jpg\";s:5:\"video\";s:12:\"Mt_Baker.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Mt Baker \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:237;a:14:{s:2:\"id\";s:3:\"237\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:16:\"Two-Swimmers.jpg\";s:5:\"video\";s:16:\"Two-Swimmers.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Two Swimmers \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:236;a:14:{s:2:\"id\";s:3:\"236\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:14:\"Boats_Maze.jpg\";s:5:\"video\";s:14:\"Boats_Maze.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Boats Maze \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:235;a:14:{s:2:\"id\";s:3:\"235\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:18:\"Candolim-Beach.jpg\";s:5:\"video\";s:18:\"Candolim-Beach.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Candolim Beach \";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:234;a:14:{s:2:\"id\";s:3:\"234\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:17:\"Working-Space.jpg\";s:5:\"video\";s:17:\"Working-Space.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Working Space \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:233;a:14:{s:2:\"id\";s:3:\"233\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:9:\"Wavez.jpg\";s:5:\"video\";s:9:\"Wavez.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Wavez \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:232;a:14:{s:2:\"id\";s:3:\"232\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:17:\"Coconut-Grove.jpg\";s:5:\"video\";s:17:\"Coconut-Grove.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Coconut Grove \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:231;a:14:{s:2:\"id\";s:3:\"231\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:19:\"Very-Open-Space.jpg\";s:5:\"video\";s:19:\"Very-Open-Space.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Very Open Space \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:230;a:14:{s:2:\"id\";s:3:\"230\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:14:\"Office-Day.jpg\";s:5:\"video\";s:14:\"Office-Day.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Office Day \";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:229;a:14:{s:2:\"id\";s:3:\"229\";s:4:\"type\";s:1:\"3\";s:6:\"handle\";s:12:\"The-Hill.jpg\";s:5:\"video\";s:12:\"The-Hill.mp4\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"The Hill \";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2018-07-16 15:34:55\";s:6:\"active\";s:1:\"1\";}i:198;a:13:{s:2:\"id\";s:3:\"198\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:16:\"object_dvd_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:3:\"DVD\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:43:17\";s:6:\"active\";s:1:\"1\";}i:197;a:13:{s:2:\"id\";s:3:\"197\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"relax_hammock.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Relax Hammock\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}i:1;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:196;a:13:{s:2:\"id\";s:3:\"196\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"beach_houses.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Beach Houses\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:195;a:13:{s:2:\"id\";s:3:\"195\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"forest_road_2.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Forest Road 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:194;a:13:{s:2:\"id\";s:3:\"194\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"clean_desk.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Clean Desk\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:193;a:13:{s:2:\"id\";s:3:\"193\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"mountain_view_6.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Mountain View 6\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1249\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:192;a:13:{s:2:\"id\";s:3:\"192\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"corn_field.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Corn Field\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1320\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:191;a:13:{s:2:\"id\";s:3:\"191\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:21:\"stylish_apartment.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Stylish Apartment\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1281\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:190;a:13:{s:2:\"id\";s:3:\"190\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:24:\"hipster_coffee_house.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Hipster Coffee House\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:189;a:13:{s:2:\"id\";s:3:\"189\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"blurry_beach.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Blurry Beach\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-10-17 12:41:12\";s:6:\"active\";s:1:\"1\";}i:188;a:13:{s:2:\"id\";s:3:\"188\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_plant_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Plant 1\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-12 16:25:27\";s:6:\"active\";s:1:\"1\";}i:187;a:13:{s:2:\"id\";s:3:\"187\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:16:\"object_pen_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Pen 1\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-12 16:25:27\";s:6:\"active\";s:1:\"1\";}i:186;a:13:{s:2:\"id\";s:3:\"186\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"greens_street.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Greens Street\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1277\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:185;a:13:{s:2:\"id\";s:3:\"185\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:10:\"desert.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Desert\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:184;a:13:{s:2:\"id\";s:3:\"184\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"mountain_view_5.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Mountain View 5\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:183;a:13:{s:2:\"id\";s:3:\"183\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:10:\"laptop.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Laptop\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1391\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:182;a:13:{s:2:\"id\";s:3:\"182\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"grand_canyon.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Grand Canyon\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1287\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:181;a:13:{s:2:\"id\";s:3:\"181\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:20:\"landscape_clouds.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Landscape Clouds\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1272\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:180;a:13:{s:2:\"id\";s:3:\"180\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"highway_night.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Highway Night\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}i:1;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1440\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:179;a:13:{s:2:\"id\";s:3:\"179\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"beach_water.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Beach Water\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:177;a:13:{s:2:\"id\";s:3:\"177\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"woman_beach.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Woman Beach\";s:4:\"tags\";a:4:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:2;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}i:3;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:175;a:13:{s:2:\"id\";s:3:\"175\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:12:\"cool_guy.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Cool Guy\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:174;a:13:{s:2:\"id\";s:3:\"174\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:13:\"beach_sea.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Beach Sea\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:2;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:173;a:13:{s:2:\"id\";s:3:\"173\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"bridge_clouds.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Bridge Clouds\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}i:2;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1281\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-09-05 15:29:22\";s:6:\"active\";s:1:\"1\";}i:172;a:13:{s:2:\"id\";s:3:\"172\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:16:\"object_egg_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:3:\"Egg\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"600\";s:6:\"height\";s:3:\"600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:171;a:13:{s:2:\"id\";s:3:\"171\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_guitar_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Guitar\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:170;a:13:{s:2:\"id\";s:3:\"170\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_envelope_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Closed Envelope\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:169;a:13:{s:2:\"id\";s:3:\"169\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_postit_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Postit Label White\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"900\";s:6:\"height\";s:3:\"900\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:168;a:13:{s:2:\"id\";s:3:\"168\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_envelope_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Open Envelope\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:167;a:13:{s:2:\"id\";s:3:\"167\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_eggs_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Egg Carton\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:166;a:13:{s:2:\"id\";s:3:\"166\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:25:\"object_bottleopener_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Bottle Opener\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}i:1;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:165;a:13:{s:2:\"id\";s:3:\"165\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_blueprints_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Blueprints\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:164;a:13:{s:2:\"id\";s:3:\"164\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:22:\"object_holepunch_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Hole punch\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:163;a:13:{s:2:\"id\";s:3:\"163\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_speaker_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Black Speaker\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:162;a:13:{s:2:\"id\";s:3:\"162\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_eraser_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Eraser\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:161;a:13:{s:2:\"id\";s:3:\"161\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_vinylcover_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Vinyl Cover\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:160;a:13:{s:2:\"id\";s:3:\"160\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_booklet_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Booklet 1\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:159;a:13:{s:2:\"id\";s:3:\"159\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:22:\"object_earphones_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Earphones 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:158;a:13:{s:2:\"id\";s:3:\"158\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_vinyl_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Vinyl\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:157;a:13:{s:2:\"id\";s:3:\"157\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_postit_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Postit Label Pink\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"900\";s:6:\"height\";s:3:\"900\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:156;a:13:{s:2:\"id\";s:3:\"156\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_mechpencil_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Mechanical Pencil\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:155;a:13:{s:2:\"id\";s:3:\"155\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:22:\"object_turntable_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Turntable\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:154;a:13:{s:2:\"id\";s:3:\"154\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_folder_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Closed Folder Black\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:153;a:13:{s:2:\"id\";s:3:\"153\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_postit_4.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Postit Label Green\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"900\";s:6:\"height\";s:3:\"900\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:152;a:13:{s:2:\"id\";s:3:\"152\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_folder_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Blank Folder\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:151;a:13:{s:2:\"id\";s:3:\"151\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_pencup_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Pen Cup\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:150;a:13:{s:2:\"id\";s:3:\"150\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_winebottle_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Red Wine Bottle\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:149;a:13:{s:2:\"id\";s:3:\"149\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_headphones_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Headphones\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:148;a:13:{s:2:\"id\";s:3:\"148\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:22:\"object_earphones_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Earphones\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:147;a:13:{s:2:\"id\";s:3:\"147\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_postit_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Postit Label Yellow\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"900\";s:6:\"height\";s:3:\"900\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:146;a:13:{s:2:\"id\";s:3:\"146\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:22:\"object_corkscrew_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Corkscrew Bottle Opener\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}i:1;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1300\";s:6:\"height\";s:4:\"1300\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-18 15:34:49\";s:6:\"active\";s:1:\"1\";}i:145;a:13:{s:2:\"id\";s:3:\"145\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_muffin_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Chocolate Muffin\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"900\";s:6:\"height\";s:3:\"900\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:144;a:13:{s:2:\"id\";s:3:\"144\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_chair_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Yellow Chair\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:143;a:13:{s:2:\"id\";s:3:\"143\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_knife_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Knife 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:142;a:13:{s:2:\"id\";s:3:\"142\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:26:\"object_choppingboard_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Chopping Board 3\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:141;a:13:{s:2:\"id\";s:3:\"141\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:26:\"object_choppingboard_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Chopping Board 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:140;a:13:{s:2:\"id\";s:3:\"140\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_coffee_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Coffee Cup 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1200\";s:6:\"height\";s:4:\"1200\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:139;a:13:{s:2:\"id\";s:3:\"139\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_bread_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Croissant Bread\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:138;a:13:{s:2:\"id\";s:3:\"138\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_spoon_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Wodden Spoon\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:137;a:13:{s:2:\"id\";s:3:\"137\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:26:\"object_choppingboard_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Chopping Board 1\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:136;a:13:{s:2:\"id\";s:3:\"136\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:16:\"object_cup_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Empty Cup 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:4:\"1400\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:135;a:13:{s:2:\"id\";s:3:\"135\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_knife_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Knife\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:134;a:13:{s:2:\"id\";s:3:\"134\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_spoon_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Spoon\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:133;a:13:{s:2:\"id\";s:3:\"133\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:16:\"object_cup_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Empty Cup\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:4:\"1400\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:132;a:13:{s:2:\"id\";s:3:\"132\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_chair_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"White Chair\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:131;a:13:{s:2:\"id\";s:3:\"131\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_coffee_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Coffee Cup\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:130;a:13:{s:2:\"id\";s:3:\"130\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_frypan_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Fry Pan 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:129;a:13:{s:2:\"id\";s:3:\"129\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_frypan_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Fry Pan 1\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:128;a:13:{s:2:\"id\";s:3:\"128\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_fork_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:4:\"Fork\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:127;a:13:{s:2:\"id\";s:3:\"127\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_dishrag_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Dishrag Cloth\";s:4:\"tags\";a:0:{}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-17 13:48:44\";s:6:\"active\";s:1:\"1\";}i:126;a:13:{s:2:\"id\";s:3:\"126\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_wacom_pen.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Wacom Drawing Pen\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}i:2;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1060\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:125;a:13:{s:2:\"id\";s:3:\"125\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_occulus_vr.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:23:\"Occulus Virtual Reality\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:124;a:13:{s:2:\"id\";s:3:\"124\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_antenna.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Antenna Radar\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:123;a:13:{s:2:\"id\";s:3:\"123\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_solarpanel.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Solar Panel\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:122;a:13:{s:2:\"id\";s:3:\"122\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:16:\"object_wacom.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Wacom Drawing Tablet\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}i:2;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:121;a:13:{s:2:\"id\";s:3:\"121\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_earth_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Earth Globe Planet 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:120;a:13:{s:2:\"id\";s:3:\"120\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_chair_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Office Chair\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:119;a:13:{s:2:\"id\";s:3:\"119\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:24:\"object_windturbine_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Wind Turbine 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:118;a:13:{s:2:\"id\";s:3:\"118\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:22:\"object_windturbine.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Wind Turbine\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:117;a:13:{s:2:\"id\";s:3:\"117\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:16:\"object_earth.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Earth Globe Planet\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 16:50:55\";s:6:\"active\";s:1:\"1\";}i:116;a:13:{s:2:\"id\";s:3:\"116\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"mountain_view_2.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Mountain View 2\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1275\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:115;a:13:{s:2:\"id\";s:3:\"115\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"desert_trees.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Desert Trees\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1275\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:114;a:13:{s:2:\"id\";s:3:\"114\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:20:\"explore_moutains.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Explore Mountains\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:113;a:13:{s:2:\"id\";s:3:\"113\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"night_skyline_2.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Night Skyline 2\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}i:1;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:112;a:13:{s:2:\"id\";s:3:\"112\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"cliff_ocean.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Cliff Ocean\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:111;a:13:{s:2:\"id\";s:3:\"111\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"city_smoke.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"City Smoke\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}i:1;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:110;a:13:{s:2:\"id\";s:3:\"110\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"surfer_beach.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Surfer Beach\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:2;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1278\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:109;a:13:{s:2:\"id\";s:3:\"109\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:13:\"sky_night.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Sky Night\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}i:2;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:108;a:13:{s:2:\"id\";s:3:\"108\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"palm_sunset.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Palm Sunset\";s:4:\"tags\";a:4:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}i:2;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}i:3;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1372\";s:6:\"height\";s:4:\"1920\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:107;a:13:{s:2:\"id\";s:3:\"107\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"concert_people.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Concert People\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1277\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:106;a:13:{s:2:\"id\";s:3:\"106\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"forest_road.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Forest Road\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:105;a:13:{s:2:\"id\";s:3:\"105\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:15:\"beach_ocean.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Beach Ocean\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:2;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:104;a:13:{s:2:\"id\";s:3:\"104\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:18:\"mountain_night.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Mountain Night\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}i:2;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1277\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:103;a:13:{s:2:\"id\";s:3:\"103\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"ocean_mountains.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Ocean Mountains\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1282\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:102;a:13:{s:2:\"id\";s:3:\"102\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:10:\"forest.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:6:\"Forest\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:101;a:13:{s:2:\"id\";s:3:\"101\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"ocean_stones.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Ocean Stones\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:2;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:100;a:13:{s:2:\"id\";s:3:\"100\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"country_road.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Country Road\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}i:2;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:99;a:13:{s:2:\"id\";s:2:\"99\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:9:\"beach.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:5:\"Beach\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:98;a:13:{s:2:\"id\";s:2:\"98\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:16:\"city_skyline.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"City Skyline\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:97;a:13:{s:2:\"id\";s:2:\"97\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"night_skyline.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Night Skyline\";s:4:\"tags\";a:3:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}i:2;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:96;a:13:{s:2:\"id\";s:2:\"96\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"city_river.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"City River\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:95;a:13:{s:2:\"id\";s:2:\"95\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"mountain_view_3.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Mountain View 3\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1281\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:94;a:13:{s:2:\"id\";s:2:\"94\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:14:\"misty_farm.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Misty Farm\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:93;a:13:{s:2:\"id\";s:2:\"93\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"mountain_path.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Mountain Path\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1280\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:92;a:13:{s:2:\"id\";s:2:\"92\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"night_skyline_3.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Night Skyline 3\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:91;a:13:{s:2:\"id\";s:2:\"91\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:17:\"mountain_view.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Mountain View\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1160\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:90;a:13:{s:2:\"id\";s:2:\"90\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"rocky_landscape.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Rocky Landscape\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1080\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:89;a:13:{s:2:\"id\";s:2:\"89\";s:4:\"type\";s:1:\"2\";s:6:\"handle\";s:19:\"mountain_view_4.jpg\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Mountain View 4\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:1;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:4:\"1203\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-15 14:29:46\";s:6:\"active\";s:1:\"1\";}i:88;a:13:{s:2:\"id\";s:2:\"88\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:24:\"object_eiffeltower_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Eiffeltower 2\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}i:1;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"700\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:87;a:13:{s:2:\"id\";s:2:\"87\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_notebook_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Notebook PC\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"2000\";s:6:\"height\";s:4:\"2000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:86;a:13:{s:2:\"id\";s:2:\"86\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_macbook_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:20:\"Apple Macbook Silver\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"2000\";s:6:\"height\";s:4:\"2000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:85;a:13:{s:2:\"id\";s:2:\"85\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_canon_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:21:\"Canon Camera DSLR Top\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:84;a:13:{s:2:\"id\";s:2:\"84\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_iphone_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:25:\"Apple iPhone Silver White\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:83;a:13:{s:2:\"id\";s:2:\"83\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_candy_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Candy Colored 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:82;a:13:{s:2:\"id\";s:2:\"82\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_macmouse_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Apple Mac Mouse\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:81;a:13:{s:2:\"id\";s:2:\"81\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_iphone_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Apple iPhone Black\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:80;a:13:{s:2:\"id\";s:2:\"80\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_deco_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"White Deco Object\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}i:1;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:79;a:13:{s:2:\"id\";s:2:\"79\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_applewatch_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:24:\"Apple Watch White Silver\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:78;a:13:{s:2:\"id\";s:2:\"78\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_swissknife_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Swiss Knife\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}i:1;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:77;a:13:{s:2:\"id\";s:2:\"77\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_applewatch_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Apple Watch Black\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:76;a:13:{s:2:\"id\";s:2:\"76\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_candy_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Candy Colored\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:75;a:13:{s:2:\"id\";s:2:\"75\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_ipad_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Apple iPad Black\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"2000\";s:6:\"height\";s:4:\"2000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:74;a:13:{s:2:\"id\";s:2:\"74\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_lamp_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Black Desk Lamp\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:73;a:13:{s:2:\"id\";s:2:\"73\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_canon_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Canon Camera DLSR\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:72;a:13:{s:2:\"id\";s:2:\"72\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_blackberry_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Blackberry 3\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:71;a:13:{s:2:\"id\";s:2:\"71\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_iphone_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Apple iPhone Silver\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:70;a:13:{s:2:\"id\";s:2:\"70\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_ipad_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Apple iPad Gold\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"2000\";s:6:\"height\";s:4:\"2000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:69;a:13:{s:2:\"id\";s:2:\"69\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_printer_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:7:\"Printer\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:68;a:13:{s:2:\"id\";s:2:\"68\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_pcmouse_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Black PC Mouse\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:67;a:13:{s:2:\"id\";s:2:\"67\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_ipad_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Apple iPad Silver\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"2000\";s:6:\"height\";s:4:\"2000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:66;a:13:{s:2:\"id\";s:2:\"66\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_lamp_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Desk Lamp Top\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:65;a:13:{s:2:\"id\";s:2:\"65\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:22:\"object_macscreen_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Apple Mac Screen\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"2000\";s:6:\"height\";s:4:\"2000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:64;a:13:{s:2:\"id\";s:2:\"64\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_blackberry_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Blackberry 2\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:63;a:13:{s:2:\"id\";s:2:\"63\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_applewatch_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Apple Watch Gold\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"800\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:62;a:13:{s:2:\"id\";s:2:\"62\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_blackberry_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Blackberry\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 16:51:11\";s:6:\"active\";s:1:\"1\";}i:49;a:13:{s:2:\"id\";s:2:\"49\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_bottle_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Brown Glass Bottle\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}i:1;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:48;a:13:{s:2:\"id\";s:2:\"48\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_glasses_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Hipster Glasses Top\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:47;a:13:{s:2:\"id\";s:2:\"47\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_magazine_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Blank Magazine\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:46;a:13:{s:2:\"id\";s:2:\"46\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:28:\"object_leatherdocument_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:24:\"Black Leather Document 2\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}i:1;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:45;a:13:{s:2:\"id\";s:2:\"45\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_purse_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Black Purse 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:44;a:13:{s:2:\"id\";s:2:\"44\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_typewriter_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Retro Typewriter 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:43;a:13:{s:2:\"id\";s:2:\"43\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_book_5.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Old Books\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:42;a:13:{s:2:\"id\";s:2:\"42\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:28:\"object_leatherdocument_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:29:\"Black Leather Document Closed\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:41;a:13:{s:2:\"id\";s:2:\"41\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_book_4.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:8:\"Old Book\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:40;a:13:{s:2:\"id\";s:2:\"40\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_wallet_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:22:\"Black Leather Document\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:39;a:13:{s:2:\"id\";s:2:\"39\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_quill_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Quill Feather 2\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:38;a:13:{s:2:\"id\";s:2:\"38\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:24:\"object_eiffeltower_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Eiffeltower\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:37;a:13:{s:2:\"id\";s:2:\"37\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_magazine_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Open Book 3\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1333\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:36;a:13:{s:2:\"id\";s:2:\"36\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_book_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:10:\"Blank Book\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:35;a:13:{s:2:\"id\";s:2:\"35\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"object_glasses_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:15:\"Hipster Glasses\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:34;a:13:{s:2:\"id\";s:2:\"34\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_book_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Open Book 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:33;a:13:{s:2:\"id\";s:2:\"33\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_gloves_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Black Gloves\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:32;a:13:{s:2:\"id\";s:2:\"32\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_typewriter_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Retro Typewriter\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:31;a:13:{s:2:\"id\";s:2:\"31\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:17:\"object_book_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Open Book\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:30;a:13:{s:2:\"id\";s:2:\"30\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_wallet_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Black Wallet\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1500\";s:6:\"height\";s:4:\"1500\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:29;a:13:{s:2:\"id\";s:2:\"29\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_purse_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:11:\"Black Purse\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:28;a:13:{s:2:\"id\";s:2:\"28\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_quill_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:13:\"Quill Feather\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 12:57:32\";s:6:\"active\";s:1:\"1\";}i:27;a:13:{s:2:\"id\";s:2:\"27\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_artbox_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:16:\"Art Box Colors 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:26;a:13:{s:2:\"id\";s:2:\"26\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"object_cloth_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:17:\"Cloth Paint Color\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:4:\"1400\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:25;a:13:{s:2:\"id\";s:2:\"25\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"object_brushpot_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:9:\"Brush Pot\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"984\";s:6:\"height\";s:3:\"984\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:24;a:13:{s:2:\"id\";s:2:\"24\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:24:\"object_paintbucket_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Paint Bucket\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:4:\"1400\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:23;a:13:{s:2:\"id\";s:2:\"23\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_paintbrush_2.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Paintbrush 3\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"700\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:22;a:13:{s:2:\"id\";s:2:\"22\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:19:\"object_artbox_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Art Box Colors\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:21;a:13:{s:2:\"id\";s:2:\"21\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_paintbrush_3.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Paintbrush 2\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1100\";s:6:\"height\";s:4:\"1100\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:20;a:13:{s:2:\"id\";s:2:\"20\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:23:\"object_paintbrush_1.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:12:\"Paintbrush 1\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1000\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-12 10:59:23\";s:6:\"active\";s:1:\"1\";}i:11;a:13:{s:2:\"id\";s:2:\"11\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"table_radio_right.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Radio Speaker Wood\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-11 13:37:51\";s:6:\"active\";s:1:\"1\";}i:10;a:13:{s:2:\"id\";s:2:\"10\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:18:\"keyboard_apple.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:14:\"Apple Keyboard\";s:4:\"tags\";a:1:{i:0;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-11 13:37:51\";s:6:\"active\";s:1:\"1\";}i:9;a:13:{s:2:\"id\";s:1:\"9\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:20:\"macbook_top_gold.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:18:\"Apple Macbook Gold\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1600\";s:6:\"height\";s:4:\"1600\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-11 13:37:51\";s:6:\"active\";s:1:\"1\";}i:8;a:13:{s:2:\"id\";s:1:\"8\";s:4:\"type\";s:1:\"1\";s:6:\"handle\";s:21:\"nexus6_front_blue.png\";s:4:\"data\";s:0:\"\";s:4:\"name\";s:19:\"Google Nexus 6 Blue\";s:4:\"tags\";a:2:{i:0;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:1;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}}s:11:\"description\";s:8:\"New File\";s:5:\"width\";s:4:\"1100\";s:6:\"height\";s:4:\"1100\";s:14:\"plugin_version\";s:0:\"\";s:7:\"version\";s:3:\"1.0\";s:5:\"added\";s:19:\"2016-08-11 13:37:51\";s:6:\"active\";s:1:\"1\";}}s:4:\"tags\";a:18:{i:28;a:3:{s:2:\"id\";s:2:\"28\";s:6:\"handle\";s:11:\"abstraction\";s:4:\"name\";s:11:\"Abstraction\";}i:1;a:3:{s:2:\"id\";s:1:\"1\";s:6:\"handle\";s:11:\"accessories\";s:4:\"name\";s:11:\"Accessories\";}i:5;a:3:{s:2:\"id\";s:1:\"5\";s:6:\"handle\";s:3:\"art\";s:4:\"name\";s:3:\"Art\";}i:20;a:3:{s:2:\"id\";s:2:\"20\";s:6:\"handle\";s:5:\"Beach\";s:4:\"name\";s:5:\"Beach\";}i:21;a:3:{s:2:\"id\";s:2:\"21\";s:6:\"handle\";s:4:\"City\";s:4:\"name\";s:4:\"City\";}i:25;a:3:{s:2:\"id\";s:2:\"25\";s:6:\"handle\";s:4:\"dark\";s:4:\"name\";s:4:\"Dark\";}i:2;a:3:{s:2:\"id\";s:1:\"2\";s:6:\"handle\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";}i:16;a:3:{s:2:\"id\";s:2:\"16\";s:6:\"handle\";s:4:\"food\";s:4:\"name\";s:4:\"Food\";}i:26;a:3:{s:2:\"id\";s:2:\"26\";s:6:\"handle\";s:5:\"light\";s:4:\"name\";s:5:\"Light\";}i:18;a:3:{s:2:\"id\";s:2:\"18\";s:6:\"handle\";s:4:\"misc\";s:4:\"name\";s:4:\"Misc\";}i:4;a:3:{s:2:\"id\";s:1:\"4\";s:6:\"handle\";s:5:\"music\";s:4:\"name\";s:5:\"Music\";}i:19;a:3:{s:2:\"id\";s:2:\"19\";s:6:\"handle\";s:6:\"nature\";s:4:\"name\";s:6:\"Nature\";}i:23;a:3:{s:2:\"id\";s:2:\"23\";s:6:\"handle\";s:5:\"Night\";s:4:\"name\";s:5:\"Night\";}i:3;a:3:{s:2:\"id\";s:1:\"3\";s:6:\"handle\";s:6:\"office\";s:4:\"name\";s:6:\"Office\";}i:24;a:3:{s:2:\"id\";s:2:\"24\";s:6:\"handle\";s:6:\"People\";s:4:\"name\";s:6:\"People\";}i:22;a:3:{s:2:\"id\";s:2:\"22\";s:6:\"handle\";s:3:\"Sky\";s:4:\"name\";s:3:\"Sky\";}i:29;a:3:{s:2:\"id\";s:2:\"29\";s:6:\"handle\";s:5:\"space\";s:4:\"name\";s:5:\"Space\";}i:27;a:3:{s:2:\"id\";s:2:\"27\";s:6:\"handle\";s:5:\"sport\";s:4:\"name\";s:5:\"Sport\";}}}', 'no');
INSERT INTO `wp8b_options` VALUES(174, '7e90a2c2fbeeac7d327e31f18c353008', 'a:2:{s:7:\"timeout\";i:1597246947;s:5:\"value\";s:174:\"{\"new_version\":\"\",\"stable_version\":\"\",\"sections\":\"\",\"license_check\":\"\",\"msg\":\"License key is not valid for Duplicator Pro\",\"homepage\":\"\",\"package\":\"\",\"icons\":[],\"banners\":[]}\";}', 'yes'),
 (171, 'duplicator_pro_reset_user_settings_required', '0', 'yes'),
 (541, 'cerber-antibot', 'a:2:{i:0;a:4:{i:0;a:2:{i:0;s:8:\"LWXj-_mb\";i:1;s:8:\"ncSu6os7\";}i:1;a:2:{i:0;s:10:\"wROrBjnSsQ\";i:1;s:10:\"vgqKXBteNk\";}i:2;a:2:{i:0;s:7:\"LbMozPs\";i:1;s:7:\"3epKYat\";}i:3;a:2:{i:0;s:14:\"eU_mtndFjMKHic\";i:1;s:14:\"Y[Z7RBi.axu46j\";}}i:1;a:3:{i:0;a:2:{i:0;s:12:\"KGTFzfDUjHpa\";i:1;s:12:\"DFQOy*8WmpBd\";}i:1;a:2:{i:0;s:10:\"iXVLlmUQwN\";i:1;s:10:\"5]m7_[@vsT\";}i:2;a:2:{i:0;s:15:\"ycfYalGQMRnLASV\";i:1;s:15:\"OG*Y1q.Wgz7dQKo\";}}}', 'no'),
 (173, 'duplicator_pro_license_key', 'NULLED WEAWP', 'yes'),
 (184, 'kallyas_hg_dash_theme_check', '1x', 'yes'),
 (539, 'cerber-nexus-slave', 'a:3:{s:9:\"slave_ips\";s:0:\"\";s:12:\"slave_access\";i:2;s:10:\"slave_diag\";i:0;}', 'no'),
 (540, '_cerber_db_errors', 'a:5:{i:0;s:130:\"Table \'vicodigi_wp642.wp8b_cerber_sets\' doesn\'t exist for the query: SELECT * FROM wp8b_cerber_sets WHERE the_key = \"_nexus_mode\" \";i:1;s:146:\"Table \'vicodigi_wp642.wp8b_cerber_sets\' doesn\'t exist for the query: SELECT * FROM wp8b_cerber_sets WHERE the_key = \"admin_notice\"  AND the_id = 0\";i:2;s:172:\"Table \'vicodigi_wp642.wp8b_cerber_sets\' doesn\'t exist for the query: INSERT INTO wp8b_cerber_sets (the_key, the_id, the_value, expires) VALUES (\"admin_notice\",0,\"a:0:{}\",0)\";i:3;s:147:\"Table \'vicodigi_wp642.wp8b_cerber_sets\' doesn\'t exist for the query: SELECT * FROM wp8b_cerber_sets WHERE the_key = \"admin_message\"  AND the_id = 0\";i:4;s:173:\"Table \'vicodigi_wp642.wp8b_cerber_sets\' doesn\'t exist for the query: INSERT INTO wp8b_cerber_sets (the_key, the_id, the_value, expires) VALUES (\"admin_message\",0,\"a:0:{}\",0)\";}', 'no'),
 (538, 'cerber-nexus_master', 'a:7:{s:13:\"master_tolist\";i:1;s:13:\"master_swshow\";i:1;s:14:\"master_at_site\";i:1;s:13:\"master_locale\";i:0;s:9:\"master_dt\";i:0;s:9:\"master_tz\";i:0;s:11:\"master_diag\";i:0;}', 'no'),
 (537, 'cerber-policies', 'a:9:{s:13:\"scan_delunatt\";i:0;s:11:\"scan_delupl\";a:0:{}s:14:\"scan_delunwant\";i:0;s:15:\"scan_recover_wp\";i:0;s:15:\"scan_recover_pl\";i:0;s:14:\"scan_nodeltemp\";i:0;s:14:\"scan_nodelsess\";i:0;s:13:\"scan_delexdir\";a:0:{}s:13:\"scan_delexext\";a:0:{}}', 'no'),
 (536, 'cerber-schedule', 'a:8:{s:11:\"scan_aquick\";i:0;s:10:\"scan_afull\";s:5:\"03:00\";s:18:\"scan_afull-enabled\";i:0;s:10:\"scan_reinc\";a:5:{i:3;i:1;i:4;i:1;i:15;i:1;i:50;i:1;i:51;i:1;}s:12:\"scan_relimit\";i:3;s:10:\"scan_isize\";i:0;s:12:\"scan_ierrors\";i:0;s:10:\"email-scan\";s:0:\"\";}', 'no'),
 (535, 'cerber-scanner', 'a:10:{s:8:\"scan_cpt\";a:0:{}s:9:\"scan_uext\";a:0:{}s:12:\"scan_exclude\";a:0:{}s:9:\"scan_inew\";s:1:\"1\";s:9:\"scan_imod\";s:1:\"1\";s:10:\"scan_chmod\";s:1:\"0\";s:8:\"scan_tmp\";s:1:\"1\";s:9:\"scan_sess\";s:1:\"1\";s:10:\"scan_debug\";s:1:\"0\";s:13:\"scan_qcleanup\";s:2:\"30\";}', 'no'),
 (534, 'cerber-opt_shield', 'a:4:{s:8:\"ds_4opts\";i:0;s:14:\"ds_4opts_roles\";a:1:{i:0;s:13:\"administrator\";}s:13:\"ds_4opts_list\";a:7:{s:11:\"admin_email\";i:1;s:12:\"default_role\";i:1;s:4:\"home\";i:1;s:7:\"siteurl\";i:1;s:18:\"users_can_register\";i:1;s:14:\"active_plugins\";i:1;s:8:\"template\";i:1;}s:12:\"ds_4opts_acl\";i:0;}', 'no'),
 (533, 'cerber-user_shield', 'a:9:{s:7:\"ds_4acc\";i:0;s:13:\"ds_regs_roles\";a:0:{}s:10:\"ds_add_acc\";a:1:{i:0;s:13:\"administrator\";}s:11:\"ds_edit_acc\";a:1:{i:0;s:13:\"administrator\";}s:11:\"ds_4acc_acl\";i:0;s:9:\"ds_4roles\";i:0;s:11:\"ds_add_role\";a:1:{i:0;s:13:\"administrator\";}s:12:\"ds_edit_role\";a:1:{i:0;s:13:\"administrator\";}s:13:\"ds_4roles_acl\";i:0;}', 'no'),
 (518, 'duplicator_pro_plugin_version', '3.8.3.4', 'yes'),
 (545, 'cerber-groove-x', 'a:2:{i:0;s:25:\"vGbMD5reqdnkEFm8C2tLRyAHo\";i:1;s:29:\"eLS5GIK6XbogChrJ9n7jOTaYmFQqk\";}', 'no'),
 (526, 'cerber-main', 'a:32:{s:9:\"boot-mode\";s:1:\"0\";s:8:\"attempts\";s:1:\"5\";s:6:\"period\";s:2:\"30\";s:7:\"lockout\";s:2:\"60\";s:8:\"agperiod\";s:2:\"24\";s:7:\"aglocks\";s:1:\"2\";s:6:\"aglast\";s:1:\"4\";s:10:\"limitwhite\";s:1:\"0\";s:5:\"proxy\";s:1:\"0\";s:10:\"cookiepref\";s:0:\"\";s:6:\"subnet\";s:1:\"0\";s:8:\"nonusers\";s:1:\"0\";s:7:\"wplogin\";s:1:\"0\";s:10:\"noredirect\";s:1:\"0\";s:7:\"page404\";s:1:\"1\";s:9:\"loginpath\";s:0:\"\";s:9:\"loginnowp\";s:1:\"0\";s:10:\"citadel_on\";s:1:\"1\";s:7:\"cilimit\";s:3:\"200\";s:8:\"ciperiod\";s:2:\"15\";s:10:\"ciduration\";s:2:\"60\";s:8:\"cinotify\";s:1:\"1\";s:7:\"keeplog\";s:2:\"30\";s:12:\"keeplog_auth\";s:2:\"30\";s:8:\"ip_extra\";s:1:\"1\";s:9:\"cerberlab\";s:1:\"0\";s:11:\"cerberproto\";s:1:\"0\";s:7:\"usefile\";s:1:\"0\";s:10:\"dateformat\";s:0:\"\";s:10:\"plain_date\";s:1:\"0\";s:10:\"admin_lang\";s:1:\"0\";s:14:\"no_white_my_ip\";s:1:\"0\";}', 'no'),
 (527, 'cerber-hardening', 'a:13:{s:8:\"stopenum\";i:1;s:8:\"adminphp\";i:0;s:8:\"phpnoupl\";i:0;s:8:\"nophperr\";i:1;s:6:\"xmlrpc\";i:0;s:7:\"nofeeds\";i:0;s:10:\"norestuser\";i:1;s:6:\"norest\";i:0;s:8:\"restauth\";i:1;s:9:\"restroles\";a:1:{i:0;s:13:\"administrator\";}s:9:\"restwhite\";s:6:\"oembed\";s:10:\"hashauthor\";i:0;s:9:\"cleanhead\";i:1;}', 'no'),
 (528, 'cerber-users', 'a:16:{s:8:\"authonly\";i:0;s:11:\"authonlyacl\";i:0;s:11:\"authonlymsg\";s:64:\"Solo los usuarios registrados y conectados pueden ver este sitio\";s:13:\"authonlyredir\";s:0:\"\";s:12:\"reglimit_num\";i:3;s:12:\"reglimit_min\";i:60;s:6:\"emrule\";i:0;s:6:\"emlist\";a:0:{}s:10:\"prohibited\";a:0:{}s:11:\"auth_expire\";s:0:\"\";s:8:\"usersort\";s:0:\"\";s:11:\"pdata_erase\";i:0;s:14:\"pdata_sessions\";i:0;s:12:\"pdata_export\";i:0;s:9:\"pdata_act\";i:0;s:9:\"pdata_trf\";a:0:{}}', 'no'),
 (529, 'cerber-antispam', 'a:9:{s:8:\"botscomm\";i:1;s:7:\"botsreg\";i:0;s:7:\"botsany\";i:0;s:8:\"botssafe\";i:0;s:10:\"botsnoauth\";i:1;s:9:\"botswhite\";s:0:\"\";s:8:\"spamcomm\";i:0;s:10:\"trashafter\";i:7;s:18:\"trashafter-enabled\";i:0;}', 'no'),
 (530, 'cerber-recaptcha', 'a:14:{s:7:\"sitekey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:9:\"invirecap\";i:0;s:10:\"recaplogin\";i:0;s:9:\"recaplost\";i:0;s:8:\"recapreg\";i:0;s:13:\"recapwoologin\";i:0;s:12:\"recapwoolost\";i:0;s:11:\"recapwooreg\";i:0;s:8:\"recapcom\";i:0;s:12:\"recapcomauth\";i:0;s:16:\"recaptcha-period\";i:60;s:16:\"recaptcha-number\";i:3;s:16:\"recaptcha-within\";i:30;}', 'no'),
 (531, 'cerber-notifications', 'a:11:{s:6:\"notify\";i:1;s:5:\"above\";i:3;s:5:\"email\";s:0:\"\";s:9:\"emailrate\";i:12;s:14:\"notify-new-ver\";s:1:\"1\";s:7:\"pbtoken\";s:0:\"\";s:8:\"pbdevice\";s:0:\"\";s:12:\"wreports-day\";s:1:\"1\";s:13:\"wreports-time\";i:9;s:12:\"email-report\";s:0:\"\";s:13:\"enable-report\";s:1:\"1\";}', 'no'),
 (532, 'cerber-traffic', 'a:18:{s:9:\"tienabled\";s:1:\"1\";s:9:\"tiipwhite\";s:1:\"0\";s:7:\"tiwhite\";a:0:{}s:8:\"tierrmon\";s:1:\"1\";s:11:\"tierrnoauth\";s:1:\"0\";s:6:\"timode\";s:1:\"1\";s:9:\"tinocrabs\";s:1:\"1\";s:8:\"tinolocs\";a:0:{}s:6:\"tinoua\";a:0:{}s:8:\"tifields\";s:1:\"0\";s:6:\"timask\";a:0:{}s:6:\"tihdrs\";s:1:\"0\";s:6:\"tisenv\";s:1:\"0\";s:7:\"ticandy\";s:1:\"0\";s:8:\"tiphperr\";s:1:\"0\";s:11:\"tithreshold\";s:0:\"\";s:9:\"tikeeprec\";s:2:\"30\";s:14:\"tikeeprec_auth\";s:2:\"30\";}', 'no'),
 (266, 'wordfence_version', '7.4.10', 'yes'),
 (267, 'wordfence_case', '1', 'yes'),
 (268, 'wordfence_installed', '1', 'yes'),
 (269, 'wordfenceActivated', '1', 'yes'),
 (270, 'wf_plugin_act_error', '', 'yes'),
 (281, 'revslider_servers', 'a:7:{i:0;s:22:\"themepunch-ext-b.tools\";i:1;s:22:\"themepunch-ext-b.tools\";i:2;s:16:\"themepunch.tools\";i:3;s:22:\"themepunch-ext-a.tools\";i:4;s:22:\"themepunch-ext-a.tools\";i:5;s:22:\"themepunch-ext-a.tools\";i:6;s:22:\"themepunch-ext-b.tools\";}', 'yes'),
 (282, 'revslider_server_refresh', '1597070494', 'yes'),
 (283, 'revslider-update-check-short', '1597070494', 'yes'),
 (284, 'revslider-connection', '1', 'yes'),
 (285, 'revslider-update-hash', 'a3fc58e66411768c31d0f84fdf0a9e34', 'yes'),
 (286, 'revslider-latest-version', '6.2.17', 'yes'),
 (287, 'revslider-stable-version', '4.2', 'yes'),
 (288, 'revslider-notices', 'a:0:{}', 'yes'),
 (289, 'revslider-addons', 'O:8:\"stdClass\":27:{s:26:\"revslider-whiteboard-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:26:\"revslider-whiteboard-addon\";s:12:\"version_from\";s:5:\"5.2.0\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:10:\"Whiteboard\";s:6:\"line_1\";s:31:\"Create Hand-Drawn Presentations\";s:6:\"line_2\";s:45:\"that are understandable, memorable & engaging\";s:9:\"available\";s:5:\"2.2.0\";s:10:\"background\";s:81:\"//updates.themepunch-ext-b.tools/revslider/addons/images/whiteboard_widget_bg.jpg\";s:6:\"button\";s:11:\"How to use?\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:77:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_whiteboard.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"WB\";}}s:22:\"revslider-backup-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:22:\"revslider-backup-addon\";s:12:\"version_from\";s:5:\"5.2.0\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:6:\"Backup\";s:6:\"line_1\";s:12:\"Make Backups\";s:6:\"line_2\";s:25:\"Revisions for your safety\";s:9:\"available\";s:5:\"2.0.1\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:11:\"How to use?\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:73:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_backup.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"BU\";}}s:23:\"revslider-gallery-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:23:\"revslider-gallery-addon\";s:12:\"version_from\";s:5:\"5.2.0\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:17:\"WordPress Gallery\";s:6:\"line_1\";s:31:\"Replace the standard WP Gallery\";s:6:\"line_2\";s:31:\"with the Sliders of your choice\";s:9:\"available\";s:5:\"2.0.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:76:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_wpgallery.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"GA\";}}s:25:\"revslider-rel-posts-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:25:\"revslider-rel-posts-addon\";s:12:\"version_from\";s:7:\"5.2.4.1\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:13:\"Related Posts\";s:6:\"line_1\";s:25:\"Add related Posts Sliders\";s:6:\"line_2\";s:31:\"at the end of your post content\";s:9:\"available\";s:5:\"2.0.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:76:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_wprelated.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"RP\";}}s:26:\"revslider-typewriter-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:26:\"revslider-typewriter-addon\";s:12:\"version_from\";s:5:\"5.3.0\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:17:\"Typewriter Effect\";s:6:\"line_1\";s:27:\"Enhance your slider\'s text \";s:6:\"line_2\";s:24:\"with typewriter effects \";s:9:\"available\";s:5:\"2.0.3\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:77:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_typewriter.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"TW\";}}s:23:\"revslider-sharing-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:23:\"revslider-sharing-addon\";s:12:\"version_from\";s:5:\"5.3.1\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:14:\"Social Sharing\";s:6:\"line_1\";s:17:\"Share your slides\";s:6:\"line_2\";s:50:\"with RevSlider \"actions\" because sharing is caring\";s:9:\"available\";s:5:\"2.0.5\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:11:\"How to use?\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:80:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_socialsharing.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"SH\";}}s:27:\"revslider-maintenance-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:27:\"revslider-maintenance-addon\";s:12:\"version_from\";s:5:\"5.3.1\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:15:\"Coming & Maint.\";s:6:\"line_1\";s:37:\"Simple Coming Soon & Maintenance Page\";s:6:\"line_2\";s:42:\"Let your visitors know what\'s up and when!\";s:9:\"available\";s:5:\"2.1.1\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:84:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_underconstruction.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"MT\";}}s:20:\"revslider-snow-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:20:\"revslider-snow-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:12:\"Holiday Snow\";s:6:\"line_1\";s:12:\"Let it snow!\";s:6:\"line_2\";s:32:\"Add animated snow to any Slider \";s:9:\"available\";s:5:\"2.0.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:11:\"How to use?\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:71:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_snow.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"SN\";}}s:25:\"revslider-particles-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:25:\"revslider-particles-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:16:\"Particle Effects\";s:6:\"line_1\";s:17:\"Let\'s Parti(cle)!\";s:6:\"line_2\";s:51:\"Add interactive particle animations to your sliders\";s:9:\"available\";s:5:\"2.2.4\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:11:\"How to use?\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:76:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_particles.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"PT\";}}s:24:\"revslider-polyfold-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:24:\"revslider-polyfold-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:22:\"Polyfold Scroll Effect\";s:6:\"line_1\";s:32:\"Add sharp edges to your sliders \";s:6:\"line_2\";s:35:\"as they scroll into and out of view\";s:9:\"available\";s:5:\"2.0.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:11:\"How to use?\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:75:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_polyfold.jpg\";s:5:\"color\";s:7:\"#3e186f\";s:4:\"text\";s:2:\"PF\";}}s:19:\"revslider-404-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:19:\"revslider-404-addon\";s:12:\"version_from\";s:3:\"5.3\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:3:\"404\";s:6:\"line_1\";s:39:\"Build custom 404 \"Page not Found\" Pages\";s:6:\"line_2\";s:28:\"with Slider Revolution swag!\";s:9:\"available\";s:5:\"2.0.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:70:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_404.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:3:\"404\";}}s:30:\"revslider-prevnext-posts-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:30:\"revslider-prevnext-posts-addon\";s:12:\"version_from\";s:3:\"5.4\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:14:\"Adjacent Posts\";s:6:\"line_1\";s:30:\"Display previous and next post\";s:6:\"line_2\";s:28:\"to the currently showing one\";s:9:\"available\";s:5:\"2.0.1\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:77:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_wpadjacent.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"PN\";}}s:25:\"revslider-filmstrip-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:25:\"revslider-filmstrip-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:9:\"Filmstrip\";s:6:\"line_1\";s:44:\"Display a continously rotating set of images\";s:6:\"line_2\";s:26:\"for your slide backgrounds\";s:9:\"available\";s:5:\"2.0.3\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:76:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_filmstrip.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"FS\";}}s:21:\"revslider-login-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:21:\"revslider-login-addon\";s:12:\"version_from\";s:3:\"5.4\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:10:\"Login Page\";s:6:\"line_1\";s:25:\"Very simple WP Login Page\";s:6:\"line_2\";s:34:\"enhanced with your favorite slider\";s:9:\"available\";s:5:\"2.0.1\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:72:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_login.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"LI\";}}s:24:\"revslider-featured-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:24:\"revslider-featured-addon\";s:12:\"version_from\";s:3:\"5.4\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:20:\"Post Featured Slider\";s:6:\"line_1\";s:25:\"Display a featured Slider\";s:6:\"line_2\";s:41:\"instead of a featured Image in your Posts\";s:9:\"available\";s:5:\"2.0.1\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:1;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:77:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_wpfeatured.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"FT\";}}s:22:\"revslider-slicey-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:22:\"revslider-slicey-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:6:\"Slicey\";s:6:\"line_1\";s:20:\"Slice \'em up nicely!\";s:6:\"line_2\";s:38:\"Create image slices of your background\";s:9:\"available\";s:5:\"2.0.6\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:73:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_slicey.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"SL\";}}s:27:\"revslider-beforeafter-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:27:\"revslider-beforeafter-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:14:\"Before & After\";s:6:\"line_1\";s:35:\"Compare two slides before and after\";s:6:\"line_2\";s:33:\"use it vertically or horizontally\";s:9:\"available\";s:5:\"2.0.7\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:78:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_beforeafter.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"BA\";}}s:23:\"revslider-weather-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:23:\"revslider-weather-addon\";s:12:\"version_from\";s:7:\"5.4.5.2\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:7:\"Weather\";s:6:\"line_1\";s:21:\"Every where you go...\";s:6:\"line_2\";s:36:\"...always take the weather with you!\";s:9:\"available\";s:5:\"2.0.1\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:9:\"Configure\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:74:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_weather.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"WT\";}}s:24:\"revslider-panorama-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:24:\"revslider-panorama-addon\";s:12:\"version_from\";s:7:\"5.4.5.2\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:8:\"Panorama\";s:6:\"line_1\";s:14:\"Panorama AddOn\";s:6:\"line_2\";s:23:\"Display images in 360°\";s:9:\"available\";s:5:\"2.1.2\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:75:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_panorama.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"PN\";}}s:30:\"revslider-duotonefilters-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:30:\"revslider-duotonefilters-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:7:\"Duotone\";s:6:\"line_1\";s:7:\"Duotone\";s:6:\"line_2\";s:25:\"Because one is not enough\";s:9:\"available\";s:5:\"2.0.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:74:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_duotone.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:3:\"DTF\";}}s:24:\"revslider-revealer-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:24:\"revslider-revealer-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:6:\"Reveal\";s:6:\"line_1\";s:9:\"Reveal...\";s:6:\"line_2\";s:37:\"...your inner beast... and RevSliders\";s:9:\"available\";s:5:\"2.1.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:73:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_reveal.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"RV\";}}s:23:\"revslider-refresh-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:23:\"revslider-refresh-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:8:\"(Re)Load\";s:6:\"line_1\";s:39:\"Reload the current page or a custom URL\";s:6:\"line_2\";s:34:\"after a certain time, loops, slide\";s:9:\"available\";s:5:\"2.0.0\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:73:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_reload.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"RF\";}}s:27:\"revslider-bubblemorph-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:27:\"revslider-bubblemorph-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:11:\"BubbleMorph\";s:6:\"line_1\";s:26:\"Include BubbleMorph Layers\";s:6:\"line_2\";s:33:\"for a decorative lava lamp effect\";s:9:\"available\";s:5:\"2.1.5\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:78:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_bubblemorph.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"BM\";}}s:28:\"revslider-liquideffect-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:28:\"revslider-liquideffect-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:10:\"Distortion\";s:6:\"line_1\";s:22:\"Add Distortion Effects\";s:6:\"line_2\";s:30:\"to your slides and transitions\";s:9:\"available\";s:5:\"2.0.4\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:77:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_distortion.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"LE\";}}s:31:\"revslider-explodinglayers-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:31:\"revslider-explodinglayers-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:16:\"Exploding Layers\";s:6:\"line_1\";s:23:\"Add explosive particles\";s:6:\"line_2\";s:24:\"to your layers animation\";s:9:\"available\";s:5:\"2.1.3\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:76:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_exploding.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"EL\";}}s:26:\"revslider-paintbrush-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:26:\"revslider-paintbrush-addon\";s:12:\"version_from\";s:5:\"5.4.6\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:10:\"Paintbrush\";s:6:\"line_1\";s:14:\"Paint or Erase\";s:6:\"line_2\";s:22:\"your background images\";s:9:\"available\";s:5:\"2.1.8\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:6:\"How To\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:77:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_paintbrush.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"PB\";}}s:29:\"revslider-domain-switch-addon\";O:8:\"stdClass\":11:{s:4:\"slug\";s:29:\"revslider-domain-switch-addon\";s:12:\"version_from\";s:5:\"6.0.0\";s:10:\"version_to\";s:5:\"9.9.9\";s:5:\"title\";s:13:\"Domain Switch\";s:6:\"line_1\";s:17:\"Switch Image URLs\";s:6:\"line_2\";s:37:\"in sliders from one domain to another\";s:9:\"available\";s:5:\"1.0.1\";s:10:\"background\";s:0:\"\";s:6:\"button\";s:11:\"How to use?\";s:6:\"global\";b:0;s:4:\"logo\";O:8:\"stdClass\":3:{s:3:\"img\";s:79:\"//updates.themepunch-ext-b.tools/revslider/addons/images/addon_domainswitch.jpg\";s:5:\"color\";s:0:\"\";s:4:\"text\";s:2:\"DS\";}}}', 'yes'),
 (187, 'updraftplus_version', '1.16.26', 'yes'),
 (188, 'updraft_updraftvault', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-ad43fcdf71a5480c93f1375c98190e62\";a:3:{s:5:\"token\";s:0:\"\";s:5:\"email\";s:0:\"\";s:5:\"quota\";i:-1;}}}', 'yes'),
 (189, 'updraft_dropbox', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-86cfb41d2b2d77269a1ea2bc5f447bcb\";a:4:{s:6:\"appkey\";s:0:\"\";s:6:\"secret\";s:0:\"\";s:6:\"folder\";s:0:\"\";s:15:\"tk_access_token\";s:0:\"\";}}}', 'yes'),
 (190, 'updraft_s3', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-2c17a2b32d27cb74f002d10fef9e7c84\";a:5:{s:9:\"accesskey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:4:\"path\";s:0:\"\";s:3:\"rrs\";s:0:\"\";s:22:\"server_side_encryption\";s:0:\"\";}}}', 'yes'),
 (191, 'updraft_cloudfiles', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-c635c167a5d8d3549660be0838012c6f\";a:5:{s:4:\"user\";s:0:\"\";s:7:\"authurl\";s:35:\"https://auth.api.rackspacecloud.com\";s:6:\"apikey\";s:0:\"\";s:4:\"path\";s:0:\"\";s:6:\"region\";N;}}}', 'yes'),
 (192, 'updraft_googledrive', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-6b15eeb63935e26080f021b1e74a3d81\";a:3:{s:8:\"clientid\";s:0:\"\";s:6:\"secret\";s:0:\"\";s:5:\"token\";s:0:\"\";}}}', 'yes'),
 (193, 'updraft_onedrive', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-7f7ea85b136a3c160725e3181ade8ebf\";a:0:{}}}', 'yes'),
 (194, 'updraft_ftp', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-1d9c643cbda79439c76791a110eeec74\";a:5:{s:4:\"host\";s:0:\"\";s:4:\"user\";s:0:\"\";s:4:\"pass\";s:0:\"\";s:4:\"path\";s:0:\"\";s:7:\"passive\";i:1;}}}', 'yes'),
 (195, 'updraft_azure', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-daa6eadcae7003d9aaca75836b89d4d2\";a:0:{}}}', 'yes'),
 (196, 'updraft_sftp', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-67c8eaff90d66b0ff32691bfc8c64bf3\";a:0:{}}}', 'yes'),
 (197, 'updraft_googlecloud', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-146d79e7d9d228cd3c70a21f1b426bff\";a:0:{}}}', 'yes'),
 (198, 'updraft_backblaze', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-6fa97db965d3047773ac08ce2e97a6dc\";a:0:{}}}', 'yes'),
 (199, 'updraft_webdav', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-b177f4368e94a3870652abaf55dd2c5a\";a:0:{}}}', 'yes'),
 (200, 'updraft_s3generic', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-052241ba4b09dcb868aa2104b91dc854\";a:4:{s:9:\"accesskey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:4:\"path\";s:0:\"\";s:8:\"endpoint\";s:0:\"\";}}}', 'yes'),
 (201, 'updraft_openstack', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-038e392fea3d7e36a293cc722dc9af33\";a:6:{s:4:\"user\";s:0:\"\";s:7:\"authurl\";s:0:\"\";s:8:\"password\";s:0:\"\";s:6:\"tenant\";s:0:\"\";s:4:\"path\";s:0:\"\";s:6:\"region\";s:0:\"\";}}}', 'yes'),
 (202, 'updraft_dreamobjects', 'a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-2cdeb55435f74dfb7b34d6aaac932eab\";a:3:{s:9:\"accesskey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:4:\"path\";s:0:\"\";}}}', 'yes'),
 (203, 'updraftplus-addons_siteid', '658357f1857a0e9bdc87c9f3ed557098', 'no'),
 (204, 'updraft_lastmessage', 'El respaldo parece haber tenido éxito y ahora está completado (Ago 10 14:53:00)', 'yes'),
 (205, 'updraftplus_unlocked_fd', '1', 'no'),
 (206, 'updraftplus_last_lock_time_fd', '2020-08-10 14:50:35', 'no'),
 (207, 'updraftplus_semaphore_fd', '0', 'no'),
 (208, 'updraft_last_scheduled_fd', '1597071035', 'yes'),
 (210, 'updraftplus_tour_cancelled_on', 'backup_now_btn_success', 'yes'),
 (211, 'updraft_backup_history', 'a:3:{i:1597071035;a:19:{s:7:\"plugins\";a:1:{i:0;s:58:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-plugins.zip\";}s:12:\"plugins-size\";i:25587076;s:6:\"themes\";a:1:{i:0;s:57:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-themes.zip\";}s:11:\"themes-size\";i:7082612;s:7:\"uploads\";a:1:{i:0;s:58:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-uploads.zip\";}s:12:\"uploads-size\";i:1865;s:6:\"others\";a:1:{i:0;s:57:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-others.zip\";}s:11:\"others-size\";i:6683222;s:2:\"db\";s:52:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-db.gz\";s:7:\"db-size\";i:2395649;s:9:\"checksums\";a:2:{s:4:\"sha1\";a:5:{s:8:\"plugins0\";s:40:\"557764078a1df747a48f12e08448e45789c234b0\";s:7:\"themes0\";s:40:\"05f917bb738e21739ded0c21527ffe6d873db8a3\";s:8:\"uploads0\";s:40:\"147e2c6d2a1a0030f4f130e9de9804c18263bea5\";s:7:\"others0\";s:40:\"a6855de494b792162e6ba7b363d5b0f2861c2699\";s:3:\"db0\";s:40:\"2e97cf0c3b3e08e99f614c3b409ff4bbb47fcbee\";}s:6:\"sha256\";a:5:{s:8:\"plugins0\";s:64:\"c6540dc562a6b3028a9c6886f4eadc21858f6e028ca35b9a0c00b00f75e93fd8\";s:7:\"themes0\";s:64:\"d27fba69797c8a9575270b27b4a003af6005f5e85df2dbc200bdf6fe09716e1d\";s:8:\"uploads0\";s:64:\"d950f11c0cbf074eb2a618d6398f9a8b8085a756b369c0b90aa1ec51c6f07b6c\";s:7:\"others0\";s:64:\"770b01df7c68121bd38c344457187f52e0b861a862ef6699e33539ac5d70bc47\";s:3:\"db0\";s:64:\"8808b3bdff299644e469e3ff7ed7253a725a7e7ae00389e3d03d6d25e70c0a5b\";}}s:5:\"nonce\";s:12:\"7df8525ca88f\";s:7:\"service\";a:1:{i:0;s:4:\"none\";}s:20:\"service_instance_ids\";a:0:{}s:11:\"always_keep\";b:1;s:19:\"files_enumerated_at\";a:4:{s:7:\"plugins\";i:1597071035;s:6:\"themes\";i:1597071154;s:7:\"uploads\";i:1597071163;s:6:\"others\";i:1597071163;}s:18:\"created_by_version\";s:7:\"1.16.26\";s:21:\"last_saved_by_version\";s:7:\"1.16.26\";s:12:\"is_multisite\";b:0;}i:1593004371;a:18:{s:7:\"plugins\";a:1:{i:0;s:58:\"backup_2020-06-24-1312_Sitio_Demo_f31583d01c39-plugins.zip\";}s:12:\"plugins-size\";i:30103904;s:6:\"themes\";a:1:{i:0;s:57:\"backup_2020-06-24-1312_Sitio_Demo_f31583d01c39-themes.zip\";}s:11:\"themes-size\";i:7082612;s:7:\"uploads\";a:1:{i:0;s:58:\"backup_2020-06-24-1312_Sitio_Demo_f31583d01c39-uploads.zip\";}s:12:\"uploads-size\";i:6388;s:6:\"others\";a:1:{i:0;s:57:\"backup_2020-06-24-1312_Sitio_Demo_f31583d01c39-others.zip\";}s:11:\"others-size\";i:3377264;s:5:\"nonce\";s:12:\"f31583d01c39\";s:7:\"service\";a:1:{i:0;s:4:\"none\";}s:20:\"service_instance_ids\";a:0:{}s:11:\"always_keep\";b:0;s:19:\"files_enumerated_at\";a:4:{s:7:\"plugins\";i:1593004371;s:6:\"themes\";i:1593004549;s:7:\"uploads\";i:1593004570;s:6:\"others\";i:1593004570;}s:18:\"created_by_version\";s:7:\"1.16.25\";s:21:\"last_saved_by_version\";s:7:\"1.16.25\";s:12:\"is_multisite\";b:0;s:2:\"db\";a:1:{i:0;s:52:\"backup_2020-06-24-1312_Sitio_Demo_f31583d01c39-db.gz\";}s:7:\"db-size\";i:2268450;}i:1588675741;a:18:{s:7:\"plugins\";a:1:{i:0;s:58:\"backup_2020-05-05-1049_Sitio_Demo_4fc43b57e118-plugins.zip\";}s:12:\"plugins-size\";i:29870733;s:6:\"themes\";a:1:{i:0;s:57:\"backup_2020-05-05-1049_Sitio_Demo_4fc43b57e118-themes.zip\";}s:11:\"themes-size\";i:7082612;s:7:\"uploads\";a:1:{i:0;s:58:\"backup_2020-05-05-1049_Sitio_Demo_4fc43b57e118-uploads.zip\";}s:12:\"uploads-size\";i:6126;s:6:\"others\";a:1:{i:0;s:57:\"backup_2020-05-05-1049_Sitio_Demo_4fc43b57e118-others.zip\";}s:11:\"others-size\";i:3369509;s:5:\"nonce\";s:12:\"4fc43b57e118\";s:7:\"service\";a:1:{i:0;s:4:\"none\";}s:20:\"service_instance_ids\";a:0:{}s:11:\"always_keep\";b:1;s:19:\"files_enumerated_at\";a:4:{s:7:\"plugins\";i:1588675741;s:6:\"themes\";i:1588675878;s:7:\"uploads\";i:1588675897;s:6:\"others\";i:1588675897;}s:18:\"created_by_version\";s:7:\"1.16.23\";s:21:\"last_saved_by_version\";s:7:\"1.16.23\";s:12:\"is_multisite\";b:0;s:2:\"db\";a:1:{i:0;s:52:\"backup_2020-05-05-1049_Sitio_Demo_4fc43b57e118-db.gz\";}s:7:\"db-size\";i:1907199;}}', 'no'),
 (832, '_cerber_report', 'a:2:{i:0;i:1586164730;i:1;b:1;}', 'no'),
 (934, 'wordfence_syncAttackDataAttempts', '0', 'no'),
 (935, 'wordfence_syncingAttackData', '0', 'no'),
 (1477, 'updraft_remotesites', '', 'yes'),
 (1478, 'updraft_migrator_localkeys', '', 'yes'),
 (1479, 'updraft_central_localkeys', '', 'yes'),
 (220, 'woocommerce_meta_box_errors', 'a:0:{}', 'yes'),
 (221, 'woocommerce_admin_notices', 'a:1:{i:0;s:7:\"install\";}', 'yes'),
 (298, 'revslider_update_version', '6.2.0', 'yes'),
 (299, 'widget_rev-slider-widget', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (300, 'revslider_update_revision_current', '6.2.0', 'yes'),
 (303, 'edd_api_request_7e90a2c2fbeeac7d327e31f18c353008', 'a:2:{s:7:\"timeout\";i:1588557860;s:5:\"value\";s:123:\"{\"new_version\":\"\",\"stable_version\":\"\",\"sections\":\"\",\"license_check\":\"\",\"msg\":\"License key is not valid for Duplicator Pro\"}\";}', 'yes'),
 (308, 'updraft_last_backup', 'a:5:{s:11:\"backup_time\";i:1597071035;s:12:\"backup_array\";a:11:{s:7:\"plugins\";a:1:{i:0;s:58:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-plugins.zip\";}s:12:\"plugins-size\";i:25587076;s:6:\"themes\";a:1:{i:0;s:57:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-themes.zip\";}s:11:\"themes-size\";i:7082612;s:7:\"uploads\";a:1:{i:0;s:58:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-uploads.zip\";}s:12:\"uploads-size\";i:1865;s:6:\"others\";a:1:{i:0;s:57:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-others.zip\";}s:11:\"others-size\";i:6683222;s:2:\"db\";s:52:\"backup_2020-08-10-1450_Sitio_Demo_7df8525ca88f-db.gz\";s:7:\"db-size\";i:2395649;s:9:\"checksums\";a:2:{s:4:\"sha1\";a:5:{s:8:\"plugins0\";s:40:\"557764078a1df747a48f12e08448e45789c234b0\";s:7:\"themes0\";s:40:\"05f917bb738e21739ded0c21527ffe6d873db8a3\";s:8:\"uploads0\";s:40:\"147e2c6d2a1a0030f4f130e9de9804c18263bea5\";s:7:\"others0\";s:40:\"a6855de494b792162e6ba7b363d5b0f2861c2699\";s:3:\"db0\";s:40:\"2e97cf0c3b3e08e99f614c3b409ff4bbb47fcbee\";}s:6:\"sha256\";a:5:{s:8:\"plugins0\";s:64:\"c6540dc562a6b3028a9c6886f4eadc21858f6e028ca35b9a0c00b00f75e93fd8\";s:7:\"themes0\";s:64:\"d27fba69797c8a9575270b27b4a003af6005f5e85df2dbc200bdf6fe09716e1d\";s:8:\"uploads0\";s:64:\"d950f11c0cbf074eb2a618d6398f9a8b8085a756b369c0b90aa1ec51c6f07b6c\";s:7:\"others0\";s:64:\"770b01df7c68121bd38c344457187f52e0b861a862ef6699e33539ac5d70bc47\";s:3:\"db0\";s:64:\"8808b3bdff299644e469e3ff7ed7253a725a7e7ae00389e3d03d6d25e70c0a5b\";}}}s:7:\"success\";i:1;s:6:\"errors\";a:0:{}s:12:\"backup_nonce\";s:12:\"7df8525ca88f\";}', 'yes'),
 (296, 'rs-templates', 'a:3:{s:4:\"hash\";s:32:\"4bb4c7d456cb83a3d98582fe094eaedd\";s:6:\"slider\";a:442:{i:0;a:22:{s:2:\"id\";s:1:\"1\";s:5:\"title\";s:16:\"Classic Carousel\";s:5:\"alias\";s:16:\"classic-carousel\";s:3:\"zip\";s:20:\"classic-carousel.zip\";s:3:\"uid\";s:32:\"146a01dd380c0cdee85c4456ee68cd84\";s:3:\"img\";s:27:\"classic-carousel/slider.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/carousel-slider-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:141:\"<span class=\"ttm_content\">Our classic, full-width carousel example. Drag, swipe or click to navigate!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:284:\"<span class=\"ttm_content\">This is a \"Default\" content carousel. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-22 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:1;a:22:{s:2:\"id\";s:1:\"2\";s:5:\"title\";s:14:\"Classic Slider\";s:5:\"alias\";s:13:\"classicslider\";s:3:\"zip\";s:17:\"classicslider.zip\";s:3:\"uid\";s:32:\"a0d6a9248c9066b404ba0f1cdadc5cf2\";s:3:\"img\";s:24:\"classicslider/slider.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/wordpress-slideshow-gallery/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:136:\" <span class=\"ttm_content\">A classic slideshow example with timer, bullets and arrow navigation.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:2;a:22:{s:2:\"id\";s:1:\"3\";s:5:\"title\";s:12:\"Content Tabs\";s:5:\"alias\";s:11:\"contenttabs\";s:3:\"zip\";s:15:\"contenttabs.zip\";s:3:\"uid\";s:32:\"e02e91604b690123a3d07a65582c4fd0\";s:3:\"img\";s:22:\"contenttabs/slider.jpg\";s:7:\"preview\";s:63:\"http://revolution.themepunch.com/wordpress-content-tabs-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:170:\" <span class=\"ttm_content\">An auto-size slider with a cool split-text animation effect. Navigate with vertical bullets and thumbs.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:3;a:22:{s:2:\"id\";s:1:\"4\";s:5:\"title\";s:13:\"Facebook Feed\";s:5:\"alias\";s:13:\"facebook-feed\";s:3:\"zip\";s:17:\"facebook-feed.zip\";s:3:\"uid\";s:32:\"5506431d5b1babcb25dcf52c508d42e3\";s:3:\"img\";s:24:\"facebook-feed/slider.jpg\";s:7:\"preview\";s:57:\"http://revolution.themepunch.com/wordpress-facebook-feed/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:174:\"<span class=\"ttm_content\"> This slider is automatically populated by a Facebook stream. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"Facebook Stream\"</a>. Make sure to input your correct API information in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:11:\"socialmedia\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:4;a:22:{s:2:\"id\";s:1:\"5\";s:5:\"title\";s:7:\"Fashion\";s:5:\"alias\";s:7:\"fashion\";s:3:\"zip\";s:11:\"fashion.zip\";s:3:\"uid\";s:32:\"4f4b914d6db35e19101ff003c4e7ea3a\";s:3:\"img\";s:18:\"fashion/slider.jpg\";s:7:\"preview\";s:65:\"http://revolution.themepunch.com/wordpress-one-page-slider-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:183:\"  <span class=\"ttm_content\">A front-page slider that can be used as an intro for your website. Navigate by using mouse-wheel scroll or bullets.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:5;a:22:{s:2:\"id\";s:1:\"6\";s:5:\"title\";s:14:\"Flickr Gallery\";s:5:\"alias\";s:14:\"flickr-gallery\";s:3:\"zip\";s:18:\"flickr-gallery.zip\";s:3:\"uid\";s:32:\"ad85cfac7acfa678e6a1b8febfee51ed\";s:3:\"img\";s:25:\"flickr-gallery/slider.jpg\";s:7:\"preview\";s:57:\"http://revolution.themepunch.com/wordpress-flickr-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"640\";s:11:\"description\";s:173:\" <span class=\"ttm_content\"> This slider is automatically populated by a Flickr stream. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:413:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"Flickr Stream\"</a>. Make sure to input your correct API information in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:11:\"socialmedia\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:6;a:23:{s:2:\"id\";s:1:\"7\";s:5:\"title\";s:3:\"Gym\";s:5:\"alias\";s:3:\"gym\";s:3:\"zip\";s:7:\"gym.zip\";s:3:\"uid\";s:32:\"e4d81f13f96fb9bc905f4ad89615032b\";s:3:\"img\";s:14:\"gym/slider.jpg\";s:7:\"preview\";s:59:\"http://revolution.themepunch.com/one-page-wordpress-slider/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:189:\"<span class=\"ttm_content\">A front-page slider that can be used as an intro for your website. Navigate by using mouse-wheel scroll or the slider menu.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:583:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Instructions for <a href=\"https://www.themepunch.com/faq/modify-burger-menu/\" target=\"_blank\">changing the menu</a>.</span><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:7;a:22:{s:2:\"id\";s:1:\"8\";s:5:\"title\";s:18:\"Highlight Carousel\";s:5:\"alias\";s:18:\"highlight-carousel\";s:3:\"zip\";s:22:\"highlight-carousel.zip\";s:3:\"uid\";s:32:\"ada52163f723a942f782351fa0396b3d\";s:3:\"img\";s:29:\"highlight-carousel/slider.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/wordpress-swipe-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"720\";s:11:\"description\";s:138:\"  <span class=\"ttm_content\">A swipe-controlled carousel with an additional tab-based navigation.</span>\r\n<span class=\"ttm_space\"></span>\r\n\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:8;a:22:{s:2:\"id\";s:1:\"9\";s:5:\"title\";s:18:\"Highlight Showcase\";s:5:\"alias\";s:18:\"highlight-showcase\";s:3:\"zip\";s:22:\"highlight-showcase.zip\";s:3:\"uid\";s:32:\"2bfe0bd410fb48fec9d942eab1e21530\";s:3:\"img\";s:29:\"highlight-showcase/slider.jpg\";s:7:\"preview\";s:62:\"http://revolution.themepunch.com/wordpress-parallax-slideshow/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1230\";s:6:\"height\";s:3:\"720\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">A tab-based navigation, a slideshow timer and cool animations make this slider interesting!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:9;a:22:{s:2:\"id\";s:2:\"10\";s:5:\"title\";s:10:\"Image Hero\";s:5:\"alias\";s:10:\"image-hero\";s:3:\"zip\";s:13:\"imagehero.zip\";s:3:\"uid\";s:32:\"7db18781d44f2adc28c962440894aac1\";s:3:\"img\";s:20:\"imagehero/slider.jpg\";s:7:\"preview\";s:54:\"http://revolution.themepunch.com/wordpress-hero-image/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:121:\"<span class=\"ttm_content\">A commonly used full-width image hero block with texts.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:10;a:23:{s:2:\"id\";s:2:\"11\";s:5:\"title\";s:17:\"Instagram Gallery\";s:5:\"alias\";s:13:\"insta-gallery\";s:3:\"zip\";s:17:\"insta-gallery.zip\";s:3:\"uid\";s:32:\"711732b0d42ec2b57818a2b9b1d86cba\";s:3:\"img\";s:24:\"insta-gallery/slider.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/wordpress-instagram-gallery/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"640\";s:11:\"description\";s:174:\"<span class=\"ttm_content\">This slider is automatically populated by a Instagram stream. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:416:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"Instagram Stream\"</a>. Make sure to input your correct API information in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:11:\"socialmedia\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:11;a:23:{s:2:\"id\";s:2:\"12\";s:5:\"title\";s:21:\"Levano Restaurant Bar\";s:5:\"alias\";s:19:\"levanorestaurantbar\";s:3:\"zip\";s:23:\"levanorestaurantbar.zip\";s:3:\"uid\";s:32:\"4178f837db67d1b2eb6cb5840bbd0b42\";s:3:\"img\";s:30:\"levanorestaurantbar/slider.jpg\";s:7:\"preview\";s:63:\"http://revolution.themepunch.com/wordpress-front-page-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:181:\"<span class=\"ttm_content\">A front-page slider that can be used as an intro for your website. Navigate by using mouse-wheel scroll or bullets.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:583:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Instructions for <a href=\"https://www.themepunch.com/faq/modify-burger-menu/\" target=\"_blank\">changing the menu</a>.</span><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:12;a:22:{s:2:\"id\";s:2:\"13\";s:5:\"title\";s:19:\"Main Feature Slider\";s:5:\"alias\";s:11:\"mainfeature\";s:3:\"zip\";s:15:\"mainfeature.zip\";s:3:\"uid\";s:32:\"1e002a3230ab00095bedc6f60393ee7f\";s:3:\"img\";s:22:\"mainfeature/slider.jpg\";s:7:\"preview\";s:33:\"http://revolution.themepunch.com/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1230\";s:6:\"height\";s:3:\"750\";s:11:\"description\";s:127:\" <span class=\"ttm_content\">A slightly stripped down version of the main preview slider.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:13;a:22:{s:2:\"id\";s:2:\"14\";s:5:\"title\";s:17:\"Media Gallery Two\";s:5:\"alias\";s:17:\"media-gallery-two\";s:3:\"zip\";s:21:\"media-gallery-two.zip\";s:3:\"uid\";s:32:\"d002f1b1b55805f9322c264c5504ba5a\";s:3:\"img\";s:28:\"media-gallery-two/slider.jpg\";s:7:\"preview\";s:64:\"http://revolution.themepunch.com/wordpress-media-gallery-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1230\";s:6:\"height\";s:3:\"692\";s:11:\"description\";s:127:\"<span class=\"ttm_content\">A media gallery example with Vimeo, HTML5 and Youtube videos.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change media and titles.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:14;a:22:{s:2:\"id\";s:2:\"15\";s:5:\"title\";s:23:\"Media Carousel Autoplay\";s:5:\"alias\";s:23:\"media-carousel-autoplay\";s:3:\"zip\";s:27:\"media-carousel-autoplay.zip\";s:3:\"uid\";s:32:\"393d7875b1cc9d933378b35e4f645d76\";s:3:\"img\";s:34:\"media-carousel-autoplay/slider.jpg\";s:7:\"preview\";s:57:\"http://revolution.themepunch.com/wordpress-media-gallery/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:3:\"720\";s:6:\"height\";s:3:\"405\";s:11:\"description\";s:153:\"<span class=\"ttm_content\">A media carousel with \"autoplay\" activated. Swipe or click tabs to navigate the slider.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:289:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change media and caption texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:15;a:22:{s:2:\"id\";s:2:\"16\";s:5:\"title\";s:21:\"News Background Video\";s:5:\"alias\";s:21:\"news-background-video\";s:3:\"zip\";s:17:\"news-bg-video.zip\";s:3:\"uid\";s:32:\"a0efe44ac3af0f958b3f84c816a08272\";s:3:\"img\";s:24:\"news-bg-video/slider.jpg\";s:7:\"preview\";s:58:\"http://revolution.themepunch.com/wordpress-content-blocks/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"500\";s:11:\"description\";s:143:\"<span class=\"ttm_content\">A hero block with HTML5 background video that plays when entering the screen.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background video and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:16;a:22:{s:2:\"id\";s:2:\"17\";s:5:\"title\";s:12:\"News Gallery\";s:5:\"alias\";s:12:\"news-gallery\";s:3:\"zip\";s:16:\"news-gallery.zip\";s:3:\"uid\";s:32:\"3a069c3b286dbb9ee435563f747e3300\";s:3:\"img\";s:23:\"news-gallery/slider.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/wordpress-news-rotator/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"500\";s:11:\"description\";s:131:\"<span class=\"ttm_content\">A news gallery slideshow with tab navigation. Great for any blog!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:17;a:22:{s:2:\"id\";s:2:\"18\";s:5:\"title\";s:23:\"News Gallery Post Based\";s:5:\"alias\";s:23:\"news-gallery-post-based\";s:3:\"zip\";s:27:\"news-gallery-post-based.zip\";s:3:\"uid\";s:32:\"32fe05b1039c29ab9420bfd15aec5488\";s:3:\"img\";s:34:\"news-gallery-post-based/slider.jpg\";s:7:\"preview\";s:55:\"http://revolution.themepunch.com/wordpress-post-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"500\";s:11:\"description\";s:125:\"<span class=\"ttm_content\"> This slider is automatically populated by WordPress posts.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:423:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"Post-Based Slider\"</a>. Make sure to select the post type you want to display in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:9:\"postbased\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:18;a:22:{s:2:\"id\";s:2:\"19\";s:5:\"title\";s:9:\"News Hero\";s:5:\"alias\";s:9:\"news-hero\";s:3:\"zip\";s:13:\"news-hero.zip\";s:3:\"uid\";s:32:\"96a0385538a17c8c81ed8175740f70ea\";s:3:\"img\";s:20:\"news-hero/slider.jpg\";s:7:\"preview\";s:58:\"http://revolution.themepunch.com/wordpress-content-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"500\";s:11:\"description\";s:107:\"<span class=\"ttm_content\">A image hero block with ken burns effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:19;a:22:{s:2:\"id\";s:2:\"20\";s:5:\"title\";s:10:\"News Video\";s:5:\"alias\";s:10:\"news-video\";s:3:\"zip\";s:14:\"news-video.zip\";s:3:\"uid\";s:32:\"f901e9e16e0363248156c2209eb584e9\";s:3:\"img\";s:21:\"news-video/slider.jpg\";s:7:\"preview\";s:58:\"http://revolution.themepunch.com/wordpress-content-blocks/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"500\";s:11:\"description\";s:128:\"<span class=\"ttm_content\">A Vimeo background video hero block with play / pause buttons.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:289:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the video and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:20;a:23:{s:2:\"id\";s:2:\"21\";s:5:\"title\";s:15:\"Newsletter Hero\";s:5:\"alias\";s:15:\"newsletter-hero\";s:3:\"zip\";s:19:\"newsletter-hero.zip\";s:3:\"uid\";s:32:\"6290a9864d8c4c6311784586ed1cc5fe\";s:3:\"img\";s:26:\"newsletter-hero/slider.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/wordpress-newsletter-signup/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:137:\"<span class=\"ttm_content\">This hero block uses a custom styled Mailchimp newsletter signup field.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:435:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image, texts, and <a href=\"https://www.themepunch.com/faq/how-to-setup-mailchimp-for-the-newsletter-hero-template/\" target=\"_blank\">Mailchimp code</a>.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:21;a:22:{s:2:\"id\";s:2:\"22\";s:5:\"title\";s:11:\"Not Generic\";s:5:\"alias\";s:10:\"notgeneric\";s:3:\"zip\";s:14:\"notgeneric.zip\";s:3:\"uid\";s:32:\"9d87ba95e02210a9f82387add2ceadf9\";s:3:\"img\";s:21:\"notgeneric/slider.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/wordpress-fullscreen-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">A full-screen slider with a layer based navigation and sleek content elements.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:583:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Instructions for <a href=\"https://www.themepunch.com/faq/modify-burger-menu/\" target=\"_blank\">changing the menu</a>.</span><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:22;a:23:{s:2:\"id\";s:2:\"23\";s:5:\"title\";s:11:\"Photography\";s:5:\"alias\";s:11:\"photography\";s:3:\"zip\";s:15:\"photography.zip\";s:3:\"uid\";s:32:\"1b2072547afb75e49f33b016751ed360\";s:3:\"img\";s:22:\"photography/slider.jpg\";s:7:\"preview\";s:62:\"http://revolution.themepunch.com/wordpress-photography-slider/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:194:\"<span class=\"ttm_content\">A front-page slider that can be used as an intro for your website. Navigate by using mouse-wheel scroll or the layer-based menu.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:583:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Instructions for <a href=\"https://www.themepunch.com/faq/modify-burger-menu/\" target=\"_blank\">changing the menu</a>.</span><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:23;a:22:{s:2:\"id\";s:2:\"24\";s:5:\"title\";s:20:\"Photography Carousel\";s:5:\"alias\";s:20:\"photography-carousel\";s:3:\"zip\";s:24:\"photography-carousel.zip\";s:3:\"uid\";s:32:\"9a84b859ba23dc49ba8784e3a86545fa\";s:3:\"img\";s:31:\"photography-carousel/slider.jpg\";s:7:\"preview\";s:57:\"http://revolution.themepunch.com/wordpress-photo-gallery/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">A front-page carousel that can be used as an intro for your website. Navigate by using mouse-wheel scroll or the layer-based menu.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:583:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Instructions for <a href=\"https://www.themepunch.com/faq/modify-burger-menu/\" target=\"_blank\">changing the menu</a>.</span><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:24;a:23:{s:2:\"id\";s:2:\"25\";s:5:\"title\";s:16:\"Search Form Hero\";s:5:\"alias\";s:16:\"search-form-hero\";s:3:\"zip\";s:20:\"search-form-hero.zip\";s:3:\"uid\";s:32:\"e09eb1bd0f22b3a2b02a1aa251dd1f3e\";s:3:\"img\";s:27:\"search-form-hero/slider.jpg\";s:7:\"preview\";s:60:\"http://revolution.themepunch.com/wordpress-search-form-hero/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">This hero block uses a custom styled input field to show search results on a WordPress site.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:320:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image, texts, and search field code.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:25;a:22:{s:2:\"id\";s:2:\"26\";s:5:\"title\";s:17:\"Showcase Carousel\";s:5:\"alias\";s:16:\"showcasecarousel\";s:3:\"zip\";s:20:\"showcasecarousel.zip\";s:3:\"uid\";s:32:\"c5ca218398331bd2c064efc2f62eae56\";s:3:\"img\";s:27:\"showcasecarousel/slider.jpg\";s:7:\"preview\";s:62:\"http://revolution.themepunch.com/wordpress-cover-flow-gallery/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:3:\"600\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:129:\"<span class=\"ttm_content\">A fancy carousel that rotates, fades and scales slider items.</span>\r\n<span class=\"ttm_space\"></span>\r\n\";s:11:\"setup_notes\";s:284:\"<span class=\"ttm_content\">This is a \"Default\" content carousel. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:26;a:22:{s:2:\"id\";s:2:\"27\";s:5:\"title\";s:11:\"Sports Hero\";s:5:\"alias\";s:11:\"sports-hero\";s:3:\"zip\";s:14:\"sportshero.zip\";s:3:\"uid\";s:32:\"8de7a145f32a362d618d2595ffa2f724\";s:3:\"img\";s:21:\"sportshero/slider.jpg\";s:7:\"preview\";s:54:\"http://revolution.themepunch.com/wordpress-image-hero/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"720\";s:11:\"description\";s:113:\"<span class=\"ttm_content\">An sports themed image hero block with buttons.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:27;a:22:{s:2:\"id\";s:2:\"28\";s:5:\"title\";s:12:\"Twitter Feed\";s:5:\"alias\";s:12:\"twitter-feed\";s:3:\"zip\";s:16:\"twitter-feed.zip\";s:3:\"uid\";s:32:\"efbfc2af5da5258e7b7bed8598e483cc\";s:3:\"img\";s:23:\"twitter-feed/slider.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/wordpress-twitter-feed/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:3:\"800\";s:6:\"height\";s:3:\"640\";s:11:\"description\";s:173:\"<span class=\"ttm_content\"> This slider is automatically populated by a Twitter stream. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:414:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"Twitter Stream\"</a>. Make sure to input your correct API information in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:11:\"socialmedia\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:28;a:22:{s:2:\"id\";s:2:\"29\";s:5:\"title\";s:13:\"Vimeo Gallery\";s:5:\"alias\";s:13:\"vimeo-gallery\";s:3:\"zip\";s:17:\"vimeo-gallery.zip\";s:3:\"uid\";s:32:\"fa824ce1ff3942ec268fc9eda60df539\";s:3:\"img\";s:24:\"vimeo-gallery/slider.jpg\";s:7:\"preview\";s:57:\"http://revolution.themepunch.com/wordpress-vimeo-gallery/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1230\";s:6:\"height\";s:3:\"692\";s:11:\"description\";s:170:\"<span class=\"ttm_content\">This slider is automatically populated by a Vimeo stream. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:412:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"Vimeo Stream\"</a>. Make sure to input your correct API information in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:11:\"socialmedia\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:29;a:22:{s:2:\"id\";s:2:\"30\";s:5:\"title\";s:10:\"Vimeo Hero\";s:5:\"alias\";s:9:\"vimeohero\";s:3:\"zip\";s:13:\"vimeohero.zip\";s:3:\"uid\";s:32:\"c575575f96173d88589cddcb06120b77\";s:3:\"img\";s:20:\"vimeohero/slider.jpg\";s:7:\"preview\";s:54:\"http://revolution.themepunch.com/wordpress-hero-vimeo/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:116:\"<span class=\"ttm_content\">A commonly used Vimeo video background hero block.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:464:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background video and texts.<br/><br/></span>\r\nScreencast for <a href=\"https://www.youtube.com/playlist?list=PLSCdqDWVMJPPXEuOEqYEQMAsp0vAYw52_\" target=\"_blank\">mobile video</a> considerations.</a>\r\n<br/><br/>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:30;a:22:{s:2:\"id\";s:2:\"31\";s:5:\"title\";s:16:\"Web Product Dark\";s:5:\"alias\";s:16:\"web-product-dark\";s:3:\"zip\";s:20:\"web-product-dark.zip\";s:3:\"uid\";s:32:\"39b872cf0608e63c3a503e58374dc30a\";s:3:\"img\";s:27:\"web-product-dark/slider.jpg\";s:7:\"preview\";s:60:\"http://revolution.themepunch.com/wordpress-frontpage-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:194:\"<span class=\"ttm_content\">A front-page slider that can be used as an intro for your website. Navigate by using mouse-wheel scroll or the layer-based menu.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:583:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Instructions for <a href=\"https://www.themepunch.com/faq/modify-burger-menu/\" target=\"_blank\">changing the menu</a>.</span><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:31;a:22:{s:2:\"id\";s:2:\"32\";s:5:\"title\";s:21:\"Web Product Dark Hero\";s:5:\"alias\";s:21:\"web-product-dark-hero\";s:3:\"zip\";s:25:\"web-product-dark-hero.zip\";s:3:\"uid\";s:32:\"b6784e8925221f36677217979d26e6f0\";s:3:\"img\";s:32:\"web-product-dark-hero/slider.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/wordpress-header-image/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:162:\"<span class=\"ttm_content\">A modern hero block with three common devices. The screens of each device can be changed easily!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:32;a:22:{s:2:\"id\";s:2:\"33\";s:5:\"title\";s:22:\"Web Product Light Hero\";s:5:\"alias\";s:22:\"web-product-light-hero\";s:3:\"zip\";s:26:\"web-product-light-hero.zip\";s:3:\"uid\";s:32:\"428e65d6aaa6ef775429989d50516492\";s:3:\"img\";s:33:\"web-product-light-hero/slider.jpg\";s:7:\"preview\";s:54:\"http://revolution.themepunch.com/hero-image-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:162:\"<span class=\"ttm_content\">A modern hero block with three common devices. The screens of each device can be changed easily!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:289:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:33;a:22:{s:2:\"id\";s:2:\"34\";s:5:\"title\";s:17:\"Web Product Light\";s:5:\"alias\";s:15:\"webproductlight\";s:3:\"zip\";s:19:\"webproductlight.zip\";s:3:\"uid\";s:32:\"fa23dab5bf1139c6393828647a9de4e0\";s:3:\"img\";s:26:\"webproductlight/slider.jpg\";s:7:\"preview\";s:54:\"http://revolution.themepunch.com/wordpress-cover-page/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:194:\"<span class=\"ttm_content\">A front-page slider that can be used as an intro for your website. Navigate by using mouse-wheel scroll or the layer-based menu.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:583:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Instructions for <a href=\"https://www.themepunch.com/faq/modify-burger-menu/\" target=\"_blank\">changing the menu</a>.</span><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:34;a:22:{s:2:\"id\";s:2:\"35\";s:5:\"title\";s:15:\"Youtube Gallery\";s:5:\"alias\";s:15:\"youtube-gallery\";s:3:\"zip\";s:19:\"youtube-gallery.zip\";s:3:\"uid\";s:32:\"ee9e4928ac74f5f0c0b697ce708f5aa7\";s:3:\"img\";s:26:\"youtube-gallery/slider.jpg\";s:7:\"preview\";s:59:\"http://revolution.themepunch.com/wordpress-youtube-gallery/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:173:\"<span class=\"ttm_content\"> This slider is automatically populated by a YouTube stream. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:414:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"YouTube Stream\"</a>. Make sure to input your correct API information in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:11:\"socialmedia\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:35;a:22:{s:2:\"id\";s:2:\"36\";s:5:\"title\";s:12:\"Youtube Hero\";s:5:\"alias\";s:11:\"youtubehero\";s:3:\"zip\";s:15:\"youtubehero.zip\";s:3:\"uid\";s:32:\"e0b2c12a45841bdf21cb96305f2c85bf\";s:3:\"img\";s:22:\"youtubehero/slider.jpg\";s:7:\"preview\";s:58:\"http://revolution.themepunch.com/wordpress-youtube-header/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:104:\"<span class=\"ttm_content\">A YouTube video background hero block.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:633:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background video and texts.<br/><br/></span>\r\nScreencast for <a href=\"https://www.youtube.com/playlist?list=PLSCdqDWVMJPPXEuOEqYEQMAsp0vAYw52_\" target=\"_blank\">mobile video</a> considerations.</a>\r\n<br/><br/>\r\nLearn how to <a href=\"https://www.themepunch.com/faq/enable-sound-for-the-youtube-hero-template/\" target=\"_blank\">enable sound for the background video</a><br /><br />\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:15:\"Revolution Base\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:36;a:22:{s:2:\"id\";s:2:\"37\";s:5:\"title\";s:13:\"Scroll Effect\";s:5:\"alias\";s:13:\"scroll-effect\";s:3:\"zip\";s:17:\"scroll-effect.zip\";s:3:\"uid\";s:32:\"417f59e9db87aa7e47c8509eb88d4af6\";s:3:\"img\";s:23:\"scrolleffect/slide1.jpg\";s:7:\"preview\";s:60:\"http://revolution.themepunch.com/big-bold-fullscreen-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:134:\"<span class=\"ttm_content\">A full-screen slider with a unique scroll effect and big, bold text.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:485:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>For further configuration options please view the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">\"Custom CSS/JS\"</a> section in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:37;a:22:{s:2:\"id\";s:2:\"38\";s:5:\"title\";s:12:\"Content Zoom\";s:5:\"alias\";s:12:\"content-zoom\";s:3:\"zip\";s:16:\"content-zoom.zip\";s:3:\"uid\";s:32:\"42ef8cdb70d42ec6ff6fa3b69a027b5f\";s:3:\"img\";s:22:\"contentzoom/slide1.jpg\";s:7:\"preview\";s:53:\"http://revolution.themepunch.com/content-zoom-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:243:\"<span class=\"ttm_content\">A very unique full-width slider that uses <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> to their potential.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:371:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:38;a:22:{s:2:\"id\";s:2:\"39\";s:5:\"title\";s:13:\"Food Carousel\";s:5:\"alias\";s:13:\"food-carousel\";s:3:\"zip\";s:17:\"food-carousel.zip\";s:3:\"uid\";s:32:\"a7bf54527b6658a0a308c70c729779fe\";s:3:\"img\";s:29:\"foodcarousel/slider_cover.jpg\";s:7:\"preview\";s:54:\"http://revolution.themepunch.com/food-carousel-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:267:\"<span class=\"ttm_content\">A fancy carousel with detail content on each slide. <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> are used to show and hide layers.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:371:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:39;a:23:{s:2:\"id\";s:2:\"40\";s:5:\"title\";s:14:\"Rotating Words\";s:5:\"alias\";s:14:\"rotating-words\";s:3:\"zip\";s:18:\"rotating-words.zip\";s:3:\"uid\";s:32:\"70190463d9376f278c8197b7b2ef6c1b\";s:3:\"img\";s:24:\"rotatingwords/slide1.jpg\";s:7:\"preview\";s:53:\"http://revolution.themepunch.com/rotating-words-hero/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:134:\"<span class=\"ttm_content\">A full-screen hero block with unique animated text and blur effects.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:495:\"<span class=\"ttm_content\">This is a \"Default\" hero slider. Edit the slide to change the background media and texts.<br/>For further configuration options please view the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">\"Custom CSS/JS\"</a> section in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:40;a:22:{s:2:\"id\";s:2:\"41\";s:5:\"title\";s:22:\"Travel Static Captions\";s:5:\"alias\";s:22:\"travel-static-captions\";s:3:\"zip\";s:26:\"travel-static-captions.zip\";s:3:\"uid\";s:32:\"bbe7d61c7c741ebc7aa1ce1082b0cb71\";s:3:\"img\";s:33:\"travel-static-captions/slide1.jpg\";s:7:\"preview\";s:50:\"http://revolution.themepunch.com/travel-slideshow/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:148:\"<span class=\"ttm_content\">A slideshow example with static captions layers above a rotating image background.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:41;a:22:{s:2:\"id\";s:2:\"42\";s:5:\"title\";s:7:\"Concept\";s:5:\"alias\";s:7:\"concept\";s:3:\"zip\";s:11:\"concept.zip\";s:3:\"uid\";s:32:\"47cb06083e87503762f6746725117a3c\";s:3:\"img\";s:18:\"concept/slide1.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/fullscreen-wordpress-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">A full-screen slider that uses <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> to their potential.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:371:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:42;a:22:{s:2:\"id\";s:2:\"43\";s:5:\"title\";s:15:\"True Fullscreen\";s:5:\"alias\";s:17:\"fullscreen-button\";s:3:\"zip\";s:21:\"fullscreen-button.zip\";s:3:\"uid\";s:32:\"618a43bdf89333b555531f6d6ecde359\";s:3:\"img\";s:28:\"fullscreen-button/slide1.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/wordpress-sidebar-slideshow/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:246:\"<span class=\"ttm_content\">A slider with a full-screen button that uses <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> to their potential.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:297:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change the background images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:43;a:22:{s:2:\"id\";s:2:\"44\";s:5:\"title\";s:16:\"Creative Freedom\";s:5:\"alias\";s:15:\"creativefreedom\";s:3:\"zip\";s:19:\"creativefreedom.zip\";s:3:\"uid\";s:32:\"8902bf6c93126c2c6323626b9e872621\";s:3:\"img\";s:26:\"creativefreedom/slide1.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/wordpress-touch-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A full-screen slider with a unique vertical navigation and 3D-parallax effects.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:290:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images, videos and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:44;a:22:{s:2:\"id\";s:2:\"45\";s:5:\"title\";s:17:\"3D Parallax Scene\";s:5:\"alias\";s:13:\"parallaxscene\";s:3:\"zip\";s:17:\"parallaxscene.zip\";s:3:\"uid\";s:32:\"51566f1ce649708e97a0f5dfaf05ea19\";s:3:\"img\";s:24:\"parallaxscene/slide1.jpg\";s:7:\"preview\";s:55:\"http://revolution.themepunch.com/wordpress-3d-parallax/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:3:\"5.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"700\";s:11:\"description\";s:328:\"<span class=\"ttm_content\">A 3D-parallax hero scene with mouse-controlled effects. Smart image arrangement creates a convincing 3D effect. Tooltips are shown using <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a>.</span>\r\n</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:45;a:22:{s:2:\"id\";s:2:\"46\";s:5:\"title\";s:10:\"Wow Factor\";s:5:\"alias\";s:15:\"slidingoverlays\";s:3:\"zip\";s:19:\"slidingoverlays.zip\";s:3:\"uid\";s:32:\"18002d17e8bc7ca61b0951f5305a759e\";s:3:\"img\";s:26:\"slidingoverlays/slide1.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/responsive-wordpress-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:106:\"<span class=\"ttm_content\">A 3D-parallax effect full-screen slider.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:446:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\nScreencast for <a href=\"https://www.youtube.com/playlist?list=PLSCdqDWVMJPPXEuOEqYEQMAsp0vAYw52_\" target=\"_blank\">mobile video</a> considerations.</a>\r\n<br/><br/>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:46;a:22:{s:2:\"id\";s:2:\"47\";s:5:\"title\";s:14:\"3D Web Product\";s:5:\"alias\";s:25:\"web-product-light-hero-3d\";s:3:\"zip\";s:29:\"web-product-light-hero-3d.zip\";s:3:\"uid\";s:32:\"efd345c5da805414093e46066cefd751\";s:3:\"img\";s:36:\"web-product-light-hero-3d/slide1.jpg\";s:7:\"preview\";s:52:\"http://revolution.themepunch.com/wordpress-3d-scene/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.1\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:3:\"668\";s:11:\"description\";s:149:\"<span class=\"ttm_content\">A 3D-parallax hero scene slider with a convincing depth-effect and animated clouds.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:47;a:22:{s:2:\"id\";s:2:\"48\";s:5:\"title\";s:15:\"WooCommerce Big\";s:5:\"alias\";s:6:\"woobig\";s:3:\"zip\";s:10:\"woobig.zip\";s:3:\"uid\";s:32:\"bfb09a39656c7c80e86b468fc5b3403c\";s:3:\"img\";s:17:\"woobig/slide1.jpg\";s:7:\"preview\";s:52:\"http://revolution.themepunch.com/woocommerce-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1200\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:173:\"<span class=\"ttm_content\">This slider is automatically populated by WooCommerce posts. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"WooCommerce Slider\"</a>. Make sure to select the products you want to show in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:9:\"postbased\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:48;a:22:{s:2:\"id\";s:2:\"49\";s:5:\"title\";s:17:\"WooCommerce Small\";s:5:\"alias\";s:16:\"woocommercesmall\";s:3:\"zip\";s:20:\"woocommercesmall.zip\";s:3:\"uid\";s:32:\"b17c2adcc5c4c4b68a7ac6fee32fa030\";s:3:\"img\";s:27:\"woocommercesmall/slide1.jpg\";s:7:\"preview\";s:52:\"http://revolution.themepunch.com/woocommerce-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.1\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"266\";s:11:\"description\";s:174:\" <span class=\"ttm_content\">This slider is automatically populated by WooCommerce posts. Just one slide is needed to show a whole feed!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"WooCommerce Slider\"</a>. Make sure to select the products you want to show in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:9:\"postbased\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:49;a:22:{s:2:\"id\";s:2:\"50\";s:5:\"title\";s:17:\"Restaurant Header\";s:5:\"alias\";s:10:\"finedining\";s:3:\"zip\";s:14:\"finedining.zip\";s:3:\"uid\";s:32:\"03481a9e258501fbe3888b48830ea845\";s:3:\"img\";s:21:\"finedining/slide1.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/restaurant-hero-header/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:275:\"<span class=\"ttm_content\">A full-screen hero block slider that shows different background layers on button hover using <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a>.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:464:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\nScreencast for <a href=\"https://www.youtube.com/playlist?list=PLSCdqDWVMJPPXEuOEqYEQMAsp0vAYw52_\" target=\"_blank\">mobile video</a> considerations.</a>\r\n<br/><br/>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:50;a:22:{s:2:\"id\";s:2:\"51\";s:5:\"title\";s:21:\"Agency Website Header\";s:5:\"alias\";s:12:\"agency-intro\";s:3:\"zip\";s:16:\"agency-intro.zip\";s:3:\"uid\";s:32:\"e9be2afdd55a0c8d0d8d0cc12ba4c82f\";s:3:\"img\";s:23:\"agency-intro/slide1.jpg\";s:7:\"preview\";s:60:\"http://revolution.themepunch.com/agency-website-hero-header/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:302:\" <span class=\"ttm_content\">A full-screen hero block slider with ken burns effect and video modal on button click. <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> are used to achieve this effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:371:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:51;a:22:{s:2:\"id\";s:2:\"52\";s:5:\"title\";s:11:\"Team Slider\";s:5:\"alias\";s:7:\"ourteam\";s:3:\"zip\";s:11:\"ourteam.zip\";s:3:\"uid\";s:32:\"d8eb1fec07a79202d1118bb17f70c233\";s:3:\"img\";s:18:\"ourteam/slide1.jpg\";s:7:\"preview\";s:74:\"http://revolution.themepunch.com/thumbnail-hover-slider-revolution-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.1.4\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:303:\"<span class=\"ttm_content\">A team slider that changes slides and displays additional information on thumbnail hover. It uses <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> to achieve this effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:657:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\nLearn how to <a href=\"https://www.themepunch.com/faq/modify-thumbnails-for-our-team-template/\" target=\"_blank\">modify the thumbnails</a><br/><br/>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:52;a:22:{s:2:\"id\";s:2:\"53\";s:5:\"title\";s:13:\"Team Carousel\";s:5:\"alias\";s:17:\"our-team-carousel\";s:3:\"zip\";s:21:\"our-team-carousel.zip\";s:3:\"uid\";s:32:\"37656d5dcab1f265c025cb2a3d669809\";s:3:\"img\";s:26:\"ourteamcarousel/slide1.jpg\";s:7:\"preview\";s:83:\"http://revolution.themepunch.com/thumbnail-hover-carousel-slider-revolution-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.1.4\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:306:\" <span class=\"ttm_content\">A team carousel that changes slides and displays additional information on thumbnail hover. It uses <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> to achieve this effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:659:\"<span class=\"ttm_content\">This is a \"Default\" content carousel. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\nLearn how to <a href=\"https://www.themepunch.com/faq/modify-thumbnails-for-our-team-template/\" target=\"_blank\">modify the thumbnails</a><br/><br/>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:53;a:22:{s:2:\"id\";s:2:\"54\";s:5:\"title\";s:17:\"4K Youtube Slider\";s:5:\"alias\";s:13:\"betteryoutube\";s:3:\"zip\";s:17:\"betteryoutube.zip\";s:3:\"uid\";s:32:\"d7c5fef9f257037d7a148038aa2a1857\";s:3:\"img\";s:24:\"betteryoutube/slide1.jpg\";s:7:\"preview\";s:94:\"http://revolution.themepunch.com/fullscreen-4k-youtube-video-gallery-slider-revolution-plugin/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.1.4\";s:5:\"width\";s:4:\"1200\";s:6:\"height\";s:3:\"675\";s:11:\"description\";s:293:\" <span class=\"ttm_content\">A full-screen youtube gallery with 4K videos as an example. <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> are used to breathe life into navigation elements.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:535:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change videos and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/><br/></span>\r\nScreencast for <a href=\"https://www.youtube.com/playlist?list=PLSCdqDWVMJPPXEuOEqYEQMAsp0vAYw52_\" target=\"_blank\">mobile video</a> considerations.</a>\r\n<br/><br/>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:54;a:22:{s:2:\"id\";s:2:\"55\";s:5:\"title\";s:21:\"Agency Website Header\";s:5:\"alias\";s:19:\"agencywebsiteheader\";s:3:\"zip\";s:23:\"agencywebsiteheader.zip\";s:3:\"uid\";s:32:\"c11d272c87277a7a38d9e7fd13e27947\";s:3:\"img\";s:30:\"agencywebsiteheader/slide1.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/fullscreen-hero-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:245:\" <span class=\"ttm_content\">A very unique full-screen slider that uses <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> to their potential.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:509:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:55;a:22:{s:2:\"id\";s:2:\"56\";s:5:\"title\";s:11:\"Coming Soon\";s:5:\"alias\";s:10:\"comingsoon\";s:3:\"zip\";s:14:\"comingsoon.zip\";s:3:\"uid\";s:32:\"0f89edf995512e6d6e864a2ee7221829\";s:3:\"img\";s:21:\"comingsoon/slide1.jpg\";s:7:\"preview\";s:79:\"http://revolution.themepunch.com/coming-soon-wordpress-under-construction-site/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:299:\"<span class=\"ttm_content\">A full-screen slider that can be used as a \"Coming Soon\" page. <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a> are used to achieve various interaction possibilities.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:638:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>For further configuration options please view the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">\"Custom CSS/JS\"</a> section in the slider settings.<br/><br/></span>\r\nInstructions for <a href=\"https://www.themepunch.com/faq/change-date-for-coming-soon-template/\" target=\"_blank\">how to change the date.</a><br /><br />\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:56;a:22:{s:2:\"id\";s:2:\"57\";s:5:\"title\";s:20:\"Christmas Snow Scene\";s:5:\"alias\";s:9:\"snowscene\";s:3:\"zip\";s:13:\"snowscene.zip\";s:3:\"uid\";s:32:\"a747bf0837caff86c62419a746690209\";s:3:\"img\";s:20:\"snowscene/slide1.jpg\";s:7:\"preview\";s:54:\"http://revolution.themepunch.com/christmas-snow-scene/\";s:7:\"version\";s:5:\"1.0.5\";s:8:\"required\";s:5:\"5.0.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:141:\"<span class=\"ttm_content\">A slider with multiple christmas themed slides and a neat snow fall effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:485:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>For further configuration options please view the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">\"Custom CSS/JS\"</a> section in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:57;a:22:{s:2:\"id\";s:2:\"58\";s:5:\"title\";s:15:\"Rock Band Music\";s:5:\"alias\";s:8:\"rockband\";s:3:\"zip\";s:12:\"rockband.zip\";s:3:\"uid\";s:32:\"5f557a5fad2fd6ca982a6ae6e9619637\";s:3:\"img\";s:19:\"rockband/slide1.jpg\";s:7:\"preview\";s:80:\"http://revolution.themepunch.com/rock-band-music-theme-slider-revolution-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:140:\" <span class=\"ttm_content\">A rock band themed hero block slider with an embedded SoundCloud element.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:464:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background video and texts.<br/><br/></span>\r\nScreencast for <a href=\"https://www.youtube.com/playlist?list=PLSCdqDWVMJPPXEuOEqYEQMAsp0vAYw52_\" target=\"_blank\">mobile video</a> considerations.</a>\r\n<br/><br/>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-24 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:58;a:22:{s:2:\"id\";s:2:\"59\";s:5:\"title\";s:18:\"Sleek Landing Page\";s:5:\"alias\";s:16:\"sleeklandingpage\";s:3:\"zip\";s:20:\"sleeklandingpage.zip\";s:3:\"uid\";s:32:\"07f7f2608936a8ae226213b7d99eee3f\";s:3:\"img\";s:27:\"sleeklandingpage/slide1.jpg\";s:7:\"preview\";s:70:\"http://revolution.themepunch.com/landing-page-free-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:191:\"<span class=\"ttm_content\">A full-screen slider that can be used as an App-Landing-Page. The object layers and custom animations create a unique effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-02-22 13:21:33\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:59;a:22:{s:2:\"id\";s:2:\"60\";s:5:\"title\";s:16:\"App Landing Page\";s:5:\"alias\";s:14:\"applandingpage\";s:3:\"zip\";s:18:\"applandingpage.zip\";s:3:\"uid\";s:32:\"38eb600893c1484ab8fd2a3dce3678d7\";s:3:\"img\";s:25:\"applandingpage/slide1.jpg\";s:7:\"preview\";s:64:\"http://revolution.themepunch.com/app-landing-page-free-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:263:\"<span class=\"ttm_content\">A full-screen hero block that can be used as an app landing page. The detail view is build using <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a>.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:371:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>It might be helpful to use the \"hide/show layer\" feature to efficiently edit all content.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:60;a:22:{s:2:\"id\";s:2:\"61\";s:5:\"title\";s:10:\"Desk Scene\";s:5:\"alias\";s:9:\"deskscene\";s:3:\"zip\";s:13:\"deskscene.zip\";s:3:\"uid\";s:32:\"172a1a89a3e3b333cb4dbeb238f534c5\";s:3:\"img\";s:20:\"deskscene/slide1.jpg\";s:7:\"preview\";s:49:\"http://revolution.themepunch.com/hero-desk-scene/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:135:\"<span class=\"ttm_content\">A beautiful desk scene with a cool reveal effect when scrolling down.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:61;a:22:{s:2:\"id\";s:2:\"62\";s:5:\"title\";s:17:\"Clean News Slider\";s:5:\"alias\";s:15:\"cleannewsslider\";s:3:\"zip\";s:19:\"cleannewsslider.zip\";s:3:\"uid\";s:32:\"82c3f521fe31b80984be0f19e1a9899e\";s:3:\"img\";s:26:\"cleannewsslider/slide1.jpg\";s:7:\"preview\";s:55:\"http://revolution.themepunch.com/wordpress-news-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:132:\"<span class=\"ttm_content\">A slideshow example with clean content and thumbnail navigation.</span>\r\n<span class=\"ttm_space\"></span>\r\n\";s:11:\"setup_notes\";s:282:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:62;a:22:{s:2:\"id\";s:2:\"63\";s:5:\"title\";s:13:\"Image Gallery\";s:5:\"alias\";s:12:\"imagegallery\";s:3:\"zip\";s:16:\"imagegallery.zip\";s:3:\"uid\";s:32:\"cef1d75357df2cb53b990c74a214813e\";s:3:\"img\";s:23:\"imagegallery/slide1.jpg\";s:7:\"preview\";s:64:\"http://revolution.themepunch.com/wordpress-photo-gallery-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.0\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"667\";s:11:\"description\";s:239:\"<span class=\"ttm_content\">A photo gallery suitable to display your images using <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> to their potential.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:63;a:22:{s:2:\"id\";s:2:\"64\";s:5:\"title\";s:19:\"Standard WP Gallery\";s:5:\"alias\";s:19:\"standard-wp-gallery\";s:3:\"zip\";s:23:\"standard-wp-gallery.zip\";s:3:\"uid\";s:32:\"632035b8a27652d8081dbdfa343dc93d\";s:3:\"img\";s:30:\"standard-wp-gallery/slide1.jpg\";s:7:\"preview\";s:64:\"http://revolution.themepunch.com/wordpress-photo-gallery-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.0\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"667\";s:11:\"description\";s:143:\"<span class=\"ttm_content\">A photo gallery that uses the \"Standard WP Gallery\" add-on to display images.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:407:\"<span class=\"ttm_content\">Please follow the setup guide on the \"Standard WP Gallery\" add-on page.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:9:\"postbased\";}s:14:\"plugin_require\";s:166:\"[{\"path\":\"revslider-gallery-addon\\/revslider-gallery-addon.php\",\"name\":\"WP Gallery AddOn\",\"url\":\"http:\\/\\/revolution.themepunch.com\\/wordpress-photo-gallery-plugin\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:64;a:22:{s:2:\"id\";s:2:\"65\";s:5:\"title\";s:21:\"Clean News Post Based\";s:5:\"alias\";s:21:\"clean-news-post-based\";s:3:\"zip\";s:25:\"clean-news-post-based.zip\";s:3:\"uid\";s:32:\"f4cf5bbe51afa5a361754bb081cbabf2\";s:3:\"img\";s:32:\"clean-news-post-based/slide1.jpg\";s:7:\"preview\";s:55:\"http://revolution.themepunch.com/wordpress-news-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.0\";s:5:\"width\";s:4:\"1200\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:125:\"<span class=\"ttm_content\"> This slider is automatically populated by WordPress posts.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:423:\"<span class=\"ttm_content\">The content source is set to <a href=\"https://www.themepunch.com/slider-revolution/module-content/#flickr\" target=\"_blank\">\"Post-Based Slider\"</a>. Make sure to select the post type you want to display in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:9:\"postbased\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:65;a:22:{s:2:\"id\";s:2:\"66\";s:5:\"title\";s:22:\"Interactive Whiteboard\";s:5:\"alias\";s:21:\"interactivewhiteboard\";s:3:\"zip\";s:25:\"interactivewhiteboard.zip\";s:3:\"uid\";s:32:\"058b4af535d6c6c7bcec5225845e3eb4\";s:3:\"img\";s:32:\"interactivewhiteboard/slide1.jpg\";s:7:\"preview\";s:77:\"http://revolution.themepunch.com/interactive-whiteboard-animation-free-addon/\";s:7:\"version\";s:5:\"1.0.5\";s:8:\"required\";s:5:\"5.2.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:269:\"<span class=\"ttm_content\">This is the example slider from the Whiteboard add-on preview.<br/><a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> are used to achieve certain effects.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:541:\"<span class=\"ttm_content\">This slider template requires the <a href=\"https://www.themepunch.com/slider-revolution/whiteboard-addon/\" target=\"_blank\">Whiteboard add-on</a> to be installed. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:185:\"[{\"path\":\"revslider-whiteboard-addon\\/revslider-whiteboard-addon.php\",\"name\":\"Whiteboard AddOn\",\"url\":\"http:\\/\\/revolution.themepunch.com\\/interactive-whiteboard-animation-free-addon\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:66;a:22:{s:2:\"id\";s:2:\"68\";s:5:\"title\";s:17:\"Innovation Slider\";s:5:\"alias\";s:10:\"innovation\";s:3:\"zip\";s:14:\"innovation.zip\";s:3:\"uid\";s:32:\"d3440b69126d9c186fddc713b18b0002\";s:3:\"img\";s:21:\"innovation/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/best-wordpress-slider-plugin-2016/\";s:7:\"version\";s:5:\"1.0.5\";s:8:\"required\";s:7:\"5.2.3.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:258:\"<span class=\"ttm_content\">A full-screen slider with an elegant fade-out parallax effect. <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> are used for links on layers.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:493:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images, videos and texts.<br/>For further configuration options please view the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">\"Custom CSS/JS\"</a> section in the slider settings.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"2016-03-29 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:67;a:25:{s:2:\"id\";s:2:\"69\";s:5:\"title\";s:25:\"Dark Content Block - Menu\";s:5:\"alias\";s:24:\"dark-fullsite-block-menu\";s:3:\"zip\";s:34:\"packs/dark-fullsite-block-menu.zip\";s:3:\"uid\";s:32:\"bf4bd226719d3c3d3146592976e31ca1\";s:3:\"img\";s:35:\"dark-fullsite-block-menu/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:68;a:25:{s:2:\"id\";s:2:\"70\";s:5:\"title\";s:25:\"Dark Content Block - Hero\";s:5:\"alias\";s:21:\"dark-fullsite-block-1\";s:3:\"zip\";s:31:\"packs/dark-fullsite-block-1.zip\";s:3:\"uid\";s:32:\"d8859245fe600288ca932dc29aca751f\";s:3:\"img\";s:32:\"dark-fullsite-block-1/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:69;a:25:{s:2:\"id\";s:2:\"71\";s:5:\"title\";s:26:\"Dark Content Block - About\";s:5:\"alias\";s:27:\"dark-fullsite-block-2-about\";s:3:\"zip\";s:37:\"packs/dark-fullsite-block-2-about.zip\";s:3:\"uid\";s:32:\"298401901521a197a8294c1b4f73df3e\";s:3:\"img\";s:38:\"dark-fullsite-block-2-about/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:70;a:25:{s:2:\"id\";s:2:\"72\";s:5:\"title\";s:29:\"Dark Content Block - Services\";s:5:\"alias\";s:30:\"dark-fullsite-block-3-services\";s:3:\"zip\";s:40:\"packs/dark-fullsite-block-3-services.zip\";s:3:\"uid\";s:32:\"8da3ed605472ed6a26c745fb52f85f82\";s:3:\"img\";s:41:\"dark-fullsite-block-3-services/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:71;a:25:{s:2:\"id\";s:2:\"73\";s:5:\"title\";s:29:\"Dark Content Block - Products\";s:5:\"alias\";s:30:\"dark-fullsite-block-4-products\";s:3:\"zip\";s:40:\"packs/dark-fullsite-block-4-products.zip\";s:3:\"uid\";s:32:\"99e4f40399d20261a6131043d0e50b0c\";s:3:\"img\";s:41:\"dark-fullsite-block-4-products/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:422:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\r\n\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:72;a:25:{s:2:\"id\";s:2:\"74\";s:5:\"title\";s:33:\"Dark Content Block - Testimonials\";s:5:\"alias\";s:34:\"dark-fullsite-block-5-testimonials\";s:3:\"zip\";s:44:\"packs/dark-fullsite-block-5-testimonials.zip\";s:3:\"uid\";s:32:\"2f9121e0eedd51afe85e233d0743acab\";s:3:\"img\";s:45:\"dark-fullsite-block-5-testimonials/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:73;a:25:{s:2:\"id\";s:2:\"75\";s:5:\"title\";s:28:\"Dark Content Block - Callout\";s:5:\"alias\";s:29:\"dark-fullsite-block-6-callout\";s:3:\"zip\";s:39:\"packs/dark-fullsite-block-6-callout.zip\";s:3:\"uid\";s:32:\"55fbecb113ff21f050be7adc08637329\";s:3:\"img\";s:40:\"dark-fullsite-block-6-callout/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:74;a:25:{s:2:\"id\";s:2:\"76\";s:5:\"title\";s:27:\"Dark Content Block - Footer\";s:5:\"alias\";s:28:\"dark-fullsite-block-7-footer\";s:3:\"zip\";s:38:\"packs/dark-fullsite-block-7-footer.zip\";s:3:\"uid\";s:32:\"2ff517f5c7c54e3e0c2dd733cfd3400e\";s:3:\"img\";s:39:\"dark-fullsite-block-7-footer/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:75;a:25:{s:2:\"id\";s:2:\"77\";s:5:\"title\";s:26:\"Light Content Block - Menu\";s:5:\"alias\";s:19:\"fullsite-block-menu\";s:3:\"zip\";s:29:\"packs/fullsite-block-menu.zip\";s:3:\"uid\";s:32:\"8010971f34387d5f94a1f4e577ef382a\";s:3:\"img\";s:30:\"fullsite-block-menu/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:76;a:25:{s:2:\"id\";s:2:\"78\";s:5:\"title\";s:26:\"Light Content Block - Hero\";s:5:\"alias\";s:15:\"fullsite-block1\";s:3:\"zip\";s:25:\"packs/fullsite-block1.zip\";s:3:\"uid\";s:32:\"45bf7179843e01ce112e8ec754b0455c\";s:3:\"img\";s:26:\"fullsite-block1/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:77;a:25:{s:2:\"id\";s:2:\"79\";s:5:\"title\";s:27:\"Light Content Block - About\";s:5:\"alias\";s:22:\"fullsite-block-2-about\";s:3:\"zip\";s:32:\"packs/fullsite-block-2-about.zip\";s:3:\"uid\";s:32:\"8402b460638a746d36433cb161440b7d\";s:3:\"img\";s:33:\"fullsite-block-2-about/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:78;a:25:{s:2:\"id\";s:2:\"80\";s:5:\"title\";s:30:\"Light Content Block - Services\";s:5:\"alias\";s:25:\"fullsite-block-3-services\";s:3:\"zip\";s:35:\"packs/fullsite-block-3-services.zip\";s:3:\"uid\";s:32:\"7b8cea27f4d6ae17c5e1eae12457bd06\";s:3:\"img\";s:36:\"fullsite-block-3-services/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:79;a:25:{s:2:\"id\";s:2:\"81\";s:5:\"title\";s:30:\"Light Content Block - Products\";s:5:\"alias\";s:25:\"fullsite-block-4-products\";s:3:\"zip\";s:35:\"packs/fullsite-block-4-products.zip\";s:3:\"uid\";s:32:\"d148935362d7122636cda0635eae4be7\";s:3:\"img\";s:36:\"fullsite-block-4-products/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:80;a:25:{s:2:\"id\";s:2:\"82\";s:5:\"title\";s:34:\"Light Content Block - Testimonials\";s:5:\"alias\";s:29:\"fullsite-block-5-testimonials\";s:3:\"zip\";s:39:\"packs/fullsite-block-5-testimonials.zip\";s:3:\"uid\";s:32:\"06255bfd421e40f71fa8197b839dbf03\";s:3:\"img\";s:40:\"fullsite-block-5-testimonials/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:81;a:25:{s:2:\"id\";s:2:\"83\";s:5:\"title\";s:29:\"Light Content Block - Callout\";s:5:\"alias\";s:24:\"fullsite-block-6-callout\";s:3:\"zip\";s:34:\"packs/fullsite-block-6-callout.zip\";s:3:\"uid\";s:32:\"8a88c3447676b613ec5db2fe5d63315c\";s:3:\"img\";s:35:\"fullsite-block-6-callout/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:82;a:25:{s:2:\"id\";s:2:\"84\";s:5:\"title\";s:28:\"Light Content Block - Footer\";s:5:\"alias\";s:23:\"fullsite-block-7-footer\";s:3:\"zip\";s:33:\"packs/fullsite-block-7-footer.zip\";s:3:\"uid\";s:32:\"34300b4407a2093eb2e1e08868fa8319\";s:3:\"img\";s:34:\"fullsite-block-7-footer/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:83;a:22:{s:2:\"id\";s:2:\"85\";s:5:\"title\";s:12:\"Tech Journal\";s:5:\"alias\";s:11:\"techjournal\";s:3:\"zip\";s:15:\"techjournal.zip\";s:3:\"uid\";s:32:\"7f92d70d1c108378f915b18c2ceb71d6\";s:3:\"img\";s:22:\"techjournal/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.1\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:130:\"<span class=\"ttm_content\">A full-width slider with navigation direction-based transitions.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:277:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:84;a:22:{s:2:\"id\";s:2:\"86\";s:5:\"title\";s:14:\"Car Dealership\";s:5:\"alias\";s:13:\"cardealership\";s:3:\"zip\";s:17:\"cardealership.zip\";s:3:\"uid\";s:32:\"bb010838855a8ae4d1dd68e139bf169e\";s:3:\"img\";s:24:\"cardealership/slide1.jpg\";s:7:\"preview\";s:56:\"https://revolution.themepunch.com/car-dealership-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"650\";s:11:\"description\";s:130:\"<span class=\"ttm_content\">A full-width slider with navigation direction-based transitions.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:277:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:85;a:22:{s:2:\"id\";s:2:\"87\";s:5:\"title\";s:22:\"FullScreen Menu Slider\";s:5:\"alias\";s:14:\"fullscreenmenu\";s:3:\"zip\";s:18:\"fullscreenmenu.zip\";s:3:\"uid\";s:32:\"6de81d74c4bf193e2e274d43038adc85\";s:3:\"img\";s:25:\"fullscreenmenu/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-fullscreen-menu/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:131:\"<span class=\"ttm_content\">A full-screen slider that contains a menu with slide blur effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:86;a:22:{s:2:\"id\";s:2:\"88\";s:5:\"title\";s:18:\"Creative Frontpage\";s:5:\"alias\";s:17:\"creativefrontpage\";s:3:\"zip\";s:21:\"creativefrontpage.zip\";s:3:\"uid\";s:32:\"0636cb368af3bcaa2f68eb0ebefe6439\";s:3:\"img\";s:28:\"creativefrontpage/slide1.jpg\";s:7:\"preview\";s:56:\"https://revolution.themepunch.com/best-wordpress-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:246:\"<span class=\"ttm_content\">A full-screen slider with hidden slides that are triggered via  <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\" target=\"_blank\">\"Layer Actions\"</a>.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:87;a:25:{s:2:\"id\";s:2:\"89\";s:5:\"title\";s:20:\"Website Builder Menu\";s:5:\"alias\";s:19:\"websitebuilder-menu\";s:3:\"zip\";s:29:\"packs/websitebuilder-menu.zip\";s:3:\"uid\";s:32:\"d9e6d9c961f123a3a4847b51fc3ba3a2\";s:3:\"img\";s:30:\"websitebuilder-menu/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:2:\"60\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:88;a:25:{s:2:\"id\";s:2:\"90\";s:5:\"title\";s:20:\"Website Builder Hero\";s:5:\"alias\";s:19:\"websitebuilder-hero\";s:3:\"zip\";s:29:\"packs/websitebuilder-hero.zip\";s:3:\"uid\";s:32:\"6cb2df9a41ad2e7865bb9bbea7e39cb5\";s:3:\"img\";s:30:\"websitebuilder-hero/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1230\";s:6:\"height\";s:3:\"700\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:89;a:25:{s:2:\"id\";s:2:\"91\";s:5:\"title\";s:23:\"Website Builder Clients\";s:5:\"alias\";s:22:\"websitebuilder-clients\";s:3:\"zip\";s:32:\"packs/websitebuilder-clients.zip\";s:3:\"uid\";s:32:\"050e59c43c9a693510d01f29532088cf\";s:3:\"img\";s:33:\"websitebuilder-clients/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"120\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:90;a:25:{s:2:\"id\";s:2:\"92\";s:5:\"title\";s:24:\"Website Builder Services\";s:5:\"alias\";s:23:\"websitebuilder-services\";s:3:\"zip\";s:33:\"packs/websitebuilder-services.zip\";s:3:\"uid\";s:32:\"48d56d67615efce619ae973ab4358c07\";s:3:\"img\";s:34:\"websitebuilder-services/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"558\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:91;a:26:{s:2:\"id\";s:2:\"93\";s:5:\"title\";s:24:\"Website Builder Discover\";s:5:\"alias\";s:23:\"websitebuilder-discover\";s:3:\"zip\";s:33:\"packs/websitebuilder-discover.zip\";s:3:\"uid\";s:32:\"425a08a7be338daea3df02a07ff5c316\";s:3:\"img\";s:34:\"websitebuilder-discover/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"955\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:92;a:25:{s:2:\"id\";s:2:\"94\";s:5:\"title\";s:22:\"Website Builder Slider\";s:5:\"alias\";s:21:\"websitebuilder-slider\";s:3:\"zip\";s:31:\"packs/websitebuilder-slider.zip\";s:3:\"uid\";s:32:\"9d670b7335016accb590dc8d52bfb6f0\";s:3:\"img\";s:32:\"websitebuilder-slider/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"500\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:93;a:25:{s:2:\"id\";s:2:\"95\";s:5:\"title\";s:28:\"Website Builder CallToAction\";s:5:\"alias\";s:27:\"websitebuilder-calltoaction\";s:3:\"zip\";s:37:\"packs/websitebuilder-calltoaction.zip\";s:3:\"uid\";s:32:\"45851baf9e61f55ed9f5fa9d0beff77e\";s:3:\"img\";s:38:\"websitebuilder-calltoaction/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"960\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:94;a:25:{s:2:\"id\";s:2:\"96\";s:5:\"title\";s:22:\"Website Builder Footer\";s:5:\"alias\";s:21:\"websitebuilder-footer\";s:3:\"zip\";s:31:\"packs/websitebuilder-footer.zip\";s:3:\"uid\";s:32:\"2732bbe66ef28219d6cc53ce8cc78863\";s:3:\"img\";s:32:\"websitebuilder-footer/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:95;a:22:{s:2:\"id\";s:2:\"97\";s:5:\"title\";s:21:\"Focus Parallax Effect\";s:5:\"alias\";s:13:\"focusparallax\";s:3:\"zip\";s:17:\"focusparallax.zip\";s:3:\"uid\";s:32:\"13bd15fb3ddf8b9841cb55b89389cc73\";s:3:\"img\";s:24:\"focusparallax/slide1.jpg\";s:7:\"preview\";s:68:\" https://revolution.themepunch.com/parallax-effect-wordpress-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:256:\"<span class=\"ttm_content\">A full-screen slider with mouse controlled parallax effects. <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> are used for links on layers.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:415:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/>Some content is in <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">\"Static / Global Layers\"</a><br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:96;a:22:{s:2:\"id\";s:2:\"98\";s:5:\"title\";s:14:\"Duotone Slider\";s:5:\"alias\";s:7:\"duotone\";s:3:\"zip\";s:11:\"duotone.zip\";s:3:\"uid\";s:32:\"494862ceb6cb7c6658ad7cd36848cccd\";s:3:\"img\";s:18:\"duotone/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/wordpress-header-image-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.4\";s:5:\"width\";s:4:\"1200\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:252:\"<span class=\"ttm_content\">A full-screen slider with unique parallax scroll effect. <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> are used for links on layers.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:277:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:97;a:25:{s:2:\"id\";s:2:\"99\";s:5:\"title\";s:12:\"Minimal Menu\";s:5:\"alias\";s:6:\"r_menu\";s:3:\"zip\";s:16:\"packs/r_menu.zip\";s:3:\"uid\";s:32:\"30d6a6895db1a5f29b1679061551c9f0\";s:3:\"img\";s:17:\"r_menu/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/minimal-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"110\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:890:\"<span class=\"ttm_content\">\r\nIn the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">Custom JavaScript</a> section of the \"Minimal Menu\" Template you can scroll down to the color change section.<br/>\r\nFor any elements you want to background color change in addition to the sites body, add this class to the <a href=\"https://www.themepunch.com/revslider-doc/layer-attributes/\" target=\"_blank\">Layers Attributes</a> \".tp-colorchange\".<br/><br/>\r\nIf you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:24:\"Minimal Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"4\";s:9:\"installed\";b:0;}i:98;a:25:{s:2:\"id\";s:3:\"100\";s:5:\"title\";s:12:\"Minimal Hero\";s:5:\"alias\";s:5:\"rhero\";s:3:\"zip\";s:16:\"packs/r_hero.zip\";s:3:\"uid\";s:32:\"b8b46186956f6e66ad0c08e4532bbbde\";s:3:\"img\";s:17:\"r_hero/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/minimal-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"700\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:890:\"<span class=\"ttm_content\">\r\nIn the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">Custom JavaScript</a> section of the \"Minimal Menu\" Template you can scroll down to the color change section.<br/>\r\nFor any elements you want to background color change in addition to the sites body, add this class to the <a href=\"https://www.themepunch.com/revslider-doc/layer-attributes/\" target=\"_blank\">Layers Attributes</a> \".tp-colorchange\".<br/><br/>\r\nIf you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:24:\"Minimal Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"4\";s:9:\"installed\";b:0;}i:99;a:25:{s:2:\"id\";s:3:\"101\";s:5:\"title\";s:13:\"Minimal About\";s:5:\"alias\";s:7:\"r_about\";s:3:\"zip\";s:17:\"packs/r_about.zip\";s:3:\"uid\";s:32:\"343010c4b4c03f92888c3e9e95bc2bb1\";s:3:\"img\";s:18:\"r_about/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/minimal-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:890:\"<span class=\"ttm_content\">\r\nIn the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">Custom JavaScript</a> section of the \"Minimal Menu\" Template you can scroll down to the color change section.<br/>\r\nFor any elements you want to background color change in addition to the sites body, add this class to the <a href=\"https://www.themepunch.com/revslider-doc/layer-attributes/\" target=\"_blank\">Layers Attributes</a> \".tp-colorchange\".<br/><br/>\r\nIf you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:24:\"Minimal Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"4\";s:9:\"installed\";b:0;}i:100;a:25:{s:2:\"id\";s:3:\"102\";s:5:\"title\";s:16:\"Minimal Products\";s:5:\"alias\";s:10:\"r_products\";s:3:\"zip\";s:20:\"packs/r_products.zip\";s:3:\"uid\";s:32:\"dda93e85c6a4456d132040147f087f39\";s:3:\"img\";s:21:\"r_products/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/minimal-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:4:\"1100\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:890:\"<span class=\"ttm_content\">\r\nIn the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">Custom JavaScript</a> section of the \"Minimal Menu\" Template you can scroll down to the color change section.<br/>\r\nFor any elements you want to background color change in addition to the sites body, add this class to the <a href=\"https://www.themepunch.com/revslider-doc/layer-attributes/\" target=\"_blank\">Layers Attributes</a> \".tp-colorchange\".<br/><br/>\r\nIf you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:24:\"Minimal Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"4\";s:9:\"installed\";b:0;}i:101;a:25:{s:2:\"id\";s:3:\"103\";s:5:\"title\";s:12:\"Minimal Info\";s:5:\"alias\";s:6:\"r_info\";s:3:\"zip\";s:16:\"packs/r_info.zip\";s:3:\"uid\";s:32:\"d6e368e8fd4862174af6c980389ae530\";s:3:\"img\";s:17:\"r_info/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/minimal-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:890:\"<span class=\"ttm_content\">\r\nIn the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">Custom JavaScript</a> section of the \"Minimal Menu\" Template you can scroll down to the color change section.<br/>\r\nFor any elements you want to background color change in addition to the sites body, add this class to the <a href=\"https://www.themepunch.com/revslider-doc/layer-attributes/\" target=\"_blank\">Layers Attributes</a> \".tp-colorchange\".<br/><br/>\r\nIf you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:24:\"Minimal Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"4\";s:9:\"installed\";b:0;}i:102;a:22:{s:2:\"id\";s:3:\"104\";s:5:\"title\";s:18:\"Inspiration Header\";s:5:\"alias\";s:17:\"inspirationheader\";s:3:\"zip\";s:21:\"inspirationheader.zip\";s:3:\"uid\";s:32:\"69f04b2be0b618fa7e184af83b86b7e7\";s:3:\"img\";s:28:\"inspirationheader/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/wordpress-theme-header/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:159:\"<span class=\"ttm_content\">This full-screen hero slider features sequentially animated texts and cool parallax elements.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:103;a:22:{s:2:\"id\";s:3:\"105\";s:5:\"title\";s:15:\"Magazine Slider\";s:5:\"alias\";s:13:\"magazineposts\";s:3:\"zip\";s:17:\"magazineposts.zip\";s:3:\"uid\";s:32:\"c562f3457e4edbd030959f7c5e6e0f7c\";s:3:\"img\";s:24:\"magazineposts/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-magazine-slider/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1400\";s:6:\"height\";s:4:\"1000\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">A full-width slider with a mouse-controlled 3D-Parallax effect. Enjoy! <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> are used for links on layers.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:277:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:104;a:22:{s:2:\"id\";s:3:\"106\";s:5:\"title\";s:11:\"News Header\";s:5:\"alias\";s:17:\"explorationheader\";s:3:\"zip\";s:21:\"explorationheader.zip\";s:3:\"uid\";s:32:\"8f20d5a868c90ded08b835fb9e8307d7\";s:3:\"img\";s:28:\"explorationheader/slide1.jpg\";s:7:\"preview\";s:56:\"https://revolution.themepunch.com/wordpress-news-header/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:288:\"<span class=\"ttm_content\">A full-screen slider that is a perfect fit for displaying news on your websites header! Check out <a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> to add links to buttons.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:277:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:105;a:25:{s:2:\"id\";s:3:\"107\";s:5:\"title\";s:23:\"Minimal Website Package\";s:5:\"alias\";s:23:\"minimal-website-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:23:\"minimal-website-package\";s:3:\"img\";s:31:\"packages/template_group_1_1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/minimal-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"110\";s:11:\"description\";s:181:\"<span class=\"ttm_content\">The Minimal Website Template is a one-pager website with a unique background color change effect on scrolling down.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:890:\"<span class=\"ttm_content\">\r\nIn the <a href=\"https://https://www.themepunch.com/slider-revolution/custom-css-javascript/\" target=\"_blank\">Custom JavaScript</a> section of the \"Minimal Menu\" Template you can scroll down to the color change section.<br/>\r\nFor any elements you want to background color change in addition to the sites body, add this class to the <a href=\"https://www.themepunch.com/revslider-doc/layer-attributes/\" target=\"_blank\">Layers Attributes</a> \".tp-colorchange\".<br/><br/>\r\nIf you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:24:\"Minimal Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"4\";s:9:\"installed\";b:0;}i:106;a:25:{s:2:\"id\";s:3:\"108\";s:5:\"title\";s:23:\"Website Builder Package\";s:5:\"alias\";s:22:\"websitebuilder-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:22:\"websitebuilder-package\";s:3:\"img\";s:29:\"packages/template_group_2.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/wordpress-website-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.2.5.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:2:\"60\";s:11:\"description\";s:191:\"<span class=\"ttm_content\">The Website Builder Package is a clean, usable collection website modules that can be used all together or each on their own.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Website Builder\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"3\";s:9:\"installed\";b:0;}i:107;a:25:{s:2:\"id\";s:3:\"109\";s:5:\"title\";s:26:\"Dark Content Block Package\";s:5:\"alias\";s:27:\"dark-fullsite-block-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:27:\"dark-fullsite-block-package\";s:3:\"img\";s:29:\"packages/template_group_4.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/dark-wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">This Minimal Website Template has some sleek parallax effects and on-demand loading modules.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Fullsite Dark\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"2\";s:9:\"installed\";b:0;}i:108;a:25:{s:2:\"id\";s:3:\"110\";s:5:\"title\";s:27:\"Light Content Block Package\";s:5:\"alias\";s:22:\"fullsite-block-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:22:\"fullsite-block-package\";s:3:\"img\";s:29:\"packages/template_group_3.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/wordpress-parallax-theme/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.2.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">This Minimal Website Template has some sleek parallax effects and on-demand loading modules.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:8:\"Fullsite\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"1\";s:9:\"installed\";b:0;}i:109;a:22:{s:2:\"id\";s:3:\"111\";s:5:\"title\";s:17:\"Typewriter Effect\";s:5:\"alias\";s:16:\"typewritereffect\";s:3:\"zip\";s:20:\"typewritereffect.zip\";s:3:\"uid\";s:32:\"d6f8bae06cc4a7b158d680c01e59ddc2\";s:3:\"img\";s:27:\"typewritereffect/slide1.jpg\";s:7:\"preview\";s:62:\"https://revolution.themepunch.com/wordpress-typewriter-effect/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:263:\"<span class=\"ttm_content\">This is the example slider from the Typewriter add-on preview.<br/><a href=\"https://www.themepunch.com/revslider-doc/layer-settings/#layeractions\">\"Layer Actions\"</a> are used for links on buttons.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:403:\"<span class=\"ttm_content\">This slider template requires the <a href=\"https://www.themepunch.com/slider-revolution/typewriter-addon/\" target=\"_blank\">Typewriter add-on</a> to be installed. Edit the slides to change images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:173:\"[{\"path\":\"revslider-typewriter-addon\\/revslider-typewriter-addon.php\",\"name\":\"Typewriter AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/typewriter-addon\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:110;a:22:{s:2:\"id\";s:3:\"112\";s:5:\"title\";s:17:\"Blend Mode Header\";s:5:\"alias\";s:15:\"blendmodeheader\";s:3:\"zip\";s:19:\"blendmodeheader.zip\";s:3:\"uid\";s:32:\"2e44e976596d757aab40ffa28086dcf9\";s:3:\"img\";s:26:\"blendmodeheader/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/blend-mode-hero-header/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:4:\"1000\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">This full-screen hero header with HMTL5 background video, utilizes the new 5.3 blend mode effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:300:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:111;a:27:{s:2:\"id\";s:3:\"113\";s:5:\"title\";s:17:\"Themeplicity Menu\";s:5:\"alias\";s:17:\"themeplicity_menu\";s:3:\"zip\";s:27:\"packs/themeplicity_menu.zip\";s:3:\"uid\";s:32:\"7d5c1e75eaafa63683895a32a62f4ce0\";s:3:\"img\";s:28:\"themeplicity_menu/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:2:\"90\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:112;a:27:{s:2:\"id\";s:3:\"114\";s:5:\"title\";s:19:\"Themeplicity Header\";s:5:\"alias\";s:19:\"themeplicity_header\";s:3:\"zip\";s:29:\"packs/themeplicity_header.zip\";s:3:\"uid\";s:32:\"907091e4d58acc7d12f802de2f280b7d\";s:3:\"img\";s:30:\"themeplicity_header/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:4:\"1000\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:113;a:27:{s:2:\"id\";s:3:\"115\";s:5:\"title\";s:18:\"Themeplicity Offer\";s:5:\"alias\";s:18:\"themeplicity_offer\";s:3:\"zip\";s:28:\"packs/themeplicity_offer.zip\";s:3:\"uid\";s:32:\"1bd8f9aa2f3e340449664c65ba17fb51\";s:3:\"img\";s:29:\"themeplicity_offer/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"330\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:114;a:27:{s:2:\"id\";s:3:\"116\";s:5:\"title\";s:23:\"Themeplicity What We Do\";s:5:\"alias\";s:21:\"themeplicity_whatwedo\";s:3:\"zip\";s:31:\"packs/themeplicity_whatwedo.zip\";s:3:\"uid\";s:32:\"aa800a44b5a3eab30414dde1f32bfed7\";s:3:\"img\";s:32:\"themeplicity_whatwedo/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"813\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:115;a:27:{s:2:\"id\";s:3:\"117\";s:5:\"title\";s:21:\"Themeplicity Projects\";s:5:\"alias\";s:21:\"themeplicity_projects\";s:3:\"zip\";s:31:\"packs/themeplicity_projects.zip\";s:3:\"uid\";s:32:\"5f61b3a13033ba6a51a18270163e0a50\";s:3:\"img\";s:32:\"themeplicity_projects/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"813\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:116;a:27:{s:2:\"id\";s:3:\"118\";s:5:\"title\";s:24:\"Themeplicity Whats Great\";s:5:\"alias\";s:23:\"themeplicity_whatsgreat\";s:3:\"zip\";s:33:\"packs/themeplicity_whatsgreat.zip\";s:3:\"uid\";s:32:\"ce9faf8c55ed2e33e091b23667e7173b\";s:3:\"img\";s:34:\"themeplicity_whatsgreat/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:117;a:27:{s:2:\"id\";s:3:\"119\";s:5:\"title\";s:19:\"Themeplicity Tables\";s:5:\"alias\";s:19:\"themeplicity_tables\";s:3:\"zip\";s:29:\"packs/themeplicity_tables.zip\";s:3:\"uid\";s:32:\"f28bb4cd20ec1f29a1de7da5ad09c293\";s:3:\"img\";s:30:\"themeplicity_tables/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:4:\"1059\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:118;a:27:{s:2:\"id\";s:3:\"120\";s:5:\"title\";s:24:\"Themeplicity Contactform\";s:5:\"alias\";s:24:\"themeplicity_contactform\";s:3:\"zip\";s:34:\"packs/themeplicity_contactform.zip\";s:3:\"uid\";s:32:\"3e59da970f534490774fa8e053f5b5ed\";s:3:\"img\";s:35:\"themeplicity_contactform/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:4:\"1067\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:119;a:27:{s:2:\"id\";s:3:\"121\";s:5:\"title\";s:19:\"Themeplicity Footer\";s:5:\"alias\";s:19:\"themeplicity_footer\";s:3:\"zip\";s:29:\"packs/themeplicity_footer.zip\";s:3:\"uid\";s:32:\"89eeb0b4b852c5f743e1bd76e3e8f2ef\";s:3:\"img\";s:30:\"themeplicity_footer/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"780\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:120;a:27:{s:2:\"id\";s:3:\"122\";s:5:\"title\";s:20:\"Themeplicity Package\";s:5:\"alias\";s:20:\"themeplicity-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:20:\"themeplicity-package\";s:3:\"img\";s:38:\"packages/templatepack_themeplicity.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Themeplicity Website Template uses the new groups & rows feature introduced in 5.3 to its full potential.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Themeplicity Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"5\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:121;a:27:{s:2:\"id\";s:3:\"123\";s:5:\"title\";s:19:\"Nice And Clean Menu\";s:5:\"alias\";s:17:\"NiceAndClean_Menu\";s:3:\"zip\";s:27:\"packs/NiceAndClean_Menu.zip\";s:3:\"uid\";s:32:\"3f8c01e26c7446428e045c4b1180776d\";s:3:\"img\";s:28:\"NiceAndClean_Menu/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:2:\"90\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:122;a:27:{s:2:\"id\";s:3:\"124\";s:5:\"title\";s:21:\"Nice And Clean Header\";s:5:\"alias\";s:19:\"NiceAndClean_Header\";s:3:\"zip\";s:29:\"packs/NiceAndClean_Header.zip\";s:3:\"uid\";s:32:\"76931033addb20a62557c2845a4d6a11\";s:3:\"img\";s:30:\"NiceAndClean_Header/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:123;a:27:{s:2:\"id\";s:3:\"125\";s:5:\"title\";s:23:\"Nice And Clean Services\";s:5:\"alias\";s:21:\"NiceAndClean_Services\";s:3:\"zip\";s:31:\"packs/NiceAndClean_Services.zip\";s:3:\"uid\";s:32:\"02f72ec606800c8215bcadea09624e87\";s:3:\"img\";s:32:\"NiceAndClean_Services/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"360\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:124;a:27:{s:2:\"id\";s:3:\"126\";s:5:\"title\";s:20:\"Nice And Clean About\";s:5:\"alias\";s:18:\"NiceAndClean_About\";s:3:\"zip\";s:28:\"packs/NiceAndClean_About.zip\";s:3:\"uid\";s:32:\"9510f6fdbb8e9473e8c22f692a6bc89f\";s:3:\"img\";s:29:\"NiceAndClean_About/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:125;a:27:{s:2:\"id\";s:3:\"127\";s:5:\"title\";s:20:\"Nice And Clean Video\";s:5:\"alias\";s:18:\"niceandclean_video\";s:3:\"zip\";s:28:\"packs/niceandclean_video.zip\";s:3:\"uid\";s:32:\"2bb9e1ad329435cc500542d0c7025e15\";s:3:\"img\";s:29:\"niceandclean_video/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:126;a:27:{s:2:\"id\";s:3:\"128\";s:5:\"title\";s:25:\"Nice And Clean Highlights\";s:5:\"alias\";s:23:\"niceandclean_highlights\";s:3:\"zip\";s:33:\"packs/niceandclean_highlights.zip\";s:3:\"uid\";s:32:\"ff396af163a79d2d5b35db17c1ea7aa6\";s:3:\"img\";s:34:\"niceandclean_highlights/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:127;a:27:{s:2:\"id\";s:3:\"129\";s:5:\"title\";s:23:\"Nice And Clean Projects\";s:5:\"alias\";s:21:\"NiceAndClean_Projects\";s:3:\"zip\";s:31:\"packs/NiceAndClean_Projects.zip\";s:3:\"uid\";s:32:\"1e6695959ef83f8975b52289c08a4d44\";s:3:\"img\";s:32:\"NiceAndClean_Projects/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:3:\"600\";s:6:\"height\";s:3:\"600\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:128;a:27:{s:2:\"id\";s:3:\"130\";s:5:\"title\";s:25:\"Nice And Clean TextBlocks\";s:5:\"alias\";s:23:\"niceandclean_textblocks\";s:3:\"zip\";s:33:\"packs/niceandclean_textblocks.zip\";s:3:\"uid\";s:32:\"1f33eb839c96ea3225faff1c8d382b05\";s:3:\"img\";s:34:\"niceandclean_textblocks/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:129;a:27:{s:2:\"id\";s:3:\"131\";s:5:\"title\";s:22:\"Nice And Clean CallOut\";s:5:\"alias\";s:20:\"niceandclean_callout\";s:3:\"zip\";s:30:\"packs/niceandclean_callout.zip\";s:3:\"uid\";s:32:\"54d4d9bcf79d357de0e614700e909863\";s:3:\"img\";s:31:\"niceandclean_callout/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"500\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:130;a:27:{s:2:\"id\";s:3:\"132\";s:5:\"title\";s:21:\"Nice And Clean Footer\";s:5:\"alias\";s:19:\"niceandclean_footer\";s:3:\"zip\";s:29:\"packs/niceandclean_footer.zip\";s:3:\"uid\";s:32:\"5492d7f72b3771a4e754f91bda063b15\";s:3:\"img\";s:30:\"niceandclean_footer/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"400\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:542:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">For using the social sharing buttons, please install the social sharing add-on.<br><br></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:131;a:22:{s:2:\"id\";s:3:\"134\";s:5:\"title\";s:15:\"80s Style Intro\";s:5:\"alias\";s:3:\"80s\";s:3:\"zip\";s:7:\"80s.zip\";s:3:\"uid\";s:32:\"98881ab51f71b2fbdb220752d321b15a\";s:3:\"img\";s:14:\"80s/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/80s-style-intro/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:139:\"<span class=\"ttm_content\">This intro hero block takes you back to the 80\'s with some funky effects.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:317:\"<span class=\"ttm_content\">This is a \"Default\" content hero slider. Just edit the slide to change the background image and text.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:132;a:22:{s:2:\"id\";s:3:\"135\";s:5:\"title\";s:18:\"Blur Effect Slider\";s:5:\"alias\";s:10:\"blurslider\";s:3:\"zip\";s:14:\"blurslider.zip\";s:3:\"uid\";s:32:\"83bd6e1ccef83f03c944fa05b0a2d879\";s:3:\"img\";s:21:\"blurslider/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/blur-effect-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:147:\"<span class=\"ttm_content\">This slider makes use of the brand new blur effects available with version 5.3.1.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:315:\"<span class=\"ttm_content\">This is a \"Default\" content slider. Just edit the slides to change the background images and texts.<br/><br/></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:133;a:22:{s:2:\"id\";s:3:\"136\";s:5:\"title\";s:18:\"Coming Soon Add-On\";s:5:\"alias\";s:15:\"ComingSoonAddon\";s:3:\"zip\";s:19:\"ComingSoonAddon.zip\";s:3:\"uid\";s:32:\"51258492055b940099eb96ba52901fa9\";s:3:\"img\";s:26:\"ComingSoonAddon/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/coming-soon-add-on/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:133:\"<span class=\"ttm_content\">This slider template makes use of the brand new Coming Soon Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:197:\"[{\"path\":\"revslider-maintenance-addon\\/revslider-maintenance-addon.php\",\"name\":\"Coming Soon & Maintenance AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/revslider-doc\\/add-coming-soon-maintenance\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:134;a:27:{s:2:\"id\";s:3:\"137\";s:5:\"title\";s:22:\"Nice And Clean Package\";s:5:\"alias\";s:22:\"nice-and-clean-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:22:\"nice-and-clean-package\";s:3:\"img\";s:38:\"packages/templatepack_niceandclean.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/nice-clean-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"800\";s:11:\"description\";s:242:\"<span class=\"ttm_content\">The Nice & Clean Website Template uses groups & rows for a fully responsive website experience. Elegant blur effects available since version 5.3.1 make this template stand out!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"Nice & Clean Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"6\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:135;a:22:{s:2:\"id\";s:3:\"138\";s:5:\"title\";s:18:\"Snow Effect Add-On\";s:5:\"alias\";s:9:\"snowaddon\";s:3:\"zip\";s:13:\"snowaddon.zip\";s:3:\"uid\";s:32:\"7408d8567b8af5716eaabd390422e51b\";s:3:\"img\";s:20:\"snowaddon/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/snow-effect-add-on/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:183:\"<span class=\"ttm_content\">Add a pleasant Snow Effect to your website with this slider template. Make sure to install the \"Holiday Snow\" Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:153:\"[{\"path\":\"revslider-snow-addon\\/revslider-snow-addon.php\",\"name\":\"Snow AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:136;a:22:{s:2:\"id\";s:3:\"139\";s:5:\"title\";s:19:\"Particle Effect One\";s:5:\"alias\";s:19:\"particle-effect-one\";s:3:\"zip\";s:23:\"particle-effect-one.zip\";s:3:\"uid\";s:32:\"a4611c906e35ca60f617da86217b5299\";s:3:\"img\";s:30:\"particle-effect-one/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/particle-effect-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:143:\"<span class=\"ttm_content\">A unique particle effect that can serve as a stunning intro for your website.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:442:\"<span class=\"ttm_content\">The blend mode effect is achieved through a layer image with CSS blend mode. If you want to customize this effect, select the \"BLEND MODE IMAGE\" layer and go to \"advanced style -> filters -> blend mode\".</span>\r\n<span class=\"ttm_space\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:137;a:22:{s:2:\"id\";s:3:\"140\";s:5:\"title\";s:19:\"Particle Effect Two\";s:5:\"alias\";s:19:\"particle-effect-two\";s:3:\"zip\";s:23:\"particle-effect-two.zip\";s:3:\"uid\";s:32:\"b8ecbf43374a69e4ab329ea834862ef8\";s:3:\"img\";s:30:\"particle-effect-two/slide1.jpg\";s:7:\"preview\";s:56:\"https://revolution.themepunch.com/particle-effect-intro/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:143:\"<span class=\"ttm_content\">A unique particle effect that can serve as a stunning intro for your website.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:138;a:22:{s:2:\"id\";s:3:\"141\";s:5:\"title\";s:21:\"Particle Effect Three\";s:5:\"alias\";s:21:\"particle-effect-three\";s:3:\"zip\";s:25:\"particle-effect-three.zip\";s:3:\"uid\";s:32:\"b33bc2c5655d8d51cd17c3740f72e748\";s:3:\"img\";s:32:\"particle-effect-three/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/particle-background-effect/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:143:\"<span class=\"ttm_content\">A unique particle effect that can serve as a stunning intro for your website.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:437:\"<span class=\"ttm_content\">The blend mode effect is achieved through a layer image with CSS blend mode. If you want to customize this effect, select the \"BLEND IMAGE\" layer and go to \"advanced style -> filters -> blend mode\".</span>\r\n<span class=\"ttm_space\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:139;a:23:{s:2:\"id\";s:3:\"142\";s:5:\"title\";s:16:\"Portfolio Viewer\";s:5:\"alias\";s:15:\"portfolioviewer\";s:3:\"zip\";s:19:\"portfolioviewer.zip\";s:3:\"uid\";s:32:\"9ac7230ff5b880fb6c8f28fbbc123b3b\";s:3:\"img\";s:26:\"portfolioviewer/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/wordpress-portfolio-plugin/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:207:\"<span class=\"ttm_content\">This slider template can be used to display your portfolio highlights in a stunning way, utilising out free particles add-on and blend modes.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:387:\"<span class=\"ttm_content\">The navigation for the slides is found in the <a href=\"https://www.themepunch.com/slider-revolution/global-layers/\" target=\"_blank\">Static Layers</a>.</span><span class=\"ttm_space\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:140;a:22:{s:2:\"id\";s:3:\"143\";s:5:\"title\";s:12:\"App Showcase\";s:5:\"alias\";s:11:\"appshowcase\";s:3:\"zip\";s:15:\"appshowcase.zip\";s:3:\"uid\";s:32:\"082aef931b0369080bc30c3a2a0c331f\";s:3:\"img\";s:22:\"appshowcase/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/app-showcase-wordpress-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.3.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:239:\"<span class=\"ttm_content\">This template shows off our new \"Polyfold Effects\" Add-On in form of an App product showcase module. Get started now and illustrate your Apps key features in a striking way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:179:\"[{\"path\":\"revslider-polyfold-addon\\/revslider-polyfold-addon.php\",\"name\":\"Polyfold Scroll Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:141;a:23:{s:2:\"id\";s:3:\"144\";s:5:\"title\";s:19:\"Gravity Design Hero\";s:5:\"alias\";s:13:\"gravitydesign\";s:3:\"zip\";s:17:\"gravitydesign.zip\";s:3:\"uid\";s:32:\"7bdbe73a6e5bf290cb4412708ac4134d\";s:3:\"img\";s:24:\"gravitydesign/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/best-wordpress-slider-plugin-2017/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:205:\"<span class=\"ttm_content\">This hero template shows a striking mouse-parallax scene and cool particle effects. Requires our \"Particle Effects\" Add-on to be installed.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:142;a:23:{s:2:\"id\";s:3:\"145\";s:5:\"title\";s:14:\"404 Error Page\";s:5:\"alias\";s:12:\"404errorpage\";s:3:\"zip\";s:16:\"404errorpage.zip\";s:3:\"uid\";s:32:\"2dc62d802b42b73088651cac17d0c486\";s:3:\"img\";s:23:\"404errorpage/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/404-error-page-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:227:\"<span class=\"ttm_content\">This template can be used as a custom error page on your website with our new 404 page Add-On. Of course you can also use this template as a regular hero header.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:179:\"{\"1\":{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}}\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:143;a:22:{s:2:\"id\";s:3:\"146\";s:5:\"title\";s:16:\"Carousel Gallery\";s:5:\"alias\";s:15:\"carouselgallery\";s:3:\"zip\";s:19:\"carouselgallery.zip\";s:3:\"uid\";s:32:\"041838fd32923c40e15c998f0ea19526\";s:3:\"img\";s:26:\"carouselgallery/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/wordpress-carousel-gallery/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.4\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:159:\"<span class=\"ttm_content\">This carousel gallery features a subtle parallax effect, html5 video and a fullscreen button.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:144;a:23:{s:2:\"id\";s:3:\"147\";s:5:\"title\";s:16:\"Filmstrip Effect\";s:5:\"alias\";s:9:\"filmstrip\";s:3:\"zip\";s:13:\"filmstrip.zip\";s:3:\"uid\";s:32:\"7bd142f272cc15d86998a79520e9e581\";s:3:\"img\";s:20:\"filmstrip/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/filmstrip-add-on-slider/ \";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:241:\"<span class=\"ttm_content\">This template uses our Filmstrip Add-On to display a continuous scrolling set of images per slide.\r\n There is lots of customization options like animation speed and direction.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:180:\"[{\"path\":\"revslider-filmstrip-addon\\/revslider-filmstrip-addon.php\",\"name\":\"Background FilmStrip Add-On\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:145;a:22:{s:2:\"id\";s:3:\"148\";s:5:\"title\";s:11:\"Space Opera\";s:5:\"alias\";s:10:\"spaceopera\";s:3:\"zip\";s:14:\"spaceopera.zip\";s:3:\"uid\";s:32:\"a2c8bffcb138a86c0f373adebb6de046\";s:3:\"img\";s:21:\"spaceopera/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/space-opera-presentation/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.4\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:201:\"<span class=\"ttm_content\">The Space Opera template can be enjoyed as a slow paced, full-screen slider experience and is great to show your most prominent photos.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:146;a:22:{s:2:\"id\";s:3:\"149\";s:5:\"title\";s:13:\"Website Intro\";s:5:\"alias\";s:12:\"websiteintro\";s:3:\"zip\";s:16:\"websiteintro.zip\";s:3:\"uid\";s:32:\"348df76d999456aa19be58c9df56ae20\";s:3:\"img\";s:23:\"websiteintro/slide1.jpg\";s:7:\"preview\";s:65:\"https://revolution.themepunch.com/website-intro-wordpress-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.4\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:274:\"<span class=\"ttm_content\">Making use of our new Slicey Add-On, this slider show a really cool effect you just have to experience yourself! Just change the slides background images and the existing slices will automatically be applied.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:171:\"[{\"path\":\"revslider-slicey-addon\\/revslider-slicey-addon.php\",\"name\":\"Background Slicey Add-On\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:147;a:22:{s:2:\"id\";s:3:\"150\";s:5:\"title\";s:13:\"Mask Showcase\";s:5:\"alias\";s:12:\"maskshowcase\";s:3:\"zip\";s:16:\"maskshowcase.zip\";s:3:\"uid\";s:32:\"fc943c31e2da9c63b252aeabf554d128\";s:3:\"img\";s:23:\"maskshowcase/slide1.jpg\";s:7:\"preview\";s:56:\"https://revolution.themepunch.com/minimal-mask-showcase/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.4\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Mask Showcase template uses gradients and the amazing block layer animations. A minimal slider treat for any website!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:148;a:22:{s:2:\"id\";s:3:\"151\";s:5:\"title\";s:20:\"Parallax Zoom Slices\";s:5:\"alias\";s:18:\"parallaxzoomslices\";s:3:\"zip\";s:22:\"parallaxzoomslices.zip\";s:3:\"uid\";s:32:\"83537cae05709ddb9bcb7375470a5894\";s:3:\"img\";s:29:\"parallaxzoomslices/slide1.jpg\";s:7:\"preview\";s:72:\"https://revolution.themepunch.com/parallax-zoom-slices-wordpress-plugin/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:3:\"5.4\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:249:\"<span class=\"ttm_content\">This template uses the Slicey Add-On to add a unique effect to slide background images. You can simple change the background images and the slice effect will automatically be applied.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:171:\"[{\"path\":\"revslider-slicey-addon\\/revslider-slicey-addon.php\",\"name\":\"Background Slicey Add-On\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:149;a:22:{s:2:\"id\";s:3:\"152\";s:5:\"title\";s:22:\"Double Exposure Effect\";s:5:\"alias\";s:20:\"doubleexposureeffect\";s:3:\"zip\";s:24:\"doubleexposureeffect.zip\";s:3:\"uid\";s:32:\"8d9229b5cbcf5bda5fbdc6a8e01a2b8c\";s:3:\"img\";s:31:\"doubleexposureeffect/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/wordpress-double-exposure-effect/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">Make any website special with the double exposure effect slider. Use as a header module or anywhere you want!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:150;a:22:{s:2:\"id\";s:3:\"153\";s:5:\"title\";s:24:\"Mountain Parallax Header\";s:5:\"alias\";s:22:\"mountainparallaxheader\";s:3:\"zip\";s:26:\"mountainparallaxheader.zip\";s:3:\"uid\";s:32:\"8dc64663f317a2abdf179bbe341d016e\";s:3:\"img\";s:33:\"mountainparallaxheader/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/mountain-wordpress-parallax-header/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:192:\"<span class=\"ttm_content\">This template is a cool intro for any page, featuring a striking parallax effect. Just change texts and links and you\'re done!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:151;a:26:{s:2:\"id\";s:3:\"154\";s:5:\"title\";s:26:\"GoodNews One-Pager Package\";s:5:\"alias\";s:26:\"goodnews-one-pager-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:26:\"goodnews-one-pager-package\";s:3:\"img\";s:44:\"packages/templatepack_goodnews_one_pager.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:4:{i:0;s:8:\"carousel\";i:1;s:6:\"slider\";i:2;s:4:\"hero\";i:3;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:152;a:26:{s:2:\"id\";s:3:\"155\";s:5:\"title\";s:13:\"GoodNews Menu\";s:5:\"alias\";s:12:\"goodnewsmenu\";s:3:\"zip\";s:22:\"packs/goodnewsmenu.zip\";s:3:\"uid\";s:32:\"4cbc82501ff340fcdc0acf7eb3ba2640\";s:3:\"img\";s:23:\"goodnewsmenu/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">You can use this slider as a module on your website or install it as part of a slider pack. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:153;a:26:{s:2:\"id\";s:3:\"156\";s:5:\"title\";s:15:\"GoodNews Header\";s:5:\"alias\";s:14:\"goodnewsheader\";s:3:\"zip\";s:24:\"packs/goodnewsheader.zip\";s:3:\"uid\";s:32:\"c6660b6bdbf596f38466f569596f5259\";s:3:\"img\";s:25:\"goodnewsheader/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:154;a:26:{s:2:\"id\";s:3:\"157\";s:5:\"title\";s:18:\"GoodNews Whats Hot\";s:5:\"alias\";s:16:\"goodnewswhatshot\";s:3:\"zip\";s:26:\"packs/goodnewswhatshot.zip\";s:3:\"uid\";s:32:\"cb841ce64a99a6644adab049cf5405cd\";s:3:\"img\";s:27:\"goodnewswhatshot/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:155;a:26:{s:2:\"id\";s:3:\"158\";s:5:\"title\";s:17:\"GoodNews Featured\";s:5:\"alias\";s:16:\"goodnewsfeatured\";s:3:\"zip\";s:26:\"packs/goodnewsfeatured.zip\";s:3:\"uid\";s:32:\"00bde4b09e3700da7183999eaf137ccc\";s:3:\"img\";s:27:\"goodnewsfeatured/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:156;a:26:{s:2:\"id\";s:3:\"159\";s:5:\"title\";s:18:\"GoodNews Spotlight\";s:5:\"alias\";s:17:\"goodnewsspotlight\";s:3:\"zip\";s:27:\"packs/goodnewsspotlight.zip\";s:3:\"uid\";s:32:\"138076241a828e1c5764379944755f2b\";s:3:\"img\";s:28:\"goodnewsspotlight/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:157;a:26:{s:2:\"id\";s:3:\"160\";s:5:\"title\";s:17:\"GoodNews Carousel\";s:5:\"alias\";s:16:\"goodnewscarousel\";s:3:\"zip\";s:26:\"packs/goodnewscarousel.zip\";s:3:\"uid\";s:32:\"d29d4460a6015e30d08d2714232d3768\";s:3:\"img\";s:27:\"goodnewscarousel/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:8:\"carousel\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:158;a:26:{s:2:\"id\";s:3:\"161\";s:5:\"title\";s:16:\"GoodNews Callout\";s:5:\"alias\";s:15:\"goodnewscallout\";s:3:\"zip\";s:25:\"packs/goodnewscallout.zip\";s:3:\"uid\";s:32:\"d9568b3193e96577fae630b3a6728785\";s:3:\"img\";s:26:\"goodnewscallout/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:159;a:26:{s:2:\"id\";s:3:\"162\";s:5:\"title\";s:15:\"GoodNews Footer\";s:5:\"alias\";s:14:\"goodnewsfooter\";s:3:\"zip\";s:24:\"packs/goodnewsfooter.zip\";s:3:\"uid\";s:32:\"34f43f891cb8d55375149dc4bbc38298\";s:3:\"img\";s:25:\"goodnewsfooter/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"GoodNews One-Pager\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"7\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:160;a:26:{s:2:\"id\";s:3:\"163\";s:5:\"title\";s:29:\"GoodNews Content Page Package\";s:5:\"alias\";s:29:\"goodnews-content-page-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:29:\"goodnews-content-page-package\";s:3:\"img\";s:55:\"packages/templatepack_goodnews_content_page_package.jpg\";s:7:\"preview\";s:78:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme-content/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:3:{i:0;s:6:\"slider\";i:1;s:4:\"hero\";i:2;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"GoodNews Content Page\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"8\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:161;a:26:{s:2:\"id\";s:3:\"164\";s:5:\"title\";s:18:\"GoodNews Menu Back\";s:5:\"alias\";s:16:\"goodnewsmenuback\";s:3:\"zip\";s:26:\"packs/goodnewsmenuback.zip\";s:3:\"uid\";s:32:\"1340d1aeefba497a7d404d12a1fceed4\";s:3:\"img\";s:27:\"goodnewsmenuback/slide1.jpg\";s:7:\"preview\";s:78:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme-content/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"GoodNews Content Page\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"8\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:162;a:26:{s:2:\"id\";s:3:\"165\";s:5:\"title\";s:20:\"GoodNews Blog Header\";s:5:\"alias\";s:18:\"goodnewsblogheader\";s:3:\"zip\";s:28:\"packs/goodnewsblogheader.zip\";s:3:\"uid\";s:32:\"abc4d7c1e48475c6def05f1f6d8bf564\";s:3:\"img\";s:29:\"goodnewsblogheader/slide1.jpg\";s:7:\"preview\";s:78:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme-content/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"GoodNews Content Page\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"8\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:163;a:26:{s:2:\"id\";s:3:\"166\";s:5:\"title\";s:21:\"GoodNews Blog Content\";s:5:\"alias\";s:19:\"goodnewsblogcontent\";s:3:\"zip\";s:29:\"packs/goodnewsblogcontent.zip\";s:3:\"uid\";s:32:\"bbf34563da6db2779c29599b503b07e9\";s:3:\"img\";s:30:\"goodnewsblogcontent/slide1.jpg\";s:7:\"preview\";s:78:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme-content/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"GoodNews Content Page\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"8\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:164;a:26:{s:2:\"id\";s:3:\"167\";s:5:\"title\";s:21:\"GoodNews Testimonials\";s:5:\"alias\";s:20:\"goodnewstestimonials\";s:3:\"zip\";s:30:\"packs/goodnewstestimonials.zip\";s:3:\"uid\";s:32:\"606b7336e86f69c567542d3f43712b56\";s:3:\"img\";s:31:\"goodnewstestimonials/slide1.jpg\";s:7:\"preview\";s:78:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme-content/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"GoodNews Content Page\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"8\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:165;a:26:{s:2:\"id\";s:3:\"168\";s:5:\"title\";s:20:\"GoodNews Blog Footer\";s:5:\"alias\";s:18:\"goodnewsblogfooter\";s:3:\"zip\";s:28:\"packs/goodnewsblogfooter.zip\";s:3:\"uid\";s:32:\"1fb88aecfb116fde67ce8d52bd3b5f05\";s:3:\"img\";s:29:\"goodnewsblogfooter/slide1.jpg\";s:7:\"preview\";s:78:\"https://revolution.themepunch.com/goodnews-responsive-wordpress-theme-content/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:268:\"<span class=\"ttm_content\">The GoodNews One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:21:\"GoodNews Content Page\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"8\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:166;a:22:{s:2:\"id\";s:3:\"169\";s:5:\"title\";s:19:\"Before After Slider\";s:5:\"alias\";s:17:\"beforeafterslider\";s:3:\"zip\";s:21:\"beforeafterslider.zip\";s:3:\"uid\";s:32:\"6e615091a1fc3037c24b985ce5136fb2\";s:3:\"img\";s:28:\"beforeafterslider/slide1.jpg\";s:7:\"preview\";s:54:\"https://revolution.themepunch.com/before-after-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.4.3.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:201:\"<span class=\"ttm_content\">This is the example slider for our Before / After Add-On that allows you to create unique presentations with a comparing functionality.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:320:\"<span class=\"ttm_content\">How to install <a href=\"https://www.themepunch.com/slider-revolution/install-addons/\" target=\"_blank\">Add-Ons</a>.</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-beforeafter-addon\\/revslider-beforeafter-addon.php\",\"name\":\"Before After AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:167;a:22:{s:2:\"id\";s:3:\"170\";s:5:\"title\";s:16:\"Product Showcase\";s:5:\"alias\";s:15:\"productshowcase\";s:3:\"zip\";s:19:\"productshowcase.zip\";s:3:\"uid\";s:32:\"a43447670260aaa7e8ff66cedfddb57a\";s:3:\"img\";s:26:\"productshowcase/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/wordpress-product-showcase-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:165:\"<span class=\"ttm_content\">Looking to sell products effectively? Our product showcase slider is just what you are looking for!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:168;a:22:{s:2:\"id\";s:3:\"171\";s:5:\"title\";s:23:\"Overexposure Transition\";s:5:\"alias\";s:22:\"overexposuretransition\";s:3:\"zip\";s:26:\"overexposuretransition.zip\";s:3:\"uid\";s:32:\"13f16bbe6c6d646c7d0cb817a0d3d181\";s:3:\"img\";s:33:\"overexposuretransition/slide1.jpg\";s:7:\"preview\";s:65:\"https://revolution.themepunch.com/overexposure-transition-effect/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:155:\"<span class=\"ttm_content\">Subtle overexposure transitions and smooth color fade effects make this slider stand out.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:320:\"<span class=\"ttm_content\">How to install <a href=\"https://www.themepunch.com/slider-revolution/install-addons/\" target=\"_blank\">Add-Ons</a>.</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:169;a:22:{s:2:\"id\";s:3:\"172\";s:5:\"title\";s:15:\"Parallax Scroll\";s:5:\"alias\";s:14:\"parallaxscroll\";s:3:\"zip\";s:18:\"parallaxscroll.zip\";s:3:\"uid\";s:32:\"82546ee2f6af6c6682852f495109b3c3\";s:3:\"img\";s:25:\"parallaxscroll/slide1.jpg\";s:7:\"preview\";s:50:\"https://revolution.themepunch.com/parallax-scroll/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:148:\"<span class=\"ttm_content\">A strikingly colourful header for your website with super smooth parallax effects.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:170;a:27:{s:2:\"id\";s:3:\"173\";s:5:\"title\";s:24:\"TechCo One-Pager Package\";s:5:\"alias\";s:24:\"techco-one-pager-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:24:\"techco-one-pager-package\";s:3:\"img\";s:28:\"packages/techco_overview.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:3:{i:0;s:6:\"slider\";i:1;s:4:\"hero\";i:2;s:7:\"website\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:171;a:27:{s:2:\"id\";s:3:\"174\";s:5:\"title\";s:11:\"TechCo Menu\";s:5:\"alias\";s:11:\"techco-menu\";s:3:\"zip\";s:21:\"packs/techco-menu.zip\";s:3:\"uid\";s:32:\"55e5efee828cdf1ff7e2d3b90a301ea9\";s:3:\"img\";s:22:\"techco-menu/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:172;a:27:{s:2:\"id\";s:3:\"175\";s:5:\"title\";s:13:\"TechCo Header\";s:5:\"alias\";s:13:\"techco-header\";s:3:\"zip\";s:23:\"packs/techco-header.zip\";s:3:\"uid\";s:32:\"fb574d1376de9b1e408c91f51e6497d7\";s:3:\"img\";s:24:\"techco-header/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:173;a:27:{s:2:\"id\";s:3:\"176\";s:5:\"title\";s:12:\"TechCo About\";s:5:\"alias\";s:12:\"techco-about\";s:3:\"zip\";s:22:\"packs/techco-about.zip\";s:3:\"uid\";s:32:\"ba216da8231e55118d87e37d2358812c\";s:3:\"img\";s:23:\"techco-about/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:174;a:27:{s:2:\"id\";s:3:\"177\";s:5:\"title\";s:15:\"TechCo Services\";s:5:\"alias\";s:15:\"techco-services\";s:3:\"zip\";s:25:\"packs/techco-services.zip\";s:3:\"uid\";s:32:\"ef4a8ddbb5e1136133f7bc1227248e22\";s:3:\"img\";s:26:\"techco-services/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:175;a:27:{s:2:\"id\";s:3:\"178\";s:5:\"title\";s:12:\"TechCo Video\";s:5:\"alias\";s:12:\"techco-video\";s:3:\"zip\";s:22:\"packs/techco-video.zip\";s:3:\"uid\";s:32:\"d7bb92281d05f39f9bc9eca71f90e402\";s:3:\"img\";s:23:\"techco-video/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:176;a:27:{s:2:\"id\";s:3:\"179\";s:5:\"title\";s:13:\"TechCo Prices\";s:5:\"alias\";s:13:\"techco-prices\";s:3:\"zip\";s:23:\"packs/techco-prices.zip\";s:3:\"uid\";s:32:\"6291f404efbea12bb181352aba71ef11\";s:3:\"img\";s:24:\"techco-prices/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:177;a:27:{s:2:\"id\";s:3:\"180\";s:5:\"title\";s:19:\"TechCo Testimonials\";s:5:\"alias\";s:19:\"techco-testimonials\";s:3:\"zip\";s:29:\"packs/techco-testimonials.zip\";s:3:\"uid\";s:32:\"3460bd51f6b80599266fecb7fbb918be\";s:3:\"img\";s:30:\"techco-testimonials/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:178;a:27:{s:2:\"id\";s:3:\"181\";s:5:\"title\";s:13:\"TechCo Footer\";s:5:\"alias\";s:13:\"techco-footer\";s:3:\"zip\";s:23:\"packs/techco-footer.zip\";s:3:\"uid\";s:32:\"640abcd549137520461a4a71ff758a3b\";s:3:\"img\";s:24:\"techco-footer/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/techco-one-page-wordpress-theme/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:266:\"<span class=\"ttm_content\">The TechCo One-Pager template pack is a fantastic solution if you want to get a simple website going fast. Use all modules at once as seen in the preview or pick individual modules for usage anywhere!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"TechCo One-Pager\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:1:\"9\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:179;a:22:{s:2:\"id\";s:3:\"182\";s:5:\"title\";s:12:\"Live Weather\";s:5:\"alias\";s:7:\"weather\";s:3:\"zip\";s:11:\"weather.zip\";s:3:\"uid\";s:32:\"aab92e69374e4c7b8c6741fe02e574b9\";s:3:\"img\";s:18:\"weather/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/wordpress-live-weather-add-on/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:7:\"5.4.5.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:173:\"<span class=\"ttm_content\">Showcasing our weather add-on, this slider show a different cities temperatures and forecast on each slide.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:168:\"[{\"path\":\"revslider-weather-addon\\/revslider-weather-addon.php\",\"name\":\"Live Weather Add-On\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:180;a:22:{s:2:\"id\";s:3:\"183\";s:5:\"title\";s:17:\"360 Panorama Tour\";s:5:\"alias\";s:11:\"360panorama\";s:3:\"zip\";s:15:\"360panorama.zip\";s:3:\"uid\";s:32:\"332720fdacdbb38f65e8327a2a96c52d\";s:3:\"img\";s:22:\"360panorama/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/360-degree-real-estate-virtual-tour/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.4.5.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:155:\"<span class=\"ttm_content\">An example template for our Panorama 360 tour add-on, created for the real estate market.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:165:\"[{\"path\":\"revslider-panorama-addon\\/revslider-panorama-addon.php\",\"name\":\"Panorama AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:181;a:22:{s:2:\"id\";s:3:\"184\";s:5:\"title\";s:14:\"Duotone Add-on\";s:5:\"alias\";s:14:\"duotone-add-on\";s:3:\"zip\";s:18:\"duotone-add-on.zip\";s:3:\"uid\";s:32:\"a428c6f363b3146e96d20a6f44958922\";s:3:\"img\";s:25:\"duotone-add-on/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/wordpress-duotone-effect-add-on/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:168:\"<span class=\"ttm_content\">This example template showcases 3 of the 30 Duotone filters available in our brand new Duotone Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:350:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"},{\"path\":\"revslider-duotonefilters-addon\\/revslider-duotonefilters-addon.php\",\"name\":\"Duotone AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:182;a:22:{s:2:\"id\";s:3:\"185\";s:5:\"title\";s:13:\"Reveal Add-on\";s:5:\"alias\";s:13:\"reveal-add-on\";s:3:\"zip\";s:17:\"reveal-add-on.zip\";s:3:\"uid\";s:32:\"7fa7525d8ff7fa7365cb98a437e88e32\";s:3:\"img\";s:24:\"reveal-add-on/slide1.jpg\";s:7:\"preview\";s:66:\"https://revolution.themepunch.com/wordpress-content-reveal-effect/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:204:\"<span class=\"ttm_content\">An example template that uses our Reveal Add-On, which adds 14 new preloaders combined with reveal loading effects for any slider or hero.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:337:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"},{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:201;a:23:{s:2:\"id\";s:3:\"210\";s:5:\"title\";s:21:\"Cryptocurrency Prices\";s:5:\"alias\";s:12:\"cryptoslider\";s:3:\"zip\";s:16:\"cryptoslider.zip\";s:3:\"uid\";s:32:\"c4b02210387f11946223977e940d9e9e\";s:3:\"img\";s:23:\"cryptoslider/slide1.jpg\";s:7:\"preview\";s:95:\"https://revolution.themepunch.com/cryptocurrency-wordpress-price-api-bitcoin-ethereum-litecoin/\";s:7:\"version\";s:5:\"1.0.5\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"900\";s:11:\"description\";s:209:\"<span class=\"ttm_content\">This Template can show live, animated cryptocurrency prices. More than 1300 currencies are supported, getting prices via the cryptocompare API.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:410:\"<span class=\"ttm_content\">Please refer to the \"Custom JavaScript\" section of this sliders settings, for info on how to modify currencies. Provide a class to the row / column / group where the currency text elements are located in.</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:202;a:25:{s:2:\"id\";s:3:\"211\";s:5:\"title\";s:18:\"Immersion One Page\";s:5:\"alias\";s:26:\"immersion-one-page-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:26:\"immersion-one-page-package\";s:3:\"img\";s:31:\"packages/immersion_overview.jpg\";s:7:\"preview\";s:74:\"https://revolution.themepunch.com/immersion-wordpress-one-page-theme-2018/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:292:\"<span class=\"ttm_content\">The Immersion WordPress one page theme is a great fit if you quickly want to setup a visually oriented one page website. Using the power of Slider Revolution, we added some interesting effects like slicing and smooth parallax.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:3:{i:0;s:6:\"slider\";i:1;s:4:\"hero\";i:2;s:7:\"website\";}s:14:\"plugin_require\";s:343:\"[{\"path\":\"revslider-typewriter-addon\\/revslider-typewriter-addon.php\",\"name\":\"Typewriter AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/typewriter-addon\\/\"},{\"path\":\"revslider-slicey-addon\\/revslider-slicey-addon.php\",\"name\":\"Background Slicey Add-On\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Immersion One Page\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"10\";s:9:\"installed\";b:0;}i:203;a:25:{s:2:\"id\";s:3:\"212\";s:5:\"title\";s:16:\"Immersion Header\";s:5:\"alias\";s:16:\"immersion_header\";s:3:\"zip\";s:26:\"packs/immersion_header.zip\";s:3:\"uid\";s:32:\"853da51256308b341ecd030bd4883229\";s:3:\"img\";s:27:\"immersion_header/slide1.jpg\";s:7:\"preview\";s:74:\"https://revolution.themepunch.com/immersion-wordpress-one-page-theme-2018/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:292:\"<span class=\"ttm_content\">The Immersion WordPress one page theme is a great fit if you quickly want to setup a visually oriented one page website. Using the power of Slider Revolution, we added some interesting effects like slicing and smooth parallax.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:173:\"[{\"path\":\"revslider-typewriter-addon\\/revslider-typewriter-addon.php\",\"name\":\"Typewriter AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/typewriter-addon\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Immersion One Page\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"10\";s:9:\"installed\";b:0;}i:204;a:25:{s:2:\"id\";s:3:\"213\";s:5:\"title\";s:19:\"Immersion Mountains\";s:5:\"alias\";s:19:\"immersion-mountains\";s:3:\"zip\";s:29:\"packs/immersion-mountains.zip\";s:3:\"uid\";s:32:\"817167eb3fe22b7e065ba210cbe6d53c\";s:3:\"img\";s:30:\"immersion-mountains/slide1.jpg\";s:7:\"preview\";s:74:\"https://revolution.themepunch.com/immersion-wordpress-one-page-theme-2018/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:292:\"<span class=\"ttm_content\">The Immersion WordPress one page theme is a great fit if you quickly want to setup a visually oriented one page website. Using the power of Slider Revolution, we added some interesting effects like slicing and smooth parallax.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:171:\"[{\"path\":\"revslider-slicey-addon\\/revslider-slicey-addon.php\",\"name\":\"Background Slicey Add-On\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Immersion One Page\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"10\";s:9:\"installed\";b:0;}i:205;a:25:{s:2:\"id\";s:3:\"214\";s:5:\"title\";s:17:\"Immersion Product\";s:5:\"alias\";s:17:\"immersion-product\";s:3:\"zip\";s:27:\"packs/immersion-product.zip\";s:3:\"uid\";s:32:\"64134f263484d2bbcd7ef088ffbbfb4b\";s:3:\"img\";s:28:\"immersion-product/slide1.jpg\";s:7:\"preview\";s:74:\"https://revolution.themepunch.com/immersion-wordpress-one-page-theme-2018/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:292:\"<span class=\"ttm_content\">The Immersion WordPress one page theme is a great fit if you quickly want to setup a visually oriented one page website. Using the power of Slider Revolution, we added some interesting effects like slicing and smooth parallax.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Immersion One Page\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"10\";s:9:\"installed\";b:0;}i:206;a:25:{s:2:\"id\";s:3:\"215\";s:5:\"title\";s:16:\"Immersion Design\";s:5:\"alias\";s:16:\"immersion-design\";s:3:\"zip\";s:26:\"packs/immersion-design.zip\";s:3:\"uid\";s:32:\"91e1d77c1a2826438763804f4d02bc26\";s:3:\"img\";s:27:\"immersion-design/slide1.jpg\";s:7:\"preview\";s:74:\"https://revolution.themepunch.com/immersion-wordpress-one-page-theme-2018/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:292:\"<span class=\"ttm_content\">The Immersion WordPress one page theme is a great fit if you quickly want to setup a visually oriented one page website. Using the power of Slider Revolution, we added some interesting effects like slicing and smooth parallax.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Immersion One Page\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"10\";s:9:\"installed\";b:0;}i:207;a:25:{s:2:\"id\";s:3:\"216\";s:5:\"title\";s:22:\"Immersion Phototgraphy\";s:5:\"alias\";s:21:\"immersion-photography\";s:3:\"zip\";s:31:\"packs/immersion-photography.zip\";s:3:\"uid\";s:32:\"e3ddf0c577b09740f5cbf2e38ffd684d\";s:3:\"img\";s:32:\"immersion-photography/slide1.jpg\";s:7:\"preview\";s:74:\"https://revolution.themepunch.com/immersion-wordpress-one-page-theme-2018/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:292:\"<span class=\"ttm_content\">The Immersion WordPress one page theme is a great fit if you quickly want to setup a visually oriented one page website. Using the power of Slider Revolution, we added some interesting effects like slicing and smooth parallax.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Immersion One Page\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"10\";s:9:\"installed\";b:0;}i:208;a:25:{s:2:\"id\";s:3:\"217\";s:5:\"title\";s:14:\"Immersion Grid\";s:5:\"alias\";s:14:\"immersion-grid\";s:3:\"zip\";s:24:\"packs/immersion-grid.zip\";s:3:\"uid\";s:32:\"b6903868189bb83b2c7a852fde3a7dc3\";s:3:\"img\";s:25:\"immersion-grid/slide1.jpg\";s:7:\"preview\";s:74:\"https://revolution.themepunch.com/immersion-wordpress-one-page-theme-2018/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.4.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:292:\"<span class=\"ttm_content\">The Immersion WordPress one page theme is a great fit if you quickly want to setup a visually oriented one page website. Using the power of Slider Revolution, we added some interesting effects like slicing and smooth parallax.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Immersion One Page\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"10\";s:9:\"installed\";b:0;}i:209;a:23:{s:2:\"id\";s:3:\"218\";s:5:\"title\";s:18:\"Funky Intro Slider\";s:5:\"alias\";s:11:\"funkyslider\";s:3:\"zip\";s:15:\"funkyslider.zip\";s:3:\"uid\";s:32:\"2d4187e3fdad19b976be335253c8925d\";s:3:\"img\";s:22:\"funkyslider/slide1.jpg\";s:7:\"preview\";s:70:\"https://revolution.themepunch.com/funky-intro-slider-wordpress-plugin/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:200:\"<span class=\"ttm_content\">This funky intro slider fits just right if you need a striking introduction to your website! Sleek, beautiful and easily customizable!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:335:\"[{\"path\":\"revslider-typewriter-addon\\/revslider-typewriter-addon.php\",\"name\":\"Typewriter AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/typewriter-addon\\/\"},{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:210;a:26:{s:2:\"id\";s:3:\"219\";s:5:\"title\";s:19:\"Clear View Magazine\";s:5:\"alias\";s:27:\"clear-view-magazine-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:27:\"clear-view-magazine-package\";s:3:\"img\";s:41:\"packages/clear_view_magazine_overview.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:211;a:26:{s:2:\"id\";s:3:\"220\";s:5:\"title\";s:15:\"Clear View Menu\";s:5:\"alias\";s:14:\"clearview_menu\";s:3:\"zip\";s:24:\"packs/clearview_menu.zip\";s:3:\"uid\";s:32:\"eaecee5fa5f3c3a7f4d2a96c4616a353\";s:3:\"img\";s:25:\"clearview_menu/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:212;a:26:{s:2:\"id\";s:3:\"221\";s:5:\"title\";s:17:\"Clear View Header\";s:5:\"alias\";s:16:\"clearview_header\";s:3:\"zip\";s:26:\"packs/clearview_header.zip\";s:3:\"uid\";s:32:\"25e3dd80ad130875d7438a07952cb0cd\";s:3:\"img\";s:27:\"clearview_header/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:213;a:26:{s:2:\"id\";s:3:\"222\";s:5:\"title\";s:18:\"Clear View Mission\";s:5:\"alias\";s:17:\"clearview_mission\";s:3:\"zip\";s:27:\"packs/clearview_mission.zip\";s:3:\"uid\";s:32:\"35b2092a49fd2beb549342e69097eb5b\";s:3:\"img\";s:28:\"clearview_mission/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:214;a:26:{s:2:\"id\";s:3:\"223\";s:5:\"title\";s:17:\"Clear View Slider\";s:5:\"alias\";s:17:\"clear-view-slider\";s:3:\"zip\";s:27:\"packs/clear-view-slider.zip\";s:3:\"uid\";s:32:\"d2e17edffce16ed78c54b0ef23fd7e05\";s:3:\"img\";s:28:\"clear-view-slider/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:215;a:26:{s:2:\"id\";s:3:\"224\";s:5:\"title\";s:15:\"Clear View News\";s:5:\"alias\";s:15:\"clear-view-news\";s:3:\"zip\";s:25:\"packs/clear-view-news.zip\";s:3:\"uid\";s:32:\"5698d3131ba141e9afcfd2906739dd00\";s:3:\"img\";s:26:\"clear-view-news/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:216;a:26:{s:2:\"id\";s:3:\"225\";s:5:\"title\";s:18:\"Clear View Clients\";s:5:\"alias\";s:18:\"clear-view-clients\";s:3:\"zip\";s:28:\"packs/clear-view-clients.zip\";s:3:\"uid\";s:32:\"b95616a94832e22bdfac5ce60232be1b\";s:3:\"img\";s:29:\"clear-view-clients/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:217;a:26:{s:2:\"id\";s:3:\"226\";s:5:\"title\";s:18:\"Clear View Contact\";s:5:\"alias\";s:18:\"clear-view-contact\";s:3:\"zip\";s:28:\"packs/clear-view-contact.zip\";s:3:\"uid\";s:32:\"0e0cc1d8f6f6500e5f8a2b091fa3b4cb\";s:3:\"img\";s:29:\"clear-view-contact/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-minimal-magazine-wordpress-template/\";s:7:\"version\";s:5:\"1.0.3\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:19:\"Clear View Magazine\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"11\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:218;a:26:{s:2:\"id\";s:3:\"227\";s:5:\"title\";s:20:\"Clear View Post Page\";s:5:\"alias\";s:28:\"clear-view-post-page-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:28:\"clear-view-post-page-package\";s:3:\"img\";s:42:\"packages/clear_view_post_page_overview.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-single-post-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Clear View Post Page\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"12\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:219;a:26:{s:2:\"id\";s:3:\"228\";s:5:\"title\";s:22:\"Clear View Single Menu\";s:5:\"alias\";s:22:\"clear-view-single-menu\";s:3:\"zip\";s:32:\"packs/clear-view-single-menu.zip\";s:3:\"uid\";s:32:\"1e80f81982f8a4ea763482d4fa99d321\";s:3:\"img\";s:33:\"clear-view-single-menu/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-single-post-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Clear View Post Page\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"12\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:220;a:26:{s:2:\"id\";s:3:\"229\";s:5:\"title\";s:24:\"Clear View Single Header\";s:5:\"alias\";s:24:\"clear-view-single-header\";s:3:\"zip\";s:34:\"packs/clear-view-single-header.zip\";s:3:\"uid\";s:32:\"c8d717627be6cd5e70922ab609694dbf\";s:3:\"img\";s:35:\"clear-view-single-header/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-single-post-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Clear View Post Page\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"12\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:221;a:26:{s:2:\"id\";s:3:\"230\";s:5:\"title\";s:23:\"Clear View Single Media\";s:5:\"alias\";s:23:\"clear-view-single-media\";s:3:\"zip\";s:33:\"packs/clear-view-single-media.zip\";s:3:\"uid\";s:32:\"c480368ded2a64f0cdd44f1674213814\";s:3:\"img\";s:34:\"clear-view-single-media/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-single-post-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Clear View Post Page\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"12\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:222;a:26:{s:2:\"id\";s:3:\"231\";s:5:\"title\";s:22:\"Clear View Single More\";s:5:\"alias\";s:22:\"clear-view-single-more\";s:3:\"zip\";s:32:\"packs/clear-view-single-more.zip\";s:3:\"uid\";s:32:\"9c693190df26218366d1f77e10cf550a\";s:3:\"img\";s:33:\"clear-view-single-more/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-single-post-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Clear View Post Page\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"12\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:223;a:26:{s:2:\"id\";s:3:\"232\";s:5:\"title\";s:25:\"Clear View Single Contact\";s:5:\"alias\";s:25:\"clear-view-single-contact\";s:3:\"zip\";s:35:\"packs/clear-view-single-contact.zip\";s:3:\"uid\";s:32:\"73c0a889f2b654a87b5aba1ff76fbc5c\";s:3:\"img\";s:36:\"clear-view-single-contact/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/clear-view-single-post-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:196:\"<span class=\"ttm_content\">The Clear View Minimal Magazine WordPress Template is a full Slider Revolution module arrangement with fully customizable content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Clear View Post Page\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"12\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:224;a:23:{s:2:\"id\";s:3:\"233\";s:5:\"title\";s:18:\"Clean Landing Page\";s:5:\"alias\";s:16:\"cleanlandingpage\";s:3:\"zip\";s:20:\"cleanlandingpage.zip\";s:3:\"uid\";s:32:\"727a3680d312f22c6a5998ebdb9afe52\";s:3:\"img\";s:27:\"cleanlandingpage/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/clean-landing-page-for-wordpress/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:203:\"<span class=\"ttm_content\">The Clean Landing Page is a fullscreen Intro Module that is a striking introduction to any minimal website, with no unnecessary elements.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:173:\"[{\"path\":\"revslider-typewriter-addon\\/revslider-typewriter-addon.php\",\"name\":\"Typewriter AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/typewriter-addon\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:225;a:23:{s:2:\"id\";s:3:\"234\";s:5:\"title\";s:9:\"Clear Cut\";s:5:\"alias\";s:8:\"clearcut\";s:3:\"zip\";s:12:\"clearcut.zip\";s:3:\"uid\";s:32:\"07f43c00e9b4d3057a03cdb3385ad2b7\";s:3:\"img\";s:19:\"clearcut/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/clear-cut-portfolio-website-for-wordpress/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:240:\"<span class=\"ttm_content\">The Clear Cut Template is an All-In-One Portfolio Website solution that works best for smaller portfolios. Highlight your best work in a striking and mobile friendly fashion!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:226;a:25:{s:2:\"id\";s:3:\"235\";s:5:\"title\";s:22:\"Wonderstruck One-Pager\";s:5:\"alias\";s:30:\"wonderstruck-one-pager-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:30:\"wonderstruck-one-pager-package\";s:3:\"img\";s:44:\"packages/wonderstruck-one-pager-overview.jpg\";s:7:\"preview\";s:77:\"https://revolution.themepunch.com/wonderstruck-one-page-website-for-wordpress\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:241:\"<span class=\"ttm_content\">The Wonderstruck One-Pager Template is a clean, colorful way to showcase your portfolio online. Just install, change the content and you have a mobile ready online experience!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Wonderstruck One-Pager\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"13\";s:9:\"installed\";b:0;}i:227;a:25:{s:2:\"id\";s:3:\"236\";s:5:\"title\";s:17:\"Wonderstruck Menu\";s:5:\"alias\";s:17:\"wonderstruck_menu\";s:3:\"zip\";s:27:\"packs/wonderstruck_menu.zip\";s:3:\"uid\";s:32:\"0a976e9aaae59c4f795b38f59f5a08d8\";s:3:\"img\";s:28:\"wonderstruck_menu/slide1.jpg\";s:7:\"preview\";s:77:\"https://revolution.themepunch.com/wonderstruck-one-page-website-for-wordpress\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:241:\"<span class=\"ttm_content\">The Wonderstruck One-Pager Template is a clean, colorful way to showcase your portfolio online. Just install, change the content and you have a mobile ready online experience!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Wonderstruck One-Pager\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"13\";s:9:\"installed\";b:0;}i:228;a:25:{s:2:\"id\";s:3:\"237\";s:5:\"title\";s:19:\"Wonderstruck Header\";s:5:\"alias\";s:19:\"wonderstruck_header\";s:3:\"zip\";s:29:\"packs/wonderstruck_header.zip\";s:3:\"uid\";s:32:\"e1379f77a902960a0ce12d44d85a9e0a\";s:3:\"img\";s:30:\"wonderstruck_header/slide1.jpg\";s:7:\"preview\";s:77:\"https://revolution.themepunch.com/wonderstruck-one-page-website-for-wordpress\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:241:\"<span class=\"ttm_content\">The Wonderstruck One-Pager Template is a clean, colorful way to showcase your portfolio online. Just install, change the content and you have a mobile ready online experience!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Wonderstruck One-Pager\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"13\";s:9:\"installed\";b:0;}i:229;a:25:{s:2:\"id\";s:3:\"238\";s:5:\"title\";s:18:\"Wonderstruck About\";s:5:\"alias\";s:18:\"wonderstruck_about\";s:3:\"zip\";s:28:\"packs/wonderstruck_about.zip\";s:3:\"uid\";s:32:\"d207fb140fd328acc3038300ea52082a\";s:3:\"img\";s:29:\"wonderstruck_about/slide1.jpg\";s:7:\"preview\";s:77:\"https://revolution.themepunch.com/wonderstruck-one-page-website-for-wordpress\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:241:\"<span class=\"ttm_content\">The Wonderstruck One-Pager Template is a clean, colorful way to showcase your portfolio online. Just install, change the content and you have a mobile ready online experience!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Wonderstruck One-Pager\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"13\";s:9:\"installed\";b:0;}i:230;a:25:{s:2:\"id\";s:3:\"239\";s:5:\"title\";s:18:\"Wonderstruck Works\";s:5:\"alias\";s:18:\"wonderstruck-works\";s:3:\"zip\";s:28:\"packs/wonderstruck-works.zip\";s:3:\"uid\";s:32:\"4476935097e27d92454b0011b7700c1d\";s:3:\"img\";s:29:\"wonderstruck-works/slide1.jpg\";s:7:\"preview\";s:77:\"https://revolution.themepunch.com/wonderstruck-one-page-website-for-wordpress\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:241:\"<span class=\"ttm_content\">The Wonderstruck One-Pager Template is a clean, colorful way to showcase your portfolio online. Just install, change the content and you have a mobile ready online experience!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Wonderstruck One-Pager\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"13\";s:9:\"installed\";b:0;}i:231;a:25:{s:2:\"id\";s:3:\"240\";s:5:\"title\";s:20:\"Wonderstruck Contact\";s:5:\"alias\";s:20:\"wonderstruck-contact\";s:3:\"zip\";s:30:\"packs/wonderstruck-contact.zip\";s:3:\"uid\";s:32:\"9e4911521f77bce2b8efa40f4c2adc22\";s:3:\"img\";s:31:\"wonderstruck-contact/slide1.jpg\";s:7:\"preview\";s:77:\"https://revolution.themepunch.com/wonderstruck-one-page-website-for-wordpress\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:241:\"<span class=\"ttm_content\">The Wonderstruck One-Pager Template is a clean, colorful way to showcase your portfolio online. Just install, change the content and you have a mobile ready online experience!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Wonderstruck One-Pager\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"13\";s:9:\"installed\";b:0;}i:232;a:22:{s:2:\"id\";s:3:\"241\";s:5:\"title\";s:12:\"Bubble Morph\";s:5:\"alias\";s:11:\"bubblemorph\";s:3:\"zip\";s:15:\"bubblemorph.zip\";s:3:\"uid\";s:32:\"1102d6f5460ab82cb612cbe9f1d9514b\";s:3:\"img\";s:22:\"bubblemorph/slide1.jpg\";s:7:\"preview\";s:75:\"https://revolution.themepunch.com/bubble-morph-effect-add-on-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:188:\"<span class=\"ttm_content\">The Bubble Morph Add-On allows you to create interesting Lava-Lamp style effects on any of your Slider Revolution content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:233;a:22:{s:2:\"id\";s:3:\"242\";s:5:\"title\";s:16:\"Distortion AddOn\";s:5:\"alias\";s:15:\"distortionaddon\";s:3:\"zip\";s:19:\"distortionaddon.zip\";s:3:\"uid\";s:32:\"0ad46c9929bb2fa6316f1e6ced301aaf\";s:3:\"img\";s:26:\"distortionaddon/slide1.jpg\";s:7:\"preview\";s:73:\"https://revolution.themepunch.com/distortion-effect-add-on-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.7\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Distortion Add-On allows you to create interesting Distortion style effects on any of your Slider Revolution content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:182:\"[{\"path\":\"revslider-liquideffect-addon\\/revslider-liquideffect-addon.php\",\"name\":\"Distortion Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:234;a:22:{s:2:\"id\";s:3:\"243\";s:5:\"title\";s:10:\"Club Flyer\";s:5:\"alias\";s:9:\"clubflyer\";s:3:\"zip\";s:13:\"clubflyer.zip\";s:3:\"uid\";s:32:\"dab73b9904d0e643a35b0475980998bd\";s:3:\"img\";s:20:\"clubflyer/slide1.jpg\";s:7:\"preview\";s:81:\"https://revolution.themepunch.com/club-flyer-landing-page-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:227:\"<span class=\"ttm_content\">This Club Fyler Template for Slider Revolution uses the brand new Exploding Layers Add-On to create a captivating effect. Tap into unlimited creative potential. </span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:187:\"[{\"path\":\"revslider-explodinglayers-addon\\/revslider-explodinglayers-addon.php\",\"name\":\"Exploding Layers AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:235;a:23:{s:2:\"id\";s:3:\"244\";s:5:\"title\";s:16:\"Paintbrush AddOn\";s:5:\"alias\";s:15:\"paintbrushaddon\";s:3:\"zip\";s:19:\"paintbrushaddon.zip\";s:3:\"uid\";s:32:\"c85c48a6742b4bf72a2590cc1b50f6a0\";s:3:\"img\";s:26:\"paintbrushaddon/slide1.jpg\";s:7:\"preview\";s:73:\"https://revolution.themepunch.com/paintbrush-effect-add-on-for-wordpress/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:239:\"<span class=\"ttm_content\">The Paintbrush Add-On for WordPress allows you to add cool mouse interaction effects to your Slider Revolution content. Examples: Blur Reveal, Color Reveal, Scratch Me Free.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:171:\"[{\"path\":\"revslider-paintbrush-addon\\/revslider-paintbrush-addon.php\",\"name\":\"Paintbrush AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:236;a:25:{s:2:\"id\";s:3:\"245\";s:5:\"title\";s:18:\"Parallax One-Pager\";s:5:\"alias\";s:26:\"parallax-one-pager-package\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:26:\"parallax-one-pager-package\";s:3:\"img\";s:39:\"packages/parallax-one-pager-package.jpg\";s:7:\"preview\";s:71:\"https://revolution.themepunch.com/parallax-one-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:230:\"<span class=\"ttm_content\">The Parallax One-Page WordPress Template is consisting of 3 hero blocks and contains a beautiful parallax mountain scene. An impactful opening to your web presence!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Parallax One-Pager\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"14\";s:9:\"installed\";b:0;}i:237;a:25:{s:2:\"id\";s:3:\"246\";s:5:\"title\";s:15:\"Parallax Header\";s:5:\"alias\";s:15:\"parallax_header\";s:3:\"zip\";s:25:\"packs/parallax_header.zip\";s:3:\"uid\";s:32:\"32bf4a0f5136853bd6bd366275a7a60b\";s:3:\"img\";s:26:\"parallax_header/slide1.jpg\";s:7:\"preview\";s:71:\"https://revolution.themepunch.com/parallax-one-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:230:\"<span class=\"ttm_content\">The Parallax One-Page WordPress Template is consisting of 3 hero blocks and contains a beautiful parallax mountain scene. An impactful opening to your web presence!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Parallax One-Pager\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"14\";s:9:\"installed\";b:0;}i:238;a:25:{s:2:\"id\";s:3:\"247\";s:5:\"title\";s:16:\"Parallax Content\";s:5:\"alias\";s:16:\"parallax_content\";s:3:\"zip\";s:26:\"packs/parallax_content.zip\";s:3:\"uid\";s:32:\"a25c5fb8f74757476ab4dc038e56f90d\";s:3:\"img\";s:27:\"parallax_content/slide1.jpg\";s:7:\"preview\";s:71:\"https://revolution.themepunch.com/parallax-one-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:230:\"<span class=\"ttm_content\">The Parallax One-Page WordPress Template is consisting of 3 hero blocks and contains a beautiful parallax mountain scene. An impactful opening to your web presence!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Parallax One-Pager\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"14\";s:9:\"installed\";b:0;}i:239;a:25:{s:2:\"id\";s:3:\"248\";s:5:\"title\";s:15:\"Parallax Footer\";s:5:\"alias\";s:15:\"parallax_footer\";s:3:\"zip\";s:25:\"packs/parallax_footer.zip\";s:3:\"uid\";s:32:\"665dff9ea6eaf162a2a1f160f51a9ddb\";s:3:\"img\";s:26:\"parallax_footer/slide1.jpg\";s:7:\"preview\";s:71:\"https://revolution.themepunch.com/parallax-one-page-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:230:\"<span class=\"ttm_content\">The Parallax One-Page WordPress Template is consisting of 3 hero blocks and contains a beautiful parallax mountain scene. An impactful opening to your web presence!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Parallax One-Pager\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"14\";s:9:\"installed\";b:0;}i:240;a:25:{s:2:\"id\";s:3:\"249\";s:5:\"title\";s:18:\"Le Chef Restaurant\";s:5:\"alias\";s:18:\"le-chef-restaurant\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:26:\"le-chef-restaurant-package\";s:3:\"img\";s:39:\"packages/le-chef-restaurant-package.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/le-chef-restaurant-website-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:261:\"<span class=\"ttm_content\">The Le Chef Restaurant Template is a One-Page Website and a full solution for your clients Restaurant. Showcase images in the header slideshow and present the Restaurants offering in a clear way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Le Chef Restaurant\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"15\";s:9:\"installed\";b:0;}i:241;a:25:{s:2:\"id\";s:3:\"250\";s:5:\"title\";s:12:\"Le Chef Menu\";s:5:\"alias\";s:12:\"le-chef-menu\";s:3:\"zip\";s:22:\"packs/le-chef-menu.zip\";s:3:\"uid\";s:32:\"2f2a6a333431fefe4a7b3b6a982b2ff5\";s:3:\"img\";s:23:\"le-chef-menu/slide1.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/le-chef-restaurant-website-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:261:\"<span class=\"ttm_content\">The Le Chef Restaurant Template is a One-Page Website and a full solution for your clients Restaurant. Showcase images in the header slideshow and present the Restaurants offering in a clear way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Le Chef Restaurant\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"15\";s:9:\"installed\";b:0;}i:242;a:25:{s:2:\"id\";s:3:\"251\";s:5:\"title\";s:14:\"Le Chef Header\";s:5:\"alias\";s:14:\"le-chef-header\";s:3:\"zip\";s:24:\"packs/le-chef-header.zip\";s:3:\"uid\";s:32:\"06450ca3be5a4a8959f3752ab974e574\";s:3:\"img\";s:25:\"le-chef-header/slide1.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/le-chef-restaurant-website-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:261:\"<span class=\"ttm_content\">The Le Chef Restaurant Template is a One-Page Website and a full solution for your clients Restaurant. Showcase images in the header slideshow and present the Restaurants offering in a clear way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Le Chef Restaurant\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"15\";s:9:\"installed\";b:0;}i:243;a:25:{s:2:\"id\";s:3:\"252\";s:5:\"title\";s:18:\"Le Chef Philosophy\";s:5:\"alias\";s:18:\"le-chef-philosophy\";s:3:\"zip\";s:28:\"packs/le-chef-philosophy.zip\";s:3:\"uid\";s:32:\"a532fd029addeb18106e751409b8e20a\";s:3:\"img\";s:29:\"le-chef-philosophy/slide1.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/le-chef-restaurant-website-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:261:\"<span class=\"ttm_content\">The Le Chef Restaurant Template is a One-Page Website and a full solution for your clients Restaurant. Showcase images in the header slideshow and present the Restaurants offering in a clear way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Le Chef Restaurant\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"15\";s:9:\"installed\";b:0;}i:244;a:25:{s:2:\"id\";s:3:\"253\";s:5:\"title\";s:12:\"Le Chef Food\";s:5:\"alias\";s:12:\"le-chef-food\";s:3:\"zip\";s:22:\"packs/le-chef-food.zip\";s:3:\"uid\";s:32:\"cd4b6a2cb5de2dd20a0e8ba0c35451df\";s:3:\"img\";s:23:\"le-chef-food/slide1.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/le-chef-restaurant-website-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:261:\"<span class=\"ttm_content\">The Le Chef Restaurant Template is a One-Page Website and a full solution for your clients Restaurant. Showcase images in the header slideshow and present the Restaurants offering in a clear way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Le Chef Restaurant\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"15\";s:9:\"installed\";b:0;}i:245;a:25:{s:2:\"id\";s:3:\"254\";s:5:\"title\";s:16:\"Le Chef La Carte\";s:5:\"alias\";s:16:\"le-chef-la-carte\";s:3:\"zip\";s:26:\"packs/le-chef-la-carte.zip\";s:3:\"uid\";s:32:\"6f312749679c3ba52c41189a6b8bf729\";s:3:\"img\";s:27:\"le-chef-la-carte/slide1.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/le-chef-restaurant-website-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:261:\"<span class=\"ttm_content\">The Le Chef Restaurant Template is a One-Page Website and a full solution for your clients Restaurant. Showcase images in the header slideshow and present the Restaurants offering in a clear way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Le Chef Restaurant\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"15\";s:9:\"installed\";b:0;}i:246;a:25:{s:2:\"id\";s:3:\"255\";s:5:\"title\";s:14:\"Le Chef Footer\";s:5:\"alias\";s:14:\"le-chef-footer\";s:3:\"zip\";s:24:\"packs/le-chef-footer.zip\";s:3:\"uid\";s:32:\"12fc241e8e5b9e5df9758c43448e2907\";s:3:\"img\";s:25:\"le-chef-footer/slide1.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/le-chef-restaurant-website-wordpress-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:261:\"<span class=\"ttm_content\">The Le Chef Restaurant Template is a One-Page Website and a full solution for your clients Restaurant. Showcase images in the header slideshow and present the Restaurants offering in a clear way!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:18:\"Le Chef Restaurant\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"15\";s:9:\"installed\";b:0;}i:247;a:22:{s:2:\"id\";s:3:\"256\";s:5:\"title\";s:20:\"News Magazine Slider\";s:5:\"alias\";s:20:\"news-magazine-slider\";s:3:\"zip\";s:24:\"news-magazine-slider.zip\";s:3:\"uid\";s:32:\"31f2c1506babb1fef459401f051d2d52\";s:3:\"img\";s:31:\"news-magazine-slider/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/news-magazine-slider-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:205:\"<span class=\"ttm_content\">The Magazine Slider offers various layouts that support static content images, HTML5 and Youtube video. Great for any blog or news website!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:248;a:22:{s:2:\"id\";s:3:\"257\";s:5:\"title\";s:18:\"Real Estate Slider\";s:5:\"alias\";s:18:\"real-estate-slider\";s:3:\"zip\";s:22:\"real-estate-slider.zip\";s:3:\"uid\";s:32:\"739ce6336e46815094387c9448e6c804\";s:3:\"img\";s:29:\"real-estate-slider/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/real-estate-slider-for-wordpress/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:204:\"<span class=\"ttm_content\">The Real Estate Slider allows to display real estate offers with a large ken burns background image and additional thumbnail hover images.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:249;a:22:{s:2:\"id\";s:3:\"258\";s:5:\"title\";s:14:\"Fashion Header\";s:5:\"alias\";s:14:\"fashion-header\";s:3:\"zip\";s:18:\"fashion-header.zip\";s:3:\"uid\";s:32:\"24ece4e7f4d31cd90377c62abbd9e25a\";s:3:\"img\";s:25:\"fashion-header/slide1.jpg\";s:7:\"preview\";s:75:\"https://revolution.themepunch.com/fashion-shop-header-slider-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"5.4.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:254:\"<span class=\"ttm_content\">The Fashion Shop Header ist the ideal Slider to display as an intro to your shop website or as a separator in between content. Our unique \"Bubble Morph\" effect makes this module stand out!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:250;a:22:{s:2:\"id\";s:3:\"259\";s:5:\"title\";s:14:\"Seasonal Offer\";s:5:\"alias\";s:13:\"seasonaloffer\";s:3:\"zip\";s:17:\"seasonaloffer.zip\";s:3:\"uid\";s:32:\"caf2f17f8fd64f2f89dcb3c8dd238457\";s:3:\"img\";s:24:\"seasonaloffer/slide1.jpg\";s:7:\"preview\";s:80:\"https://revolution.themepunch.com/seasonal-offer-christmas-header-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.4.8.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:204:\"<span class=\"ttm_content\">Use the Seasonal Offer Header to promote special offers in the holiday season, or just to add some snowy christmas spirit to your website!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:153:\"[{\"path\":\"revslider-snow-addon\\/revslider-snow-addon.php\",\"name\":\"Snow AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:251;a:26:{s:2:\"id\";s:3:\"260\";s:5:\"title\";s:11:\"Barber Shop\";s:5:\"alias\";s:11:\"barber-shop\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:19:\"barber-shop-package\";s:3:\"img\";s:32:\"packages/barber-shop-package.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:252;a:26:{s:2:\"id\";s:3:\"261\";s:5:\"title\";s:18:\"Barber Shop Header\";s:5:\"alias\";s:18:\"barber-shop-header\";s:3:\"zip\";s:28:\"packs/barber-shop-header.zip\";s:3:\"uid\";s:32:\"71c995d36d39a0e8a04cffdf753f2ba2\";s:3:\"img\";s:29:\"barber-shop-header/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:253;a:26:{s:2:\"id\";s:3:\"262\";s:5:\"title\";s:23:\"Barber Shop Mobile Menu\";s:5:\"alias\";s:23:\"barber-shop-mobile-menu\";s:3:\"zip\";s:33:\"packs/barber-shop-mobile-menu.zip\";s:3:\"uid\";s:32:\"762c6fb5c6306f37becb1e55773c2592\";s:3:\"img\";s:34:\"barber-shop-mobile-menu/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:254;a:26:{s:2:\"id\";s:3:\"263\";s:5:\"title\";s:24:\"Barber Shop First Screen\";s:5:\"alias\";s:24:\"barber-shop-first-screen\";s:3:\"zip\";s:34:\"packs/barber-shop-first-screen.zip\";s:3:\"uid\";s:32:\"acf70bfd64cff2c3c2ea5585223575da\";s:3:\"img\";s:35:\"barber-shop-first-screen/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:255;a:26:{s:2:\"id\";s:3:\"264\";s:5:\"title\";s:17:\"Barber Shop About\";s:5:\"alias\";s:17:\"barber-shop-about\";s:3:\"zip\";s:27:\"packs/barber-shop-about.zip\";s:3:\"uid\";s:32:\"bc8b63cfc7f8c34173b4fd5b082fc05a\";s:3:\"img\";s:28:\"barber-shop-about/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:256;a:26:{s:2:\"id\";s:3:\"265\";s:5:\"title\";s:20:\"Barber Shop Services\";s:5:\"alias\";s:20:\"barber-shop-services\";s:3:\"zip\";s:30:\"packs/barber-shop-services.zip\";s:3:\"uid\";s:32:\"d65121d6f84fabd812a2b621b768e10e\";s:3:\"img\";s:31:\"barber-shop-services/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:257;a:26:{s:2:\"id\";s:3:\"266\";s:5:\"title\";s:19:\"Barber Shop Barbers\";s:5:\"alias\";s:19:\"barber-shop-barbers\";s:3:\"zip\";s:29:\"packs/barber-shop-barbers.zip\";s:3:\"uid\";s:32:\"003e9fec9693072119c8f8d8b6690c4d\";s:3:\"img\";s:30:\"barber-shop-barbers/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:258;a:26:{s:2:\"id\";s:3:\"267\";s:5:\"title\";s:20:\"Barber Shop Contacts\";s:5:\"alias\";s:20:\"barber-shop-contacts\";s:3:\"zip\";s:30:\"packs/barber-shop-contacts.zip\";s:3:\"uid\";s:32:\"cdcc08f5d6c90dbcfd0502bda2401643\";s:3:\"img\";s:31:\"barber-shop-contacts/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:259;a:26:{s:2:\"id\";s:3:\"268\";s:5:\"title\";s:18:\"Barber Shop Footer\";s:5:\"alias\";s:18:\"barber-shop-footer\";s:3:\"zip\";s:28:\"packs/barber-shop-footer.zip\";s:3:\"uid\";s:32:\"26ca5ae0de7cdbb2ca19348b6e01eda0\";s:3:\"img\";s:29:\"barber-shop-footer/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/barber-shop-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:220:\"<span class=\"ttm_content\">The Barber Shop is a useful One-Page template presenting all information about your business. Build your websites faster with Slider Revolution templates.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Barber Shop\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"16\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:260;a:22:{s:2:\"id\";s:3:\"269\";s:5:\"title\";s:12:\"Fitness Club\";s:5:\"alias\";s:21:\"fitness-club-template\";s:3:\"zip\";s:25:\"fitness-club-template.zip\";s:3:\"uid\";s:32:\"14ea10d68d6aad1df62b3becf71df754\";s:3:\"img\";s:32:\"fitness-club-template/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/fitness-club-header-for-wordpress/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:223:\"<span class=\"ttm_content\">The Fitness Club Header is the perfect introduction to your fitness themed website. Showcase your current offers or service portfolio with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:261;a:22:{s:2:\"id\";s:3:\"270\";s:5:\"title\";s:13:\"Soccer School\";s:5:\"alias\";s:13:\"soccer-school\";s:3:\"zip\";s:17:\"soccer-school.zip\";s:3:\"uid\";s:32:\"9906b48812aff67097f990eeee42dd41\";s:3:\"img\";s:24:\"soccer-school/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/soccer-club-slider-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:228:\"<span class=\"ttm_content\">The Soccer Club Header is the perfect introduction to your Soccer School themed website. Showcase your current offers or service portfolio with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:262;a:22:{s:2:\"id\";s:3:\"271\";s:5:\"title\";s:10:\"Music Band\";s:5:\"alias\";s:19:\"music-band-template\";s:3:\"zip\";s:23:\"music-band-template.zip\";s:3:\"uid\";s:32:\"91e79657bf1b1812f8114a00ab8e0eb4\";s:3:\"img\";s:30:\"music-band-template/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/music-band-template-for-wordpress/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:7:\"5.4.8.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Music Band Header is the perfect introduction to your Music Band themed website. Showcase your current songs, albums and videos with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:263;a:22:{s:2:\"id\";s:3:\"272\";s:5:\"title\";s:15:\"Restaurant Menu\";s:5:\"alias\";s:15:\"restaurant-menu\";s:3:\"zip\";s:19:\"restaurant-menu.zip\";s:3:\"uid\";s:32:\"078809cffb21b6c4d3f5aaa2daeb193d\";s:3:\"img\";s:26:\"restaurant-menu/slide1.jpg\";s:7:\"preview\";s:71:\"https://revolution.themepunch.com/restaurant-menu-slider-for-wordpress/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:7:\"5.4.8.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:208:\"<span class=\"ttm_content\">The Restaurant Menu Header is the perfect introduction to your Restaurant themed website. Showcase your current dishes with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:264;a:22:{s:2:\"id\";s:3:\"273\";s:5:\"title\";s:16:\"Cinematic Slider\";s:5:\"alias\";s:16:\"cinematic-slider\";s:3:\"zip\";s:20:\"cinematic-slider.zip\";s:3:\"uid\";s:32:\"c53e7dcbb6b656ae7b4c91d333589838\";s:3:\"img\";s:27:\"cinematic-slider/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/cinematic-slider-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:138:\"<span class=\"ttm_content\">Bold texts and a cinematic transition effect make this slider stand out!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:265;a:22:{s:2:\"id\";s:3:\"274\";s:5:\"title\";s:17:\"3D Parallax Cubes\";s:5:\"alias\";s:17:\"3d-parallax-cubes\";s:3:\"zip\";s:21:\"3d-parallax-cubes.zip\";s:3:\"uid\";s:32:\"c5b809a1829f8f809c9a768cd3d6b3cb\";s:3:\"img\";s:28:\"3d-parallax-cubes/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/3d-parallax-cubes-slider-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:149:\"<span class=\"ttm_content\">This amazing 3D cubes parallax effect can be an eye-opening intro for your website!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:266;a:25:{s:2:\"id\";s:3:\"275\";s:5:\"title\";s:33:\"Medicare Medical Services Website\";s:5:\"alias\";s:33:\"medicare-medical-services-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:41:\"medicare-medical-services-website-package\";s:3:\"img\";s:29:\"packages/medicare_package.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:267;a:25:{s:2:\"id\";s:3:\"276\";s:5:\"title\";s:13:\"Medicare Menu\";s:5:\"alias\";s:13:\"medicare-menu\";s:3:\"zip\";s:23:\"packs/medicare-menu.zip\";s:3:\"uid\";s:32:\"0e4ca8fc281e20251b3fffa19d470fed\";s:3:\"img\";s:24:\"medicare-menu/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:268;a:25:{s:2:\"id\";s:3:\"277\";s:5:\"title\";s:15:\"Medicare Header\";s:5:\"alias\";s:15:\"medicare-header\";s:3:\"zip\";s:25:\"packs/medicare-header.zip\";s:3:\"uid\";s:32:\"03e8ade247d8c96f548bc0515f34043f\";s:3:\"img\";s:26:\"medicare-header/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:269;a:25:{s:2:\"id\";s:3:\"278\";s:5:\"title\";s:14:\"Medicare About\";s:5:\"alias\";s:14:\"medicare-about\";s:3:\"zip\";s:24:\"packs/medicare-about.zip\";s:3:\"uid\";s:32:\"a3ab9e89155ef2542820343f30b29f72\";s:3:\"img\";s:25:\"medicare-about/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:270;a:25:{s:2:\"id\";s:3:\"279\";s:5:\"title\";s:18:\"Medicare Highlight\";s:5:\"alias\";s:18:\"medicare-highlight\";s:3:\"zip\";s:28:\"packs/medicare-highlight.zip\";s:3:\"uid\";s:32:\"c3c8a74e5402489f1a85a0c83890ef1f\";s:3:\"img\";s:29:\"medicare-highlight/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:271;a:25:{s:2:\"id\";s:3:\"280\";s:5:\"title\";s:17:\"Medicare Services\";s:5:\"alias\";s:17:\"medicare-services\";s:3:\"zip\";s:27:\"packs/medicare-services.zip\";s:3:\"uid\";s:32:\"8869b0834d4649dcc3221bed65980806\";s:3:\"img\";s:28:\"medicare-services/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:272;a:25:{s:2:\"id\";s:3:\"281\";s:5:\"title\";s:16:\"Medicare Doctors\";s:5:\"alias\";s:16:\"medicare-doctors\";s:3:\"zip\";s:26:\"packs/medicare-doctors.zip\";s:3:\"uid\";s:32:\"2c9d57afd64244b5f7e30b0d87c842f9\";s:3:\"img\";s:27:\"medicare-doctors/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:273;a:25:{s:2:\"id\";s:3:\"282\";s:5:\"title\";s:17:\"Medicare Research\";s:5:\"alias\";s:17:\"medicare-research\";s:3:\"zip\";s:27:\"packs/medicare-research.zip\";s:3:\"uid\";s:32:\"31e84a91fc8b8d5296e715e539a076d0\";s:3:\"img\";s:28:\"medicare-research/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:274;a:25:{s:2:\"id\";s:3:\"283\";s:5:\"title\";s:19:\"Medicare Why Choose\";s:5:\"alias\";s:18:\"medicare-whychoose\";s:3:\"zip\";s:28:\"packs/medicare-whychoose.zip\";s:3:\"uid\";s:32:\"6dad61c672127de9e35884caa45d49a0\";s:3:\"img\";s:29:\"medicare-whychoose/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:275;a:25:{s:2:\"id\";s:3:\"284\";s:5:\"title\";s:16:\"Medicare Contact\";s:5:\"alias\";s:16:\"medicare-contact\";s:3:\"zip\";s:26:\"packs/medicare-contact.zip\";s:3:\"uid\";s:32:\"89bc35ad8beb62a149c42262ae49a270\";s:3:\"img\";s:27:\"medicare-contact/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:276;a:25:{s:2:\"id\";s:3:\"285\";s:5:\"title\";s:15:\"Medicare Footer\";s:5:\"alias\";s:15:\"medicare-footer\";s:3:\"zip\";s:25:\"packs/medicare-footer.zip\";s:3:\"uid\";s:32:\"ccf63e5233b3d63009e5ee90db51b37b\";s:3:\"img\";s:26:\"medicare-footer/slide1.jpg\";s:7:\"preview\";s:68:\"https://revolution.themepunch.com/medicare-medical-services-website/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:163:\"<span class=\"ttm_content\">The Medicare Medical Services template is a great solution for your medical practice or hospital.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Medicare Medical Services\";s:13:\"package_order\";s:2:\"10\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"17\";s:9:\"installed\";b:0;}i:277;a:25:{s:2:\"id\";s:3:\"286\";s:5:\"title\";s:20:\"Coffee Joint Website\";s:5:\"alias\";s:20:\"coffee-joint-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:28:\"coffee-joint-website-package\";s:3:\"img\";s:27:\"packages/coffee_package.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:278;a:25:{s:2:\"id\";s:3:\"287\";s:5:\"title\";s:11:\"Coffee Menu\";s:5:\"alias\";s:11:\"coffee-menu\";s:3:\"zip\";s:21:\"packs/coffee-menu.zip\";s:3:\"uid\";s:32:\"81195cad7be3f5180a267b34ce8cf966\";s:3:\"img\";s:22:\"coffee-menu/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:279;a:25:{s:2:\"id\";s:3:\"288\";s:5:\"title\";s:13:\"Coffee Header\";s:5:\"alias\";s:13:\"coffee-header\";s:3:\"zip\";s:23:\"packs/coffee-header.zip\";s:3:\"uid\";s:32:\"5eed8adb9d3ae12168ad4735ac63eb20\";s:3:\"img\";s:24:\"coffee-header/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:280;a:25:{s:2:\"id\";s:3:\"289\";s:5:\"title\";s:17:\"Coffee Philosophy\";s:5:\"alias\";s:17:\"coffee-philosophy\";s:3:\"zip\";s:27:\"packs/coffee-philosophy.zip\";s:3:\"uid\";s:32:\"76b5ccae3fa87fd0f991b87e7ae71c27\";s:3:\"img\";s:28:\"coffee-philosophy/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:281;a:25:{s:2:\"id\";s:3:\"290\";s:5:\"title\";s:12:\"Coffee Carte\";s:5:\"alias\";s:12:\"coffee-carte\";s:3:\"zip\";s:22:\"packs/coffee-carte.zip\";s:3:\"uid\";s:32:\"470214ddd2cec585629fb79a0fd908d6\";s:3:\"img\";s:23:\"coffee-carte/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:282;a:25:{s:2:\"id\";s:3:\"291\";s:5:\"title\";s:13:\"Coffee Teaser\";s:5:\"alias\";s:13:\"coffee-teaser\";s:3:\"zip\";s:23:\"packs/coffee-teaser.zip\";s:3:\"uid\";s:32:\"2ed868896c92a7bfb6431803c79e8486\";s:3:\"img\";s:24:\"coffee-teaser/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:283;a:25:{s:2:\"id\";s:3:\"292\";s:5:\"title\";s:14:\"Coffee Find Us\";s:5:\"alias\";s:13:\"coffee-findus\";s:3:\"zip\";s:23:\"packs/coffee-findus.zip\";s:3:\"uid\";s:32:\"96d3784473dfa64bce9e1e4101919927\";s:3:\"img\";s:24:\"coffee-findus/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:284;a:25:{s:2:\"id\";s:3:\"293\";s:5:\"title\";s:13:\"Coffee Footer\";s:5:\"alias\";s:13:\"coffee-footer\";s:3:\"zip\";s:23:\"packs/coffee-footer.zip\";s:3:\"uid\";s:32:\"6027c25e87a5fe7fd8727a51c0967915\";s:3:\"img\";s:24:\"coffee-footer/slide1.jpg\";s:7:\"preview\";s:76:\"https://revolution.themepunch.com/coffee-joint-coffee-shop-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:144:\"<span class=\"ttm_content\">The Coffee Joint website template is a great solution for your cafe or bistro.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Coffee Joint\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"18\";s:9:\"installed\";b:0;}i:285;a:26:{s:2:\"id\";s:3:\"294\";s:5:\"title\";s:17:\"Minimal Portfolio\";s:5:\"alias\";s:25:\"minimal-portfolio-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:25:\"minimal-portfolio-package\";s:3:\"img\";s:38:\"packages/minimal_portfolio_package.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/minimal-portfolio-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">The Minimal Portfolio template is a slide based website with additional modal detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Minimal Portfolio\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"19\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:286;a:26:{s:2:\"id\";s:3:\"295\";s:5:\"title\";s:17:\"Minimal Portfolio\";s:5:\"alias\";s:17:\"minimal-portfolio\";s:3:\"zip\";s:27:\"packs/minimal-portfolio.zip\";s:3:\"uid\";s:32:\"183b97b301d5ff0b171c067a87c8a3f5\";s:3:\"img\";s:28:\"minimal-portfolio/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/minimal-portfolio-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">The Minimal Portfolio template is a slide based website with additional modal detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Minimal Portfolio\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"19\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:287;a:26:{s:2:\"id\";s:3:\"296\";s:5:\"title\";s:23:\"Minimal Portfolio Modal\";s:5:\"alias\";s:23:\"minimal-portfolio-modal\";s:3:\"zip\";s:33:\"packs/minimal-portfolio-modal.zip\";s:3:\"uid\";s:32:\"6874e6cec3663670f209a8d8a4f26b16\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/minimal-portfolio-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">The Minimal Portfolio template is a slide based website with additional modal detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Minimal Portfolio\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"19\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:288;a:25:{s:2:\"id\";s:3:\"297\";s:5:\"title\";s:23:\"Angled Business Website\";s:5:\"alias\";s:23:\"angled-business-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:31:\"angled-business-website-package\";s:3:\"img\";s:27:\"packages/angled_package.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:289;a:25:{s:2:\"id\";s:3:\"298\";s:5:\"title\";s:11:\"Angled Menu\";s:5:\"alias\";s:11:\"angled-menu\";s:3:\"zip\";s:21:\"packs/angled-menu.zip\";s:3:\"uid\";s:32:\"2fe0c4682d1231ee3918be9e4fcb1837\";s:3:\"img\";s:22:\"angled-menu/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:290;a:25:{s:2:\"id\";s:3:\"299\";s:5:\"title\";s:13:\"Angled Header\";s:5:\"alias\";s:13:\"angled-header\";s:3:\"zip\";s:23:\"packs/angled-header.zip\";s:3:\"uid\";s:32:\"09462601d4edca8dff899de6f666dc47\";s:3:\"img\";s:24:\"angled-header/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:291;a:25:{s:2:\"id\";s:3:\"300\";s:5:\"title\";s:11:\"Angled News\";s:5:\"alias\";s:11:\"angled-news\";s:3:\"zip\";s:21:\"packs/angled-news.zip\";s:3:\"uid\";s:32:\"b315105763ed91214cb2f0ac12615729\";s:3:\"img\";s:22:\"angled-news/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:292;a:25:{s:2:\"id\";s:3:\"301\";s:5:\"title\";s:15:\"Angled Services\";s:5:\"alias\";s:15:\"angled-services\";s:3:\"zip\";s:25:\"packs/angled-services.zip\";s:3:\"uid\";s:32:\"7605651c1487e1a6c32edc70017be8ad\";s:3:\"img\";s:26:\"angled-services/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:293;a:25:{s:2:\"id\";s:3:\"302\";s:5:\"title\";s:14:\"Angled Success\";s:5:\"alias\";s:14:\"angled-success\";s:3:\"zip\";s:24:\"packs/angled-success.zip\";s:3:\"uid\";s:32:\"9e3fa974a42ecf80e1ec6ff991fca430\";s:3:\"img\";s:25:\"angled-success/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:294;a:25:{s:2:\"id\";s:3:\"303\";s:5:\"title\";s:13:\"Angled Footer\";s:5:\"alias\";s:13:\"angled-footer\";s:3:\"zip\";s:23:\"packs/angled-footer.zip\";s:3:\"uid\";s:32:\"aed4eaa2f7883351ba9c9947feef153e\";s:3:\"img\";s:24:\"angled-footer/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:295;a:25:{s:2:\"id\";s:3:\"304\";s:5:\"title\";s:20:\"Angled Content Modal\";s:5:\"alias\";s:20:\"angled-content-modal\";s:3:\"zip\";s:30:\"packs/angled-content-modal.zip\";s:3:\"uid\";s:32:\"4ddc74515fdf84f974217e4ed47a7c66\";s:3:\"img\";s:31:\"angled-content-modal/slide1.jpg\";s:7:\"preview\";s:67:\"https://revolution.themepunch.com/angled-business-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Angled Business Website template is a geometric, parallax one-page website with modal based detail pages.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:15:\"Angled Business\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"20\";s:9:\"installed\";b:0;}i:296;a:22:{s:2:\"id\";s:3:\"312\";s:5:\"title\";s:24:\"Retouch Before and After\";s:5:\"alias\";s:7:\"Retouch\";s:3:\"zip\";s:11:\"Retouch.zip\";s:3:\"uid\";s:32:\"58894991f1abd8b448c8d353b1b5fe76\";s:3:\"img\";s:18:\"Retouch/slide1.jpg\";s:7:\"preview\";s:61:\"http://revolution.themepunch.com/retouch-before-after-slider/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:155:\"<span class=\"ttm_content\">The Retouch Slider is the perfect way to compare your photos before and after retouching.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-beforeafter-addon\\/revslider-beforeafter-addon.php\",\"name\":\"Before After AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:297;a:22:{s:2:\"id\";s:3:\"313\";s:5:\"title\";s:11:\"Tech Slider\";s:5:\"alias\";s:11:\"tech-slider\";s:3:\"zip\";s:15:\"tech-slider.zip\";s:3:\"uid\";s:32:\"a98e2b264f00a1116d21808c6a543162\";s:3:\"img\";s:22:\"tech-slider/slide1.jpg\";s:7:\"preview\";s:63:\"http://revolution.themepunch.com/tech-showcase-slider-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:153:\"<span class=\"ttm_content\">This classic slider module with sleek device mockups features a smooth parallax effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:298;a:25:{s:2:\"id\";s:3:\"314\";s:5:\"title\";s:19:\"Peak Agency Website\";s:5:\"alias\";s:19:\"peak-agency-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:27:\"peak-agency-website-package\";s:3:\"img\";s:25:\"packages/peak_package.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/peak-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:129:\"<span class=\"ttm_content\">The Peak Agency Website template is a minimal, light one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Peak Agency\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"22\";s:9:\"installed\";b:0;}i:299;a:25:{s:2:\"id\";s:3:\"315\";s:5:\"title\";s:11:\"Peak Header\";s:5:\"alias\";s:11:\"peak-header\";s:3:\"zip\";s:21:\"packs/peak-header.zip\";s:3:\"uid\";s:32:\"b721bd612e9fbc5182418ad3fd7d0808\";s:3:\"img\";s:22:\"peak-header/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/peak-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:129:\"<span class=\"ttm_content\">The Peak Agency Website template is a minimal, light one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Peak Agency\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"22\";s:9:\"installed\";b:0;}i:300;a:25:{s:2:\"id\";s:3:\"316\";s:5:\"title\";s:10:\"Peak About\";s:5:\"alias\";s:10:\"peak-about\";s:3:\"zip\";s:20:\"packs/peak-about.zip\";s:3:\"uid\";s:32:\"7e68b1012fb03490d45c7f79e8cb1b19\";s:3:\"img\";s:21:\"peak-about/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/peak-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:129:\"<span class=\"ttm_content\">The Peak Agency Website template is a minimal, light one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Peak Agency\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"22\";s:9:\"installed\";b:0;}i:301;a:25:{s:2:\"id\";s:3:\"317\";s:5:\"title\";s:14:\"Peak Portfolio\";s:5:\"alias\";s:14:\"peak-portfolio\";s:3:\"zip\";s:24:\"packs/peak-portfolio.zip\";s:3:\"uid\";s:32:\"6198d1885ba9e95221c33e404f21bdbc\";s:3:\"img\";s:25:\"peak-portfolio/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/peak-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:129:\"<span class=\"ttm_content\">The Peak Agency Website template is a minimal, light one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Peak Agency\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"22\";s:9:\"installed\";b:0;}i:302;a:25:{s:2:\"id\";s:3:\"318\";s:5:\"title\";s:11:\"Peak Footer\";s:5:\"alias\";s:11:\"peak-footer\";s:3:\"zip\";s:21:\"packs/peak-footer.zip\";s:3:\"uid\";s:32:\"2dead6897ad3b3a709b380d81242f76b\";s:3:\"img\";s:22:\"peak-footer/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/peak-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:129:\"<span class=\"ttm_content\">The Peak Agency Website template is a minimal, light one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:11:\"Peak Agency\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"22\";s:9:\"installed\";b:0;}i:303;a:25:{s:2:\"id\";s:3:\"319\";s:5:\"title\";s:24:\"Modern Portfolio Website\";s:5:\"alias\";s:24:\"modern-portfolio-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:32:\"modern-portfolio-website-package\";s:3:\"img\";s:30:\"packages/portfolio-package.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/modern-portfolio-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A modern portfolio template with fancy scroll animations and a colorful design.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"Modern Portfolio\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"23\";s:9:\"installed\";b:0;}i:304;a:25:{s:2:\"id\";s:3:\"320\";s:5:\"title\";s:17:\"Portfolio Welcome\";s:5:\"alias\";s:17:\"portfolio-welcome\";s:3:\"zip\";s:27:\"packs/portfolio-welcome.zip\";s:3:\"uid\";s:32:\"97336b8785e4a7b27facaf1547e0464d\";s:3:\"img\";s:28:\"portfolio-welcome/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/modern-portfolio-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A modern portfolio template with fancy scroll animations and a colorful design.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"Modern Portfolio\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"23\";s:9:\"installed\";b:0;}i:305;a:25:{s:2:\"id\";s:3:\"321\";s:5:\"title\";s:15:\"Portfolio About\";s:5:\"alias\";s:15:\"portfolio-about\";s:3:\"zip\";s:25:\"packs/portfolio-about.zip\";s:3:\"uid\";s:32:\"5d3a4724fd453de5313ceb6696c1db62\";s:3:\"img\";s:26:\"portfolio-about/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/modern-portfolio-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A modern portfolio template with fancy scroll animations and a colorful design.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"Modern Portfolio\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"23\";s:9:\"installed\";b:0;}i:306;a:25:{s:2:\"id\";s:3:\"322\";s:5:\"title\";s:21:\"Portfolio Works Title\";s:5:\"alias\";s:21:\"portfolio-works-title\";s:3:\"zip\";s:31:\"packs/portfolio-works-title.zip\";s:3:\"uid\";s:32:\"cbb5c6e875cc1f25b463fdf89cabef28\";s:3:\"img\";s:32:\"portfolio-works-title/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/modern-portfolio-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A modern portfolio template with fancy scroll animations and a colorful design.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"Modern Portfolio\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"23\";s:9:\"installed\";b:0;}i:307;a:25:{s:2:\"id\";s:3:\"323\";s:5:\"title\";s:23:\"Portfolio Works Content\";s:5:\"alias\";s:23:\"portfolio-works-content\";s:3:\"zip\";s:33:\"packs/portfolio-works-content.zip\";s:3:\"uid\";s:32:\"5c87311128c7794ffa6ee07ea0648082\";s:3:\"img\";s:34:\"portfolio-works-content/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/modern-portfolio-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A modern portfolio template with fancy scroll animations and a colorful design.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"Modern Portfolio\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"23\";s:9:\"installed\";b:0;}i:308;a:25:{s:2:\"id\";s:3:\"324\";s:5:\"title\";s:18:\"Portfolio Contacts\";s:5:\"alias\";s:18:\"portfolio-contacts\";s:3:\"zip\";s:28:\"packs/portfolio-contacts.zip\";s:3:\"uid\";s:32:\"bd81feffad83b69218f7e837478038e5\";s:3:\"img\";s:29:\"portfolio-contacts/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/modern-portfolio-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A modern portfolio template with fancy scroll animations and a colorful design.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:16:\"Modern Portfolio\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"23\";s:9:\"installed\";b:0;}i:309;a:26:{s:2:\"id\";s:3:\"325\";s:5:\"title\";s:18:\"App Studio Website\";s:5:\"alias\";s:18:\"app-studio-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:26:\"app-studio-website-package\";s:3:\"img\";s:31:\"packages/App_Studio_package.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/app-studio-website/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:149:\"<span class=\"ttm_content\">A modern one-page presentation website to present your mobile app development team.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:10:\"App Studio\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"24\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:310;a:26:{s:2:\"id\";s:3:\"326\";s:5:\"title\";s:18:\"App Studio Welcome\";s:5:\"alias\";s:18:\"App-Studio-Welcome\";s:3:\"zip\";s:28:\"packs/App-Studio-Welcome.zip\";s:3:\"uid\";s:32:\"2ce0f3c54214b04e6c3a9becfd59730c\";s:3:\"img\";s:29:\"App-Studio-Welcome/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/app-studio-website/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:149:\"<span class=\"ttm_content\">A modern one-page presentation website to present your mobile app development team.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:10:\"App Studio\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"24\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:311;a:26:{s:2:\"id\";s:3:\"327\";s:5:\"title\";s:19:\"App Studio Services\";s:5:\"alias\";s:19:\"App-Studio-Services\";s:3:\"zip\";s:29:\"packs/App-Studio-Services.zip\";s:3:\"uid\";s:32:\"5df7776271ec69d2f9edaa6b842715a9\";s:3:\"img\";s:30:\"App-Studio-Services/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/app-studio-website/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:149:\"<span class=\"ttm_content\">A modern one-page presentation website to present your mobile app development team.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:10:\"App Studio\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"24\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:312;a:26:{s:2:\"id\";s:3:\"328\";s:5:\"title\";s:16:\"App Studio About\";s:5:\"alias\";s:16:\"App-Studio-About\";s:3:\"zip\";s:26:\"packs/App-Studio-About.zip\";s:3:\"uid\";s:32:\"af8b84dc116c629df7bd89fc69271a2e\";s:3:\"img\";s:27:\"App-Studio-About/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/app-studio-website/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:149:\"<span class=\"ttm_content\">A modern one-page presentation website to present your mobile app development team.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:10:\"App Studio\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"24\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:313;a:26:{s:2:\"id\";s:3:\"329\";s:5:\"title\";s:19:\"App Studio Contacts\";s:5:\"alias\";s:19:\"App-Studio-Contacts\";s:3:\"zip\";s:29:\"packs/App-Studio-Contacts.zip\";s:3:\"uid\";s:32:\"afbbd2214c983d314f3215a00db9198d\";s:3:\"img\";s:30:\"App-Studio-Contacts/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/app-studio-website/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:149:\"<span class=\"ttm_content\">A modern one-page presentation website to present your mobile app development team.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:10:\"App Studio\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"24\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:314;a:22:{s:2:\"id\";s:3:\"330\";s:5:\"title\";s:14:\"Cube Animation\";s:5:\"alias\";s:14:\"cube-animation\";s:3:\"zip\";s:18:\"cube-animation.zip\";s:3:\"uid\";s:32:\"c03dd3cfc60479dfc6d79ddb64fa0ec5\";s:3:\"img\";s:25:\"cube-animation/slide1.jpg\";s:7:\"preview\";s:65:\"https://revolution.themepunch.com/cube-animation-slider-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:155:\"<span class=\"ttm_content\">A modern slider with text elements, cube animations and a striking call to action button.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:315;a:26:{s:2:\"id\";s:3:\"331\";s:5:\"title\";s:13:\"Basic Website\";s:5:\"alias\";s:13:\"basic-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:21:\"basic-website-package\";s:3:\"img\";s:26:\"packages/basic_package.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:316;a:26:{s:2:\"id\";s:3:\"332\";s:5:\"title\";s:10:\"Basic Menu\";s:5:\"alias\";s:10:\"basic-menu\";s:3:\"zip\";s:20:\"packs/basic-menu.zip\";s:3:\"uid\";s:32:\"39277f53b2cb5ac644a1649b47c37270\";s:3:\"img\";s:21:\"basic-menu/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:317;a:26:{s:2:\"id\";s:3:\"333\";s:5:\"title\";s:12:\"Basic Header\";s:5:\"alias\";s:12:\"basic-header\";s:3:\"zip\";s:22:\"packs/basic-header.zip\";s:3:\"uid\";s:32:\"ad7a32dbccb0bdf9de64cf2adfa950a2\";s:3:\"img\";s:23:\"basic-header/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:318;a:26:{s:2:\"id\";s:3:\"334\";s:5:\"title\";s:13:\"Basic Content\";s:5:\"alias\";s:13:\"basic-content\";s:3:\"zip\";s:23:\"packs/basic-content.zip\";s:3:\"uid\";s:32:\"0b12f3b183a3c8206e3a7b28d2d93108\";s:3:\"img\";s:24:\"basic-content/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:319;a:26:{s:2:\"id\";s:3:\"335\";s:5:\"title\";s:14:\"Basic Carousel\";s:5:\"alias\";s:14:\"basic-carousel\";s:3:\"zip\";s:24:\"packs/basic-carousel.zip\";s:3:\"uid\";s:32:\"e4abb5c6d5cf914530575a982d3dfc14\";s:3:\"img\";s:25:\"basic-carousel/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:8:\"carousel\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:320;a:26:{s:2:\"id\";s:3:\"336\";s:5:\"title\";s:13:\"Basic Callout\";s:5:\"alias\";s:13:\"basic-callout\";s:3:\"zip\";s:23:\"packs/basic-callout.zip\";s:3:\"uid\";s:32:\"2ccc208b9322f5435d0f4ff64c6d9dab\";s:3:\"img\";s:24:\"basic-callout/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:321;a:26:{s:2:\"id\";s:3:\"337\";s:5:\"title\";s:10:\"Basic Grid\";s:5:\"alias\";s:10:\"basic-grid\";s:3:\"zip\";s:20:\"packs/basic-grid.zip\";s:3:\"uid\";s:32:\"3cb4b41d2992eba012921b8fb7c96daa\";s:3:\"img\";s:21:\"basic-grid/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:322;a:26:{s:2:\"id\";s:3:\"338\";s:5:\"title\";s:17:\"Basic Video Block\";s:5:\"alias\";s:17:\"basic-video-block\";s:3:\"zip\";s:27:\"packs/basic-video-block.zip\";s:3:\"uid\";s:32:\"e7c1d42b21819741f3e72c1325dae5ed\";s:3:\"img\";s:28:\"basic-video-block/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:323;a:26:{s:2:\"id\";s:3:\"339\";s:5:\"title\";s:12:\"Basic Footer\";s:5:\"alias\";s:12:\"basic-footer\";s:3:\"zip\";s:22:\"packs/basic-footer.zip\";s:3:\"uid\";s:32:\"ed8f6a554775ebace558af2f4f2dcbac\";s:3:\"img\";s:23:\"basic-footer/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:324;a:26:{s:2:\"id\";s:3:\"340\";s:5:\"title\";s:14:\"Basic Lightbox\";s:5:\"alias\";s:14:\"basic-lightbox\";s:3:\"zip\";s:24:\"packs/basic-lightbox.zip\";s:3:\"uid\";s:32:\"e4b025b300b1a8f417d04eb80113fac2\";s:3:\"img\";s:25:\"basic-lightbox/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/basic-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:187:\"<span class=\"ttm_content\">The Basic Website template is a minimal one-page website with all the essential modules. Usable and quickly customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:13:\"Basic Website\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"25\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:325;a:22:{s:2:\"id\";s:3:\"341\";s:5:\"title\";s:13:\"Nature Slider\";s:5:\"alias\";s:13:\"nature-slider\";s:3:\"zip\";s:17:\"nature-slider.zip\";s:3:\"uid\";s:32:\"eef1a4584ec1c3b8c26c305cca44e805\";s:3:\"img\";s:24:\"nature-slider/slide1.jpg\";s:7:\"preview\";s:56:\"http://revolution.themepunch.com/nature-explorer-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:151:\"<span class=\"ttm_content\">The Nature Explorer Slider Template uses the Distortion and Particle Effects Add-Ons.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:356:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"},{\"path\":\"revslider-liquideffect-addon\\/revslider-liquideffect-addon.php\",\"name\":\"Distortion Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:326;a:22:{s:2:\"id\";s:3:\"342\";s:5:\"title\";s:11:\"Art Gallery\";s:5:\"alias\";s:11:\"art-gallery\";s:3:\"zip\";s:15:\"art-gallery.zip\";s:3:\"uid\";s:32:\"b8c5095ae3407337e6e5b2a8515e7d6e\";s:3:\"img\";s:22:\"art-gallery/slide1.jpg\";s:7:\"preview\";s:62:\"https://revolution.themepunch.com/art-gallery-slider-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:145:\"<span class=\"ttm_content\">A modern slider with large, geometric elements and interesting mask animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:327;a:25:{s:2:\"id\";s:3:\"343\";s:5:\"title\";s:20:\"Construction Company\";s:5:\"alias\";s:28:\"construction-company-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:36:\"construction-company-website-package\";s:3:\"img\";s:33:\"packages/construction_package.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/construction-company-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:244:\"<span class=\"ttm_content\">The Construction Company is the perfect introduction to your Construction themed website. Showcase your current projects, services and contact information with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";s:163:\"[{\"path\":\"revslider-revealer-addon\\/revslider-revealer-addon.php\",\"name\":\"Reveal AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Construction Company\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"26\";s:9:\"installed\";b:0;}i:328;a:25:{s:2:\"id\";s:3:\"344\";s:5:\"title\";s:19:\"Construction Header\";s:5:\"alias\";s:19:\"Construction-Header\";s:3:\"zip\";s:29:\"packs/Construction-Header.zip\";s:3:\"uid\";s:32:\"5c77de774b8f5487c1276c4a7b3dc80c\";s:3:\"img\";s:30:\"Construction-Header/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/construction-company-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:244:\"<span class=\"ttm_content\">The Construction Company is the perfect introduction to your Construction themed website. Showcase your current projects, services and contact information with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Construction Company\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"26\";s:9:\"installed\";b:0;}i:329;a:25:{s:2:\"id\";s:3:\"345\";s:5:\"title\";s:17:\"Construction Home\";s:5:\"alias\";s:17:\"Construction-Home\";s:3:\"zip\";s:27:\"packs/Construction-Home.zip\";s:3:\"uid\";s:32:\"fcb277f0c07dad270d2a7cef4431bef8\";s:3:\"img\";s:28:\"Construction-Home/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/construction-company-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:244:\"<span class=\"ttm_content\">The Construction Company is the perfect introduction to your Construction themed website. Showcase your current projects, services and contact information with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Construction Company\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"26\";s:9:\"installed\";b:0;}i:330;a:25:{s:2:\"id\";s:3:\"346\";s:5:\"title\";s:21:\"Construction Projects\";s:5:\"alias\";s:21:\"Construction-Projects\";s:3:\"zip\";s:31:\"packs/Construction-Projects.zip\";s:3:\"uid\";s:32:\"0c847173c3739f79778dc2c0fc9704e4\";s:3:\"img\";s:32:\"Construction-Projects/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/construction-company-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:244:\"<span class=\"ttm_content\">The Construction Company is the perfect introduction to your Construction themed website. Showcase your current projects, services and contact information with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Construction Company\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"26\";s:9:\"installed\";b:0;}i:331;a:25:{s:2:\"id\";s:3:\"347\";s:5:\"title\";s:20:\"Construction History\";s:5:\"alias\";s:20:\"Construction-History\";s:3:\"zip\";s:30:\"packs/Construction-History.zip\";s:3:\"uid\";s:32:\"758da120c4b6c5606692faf0aa43aac6\";s:3:\"img\";s:31:\"Construction-History/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/construction-company-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:244:\"<span class=\"ttm_content\">The Construction Company is the perfect introduction to your Construction themed website. Showcase your current projects, services and contact information with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Construction Company\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"26\";s:9:\"installed\";b:0;}i:332;a:25:{s:2:\"id\";s:3:\"348\";s:5:\"title\";s:21:\"Construction Services\";s:5:\"alias\";s:21:\"Construction-Services\";s:3:\"zip\";s:31:\"packs/Construction-Services.zip\";s:3:\"uid\";s:32:\"5ad5b841c1d89e97ddbf972c8b11abd4\";s:3:\"img\";s:32:\"Construction-Services/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/construction-company-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:244:\"<span class=\"ttm_content\">The Construction Company is the perfect introduction to your Construction themed website. Showcase your current projects, services and contact information with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Construction Company\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"26\";s:9:\"installed\";b:0;}i:333;a:25:{s:2:\"id\";s:3:\"349\";s:5:\"title\";s:21:\"Construction Contacts\";s:5:\"alias\";s:21:\"Construction-Contacts\";s:3:\"zip\";s:31:\"packs/Construction-Contacts.zip\";s:3:\"uid\";s:32:\"b8c3c34046bb91ebb243e4da64745d37\";s:3:\"img\";s:32:\"Construction-Contacts/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/construction-company-website/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:244:\"<span class=\"ttm_content\">The Construction Company is the perfect introduction to your Construction themed website. Showcase your current projects, services and contact information with sleek transitions!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:420:\"<span class=\"ttm_content\">If you want to setup the full website example as seen in the preview, please follow the <a href=\"https://www.themepunch.com/faq/setup-content-blocks-template/\" target=\"_blank\">Content Blocks instructions here</a>.<br><br>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:20:\"Construction Company\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"26\";s:9:\"installed\";b:0;}i:334;a:22:{s:2:\"id\";s:3:\"350\";s:5:\"title\";s:22:\"Classic Cars Evolution\";s:5:\"alias\";s:22:\"Classic-Cars-Evolution\";s:3:\"zip\";s:26:\"Classic-Cars-Evolution.zip\";s:3:\"uid\";s:32:\"7061757f128fd624b0227715dab73b74\";s:3:\"img\";s:33:\"Classic-Cars-Evolution/slide1.jpg\";s:7:\"preview\";s:65:\"https://revolution.themepunch.com/classic-cars-before-after-hero/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:156:\"<span class=\"ttm_content\">The Classic Cars Evolution Slider is a great example of our popular before & after Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-beforeafter-addon\\/revslider-beforeafter-addon.php\",\"name\":\"Before After AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:335;a:23:{s:2:\"id\";s:3:\"351\";s:5:\"title\";s:21:\"404 Error Space Theme\";s:5:\"alias\";s:21:\"404-Error-Space-Theme\";s:3:\"zip\";s:25:\"404-Error-Space-Theme.zip\";s:3:\"uid\";s:32:\"6412adc7ec025826328e40e552a14e1e\";s:3:\"img\";s:32:\"404-Error-Space-Theme/slide1.jpg\";s:7:\"preview\";s:49:\"https://revolution.themepunch.com/404-error-page/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.0.0\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:158:\"<span class=\"ttm_content\">The Classic Cars Evolution Slider is the perfect way to make your error page more beautiful.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:336;a:25:{s:2:\"id\";s:3:\"352\";s:5:\"title\";s:12:\"Landing Page\";s:5:\"alias\";s:20:\"landing-page-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:28:\"landing-page-website-package\";s:3:\"img\";s:23:\"packages/lp_package.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:337;a:25:{s:2:\"id\";s:3:\"353\";s:5:\"title\";s:17:\"Landing Page Hero\";s:5:\"alias\";s:17:\"landing-page-hero\";s:3:\"zip\";s:27:\"packs/landing-page-hero.zip\";s:3:\"uid\";s:32:\"d328635caa20da7ee8a3ab687f8656ff\";s:3:\"img\";s:28:\"landing-page-hero/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:338;a:25:{s:2:\"id\";s:3:\"354\";s:5:\"title\";s:21:\"Landing Page Features\";s:5:\"alias\";s:21:\"landing-page-features\";s:3:\"zip\";s:31:\"packs/landing-page-features.zip\";s:3:\"uid\";s:32:\"6552bc72abace10918a64866d9bb79c1\";s:3:\"img\";s:32:\"landing-page-features/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:339;a:25:{s:2:\"id\";s:3:\"355\";s:5:\"title\";s:20:\"Landing Page Callout\";s:5:\"alias\";s:20:\"landing-page-callout\";s:3:\"zip\";s:30:\"packs/landing-page-callout.zip\";s:3:\"uid\";s:32:\"c5b101ea5471e7409ae7effa8d45fbcf\";s:3:\"img\";s:31:\"landing-page-callout/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:340;a:25:{s:2:\"id\";s:3:\"356\";s:5:\"title\";s:20:\"Landing Page Content\";s:5:\"alias\";s:20:\"landing-page-content\";s:3:\"zip\";s:30:\"packs/landing-page-content.zip\";s:3:\"uid\";s:32:\"34da8057a6bb3677c9adf9f18ffc6cf0\";s:3:\"img\";s:31:\"landing-page-content/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:341;a:25:{s:2:\"id\";s:3:\"357\";s:5:\"title\";s:25:\"Landing Page Testimonials\";s:5:\"alias\";s:25:\"landing-page-testimonials\";s:3:\"zip\";s:35:\"packs/landing-page-testimonials.zip\";s:3:\"uid\";s:32:\"a83606e311cd5115422d86f04890cbf1\";s:3:\"img\";s:36:\"landing-page-testimonials/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:342;a:25:{s:2:\"id\";s:3:\"358\";s:5:\"title\";s:27:\"Landing Page Call to Action\";s:5:\"alias\";s:27:\"landing-page-call-to-action\";s:3:\"zip\";s:37:\"packs/landing-page-call-to-action.zip\";s:3:\"uid\";s:32:\"adfb456b27fa7eb6b1415d8f80836f05\";s:3:\"img\";s:38:\"landing-page-call-to-action/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:343;a:25:{s:2:\"id\";s:3:\"359\";s:5:\"title\";s:17:\"Landing Page Help\";s:5:\"alias\";s:17:\"landing-page-help\";s:3:\"zip\";s:27:\"packs/landing-page-help.zip\";s:3:\"uid\";s:32:\"ca502431f9b7f6249d99b02464de2dd7\";s:3:\"img\";s:28:\"landing-page-help/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:344;a:25:{s:2:\"id\";s:3:\"360\";s:5:\"title\";s:19:\"Landing Page Footer\";s:5:\"alias\";s:19:\"landing-page-footer\";s:3:\"zip\";s:29:\"packs/landing-page-footer.zip\";s:3:\"uid\";s:32:\"2a6afc371dbd60cb117f8a0f5d09eac9\";s:3:\"img\";s:30:\"landing-page-footer/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:345;a:25:{s:2:\"id\";s:3:\"361\";s:5:\"title\";s:24:\"Landing Page Price Modal\";s:5:\"alias\";s:24:\"landing-page-price-modal\";s:3:\"zip\";s:34:\"packs/landing-page-price-modal.zip\";s:3:\"uid\";s:32:\"a6c5c0430b46dd4e6e68416964a8c54d\";s:3:\"img\";s:35:\"landing-page-price-modal/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/landing-page-builder/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.0.8\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:193:\"<span class=\"ttm_content\">Landing Page is a one-page website template with standard modules to build an effective landing page for your business/product.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:624:\"<span class=\"ttm_content\">After installing this template package, please remove the \"price modal\" module shortcode from the automatically created page. Also, a small modification is needed in these templates: \"Landing Page Hero\", \"Landing page Call to Action\" and \"Landing Page Footer\". Click the buttons in these template and then go to \"layer -> actions\" and set the target of the \"Open Slider Modal\" action to the \"Landing Page Price Modal\".</span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:12:\"Landing Page\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"27\";s:9:\"installed\";b:0;}i:346;a:25:{s:2:\"id\";s:3:\"371\";s:5:\"title\";s:17:\"Corporate Website\";s:5:\"alias\";s:17:\"corporate-website\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:25:\"corporate-website-package\";s:3:\"img\";s:30:\"packages/corporate-website.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";s:173:\"[{\"path\":\"revslider-typewriter-addon\\/revslider-typewriter-addon.php\",\"name\":\"Typewriter AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/typewriter-addon\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:347;a:25:{s:2:\"id\";s:3:\"372\";s:5:\"title\";s:16:\"Corporate Header\";s:5:\"alias\";s:16:\"Corporate-Header\";s:3:\"zip\";s:26:\"packs/Corporate-Header.zip\";s:3:\"uid\";s:32:\"04f868e3812a1681f00ab89580e5d1f8\";s:3:\"img\";s:27:\"Corporate-Header/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:348;a:25:{s:2:\"id\";s:3:\"373\";s:5:\"title\";s:24:\"Corporate Welcome Screen\";s:5:\"alias\";s:24:\"Corporate-Welcome-Screen\";s:3:\"zip\";s:34:\"packs/Corporate-Welcome-Screen.zip\";s:3:\"uid\";s:32:\"052afe98ef819f7ace041dbbdb749639\";s:3:\"img\";s:35:\"Corporate-Welcome-Screen/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:173:\"[{\"path\":\"revslider-typewriter-addon\\/revslider-typewriter-addon.php\",\"name\":\"Typewriter AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/typewriter-addon\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:349;a:25:{s:2:\"id\";s:3:\"374\";s:5:\"title\";s:15:\"Corporate About\";s:5:\"alias\";s:15:\"Corporate-About\";s:3:\"zip\";s:25:\"packs/Corporate-About.zip\";s:3:\"uid\";s:32:\"7bf5f8f6d4cc3016cea86289cb46e5b6\";s:3:\"img\";s:26:\"Corporate-About/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:350;a:25:{s:2:\"id\";s:3:\"375\";s:5:\"title\";s:19:\"Corporate Portfolio\";s:5:\"alias\";s:19:\"Corporate-Portfolio\";s:3:\"zip\";s:29:\"packs/Corporate-Portfolio.zip\";s:3:\"uid\";s:32:\"612c2bd784fea81392dda1644a3c3cf3\";s:3:\"img\";s:30:\"Corporate-Portfolio/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:351;a:25:{s:2:\"id\";s:3:\"376\";s:5:\"title\";s:15:\"Corporate Chart\";s:5:\"alias\";s:15:\"Corporate-Chart\";s:3:\"zip\";s:25:\"packs/Corporate-Chart.zip\";s:3:\"uid\";s:32:\"4d27d9b3b2cfcce750e526aafb322a9f\";s:3:\"img\";s:26:\"Corporate-Chart/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:352;a:25:{s:2:\"id\";s:3:\"377\";s:5:\"title\";s:14:\"Corporate News\";s:5:\"alias\";s:14:\"Corporate-News\";s:3:\"zip\";s:24:\"packs/Corporate-News.zip\";s:3:\"uid\";s:32:\"bb65ed57a0d4db795d8b738f0a92f2d7\";s:3:\"img\";s:25:\"Corporate-News/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:353;a:25:{s:2:\"id\";s:3:\"378\";s:5:\"title\";s:16:\"Corporate Hiring\";s:5:\"alias\";s:16:\"Corporate-Hiring\";s:3:\"zip\";s:26:\"packs/Corporate-Hiring.zip\";s:3:\"uid\";s:32:\"136cf1a91604e819089eb3573a6e100a\";s:3:\"img\";s:27:\"Corporate-Hiring/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:354;a:25:{s:2:\"id\";s:3:\"379\";s:5:\"title\";s:22:\"Corporate Testimonials\";s:5:\"alias\";s:22:\"Corporate-Testimonials\";s:3:\"zip\";s:32:\"packs/Corporate-Testimonials.zip\";s:3:\"uid\";s:32:\"b17aec0afdc31e37359cfa406164463c\";s:3:\"img\";s:33:\"Corporate-Testimonials/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:355;a:25:{s:2:\"id\";s:3:\"380\";s:5:\"title\";s:15:\"Corporate Store\";s:5:\"alias\";s:15:\"Corporate-Store\";s:3:\"zip\";s:25:\"packs/Corporate-Store.zip\";s:3:\"uid\";s:32:\"6240b14620ddc634736716e0cdfdeb31\";s:3:\"img\";s:26:\"Corporate-Store/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:356;a:25:{s:2:\"id\";s:3:\"381\";s:5:\"title\";s:17:\"Corporate Support\";s:5:\"alias\";s:17:\"Corporate-Support\";s:3:\"zip\";s:27:\"packs/Corporate-Support.zip\";s:3:\"uid\";s:32:\"9424292a78076ce68c2faf587b26cdad\";s:3:\"img\";s:28:\"Corporate-Support/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"10\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:357;a:25:{s:2:\"id\";s:3:\"382\";s:5:\"title\";s:14:\"Corporate Team\";s:5:\"alias\";s:14:\"Corporate-Team\";s:3:\"zip\";s:24:\"packs/Corporate-Team.zip\";s:3:\"uid\";s:32:\"4fafe469b5a0a2545625c3f6d7ff3b9e\";s:3:\"img\";s:25:\"Corporate-Team/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"11\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:358;a:25:{s:2:\"id\";s:3:\"383\";s:5:\"title\";s:33:\"Corporate Selected Projects Title\";s:5:\"alias\";s:33:\"Corporate-Selected-Projects-Title\";s:3:\"zip\";s:43:\"packs/Corporate-Selected-Projects-Title.zip\";s:3:\"uid\";s:32:\"0ed3c41f51e6bf404c2fe179fa8d8ceb\";s:3:\"img\";s:44:\"Corporate-Selected-Projects-Title/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"12\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:359;a:25:{s:2:\"id\";s:3:\"384\";s:5:\"title\";s:27:\"Corporate Selected Projects\";s:5:\"alias\";s:27:\"Corporate-Selected-Projects\";s:3:\"zip\";s:37:\"packs/Corporate-Selected-Projects.zip\";s:3:\"uid\";s:32:\"1096c78d5f007f3900228a4092515e2e\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"13\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:360;a:25:{s:2:\"id\";s:3:\"385\";s:5:\"title\";s:17:\"Corporate Clients\";s:5:\"alias\";s:17:\"Corporate-Clients\";s:3:\"zip\";s:27:\"packs/Corporate-Clients.zip\";s:3:\"uid\";s:32:\"60fe3a311195bf4dba3e50bd1ab98574\";s:3:\"img\";s:28:\"Corporate-Clients/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"14\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:361;a:25:{s:2:\"id\";s:3:\"386\";s:5:\"title\";s:20:\"Corporate Text Block\";s:5:\"alias\";s:20:\"Corporate-Text-Block\";s:3:\"zip\";s:30:\"packs/Corporate-Text-Block.zip\";s:3:\"uid\";s:32:\"93b68bb23d65fd1028b6b5f6d19b85b5\";s:3:\"img\";s:31:\"Corporate-Text-Block/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"15\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:362;a:25:{s:2:\"id\";s:3:\"387\";s:5:\"title\";s:20:\"Corporate Mobile App\";s:5:\"alias\";s:20:\"Corporate-Mobile-App\";s:3:\"zip\";s:30:\"packs/Corporate-Mobile-App.zip\";s:3:\"uid\";s:32:\"e592369d233bea673403daa15c6e498a\";s:3:\"img\";s:31:\"Corporate-Mobile-App/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"16\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:363;a:25:{s:2:\"id\";s:3:\"388\";s:5:\"title\";s:18:\"Corporate Contacts\";s:5:\"alias\";s:18:\"Corporate-Contacts\";s:3:\"zip\";s:28:\"packs/Corporate-Contacts.zip\";s:3:\"uid\";s:32:\"91ae9488b54b7020f8ae9dfbfd6c563a\";s:3:\"img\";s:29:\"Corporate-Contacts/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"17\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:364;a:25:{s:2:\"id\";s:3:\"389\";s:5:\"title\";s:16:\"Corporate Footer\";s:5:\"alias\";s:16:\"Corporate-Footer\";s:3:\"zip\";s:26:\"packs/Corporate-Footer.zip\";s:3:\"uid\";s:32:\"a01df90af203f06194c1a18745d79861\";s:3:\"img\";s:27:\"Corporate-Footer/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"18\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:365;a:25:{s:2:\"id\";s:3:\"390\";s:5:\"title\";s:23:\"Corporate Scroll To Top\";s:5:\"alias\";s:23:\"Corporate-Scroll-To-Top\";s:3:\"zip\";s:33:\"packs/Corporate-Scroll-To-Top.zip\";s:3:\"uid\";s:32:\"2d68f6e4590a9a445e6eb055dfee88ba\";s:3:\"img\";s:34:\"Corporate-Scroll-To-Top/slide1.jpg\";s:7:\"preview\";s:61:\"https://revolution.themepunch.com/corporate-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.1\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:248:\"<span class=\"ttm_content\">The Corporate Template is a collection of useful modules to construct your website. Portfolio, news, clients, team, contact, basic content, etc. There is something for everyone here!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:206:\"<span class=\"ttm_content\"></span>\r\n<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:17:\"Corporate Website\";s:13:\"package_order\";s:2:\"19\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"29\";s:9:\"installed\";b:0;}i:366;a:26:{s:2:\"id\";s:3:\"402\";s:5:\"title\";s:23:\"Brutal Website Template\";s:5:\"alias\";s:23:\"brutal-website-template\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:31:\"brutal-website-template-package\";s:3:\"img\";s:36:\"packages/brutal-website-template.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:367;a:26:{s:2:\"id\";s:3:\"403\";s:5:\"title\";s:11:\"Brutal Menu\";s:5:\"alias\";s:11:\"brutal-menu\";s:3:\"zip\";s:21:\"packs/brutal-menu.zip\";s:3:\"uid\";s:32:\"04b21c7aee2479793336e964230d6e3f\";s:3:\"img\";s:22:\"brutal-menu/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:368;a:26:{s:2:\"id\";s:3:\"404\";s:5:\"title\";s:11:\"Brutal Hero\";s:5:\"alias\";s:11:\"brutal-hero\";s:3:\"zip\";s:21:\"packs/brutal-hero.zip\";s:3:\"uid\";s:32:\"a342ad01054b97bac7980fdf9e275b34\";s:3:\"img\";s:22:\"brutal-hero/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:369;a:26:{s:2:\"id\";s:3:\"405\";s:5:\"title\";s:12:\"Brutal About\";s:5:\"alias\";s:12:\"brutal-about\";s:3:\"zip\";s:22:\"packs/brutal-about.zip\";s:3:\"uid\";s:32:\"a3e1cd2e36c9a783c1932fdafe2e4434\";s:3:\"img\";s:23:\"brutal-about/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:370;a:26:{s:2:\"id\";s:3:\"406\";s:5:\"title\";s:16:\"Brutal Highlight\";s:5:\"alias\";s:16:\"brutal-highlight\";s:3:\"zip\";s:26:\"packs/brutal-highlight.zip\";s:3:\"uid\";s:32:\"b7f8522dcb4636467633bd3b14f4e3e9\";s:3:\"img\";s:27:\"brutal-highlight/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:371;a:26:{s:2:\"id\";s:3:\"407\";s:5:\"title\";s:15:\"Brutal Projects\";s:5:\"alias\";s:15:\"brutal-projects\";s:3:\"zip\";s:25:\"packs/brutal-projects.zip\";s:3:\"uid\";s:32:\"1a462e91373042193ca5d623dd8e8a47\";s:3:\"img\";s:26:\"brutal-projects/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:372;a:26:{s:2:\"id\";s:3:\"408\";s:5:\"title\";s:15:\"Brutal Services\";s:5:\"alias\";s:15:\"brutal-services\";s:3:\"zip\";s:25:\"packs/brutal-services.zip\";s:3:\"uid\";s:32:\"cbeeb1e7a5c2842b155fe13acb7c165d\";s:3:\"img\";s:26:\"brutal-services/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:373;a:26:{s:2:\"id\";s:3:\"409\";s:5:\"title\";s:14:\"Brutal Callout\";s:5:\"alias\";s:14:\"brutal-callout\";s:3:\"zip\";s:24:\"packs/brutal-callout.zip\";s:3:\"uid\";s:32:\"31b6dafdb2dfb548152653e60df5a3bc\";s:3:\"img\";s:25:\"brutal-callout/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:374;a:26:{s:2:\"id\";s:3:\"410\";s:5:\"title\";s:13:\"Brutal Footer\";s:5:\"alias\";s:13:\"brutal-footer\";s:3:\"zip\";s:23:\"packs/brutal-footer.zip\";s:3:\"uid\";s:32:\"07559f0c574e3dd95b2d40d72cbb01bc\";s:3:\"img\";s:24:\"brutal-footer/slide1.jpg\";s:7:\"preview\";s:58:\"https://revolution.themepunch.com/brutal-website-template/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:232:\"<span class=\"ttm_content\">The Brutal template is a one-pager with a unique design that sticks out. The project & services sliders with direction based transitions are particularly interesting.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Brutal Website Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"31\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:375;a:25:{s:2:\"id\";s:3:\"411\";s:5:\"title\";s:23:\"Church Website Template\";s:5:\"alias\";s:23:\"church-website-template\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:31:\"church-website-template-package\";s:3:\"img\";s:36:\"packages/church-website-template.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:376;a:25:{s:2:\"id\";s:3:\"412\";s:5:\"title\";s:13:\"Church Header\";s:5:\"alias\";s:13:\"Church-Header\";s:3:\"zip\";s:23:\"packs/Church-Header.zip\";s:3:\"uid\";s:32:\"c14289117e1e2b9ee716fb99146b2e03\";s:3:\"img\";s:24:\"Church-Header/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:377;a:25:{s:2:\"id\";s:3:\"413\";s:5:\"title\";s:22:\"Church Upcoming Events\";s:5:\"alias\";s:22:\"Church-Upcoming-Events\";s:3:\"zip\";s:32:\"packs/Church-Upcoming-Events.zip\";s:3:\"uid\";s:32:\"056a26efddae92973fee4ee5cfa75f10\";s:3:\"img\";s:33:\"Church-Upcoming-Events/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:378;a:25:{s:2:\"id\";s:3:\"414\";s:5:\"title\";s:12:\"Church About\";s:5:\"alias\";s:12:\"Church-About\";s:3:\"zip\";s:22:\"packs/Church-About.zip\";s:3:\"uid\";s:32:\"8ef133f3f669f06380334a83e27eedbb\";s:3:\"img\";s:23:\"Church-About/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:379;a:25:{s:2:\"id\";s:3:\"415\";s:5:\"title\";s:14:\"Church Pastors\";s:5:\"alias\";s:14:\"Church-Pastors\";s:3:\"zip\";s:24:\"packs/Church-Pastors.zip\";s:3:\"uid\";s:32:\"715edc0833a753b72350b8c974f86f94\";s:3:\"img\";s:25:\"Church-Pastors/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:380;a:25:{s:2:\"id\";s:3:\"416\";s:5:\"title\";s:20:\"Church Photo Gallery\";s:5:\"alias\";s:20:\"Church-Photo-Gallery\";s:3:\"zip\";s:30:\"packs/Church-Photo-Gallery.zip\";s:3:\"uid\";s:32:\"d94808a97149cd5d3b3354a28409ffd7\";s:3:\"img\";s:31:\"Church-Photo-Gallery/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:381;a:25:{s:2:\"id\";s:3:\"417\";s:5:\"title\";s:16:\"Church Community\";s:5:\"alias\";s:16:\"Church-Community\";s:3:\"zip\";s:26:\"packs/Church-Community.zip\";s:3:\"uid\";s:32:\"2244e6a6d7a691653eae2d70765130a7\";s:3:\"img\";s:27:\"Church-Community/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:382;a:25:{s:2:\"id\";s:3:\"418\";s:5:\"title\";s:13:\"Church Sermon\";s:5:\"alias\";s:13:\"Church-Sermon\";s:3:\"zip\";s:23:\"packs/Church-Sermon.zip\";s:3:\"uid\";s:32:\"8fedf983bd55fff0f7a16d9f0a7e5408\";s:3:\"img\";s:24:\"Church-Sermon/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:383;a:25:{s:2:\"id\";s:3:\"419\";s:5:\"title\";s:15:\"Church Contacts\";s:5:\"alias\";s:15:\"Church-Contacts\";s:3:\"zip\";s:25:\"packs/Church-Contacts.zip\";s:3:\"uid\";s:32:\"0b1a6968e75868548fd98e435625c090\";s:3:\"img\";s:26:\"Church-Contacts/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:384;a:25:{s:2:\"id\";s:3:\"420\";s:5:\"title\";s:13:\"Church Footer\";s:5:\"alias\";s:13:\"Church-Footer\";s:3:\"zip\";s:23:\"packs/Church-Footer.zip\";s:3:\"uid\";s:32:\"29756685d3dc49e42edada43e6393b7b\";s:3:\"img\";s:24:\"Church-Footer/slide1.jpg\";s:7:\"preview\";s:63:\"https://revolution.themepunch.com/church-website-template-dark/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:23:\"Church Website Template\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"32\";s:9:\"installed\";b:0;}i:385;a:25:{s:2:\"id\";s:3:\"421\";s:5:\"title\";s:29:\"Church Light Website Template\";s:5:\"alias\";s:29:\"church-light-website-template\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:37:\"church-light-website-template-package\";s:3:\"img\";s:42:\"packages/church-light-website-template.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:386;a:25:{s:2:\"id\";s:3:\"422\";s:5:\"title\";s:19:\"Church Light Header\";s:5:\"alias\";s:19:\"Church-Light-Header\";s:3:\"zip\";s:29:\"packs/Church-Light-Header.zip\";s:3:\"uid\";s:32:\"81c00f4b52cf55214de919e3f13121fc\";s:3:\"img\";s:30:\"Church-Light-Header/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:387;a:25:{s:2:\"id\";s:3:\"423\";s:5:\"title\";s:28:\"Church Light Upcoming Events\";s:5:\"alias\";s:28:\"Church-Light-Upcoming-Events\";s:3:\"zip\";s:38:\"packs/Church-Light-Upcoming-Events.zip\";s:3:\"uid\";s:32:\"963a49f4be0557ac5f3ee61d256f5bda\";s:3:\"img\";s:39:\"Church-Light-Upcoming-Events/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:388;a:25:{s:2:\"id\";s:3:\"424\";s:5:\"title\";s:18:\"Church Light About\";s:5:\"alias\";s:18:\"Church-Light-About\";s:3:\"zip\";s:28:\"packs/Church-Light-About.zip\";s:3:\"uid\";s:32:\"d46c8e8e6f80e6bfedb54f1cdc49e7e6\";s:3:\"img\";s:29:\"Church-Light-About/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:389;a:25:{s:2:\"id\";s:3:\"425\";s:5:\"title\";s:20:\"Church Light Pastors\";s:5:\"alias\";s:20:\"Church-Light-Pastors\";s:3:\"zip\";s:30:\"packs/Church-Light-Pastors.zip\";s:3:\"uid\";s:32:\"7cc3dec61556e2291d6f38c1ea5e983f\";s:3:\"img\";s:31:\"Church-Light-Pastors/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:390;a:25:{s:2:\"id\";s:3:\"426\";s:5:\"title\";s:26:\"Church Light Photo Gallery\";s:5:\"alias\";s:26:\"Church-Light-Photo-Gallery\";s:3:\"zip\";s:36:\"packs/Church-Light-Photo-Gallery.zip\";s:3:\"uid\";s:32:\"9e13100179b9b700b005693eeca57902\";s:3:\"img\";s:37:\"Church-Light-Photo-Gallery/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:391;a:25:{s:2:\"id\";s:3:\"427\";s:5:\"title\";s:22:\"Church Light Community\";s:5:\"alias\";s:22:\"Church-Light-Community\";s:3:\"zip\";s:32:\"packs/Church-Light-Community.zip\";s:3:\"uid\";s:32:\"14fcc0d43d899fd96116bdbc57c7c5ea\";s:3:\"img\";s:33:\"Church-Light-Community/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:392;a:25:{s:2:\"id\";s:3:\"428\";s:5:\"title\";s:19:\"Church Light Sermon\";s:5:\"alias\";s:19:\"Church-Light-Sermon\";s:3:\"zip\";s:29:\"packs/Church-Light-Sermon.zip\";s:3:\"uid\";s:32:\"fc30be7e703bc7b235665c36baa80e4e\";s:3:\"img\";s:30:\"Church-Light-Sermon/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:393;a:25:{s:2:\"id\";s:3:\"429\";s:5:\"title\";s:21:\"Church Light Contacts\";s:5:\"alias\";s:21:\"Church-Light-Contacts\";s:3:\"zip\";s:31:\"packs/Church-Light-Contacts.zip\";s:3:\"uid\";s:32:\"ed83d8fa63ecb59cf42656068ecf8d25\";s:3:\"img\";s:32:\"Church-Light-Contacts/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:394;a:25:{s:2:\"id\";s:3:\"430\";s:5:\"title\";s:19:\"Church Light Footer\";s:5:\"alias\";s:19:\"Church-Light-Footer\";s:3:\"zip\";s:29:\"packs/Church-Light-Footer.zip\";s:3:\"uid\";s:32:\"a168772865fd5dcf6229c9c6a49dff73\";s:3:\"img\";s:30:\"Church-Light-Footer/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/church-website-template-light/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.2\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:202:\"<span class=\"ttm_content\">The Church Website Template is a complete solution for the holy internet presence of your church. Available as a light and dark version.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Church Light Website Template\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"33\";s:9:\"installed\";b:0;}i:395;a:27:{s:2:\"id\";s:3:\"431\";s:5:\"title\";s:25:\"Rockable Website Template\";s:5:\"alias\";s:25:\"rockable-website-template\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:33:\"rockable-website-template-package\";s:3:\"img\";s:38:\"packages/rockable-website-template.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:396;a:27:{s:2:\"id\";s:3:\"432\";s:5:\"title\";s:13:\"Rockable Menu\";s:5:\"alias\";s:13:\"rockable-menu\";s:3:\"zip\";s:23:\"packs/rockable-menu.zip\";s:3:\"uid\";s:32:\"92d18f7ff38f22ff411a4ef4d9f54934\";s:3:\"img\";s:24:\"rockable-menu/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:397;a:27:{s:2:\"id\";s:3:\"433\";s:5:\"title\";s:13:\"Rockable Hero\";s:5:\"alias\";s:13:\"rockable-hero\";s:3:\"zip\";s:23:\"packs/rockable-hero.zip\";s:3:\"uid\";s:32:\"ba16b28d6bde95910cbce572bb251208\";s:3:\"img\";s:24:\"rockable-hero/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:398;a:27:{s:2:\"id\";s:3:\"434\";s:5:\"title\";s:15:\"Rockable Lineup\";s:5:\"alias\";s:15:\"rockable-lineup\";s:3:\"zip\";s:25:\"packs/rockable-lineup.zip\";s:3:\"uid\";s:32:\"6631980112805533a0d328c37e56adbd\";s:3:\"img\";s:26:\"rockable-lineup/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:399;a:27:{s:2:\"id\";s:3:\"435\";s:5:\"title\";s:17:\"Rockable Lineup 2\";s:5:\"alias\";s:17:\"rockable-lineup-2\";s:3:\"zip\";s:27:\"packs/rockable-lineup-2.zip\";s:3:\"uid\";s:32:\"98bc41d982dc478edabff4aa99461dbc\";s:3:\"img\";s:28:\"rockable-lineup-2/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:400;a:27:{s:2:\"id\";s:3:\"436\";s:5:\"title\";s:22:\"Rockable Gallery Title\";s:5:\"alias\";s:22:\"rockable-gallery-title\";s:3:\"zip\";s:32:\"packs/rockable-gallery-title.zip\";s:3:\"uid\";s:32:\"da43a76f5bc77aa6efe158b00ab7cf0d\";s:3:\"img\";s:33:\"rockable-gallery-title/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:401;a:27:{s:2:\"id\";s:3:\"437\";s:5:\"title\";s:16:\"Rockable Gallery\";s:5:\"alias\";s:16:\"rockable-gallery\";s:3:\"zip\";s:26:\"packs/rockable-gallery.zip\";s:3:\"uid\";s:32:\"c12a144d6860bcf24e91d5b980ac22f1\";s:3:\"img\";s:27:\"rockable-gallery/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:8:\"carousel\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:402;a:27:{s:2:\"id\";s:3:\"438\";s:5:\"title\";s:17:\"Rockable Sponsors\";s:5:\"alias\";s:17:\"rockable-sponsors\";s:3:\"zip\";s:27:\"packs/rockable-sponsors.zip\";s:3:\"uid\";s:32:\"1e40d4a810c23f8d5fe5cd5ca31ee20d\";s:3:\"img\";s:28:\"rockable-sponsors/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:403;a:27:{s:2:\"id\";s:3:\"439\";s:5:\"title\";s:15:\"Rockable Footer\";s:5:\"alias\";s:15:\"rockable-footer\";s:3:\"zip\";s:25:\"packs/rockable-footer.zip\";s:3:\"uid\";s:32:\"a4a9952d5e56fc14366155e8ebfa432a\";s:3:\"img\";s:26:\"rockable-footer/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:404;a:27:{s:2:\"id\";s:3:\"440\";s:5:\"title\";s:21:\"Rockable Detail Modal\";s:5:\"alias\";s:21:\"rockable-detail-modal\";s:3:\"zip\";s:31:\"packs/rockable-detail-modal.zip\";s:3:\"uid\";s:32:\"b51d918203ff7975a144a9f1be09f31b\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:405;a:27:{s:2:\"id\";s:3:\"441\";s:5:\"title\";s:23:\"Rockable Detail Modal 2\";s:5:\"alias\";s:23:\"rockable-detail-modal-2\";s:3:\"zip\";s:33:\"packs/rockable-detail-modal-2.zip\";s:3:\"uid\";s:32:\"dcf51ebb3d4a1dec94748a1e016c5ef7\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";s:7:\"preview\";s:60:\"https://revolution.themepunch.com/rockable-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">The Rockable Website Template can present your Festival or Concert oriented website in a unique one-pager.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:25:\"Rockable Website Template\";s:13:\"package_order\";s:2:\"10\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"34\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:407;a:23:{s:2:\"id\";s:3:\"443\";s:5:\"title\";s:16:\"Isometric Slider\";s:5:\"alias\";s:16:\"isometric-slider\";s:3:\"zip\";s:20:\"isometric-slider.zip\";s:3:\"uid\";s:32:\"fb06051fcf6649a44f2292044e414a36\";s:3:\"img\";s:27:\"isometric-slider/slide1.jpg\";s:7:\"preview\";s:51:\"https://revolution.themepunch.com/isometric-slider/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:154:\"<span class=\"ttm_content\">A colorful, isometric slider template with fully customizable colors and screen content.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;}i:408;a:25:{s:2:\"id\";s:3:\"444\";s:5:\"title\";s:26:\"Woo Commerce Slider Static\";s:5:\"alias\";s:26:\"woo-commerce-slider-static\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:26:\"woo-commerce-slider-static\";s:3:\"img\";s:39:\"packages/woo-commerce-slider-static.jpg\";s:7:\"preview\";s:54:\"https://revolution.themepunch.com/woo-commerce-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:178:\"<span class=\"ttm_content\">A uniquely animated Woo Commerce Slider template - this is the static version that doesn\'t use Woo Commerce data</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:26:\"Woo Commerce Slider Static\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"35\";s:9:\"installed\";b:0;}i:409;a:25:{s:2:\"id\";s:3:\"445\";s:5:\"title\";s:17:\"E-Commerce Slider\";s:5:\"alias\";s:17:\"E-Commerce-Slider\";s:3:\"zip\";s:27:\"packs/E-Commerce-Slider.zip\";s:3:\"uid\";s:32:\"1533cfd83c2ae122f23074e1ed77f256\";s:3:\"img\";s:28:\"E-Commerce-Slider/slide1.jpg\";s:7:\"preview\";s:54:\"https://revolution.themepunch.com/woo-commerce-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:178:\"<span class=\"ttm_content\">A uniquely animated Woo Commerce Slider template - this is the static version that doesn\'t use Woo Commerce data</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:26:\"Woo Commerce Slider Static\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"35\";s:9:\"installed\";b:0;}i:410;a:25:{s:2:\"id\";s:3:\"446\";s:5:\"title\";s:23:\"E-Commerce Slider Modal\";s:5:\"alias\";s:23:\"E-Commerce-Slider-Modal\";s:3:\"zip\";s:33:\"packs/E-Commerce-Slider-Modal.zip\";s:3:\"uid\";s:32:\"825e05c3967515b92a75da017c68a863\";s:3:\"img\";s:34:\"E-Commerce-Slider-Modal/slide1.jpg\";s:7:\"preview\";s:54:\"https://revolution.themepunch.com/woo-commerce-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:178:\"<span class=\"ttm_content\">A uniquely animated Woo Commerce Slider template - this is the static version that doesn\'t use Woo Commerce data</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:26:\"Woo Commerce Slider Static\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"35\";s:9:\"installed\";b:0;}i:411;a:22:{s:2:\"id\";s:3:\"447\";s:5:\"title\";s:27:\"Woo Commerce Slider Dynamic\";s:5:\"alias\";s:27:\"Woo-Commerce-Slider-Dynamic\";s:3:\"zip\";s:31:\"Woo-Commerce-Slider-Dynamic.zip\";s:3:\"uid\";s:32:\"b8e2c64f3739e552c563c48c59f20fe7\";s:3:\"img\";s:38:\"Woo-Commerce-Slider-Dynamic/slide1.jpg\";s:7:\"preview\";s:54:\"https://revolution.themepunch.com/woo-commerce-slider/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:172:\"<span class=\"ttm_content\">A uniquely animated Woo Commerce Slider template - this is the dynamic version that uses Woo Commerce data</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:412;a:25:{s:2:\"id\";s:3:\"448\";s:5:\"title\";s:31:\"Blooming Event Florist Template\";s:5:\"alias\";s:31:\"blooming-event-florist-template\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:39:\"blooming-event-florist-template-package\";s:3:\"img\";s:52:\"packages/blooming-event-florist-template-package.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:413;a:25:{s:2:\"id\";s:3:\"449\";s:5:\"title\";s:15:\"Blooming Header\";s:5:\"alias\";s:15:\"blooming-header\";s:3:\"zip\";s:25:\"packs/blooming-header.zip\";s:3:\"uid\";s:32:\"aa2ee34fd8ed018945ba64e6913810e4\";s:3:\"img\";s:26:\"blooming-header/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:414;a:25:{s:2:\"id\";s:3:\"450\";s:5:\"title\";s:14:\"Blooming About\";s:5:\"alias\";s:14:\"blooming-about\";s:3:\"zip\";s:24:\"packs/blooming-about.zip\";s:3:\"uid\";s:32:\"dd7095e46fab2eb475d00480fd17a6ec\";s:3:\"img\";s:25:\"blooming-about/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:415;a:25:{s:2:\"id\";s:3:\"451\";s:5:\"title\";s:18:\"Blooming Portfolio\";s:5:\"alias\";s:18:\"blooming-portfolio\";s:3:\"zip\";s:28:\"packs/blooming-portfolio.zip\";s:3:\"uid\";s:32:\"c72ddcbb07b62982b8c21328a6383e22\";s:3:\"img\";s:29:\"blooming-portfolio/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:416;a:25:{s:2:\"id\";s:3:\"452\";s:5:\"title\";s:22:\"Blooming Wedding Title\";s:5:\"alias\";s:22:\"blooming-wedding-title\";s:3:\"zip\";s:32:\"packs/blooming-wedding-title.zip\";s:3:\"uid\";s:32:\"4fcfb0b99289c12d014c67306bb7687b\";s:3:\"img\";s:33:\"blooming-wedding-title/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:417;a:25:{s:2:\"id\";s:3:\"453\";s:5:\"title\";s:25:\"Blooming Wedding Carousel\";s:5:\"alias\";s:25:\"blooming-wedding-carousel\";s:3:\"zip\";s:35:\"packs/blooming-wedding-carousel.zip\";s:3:\"uid\";s:32:\"1d1bb979dbfca8ba9d43da1c0f665339\";s:3:\"img\";s:36:\"blooming-wedding-carousel/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:8:\"carousel\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:418;a:25:{s:2:\"id\";s:3:\"454\";s:5:\"title\";s:21:\"Blooming Wedding Text\";s:5:\"alias\";s:21:\"blooming-wedding-text\";s:3:\"zip\";s:31:\"packs/blooming-wedding-text.zip\";s:3:\"uid\";s:32:\"326f2793294a739dd3aac3cc45332df8\";s:3:\"img\";s:32:\"blooming-wedding-text/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:419;a:25:{s:2:\"id\";s:3:\"455\";s:5:\"title\";s:22:\"Blooming Parties Title\";s:5:\"alias\";s:22:\"blooming-parties-title\";s:3:\"zip\";s:32:\"packs/blooming-parties-title.zip\";s:3:\"uid\";s:32:\"b47aae1b368d3c3d9017f260e6c6a547\";s:3:\"img\";s:33:\"blooming-parties-title/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:420;a:25:{s:2:\"id\";s:3:\"456\";s:5:\"title\";s:25:\"Blooming Parties Carousel\";s:5:\"alias\";s:25:\"blooming-parties-carousel\";s:3:\"zip\";s:35:\"packs/blooming-parties-carousel.zip\";s:3:\"uid\";s:32:\"9f90a9da7b017aeee7f3b608cda066e6\";s:3:\"img\";s:36:\"blooming-parties-carousel/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:8:\"carousel\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:421;a:25:{s:2:\"id\";s:3:\"457\";s:5:\"title\";s:21:\"Blooming Parties Text\";s:5:\"alias\";s:21:\"blooming-parties-text\";s:3:\"zip\";s:31:\"packs/blooming-parties-text.zip\";s:3:\"uid\";s:32:\"66a47346cc639b8b9b9b5dfa1521b6ef\";s:3:\"img\";s:32:\"blooming-parties-text/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:422;a:25:{s:2:\"id\";s:3:\"458\";s:5:\"title\";s:22:\"Blooming Funeral Title\";s:5:\"alias\";s:22:\"blooming-funeral-title\";s:3:\"zip\";s:32:\"packs/blooming-funeral-title.zip\";s:3:\"uid\";s:32:\"e9e77134472c33c56be442073f29d1fd\";s:3:\"img\";s:33:\"blooming-funeral-title/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:2:\"10\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:423;a:25:{s:2:\"id\";s:3:\"459\";s:5:\"title\";s:23:\"Blooming Funeral Slider\";s:5:\"alias\";s:23:\"blooming-funeral-slider\";s:3:\"zip\";s:33:\"packs/blooming-funeral-slider.zip\";s:3:\"uid\";s:32:\"d15090841c25c7c8f0e1b0987c0c0887\";s:3:\"img\";s:34:\"blooming-funeral-slider/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:2:\"11\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:424;a:25:{s:2:\"id\";s:3:\"460\";s:5:\"title\";s:21:\"Blooming Funeral Text\";s:5:\"alias\";s:21:\"blooming-funeral-text\";s:3:\"zip\";s:31:\"packs/blooming-funeral-text.zip\";s:3:\"uid\";s:32:\"d7c80e246f31e3d2f4e5dc1656f133cc\";s:3:\"img\";s:32:\"blooming-funeral-text/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:2:\"12\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:425;a:25:{s:2:\"id\";s:3:\"461\";s:5:\"title\";s:16:\"Blooming Contact\";s:5:\"alias\";s:16:\"blooming-contact\";s:3:\"zip\";s:26:\"packs/blooming-contact.zip\";s:3:\"uid\";s:32:\"54280182bca86443e2648b3146f41e47\";s:3:\"img\";s:27:\"blooming-contact/slide1.jpg\";s:7:\"preview\";s:57:\"https://revolution.themepunch.com/event-florist-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:175:\"<span class=\"ttm_content\">The Blooming Event Florist Template is a complete one-page website solution with beautiful floral animations.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:31:\"Blooming Event Florist Template\";s:13:\"package_order\";s:2:\"13\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"36\";s:9:\"installed\";b:0;}i:426;a:22:{s:2:\"id\";s:3:\"462\";s:5:\"title\";s:13:\"Particle Hero\";s:5:\"alias\";s:13:\"particle-hero\";s:3:\"zip\";s:17:\"particle-hero.zip\";s:3:\"uid\";s:32:\"3f422f4807bf9ef4cb15dade515dad00\";s:3:\"img\";s:24:\"particle-hero/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/wordpress-hero-image-header/#slide6\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:120:\"<span class=\"ttm_content\">A Hero header module using the Particle Effect Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:427;a:22:{s:2:\"id\";s:3:\"463\";s:5:\"title\";s:17:\"Bubble Morph Hero\";s:5:\"alias\";s:17:\"bubble-morph-hero\";s:3:\"zip\";s:21:\"bubble-morph-hero.zip\";s:3:\"uid\";s:32:\"b47e6bcc1ae80393ff3f7388ed3b9f8f\";s:3:\"img\";s:28:\"bubble-morph-hero/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/wordpress-hero-image-header/#slide5\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:117:\"<span class=\"ttm_content\">A Hero header module using the Bubble Morph Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:174:\"[{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:428;a:22:{s:2:\"id\";s:3:\"464\";s:5:\"title\";s:13:\"Parallax Hero\";s:5:\"alias\";s:13:\"parallax-hero\";s:3:\"zip\";s:17:\"parallax-hero.zip\";s:3:\"uid\";s:32:\"290e86534326ee118e96ae7ce0538fa2\";s:3:\"img\";s:24:\"parallax-hero/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/wordpress-hero-image-header/#slide4\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:117:\"<span class=\"ttm_content\">A parallax hero module with mouse move interaction.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:429;a:22:{s:2:\"id\";s:3:\"465\";s:5:\"title\";s:10:\"Video Hero\";s:5:\"alias\";s:10:\"video-hero\";s:3:\"zip\";s:14:\"video-hero.zip\";s:3:\"uid\";s:32:\"f9e280015d3408bb0482e13fe753da8f\";s:3:\"img\";s:21:\"video-hero/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/wordpress-hero-image-header/#slide3\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:111:\"<span class=\"ttm_content\">A simple Hero header module with HTML5 video.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:430;a:22:{s:2:\"id\";s:3:\"466\";s:5:\"title\";s:14:\"Ken Burns Hero\";s:5:\"alias\";s:14:\"ken-burns-hero\";s:3:\"zip\";s:18:\"ken-burns-hero.zip\";s:3:\"uid\";s:32:\"d5f89e5f5b3991b995e2bfeb50cfe9f8\";s:3:\"img\";s:25:\"ken-burns-hero/slide1.jpg\";s:7:\"preview\";s:69:\"https://revolution.themepunch.com/wordpress-hero-image-header/#slide2\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:142:\"<span class=\"ttm_content\">A simple image background hero header module with a subtle Ken Burns effect.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:431;a:22:{s:2:\"id\";s:3:\"467\";s:5:\"title\";s:21:\"Basic Hero Collection\";s:5:\"alias\";s:21:\"basic-hero-collection\";s:3:\"zip\";s:25:\"basic-hero-collection.zip\";s:3:\"uid\";s:32:\"ff625c65e8aab4689fa56d5652279d51\";s:3:\"img\";s:32:\"basic-hero-collection/slide1.jpg\";s:7:\"preview\";s:62:\"https://revolution.themepunch.com/wordpress-hero-image-header/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.5\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:153:\"<span class=\"ttm_content\">A collection of WordPress Hero Headers with image, video, particles, parallax and more!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";s:348:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"},{\"path\":\"revslider-bubblemorph-addon\\/revslider-bubblemorph-addon.php\",\"name\":\"BubbleMorph AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:432;a:22:{s:2:\"id\";s:3:\"468\";s:5:\"title\";s:19:\"Launching Very Soon\";s:5:\"alias\";s:19:\"launching-very-soon\";s:3:\"zip\";s:23:\"launching-very-soon.zip\";s:3:\"uid\";s:32:\"2da45cf2d9bec07e7183b3f7777986b9\";s:3:\"img\";s:30:\"launching-very-soon/slide1.jpg\";s:7:\"preview\";s:59:\"https://revolution.themepunch.com/launching-soon-countdown/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:166:\"<span class=\"ttm_content\">Rocket BOOST! A beautifully animated launching soon countdown module using our \"Coming Soon\" Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:197:\"[{\"path\":\"revslider-maintenance-addon\\/revslider-maintenance-addon.php\",\"name\":\"Coming Soon & Maintenance AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/revslider-doc\\/add-coming-soon-maintenance\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:433;a:22:{s:2:\"id\";s:3:\"469\";s:5:\"title\";s:18:\"Under Construction\";s:5:\"alias\";s:18:\"Under-Construction\";s:3:\"zip\";s:22:\"Under-Construction.zip\";s:3:\"uid\";s:32:\"4b12f9a82a5b48d45a707df93406eb5b\";s:3:\"img\";s:29:\"Under-Construction/slide1.jpg\";s:7:\"preview\";s:53:\"https://revolution.themepunch.com/under-construction/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:157:\"<span class=\"ttm_content\">You will love this animated under construction landing page using our \"Coming Soon\" Add-On.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:197:\"[{\"path\":\"revslider-maintenance-addon\\/revslider-maintenance-addon.php\",\"name\":\"Coming Soon & Maintenance AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/revslider-doc\\/add-coming-soon-maintenance\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:434;a:22:{s:2:\"id\";s:3:\"470\";s:5:\"title\";s:15:\"Particle Effect\";s:5:\"alias\";s:15:\"Particle-Effect\";s:3:\"zip\";s:19:\"Particle-Effect.zip\";s:3:\"uid\";s:32:\"66cf4e514e83a6984903694fd587edb6\";s:3:\"img\";s:26:\"Particle-Effect/slide1.jpg\";s:7:\"preview\";s:54:\"https://revolution.themepunch.com/snow-particle-scene/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:140:\"<span class=\"ttm_content\">Get into a winter mood with our Snow Particle Scene for Slider Revolution!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:435;a:22:{s:2:\"id\";s:3:\"471\";s:5:\"title\";s:17:\"Particle Effect 2\";s:5:\"alias\";s:17:\"Particle-Effect-2\";s:3:\"zip\";s:21:\"Particle-Effect-2.zip\";s:3:\"uid\";s:32:\"303337c29a97a816ccecca7e5f0b5e20\";s:3:\"img\";s:28:\"Particle-Effect-2/slide1.jpg\";s:7:\"preview\";s:56:\"https://revolution.themepunch.com/cyber-particle-effect/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:147:\"<span class=\"ttm_content\">Amaze your website visitors with the cyber particle effect for Slider Revolution!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:4:\"hero\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:436;a:25:{s:2:\"id\";s:3:\"472\";s:5:\"title\";s:22:\"Stark Website Template\";s:5:\"alias\";s:22:\"stark-website-template\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:30:\"stark-website-template-package\";s:3:\"img\";s:43:\"packages/stark-website-template-package.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:437;a:25:{s:2:\"id\";s:3:\"473\";s:5:\"title\";s:10:\"Stark Menu\";s:5:\"alias\";s:10:\"stark-menu\";s:3:\"zip\";s:20:\"packs/stark-menu.zip\";s:3:\"uid\";s:32:\"bb31150df180e784d76a1f5ea306bf05\";s:3:\"img\";s:21:\"stark-menu/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:87:\"offset=\"t:0px,0px,0px,0px;b:0px,0px,0px,0px;l:140px,70px,0px,0px;r:140px,70px,0px,0px;\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:438;a:25:{s:2:\"id\";s:3:\"474\";s:5:\"title\";s:12:\"Stark Header\";s:5:\"alias\";s:12:\"stark-header\";s:3:\"zip\";s:22:\"packs/stark-header.zip\";s:3:\"uid\";s:32:\"62bfca01bf6e33cfad81d8df06498299\";s:3:\"img\";s:23:\"stark-header/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:93:\"offset=\"t:40px,30px,20px,10px;b:0px,0px,0px,0px;l:40px,30px,20px,10px;r:40px,30px,20px,10px;\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:439;a:25:{s:2:\"id\";s:3:\"475\";s:5:\"title\";s:13:\"Stark Content\";s:5:\"alias\";s:13:\"stark-content\";s:3:\"zip\";s:23:\"packs/stark-content.zip\";s:3:\"uid\";s:32:\"4577ca760133eb5d894c46f212f6eefb\";s:3:\"img\";s:24:\"stark-content/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:110:\"offset=\"t:-50px,-30px,-30px,-20px;b:0px,0px,0px,0px;l:140px,70px,50px,30px;r:140px,70px,50px,30px;\" zindex=\"6\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:440;a:25:{s:2:\"id\";s:3:\"476\";s:5:\"title\";s:14:\"Stark Carousel\";s:5:\"alias\";s:14:\"stark-carousel\";s:3:\"zip\";s:24:\"packs/stark-carousel.zip\";s:3:\"uid\";s:32:\"de63336d333eeff10eccfd5d9741e6c9\";s:3:\"img\";s:25:\"stark-carousel/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:108:\"offset=\"t:-50px,-30px,-30px,-20px;b:0px,0px,0px,0px;l:40px,30px,20px,10px;r:40px,30px,20px,10px;\" zindex=\"1\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:441;a:25:{s:2:\"id\";s:3:\"477\";s:5:\"title\";s:15:\"Stark Portfolio\";s:5:\"alias\";s:15:\"stark-portfolio\";s:3:\"zip\";s:25:\"packs/stark-portfolio.zip\";s:3:\"uid\";s:32:\"99fcf3df65f8471fe30bec1bf0c2350d\";s:3:\"img\";s:26:\"stark-portfolio/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:110:\"offset=\"t:-50px,-30px,-30px,-20px;b:0px,0px,0px,0px;l:140px,70px,50px,30px;r:140px,70px,50px,30px;\" zindex=\"5\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:442;a:25:{s:2:\"id\";s:3:\"478\";s:5:\"title\";s:22:\"Stark Portfolio Detail\";s:5:\"alias\";s:22:\"stark-portfolio-detail\";s:3:\"zip\";s:32:\"packs/stark-portfolio-detail.zip\";s:3:\"uid\";s:32:\"7484fc54f81daec07c93e992216310ce\";s:3:\"img\";s:33:\"stark-portfolio-detail/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:6:\"slider\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:443;a:25:{s:2:\"id\";s:3:\"479\";s:5:\"title\";s:13:\"Stark Contact\";s:5:\"alias\";s:13:\"stark-contact\";s:3:\"zip\";s:23:\"packs/stark-contact.zip\";s:3:\"uid\";s:32:\"8d704226b7093123a9d9faf424da6c35\";s:3:\"img\";s:24:\"stark-contact/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:108:\"offset=\"t:-50px,-30px,-30px,-20px;b:0px,0px,0px,0px;l:40px,30px,20px,10px;r:40px,30px,20px,10px;\" zindex=\"2\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:444;a:25:{s:2:\"id\";s:3:\"480\";s:5:\"title\";s:12:\"Stark Footer\";s:5:\"alias\";s:12:\"stark-footer\";s:3:\"zip\";s:22:\"packs/stark-footer.zip\";s:3:\"uid\";s:32:\"e7132dc158e7dcdb4ef5b3a1aa00208a\";s:3:\"img\";s:23:\"stark-footer/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:114:\"offset=\"t:-50px,-30px,-30px,-20px;b:40px,30px,20px,20px;l:140px,70px,50px,30px;r:140px,70px,50px,30px;\" zindex=\"3\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:445;a:25:{s:2:\"id\";s:3:\"481\";s:5:\"title\";s:16:\"Stark Newsletter\";s:5:\"alias\";s:16:\"stark-newsletter\";s:3:\"zip\";s:26:\"packs/stark-newsletter.zip\";s:3:\"uid\";s:32:\"bb76ddd68dbe6bda5ece7e4227a51413\";s:3:\"img\";s:27:\"stark-newsletter/slide1.jpg\";s:7:\"preview\";s:64:\"https://revolution.themepunch.com/stark-agency-website-template/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:221:\"<span class=\"ttm_content\">The Stark Agency website template is a collection of modules using our new Gutenberg Block \"margin & padding\" feature. Create unique, customizable layouts!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:22:\"Stark Website Template\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"1\";s:9:\"additions\";s:33:\"usage=\"modal\" modal=\"s:#contact;\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"37\";s:9:\"installed\";b:0;}i:446;a:22:{s:2:\"id\";s:3:\"482\";s:5:\"title\";s:15:\"Big Summer Sale\";s:5:\"alias\";s:15:\"big-summer-sale\";s:3:\"zip\";s:19:\"big-summer-sale.zip\";s:3:\"uid\";s:32:\"a6779fa7109763209d234f9cf2e766c6\";s:3:\"img\";s:26:\"big-summer-sale/slide1.jpg\";s:7:\"preview\";s:62:\"https://revolution.themepunch.com/big-summer-sale-shop-slider/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:153:\"<span class=\"ttm_content\">The Big Summer Sale Shop Slider is a beautiful eye catcher for your e-commerce website!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:447;a:22:{s:2:\"id\";s:3:\"483\";s:5:\"title\";s:18:\"Traveller Carousel\";s:5:\"alias\";s:18:\"traveller-carousel\";s:3:\"zip\";s:22:\"traveller-carousel.zip\";s:3:\"uid\";s:32:\"185344ed6236bea2906a79035d1d5702\";s:3:\"img\";s:29:\"traveller-carousel/slide1.jpg\";s:7:\"preview\";s:55:\"https://revolution.themepunch.com/travel-blog-carousel/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:137:\"<span class=\"ttm_content\">A travel blog carousel with interesting parallax and ken burns effects!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:263:\"<span class=\"ttm_content\">Note that the content visible on all slides can be edited on the \"global layers\" slide.<br/>Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";s:175:\"[{\"path\":\"revslider-particles-addon\\/revslider-particles-addon.php\",\"name\":\"Particles Effect AddOn\",\"url\":\"https:\\/\\/www.themepunch.com\\/slider-revolution\\/install-addons\\/\"}]\";s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:448;a:22:{s:2:\"id\";s:3:\"484\";s:5:\"title\";s:16:\"Project Carousel\";s:5:\"alias\";s:16:\"project-carousel\";s:3:\"zip\";s:20:\"project-carousel.zip\";s:3:\"uid\";s:32:\"49c85ad406da943bdd25f08fd6496748\";s:3:\"img\";s:27:\"project-carousel/slide1.jpg\";s:7:\"preview\";s:51:\"https://revolution.themepunch.com/project-carousel/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:137:\"<span class=\"ttm_content\">A project carousel with images and texts that can be customized easily!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:449;a:22:{s:2:\"id\";s:3:\"485\";s:5:\"title\";s:13:\"News Carousel\";s:5:\"alias\";s:13:\"news-carousel\";s:3:\"zip\";s:17:\"news-carousel.zip\";s:3:\"uid\";s:32:\"76f5b939150092a30038f161084140ae\";s:3:\"img\";s:24:\"news-carousel/slide1.jpg\";s:7:\"preview\";s:48:\"https://revolution.themepunch.com/news-carousel/\";s:7:\"version\";s:5:\"1.0.0\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:134:\"<span class=\"ttm_content\">A news carousel with images and texts that can be customized easily!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:8:\"carousel\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}i:450;a:27:{s:2:\"id\";s:3:\"486\";s:5:\"title\";s:29:\"Story Blocks Website Template\";s:5:\"alias\";s:29:\"story-blocks-website-template\";s:3:\"zip\";s:0:\"\";s:3:\"uid\";s:37:\"story-blocks-website-template-package\";s:3:\"img\";s:50:\"packages/story-blocks-website-template-package.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"0\";s:14:\"package_parent\";s:4:\"true\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:451;a:27:{s:2:\"id\";s:3:\"487\";s:5:\"title\";s:10:\"Story Menu\";s:5:\"alias\";s:10:\"story-menu\";s:3:\"zip\";s:20:\"packs/story-menu.zip\";s:3:\"uid\";s:32:\"1f2f7cd91480f15cff8e7100f788c650\";s:3:\"img\";s:21:\"story-menu/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"1\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:452;a:27:{s:2:\"id\";s:3:\"488\";s:5:\"title\";s:12:\"Story Header\";s:5:\"alias\";s:12:\"story-header\";s:3:\"zip\";s:22:\"packs/story-header.zip\";s:3:\"uid\";s:32:\"e1a5ad5018a24ccdc71c2863edfe775e\";s:3:\"img\";s:23:\"story-header/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"2\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:453;a:27:{s:2:\"id\";s:3:\"489\";s:5:\"title\";s:13:\"Story Block 1\";s:5:\"alias\";s:13:\"story-block-1\";s:3:\"zip\";s:23:\"packs/story-block-1.zip\";s:3:\"uid\";s:32:\"2a9fee97dcf477e36d048af8a902f47a\";s:3:\"img\";s:24:\"story-block-1/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"3\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:454;a:27:{s:2:\"id\";s:3:\"490\";s:5:\"title\";s:15:\"Story Content 1\";s:5:\"alias\";s:15:\"story-content-1\";s:3:\"zip\";s:25:\"packs/story-content-1.zip\";s:3:\"uid\";s:32:\"6773614bbce543b83a0d2b2ad8facc96\";s:3:\"img\";s:26:\"story-content-1/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"4\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:455;a:27:{s:2:\"id\";s:3:\"491\";s:5:\"title\";s:13:\"Story Block 2\";s:5:\"alias\";s:13:\"story-block-2\";s:3:\"zip\";s:23:\"packs/story-block-2.zip\";s:3:\"uid\";s:32:\"2e708e3cebab57ca20b228ffba426ce7\";s:3:\"img\";s:24:\"story-block-2/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"5\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:456;a:27:{s:2:\"id\";s:3:\"492\";s:5:\"title\";s:13:\"Story Block 3\";s:5:\"alias\";s:13:\"story-block-3\";s:3:\"zip\";s:23:\"packs/story-block-3.zip\";s:3:\"uid\";s:32:\"7156cf069f65644faf90122dab451231\";s:3:\"img\";s:24:\"story-block-3/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"6\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:457;a:27:{s:2:\"id\";s:3:\"493\";s:5:\"title\";s:15:\"Story Content 2\";s:5:\"alias\";s:15:\"story-content-2\";s:3:\"zip\";s:25:\"packs/story-content-2.zip\";s:3:\"uid\";s:32:\"1223cd77d1f36d69e69ce50223e16ea7\";s:3:\"img\";s:26:\"story-content-2/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"7\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:458;a:27:{s:2:\"id\";s:3:\"494\";s:5:\"title\";s:13:\"Story Block 4\";s:5:\"alias\";s:13:\"story-block-4\";s:3:\"zip\";s:23:\"packs/story-block-4.zip\";s:3:\"uid\";s:32:\"85ac48e8e8231d2c38206cba4e7ebb68\";s:3:\"img\";s:24:\"story-block-4/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"8\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:459;a:27:{s:2:\"id\";s:3:\"495\";s:5:\"title\";s:15:\"Story Content 3\";s:5:\"alias\";s:15:\"story-content-3\";s:3:\"zip\";s:25:\"packs/story-content-3.zip\";s:3:\"uid\";s:32:\"82cac52f3ba79c0559fe0ad0cdf9d3b2\";s:3:\"img\";s:26:\"story-content-3/slide1.jpg\";s:7:\"preview\";s:47:\"https://revolution.themepunch.com/story-blocks/\";s:7:\"version\";s:5:\"1.0.1\";s:8:\"required\";s:5:\"6.1.6\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:229:\"<span class=\"ttm_content\">The Story Blocks for Slider Revolution can be used to create scroll-based stories on your WordPress site. Mix and match the individual blocks to create YOUR story!</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:2:{i:0;s:4:\"hero\";i:1;s:7:\"website\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:7:\"package\";s:29:\"Story Blocks Website Template\";s:13:\"package_order\";s:1:\"9\";s:14:\"package_parent\";s:0:\"\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:10:\"package_id\";s:2:\"38\";s:9:\"installed\";b:0;s:6:\"is_new\";b:1;s:10:\"push_image\";b:1;}i:460;a:22:{s:2:\"id\";s:3:\"442\";s:5:\"title\";s:27:\"Real Estate Showcase Slider\";s:5:\"alias\";s:27:\"real-estate-showcase-slider\";s:3:\"zip\";s:31:\"Real-Estate-Showcase-Slider.zip\";s:3:\"uid\";s:32:\"486b2bbe296722e70421731e3c05711b\";s:3:\"img\";s:38:\"Real-Estate-Showcase-Slider/slide1.jpg\";s:7:\"preview\";s:62:\"https://revolution.themepunch.com/real-estate-showcase-slider/\";s:7:\"version\";s:5:\"1.0.2\";s:8:\"required\";s:5:\"6.1.3\";s:5:\"width\";s:4:\"1240\";s:6:\"height\";s:3:\"868\";s:11:\"description\";s:152:\"<span class=\"ttm_content\">An elegant showcase for your real estate & realtor website. Flexible and customizable.</span>\r\n<span class=\"ttm_space\"></span>\";s:11:\"setup_notes\";s:171:\"<span class=\"ttm_content\">Checkout our <a href=\"https://revolution.themepunch.com/documentation\" target=\"_blank\">Documentation</a> for basic Slider Revolution help.</span>\";s:3:\"cat\";s:7:\"Premium\";s:6:\"filter\";a:1:{i:0;s:6:\"slider\";}s:14:\"plugin_require\";N;s:4:\"date\";s:19:\"0000-00-00 00:00:00\";s:13:\"package_order\";s:1:\"0\";s:5:\"modal\";s:1:\"0\";s:9:\"additions\";s:0:\"\";s:6:\"active\";s:1:\"1\";s:9:\"installed\";b:0;}}s:6:\"slides\";a:448:{s:16:\"classic-carousel\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"classic-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"classic-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"classic-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:27:\"classic-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:27:\"classic-carousel/slide5.jpg\";}}s:13:\"classicslider\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"classicslider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"classicslider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"classicslider/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:24:\"classicslider/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:24:\"classicslider/slide5.jpg\";}}s:11:\"contenttabs\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"contenttabs/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"contenttabs/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"contenttabs/slide3.jpg\";}}s:13:\"facebook-feed\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"facebook-feed/slide1.jpg\";}}s:7:\"fashion\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:18:\"fashion/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:18:\"fashion/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:18:\"fashion/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:18:\"fashion/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:18:\"fashion/slide5.jpg\";}}s:14:\"flickr-gallery\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"flickr-gallery/slide1.jpg\";}}s:3:\"gym\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:14:\"gym/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:14:\"gym/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:14:\"gym/slide3.jpg\";}}s:18:\"highlight-carousel\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"highlight-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"highlight-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"highlight-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:29:\"highlight-carousel/slide4.jpg\";}}s:18:\"highlight-showcase\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"highlight-showcase/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"highlight-showcase/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"highlight-showcase/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:29:\"highlight-showcase/slide4.jpg\";}}s:10:\"image-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"imagehero/slide1.jpg\";}}s:13:\"insta-gallery\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"insta-gallery/slide1.jpg\";}}s:19:\"levanorestaurantbar\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"levanorestaurantbar/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:30:\"levanorestaurantbar/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:30:\"levanorestaurantbar/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:30:\"levanorestaurantbar/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:30:\"levanorestaurantbar/slide5.jpg\";}}s:11:\"mainfeature\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"mainfeature/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"mainfeature/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"mainfeature/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:22:\"mainfeature/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:22:\"mainfeature/slide7.jpg\";}}s:17:\"media-gallery-two\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"media-gallery-two/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"media-gallery-two/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"media-gallery-two/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:28:\"media-gallery-two/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:28:\"media-gallery-two/slide6.jpg\";}}s:23:\"media-carousel-autoplay\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"media-carousel-autoplay/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:34:\"media-carousel-autoplay/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:34:\"media-carousel-autoplay/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:34:\"media-carousel-autoplay/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:34:\"media-carousel-autoplay/slide6.jpg\";}}s:21:\"news-background-video\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"news-bg-video/slide1.jpg\";}}s:12:\"news-gallery\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"news-gallery/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:23:\"news-gallery/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:23:\"news-gallery/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:23:\"news-gallery/slide4.jpg\";}}s:23:\"news-gallery-post-based\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"news-gallery-post-based/slide1.jpg\";}}s:9:\"news-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"news-hero/slide1.jpg\";}}s:10:\"news-video\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"news-video/slide1.jpg\";}}s:15:\"newsletter-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"newsletter-hero/slide1.jpg\";}}s:10:\"notgeneric\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"notgeneric/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:21:\"notgeneric/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:21:\"notgeneric/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:21:\"notgeneric/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:21:\"notgeneric/slide5.jpg\";}}s:11:\"photography\";a:10:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"photography/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"photography/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"photography/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:22:\"photography/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:22:\"photography/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:22:\"photography/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:22:\"photography/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:22:\"photography/slide8.jpg\";}i:8;a:2:{s:5:\"title\";s:7:\"Slide 9\";s:3:\"img\";s:22:\"photography/slide9.jpg\";}i:9;a:2:{s:5:\"title\";s:8:\"Slide 10\";s:3:\"img\";s:23:\"photography/slide10.jpg\";}}s:20:\"photography-carousel\";a:10:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"photography-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:31:\"photography-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:31:\"photography-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:31:\"photography-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:31:\"photography-carousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:31:\"photography-carousel/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:31:\"photography-carousel/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:31:\"photography-carousel/slide8.jpg\";}i:8;a:2:{s:5:\"title\";s:7:\"Slide 9\";s:3:\"img\";s:31:\"photography-carousel/slide9.jpg\";}i:9;a:2:{s:5:\"title\";s:8:\"Slide 10\";s:3:\"img\";s:32:\"photography-carousel/slide10.jpg\";}}s:16:\"search-form-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"search-form-hero/slide1.jpg\";}}s:16:\"showcasecarousel\";a:9:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"showcasecarousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"showcasecarousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"showcasecarousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:27:\"showcasecarousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:27:\"showcasecarousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:27:\"showcasecarousel/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:27:\"showcasecarousel/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:27:\"showcasecarousel/slide8.jpg\";}i:8;a:2:{s:5:\"title\";s:7:\"Slide 9\";s:3:\"img\";s:27:\"showcasecarousel/slide9.jpg\";}}s:11:\"sports-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"sportshero/slide1.jpg\";}}s:12:\"twitter-feed\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"twitter-feed/slide1.jpg\";}}s:13:\"vimeo-gallery\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"vimeo-gallery/slide1.jpg\";}}s:9:\"vimeohero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"vimeohero/slide1.jpg\";}}s:16:\"web-product-dark\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"web-product-dark/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"web-product-dark/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"web-product-dark/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:27:\"web-product-dark/slide4.jpg\";}}s:21:\"web-product-dark-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"web-product-dark-hero/slide1.jpg\";}}s:22:\"web-product-light-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"web-product-light-hero/slide1.jpg\";}}s:15:\"webproductlight\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"webproductlight/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"webproductlight/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"webproductlight/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"webproductlight/slide4.jpg\";}}s:15:\"youtube-gallery\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"youtube-gallery/slide1.jpg\";}}s:11:\"youtubehero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"youtubehero/slide1.jpg\";}}s:13:\"scroll-effect\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"scrolleffect/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:23:\"scrolleffect/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:23:\"scrolleffect/slide3.jpg\";}}s:12:\"content-zoom\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"contentzoom/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"contentzoom/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"contentzoom/slide3.jpg\";}}s:13:\"food-carousel\";a:7:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"foodcarousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:23:\"foodcarousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:23:\"foodcarousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:23:\"foodcarousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:23:\"foodcarousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:23:\"foodcarousel/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:23:\"foodcarousel/slide7.jpg\";}}s:14:\"rotating-words\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"rotatingwords/slide1.jpg\";}}s:22:\"travel-static-captions\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"travel-static-captions/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:33:\"travel-static-captions/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:33:\"travel-static-captions/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:33:\"travel-static-captions/slide4.jpg\";}}s:7:\"concept\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:18:\"concept/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:18:\"concept/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:18:\"concept/slide3.jpg\";}}s:17:\"fullscreen-button\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"fullscreen-button/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"fullscreen-button/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"fullscreen-button/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:28:\"fullscreen-button/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:28:\"fullscreen-button/slide5.jpg\";}}s:15:\"creativefreedom\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"creativefreedom/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"creativefreedom/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"creativefreedom/slide3.jpg\";}}s:13:\"parallaxscene\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"parallaxscene/slide1.jpg\";}}s:15:\"slidingoverlays\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"slidingoverlays/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"slidingoverlays/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"slidingoverlays/slide3.jpg\";}}s:25:\"web-product-light-hero-3d\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:36:\"web-product-light-hero-3d/slide1.jpg\";}}s:6:\"woobig\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:17:\"woobig/slide1.jpg\";}}s:16:\"woocommercesmall\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"woocommercesmall/slide1.jpg\";}}s:10:\"finedining\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"finedining/slide1.jpg\";}}s:12:\"agency-intro\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"agency-intro/slide1.jpg\";}}s:7:\"ourteam\";a:7:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:18:\"ourteam/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:18:\"ourteam/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:18:\"ourteam/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:18:\"ourteam/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:18:\"ourteam/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:18:\"ourteam/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:18:\"ourteam/slide7.jpg\";}}s:17:\"our-team-carousel\";a:7:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"ourteamcarousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"ourteamcarousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"ourteamcarousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"ourteamcarousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:26:\"ourteamcarousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:26:\"ourteamcarousel/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:26:\"ourteamcarousel/slide7.jpg\";}}s:13:\"betteryoutube\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"betteryoutube/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"betteryoutube/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"betteryoutube/slide3.jpg\";}}s:19:\"agencywebsiteheader\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"agencywebsiteheader/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:30:\"agencywebsiteheader/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:30:\"agencywebsiteheader/slide3.jpg\";}}s:10:\"comingsoon\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"comingsoon/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:21:\"comingsoon/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:21:\"comingsoon/slide3.jpg\";}}s:9:\"snowscene\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"snowscene/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:20:\"snowscene/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:20:\"snowscene/slide3.jpg\";}}s:8:\"rockband\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:19:\"rockband/slide1.jpg\";}}s:16:\"sleeklandingpage\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"sleeklandingpage/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"sleeklandingpage/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"sleeklandingpage/slide3.jpg\";}}s:14:\"applandingpage\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"applandingpage/slide1.jpg\";}}s:9:\"deskscene\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"deskscene/slide1.jpg\";}}s:15:\"cleannewsslider\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"cleannewsslider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"cleannewsslider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"cleannewsslider/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"cleannewsslider/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:26:\"cleannewsslider/slide5.jpg\";}}s:12:\"imagegallery\";a:8:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"imagegallery/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:23:\"imagegallery/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:23:\"imagegallery/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:23:\"imagegallery/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:23:\"imagegallery/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:23:\"imagegallery/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:23:\"imagegallery/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:23:\"imagegallery/slide8.jpg\";}}s:19:\"standard-wp-gallery\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"standard-wp-gallery/slide1.jpg\";}}s:21:\"clean-news-post-based\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"clean-news-post-based/slide1.jpg\";}}s:21:\"interactivewhiteboard\";a:8:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"interactivewhiteboard/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:32:\"interactivewhiteboard/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:32:\"interactivewhiteboard/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:32:\"interactivewhiteboard/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:32:\"interactivewhiteboard/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:32:\"interactivewhiteboard/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:32:\"interactivewhiteboard/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:32:\"interactivewhiteboard/slide8.jpg\";}}s:10:\"innovation\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"innovation/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:21:\"innovation/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:21:\"innovation/slide3.jpg\";}}s:24:\"dark-fullsite-block-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"dark-fullsite-block-menu/slide1.jpg\";}}s:21:\"dark-fullsite-block-1\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"dark-fullsite-block-1/slide1.jpg\";}}s:27:\"dark-fullsite-block-2-about\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"dark-fullsite-block-2-about/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:38:\"dark-fullsite-block-2-about/slide2.jpg\";}}s:30:\"dark-fullsite-block-3-services\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:41:\"dark-fullsite-block-3-services/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:41:\"dark-fullsite-block-3-services/slide2.jpg\";}}s:30:\"dark-fullsite-block-4-products\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:41:\"dark-fullsite-block-4-products/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:41:\"dark-fullsite-block-4-products/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:41:\"dark-fullsite-block-4-products/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:41:\"dark-fullsite-block-4-products/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:41:\"dark-fullsite-block-4-products/slide5.jpg\";}}s:34:\"dark-fullsite-block-5-testimonials\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:45:\"dark-fullsite-block-5-testimonials/slide1.jpg\";}}s:29:\"dark-fullsite-block-6-callout\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:40:\"dark-fullsite-block-6-callout/slide1.jpg\";}}s:28:\"dark-fullsite-block-7-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:39:\"dark-fullsite-block-7-footer/slide1.jpg\";}}s:19:\"fullsite-block-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"fullsite-block-menu/slide1.jpg\";}}s:15:\"fullsite-block1\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"fullsite-block1/slide1.jpg\";}}s:22:\"fullsite-block-2-about\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"fullsite-block-2-about/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:33:\"fullsite-block-2-about/slide2.jpg\";}}s:25:\"fullsite-block-3-services\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:36:\"fullsite-block-3-services/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:36:\"fullsite-block-3-services/slide2.jpg\";}}s:25:\"fullsite-block-4-products\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:36:\"fullsite-block-4-products/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:36:\"fullsite-block-4-products/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:36:\"fullsite-block-4-products/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:36:\"fullsite-block-4-products/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:36:\"fullsite-block-4-products/slide5.jpg\";}}s:29:\"fullsite-block-5-testimonials\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:40:\"fullsite-block-5-testimonials/slide1.jpg\";}}s:24:\"fullsite-block-6-callout\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"fullsite-block-6-callout/slide1.jpg\";}}s:23:\"fullsite-block-7-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"fullsite-block-7-footer/slide1.jpg\";}}s:11:\"techjournal\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"techjournal/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"techjournal/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"techjournal/slide3.jpg\";}}s:13:\"cardealership\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"cardealership/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"cardealership/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"cardealership/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:24:\"cardealership/slide4.jpg\";}}s:14:\"fullscreenmenu\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"fullscreenmenu/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"fullscreenmenu/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"fullscreenmenu/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:25:\"fullscreenmenu/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:25:\"fullscreenmenu/slide5.jpg\";}}s:17:\"creativefrontpage\";a:8:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"creativefrontpage/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"creativefrontpage/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"creativefrontpage/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:28:\"creativefrontpage/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:28:\"creativefrontpage/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:28:\"creativefrontpage/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:28:\"creativefrontpage/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:28:\"creativefrontpage/slide8.jpg\";}}s:19:\"websitebuilder-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"websitebuilder-menu/slide1.jpg\";}}s:19:\"websitebuilder-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"websitebuilder-hero/slide1.jpg\";}}s:22:\"websitebuilder-clients\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"websitebuilder-clients/slide1.jpg\";}}s:23:\"websitebuilder-services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"websitebuilder-services/slide1.jpg\";}}s:23:\"websitebuilder-discover\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"websitebuilder-discover/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:34:\"websitebuilder-discover/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:34:\"websitebuilder-discover/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:34:\"websitebuilder-discover/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:34:\"websitebuilder-discover/slide5.jpg\";}}s:21:\"websitebuilder-slider\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"websitebuilder-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:32:\"websitebuilder-slider/slide2.jpg\";}}s:27:\"websitebuilder-calltoaction\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"websitebuilder-calltoaction/slide1.jpg\";}}s:21:\"websitebuilder-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"websitebuilder-footer/slide1.jpg\";}}s:13:\"focusparallax\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"focusparallax/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"focusparallax/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"focusparallax/slide3.jpg\";}}s:7:\"duotone\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:18:\"duotone/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:18:\"duotone/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:18:\"duotone/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:18:\"duotone/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:18:\"duotone/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:18:\"duotone/slide6.jpg\";}}s:6:\"r_menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:17:\"r_menu/slide1.jpg\";}}s:5:\"rhero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:17:\"r_hero/slide1.jpg\";}}s:7:\"r_about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:18:\"r_about/slide1.jpg\";}}s:10:\"r_products\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"r_products/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:21:\"r_products/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:21:\"r_products/slide3.jpg\";}}s:6:\"r_info\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:17:\"r_info/slide1.jpg\";}}s:17:\"inspirationheader\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"inspirationheader/slide1.jpg\";}}s:13:\"magazineposts\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"magazineposts/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"magazineposts/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"magazineposts/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:24:\"magazineposts/slide4.jpg\";}}s:17:\"explorationheader\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"explorationheader/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"explorationheader/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"explorationheader/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:28:\"explorationheader/slide4.jpg\";}}s:16:\"typewritereffect\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"typewritereffect/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"typewritereffect/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"typewritereffect/slide3.jpg\";}}s:15:\"blendmodeheader\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"blendmodeheader/slide1.jpg\";}}s:17:\"themeplicity_menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"themeplicity_menu/slide1.jpg\";}}s:19:\"themeplicity_header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"themeplicity_header/slide1.jpg\";}}s:18:\"themeplicity_offer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"themeplicity_offer/slide1.jpg\";}}s:21:\"themeplicity_whatwedo\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"themeplicity_whatwedo/slide1.jpg\";}}s:21:\"themeplicity_projects\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"themeplicity_projects/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:32:\"themeplicity_projects/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:32:\"themeplicity_projects/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:32:\"themeplicity_projects/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:32:\"themeplicity_projects/slide5.jpg\";s:3:\"img\";s:7:\"Slide 5\";}}s:23:\"themeplicity_whatsgreat\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"themeplicity_whatsgreat/slide1.jpg\";}}s:19:\"themeplicity_tables\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"themeplicity_tables/slide1.jpg\";}}s:24:\"themeplicity_contactform\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"themeplicity_contactform/slide1.jpg\";}}s:19:\"themeplicity_footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"themeplicity_footer/slide1.jpg\";}}s:17:\"NiceAndClean_Menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"NiceAndClean_Menu/slide1.jpg\";}}s:19:\"NiceAndClean_Header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"NiceAndClean_Header/slide1.jpg\";}}s:21:\"NiceAndClean_Services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"NiceAndClean_Services/slide1.jpg\";}}s:18:\"NiceAndClean_About\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"NiceAndClean_About/slide1.jpg\";}}s:18:\"niceandclean_video\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"niceandclean_video/slide1.jpg\";}}s:23:\"niceandclean_highlights\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"niceandclean_highlights/slide1.jpg\";}}s:21:\"NiceAndClean_Projects\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"NiceAndClean_Projects/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:32:\"NiceAndClean_Projects/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:32:\"NiceAndClean_Projects/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:32:\"NiceAndClean_Projects/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:32:\"NiceAndClean_Projects/slide5.jpg\";}}s:23:\"niceandclean_textblocks\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"niceandclean_textblocks/slide1.jpg\";}}s:20:\"niceandclean_callout\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"niceandclean_callout/slide1.jpg\";}}s:19:\"niceandclean_footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"niceandclean_footer/slide1.jpg\";}}s:3:\"80s\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:14:\"80s/slide1.jpg\";}}s:10:\"blurslider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"blurslider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:21:\"blurslider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:21:\"blurslider/slide3.jpg\";}}s:15:\"ComingSoonAddon\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"ComingSoonAddon/slide1.jpg\";}}s:9:\"snowaddon\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"snowaddon/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:20:\"snowaddon/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:20:\"snowaddon/slide3.jpg\";}}s:19:\"particle-effect-one\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"particle-effect-one/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:30:\"particle-effect-one/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:30:\"particle-effect-one/slide3.jpg\";}}s:19:\"particle-effect-two\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"particle-effect-two/slide1.jpg\";}}s:21:\"particle-effect-three\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"particle-effect-three/slide1.jpg\";}}s:15:\"portfolioviewer\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"portfolioviewer/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"portfolioviewer/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"portfolioviewer/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"portfolioviewer/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:26:\"portfolioviewer/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:26:\"portfolioviewer/slide6.jpg\";}}s:11:\"appshowcase\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"appshowcase/slide1.jpg\";}}s:13:\"gravitydesign\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"gravitydesign/slide1.jpg\";}}s:12:\"404errorpage\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"404errorpage/slide1.jpg\";}}s:15:\"carouselgallery\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"carouselgallery/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"carouselgallery/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"carouselgallery/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"carouselgallery/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:26:\"carouselgallery/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:26:\"carouselgallery/slide6.jpg\";}}s:9:\"filmstrip\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"filmstrip/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:20:\"filmstrip/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:20:\"filmstrip/slide3.jpg\";}}s:10:\"spaceopera\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"spaceopera/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:21:\"spaceopera/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:21:\"spaceopera/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:21:\"spaceopera/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:21:\"spaceopera/slide5.jpg\";}}s:12:\"websiteintro\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"websiteintro/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:23:\"websiteintro/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:23:\"websiteintro/slide3.jpg\";}}s:12:\"maskshowcase\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"maskshowcase/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:23:\"maskshowcase/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:23:\"maskshowcase/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:23:\"maskshowcase/slide4.jpg\";}}s:18:\"parallaxzoomslices\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"parallaxzoomslices/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"parallaxzoomslices/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"parallaxzoomslices/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:29:\"parallaxzoomslices/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:29:\"parallaxzoomslices/slide5.jpg\";}}s:20:\"doubleexposureeffect\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"doubleexposureeffect/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:31:\"doubleexposureeffect/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:31:\"doubleexposureeffect/slide3.jpg\";}}s:22:\"mountainparallaxheader\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"mountainparallaxheader/slide1.jpg\";}}s:12:\"goodnewsmenu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"goodnewsmenu/slide1.jpg\";}}s:14:\"goodnewsheader\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"goodnewsheader/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"goodnewsheader/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"goodnewsheader/slide3.jpg\";}}s:16:\"goodnewswhatshot\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"goodnewswhatshot/slide1.jpg\";}}s:16:\"goodnewsfeatured\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"goodnewsfeatured/slide1.jpg\";}}s:17:\"goodnewsspotlight\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"goodnewsspotlight/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"goodnewsspotlight/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"goodnewsspotlight/slide3.jpg\";}}s:16:\"goodnewscarousel\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"goodnewscarousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"goodnewscarousel/slide2.jpg\";}}s:15:\"goodnewscallout\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"goodnewscallout/slide1.jpg\";}}s:14:\"goodnewsfooter\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"goodnewsfooter/slide1.jpg\";}}s:16:\"goodnewsmenuback\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"goodnewsmenuback/slide1.jpg\";}}s:18:\"goodnewsblogheader\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"goodnewsblogheader/slide1.jpg\";}}s:19:\"goodnewsblogcontent\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"goodnewsblogcontent/slide1.jpg\";}}s:20:\"goodnewstestimonials\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"goodnewstestimonials/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:31:\"goodnewstestimonials/slide2.jpg\";}}s:18:\"goodnewsblogfooter\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"goodnewsblogfooter/slide1.jpg\";}}s:17:\"beforeafterslider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"beforeafterslider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"beforeafterslider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"beforeafterslider/slide3.jpg\";}}s:15:\"productshowcase\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"productshowcase/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"productshowcase/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"productshowcase/slide3.jpg\";}}s:22:\"overexposuretransition\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"overexposuretransition/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:33:\"overexposuretransition/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:33:\"overexposuretransition/slide3.jpg\";}}s:14:\"parallaxscroll\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"parallaxscroll/slide1.jpg\";}}s:11:\"techco-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"techco-menu/slide1.jpg\";}}s:13:\"techco-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"techco-header/slide1.jpg\";}}s:12:\"techco-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"techco-about/slide1.jpg\";}}s:15:\"techco-services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"techco-services/slide1.jpg\";}}s:12:\"techco-video\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"techco-video/slide1.jpg\";}}s:13:\"techco-prices\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"techco-prices/slide1.jpg\";}}s:19:\"techco-testimonials\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"techco-testimonials/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:30:\"techco-testimonials/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:30:\"techco-testimonials/slide3.jpg\";}}s:13:\"techco-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"techco-footer/slide1.jpg\";}}s:7:\"weather\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:18:\"weather/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:18:\"weather/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:18:\"weather/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:18:\"weather/slide4.jpg\";}}s:11:\"360panorama\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"360panorama/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"360panorama/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"360panorama/slide3.jpg\";}}s:14:\"duotone-add-on\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"duotone-add-on/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"duotone-add-on/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"duotone-add-on/slide3.jpg\";}}s:13:\"reveal-add-on\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"reveal-add-on/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"reveal-add-on/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"reveal-add-on/slide3.jpg\";}}s:16:\"band-tour-poster\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:40:\"smartcontent/band-tour-poster/slide1.png\";}}s:14:\"brewery-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"smartcontent/brewery-slider/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:38:\"smartcontent/brewery-slider/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:38:\"smartcontent/brewery-slider/slide3.png\";}}s:9:\"burgerbar\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"smartcontent/burgerbar/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:33:\"smartcontent/burgerbar/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:33:\"smartcontent/burgerbar/slide3.png\";}}s:19:\"burger-bar-portrait\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:43:\"smartcontent/burger-bar-portrait/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:43:\"smartcontent/burger-bar-portrait/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:43:\"smartcontent/burger-bar-portrait/slide3.png\";}}s:8:\"car-rent\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"smartcontent/car-rent/slide1.png\";}}s:6:\"coffee\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"smartcontent/coffee/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:30:\"smartcontent/coffee/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:30:\"smartcontent/coffee/slide3.png\";}}s:14:\"holiday-advert\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"smartcontent/holiday-advert/slide1.png\";}}s:18:\"iphone-cases-light\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:42:\"smartcontent/iphone-cases-light/slide1.png\";}}s:7:\"medical\";a:2:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"smartcontent/medical/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:31:\"smartcontent/medical/slide2.png\";}}s:13:\"mexican-grill\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:37:\"smartcontent/mexican-grill/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:37:\"smartcontent/mexican-grill/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:37:\"smartcontent/mexican-grill/slide3.png\";}}s:20:\"mobile-retail-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:44:\"smartcontent/mobile-retail-slider/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:44:\"smartcontent/mobile-retail-slider/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:44:\"smartcontent/mobile-retail-slider/slide3.png\";}}s:14:\"money-exchange\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"smartcontent/money-exchange/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:38:\"smartcontent/money-exchange/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:38:\"smartcontent/money-exchange/slide3.png\";}}s:28:\"restaurant-menu-first-screen\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:52:\"smartcontent/restaurant-menu-first-screen/slide1.png\";}}s:29:\"restaurant-menu-second-screen\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:53:\"smartcontent/restaurant-menu-second-screen/slide1.png\";}}s:28:\"restaurant-menu-third-screen\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:52:\"smartcontent/restaurant-menu-third-screen/slide1.png\";}}s:11:\"shoes-store\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"smartcontent/shoes-store/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:35:\"smartcontent/shoes-store/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:35:\"smartcontent/shoes-store/slide3.png\";}}s:20:\"supermarket-products\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:44:\"smartcontent/supermarket-products/slide1.png\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:44:\"smartcontent/supermarket-products/slide2.png\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:44:\"smartcontent/supermarket-products/slide3.png\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:44:\"smartcontent/supermarket-products/slide4.png\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:44:\"smartcontent/supermarket-products/slide5.png\";}}s:16:\"travel-insurance\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:40:\"smartcontent/travel-insurance/slide1.png\";}}s:12:\"cryptoslider\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"cryptoslider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:23:\"cryptoslider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:23:\"cryptoslider/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:23:\"cryptoslider/slide4.jpg\";}}s:16:\"immersion_header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"immersion_header/slide1.jpg\";}}s:19:\"immersion-mountains\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"immersion-mountains/slide1.jpg\";}}s:17:\"immersion-product\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"immersion-product/slide1.jpg\";}}s:16:\"immersion-design\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"immersion-design/slide1.jpg\";}}s:21:\"immersion-photography\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"immersion-photography/slide1.jpg\";}}s:14:\"immersion-grid\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"immersion-grid/slide1.jpg\";}}s:11:\"funkyslider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"funkyslider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"funkyslider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"funkyslider/slide3.jpg\";}}s:14:\"clearview_menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"clearview_menu/slide1.jpg\";}}s:16:\"clearview_header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"clearview_header/slide1.jpg\";}}s:17:\"clearview_mission\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"clearview_mission/slide1.jpg\";}}s:17:\"clear-view-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"clear-view-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"clear-view-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"clear-view-slider/slide3.jpg\";}}s:15:\"clear-view-news\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"clear-view-news/slide1.jpg\";}}s:18:\"clear-view-clients\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"clear-view-clients/slide1.jpg\";}}s:18:\"clear-view-contact\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"clear-view-contact/slide1.jpg\";}}s:22:\"clear-view-single-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"clear-view-single-menu/slide1.jpg\";}}s:24:\"clear-view-single-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"clear-view-single-header/slide1.jpg\";}}s:23:\"clear-view-single-media\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"clear-view-single-media/slide1.jpg\";}}s:22:\"clear-view-single-more\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"clear-view-single-more/slide1.jpg\";}}s:25:\"clear-view-single-contact\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:36:\"clear-view-single-contact/slide1.jpg\";}}s:16:\"cleanlandingpage\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"cleanlandingpage/slide1.jpg\";}}s:8:\"clearcut\";a:10:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:19:\"clearcut/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:19:\"clearcut/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:19:\"clearcut/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:19:\"clearcut/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:19:\"clearcut/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:19:\"clearcut/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:19:\"clearcut/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:19:\"clearcut/slide8.jpg\";}i:8;a:2:{s:5:\"title\";s:7:\"Slide 9\";s:3:\"img\";s:19:\"clearcut/slide9.jpg\";}i:9;a:2:{s:5:\"title\";s:8:\"Slide 10\";s:3:\"img\";s:20:\"clearcut/slide10.jpg\";}}s:17:\"wonderstruck_menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"wonderstruck_menu/slide1.jpg\";}}s:19:\"wonderstruck_header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"wonderstruck_header/slide1.jpg\";}}s:18:\"wonderstruck_about\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"wonderstruck_about/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"wonderstruck_about/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"wonderstruck_about/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:29:\"wonderstruck_about/slide4.jpg\";}}s:18:\"wonderstruck-works\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"wonderstruck-works/slide1.jpg\";}}s:20:\"wonderstruck-contact\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"wonderstruck-contact/slide1.jpg\";}}s:11:\"bubblemorph\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"bubblemorph/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"bubblemorph/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"bubblemorph/slide3.jpg\";}}s:15:\"distortionaddon\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"distortionaddon/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"distortionaddon/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"distortionaddon/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"distortionaddon/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:26:\"distortionaddon/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:26:\"distortionaddon/slide6.jpg\";}}s:9:\"clubflyer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:20:\"clubflyer/slide1.jpg\";}}s:15:\"paintbrushaddon\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"paintbrushaddon/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"paintbrushaddon/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"paintbrushaddon/slide3.jpg\";}}s:15:\"parallax_header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"parallax_header/slide1.jpg\";}}s:16:\"parallax_content\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"parallax_content/slide1.jpg\";}}s:15:\"parallax_footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"parallax_footer/slide1.jpg\";}}s:12:\"le-chef-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"le-chef-menu/slide1.jpg\";}}s:14:\"le-chef-header\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"le-chef-header/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"le-chef-header/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"le-chef-header/slide3.jpg\";}}s:18:\"le-chef-philosophy\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"le-chef-philosophy/slide1.jpg\";}}s:12:\"le-chef-food\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"le-chef-food/slide1.jpg\";}}s:16:\"le-chef-la-carte\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"le-chef-la-carte/slide1.jpg\";}}s:14:\"le-chef-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"le-chef-footer/slide1.jpg\";}}s:20:\"news-magazine-slider\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"news-magazine-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:31:\"news-magazine-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:31:\"news-magazine-slider/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:31:\"news-magazine-slider/slide4.jpg\";}}s:18:\"real-estate-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"real-estate-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"real-estate-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"real-estate-slider/slide3.jpg\";}}s:14:\"fashion-header\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"fashion-header/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"fashion-header/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"fashion-header/slide3.jpg\";}}s:13:\"seasonaloffer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"seasonaloffer/slide1.jpg\";}}s:18:\"barber-shop-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"barber-shop-header/slide1.jpg\";}}s:23:\"barber-shop-mobile-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"barber-shop-mobile-menu/slide1.jpg\";}}s:24:\"barber-shop-first-screen\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"barber-shop-first-screen/slide1.jpg\";}}s:17:\"barber-shop-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"barber-shop-about/slide1.jpg\";}}s:20:\"barber-shop-services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"barber-shop-services/slide1.jpg\";}}s:19:\"barber-shop-barbers\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"barber-shop-barbers/slide1.jpg\";}}s:20:\"barber-shop-contacts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"barber-shop-contacts/slide1.jpg\";}}s:18:\"barber-shop-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"barber-shop-footer/slide1.jpg\";}}s:21:\"fitness-club-template\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"fitness-club-template/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:32:\"fitness-club-template/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:32:\"fitness-club-template/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:32:\"fitness-club-template/slide4.jpg\";}}s:13:\"soccer-school\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"soccer-school/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"soccer-school/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"soccer-school/slide3.jpg\";}}s:19:\"music-band-template\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"music-band-template/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:30:\"music-band-template/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:30:\"music-band-template/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:30:\"music-band-template/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:30:\"music-band-template/slide5.jpg\";}}s:15:\"restaurant-menu\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"restaurant-menu/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"restaurant-menu/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"restaurant-menu/slide3.jpg\";}}s:16:\"cinematic-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"cinematic-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"cinematic-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"cinematic-slider/slide3.jpg\";}}s:17:\"3d-parallax-cubes\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"3d-parallax-cubes/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"3d-parallax-cubes/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"3d-parallax-cubes/slide3.jpg\";}}s:13:\"medicare-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"medicare-menu/slide1.jpg\";}}s:15:\"medicare-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"medicare-header/slide1.jpg\";}}s:14:\"medicare-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"medicare-about/slide1.jpg\";}}s:18:\"medicare-highlight\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"medicare-highlight/slide1.jpg\";}}s:17:\"medicare-services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"medicare-services/slide1.jpg\";}}s:16:\"medicare-doctors\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"medicare-doctors/slide1.jpg\";}}s:17:\"medicare-research\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"medicare-research/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"medicare-research/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"medicare-research/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:28:\"medicare-research/slide4.jpg\";}}s:18:\"medicare-whychoose\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"medicare-whychoose/slide1.jpg\";}}s:16:\"medicare-contact\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"medicare-contact/slide1.jpg\";}}s:15:\"medicare-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"medicare-footer/slide1.jpg\";}}s:11:\"coffee-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"coffee-menu/slide1.jpg\";}}s:13:\"coffee-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"coffee-header/slide1.jpg\";}}s:17:\"coffee-philosophy\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"coffee-philosophy/slide1.jpg\";}}s:12:\"coffee-carte\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"coffee-carte/slide1.jpg\";}}s:13:\"coffee-teaser\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"coffee-teaser/slide1.jpg\";}}s:13:\"coffee-findus\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"coffee-findus/slide1.jpg\";}}s:13:\"coffee-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"coffee-footer/slide1.jpg\";}}s:17:\"minimal-portfolio\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"minimal-portfolio/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"minimal-portfolio/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"minimal-portfolio/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:28:\"minimal-portfolio/slide4.jpg\";}}s:23:\"minimal-portfolio-modal\";a:7:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:34:\"minimal-portfolio-modal/slide7.jpg\";}}s:11:\"angled-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"angled-menu/slide1.jpg\";}}s:13:\"angled-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"angled-header/slide1.jpg\";}}s:11:\"angled-news\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"angled-news/slide1.jpg\";}}s:15:\"angled-services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"angled-services/slide1.jpg\";}}s:14:\"angled-success\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"angled-success/slide1.jpg\";}}s:13:\"angled-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"angled-footer/slide1.jpg\";}}s:20:\"angled-content-modal\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"angled-content-modal/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:31:\"angled-content-modal/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:31:\"angled-content-modal/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:31:\"angled-content-modal/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:31:\"angled-content-modal/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:31:\"angled-content-modal/slide6.jpg\";}}s:13:\"big-bold-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"big-bold-menu/slide1.jpg\";}}s:15:\"big-bold-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"big-bold-header/slide1.jpg\";}}s:16:\"big-bold-content\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"big-bold-content/slide1.jpg\";}}s:13:\"big-bold-blog\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"big-bold-blog/slide1.jpg\";}}s:18:\"big-bold-highlight\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"big-bold-highlight/slide1.jpg\";}}s:15:\"big-bold-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"big-bold-footer/slide1.jpg\";}}s:7:\"Retouch\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:18:\"Retouch/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:18:\"Retouch/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:18:\"Retouch/slide3.jpg\";}}s:11:\"tech-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"tech-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"tech-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"tech-slider/slide3.jpg\";}}s:11:\"peak-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"peak-header/slide1.jpg\";}}s:10:\"peak-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"peak-about/slide1.jpg\";}}s:14:\"peak-portfolio\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"peak-portfolio/slide1.jpg\";}}s:11:\"peak-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"peak-footer/slide1.jpg\";}}s:17:\"portfolio-welcome\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"portfolio-welcome/slide1.jpg\";}}s:15:\"portfolio-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"portfolio-about/slide1.jpg\";}}s:21:\"portfolio-works-title\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"portfolio-works-title/slide1.jpg\";}}s:23:\"portfolio-works-content\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"portfolio-works-content/slide1.jpg\";}}s:18:\"portfolio-contacts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"portfolio-contacts/slide1.jpg\";}}s:18:\"App-Studio-Welcome\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"App-Studio-Welcome/slide1.jpg\";}}s:19:\"App-Studio-Services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"App-Studio-Services/slide1.jpg\";}}s:16:\"App-Studio-About\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"App-Studio-About/slide1.jpg\";}}s:19:\"App-Studio-Contacts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"App-Studio-Contacts/slide1.jpg\";}}s:14:\"cube-animation\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"cube-animation/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"cube-animation/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"cube-animation/slide3.jpg\";}}s:10:\"basic-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"basic-menu/slide1.jpg\";}}s:12:\"basic-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"basic-header/slide1.jpg\";}}s:13:\"basic-content\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"basic-content/slide1.jpg\";}}s:14:\"basic-carousel\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"basic-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"basic-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"basic-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:25:\"basic-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:25:\"basic-carousel/slide5.jpg\";}}s:13:\"basic-callout\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"basic-callout/slide1.jpg\";}}s:10:\"basic-grid\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"basic-grid/slide1.jpg\";}}s:17:\"basic-video-block\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"basic-video-block/slide1.jpg\";}}s:12:\"basic-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"basic-footer/slide1.jpg\";}}s:14:\"basic-lightbox\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"basic-lightbox/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"basic-lightbox/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"basic-lightbox/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:25:\"basic-lightbox/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:25:\"basic-lightbox/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:25:\"basic-lightbox/slide6.jpg\";}}s:13:\"nature-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"nature-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"nature-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"nature-slider/slide3.jpg\";}}s:11:\"art-gallery\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"art-gallery/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:22:\"art-gallery/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:22:\"art-gallery/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:22:\"art-gallery/slide4.jpg\";}}s:19:\"Construction-Header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"Construction-Header/slide1.jpg\";}}s:17:\"Construction-Home\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"Construction-Home/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:28:\"Construction-Home/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:28:\"Construction-Home/slide3.jpg\";}}s:21:\"Construction-Projects\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"Construction-Projects/slide1.jpg\";}}s:20:\"Construction-History\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"Construction-History/slide1.jpg\";}}s:21:\"Construction-Services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"Construction-Services/slide1.jpg\";}}s:21:\"Construction-Contacts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"Construction-Contacts/slide1.jpg\";}}s:21:\"404-Error-Space-Theme\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"404-Error-Space-Theme/slide1.jpg\";}}s:17:\"landing-page-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"landing-page-hero/slide1.jpg\";}}s:21:\"landing-page-features\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"landing-page-features/slide1.jpg\";}}s:20:\"landing-page-callout\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"landing-page-callout/slide1.jpg\";}}s:20:\"landing-page-content\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"landing-page-content/slide1.jpg\";}}s:25:\"landing-page-testimonials\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:36:\"landing-page-testimonials/slide1.jpg\";}}s:27:\"landing-page-call-to-action\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"landing-page-call-to-action/slide1.jpg\";}}s:17:\"landing-page-help\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"landing-page-help/slide1.jpg\";}}s:19:\"landing-page-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"landing-page-footer/slide1.jpg\";}}s:24:\"landing-page-price-modal\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"landing-page-price-modal/slide1.jpg\";}}s:18:\"energy-drinks-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"energy-drinks-hero/slide1.jpg\";}}s:19:\"energy-drinks-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"energy-drinks-about/slide1.jpg\";}}s:21:\"energy-drinks-product\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"energy-drinks-product/slide1.jpg\";}}s:23:\"energy-drinks-product-2\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"energy-drinks-product-2/slide1.jpg\";}}s:23:\"energy-drinks-product-3\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"energy-drinks-product-3/slide1.jpg\";}}s:19:\"energy-drinks-order\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"energy-drinks-order/slide1.jpg\";}}s:20:\"energy-drinks-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"energy-drinks-footer/slide1.jpg\";}}s:19:\"energy-drinks-modal\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"energy-drinks-modal/slide1.jpg\";}}s:16:\"Corporate-Header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"Corporate-Header/slide1.jpg\";}}s:24:\"Corporate-Welcome-Screen\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"Corporate-Welcome-Screen/slide1.jpg\";}}s:15:\"Corporate-About\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"Corporate-About/slide1.jpg\";}}s:19:\"Corporate-Portfolio\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"Corporate-Portfolio/slide1.jpg\";}}s:15:\"Corporate-Chart\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"Corporate-Chart/slide1.jpg\";}}s:14:\"Corporate-News\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"Corporate-News/slide1.jpg\";}}s:16:\"Corporate-Hiring\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"Corporate-News/slide1.jpg\";}}s:22:\"Corporate-Testimonials\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"Corporate-Testimonials/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:33:\"Corporate-Testimonials/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:33:\"Corporate-Testimonials/slide3.jpg\";}}s:15:\"Corporate-Store\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"Corporate-Store/slide1.jpg\";}}s:17:\"Corporate-Support\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"Corporate-Support/slide1.jpg\";}}s:14:\"Corporate-Team\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"Corporate-Team/slide1.jpg\";}}s:33:\"Corporate-Selected-Projects-Title\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:44:\"Corporate-Selected-Projects-Title/slide1.jpg\";}}s:27:\"Corporate-Selected-Projects\";a:7:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:38:\"Corporate-Selected-Projects/slide7.jpg\";}}s:17:\"Corporate-Clients\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"Corporate-Clients/slide1.jpg\";}}s:20:\"Corporate-Text-Block\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"Corporate-Text-Block/slide1.jpg\";}}s:20:\"Corporate-Mobile-App\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"Corporate-Mobile-App/slide1.jpg\";}}s:18:\"Corporate-Contacts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"Corporate-Contacts/slide1.jpg\";}}s:16:\"Corporate-Footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"Corporate-Footer/slide1.jpg\";}}s:23:\"Corporate-Scroll-To-Top\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"Corporate-Scroll-To-Top/slide1.jpg\";}}s:14:\"geometric-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"geometric-menu/slide1.jpg\";}}s:14:\"geometric-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"geometric-hero/slide1.jpg\";}}s:14:\"geometric-grid\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"geometric-grid/slide1.jpg\";}}s:15:\"geometric-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"geometric-about/slide1.jpg\";}}s:15:\"geometric-texts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"geometric-texts/slide1.jpg\";}}s:18:\"geometric-services\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"geometric-services/slide1.jpg\";}}s:17:\"geometric-texts-2\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"geometric-texts-2/slide1.jpg\";}}s:22:\"geometric-testimonials\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"geometric-testimonials/slide1.jpg\";}}s:16:\"geometric-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"geometric-footer/slide1.jpg\";}}s:18:\"geometric-lightbox\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"geometric-lightbox/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"geometric-lightbox/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"geometric-lightbox/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:29:\"geometric-lightbox/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:29:\"geometric-lightbox/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:29:\"geometric-lightbox/slide6.jpg\";}}s:11:\"brutal-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"brutal-menu/slide1.jpg\";}}s:11:\"brutal-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:22:\"brutal-hero/slide1.jpg\";}}s:12:\"brutal-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"brutal-about/slide1.jpg\";}}s:16:\"brutal-highlight\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"brutal-highlight/slide1.jpg\";}}s:15:\"brutal-projects\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"brutal-projects/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"brutal-projects/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"brutal-projects/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"brutal-projects/slide4.jpg\";}}s:15:\"brutal-services\";a:4:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"brutal-services/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"brutal-services/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"brutal-services/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:26:\"brutal-services/slide4.jpg\";}}s:14:\"brutal-callout\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"brutal-callout/slide1.jpg\";}}s:13:\"brutal-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"brutal-footer/slide1.jpg\";}}s:13:\"Church-Header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"Church-Header/slide1.jpg\";}}s:22:\"Church-Upcoming-Events\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"Church-Upcoming-Events/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:33:\"Church-Upcoming-Events/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:33:\"Church-Upcoming-Events/slide3.jpg\";}}s:12:\"Church-About\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"Church-About/slide1.jpg\";}}s:14:\"Church-Pastors\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"Church-Pastors/slide1.jpg\";}}s:20:\"Church-Photo-Gallery\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"Church-Photo-Gallery/slide1.jpg\";}}s:16:\"Church-Community\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"Church-Community/slide1.jpg\";}}s:13:\"Church-Sermon\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"Church-Sermon/slide1.jpg\";}}s:15:\"Church-Contacts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"Church-Contacts/slide1.jpg\";}}s:13:\"Church-Footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"Church-Footer/slide1.jpg\";}}s:19:\"Church-Light-Header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"Church-Light-Header/slide1.jpg\";}}s:28:\"Church-Light-Upcoming-Events\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:39:\"Church-Light-Upcoming-Events/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:39:\"Church-Light-Upcoming-Events/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:39:\"Church-Light-Upcoming-Events/slide3.jpg\";}}s:18:\"Church-Light-About\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"Church-Light-About/slide1.jpg\";}}s:20:\"Church-Light-Pastors\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:31:\"Church-Light-Pastors/slide1.jpg\";}}s:26:\"Church-Light-Photo-Gallery\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:37:\"Church-Light-Photo-Gallery/slide1.jpg\";}}s:22:\"Church-Light-Community\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"Church-Light-Community/slide1.jpg\";}}s:19:\"Church-Light-Sermon\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"Church-Light-Sermon/slide1.jpg\";}}s:21:\"Church-Light-Contacts\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"Church-Light-Contacts/slide1.jpg\";}}s:19:\"Church-Light-Footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"Church-Light-Footer/slide1.jpg\";}}s:13:\"rockable-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"rockable-menu/slide1.jpg\";}}s:13:\"rockable-hero\";a:5:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"rockable-hero/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"rockable-hero/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"rockable-hero/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:24:\"rockable-hero/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:24:\"rockable-hero/slide5.jpg\";}}s:15:\"rockable-lineup\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"rockable-lineup/slide1.jpg\";}}s:17:\"rockable-lineup-2\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"rockable-lineup-2/slide1.jpg\";}}s:22:\"rockable-gallery-title\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"rockable-gallery-title/slide1.jpg\";}}s:16:\"rockable-gallery\";a:7:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"rockable-gallery/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"rockable-gallery/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"rockable-gallery/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:27:\"rockable-gallery/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:27:\"rockable-gallery/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:27:\"rockable-gallery/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:27:\"rockable-gallery/slide7.jpg\";}}s:17:\"rockable-sponsors\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"rockable-sponsors/slide1.jpg\";}}s:15:\"rockable-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"rockable-footer/slide1.jpg\";}}s:21:\"rockable-detail-modal\";a:18:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:8;a:2:{s:5:\"title\";s:7:\"Slide 9\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:9;a:2:{s:5:\"title\";s:8:\"Slide 10\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:10;a:2:{s:5:\"title\";s:8:\"Slide 11\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:11;a:2:{s:5:\"title\";s:8:\"Slide 12\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:12;a:2:{s:5:\"title\";s:8:\"Slide 13\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:13;a:2:{s:5:\"title\";s:8:\"Slide 14\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:14;a:2:{s:5:\"title\";s:8:\"Slide 15\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:15;a:2:{s:5:\"title\";s:8:\"Slide 16\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:16;a:2:{s:5:\"title\";s:8:\"Slide 17\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}i:17;a:2:{s:5:\"title\";s:8:\"Slide 18\";s:3:\"img\";s:32:\"rockable-detail-modal/slide1.jpg\";}}s:23:\"rockable-detail-modal-2\";a:18:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:8;a:2:{s:5:\"title\";s:7:\"Slide 9\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:9;a:2:{s:5:\"title\";s:8:\"Slide 10\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:10;a:2:{s:5:\"title\";s:8:\"Slide 11\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:11;a:2:{s:5:\"title\";s:8:\"Slide 12\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:12;a:2:{s:5:\"title\";s:8:\"Slide 13\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:13;a:2:{s:5:\"title\";s:8:\"Slide 14\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:14;a:2:{s:5:\"title\";s:8:\"Slide 15\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:15;a:2:{s:5:\"title\";s:8:\"Slide 16\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:16;a:2:{s:5:\"title\";s:8:\"Slide 17\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}i:17;a:2:{s:5:\"title\";s:8:\"Slide 18\";s:3:\"img\";s:34:\"rockable-detail-modal-2/slide1.jpg\";}}s:27:\"real-estate-showcase-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:38:\"Real-Estate-Showcase-Slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:38:\"Real-Estate-Showcase-Slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:38:\"Real-Estate-Showcase-Slider/slide3.jpg\";}}s:16:\"isometric-slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"isometric-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"isometric-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"isometric-slider/slide3.jpg\";}}s:17:\"E-Commerce-Slider\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"Shoes-Store-Slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"Shoes-Store-Slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"Shoes-Store-Slider/slide3.jpg\";}}s:23:\"E-Commerce-Slider-Modal\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:35:\"Shoes-Store-Slider-Modal/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:35:\"Shoes-Store-Slider-Modal/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:35:\"Shoes-Store-Slider-Modal/slide3.jpg\";}}s:27:\"Woo-Commerce-Slider-Dynamic\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:37:\"Shoes-Store-Slider-Dynamic/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:37:\"Shoes-Store-Slider-Dynamic/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:37:\"Shoes-Store-Slider-Dynamic/slide3.jpg\";}}s:15:\"blooming-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"blooming-header/slide1.jpg\";}}s:14:\"blooming-about\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"blooming-about/slide1.jpg\";}}s:18:\"blooming-portfolio\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"blooming-portfolio/slide1.jpg\";}}s:22:\"blooming-wedding-title\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"blooming-wedding-title/slide1.jpg\";}}s:25:\"blooming-wedding-carousel\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:36:\"blooming-wedding-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:36:\"blooming-wedding-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:36:\"blooming-wedding-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:36:\"blooming-wedding-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:36:\"blooming-wedding-carousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:36:\"blooming-wedding-carousel/slide6.jpg\";}}s:21:\"blooming-wedding-text\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"blooming-wedding-text/slide1.jpg\";}}s:22:\"blooming-parties-title\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"blooming-parties-title/slide1.jpg\";}}s:25:\"blooming-parties-carousel\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:36:\"blooming-parties-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:36:\"blooming-parties-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:36:\"blooming-parties-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:36:\"blooming-parties-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:36:\"blooming-parties-carousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:36:\"blooming-parties-carousel/slide6.jpg\";}}s:21:\"blooming-parties-text\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"blooming-parties-text/slide1.jpg\";}}s:22:\"blooming-funeral-title\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"blooming-funeral-title/slide1.jpg\";}}s:23:\"blooming-funeral-slider\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:34:\"blooming-funeral-slider/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:34:\"blooming-funeral-slider/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:34:\"blooming-funeral-slider/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:34:\"blooming-funeral-slider/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:34:\"blooming-funeral-slider/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:34:\"blooming-funeral-slider/slide6.jpg\";}}s:21:\"blooming-funeral-text\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"blooming-funeral-text/slide1.jpg\";}}s:16:\"blooming-contact\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"blooming-contact/slide1.jpg\";}}s:13:\"particle-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"particle-hero/slide1.jpg\";}}s:17:\"bubble-morph-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"bubble-morph-hero/slide1.jpg\";}}s:13:\"parallax-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"parallax-hero/slide1.jpg\";}}s:10:\"video-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"video-hero/slide1.jpg\";}}s:14:\"ken-burns-hero\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"ken-burns-hero/slide1.jpg\";}}s:21:\"basic-hero-collection\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:32:\"basic-hero-collection/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:32:\"basic-hero-collection/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:32:\"basic-hero-collection/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:32:\"basic-hero-collection/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:32:\"basic-hero-collection/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:32:\"basic-hero-collection/slide6.jpg\";}}s:19:\"launching-very-soon\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:30:\"launching-very-soon/slide1.jpg\";}}s:18:\"Under-Construction\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"Under-Construction/slide1.jpg\";}}s:15:\"Particle-Effect\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"Particle-Effect/slide1.jpg\";}}s:17:\"Particle-Effect-2\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:28:\"Particle-Effect-2/slide1.jpg\";}}s:10:\"stark-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"stark-menu/slide1.jpg\";}}s:12:\"stark-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"stark-header/slide1.jpg\";}}s:13:\"stark-content\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"stark-content/slide1.jpg\";}}s:14:\"stark-carousel\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:25:\"stark-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:25:\"stark-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:25:\"stark-carousel/slide3.jpg\";}}s:15:\"stark-portfolio\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"stark-portfolio/slide1.jpg\";}}s:22:\"stark-portfolio-detail\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:33:\"stark-portfolio-detail/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:33:\"stark-portfolio-detail/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:33:\"stark-portfolio-detail/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:33:\"stark-portfolio-detail/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:33:\"stark-portfolio-detail/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:33:\"stark-portfolio-detail/slide6.jpg\";}}s:13:\"stark-contact\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"stark-contact/slide1.jpg\";}}s:12:\"stark-footer\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"stark-footer/slide1.jpg\";}}s:16:\"stark-newsletter\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"stark-newsletter/slide1.jpg\";}}s:15:\"big-summer-sale\";a:3:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"big-summer-sale/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:26:\"big-summer-sale/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:26:\"big-summer-sale/slide3.jpg\";}}s:18:\"traveller-carousel\";a:6:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:29:\"traveller-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:29:\"traveller-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:29:\"traveller-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:29:\"traveller-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:29:\"traveller-carousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:29:\"traveller-carousel/slide6.jpg\";}}s:16:\"project-carousel\";a:7:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:27:\"project-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:27:\"project-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:27:\"project-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:27:\"project-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:27:\"project-carousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:27:\"project-carousel/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:27:\"project-carousel/slide7.jpg\";}}s:13:\"news-carousel\";a:8:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"news-carousel/slide1.jpg\";}i:1;a:2:{s:5:\"title\";s:7:\"Slide 2\";s:3:\"img\";s:24:\"news-carousel/slide2.jpg\";}i:2;a:2:{s:5:\"title\";s:7:\"Slide 3\";s:3:\"img\";s:24:\"news-carousel/slide3.jpg\";}i:3;a:2:{s:5:\"title\";s:7:\"Slide 4\";s:3:\"img\";s:24:\"news-carousel/slide4.jpg\";}i:4;a:2:{s:5:\"title\";s:7:\"Slide 5\";s:3:\"img\";s:24:\"news-carousel/slide5.jpg\";}i:5;a:2:{s:5:\"title\";s:7:\"Slide 6\";s:3:\"img\";s:24:\"news-carousel/slide6.jpg\";}i:6;a:2:{s:5:\"title\";s:7:\"Slide 7\";s:3:\"img\";s:24:\"news-carousel/slide7.jpg\";}i:7;a:2:{s:5:\"title\";s:7:\"Slide 8\";s:3:\"img\";s:24:\"news-carousel/slide8.jpg\";}}s:10:\"story-menu\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:21:\"story-menu/slide1.jpg\";}}s:12:\"story-header\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:23:\"story-header/slide1.jpg\";}}s:13:\"story-block-1\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"story-block-1/slide1.jpg\";}}s:15:\"story-content-1\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"story-content-1/slide1.jpg\";}}s:13:\"story-block-2\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"story-block-2/slide1.jpg\";}}s:13:\"story-block-3\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"story-block-3/slide1.jpg\";}}s:15:\"story-content-2\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"story-content-2/slide1.jpg\";}}s:13:\"story-block-4\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:24:\"story-block-4/slide1.jpg\";}}s:15:\"story-content-3\";a:1:{i:0;a:2:{s:5:\"title\";s:7:\"Slide 1\";s:3:\"img\";s:26:\"story-content-3/slide1.jpg\";}}}}', 'no');
INSERT INTO `wp8b_options` VALUES(695, '_cerber_notify_new', 'a:2:{i:0;s:3:\"8.6\";i:1;s:5:\"8.6.3\";}', 'no'),
 (1543, '_site_transient_timeout_cerber_hourly_2', '1597169432', 'no'),
 (1544, '_site_transient_cerber_hourly_2', 'a:2:{i:0;i:1597162232;i:1;i:1597162232;}', 'no'),
 (507, 'wordfence_ls_version', '1.0.5', 'yes'),
 (544, 'cerber-groove', 'lyihPoudpsYWzDwt', 'no'),
 (542, 'cerber_admin_info', '<h1>Highlights from WP Cerber Security 8.6.6</h1><ul><li>New: On the user sessions page, you can now search sessions by a user name, email, and the IP address from which a user has logged in.</li><li>New: You can specify locations (URL Paths) to exclude requests from logging. They can be either exact matches or regular expressions (REGEX).</li><li>New: You can exclude requests from logging based on the value of the User-Agent (UA) header.</li><li>New: A new, minimal logging mode. When it is set, only HTTP requests related to known activities are logged.</li><li>Improved: The layout of the Live Traffic log has been improved: now all events that are logged during a particular request are shown as an event list sorted in reverse order.</li><li>Improved: The user sessions page has been optimized for performance and compatibility and now works blazingly fast.</li><li>Improved: If your website is behind a proxy, IP addresses of user sessions now are detected more precisely.</li></ul><p style=\"margin-top: 18px; font-weight: bold;\"><span class=\"dashicons-before dashicons-info\"></span>  &nbsp; <a href=\"https://wpcerber.com/?plugin_version=8.6.6\" target=\"_blank\">Read more on wpcerber.com</a></p>  <h2 style=\"margin-top: 28px;\">Cerber needs your help</h2>\r\n                    <p style=\"margin-top: 20px;\">\r\n                    By sharing your unique opinion on WP Cerber, you will help the engineers behind the plugin make greater progress and help other professionals find the right software. You can leave your review on one of the following websites. No needs to use English. Feel free to use your native language. Thanks!\r\n                    </p>\r\n                    \r\n                    \r\n                    <p><a href=\"https://www.trustpilot.com/review/wpcerber.com\" target=\"_blank\">Trustpilot</a> &nbsp;/&nbsp; \r\n                    <a href=\"https://www.g2crowd.com/products/cerber-security-antispam-malware-scan/\" target=\"_blank\">G2.COM</a> &nbsp;/&nbsp; \r\n                    <a href=\"https://reviews.capterra.com/new/187653\" target=\"_blank\">Capterra</a></p>\r\n                    \r\n                    <!--<p><a href=\"https://www.trustpilot.com/review/wpcerber.com\" target=\"_blank\">Trustpilot</a></p>\r\n                    <p><a href=\"https://www.g2crowd.com/products/cerber-security-antispam-malware-scan/\" target=\"_blank\">G2.COM</a></p>\r\n                    <p><a href=\"https://reviews.capterra.com/new/187653\" target=\"_blank\">Capterra</a></p>\r\n                    -->\r\n	        <p style=\"text-align:right; padding-right: 20px;\">\r\n    		    <input type=\"button\" class=\"button button-primary cerber-dismiss\" value=\" &nbsp; ¡Impresionante! &nbsp; \"/></p>', 'no'),
 (543, '_cerber_up', 'a:2:{s:1:\"v\";s:5:\"8.6.6\";s:1:\"t\";i:1597070713;}', 'no'),
 (937, 'wordfence_lastSyncAttackData', '1588471029', 'no'),
 (645, 'revslider-additions', 'O:8:\"stdClass\":1:{s:7:\"selling\";b:0;}', 'yes'),
 (671, 'rs-templates-counter', '0', 'no'),
 (730, 'can_compress_scripts', '1', 'no'),
 (791, '_transient_health-check-site-status-result', '{\"good\":\"8\",\"recommended\":\"9\",\"critical\":\"0\"}', 'yes'),
 (1552, '_site_transient_timeout_kallyas_hg_dash_plugins', '1597246412', 'no'),
 (1553, '_site_transient_kallyas_hg_dash_plugins', 'a:39:{s:19:\"kallyas-child-theme\";a:13:{s:10:\"addon_type\";s:11:\"child_theme\";s:4:\"name\";s:19:\"Kallyas child theme\";s:4:\"slug\";s:19:\"kallyas-child-theme\";s:6:\"source\";s:17:\"kallyas-child.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.0\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/QbFCbR4.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:199:\"Always stay updated and safely customize Kallyas theme code, by applying custom hooks or overriding files. <a href=\"https://codex.wordpress.org/Child_Themes\" target=\"_blank\">More on Child Themes</a>.\";s:9:\"zn_plugin\";s:0:\"\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:9:\"revslider\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:17:\"Revolution Slider\";s:4:\"slug\";s:9:\"revslider\";s:6:\"source\";s:13:\"revslider.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:6:\"6.2.12\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/zlC8IqW.png\";s:15:\"z_plugin_author\";s:10:\"themepunch\";s:20:\"z_plugin_description\";s:140:\"Slider Revolution is not only for Sliders. You can now build a beautiful one-page web presence with absolutely no coding knowledge required.\";s:9:\"zn_plugin\";s:23:\"revslider/revslider.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:15:\"RevSliderSlider\";}s:11:\"woocommerce\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:11:\"WooCommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"2.5.5\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/uuF94OE.png\";s:15:\"z_plugin_author\";s:9:\"woothemes\";s:20:\"z_plugin_description\";s:248:\"WooCommerce is a free eCommerce plugin that allows you to sell anything, beautifully. Built to integrate seamlessly with WordPress, WooCommerce is the world\'s favorite eCommerce solution that gives both store owners and developers complete control.\";s:9:\"zn_plugin\";s:27:\"woocommerce/woocommerce.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:11:\"WooCommerce\";}s:7:\"bbpress\";a:13:{s:10:\"addon_type\";s:0:\"\";s:4:\"name\";s:7:\"BBpress\";s:4:\"slug\";s:7:\"bbpress\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"2.5.5\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/VjswO8O.png\";s:15:\"z_plugin_author\";s:9:\"WordPress\";s:20:\"z_plugin_description\";s:50:\"bbPress is forum software, made the WordPress way.\";s:9:\"zn_plugin\";s:19:\"bbpress/bbpress.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:7:\"booking\";a:13:{s:10:\"addon_type\";s:0:\"\";s:4:\"name\";s:16:\"Booking Calendar\";s:4:\"slug\";s:7:\"booking\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:3:\"6.2\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/9Z9j3lY.png\";s:15:\"z_plugin_author\";s:9:\"wpdevelop\";s:20:\"z_plugin_description\";s:128:\"Booking Calendar plugin - is the ultimate booking system for online reservation and availability checking service for your site.\";s:9:\"zn_plugin\";s:25:\"booking/wpdev-booking.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:16:\"hogash-post-love\";a:13:{s:10:\"addon_type\";s:0:\"\";s:4:\"name\";s:30:\"PostLove - Content like plugin\";s:4:\"slug\";s:16:\"hogash-post-love\";s:6:\"source\";s:20:\"hogash-post-love.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.0\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/VhswEdq.png\";s:15:\"z_plugin_author\";s:12:\"HogashStudio\";s:20:\"z_plugin_description\";s:145:\"Hogash Post Love brings article loving to your site. You users or visitors would be able to share their interest in your articles by loving them.\";s:9:\"zn_plugin\";s:37:\"hogash-post-love/hogash-post-love.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:10:\"CuteSlider\";a:13:{s:10:\"addon_type\";s:0:\"\";s:4:\"name\";s:11:\"Cute Slider\";s:4:\"slug\";s:10:\"CuteSlider\";s:6:\"source\";s:16:\"cutesliderwp.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:6:\"1.1.18\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/Of4CycQ.png\";s:15:\"z_plugin_author\";s:25:\"Averta and Kreatura Media\";s:20:\"z_plugin_description\";s:188:\"Cute Slider is a unique and easy to use slider with awesome 3D and 2D transition effects, captions, 4 ready to use templates, video (youtube and vimeo) support and more impressive features\";s:9:\"zn_plugin\";s:25:\"CuteSlider/cuteslider.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:183:\"This plugin is no longer maintained by its developers. Please be aware that problems may appear when using it. We strongly recommend using an alternative slider provided by the theme.\";}s:11:\"is_callable\";s:0:\"\";}s:17:\"event-calendar-wd\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:17:\"Calendar Event WD\";s:4:\"slug\";s:17:\"event-calendar-wd\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:6:\"1.1.15\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/0gv4KmJ.png\";s:15:\"z_plugin_author\";s:9:\"webdorado\";s:20:\"z_plugin_description\";s:84:\"Organize and publish your events in an easy and elegant way using Event Calendar WD.\";s:9:\"zn_plugin\";s:26:\"event-calendar-wd/ecwd.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:20:\"znpb-counter-element\";a:13:{s:10:\"addon_type\";s:10:\"pb_element\";s:4:\"name\";s:20:\"ZNPB Counter Element\";s:4:\"slug\";s:20:\"znpb-counter-element\";s:6:\"source\";s:24:\"znpb-counter-element.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.2\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/8wunBWG.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:100:\"Adds a counter element into the page builder. The element will generate an animating counter number.\";s:9:\"zn_plugin\";s:45:\"znpb-counter-element/znpb-counter-element.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:12:\"znpb-flipbox\";a:13:{s:10:\"addon_type\";s:10:\"pb_element\";s:4:\"name\";s:20:\"ZNPB FlipBox Element\";s:4:\"slug\";s:12:\"znpb-flipbox\";s:6:\"source\";s:16:\"znpb-flipbox.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.8\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/WqYhTnT.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:95:\"This element will generate an animated flipping box, which accepts custom page builder content.\";s:9:\"zn_plugin\";s:29:\"znpb-flipbox/znpb-flipbox.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:17:\"wd-instagram-feed\";a:13:{s:10:\"addon_type\";s:0:\"\";s:4:\"name\";s:17:\"Instagram Feed WD\";s:4:\"slug\";s:17:\"wd-instagram-feed\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:6:\"1.1.27\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/yG8oYPo.png\";s:15:\"z_plugin_author\";s:9:\"webdorado\";s:20:\"z_plugin_description\";s:129:\"Instagram Feed WD plugin is a user-friendly tool for displaying user or hashtag-based feeds on your website with only few clicks.\";s:9:\"zn_plugin\";s:39:\"wd-instagram-feed/wd-instagram-feed.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:42:\"bookly-responsive-appointment-booking-tool\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:11:\"Bookly Lite\";s:4:\"slug\";s:42:\"bookly-responsive-appointment-booking-tool\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:6:\"14.5.1\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/uZpo5Ym.png\";s:15:\"z_plugin_author\";s:6:\"Ladela\";s:20:\"z_plugin_description\";s:110:\"Bookly is a easy-to-use and easy-to-manage booking tool for Service providers who think about their customers.\";s:9:\"zn_plugin\";s:51:\"bookly-responsive-appointment-booking-tool/main.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:12:\"mp-timetable\";a:13:{s:10:\"addon_type\";s:0:\"\";s:4:\"name\";s:22:\"Timetable by MotoPress\";s:4:\"slug\";s:12:\"mp-timetable\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"2.0.4\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/cr8EkFh.png\";s:15:\"z_plugin_author\";s:9:\"MotoPress\";s:20:\"z_plugin_description\";s:162:\"MotoPress Timetable and Event Schedule is an all-around organizer plugin developed to help you create and manage online schedules for a single or multiple events.\";s:9:\"zn_plugin\";s:29:\"mp-timetable/mp-timetable.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:25:\"kallyas-addon-side-header\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:27:\"Side Header - Kallyas Addon\";s:4:\"slug\";s:25:\"kallyas-addon-side-header\";s:6:\"source\";s:29:\"kallyas-addon-side-header.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.4.0\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/YPD7bpq.png\";s:15:\"z_plugin_author\";s:12:\"HogashStudio\";s:20:\"z_plugin_description\";s:165:\"This plugin will replace the default Kallyas theme header with a side block containing components such as logo image, main navigation, search form, social icons etc.\";s:9:\"zn_plugin\";s:55:\"kallyas-addon-side-header/kallyas-addon-side-header.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:25:\"kallyas-addon-nav-overlay\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:34:\"Navigation Overlay - Kallyas Addon\";s:4:\"slug\";s:25:\"kallyas-addon-nav-overlay\";s:6:\"source\";s:29:\"kallyas-addon-nav-overlay.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:6:\"1.0.12\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/OST9rF6.png\";s:15:\"z_plugin_author\";s:12:\"HogashStudio\";s:20:\"z_plugin_description\";s:136:\"This plugin will replace the default Kallyas theme side panel navigation with an overlay panel. Can be used on desktop viewport as well.\";s:9:\"zn_plugin\";s:55:\"kallyas-addon-nav-overlay/kallyas-addon-nav-overlay.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:21:\"animated-text-element\";a:13:{s:10:\"addon_type\";s:10:\"pb_element\";s:4:\"name\";s:21:\"Animated Text Element\";s:4:\"slug\";s:21:\"animated-text-element\";s:6:\"source\";s:25:\"animated-text-element.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.0\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/mwDERYw.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:57:\"This element will display a text with a typing animation.\";s:9:\"zn_plugin\";s:47:\"animated-text-element/animated-text-element.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:12:\"znpb-tiltbox\";a:13:{s:10:\"addon_type\";s:10:\"pb_element\";s:4:\"name\";s:15:\"TiltBox Element\";s:4:\"slug\";s:12:\"znpb-tiltbox\";s:6:\"source\";s:16:\"znpb-tiltbox.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.2\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/RYazF16.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:102:\"This element will add a box containing texts and an image, which will be animated upon mouse hovering.\";s:9:\"zn_plugin\";s:29:\"znpb-tiltbox/znpb-tiltbox.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:18:\"znpb-posts-layouts\";a:13:{s:10:\"addon_type\";s:10:\"pb_element\";s:4:\"name\";s:26:\"Blog-Posts Layouts Element\";s:4:\"slug\";s:18:\"znpb-posts-layouts\";s:6:\"source\";s:22:\"znpb-posts-layouts.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.1.5\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/BJQ7Uhs.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:68:\"This page builder plugin will display various layouts of blog posts.\";s:9:\"zn_plugin\";s:41:\"znpb-posts-layouts/znpb-posts-layouts.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:14:\"nav-menu-roles\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:14:\"Nav Menu Roles\";s:4:\"slug\";s:14:\"nav-menu-roles\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"1.8.6\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:56:\"https://kallyas.net/images/plugin-img/nav-user-roles.png\";s:15:\"z_plugin_author\";s:14:\"helgatheviking\";s:20:\"z_plugin_description\";s:44:\"Hide custom menu items based on user roles. \";s:9:\"zn_plugin\";s:33:\"nav-menu-roles/nav-menu-roles.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:20:\"paid-memberships-pro\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:20:\"Paid Memberships Pro\";s:4:\"slug\";s:20:\"paid-memberships-pro\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:8:\"1.8.13.6\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:61:\"https://kallyas.net/images/plugin-img/paid-membershio-pro.png\";s:15:\"z_plugin_author\";s:13:\"Jason Coleman\";s:20:\"z_plugin_description\";s:132:\"A revenue-generating machine for membership sites. Unlimited levels with recurring payment, protected content and member management.\";s:9:\"zn_plugin\";s:45:\"paid-memberships-pro/paid-memberships-pro.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:17:\"pmpro-woocommerce\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:41:\"Paid Memberships Pro - WooCommerce Add On\";s:4:\"slug\";s:17:\"pmpro-woocommerce\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:3:\"1.4\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:64:\"https://kallyas.net/images/plugin-img/paid-membershio-pro-wc.png\";s:15:\"z_plugin_author\";s:22:\"Jason Coleman, Messica\";s:20:\"z_plugin_description\";s:49:\"Integrates Paid Memberships Pro with WooCommerce.\";s:9:\"zn_plugin\";s:39:\"pmpro-woocommerce/pmpro-woocommerce.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:14:\"instashow-lite\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:22:\"Instagram Feed Gallery\";s:4:\"slug\";s:14:\"instashow-lite\";s:6:\"source\";s:18:\"instashow-lite.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.4.2\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:51:\"https://kallyas.net/images/plugin-img/instashow.png\";s:15:\"z_plugin_author\";s:8:\"Elfsight\";s:20:\"z_plugin_description\";s:53:\"Allows setting up gorgeous grids of Instagram photos.\";s:9:\"zn_plugin\";s:33:\"instashow-lite/instashow-lite.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:16:\"wp-hotel-booking\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:16:\"WP Hotel Booking\";s:4:\"slug\";s:16:\"wp-hotel-booking\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:7:\"1.7.6.4\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:58:\"https://kallyas.net/images/plugin-img/wp-hotel-booking.png\";s:15:\"z_plugin_author\";s:9:\"ThimPress\";s:20:\"z_plugin_description\";s:46:\"A complete hotel booking plugin for WordPress.\";s:9:\"zn_plugin\";s:37:\"wp-hotel-booking/wp-hotel-booking.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:16:\"znpb-breadcrumbs\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:16:\"ZNPB Breadcrumbs\";s:4:\"slug\";s:16:\"znpb-breadcrumbs\";s:6:\"source\";s:20:\"znpb-breadcrumbs.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.0\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/ZKTpj9d.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:50:\"Simple way of displaying breadcrumbs in your page.\";s:9:\"zn_plugin\";s:37:\"znpb-breadcrumbs/znpb-breadcrumbs.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:16:\"hogash-mailchimp\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:16:\"Hogash Mailchimp\";s:4:\"slug\";s:16:\"hogash-mailchimp\";s:6:\"source\";s:20:\"hogash-mailchimp.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.4\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:30:\"http://i.imgur.com/V4A2Rat.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:68:\"A plugin that will add Mailchimp functionality to all Hogash themes.\";s:9:\"zn_plugin\";s:37:\"hogash-mailchimp/hogash-mailchimp.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:19:\"hg-before-and-after\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:22:\"Before & After element\";s:4:\"slug\";s:19:\"hg-before-and-after\";s:6:\"source\";s:23:\"hg-before-and-after.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.0.0\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:25:\"//i.imgur.com/VClE1Ad.png\";s:15:\"z_plugin_author\";s:13:\"Hogash Studio\";s:20:\"z_plugin_description\";s:151:\"This plugin will add a before and after element. It will allow you to present two images with a bar that the user can drag to reveal the image bellow .\";s:9:\"zn_plugin\";s:43:\"hg-before-and-after/hg-before-and-after.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:14:\"wp-car-manager\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:14:\"WP Car Manager\";s:4:\"slug\";s:14:\"wp-car-manager\";s:6:\"source\";s:18:\"wp-car-manager.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"1.4.1\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:56:\"https://kallyas.net/images/plugin-img/wp-car-manager.png\";s:15:\"z_plugin_author\";s:6:\"Never5\";s:20:\"z_plugin_description\";s:90:\"WP Car Manager allows you to manage and list your cars from within your WordPress website!\";s:9:\"zn_plugin\";s:33:\"wp-car-manager/wp-car-manager.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:20:\"wp-notification-bars\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:20:\"WP Notification Bars\";s:4:\"slug\";s:20:\"wp-notification-bars\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"1.0.1\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:28:\"http://imgur.com/jGhk0RA.png\";s:15:\"z_plugin_author\";s:11:\"MyThemeShop\";s:20:\"z_plugin_description\";s:190:\"WP Notification Bars is a custom notification and alert bar plugin for WordPress which is perfect for marketing promotions, alerts, increasing click throughs to other pages and so much more.\";s:9:\"zn_plugin\";s:45:\"wp-notification-bars/wp-notification-bars.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:12:\"powies-whois\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:26:\"Powie\'s WHOIS Domain Check\";s:4:\"slug\";s:12:\"powies-whois\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:6:\"0.9.26\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:55:\"https://kallyas.net/images/plugin-img/hosting-check.png\";s:15:\"z_plugin_author\";s:15:\"Thomas Ehrhardt\";s:20:\"z_plugin_description\";s:44:\"Checks Domain WHOIS Lookup for availability.\";s:9:\"zn_plugin\";s:29:\"powies-whois/powies-whois.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:23:\"yith-infinite-scrolling\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:23:\"YITH Infinite Scrolling\";s:4:\"slug\";s:23:\"yith-infinite-scrolling\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"1.0.9\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:64:\"https://ps.w.org/yith-infinite-scrolling/assets/icon-128x128.jpg\";s:15:\"z_plugin_author\";s:8:\"YITHEMES\";s:20:\"z_plugin_description\";s:293:\"People have become used to see contents online in a sequential way: think about Facebook or Twitter, two navigation systems that now influence how we browse the web. With YITH Infinite Scrolling, we have decided to apply this idea for an immediate and direct consultation of the page contents!\";s:9:\"zn_plugin\";s:32:\"yith-infinite-scrolling/init.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:16:\"post-types-order\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:16:\"Post Types Order\";s:4:\"slug\";s:16:\"post-types-order\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:7:\"1.9.3.9\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:69:\"https://ps.w.org/post-types-order/assets/icon-128x128.png?rev=1226428\";s:15:\"z_plugin_author\";s:8:\"Nsp Code\";s:20:\"z_plugin_description\";s:107:\"A powerful plugin, Order Posts and Post Types Objects using a Drag and Drop Sortable JavaScript capability.\";s:9:\"zn_plugin\";s:37:\"post-types-order/post-types-order.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:22:\"woo-variation-swatches\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:30:\"WooCommerce Variation Swatches\";s:4:\"slug\";s:22:\"woo-variation-swatches\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:6:\"1.0.44\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:59:\"https://kallyas.net/images/plugin-img/variationswatches.png\";s:15:\"z_plugin_author\";s:11:\"Emran Ahmed\";s:20:\"z_plugin_description\";s:88:\"Beautiful Color, Image and Buttons Variation Swatches For WooCommerce Product Attributes\";s:9:\"zn_plugin\";s:49:\"woo-variation-swatches/woo-variation-swatches.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:15:\"woo-lucky-wheel\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:43:\"WooCommerce Lucky Wheel &ndash; Spin a Sale\";s:4:\"slug\";s:15:\"woo-lucky-wheel\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:7:\"1.0.4.3\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:72:\"https://kallyas.net/images/plugin-img/lucky-wheel-woocommerce-plugin.png\";s:15:\"z_plugin_author\";s:10:\"VillaTheme\";s:20:\"z_plugin_description\";s:93:\"Collect emails from customers who visit your store by giving them a chance to win a discount.\";s:9:\"zn_plugin\";s:35:\"woo-lucky-wheel/woo-lucky-wheel.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:24:\"countdown-timer-ultimate\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:24:\"Countdown Timer Ultimate\";s:4:\"slug\";s:24:\"countdown-timer-ultimate\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"1.1.5\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:56:\"https://kallyas.net/images/plugin-img/counter-plugin.png\";s:15:\"z_plugin_author\";s:17:\"WP Online Support\";s:20:\"z_plugin_description\";s:61:\"A very simple plugin to add countdown timer to your website. \";s:9:\"zn_plugin\";s:44:\"countdown-timer-ultimate/countdown-timer.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:6:\"leadin\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:28:\"HubSpot All-In-One Marketing\";s:4:\"slug\";s:6:\"leadin\";s:6:\"source\";s:10:\"leadin.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:5:\"7.5.0\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:62:\"https://my.hogash.com/wp-content/uploads/2019/05/hubspot-1.png\";s:15:\"z_plugin_author\";s:7:\"HubSpot\";s:20:\"z_plugin_description\";s:215:\"HubSpot All-In-One Marketing is the ultimate free marketing plugin for WordPress if you want to grow your email list, generate leads, and manage all your contacts inside HubSpot&amp;amp;amp;amp;amp;rsquo;s free CRM.\";s:9:\"zn_plugin\";s:17:\"leadin/leadin.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:14:\"instagram-feed\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:31:\"Smash Balloon Social Photo Feed\";s:4:\"slug\";s:14:\"instagram-feed\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:5:\"2.3.1\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:55:\"https://kallyas.net/images/plugin-img/instashowlite.png\";s:15:\"z_plugin_author\";s:13:\"Smash Balloon\";s:20:\"z_plugin_description\";s:115:\"Display Instagram posts from your Instagram accounts, either in the same single feed or in multiple different ones.\";s:9:\"zn_plugin\";s:33:\"instagram-feed/instagram-feed.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:23:\"ti-woocommerce-wishlist\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:30:\"TI WooCommerce Wishlist Plugin\";s:4:\"slug\";s:23:\"ti-woocommerce-wishlist\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:6:\"1.17.1\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:56:\"https://kallyas.net/images/plugin-img/ti-wc-wishlist.png\";s:15:\"z_plugin_author\";s:16:\"TemplateInvaders\";s:20:\"z_plugin_description\";s:120:\"WooCommerce Wishlist is a simple but powerful tool that can help you to convert your site visitors into loyal customers.\";s:9:\"zn_plugin\";s:51:\"ti-woocommerce-wishlist/ti-woocommerce-wishlist.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:35:\"zakeke-interactive-product-designer\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:51:\"Zakeke Interactive Product Designer for WooCommerce\";s:4:\"slug\";s:35:\"zakeke-interactive-product-designer\";s:6:\"source\";s:0:\"\";s:11:\"source_type\";s:4:\"repo\";s:7:\"version\";s:6:\"2.0.13\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:48:\"https://kallyas.net/images/plugin-img/zakeke.jpg\";s:15:\"z_plugin_author\";s:6:\"Zakeke\";s:20:\"z_plugin_description\";s:87:\"Print On Demand Plugin. Customers can see their fully customized product before buying.\";s:9:\"zn_plugin\";s:46:\"zakeke-interactive-product-designer/zakeke.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}s:20:\"wp-hotel-booking-new\";a:13:{s:10:\"addon_type\";s:2:\"-1\";s:4:\"name\";s:20:\"WP Hotel Booking new\";s:4:\"slug\";s:20:\"wp-hotel-booking-new\";s:6:\"source\";s:24:\"wp-hotel-booking-new.zip\";s:11:\"source_type\";s:8:\"internal\";s:7:\"version\";s:7:\"1.7.6.4\";s:7:\"private\";s:1:\"0\";s:13:\"z_plugin_icon\";s:58:\"https://kallyas.net/images/plugin-img/wp-hotel-booking.png\";s:15:\"z_plugin_author\";s:9:\"ThimPress\";s:20:\"z_plugin_description\";s:46:\"A complete hotel booking plugin for WordPress.\";s:9:\"zn_plugin\";s:41:\"wp-hotel-booking-new/wp-hotel-booking.php\";s:10:\"deprecated\";a:1:{s:7:\"message\";s:0:\"\";}s:11:\"is_callable\";s:0:\"\";}}', 'no'),
 (1491, '_transient_timeout_zn_google_fonts_cache', '1597502518', 'no'),
 (1492, '_transient_zn_google_fonts_cache', 'a:999:{s:7:\"ABeeZee\";a:3:{s:6:\"family\";s:7:\"ABeeZee\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Abel\";a:3:{s:6:\"family\";s:4:\"Abel\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Abhaya Libre\";a:3:{s:6:\"family\";s:12:\"Abhaya Libre\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:7:\"sinhala\";}}s:13:\"Abril Fatface\";a:3:{s:6:\"family\";s:13:\"Abril Fatface\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Aclonica\";a:3:{s:6:\"family\";s:8:\"Aclonica\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Acme\";a:3:{s:6:\"family\";s:4:\"Acme\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Actor\";a:3:{s:6:\"family\";s:5:\"Actor\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Adamina\";a:3:{s:6:\"family\";s:7:\"Adamina\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Advent Pro\";a:3:{s:6:\"family\";s:10:\"Advent Pro\";s:8:\"variants\";a:7:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"greek\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:15:\"Aguafina Script\";a:3:{s:6:\"family\";s:15:\"Aguafina Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Akronim\";a:3:{s:6:\"family\";s:7:\"Akronim\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Aladin\";a:3:{s:6:\"family\";s:6:\"Aladin\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Alata\";a:3:{s:6:\"family\";s:5:\"Alata\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:6:\"Alatsi\";a:3:{s:6:\"family\";s:6:\"Alatsi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"Aldrich\";a:3:{s:6:\"family\";s:7:\"Aldrich\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Alef\";a:3:{s:6:\"family\";s:4:\"Alef\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";}}s:8:\"Alegreya\";a:3:{s:6:\"family\";s:8:\"Alegreya\";s:8:\"variants\";a:10:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";i:6;s:3:\"800\";i:7;s:9:\"800italic\";i:8;s:3:\"900\";i:9;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:11:\"Alegreya SC\";a:3:{s:6:\"family\";s:11:\"Alegreya SC\";s:8:\"variants\";a:10:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";i:6;s:3:\"800\";i:7;s:9:\"800italic\";i:8;s:3:\"900\";i:9;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:13:\"Alegreya Sans\";a:3:{s:6:\"family\";s:13:\"Alegreya Sans\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"800\";i:11;s:9:\"800italic\";i:12;s:3:\"900\";i:13;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:16:\"Alegreya Sans SC\";a:3:{s:6:\"family\";s:16:\"Alegreya Sans SC\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"800\";i:11;s:9:\"800italic\";i:12;s:3:\"900\";i:13;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:4:\"Aleo\";a:3:{s:6:\"family\";s:4:\"Aleo\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Alex Brush\";a:3:{s:6:\"family\";s:10:\"Alex Brush\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Alfa Slab One\";a:3:{s:6:\"family\";s:13:\"Alfa Slab One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:5:\"Alice\";a:3:{s:6:\"family\";s:5:\"Alice\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";}}s:5:\"Alike\";a:3:{s:6:\"family\";s:5:\"Alike\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Alike Angular\";a:3:{s:6:\"family\";s:13:\"Alike Angular\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Allan\";a:3:{s:6:\"family\";s:5:\"Allan\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Allerta\";a:3:{s:6:\"family\";s:7:\"Allerta\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Allerta Stencil\";a:3:{s:6:\"family\";s:15:\"Allerta Stencil\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Allura\";a:3:{s:6:\"family\";s:6:\"Allura\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Almarai\";a:3:{s:6:\"family\";s:7:\"Almarai\";s:8:\"variants\";a:4:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";i:3;s:3:\"800\";}s:7:\"subsets\";a:1:{i:0;s:6:\"arabic\";}}s:8:\"Almendra\";a:3:{s:6:\"family\";s:8:\"Almendra\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"Almendra Display\";a:3:{s:6:\"family\";s:16:\"Almendra Display\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Almendra SC\";a:3:{s:6:\"family\";s:11:\"Almendra SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Amarante\";a:3:{s:6:\"family\";s:8:\"Amarante\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Amaranth\";a:3:{s:6:\"family\";s:8:\"Amaranth\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Amatic SC\";a:3:{s:6:\"family\";s:9:\"Amatic SC\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:6:\"hebrew\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:9:\"Amethysta\";a:3:{s:6:\"family\";s:9:\"Amethysta\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Amiko\";a:3:{s:6:\"family\";s:5:\"Amiko\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"600\";i:2;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Amiri\";a:3:{s:6:\"family\";s:5:\"Amiri\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Amita\";a:3:{s:6:\"family\";s:5:\"Amita\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Anaheim\";a:3:{s:6:\"family\";s:7:\"Anaheim\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Andada\";a:3:{s:6:\"family\";s:6:\"Andada\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Andika\";a:3:{s:6:\"family\";s:6:\"Andika\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:6:\"Angkor\";a:3:{s:6:\"family\";s:6:\"Angkor\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:24:\"Annie Use Your Telescope\";a:3:{s:6:\"family\";s:24:\"Annie Use Your Telescope\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Anonymous Pro\";a:3:{s:6:\"family\";s:13:\"Anonymous Pro\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"greek\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:5:\"Antic\";a:3:{s:6:\"family\";s:5:\"Antic\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Antic Didone\";a:3:{s:6:\"family\";s:12:\"Antic Didone\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Antic Slab\";a:3:{s:6:\"family\";s:10:\"Antic Slab\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Anton\";a:3:{s:6:\"family\";s:5:\"Anton\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:6:\"Arapey\";a:3:{s:6:\"family\";s:6:\"Arapey\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Arbutus\";a:3:{s:6:\"family\";s:7:\"Arbutus\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Arbutus Slab\";a:3:{s:6:\"family\";s:12:\"Arbutus Slab\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:19:\"Architects Daughter\";a:3:{s:6:\"family\";s:19:\"Architects Daughter\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Archivo\";a:3:{s:6:\"family\";s:7:\"Archivo\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:13:\"Archivo Black\";a:3:{s:6:\"family\";s:13:\"Archivo Black\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Archivo Narrow\";a:3:{s:6:\"family\";s:14:\"Archivo Narrow\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:10:\"Aref Ruqaa\";a:3:{s:6:\"family\";s:10:\"Aref Ruqaa\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";}}s:13:\"Arima Madurai\";a:3:{s:6:\"family\";s:13:\"Arima Madurai\";s:8:\"variants\";a:8:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"700\";i:6;s:3:\"800\";i:7;s:3:\"900\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";i:3;s:10:\"vietnamese\";}}s:5:\"Arimo\";a:3:{s:6:\"family\";s:5:\"Arimo\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:8:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:6:\"hebrew\";i:5;s:5:\"latin\";i:6;s:9:\"latin-ext\";i:7;s:10:\"vietnamese\";}}s:8:\"Arizonia\";a:3:{s:6:\"family\";s:8:\"Arizonia\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Armata\";a:3:{s:6:\"family\";s:6:\"Armata\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Arsenal\";a:3:{s:6:\"family\";s:7:\"Arsenal\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:8:\"Artifika\";a:3:{s:6:\"family\";s:8:\"Artifika\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Arvo\";a:3:{s:6:\"family\";s:4:\"Arvo\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Arya\";a:3:{s:6:\"family\";s:4:\"Arya\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:4:\"Asap\";a:3:{s:6:\"family\";s:4:\"Asap\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:14:\"Asap Condensed\";a:3:{s:6:\"family\";s:14:\"Asap Condensed\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:4:\"Asar\";a:3:{s:6:\"family\";s:4:\"Asar\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Asset\";a:3:{s:6:\"family\";s:5:\"Asset\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Assistant\";a:3:{s:6:\"family\";s:9:\"Assistant\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";}}s:7:\"Astloch\";a:3:{s:6:\"family\";s:7:\"Astloch\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Asul\";a:3:{s:6:\"family\";s:4:\"Asul\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Athiti\";a:3:{s:6:\"family\";s:6:\"Athiti\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:4:\"Atma\";a:3:{s:6:\"family\";s:4:\"Atma\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:7:\"bengali\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:10:\"Atomic Age\";a:3:{s:6:\"family\";s:10:\"Atomic Age\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Aubrey\";a:3:{s:6:\"family\";s:6:\"Aubrey\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Audiowide\";a:3:{s:6:\"family\";s:9:\"Audiowide\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Autour One\";a:3:{s:6:\"family\";s:10:\"Autour One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Average\";a:3:{s:6:\"family\";s:7:\"Average\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Average Sans\";a:3:{s:6:\"family\";s:12:\"Average Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:19:\"Averia Gruesa Libre\";a:3:{s:6:\"family\";s:19:\"Averia Gruesa Libre\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Averia Libre\";a:3:{s:6:\"family\";s:12:\"Averia Libre\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:17:\"Averia Sans Libre\";a:3:{s:6:\"family\";s:17:\"Averia Sans Libre\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:18:\"Averia Serif Libre\";a:3:{s:6:\"family\";s:18:\"Averia Serif Libre\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"B612\";a:3:{s:6:\"family\";s:4:\"B612\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"B612 Mono\";a:3:{s:6:\"family\";s:9:\"B612 Mono\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Bad Script\";a:3:{s:6:\"family\";s:10:\"Bad Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";}}s:7:\"Bahiana\";a:3:{s:6:\"family\";s:7:\"Bahiana\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Bahianita\";a:3:{s:6:\"family\";s:9:\"Bahianita\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:12:\"Bai Jamjuree\";a:3:{s:6:\"family\";s:12:\"Bai Jamjuree\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:7:\"Baloo 2\";a:3:{s:6:\"family\";s:7:\"Baloo 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:12:\"Baloo Bhai 2\";a:3:{s:6:\"family\";s:12:\"Baloo Bhai 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:14:\"Baloo Bhaina 2\";a:3:{s:6:\"family\";s:14:\"Baloo Bhaina 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"oriya\";i:3;s:10:\"vietnamese\";}}s:15:\"Baloo Chettan 2\";a:3:{s:6:\"family\";s:15:\"Baloo Chettan 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:9:\"malayalam\";i:3;s:10:\"vietnamese\";}}s:10:\"Baloo Da 2\";a:3:{s:6:\"family\";s:10:\"Baloo Da 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:7:\"bengali\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:13:\"Baloo Paaji 2\";a:3:{s:6:\"family\";s:13:\"Baloo Paaji 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:8:\"gurmukhi\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:13:\"Baloo Tamma 2\";a:3:{s:6:\"family\";s:13:\"Baloo Tamma 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:7:\"kannada\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:15:\"Baloo Tammudu 2\";a:3:{s:6:\"family\";s:15:\"Baloo Tammudu 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:6:\"telugu\";i:3;s:10:\"vietnamese\";}}s:14:\"Baloo Thambi 2\";a:3:{s:6:\"family\";s:14:\"Baloo Thambi 2\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";i:3;s:10:\"vietnamese\";}}s:13:\"Balsamiq Sans\";a:3:{s:6:\"family\";s:13:\"Balsamiq Sans\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:9:\"Balthazar\";a:3:{s:6:\"family\";s:9:\"Balthazar\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Bangers\";a:3:{s:6:\"family\";s:7:\"Bangers\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:6:\"Barlow\";a:3:{s:6:\"family\";s:6:\"Barlow\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:16:\"Barlow Condensed\";a:3:{s:6:\"family\";s:16:\"Barlow Condensed\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:21:\"Barlow Semi Condensed\";a:3:{s:6:\"family\";s:21:\"Barlow Semi Condensed\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:10:\"Barriecito\";a:3:{s:6:\"family\";s:10:\"Barriecito\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:6:\"Barrio\";a:3:{s:6:\"family\";s:6:\"Barrio\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Basic\";a:3:{s:6:\"family\";s:5:\"Basic\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Baskervville\";a:3:{s:6:\"family\";s:12:\"Baskervville\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Battambang\";a:3:{s:6:\"family\";s:10:\"Battambang\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:7:\"Baumans\";a:3:{s:6:\"family\";s:7:\"Baumans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Bayon\";a:3:{s:6:\"family\";s:5:\"Bayon\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:10:\"Be Vietnam\";a:3:{s:6:\"family\";s:10:\"Be Vietnam\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";i:12;s:3:\"800\";i:13;s:9:\"800italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:10:\"Bebas Neue\";a:3:{s:6:\"family\";s:10:\"Bebas Neue\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Belgrano\";a:3:{s:6:\"family\";s:8:\"Belgrano\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Bellefair\";a:3:{s:6:\"family\";s:9:\"Bellefair\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Belleza\";a:3:{s:6:\"family\";s:7:\"Belleza\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Bellota\";a:3:{s:6:\"family\";s:7:\"Bellota\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:12:\"Bellota Text\";a:3:{s:6:\"family\";s:12:\"Bellota Text\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:9:\"BenchNine\";a:3:{s:6:\"family\";s:9:\"BenchNine\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Bentham\";a:3:{s:6:\"family\";s:7:\"Bentham\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Berkshire Swash\";a:3:{s:6:\"family\";s:15:\"Berkshire Swash\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Beth Ellen\";a:3:{s:6:\"family\";s:10:\"Beth Ellen\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Bevan\";a:3:{s:6:\"family\";s:5:\"Bevan\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:21:\"Big Shoulders Display\";a:3:{s:6:\"family\";s:21:\"Big Shoulders Display\";s:8:\"variants\";a:8:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";i:7;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:18:\"Big Shoulders Text\";a:3:{s:6:\"family\";s:18:\"Big Shoulders Text\";s:8:\"variants\";a:8:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";i:7;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:13:\"Bigelow Rules\";a:3:{s:6:\"family\";s:13:\"Bigelow Rules\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Bigshot One\";a:3:{s:6:\"family\";s:11:\"Bigshot One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Bilbo\";a:3:{s:6:\"family\";s:5:\"Bilbo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"Bilbo Swash Caps\";a:3:{s:6:\"family\";s:16:\"Bilbo Swash Caps\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"BioRhyme\";a:3:{s:6:\"family\";s:8:\"BioRhyme\";s:8:\"variants\";a:5:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:17:\"BioRhyme Expanded\";a:3:{s:6:\"family\";s:17:\"BioRhyme Expanded\";s:8:\"variants\";a:5:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Biryani\";a:3:{s:6:\"family\";s:7:\"Biryani\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Bitter\";a:3:{s:6:\"family\";s:6:\"Bitter\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:23:\"Black And White Picture\";a:3:{s:6:\"family\";s:23:\"Black And White Picture\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:14:\"Black Han Sans\";a:3:{s:6:\"family\";s:14:\"Black Han Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:13:\"Black Ops One\";a:3:{s:6:\"family\";s:13:\"Black Ops One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Blinker\";a:3:{s:6:\"family\";s:7:\"Blinker\";s:8:\"variants\";a:8:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";i:7;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Bokor\";a:3:{s:6:\"family\";s:5:\"Bokor\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:6:\"Bonbon\";a:3:{s:6:\"family\";s:6:\"Bonbon\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Boogaloo\";a:3:{s:6:\"family\";s:8:\"Boogaloo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Bowlby One\";a:3:{s:6:\"family\";s:10:\"Bowlby One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Bowlby One SC\";a:3:{s:6:\"family\";s:13:\"Bowlby One SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Brawler\";a:3:{s:6:\"family\";s:7:\"Brawler\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Bree Serif\";a:3:{s:6:\"family\";s:10:\"Bree Serif\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Bubblegum Sans\";a:3:{s:6:\"family\";s:14:\"Bubblegum Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Bubbler One\";a:3:{s:6:\"family\";s:11:\"Bubbler One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Buda\";a:3:{s:6:\"family\";s:4:\"Buda\";s:8:\"variants\";a:1:{i:0;s:3:\"300\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Buenard\";a:3:{s:6:\"family\";s:7:\"Buenard\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Bungee\";a:3:{s:6:\"family\";s:6:\"Bungee\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:15:\"Bungee Hairline\";a:3:{s:6:\"family\";s:15:\"Bungee Hairline\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:13:\"Bungee Inline\";a:3:{s:6:\"family\";s:13:\"Bungee Inline\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:14:\"Bungee Outline\";a:3:{s:6:\"family\";s:14:\"Bungee Outline\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:12:\"Bungee Shade\";a:3:{s:6:\"family\";s:12:\"Bungee Shade\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:10:\"Butcherman\";a:3:{s:6:\"family\";s:10:\"Butcherman\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Butterfly Kids\";a:3:{s:6:\"family\";s:14:\"Butterfly Kids\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Cabin\";a:3:{s:6:\"family\";s:5:\"Cabin\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:15:\"Cabin Condensed\";a:3:{s:6:\"family\";s:15:\"Cabin Condensed\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:12:\"Cabin Sketch\";a:3:{s:6:\"family\";s:12:\"Cabin Sketch\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Caesar Dressing\";a:3:{s:6:\"family\";s:15:\"Caesar Dressing\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Cagliostro\";a:3:{s:6:\"family\";s:10:\"Cagliostro\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Cairo\";a:3:{s:6:\"family\";s:5:\"Cairo\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Caladea\";a:3:{s:6:\"family\";s:7:\"Caladea\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Calistoga\";a:3:{s:6:\"family\";s:9:\"Calistoga\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:14:\"Calligraffitti\";a:3:{s:6:\"family\";s:14:\"Calligraffitti\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Cambay\";a:3:{s:6:\"family\";s:6:\"Cambay\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Cambo\";a:3:{s:6:\"family\";s:5:\"Cambo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Candal\";a:3:{s:6:\"family\";s:6:\"Candal\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Cantarell\";a:3:{s:6:\"family\";s:9:\"Cantarell\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Cantata One\";a:3:{s:6:\"family\";s:11:\"Cantata One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Cantora One\";a:3:{s:6:\"family\";s:11:\"Cantora One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Capriola\";a:3:{s:6:\"family\";s:8:\"Capriola\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Cardo\";a:3:{s:6:\"family\";s:5:\"Cardo\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"greek\";i:1;s:9:\"greek-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:5:\"Carme\";a:3:{s:6:\"family\";s:5:\"Carme\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Carrois Gothic\";a:3:{s:6:\"family\";s:14:\"Carrois Gothic\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:17:\"Carrois Gothic SC\";a:3:{s:6:\"family\";s:17:\"Carrois Gothic SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Carter One\";a:3:{s:6:\"family\";s:10:\"Carter One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Catamaran\";a:3:{s:6:\"family\";s:9:\"Catamaran\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";}}s:6:\"Caudex\";a:3:{s:6:\"family\";s:6:\"Caudex\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"greek\";i:1;s:9:\"greek-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:6:\"Caveat\";a:3:{s:6:\"family\";s:6:\"Caveat\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:12:\"Caveat Brush\";a:3:{s:6:\"family\";s:12:\"Caveat Brush\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:18:\"Cedarville Cursive\";a:3:{s:6:\"family\";s:18:\"Cedarville Cursive\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Ceviche One\";a:3:{s:6:\"family\";s:11:\"Ceviche One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Chakra Petch\";a:3:{s:6:\"family\";s:12:\"Chakra Petch\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:6:\"Changa\";a:3:{s:6:\"family\";s:6:\"Changa\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:10:\"Changa One\";a:3:{s:6:\"family\";s:10:\"Changa One\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Chango\";a:3:{s:6:\"family\";s:6:\"Chango\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Charm\";a:3:{s:6:\"family\";s:5:\"Charm\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:10:\"Charmonman\";a:3:{s:6:\"family\";s:10:\"Charmonman\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:8:\"Chathura\";a:3:{s:6:\"family\";s:8:\"Chathura\";s:8:\"variants\";a:5:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:18:\"Chau Philomene One\";a:3:{s:6:\"family\";s:18:\"Chau Philomene One\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Chela One\";a:3:{s:6:\"family\";s:9:\"Chela One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Chelsea Market\";a:3:{s:6:\"family\";s:14:\"Chelsea Market\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Chenla\";a:3:{s:6:\"family\";s:6:\"Chenla\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:17:\"Cherry Cream Soda\";a:3:{s:6:\"family\";s:17:\"Cherry Cream Soda\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Cherry Swash\";a:3:{s:6:\"family\";s:12:\"Cherry Swash\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Chewy\";a:3:{s:6:\"family\";s:5:\"Chewy\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Chicle\";a:3:{s:6:\"family\";s:6:\"Chicle\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Chilanka\";a:3:{s:6:\"family\";s:8:\"Chilanka\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"malayalam\";}}s:5:\"Chivo\";a:3:{s:6:\"family\";s:5:\"Chivo\";s:8:\"variants\";a:8:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";i:6;s:3:\"900\";i:7;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Chonburi\";a:3:{s:6:\"family\";s:8:\"Chonburi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:6:\"Cinzel\";a:3:{s:6:\"family\";s:6:\"Cinzel\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:17:\"Cinzel Decorative\";a:3:{s:6:\"family\";s:17:\"Cinzel Decorative\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"900\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Clicker Script\";a:3:{s:6:\"family\";s:14:\"Clicker Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Coda\";a:3:{s:6:\"family\";s:4:\"Coda\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Coda Caption\";a:3:{s:6:\"family\";s:12:\"Coda Caption\";s:8:\"variants\";a:1:{i:0;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Codystar\";a:3:{s:6:\"family\";s:8:\"Codystar\";s:8:\"variants\";a:2:{i:0;s:3:\"300\";i:1;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Coiny\";a:3:{s:6:\"family\";s:5:\"Coiny\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";i:3;s:10:\"vietnamese\";}}s:5:\"Combo\";a:3:{s:6:\"family\";s:5:\"Combo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Comfortaa\";a:3:{s:6:\"family\";s:9:\"Comfortaa\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:10:\"Comic Neue\";a:3:{s:6:\"family\";s:10:\"Comic Neue\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Coming Soon\";a:3:{s:6:\"family\";s:11:\"Coming Soon\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Concert One\";a:3:{s:6:\"family\";s:11:\"Concert One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Condiment\";a:3:{s:6:\"family\";s:9:\"Condiment\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Content\";a:3:{s:6:\"family\";s:7:\"Content\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:12:\"Contrail One\";a:3:{s:6:\"family\";s:12:\"Contrail One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Convergence\";a:3:{s:6:\"family\";s:11:\"Convergence\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Cookie\";a:3:{s:6:\"family\";s:6:\"Cookie\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Copse\";a:3:{s:6:\"family\";s:5:\"Copse\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Corben\";a:3:{s:6:\"family\";s:6:\"Corben\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Cormorant\";a:3:{s:6:\"family\";s:9:\"Cormorant\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:18:\"Cormorant Garamond\";a:3:{s:6:\"family\";s:18:\"Cormorant Garamond\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:16:\"Cormorant Infant\";a:3:{s:6:\"family\";s:16:\"Cormorant Infant\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:12:\"Cormorant SC\";a:3:{s:6:\"family\";s:12:\"Cormorant SC\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:17:\"Cormorant Unicase\";a:3:{s:6:\"family\";s:17:\"Cormorant Unicase\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:17:\"Cormorant Upright\";a:3:{s:6:\"family\";s:17:\"Cormorant Upright\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Courgette\";a:3:{s:6:\"family\";s:9:\"Courgette\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Courier Prime\";a:3:{s:6:\"family\";s:13:\"Courier Prime\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Cousine\";a:3:{s:6:\"family\";s:7:\"Cousine\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:8:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:6:\"hebrew\";i:5;s:5:\"latin\";i:6;s:9:\"latin-ext\";i:7;s:10:\"vietnamese\";}}s:8:\"Coustard\";a:3:{s:6:\"family\";s:8:\"Coustard\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"900\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:21:\"Covered By Your Grace\";a:3:{s:6:\"family\";s:21:\"Covered By Your Grace\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Crafty Girls\";a:3:{s:6:\"family\";s:12:\"Crafty Girls\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Creepster\";a:3:{s:6:\"family\";s:9:\"Creepster\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Crete Round\";a:3:{s:6:\"family\";s:11:\"Crete Round\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Crimson Pro\";a:3:{s:6:\"family\";s:11:\"Crimson Pro\";s:8:\"variants\";a:16:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";i:7;s:3:\"900\";i:8;s:9:\"200italic\";i:9;s:9:\"300italic\";i:10;s:6:\"italic\";i:11;s:9:\"500italic\";i:12;s:9:\"600italic\";i:13;s:9:\"700italic\";i:14;s:9:\"800italic\";i:15;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:12:\"Crimson Text\";a:3:{s:6:\"family\";s:12:\"Crimson Text\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"600\";i:3;s:9:\"600italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Croissant One\";a:3:{s:6:\"family\";s:13:\"Croissant One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Crushed\";a:3:{s:6:\"family\";s:7:\"Crushed\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Cuprum\";a:3:{s:6:\"family\";s:6:\"Cuprum\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:9:\"Cute Font\";a:3:{s:6:\"family\";s:9:\"Cute Font\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:6:\"Cutive\";a:3:{s:6:\"family\";s:6:\"Cutive\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Cutive Mono\";a:3:{s:6:\"family\";s:11:\"Cutive Mono\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"DM Mono\";a:3:{s:6:\"family\";s:7:\"DM Mono\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"DM Sans\";a:3:{s:6:\"family\";s:7:\"DM Sans\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"DM Serif Display\";a:3:{s:6:\"family\";s:16:\"DM Serif Display\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"DM Serif Text\";a:3:{s:6:\"family\";s:13:\"DM Serif Text\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Damion\";a:3:{s:6:\"family\";s:6:\"Damion\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Dancing Script\";a:3:{s:6:\"family\";s:14:\"Dancing Script\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"Dangrek\";a:3:{s:6:\"family\";s:7:\"Dangrek\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:16:\"Darker Grotesque\";a:3:{s:6:\"family\";s:16:\"Darker Grotesque\";s:8:\"variants\";a:7:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"David Libre\";a:3:{s:6:\"family\";s:11:\"David Libre\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:20:\"Dawning of a New Day\";a:3:{s:6:\"family\";s:20:\"Dawning of a New Day\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Days One\";a:3:{s:6:\"family\";s:8:\"Days One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Dekko\";a:3:{s:6:\"family\";s:5:\"Dekko\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Delius\";a:3:{s:6:\"family\";s:6:\"Delius\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:17:\"Delius Swash Caps\";a:3:{s:6:\"family\";s:17:\"Delius Swash Caps\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Delius Unicase\";a:3:{s:6:\"family\";s:14:\"Delius Unicase\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Della Respira\";a:3:{s:6:\"family\";s:13:\"Della Respira\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Denk One\";a:3:{s:6:\"family\";s:8:\"Denk One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Devonshire\";a:3:{s:6:\"family\";s:10:\"Devonshire\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Dhurjati\";a:3:{s:6:\"family\";s:8:\"Dhurjati\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:13:\"Didact Gothic\";a:3:{s:6:\"family\";s:13:\"Didact Gothic\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";}}s:9:\"Diplomata\";a:3:{s:6:\"family\";s:9:\"Diplomata\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Diplomata SC\";a:3:{s:6:\"family\";s:12:\"Diplomata SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Do Hyeon\";a:3:{s:6:\"family\";s:8:\"Do Hyeon\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:5:\"Dokdo\";a:3:{s:6:\"family\";s:5:\"Dokdo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:6:\"Domine\";a:3:{s:6:\"family\";s:6:\"Domine\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Donegal One\";a:3:{s:6:\"family\";s:11:\"Donegal One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Doppio One\";a:3:{s:6:\"family\";s:10:\"Doppio One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Dorsa\";a:3:{s:6:\"family\";s:5:\"Dorsa\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Dosis\";a:3:{s:6:\"family\";s:5:\"Dosis\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Dr Sugiyama\";a:3:{s:6:\"family\";s:11:\"Dr Sugiyama\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Duru Sans\";a:3:{s:6:\"family\";s:9:\"Duru Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Dynalight\";a:3:{s:6:\"family\";s:9:\"Dynalight\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"EB Garamond\";a:3:{s:6:\"family\";s:11:\"EB Garamond\";s:8:\"variants\";a:10:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";i:5;s:6:\"italic\";i:6;s:9:\"500italic\";i:7;s:9:\"600italic\";i:8;s:9:\"700italic\";i:9;s:9:\"800italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:10:\"Eagle Lake\";a:3:{s:6:\"family\";s:10:\"Eagle Lake\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"East Sea Dokdo\";a:3:{s:6:\"family\";s:14:\"East Sea Dokdo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:5:\"Eater\";a:3:{s:6:\"family\";s:5:\"Eater\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Economica\";a:3:{s:6:\"family\";s:9:\"Economica\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Eczar\";a:3:{s:6:\"family\";s:5:\"Eczar\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:10:\"El Messiri\";a:3:{s:6:\"family\";s:10:\"El Messiri\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:8:\"cyrillic\";i:2;s:5:\"latin\";}}s:11:\"Electrolize\";a:3:{s:6:\"family\";s:11:\"Electrolize\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Elsie\";a:3:{s:6:\"family\";s:5:\"Elsie\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"Elsie Swash Caps\";a:3:{s:6:\"family\";s:16:\"Elsie Swash Caps\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Emblema One\";a:3:{s:6:\"family\";s:11:\"Emblema One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Emilys Candy\";a:3:{s:6:\"family\";s:12:\"Emilys Candy\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Encode Sans\";a:3:{s:6:\"family\";s:11:\"Encode Sans\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:21:\"Encode Sans Condensed\";a:3:{s:6:\"family\";s:21:\"Encode Sans Condensed\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:20:\"Encode Sans Expanded\";a:3:{s:6:\"family\";s:20:\"Encode Sans Expanded\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:26:\"Encode Sans Semi Condensed\";a:3:{s:6:\"family\";s:26:\"Encode Sans Semi Condensed\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:25:\"Encode Sans Semi Expanded\";a:3:{s:6:\"family\";s:25:\"Encode Sans Semi Expanded\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:10:\"Engagement\";a:3:{s:6:\"family\";s:10:\"Engagement\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Englebert\";a:3:{s:6:\"family\";s:9:\"Englebert\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Enriqueta\";a:3:{s:6:\"family\";s:9:\"Enriqueta\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Epilogue\";a:3:{s:6:\"family\";s:8:\"Epilogue\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Erica One\";a:3:{s:6:\"family\";s:9:\"Erica One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Esteban\";a:3:{s:6:\"family\";s:7:\"Esteban\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:15:\"Euphoria Script\";a:3:{s:6:\"family\";s:15:\"Euphoria Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Ewert\";a:3:{s:6:\"family\";s:5:\"Ewert\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:3:\"Exo\";a:3:{s:6:\"family\";s:3:\"Exo\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:5:\"Exo 2\";a:3:{s:6:\"family\";s:5:\"Exo 2\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:13:\"Expletus Sans\";a:3:{s:6:\"family\";s:13:\"Expletus Sans\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Fahkwang\";a:3:{s:6:\"family\";s:8:\"Fahkwang\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:12:\"Fanwood Text\";a:3:{s:6:\"family\";s:12:\"Fanwood Text\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Farro\";a:3:{s:6:\"family\";s:5:\"Farro\";s:8:\"variants\";a:4:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Farsan\";a:3:{s:6:\"family\";s:6:\"Farsan\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:9:\"Fascinate\";a:3:{s:6:\"family\";s:9:\"Fascinate\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:16:\"Fascinate Inline\";a:3:{s:6:\"family\";s:16:\"Fascinate Inline\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Faster One\";a:3:{s:6:\"family\";s:10:\"Faster One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Fasthand\";a:3:{s:6:\"family\";s:8:\"Fasthand\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:9:\"Fauna One\";a:3:{s:6:\"family\";s:9:\"Fauna One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Faustina\";a:3:{s:6:\"family\";s:8:\"Faustina\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:6:\"italic\";i:5;s:9:\"500italic\";i:6;s:9:\"600italic\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:8:\"Federant\";a:3:{s:6:\"family\";s:8:\"Federant\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Federo\";a:3:{s:6:\"family\";s:6:\"Federo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Felipa\";a:3:{s:6:\"family\";s:6:\"Felipa\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Fenix\";a:3:{s:6:\"family\";s:5:\"Fenix\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Finger Paint\";a:3:{s:6:\"family\";s:12:\"Finger Paint\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Fira Code\";a:3:{s:6:\"family\";s:9:\"Fira Code\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";}}s:9:\"Fira Mono\";a:3:{s:6:\"family\";s:9:\"Fira Mono\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"700\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";}}s:9:\"Fira Sans\";a:3:{s:6:\"family\";s:9:\"Fira Sans\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:19:\"Fira Sans Condensed\";a:3:{s:6:\"family\";s:19:\"Fira Sans Condensed\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:25:\"Fira Sans Extra Condensed\";a:3:{s:6:\"family\";s:25:\"Fira Sans Extra Condensed\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:10:\"Fjalla One\";a:3:{s:6:\"family\";s:10:\"Fjalla One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Fjord One\";a:3:{s:6:\"family\";s:9:\"Fjord One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Flamenco\";a:3:{s:6:\"family\";s:8:\"Flamenco\";s:8:\"variants\";a:2:{i:0;s:3:\"300\";i:1;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Flavors\";a:3:{s:6:\"family\";s:7:\"Flavors\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Fondamento\";a:3:{s:6:\"family\";s:10:\"Fondamento\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"Fontdiner Swanky\";a:3:{s:6:\"family\";s:16:\"Fontdiner Swanky\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Forum\";a:3:{s:6:\"family\";s:5:\"Forum\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:12:\"Francois One\";a:3:{s:6:\"family\";s:12:\"Francois One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:16:\"Frank Ruhl Libre\";a:3:{s:6:\"family\";s:16:\"Frank Ruhl Libre\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"700\";i:4;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:12:\"Freckle Face\";a:3:{s:6:\"family\";s:12:\"Freckle Face\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:20:\"Fredericka the Great\";a:3:{s:6:\"family\";s:20:\"Fredericka the Great\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Fredoka One\";a:3:{s:6:\"family\";s:11:\"Fredoka One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Freehand\";a:3:{s:6:\"family\";s:8:\"Freehand\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:6:\"Fresca\";a:3:{s:6:\"family\";s:6:\"Fresca\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Frijole\";a:3:{s:6:\"family\";s:7:\"Frijole\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Fruktur\";a:3:{s:6:\"family\";s:7:\"Fruktur\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Fugaz One\";a:3:{s:6:\"family\";s:9:\"Fugaz One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"GFS Didot\";a:3:{s:6:\"family\";s:9:\"GFS Didot\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"greek\";}}s:15:\"GFS Neohellenic\";a:3:{s:6:\"family\";s:15:\"GFS Neohellenic\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"greek\";}}s:8:\"Gabriela\";a:3:{s:6:\"family\";s:8:\"Gabriela\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";}}s:5:\"Gaegu\";a:3:{s:6:\"family\";s:5:\"Gaegu\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:6:\"Gafata\";a:3:{s:6:\"family\";s:6:\"Gafata\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Galada\";a:3:{s:6:\"family\";s:6:\"Galada\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:7:\"bengali\";i:1;s:5:\"latin\";}}s:8:\"Galdeano\";a:3:{s:6:\"family\";s:8:\"Galdeano\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Galindo\";a:3:{s:6:\"family\";s:7:\"Galindo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Gamja Flower\";a:3:{s:6:\"family\";s:12:\"Gamja Flower\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:8:\"Gayathri\";a:3:{s:6:\"family\";s:8:\"Gayathri\";s:8:\"variants\";a:3:{i:0;s:3:\"100\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"malayalam\";}}s:7:\"Gelasio\";a:3:{s:6:\"family\";s:7:\"Gelasio\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:13:\"Gentium Basic\";a:3:{s:6:\"family\";s:13:\"Gentium Basic\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:18:\"Gentium Book Basic\";a:3:{s:6:\"family\";s:18:\"Gentium Book Basic\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:3:\"Geo\";a:3:{s:6:\"family\";s:3:\"Geo\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Geostar\";a:3:{s:6:\"family\";s:7:\"Geostar\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Geostar Fill\";a:3:{s:6:\"family\";s:12:\"Geostar Fill\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Germania One\";a:3:{s:6:\"family\";s:12:\"Germania One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Gidugu\";a:3:{s:6:\"family\";s:6:\"Gidugu\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:13:\"Gilda Display\";a:3:{s:6:\"family\";s:13:\"Gilda Display\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Girassol\";a:3:{s:6:\"family\";s:8:\"Girassol\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Give You Glory\";a:3:{s:6:\"family\";s:14:\"Give You Glory\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Glass Antiqua\";a:3:{s:6:\"family\";s:13:\"Glass Antiqua\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Glegoo\";a:3:{s:6:\"family\";s:6:\"Glegoo\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:17:\"Gloria Hallelujah\";a:3:{s:6:\"family\";s:17:\"Gloria Hallelujah\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Goblin One\";a:3:{s:6:\"family\";s:10:\"Goblin One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Gochi Hand\";a:3:{s:6:\"family\";s:10:\"Gochi Hand\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Gorditas\";a:3:{s:6:\"family\";s:8:\"Gorditas\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Gothic A1\";a:3:{s:6:\"family\";s:9:\"Gothic A1\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:4:\"Gotu\";a:3:{s:6:\"family\";s:4:\"Gotu\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:21:\"Goudy Bookletter 1911\";a:3:{s:6:\"family\";s:21:\"Goudy Bookletter 1911\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Graduate\";a:3:{s:6:\"family\";s:8:\"Graduate\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Grand Hotel\";a:3:{s:6:\"family\";s:11:\"Grand Hotel\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Gravitas One\";a:3:{s:6:\"family\";s:12:\"Gravitas One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Great Vibes\";a:3:{s:6:\"family\";s:11:\"Great Vibes\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Grenze\";a:3:{s:6:\"family\";s:6:\"Grenze\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:14:\"Grenze Gotisch\";a:3:{s:6:\"family\";s:14:\"Grenze Gotisch\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:6:\"Griffy\";a:3:{s:6:\"family\";s:6:\"Griffy\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Gruppo\";a:3:{s:6:\"family\";s:6:\"Gruppo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Gudea\";a:3:{s:6:\"family\";s:5:\"Gudea\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Gugi\";a:3:{s:6:\"family\";s:4:\"Gugi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:6:\"Gupter\";a:3:{s:6:\"family\";s:6:\"Gupter\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Gurajada\";a:3:{s:6:\"family\";s:8:\"Gurajada\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:6:\"Habibi\";a:3:{s:6:\"family\";s:6:\"Habibi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Halant\";a:3:{s:6:\"family\";s:6:\"Halant\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:15:\"Hammersmith One\";a:3:{s:6:\"family\";s:15:\"Hammersmith One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Hanalei\";a:3:{s:6:\"family\";s:7:\"Hanalei\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Hanalei Fill\";a:3:{s:6:\"family\";s:12:\"Hanalei Fill\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Handlee\";a:3:{s:6:\"family\";s:7:\"Handlee\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Hanuman\";a:3:{s:6:\"family\";s:7:\"Hanuman\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:12:\"Happy Monkey\";a:3:{s:6:\"family\";s:12:\"Happy Monkey\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Harmattan\";a:3:{s:6:\"family\";s:9:\"Harmattan\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Headland One\";a:3:{s:6:\"family\";s:12:\"Headland One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Heebo\";a:3:{s:6:\"family\";s:5:\"Heebo\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";}}s:11:\"Henny Penny\";a:3:{s:6:\"family\";s:11:\"Henny Penny\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Hepta Slab\";a:3:{s:6:\"family\";s:10:\"Hepta Slab\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:20:\"Herr Von Muellerhoff\";a:3:{s:6:\"family\";s:20:\"Herr Von Muellerhoff\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Hi Melody\";a:3:{s:6:\"family\";s:9:\"Hi Melody\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:4:\"Hind\";a:3:{s:6:\"family\";s:4:\"Hind\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:11:\"Hind Guntur\";a:3:{s:6:\"family\";s:11:\"Hind Guntur\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:6:\"telugu\";}}s:12:\"Hind Madurai\";a:3:{s:6:\"family\";s:12:\"Hind Madurai\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";}}s:13:\"Hind Siliguri\";a:3:{s:6:\"family\";s:13:\"Hind Siliguri\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:7:\"bengali\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:13:\"Hind Vadodara\";a:3:{s:6:\"family\";s:13:\"Hind Vadodara\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:15:\"Holtwood One SC\";a:3:{s:6:\"family\";s:15:\"Holtwood One SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Homemade Apple\";a:3:{s:6:\"family\";s:14:\"Homemade Apple\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Homenaje\";a:3:{s:6:\"family\";s:8:\"Homenaje\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"IBM Plex Mono\";a:3:{s:6:\"family\";s:13:\"IBM Plex Mono\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:13:\"IBM Plex Sans\";a:3:{s:6:\"family\";s:13:\"IBM Plex Sans\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:23:\"IBM Plex Sans Condensed\";a:3:{s:6:\"family\";s:23:\"IBM Plex Sans Condensed\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:14:\"IBM Plex Serif\";a:3:{s:6:\"family\";s:14:\"IBM Plex Serif\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:15:\"IM Fell DW Pica\";a:3:{s:6:\"family\";s:15:\"IM Fell DW Pica\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:18:\"IM Fell DW Pica SC\";a:3:{s:6:\"family\";s:18:\"IM Fell DW Pica SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:19:\"IM Fell Double Pica\";a:3:{s:6:\"family\";s:19:\"IM Fell Double Pica\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:22:\"IM Fell Double Pica SC\";a:3:{s:6:\"family\";s:22:\"IM Fell Double Pica SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"IM Fell English\";a:3:{s:6:\"family\";s:15:\"IM Fell English\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:18:\"IM Fell English SC\";a:3:{s:6:\"family\";s:18:\"IM Fell English SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:20:\"IM Fell French Canon\";a:3:{s:6:\"family\";s:20:\"IM Fell French Canon\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:23:\"IM Fell French Canon SC\";a:3:{s:6:\"family\";s:23:\"IM Fell French Canon SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:20:\"IM Fell Great Primer\";a:3:{s:6:\"family\";s:20:\"IM Fell Great Primer\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:23:\"IM Fell Great Primer SC\";a:3:{s:6:\"family\";s:23:\"IM Fell Great Primer SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:16:\"Ibarra Real Nova\";a:3:{s:6:\"family\";s:16:\"Ibarra Real Nova\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"600\";i:3;s:9:\"600italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Iceberg\";a:3:{s:6:\"family\";s:7:\"Iceberg\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Iceland\";a:3:{s:6:\"family\";s:7:\"Iceland\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Imprima\";a:3:{s:6:\"family\";s:7:\"Imprima\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Inconsolata\";a:3:{s:6:\"family\";s:11:\"Inconsolata\";s:8:\"variants\";a:8:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";i:7;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:5:\"Inder\";a:3:{s:6:\"family\";s:5:\"Inder\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Indie Flower\";a:3:{s:6:\"family\";s:12:\"Indie Flower\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Inika\";a:3:{s:6:\"family\";s:5:\"Inika\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Inknut Antiqua\";a:3:{s:6:\"family\";s:14:\"Inknut Antiqua\";s:8:\"variants\";a:7:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:10:\"Inria Sans\";a:3:{s:6:\"family\";s:10:\"Inria Sans\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Inria Serif\";a:3:{s:6:\"family\";s:11:\"Inria Serif\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Inter\";a:3:{s:6:\"family\";s:5:\"Inter\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:12:\"Irish Grover\";a:3:{s:6:\"family\";s:12:\"Irish Grover\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Istok Web\";a:3:{s:6:\"family\";s:9:\"Istok Web\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:8:\"Italiana\";a:3:{s:6:\"family\";s:8:\"Italiana\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Italianno\";a:3:{s:6:\"family\";s:9:\"Italianno\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Itim\";a:3:{s:6:\"family\";s:4:\"Itim\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:16:\"Jacques Francois\";a:3:{s:6:\"family\";s:16:\"Jacques Francois\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:23:\"Jacques Francois Shadow\";a:3:{s:6:\"family\";s:23:\"Jacques Francois Shadow\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Jaldi\";a:3:{s:6:\"family\";s:5:\"Jaldi\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:14:\"Jim Nightshade\";a:3:{s:6:\"family\";s:14:\"Jim Nightshade\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Jockey One\";a:3:{s:6:\"family\";s:10:\"Jockey One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Jolly Lodger\";a:3:{s:6:\"family\";s:12:\"Jolly Lodger\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Jomhuria\";a:3:{s:6:\"family\";s:8:\"Jomhuria\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:9:\"Jomolhari\";a:3:{s:6:\"family\";s:9:\"Jomolhari\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:7:\"tibetan\";}}s:12:\"Josefin Sans\";a:3:{s:6:\"family\";s:12:\"Josefin Sans\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:9:\"100italic\";i:8;s:9:\"200italic\";i:9;s:9:\"300italic\";i:10;s:6:\"italic\";i:11;s:9:\"500italic\";i:12;s:9:\"600italic\";i:13;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:12:\"Josefin Slab\";a:3:{s:6:\"family\";s:12:\"Josefin Slab\";s:8:\"variants\";a:10:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Jost\";a:3:{s:6:\"family\";s:4:\"Jost\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:8:\"Joti One\";a:3:{s:6:\"family\";s:8:\"Joti One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:3:\"Jua\";a:3:{s:6:\"family\";s:3:\"Jua\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:6:\"Judson\";a:3:{s:6:\"family\";s:6:\"Judson\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:5:\"Julee\";a:3:{s:6:\"family\";s:5:\"Julee\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Julius Sans One\";a:3:{s:6:\"family\";s:15:\"Julius Sans One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Junge\";a:3:{s:6:\"family\";s:5:\"Junge\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Jura\";a:3:{s:6:\"family\";s:4:\"Jura\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:17:\"Just Another Hand\";a:3:{s:6:\"family\";s:17:\"Just Another Hand\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:23:\"Just Me Again Down Here\";a:3:{s:6:\"family\";s:23:\"Just Me Again Down Here\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:3:\"K2D\";a:3:{s:6:\"family\";s:3:\"K2D\";s:8:\"variants\";a:16:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:5:\"Kadwa\";a:3:{s:6:\"family\";s:5:\"Kadwa\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";}}s:5:\"Kalam\";a:3:{s:6:\"family\";s:5:\"Kalam\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Kameron\";a:3:{s:6:\"family\";s:7:\"Kameron\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Kanit\";a:3:{s:6:\"family\";s:5:\"Kanit\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:9:\"Kantumruy\";a:3:{s:6:\"family\";s:9:\"Kantumruy\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:5:\"Karla\";a:3:{s:6:\"family\";s:5:\"Karla\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Karma\";a:3:{s:6:\"family\";s:5:\"Karma\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Katibeh\";a:3:{s:6:\"family\";s:7:\"Katibeh\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:14:\"Kaushan Script\";a:3:{s:6:\"family\";s:14:\"Kaushan Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Kavivanar\";a:3:{s:6:\"family\";s:9:\"Kavivanar\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";}}s:6:\"Kavoon\";a:3:{s:6:\"family\";s:6:\"Kavoon\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Kdam Thmor\";a:3:{s:6:\"family\";s:10:\"Kdam Thmor\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:10:\"Keania One\";a:3:{s:6:\"family\";s:10:\"Keania One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Kelly Slab\";a:3:{s:6:\"family\";s:10:\"Kelly Slab\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Kenia\";a:3:{s:6:\"family\";s:5:\"Kenia\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Khand\";a:3:{s:6:\"family\";s:5:\"Khand\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Khmer\";a:3:{s:6:\"family\";s:5:\"Khmer\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:5:\"Khula\";a:3:{s:6:\"family\";s:5:\"Khula\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:14:\"Kirang Haerang\";a:3:{s:6:\"family\";s:14:\"Kirang Haerang\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:8:\"Kite One\";a:3:{s:6:\"family\";s:8:\"Kite One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Knewave\";a:3:{s:6:\"family\";s:7:\"Knewave\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"KoHo\";a:3:{s:6:\"family\";s:4:\"KoHo\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:9:\"Kodchasan\";a:3:{s:6:\"family\";s:9:\"Kodchasan\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:6:\"Kosugi\";a:3:{s:6:\"family\";s:6:\"Kosugi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:8:\"japanese\";i:2;s:5:\"latin\";}}s:11:\"Kosugi Maru\";a:3:{s:6:\"family\";s:11:\"Kosugi Maru\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:8:\"japanese\";i:2;s:5:\"latin\";}}s:9:\"Kotta One\";a:3:{s:6:\"family\";s:9:\"Kotta One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Koulen\";a:3:{s:6:\"family\";s:6:\"Koulen\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:6:\"Kranky\";a:3:{s:6:\"family\";s:6:\"Kranky\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Kreon\";a:3:{s:6:\"family\";s:5:\"Kreon\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Kristi\";a:3:{s:6:\"family\";s:6:\"Kristi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Krona One\";a:3:{s:6:\"family\";s:9:\"Krona One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Krub\";a:3:{s:6:\"family\";s:4:\"Krub\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:10:\"Kulim Park\";a:3:{s:6:\"family\";s:10:\"Kulim Park\";s:8:\"variants\";a:10:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Kumar One\";a:3:{s:6:\"family\";s:9:\"Kumar One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:17:\"Kumar One Outline\";a:3:{s:6:\"family\";s:17:\"Kumar One Outline\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Kurale\";a:3:{s:6:\"family\";s:6:\"Kurale\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:10:\"devanagari\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";}}s:15:\"La Belle Aurore\";a:3:{s:6:\"family\";s:15:\"La Belle Aurore\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Lacquer\";a:3:{s:6:\"family\";s:7:\"Lacquer\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Laila\";a:3:{s:6:\"family\";s:5:\"Laila\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:11:\"Lakki Reddy\";a:3:{s:6:\"family\";s:11:\"Lakki Reddy\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:7:\"Lalezar\";a:3:{s:6:\"family\";s:7:\"Lalezar\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:8:\"Lancelot\";a:3:{s:6:\"family\";s:8:\"Lancelot\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Lateef\";a:3:{s:6:\"family\";s:6:\"Lateef\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";}}s:4:\"Lato\";a:3:{s:6:\"family\";s:4:\"Lato\";s:8:\"variants\";a:10:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";i:8;s:3:\"900\";i:9;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"League Script\";a:3:{s:6:\"family\";s:13:\"League Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Leckerli One\";a:3:{s:6:\"family\";s:12:\"Leckerli One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Ledger\";a:3:{s:6:\"family\";s:6:\"Ledger\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Lekton\";a:3:{s:6:\"family\";s:6:\"Lekton\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Lemon\";a:3:{s:6:\"family\";s:5:\"Lemon\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Lemonada\";a:3:{s:6:\"family\";s:8:\"Lemonada\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:11:\"Lexend Deca\";a:3:{s:6:\"family\";s:11:\"Lexend Deca\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:10:\"Lexend Exa\";a:3:{s:6:\"family\";s:10:\"Lexend Exa\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Lexend Giga\";a:3:{s:6:\"family\";s:11:\"Lexend Giga\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Lexend Mega\";a:3:{s:6:\"family\";s:11:\"Lexend Mega\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Lexend Peta\";a:3:{s:6:\"family\";s:11:\"Lexend Peta\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Lexend Tera\";a:3:{s:6:\"family\";s:11:\"Lexend Tera\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:12:\"Lexend Zetta\";a:3:{s:6:\"family\";s:12:\"Lexend Zetta\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:17:\"Libre Barcode 128\";a:3:{s:6:\"family\";s:17:\"Libre Barcode 128\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:22:\"Libre Barcode 128 Text\";a:3:{s:6:\"family\";s:22:\"Libre Barcode 128 Text\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:16:\"Libre Barcode 39\";a:3:{s:6:\"family\";s:16:\"Libre Barcode 39\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:25:\"Libre Barcode 39 Extended\";a:3:{s:6:\"family\";s:25:\"Libre Barcode 39 Extended\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:30:\"Libre Barcode 39 Extended Text\";a:3:{s:6:\"family\";s:30:\"Libre Barcode 39 Extended Text\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:21:\"Libre Barcode 39 Text\";a:3:{s:6:\"family\";s:21:\"Libre Barcode 39 Text\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:17:\"Libre Baskerville\";a:3:{s:6:\"family\";s:17:\"Libre Baskerville\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:20:\"Libre Caslon Display\";a:3:{s:6:\"family\";s:20:\"Libre Caslon Display\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:17:\"Libre Caslon Text\";a:3:{s:6:\"family\";s:17:\"Libre Caslon Text\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Libre Franklin\";a:3:{s:6:\"family\";s:14:\"Libre Franklin\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Life Savers\";a:3:{s:6:\"family\";s:11:\"Life Savers\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Lilita One\";a:3:{s:6:\"family\";s:10:\"Lilita One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:15:\"Lily Script One\";a:3:{s:6:\"family\";s:15:\"Lily Script One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Limelight\";a:3:{s:6:\"family\";s:9:\"Limelight\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Linden Hill\";a:3:{s:6:\"family\";s:11:\"Linden Hill\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Literata\";a:3:{s:6:\"family\";s:8:\"Literata\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:6:\"italic\";i:5;s:9:\"500italic\";i:6;s:9:\"600italic\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:5:\"greek\";i:2;s:9:\"greek-ext\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:16:\"Liu Jian Mao Cao\";a:3:{s:6:\"family\";s:16:\"Liu Jian Mao Cao\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:6:\"Livvic\";a:3:{s:6:\"family\";s:6:\"Livvic\";s:8:\"variants\";a:16:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"900\";i:15;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"Lobster\";a:3:{s:6:\"family\";s:7:\"Lobster\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:11:\"Lobster Two\";a:3:{s:6:\"family\";s:11:\"Lobster Two\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:16:\"Londrina Outline\";a:3:{s:6:\"family\";s:16:\"Londrina Outline\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Londrina Shadow\";a:3:{s:6:\"family\";s:15:\"Londrina Shadow\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Londrina Sketch\";a:3:{s:6:\"family\";s:15:\"Londrina Sketch\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Londrina Solid\";a:3:{s:6:\"family\";s:14:\"Londrina Solid\";s:8:\"variants\";a:4:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"900\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Long Cang\";a:3:{s:6:\"family\";s:9:\"Long Cang\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:4:\"Lora\";a:3:{s:6:\"family\";s:4:\"Lora\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:6:\"italic\";i:5;s:9:\"500italic\";i:6;s:9:\"600italic\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:21:\"Love Ya Like A Sister\";a:3:{s:6:\"family\";s:21:\"Love Ya Like A Sister\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:17:\"Loved by the King\";a:3:{s:6:\"family\";s:17:\"Loved by the King\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Lovers Quarrel\";a:3:{s:6:\"family\";s:14:\"Lovers Quarrel\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Luckiest Guy\";a:3:{s:6:\"family\";s:12:\"Luckiest Guy\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Lusitana\";a:3:{s:6:\"family\";s:8:\"Lusitana\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Lustria\";a:3:{s:6:\"family\";s:7:\"Lustria\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"M PLUS 1p\";a:3:{s:6:\"family\";s:9:\"M PLUS 1p\";s:8:\"variants\";a:7:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:9:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:6:\"hebrew\";i:5;s:8:\"japanese\";i:6;s:5:\"latin\";i:7;s:9:\"latin-ext\";i:8;s:10:\"vietnamese\";}}s:17:\"M PLUS Rounded 1c\";a:3:{s:6:\"family\";s:17:\"M PLUS Rounded 1c\";s:8:\"variants\";a:7:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:9:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:6:\"hebrew\";i:5;s:8:\"japanese\";i:6;s:5:\"latin\";i:7;s:9:\"latin-ext\";i:8;s:10:\"vietnamese\";}}s:13:\"Ma Shan Zheng\";a:3:{s:6:\"family\";s:13:\"Ma Shan Zheng\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:7:\"Macondo\";a:3:{s:6:\"family\";s:7:\"Macondo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:18:\"Macondo Swash Caps\";a:3:{s:6:\"family\";s:18:\"Macondo Swash Caps\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Mada\";a:3:{s:6:\"family\";s:4:\"Mada\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";}}s:5:\"Magra\";a:3:{s:6:\"family\";s:5:\"Magra\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Maiden Orange\";a:3:{s:6:\"family\";s:13:\"Maiden Orange\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Maitree\";a:3:{s:6:\"family\";s:7:\"Maitree\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:18:\"Major Mono Display\";a:3:{s:6:\"family\";s:18:\"Major Mono Display\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:4:\"Mako\";a:3:{s:6:\"family\";s:4:\"Mako\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Mali\";a:3:{s:6:\"family\";s:4:\"Mali\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:8:\"Mallanna\";a:3:{s:6:\"family\";s:8:\"Mallanna\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:7:\"Mandali\";a:3:{s:6:\"family\";s:7:\"Mandali\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:7:\"Manjari\";a:3:{s:6:\"family\";s:7:\"Manjari\";s:8:\"variants\";a:3:{i:0;s:3:\"100\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"malayalam\";}}s:7:\"Manrope\";a:3:{s:6:\"family\";s:7:\"Manrope\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"greek\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:8:\"Mansalva\";a:3:{s:6:\"family\";s:8:\"Mansalva\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Manuale\";a:3:{s:6:\"family\";s:7:\"Manuale\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:6:\"italic\";i:5;s:9:\"500italic\";i:6;s:9:\"600italic\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Marcellus\";a:3:{s:6:\"family\";s:9:\"Marcellus\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Marcellus SC\";a:3:{s:6:\"family\";s:12:\"Marcellus SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Marck Script\";a:3:{s:6:\"family\";s:12:\"Marck Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:9:\"Margarine\";a:3:{s:6:\"family\";s:9:\"Margarine\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Markazi Text\";a:3:{s:6:\"family\";s:12:\"Markazi Text\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:9:\"Marko One\";a:3:{s:6:\"family\";s:9:\"Marko One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Marmelad\";a:3:{s:6:\"family\";s:8:\"Marmelad\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Martel\";a:3:{s:6:\"family\";s:6:\"Martel\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:11:\"Martel Sans\";a:3:{s:6:\"family\";s:11:\"Martel Sans\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Marvel\";a:3:{s:6:\"family\";s:6:\"Marvel\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Mate\";a:3:{s:6:\"family\";s:4:\"Mate\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Mate SC\";a:3:{s:6:\"family\";s:7:\"Mate SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Maven Pro\";a:3:{s:6:\"family\";s:9:\"Maven Pro\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";i:5;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"McLaren\";a:3:{s:6:\"family\";s:7:\"McLaren\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Meddon\";a:3:{s:6:\"family\";s:6:\"Meddon\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"MedievalSharp\";a:3:{s:6:\"family\";s:13:\"MedievalSharp\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Medula One\";a:3:{s:6:\"family\";s:10:\"Medula One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Meera Inimai\";a:3:{s:6:\"family\";s:12:\"Meera Inimai\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:5:\"tamil\";}}s:6:\"Megrim\";a:3:{s:6:\"family\";s:6:\"Megrim\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Meie Script\";a:3:{s:6:\"family\";s:11:\"Meie Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Merienda\";a:3:{s:6:\"family\";s:8:\"Merienda\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Merienda One\";a:3:{s:6:\"family\";s:12:\"Merienda One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Merriweather\";a:3:{s:6:\"family\";s:12:\"Merriweather\";s:8:\"variants\";a:8:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";i:6;s:3:\"900\";i:7;s:9:\"900italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:17:\"Merriweather Sans\";a:3:{s:6:\"family\";s:17:\"Merriweather Sans\";s:8:\"variants\";a:8:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";i:6;s:3:\"800\";i:7;s:9:\"800italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Metal\";a:3:{s:6:\"family\";s:5:\"Metal\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:11:\"Metal Mania\";a:3:{s:6:\"family\";s:11:\"Metal Mania\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Metamorphous\";a:3:{s:6:\"family\";s:12:\"Metamorphous\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Metrophobic\";a:3:{s:6:\"family\";s:11:\"Metrophobic\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:8:\"Michroma\";a:3:{s:6:\"family\";s:8:\"Michroma\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Milonga\";a:3:{s:6:\"family\";s:7:\"Milonga\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Miltonian\";a:3:{s:6:\"family\";s:9:\"Miltonian\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:16:\"Miltonian Tattoo\";a:3:{s:6:\"family\";s:16:\"Miltonian Tattoo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Mina\";a:3:{s:6:\"family\";s:4:\"Mina\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:7:\"bengali\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Miniver\";a:3:{s:6:\"family\";s:7:\"Miniver\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Miriam Libre\";a:3:{s:6:\"family\";s:12:\"Miriam Libre\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Mirza\";a:3:{s:6:\"family\";s:5:\"Mirza\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:14:\"Miss Fajardose\";a:3:{s:6:\"family\";s:14:\"Miss Fajardose\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Mitr\";a:3:{s:6:\"family\";s:4:\"Mitr\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:5:\"Modak\";a:3:{s:6:\"family\";s:5:\"Modak\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:14:\"Modern Antiqua\";a:3:{s:6:\"family\";s:14:\"Modern Antiqua\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Mogra\";a:3:{s:6:\"family\";s:5:\"Mogra\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Molengo\";a:3:{s:6:\"family\";s:7:\"Molengo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Molle\";a:3:{s:6:\"family\";s:5:\"Molle\";s:8:\"variants\";a:1:{i:0;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Monda\";a:3:{s:6:\"family\";s:5:\"Monda\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Monofett\";a:3:{s:6:\"family\";s:8:\"Monofett\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Monoton\";a:3:{s:6:\"family\";s:7:\"Monoton\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:20:\"Monsieur La Doulaise\";a:3:{s:6:\"family\";s:20:\"Monsieur La Doulaise\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Montaga\";a:3:{s:6:\"family\";s:7:\"Montaga\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Montez\";a:3:{s:6:\"family\";s:6:\"Montez\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Montserrat\";a:3:{s:6:\"family\";s:10:\"Montserrat\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:21:\"Montserrat Alternates\";a:3:{s:6:\"family\";s:21:\"Montserrat Alternates\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:20:\"Montserrat Subrayada\";a:3:{s:6:\"family\";s:20:\"Montserrat Subrayada\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Moul\";a:3:{s:6:\"family\";s:4:\"Moul\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:8:\"Moulpali\";a:3:{s:6:\"family\";s:8:\"Moulpali\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:22:\"Mountains of Christmas\";a:3:{s:6:\"family\";s:22:\"Mountains of Christmas\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Mouse Memoirs\";a:3:{s:6:\"family\";s:13:\"Mouse Memoirs\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Mr Bedfort\";a:3:{s:6:\"family\";s:10:\"Mr Bedfort\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Mr Dafoe\";a:3:{s:6:\"family\";s:8:\"Mr Dafoe\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Mr De Haviland\";a:3:{s:6:\"family\";s:14:\"Mr De Haviland\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:19:\"Mrs Saint Delafield\";a:3:{s:6:\"family\";s:19:\"Mrs Saint Delafield\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Mrs Sheppards\";a:3:{s:6:\"family\";s:13:\"Mrs Sheppards\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Mukta\";a:3:{s:6:\"family\";s:5:\"Mukta\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:11:\"Mukta Mahee\";a:3:{s:6:\"family\";s:11:\"Mukta Mahee\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gurmukhi\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:11:\"Mukta Malar\";a:3:{s:6:\"family\";s:11:\"Mukta Malar\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";}}s:11:\"Mukta Vaani\";a:3:{s:6:\"family\";s:11:\"Mukta Vaani\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Mulish\";a:3:{s:6:\"family\";s:6:\"Mulish\";s:8:\"variants\";a:16:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";i:7;s:3:\"900\";i:8;s:9:\"200italic\";i:9;s:9:\"300italic\";i:10;s:6:\"italic\";i:11;s:9:\"500italic\";i:12;s:9:\"600italic\";i:13;s:9:\"700italic\";i:14;s:9:\"800italic\";i:15;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:12:\"MuseoModerno\";a:3:{s:6:\"family\";s:12:\"MuseoModerno\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:13:\"Mystery Quest\";a:3:{s:6:\"family\";s:13:\"Mystery Quest\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:3:\"NTR\";a:3:{s:6:\"family\";s:3:\"NTR\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:18:\"Nanum Brush Script\";a:3:{s:6:\"family\";s:18:\"Nanum Brush Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:12:\"Nanum Gothic\";a:3:{s:6:\"family\";s:12:\"Nanum Gothic\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:19:\"Nanum Gothic Coding\";a:3:{s:6:\"family\";s:19:\"Nanum Gothic Coding\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:14:\"Nanum Myeongjo\";a:3:{s:6:\"family\";s:14:\"Nanum Myeongjo\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:16:\"Nanum Pen Script\";a:3:{s:6:\"family\";s:16:\"Nanum Pen Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:6:\"Neucha\";a:3:{s:6:\"family\";s:6:\"Neucha\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";}}s:6:\"Neuton\";a:3:{s:6:\"family\";s:6:\"Neuton\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"New Rocker\";a:3:{s:6:\"family\";s:10:\"New Rocker\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"News Cycle\";a:3:{s:6:\"family\";s:10:\"News Cycle\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Niconne\";a:3:{s:6:\"family\";s:7:\"Niconne\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Niramit\";a:3:{s:6:\"family\";s:7:\"Niramit\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:9:\"Nixie One\";a:3:{s:6:\"family\";s:9:\"Nixie One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Nobile\";a:3:{s:6:\"family\";s:6:\"Nobile\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Nokora\";a:3:{s:6:\"family\";s:6:\"Nokora\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:7:\"Norican\";a:3:{s:6:\"family\";s:7:\"Norican\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Nosifer\";a:3:{s:6:\"family\";s:7:\"Nosifer\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Notable\";a:3:{s:6:\"family\";s:7:\"Notable\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:20:\"Nothing You Could Do\";a:3:{s:6:\"family\";s:20:\"Nothing You Could Do\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Noticia Text\";a:3:{s:6:\"family\";s:12:\"Noticia Text\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Noto Sans\";a:3:{s:6:\"family\";s:9:\"Noto Sans\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:8:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:10:\"devanagari\";i:3;s:5:\"greek\";i:4;s:9:\"greek-ext\";i:5;s:5:\"latin\";i:6;s:9:\"latin-ext\";i:7;s:10:\"vietnamese\";}}s:12:\"Noto Sans HK\";a:3:{s:6:\"family\";s:12:\"Noto Sans HK\";s:8:\"variants\";a:6:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:16:\"chinese-hongkong\";i:1;s:5:\"latin\";}}s:12:\"Noto Sans JP\";a:3:{s:6:\"family\";s:12:\"Noto Sans JP\";s:8:\"variants\";a:6:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:8:\"japanese\";i:1;s:5:\"latin\";}}s:12:\"Noto Sans KR\";a:3:{s:6:\"family\";s:12:\"Noto Sans KR\";s:8:\"variants\";a:6:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:12:\"Noto Sans SC\";a:3:{s:6:\"family\";s:12:\"Noto Sans SC\";s:8:\"variants\";a:6:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:12:\"Noto Sans TC\";a:3:{s:6:\"family\";s:12:\"Noto Sans TC\";s:8:\"variants\";a:6:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:19:\"chinese-traditional\";i:1;s:5:\"latin\";}}s:10:\"Noto Serif\";a:3:{s:6:\"family\";s:10:\"Noto Serif\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:13:\"Noto Serif JP\";a:3:{s:6:\"family\";s:13:\"Noto Serif JP\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:8:\"japanese\";i:1;s:5:\"latin\";}}s:13:\"Noto Serif KR\";a:3:{s:6:\"family\";s:13:\"Noto Serif KR\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:13:\"Noto Serif SC\";a:3:{s:6:\"family\";s:13:\"Noto Serif SC\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:13:\"Noto Serif TC\";a:3:{s:6:\"family\";s:13:\"Noto Serif TC\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:19:\"chinese-traditional\";i:1;s:5:\"latin\";}}s:8:\"Nova Cut\";a:3:{s:6:\"family\";s:8:\"Nova Cut\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Nova Flat\";a:3:{s:6:\"family\";s:9:\"Nova Flat\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Nova Mono\";a:3:{s:6:\"family\";s:9:\"Nova Mono\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"greek\";i:1;s:5:\"latin\";}}s:9:\"Nova Oval\";a:3:{s:6:\"family\";s:9:\"Nova Oval\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Nova Round\";a:3:{s:6:\"family\";s:10:\"Nova Round\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Nova Script\";a:3:{s:6:\"family\";s:11:\"Nova Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Nova Slim\";a:3:{s:6:\"family\";s:9:\"Nova Slim\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Nova Square\";a:3:{s:6:\"family\";s:11:\"Nova Square\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Numans\";a:3:{s:6:\"family\";s:6:\"Numans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Nunito\";a:3:{s:6:\"family\";s:6:\"Nunito\";s:8:\"variants\";a:14:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"800\";i:11;s:9:\"800italic\";i:12;s:3:\"900\";i:13;s:9:\"900italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:11:\"Nunito Sans\";a:3:{s:6:\"family\";s:11:\"Nunito Sans\";s:8:\"variants\";a:14:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"800\";i:11;s:9:\"800italic\";i:12;s:3:\"900\";i:13;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Odibee Sans\";a:3:{s:6:\"family\";s:11:\"Odibee Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Odor Mean Chey\";a:3:{s:6:\"family\";s:14:\"Odor Mean Chey\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:7:\"Offside\";a:3:{s:6:\"family\";s:7:\"Offside\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Old Standard TT\";a:3:{s:6:\"family\";s:15:\"Old Standard TT\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:9:\"Oldenburg\";a:3:{s:6:\"family\";s:9:\"Oldenburg\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Oleo Script\";a:3:{s:6:\"family\";s:11:\"Oleo Script\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:22:\"Oleo Script Swash Caps\";a:3:{s:6:\"family\";s:22:\"Oleo Script Swash Caps\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Open Sans\";a:3:{s:6:\"family\";s:9:\"Open Sans\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";i:8;s:3:\"800\";i:9;s:9:\"800italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:19:\"Open Sans Condensed\";a:3:{s:6:\"family\";s:19:\"Open Sans Condensed\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:11:\"Oranienbaum\";a:3:{s:6:\"family\";s:11:\"Oranienbaum\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:8:\"Orbitron\";a:3:{s:6:\"family\";s:8:\"Orbitron\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";i:5;s:3:\"900\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Oregano\";a:3:{s:6:\"family\";s:7:\"Oregano\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Orienta\";a:3:{s:6:\"family\";s:7:\"Orienta\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:15:\"Original Surfer\";a:3:{s:6:\"family\";s:15:\"Original Surfer\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Oswald\";a:3:{s:6:\"family\";s:6:\"Oswald\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:16:\"Over the Rainbow\";a:3:{s:6:\"family\";s:16:\"Over the Rainbow\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Overlock\";a:3:{s:6:\"family\";s:8:\"Overlock\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";i:4;s:3:\"900\";i:5;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Overlock SC\";a:3:{s:6:\"family\";s:11:\"Overlock SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Overpass\";a:3:{s:6:\"family\";s:8:\"Overpass\";s:8:\"variants\";a:16:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";i:12;s:3:\"800\";i:13;s:9:\"800italic\";i:14;s:3:\"900\";i:15;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Overpass Mono\";a:3:{s:6:\"family\";s:13:\"Overpass Mono\";s:8:\"variants\";a:4:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:3:\"Ovo\";a:3:{s:6:\"family\";s:3:\"Ovo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Oxanium\";a:3:{s:6:\"family\";s:7:\"Oxanium\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";i:6;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Oxygen\";a:3:{s:6:\"family\";s:6:\"Oxygen\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Oxygen Mono\";a:3:{s:6:\"family\";s:11:\"Oxygen Mono\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"PT Mono\";a:3:{s:6:\"family\";s:7:\"PT Mono\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:7:\"PT Sans\";a:3:{s:6:\"family\";s:7:\"PT Sans\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:15:\"PT Sans Caption\";a:3:{s:6:\"family\";s:15:\"PT Sans Caption\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:14:\"PT Sans Narrow\";a:3:{s:6:\"family\";s:14:\"PT Sans Narrow\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:8:\"PT Serif\";a:3:{s:6:\"family\";s:8:\"PT Serif\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:16:\"PT Serif Caption\";a:3:{s:6:\"family\";s:16:\"PT Serif Caption\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:8:\"Pacifico\";a:3:{s:6:\"family\";s:8:\"Pacifico\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:6:\"Padauk\";a:3:{s:6:\"family\";s:6:\"Padauk\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:7:\"myanmar\";}}s:9:\"Palanquin\";a:3:{s:6:\"family\";s:9:\"Palanquin\";s:8:\"variants\";a:7:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:14:\"Palanquin Dark\";a:3:{s:6:\"family\";s:14:\"Palanquin Dark\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:8:\"Pangolin\";a:3:{s:6:\"family\";s:8:\"Pangolin\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:7:\"Paprika\";a:3:{s:6:\"family\";s:7:\"Paprika\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Parisienne\";a:3:{s:6:\"family\";s:10:\"Parisienne\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Passero One\";a:3:{s:6:\"family\";s:11:\"Passero One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Passion One\";a:3:{s:6:\"family\";s:11:\"Passion One\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:18:\"Pathway Gothic One\";a:3:{s:6:\"family\";s:18:\"Pathway Gothic One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Patrick Hand\";a:3:{s:6:\"family\";s:12:\"Patrick Hand\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:15:\"Patrick Hand SC\";a:3:{s:6:\"family\";s:15:\"Patrick Hand SC\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"Pattaya\";a:3:{s:6:\"family\";s:7:\"Pattaya\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:4:\"thai\";i:4;s:10:\"vietnamese\";}}s:9:\"Patua One\";a:3:{s:6:\"family\";s:9:\"Patua One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Pavanam\";a:3:{s:6:\"family\";s:7:\"Pavanam\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:5:\"tamil\";}}s:11:\"Paytone One\";a:3:{s:6:\"family\";s:11:\"Paytone One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"Peddana\";a:3:{s:6:\"family\";s:7:\"Peddana\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:7:\"Peralta\";a:3:{s:6:\"family\";s:7:\"Peralta\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"Permanent Marker\";a:3:{s:6:\"family\";s:16:\"Permanent Marker\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:19:\"Petit Formal Script\";a:3:{s:6:\"family\";s:19:\"Petit Formal Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Petrona\";a:3:{s:6:\"family\";s:7:\"Petrona\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Philosopher\";a:3:{s:6:\"family\";s:11:\"Philosopher\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:10:\"vietnamese\";}}s:6:\"Piedra\";a:3:{s:6:\"family\";s:6:\"Piedra\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Pinyon Script\";a:3:{s:6:\"family\";s:13:\"Pinyon Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Pirata One\";a:3:{s:6:\"family\";s:10:\"Pirata One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Plaster\";a:3:{s:6:\"family\";s:7:\"Plaster\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Play\";a:3:{s:6:\"family\";s:4:\"Play\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:8:\"Playball\";a:3:{s:6:\"family\";s:8:\"Playball\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"Playfair Display\";a:3:{s:6:\"family\";s:16:\"Playfair Display\";s:8:\"variants\";a:12:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";i:5;s:3:\"900\";i:6;s:6:\"italic\";i:7;s:9:\"500italic\";i:8;s:9:\"600italic\";i:9;s:9:\"700italic\";i:10;s:9:\"800italic\";i:11;s:9:\"900italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:19:\"Playfair Display SC\";a:3:{s:6:\"family\";s:19:\"Playfair Display SC\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";i:4;s:3:\"900\";i:5;s:9:\"900italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:7:\"Podkova\";a:3:{s:6:\"family\";s:7:\"Podkova\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:10:\"Poiret One\";a:3:{s:6:\"family\";s:10:\"Poiret One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:10:\"Poller One\";a:3:{s:6:\"family\";s:10:\"Poller One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Poly\";a:3:{s:6:\"family\";s:4:\"Poly\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Pompiere\";a:3:{s:6:\"family\";s:8:\"Pompiere\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Pontano Sans\";a:3:{s:6:\"family\";s:12:\"Pontano Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Poor Story\";a:3:{s:6:\"family\";s:10:\"Poor Story\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:7:\"Poppins\";a:3:{s:6:\"family\";s:7:\"Poppins\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:16:\"Port Lligat Sans\";a:3:{s:6:\"family\";s:16:\"Port Lligat Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:16:\"Port Lligat Slab\";a:3:{s:6:\"family\";s:16:\"Port Lligat Slab\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Pragati Narrow\";a:3:{s:6:\"family\";s:14:\"Pragati Narrow\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Prata\";a:3:{s:6:\"family\";s:5:\"Prata\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:10:\"vietnamese\";}}s:11:\"Preahvihear\";a:3:{s:6:\"family\";s:11:\"Preahvihear\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:14:\"Press Start 2P\";a:3:{s:6:\"family\";s:14:\"Press Start 2P\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";}}s:5:\"Pridi\";a:3:{s:6:\"family\";s:5:\"Pridi\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:14:\"Princess Sofia\";a:3:{s:6:\"family\";s:14:\"Princess Sofia\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Prociono\";a:3:{s:6:\"family\";s:8:\"Prociono\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Prompt\";a:3:{s:6:\"family\";s:6:\"Prompt\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:10:\"Prosto One\";a:3:{s:6:\"family\";s:10:\"Prosto One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:11:\"Proza Libre\";a:3:{s:6:\"family\";s:11:\"Proza Libre\";s:8:\"variants\";a:10:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"600\";i:5;s:9:\"600italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";i:8;s:3:\"800\";i:9;s:9:\"800italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Public Sans\";a:3:{s:6:\"family\";s:11:\"Public Sans\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Puritan\";a:3:{s:6:\"family\";s:7:\"Puritan\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Purple Purse\";a:3:{s:6:\"family\";s:12:\"Purple Purse\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Quando\";a:3:{s:6:\"family\";s:6:\"Quando\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Quantico\";a:3:{s:6:\"family\";s:8:\"Quantico\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Quattrocento\";a:3:{s:6:\"family\";s:12:\"Quattrocento\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:17:\"Quattrocento Sans\";a:3:{s:6:\"family\";s:17:\"Quattrocento Sans\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Questrial\";a:3:{s:6:\"family\";s:9:\"Questrial\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Quicksand\";a:3:{s:6:\"family\";s:9:\"Quicksand\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:14:\"Quintessential\";a:3:{s:6:\"family\";s:14:\"Quintessential\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Qwigley\";a:3:{s:6:\"family\";s:7:\"Qwigley\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:15:\"Racing Sans One\";a:3:{s:6:\"family\";s:15:\"Racing Sans One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Radley\";a:3:{s:6:\"family\";s:6:\"Radley\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Rajdhani\";a:3:{s:6:\"family\";s:8:\"Rajdhani\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Rakkas\";a:3:{s:6:\"family\";s:6:\"Rakkas\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Raleway\";a:3:{s:6:\"family\";s:7:\"Raleway\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:12:\"Raleway Dots\";a:3:{s:6:\"family\";s:12:\"Raleway Dots\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Ramabhadra\";a:3:{s:6:\"family\";s:10:\"Ramabhadra\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:8:\"Ramaraja\";a:3:{s:6:\"family\";s:8:\"Ramaraja\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:6:\"Rambla\";a:3:{s:6:\"family\";s:6:\"Rambla\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Rammetto One\";a:3:{s:6:\"family\";s:12:\"Rammetto One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Ranchers\";a:3:{s:6:\"family\";s:8:\"Ranchers\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Rancho\";a:3:{s:6:\"family\";s:6:\"Rancho\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Ranga\";a:3:{s:6:\"family\";s:5:\"Ranga\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:4:\"Rasa\";a:3:{s:6:\"family\";s:4:\"Rasa\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:9:\"Rationale\";a:3:{s:6:\"family\";s:9:\"Rationale\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Ravi Prakash\";a:3:{s:6:\"family\";s:12:\"Ravi Prakash\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:9:\"Recursive\";a:3:{s:6:\"family\";s:9:\"Recursive\";s:8:\"variants\";a:7:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:10:\"vietnamese\";}}s:15:\"Red Hat Display\";a:3:{s:6:\"family\";s:15:\"Red Hat Display\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";i:6;s:3:\"900\";i:7;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Red Hat Text\";a:3:{s:6:\"family\";s:12:\"Red Hat Text\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"500\";i:3;s:9:\"500italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Red Rose\";a:3:{s:6:\"family\";s:8:\"Red Rose\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Redressed\";a:3:{s:6:\"family\";s:9:\"Redressed\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Reem Kufi\";a:3:{s:6:\"family\";s:9:\"Reem Kufi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";}}s:13:\"Reenie Beanie\";a:3:{s:6:\"family\";s:13:\"Reenie Beanie\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Revalia\";a:3:{s:6:\"family\";s:7:\"Revalia\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Rhodium Libre\";a:3:{s:6:\"family\";s:13:\"Rhodium Libre\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Ribeye\";a:3:{s:6:\"family\";s:6:\"Ribeye\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Ribeye Marrow\";a:3:{s:6:\"family\";s:13:\"Ribeye Marrow\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Righteous\";a:3:{s:6:\"family\";s:9:\"Righteous\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Risque\";a:3:{s:6:\"family\";s:6:\"Risque\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Roboto\";a:3:{s:6:\"family\";s:6:\"Roboto\";s:8:\"variants\";a:12:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"900\";i:11;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:16:\"Roboto Condensed\";a:3:{s:6:\"family\";s:16:\"Roboto Condensed\";s:8:\"variants\";a:6:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"700\";i:5;s:9:\"700italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:11:\"Roboto Mono\";a:3:{s:6:\"family\";s:11:\"Roboto Mono\";s:8:\"variants\";a:14:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:9:\"100italic\";i:8;s:9:\"200italic\";i:9;s:9:\"300italic\";i:10;s:6:\"italic\";i:11;s:9:\"500italic\";i:12;s:9:\"600italic\";i:13;s:9:\"700italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:11:\"Roboto Slab\";a:3:{s:6:\"family\";s:11:\"Roboto Slab\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:9:\"Rochester\";a:3:{s:6:\"family\";s:9:\"Rochester\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Rock Salt\";a:3:{s:6:\"family\";s:9:\"Rock Salt\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Rokkitt\";a:3:{s:6:\"family\";s:7:\"Rokkitt\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Romanesco\";a:3:{s:6:\"family\";s:9:\"Romanesco\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Ropa Sans\";a:3:{s:6:\"family\";s:9:\"Ropa Sans\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Rosario\";a:3:{s:6:\"family\";s:7:\"Rosario\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";i:5;s:9:\"300italic\";i:6;s:6:\"italic\";i:7;s:9:\"500italic\";i:8;s:9:\"600italic\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:8:\"Rosarivo\";a:3:{s:6:\"family\";s:8:\"Rosarivo\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Rouge Script\";a:3:{s:6:\"family\";s:12:\"Rouge Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Rowdies\";a:3:{s:6:\"family\";s:7:\"Rowdies\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:9:\"Rozha One\";a:3:{s:6:\"family\";s:9:\"Rozha One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Rubik\";a:3:{s:6:\"family\";s:5:\"Rubik\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";i:8;s:3:\"900\";i:9;s:9:\"900italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:6:\"hebrew\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:14:\"Rubik Mono One\";a:3:{s:6:\"family\";s:14:\"Rubik Mono One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:4:\"Ruda\";a:3:{s:6:\"family\";s:4:\"Ruda\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";i:5;s:3:\"900\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:6:\"Rufina\";a:3:{s:6:\"family\";s:6:\"Rufina\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Ruge Boogie\";a:3:{s:6:\"family\";s:11:\"Ruge Boogie\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Ruluko\";a:3:{s:6:\"family\";s:6:\"Ruluko\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Rum Raisin\";a:3:{s:6:\"family\";s:10:\"Rum Raisin\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Ruslan Display\";a:3:{s:6:\"family\";s:14:\"Ruslan Display\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:9:\"Russo One\";a:3:{s:6:\"family\";s:9:\"Russo One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Ruthie\";a:3:{s:6:\"family\";s:6:\"Ruthie\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:3:\"Rye\";a:3:{s:6:\"family\";s:3:\"Rye\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Sacramento\";a:3:{s:6:\"family\";s:10:\"Sacramento\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Sahitya\";a:3:{s:6:\"family\";s:7:\"Sahitya\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";}}s:4:\"Sail\";a:3:{s:6:\"family\";s:4:\"Sail\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Saira\";a:3:{s:6:\"family\";s:5:\"Saira\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:15:\"Saira Condensed\";a:3:{s:6:\"family\";s:15:\"Saira Condensed\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:21:\"Saira Extra Condensed\";a:3:{s:6:\"family\";s:21:\"Saira Extra Condensed\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:20:\"Saira Semi Condensed\";a:3:{s:6:\"family\";s:20:\"Saira Semi Condensed\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:17:\"Saira Stencil One\";a:3:{s:6:\"family\";s:17:\"Saira Stencil One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:5:\"Salsa\";a:3:{s:6:\"family\";s:5:\"Salsa\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Sanchez\";a:3:{s:6:\"family\";s:7:\"Sanchez\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Sancreek\";a:3:{s:6:\"family\";s:8:\"Sancreek\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Sansita\";a:3:{s:6:\"family\";s:7:\"Sansita\";s:8:\"variants\";a:8:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";i:4;s:3:\"800\";i:5;s:9:\"800italic\";i:6;s:3:\"900\";i:7;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Sarabun\";a:3:{s:6:\"family\";s:7:\"Sarabun\";s:8:\"variants\";a:16:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:6:\"Sarala\";a:3:{s:6:\"family\";s:6:\"Sarala\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:6:\"Sarina\";a:3:{s:6:\"family\";s:6:\"Sarina\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Sarpanch\";a:3:{s:6:\"family\";s:8:\"Sarpanch\";s:8:\"variants\";a:6:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";i:5;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Satisfy\";a:3:{s:6:\"family\";s:7:\"Satisfy\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Sawarabi Gothic\";a:3:{s:6:\"family\";s:15:\"Sawarabi Gothic\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:8:\"japanese\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:15:\"Sawarabi Mincho\";a:3:{s:6:\"family\";s:15:\"Sawarabi Mincho\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"japanese\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Scada\";a:3:{s:6:\"family\";s:5:\"Scada\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";}}s:12:\"Scheherazade\";a:3:{s:6:\"family\";s:12:\"Scheherazade\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";}}s:10:\"Schoolbell\";a:3:{s:6:\"family\";s:10:\"Schoolbell\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Scope One\";a:3:{s:6:\"family\";s:9:\"Scope One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"Seaweed Script\";a:3:{s:6:\"family\";s:14:\"Seaweed Script\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Secular One\";a:3:{s:6:\"family\";s:11:\"Secular One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:12:\"Sedgwick Ave\";a:3:{s:6:\"family\";s:12:\"Sedgwick Ave\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:20:\"Sedgwick Ave Display\";a:3:{s:6:\"family\";s:20:\"Sedgwick Ave Display\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:3:\"Sen\";a:3:{s:6:\"family\";s:3:\"Sen\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Sevillana\";a:3:{s:6:\"family\";s:9:\"Sevillana\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Seymour One\";a:3:{s:6:\"family\";s:11:\"Seymour One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:18:\"Shadows Into Light\";a:3:{s:6:\"family\";s:18:\"Shadows Into Light\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:22:\"Shadows Into Light Two\";a:3:{s:6:\"family\";s:22:\"Shadows Into Light Two\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Shanti\";a:3:{s:6:\"family\";s:6:\"Shanti\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Share\";a:3:{s:6:\"family\";s:5:\"Share\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Share Tech\";a:3:{s:6:\"family\";s:10:\"Share Tech\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Share Tech Mono\";a:3:{s:6:\"family\";s:15:\"Share Tech Mono\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Shojumaru\";a:3:{s:6:\"family\";s:9:\"Shojumaru\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Short Stack\";a:3:{s:6:\"family\";s:11:\"Short Stack\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Shrikhand\";a:3:{s:6:\"family\";s:9:\"Shrikhand\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"gujarati\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:8:\"Siemreap\";a:3:{s:6:\"family\";s:8:\"Siemreap\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:10:\"Sigmar One\";a:3:{s:6:\"family\";s:10:\"Sigmar One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"Signika\";a:3:{s:6:\"family\";s:7:\"Signika\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:16:\"Signika Negative\";a:3:{s:6:\"family\";s:16:\"Signika Negative\";s:8:\"variants\";a:4:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"600\";i:3;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Simonetta\";a:3:{s:6:\"family\";s:9:\"Simonetta\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"900\";i:3;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Single Day\";a:3:{s:6:\"family\";s:10:\"Single Day\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:6:\"korean\";}}s:7:\"Sintony\";a:3:{s:6:\"family\";s:7:\"Sintony\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Sirin Stencil\";a:3:{s:6:\"family\";s:13:\"Sirin Stencil\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Six Caps\";a:3:{s:6:\"family\";s:8:\"Six Caps\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Skranji\";a:3:{s:6:\"family\";s:7:\"Skranji\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Slabo 13px\";a:3:{s:6:\"family\";s:10:\"Slabo 13px\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Slabo 27px\";a:3:{s:6:\"family\";s:10:\"Slabo 27px\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Slackey\";a:3:{s:6:\"family\";s:7:\"Slackey\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Smokum\";a:3:{s:6:\"family\";s:6:\"Smokum\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Smythe\";a:3:{s:6:\"family\";s:6:\"Smythe\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Sniglet\";a:3:{s:6:\"family\";s:7:\"Sniglet\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Snippet\";a:3:{s:6:\"family\";s:7:\"Snippet\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Snowburst One\";a:3:{s:6:\"family\";s:13:\"Snowburst One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Sofadi One\";a:3:{s:6:\"family\";s:10:\"Sofadi One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:5:\"Sofia\";a:3:{s:6:\"family\";s:5:\"Sofia\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Solway\";a:3:{s:6:\"family\";s:6:\"Solway\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Song Myung\";a:3:{s:6:\"family\";s:10:\"Song Myung\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:10:\"Sonsie One\";a:3:{s:6:\"family\";s:10:\"Sonsie One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:4:\"Sora\";a:3:{s:6:\"family\";s:4:\"Sora\";s:8:\"variants\";a:8:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:16:\"Sorts Mill Goudy\";a:3:{s:6:\"family\";s:16:\"Sorts Mill Goudy\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:15:\"Source Code Pro\";a:3:{s:6:\"family\";s:15:\"Source Code Pro\";s:8:\"variants\";a:14:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";i:12;s:3:\"900\";i:13;s:9:\"900italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:15:\"Source Sans Pro\";a:3:{s:6:\"family\";s:15:\"Source Sans Pro\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"900\";i:11;s:9:\"900italic\";}s:7:\"subsets\";a:7:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";i:6;s:10:\"vietnamese\";}}s:16:\"Source Serif Pro\";a:3:{s:6:\"family\";s:16:\"Source Serif Pro\";s:8:\"variants\";a:12:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"900\";i:11;s:9:\"900italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:10:\"Space Mono\";a:3:{s:6:\"family\";s:10:\"Space Mono\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:7:\"Spartan\";a:3:{s:6:\"family\";s:7:\"Spartan\";s:8:\"variants\";a:9:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Special Elite\";a:3:{s:6:\"family\";s:13:\"Special Elite\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Spectral\";a:3:{s:6:\"family\";s:8:\"Spectral\";s:8:\"variants\";a:14:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";i:12;s:3:\"800\";i:13;s:9:\"800italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:11:\"Spectral SC\";a:3:{s:6:\"family\";s:11:\"Spectral SC\";s:8:\"variants\";a:14:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"500\";i:7;s:9:\"500italic\";i:8;s:3:\"600\";i:9;s:9:\"600italic\";i:10;s:3:\"700\";i:11;s:9:\"700italic\";i:12;s:3:\"800\";i:13;s:9:\"800italic\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:10:\"Spicy Rice\";a:3:{s:6:\"family\";s:10:\"Spicy Rice\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Spinnaker\";a:3:{s:6:\"family\";s:9:\"Spinnaker\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Spirax\";a:3:{s:6:\"family\";s:6:\"Spirax\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:10:\"Squada One\";a:3:{s:6:\"family\";s:10:\"Squada One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:20:\"Sree Krushnadevaraya\";a:3:{s:6:\"family\";s:20:\"Sree Krushnadevaraya\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:8:\"Sriracha\";a:3:{s:6:\"family\";s:8:\"Sriracha\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:8:\"Srisakdi\";a:3:{s:6:\"family\";s:8:\"Srisakdi\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:11:\"Staatliches\";a:3:{s:6:\"family\";s:11:\"Staatliches\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Stalemate\";a:3:{s:6:\"family\";s:9:\"Stalemate\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Stalinist One\";a:3:{s:6:\"family\";s:13:\"Stalinist One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:15:\"Stardos Stencil\";a:3:{s:6:\"family\";s:15:\"Stardos Stencil\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:21:\"Stint Ultra Condensed\";a:3:{s:6:\"family\";s:21:\"Stint Ultra Condensed\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:20:\"Stint Ultra Expanded\";a:3:{s:6:\"family\";s:20:\"Stint Ultra Expanded\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Stoke\";a:3:{s:6:\"family\";s:5:\"Stoke\";s:8:\"variants\";a:2:{i:0;s:3:\"300\";i:1;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Strait\";a:3:{s:6:\"family\";s:6:\"Strait\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Stylish\";a:3:{s:6:\"family\";s:7:\"Stylish\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:19:\"Sue Ellen Francisco\";a:3:{s:6:\"family\";s:19:\"Sue Ellen Francisco\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Suez One\";a:3:{s:6:\"family\";s:8:\"Suez One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:13:\"Sulphur Point\";a:3:{s:6:\"family\";s:13:\"Sulphur Point\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Sumana\";a:3:{s:6:\"family\";s:6:\"Sumana\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:9:\"Sunflower\";a:3:{s:6:\"family\";s:9:\"Sunflower\";s:8:\"variants\";a:3:{i:0;s:3:\"300\";i:1;s:3:\"500\";i:2;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:9:\"Sunshiney\";a:3:{s:6:\"family\";s:9:\"Sunshiney\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:16:\"Supermercado One\";a:3:{s:6:\"family\";s:16:\"Supermercado One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Sura\";a:3:{s:6:\"family\";s:4:\"Sura\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Suranna\";a:3:{s:6:\"family\";s:7:\"Suranna\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:9:\"Suravaram\";a:3:{s:6:\"family\";s:9:\"Suravaram\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:11:\"Suwannaphum\";a:3:{s:6:\"family\";s:11:\"Suwannaphum\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:18:\"Swanky and Moo Moo\";a:3:{s:6:\"family\";s:18:\"Swanky and Moo Moo\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Syncopate\";a:3:{s:6:\"family\";s:9:\"Syncopate\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Tajawal\";a:3:{s:6:\"family\";s:7:\"Tajawal\";s:8:\"variants\";a:7:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"800\";i:6;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";}}s:9:\"Tangerine\";a:3:{s:6:\"family\";s:9:\"Tangerine\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Taprom\";a:3:{s:6:\"family\";s:6:\"Taprom\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"khmer\";}}s:5:\"Tauri\";a:3:{s:6:\"family\";s:5:\"Tauri\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Taviraj\";a:3:{s:6:\"family\";s:7:\"Taviraj\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:4:\"Teko\";a:3:{s:6:\"family\";s:4:\"Teko\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:5:\"Telex\";a:3:{s:6:\"family\";s:5:\"Telex\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:18:\"Tenali Ramakrishna\";a:3:{s:6:\"family\";s:18:\"Tenali Ramakrishna\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:10:\"Tenor Sans\";a:3:{s:6:\"family\";s:10:\"Tenor Sans\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:11:\"Text Me One\";a:3:{s:6:\"family\";s:11:\"Text Me One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Thasadith\";a:3:{s:6:\"family\";s:9:\"Thasadith\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:18:\"The Girl Next Door\";a:3:{s:6:\"family\";s:18:\"The Girl Next Door\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Tienne\";a:3:{s:6:\"family\";s:6:\"Tienne\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:3:\"700\";i:2;s:3:\"900\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Tillana\";a:3:{s:6:\"family\";s:7:\"Tillana\";s:8:\"variants\";a:5:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:7:\"Timmana\";a:3:{s:6:\"family\";s:7:\"Timmana\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:6:\"telugu\";}}s:5:\"Tinos\";a:3:{s:6:\"family\";s:5:\"Tinos\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:8:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:6:\"hebrew\";i:5;s:5:\"latin\";i:6;s:9:\"latin-ext\";i:7;s:10:\"vietnamese\";}}s:9:\"Titan One\";a:3:{s:6:\"family\";s:9:\"Titan One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:13:\"Titillium Web\";a:3:{s:6:\"family\";s:13:\"Titillium Web\";s:8:\"variants\";a:11:{i:0;s:3:\"200\";i:1;s:9:\"200italic\";i:2;s:3:\"300\";i:3;s:9:\"300italic\";i:4;s:7:\"regular\";i:5;s:6:\"italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";i:10;s:3:\"900\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Tomorrow\";a:3:{s:6:\"family\";s:8:\"Tomorrow\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:11:\"Trade Winds\";a:3:{s:6:\"family\";s:11:\"Trade Winds\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Trirong\";a:3:{s:6:\"family\";s:7:\"Trirong\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:9:\"100italic\";i:2;s:3:\"200\";i:3;s:9:\"200italic\";i:4;s:3:\"300\";i:5;s:9:\"300italic\";i:6;s:7:\"regular\";i:7;s:6:\"italic\";i:8;s:3:\"500\";i:9;s:9:\"500italic\";i:10;s:3:\"600\";i:11;s:9:\"600italic\";i:12;s:3:\"700\";i:13;s:9:\"700italic\";i:14;s:3:\"800\";i:15;s:9:\"800italic\";i:16;s:3:\"900\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:4:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:4:\"thai\";i:3;s:10:\"vietnamese\";}}s:7:\"Trocchi\";a:3:{s:6:\"family\";s:7:\"Trocchi\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Trochut\";a:3:{s:6:\"family\";s:7:\"Trochut\";s:8:\"variants\";a:3:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Trykker\";a:3:{s:6:\"family\";s:7:\"Trykker\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:10:\"Tulpen One\";a:3:{s:6:\"family\";s:10:\"Tulpen One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:11:\"Turret Road\";a:3:{s:6:\"family\";s:11:\"Turret Road\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"800\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Ubuntu\";a:3:{s:6:\"family\";s:6:\"Ubuntu\";s:8:\"variants\";a:8:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";i:6;s:3:\"700\";i:7;s:9:\"700italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";}}s:16:\"Ubuntu Condensed\";a:3:{s:6:\"family\";s:16:\"Ubuntu Condensed\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";}}s:11:\"Ubuntu Mono\";a:3:{s:6:\"family\";s:11:\"Ubuntu Mono\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:9:\"greek-ext\";i:4;s:5:\"latin\";i:5;s:9:\"latin-ext\";}}s:5:\"Ultra\";a:3:{s:6:\"family\";s:5:\"Ultra\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:14:\"Uncial Antiqua\";a:3:{s:6:\"family\";s:14:\"Uncial Antiqua\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Underdog\";a:3:{s:6:\"family\";s:8:\"Underdog\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:9:\"Unica One\";a:3:{s:6:\"family\";s:9:\"Unica One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:14:\"UnifrakturCook\";a:3:{s:6:\"family\";s:14:\"UnifrakturCook\";s:8:\"variants\";a:1:{i:0;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:18:\"UnifrakturMaguntia\";a:3:{s:6:\"family\";s:18:\"UnifrakturMaguntia\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:7:\"Unkempt\";a:3:{s:6:\"family\";s:7:\"Unkempt\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Unlock\";a:3:{s:6:\"family\";s:6:\"Unlock\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Unna\";a:3:{s:6:\"family\";s:4:\"Unna\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"VT323\";a:3:{s:6:\"family\";s:5:\"VT323\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Vampiro One\";a:3:{s:6:\"family\";s:11:\"Vampiro One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:6:\"Varela\";a:3:{s:6:\"family\";s:6:\"Varela\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"Varela Round\";a:3:{s:6:\"family\";s:12:\"Varela Round\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:4:{i:0;s:6:\"hebrew\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:5:\"Varta\";a:3:{s:6:\"family\";s:5:\"Varta\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:11:\"Vast Shadow\";a:3:{s:6:\"family\";s:11:\"Vast Shadow\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:12:\"Vesper Libre\";a:3:{s:6:\"family\";s:12:\"Vesper Libre\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"700\";i:3;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:12:\"Viaoda Libre\";a:3:{s:6:\"family\";s:12:\"Viaoda Libre\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:5:\"Vibes\";a:3:{s:6:\"family\";s:5:\"Vibes\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"arabic\";i:1;s:5:\"latin\";}}s:5:\"Vibur\";a:3:{s:6:\"family\";s:5:\"Vibur\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Vidaloka\";a:3:{s:6:\"family\";s:8:\"Vidaloka\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Viga\";a:3:{s:6:\"family\";s:4:\"Viga\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:5:\"Voces\";a:3:{s:6:\"family\";s:5:\"Voces\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:7:\"Volkhov\";a:3:{s:6:\"family\";s:7:\"Volkhov\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:6:\"italic\";i:2;s:3:\"700\";i:3;s:9:\"700italic\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Vollkorn\";a:3:{s:6:\"family\";s:8:\"Vollkorn\";s:8:\"variants\";a:12:{i:0;s:7:\"regular\";i:1;s:3:\"500\";i:2;s:3:\"600\";i:3;s:3:\"700\";i:4;s:3:\"800\";i:5;s:3:\"900\";i:6;s:6:\"italic\";i:7;s:9:\"500italic\";i:8;s:9:\"600italic\";i:9;s:9:\"700italic\";i:10;s:9:\"800italic\";i:11;s:9:\"900italic\";}s:7:\"subsets\";a:6:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"greek\";i:3;s:5:\"latin\";i:4;s:9:\"latin-ext\";i:5;s:10:\"vietnamese\";}}s:11:\"Vollkorn SC\";a:3:{s:6:\"family\";s:11:\"Vollkorn SC\";s:8:\"variants\";a:4:{i:0;s:7:\"regular\";i:1;s:3:\"600\";i:2;s:3:\"700\";i:3;s:3:\"900\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:8:\"Voltaire\";a:3:{s:6:\"family\";s:8:\"Voltaire\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:23:\"Waiting for the Sunrise\";a:3:{s:6:\"family\";s:23:\"Waiting for the Sunrise\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:8:\"Wallpoet\";a:3:{s:6:\"family\";s:8:\"Wallpoet\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:15:\"Walter Turncoat\";a:3:{s:6:\"family\";s:15:\"Walter Turncoat\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:6:\"Warnes\";a:3:{s:6:\"family\";s:6:\"Warnes\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Wellfleet\";a:3:{s:6:\"family\";s:9:\"Wellfleet\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:9:\"Wendy One\";a:3:{s:6:\"family\";s:9:\"Wendy One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:8:\"Wire One\";a:3:{s:6:\"family\";s:8:\"Wire One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Work Sans\";a:3:{s:6:\"family\";s:9:\"Work Sans\";s:8:\"variants\";a:18:{i:0;s:3:\"100\";i:1;s:3:\"200\";i:2;s:3:\"300\";i:3;s:7:\"regular\";i:4;s:3:\"500\";i:5;s:3:\"600\";i:6;s:3:\"700\";i:7;s:3:\"800\";i:8;s:3:\"900\";i:9;s:9:\"100italic\";i:10;s:9:\"200italic\";i:11;s:9:\"300italic\";i:12;s:6:\"italic\";i:13;s:9:\"500italic\";i:14;s:9:\"600italic\";i:15;s:9:\"700italic\";i:16;s:9:\"800italic\";i:17;s:9:\"900italic\";}s:7:\"subsets\";a:3:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";i:2;s:10:\"vietnamese\";}}s:17:\"Yanone Kaffeesatz\";a:3:{s:6:\"family\";s:17:\"Yanone Kaffeesatz\";s:8:\"variants\";a:6:{i:0;s:3:\"200\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"600\";i:5;s:3:\"700\";}s:7:\"subsets\";a:4:{i:0;s:8:\"cyrillic\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";i:3;s:10:\"vietnamese\";}}s:11:\"Yantramanav\";a:3:{s:6:\"family\";s:11:\"Yantramanav\";s:8:\"variants\";a:6:{i:0;s:3:\"100\";i:1;s:3:\"300\";i:2;s:7:\"regular\";i:3;s:3:\"500\";i:4;s:3:\"700\";i:5;s:3:\"900\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:9:\"Yatra One\";a:3:{s:6:\"family\";s:9:\"Yatra One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:3:{i:0;s:10:\"devanagari\";i:1;s:5:\"latin\";i:2;s:9:\"latin-ext\";}}s:10:\"Yellowtail\";a:3:{s:6:\"family\";s:10:\"Yellowtail\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:9:\"Yeon Sung\";a:3:{s:6:\"family\";s:9:\"Yeon Sung\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:6:\"korean\";i:1;s:5:\"latin\";}}s:10:\"Yeseva One\";a:3:{s:6:\"family\";s:10:\"Yeseva One\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:5:{i:0;s:8:\"cyrillic\";i:1;s:12:\"cyrillic-ext\";i:2;s:5:\"latin\";i:3;s:9:\"latin-ext\";i:4;s:10:\"vietnamese\";}}s:10:\"Yesteryear\";a:3:{s:6:\"family\";s:10:\"Yesteryear\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:4:\"Yrsa\";a:3:{s:6:\"family\";s:4:\"Yrsa\";s:8:\"variants\";a:5:{i:0;s:3:\"300\";i:1;s:7:\"regular\";i:2;s:3:\"500\";i:3;s:3:\"600\";i:4;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:12:\"ZCOOL KuaiLe\";a:3:{s:6:\"family\";s:12:\"ZCOOL KuaiLe\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:21:\"ZCOOL QingKe HuangYou\";a:3:{s:6:\"family\";s:21:\"ZCOOL QingKe HuangYou\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:13:\"ZCOOL XiaoWei\";a:3:{s:6:\"family\";s:13:\"ZCOOL XiaoWei\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:6:\"Zeyada\";a:3:{s:6:\"family\";s:6:\"Zeyada\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:1:{i:0;s:5:\"latin\";}}s:13:\"Zhi Mang Xing\";a:3:{s:6:\"family\";s:13:\"Zhi Mang Xing\";s:8:\"variants\";a:1:{i:0;s:7:\"regular\";}s:7:\"subsets\";a:2:{i:0;s:18:\"chinese-simplified\";i:1;s:5:\"latin\";}}s:10:\"Zilla Slab\";a:3:{s:6:\"family\";s:10:\"Zilla Slab\";s:8:\"variants\";a:10:{i:0;s:3:\"300\";i:1;s:9:\"300italic\";i:2;s:7:\"regular\";i:3;s:6:\"italic\";i:4;s:3:\"500\";i:5;s:9:\"500italic\";i:6;s:3:\"600\";i:7;s:9:\"600italic\";i:8;s:3:\"700\";i:9;s:9:\"700italic\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}s:20:\"Zilla Slab Highlight\";a:3:{s:6:\"family\";s:20:\"Zilla Slab Highlight\";s:8:\"variants\";a:2:{i:0;s:7:\"regular\";i:1;s:3:\"700\";}s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}}}', 'no'),
 (1498, '_site_transient_timeout_cerber_daily_1', '1597332807', 'no'),
 (1499, '_site_transient_cerber_daily_1', 'a:2:{i:0;i:1597160007;i:1;i:1597160007;}', 'no'),
 (1560, '_site_transient_timeout_community-events-7c9823f65864b35e648990605a90302f', '1597203500', 'no'),
 (747, '_transient_timeout_zn_server_connection_check', '1617372762', 'no'),
 (748, '_transient_zn_server_connection_check', 'ok', 'no'),
 (755, 'theme_mods_kallyas-child', 'a:3:{i:0;b:0;s:18:\"nav_menu_locations\";a:1:{s:15:\"main_navigation\";i:516;}s:18:\"custom_css_post_id\";i:-1;}', 'yes'),
 (1223, 'auto_core_update_notified', 'a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:27:\"vicosolutions.com@gmail.com\";s:7:\"version\";s:5:\"5.4.1\";s:9:\"timestamp\";i:1588233404;}', 'no'),
 (1507, '_site_transient_timeout_php_check_75e04be8322671c786117633c455e7a7', '1597675388', 'no'),
 (1508, '_site_transient_php_check_75e04be8322671c786117633c455e7a7', 'a:5:{s:19:\"recommended_version\";s:3:\"7.4\";s:15:\"minimum_version\";s:6:\"5.6.20\";s:12:\"is_supported\";b:0;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}', 'no'),
 (1780, 'action_scheduler_migration_status', 'complete', 'yes'),
 (1785, 'zn_permalinks', 'a:5:{s:9:\"portfolio\";s:0:\"\";s:16:\"project_category\";s:0:\"\";s:14:\"portfolio_tags\";s:0:\"\";s:13:\"documentation\";s:0:\"\";s:22:\"documentation_category\";s:0:\"\";}', 'yes'),
 (1787, 'zn_kallyas_custom_css', '/* Align menu with logo */\r\n.main-nav > ul > .menu-item {\r\n    margin-top: 23px;\r\n}\r\n/* logo container */\r\n.site-header.kl-center-menu .zn-original-logo {margin-left: 0px;}\r\n.main-nav > ul > .menu-item a {font-family: \"Open Sans\"; font-weight: 300;}\r\n\r\n/* push the header mini cart button to the right */\r\n.site-header-main-right {\r\n    -webkit-box-ordinal-group: 2;\r\n    -ms-flex-order: 1;\r\n    order: 1;\r\n}\r\n\r\n.site-header-main-center {\r\n    -webkit-box-ordinal-group: 3;\r\n    -ms-flex-order: 2;\r\n    order: 2; \r\n}\r\n\r\n.site-header-main-left {\r\n    -webkit-box-ordinal-group: 4;\r\n    -ms-flex-order: 3;\r\n    order: 3;\r\n}\r\n\r\n.site-header .site-header-main-right .sh-component:last-child {\r\n    margin-left: 0 !important;\r\n}\r\n\r\n/*Reposition cart to the right*/\r\n.site-header .site-header-col-left .topnav-drop .topnav-drop-panel {\r\n    left: auto;\r\n    right: 0;\r\n}\r\n.site-header .site-header-col-left .topnav-drop-panel-inner:after {\r\n    left: auto;\r\n    right: 10px;\r\n}\r\n\r\n/* header mini cart button style */\r\n.kl-cart-button .svg-cart.kl-cart-icon:after {\r\n    background-color: #fff;\r\n    color: #000;\r\n}\r\n\r\n@media (min-width: 768px) {\r\n    .site-header.style13.kl-center-menu .main-nav > ul > li > a {\r\n        line-height: 42px;\r\n    }\r\n}\r\n\r\n/* Category section */\r\n#category .col-sm-4.col-md-4 {\r\n    padding-right: 0px;\r\n    padding-left: 0px;\r\n}\r\n#category .col-sm-4.col-md-4 .znColumnElement-innerWrapper {\r\n    border-left: 0px;\r\n    border-bottom: 0px;\r\n}\r\n\r\n/* BOUQUETS section */\r\n\r\n.zn_badge_container {top: 30px; left: -10px;}\r\n.zn_badge_sale, \r\n.zn_badge_new, \r\n.zn_badge_soldout {font-size: 12px; font-weight: bold; border-radius: 0; padding: 15px 18px;}\r\n.zn_badge_sale:after {content: none;}\r\n\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic:before {box-shadow: none;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic:hover:before {box-shadow: inset 0 0 0 4px #ff6666;}\r\n\r\n/* Woocommerce archive changes */\r\n.eluidd21e945a .page-title,\r\n.eluidd21e945a .woocommerce-result-count,\r\n.eluidd21e945a .woocommerce-ordering,\r\n.eluidd21e945a .kw-actions{display: none;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .kw-details {background: #f3f3f3; min-height: 100px;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic:hover .kw-details {background: #fff;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .kw-details-title {min-height: auto}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .kw-details-desc {background: transparent; color: #939393; height: auto;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .kw-details-desc p:last-of-type {margin-bottom: 0;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .price .amount,\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .price del, \r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .price ins {\r\n    font-size: 14px;\r\n    line-height: 50px;\r\n    text-align: center;\r\n    background: #fff;\r\n    width: 50px;\r\n    height: 50px;\r\n    border-radius: 50%;\r\n    display: inline-block;\r\n    -webkit-transition: all 0.25s ease-out;\r\n    transition: all 0.25s ease-out;\r\n}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic:hover .price .amount,\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic:hover .price del, \r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic:hover .price ins {\r\n    background: #f7f7f7;\r\n}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .price ins {\r\n    color: #ff6666;\r\n    float: right;\r\n}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .price del {\r\n    margin-right: 5px;\r\n}\r\n\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .price del span {\r\n    color: #000;\r\n}\r\n\r\n.eluidd21e945a .product-list-item:hover .woocommerce-Price-amount{background: #edecec;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic .kw-details-title {font-size: 14px; font-weight: bold; display: inline-block;}\r\n.woocommerce ul.products li.product .product-list-item.prod-layout-classic:hover .kw-details-title {color: #2f2f2f;}\r\n.woocommerce ul.products li.product {margin: 0 0 100px;}\r\n.eluid2e717c50 p:before {font-size: 100px; line-height: 20px; font-family: Times New Roman, Georgia, Serif; color: #fff; content:\'“\';position: absolute; top: 20px; left: -30px; }\r\n.eluid2e717c50 p:after {font-size: 100px; line-height: 20px; font-family: Times New Roman, Georgia, Serif; color: #fff; content:\'”\';top: 100px; right: 0px; position: absolute;}\r\n\r\n@media (min-width: 992px) {\r\n    .woocommerce div:not([class*=\"_sidebar\"]) ul.products li.product .product-list-item.prod-layout-classic .price {\r\n        color: #ff6666;\r\n        position: absolute;\r\n        right: 20px;\r\n        top: 25px;\r\n    }\r\n}\r\n\r\n/* Footer newsletter */\r\n.nlbox--style-transparent .elm-nlbox__input {color: #000;}\r\n\r\n/* InfoCart*/\r\n.cart-container .buttons .button.checkout {background-color: #99cc66!important; color: #fff!important; float: right;}\r\n.cart-container .buttons .button.checkout:hover {background-color: #98bd74!important;}\r\n.cart-container .buttons .button,\r\n.cart-container .buttons .button.checkout {padding: 13px 0; border: none; text-transform: capitalize;}\r\n.woocommerce-mini-cart__total {display: none;}\r\n.topnav-drop-panel.topnav--cart-panel {min-width: 320px;}\r\n.cart-container .buttons .button {width: calc(43% - 6px);}\r\n/*.cart-container {padding: 0px;}*/\r\n.cart-container .cart_list {border: none; padding: 30px; background: #f5f5f5; margin: 0px;}\r\n.woocommerce ul.cart_list, .woocommerce ul.product_list_widget {padding: 30px;}\r\n.woocommerce-mini-cart__buttons {padding: 20px 30px; background: #e9e9e9;}\r\n.cart-container .mini_cart_item a:not(.remove) {font-size: 13px;}\r\n.woocommerce-mini-cart .quantity {font-size: 13px; color: #ff6666; line-height: 30px;}\r\n.single-product .cart-container .cart_list .remove {margin-top: -10px; padding-left: 10px;}\r\n.cart-container .cart_list .remove {font-size: 36px; font-weight: 300; margin-top: -20px; padding-left: 20px;}\r\n.cart-container .cart_list a:hover {color: #000!important;}\r\n\r\n.znBoxShadow-6, .znBoxShadow--hov-6:hover {\r\n    -webkit-box-shadow: 0 0 27px 0 rgba(0, 0, 0, 0.17);\r\n    box-shadow: 0 0 27px 0 rgba(0, 0, 0, 0.17);\r\n}', 'yes'),
 (1796, '_transient_wc_count_comments', 'O:8:\"stdClass\":7:{s:14:\"total_comments\";i:1;s:3:\"all\";i:1;s:8:\"approved\";s:1:\"1\";s:9:\"moderated\";i:0;s:4:\"spam\";i:0;s:5:\"trash\";i:0;s:12:\"post-trashed\";i:0;}', 'yes'),
 (1800, '_transient_timeout__woocommerce_helper_updates', '1597203985', 'no'),
 (1801, '_transient__woocommerce_helper_updates', 'a:4:{s:4:\"hash\";s:32:\"d751713988987e9331980363e24189ce\";s:7:\"updated\";i:1597160785;s:8:\"products\";a:0:{}s:6:\"errors\";a:1:{i:0;s:10:\"http-error\";}}', 'no'),
 (1802, '_site_transient_update_plugins', 'O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1597160786;s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:7:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:21:\"w.org/plugins/akismet\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:5:\"4.1.6\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/akismet.4.1.6.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:59:\"https://ps.w.org/akismet/assets/icon-256x256.png?rev=969272\";s:2:\"1x\";s:59:\"https://ps.w.org/akismet/assets/icon-128x128.png?rev=969272\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:61:\"https://ps.w.org/akismet/assets/banner-772x250.jpg?rev=479904\";}s:11:\"banners_rtl\";a:0:{}}s:37:\"login-customizer/login-customizer.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:30:\"w.org/plugins/login-customizer\";s:4:\"slug\";s:16:\"login-customizer\";s:6:\"plugin\";s:37:\"login-customizer/login-customizer.php\";s:11:\"new_version\";s:5:\"2.0.1\";s:3:\"url\";s:47:\"https://wordpress.org/plugins/login-customizer/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/login-customizer.zip\";s:5:\"icons\";a:2:{s:2:\"1x\";s:61:\"https://ps.w.org/login-customizer/assets/icon.svg?rev=1083443\";s:3:\"svg\";s:61:\"https://ps.w.org/login-customizer/assets/icon.svg?rev=1083443\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:71:\"https://ps.w.org/login-customizer/assets/banner-772x250.png?rev=1083443\";}s:11:\"banners_rtl\";a:0:{}}s:9:\"hello.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/hello-dolly\";s:4:\"slug\";s:11:\"hello-dolly\";s:6:\"plugin\";s:9:\"hello.php\";s:11:\"new_version\";s:5:\"1.7.2\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/hello-dolly/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/hello-dolly.1.7.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-256x256.jpg?rev=2052855\";s:2:\"1x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-128x128.jpg?rev=2052855\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:66:\"https://ps.w.org/hello-dolly/assets/banner-772x250.jpg?rev=2052855\";}s:11:\"banners_rtl\";a:0:{}}s:27:\"updraftplus/updraftplus.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/updraftplus\";s:4:\"slug\";s:11:\"updraftplus\";s:6:\"plugin\";s:27:\"updraftplus/updraftplus.php\";s:11:\"new_version\";s:7:\"1.16.26\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/updraftplus/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/updraftplus.1.16.26.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-256x256.jpg?rev=1686200\";s:2:\"1x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-128x128.jpg?rev=1686200\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/updraftplus/assets/banner-1544x500.png?rev=1686200\";s:2:\"1x\";s:66:\"https://ps.w.org/updraftplus/assets/banner-772x250.png?rev=1686200\";}s:11:\"banners_rtl\";a:0:{}}s:27:\"woocommerce/woocommerce.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:6:\"plugin\";s:27:\"woocommerce/woocommerce.php\";s:11:\"new_version\";s:5:\"4.3.2\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/woocommerce/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/woocommerce.4.3.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/woocommerce/assets/icon-256x256.png?rev=2075035\";s:2:\"1x\";s:64:\"https://ps.w.org/woocommerce/assets/icon-128x128.png?rev=2075035\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/woocommerce/assets/banner-1544x500.png?rev=2075035\";s:2:\"1x\";s:66:\"https://ps.w.org/woocommerce/assets/banner-772x250.png?rev=2075035\";}s:11:\"banners_rtl\";a:0:{}}s:23:\"wordfence/wordfence.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:23:\"w.org/plugins/wordfence\";s:4:\"slug\";s:9:\"wordfence\";s:6:\"plugin\";s:23:\"wordfence/wordfence.php\";s:11:\"new_version\";s:6:\"7.4.10\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/wordfence/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/wordfence.7.4.10.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:62:\"https://ps.w.org/wordfence/assets/icon-256x256.png?rev=2070855\";s:2:\"1x\";s:54:\"https://ps.w.org/wordfence/assets/icon.svg?rev=2070865\";s:3:\"svg\";s:54:\"https://ps.w.org/wordfence/assets/icon.svg?rev=2070865\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/wordfence/assets/banner-1544x500.jpg?rev=2124102\";s:2:\"1x\";s:64:\"https://ps.w.org/wordfence/assets/banner-772x250.jpg?rev=2124102\";}s:11:\"banners_rtl\";a:0:{}}s:23:\"wp-cerber/wp-cerber.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:23:\"w.org/plugins/wp-cerber\";s:4:\"slug\";s:9:\"wp-cerber\";s:6:\"plugin\";s:23:\"wp-cerber/wp-cerber.php\";s:11:\"new_version\";s:5:\"8.6.6\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/wp-cerber/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/wp-cerber.8.6.6.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:62:\"https://ps.w.org/wp-cerber/assets/icon-256x256.png?rev=2344645\";s:2:\"1x\";s:62:\"https://ps.w.org/wp-cerber/assets/icon-128x128.png?rev=2344628\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/wp-cerber/assets/banner-1544x500.png?rev=2344628\";s:2:\"1x\";s:64:\"https://ps.w.org/wp-cerber/assets/banner-772x250.png?rev=2344628\";}s:11:\"banners_rtl\";a:0:{}}}s:7:\"checked\";a:1:{s:33:\"duplicator-pro/duplicator-pro.php\";s:7:\"3.8.3.4\";}}', 'no'),
 (1803, '_transient_timeout_wc_low_stock_count', '1599752787', 'no'),
 (1804, '_transient_wc_low_stock_count', '0', 'no'),
 (1805, '_transient_timeout_wc_outofstock_count', '1599752787', 'no'),
 (1806, '_transient_wc_outofstock_count', '0', 'no'),
 (1808, '_transient_wc_report_sales_by_date', 'a:8:{s:32:\"c2ceda8bccc207df1c8ad07fbc48afe5\";a:0:{}s:32:\"ffe58889669f5e9ba9fdd29c977d2a8d\";a:0:{}s:32:\"9605790da0b6ed77c6aee4d93f5a6f4d\";a:0:{}s:32:\"c0207c87e089215889ce154a33adbf5d\";N;s:32:\"b6e7a19b5eaeffdc520291f601cd3014\";a:0:{}s:32:\"bcfa1d5a886ae32e142be7f89330e2c4\";a:0:{}s:32:\"ccc3f829173106a05ca4d58068f43e76\";a:0:{}s:32:\"2ea3e97630152f5883cf8b70ef00a532\";a:0:{}}', 'no'),
 (1809, '_transient_timeout_wc_admin_report', '1597247187', 'no'),
 (1810, '_transient_wc_admin_report', 'a:1:{s:32:\"dcb598adc1a22f8201bbb163c62405ab\";a:0:{}}', 'no'),
 (1818, 'duplicator_pro_ui_view_state', 'a:2:{s:22:\"dup-pack-storage-panel\";s:1:\"1\";s:22:\"dup-pack-archive-panel\";s:1:\"1\";}', 'yes'),
 (1820, 'duplicator_pro_package_active', '{\"Created\":\"2020-08-11 16:27:16\",\"Version\":\"3.8.3.4\",\"VersionWP\":\"5.4.2\",\"VersionDB\":\"5.7.31\",\"VersionPHP\":\"7.2.32\",\"VersionOS\":\"Linux\",\"ID\":null,\"Name\":\"20200811_iglesiauniversitaria\",\"Hash\":\"555d1b2a652911102415_20200811162716\",\"NameHash\":\"20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716\",\"Type\":0,\"Notes\":\"\",\"StorePath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\\/tmp\",\"StoreURL\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/backups-dup-pro\\/\",\"ScanFile\":\"20200811_iglesiauniversitaria_555d1b2a652911102415_20200811162716_scan.json\",\"timer_start\":-1,\"Runtime\":null,\"ExeSize\":null,\"ZipSize\":0,\"Brand\":\"Default\",\"Brand_ID\":-2,\"ziparchive_mode\":null,\"Archive\":{\"ExportOnlyDB\":0,\"FilterDirs\":\"\",\"FilterExts\":\"\",\"FilterFiles\":\"\",\"FilterDirsAll\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/ai1wm-backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backupwordpress\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/contents\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/infinitewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/managewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/old-cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/wordfence\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/updraft\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/aiowps_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backup-guard\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_temp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/mainwp\\/backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/pb_backupbuddy\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/sucuri\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp-clone\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp_all_backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wpbackitup_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wfcache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wishlist-backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-snapshots\"],\"FilterExtsAll\":[],\"FilterFilesAll\":[\".DS_Store\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/zn_fonts\\/icomoon\\/icomoon\\/selection.json\",\"dbcache\",\"debug_log\",\"error.log\",\"error_log\",\"objectcache\",\"pgcache\",\"ws_ftp.log\"],\"FilterOn\":0,\"File\":null,\"Format\":\"ZIP\",\"PackDir\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"Size\":200536945,\"Dirs\":null,\"DirCount\":1649,\"RecursiveLinks\":[],\"Files\":null,\"FileCount\":11325,\"file_count\":-1,\"FilterInfo\":{\"Dirs\":{\"Warning\":[],\"Unreadable\":[],\"AddonSites\":[],\"Core\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backups-dup-pro\"],\"Global\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/ai1wm-backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/backupwordpress\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/contents\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/infinitewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/managewp\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/old-cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/updraft\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wishlist-backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/wfcache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/plugins\\/wordfence\\/tmp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/cache\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/aiowps_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_temp\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backupbuddy_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/mainwp\\/backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/pb_backupbuddy\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/snapshots\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/sucuri\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp-clone\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wp_all_backup\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/wpbackitup_backups\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/backup-guard\"],\"Instance\":[]},\"Files\":{\"Warning\":[],\"Unreadable\":[\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\\/uploads\\/zn_fonts\\/icomoon\\/icomoon\\/selection.json\"],\"Size\":[],\"Core\":[],\"Global\":[\"error_log\",\"error.log\",\"debug_log\",\"ws_ftp.log\",\"dbcache\",\"pgcache\",\"objectcache\",\".DS_Store\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\"],\"Instance\":[]},\"Exts\":{\"Core\":[],\"Global\":[],\"Instance\":[]},\"TreeSize\":{\"tree\":{\"id\":\"0\",\"parentId\":\"\",\"name\":\"modelox\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"isDir\":true,\"childs\":{\"wp-blog-header.php\":{\"id\":\"0_0\",\"parentId\":\"0\",\"name\":\"wp-blog-header.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-blog-header.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".well-known\":{\"id\":\"0_1\",\"parentId\":\"0\",\"name\":\".well-known\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.well-known\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"error_log\":{\"id\":\"0_2\",\"parentId\":\"0\",\"name\":\"error_log\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/error_log\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-content\":{\"id\":\"0_3\",\"parentId\":\"0\",\"name\":\"wp-content\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"wp-signup.php\":{\"id\":\"0_4\",\"parentId\":\"0\",\"name\":\"wp-signup.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-signup.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".htaccess\":{\"id\":\"0_5\",\"parentId\":\"0\",\"name\":\".htaccess\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"cgi-bin\":{\"id\":\"0_6\",\"parentId\":\"0\",\"name\":\"cgi-bin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/cgi-bin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":false},\"wp-config.php\":{\"id\":\"0_7\",\"parentId\":\"0\",\"name\":\"wp-config.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-admin\":{\"id\":\"0_8\",\"parentId\":\"0\",\"name\":\"wp-admin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-admin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"php.ini\":{\"id\":\"0_9\",\"parentId\":\"0\",\"name\":\"php.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/php.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-mail.php\":{\"id\":\"0_10\",\"parentId\":\"0\",\"name\":\"wp-mail.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-mail.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"index.php\":{\"id\":\"0_11\",\"parentId\":\"0\",\"name\":\"index.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/index.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"xmlrpc.php\":{\"id\":\"0_12\",\"parentId\":\"0\",\"name\":\"xmlrpc.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/xmlrpc.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-config-sample.php\":{\"id\":\"0_13\",\"parentId\":\"0\",\"name\":\"wp-config-sample.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config-sample.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-trackback.php\":{\"id\":\"0_14\",\"parentId\":\"0\",\"name\":\"wp-trackback.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-trackback.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".user.ini\":{\"id\":\"0_15\",\"parentId\":\"0\",\"name\":\".user.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.user.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-login.php\":{\"id\":\"0_16\",\"parentId\":\"0\",\"name\":\"wp-login.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-login.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-settings.php\":{\"id\":\"0_17\",\"parentId\":\"0\",\"name\":\"wp-settings.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-settings.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-comments-post.php\":{\"id\":\"0_18\",\"parentId\":\"0\",\"name\":\"wp-comments-post.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-comments-post.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-load.php\":{\"id\":\"0_19\",\"parentId\":\"0\",\"name\":\"wp-load.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-load.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-links-opml.php\":{\"id\":\"0_20\",\"parentId\":\"0\",\"name\":\"wp-links-opml.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-links-opml.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"readme.html\":{\"id\":\"0_21\",\"parentId\":\"0\",\"name\":\"readme.html\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/readme.html\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"license.txt\":{\"id\":\"0_22\",\"parentId\":\"0\",\"name\":\"license.txt\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/license.txt\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-cron.php\":{\"id\":\"0_23\",\"parentId\":\"0\",\"name\":\"wp-cron.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-cron.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-activate.php\":{\"id\":\"0_24\",\"parentId\":\"0\",\"name\":\"wp-activate.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-activate.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-includes\":{\"id\":\"0_25\",\"parentId\":\"0\",\"name\":\"wp-includes\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-includes\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true}},\"data\":[],\"haveChildren\":true},\"rootPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\"},\"TreeWarning\":{\"tree\":{\"id\":\"0\",\"parentId\":\"\",\"name\":\"modelox\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\",\"isDir\":true,\"childs\":{\"wp-blog-header.php\":{\"id\":\"0_0\",\"parentId\":\"0\",\"name\":\"wp-blog-header.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-blog-header.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".well-known\":{\"id\":\"0_1\",\"parentId\":\"0\",\"name\":\".well-known\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.well-known\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"error_log\":{\"id\":\"0_2\",\"parentId\":\"0\",\"name\":\"error_log\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/error_log\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-content\":{\"id\":\"0_3\",\"parentId\":\"0\",\"name\":\"wp-content\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-content\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"wp-signup.php\":{\"id\":\"0_4\",\"parentId\":\"0\",\"name\":\"wp-signup.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-signup.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".htaccess\":{\"id\":\"0_5\",\"parentId\":\"0\",\"name\":\".htaccess\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.htaccess\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"cgi-bin\":{\"id\":\"0_6\",\"parentId\":\"0\",\"name\":\"cgi-bin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/cgi-bin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":false},\"wp-config.php\":{\"id\":\"0_7\",\"parentId\":\"0\",\"name\":\"wp-config.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-admin\":{\"id\":\"0_8\",\"parentId\":\"0\",\"name\":\"wp-admin\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-admin\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true},\"php.ini\":{\"id\":\"0_9\",\"parentId\":\"0\",\"name\":\"php.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/php.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-mail.php\":{\"id\":\"0_10\",\"parentId\":\"0\",\"name\":\"wp-mail.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-mail.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"index.php\":{\"id\":\"0_11\",\"parentId\":\"0\",\"name\":\"index.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/index.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"xmlrpc.php\":{\"id\":\"0_12\",\"parentId\":\"0\",\"name\":\"xmlrpc.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/xmlrpc.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-config-sample.php\":{\"id\":\"0_13\",\"parentId\":\"0\",\"name\":\"wp-config-sample.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-config-sample.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-trackback.php\":{\"id\":\"0_14\",\"parentId\":\"0\",\"name\":\"wp-trackback.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-trackback.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\".user.ini\":{\"id\":\"0_15\",\"parentId\":\"0\",\"name\":\".user.ini\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/.user.ini\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-login.php\":{\"id\":\"0_16\",\"parentId\":\"0\",\"name\":\"wp-login.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-login.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-settings.php\":{\"id\":\"0_17\",\"parentId\":\"0\",\"name\":\"wp-settings.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-settings.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-comments-post.php\":{\"id\":\"0_18\",\"parentId\":\"0\",\"name\":\"wp-comments-post.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-comments-post.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-load.php\":{\"id\":\"0_19\",\"parentId\":\"0\",\"name\":\"wp-load.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-load.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-links-opml.php\":{\"id\":\"0_20\",\"parentId\":\"0\",\"name\":\"wp-links-opml.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-links-opml.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"readme.html\":{\"id\":\"0_21\",\"parentId\":\"0\",\"name\":\"readme.html\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/readme.html\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"license.txt\":{\"id\":\"0_22\",\"parentId\":\"0\",\"name\":\"license.txt\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/license.txt\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-cron.php\":{\"id\":\"0_23\",\"parentId\":\"0\",\"name\":\"wp-cron.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-cron.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-activate.php\":{\"id\":\"0_24\",\"parentId\":\"0\",\"name\":\"wp-activate.php\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-activate.php\",\"isDir\":false,\"childs\":[],\"data\":[],\"haveChildren\":null},\"wp-includes\":{\"id\":\"0_25\",\"parentId\":\"0\",\"name\":\"wp-includes\",\"fullPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\\/wp-includes\",\"isDir\":true,\"childs\":[],\"data\":[],\"haveChildren\":true}},\"data\":[],\"haveChildren\":true},\"rootPath\":\"\\/home\\/vicodigi\\/public_html\\/modelox\"}},\"ListDelimiter\":\";\\n\",\"isOuterWPContentDir\":false},\"Multisite\":{\"FilterSites\":\"\"},\"Installer\":{\"File\":null,\"Size\":0,\"OptsSecureOn\":0,\"OptsSecurePass\":\"\",\"OptsSkipScan\":0,\"OptsDBHost\":\"\",\"OptsDBName\":\"\",\"OptsDBUser\":\"\",\"OptsCPNLHost\":\"\",\"OptsCPNLUser\":\"\",\"OptsCPNLPass\":\"\",\"OptsCPNLEnable\":0,\"OptsCPNLConnect\":false,\"OptsCPNLDBAction\":\"create\",\"OptsCPNLDBHost\":\"\",\"OptsCPNLDBName\":\"\",\"OptsCPNLDBUser\":\"\",\"numFilesAdded\":0,\"numDirsAdded\":0},\"Database\":{\"info\":{\"buildMode\":\"PHPCHUNKING\",\"collationList\":[\"utf8_general_ci\",\"utf8mb4_unicode_520_ci\",\"utf8mb4_unicode_ci\",\"latin1_general_ci\"],\"isTablesUpperCase\":0,\"isNameUpperCase\":0,\"name\":\"vicodigi_wp642\",\"tablesBaseCount\":110,\"tablesFinalCount\":110,\"tablesRowCount\":31245,\"tablesSizeOnDisk\":8991903,\"varLowerCaseTables\":\"0\",\"version\":\"5.7.31\",\"versionComment\":\"MySQL Community Server - (GPL)\",\"tableWiseRowCounts\":[]},\"Type\":\"MySQL\",\"Size\":null,\"File\":null,\"FilterTables\":\"\",\"FilterOn\":0,\"DBMode\":null,\"Compatible\":\"\",\"Comments\":\"MySQL Community Server - (GPL)\",\"dbStorePathPublic\":null},\"Status\":5,\"schedule_id\":-1,\"build_progress\":{\"thread_start_time\":null,\"initialized\":false,\"installer_built\":false,\"archive_started\":false,\"archive_has_database\":false,\"archive_built\":false,\"database_script_built\":false,\"failed\":false,\"next_archive_file_index\":0,\"next_archive_dir_index\":0,\"retries\":0,\"current_build_mode\":-1,\"current_build_compression\":true,\"custom_data\":null,\"warnings\":[]},\"db_build_progress\":{\"tableIndex\":0,\"tableOffset\":0,\"totalRowOffset\":0,\"chunkIndex\":null,\"validationStage1\":false,\"bulkOffset\":0,\"bulkSizeOffset\":0,\"doneInit\":false,\"doneFiltering\":false,\"doneCreates\":false,\"completed\":false,\"tablesToProcess\":[],\"startTime\":null,\"fileOffset\":0,\"wasInterrupted\":false,\"errorOut\":false,\"failureCount\":0,\"totalSchemaSize\":0,\"tablesSchemaSizes\":[]},\"upload_infos\":[{\"storage_id\":\"7\",\"archive_offset\":0,\"copied_installer\":false,\"copied_archive\":false,\"progress\":0,\"num_failures\":0,\"failed\":false,\"cancelled\":false,\"upload_id\":null,\"failure_count\":0,\"data\":\"\",\"data2\":\"\",\"has_started\":false,\"status_message_details\":\"\",\"started_timestamp\":null,\"stopped_timestamp\":null}],\"active_storage_id\":-1,\"template_id\":5}', 'yes'),
 (1852, '_transient_doing_cron', '1597163488.4785640239715576171875', 'yes'),
 (1481, 'updraft_jobdata_ed56b76acc3d', 'a:14:{s:8:\"job_type\";s:7:\"restore\";s:11:\"job_time_ms\";d:1597070478.820106029510498046875;s:16:\"backup_timestamp\";s:10:\"1593004371\";s:12:\"meta_foreign\";s:1:\"0\";s:28:\"updraft_restorer_backup_info\";s:99:\"{\\\"timestamp\\\":1593004371,\\\"created_by_version\\\":\\\"1.16.25\\\",\\\"same_url\\\":true,\\\"multisite\\\":false}\";s:32:\"updraft_restorer_restore_options\";a:1:{s:29:\"updraft_restore_table_options\";a:100:{i:0;s:12:\"wp8b_options\";i:1;s:10:\"wp8b_users\";i:2;s:13:\"wp8b_usermeta\";i:3;s:16:\"wp8b_commentmeta\";i:4;s:13:\"wp8b_comments\";i:5;s:10:\"wp8b_links\";i:6;s:13:\"wp8b_postmeta\";i:7;s:10:\"wp8b_posts\";i:8;s:23:\"wp8b_term_relationships\";i:9;s:18:\"wp8b_term_taxonomy\";i:10;s:13:\"wp8b_termmeta\";i:11;s:10:\"wp8b_terms\";i:12;s:28:\"wp8b_actionscheduler_actions\";i:13;s:27:\"wp8b_actionscheduler_claims\";i:14;s:27:\"wp8b_actionscheduler_groups\";i:15;s:25:\"wp8b_actionscheduler_logs\";i:16;s:12:\"wp8b_booking\";i:17;s:17:\"wp8b_bookingdates\";i:18;s:17:\"wp8b_cerber_files\";i:19;s:16:\"wp8b_cerber_sets\";i:20;s:15:\"wp8b_cerber_uss\";i:21;s:15:\"wp8b_cuteslider\";i:22;s:28:\"wp8b_duplicator_pro_entities\";i:23;s:28:\"wp8b_duplicator_pro_packages\";i:24;s:33:\"wp8b_hotel_booking_order_itemmeta\";i:25;s:30:\"wp8b_hotel_booking_order_items\";i:26;s:24:\"wp8b_hotel_booking_plans\";i:27;s:20:\"wp8b_mailchimp_carts\";i:28;s:19:\"wp8b_mailchimp_jobs\";i:29;s:22:\"wp8b_mp_timetable_data\";i:30;s:19:\"wp8b_mphb_sync_logs\";i:31;s:20:\"wp8b_mphb_sync_queue\";i:32;s:20:\"wp8b_mphb_sync_stats\";i:33;s:19:\"wp8b_mphb_sync_urls\";i:34;s:18:\"wp8b_revslider_css\";i:35;s:22:\"wp8b_revslider_css_bkp\";i:36;s:31:\"wp8b_revslider_layer_animations\";i:37;s:35:\"wp8b_revslider_layer_animations_bkp\";i:38;s:26:\"wp8b_revslider_navigations\";i:39;s:30:\"wp8b_revslider_navigations_bkp\";i:40;s:22:\"wp8b_revslider_sliders\";i:41;s:26:\"wp8b_revslider_sliders_bkp\";i:42;s:21:\"wp8b_revslider_slides\";i:43;s:25:\"wp8b_revslider_slides_bkp\";i:44;s:28:\"wp8b_revslider_static_slides\";i:45;s:32:\"wp8b_revslider_static_slides_bkp\";i:46;s:30:\"wp8b_sbi_instagram_feeds_posts\";i:47;s:24:\"wp8b_sbi_instagram_posts\";i:48;s:21:\"wp8b_tinvwl_analytics\";i:49;s:17:\"wp8b_tinvwl_items\";i:50;s:17:\"wp8b_tinvwl_lists\";i:51;s:26:\"wp8b_wc_admin_note_actions\";i:52;s:19:\"wp8b_wc_admin_notes\";i:53;s:23:\"wp8b_wc_category_lookup\";i:54;s:23:\"wp8b_wc_customer_lookup\";i:55;s:20:\"wp8b_wc_download_log\";i:56;s:27:\"wp8b_wc_order_coupon_lookup\";i:57;s:28:\"wp8b_wc_order_product_lookup\";i:58;s:19:\"wp8b_wc_order_stats\";i:59;s:24:\"wp8b_wc_order_tax_lookup\";i:60;s:27:\"wp8b_wc_product_meta_lookup\";i:61;s:24:\"wp8b_wc_tax_rate_classes\";i:62;s:16:\"wp8b_wc_webhooks\";i:63;s:14:\"wp8b_wdi_feeds\";i:64;s:15:\"wp8b_wdi_themes\";i:65;s:19:\"wp8b_wfblockediplog\";i:66;s:14:\"wp8b_wfblocks7\";i:67;s:13:\"wp8b_wfconfig\";i:68;s:15:\"wp8b_wfcrawlers\";i:69;s:18:\"wp8b_wffilechanges\";i:70;s:15:\"wp8b_wffilemods\";i:71;s:11:\"wp8b_wfhits\";i:72;s:13:\"wp8b_wfhoover\";i:73;s:13:\"wp8b_wfissues\";i:74;s:20:\"wp8b_wfknownfilelist\";i:75;s:23:\"wp8b_wflivetraffichuman\";i:76;s:11:\"wp8b_wflocs\";i:77;s:13:\"wp8b_wflogins\";i:78;s:21:\"wp8b_wfls_2fa_secrets\";i:79;s:18:\"wp8b_wfls_settings\";i:80;s:20:\"wp8b_wfnotifications\";i:81;s:20:\"wp8b_wfpendingissues\";i:82;s:19:\"wp8b_wfreversecache\";i:83;s:16:\"wp8b_wfsnipcache\";i:84;s:13:\"wp8b_wfstatus\";i:85;s:19:\"wp8b_wftrafficrates\";i:86;s:25:\"wp8b_woocommerce_api_keys\";i:87;s:37:\"wp8b_woocommerce_attribute_taxonomies\";i:88;s:49:\"wp8b_woocommerce_downloadable_product_permissions\";i:89;s:20:\"wp8b_woocommerce_log\";i:90;s:31:\"wp8b_woocommerce_order_itemmeta\";i:91;s:28:\"wp8b_woocommerce_order_items\";i:92;s:34:\"wp8b_woocommerce_payment_tokenmeta\";i:93;s:31:\"wp8b_woocommerce_payment_tokens\";i:94;s:25:\"wp8b_woocommerce_sessions\";i:95;s:40:\"wp8b_woocommerce_shipping_zone_locations\";i:96;s:38:\"wp8b_woocommerce_shipping_zone_methods\";i:97;s:31:\"wp8b_woocommerce_shipping_zones\";i:98;s:35:\"wp8b_woocommerce_tax_rate_locations\";i:99;s:26:\"wp8b_woocommerce_tax_rates\";}}s:15:\"updraft_restore\";a:5:{i:0;s:7:\"plugins\";i:1;s:6:\"themes\";i:2;s:7:\"uploads\";i:3;s:6:\"others\";i:4;s:2:\"db\";}s:15:\"restore_options\";a:4:{s:29:\"updraft_restore_table_options\";a:100:{i:0;s:12:\"wp8b_options\";i:1;s:10:\"wp8b_users\";i:2;s:13:\"wp8b_usermeta\";i:3;s:16:\"wp8b_commentmeta\";i:4;s:13:\"wp8b_comments\";i:5;s:10:\"wp8b_links\";i:6;s:13:\"wp8b_postmeta\";i:7;s:10:\"wp8b_posts\";i:8;s:23:\"wp8b_term_relationships\";i:9;s:18:\"wp8b_term_taxonomy\";i:10;s:13:\"wp8b_termmeta\";i:11;s:10:\"wp8b_terms\";i:12;s:28:\"wp8b_actionscheduler_actions\";i:13;s:27:\"wp8b_actionscheduler_claims\";i:14;s:27:\"wp8b_actionscheduler_groups\";i:15;s:25:\"wp8b_actionscheduler_logs\";i:16;s:12:\"wp8b_booking\";i:17;s:17:\"wp8b_bookingdates\";i:18;s:17:\"wp8b_cerber_files\";i:19;s:16:\"wp8b_cerber_sets\";i:20;s:15:\"wp8b_cerber_uss\";i:21;s:15:\"wp8b_cuteslider\";i:22;s:28:\"wp8b_duplicator_pro_entities\";i:23;s:28:\"wp8b_duplicator_pro_packages\";i:24;s:33:\"wp8b_hotel_booking_order_itemmeta\";i:25;s:30:\"wp8b_hotel_booking_order_items\";i:26;s:24:\"wp8b_hotel_booking_plans\";i:27;s:20:\"wp8b_mailchimp_carts\";i:28;s:19:\"wp8b_mailchimp_jobs\";i:29;s:22:\"wp8b_mp_timetable_data\";i:30;s:19:\"wp8b_mphb_sync_logs\";i:31;s:20:\"wp8b_mphb_sync_queue\";i:32;s:20:\"wp8b_mphb_sync_stats\";i:33;s:19:\"wp8b_mphb_sync_urls\";i:34;s:18:\"wp8b_revslider_css\";i:35;s:22:\"wp8b_revslider_css_bkp\";i:36;s:31:\"wp8b_revslider_layer_animations\";i:37;s:35:\"wp8b_revslider_layer_animations_bkp\";i:38;s:26:\"wp8b_revslider_navigations\";i:39;s:30:\"wp8b_revslider_navigations_bkp\";i:40;s:22:\"wp8b_revslider_sliders\";i:41;s:26:\"wp8b_revslider_sliders_bkp\";i:42;s:21:\"wp8b_revslider_slides\";i:43;s:25:\"wp8b_revslider_slides_bkp\";i:44;s:28:\"wp8b_revslider_static_slides\";i:45;s:32:\"wp8b_revslider_static_slides_bkp\";i:46;s:30:\"wp8b_sbi_instagram_feeds_posts\";i:47;s:24:\"wp8b_sbi_instagram_posts\";i:48;s:21:\"wp8b_tinvwl_analytics\";i:49;s:17:\"wp8b_tinvwl_items\";i:50;s:17:\"wp8b_tinvwl_lists\";i:51;s:26:\"wp8b_wc_admin_note_actions\";i:52;s:19:\"wp8b_wc_admin_notes\";i:53;s:23:\"wp8b_wc_category_lookup\";i:54;s:23:\"wp8b_wc_customer_lookup\";i:55;s:20:\"wp8b_wc_download_log\";i:56;s:27:\"wp8b_wc_order_coupon_lookup\";i:57;s:28:\"wp8b_wc_order_product_lookup\";i:58;s:19:\"wp8b_wc_order_stats\";i:59;s:24:\"wp8b_wc_order_tax_lookup\";i:60;s:27:\"wp8b_wc_product_meta_lookup\";i:61;s:24:\"wp8b_wc_tax_rate_classes\";i:62;s:16:\"wp8b_wc_webhooks\";i:63;s:14:\"wp8b_wdi_feeds\";i:64;s:15:\"wp8b_wdi_themes\";i:65;s:19:\"wp8b_wfblockediplog\";i:66;s:14:\"wp8b_wfblocks7\";i:67;s:13:\"wp8b_wfconfig\";i:68;s:15:\"wp8b_wfcrawlers\";i:69;s:18:\"wp8b_wffilechanges\";i:70;s:15:\"wp8b_wffilemods\";i:71;s:11:\"wp8b_wfhits\";i:72;s:13:\"wp8b_wfhoover\";i:73;s:13:\"wp8b_wfissues\";i:74;s:20:\"wp8b_wfknownfilelist\";i:75;s:23:\"wp8b_wflivetraffichuman\";i:76;s:11:\"wp8b_wflocs\";i:77;s:13:\"wp8b_wflogins\";i:78;s:21:\"wp8b_wfls_2fa_secrets\";i:79;s:18:\"wp8b_wfls_settings\";i:80;s:20:\"wp8b_wfnotifications\";i:81;s:20:\"wp8b_wfpendingissues\";i:82;s:19:\"wp8b_wfreversecache\";i:83;s:16:\"wp8b_wfsnipcache\";i:84;s:13:\"wp8b_wfstatus\";i:85;s:19:\"wp8b_wftrafficrates\";i:86;s:25:\"wp8b_woocommerce_api_keys\";i:87;s:37:\"wp8b_woocommerce_attribute_taxonomies\";i:88;s:49:\"wp8b_woocommerce_downloadable_product_permissions\";i:89;s:20:\"wp8b_woocommerce_log\";i:90;s:31:\"wp8b_woocommerce_order_itemmeta\";i:91;s:28:\"wp8b_woocommerce_order_items\";i:92;s:34:\"wp8b_woocommerce_payment_tokenmeta\";i:93;s:31:\"wp8b_woocommerce_payment_tokens\";i:94;s:25:\"wp8b_woocommerce_sessions\";i:95;s:40:\"wp8b_woocommerce_shipping_zone_locations\";i:96;s:38:\"wp8b_woocommerce_shipping_zone_methods\";i:97;s:31:\"wp8b_woocommerce_shipping_zones\";i:98;s:35:\"wp8b_woocommerce_tax_rate_locations\";i:99;s:26:\"wp8b_woocommerce_tax_rates\";}s:24:\"updraft_encryptionphrase\";s:0:\"\";s:39:\"updraft_restorer_wpcore_includewpconfig\";b:0;s:33:\"updraft_incremental_restore_point\";i:-1;}s:20:\"second_loop_entities\";a:0:{}s:23:\"last_processed_db_table\";s:26:\"wp8b_woocommerce_tax_rates\";s:43:\"last_index_2bb2c6abf4bf8f3b644770e3b21640e4\";a:3:{s:5:\"index\";i:5755;s:4:\"info\";a:7:{s:4:\"name\";s:39:\"plugins/akismet/class.akismet-admin.php\";s:5:\"index\";i:5755;s:3:\"crc\";i:2935376082;s:4:\"size\";i:49566;s:5:\"mtime\";i:1592976414;s:9:\"comp_size\";i:12438;s:11:\"comp_method\";i:8;}s:12:\"size_written\";i:75592502;}s:43:\"last_index_8522a9ca76fa348824b1c91c28b3650b\";a:3:{s:5:\"index\";i:1536;s:4:\"info\";a:7:{s:4:\"name\";s:58:\"themes/kallyas/components/blog/blog-default-def_modern.php\";s:5:\"index\";i:1536;s:3:\"crc\";i:2688459415;s:4:\"size\";i:3536;s:5:\"mtime\";i:1592976260;s:9:\"comp_size\";i:1018;s:11:\"comp_method\";i:8;}s:12:\"size_written\";i:21718764;}s:43:\"last_index_d3db188c30b80114123b5d0c8d9db816\";a:3:{s:5:\"index\";i:16;s:4:\"info\";a:7:{s:4:\"name\";s:48:\"uploads/zion-builder/cache/2-layout-loggedin.css\";s:5:\"index\";i:16;s:3:\"crc\";i:0;s:4:\"size\";i:0;s:5:\"mtime\";i:1592976260;s:9:\"comp_size\";i:0;s:11:\"comp_method\";i:0;}s:12:\"size_written\";i:20242;}s:43:\"last_index_92df4ad10b1c56fe5f8bafc9dd26e672\";a:3:{s:5:\"index\";i:57;s:4:\"info\";a:7:{s:4:\"name\";s:28:\"wflogs/GeoLite2-Country.mmdb\";s:5:\"index\";i:57;s:3:\"crc\";i:2393962837;s:4:\"size\";i:3803555;s:5:\"mtime\";i:1592976266;s:9:\"comp_size\";i:1908319;s:11:\"comp_method\";i:8;}s:12:\"size_written\";i:8681841;}}', 'no'),
 (1561, '_site_transient_community-events-7c9823f65864b35e648990605a90302f', 'a:3:{s:9:\"sandboxed\";b:0;s:8:\"location\";a:1:{s:2:\"ip\";s:11:\"190.75.83.0\";}s:6:\"events\";a:2:{i:0;a:8:{s:4:\"type\";s:8:\"wordcamp\";s:5:\"title\";s:35:\"WordCamp Minneapolis, Minnesota USA\";s:3:\"url\";s:38:\"https://minneapolis.wordcamp.org/2020/\";s:6:\"meetup\";N;s:10:\"meetup_url\";N;s:4:\"date\";s:19:\"2020-08-21 13:45:00\";s:8:\"end_date\";s:19:\"2020-08-21 13:45:00\";s:8:\"location\";a:4:{s:8:\"location\";s:6:\"Online\";s:7:\"country\";s:2:\"US\";s:8:\"latitude\";d:44.97775299999999987221599440090358257293701171875;s:9:\"longitude\";d:-93.265010799999998880593921057879924774169921875;}}i:1;a:8:{s:4:\"type\";s:6:\"meetup\";s:5:\"title\";s:45:\"Primer evento online WordPress Meetup Caracas\";s:3:\"url\";s:65:\"https://www.meetup.com/WordPress-Meetup-Caracas/events/272453255/\";s:6:\"meetup\";s:24:\"WordPress Meetup Caracas\";s:10:\"meetup_url\";s:48:\"https://www.meetup.com/WordPress-Meetup-Caracas/\";s:4:\"date\";s:19:\"2020-08-28 21:00:00\";s:8:\"end_date\";s:19:\"2020-08-28 22:00:00\";s:8:\"location\";a:4:{s:8:\"location\";s:6:\"Online\";s:7:\"country\";s:2:\"VE\";s:8:\"latitude\";d:10.5399999618530006983974089962430298328399658203125;s:9:\"longitude\";d:-66.9300003051759944128207280300557613372802734375;}}}}', 'no'),
 (1588, '_site_transient_update_core', 'O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:65:\"https://downloads.wordpress.org/release/es_ES/wordpress-5.4.2.zip\";s:6:\"locale\";s:5:\"es_ES\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:65:\"https://downloads.wordpress.org/release/es_ES/wordpress-5.4.2.zip\";s:10:\"no_content\";b:0;s:11:\"new_bundled\";b:0;s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"5.4.2\";s:7:\"version\";s:5:\"5.4.2\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.3\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1597160786;s:15:\"version_checked\";s:5:\"5.4.2\";s:12:\"translations\";a:0:{}}', 'no'),
 (1556, '_transient_timeout_wfcredentialstatus_1', '1597163841', 'no'),
 (1557, '_transient_wfcredentialstatus_1', '0b8f444c9b0a4550adb8b526e088769f1e32e2b1502b8a8c4ee54b1bfe7d3ba5b', 'no'),
 (1558, '_site_transient_timeout_browser_195dfc10ee035dd613772a80486d1e59', '1597765068', 'no'),
 (1559, '_site_transient_browser_195dfc10ee035dd613772a80486d1e59', 'a:10:{s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"84.0.4147.105\";s:8:\"platform\";s:7:\"Windows\";s:10:\"update_url\";s:29:\"https://www.google.com/chrome\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/chrome.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/chrome.png?1\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}', 'no'),
 (1519, 'revslider_table_version', '1.0.8', 'yes'),
 (1722, 'woocommerce_maxmind_geolocation_settings', 'a:1:{s:15:\"database_prefix\";s:32:\"RXFI35APD5xVSF8bSNBRepPRtWTE912N\";}', 'yes'),
 (1712, '_transient_timeout__woocommerce_upload_directory_status', '1597246966', 'no'),
 (1713, '_transient__woocommerce_upload_directory_status', 'protected', 'no'),
 (1714, 'shop_catalog_image_size', 'a:3:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"300\";s:4:\"crop\";i:1;}', 'yes'),
 (1715, 'shop_single_image_size', 'a:3:{s:5:\"width\";s:3:\"600\";s:6:\"height\";s:3:\"600\";s:4:\"crop\";i:1;}', 'yes'),
 (1716, 'shop_thumbnail_image_size', 'a:3:{s:5:\"width\";s:3:\"180\";s:6:\"height\";s:3:\"180\";s:4:\"crop\";i:1;}', 'yes'),
 (1717, 'woocommerce_category_archive_display', '', 'yes'),
 (1726, 'widget_woocommerce_layered_nav', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1727, 'widget_woocommerce_price_filter', 'a:2:{i:1;a:1:{s:5:\"title\";s:15:\"Filter by price\";}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1728, 'widget_woocommerce_product_categories', 'a:2:{i:1;a:7:{s:5:\"title\";s:18:\"Product categories\";s:7:\"orderby\";s:4:\"name\";s:8:\"dropdown\";i:0;s:5:\"count\";i:0;s:12:\"hierarchical\";i:1;s:18:\"show_children_only\";i:0;s:10:\"hide_empty\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1729, 'widget_woocommerce_product_search', 'a:2:{i:1;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1730, 'widget_woocommerce_product_tag_cloud', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1731, 'widget_woocommerce_products', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1732, 'widget_woocommerce_recently_viewed_products', 'a:2:{i:1;a:2:{s:5:\"title\";s:24:\"Recently viewed products\";s:6:\"number\";i:10;}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1733, 'widget_woocommerce_top_rated_products', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1734, 'widget_woocommerce_recent_reviews', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1735, 'widget_woocommerce_rating_filter', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1786, 'zn_kallyas_custom_js', '', 'yes'),
 (1739, 'woocommerce_admin_install_timestamp', '1597160571', 'yes'),
 (1738, 'woocommerce_admin_version', '1.3.1', 'yes'),
 (1741, '_transient_timeout_as-post-store-dependencies-met', '1597246972', 'no'),
 (1742, '_transient_as-post-store-dependencies-met', 'yes', 'no'),
 (1743, 'wc_admin_note_home_screen_feedback_homescreen_accessed', '1597160572', 'yes'),
 (1744, 'wc_blocks_db_schema_version', '260', 'yes'),
 (1794, '_transient_wc_term_counts', 'a:5:{i:515;s:1:\"2\";i:19;s:1:\"2\";i:18;s:1:\"2\";i:17;s:1:\"1\";i:20;s:1:\"1\";}', 'no'),
 (1755, 'zn_custom_fonts', 'a:1:{s:7:\"icomoon\";a:0:{}}', 'yes'),
 (1766, '_transient_product_query-transient-version', '1597160624', 'yes'),
 (1793, '_transient_timeout_wc_term_counts', '1599752664', 'no'),
 (1562, '_transient_timeout_feed_69c933d8a78805efd0abe985766ffb51', '1597203501', 'no'),
 (1563, '_transient_feed_69c933d8a78805efd0abe985766ffb51', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"WordPress.org\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"https://es.wordpress.org\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Español\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Aug 2020 23:42:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"es\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wordpress.org/?v=5.6-alpha-48782\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:79:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"WordPress 5.5 candidata a definitiva 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://es.wordpress.org/2020/08/04/wordpress-5-5-candidata-a-definitiva-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"https://es.wordpress.org/2020/08/04/wordpress-5-5-candidata-a-definitiva-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Aug 2020 23:42:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"5.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:2:\"RC\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=5288\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:370:\"¡Ya está aquí la segunda versión candidata a definitiva de WordPress 5.5! WordPress 5.5 está actualmente programada para lanzarse&#160;el 11 de agosto, pero necesitamos tu ayuda para conseguirlo – si aún no has probado la versión 5.5,&#160;¡ahora es el momento! Hay dos maneras de probar la versión candidata a definitiva de WordPress 5.5: Probar el [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2975:\"\n<p>¡Ya está aquí la segunda versión candidata a definitiva de WordPress 5.5!</p>\n\n\n\n<p>WordPress 5.5 está actualmente programada para lanzarse&nbsp;<strong>el 11 de agosto</strong>, pero necesitamos tu ayuda para conseguirlo – si aún no has probado la versión 5.5,&nbsp;<strong>¡ahora es el momento!</strong></p>\n\n\n\n<p>Hay dos maneras de probar la versión candidata a definitiva de WordPress 5.5:</p>\n\n\n\n<ul><li>Probar el plugin <a rel=\"noreferrer noopener\" href=\"https://es.wordpress.org/plugins/wordpress-beta-tester/\" target=\"_blank\">WordPress Beta Tester</a> (elige la opción «versiones avanzadas»)</li><li>O <a href=\"https://wordpress.org/wordpress-5.5-RC2.zip\">descarga aquí la versión</a> (zip).</li></ul>\n\n\n\n<p>Gracias a todos los contribuidores que han probado las versiones beta y han enviado comentarios. Probar fallos es una parte crítica del pulido de cada versión y un fantástico modo de contribuir a WordPress.</p>\n\n\n\n<h2>Desarrolladores de plugins y temas</h2>\n\n\n\n<p>Por favor, prueba tus plugins y temas con WordPress 5.5 y actualiza el texto de versión de <em>Probado hasta</em> en el archivo readme a la 5.5. Si encuentras problemas de compatibilidad, por favor, asegúrate de publicarlo en los <a href=\"https://wordpress.org/support/forum/alphabeta/\">foros de soporte</a> para que podamos resolverlo antes de la versión final.</p>\n\n\n\n<p>Para un desglose más detallado de los cambios incluidos en WordPress 5.5, mira <a href=\"https://es.wordpress.org/2020/07/10/wordpress-5-5-beta-1/\" data-type=\"post\" data-id=\"5234\">la entrada de WordPress 5.5 beta 1</a>.</p>\n\n\n\n<p>¡La <a rel=\"noreferrer noopener\" href=\"https://make.wordpress.org/core/2020/07/30/wordpress-5-5-field-guide/\" target=\"_blank\">guía de campo de WordPress 5.5</a> ya está publicada! Es tu fuente de detalles sobre todos los principales cambios.</p>\n\n\n\n<h2>Cómo ayudar</h2>\n\n\n\n<p>¿Hablas otro idioma que no sea el inglés?&nbsp;<a rel=\"noreferrer noopener\" href=\"https://translate.wordpress.org/projects/wp/dev/\" target=\"_blank\">¡Ayúdanos a traducir WordPress a más de 100 idiomas!</a></p>\n\n\n\n<p>Esta versión también marca el&nbsp;<a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\">punto de congelación de cadenas</a>&nbsp;de la programación de la versión 5.5.</p>\n\n\n\n<p>Si crees que has encontrado un error, puedes publicarlo en el&nbsp;<a rel=\"noreferrer noopener\" href=\"https://wordpress.org/support/forum/alphabeta/\" target=\"_blank\">área Alpha/Beta</a>&nbsp;de los foros de soporte. ¡Nos encantaría saber de ti!</p>\n\n\n\n<p><em>Si te sientes cómodo escribiendo informes de errores replicables,&nbsp;<a rel=\"noreferrer noopener\" href=\"https://core.trac.wordpress.org/newticket\" target=\"_blank\">presenta uno en el Trac de WordPress</a>, donde también puedes encontrar una&nbsp;<a rel=\"noreferrer noopener\" href=\"https://core.trac.wordpress.org/tickets/major\" target=\"_blank\">lista de errores conocidos</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"https://es.wordpress.org/2020/08/04/wordpress-5-5-candidata-a-definitiva-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:79:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"WordPress 5.5 candidata a definitiva\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"https://es.wordpress.org/2020/07/29/wordpress-5-5-candidata-a-definitiva/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"https://es.wordpress.org/2020/07/29/wordpress-5-5-candidata-a-definitiva/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2020 15:22:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"5.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:2:\"RC\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=5275\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:351:\"¡Ya está disponible la primera versión candidata a definitiva de WordPress 5.5! Este es un hito importante a medida que avanzamos hacia la fecha de lanzamiento de WordPress 5.5. «Candidata a definitiva» significa que la nueva versión está lista para su lanzamiento, pero con millones de usuarios y miles de plugins y temas, es posible [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3410:\"\n<p>¡Ya está disponible la primera versión candidata a definitiva de WordPress 5.5!</p>\n\n\n\n<p>Este es un hito importante a medida que avanzamos hacia la fecha de lanzamiento de WordPress 5.5.</p>\n\n\n\n<p>«Candidata a definitiva» significa que la nueva versión está lista para su lanzamiento, pero con millones de usuarios y miles de plugins y temas, es posible que algo se nos haya pasado por alto.</p>\n\n\n\n<p>WordPress 5.5 está actualmente programada para lanzarse <strong>el 11 de agosto</strong>, pero necesitamos tu ayuda para conseguirlo – si aún no has probado la versión 5.5, <strong>¡ahora es el momento!</strong></p>\n\n\n\n<p>Hay dos maneras de probar la versión candidata a definitiva de WordPress 5.5:</p>\n\n\n\n<ul><li>Probar el plugin <a rel=\"noreferrer noopener\" href=\"https://es.wordpress.org/plugins/wordpress-beta-tester/\" target=\"_blank\">WordPress Beta Tester</a> (elige la opción «versiones avanzadas»)</li><li>O <a href=\"https://wordpress.org/wordpress-5.5-RC1.zip\">descarga aquí la versión</a> (zip).</li></ul>\n\n\n\n<p>Gracias a todos los contribuidores que han probado las versiones beta y han enviado comentarios. Probar fallos es una parte crítica del pulido de cada versión y un fantástico modo de contribuir a WordPress.</p>\n\n\n\n<h2>¿Qué trae WordPress 5.5?</h2>\n\n\n\n<p>WordPress 5.5 tiene montones de mejoras para pulir la experiencia de los desarrolladores. Para estar al día suscríbete al <a href=\"https://make.wordpress.org/core/\">blog de Make WordPress Core</a> y presta especial atención a la etiqueta de <a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">notas para desarrolladores</a> para las actualizaciones sobre estos y otros cambios que podrían afectar a tus productos.</p>\n\n\n\n<h2>Desarrolladores de plugins y temas</h2>\n\n\n\n<p>Por favor, prueba tus plugins y temas con WordPress 5.5 y actualiza el texto de versión de <em>Probado hasta</em> en el archivo readme a la 5.5. Si encuentras problemas de compatibilidad, por favor, asegúrate de publicarlo en los <a href=\"https://wordpress.org/support/forum/alphabeta/\">foros de soporte</a> para que podamos resolverlo antes de la versión final</p>\n\n\n\n<p>La guía de campo de WordPress 5.5 se publicará muy pronto, con una explicación más detallada sobre los principales cambios.</p>\n\n\n\n<h2>Cómo ayudar</h2>\n\n\n\n<p>¿Hablas otro idioma que no sea el inglés?&nbsp;<a rel=\"noreferrer noopener\" href=\"https://translate.wordpress.org/projects/wp/dev/\" target=\"_blank\">¡Ayúdanos a traducir WordPress a más de 100 idiomas!</a></p>\n\n\n\n<p>Esta versión también marca el <a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\">punto de congelación de cadenas</a> de la programación de la versión 5.5.</p>\n\n\n\n<p>Si crees que has encontrado un error, puedes publicarlo en el&nbsp;<a rel=\"noreferrer noopener\" href=\"https://wordpress.org/support/forum/alphabeta/\" target=\"_blank\">área Alpha/Beta</a>&nbsp;de los foros de soporte. ¡Nos encantaría saber de ti!</p>\n\n\n\n<p><em>Si te sientes cómodo escribiendo informes de errores replicables,&nbsp;<a rel=\"noreferrer noopener\" href=\"https://core.trac.wordpress.org/newticket\" target=\"_blank\">presenta uno en el Trac de WordPress</a>, donde también puedes encontrar una&nbsp;<a rel=\"noreferrer noopener\" href=\"https://core.trac.wordpress.org/tickets/major\" target=\"_blank\">lista de errores conocidos</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://es.wordpress.org/2020/07/29/wordpress-5-5-candidata-a-definitiva/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:79:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.5 beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://es.wordpress.org/2020/07/21/wordpress-5-5-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://es.wordpress.org/2020/07/21/wordpress-5-5-beta-3/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Jul 2020 23:11:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"5.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=5260\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:370:\"¡Ya está disponible la beta 3 de WordPress 5.5 para probarla! Este software está aún en desarrollo,&#160;a sí que no es recomendable ejecutar esta versión en un sitio en producción. Plantéate configurar un sitio de pruebas para probar la nueva versión. Puedes probar WordPress 5.5 beta 2 de dos maneras: Prueba el plugin WordPress Beta Tester (elige [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3914:\"\n<p>¡Ya está disponible la beta 3 de WordPress 5.5 para probarla!</p>\n\n\n\n<p><strong>Este software está aún en desarrollo,</strong>&nbsp;a sí que no es recomendable ejecutar esta versión en un sitio en producción. Plantéate configurar un sitio de pruebas para probar la nueva versión.</p>\n\n\n\n<p>Puedes probar WordPress 5.5 beta 2 de dos maneras:</p>\n\n\n\n<ul><li>Prueba el plugin <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> (elige la opción «versión avanzada»)</li><li>O <a href=\"https://wordpress.org/wordpress-5.5-beta3.zip\">descarga aquí la beta (zip)</a>.</li></ul>\n\n\n\n<p>El lanzamiento de WordPress 5.5 está programado para el&nbsp;<a href=\"https://make.wordpress.org/core/5-5/\">11 de agosto de 2020</a>, y&nbsp;¡<strong>necesitamos tu ayuda para conseguirlo</strong>!</p>\n\n\n\n<p>Gracias a todos los que han contribuido al desarrollo de <a href=\"https://es.wordpress.org/2020/07/15/wordpress-5-5-beta-2/\" data-type=\"post\" data-id=\"5248\">la beta 2</a> y enviado opiniones. Probar para encontrar fallos es una parte importante para mejorar cada versión y un fantástico modo de contribuir a WordPress. Aquí tienes algunos de los cambios desde la beta 1 a los que prestar atención mientras la pruebes.</p>\n\n\n\n<h2>Algunos puntos destacados</h2>\n\n\n\n<p id=\"block-85da84ec-c841-42f9-8d3b-1a4537a61d10\">Desde la <a href=\"https://es.wordpress.org/2020/07/15/wordpress-5-5-beta-2/\" data-type=\"post\" data-id=\"5248\">beta 2</a> se han corregido <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;changetime=07%2F15%2F2020..07%2F21%2F2020&amp;milestone=5.5&amp;group=component&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\">43 fallos</a>. Aquí están algunos pequeños cambios en la beta 2:</p>\n\n\n\n<ul><li>Las versiones de plugins y temas ahora se comparten en los correos electrónicos cuando se actualizan automáticamente (ver <a href=\"https://core.trac.wordpress.org/ticket/50350\">#50350</a>).</li><li>Las rutas de la API REST sin <code>permission_callback</code> ahora lanzan una advertencia de <code>_doing_it_wrong()</code> (ver <a rel=\"noreferrer noopener\" target=\"_blank\" href=\"https://core.trac.wordpress.org/ticket/50075\">#50075</a>).</li><li>Más de 23 cambios y actualizaciones en Gutenberg (ver <a href=\"https://github.com/WordPress/gutenberg/pull/24068\">#24068</a> y <a href=\"https://core.trac.wordpress.org/ticket/50712\">#50712</a>).</li><li>Se ha corregido un fallo con los nuevos Dashicons de importar y exportar la base de datos (ver <a href=\"https://core.trac.wordpress.org/ticket/49913\">#49913</a>).</li></ul>\n\n\n\n<h2>Notas para desarrolladores</h2>\n\n\n\n<p>WordPress 5.5 tiene montones de detalles para mejorar la experiencia del desarrollador. Para mantenerte al día suscríbete al&nbsp;<a href=\"https://make.wordpress.org/core/\">blog de Make WordPress Core</a>&nbsp;y presta especial atención a las&nbsp;<a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">notas para desarrolladores</a>&nbsp;par estar al día de estos y otros cambios que podrían afectar a tus productos.</p>\n\n\n\n<h2><strong>Cómo puedes ayudar</strong></h2>\n\n\n\n<p>¿Hablas otro idioma que no sea el inglés?&nbsp;¡<a href=\"https://translate.wordpress.org/projects/wp/dev/\">Ayuda a traducir WordPress a más de 100 idiomas</a>!</p>\n\n\n\n<p>Si crees que has encontrado un fallo, por favor, publícalo en el área&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta</a>&nbsp;de los foros de soporte. ¡Nos encantaría saber de ti! Si te sientes cómodo escribiendo un informe de un fallo reproducible,&nbsp;<a href=\"https://core.trac.wordpress.org/newticket\">envía uno al trac de WordPress</a>. Ahí es donde también puedes encontrar una lista de&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">fallos conocidos</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://es.wordpress.org/2020/07/21/wordpress-5-5-beta-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:79:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.5 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://es.wordpress.org/2020/07/15/wordpress-5-5-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://es.wordpress.org/2020/07/15/wordpress-5-5-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Jul 2020 10:26:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"5.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=5248\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:370:\"¡Ya está disponible la beta 2 de WordPress 5.5 para probarla! Este software está aún en desarrollo,&#160;a sí que no es recomendable ejecutar esta versión en un sitio en producción. Plantéate configurar un sitio de pruebas para probar la nueva versión. Puedes probar WordPress 5.5 beta 2 de dos maneras: Prueba el plugin WordPress Beta Tester (elige [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4323:\"\n<p>¡Ya está disponible la beta 2 de WordPress 5.5 para probarla!</p>\n\n\n\n<p><strong>Este software está aún en desarrollo,</strong>&nbsp;a sí que no es recomendable ejecutar esta versión en un sitio en producción. Plantéate configurar un sitio de pruebas para probar la nueva versión.</p>\n\n\n\n<p>Puedes probar WordPress 5.5 beta 2 de dos maneras:</p>\n\n\n\n<ul><li>Prueba el plugin <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> (elige la opción «versión avanzada»)</li><li>O <a href=\"https://wordpress.org/wordpress-5.5-beta2.zip\">descarga aquí la beta (zip)</a>.</li></ul>\n\n\n\n<p>El lanzamiento de WordPress 5.5 está programado para el <a href=\"https://make.wordpress.org/core/5-5/\">11 de agosto de 2020</a>, y ¡<strong>necesitamos tu ayuda para conseguirlo</strong>!</p>\n\n\n\n<p>Gracias a todos los que han contribuido al desarrollo de <a href=\"https://es.wordpress.org/2020/07/10/wordpress-5-5-beta-1/\" data-type=\"post\" data-id=\"5234\">la beta 1</a> y enviado opiniones. Probar para encontrar fallos es una parte importante para mejorar cada versión y un fantástico modo de contribuir a WordPress. Aquí tienes algunos de los cambios desde la beta 1 a los que prestar atención mientras la pruebes.</p>\n\n\n\n<h2>Algunos puntos destacados</h2>\n\n\n\n<p id=\"block-85da84ec-c841-42f9-8d3b-1a4537a61d10\">Desde la <a href=\"https://es.wordpress.org/2020/07/10/wordpress-5-5-beta-1/\" data-type=\"post\" data-id=\"5234\">beta 1</a> se han corregido <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;changetime=07%2F08%2F2020..07%2F14%2F2020&amp;milestone=5.5&amp;group=component&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\">48 fallos</a>. Aquí tienes un resumen de unos cuantos cambios incluidos en la beta 2:</p>\n\n\n\n<ul><li>Se han corregido 19 fallos adicionales en el editor de bloques (ver <a href=\"https://github.com/WordPress/gutenberg/pull/23903\">#23903</a> y <a href=\"https://github.com/WordPress/gutenberg/pull/23905\">#23905</a>).</li><li>La fuente de iconos Dashicons se ha actualizado (ver <a href=\"https://core.trac.wordpress.org/ticket/49913\">#49913</a>).</li><li>Los widgets rotos provocados por los cambios en la beta 1 se han arreglado (ver <a href=\"https://core.trac.wordpress.org/ticket/50609\">#50609</a>).</li><li>La gestión de solicitudes al contar revisiones se ha mejorado (ver <a href=\"https://core.trac.wordpress.org/ticket/34560\">#34560</a>).</li><li>Se ha añadido una vista expandida alternativa para <code>wp_list_table</code> (ver <a href=\"https://core.trac.wordpress.org/ticket/49715\">#49715</a>).</li><li>Se han realizado algunos ajustes a la gestión de los términos por defecto en las taxonomías personalizadas (ver <a href=\"https://core.trac.wordpress.org/ticket/43517\">#43517</a>)</li></ul>\n\n\n\n<p>Se han hecho varias actualizaciones al editor de bloques. Para más detalles ver <a href=\"https://github.com/WordPress/gutenberg/pull/23903\">#23903</a> y <a href=\"https://github.com/WordPress/gutenberg/pull/23905\">#23905</a>.</p>\n\n\n\n<h2>Notas para desarrolladores</h2>\n\n\n\n<p>WordPress 5.5 tiene montones de detalles para mejorar la experiencia del desarrollador. Para mantenerte al día suscríbete al <a href=\"https://make.wordpress.org/core/\">blog de Make WordPress Core</a> y presta especial atención a las <a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">notas para desarrolladores</a> par estar al día de estos y otros cambios que podrían afectar a tus productos.</p>\n\n\n\n<h2><strong>Cómo puedes ayudar</strong></h2>\n\n\n\n<p>¿Hablas otro idioma que no sea el inglés?&nbsp;¡<a href=\"https://translate.wordpress.org/projects/wp/dev/\">Ayuda a traducir WordPress a más de 100 idiomas</a>!</p>\n\n\n\n<p>Si crees que has encontrado un fallo, por favor, publícalo en el área&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta</a>&nbsp;de los foros de soporte. ¡Nos encantaría saber de ti! Si te sientes cómodo escribiendo un informe de un fallo reproducible,&nbsp;<a href=\"https://core.trac.wordpress.org/newticket\">envía uno al trac de WordPress</a>. Ahí es donde también puedes encontrar una lista de&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">fallos conocidos</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://es.wordpress.org/2020/07/15/wordpress-5-5-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:79:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.5 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://es.wordpress.org/2020/07/10/wordpress-5-5-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://es.wordpress.org/2020/07/10/wordpress-5-5-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Jul 2020 15:29:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"5.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=5234\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:355:\"¡Ya está disponible la beta 1 de WordPress 5.5 para probarla! Este software está aún en desarrollo, a sí que no es recomendable ejecutar esta versión en un sitio en producción. Plantéate configurar un sitio de pruebas para probar la nueva versión. Puedes probar WordPress 5.5 beta de dos maneras: Prueba el plugin WordPress Beta Tester [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:10173:\"\n<p>¡Ya está disponible la beta 1 de WordPress 5.5 para probarla!</p>\n\n\n\n<p><strong>Este software está aún en desarrollo,</strong> a sí que no es recomendable ejecutar esta versión en un sitio en producción. Plantéate configurar un sitio de pruebas para probar la nueva versión.</p>\n\n\n\n<p>Puedes probar WordPress 5.5 beta de dos maneras:</p>\n\n\n\n<ul><li>Prueba el plugin <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> (elige la opción «versión avanzada»)</li><li>O <a href=\"https://wordpress.org/wordpress-5.5-beta1.zip\">descarga aquí la beta (zip)</a>.</li></ul>\n\n\n\n<p>El objetivo actual para la versión final es el 11 de agosto de 2020. Esto son solo <strong>cinco semanas</strong>. Tu ayuda es necesaria para asegurar que esta versión se pruebe adecuadamente.</p>\n\n\n\n<p>Probar para buscar fallos es una parte importante del pulido de una versión durante la etapa beta, y un fantástico modo de contribuir. Aquí tienes algunos de los grandes cambios y características a las prestar mucha atención durante las pruebas.</p>\n\n\n\n<h2><strong>Editor de bloques: características y mejoras</strong></h2>\n\n\n\n<p>WordPress 5.5 incluirá diez versiones del plugin Gutenberg, trayendo una larga lista de emocionantes nuevas características. Aquí tienes unas cuantas:</p>\n\n\n\n<ul><li><strong>Edición de imágenes integrada – </strong>Recorta, rota y haz zoom con fotos de manera integrada, en los mismos bloques de imagen.</li><li><strong>Patrones de bloques</strong> – Crear páginas elaborados puede ser algo trivial con los patrones de bloques. Se  incluyen varios por defecto.</li><li><strong>Vistas previas por dispositivo</strong> – Revisa cómo verán tu contenido los usuarios en distintos tamaños de pantalla.</li><li><strong>Fin del agobio de bloques</strong>. El nuevo panel insertador de bloques muestra categorías y colecciones bien organizadas. Como extra, es compatible con patrones y se integra con el nuevo directorio de bloques directamente.</li><li><strong>Descubre, instala e insertar bloques de terceros</strong> desde tu editor, usando el nuevo directorio de bloques.</li><li>Una mejor y <strong>más suave experiencia de edición </strong>con: <ul><li>Arrastrar y soltar mejorado</li><li>Movedores de bloques que puedes ver y sujetar</li><li>Selección del bloque superior</li><li>Destacado de enfoque contextual</li><li>Formato de selección múltiple que te permite cambiar varios bloques a la vez</li><li>Posibilidad de copiar y recolocar bloques fácilmente</li><li>Y … mejor rendimiento</li></ul></li><li><strong>Una caja de herramientas de diseño ampliada para los temas.</strong></li><li>Ahora <strong>añade fondos y gradientes</strong> a más tipos de bloques, como a grupos, columnas, medios y texto</li><li>Y <strong>compatibilidad con más tipos de medidas</strong> — no solo píxeles. ¡Elige ems, rems, porcentajes, vh, vw y más! Además, ajusta la altura de línea mientras se escribe, haciendo que escribir y teclear sea algo fluido.</li></ul>\n\n\n\n<p>En resumen, WordPress 5.5 trae más de 1.500 mejoras útiles a la experiencia del editor de bloques. </p>\n\n\n\n<p>Para ver todas las características de cada versión en detalle echa un vistazo a las entradas de las versiones: <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v7.5.0\">7.5</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v7.6.0\">7.6</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v7.7.0\">7.7</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v7.8.0\">7.8</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v7.9.0\">7.9</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v8.0.0\">8.0</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v8.1.0\">8.1</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v8.2.0\">8.2</a>, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v8.3.0\">8.3</a> y <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v8.4.0\">8.4</a>.</p>\n\n\n\n<h2><strong>¡Espera! ¡Hay más!</strong></h2>\n\n\n\n<h3>Mapas del sitio <strong>XML</strong></h3>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/2020/06/10/merge-announcement-extensible-core-sitemaps/\">Ahora se incluyen mapas del sitio XML en WordPress</a> y estarán activos por defecto. Los mapas del sitio son esenciales para que los motores de búsqueda descubran tu web. Las entradas, páginas, tipos de contenido personalizado, la página de inicio de tu web y más se incluirán para mejorar la visibilidad de tu sitio.</p>\n\n\n\n<h3><strong>Actualizaciones automáticas de plugins y temas</strong></h3>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/tag/core-auto-updates/\">WordPress 5.5 también trae las actualizaciones automáticas de plugins y temas</a>. Controla fácilmente a qué plugins y temas permitirás que se actualicen por sí solos. Siempre es recomendable que ejecutes las últimas versiones de todos los plugins y temas. ¡Esta nueva característica hará que sea más fácil que nunca!</p>\n\n\n\n<h3>Carga diferida de imágenes<strong> images</strong></h3>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/2020/04/08/lazy-loading-of-images-is-in-core/\">WordPress 5.5 incluirá compatibilidad nativa con la carga diferida de imágenes</a> utilizando los estándares de los nuevos navegadores. Con la carga diferida, las imágenes no se envían a los usuarios hasta que se alcanza su punto de visualización. Esto ahorra ancho de banda para todos (usuarios, servidores, ISPs), haciendo más fácil a quienes tienen velocidades de Internet más lentas navegar por la web, ahorrando electricidad y más.</p>\n\n\n\n<h3><strong>Mejor accesibilidad</strong></h3>\n\n\n\n<p>En cada versión, WordPress trabaja duro para mejorar la accesibilidad. La versión 5.5 no es distinta e incluye una parcela de correcciones y mejoras de accesibilidad. Echa un vistazo:</p>\n\n\n\n<ul><li>Las tablas de listas ahora tienen más modos de visualización ampliados y alternos.</li><li>Los widgets de listas de enlaces ahora se pueden convertir a bloques de navegación en HTML5.</li><li>Copiar enlaces en pantallas de medios y ventanas emergentes ahora se puede hacer con un simple clic de botón.</li><li>Los botones desactivados ahora se ven realmente desactivados.</li><li>Las cajas meta ahora se pueden mover con el teclado.</li><li>Un logotipo personalizado en la página de inicio ya no enlaza a la página de inicio.</li><li>Los dispositivos de asistencia ahora pueden ver los mensajes de estado en el editor de imágenes.</li><li>La animación de sacudida que indica  un fallo de acceso ahora respeta la decisión del usuario en la media query <code>prefers-reduced-motion</code>.</li><li>Los prefijos de <code>Error:</code> redundantes se han eliminado de los aviso de error.</li></ul>\n\n\n\n<h2><strong>Otros cambios</strong></h2>\n\n\n\n<ul><li>Los plugins y temas ahora se pueden actualizar subiendo un archivo ZIP.</li><li><a href=\"https://make.wordpress.org/core/2020/06/26/wordpress-5-5-better-fine-grained-control-of-redirect_guess_404_permalink/\">Control más granular de redirect_guess_404_permalink()</a>.</li><li><a href=\"https://make.wordpress.org/core/2020/07/01/external-library-updates-in-wordpress-5-5-call-for-testing/\">Se han actualizado varias bibliotecas externas empaquetadas</a>, ¡incluyendo PHPMailer, SimplePie, Twemoji, Masonry y más!</li></ul>\n\n\n\n<p>Permanece atento al <a href=\"https://make.wordpress.org/core/\">blog de Make WordPress Core</a> para ver las <a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">notas para desarrolladores de la versión 5.5</a> en las próximas semanas, que incluirán estos y otros cambios en mayor detalle.</p>\n\n\n\n<p>Hasta ahora, los contribuidores han corregido más de <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;milestone=5.5&amp;group=component&amp;max=500&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\">360 tickets en WordPress 5.5</a>, incluidas <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;status=reopened&amp;type=enhancement&amp;milestone=5.5&amp;or&amp;status=closed&amp;status=reopened&amp;type=feature+request&amp;milestone=5.5&amp;col=id&amp;col=summary&amp;col=type&amp;col=status&amp;col=milestone&amp;col=owner&amp;col=priority&amp;col=changetime&amp;col=keywords&amp;order=changetime\">157 nuevas características y  mejoras</a>, y más correcciones a fallos que están en marcha.</p>\n\n\n\n<h2><strong>Cómo puedes ayudar</strong></h2>\n\n\n\n<p>¿Hablas otro idioma que no sea el inglés? ¡<a href=\"https://translate.wordpress.org/projects/wp/dev/\">Ayuda a traducir WordPress a más de 100 idiomas</a>!</p>\n\n\n\n<p>Si crees que has encontrado un fallo, por favor, publícalo en el área <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta</a> de los foros de soporte. ¡Nos encantaría saber de ti! Si te sientes cómodo escribiendo un informe de un fallo reproducible, <a href=\"https://core.trac.wordpress.org/newticket\">envía uno al trac de  WordPress</a>. Ahí es donde también puedes encontrar una lista de <a href=\"https://core.trac.wordpress.org/tickets/major\">fallos conocidos</a>.</p>\n\n\n\n<p><em>Gracias a <a href=\"https://profiles.wordpress.org/webcommsat/\">@webcommsat</a>, <a href=\"https://profiles.wordpress.org/yvettesonneveld/\">@yvettesonneveld</a>, <a href=\"https://profiles.wordpress.org/estelaris/\">@estelaris</a>, y <a href=\"https://profiles.wordpress.org/marybaum/\">@marybaum</a> por compilar y escribir la entrada original en inglés, a <a href=\"https://profiles.wordpress.org/davidbaumwald/\">@davidbaumwald</a> por mejorarla, a <a href=\"https://profiles.wordpress.org/cbringmann/\">@cbringmann</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">@desrosj</a> y <a href=\"https://profiles.wordpress.org/andreamiddleton/\">@andreamiddleton</a> por la revisión final, y a <a href=\'https://profiles.wordpress.org/fernandot/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>fernandot</a> por la entrada en español.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://es.wordpress.org/2020/07/10/wordpress-5-5-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:85:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WordPress 5.4.2: Actualización de seguridad y mantenimiento\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"https://es.wordpress.org/2020/06/11/wordpress-5-4-2-actualizacion-de-seguridad-y-mantenimiento/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"https://es.wordpress.org/2020/06/11/wordpress-5-4-2-actualizacion-de-seguridad-y-mantenimiento/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Jun 2020 18:09:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:13:\"Mantenimiento\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:9:\"Seguridad\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:3:\"5.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:5:\"5.4.2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=5099\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:382:\"¡Ya está disponible WordPress 5.4.2! Esta actualización de seguridad y mantenimiento incluye 23 correcciones a fallos y mejoras. Además, añade una serie de correcciones de seguridad – ve la lista abajo. Estos fallos afectan a las versiones de WordPress 5.4.1 y anteriores; la versión 5.4.2 las corrige, así que querrás actualizar. Si todavía no has actualizado [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:7375:\"\n<p>¡Ya está disponible WordPress 5.4.2!</p>\n\n\n\n<p>Esta actualización de seguridad y mantenimiento incluye 23 correcciones a fallos y mejoras. Además, añade una serie de correcciones de seguridad – ve la lista abajo.</p>\n\n\n\n<p>Estos fallos afectan a las versiones de WordPress 5.4.1 y anteriores; la versión 5.4.2 las corrige, así que querrás actualizar.</p>\n\n\n\n<p>Si todavía no has actualizado a la versión 5.4, también hay versiones actualizadas para las versiones 5.3 y anteriores que corrigen los fallos por ti.</p>\n\n\n\n<h3><strong>Actualizaciones de seguridad</strong></h3>\n\n\n\n<p>Las versiones de WordPress 5.4 y anteriores están afectadas por los siguientes fallos, que se corrigen en la versión 5.4.2. Si todavía no has actualizado a la versión 5.4, también hay versiones actualizadas para las versiones 5.3 y anteriores que corrigen los problemas de seguridad.</p>\n\n\n\n<ul><li>Gracias a Sam Thomas (jazzy2fives) por descubrir un problema de XSS por el que los usuarios identificados con bajos privilegios podían añadir JavaScript a las entradas en el editor de bloques.</li><li>Gracias a Luigi – (<a href=\"https://www.gubello.me/\">gubello.me</a>) por descubrir un problema de XSS por el que los usuarios identificados con permisos de subida podían añadir JavaScript a los archivos de medios.</li><li>Gracias a Ben Bidner, del equipo de seguridad de WordPress por descubrir un problema de redirección abierta en <em>wp_validate_redirect()</em>.</li><li>Gracias a <a href=\"http://apapedulimu.click/\">Nrimo Ing Pandum</a> por descubrir un problema de identificación XSS desde las subidas de temas.</li><li>Gracias a <a href=\"https://blog.ripstech.com/authors/simon-scannell\">Simon Scannell of RIPS Technologies</a> por descubrir un problema por el que <em>set-screen-option</em> podía ser mal utilizado por plugins para conseguir escalado de privilegios.</li><li>Gracias a <a href=\"https://profiles.wordpress.org/poena/\">Carolina Nymark</a> por descubrir un problema por el que los comentarios en entradas y páginas protegidas por contraseña podrían mostrarse en ciertas condiciones.</li></ul>\n\n\n\n<p>Gracias a todos los que habéis informado por <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">haber avisado de modo privado de las vulnerabilidades</a>. Esto da al equipo de seguridad tiempo para corregir las vulnerabilidades antes de que los sitios WordPress puedan ser atacados.</p>\n\n\n\n<p>También se ha lanzado una actualización de mantenimiento para las versiones 5.1, 5.2 y 5.3. Revisa la <a href=\"https://make.wordpress.org/core/2020/06/09/wordpress-5-4-2-prevent-unmoderated-comments-from-search-engine-indexation/\">nota para desarrolladores</a> para más información.</p>\n\n\n\n<p>Puedes ver la <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;resolution=fixed&amp;milestone=5.4.2&amp;order=priority\">lista completa de cambios en el Trac</a>.</p>\n\n\n\n<p>Para más información revisa la lista completa de cambios en el Trac o echa un vistazo a la <a href=\"https://wordpress.org/support/wordpress-version/version-5-4-2/\">página de documentación de la versión 5.4.2</a>.</p>\n\n\n\n<p>WordPress 5.4.2 es una actualización de mantenimiento de ciclo corto. La siguiente versión mayor será la <a href=\"https://make.wordpress.org/core/5-5/\">5.5</a>.</p>\n\n\n\n<p>Puedes descargar WordPress 5.4.2 descargándola desde es.WordPress.org, o visitar tu <strong>Escritorio → Actualizaciones</strong> y hacer clic en <strong>Actualizar ahora</strong>.</p>\n\n\n\n<p>Si tienes sitios compatibles con actualizaciones automáticas en segundo plano ya ha empezado el proceso de actualización.</p>\n\n\n\n<h3>¡Agradecimientos y reconocimientos!</h3>\n\n\n\n<p>Además de los investigadores de seguridad mencionados arriba, gracias a todos los que hay ayudado a que salga WordPress 5.4.2:</p>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/argentite\">argentite</a>, <a href=\"https://profiles.wordpress.org/asif2bd\">M Asif Rahman</a>, <a href=\"https://profiles.wordpress.org/audrasjb\">Jb Audras</a>, <a href=\"https://profiles.wordpress.org/ayeshrajans\">Ayesh Karunaratne</a>, <a href=\"https://profiles.wordpress.org/bdcstr\">bdcstr</a>, <a href=\"https://profiles.wordpress.org/delowardev\">Delowar Hossain</a>, <a href=\"https://profiles.wordpress.org/dhrrob\">Rob Migchels</a>, <a href=\"https://profiles.wordpress.org/donmhico\">donmhico</a>, <a href=\"https://profiles.wordpress.org/ehtis/\">Ehtisham Siddiqui</a>, <a href=\"https://profiles.wordpress.org/emlebrun\">Emilie LEBRUN</a>, <a href=\"https://profiles.wordpress.org/finomeno\">finomeno</a>, <a href=\"https://profiles.wordpress.org/garethgillman\">garethgillman</a>, <a href=\"https://profiles.wordpress.org/giorgio25b\">Giorgio25b</a>, <a href=\"https://profiles.wordpress.org/gma992\">Gabriel Maldonado</a>, <a href=\"https://profiles.wordpress.org/h71\">Hector F</a>, <a href=\"https://profiles.wordpress.org/ianbelanger\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/jorbin/\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/imath\">Mathieu Viet</a>, <a href=\"https://profiles.wordpress.org/javiercasares\">Javier Casares</a>, <a href=\"https://profiles.wordpress.org/joemcgill\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/jonkolbert\">jonkolbert</a>, <a href=\"https://profiles.wordpress.org/jonoaldersonwp\">Jono Alderson</a>, <a href=\"https://profiles.wordpress.org/joyously\">Joy</a>, <a href=\"https://profiles.wordpress.org/karmatosed\">Tammie Lister</a>, <a href=\"https://profiles.wordpress.org/kjellr\">Kjell Reigstad</a>, <a href=\"https://profiles.wordpress.org/kthmd\">KT</a>, <a href=\"https://profiles.wordpress.org/markusthiel\">markusthiel</a>, <a href=\"https://profiles.wordpress.org/mayankmajeji\">Mayank Majeji</a>, <a href=\"https://profiles.wordpress.org/melchoyce\">Mel Choyce-Dwan</a>, <a href=\"https://profiles.wordpress.org/mislavjuric\">mislavjuric</a>, <a href=\"https://profiles.wordpress.org/mukesh27\">Mukesh Panchal</a>, <a href=\"https://profiles.wordpress.org/nikhilbhansi\">Nikhil Bhansi</a>, <a href=\"https://profiles.wordpress.org/oakesjosh\">oakesjosh</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/passoniate\">Arslan Ahmed</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/poena\">Carolina Nymark</a>, <a href=\"https://profiles.wordpress.org/sabernhardt\">Stephen Bernhardt</a>, <a href=\"https://profiles.wordpress.org/samful\">Sam Fullalove</a>, <a href=\"https://profiles.wordpress.org/schlessera\">Alain Schlesser</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/skarabeq\">skarabeq</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/skithund\">Toni Viemerö</a>, <a href=\"https://profiles.wordpress.org/suzylah\">suzylah</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/utz119\">TeBenachi</a>, <a href=\"https://profiles.wordpress.org/whyisjake\">Jake Spurlock</a> y <a href=\"https://profiles.wordpress.org/yuhin\">yuhin</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"https://es.wordpress.org/2020/06/11/wordpress-5-4-2-actualizacion-de-seguridad-y-mantenimiento/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:73:\"\n		\n		\n					\n		\n		\n		\n				\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"WordCamp Europe Online 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://es.wordpress.org/2020/05/29/wordcamp-europe-online-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://es.wordpress.org/2020/05/29/wordcamp-europe-online-2020/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 29 May 2020 07:41:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WordCamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=5063\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:345:\"En solo una semana tenemos una nueva cita: WordCamp Europe Online 2020, un evento de encuentro de la comunidad de WordPress en el que aprender, compartir, hacer networking y sobre todo, disfrutar. ¿Qué es WCEU online? WordCamp Europe, o WCEU, es un evento anual cuyo propósito es crear y reforzar las conexiones entre las diferentes [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:8461:\"\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"583\" height=\"434\" src=\"https://es.wordpress.org/files/2020/05/wceu2020-tiles.jpg\" alt=\"\" class=\"wp-image-5065\" srcset=\"https://es.wordpress.org/files/2020/05/wceu2020-tiles.jpg 583w, https://es.wordpress.org/files/2020/05/wceu2020-tiles-300x223.jpg 300w\" sizes=\"(max-width: 583px) 100vw, 583px\" /></figure>\n\n\n\n<p>En solo una semana tenemos una nueva cita: WordCamp Europe Online 2020, un evento de encuentro de la comunidad de WordPress en el que aprender, compartir, hacer networking y sobre todo, disfrutar.</p>\n\n\n\n<h2>¿Qué es WCEU online?</h2>\n\n\n\n<p>WordCamp Europe, o WCEU, es un evento anual cuyo propósito es crear y reforzar las conexiones entre las diferentes comunidades locales de WordPress en Europa. </p>\n\n\n\n<p>Tiene una duración de tres días, durante los cuales miles de asistentes procedentes de todo el mundo disfrutarán de las numerosas conferencias, intercambian ideas y participan en el Contributor Day, una jornada dedicada a continuar mejorando entre todos el proyecto de código abierto de WordPress.</p>\n\n\n\n<p>WordCamp Europe se organiza cada año en una ciudad europea diferente por un equipo de voluntarios. Desde la primera WordCamp Europe, celebrada en 2013 ya han habido siete ediciones más en diferentes ciudades europeas, que consiguen año tras año superar el récord de asistencia a una WordCamp.&nbsp;</p>\n\n\n\n<p>La edición de este año se iba a celebrar en Oporto (Portugal), pero por la crisis de la COVID-19 ha tenido que ser pospuesta al 2021. </p>\n\n\n\n<p>Pero esto no significa que este año no vaya a haber WCEU. Los organizadores han decidido que WCEU 2020 tenía que celebrarse, y por primera vez <strong>WordCamp Europe será Online, abierta a todos y de inscripción gratuita</strong>. </p>\n\n\n\n<p>WCEU tendrá lugar <strong>del 4 al 6 de junio</strong>, donde será posible asistir a las numerosas conferencias y talleres en directo vía streaming, y al Contributor Day también virtual. </p>\n\n\n\n<p>Además, habrá salas de encuentro online donde podrás conocer a los patrocinadores, participar en demostraciones y chatear con otros asistentes a la WCEU.</p>\n\n\n\n<p>El idioma oficial de la WordCamp Europe es el inglés, y aunque no tengas un gran dominio del mismo, o tu inglés ande algo oxidado y creas que no te vas a enterar muy bien de las ponencias, o que vas a estar muy perdido, no olvides que se trata también de conocer y hacer networking con gente interesante de todo el mundo, y seguro que encontrarás personas que hablan tu idioma.&nbsp;</p>\n\n\n\n<p>Además, no hace falta que seas un experto en WordPress, si estás empezando o pensando hacerlo, encontrarás conferencias de todos los niveles de conocimiento y de todas las temáticas.</p>\n\n\n\n<h2>¿Cómo participar en WCEU Online?</h2>\n\n\n\n<p>Como ves, puedes asistir a esta edición de la WCEU desde tu casa, así que las recomendaciones para aprovechar al máximo estos tres días de intercambio de conocimientos son las siguientes:</p>\n\n\n\n<ol><li><strong>Consigue tu entrada con tiempo</strong>: Si bien es cierto que tienes hasta el 3 de junio a las 23:59 para obtener tu<a href=\"https://2020.europe.wordcamp.org/tickets/\"> entrada a la Wordcamp Europe Online 2020</a>, lo mejor es pillar el billete con tiempo y reservar esos días en el calendario para no sufrir overbooking en la agenda.</li><li><strong>Contributor Day: </strong>WCEU comienza el día 4 de junio con el Contributor Day, el día de contribución al proyecto de WordPress. Es un espacio donde el conocimiento no sólo fluye, sino que construye, porque este día del evento está dedicado única y exclusivamente a mejorar WordPress a partir de los conocimientos de la comunidad. Y cuando hablamos de comunidad nos referimos a cualquier área vinculada a WordPress. No es necesario ser programador o desarrollador para participar en el Contributor Day, tus conocimientos y background serán de ayuda.</li><li><strong>Prepara tu espacio de disfrute. </strong>Vale, una vez que tienes el acceso a las áreas de la WordCamp Europe ya estás preparado para aprovechar 2 días intensivos de conocimientos sobre WordPress. Para que los disfrutes sin contratiempos, te recomendamos:<ol><li>Cumple escrupulosamente<a href=\"https://2020.europe.wordcamp.org/code-of-conduct/\"> el código de conducta de WordCamp Europe</a> o podrías ser expulsado del evento.</li><li>Conéctate a Internet por cable si puedes, mejor que por wi-fi. La conexión siempre es más rápida y estable, y no sufrirás posibles cortes de conexión, especialmente estos días en que todos estamos conectados desde casa.</li><li>Utiliza preferentemente los navegadores Chrome o Firefox, por cuestiones de compatibilidad.</li><li>Mejor ordenador o tablet que dispositivo móvil, sobre todo para el chat en directo.</li></ol></li></ol>\n\n\n\n<p><strong>No te pierdas nada de la WordCamp</strong>: pendiente de tu email y a la<a href=\"https://2020.europe.wordcamp.org/news/\"> sección de noticias de la WCEU</a> porque estos son los canales para actualizarte sobre cambios de agenda, conexiones a las charlas y mucho más. </p>\n\n\n\n<p>Y por supuesto, sigue las páginas y cuentas de WCEU en las redes sociales:<a href=\"https://twitter.com/WCEurope/\"> Twitter de WCEU</a>,<a href=\"https://facebook.com/WCEurope/\"> Facebook de WCEU</a> e<a href=\"https://instagram.com/wceurope/\"> Instagram de WCEU</a>.</p>\n\n\n\n<h2>¡Ya está disponible el programa de WCEU!</h2>\n\n\n\n<p><strong>WordCamp Europe comenzará el día 4 de junio</strong> con el Contributor Day. Y continuará los días 5 y 6 con dos tracks paralelos de charlas que comenzarán ambos días a las 15h (hora española).</p>\n\n\n\n<p>Como todos los años, los ponentes de WordCamp Europe proceden de diferentes partes del mundo y nos hablarán sobre todo tipo de temáticas relacionadas con WordPress. </p>\n\n\n\n<p>Habrá ponencias de desarrollo, negocios, diseño, contenido, comunidad, SEO, marketing, privacidad, accesibilidad e incluso de inteligencia artificial.</p>\n\n\n\n<p>Entre los ponentes encontramos representación de la comunidad española con<a href=\"https://2020.europe.wordcamp.org/session/headless-wordpress-current-status-and-remaining-challenges/\"> Luis Herranz</a> y<a href=\"https://2020.europe.wordcamp.org/session/ai-in-the-hacking-world-war/\"> Néstor Angulo</a>.</p>\n\n\n\n<p>Al igual que ocurrió en WordCamp España Online 2020, Matt Mullenweg estará presente en WCEU en una sesión que han llamada<a href=\"https://2020.europe.wordcamp.org/session/matt-on-wordpress/\"> «In Conversation with Matt Mullenweg»</a>.</p>\n\n\n\n<h2>Beneficios de asistir a WCEU online</h2>\n\n\n\n<p>Que WordCamp Europa sea online nos brinda grandes posibilidades y oportunidades que queremos recordarte con el fin de animarte a no perder esta gran cita de la comunidad de WordPress.</p>\n\n\n\n<ul><li>Puedes <strong>marcar la diferencia</strong> ayudando a la comunidad a crecer con solo tu asistencia.</li><li>Es una <strong>manera fácil y divertida</strong> de aprender de la mano de grandes ponentes que te lo explican por su propia experiencia y, quien quita, puede que hables o trabajes en un tú a tú con ellos el día del Contributor Day.</li><li><strong>Practicar el inglés</strong> y conocer gente en las salas para networking y en el Contributor Day, no hay mejor manera de aprender divirtiéndose y conocer formas diferentes de usar WordPress.</li><li>En esta nueva versión no podremos notar la cercanía de los asistentes, pero en cambio <strong>los costes</strong> de ir a la WordCamp se verán reducidos, ¡aunque el café lo pones tú!</li></ul>\n\n\n\n<p>Por estas y muchas otras razones te animamos a vernos, esta vez de forma virtual, en la próxima WordCamp Europe 2020. </p>\n\n\n\n<p>Venga, no te lo pienses más, y consigue ya tu<a href=\"https://2020.europe.wordcamp.org/tickets/\"> entrada gratuita a WCEU.</a></p>\n\n\n\n<p>¡Nos vemos del 4 al 6 de junio!</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><strong>Redacción:</strong> <a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/anagavilan/\" target=\"_blank\">Ana Gavilán</a>, <a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/lusan2/\" target=\"_blank\">Lucía Sánchez</a> y <a href=\"https://profiles.wordpress.org/menapa/\" target=\"_blank\" rel=\"noreferrer noopener\">Merce Navas</a>.</p><cite><strong>Revisión:</strong><a href=\"https://profiles.wordpress.org/sacrajaimez/\"> @sacrajaimez</a></cite></blockquote>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://es.wordpress.org/2020/05/29/wordcamp-europe-online-2020/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:85:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"WordPress 5.4.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://es.wordpress.org/2020/04/30/wordpress-5-4-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://es.wordpress.org/2020/04/30/wordpress-5-4-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Apr 2020 06:53:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:13:\"Mantenimiento\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:9:\"Seguridad\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:3:\"5.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:5:\"5.4.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=4955\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:416:\"¡Ya está disponible WordPress 5.4.1! Esta actualización de seguridad y mantenimiento contiene 17 correcciones a fallos además de 7 correcciones de seguridad. Al ser una actualización de seguridad es recomendable que actualices tus sitios de inmediato. Todas las versiones desde WordPress 3.7 también se han actualizado. WordPress 5.4.1 es una versión de mantenimiento de ciclo corto. La siguiente [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:7441:\"\n<p>¡Ya está disponible WordPress 5.4.1!</p>\n\n\n\n<p>Esta actualización de seguridad y mantenimiento contiene 17 <a href=\"https://core.trac.wordpress.org/query?milestone=5.4.1&amp;group=component&amp;col=id&amp;col=summary&amp;col=milestone&amp;col=owner&amp;col=type&amp;col=status&amp;col=priority&amp;order=priorityhttps://core.trac.wordpress.org/query?milestone=5.4.1&amp;group=component&amp;col=id&amp;col=summary&amp;col=milestone&amp;col=owner&amp;col=type&amp;col=status&amp;col=priority&amp;order=priority\">correcciones a fallos</a> además de 7 correcciones de seguridad. Al ser una <strong>actualización de seguridad</strong> es recomendable que actualices tus sitios de inmediato. Todas las versiones desde WordPress 3.7 también se han actualizado.</p>\n\n\n\n<p>WordPress 5.4.1 es una versión de mantenimiento de ciclo corto. La siguiente versión mayor será la 5.5.</p>\n\n\n\n<p>Puedes descargar WordPress 5.4.1 descargándola desde es.WordPress.org, o visitar tu Escritorio → Actualizaciones y hacer clic en Actualizar ahora.</p>\n\n\n\n<p>Si tienes sitios compatibles con actualizaciones automáticas en segundo plano ya ha empezado el proceso de actualización.</p>\n\n\n\n<h3>Actualizaciones de seguridad</h3>\n\n\n\n<p>Son siete problemas de seguridad que afectan a WordPress 5.4 y anteriores. Si no has actualizado todavía a la versión 5.4 también se han actualizado todas las versiones de WordPress desde la 3.7 para corregir los siguientes problemas de seguridad:</p>\n\n\n\n<ul><li>Gracias a <a href=\"https://hackerone.com/hijibiji\">Muaz Bin Abdus Sattar</a> y <a href=\"https://hackerone.com/dyennez\">Jannes</a> que informaron independientemente de un problema por el que los tokens de restablecimiento de contraseña no se invalidaban correctamente</li><li>Gracias a <a href=\"https://github.com/ka1n4t\">ka1n4t</a> por descubrir un problema por el que ciertas entradas privadas podián verse sin identificarse</li><li>Gracias a <a href=\"https://evanricafort.com/\">Evan Ricafort</a> por descubrir un problema de XSS en el personalizador</li><li>Gracias a Ben Bidner del equipo de seguridad de WordPress, que descubrió un problema de XSS en el bloque de búsqueda</li><li>Gracias a Nick Daugherty del equipo de <a href=\"https://wpvip.com/\">WordPress VIP</a>  y de seguridad de WordPress, que descubrió un problema de XSS en <code>wp-object-cache</code></li><li>Gracias a Ronnie Goodrich (<a href=\"https://hackerone.com/kahoots\">Kahoots</a>) y <a href=\"http://pentestusa.com/\">Jason Medeiros</a> que informaron independientementne de un problema de XSS en las subidas de archivos.</li><li>Gracias a <a href=\"https://weston.ruter.net/\">Weston Ruter</a> por corregir una vulnerabilidad de XSS almacenado en el personalizador</li><li>Además, Nguyen de Duc descubrió un problema de XSS identificado en el editor de bloques en las versiones de WordPress 5.4 RC1 y RC2. Se corrigió en la 5.4 RC5. Queríamos estar seguros de agradecer y reconocer todo su trabajo para hacer que WordPress sea más seguro</li></ul>\n\n\n\n<p>Gracias a todos los que habéis informado por <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">haber avisado de modo privado de las vulnerabilidades</a>. Esto da al equipo de seguridad tiempo para corregir las vulnerabilidades antes de que los sitios WordPress puedan ser atacados.</p>\n\n\n\n<p>Para más información revisa la <a href=\"https://core.trac.wordpress.org/query?milestone=5.4.1&amp;group=component&amp;col=id&amp;col=summary&amp;col=milestone&amp;col=owner&amp;col=type&amp;col=status&amp;col=priority&amp;order=priority\">lista completa de cambios</a> en el Trac, o echa un vistazo a la <a href=\"https://wordpress.org/support/wordpress-version/version-5-4-1/\">página de documentación en HelpHub de la versión 5.4.1</a>.</p>\n\n\n\n<p>ADemás de los investigadores de seguridad mencionados arriba, gracias a todos los que han ayudado a que WordPress 5.4.1 esté disponible:</p>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/aduth/\">Andrew Duthie</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/afragen/\">Andy Fragen</a>, <a href=\"https://profiles.wordpress.org/apeatling/\">Andy Peatling</a>, <a href=\"https://profiles.wordpress.org/arnaudbroes/\">arnaudbroes</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/dhrrob/\">DhrRob</a>, <a href=\"https://profiles.wordpress.org/dono12/\">Dono12</a>, <a href=\"https://profiles.wordpress.org/dudo/\">dudo</a>, <a href=\"https://profiles.wordpress.org/ehtis/\">Ehtisham Siddiqui</a>, <a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>, <a href=\"https://profiles.wordpress.org/garrett-eclipse/\">Garrett Hyder</a>, <a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/ipstenu/\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/whyisjake/\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>, <a href=\"https://profiles.wordpress.org/kadamwhite/\">K. Adam White</a>, <a href=\"https://profiles.wordpress.org/ryelle/\">Kelly Choyce-Dwan</a>, <a href=\"https://profiles.wordpress.org/markrh/\">MarkRH</a>, <a href=\"https://profiles.wordpress.org/mattyrob/\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/mcsf/\">Miguel Fonseca</a>, <a href=\"https://profiles.wordpress.org/batmoo/\">Mohammad Jangda</a>, <a href=\"https://profiles.wordpress.org/mukesh27/\">Mukesh Panchal</a>, <a href=\"https://profiles.wordpress.org/nickdaugherty/\">Nick Daugherty</a>, <a href=\"https://profiles.wordpress.org/noahtallen/\">noahtallen</a>, <a href=\"https://profiles.wordpress.org/pbiron/\">Paul Biron</a>, <a href=\"https://profiles.wordpress.org/westi/\">Peter Westwood</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/pikamander2/\">pikamander2</a>, <a href=\"https://profiles.wordpress.org/r-a-y/\">r-a-y</a>, <a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>, <a href=\"https://profiles.wordpress.org/otto42/\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sorenbronsted/\">Søren Brønsted</a>, <a href=\"https://profiles.wordpress.org/sstoqnov/\">Stanimir Stoyanov</a>, <a href=\"https://profiles.wordpress.org/isabel_brison/\">tellthemachines</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs/\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/toro_unit/\">Toro_Unit (Hiroshi Urabe)</a>, <a href=\"https://profiles.wordpress.org/treecutter/\">treecutter</a> y <a href=\"https://profiles.wordpress.org/yohannp/\">yohannp</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://es.wordpress.org/2020/04/30/wordpress-5-4-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:73:\"\n		\n		\n					\n		\n		\n		\n				\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"WordCamp  España Online 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://es.wordpress.org/2020/04/29/wordcamp-espana-online-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://es.wordpress.org/2020/04/29/wordcamp-espana-online-2020/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Apr 2020 11:34:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WordCamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=4950\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:374:\"Si echas de menos los eventos de la comunidad WordPress España estás de enhorabuena pues ni siquiera las pandemias mundiales pueden pararnos. Es cierto que durante meses estamos añorando las WordCamp y Meetups presenciales, en las que compartir conocimientos y experiencias con otros usuarios de WordPress, pero no todo estaba dicho. La primera WordCamp España [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4726:\"\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"800\" height=\"450\" src=\"https://es.wordpress.org/files/2020/04/WCES-2020-blog-WordPress.org_.png\" alt=\"\" class=\"wp-image-4951\" srcset=\"https://es.wordpress.org/files/2020/04/WCES-2020-blog-WordPress.org_.png 800w, https://es.wordpress.org/files/2020/04/WCES-2020-blog-WordPress.org_-300x169.png 300w, https://es.wordpress.org/files/2020/04/WCES-2020-blog-WordPress.org_-768x432.png 768w\" sizes=\"(max-width: 800px) 100vw, 800px\" /></figure>\n\n\n\n<p>Si echas de menos los eventos de la comunidad WordPress España estás de enhorabuena pues ni siquiera las pandemias mundiales pueden pararnos.</p>\n\n\n\n<p>Es cierto que durante meses estamos añorando las WordCamp y Meetups presenciales, en las que compartir conocimientos y experiencias  con otros usuarios de WordPress, pero no todo estaba dicho.</p>\n\n\n\n<h2>La primera WordCamp España Online</h2>\n\n\n\n<p>Un grupo de locos encantadores tuvieron  la genial idea de plantear una WordCamp Online para todos los hispanohablantes, y dicho y hecho.</p>\n\n\n\n<p>En cuestión de días estaba montado <a rel=\"noreferrer noopener\" href=\"https://2020.spain.wordcamp.org/organizadores/\" target=\"_blank\">el equipo de organización de de la primera WordCamp España Online</a>.</p>\n\n\n\n<p>En pocos días estaba creada <a rel=\"noreferrer noopener\" href=\"https://2020.spain.wordcamp.org\" target=\"_blank\">la web</a> y todo en funcionamiento, con llamadas a <a rel=\"noreferrer noopener\" href=\"https://2020.spain.wordcamp.org/2020/04/02/llamada-a-ponentes/\" target=\"_blank\">ponentes</a> y <a rel=\"noreferrer noopener\" href=\"https://2020.spain.wordcamp.org/2020/04/06/llamada-patrocinadores/\" target=\"_blank\">patrocinadores</a>.</p>\n\n\n\n<h2>4 días de WordCamp y un programa impresionante</h2>\n\n\n\n<p> Si algo te llamará la atención de WordCamp España Online va a ser <strong><a href=\"https://2020.spain.wordcamp.org/programa-wces-2020/\" target=\"_blank\" rel=\"noreferrer noopener\">el inmenso, interesante, diverso y completo programa de ponencias, charlas y talleres</a></strong>.</p>\n\n\n\n<p>Son nada menos que <strong>4 días, del 6 al 9 de mayo de 2020</strong>, en horario <strong>de 16:00  a 20:30 (CEST)</strong>, y da para mucho.</p>\n\n\n\n<h2>Un evento WordPress diferente</h2>\n\n\n\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"800\" height=\"450\" src=\"https://es.wordpress.org/files/2020/04/WCES-2020-blog-sobre-WCES.png\" alt=\"\" class=\"wp-image-4865\" srcset=\"https://es.wordpress.org/files/2020/04/WCES-2020-blog-sobre-WCES.png 800w, https://es.wordpress.org/files/2020/04/WCES-2020-blog-sobre-WCES-300x169.png 300w, https://es.wordpress.org/files/2020/04/WCES-2020-blog-sobre-WCES-768x432.png 768w\" sizes=\"(max-width: 800px) 100vw, 800px\" /></figure>\n\n\n\n<p>Al ser online, va a ser una WordCamp diferente, en la que la organización está desgranando las esencias para que no se pierda el carácter de evento de comunidad WordPress.</p>\n\n\n\n<p>Para conseguirlo, habrá salas privadas con los ponentes (online claro), mesas (virtuales) de contribución, y un montón más de maneras de conectar, aprender y compartir, como en cualquier evento WordPress.</p>\n\n\n\n<h2>Cómo disfrutar la primera  WordCamp España Online</h2>\n\n\n\n<p>Poco hace falta para disfrutar de este evento único e inolvidable, que lo será.</p>\n\n\n\n<p>En la web han detallado <a rel=\"noreferrer noopener\" href=\"https://2020.spain.wordcamp.org/como-asistir/\" target=\"_blank\"><strong>unos importantes consejos para los asistentes</strong></a>, que te recomendamos echar un vistazo.</p>\n\n\n\n<p>Pero sobre todo, lo más importante, es que te registres como asistente, para una experiencia plena de WordCamp España Online 2020.</p>\n\n\n\n<p>También se podrán ver las ponencias desde YouTube, pero la experiencia total será si te registras, algo más fácil que nunca…</p>\n\n\n\n<h2>Entradas gratuitas</h2>\n\n\n\n<p>Sí, el evento es totalmente gratis, y además con sorpresas, regalos, sorteos, y todo tipo de ventajas para los usuarios registrados.</p>\n\n\n\n<ul><li>Comunicaciones exclusivas a usuarios registrados.</li><li>Fantásticos regalos digitales de WordCamp España.</li><li>Participar en sorteos exclusivos de nuestros patrocinadores.</li><li>Acceso a salas de networking privadas con los ponentes.</li></ul>\n\n\n\n<p>Seguro que ya lo tienes claro ¿no? Pues nada, pulsa en el siguiente botón y reserva ya tu entrada gratuita para este evento tan especial, para la primera WordCamp España Online. </p>\n\n\n\n<div class=\"wp-block-buttons\">\n<div class=\"wp-block-button\"><a class=\"wp-block-button__link\" href=\"https://2020.spain.wordcamp.org/entradas/\" target=\"_blank\" rel=\"noreferrer noopener\">Registrarme en WordCamp España Online</a></div>\n</div>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://es.wordpress.org/2020/04/29/wordcamp-espana-online-2020/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:76:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"WordPress 5.4 «Adderley»\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://es.wordpress.org/2020/04/01/wordpress-5-4-adderley/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://es.wordpress.org/2020/04/01/wordpress-5-4-adderley/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 01 Apr 2020 07:24:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:15:\"Actualizaciones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"5.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://es.wordpress.org/?p=4802\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:349:\"Bienvenido a WordPress 5.4 Cada versión mayor añade más cosas al editor de bloques. Más formas de hacer que las entradas y páginas cobren vida con tus mejores imágenes. Más formas de atraer a los visitantes y de mantenerlos implicados con la diversidad de medios incrustados desde los principales servicios web. Más formas de hacer [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Fernando Tellado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:53905:\"\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://es.wordpress.org/files/2020/04/5-4_album-cover-1024x1024.png\" alt=\"\" class=\"wp-image-4803\" srcset=\"https://es.wordpress.org/files/2020/04/5-4_album-cover-1024x1024.png 1024w, https://es.wordpress.org/files/2020/04/5-4_album-cover-300x300.png 300w, https://es.wordpress.org/files/2020/04/5-4_album-cover-150x150.png 150w, https://es.wordpress.org/files/2020/04/5-4_album-cover-768x768.png 768w, https://es.wordpress.org/files/2020/04/5-4_album-cover.png 1264w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure>\n\n\n\n<div class=\"wp-block-group has-very-light-gray-color has-text-color has-background\" style=\"background-color:#0658e5\"><div class=\"wp-block-group__inner-container\">\n<h2 class=\"has-text-align-center\">Di hola a más y mejor</h2>\n\n\n\n<p class=\"has-text-align-center\">Más formas de hacer que tus páginas cobren vida. Con formas más fáciles de hacer todo y que luzca mejor que nunca –&nbsp;¡y mejoras de velocidad que puedes notar!</p>\n</div></div>\n\n\n\n<h2>Bienvenido a WordPress 5.4</h2>\n\n\n\n<p>Cada versión mayor añade más cosas al editor de bloques.</p>\n\n\n\n<p>Más formas de hacer que las entradas y páginas cobren vida con tus mejores imágenes. Más formas de atraer a los visitantes y de mantenerlos implicados con la diversidad de medios incrustados desde los principales servicios web.</p>\n\n\n\n<p>Más formas de hacer real tu visión y de poner bloques en el lugar perfecto –&nbsp;incluso si un tipo de bloque en particular es nuevo para ti. Procesos más eficaces.</p>\n\n\n\n<p>Y más velocidad en todas partes, para que, mientras creas secciones o galerías o simplemente escribes una línea de prosa, puedas sentir cómo tu trabajo es más rápido.</p>\n\n\n\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"1024\" height=\"512\" src=\"https://es.wordpress.org/files/2020/04/Squares-1024x512.jpg\" alt=\"\" class=\"wp-image-4804\" srcset=\"https://es.wordpress.org/files/2020/04/Squares-1024x512.jpg 1024w, https://es.wordpress.org/files/2020/04/Squares-300x150.jpg 300w, https://es.wordpress.org/files/2020/04/Squares-768x384.jpg 768w, https://es.wordpress.org/files/2020/04/Squares.jpg 1264w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure>\n\n\n\n<h2>Dos nuevos bloques. Y mejores bloques en general</h2>\n\n\n\n<ul><li>Dos bloques totalmente nuevos: El bloque de enlaces sociales y el de botones hacen que añadir características interactivas sea rápido y fácil.</li><li>Nuevas posibilidades con el color: Gradientes en el bloque de botones y fondo, acceso a la barra de herramientas para las opciones de color en los bloques de texto enriquecido y, por primera vez, opciones de color en los bloques de grupo y columnas.</li><li>¡Imagina que mucho menos! La versión 5.4 agiliza todo el proceso de colocación y sustitución de medios en cada bloque. ¡Ahora funciona de la misma manera en casi todos los bloques!</li><li>Y si alguna vez has pensado que tu imagen del bloque de medios y texto debería enlazar a alguna otra cosa – ¿quizá una imagen de un folleto que debería descargar ese folleto como documento? Bien, pues ahora puedes hacerlo.</li></ul>\n\n\n\n<figure class=\"wp-block-video\"><video controls preload=\"auto\" src=\"https://es.wordpress.org/files/2020/04/textcolor.mp4\"></video></figure>\n\n\n\n<h2>Interfaz más clara, navegación más clara –&nbsp;¡y tabulado más sencillo!</h2>\n\n\n\n<ul><li>Navegación por los bloques más clara con migas de pan de bloques. Una selección más sencilla una vez estés ahí.</li><li>Para cuando necesites navegar con el teclado, tienes un mejor tabulado y enfoque. Además, puedes tabular a la barra lateral de prácticamente cualquier bloque.</li><li>¡Velocidad! Un 14 % más rápido en cargar el editor, un 51 % más rápido en el tiempo de tecleo!</li><li>Las sugerencias han desaparecido. En su lugar, una ventana con la guía de bienvenida puede llevarte a dónde necesites —y solo cuando lo necesites— una y otra vez.</li><li>Descubre a simple vista si estás en el modo de edición o de navegación de bloques. O, si tienes una visión restringida, tu lector en pantalla te dirá en qué modo estás.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Por supuesto, si quieres utilizar las más recientes herramientas y características, instala el&nbsp;<a href=\"https://es.wordpress.org/plugins/gutenberg/\">plugin Gutenberg</a>. Podrás ser el primero en utilizar las nuevas y sorprendentes características del editor de bloques, ¡antes que nadie las vea!</p></blockquote>\n\n\n\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"1024\" height=\"512\" src=\"https://es.wordpress.org/files/2020/04/Rectangles-and-circles-1-1024x512.jpg\" alt=\"\" class=\"wp-image-4807\" srcset=\"https://es.wordpress.org/files/2020/04/Rectangles-and-circles-1-1024x512.jpg 1024w, https://es.wordpress.org/files/2020/04/Rectangles-and-circles-1-300x150.jpg 300w, https://es.wordpress.org/files/2020/04/Rectangles-and-circles-1-768x384.jpg 768w, https://es.wordpress.org/files/2020/04/Rectangles-and-circles-1.jpg 1264w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure>\n\n\n\n<h2>Tu derecho fundamental: privacidad</h2>\n\n\n\n<p>WordPress 5.4 ayuda con una gran variedad de problemas de privacidad de todo el mundo. De este modo, cuando los usuarios y colaboradores pregunten sobre el cumplimiento de la normativa o sobre cómo gestiona tu equipo los datos de los usuarios, las respuestas deberían ser mucho más fáciles de obtener.</p>\n\n\n\n<p>Echa un vistazo:</p>\n\n\n\n<ul><li>Ahora, las exportaciones de datos personales incluyen la información sobre las sesiones de los usuarios y los datos de ubicación de los usuarios del widget de eventos de la comunidad. Además, ¡una tabla de contenidos!</li><li>Mira el progreso a medida que procesas las solicitudes de exportación y borrado a través de las herramientas de privacidad.</li><li>Además, pequeñas mejoras en todo dan a las herramientas de privacidad un aspecto más limpio. ¡Tus ojos te lo agradecerán!</li></ul>\n\n\n\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"1024\" height=\"512\" src=\"https://es.wordpress.org/files/2020/04/Mixed-1024x512.jpg\" alt=\"\" class=\"wp-image-4808\" srcset=\"https://es.wordpress.org/files/2020/04/Mixed-1024x512.jpg 1024w, https://es.wordpress.org/files/2020/04/Mixed-300x150.jpg 300w, https://es.wordpress.org/files/2020/04/Mixed-768x384.jpg 768w, https://es.wordpress.org/files/2020/04/Mixed.jpg 1264w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure>\n\n\n\n<h2>Solo para los desarrolladores</h2>\n\n\n\n<h3>Añadir campos personalizados a los elementos del menú, de forma nativa</h3>\n\n\n\n<p>Dos nuevas acciones te permiten añadir campos personalizados a los elementos del menú, sin necesidad de un plugin y sin escribir walkers personalizados.</p>\n\n\n\n<p>En la pantalla de administración de menús,&nbsp;<code>wp_nav_menu_item_custom_fields</code>&nbsp;se activa justo antes de los botones de un elemento de navegación del menú en el editor de menús.</p>\n\n\n\n<p>En el personalizador,&nbsp;<code>wp_nav_menu_item_custom_fields_customize_template</code>&nbsp;se activa al final de la plantilla de elementos del menú y campos de formulario.</p>\n\n\n\n<p>Comprueba tu código y mira dónde pueden reemplazar estas nuevas acciones a tu código personalizado y, si te preocupa la duplicación, añade una comprobación para la versión de WordPress.</p>\n\n\n\n<h3>¡Bloques! Estilo más sencillo, nuevas API e incrustaciones</h3>\n\n\n\n<ul><li><strong>Radicalmente</strong>&nbsp;más sencillo el estilo de los bloques. ¡Los márgenes negativos y el relleno por defecto han desaparecido! Ahora puedes dar estilo a los bloques del modo que los necesitas. Y una reprogramación se ha deshecho de cuatro `div` de envoltura redundantes.</li><li>Ahora, si creas plugins, puedes registrar las colecciones de tus bloques por el espacio de nombres a través de las categorías, una gran forma de obtener más visibilidad de marca.</li><li>Deja que los usuarios hagan más con dos nuevas API: variaciones y gradientes de bloques.</li><li>Ahora, en los incrustados, el editor de bloques es compatible con TikTok y se ha eliminado CollegeHumor.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Hay mucho más que los desarrolladores adorarán en WordPress 5.4. Para descubrir más y aprender cómo hacer que estos cambios brillen en tus sitios, temas, plugins y más, consulta la&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">guía de campo de WordPress 5.4.</a></p></blockquote>\n\n\n\n<h2><strong>El equipo</strong></h2>\n\n\n\n<p>Esta versión la lideraron&nbsp;<a href=\"http://ma.tt/\">Matt Mullenweg</a>,&nbsp;<a href=\"https://profiles.wordpress.org/francina\">Francesca Marano</a> y&nbsp;<a href=\"https://dream-encode.com/blog/\">David Baumwald</a>. Recibieron apoyo entusiasta del equipo de la versión:</p>\n\n\n\n<ul><li><strong>Editor técnico</strong>: Jorge Filipe Costa (<strong><a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">@jorgefelipecosta</a></strong>)</li><li><strong>Editor de diseño</strong>: Mark Uraine (<a rel=\"noreferrer noopener\" target=\"_blank\" href=\"https://profiles.wordpress.org/mapk/\"><strong>@mapk</strong></a>)</li><li><strong>Núcleo técnico</strong>: Sergey Biryukov (<a href=\"https://profiles.wordpress.org/sergeybiryukov/\"><strong>@sergeybiryukov</strong></a>)</li><li><strong>Diseño</strong>: Tammie Lister (<strong><a href=\"https://profiles.wordpress.org/karmatosed/\">@karmatosed</a></strong>)</li><li><strong>Coordinador de documentación</strong>:&nbsp;JB Audras (<a href=\"https://profiles.wordpress.org/audrasjb/\"><strong>@audrasjb</strong></a>)</li><li><strong>Encargado de documentación y comunicaciones</strong>: Mary Baum (<strong><a href=\"https://profiles.wordpress.org/marybaum/\">@marybaum</a></strong>)</li></ul>\n\n\n\n<p>Al equipo se unieron a lo largo de todo el ciclo de desarrollo&nbsp;<strong>552 generosos contribuidores voluntarios</strong>&nbsp;que trabajaron colectivamente en&nbsp;<strong><a href=\"https://core.trac.wordpress.org/milestone/5.4\">361</a>&nbsp;tickets en el Trac</strong>&nbsp;y&nbsp;<strong>1226 peticiones en GitHub</strong>.</p>\n\n\n\n<p>Ponte una lista de reproducción de Nat Adderley, haz clic en ese botón de actualizar (o&nbsp;<a href=\"https://es.wordpress.org/download/\">descárgala directamente</a>), y echa un vistazo a los perfiles de los amigos que han ayudado: <a href=\"https://profiles.wordpress.org/0v3rth3d4wn/\">0v3rth3d4wn</a>,&nbsp;<a href=\"https://profiles.wordpress.org/123host/\">123host</a>,&nbsp;<a href=\"https://profiles.wordpress.org/1naveengiri/\">1naveengiri</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jorbin/\">Aaron Jorbin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/abhijitrakas/\">Abhijit Rakas</a>,&nbsp;<a href=\"https://profiles.wordpress.org/abrightclearweb/\">abrightclearweb</a>,&nbsp;<a href=\"https://profiles.wordpress.org/acosmin/\">acosmin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/adamsilverstein/\">Adam Silverstein</a>,&nbsp;<a href=\"https://profiles.wordpress.org/adamboro/\">adamboro</a>,&nbsp;<a href=\"https://profiles.wordpress.org/addiestavlo/\">Addie</a>,&nbsp;<a href=\"https://profiles.wordpress.org/adnanlimdi/\">adnan.limdi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/shaikhaezaz80/\">Aezaz Shaikh</a>,&nbsp;<a href=\"https://profiles.wordpress.org/aftabmuni/\">Aftab Ali Muni</a>,&nbsp;<a href=\"https://profiles.wordpress.org/akibjorklund/\">Aki Björklund</a>,&nbsp;<a href=\"https://profiles.wordpress.org/smallprogrammers/\">Akib</a>,&nbsp;<a href=\"https://profiles.wordpress.org/atachibana/\">Akira Tachibana</a>,&nbsp;<a href=\"https://profiles.wordpress.org/akshayar/\">akshayar</a>,&nbsp;<a href=\"https://profiles.wordpress.org/schlessera/\">Alain Schlesser</a>,&nbsp;<a href=\"https://profiles.wordpress.org/aljullu/\">Albert Juhé Lluveras</a>,&nbsp;<a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>,&nbsp;<a href=\"https://profiles.wordpress.org/viper007bond/\">Alex Mills</a>,&nbsp;<a href=\"https://profiles.wordpress.org/alexholsgrove/\">AlexHolsgrove</a>,&nbsp;<a href=\"https://profiles.wordpress.org/alexischenal/\">alexischenal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/alextran/\">alextran</a>,&nbsp;<a href=\"https://profiles.wordpress.org/alishankhan/\">alishankhan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/allancole/\">allancole</a>,&nbsp;<a href=\"https://profiles.wordpress.org/allendav/\">Allen Snook</a>,&nbsp;<a href=\"https://profiles.wordpress.org/alpipego/\">alpipego</a>,&nbsp;<a href=\"https://profiles.wordpress.org/amirs17/\">Amir Seljubac</a>,&nbsp;<a href=\"https://profiles.wordpress.org/wpamitkumar/\">Amit Dudhat</a>,&nbsp;<a href=\"https://profiles.wordpress.org/amolv/\">Amol Vhankalas</a>,&nbsp;<a href=\"https://profiles.wordpress.org/agawish/\">Amr Gawish</a>,&nbsp;<a href=\"https://profiles.wordpress.org/amykamala/\">Amy Kamala</a>,&nbsp;<a href=\"https://profiles.wordpress.org/anantajitjg/\">Anantajit JG</a>,&nbsp;<a href=\"https://profiles.wordpress.org/anlino/\">Anders Norén</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nosolosw/\">Andrés</a>,&nbsp;<a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dontdream/\">Andrea Tarantini</a>,&nbsp;<a href=\"https://profiles.wordpress.org/andreaitm/\">andreaitm</a>,&nbsp;<a href=\"https://profiles.wordpress.org/andraganescu/\">Andrei Draganescu</a>,&nbsp;<a href=\"https://profiles.wordpress.org/aandrewdixon/\">Andrew Dixon</a>,&nbsp;<a href=\"https://profiles.wordpress.org/aduth/\">Andrew Duthie</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nacin/\">Andrew Nacin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/andrewserong/\">Andrew Serong</a>,&nbsp;<a href=\"https://profiles.wordpress.org/eatingrules/\">Andrew Wilder</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rarst/\">Andrey Savchenko</a>,&nbsp;<a href=\"https://profiles.wordpress.org/afragen/\">Andy Fragen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/andizer/\">Andy Meerwaldt</a>,&nbsp;<a href=\"https://profiles.wordpress.org/apeatling/\">Andy Peatling</a>,&nbsp;<a href=\"https://profiles.wordpress.org/la-geek/\">Angelika Reisiger</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ankitmaru/\">Ankit Panchal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/antpb/\">Anthony Burchell</a>,&nbsp;<a href=\"https://profiles.wordpress.org/paranoia1906/\">Anthony Ledesma</a>,&nbsp;<a href=\"https://profiles.wordpress.org/apedog/\">apedog</a>,&nbsp;<a href=\"https://profiles.wordpress.org/apermo/\">Apermo</a>,&nbsp;<a href=\"https://profiles.wordpress.org/apieschel/\">apieschel</a>,&nbsp;<a href=\"https://profiles.wordpress.org/aravindajith/\">Aravind Ajith</a>,&nbsp;<a href=\"https://profiles.wordpress.org/archon810/\">archon810</a>,&nbsp;<a href=\"https://profiles.wordpress.org/arenddeboer/\">arenddeboer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/aristath/\">Ari Stathopoulos</a>,&nbsp;<a href=\"https://profiles.wordpress.org/passoniate/\">Arslan Ahmed</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ashokrd2013/\">ashokrd2013</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ataurr/\">Ataur R</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ate-up-with-motor/\">Ate Up With Motor</a>,&nbsp;<a href=\"https://profiles.wordpress.org/autotutorial/\">autotutorial</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ayeshrajans/\">Ayesh Karunaratne</a>,&nbsp;<a href=\"https://profiles.wordpress.org/backups/\">BackuPs</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bahia0019/\">bahia0019</a>,&nbsp;<a href=\"https://profiles.wordpress.org/b-07/\">Bappi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bartczyz/\">Bart Czyz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bengreeley/\">Ben Greeley</a>,&nbsp;<a href=\"https://profiles.wordpress.org/benedictsinger/\">benedictsinger</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bfintal/\">Benjamin Intal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bibliofille/\">bibliofille</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bilgilabs/\">bilgilabs</a>,&nbsp;<a href=\"https://profiles.wordpress.org/birgire/\">Birgir Erlendsson</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bph/\">Birgit Pauli-Haack</a>,&nbsp;<a href=\"https://profiles.wordpress.org/skypressatx/\">BMO</a>,&nbsp;<a href=\"https://profiles.wordpress.org/boga86/\">Boga86</a>,&nbsp;<a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone Gorges</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bwmarkle/\">Brad Markle</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kraftbj/\">Brandon Kraft</a>,&nbsp;<a href=\"https://profiles.wordpress.org/brentswisher/\">Brent Swisher</a>,&nbsp;<a href=\"https://profiles.wordpress.org/cvoell/\">Cameron Voell</a>,&nbsp;<a href=\"https://profiles.wordpress.org/poena/\">Carolina Nymark</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ceyhun0/\">ceyhun0</a>,&nbsp;<a href=\"https://profiles.wordpress.org/chetan200891/\">Chetan Prajapati</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ketuchetan/\">Chetan Satasiya</a>,&nbsp;<a href=\"https://profiles.wordpress.org/chinteshprajapati/\">Chintesh Prajapati</a>,&nbsp;<a href=\"https://profiles.wordpress.org/chipsnyder/\">Chip Snyder</a>,&nbsp;<a href=\"https://profiles.wordpress.org/cklosows/\">Chris Klosowski</a>,&nbsp;<a href=\"https://profiles.wordpress.org/eclare/\">Chris Trynkiewicz (Sukces Strony)</a>,&nbsp;<a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pixelverbieger/\">Christian Sabo</a>,&nbsp;<a href=\"https://profiles.wordpress.org/christianamohr/\">Christiana Mohr</a>,&nbsp;<a href=\"https://profiles.wordpress.org/clayisland/\">clayisland</a>,&nbsp;<a href=\"https://profiles.wordpress.org/copons/\">Copons</a>,&nbsp;<a href=\"https://profiles.wordpress.org/coreymckrill/\">Corey McKrill</a>,&nbsp;<a href=\"https://profiles.wordpress.org/crdunst/\">crdunst</a>,&nbsp;<a href=\"https://profiles.wordpress.org/littlebigthing/\">Csaba (LittleBigThings)</a>,&nbsp;<a href=\"https://profiles.wordpress.org/xendo/\">Dademaru</a>,&nbsp;<a href=\"https://profiles.wordpress.org/retrofox/\">Damián Suárez</a>,&nbsp;<a href=\"https://profiles.wordpress.org/danielbachhuber/\">Daniel Bachhuber</a>,&nbsp;<a href=\"https://profiles.wordpress.org/danieltj/\">Daniel James</a>,&nbsp;<a href=\"https://profiles.wordpress.org/diddledan/\">Daniel Llewellyn</a>,&nbsp;<a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mte90/\">Daniele Scasciafratte</a>,&nbsp;<a href=\"https://profiles.wordpress.org/daniloercoli/\">daniloercoli</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nerrad/\">Darren Ethier (nerrad)</a>,&nbsp;<a href=\"https://profiles.wordpress.org/darrenlambert/\">darrenlambert</a>,&nbsp;<a href=\"https://profiles.wordpress.org/davidshq/\">Dave Mackey</a>,&nbsp;<a href=\"https://profiles.wordpress.org/get_dave/\">Dave Smith</a>,&nbsp;<a href=\"https://profiles.wordpress.org/daveslaughter/\">daveslaughter</a>,&nbsp;<a href=\"https://profiles.wordpress.org/davewp196/\">DaveWP196</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dartiss/\">David Artiss</a>,&nbsp;<a href=\"https://profiles.wordpress.org/davidbinda/\">David Binovec</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dlh/\">David Herrera</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dryanpress/\">David Ryan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dshanske/\">David Shanske</a>,&nbsp;<a href=\"https://profiles.wordpress.org/superdav42/\">David Stone</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dkarfa/\">Debabrata Karfa</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dekervit/\">dekervit</a>,&nbsp;<a href=\"https://profiles.wordpress.org/delowardev/\">Delowar Hossain</a>,&nbsp;<a href=\"https://profiles.wordpress.org/denisco/\">Denis Yanchevskiy</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dhavalkasvala/\">Dhaval kasavala</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dhurlburtusa/\">dhurlburtusa</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dilipbheda/\">Dilip Bheda</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dingo_d/\">dingo-d</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dipeshkakadiya/\">dipeshkakadiya</a>,&nbsp;<a href=\"https://profiles.wordpress.org/djp424/\">djp424</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dominic_ks/\">dominic_ks</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dotancohen/\">Dotan Cohen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dphiffer/\">dphiffer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dragosh635/\">dragosh635</a>,&nbsp;<a href=\"https://profiles.wordpress.org/drewapicture/\">Drew Jaynes</a>,&nbsp;<a href=\"https://profiles.wordpress.org/eclev91/\">eclev91</a>,&nbsp;<a href=\"https://profiles.wordpress.org/seedsca/\">ecotechie</a>,&nbsp;<a href=\"https://profiles.wordpress.org/eden159/\">eden159</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ediamin/\">Edi Amin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/disillusia/\">edmundcwm</a>,&nbsp;<a href=\"https://profiles.wordpress.org/etoledom/\">Eduardo Toledo</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>,&nbsp;<a href=\"https://profiles.wordpress.org/elmastudio/\">Ellen Bauer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/aliveic/\">Emil E</a>,&nbsp;<a href=\"https://profiles.wordpress.org/epiqueras/\">Enrique Piqueras</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nrqsnchz/\">Enrique Sánchez</a>,&nbsp;<a href=\"https://profiles.wordpress.org/equin0x80/\">equin0x80</a>,&nbsp;<a href=\"https://profiles.wordpress.org/erikkroes/\">erikkroes</a>,&nbsp;<a href=\"https://profiles.wordpress.org/estelaris/\">Estela Rueda</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fabifott/\">Fabian</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fabiankaegy/\">Fabian Kägy</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fahimmurshed/\">Fahim Murshed</a>,&nbsp;<a href=\"https://profiles.wordpress.org/faisal03/\">Faisal Alvi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/felipeelia/\">Felipe Elia</a>,&nbsp;<a href=\"https://profiles.wordpress.org/felipeloureirosantos/\">Felipe Santos</a>,&nbsp;<a href=\"https://profiles.wordpress.org/flixos90/\">Felix Arntz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fernandovbsouza/\">Fernando Souza</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fervillz/\">fervillz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fgiannar/\">fgiannar</a>,&nbsp;<a href=\"https://profiles.wordpress.org/flaviozavan/\">flaviozavan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mista-flo/\">Florian TIAR</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fotisps/\">Fotis Pastrakis</a>,&nbsp;<a href=\"https://profiles.wordpress.org/efarem/\">Frank Martin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/galbaras/\">Gal Baras</a>,&nbsp;<a href=\"https://profiles.wordpress.org/garrett-eclipse/\">Garrett Hyder</a>,&nbsp;<a href=\"https://profiles.wordpress.org/garyj/\">Gary Jones</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pento/\">Gary Pendergast</a>,&nbsp;<a href=\"https://profiles.wordpress.org/guddu1315/\">Gaurang Dabhi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/georgestephanis/\">George Stephanis</a>,&nbsp;<a href=\"https://profiles.wordpress.org/geriux/\">geriux</a>,&nbsp;<a href=\"https://profiles.wordpress.org/girishpanchal/\">Girish Panchal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/glebkema/\">Gleb Kemarsky</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hometowntrailers/\">Glenn</a>,&nbsp;<a href=\"https://profiles.wordpress.org/gh640/\">Goto Hayato</a>,&nbsp;<a href=\"https://profiles.wordpress.org/grafruessel/\">grafruessel</a>,&nbsp;<a href=\"https://profiles.wordpress.org/gregrickaby/\">Greg Rickaby</a>,&nbsp;<a href=\"https://profiles.wordpress.org/gziolo/\">Grzegorz Ziółkowski</a>,&nbsp;<a href=\"https://profiles.wordpress.org/grzegorzjanoszka/\">Grzegorz.Janoszka</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bordoni/\">Gustavo Bordoni</a>,&nbsp;<a href=\"https://profiles.wordpress.org/gwwar/\">gwwar</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hamedmoodi/\">hamedmoodi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hampzter/\">hAmpzter</a>,&nbsp;<a href=\"https://profiles.wordpress.org/happiryu/\">happiryu</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hareesh-pillai/\">Hareesh Pillai</a>,&nbsp;<a href=\"https://profiles.wordpress.org/harry-milatz/\">Harry Milatz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hazdiego/\">Haz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/helgatheviking/\">helgatheviking</a>,&nbsp;<a href=\"https://profiles.wordpress.org/henryholtgeerts/\">Henry Holtgeerts</a>,&nbsp;<a href=\"https://profiles.wordpress.org/imani3011/\">Himani Lotia</a>,&nbsp;<a href=\"https://profiles.wordpress.org/krynes/\">Hubert Kubiak</a>,&nbsp;<a href=\"https://profiles.wordpress.org/i3anaan/\">i3anaan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>,&nbsp;<a href=\"https://profiles.wordpress.org/iandunn/\">Ian Dunn</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ianatkins/\">ianatkins</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ianmjones/\">ianmjones</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ideaboxcreations/\">IdeaBox Creations</a>,&nbsp;<a href=\"https://profiles.wordpress.org/shaampk1/\">Ihtisham Zahoor</a>,&nbsp;<a href=\"https://profiles.wordpress.org/intimez/\">intimez</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ipstenu/\">Ipstenu (Mika Epstein)</a>,&nbsp;<a href=\"https://profiles.wordpress.org/isabel_brison/\">Isabel Brison</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ispreview/\">ispreview</a>,&nbsp;<a href=\"https://profiles.wordpress.org/whyisjake/\">Jake Spurlock</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jbinda/\">Jakub Binda</a>,&nbsp;<a href=\"https://profiles.wordpress.org/macmanx/\">James Huff</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jameskoster/\">James Koster</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jnylen0/\">James Nylen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jameslnewell/\">jameslnewell</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jankimoradiya/\">Janki Moradiya</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jarretc/\">Jarret</a>,&nbsp;<a href=\"https://profiles.wordpress.org/studiotwee/\">Jasper van der Meer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jaydeep23290/\">jaydeep23290</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jdy68/\">jdy68</a>,&nbsp;<a href=\"https://profiles.wordpress.org/audrasjb/\">Jean-Baptiste Audras</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jean-david/\">Jean-David Daviet</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jblz/\">Jeff Bowen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jeffpaul/\">Jeff Paul</a>,&nbsp;<a href=\"https://profiles.wordpress.org/phpbits/\">Jeffrey Carandang</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jeichorn/\">jeichorn</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jenilk/\">Jenil Kanani</a>,&nbsp;<a href=\"https://profiles.wordpress.org/miss_jwo/\">Jenny Wong</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jepperask/\">jepperask</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jeremyclarke/\">Jer Clarke</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jeremyfelt/\">Jeremy Felt</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jeherve/\">Jeremy Herve</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jeroenrotty/\">Jeroen Rotty</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jeryj/\">Jerry Jones</a>,&nbsp;<a href=\"https://profiles.wordpress.org/luminuu/\">Jessica Lyschik</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jipmoors/\">Jip Moors</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joedolson/\">Joe Dolson</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joehoyle/\">Joe Hoyle</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joemcgill/\">Joe McGill</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joen/\">Joen Asmussen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>,&nbsp;<a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby</a>,&nbsp;<a href=\"https://profiles.wordpress.org/johnwatkins0/\">johnwatkins0</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jon81/\">Jon</a>,&nbsp;<a href=\"https://profiles.wordpress.org/itsjonq/\">Jon Quach</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jonsurrell/\">Jon Surrell</a>,&nbsp;<a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jg-visual/\">Jonathan Goldford</a>,&nbsp;<a href=\"https://profiles.wordpress.org/spacedmonkey/\">Jonny Harris</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jonoaldersonwp/\">Jono Alderson</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joonasvanhatapio/\">Joonas Vanhatapio</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joostdevalk/\">Joost de Valk</a>,&nbsp;<a href=\"https://profiles.wordpress.org/koke/\">Jorge Bernal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>,&nbsp;<a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joshuawold/\">JoshuaWold</a>,&nbsp;<a href=\"https://profiles.wordpress.org/joyously/\">Joy</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jqz/\">jqz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jsnajdr/\">jsnajdr</a>,&nbsp;<a href=\"https://profiles.wordpress.org/juanfra/\">Juanfra Aldasoro</a>,&nbsp;<a href=\"https://profiles.wordpress.org/derweili/\">Julian Weiland</a>,&nbsp;<a href=\"https://profiles.wordpress.org/juliankimmig/\">julian.kimmig</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jrf/\">Juliette Reinders Folmer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/juliobox/\">Julio Potier</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nukaga/\">Junko Nukaga</a>,&nbsp;<a href=\"https://profiles.wordpress.org/jurgen/\">jurgen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/justdaiv/\">justdaiv</a>,&nbsp;<a href=\"https://profiles.wordpress.org/justinahinon/\">Justin Ahinon</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kadamwhite/\">K. Adam White</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kaggdesign/\">kaggdesign</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kalpshit/\">KalpShit Akabari</a>,&nbsp;<a href=\"https://profiles.wordpress.org/leprincenoir/\">Kantari Samy</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kasparsd/\">Kaspars</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ryelle/\">Kelly Dwan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kennithnichol/\">Kennith Nichol</a>,&nbsp;<a href=\"https://profiles.wordpress.org/khag7/\">Kevin Hagerty</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kharisblank/\">Kharis Sulistiyono</a>,&nbsp;<a href=\"https://profiles.wordpress.org/khushbu19/\">Khushbu Modi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/killerbishop/\">killerbishop</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kinjaldalwadi/\">kinjaldalwadi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kitchin/\">kitchin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ixkaito/\">Kite</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kjellr/\">Kjell Reigstad</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kkarpieszuk/\">kkarpieszuk</a>,&nbsp;<a href=\"https://profiles.wordpress.org/knutsp/\">Knut Sparhell</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kokkieh/\">KokkieH</a>,&nbsp;<a href=\"https://profiles.wordpress.org/obenland/\">Konstantin Obenland</a>,&nbsp;<a href=\"https://profiles.wordpress.org/xkon/\">Konstantinos Xenos</a>,&nbsp;<a href=\"https://profiles.wordpress.org/klopez8/\">Krystyna</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kubiq/\">kubiq</a>,&nbsp;<a href=\"https://profiles.wordpress.org/wpkuf/\">kuflievskiy</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sainthkh/\">Kukhyeon Heo</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kyliesabra/\">kyliesabra</a>,&nbsp;<a href=\"https://profiles.wordpress.org/lakenh/\">Laken Hafner</a>,&nbsp;<a href=\"https://profiles.wordpress.org/leandroalonso/\">leandroalonso</a>,&nbsp;<a href=\"https://profiles.wordpress.org/leogermani/\">leogermani</a>,&nbsp;<a href=\"https://profiles.wordpress.org/lgrev01/\">lgrev01</a>,&nbsp;<a href=\"https://profiles.wordpress.org/linuxologos/\">linuxologos</a>,&nbsp;<a href=\"https://profiles.wordpress.org/lisota/\">lisota</a>,&nbsp;<a href=\"https://profiles.wordpress.org/lorenzof/\">Lorenzo Fracassi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/luisherranz/\">luisherranz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/luisrivera/\">luisrivera</a>,&nbsp;<a href=\"https://profiles.wordpress.org/lukaswaudentio/\">lukaswaudentio</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ljasinskipl/\">Lukasz Jasinski</a>,&nbsp;<a href=\"https://profiles.wordpress.org/lukecavanagh/\">Luke Cavanagh</a>,&nbsp;<a href=\"https://profiles.wordpress.org/wodarekly/\">Lydia Wodarek</a>,&nbsp;<a href=\"https://profiles.wordpress.org/vinoth06/\">M A Vinoth Kumar</a>,&nbsp;<a href=\"https://profiles.wordpress.org/maciejmackowiak/\">maciejmackowiak</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mahesh901122/\">Mahesh Waghmare</a>,&nbsp;<a href=\"https://profiles.wordpress.org/manzoorwanijk/\">Manzoor Wani</a>,&nbsp;<a href=\"https://profiles.wordpress.org/marcelo2605/\">marcelo2605</a>,&nbsp;<a href=\"https://profiles.wordpress.org/marcio-zebedeu/\">Marcio Zebedeu</a>,&nbsp;<a href=\"https://profiles.wordpress.org/marcoz/\">MarcoZ</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mkaz/\">Marcus Kazmierczak</a>,&nbsp;<a href=\"https://profiles.wordpress.org/marekdedic/\">Marek Dědič</a>,&nbsp;<a href=\"https://profiles.wordpress.org/clorith/\">Marius Jensen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/marius84/\">Marius84</a>,&nbsp;<a href=\"https://profiles.wordpress.org/markjaquith/\">Mark Jaquith</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mmarzeotti/\">Mark Marzeotti</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mapk/\">Mark Uraine</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hinjiriyo/\">Martin Stehle</a>,&nbsp;<a href=\"https://profiles.wordpress.org/m-e-h/\">Marty Helmick</a>,&nbsp;<a href=\"https://profiles.wordpress.org/marybaum/\">Mary Baum</a>,&nbsp;<a href=\"https://profiles.wordpress.org/matstars/\">Mat Gargano</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mat-lipe/\">Mat Lipe</a>,&nbsp;<a href=\"https://profiles.wordpress.org/imath/\">Mathieu Viet</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mattkeys/\">Matt Keys</a>,&nbsp;<a href=\"https://profiles.wordpress.org/veraxus/\">Matt van Andel</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mattchowning/\">mattchowning</a>,&nbsp;<a href=\"https://profiles.wordpress.org/snapfractalpop/\">Matthew Kevins</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mattnyeus/\">mattnyeus</a>,&nbsp;<a href=\"https://profiles.wordpress.org/maxme/\">maxme</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mayanksonawat/\">mayanksonawat</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mbrailer/\">mbrailer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mehidi258/\">Mehidi Hassan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/melchoyce/\">Mel Choyce-Dwan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mensmaximus/\">mensmaximus</a>,&nbsp;<a href=\"https://profiles.wordpress.org/michael-arestad/\">Michael Arestad</a>,&nbsp;<a href=\"https://profiles.wordpress.org/michaelecklund/\">Michael Ecklund</a>,&nbsp;<a href=\"https://profiles.wordpress.org/donmhico/\">Michael Panaga</a>,&nbsp;<a href=\"https://profiles.wordpress.org/marktimemedia/\">Michelle Schulp</a>,&nbsp;<a href=\"https://profiles.wordpress.org/miette49/\">miette49</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mcsf/\">Miguel Fonseca</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mmtr86/\">Miguel Torres</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mihdan/\">mihdan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/miinasikk/\">Miina Sikk</a>,&nbsp;<a href=\"https://profiles.wordpress.org/simison/\">Mikael Korpela</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mauteri/\">Mike Auteri</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mikehansenme/\">Mike Hansen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mikeschinkel/\">Mike Schinkel [WPLib Box project lead]</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mikeschroder/\">Mike Schroder</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mikejdent/\">mikejdent</a>,&nbsp;<a href=\"https://profiles.wordpress.org/msaari/\">Mikko Saari</a>,&nbsp;<a href=\"https://profiles.wordpress.org/iihglobal/\">Milan Patel</a>,&nbsp;<a href=\"https://profiles.wordpress.org/gdragon/\">Milan Petrovic</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mimitips/\">mimi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mircoraffinetti/\">mircoraffinetti</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mjnewman/\">mjnewman</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mlbrgl/\">mlbrgl</a>,&nbsp;<a href=\"https://profiles.wordpress.org/morganestes/\">Morgan Estes</a>,&nbsp;<a href=\"https://profiles.wordpress.org/man4toman/\">Morteza Geransayeh</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mppfeiffer/\">mppfeiffer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mryoga/\">mryoga</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mtias/\">mtias</a>,&nbsp;<a href=\"https://profiles.wordpress.org/musamamasood/\">Muhammad Usama Masood</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mujuonly/\">mujuonly</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mukesh27/\">Mukesh Panchal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/assassinateur/\">Nadir Seghir</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nagoke/\">nagoke</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nfmohit/\">Nahid Ferdous Mohit</a>,&nbsp;<a href=\"https://profiles.wordpress.org/finchps/\">Nate Finch</a>,&nbsp;<a href=\"https://profiles.wordpress.org/mukto90/\">Nazmul Ahsan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nekomajin/\">nekomajin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nextscripts/\">NextScripts</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nickdaugherty/\">Nick Daugherty</a>,&nbsp;<a href=\"https://profiles.wordpress.org/celloexpressions/\">Nick Halsey</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nsundberg/\">Nicklas Sundberg</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nickylimjj/\">Nicky Lim</a>,&nbsp;<a href=\"https://profiles.wordpress.org/vadimnicolai/\">nicolad</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rahe/\">Nicolas Juen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nicole2292/\">nicole2292</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nielslange/\">Niels Lange</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nikhilgupte/\">nikhilgupte</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nilamacharya/\">nilamacharya</a>,&nbsp;<a href=\"https://profiles.wordpress.org/noahtallen/\">noahtallen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/noyle/\">noyle</a>,&nbsp;<a href=\"https://profiles.wordpress.org/nsubugak/\">nsubugak</a>,&nbsp;<a href=\"https://profiles.wordpress.org/oakesjosh/\">oakesjosh</a>,&nbsp;<a href=\"https://profiles.wordpress.org/oldenburg/\">oldenburg</a>,&nbsp;<a href=\"https://profiles.wordpress.org/alshakero/\">Omar Alshaker</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ottok/\">Otto Kekäläinen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ov3rfly/\">Ov3rfly</a>,&nbsp;<a href=\"https://profiles.wordpress.org/iaaxpage/\">page-carbajal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pagewidth/\">pagewidth</a>,&nbsp;<a href=\"https://profiles.wordpress.org/paragoninitiativeenterprises/\">Paragon Initiative Enterprises</a>,&nbsp;<a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>,&nbsp;<a href=\"https://profiles.wordpress.org/casiepa/\">Pascal Casier</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pbearne/\">Paul Bearne</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pbiron/\">Paul Biron</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rixeo/\">Paul Kevin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/paulschreiber/\">Paul Schreiber</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pcarvalho/\">pcarvalho</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pedromendonca/\">Pedro Mendonça</a>,&nbsp;<a href=\"https://profiles.wordpress.org/perrywagle/\">perrywagle</a>,&nbsp;<a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>,&nbsp;<a href=\"https://profiles.wordpress.org/philipmjackson/\">Philip Jackson</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pierlo/\">Pierre Gordon</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pierrelannoy/\">Pierre Lannoy</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pikamander2/\">pikamander2</a>,&nbsp;<a href=\"https://profiles.wordpress.org/prashantvatsh/\">Prashant Singh</a>,&nbsp;<a href=\"https://profiles.wordpress.org/pratik-jain/\">Pratik Jain</a>,&nbsp;<a href=\"https://profiles.wordpress.org/presskopp/\">Presskopp</a>,&nbsp;<a href=\"https://profiles.wordpress.org/priyankabehera155/\">Priyanka Behera</a>,&nbsp;<a href=\"https://profiles.wordpress.org/raamdev/\">Raam Dev</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bamadesigner/\">Rachel Cherry</a>,&nbsp;<a href=\"https://profiles.wordpress.org/larrach/\">Rachel Peter</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ragnarokatz/\">ragnarokatz</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ramiy/\">Rami Yushuvaev</a>,&nbsp;<a href=\"https://profiles.wordpress.org/raoulunger/\">raoulunger</a>,&nbsp;<a href=\"https://profiles.wordpress.org/razamalik/\">razamalik</a>,&nbsp;<a href=\"https://profiles.wordpress.org/remcotolsma/\">Remco Tolsma</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rephotsirch/\">rephotsirch</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rheinardkorf/\">rheinardkorf</a>,&nbsp;<a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>,&nbsp;<a href=\"https://profiles.wordpress.org/quicoto/\">Ricard Torres</a>,&nbsp;<a href=\"https://profiles.wordpress.org/richtabor/\">Rich Tabor</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rimadoshi/\">rimadoshi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rinkuyadav999/\">Rinku Y</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rcutmore/\">Rob Cutmore</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rob006/\">rob006</a>,&nbsp;<a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rconde/\">Roi Conde</a>,&nbsp;<a href=\"https://profiles.wordpress.org/murgroland/\">Roland Murg</a>,&nbsp;<a href=\"https://profiles.wordpress.org/costasovo/\">Rostislav Wolný</a>,&nbsp;<a href=\"https://profiles.wordpress.org/roytanck/\">Roy Tanck</a>,&nbsp;<a href=\"https://profiles.wordpress.org/kingkool68/\">Russell Heimlich</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rryyaanndd/\">Ryan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/bookdude13/\">Ryan Fredlund</a>,&nbsp;<a href=\"https://profiles.wordpress.org/rmccue/\">Ryan McCue</a>,&nbsp;<a href=\"https://profiles.wordpress.org/welcher/\">Ryan Welcher</a>,&nbsp;<a href=\"https://profiles.wordpress.org/looswebstudio/\">Ryo</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sebastienserre/\">Sébastien SERRE</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sablednah/\">sablednah</a>,&nbsp;<a href=\"https://profiles.wordpress.org/viralsampat/\">Sampat Viral</a>,&nbsp;<a href=\"https://profiles.wordpress.org/otto42/\">Samuel Wood (Otto)</a>,&nbsp;<a href=\"https://profiles.wordpress.org/samuelfernandez/\">SamuelFernandez</a>,&nbsp;<a href=\"https://profiles.wordpress.org/zanderz/\">Sander</a>,&nbsp;<a href=\"https://profiles.wordpress.org/santilinwp/\">santilinwp</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sathyapulse/\">Sathiyamoorthy V</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tivus/\">Schuhwerk</a>,&nbsp;<a href=\"https://profiles.wordpress.org/coffee2code/\">Scott Reilly</a>,&nbsp;<a href=\"https://profiles.wordpress.org/wonderboymusic/\">Scott Taylor</a>,&nbsp;<a href=\"https://profiles.wordpress.org/scruffian/\">scruffian</a>,&nbsp;<a href=\"https://profiles.wordpress.org/scvleon/\">scvleon</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sebastianpisula/\">Sebastian Pisula</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sgr33n/\">Sergio de Falco</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sergiomdgomes/\">sergiomdgomes</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sgastard/\">sgastard</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sgoen/\">sgoen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/shahariaazam/\">Shaharia Azam</a>,&nbsp;<a href=\"https://profiles.wordpress.org/cafenoirdesign/\">Shannon Smith</a>,&nbsp;<a href=\"https://profiles.wordpress.org/shariqkhan2012/\">shariqkhan2012</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sncoker/\">Shawntelle Coker</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sheparddw/\">sheparddw</a>,&nbsp;<a href=\"https://profiles.wordpress.org/shital-patel/\">Shital Marakana</a>,&nbsp;<a href=\"https://profiles.wordpress.org/shizumi/\">Shizumi Yoshiaki</a>,&nbsp;<a href=\"https://profiles.wordpress.org/simonjanin/\">simonjanin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sinatrateam/\">sinatrateam</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sirreal/\">sirreal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/skorasaurus/\">skorasaurus</a>,&nbsp;<a href=\"https://profiles.wordpress.org/smerriman/\">smerriman</a>,&nbsp;<a href=\"https://profiles.wordpress.org/socalchristina/\">socalchristina</a>,&nbsp;<a href=\"https://profiles.wordpress.org/soean/\">Soren Wrede</a>,&nbsp;<a href=\"https://profiles.wordpress.org/spenserhale/\">spenserhale</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sproutchris/\">sproutchris</a>,&nbsp;<a href=\"https://profiles.wordpress.org/squarecandy/\">squarecandy</a>,&nbsp;<a href=\"https://profiles.wordpress.org/starvoters1/\">starvoters1</a>,&nbsp;<a href=\"https://profiles.wordpress.org/steelwagstaff/\">SteelWagstaff</a>,&nbsp;<a href=\"https://profiles.wordpress.org/steevithak/\">steevithak</a>,&nbsp;<a href=\"https://profiles.wordpress.org/ryokuhi/\">Stefano Minoia</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hypest/\">Stefanos Togoulidis</a>,&nbsp;<a href=\"https://profiles.wordpress.org/steffanhalv/\">steffanhalv</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sabernhardt/\">Stephen Bernhardt</a>,&nbsp;<a href=\"https://profiles.wordpress.org/netweb/\">Stephen Edgar</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dufresnesteven/\">Steve Dufresne</a>,&nbsp;<a href=\"https://profiles.wordpress.org/stevegrunwell/\">Steve Grunwell</a>,&nbsp;<a href=\"https://profiles.wordpress.org/stevenlinx/\">stevenlinx</a>,&nbsp;<a href=\"https://profiles.wordpress.org/stiofansisland/\">Stiofan</a>,&nbsp;<a href=\"https://profiles.wordpress.org/matthias-reuter/\">straightvisions GmbH</a>,&nbsp;<a href=\"https://profiles.wordpress.org/stroona/\">stroona.com</a>,&nbsp;<a href=\"https://profiles.wordpress.org/subratamal/\">Subrata Mal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/subrataemfluence/\">Subrata Sarkar</a>,&nbsp;<a href=\"https://profiles.wordpress.org/manikmist09/\">Sultan Nasir Uddin</a>,&nbsp;<a href=\"https://profiles.wordpress.org/swapnild/\">swapnild</a>,&nbsp;<a href=\"https://profiles.wordpress.org/cybr/\">Sybre Waaijer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/sergioestevao/\">Sérgio Estêvão</a>,&nbsp;<a href=\"https://profiles.wordpress.org/miyauchi/\">Takayuki Miyauchi</a>,&nbsp;<a href=\"https://profiles.wordpress.org/takeshifurusato/\">Takeshi Furusato</a>,&nbsp;<a href=\"https://profiles.wordpress.org/karmatosed/\">Tammie Lister</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tanvirul/\">Tanvirul Haque</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tbschen/\">TBschen</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tdlewis77/\">tdlewis77</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tellyworth/\">Tellyworth</a>,&nbsp;<a href=\"https://profiles.wordpress.org/thamaraiselvam/\">Thamaraiselvam</a>,&nbsp;<a href=\"https://profiles.wordpress.org/thefarlilacfield/\">thefarlilacfield</a>,&nbsp;<a href=\"https://profiles.wordpress.org/themezee/\">ThemeZee</a>,&nbsp;<a href=\"https://profiles.wordpress.org/timhavinga/\">Tim Havinga</a>,&nbsp;<a href=\"https://profiles.wordpress.org/hedgefield/\">Tim Hengeveld</a>,&nbsp;<a href=\"https://profiles.wordpress.org/timon33/\">timon33</a>,&nbsp;<a href=\"https://profiles.wordpress.org/spaceshipone/\">Timothée Brosille</a>,&nbsp;<a href=\"https://profiles.wordpress.org/timothyblynjacobs/\">Timothy Jacobs</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tkama/\">Tkama</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tmanoilov/\">tmanoilov</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tmatsuur/\">tmatsuur</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tobifjellner/\">tobifjellner (Tor-Bjorn Fjellner)</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tomgreer/\">Tom Greer</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tjnowell/\">Tom J Nowell</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tommix/\">tommix</a>,&nbsp;<a href=\"https://profiles.wordpress.org/skithund/\">Toni Viemerö</a>,&nbsp;<a href=\"https://profiles.wordpress.org/toro_unit/\">Toro_Unit (Hiroshi Urabe)</a>,&nbsp;<a href=\"https://profiles.wordpress.org/torres126/\">torres126</a>,&nbsp;<a href=\"https://profiles.wordpress.org/zodiac1978/\">Torsten Landsiedel</a>,&nbsp;<a href=\"https://profiles.wordpress.org/itowhid06/\">Towhidul Islam</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tristangemus/\">tristangemus</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tristanleboss/\">tristanleboss</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tsuyoring/\">tsuyoring</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dinhtungdu/\">Tung Du</a>,&nbsp;<a href=\"https://profiles.wordpress.org/desaiuditd/\">Udit Desai</a>,&nbsp;<a href=\"https://profiles.wordpress.org/grapplerulrich/\">Ulrich</a>,&nbsp;<a href=\"https://profiles.wordpress.org/upadalavipul/\">upadalavipul</a>,&nbsp;<a href=\"https://profiles.wordpress.org/utsav72640/\">Utsav tilava</a>,&nbsp;<a href=\"https://profiles.wordpress.org/vaishalipanchal/\">Vaishali Panchal</a>,&nbsp;<a href=\"https://profiles.wordpress.org/valentinbora/\">Valentin Bora</a>,&nbsp;<a href=\"https://profiles.wordpress.org/varunshanbhag/\">varunshanbhag</a>,&nbsp;<a href=\"https://profiles.wordpress.org/veminom/\">Veminom</a>,&nbsp;<a href=\"https://profiles.wordpress.org/vinita29/\">Vinita Tandulkar</a>,&nbsp;<a href=\"https://profiles.wordpress.org/virgodesign/\">virgodesign</a>,&nbsp;<a href=\"https://profiles.wordpress.org/vsamoletov/\">Vlad. S.</a>,&nbsp;<a href=\"https://profiles.wordpress.org/vortfu/\">vortfu</a>,&nbsp;<a href=\"https://profiles.wordpress.org/waleedt93/\">waleedt93</a>,&nbsp;<a href=\"https://profiles.wordpress.org/webmandesign/\">WebMan Design | Oliver Juhas</a>,&nbsp;<a href=\"https://profiles.wordpress.org/websupporter/\">websupporter</a>,&nbsp;<a href=\"https://profiles.wordpress.org/westonruter/\">Weston Ruter</a>,&nbsp;<a href=\"https://profiles.wordpress.org/earnjam/\">William Earnhardt</a>,&nbsp;<a href=\"https://profiles.wordpress.org/williampatton/\">William Patton</a>,&nbsp;<a href=\"https://profiles.wordpress.org/wpgurudev/\">wpgurudev</a>,&nbsp;<a href=\"https://profiles.wordpress.org/alexandreb3/\">WPMarmite</a>,&nbsp;<a href=\"https://profiles.wordpress.org/wptoolsdev/\">wptoolsdev</a>,&nbsp;<a href=\"https://profiles.wordpress.org/xedinunknown-1/\">xedinunknown-1</a>,&nbsp;<a href=\"https://profiles.wordpress.org/yale01/\">yale01</a>,&nbsp;<a href=\"https://profiles.wordpress.org/collet/\">Yannicki</a>,&nbsp;<a href=\"https://profiles.wordpress.org/yordansoares/\">Yordan Soares</a>,&nbsp;<a href=\"https://profiles.wordpress.org/fierevere/\">Yui</a>,&nbsp;<a href=\"https://profiles.wordpress.org/zachflauaus/\">zachflauaus</a>,&nbsp;<a href=\"https://profiles.wordpress.org/tollmanz/\">Zack Tollman</a>,&nbsp;<a href=\"https://profiles.wordpress.org/zebulan/\">Zebulan Stanphill</a>,&nbsp;<a href=\"https://profiles.wordpress.org/zaffarn/\">Zee</a>, y&nbsp;<a href=\"https://profiles.wordpress.org/zsusag/\">zsusag</a>.</p>\n\n\n\n<p>Muchas gracias a todos los voluntarios de la comunidad que han contribuido en <a href=\"https://es.wordpress.org/support\">los foros de soporte</a>. Responden preguntas de personas de todo el mundo, ya estén usando WordPress por primera vez o desde la primera versión. ¡Estas actualizaciones tienen más éxito gracias a sus esfuerzos!</p>\n\n\n\n<h2>Traductores</h2>\n\n\n\n<p>Para finalizar, gracias a todos los traductores de la comunidad que han trabajado en WordPress 5.4. Sus esfuerzos traen WordPress completamente traducido a&nbsp;46 idiomas en el momento del lanzamiento, y más que habrá.</p>\n\n\n\n<ul><li><a href=\"https://profiles.wordpress.org/nobnob\">Javier Esteban</a></li><li><a href=\"https://profiles.wordpress.org/jconti\">Jose Conti</a></li><li><a href=\"https://profiles.wordpress.org/fernandot\">Fernando Tellado</a></li><li><a href=\"https://profiles.wordpress.org/_dorsvenabili\">Rocio Valdivia</a></li><li><a href=\"https://profiles.wordpress.org/unintended8\">Juan Hernando</a></li><li><a href=\"https://profiles.wordpress.org/bi0xid\">Rafa Poveda</a></li><li><a href=\"https://profiles.wordpress.org/luisrull\">Luis Rull</a></li><li><a href=\"https://profiles.wordpress.org/nilovelez\">Nilo Velez</a></li><li><a href=\"https://profiles.wordpress.org/balboag\">Gerardo Balboa</a></li><li><a href=\"https://profiles.wordpress.org/koke\">Jorge Bernal</a></li><li><a href=\"https://profiles.wordpress.org/leemon\">leemon</a>.</li></ul>\n\n\n\n<p>Si quieres aprender más sobre cómo ser voluntario con WordPress, pásate por&nbsp;<a href=\"https://make.wordpress.org/\">Make WordPress</a>&nbsp;o el&nbsp;<a href=\"https://make.wordpress.org/core/\">blog de desarrollo del núcleo</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://es.wordpress.org/2020/04/01/wordpress-5-4-adderley/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:30:\"https://es.wordpress.org/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 11 Aug 2020 15:38:20 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:6:\"x-olaf\";s:3:\"⛄\";s:13:\"last-modified\";s:29:\"Tue, 04 Aug 2020 23:42:36 GMT\";s:4:\"link\";s:61:\"<https://es.wordpress.org/wp-json/>; rel=\"https://api.w.org/\"\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:9:\"HIT ord 2\";}}s:5:\"build\";s:14:\"20130911033210\";}', 'no'),
 (1564, '_transient_timeout_feed_mod_69c933d8a78805efd0abe985766ffb51', '1597203501', 'no'),
 (1565, '_transient_feed_mod_69c933d8a78805efd0abe985766ffb51', '1597160301', 'no'),
 (1566, '_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9', '1597203501', 'no'),
 (1567, '_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WP Mobile Apps: How Do I Connect My WordPress.com or Jetpack Site?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://apps.wordpress.com/?p=4037\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://apps.wordpress.com/2020/08/11/how-do-i-connect-my-wordpress-com-or-jetpack-site/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1593:\"<p>To access a site hosted with WordPress.com or connected to WordPress.com through the Jetpack plugin, log in with your WordPress.com credentials. After clicking on the <strong>Login button</strong>, select <strong>Continue with WordPress.com. </strong></p>\n\n\n\n<p>You can also select the others options to <strong>Continue with Google</strong> or <strong>Continue with Apple</strong> if the email address linked to these services matches the email address of your WordPress.com account. </p>\n\n\n\n<p>Next, <em>enter the email address</em> associated with your WordPress.com account and click <strong>next</strong>. From there you can either choose to receive a login link to be sent to your email address or click on the link to &#8220;enter your password instead&#8221; to use your password to log in.  If you select the option to receive a login link, you&#8217;ll be given the option to open Mail where you should have received a new email with a button to click to <strong>&#8216;Log in to the app&#8217;</strong>. This link expires in one hour and when clicked should redirect you to the app where you will see a list of your sites and have the option to either Connect another site or press &#8216;Done&#8217; to start managing your WordPress.com connected sites. </p>\n\n\n\n<p>See the login procedure below:</p>\n\n\n\n<ul><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li></ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Aug 2020 08:16:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Rebecca\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:116:\"WPTavern: Astra Theme Suspended and Reinstated, Themes Team Works Toward Delisting Strategy for Guideline Violations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102960\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:275:\"https://wptavern.com/astra-theme-suspended-and-reinstated-themes-team-works-toward-delisting-strategy-for-guideline-violations?utm_source=rss&utm_medium=rss&utm_campaign=astra-theme-suspended-and-reinstated-themes-team-works-toward-delisting-strategy-for-guideline-violations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11208:\"<img />\n\n\n\n<p class=\"has-drop-cap\">The Themes Team <a href=\"https://themes.trac.wordpress.org/ticket/87407#comment:3\">suspended Astra</a> from the official theme directory just a few short weeks after it became the first non-default WordPress theme to <a href=\"https://wptavern.com/astra-becomes-the-only-non-default-wordpress-theme-with-1-million-installs\">surpass one million active installs</a>. The reason: the theme was breaking the directory&rsquo;s ban on affiliate links. The theme has since been reinstated. However, it has been delisted from the popular themes list.</p>\n\n\n\n<p>After the Themes Team handed down an initial five-week suspension, the story continued to unfold through various channels over the weekend and into the start of the new week. Brainstorm Force, the company behind the theme, <a href=\"https://themes.trac.wordpress.org/ticket/87407#comment:4\">argued that it did not violate</a> the affiliate link rule because the theme was simply filtering referral IDs of third-party plugins.  The plugins were technically supplying the links. The company also asked for lenience because this was its first violation.</p>\n\n\n\n<p>Since the initial discussion, the Themes Team has reinstated the theme while bumping it off the <a href=\"https://wordpress.org/themes/\">popular themes list</a>. The goal is to make sure existing users still have access to updates while providing a method for dealing with guidelines violations, a method that does not go to the extreme of outright suspension. The team also added an additional week of punishment after finding a sixth affiliate-related violation missed in the initial review.  Astra will now be delisted for a total of six weeks.</p>\n\n\n\n<p>Astra is not the first suspension of a popular theme over the years. These high-profile suspensions can lead to the loss of thousands of dollars in revenue if the theme&rsquo;s business model relies on traffic from WordPress.org. In 2017, a <a href=\"https://wptavern.com/zerif-lite-suspended-from-wordpress-theme-directory-300k-users-left-without-updates\">five-month suspension</a> of the Zerif Lite theme left its creators with a <a href=\"https://wptavern.com/zerif-lite-returns-to-wordpress-org-after-5-month-suspension-and-63-decline-in-revenue\">decline of 63% in revenue</a>. Zerif Lite&rsquo;s user count was around one-third of Astra&rsquo;s current total.</p>\n\n\n\n<p>While it will take some time to see the results, being delisted will likely cut into Brainstorm Force&rsquo;s revenue. The theme upsells a <em>pro</em> version of their theme. It is a common <em>freemium</em> model that many theme companies employ.</p>\n\n\n\n<p>The WordPress.org theme review guidelines <a href=\"https://make.wordpress.org/themes/handbook/review/required/#selling-credits-and-links\">ban affiliate links</a>. More precisely, the guideline is as follows:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Themes are not allowed to have affiliate URLs or links.</p></blockquote>\n\n\n\n<p>Technically, Brainstorm Force did not directly output affiliate links via its theme. Instead, the theme injected the company&rsquo;s referral ID into affiliate links for third-party plugins when they were active on a user&rsquo;s site. In and of itself, this type of injection is nothing nefarious. The plugins themselves allow for such filtering of their affiliate links, presumably to entice theme authors to make a few dollars by recommending and integrating with them.</p>\n\n\n\n<p>As for the Astra theme, the question is whether it violated the affiliate guideline. When the rule was written, the Themes Team was most likely thinking about direct links within the theme and not a scenario where a theme was injecting a referral ID or filtering an existing link from a plugin.</p>\n\n\n\n<p>According to the Themes Team, at least two of the affiliate IDs in Astra were for plugins that the theme recommended but did not actually integrate with or support in any way. In at least once instance, the theme automatically updated a database option for the Monster Insights plugin to add an affiliate ID &mdash; automatically updating any database option without user action is generally not allowed.</p>\n\n\n\n<p>Regardless of individual opinions on the Theme Team&rsquo;s complete ban of affiliate links, it is not a cut-and-dry situation of simply allowing or disallowing.</p>\n\n\n\n<p>&ldquo;It is also about needing to understand the legal impact of disclosures,&rdquo; said Carolina Nymark, a team representative. &ldquo;It is not something that the team can take responsibility for, nor look away if authors do not follow it.&rdquo;</p>\n\n\n\n<h2>Astra&rsquo;s Apology and Response</h2>\n\n\n\n<img />\n\n\n\n<p class=\"has-drop-cap\">Sujay Pawar, a co-founder of Brainstorm Force, published an <a href=\"https://wpastra.com/open-letter/\">open apology on the Astra blog</a>. However, this apology post created its own controversy within the community. The current post was not the first apology. Pawar changed his original post and removed some of the earlier promises he made to the community.</p>\n\n\n\n<p>According to multiple sources within the community and a <a href=\"https://wpastra.com/open-letter/#comment-62065\">comment on the post</a>, he had promised to dedicate 16 hours from one of the company&rsquo;s senior developers to contribute work for the Themes Team. Along with this contribution, he promised to spend 5% of the company&rsquo;s resources toward open source development and to donate to future WordCamps.</p>\n\n\n\n<p>&ldquo;These last few days have been very emotional for me and the entire team,&rdquo; said Pawar. &ldquo;I have never been in such a stressful situation in my life. As you can imagine, I wrote many versions of this apology and just wasn&rsquo;t sure what was the best way to do it.&rdquo;</p>\n\n\n\n<p>For some people in the community, changing the post&rsquo;s content seemed suspicious. He had changed it around the same time the theme was reinstated on WordPress.org. However, the issue was likely the result of bad timing. Pawar was forthcoming about having written the original post and later removing parts of it.</p>\n\n\n\n<p>&ldquo;My initial apology did include the specifics of how we are planning to increase our commitment to WordPress, but after more thought, I felt it wasn&rsquo;t the right place to share that,&rdquo; he said. &ldquo;I don&rsquo;t want our contributions to be overshadowed or tied back to a rule violation. We still plan to honor our commitment, and we will release those details in a dedicated post.&rdquo;</p>\n\n\n\n<p>Pawar has no hard feelings for the Themes Team. For him, it has been a high-stress weekend that he will no doubt recover from. He is attempting to rectify the situation the best he can.</p>\n\n\n\n<p>&ldquo;I have a lot of respect for all members of Themes Team,&rdquo; he said. &ldquo;They work tirelessly to move the WordPress ecosystem forward. I 100% believe that guidelines must be enforced because it&rsquo;s the only way to ensure that WordPress keeps growing. As one of the most popular theme authors, it&rsquo;s our goal to lead by setting a good example and work together with the TRT to set better standards.&rdquo;</p>\n\n\n\n<h2>Long Term: Delisting Themes Instead of Suspending</h2>\n\n\n\n<img />\n\n\n\n<p class=\"has-drop-cap\">The Themes Team does not have a lot of options when it comes to punitive measures for guideline violations. In a large part, this is the result of limitations of the software in use. The team simply needs better tools.</p>\n\n\n\n<p>&ldquo;The punitive measures the team has right now is suspend it or do nothing,&rdquo; said William Patton, a Themes Team representative. &ldquo;There is no in-between, and in a lot of cases, neither of those two options are ideal. From past experience, I have found that asking authors repeatedly for changes is either ineffective or they fix it but the behavior returns after a short time. Suspension has been quite effective in some cases but it is quite a lot of work for the team to manage and maintain lists or time frames of what happened when and to revisit after a given time.&rdquo;</p>\n\n\n\n<p>Patton said that the threat of suspension without action is ineffective. However, actually going through with suspending a theme often has implications for end-users. In some cases, there may be an urgent security update that users need to get, but the suspension system does not make that easy to manage.</p>\n\n\n\n<p>There is now an <a href=\"https://meta.trac.wordpress.org/ticket/5362\">open meta ticket</a> to offer theme directory administrators the option to delist a theme. In effect, this would keep a theme such as Astra available in the directory if someone knows the direct URL. It would also allow the theme author to provide updates, such as security fixes, to users without direct approval from the Themes Team. However, the theme would not be available through the popular themes list or search.</p>\n\n\n\n<p>This offers the team a less drastic option than a full-on suspension and has no negative drawbacks for existing theme users.</p>\n\n\n\n<p>Currently, the team found what they described as a &ldquo;hacky&rdquo; method of essentially delisting Astra. Because the popular themes list algorithm uses the theme&rsquo;s publication date to help determine a theme&rsquo;s popularity, the team changed this date for the theme to push it down the popular list. It is not a perfect solution, but it provided a quick middle ground between doing nothing and suspension, at least until a more permanent solution is in place. It also gives them an early chance to test out the effects such a measure would have.</p>\n\n\n\n<p>Punitive measures have always been a struggle for the team. On the one hand, they do not like to suspend themes for wrongdoing, regardless of whether such wrongdoing was intentional. On the other, they must attempt to provide a fair playing field for all theme authors. Threats of punishment for guideline violations ring hollow if there is no follow-through. It is not an easy position, and team members can quickly become victims of harassment or unwanted private messages from theme developers and outsiders.</p>\n\n\n\n<p>&ldquo;We had several occasions where theme authors would &lsquo;follow us home&rsquo; with blame and different kinds of suggestions,&rdquo; said Nymark.</p>\n\n\n\n<p>One of the ways the Themes Team has been dealing with this is by using the relatively anonymous &ldquo;@trtmessenger&rdquo; account when suspending themes. This is the route the team took when handling the Astra theme suspension and followup decisions.</p>\n\n\n\n<p>The team has dealt with attacks toward individual members over the years on various decisions it has made. In many cases, the representative who delivered a particular decision, regardless of their personal role in it, bared the brunt of the negative feedback. Far too often, it was a case of shooting the messenger, and the current reps have found a workable solution for this issue.</p>\n\n\n\n<p>&ldquo;This is an account that enables messages to be sent without one single person being held accountable for the message,&rdquo; said Patton. &ldquo;It is intended to prevent anyone from getting any negative feedback directly from a decision.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Aug 2020 21:29:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WPTavern: New WordPress Plugins Disable Unsplash CDN\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102767\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:149:\"https://wptavern.com/new-wordpress-plugins-disable-unsplash-cdn?utm_source=rss&utm_medium=rss&utm_campaign=new-wordpress-plugins-disable-unsplash-cdn\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9548:\"<p>In light of the recent conversations about the Unsplash plugin&rsquo;s CDN, several extensions have popped up this week for disabling it. By default, the plugin serves images from the CDN but saves copies to the WordPress media library in case the plugin is disabled or removed. The plugin does not currently have an option to change this.</p>\n\n\n\n<p><a href=\"https://wordpress.org/plugins/disable-unsplash-cdn/\">Disable Unsplash CDN</a> is the first to be published to the WordPress.org directory for changing the plugin&rsquo;s default behavior. There are no options or settings &ndash; activating it turns it on. Xaver Birsak, a prolific WordPress plugin author, created it to help users who may experience slower page speed caused by the Unsplash CDN.</p>\n\n\n\n<p>&ldquo;I&rsquo;ve followed the release of the official Unsplash plugin as well the strange one-star rating from Matt Mullenweg which is think is not appropriate,&rdquo; Birsak said. &ldquo;The problem he mentioned was, in addition to the Unsplash license, the fact that images are being served from Unsplash (Imgix) servers. I don&rsquo;t think that this is totally unnecessary from Unsplash as a CDN can serve images much quicker in most cases. For some users this is maybe not the case.&rdquo;</p>\n\n\n\n<p>Birsak was referencing Matt Mullenweg&rsquo;s recent <a href=\"https://wordpress.org/support/topic/i-wouldnt-recommend-using-this/\">one-star review</a> of the Unsplash plugin, which drew the ire of many plugin developers whose ability to monetize their products can hinge on getting decent reviews. The review called the plugin &ldquo;sketchy&rdquo; and called into question the practice of making the CDN the default:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>It&rsquo;s unclear why they want you to use their CDN and make that the default, it&rsquo;s probably to support their&nbsp;<a href=\"https://unsplash.com/blog/introducing-unsplash-for-brands/\">new advertising business model</a>&nbsp;and get analytics for it. Running a CDN is expensive, and if you&rsquo;re not paying for it then you are the product. I would not be surprised if Unsplash hotlinked images broke at some point in the future.</p><p>If you want a CDN, you should run one for your entire site, not just certain images from a single source &mdash; in fact having multiple CDNs running at the same time could slow down your site because of the additional DNS lookups.</p></blockquote>\n\n\n\n<p>Birsak said he checked the plugin and found a simple solution for bypassing the hotlinking, which only requires a few lines of code. </p>\n\n\n\n<p>&ldquo;Since it&rsquo;s so easy, and others may find it useful, I released this plugin,&rdquo; Birsak said. &ldquo;Nowadays with GDPR and the invalidation of the Privacy Shield people are more likely to be concerned about sending data to third party services. So disabling the CDN should at least be an option.&rdquo;</p>\n\n\n\n<p>WordPress developer <a href=\"https://tomjn.com/\">Tom Nowell</a> also created a quick plugin to disable Unsplash&rsquo;s CDN, which is now <a href=\"https://gist.github.com/tomjn/a7036d369d6f8082dd1eb256c651696e\">available on GitHub</a>.</p>\n\n\n\n<p>&ldquo;I don&rsquo;t have qualms with Unsplash themselves but I did miss having the option to choose for myself,&rdquo; Nowell said regarding the plugin&rsquo;s CDN default. &ldquo;Rather than argue to add it, I spent a little time and built the plugin, it&rsquo;s only small so didn&rsquo;t take much time. As for the CDN, it&rsquo;s nice to save bandwidth, though for local development it&rsquo;s always faster to switch it off.&rdquo;</p>\n\n\n\n<h2>Unsplash Plugin Will Not Add an Option to Disable the CDN &ndash; Its API Guidelines Require Apps to Use It</h2>\n\n\n\n<p>The plugins that disable Unsplash&rsquo;s CDN could immediately become obsolete if Unsplash decided to build in an option into the official plugin to do the same. The company has confirmed the team has no current plans to so. </p>\n\n\n\n<p>&ldquo;The CDN is a feature that dynamically serves the right size and format of image, and includes performance optimizations not available via additional plugins like WordPress.com&rsquo;s Jetpack or most CDNs,&rdquo; Unsplash co-founder Luke Chesser said. &ldquo;We do this to improve the performance of the image loading and allow Unsplash contributors to count the number of times their images have been seen.&rdquo;</p>\n\n\n\n<p>In addition to sharing this data with contributing photographers, Unsplash advertisers also need this data to continue getting value from the new <a href=\"https://unsplash.com/blog/introducing-unsplash-for-brands/\">Unsplash for Brands</a> business model. </p>\n\n\n\n<p>The total monthly cost in 2019 for the company&rsquo;s image hosting with <a rel=\"noreferrer noopener\" href=\"https://imgix.com/\" target=\"_blank\">Imgix</a> was <a href=\"https://medium.com/unsplash/what-does-unsplash-cost-in-2019-f499620a14d0\">$42,408</a>, which means Unsplash spends north of $500k per year to serve optimized images via its CDN. Chesser said the cost of the CDN is &ldquo;very low relative to the number of requests and traffic it can serve,&rdquo; given how optimized and performant the image serving infrastructure is. Last year Unsplash sent petabytes of data through Imgix&rsquo;s CDN for 250 million variations of the library&rsquo;s source images.</p>\n\n\n\n<p>&ldquo;We treat brands as contributors as they also share images on Unsplash,&rdquo; Chesser said. &ldquo;We report downloads and views back to them. So yes, the view and download counts do matter to our business from a monetary perspective, but to be clear, if you take away brands, we would still have this requirement as it&rsquo;s central to growing the library and encouraging more contributors.&rdquo;</p>\n\n\n\n<p>Providing stats to brands undoubtedly helps pay the bills and keeps the lights on, so it is no wonder the requirement to use the CDN will remain in the WordPress plugin. In fact, this requirement was built into <a href=\"https://help.unsplash.com/en/articles/2511245-unsplash-api-guidelines\">Unsplash&rsquo;s API guidelines</a> in 2018 and applies to all applications accessing the collection:</p>\n\n\n\n<p>&ldquo;<em>All API uses must use the hotlinked image URLs returned by the API under the <code>photo.urls</code> &nbsp;properties. This applies to all uses of the image and not just search results. &ldquo;</em></p>\n\n\n\n<p>In 2019, Unsplash received more traffic from its API partners than from the company&rsquo;s own website and official apps. Any successful monetization strategy that hinges on advertising will need to deliver those stats and requiring applications use the CDN in order to use the API is one way to do that. </p>\n\n\n\n<p>Matt Mullenweg recently <a href=\"https://twitter.com/photomatt/status/1290739168537001984\">asked</a> what these API guidelines mean for existing WordPress plugins, like <a href=\"https://wordpress.org/plugins/instant-images/\">Instant Images</a>, that serve Unsplash images without using the CDN. The plugin has more than 50,000 active installations. </p>\n\n\n\n<p>&ldquo;When we released the updated guidelines we applied them proactively to new apps and worked with developers on a case by case basis over a one year period to consider hotlinking and downloads for legacy apps,&rdquo; Chesser said. &ldquo;Instant Images was built before we made the update to the guidelines and so we exempted them long ago, along with&nbsp;a number of other legacy apps.&rdquo;</p>\n\n\n\n<p>Instant Images plugin developer Darren Cooney said he will not be adding an option to his plugin for turning on the CDN and declined to comment further on his reasons. </p>\n\n\n\n<p>&ldquo;I will say that I think the CDN should be opt-in and it should be more clear what happens on the Unsplash side when the CDN is in use,&rdquo; Cooney said. &ldquo;What is tracked, why it&rsquo;s tracked and what benefit do added views provide the contributors.&rdquo;</p>\n\n\n\n<p> When asked whether Unsplash plans to update the plugin to deny API access to sites that have added a plugin to disable the CDN, Chesser said no. WordPress plugins weaponizing themselves against each other is not unheard of, although it is unusual and frowned upon.</p>\n\n\n\n<p>&ldquo;We don&rsquo;t do things like that,&rdquo; Chesser said. &ldquo;I think anyone who knows our team and our community will know that we always try to take reasonable actions as we&rsquo;re representing a lot of contributors and a large community. If a user wants to install a plugin to deactivate the CDN but still access the library, they can do that by all means, but we don&rsquo;t want to build, promote, and support that functionality ourselves because it works against our community,&nbsp;our business, and our mission.&rdquo;</p>\n\n\n\n<p>The bottom line is Unsplash is a business, and a business needs to make money. Certainly a company doesn&rsquo;t commission a WordPress plugin from a team of the caliber of <a href=\"https://xwp.co/\">XWP</a> without hoping for a return on that kind of investment. The plugin&rsquo;s setup process makes it effortless for users to connect to the Unsplash API, but there isn&rsquo;t any transparency during this process regarding what data users are agreeing to send Unsplash. The plugin needs to be more forthcoming about the data the CDN collects on views and downloads. This would go a long way towards establishing more credibility with skeptics. Those who are wary of the requirement to use the CDN can use a plugin to disable it or install an alternative like Instant Images. </p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Aug 2020 21:45:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"WPTavern: Gutenberg 8.7 Adds Minor Changes, Updates Block Pattern Designs, and Continues Full-Site Editing Work\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102950\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:263:\"https://wptavern.com/gutenberg-8-7-adds-minor-changes-updates-block-pattern-designs-and-continues-full-site-editing-work?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-8-7-adds-minor-changes-updates-block-pattern-designs-and-continues-full-site-editing-work\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5390:\"<p class=\"has-drop-cap\">On Wednesday, the Gutenberg team pushed what was primarily <a href=\"https://make.wordpress.org/core/2020/08/05/whats-new-in-gutenberg-august-5/\">minor enhancements and bug fixes</a> to the WordPress platform&rsquo;s primary project. Everyone is mostly gearing up for the WordPress 5.5 release, so we are not seeing any major features dropping at the moment. However, steady work continues on improving the Gutenberg plugin.</p>\n\n\n\n<p>Gutenberg 8.7 contains over 30 bug fixes, in which nearly a third were accessibility-related changes. Around half of the new enhancements focused on updating block patterns.</p>\n\n\n\n<p>Users can look forward to several minor enhancements that should improve the editor, such as the Buttons block getting a proper <a href=\"https://github.com/WordPress/gutenberg/pull/24249\">preview in the inserter</a>. The monitoring solution behind auto-saving should also <a href=\"https://github.com/WordPress/gutenberg/pull/23962\">work more consistently</a> with this update.</p>\n\n\n\n<p>The biggest user-facing enhancement is the change in <a href=\"https://github.com/WordPress/gutenberg/pull/24263\">dealing with invalid blocks</a>. The latest version of the plugin makes the <em>attempt block recovery</em> option the default. This change hides the <em>resolve</em>, <em>convert to classic</em>, and <em>convert to HTML</em> options under the sub-menu (ellipsis button). This is a nice touch and makes the most sense. Attempting to recover a block should generally be the first step when correcting invalid block output.</p>\n\n\n\n<h2>Block Pattern Updates</h2>\n\n\n\n<ul><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li><li class=\"blocks-gallery-item\"><img /></li></ul>Updated block pattern designs.\n\n\n\n<p class=\"has-drop-cap\">I can now proceed to eat my earlier words of <a href=\"https://wptavern.com/decision-time-what-block-patterns-should-ship-with-wordpress-5-5\">frustration with block patterns</a>. Or, perhaps I can praise myself in some small way for pushing the Gutenberg team to up their game. I was unhappy with the abysmal designs that were originally going to ship with WordPress 5.5. The team has taken what was looking to be one of the most disappointing first outings for a feature and turned it into something the project can be proud of.</p>\n\n\n\n<p>It did not take much. A photo here. A touch of pizazz there. The Don Quixote images and text bring a cohesive theme to the patterns, breathing a touch of life in an otherwise desolate and barren feature.</p>\n\n\n\n<p>The &ldquo;large header with a heading&rdquo; pattern <a href=\"https://github.com/WordPress/gutenberg/pull/24141\">dropped the blinding background</a> gradient and replaced it with an image. The &ldquo;quote&rdquo; pattern <a href=\"https://github.com/WordPress/gutenberg/pull/24140\">now has a face</a> instead of an impersonal icon. Even the &ldquo;two images side by side&rdquo; pattern <a href=\"https://github.com/WordPress/gutenberg/pull/24139\">fits in thematically</a>.</p>\n\n\n\n<p>If anything, I am not a fan of the long pattern names. &ldquo;Large header with a heading and a button&rdquo; and &ldquo;three columns of text with buttons&rdquo; do not exactly roll off the tongue. Nor do they make it easy to write about them. I do not wish the pain of typing them out on any support volunteers.</p>\n\n\n\n<p>At least we are working with a somewhat decent set of patterns going forward, and that is enough to be thankful for at this point. I will now await the first theme author to truly impress me with custom patterns.</p>\n\n\n\n<h2>Experimental Features Update</h2>\n\n\n\n<img />Site editor beta.\n\n\n\n<p class=\"has-drop-cap\">Much of the work for this release centered on the plugin&rsquo;s experimental features. The bulk of it went toward post-related blocks. At this point, these features are so experimental that even experienced developers outside of the inner Gutenberg circle have trouble following the progress. It is nice to see the continual movement in this area. However, from a user viewpoint, it is not even ready for a quick look. Enable at your own risk. Wait until the product is a bit more polished.</p>\n\n\n\n<p>I typically enable Gutenberg&rsquo;s experimental features once a month or so. I want to keep up with the progress and not feel out of the loop. Such was the case over the past couple of days as I tinkered a bit more with the full-site editing and demo templates features. I am unsure what I was hoping for. Mostly, I wanted some indication of a bright future &mdash; one that I fully expect to be realized at some point. I wanted to be wowed.</p>\n\n\n\n<p>I understand why the <em>wow</em> factor is not there. The feature is far from ready. More than that, I know that, as a developer, you have a vision of the finished product in your head, and as the UI is in flux, others cannot see that vision. It is a step-by-step process that you simply have to continue working through.</p>\n\n\n\n<p>I am still of the belief that full-site editing will not be close to a viable feature until 2021. Even with all hands on deck, four months is too small of a window to make anything remotely competitive to existing solutions out there. When full-site editing does land in core WordPress, it needs to do so with a bang, not a whimper.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Aug 2020 21:33:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"WPTavern: Is WP Notify the Silver Bullet WordPress Needs to End Admin Notification Spam?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102877\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"https://wptavern.com/is-wp-notify-the-silver-bullet-wordpress-needs-to-end-admin-notification-spam?utm_source=rss&utm_medium=rss&utm_campaign=is-wp-notify-the-silver-bullet-wordpress-needs-to-end-admin-notification-spam\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5192:\"<p>A short while ago, Justin Tadlock posted an article titled <a rel=\"noreferrer noopener\" href=\"https://wptavern.com/are-plugin-authors-to-blame-for-the-poor-admin-notices-experience\" target=\"_blank\">Are Plugin Authors to Blame for the Poor Admin Notices Experience?</a>. If you haven&rsquo;t already, I recommend reading his article. It describes in detail one question I&rsquo;ve been pondering since I originally posted the <a href=\"https://make.wordpress.org/core/2019/08/05/feature-project-proposal-wp-notify/\">WP Notify feature project proposal</a> almost a year ago now: Will a new notification system for WordPress solve the notification spam, or just move it elsewhere?</p>\n\n\n\n<p>The answer might not be as simple as we think.</p>\n\n\n\n<p>I have been building, maintaining, and supporting a number of free, paid, and client plugins for the past five years. During that time I have also been an active contributor &mdash; as much as I possibly can outside of work and my personal life &mdash; to the WordPress open source project. Now that&rsquo;s definitely a drop in the ocean compared to some folks, but whenever I see the mess that can occur when multiple plugins or themes register admin_notices on EVERY SINGLE ADMIN PAGE, it strengthens my resolve in the idea that WordPress needs a centrally managed notification system.&nbsp;</p>\n\n\n\n<p>If you read Justin&rsquo;s article, or you are a plugin or theme developer yourself, you know that the notifications system (aka admin notices, a reference to the WordPress <a rel=\"noreferrer noopener\" href=\"https://developer.wordpress.org/reference/hooks/admin_notices/\" target=\"_blank\">hook that prints these notices</a>) in WordPress is limited at best. We need to be honest with ourselves, however, admin notices was not designed to function as a notification system. Admin notices should really only be used to display useful information to the user about state changes in the system. Messages like when a post has been updated or deleted, or a database upgrade is required. Short, useful, and more importantly, relevant.</p>\n\n\n\n<p>As developers, we usually look for the root cause of a problem. And in the case of admin notices, the root cause is not the current notification system, or the fact that plugin developers use it for things other than, well, admin notices. The root cause is the fact that there has never existed a mechanism for notifications other than admin notices to be displayed to the user. This means that whenever a plugin developer has needed, or in fact wanted, to communicate with their users, via &ldquo;in app messages,&rdquo; admin notices has been the only way they can do so.</p>\n\n\n\n<p>Want to let your users know about a new upgrade? Admin notice. Want to ask them to leave a review? Admin notice. Your premium license is about to expire! Admin notice. Hey, we&rsquo;ve got a new sale on our premium products! Admin notice. It all soon adds up to an almighty mess.</p>\n\n\n\n<p>And that&rsquo;s the problem with a project like WP Notify. We&rsquo;ve had admin notices, in its current iteration at least, since 2011. That means we have been using it for all our user facing messages now for nine years at least &ndash; nine years of plugin and theme developers using admin notices to send messages to users.&nbsp;</p>\n\n\n\n<p>If you have children, imagine telling your nine year old that the way they have been walking is wrong, and they now need to learn a completely new way of doing it. Good Luck!</p>\n\n\n\n<p>So, as much as it pains me to admit it, WP Notify is not the silver bullet that will magically fix the problem at its core. As Matt Mullenweg pointed out in the comments on Justin&rsquo;s article, &ldquo;I don&rsquo;t think a notification center is the solution to this problem. It may be useful for other reasons, but not that one.&rdquo;</p>\n\n\n\n<p>However, not having a specific solution for notifications other than those that are necessary, means that developers will keep on doing things the way they have always been. Enforcing new guidelines around the current functionality nine years later is going to be hard, especially since enforcing these guidelines will have to be done by a small group of volunteers, namely the theme and plugin review teams.&nbsp;</p>\n\n\n\n<p>By building WP Notify, we create a new and hopefully better way for plugin and theme developers to connect and communicate with their users. At the same time, we provide a tool by which we can more easily enforce any new guidelines. A guideline could be created for example, that unless your message is strictly within the realms of informing the user about state changes in the system, it needs to be displayed in the notifications center, and not as an admin notice.</p>\n\n\n\n<p>So no, I don&rsquo;t believe WP Notify will be a silver bullet solution. We&rsquo;re not going to build it, ship it, and suddenly all the notification spam goes away the next day. That kind of change takes time.</p>\n\n\n\n<p>But I do believe it&rsquo;s a step in the right direction.</p>\n\n\n\n<p>If you agree with me, why not <a href=\"https://make.wordpress.org/core/tag/feature-notifications/\">join our merry band and help us build it</a>.&nbsp;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Aug 2020 14:06:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Jonathan Bossenger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: Automattic Relaunches P2, Self-Hosted Version on the Roadmap\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102891\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:183:\"https://wptavern.com/automattic-relaunches-p2-self-hosted-version-on-the-roadmap?utm_source=rss&utm_medium=rss&utm_campaign=automattic-relaunches-p2-self-hosted-version-on-the-roadmap\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4890:\"<p>Automattic&rsquo;s relaunch of P2 is <a href=\"https://wordpress.com/p2/\">now in Beta</a>. This is the long-awaited update to the company&rsquo;s internal collaboration software that is also used on WordPress.org and other self-hosted sites via a theme. For years, Automattic, which now counts more than 1,200 employees in 77 countries, has had P2 at the core of its written communication tools. It is used as a complement to Slack and video conferencing, providing a public collaboration space for conversations which might otherwise be hidden away in emails. </p>\n\n\n\n<p>The older version of P2 functioned as a dependable workhorse with few changes over the years, but the beta introduces some marked improvements that make it more versatile than before. It is now seamlessly integrated with the block editor and includes a streamlined invitation system for onboarding new team members.</p>\n\n\n\n<img />\n\n\n\n<p>P2 has a fresh design that has come a long way since its roots as an <a href=\"https://ma.tt/2009/05/how-p2-changed-automattic/\">evolution of the Prologue microblogging theme.</a> Many things about WordPress have changed since P2&rsquo;s first launch 11 years ago but threaded conversations have endured as a useful collaboration format. Mobile support is one of the things that has improved significantly. Users can get notifications via the web, email, and the WordPress mobile apps.</p>\n\n\n\n<img />\n\n\n\n<p>&ldquo;It works on the WordPress apps perfectly but it&rsquo;s handled as a normal WordPress site, without any P2 specific functionality,&rdquo; Automattic&rsquo;s P2 launch lead Jon Burke said. &ldquo;P2 specific functionality and improvements are on the mobile app product roadmap. The browser version on the other hand has all the particularities that P2 has.&rdquo;</p>\n\n\n\n<p>The beta version of P2 is free and each instance comes with 3GB of storage space for images and files. Users can create as many as they like. The product is built on top of WordPress.com&rsquo;s infrastructure but functions as a scaled back version of a blog &ndash; essentially a WordPress for teams. </p>\n\n\n\n<p>Pricing for the commercial upgrade has not yet been determined, according to Burke, but the roadmap includes a hefty list of features.</p>\n\n\n\n<p>&ldquo;We&rsquo;ll have integrations with third party services, project management features, more storage space, custom URLs, more customization options, etc,&rdquo; Burke said. &ldquo;We plan to introduce multi-site functionality, too, so an organization can create multiple P2s while sharing the same user base, have cross-posting, a common glossary, and other advanced features.&rdquo;</p>\n\n\n\n<p>With the diverse myriad of blocks pouring into the WordPress ecosystem, every P2 has the opportunity to be unique, depending on which features it introduces through the editor. Burke said Automattic plans to allow admins to extend their P2 instances with plugins in the enterprise version.</p>\n\n\n\n<h2>P2 Set to Roll Out on WordPress.com, Self-Hosted Version Coming &ldquo;Eventually&rdquo; </h2>\n\n\n\n<p>P2 is just now entering beta but many fans are already eagerly awaiting a self-hosted version. Burke said it is coming &ldquo;eventually,&rdquo; but the team hasn&rsquo;t yet worked out how it will be structured. The project is not currently available on GitHub.</p>\n\n\n\n<p>&ldquo;With this launch version behind us the P2 team will turn to this but don&rsquo;t yet have a time-line,&rdquo; Burke said. &ldquo;The team will need to now define how the backend admin will look.&rdquo; The updated P2 is also coming to power conversations on WordPress.org further down the road.</p>\n\n\n\n<p>&ldquo;We don&rsquo;t yet have a target date but it is on the product roadmap,&rdquo; he said. &ldquo;This P2 version has been more than a theme or plugin update &ndash; it&rsquo;s really a product concept- so we can&rsquo;t simply update the WordPress.org P2 theme; it requires additional progress.&rdquo;</p>\n\n\n\n<p>P2 seems like it would be a good fit for Automattic&rsquo;s <a href=\"https://happy.tools/\">Happy Tools</a> suite of products for distributed teams. A version of P2 with more features may roll out under this brand once the beta concludes.</p>\n\n\n\n<p>&ldquo;Given the sudden global shift to remote work we really wanted to get out a stable product as soon as we could,&rdquo; Burke said. &ldquo;That really made WordPress.com the most expedient pathway to get P2 into peoples&rsquo; hands.</p>\n\n\n\n<p>&ldquo;Now that we have launched this version, we will make decisions around where the next releases will live. P2 has been envisioned as being part of the Happy Tools suite. But we are going to learn from the early users on WordPress.com and prioritize the next steps. We know that some users will need a premium version on WordPress.com in order to secure a custom domain and other features so we will update that shortly.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Aug 2020 22:10:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"WPTavern: Plugin Rank Provides Insight Into WordPress Search Results, Competitive Analysis, and Email Reports for Developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102835\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:289:\"https://wptavern.com/plugin-rank-provides-insight-into-wordpress-search-results-competitive-analysis-and-email-reports-for-developers?utm_source=rss&utm_medium=rss&utm_campaign=plugin-rank-provides-insight-into-wordpress-search-results-competitive-analysis-and-email-reports-for-developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6181:\"<p class=\"has-drop-cap\">Iain Poulson announced that <a href=\"https://pluginrank.com/\">Plugin Rank</a> is open to the public yesterday. It is a new service that allows plugin authors to track their rankings by keyword on the official WordPress plugin directory. The service is geared toward plugin authors with freemium offerings.</p>\n\n\n\n<p>The tools were already in place for Poulson to build the service.  He just needed to build his service on top of them.  &ldquo;Plugin Rank leverages the WordPress.org API to retrieve a set of plugins for a search term,&rdquo; he said. &ldquo;It&rsquo;s the same API that WordPress uses when a user searches for a plugin inside their WordPress dashboard or when searching on the plugin directory.&rdquo;</p>\n\n\n\n<p>Poulson described how a user might search for a membership plugin by typing &ldquo;membership&rdquo; in the search box. The WordPress API returns a set of plugins that best match that term, based on an internal ranking algorithm. The Plugin Rank service uses this same, underlying technology.</p>\n\n\n\n<p>&ldquo;Plugin Rank will check the API daily to find the latest positions of the plugins for the keywords being tracked by Plugin Rank customers,&rdquo; he said. &ldquo;This data is then used to show position movement and charted to show an overall picture of how the plugins are ranking.&rdquo;</p>\n\n\n\n<img />Plugin dashboard screen.\n\n\n\n<p>The idea for the service was born from work he and others were doing at <a href=\"https://deliciousbrains.com/\">Delicious Brains</a>, a WordPress development company, a few months ago. &ldquo;We&rsquo;d started to work on improving the copy in the <a href=\"https://wordpress.org/plugins/wp-migrate-db/\">WP Migrate DB</a> plugin readme.txt files to rank higher in search results,&rdquo; he said. &ldquo;Brad Touesnard set up a Google sheet with all the keywords we wanted to rank for, a link to search the keyword on wordpress.org, and columns for each month. He started to record the position the plugin appears for each keyword every month. Or that was the idea, when we remembered!&rdquo;</p>\n\n\n\n<p>Poulson began using the same system for <a href=\"https://wpusermanager.com/\">WP User Manager</a> and <a href=\"https://intagrate.io/\">Intagrate</a>, two freemium plugins he had in the plugin directory. However, it did not take long to realize the futility of that system.</p>\n\n\n\n<p>&ldquo;The sheer manual nature of the task of setting up the sheet, monthly checking, and trying to remember to do it made me think there must be a better way,&rdquo; he said. &ldquo;So I started to work on an app to do it for me.&rdquo;</p>\n\n\n\n<p>Besides simply providing a particular plugin&rsquo;s rank, Poulson said the service provides information that can help plugin developers raise their rankings in the search results.</p>\n\n\n\n<img />Competitive analysis against other plugins.\n\n\n\n<p>&ldquo;The competitor analysis in Plugin Rank gives you an insight into the top 50 plugins that rank for the keywords you care about,&rdquo; said Poulson. &ldquo;It gives you insights into what those plugins are doing that make them rank higher than you. Do they have a high amount of the keyword in their readme? Do they have it in their title or tags? Do they answer the bulk of their support requests? Do they have a large number of five-star ratings?&rdquo;</p>\n\n\n\n<h2>A Premium Service with a Premium Price</h2>\n\n\n\n<p class=\"has-drop-cap\">Plugin Rank is the first service of its kind in the WordPress industry. Therefore, Poulson had to look outside of traditional WordPress channels to get a sense of how to <a href=\"https://pluginrank.com/pricing/\">price the new service.</a></p>\n\n\n\n<p>&ldquo;I looked at similar SEO tools for traditional search engines, like <a href=\"https://ahrefs.com/\">Ahrefs</a> and <a href=\"https://www.semrush.com/\">SEMrush</a>, and tried to base my pricing on how valuable it can be in relation to other marketing channels,&rdquo; he said.</p>\n\n\n\n<p>Only time and feedback will decide whether he found the sweet spot between offering a valuable service and what plugin developers are willing to fork over. The Starter tier allows plugin authors to track up to five keywords for a single plugin. It also includes email reports and competitor analysis. The $9 per month price tag is low enough for developers to dip their toes in and decide whether it is worth upgrading for tracking more keywords and plugins.</p>\n\n\n\n<p>The $49 Plus plan allows up to five plugins and 50 keywords. It also includes tracking for multiple languages. The $119 Pro plan bumps the plugin count to 20 and keyword number to 500.</p>\n\n\n\n<p>Right now, Plugin Rank is offering a 21-day free trial, which is a no-brainer for any freemium plugin author who might even be remotely interested in the service. <em>I have no doubt I would sign up if I was still in the freemium plugin game.</em></p>\n\n\n\n<p>&ldquo;Most developers and companies will invest heavily and get good results from content marketing and SEO improvements, and their WordPress.org plugin listing will receive little attention,&rdquo; said Poulson. &ldquo;But for freemium plugins, it can be a huge channel for getting people using their plugin and buying the up-sells. So it&rsquo;s priced with that in mind.&rdquo;</p>\n\n\n\n<h2>The Future of the Service</h2>\n\n\n\n<p class=\"has-drop-cap\">The <em>knowledge</em> of where a plugin stands in the rankings and having the data readily available will undoubtedly help many plugin authors. However, knowledge is merely the beginning of ranking higher. For developers who are not well-versed in marketing and SEO, they will need to develop new skills to make full use of what they learn from the service.</p>\n\n\n\n<p>Poulson seems interested in expanding the service beyond its initial goal of providing ranking data. Tutorials, videos, and other resources would be a nice value-add for those who buy into the service now.</p>\n\n\n\n<p>&ldquo;Plugin Rank&rsquo;s primary functionality at the moment is monitoring and getting access to data,&rdquo; he said, &ldquo;but I&rsquo;ve got features planned that focus on how to make improvements, as well as tutorial-style content on the Resources page.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Aug 2020 21:14:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"BuddyPress: BuddyPress 6.2.0 Maintenance release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=313261\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://buddypress.org/2020/08/buddypress-6-2-0/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1123:\"<p>Immediately available is&nbsp;<a href=\"https://downloads.wordpress.org/plugin/buddypress.6.2.0.zip\">BuddyPress 6.2.0</a>. This maintenance release:</p>\n\n\n\n<ul><li>fixes 1 bug related to the 6.0.0 release, </li><li>is preparing BuddyPress for WordPress 5.5.0,</li><li>is a recommended upgrade for all BuddyPress installations.</li></ul>\n\n\n\n<p>For details on the changes, please read the&nbsp;<a href=\"https://codex.buddypress.org/releases/version-6-2-0/\">6.2.0 release notes</a>.</p>\n\n\n\n<p>Update to BuddyPress 6.2.0 today in your WordPress Dashboard, or by&nbsp;<a href=\"https://wordpress.org/plugins/buddypress/\">downloading from the WordPress.org plugin repository</a>.</p>\n\n\n\n<h2>Many thanks to 6.2.0 contributors&nbsp;<span class=\"dashicons dashicons-heart\"></span></h2>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/hareesh-pillai/\">hareesh-pillai</a>, <a href=\"https://profiles.wordpress.org/man4toman\">man4toman</a>, <a href=\"https://profiles.wordpress.org/dcavins/\">dcavins</a>, <a href=\"https://profiles.wordpress.org/boonebgorges\">boonebgorges</a>, <a href=\"https://profiles.wordpress.org/imath/\">imath</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Aug 2020 19:40:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mathieu Viet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"Post Status: Creating healthy virtual work environments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=79424\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://poststatus.com/creating-healthy-virtual-work-environments/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:738:\"<p>We\'re seeing the strain of isolation and 100% remote work without meetups, conferences, or other in-person opportunities to collaborate. In this episode of Post Status Draft, Cory and Brian discuss how to create healthy virtual work environments, including some tips for establishing better work days.</p>\n\n\n\n\n\n\n\n<p>Or watch this episode on YouTube:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>\n\n\n\n<h3>Sponsor: Pagely</h3>\n\n\n\n<p><a href=\"https://pagely.com/\">Pagely</a> offers best-in-class managed WordPress hosting, powered by Amazon\'s Cloud, the Internet’s most reliable infrastructure. Pagely helps big brands scale WordPress.Thank you to <a href=\"https://pagely.com/\">Pagely</a> for being a Post Status partner!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 05 Aug 2020 23:10:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: WordPress Cancels All In-Person Flagship Events Until 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102777\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:181:\"https://wptavern.com/wordpress-cancels-all-in-person-flagship-events-until-2022?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-cancels-all-in-person-flagship-events-until-2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3357:\"<p>As the world scrambles to invent and manufacture therapeutics and vaccines for COVID-19, the World Health Organization has <a href=\"https://www.who.int/news-room/detail/01-08-2020-covid-19-emergency-committee-highlights-need-for-response-efforts-over-long-term\">declared</a> the pandemic &ldquo;a once-in-a-century health crisis, the effects of which will be felt for decades to come.&rdquo; Outbreaks vary in severity across the globe, making it impossible to host international conferences safely for many months (and possibly years) to come.</p>\n\n\n\n<p>In consideration for the time and efforts of hundreds of volunteers who would be involved in planning in-person events, WordPress <a href=\"https://make.wordpress.org/community/2020/08/04/announcement-flagship-events-in-2021\">announced</a> it will no longer accept any applications for flagship events in 2021:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Flagship events (i.e. large, regional WordCamps that attract an international audience) bring together people from all corners of the world, so until infection rates are effectively mitigated and/or a vaccine is widely available, these large scale events that typically host more than 1,000 individuals could become &ldquo;super-spreader&rdquo; events if a single infected person attends.&nbsp;</p><p>Applications for new flagship events (or regional events that cover multiple regions or countries) will not be accepted for all of 2021.</p></blockquote>\n\n\n\n<p>The announcement comes on the heels of <a href=\"https://wptavern.com/wordcamp-us-2020-canceled-due-to-pandemic-stress-and-online-event-fatigue\">WordCamp US canceling its virtual event</a> due to overextended organizers and online event fatigue for attendees. Up until this point, organizing teams from the large regional camps have been making their own determinations regarding the suitability of hosting an event online. The change announced this week prevents new events from applying and then inevitably having to transition to a virtual format.</p>\n\n\n\n<p>Existing flagship events that were already in the pipeline will be allowed to continue as online events. These include WordCamps Europe, US, Asia, and  Centroam&eacute;rica. Of these, WCEU has already <a href=\"https://wptavern.com/wordcamp-europe-goes-virtual-for-2021-in-person-conference-to-resume-2022\">announced</a> an online event.</p>\n\n\n\n<p>&ldquo;As&nbsp;<a href=\"https://make.wordpress.org/community/2020/07/23/building-community-beyond-events/\">online events continue to evolve</a>&nbsp;to reflect community needs, the Community Team strongly encourages these flagship organizing teams to be creative in their approach,&rdquo; Hugh Lashbrooke said in the announcement. This challenge forces organizers to proceed only if they can  knock it out of the park in terms of creativity. Otherwise, it&rsquo;s simply hosting another online conference in the same tired format for the sake of tradition. </p>\n\n\n\n<p>WordPress is at an interesting point in its history where it can no longer rely on in-person events to drive enthusiasm, education, and growth for the community. Flagship WordCamps are a necessary casualty in the fight to slow the spread of the virus, but this early decision provides a welcome peg of certainty for those who normally invest a significant amount of time in making these events a reality.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 05 Aug 2020 21:57:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Disable Comments Plugin Looking for New Owner, Highest Bid Goes to Charity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102771\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:211:\"https://wptavern.com/disable-comments-plugin-looking-for-new-owner-highest-bid-goes-to-charity?utm_source=rss&utm_medium=rss&utm_campaign=disable-comments-plugin-looking-for-new-owner-highest-bid-goes-to-charity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4743:\"<p class=\"has-drop-cap\">Samir Shah is ready to part ways with his popular <a href=\"https://wordpress.org/plugins/disable-comments/\">Disable Comments</a> plugin. The WordPress extension has garnered over a million users and a solid 220 five-star reviews out of 229, but its owner no longer has the time to maintain it. Rather than simply give it away or sell it for profit, he plans to auction it for charity.  The highest bidder will donate to Effective Altruism Funds (EAF), a charitable organization, for ownership.</p>\n\n\n\n<p>Shah asks that those who are interested in bidding on the plugin contact him via his <a href=\"http://twitter.com/solaris_smoke/\">Twitter account</a>. He is also open to feedback on how to approach this at the moment.</p>\n\n\n\n<p>He first released the Disable Comments plugin in 2011. This was during a time that he was working professionally with WordPress. His primary use case was with corporate clients who did not need any sort of commenting functionality on the site.</p>\n\n\n\n<p>&ldquo;After repeating this implementation on several projects I ported it to a plugin,&rdquo; he said. &ldquo;The plugin became popular very quickly so it turns out this was a common use case.&rdquo;</p>\n\n\n\n<p>Shah used PHP and WordPress primarily between 2009 and 2015. However, the work his company has been doing has shifted his focus to other languages and platforms. He has not used WordPress professionally since 2016 but has continued maintaining this plugin for the community in his free time.</p>\n\n\n\n<p>&ldquo;In the last year or two I&rsquo;ve found it hard to keep up with the maintenance of the plugin,&rdquo; he said. &ldquo;I&rsquo;m increasingly unfamiliar with both the WordPress core (major changes like Gutenberg, for example) and with newer versions of PHP. It is time to find a new owner who is actively using WordPress.&rdquo;</p>\n\n\n\n<p>Disable Comments allows administrators to disable the comment functionality across the entire site. Users can also control it based on a specific post type or even disable comments across the network when used on a multisite installation.</p>\n\n\n\n<p>The primary use case is for disabling all commenting-related functionality. When this mode is enabled, the plugin hides comment links from all menus, removes comment widgets, hides the discussion settings screen, disables outgoing pingbacks, and more. Of course, it disables commenting on the front end too.</p>\n\n\n\n<p>Shah also has a <a href=\"https://github.com/solarissmoke/disable-comments-mu\">&ldquo;must use&rdquo; version</a> of the plugin available on GitHub. This comes in handy for professional work where the developer does not want the client to accidentally deactivate the plugin.</p>\n\n\n\n<p>&ldquo;I never intended to make any money off this plugin, which is completely free to use,&rdquo; said Shah. &ldquo;I have however received a number of financial offers for it over the years (presumably because people value the large user base), and so the idea I had was to auction it. The highest bidder would pay their bid to my preferred charitable organization, and send me a receipt as proof of donation in exchange for ownership of the plugin.&rdquo;</p>\n\n\n\n<p>He is hoping that someone in the community will value a free plugin that does not generate revenue. With over a million active installs, there is a possibility that a company could directly or indirectly profit from ownership. Even if not, this would be a good opportunity for someone with the resources to give back to the WordPress community. There is an obvious need for this type of plugin.</p>\n\n\n\n<p>While Shah says he does not spend much time on charitable work, he does try to donate a percentage of his annual income to charity and believes this is another avenue to do some good.</p>\n\n\n\n<p>&ldquo;I&rsquo;m in the privileged position at the moment of having sufficient income to meet my basic needs,&rdquo; he said. &ldquo;Selling the plugin for profit isn&rsquo;t going to alter my standard of living, and I&rsquo;m not interested in profit for its own sake. If I can extract some value from this plugin and give it to EAF then it will go some way to improving the lives of others.&rdquo;</p>\n\n\n\n<p>He said he chose EAF because it uses an evidence-based approach to distributing funds by focusing on empirical measures of impact. &ldquo;This felt to me like a better strategy than just picking a cause that I was personally attached to. There are particular areas of their work &mdash; e.g., the long-term future fund &mdash; that I think are especially important today.&rdquo;</p>\n\n\n\n<p>It will be interesting to see how this type of <em>sale</em> works out. What do you think of trading ownership of a plugin for a charitable contribution?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 05 Aug 2020 18:45:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WordPress.org blog: WordPress 5.5 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8764\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2020/08/wordpress-5-5-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2501:\"<p>The second release candidate for WordPress 5.5 is here!</p>\n\n\n\n<p>WordPress 5.5 is slated for release&nbsp;on&nbsp;<strong>August 11, 2020</strong>, but we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.5 yet,&nbsp;now is the time!</p>\n\n\n\n<p>You can test the WordPress 5.5 release candidate in two ways:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.5-RC2.zip\">download the release candidate here (zip)</a>.</li></ul>\n\n\n\n<p>Thank you to all of the contributors who tested the&nbsp;Beta releases and gave feedback. Testing for bugs is a critical part of polishing every release and a great way to contribute to WordPress.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.5 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme file to 5.5. If you find compatibility problems, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>,&nbsp;so those can be figured out before the final release.</p>\n\n\n\n<p>For a more detailed breakdown of the changes included in WordPress 5.5, check out the <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-1/\">WordPress 5.5 beta 1 post</a>. The&nbsp;<a href=\"https://make.wordpress.org/core/2020/07/30/wordpress-5-5-field-guide/\">WordPress 5.5 Field Guide</a>&nbsp;is also out! It’s your source for details on all the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a>&nbsp;This release also marks the&nbsp;<a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\">hard string freeze</a>&nbsp;point of the 5.5 release schedule.</p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">fill one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Aug 2020 19:12:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jake Spurlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: Redux Framework Relaunches, Focuses Efforts on Gutenberg Templates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98604\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"https://wptavern.com/redux-framework-relaunches-focuses-efforts-on-gutenberg-templates?utm_source=rss&utm_medium=rss&utm_campaign=redux-framework-relaunches-focuses-efforts-on-gutenberg-templates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:13983:\"<p class=\"has-drop-cap\">D&#333;vy Paukstys was rushing out another update with bug fixes yesterday morning as we chatted about the future of his popular <a href=\"https://redux.io/\">Redux Framework</a>. It was not the first update of the day. The Virginia-based developer is just over a week into what he has called the <em>soft launch</em> of Redux 4.x. It is a major reconstruction of a plugin that has been powering over 900,000 websites and has a strong developer audience.</p>\n\n\n\n<p>The changes over the past week might seem risky to some. He has built a massive user base by providing one of the most <a href=\"https://wordpress.org/plugins/redux-framework/\">powerful theme and plugin options frameworks</a> in WordPress history. The plugin&rsquo;s new focus leans heavily toward the block editor, which is still one of the most controversial features of WordPress, even after nearly two years as part of the core platform.</p>\n\n\n\n<p>Paukstys needed to make a change. The developer-only approach was not generating the return on investment that he needed. The $7,000 in donations and subscriptions received in 2019 was not sustainable, especially when products on the Envato marketplace had generated at least $56 million on the back of Redux, according to data he had gathered. He was leaving far too much money on the table. Redux was a successful product on the surface, but developers were either unwilling to pony up the cash or the business plan was not working. It was time for something new.</p>\n\n\n\n<p>It was not merely time for a change because the business was essentially going nowhere. The game was and is still changing. Theme options, the bread and butter of Redux, will likely be a thing of the past in the next year or two. Themes will become far less reliant on options panels. Developers will need to build their offerings around the block system and plugins like Redux need to keep up.</p>\n\n\n\n<p>The writing was on the wall. The best time to profit from a theme options framework was the past decade. Whether it is the <a href=\"https://wptavern.com/will-page-builders-remain-competitive-in-the-block-era\">block editor or a page-building plugin</a> like Elementor, design options are on the individual page level now, or at least not buckled into old-school concepts like theme options panels or the customizer.</p>\n\n\n\n<p><em>The times they are a-changin&rsquo;</em>, and Redux is changing with them.</p>\n\n\n\n<p>Paukstys is no stranger to moving with the flow. It has allowed his framework&rsquo;s user numbers to continue growing over the years. In 2015, he shifted gears and focused on making sure his framework <a href=\"https://wptavern.com/redux-and-kirki-frameworks-join-forces-to-provide-better-support-for-the-wordpress-customizer\">supported the customizer</a>. This came after a controversial decision from the Themes Team to <a href=\"https://wptavern.com/wordpress-org-now-requires-theme-authors-to-use-the-customizer-to-build-theme-options\">require the use of the customizer</a> instead of custom theme options screens. Paukstys was a vocal opponent of the decision and still believes the customizer never panned out. In hindsight, he may have been right; the customizer has felt like an abandoned project over the past couple of years. Still, he made the necessary moves to keep his options framework relevant when necessary.</p>\n\n\n\n<p>Today, he is propelling Redux into a new era in which blocks reign supreme.</p>\n\n\n\n<p>&ldquo;If Redux didn&rsquo;t go into the world of blocks it would eventually be a thing of yesterday,&rdquo; he said. &ldquo;The future is blocks and that&rsquo;s where we are putting our focus. We&rsquo;re excited to once again be on the cutting edge and we hope our product can really help users, freelancers, and agencies build and improve their sites in ways they never have before.&rdquo;</p>\n\n\n\n<p>What he and the Redux team has done is tack an entirely new set of user-focused features onto what was once a developer platform. Even the marketing has changed. Redux is now in the business of providing and upselling features to end-users. It is no longer taking a backseat to the theme and plugin authors who have profited in the millions upon its developer API. The team is taking the steering wheel and driving toward its own future.</p>\n\n\n\n<h2>What Does the New Redux Do?</h2>\n\n\n\n<img />Ice Cream shop template kit.\n\n\n\n<p class=\"has-drop-cap\">Redux still does all the things it has always done. Developers can build custom settings screens and offer whatever options they want to their own end-users. The most glaring addition is the new <a href=\"https://templates.redux.io/\">Redux Templates</a> feature, which directly integrates with the block editor.</p>\n\n\n\n<p>&ldquo;Redux Templates acts as a block discovery library if you will,&rdquo; said Paukstys. &ldquo;We bring all templates provided by third-party plugins into a single library. You can essentially see and preview what&rsquo;s possible, click, and import.&rdquo;</p>\n\n\n\n<p>Redux also has a built-in block dependency installer. When importing third-party templates or blocks, it will check if the plugin is installed and active. If not, it will take care of that for users.</p>\n\n\n\n<p>The end goal is to ease the trouble of finding advanced block templates. Currently, most of the block templating plugins are dispersed, projects wondering around the wild. Users cannot find what they need if they do not know where to look. Redux changes all of that. Currently, it supports 18 different block plugins. It serves to give more exposure to existing block plugins and helps users discover solutions they might not have otherwise found.</p>\n\n\n\n<p>On the post-editing screen, the plugin adds a new &ldquo;Templates&rdquo; button to the top toolbar. Once clicked, it opens a popup with its library of sections, templates, and template kits.</p>\n\n\n\n<img />Viewing templates from the Redux library.\n\n\n\n<p>One of the nicer features of the plugin is its previewer. By clicking the preview button, users can see what a section or template looks like before importing anything. On the left side of the previewer, the plugin displays tabs that show what blocks are used and what required plugins would need to be installed and activated.</p>\n\n\n\n<p>Redux leaves little to the imagination. Any necessary information about what is being installed is directly available. Plus, it provides links to any plugins that might be installed.</p>\n\n\n\n<img />Previewing a contact template.\n\n\n\n<p>The great thing is that the Templates feature does not lock the user down to the Redux plugin. If a user wants to deactivate Redux in the future, nothing will change with their blocks. It is primarily serving as a bridge between end-users and the massive world of block projects.</p>\n\n\n\n<p>&ldquo;We see the future of options being diminished in the long run by blocks, so we found a way to move into that space to keep Redux always on the cutting edge,&rdquo; said Paukstys. His team completely rewrote the underlying framework and brought everything up to the WordPress coding standards.</p>\n\n\n\n<p>The move to support blocks is more of a repositioning of a project whose days were numbered.</p>\n\n\n\n<p>Paukstys stressed that Redux has every feature that it had before and even more. The team added CSS variables for developers if they prefer using them over a compiler. He feels like the core framework has improved drastically, which means old users can continue enjoying the features they have become accustomed to.</p>\n\n\n\n<h2>A New Business Plan</h2>\n\n\n\n<img />\n\n\n\n<p class=\"has-drop-cap\">Make no mistake. Paukstys is looking to grow the revenue of his business and create a sustainable future for Redux. The <a href=\"https://redux.io/pricing/\">pricing plan</a> is clear and follows a model that has been successful for many commercial plugins over the years. The plans are tiered and range from $49 per year to $249, depending on the number sites the user wants automatic updates and support for.</p>\n\n\n\n<p>The commercial plans offer new features for developers like automated Google Font updates, custom fonts integrated into all panels, unlimited widget areas, and dynamic search.</p>\n\n\n\n<p>However, the big upsell is landing directly on the doorstep of end-users. Each of the commercial plans offers full access to over 1,000 sections and full-page templates. The breadth of options can almost be overwhelming, but the average user will be able to find nearly any type of template needed for their site. From restaurants to corporate offices to fitness studios, there is a little something for everyone.</p>\n\n\n\n<p>&ldquo;I was all too altruistic,&rdquo; said Paukstys of the previous years. &ldquo;I believed that if I helped people make money, they&rsquo;d give back. Unfortunately, that is not how it works. I&rsquo;ve worked for years with various pricing models, each doomed to fail.&rdquo; He had seen others rise to business success, quite often on the work that he had put in. It is not all about money, and he believes he has something of value to offer in return.</p>\n\n\n\n<p>Development skill is not enough to breed financial success. Sound financial principles must back it up.</p>\n\n\n\n<p>One of the catalysts for recent changes to his business plan was joining <a href=\"https://poststatus.com/\">Post Status</a>, which has a strong community of business leaders in the WordPress ecosystem. He credits Alex Denning, Kimberly Lipari, Haris Zulfiqar, Rich Tabor, and others as inspiration, helping him to shift his thinking around the business side of the project.</p>\n\n\n\n<p>Some of the lessons he has learned thus far are:</p>\n\n\n\n<ul><li>Developers are already starved. Focus on users.</li><li>Add-ons can be a bad model. A single pro/premium product is much easier to sell and manage.</li><li>The need for a revenue model. Don&rsquo;t expect people to just hand over money.</li><li>Use the audience you have. Don&rsquo;t cannibalize yourself.</li></ul>\n\n\n\n<p>&ldquo;Where we&rsquo;ve ended up is a <em>much</em> cheaper plan for developers and a powerful toolkit for users,&rdquo; he said. &ldquo;Hopefully, we&rsquo;re pushing Gutenberg into a greater place of value.&rdquo;</p>\n\n\n\n<h2>Moving Forward</h2>\n\n\n\n<p class=\"has-drop-cap\">Naturally, not every user will be happy with the overhaul of the plugin. For years, Redux was geared specifically toward developers. It was an options framework.</p>\n\n\n\n<p>&ldquo;Redux was for a completely different purpose which is for developers to create Options framework,&rdquo; wrote a user named James <a href=\"https://wordpress.org/support/topic/dishonest-and-bad-performance/\">in a review</a>. &ldquo;They have changed the plugin suddenly to a page builder something like that. It doesn&rsquo;t make sense and they are using the previous plugin&rsquo;s reputation.&rdquo;</p>\n\n\n\n<p>It is a fair criticism. And, it was expected. The plugin has switched much of its focus to end-users. However, it has not removed the existing API and features that made it successful with developers in the past.</p>\n\n\n\n<p>Paukstys is clear that he is building on top of the reputation that Redux has earned and launching new features for end-users. He is unapologetic about trying something new to bring in a reasonable return on his years-long investment of time and resources. Launching a completely new and separate project would carry far more risk. It makes sense to build atop the mountain he had already built.</p>\n\n\n\n<p>It won&rsquo;t make everyone happy. However, he said that the feedback has been &ldquo;shockingly positive&rdquo; in the week since the Redux 4 soft launch.</p>\n\n\n\n<p>&ldquo;I&rsquo;ve never realized how much users appreciated Redux,&rdquo; he said. &ldquo;Some of the changes to the framework broke sites, and everyone I have reached out to help has been so extremely gracious. It&rsquo;s so refreshing and honestly helps me to see why the WordPress community is such a great place to be. I fear developers are too harsh to one another. Users on the other hand, if provided kind support, are in turn incredibly kind.&rdquo;</p>\n\n\n\n<p>If most of the feedback thus far is any indication of the plugin&rsquo;s future, do not expect to see pitchforks and torches.</p>\n\n\n\n<p>He might have to take a few lumps with a few disgruntled users over the change. It comes with the territory. However, feedback will likely directly correlate with how well he serves users through the Redux support channels.</p>\n\n\n\n<p>The project will also benefit from a potentially new user base in the coming months and years. The plugin is dipping its toes into a new market while maintaining the features that got it to where it is today. It will be a bit of a balancing act, but the plugin must move with the times.</p>\n\n\n\n<h2>The Future of Redux</h2>\n\n\n\n<p class=\"has-drop-cap\">This is a new era for Redux. In the immediate future, Paukstys and team will need to focus on ironing out all of the bugs and the transition to a new market. It is a time for reflection, careful listening, and attentiveness before diving headlong into new features.</p>\n\n\n\n<p>&ldquo;In the past, we were 100% developer-centric,&rdquo; said Paukstys. &ldquo;That being said, we always had our eye on the user and wanted to fulfill their needs. Now we&rsquo;re expanding to support the users directly, as well as developers.&rdquo;</p>\n\n\n\n<p>With the newfound focus on end-users, there is potential for growth in other areas. Paukstys says the focus is 100% on the block editor at present. Branching out to support other major page builders like Elementor is not out of the question. However, Redux should be able to continue finding success by extending the core experience.</p>\n\n\n\n<p>&ldquo;When we started this adventure into the blocks space, we worried, given the limited number of blocks out there,&rdquo; he said. &ldquo;But honestly, there&rsquo;s some amazing innovation out there, and it&rsquo;s been pretty great what we can build with Gutenberg.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Aug 2020 14:21:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"WPTavern: Automattic Updates Press Page to Clarify Distinction between WordPress.org and WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102612\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:249:\"https://wptavern.com/automattic-updates-press-page-to-clarify-distinction-between-wordpress-org-and-wordpress-com?utm_source=rss&utm_medium=rss&utm_campaign=automattic-updates-press-page-to-clarify-distinction-between-wordpress-org-and-wordpress-com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6031:\"<p>Last week, Automattic&rsquo;s marketing team made a positive step towards curbing the perennial branding confusion between WordPress.org and WordPress.com. The company&rsquo;s <a href=\"https://automattic.com/press/\">press page</a> was updated with a notice to journalists who are writing about Automattic:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Automattic owns and operates&nbsp;<a href=\"https://wordpress.com/\">WordPress.com</a>, which is a hosted version of the open source WordPress software with added features for security, speed and support. Please append &ldquo;.com&rdquo; when referencing our product name.</p><p><a href=\"http://wordpress.org/\">WordPress</a>&nbsp;is open source software, which is written, maintained, and supported by thousands of independent contributors worldwide. Automattic is a major contributor to the WordPress open source project. If you would like to contribute to the WordPress open source project, learn more at&nbsp;<a href=\"https://make.wordpress.org/\">make.wordpress.org</a>.</p></blockquote>\n\n\n\n<p>This update was prompted by a recent <a href=\"https://www.linkedin.com/posts/caspar-hubinger_wordpress-activity-6688334765575176192-0-Eh\">conversation on LinkedIn</a> between Caspar H&uuml;binger, who works as a digital marketer at Human Made, and WordPress.com CMO Monica Ohara. H&uuml;binger had posted regarding an inaccuracy in a recent New York Times <a href=\"https://www.nytimes.com/2020/07/12/business/matt-mullenweg-automattic-corner-office.html\">article</a> featuring Matt Mullenweg as an evangelist for remote work at Automattic. The article, which has since been corrected, misattributed Automattic as the company that &ldquo;runs the digital publishing platform WordPress.&rdquo; </p>\n\n\n\n<p>These kinds of mistakes are quite frequent, yet understandable, in publications that are not as familiar with the WordPress ecosystem. Yet, these errors often evoke a strong reaction from the project&rsquo;s community whenever they pop up in the media. </p>\n\n\n\n<p>Ohara commented on H&uuml;binger&rsquo;s post and exchanged direct messages where he made a case for clarifying the branding on Automattic&rsquo;s website. Ohara was amenable and the notice appeared shortly after the exchange.</p>\n\n\n\n<p>Several years ago H&uuml;binger created a <a href=\"https://wpisnotwp.com/\">website</a> to clarify the confusion between WordPress, the open source project, and WordPress.com. Post Status also has a <a href=\"https://poststatus.com/resources/wordpress-versus-automattic/\">resource page</a> that explains the difference between WordPress.org and Automattic&rsquo;s products, but these kinds of external resources never seemed to make much of a difference. </p>\n\n\n\n<p>In 2018, H&uuml;binger prevailed upon the author of a TechCrunch article who referenced&nbsp;<a rel=\"noreferrer noopener\" target=\"_blank\" href=\"http://wordpress.com/\">WordPress.com</a>&nbsp;as &ldquo;WordPress&rdquo; and worked with her on getting the difference documented in TechCrunch&rsquo;s internal editorial guidelines. After he had explained the problem, she replied: &ldquo;We had no policy on this. We&rsquo;re going to change it to .com (or make references to Automattic as needed), and note in our style guide.&rdquo;</p>\n\n\n\n<p>When asked why he finds himself a champion of this particular cause, he said he often found himself angry when the name of the open source project he has dedicated most of his digital career to was confused with a commercial service built on top of it.</p>\n\n\n\n<p>&ldquo;It&rsquo;s a distortion of reality and I always felt sort of betrayed when it happened,&rdquo; H&uuml;binger said.</p>\n\n\n\n<p>&ldquo;I know that many of my community peers feel hurt to this day, even if some of them would probably shrug it off when asked. The word for it is resignation, and to me, it is poison to the human soul. From my perspective, Automattic&rsquo;s passiveness actively fed the narrative that they were profiting from the naming confusion, and that narrative &ndash; true or not &ndash; it keeps poisoning WordPress&rsquo; open source community.&rdquo;</p>\n\n\n\n<p>Although many times articles with errors confusing WordPress and .com were corrected afterwards, it can take a few days after the initial rush of traffic hits. </p>\n\n\n\n<p>&ldquo;So the message that &lsquo;Automattic runs/owns WordPress&rsquo; keeps being established for the public,&rdquo; H&uuml;binger contended when making his case to Ohara. &ldquo;Worse, the burden of flagging miscommunication when it happens and having it corrected in many cases is left to those who are harmed by it, i.e. open source contributors.&rdquo;</p>\n\n\n\n<p>For years people have speculated whether Automattic might rename WordPress.com to avoid the longstanding confusion. Many believe it will never happen, since the company undoubtedly benefits from tightly coupling its products to WordPress&rsquo; name recognition. Ohara declined to comment on whether any major branding changes are on the horizon.</p>\n\n\n\n<p>&ldquo;I will say that we&rsquo;re not trying to compete with the WordPress ecosystem,&rdquo; Ohara said. &ldquo;We want to help the overall ecosystem grow and I look forward to working closely with the community.&rdquo;</p>\n\n\n\n<p>This small yet important change to Automattic&rsquo;s press page is the direct result of H&uuml;binger&rsquo;s persistent advocacy effort. It may not eliminate all future media errors, but it is a positive development that demonstrates someone is listening.</p>\n\n\n\n<p>&ldquo;While a dedicated press page will not be able to prevent future confusion of WordPress and WordPress.com altogether (because it simply isn&rsquo;t possible), my hope is that it will be seen as a first practical step to help heal the relationship between Automattic and parts of WordPress&rsquo; open source community, which so many Automatticians have made such incredible amounts of contributions to ever since the company existed, and that is another thing that is too easy to forget,&rdquo; H&uuml;binger said.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 03 Aug 2020 17:35:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WordPress.org blog: The Month in WordPress: July 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8755\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://wordpress.org/news/2020/08/the-month-in-wordpress-july-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11541:\"<p>July was an action-packed month for the WordPress project. The month saw a lot of updates on one of the most anticipated releases &#8211; WordPress 5.5! WordCamp US 2020 was canceled and the WordPress community team started experimenting with different formats for engaging online events, in July. Read on to catch up with all the updates from the WordPress world.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordPress 5.5 Updates</h2>\n\n\n\n<p>July was full of WordPress 5.5 updates! The WordPress 5.5 <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-1\">Beta 1</a> came out on July 7, followed by <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-2/\">Beta 2</a> on July 14, <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-3/\">Beta 3</a> on July 21, and <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-4/\">Beta 4</a> on July 27. Subsequently, the team also published the first <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-release-candidate/\">release candidate</a> of WordPress 5.5 on July 28.&nbsp;</p>\n\n\n\n<p>WordPress 5.5, which is slated for release on <a href=\"https://make.wordpress.org/core/5-5/\">August 11, 2020</a>, is a major update with features like <a href=\"https://make.wordpress.org/core/tag/feature-autoupdates/\">automatic updates for plugins and themes</a>, a <a href=\"https://make.wordpress.org/plugins/2020/07/22/proposed-block-directory-guidelines/\">block directory</a>, <a href=\"https://make.wordpress.org/core/2020/06/10/merge-announcement-extensible-core-sitemaps/\">XML sitemaps</a>, <a href=\"https://make.wordpress.org/core/2020/07/16/block-patterns-in-wordpress-5-5/\">block patterns</a>, and <a href=\"https://make.wordpress.org/core/2020/07/14/lazy-loading-images-in-5-5/\">lazy-loading images</a>, among others. To learn more about the release, check out its <a href=\"https://make.wordpress.org/core/2020/07/30/wordpress-5-5-field-guide/\">field guide post</a>.</p>\n\n\n\n<p>Want to get involved in building WordPress Core? Follow<a href=\"https://make.wordpress.org/core/\"> the Core team blog</a>, and join the #core channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>Gutenberg 8.5 and 8.6</h2>\n\n\n\n<p>The core team launched Gutenberg <a href=\"https://make.wordpress.org/core/2020/07/08/whats-new-in-gutenberg-8-july/\">8.5</a> and <a href=\"https://make.wordpress.org/core/2020/07/22/whats-new-in-gutenberg-july-22/\">8.6</a>. Version 8.5 &#8211; the last plugin release will be included entirely (without experimental features) in WordPress 5.5, introduced improvements to block drag-and-drop and accessibility, easier updates for external images, and support for the block directory. Version 8.6 comes with features like Cover block video position controls and block pattern updates. For full details on the latest versions on these Gutenberg releases, visit these posts about <a href=\"https://make.wordpress.org/core/2020/07/08/whats-new-in-gutenberg-8-july/\">8.5</a> and <a href=\"https://make.wordpress.org/core/2020/07/22/whats-new-in-gutenberg-july-22/\">8.6</a>.</p>\n\n\n\n<p>Want to get involved in building Gutenberg? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, contribute to <a href=\"https://github.com/WordPress/gutenberg/\">Gutenberg on GitHub</a>, and join the #core-editor channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>Reimagining Online WordPress Events</h2>\n\n\n\n<p>The Community team made the difficult decision <a href=\"https://make.wordpress.org/community/2020/07/27/in-person-events-in-rest-of-year-2020/\">to suspend in-person WordPress events for the rest of 2020</a> in light of the COVID-19 pandemic. The team has also started working on <a href=\"https://make.wordpress.org/community/2020/07/13/reimagining-online-events/\">reimagining online events</a>. Based on <a href=\"https://make.wordpress.org/community/2020/07/13/reimagining-online-events/#comment-28505\">feedback from the community members</a>, the team decided to <a href=\"https://make.wordpress.org/community/2020/07/23/moving-forward-with-online-events/\">make changes to the current online WordCamp format</a>. Key changes include wrapping up financial support for A/V vendors, ending event swag support for newer online WordCamps, and suspending the Global Community Sponsorship program for 2020. The team encourages upcoming online WordCamps to experiment with their events to facilitate an effective learning experience for attendees while avoiding online event fatigue. The team is currently working on a proposal to organize community-supported <a href=\"https://make.wordpress.org/community/2020/07/23/building-community-beyond-events/\">recorded workshops and synchronous discussion groups</a> to help community members learn WordPress.<br /><br />Want to get involved with the Community team? <a href=\"https://make.wordpress.org/community/\">Follow the Community blog here</a>, or join them in the #community-events channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>. To organize a Meetup or WordCamp, <a href=\"https://make.wordpress.org/community/handbook/virtual-events/welcome/applying-for-a-virtual-event/\">visit the handbook page</a>.&nbsp;</p>\n\n\n\n<h2>WordCamp US 2020 is canceled</h2>\n\n\n\n<p>The organizers of WordCamp US 2020 have <a href=\"https://2020.us.wordcamp.org/2020/07/30/wcus-2020-an-update/\">canceled the event</a> in light of the continued pandemic and online event fatigue. The flagship event, which was originally scheduled for October 27-29 as an in-person event, had already planned to transition to an online event. Several WCUS Organizers will be working with the WordPress Community team to focus on other formats and ideas for online events, including a 24-hour contributor day, and contributing to the workshops initiative <a href=\"https://make.wordpress.org/community/2020/07/23/building-community-beyond-events/\">currently being discussed</a>. Matt Mullenweg’s State of the Word (which typically accompanies WordCamp US) is likely to take place in a different format later in 2020.</p>\n\n\n\n<h2>Plugin and theme updates are now available over zip files</h2>\n\n\n\n<p>After eleven years, WordPress now allows users to update plugins and themes by <a href=\"https://core.trac.wordpress.org/changeset/48390\">uploading a ZIP file, in WordPress 5.5</a>.&nbsp; The feature, which was merged on July 7, has been one of the most requested features in WordPress. Now, when a user tries to upload a plugin or theme zip file from the WordPress dashboard by clicking the “Install Now” button, WordPress will direct users to a new screen that compares the currently-installed extension with the uploaded versions. Users can then choose between continuing with the installation or canceling. WordPress 5.5 will also offer <a href=\"https://make.wordpress.org/core/tag/feature-autoupdates/\">automatic plugin and theme updates</a>.&nbsp;</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>Further Reading:</h2>\n\n\n\n<ul><li>The <a href=\"https://make.wordpress.org/plugins/2020/07/22/proposed-block-directory-guidelines/\">Block directory</a> is coming to WordPress with the 5.5 release. Plugin authors can now <a href=\"https://make.wordpress.org/plugins/2020/07/11/you-can-now-add-your-own-plugins-to-the-block-directory/\">submit their Block plugins to the directory</a>.</li><li>The Core team has opened up the <a href=\"https://make.wordpress.org/core/2020/07/31/wordpress-5-6-whats-on-your-wishlist/\">call for features</a> in the WordPress 5.6 release. You can <a href=\"https://make.wordpress.org/core/2020/07/31/wordpress-5-6-whats-on-your-wishlist/\">comment on the post</a> with features that you’d like to be included, current UX pain points, or maintenance tickets that need to be addressed. August 20 is the deadline for feature requests. </li><li>Editor features such as the new Navigation block, the navigation screen, and the widget screen that were originally <a href=\"https://make.wordpress.org/updates/2020/03/06/update-progress-on-goals/\">planned to be merged with WordPress 5.5</a> have been <a href=\"https://make.wordpress.org/core/2020/07/02/editor-features-for-wordpress-5-5-update/\">pushed for the next release</a>. </li><li>The Theme team is inviting proposals on whether to allow themes to <a href=\"https://make.wordpress.org/themes/2020/07/13/proposal-allow-themes-to-add-a-top-level-admin-menu/\">place an additional top-level menu link</a> in the admin.</li><li><a href=\"https://buddypress.org/2020/07/buddypress-6-2-0-beta/\">BuddyPress 6.2 beta </a>is out in the wild, and the team will soon release the stable version. The update includes changes that will make BuddyPress fully compatible with WordPress 5.5.</li><li>WordCamp EU 2021, which was being planned as an in-person event in Porto, Portugal, <a href=\"https://europe.wordcamp.org/2021/wordcamp-europe-2021-will-be-online/\">is moving online</a>. The team is considering an in-person WordCamp EU in 2022. </li><li>The Polyglots team has prepared and finalized a <a href=\"https://make.wordpress.org/polyglots/2020/07/09/translation-editor-locale-manager-vetting-criteria-page-draft/\">Translation Editor &amp; Locale Manager Vetting Criteria</a> to provide more clarity on how global mentors assign PTE/GTE/Locale Managers and to help locale teams set their own guidelines. The document, which was finalized <a href=\"https://make.wordpress.org/polyglots/2020/07/09/translation-editor-locale-manager-vetting-criteria-page-draft/\">after a lot of discussion</a>, is now available in the <a href=\"https://make.wordpress.org/polyglots/handbook/translating/expectations/translation-editor-locale-manager-vetting-criteria/\">Polyglots handbook</a>.</li><li>Members of the Community team <a href=\"https://make.wordpress.org/community/2020/07/03/proposal-recognition-for-event-volunteers-and-attendees-in-wordpress-org-profile/\">are discussing</a> whether WordCamp volunteers, WordCamp attendees, or Meetup attendees should be awarded a WordPress.org profile badge. The ongoing discussion will be open for comments until August 13.</li><li>The <a href=\"https://make.wordpress.org/core/tag/feature-notifications/\">WP Notify project</a>, which aims to create a better way to manage and deliver notifications to the relevant audience, is on to its next steps. The team has finalized the initial requirements, and is <a href=\"https://make.wordpress.org/core/2020/07/09/wp-notify-next-steps/\">kicking off the project build</a>.</li><li>The WordPress documentation team is <a rel=\"noreferrer noopener\" href=\"https://make.wordpress.org/docs/tag/external-linking-policy/\" target=\"_blank\">considering a ban on links to commercial websites</a> in a revision to its external linking policy. The policy change does not remove external links to commercial sites from WordPress.org and only applies to documentation sites. The idea is to protect documentation from being abused, and to prevent the WordPress project from being biased. Discussion on this post is still ongoing, and a decision has not yet been made. Feel free to<a href=\"https://make.wordpress.org/docs/tag/external-linking-policy/\"> comment on the discussion posts</a>, if you would like to share your thoughts on the topic. </li></ul>\n\n\n\n<p><em>Have a story that we should include in the next “Month in WordPress” post? Please </em><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><em>submit it here</em></a><em>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 03 Aug 2020 13:54:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Hari Shanker R\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Big Orange Heart Opens 2020 Remote Work Wellbeing and Mental Health Survey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102631\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:213:\"https://wptavern.com/big-orange-heart-opens-2020-remote-work-wellbeing-and-mental-health-survey?utm_source=rss&utm_medium=rss&utm_campaign=big-orange-heart-opens-2020-remote-work-wellbeing-and-mental-health-survey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3039:\"<p>A Big Orange Heart, formerly known as WP&amp;UP, has opened its 2020 <a href=\"https://www.bigorangeheart.org/survey-2020.html\">Remote Work Wellbeing and Mental Health Survey</a>. The charity organization focuses on supporting remote working communities with education and resources for mental and physical health. It is also home to a community of more than 4,700 members who support each other in growing their businesses and building new skills.</p>\n\n\n\n<p>The survey asks fairly broad questions about your mental health and the mental health support in your work environment. It takes approximately three minutes and is completely anonymous.</p>\n\n\n\n<img />\n\n\n\n<p>Results from the 2019 survey showed that the majority of people in the WordPress community work alone and a significant percentage are dealing with anxiety and suicidal thoughts:</p>\n\n\n\n<ul><li>8% of the WordPress community have had suicidal thoughts in the last 12 months</li><li>47% stated their workplace makes them feel anxious</li><li>56% of the WordPress community works alone</li></ul>\n\n\n\n<p>Big Orange Heart founder Dan Maby believes these results are helping his team save lives. The charity is actively creating and maintaining services and a peer support network that encourage people to stay connected to their community, in order to reduce the isolation they experience. </p>\n\n\n\n<p>&ldquo;Our 2019 results identified that almost 8% of all respondents had been dealing with sustained periods of feeling suicidal over the previous 12-months, twice the national US average,&rdquo; Maby said.&nbsp;&ldquo;This finding led to more training being provided in suicide prevention and support for our team, which enabled us to support multiple individuals that have contacted us requiring suicidal support, all of whom are still with us today.&rdquo;&nbsp;&nbsp;</p>\n\n\n\n<p>There are more people working alone remotely now than ever before due to the pandemic. Spend a short time on any social media network and you will likely hear several people say they are not doing okay. This survey helps the team at Big Orange Heart understand the extent of mental health related issues within the remote working community and informs various initiatives the organization plans throughout the year. </p>\n\n\n\n<p>&ldquo;As a charity, like so many others at this time, we have been heavily impacted by the COVID-19 global crisis,&rdquo; Maby said. &ldquo;Now more than ever we need to ensure our limited resources are used in the most effective way possible. Your anonymous data will allow us to best understand how we can help improve the lives of others within our community.&rdquo;</p>\n\n\n\n<p>The <a href=\"https://www.bigorangeheart.org/survey-2020.html\">Remote Work Wellbeing and Mental Health Survey</a> runs for one month and will close on August 31st. Take the survey and check out Big Orange Heart&rsquo;s <a href=\"https://www.bigorangeheart.org/blog/\">blog</a> for several helpful posts on how to maintain your mental health while working during this crisis.</p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 01 Aug 2020 03:04:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: WordPress 5.6 Wish List: Homepage Post Type Selection and Block Management\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102615\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:211:\"https://wptavern.com/wordpress-5-6-wish-list-homepage-post-type-selection-and-block-management?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-5-6-wish-list-homepage-post-type-selection-and-block-management\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4584:\"<p class=\"has-drop-cap\">With the WordPress 5.5 development cycle coming to a close, it is time to begin mapping out what features should land in WordPress 5.6 later this year. Earlier today, Chloe Bringmann <a href=\"https://make.wordpress.org/core/2020/07/31/wordpress-5-6-whats-on-your-wishlist/\">asked the community to chime in</a> with its wish list on the Make Core blog.</p>\n\n\n\n<p>As usual, I have a few thoughts. I tend to lean toward addressing some of the long-standing developer-friendly tickets because these features allow plugin authors to build better products for end-users in the long run.</p>\n\n\n\n<p>A complete <a href=\"https://wptavern.com/open-call-for-wordpress-5-5-tickets-whats-on-your-wish-list\">custom post status API</a> tops my usual list of most-wanted features. I have already opined over this for my WordPress 5.5 wish list. It may be time for more realistic dreams. Maybe we will revisit it another year or two down the road. However, if any core leads want to give the feature a green light, I will gladly be the evangelist and get others excited about it.</p>\n\n\n\n<h2>Homepage Post Type Selection</h2>\n\n\n\n<p class=\"has-drop-cap\">For this release, I want to call out one of my other years-long wishes. WordPress should allow end-users to select any custom post type for display on the homepage.</p>\n\n\n\n<p>Imagine a WordPress where users can head to their Reading Settings screen in the admin and select something other than their normal posts list or a page to appear on the homepage. <em>Have a forum plugin installed?</em> Maybe users want to list their latest topics or forums list. <em>Running an eCommerce plugin?</em> Users should be able to display their products. <em>Setting up a web design portfolio?</em> Display the most recent projects by simply selecting this choice in the admin.</p>\n\n\n\n<p>This is an area where the software has always catered to bloggers and has avoided throwing a little love to other types of sites.</p>\n\n\n\n<p>Currently, plugin authors must perform some crazy hacks to make this work. The WooCommerce <a href=\"https://github.com/woocommerce/woocommerce/blob/master/includes/class-wc-query.php\">custom query class</a> is enough to make any developer give up. Not all of the code in that file is for the front page, but it has a frustrating amount to make something work that should be far simpler for plugin authors.</p>\n\n\n\n<p>The reason this needs to be in core WordPress is so that each and every plugin does not need to roll a custom solution. Plugins should be able to flag their post types during registration as &ldquo;allowed on homepage&rdquo; &mdash; not all post types are meant for this type of display. Then, WordPress should handle all the dirty work behind the scenes if a particular post type is selected by the end-user. The addition to the API for plugin authors would be simple, and plugins that are already hacking this feature together can drop a lot of unnecessary code.</p>\n\n\n\n<p>There is an existing <a href=\"https://core.trac.wordpress.org/ticket/19958\">8-year-old ticket</a> for the feature. It has a few old and likely outdated patches and has not seen any real activity in the past four years. Nevertheless, it would be nice to see this feature in core WordPress and finally close the ticket.</p>\n\n\n\n<h2>Block System Wish List</h2>\n\n\n\n<p class=\"has-drop-cap\">Like most releases, the block system will be getting the most attention. The things that will land in WordPress 5.6 are mostly already set in stone, assuming a particular feature does not fall behind in development like widgets and nav menus did for the 5.5 release.</p>\n\n\n\n<p>On the whole, I like the general direction the block system has been headed. If anything, I have been impatient with some things, such as awaiting the integrated <a href=\"https://wptavern.com/version-1-prototype-of-the-wordpress-admin-block-directory-announced\">block management screen</a> in the admin. For other features, such as full-site editing, I am still wondering whether they are realistic goals for the WordPress 5.6 release.</p>\n\n\n\n<p>I would take a release and focus on tightening up and polishing the existing system. Take stock of the pain points &mdash; and there are many &mdash; that users are mentioning. Spend time working on smoothing out the editing experience before tacking on new features.</p>\n\n\n\n<p>That is not going to happen. New features are what get developers up in the morning and excited about the project. Therefore, my fallback request is to bring on the block management screen.</p>\n\n\n\n<p>What&rsquo;s on your wish list?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jul 2020 21:15:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: WordCamp US 2020 Canceled Due to Pandemic Stress and Online Event Fatigue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102579\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:211:\"https://wptavern.com/wordcamp-us-2020-canceled-due-to-pandemic-stress-and-online-event-fatigue?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-us-2020-canceled-due-to-pandemic-stress-and-online-event-fatigue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7146:\"<p><a href=\"https://2020.us.wordcamp.org/\">WordCamp US 2020</a>, which was originally scheduled for October 27-29, was officially canceled today. In April, organizers <a href=\"https://wptavern.com/wordcamp-us-2020-goes-online-cancels-in-person-event\">transitioned to planning for it to be held as a virtual event</a>, but the tenuous situation with the pandemic in the United States and the stress on the event&rsquo;s large crew of volunteers has precipitated a full cancellation. The decision was announced on the WCUS website:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>It is with heavy hearts that we have made the decision to cancel this year&rsquo;s WordCamp US event. In light of the continued pandemic, online event fatigue for attendees, organizers, and volunteers, and the desire for WordCamp experiences to be&nbsp;<em>traditional</em>&nbsp;WordCamp experiences, we have made the difficult decision to stop this year&rsquo;s planning, and cancel WordCamp US 2020.</p></blockquote>\n\n\n\n<p>After the pandemic started forcing WordCamps and meetups to go online, many community team members seemed to put on a brave face about adapting WordCamps to virtual events, but WCUS organizers are publicly recognizing the reality of online event fatigue. </p>\n\n\n\n<p>Angela Jin, one of the lead organizers, said her team discussed how recent online WordCamps have struggled to meet traditional goals of connecting people and encouraging contribution. In light of attendees&rsquo; increasing online conference fatigue, WCUS organizers considered the cost of volunteers&rsquo; time.</p>\n\n\n\n<p>&ldquo;The Lead Organizers also took into consideration how many volunteers we have on this team, and how much time we were asking them to invest in an event that didn&rsquo;t seem to be able to offer the same level of joy or satisfaction that an in-person WordCamp would,<strong>&ldquo;</strong> Jin said.</p>\n\n\n\n<p>&ldquo;As you might imagine, this was a very upsetting realization, but the whole team spent time discussing together, and we believe that we made the right decision.&rdquo;&nbsp;</p>\n\n\n\n<p>The U.S. passed more than 150,000 Coronavirus deaths this week and outbreaks are worsening right as schools are supposed to be opening. As COVID-19 cases continue to rise sharply in many states, renewed lockdowns and political tensions have put people on edge. Every day brings a fresh injection of bad news and the country is deeply mired in division ahead of one of the most contentious presidential elections in history. Late October is not an ideal time to try to host WordPress&rsquo; flagship WordCamp online. </p>\n\n\n\n<p>One WCUS organizer, who requested to remain anonymous, said he was angry that he invested more than 100 hours across various organizing teams and wished it had come sooner. He described how multiple personal stressors were impacting daily life and draining the team&rsquo;s energy.</p>\n\n\n\n<p>&ldquo;I feel everyone is tired and worn out,&rdquo; he said. &ldquo;They are stressed &ndash; we are all losing friends [to COVID-19]. Everyone is fighting about politics and the work suffered.&rdquo; </p>\n\n\n\n<p>He reported that many organizers were not doing their parts and all tasks were delayed. Although he experienced a high level of frustration with how it was handled, he was relieved when the decision was announced. Many of the event&rsquo;s 50 organizers are also involved in coordinating local meetups and leading other WordCamps, and their energies are spread thin.</p>\n\n\n\n<p>&ldquo;This will pave the way for something new and better,&rdquo; he said. &ldquo;We have to evolve as a community and one more zoom meeting is not it.&rdquo;</p>\n\n\n\n<p>Not all organizers considered the time invested as a loss. Cate DeRosia, who has also helped organize WordCamp Grand Rapids in the past, said the lead WCUS organizers consulted with the entire team through a multi-step process and gave opportunities for their opinions to be heard.</p>\n\n\n\n<p>&ldquo;It&rsquo;s easy to imagine that as an organizer I&rsquo;d be disappointed by this decision, but that couldn&rsquo;t be further from the truth,&rdquo; Cate DeRosia said. &ldquo;None of this is what I&rsquo;d hoped for, but the time I&rsquo;ve invested in WCUS has helped me grow relationships and learn new skills that ultimately help me further my career goals and make me a better volunteer in the future. </p>\n\n\n\n<p>&ldquo;COVID-19 has been unpredictable and made everything about life harder. By making this difficult decision now, we all get back a little of our time to invest in other areas instead of using up more energy and risking volunteer burnout for an event that ran the risk of getting lost amid other online events.&rdquo; </p>\n\n\n\n<h2>State of the Word May be Hosted as a Separate, Focused Event</h2>\n\n\n\n<p>WCUS is encouraging speakers to apply again next year. Although all regular sessions on the program were canceled, some organizers will be shifting their focus to hosting a 24-hour contributor day along with producing some workshops and youth programming content.</p>\n\n\n\n<p>Matt Mullenweg&rsquo;s annual State of the Word address is also expected to happen but will likely take a different format this year.</p>\n\n\n\n<p>&ldquo;Discussions about the State of the Word are still active; our understanding is that it will still happen, but possibly not in association with any other event,&rdquo; Jin said. </p>\n\n\n\n<p>&ldquo;I&rsquo;m really excited about the potential for lots of smaller, focused, and educational ways for the community to connect online this year,&rdquo; Matt Mullenweg said. &ldquo;For the State of the Word I don&rsquo;t have a plan yet, I think there&rsquo;s less value to us watching the same thing at the same time if we can&rsquo;t hang out afterward, but it still would be fun to celebrate the great progress we&rsquo;ve been making with some sort of video. Stay tuned November-ish.&rdquo;</p>\n\n\n\n<p>Cancellation costs for WCUS are still being finalized. Prior to making it a virtual event, the original budget was close to $1 million, with the largest costs being the venue and catering. Jin said the team will publish a full accounting of expenses on the Community Team blog or the event site after the last round of discussions with vendors are complete.</p>\n\n\n\n<p>It&rsquo;s too soon to know if the WordCamp will be an in-person event in 2021. When asked if they will be hosting in St. Louis again, Jin said that any decisions regarding WCUS 2021 are paused for now.</p>\n\n\n\n<p>&ldquo;The WCUS team did invest a lot of time and energy into this event, but in a year when it is incredibly hard to plan anything, we did the best we could and adapted quickly,&rdquo; she said. &ldquo;I&rsquo;m sad, of course, as I miss seeing everyone at WordCamps, but even if it was time and energy invested in something that didn&rsquo;t happen, I spent time doing it with brilliant people who care just as much about WordPress as I do. It&rsquo;s been an immensely challenging year, and I&rsquo;m humbled to have been a part of this team, which has consistently supported each other and grown together in the face of adversity.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jul 2020 01:04:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: Post a Lot of Code? Try the Code Syntax Block Plugin for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102574\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"https://wptavern.com/post-a-lot-of-code-try-the-code-syntax-block-plugin-for-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=post-a-lot-of-code-try-the-code-syntax-block-plugin-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2934:\"<p class=\"has-drop-cap\">I am always on the lookout for interesting syntax-highlighting plugins, particularly for those occasions when I write tutorials or other articles that lean heavily on code. Far too many plugins use shortcodes, custom blocks, or other odd solutions. However, there is one option that I intentionally overlooked when it was released over a year ago: <a href=\"https://wordpress.org/plugins/code-syntax-block/\">Code Syntax Block</a> by Marcus Kazmierczak.</p>\n\n\n\n<p>Based on the name, I assumed it was yet another standalone block. However, I have since given it another look and realized that this was note the case. It integrates directly with the core WordPress block. There are times when a new block is necessary, but this is not one of those times. Sometimes it is better to extend the existing blocks in core.</p>\n\n\n\n<p>Code Syntax Block uses the <a href=\"https://prismjs.com/\">Prism JavaScript library</a> to add syntax highlighting on the front end of the site. The plugin is designed well. It loads its scripts and styles only when the code block is in use.</p>\n\n\n\n<img />Front end PHP code example.\n\n\n\n<p>The plugin does not load Prism in the editor, so the code output will use the default editor or theme styling. This may not appeal to those who want a one-to-one match between the back and front end.  I am comfortable with  the non-highlighted version in the admin while having the <em>pretty</em> output on the front end.  However, it would be nice to see an option or filter to enable highlighting in the editor.</p>\n\n\n\n<p>Out of the box, the plugin uses the <a href=\"https://github.com/AGMStudio/prism-theme-one-dark\">One Dark</a> theme, which was created for the Atom editor and ported to Prism. Developers can overwrite the theme with either a custom <code>assets/prism/prism.css</code> file in their theme or by filtering the path or URL that gets loaded.  The Prism project has a <a href=\"https://github.com/PrismJS/prism-themes\">variety of themes</a> available that are plug-and-play.  Other themes exist outside of the official list too.</p>\n\n\n\n<p>On the admin side, the plugin creates a new &ldquo;Settings&rdquo; tab for the code block and adds a few options that users can choose from:</p>\n\n\n\n<ul><li>Language</li><li>Show line numbers</li><li>Title for code block</li></ul>\n\n\n\n<img />Editor view of Code Syntax Highlighter\n\n\n\n<p>By default, the plugin does not support the full list of over 200 languages. Instead, it lists just over 40 of the most popular. The list is filterable, so anyone can add or remove languages with a few lines of code. There is also a filter hook for setting the default languages, which would be particularly useful for those who routinely post code snippets in the same coding language.</p>\n\n\n\n<p>After a few days of testing, I can safely say that Code Syntax Block is being added to my WordPress toolbox. I wish I had only given it a shot much sooner.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jul 2020 17:30:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: Bing Launches URL Submissions Plugin for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102450\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:165:\"https://wptavern.com/bing-launches-url-submissions-plugin-for-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=bing-launches-url-submissions-plugin-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5150:\"<p>Bing has <a href=\"https://blogs.bing.com/webmaster/july-2020/Get-your-WordPress-content-indexed-immediately-using-Bing-Webmaster-Tools-plugin\">launched</a> its first official <a href=\"https://wordpress.org/plugins/bing-webmaster-tools/\">plugin</a> for WordPress aimed at helping site owners get their content indexed immediately. Instead of waiting for a bingbot to crawl the site, the plugin notifies Bing of any new or updated content automatically using its <a href=\"https://www.bing.com/webmasters/url-submission-api\">Submit URL API</a>.</p>\n\n\n\n<p>&ldquo;Bing&nbsp;believes that the future for search engines is less about crawling to discover content and more about sharing new and updated content across the web, a fundamental shift in the way that search engines handle web sites,&rdquo; Bing Product Manager Fabrice Canel said. &ldquo;Instead of monitoring RSS, sitemaps and HTML pages to check for new pages, discover content changes and/or new outbound links, websites will notify search engines directly about relevant URLs changing on their website.&rdquo;</p>\n\n\n\n<p>Search engines can take anywhere from several hours to a few weeks to <a href=\"https://support.google.com/webmasters/answer/6065812?hl=en\">crawl a website</a>. Bing&rsquo;s API allows site owners to get content indexed immediately, while eventually reducing the crawling frequency for sites where there are no changes. Users will need to <a href=\"https://docs.microsoft.com/en-us/bingwebmaster/getting-access#using-api-key\">generate an API key</a> in order to configure the plugin for access to the Bing Webmaster Tools API.</p>\n\n\n\n<img />\n\n\n\n<p><br />The new plugin also introduces a few other options for managing URL submissions:</p>\n\n\n\n<ul><li>Toggle the automatic submission feature</li><li>Manually submit a URL to Bing Index</li><li>View list of recent URL submissions from the plugin</li><li>Retry any failed submissions from the recent submissions list</li><li>Download recent URL submissions for analysis</li></ul>\n\n\n\n<p>Canel said the Bing Webmaster Team recommends using the new URL Submissions plugin as a complement to existing plugins that connect sites to Bing, such as <a href=\"https://jetpack.com/support/site-verification-tools/\">Jetpack&rsquo;s site verification tool</a>, and <a href=\"https://wordpress.org/plugins/search/SEO/\">SEO plugins</a> that add XML sitemaps. Bing&rsquo;s plugin is different in that it focuses on enabling Bing to discover immediate changes on WordPress sites.</p>\n\n\n\n<p>&ldquo;Sitemaps are a great complementary solution to our plugin to discover all URLs on WordPress sites, but we cannot monitor each sitemap all the time,&rdquo; Canel said. &ldquo;Only a small percentage of WordPress sites are publishing content every day. Most are nearly static and this is preferable to be notified instead of pulling content every so often for them. Same for sites publishing often, it helps to get the content quickly indexed instead of having to wait a long time.&rdquo;</p>\n\n\n\n<p>Bing doesn&rsquo;t usually get as much airtime as Google and its supporting tools, since Google continues to dominate the search market. Bing&rsquo;s market share is currently <a href=\"https://gs.statcounter.com/search-engine-market-share/\">hovering at 2.75%</a> of searches globally on all platforms as of June 2020. </p>\n\n\n\n<div id=\"all-search_engine-ww-monthly-201906-202006\" width=\"600\" height=\"400\"></div><!-- You may change the values of width and height above to resize the chart --><p>Source: <a href=\"https://gs.statcounter.com/search-engine-market-share\">StatCounter Global Stats &ndash; Search Engine Market Share</a></p>\n\n\n\n<p>The search engine has seen slow but steady growth in certain regions and platforms. Bing performs higher globally across desktop searches (6.08%).  In the United Sates, Bing&rsquo;s market share is sitting at 6.99% and is even higher on US desktop searches (13.35%):</p>\n\n\n\n<table><tbody><tr><th>Google</th><td>87.71%</td></tr><tr><th>bing</th><td>6.99%</td></tr><tr><th>Yahoo!</th><td>3.44%</td></tr></tbody></table><a href=\"https://gs.statcounter.com/search-engine-market-share/\">Search Engine Market Share in US &ndash; June 2020</a>\n\n\n\n<p>Bing may not boast a big slice of the search market pie, but the search engine served close to <a href=\"https://www.statista.com/statistics/752270/range-of-bingcom-based-on-unique-visitors/\">936.5 million</a> unique global visitors during the month of May 2020. More than half of Bing users have a bachelor&rsquo;s or post graduate degree and <a href=\"https://www.statista.com/statistics/742834/usa-bing-audience-share-by-income/\">38% of Bing users</a> have an income of $100,000 USD or higher. Depending on the demographic you are targeting, being found by Bing users may be one small factor in your site&rsquo;s overall success. </p>\n\n\n\n<p>The search engine recently updated its <a href=\"https://www.bing.com/webmaster/help/webmaster-guidelines-30fba23a\">webmaster guidelines</a> for the first time since 2012. If you&rsquo;re looking to optimize for Bing&rsquo;s audience, this document contains a detailed break down of how the search engine ranks content. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2020 23:49:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: Upcoming in WordPress 5.5: Features and Changes Theme Authors Should Know About\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102535\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:221:\"https://wptavern.com/upcoming-in-wordpress-5-5-features-and-changes-theme-authors-should-know-about?utm_source=rss&utm_medium=rss&utm_campaign=upcoming-in-wordpress-5-5-features-and-changes-theme-authors-should-know-about\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8147:\"<p class=\"has-drop-cap\">August 11, the target release date for WordPress 5.5, is just shy of two weeks away. For developers who have not been completely on top of the upcoming release, now is a good time to start looking at how changes might affect their projects. Theme authors in particular can expect several new features and some breaking changes.</p>\n\n\n\n<p>For the most part, WordPress 5.5 will introduce new features that theme developers can begin to add to their themes. However, the two biggest changes that could negatively impact their themes will be automatic updates and direct HTML changes to the custom logo output.</p>\n\n\n\n<p>Outside of the new features and changes, theme authors should catch up on our <a href=\"https://wptavern.com/tag/gutenberg\">coverage of the Gutenberg plugin</a> and test against its updates that are being merged into core WordPress.</p>\n\n\n\n<h2>Auto Updates</h2>\n\n\n\n<p class=\"has-drop-cap\">WordPress 5.5 will finally introduce <a href=\"https://wptavern.com/automatic-theme-and-plugin-updates-slated-for-wordpress-5-5\">automatic updates for plugins and themes.</a> It is a long-awaited feature and should be a good thing in terms of keeping end-users updated and running what is usually the most secure version of their extensions. However, the big downside to automatic updates is that most themes and plugins will not have the same level of quality control as core WordPress receives. Even the best development companies might have only a few people looking over the code.</p>\n\n\n\n<p>On the flip-side, the automatic updates feature means that theme authors can push fixes out to end-users much more quickly.</p>\n\n\n\n<p>The big thing is that theme developers need to be aware that users will be enabling automatic updates. For some, this might not mean changing anything with their release cycles. For others, it might mean tacking on some extra time to ensure that extra quality control is in place. The success of automatic updates lies directly on the shoulders of the plugin and theme authors. It is a huge responsibility that should not be taken lightly. WordPress is placing a lot of trust in its development community to get this right.</p>\n\n\n\n<h2>HTML Change for Custom Logos</h2>\n\n\n\n<p class=\"has-drop-cap\">As part of an <a href=\"https://core.trac.wordpress.org/ticket/37011\">accessibility-related ticket</a> for WordPress 5.5, the core <code>get_custom_logo()</code> and <code>the_custom_logo()</code> functions will no longer <a href=\"https://make.wordpress.org/core/2020/07/28/themes-changes-related-to-get_custom_logo-in-wordpress-5-5/\">output a link around the logo image</a> when viewing the site homepage. This change was made because the link itself points to the homepage by default and is unnecessary in that context.</p>\n\n\n\n<p>Right now, there are 183 themes in the official theme directory that target the link in their CSS. This does not necessarily mean that all 183 themes will be broken upon update. However, it likely means that some of them will need a tweak or two.</p>\n\n\n\n<p>Theme authors are encouraged to target the <code>.custom-logo-link</code> class instead of any particular HTML element. The new change will add a <code>&lt;span&gt;</code> element rather than an <code>&lt;a&gt;</code> element on the homepage. Both will use the same class.</p>\n\n\n\n<h2>Block Patterns Have Arrived</h2>\n\n\n\n<p class=\"has-drop-cap\">It is no secret that I am <a href=\"https://wptavern.com/block-patterns-will-change-everything\">downright giddy</a> about the prospect of theme designers being loosed upon the world, allowing their talents to shine via block patterns.  Patterns have been one of the missing features since the initial launch of the Gutenberg project. For theme authors, they represent that missing link between designing unique &ldquo;templates&rdquo; or &ldquo;sections&rdquo; and providing end-users a means to add them to their sites.</p>\n\n\n\n<p>Block patterns are essentially groups of pre-configured blocks that users can insert into their posts or pages at the click of a button. The beauty of the system is that theme authors can design whatever patterns their hearts desire and make them easily available to their users. No need for complicated theme settings. No lengthy tutorials explaining how to recreate the demo. Design something in the block editor. Register it as a pattern. Let users insert it into a post and rejoice.</p>\n\n\n\n<p>This is an opportunity that theme authors have never had before. It is an opportunity to create beautiful designs without having to worry about overcomplicating it for the average user. It is a pivotal moment in WordPress theme design history. Theme authors have the chance to push the system and see what WordPress and its block editor are truly capable of.</p>\n\n\n\n<p><em>Building a restaurant theme?</em> Provide users with multiple food menu patterns. <em>Creating something for novelists or other book authors?</em> Give users some layout options for showcasing their books.</p>\n\n\n\n<p>The <a href=\"https://developer.wordpress.org/block-editor/developers/block-api/block-patterns/\">block patterns API</a> removes many prior limits to what theme authors could realistically do. Now, it&rsquo;s time for those theme authors to take charge.</p>\n\n\n\n<h2>Line Heights and Custom Units</h2>\n\n\n\n<p class=\"has-drop-cap\">The block editor has two new tools for end-users to take advantage of: <a href=\"https://make.wordpress.org/core/2020/07/27/new-block-tools-on-wordpress-5-5/\">custom line-heights and custom units</a>. Theme authors can opt into allowing users to edit the line-height of paragraphs and headings with the <code>custom-line-heights</code> theme support flag. They can also allow users to switch between various units, such as when defining the Cover block&rsquo;s height, with the <code>custom-units</code> flag. In addition to pixels, themes can define which units are supported.</p>\n\n\n\n<p>Allowing users to customize the line-height value for text can be tricky business. There are some situations where it is warranted. However, for theme authors who prefer to maintain a strict vertical rhythm, this could lead to disaster. This will likely come down to a personal choice for developers based on what type of theme they are building.</p>\n\n\n\n<h2>Accessible Widgets Navigation</h2>\n\n\n\n<p class=\"has-drop-cap\">Starting with WordPress 5.5, theme authors will be able to opt into outputting more <a href=\"https://make.wordpress.org/core/2020/07/09/accessibility-improvements-to-widgets-outputting-lists-of-links-in-5-5/\">accessible widgets</a>. By default, widgets that display unordered lists do so without any context. This can make it difficult for those using assistive technologies to navigate the site.</p>\n\n\n\n<p>Theme authors can now add <code>navigation-widgets</code> to the HTML5 theme supports array to add the new markup. WordPress will then wrap all core widgets with a <code>&lt;nav&gt;</code> element and an <code>aria-label</code> based on the widget title.</p>\n\n\n\n<p>This will not affect widgets from third-party plugins. Plugin authors should reevaluate their widgets to determine if they want to support this feature.</p>\n\n\n\n<h2>Template Functions Updates</h2>\n\n\n\n<p class=\"has-drop-cap\">WordPress is tacking on some nice features for its templating functions in the upcoming release. The first major change is that theme authors can pass data to template files. We have <a href=\"https://wptavern.com/theme-authors-can-pass-data-to-template-files-in-wordpress-5-5\">previously covered</a> this story on the Tavern. This feature, while years late, should still be useful for more complex theming setups and allow developers to bypass odd workarounds or in-house solutions.</p>\n\n\n\n<p>Template-loading functions, such as <code>get_template_part()</code> and others, will also <a href=\"https://core.trac.wordpress.org/ticket/40969\">return a value</a> in WordPress 5.5. If the template is not found, the function will return a <code>false</code> value. Otherwise, it will return <code>void</code>. This will be helpful in situations where theme authors need to run a conditional to check if a template exists.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2020 22:05:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WPTavern: Gutenberg 8.6 Adds Cover Block Video Positioning and Updates Block Patterns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102512\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:215:\"https://wptavern.com/gutenberg-8-6-adds-cover-block-video-positioning-and-updates-block-patterns?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-8-6-adds-cover-block-video-positioning-and-updates-block-patterns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4671:\"<p class=\"has-drop-cap\">Gutenberg 8.6 <a href=\"https://make.wordpress.org/core/2020/07/22/whats-new-in-gutenberg-july-22/\">landed quietly last week</a>. Much of the focus right now is ironing out the remaining bugs for WordPress 5.5 during its beta cycle. However, that does not mean the Gutenberg project has come to a complete halt in terms of new features. The team is marching forward with extra goodies for those who use the plugin.</p>\n\n\n\n<p>The latest update of the plugin did not cover as much ground as normal, but it does include an enhancement for the Cover block when using a video background and several updates to block patterns.</p>\n\n\n\n<p>The primary focus for version 8.6 was squashing bugs. The development team addressed over three dozen of them while correcting a handful of performance issues. While new features and enhancements from 8.6 onward are not expected in the upcoming WordPress 5.5, most bug fixes should be included.</p>\n\n\n\n<h2>Focal Point Selector for Video Covers</h2>\n\n\n\n<img />Selecting a focal point for a video background.\n\n\n\n<p class=\"has-drop-cap\">The Cover block has long allowed users to pick a focal point for background images. However, this feature was missing when users added a background video to the block. As of version 8.6, that is no longer the case. Both image and video backgrounds should work in much the same way.</p>\n\n\n\n<p>Gutenberg now has a new &ldquo;<a href=\"https://github.com/WordPress/gutenberg/pull/22531\">Focal point picker</a>&rdquo; option located under the &ldquo;Media settings&rdquo; tab when adding a video background. Users can select the focal point by dragging the circle icon in the video box or hardcode left and top percentage values in the input fields below it.</p>\n\n\n\n<p>This is not a particularly exciting development for most Gutenberg users.  Self-hosting video is not cheap and remains unused for most. However, for those who do use video backgrounds, it is one of those nice-to-have features that is there when needed.</p>\n\n\n\n<h2>Updated Block Patterns</h2>\n\n\n\n<img />Inserting the updated quote block pattern.\n\n\n\n<p class=\"has-drop-cap\">The Gutenberg team updated several of the existing block patterns. For the most part, the pattern updates were minor cosmetic changes, tweaks that improve the overall design. The button-related patterns received simple changes, such as new <a href=\"https://github.com/WordPress/gutenberg/pull/23848\">text labels</a> and <a href=\"https://github.com/WordPress/gutenberg/pull/23849\">colors</a>. The developers also changed the colors and text of the large header patterns.</p>\n\n\n\n<p>The team moved the header above the columns in the <a href=\"https://github.com/WordPress/gutenberg/pull/23853\">two columns text pattern</a> and changed the text to make the columns appear equal height by default. It is a poor use of textual columns, which would ideally be handled with CSS instead so that it works appropriately across screen sizes. Perhaps it would be better to have a &ldquo;Text Columns&rdquo; block in the long run.</p>\n\n\n\n<p>The nicest block pattern update was for the <a href=\"https://github.com/WordPress/gutenberg/pull/23881\">quote pattern</a>. It now has an image at the top and a separator at the bottom. It is akin to a single testimonial, which is more of a <em>pattern</em> than a basic quote.</p>\n\n\n\n<p>Theme authors can also <a href=\"https://github.com/WordPress/gutenberg/pull/24042\">remove support</a> for the core block patterns with a single line of code: <code>remove_theme_support( \'core-block-patterns\' )</code>. This does not drop support for patterns altogether. For example, patterns added by plugins or the theme will still appear in the inserter.</p>\n\n\n\n<h2>Site Icon Used in Fullscreen Mode</h2>\n\n\n\n<img />Site icon appears in top left in fullscreen mode.\n\n\n\n<p class=\"has-drop-cap\">When writing in fullscreen mode, the &ldquo;back to posts&rdquo; link has utilized the WordPress logo in the past. In version 8.6, the user&rsquo;s custom <a href=\"https://github.com/WordPress/gutenberg/pull/22952\">site icon will take its place</a>. However, this will only happen if the user has uploaded an icon via the customizer.</p>\n\n\n\n<p>I am unsure how I feel about this change. In practice, it almost feels like clicking the icon should take me to the front end of the site instead of the post management screen. At least with the WordPress icon, it felt like it was pointing toward an admin-side screen instead. For my workflow, I would rather see this link/icon replaced with a button that toggles between fullscreen and normal mode, popping the admin menu back into place rather than departing the editing screen altogether.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jul 2020 20:59:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WordPress.org blog: WordPress 5.5 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8732\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2020/07/wordpress-5-5-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2968:\"<p>The first release candidate for WordPress 5.5 is now available!</p>\n\n\n\n<p>This is an important milestone in the community&#8217;s progress toward the final release of WordPress 5.5. </p>\n\n\n\n<p>“Release Candidate” means that the new version is ready for release, but with millions of users and thousands of plugins and themes, it’s possible something was missed. WordPress 5.5 is slated for release&nbsp;on&nbsp;<strong>August 11, 2020</strong>, but we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.5 yet,&nbsp;<strong>now is the time</strong>!</p>\n\n\n\n<p>You can test the WordPress 5.5 release candidate in two ways:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.5-RC1.zip\">download the release candidate here (zip)</a>.</li></ul>\n\n\n\n<p>Thank you to all of the contributors who tested the&nbsp;Beta releases and gave feedback. Testing for bugs is a critical part of polishing every release and a great way to contribute to WordPress.</p>\n\n\n\n<h2>What’s in WordPress 5.5?</h2>\n\n\n\n<p>WordPress 5.5 has lots of refinements to polish the developer experience. To keep up, subscribe to the&nbsp;<a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a>&nbsp;and pay special attention to the&nbsp;<a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">developer notes</a>&nbsp;tag for updates on those and other changes that could affect your products.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.5 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme file to 5.5. If you find compatibility problems, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>,&nbsp;so those can be figured out before the final release.</p>\n\n\n\n<p>The&nbsp;WordPress 5.5 Field Guide, due very shortly, will give you a more detailed dive into the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a>&nbsp;This release also marks the <a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\">hard string freeze</a>&nbsp;point of the 5.5 release schedule.</p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">fill one on WordPress Trac</a>, where you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jul 2020 19:08:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Jb Audras\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: WordPress to Stick with Online-Only Meetups and WordCamps for Remainder of 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102462\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:223:\"https://wptavern.com/wordpress-to-stick-with-online-only-meetups-and-wordcamps-for-remainder-of-2020?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-to-stick-with-online-only-meetups-and-wordcamps-for-remainder-of-2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6256:\"<img />photo credit: <a href=\"https://stocksnap.io/photo/macbook-computer-JPZDGEMDH3\">Burst</a>\n\n\n\n<p>The WordPress Community Team has officially updated its guidelines for WordCamps to be online-only events for the remainder of 2020. The six WordCamps on the <a href=\"https://central.wordcamp.org/schedule/\">schedule</a> through the end of the year were already planning on using an online format but the guidelines also include local <a href=\"https://make.wordpress.org/community/events/online/\">meetups</a>. </p>\n\n\n\n<p>&ldquo;The team acknowledges that this is not easy for the community that has been heavily based on in-person events and encounters,&rdquo; Timi Wahalahti said in the <a href=\"https://make.wordpress.org/community/2020/07/27/in-person-events-in-rest-of-year-2020/\">announcement</a>. &ldquo;Unfortunately, the global coronavirus situation does not seem to be slowing down to a level that would allow us organizing in-person events safely at this time.&rdquo;</p>\n\n\n\n<p>The guidelines will be re-evaluated in the first quarter of 2021, but some organizers are already planning for online events next year. WordCamp Europe 2021 is the first WordPress event to <a href=\"https://wptavern.com/wordcamp-europe-goes-virtual-for-2021-in-person-conference-to-resume-2022\">go virtual for the coming year</a>, with the in-person event resuming in 2022.</p>\n\n\n\n<p>Moving what was once a vibrant in-person gathering to a two-dimensional online format is a challenging endeavor, especially when the world is suddenly awash in online events competing for attention. Making virtual events stand out from the crowd is a new marketing challenge. </p>\n\n\n\n<p>There is something about the magic of WordCamps that gives momentum to ideas and collaboration. While you cannot replicate the chance meetings in the hallway and the priceless conversations over long dinners, online events have the benefit of being more geographically inclusive. The constraints of the pandemic are also challenging our assumptions about how online gatherings are supposed to work.</p>\n\n\n\n<h2>WordPress Community Team to Explore New Event Formats, Redefine Relationships with Sponsors, Temporarily Cancel Swag Spending</h2>\n\n\n\n<p>The necessity for virtual events has inspired discussion around some new event formats, including a new <a href=\"https://make.wordpress.org/community/2020/07/23/building-community-beyond-events/\">proposal</a> that decouples online events from geography. WordPress Community manager Hugh Lashbrooke described how events might explore combining synchronous discussions with previously recorded workshops:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>What if we blended those two elements into a program that provides the flexibility of online content, with the value and sense of community that comes with learning together?</p><p>We could publish workshops in a central location (on&nbsp;<code>wordpress.org</code>, for better visibility and reach) and then invite learners to join live discussion groups that cater to different timezones. This &ldquo;<a href=\"https://en.wikipedia.org/wiki/Flipped_classroom\">flipped classroom</a>&rdquo; model allows people to learn at their convenience, and then come together for additional development.&nbsp;</p></blockquote>\n\n\n\n<p>Lashbrooke suggested the workshops could be designed by people who would otherwise be speaking WordCamps and could possibly source content from WordPress.tv or talks that have been given at online meetups.</p>\n\n\n\n<p>&ldquo;There is also potential for longer courses, composed of multiple workshops, and a group that meets repeatedly over time,&rdquo; Lashbrooke said.</p>\n\n\n\n<p>So far the suggestions in  the comments include introductory workshops for WordPress. These would be timely for newcomers who have recently lost work and are looking to improve their online resumes or portfolios, or start up a new business. Beginner workshops have strong outreach potential if promoted outside of the WordPress community.</p>\n\n\n\n<p>During the first half of the year, the Community Team began transitioning to facilitating the needs of online events and have continued to work tirelessly to find ways for people to connect. In a recent <a href=\"https://make.wordpress.org/community/2020/07/23/moving-forward-with-online-events/\">update</a>, WordPress community organizer Andrea Middleton explained that changes are coming for future online events, which may adopt another name instead of using &ldquo;WordCamp.&rdquo;</p>\n\n\n\n<p>Due to the<a href=\"https://make.wordpress.org/community/2020/05/11/financial-update-on-wordpress-community-programs/\"> financial position</a> of WordPress Community Support PBC (WPCS), the community team is ending programmatic support for online AV vendor expenses. WordCamps that are not yet on the schedule will be encouraged to get sponsorships if they require the use of a professional AV vendor.</p>\n\n\n\n<p>&ldquo;Likewise, we have paused plans to spend money on sending swag, T-shirts, or other typical WordCamp collateral,&rdquo; Middleton said. &ldquo;It&rsquo;s important to change our frame of reference for what&rsquo;s necessary to make online events, away from the WordCamp model. Just because we did things a certain way for WordCamps, doesn&rsquo;t mean it&rsquo;s a high priority for online events.&rdquo;</p>\n\n\n\n<p>Sponsorships are also being re-examined, as online events haven&rsquo;t quite been able to deliver the same value to sponsors that traditional events did.</p>\n\n\n\n<p>&ldquo;The value proposition of online sponsor booths is shaky, and we&rsquo;ve always prided ourselves in partnering with our sponsors,&rdquo; Middleton said. &ldquo;Looking ahead, we must examine how much funding we&nbsp;<strong>need</strong>&nbsp;to create events that meet the goals of the team, and let that determine how to best coordinate with our community sponsors to deliver value and further our mission.&rdquo; </p>\n\n\n\n<p>The potential for in-person events for the coming year is still uncertain at this point, in the absence of a vaccine ready for commercial distribution. WordPress&rsquo; global sponsorship program has been temporarily suspended and the Community Team plans to work with global sponsors later this year to make a plan for 2021.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jul 2020 01:06:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: Are Plugin Authors to Blame for the Poor Admin Notices Experience?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102405\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"https://wptavern.com/are-plugin-authors-to-blame-for-the-poor-admin-notices-experience?utm_source=rss&utm_medium=rss&utm_campaign=are-plugin-authors-to-blame-for-the-poor-admin-notices-experience\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6619:\"<p class=\"has-drop-cap\">Last Thursday, Vova Feldman published an article asking that we <a href=\"https://freemius.com/blog/wordpress-admin-notices/\">stop blaming plugin authors</a> for the plethora of admin notices that users are bombarded with each day. <em>The real culprit?</em> The lack of a notifications mechanism in WordPress core.</p>\n\n\n\n<p>Feldman&rsquo;s post was prompted by a <a href=\"https://twitter.com/scottbolinger/status/1280567235006742528\">tweet</a> in which Scott Bolinger called out plugin authors for letting admin notices get out of control:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">Good lord WordPress plugin authors, this is out of control. <a href=\"https://t.co/0S42908C5T\">pic.twitter.com/0S42908C5T</a></p>&mdash; Scott Bolinger (@scottbolinger) <a href=\"https://twitter.com/scottbolinger/status/1280567235006742528?ref_src=twsrc%5Etfw\">July 7, 2020</a></blockquote>\n</div>\n\n\n\n<p>Feldman argues that laying the blame on plugin authors is the wrong way to look at the issue. While I agree that the underlying problem lies with WordPress, plugin authors have played their part in creating an atmosphere where they have become the scapegoat for everything wrong with the system.</p>\n\n\n\n<p>I have developed plugins since a fateful day in April 2007 in which I released a plugin that simply listed the current page&rsquo;s subpages. I have worked on 100s of plugins for clients and public release since then. In that time, I have maybe added a custom admin notice two times and only when the plugin had a major change, such as a database update. I reserved such notices for the OMGBBQ-very-important-you-need-to-read-this type of stuff. I considered it my duty to create an experience in which the user did not have to dismiss a notice every time one of my plugins received an update.</p>\n\n\n\n<p>This was not because I was cognizant of the growing issue of dozens of notices on some sites or how often users were being overwhelmed with them. For many years, I worked within a bubble where I simply focused on creating what I considered an ideal experience for my users. I always thought the admin notices system created an abysmal experience. It did not make sense to use it more than necessary.</p>\n\n\n\n<p>On the other hand, there were likely a few times over the years where I should have added some sort of notices for changes. Instead, I avoided doing so altogether because WordPress lacked a notifications system. I missed some good opportunities for communication.</p>\n\n\n\n<p>To a large extent, the issue stems from this lack of a proper notification system. However, plugin authors have perpetuated this broken system by continuing to use it when unnecessary. They have used it as a billboard to place their <a href=\"https://wptavern.com/black-friday-banner-gone-wrong-advertising-in-free-plugins\">holiday ads</a>. They have used it to upsell commercial versions of their products and services while prompting users for a five-star rating. There is plenty of blame to go around.</p>\n\n\n\n<p>Instead of placing blame, we should start asking what tools would solve problems for developers.</p>\n\n\n\n<h2>The Need for a Better System</h2>\n\n\n\n<p class=\"has-drop-cap\">Technically, WordPress simply has a hook and a set of common classes that developers can use in their HTML to provide some different colors for notices. There is no API, and without an API, it is impossible for even third-party plugin developers to even try their hands at creating various solutions.</p>\n\n\n\n<p>The closest thing WordPress has to an API is a little-known project from the Themes Team that provides a <a href=\"https://github.com/WPTT/admin-notices\">standardized method for theme authors</a> to add notices. However, the project covers only one aspect of admin notices, which is to create a consistent UI.</p>\n\n\n\n<p>The admin notice issue cannot be properly addressed without identifying the problems that plugin authors have tried to solve within the system, which at least includes the following:</p>\n\n\n\n<ul><li>User-oriented notifications, generally appearing after a user action.</li><li>Advertising commercial products and services.</li><li>Calls for plugin feedback or star ratings.</li></ul>\n\n\n\n<p>One of the primary issues with the current notification system is that it was created for the first item in that list. The other two items are not necessarily bad things. They are just poor usages of the system in place. However, there is no other standard method to handle those scenarios.</p>\n\n\n\n<p>Advertising is something we all must deal with in some form or fashion. I am unsure if there could or even should be a standard API for advertising. An outright ban of ads in the admin notice area could create a beast of its own, forcing plugin authors to come up with more obtrusive forms of advertising in other areas of the admin. I want to support advertising but not when that advertising wiggles its way to the top of every admin screen.</p>\n\n\n\n<p>WordPress provides no easy way for end-users to rate or review plugins from their admin interfaces. Having an easy way to provide direct feedback would be immensely helpful for both users and developers. While I am certain many people would argue against such integration with the WordPress.org site (there are arguments against any external integration out of the box), ratings and reviews would require an explicit opt-in from end-users because they would need an account on WordPress.org.</p>\n\n\n\n<p>Advertising and plugin feedback should not be a part of a discussion on admin notices. However, reality dictates that they are integral to the conversation.</p>\n\n\n\n<p>The first order of business must be to create a new notification system from the ground up. It should provide a standard API for plugin authors while handing over full management capabilities to the site owners. Users should be able to disable notices altogether or even enable/disable notices on a per-plugin basis. <em>Notice that a particular plugin author provides useless notices?</em> Well, just disable notices from that plugin. The author lost their privileges.</p>\n\n\n\n<p>From that point, we can let the progress drive the discussion on what to do about advertising and calls for feedback. A new system may shift them to a new screen &mdash; out of sight out of mind &mdash; but not make those problems disappear.</p>\n\n\n\n<p>More than anything, it is time for a champion.  The project does not get done without someone who will pave the path forward and earn the green light for a new notifications system in WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jul 2020 21:40:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"WordPress.org blog: WordPress 5.5 Beta 4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8719\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3766:\"<p>WordPress 5.5 Beta 4 is now available!</p>\n\n\n\n<p id=\"block-81bd56b9-ea44-43ad-ab36-a5ae78b54375\"><strong>This software is still in development,</strong> so it’s not recommended to run this version on a production site. Consider setting up a test site to play with the new version.</p>\n\n\n\n<p id=\"block-7cc1bbc6-17f9-44c5-8f67-da4e3059ad69\">You can test WordPress 5.5 Beta 4 in two ways:</p>\n\n\n\n<ul id=\"block-4840af57-f44b-4d9f-aa64-c6a452392e42\"><li>Try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (choose the “bleeding edge nightlies” option)</li><li>Or <a href=\"https://wordpress.org/wordpress-5.5-beta4.zip\">download the beta here</a> (zip).</li></ul>\n\n\n\n<p id=\"block-a40528cb-eb3b-4c8a-8f5e-aa700f1ba086\">WordPress 5.5 is slated for release on <a href=\"https://make.wordpress.org/core/5-5/\">August 11th, 2020</a>, and <strong>we need your help to get there</strong>!</p>\n\n\n\n<p>Thank you to all of the contributors who tested the <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-3/\">beta 3</a> development release and gave feedback. Testing for bugs is a critical part of polishing every release and a great way to contribute to WordPress. </p>\n\n\n\n<h2 id=\"block-15d6d57f-905d-4a47-9f66-839468a5375a\">Some highlights</h2>\n\n\n\n<p id=\"block-85da84ec-c841-42f9-8d3b-1a4537a61d10\">Since <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-3/\">beta 3</a>, <a href=\"https://core.trac.wordpress.org/query?status=closed&changetime=07%2F22%2F2020..07%2F28%2F2020&milestone=5.5&group=component&col=id&col=summary&col=owner&col=type&col=priority&col=component&col=version&order=priority\">43 bugs</a> have been fixed. Here are a few changes in beta 4:</p>\n\n\n\n<ul><li>Add <code>\"loading\"</code> as an allowed kses image attribute (see <a href=\"https://core.trac.wordpress.org/ticket/50731\">#50731</a>).</li><li>Add filter for the plugin/theme auto-update message in the Info tab of Site health (see <a rel=\"noreferrer noopener\" target=\"_blank\" href=\"https://core.trac.wordpress.org/ticket/50663\">#50663</a>).</li><li><code>$_SERVER[\'SERVER_NAME\']</code> not a reliable when generating email host names (see <a href=\"https://core.trac.wordpress.org/ticket/25239\">#25239</a>)</li><li>Several backported fixes from Gutenberg are included in WordPress 5.5 Beta 4 (<a href=\"https://github.com/WordPress/gutenberg/pull/24218\">See PR #24218</a>)</li></ul>\n\n\n\n<h2 id=\"block-76156b2b-0a52-4502-b585-6cbe9481f55b\">Developer notes</h2>\n\n\n\n<p id=\"block-3fe5e264-0a95-4f12-9a18-0cb9dc5955d1\">WordPress 5.5 has lots of refinements to polish the developer experience. To keep up, subscribe to the <a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a> and pay special attention to the <a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">developers’ notes</a> for updates on those and other changes that could affect your products.</p>\n\n\n\n<h2 id=\"block-bc89fd56-47b0-439f-8e2c-4a642c80a616\">How to Help</h2>\n\n\n\n<p id=\"block-3ff83a77-8b54-4061-ae2d-45fc984cbd76\">Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev/\">Help translate WordPress into more than 100 languages</a>!</p>\n\n\n\n<p id=\"block-9d871099-ec49-446c-8322-9e49b7498c10\">If you think you’ve found a bug, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area</a> in the support forums. We’d love to hear from you!</p>\n\n\n\n<p id=\"block-bd71c1d3-39d9-4b2a-8193-3486497b45fd\">If you’re comfortable writing a reproducible bug report, <a href=\"https://core.trac.wordpress.org/newticket\">file one on WordPress Trac</a>, where you can also find a list of <a href=\"https://core.trac.wordpress.org/tickets/major\">known bugs</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jul 2020 20:56:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"Donncha: Crowdsignal Polls in your Block Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://odd.blog/?p=89503098\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://odd.blog/2020/07/27/crowdsignal-polls-in-your-block-editor/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2423:\"<div class=\"aligncenter crowdsignal-poll-wrapper\"></div>\n\n\n<p>The <a href=\"https://crowdsignal.com/\">Crowdsignal</a> team at Automattic have been quietly working on a new <a href=\"https://wordpress.org/plugins/crowdsignal-forms/\">poll block</a> for the last few weeks. We finally made it public today on WordPress.org!</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>We set out with the task of creating a block that would allow the writer to quickly insert a poll in their posts using the block editor. More than that, it had to be simple to use. It also needed to be themed to match the look and feel of the website it would appear on.</p>\n\n\n\n<div class=\"wp-block-image size-large\"><img /></div>\n\n\n\n<p>We&#8217;ve created a block that does that. It also records the votes collected on the Crowdsignal website where you can analyse the results using reports Crowdsignal users have always used.</p>\n\n\n\n<div class=\"wp-block-image size-large\"><img /></div>\n\n\n\n<p>Search for &#8220;Crowdsignal Forms&#8221; on your plugins page to install it in the usual way.</p>\n\n\n\n<p>A free <a href=\"https://crowdsignal.com/\">Crowdsignal</a> account is required to use the block. We made it really easy to connect your site to your Crowdsignal account. If you don&#8217;t have one then creating a new account is simple too.</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>The first 2,500 responses you collect are included in your free account, and further votes are recorded but free users are encouraged to upgrade if they want to do further analysis of all the data they collect.</p>\n\n<p><strong>Related Posts</strong><ul><li> <a href=\"https://odd.blog/2004/01/29/htmlarea-the-free-customizable-online-editor/\" rel=\"bookmark\" title=\"Permanent Link: HTMLArea &#8212; the free, customizable online editor\">HTMLArea &#8212; the free, customizable online editor</a></li><li> <a href=\"https://odd.blog/2003/04/02/cross-browser-rich-text-editor/\" rel=\"bookmark\" title=\"Permanent Link: Cross-Browser Rich Text Editor\">Cross-Browser Rich Text Editor</a></li><li> <a href=\"https://odd.blog/2003/05/22/cross-browser-rich-text-editor-work-in-firebird/\" rel=\"bookmark\" title=\"Permanent Link: Cross-Browser Rich Text Editor &#8211; work in Firebird?\">Cross-Browser Rich Text Editor &#8211; work in Firebird?</a></li></ul></p>\n<p><a href=\"https://odd.blog/2020/07/27/crowdsignal-polls-in-your-block-editor/\" rel=\"nofollow\">Source</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jul 2020 19:17:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Donncha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:11:\"\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"HeroPress: HeroPress Gets A Surprise\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://heropress.com/?p=3242\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:117:\"https://heropress.com/heropress-gets-a-surprise/#utm_source=rss&utm_medium=rss&utm_campaign=heropress-gets-a-surprise\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1373:\"<img width=\"960\" height=\"540\" src=\"https://s20094.pcdn.co/wp-content/uploads/2020/07/heropress_cape_video_thumb-1024x576.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Topher wearing his cape.\" />\n<p>A couple of months ago <a href=\"https://twitter.com/michelleames\">Michelle Frechette</a> approached me about being on a podcast for <a href=\"https://sentree.io\">Sentree.io</a>. I didn&#8217;t realize at the time I was going to be their inaugural guest! We had a great time, and things got back to normal.</p>\n\n\n\n<p>Several weeks later Michelle said they sent me a thanks gift, which was very thoughtful, and that I should have someone video the unboxing. I never once imagined what they actually sent me.  Here&#8217;s the video.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<div class=\"jetpack-video-wrapper\"></div>\n</div>\n\n\n\n<p>My family already has all sorts of ideas about how to use it at WordCamps. I just hope it survives being worn ALL DAY EVERY DAY.</p>\n\n\n\n<p>It&#8217;s super well made, I snooped a little and found the etsy shop it came from. Really great embroidery and seaming. Really classy.</p>\n\n\n\n<p>Thanks Sentree, and thanks Michelle.  :)</p>\n<p>The post <a rel=\"nofollow\" href=\"https://heropress.com/heropress-gets-a-surprise/\">HeroPress Gets A Surprise</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jul 2020 13:31:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: Develop, Test, and Showcase Blocks in Isolation With BlockBook\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102310\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:185:\"https://wptavern.com/develop-test-and-showcase-blocks-in-isolation-with-blockbook?utm_source=rss&utm_medium=rss&utm_campaign=develop-test-and-showcase-blocks-in-isolation-with-blockbook\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4143:\"<p class=\"has-drop-cap\">Riad Benguella <a href=\"https://riad.blog/2020/07/22/introducing-blockbook-for-wordpress/\">released BlockBook</a>, a project that promises to overhaul how developers build blocks and more, on Tuesday. It is a development environment that allows creators to work with blocks in isolation, outside of WordPress. Developers can view individual block properties and test output from a defined block library.</p>\n\n\n\n<p>BlockBook is available as an <a href=\"https://www.npmjs.com/package/blockbook-cli\">npm package</a>. Developers can also contribute to the project through its <a href=\"https://github.com/youknowriad/blockbook\">GitHub repository</a>.</p>\n\n\n\n<p>Benguella got the idea from <a href=\"https://storybook.js.org/\">Storybook</a>, which is an open-source tool for developing UI components for React, Vue, Angular, and other JavaScript libraries in isolation. It is an environment that makes development and testing more efficient for individual components. It also allows end-users the opportunity to test those components before they are brought into a project. The goal for BlockBook is to bring a similar system to WordPress block development.</p>\n\n\n\n<p>&ldquo;If we think about it a little bit, blocks are reusable units that can live on their own outside of any context, they can be edited visually, and they produce markup,&rdquo; wrote Benguella in the announcement post. &ldquo;They have in fact a lot in common with React Components. They are super-powered React Components.&rdquo;</p>\n\n\n\n<p>He believes that BlockBook will be able to solve many of the issues around block development by taking the principles of the Storybook application and employing them into an environment specifically for building, testing, documenting, and sharing blocks.</p>\n\n\n\n<p>Benguella has a full <a href=\"https://youknowriad.github.io/blockbook/\">demo available</a> as a GitHub page. Developers can do the same with their plugins or simply host it as a static site on their own server.</p>\n\n\n\n<img />BlockBook example output of the Gallery block.\n\n\n\n<p>In his post, he identified three major challenges that his project is meeting head-on. The first, and most obvious for anyone who has delved into block development, is creating blocks within the WordPress environment. It is a tedious and inefficient process to develop and test blocks in the WordPress admin. By isolating the block code, developers can bypass many of the routine tasks every time they make a code change to a block.</p>\n\n\n\n<p>The second challenge was to figure out a way to make theme testing much easier. For theme authors with one or two themes, testing block styling is relatively easy. However, for businesses, agencies, and others who maintain many themes, there is no good way to quickly see how individual blocks behave for each of the themes. BlockBook allows theme authors to register any number of themes. Essentially, developers add a few lines of code and point to the appropriate stylesheet. Once set up, testing is as simple as switching themes via a dropdown select and moving between individual blocks. All of this happens almost instantly.</p>\n\n\n\n<p>The third part of the equation involves end-users. Currently, users have no good way to test blocks without installing a block plugin, heading to their editor, and tinkering around with it. If they do not like the block, they must start the process all over again. With BlockBook, developers can make their blocks available for testing beforehand. They can even allow end-users to beta test blocks and provide feedback without installing a plugin at all.</p>\n\n\n\n<p>However, that is still not quite as efficient as Benguella would like. It would rely on individual developers. For the long-term, he hopes the project becomes an official WordPress package. This creates the possibility of WordPress.org automatically building and hosting a BlockBook for plugins and themes, giving users a chance to test before installing.</p>\n\n\n\n<p>This is something that could be revolutionary for users if the official WordPress project could take it on and create a solid user experience around it.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jul 2020 19:00:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"WPTavern: Unsplash Responds to Image Licensing Concerns, Clarifies Reasons for Hotlinking and Tracking\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102268\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:247:\"https://wptavern.com/unsplash-responds-to-image-licensing-concerns-clarifies-reasons-for-hotlinking-and-tracking?utm_source=rss&utm_medium=rss&utm_campaign=unsplash-responds-to-image-licensing-concerns-clarifies-reasons-for-hotlinking-and-tracking\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:22930:\"<p>Concerns are mounting regarding Unsplash&rsquo;s terms and image licensing after the site <a href=\"https://wptavern.com/unsplash-launches-official-plugin-for-wordpress\">launched its official WordPress plugin</a> this week. Several people commented on the restrictions and lack of clarity in the license. </p>\n\n\n\n<p>&ldquo;The irony here is that this goes against Unsplash&rsquo;s own licensing for images,&rdquo; Aris Stathopoulos commented. &ldquo;It&rsquo;s vague and restrictive to the point where one doesn&rsquo;t even know if they can actually use the images they import.&rdquo;</p>\n\n\n\n<p>Matt Mullenweg responded to Stathopoulos&rsquo; comment, saying, &ldquo;I agree, not sure if this should be allowed in the directory.&rdquo;</p>\n\n\n\n<p>The last time the site made a major splash in WordPress news was in 2017 after <a href=\"https://wptavern.com/unsplash-updates-its-license-raises-gpl-compatibility-concerns\">revising its license</a> to prohibit the compilation of photos for the creation of a similar or competing service. Its new branded license made the library&rsquo;s images incompatible with the GPL and unable to distributed with WordPress themes and plugins.</p>\n\n\n\n<p>Unsplash co-founder Luke Chesser believes these comments are due to a misunderstanding about the license change.</p>\n\n\n\n<p>&ldquo;As you know, themes have a requirement that themes and their content be GPL compatible,&rdquo; Chesser said. &ldquo;Outside of themes, WordPress&rsquo;s application of GPL doesn&rsquo;t apply to content in plugins. That&rsquo;s why you can have a YouTube plugin, a Getty Images plugin, a Giphy plugin, etc. &mdash; none of this content is licensed under GPL. In most cases plugins serve content that has a very narrow usage license, much, much more restrictive than the Unsplash License.&rdquo;</p>\n\n\n\n<h2>Why Unsplash Abandoned Creative Commons Zero Licensing</h2>\n\n\n\n<p>To understand the sensitivity to Unsplash&rsquo;s licensing change, one must dust off a bit of web history. When the site first started in 2013, the images were licensed under the very permissive&nbsp;<a rel=\"noreferrer noopener\" href=\"http://creativecommons.org/publicdomain/zero/1.0/\" target=\"_blank\">Creative Commons Zero</a>&nbsp;license. It quickly grew from a Tumblr-hosted photo blog that shared &ldquo;10 new photos every 10 days&rdquo; for free, to one of the most popular photo libraries on the web. </p>\n\n\n\n<p>Chesser said the real life problems the Unsplash community encountered caused his team to change the licensing to protect photo authors. </p>\n\n\n\n<p>&ldquo;People were downloading the images and reselling them on Getty and Shutterstock,&rdquo; he said. &ldquo;Even if the people doing this made no money, it was such a negative experience for Unsplash contributors that they would remove their images from Unsplash, removing content that was previously available to openly be created with.</p>\n\n\n\n<p>&ldquo;Scraping of the site and the library had a similar effect as contributors would see their photos copied over to thousands of free image sites they never signed up for, or worse, their photos being made available to other sites with no attribution.&rdquo;</p>\n\n\n\n<p>Unsplash contributors were likely not fully aware of the freedoms that the CC0 license affords. These problems may be undesirable applications of the license but they were not outright misuses. When Unsplash changed its license, approximately 200,000 images were no longer identified on the site as being part of the public domain. </p>\n\n\n\n<p>Creative Commons got involved after the organization started receiving questions from users in the open content and free software movements. Ryan Merkley, CEO of Creative Commons at that time, penned an <a href=\"https://creativecommons.org/2017/06/22/unsplash/\">update</a> on Unsplash&rsquo;s licensing change to the CC community, expressing the organization&rsquo;s concerns.</p>\n\n\n\n<p>&ldquo;Our intention is to ensure that CC community members understand what has happened to a service they have been using that incorporated CC tools, and to protect the content that was dedicated to the public domain,&rdquo; Merkley said.</p>\n\n\n\n<p>Creative Commons called on Unsplash to properly differentiate the works that were previously shared under the irrevocable CC0 license so that they would not disappear from the public domain:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Following the switch to the new Unsplash-branded license, there is no marking of works that were previously shared in the public domain using CC0. The Unsplash API restricts/obscures the full CC0 collection, which we believe to be about 200,000 images, but it isn&rsquo;t possible to access the complete archive. In order to ensure that the commons is maintained, we hope that Unsplash will either a) properly mark all the works shared using CC0 and/or b) make available a full archive of the CC0 works so they can be shared on a platform that supports open licensing and public domain tools. Previous platforms that have gone under or abandoned open license tools have shared their CC archives for this purpose. We hope Unsplash will follow the same path.</p></blockquote>\n\n\n\n<p>Unsplash declined to identify these images at that time. When I asked Chesser if the company is willing to update their API to differentiate these works, he said they discovered the images were never CC0 to begin with because of Unsplash&rsquo;s terms: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>The 2017 license clarification I described was also brought about because the team from Creative Commons told us that the photos were not licensed under CC0 if there were additional terms stipulated on the terms page. Therefore, the photos were not actually under CC0, as they had been submitted with additional terms attached to them and we could not and can not distribute the&nbsp;photos under the CC0 license. As part of this, we renamed the license to the Unsplash License and clarified the main parts of the terms in the form of the Unsplash License.</p></blockquote>\n\n\n\n<p>The controversy over the license change struck a nerve with those who <a href=\"https://www.designernews.co/stories/84910-unsplash-images-are-no-longer-in-the-public-domain\">perceived the move to be unfair</a> to the community of creators who had been convinced to put their works in the public domain. Unsplash had become a household name on the backs of Creative Commons Zero licensing, with the images fetching more than <a href=\"https://medium.com/unsplash/unsplash-best-of-2017-eb36ee81236\">29 billion views in 2017</a>, only to abandon the license when it was no longer expedient for the growth of their community. </p>\n\n\n\n<p>That body of work that had been originally shared to the public domain was then deftly hidden away (and remains so) with no differentiation in the site&rsquo;s API to identify these images. This is what Mullenweg seemed to be referencing when he <a href=\"https://wptavern.com/unsplash-launches-official-plugin-for-wordpress#comment-335431\">commented</a> on the plugin launch. </p>\n\n\n\n<p>&ldquo;Encouraging hotlinking is also pretty suspicious, especially after the previous bait and switch,&rdquo; Mullenweg said. &ldquo;Maybe if there was a way again to find just the CC0 licensed images, which the Creative Commons also requested, this could be okay to promote.&rdquo;</p>\n\n\n\n<p>Chesser contends that the Unsplash community had no complaints with the decision and that the only people who were dissatisfied were those who were not contributors.</p>\n\n\n\n<p>&ldquo;For anyone who feels that we somehow &lsquo;tricked&rsquo; our community, again, I&rsquo;d point back to the reaction from our actual contributor community &mdash; the people who generously submit their images to Unsplash for others to create with,&rdquo; Chesser said. &ldquo;We heard no complaints from this community when we clarified the License in 2017. Had there been an issue,&nbsp;had we somehow been taking&nbsp;advantage of their contributions, we would have certainly heard about it then, as our community are very passionate and vocal. </p>\n\n\n\n<p>&ldquo;The only complaints we heard were from people from outside of the Unsplash community &mdash; including Matt &mdash; who have never submitted an image to Unsplash and aren&rsquo;t part of our community. On the internet, there will always be people who disagree with you &mdash; we focus on our community and expanding the number of people who have access to create with images.&rdquo;</p>\n\n\n\n<p>This particular licensing conflict seems to have inspired a bit of lasting apprehension regarding Unsplash&rsquo;s willingness to change its license and terms in the future. Allowing a plugin to efficiently pump out thousands of images to WordPress sites could potentially make the platform&rsquo;s user base a vector for disseminating works that someday may not be available with the same freedoms. </p>\n\n\n\n<p>&ldquo;Could the terms or licensing of that hotlinking change in the future, as the licensing did in 2017?&rdquo; Mullenweg asked in the comments.</p>\n\n\n\n<p>&ldquo;I forsee no future scenario where our terms will ever meaningfully change,&rdquo; Chesser said. &ldquo;They will of course occasionally be refined, as all terms are&mdash;like when we added clarifications around GDPR compliance or when we add new features that require a legal definition. But our mission and goal are the same as they have always been: to enable anyone to create with visuals, and our terms will continue to reflect that.&rdquo;</p>\n\n\n\n<p>After a few in the WordPress community expressed that the license was not clear in terms of what users can do with the images, Chesser said he would be open to making a separate clarification document to address any legitimate concerns.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">The actual license has been ruled as very clear by a lot of lawyers and we want to avoid complicating it\'s simplicity with more legalese, but we\'re open to making a separate clarification/side-letter/legal document which addresses any legitimate concerns</p>&mdash; Luke Chesser (@lukechesser) <a href=\"https://twitter.com/lukechesser/status/1286446954197770244?ref_src=twsrc%5Etfw\">July 23, 2020</a></blockquote>\n</div>\n\n\n\n<p>When the 2017 licensing controversy happened, Richard Best, a technology and public lawyer based in New Zealand, said the new Unsplash license <a href=\"http://wpandlegalstuff.com/unsplash-gpl-compatibility-concern-red-herring/\">could use some clarification</a> regarding freedoms for downstream recipients. He suggested changes that rephrase it as follows: &ldquo;Unsplash grants&nbsp;<span>you and every person&nbsp;who comes into possession of the photos</span>&nbsp;a nonexclusive copyright license to&hellip;&rdquo;</p>\n\n\n\n<p>&ldquo;These changes are intended to ensure that downstream recipients of the photos receive the same licence from Unsplash,&rdquo; Best said. &ldquo;Both the GPL and the Creative Commons licences are structured in this way. Without these changes, distributors of products like website themes may be concerned&nbsp;that the end users of their products will not receive the rights they need to use the photos for their own purposes.&rdquo;</p>\n\n\n\n<p>Chesser said the&nbsp;Unsplash License and terms were created by the same legal team that created the Creative Commons licenses. Any major differences regarding the freedoms for downstream recipients were likely considered and intentional. It may still be an important clarification, as the block editor continues to make it easier for users to create and share their own designs with images. </p>\n\n\n\n<h2>Unsplash Clarifies the Purpose of Hotlinking to the CDN and Tracking Views</h2>\n\n\n\n<p>The official Unsplash plugin is different from other plugins created to connect users to the free image library in that it hotlinks images to the Unsplash CDN, ostensibly to reduce the site&rsquo;s bandwidth usage and speed up delivery.</p>\n\n\n\n<p>&ldquo;The plugin uses the Unsplash CDN to serve Unsplash images while the plugin is installed and enabled,&rdquo; Chesser said. &ldquo;At the same time, every image used in a post will also be copied over to the local server and stored there. We store a copy of every image on the local WordPress install so that if the plugin is disabled or removed by the site owner, their posts can continue to serve the local images and don&rsquo;t break, however they lose the features of the Unsplash CDN.&rdquo;</p>\n\n\n\n<p>The CDN also supports dynamic resizing, compression, cropping, automatic file format conversion, and a number of performance improvements that Chesser said the service has implemented based on what the team as learned from serving tens of billions of images every month for 8+ years.</p>\n\n\n\n<p>&ldquo;When we talked to publishers, these features were extremely important to them,&rdquo; he said. &ldquo;Rather than try to rebuild the wheel in WordPress, we wanted to offer these features to publishers as they aren&rsquo;t supported natively by WordPress and are table stakes for modern image serving.&rdquo;</p>\n\n\n\n<p>The Unsplash CDN exists to serve the needs of Buzzfeed, Trello, Adobe, Dropbox, Notion, and 2,200+ official <a href=\"https://unsplash.com/developers\">API integrations</a>. It also gives Unsplash contributors a better idea of the real number of views of the content they post.</p>\n\n\n\n<p>&ldquo;This outsized distribution of their images is one of the main reasons that photographers post on Unsplash,&rdquo; Chesser said. &ldquo;A quick <a href=\"https://twitter.com/search?q=unsplash%20views&src=typed_query\">search on twitter</a> gives you a good idea for how important this phenomenon is to our contributors.&rdquo;</p>\n\n\n\n<p>One commenter <a href=\"https://wptavern.com/unsplash-launches-official-plugin-for-wordpress#comment-335442\">said</a> that she was put off by the official plugin&rsquo;s requirement to authenticate, since competing plugins don&rsquo;t add this extra layer.</p>\n\n\n\n<p>&ldquo;They can now force user sign ups to inflate their user base even though other plugins just serve images without any sort of authentication,&rdquo; she said. &ldquo;What is the point in a user authenticating to only receive an API key? It&rsquo;s not like you can access Likes or your collection with only the API key.</p>\n\n\n\n<p>&ldquo;Serving images from their CDN also allows them to track image views and URLs which helps inflate the download and view counts for their contributors. These other plugins like Instant Images downloads the file to your media library which would only count as a single download. I&rsquo;m going to stick with Instant Images as I don&rsquo;t feel like feeding the advertising machine.&rdquo;</p>\n\n\n\n<p>Responses to the plugin&rsquo;s approach were mixed, but overall it seemed that most users were delighted to cut a few steps out of their workflow for posting images to WordPress. The plugin has more than 300 downloads in 48 hours.</p>\n\n\n\n<h2>Is Unsplash in Violation of the WordPress Plugin Directory&rsquo;s Guidelines?</h2>\n\n\n\n<p>After Matt Mullenweg raised concerns about the plugin&rsquo;s suitability for the directory, commenters called in similar concerns about the Pexels library, which Automattic uses in Jetpack.</p>\n\n\n\n<p>Unsplash does not appear to be in violation of the official WordPress.org plugin directory guidelines. Earlier this year when asked about a different plugin that imports an Unsplash image, Plugin Team member Samuel Otto Wood <a href=\"https://wordpress.slack.com/archives/C1LBM36LC/p1581854898429000\">responded</a> using an Unsplash-specific example: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Let&rsquo;s simplify this right down to basics: Lets say you made a plugin that imports images from Unsplash into your site. That plugin is fine. It has no images in it, the purpose of it is to access a library of images and allow you to pull them into your site. You have to take actions to pull in those images. That is perfectly acceptable for being hosted on&nbsp;<a rel=\"noreferrer noopener\" target=\"_blank\" href=\"http://w.org/\">w.org</a>. So, you can&rsquo;t use Unsplash images in your plugin hosted here. But if it pulls them from somewhere else via user action and intention, fine.</p></blockquote>\n\n\n\n<p>Chesser sees the concerns regarding the clarity of Unsplash&rsquo;s licensing as unwarranted, given Automattic&rsquo;s use of the Pexels library.</p>\n\n\n\n<p>&ldquo;Pexels made a clone of the Unsplash License with the exact same restrictions shortly after we updated it in 2017,&rdquo; Chesser said. &ldquo;At no point has WordPress expressed any skepticism that the Pexels License is legally vague. Given that they have instead created multiple official partnerships with Pexels, including adding it to Jetpack, then I would expect that they consider the license to be legally clear.&rdquo;</p>\n\n\n\n<p>Both Pexels and Unsplash licenses share similar restrictions but Pexels has more restrictions on how images can be used. Chesser believes the renewed concerns are entirely founded on Unsplash&rsquo;s controversial 2017 licensing change.</p>\n\n\n\n<p>&ldquo;Before 2017, we had a strong relationship with WordPress,&rdquo; Chesser said. &ldquo;Since then, WordPress has essentially cut off all ties with Unsplash and instead made partnerships with Pexels to integrate into WordPress features. What&rsquo;s strange though is that shortly after we clarified our license in 2017, Pexels did the same thing, adding the same restrictions&nbsp;<a rel=\"noreferrer noopener\" href=\"https://www.pexels.com/terms-of-service/#restrictions-on-use-of-the-service-and-content:~:text=to%20portray%20any%20person%20depicted%20in,engaging%20in%20immoral%20or%20criminal%20activities%3B\" target=\"_blank\">plus a few additional ones</a>.</p>\n\n\n\n<p>&ldquo;Specifically, you can see that they have the same restriction around&nbsp;<a rel=\"noreferrer noopener\" href=\"https://www.pexels.com/license/#flash-container:~:text=Don\'t%20sell%20unaltered%20copies%20of%20a,physical%20product%20without%20modifying%20it%20first.\" target=\"_blank\">reselling of content</a>&nbsp;and the&nbsp;<a rel=\"noreferrer noopener\" href=\"https://www.pexels.com/license/#flash-container:~:text=Don\'t%20redistribute%20or%20sell%20the%20photos%20and%20videos%20on%20other%20stock%20photo%20or%20wallpaper%20platforms.\" target=\"_blank\">same restriction around recompiling and scraping of the site</a>. (Note: they use the word redistribute on the license page, but&nbsp;<a rel=\"noreferrer noopener\" href=\"https://www.pexels.com/terms-of-service/#intellectual-property:~:text=the%20right%20to%20compile%20any%20Pexels%20Content%20to%20replicate%20a%20similar%20or%20competing%20Service%3B\" target=\"_blank\">use the word compile in their terms</a>.)&rdquo;</p>\n\n\n\n<p><a href=\"https://xwp.co/\">XWP</a>, the agency that Unsplash partnered with to build the plugin, said the license is &ldquo;significantly less restrictive than Pexels, Youtube, Getty, Spotify and many other examples you&rsquo;ll find throughout the plugin directory.&rdquo; If this plugin is in violation, then many others would be called into question along with it.</p>\n\n\n\n<p>&ldquo;As rule 6 on the <a rel=\"noreferrer noopener\" href=\"http://wordpress.org/\" target=\"_blank\">WordPress.org</a> plugin guidelines clearly state: &lsquo;Plugins that act as an interface to some external third party service (e.g. a video hosting site) are allowed, even for paid services,&rdquo; XWP CTO Derek Herman said.</p>\n\n\n\n<p>&ldquo;As their high quality images are available as an API, we built a community plugin up to WordPress VIP coding standards so that Unsplash would work on a variety of use cases, from WordPress versions 4.9 to 5.4. Integration with APIs has been key to WordPress&rsquo; growth over the past few years.&rdquo;</p>\n\n\n\n<p>Herman also cited several prominent examples of content integrations with varying licenses and terms that govern the content:</p>\n\n\n\n<ul><li>A leading enterprise publishing plugin is <a href=\"https://wordpress.org/plugins/getty-images/\" target=\"_blank\" rel=\"noreferrer noopener\">Getty Images</a>, which is a <a href=\"https://wpvip.com/plugins/getty-images/\" target=\"_blank\" rel=\"noreferrer noopener\">WordPress VIP partner plugin</a> and has long been used by larger organizations. It primarily sells &ldquo;restricted-usage&rdquo; images connected to a network of media sources like newspapers and freelancers.</li><li><a href=\"https://wordpress.org/support/article/embeds/\" target=\"_blank\" rel=\"noreferrer noopener\">WordPress core has extensive oembed support for third parties</a>, which takes third-party URLs and parses them in a way to link to the site. While Amazon Kindle, Spotify and Youtube&rsquo;s content licensing rules are quite restrictive, the goal of these integrations are to encourage content creators to tell stories with what they find across the internet.</li><li>In its most recent release <a href=\"https://jetpack.com/2020/07/07/87-easier-reach-customers/\" target=\"_blank\" rel=\"noreferrer noopener\">Jetpack included two exciting new media integrations</a>&mdash;Google Photos and Pexels&mdash;which are certainly relevant here. Pexels actually has a &ldquo;<a href=\"https://help.pexels.com/hc/en-us/articles/360043229813-Can-I-use-photos-and-videos-from-Pexels-in-a-political-campaign-\" target=\"_blank\" rel=\"noreferrer noopener\">political views</a>&rdquo; clause in their license. As they do not define what is a &ldquo;political policy or viewpoint&rdquo; it could be viewed as too restrictive as nearly any post could be construed as being political.</li><li>There are a few other plugins using Unsplash in the WordPress ecosystem, such as <a href=\"https://wordpress.org/plugins/instant-images/\" target=\"_blank\" rel=\"noreferrer noopener\">Instant Images</a> (which has been in the directory for over three years). In fact, WordPress Release lead Riad Benguella wrote a great prototype plugin called &ldquo;<a href=\"https://wptavern.com/drop-it-plugin-brings-gifs-and-unsplash-photos-to-gutenberg\" target=\"_blank\" rel=\"noreferrer noopener\">Drop It</a>,&rdquo; which integrates with both GIPHY and Unsplash, and served as inspiration for us on this project.&nbsp;</li></ul>\n\n\n\n<p>At the moment, it seems Unsplash is within WordPress.org&rsquo;s plugin directory guidelines, but if its terms and licensing are deemed incompatible, many media integrations in the plugin ecosystem will also be called into question. Users who object to Unsplash&rsquo;s method of delivery can always opt to use a plugin with a different approach. Those who want to support libraries that serve images with GPL-compatible licensing can check out the Theme Team&rsquo;s list of <a href=\"https://make.wordpress.org/themes/handbook/review/resources/#recommended-websites-for-images\">recommended sources</a> and look for plugins that integrate those.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jul 2020 17:24:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"WPTavern: Revised Block Directory Guidelines Proposal Updates Wording but Changes Little Else\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102315\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:231:\"https://wptavern.com/revised-block-directory-guidelines-proposal-updates-wording-but-changes-little-else?utm_source=rss&utm_medium=rss&utm_campaign=revised-block-directory-guidelines-proposal-updates-wording-but-changes-little-else\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6513:\"<p class=\"has-drop-cap\">Yesterday, Alex Shiels <a href=\"https://make.wordpress.org/plugins/2020/07/22/proposed-block-directory-guidelines/\">posted an update</a> to the <a href=\"https://github.com/WordPress/wporg-plugin-guidelines/pull/70/files#diff-bcf4c6e86251a8d088c6bd5800c476ff\">proposed guidelines</a> for the WordPress block directory. The document adds eight rules for plugin authors to follow if they plan to add their one-off blocks to the directory. The guidelines are additional requirements on top of the existing plugin directory guidelines.</p>\n\n\n\n<p>While the wording and organization of the block guidelines received a revamp in comparison to the <a href=\"https://github.com/WordPress/wporg-plugin-guidelines/blob/87a9a17eca6d4b39a6bb4b1f2c8dcf33aff26336/blocks.md\">original proposal</a>, the overall sentiment is unchanged. Shiels thanks community developers for the feedback on the original guidelines but does not go into detail about the things that changed as a result.</p>\n\n\n\n<p>The primary guidelines are mostly expected, run-of-the-mill requirements for blocks. Developers need a <code>block.json</code> file. They should name stuff appropriately. Plugins should contain only a single block. Plugins should only touch the block editor. Blocks should work seamlessly once activated.</p>\n\n\n\n<p>The remaining guidelines are certain to be a disappointment or point of contention for some developers.</p>\n\n\n\n<h2>Monetization Still Not Allowed</h2>\n\n\n\n<p class=\"has-drop-cap\">The largest <a href=\"https://wptavern.com/can-the-block-directory-and-business-interests-coexist\">feedback on the guidelines</a> we received here at the Tavern surrounded what is essentially a blanket ban on commercial interests for block developers. Blocks still cannot hook into a paid service or advertise within the admin. This limitation will obviously turn away many businesses that may have been looking forward to the block directory as a potential avenue for profit. Right now, one-off blocks will need to be built by those with altruistic interests, giving back to the community simply out of the kindness of their hearts.</p>\n\n\n\n<p>While there is nothing inherently wrong with wanting to do that, it is not attractive to developers who are primarily focused on putting food on the table. Hobbyists and larger businesses with the resources to give back will be well-suited to add blocks to the directory. However, it will give a lot of developers pause because it is unlikely a good return on investment. Instead, those developers are more likely to submit their blocks to the normal plugin directory with their normal upsell methods. This will only serve to make block discoverability harder for end-users.</p>\n\n\n\n<p>This is a missed opportunity to build a well-rounded system that is fair to both users and developers who need to make a living. Whether it is through the plugin tag system or specific guidelines on monetization, we could have built something that made everyone a little happy and a little mad, a compromise that merged a good user interface and experience.</p>\n\n\n\n<p>It is not like there have been no proposals. In January, Luke Carbis wrote a detailed outline of <a href=\"https://carb.is/2020/01/block-business/\">how WordPress could provide a middle ground</a> between sustainability (business models) and accessibility (free options) with the upcoming block directory. His fear was that the block directory would be full of blocks without updates in a few years because the completely free model is unsustainable. His proposal was a badge-based system that let users know if a block contained ads, used a freemium model, or required a sign-in to a third-party service.</p>\n\n\n\n<p>The current guideline is not set in stone. This is the first version of the block directory. It is not out of the question that the team could change things as the directory grows over time.</p>\n\n\n\n<h2>No Love for Server-Side Blocks</h2>\n\n\n\n<p class=\"has-drop-cap\">The block directory guidelines are still heavily geared toward static blocks. PHP must be kept at a minimum and primarily be used to load any necessary scripts and stylesheets. Server-side blocks are not getting much attention at the moment, which may be a limitation of the software.</p>\n\n\n\n<p>It would be great to see a way for some server-side blocks to be included in the block directory. For example, a breadcrumbs block would need to rely heavily on PHP to render its output. It is a dynamic block rather than static. This particular block would not be useful until full-site editing lands in WordPress, which is still several months away. However, I am getting the itch to turn an old breadcrumbs plugin of mine into a block. It would be neat to see it listed in the block directory.</p>\n\n\n\n<p>There are countless other scenarios. Post lists, product grids, and data pulled from external APIs are all good use cases for one-off blocks.</p>\n\n\n\n<h2>Dependencies Are Not Allowed</h2>\n\n\n\n<p class=\"has-drop-cap\">Given the way that WordPress works, it makes sense to ban dependencies on other plugins for any particular block to function. This is an old limitation that is rearing its head again. Every other modern framework uses some sort of dependency management to address this problem.</p>\n\n\n\n<p>The block directory has the potential to exacerbate the problem even further. Because plugins coming from this directory will be single blocks, it will often mean that developers are using the same bits of code across multiple projects. For example, an end-user may activate multiple block plugins that rely on the same JavaScript library. Because there is no 100%, sure-fire way to make sure only one instance of this library is loaded, users may be running multiple instances of it on their sites. It is not a new problem, but smaller block plugins mean that users are more likely to install more plugins. It increases the probability of running into this issue.</p>\n\n\n\n<p>If there was any sort of basic dependency management for plugin authors to use in WordPress, it would solve a world of problems. Over the years, developers have created methods to minimize the issues stemming from the lack of such a system. However, nothing is foolproof without a standard to follow.</p>\n\n\n\n<p>This has also held developers back from building libraries, scripts, and tools that could benefit the entire development community as a whole. Everyone builds their own things in-house, and the block directory is making a promise for more of the same.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jul 2020 20:38:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"BuddyPress: BuddyPress 6.2.0 beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=312990\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://buddypress.org/2020/07/buddypress-6-2-0-beta/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2350:\"<p>Hi BuddyPress contributors!</p>\n\n\n\n<p>We will soon publish a maintenance release (<strong>6.2.0</strong>) to prepare BuddyPress to some changes that will introduce WordPress next major release (5.5.0). WordPress 5.5.0 is slated for August 11, and we&#8217;d love you to help us use the coming days to make sure your favorite community engine is ready to fully enjoy this new version of WordPress.</p>\n\n\n\n<p>BuddyPress 6.2.0 will make sure our BP Email feature is using the 6.0 version of PHPMailer when WordPress 5.5.0 is installed on your site and will carry on using its version 5.2 when your WordPress version is lower (4.8 to 5.4 for the supported versions of our 6.0 branch). For more information about it, please have a look to this <a href=\"https://buddypress.trac.wordpress.org/ticket/8322\">ticket</a>.</p>\n\n\n\n<p>If you&#8217;re a plugin or a theme developer and are extending our BP Email feature, we strongly advise you to test your code with the latest pre-release of WordPress 5.5.0 (eg: <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-3/\">5.5.0-beta3</a>) and BuddyPress <a href=\"https://downloads.wordpress.org/plugin/buddypress.6.2.0-beta1.zip\">6.2.0-beta1</a>.</p>\n\n\n\n<p>WordPress 5.5.0 will also <a href=\"https://make.wordpress.org/core/2020/06/29/updating-jquery-version-shipped-with-wordpress/\">remove the jQuery Migrate library</a>, as BuddyPress uses a lot jQuery, we&#8217;ve been checking the impact of this removal. We haven&#8217;t found any issue so far, but if you do, please warn us about it commenting this <a href=\"https://buddypress.trac.wordpress.org/ticket/8333\">ticket</a>.</p>\n\n\n\n<p>A detailed changelog will be part of our official release notes, but, until then, you can check out this&nbsp;<a href=\"https://buddypress.trac.wordpress.org/query?status=closed&group=resolution&milestone=6.2.0\">report on Trac</a>&nbsp;for the full list of fixes.</p>\n\n\n\n<p>You can test the <a href=\"https://downloads.wordpress.org/plugin/buddypress.6.2.0-beta1.zip\">6.2.0-beta1</a> pre-release in 2 ways :</p>\n\n\n\n<ul><li>Use the <a href=\"https://wordpress.org/plugins/bp-beta-tester/\">BP Beta Tester</a> plugin.</li><li><a href=\"https://downloads.wordpress.org/plugin/buddypress.6.2.0-beta1.zip\">Download the 6.2.0 beta release here (zip file)</a>.</li></ul>\n\n\n\n<p>Thanks in advance for your contributions.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jul 2020 00:45:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mathieu Viet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Google Delays Mobile-First Indexing Deadline to March 2021\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102262\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:181:\"https://wptavern.com/google-delays-mobile-first-indexing-deadline-to-march-2021?utm_source=rss&utm_medium=rss&utm_campaign=google-delays-mobile-first-indexing-deadline-to-march-2021\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3509:\"<p>Google had set September 2020 as the deadline for when it would begin to fully switch over to crawling and indexing sites using mobile-first indexing but announced today that site owners will have more time to prepare. The deadline has been <a href=\"https://webmasters.googleblog.com/2020/07/prepare-for-mobile-first-indexing-with.html\">extended to March 2021</a>. </p>\n\n\n\n<p>Mobile-first indexing is a long-term plan that Google began rolling out in July 2019 by enabling it for new domains. The company cited &ldquo;these uncertain times&rdquo; as the reason for delaying the next phase of the rollout. The announcement also referenced further testing that showed a number of common issues sites are having in making the transition. Google urged site owners to pay close attention to several important issues:</p>\n\n\n\n<ul><li>Robots meta tags on mobile version should match the desktop version or Google may fail to index or follow links on the page.</li><li>Do not lazy-load primary content based on user interactions (like swiping, clicking, or typing), because the Googlebot doesn&rsquo;t trigger these user interactions.</li><li>Avoid the bad practice of using smaller images on mobile to fit the smaller screen. Small and low quality image will not be favorably indexed.</li><li>Ensure content on the mobile version matches the desktop, since only the mobile version will be used for indexing and ranking in Search. </li><li>Include meaningful alt text for images.</li></ul>\n\n\n\n<p>Google also outlined several other tips for image and video markup and placement. The announcement is essentially a tutorial for how to improve common mistakes that can negatively impact mobile ranking and indexing.</p>\n\n\n\n<p>Since mobile-first indexing is already enabled for most currently crawled sites, some speculated that the delayed deadline was due to hastily migrated mobile subdomain sites. John Mueller, Webmaster Trends Analyst at Google, confirmed this is the case and advised site owners to avoid this dated approach and update at the nearest opportunity.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">That\'s basically the inverse of how it was before, when desktop URLs were sometimes shown in mobile serps. Ideally, you\'d redirect by device type. M-dot sites do make things harder; for new sites I\'d avoid them, for older sites, I\'d fix with the next bigger revamp.</p>&mdash; &#127820; John &#127820; (@JohnMu) <a href=\"https://twitter.com/JohnMu/status/1285877309862563840?ref_src=twsrc%5Etfw\">July 22, 2020</a></blockquote>\n</div>\n\n\n\n<p>Before the advent of responsive design, many WordPress site owners added plugins that would create a separate mobile site to provide a more mobile-friendly browsing experience. Website visitors soon expected the entire web to be available to them on the devices they carried around in their pockets. This is now the primary way that people interact with the web, and Google&rsquo;s mobile-first indexing is a reflection of this new reality.</p>\n\n\n\n<p>If your WordPress site is still relying on a plugin to create a separate mobile site, or if you are using a plugin for lazy loading, make sure that the solution you have in place is following  Google&rsquo;s <a href=\"https://developers.google.com/search/mobile-sites/mobile-first-indexing\">mobile-first indexing best practices</a>. There are still 9 months remaining before Google makes mobile-first indexing and ranking the default for the entire web.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jul 2020 23:20:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: Zero BS CRM Rebrands and Relaunches as Jetpack CRM\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102138\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:165:\"https://wptavern.com/zero-bs-crm-rebrands-and-relaunches-as-jetpack-crm?utm_source=rss&utm_medium=rss&utm_campaign=zero-bs-crm-rebrands-and-relaunches-as-jetpack-crm\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5649:\"<img />Jetpack CRM welcome screen.\n\n\n\n<p class=\"has-drop-cap\">Mike Stott, co-creator of Zero BS CRM, <a href=\"https://jetpack.com/2020/07/20/introducing-jetpack-crm/\">announced the launch of Jetpack CRM</a> on Monday. The news was the seemingly inevitable rebranding of the original plugin that he and Woody Hayday had built. Automattic, the owner of the Jetpack plugin, acquired the project almost a year ago. While <a href=\"https://wordpress.org/plugins/zero-bs-crm/\">Jetpack CRM</a> carries the &ldquo;Jetpack&rdquo; name, it is still a standalone project and has a <a href=\"https://jetpackcrm.com/\">dedicated website</a>.</p>\n\n\n\n<p>CRM stands for &ldquo;customer relationship management.&rdquo; Such systems allow businesses to manage relationships through an interface but can vary extensively in user experience. The goal is to manage contacts, sales, and productivity through the software.</p>\n\n\n\n<p>The duo of Stott and Hayday have had a bit of a journey in the past year. In August 2019, <a href=\"https://wptavern.com/automattic-acquires-zero-bs-crm-considers-rebranding-it-as-jetpack-crm\">Automattic acquired the project</a> and provided the resources for the team to continue working on Zero BS CRM. The <a href=\"https://wptavern.com/zero-bs-crm-3-0-improves-ui-changes-database-structure-and-becomes-more-extendable\">3.0 launch</a> in December 2019 was a massive undertaking that included a major database change and UI improvements. Since then, they have worked toward rebranding the project. Stott also did this with a newborn in his family.</p>\n\n\n\n<p>When version 3.0 of Zero BS CRM launched, Stott said they were still discussing whether to rebrand and bring the plugin under the Jetpack umbrella. They were gathering user feedback at the time, but his primary focus was on developing features. The name was not the foremost thing on his mind. However, branding can make or break even a good project, and Jetpack is as close to a household name as any product coming out of the WordPress ecosystem. It made sense to lean on that branding.</p>\n\n\n\n<p>&ldquo;Jetpack&rsquo;s mission is to help entrepreneurs and small businesses succeed by providing tools that keep their sites fast and secure,&rdquo; said Stott. &ldquo;We felt that from within the Automattic family, this was a great match. We created ZBS CRM with the same end goal in mind &mdash; helping you succeed through better customer relationships, so it just made sense.&rdquo;</p>\n\n\n\n<p>After nearly a year beyond the acquisition, Stott feels like things are going great within the new environment at Automattic. &ldquo;We&rsquo;ve found the right product fit within Automattic,&rdquo; he said. &ldquo;In Jetpack, we&rsquo;re happy that we can really push the CRM, and it&rsquo;s exciting to be part of the bigger WordPress family and being able to integrate with WooCommerce, etc.&rdquo;</p>\n\n\n\n<p>Version 4.0 of the plugin primarily changes the branding in the admin and lightens the UI background. The team has also continued to add small changes.</p>\n\n\n\n<p>&ldquo;Looking ahead, we&rsquo;re excited to continue developing the CRM following user feedback,&rdquo; said Stott. &ldquo;We&rsquo;ll be working on our roadmap and, of course, how we can best integrate with the Jetpack family.&rdquo;</p>\n\n\n\n<h2>Growing and the Future</h2>\n\n\n\n<p class=\"has-drop-cap\">Jetpack CRM currently has 3,000+ active installs. This is up from 2,000 since the launch of version 3.0 last December. It has been a slow road thus far. However, there is room for growth. The leading CRM plugin, Hubspot, has 100,000+ active installs. There should be plenty of room for competing plugins in the CRM market.</p>\n\n\n\n<p>&ldquo;There&rsquo;s a massive opportunity for CRM in the WordPress space,&rdquo; said Stott. &ldquo;A CRM is not like installing an SEO plugin on every website you own &mdash; generally you&rsquo;d only have a single CRM for your business &mdash; but it&rsquo;s the core of your business. The fact that 3,000+ users and counting are choosing WordPress to run their CRM is a great start.&rdquo;</p>\n\n\n\n<p>The Jetpack brand should help spur some of the growth, particularly if Automattic pushes it as an add-on within the primary Jetpack plugin.</p>\n\n\n\n<p>&ldquo;[Jetpack] has substantial reach among website owners who would benefit from a CRM but may not know what a CRM is,&rdquo; said Stott. &ldquo;While we&rsquo;re happy that the plugin is still growing organically, we are just about set up to really push Jetpack CRM with full force.&rdquo;</p>\n\n\n\n<p>Stott believes the Hubspot comparison isn&rsquo;t apples-to-apples. Unlike Jetpack CRM, the Hubspot plugin pushes users to an app that is hosted off-site.</p>\n\n\n\n<p>&ldquo;While this makes sense for some users, it doesn&rsquo;t really take advantage of the huge benefits that native WordPress plugins offer,&rdquo; he said. &ldquo;Jetpack CRM sits on the user&rsquo;s servers. Users manage and control their own data &mdash; a huge win under the GDPR whereas a site owner you&rsquo;re legally required to know where your data is held. Not to mention that the plugin is also extendable.&rdquo;</p>\n\n\n\n<p>Stott said he has always loved the WordPress community&rsquo;s open-source approach and the freedoms that it provides to build something custom or extend what is already there. There should be ample opportunity for developers to extend Jetpack CRM&rsquo;s codebase.</p>\n\n\n\n<p>&ldquo;To my mind, there has never been a more exciting time for plugins like Jetpack CRM, which we envision as the &lsquo;business layer&rsquo; for modern entrepreneurs, much like WooCommerce has democratized eCommerce,&rdquo; he said.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jul 2020 19:21:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Unsplash Launches Official Plugin for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=101136\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:159:\"https://wptavern.com/unsplash-launches-official-plugin-for-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=unsplash-launches-official-plugin-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6658:\"<p><a href=\"https://unsplash.com/\">Unsplash</a> has released its own <a href=\"https://wordpress.org/plugins/unsplash/\">official plugin for WordPress</a>, co-developed with the team at <a href=\"https://xwp.co/\">XWP</a>. The plugin seamlessly connects Unsplash&rsquo;s 1 million+ free high-resolution image library with the WordPress editor.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<a href=\"https://cloudup.com/cUQ5pBCD6jD\"><img src=\"https://cldup.com/3UUPV-2ayL.gif\" alt=\"Post usage 1\" width=\"1100\" height=\"612\" /></a>\n</div>\n\n\n\n<p>Users can easily search Unsplash directly inside the custom block and insert images with attribution and alt description info automatically filled in. The selected images are download and added to the WordPress media library, saving users the trouble of having to leave their dashboards to search, download, and upload images. </p>\n\n\n\n<p>Unsplash co-founder Luke Chesser described the project as &ldquo;bringing the internet&rsquo;s image library to the internet&rsquo;s publishing platform.&rdquo; Although the plugin is useful for any type of website &ndash; from small blogs to businesses, it was large publishing organizations that provided the impetus for Unsplash to develop an official integration for WordPress.</p>\n\n\n\n<p>&ldquo;We&rsquo;ve been working with a lot of publishers as they integrate Unsplash into their publishing flows to replace legacy solutions,&rdquo; Chesser said. &ldquo;With so many publishers being powered by WordPress, we saw a repeated need for a high quality integration that could be shared by all of the publishers. In order to best serve them, we needed to offer something that we could ensure met their needs both now and in the future.&rdquo;</p>\n\n\n\n<p><a href=\"https://wordpress.org/plugins/instant-images/\">Instant Images</a>, a plugin that boasts one-click Unsplash uploads, is currently the largest competitor to the adoption of the official plugin with more than 50,000 active installs. Many other plugins have also added some form of Unsplash integration in the past. Chesser said his team has loved seeing the variety of applications developers have created with their API and they were hesitant to create their own plugin.</p>\n\n\n\n<p>&ldquo;We saw a gap between the things big and small publishers were telling us, and the way the existing plugins had been developed,&rdquo; he said. &ldquo;Most existing plugins reupload the image to the WordPress library and then treat it as a standard image, which breaks a handful of things:</p>\n\n\n\n<ul><li>Image attribution to the original photographer is usually lost (or is no longer supported past the first usage)</li><li>The time it takes for the server to download the image and then reupload it can be slow</li><li>Out of the box, WordPress&rsquo;s current support for dynamic image URLs that adapt to the device connection and screen size is limited and by using the&nbsp;Unsplash&nbsp;CDN, we could ensure that the right size image is served to better optimize for performance.&rdquo;</li></ul>\n\n\n\n<p>When developing the official plugin, Unsplash and XWP took feedback from publishers and aimed to improve on how existing plugins handled images. After testing it, I found the search feature was fast and setup was a breeze. The plugin handles everything for the user invisibly in the background and its integration with the block editor makes it feel like a natural part of WordPress.</p>\n\n\n\n<h2>Unsplash Aims to Increase Its Audience by Enhancing the Publishing Workflow for WordPress Publishers</h2>\n\n\n\n<p>As Unsplash looks to define a new economic model around photography, WordPress-powered sites are a major consideration, since the platform powers <a href=\"https://w3techs.com/technologies/details/cm-wordpress\">more than 37%</a> of Alexa&rsquo;s&nbsp;top 10 million&nbsp;websites.</p>\n\n\n\n<p>Seven years after it started as a Tumblr blog, Unsplash is moving to directly monetize the site by working with brands to create photos that will appear in search results. &ldquo;Unsplash for Brands&rdquo; launched in December 2019 as an answer to the question of how Unsplash will make money. Companies pay to have their branded images show up prominently in search results alongside other organically ranking images that match users&rsquo; queries. </p>\n\n\n\n<p>&ldquo;While they serve completely different purposes, I think a lot of brands are growing tired of the state of digital advertising today, with Facebook and Google having a host of problems around privacy, targeting, and negative consequences for culture,&rdquo; Chesser said. &ldquo;Unsplash&nbsp;allows brands to influence the visual mindshare of the internet while having an authentic and positive impact on their audience.&rdquo;&nbsp;</p>\n\n\n\n<p>Launching an official WordPress plugin is a strategic move for Unsplash as it puts those branded images in front of a larger audience with users searching directly within the editor. Although the company continues to push out new features to the&nbsp;Unsplash&nbsp;API, many publishers did not have the resources to create their own integrations.</p>\n\n\n\n<p>&ldquo;After so many conversations with publishers, both big and small, that want to integrate the&nbsp;Unsplash&nbsp;library but can&rsquo;t due to resources, we felt that we needed to offer something more ready to use than the raw API or SDKs,&rdquo; Chesser said.</p>\n\n\n\n<p>&ldquo;We built the current version of the&nbsp;Unsplash&nbsp;for WordPress plugin so that it meets those needs of publishers now, but we know that we can push it a lot further in the future.&rdquo; </p>\n\n\n\n<p>The first iteration of the plugin mirrors the flow and features that a user would have while navigating unsplash.com, while keeping the writer inside the editor. Now that Unsplash is integrated into the WordPress publishing flow, Chesser sees the opportunity to add more interesting features. Open sourcing the plugin also has the potential to increase Unsplash&rsquo;s audience as developers extend its core features for use in other plugins.</p>\n\n\n\n<p>&ldquo;Using the context of the post, we can help suggest images or prefill a search using natural language processing,&rdquo; Chesser said. &ldquo;We can link together&nbsp;Unsplash&nbsp;images with other WordPress tools to help publishers edit and process images directly in their posts. And with a lot of the work from the plugin being focused on making&nbsp;Unsplash&nbsp;images work natively inside of the WordPress Media Library, we can even open-source the core in such a way that developers can extend and reuse the functionality, avoiding duplication across all of our third party WordPress plugins.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Jul 2020 23:33:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: Why Accessibility Matters for WordPress Themes and Their Users\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102133\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:189:\"https://wptavern.com/why-accessibility-matters-for-wordpress-themes-and-their-users?utm_source=rss&utm_medium=rss&utm_campaign=why-accessibility-matters-for-wordpress-themes-and-their-users\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:13307:\"<p>&ldquo;Do you ever read the subtitles on a video so you didn&rsquo;t need to unmute it?&rdquo; asked William Patton, a representative from the WordPress Themes Team. &ldquo;Used the &lsquo;beep&rsquo; from a crosswalk to know when to cross the road? Found yourself reading the info panel at an airport? Those things are considered features, but in reality, they are aids for people with additional needs.&rdquo;</p>\n\n\n\n<p>As I talked with Patton and other reps from the Themes Team, it was clear they believed accessibility was a vital piece of the theme-building puzzle. The team has made small moves in the last year to bring more themes up to standards. However, it has been a slow-going process.</p>\n\n\n\n<p>Last July, the <a href=\"https://wptavern.com/wordpress-theme-review-team-initiates-new-long-term-plan-to-make-all-wordpress-org-themes-accessible\">team initiated a plan</a> to add a new guideline every two months or so that would address a single accessibility issue. It would become every theme author&rsquo;s responsibility to make sure they were meeting the new guidelines. It would be every reviewer&rsquo;s responsibility to understand how to test guidelines as they were implemented. Thus far, the team has required only that themes have a working skip-to-content link and keyboard-capable navigation menus.</p>\n\n\n\n<p>Not every theme author was excited about the move. Some have still shown resistance a year later.</p>\n\n\n\n<p>Last week, we covered the Astra theme&rsquo;s news of hitting 1 million active installs. A <a href=\"https://wptavern.com/astra-becomes-the-only-non-default-wordpress-theme-with-1-million-installs#comment-335038\">commenter made a point</a> that the data shows that end-users do not care about accessibility &mdash; the Astra theme makes no mention of being accessibility-ready. The conclusion was that the Themes Team should not be implementing such guidelines based on the success of one of the directory&rsquo;s most popular themes.</p>\n\n\n\n<p>While there are several things we could do to pick apart the original comment and the limited view of the situation, we can instead use it as a catalyst to discuss why accessibility is something that should be at the forefront of every theme author&rsquo;s mind. Patton, along with Themes Team representatives Carolina Nymark and Denis &#381;oljom, had a lot to say on the subject.</p>\n\n\n\n<p>The overarching theme was that awareness is vital and that theme developers play a crucial role in making the web more accessible.</p>\n\n\n\n<h2>Awareness Is Key</h2>\n\n\n\n<img />\n\n\n\n<p>&#381;oljom likened the awareness of accessibility to that of a cisgender person looking at the world from the perspective of a transgender person. Once he became aware of larger issues, he made sure to address gender-specific pronouns in his code comments, such as replacing instances of &ldquo;he&rdquo; with &ldquo;they.&rdquo; He hopes such small changes spark similar changes from others.</p>\n\n\n\n<p>He said the situation was the same with accessibility. &ldquo;It might not mean much to a person who doesn&rsquo;t have any disabilities, but putting yourself in somebody else&rsquo;s shoes changes one&rsquo;s perspective. This is why we started to include things like skip links, keyboard nav, etc.&rdquo;</p>\n\n\n\n<p>The team does not hope theme authors will merely become technically proficient at addressing accessibility issues in their themes. While that would be a help from a review standpoint, it addresses only the symptoms rather than root causes of the issues. Instead, by making more developers aware, they will begin to look at development from multiple perspectives. They will ask how a screen-readers will handle their theme. They will ask whether their colors have enough contrast for low-vision users to read. They will wonder if non-mouse users can navigate their users&rsquo; sites.</p>\n\n\n\n<p>The technical stuff is the easy part. Changing perspectives and becoming more empathetic toward those who are different is much more difficult. But not impossible.</p>\n\n\n\n<p>&ldquo;A lot of us who build for the web are lacking some basic insights into what it is like to have additional needs beyond what is our own normal,&rdquo; said Patton. &ldquo;There is a saying: &lsquo;if you could see it through my eyes, you would see it differently.&rsquo; If you could see through the eyes of someone with color blindness or impaired vision, you quite literally would see things differently.&rdquo;</p>\n\n\n\n<p>The trouble with humans, in general, is that it can sometimes be hard to see things through someone else&rsquo;s eyes. Of course, there are tools to simulate accessibility issues for developers, so that helps. However, these tools do not replicate what it is like to walk through life with a particular impairment or disability. Some of us can only partially glimpse the difficulties that others may have when navigating the web. This does not mean that we cannot address the downfalls of the software we build and become more inclusive to all people, especially if we are proactive when issues are raised.</p>\n\n\n\n<p>Nymark identified a few areas where the community can improve awareness:</p>\n\n\n\n<ul><li>Make sure that all contributors are aware of the WordPress accessibility requirements so that all new features are accessible.</li><li>Highlight accessibility improvements when WordPress is updated.</li><li>Feature more diverse use cases and highlight areas where the accessibility that is built into WordPress has helped people share and access important content.</li></ul>\n\n\n\n<p>&ldquo;The themes team hopes that by making theme authors aware of accessibility issues, authors will learn that even small changes to their code and design can have a great positive impact,&rdquo; she said.</p>\n\n\n\n<h2>Is Accessibility Important to End-Users?</h2>\n\n\n\n<img />\n\n\n\n<p>Certainly, accessibility is important for <em>some</em> users. It certainly mattered to Guillermo Robles, a blind man who sued pizza chain Domino&rsquo;s in 2016 for an inaccessible website. The court case was important enough that it moved through the system all the way to the U.S. Supreme Court. Ultimately, the <a href=\"https://wptavern.com/u-s-supreme-court-denies-dominos-appeal-to-determine-whether-websites-must-be-accessible\">higher court denied Domino&rsquo;s appeal</a> of an earlier ruling. The U.S. 9th Circuit court had previously ruled that business websites fall under Title III of the American with Disabilities Act (ADA) and must meet accessibility standards.</p>\n\n\n\n<p>This was a landmark case in the U.S. for accessibility advocates last October. It is also worth remembering as we near the upcoming 30th anniversary of the ADA on July 26.</p>\n\n\n\n<p>Domino&rsquo;s is a billion-dollar business. The company has enough money to fight such battles for years. They also have the money to hire world-class web developers to correct any accessibility issues.</p>\n\n\n\n<p>However, for small business owners, hiring a single developer, much less an entire agency or team, is often a non-starter. Many small businesses are fortunate to break even. WordPress and its ecosystem of free or low-cost solutions have democratized eCommerce on a scale previously unwitnessed. It means that mom-and-pop stores can have an online presence. It means teens can begin selling their custom art and a multitude of others can make money online without the backing of wads of cash.</p>\n\n\n\n<p>For these small business owners, many are unaware of accessibility concerns. They pick up a few plugins and find a theme that suitably matches their branding. The possibility of an impending accessibility-related lawsuit is the furthest thing from their mind. This is a major reason that WordPress needs to be a leader in meeting accessibility standards. Themes, which are the part of the site that visitors will interact with, are possibly the most important part of that equation.</p>\n\n\n\n<p>Some would argue that small business owners should understand the laws of their jurisdiction. That is true. However, it is also partly the responsibility of the software creators, says the Theme Team representatives.</p>\n\n\n\n<p>&ldquo;Yes, the technology should account for additional needs,&rdquo; said Patton. &ldquo;Yes, the tooling should enable people to make good choices with regards to this. Yes, it should be easy to meet a minimum level of accessibility in the things we create with ease. Yes, it should be a fair assumption that the choices available to pick from are accessible.&rdquo;</p>\n\n\n\n<p>The web is inherently accessible out of the box. Raw HTML is read and output by web browsers in such a way that the content can be accessed by anyone. Patton says that it is the things that developers do from that point forward that makes that experience better or worse.</p>\n\n\n\n<p>&ldquo;Trade-offs are made that are well-intentioned but not always helpful,&rdquo; he said. &ldquo;Design trade-offs are the easiest to point out. Taking text and embedding it into an image means that some of its value is lost in exchange for it looking pretty. Using closely matching colors for text and background might create an interesting effect to some people but for others, it makes it impossible to read. Sometimes it&rsquo;s about balancing those trade-offs with the needs of others, but it is those kinds of trade-offs that most people struggle to give up.&rdquo;</p>\n\n\n\n<p>Nymark described some more technical issues that the average end-user should expect to simply be a non-issue. For example, it is reasonable to assume that a theme installed from the official WordPress directory would be free from HTML, PHP, and JavaScript errors. These are items that users should not have to worry about checking before activating the theme on their site. The errors should simply not exist.</p>\n\n\n\n<p>It is that level of quality control that end-users should expect in terms of accessibility, an assurance that the theme does all the things it is supposed to do. It is not about whether end-users &ldquo;care&rdquo; about accessibility.</p>\n\n\n\n<p>&ldquo;If a form on a shop checkout page is not working, this can lead to loss of income,&rdquo; she said. &ldquo;Users rely on the technical solution provided by plugins and themes and expect everyone to be able to use their shop. Whether or not the site owner recognizes this as an accessibility issue is irrelevant because their page just needs to work.&rdquo;</p>\n\n\n\n<h2>Why Theme Authors Should Care</h2>\n\n\n\n<img />\n\n\n\n<p>&ldquo;If those who choose themes don&rsquo;t consider accessibility and the theme author did not consider it, then the [visitors] of the sites built with those themes are the ones that lose out,&rdquo; said Patton. &ldquo;It&rsquo;s not a huge leap to realize that low accessibility on your site directly equates to a reduction of potential users.&rdquo;</p>\n\n\n\n<p>He said that end-users would naturally assume the themes they are picking from do not have accessibility issues. However, that assumption is typically far from accurate.</p>\n\n\n\n<p>&ldquo;Theme authors should care about the accessibility of their creations so that the people picking their themes don&rsquo;t need to use it as a deciding factor,&rdquo; he said.</p>\n\n\n\n<p>My go-to response is that developers should concern themselves with accessibility because it is for the collective good. Humans should care about making sure that all other humans have the same freedoms that they enjoy, which are often take for granted.</p>\n\n\n\n<p>Even those who cannot view it from that perspective should be able to appreciate that it is a smart business decision. It makes little sense to leave money on the table, especially if you are a developer who is selling a theme or upselling additional features on top of a free theme. There is an entire segment of users that represents money lost.</p>\n\n\n\n<p>Additionally, more and more countries are implementing laws around web accessibility. Over time, such laws will be commonplace, particularly in the business sector. Inaccessible themes will lose users as such laws are enforced. Now is a good time to get ahead of impending change.</p>\n\n\n\n<h2>More Guidelines Ahead</h2>\n\n\n\n<p>The WordPress Themes Team has been slow about adopting additional guidelines surrounding accessibility. However, more are expected to land at some point. Team reps want to work with authors and reviewers alike to make the transition as painless as possible.</p>\n\n\n\n<p>&ldquo;We have not added anything else because theme authors are still not releasing themes with working implementations of skip links and usable keyboard navigation,&rdquo; said Patton. &ldquo;When those two things become habitual, it will be time to introduce another aspect as a requirement.&rdquo;</p>\n\n\n\n<p>The next guideline in line is expected to be underlined links in the post content. This would be an easy win if the team can get past the current stage. Right now, the team reps are unsure when that will happen.</p>\n\n\n\n<p>&ldquo;The fact that this has taken so long for authors to get this right probably indicates that we need to do better at guiding them to resources to learn how to do it and why it is important,&rdquo; said Patton. &ldquo;Perhaps that is a better avenue to pursue than looking to implement additional asks of them.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Jul 2020 19:48:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"WordPress.org blog: WordPress 5.5 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8706\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3830:\"<p>WordPress 5.5 Beta 3 is now available!</p>\n\n\n\n<p id=\"block-81bd56b9-ea44-43ad-ab36-a5ae78b54375\"><strong>This software is still in development,</strong>so it’s not recommended to run this version on a production site. Consider setting up a test site to play with the new version.</p>\n\n\n\n<p id=\"block-7cc1bbc6-17f9-44c5-8f67-da4e3059ad69\">You can test WordPress 5.5 Beta 3 in two ways:</p>\n\n\n\n<ul id=\"block-4840af57-f44b-4d9f-aa64-c6a452392e42\"><li>Try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (choose the “bleeding edge nightlies” option)</li><li>Or <a href=\"https://wordpress.org/wordpress-5.5-beta3.zip\">download the beta here</a> (zip).</li></ul>\n\n\n\n<p id=\"block-a40528cb-eb3b-4c8a-8f5e-aa700f1ba086\">WordPress 5.5 is slated for release on <a href=\"https://make.wordpress.org/core/5-5/\">August 11th, 2020</a>, and <strong>we need your help to get there</strong>!</p>\n\n\n\n<p>Thank you to all of the contributors who tested the <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-2/\">beta 2</a> development release and gave feedback. Testing for bugs is a critical part of polishing every release and a great way to contribute to WordPress. </p>\n\n\n\n<h2 id=\"block-15d6d57f-905d-4a47-9f66-839468a5375a\">Some highlights</h2>\n\n\n\n<p id=\"block-85da84ec-c841-42f9-8d3b-1a4537a61d10\">Since <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-2/\">beta 2</a>, <a href=\"https://core.trac.wordpress.org/query?status=closed&changetime=07%2F15%2F2020..07%2F21%2F2020&milestone=5.5&group=component&col=id&col=summary&col=owner&col=type&col=priority&col=component&col=version&order=priority\">43 bugs</a> have been fixed. Here are a few changes in beta 3:</p>\n\n\n\n<ul><li>Plugin and theme versions are now shared in the emails when automatically updated (see <a href=\"https://core.trac.wordpress.org/ticket/50350\">#50350</a>).</li><li>REST API routes without a <code>permission_callback</code> now trigger a <code>_doing_it_wrong()</code> warning (see <a rel=\"noreferrer noopener\" target=\"_blank\" href=\"https://core.trac.wordpress.org/ticket/50075\">#50075</a>).</li><li>Over 23 Gutenberg changes and updates (see <a href=\"https://github.com/WordPress/gutenberg/pull/24068\">#24068</a> and <a href=\"https://core.trac.wordpress.org/ticket/50712\">#50712</a>).</li><li>A bug with the new import and export database Dashicons has been fixed (see <a href=\"https://core.trac.wordpress.org/ticket/49913\">#49913</a>).</li></ul>\n\n\n\n<h2 id=\"block-76156b2b-0a52-4502-b585-6cbe9481f55b\">Developer notes</h2>\n\n\n\n<p id=\"block-3fe5e264-0a95-4f12-9a18-0cb9dc5955d1\">WordPress 5.5 has lots of refinements to polish the developer experience. To keep up, subscribe to the <a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a> and pay special attention to the <a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">developers’ notes</a> for updates on those and other changes that could affect your products.</p>\n\n\n\n<h2 id=\"block-bc89fd56-47b0-439f-8e2c-4a642c80a616\">How to Help</h2>\n\n\n\n<p id=\"block-3ff83a77-8b54-4061-ae2d-45fc984cbd76\">Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev/\">Help translate WordPress into more than 100 languages</a>!</p>\n\n\n\n<p id=\"block-9d871099-ec49-446c-8322-9e49b7498c10\">If you think you’ve found a bug, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area</a> in the support forums. We’d love to hear from you!</p>\n\n\n\n<p id=\"block-bd71c1d3-39d9-4b2a-8193-3486497b45fd\">If you’re comfortable writing a reproducible bug report, <a href=\"https://core.trac.wordpress.org/newticket\">file one on WordPress Trac</a>, where you can also find a list of <a href=\"https://core.trac.wordpress.org/tickets/major\">known bugs</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Jul 2020 17:51:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jake Spurlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: WordPress 5.5 to Remove Hulu from List of Supported oEmbed Providers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102148\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:201:\"https://wptavern.com/wordpress-5-5-to-remove-hulu-from-list-of-supported-oembed-providers?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-5-5-to-remove-hulu-from-list-of-supported-oembed-providers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2311:\"<p>WordPress 5.5 will be dropping Hulu oEmbed support after Hulu silently disabled its oEmbed API. This is the API that allows users to copy and paste a link into the editor and have it automatically embed the content, as opposed to copying a chunk of embed code. Documentation contributors <a href=\"https://github.com/WordPress/gutenberg/issues/23920\">discovered that it wasn&rsquo;t working</a> while attempting to document the Hulu Embed block.</p>\n\n\n\n<p>Birgit Pauli-Haack confirmed with Hulu that embedding is not currently an option. Hulu support did not elaborate on why it was removed.<a href=\"https://wptavern.com/wp-admin/edit.php?post_type=post\"></a></p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">Apologies for any disappointment! This isn\'t an available option at the moment, but we\'ll express your interest. If there\'s anything else we can help out with down the road, please don\'t hesitate to reach back out!</p>&mdash; Hulu Support (@hulu_support) <a href=\"https://twitter.com/hulu_support/status/1283562756726300672?ref_src=twsrc%5Etfw\">July 16, 2020</a></blockquote>\n</div>\n\n\n\n<p>The block currently displays an error when attempting to embed a Hulu link, stating &ldquo;Sorry, this content could not be embedded.&rdquo; As a result, WordPress contributors have <a href=\"https://core.trac.wordpress.org/changeset/48512\">removed</a> both the block from the editor and the provider from core. </p>\n\n\n\n<p>WordPress has included Hulu <a href=\"https://wordpress.org/support/article/embeds/#okay-so-what-sites-can-i-embed-from\">oEmbed support</a> for the past 11 years, since it was first added in <a href=\"https://wordpress.org/support/wordpress-version/version-2-9/\">WordPress 2.9</a> (December 2009). Services are <a href=\"https://wordpress.org/support/article/embeds/#okay-so-what-sites-can-i-embed-from\">logged</a> on WordPress.org as they are added or removed. Hulu was removed as soon as it was discovered that oEmbed support no longer worked, similar to other <a href=\"https://core.trac.wordpress.org/ticket/45399\">previously unsupported providers</a> &ndash; most recently FunnyOrDie and Photobucket. This is a major loss of convenience for users who are trying to embed Hulu links but it lies outside of WordPress&rsquo; control. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Jul 2020 22:48:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: Theme Authors Can Pass Data to Template Files in WordPress 5.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102136\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:189:\"https://wptavern.com/theme-authors-can-pass-data-to-template-files-in-wordpress-5-5?utm_source=rss&utm_medium=rss&utm_campaign=theme-authors-can-pass-data-to-template-files-in-wordpress-5-5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4777:\"<p class=\"has-drop-cap\">Theme developers can finally rejoice. For the first time, it is now possible to pass data to templates via the various core template-loading functions. Enrico Sorcinelli <a href=\"https://make.wordpress.org/core/2020/07/17/passing-arguments-to-template-files-in-wordpress-5-5/\">announced the change</a> on the Make Core blog this past Friday.</p>\n\n\n\n<p>The <a href=\"https://core.trac.wordpress.org/ticket/21676\">feature was originally proposed</a> by Scott Kingsley Clark in 2012. Over the years, the ticket has received a dozen patches. It has survived a closure and arguments over why the feature should not go into core. Sorcinelli was a primary driver that kept the ticket alive for the last few years.</p>\n\n\n\n<p>WordPress developers have been cleaning up some old-but-useful feature requests for the 5.5 release cycle. A couple of weeks ago, an 11-year-old ticket to allow users to <a href=\"https://wptavern.com/after-11-years-users-will-be-able-to-update-themes-and-plugins-via-a-zip-file\">update themes and plugins via a ZIP file</a> made the cut. Core developers even closed a 9-year-old ticket related to an <a href=\"https://core.trac.wordpress.org/ticket/17232\">Internet Explorer 6 hack</a> &mdash; <em>progress</em>. However, for theme authors, one of the most important additions is control over passing data from one template to another.</p>\n\n\n\n<p>Typically, in PHP, variables can be passed from file to file because they remain in the same scope. However, that is not the case if the inclusion of the file is taken out of that scope by including the file from inside of a function. The scope is then limited to the function. That is how the template system works in WordPress. This is not necessarily a bad thing. However, it has meant that theme developers have had no built-in method of passing data from one template to the next.</p>\n\n\n\n<p>Imagine creating a variable in one template but needing to access that same variable in a sub-template. There is no shortage of methods to accomplish this, but many are inelegant.</p>\n\n\n\n<p>&ldquo;For years, theme developers wishing to pass data to template files have had to use less than ideal workarounds,&rdquo; wrote Sorcinelli in the announcement. The worst solutions typically involved creating a global variable. Others created custom template-loading functions on top of WordPress&rsquo;s existing system. The problem with all methods, regardless of which was ideal, was that no standard existed. Each theme would need to build its own solution, and plugins that touched the front end would often have a competing solution.</p>\n\n\n\n<p>All of the WordPress template-loading functions now support an additional parameter of <code>$args</code>, which allows theme authors to pass along an associative array of data to the loaded template. The functions that support this new parameter are:</p>\n\n\n\n<ul><li><code>get_header()</code></li><li><code>get_footer()</code></li><li><code>get_sidebar()</code></li><li><code>get_template_part()</code></li><li><code>locate_template()</code></li><li><code>load_template()</code></li></ul>\n\n\n\n<p>Any hooks associated with the functions also pass along the data.</p>\n\n\n\n<p>The <code>get_search_form()</code> function has supported a similar parameter since WordPress 5.2. In practice, it should work mostly the same, but the function has a couple of default values it sets.</p>\n\n\n\n<p>An additional benefit of having a standard method of passing data to templates is that the feature can be built upon in the future. For example, WordPress could eventually offer a hook for filtering the data, which could come in handy with child themes.</p>\n\n\n\n<p>The WordPress template system still lacks the robustness of more modern frameworks, but this simple change will allow for a variety of applications.</p>\n\n\n\n<p>One question remains: <em>is the arrival of this feature too late?</em> With WordPress on track to revamp the entire theme system to integrate with the upcoming full-site editing feature, will this feature be useful for only the next few months?</p>\n\n\n\n<p>Even if most theme developers don&rsquo;t immediately jump on board the block-based themes bandwagon for another year, the feature could come in handy  until they do. Perhaps it will also have some usefulness beyond the current theming paradigm.</p>\n\n\n\n<p>Developers still do not have a clear picture of what theming with blocks will look like in the next few years. There may be situations where passing dynamic data is still necessary in the next system. Even if not, it will likely be a long while before there is mass adoption of block-based themes from the existing theme development community. In the meantime, many will be able to drop in-house solutions and use standard functions.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Jul 2020 19:44:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"Matt: Corner Office Interview\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=51861\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://ma.tt/2020/07/corner-office-interview/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2488:\"<p>If you pick up a print edition of the Sunday New York Times today you&#8217;ll see <a href=\"https://www.nytimes.com/2020/07/12/business/matt-mullenweg-automattic-corner-office.html\">the Corner Office interview with David Gelles in the business section</a>. </p>\n\n\n\n<img />(Hat tip to <a href=\"http://www.maryconrad.org/\">Mary Conrad</a> for the picture, I haven&#8217;t seen it in person yet.)\n\n\n\n<p>A quote that seems to be resonating with people,</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>This column is called Corner Office, and most people who choose to have offices are usually the bosses. And I’ve been to the offices of billionaire C.E.O.s that have their own private bathroom, beautiful art and couches. But these are all things that you can have in your house. What I love about distributed organizations is every single employee can have a corner office.</p></blockquote>\n\n\n\n<p>Sometimes my corner office has been the corner of an airport floor next to a power outlet! I&#8217;ve also heard from colleagues that feel like their office feels like an unsupervised day care center since the quarantine started. The point I want to make is there&#8217;s a world of possibility that opens up when you move from the finite space of a shared office, and all the politics of dividing up the scarce resource of desirable space, to the <a href=\"https://www.amazon.com/Finite-Infinite-Games-James-Carse/dp/1476731713\">infinite game</a> where people can define their own &#8220;office&#8221; as the place where they will be most productive, and do so however they like with no penalties or restraints.</p>\n\n\n\n<p>If you had the best space in the legacy office, you probably liked it and may even have had motivated reasoning around ineffable things that happened in the office like &#8220;culture&#8221; that would be impossible without it, but the average experience of an entry-level worker was not as positive. Now there can be a much more even playing field. At <a href=\"https://automattic.com/\">Automattic</a> we have a home office allowance people can use to buy equipment they need to make their home work area comfortable and productive, and it&#8217;s the same if you&#8217;re leading a team of hundreds or if it&#8217;s your first job.</p>\n\n\n\n<p>If you&#8217;d like to hear the entire conversation <a href=\"https://www.youtube.com/watch?v=fFg6YcBB2uI&feature=youtu.be\">they&#8217;ve posted the original audio and interview</a> that was distilled into the print version.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 19 Jul 2020 21:13:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: All in One SEO Pack Plugin Patches XSS Vulnerability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102036\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"https://wptavern.com/all-in-one-seo-pack-plugin-patches-xss-vulnerability?utm_source=rss&utm_medium=rss&utm_campaign=all-in-one-seo-pack-plugin-patches-xss-vulnerability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1843:\"<p><a href=\"https://wordpress.org/plugins/all-in-one-seo-pack\">All in One SEO Pack</a> patched an XSS vulnerability this week that was <a href=\"https://www.wordfence.com/blog/2020/07/2-million-users-affected-by-vulnerability-in-all-in-one-seo-pack/\">discovered</a> by the security researchers at Wordfence on July 10. The popular plugin has more than 2 million active installs, according to WordPress.org.</p>\n\n\n\n<p>Wordfence researchers categorized it as &ldquo;a medium severity security issue&rdquo; that could result in &ldquo;a complete site takeover and other severe consequences:&rdquo;</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>This flaw allowed authenticated users with contributor level access or above the ability to inject malicious scripts that would be executed if a victim accessed the wp-admin panel&rsquo;s &lsquo;all posts&rsquo; page.</p></blockquote>\n\n\n\n<p>Version 3.6.2, released on July 15, 2020, includes the following update in the changelog: &ldquo;Improved the output of SEO meta fields + added additional sanitization for security hardening.&rdquo;</p>\n\n\n\n<p>All in One SEO Pack users are strongly recommended to update to the latest version. At the time of publishing, just 12% of the plugin&rsquo;s user base is running versions 3.6.x, which includes the three most recent versions. This leaves more than 1.7 million installations (88% of the plugin&rsquo;s users) vulnerable. </p>\n\n\n\n<p>Many users don&rsquo;t log into their WordPress sites often enough to learn about security updates in a timely fashion. Plugin authors often don&rsquo;t advertise the importance of the update on their websites or social media. This is the type of situation that WordPress 5.5 should help to mitigate, as it introduces admin controls in the dashboard that allow users to enable automatic updates for themes and plugins. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Jul 2020 21:48:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"WPTavern: WPCampus Online 2020 Conference Features Accessibility and Higher Education Topics, July 29-30\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=102003\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:251:\"https://wptavern.com/wpcampus-online-2020-conference-features-accessibility-and-higher-education-topics-july-29-30?utm_source=rss&utm_medium=rss&utm_campaign=wpcampus-online-2020-conference-features-accessibility-and-higher-education-topics-july-29-30\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4948:\"<p><a href=\"https://www.wpcampus.org/\">WPCampus</a>, a community focused on WordPress and higher education, will host its 5th annual in-person conference as a free, <a href=\"https://2020.wpcampus.org/\">online event</a> this year.  The two-day event will feature sessions, lightning talks, sponsor demonstrations, and trivia, July 29-30, 2020. </p>\n\n\n\n<p>Although the WPCampus community is no stranger to hosting online events (they usually host a virtual conference in January), current events have forced educational institutions to rely more heavily on those who maintain their digital infrastructure. Many WPCampus members fall into this category and are operating under a great deal more stress as compared to previous years. The community has more than 1,116 members representing 688 institutions.</p>\n\n\n\n<p>&ldquo;In higher ed, &lsquo;wearer of many hats&rsquo; is a common saying,&rdquo; WPCampus director Rachel Cherry said. &ldquo;Per usual, most who work in our space are already going above and beyond to cover numerous job roles. For example, I was always a team of one: I designed the site, programmed the site, performed QA, and managed content editors. With the pandemic forcing many universities to increase their online presence, higher ed web professionals are busier than ever, working to help with the transition while bearing the stress of lowered budgets, working from home, and whether or not their physical campus will open for the fall semester.&rdquo; </p>\n\n\n\n<p>As many institutions are moving to make their courses available online, Cherry said ensuring that vital resources are accessible has become even more critical.</p>\n\n\n\n<p>&ldquo;The pandemic forced a vast majority of our society&rsquo;s processes and interactions to go online, and it&rsquo;s shining a spotlight on how inaccessible a lot of our systems are,&rdquo; she said. &ldquo;For example, online event platforms became a necessity for conferences. But the vast majority of these platforms are inaccessible. Crowdcast, for instance, is nearly impossible to use if you can&rsquo;t use a mouse. Using inaccessible online platforms for your event is no different from denying attendee access at the door because the building doesn&rsquo;t have a wheelchair ramp.&rdquo;</p>\n\n\n\n<p><a href=\"https://2020.wpcampus.org/\">WPCampus Online 2020</a> will include a selection of sessions from accessibility experts on topics such as justifying the budget for accessibility initiatives, accessibility for non-developers, Gutenberg accessibility, end-to-end accessibility testing, and mobile site and native app accessibility testing guidelines. If you are looking to deepen your knowledge of accessibility, this conference features more sessions on this topic than most WordCamps.</p>\n\n\n\n<p>The event&rsquo;s <a href=\"https://2020.wpcampus.org/speakers/\">schedule</a> also includes other topics of interest to those in higher education with sessions on managing multiple WordPress sites, building a self-publishing platform, extending the WP REST API, automation tools, data visualization for WordPress, and improving website performance.</p>\n\n\n\n<p>In lieu of giving away swag for the event, WPCampus is coordinating a fundraising effort for the Black Lives Matter movement and those struggling with COVID-19. The organization will <a href=\"https://2020.wpcampus.org/donate/\">match donations</a> to the following organizations: </p>\n\n\n\n<ul id=\"input_10_4\"><li>Black Lives Matter</li><li>The American Civil Liberties Union (ACLU)</li><li>NAACP Legal Defense Fund</li><li>Black Girls Code</li><li>Feeding America</li></ul>\n\n\n\n<p>Cherry reports that more than 350 people have registered so far and she anticipates 500-600 attendees online this year. WPCampus will stream the session videos on YouTube and they will be recorded and available after the event. <a href=\"https://2020.wpcampus.org/register/\">Registration</a> is free, thanks the the event&rsquo;s sponsors, which include many WordPress agencies, hosts, and contributing individuals.</p>\n\n\n\n<p>Despite the disappointment at not being able to meet in-person in New Orleans this year, Cherry said she is grateful for the &ldquo;more in-depth than usual&rdquo; time the community will have to spend together during the virtual conference. WPCampus members have found camaraderie and encouragement in their community by sharing stories and asking each other for help during this profoundly challenging time. </p>\n\n\n\n<p>&ldquo;We&rsquo;ve become a family,&rdquo; Cherry said. &ldquo;And not just with higher ed and other web professionals, but with the vendors that support us and want to invest in our growth. Because of our events and community, we were able to sponsor the Gutenberg accessibility audit and play a huge role in improving the accessibility of the WordPress platform. I am incredibly proud of the ever-increasing focus, education, and advocacy our community has placed on accessibility.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Jul 2020 20:44:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Should WordPress Themes Add a Top-Level Admin Menu Item?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=101807\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:175:\"https://wptavern.com/should-wordpress-themes-add-a-top-level-admin-menu-item?utm_source=rss&utm_medium=rss&utm_campaign=should-wordpress-themes-add-a-top-level-admin-menu-item\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7349:\"<p class=\"has-drop-cap\">WordPress has almost always provided a top-level admin menu item for themes. It is clearly labeled &ldquo;Appearance.&rdquo; It is the single location that all WordPress users know to visit to modify any appearance-related things for their WordPress site. However, there is a movement within the Themes Team to allow themes to <a href=\"https://make.wordpress.org/themes/2020/07/13/proposal-allow-themes-to-add-a-top-level-admin-menu/\">place an additional top-level menu link</a> in the admin. The big question: <em>should this idea move forward?</em></p>\n\n\n\n<p>When the Themes Team (originally called the Theme Review Team) was formed, its members created a set of guidelines that would be shaped and reshaped over the years. They were a set of living guidelines that could always be changed with the times.</p>\n\n\n\n<p>One of the oldest guidelines required that themes must place any custom admin pages under the Appearance menu item. It made sense. WordPress provided a standard location for any theme-related pages. The custom header and background features lived under Appearance. Widgets, also defined by the current theme, were housed as a sub-page. Eventually, WordPress&rsquo;s custom nav menu system came along and was &mdash; you guessed it &mdash; situated under Appearance. The core developers even put the customizer link in the same place.</p>\n\n\n\n<p>For over a decade, there was a well-defined standard. Sure, commercial themes outside of the official directory would sometimes break the mold. However, themes from the directory followed the pattern.</p>\n\n\n\n<p>Now, the Themes Team is proposing that themes should be able to break from tradition.</p>\n\n\n\n<p>The discussion arose after a question of whether themes should be able to add a custom panel to the block editor sidebar, which is not allowed.</p>\n\n\n\n<p>&ldquo;To keep the editor free from clutter, advertising and upsell, with the customizer being used less, and no dashboard widgets being allowed, can we give theme authors a better place to include their information, and limit upsell to that area?&rdquo; wrote Carolina Nymark in <a href=\"https://make.wordpress.org/themes/2020/07/10/meeting-notes-tuesday-7th-of-july-2020/\">last week&rsquo;s team meeting notes</a>.</p>\n\n\n\n<p>The proposal seems to settle on the idea that themes will lose visibility as WordPress moves toward full-site editing and the customizer becomes less important. The customizer is not an ideal place for anything but theme options, but that notion seems to have been overlooked in the discussion. Nevertheless, the original guideline that disallowed themes from creating top-level menu items preceded the advent of the customizer by several years. Advertising, documentation, plugin recommendations, and similar pages were always allowed under the existing Appearance menu. The usefulness of the customizer was never a necessary part of that conversation.</p>\n\n\n\n<p>Ultimately, the question should be about what is best for users. There is no data to support making the change or sticking with the status quo. However, we do have a standard that has existed for years.</p>\n\n\n\n<h2>The Proposed Guidelines</h2>\n\n\n\n<p class=\"has-drop-cap\">The proposal would create several new guidelines for theme authors to follow and reviewers to check, assuming the theme created a top-level admin menu item:</p>\n\n\n\n<ul><li>No admin menu priority may be used.</li><li>No UI or color changes are allowed for the menu item.</li><li>The title must be kept short and not include spam.</li><li>No more than three sub-pages.</li><li>Child themes are limited to one sub-page or can remove the parent&rsquo;s pages and add its own.</li></ul>\n\n\n\n<p>Some of these make sense and follow along with existing guidelines, such as not spamming or changing the admin UI. However, others could be problematic.</p>\n\n\n\n<p>If moving forward with the proposal, setting a menu item priority should be required rather than not allowed. If anything, it would make sense to require a specific priority to place the custom menu item immediately after the existing Appearance item. This would at least group them together by default. If changing the place where users are accustomed to seeing theme-related pages, it is probably best not to break too far from the standard location.</p>\n\n\n\n<p><em>No more than three sub-pages?</em> Surely there will be a theme with a top-level admin menu item that needs four sub-pages at some point. If giving theme authors the freedom to take up valuable real estate in the admin, a limit of three sub-pages seems like a rule to fix the mistake of allowing the top-level item in the first place. It is an arbitrary number at best. There would be no reason to cap it once making the guideline change. It also adds one more item that the team will need to police.</p>\n\n\n\n<p>The limitation of sub-pages for child themes seems just as arbitrary.  No such limitation exists when placing sub-pages under the standard Appearance screen.</p>\n\n\n\n<p>The entire proposal is little more than extra work on a team that is already strained for resources.</p>\n\n\n\n<p>Instead of the simple rule that has existed for years, the proposal adds a new rule with several sub-rules. If the team desires the extra work, I suppose this point doesn&rsquo;t matter.</p>\n\n\n\n<h2>The Elephant in the Room</h2>\n\n\n\n<p class=\"has-drop-cap\">There is one aspect of this discussion that everyone knows about but few are willing to broach. Underneath all the guidelines from the Themes Team and whether most theme authors support a particular decision is how this affects the financial bottom line. When we talk about <em>visibility</em> of a theme&rsquo;s admin pages, we are primarily talking about providing another avenue for commercial upsells.</p>\n\n\n\n<p>Some of this discussion on visibility is shrouded in concepts such as surfacing end-user documentation or adding a visible <em>readme</em> for the user&rsquo;s benefit. These are legitimate concerns, especially when theme developers have watched <a href=\"https://meta.trac.wordpress.org/ticket/215\">tickets to address such downfalls</a> seemingly dwindle into obscurity over the years. Whether a top-level admin menu item makes sense for exposing theme documentation might be worth discussing, but there is no world in which this would be the primary use case.</p>\n\n\n\n<p>The topic of visibility rests on the idea of upselling the pro version of the theme, add-ons, or other services.</p>\n\n\n\n<p>Far too many plugins already go overboard, creating a billboard of the WordPress admin. One of the things users could almost be assured of is that themes from the official directory were constrained enough that they were not the hot mess that plugins have become as of late. However, that could all change.</p>\n\n\n\n<p>Do we really want an extra top-level admin menu item that will be, for all intents and purposes, to advertise?</p>\n\n\n\n<p>Maybe it doesn&rsquo;t matter in the end. Users are so accustomed to the clutter produced by the dozens of plugins on their sites. One more may not matter at this point.</p>\n\n\n\n<p>Or, should we be having a different conversation altogether? If this ultimately boils down to advertising, are there ways we can open this up for theme authors while still creating a user experience that keeps the WordPress admin free of clutter?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Jul 2020 20:03:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Astra Becomes the Only Non-Default WordPress Theme With 1 Million Installs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=101924\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:213:\"https://wptavern.com/astra-becomes-the-only-non-default-wordpress-theme-with-1-million-installs?utm_source=rss&utm_medium=rss&utm_campaign=astra-becomes-the-only-non-default-wordpress-theme-with-1-million-installs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5336:\"<p class=\"has-drop-cap\">On Tuesday, Brainstorm Force announced its Astra theme <a href=\"https://wpastra.com/one-million-active-installs/\">passed 1 million active installations</a>. It is the only non-default theme in the official WordPress theme directory to reach such a height.</p>\n\n\n\n<p>Popularity breeds popularity. Once the theme broke 50,000 installs in January 2019, it was a quick hop and skip to 500,000 in October and 1 million less than a year later. With the winds of momentum at its back, the theme may become an unstoppable force. It is anyone&rsquo;s guess when growth will begin to plateau.</p>\n\n\n\n<p>&ldquo;We recognize that this is not an ordinary feat,&rdquo; wrote Sujay Pawar in the announcement post. He said the team has no plans of resting at this point. &ldquo;1 million is just a milestone in our journey.&rdquo;</p>\n\n\n\n<p>Many WordPress plugins have long ago passed the million-install milestone. Several have multi-millions. However, this is a much tougher feat for themes. One of the limiting factors is that users can only activate one of them at a time. There is no limit when it comes to plugins, and users often have dozens running at once. One million active installs is a level of popularity that is almost unheard of in the theming world.</p>\n\n\n\n<p>&ldquo;There is a huge gap between Astra and all others,&rdquo; said William Patton, a WordPress Themes Team representative. &ldquo;Hitting 1 million is pretty astounding honestly.&rdquo;</p>\n\n\n\n<p>This is not simply a major milestone for the Astra theme. It is huge for WordPress. For a third-party theme creator to reach a number that only the default themes can boast is the sort of thing we should all rejoice in a bit. It is a testament to how much WordPress has grown over the years.</p>\n\n\n\n<p>Aside from the default themes that ship with WordPress, there are currently five themes with more than 100,000 active installs:</p>\n\n\n\n<ul><li><a href=\"https://wordpress.org/themes/astra/\">Astra</a> &ndash; 1 million</li><li><a href=\"https://wordpress.org/themes/oceanwp/\">OceanWP</a> &ndash; 600,000</li><li><a href=\"https://wordpress.org/themes/generatepress/\">GeneratePress</a> &ndash; 300,000</li><li><a href=\"https://wordpress.org/themes/hello-elementor/\">Hello Elementor</a> &ndash; 300,000</li><li><a href=\"https://wordpress.org/themes/storefront/\">Storefront</a> &ndash; 200,000</li></ul>\n\n\n\n<p>Once that first theme passes the 1 million mark, it is only a matter of time before others start breaking the barrier. OceanWP has the shortest striking distance and could be next. However, Hello Elementor is moving fast and earned its install count in a year and a half.</p>\n\n\n\n<p>Regardless of the next theme to hit the milestone, this is one of those moments we should look back on in a few years to see how far we have come. Perhaps 1 million active installs will merely be a stepping stone to even greater heights for large numbers of themes.</p>\n\n\n\n<h2>What Makes Astra Special?</h2>\n\n\n\n<img />\n\n\n\n<p class=\"has-drop-cap\">The default Astra theme is not anything particularly revolutionary on the surface. Out of the box, users are given a nearly blank canvas. It seems little more than your run-of-the-mill WordPress theme that would not garner much attention. However, it has one of the easiest setup processes that I have ever experienced with any theme. At the click of a button, end-users can pick from a plethora of starter templates.</p>\n\n\n\n<p>There are hundreds of starter templates for Elementor and Beaver Builder. The Brizy page builder gets a little love too. There is even a modest 20 starter templates for Gutenberg. The theme&rsquo;s block editor styling leaves a lot to be desired, but I would wager that Brainstorm Force is serving a primary audience of Elementor users. The team probably won&rsquo;t have a huge incentive to change that anytime soon. And, there is really no need to. Elementor <a href=\"https://elementor.com/blog/5-million-active-installs/\">passed 5 million active installs</a> in May and is showing no signs of slowing down. Smart theme development businesses are making sure they support the plugin. Elementor support is where the money is right now.</p>\n\n\n\n<p>Astra&rsquo;s starter templates are not merely templates. The theme will install and activate plugins needed too.</p>\n\n\n\n<p>Many of the templates are free, but some are available for purchase. The theme allows users to filter the search between free and &ldquo;agency&rdquo; templates, so there is no trickery going on as is often the case with similar themes from the directory. They clearly label any upsells in the admin. At a time when the WordPress Themes Team struggles with theme authors circumventing advertising guidelines, Astra seems to be hitting a sweet spot that is both user-friendly and within the directory rules.</p>\n\n\n\n<p>While good marketing and business plans go a long way toward getting installation numbers up, you cannot keep those numbers without building a product that users will continue using. Its simple import process makes it an easy go-to choice for anyone who doesn&rsquo;t relish the idea of spending hours trying to make their site look like the demo.</p>\n\n\n\n<p>The theme&rsquo;s users can probably best answer the question of Astra&rsquo;s popularity.  Brainstorm Force is clearly doing something right.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Jul 2020 19:38:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Blocksy Theme Adds New Charity Starter Site, Pro Version to Launch in 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=101884\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:211:\"https://wptavern.com/blocksy-theme-adds-new-charity-starter-site-pro-version-to-launch-in-2020?utm_source=rss&utm_medium=rss&utm_campaign=blocksy-theme-adds-new-charity-starter-site-pro-version-to-launch-in-2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4087:\"<p><a href=\"https://wordpress.org/themes/blocksy/\">Blocksy</a> is one of the best free themes available for the block editor right now and is rapidly growing in popularity. CreativeThemes, the Romania-based company behind the theme, released an update to Blocksy this week, along with a new starter site for charities. </p>\n\n\n\n<p>The concept of &ldquo;starter sites&rdquo; is an interesting new twist on &ldquo;starter templates,&rdquo; which essentially allow users to import the content from a demo. Theme makers for products like <a href=\"https://creativethemes.com/blocksy/\">Blocksy</a>, <a href=\"https://wpastra.com/\">Astra</a>, and <a href=\"https://github.com/godaddy-wordpress/go\">Go</a> use this approach to help users implement different types of websites by importing the content from a pre-built demo site. The demos use the same base theme but vary widely in how they are customized. </p>\n\n\n\n<p>Blocksy&rsquo;s starter sites are a one-click XML demo import that automatically brings in the pages, images, and theme options. This puts all the blocks in the right place so the user needs only to customize the demo, instead of trying to find the right settings to match the demo.</p>\n\n\n\n<p>The new <a href=\"https://demo.creativethemes.com/blocksy/charity/\">Charity starter site</a> is built with the <a href=\"https://wordpress.org/plugins/stackable-ultimate-gutenberg-blocks/\">Stackable</a> plugin&rsquo;s page builder blocks. It joins four other <a href=\"https://creativethemes.com/blocksy/starter-sites/\">free starter sites</a> designed specifically for blogs, apps, travel, and e-commerce. The design can be imported under the Blocksy menu in the WordPress admin.</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>According to the theme&rsquo;s beautifully designed and user friendly <a href=\"https://creativethemes.com/blocksy/changelog/\">changelog</a>, Blocksy can now automatically detect Custom Post Types and add their appropriate options. The update also adds a sizing option for related posts thumbnails, a new Twitch social icon, and improves compatibility with WooCommerce product display and miscellaneous extensions.</p>\n\n\n\n<h2>Blocksy Pro Version Coming Soon </h2>\n\n\n\n<p>When we first <a href=\"https://wptavern.com/blocksy-wordpress-theme-provides-a-solid-block-editor-experience\">reviewed</a> the theme in January 2020, it had 1,000 active installs and 58 five-star reviews. Over the past six months, the theme&rsquo;s user base has grown to more than 4,000 active installs and a perfect five-star rating on WordPress.org from 191 reviewers. It is currently maintained by a team of two &ndash; Sergiu Radu and Andrei Glingeanu.</p>\n\n\n\n<p>Blocksy&rsquo;s creators have been working on custom projects and random jobs to support the time they spend developing the theme but they plan to launch a pro version as early as this summer.</p>\n\n\n\n<p>&ldquo;We plan to add more features in the premium version, more demos, and also offer better and faster support,&rdquo; Radu said. &ldquo;I hope after we release the premium version we will be able to take on a few more people in our team to help us, at least with support so we can concentrate better on development.&rdquo;</p>\n\n\n\n<p>Radu said the pro version will include some premium starter sites as well as additional functionality for the base theme.  They are aiming to include the following features in the first release:</p>\n\n\n\n<ul><li>Multiple conditional headers</li><li>Multiple conditional footers</li><li>Multiple conditional sidebars</li><li>More header elements</li><li>More footer elements</li><li>White labeling</li><li>Custom fonts extension</li><li>Adobe Typekit extension</li><li>Hooks (conditional)</li><li>Sticky header</li></ul>\n\n\n\n<p>In a second round of updates for the pro version, Blocksy creators plan to include features like custom color palettes, AMP, LearnDash, and EDD integrations, along with extensions for ads, mega menus, and portfolios. In the meantime, Radu says they do not plan to add more features to the free version &ndash; only improvements and new starter sites. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Jul 2020 22:32:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WPTavern: Eye-Catching Typography and Personality: Blossom Themes Launches Sarada Lite\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=101933\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:215:\"https://wptavern.com/eye-catching-typography-and-personality-blossom-themes-launches-sarada-lite?utm_source=rss&utm_medium=rss&utm_campaign=eye-catching-typography-and-personality-blossom-themes-launches-sarada-lite\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6064:\"<img />Sarada Lite homepage.\n\n\n\n<p class=\"has-drop-cap\">Blossom Themes launched <a href=\"https://wordpress.org/themes/sarada-lite/\">Sarada Lite</a>, its 25th theme, on the WordPress theme directory today. The theme is billed as a &ldquo;feminine blog theme&rdquo; specifically for professional bloggers. However, it would work well in a variety of contexts. While it is targeted at fashion, travel, and lifestyle bloggers, it is well-rounded enough for anyone who wants a touch of personality as part of their blogging experience.</p>\n\n\n\n<p>I nearly passed over this theme. It had no mention of the block editor or Gutenberg in its description. It was not tagged in the directory as having editor styles (technically, it doesn&rsquo;t have them). There are few themes that I give much attention to if they do not style the latest features and blocks in WordPress. It has to be truly eye-catching otherwise. Sarada Lite is a breathtaking design, so it drew me in. It is the sort of theme that inspires me to write. Plus, its light color scheme along with the author&rsquo;s choice of images in the demo fit perfectly into the summer season. It simply makes me want to sit on the beach with a mojito and my laptop ready to spin up some great content.</p>\n\n\n\n<p>What makes this theme stand out is its typography. The status quo with most free themes in the WordPress theme directory is to simply not give any attention to things like font size, characters per line, line height, or vertical rhythm. Long-form content is practically unreadable with such themes. However, long-winded writers need not be fearful of the reader losing interest because of the design. Sarada Lite creates an inviting atmosphere that beckons the visitor to actually read.</p>\n\n\n\n<p>The theme supports several plugins, most of which are a part of the Blossom Themes collection. They are unnecessary for a solid blogging experience with this theme. Users should shy away from taking advantage of every bell and whistle the theme or its add-ons provide. The default setup is mostly where the theme shines.</p>\n\n\n\n<p>Users who need a shop can also enjoy WooCommerce integration. The theme does not add much in the way of shop-related features, opting to style the default output of the eCommerce plugin instead.</p>\n\n\n\n<h2>Design Elements Worth Noting</h2>\n\n\n\n<img />Single post view.\n\n\n\n<p class=\"has-drop-cap\">When testing and reviewing themes, it is often easy to get lost in the features. However, with Sarada Lite, it&rsquo;s not the theme features that are important. They may even be a detriment to the theme (more on that later). The thing that makes this theme special is the small design elements. The author puts a unique spin on things that give the theme a personality of its own. Designers who want to show off their design chops often go overboard, but Sarada Lite has just enough flair to draw attention to important elements without getting in the way of the content.</p>\n\n\n\n<p>In particular, the theme&rsquo;s use of the <a href=\"https://fonts.google.com/specimen/Caveat\">Caveat font</a> gives secondary text just the right amount of pop. It is not a font that lends itself well to long-form content. However, the theme makes use of it for links, captions, quote citations, and a few other elements.</p>\n\n\n\n<img />Sarada Lite&rsquo;s blockquote design.\n\n\n\n<p>The theme offers various layouts with and without a sidebar. For single posts, I recommend dropping the sidebar and choosing the full-width centered layout to make full use of the block editor&rsquo;s capabilities. This gives enough breathing room for users who like to make liberal use of wide and full-width blocks. The theme has an option to change the layout globally and on a per-post basis.</p>\n\n\n\n<h2>Issues</h2>\n\n\n\n<p class=\"has-drop-cap\">One of the biggest issues with Sarada Lite is that users do not get a one-to-one match between the editor and the front end. The missing piece is the theme&rsquo;s beautiful typography. It is nowhere to be found while writing a post. The theme&rsquo;s admin-side CSS is bare-bones to the point where there is little use in loading the stylesheet. I hope this is merely something the theme author skipped for version 1.0 with a firm plan to add it in the next release. At worst, it is an extra couple of hours of work that offers a huge benefit to theme users.</p>\n\n\n\n<p>The other major downside of Sarada Lite is that it tries to do too much. Its customizer options feel a bit overboard and disorganized. In too many cases, I was left wondering what a particular option was for or searching around for specific options in odd places.</p>\n\n\n\n<p>I also found the Instagram feed (available via the Blossom Themes Social Feed add-on) in the header to be a horrendous addition, ruining what is an otherwise open and inviting design. Fortunately, this is an optional feature. Once again, the theme is doing too much here. I understand it is a bullet point on the ol&rsquo; marketing sheet, but it is an eyesore in practice. The Instagram feed works much better in the footer. My advice for theme users: avoid putting this in your header at all costs. Your site visitors should not need to skip over social media images just to get to your content.</p>\n\n\n\n<p>As gracefully as the various sliders on the theme&rsquo;s homepage are done, I am now and always anti-slider. They offer no real benefit to the reader and often hide away content that would have otherwise been seen. The theme&rsquo;s slider sections, some of which are optional, are relatively low-key. I have seen far worse, but I would rather not see them at all.</p>\n\n\n\n<p>Despite the theme&rsquo;s issues, they are not so detrimental that I wouldn&rsquo;t recommend the theme. Assuming the theme author adds in editor styles that match the front end, the other issues can mostly be avoided by user choice. The theme works well without tinkering with its options and adding extra plugins.</p>\n\n\n\n<p>Sarada Lite is best without all the extras. What the user does with the theme will make or break the experience.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Jul 2020 20:56:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"HeroPress: Second Chances: How A Trip Back  Into The WordPress Community Saved My Life\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=3229\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:220:\"https://heropress.com/essays/second-chances-how-a-trip-back-into-the-wordpress-community-saved-my-life/#utm_source=rss&utm_medium=rss&utm_campaign=second-chances-how-a-trip-back-into-the-wordpress-community-saved-my-life\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7043:\"<img width=\"960\" height=\"480\" src=\"https://s20094.pcdn.co/wp-content/uploads/2021/07/071320-min.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: The energies received in return for giving back to the WordPress community healed me emotionally, allowing me to contribute creatively.\" /><p>Often, we refuse change and don&#8217;t get a second opportunity to make things right. But for me, June 17, 2017, changed my life forever. A life-threatening heart event forced me to start over and in the short time since WordPress helped me rediscover myself and to do the things I truly love.</p>\n<p>At 10 am that morning, I was laid out flat on a cold, hard operating table being poked, prodded, and prepped for a surgical procedure. According to my doctors, this procedure was the only sure way to find out what had been plaguing me for five long years. Within the next sixty minutes, if things go sideways, I could be dead.</p>\n<p>As I slowly came to, words floated through a lifting fog of anesthesia. &#8220;You had two 100% blocked arteries,&#8221; my cardiologist said. A flood of concern and questions seemed to flow freely foremost, &#8220;what will happen to me?&#8221;</p>\n<h3>Two Paths Lead to WordPress</h3>\n<p>Looking back, my WordPress journey has two paths, pre- or post-heart event. When the lead developer and CSS goddess left our public transit agency almost 10 years ago, they left behind a company news blog with the Headway theme. That year we were fortunate to have room in our budget allowing me to attend the WordPress VIP Intensive Developer Workshop in Napa.</p>\n<p>At that time my experience was entirely in basic static HTML as a web designer so imagine how lost and out of place I felt being asked to &#8220;spin up a virtual box&#8221; midway through the first day. Surrounded by the best and the brightest distributed Automatticians from around the world, person after person answered my questions or assisted in any way they could. That day I learned what the phrase WordCamp Community really meant.</p>\n<h3>Leaving the Past Behind</h3>\n<p>What if you got a do-over? A mulligan, a reset button? Imagine being totally free from the stressors of the daily grind, similar to being a young child, with nothing to do but play all day.</p>\n<p>Staring at the ceiling from my bed while recovering, I decided to stop the world and get off. I took a leave of absence from work beginning September 11. Looking deep within, I searched to rediscover me and the loves of my life &#8211; giving selflessly to others, picking up a pencil to sketch, storytelling, and WORDPRESS.</p>\n<p>Every day for the next ninety days, I resolved to do only the things reconnected me with things dormant in my past that brought me joy:</p>\n<ul>\n<li>Each morning I&#8217;d pick up a pencil, sketch;</li>\n<li>I&#8217;d exercise and practice mindfulness; and</li>\n<li>No day would be complete without giving back, doing something with WordPress for others. Like an Agile process, I&#8217;d loop through these tasks, reassess, then repeat, each morning becoming stronger than the previous.</li>\n</ul>\n<p>Slowly, progress was being made in my recovery. From feeling faint and unable to walk from my bedside to my bathroom; 100 steps turned into 100 yards then one lap at my local park. I set a goal to climb to one of the highest points in our area, the top of Central Park.</p>\n<h3>The Journey of 4,890 Miles Begins with One Step</h3>\n<p>My second path into WordPress started later that summer. Untethered, I walked into my first-ever official WordPress Meetup in a coworking space located downtown Los Angeles, apprehensive, unsure what to expect. That evening a wonderful speaker on SEO followed the organizers from WordCamp Los Angeles calling for volunteers and I immediately raised my hand. The old me would not have.</p>\n<p>From that point through December, I attended almost twenty (20) WordPress Meetups, attended four WordCamps (Grand Rapids, Los Angeles, Riverside, and United States via Livestream) logging almost 5,000 miles in the process. Rebuilding a website for a printing company pro bono while rehabilitating my heart and body. The energies received in return for giving back to the WordPress Community healed me emotionally, allowing me to contribute creatively &#8212; I loved it and wanted to do even more!</p>\n<h3>Making a List, Checking It Twice</h3>\n<p>Tired of driving home very late nights from area Meetups from all points around SoCal, I decided to start a meetup locally. On January 26, 2018, at 7:30 pm, I reached the last slide of my first presentation at our official WordPress Santa Clarita Valley Meetup. It read, &#8220;host the first annual WordCamp Santa Clarita&#8221;.</p>\n<p>The faces in the audience &#8211; Tom, Steve, Matt, and others new to WordPress all looked at me skeptically, seeing someone full of dreams, spouting enthusiasm. But one thing was clear to me &#8212; WordPress had given me a shot at reclaiming something laid dormant and anything seemed possible.</p>\n<p>Sixteen (16) months later, the first WordCamp north of Los Angeles and south of Sacramento since 2014 debuted in Santa Clarita. A small, but an incredible team of volunteers bought into my enthusiasm turned around and gave back to our attendees in our WordPress Community.</p>\n<h3>Speak On It</h3>\n<p>In my pre-heart event life, I began public speaking in a formal setting completing over 40 presentations but had stepped off the stage years earlier in a company club. Back in 2014 while walking through the break room at WordCamp Los Angeles one of the lead organizers handed me a mic and asked me to speak. Afterward, he said, &#8220;you should present at a WordCamp.&#8221;</p>\n<p>Four years later, I stood on stage at WordCamp Chicago sharing my WordPress journey and hoping to inspire others to never give up on going after your dreams. Until that weekend in Chicago, I hadn&#8217;t seen any African-American men onstage and felt it important to encourage diversity through my message of rebirth.</p>\n<blockquote><p><i>&#8220;Live as if you were to die tomorrow. Learn as if you were to live forever.&#8221; </i></p>\n<p><i>Mahatma Gandhi</i></p></blockquote>\n<p>I&#8217;ve met the most incredible group of nurturing, giving, and talented people stretching back to Sara (Rosso) in Napa through Angela (Jin) or David (Bisset) on the WordCamp US team. Every time I needed confidence or a word of encouragement Cami (Kaos), Kathy (Drewien), Brandon (Dove), or someone in the Community was that steadying hand on my shoulder.</p>\n<p>I think about these words often as inspiration, waking each morning to greet the sunrise full of ideas and promise. How can I give back? What can I do with WordPress today?</p>\n<p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/second-chances-how-a-trip-back-into-the-wordpress-community-saved-my-life/\">Second Chances: How A Trip Back  Into The WordPress Community Saved My Life</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Jul 2020 11:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Joe Simpson Jr.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: WordCamp Europe Goes Virtual for 2021, In-Person Conference to Resume 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=101866\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:211:\"https://wptavern.com/wordcamp-europe-goes-virtual-for-2021-in-person-conference-to-resume-2022?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-europe-goes-virtual-for-2021-in-person-conference-to-resume-2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7807:\"<p>While much of the world is currently suspended in the uncertainty caused by the pandemic, WordCamp Europe delivered a surprisingly decisive <a href=\"https://europe.wordcamp.org/2021/wordcamp-europe-2021-will-be-online/\">announcement</a> today regarding the status of the 2021 event in Porto. Organizers moved to make it a virtual conference, 10 months in advance of the planned dates, June 3-5, 2021:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>After careful consideration, and following guidance from WordCamp Central, we have agreed to hold WCEU 2021 online.</p><p>Although it was a difficult decision, it also seems the right thing to do. Considering the continuing uncertainty regarding COVID-19, we are hesitant to draw so many individuals from so many different places into one physical space.</p><p>We understand that this decision will come as a disappointment to many. We know that this event is a much-needed social outlet for many in our community and that an online event isn&rsquo;t quite the same as a physical event. We&rsquo;re so sad to not be able to greet you all in person in Porto in June.</p></blockquote>\n\n\n\n<p>The announcement cited several positive aspects of going virtual, including eliminating the uncertainty for attendees and their travel arrangements, allowing for a larger global audience without the expense and risk, and having more time for creating a better online experience. The 2020 event had just three months to convert to a virtual conference but was able to reach more than 8,000 attendees.</p>\n\n\n\n<p>In the absence of a vaccine ready for mass distribution or any proven commercially available therapeutics specifically designed to target the virus, it is impossible for organizers to nail down a safe timeline for a multinational event in 2021. Hugh Lashbrooke, who is assisting the WCEU organizing team as a mentor from WordCamp Central, identified risk mitigation as one of the primary factors in their decision.</p>\n\n\n\n<p>&ldquo;Attendee safety is a primary concern in WordCamp organizing,&rdquo; Lashbrooke said. &ldquo;While the pandemic is progressing differently in different regions of the world, it seems that large in-person events that bring together thousands of people from multiple countries in a single shared space are still a risky proposition &mdash; and it&rsquo;s not clear when this will be safe again.&rdquo; </p>\n\n\n\n<p>WordCampers <a href=\"https://twitter.com/WCEurope/status/1283017418261049346\">reacting to the news</a> today seemed to understand the need for such a disruptive change, but most expressed deep disappointment. </p>\n\n\n\n<p>&ldquo;I&rsquo;m sure the decision won&rsquo;t have been taken lightly,&rdquo; Simon Dickson said. &ldquo;But WCEU is so important in terms of defining and sustaining the European &ndash; and indeed, global &ndash; WordPress community. With all due respect to online alternatives, two blank years will hit community spirit hard.&rdquo;</p>\n\n\n\n<p>The goal for WordCamp Europe is to resume the in-person event in 2022 and organizers have booked the Super Bock Arena (Pavilh&atilde;o Rosa Mota) for June 2 &ndash; June 4, 2022.&nbsp;</p>\n\n\n\n<p>If WCEU can resume normal operations in 2022, it will be the first time in three years that the European WordPress community has had the opportunity to gather in-person in one place. One disappointed attendee <a href=\"https://twitter.com/7strel/status/1283102522270507008\">said</a>, &ldquo;Understandable. As we say in Portugal: &Agrave; terceira ser&aacute; de vez! At&eacute; 2022,&rdquo; which roughly translates to the English saying, &ldquo;Third time&rsquo;s a charm.&rdquo;</p>\n\n\n\n<h2>WordPress Community Team Is Working Towards Facilitating More Effective Events</h2>\n\n\n\n<p>Lashbrooke said adjusting to emerging world events has been hard on all WordCamp organizing teams this year, as well as sponsors, speakers, and attendees. WordCamp Asia was forced to cancel, WordCamp US has gone virtual, and many other smaller camps have gone online or been postponed. The WordPress Community team is <a href=\"https://make.wordpress.org/community/2020/07/13/reimagining-online-events/\">discussing how they can improve online events</a> to provide a better experience for the community. Some of the broader ideas for creating more effective events include the following:</p>\n\n\n\n<ul><li>Decouple online events from geography</li><li>Encourage events and workshops defined by topics, languages, etc.</li><li>Explore shorter, &ldquo;snack-sized&rdquo; online events</li><li>Experiment with the frequency of events</li></ul>\n\n\n\n<p>A peripheral <a href=\"https://twitter.com/learnwithmattc/status/1282723205728227330\">discussion</a> regarding sponsors is happening on Twitter, after recent online WordCamps failed to deliver a positive experience of virtual sponsor booths.</p>\n\n\n\n<p>&ldquo;If you want to offer sponsors a &lsquo;Virtual Booth&rsquo; as a benefit of sponsorship, you&rsquo;re going to have to do something during the main event to make that attractive and easy for attendees to attend &mdash; otherwise it&rsquo;s not a sponsor benefit,&rdquo; Matt Cromwell said.</p>\n\n\n\n<p>&ldquo;If attendees have to log off the regular WordCamp platform, then go find some other link to some other virtual platform the experience becomes arduous and full of friction for the attendee making it highly unlikely they&rsquo;ll attend. WordCamps that are switching to virtual should look into more robust platforms like <a href=\"https://hopin.to/\">Hopin</a> which allow for various rooms that are consolidated to the same platform for attendees.&rdquo;</p>\n\n\n\n<p>WordCamp Europe 2020 organizer Bernhard Kau said his team looked into using Hopin but found it wasn&rsquo;t fully accessible.</p>\n\n\n\n<p>&ldquo;Hopin looked promising at first, not only for sponsors, but also for networking between attendees,&rdquo; Kau said. &ldquo;But it lacks basic accessibility. It&rsquo;s unusable with keyboard only for example. I&rsquo;d love to see it improve, so we could use it in the future.&rdquo; </p>\n\n\n\n<p>Lashbrooke said WordCamp Central has also considered Hopin, among other apps, while doing <a href=\"https://docs.google.com/spreadsheets/d/1ym0nuKxhnzyBmNAozSNdviCjmlTq3e2J95usFbpUQrY/edit#gid=0\">extensive research on accessible platforms</a>.</p>\n\n\n\n<p>&ldquo;Right now, everyone&rsquo;s still working on a way to make that work for everyone, and we&rsquo;re lucky that our sponsors are so honest with us about their experiences, because it helps us improve,&rdquo; Lashbrooke said. </p>\n\n\n\n<p>&ldquo;One thing that is of paramount importance to us as a team is that all WordPress events maintain a high level of accessibility, and unfortunately when it comes to streaming platforms we have very limited options when it comes to accessible streaming services. Zoom is about the only fully-accessible platform, so it&rsquo;s the only option to use for sponsor booths.&rdquo;</p>\n\n\n\n<p>With ten months of lead time, WordCamp Europe organizers will have plenty of opportunities to experiment with new ideas to make the event more engaging for both attendees and sponsors. All the other WordCamps on the <a href=\"https://central.wordcamp.org/schedule/\">schedule</a> through the end of the year have already been converted to online events. For the time being, it looks like virtual camps are here to stay.</p>\n\n\n\n<p>&ldquo;I really doubt we&rsquo;ll be abandoning online events, after COVID-19 is more under control worldwide,&rdquo; WordPress Community organizer Andrea Middleton <a href=\"https://make.wordpress.org/community/2020/07/13/reimagining-online-events/#comment-28388\">said</a>. &ldquo;I think that we&rsquo;ll need to figure out how in-person events and online events can best coexist, but it seems like we&rsquo;ll have time to figure that out.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Jul 2020 23:55:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Call for Block Plugins: The WordPress Block Directory Is Open for Business\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=101853\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:211:\"https://wptavern.com/call-for-block-plugins-the-wordpress-block-directory-is-open-for-business?utm_source=rss&utm_medium=rss&utm_campaign=call-for-block-plugins-the-wordpress-block-directory-is-open-for-business\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6029:\"<img />WordPress block directory.\n\n\n\n<p class=\"has-drop-cap\">Over the weekend, Alex Shiels announced an open call for plugin authors to <a href=\"https://make.wordpress.org/plugins/2020/07/11/you-can-now-add-your-own-plugins-to-the-block-directory/\">begin submitting one-off block plugins</a> to the official <a href=\"https://wordpress.org/plugins/browse/block/\">block directory</a>. In the upcoming WordPress 5.5 update, slated for release on August 11, end-users will be able to search for, install, and add blocks directly from the editor. With little time left before release, will plugin authors make this a worthwhile feature for users?</p>\n\n\n\n<p>&ldquo;The Block Directory is a subset of plugins in the plugin directory that can be instantly and seamlessly installed from the Gutenberg editor with a single click,&rdquo; wrote Shiels in the announcement. &ldquo;We call these new plugins &lsquo;block plugins&rsquo; and have worked hard to make it easier for people to contribute to this new feature coming to WordPress 5.5.&rdquo;</p>\n\n\n\n<p>WordPress plugin authors now have a new <a href=\"https://wordpress.org/plugins/developers/block-plugin-validator/\">block validation tool</a> at their disposal. The validator can check an SVN repository URL, Github URL, or plugin slug to determine if it is suitable for inclusion into the WordPress block directory. It is still under development, so plugin authors should report any issues they run into.</p>\n\n\n\n<p>For existing plugins in the plugin directory, developers can publish them to the block directory after passing validation with the tool. Plugin authors can also remove their plugins from the block directory at the click of the button.</p>\n\n\n\n<p>The block plugin guidelines are still under development. The <a href=\"https://github.com/WordPress/wporg-plugin-guidelines/pull/68\">draft ticket</a> has been open since November 21, 2019. It has seen little activity in the months since. Presumably, there will be a finalized version on WordPress.org rather than GitHub before WordPress 5.5 lands.</p>\n\n\n\n<p>Developers who want to begin building block plugins should follow the updated <a href=\"https://developer.wordpress.org/block-editor/tutorials/block-tutorial/\">block development tutorial</a>.</p>\n\n\n\n<h2>A Late Rallying Cry</h2>\n\n\n\n<p class=\"has-drop-cap\">Technically, plugin authors have been able to submit blocks to the directory for months. It was a bit of a hidden feature that few developers took advantage of. The user base was primarily Gutenberg plugin users who had enabled the experimental block directory search feature. Despite the small user base, it was an ideal time for plugin authors to begin experimenting and building an audience. It could have also been a great opportunity for relatively unknown developers to make their mark upon the WordPress world. There is still some time for that, but the community has not been actively encouraged to create blocks for the directory. With WordPress 5.5 looming ahead, the past few months seem like a missed opportunity.</p>\n\n\n\n<p>Nick Hamze, one of the most prolific publishers of one-off blocks, is <a href=\"https://block.garden/taking-a-break/\">taking a break</a>. He originally had plans to release 99 plugins throughout 2020, but the WordPress plugin review team asked him to dial things back a bit. His routine releases were putting a strain on the team. The problem is that he was one of the few plugin authors <a href=\"https://wptavern.com/the-wacky-world-of-sorta-brilliants-sorta-fun-block-plugins\">putting in the work</a> to make the block directory a great thing.</p>\n\n\n\n<p>As a former reviewer for the themes team, I understand how easy it is to get overwhelmed with a wave of new projects that need a code review. At the same time, I would be willing to bump Hamze&rsquo;s work to the front of the line, regardless of how often he was releasing new plugins. It may be a bit unfair to other plugin authors, but few others were betting big on what will be one of WordPress 5.5&rsquo;s highlights: a searchable block directory.</p>\n\n\n\n<p>&ldquo;If someone would have just given me the barest encouragement I would have kept going, but due to my experience, I stopped submitting blocks and won&rsquo;t do it anymore in the future,&rdquo; said Hamze.</p>\n\n\n\n<p>If no one else was putting in the work, there should have been no harm in giving him a bit of priority or a helping hand. That way, when WordPress 5.5 launches, there is something to show for this feature.</p>\n\n\n\n<p>Now, we are in the 11th hour, mere weeks before 5.5&rsquo;s official release, with a meager offering of blocks &mdash; instead of hundreds of blocks, we are currently nearing the 60 mark. It is a last-minute rallying call to get plugin authors churning away before the final bell rings. Yet, WordPress just benched what was essentially its star player.</p>\n\n\n\n<p>I have no doubt the block directory will continue to grow. More developers will buy into it, especially as full-site editing creates more possibilities in WordPress 5.6 later this year. Some authors will likely produce more blocks than the totality of the current number in the directory.</p>\n\n\n\n<p>If the Gutenberg team had managed to squeeze the <a href=\"https://wptavern.com/version-1-prototype-of-the-wordpress-admin-block-directory-announced\">directory and management screens</a> into WordPress 5.5 admin, it would have made for a far bigger splash. It would have been good visibility for block makers. WordPress will support a block directory search for now. However, there is no way for end-users to more casually browse blocks via their admin. There is no way to see the latest block plugin releases or view the most popular blocks. Some of these things may have made one-off block development a bit more enticing to plugin authors. </p>\n\n\n\n<p>I am still optimistic that more plugin authors will jump onto the block bandwagon. It will just be a while before we start seeing the wealth of blocks that cover the entire spectrum of what users need.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Jul 2020 20:09:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"WordPress.org blog: WordPress 5.5 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8681\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4508:\"<p id=\"block-000046ff-d8e6-40a8-9869-2dd39e50f270\"><br />WordPress 5.5 Beta 2 is now available!</p>\n\n\n\n<p id=\"block-81bd56b9-ea44-43ad-ab36-a5ae78b54375\"><strong><strong>This software is still in development,</strong>&nbsp;</strong>so it’s not recommended to run this version on a production site. Consider setting up a test site to play with the new version.</p>\n\n\n\n<p id=\"block-7cc1bbc6-17f9-44c5-8f67-da4e3059ad69\">You can test WordPress 5.5 beta 2 in two ways:</p>\n\n\n\n<ul id=\"block-4840af57-f44b-4d9f-aa64-c6a452392e42\"><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.5-beta2.zip\">download the beta here</a>&nbsp;(zip).</li></ul>\n\n\n\n<p id=\"block-a40528cb-eb3b-4c8a-8f5e-aa700f1ba086\">WordPress 5.5 is slated for release on&nbsp;<a href=\"https://make.wordpress.org/core/5-5/\">August 11th, 2020</a>, and <strong>we need your help to get there</strong>!</p>\n\n\n\n<p>Thank you to all of the contributors that tested the <a href=\"https://wordpress.org/news/2020/07/wordpress-5-5-beta-1/\">beta 1</a> development release and provided feedback. Testing for bugs is an important part of polishing each release and a great way to contribute to WordPress. Here are some of the changes since beta 1 to pay close attention to while testing.</p>\n\n\n\n<h2 id=\"block-15d6d57f-905d-4a47-9f66-839468a5375a\">Some highlights</h2>\n\n\n\n<p id=\"block-85da84ec-c841-42f9-8d3b-1a4537a61d10\">Since <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-1/\">beta 1</a>, <a href=\"https://core.trac.wordpress.org/query?status=closed&changetime=07%2F08%2F2020..07%2F14%2F2020&milestone=5.5&group=component&col=id&col=summary&col=owner&col=type&col=priority&col=component&col=version&order=priority\">48 bugs</a> have been fixed. Here is a summary of a few changes included in beta 2:</p>\n\n\n\n<ul><li>19 additional bugs have been fixed in the block editor (see <a href=\"https://github.com/WordPress/gutenberg/pull/23903\">#23903</a> and <a href=\"https://github.com/WordPress/gutenberg/pull/23905\">#23905</a>).</li><li>The Dashicons icon font has been updated (see <a href=\"https://core.trac.wordpress.org/ticket/49913\">#49913</a>).</li><li>Broken widgets stemming from changes in Beta 1 have been fixed (see <a href=\"https://core.trac.wordpress.org/ticket/50609\">#50609</a>).</li><li>Query handling when counting revisions has been improved (see <a href=\"https://core.trac.wordpress.org/ticket/34560\">#34560</a>).</li><li>An alternate, expanded view was added for <code>wp_list_table</code> (see <a href=\"https://core.trac.wordpress.org/ticket/49715\">#49715</a>).</li><li>Some adjustments were made to the handling of default terms for custom taxonomies (see <a href=\"https://core.trac.wordpress.org/ticket/43517\">#43517</a>)</li></ul>\n\n\n\n<p>Several updates have been made to the block editor. For details, see <a href=\"https://github.com/WordPress/gutenberg/pull/23903\">#23903</a> and <a href=\"https://github.com/WordPress/gutenberg/pull/23905\">#23905</a>.</p>\n\n\n\n<h2 id=\"block-76156b2b-0a52-4502-b585-6cbe9481f55b\">Developer notes</h2>\n\n\n\n<p id=\"block-3fe5e264-0a95-4f12-9a18-0cb9dc5955d1\">WordPress 5.5 has lots of refinements to polish the developer experience. To keep up, subscribe to the&nbsp;<a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a>&nbsp;and pay special attention to the&nbsp;<a href=\"https://make.wordpress.org/core/tag/5-5+dev-notes/\">developers’ notes</a>&nbsp;for updates on those and other changes that could affect your products.</p>\n\n\n\n<h2 id=\"block-bc89fd56-47b0-439f-8e2c-4a642c80a616\">How to Help</h2>\n\n\n\n<p id=\"block-3ff83a77-8b54-4061-ae2d-45fc984cbd76\">Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev/\">Help us translate WordPress into more than 100 languages</a>!</p>\n\n\n\n<p id=\"block-9d871099-ec49-446c-8322-9e49b7498c10\">If you think you’ve found a bug, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you!</p>\n\n\n\n<p id=\"block-bd71c1d3-39d9-4b2a-8193-3486497b45fd\">If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://core.trac.wordpress.org/newticket\">file one on WordPress Trac</a>,&nbsp;where you can also find a list of&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">known bugs</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Jul 2020 17:24:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jake Spurlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 11 Aug 2020 15:38:21 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Tue, 11 Aug 2020 15:15:08 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:9:\"HIT ord 2\";s:16:\"content-encoding\";s:2:\"br\";}}s:5:\"build\";s:14:\"20130911033210\";}', 'no');
INSERT INTO `wp8b_options` VALUES(1568, '_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9', '1597203501', 'no'),
 (1569, '_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9', '1597160301', 'no'),
 (1570, '_transient_timeout_feed_e0061ca2fa5b884e483872aa34d3e7eb', '1597203502', 'no'),
 (1571, '_transient_feed_e0061ca2fa5b884e483872aa34d3e7eb', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"UpdraftPlus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"https://updraftplus.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WordPress\'s leading backup plugin - backup, restore and clone WordPress sites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jul 2020 09:27:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wordpress.org/?v=5.4.2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:94:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"Where to find motivation and inspiration when building your first website\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/9-3pvoQHKXo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"https://updraftplus.com/motivation-and-inspiration-ideas-when-building-your-first-website/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jul 2020 09:27:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:8:{i:0;a:5:{s:4:\"data\";s:20:\"Other WordPress news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:18:\"Training materials\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:6:\"course\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:13:\"first website\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:5:\"guide\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:5:\"ideas\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:13:\"inspirational\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:7;a:5:{s:4:\"data\";s:9:\"wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=630657\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:813:\"<p>For most people, the internet is all about consumption. They go online to find entertainment, shop, learn and generally be distracted from all of the troubles and stress modern life is currently throwing at us. People are generally aware of &#8230; <a href=\"https://updraftplus.com/motivation-and-inspiration-ideas-when-building-your-first-website/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/motivation-and-inspiration-ideas-when-building-your-first-website/\">Where to find motivation and inspiration when building your first website</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:8714:\"<p><span style=\"font-weight: 400;\">For most people, the internet is all about consumption. They go online to find entertainment, shop, learn and generally be distracted from all of the troubles and stress modern life is currently throwing at us. People are generally aware of the internet&#8217;s incredible potential for creative expression and professional development, but most people have never actually attempted to create their own websites.</span></p>\n<p><span style=\"font-weight: 400;\">When someone does resolve to take the first steps into the exciting and daunting world of building your first site, they have a remarkable journey ahead of them. Consult anyone with a history of web development (professional or amateur) and they’ll tell you that their first website project can be a transformative experience.</span></p>\n<p><span style=\"font-weight: 400;\">It’s isn’t an easy process though, particularly for those with minimal tech expertise, and not every attempt you make at building a website will work out. It can be easy for an aspiring web developer or entrepreneur to give up due to confusion about what to do technically, or even a lack of creative direction. After all, simple setup procedures and </span><a href=\"https://www.metaslider.com/should-you-use-a-free-wordpress-theme-for-your-website/\"><span style=\"font-weight: 400;\">free themes</span></a><span style=\"font-weight: 400;\"> can’t solve all design problems.</span></p>\n<p><span style=\"font-weight: 400;\">This blog is intended to help someone in such a position. If you know someone building their first site, or if you are working on building </span><i><span style=\"font-weight: 400;\">your </span></i><span style=\"font-weight: 400;\">first website, these inspirational ideas will hopefully help:</span></p>\n<h2><span style=\"font-weight: 400;\">Take a basic course</span></h2>\n<p><span style=\"font-weight: 400;\">While it is possible for someone with decent IT skills to cobble together a fairly decent website with no formal development tuition or training, it doesn’t mean it’s preferable. If you are trying to build a site but aren’t sure how to proceed, it is highly recommended that you think about taking a </span><a href=\"https://www.wpbeaverbuilder.com/wordpress-training-course/\"><span style=\"font-weight: 400;\">basic course</span></a><span style=\"font-weight: 400;\"> in website development. This can be a great way to pick up the fundamentals that can otherwise be missed so easily when you’re winging it.</span></p>\n<p><span style=\"font-weight: 400;\">When it comes to deciding which course you should take, it really depends on what you are willing to spend, how much you already know, what results you are trying to achieve and what type of website you are aiming to build. A simple blog website for example will require much less knowledge than a large online store with various payment, shipping, tax and language options. Udemy for example </span><a href=\"https://www.udemy.com/topic/wordpress/\"><span style=\"font-weight: 400;\">has various courses specifically for WordPress</span></a><span style=\"font-weight: 400;\">, many concentrating on different elements of the development process. Just one solid course can prove extremely useful. Remember to read user reviews before committing your time and money on a course though, as quality and results can vary.</span></p>\n<h2><span style=\"font-weight: 400;\">Research and read success stories</span></h2>\n<p><span style=\"font-weight: 400;\">A journey of a thousand miles starts with a single step: even though we all know this, it’s still tough for someone to take that step to place it into an appropriate context. If the process of developing your first website starts to drag, it is the easiest thing in the world to just give up on the idea, justifying this abandonment by assuming that it would never have amounted to anything anyway. As with all those well-meaning New Year’s resolutions that fall by the wayside after a month or two, the world is littered with partially designed and built websites that are ultimately forgotten because things got too difficult.</span></p>\n<p><span style=\"font-weight: 400;\">That’s where success stories become so meaningful. There are </span><a href=\"https://www.shopify.com/retail/5-successful-retail-businesses-that-started-off-as-side-hustles\"><span style=\"font-weight: 400;\">plenty of examples</span></a><span style=\"font-weight: 400;\"> out there of thriving businesses that started out slowly, without massive budgets or fanfare. Instead, many successful sites began as simple side hustles set up by aspiring entrepreneurs that eventually grew into highly successful and lucrative businesses. Their creators believed in themselves, worked hard on their websites and kept moving ahead until they achieved their goals. Knowing that success </span><i><span style=\"font-weight: 400;\">can </span></i><span style=\"font-weight: 400;\">be achieved is hugely important for getting through the tough early stages.</span></p>\n<h2><span style=\"font-weight: 400;\">Examine great sites</span></h2>\n<p><span style=\"font-weight: 400;\">When trying to build something great, it can be a massive challenge should you not be very experienced with the production process. It can even be tough to properly envisage exactly what you may be ultimately aiming for. What should the website ultimately look like? How should it work? What pages and categories should you have? In life, there can be a lot of value in having role models to emulate as it can provide inspiration and allow you to see how established and successful sites got where they are, giving you something to aim towards too.</span></p>\n<p><span style=\"font-weight: 400;\">Because of this, one of the best ways to get inspired when building your website is to closely examine the best and most successful websites out there that are similar to yours. Why do users like them so much? What lessons can you learn about how to build a great website? And most importantly, what can be done better?</span> <span style=\"font-weight: 400;\">This will allow you to return to your development project with a much clearer vision of where you would like to take your site.</span></p>\n<h2><span style=\"font-weight: 400;\">Join a community</span></h2>\n<p><span style=\"font-weight: 400;\">One of the best things about the online world has always been its ability to bring people from different backgrounds and lifestyles together. Whatever interest a given person is looking to pursue, they can be absolutely confident that there are relevant internet communities already in place, and that’s certainly the case for web development (and entrepreneurship in general).</span></p>\n<p><span style=\"font-weight: 400;\">Each content management system has numerous communities dedicated to it online, which are always a great place to start. Reddit is another great place for general advice: </span><a href=\"https://www.reddit.com/r/Entrepreneur/\"><span style=\"font-weight: 400;\">the r/Entrepreneur subreddit</span></a><span style=\"font-weight: 400;\"> has 650k members, which is a great place to ask broader business questions. There are also subs like </span><a href=\"https://www.reddit.com/r/webdev/\"><span style=\"font-weight: 400;\">r/webdev</span></a><span style=\"font-weight: 400;\"> (416k members) for more specific technical queries. There are also thousands of videos on YouTube that help show you how to develop and setup a WordPress site, taking you through all the steps needed to take your website plan from idea to reality. </span></p>\n<p><iframe title=\"How To Make a WordPress Website  - For Beginners\" width=\"1080\" height=\"608\" src=\"https://www.youtube.com/embed/8AZ8GqW5iak?feature=oembed\" frameborder=\"0\" allow=\"accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture\" allowfullscreen></iframe></p>\n<p><span style=\"font-weight: 400;\">Inspiration can come in many forms and mean different things to different people, but at its core it’s about motivation: motivation to learn, to keep going, and to strive for greater achievement. While the ideas listed above are far from revolutionary, they are incredibly potent and just one of them can be enough to push a project through to fruition.</span></p>\n<p><a href=\"https://ecommerceplatforms.io\">Rodney Laws</a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/motivation-and-inspiration-ideas-when-building-your-first-website/\">Where to find motivation and inspiration when building your first website</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"https://updraftplus.com/motivation-and-inspiration-ideas-when-building-your-first-website/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"https://updraftplus.com/motivation-and-inspiration-ideas-when-building-your-first-website/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:82:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"5 effective on-site marketing tips for your WordPress site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/Nf5VX_kCEcY/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"https://updraftplus.com/5-effective-on-site-marketing-tips-for-your-wordpress-site/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Jul 2020 13:42:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:20:\"Other WordPress news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:9:\"marketing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:9:\"wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=621029\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:803:\"<p>With 1.3 billion websites, WordPress is by far and away the top choice for website creation across the world. The platform&#8217;s popularity comes from allowing users to easily create personal sites, purchase domain names and customize the site with easy to &#8230; <a href=\"https://updraftplus.com/5-effective-on-site-marketing-tips-for-your-wordpress-site/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/5-effective-on-site-marketing-tips-for-your-wordpress-site/\">5 effective on-site marketing tips for your WordPress site</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:12704:\"<p><span style=\"font-weight: 400;\">With </span><a href=\"https://www.whoishostingthis.com/compare/wordpress/stats/#:~:text=Considering%20that%20the%20number%20of,WordPress%2C%20which%20is%20still%20huge.\"><span style=\"font-weight: 400;\">1.3 billion</span></a><span style=\"font-weight: 400;\"> websites, WordPress is by far and away the top choice for website creation across the world. The platform&#8217;s popularity comes from allowing users to easily create personal sites, purchase domain names and customize the site with easy to use, no-development-needed plugins. Since its launch in 2003, WordPress has made the world of site creation accessible for everyone. </span></p>\n<p><span style=\"font-weight: 400;\">If you have created your own WordPress site and customized it to your personal preference, your next step will probably be figuring out how you market and drive traffic to your brand new site.</span></p>\n<p><span style=\"font-weight: 400;\">This can prove to be very challenging. You could have the greatest idea and site in the world, but without the right marketing, it could remain essentially invisible and un-visited. Luckily, we have 5 of the best tips for successfully marketing your WordPress site.</span></p>\n<h3><span style=\"font-weight: 400;\">1. Use the right plugins</span></h3>\n<p><span style=\"font-weight: 400;\">WordPress allows you to easily integrate plugins so you can make improvements to your website without having to code them yourself. Plugins are extensions that add features, data analytics, and other resources to assist your website. However, you may not know how to </span><a href=\"https://wpforms.com/best-free-wordpress-plugins-for-your-website/\"><span style=\"font-weight: 400;\">choose the plugins</span></a><span style=\"font-weight: 400;\"> that will be best for your site.</span></p>\n<p><span style=\"font-weight: 400;\">Choosing the right plugins for your website comes down to identifying exactly what needs improving, or where you can get a competitive edge on your competitors. For example, you can find plugins that offer features such as these:</span></p>\n<ul>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Improving your SEO (making it more findable).</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Allowing you to </span><a href=\"https://wordpress.org/plugins/wp-optimize/\"><span style=\"font-weight: 400;\">resize and compress images</span></a><span style=\"font-weight: 400;\"> on your website ( making it faster).</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Gathering, collecting, and adding email addresses to your newsletter (making it easier to connect with your visitors).<br />\n</span></li>\n<li>Are <a href=\"https://www.omnisend.com/blog/woocommerce-plugins/\">tailored for e-commerce</a> (making it easier to sell products on your website).</li>\n</ul>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/07/image4.png\"><img class=\"alignnone wp-image-621074\" src=\"https://updraftplus.com/wp-content/uploads/2020/07/image4.png\" alt=\"\" width=\"718\" height=\"458\" /></a></p>\n<p><a href=\"https://wordpress.org/plugins/\"><span style=\"font-weight: 400;\">Source</span></a></p>\n<p><span style=\"font-weight: 400;\">WordPress allows you to easily find popular plugins that others use. You can also search for specific plugins in the internal WordPress search engine &#8211; you should have no problems finding the right plugin to address issues or provide changes for your website.</span></p>\n<h3><span style=\"font-weight: 400;\">2. Optimize your website</span></h3>\n<p><span style=\"font-weight: 400;\">Internet users today expect any website they visit to load almost instantly and provide quick answers. Due to this expectation, it is essential you </span><a href=\"https://looka.com/blog/how-to-make-your-own-website/\"><span style=\"font-weight: 400;\">optimize your website</span></a><span style=\"font-weight: 400;\"> and reduce load times so people can quickly access it. Even a few seconds can make the difference between someone staying on your site or leaving.</span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/07/image3.png\"><img class=\"alignnone wp-image-621077\" src=\"https://updraftplus.com/wp-content/uploads/2020/07/image3.png\" alt=\"\" width=\"522\" height=\"206\" /></a></p>\n<p><a href=\"https://hostreviews.co.uk/website-speed-statistics/\"><span style=\"font-weight: 400;\">Source</span></a></p>\n<p><span style=\"font-weight: 400;\">Every second counts when it comes to website loading speed. The image above shows how the bounce rate increases by 32 percent after visitors are forced to wait three seconds for the website to load. This continues to grow and become worse as more time passes. So, if you want to reduce the number of people that leave your site, you need to lower those load times.</span></p>\n<p><span style=\"font-weight: 400;\">Some options to improve your loading speed include purchasing a private or shared hosting service, removing unused plugins and optimizing your images. Even small optimizations like these can help your site to load slightly faster and retain more visitors.</span></p>\n<h3><span style=\"font-weight: 400;\">3. Use A/B testing for landing pages</span></h3>\n<p><a href=\"https://monday.com/blog/marketing/marketing-teams/\"><span style=\"font-weight: 400;\">Effective marketing</span></a><span style=\"font-weight: 400;\"> requires you to collect data so you can implement the right changes to your website. Many companies use the A/B testing approach to accomplish this, meaning that websites will display two different versions of landing pages to visitors. They will then collect the data for both (for example; session time, click rates, click map) so they can see exactly which elements are working well and which are not. </span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/07/image5.png\"><img class=\"alignnone wp-image-621079\" src=\"https://updraftplus.com/wp-content/uploads/2020/07/image5.png\" alt=\"\" width=\"622\" height=\"474\" /></a></p>\n<p><a href=\"https://financesonline.com/a-b-testing-statistics/\"><span style=\"font-weight: 400;\">Source</span></a></p>\n<p><span style=\"font-weight: 400;\">The image above shows how a company can improve their metrics with A/B testing. This method can also be used in multiple ways to help improve your pages, emails and other resources.</span></p>\n<ul>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Testing colors will let you know which ones appeal most to your customers.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Trying out different email formats and subject lines to get more clicks.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Showing different landing pages will help you to find the one that draws in most leads.</span></li>\n</ul>\n<p><span style=\"font-weight: 400;\">A/B testing works because it allows you to see which idea performs the best. This way, you can effectively test your pages and optimize them to their maximum potential.</span></p>\n<h3><span style=\"font-weight: 400;\">4. Integrate pop-ups to gain contacts</span></h3>\n<p><span style=\"font-weight: 400;\">If you’ve been on the internet before, then you will no doubt know about pop-ups. They usually appear on your screen as soon as you go on a website or if you’re about to leave. Even if you do use popups on your site, you might think that they could cause people to leave as they can generally be seen as annoying. So are they worth the risk?</span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/07/image1.png\"><img class=\"alignnone size-full wp-image-621080\" src=\"https://updraftplus.com/wp-content/uploads/2020/07/image1.png\" alt=\"\" width=\"610\" height=\"278\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/07/image1.png 610w, https://updraftplus.com/wp-content/uploads/2020/07/image1-480x219.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) 610px, 100vw\" /></a></p>\n<p><a href=\"https://www.ipaper.io/blog/popups-for-websites-and-flipbooks\"><span style=\"font-weight: 400;\">Source</span></a></p>\n<p><span style=\"font-weight: 400;\">Looking at the data, you can see that popups have no noticeable effect on your bounce rate but they can double your subscription rate. This suggests that typically you needn’t worry about pop-ups causing people to leave as it has no discernible impact on user behaviour. The benefits of popups seem to heavily outweigh the drawbacks.</span></p>\n<p><span style=\"font-weight: 400;\">There are a few best practices to follow with popups:</span></p>\n<ul>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Whether you choose an immediate popup, or an exit-intent popup, choose one or the other and don’t overdo it. It can feel spammy otherwise. </span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Target your popups to be relevant to the page content. This makes it feel more native to the content that your visitor is already engaged with.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Make it so that if a visitor closes a popup, they won’t see it again for a certain amount of time. 30 days is usually a good benchmark for when you can re-show a returning visitor, but test that time frame for your own site. </span></li>\n</ul>\n<p><span style=\"font-weight: 400;\">Remember that you can use popups to encourage certain actions from your visitors. For example, you can invite them to follow your social media pages, make an account on your website, or sign up to get emails or SMS notifications from you. Experiment and find the best approach for your popups.</span></p>\n<h3><span style=\"font-weight: 400;\">5. Optimize your blogs</span></h3>\n<p><span style=\"font-weight: 400;\">If you want to improve your website’s SEO, then you should focus on your blogs as they can help your business grow in various ways..</span></p>\n<ul>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Provide high-quality content on your website.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Encourage people to visit your website regularly to read articles.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Include keywords in your articles to improve your search engine rankings.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Create fresh content that updates frequently, something which Google prizes highly in its search engine algorithm.</span></li>\n</ul>\n<p><span style=\"font-weight: 400;\">But what parts of your article should you focus on to improve your site&#8217;s SEO?</span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/07/image2.png\"><img class=\"alignnone wp-image-621082\" src=\"https://updraftplus.com/wp-content/uploads/2020/07/image2.png\" alt=\"\" width=\"543\" height=\"543\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/07/image2.png 543w, https://updraftplus.com/wp-content/uploads/2020/07/image2-480x480.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) 543px, 100vw\" /></a></p>\n<p><a href=\"https://databox.com/blog-seo-tips\"><span style=\"font-weight: 400;\">Source</span></a></p>\n<p><span style=\"font-weight: 400;\">If you don’t know where to start with blog optimization, then use the data above. Headline optimization works well because your titles will draw in clicks from outbound links and search engines. Additionally headers and body text allow you to incorporate keywords that can help improve your search engine ranking.</span></p>\n<p><span style=\"font-weight: 400;\">As you improve your blog SEO, you can gain more traffic on your website which will hopefully develop into more leads and conversions if your sales funnel is well-optimized.</span></p>\n<h3><span style=\"font-weight: 400;\">Final comments</span></h3>\n<p><span style=\"font-weight: 400;\">Remember that creating a website is only the first part of establishing your online presence. After providing a place for people to make purchases or interact with your business, you need to work on marketing. By using the five tips mentioned in this article, you can improve your site and allow your business to meet its marketing goals.</span></p>\n<p>Laura Narusyte</p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/5-effective-on-site-marketing-tips-for-your-wordpress-site/\">5 effective on-site marketing tips for your WordPress site</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://updraftplus.com/5-effective-on-site-marketing-tips-for-your-wordpress-site/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"https://updraftplus.com/5-effective-on-site-marketing-tips-for-your-wordpress-site/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:82:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"UpdraftCentral release new 0.8.13 (free and paid) update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/UKOKPjJAPcA/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://updraftplus.com/0-8-13-release/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 01 Jul 2020 14:22:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:14:\"UpdraftCentral\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:20:\"UpdraftCental Update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:14:\"updraftcentral\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:26:\"updraftcentral development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=609297\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:690:\"<p>The latest updates for UpdraftCentral (0.8.13) have now been released. This new release comes loaded with many new features, fixes and tweaks. One of the new features in this update now allows you to upload your plugins and themes while &#8230; <a href=\"https://updraftplus.com/0-8-13-release/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/0-8-13-release/\">UpdraftCentral release new 0.8.13 (free and paid) update</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5056:\"<p><span style=\"font-weight: 400;\">The latest updates for <a href=\"https://en-gb.wordpress.org/plugins/updraftcentral/\">UpdraftCentral</a> (0.8.13) have now been released. This new release comes loaded with many new features, fixes and tweaks.</span></p>\n<p><span style=\"font-weight: 400;\">One of the new features in this update now allows you to upload your plugins and themes while they are still in their zip format. To do this, you first need to install <a href=\"https://updraftplus.com/shop/updraftcentral-dashboard/\">UpdraftCentral Premium</a>. Once this is installed, just press the &#8216;Plugins&#8217; or &#8216;Themes&#8217; menu item, then select &#8216;Install Plugins&#8217; and you will now be able to drag and drop your zip file and upload it directly.</span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/07/pasted-image-0.png\"><img class=\"size-full wp-image-609341 aligncenter\" src=\"https://updraftplus.com/wp-content/uploads/2020/07/pasted-image-0.png\" alt=\"\" width=\"544\" height=\"274\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/07/pasted-image-0.png 544w, https://updraftplus.com/wp-content/uploads/2020/07/pasted-image-0-480x242.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) 544px, 100vw\" /></a></p>\n<p><span style=\"font-weight: 400;\">Another new feature in this update gives</span><span style=\"font-weight: 400;\"> users even more control over remote storage options. Anytime you create a backup with UpdraftCentral, you can now select which of the remote storage locations you would like to send the backup to. </span><span style=\"font-weight: 400;\">Just open the following dialogue box in UpdraftCentral and you can select or deselect the remote storage options of your choice.</span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/07/pasted-image-0-1.png\"><img class=\"wp-image-609342 aligncenter\" src=\"https://updraftplus.com/wp-content/uploads/2020/07/pasted-image-0-1.png\" alt=\"\" width=\"367\" height=\"492\" /></a></p>\n<p><span style=\"font-weight: 400;\">In addition to these new updates, we have also made various tweaks and fixes to keep UpdraftCentral running smooth and compatible with future WordPress and PHP releases.</span></p>\n<ul>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>FEATURE</strong>: Added the ability to choose the remote storage locations you want to send your backup to in the “Backup Now” modal</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>FIX</strong>: Fix scheduled commands execution through WP cron</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>FIX</strong>: Fix can’t delete backup item without refreshing the list after a successful restore process</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>FIX</strong>: Fix layout/css glitch on the backup settings page</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>FIX</strong>: Fix popper.js related error and warning</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Improve UX and accessibility with better keyboard navigation</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Register updates retrieval to run in the background</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Add editor class for page and post modules</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Add new error message to the rpcerrors collection</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Show upload errors in dialog as well as in browser console if debug level is set</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Improve JavaScript’s compatibility with minification and merging, in particular WP-Optimize</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Add REST controller files for page and post modules</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Add internal capability to install plugin or theme through zip file</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Upgrade Bootstrap and Bootbox libraries to current versions</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\"><strong>TWEAK</strong>: Force the connection method ‘via_mothership’ if the command is in the UpdraftClone namespace</span></li>\n</ul>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/0-8-13-release/\">UpdraftCentral release new 0.8.13 (free and paid) update</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"https://updraftplus.com/0-8-13-release/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://updraftplus.com/0-8-13-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:63:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"UpdraftPlus release latest 1.16.25 (free &amp; paid) version\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/chqnBB_gJFE/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Jun 2020 09:55:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:28:\"UpdraftPlus development news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"UpdraftPlus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:23:\"UpdraftPlus development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=594176\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:784:\"<p>The latest updates for UpdraftPlus (1.16.24 and 1.16.25) have now been released. These latest releases come with many new features, fixes and tweaks including the newly added ability to choose the remote storage locations that you would like to send &#8230; <a href=\"https://updraftplus.com/updraftplus-release-latest-1-16-25-free-paid-version/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/updraftplus-release-latest-1-16-25-free-paid-version/\">UpdraftPlus release latest 1.16.25 (free &#038; paid) version</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5053:\"<p><span style=\"font-weight: 400;\">The latest updates for UpdraftPlus (1.16.24 and 1.16.25) have now been released. These latest releases come with many new features, fixes and tweaks including the newly added ability to choose the remote storage locations that you would like to send your backups to in the “Backup Now” modal. This new feature gives users the ability to make a quick backup to just one of your backup storage destinations should you need to backup to just one location. </span></p>\n<p><span style=\"font-weight: 400;\">This update also gives users the option to configure a remote backup storage location (that may be disabled in your settings) and select it to upload to this storage location. This can be particularly useful if you are using UpdraftValt for your main scheduled backups, but still want to make a one off backup that could (for example) include temporary theme changes that you do not want to store alongside your regular backups.</span></p>\n<p><span style=\"font-weight: 400;\">As part of this update we are also improving our database backup and restore code so that it will now support migration between different ‘generate columns’ syntaxes of MySQL and MariaDB. This will help with migrations between different servers when users are using different databases. We have also added other useful improvements to the update including; handling binary data during backup and added support for the AWS Miland and Cape Town endpoints. </span></p>\n<p><span style=\"font-weight: 400;\">In addition to these new updates, we have also made various tweaks and fixes to keep UpdraftPlus running smooth and compatible with future WordPress and PHP releases.</span></p>\n<p><b>1.16.25 </b></p>\n<ul>\n<li><span style=\"font-weight: 400;\">FIX: Dropbox since 1.16.24 was only deleting one backup files archive out of the set. i.e. Excess archives remained on Dropbox. These have to be deleted manually.</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Add version to CSS and JS within filenames to prevent old versions being served after update on sites which have customisations to remove the query string</span></li>\n</ul>\n<p><b>1.16.24 </b></p>\n<ul>\n<li><span style=\"font-weight: 400;\">FEATURE: Support migration between different “generate columns” syntaxes of MySQL and MariaDB</span></li>\n<li><span style=\"font-weight: 400;\">FEATURE: Added the ability to choose the remote storage locations you want to send your backup to in the “Backup Now” modal</span></li>\n<li><span style=\"font-weight: 400;\">FIX: If non-WordPress tables are selected in the advanced ‘Backup Now’ options, then back them up (even if the saved setting to back them up is off). i.e. “Backup Now” over-ride options should have been taking priority.</span></li>\n<li><span style=\"font-weight: 400;\">FIX: Failure to restore database ‘view’ in some rare circumstances due to the nonexistent DEFINER account and lack of privileges</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Handle binary data during backup</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Add strack_st to the lists of large logging tables and tables not requiring search/replace</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Make search and replace case insensitive when operating on URLs</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: The incremental backup notice logic</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Update bundled updater class (YahnisElsts/plugin-update-checker) (paid versions) to version 4.9</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Add another tweak to paid versions’ update checking time algorithm</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Add the options_exist() method to backup modules that did not have it</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: During manual backup uploads, check if the last 4 bytes are string “null” (caused by an error in uploading to Dropbox) and if so remove them. Prevents an unnecessary message about unexpected data.</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Show the backup label (if specified) in the UI backup progress indicator</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Added the facility to clear the list of existing migration sites</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Create default instance labels</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Bring list of debugging plugins up to date</span></li>\n<li><span style=\"font-weight: 400;\">TWEAK: Add support for the AWS Milan and Cape Town endpoints (and correct a couple of existing endpoints that had wrong references)</span></li>\n</ul>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/updraftplus-release-latest-1-16-25-free-paid-version/\">UpdraftPlus release latest 1.16.25 (free &#038; paid) version</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"https://updraftplus.com/updraftplus-release-latest-1-16-25-free-paid-version/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:91:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"WP-Optimize updated with new Minify feature\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/NeWIJ2fr3cQ/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"https://updraftplus.com/wp-optimize-updated-with-new-minify-feature/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 02 Jun 2020 12:35:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:7:{i:0;a:5:{s:4:\"data\";s:11:\"WP Optimize\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:6:\"Minify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"WP-O\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:11:\"WP-Optimise\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:18:\"WP-Optimise Update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:11:\"WP-Optimize\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:17:\"WP-Optmize update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=590046\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:761:\"<p>WP-Optimize is our popular all-in-one WordPress performance and optimisation plugin that cleans your database, compresses your large images and caches your site. As you may have seen in our recent blog, in addition to these features WP-Optimize have now released &#8230; <a href=\"https://updraftplus.com/wp-optimize-updated-with-new-minify-feature/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/wp-optimize-updated-with-new-minify-feature/\">WP-Optimize updated with new Minify feature</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5847:\"<p><iframe title=\"Minify for WP-Optimize\" src=\"https://player.vimeo.com/video/402556749?dnt=1&amp;app_id=122963\" width=\"1080\" height=\"608\" frameborder=\"0\" allow=\"autoplay; fullscreen\" allowfullscreen></iframe></p>\n<p><span style=\"font-weight: 400;\"><br />\nWP-Optimize is our popular all-in-one WordPress performance and optimisation plugin that cleans your database, compresses your large images and caches your site. As you may have seen in our recent </span><a href=\"https://updraftplus.com/wp-optimize-to-release-new-minify-feature/\"><span style=\"font-weight: 400;\">blog</span></a><span style=\"font-weight: 400;\">, in addition to these features WP-Optimize have now released a new Minify feature that can help make your website run even faster. This new Minify feature is all about increasing the speed of users&#8217; WordPress site.</span></p>\n<p><b>How does Minify work?</b></p>\n<p><span style=\"font-weight: 400;\">Minify works by combining and minifying the static assets of your website, including CSS and JavaScript files. By removing the unnecessary characters in these static assets, Minify deletes characters such as line breaks and white space from your website’s code; the deletion of which can help your site to load faster by further saving space. Minify also ensures that your files are merged into as few files as possible. This reduces the amount of load on your web server and can be quicker to load fewer files.</span></p>\n<p><span style=\"font-weight: 400;\">Users can also defer the loading of any CSS or JavaScript file. This means any large or extraneous CSS or JavaScript file can be loaded independently from the core of your WordPress site; giving users quicker access to your site.</span></p>\n<p><span style=\"font-weight: 400;\">WP-Optimize Minify has been built and designed to work seamlessly with your website and the overall WP-Optimize optimization process. By activating and using Minify, you should find that everything on your site still acts and behaves in exactly the same way that it always has, with the one difference being that it will now hopefully run faster due to the removal of all the unnecessary information.  </span></p>\n<p><b>Is Minify easy to use?</b></p>\n<p><span style=\"font-weight: 400;\">We have designed the Minify feature to be easy to use regardless of a user&#8217;s level of skill and knowledge. For most people, all you have to do is toggle the main switch to “enable minify”. </span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/06/New-Project-44.jpg\"><img class=\"alignnone wp-image-590051 size-large\" src=\"https://updraftplus.com/wp-content/uploads/2020/06/New-Project-44-1024x420.jpg\" alt=\"\" width=\"1024\" height=\"420\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/06/New-Project-44-980x402.jpg 980w, https://updraftplus.com/wp-content/uploads/2020/06/New-Project-44-480x197.jpg 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) and (max-width: 980px) 980px, (min-width: 981px) 1024px, 100vw\" /></a></p>\n<p><span style=\"font-weight: 400;\">WP-Optimize will then automatically take care of all your minification needs. </span></p>\n<p><b>What if I have issues using Minify?</b></p>\n<p><span style=\"font-weight: 400;\">While simply just turning on Minify will get great results and be sufficient for most users, there will be a small number of users that may find that due to their specific website design, the appearance of the site may have altered. While the possibility of this happening will be rare, there is a very small chance it could happen. Should you find yourself in this position, just toggle the “enable minify&#8221; switch again to turn off the feature and your site will revert back to its original state. We then recommend visiting our support forum and ask for help on how to configure Minify to work on your site.</span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/06/New-Project-45.jpg\"><img class=\"alignnone wp-image-590053 size-large\" src=\"https://updraftplus.com/wp-content/uploads/2020/06/New-Project-45-1024x303.jpg\" alt=\"\" width=\"1024\" height=\"303\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/06/New-Project-45-980x290.jpg 980w, https://updraftplus.com/wp-content/uploads/2020/06/New-Project-45-480x142.jpg 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) and (max-width: 980px) 980px, (min-width: 981px) 1024px, 100vw\" /></a></p>\n<p><b>Individual control</b></p>\n<p><span style=\"font-weight: 400;\">With WP-Optimize Minify, you also have the option of adjusting the settings specifically for your website. To change the settings to best suit you and your site, you can go into the HTML, JavaScript, CSS, Fonts, Settings or Advanced tabs to change the settings, creating specific rules for your site.</span></p>\n<p><span style=\"font-weight: 400;\">Should you wish to undo any of the changes you made, we designed Minify so that any changes you may make will not be permanent and can be rolled back by just removing your changes. </span></p>\n<p><span style=\"font-weight: 400;\">Using the Minify feature is completely risk free and is another important and proven way to speed up your page loading times.</span></p>\n<p><span style=\"font-weight: 400;\">We designed the Minify feature to be simple to use and intuitive. Just install </span><a href=\"https://getwpo.com/\"><span style=\"font-weight: 400;\">WP-Optimize</span></a><span style=\"font-weight: 400;\"> and start using it today.</span></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/wp-optimize-updated-with-new-minify-feature/\">WP-Optimize updated with new Minify feature</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"https://updraftplus.com/wp-optimize-updated-with-new-minify-feature/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"8\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://updraftplus.com/wp-optimize-updated-with-new-minify-feature/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:88:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"How to restore your WordPress site to a previous date\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/46LtfRAV2Lc/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"https://updraftplus.com/how-to-restore-your-wordpress-site-to-a-previous-date/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 May 2020 14:10:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:6:{i:0;a:5:{s:4:\"data\";s:22:\"UpdraftPlus advantages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:32:\"how to restore my wordpress site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:22:\"How to use UpdraftPlus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:26:\"restore site previous date\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:22:\"restore wordpress site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:19:\"updraftplus restore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=582659\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:784:\"<p>There’s nothing more distressing for a site manager then having something go wrong with your WordPress site. Whether it’s unexpected file changes, malware, errors, plugin updates, or something else entirely, the fix sadly may not be simple. Due to all &#8230; <a href=\"https://updraftplus.com/how-to-restore-your-wordpress-site-to-a-previous-date/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/how-to-restore-your-wordpress-site-to-a-previous-date/\">How to restore your WordPress site to a previous date</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Gina Lucia\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:14649:\"<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/05/restore-wordpress-updraft.jpg\"><img class=\"alignnone size-full wp-image-582667\" src=\"https://updraftplus.com/wp-content/uploads/2020/05/restore-wordpress-updraft.jpg\" alt=\"\" width=\"1580\" height=\"660\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/05/restore-wordpress-updraft.jpg 1580w, https://updraftplus.com/wp-content/uploads/2020/05/restore-wordpress-updraft-1280x535.jpg 1280w, https://updraftplus.com/wp-content/uploads/2020/05/restore-wordpress-updraft-980x409.jpg 980w, https://updraftplus.com/wp-content/uploads/2020/05/restore-wordpress-updraft-480x201.jpg 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) and (max-width: 980px) 980px, (min-width: 981px) and (max-width: 1280px) 1280px, (min-width: 1281px) 1580px, 100vw\" /></a></p>\n<p><span style=\"font-weight: 400;\">There’s nothing more distressing for a site manager then having something go wrong with your WordPress site. Whether it’s unexpected file changes, malware, errors, plugin updates, or something else entirely, the fix sadly may not be simple. Due to all the potential issues a WordPress site faces, it can be a valuable lifeline to easily and quickly restore your site to a healthier point in time by using UpdraftPlus. It’s for this reason you might need to restore your WordPress site to a previous date and reset your site back to a healthier point in time.</span></p>\n<p><span style=\"font-weight: 400;\">In this guide, we’ll be providing you with step-by-step instructions detailing how you can restore your WordPress site to a previous date using the UpdraftPlus WordPress backup plugin. As a bonus, we’ll outline why you might need to restore your WordPress site with a few examples you might find familiar. </span></p>\n<p><b>The plugin mentioned in this guide:</b></p>\n<ul>\n<li style=\"font-weight: 400;\"><a href=\"https://updraftplus.com/\"><span style=\"font-weight: 400;\">UpdraftPlus</span></a><span style=\"font-weight: 400;\"> – Schedule regular backups of your WordPress site and restore it from those backups in your WordPress control panel.</span></li>\n</ul>\n<p><span style=\"font-weight: 400;\">Want to head straight to the tutorial? <a href=\"https://updraftplus.com/faqs/restore-site-updraftplus/\">Click here</a>.</span></p>\n<h3><span style=\"font-weight: 400;\">Why you might need to restore your WordPress site</span></h3>\n<p><span style=\"font-weight: 400;\">Before we outline how you can restore your site, it’s worth looking into some of the reasons why you might need to do it. Restoring your WordPress site to a previous date isn’t something that should be done lightly, but there are a few very valid and common reasons why you might need to. Here are a few you might recognise:</span></p>\n<h3><span style=\"font-weight: 400;\">Your site has been hacked or compromised</span></h3>\n<p><span style=\"font-weight: 400;\">WordPress itself is a secure content management system on which you can build your website. However, without proper management, it can be prone to attacks by bots and/or hackers. </span></p>\n<p><span style=\"font-weight: 400;\">Any of the following could give these bots or hackers an easy way into your website to spread malware, change access, steal user data or change files:</span></p>\n<ul>\n<li style=\"font-weight: 400;\"><b>WordPress, plugins or themes have not been updated</b><span style=\"font-weight: 400;\"> &#8211; Most plugins need to be kept up to date to remain secure and free from the latest vulnerabilities. By not updating plugins, website owners can leave their site unintentionally vulnerable.</span></li>\n<li style=\"font-weight: 400;\"><b>Weak passwords and usernames are still being used</b><span style=\"font-weight: 400;\"> &#8211; a weak or common username or password combination is enough for bots to gain access to your site. Even keeping the </span><a href=\"https://hackertarget.com/attacking-wordpress/\"><span style=\"font-weight: 400;\">username ‘admin’ on your site</span></a><span style=\"font-weight: 400;\"> can leave you open to easy access.</span></li>\n</ul>\n<p><span style=\"font-weight: 400;\">Should you site become compromised in this way, then a backup and restore plugin like </span><a href=\"https://updraftplus.com/\"><span style=\"font-weight: 400;\">UpdraftPlus</span></a><span style=\"font-weight: 400;\"> can restore your sites content. With an </span><a href=\"https://updraftplus.com/shop/more-files/\"><span style=\"font-weight: 400;\">additional add-on</span></a><span style=\"font-weight: 400;\">, UpdraftPlus can also restore your WordPress core and non-standard files too.</span></p>\n<h3><span style=\"font-weight: 400;\">Major changes were made and files are overwritten</span></h3>\n<p><span style=\"font-weight: 400;\">In the management of your WordPress site, sometimes things can get out of hand and mistakes can be made. For example, you have a developer or member of your team working on making improvements to your site but they forget to save an older version of the file they’re working on, just in case they make a mistake. </span></p>\n<p><span style=\"font-weight: 400;\">By making the wrong kind of changes, your developer has created an error on a major file, with you site now inaccessible to visitors. By using a </span><a href=\"https://updraftplus.com/\"><span style=\"font-weight: 400;\">backup and restore plugin</span></a><span style=\"font-weight: 400;\"> though, you’re able to restore your WordPress site to a previous date, before the error was created and the file was changed.</span></p>\n<p><b>Pro tip:</b><span style=\"font-weight: 400;\"> When either making changes to your website yourself or having a developer help you, we always recommend creating a clone/staging environment for your site. This way any changes you make won’t affect your live site. You can do this easily with </span><a href=\"https://updraftplus.com/updraftclone/\"><span style=\"font-weight: 400;\">UpdraftClone</span></a><span style=\"font-weight: 400;\">.</span></p>\n<p><span style=\"font-weight: 400;\">As a bonus, UpdraftPlus can be set up to perform automatic backups when plugins, themes and WordPress core updates run. This means that keeping your site up to date and secure has never been easier.</span></p>\n<h2><span style=\"font-weight: 400;\">How to restore your WordPress site to a previous date</span></h2>\n<p><span style=\"font-weight: 400;\">If you recognise any of the above situations and need to restore your WordPress site to a previous date, then the following step-by-step instructions will help.</span></p>\n<p><b>Note: </b><span style=\"font-weight: 400;\">UpdraftPlus can only restore your site to a previous date if you already had UpdraftPlus installed and performing scheduled backups. If you do not have UpdraftPlus installed, it is recommend that you contact your hosting provider, who can hopefully help you.</span></p>\n<p><span style=\"font-weight: 400;\">To save your future-self time, money and a serious headache, </span><a href=\"https://updraftplus.com/\"><span style=\"font-weight: 400;\">get UpdraftPlus installed</span></a><span style=\"font-weight: 400;\"> (it’s free) on your site to give you peace of mind.</span></p>\n<p><b>UpdraftPlus not only restores your WordPress site to a previous date, but it also:</b></p>\n<ul>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Performs backups of all your WordPress files, databases, plugins and themes.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Implements scheduled backups every 4, 8 or 12 hours, daily, weekly, fortnightly or monthly (set by you).</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Restores backups directly from your WordPress control panel.</span></li>\n<li style=\"font-weight: 400;\"><span style=\"font-weight: 400;\">Lets you store your backups remotely on Google Drive, Dropbox, OneDrive and more.</span></li>\n</ul>\n<h3><span style=\"font-weight: 400;\">Installing UpdraftPlus</span></h3>\n<p><span style=\"font-weight: 400;\">Installing UpdraftPlus takes just a minute or two and is as simple as adding any other plugin to your site. To install, follow these steps:</span></p>\n<p>1.In your WordPress dashboard go to <b>Plugins</b> &gt; <b>Add New</b>.</p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.17.30.jpg\"><img class=\"alignnone size-full wp-image-582672\" src=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.17.30.jpg\" alt=\"\" width=\"675\" height=\"150\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.17.30.jpg 675w, https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.17.30-480x107.jpg 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) 675px, 100vw\" /></a></p>\n<p>2. Type <b>UpdraftPlus</b> into the search bar.</p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.18.39.png\"><img class=\"alignnone size-full wp-image-582673\" src=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.18.39.png\" alt=\"\" width=\"1017\" height=\"126\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.18.39.png 1017w, https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.18.39-980x121.png 980w, https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.18.39-480x59.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) and (max-width: 980px) 980px, (min-width: 981px) 1017px, 100vw\" /></a></p>\n<p>3. Find the <b>UpdraftPlus WordPress Backup Plugin</b> and press <b>Install Now</b> and then <b>Activate</b>.</p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.19.53.png\"><img class=\"alignnone size-full wp-image-582674\" src=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.19.53.png\" alt=\"\" width=\"514\" height=\"350\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.19.53.png 514w, https://updraftplus.com/wp-content/uploads/2020/05/Screenshot-2020-02-24-at-13.19.53-480x327.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) 514px, 100vw\" /></a></p>\n<h3><span style=\"font-weight: 400;\">How to use UpdraftPlus to restore your WordPress site</span></h3>\n<p><span style=\"font-weight: 400;\">In this example, we have UpdraftPlus installed, set up and running and have already backed up our site in Google Drive (our storage of choice). If you need a little more help, read this guide to understand </span><a href=\"https://updraftplus.com/how-to-backup-a-wordpress-site-step-by-step-guide/\"><span style=\"font-weight: 400;\">how to get UpdraftPlus up and running</span></a><span style=\"font-weight: 400;\"> and backing up your site.</span></p>\n<p><b>To restore your site, do the following:</b></p>\n<p>1. Go to <b>Settings</b> &gt; <b>UpdraftPlus Backups</b> in your WordPress menu. This will open your UpdraftPlus settings page.</p>\n<p>2. Scroll down the page until you reach the <b>Existing Backups</b> section.</p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/05/01-udp-dashboard-1.png\"><img class=\"alignnone size-full wp-image-582675\" src=\"https://updraftplus.com/wp-content/uploads/2020/05/01-udp-dashboard-1.png\" alt=\"\" width=\"1033\" height=\"846\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/05/01-udp-dashboard-1.png 1033w, https://updraftplus.com/wp-content/uploads/2020/05/01-udp-dashboard-1-980x803.png 980w, https://updraftplus.com/wp-content/uploads/2020/05/01-udp-dashboard-1-480x393.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) and (max-width: 980px) 980px, (min-width: 981px) 1033px, 100vw\" /></a></p>\n<p>3. Find the backup from the date you want to restore and press the blue <b>Restore</b> button.</p>\n<p>4. You will then be shown a popup which will ask you which elements of your database you want to restore. Select the ones that apply and press <b>Restore.</b></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/05/restore2.png\"><img class=\"alignnone size-full wp-image-582679\" src=\"https://updraftplus.com/wp-content/uploads/2020/05/restore2.png\" alt=\"\" width=\"601\" height=\"488\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/05/restore2.png 601w, https://updraftplus.com/wp-content/uploads/2020/05/restore2-480x390.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) 601px, 100vw\" /></a></p>\n<p><span style=\"font-weight: 400;\">When your restore is complete, a message will pop up telling you the “Restore has been successful”.</span></p>\n<p><span style=\"font-weight: 400;\">That’s it!, Restoring your WordPress site with UpdraftPlus is easy and hassle-free. Plus, you can configure how often you would like your backups to take place. This is handy if you have a very active site that’s updated regularly, allowing you to create daily updates to help give you peace of mind.</span></p>\n<h2><span style=\"font-weight: 400;\">Summary: Restoring your WordPress site to a previous date </span></h2>\n<p><span style=\"font-weight: 400;\">In this guide, you’ve learned why having the ability to restore your WordPress site is important and how to get it done quickly and easily using UpdraftPlus.</span></p>\n<p><span style=\"font-weight: 400;\">The investment you make in backing up your website so you can restore it to a previous date should you ever need to, will not only save you time but money also. </span></p>\n<p><span style=\"font-weight: 400;\">Having the ability to restore your WordPress site will help you avoid costly developer fees and website downtime. </span><a href=\"https://updraftplus.com/\"><span style=\"font-weight: 400;\">UpdraftPlus</span></a><span style=\"font-weight: 400;\"> makes this process simple and easy to do.</span></p>\n<p><b>The plugin featured in this guide:</b></p>\n<p><a href=\"https://updraftplus.com/\"><span style=\"font-weight: 400;\">Get UpdraftPlus for free</span></a><span style=\"font-weight: 400;\"> – Schedule regular backups of your WordPress site and restore it from those backups in your WordPress control panel.</span></p>\n<p>&nbsp;</p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/how-to-restore-your-wordpress-site-to-a-previous-date/\">How to restore your WordPress site to a previous date</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"https://updraftplus.com/how-to-restore-your-wordpress-site-to-a-previous-date/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://updraftplus.com/how-to-restore-your-wordpress-site-to-a-previous-date/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:78:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"How millions working from home has slowed the internet and how WP-Optimize is working hard to help\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/_v19JdJPn08/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 07 May 2020 10:46:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:8:{i:0;a:5:{s:4:\"data\";s:11:\"WP Optimize\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:5:\"covid\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"COVID-19\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:13:\"slow internet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:17:\"working from home\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:4:\"WP-O\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:11:\"WP-Optimise\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:7;a:5:{s:4:\"data\";s:11:\"WP-Optimize\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=572025\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:868:\"<p>The current enforced working from home guidelines in place are in place in an attempt to slow the spread of Covid-19. They have now become a way of life for many, with a growing number of people in the UK &#8230; <a href=\"https://updraftplus.com/how-millions-working-from-home-has-slowed-the-internet-and-how-wp-optimize-is-working-hard-to-help/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/how-millions-working-from-home-has-slowed-the-internet-and-how-wp-optimize-is-working-hard-to-help/\">How millions working from home has slowed the internet and how WP-Optimize is working hard to help</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5962:\"<p><span style=\"font-weight: 400;\">The current enforced working from home guidelines in place are in place in an attempt to slow the spread of Covid-19. They have now become a way of life for many, with a growing number of people in the UK and around the world now using the internet to provide not just entertainment, but work and education also. This extra demand on bandwidth and associated infrastructure has caused problems for many and include the recent </span><a href=\"https://www.express.co.uk/life-style/science-technology/1274821/Virgin-Media-Offline-Outage-Internet-Down-Refund-Money-Back-Compensation\"><span style=\"font-weight: 400;\">Virgin internet outage</span></a><span style=\"font-weight: 400;\">, which left 43,00 users in the UK without an internet connection. Along with these outages, many internet users have also complained about the reduction in internet speeds that have seemed to have been put into effect to combat overuse. </span></p>\n<p><b>Why do you have a slow internet connection?</b></p>\n<p><span style=\"font-weight: 400;\">While the increase in the use of the internet by those homeschooling or binge watching Netflix accounts for the increase in demand, there may be some tips and tricks you can employ to help improve and hopefully speed up your internet connection. </span></p>\n<p><span style=\"font-weight: 400;\">The first thing to consider is the physical location of your internet server. If it is located too far away from your primary device, your home network connection could suffer due to potentially passing through many different devices before reaching your primary device. Also try to ensure that your router is as far away as possible from other devices, such as mobile phones, baby monitors, stereos, smart TVs and speakers, as these devices could interfere with the signal. </span></p>\n<p><span style=\"font-weight: 400;\">If it is not practical to move the router or bring your device closer, one way to help fix this would be to use a WiFi signal booster. A WiFi signal booster will extend your home network coverage by boosting or amplifying your router&#8217;s wireless internet signal. A WiFi signal booster can help to efficiently extend your wireless network, which will be of particular use if you have set-up a temporary office, such as in an attic or garden shed.</span></p>\n<p><b>Other options you can also try</b></p>\n<p><span style=\"font-weight: 400;\">It is also worth remembering that you should try rebooting your router occasionally as it can help clear specific malware (malicious software that has been designed to cause damage to your device or server) or use a wired ethernet connection directly with the router. </span></p>\n<p><span style=\"font-weight: 400;\">Also ensure that you regularly check your computer is updated with the latest antivirus software. While most antivirus protection programmes will carry out this task automatically, it is essential that you keep your computer’s protection up to date, which will help stop new threats slipping past your defences and potentially slowing your computer down.</span></p>\n<p><span style=\"font-weight: 400;\">In the UK, OFCOM have released a 7 point ‘</span><a href=\"https://www.ofcom.org.uk/phones-telecoms-and-internet/advice-for-consumers/stay-connected\"><span style=\"font-weight: 400;\">Stay connected during the coronavirus</span></a><span style=\"font-weight: 400;\">’ guide that further details everything you can do to help limit the strain on your internet. As well as moving your router clear of other devices, OFCOM also recommend that you use a landline when making calls if possible, turn off devices such as tablets and smartphones that you are not using (as they will often use WiFi in the background), try a wired ethernet cable to get better speeds, plug your router directly into your main phone socket and get advice from your broadband provider.   </span></p>\n<p><b>Making your site faster</b></p>\n<p><span style=\"font-weight: 400;\">With millions of extra people using and putting a strain on the internet every day, a scenario could arise where it is possible that your website’s users will experience periods where your site will be slow and unresponsive.</span></p>\n<p><span style=\"font-weight: 400;\">While we are unable to make the internet run faster, </span><a href=\"https://getwpo.com/\"><span style=\"font-weight: 400;\">WP-Optimize</span></a><span style=\"font-weight: 400;\"> has put in a lot of time and effort trying to do the next best thing. If you want your website to run faster and remain usable, installing WP-Optimize on your WordPress site is a great place to start. WP-Optimize is a revolutionary, all in one plugin that cleans your website’s database, compresses images (which slow loading speed) and caches your site. By improving your website’s performance, WP-Optimize can also help boost SEO, reduce visitor bounce rate and reduce server resources.</span></p>\n<p><span style=\"font-weight: 400;\">For further details on how to improve your website’s speed using WP-Optimize, be sure to check out </span><a href=\"https://updraftplus.com/how-to-increase-website-speed-with-wp-optimize-plugin/\"><span style=\"font-weight: 400;\">this blog</span></a><span style=\"font-weight: 400;\">. In this blog you will discover the best way to set-up and optimize the plugin. </span></p>\n<p><span style=\"font-weight: 400;\">If you have any questions or comments regarding WP-Optimize, please leave a message in the comment section below. </span></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/how-millions-working-from-home-has-slowed-the-internet-and-how-wp-optimize-is-working-hard-to-help/\">How millions working from home has slowed the internet and how WP-Optimize is working hard to help</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:123:\"https://updraftplus.com/how-millions-working-from-home-has-slowed-the-internet-and-how-wp-optimize-is-working-hard-to-help/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:66:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Clones have just got bigger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/DfFpcV2YQU0/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Apr 2020 14:07:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:12:\"UpdraftClone\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:6:\"clones\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:15:\"WordPress Clone\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:24:\"WordPress Clone database\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=560511\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:724:\"<p>Since its launch in September 2018, UpdraftClone has been helping to revolutionise how people &#8216;copy and paste&#8217; WordPress sites. While this clone feature was launched to allow users to create a ready-hosted cloned site instantly from UpdraftPlus, there have been &#8230; <a href=\"https://updraftplus.com/clones-have-just-got-bigger/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/clones-have-just-got-bigger/\">Clones have just got bigger</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1849:\"<p><span style=\"font-weight: 400;\">Since its launch in September 2018, <a href=\"https://updraftplus.com/updraftclone/\">UpdraftClone</a> has been helping to revolutionise how people &#8216;copy and paste&#8217; WordPress sites. While this clone feature was launched to allow users to create a ready-hosted cloned site instantly from UpdraftPlus, there have been some users that have requested the ability to generate larger clones. </span></p>\n<p><span style=\"font-weight: 400;\">Following these requests, many people will be pleased to hear that launching soon, users of UpdraftClone will now be able to boot larger clones should they need to. This new feature will be of particular use to users that have a site larger than 25GB (the smallest clone size). UpdraftClone will also automatically choose the correct size of the clone should the user select an existing backup. As the larger clones take up more server space, they will cost a little extra in tokens to run and renew. </span></p>\n<p><span style=\"font-weight: 400;\">We have also extended the larger clone option to existing clones. To increase the size of your existing clones, just go to your UpdraftPlus account “My-Clones” page and click on “Manage Clone” for the clone that you wish to resize. An option will then appear allowing the user to increase the size of the existing clone, should you require more space. </span></p>\n<p><span style=\"font-weight: 400;\">If you have any questions, be sure to share them with us in the comment section below. </span></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/clones-have-just-got-bigger/\">Clones have just got bigger</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://updraftplus.com/clones-have-just-got-bigger/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:75:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"Working from home: What we can learn from WordPress bloggers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/nZB5EjX_sjQ/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Apr 2020 14:29:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:7:{i:0;a:5:{s:4:\"data\";s:9:\"Off Topic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:20:\"Other WordPress news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"Blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:5:\"covid\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:8:\"COVID-19\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:9:\"wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:17:\"working from home\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=556837\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:815:\"<p>With the current world-wide situation regarding the Covid-19 virus necessitating many people to either start or exclusively work from home for the first time in their careers, the traditional 9-5 working day is constantly being rewritten and re-evaluated by companies &#8230; <a href=\"https://updraftplus.com/working-from-home-what-we-can-learn-from-wordpress-bloggers/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/working-from-home-what-we-can-learn-from-wordpress-bloggers/\">Working from home: What we can learn from WordPress bloggers</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Wayne Mullins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:8728:\"<p><span style=\"font-weight: 400;\">With the current world-wide situation regarding the Covid-19 virus necessitating many people to either start or exclusively work from home for the first time in their careers, the traditional 9-5 working day is constantly being rewritten and re-evaluated by companies being forced to change the way their staff work. </span></p>\n<p><span style=\"font-weight: 400;\">Due to the current crisis, many companies are now being forced to update their working practices for the first time in generations or risk going out of business and potentially contributing to the spread of the virus to vulnerable parties. With the changing of these traditional working attitudes, companies all over the world are having to find new ways to adapt in order to remain active, relevant and accommodating to workers affected by the current situation</span></p>\n<p><b>Why have some companies resisted the working from home movement?</b></p>\n<p><span style=\"font-weight: 400;\">Before the Covid-19 outbreak, it was estimated that </span><a href=\"https://www.avocor.com/blog/business-blog/remote-working-statistics/\"><span style=\"font-weight: 400;\">70% of people</span></a><span style=\"font-weight: 400;\"> worldwide work remotely at least once per week. Even before the virus forced a fundamental shift in working patterns, statistics have shown that working from home has been gaining in popularity all over the world due to the increase in high speed internet and changing demands and expectations of a younger workforce to have a better work/life balance. However many old school companies have been </span><a href=\"https://www.ft.com/content/5dc60b96-669c-11ea-800d-da70cff6e4d3\"><span style=\"font-weight: 400;\">resistant to change</span></a><span style=\"font-weight: 400;\"> and have clung to the traditional 9-5 model due to lack of trust in staff, poor infrastructure and the inability or desire to evolve. In the UK the </span><a href=\"https://workplaceinsight.net/homeworking-up-more-than-a-quarter-in-last-decade-analysis-shows/\"><span style=\"font-weight: 400;\">TUC estimates</span></a><span style=\"font-weight: 400;\"> that around 4 million UK workers would like to be given the chance to work from home at least some time during the week, but have never been given the opportunity.</span></p>\n<p><span style=\"font-weight: 400;\">It is not just the improved work/life balance that attracts many workers to the idea of working from home. Nearly 10% of commuters spend 90 minutes or more travelling each way to get to work, with “extreme commuters” now hitting 2 </span><a href=\"https://www.randstad.co.uk/about-us/press-releases/randstad-news/savvy-super-commuters-spend-time-wisely/\"><span style=\"font-weight: 400;\">million in the UK</span></a><span style=\"font-weight: 400;\">. The environmental impact of having millions of people travelling such great distances for work (that we are now seeing can largely be done from home) is another major factor in the desire to commute less for many workers. </span></p>\n<p><span style=\"font-weight: 400;\">While it may be an extreme example given the overall quarantine guidelines enacted during the early stages of the outbreak, the Nitrogen dioxide levels from China </span><a href=\"https://www.nbcnews.com/science/environment/coronavirus-shutdowns-have-unintended-climate-benefits-n1161921\"><span style=\"font-weight: 400;\">dropped massively</span></a><span style=\"font-weight: 400;\"> during the lockdown period of February and March, showing what can be done to limit climate change and improve air quality just by eliminating the </span><a href=\"https://pollybarks.com/zero-waste-commute/\"><span style=\"font-weight: 400;\">commute to a job</span></a><span style=\"font-weight: 400;\">.</span></p>\n<p><a href=\"https://updraftplus.com/wp-content/uploads/2020/04/China1.png\"><img class=\"alignnone size-full wp-image-556840\" src=\"https://updraftplus.com/wp-content/uploads/2020/04/China1.png\" alt=\"\" width=\"720\" height=\"545\" srcset=\"https://updraftplus.com/wp-content/uploads/2020/04/China1.png 720w, https://updraftplus.com/wp-content/uploads/2020/04/China1-480x363.png 480w\" sizes=\"(min-width: 0px) and (max-width: 480px) 480px, (min-width: 481px) 720px, 100vw\" /></a></p>\n<p><b>What can we learn from WordPress bloggers?</b></p>\n<p><span style=\"font-weight: 400;\">A big share of WordPress users are those who use the platform for blogging. For this army of WordPress users very little will change during this time, but there are valuable lessons about how to successfully remote working we can learn from our blogging colleagues. </span></p>\n<p><span style=\"font-weight: 400;\">There are many guides on the best methods and rules to follow when working from home. As we discussed in our previous </span><a href=\"https://updraftplus.com/top-5-tips-to-keep-active-and-healthy-during-lock-down/\"><span style=\"font-weight: 400;\">blog</span></a><span style=\"font-weight: 400;\">, there are several basic rules you can follow during your enforced ‘work from home’ period if you hope to achieve the same kind of work ethic as a successful WordPress blogger.</span></p>\n<ul>\n<li><b>A designated work space</b><span style=\"font-weight: 400;\"><br />\n</span><span style=\"font-weight: 400;\">While you may not be able to dedicate an entire room to your new ‘home office’, there are still things you can do to help create a more work-like environment. Sitting in front of the TV on your laptop isn’t going to result in much work getting done, so if you are working from a dining table or the desk in your bedroom, make sure that it is free from clutter, obvious distractions and you have enough room to work comfortably. </span></li>\n<li><b>Plan your work day<br />\n<span style=\"font-weight: 400;\">If you make a list in the morning of what jobs you want to get done and by when, it can help keep you motivated and give you clear goals and targets for the day ahead. Working to a pre-set plan can help create the traditional ‘deadline’ mindset that can help improve your output and performance.</span></b></li>\n<li><b>Limit your hours<br />\n<span style=\"font-weight: 400;\">While working from home can save hours everyday as you no longer need to commute, it might be tempting to put those hours towards your work instead, This can result in someone potentially facing burn-out from working too long and not taking enough breaks.</span></b></li>\n<li><strong>Remember to exercise</strong><br />\n<span style=\"font-weight: 400;\">From getting up in the morning, to sitting at your desk: The whole process could take less than 10 steps. Sitting at your computer all day in the comfort of your own home could potentially cause you to neglect the need to get up, move around and step away from the screen for a break. By spending too much time at your computer, you can risk eye strain, repetitive stress injuries and fatigue. By taking regular breaks and exercising, you can re-energise your mind, re-focus your concentration and increase your productivity. </span></li>\n<li><strong>Limit distractions</strong><br />\n<span style=\"font-weight: 400;\">With smartphones, the internet and streaming services, there is literally an unending amount of content and services to distract you when you are trying to work. As WordPress bloggers know only too well, it is necessary to limit these distractions if you ever want to get anything done. The easiest way to do this is by making sure your new home working area is free of these distractions. While it may not be possible to remove every attention g rabbing app or website, you can still limit their impact on your focus. For example, try setting your mobile phone to silent so you are not distracted every time you have a notification</span></li>\n</ul>\n<p><b>In summary</b></p>\n<p><span style=\"font-weight: 400;\">While we do not know how many weeks, months or even years the current situation will continue for, we do know that when it comes to remote working, WordPress bloggers around the world have shown that we can still have a rich and fulfilling work life environment. By following the above steps when setting up your home office and work environment, it is important to remember that it is going to take a fair bit of time, effort and focus in order to establish what does and doesn’t work for you personally. </span></p>\n<p>&nbsp;</p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/working-from-home-what-we-can-learn-from-wordpress-bloggers/\">Working from home: What we can learn from WordPress bloggers</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"https://updraftplus.com/working-from-home-what-we-can-learn-from-wordpress-bloggers/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:75:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"How has your business and WordPress site been affected by the Covid-19 crisis?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://feedproxy.google.com/~r/UpdraftPlus/~3/i9RYhj9bdZI/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Apr 2020 11:00:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:7:{i:0;a:5:{s:4:\"data\";s:9:\"Off Topic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:20:\"Other WordPress news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:13:\"Uncategorized\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:5:\"covid\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:11:\"UpdraftPlus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:5:\"virus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:9:\"wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"https://updraftplus.com/?p=550725\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:812:\"<p>It feels like the whole world is turned upside down.  Everybody and everything has been affected by the global pandemic. Even those who avoid exposure to the dreaded virus have their businesses exposed to a new, unknown environment of economic &#8230; <a href=\"https://updraftplus.com/business-wordpress-site-been-affected-by-the-covid-19-crisis/\">Continue reading <span class=\"meta-nav\">&#8594;</span></a></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/business-wordpress-site-been-affected-by-the-covid-19-crisis/\">How has your business and WordPress site been affected by the Covid-19 crisis?</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Naomi Miles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3233:\"<p><span style=\"font-weight: 400;\">It feels like the whole world is turned upside down. </span></p>\n<p><span style=\"font-weight: 400;\">Everybody and everything has been affected by the global pandemic. Even those who avoid exposure to the dreaded virus have their businesses exposed to a new, unknown environment of economic uncertainty. This is an unprecedented time and for many, it’s deeply unsettling. </span></p>\n<p><span style=\"font-weight: 400;\">At a time when so many of us are shut in, the internet provides us with some consolation: it is, for many, a vital lifeline to the outside world providing news and advice, a way of us getting hold of groceries, medication and other necessities, and of getting e-learning resources for our children.</span></p>\n<p><span style=\"font-weight: 400;\">This time of crisis makes us more aware than ever of our frailty- both as individuals and as a society. It makes us conscious of just how interconnected our world is, and there’s strength in that fact too. We can all do our bit and stand shoulder to shoulder with others.</span></p>\n<p><span style=\"font-weight: 400;\">We want you to know that at UpdraftPlus, we’re here for you. With so much else going on, the last thing you want to worry about is your WordPress site&#8217;s basic functioning, so rest assured that we&#8217;re here to provide expert support 6 days a week, around the clock.  We&#8217;re a team of 15, distributed across 9 different countries and 4 continents and as of the last few weeks, we&#8217;re all working from home. Whatever happens over the coming weeks and months, someone will be on hand to help with your backup queries. </span></p>\n<p><span style=\"font-weight: 400;\">In the midst of</span><a href=\"https://www.telegraph.co.uk/news/2020/03/09/uk-broadband-wont-cope-millions-working-home-coronavirus-outbreak/\"> <span style=\"font-weight: 400;\">reports</span></a><span style=\"font-weight: 400;\"> of the internet becoming slower from all the people working from home, we&#8217;re also working hard to process all your support requests at Updraft&#8217;s</span><a href=\"https://getwpo.com/\"> <span style=\"font-weight: 400;\">WP-Optimize Cache</span></a><span style=\"font-weight: 400;\"> to ensure your website runs as fast and efficiently as possible.</span></p>\n<p><span style=\"font-weight: 400;\">Finally, the team here at UpdraftPlus want to hear about how your WordPress business is being affected by this crisis. What’s your experience? How have you adapted? Has your business been hit or your online presence providing a crucial service? And what advice would you pass on to other businesses?</span></p>\n<p><b><i>Please share below how your WordPress business has been affected for the worse or better at this time.</i></b></p>\n<p><span style=\"font-weight: 400;\">The UpdraftPlus Team</span></p>\n<p>The post <a rel=\"nofollow\" href=\"https://updraftplus.com/business-wordpress-site-been-affected-by-the-covid-19-crisis/\">How has your business and WordPress site been affected by the Covid-19 crisis?</a> appeared first on <a rel=\"nofollow\" href=\"https://updraftplus.com\">UpdraftPlus</a>. <a href=\"http://updraftplus.com\">UpdraftPlus - Backup, restore and migration plugin for WordPress.</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"https://updraftplus.com/business-wordpress-site-been-affected-by-the-covid-19-crisis/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:2:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";s:4:\"href\";s:39:\"http://feeds.feedburner.com/UpdraftPlus\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:2:{s:3:\"rel\";s:3:\"hub\";s:4:\"href\";s:32:\"http://pubsubhubbub.appspot.com/\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:4:\"info\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:3:\"uri\";s:11:\"updraftplus\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:11:{s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:4:\"etag\";s:27:\"aSaBydY5t31Ov1YGfcKilIBl7YU\";s:13:\"last-modified\";s:29:\"Tue, 11 Aug 2020 15:16:21 GMT\";s:16:\"content-encoding\";s:4:\"gzip\";s:4:\"date\";s:29:\"Tue, 11 Aug 2020 15:38:22 GMT\";s:7:\"expires\";s:29:\"Tue, 11 Aug 2020 15:38:22 GMT\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:22:\"x-content-type-options\";s:7:\"nosniff\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:6:\"server\";s:3:\"GSE\";s:7:\"alt-svc\";s:192:\"h3-29=\":443\"; ma=2592000,h3-27=\":443\"; ma=2592000,h3-T050=\":443\"; ma=2592000,h3-Q050=\":443\"; ma=2592000,h3-Q046=\":443\"; ma=2592000,h3-Q043=\":443\"; ma=2592000,quic=\":443\"; ma=2592000; v=\"46,43\"\";}}s:5:\"build\";s:14:\"20130911033210\";}', 'no'),
 (1572, '_transient_timeout_feed_mod_e0061ca2fa5b884e483872aa34d3e7eb', '1597203502', 'no'),
 (1573, '_transient_feed_mod_e0061ca2fa5b884e483872aa34d3e7eb', '1597160302', 'no'),
 (1574, '_transient_timeout_updraftplus_dashboard_news', '1597203502', 'no'),
 (1575, '_transient_updraftplus_dashboard_news', '<div class=\"rss-widget\"><ul><li class=\"updraftplus_dashboard_news_item\"><a href=\"https://modelox.vico.digital/wp-admin/\" class=\"dashicons dashicons-no-alt\" title=\"Descartar todas las noticias de UpdraftPlus\" onClick=\"updraftplus_dismiss_dashboard_news(); return false;\" style=\"float: right; box-shadow: none; margin-left: 5px;\"></a><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/UpdraftPlus/~3/9-3pvoQHKXo/\'>UpdraftPlus: Where to find motivation and inspiration when building your first website</a></li><li class=\"updraftplus_dashboard_news_item\"><a href=\"https://modelox.vico.digital/wp-admin/\" class=\"dashicons dashicons-no-alt\" title=\"Descartar todas las noticias de UpdraftPlus\" onClick=\"updraftplus_dismiss_dashboard_news(); return false;\" style=\"float: right; box-shadow: none; margin-left: 5px;\"></a><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/UpdraftPlus/~3/Nf5VX_kCEcY/\'>UpdraftPlus: 5 effective on-site marketing tips for your WordPress site</a></li></ul></div>', 'no'),
 (1576, '_transient_timeout_dash_v2_c05853b002c443ec8e57ff884f56cdde', '1597203502', 'no'),
 (1577, '_transient_dash_v2_c05853b002c443ec8e57ff884f56cdde', '<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://es.wordpress.org/2020/08/04/wordpress-5-5-candidata-a-definitiva-2/\'>WordPress 5.5 candidata a definitiva 2</a></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://apps.wordpress.com/2020/08/11/how-do-i-connect-my-wordpress-com-or-jetpack-site/\'>WP Mobile Apps: How Do I Connect My WordPress.com or Jetpack Site?</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/astra-theme-suspended-and-reinstated-themes-team-works-toward-delisting-strategy-for-guideline-violations?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=astra-theme-suspended-and-reinstated-themes-team-works-toward-delisting-strategy-for-guideline-violations\'>WPTavern: Astra Theme Suspended and Reinstated, Themes Team Works Toward Delisting Strategy for Guideline Violations</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/new-wordpress-plugins-disable-unsplash-cdn?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=new-wordpress-plugins-disable-unsplash-cdn\'>WPTavern: New WordPress Plugins Disable Unsplash CDN</a></li></ul></div>', 'no'),
 (1721, 'action_scheduler_lock_async-request-runner', '1597163550', 'yes'),
 (1807, '_transient_timeout_wc_report_sales_by_date', '1597247187', 'no'),
 (1720, 'category_children', 'a:0:{}', 'yes'),
 (1591, 'schema-ActionScheduler_StoreSchema', '3.0.1597160559', 'yes'),
 (1592, 'schema-ActionScheduler_LoggerSchema', '2.0.1597160559', 'yes'),
 (1590, '_site_transient_update_themes', 'O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1597160558;s:7:\"checked\";a:2:{s:13:\"kallyas-child\";s:5:\"4.0.0\";s:7:\"kallyas\";s:6:\"4.17.5\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}', 'no'),
 (1595, 'woocommerce_schema_version', '430', 'yes'),
 (1596, 'woocommerce_store_address', '', 'yes'),
 (1597, 'woocommerce_store_address_2', '', 'yes'),
 (1598, 'woocommerce_store_city', '', 'yes'),
 (1599, 'woocommerce_default_country', 'GB', 'yes'),
 (1600, 'woocommerce_store_postcode', '', 'yes'),
 (1601, 'woocommerce_allowed_countries', 'all', 'yes'),
 (1602, 'woocommerce_all_except_countries', '', 'yes'),
 (1603, 'woocommerce_specific_allowed_countries', '', 'yes'),
 (1604, 'woocommerce_ship_to_countries', '', 'yes'),
 (1605, 'woocommerce_specific_ship_to_countries', '', 'yes'),
 (1606, 'woocommerce_default_customer_address', 'base', 'yes'),
 (1607, 'woocommerce_calc_taxes', 'no', 'yes'),
 (1608, 'woocommerce_enable_coupons', 'yes', 'yes'),
 (1609, 'woocommerce_calc_discounts_sequentially', 'no', 'no'),
 (1610, 'woocommerce_currency', 'GBP', 'yes'),
 (1611, 'woocommerce_currency_pos', 'left', 'yes'),
 (1612, 'woocommerce_price_thousand_sep', ',', 'yes'),
 (1613, 'woocommerce_price_decimal_sep', '.', 'yes'),
 (1614, 'woocommerce_price_num_decimals', '2', 'yes'),
 (1615, 'woocommerce_shop_page_id', '141', 'yes'),
 (1616, 'woocommerce_cart_redirect_after_add', 'no', 'yes'),
 (1617, 'woocommerce_enable_ajax_add_to_cart', 'yes', 'yes'),
 (1618, 'woocommerce_placeholder_image', '19', 'yes'),
 (1619, 'woocommerce_weight_unit', 'kg', 'yes'),
 (1620, 'woocommerce_dimension_unit', 'cm', 'yes'),
 (1621, 'woocommerce_enable_reviews', 'yes', 'yes'),
 (1622, 'woocommerce_review_rating_verification_label', 'yes', 'no'),
 (1623, 'woocommerce_review_rating_verification_required', 'no', 'no'),
 (1624, 'woocommerce_enable_review_rating', 'yes', 'yes'),
 (1625, 'woocommerce_review_rating_required', 'yes', 'no'),
 (1626, 'woocommerce_manage_stock', 'yes', 'yes'),
 (1627, 'woocommerce_hold_stock_minutes', '60', 'no'),
 (1628, 'woocommerce_notify_low_stock', 'yes', 'no'),
 (1629, 'woocommerce_notify_no_stock', 'yes', 'no'),
 (1630, 'woocommerce_stock_email_recipient', 'vicosolutions.com@gmail.com', 'no'),
 (1631, 'woocommerce_notify_low_stock_amount', '2', 'no'),
 (1632, 'woocommerce_notify_no_stock_amount', '0', 'yes'),
 (1633, 'woocommerce_hide_out_of_stock_items', 'no', 'yes'),
 (1634, 'woocommerce_stock_format', '', 'yes'),
 (1635, 'woocommerce_file_download_method', 'force', 'no'),
 (1636, 'woocommerce_downloads_require_login', 'no', 'no'),
 (1637, 'woocommerce_downloads_grant_access_after_payment', 'yes', 'no'),
 (1638, 'woocommerce_downloads_add_hash_to_filename', 'yes', 'yes'),
 (1639, 'woocommerce_prices_include_tax', 'no', 'yes'),
 (1640, 'woocommerce_tax_based_on', 'shipping', 'yes'),
 (1641, 'woocommerce_shipping_tax_class', 'inherit', 'yes'),
 (1642, 'woocommerce_tax_round_at_subtotal', 'no', 'yes'),
 (1643, 'woocommerce_tax_classes', '', 'yes'),
 (1644, 'woocommerce_tax_display_shop', 'excl', 'yes'),
 (1645, 'woocommerce_tax_display_cart', 'excl', 'yes'),
 (1646, 'woocommerce_price_display_suffix', '', 'yes'),
 (1647, 'woocommerce_tax_total_display', 'itemized', 'no'),
 (1648, 'woocommerce_enable_shipping_calc', 'yes', 'no'),
 (1649, 'woocommerce_shipping_cost_requires_address', 'no', 'yes'),
 (1650, 'woocommerce_ship_to_destination', 'billing', 'no'),
 (1651, 'woocommerce_shipping_debug_mode', 'no', 'yes'),
 (1652, 'woocommerce_enable_guest_checkout', 'yes', 'no'),
 (1653, 'woocommerce_enable_checkout_login_reminder', 'no', 'no'),
 (1654, 'woocommerce_enable_signup_and_login_from_checkout', 'no', 'no'),
 (1655, 'woocommerce_enable_myaccount_registration', 'no', 'no'),
 (1656, 'woocommerce_registration_generate_username', 'yes', 'no'),
 (1657, 'woocommerce_registration_generate_password', 'yes', 'no'),
 (1658, 'woocommerce_erasure_request_removes_order_data', 'no', 'no'),
 (1659, 'woocommerce_erasure_request_removes_download_data', 'no', 'no'),
 (1660, 'woocommerce_allow_bulk_remove_personal_data', 'no', 'no'),
 (1661, 'woocommerce_registration_privacy_policy_text', 'Tus datos personales se utilizarán para procesar tu pedido, mejorar tu experiencia en esta web, gestionar el acceso a tu cuenta y otros propósitos descritos en nuestra [privacy_policy].', 'yes'),
 (1662, 'woocommerce_checkout_privacy_policy_text', 'Tus datos personales se utilizarán para procesar tu pedido, mejorar tu experiencia en esta web y otros propósitos descritos en nuestra [privacy_policy].', 'yes'),
 (1663, 'woocommerce_delete_inactive_accounts', 'a:2:{s:6:\"number\";s:0:\"\";s:4:\"unit\";s:6:\"months\";}', 'no'),
 (1664, 'woocommerce_trash_pending_orders', '', 'no'),
 (1665, 'woocommerce_trash_failed_orders', '', 'no'),
 (1666, 'woocommerce_trash_cancelled_orders', '', 'no'),
 (1667, 'woocommerce_anonymize_completed_orders', 'a:2:{s:6:\"number\";s:0:\"\";s:4:\"unit\";s:6:\"months\";}', 'no'),
 (1668, 'woocommerce_email_from_name', 'Sitio Demo', 'no'),
 (1669, 'woocommerce_email_from_address', 'vicosolutions.com@gmail.com', 'no'),
 (1670, 'woocommerce_email_header_image', '', 'no'),
 (1671, 'woocommerce_email_footer_text', '{site_title} &mdash; Built with {WooCommerce}', 'no'),
 (1672, 'woocommerce_email_base_color', '#96588a', 'no'),
 (1673, 'woocommerce_email_background_color', '#f7f7f7', 'no'),
 (1674, 'woocommerce_email_body_background_color', '#ffffff', 'no'),
 (1675, 'woocommerce_email_text_color', '#3c3c3c', 'no'),
 (1676, 'woocommerce_cart_page_id', '137', 'yes'),
 (1677, 'woocommerce_checkout_page_id', '138', 'yes'),
 (1678, 'woocommerce_myaccount_page_id', '139', 'yes'),
 (1679, 'woocommerce_terms_page_id', '', 'no'),
 (1680, 'woocommerce_checkout_pay_endpoint', 'order-pay', 'yes'),
 (1681, 'woocommerce_checkout_order_received_endpoint', 'order-received', 'yes'),
 (1682, 'woocommerce_myaccount_add_payment_method_endpoint', 'add-payment-method', 'yes'),
 (1683, 'woocommerce_myaccount_delete_payment_method_endpoint', 'delete-payment-method', 'yes'),
 (1684, 'woocommerce_myaccount_set_default_payment_method_endpoint', 'set-default-payment-method', 'yes'),
 (1685, 'woocommerce_myaccount_orders_endpoint', 'orders', 'yes'),
 (1686, 'woocommerce_myaccount_view_order_endpoint', 'view-order', 'yes'),
 (1687, 'woocommerce_myaccount_downloads_endpoint', 'downloads', 'yes'),
 (1688, 'woocommerce_myaccount_edit_account_endpoint', 'edit-account', 'yes'),
 (1689, 'woocommerce_myaccount_edit_address_endpoint', 'edit-address', 'yes'),
 (1690, 'woocommerce_myaccount_payment_methods_endpoint', 'payment-methods', 'yes'),
 (1691, 'woocommerce_myaccount_lost_password_endpoint', 'lost-password', 'yes'),
 (1692, 'woocommerce_logout_endpoint', 'customer-logout', 'yes'),
 (1693, 'woocommerce_api_enabled', 'no', 'yes'),
 (1694, 'woocommerce_allow_tracking', 'no', 'no'),
 (1695, 'woocommerce_show_marketplace_suggestions', 'yes', 'no'),
 (1696, 'woocommerce_single_image_width', '600', 'yes'),
 (1697, 'woocommerce_thumbnail_image_width', '300', 'yes'),
 (1698, 'woocommerce_checkout_highlight_required_fields', 'yes', 'yes'),
 (1699, 'woocommerce_demo_store', 'no', 'no'),
 (1700, 'woocommerce_permalinks', 'a:5:{s:12:\"product_base\";s:5:\"/shop\";s:13:\"category_base\";s:18:\"categoria-producto\";s:8:\"tag_base\";s:17:\"etiqueta-producto\";s:14:\"attribute_base\";s:0:\"\";s:22:\"use_verbose_page_rules\";b:1;}', 'yes'),
 (1718, 'woocommerce_shop_page_display', '', 'yes'),
 (1701, 'current_theme_supports_woocommerce', 'yes', 'yes'),
 (1702, 'woocommerce_queue_flush_rewrite_rules', 'no', 'yes'),
 (1703, '_transient_wc_attribute_taxonomies', 'a:0:{}', 'yes'),
 (1772, 'product_cat_children', 'a:0:{}', 'yes'),
 (1705, 'default_product_cat', '16', 'yes'),
 (1723, '_transient_woocommerce_webhook_ids_status_active', 'a:0:{}', 'yes'),
 (1724, 'widget_woocommerce_widget_cart', 'a:2:{i:1;a:2:{s:5:\"title\";s:4:\"Cart\";s:13:\"hide_if_empty\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1725, 'widget_woocommerce_layered_nav_filters', 'a:1:{s:12:\"_multiwidget\";i:1;}', 'yes'),
 (1708, 'woocommerce_version', '4.3.2', 'yes'),
 (1709, 'woocommerce_db_version', '4.3.2', 'yes'),
 (1710, 'woocommerce_homescreen_enabled', 'yes', 'yes');

/* INSERT TABLE DATA: wp8b_postmeta */
INSERT INTO `wp8b_postmeta` VALUES(1, 2, '_wp_page_template', 'default'),
 (2, 3, '_wp_page_template', 'default'),
 (9, 8, '_wp_page_template', 'template-login-customizer.php'),
 (16, 19, '_wp_attached_file', 'woocommerce-placeholder.png'),
 (17, 19, '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:1200;s:6:\"height\";i:1200;s:4:\"file\";s:27:\"woocommerce-placeholder.png\";s:5:\"sizes\";a:7:{s:6:\"medium\";a:4:{s:4:\"file\";s:35:\"woocommerce-placeholder-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:37:\"woocommerce-placeholder-1024x1024.png\";s:5:\"width\";i:1024;s:6:\"height\";i:1024;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:35:\"woocommerce-placeholder-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:35:\"woocommerce-placeholder-768x768.png\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:35:\"woocommerce-placeholder-187x187.png\";s:5:\"width\";i:187;s:6:\"height\";i:187;s:9:\"mime-type\";s:9:\"image/png\";}s:16:\"full-width-image\";a:4:{s:4:\"file\";s:37:\"woocommerce-placeholder-1170x1170.png\";s:5:\"width\";i:1170;s:6:\"height\";i:1170;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"lp_bi_image\";a:4:{s:4:\"file\";s:35:\"woocommerce-placeholder-750x350.png\";s:5:\"width\";i:750;s:6:\"height\";i:350;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}'),
 (18, 20, '_wp_attached_file', '2017/09/logo.png'),
 (19, 20, '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:103;s:6:\"height\";i:84;s:4:\"file\";s:16:\"2017/09/logo.png\";s:5:\"sizes\";a:2:{s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"logo-100x84.png\";s:5:\"width\";i:100;s:6:\"height\";i:84;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"logo-100x84.png\";s:5:\"width\";i:100;s:6:\"height\";i:84;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}'),
 (20, 23, '_wp_attached_file', '2017/10/kallyas_placeholder.png'),
 (21, 23, '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1080;s:4:\"file\";s:31:\"2017/10/kallyas_placeholder.png\";s:5:\"sizes\";a:14:{s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-300x169.png\";s:5:\"width\";i:300;s:6:\"height\";i:169;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:32:\"kallyas_placeholder-1024x576.png\";s:5:\"width\";i:1024;s:6:\"height\";i:576;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-768x432.png\";s:5:\"width\";i:768;s:6:\"height\";i:432;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:32:\"kallyas_placeholder-1536x864.png\";s:5:\"width\";i:1536;s:6:\"height\";i:864;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-280x158.png\";s:5:\"width\";i:280;s:6:\"height\";i:158;s:9:\"mime-type\";s:9:\"image/png\";}s:16:\"full-width-image\";a:4:{s:4:\"file\";s:32:\"kallyas_placeholder-1170x658.png\";s:5:\"width\";i:1170;s:6:\"height\";i:658;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"lp_bi_image\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-750x350.png\";s:5:\"width\";i:750;s:6:\"height\";i:350;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:31:\"kallyas_placeholder-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";s:9:\"uncropped\";b:0;}s:18:\"woocommerce_single\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-600x338.png\";s:5:\"width\";i:600;s:6:\"height\";i:338;s:9:\"mime-type\";s:9:\"image/png\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-600x338.png\";s:5:\"width\";i:600;s:6:\"height\";i:338;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:31:\"kallyas_placeholder-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:13:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}s:14:\"resized_images\";a:2:{i:0;s:9:\"800x566_c\";i:1;s:8:\"140x78_c\";}}}'),
 (22, 129, '_wp_attached_file', '2017/09/copyright.png'),
 (23, 129, '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:93;s:6:\"height\";i:76;s:4:\"file\";s:21:\"2017/09/copyright.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}'),
 (24, 130, '_wp_attached_file', '2017/09/logo.png'),
 (25, 130, '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:103;s:6:\"height\";i:84;s:4:\"file\";s:16:\"2017/09/logo.png\";s:5:\"sizes\";a:2:{s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"logo-100x84.png\";s:5:\"width\";i:100;s:6:\"height\";i:84;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"logo-100x84.png\";s:5:\"width\";i:100;s:6:\"height\";i:84;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}'),
 (459, 160, '_menu_item_type', 'taxonomy'),
 (468, 160, '_menu_item_zn_mega_menu_headers', ''),
 (28, 132, '_wp_page_template', 'default'),
 (467, 160, '_menu_item_zn_mega_menu_enable', ''),
 (469, 160, '_menu_item_zn_mega_menu_label', ''),
 (31, 135, '_wp_page_template', 'default'),
 (32, 140, 'zn_page_builder_status', 'enabled'),
 (33, 140, '_zn_zion_builder_status', 'enabled'),
 (34, 140, '_wp_page_template', 'default'),
 (35, 140, 'slide_template', 'default'),
 (36, 140, 'zn-custom-layout', '0'),
 (37, 140, 'zn_page_builder_els', 'a:2:{i:0;a:6:{s:6:\"object\";s:24:\"TH_CustomSubHeaderLayout\";s:7:\"options\";a:1:{s:15:\"hm_header_style\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid18251f48\";}i:1;a:6:{s:6:\"object\";s:9:\"ZnSection\";s:7:\"options\";a:59:{s:4:\"size\";s:9:\"container\";s:12:\"custom_width\";s:4:\"1170\";s:20:\"custom_width_percent\";s:3:\"100\";s:10:\"sec_height\";s:4:\"auto\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:6:\"valign\";s:3:\"top\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_md\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_sm\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_xs\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:4:\"60px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"60px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:16:\"background_color\";s:0:\"\";s:11:\"source_type\";s:0:\"\";s:16:\"background_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:15:\"enable_parallax\";s:2:\"no\";s:9:\"skewed_bg\";s:2:\"no\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:14:\"source_overlay\";s:1:\"0\";s:20:\"source_overlay_color\";s:7:\"#353535\";s:22:\"source_overlay_opacity\";s:2:\"30\";s:29:\"source_overlay_color_gradient\";s:7:\"#353535\";s:34:\"source_overlay_color_gradient_opac\";s:2:\"30\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:14:\"section_scheme\";s:0:\"\";s:16:\"section_topmasks\";s:4:\"none\";s:11:\"topmasks_bg\";s:0:\"\";s:16:\"hm_header_bmasks\";s:4:\"none\";s:19:\"hm_header_bmasks_bg\";s:0:\"\";s:16:\"enable_ov_hidden\";s:14:\"zn_dummy_value\";s:15:\"dsb_sidemargins\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:6:\"zIndex\";s:0:\"\";s:11:\"gutter_size\";s:0:\"\";s:18:\"enable_inlinemodal\";s:14:\"zn_dummy_value\";s:11:\"window_size\";s:4:\"1200\";s:16:\"window_autopopup\";s:0:\"\";s:15:\"autopopup_delay\";s:1:\"5\";s:16:\"autopopup_cookie\";s:2:\"no\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:9:\"custom_id\";s:13:\"eluid7b3907e0\";}s:7:\"content\";a:2:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:38:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:8:{s:2:\"lg\";s:0:\"\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:3:\"top\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:7:\"#ffffff\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:4:\"40px\";s:5:\"right\";s:4:\"40px\";s:6:\"bottom\";s:4:\"40px\";s:4:\"left\";s:4:\"40px\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:4:\"none\";s:12:\"border_width\";s:1:\"0\";s:12:\"border_color\";s:0:\"\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:21:\"obj_parallax_distance\";s:3:\"100\";s:18:\"obj_parallax_speed\";s:3:\"800\";s:19:\"obj_parallax_easing\";s:14:\"Power1.easeOut\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:9:\"custom_id\";s:13:\"eluidecdd4735\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:15:\"TH_TitleElement\";s:7:\"options\";a:38:{s:12:\"te_alignment\";s:4:\"left\";s:8:\"te_title\";s:10:\"Contact Us\";s:11:\"te_subtitle\";s:0:\"\";s:14:\"te_color_theme\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"20px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"title_bmargin\";a:8:{s:2:\"lg\";s:1:\"0\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:17:\"parent_hover_anim\";s:0:\"\";s:15:\"parent_hover_id\";s:0:\"\";s:13:\"te_tt_heading\";s:1:\"3\";s:19:\"cc_font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:9:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"22px\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:7:\"#0a0a0a\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:13:\"title_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:10:\"te_stt_tag\";s:2:\"h4\";s:13:\"subtitle_typo\";a:9:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:9:\"te_symbol\";s:0:\"\";s:15:\"te_symbol_color\";s:7:\"default\";s:22:\"te_symbol_custom_color\";s:7:\"#cd2122\";s:14:\"te_symbol_icon\";a:2:{s:6:\"family\";s:0:\"\";s:7:\"unicode\";s:0:\"\";}s:9:\"icon_size\";s:2:\"28\";s:13:\"te_symbol_pos\";s:11:\"after-title\";s:7:\"te_text\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:21:\"obj_parallax_distance\";s:3:\"100\";s:18:\"obj_parallax_speed\";s:3:\"800\";s:19:\"obj_parallax_easing\";s:14:\"Power1.easeOut\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid3545348d\";}i:1;a:7:{s:6:\"object\";s:13:\"ZnContactForm\";s:7:\"options\";a:28:{s:5:\"email\";s:15:\"test@domain.com\";s:7:\"cf_from\";s:7:\"noreply\";s:16:\"cf_force_dynamic\";s:14:\"zn_dummy_value\";s:16:\"cf_custom_sender\";s:0:\"\";s:12:\"redirect_url\";s:0:\"\";s:12:\"submit_label\";s:12:\"Send message\";s:13:\"email_subject\";s:19:\"New form submission\";s:12:\"sent_message\";s:27:\"Thank you for contacting us\";s:7:\"captcha\";s:1:\"0\";s:12:\"captcha_lang\";s:0:\"\";s:12:\"send_me_copy\";s:2:\"no\";s:19:\"mailchimp_subscribe\";s:2:\"no\";s:17:\"mailchimp_list_id\";s:0:\"\";s:12:\"cf_labels_pl\";s:1:\"3\";s:11:\"description\";s:0:\"\";s:8:\"cf_debug\";s:14:\"zn_dummy_value\";s:6:\"fields\";a:4:{i:0;a:12:{s:4:\"name\";s:4:\"Name\";s:4:\"type\";s:4:\"text\";s:13:\"select_option\";s:0:\"\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:14:\"Type your name\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:9:\"col-sm-12\";s:10:\"validation\";s:9:\"not_empty\";}i:1;a:12:{s:4:\"name\";s:5:\"Email\";s:4:\"type\";s:4:\"text\";s:13:\"select_option\";s:0:\"\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:18:\"Your email address\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:9:\"col-sm-12\";s:10:\"validation\";s:8:\"is_email\";}i:2;a:12:{s:4:\"name\";s:7:\"Subject\";s:4:\"type\";s:6:\"select\";s:13:\"select_option\";s:192:\"Order Inquiry:Order Inquiry, Pricing/Checkout Issues:Pricing/Checkout Issues, Product Inquiry:Product Inquiry, Shipping Charges:Shipping Charges, Store Experience:Store Experience, Other:Other\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:4:\"Sele\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:9:\"col-sm-12\";s:10:\"validation\";s:9:\"not_empty\";}i:3;a:12:{s:4:\"name\";s:7:\"Message\";s:4:\"type\";s:8:\"textarea\";s:13:\"select_option\";s:0:\"\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:24:\"Please type your message\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:9:\"col-sm-12\";s:10:\"validation\";s:4:\"none\";}}s:14:\"element_scheme\";s:0:\"\";s:14:\"cf_form_styles\";s:5:\"fancy\";s:13:\"input_corners\";s:13:\"inp-c--square\";s:12:\"inputs_style\";s:11:\"inp-s--flat\";s:12:\"button_style\";s:13:\"btn-fullcolor\";s:14:\"button_corners\";s:11:\"btn--square\";s:12:\"button_width\";s:0:\"\";s:11:\"button_size\";s:6:\"btn-md\";s:13:\"btn_alignment\";s:5:\"right\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid5e104af2\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid6e4558b9\";}i:1;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:38:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:8:{s:2:\"lg\";s:0:\"\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:3:\"top\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:4:\"40px\";s:5:\"right\";s:1:\"0\";s:6:\"bottom\";s:1:\"0\";s:4:\"left\";s:4:\"30px\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:4:\"none\";s:12:\"border_width\";s:1:\"0\";s:12:\"border_color\";s:0:\"\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:21:\"obj_parallax_distance\";s:3:\"100\";s:18:\"obj_parallax_speed\";s:3:\"800\";s:19:\"obj_parallax_easing\";s:14:\"Power1.easeOut\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:9:\"custom_id\";s:13:\"eluidecdd4735\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:15:\"TH_TitleElement\";s:7:\"options\";a:38:{s:12:\"te_alignment\";s:4:\"left\";s:8:\"te_title\";s:16:\"Location details\";s:11:\"te_subtitle\";s:73:\"Collaboratively plagiarize dynamic infrastructures and premium solutions.\";s:14:\"te_color_theme\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:3:\"20%\";s:6:\"bottom\";s:3:\"8px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"title_bmargin\";a:8:{s:2:\"lg\";s:2:\"20\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:17:\"parent_hover_anim\";s:0:\"\";s:15:\"parent_hover_id\";s:0:\"\";s:13:\"te_tt_heading\";s:1:\"3\";s:19:\"cc_font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:9:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"22px\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:7:\"#0a0a0a\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:13:\"title_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:10:\"te_stt_tag\";s:1:\"p\";s:13:\"subtitle_typo\";a:9:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"13px\";s:11:\"line-height\";s:4:\"26px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:9:\"te_symbol\";s:0:\"\";s:15:\"te_symbol_color\";s:7:\"default\";s:22:\"te_symbol_custom_color\";s:7:\"#cd2122\";s:14:\"te_symbol_icon\";a:2:{s:6:\"family\";s:0:\"\";s:7:\"unicode\";s:0:\"\";}s:9:\"icon_size\";s:2:\"28\";s:13:\"te_symbol_pos\";s:11:\"after-title\";s:7:\"te_text\";s:79:\"793 Scenic Way\r\nMattoon, IL 61938\r\n217-661-4539\r\n\r\nOpen 8am – 10pm every day\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:21:\"obj_parallax_distance\";s:3:\"100\";s:18:\"obj_parallax_speed\";s:3:\"800\";s:19:\"obj_parallax_easing\";s:14:\"Power1.easeOut\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluide3b0a67d\";}i:1;a:7:{s:6:\"object\";s:11:\"ZnGoogleMap\";s:7:\"options\";a:32:{s:13:\"sc_map_apikey\";s:39:\"AIzaSyCJdbTGJaMvYTT0uyJj2UxZOOAhoDv0G3s\";s:20:\"single_multiple_maps\";a:1:{i:0;a:6:{s:15:\"sc_map_latitude\";s:9:\"41.447390\";s:16:\"sc_map_longitude\";s:10:\"-72.843868\";s:7:\"tooltip\";s:0:\"\";s:11:\"sc_map_icon\";s:0:\"\";s:21:\"sc_map_icon_animation\";s:0:\"\";s:9:\"icon_size\";s:2:\"20\";}}s:11:\"sc_map_zoom\";s:2:\"14\";s:11:\"sc_map_type\";s:7:\"ROADMAP\";s:17:\"sc_map_directions\";s:3:\"yes\";s:22:\"sc_map_directions_text\";s:16:\"Visit us from...\";s:21:\"sc_map_directions_pos\";s:8:\"top-left\";s:13:\"show_overview\";s:14:\"zn_dummy_value\";s:15:\"show_streetview\";s:14:\"zn_dummy_value\";s:12:\"show_maptype\";s:14:\"zn_dummy_value\";s:15:\"ww_mapinfo_type\";s:7:\"infobox\";s:17:\"ww_slide_m_button\";s:0:\"\";s:15:\"ww_slide_l_text\";s:0:\"\";s:13:\"ww_slide_link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"sc_map_panel_img\";s:0:\"\";s:18:\"sc_map_panel_title\";s:0:\"\";s:17:\"sc_map_panel_text\";s:0:\"\";s:15:\"ww_header_style\";s:1:\"0\";s:16:\"hm_header_bmasks\";s:4:\"none\";s:19:\"hm_header_bmasks_bg\";s:0:\"\";s:13:\"sc_fullscreen\";s:2:\"no\";s:13:\"sc_map_height\";s:3:\"265\";s:16:\"use_custom_style\";s:14:\"zn_dummy_value\";s:12:\"custom_style\";s:0:\"\";s:19:\"custom_style_active\";s:0:\"\";s:10:\"sc_ccenter\";s:14:\"zn_dummy_value\";s:14:\"sc_cc_latitude\";s:0:\"\";s:15:\"sc_cc_longitude\";s:0:\"\";s:25:\"sc_map_zooming_mousewheel\";s:14:\"zn_dummy_value\";s:19:\"sc_map_localization\";s:0:\"\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidffb3ca0a\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidadd68565\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid0fb166e2\";}}'),
 (38, 140, 'show_header', ''),
 (39, 140, 'show_footer', ''),
 (40, 140, 'zn_page_custom_css', ''),
 (41, 140, 'zn_page_custom_js', ''),
 (42, 141, '_wp_page_template', 'default'),
 (43, 141, 'slide_template', 'default'),
 (44, 141, 'zn-custom-layout', '0'),
 (45, 142, 'zn_page_builder_status', 'enabled'),
 (46, 142, '_zn_zion_builder_status', 'enabled'),
 (47, 142, 'slide_template', 'default'),
 (48, 142, 'zn_page_builder_els', 'a:1:{i:0;a:6:{s:6:\"object\";s:9:\"ZnSection\";s:7:\"options\";a:66:{s:4:\"size\";s:9:\"container\";s:12:\"custom_width\";s:4:\"1170\";s:20:\"custom_width_percent\";s:3:\"100\";s:10:\"sec_height\";s:4:\"auto\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:6:\"valign\";s:3:\"top\";s:11:\"gutter_size\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"xs\";s:12:\"cc_margin_lg\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_md\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_sm\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_xs\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:5:\"180px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"35px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:3:\"0px\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:4:\"20px\";}s:16:\"background_color\";s:7:\"#f7f7f7\";s:11:\"source_type\";s:0:\"\";s:16:\"background_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:15:\"enable_parallax\";s:2:\"no\";s:9:\"skewed_bg\";s:2:\"no\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:14:\"source_overlay\";s:1:\"0\";s:20:\"source_overlay_color\";s:7:\"#353535\";s:22:\"source_overlay_opacity\";s:2:\"30\";s:29:\"source_overlay_color_gradient\";s:7:\"#353535\";s:34:\"source_overlay_color_gradient_opac\";s:2:\"30\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:14:\"section_scheme\";s:0:\"\";s:16:\"section_topmasks\";s:4:\"none\";s:11:\"topmasks_bg\";s:0:\"\";s:17:\"top_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:18:\"top_mask_bg_height\";s:3:\"100\";s:16:\"hm_header_bmasks\";s:4:\"none\";s:20:\"bottom_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:21:\"bottom_mask_bg_height\";s:3:\"100\";s:19:\"hm_header_bmasks_bg\";s:0:\"\";s:16:\"enable_ov_hidden\";s:14:\"zn_dummy_value\";s:15:\"dsb_sidemargins\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:6:\"zIndex\";s:0:\"\";s:18:\"enable_inlinemodal\";s:14:\"zn_dummy_value\";s:11:\"window_size\";s:4:\"1200\";s:16:\"window_autopopup\";s:0:\"\";s:15:\"autopopup_delay\";s:1:\"5\";s:16:\"autopopup_cookie\";s:2:\"no\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:7:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:3:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:10:\"Newsletter\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"18px\";s:11:\"line-height\";s:4:\"28px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"20px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid8e592833\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:34:\"LATEST NEWS STRAIGHT TO YOUR INBOX\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:0:\"\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"35px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluide46ee1e9\";}i:2;a:7:{s:6:\"object\";s:16:\"TH_NewsletterBox\";s:7:\"options\";a:18:{s:7:\"nb_mlid\";s:10:\"acc4aa1f3d\";s:8:\"nb_style\";s:6:\"normal\";s:9:\"nb_layout\";s:8:\"separate\";s:8:\"nb_em_pl\";s:0:\"\";s:13:\"nb_btn_height\";s:2:\"40\";s:14:\"button_corners\";s:12:\"btn--rounded\";s:11:\"nb_btn_type\";s:4:\"icon\";s:12:\"nb_btn_color\";s:7:\"#0c0c0c\";s:16:\"nb_btn_color_hov\";s:7:\"#ff5969\";s:8:\"nb_sb_pl\";s:2:\"->\";s:7:\"nb_icon\";a:2:{s:6:\"family\";s:27:\"glyphicons_halflingsregular\";s:7:\"unicode\";s:5:\"ue092\";}s:12:\"nb_font_size\";s:2:\"19\";s:12:\"nb_btn_width\";s:2:\"45\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid6961cf39\";}}s:5:\"width\";s:8:\"col-md-3\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid711256b0\";}i:1;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:11:\"Information\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"18px\";s:11:\"line-height\";s:4:\"28px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"20px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid3c91c51c\";}i:1;a:7:{s:6:\"object\";s:13:\"TH_CustomMenu\";s:7:\"options\";a:16:{s:7:\"cm_menu\";s:3:\"517\";s:8:\"cm_depth\";s:1:\"1\";s:8:\"cm_style\";s:6:\"normal\";s:15:\"toggle_submenus\";s:2:\"no\";s:7:\"cm_cols\";s:1:\"1\";s:10:\"cm_dd_text\";s:0:\"\";s:12:\"el_alignment\";s:4:\"left\";s:8:\"cm_ucase\";s:14:\"zn_dummy_value\";s:13:\"cm_fontstyles\";a:6:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"12px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:7:\"#666666\";s:10:\"font-style\";s:0:\"\";}s:14:\"cm_font_active\";s:0:\"\";s:14:\"element_scheme\";s:0:\"\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid38162841\";}}s:5:\"width\";s:8:\"col-md-2\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidb155be8e\";}i:2;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:10:\"My Account\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"18px\";s:11:\"line-height\";s:4:\"28px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"20px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid836191fa\";}i:1;a:7:{s:6:\"object\";s:13:\"TH_CustomMenu\";s:7:\"options\";a:16:{s:7:\"cm_menu\";s:3:\"518\";s:8:\"cm_depth\";s:1:\"1\";s:8:\"cm_style\";s:6:\"normal\";s:15:\"toggle_submenus\";s:2:\"no\";s:7:\"cm_cols\";s:1:\"1\";s:10:\"cm_dd_text\";s:0:\"\";s:12:\"el_alignment\";s:4:\"left\";s:8:\"cm_ucase\";s:14:\"zn_dummy_value\";s:13:\"cm_fontstyles\";a:6:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"12px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:7:\"#666666\";s:10:\"font-style\";s:0:\"\";}s:14:\"cm_font_active\";s:0:\"\";s:14:\"element_scheme\";s:0:\"\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidc720e6b6\";}}s:5:\"width\";s:8:\"col-md-2\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidae2a67bc\";}i:3;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:9:\"Follow Us\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"18px\";s:11:\"line-height\";s:4:\"28px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"20px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidb053a67e\";}i:1;a:7:{s:6:\"object\";s:13:\"TH_CustomMenu\";s:7:\"options\";a:16:{s:7:\"cm_menu\";s:3:\"519\";s:8:\"cm_depth\";s:1:\"1\";s:8:\"cm_style\";s:6:\"normal\";s:15:\"toggle_submenus\";s:2:\"no\";s:7:\"cm_cols\";s:1:\"1\";s:10:\"cm_dd_text\";s:0:\"\";s:12:\"el_alignment\";s:4:\"left\";s:8:\"cm_ucase\";s:14:\"zn_dummy_value\";s:13:\"cm_fontstyles\";a:6:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"12px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:7:\"#666666\";s:10:\"font-style\";s:0:\"\";}s:14:\"cm_font_active\";s:0:\"\";s:14:\"element_scheme\";s:0:\"\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid1e51e849\";}}s:5:\"width\";s:8:\"col-md-2\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid5e07c9b8\";}i:4;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:5:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:7:\"Contact\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"18px\";s:11:\"line-height\";s:4:\"28px\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"20px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid5d843f62\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:38:\"4676 Devonshire Driveravenna, Oh 44266\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:0:\"\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid896a3bb2\";}i:2;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:12:\"CALL US NOW:\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:0:\"\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"5px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluida3367f85\";}i:3;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:15:\"0 1800 800 1234\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:4:\"30px\";s:11:\"line-height\";s:4:\"40px\";s:11:\"font-weight\";s:3:\"300\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:0:\"\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid1bd2740c\";}i:4;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:27:\"Email: hello@youremail.com \";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:0:\"\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"5px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid603c04f7\";}}s:5:\"width\";s:8:\"col-md-3\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid503d0a6f\";}i:5;a:7:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:0:\"\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:3:\"top\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:1:\"0\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:4:\"none\";s:12:\"border_width\";s:1:\"0\";s:12:\"border_color\";s:0:\"\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid5b3cca9c\";}i:6;a:7:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:0:\"\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:3:\"top\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:4:\"80px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:5:\"120px\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:4:\"none\";s:12:\"border_width\";s:1:\"0\";s:12:\"border_color\";s:0:\"\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:11:\"TH_ImageBox\";s:7:\"options\";a:34:{s:15:\"image_box_image\";s:69:\"https://modelox.vico.digital/wp-content/uploads/2017/09/copyright.png\";s:16:\"image_box_imgfit\";s:2:\"no\";s:16:\"image_box_height\";s:3:\"280\";s:19:\"image_box_link_text\";s:0:\"\";s:14:\"image_box_link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:15:\"image_box_title\";s:0:\"\";s:14:\"image_box_text\";s:0:\"\";s:15:\"image_box_style\";s:6:\"simple\";s:9:\"alignment\";s:6:\"center\";s:21:\"image_box_title_style\";s:18:\"title_style_center\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";}s:9:\"desc_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";}s:13:\"corner_radius\";s:1:\"0\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"30px\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"img_sizes\";a:2:{s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid1f1dc975\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid21aac694\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid94183cae\";}}'),
 (49, 142, 'show_header', ''),
 (50, 142, 'show_footer', ''),
 (51, 142, 'zn_page_custom_css', ''),
 (52, 142, 'zn_page_custom_js', ''),
 (53, 143, '_thumbnail_id', '23'),
 (54, 143, '_thumbnail_id', '79'),
 (55, 143, '_wc_review_count', '0'),
 (56, 143, '_wc_rating_count', 'a:0:{}'),
 (57, 143, '_wc_average_rating', '0'),
 (58, 143, '_sku', ''),
 (59, 143, '_regular_price', '16'),
 (60, 143, '_sale_price', ''),
 (61, 143, '_sale_price_dates_from', ''),
 (62, 143, '_sale_price_dates_to', ''),
 (63, 143, 'total_sales', '0'),
 (64, 143, '_tax_status', 'taxable'),
 (65, 143, '_tax_class', ''),
 (66, 143, '_manage_stock', 'no'),
 (67, 143, '_backorders', 'no'),
 (68, 143, '_sold_individually', 'no'),
 (69, 143, '_weight', ''),
 (70, 143, '_length', ''),
 (71, 143, '_width', ''),
 (72, 143, '_height', ''),
 (73, 143, '_upsell_ids', 'a:0:{}'),
 (74, 143, '_crosssell_ids', 'a:0:{}'),
 (75, 143, '_purchase_note', ''),
 (76, 143, '_default_attributes', 'a:0:{}'),
 (77, 143, '_virtual', 'no'),
 (78, 143, '_downloadable', 'no'),
 (79, 143, '_product_image_gallery', ''),
 (80, 143, '_download_limit', '-1'),
 (81, 143, '_download_expiry', '-1'),
 (82, 143, '_stock', 'a:1:{i:0;s:0:\"\";}'),
 (83, 143, '_stock_status', 'instock'),
 (84, 143, '_product_version', '3.1.1'),
 (85, 143, '_price', '16'),
 (86, 143, 'slide_template', 'default'),
 (87, 143, 'zn_page_layout', 'default'),
 (88, 143, 'zn_sidebar_select', 'default'),
 (89, 143, 'zn_zn_disable_subheader', ''),
 (90, 143, 'zn_subheader_style', 'zn_def_header_style'),
 (91, 143, 'zn_page_override_boxed_layout', 'def'),
 (92, 143, 'zn_page_title_show', 'yes'),
 (93, 143, 'zn_page_title', ''),
 (94, 143, 'zn_page_subtitle', ''),
 (95, 143, 'zn-custom-layout', '0'),
 (96, 144, '_thumbnail_id', '23'),
 (97, 144, '_thumbnail_id', '78'),
 (98, 144, '_wc_review_count', '0'),
 (99, 144, '_wc_rating_count', 'a:0:{}'),
 (100, 144, '_wc_average_rating', '0'),
 (101, 144, '_sku', ''),
 (102, 144, '_regular_price', '16'),
 (103, 144, '_sale_price', ''),
 (104, 144, '_sale_price_dates_from', ''),
 (105, 144, '_sale_price_dates_to', ''),
 (106, 144, 'total_sales', '0'),
 (107, 144, '_tax_status', 'taxable'),
 (108, 144, '_tax_class', ''),
 (109, 144, '_manage_stock', 'no'),
 (110, 144, '_backorders', 'no'),
 (111, 144, '_sold_individually', 'no'),
 (112, 144, '_weight', ''),
 (113, 144, '_length', ''),
 (114, 144, '_width', ''),
 (115, 144, '_height', ''),
 (116, 144, '_upsell_ids', 'a:0:{}'),
 (117, 144, '_crosssell_ids', 'a:0:{}'),
 (118, 144, '_purchase_note', ''),
 (119, 144, '_default_attributes', 'a:0:{}'),
 (120, 144, '_virtual', 'no'),
 (121, 144, '_downloadable', 'no'),
 (122, 144, '_product_image_gallery', ''),
 (123, 144, '_download_limit', '-1'),
 (124, 144, '_download_expiry', '-1'),
 (125, 144, '_stock', 'a:1:{i:0;s:0:\"\";}'),
 (126, 144, '_stock_status', 'instock'),
 (127, 144, '_product_version', '3.1.1'),
 (128, 144, '_price', '16'),
 (129, 144, 'slide_template', 'default'),
 (130, 144, 'zn_page_layout', 'default'),
 (131, 144, 'zn_sidebar_select', 'default'),
 (132, 144, 'zn_zn_disable_subheader', ''),
 (133, 144, 'zn_subheader_style', 'zn_def_header_style'),
 (134, 144, 'zn_page_override_boxed_layout', 'def'),
 (135, 144, 'zn_page_title_show', 'yes'),
 (136, 144, 'zn_page_title', ''),
 (137, 144, 'zn_page_subtitle', ''),
 (138, 144, 'zn-custom-layout', '0'),
 (139, 145, '_thumbnail_id', '23'),
 (140, 145, '_thumbnail_id', '85'),
 (141, 145, '_wc_review_count', '0'),
 (142, 145, '_wc_rating_count', 'a:0:{}'),
 (143, 145, '_wc_average_rating', '0'),
 (144, 145, '_sku', ''),
 (145, 145, '_regular_price', '16'),
 (146, 145, '_sale_price', ''),
 (147, 145, '_sale_price_dates_from', ''),
 (148, 145, '_sale_price_dates_to', ''),
 (149, 145, 'total_sales', '0'),
 (150, 145, '_tax_status', 'taxable'),
 (151, 145, '_tax_class', ''),
 (152, 145, '_manage_stock', 'no'),
 (153, 145, '_backorders', 'no'),
 (154, 145, '_sold_individually', 'no'),
 (155, 145, '_weight', ''),
 (156, 145, '_length', ''),
 (157, 145, '_width', ''),
 (158, 145, '_height', ''),
 (159, 145, '_upsell_ids', 'a:0:{}'),
 (160, 145, '_crosssell_ids', 'a:0:{}'),
 (161, 145, '_purchase_note', ''),
 (162, 145, '_default_attributes', 'a:0:{}'),
 (163, 145, '_virtual', 'no'),
 (164, 145, '_downloadable', 'no'),
 (165, 145, '_product_image_gallery', ''),
 (166, 145, '_download_limit', '-1'),
 (167, 145, '_download_expiry', '-1'),
 (168, 145, '_stock', 'a:1:{i:0;s:0:\"\";}'),
 (169, 145, '_stock_status', 'instock'),
 (170, 145, '_product_version', '3.1.1'),
 (171, 145, '_price', '16'),
 (172, 145, 'slide_template', 'default'),
 (173, 145, 'zn_page_layout', 'default'),
 (174, 145, 'zn_sidebar_select', 'default'),
 (175, 145, 'zn_zn_disable_subheader', ''),
 (176, 145, 'zn_subheader_style', 'zn_def_header_style'),
 (177, 145, 'zn_page_override_boxed_layout', 'def'),
 (178, 145, 'zn_page_title_show', 'yes'),
 (179, 145, 'zn_page_title', ''),
 (180, 145, 'zn_page_subtitle', ''),
 (181, 145, 'zn-custom-layout', '0'),
 (182, 146, '_thumbnail_id', '23'),
 (183, 146, '_thumbnail_id', '76'),
 (184, 146, '_wc_review_count', '0'),
 (185, 146, '_wc_rating_count', 'a:0:{}'),
 (186, 146, '_wc_average_rating', '0'),
 (187, 146, '_sku', ''),
 (188, 146, '_regular_price', '16'),
 (189, 146, '_sale_price', ''),
 (190, 146, '_sale_price_dates_from', ''),
 (191, 146, '_sale_price_dates_to', ''),
 (192, 146, 'total_sales', '0'),
 (193, 146, '_tax_status', 'taxable'),
 (194, 146, '_tax_class', ''),
 (195, 146, '_manage_stock', 'no'),
 (196, 146, '_backorders', 'no'),
 (197, 146, '_sold_individually', 'no'),
 (198, 146, '_weight', ''),
 (199, 146, '_length', ''),
 (200, 146, '_width', ''),
 (201, 146, '_height', ''),
 (202, 146, '_upsell_ids', 'a:0:{}'),
 (203, 146, '_crosssell_ids', 'a:0:{}'),
 (204, 146, '_purchase_note', ''),
 (205, 146, '_default_attributes', 'a:0:{}'),
 (206, 146, '_virtual', 'no'),
 (207, 146, '_downloadable', 'no'),
 (208, 146, '_product_image_gallery', ''),
 (209, 146, '_download_limit', '-1'),
 (210, 146, '_download_expiry', '-1'),
 (211, 146, '_stock', 'a:1:{i:0;s:0:\"\";}'),
 (212, 146, '_stock_status', 'instock'),
 (213, 146, '_product_version', '3.1.1'),
 (214, 146, '_price', '16'),
 (215, 146, 'slide_template', 'default'),
 (216, 146, 'zn_page_layout', 'default'),
 (217, 146, 'zn_sidebar_select', 'default'),
 (218, 146, 'zn_zn_disable_subheader', ''),
 (219, 146, 'zn_subheader_style', 'zn_def_header_style'),
 (220, 146, 'zn_page_override_boxed_layout', 'def'),
 (221, 146, 'zn_page_title_show', 'yes'),
 (222, 146, 'zn_page_title', ''),
 (223, 146, 'zn_page_subtitle', ''),
 (224, 146, 'zn-custom-layout', '0'),
 (225, 146, '_yith_wcbm_product_meta', 'a:1:{s:8:\"id_badge\";s:2:\"92\";}'),
 (226, 147, '_thumbnail_id', '23'),
 (227, 147, '_thumbnail_id', '75'),
 (228, 147, '_wc_review_count', '0'),
 (229, 147, '_wc_rating_count', 'a:0:{}'),
 (230, 147, '_wc_average_rating', '0'),
 (231, 147, '_sku', ''),
 (232, 147, '_regular_price', '16'),
 (233, 147, '_sale_price', '12'),
 (234, 147, '_sale_price_dates_from', ''),
 (235, 147, '_sale_price_dates_to', ''),
 (236, 147, 'total_sales', '0'),
 (237, 147, '_tax_status', 'taxable'),
 (238, 147, '_tax_class', ''),
 (239, 147, '_manage_stock', 'no'),
 (240, 147, '_backorders', 'no'),
 (241, 147, '_sold_individually', 'no'),
 (242, 147, '_weight', ''),
 (243, 147, '_length', ''),
 (244, 147, '_width', ''),
 (245, 147, '_height', ''),
 (246, 147, '_upsell_ids', 'a:0:{}'),
 (247, 147, '_crosssell_ids', 'a:0:{}'),
 (248, 147, '_purchase_note', ''),
 (249, 147, '_default_attributes', 'a:0:{}'),
 (250, 147, '_virtual', 'no'),
 (251, 147, '_downloadable', 'no'),
 (252, 147, '_product_image_gallery', ''),
 (253, 147, '_download_limit', '-1'),
 (254, 147, '_download_expiry', '-1'),
 (255, 147, '_stock', 'a:1:{i:0;s:0:\"\";}'),
 (256, 147, '_stock_status', 'instock'),
 (257, 147, '_product_version', '3.1.1'),
 (258, 147, '_price', '12'),
 (259, 147, 'slide_template', 'default'),
 (260, 147, 'zn_page_layout', 'default'),
 (261, 147, 'zn_sidebar_select', 'default'),
 (262, 147, 'zn_zn_disable_subheader', ''),
 (263, 147, 'zn_subheader_style', 'zn_def_header_style'),
 (264, 147, 'zn_page_override_boxed_layout', 'def'),
 (265, 147, 'zn_page_title_show', 'yes'),
 (266, 147, 'zn_page_title', ''),
 (267, 147, 'zn_page_subtitle', ''),
 (268, 147, 'zn-custom-layout', '0'),
 (269, 147, '_yith_wcbm_product_meta', 'a:1:{s:8:\"id_badge\";s:2:\"92\";}'),
 (270, 148, '_thumbnail_id', '23'),
 (271, 148, '_thumbnail_id', '74'),
 (272, 148, '_wc_review_count', '0'),
 (273, 148, '_wc_rating_count', 'a:0:{}'),
 (274, 148, '_wc_average_rating', '0'),
 (275, 148, '_sku', ''),
 (276, 148, '_regular_price', '16'),
 (277, 148, '_sale_price', ''),
 (278, 148, '_sale_price_dates_from', ''),
 (279, 148, '_sale_price_dates_to', ''),
 (280, 148, 'total_sales', '0'),
 (281, 148, '_tax_status', 'taxable'),
 (282, 148, '_tax_class', ''),
 (283, 148, '_manage_stock', 'no'),
 (284, 148, '_backorders', 'no'),
 (285, 148, '_sold_individually', 'no'),
 (286, 148, '_weight', ''),
 (287, 148, '_length', ''),
 (288, 148, '_width', ''),
 (289, 148, '_height', ''),
 (290, 148, '_upsell_ids', 'a:0:{}'),
 (291, 148, '_crosssell_ids', 'a:0:{}'),
 (292, 148, '_purchase_note', ''),
 (293, 148, '_default_attributes', 'a:0:{}'),
 (294, 148, '_virtual', 'no'),
 (295, 148, '_downloadable', 'no'),
 (296, 148, '_product_image_gallery', ''),
 (297, 148, '_download_limit', '-1'),
 (298, 148, '_download_expiry', '-1'),
 (299, 148, '_stock', 'a:1:{i:0;s:0:\"\";}'),
 (300, 148, '_stock_status', 'instock'),
 (301, 148, '_product_version', '3.1.1'),
 (302, 148, '_price', '16'),
 (303, 148, 'slide_template', 'default'),
 (304, 148, 'zn_page_layout', 'default'),
 (305, 148, 'zn_sidebar_select', 'default'),
 (306, 148, 'zn_zn_disable_subheader', ''),
 (307, 148, 'zn_subheader_style', 'zn_def_header_style'),
 (308, 148, 'zn_page_override_boxed_layout', 'def'),
 (309, 148, 'zn_page_title_show', 'yes'),
 (310, 148, 'zn_page_title', ''),
 (311, 148, 'zn_page_subtitle', ''),
 (312, 148, 'zn-custom-layout', '0'),
 (313, 149, 'zn_page_builder_status', 'enabled'),
 (314, 149, '_zn_zion_builder_status', 'enabled'),
 (315, 149, 'zn-custom-layout', '0'),
 (316, 149, 'zn_page_layout', 'default'),
 (317, 149, 'zn_sidebar_select', 'default'),
 (318, 149, 'zn_zn_disable_subheader', ''),
 (319, 149, 'zn_subheader_style', 'zn_def_header_style'),
 (320, 149, 'zn_page_override_boxed_layout', 'def'),
 (321, 149, 'zn_page_title_show', 'yes'),
 (322, 149, 'zn_page_title', ''),
 (323, 149, 'zn_page_subtitle', ''),
 (324, 149, 'zn_page_builder_els', 'a:6:{i:0;a:7:{s:6:\"object\";s:19:\"TH_RevolutionSlider\";s:7:\"options\";a:9:{s:15:\"ww_header_style\";s:1:\"0\";s:12:\"revslider_id\";s:7:\"florist\";s:16:\"hm_header_bmasks\";s:4:\"none\";s:19:\"hm_header_bmasks_bg\";s:0:\"\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidbfb51f09\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnSection\";s:7:\"options\";a:66:{s:4:\"size\";s:9:\"container\";s:12:\"custom_width\";s:4:\"1170\";s:20:\"custom_width_percent\";s:3:\"100\";s:10:\"sec_height\";s:13:\"custom_height\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"380\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:6:\"valign\";s:3:\"top\";s:11:\"gutter_size\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"xs\";s:12:\"cc_margin_lg\";a:2:{s:3:\"top\";s:3:\"0px\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_md\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_sm\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_xs\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:4:\"35px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"35px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:5:\"140px\";s:4:\"left\";s:0:\"\";}s:16:\"background_color\";s:7:\"#ffffff\";s:11:\"source_type\";s:0:\"\";s:16:\"background_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:15:\"enable_parallax\";s:2:\"no\";s:9:\"skewed_bg\";s:2:\"no\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:14:\"source_overlay\";s:1:\"0\";s:20:\"source_overlay_color\";s:7:\"#353535\";s:22:\"source_overlay_opacity\";s:2:\"30\";s:29:\"source_overlay_color_gradient\";s:7:\"#353535\";s:34:\"source_overlay_color_gradient_opac\";s:2:\"30\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:14:\"section_scheme\";s:0:\"\";s:16:\"section_topmasks\";s:4:\"none\";s:11:\"topmasks_bg\";s:0:\"\";s:17:\"top_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:18:\"top_mask_bg_height\";s:3:\"100\";s:16:\"hm_header_bmasks\";s:21:\"mask7 mask7big mask7r\";s:20:\"bottom_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:21:\"bottom_mask_bg_height\";s:3:\"100\";s:19:\"hm_header_bmasks_bg\";s:7:\"#f3f3f3\";s:16:\"enable_ov_hidden\";s:14:\"zn_dummy_value\";s:15:\"dsb_sidemargins\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:6:\"zIndex\";s:0:\"\";s:18:\"enable_inlinemodal\";s:14:\"zn_dummy_value\";s:11:\"window_size\";s:4:\"1200\";s:16:\"window_autopopup\";s:0:\"\";s:15:\"autopopup_delay\";s:1:\"5\";s:16:\"autopopup_cookie\";s:2:\"no\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:3:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:17:\"TH_MediaContainer\";s:7:\"options\";a:55:{s:12:\"mc_link_type\";s:2:\"pb\";s:13:\"mc_link_style\";s:5:\"lined\";s:11:\"mc_btn_text\";s:0:\"\";s:12:\"mc_btn_color\";s:0:\"\";s:18:\"mc_btn_color_hover\";s:0:\"\";s:20:\"mc_borderanim2_width\";s:3:\"400\";s:14:\"mc_link_target\";s:4:\"self\";s:11:\"mc_btn_link\";s:0:\"\";s:15:\"mc_btn_modalimg\";s:0:\"\";s:12:\"mc_pb_vertal\";s:6:\"center\";s:10:\"mc_pb_link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:9:\"mc_height\";a:9:{s:11:\"breakpoints\";s:1:\"1\";s:2:\"lg\";s:3:\"264\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:22:\"cc_spacing_breakpoints\";s:2:\"xs\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:5:\"-70px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"30px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:4:\"10px\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:4:\"10px\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:11:\"source_type\";s:5:\"image\";s:16:\"background_image\";a:5:{s:5:\"image\";s:79:\"https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:15:\"enable_parallax\";s:14:\"zn_dummy_value\";s:14:\"source_overlay\";s:1:\"0\";s:23:\"source_overlay_color_v2\";s:19:\"rgba(53,53,53,0.65)\";s:32:\"source_overlay_color_gradient_v2\";s:19:\"rgba(53,53,53,0.65)\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:23:\"overlay_hover_animation\";s:4:\"none\";s:21:\"overlay_hover_opacity\";s:1:\"0\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:1:\"6\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:1:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:21:\"WEDDING<br>\r\nBOUQUETS\";s:3:\"tag\";s:2:\"h3\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:4:\"32px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:6:\"center\";}s:5:\"color\";s:0:\"\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluida03d7102\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid227cacd4\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidbc7dd12d\";}}s:5:\"width\";s:8:\"col-md-4\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid8879bc87\";}i:1;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:17:\"TH_MediaContainer\";s:7:\"options\";a:55:{s:12:\"mc_link_type\";s:2:\"pb\";s:13:\"mc_link_style\";s:5:\"lined\";s:11:\"mc_btn_text\";s:0:\"\";s:12:\"mc_btn_color\";s:0:\"\";s:18:\"mc_btn_color_hover\";s:0:\"\";s:20:\"mc_borderanim2_width\";s:3:\"400\";s:14:\"mc_link_target\";s:4:\"self\";s:11:\"mc_btn_link\";s:0:\"\";s:15:\"mc_btn_modalimg\";s:0:\"\";s:12:\"mc_pb_vertal\";s:6:\"center\";s:10:\"mc_pb_link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:9:\"mc_height\";a:9:{s:11:\"breakpoints\";s:1:\"1\";s:2:\"lg\";s:3:\"264\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:22:\"cc_spacing_breakpoints\";s:2:\"xs\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:5:\"-70px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"30px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:11:\"source_type\";s:5:\"image\";s:16:\"background_image\";a:5:{s:5:\"image\";s:79:\"https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:15:\"enable_parallax\";s:14:\"zn_dummy_value\";s:14:\"source_overlay\";s:1:\"0\";s:23:\"source_overlay_color_v2\";s:19:\"rgba(53,53,53,0.65)\";s:32:\"source_overlay_color_gradient_v2\";s:19:\"rgba(53,53,53,0.65)\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:23:\"overlay_hover_animation\";s:4:\"none\";s:21:\"overlay_hover_opacity\";s:1:\"0\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:1:\"6\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:1:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:19:\"LOVE &<br>\r\nROMANCE\";s:3:\"tag\";s:2:\"h3\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:4:\"32px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:6:\"center\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:6:\"center\";}s:5:\"color\";s:7:\"#ffffff\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid135ab0aa\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidbe60f7ac\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid83b9c28b\";}}s:5:\"width\";s:8:\"col-md-4\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidad1de759\";}i:2;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:17:\"TH_MediaContainer\";s:7:\"options\";a:55:{s:12:\"mc_link_type\";s:2:\"pb\";s:13:\"mc_link_style\";s:5:\"lined\";s:11:\"mc_btn_text\";s:0:\"\";s:12:\"mc_btn_color\";s:0:\"\";s:18:\"mc_btn_color_hover\";s:0:\"\";s:20:\"mc_borderanim2_width\";s:3:\"400\";s:14:\"mc_link_target\";s:4:\"self\";s:11:\"mc_btn_link\";s:0:\"\";s:15:\"mc_btn_modalimg\";s:0:\"\";s:12:\"mc_pb_vertal\";s:6:\"center\";s:10:\"mc_pb_link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:9:\"mc_height\";a:9:{s:11:\"breakpoints\";s:1:\"1\";s:2:\"lg\";s:3:\"264\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:22:\"cc_spacing_breakpoints\";s:2:\"xs\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:5:\"-70px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:1:\"0\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:11:\"source_type\";s:5:\"image\";s:16:\"background_image\";a:5:{s:5:\"image\";s:79:\"https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:15:\"enable_parallax\";s:14:\"zn_dummy_value\";s:14:\"source_overlay\";s:1:\"0\";s:23:\"source_overlay_color_v2\";s:19:\"rgba(53,53,53,0.65)\";s:32:\"source_overlay_color_gradient_v2\";s:19:\"rgba(53,53,53,0.65)\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:23:\"overlay_hover_animation\";s:4:\"none\";s:21:\"overlay_hover_opacity\";s:1:\"0\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:1:\"6\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:1:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:22:\"birthday<br>\r\nbouquets\";s:3:\"tag\";s:2:\"h3\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:4:\"32px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:6:\"center\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:6:\"center\";}s:5:\"color\";s:7:\"#ffffff\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid9de8ea40\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid4b2afd07\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidd8f44e29\";}}s:5:\"width\";s:8:\"col-md-4\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidddd07f47\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";s:0:\"\";s:3:\"uid\";s:13:\"eluid90deda18\";}i:2;a:7:{s:6:\"object\";s:9:\"ZnSection\";s:7:\"options\";a:66:{s:4:\"size\";s:9:\"container\";s:12:\"custom_width\";s:4:\"1170\";s:20:\"custom_width_percent\";s:3:\"100\";s:10:\"sec_height\";s:4:\"auto\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:6:\"valign\";s:3:\"top\";s:11:\"gutter_size\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"xs\";s:12:\"cc_margin_lg\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_md\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_sm\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_xs\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:4:\"35px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:5:\"200px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:4:\"80px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:16:\"background_color\";s:7:\"#f3f3f3\";s:11:\"source_type\";s:0:\"\";s:16:\"background_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:15:\"enable_parallax\";s:2:\"no\";s:9:\"skewed_bg\";s:2:\"no\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:14:\"source_overlay\";s:1:\"0\";s:20:\"source_overlay_color\";s:7:\"#353535\";s:22:\"source_overlay_opacity\";s:2:\"30\";s:29:\"source_overlay_color_gradient\";s:7:\"#353535\";s:34:\"source_overlay_color_gradient_opac\";s:2:\"30\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:14:\"section_scheme\";s:0:\"\";s:16:\"section_topmasks\";s:4:\"none\";s:11:\"topmasks_bg\";s:7:\"#f3f3f3\";s:17:\"top_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:18:\"top_mask_bg_height\";s:3:\"100\";s:16:\"hm_header_bmasks\";s:12:\"mask7 mask7l\";s:20:\"bottom_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:21:\"bottom_mask_bg_height\";s:3:\"100\";s:19:\"hm_header_bmasks_bg\";s:7:\"#ffffff\";s:16:\"enable_ov_hidden\";s:14:\"zn_dummy_value\";s:15:\"dsb_sidemargins\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:6:\"zIndex\";s:0:\"\";s:18:\"enable_inlinemodal\";s:14:\"zn_dummy_value\";s:11:\"window_size\";s:4:\"1200\";s:16:\"window_autopopup\";s:0:\"\";s:15:\"autopopup_delay\";s:1:\"5\";s:16:\"autopopup_cookie\";s:2:\"no\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:8:\"category\";}s:7:\"content\";a:2:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:10:\"Categories\";s:3:\"tag\";s:2:\"h2\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:5:\"Prata\";s:9:\"font-size\";s:4:\"36px\";s:11:\"line-height\";s:4:\"46px\";s:11:\"font-weight\";s:3:\"300\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:6:\"center\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"30px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidbafec2c6\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidd2106bb8\";}i:1;a:7:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:17:\"ZnCustomContainer\";s:7:\"options\";a:30:{s:6:\"layout\";s:7:\"default\";s:12:\"abox_bgcolor\";s:0:\"\";s:14:\"normal_bgcolor\";s:0:\"\";s:16:\"background_image\";a:5:{s:5:\"image\";s:79:\"https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:4:\"left\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:7:\"contain\";}s:12:\"border_style\";s:4:\"none\";s:12:\"border_width\";s:1:\"0\";s:12:\"border_color\";s:0:\"\";s:13:\"corner_radius\";s:1:\"0\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"sm\";s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:1:\"0\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:5:\"400px\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:5:\"200px\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:1:\"0\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:3:\"0px\";}s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:11:\"gutter_size\";s:8:\"gutter-0\";s:8:\"pad_type\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:6:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"185\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:6:\"center\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:7:\"#ffffff\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"-1px\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:5:{s:3:\"top\";s:4:\"50px\";s:5:\"right\";s:4:\"50px\";s:6:\"bottom\";s:4:\"50px\";s:4:\"left\";s:4:\"50px\";s:6:\"linked\";s:1:\"1\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:5:\"solid\";s:12:\"border_width\";s:1:\"1\";s:12:\"border_color\";s:7:\"#f2f2f2\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:14:\"Congratulation\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#333333\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluiddd710424\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:66:\"Lorem ipsum dolor sit amet, \r\nconsectetur adipisicing elit, sed do\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#9b9b9b\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidb9942db0\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid3883f72f\";}i:1;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"185\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:6:\"center\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:7:\"#ffffff\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"-1px\";s:4:\"left\";s:4:\"-1px\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:5:{s:3:\"top\";s:4:\"50px\";s:5:\"right\";s:4:\"50px\";s:6:\"bottom\";s:4:\"50px\";s:4:\"left\";s:4:\"50px\";s:6:\"linked\";s:1:\"1\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:5:\"solid\";s:12:\"border_width\";s:1:\"1\";s:12:\"border_color\";s:7:\"#f2f2f2\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:9:\"CORPORATE\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#333333\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidf976d487\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:66:\"Lorem ipsum dolor sit amet, \r\nconsectetur adipisicing elit, sed do\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#9b9b9b\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid51e7339e\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidec759440\";}i:2;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"185\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:6:\"center\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:7:\"#ffffff\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:5:{s:3:\"top\";s:4:\"50px\";s:5:\"right\";s:4:\"50px\";s:6:\"bottom\";s:4:\"50px\";s:4:\"left\";s:4:\"50px\";s:6:\"linked\";s:1:\"1\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:5:\"solid\";s:12:\"border_width\";s:1:\"1\";s:12:\"border_color\";s:7:\"#f2f2f2\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:8:\"SYMPATHY\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#333333\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid9ff1c79f\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:66:\"Lorem ipsum dolor sit amet, \r\nconsectetur adipisicing elit, sed do\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#9b9b9b\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid4d57b4ea\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidb677a61b\";}i:3;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"185\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:6:\"center\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:7:\"#ffffff\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:4:\"-1px\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:5:{s:3:\"top\";s:4:\"50px\";s:5:\"right\";s:4:\"50px\";s:6:\"bottom\";s:4:\"50px\";s:4:\"left\";s:4:\"50px\";s:6:\"linked\";s:1:\"1\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:5:\"solid\";s:12:\"border_width\";s:1:\"1\";s:12:\"border_color\";s:7:\"#f2f2f2\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:7:\"FUNERAL\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#333333\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidfc2f03da\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:66:\"Lorem ipsum dolor sit amet, \r\nconsectetur adipisicing elit, sed do\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#9b9b9b\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidd220bec0\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid8ce53786\";}i:4;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"185\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:6:\"center\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:7:\"#ffffff\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:4:\"-1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:5:{s:3:\"top\";s:4:\"50px\";s:5:\"right\";s:4:\"50px\";s:6:\"bottom\";s:4:\"50px\";s:4:\"left\";s:4:\"50px\";s:6:\"linked\";s:1:\"1\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:5:\"solid\";s:12:\"border_width\";s:1:\"1\";s:12:\"border_color\";s:7:\"#f2f2f2\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:14:\"LOVE & ROMANCE\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#333333\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluida13e2ffd\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:66:\"Lorem ipsum dolor sit amet, \r\nconsectetur adipisicing elit, sed do\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#9b9b9b\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidec1f2e70\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid010db3c7\";}i:5;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"lg\";s:16:\"column_offset_lg\";s:0:\"\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:0:\"\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:0:\"\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"185\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:6:\"center\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:7:\"#ffffff\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:4:\"-1px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:4:\"-1px\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:5:{s:3:\"top\";s:4:\"50px\";s:5:\"right\";s:4:\"50px\";s:6:\"bottom\";s:4:\"50px\";s:4:\"left\";s:4:\"50px\";s:6:\"linked\";s:1:\"1\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:5:\"solid\";s:12:\"border_width\";s:1:\"1\";s:12:\"border_color\";s:7:\"#f2f2f2\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:14:\"FAMILY FLOWERS\";s:3:\"tag\";s:2:\"h4\";s:4:\"link\";a:3:{s:3:\"url\";s:1:\"#\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"34px\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#333333\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidfee089a8\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:66:\"Lorem ipsum dolor sit amet, \r\nconsectetur adipisicing elit, sed do\";s:3:\"tag\";s:1:\"p\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:5:\"right\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#9b9b9b\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"0px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid4f80e003\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluid8ecc4dd9\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid6562121e\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid9fdfb459\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid9d0e1ee6\";}i:3;a:7:{s:6:\"object\";s:9:\"ZnSection\";s:7:\"options\";a:66:{s:4:\"size\";s:9:\"container\";s:12:\"custom_width\";s:4:\"1170\";s:20:\"custom_width_percent\";s:3:\"100\";s:10:\"sec_height\";s:4:\"auto\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:6:\"valign\";s:3:\"top\";s:11:\"gutter_size\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_md\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_sm\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_xs\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:5:\"120px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"35px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:16:\"background_color\";s:7:\"#ffffff\";s:11:\"source_type\";s:0:\"\";s:16:\"background_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:15:\"enable_parallax\";s:2:\"no\";s:9:\"skewed_bg\";s:2:\"no\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:14:\"source_overlay\";s:1:\"0\";s:20:\"source_overlay_color\";s:7:\"#353535\";s:22:\"source_overlay_opacity\";s:2:\"30\";s:29:\"source_overlay_color_gradient\";s:7:\"#353535\";s:34:\"source_overlay_color_gradient_opac\";s:2:\"30\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:14:\"section_scheme\";s:0:\"\";s:16:\"section_topmasks\";s:4:\"none\";s:11:\"topmasks_bg\";s:7:\"#f3f3f3\";s:17:\"top_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:18:\"top_mask_bg_height\";s:3:\"100\";s:16:\"hm_header_bmasks\";s:4:\"none\";s:20:\"bottom_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:21:\"bottom_mask_bg_height\";s:3:\"100\";s:19:\"hm_header_bmasks_bg\";s:7:\"#ffffff\";s:16:\"enable_ov_hidden\";s:14:\"zn_dummy_value\";s:15:\"dsb_sidemargins\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:6:\"zIndex\";s:0:\"\";s:18:\"enable_inlinemodal\";s:14:\"zn_dummy_value\";s:11:\"window_size\";s:4:\"1200\";s:16:\"window_autopopup\";s:0:\"\";s:15:\"autopopup_delay\";s:1:\"5\";s:16:\"autopopup_cookie\";s:2:\"no\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:1:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:3:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:8:\"Bouquets\";s:3:\"tag\";s:2:\"h2\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:5:\"Prata\";s:9:\"font-size\";s:4:\"36px\";s:11:\"line-height\";s:4:\"46px\";s:11:\"font-weight\";s:3:\"300\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:6:\"center\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"15px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid4c855af9\";}i:1;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:63:\"Veritatis et quasi architecto beatae vitae dicta sunt explicabo\";s:3:\"tag\";s:2:\"h3\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"26px\";s:11:\"line-height\";s:4:\"36px\";s:11:\"font-weight\";s:3:\"300\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:10:\"text-align\";s:6:\"center\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:0:\"\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"40px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidc81ba0d8\";}i:2;a:7:{s:6:\"object\";s:17:\"TH_ProductArchive\";s:7:\"options\";a:9:{s:11:\"num_columns\";s:1:\"3\";s:14:\"posts_per_page\";s:2:\"10\";s:14:\"woo_categories\";a:4:{i:0;s:2:\"17\";i:1;s:2:\"18\";i:2;s:2:\"19\";i:3;s:2:\"20\";}s:15:\"show_page_title\";s:3:\"yes\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid0c444ee9\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidd21e945a\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid3a55e19a\";}i:4;a:7:{s:6:\"object\";s:9:\"ZnSection\";s:7:\"options\";a:66:{s:4:\"size\";s:9:\"container\";s:12:\"custom_width\";s:4:\"1170\";s:20:\"custom_width_percent\";s:3:\"100\";s:10:\"sec_height\";s:13:\"custom_height\";s:13:\"custom_height\";a:10:{s:10:\"properties\";s:10:\"min-height\";s:11:\"breakpoints\";s:1:\"1\";s:2:\"lg\";s:2:\"90\";s:7:\"unit_lg\";s:2:\"vh\";s:2:\"md\";s:4:\"1000\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:3:\"600\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:3:\"400\";s:7:\"unit_xs\";s:2:\"px\";}s:6:\"valign\";s:6:\"middle\";s:11:\"gutter_size\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_md\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_sm\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_xs\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:4:\"35px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"35px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:16:\"background_color\";s:0:\"\";s:11:\"source_type\";s:5:\"image\";s:16:\"background_image\";a:5:{s:5:\"image\";s:79:\"https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:15:\"enable_parallax\";s:3:\"yes\";s:9:\"skewed_bg\";s:2:\"no\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:14:\"source_overlay\";s:1:\"0\";s:20:\"source_overlay_color\";s:7:\"#353535\";s:22:\"source_overlay_opacity\";s:2:\"30\";s:29:\"source_overlay_color_gradient\";s:7:\"#353535\";s:34:\"source_overlay_color_gradient_opac\";s:2:\"30\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:14:\"section_scheme\";s:0:\"\";s:16:\"section_topmasks\";s:12:\"mask7 mask7r\";s:11:\"topmasks_bg\";s:7:\"#ffffff\";s:17:\"top_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:18:\"top_mask_bg_height\";s:3:\"100\";s:16:\"hm_header_bmasks\";s:4:\"none\";s:20:\"bottom_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:21:\"bottom_mask_bg_height\";s:3:\"100\";s:19:\"hm_header_bmasks_bg\";s:0:\"\";s:16:\"enable_ov_hidden\";s:14:\"zn_dummy_value\";s:15:\"dsb_sidemargins\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:6:\"zIndex\";s:0:\"\";s:18:\"enable_inlinemodal\";s:14:\"zn_dummy_value\";s:11:\"window_size\";s:4:\"1200\";s:16:\"window_autopopup\";s:0:\"\";s:15:\"autopopup_delay\";s:1:\"5\";s:16:\"autopopup_cookie\";s:2:\"no\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"xs\";s:16:\"column_offset_lg\";s:15:\"col-lg-offset-4\";s:16:\"column_offset_md\";s:15:\"col-md-offset-4\";s:13:\"column_offset\";s:15:\"col-sm-offset-4\";s:16:\"column_offset_xs\";s:15:\"col-xs-offset-4\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:8:\"col-sm-4\";s:11:\"size_xsmall\";s:8:\"col-xs-4\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:0:\"\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:3:\"top\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:4:\"none\";s:12:\"border_width\";s:1:\"0\";s:12:\"border_color\";s:0:\"\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:11:\"TH_ImageBox\";s:7:\"options\";a:34:{s:15:\"image_box_image\";s:79:\"https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png\";s:16:\"image_box_imgfit\";s:2:\"no\";s:16:\"image_box_height\";s:3:\"280\";s:19:\"image_box_link_text\";s:0:\"\";s:14:\"image_box_link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:15:\"image_box_title\";s:0:\"\";s:14:\"image_box_text\";s:0:\"\";s:15:\"image_box_style\";s:6:\"simple\";s:9:\"alignment\";s:6:\"center\";s:21:\"image_box_title_style\";s:18:\"title_style_center\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";}s:9:\"desc_typo\";a:8:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";}s:13:\"corner_radius\";s:3:\"199\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"30px\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"img_sizes\";a:2:{s:5:\"width\";s:3:\"140\";s:6:\"height\";s:0:\"\";}s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid073733b5\";}}s:5:\"width\";s:8:\"col-md-4\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidd4d90e65\";}i:1;a:7:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:40:{s:14:\"cc_breakpoints\";s:2:\"xs\";s:16:\"column_offset_lg\";s:15:\"col-lg-offset-3\";s:16:\"column_offset_md\";s:0:\"\";s:13:\"column_offset\";s:0:\"\";s:16:\"column_offset_xs\";s:15:\"col-xs-offset-3\";s:10:\"size_large\";s:0:\"\";s:10:\"size_small\";s:0:\"\";s:11:\"size_xsmall\";s:8:\"col-xs-6\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:0:\"\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:12:\"custom_width\";a:8:{s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:1:\"%\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:1:\"%\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:1:\"%\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:1:\"%\";}s:6:\"valign\";s:3:\"top\";s:6:\"halign\";s:4:\"left\";s:16:\"background_color\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"border_style\";s:4:\"none\";s:12:\"border_width\";s:1:\"0\";s:12:\"border_color\";s:0:\"\";s:13:\"corner_radius\";s:1:\"0\";s:6:\"zindex\";s:1:\"0\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:10:\"sticky_col\";s:14:\"zn_dummy_value\";s:19:\"sticky_col_distance\";s:3:\"100\";s:17:\"sticky_col_offset\";s:1:\"0\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:2:{i:0;a:7:{s:6:\"object\";s:10:\"TH_TextBox\";s:7:\"options\";a:21:{s:11:\"stb_content\";s:221:\"<p style=\"text-align: center; font-size: 18px;\">Thank you so much for making our wedding day so special and memorable! It was a pleasure working with you and I will recommend you to all future brides! Thank you again!</p>\";s:14:\"element_scheme\";s:0:\"\";s:17:\"parent_hover_anim\";s:0:\"\";s:15:\"parent_hover_id\";s:0:\"\";s:9:\"stb_title\";s:0:\"\";s:17:\"stb_title_heading\";s:2:\"h3\";s:9:\"stb_style\";s:6:\"style1\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:3:\"2px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid2e717c50\";}i:1;a:7:{s:6:\"object\";s:15:\"TH_TitleElement\";s:7:\"options\";a:43:{s:12:\"te_alignment\";s:6:\"center\";s:8:\"te_title\";s:17:\"Cayleigh and Adam\";s:11:\"te_subtitle\";s:0:\"\";s:14:\"te_color_theme\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"35px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"title_bmargin\";a:8:{s:2:\"lg\";s:2:\"10\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:17:\"parent_hover_anim\";s:0:\"\";s:15:\"parent_hover_id\";s:0:\"\";s:13:\"te_tt_heading\";s:1:\"3\";s:19:\"cc_font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:10:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";s:15:\"text-decoration\";s:0:\"\";}s:13:\"title_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"subtitle_typo\";a:9:{s:11:\"font-family\";s:0:\"\";s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:16:\"subtitle_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:10:\"te_stt_tag\";s:2:\"h4\";s:9:\"te_symbol\";s:0:\"\";s:15:\"te_symbol_color\";s:7:\"default\";s:22:\"te_symbol_custom_color\";s:7:\"#cd2122\";s:14:\"te_symbol_icon\";a:2:{s:6:\"family\";s:0:\"\";s:7:\"unicode\";s:0:\"\";}s:9:\"icon_size\";s:2:\"28\";s:13:\"te_symbol_pos\";s:11:\"after-title\";s:7:\"te_text\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid5c0bbcb8\";}}s:5:\"width\";s:8:\"col-md-6\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid8e6baa82\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluida9c7c828\";}i:5;a:7:{s:6:\"object\";s:9:\"ZnSection\";s:7:\"options\";a:66:{s:4:\"size\";s:9:\"container\";s:12:\"custom_width\";s:4:\"1170\";s:20:\"custom_width_percent\";s:3:\"100\";s:10:\"sec_height\";s:4:\"auto\";s:13:\"custom_height\";a:9:{s:10:\"properties\";s:10:\"min-height\";s:2:\"lg\";s:3:\"100\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:6:\"valign\";s:3:\"top\";s:11:\"gutter_size\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_md\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_sm\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:12:\"cc_margin_xs\";a:2:{s:3:\"top\";s:0:\"\";s:6:\"bottom\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:5:\"155px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:5:\"200px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:16:\"background_color\";s:7:\"#ffffff\";s:11:\"source_type\";s:0:\"\";s:16:\"background_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:12:\"source_vd_yt\";s:0:\"\";s:12:\"source_vd_vm\";s:0:\"\";s:15:\"enable_parallax\";s:2:\"no\";s:9:\"skewed_bg\";s:2:\"no\";s:22:\"source_vd_embed_iframe\";s:0:\"\";s:18:\"source_vd_self_mp4\";s:0:\"\";s:18:\"source_vd_self_ogg\";s:0:\"\";s:19:\"source_vd_self_webm\";s:0:\"\";s:12:\"source_vd_vp\";s:0:\"\";s:11:\"mobile_play\";s:2:\"no\";s:18:\"source_vd_autoplay\";s:3:\"yes\";s:14:\"source_vd_loop\";s:3:\"yes\";s:15:\"source_vd_muted\";s:3:\"yes\";s:18:\"source_vd_controls\";s:3:\"yes\";s:22:\"source_vd_controls_pos\";s:12:\"bottom-right\";s:14:\"source_overlay\";s:1:\"0\";s:20:\"source_overlay_color\";s:7:\"#353535\";s:22:\"source_overlay_opacity\";s:2:\"30\";s:29:\"source_overlay_color_gradient\";s:7:\"#353535\";s:34:\"source_overlay_color_gradient_opac\";s:2:\"30\";s:25:\"source_overlay_custom_css\";s:0:\"\";s:20:\"source_overlay_gloss\";s:14:\"zn_dummy_value\";s:14:\"section_scheme\";s:0:\"\";s:16:\"section_topmasks\";s:4:\"none\";s:11:\"topmasks_bg\";s:0:\"\";s:17:\"top_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:18:\"top_mask_bg_height\";s:3:\"100\";s:16:\"hm_header_bmasks\";s:4:\"none\";s:20:\"bottom_mask_bg_image\";a:5:{s:5:\"image\";s:0:\"\";s:6:\"repeat\";s:9:\"no-repeat\";s:10:\"attachment\";s:6:\"scroll\";s:8:\"position\";a:2:{s:1:\"x\";s:6:\"center\";s:1:\"y\";s:6:\"center\";}s:4:\"size\";s:5:\"cover\";}s:21:\"bottom_mask_bg_height\";s:3:\"100\";s:19:\"hm_header_bmasks_bg\";s:0:\"\";s:16:\"enable_ov_hidden\";s:14:\"zn_dummy_value\";s:15:\"dsb_sidemargins\";s:14:\"zn_dummy_value\";s:16:\"image_box_shadow\";s:0:\"\";s:22:\"image_box_shadow_hover\";s:0:\"\";s:6:\"zIndex\";s:0:\"\";s:18:\"enable_inlinemodal\";s:14:\"zn_dummy_value\";s:11:\"window_size\";s:4:\"1200\";s:16:\"window_autopopup\";s:0:\"\";s:15:\"autopopup_delay\";s:1:\"5\";s:16:\"autopopup_cookie\";s:2:\"no\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:3:{i:0;a:6:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:9:\"ZnHeading\";s:7:\"options\";a:25:{s:5:\"title\";s:10:\"Contact Us\";s:3:\"tag\";s:2:\"h2\";s:4:\"link\";a:3:{s:3:\"url\";s:0:\"\";s:6:\"target\";s:5:\"_self\";s:5:\"title\";s:0:\"\";}s:16:\"font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:8:{s:11:\"font-family\";s:5:\"Prata\";s:9:\"font-size\";s:4:\"36px\";s:11:\"line-height\";s:4:\"46px\";s:11:\"font-weight\";s:3:\"300\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:9:\"uppercase\";s:10:\"text-align\";s:6:\"center\";}s:13:\"title_typo_md\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_sm\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:13:\"title_typo_xs\";a:4:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:10:\"text-align\";s:0:\"\";}s:5:\"color\";s:7:\"#0a0a0a\";s:11:\"hover_color\";s:0:\"\";s:19:\"spacing_breakpoints\";s:2:\"lg\";s:9:\"margin_lg\";a:4:{s:3:\"top\";s:3:\"0px\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"30px\";s:4:\"left\";s:0:\"\";}s:9:\"margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:9:\"margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:10:\"padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";s:9:\"custom_id\";s:0:\"\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidc6ee8032\";}}s:5:\"width\";s:9:\"col-md-12\";s:6:\"widget\";s:0:\"\";s:3:\"uid\";s:13:\"eluidb0c91c01\";}i:1;a:7:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:3:{i:0;a:7:{s:6:\"object\";s:15:\"TH_TitleElement\";s:7:\"options\";a:43:{s:12:\"te_alignment\";s:4:\"left\";s:8:\"te_title\";s:7:\"Kallyas\";s:11:\"te_subtitle\";s:39:\"4676 Devonshire Drive Ravenna, OH 44266\";s:14:\"te_color_theme\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"10px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"title_bmargin\";a:8:{s:2:\"lg\";s:2:\"10\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:17:\"parent_hover_anim\";s:0:\"\";s:15:\"parent_hover_id\";s:0:\"\";s:13:\"te_tt_heading\";s:1:\"3\";s:19:\"cc_font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:10:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"18px\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";s:15:\"text-decoration\";s:0:\"\";}s:13:\"title_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"subtitle_typo\";a:9:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"18px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:16:\"subtitle_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:10:\"te_stt_tag\";s:2:\"h4\";s:9:\"te_symbol\";s:0:\"\";s:15:\"te_symbol_color\";s:7:\"default\";s:22:\"te_symbol_custom_color\";s:7:\"#cd2122\";s:14:\"te_symbol_icon\";a:2:{s:6:\"family\";s:0:\"\";s:7:\"unicode\";s:0:\"\";}s:9:\"icon_size\";s:2:\"28\";s:13:\"te_symbol_pos\";s:11:\"after-title\";s:7:\"te_text\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid7b951646\";}i:1;a:7:{s:6:\"object\";s:15:\"TH_TitleElement\";s:7:\"options\";a:43:{s:12:\"te_alignment\";s:4:\"left\";s:8:\"te_title\";s:5:\"Email\";s:11:\"te_subtitle\";s:21:\"hello@yourwebsite.com\";s:14:\"te_color_theme\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"10px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"title_bmargin\";a:8:{s:2:\"lg\";s:2:\"10\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:17:\"parent_hover_anim\";s:0:\"\";s:15:\"parent_hover_id\";s:0:\"\";s:13:\"te_tt_heading\";s:1:\"3\";s:19:\"cc_font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:10:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"18px\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";s:15:\"text-decoration\";s:0:\"\";}s:13:\"title_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"subtitle_typo\";a:9:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"18px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:16:\"subtitle_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:10:\"te_stt_tag\";s:2:\"h4\";s:9:\"te_symbol\";s:0:\"\";s:15:\"te_symbol_color\";s:7:\"default\";s:22:\"te_symbol_custom_color\";s:7:\"#cd2122\";s:14:\"te_symbol_icon\";a:2:{s:6:\"family\";s:0:\"\";s:7:\"unicode\";s:0:\"\";}s:9:\"icon_size\";s:2:\"28\";s:13:\"te_symbol_pos\";s:11:\"after-title\";s:7:\"te_text\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid71b126bc\";}i:2;a:7:{s:6:\"object\";s:15:\"TH_TitleElement\";s:7:\"options\";a:43:{s:12:\"te_alignment\";s:4:\"left\";s:8:\"te_title\";s:16:\"Customer Support\";s:11:\"te_subtitle\";s:16:\"0 1800 1800 1234\";s:14:\"te_color_theme\";s:0:\"\";s:22:\"cc_spacing_breakpoints\";s:2:\"lg\";s:12:\"cc_margin_lg\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:12:\"cc_margin_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_lg\";a:4:{s:3:\"top\";s:1:\"0\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:4:\"10px\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_md\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_sm\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"cc_padding_xs\";a:4:{s:3:\"top\";s:0:\"\";s:5:\"right\";s:0:\"\";s:6:\"bottom\";s:0:\"\";s:4:\"left\";s:0:\"\";}s:13:\"title_bmargin\";a:8:{s:2:\"lg\";s:2:\"10\";s:7:\"unit_lg\";s:2:\"px\";s:2:\"md\";s:0:\"\";s:7:\"unit_md\";s:2:\"px\";s:2:\"sm\";s:0:\"\";s:7:\"unit_sm\";s:2:\"px\";s:2:\"xs\";s:0:\"\";s:7:\"unit_xs\";s:2:\"px\";}s:17:\"parent_hover_anim\";s:0:\"\";s:15:\"parent_hover_id\";s:0:\"\";s:13:\"te_tt_heading\";s:1:\"3\";s:19:\"cc_font_breakpoints\";s:2:\"lg\";s:10:\"title_typo\";a:10:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"18px\";s:11:\"font-weight\";s:3:\"700\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";s:15:\"text-decoration\";s:0:\"\";}s:13:\"title_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"title_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:13:\"subtitle_typo\";a:9:{s:11:\"font-family\";s:9:\"Open Sans\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"18px\";s:11:\"font-weight\";s:0:\"\";s:5:\"color\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";s:14:\"text-transform\";s:0:\"\";s:11:\"text-shadow\";s:0:\"\";}s:16:\"subtitle_typo_md\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_sm\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:16:\"subtitle_typo_xs\";a:3:{s:9:\"font-size\";s:0:\"\";s:11:\"line-height\";s:0:\"\";s:14:\"letter-spacing\";s:0:\"\";}s:10:\"te_stt_tag\";s:2:\"h4\";s:9:\"te_symbol\";s:0:\"\";s:15:\"te_symbol_color\";s:7:\"default\";s:22:\"te_symbol_custom_color\";s:7:\"#cd2122\";s:14:\"te_symbol_icon\";a:2:{s:6:\"family\";s:0:\"\";s:7:\"unicode\";s:0:\"\";}s:9:\"icon_size\";s:2:\"28\";s:13:\"te_symbol_pos\";s:11:\"after-title\";s:7:\"te_text\";s:0:\"\";s:19:\"obj_parallax_enable\";s:14:\"zn_dummy_value\";s:24:\"obj_parallax_distance_v2\";s:1:\"1\";s:22:\"obj_parallax_easing_v2\";s:6:\"linear\";s:20:\"obj_parallax_reverse\";s:14:\"zn_dummy_value\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid2f27d020\";}}s:5:\"width\";s:8:\"col-md-2\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidedc70506\";}i:2;a:7:{s:6:\"object\";s:8:\"ZnColumn\";s:7:\"options\";a:0:{}s:7:\"content\";a:1:{i:0;a:7:{s:6:\"object\";s:13:\"ZnContactForm\";s:7:\"options\";a:31:{s:5:\"email\";s:0:\"\";s:7:\"cf_from\";s:7:\"noreply\";s:16:\"cf_force_dynamic\";s:14:\"zn_dummy_value\";s:16:\"cf_custom_sender\";s:0:\"\";s:12:\"redirect_url\";s:0:\"\";s:12:\"submit_label\";s:12:\"Send message\";s:13:\"email_subject\";s:19:\"New form submission\";s:12:\"sent_message\";s:27:\"Thank you for contacting us\";s:7:\"captcha\";s:1:\"0\";s:12:\"captcha_lang\";s:0:\"\";s:12:\"send_me_copy\";s:2:\"no\";s:19:\"mailchimp_subscribe\";s:2:\"no\";s:17:\"mailchimp_list_id\";s:0:\"\";s:12:\"cf_labels_pl\";s:1:\"1\";s:11:\"description\";s:0:\"\";s:8:\"cf_debug\";s:14:\"zn_dummy_value\";s:6:\"fields\";a:4:{i:0;a:13:{s:4:\"name\";s:4:\"name\";s:4:\"type\";s:4:\"text\";s:13:\"select_option\";s:0:\"\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:4:\"Name\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:8:\"col-sm-4\";s:10:\"validation\";s:9:\"not_empty\";s:11:\"is_required\";s:3:\"yes\";}i:1;a:13:{s:4:\"name\";s:5:\"email\";s:4:\"type\";s:4:\"text\";s:13:\"select_option\";s:0:\"\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:5:\"Email\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:8:\"col-sm-4\";s:10:\"validation\";s:9:\"not_empty\";s:11:\"is_required\";s:3:\"yes\";}i:2;a:13:{s:4:\"name\";s:5:\"phone\";s:4:\"type\";s:4:\"text\";s:13:\"select_option\";s:0:\"\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:5:\"Phone\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:8:\"col-sm-4\";s:10:\"validation\";s:9:\"not_empty\";s:11:\"is_required\";s:3:\"yes\";}i:3;a:13:{s:4:\"name\";s:7:\"message\";s:4:\"type\";s:8:\"textarea\";s:13:\"select_option\";s:0:\"\";s:15:\"select_multiple\";s:2:\"no\";s:12:\"radio_inline\";s:2:\"no\";s:11:\"placeholder\";s:7:\"message\";s:15:\"datepicker_lang\";s:0:\"\";s:11:\"date_format\";s:8:\"yy-mm-dd\";s:11:\"time_picker\";s:14:\"zn_dummy_value\";s:13:\"tpicker_label\";s:9:\"PICK TIME\";s:5:\"width\";s:9:\"col-sm-12\";s:10:\"validation\";s:9:\"not_empty\";s:11:\"is_required\";s:3:\"yes\";}}s:14:\"element_scheme\";s:0:\"\";s:14:\"cf_form_styles\";s:5:\"fancy\";s:13:\"input_corners\";s:0:\"\";s:12:\"inputs_style\";s:0:\"\";s:12:\"button_style\";s:30:\"btn-fullcolor btn-custom-color\";s:14:\"button_corners\";s:12:\"btn--rounded\";s:12:\"button_width\";s:0:\"\";s:11:\"button_size\";s:0:\"\";s:13:\"btn_alignment\";s:4:\"left\";s:18:\"znpb_hide_visitors\";s:3:\"all\";s:9:\"css_class\";s:0:\"\";s:19:\"appear_animation_v2\";s:4:\"none\";s:15:\"appear_duration\";s:4:\"1000\";s:12:\"appear_delay\";s:3:\"700\";}s:7:\"content\";a:0:{}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidb31102c1\";}}s:5:\"width\";s:9:\"col-md-10\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluid4fa249bf\";}}s:5:\"width\";s:0:\"\";s:6:\"widget\";s:0:\"\";s:8:\"isHidden\";a:0:{}s:3:\"uid\";s:13:\"eluidb635bb30\";}}'),
 (325, 149, 'show_header', 'show_header'),
 (326, 149, 'show_footer', 'show_footer'),
 (327, 149, 'zn_page_custom_css', ''),
 (328, 149, 'zn_page_custom_js', ''),
 (329, 150, '_menu_item_type', 'custom'),
 (330, 150, '_menu_item_menu_item_parent', '0'),
 (331, 150, '_menu_item_object_id', '150'),
 (332, 150, '_menu_item_object', 'custom'),
 (333, 150, '_menu_item_target', ''),
 (334, 150, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (335, 150, '_menu_item_xfn', ''),
 (336, 150, '_menu_item_url', '#'),
 (337, 150, '_menu_item_zn_mega_menu_enable', ''),
 (338, 150, '_menu_item_zn_mega_menu_headers', ''),
 (339, 150, '_menu_item_zn_mega_menu_label', ''),
 (340, 150, '_menu_item_zn_mega_menu_smart_area', ''),
 (341, 150, '_menu_item_zn_mega_menu_bg_image', ''),
 (342, 151, '_menu_item_type', 'custom'),
 (343, 151, '_menu_item_menu_item_parent', '0'),
 (344, 151, '_menu_item_object_id', '151'),
 (345, 151, '_menu_item_object', 'custom'),
 (346, 151, '_menu_item_target', ''),
 (347, 151, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (348, 151, '_menu_item_xfn', ''),
 (349, 151, '_menu_item_url', '#'),
 (350, 151, '_menu_item_zn_mega_menu_enable', ''),
 (351, 151, '_menu_item_zn_mega_menu_headers', ''),
 (352, 151, '_menu_item_zn_mega_menu_label', ''),
 (353, 151, '_menu_item_zn_mega_menu_smart_area', ''),
 (354, 151, '_menu_item_zn_mega_menu_bg_image', ''),
 (355, 152, '_menu_item_type', 'custom'),
 (356, 152, '_menu_item_menu_item_parent', '0'),
 (357, 152, '_menu_item_object_id', '152'),
 (358, 152, '_menu_item_object', 'custom'),
 (359, 152, '_menu_item_target', ''),
 (360, 152, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (361, 152, '_menu_item_xfn', ''),
 (362, 152, '_menu_item_url', '#'),
 (363, 152, '_menu_item_zn_mega_menu_enable', ''),
 (364, 152, '_menu_item_zn_mega_menu_headers', ''),
 (365, 152, '_menu_item_zn_mega_menu_label', ''),
 (366, 152, '_menu_item_zn_mega_menu_smart_area', ''),
 (367, 152, '_menu_item_zn_mega_menu_bg_image', ''),
 (368, 153, '_menu_item_type', 'custom'),
 (369, 153, '_menu_item_menu_item_parent', '0'),
 (370, 153, '_menu_item_object_id', '153'),
 (371, 153, '_menu_item_object', 'custom'),
 (372, 153, '_menu_item_target', ''),
 (373, 153, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (374, 153, '_menu_item_xfn', ''),
 (375, 153, '_menu_item_url', '#'),
 (376, 153, '_menu_item_zn_mega_menu_enable', ''),
 (377, 153, '_menu_item_zn_mega_menu_headers', ''),
 (378, 153, '_menu_item_zn_mega_menu_label', ''),
 (379, 153, '_menu_item_zn_mega_menu_smart_area', ''),
 (380, 153, '_menu_item_zn_mega_menu_bg_image', ''),
 (381, 154, '_menu_item_type', 'custom'),
 (382, 154, '_menu_item_menu_item_parent', '0'),
 (383, 154, '_menu_item_object_id', '154'),
 (384, 154, '_menu_item_object', 'custom'),
 (385, 154, '_menu_item_target', ''),
 (386, 154, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (387, 154, '_menu_item_xfn', ''),
 (388, 154, '_menu_item_url', '#'),
 (389, 154, '_menu_item_zn_mega_menu_enable', ''),
 (390, 154, '_menu_item_zn_mega_menu_headers', ''),
 (391, 154, '_menu_item_zn_mega_menu_label', ''),
 (392, 154, '_menu_item_zn_mega_menu_smart_area', ''),
 (393, 154, '_menu_item_zn_mega_menu_bg_image', ''),
 (394, 155, '_menu_item_type', 'custom'),
 (395, 155, '_menu_item_menu_item_parent', '0'),
 (396, 155, '_menu_item_object_id', '155'),
 (397, 155, '_menu_item_object', 'custom'),
 (398, 155, '_menu_item_target', ''),
 (399, 155, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (400, 155, '_menu_item_xfn', ''),
 (401, 155, '_menu_item_url', '#'),
 (402, 155, '_menu_item_zn_mega_menu_enable', ''),
 (403, 155, '_menu_item_zn_mega_menu_headers', ''),
 (404, 155, '_menu_item_zn_mega_menu_label', ''),
 (405, 155, '_menu_item_zn_mega_menu_smart_area', ''),
 (406, 155, '_menu_item_zn_mega_menu_bg_image', ''),
 (407, 156, '_menu_item_type', 'custom'),
 (408, 156, '_menu_item_menu_item_parent', '0'),
 (409, 156, '_menu_item_object_id', '156'),
 (410, 156, '_menu_item_object', 'custom'),
 (411, 156, '_menu_item_target', ''),
 (412, 156, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (413, 156, '_menu_item_xfn', ''),
 (414, 156, '_menu_item_url', '#'),
 (415, 156, '_menu_item_zn_mega_menu_enable', ''),
 (416, 156, '_menu_item_zn_mega_menu_headers', ''),
 (417, 156, '_menu_item_zn_mega_menu_label', ''),
 (418, 156, '_menu_item_zn_mega_menu_smart_area', ''),
 (419, 156, '_menu_item_zn_mega_menu_bg_image', ''),
 (420, 157, '_menu_item_type', 'custom'),
 (421, 157, '_menu_item_menu_item_parent', '0'),
 (422, 157, '_menu_item_object_id', '157'),
 (423, 157, '_menu_item_object', 'custom'),
 (424, 157, '_menu_item_target', ''),
 (425, 157, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (426, 157, '_menu_item_xfn', ''),
 (427, 157, '_menu_item_url', '#'),
 (428, 157, '_menu_item_zn_mega_menu_enable', ''),
 (429, 157, '_menu_item_zn_mega_menu_headers', ''),
 (430, 157, '_menu_item_zn_mega_menu_label', ''),
 (431, 157, '_menu_item_zn_mega_menu_smart_area', ''),
 (432, 157, '_menu_item_zn_mega_menu_bg_image', ''),
 (433, 158, '_menu_item_type', 'custom'),
 (434, 158, '_menu_item_menu_item_parent', '0'),
 (435, 158, '_menu_item_object_id', '158'),
 (436, 158, '_menu_item_object', 'custom'),
 (437, 158, '_menu_item_target', ''),
 (438, 158, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (439, 158, '_menu_item_xfn', ''),
 (440, 158, '_menu_item_url', '#'),
 (441, 158, '_menu_item_zn_mega_menu_enable', ''),
 (442, 158, '_menu_item_zn_mega_menu_headers', ''),
 (443, 158, '_menu_item_zn_mega_menu_label', ''),
 (444, 158, '_menu_item_zn_mega_menu_smart_area', ''),
 (445, 158, '_menu_item_zn_mega_menu_bg_image', ''),
 (446, 159, '_menu_item_type', 'custom'),
 (447, 159, '_menu_item_menu_item_parent', '0'),
 (448, 159, '_menu_item_object_id', '159'),
 (449, 159, '_menu_item_object', 'custom'),
 (450, 159, '_menu_item_target', ''),
 (451, 159, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (452, 159, '_menu_item_xfn', ''),
 (453, 159, '_menu_item_url', '#'),
 (454, 159, '_menu_item_zn_mega_menu_enable', ''),
 (455, 159, '_menu_item_zn_mega_menu_headers', ''),
 (456, 159, '_menu_item_zn_mega_menu_label', ''),
 (457, 159, '_menu_item_zn_mega_menu_smart_area', ''),
 (458, 159, '_menu_item_zn_mega_menu_bg_image', ''),
 (460, 160, '_menu_item_menu_item_parent', '0'),
 (461, 160, '_menu_item_object_id', '515'),
 (462, 160, '_menu_item_object', 'product_cat'),
 (463, 160, '_menu_item_target', ''),
 (464, 160, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (465, 160, '_menu_item_xfn', ''),
 (466, 160, '_menu_item_url', ''),
 (470, 160, '_menu_item_zn_mega_menu_smart_area', ''),
 (471, 160, '_menu_item_zn_mega_menu_bg_image', ''),
 (472, 161, '_menu_item_type', 'taxonomy'),
 (473, 161, '_menu_item_menu_item_parent', '0'),
 (474, 161, '_menu_item_object_id', '19'),
 (475, 161, '_menu_item_object', 'product_cat'),
 (476, 161, '_menu_item_target', ''),
 (477, 161, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (478, 161, '_menu_item_xfn', ''),
 (479, 161, '_menu_item_url', ''),
 (480, 161, '_menu_item_zn_mega_menu_enable', ''),
 (481, 161, '_menu_item_zn_mega_menu_headers', ''),
 (482, 161, '_menu_item_zn_mega_menu_label', ''),
 (483, 161, '_menu_item_zn_mega_menu_smart_area', ''),
 (484, 161, '_menu_item_zn_mega_menu_bg_image', ''),
 (485, 162, '_menu_item_type', 'taxonomy'),
 (486, 162, '_menu_item_menu_item_parent', '0'),
 (487, 162, '_menu_item_object_id', '18'),
 (488, 162, '_menu_item_object', 'product_cat'),
 (489, 162, '_menu_item_target', ''),
 (490, 162, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (491, 162, '_menu_item_xfn', ''),
 (492, 162, '_menu_item_url', ''),
 (493, 162, '_menu_item_zn_mega_menu_enable', ''),
 (494, 162, '_menu_item_zn_mega_menu_headers', ''),
 (495, 162, '_menu_item_zn_mega_menu_label', ''),
 (496, 162, '_menu_item_zn_mega_menu_smart_area', ''),
 (497, 162, '_menu_item_zn_mega_menu_bg_image', ''),
 (498, 163, '_menu_item_type', 'taxonomy'),
 (499, 163, '_menu_item_menu_item_parent', '0'),
 (500, 163, '_menu_item_object_id', '17'),
 (501, 163, '_menu_item_object', 'product_cat'),
 (502, 163, '_menu_item_target', ''),
 (503, 163, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (504, 163, '_menu_item_xfn', ''),
 (505, 163, '_menu_item_url', ''),
 (506, 163, '_menu_item_zn_mega_menu_enable', ''),
 (507, 163, '_menu_item_zn_mega_menu_headers', ''),
 (508, 163, '_menu_item_zn_mega_menu_label', ''),
 (509, 163, '_menu_item_zn_mega_menu_smart_area', ''),
 (510, 163, '_menu_item_zn_mega_menu_bg_image', ''),
 (511, 164, '_menu_item_type', 'taxonomy'),
 (512, 164, '_menu_item_menu_item_parent', '0'),
 (513, 164, '_menu_item_object_id', '20'),
 (514, 164, '_menu_item_object', 'product_cat'),
 (515, 164, '_menu_item_target', ''),
 (516, 164, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}');
INSERT INTO `wp8b_postmeta` VALUES(517, 164, '_menu_item_xfn', ''),
 (518, 164, '_menu_item_url', ''),
 (519, 164, '_menu_item_zn_mega_menu_enable', ''),
 (520, 164, '_menu_item_zn_mega_menu_headers', ''),
 (521, 164, '_menu_item_zn_mega_menu_label', ''),
 (522, 164, '_menu_item_zn_mega_menu_smart_area', ''),
 (523, 164, '_menu_item_zn_mega_menu_bg_image', ''),
 (524, 165, '_menu_item_type', 'post_type'),
 (525, 165, '_menu_item_menu_item_parent', '0'),
 (526, 165, '_menu_item_object_id', '140'),
 (527, 165, '_menu_item_object', 'page'),
 (528, 165, '_menu_item_target', ''),
 (529, 165, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (530, 165, '_menu_item_xfn', ''),
 (531, 165, '_menu_item_url', ''),
 (532, 165, '_menu_item_zn_mega_menu_enable', ''),
 (533, 165, '_menu_item_zn_mega_menu_headers', ''),
 (534, 165, '_menu_item_zn_mega_menu_label', ''),
 (535, 165, '_menu_item_zn_mega_menu_smart_area', ''),
 (536, 165, '_menu_item_zn_mega_menu_bg_image', ''),
 (537, 166, '_menu_item_type', 'custom'),
 (538, 166, '_menu_item_menu_item_parent', '0'),
 (539, 166, '_menu_item_object_id', '166'),
 (540, 166, '_menu_item_object', 'custom'),
 (541, 166, '_menu_item_target', ''),
 (542, 166, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (543, 166, '_menu_item_xfn', ''),
 (544, 166, '_menu_item_url', '#'),
 (545, 166, '_menu_item_zn_mega_menu_enable', ''),
 (546, 166, '_menu_item_zn_mega_menu_headers', ''),
 (547, 166, '_menu_item_zn_mega_menu_label', ''),
 (548, 166, '_menu_item_zn_mega_menu_smart_area', ''),
 (549, 166, '_menu_item_zn_mega_menu_bg_image', ''),
 (550, 167, '_menu_item_type', 'custom'),
 (551, 167, '_menu_item_menu_item_parent', '0'),
 (552, 167, '_menu_item_object_id', '167'),
 (553, 167, '_menu_item_object', 'custom'),
 (554, 167, '_menu_item_target', ''),
 (555, 167, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (556, 167, '_menu_item_xfn', ''),
 (557, 167, '_menu_item_url', '#'),
 (558, 167, '_menu_item_zn_mega_menu_enable', ''),
 (559, 167, '_menu_item_zn_mega_menu_headers', ''),
 (560, 167, '_menu_item_zn_mega_menu_label', ''),
 (561, 167, '_menu_item_zn_mega_menu_smart_area', ''),
 (562, 167, '_menu_item_zn_mega_menu_bg_image', ''),
 (563, 168, '_menu_item_type', 'custom'),
 (564, 168, '_menu_item_menu_item_parent', '0'),
 (565, 168, '_menu_item_object_id', '168'),
 (566, 168, '_menu_item_object', 'custom'),
 (567, 168, '_menu_item_target', ''),
 (568, 168, '_menu_item_classes', 'a:1:{i:0;s:0:\"\";}'),
 (569, 168, '_menu_item_xfn', ''),
 (570, 168, '_menu_item_url', '#'),
 (571, 168, '_menu_item_zn_mega_menu_enable', ''),
 (572, 168, '_menu_item_zn_mega_menu_headers', ''),
 (573, 168, '_menu_item_zn_mega_menu_label', ''),
 (574, 168, '_menu_item_zn_mega_menu_smart_area', ''),
 (575, 168, '_menu_item_zn_mega_menu_bg_image', '');

/* INSERT TABLE DATA: wp8b_posts */
INSERT INTO `wp8b_posts` VALUES(1, 1, '2020-01-06 12:44:36', '2020-01-06 12:44:36', '<!-- wp:paragraph -->\n<p>Welcome to WordPress. This is your first post. Edit or delete it, then start writing!</p>\n<!-- /wp:paragraph -->', 'Hello world!', '', 'publish', 'open', 'open', '', 'hello-world', '', '', '2020-01-06 12:44:36', '2020-01-06 12:44:36', '', 0, 'https://modelox.vico.digital/?p=1', 0, 'post', '', 1),
 (2, 1, '2020-01-06 12:44:36', '2020-01-06 12:44:36', '<!-- wp:paragraph -->\n<p>This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:quote -->\n<blockquote class=\"wp-block-quote\"><p>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</p></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:paragraph -->\n<p>...or something like this:</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:quote -->\n<blockquote class=\"wp-block-quote\"><p>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</p></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:paragraph -->\n<p>As a new WordPress user, you should go to <a href=\"https://modelox.vico.digital/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!</p>\n<!-- /wp:paragraph -->', 'Sample Page', '', 'publish', 'closed', 'open', '', 'sample-page', '', '', '2020-01-06 12:44:36', '2020-01-06 12:44:36', '', 0, 'https://modelox.vico.digital/?page_id=2', 0, 'page', '', 0),
 (3, 1, '2020-01-06 12:44:36', '2020-01-06 12:44:36', '<!-- wp:heading --><h2>Who we are</h2><!-- /wp:heading --><!-- wp:paragraph --><p>Our website address is: https://modelox.vico.digital.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>What personal data we collect and why we collect it</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Comments</h3><!-- /wp:heading --><!-- wp:paragraph --><p>When visitors leave comments on the site we collect the data shown in the comments form, and also the visitor&#8217;s IP address and browser user agent string to help spam detection.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>An anonymized string created from your email address (also called a hash) may be provided to the Gravatar service to see if you are using it. The Gravatar service privacy policy is available here: https://automattic.com/privacy/. After approval of your comment, your profile picture is visible to the public in the context of your comment.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Media</h3><!-- /wp:heading --><!-- wp:paragraph --><p>If you upload images to the website, you should avoid uploading images with embedded location data (EXIF GPS) included. Visitors to the website can download and extract any location data from images on the website.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Contact forms</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Cookies</h3><!-- /wp:heading --><!-- wp:paragraph --><p>If you leave a comment on our site you may opt-in to saving your name, email address and website in cookies. These are for your convenience so that you do not have to fill in your details again when you leave another comment. These cookies will last for one year.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you visit our login page, we will set a temporary cookie to determine if your browser accepts cookies. This cookie contains no personal data and is discarded when you close your browser.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>When you log in, we will also set up several cookies to save your login information and your screen display choices. Login cookies last for two days, and screen options cookies last for a year. If you select &quot;Remember Me&quot;, your login will persist for two weeks. If you log out of your account, the login cookies will be removed.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you edit or publish an article, an additional cookie will be saved in your browser. This cookie includes no personal data and simply indicates the post ID of the article you just edited. It expires after 1 day.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Embedded content from other websites</h3><!-- /wp:heading --><!-- wp:paragraph --><p>Articles on this site may include embedded content (e.g. videos, images, articles, etc.). Embedded content from other websites behaves in the exact same way as if the visitor has visited the other website.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>These websites may collect data about you, use cookies, embed additional third-party tracking, and monitor your interaction with that embedded content, including tracking your interaction with the embedded content if you have an account and are logged in to that website.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Analytics</h3><!-- /wp:heading --><!-- wp:heading --><h2>Who we share your data with</h2><!-- /wp:heading --><!-- wp:heading --><h2>How long we retain your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>If you leave a comment, the comment and its metadata are retained indefinitely. This is so we can recognize and approve any follow-up comments automatically instead of holding them in a moderation queue.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>For users that register on our website (if any), we also store the personal information they provide in their user profile. All users can see, edit, or delete their personal information at any time (except they cannot change their username). Website administrators can also see and edit that information.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>What rights you have over your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>If you have an account on this site, or have left comments, you can request to receive an exported file of the personal data we hold about you, including any data you have provided to us. You can also request that we erase any personal data we hold about you. This does not include any data we are obliged to keep for administrative, legal, or security purposes.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Where we send your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>Visitor comments may be checked through an automated spam detection service.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Your contact information</h2><!-- /wp:heading --><!-- wp:heading --><h2>Additional information</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>How we protect your data</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What data breach procedures we have in place</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What third parties we receive data from</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What automated decision making and/or profiling we do with user data</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Industry regulatory disclosure requirements</h3><!-- /wp:heading -->', 'Privacy Policy', '', 'draft', 'closed', 'open', '', 'privacy-policy', '', '', '2020-01-06 12:44:36', '2020-01-06 12:44:36', '', 0, 'https://modelox.vico.digital/?page_id=3', 0, 'page', '', 0),
 (8, 1, '2020-01-06 13:00:35', '2020-01-06 13:00:35', 'This page is used for Login Customizer plugin. It will not be visible to your readers. Do not delete it.', 'Login Customizer', '', 'publish', 'closed', 'closed', '', 'login-customizer', '', '', '2020-01-06 13:00:35', '2020-01-06 13:00:35', '', 0, 'https://modelox.vico.digital/login-customizer/', 0, 'page', '', 0),
 (18, 1, '2020-08-11 15:37:49', '0000-00-00 00:00:00', '', 'Borrador automático', '', 'auto-draft', 'open', 'open', '', '', '', '', '2020-08-11 15:37:49', '0000-00-00 00:00:00', '', 0, 'https://modelox.vico.digital/?p=18', 0, 'post', '', 0),
 (19, 1, '2020-08-11 15:42:40', '2020-08-11 15:42:40', '', 'woocommerce-placeholder', '', 'inherit', 'open', 'closed', '', 'woocommerce-placeholder', '', '', '2020-08-11 15:42:40', '2020-08-11 15:42:40', '', 0, 'https://modelox.vico.digital/wp-content/uploads/2020/08/woocommerce-placeholder.png', 0, 'attachment', 'image/png', 0),
 (20, 1, '2020-08-11 15:42:53', '2020-08-11 15:42:53', '', 'logo.png', '', 'inherit', 'closed', 'closed', '', 'logo-png', '', '', '2020-08-11 15:42:53', '2020-08-11 15:42:53', '', 0, 'https://modelox.vico.digital/wp-content/uploads/2017/09/logo.png', 0, 'attachment', 'image/png', 0),
 (23, 1, '2020-08-11 15:42:53', '2020-08-11 15:42:53', '', 'kallyas_placeholder.png', '', 'inherit', 'closed', 'closed', '', 'kallyas-placeholder-png', '', '', '2020-08-11 15:42:53', '2020-08-11 15:42:53', '', 0, 'https://modelox.vico.digital/wp-content/uploads/2017/10/kallyas_placeholder.png', 0, 'attachment', 'image/png', 0),
 (129, 1, '2020-08-11 15:43:01', '2020-08-11 15:43:01', '', 'copyright.png', '', 'inherit', 'closed', 'closed', '', 'copyright-png', '', '', '2020-08-11 15:43:01', '2020-08-11 15:43:01', '', 0, 'https://modelox.vico.digital/wp-content/uploads/2017/09/copyright.png', 0, 'attachment', 'image/png', 0),
 (130, 1, '2020-08-11 15:43:34', '2020-08-11 15:43:34', '', 'logo.png', '', 'inherit', 'closed', 'closed', '', 'logo-png-2', '', '', '2020-08-11 15:43:34', '2020-08-11 15:43:34', '', 0, 'https://modelox.vico.digital/wp-content/uploads/2017/09/logo.png', 0, 'attachment', 'image/png', 0),
 (131, 1, '2017-10-03 12:09:48', '2017-10-03 12:09:48', 'Welcome to <a href=\"http://localhost/kallyas_latest/\">Kallyas MU</a>. This is your first post. Edit or delete it, then start blogging!', 'Hello world!', '', 'publish', 'open', 'open', '', 'hello-world-2', '', '', '2017-10-03 12:09:48', '2017-10-03 12:09:48', '', 0, 'https://modelox.vico.digital/2017/10/03/hello-world-2/', 0, 'post', '', 0),
 (132, 1, '2017-10-03 12:09:48', '2017-10-03 12:09:48', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"https://modelox.vico.digital/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!', 'Sample Page', '', 'publish', 'closed', 'open', '', 'sample-page-2', '', '', '2020-08-11 15:43:34', '2020-08-11 15:43:34', '', 0, 'https://modelox.vico.digital/sample-page-2/', 0, 'page', '', 0),
 (133, 1, '2020-08-11 15:43:34', '2020-08-11 15:43:34', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"https://modelox.vico.digital/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!', 'Sample Page', '', 'inherit', 'closed', 'closed', '', '132-revision-v1', '', '', '2020-08-11 15:43:34', '2020-08-11 15:43:34', '', 132, 'https://modelox.vico.digital/2020/08/11/132-revision-v1/', 0, 'revision', '', 0),
 (134, 1, '2017-10-02 13:32:04', '2017-10-02 13:32:04', 'Welcome to <a href=\"http://demo.kallyas.net/\">Kallyas Demo Sites</a>. This is your first post. Edit or delete it, then start blogging!', 'Hello world!', '', 'publish', 'open', 'open', '', 'hello-world-2-2', '', '', '2017-10-02 13:32:04', '2017-10-02 13:32:04', '', 0, 'https://modelox.vico.digital/2017/10/02/hello-world-2-2/', 0, 'post', '', 0),
 (135, 1, '2017-10-02 13:32:04', '2017-10-02 13:32:04', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"https://modelox.vico.digital/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!', 'Sample Page', '', 'publish', 'closed', 'open', '', 'sample-page-2-2', '', '', '2020-08-11 15:43:34', '2020-08-11 15:43:34', '', 0, 'https://modelox.vico.digital/sample-page-2-2/', 0, 'page', '', 0),
 (136, 1, '2020-08-11 15:43:34', '2020-08-11 15:43:34', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"https://modelox.vico.digital/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!', 'Sample Page', '', 'inherit', 'closed', 'closed', '', '135-revision-v1', '', '', '2020-08-11 15:43:34', '2020-08-11 15:43:34', '', 135, 'https://modelox.vico.digital/2020/08/11/135-revision-v1/', 0, 'revision', '', 0),
 (137, 1, '2017-10-02 13:15:01', '2017-10-02 13:15:01', '[woocommerce_cart]', 'Cart', '', 'publish', 'closed', 'closed', '', 'cart', '', '', '2017-10-02 13:15:01', '2017-10-02 13:15:01', '', 0, 'https://modelox.vico.digital/cart/', 0, 'page', '', 0),
 (138, 1, '2017-10-02 13:15:01', '2017-10-02 13:15:01', '[woocommerce_checkout]', 'Checkout', '', 'publish', 'closed', 'closed', '', 'checkout', '', '', '2017-10-02 13:15:01', '2017-10-02 13:15:01', '', 0, 'https://modelox.vico.digital/checkout/', 0, 'page', '', 0),
 (139, 1, '2017-10-02 13:15:01', '2017-10-02 13:15:01', '[woocommerce_my_account]', 'My account', '', 'publish', 'closed', 'closed', '', 'my-account', '', '', '2017-10-02 13:15:01', '2017-10-02 13:15:01', '', 0, 'https://modelox.vico.digital/my-account/', 0, 'page', '', 0),
 (140, 1, '2017-10-02 13:14:47', '2017-10-02 13:14:47', '', 'Contact Us', '', 'publish', 'closed', 'closed', '', 'contact-us', '', '', '2017-10-02 13:14:47', '2017-10-02 13:14:47', '', 0, 'https://modelox.vico.digital/contact-us/', 0, 'page', '', 0),
 (141, 1, '2017-09-27 13:58:02', '2017-09-27 13:58:02', '', 'Shop', '', 'publish', 'closed', 'closed', '', 'shop', '', '', '2017-09-27 13:58:02', '2017-09-27 13:58:02', '', 0, 'https://modelox.vico.digital/shop/', 0, 'page', '', 0),
 (142, 1, '2017-09-27 07:18:46', '2017-09-27 07:18:46', '', 'Footer', '', 'publish', 'closed', 'closed', '', 'footer', '', '', '2017-09-27 07:18:46', '2017-09-27 07:18:46', '', 0, 'https://modelox.vico.digital/znpb_template_mngr/footer/', 0, 'znpb_template_mngr', '', 0),
 (143, 1, '2017-09-25 11:21:12', '2017-09-25 11:21:12', 'Intrinsicly revolutionize resource sucking e-tailers via inexpensive vortals. Uniquely evolve cross-unit ideas after premium infrastructures. Globally aggregate user-centric data rather than efficient communities.', 'A Pretty Pink Bouque', 'CONGRATULATION', 'publish', 'open', 'closed', '', 'a-pretty-pink-bouque', '', '', '2017-09-25 11:21:12', '2017-09-25 11:21:12', '', 0, 'https://modelox.vico.digital/shop/a-pretty-pink-bouque/', 0, 'product', '', 0),
 (144, 1, '2017-09-25 11:19:57', '2017-09-25 11:19:57', 'Intrinsicly revolutionize resource sucking e-tailers via inexpensive vortals. Uniquely evolve cross-unit ideas after premium infrastructures. Globally aggregate user-centric data rather than efficient communities.', 'Blooming Masterpiece', 'FAMILY FLOWERS', 'publish', 'open', 'closed', '', 'blooming-masterpiece', '', '', '2017-09-25 11:19:57', '2017-09-25 11:19:57', '', 0, 'https://modelox.vico.digital/shop/blooming-masterpiece/', 0, 'product', '', 0),
 (145, 1, '2017-09-14 13:49:18', '2017-09-14 13:49:18', 'Intrinsicly revolutionize resource sucking e-tailers via inexpensive vortals. Uniquely evolve cross-unit ideas after premium infrastructures. Globally aggregate user-centric data rather than efficient communities.', 'Light Pink Roses', 'WEDDING', 'publish', 'open', 'closed', '', 'light-pink-roses', '', '', '2017-09-14 13:49:18', '2017-09-14 13:49:18', '', 0, 'https://modelox.vico.digital/shop/light-pink-roses/', 0, 'product', '', 0),
 (146, 1, '2017-09-14 07:06:16', '2017-09-14 07:06:16', 'Intrinsicly revolutionize resource sucking e-tailers via inexpensive vortals. Uniquely evolve cross-unit ideas after premium infrastructures. Globally aggregate user-centric data rather than efficient communities.', 'Blooming Cheerful Wishes', 'CONGRATULATION', 'publish', 'open', 'closed', '', 'blooming-cheerful-wishes', '', '', '2017-09-14 07:06:16', '2017-09-14 07:06:16', '', 0, 'https://modelox.vico.digital/shop/blooming-cheerful-wishes/', 0, 'product', '', 0),
 (147, 1, '2017-09-14 07:05:02', '2017-09-14 07:05:02', 'Intrinsicly revolutionize resource sucking e-tailers via inexpensive vortals. Uniquely evolve cross-unit ideas after premium infrastructures. Globally aggregate user-centric data rather than efficient communities.', 'Beauty Calla Lily Bouquet', 'FAMILY FLOWERS', 'publish', 'open', 'closed', '', 'beauty-calla-lily-bouquet', '', '', '2017-09-14 07:05:02', '2017-09-14 07:05:02', '', 0, 'https://modelox.vico.digital/shop/beauty-calla-lily-bouquet/', 0, 'product', '', 0),
 (148, 1, '2017-09-14 06:10:22', '2017-09-14 06:10:22', 'Intrinsicly revolutionize resource sucking e-tailers via inexpensive vortals. Uniquely evolve cross-unit ideas after premium infrastructures. Globally aggregate user-centric data rather than efficient communities.', 'Breathtaking Bouquet', 'LOVE AND ROMANCE', 'publish', 'open', 'closed', '', 'breathtaking-bouquet', '', '', '2017-09-14 06:10:22', '2017-09-14 06:10:22', '', 0, 'https://modelox.vico.digital/shop/breathtaking-bouquet/', 0, 'product', '', 0),
 (149, 1, '2017-09-12 12:33:30', '2017-09-12 12:33:30', '', 'Homepage', '', 'publish', 'closed', 'closed', '', 'homepage', '', '', '2017-09-12 12:33:30', '2017-09-12 12:33:30', '', 0, 'https://modelox.vico.digital/homepage/', 0, 'page', '', 0),
 (150, 1, '2017-10-02 12:15:21', '2017-10-02 12:15:21', '', 'TWITTER', '', 'publish', 'closed', 'closed', '', 'twitter', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/twitter/', 1, 'nav_menu_item', '', 0),
 (151, 1, '2017-10-02 12:15:21', '2017-10-02 12:15:21', '', 'FACEBOOK', '', 'publish', 'closed', 'closed', '', 'facebook', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/facebook/', 2, 'nav_menu_item', '', 0),
 (152, 1, '2017-10-02 12:15:21', '2017-10-02 12:15:21', '', 'YOUTUBE', '', 'publish', 'closed', 'closed', '', 'youtube', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/youtube/', 3, 'nav_menu_item', '', 0),
 (153, 1, '2017-10-02 12:15:21', '2017-10-02 12:15:21', '', 'PINTEREST', '', 'publish', 'closed', 'closed', '', 'pinterest', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/pinterest/', 4, 'nav_menu_item', '', 0),
 (154, 1, '2017-10-02 12:15:21', '2017-10-02 12:15:21', '', 'GOOGLE+', '', 'publish', 'closed', 'closed', '', 'google', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/google/', 5, 'nav_menu_item', '', 0),
 (155, 1, '2017-10-02 12:13:25', '2017-10-02 12:13:25', '', 'HOME', '', 'publish', 'closed', 'closed', '', 'home', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/home/', 1, 'nav_menu_item', '', 0),
 (156, 1, '2017-10-02 12:13:25', '2017-10-02 12:13:25', '', 'SEARCH', '', 'publish', 'closed', 'closed', '', 'search', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/search/', 2, 'nav_menu_item', '', 0),
 (157, 1, '2017-10-02 12:13:25', '2017-10-02 12:13:25', '', 'BLOG', '', 'publish', 'closed', 'closed', '', 'blog', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/blog/', 3, 'nav_menu_item', '', 0),
 (158, 1, '2017-10-02 12:13:25', '2017-10-02 12:13:25', '', 'ABOUT', '', 'publish', 'closed', 'closed', '', 'about', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/about/', 4, 'nav_menu_item', '', 0),
 (159, 1, '2017-10-02 12:13:25', '2017-10-02 12:13:25', '', 'CONTACT', '', 'publish', 'closed', 'closed', '', 'contact', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/contact/', 5, 'nav_menu_item', '', 0),
 (160, 1, '2017-10-02 10:06:15', '2017-10-02 10:06:15', ' ', '', '', 'publish', 'closed', 'closed', '', '216', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/216/', 1, 'nav_menu_item', '', 0),
 (161, 1, '2017-10-02 10:06:15', '2017-10-02 10:06:15', ' ', '', '', 'publish', 'closed', 'closed', '', '217', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/217/', 2, 'nav_menu_item', '', 0),
 (162, 1, '2017-10-02 10:06:15', '2017-10-02 10:06:15', ' ', '', '', 'publish', 'closed', 'closed', '', '218', '', '', '2020-08-11 15:43:43', '2020-08-11 15:43:43', '', 0, 'https://modelox.vico.digital/2017/10/02/218/', 3, 'nav_menu_item', '', 0),
 (163, 1, '2017-10-02 10:06:15', '2017-10-02 10:06:15', ' ', '', '', 'publish', 'closed', 'closed', '', '219', '', '', '2020-08-11 15:43:44', '2020-08-11 15:43:44', '', 0, 'https://modelox.vico.digital/2017/10/02/219/', 4, 'nav_menu_item', '', 0),
 (164, 1, '2017-10-02 10:06:15', '2017-10-02 10:06:15', ' ', '', '', 'publish', 'closed', 'closed', '', '221', '', '', '2020-08-11 15:43:44', '2020-08-11 15:43:44', '', 0, 'https://modelox.vico.digital/2017/10/02/221/', 5, 'nav_menu_item', '', 0),
 (165, 1, '2017-10-02 13:20:29', '2017-10-02 13:20:29', ' ', '', '', 'publish', 'closed', 'closed', '', '244', '', '', '2020-08-11 15:43:44', '2020-08-11 15:43:44', '', 0, 'https://modelox.vico.digital/2017/10/02/244/', 6, 'nav_menu_item', '', 0),
 (166, 1, '2017-10-02 12:14:10', '2017-10-02 12:14:10', '', 'MY ACCOUNT', '', 'publish', 'closed', 'closed', '', 'my-account', '', '', '2020-08-11 15:43:44', '2020-08-11 15:43:44', '', 0, 'https://modelox.vico.digital/2017/10/02/my-account/', 1, 'nav_menu_item', '', 0),
 (167, 1, '2017-10-02 12:14:10', '2017-10-02 12:14:10', '', 'MY CART', '', 'publish', 'closed', 'closed', '', 'my-cart', '', '', '2020-08-11 15:43:44', '2020-08-11 15:43:44', '', 0, 'https://modelox.vico.digital/2017/10/02/my-cart/', 2, 'nav_menu_item', '', 0),
 (168, 1, '2017-10-02 12:14:10', '2017-10-02 12:14:10', '', 'MY ADDRESS', '', 'publish', 'closed', 'closed', '', 'my-address', '', '', '2020-08-11 15:43:44', '2020-08-11 15:43:44', '', 0, 'https://modelox.vico.digital/2017/10/02/my-address/', 3, 'nav_menu_item', '', 0);

/* INSERT TABLE DATA: wp8b_revslider_css */
INSERT INTO `wp8b_revslider_css` VALUES(1, '.tp-caption.medium_grey', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"padding\":\"2px 4px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#888\"}'),
 (2, '.tp-caption.small_text', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"700\",\"font-size\":\"14px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (3, '.tp-caption.medium_text', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (4, '.tp-caption.large_text', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"700\",\"font-size\":\"40px\",\"line-height\":\"40px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (5, '.tp-caption.very_large_text', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"white-space\":\"nowrap\",\"letter-spacing\":\"-2px\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (6, '.tp-caption.very_big_white', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"white-space\":\"nowrap\",\"padding-top\":\"1px\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"800\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"border-width\":\"0px\",\"border-style\":\"none\",\"padding\":\"0px 4px\",\"background-color\":\"#000\",\"margin\":\"0px\",\"type\":\"text\"}'),
 (7, '.tp-caption.very_big_black', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"white-space\":\"nowrap\",\"padding-top\":\"1px\"},\"hover\":\"\"}', '{\"color\":\"#000\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"padding\":\"0px 4px\",\"background-color\":\"#fff\"}'),
 (8, '.tp-caption.modern_medium_fat', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#000\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (9, '.tp-caption.modern_medium_fat_white', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (10, '.tp-caption.modern_medium_light', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#000\",\"font-weight\":\"300\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (11, '.tp-caption.modern_big_bluebg', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"letter-spacing\":\"0\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"800\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"padding\":\"3px 10px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#4e5b6c\"}'),
 (12, '.tp-caption.modern_big_redbg', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"padding-top\":\"1px\",\"letter-spacing\":\"0\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"300\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"padding\":\"3px 10px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#de543e\"}'),
 (13, '.tp-caption.modern_small_text_dark', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"white-space\":\"nowrap\"},\"hover\":\"\"}', '{\"color\":\"#555\",\"font-size\":\"14px\",\"line-height\":\"22px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\"}'),
 (14, '.tp-caption.boxshadow', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"-moz-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"-webkit-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\"},\"hover\":\"\"}', '[]'),
 (15, '.tp-caption.black', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"color\":\"#000\",\"type\":\"text\"}'),
 (16, '.tp-caption.noshadow', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '[]'),
 (17, '.tp-caption.thinheadline_dark', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"color\":\"rgba(0,0,0,0.85)\",\"font-weight\":\"300\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"transparent\"}'),
 (18, '.tp-caption.thintext_dark', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"color\":\"rgba(0,0,0,0.85)\",\"font-weight\":\"300\",\"font-size\":\"16px\",\"line-height\":\"26px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"transparent\",\"type\":\"text\"}'),
 (19, '.tp-caption.largeblackbg', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#000\",\"padding\":\"0px 20px\",\"border-radius\":\"0px\"}'),
 (20, '.tp-caption.largepinkbg', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#db4360\",\"padding\":\"0px 20px\",\"border-radius\":\"0px\"}'),
 (21, '.tp-caption.largewhitebg', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\"},\"hover\":\"\"}', '{\"color\":\"#000\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#fff\",\"padding\":\"0px 20px\",\"border-radius\":\"0px\"}'),
 (22, '.tp-caption.largegreenbg', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"position\":\"absolute\",\"text-shadow\":\"none\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#67ae73\",\"padding\":\"0px 20px\",\"border-radius\":\"0px\"}'),
 (23, '.tp-caption.excerpt', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"text-shadow\":\"none\",\"letter-spacing\":\"-1.5px\",\"width\":\"150px\",\"white-space\":\"normal !important\",\"height\":\"auto\"},\"hover\":\"\"}', '{\"font-size\":\"36px\",\"line-height\":\"36px\",\"font-weight\":\"700\",\"font-family\":\"Arial\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"rgba(0, 0, 0, 1)\",\"margin\":\"0px\",\"padding\":\"1px 4px 0px 4px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 255, 255)\",\"border-style\":\"none\"}'),
 (24, '.tp-caption.large_bold_grey', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(102, 102, 102)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"margin\":\"0px\",\"padding\":\"1px 4px 0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (25, '.tp-caption.medium_thin_grey', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"font-size\":\"34px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(102, 102, 102)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"1px 4px 0px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (26, '.tp-caption.small_thin_grey', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"font-size\":\"18px\",\"line-height\":\"26px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(117, 117, 117)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"1px 4px 0px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (27, '.tp-caption.lightgrey_divider', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"width\":\"370px\",\"height\":\"3px\",\"background-position\":\"initial initial\",\"background-repeat\":\"initial initial\"},\"hover\":\"\"}', '{\"text-decoration\":\"none\",\"background-color\":\"rgba(235, 235, 235, 1)\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
 (28, '.tp-caption.large_bold_darkblue', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(52, 73, 94)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (29, '.tp-caption.medium_bg_darkblue', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(52, 73, 94)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (30, '.tp-caption.medium_bold_red', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"24px\",\"line-height\":\"30px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(227, 58, 12)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (31, '.tp-caption.medium_light_red', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"21px\",\"line-height\":\"26px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(227, 58, 12)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (32, '.tp-caption.medium_bg_red', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(227, 58, 12)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (33, '.tp-caption.medium_bold_orange', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"24px\",\"line-height\":\"30px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(243, 156, 18)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (34, '.tp-caption.medium_bg_orange', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(243, 156, 18)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (35, '.tp-caption.grassfloor', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"width\":\"4000px\",\"height\":\"150px\"},\"hover\":\"\"}', '{\"text-decoration\":\"none\",\"background-color\":\"rgba(160, 179, 151, 1)\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
 (36, '.tp-caption.large_bold_white', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (37, '.tp-caption.medium_light_white', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (38, '.tp-caption.mediumlarge_light_white', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (39, '.tp-caption.mediumlarge_light_white_center', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px 0px 0px 0px\",\"text-align\":\"center\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (40, '.tp-caption.medium_bg_asbestos', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(127, 140, 141)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (41, '.tp-caption.medium_light_black', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (42, '.tp-caption.large_bold_black', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (43, '.tp-caption.mediumlarge_light_darkblue', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(52, 73, 94)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (44, '.tp-caption.small_light_white', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"17px\",\"line-height\":\"28px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (45, '.tp-caption.roundedimage', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
 (46, '.tp-caption.large_bg_black', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"font-size\":\"40px\",\"line-height\":\"40px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(0, 0, 0)\",\"padding\":\"10px 20px 15px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (47, '.tp-caption.mediumwhitebg', '{\"translated\":5,\"type\":\"text\",\"version\":\"4\"}', 'null', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(255, 255, 255)\",\"padding\":\"5px 15px 10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(0, 0, 0)\",\"border-style\":\"none\"}'),
 (48, '.tp-caption.MarkerDisplay', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ff0000\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\"}', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"font-style\":\"normal\",\"font-family\":\"Permanent Marker\",\"padding\":\"0px 0px 0px 0px\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"#000000\",\"border-style\":\"none\",\"border-width\":\"0px\",\"border-radius\":\"0px 0px 0px 0px\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (49, '.tp-caption.Restaurant-Display', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"font-size\":\"120px\",\"line-height\":\"120px\",\"font-weight\":\"700\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (50, '.tp-caption.Restaurant-Cursive', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Nothing you could do\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (51, '.tp-caption.Restaurant-ScrollDownText', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"font-size\":\"17px\",\"line-height\":\"17px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (52, '.tp-caption.Restaurant-Description', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\"}', '{\"idle\":{\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"font-size\":\"20px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (53, '.tp-caption.Restaurant-Price', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\"}', '{\"idle\":{\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (54, '.tp-caption.Restaurant-Menuitem', '{\"hover\":\"false\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#ffffff\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"500\",\"easing\":\"Power2.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"17px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"10px\",\"30px\",\"10px\",\"30px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (55, '.tp-caption.Furniture-LogoText', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"color\":\"#e6cfa3\",\"color-transparency\":\"1\",\"font-size\":\"160px\",\"line-height\":\"150px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"\\\"Raleway\\\"\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (56, '.tp-caption.Furniture-Plus', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0.5\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"text-shadow\":\"none\",\"box-shadow\":\"rgba(0,0,0,0.1) 0 1px 3px\"},\"hover\":\"\"}', '{\"color\":\"#e6cfa3\",\"color-transparency\":\"1\",\"font-size\":\"20\",\"line-height\":\"20px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"\\\"Raleway\\\"\",\"padding\":[\"6px\",\"7px\",\"4px\",\"7px\"],\"text-decoration\":\"none\",\"background-color\":\"#ffffff\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (57, '.tp-caption.Furniture-Title', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"text-shadow\":\"none\",\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"700\",\"font-style\":\"normal\",\"font-family\":\"\\\"Raleway\\\"\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (58, '.tp-caption.Furniture-Subtitle', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"20px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"\\\"Raleway\\\"\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (59, '.tp-caption.Gym-Display', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"80px\",\"line-height\":\"70px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (60, '.tp-caption.Gym-Subline', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"5px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"100\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (61, '.tp-caption.Gym-SmallText', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"22\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (62, '.tp-caption.Fashion-SmallText', '{\"translated\":5,\"type\":\"\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"12px\",\"line-height\":\"20px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"0\":\"\"}'),
 (116, '.tp-caption.kl-shopslider-2', '{\"translated\":5,\"type\":\"text\",\"version\":\"custom\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"color\":\"#2c2b2b\",\"color-transparency\":\"1\",\"font-size\":\"16px\",\"line-height\":\"18px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Open Sans\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\",\"0\":\"\",\"type\":\"text\"}'),
 (63, '.tp-caption.Fashion-BigDisplay', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (64, '.tp-caption.Fashion-TextBlock', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"font-size\":\"20px\",\"line-height\":\"40px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (65, '.tp-caption.Sports-Display', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"13px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"130px\",\"line-height\":\"130px\",\"font-weight\":\"100\",\"font-style\":\"normal\",\"font-family\":\"\\\"Raleway\\\"\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (66, '.tp-caption.Sports-DisplayFat', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":[\"\"],\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"130px\",\"line-height\":\"130px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"\\\"Raleway\\\"\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (67, '.tp-caption.Sports-Subline', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"4px\"},\"hover\":\"\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"font-size\":\"32px\",\"line-height\":\"32px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"\\\"Raleway\\\"\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (68, '.tp-caption.Instagram-Caption', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (69, '.tp-caption.News-Title', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"70px\",\"line-height\":\"60px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Roboto Slab\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (70, '.tp-caption.News-Subtitle', '{\"hover\":\"true\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"0.65\",\"text-decoration\":\"none\",\"background-color\":\"#ffffff\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"0px\",\"border-radius\":[\"0\",\"0\",\"0px\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"300\",\"easing\":\"Power3.easeInOut\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"24px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Roboto Slab\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"#ffffff\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (71, '.tp-caption.Photography-Display', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"5px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"80px\",\"line-height\":\"70px\",\"font-weight\":\"100\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (72, '.tp-caption.Photography-Subline', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#777777\",\"color-transparency\":\"1\",\"font-size\":\"20px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (73, '.tp-caption.Photography-ImageHover', '{\"hover\":\"true\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"0.5\",\"scalex\":\"0.8\",\"scaley\":\"0.8\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"1000\",\"easing\":\"Power3.easeInOut\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"20\",\"line-height\":\"22\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0\",\"border-style\":\"none\",\"border-width\":\"0px\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (74, '.tp-caption.Photography-Menuitem', '{\"hover\":\"true\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#00ffde\",\"background-transparency\":\"0.65\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"200\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"3px\",\"5px\",\"3px\",\"8px\"],\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0.65\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (75, '.tp-caption.Photography-Textblock', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (76, '.tp-caption.Photography-Subline-2', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"0.35\",\"font-size\":\"20px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (77, '.tp-caption.Photography-ImageHover2', '{\"hover\":\"true\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"0.5\",\"scalex\":\"0.8\",\"scaley\":\"0.8\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"500\",\"easing\":\"Back.easeOut\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"20\",\"line-height\":\"22\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Arial\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0\",\"border-style\":\"none\",\"border-width\":\"0px\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (78, '.tp-caption.WebProduct-Title', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#333333\",\"color-transparency\":\"1\",\"font-size\":\"90px\",\"line-height\":\"90px\",\"font-weight\":\"100\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (79, '.tp-caption.WebProduct-SubTitle', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#999999\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"20px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (80, '.tp-caption.WebProduct-Content', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#999999\",\"color-transparency\":\"1\",\"font-size\":\"16px\",\"line-height\":\"24px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\"}'),
 (81, '.tp-caption.WebProduct-Menuitem', '{\"hover\":\"true\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#999999\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#ffffff\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"200\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"20px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"3px\",\"5px\",\"3px\",\"8px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#333333\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (82, '.tp-caption.WebProduct-Title-Light', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#fff\",\"color-transparency\":\"1\",\"font-size\":\"90px\",\"line-height\":\"90px\",\"font-weight\":\"100\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (83, '.tp-caption.WebProduct-SubTitle-Light', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"0.35\",\"font-size\":\"15px\",\"line-height\":\"20px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"parallax\":\"-\"}'),
 (84, '.tp-caption.WebProduct-Content-Light', '{\"hover\":\"false\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"0.65\",\"font-size\":\"16px\",\"line-height\":\"24px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"parallax\":\"-\"}'),
 (85, '.tp-caption.FatRounded', '{\"hover\":\"true\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#fff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"1\",\"border-color\":\"#d3d3d3\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0px\",\"border-radius\":[\"50px\",\"50px\",\"50px\",\"50px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"text-shadow\":\"none\"},\"hover\":\"\"}', '{\"color\":\"#fff\",\"color-transparency\":\"1\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"20px\",\"22px\",\"20px\",\"25px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0.5\",\"border-color\":\"#d3d3d3\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0px\",\"border-radius\":[\"50px\",\"50px\",\"50px\",\"50px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (86, '.tp-caption.NotGeneric-Title', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"[object Object]\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"70px\",\"line-height\":\"70px\",\"font-weight\":\"800\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":\"10px 0px 10px 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (87, '.tp-caption.NotGeneric-SubTitle', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"4px\",\"text-align\":\"left\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"13px\",\"line-height\":\"20px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (88, '.tp-caption.NotGeneric-CallToAction', '{\"hover\":\"true\",\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1\",\"border-radius\":\"0px 0px 0px 0px\",\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power3.easeOut\"}', '{\"idle\":{\"letter-spacing\":\"3px\",\"text-align\":\"left\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"14px\",\"line-height\":\"14px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":\"10px 30px 10px 30px\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.5\",\"border-style\":\"solid\",\"border-width\":\"1\",\"border-radius\":\"0px 0px 0px 0px\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (89, '.tp-caption.NotGeneric-Icon', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"default\",\"speed\":\"300\",\"easing\":\"Power3.easeOut\"}', '{\"idle\":{\"letter-spacing\":\"3px\",\"text-align\":\"left\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":\"0px 0px 0px 0px\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0\",\"border-style\":\"solid\",\"border-width\":\"0px\",\"border-radius\":\"0px 0px 0px 0px\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (90, '.tp-caption.NotGeneric-Menuitem', '{\"hover\":\"true\",\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":\"0px 0px 0px 0px\",\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power1.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"3px\",\"text-align\":\"left\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"14px\",\"line-height\":\"14px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":\"27px 30px 27px 30px\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.15\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":\"0px 0px 0px 0px\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (91, '.tp-caption.MarkerStyle', '{\"translated\":5,\"type\":\"text\",\"version\":\"5.0\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"text-align\":\"left\",\"0\":\"\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"30px\",\"font-weight\":\"100\",\"font-style\":\"normal\",\"font-family\":\"\\\"Permanent Marker\\\"\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (92, '.tp-caption.Gym-Menuitem', '{\"hover\":\"true\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"1\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.25\",\"border-style\":\"solid\",\"border-width\":\"2px\",\"border-radius\":[\"3px\",\"3px\",\"3px\",\"3px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"200\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"3px\",\"5px\",\"3px\",\"8px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"1\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0\",\"border-style\":\"solid\",\"border-width\":\"2px\",\"border-radius\":[\"3px\",\"3px\",\"3px\",\"3px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (93, '.tp-caption.Newspaper-Button', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#FFFFFF\",\"background-transparency\":\"1\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power1.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"13px\",\"line-height\":\"17px\",\"font-weight\":\"700\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"12px\",\"35px\",\"12px\",\"35px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#ffffff\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.25\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (94, '.tp-caption.Newspaper-Subtitle', '{\"hover\":\"false\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#a8d8ee\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"20px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"0\",\"0\",\"0\",\"0\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (95, '.tp-caption.Newspaper-Title', '{\"hover\":\"false\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#fff\",\"color-transparency\":\"1\",\"font-size\":\"50px\",\"line-height\":\"55px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"\\\"Roboto Slab\\\"\",\"padding\":[\"0\",\"0\",\"10px\",\"0\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (96, '.tp-caption.Newspaper-Title-Centered', '{\"hover\":\"false\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#fff\",\"color-transparency\":\"1\",\"font-size\":\"50px\",\"line-height\":\"55px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"\\\"Roboto Slab\\\"\",\"padding\":[\"0\",\"0\",\"10px\",\"0\"],\"text-decoration\":\"none\",\"text-align\":\"center\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (97, '.tp-caption.Hero-Button', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#000000\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#ffffff\",\"background-transparency\":\"1\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power1.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"14px\",\"line-height\":\"14px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"10px\",\"30px\",\"10px\",\"30px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.5\",\"border-style\":\"solid\",\"border-width\":\"1\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (98, '.tp-caption.Video-Title', '{\"hover\":\"false\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#fff\",\"color-transparency\":\"1\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"5px\",\"5px\",\"5px\",\"5px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"-20%\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (99, '.tp-caption.Video-SubTitle', '{\"hover\":\"false\",\"type\":\"text\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"0\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"12px\",\"line-height\":\"12px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"5px\",\"5px\",\"5px\",\"5px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0.35\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"-20%\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (100, '.tp-caption.NotGeneric-Button', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power1.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"3px\",\"text-align\":\"left\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"14px\",\"line-height\":\"14px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"10px\",\"30px\",\"10px\",\"30px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.5\",\"border-style\":\"solid\",\"border-width\":\"1\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (101, '.tp-caption.NotGeneric-BigButton', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power1.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"14px\",\"line-height\":\"14px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"27px\",\"30px\",\"27px\",\"30px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.15\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (102, '.tp-caption.WebProduct-Button', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#333333\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#ffffff\",\"background-transparency\":\"1\",\"border-color\":\"#000000\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"2\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"300\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"1px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"16px\",\"line-height\":\"48px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"0px\",\"40px\",\"0px\",\"40px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#333333\",\"background-transparency\":\"1\",\"border-color\":\"#000000\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"2\",\"border-radius\":[\"0\",\"0\",\"0\",\"0\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (103, '.tp-caption.Restaurant-Button', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffe081\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"300\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"3px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"17px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"12px\",\"35px\",\"12px\",\"35px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#0a0a0a\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.5\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (104, '.tp-caption.Gym-Button', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#72a800\",\"background-transparency\":\"1\",\"border-color\":\"#000000\",\"border-transparency\":\"0\",\"border-style\":\"solid\",\"border-width\":\"0\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power1.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"1px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"15px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"13px\",\"35px\",\"13px\",\"35px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#8bc027\",\"background-transparency\":\"1\",\"border-color\":\"#000000\",\"border-transparency\":\"0\",\"border-style\":\"solid\",\"border-width\":\"0\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (105, '.tp-caption.Gym-Button-Light', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#72a800\",\"background-transparency\":\"0\",\"border-color\":\"#8bc027\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"2px\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power2.easeInOut\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"15px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"12px\",\"35px\",\"12px\",\"35px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.25\",\"border-style\":\"solid\",\"border-width\":\"2px\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (106, '.tp-caption.Sports-Button-Light', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"500\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"17px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"12px\",\"35px\",\"12px\",\"35px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.5\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (107, '.tp-caption.Sports-Button-Red', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"1\",\"border-color\":\"#000000\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"500\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"17px\",\"line-height\":\"17px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"12px\",\"35px\",\"12px\",\"35px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#db1c22\",\"background-transparency\":\"1\",\"border-color\":\"#db1c22\",\"border-transparency\":\"0\",\"border-style\":\"solid\",\"border-width\":\"2px\",\"border-radius\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (108, '.tp-caption.Photography-Button', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"auto\",\"speed\":\"300\",\"easing\":\"Power3.easeOut\"}', '{\"idle\":{\"letter-spacing\":\"1px\"},\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"15px\",\"font-weight\":\"600\",\"font-style\":\"normal\",\"font-family\":\"Raleway\",\"padding\":[\"13px\",\"35px\",\"13px\",\"35px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.25\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (109, '.tp-caption.Newspaper-Button-2', '{\"hover\":\"true\",\"type\":\"button\",\"version\":\"5.0\",\"translated\":\"5\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":[\"3px\",\"3px\",\"3px\",\"3px\"],\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"pointer_events\":\"auto\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Linear.easeNone\"}', '{\"idle\":\"\",\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"15px\",\"line-height\":\"15px\",\"font-weight\":\"900\",\"font-style\":\"normal\",\"font-family\":\"Roboto\",\"padding\":[\"10px\",\"30px\",\"10px\",\"30px\"],\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#ffffff\",\"border-transparency\":\"0.5\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":[\"3px\",\"3px\",\"3px\",\"3px\"],\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\"}'),
 (110, '.tp-caption.Creative-SubTitle', '{\"translated\":5,\"type\":\"text\",\"version\":\"custom\"}', 'null', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#cdb083\",\"font-size\":\"14px\",\"line-height\":\"14px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Lato\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\"}'),
 (111, '.tp-caption.Creative-Title', '{\"translated\":5,\"type\":\"text\",\"version\":\"custom\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"font-size\":\"70px\",\"line-height\":\"70px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Playfair Display\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-color\":\"transparent\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\"}'),
 (112, '.tp-caption.Creative-Button', '{\"hover\":\"true\",\"translated\":5,\"type\":\"text\",\"version\":\"custom\"}', '{\"color\":\"#cdb083\",\"color-transparency\":\"1\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#cdb083\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":\"0px 0px 0px 0px\",\"opacity\":\"1\",\"scalex\":\"1\",\"scaley\":\"1\",\"skewx\":\"0\",\"skewy\":\"0\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"css_cursor\":\"pointer\",\"speed\":\"300\",\"easing\":\"Power1.easeInOut\"}', '{\"idle\":{\"letter-spacing\":\"2px\"},\"hover\":\"\"}', '{\"color\":\"#cdb083\",\"font-size\":\"13px\",\"line-height\":\"13px\",\"font-weight\":\"400\",\"font-style\":\"normal\",\"font-family\":\"Lato\",\"text-decoration\":\"none\",\"background-color\":\"#000000\",\"border-color\":\"#cdb083\",\"border-style\":\"solid\",\"border-width\":\"1px\",\"border-radius\":\"0px 0px 0px 0px\"}'),
 (113, '.tp-caption.kl-shopslider-1', '{\"translated\":5,\"type\":\"text\",\"version\":\"custom\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"color\":\"#cfcfcf\",\"color-transparency\":\"1\",\"font-size\":\"54px\",\"line-height\":\"60px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Open Sans\",\"padding\":\"0 0 0 0\",\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"transparent\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"0 0 0 0\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\",\"0\":\"\",\"type\":\"text\"}'),
 (114, '.tp-caption.kl-shop-btn', '{\"translated\":5,\"type\":\"button\",\"version\":\"custom\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"color\":\"#d42627\",\"color-transparency\":\"1\",\"font-size\":\"16px\",\"line-height\":\"17px\",\"font-weight\":\"500\",\"font-style\":\"normal\",\"font-family\":\"Open Sans\",\"padding\":\"12px 35px 12px 35px\",\"text-decoration\":\"none\",\"text-align\":\"center\",\"background-color\":\"#000000\",\"background-transparency\":\"0\",\"border-color\":\"#d42627\",\"border-transparency\":\"1\",\"border-style\":\"solid\",\"border-width\":\"2\",\"border-radius\":\"3px 3px 3px 3px\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\",\"0\":\"\",\"type\":\"button\"}'),
 (115, '.tp-caption.kl-red-label', '{\"translated\":5,\"type\":\"text\",\"version\":\"custom\"}', 'null', '{\"idle\":[],\"hover\":\"\"}', '{\"color\":\"#ffffff\",\"color-transparency\":\"1\",\"font-size\":\"16px\",\"line-height\":\"20px\",\"font-weight\":\"300\",\"font-style\":\"normal\",\"font-family\":\"Open Sans\",\"padding\":\"5px 50px 5px 10px\",\"text-decoration\":\"none\",\"text-align\":\"left\",\"background-color\":\"#d42627\",\"background-transparency\":\"1\",\"border-color\":\"transparent\",\"border-transparency\":\"1\",\"border-style\":\"none\",\"border-width\":\"0\",\"border-radius\":\"3px 3px 3px 3px\",\"z\":\"0\",\"skewx\":\"0\",\"skewy\":\"0\",\"scalex\":\"1\",\"scaley\":\"1\",\"opacity\":\"1\",\"xrotate\":\"0\",\"yrotate\":\"0\",\"2d_rotation\":\"0\",\"2d_origin_x\":\"50\",\"2d_origin_y\":\"50\",\"pers\":\"600\",\"corner_left\":\"nothing\",\"corner_right\":\"nothing\",\"parallax\":\"-\",\"0\":\"\",\"type\":\"text\"}');

/* INSERT TABLE DATA: wp8b_revslider_css_bkp */
INSERT INTO `wp8b_revslider_css_bkp` VALUES(1, '.tp-caption.medium_grey', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"padding\":\"2px 4px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#888\",\"white-space\":\"nowrap\"}'),
 (2, '.tp-caption.small_text', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"14px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
 (3, '.tp-caption.medium_text', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
 (4, '.tp-caption.large_text', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"40px\",\"line-height\":\"40px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
 (5, '.tp-caption.very_large_text', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"letter-spacing\":\"-2px\"}'),
 (6, '.tp-caption.very_big_white', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"background-color\":\"#000\"}'),
 (7, '.tp-caption.very_big_black', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"background-color\":\"#fff\"}'),
 (8, '.tp-caption.modern_medium_fat', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
 (9, '.tp-caption.modern_medium_fat_white', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
 (10, '.tp-caption.modern_medium_light', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
 (11, '.tp-caption.modern_big_bluebg', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"padding\":\"3px 10px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#4e5b6c\",\"letter-spacing\":\"0\"}'),
 (12, '.tp-caption.modern_big_redbg', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"padding\":\"3px 10px\",\"padding-top\":\"1px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#de543e\",\"letter-spacing\":\"0\"}'),
 (13, '.tp-caption.modern_small_text_dark', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#555\",\"text-shadow\":\"none\",\"font-size\":\"14px\",\"line-height\":\"22px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
 (14, '.tp-caption.boxshadow', NULL, NULL, NULL, '{\"-moz-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"-webkit-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\"}'),
 (15, '.tp-caption.black', NULL, NULL, NULL, '{\"color\":\"#000\",\"text-shadow\":\"none\"}'),
 (16, '.tp-caption.noshadow', NULL, NULL, NULL, '{\"text-shadow\":\"none\"}'),
 (17, '.tp-caption.thinheadline_dark', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"rgba(0,0,0,0.85)\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"transparent\"}'),
 (18, '.tp-caption.thintext_dark', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"rgba(0,0,0,0.85)\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"16px\",\"line-height\":\"26px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"transparent\"}'),
 (19, '.tp-caption.largeblackbg', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#000\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}'),
 (20, '.tp-caption.largepinkbg', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#db4360\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}'),
 (21, '.tp-caption.largewhitebg', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#fff\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}'),
 (22, '.tp-caption.largegreenbg', NULL, NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#67ae73\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}'),
 (23, '.tp-caption.excerpt', NULL, NULL, NULL, '{\"font-size\":\"36px\",\"line-height\":\"36px\",\"font-weight\":\"700\",\"font-family\":\"Arial\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"rgba(0, 0, 0, 1)\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"letter-spacing\":\"-1.5px\",\"padding\":\"1px 4px 0px 4px\",\"width\":\"150px\",\"white-space\":\"normal !important\",\"height\":\"auto\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 255, 255)\",\"border-style\":\"none\"}'),
 (24, '.tp-caption.large_bold_grey', NULL, NULL, NULL, '{\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(102, 102, 102)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"padding\":\"1px 4px 0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (25, '.tp-caption.medium_thin_grey', NULL, NULL, NULL, '{\"font-size\":\"34px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(102, 102, 102)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"1px 4px 0px\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (26, '.tp-caption.small_thin_grey', NULL, NULL, NULL, '{\"font-size\":\"18px\",\"line-height\":\"26px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(117, 117, 117)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"1px 4px 0px\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (27, '.tp-caption.lightgrey_divider', NULL, NULL, NULL, '{\"text-decoration\":\"none\",\"background-color\":\"rgba(235, 235, 235, 1)\",\"width\":\"370px\",\"height\":\"3px\",\"background-position\":\"initial initial\",\"background-repeat\":\"initial initial\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
 (28, '.tp-caption.large_bold_darkblue', NULL, NULL, NULL, '{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(52, 73, 94)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (29, '.tp-caption.medium_bg_darkblue', NULL, NULL, NULL, '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(52, 73, 94)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (30, '.tp-caption.medium_bold_red', NULL, NULL, NULL, '{\"font-size\":\"24px\",\"line-height\":\"30px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(227, 58, 12)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (31, '.tp-caption.medium_light_red', NULL, NULL, NULL, '{\"font-size\":\"21px\",\"line-height\":\"26px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(227, 58, 12)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (32, '.tp-caption.medium_bg_red', NULL, NULL, NULL, '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(227, 58, 12)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (33, '.tp-caption.medium_bold_orange', NULL, NULL, NULL, '{\"font-size\":\"24px\",\"line-height\":\"30px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(243, 156, 18)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (34, '.tp-caption.medium_bg_orange', NULL, NULL, NULL, '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(243, 156, 18)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (35, '.tp-caption.grassfloor', NULL, NULL, NULL, '{\"text-decoration\":\"none\",\"background-color\":\"rgba(160, 179, 151, 1)\",\"width\":\"4000px\",\"height\":\"150px\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
 (36, '.tp-caption.large_bold_white', NULL, NULL, NULL, '{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (37, '.tp-caption.medium_light_white', NULL, NULL, NULL, '{\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (38, '.tp-caption.mediumlarge_light_white', NULL, NULL, NULL, '{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (39, '.tp-caption.mediumlarge_light_white_center', NULL, NULL, NULL, '{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px 0px 0px 0px\",\"text-align\":\"center\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (40, '.tp-caption.medium_bg_asbestos', NULL, NULL, NULL, '{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(127, 140, 141)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (41, '.tp-caption.medium_light_black', NULL, NULL, NULL, '{\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (42, '.tp-caption.large_bold_black', NULL, NULL, NULL, '{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (43, '.tp-caption.mediumlarge_light_darkblue', NULL, NULL, NULL, '{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(52, 73, 94)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (44, '.tp-caption.small_light_white', NULL, NULL, NULL, '{\"font-size\":\"17px\",\"line-height\":\"28px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (45, '.tp-caption.roundedimage', NULL, NULL, NULL, '{\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
 (46, '.tp-caption.large_bg_black', NULL, NULL, NULL, '{\"font-size\":\"40px\",\"line-height\":\"40px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(0, 0, 0)\",\"padding\":\"10px 20px 15px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}'),
 (47, '.tp-caption.mediumwhitebg', NULL, NULL, NULL, '{\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(255, 255, 255)\",\"padding\":\"5px 15px 10px\",\"text-shadow\":\"none\",\"border-width\":\"0px\",\"border-color\":\"rgb(0, 0, 0)\",\"border-style\":\"none\"}');

/* INSERT TABLE DATA: wp8b_revslider_layer_animations */
INSERT INTO `wp8b_revslider_layer_animations` VALUES(1, 'slidee', '{\"name\":\"slidee\",\"frame_0\":{\"transform\":{\"opacity\":\"0\",\"y\":\"-30px\"},\"timeline\":[]},\"frame_1\":{\"timeline\":{\"speed\":\"600\",\"ease\":\"power2.inOut\"}}}', 'in');

/* INSERT TABLE DATA: wp8b_revslider_layer_animations_bkp */
INSERT INTO `wp8b_revslider_layer_animations_bkp` VALUES(1, 'slidee', '{\"name\":\"slidee\",\"frame_0\":{\"transform\":{\"opacity\":\"0\",\"y\":\"-30px\"},\"timeline\":[]},\"frame_1\":{\"timeline\":{\"speed\":\"600\",\"ease\":\"Power2.easeInOut\"}}}', 'in');

/* INSERT TABLE DATA: wp8b_revslider_navigations_bkp */
INSERT INTO `wp8b_revslider_navigations_bkp` VALUES(1, 'Kallyas-Ares', 'kallyas-ares', 'arrows', '.kallyas-ares.tparrows {\n  width:50px;\n  height:50px;\n  background:transparent;\n }\n .kallyas-ares.tparrows:before {\n font-weight:normal;\n width:50px;\n height:50px;\n line-height:50px;\n font-size:40px;\n transition:all 0.3s;\n-webkit-transition:all 0.3s;\n }\n \n  .kallyas-ares.tparrows:hover:before {\n    opacity:0.75;\n  }', '', '{\"dim\":{\"width\":\"160\",\"height\":\"160\"},\"placeholders\":{},\"presets\":{},\"version\":\"6.0.0\"}'),
 (2, 'Kallyas-Ares', 'kallyas-ares', 'bullets', '.kallyas-ares .tp-bullet{\n	border-radius: 50%;\n  box-shadow: 0 0 0 2px rgba(255, 255, 255, 0);\n  -webkit-transition: box-shadow 0.3s ease;\n  transition: box-shadow 0.3s ease;\n  background:transparent;\n}\n.kallyas-ares .tp-bullet.selected,\n.kallyas-ares .tp-bullet:hover {\n  box-shadow: 0 0 0 2px #fff;\n  border:none;\n  border-radius: 50%;\n\n   background:transparent;\n}\n\n\n\n.kallyas-ares .tp-bullet-inner {\n  background-color: rgba(255, 255, 255, 0.7);\n  -webkit-transition: background-color 0.3s ease, -webkit-transform 0.3s ease;\n  transition: background-color 0.3s ease, transform 0.3s ease;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  outline: none;\n  border-radius: 50%;\n  background-color: #fff;\n  background-color: rgba(255, 255, 255, 0.3);\n  text-indent: -999em;\n  cursor: pointer;\n  position: absolute;\n}\n\n.kallyas-ares .tp-bullet.selected .tp-bullet-inner,\n.kallyas-ares .tp-bullet:hover .tp-bullet-inner{\n transform: scale(0.4);\n -webkit-transform: scale(0.4);\n background-color:#fff;\n}', '<span class=\\\"tp-bullet-inner\\\"></span>', '{\"dim\":{\"width\":\"160\",\"height\":\"160\"},\"placeholders\":{},\"presets\":{},\"version\":\"6.0.0\"}'),
 (3, 'spa-custom', 'spa-custom', 'arrows', '.spa-custom.tparrows {\n	cursor:pointer;\n	background:rgba(##back-color##);\n	width:##width##px;\n	height:##height##px;\n	position:absolute;\n	display:block;\n	z-index:100;\n}\n\n.spa-custom.tparrows:before {\n	font-family: \\\"revicons\\\";\n	font-size:##arrow-size##px;\n	color:rgb(##arrow-color##);\n	display:block;\n	line-height: ##height##px;\n	text-align: center;\n    transform:translatex(0px);\n    -webkit-transform:translatex(0px);\n    transition:all 0.3s;\n    -webkit-transition:all 0.3s;\n}\n.spa-custom.tparrows.tp-leftarrow:before {\n	content: \\\"\\\\e824\\\";\n}\n.spa-custom.tparrows.tp-rightarrow:before {\n	content: \\\"\\\\e825\\\";\n}\n.spa-custom.tparrows.tp-leftarrow:hover:before {\n    transform:translatex(-20px);\n    -webkit-transform:translatex(-20px);\n     opacity:0;\n}\n.spa-custom.tparrows.tp-rightarrow:hover:before {\n    transform:translatex(20px);\n    -webkit-transform:translatex(20px);\n     opacity:0;\n}\n\n.spa-custom .tp-arr-allwrapper {\n    overflow:hidden;\n    position:absolute;\n	width:##wrapper-width##px;\n    height:##wrapper-height##px;\n    top:0px;\n    left:0px;\n    visibility:hidden;\n      -webkit-transition: -webkit-transform 0.3s 0.3s;\n  transition: transform 0.3s 0.3s;\n  -webkit-perspective: 1000px;\n  perspective: 1000px;\n    }\n.spa-custom.tp-rightarrow .tp-arr-allwrapper {\n   right:0px;left:auto;\n      }\n.spa-custom.tparrows:hover .tp-arr-allwrapper {\n   visibility:visible;\n          }\n.spa-custom .tp-arr-imgholder {\n  width:##wrapper-width##px;position:absolute;\n  left:0px;top:0px;height:##height##px;\n  transform:translatex(-##wrapper-width##px);\n  -webkit-transform:translatex(-##wrapper-width##px);\n  transition:all 0.3s;\n  transition-delay:0.3s;\n}\n.spa-custom.tp-rightarrow .tp-arr-imgholder{\n    transform:translatex(##wrapper-width##px);\n  -webkit-transform:translatex(##wrapper-width##px);\n      }\n  \n.spa-custom.tparrows:hover .tp-arr-imgholder {\n   transform:translatex(0px);\n   -webkit-transform:translatex(0px);            \n}\n.spa-custom .tp-arr-titleholder {\n  top:##height##px;\n  width:##wrapper-width##px;\n  text-align:left; \n  display:block;\n  padding:0px 10px;\n  line-height:30px; background:#000;\n  background:rgba(##title-back-color##);\n  color:rgb(##title-font-color##);\n  font-weight:600; position:absolute;\n  font-size:##title-size##px;\n  white-space:nowrap;\n  letter-spacing:1px;\n  -webkit-transition: all 0.3s;\n  transition: all 0.3s;\n  -webkit-transform: rotatex(-90deg);\n  transform: rotatex(-90deg);\n  -webkit-transform-origin: 50% 0;\n  transform-origin: 50% 0;\n  box-sizing:border-box;\n\n}\n.spa-custom.tparrows:hover .tp-arr-titleholder {\n    -webkit-transition-delay: 0.6s;\n  transition-delay: 0.6s;\n  -webkit-transform: rotatex(0deg);\n  transform: rotatex(0deg);\n}\n', '<div class=\\\"tp-arr-allwrapper\\\">\n	<div class=\\\"tp-arr-imgholder\\\"></div>\n	<div class=\\\"tp-arr-titleholder\\\">{{title}}</div>	\n</div>', '{\"dim\":{\"width\":\"160\",\"height\":\"160\"},\"placeholders\":{\"back-color\":{\"title\":\"Background\",\"type\":\"color-rgba\",\"data\":\"rgba(0,0,0,0.5)\"},\"width\":{\"title\":\"Width\",\"type\":\"custom\",\"data\":\"30\"},\"height\":{\"title\":\"Height\",\"type\":\"custom\",\"data\":\"110\"},\"arrow-color\":{\"title\":\"Arrow-Color\",\"type\":\"color\",\"data\":\"#ffffff\"},\"arrow-size\":{\"title\":\"Arrow-Size\",\"type\":\"custom\",\"data\":\"15\"},\"wrapper-height\":{\"title\":\"Wrapper-Height\",\"type\":\"custom\",\"data\":\"140\"},\"wrapper-width\":{\"title\":\"Wrapper-Width\",\"type\":\"custom\",\"data\":\"180\"},\"title-size\":{\"title\":\"Title-Size\",\"type\":\"custom\",\"data\":\"12\"},\"title-back-color\":{\"title\":\"Title-Background\",\"type\":\"color-rgba\",\"data\":\"rgba(0,0,0,0.75)\"},\"title-font-color\":{\"title\":\"Title-Font-Color\",\"type\":\"color\",\"data\":\"#ffffff\"}},\"presets\":{},\"version\":\"6.0.0\"}'),
 (4, 'spa-custom', 'spa-custom', 'bullets', '.spa-custom.tp-bullets {\n}\n\n.spa-custom .tp-bullet {\n    overflow:hidden;\n    border-radius:50%;\n    width:##bullet-size##px;\n    height:##bullet-size##px;\n    background-color: rgba(0, 0, 0, 0);\n    box-shadow: inset 0 0 0 ##border##px rgb(##bullet-color##);\n    -webkit-transition: background 0.3s ease;\n    transition: background 0.3s ease;\n    text-align: center;\n    padding-top: 8px;\n    color: #fff;\n    font-size: 16px;\n}\n\n.spa-custom .tp-bullet:hover {\n	  background-color: rgba(##bullet-hover##);\n}\n.spa-custom .tp-bullet:after {\n  content: \\\' \\\';\n  position: absolute;\n  bottom: 0;\n  height: 0;\n  left: 0;\n  width: 100%;\n  background-color: rgb(##bullet-color##);\n  box-shadow: 0 0 1px rgb(##bullet-color##);\n  -webkit-transition: height 0.3s ease;\n  transition: height 0.3s ease;\n  z-index: -1;\n}\n.spa-custom .tp-bullet.selected:after {\n  height:100%;\n}\n.spa-custom .tp-bullet.selected {color: #aeb0b5}\n\n', '{{param1}}', '{\"dim\":{\"width\":\"160\",\"height\":\"160\"},\"placeholders\":{\"bullet-size\":{\"title\":\"Bullet-Size\",\"type\":\"custom\",\"data\":\"40\"},\"bullet-color\":{\"title\":\"Bullet-Color\",\"type\":\"color\",\"data\":\"#ffffff\"},\"border\":{\"title\":\"Border-Thickness\",\"type\":\"custom\",\"data\":\"1\"},\"bullet-hover\":{\"title\":\"Hover-Bullet\",\"type\":\"color-rgba\",\"data\":\"rgba(255, 255, 255, 0.42)\"}},\"presets\":{},\"version\":\"6.0.0\"}'),
 (5, 'spa-custom', 'spa-custom', 'tabs', '.spa-custom .tp-tab { \n  opacity:1;  \n  box-sizing:border-box;\n  padding-right:10px;\n }\n \n.spa-custom .tp-tab-content-wrapper {\n  position:absolute;\n  width:100%;\n  min-height:40%;\n  bottom:0px;\n  box-sizing:border-box;\n  padding-right:10px;\n  overflow:hidden;\n}\n.spa-custom .tp-tab-bg {\n  position:absolute; \n  top:0px;\n  left:-10px; \n  width:100%;height:100%;\n  background:rgba(##back-color##); \n}\n.spa-custom .tp-tab-image \n{ \n  width:100%;\n  height:60%;\n  position:relative;\n}\n.spa-custom .tp-tab-content \n{\n  position:relative;\n  padding:##padding##;\n  box-sizing:border-box;\n  display:block;\n  width:100%;\n }\n.spa-custom .tp-tab-date\n  {\n  display:block;\n  color:rgb(##param1-color##);\n  font-weight:600;\n  font-size:##param1-size##px;\n  margin-bottom:10px;\n  }\n.spa-custom .tp-tab-title \n{\n    display:block;	\n    color:rgb(##param2-color##);\n    font-size:##param2-size##px;\n    font-weight:800;\n    text-transform:uppercase;\n   line-height:##param2-size##px;\n}\n\n.spa-custom .tp-tab.selected .tp-tab-content-wrapper:after {\n  width: 0px;\n	height: 0px;\n	border-style: solid;\n	border-width: 25px 0 25px 10px;\n	border-color: transparent transparent transparent ##back-color##;\n	content:\\\" \\\";\n    position:absolute;\n    right:0px;\n    bottom:50%;\n    margin-bottom:-25px;\n}\n\n\n/* media queries */\n@media only screen and (max-width: 960px) {\n  .spa-custom .tp-tab .tp-tab-title {font-size:14px;line-height:16px;}\n  .spa-custom .tp-tab-date { font-size:11px; line-height:13px;margin-bottom:10px;}\n  .spa-custom .tp-tab-content { padding:15px 15px 15px 25px;}\n}\n@media only screen and (max-width: 768px) {\n  .spa-custom .tp-tab .tp-tab-title {font-size:12px;line-height:14px;}\n  .spa-custom .tp-tab-date {font-size:10px; line-height:12px;margin-bottom:5px;}\n  .spa-custom .tp-tab-content {padding:10px 10px 10px 20px;}\n}\n\n/* bottom horizontal */\n.spa-custom .nav-pos-ver-bottom.nav-dir-horizontal .tp-tab-image             { margin-top:40%; }\n.spa-custom .nav-pos-ver-bottom.nav-dir-horizontal .tp-tab-content-wrapper   { position:absolute; bottom:auto;top:0px; padding-top:10px;}\n.spa-custom .nav-pos-ver-bottom.nav-dir-horizontal                           { padding-right:0px; }\n.spa-custom .nav-pos-ver-bottom.nav-dir-horizontal .tp-tab-bg                { left:0px; top:10px;}\n.spa-custom .nav-pos-ver-bottom.nav-dir-horizontal.tp-tab.selected .tp-tab-content-wrapper:after {  \n  border-width: 0px 25px 10px 25px;\n  border-color: transparent transparent rgba(##back-color##) transparent;\n  top:0px;\n  left:50%;\n  margin-left:0px 0px 0px -25px;\n}\n\n/* center horizontal */\n.spa-custom .nav-pos-ver-center.nav-dir-horizontal .tp-tab-image             { margin-top:40%; }\n.spa-custom .nav-pos-ver-center.nav-dir-horizontal .tp-tab-content-wrapper   { position:absolute; bottom:auto;top:0px; padding-top:10px;}\n.spa-custom .nav-pos-ver-center.nav-dir-horizontal                           { padding-right:0px; }\n.spa-custom .nav-pos-ver-center.nav-dir-horizontal .tp-tab-bg                { left:0px; top:10px;}\n.spa-custom .nav-pos-ver-center.nav-dir-horizontal.tp-tab.selected .tp-tab-content-wrapper:after {  \n  border-width: 0px 25px 10px 25px;\n  border-color: transparent transparent rgba(##back-color##) transparent;\n  top:0px;\n  left:50%;\n  margin:0px 0px 0px -25px;\n}\n\n/* bottom horizontal */\n.spa-custom .nav-pos-ver-top.nav-dir-horizontal .tp-tab-content-wrapper   { padding-bottom:10px;}\n.spa-custom .nav-pos-ver-top.nav-dir-horizontal                           { padding-right:0px; }\n.spa-custom .nav-pos-ver-top.nav-dir-horizontal .tp-tab-bg                { left:0px; top:-10px;}\n.spa-custom .nav-pos-ver-top.nav-dir-horizontal.tp-tab.selected .tp-tab-content-wrapper:after {  \n  border-width: 10px 25px 0px 25px;\n  border-color: rgba(##back-color##) transparent transparent transparent;\n  bottom:0px;\n  left:50%;\n  margin:0px 0px 0px -25px;\n}\n\n/* right veertical */\n.spa-custom .nav-pos-hor-right.nav-dir-vertical .tp-tab-content-wrapper { padding-left:10px; padding-right:0px; left:0px;} \n.spa-custom .nav-pos-hor-right.nav-dir-vertical { padding-left:10px; padding-right:0px;}\n.spa-custom .nav-pos-hor-right.nav-dir-vertical .tp-tab-bg  { left:10px;}\n.spa-custom .nav-pos-hor-right.nav-dir-vertical.tp-tab.selected .tp-tab-content-wrapper:after {  \n  border-width: 25px 10px 25px 0px;\n  border-color:transparent  rgba(##back-color##) transparent transparent;\n  right:auto;\n  left:0px;    \n}\n\n', '<span class=\\\"tp-tab-image\\\"></span>\n<span class=\\\"tp-tab-content-wrapper\\\">\n<span class=\\\"tp-tab-bg\\\"></span>\n<span class=\\\"tp-tab-content\\\">\n	<span class=\\\"tp-tab-date\\\">{{param1}}</span>\n	<span class=\\\"tp-tab-title\\\">{{param2}}</span>\n</span>\n</span>', '{\"dim\":{\"width\":\"240\",\"height\":\"260\"},\"placeholders\":{\"back-color\":{\"title\":\"Background\",\"type\":\"color-rgba\",\"data\":\"#000000\"},\"param1-color\":{\"title\":\"Param-1-Color\",\"type\":\"color\",\"data\":\"#888888\"},\"param2-color\":{\"title\":\"Param-2-Color\",\"type\":\"color\",\"data\":\"#ffffff\"},\"param1-size\":{\"title\":\"Param-1-Size\",\"type\":\"custom\",\"data\":\"12\"},\"param2-size\":{\"title\":\"Param-2-Size\",\"type\":\"custom\",\"data\":\"16\"},\"padding\":{\"title\":\"Padding\",\"type\":\"custom\",\"data\":\"20px\"}},\"presets\":{},\"version\":\"6.0.0\"}');

/* INSERT TABLE DATA: wp8b_revslider_sliders */
INSERT INTO `wp8b_revslider_sliders` VALUES(45, 'Florist', 'florist', '{\"id\":\"\",\"shortcode\":\"[rev_slider alias=\\\\\\\"florist\\\\\\\"]\",\"layouttype\":\"fullwidth\",\"type\":\"standard\",\"sourcetype\":\"gallery\",\"googleFont\":[],\"addOns\":[],\"source\":{\"gallery\":[],\"post\":{\"excerptLimit\":\"55\",\"maxPosts\":\"30\",\"fetchType\":\"cat_tag\",\"category\":\"\",\"sortBy\":\"ID\",\"types\":\"post\",\"list\":\"\",\"sortDirection\":\"DESC\",\"subType\":\"post\"},\"woo\":{\"excerptLimit\":\"55\",\"maxProducts\":\"30\",\"featuredOnly\":false,\"inStockOnly\":false,\"category\":\"\",\"sortBy\":\"ID\",\"types\":\"product\",\"sortDirection\":\"DESC\",\"regPriceFrom\":\"\",\"regPriceTo\":\"\",\"salePriceFrom\":\"\",\"salePriceTo\":\"\"},\"instagram\":{\"count\":\"\",\"hashTag\":\"\",\"transient\":\"1200\",\"type\":\"user\",\"userId\":\"\"},\"facebook\":{\"album\":\"\",\"appId\":\"\",\"appSecret\":\"\",\"count\":\"\",\"pageURL\":\"\",\"transient\":\"1200\",\"typeSource\":\"album\"},\"flickr\":{\"apiKey\":\"\",\"count\":\"\",\"galleryURL\":\"\",\"groupURL\":\"\",\"photoSet\":\"\",\"transient\":\"1200\",\"type\":\"publicphotos\",\"userURL\":\"\"},\"twitter\":{\"accessSecret\":\"\",\"accessToken\":\"\",\"consumerKey\":\"\",\"consumerSecret\":\"\",\"count\":\"\",\"excludeReplies\":false,\"imageOnly\":false,\"includeRetweets\":false,\"transient\":\"1200\",\"userId\":\"\"},\"vimeo\":{\"albumId\":\"\",\"channelName\":\"\",\"count\":\"\",\"transient\":\"1200\",\"groupName\":\"\",\"typeSource\":\"user\",\"userName\":\"\"},\"youtube\":{\"api\":\"\",\"channelId\":\"\",\"count\":\"\",\"playList\":\"\",\"transient\":\"1200\",\"typeSource\":\"channel\"}},\"def\":{\"transition\":\"fade\",\"transitionDuration\":\"300\",\"delay\":\"9000\",\"background\":{\"fit\":\"cover\",\"fitX\":\"100\",\"fitY\":\"100\",\"position\":\"center center\",\"positionX\":\"0\",\"positionY\":\"0\",\"repeat\":\"no-repeat\",\"imageSourceType\":\"full\"},\"panZoom\":{\"set\":false,\"blurStart\":\"0\",\"blurEnd\":\"0\",\"duration\":\"\",\"ease\":\"none\",\"fitEnd\":\"100\",\"fitStart\":\"100\",\"xEnd\":\"0\",\"yEnd\":\"0\",\"xStart\":\"0\",\"yStart\":\"0\",\"rotateStart\":\"0\",\"rotateEnd\":\"0\"}},\"size\":{\"respectAspectRatio\":false,\"disableForceFullWidth\":false,\"gridEQModule\":false,\"custom\":{\"d\":true,\"n\":true,\"t\":true,\"m\":true},\"minHeightFullScreen\":\"\",\"minHeight\":\"\",\"fullScreenOffsetContainer\":\"\",\"fullScreenOffset\":\"\",\"width\":{\"d\":1240,\"n\":1024,\"t\":778,\"m\":480},\"height\":{\"d\":750,\"n\":768,\"t\":960,\"m\":720},\"overflow\":false,\"maxWidth\":\"\"},\"codes\":{\"css\":\"\",\"javascript\":\"\"},\"carousel\":{\"borderRadius\":\"0\",\"borderRadiusUnit\":\"px\",\"ease\":\"power3.inOut\",\"fadeOut\":true,\"scale\":false,\"horizontal\":\"center\",\"vertical\":\"center\",\"infinity\":false,\"maxItems\":\"3\",\"maxRotation\":\"0\",\"paddingTop\":\"0\",\"paddingBottom\":\"0\",\"rotation\":false,\"scaleDown\":50,\"space\":\"0\",\"speed\":\"800\",\"stretch\":false,\"varyFade\":false,\"varyRotate\":false,\"varyScale\":false,\"showAllLayers\":false},\"hero\":{\"activeSlide\":\"-1\"},\"layout\":{\"bg\":{\"color\":\"#a997a7\",\"padding\":\"0\",\"dottedOverlay\":\"none\",\"shadow\":\"0\",\"useImage\":false,\"image\":\"\",\"fit\":\"cover\",\"position\":\"center center\",\"repeat\":\"no-repeat\"},\"spinner\":{\"color\":\"#FFFFFF\",\"type\":\"0\"},\"position\":{\"marginTop\":\"0\",\"marginBottom\":\"0\",\"marginLeft\":\"0\",\"marginRight\":\"0\",\"align\":\"center\"}},\"visibility\":{\"hideSelectedLayersUnderLimit\":\"0\",\"hideAllLayersUnderLimit\":\"0\",\"hideSliderUnderLimit\":\"0\"},\"general\":{\"slideshow\":{\"stopOnHover\":false,\"stopSlider\":false,\"stopAfterLoops\":\"0\",\"stopAtSlide\":\"2\",\"shuffle\":false,\"loopSingle\":false,\"viewPort\":false,\"viewPortStart\":\"wait\",\"viewPortArea\":\"20%\",\"presetSliderHeight\":false,\"initDelay\":\"0\",\"waitForInit\":false,\"slideShow\":true},\"progressbar\":{\"set\":false,\"height\":\"5\",\"position\":\"top\",\"color\":\"rgba(0,0,0,0.15)\"},\"firstSlide\":{\"set\":false,\"duration\":\"300\",\"slotAmount\":\"7\",\"type\":\"fade\",\"alternativeFirstSlideSet\":false,\"alternativeFirstSlide\":\"1\"},\"layerSelection\":false,\"lazyLoad\":\"none\",\"nextSlideOnFocus\":false,\"disableFocusListener\":false,\"disableOnMobile\":false,\"autoPlayVideoOnMobile\":true,\"disablePanZoomMobile\":false,\"useWPML\":false},\"nav\":{\"preview\":{\"width\":\"100\",\"height\":\"50\"},\"swipe\":{\"set\":false,\"setOnDesktop\":false,\"blockDragVertical\":false,\"direction\":\"horizontal\",\"minTouch\":\"1\",\"velocity\":\"75\"},\"keyboard\":{\"set\":false,\"direction\":\"horizontal\"},\"mouse\":{\"set\":false,\"reverse\":\"default\"},\"arrows\":{\"set\":true,\"rtl\":false,\"style\":1000,\"preset\":\"default\",\"presets\":[],\"alwaysOn\":true,\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\",\"left\":{\"horizontal\":\"left\",\"vertical\":\"center\",\"offsetX\":\"20\",\"offsetY\":\"0\",\"align\":\"slider\"},\"right\":{\"horizontal\":\"right\",\"vertical\":\"center\",\"offsetX\":\"20\",\"offsetY\":\"0\",\"align\":\"slider\"}},\"thumbs\":{\"set\":false,\"rtl\":false,\"style\":2000,\"preset\":\"default\",\"presets\":[],\"alwaysOn\":true,\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\",\"spanWrapper\":false,\"horizontal\":\"center\",\"vertical\":\"bottom\",\"amount\":\"5\",\"direction\":\"horizontal\",\"height\":\"50\",\"width\":\"100\",\"widthMin\":\"100\",\"innerOuter\":\"inner\",\"offsetX\":\"0\",\"offsetY\":\"20\",\"space\":\"5\",\"align\":\"slider\",\"padding\":\"5\",\"wrapperColor\":\"transparent\"},\"tabs\":{\"set\":false,\"rtl\":false,\"style\":4000,\"preset\":\"default\",\"presets\":[],\"alwaysOn\":true,\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\",\"spanWrapper\":false,\"horizontal\":\"center\",\"vertical\":\"bottom\",\"amount\":\"5\",\"direction\":\"horizontal\",\"height\":\"50\",\"width\":\"100\",\"widthMin\":\"100\",\"innerOuter\":\"inner\",\"offsetX\":\"0\",\"offsetY\":\"20\",\"space\":\"5\",\"align\":\"slider\",\"padding\":\"5\",\"wrapperColor\":\"transparent\"},\"bullets\":{\"set\":false,\"rtl\":false,\"style\":3000,\"preset\":\"default\",\"presets\":[],\"alwaysOn\":true,\"horizontal\":\"center\",\"vertical\":\"bottom\",\"direction\":\"horizontal\",\"offsetX\":\"0\",\"offsetY\":\"20\",\"align\":\"slider\",\"space\":\"5\",\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\"}},\"troubleshooting\":{\"ignoreHeightChanges\":false,\"ignoreHeightChangesUnderLimit\":\"0\",\"alternateImageType\":\"off\",\"alternateURL\":\"\",\"alternateURLId\":false,\"jsNoConflict\":false,\"jsInBody\":false,\"outPutFilter\":\"none\",\"debugMode\":false,\"simplify_ie8_ios4\":false},\"parallax\":{\"set\":false,\"setDDD\":false,\"disableOnMobile\":false,\"levels\":[\"5\",\"10\",\"15\",\"20\",\"25\",\"30\",\"35\",\"40\",\"45\",\"46\",\"47\",\"48\",\"49\",\"50\",\"51\",\"55\"],\"ddd\":{\"BGFreeze\":false,\"layerOverflow\":false,\"overflow\":false,\"shadow\":false,\"zCorrection\":\"65\"},\"mouse\":{\"speed\":\"400\",\"bgSpeed\":0,\"layersSpeed\":0,\"origo\":\"enterpoint\",\"type\":\"mouse\"}},\"scrolleffects\":{\"set\":false,\"setBlur\":false,\"setFade\":false,\"setGrayScale\":false,\"bg\":false,\"direction\":\"both\",\"maxBlur\":\"10\",\"multiplicator\":\"1.3\",\"multiplicatorLayers\":\"1.3\",\"disableOnMobile\":true,\"tilt\":\"30\",\"layers\":false},\"version\":\"6.2.0\"}', '{\"version\":\"6.2.0\"}', '');

/* INSERT TABLE DATA: wp8b_revslider_sliders_bkp */
INSERT INTO `wp8b_revslider_sliders_bkp` VALUES(1, 'winter-sports', 'winter-sports', '{\"id\":\"\",\"shortcode\":\"[rev_slider alias=\\\\\\\"winter-sports\\\\\\\"]\",\"layouttype\":\"auto\",\"type\":\"standard\",\"sourcetype\":\"gallery\",\"googleFont\":[],\"addOns\":[],\"source\":{\"gallery\":[],\"post\":{\"excerptLimit\":\"55\",\"maxPosts\":\"30\",\"fetchType\":\"cat_tag\",\"category\":\"\",\"sortBy\":\"ID\",\"types\":\"post\",\"list\":\"\",\"sortDirection\":\"DESC\",\"subType\":\"post\"},\"woo\":{\"excerptLimit\":\"55\",\"maxProducts\":\"30\",\"featuredOnly\":false,\"inStockOnly\":false,\"category\":\"\",\"sortBy\":\"ID\",\"types\":\"product\",\"sortDirection\":\"DESC\",\"regPriceFrom\":\"\",\"regPriceTo\":\"\",\"salePriceFrom\":\"\",\"salePriceTo\":\"\"},\"instagram\":{\"count\":\"\",\"hashTag\":\"\",\"transient\":\"1200\",\"type\":\"user\",\"userId\":\"\"},\"facebook\":{\"album\":\"\",\"appId\":\"\",\"appSecret\":\"\",\"count\":\"\",\"pageURL\":\"\",\"transient\":\"1200\",\"typeSource\":\"album\"},\"flickr\":{\"apiKey\":\"\",\"count\":\"\",\"galleryURL\":\"\",\"groupURL\":\"\",\"photoSet\":\"\",\"transient\":\"1200\",\"type\":\"publicphotos\",\"userURL\":\"\"},\"twitter\":{\"accessSecret\":\"\",\"accessToken\":\"\",\"consumerKey\":\"\",\"consumerSecret\":\"\",\"count\":\"\",\"excludeReplies\":false,\"imageOnly\":false,\"includeRetweets\":false,\"transient\":\"1200\",\"userId\":\"\"},\"vimeo\":{\"albumId\":\"\",\"channelName\":\"\",\"count\":\"\",\"transient\":\"1200\",\"groupName\":\"\",\"typeSource\":\"user\",\"userName\":\"\"},\"youtube\":{\"api\":\"\",\"channelId\":\"\",\"count\":\"\",\"playList\":\"\",\"transient\":\"1200\",\"typeSource\":\"channel\"}},\"def\":{\"transition\":\"fade\",\"transitionDuration\":\"300\",\"delay\":\"9000\",\"background\":{\"fit\":\"cover\",\"fitX\":\"100\",\"fitY\":\"100\",\"position\":\"center center\",\"positionX\":\"0\",\"positionY\":\"0\",\"repeat\":\"no-repeat\",\"imageSourceType\":\"full\"},\"panZoom\":{\"set\":false,\"blurStart\":0,\"blurEnd\":0,\"duration\":\"\",\"ease\":\"Linear.easeNone\",\"fitEnd\":\"100\",\"fitStart\":\"100\",\"xEnd\":\"0\",\"yEnd\":\"0\",\"xStart\":\"0\",\"yStart\":\"0\",\"rotateStart\":\"0\",\"rotateEnd\":\"0\"}},\"size\":{\"respectAspectRatio\":false,\"disableForceFullWidth\":false,\"gridEQModule\":false,\"custom\":{\"d\":true,\"n\":true,\"t\":true,\"m\":true},\"minHeightFullScreen\":\"\",\"minHeight\":\"\",\"fullScreenOffsetContainer\":\"\",\"fullScreenOffset\":\"\",\"width\":{\"d\":1680,\"n\":1024,\"t\":778,\"m\":480},\"height\":{\"d\":868,\"n\":768,\"t\":960,\"m\":720},\"overflow\":false,\"maxWidth\":\"\"},\"codes\":{\"css\":\"\",\"javascript\":\"\"},\"carousel\":{\"borderRadius\":\"0\",\"borderRadiusUnit\":\"px\",\"ease\":\"Power3.easeInOut\",\"fadeOut\":true,\"scale\":false,\"horizontal\":\"center\",\"vertical\":\"center\",\"infinity\":false,\"maxItems\":\"3\",\"maxRotation\":\"0\",\"paddingTop\":\"0\",\"paddingBottom\":\"0\",\"rotation\":false,\"scaleDown\":\"50\",\"space\":\"0\",\"speed\":800,\"stretch\":false,\"varyFade\":false,\"varyRotate\":false,\"varyScale\":false,\"showAllLayers\":false},\"hero\":{\"activeSlide\":\"-1\"},\"layout\":{\"bg\":{\"color\":\"transparent\",\"padding\":\"0\",\"dottedOverlay\":\"none\",\"shadow\":\"0\",\"useImage\":false,\"image\":\"\",\"fit\":\"cover\",\"position\":\"center center\",\"repeat\":\"no-repeat\"},\"spinner\":{\"color\":\"#FFFFFF\",\"type\":\"0\"},\"position\":{\"marginTop\":\"0\",\"marginBottom\":\"0\",\"marginLeft\":\"0\",\"marginRight\":\"0\",\"align\":\"center\"}},\"visibility\":{\"hideSelectedLayersUnderLimit\":\"0\",\"hideAllLayersUnderLimit\":\"0\",\"hideSliderUnderLimit\":\"0\"},\"general\":{\"slideshow\":{\"stopOnHover\":false,\"stopSlider\":false,\"stopAfterLoops\":\"0\",\"stopAtSlide\":\"2\",\"shuffle\":false,\"loopSingle\":false,\"viewPort\":false,\"viewPortStart\":\"wait\",\"viewPortArea\":\"20%\",\"presetSliderHeight\":false,\"initDelay\":\"0\",\"waitForInit\":false,\"slideShow\":true},\"progressbar\":{\"set\":false,\"height\":\"5\",\"position\":\"top\",\"color\":\"rgba(0,0,0,0.15)\"},\"firstSlide\":{\"set\":false,\"duration\":\"300\",\"slotAmount\":\"7\",\"type\":\"fade\",\"alternativeFirstSlideSet\":false,\"alternativeFirstSlide\":\"1\"},\"layerSelection\":false,\"lazyLoad\":\"none\",\"nextSlideOnFocus\":false,\"disableFocusListener\":false,\"disableOnMobile\":false,\"autoPlayVideoOnMobile\":true,\"disablePanZoomMobile\":false,\"useWPML\":false},\"nav\":{\"preview\":{\"width\":\"100\",\"height\":\"50\"},\"swipe\":{\"set\":false,\"setOnDesktop\":false,\"blockDragVertical\":false,\"direction\":\"horizontal\",\"minTouch\":\"1\",\"velocity\":\"75\"},\"keyboard\":{\"set\":false,\"direction\":\"horizontal\"},\"mouse\":{\"set\":false,\"reverse\":\"default\"},\"arrows\":{\"set\":false,\"rtl\":false,\"style\":1000,\"preset\":\"default\",\"presets\":{},\"alwaysOn\":true,\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\",\"left\":{\"horizontal\":\"left\",\"vertical\":\"center\",\"offsetX\":\"20\",\"offsetY\":\"0\",\"align\":\"slider\"},\"right\":{\"horizontal\":\"right\",\"vertical\":\"center\",\"offsetX\":\"20\",\"offsetY\":\"0\",\"align\":\"slider\"}},\"thumbs\":{\"set\":false,\"rtl\":false,\"style\":2000,\"preset\":\"default\",\"presets\":{},\"alwaysOn\":true,\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\",\"spanWrapper\":false,\"horizontal\":\"center\",\"vertical\":\"bottom\",\"amount\":\"5\",\"direction\":\"horizontal\",\"height\":\"50\",\"width\":\"100\",\"widthMin\":\"100\",\"innerOuter\":\"inner\",\"offsetX\":\"0\",\"offsetY\":\"20\",\"space\":\"5\",\"align\":\"slider\",\"padding\":\"5\",\"wrapperColor\":\"transparent\"},\"tabs\":{\"set\":false,\"rtl\":false,\"style\":4000,\"preset\":\"default\",\"presets\":{},\"alwaysOn\":true,\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\",\"spanWrapper\":false,\"horizontal\":\"center\",\"vertical\":\"bottom\",\"amount\":\"5\",\"direction\":\"horizontal\",\"height\":\"50\",\"width\":\"100\",\"widthMin\":\"100\",\"innerOuter\":\"inner\",\"offsetX\":\"0\",\"offsetY\":\"20\",\"space\":\"5\",\"align\":\"slider\",\"padding\":\"5\",\"wrapperColor\":\"transparent\"},\"bullets\":{\"set\":true,\"rtl\":false,\"style\":3013,\"preset\":\"default\",\"presets\":{},\"alwaysOn\":true,\"horizontal\":\"right\",\"vertical\":\"center\",\"direction\":\"vertical\",\"offsetX\":\"20\",\"offsetY\":\"0\",\"align\":\"grid\",\"space\":\"30\",\"hideDelay\":\"200\",\"hideDelayMobile\":\"1200\",\"hideOver\":false,\"hideOverLimit\":\"0\",\"hideUnder\":false,\"hideUnderLimit\":\"0\"}},\"troubleshooting\":{\"ignoreHeightChanges\":false,\"ignoreHeightChangesUnderLimit\":\"0\",\"alternateImageType\":\"off\",\"alternateURL\":\"\",\"alternateURLId\":false,\"jsNoConflict\":false,\"jsInBody\":false,\"outPutFilter\":\"none\",\"debugMode\":false,\"simplify_ie8_ios4\":false},\"parallax\":{\"set\":true,\"setDDD\":false,\"disableOnMobile\":false,\"levels\":[\"5\",\"10\",\"15\",\"20\",\"25\",\"30\",\"35\",\"40\",\"45\",\"46\",\"47\",\"48\",\"49\",\"50\",\"51\",\"55\"],\"ddd\":{\"BGFreeze\":false,\"layerOverflow\":false,\"overflow\":false,\"shadow\":false,\"zCorrection\":\"65\"},\"mouse\":{\"speed\":\"400\",\"bgSpeed\":0,\"layersSpeed\":0,\"origo\":\"enterpoint\",\"type\":\"scroll\"}},\"scrolleffects\":{\"set\":false,\"setBlur\":false,\"setFade\":false,\"setGrayScale\":false,\"bg\":false,\"direction\":\"both\",\"maxBlur\":10,\"multiplicator\":\"1.35\",\"multiplicatorLayers\":\"1.3\",\"disableOnMobile\":false,\"tilt\":\"30\",\"layers\":false}}', '{\"version\":\"6.0.0\"}', '');

/* INSERT TABLE DATA: wp8b_revslider_slides */
INSERT INTO `wp8b_revslider_slides` VALUES(204, 45, 1, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (205, 45, 2, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"\"}},\"thumb\":{\"customThumbSrc\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"customAdminThumbSrc\":\"http:\\/\\/localhost\\/wp\\/florist\\/wp-content\\/uploads\\/sites\\/15\\/2017\\/09\\/slide1.jpg\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (206, 45, 3, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (207, 45, 4, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"100\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (208, 45, 5, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"100\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (209, 45, 6, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"100\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (210, 45, 8, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (211, 45, 9, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"100\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}'),
 (212, 45, 10, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/2017\\/10\\/kallyas_placeholder.png\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"100\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"slots\":[\"default\"],\"duration\":[600]},\"panzoom\":{\"ease\":\"none\"},\"version\":\"6.2.0\"}', '[]', '{\"0\":\"\",\"version\":\"6.2.0\"}');

/* INSERT TABLE DATA: wp8b_revslider_slides_bkp */
INSERT INTO `wp8b_revslider_slides_bkp` VALUES(1, 1, 1, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/revslider\\/winter-sports-bg.jpg\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"delay\":\"\",\"slots\":[\"default\"],\"duration\":[600]},\"effects\":{\"parallax\":\"4\"}}', '{\"1\":{\"text\":\"Image 1\",\"alias\":\"Image 1\",\"uid\":1,\"media\":{\"imageUrl\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/revslider\\/winter-sports-man2.png\",\"imageId\":356},\"size\":{\"width\":{\"d\":{\"v\":\"961px\",\"e\":true},\"n\":{\"v\":\"961px\",\"e\":true},\"t\":{\"v\":\"1090px\",\"e\":true},\"m\":{\"v\":\"834px\",\"e\":true}},\"height\":{\"d\":{\"v\":\"877px\",\"e\":true},\"n\":{\"v\":\"877px\",\"e\":true},\"t\":{\"v\":\"995px\",\"e\":true},\"m\":{\"v\":\"761px\",\"e\":true}},\"originalWidth\":1003,\"originalHeight\":916,\"aspectRatio\":{\"d\":{\"v\":1.09497816593886465597051937947981059551239013671875},\"n\":{\"v\":1.09497816593886465597051937947981059551239013671875},\"t\":{\"v\":1.09497816593886465597051937947981059551239013671875},\"m\":{\"v\":1.09497816593886465597051937947981059551239013671875}}},\"position\":{\"x\":{\"d\":{\"v\":\"88px\",\"e\":true},\"n\":{\"v\":\"-182px\",\"e\":true},\"t\":{\"v\":\"-252px\",\"e\":true},\"m\":{\"v\":\"-408px\",\"e\":true}},\"y\":{\"d\":{\"v\":\"-1px\",\"e\":true},\"n\":{\"v\":\"-1px\",\"e\":true},\"t\":{\"v\":\"-1px\",\"e\":true},\"m\":{\"e\":true}},\"horizontal\":{\"d\":{\"v\":\"right\",\"e\":true},\"n\":{\"v\":\"right\",\"e\":true},\"t\":{\"v\":\"right\",\"e\":true},\"m\":{\"v\":\"right\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"bottom\",\"e\":true},\"n\":{\"v\":\"bottom\",\"e\":true},\"t\":{\"v\":\"bottom\",\"e\":true},\"m\":{\"v\":\"bottom\",\"e\":true}},\"zIndex\":5,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":5,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"effects\":{\"parallax\":\"2\"},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"n\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"t\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"m\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"22\",\"e\":true},\"n\":{\"v\":\"22\",\"e\":true},\"t\":{\"v\":\"22\",\"e\":true},\"m\":{\"v\":\"22\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\",\"e\":true},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"n\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"t\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"m\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(255,255,255,1)\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"originX\":50,\"originY\":50,\"speed\":\"0\"},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"type\":\"image\"},\"3\":{\"text\":\"Extreme\",\"alias\":\"Extreme\",\"uid\":3,\"size\":{\"width\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"20px\",\"e\":true},\"n\":{\"v\":\"20px\"},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"-90px\",\"e\":true},\"n\":{\"v\":\"-90px\"},\"t\":{\"v\":\"-90px\",\"e\":true},\"m\":{\"v\":\"-130px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\"},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":6,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":6,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"\",\"fontSize\":{\"d\":{\"v\":\"85px\",\"e\":true},\"n\":{\"v\":\"85px\"},\"t\":{\"v\":\"85px\",\"e\":true},\"m\":{\"v\":\"70px\",\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"100px\",\"e\":true},\"n\":{\"v\":\"100px\"},\"t\":{\"v\":\"100px\",\"e\":true},\"m\":{\"v\":\"100px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"textTransform\":\"uppercase\",\"whiteSpace\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"customCSS\":\"font-family:\'Daniel\';\\n\",\"type\":\"text\"},\"4\":{\"text\":\"Sp0rts\",\"alias\":\"Extreme\",\"uid\":4,\"size\":{\"width\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"19px\",\"e\":true},\"n\":{\"v\":\"19px\"},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"-3px\",\"e\":true},\"n\":{\"v\":\"-3px\"},\"t\":{\"v\":\"-3px\",\"e\":true},\"m\":{\"v\":\"-53px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\"},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":7,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":7,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"\",\"fontSize\":{\"d\":{\"v\":\"85px\",\"e\":true},\"n\":{\"v\":\"85px\"},\"t\":{\"v\":\"85px\",\"e\":true},\"m\":{\"v\":\"70px\",\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"100px\",\"e\":true},\"n\":{\"v\":\"100px\"},\"t\":{\"v\":\"100px\",\"e\":true},\"m\":{\"v\":\"100px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"textTransform\":\"uppercase\",\"whiteSpace\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"customCSS\":\"font-family:\'Daniel\';\\n\",\"type\":\"text\"},\"5\":{\"text\":\"Clothing & Gear Shop\",\"alias\":\"Clothing & Gear Shop\",\"uid\":5,\"size\":{\"width\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"20px\",\"e\":true},\"n\":{\"v\":\"20px\"},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"61px\",\"e\":true},\"n\":{\"v\":\"61px\"},\"t\":{\"v\":\"61px\",\"e\":true},\"m\":{\"v\":\"21px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\"},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":8,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":8,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"v\":\"30px\",\"e\":true},\"n\":{\"v\":\"30px\"},\"t\":{\"v\":\"30px\",\"e\":true},\"m\":{\"v\":\"24px\",\"e\":true}},\"fontWeight\":{\"d\":{\"v\":\"600\",\"e\":true},\"n\":{\"v\":\"600\"},\"t\":{\"v\":\"600\",\"e\":true},\"m\":{\"v\":\"600\",\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"30px\",\"e\":true},\"n\":{\"v\":\"30px\"},\"t\":{\"v\":\"30px\",\"e\":true},\"m\":{\"v\":\"30px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"type\":\"text\"},\"6\":{\"text\":\"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.\",\"alias\":\"Lorem ipsum dolor si...\",\"uid\":6,\"size\":{\"width\":{\"d\":{\"v\":\"549px\",\"e\":true},\"n\":{\"v\":\"549px\",\"e\":true},\"t\":{\"v\":\"549px\",\"e\":true},\"m\":{\"v\":\"282px\",\"e\":true}},\"height\":{\"d\":{\"v\":\"67px\",\"e\":true},\"n\":{\"v\":\"67px\",\"e\":true},\"t\":{\"v\":\"67px\",\"e\":true},\"m\":{\"e\":true}},\"originalWidth\":\"549px\",\"originalHeight\":\"67px\"},\"position\":{\"x\":{\"d\":{\"v\":\"20px\",\"e\":true},\"n\":{\"v\":\"20px\",\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"125px\",\"e\":true},\"n\":{\"v\":\"125px\",\"e\":true},\"t\":{\"v\":\"125px\",\"e\":true},\"m\":{\"v\":\"95px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\",\"e\":true},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":9,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":9,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"n\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"t\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"m\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"v\":\"18px\",\"e\":true},\"n\":{\"v\":\"18px\",\"e\":true},\"t\":{\"v\":\"18px\",\"e\":true},\"m\":{\"v\":\"13px\",\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"22px\",\"e\":true},\"n\":{\"v\":\"22px\",\"e\":true},\"t\":{\"v\":\"22px\",\"e\":true},\"m\":{\"v\":\"22px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\",\"e\":true},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"v\":\"normal\",\"e\":true},\"n\":{\"v\":\"normal\",\"e\":true},\"t\":{\"v\":\"normal\",\"e\":true},\"m\":{\"v\":\"normal\",\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"n\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"t\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"m\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"type\":\"text\"},\"8\":{\"subtype\":\"roundbutton\",\"text\":\"SHOP THE SALE\",\"alias\":\"Button\",\"uid\":8,\"size\":{\"width\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"24px\",\"e\":true},\"n\":{\"v\":\"24px\"},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"200px\",\"e\":true},\"n\":{\"v\":\"200px\"},\"t\":{\"v\":\"200px\",\"e\":true},\"m\":{\"v\":\"200px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\"},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":10,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":10,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"n\":{\"v\":\"rgba(255,255,255,1)\"},\"t\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"m\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"],\"e\":true},\"n\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"]},\"t\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"],\"e\":true},\"m\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Montserrat\",\"fontSize\":{\"d\":{\"v\":\"16px\",\"e\":true},\"n\":{\"v\":\"16px\"},\"t\":{\"v\":\"16px\",\"e\":true},\"m\":{\"v\":\"16px\",\"e\":true}},\"fontWeight\":{\"d\":{\"v\":\"700\",\"e\":true},\"n\":{\"v\":\"700\"},\"t\":{\"v\":\"700\",\"e\":true},\"m\":{\"v\":\"700\",\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"17px\",\"e\":true},\"n\":{\"v\":\"17px\"},\"t\":{\"v\":\"17px\",\"e\":true},\"m\":{\"v\":\"17px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"cursor\":\"pointer\",\"backgroundColor\":\"rgba(153,204,102,0.75)\",\"borderColor\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderStyle\":{\"d\":{\"v\":\"solid\"},\"n\":{\"v\":\"solid\"},\"t\":{\"v\":\"solid\"},\"m\":{\"v\":\"solid\"}},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"n\":{\"v\":\"rgba(255,255,255,1)\"},\"t\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"m\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true}}}},\"hover\":{\"usehover\":true,\"color\":\"rgba(255,255,255,1)\",\"backgroundColor\":\"rgba(153,204,102,1)\",\"borderColor\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderStyle\":\"solid\",\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"originX\":50,\"originY\":50,\"speed\":\"0\"},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"runtime\":{\"internalClass\":\"rev-btn\"},\"customCSS\":\"outline:none;\\nbox-shadow:none;\\nbox-sizing:border-box;\\n-moz-box-sizing:border-box;\\n-webkit-box-sizing:border-box;\\n\",\"type\":\"button\"}}', '{\"0\":\"\",\"version\":\"6.0.0\"}'),
 (2, 1, 2, '{\"title\":\"Slide\",\"bg\":{\"type\":\"image\",\"color\":\"#E7E7E7\",\"image\":\"https:\\/\\/modelox.vico.digital\\/wp-content\\/uploads\\/revslider\\/winter-sports-bg2.jpg\",\"video\":{\"args\":\"hd=1&wmode=opaque&showinfo=0&rel=0;\",\"argsVimeo\":\"title=0&byline=0&portrait=0&api=1\",\"volume\":\"\"}},\"thumb\":{\"dimension\":\"slider\"},\"timeline\":{\"delay\":\"\",\"slots\":[\"default\"],\"duration\":[600]},\"effects\":{\"parallax\":\"4\"}}', '{\"10\":{\"text\":\" \",\"alias\":\"Shape\",\"uid\":10,\"size\":{\"width\":{\"d\":{\"v\":\"100%\"},\"n\":{\"v\":\"100%\"},\"t\":{\"v\":\"100%\"},\"m\":{\"v\":\"100%\"}},\"height\":{\"d\":{\"v\":\"100%\"},\"n\":{\"v\":\"100%\"},\"t\":{\"v\":\"100%\"},\"m\":{\"v\":\"100%\"}},\"covermode\":\"cover\",\"originalWidth\":\"100%\",\"originalHeight\":\"100%\"},\"position\":{\"x\":{\"d\":{\"v\":\"4366px\",\"e\":true},\"n\":{\"v\":\"4041px\",\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"vertical\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"zIndex\":5,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":5,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"v\":300,\"e\":true}},\"lineHeight\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\",\"e\":true},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"rgba(255,255,255,0.50)\",\"borderColor\":\"rgba(0,0,0,0.50)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderStyle\":{\"d\":{\"v\":\"solid\"},\"n\":{\"v\":\"solid\"},\"t\":{\"v\":\"solid\"},\"m\":{\"v\":\"solid\"}},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}}},\"hover\":{\"color\":\"rgba(255,255,255,1)\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"originX\":50,\"originY\":50,\"speed\":\"0\"},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"runtime\":{\"internalClass\":\"tp-shape tp-shapewrapper\"},\"type\":\"shape\"},\"3\":{\"text\":\"Extreme\",\"alias\":\"Extreme\",\"uid\":3,\"size\":{\"width\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"20px\",\"e\":true},\"n\":{\"v\":\"20px\",\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"-90px\",\"e\":true},\"n\":{\"v\":\"-90px\",\"e\":true},\"t\":{\"v\":\"-90px\",\"e\":true},\"m\":{\"v\":\"-90px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\",\"e\":true},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":6,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":6,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"\",\"fontSize\":{\"d\":{\"v\":\"85px\",\"e\":true},\"n\":{\"v\":\"85px\",\"e\":true},\"t\":{\"v\":\"85px\",\"e\":true},\"m\":{\"v\":\"70px\",\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"100px\",\"e\":true},\"n\":{\"v\":\"100px\",\"e\":true},\"t\":{\"v\":\"100px\",\"e\":true},\"m\":{\"v\":\"100px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\",\"e\":true},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"textTransform\":\"uppercase\",\"whiteSpace\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"customCSS\":\"font-family:\'Daniel\';\\n\",\"type\":\"text\"},\"4\":{\"text\":\"Sp0rts\",\"alias\":\"Extreme\",\"uid\":4,\"size\":{\"width\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"19px\",\"e\":true},\"n\":{\"v\":\"19px\"},\"t\":{\"v\":\"1px\",\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"-3px\",\"e\":true},\"n\":{\"v\":\"-3px\"},\"t\":{\"v\":\"-3px\",\"e\":true},\"m\":{\"v\":\"-13px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\"},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":7,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":7,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"\",\"fontSize\":{\"d\":{\"v\":\"85px\",\"e\":true},\"n\":{\"v\":\"85px\"},\"t\":{\"v\":\"85px\",\"e\":true},\"m\":{\"v\":\"70px\",\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"100px\",\"e\":true},\"n\":{\"v\":\"100px\"},\"t\":{\"v\":\"100px\",\"e\":true},\"m\":{\"v\":\"100px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"textTransform\":\"uppercase\",\"whiteSpace\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"customCSS\":\"font-family:\'Daniel\';\\n\",\"type\":\"text\"},\"5\":{\"text\":\"Clothing & Gear Shop\",\"alias\":\"Clothing & Gear Shop\",\"uid\":5,\"size\":{\"width\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"20px\",\"e\":true},\"n\":{\"v\":\"20px\"},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"61px\",\"e\":true},\"n\":{\"v\":\"61px\"},\"t\":{\"v\":\"61px\",\"e\":true},\"m\":{\"v\":\"51px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\"},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":8,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":8,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"v\":\"30px\",\"e\":true},\"n\":{\"v\":\"30px\"},\"t\":{\"v\":\"30px\",\"e\":true},\"m\":{\"v\":\"24px\",\"e\":true}},\"fontWeight\":{\"d\":{\"v\":\"600\",\"e\":true},\"n\":{\"v\":\"600\"},\"t\":{\"v\":\"600\",\"e\":true},\"m\":{\"v\":\"600\",\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"30px\",\"e\":true},\"n\":{\"v\":\"30px\"},\"t\":{\"v\":\"30px\",\"e\":true},\"m\":{\"v\":\"30px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"n\":{\"v\":\"rgba(10,10,10,1)\"},\"t\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true},\"m\":{\"v\":\"rgba(10,10,10,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"type\":\"text\"},\"6\":{\"text\":\"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.\",\"alias\":\"Lorem ipsum dolor si...\",\"uid\":6,\"size\":{\"width\":{\"d\":{\"v\":\"549px\",\"e\":true},\"n\":{\"v\":\"420px\",\"e\":true},\"t\":{\"v\":\"420px\",\"e\":true},\"m\":{\"v\":\"311px\",\"e\":true}},\"height\":{\"d\":{\"v\":\"67px\",\"e\":true},\"n\":{\"v\":\"69px\",\"e\":true},\"t\":{\"v\":\"69px\",\"e\":true},\"m\":{\"v\":\"70px\",\"e\":true}},\"originalWidth\":\"549px\",\"originalHeight\":\"67px\"},\"position\":{\"x\":{\"d\":{\"v\":\"20px\",\"e\":true},\"n\":{\"v\":\"20px\",\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"125px\",\"e\":true},\"n\":{\"v\":\"125px\",\"e\":true},\"t\":{\"v\":\"125px\",\"e\":true},\"m\":{\"v\":\"118px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\",\"e\":true},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":9,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":9,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"n\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"t\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"m\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"v\":\"18px\",\"e\":true},\"n\":{\"v\":\"18px\",\"e\":true},\"t\":{\"v\":\"18px\",\"e\":true},\"m\":{\"v\":\"14px\",\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"n\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"22px\",\"e\":true},\"n\":{\"v\":\"22px\",\"e\":true},\"t\":{\"v\":\"22px\",\"e\":true},\"m\":{\"v\":\"22px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\",\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"v\":\"normal\",\"e\":true},\"n\":{\"v\":\"normal\",\"e\":true},\"t\":{\"v\":\"normal\",\"e\":true},\"m\":{\"v\":\"normal\",\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"n\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"t\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true},\"m\":{\"v\":\"rgba(51,51,51,1)\",\"e\":true}}}},\"hover\":{\"color\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"type\":\"text\"},\"8\":{\"subtype\":\"roundbutton\",\"text\":\"SHOP THE SALE\",\"alias\":\"Button\",\"uid\":8,\"size\":{\"width\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"24px\",\"e\":true},\"n\":{\"v\":\"24px\"},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"y\":{\"d\":{\"v\":\"200px\",\"e\":true},\"n\":{\"v\":\"200px\"},\"t\":{\"v\":\"200px\",\"e\":true},\"m\":{\"v\":\"200px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"t\":{\"v\":\"center\",\"e\":true},\"m\":{\"v\":\"center\",\"e\":true}},\"vertical\":{\"d\":{\"v\":\"middle\",\"e\":true},\"n\":{\"v\":\"middle\"},\"t\":{\"v\":\"middle\",\"e\":true},\"m\":{\"v\":\"middle\",\"e\":true}},\"zIndex\":10,\"position\":\"relative\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":10,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":0},{\"id\":\"frame_999\",\"start\":9000}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"#ffffff\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":0},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"timeline\":{\"start\":9000,\"startRelative\":8700,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"n\":{\"v\":\"rgba(255,255,255,1)\"},\"t\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"m\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"],\"e\":true},\"n\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"]},\"t\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"],\"e\":true},\"m\":{\"v\":[\"20px\",\"50px\",\"20px\",\"50px\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Montserrat\",\"fontSize\":{\"d\":{\"v\":\"16px\",\"e\":true},\"n\":{\"v\":\"16px\"},\"t\":{\"v\":\"16px\",\"e\":true},\"m\":{\"v\":\"16px\",\"e\":true}},\"fontWeight\":{\"d\":{\"v\":\"700\",\"e\":true},\"n\":{\"v\":\"700\"},\"t\":{\"v\":\"700\",\"e\":true},\"m\":{\"v\":\"700\",\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"17px\",\"e\":true},\"n\":{\"v\":\"17px\"},\"t\":{\"v\":\"17px\",\"e\":true},\"m\":{\"v\":\"17px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\",\"e\":true},\"m\":{\"v\":\"inherit\",\"e\":true}},\"cursor\":\"pointer\",\"backgroundColor\":\"rgba(153,204,102,0.75)\",\"borderColor\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderStyle\":{\"d\":{\"v\":\"solid\"},\"n\":{\"v\":\"solid\"},\"t\":{\"v\":\"solid\"},\"m\":{\"v\":\"solid\"}},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"t\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"n\":{\"v\":\"rgba(255,255,255,1)\"},\"t\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true},\"m\":{\"v\":\"rgba(255,255,255,1)\",\"e\":true}}}},\"hover\":{\"usehover\":true,\"color\":\"rgba(255,255,255,1)\",\"backgroundColor\":\"rgba(153,204,102,1)\",\"borderColor\":\"rgba(0,0,0,1)\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderStyle\":\"solid\",\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"originX\":50,\"originY\":50,\"speed\":\"0\"},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"runtime\":{\"internalClass\":\"rev-btn\"},\"customCSS\":\"outline:none;\\nbox-shadow:none;\\nbox-sizing:border-box;\\n-moz-box-sizing:border-box;\\n-webkit-box-sizing:border-box;\\n\",\"type\":\"button\"}}', '{\"0\":\"\",\"version\":\"6.0.0\"}');

/* INSERT TABLE DATA: wp8b_revslider_static_slides */
INSERT INTO `wp8b_revslider_static_slides` VALUES(21, 45, '{\"static\":{\"overflow\":\"visible\"},\"version\":\"6.2.0\"}', '{\"7\":{\"text\":\"Flowers\",\"alias\":\"Flowers\",\"uid\":7,\"media\":{\"imageUrl\":\"\"},\"size\":{\"width\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"473px\",\"e\":true},\"n\":{\"v\":\"357px\",\"e\":true},\"t\":{\"v\":\"228px\",\"e\":true},\"m\":{\"v\":\"134px\",\"e\":true}},\"y\":{\"d\":{\"v\":\"269px\",\"e\":true},\"n\":{\"v\":\"233px\",\"e\":true},\"t\":{\"v\":\"208px\",\"e\":true},\"m\":{\"v\":\"128px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"vertical\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"zIndex\":5,\"position\":\"relative\"},\"attributes\":{\"tabIndex\":\"\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":5,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":9.8956298828125},{\"id\":\"frame_999\",\"start\":9000.000915527300094254314899444580078125}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"transparent\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9.8956298828125,\"startRelative\":9.8956298828125},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9.8956298828125,\"startRelative\":9.8956298828125},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"transparent\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9000.000915527300094254314899444580078125,\"startRelative\":8690.105285644500327180139720439910888671875,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Playfair Display\",\"fontStyle\":true,\"fontSize\":{\"d\":{\"v\":\"88px\",\"e\":true},\"n\":{\"v\":\"88px\"},\"t\":{\"v\":\"88px\"},\"m\":{\"v\":\"60px\",\"e\":true}},\"fontWeight\":{\"d\":{\"v\":\"700\",\"e\":true},\"n\":{\"v\":\"700\"},\"t\":{\"v\":\"700\"},\"m\":{\"v\":\"700\",\"e\":true}},\"letterSpacing\":{\"d\":{\"v\":\"0px\",\"e\":true},\"n\":{\"v\":\"0px\"},\"t\":{\"v\":\"0px\"},\"m\":{\"v\":\"0px\",\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"95px\",\"e\":true},\"n\":{\"v\":\"95px\"},\"t\":{\"v\":\"95px\"},\"m\":{\"v\":\"95px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"e\":true},\"m\":{\"e\":true}}}},\"hover\":{\"color\":\"#000000\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"ease\":\"none\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"type\":\"text\",\"version\":\"6.2.0\"},\"8\":{\"text\":\"For your special occasions!\",\"alias\":\"For your special occ...\",\"uid\":8,\"media\":{\"imageUrl\":\"\"},\"size\":{\"width\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"247px\",\"e\":true},\"n\":{\"v\":\"150px\",\"e\":true},\"t\":{\"v\":\"25px\",\"e\":true},\"m\":{\"v\":\"52px\",\"e\":true}},\"y\":{\"d\":{\"v\":\"423px\",\"e\":true},\"n\":{\"v\":\"402px\",\"e\":true},\"t\":{\"v\":\"394px\",\"e\":true},\"m\":{\"v\":\"258px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"vertical\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"zIndex\":6,\"position\":\"relative\"},\"attributes\":{\"tabIndex\":\"\"},\"behavior\":{\"intelligentInherit\":false},\"group\":{\"groupOrder\":6,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":9.8956298828125},{\"id\":\"frame_999\",\"start\":9000.000915527300094254314899444580078125}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"transparent\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9.8956298828125,\"startRelative\":9.8956298828125},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9.8956298828125,\"startRelative\":9.8956298828125},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"transparent\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9000.000915527300094254314899444580078125,\"startRelative\":8690.105285644500327180139720439910888671875,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"v\":\"60px\",\"e\":true},\"n\":{\"v\":\"60px\"},\"t\":{\"v\":\"60px\"},\"m\":{\"v\":\"31\",\"e\":true}},\"fontWeight\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"letterSpacing\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"22px\",\"e\":true},\"n\":{\"v\":\"22px\"},\"t\":{\"v\":\"22px\"},\"m\":{\"v\":\"22px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\",\"e\":true}},\"backgroundColor\":\"transparent\",\"borderRadius\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"borderWidth\":[\"0\",\"0\",\"0\",\"0\"],\"whiteSpace\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"e\":true},\"m\":{\"e\":true}}}},\"hover\":{\"color\":\"#000000\",\"borderRadius\":{\"v\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"u\":\"px\"},\"borderWidth\":[\"0px\",\"0px\",\"0px\",\"0px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"ease\":\"none\",\"svg\":{\"color\":\"#000000\"}},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"type\":\"text\",\"version\":\"6.2.0\"},\"9\":{\"subtype\":\"roundbutton\",\"text\":\"SHOP NOW\",\"alias\":\"Button\",\"uid\":9,\"media\":{\"imageUrl\":\"\"},\"size\":{\"width\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"height\":{\"d\":{\"e\":true},\"m\":{\"e\":true}}},\"position\":{\"x\":{\"d\":{\"v\":\"541px\",\"e\":true},\"n\":{\"v\":\"427px\",\"e\":true},\"t\":{\"v\":\"300px\",\"e\":true},\"m\":{\"v\":\"153px\",\"e\":true}},\"y\":{\"d\":{\"v\":\"514px\",\"e\":true},\"n\":{\"v\":\"495px\",\"e\":true},\"t\":{\"v\":\"501px\",\"e\":true},\"m\":{\"v\":\"463px\",\"e\":true}},\"horizontal\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"vertical\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"zIndex\":7,\"position\":\"relative\"},\"attributes\":{\"tabIndex\":\"\"},\"behavior\":{\"autoResponsive\":false,\"intelligentInherit\":false,\"responsiveChilds\":false},\"group\":{\"groupOrder\":7,\"columnbreakat\":\"mobile\"},\"timeline\":{\"frameOrder\":[{\"id\":\"frame_1\",\"start\":9.8956298828125},{\"id\":\"frame_999\",\"start\":9000.000915527300094254314899444580078125}],\"frames\":{\"frame_0\":{\"alias\":\"Anim From\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"0\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"transparent\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9.8956298828125,\"startRelative\":9.8956298828125},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_1\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"y\":{\"d\":{\"v\":0},\"n\":{\"v\":0},\"t\":{\"v\":0},\"m\":{\"v\":0}},\"z\":0,\"scaleX\":\"1\",\"scaleY\":\"1\",\"opacity\":\"1\",\"rotationX\":0,\"rotationY\":0,\"rotationZ\":0,\"skewX\":\"0\",\"skewY\":\"0\",\"transformPerspective\":\"600\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9.8956298828125,\"startRelative\":9.8956298828125},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}},\"frame_999\":{\"alias\":\"Anim To\",\"transform\":{\"x\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"y\":{\"d\":{\"v\":\"inherit\"},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\"}},\"z\":\"inherit\",\"scaleX\":\"inherit\",\"scaleY\":\"inherit\",\"opacity\":\"0\",\"rotationX\":\"inherit\",\"rotationY\":\"inherit\",\"rotationZ\":\"inherit\",\"skewX\":\"inherit\",\"skewY\":\"inherit\",\"transformPerspective\":\"600\"},\"color\":{\"color\":\"transparent\"},\"timeline\":{\"ease\":\"power3.inOut\",\"start\":9000.000915527300094254314899444580078125,\"startRelative\":8690.105285644500327180139720439910888671875,\"endWithSlide\":true},\"chars\":{\"delay\":\"10\"},\"words\":{\"delay\":\"10\"},\"lines\":{\"delay\":\"10\"}}},\"loop\":{\"yoyo_move\":true,\"speed\":4000}},\"idle\":{\"color\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"margin\":{\"d\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true},\"n\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"t\":{\"v\":[\"0\",\"0\",\"0\",\"0\"]},\"m\":{\"v\":[\"0\",\"0\",\"0\",\"0\"],\"e\":true}},\"padding\":{\"d\":{\"v\":[\"12px\",\"35px\",\"12px\",\"35px\"],\"e\":true},\"n\":{\"v\":[\"12px\",\"35px\",\"12px\",\"35px\"]},\"t\":{\"v\":[\"12px\",\"35px\",\"12px\",\"35px\"]},\"m\":{\"v\":[\"12px\",\"35px\",\"12px\",\"35px\"],\"e\":true}},\"autolinebreak\":false,\"fontFamily\":\"Open Sans\",\"fontSize\":{\"d\":{\"v\":\"18px\",\"e\":true},\"n\":{\"v\":\"18px\"},\"t\":{\"v\":\"18px\"},\"m\":{\"v\":\"18px\",\"e\":true}},\"fontWeight\":{\"d\":{\"v\":\"300\",\"e\":true},\"n\":{\"v\":\"300\"},\"t\":{\"v\":\"300\"},\"m\":{\"v\":\"300\",\"e\":true}},\"letterSpacing\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"lineHeight\":{\"d\":{\"v\":\"18px\",\"e\":true},\"n\":{\"v\":\"18px\"},\"t\":{\"v\":\"18px\"},\"m\":{\"v\":\"18px\",\"e\":true}},\"textAlign\":{\"d\":{\"v\":\"inherit\",\"e\":true},\"n\":{\"v\":\"inherit\"},\"t\":{\"v\":\"inherit\"},\"m\":{\"v\":\"inherit\",\"e\":true}},\"cursor\":\"pointer\",\"backgroundColor\":\"rgba(0, 0, 0, 0)\",\"borderColor\":\"#ffffff\",\"borderRadius\":{\"v\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"u\":\"px\"},\"borderStyle\":{\"d\":{\"v\":\"solid\"},\"n\":{\"v\":\"solid\"},\"t\":{\"v\":\"solid\"},\"m\":{\"v\":\"solid\"}},\"borderWidth\":[\"1\",\"1\",\"1\",\"1\"],\"whiteSpace\":{\"d\":{\"e\":true},\"m\":{\"e\":true}},\"svg\":{\"color\":{\"d\":{\"e\":true},\"m\":{\"e\":true}}}},\"hover\":{\"usehover\":true,\"backgroundColor\":\"rgba(255, 255, 255, 0.49)\",\"borderColor\":\"#ffffff\",\"borderRadius\":{\"v\":[\"30px\",\"30px\",\"30px\",\"30px\"],\"u\":\"px\"},\"borderStyle\":\"solid\",\"borderWidth\":[\"1px\",\"1px\",\"1px\",\"1px\"],\"originX\":50,\"originY\":50,\"speed\":\"0\",\"ease\":\"none\"},\"actions\":{\"animationoverwrite\":\"wait\",\"triggerMemory\":\"keep\"},\"runtime\":{\"internalClass\":\"rev-btn\"},\"customCSS\":\"outline:none;\\nbox-shadow:none;\\nbox-sizing:border-box;\\n-moz-box-sizing:border-box;\\n-webkit-box-sizing:border-box;\\n\",\"type\":\"button\",\"version\":\"6.2.0\"}}', '{\"0\":\"\",\"version\":\"6.2.0\"}');

/* INSERT TABLE DATA: wp8b_revslider_static_slides_bkp */
INSERT INTO `wp8b_revslider_static_slides_bkp` VALUES(1, 2, '[]', '[]', '{\"version\":\"6.0.0\"}'),
 (2, 4, '[]', '[]', '{\"version\":\"6.0.0\"}'),
 (3, 5, '[]', '[]', '{\"version\":\"6.0.0\"}'),
 (4, 8, '{\"static\":{\"overflow\":\"visible\"}}', '[]', '{\"0\":\"\",\"version\":\"6.0.0\"}');

/* INSERT TABLE DATA: wp8b_term_relationships */
INSERT INTO `wp8b_term_relationships` VALUES(1, 1, 0),
 (131, 1, 0),
 (134, 1, 0),
 (143, 3, 0),
 (143, 17, 0),
 (143, 18, 0),
 (144, 3, 0),
 (144, 19, 0),
 (145, 3, 0),
 (145, 17, 0),
 (145, 20, 0),
 (146, 3, 0),
 (146, 18, 0),
 (147, 3, 0),
 (147, 19, 0),
 (148, 3, 0),
 (148, 21, 0),
 (150, 23, 0),
 (151, 23, 0),
 (152, 23, 0),
 (153, 23, 0),
 (154, 23, 0),
 (155, 24, 0),
 (156, 24, 0),
 (157, 24, 0),
 (158, 24, 0),
 (159, 24, 0),
 (160, 22, 0),
 (161, 22, 0),
 (162, 22, 0),
 (163, 22, 0),
 (164, 22, 0),
 (165, 22, 0),
 (166, 25, 0),
 (167, 25, 0),
 (168, 25, 0);

/* INSERT TABLE DATA: wp8b_term_taxonomy */
INSERT INTO `wp8b_term_taxonomy` VALUES(1, 1, 'category', '', 0, 3),
 (3, 501, 'product_type', '', 0, 6),
 (4, 502, 'product_type', '', 0, 0),
 (5, 503, 'product_type', '', 0, 0),
 (6, 504, 'product_type', '', 0, 0),
 (7, 505, 'product_visibility', '', 0, 0),
 (8, 506, 'product_visibility', '', 0, 0),
 (9, 507, 'product_visibility', '', 0, 0),
 (10, 508, 'product_visibility', '', 0, 0),
 (11, 509, 'product_visibility', '', 0, 0),
 (12, 510, 'product_visibility', '', 0, 0),
 (13, 511, 'product_visibility', '', 0, 0),
 (14, 512, 'product_visibility', '', 0, 0),
 (15, 513, 'product_visibility', '', 0, 0),
 (16, 514, 'product_cat', '', 0, 0),
 (17, 515, 'product_cat', '', 0, 2),
 (18, 19, 'product_cat', '', 0, 2),
 (19, 18, 'product_cat', '', 0, 2),
 (20, 20, 'product_cat', '', 0, 1),
 (21, 17, 'product_cat', '', 0, 1),
 (22, 516, 'nav_menu', '', 0, 6),
 (23, 517, 'nav_menu', '', 0, 5),
 (24, 518, 'nav_menu', '', 0, 5),
 (25, 519, 'nav_menu', '', 0, 3);

/* INSERT TABLE DATA: wp8b_termmeta */
INSERT INTO `wp8b_termmeta` VALUES(1, 515, 'order', '0'),
 (2, 19, 'order', '0'),
 (3, 515, 'product_count_product_cat', '2'),
 (4, 19, 'product_count_product_cat', '2'),
 (5, 18, 'order', '0'),
 (6, 18, 'product_count_product_cat', '2'),
 (7, 20, 'order', '0'),
 (8, 20, 'product_count_product_cat', '1'),
 (9, 17, 'order', '0'),
 (10, 17, 'product_count_product_cat', '1');

/* INSERT TABLE DATA: wp8b_terms */
INSERT INTO `wp8b_terms` VALUES(1, 'Uncategorized', 'uncategorized', 0),
 (515, 'Birthday', 'birthday', 0),
 (501, 'simple', 'simple', 0),
 (502, 'grouped', 'grouped', 0),
 (503, 'variable', 'variable', 0),
 (504, 'external', 'external', 0),
 (505, 'exclude-from-search', 'exclude-from-search', 0),
 (506, 'exclude-from-catalog', 'exclude-from-catalog', 0),
 (507, 'featured', 'featured', 0),
 (508, 'outofstock', 'outofstock', 0),
 (509, 'rated-1', 'rated-1', 0),
 (510, 'rated-2', 'rated-2', 0),
 (511, 'rated-3', 'rated-3', 0),
 (512, 'rated-4', 'rated-4', 0),
 (513, 'rated-5', 'rated-5', 0),
 (514, 'Sin categorizar', 'sin-categorizar', 0),
 (19, 'Congratulation', 'congratulation', 0),
 (18, 'Family Flowers', 'family-flowers', 0),
 (20, 'Wedding', 'wedding', 0),
 (17, 'Love and Romance', 'love-and-romance', 0),
 (516, 'Main Menu', 'main-menu', 0),
 (517, 'Follow Us', 'follow-us', 0),
 (518, 'Information', 'information', 0),
 (519, 'My Account', 'my-account', 0);

/* INSERT TABLE DATA: wp8b_tinvwl_lists */
INSERT INTO `wp8b_tinvwl_lists` VALUES(1, 1, '2020-05-05 11:51:58', '', 'share', 'default', '222325');

/* INSERT TABLE DATA: wp8b_usermeta */
INSERT INTO `wp8b_usermeta` VALUES(1, 1, 'nickname', 'demoweb'),
 (2, 1, 'first_name', ''),
 (3, 1, 'last_name', ''),
 (4, 1, 'description', ''),
 (5, 1, 'rich_editing', 'true'),
 (6, 1, 'syntax_highlighting', 'true'),
 (7, 1, 'comment_shortcuts', 'false'),
 (8, 1, 'admin_color', 'fresh'),
 (9, 1, 'use_ssl', '0'),
 (10, 1, 'show_admin_bar_front', 'true'),
 (11, 1, 'locale', ''),
 (12, 1, 'wp8b_capabilities', 'a:1:{s:13:\"administrator\";b:1;}'),
 (13, 1, 'wp8b_user_level', '10'),
 (14, 1, 'dismissed_wp_pointers', ''),
 (15, 1, 'show_welcome_panel', '1'),
 (16, 1, 'session_tokens', 'a:2:{s:64:\"b3c51eecdf892119f1305a2d40f43e5c9068aea8642578317dd20b9142d3916d\";a:4:{s:10:\"expiration\";i:1597243385;s:2:\"ip\";s:15:\"186.167.250.237\";s:2:\"ua\";s:114:\"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36\";s:5:\"login\";i:1597070585;}s:64:\"c0413d98d51b1172459159e8ec41010d585c9919b40ce4d59d968f24fab8648c\";a:4:{s:10:\"expiration\";i:1597333041;s:2:\"ip\";s:13:\"190.75.83.206\";s:2:\"ua\";s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36\";s:5:\"login\";i:1597160241;}}'),
 (17, 1, 'wp8b_user-settings', 'libraryContent=browse&editor=tinymce&unfold=1&mfold=o'),
 (18, 1, 'wp8b_user-settings-time', '1580358000'),
 (19, 1, 'wp8b_dashboard_quick_press_last_post_id', '18'),
 (20, 1, 'community-events-location', 'a:1:{s:2:\"ip\";s:11:\"190.75.83.0\";}'),
 (21, 1, 'duplicator_pro_created_format', '1'),
 (23, 1, 'wfls-last-login', '1597160249'),
 (32, 1, 'wc_last_active', '1597104000'),
 (33, 1, '_woocommerce_tracks_anon_id', 'woo:2Qm9keylXtdbUNZ4GV9acMIj');

/* INSERT TABLE DATA: wp8b_users */
INSERT INTO `wp8b_users` VALUES(1, 'demoweb', '$P$B1gUmlTkVhjKBVHlJcgjq60fPmDX.s0', 'demoweb', 'vicosolutions.com@gmail.com', '', '2020-01-06 12:44:36', '', 0, 'demoweb');

/* INSERT TABLE DATA: wp8b_wc_admin_note_actions */
INSERT INTO `wp8b_wc_admin_note_actions` VALUES(5, 5, 'yes-please', '¡Sí, por favor!', 'https://woocommerce.us8.list-manage.com/subscribe/post?u=2c1434dc56f9506bf3c3ecd21&amp;id=13860df971&amp;SIGNUPPAGE=plugin', 'actioned', 0),
 (2, 2, 'connect', 'Connect', '?page=wc-addons&section=helper', 'actioned', 0),
 (3, 3, 'add-a-product', 'Add a product', 'https://modelox.vico.digital/wp-admin/post-new.php?post_type=product', 'actioned', 1),
 (4, 4, 'learn-more', 'Aprende más', 'https://woocommerce.com/mobile/', 'actioned', 0),
 (6, 6, 'open-marketing-hub', 'Abrir centro de marketing', 'https://modelox.vico.digital/wp-admin/admin.php?page=wc-admin&path=/marketing', 'actioned', 0);

/* INSERT TABLE DATA: wp8b_wc_admin_notes */
INSERT INTO `wp8b_wc_admin_notes` VALUES(5, 'wc-admin-onboarding-email-marketing', 'info', 'en_US', 'Trucos, actualizaciones de productos e inspiración', 'Estamos aquí para ti - consigue trucos, actualizaciones de productos e inspiración en tu buzón', 'info', '{}', 'unactioned', 'woocommerce-admin', '2020-08-11 15:42:54', NULL, 0, 'plain', '', 0),
 (6, 'wc-admin-marketing-intro', 'info', 'en_US', 'Conecta con tu audiencia', 'Aumenta tu base de clientes e incrementa tus ventas con las herramientas de marketing creadas para WooCommerce.', 'info', '{}', 'unactioned', 'woocommerce-admin', '2020-08-11 15:42:54', NULL, 0, 'plain', '', 0),
 (2, 'wc-admin-wc-helper-connection', 'info', 'en_US', 'Connect to WooCommerce.com', 'Connect to get important product notifications and updates.', 'info', '{}', 'unactioned', 'woocommerce-admin', '2020-02-01 03:36:40', NULL, 0, '', NULL, 0),
 (3, 'wc-admin-add-first-product', 'info', 'en_US', 'Add your first product', 'Grow your revenue by adding products to your store. Add products manually, import from a sheet, or migrate from another platform.', 'product', '{}', 'unactioned', 'woocommerce-admin', '2020-02-01 16:49:38', NULL, 0, '', NULL, 0),
 (4, 'wc-admin-mobile-app', 'info', 'en_US', 'Instala la aplicación móvil WooCommerce', 'Instala la aplicación móvil de WooCommerce para gestionar pedidos, recibir avisos de ventas y ver métricas clave – allí donde estés.', 'phone', '{}', 'unactioned', 'woocommerce-admin', '2020-02-03 17:36:20', NULL, 0, '', NULL, 0);

/* INSERT TABLE DATA: wp8b_wc_category_lookup */
INSERT INTO `wp8b_wc_category_lookup` VALUES(514, 514);

/* INSERT TABLE DATA: wp8b_wc_customer_lookup */
INSERT INTO `wp8b_wc_customer_lookup` VALUES(1, NULL, '', 'yobell', 'yupanqui', 'yobell@gmail.com', '2020-02-01 17:18:14', NULL, 'VE', '1040', '10 calle', 'mirnda');

/* INSERT TABLE DATA: wp8b_wc_order_product_lookup */
INSERT INTO `wp8b_wc_order_product_lookup` VALUES(2, 25, 20, 0, 1, '2020-02-01 17:18:14', 1, '8', '8', '0', '0', '0', '0');

/* INSERT TABLE DATA: wp8b_wc_order_stats */
INSERT INTO `wp8b_wc_order_stats` VALUES(25, 0, '2020-02-01 17:18:14', '2020-02-01 17:18:14', 1, '8', '0', '0', '8', 0, 'wc-cancelled', 1);

/* INSERT TABLE DATA: wp8b_wc_tax_rate_classes */
INSERT INTO `wp8b_wc_tax_rate_classes` VALUES(1, 'Tasa reducida', 'tasa-reducida'),
 (2, 'Tasa cero', 'tasa-cero');

/* INSERT TABLE DATA: wp8b_wdi_themes */
INSERT INTO `wp8b_wdi_themes` VALUES(1, 'Instagram', '1', '#FFFFFF', '100%', '100%', '#FFFFFF', '#429fff', '0px', '5px', '0px', '#DDDDDD', 'left', '40', '0', '5px', '#0f4973', '400', '18px', 'normal', '3', '25', '10', '#ffffff', '#0f4973', '#0f4973', '18', '#0f4973', '#0f4973', '#ffffff', '', '5px', '0px', '', '40', '40', '', '0px', '', '', '#0f4973', '400', '18px', 'normal', '14px', '#25292c', '90', '#ffffff', '20', '10', '7', 'bottom', '#2a5b83', '4', '80', 'center', '#FFFFFF', '100', '14', '100', '16', '2', 'none', '#FFFFFF', 'none', '#2a5b83', '100', '20', '20', '-10', '-10', '15', '#FFFFFF', '#000000', '#000000', '#ffffff', 'tenweb-i-chevron', '#2a5b83', '80', 'none', '40', '40', '20', '#25292c', '#FFFFFF', '20', '0', 'none', '#FFFFFF', 'top', '0 1px', '1', 'solid', '#25292c', '0', '0', '#FFFFFF', '70', '20', '#FFFFFF', '#3B3B3B', 'top', 'right', '#3b3b3b', '80', '1', 'none', '#3b3b3b', '5', '5px', '15px', '#FFFFFF', 'segoe ui', 'bold', '13', '#FFFFFF', 'segoe ui', 'normal', '14', '30', '400', 'right', '#ffffff', '12', '#000000', 'segoe ui', '14', '#125688', '#002160', '10', '12', '1', 'none', '#666666', '0', '2px', '#333333', '#616161', '3px 10px', '1', 'none', '#666666', '3', '1', 'solid', '#125688', '#125688', '#000000', '5px', '5px', '#ffffff', '0px', '#FFFFFF', '#FFFFFF', '1', '#8a8d8e', '#8a8d8e', '14px', '#125688', '0', '#8e8e8e', '13px', '#125688', '50', '#FFFFFF', '25px', '', '5px', '0px', 'gray', '0px', '#FFFFFF', '#FFFFFF', '1', '#8a8d8e', '#8a8d8e', '14px', '#125688', '0', '#8e8e8e', '13px', '#125688', '50', '#FFFFFF', '25px', '', '5px', '0px', 'gray', '0px', '#FFFFFF', '#FFFFFF', '1', '#8a8d8e', '#8a8d8e', '16px', '#125688', '0', '#8e8e8e', '20px', '5px', '0px', 'gray', '0px', '#FFFFFF', '#FFFFFF', '1', '#8a8d8e', '#8a8d8e', '16px', '#125688', '0', '#8e8e8e', '20px', 'center', '4px', '#ffffff', '500px', '90px', '90px', '1px', '#0f4973', '#1e73be', '14px', 'transparent', '#0f4973', '18px', '15px', '#25292c', 'center', 'top', '', '', '', ''),
 (2, 'Elegant', '0', '#FFFFFF', '100%', '100%', '#FFFFFF', '#3cbac8', '0px', '5px', '0px', '#DDDDDD', 'left', '40', '0', '5px', '#686666', '400', '22px', 'normal', '7', '25', '10', '#ffffff', '#3cbac8', '#3cbac8', '18', '#3cbac8', '#ffffff', '#3cbac8', '', '5px', '0px', '', '40', '40', '', '0px', '', '', '#686666', '400', '22px', 'normal', '14px', '#ffffff', '80', '#000000', '20', '10', '7', 'bottom', '#3cbac8', '4', '80', 'center', '#FFFFFF', '100', '14', '100', '16', '2', 'none', '#FFFFFF', 'none', '#3cbac8', '100', '20', '20', '-10', '-10', '15', '#FFFFFF', '#3cbac8', '#2a5b83', '#ffffff', 'tenweb-i-chevron', '#3cbac8', '100', 'none', '40', '40', '20', '#ff4444', '#FFFFFF', '20', '0', 'none', '#FFFFFF', 'top', '0 1px', '1', 'solid', '#ffffff', '0', '0', '#FFFFFF', '40', '20', '#FFFFFF', '#3cbac8', 'top', 'right', '#3cbac8', '87', '1', 'none', '#3cbac8', '5', '5px', '15px', '#FFFFFF', 'segoe ui', 'bold', '13', '#FFFFFF', 'segoe ui', 'normal', '14', '30', '400', 'right', '#000000', '12', '#3cbac8', 'segoe ui', '14', '#ffffff', '#ff4444', '10', '12', '1', 'none', '#666666', '0', '2px', '#333333', '#616161', '3px 10px', '1', 'none', '#666666', '3', '1', 'ridge', '#ffffff', '#ffffff', '#ff4444', '5px', '0px', '#0a0909', '0px', '#FFFFFF', '#FFFFFF', '1', '#3cbac8', '#3cbac8', '14px', '#000000', '0', '#686666', '13px', '#3cbac8', '50', '#FFFFFF', '25px', '', '5px', '0px', '#0a0909', '0px', '#FFFFFF', '#FFFFFF', '1', '#3cbac8', '#3cbac8', '14px', '#000000', '0', '#686666', '13px', '#3cbac8', '50', '#FFFFFF', '25px', '', '5px', '0px', '#000000', '0px', '#FFFFFF', '#FFFFFF', '1', '#3cbac8', '#3cbac8', '16px', '#000000', '0', '#6866666', '20px', '5px', '0px', '#000000', '0px', '#FFFFFF', '#FFFFFF', '1', '#3cbac8', '#3cbac8', '16px', '#000000', '0', '#686666', '20px', 'center', '4px', '#3cbac8', '10px', '40px', '130px', '1px', '#ffffff', '#ffffff', '14px', '3cbac8', '#3cbac8', '18px', '15px', '#000000', 'center', 'top', '', '', '', '');

/* INSERT TABLE DATA: wp8b_wfconfig */
INSERT INTO `wp8b_wfconfig` VALUES('alertOn_update', '0', 'yes'),
 ('alertOn_scanIssues', '1', 'yes'),
 ('alertOn_throttle', '0', 'yes'),
 ('alertOn_block', '1', 'yes'),
 ('alertOn_loginLockout', '1', 'yes'),
 ('alertOn_breachLogin', '1', 'yes'),
 ('alertOn_lostPasswdForm', '1', 'yes'),
 ('alertOn_adminLogin', '1', 'yes'),
 ('alertOn_firstAdminLoginOnly', '0', 'yes'),
 ('alertOn_nonAdminLogin', '0', 'yes'),
 ('alertOn_firstNonAdminLoginOnly', '0', 'yes'),
 ('alertOn_wordfenceDeactivated', '1', 'yes'),
 ('alertOn_wafDeactivated', '1', 'yes'),
 ('liveTrafficEnabled', '0', 'yes'),
 ('advancedCommentScanning', '1', 'yes'),
 ('checkSpamIP', '1', 'yes'),
 ('spamvertizeCheck', '1', 'yes'),
 ('liveTraf_ignorePublishers', '1', 'yes'),
 ('liveTraf_displayExpandedRecords', '0', 'no'),
 ('scheduledScansEnabled', '1', 'yes'),
 ('lowResourceScansEnabled', '0', 'yes'),
 ('scansEnabled_checkGSB', '1', 'yes'),
 ('scansEnabled_checkHowGetIPs', '1', 'yes'),
 ('scansEnabled_core', '1', 'yes'),
 ('scansEnabled_themes', '0', 'yes'),
 ('scansEnabled_plugins', '0', 'yes'),
 ('scansEnabled_coreUnknown', '1', 'yes'),
 ('scansEnabled_malware', '1', 'yes'),
 ('scansEnabled_fileContents', '1', 'yes'),
 ('scansEnabled_fileContentsGSB', '1', 'yes'),
 ('scansEnabled_checkReadableConfig', '1', 'yes'),
 ('scansEnabled_suspectedFiles', '1', 'yes'),
 ('scansEnabled_posts', '1', 'yes'),
 ('scansEnabled_comments', '1', 'yes'),
 ('scansEnabled_suspiciousOptions', '1', 'yes'),
 ('scansEnabled_passwds', '1', 'yes'),
 ('scansEnabled_diskSpace', '1', 'yes'),
 ('scansEnabled_wafStatus', '1', 'yes'),
 ('scansEnabled_options', '1', 'yes'),
 ('scansEnabled_wpscan_fullPathDisclosure', '1', 'yes'),
 ('scansEnabled_wpscan_directoryListingEnabled', '1', 'yes'),
 ('scansEnabled_scanImages', '0', 'yes'),
 ('scansEnabled_highSense', '0', 'yes'),
 ('scansEnabled_oldVersions', '1', 'yes'),
 ('scansEnabled_suspiciousAdminUsers', '1', 'yes'),
 ('liveActivityPauseEnabled', '1', 'yes'),
 ('firewallEnabled', '1', 'yes'),
 ('blockFakeBots', '0', 'yes'),
 ('autoBlockScanners', '1', 'yes'),
 ('loginSecurityEnabled', '1', 'yes'),
 ('loginSec_strongPasswds_enabled', '1', 'yes'),
 ('loginSec_breachPasswds_enabled', '1', 'yes'),
 ('loginSec_lockInvalidUsers', '0', 'yes'),
 ('loginSec_maskLoginErrors', '1', 'yes'),
 ('loginSec_blockAdminReg', '1', 'yes'),
 ('loginSec_disableAuthorScan', '1', 'yes'),
 ('loginSec_disableOEmbedAuthor', '0', 'yes'),
 ('loginSec_requireAdminTwoFactor', '0', 'yes'),
 ('notification_updatesNeeded', '1', 'yes'),
 ('notification_securityAlerts', '1', 'yes'),
 ('notification_promotions', '1', 'yes'),
 ('notification_blogHighlights', '1', 'yes'),
 ('notification_productUpdates', '1', 'yes'),
 ('notification_scanStatus', '1', 'yes'),
 ('other_hideWPVersion', '0', 'yes'),
 ('other_blockBadPOST', '0', 'yes'),
 ('other_scanComments', '1', 'yes'),
 ('other_pwStrengthOnUpdate', '1', 'yes'),
 ('other_WFNet', '1', 'yes'),
 ('other_scanOutside', '0', 'yes'),
 ('other_bypassLitespeedNoabort', '0', 'yes'),
 ('deleteTablesOnDeact', '0', 'yes'),
 ('autoUpdate', '1', 'yes'),
 ('startScansRemotely', '0', 'yes'),
 ('disableConfigCaching', '0', 'yes'),
 ('addCacheComment', '0', 'yes'),
 ('disableCodeExecutionUploads', '0', 'yes'),
 ('allowHTTPSCaching', '0', 'yes'),
 ('debugOn', '0', 'yes'),
 ('email_summary_enabled', '1', 'yes'),
 ('email_summary_dashboard_widget_enabled', '1', 'yes'),
 ('ssl_verify', '1', 'yes'),
 ('ajaxWatcherDisabled_front', '0', 'yes'),
 ('ajaxWatcherDisabled_admin', '0', 'yes'),
 ('wafAlertOnAttacks', '1', 'yes'),
 ('disableWAFIPBlocking', '0', 'yes'),
 ('showAdminBarMenu', '1', 'yes'),
 ('displayTopLevelOptions', '1', 'yes'),
 ('displayTopLevelBlocking', '0', 'yes'),
 ('displayTopLevelLiveTraffic', '0', 'yes'),
 ('displayAutomaticBlocks', '1', 'yes'),
 ('allowLegacy2FA', '0', 'yes'),
 ('scan_include_extra', '', 'yes'),
 ('alertEmails', 'vicosolutions.com@gmail.com', 'yes'),
 ('liveTraf_ignoreUsers', '', 'yes'),
 ('liveTraf_ignoreIPs', '', 'yes'),
 ('liveTraf_ignoreUA', '', 'yes'),
 ('maxMem', '256', 'yes'),
 ('scan_exclude', '', 'yes'),
 ('scan_maxIssues', '1000', 'yes'),
 ('scan_maxDuration', '', 'yes'),
 ('whitelisted', '', 'yes'),
 ('whitelistedServices', '{}', 'yes'),
 ('bannedURLs', '', 'yes'),
 ('maxExecutionTime', '0', 'yes'),
 ('howGetIPs', '', 'yes'),
 ('actUpdateInterval', '2', 'yes'),
 ('alert_maxHourly', '0', 'yes'),
 ('loginSec_userBlacklist', '', 'yes'),
 ('liveTraf_maxRows', '2000', 'yes'),
 ('liveTraf_maxAge', '30', 'yes'),
 ('neverBlockBG', 'neverBlockVerified', 'yes'),
 ('loginSec_countFailMins', '240', 'yes'),
 ('loginSec_lockoutMins', '240', 'yes'),
 ('loginSec_strongPasswds', 'pubs', 'yes'),
 ('loginSec_breachPasswds', 'admins', 'yes'),
 ('loginSec_maxFailures', '20', 'yes'),
 ('loginSec_maxForgotPasswd', '20', 'yes'),
 ('maxGlobalRequests', 'DISABLED', 'yes'),
 ('maxGlobalRequests_action', 'throttle', 'yes'),
 ('maxRequestsCrawlers', 'DISABLED', 'yes'),
 ('maxRequestsCrawlers_action', 'throttle', 'yes'),
 ('maxRequestsHumans', 'DISABLED', 'yes'),
 ('maxRequestsHumans_action', 'throttle', 'yes'),
 ('max404Crawlers', 'DISABLED', 'yes'),
 ('max404Crawlers_action', 'throttle', 'yes'),
 ('max404Humans', 'DISABLED', 'yes'),
 ('max404Humans_action', 'throttle', 'yes'),
 ('blockedTime', '300', 'yes'),
 ('email_summary_interval', 'weekly', 'yes'),
 ('email_summary_excluded_directories', 'wp-content/cache,wp-content/wflogs', 'yes'),
 ('allowed404s', '/favicon.ico\n/apple-touch-icon*.png\n/*@2x.png\n/browserconfig.xml', 'yes'),
 ('wafAlertWhitelist', '', 'yes'),
 ('wafAlertInterval', '600', 'yes'),
 ('wafAlertThreshold', '100', 'yes'),
 ('howGetIPs_trusted_proxies', '', 'yes'),
 ('scanType', 'standard', 'yes'),
 ('manualScanType', 'onceDaily', 'yes'),
 ('schedStartHour', '12', 'yes'),
 ('schedMode', 'auto', 'yes'),
 ('cbl_loggedInBlocked', '', 'yes'),
 ('cbl_action', 'block', 'yes'),
 ('cbl_redirURL', '', 'yes'),
 ('cbl_bypassRedirURL', '', 'yes'),
 ('cbl_bypassRedirDest', '', 'yes'),
 ('cbl_bypassViewURL', '', 'yes'),
 ('loginSec_enableSeparateTwoFactor', '', 'yes'),
 ('blockCustomText', '', 'yes'),
 ('alertOn_severityLevel', '25', 'yes'),
 ('apiKey', '5e64b01ef0cc2279a2c32640b97803b26a7adb32eb4243e5693b833a4da7f45074d0b996778fb685660ee4e16dba1ae011962a857c69f9ed1874908a17a53e96962c855e42f8031618308804733689e7', 'yes'),
 ('keyType', 'free', 'yes'),
 ('isPaid', '', 'yes'),
 ('betaThreatDefenseFeed', '0', 'yes'),
 ('timeoffset_wf_updated', '1597160008', 'yes'),
 ('cacheType', 'disabled', 'yes'),
 ('detectProxyRecommendation', 'REMOTE_ADDR', 'no'),
 ('dismissAutoPrependNotice', '0', 'yes'),
 ('onboardingAttempt1', 'license', 'yes'),
 ('onboardingAttempt2', '', 'no'),
 ('onboardingAttempt3', '', 'no'),
 ('onboardingAttempt3Initial', '0', 'yes'),
 ('needsNewTour_dashboard', '0', 'yes'),
 ('needsNewTour_firewall', '0', 'yes'),
 ('needsNewTour_scan', '0', 'yes'),
 ('needsNewTour_blocking', '1', 'yes'),
 ('needsNewTour_livetraffic', '0', 'yes'),
 ('needsNewTour_loginsecurity', '0', 'yes'),
 ('needsUpgradeTour_dashboard', '0', 'yes'),
 ('needsUpgradeTour_firewall', '0', 'yes'),
 ('needsUpgradeTour_scan', '0', 'yes'),
 ('needsUpgradeTour_blocking', '0', 'yes'),
 ('needsUpgradeTour_livetraffic', '0', 'yes'),
 ('needsUpgradeTour_loginsecurity', '0', 'yes'),
 ('supportContent', '{\"top\":[{\"title\":\"Blocking Troubleshooting\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/blocking\\/troubleshooting\\/\",\"order\":0},{\"title\":\"Optimizing The Firewall\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/optimizing-the-firewall\\/\",\"order\":1},{\"title\":\"Wordfence Web Application Firewall (WAF)\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/\",\"order\":2},{\"title\":\"Scan Troubleshooting\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/scan\\/troubleshooting\\/\",\"order\":3},{\"title\":\"Wordfence and LiteSpeed\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/system-requirements\\/litespeed\\/\",\"order\":4},{\"title\":\"Two-Factor Authentication\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/two-factor-authentication\\/\",\"order\":5},{\"title\":\"Firewall Learning Mode\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/learning-mode\\/\",\"order\":6},{\"title\":\"Scan Results\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/scan\\/scan-results\\/\",\"order\":7},{\"title\":\"I am locked out of my site\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/blocking\\/#i-am-locked-out-of-my-site\",\"order\":8},{\"title\":\"PHP Fatal error: Failed opening required wordfence-waf.php\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/#php-fatal-error-failed-opening-required-wordfence-waf-php\",\"order\":9}],\"all\":[{\"title\":\"Wordfence Central\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/\",\"excerpt\":\"Wordfence Central provides a powerful and efficient way to manage the security of many WordPress sites via a single interface.\",\"children\":[{\"title\":\"Using the Settings page\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/settings\\/\",\"order\":0},{\"title\":\"Connecting your sites to Wordfence Central\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/connect\\/\",\"order\":1},{\"title\":\"Setting up two-factor authentication\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/2fa\\/\",\"order\":2},{\"title\":\"Using the Dashboard page\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/central\\/\",\"order\":3},{\"title\":\"Viewing scan Findings\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/findings\\/\",\"order\":4},{\"title\":\"Using the Configuration page\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/configuration\\/\",\"order\":5},{\"title\":\"Using Wordfence plugin options Templates\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/central\\/templates\\/\",\"order\":6}],\"order\":0},{\"title\":\"Dashboard\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/dashboard\\/\",\"excerpt\":\"The Wordfence Dashboard provides insight into the current state of your site’s security.\",\"children\":[{\"title\":\"Options\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/dashboard\\/options\\/\",\"order\":0},{\"title\":\"Alerts\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/dashboard\\/alerts\\/\",\"order\":1}],\"order\":1},{\"title\":\"Firewall\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/\",\"excerpt\":\"The Wordfence Web Application Firewall is a PHP based, application level firewall that filters out malicious requests to your site. \",\"children\":[{\"title\":\"Optimizing\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/optimizing-the-firewall\\/\",\"order\":0},{\"title\":\"Learning Mode\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/learning-mode\\/\",\"order\":1},{\"title\":\"Statistics\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/statistics\\/\",\"order\":2},{\"title\":\"Options\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/options\\/\",\"order\":3},{\"title\":\"MySQLi storage engine\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/mysqli-storage-engine\\/\",\"order\":4},{\"title\":\"Brute Force Protection\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/brute-force\\/\",\"order\":5},{\"title\":\"Rate Limiting\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/rate-limiting\\/\",\"order\":6},{\"title\":\"Troubleshooting\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/firewall\\/troubleshooting\\/\",\"order\":7}],\"order\":2},{\"title\":\"Blocking\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/blocking\\/\",\"excerpt\":\"Aside from the Firewall rules that protect against SQL-injection, XSS and more, Wordfence also has custom features for additional blocking. \",\"children\":[{\"title\":\"Country Blocking\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/blocking\\/country-blocking\\/\",\"order\":0},{\"title\":\"Blocking Troubleshooting\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/blocking\\/troubleshooting\\/\",\"order\":1}],\"order\":3},{\"title\":\"Scan\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/scan\\/\",\"excerpt\":\"A Wordfence scan examines all files on your WordPress website looking for malicious code, backdoors, shells that hackers have installed, known malicious URLs and known patterns of infections.\",\"children\":[{\"title\":\"Options\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/scan\\/options\\/\",\"order\":0},{\"title\":\"Results\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/scan\\/scan-results\\/\",\"order\":1},{\"title\":\"Scheduling\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/scan\\/scheduling\\/\",\"order\":2},{\"title\":\"Troubleshooting\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/scan\\/troubleshooting\\/\",\"order\":3}],\"order\":4},{\"title\":\"Tools\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/\",\"excerpt\":\"Wordfence Tools include Two Factor Authentication, Whois Lookup, Password Audit, Live Traffic and Diagnostics.\",\"children\":[{\"title\":\"Import\\/Export\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/import-export\\/\",\"order\":0},{\"title\":\"Password Auditing\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/password-auditing\\/\",\"order\":1},{\"title\":\"Whois Lookup\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/whois-lookup\\/\",\"order\":2},{\"title\":\"Diagnostics\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/diagnostics\\/\",\"order\":3},{\"title\":\"Live Traffic\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/live-traffic\\/\",\"order\":4},{\"title\":\"Two-Factor Authentication\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/two-factor-authentication\\/\",\"order\":5},{\"title\":\"Legacy Two-Factor Authentication\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/tools\\/legacy-two-factor-authentication\\/\",\"order\":6}],\"order\":5},{\"title\":\"Login Security\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/login-security\\/\",\"excerpt\":\"The Login Security page currently contains settings for two-factor authentication (2FA) and reCAPTCHA. In a future Wordfence version, existing login-related features will also move to the same page.\",\"order\":6},{\"title\":\"Advanced\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/\",\"excerpt\":\"If you want to know more about the technical details of Wordfence, you\'ll find the answers in this section.\",\"children\":[{\"title\":\"System requirements\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/system-requirements\\/\",\"order\":0},{\"title\":\"Changelog\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/changelog\\/\",\"order\":1},{\"title\":\"Remove or Reset\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/remove-or-reset\\/\",\"order\":2},{\"title\":\"Technical Details\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/technical-details\\/\",\"order\":3},{\"title\":\"Constants\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/constants\\/\",\"order\":4},{\"title\":\"Wordfence API\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/wordfence-api\\/\",\"order\":5},{\"title\":\"Troubleshooting\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/advanced\\/troubleshooting\\/\",\"order\":6}],\"order\":7},{\"title\":\"Wordfence Premium\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/premium\\/\",\"excerpt\":\"Wordfence Premium comes with an IP Blacklist, Real Time Protection and much more.\",\"children\":[{\"title\":\"Account\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/premium\\/account\\/\",\"order\":0},{\"title\":\"Pricing\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/premium\\/pricing\\/\",\"order\":1},{\"title\":\"License Key\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/premium\\/api-key\\/\",\"order\":2}],\"order\":8},{\"title\":\"Wordfence and GDPR - General Data Protection Regulation\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/general-data-protection-regulation\\/\",\"excerpt\":\"Defiant, the company behind Wordfence, has updated its terms of use, privacy policies and software, as well as made available a data processing agreement to meet GDPR compliance. Customers must review and agree to updated terms in order to continue using our products and services. We also provide a data processing agreement if you qualify as a data controller under the GDPR.\",\"order\":9},{\"title\":\"Site Cleaning and Security Audits\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/security-services\\/\",\"excerpt\":\"Let one of our Security Analysts help you clean your infected site or inspect it for vulnerabilities.\",\"order\":10},{\"title\":\"Login Security Plugin\",\"permalink\":\"https:\\/\\/www.wordfence.com\\/help\\/login-security-plugin\\/\",\"excerpt\":\"The Wordfence Login Security plugin contains a subset of the features found in the full Wordfence plugin: Two-factor Authentication, XML-RPC Protection and Login Page CAPTCHA. It is ideal for sites that need login security functionality but either can’t or don’t want to run the full Wordfence plugin.\",\"order\":11}]}', 'yes'),
 ('supportHash', 'cd4586d45a3b5b64878637ae274e90636206e42f776f8d456a6203a6bf9eed63', 'yes'),
 ('whitelistPresets', '{\"wordfence\":{\"n\":\"Wordfence\",\"h\":true,\"d\":true,\"f\":true,\"r\":[\"54.68.32.247\",\"69.46.36.0\\/27\",\"2605:2400:0104:0100::\\/56\"]},\"sucuri\":{\"n\":\"Sucuri\",\"d\":true,\"r\":[\"97.74.127.171\",\"69.164.203.172\",\"173.230.128.135\",\"66.228.34.49\",\"66.228.40.185\",\"50.116.36.92\",\"50.116.36.93\",\"50.116.3.171\",\"198.58.96.212\",\"50.116.63.221\",\"192.155.92.112\",\"192.81.128.31\",\"198.58.106.244\",\"192.155.95.139\",\"23.239.9.227\",\"198.58.112.103\",\"192.155.94.43\",\"162.216.16.33\",\"173.255.233.124\",\"173.255.233.124\",\"192.155.90.179\",\"50.116.41.217\",\"192.81.129.227\",\"198.58.111.80\",\"162.216.19.183\"]},\"facebook\":{\"n\":\"Facebook\",\"d\":true,\"r\":[\"69.63.176.0\\/20\",\"66.220.144.0\\/20\",\"66.220.144.0\\/21\",\"69.63.184.0\\/21\",\"69.63.176.0\\/21\",\"74.119.76.0\\/22\",\"69.171.255.0\\/24\",\"173.252.64.0\\/18\",\"69.171.224.0\\/19\",\"69.171.224.0\\/20\",\"103.4.96.0\\/22\",\"69.63.176.0\\/24\",\"173.252.64.0\\/19\",\"173.252.70.0\\/24\",\"31.13.64.0\\/18\",\"31.13.24.0\\/21\",\"66.220.152.0\\/21\",\"66.220.159.0\\/24\",\"69.171.239.0\\/24\",\"69.171.240.0\\/20\",\"31.13.64.0\\/19\",\"31.13.64.0\\/24\",\"31.13.65.0\\/24\",\"31.13.67.0\\/24\",\"31.13.68.0\\/24\",\"31.13.69.0\\/24\",\"31.13.70.0\\/24\",\"31.13.71.0\\/24\",\"31.13.72.0\\/24\",\"31.13.73.0\\/24\",\"31.13.74.0\\/24\",\"31.13.75.0\\/24\",\"31.13.76.0\\/24\",\"31.13.77.0\\/24\",\"31.13.96.0\\/19\",\"31.13.66.0\\/24\",\"173.252.96.0\\/19\",\"69.63.178.0\\/24\",\"31.13.78.0\\/24\",\"31.13.79.0\\/24\",\"31.13.80.0\\/24\",\"31.13.82.0\\/24\",\"31.13.83.0\\/24\",\"31.13.84.0\\/24\",\"31.13.85.0\\/24\",\"31.13.86.0\\/24\",\"31.13.87.0\\/24\",\"31.13.88.0\\/24\",\"31.13.89.0\\/24\",\"31.13.90.0\\/24\",\"31.13.91.0\\/24\",\"31.13.92.0\\/24\",\"31.13.93.0\\/24\",\"31.13.94.0\\/24\",\"31.13.95.0\\/24\",\"69.171.253.0\\/24\",\"69.63.186.0\\/24\",\"31.13.81.0\\/24\",\"179.60.192.0\\/22\",\"179.60.192.0\\/24\",\"179.60.193.0\\/24\",\"179.60.194.0\\/24\",\"179.60.195.0\\/24\",\"185.60.216.0\\/22\",\"45.64.40.0\\/22\",\"185.60.216.0\\/24\",\"185.60.217.0\\/24\",\"185.60.218.0\\/24\",\"185.60.219.0\\/24\",\"129.134.0.0\\/16\",\"157.240.0.0\\/16\",\"157.240.8.0\\/24\",\"157.240.0.0\\/24\",\"157.240.1.0\\/24\",\"157.240.2.0\\/24\",\"157.240.3.0\\/24\",\"157.240.4.0\\/24\",\"157.240.5.0\\/24\",\"157.240.6.0\\/24\",\"157.240.7.0\\/24\",\"157.240.9.0\\/24\",\"157.240.10.0\\/24\",\"157.240.16.0\\/24\",\"157.240.19.0\\/24\",\"157.240.11.0\\/24\",\"157.240.12.0\\/24\",\"157.240.13.0\\/24\",\"157.240.14.0\\/24\",\"157.240.15.0\\/24\",\"157.240.17.0\\/24\",\"157.240.18.0\\/24\",\"157.240.20.0\\/24\",\"157.240.21.0\\/24\",\"157.240.22.0\\/24\",\"157.240.23.0\\/24\",\"157.240.0.0\\/17\",\"69.171.250.0\\/24\",\"157.240.24.0\\/24\",\"157.240.25.0\\/24\",\"199.201.64.0\\/24\",\"199.201.65.0\\/24\",\"199.201.64.0\\/22\",\"204.15.20.0\\/22\",\"157.240.192.0\\/24\",\"129.134.0.0\\/17\",\"204.15.20.0\\/22\",\"69.63.176.0\\/20\",\"69.63.176.0\\/21\",\"69.63.184.0\\/21\",\"66.220.144.0\\/20\",\"69.63.176.0\\/20\",\"2620:0:1c00::\\/40\",\"2a03:2880::\\/32\",\"2a03:2880:fffe::\\/48\",\"2a03:2880:ffff::\\/48\",\"2620:0:1cff::\\/48\",\"2a03:2880:f000::\\/48\",\"2a03:2880:f001::\\/48\",\"2a03:2880:f002::\\/48\",\"2a03:2880:f003::\\/48\",\"2a03:2880:f004::\\/48\",\"2a03:2880:f005::\\/48\",\"2a03:2880:f006::\\/48\",\"2a03:2880:f007::\\/48\",\"2a03:2880:f008::\\/48\",\"2a03:2880:f009::\\/48\",\"2a03:2880:f00a::\\/48\",\"2a03:2880:f00b::\\/48\",\"2a03:2880:f00c::\\/48\",\"2a03:2880:f00d::\\/48\",\"2a03:2880:f00e::\\/48\",\"2a03:2880:f00f::\\/48\",\"2a03:2880:f010::\\/48\",\"2a03:2880:f011::\\/48\",\"2a03:2880:f012::\\/48\",\"2a03:2880:f013::\\/48\",\"2a03:2880:f014::\\/48\",\"2a03:2880:f015::\\/48\",\"2a03:2880:f016::\\/48\",\"2a03:2880:f017::\\/48\",\"2a03:2880:f018::\\/48\",\"2a03:2880:f019::\\/48\",\"2a03:2880:f01a::\\/48\",\"2a03:2880:f01b::\\/48\",\"2a03:2880:f01c::\\/48\",\"2a03:2880:f01d::\\/48\",\"2a03:2880:f01e::\\/48\",\"2a03:2880:f01f::\\/48\",\"2a03:2880:1000::\\/36\",\"2a03:2880:2000::\\/36\",\"2a03:2880:3000::\\/36\",\"2a03:2880:4000::\\/36\",\"2a03:2880:5000::\\/36\",\"2a03:2880:6000::\\/36\",\"2a03:2880:7000::\\/36\",\"2a03:2880:f020::\\/48\",\"2a03:2880:f021::\\/48\",\"2a03:2880:f022::\\/48\",\"2a03:2880:f023::\\/48\",\"2a03:2880:f024::\\/48\",\"2a03:2880:f025::\\/48\",\"2a03:2880:f026::\\/48\",\"2a03:2880:f027::\\/48\",\"2a03:2880:f028::\\/48\",\"2a03:2880:f029::\\/48\",\"2a03:2880:f02b::\\/48\",\"2a03:2880:f02c::\\/48\",\"2a03:2880:f02d::\\/48\",\"2a03:2880:f02e::\\/48\",\"2a03:2880:f02f::\\/48\",\"2a03:2880:f030::\\/48\",\"2a03:2880:f031::\\/48\",\"2a03:2880:f032::\\/48\",\"2a03:2880:f033::\\/48\",\"2a03:2880:f034::\\/48\",\"2a03:2880:f035::\\/48\",\"2a03:2880:f036::\\/48\",\"2a03:2880:f037::\\/48\",\"2a03:2880:f038::\\/48\",\"2a03:2880:f039::\\/48\",\"2a03:2880:f03a::\\/48\",\"2a03:2880:f03b::\\/48\",\"2a03:2880:f03c::\\/48\",\"2a03:2880:f03d::\\/48\",\"2a03:2880:f03e::\\/48\",\"2a03:2880:f03f::\\/48\",\"2401:db00::\\/32\",\"2a03:2880::\\/36\",\"2803:6080::\\/32\",\"2a03:2880:f100::\\/48\",\"2a03:2880:f200::\\/48\",\"2a03:2880:f101::\\/48\",\"2a03:2880:f201::\\/48\",\"2a03:2880:f102::\\/48\",\"2a03:2880:f202::\\/48\",\"2a03:2880:f103::\\/48\",\"2a03:2880:f203::\\/48\",\"2a03:2880:f104::\\/48\",\"2a03:2880:f204::\\/48\",\"2a03:2880:f107::\\/48\",\"2a03:2880:f207::\\/48\",\"2a03:2880:f108::\\/48\",\"2a03:2880:f208::\\/48\",\"2a03:2880:f109::\\/48\",\"2a03:2880:f209::\\/48\",\"2a03:2880:f10a::\\/48\",\"2a03:2880:f20a::\\/48\",\"2a03:2880:f10b::\\/48\",\"2a03:2880:f20b::\\/48\",\"2a03:2880:f10d::\\/48\",\"2a03:2880:f20d::\\/48\",\"2a03:2880:f10e::\\/48\",\"2a03:2880:f20e::\\/48\",\"2a03:2880:f10f::\\/48\",\"2a03:2880:f20f::\\/48\",\"2a03:2880:f110::\\/48\",\"2a03:2880:f210::\\/48\",\"2a03:2880:f111::\\/48\",\"2a03:2880:f211::\\/48\",\"2a03:2880:f112::\\/48\",\"2a03:2880:f212::\\/48\",\"2a03:2880:f114::\\/48\",\"2a03:2880:f214::\\/48\",\"2a03:2880:f115::\\/48\",\"2a03:2880:f215::\\/48\",\"2a03:2880:f116::\\/48\",\"2a03:2880:f216::\\/48\",\"2a03:2880:f117::\\/48\",\"2a03:2880:f217::\\/48\",\"2a03:2880:f118::\\/48\",\"2a03:2880:f218::\\/48\",\"2a03:2880:f119::\\/48\",\"2a03:2880:f219::\\/48\",\"2a03:2880:f11a::\\/48\",\"2a03:2880:f21a::\\/48\",\"2a03:2880:f11f::\\/48\",\"2a03:2880:f21f::\\/48\",\"2a03:2880:f121::\\/48\",\"2a03:2880:f221::\\/48\",\"2a03:2880:f122::\\/48\",\"2a03:2880:f222::\\/48\",\"2a03:2880:f123::\\/48\",\"2a03:2880:f223::\\/48\",\"2a03:2880:f10c::\\/48\",\"2a03:2880:f20c::\\/48\",\"2a03:2880:f126::\\/48\",\"2a03:2880:f226::\\/48\",\"2a03:2880:f105::\\/48\",\"2a03:2880:f205::\\/48\",\"2a03:2880:f125::\\/48\",\"2a03:2880:f225::\\/48\",\"2a03:2880:f106::\\/48\",\"2a03:2880:f206::\\/48\",\"2a03:2880:f11b::\\/48\",\"2a03:2880:f21b::\\/48\",\"2a03:2880:f113::\\/48\",\"2a03:2880:f213::\\/48\",\"2a03:2880:f11c::\\/48\",\"2a03:2880:f21c::\\/48\",\"2a03:2880:f128::\\/48\",\"2a03:2880:f228::\\/48\",\"2a03:2880:f02a::\\/48\",\"2a03:2880:f12a::\\/48\",\"2a03:2880:f22a::\\/48\",\"2a03:2880:f12f::\\/48\",\"2a03:2880:f22f::\\/48\",\"2a03:2880:f11d::\\/48\",\"2a03:2880:f11e::\\/48\",\"2a03:2880:f120::\\/48\",\"2a03:2880:f124::\\/48\",\"2a03:2880:f127::\\/48\",\"2a03:2880:f129::\\/48\",\"2a03:2880:f12b::\\/48\",\"2a03:2880:f12c::\\/48\",\"2a03:2880:f12d::\\/48\",\"2a03:2880:f12e::\\/48\",\"2a03:2880:f130::\\/48\",\"2a03:2880:f131::\\/48\",\"2a03:2880:f132::\\/48\",\"2a03:2880:f133::\\/48\",\"2a03:2880:f134::\\/48\",\"2a03:2880:f135::\\/48\",\"2a03:2880:f136::\\/48\",\"2a03:2880:f137::\\/48\",\"2a03:2880:f138::\\/48\",\"2a03:2880:f139::\\/48\",\"2a03:2880:f13a::\\/48\",\"2a03:2880:f13b::\\/48\",\"2a03:2880:f13c::\\/48\",\"2a03:2880:f13d::\\/48\",\"2a03:2880:f13e::\\/48\",\"2a03:2880:f13f::\\/48\",\"2a03:2880:f21d::\\/48\",\"2a03:2880:f21e::\\/48\",\"2a03:2880:f220::\\/48\",\"2a03:2880:f224::\\/48\",\"2a03:2880:f227::\\/48\",\"2a03:2880:f229::\\/48\",\"2a03:2880:f22b::\\/48\",\"2a03:2880:f22c::\\/48\",\"2a03:2880:f22d::\\/48\",\"2a03:2880:f22e::\\/48\",\"2a03:2880:f230::\\/48\",\"2a03:2880:f231::\\/48\",\"2a03:2880:f232::\\/48\",\"2a03:2880:f233::\\/48\",\"2a03:2880:f234::\\/48\",\"2a03:2880:f235::\\/48\",\"2a03:2880:f236::\\/48\",\"2a03:2880:f237::\\/48\",\"2a03:2880:f238::\\/48\",\"2a03:2880:f239::\\/48\",\"2a03:2880:f23a::\\/48\",\"2a03:2880:f23b::\\/48\",\"2a03:2880:f23c::\\/48\",\"2a03:2880:f23d::\\/48\",\"2a03:2880:f23e::\\/48\",\"2a03:2880:f23f::\\/48\",\"2a03:2880:f0ff::\\/48\",\"2a03:2880:f1ff::\\/48\",\"2a03:2880:f2ff::\\/48\",\"2c0f:ef78:0003::\\/48\"]},\"uptimerobot\":{\"n\":\"Uptime Robot\",\"d\":true,\"r\":[\"69.162.124.224\\/28\",\"63.143.42.240\\/28\"]},\"statuscake\":{\"n\":\"StatusCake\",\"d\":true,\"r\":[\"103.194.112.70\",\"104.131.247.151\",\"104.131.248.65\",\"104.131.248.78\",\"104.156.229.24\",\"104.156.255.184\",\"104.206.168.26\",\"104.238.164.105\",\"107.150.1.135\",\"107.155.104.182\",\"107.155.108.234\",\"107.155.125.29\",\"107.161.28.219\",\"107.170.197.248\",\"107.170.219.46\",\"107.170.227.23\",\"107.170.227.24\",\"107.170.240.141\",\"107.170.53.191\",\"107.191.47.131\",\"107.191.57.237\",\"108.61.119.153\",\"108.61.162.214\",\"108.61.205.201\",\"108.61.212.141\",\"108.61.215.179\",\"125.63.48.239\",\"128.199.222.65\",\"138.197.130.232\",\"138.197.130.235\",\"138.197.140.243\",\"138.204.171.136\",\"138.68.24.115\",\"138.68.24.136\",\"138.68.24.207\",\"138.68.24.60\",\"138.68.80.10\",\"138.68.80.173\",\"139.59.15.79\",\"139.59.155.26\",\"139.59.190.241\",\"139.59.22.109\",\"139.59.26.85\",\"139.59.29.167\",\"149.154.157.61\",\"149.255.59.100\",\"151.236.10.238\",\"151.236.18.80\",\"151.80.175.223\",\"151.80.175.226\",\"154.127.60.23\",\"154.127.60.59\",\"158.255.208.76\",\"159.203.182.22\",\"159.203.182.60\",\"159.203.186.225\",\"159.203.31.18\",\"162.243.247.163\",\"162.243.71.56\",\"162.248.97.72\",\"162.253.64.104\",\"162.253.64.87\",\"176.56.230.110\",\"178.62.101.57\",\"178.62.104.137\",\"178.62.106.84\",\"178.62.109.7\",\"178.62.40.233\",\"178.62.41.44\",\"178.62.41.49\",\"178.62.41.52\",\"178.62.65.162\",\"178.62.71.227\",\"178.62.78.199\",\"178.62.80.93\",\"178.62.86.69\",\"178.73.210.99\",\"181.41.201.117\",\"181.41.214.137\",\"185.112.157.185\",\"185.12.45.70\",\"185.47.129.168\",\"185.60.135.86\",\"188.166.158.224\",\"188.166.253.148\",\"188.226.139.158\",\"188.226.158.160\",\"188.226.169.228\",\"188.226.171.58\",\"188.226.184.152\",\"188.226.185.106\",\"188.226.186.199\",\"188.226.203.84\",\"188.226.247.184\",\"188.68.238.79\",\"192.241.221.11\",\"193.124.178.54\",\"193.124.178.61\",\"193.182.144.105\",\"193.182.144.147\",\"199.167.128.80\",\"209.222.30.242\",\"213.183.56.107\",\"217.148.43.188\",\"217.148.43.202\",\"31.220.7.237\",\"37.157.246.146\",\"37.235.48.42\",\"37.235.52.25\",\"37.235.53.240\",\"37.235.55.205\",\"37.97.188.103\",\"45.32.128.80\",\"45.32.145.79\",\"45.32.151.21\",\"45.32.160.172\",\"45.32.166.195\",\"45.32.171.24\",\"45.32.192.198\",\"45.32.195.186\",\"45.32.195.93\",\"45.32.212.56\",\"45.32.36.158\",\"45.32.7.22\",\"45.63.121.159\",\"45.63.26.78\",\"45.63.51.63\",\"45.63.61.213\",\"45.63.76.68\",\"45.63.78.84\",\"45.63.86.120\",\"45.63.88.213\",\"45.76.1.44\",\"45.76.192.50\",\"45.76.3.112\",\"46.101.0.24\",\"46.101.110.32\",\"46.101.110.43\",\"46.101.110.45\",\"46.101.20.96\",\"46.101.238.182\",\"46.101.238.189\",\"46.101.240.208\",\"46.101.27.186\",\"46.101.61.83\",\"46.101.74.251\",\"5.45.179.103\",\"50.2.139.16\",\"82.221.95.161\",\"91.236.116.163\"]},\"managewp\":{\"n\":\"ManageWP\",\"d\":false,\"r\":[\"34.211.180.66\",\"54.70.65.107\",\"34.210.224.7\",\"52.41.5.108\",\"52.35.72.129\",\"54.191.137.17\",\"35.162.254.253\",\"52.11.12.231\",\"52.11.29.70\",\"52.11.54.161\",\"52.24.142.159\",\"52.25.191.255\",\"52.27.181.126\",\"52.34.126.117\",\"52.34.254.47\",\"52.35.82.99\",\"52.36.28.80\",\"52.38.106.97\",\"52.39.177.152\",\"52.41.230.148\",\"52.41.237.12\",\"52.42.126.166\",\"52.43.13.71\",\"52.43.76.224\",\"52.88.96.110\",\"52.89.155.51\",\"54.148.73.118\",\"54.186.37.105\",\"54.187.92.57\",\"54.191.32.65\",\"54.191.67.23\",\"54.191.80.119\",\"54.191.135.209\",\"54.191.136.176\",\"54.191.148.85\",\"54.191.149.8\",\"52.26.122.21\",\"52.24.187.29\",\"52.89.85.107\",\"54.186.128.167\",\"54.191.40.136\",\"52.24.62.11\",\"52.88.119.122\",\"54.191.148.225\",\"54.191.151.18\",\"52.89.94.121\",\"52.25.116.116\",\"52.88.215.225\",\"54.186.143.184\",\"52.88.197.180\",\"52.27.171.126\"]},\"seznam\":{\"n\":\"Seznam Search Engine\",\"d\":true,\"r\":[\"77.75.74.0\\/24\",\"77.75.76.0\\/24\",\"77.75.77.0\\/24\",\"77.75.78.0\\/24\",\"77.75.79.0\\/24\",\"2a02:598:a::78:0\\/112\",\"2a02:598:a::79:0\\/112\",\"2a02:598:2::0\\/96\"]}}', 'yes'),
 ('whitelistHash', 'bf3d76dc05caf8623cb3fe01c1fc9e308e2f2ea37b826937d850fde361cdefd4', 'yes'),
 ('touppPromptNeeded', '1', 'yes'),
 ('touppBypassNextCheck', '0', 'yes'),
 ('autoUpdateAttempts', '0', 'yes'),
 ('previousWflogsFileList', '[\"ips.php\",\"config-synced.php\",\"config-transient.php\",\".htaccess\",\"rules.php\",\"config-livewaf.php\",\"template.php\",\"attack-data.php\",\"config.php\",\"GeoLite2-Country.mmdb\"]', 'yes'),
 ('diagnosticsWflogsRemovalHistory', '[]', 'no'),
 ('encKey', '4409c49b12784a52', 'yes'),
 ('longEncKey', '9e789d8065cee156f80364af8c227ed9da91d6e3580cc20648436aca58558e2b', 'yes'),
 ('cbl_restOfSiteBlocked', '1', 'yes'),
 ('timeoffset_wf', '0', 'yes'),
 ('lastBlockAggregation', '1597160009', 'yes'),
 ('allowed404s6116Migration', '1', 'yes'),
 ('migration636_email_summary_excluded_directories', '1', 'no'),
 ('fileContentsGSB6315Migration', '1', 'yes'),
 ('config701Migration', '1', 'yes'),
 ('blocks702Migration', '1', 'yes'),
 ('geoIPVersionHash', '8a7dba97f41311dda2bfa98f60b77d6c930d3150560909850a22b80a732ecb36', 'yes'),
 ('scansEnabled_geoipSupport', '1', 'yes'),
 ('config720Migration', '1', 'yes'),
 ('waf_status', 'enabled', 'yes'),
 ('detectProxyNextCheck', '1597675301', 'no'),
 ('detectProxyNonce', '', 'no'),
 ('wordpressPluginVersions', 'a:9:{s:7:\"akismet\";s:5:\"4.1.6\";s:16:\"login-customizer\";s:5:\"2.0.1\";s:14:\"duplicator-pro\";s:7:\"3.8.3.4\";s:5:\"hello\";s:5:\"1.7.2\";s:9:\"revslider\";s:6:\"6.2.17\";s:11:\"updraftplus\";s:7:\"1.16.26\";s:11:\"woocommerce\";s:5:\"4.3.2\";s:9:\"wordfence\";s:6:\"7.4.10\";s:9:\"wp-cerber\";s:5:\"8.6.6\";}', 'yes'),
 ('serverIP', '1588014642;51.91.128.199', 'yes'),
 ('allScansScheduled', 'a:2:{i:0;a:2:{s:9:\"timestamp\";i:1597282200;s:4:\"args\";a:1:{i:0;i:1597282200;}}i:1;a:2:{s:9:\"timestamp\";i:1597541400;s:4:\"args\";a:1:{i:0;i:1597541400;}}}', 'yes'),
 ('lastDailyCron', '1597160007', 'yes'),
 ('activatingIP', '190.206.192.27', 'yes'),
 ('cbl_cookieVal', '5e325a80cfeb7', 'yes'),
 ('serverDNS', '1597160003;14400;51.91.128.199', 'yes'),
 ('adminNoticeQueue', 'a:0:{}', 'yes'),
 ('wp_home_url', 'https://modelox.vico.digital', 'yes'),
 ('wp_site_url', 'https://modelox.vico.digital', 'yes'),
 ('dbVersion', '5.7.31-cll-lve', 'yes'),
 ('lastDashboardCheck', '1597160008', 'yes'),
 ('dashboardData', 'a:4:{s:9:\"generated\";i:1597156843;s:3:\"tdf\";a:3:{s:9:\"community\";i:5710;s:7:\"premium\";i:5711;s:9:\"blacklist\";i:22946;}s:10:\"attackdata\";a:3:{s:3:\"24h\";a:24:{i:0;a:2:{s:1:\"t\";i:1597068000;s:1:\"c\";i:6415263;}i:1;a:2:{s:1:\"t\";i:1597071600;s:1:\"c\";i:5698806;}i:2;a:2:{s:1:\"t\";i:1597075200;s:1:\"c\";i:5716751;}i:3;a:2:{s:1:\"t\";i:1597078800;s:1:\"c\";i:5370887;}i:4;a:2:{s:1:\"t\";i:1597082400;s:1:\"c\";i:5397686;}i:5;a:2:{s:1:\"t\";i:1597086000;s:1:\"c\";i:5093187;}i:6;a:2:{s:1:\"t\";i:1597089600;s:1:\"c\";i:5409646;}i:7;a:2:{s:1:\"t\";i:1597093200;s:1:\"c\";i:5481559;}i:8;a:2:{s:1:\"t\";i:1597096800;s:1:\"c\";i:5091141;}i:9;a:2:{s:1:\"t\";i:1597100400;s:1:\"c\";i:4521249;}i:10;a:2:{s:1:\"t\";i:1597104000;s:1:\"c\";i:5136852;}i:11;a:2:{s:1:\"t\";i:1597107600;s:1:\"c\";i:5198179;}i:12;a:2:{s:1:\"t\";i:1597111200;s:1:\"c\";i:5159371;}i:13;a:2:{s:1:\"t\";i:1597114800;s:1:\"c\";i:4992817;}i:14;a:2:{s:1:\"t\";i:1597118400;s:1:\"c\";i:5128980;}i:15;a:2:{s:1:\"t\";i:1597122000;s:1:\"c\";i:5764920;}i:16;a:2:{s:1:\"t\";i:1597125600;s:1:\"c\";i:6833267;}i:17;a:2:{s:1:\"t\";i:1597129200;s:1:\"c\";i:6159931;}i:18;a:2:{s:1:\"t\";i:1597132800;s:1:\"c\";i:5503091;}i:19;a:2:{s:1:\"t\";i:1597136400;s:1:\"c\";i:6711824;}i:20;a:2:{s:1:\"t\";i:1597140000;s:1:\"c\";i:7570223;}i:21;a:2:{s:1:\"t\";i:1597143600;s:1:\"c\";i:5816319;}i:22;a:2:{s:1:\"t\";i:1597147200;s:1:\"c\";i:6152877;}i:23;a:2:{s:1:\"t\";i:1597150800;s:1:\"c\";i:7507283;}}s:2:\"7d\";a:7:{i:0;a:2:{s:1:\"t\";i:1596499200;s:1:\"c\";i:139786921;}i:1;a:2:{s:1:\"t\";i:1596585600;s:1:\"c\";i:137453534;}i:2;a:2:{s:1:\"t\";i:1596672000;s:1:\"c\";i:144840893;}i:3;a:2:{s:1:\"t\";i:1596758400;s:1:\"c\";i:143390209;}i:4;a:2:{s:1:\"t\";i:1596844800;s:1:\"c\";i:149152372;}i:5;a:2:{s:1:\"t\";i:1596931200;s:1:\"c\";i:141828290;}i:6;a:2:{s:1:\"t\";i:1597017600;s:1:\"c\";i:138953354;}}s:3:\"30d\";a:30:{i:0;a:2:{s:1:\"t\";i:1594512000;s:1:\"c\";i:123113732;}i:1;a:2:{s:1:\"t\";i:1594598400;s:1:\"c\";i:135731326;}i:2;a:2:{s:1:\"t\";i:1594684800;s:1:\"c\";i:137000818;}i:3;a:2:{s:1:\"t\";i:1594771200;s:1:\"c\";i:138584371;}i:4;a:2:{s:1:\"t\";i:1594857600;s:1:\"c\";i:130838980;}i:5;a:2:{s:1:\"t\";i:1594944000;s:1:\"c\";i:143014875;}i:6;a:2:{s:1:\"t\";i:1595030400;s:1:\"c\";i:140938392;}i:7;a:2:{s:1:\"t\";i:1595116800;s:1:\"c\";i:136092512;}i:8;a:2:{s:1:\"t\";i:1595203200;s:1:\"c\";i:134949569;}i:9;a:2:{s:1:\"t\";i:1595289600;s:1:\"c\";i:140926316;}i:10;a:2:{s:1:\"t\";i:1595376000;s:1:\"c\";i:125827677;}i:11;a:2:{s:1:\"t\";i:1595462400;s:1:\"c\";i:143658332;}i:12;a:2:{s:1:\"t\";i:1595548800;s:1:\"c\";i:138289345;}i:13;a:2:{s:1:\"t\";i:1595635200;s:1:\"c\";i:116900038;}i:14;a:2:{s:1:\"t\";i:1595721600;s:1:\"c\";i:128521622;}i:15;a:2:{s:1:\"t\";i:1595808000;s:1:\"c\";i:137941879;}i:16;a:2:{s:1:\"t\";i:1595894400;s:1:\"c\";i:133703694;}i:17;a:2:{s:1:\"t\";i:1595980800;s:1:\"c\";i:141448480;}i:18;a:2:{s:1:\"t\";i:1596067200;s:1:\"c\";i:140376449;}i:19;a:2:{s:1:\"t\";i:1596153600;s:1:\"c\";i:129816711;}i:20;a:2:{s:1:\"t\";i:1596240000;s:1:\"c\";i:134787530;}i:21;a:2:{s:1:\"t\";i:1596326400;s:1:\"c\";i:139908885;}i:22;a:2:{s:1:\"t\";i:1596412800;s:1:\"c\";i:137370304;}i:23;a:2:{s:1:\"t\";i:1596499200;s:1:\"c\";i:139786921;}i:24;a:2:{s:1:\"t\";i:1596585600;s:1:\"c\";i:137453534;}i:25;a:2:{s:1:\"t\";i:1596672000;s:1:\"c\";i:144840893;}i:26;a:2:{s:1:\"t\";i:1596758400;s:1:\"c\";i:143390209;}i:27;a:2:{s:1:\"t\";i:1596844800;s:1:\"c\";i:149152372;}i:28;a:2:{s:1:\"t\";i:1596931200;s:1:\"c\";i:141828290;}i:29;a:2:{s:1:\"t\";i:1597017600;s:1:\"c\";i:138953354;}}}s:9:\"countries\";a:1:{s:2:\"7d\";a:10:{i:0;a:2:{s:2:\"cd\";s:2:\"US\";s:2:\"ct\";i:390003268;}i:1;a:2:{s:2:\"cd\";s:2:\"IN\";s:2:\"ct\";i:184716716;}i:2;a:2:{s:2:\"cd\";s:2:\"FR\";s:2:\"ct\";i:154210165;}i:3;a:2:{s:2:\"cd\";s:2:\"CN\";s:2:\"ct\";i:127501183;}i:4;a:2:{s:2:\"cd\";s:2:\"DE\";s:2:\"ct\";i:79241369;}i:5;a:2:{s:2:\"cd\";s:2:\"BR\";s:2:\"ct\";i:78199809;}i:6;a:2:{s:2:\"cd\";s:2:\"RU\";s:2:\"ct\";i:76889949;}i:7;a:2:{s:2:\"cd\";s:2:\"GB\";s:2:\"ct\";i:74467634;}i:8;a:2:{s:2:\"cd\";s:2:\"SG\";s:2:\"ct\";i:73102049;}i:9;a:2:{s:2:\"cd\";s:2:\"UA\";s:2:\"ct\";i:59637050;}}}}', 'yes'),
 ('tldlist', '|com|org|net|edu|aaa|abb|abc|aco|ads|aeg|afl|aig|anz|aol|app|art|aws|axa|bar|bbc|bbt|bcg|bcn|bet|bid|bio|biz|bms|bmw|bom|boo|bot|box|buy|bzh|cab|cal|cam|car|cat|cba|cbn|cbs|ceb|ceo|cfa|cfd|cpa|crs|csc|dad|day|dds|dev|dhl|diy|dnp|dog|dot|dtv|dvr|eat|eco|esq|eus|fan|fit|fly|foo|fox|frl|ftr|fun|fyi|gal|gap|gay|gdn|gea|gle|gmo|gmx|goo|gop|got|gov|hbo|hiv|hkt|hot|how|ibm|ice|icu|ifm|inc|ing|ink|int|ist|itv|jcb|jcp|jio|jll|jmp|jnj|jot|joy|kfh|kia|kim|kpn|krd|lat|law|lds|llc|llp|lol|lpl|ltd|man|map|mba|med|men|mil|mit|mlb|mls|mma|moe|moi|mom|mov|msd|mtn|mtr|nab|nba|nec|new|nfl|ngo|nhk|now|nra|nrw|ntt|nyc|obi|off|one|ong|onl|ooo|ott|ovh|pay|pet|phd|pid|pin|pnc|pro|pru|pub|pwc|qvc|red|ren|ril|rio|rip|run|rwe|sap|sas|sbi|sbs|sca|scb|ses|sew|sex|sfr|ski|sky|soy|srl|stc|tab|tax|tci|tdk|tel|thd|tjx|top|trv|tui|tvs|ubs|uno|uol|ups|vet|vig|vin|vip|wed|win|wme|wow|wtc|wtf|xin|xxx|xyz|you|yun|zip|ac|ad|ae|af|ag|ai|al|am|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cw|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|za|zm|zw|aarp|able|adac|aero|akdn|ally|amex|amica|arab|army|arpa|arte|asda|archi|asia|alstom|amfam|audi|auto|apple|audible|audio|alsace|auction|autos|amazon|azure|athleta|band|bank|anquan|author|avianca|baby|baidu|android|aramco|auspost|banamex|bananarepublic|bbva|best|abbvie|beer|bike|bing|actor|abbott|cash|cern|chat|citi|club|build|cbre|chase|city|cool|date|dclk|deal|dell|desi|limo|lexus|life|adult|lego|lgbt|like|legal|link|loan|loft|love|name|lease|navy|abarth|moto|cheap|delta|live|ninja|nissan|nissay|nokia|norton|nowruz|abogado|aetna|academy|bayern|basketball|blog|blue|bauhaus|beats|bofa|bond|book|buzz|cafe|call|camp|care|cars|casa|case|coop|cyou|data|diet|canon|dish|docs|kred|land|lidl|ltda|luxe|kyoto|meme|mini|mint|lamer|maif|meet|menu|mobi|moda|news|next|nike|cards|nexus|nico|nikon|ollo|open|airbus|page|pars|pics|barefoot|ping|bible|pink|play|airtel|plus|alibaba|alipay|barclays|barcelona|barclaycard|pohl|bingo|black|boats|cisco|cloud|crown|dabur|lupin|agakhan|cymru|dance|lilly|macys|mango|pccw|africa|media|miami|movie|nowtv|omega|agency|bargains|bosch|citic|click|coach|codes|deals|linde|lipsy|lixil|loans|locus|lotte|lotto|money|oracle|orange|party|online|pfizer|baseball|paris|office|olayan|osaka|otsuka|parts|domains|duck|dvag|erni|fage|fans|farm|fast|fiat|fido|film|fire|airforce|fail|alfaromeo|americanexpress|fish|flir|food|ford|gift|forum|gmbh|gold|golf|goog|forex|globo|gmail|allstate|free|fund|gifts|glade|glass|allfinanz|gallo|game|gbiz|gent|ggee|games|gives|kpmg|porn|xbox|zara|abudhabi|drive|team|tech|yoga|dubai|earth|star|teva|zero|edeka|surf|taxi|zone|email|talk|epson|accenture|accountant|final|tips|vana|visa|vote|fedex|viva|vivo|faith|tiaa|town|toys|tube|voto|wang|weir|wien|wiki|wine|accountants|work|afamilycompany|green|guge|haus|help|host|hsbc|group|hyatt|apartments|guru|hair|hdfc|here|hgtv|house|icbc|imdb|reit|irish|post|ikano|immo|info|itau|java|aquarelle|ieee|rent|iveco|jeep|jobs|jprs|kddi|kiwi|qpon|read|pharmacy|prod|raid|philips|prof|rest|analytics|attorney|gripe|gucci|guide|homes|horse|room|honda|rmit|intel|okinawa|amsterdam|koeln|oldnavy|associates|northwesternmutual|rich|jetzt|download|observer|onyourside|rsvp|panasonic|safe|sale|americanfamily|olayangroup|organic|origins|ruhr|sarl|save|partners|saxo|seat|seek|sexy|shaw|shia|passagens|scot|shop|show|silk|sina|site|skin|sncf|sohu|song|sony|spot|phone|solar|total|beauty|berlin|bharti|bostik|boston|sport|broker|smart|smile|store|brother|bugatti|skype|sling|stada|camera|claims|coffee|comsec|capital|chrome|swiss|caseih|casino|caravan|career|church|condos|study|careers|circle|clinic|comcast|commbank|community|company|sucks|chanel|cologne|compare|computer|construction|style|center|consulting|contact|google|booking|clinique|salon|bentley|health|bestbuy|charity|chintai|cipriani|citadel|cityeats|gratis|channel|cleaning|hermes|sener|shoes|safety|sakura|college|hiphop|hotels|hughes|sanofi|clubmed|hockey|imamat|school|schule|seven|sharp|shell|search|secure|select|shouji|social|stream|studio|supply|suzuki|swatch|sydney|clothing|soccer|cooking|dental|expert|flickr|gallup|vegas|video|events|vodka|volvo|wales|futbol|watch|weber|dating|datsun|estate|garden|weibo|family|works|dealer|direct|emerck|world|doctor|xerox|dunlop|dupont|durban|global|yahoo|coupon|credit|cruise|degree|design|energy|george|giving|insure|space|taipei|tires|tirol|tmall|today|tokyo|tools|taobao|tennis|corsica|cookingchannel|tatar|target|tjmaxx|tkmaxx|contractors|tattoo|tienda|toray|tours|trade|ubank|toyota|trust|tunes|tushu|travel|unicom|viajes|viking|villas|virgin|vision|voting|voyage|vuelos|walter|webcam|xihuan|yachts|yandex|zappos|country|dentist|fishing|exchange|fidelity|finance|lawyer|financial|fitness|firestone|firmdale|flights|frogans|leclerc|democrat|fujitsu|latino|delivery|florist|forsale|etisalat|flowers|lefrak|makeup|farmers|ferrari|luxury|fashion|london|exposed|express|feedback|market|cricket|cruises|digital|ferrero|living|maison|latrobe|limited|lincoln|madrid|marketing|ryukyu|deloitte|gallery|genting|locker|lundbeck|markets|boutique|bradesco|broadway|brussels|budapest|pictet|tiffany|builders|discount|ericsson|frontdoor|frontier|fresenius|fujixerox|furniture|tickets|diamonds|discover|engineer|football|lifestyle|photo|photos|physio|toshiba|lighting|trading|marriott|theatre|maserati|mobile|monash|monster|mormon|xfinity|mortgage|moscow|museum|mutual|nagoya|yamaxun|youtube|directory|metlife|merckmsd|natura|education|netbank|memorial|netflix|network|pictures|fairwinds|mattel|neustar|mckinsey|equipment|zuerich|marshalls|saarland|blackfriday|watches|bloomberg|microsoft|theater|training|ventures|verisign|walmart|travelers|wanggou|weather|whoswho|melbourne|website|bnpparibas|vacations|wedding|windows|winners|vanguard|woodside|xn--90ae|yokohama|xn--90ais|xn--e1a4c|xn--l1acc|blockbuster|xn--p1ai|xn--c1avg|xn--node|xn--d1alf|xn--fhbei|xn--j1aef|xn--j1amh|xn--ngbrx|xn--nqv7f|xn--p1acf|xn--qxa6a|xn--qxam|xn--tckwe|xn--vhquv|yodobashi|boehringer|hangout|kinder|lasalle|guardian|guitars|graphics|hamburg|hotmail|catering|catholic|grainger|holiday|homedepot|engineering|grocery|lanxess|hdfcbank|rehab|enterprises|jewelry|holdings|kindle|helsinki|foundation|hisamitsu|hitachi|hoteles|homegoods|capitalone|hosting|hospital|homesense|kaufen|juniper|kitchen|eurovision|juegos|jpmorgan|extraspace|healthcare|joburg|hyundai|management|mitsubishi|reise|lacaixa|rugby|goldpoint|institute|cuisinella|jaguar|godaddy|intuit|ismaili|christmas|kosher|komatsu|lancaster|lancia|newholland|investments|report|insurance|reisen|repair|review|coupons|courses|reviews|reliance|creditcard|international|landrover|nationwide|rentals|rexroth|business|rocher|rodeo|capetown|goodyear|infiniti|ipiranga|rogers|samsung|schmidt|science|istanbul|ricoh|rocks|sandvik|security|richardli|schwarz|shriram|samsclub|services|motorcycles|shopping|showtime|immobilien|shiksha|industries|kuokgroup|scjohnson|shangrila|nextdirect|pioneer|pizza|place|plumbing|praxi|bridgestone|poker|politie|press|prime|quest|radio|quebec|racing|pramerica|realtor|realty|recipes|property|republican|productions|promo|scholarships|singles|restaurant|progressive|staples|redstone|statefarm|stcgroup|realestate|storage|properties|foodnetwork|softbank|software|solutions|support|temasek|supplies|surgery|systems|prudential|tatamotors|technology|redumbrella|schaeffler|statebank|stockholm|protection|swiftcover|university|lplfinancial|sandvikcoromant|vlaanderen|volkswagen|calvinklein|cancerresearch|creditunion|lamborghini|lifeinsurance|photography|playstation|travelchannel|travelersinsurance|xn--30rr7y|xn--3pxu8k|xn--45q11c|xn--4gbrim|weatherchannel|xn--55qx5d|xn--11b4c3d|xn--90a3ac|xn--9et52u|kerryhotels|williamhill|xn--1qqw23a|xn--2scrj9c|xn--3bst00m|xn--5tzm5g|xn--1ck2e1b|xn--3ds443g|xn--9dbq2a|xn--45brj9c|xn--6frz82g|xn--80adxhks|xn--80ao21a|xn--6qq986b3xl|xn--c2br7g|xn--80aqecdr1a|xn--80asehdb|xn--80aswg|xn--3hcrj9c|xn--42c2d9a|xn--55qw42g|xn--8y0a063a|xn--54b7fta0cc|xn--5su34j936bgsg|xn--cck2b3b|xn--3e0b707e|xn--45br5cyl|xn--3oq18vl8pn36a|xn--fiq64b|xn--fiqs8s|xn--fiqz9s|kerryproperties|versicherung|spreadbetting|kerrylogistics|xn--czrs0t|xn--czru2d|wolterskluwer|xn--cg4bki|xn--cckwcxetd|xn--io0a7i|xn--kput3i|xn--9krt00a|xn--czr694b|xn--d1acj3b|xn--g2xx48c|xn--unup4y|xn--wgbh1c|xn--efvy88h|xn--fct429k|xn--wgbl6a|xn--y9a3aq|xn--fjq720a|xn--pssy2u|xn--flw351e|xn--gckr3f0f|xn--gecrj9c|xn--q7ce6a|xn--fzc2c9e2c|xn--j6w193g|xn--clchc0ea0b2g2a9gcd|xn--imr513n|xn--bck1b9a5dre4c|xn--jvr189m|xn--eckvdtc9d|xn--kprw13d|xn--b4w605ferd|xn--fiq228c5hs|xn--gk3at1e|xn--h2brj9c|xn--hxt814e|xn--h2brj9c8c|xn--kpry57d|xn--mgbtx2b|xn--h2breg3eve|xn--i1b6b1a6a2e|xn--lgbbat1ad8j|xn--mgbbh1a|xn--fpcrj9c3d|xn--fzys8d69uvgm|xn--mix891f|xn--pgbs0dh|xn--jlq480n2rg|xn--mgb9awbf|xn--mgba3a3ejt|xn--mxtq1m|xn--mgbt3dhd|xn--mk1bu44c|xn--mgbaam7a8h|xn--mgbab2bd|xn--mgbgu82a|xn--mgbpl2fh|xn--mgbayh7gpa|xn--mgbbh1a71e|xn--mgba3a4f16a|xn--mgbaakc7dvf|xn--mgbc0a9azcg|xn--mgbca7dzdo|xn--mgbcpq6gpa1a|xn--mgbai9azgqp6j|xn--mgberp4a5d4ar|xn--mgbi4ecexp|xn--mgbah1a3hjkrd|xn--mgbx4cd0ab|xn--mgba7c0bbn0a|xn--zfr164b|xn--ngbc5azd|xn--nyqy26a|xn--nqv7fs00ema|xn--q9jyb4c|xn--qcka1pmc|xn--jlq61u9w7b|xn--o3cw4h|xn--otu796d|xn--ogbpf8fl|xn--rhqv96g|xn--s9brj9c|xn--t60b56a|xn--ngbe9e0a|xn--kcrx77d1x4a|xn--rovu88b|xn--rvc1e0am3e|xn--ses554g|xn--vuq861b|xn--w4rs40l|xn--tiq49xqyj|xn--w4r85el8fhu5dnra|xn--yfro4i67o|xn--vermgensberater-ctb|xn--vermgensberatung-pwb|xn--xhq521b|xn--xkc2al3hye2a|xn--ygbi2ammx|xn--xkc2dl3a5ee0h|', 'yes'),
 ('tldlistHash', '3d9da9634cd68e555aeaf2db439aa5da63a7f127f0175aab7681e34eaf9484b8', 'yes'),
 ('noc1ScanSchedule', 'a:2:{i:0;i:1597282200;i:1;i:1597541400;}', 'yes'),
 ('showWfCentralUI', '1', 'yes'),
 ('allowMySQLi', '1', 'yes'),
 ('dbTest', 'a:1:{s:5:\"nonce\";s:64:\"107ef42452fc707f87f2344c6cbad632adee100c123ad9c83cd523e59170a438\";}', 'no'),
 ('vulnerabilities_plugin', 'a:9:{i:0;a:4:{s:4:\"slug\";s:7:\"akismet\";s:11:\"fromVersion\";s:5:\"4.1.6\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}i:1;a:4:{s:4:\"slug\";s:16:\"login-customizer\";s:11:\"fromVersion\";s:5:\"2.0.1\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}i:2;a:4:{s:4:\"slug\";s:11:\"hello-dolly\";s:11:\"fromVersion\";s:5:\"1.7.2\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}i:3;a:4:{s:4:\"slug\";s:11:\"updraftplus\";s:11:\"fromVersion\";s:7:\"1.16.26\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}i:4;a:4:{s:4:\"slug\";s:11:\"woocommerce\";s:11:\"fromVersion\";s:5:\"4.3.2\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}i:5;a:4:{s:4:\"slug\";s:9:\"wordfence\";s:11:\"fromVersion\";s:6:\"7.4.10\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}i:6;a:4:{s:4:\"slug\";s:9:\"wp-cerber\";s:11:\"fromVersion\";s:5:\"8.6.6\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}i:7;a:4:{s:4:\"slug\";s:14:\"duplicator-pro\";s:11:\"fromVersion\";s:7:\"3.8.3.4\";s:10:\"vulnerable\";b:1;s:4:\"link\";s:42:\"https://wpvulndb.com/vulnerabilities/10078\";}i:8;a:4:{s:4:\"slug\";s:9:\"revslider\";s:11:\"fromVersion\";s:6:\"6.2.17\";s:10:\"vulnerable\";b:0;s:4:\"link\";b:0;}}', 'yes'),
 ('totalScansRun', '40', 'yes'),
 ('wfKillRequested', '0', 'no'),
 ('currentCronKey', '', 'yes'),
 ('wf_scanLastStatusTime', '0', 'yes'),
 ('wf_scanRunning', '', 'yes'),
 ('wfPeakMemory', '84410368', 'no'),
 ('wfScanStartVersion', '5.4.2', 'yes'),
 ('lowResourceScanWaitStep', '', 'yes'),
 ('wfStatusStartMsgs', 'a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}', 'yes'),
 ('wf_summaryItems', 'a:8:{s:12:\"scannedPosts\";i:0;s:15:\"scannedComments\";i:0;s:12:\"scannedFiles\";i:0;s:14:\"scannedPlugins\";i:0;s:13:\"scannedThemes\";i:0;s:12:\"scannedUsers\";i:0;s:11:\"scannedURLs\";i:0;s:10:\"lastUpdate\";i:1597160015;}', 'yes'),
 ('scanStageStatuses', 'a:11:{s:13:\"spamvertising\";a:4:{s:6:\"status\";s:7:\"premium\";s:7:\"started\";i:0;s:8:\"finished\";i:0;s:8:\"expected\";i:0;}s:4:\"spam\";a:4:{s:6:\"status\";s:7:\"premium\";s:7:\"started\";i:0;s:8:\"finished\";i:0;s:8:\"expected\";i:0;}s:9:\"blacklist\";a:4:{s:6:\"status\";s:7:\"premium\";s:7:\"started\";i:0;s:8:\"finished\";i:0;s:8:\"expected\";i:0;}s:6:\"server\";a:4:{s:6:\"status\";s:16:\"complete-success\";s:7:\"started\";i:5;s:8:\"finished\";i:5;s:8:\"expected\";i:5;}s:7:\"changes\";a:4:{s:6:\"status\";s:16:\"complete-success\";s:7:\"started\";i:2;s:8:\"finished\";i:2;s:8:\"expected\";i:2;}s:6:\"public\";a:4:{s:6:\"status\";s:16:\"complete-success\";s:7:\"started\";i:3;s:8:\"finished\";i:3;s:8:\"expected\";i:2;}s:7:\"malware\";a:4:{s:6:\"status\";s:16:\"complete-warning\";s:7:\"started\";i:2;s:8:\"finished\";i:3;s:8:\"expected\";i:2;}s:7:\"content\";a:4:{s:6:\"status\";s:16:\"complete-success\";s:7:\"started\";i:5;s:8:\"finished\";i:6;s:8:\"expected\";i:3;}s:8:\"password\";a:4:{s:6:\"status\";s:16:\"complete-success\";s:7:\"started\";i:2;s:8:\"finished\";i:2;s:8:\"expected\";i:1;}s:13:\"vulnerability\";a:4:{s:6:\"status\";s:7:\"running\";s:7:\"started\";i:2;s:8:\"finished\";i:1;s:8:\"expected\";i:1;}s:7:\"options\";a:4:{s:6:\"status\";s:16:\"complete-success\";s:7:\"started\";i:2;s:8:\"finished\";i:2;s:8:\"expected\";i:2;}}', 'no'),
 ('lastScanCompleted', 'ok', 'yes'),
 ('lastScanFailureType', '', 'yes'),
 ('scanTime', '1597160015.4771', 'yes'),
 ('malwarePrefixes', '\0\0\0\0\0\0y8\0ٗΝ;˽sIYJBR$RI%QDZHJ!I+JHi!*)EE+&~yy33>ǌ\no>^\'_wBx1uO\Z %e\r?EC)M>8)}uׄ-X1ffm\0\0\0ra?\0xG7\0?)`\04DK@bH\0Y+ gZ\0p\Z\0@1Pt180\0v6. );ռ\Z@U	{\0u\'@p_F\\q4\0Z.=_\r0ht&:A!\0]߀\n@7\0b?g];al`,[0``x,0`00a$`d0ZU\\\0>K>&)/S5);0r=	7?`\\C`9*XXՐd`~`6LXK֗_W6$`tt/<$p87O\0`m0m.V!kH,\ZHf~x89u6~\\\\`w<:`^s0\0,?\0,H{\r,8,(N\0\\Y\0,x,x\0cOӀg#`-u७xxs/]\0,%|l0,Yg8`р]C\'v\0k܀\0& `O,:	X&\"@`H h4 8Z܁s`I\Z0XӺٛA@XPv/6\"J b\Z \"k\0X:\0Q U5dDG]\06=]lnX[V@.E$.-ض,; ~j >Nu灄@B#8H7H|;؁.v+$ i?s +\n	؍,v4{f7go`>w`^`_N`R<)A=qR M6f0\nH/\02Kg; c\"9P0%kӢ@D g= 3pdQ!p4pY@zs pN\Z\nt_Tp[B@Ipm\Z=(n1\ZY\Z{{%\'F|\0*^&)@(2(OR˧w&W\0`m=P2@k@F:P}|7:S[9Z]rә\05Gf6\0|}E$p@xxx82/4htxt8S4πcÀQG^@6y <xaj\rxi9x9Y	^^Kږmb൷=:$x1x;r)Юc\r	|hK:́O|ϻu/o]#[?@@=\r_ǾU7c\"oN)0KK 4M?Ч |c@ĺDh-/1\'qĝxx6$/E.8(Z;]ˢ@@k@$P2[߀2hPu:HDT3@f\'{ GܺP\0UAUR\0~P-En8Uj饁ZZ|AM~!Uj?j?{*\r:A-vpp)8DWZ;@Wh84-zq	8l0p4N\r_[\rp?8X\Z}M\0]A;A	@8.8\Z\\}Z м{*gpb8\0h9v>hh5JN\0@kh\rh}lmN^mAoE/@;~U8i?>&/\'?O\0|D@@\'pZz!<8=]#~3g3G35\r+GYnn_A!8XyE\r$%!o==Ꟁgp\0/yhApQ\ZK:R..n烾K=GKTkeWd+OW|7]W>G0آ4W]\0WX	{0?^Xuǀ#߂!Mu+>oQ>3F4\0^5	>	F>n\\]< \r\npLp+Vf=u7m2p[Wpۉ}\'0nb\0I`,p;Ll6GX)&\n&?w}H{{=\0߯*Sx-e`ڑ+`r0\r>hxpD0[=*p灇^\0RlUݞ\0\0s1c/U`\"38_R\n̛\0512 y6X,<x9*XX,`3%OMY+s<&<\r,60K@0<0lXe3JB0+.+g)7gxyE\\H+FEWo?E<kC9u5,ޮowuw^Ƹ\'Р	>\nj\0}qw=`S=-{(\'oi$l-#g/_$//Ԃ+W?u\0	sߵz{^Cct<1<\0vmONsۧO/ ~U>}8X	v]:X\nv{D{N?1bo2_WvWu6\Z#?࿲0k;W; 47Cp #\n{0\0v|!b9.y l1m#!r\'\Z\n!ѼXH%:+!驫[Hfɾ\\SŐ-D\ri\'!h)1Rj/w, ά!?H0	VG!a$49 wA4_HG{O\r\rt<{\r˟}Wwo@CAܞA|AJa Â+Ј5Yrh#\Z\n2%!Fi-FF\'L4Bcd%И+ 3dȜ\"]-8$Ȳp*dYBV@\'C,t $dmMX k ErHQBsSiِhڪ7ȹ;l\0\0M\'Ch.ճr]=rr}5*=$4O_<	-<C $IxAs]4hBo3h=Z4|=+Sȫv\'yZCK<AK%ի!! x}\Z  7wOfB+\r@+ch垅ʻáo@+{CP`;h;Z5Zդ\"h5v7VB/Ck\ZPH(t:_d(!;~hR	,	5brnAVB+>A[C[w|,=I$03J9\0%\nmjЎ(ɴJ%m/%\n%_vM\nqOA)g_@)/ڠTq%tVO|\0L	\neAfYP(9Opy(kHkCG8tditȓ(g{k	_\r?~ʷ̀#G@CwC\'_		YЉ[*Zj}	BCET9*>*	Ag\n~CŊPq*?*)̂JNι*swCcʠp|7tT2TAWA3%/	t	UM_Uqn]]MBGk	kC5\rPGtscLX9\0i: :׮ݏzj=5n\'BO@@uPwj3%Yk\rzMzmrԾ9zqeԑiu\nuz:ʠOZ~MЗoзFNr	u{_ks3zPoUsmgaWA<R>{пlFa4q0zm`Fuw`&/Är܂I`L(	[KM%\'Kɰ,\ne?a:*_F7`eV&0C`Ns`˰qXXΰt5,4\ZdXCk:\"u|&:mPx}>!]{C0<6t><\04\09\r`Ol\\k	|MY^$6wh-V6k`Ex|=غlS4m6¶_Rėn>~!<9v};\\4\rSoiӪ_ӞR(y\rعB?]*q	gN\r0gfngnR`bxN<P=w/ج=`]xx>xѹW?x}x[.|t}F$qx\r0PxCexxYjxY+OoU	\rKag\r\0^Yp	ژÁk\Z`>޸^=E}Aap[mሳYpy1	#oQ3]8t11l!ǂ;x[(x6sy\0ǏW-__;hxǑpҴhx\'>v#y;8x_{TISqkC74[N[_no[\rs78c6g	gfK:#M>Q>z>f>LyGpޣp	\"\n>p>>	,;§N]YE\"H̰ٚmK..Yu.9>r|<.cS\rp!pm\\u!|1Z%&g.|\rµpv-#62ckqku.sWe?q<m@>n7oÏVMZǧOfͻg5w~Q9n=L/=W+W?UH^]-߫w6XF;~)o5x*oMgwr\roww?6{\Z=s1ý:˫_#_\'?^K#_p?[<\0>\"@n>7So#h}=D^q!D<9\0ND$!/R9!&MDu$BO#JaL}؊poG_ sWNDQGDxv\nѲhE ZmLDn_h\rD GtCt~5\"ŝoDDG1{NF>@!!1\\w1\n@֚\"F}v蟦}bڸ\'2f>bVeK& ^o]\"u\'2[jX*G#g+ub	%Ґu}\\daȤc+{{	2eq{q(F!N:iayCc*|<q>qrq9}<^	2Պ%Y[713\Z2j\"2B\Z2)23D﹇̯Z,x!a%gsx,ܾY!^o@#KjZ	R}CdUC2h$gA +NBUYH*Yٽ	\\	FmU?U4(ІǝEOBVEV7CLđ5G	)XN[֤#KA$Zdnnsd\"YTl\0h$:]qqG6Ȗ)ȶÑm)xj$$,Z$$$Ew7J$,$\rsٹ|\"{!{uW {#{?mF]@Sϐ>  )\")\ZERCR7\"\" #i[ u$$sxиa.pb3uE: ٽ{޻ȱH6=!ybJ9y9YmiEhrr\0r&\n9S9k9;3rR<)EJ,s}<R:7R>P͡gHD8rI\\?\Z<B.!W^k# w*&*:aR%NmDjGjn#7:JZHHo䦤َ !QH]1r/[{\'r-4#U\"5H)G{ȓ7{ޅHȳ,Ke$1¿yyyE!mH8\Ze&NykyywyꁴK;H{m?8C\\v=D:_\"V|C>@>8B,[|)B@.B|ьF~h ހR7-4{>z}U@&; }KH3	_po(\'\nu:	Eʛ(\ZEk(tBq(YEŢش?ʮODB3PF/e>c(ېr#PpTsd5ܨA<~Pq*T/2ߠzPRT7?F٨Aj-BCGOGIq:lLPfQCPB-]j5:\":7\"j\Z@\\Va7{e脕5cQ}cщ>N޲ǡuPǙCQ:Tgixt=u)B]ζӱ2tz=x:Ctɖn[e;:Ξzu{	S΍[뚌|.0z {zT.=\rђ>Eo6[rkDW4EЕ+=+`te>ڄJnDգo/;!cסޛѰ\'4|G,\Z]k]?-!x\ZI8\'E7\Zi.B7E7/1hlc95e\Z*G_	S_/[Sѝ5hLc4%CwnE\r>}7no5wM1@SmBSXBSGѴ}Uhz0Vf|f@3բl|#\nѬ1uh֭hV4gM@s\"МX4e(a$zd4-E(F󲖡3t|h~4=qFOCOm@X-ЎEƬCNFOBO{FO?$%ZB0L\rZt-u-+G/eW\\޷UUaNh5rF+kk%{k_XzbZk֮qBoR^zv(Κ}}Wz?&\0}([>\\>hIa6GhmT>GuS3}Vb씢-wG9zOr\"5}5}e݇Z}}=	}=Q(nrm\ZmcOtED?G;lG/c,v}B?߃~<\Z~iFjMF_DFF\rhuȣݣCsў/ץFtBC!STo֍G@3\0RO0\ZcX{_~?\r#]0;vDyLl}0lLb`Ibw1نQyqS\Zĸ32/?jbNz-L}SaSO5ibU0	Ssln{ Ӄ0?1WIHSlhB\"6,~\r6[fZ\r/_*F[O5/ ̴&c/k{663\Z[gTY,1lLl|-6a	f3/f3f˿l1ۨ$66iYMYM)9ama7Ci6;2sHa?،#Y5 &ܨcn̝sgbs+ߞؼ7ؼo?6q)\0-h<as1=gR[SyŃa%?`>Kea&]b+z!tލ|5|q|{[5e4:\\g$Bta!XLª`gᳱuغu؆ǽ؆g\r_]XXXtq>܄mmmN8m>t۲=ǶfZI\rXxp=KmaU*x;K%ݷvŒYlbplϔ5؞ؾIkLK=i.\'`ðX4,3x\rvh찏?e˺nebi4c܃;N-:c<t\'婶byw\r|h!v;	N?\nDc-t`EqXu.&3ؙu,VJǊ-!XɡXIe\\Ft9+Ji꿼%Du!%V*n*KZإo[zؕ/Xen;]f?n`mOk\'7b\rcחbo.\rjb={\rU\rc؍;؍X-7\r}	]=!:Z%ѵX9X%5B_\']Xs%lt,<kV2ZX3bc/Wb//Ea-0[7wg}o>ľ*Xj+{2],~GҰQY/,\\vZ?N#HoB,܇;q\0G<q\\\'M\'q	\\rk.ҟSqhjYhӊsquF\\(݂kt\Zcmk߶5::p\rJ|>d5>d[\\Rz۾z{p6~]iB|>VGtōq~nnrt=>*<>D%>MOt`]8ռ͇|m,nm[؄p|l;|z\n<Oŭnu=w8v\'Tmln6z[M-n	]7vzpw`k|JO?w[;M;Mq#\rԘd|jZ݅O;]K>0n0ggE\0O|Vw%>;\Z>7n,>5>_e/y[/؏/|\n_qz{u^\Z0vƽ/V>ǃqOKR6|2\n)Skp\'^ʐx >_%_5z	i^p_p4:}_ãOj{3Ou:u:ay|	xuxd<xYaG7\ZN7޿Gs?1&5xg<&y\Zio|ee46|qxj|zi(m	^4t<a<6|GG<5s|g[%;OuW2:2h5|/ﻢ?O	SҏZTO-xz&~~0x%1Eg,3	OxfC<~ȁ-XdjO/ŏxŏ\\{y4E5۞ ʇɠ9T/?/Z\\?৭wOOiOwƋػxQ]nb\"xma_ey?~?	~+|\"__v_	Ư,}WjVU%3xx>:~=~m0yc[j\\8519,~SӉߜo෿Xw5;CsCxpk!~oP,8 8e.x*o𦵾xfiT7ݚ71,X??؅:l7[/q_xu-N\0qױq)t[W.ߗ<?<;|Ymz/϶3gS/Mg7_{,ook]\Z.gw6êqfk{7xoa\'i]>Պ~х?&[߁x_;*@1_r|A_G0Մ\0K)zw@?@v0N?Bh04\'-0!$d)Urw$&;Clg7p]|	>b/*^Pe00y}\ZCh%7ڃf_w`b\"1xbh11DaC}%\ZD,aP3ZVSE	\" ;NxK$#i[bH#CxUDv01!FFѫ>iHbEbLT\'aDX{NX|N~B|K/y\"a9O|OX~]IX|$񖫉			/1aA})%	΄nbʃ/ĔvC%ILwSSWN6#ӷQĴ	g넳+\\H\'\\FU.%,1#p=1h&fE\"Y\'r	7I۳ۛɀpv\"܏%	ĜpbT[	6S/t]Nx$/cX<=XbA,~J,$|W|X*#f KK\"t;	\")X9d\Z.lHk5ïk̈5	DR#\"$fO R:vXKl\\DDWQ?kE-Ħ@bAl>Nl2]1ݿZtضÜN=o&׉DEDd54̄H:<؅&vF#ݏ=6=SL\'܈+܉ډ)=Dc688p-qLfHDF#yDzaՏ!8dHr\'`k\"4i#eܡ\'ZoDfs_<8DdcD#DѴD(\n<OugADK(u\\BO7[O\'.&.ڏeDWJr\'(?辒XM\\|򕨨\'.!*)QQuh(Qd`FW7\\p	Q{ً9}q&ekEܺB>BMgNYO܉xCܩ_AMcN\'Mk)}wr)`\n⡍-oQ7oL&\ZDC\"Q;Ԛh|YL<YA<I< %!-̈gCY9keq%-xA@$xxxyO|\\FDԽEt.J|6#>Ӵoi7lKGt\'|Ӊw3DH@opG񻦛ӫE{}?~ӟS>1px.%/H ah.VZ 1q#q/AGWs$	986rS$֏= B8I?#3?d\ZHvh)ɾBy$簞X\\i3:T!)<Oj=!5NZ$R\r59ZI\Zމ$/%\"\rRQ ݚ4+\'-AHC>4O}\Z9brNrd0r!iIi|c:i|k7i\"MF&H2\'<si֑c\'_%ǥ+IѣH+Xrd9^JKlYO6&m mgoH5D9UM:yI:%1q;HNYDN%MNFN˯#wΩ^KNI׳WIHwc{S#i&LyD)Nέay<g4ҳdą\\dD.*\'<H䳤ס}b߿gZWN!}cҵɥ	{ȥ?-eeKI?ă\\fN.@CNhM\']ɀɕO:r䪿`?j#sr\rB\r C\"2w2ʜ᧋2\"4(|L/%>&וuGLf>O##GFndd/FFS(Kuȍ1h2:y4	#7JnOn*~FnlDƬLƴ-\'7;DnNYOƙ\"m$Jčdǟ5ɤ_dR73$ddr׶Nr7#&ɳBd-Εd=r9)@fUYdV+n\'S<RFc/=\\\rK^}HEk:O˴N\nd+Y$Rk#Ӽ-yD\ZY ~&<!-F`#ynZ\"yYC^M!/m\'&\'˶=\'lrJ<|-Y~=y1MNVKZ:䥩/JGd=y`yY=5YIVo!:\"%yXf+YSJֺe7N7k[M<${K>pJ\'\\t CcaiU{18Ml-&nM.Ko{\'kޓO=fY*lO6O Wo!zggg_Ed˟R;6d5|S|=|;||[n!\'ۯƐk5=ò0QD~6?D~N~9RJ~[]Fx]Mv?u&{r^h_JW=@Db?-ɿV{Ⱦɿ~(=\"pUR.dm\"TvPDL>\"Hlc.z+{k(|8QXFxKh\"fZuoD\"\"fע!;4!BDHޝ_\"g\"a\rEG&F:o;/2~/\ZA4vmhܰѢqwAxH\"\Z?\\#6!<Ed\',MM.s9\"G\"ǖ]Ѵ3ED.D3Df.#ro=&,;shޠyCψryg<NOytZ-(ZTghoF|2)Oȧmchoh\\sъ?\"7E+lD+?cEAC/T¾6o.w\'Z{VhCPhCц*R^ѦnGQLB9hx(Bx(	>+yRHh4D)!٢Wǋsg>>/0_+-x&:4Ht(c(B()T#dHmDGM\rEG:DG>rn!:(Q;щ(mQhpZQѲzQQP	kDDJFJf΋DD*kEeVʂD凵EgBD3EDWfU&鋮nUD׮]PtnF#,Ɖn~28.݉4YEQvQCRhOQ讨)XT0A8K*zq5+5\'E/bE/^NX.jm,zy^z,j)z3hM[\n;4QǖD>/[(BїD䑢gEE]D7x(o}Q&߃6ѿbJ,F&UQ1(&]bQX%K˶eّblX],8-2X1\\?=ż\"dXFVGJT<t5P	bCC<|xD\\#{xQ\rcYVYjتC<NUbkPlTl$X</WlJ<@?S;zb6bO.eltf`صP<kUxֳ/b=bb$9]kT=bۗ-^PKFkEK;։WmA_)Ł+~WIūj8tDCg4έfquxMvMcqx\\-qjSq<tC$|	\Zwz4K{!ޖ.ޟũQjiӒkO>Jggi֟#마w_>]\\,>(.*>e(.{G\\ء9nrnĥo։ƒC/}W*Wĉ/{/o._#R+ڔ ;!m-H|qqV[Cķwn9U|w(~P%~chq%\'nw7M7|7\nō[M:\'`q[73/_4:_ŭ6G-Ƈů7M;ix+ğx)kşdo[]wV{{>6l?:ſX&AK\Z$r	.K%xc	XB> !Z7HHiX\"\"~HD$[%bm=(]0A\n	{Or(Qs d\"d2dІ\'FƝx[n6^D ]%C?[\"1<m.NosIb{EbX2ꌣdTQhdd%=$G;I&Jl^Ml]3}dွq\'T#B2L4<NtĩadZYĹdF,dfnɬk	I.wK`$d$~CJGUd?bg$KgH_6KIDI<#Y<X$[+Z%Y͐!oLϑ8IV\\Jn\'Yg+	z\Z(	zMfed뽒5?%!%a֒$I{G%Iă\nZ,ɺ	h|d\0I6x\"umlJ^ml+I&iGHvKOHx{H\";do	%JǙHR}HL͐}-PK2Irl$QPrtXrtbLWI\\eܽŀ$i	}7ɉ풂SSHNeސ:Lr!ٙ$>I%n$>*IU%e+$e]\nT\\_RHrm^[o%wxS%u:5]{s%v~XwQ9I%vђےg%#s%ϯH^ yKbIɋˣ%\rݳ=씼,yIﳔ|0|^J>Ŭ|WK>7||&3HmHɷc$otkJzT;3K%?GI~<(m+*xzI\n٭BSl0u]I	iT$KO$KeCRER/I^\\;-՚(ZuKmX:\"wtD?ȩ#äF¥&`tK:J!5t̆*kff{R/.WwJǎI:6P:Uj͍$ڴImg6<Hv߂FK\'ڏ#V,JS-BS[Jfܗ:eNi\rJg:*uv礳Gq)TJ88K=)C-FH̥ORdԻO)m,]v8P\')&K-\Z0ĤU6KZ&i9i\"i{4DV#\r,\rJCuIC#>H^nuF\Z}F:ҨS1^I7IMɔ҄;&H&WJw.]]\"mI?ɔ\\֔JWK3͐fՌfߴu =zwI]\\z3i*=5ll}ܺ򃷤cii\'T-TZ&!\'޻Kzփf;K}uqҺ{pޥpaNfG+\"5QƺҦ	\'sNJߔ>Qi%i疑ofH_zIێJ_[%}kHvK̗߭~ ؽMy%BiZYK6Xua?T{ni_Ү\"eCiFߕ/*!GڏG/2J~<He3s~AK&ID\\.eҀ-2iL~PR/ϥʘrLbdKu?.cۗ3dOq2vLL;vlPt8`tlpcL7Ljllh0D6VxM	rG65>$35>=LY=#[,wZf	JGp|}h|lJ\'cH6mlIuled*@[B<D6y,$?>L6\'EF9XZ0{vw6bH\Z ÿɖo+m_<d\rͲgddk:uKdd?e3e;ɢɢO6.Ŭ/۲u,0Y(v]g,\'e	#e	˶{xwNDTK]Rgzad{\ne}).;Bv ;X\";X7D;L\'Yv=U#9cV~c{]e>ee\n<ܕ&;c(+\\ ;7gmم0Y	KsWv.PvœUɮjnzdw\'ꂞZeϔ=l {<]Dy[,)kt=KY\"k!\\e-]Ke!K쥱e -{Y<BxSZ&Q־CgCv]IY.l%V..v{%kdrd}5?Eoe]27|\rFn-GFQ09Np9~RN,\'~-nE%\\jeyrqGNXȕl69{\\-I7`\">kW5uNx9r{Aܰ|-#o}Ms&GdMM5MKjf?7\'Qe,J[g\'x[wm,Or1/*w:yLq@>mE*rW?9rkssNF{/\Z*_tY[ܣ\'HbܳH(E_(s˾@uZ{K>/5ZxA|B||]N&}<7y9y#y<\"|yn|LGQ1Jq<:I_ 4w|t?|X~<nyyvHyr|ׂ]74uSޥS%򃋶ź˳˳og~(>[<H0C~<OGMEcE/+Kgɋ\rS%ez\"/G~ixyeyiyub\Z&͆J́[\n6C|ߖ]?a*onʛCM5gfg_[Yem-WۻX;C3U-iOZO˝?}Y>X4#4Z\0 Зzޝ?*{OW.ם.=AeJ!\\\nPP\n_D/Ph=|\"Q)Ŕ8`<%$!JXJl)ٵ9Jn6@\r(AQ)HGQSӧC(.ŵPR\\K#(MbJ˚(7MXRCPC\\<NθB}I3)}`\0~FSCQRjX=j/k0{655b5Q 5\ZG|]CMM(K[(?5es\Ze\ZZK~F1\n%ٵT|yb=H=}\Zg\Zb+5nS?5n>j\reuv5~e̖lć(;]X85e25eLM	C9YH9lzSʩrEQ.))tEW_)<aCx~f-:H	{)7&mr?6ro79@_KDPRCKy-]R^\"))_p7廗nF-+EfP~wZ?((\n9*njTb*p<j\ZjrjuR\rj<\n;KP㩵Op𣛊,KE^ZLm2vNQѷMP>o6wRNR[&(-s8X*tc9XDZATҦ[T#uʞu&ۥ={\"@Dظ:pԗJKϒP鯏S\rSQ#⨃Y?MTEe8Σ0=L:#6PzaT~\\JoN0:zak:1$:q7:;:Ǎ*z::c!Ux:6:s+u@yR%ڨeT)*~:UvzUʏQ?QFbsr	uyU=j1uNFg:UfU$eQjQ;Nv]^?Rꁣ.`\r!S Ѳj`E5G5U$RSӔԓɁSG\rLϗz^HHnBkt՞jj/QǨ7è7qꝎ.v	.8Ju\"AԧA~N?Kd5&ɩoKo.OTWfMo~NAr-~Ϸ_Tr7*NRΕ\nhR*YK(^:[ARȂ\nY?ܨMAݲS(+wJ9\neBY٠`4M\n|G)<uCG+A\nu90\"\\=D(\\14TxVcz\nA-\no*F^B1⟛b\nM\nҏ\nkk&Tdp$xd)J1V+,W	Py>MaFlWyWy08(,VD+ƾ?7X1b\n˹\n	7:^+lM\nc/vZuI.*&}^7r9\ZR8{Ӳ(NR8Pq\n8ŌlL^Ŭi!\n7SFemF1[bybvHD<y\"\Z,(< X:Rp0Ţ1c($s[ދKV,鹦𭟤X{_qbYBdby|\ny\nP79cCuns(\\Q/Tr~MlB|=Wm\"T)l7+»+(\"녈q}*֮;X@*EM_+Ɋ<Em+6)+v0;MPH?ؕ)v\'J{GSu[*RWe+R7MVnQ7(;}(2|)26(22š&q*?YfAIw?GvKG\nRǅ3<%|4E~ɽ\'AEvbNQ8bӿE[Պb؇TeW]rZEQ\\ZtUq}JIEeE2_QuVQTÉj;Euz\nў(n\\TjwUNx*]Kum:ox pqqEchhj-R<zx**摊fpEs~ųEKsm6(^/tR(ޝxR~EGLsJSS_ŗ]	E~O{ů_y__a\"*!\ZVF\Zi\rͦCu4rI4\ZX\\\Z_/J\ZPAgh^-V=Ą%/ӒiYIMOgh,Ѳio:\04[Gsw_*/SѪhuH6qui!>Zњ˾I5}<=u1SC:Ѓmja[u\rZ衃uA0=4G>tiFzm\Z]H\\8cfƋhP/h\00m0ҾH[ҧ:	E=Tum5m2i_(m_MS*GSTj=uzٓyS=͹@DLF쩠]j.koӮXP/aJܧE϶8H~@Hhhh=\'@n=IzZE/O/	ʧ}nͼAO<?L~+\n\02:0HC\"yѫ5EZ:wPG5k-j@EM<zm\rA]MoP騭\r c:}z{5?YGHoHc7ӱNѱQӆtt/3:n]O\'-S:qR:8CC\'/}w,;g;͡wtrV!KG:L\n֢w8NT)3)Wt\n:uGs*}#~MN\ZDgN3҇sC^atVݢ	H?i>hIk_I&Tyq:tbw )]p.>ӧnӧkŮWȇ.KFL;s=9At];}>m8}*s]\rqmg1}jEթk=Zy}KM2עoOo_LE7uQ=>O~b,]x?5nؾ~$ʥя\Zҍ^ǟO=7}Π[-ޙt||E\0zNniD>w_n~AlJ2`O\rC;~үI􇃓sY4AwlKwННˏӝ·&\'Spuu25TBGdLw-@w-\"f]Gݿ=_c>|e%/؁>*k%:d[8BtS`RsE)ʵP?nRJyJ{J(Rh*ΉJBILQқLAwO*S*\\\ZT^TES\nfRxG)Rj)(GnQj?U~Z9$	]ޕJ}eHK9uʑF/)Jc;{(z㳔cw++ͼ&?cyrܔq7Z9{Қ6ً6o5ʉυ)\'<W0J{줜|A9sSN}R4S$+W:V:;vlrZr5>uҵLz~OÙ(g2WW7Q	3A9rsZl\\grIⲳJoJ\\϶J_7J__cnCXe˾+(וˋF+TDrp2HI*ە\'(Wo^\\}_FFU_QVʵ	2:Qsح\\7I^erSwU(c)ʘ-<߯fW[}Qn{F*>)づws+#b	m[@;ܾWnOߢL|3I(\'PjR?+wJUKKUʔ4seZeece̘hl<4Qyh}PBCQz;e#Vʣ1ʣ6ʣeWǰJe\"oe[2/(SZ̿(O٤,P)&+OǕ7+W1HyV<=Dyh/eHezdfħZYt]Y*<wyLy=,#*ˬo(/^Ɣo~SVX*+>Q^۫cJ}_+/.*tRVY+UٯU]էieu嵂O򖃧֮7qÔT\'̔w$m;Λʻ˗*lbVi򁡞reciS@D옋elEM+)_l3|=\'L\'W!廪Be{h^eR1SvʯǔW~?>O5EPvCʞweg`/3(ߗ*UKg\0faM`ۯ3ҥ4\'72qQ0ɌX:40Ji3a;ީQjHFؖh̓ߌdF[]h{3Ͼ23:%/g62C\'1F4Fo;F2{0	ڌ~)1t\\ˌc<c\\1r1IɌZ^\Z|gdX$a,Ǽd.`{ɘ{yu@c/d&3BII0p,35i1iٌӪ\0Ʃqze}eӭ2G;;n3:3;3x!`tffAbc(3jKx[1>W2_c	ko,ݪ,m\r`,[,YL@])r{J4Y)L\\&8	?΄Lτ3!LH.&.bɄ1aVQLX&-	7D|_Ϭ{Ĭkc}[ì7Dd\"C\"ՇWCUۙL*fcD11gօ9̶!Lw0IH$d3	LL+]&I/]Ic3{˘=v33)h5I2顣N2A9LfX&K5\rgnoc#F09cRY=9rm	s\rsoKerۘܛr&\'&R`^Oc=_0\'OdN2ɴɜLAsLJm38sf#SO`/0ŏ23B&3_`./}QLybL&b.Mg.aa\\T.`*L4su/S\0Szsc<\\?\\L:z L\"scndnVG37_52\"2e=e0,e}Oyy<|-g/0LLi9i_C\'3\'棝̳Og0-̋+K3/S6y}?y<¼ryqa͘sL\ṙ2M\\gwFL|y\0%ArȁK1_Sqk)|c1߷cg̮0]쥙c.< 7{ߙkFCfhb29B90]>BX(~\"h9bOo{<K ,2/V4+9 g~X/9KG׬26fi,~R\rX49|ebmYI#=U\rذjPVq+HpVKjX8|4a{?gCeZVWs5cusQV7̜շSzAX֠5x\ZZep;c_Ŏ O#,숻HȴaQ7c\'fYGk>\"5-6Ys}e͎5y5qq//V#CӤk=k}y%kژf6yZD֎NZe\'5d\'}du(ཟuֳNo&_XsX~D`N=a4`笟iy+Ʋ\nBXcX/ŬR].`\'׳KjjOe}GTsKel17wCͮήg%ӭ\rz%\Z]bCk\rƆΆi=aFapR6BkۿGf6BnamhO6:d;nncxx[۾q6s6.o-MMg.`lٝ-vgR6yR{2vϚCikB6u^6u&@$6my6r*qQffBCllN9q=:a9{tihJ>{M{li {l;6d){<7^ĞаcF^lahY\Z{:`\0/ٳgjŎ?ْZܖb[ܣ3H[ߏd/gTrryY`jd]daOސG7FH={j։uVWT{k{T%2܅}0<ia|GG͟ǚA9lsJ\\}6}ЃmS̶<7dLb/Ǿ7}yr<J5}˂}mnþ}Ɉ}kξ2mosf~=0r/y+	~~޻RZ~hد9$;|>aǲyl6Q̟]\Z`{}6k}d}qlj,_(-؁;9l́$栦\\X!w9d<{8s2#p/x)\')7꩜d\Z\'q20rPj)p3;1Mg9VgǾ8q|]Rp5a6n	9e\ZY4pN{g7(t0c\rtc93ATK7nؑP?nx7b=7d,7$yY͍lXM医q&Q߸Qm]nn׳8S3\r.4/qmCBшY9ǍO)ƧqZ-8M!`$g7.gtgoQMMl&_⦞খsS+h%sRMSdr,_87xxt7`	7wDn9[nn^1nL,-VqɜG.S&<&*VsfqcnrK<9͜[u90Л[\Z,pnr~zC?,8.8P\'r+>q,}2n&.XtB&qдR.[-֣?	OhnwcLb~Ŷq[ør,%]%UuqT=Nܞ;Krs\'_ʥ{q)4>K˥7wNeC?<37;(+c=[\\˻^]p\'mNÝZ\n>[iWaϝvsgΎ Y\\[WR;Ý>ʕR5W9++̕\r+ʦ[res~~pHWAsfusWor[ʯkڸ돓܍4W;6Y{UqwNquh&wO3b{rl\nÑ9gQW_kx{tk\\kx=+_=\Zõ,3b2g?\Z26vژkY̵>\'cil1]:pݟu5}t羖\'vp]Cչ֪+g7<p&qr8s}p}ڄ!<ZCR.LGz<Qw	5Q	o籧n<\'GI\"^4mE{xÿ%NR^SKTFO\nx4LxEIOlsymygl=kU\'_:s?7!GNS~󆧵x2~_L~Ğ ~{r7I+M:QFѱ4oZΛ>ď͔Spbzok[i-uWV8jl\"o	?f??-Pn[omjLy۠w)=%ϞOOYO);3si)He-eû3DyCcj~~V/»2y-n|K^[C\'G+\'NwJ ?ʄ~[#U`:`k8\"_χ!o/PlzvlL#bg~Z9_/G##Q_\nT^oju7uM7Gf[v4[~,>nA><K|o+D+6T%Bݦ3=^ OS-|ZAV?UgYe|>4v	SpϩiS1wU:2>.\'\'wz*`_pm_8/hOmO_G.K~Eu|QgI5%	ف|q;$2/)ß{__j/4MLeG\0!_Wvd+NzjmZG݅g7b[-em`vsgxg߭\'UV.;?,ׯ;77~7?\'\rS`*j9oHᛝ\\-U=/9|k:%/#3W6~\"f˿UoRos!}};cx=wVm\'^_<忶oo|.wGG__&z<_Uyo_ÿM\'kUy~FLV*p\n0DnvRU_BWaΩWU*QEhT{\\%\\%;o|\nT*<LE{9*dzU짗*J5P%0E*hJ)RiN<SiOUi\'ViWRt&lP\rƽTNLuK5Sҏ|ҿ`2\Z_e4|bdEjTըtըhT5ڋVS^WюPKRTmTTݪK.V$%IUeS|~DDpjN* [4ʱQ}jZ4y9C*Y*Cǅ7WMVX8_5stQٵTj{L{B{EjqTs|UsZUs~榾Q\\w^5j*;*#UR-\\QjQ?c\rUӎZC}!DdrϏ*_iʷF,bjV=ڵ#TT*Tl<Zy**8^Y4d@S>w^F*d2UHB*TK\nۤ\n\nTUk;W֫U\'ǫ6\rثb-͜*j/֪<U©oĊfՎ4ծ8վڥMcTݪKf\"ҵU#T{TO,l*;WѪcU^\\Un*}xTu<FuVt_*Xf*(:_\nPVuUmTJNfJ*uS\0򒛪&{b`b0Uv%+Pu)JuY[u4CueՕ=ꉪ>aT_TkCM\\>ZuYU榪oE{χ?Q=ϺjXjTMFI쟪ǋtTOE{T͉=KT^^f^f^<QO\r6Toՙ-|zU`U[9TufUL>Y\\[qo\r#TߞTu[8UOLՏ?OUq՟TSū~W3F_j\Z8`fj\ZITCǎW#qG5qA&^TE&jqF-s|SjzWV\'ՊjGLU+}j9\'jZpثf5?v\ndD=N_=qz,~jAB%uA:bCE#R4U|rFmqLmtF6NUM&i\rjWգ?MӖǘP7S[S?yV{Hm9az<)>jk&Em=[_mQmsPzģv[mPOQ=@zJBzJAK=՘UOR=\nyjmMicoޫ]3GS袞+U>4\\>}IzTQ;wz깝36=_4.T/V/+R/]TY^ڧ^|Bv>޴E$^$CTRWKwک2jڿ:`xzj:P.VSZ9W7Wk׫C­!y.PVk\'Q4TJG|UopxZVo\\j4zӼM\ZuBul:0Vփq\'[Iu\ZzV^Iu΅UꝗcCNQ8xLV-U;VN1SSU>bNox>UQ4R}h|v#+YzU6A\\=y!f\'6O<;> 2Y}Kuhua*CԧgYuc$S]ݧ>Ͽ/lTŰDE`ŷ\nH%9˳՗_R_9,2S_~[[ǫoLQ߈[q㶺v|\ncwW%g_W~`rF<Q?t$Y%Տ7^Hdq~wO~ʠ竛fUPܽMjoXn0Rn4j߾VTn_F~tc u@~ӽ{/\'Ww9Wh{Ҷ8mQtWk^=SԿ,PyQ7Wx/Q2| F	ZBr;k#`	8C#<o	$L%FAGj{l\'A>TP&8es\nA_P\"ό\"A褠\"LОD RA;EBd!wI~-AZd040G0<A_~Gހ\nFwqe0r-Xhc\ncwcc3f0qpaRaR0+^|{GZYo;*L.8\0K\'\\H;NS5VHp	fWsRyV~¼¼W<\rǸ\".,E2_\'xu7KG²$\\/	:3Boª4WS_Bpzauaͅz!DBD!th!4A=QV-DDl+!n&Mq6\\6\"BTFpT4#9&	1҅揃--2\"maBB\\8!+C8_o/{DB~RHH*l-l	YZ$ǗBl7agwa?=W{\n_!e!R\rT=!u;쒐&o	g|#dr2!cR!㷋%d˄CCӄ+:,OBVJM8	1#1Ocs{Q˅5p|XZ!O!Z!Q!?!QOsNoNbSnWB3sQ¹qB&rsBAPD(	.9\'\\9_l6K\\O(\\UZ(T	՟ٵ2frpjnlnDX	,-prR$Yr\\(Ed]npF\\w]Wgp\\xP?Us?BBc\'Oh\ZRx<Bxj7DxbtO,UhYVhyn$<*<+.	/\n8{Sk6cv-Vh,o-\"k B{~7CY)|>\nÄ\Z@:M/G6)BJ2Qv-H\Z@辒$z0B.gSUGY.!\\F}\0Q\ZvxOk\rdدj\rJנ^ha\Z\'\r9L#ھQ#H#Movȯ5hOfkk5~\r]sHTO(?k75\\3>M4_\ZZ-@#MhE4:4:/Ojt:?h?EFkNi5Nr0JK3l\"1+4F\ZQS(QQM5~֌\Z1Ќ	~,<|SƢCK3@fr͸K\Z\Zy	}C4I56\r5vNةk\\2f͔4{-5S4SM4Nssu/.L\ZK5LfR3kgqQqtT|f\\fGA͂ߗ544ς4sfhB4^5V;4͒ٴyMح۰S|fEtfE[&@{&i&Cf}ʥ5+hV~]Y5fռRMP*	xYy8oǑQܹsg:wI(JBD6!RfRJ}\r%T$K҂h~|><s=3!]7A8PL9N8uEQ%R^R8N]@8Ppc̯= B@,!`!m?g=\rz΄iKKM[.B	PD~p#BY\0!҂pãp7GvpXB/b-&@9+GHIH<KH,p%wwf>lB2EHr\0$zRkMV	na5[K+8C߻YDxH$<t[DxHx̛ݘ8?cF-Em%C6SBvBٕBIjBP~PoK=Pw{1FBEB}-pАGh&45|$<!<BxqţyY:Fhnr\'ZiVaBXBk,s\nՑτ	)Jτ%#ΈM,+[bKOJE6G.J>FY]Om!>&	}>K	}O	Ǭ	g\'	DƕU.v5âۄԣu	_	EI%?$	aϘ0N!ȯ&YM\\JN5@]XOs\nav0kGWB{y]$GZ\'Dv*Qˌ<@\\0CQ-v\'Q=%j~k$.٫JԚ!.ݕB~F&Hu^uuozzy+~>$~H\\mHྋDH\\dr~JDCo	D:n<!2䜉D=D\Z+\'\"#ȹ6!li@G(!_qmǈ(D(=E݆DY?@N4N\"\rDD#Zq:qͯ@:⺚h\r\'<qnR~܇QEq	h6CK|D@;-%-E^DQ%n4q[V&hAi nL0\'ڍLwEݿhNܳb%q*qϼ\"с#:\\8LwWiѱJtDt*#:] \\~&%G\'xL<N\r^7c-##zHy{\"%͉$p!,8Gر4@TA#S%[x^=x-\'\"b)ŷKcKpe!Uiblb%gbh1C\n<EFt=HatUx.Q-A%ƙ!9!ƽBL|ASELGL*OLDL~?_눩niG.i3֞\'fxČ/̣̽,ĻWW7<$fW9EGy/!J7tb~XXC,%!bm*cJ,? \Zx~bNbU&bUb=xX!sĦωϯ V_?\'Q$6o|Cl>Dl!x[u]_߸?#;U_[;ЁN%*+d9jbw>g,1Ԅ1\\@v=t+?(8j!=6op9#~ǉ6腝ѸR☑8*\"~&~m\"~{&G}8n%qR/qqj\rqjN@q\'N$\\nEiK&ZuG\\B5&:L2&΍k{aq~=\"\n\n\0%q@4P\nlT\n_@XxX	ŜFŚux@}깿\0\0͓\0NXAg\0+N^\014 ]\0p-\0oa\0L\0)( /m\0]PLz	!{g-ԷhszF]|Zi\0Sc#|0?\0v5`n7\0\0_g%  \\\Z^˿\0j#\0,C݀d: sdy*?5K	\ZrV8\r\0klku\n::;$ظ/1/00g\04r%`kf`I\nXf`CCۀ]\0۵iݭ+س;p꜁˾{]ـ|#8⁃=Ma8<\0\'O[156wN8>A/0[t;}8q8N> X~.ρE@`f>9Lf@6ຎp}kp3i\ZL?D~\"gK<[ JMZ	zD_KnG5\0d Vu%\"8% nj17$@$;`[@J g9Hii@xt<K\02a@m?apW	p&\0V,\09N\'{!@NHu|_\r䙎\0a@m`P|(<	P<%vR#L\r\'\0Ur@՟dfWPs#\0]C\r@cfiw<DOͷO󁧞sfݣ@\Z3EhSZ7~v@5c$xk~B.tځ=8^6+\03q@\\0З0U`\0YK5`q;0v+\0>_h$U^*Ni<&\"t`\"0Li?oo9`;`>A{Ag@hGPE(.]	A7@]+PTI5@@*9\\\r.p\\\0\0uՠ&ԣ3@h9p\"$AR4Ha$D|@%>iAy($fL @6d kf恼ϋAm$(E-(}7Aq\\6(1>J\n@)PT\0bUj\Z\Z@cuxKh	=ہk_p}q7pqpch11X<n5*?3rƛVW[u]hn?9MmO:9@.pϗ󠃠tx,^w\Z#|eNS34:MQ\0tz&2@a!𝏠9虙\0z--\n*Ǐ.7ǻV\'+dg6}\0f^r@N{П?ZOg7(3`w0R^\n^P\0T#BAo{4B	\\^;\rns`\r309\Z/oK؁`	{0>=>Ld̂wJ\r`ҏ\r`rB0E7_;`&\0<uJO)oY ay03[̭=>QL\r<8029o{\r,|,pYFq``,\0p,,Z-p.X\r,\n=y\0Xq+X|,NIS`dg,Xr\n,K/[y{כY:XX	%ei\n`XN\r\r}u,\0˿\r忽\nBU01+l++.TR`E5X1ZV.+?+|_+*f*$V~č`5:VՎ`u9=\0ןR:\roaXsft`J>OەN.X?\r6>\r;B>Pl`C>l;6l5&X\Zl:4[%%f\'҄H\Z+n#*\"|6|5	ofi>;\ZXc`J/ؽn\0~ ?~K{LYp`IbUC49d\n?G[\0d_j΃_7_ͪׯ[o?og\\N^0@/pJN?r@pp>Nӹ	מQw:s/;UW_B)In;NO$$fbؼq8h3I/wZ\ZICI84\"$$.>iɕs$-I+inRA;$$MWN$JZKZѝk|7#`V)V8#8yDH&$ L%A~%:DɧZDSN!1-IS$OHo$΢i\'Sc\0$50ZDII%$\\KyF20I緑Vk˓V%ou϶LT]I&ImH$K;IeI+HJI:6*̨Hf1>s$s5Җ$z\"ˌ(ɆEUdT@Y=gvKH$W%B!$GDoͿ$$ע$7]fJr1Gr\'R-$֎&~I:Āt<-H6}L>>H򾌑|^\Z|\"3#}$/K:e<C:uӗt*Ft)p#$[IcIAy3FVޤG\"I.!]yNȂtM@\nL%;HI들K[I?bHnVD8tg*)IRޠT-)3崒tWN@>D/zOoQEV}H^I_Dzh]Nz}h4!ID<FR޵rR?TqTōTpTvCL*kF* [IǤlTdTsAR@^OΐO\Z\"5#5n#5>\"5=!=\"={l,y}fV1:5zR#Lz\'N\"!u.\0R;H]Ioz\"yR]RRER+i\Zip}Ҡ;Ґ+ii84>/K\Z9<O\ZyK\Z4:N\Z\"M\"{H\Z#}9BY<$M,U#Cv\Z%M?%r$&H?n~a\"|ҟ3ڤYG5Ҝ\n47E˹I[|Q?\n$L\nc!9CoH^~#$Zp$	|7\rb\nRٺR5kT̓+Т!G5Ā4CK@KZ ֍VegHMH;ܔ\ZVIV\"6\"\0f\"{S5 Y\"/+CgB5(kl!tCfļOX[!o\'&C|\'x w4Ԇ!\0$X	<w@fHPAC$gM4!hgЪhՐdmd0c	&@&a\0d5d|,͆r5kКuh:)Z?C6(6t6C\'@f7bh?&dP	YBFVuж!ke:(	?mϿv,v8iA6 h;dG\rwB}:|hZh~vh<\n\\\\@n+C Pt\nt6\nY6<A^!/.\\Kg  qOdo|Aq.C~L!ծ)T:ÆN3MP\'\nr:{?].X*CfbRkХ&ՋբP6\nՖBa(I(,>\nk[sz\"~AInL_A7Z- %+lp({=o\n?%ЯA	롄PB_\'#J.R@\\(8q(\r<Ly\Z9rBw+lN4`\Z\rA	|q{喤@Oe}{oˀ\nAˠ`Uv*X@rr+Ty*C$T<U]7d5BiGz!>\r^f@BAo^7P[1~u8OC闠P\'u~?ϡЇP+d$>eB\'54/h*hhks4FCc[EЗa۠^ZMT;AФ,4=M]Q~&Aӟqh&?\n^B_Arddcd^Y?Yibb$Yy;NV.*1Yd;qdKaojXdM䥣e&5dm!N;d]-YʔB]\"zO&7Udp8=N #h:2S@f-2V8C摹:ܴd]52\"gy Y8N-ɢ\",dim,k\'˦2dlwCd\ZW&2\")zL^sky}yӦ>9\"yGl1lZ	ٺ-y{9N񢞼\"!W\"_$^6 ]N}LH޳ȃƇUG\rHv1\'￙L>p8GvN{.o%#Zn$dw7dc\ZdMd;ȇɇ?G@~ZqT_x\"O#|~C!T֓}\\oɧ#6\"_B\">1\'曑rVm}FM7E|j6j	rH\Z?z#9D%]bk/Rr˿HYOKȷhM=kI=M]GuCCGd6CN:MNFݔ)ryr9}rƏ=̀k̩rV)a|]H_|xlmȏ7M,#?n$?&*\'ٓsItrލIrAwb!(%\\lA.ɥay)O  W;u1Or\\B\'+k[-ɵ\rz\r{trH9A~1# T&_{m-,|	b9+W٪לHrr[-3=wC͉BGA=m^5&Wkv{{3<X<H]\'D^!\nG\rǚzxmq/׭;^\rwɓ|&y,K!I !m!&,IysΏkn;؉\'ҁ<6C@S&jJ?ߟcFfa)X[G_7Lp^`\0+߂=	Rb4|V.ԆUU,``եBx^h`҅55oKKla1Ͱ.5Xgy,cy^b#5um`b#y^iy\Z&`WW0{\r	#0US7ܵ0uj3LiiR;P30IS8c^0;/qp9/\\La-	(,¢*XTd	jG`1hX,KXjOUaUi%lZ_\n5eɞSxc\"xc&lo3\n/1`ؼXzm3l>[?]|xׯ-0lV;ax! \n;8os~z`y	츐;K&a\'	ؙ\nvj]vAcصvc1xRدq>e&xgogSG8 2\"pPR[\rx\0_˟ކ/ހ/K7\'gXwpuCá06tt07V~hXVc>qqR`8^!\rNR\'p2M\'Qp}}8\0Nl3P^NslZG٫\'{OUn	5^d\0E3^pI)\\\Z..{.?]\n*&R᪦pڷX\rW_>W5T\ZϗpL~d\nn\\7.4&,_/ptq_-֗	pk[\')*_׋On_n;N\"uLsr\'Ak_ܝp?-?\\2}+~;\"<СRZ<4֭tb/x<\0i߀/cR W\rظ׀]ɇ_gxnHc)mRQ)r(({,leeeA%eE)<\"褨lܱT_vS)\rP>BYEY{RAI,1֣,Sܵ)Z^]roΚocZ\"Eo8sⷄ2g3BL5Q\0G&8ATR_Z(f\nB>3HAQ&-m1IaS؇P؞w),O\nm7\"~Lms(k0E$*RD4\";7KѷmЧZɦ=ȥ^b(!O)F~Sv|]Q֦l΢4R֫Gٰی)(4eӬ!e!gś`e@,G|y5$PNXPl(6w)vNQRvSu)i)%\')({){;z(vR59PT\\8_S\\L\r).M(3CɑCo_Q<R<4)6y!	g&Au+8?儖rzr2{5{IQ|E;(KRw)FՔ/(g)g)g/SVavsU)O*P.|\\l̡\\2*\\r7LHBOeZ|#%TpZ4E	sC	{rˣ\\@IaNl`Sn\\Jr%smbG~1B״p%1<UGIJ次/(ՙ]LLJHg% dJ\0ʃd\r%Jv#	cI5q9J԰RңP*ʋ:*eJUy:کRR㺟ROI 羣4p)\r^*F5SJq[ZSE_)όHg{RS(R^>|Fi\rMi<CyBimmDiKi\'Pe:M_ROtS(={)=])R>>xJ8u+Qz7|[)fVQVQzS\"((|eGz2fQ\n);(gocɴ󔩃K(?2C(3E_kc(6~2;LQŔ*DNo)\"wJQ`Ŝ/Di\"32E.dQN\"jGO\"5RDcT,q܅,y,۪,;h!:_%D7	Y1\"Q;\01--,A_꫏*|!2E+L=0\"5kF؈>CTEnA9w\"AF~3	K5DDVE  K!#C9b11?u+/ .\nu3u}M}$1uEֻT!Mg7d|1ETqs)ȶ?ȶdJvG׌ ;8#NndndȮKkhĎmAݍMJE\nQ9=<G!/|D\\/f#G#GGc-Khnh#D ^\"#6 ꢑq+VDd[xz ޙg3\'FS`䴲=r7r	<Go?EH!=|?$Vr.|+rE\\phrdrmrm	]]~ a5ٍYDXO.k7uz6<ryg\ZUD@nk[\"Y3Hc67\rF~Dݑv$4t:#=?ېHF5d.dHf-$ rw(r};BHV ;<9yIG4F$s(RȯC\n\'\"j?R)rB E)HI		)%BJYqHRک) !H9)oD\rjf$RӁ#R!	Aj+!uH4<\"\'HRiwy\r\"\\qy錼:WYDƞ\"or7EHZtH\r6->^/y0yPtg/F>Ȑz+sS{h|,|Cz\n޻\0Q(==nO䳼o22>|	Do _o/D%F&#ں$RFd&dv#3yώLW}7z3>V!sB\'\'?fd~22h*gUG\n\'qwLQ肧QEbpUhDuʤ\\TUۊ.DA¢Œia>jF5jTOTˤ2.5D:!Ityg-;p8EWE?4B(ք{Q(0r˞M&J;\\P8Q3_D*THiGT?@EW7grXxRQ0T4]%|A\rNk>Q\rXE]sv3v6]H}]5yڅو]nfaC4D7?~k@FG-D-P+Ժ:jÊEwffv}/Ծg?a	3}럃3|K2EAOԱ6z`>n3Cu8yR\rPׄ cS8q-Г7\\ѓn5s\nIG}үDOztt\ZdWRA/^pF/X@4/[ge蕠\ZJ\Zz;^ݐV4g\r?/G-ш+\ZF$7n7J/Q4j4*mޜMFo\rDcKX^4mahM\\Tqމ&mAkДB4sM|дh	401[f^YnѻbW\"uRZhμ19&}q1+Cs\'h^Z-pE\rHwZgm@%hi6nZ.߇Ve0ZڌbMh}A&Z2mPjChӗV*6}}q5m^\\B[zV0Z}힊?\'iEhن]}~+>bJ%h=\nVGlv=hϫ}GګuE`D-ϯ-Б5蘬\rZ~I~tA+DB\r:ɜG\')iGO<gy~yй[X!2@ɳT9RQ^.ܐC]8^H]iL]OGQлK]jQ*Q?jZRWF_vTPT\0?\nETG&\\|\n8I¹7**%AE5vT-{*͒J5TwTB7KvP#T}KeGS9(snfPmnTnw*?#*Nb*T<ݗ*V;@J`*բEUT)Ao+qh(jB5n]J]O]sĀ.E5{jNj=Gݼpje:uDqբ5jSmrՃTb-+E5ԝ]#TۆT۶/TeA=4ui˩RR׶S>S\\DuVҤmUS-(TT!-ꑅ۩/SP=Wzz6K^FjT6c=z\"zK{h\rG\n7ϱT[ܷTߗTTu~iOqSY4=gLQB<\":nR/?@lA\r6QqQ/+QW0=Cԫrԫ*\n*qkЅotjX&5<5l5Bz&5*\ZU\Z7ztzs\Z-SK1X5޺\ZBM0GM7&:P=gr)5T~j=.5~<54~FڮBW- eESL	\\)5?jq2q.]:57x-5=Z0?E-tzP\"TS˩S++\\66rP󩍕&CjSO.ꋒ\"ͱ\nJj˨9e꫽CW_m7QjPSL5jUwY|껗R߯lvR6S?5~GXD;OoXG4utR\ZSﻨ#_⩣G1qoS\'7ݡԩiK4ɟ:#w:TRgܮSgAU?*?osEs?ߠP/;:oL?H;;BPɇTh\nCki4Řy4%o4C}4Oq4o\\J\rMe8M-z\\(fmx\"m6Iޣ@8J8H,-ὡ-~N[|ELӊͣiYӖ7fLVޢim\Z}[A#M5kh4DHCQRiԬl\ZݠFwס1L,h.\Zsv\Z3i7Pa#hŷ4$}Ii4\Z?M&J	\ZhƓ44Q?MfA[U@3Tҧnw;O3JB5ik\\7vmD^6hM6L3if3iiilymKmK|6bf0f9.m[Cۖ}IfeʣkI]\\DىShi\'hiv54\r=W{u2i\n42O˃4g47V-h1}@;_O yީyh\nh|.VS X1<<vfsȜ$N;ww-gAhW]\\J)M^IҤEmeH|MSHV5-2vwƁ[ci	JZ³tZb;ڝWaZ2Ԣ<FK[@8oD;HҒвVв.?e}=)ܣݏReKhwhZiqhEhrhO\'iy\0?VhyVUC+|G+ZB+j@CišiJZ\'FVM+OG7EZJZVZ5/&2VsilխDkW5t=54=_9ڋSh/ZVZWrVhNڼ\0Z{Z\'݌9u6֟m\"Z76d,Ck-wNZ\'6>qi$hiUh_цChM:@ykHg;w\rо*ӾӾ}}DJMWiS$ڏ)6ss+CDIU)=CI^ACi]\nOnҕҕte=[\nTCWqBtetɗŖg\nK\'Zz|Get]}y	k\n]om}@XG_yl}Gm9t\'ޡ{tM9EGSԀ::\':}AEgT=3/YWM%ʢ$ӹa\":r:oY)7YGtFt]vnxrbsn\0}MVVRL_N}$\'dގnz }>}}}ޕtf_]m[-ӷfsѷLѷq_;wHl;v:mvMtiO.%,>ɫAJwʠ;Hݠv<~s\rSLwǿݻvwEOLЏo=m@\\Bz@?J{QtSbw(ݯ6M?~JJ?@M\\Փ@{9/_Sbt}z)=BIҬG%oңj_|z)wzbjzby4=q-=)BO+룧}4gllg3>$3,GcTz.=g?-|?9F]O˷xLϛI?]H/?-zQ	08J^|2^	K87=geƉ.z^UJ^Clנ\ZJz<vVGDJoЛ7қ?<Go	W3]ߩLSmlz.\'B`17zezOVzϕ~}}	\n\r~jz9}`Ck#5%/N/>ѿjп{O={Tj\'4=1EAdyw5_kwCh/}Lw12^272,fd,|,P;X%eÆv{%%=Z#bƲmڌe1-)c(d.r::kfD9PwAc&Jw2򌁼hfPG3h$.wAOAOSY<`/18]8!3DnCt߉!aH~0O.jƪ+O1V??bna1/?c-e0acV9Waؔ2TBdl\nalؼ>1ƖːbckgƎ:C:İ*;w`a+`؎0v-bp0:_g-ؿ5\nNkƁQo0<88c8XBnn4xƑ9#7Gax&So;Ƿgqqozۣ#\'\\a2Ʃxeq3rgs\nge\0AW_A.Ռs޹2ծ0]fk$sKW31B;9Fx$#ǈǸ.7MFv	FFXF|OF|F #aF;F#HmgAt9FrqƸf-+d-`ܻq,x	a[i`e,b䯛a(c3\n3-Er\'5eA%)fQQ;((_(?KfT<F=FŗfFep9Q^ƨYɨ	b0j2j\\`.hf4b\'gf(F\rV.kNk=w7(ӌwZW]FuѭѽǗ񡼅2W[hc|2>e^Vdv2<@,ch(11ܓ?5Dc1/W:Mvb}U.dLSS?2~K㌙Lo]_:?dluc31(d̹1ާ336t0112d#LR#r)Se@TTb.0#1e.TgX%0>061ɖ3i3u3u⽙:N1&0L=VSsy\rsœ̕L=TLx	a\"UL:&Vdʝ`2i.a2K=LLɿLLc)f1k3嗙xr&^q)JafsLg檀@87LJLC!4tg\Z0ն0)ILML%LS݋L.2͎0737{d3h2p_2[0-3-o2-obZran2d`IIfĳ;;\\;FLLok71w;2?`Jf:0ǘo3.c]\'\ne43extjb:[,d:_He_ldtӼt_xt0).f\ngzy/aH&3=^`zfzY3ڙ\'G3}}g3O2O<ty:y}yaي^f|ftcy~Pgy!rm+!̐_b0f0fI*,qc32o7afb2V36^Ws1$92()<fjbffj32L>Lg{t03o`fu0q31KO1y1E,b̿EbcD`1ʙ31K4?2K^R%5̒i1\\mY.ęݻc55Z%z8flHlf60Mv̧^}ߙ/\n u)}Vf͓|kq컧=p`<2GC6oV̑1_JsL%vMP~9Y\01֨1<ΜY5 ;9{N99;97G9ߛ mg)<c)Q5XJy&,2\"KFKuab-*b-^Z<RzҀY\Z<K#(K`	kIkv0K(e-tڱt߶Vo`YD\'C0^ubX\']aQMYc1,?,,,mbUXX,2ަ8b\r/>oqr,HK%4:YxKː%Q{h-`IDX$KzK&eɜ4Yz,E^j-k,5fXkd[މe4,2?eq.ey,h\rk[.*ڎemy{lX6Otnd;*cmg9[Xο/\\8@ۋX^^+Y\'|Y~c,^Rcb^QcY㝬&Gwϲ.{̺$b]e]na]^zb]\rNaZ	Ye-u7Y+ƚu++zQ7+z?}/u{9.𓕸c5+i)+JX=܃(\\).ʺzఛ(	a=*c=9U*fceYݬBV1x=*fg/^1sU)Uu0XUϱ/vjijWjc%kKYtV4z`=3Lg=7Sgp`:zώ\\jea=z͟;={_Vł[5h=\Z\Z\Z\ZdFYaYc׬ klcww&*XSZJqTK\'뇚kztw/5f̔~	@֯gѬY7kr,kvfU(cͯe棻19L &oS?M1yST)J\0[h-_-:[ԶS#aj\nf/ԚʉLC40́dlllIBuJZ-8NW?.l1уPVlV`+展.bDJ1  1Ҋv]hl`{kɰǨ!%+Fnї8b̔Q9cm݂-`<ƸAyqfb9L ~D\Z1H&։I`V-lVpQlu*Či`F:fWǌs;ISִa&90eN!luf4fn\Z3O\Za[aV#6fv^a;0?)ۥ\rmR\n0l;pۻ	s\"*ylNl!_U\\肹pb.As\Zs>c~\n^;\ZՂW߅ñ#}a;݅Zkݢ=ag?ƂaT,x2,\'vI9D]:]7Bޟ)Ǘ;[{X\nna7˞bY,S,Vw%\\BbE3׋ݡbwRcIW+X\n[K4/,oTe:7cKE,Kpڣeð{S`33p	{o=r*cO\'QX~+aMX!샕8c%\nXZh\r&XͅzVbecK`\r5BkTÚb$Si5{܅5aX+kڈͥk;Z5z.֡܄oðw۱&XגXfM`c=eGX\ZֿwBcا6wlHAؘv.}_9}?}zMObӐ6wοD^fb3Ϭ\"\'z45wMo%3+amg+g/^^p~qc+ͱ=cl+w٪ZتEEl59Ɖ-l\n=lm7yw[φk;:+Re%W\\C+K+^]ef[6a&m`-Oؔ8q|F?lʦyiClN2پ*bc|M6ޏb+8߼e]%Ҥlv-kg_\rl\0h$hp9b{imr\ncMßHdd14fo69pa[nŶVNl+#mK~ٟmƶ^Ķ-wcۙU=hυWn-{_h{:{1bZUZ2/}H}HU+cl}y}Lo}\\&ؖ}bDvDw2r/S[Tc.f}f$K/<a\'/68}d_WwC?!d0ȎPgfߚ5c6g߾Îg1q7#qWofBI/\r4+vvoBݷv{ގ-{j4Kuj؏(UGv$c)\'\'Eb9vq]..y.}Pͮ44`WUjT̮ZȮAVg/$L݊\\b\n#mn3bgZg7;[2;:G=+=!1ؽ}[`	[;ѫb;=Vqm-[*{<TcQb	\\,{.p{f{570{B#g#wǑw(0pܞs.(prWsT|!x<FsTs8߼8p	sƝ8ws4.lhmhĿh\"!%-Pβ\0Β !Ί8+9+ۣ8+28!9$Mh1zpd*9AF96)C>;q{9Ly3aY9[\nn/ßA0WUKk8f8#3S6sd>9^c4qo9Z5uuԥ}:-gzsF7`(KgSc\'gm\rVű<ϱα]ʱ\'r6sM>g|Pyq9qՔrj8Vs<Vqn~Up\ZsIhW_rN:x{p|:8VtVY)I93Ӂ󜳢PYwNvι0sΥ&՜tN(q>q+\03Nd%\r)\r΍<smù\r*[qbo|Ļ$hqpWr>$>YIoIVȟᤄsRnDqҗ&q2G9YYz{o8&J8$9i#QJ#Σ\\vNnSΓW_9y~q^Np\n+9EF9Ŕ\'8%cRNhNySNũN5lƩIũ}S~nNqiqq&pzq)l<[yyBbgБ*À-pެ8op\'8/8S79oI9po}:9}˜ne85&@7Oew98^1!a	0k3?+}8\'8_||$r&7r&9O8?Vi241Tș)yzUUgUpL>l.Қ媛gj*|.jor8su\Zqsu\\\\T\n{J{.an.K.u l./wgq!yw.%_yͥR..3SRWjqC\\^mx?\n\rsVsq\\\ZJp%Lqk0]q:zzPk\\Ï\\㼧ܵu\\g۷s<n暑p7q7\ZrͯrrTv\nV\Z߸r?xryuȏ:p:szrøOzm܃܃u׸n/pݷJzC#\\Os\\ϊN	){l^4Ο\\Lv)6|L9Sݦ܀?czGn%Mx])6uZ({ۄ*\r=\r-m㆝\r{{q#u}܈!=no.7ώyc{$7jK2Vmu{[y{;(7unl?nIWnpo	7\07qW7q>{GM&eM\'+qӛH7\Z7k	͊5Ykɽ/ޭp/ν/<N}@>\\q^}2[d\0Ɉ7-Nܢ\"nQ\"n1j-qrYsܲ~ܲݮ\nCSn宽\'SܪܚZ\Znvީpޚ۔\'>}ś<3y+B;=%H15)f3m??0vJvL[rԹ]p?A܏wr{Oq{+r{E޾>.9nt;lw`ʚIuk6wI/{pk/sGrG~]~QcpN~WǝsdTrql3bx?&s~=2z!O9y>N2YOo2O1>Sn)[--2⩩+/XSPS~[mu[WeUV>i\nx<g-|\Zx+PqUyzǷk	<ȓdvV\\[g\"*xF;x6yGxk	u!o}f\no}\r/Bx[6KYͳt2YV{,?<m}DmoYE3l+y;/*v^~e|V31Ϯ$ϡ>o}q}JxN\Z<k,O]ANyg+o};wT=wtb\'+dU}s<y]_v\04;ёph/ b/(ЋT;w}ޅL^p5eOx\\y_]Cx\rxWثxWsyWxW4䅬YW¼2y^y\\8v#u\"Myzȋyċ}(xNyޝ$N^/侇ǽdo^\\/3x/3/k	/$w!޽ԇożjyxjyMi|yEwTyŢS\\W1+}+sKn**2yjt^?^tWƫ>ՅI[x&^s8k׼o%z\Zxlry]\ry]>md^ݼmއ=/zLy}`^ߚ#~OOxν\r\rxCyB0bv\r>>zV2~ϛX&MXϛb)ߟ|2xN95UQK޿?1o~b-o~ފ/L_\0\n:\nJzbR\nPW1DUz||5jں2V=W2k\Z>|._s&_c7,\'_WZ:W,3>q>1d-.󡓖|X݈O⣄A>Jʧ.$`\rƧ]3\"I|Ɠx>s\n~~g~s+d>/Մ/H%{l|	=/5kK^|UAy|m#||?|_|U56V5שL׭t䛘ק7?=⛕fu\"Y}-ӛFacs/;|mr*mV|3ٓGB;#=l]|[~06<; |I>CC*a\ri[*s|76}WQ:*cߣ <߫lG\"4Tyus|XuOUV%ԎӚpr/S\rM@K}~cu?E\Z?b<IǏ?ɏZGio*ouG?_Ï0?YD~\'qIFiNӗ3Zʿwf?<EostfP;__V//\r?Z/䗾WXW&S~ŷB~~-\ZWkVױZ&~}[o2--3CM7n;;:~w?)?WlNE}h-GQg1GfRf/5#/_W:qnooos+\'\'ou^Nk\nύ?\'SǟuBssqP@a^_X#(~(PaXT9w^,:c)Py\ZCG{%Z;hϞ,@{.G.	V0\nۿq\0V\0|* * 	cogb\0b/@X:uL@[A@K06	\r,\0]/nRs\'j\\[I|#|dfG xg.ѓ\0{F ɍH~/\".V%0|(06kK,p:o3\r`r\rO6>:\'03\"0&t5A`G`\n>X)֔!X%~?7gt6I˦][wVS]S^Sn`}:,~W;	5\n/on\nJ҇7m7=/BpX1YpXpBp䬞eEq//_XQxV;\'纮\'IKolhsG4ierraϠ \"OpmI> Tp]\"DR}AUB-`ALAt{v?]c7HsL\"H8E$l$f	e$$AR ?Uz[2HZ!Hd.\rdrh@}LL,ș\r\n<-x21!Ȼz]}f<AѹA%E&YPt6LP		Q;AyFAe9]PCPՒ qԦXGB\rPAö/\'!&:\n9.xN*IК:\"x*xMGоpS ~\'.xg<+xwQ[ΐ]M/A7\'Rmp[ᨇ\'@sN〇7EYwÐӉ\\>m?s}g#yyѕ)q@^A0?&7\')L~Snߏ~L	?wtI.fM	fi	措\n*%\'X(vG(n {pP(^(/Ti\n.!\\-T.\\}_P}PsQ(ԲZ¥~ƄiP;M$=tBLx@\Z?\nuB	I7	ɆBxKb$5!\'U	{\\Bla(BNr+\nENBiE(sx$M\Zw	\r盄FDUXhd^hg\'\\+	׎M2z+\\8 \\7.*Npn<Rh/VZZN<nY(EmNhRh}\'B]pQFfUpEp]n>eоE^x@5˖FKKНh&t\"<lHx8YxoᑵB@OsEõcVyc{\'>	OZmzG}k?M	hf	ԯ\nAgJA%#s[KGKE	/^1\";- 2[xBxTzh0,S$+?#	o,[\'A} S;H3]\'c	5m	;Iid߽&PVvS6O.\"L\'Lf`^	o&	l[.|\">>$|ذ]_a0O(;	7\\_#̟G{	ƄQae5aڮ^+Յ56υ\r˄#a§.=W!״{7AfP]awk	4]m®JawgAan}aUa_.Prvqoϋ\n?o~;X-@8e\n(\Zj\\)up֌\';> K*\nΟWr{p\ZW0+=+~VU6?|oK#\\EW\'\Z]Ɓ|i(tr\Za[:rKuzKp\n8R_]㄄8\ru\\a~#ѥ\"\ZMé~.8]Gΐ&qeCߊc\\pJ;ցδ㼚8nqA{<.gQq銋]Gq)Ue\\&ⲟq#C7:dkLkܦ5Sڶ7q7z-S|=o	77;f-pD,l)7ۧ:ŸEYn1-͛qK)VZ)ŭv	qk*o?mM	ߕjwwmcp\"\'|r/|wF{5z}Խ\'c|_3V;].\rpWBh!ڰ??!ډ{{}{VN^pK\ru<@ƽ	-G܏u9~W,?#\0x?6\\\ZŃ^sv~H?=_0\'jp:~1/5/OݻxȝxtᲧ\"XqxG~߈9Gi޾oDѺx|?<tO*>\'˫)?<ُ\\Y.-~O~|?Tsz	h?ك;y3G-xQV^2/mc?O?0/>Nx)\n^D6kx7ǟ;?ϐǟ\0x57ڊqkiXoZWnGn	x|_6;t»LzU[xlFV>؏];Ue)|G_VR\rד;>ᓬT\'xŭ\Z> >m\0=skEN{@b(R6\"KEOu^fm-6\ni-yZdJ Yiݽ\'Z4.Z\ZATlhYnhYLC 	-[)uiVpE+|dY#\"<; \":ω@ܡ!&1TQ9(BDTK1*D\"Ε1g _UPqc\"\"oqǬ2xzD|==HU$ ,	CD\"H4 uuEM\"q-\"=\"΋5;ք֡\"ɜxȤhh1h}/\r\\\rцu\rGEn6vN6^(2#։v|m2	m ڲG%_dj(X\"%\nX-ڶ]dUdO.ڵJdUd\'\"R\"ڳ(r8-rHI\\+G[\'ڷh_1Ѿ)%\"gD<DkDEس\r[٢ejI;Wɸw\rA\"o9+wsSeihe31Qi9(X((S(\n\rѥSk.P^QX}Q<Q:kJD#xǢEnݦD1jQ̦nQL5QQ\\P(Q莩(!J:+Q*(5K$JD{E7DiEU4QkѽgE|EE,D4n=+(\\&>%ѣE	QњLQQQgQsQQqXdQ뱨**owN*G.Ujd?DjlQ?NԔ=0=/==ϖZ<EbD36:袎F;ޔ]_7,_ݲC[G\r \Z\r}w}U4b*\ZՊ:BDckD_E_ݐ̻E?EZdLOwbOѬhh\ZaX7Y,3\'^pCH$V;(Vŋċڈ,ŋ4ċ+8b/\ZLwFbX.JR2ҁa%Abm$ֱX!^J$ֳ+^%&b\r1,õbxMLqS41r!fP11C.fg#41[.2|l!1{xDpN[L wEZg1n*NK2Œ?b)rF,$\'c7]ū]TĆ[֊\r\r͕\'k*뮠b{bbxIxV.\Zbv9٧(yko%;Ll)m[2[[7;ΉwP;|VkVNlGJSl(sV@t;X\\\\X;Nzb?u\\UG vC]nćŇkG={=_qH|\"VO|d~{wػ0(b{žiSBf?񩩭ħx&&_R\ni`~FՐVqZ8Ef/?7[pqHy+T|C8ͬk[WYűq;֟A=hq|%qZ,N/NH/Nk=Jĉ;\n=;IIw\Z2չh8 \\N_*gTE3|gY̊3wW|5,_Bg͈Q=ac?X)}G8/y+NŅ\nqap@Q\\4V\\<A\\∸L㹸uqy\"5X\\ٲC\\P\\Q\\{kAyq3]gsgp\ZK%%K \n/[8ׯmom}>7{Tdq\\FNikok8_a^ÉqOac̨cvH<p[<txE<&lD<RK<6\'Mēf\n-?3\Z♞r1\"gW^ϩ?\nĳs5⿫]hSw:KKOHJqD麶D鑪DF\nDug\rC5_Jl%$g[$;$owJ4B3%%K%ZNYcm^7]k8FK_B.!:Ks]h=	EH`-Dӻ%5q	}waCºXqJ8k$͗$=ޜP\"+xIIUZ%hpww1qĸ)Y#됬iO4ޒn\r]&YO&Y߃I6\'J6]LlKk%f%XHtI\rkGLu7+$6o$%՞؞؞.J5Kv+zHO=ל1\'qo8\\s>!qD8[J\\N$J6OJNI%%7hKH<$|Q/KrBPrҨKr[_ 	2$g6^rJ)iO$g əۇ%g>%g+$$	ssII씜+IΫ=\\(	/	.],	%H.HJIB3$a\ZɒDII亥$԰$q$\Z-\rJ$7e.ђ%1Z$I:KI2Iܡ`I<)sVUKҠ	I$]$+3Q$Hr*MPᬚ$jFqEk\\}S H\n$«ђxSIaҬhRR{,)I%ޒ1ICIEx2礤JARm%.4\"J\Z\\+$\r㪒F$H8yRt)iP(|9#i^\'iQ%i)*i}Kv3BfI{佋}C)CI|ɇE)mD#*/{#齬/ז.JD_%H>K>u&JVJ7\\[NH>JyJ$c%I_0LhޔL$dnH?%O]PL믒AP\\@ߒ.ߩ/R9T*HtRptaDHiNQ.:]Cf ]}T}Die#]AHHZInI^K\\juIvKsڟiR|TeT$]~TWt,%8}FR~D\nH\Z)8)%tKI{$ǍRȓ%%WKa8\\\n_&+˥)K*J[3RZlUÖbR,kD\rKyOܤ{yW/JdT*#KeER}tR㿇knK]o+ӖnH¥jI7nn֐?MRsz\\`\"b[ŗ\')\"CmS]j*ݾnՕnGCYU$q5@j\"ue&JjRwYVMm:Y8J\\Ǥ΂R>Kp\\zpQAmX&uڤt`K_WRF91Wғ5iM?\\gHKmi陧ۤgJ_ܥwJUl/\r,rHz\Z^I^uϔ^,\r寒PixH\Z-/Ko|@\Z5,C\ZjP\Z#KzH^HISU.KSeKӔy44%C,͌%͚sfۆI\Z}>FJ&-ɐ\rI`HrŶ2tRZ[ZK+b\0ii%<!}\"ZIVoVHKkNKz祵IkgWJҺ5Ҧ$]җQi:ikrmFQڮ[ mwI;VH߾!}7.}+Z*&~F4Iڳ6]T*QEVIl鐲t[:tt(U[:N~~{W:B:8IǔIǯJ|_`׀5	gX:qV:NfKgHґJ)z&-KWO:F:/SmQL))\\)9Ȕrɔ	eʏe*.}2ՏeEe$LT_P#[l٥!*NLOl9D{fLO;^Bl$/[claʀ<xtPF(AוdP^yℌ-lݝ2ꦅ2:妌~HFv1e̓2Qe&cyreg?dG\'U(5wKewd\02L|#5d\Z2y٪j#3ӻ$[]$3)T6~{,3{_)3׵WY,bdKeΡmG.ɶ.(GeKdzem2e{0_ٞ0ٞ22ӷ2W|yX,;\';tzFC/ȧ<ʎzʎz<IKd2/E츪TvDO/m^&-|8PHJd5T>|I\"*VHV\"#	EYY	HJ\"羯2\"!!^:Y*StEwCe!~U\0Ðڐ<Hl$r;$԰*|	~rG6rH]/zC<H͐(]MHDH4-\nr:q\0r\noIwd\nI:4I$[ARԑ܃G2GƋGdGQ*$-^>yjt/<<-$z-o3o,C\nLH P9R6R$Bl!E i /A^=)\0){)[H62yR\nQ\nZTx6ՀM)C\Z.hC\Z<`i	HHklzw	ZpqX\nQ Om{\\=\r2\r2dL]!Fad.=ȈdT^2v2_\0&])T2LǆAST!Ӄ<Ȍ[,d&䇴d\rTYyCm,{\rum+wd\n<uj[Y\rBV.B8C6ŐCsg!@>~\rwoȿ`D<*0%d\rTX*ׂ<SnZs*ݾkT${g	U#@\Zw\ZҡhPPP!P\\	T\nTwT7\n/=ow@2	5fN@Ͷ@<:=2(RZk\nje	=	=$8\r=y\0\nIBН(\n{bBg2qTbB3P>(F;\rJ@A(DJ2;jRuP(U	32P;>qʾ!rPn@\'*|\0>~G#良PkГ/ԘvnP[Pۋ2PG|C蹓fsE=+Pg6Թ\ruQut@]Kz*KJB//LB/A݄f\\0,j	ƀ2S.ַMPX%2z<U454pY\Z4m\r6\rƞ>\rBC#!;лfw_F>l\Z4Z\Z}94f@\0\r?j;O&.hshBh!hЇhJ%#\0*}&4mv@!xL*IB	4\0ͥ`y<\'h^|4\r7\0;o􀾈BRwhq\"8h+q9$DZ\0-~}	}AFeh94h!7rw76кsg\r,\rK&oЦh&ڲ&C̡n\'zeh=3G]ڇ]W]Ю!hwOhOh\r훔~xyQ\rE~: :z\r:$@\\ãIQMKX:LօN<NBCtly\nUYtt}/h߰LI7L7LUL&=\0je6V	0\Z$L/L}&	lEKؖk090y0L2LQ\rYLI#|ZRy*uJ;SSvjvCa\Zaڒ0+7a)a:F]0|wLl;	;3PkT`FU{̳`uaBaFpK}0ni1]qӋ`߁A2`;08\Z̀!?_Ս`tH{?90R4k菮Ga0\rcz1}Ca=0jcoaxWN0\rLV]x+L|L|?	vn;1vN\rra!ؙn<>S:bzؕ0wװ*?aWuR`^]7	v\n\r:1{9|L&;\Za)`A8,8#,UZfBQ?XhM#,s6kXD8,-\ZRiݓ+_Y܅ŝ~__=0`	TXB,1\r%t\r`ðG7RKa<Xjc@,MK܄a#cj\'?aOTzaO27e=+²sXv-,/ V+\0$5XX1/XKX	d\rV5\0+~끕݃vL|`e-2YXyrb;VQ,{]~V)J\"aozaU\"GXU3XV,V\r;KWiM`\ruƙ[`q<{	\r؇c.XGn\0-X/~p#X6x	6t67+ȁM̙&raz)NTO<l l:l&z\Z쇽/Gl	l75a`~~#UV̼a+VawZ+a9;a&n%7nFc˚p9E<R\0oo\0Wn+3Zpye\\)+|F=|\Z|\'|\'<\\9wBf\\zwNw?5ͳᚐp-4\\V|O2\\۰#	ח	^響識h\r~\ZT^\rͿu.,[*]@?8pJ\rxx_\rG=G[nѬp[8>Nh2Cp~8%8:w\0p}I8,n]4h\n~N=\0?́MK;MNt~qk\nUI~9/Gu++oW~{$հJN=\rM0ff9[}^+sӇA3`+x(!<.քzNL#{#Yc3	?x~x<ixD&n]xyxox~xqӣb7xnV$<mx^&xއZx~xpx-^RyZ^:U/WUW?<ylƐEsx=/mr	mQo89\'~NP7oM?|Z;zYmη-xsx&7\r;r5>p>p\r.~\Z%G)uѺ{3|e	>V;)[?>\n|>FOAW,^JK\02|Q_[_|H//eB+Ng\'gM\0R4>xHgYe`˛ܕj@m7 7w=	(P6=\'=ؾPg	j\r~@e\0~0zI`W/`7xؽahտ.{>{{Eޭ\Z@_ak=4\0<;X*\nn\0Fˀ$``w̀;\Z0KUG\ZAe6X]\0\"1RXp|p!\0@YU\0R>?\0?@~(,\0`\0x%\0\0O`z7@HV\0 @>\07\rv	]<:h0_&];\0!R\0%\"8Y{8-98\0r\03p8_+	89g\\H.W\0(aʯ6?n7[\'Wi1xޱw\\%p=)\0_[a(Y\0@4;\0wt8\nDV16@Lp};|]qxO ~QH.I ~Hf\0Hk\nE\"Hr׀z7 M\0H\0Ș\r\0\"YT٣\r3C [F\ZȽ\"rzo%ׁR(wt/uW[q@P\nTo&T*N<PuT[긣@\r\n	C@j)аfT97МEmGځXh\'`t)9\0]k@w#4z>\0Hs\'_a|8|j K>Cٛ=V5`*005۸)0};0\00=m	.?7?5#c`H\rj<,ft`ekҷ5`!^\06HP`\0%4ċB\'aB\nBvNBb4b[s(BQ_x#4B$Sr/BPC҈]\rnc=ڦ;:/:5|nB/2b76boN:b_ā\r<QIIɣ QY.\ra6pq_0O@G@X(GX<8j8JB<<֋<+FX9!<U=.!\" !Aw 7$@=݄@\r#-*#p[1 AA݈ _-EP=d/(솠 7,}\'`OU!8	N	BB0!< D]c\r52M;)BTDT_\' a狰͔Gة3vu]\"ޢa:pP	G8G?8CFA8<@\\#\\?.	+:nQզHĵ/kkS/\"\"n7!n@,.\ZeQ𺛌:f ^#\"|S\Z#5}C5D_DV\rqgp>x\0y$9g\'#]EJC=QmB$\"NG$F$#I. R_!R<?i#\"cfē`_Sۈ4ĳE&\"H\"{*CE4/!rv!̯!ш\n\';o\"8{%#J\r#&eD^DoD%F\0Q2`16AdhqD4<.C4 $kMpD\'KD; _CX\\F@!Fm$h7BшN<As!\r#o\"__l_ADU5	U BC Fۉ.툩]͈>Y\01y1h!殧!~raŘį<R>bپ\0\\XA\"=@/ 6,m!)AWn7v)qm)53@G\ZHY6rKBrk)\'Bʹ! .8Hr/B\"w^xYTD*_\"ջFAjlnBj8!5F\"5/H#5_!! uMjzk{GKېH`^iGi\0i4\"\r Mբf_7GR.!-uG|fHgG17\"H9$43:v	Ӎs\0#DC_w!qR&Hi$.+	ƞAdm$y&Iy;}BV\"zp$Cɜ1D%#d$ v#9HN7$3͑q)<);K6 ŔyiTit$v0Syv	c635gaHǫL9\ZEy1zRaFyyYyg䕯ϐnkȫ9K;7\"oAތ1CJ#oMEz =\03Yߟ ֯\"wBu\"Cj^ Cc !#@F8b>*LdTdTk2\ZMCAޛ|e%!c/\"d6!hG&X!⺑	}ڏLiD\"S#S*/ 5^EI-#ӐBdZ12b|Cfބ,z̪f#ۜ@~|q|Q\ZY,<,FmC<,iCYER 2YB=،AV#+R*Oo5 LCj1d́S_w!Tl7l2FތlyzWA4\"5C(L=+eǠȏ_w\\Ȏd:Yy@vyU!אw#{ӑ {j#|r9p59S[*2@C؃VA~7G~lC܅#g7!E\"ՑIsC:r2#}uS\\cB+{Q%wPv<Em2CI:*$K~FmYGmN\"dCPR(($jm=xRHG)Yv5vr`(@1JyR!!P*(PUe(͏Q\Z.u(Mh~V<Jkes[ێS5FcPzQFP6I(+(E>\\ԁ\rT\'\neh2k22=2g2F>@_GRSFjD:pR/C1/e鱈.EYQ[PDQL#5J$\"P>(Tm7\n5B/H0P(\\\nD]ΣqPR(Ra\"2CRTPR#t2@q2tP(hpT%9uC*EY@8ġlhn(\Z-(;Y=ʡ:3n:+:{rيЊrZD9.\r\\\"Q.}(%rAF]`{b	uu3,uss\"G(fL*3u}[yצ-UWzkك5^G>CtG?,D;QZFT*u&ChESŢeGNA_wF:4D%HY\ZuPwR֣RPSv(Q\'ԣT)T鞿ͨ? *Kzfz6<SN}:*[&*;\0#ʍD%< *Z\";U3U]*Q+GtAjYJ2Q6Pe_Q\\T |8CUZC&˨ڑ:W!^gagu4zǸjBpPQOjE.\\TwQ,STfoTߑۨ>c	Tj@4\ZgQ\ZΨaᦧícQ#F)gPTPcSqԷj\n_	5ueB>WD-MQ{Ԋ!ZcP+)K y;?Kh>Mehɜ|]h)Th(Zczj4ZֺF8z+,zhuZVЉVX@o[>VJB+]ۋ\0oNrt;Z#\ZRV龅V=~&w~5uSq1=ִ%5Fuuh=EOЦ\rhCWCaqڒg>&<FC^=CCa\Z0\Z~\rĝC)ЈP422Fͪ1Иhl#\Z&Jͣ\'4I5M*BTKEj.nhz4Ds@ui{%Z--ο>1GA[k@[jOZm6h ]oh;ZNavhy>dv,uC\'E_\Z/B_=vv?vB;/D]F_v~\n\rnv_;倾a7&=^Z^;\'wo[#ѾLoV-2: HG<َ|U`DSP4tX}N^	Aw=FGy0ta:*:.~B\'9NG\'->D?YC?~B@@=+{O>)z3*g)g/9/ߣg9*ѹ>t^Eşt!]hADBѥ24]FofЯѕkJqteirTt1*\n]UEW{H\ZQ8V;v*BnF7?F7E7YD7z!\\~?n}\Z%F>zݦVdno2Bw\ZDw?	П^Awv\0GkE,<FKa+>zxh===UA]F[\Z=a\Z\'Sѳ*蹪NϠIϻ?z0^?^>^C/{@FA{迈(_i1fLfSwiT̆\0fC>#W#Cf[fAL;Fifg<FvF+FZݎQW޼b\ZFS\06т``t:1W}G0\'11́,ḰzUvc5cx1[1rƘbL190N`9݃0ga,\Zl0Gyn0`Ub@$0U(nO 0J 2T\"	3\"apcV\Z7Lb6G1`\'CZP\Z)CG`f2EY4eb1- J#<2}XÜTm?r`la;.C̙A̙9>Yf.WWUk2-n(X=\ZIs^l٘ Y0yp\\xb|<10_@owLsyc\"O`>dca1AZ2L(J;pPDNc\r0TLܿ	L|Z>&*rhxx6\08?Is<yRIy\'I}iIa24IWIOLaS5L/&!&gq\rW0y1yBLnŐ̋0buL`LQOL)Sryq\'SՊ){yc^wGc|lƼżJԊc:%c\ZјlLR2I)}/Rii]bZa>6a1=%1}7\'1}g0_*001%o0_ݛ1%-̐	3\r3\'f(0Ōw`b&a&fr1S\\fʉ؆Ml,c~`~eaJ7c01KW̚Kif=\r^׏]lts+y\0+ŘJ9J];bTKm*z۾*ʝ*<\n&v+U	Īê	X:UvZ4V?Vv!L>v;֏Ww_bZ5\ZAjVXkXX籦Uf	X%-]?XWuC6Cg5ܰGnaa+Xx`^,fafX9,2Emvb.\ZbXl	pyKpK\Z~~,f&3WciX6/,J1rrMS=X0E`|P+|cEaEe\'Xk dd֦:3)FP<\rĞS={y蜍utabO΂`ŌX%c)u0\n9\"q`&r^k>XLZ]>g{;;{B\Z\rt```\\!2!ؐIlĶHM,6J|\Z	(6~GlK+؄\'\n6;lҏ}d	l656y<0}tSzĦ}>f[o`3We906\'L	r?bk0;dlB\n>|[>[؊-0Ėkþa_eIbX\n؊\n[1\\V6V`{7ck-5]l}m+~\n¾\r6\\mh6MUVwğw-R*ؖ%^/lK:g#llkKlk3MmgVc;WlO@;;x1\r;Xe<=a{b7R/%cͯS۱Swag6!?baga缾b>.bS懰Kؕa\0*nK\Z\'\0\'/\'y`\'q5F2mn;m^msm)qۧp;q;GqʇTT{`8pjqj?8s8=18ݸ]qup{>t0n8;pzS8}<>N$no(n(g\ngb~gxę1paXu;Ew4w+wކ;wA\Z/`58=>LlqZQrqG8`Apӊ#ٌك8Rꅣhkn8},2ı~ǮpƱpA88!4N8҈)įcqL\"\ri\Zg;w&y$FmV!m}c})\"Q~?Α觊;G99qNo[qΰ8pW[[-ቻ[cpu8=ep~8N.@\Zpb\"t$aM)`\\0:8/G\"\nCpsMM{	{,%\\܍~\\;dz5.n	ي{KԊ{=Q==våA\'qongqߍrr,pqqyP\\9[qZꋸI+K/{]qjW7^^%|+*eqٸZy9k]4\\󷓸X<k{=׎ZõO#pb\\7N\\׹op\r\\=\\/\rډ#9>=[-nPY7م>Syiىyw7^/n\\+7>1}}p.2f)dܔsv5T17Caf(f!_p?U~hqFqɸe&g([\0Ec҇Vܲ0n9\Z[~BVA/ܟgŸ0z8m866fq_qfozp/^f/㏗.PRͪzx/[jrM&ea3xoxA0:SW]	^]($~R]n;m	^*9^-ﻕo[߿T?47Tqxc(\Zo|Zo|\Z8o	\0o	o77ދ?T?do>?Ƥo㡖<a\']_C\Zx\Z~\'IE9xR[<l+⤋zi-x{?6gN\'|P2ؔnD7xSAdi:6h3{x)R9®k619)\"FŻy݂Yxw5{`9v:\'\n=1435yMxP\'9U{}_+A$QWx|p\0Ysh;<Ћ5G!yh1|̏|o|\\>|BK|\'ÃFA\0Yc7}gNay\">k9ղ՝0/:/؋/~/!_Z×\\;O+L\r<oަ|U՛s[\"Փ\Z<|9|\r)f3`|cyk;Rh1mb|k;u\0xm=%{>{k>W\"sa\0sv/P\07~(?ڑc*c\rqbG\num&\'Ud~~*D?x?=gXe9I&M\rgy\r~A>}mDQů?}\'k:2g+zV?sM7n6Bkfs^W6U¶iAQPFPl (NCJBR @P\n\"\\C}5@P4Of4n*p6/ %hoK\r{AЛ#WZ{/.}%~F؟=APΆ`&f\\\"f~<$E0W$T%9F+%	0\"ȟ# vd3c!`)Jgpʮ:oH+Aq/(5L B\"P+h#ڽVG|&p~Us? w$ęLJ!Q+Fp\nM8Up:*`M`z`seF8A$8._	._.Ğ#8EJW\\z >وpu9՘buk\0#:#}]F|.|/<	AƄM$RjBfR	a	ws	ubB\\!D&b	do!iw:!@HzcOHYNxԲBHmxDx\Z IN_&J<*\"d	?\"As=(5BtBoB^t#!ԗ߸P͖PdRG(*&p&%+vBOkm#RAB՘)9ފиExw{Ox(KhuAh)\"\'	mTBۥ;v,S+Kè\"_	_	&Մa\naa 0jO\Z\n$L	#Ƅ|M0Jo{DL\"0ٜK>L1%j%em%A%,(<Fu_u¯&[Y8a:CEº/\r9+0yI7\\GpN%n\\#JY#$JGe.D@}ll?qˑ-D1|/qcQIzTqqg<Qx!QUOewZM9GAQ?Ox`@4DFmDM2CaCMXo_GJ{GY|oD`%N:CD/g}D\"f9?Hĸ|\'b\\	fDB6(@$&CzDRq\r\"\"ҰDQw\"Ldc7Db\"&3Knw\"r\"a7KCD!hJ<K#\0KD{%DvOU3O#Hӵ=D\r5k6!ExÇx92xqLLt^&ƲSp9ѝJtg8˺u(ՂW*DK\'YDω/D/	+L$%ϊAS3P0b裗İw\0\r❟ĈC%Fޯ F)3Q.\rQ=bUiCb\"CL\\$&pI_])oƈ\ZS^*3?׈_mz\'\'Ww> f]#D0$GzI,(/ }&1%T~%!t\" &>-K|vʎ&)Zfr;X@\"֍%ֿ!NlجHlU\'|Ip߈ئbOl#Il#~<dO,Gh$~R{F{T=<b/&ΛŽدJ/\"s#[Ó}Q|6ql-֋3;֒i}		D<q#E2J:[La,T88qNSH[&,HL\\I}#5q\0qeq=J\\?FЃ7}d<MwM7M٠$	J}@YbpK\"(\Ze7;Pqh\nl@%׃%pp_P9LTyՒ	ZuPFYP#Xw_154PԶ}(hp=p_6f&7;*\rAC[6h\n\ZdADxc4)w7;@QU`h	-H*X\nIB70a ,o+ B[\" \nB \nĎXAb1n:dSI*+RLT\0vͪ (A9d  Ț\09$+8rW  %ȟ\nl@S5(4v\0Erh^K\0OXSSN~W633,CA{\\ڗ2@v1p?Y:x-[v3!x|7/\rdl(x9\"~\0Q^757cgM7*;A<\rz[@o\na\0kzv\'3k`0*0-@w7O`aY0Z9.[cXc`50^Lx\0&Z]j$0)>/|z|H7)r!0>rO-L\rN7i/\Z:i7fYOۀO{LH&Ep0;(e$9`0#\0v;G9IIPXx\n,gtXs,Ye/2RU#	,D|Vukd5A`m:۳K=~\0|6\r!``\Zln?\0[;΃(X-?vAv\\8~BiJS2_=<5x8!g88>}\rS}i}tp]N\0Cs~8\rϽYbA\\.-z[\rPD]&l!4ڑd/䤴I\\\"I~LDR$)\"),rHbI۩XҎ4%$ej4Iy{DҴ#iI{H%H:\\.K1Nڧu/2tO:PL:0D2t&GL#F2?tՃtt\"d8\ZtO:##2&YB<I	\rJNd5J:~nt\r	jϭ$_HN\"ȉԁ$	V/P{I$\\R	7\"\\$ұS$8u~4$L${ؕĮ#qIK;H<)0$I\"~#IttB^t\"ct0d!tdG%V(\"SIclo_.X.dM.ՍHoIHRICnJ\'n#y4Z:X۷$	R$)42F\n#h4HQ;HҽvR)vn]R܋bRR|%҃ěDdR<OzHDO)J)gHJGRIy6r_E3\"R11)ە@}M{Lz 蚐\n\njIE;ߐ\nHˤB(tYTG*+Az}5u2T>A\\+$1$醑,FHՏߒjɤkIukӓt	RoYjt#!rҝJjY#?@j婓Z>lCj˄ڲH/HfO> u=&uCIqOI_6̮dIIUHao!&ҰUi8҇41;O4w49$M=\"M~L&͜\'&%<cEi^	i>thE<HAZIR*ՠRjz3i_!WIݷݷ$K%\06yddL?,;BޒPGޒ!ˁd9j;Y^2,JV +\\$+>o\'+ْ+KޞBVKI#+W4OUUUU{d5RnC&Y2L֌eZ0GY󸑬;F1\'5Il\0K\"\\Y%	[Y&wk&&fgfdm>H\'٢<|w|3J-ߏ!ʞdm2d!#ddHFQrwh\Z2Q$KdrL S6Ȕx2Nf92g\\u.\'uc2d\r ރ,̸EN\"k>O:gudkG+)g46OMF- Y)䳮4\"<|!}{Gv;IO8Cv\"4\"\n!rȮt\Z#||Yv|~||ѕ|}\r<|C&{溑5\">`\'٧B\'\"&\\^!fw$OCɡprXl=ΎEr̵o䘛S{Փѻqugƒf+-I,rcgrrU-&f8rT1T*99êd/IhKdr&y?9sΞV(9_Cή p9ȅBrіnr!\\q\\|N~ҙ}+Ce7!z`C rUf2ZZ҇\\W\\HǐkT뼤o1oɍƯM./MoMyZ{rkO)r[#rG/ܹ/_ɽGB}}䯼&䡚3Í[#x	\0<:\r\'u~{߶$O\'\Zȓei+yFN9MM={<5<\'xDZIWEoU#zMenA$ku+n;)/4JźYŭ%4pE1E\"e&sK%7EUEZLQ_ʣGH{JM,.vh8R(:u딽\Z&6ʁJ8p%0b S)F14=bNbFR̃b)e\\ʡW#K}?)z̗ȥ\nP\0#|\n\"P(#(i\'\n	\nl>_g/QhWGi\nc/\nsHapLa\'pU	EՂ\"TDPNQNPl8\\M9r%rVэr|rZr66rNrݓr>VrCԆtԑlt⺓pcp\ZOLERrUzrUmr5OvHr|&Zy\r`ͺmg(rO)pxz)^E;/NKJUJP4_RBj(!#є)wQ¹(w6($JtJjJW)%ۄ\0YMyMyK$JR((Iy\r<%E?By@y0%ˤ_\"PKz)w)R$WNɼƣd<HyWϠ<(ARr:Sr9a|PJ~ʋ.+BD--J%!򒺇RښIyuRvNx{DRGy\r-ƵR\"OyJOeSjۺ)ur)j(o)\r=2ffʻ܇(~ʇZ݇(m(g(m?)NΙ6\'J#\\)}PJ嫾e&2ZRm!N)eH2t22*s*QƶQ|.RƯHQ=@|ǺQ38T[eʛ2#s27âj ٪\0hJg||e9gϙgM\ruĕ~*!@Lݔ@.UusZ[d	m]-TN&uTTZTUwTU(WTՌgTMX:Z!U-=uV)&ى\njPu>Qz!TKTQu2uMTTH5{j͓j=jvLj=୿T<8Оa]%a&U7\ri-kTpѸ*#\nM%SaWM\0hϳTܖ.* 0H4*f@HRR\n4g*}$2PY=TA*R-v \rU;O})Q̩S9bU\ZաXz\'(W`WTGX/ܗ!y\ZڨR;N_S}ͩ5eAT\'T}ԫ{cWW˨SEd@TOy%zpǊ#K\rԣ*yP%jp\Z\ZTA\rv Q^&RﴼwיԈԘ-Z{hXOԸ[z$mꣷ/vRӆS卩LRAlf:QW>?5+zǢ풧7GP2ԢWԢu9jZ/Z{/Z&S\n(jn>\rzJZTZRk,j=}VO}r1{t@mI}B}77B}J}{_cvjjـR;cjI	ΙOJ.\"jWZ\"UkhKosm)`-uXut::^-ʆEHD:!c:{iu:Go|H]Bw66.ԥ{+QUu5R=}uu}#ufu{׷=O#_-HMs݋&;L,1M@&#XҶAѶж>5h\\WhiJ	4K4Fm\'3MEc҅Iv]2t.R*MSMq`h{nPi{ =σh{zhڨVW	M[a,M_!W$m\"m%ځ4eAOa4(\rx\Zd;fG3𧙥z𴃘4s@a\nڑy4fDYю IT\ZH[Ӑ44\Zq\Z>M:id\Z9nFQQ`h44<xј&\Z[ΧWo8tƣni®4:&\neN<>H;yfs=vY.ɍrv&F#܀vn)v.v]څw4\'_4gIsw\"b(rn+ڵ6苴qRin-nyd<Qhޙi>|[#i[iWe:-fއ5ZZlC-g-\"Kפ=>%/%i}ش--AK+@ˀgўߣeIhϥhϕ%i9KZr\'-ϨwN{Fˏ0^+\n|UhiYB\Z=>Z3ZeR>+Z\')Z̓&ZwZYZ\\Z,V~V7V%@h\rBiZ)ZSGF,Okڮ-@Z{@}ֱe/#1Y@NӺzGz.e+>JӾ֡|H8Iw6pq6ԡD^ʹew\ZmؠM>qM\r7f\rgh6Chshd)eڒ5ڒ3Tɤ-T)VշVwV{nVi_h:?_\\cʷRh7T]n_?]*]d}](]1YcVtebAW\rOWlBרB>ZN~M~~p;OѶqnSJ7.쥛=Ч:N7L7ϹD?O[pbgV8kUP-ݪ}vCgp#Uӑc\rtT:f\ZkEǆܤcӴZw:nLM5:N:-h_I3:IN3ktƩY:#zΖDg9t̓B\"yjKtލB:A4҅~?1ti58=.ΏO<$Umu63tGMo/ӝ_/x]]t7U{y3F)7qc+c)}u6SNEߤ( }oAA`9z6z=EG.xУNc:zܿez|p]w\ZUzB)z/z,==,*%G\\?nHO裏3v;Yy^ZfRyzi^I/	aDEC-Coť_w&?\rw_w{轂؋ބ(zo5gVzr(>7GH̤p[>>E|>>^x>ިAm@F&A8y>Lv5[\"G>}_}n}.בhvhM_tܣ/YW+髚UC{2u}!qi,!Ɛ،a`Ȥه4bcaCn6C>&zPt-`(.80vj1O0ʕ{*eZcc\Z)C힘+%{4ihdhY3Hz%MC=`|{R7c{)}$\Z@Va0\Zf`dRGA݌c*cDmЊ\\5x0#&qǞA|Z\02BO5|>`32!֡ꌓxbɏrp㴧?v>Їᠾ\0{pd8|d1g2ί2.f0_1:*N\\\ne%Z&ɸ¸L2g\\g\\2ܼ2uv0s AUra\rVcڋ=uȸX~e3363i `F#4ZZ 3b?b-0\"TQM=F{_3`Ux݌ÌFYF8[G	Ͳt|	#Y7#{l1`9\'yRygz͌{\\\"H8.Q#JFSFE6fTtU0^92*eW%?op?Ui\0dTz2\\6FQg}^`[2{o)1z2o߿c463\Zkjw5Y{\r{>lcú`|d1>fJ1SNSs?ˉ\nxMbD3z=ջ}O}zWR\n1.ng<go1÷wI\'[ƔQ+ca&<cmke<|1Y<Xb,\Zb]Ҍ??kkU\n3\r9ߴ<?{\Z:)ܔp)u)ّ܌aJ㤙2Ԙ[/13`a1宾c\\gk\r0d/3\\ƙۦG{Pi4s:Sr5S7e]]gf1w]f&ܕ=SԼ|9^ejeOdsw2BN0. 4Q4Jqb\Z51c&&d	+Y=Cs̃=LH}桞8^aZ\" ih<{<<ڢʴ6dZleZg0ckLL`&(	xL&\"܌,bb\Z=;8*_}IeLe&5ImKf%LzI&[,ݭU19L,S(a\n1E7iL\r^*ȴO2vL{txt9t<</f^hztBW3M̋͘LKbMhLK;n6kC$_׳\"7dz8D1=1=	W|^AL^oOV&w/wQg\\a332̀kqf3lhyGN93y.3BqQwMbF>xʌd11DCz{\"flk}]}rfg]̌s`ƹv303Ĵ3fSfrWCw3IMΈ1|bTNef^af֘ϰ^3̜ߎ#̼Dffu	}̂t_f%,\\gh3K1KL\n>2_aZ[cbǜf)0\'0+}Go2s5Q̷Fon1׉f\nlcevR2o>fv?Ybvya9_\"k_=K̯-j!S^s-Зg̡T09b9HcECceLRCs\"J99Y(˜vǜe?aݙce΃\'<KyF\Zsee7ss͞1np\'\rϒΒT.bIYKdɳd<nd\nY\ZXn-,9W,w?Xz/m2*mjm,\rֶHr7k{CrqY\"7K&KR/fz$diaHft6lXzYzpޠAp־=XoX5AC/``YeeQ2jmcC,+,L:`#e2Ob\Z`qŲ:*`aYM&5>a[&7/X-*,K`!d3,\nQBg0,P\'obYd,JQEYo\'X,\rא{7$Rv%a	Y⚝,əK~<1֩[{YMlOUγra9]aJ,%֥b֕7,<e>*5uu%uquC.uR\\dyC|^<f|+g&|JYGX~ҫ,wY~x<+Pcf}\nwa9ʺ\n/8ºafˊ~bEt~cżu˝̊?e{Ya$Vr+J$d$eldRgXiv4_VZW?XOUa_YYrXy>VYV!V~N<+2U4Uc:Lffko*XoX5ze_ViKV;ղ?HC1ǗծjOcuh:9ΑJ֧ϷY]Էn3GcLJ!rYW~ kb5体5sb\rߵg}n`M)SY/ر&YSXtxǉ޳fdRSXs\\\\%k> 5uXg5d+ZalFVbwVYzGY\ZY6%to7=mdKdKR!|Tqv).&-sʝ-s;)Q|[n[^Ǝ-2[V}Vzq΀Uyll_*ljϗze\'>fc(]`uٺTH{_]@m`6؇<aa	f[D.>gC?`CٰZl|3gQҹlt)`qil#Vxe6>\0(\rNlR+\"UeS9Zl=wdFlp6*W9r6ǭ͍f[O|E6!-HXb{٢$<[4Ķf>V}mk^Ͷ]̶Mde6>cvg;4c?g`;f\'f8lgf29o7ۥvc/5d_ַd_/;e_d_QWf_mʾr2}mҎ}m}=ʀ}À0=[v=Z7^cW޻3wo>3l_;;X;;DfƳ\Zzw\nwOw\Zؑ4ّgّY$vT	;S1;	;:4}g޼};Obǟmbhc?d?hg\'Z`?5~ځ8z7;myv4;=\'?ٙ<v윁\Zv\'vdvnG80?g_~Qu]d.lg6KnKOK\nKo٥WXvs]am~ӳ]e6<\Z=ew\"]nϱϟ_n|bMg#ϲN8oes]a{=6Ğ@\'N	\"{ {+!PgO@c*{7b\n7s&{i<{i{0\Z{iUd鷱NE9#\r	F**g3GÑ\nlqpd{-9re\nu|b$GeGeGmQ>1h_Xpt/ps*]쳻g5.k}\ZǠٟc\'LscsСsYcn㘟rsC,<8q=ut{0z@>q\09\"H]\0edAg>`x%<݃pR\nLJs{ÝCrHK6r{>ΡX19oFQ>awqNm *p,!sU9\0sć8*.kJ5:s2(t\r2>Aqa99xqX看+\\H\\xJ8<8K^8\\Rqr\\*s\\SќKz6k-KS#IMx\\pxws|n.qnr8~\rDN\'X\'87\'=\Zz߃ȹ	qN.\'zsυɉ8˜xe\'X#\'E{pK<hsqsa#\rUN*IIs9IfIW-_ᤧKq2kKga,]NVSNV\n~N6}ґTɟ2H9%iO8/t8(NEn%uN%SMTvm]ͩ/xrގ 8\rw|8\re9fE\'N3:9-*8|NkC;Ca-a7ltv-N(to`\n8=I9=ʜ^0!NoNs#Bq[Η~ZNǜQ#gXj3{3j/-rƝqsќo\r)\nQￖ8bTI:gUg&ۅ33c3KP,zr~5ks~\'\'qdĜ`KG󜕟Οu&οx^HWre4V2-S\\-B\\WSWx*}e7WwW\\\\>U-W-\'sKD\\\r\\̀c\\(_v\\4W{Hk5ݿ{VO5l\Z|\Z)ypʑ\\c)qTL	II=kjr%*3lmvG-\ZM\\\\#;V6cc(.B=EDn\"os1JI\\)sń^b̸R\\\r;.3KjԠ!.mY.3/udUSe7*r9>\\z{Ą˽rg,B\\%W8W|\"׺\r毀{*2{+kkvkkG\r]:WܳgOrQָºNT맹.k2ҾK+w۹\"ՈܫosEl^`[soTfp=a\\B_n)Gn@n`n8\r9\rI↶<I˽v{g7<6n$΍ʖF}FqTn)On̪	>{9`,&*&&{pS/sSfrSfn\0nz]n܌\'ܧF\n(47j5B͎qvB~qsӃUJܼq\nEp_\Z}7nY\nnywnuk%\')ܪn*Uͭݙǭ|֯r:666]6ppM&vi6r2{ݸܮ|n_~#s-e\nz1Ke<v7Ekw|u;⎮厝IapǹFs\'q\'߈S^q*qgo{sgsܹOw?}ĝ.r7up?>|w5]WuSC0i_Nߑ$r<	7OR3OXJ9Ϛ\'-cɓȓ=S1<<ş]<hގWry^<՗<<:OXNힼӄi:4\Z44xZxZwx{nxxK/	ydy5|3<<1֑gLuG}GL<<$[ޡy<q:J,J;&?;&<;v\ray<}l\"Uüiaye\Z×kH%<2ģvJ<*=7ǔco]q-Gx[<ᶝ<q4D,D-Z魯\"fK$\"x;lZmϮϳs;?;[([s$\\9>LÕ5$ν?s9Ÿ<5z37,wYwA/[x\'\'ɘEyh]<DߖB=}H&/@//p[%/|Bgyah^8wWREfyQ^T/ڦ/ݗH_K#Uy߯Jx.xw2>Vy4	yϊxLx9]\nE_^i3Wk?xĸWbb+佔+:V{U{W+Uh]tUPyof\Z^;ּzhJ\Z5n\Zpek{g{|עznz<v΋ֵ>庛kx}6!b/:\'x_O|\r\r7J:~|fțD(]Mf	jo\'xKxKo>`yKy	\n7o5[[7 y#n7,%kjRD/o>ȗ˛xl˷4=Tyk|ŚRWJ|叇*k|u0wq\nk4w\nr|DK3|mp6-ͯ:~_\'??R7zo@@~MȪ|Q(mAEݭIPձ|ۡ\'@qG4ck|7UOr{O|%4\')2|J,O+齉|f>{p7k7&|i]2Z._T2η&e~|_X;Er.#p\0/[%SZs֑|Z|!c)D-=|/bWqWs~\rB;A1~!??G~oNe}]~Ϗx\r?jGqQm\'L=364p7\n~>?N$Ǐ_G<?%It>~::?C/~f$~a~E~7܆6~SWO3/os%~8K/KWGe3eN~-Jsuˋo#\Zݯ\Z2~V~x5k~/(o~HtⷫpO~ǈ/sܔI wM𻊷{S_]C. m\\)>?;AsrOgRS~3o/\rZR_״--	0[Re(\n@뿜y\'@\"T @@@Ѯ_(PC($v\rT4i(**TjO	Ԋ]ýLJU#莬	E\r</<\n6fB`n[phys\0.	(\"VY	|(yM@2ʅPN@P/\n\Z=[@gx@NR+|p6	Yմ@/~\nN8=XnX|\nNil/\\CF}̶rV[p^)PpnϐIF,p#.\Z<v.	.OOx!$5Ͻ-4G8K*\'	|\0_B t :(Uz`*^~RMpj bR_H\nľQ7\'$&\'xoC AX$HvO<n,H&x$x4R H}\"H͑<F_A6 W (-	?\nD^ŝ$^BSPq_[3SzD$xcTZT\nj6G궤	/ԧ޺!\rFkAh/	--\'_S3Cv<A|󇪠v7CзJw W1؏\'C3潂N(:E0,|y	-ߵ	_y$8-hG	<37	f*?rٞFBi|\'i%5%zk\"oPrKBi?B8t/Og̹[B0LpZPNPE(ׇ\'	_8fBڐpsBx pGpgFPU&T}rA.qS8T;U/.4r)4z(4\ZpZ8cPW!hBM0u\'!x^#g	BE?)D	n	QWJ!\\k{	!%2i\"!J-rB븭BI3\rᩲ0CUhExiQxUQ,#<\'8.<׵(<*<*]%\"(Be^m\r^bo|)5yE1zhztzˊ+~0߂0pG.ECQ9pSYao0BZuG}DV\'y)G{\"?C-N\nЍ|	Ħ(aIl\'L&\n7~\nSUiAaۜ0>\\-T?&̌$fH\nk>/x+Ff\ns}¼O¼2mEK(aqȐaқWY6²2ay7߄UU_Ǆuxa=灰^\"|;E6>6|6]66m6PR/|VR/*;m6O_a[oaQ-쨶vN	I?#O~=ElF\r3L##Q_P8O8\Z,&]-ֳMmM<Z=T8a!*Ip2p*N8sG ypp%\\g\n7E^ąѦ2?drhs_l}ۣ\"=4\"%Rm)vx8v<)1%)I,TD^\"h+S1%ڍ)ڣIi/	E:\rd~!*wP\"C\ZPdNdR?)2fE_\nDEۊEEYEfA\"Do\"x	<3MDUa\"JaZ-B_0/E}\"H#Yc\"0FGNH\"o5QD͚\"C\\PqԊ~P(^YYYԊN:Tl5EsE?GEJs y7?B5eG닢[.E+t[=\'vxMt}և\"ȋ~AP$ Jo(/MLlFBLE(]Qi(⢽(jo(N>\'Rŧ=ȋ%6\rEI.ҢK4ѣDE鐇F)Wy(3[W=R@e_ȋEٝQh۽7JD\\QPQpTT+-*.J^]y.zuQ&&){(5\Z\ZD$5ѻQQiIQ9QlĸQ?U\Z\"Gײh\0Y.\Z*\r\Z.KDcEcѸfxNWLR4q\"D?DvEEܞќNhiY4[RV$Z~M<Ѳh5#+doZ-o].V˔eʰ[;rpb,/ZxoJǴ;XwX̉w\\?#ޑuJ(++#abyXMTfK.5Pbk\nb!XX&=\'~\'֛mmŉn={V|ؠAlԵKl,Rl|]l2IlV&6%?;i\'p\\|+C|l[Xz,_CNZb`\'FtxC\r1+w	*Dg1,&%%T.\"f^Q\nb\\	me$0-|->u׿b[)-onLZlYlo.+N;xbWbG{=ߥ+JScKy+e+@}dV|M.v\\|i(qX|m*xM|/]|\Z]|랬أMi-7{\Z$ד(WNύ1\\XQ\0ea\"єd\rг{?v+-+\"\"Ew9w\0H\0!!;\0!Ol@x (?\"6\"|\07z7\0QJ(u@ԛ̀e@4?sB{b>*\0b?S^ H(\\\'\0n08cA\r\0\\\0/h2[yl7799EI)@A@^$D|P2Tl\"\0**e*_|<x<x	xJ<MɟԬ%]=uԾ\nk\0\0åuF@C@kV$c%EQ4	xu$mmF\0__(\0zY>^@,	vc00hNN\0C#I\0#\0z\0%ex	`,Aex\Z0L+&{ɥef0\0==R46\'&e\'`3`OsP{(g\0XXvXAVVϾ\0v\0֎\0\0֛&DFm(ߡc;@9(_ ʿ\0*\0s-恛Հ[,[-mzwnjIZR\nPPi(ШШ_h|84hhv{P29:phŎZ˅;wm_,M1@{tࢁF\0k~*:h:uNI-.gI@7@s@wR8oGO@ϦC@/6[xӷKڛ<Vtve`sm=\0^t^|g80H,0I@@M{\0@h3 f)aQ bh Ļ|?Ӏ@@ yhHiJ7XK m2H[2f*m\rd_\0-@=g#?@K>Pr(=J7!ao!Jo!c7>C߭+>Wg1$0z0X<\0L*=LI&C7>k9Gioc1߁Yp``v0q`+1yIys|_{Eཨ5`X\n,(,L,l	:,\n,>,\n,V2=gU\'jK2\rXNw\0\no\0wo;\0lG[lKSؙ7v\n|	~5M>\n||kD\0D?Gv~}$o	y;\Z8pb&8Y\\2ni~\0~ٕ	g39$Z]Og(G[n_rz\'ߴ?7mׁk7A27  \'ͶQ͒<}&-%b%Zzu%:V~V{H\0q#HwS7Hwg1Ha\0\rO4<\0\'4dd&x2/ev!A K.%\Z}csEgdmbv\0S3U:kB~wIAN[UANAΠ%U?7#e@GЉ  bB\0dqd=ȧY:#ځV7VAmt@@Х^((4S$S00&BA_$AxC\rD!I `ip= ܭn>g_DAS b,bW8QATW *>:@1ib(ػn8Z@ m\n$LpIr@!@@ѠVyPXQPd8tuPtc(f(V2C/@	Ar($z\":	zYЍ<i2ʼ5*leߺ\r\ZAyQf|&(PiPr7^19P	PTPrtt086TR	Tje*>N*@QPУSm*u 艷w?PSP/PQj\\	jzXj~jj5r&Q P|Jjp;j7ԕ#PO͵Po5g{n|_V:h0	hch*4\Zz\Z~\n\Z\r*hc8)h<\r4\raMGBrZN\0!ho\Z	Yd\rw<V{Zvm|\rq9%ɀe+`RX1\rV,+AJ5`ehxˡO8_V:x[@x[#x[jxifV?\Z5>k:5Z``΋ΛxQXقR`}I~;Xl\n64\r.XOFq/`\'`{TsdO`;`=z!{_YGߒN{>/@GUر\r|Ķ|4	 d1),e9l>^{|B{`΀=-^jf`wyw/	|RӢ\nY	\0&ڃ}Oi3:g&Ϫ#wχ˃/,=!Yp~e\0乀!`(b;GZ50FiAo`|@+w^dD \\T0&̔E0\r<~ywl~ž?%`i=Xڎ\0KǮC^p!CP:p(8l8\"b\r4GN.*<_1=y/~N\'zn\')8\Z8C\Z*Z&ECS7Eoo\'LoߛDS1α&sݢw!໘dp>\n\\\r\rw|r\r|.>.r:.feKepwpm6\"F+\0?֚W\0?\0?9~`-^?*?[k9)SK5)pmpC[3\\ibTn=ܚlnHݬ__=w}\"fGwo7,pOop7ྀ;3&]4xxf+y<}\0<ڧ\0bxX<v<0xb#xKOf肧\0_Kv,%(R-<zx\0I]փ_(nB4@#_BoCT *BT~@x\n![ll	qf^QAJ uS\r6&2BH :DKȎA4dǧ6Dt\0W\nR-dg`i\'P1\01:1ꉅkUBL(Ip4tuY>9bNyŇXWA,@ݭؕAZg[kدBC]CC>D88y@?Bߵcs5=q}\nr<<DjC<5 \r\'!3w|\'dW:\'(Qȩ֐3\Zː3 gm& ~{ ~V$9m6K!UZ R@`L3!D}`\\ eOn>/@E;!Cҋ:B眇05f!L*W\ra?AC~6D	q_0PDmDi@>B\rS!ѻÓ؀w(H\\7s	y?$l\n$P!r$HJ:$UJ\\\\V6  hH]kH<$k+&@!w6!9g+ yv|Ƚ nC\nN! J%HI-t)H:gGnVLy UlGȓʐ\'v\'ZTH\Z33fHm+H]/R%F\ZHKH3HB>yy\r;&1M\nc5q5ygC$(Ȉ[	d\0~$3\'K\n\r2~d9\r2|=LC\Z숀fdA~R\n ?yB7!A-_ EYY.xY?YK!+ݐӐUKU*$C@!!J.CeP}rP9ETf$*gBPPeeU6\0TݒN·:)BU>@4EPFT#Y88\nAuEwzǡzm>PHH0|7ԨԼj.ˇZ:9AhPkPk>m\0]7c6`kC?;@_A<@Cҁ8=cu:pC43.zPs4kSnu\"Iz2=9q\0\0s\Zԏ>,%\rzg;K%AP@M=Caٷ,(E܄\"יP)7C1CuP)%B	(#JJ%RPPft\'\nJPPqy<T9*)J&5h4KhM\'hhahX?\Z\Zm74R\Zikx߁FUAl^EFhCG\\hb4	XMEC\")k25ntYUh:EhFX4cfiiCQmhL{4/lZx-hXBBTGh	ZZr2ZE\r}B\n}\r}~?XhMfzZ{HZw6>5Z<RN0m>\r\n05v@;B;oX@_݊\rj\0}5\Z\0dbCBdݟRo;=mоi/[зϠkMۮA?8\0TmBǺ77AD@\'O@\'	[O_=~|\n:sEҡ?\nA3y!fbX%t		]>|\'\Zߡkп6<\Zq+t]&#m 6Y事a\n0ū\Z0\ZJql˗V6lm#vb5Lz\r+i^4i)tazr\0ӹQ\n0Y#&	flS3N<3`K`f\ZJ0>]ưP0V=E.A%ءyvs9s*srVy\r	7VNMD<a0st=EKX;\rD\0%0`\rCV`[0>öl(dT!\\WO`w&n	?킉tak0im\r\naZ`ᖛa\0ȣaWNîDî1%{KRRG`׃6înt2ej>eұ,c,}X>X2,p{(,ސ+ 8еV(	++,j+2+\r+	V\\\0V\ZVV.K\Z`:0X:JuJ	ONThÞaOoc\Z2{\0kkh\rkxku\rb`>q-\r9zS\"lRcwh؈{#5vfa`N>ρ}t}y<Mþ?M<}n}bf=as`C؏#|\\:w\0lѨx2JumؿM಼Ul\\]DWqŻ\0\\W@j~ p)_M\Z\\\\7j7\\\\oA׿7	7R=	7J_71>݀:M\'p3SpWp)|ܲ_qR[mv8,^no?0Ww,it;=\nwˆ8.퇻&ݷlJ{1~pl~M~	h	\'p689fpw;8FCNIpWN3j\Z8{οMb<.f%kprxHixHxPx@x,<><K\Z\05,c/ᱍn8]:x2<^w?O8O(<OL҆\'!7ko	~evwz#xm;<./x^(Fś5?xP+:^>iX+MQGǑsj#A?6\Zo\\7\r|7/7[Ԩ[8V:NU8\nZz\nz#mq@F\Z3BLp|$\Z|\n>\Z\"h>\n&ÿ~g@C9A\'X>|z\r/i</}W3kDzKFP)!x-;ߴ?R_ \Z\'JE^o[T_ P5CC\'\ZBDb;Wn\'4;ë;3m+&C+maD&eyQC\n¼VaveMu,X8Vm?ػֈpPA8-D8<GE!]݊88$\Zp \"AF#\\ k#%3ǳYRjC~\"NM!μB%ш@9\"RQ@C\0\\J@b28䇀szt>f\nUűAIf!(T\'DSES<j \r!\\Ar&D#\"TJGBW1W1F1.!b5DvDd=\"\"	{\0XHb\"nC$w^@&#R\"i+g7n nܜCEƶ\"ҭ)$Dz=\",\rȞڄ!}DܕFܝSFiACy#\nz^$#J%\nM3DŕycD{O?!sϫ\r+F1Dcd=h\0wѤhr Z.\"!uNUī W]rO5oA}A\rtCWF=sA1TkxcqvĤEbj?\rb\Zލ9?CN#濔\"~9mF,@~X<YX7 V,1KU&GރX׹\"6m_!X\"eT/#eʔvJHA\nrN䖾)X:r	j\0\nnT\"5\ZSH7HH	&H=H}~rgz?`?/uih1X4\"MG&5H3w1&ŶdE2ri$GGZ.#Y6QH[}{!!#N\"̐?W.9HV+_fOFz:Bzũ\"2#֍޳>sHz1wmy&y<y1,\"o C79<y^\0E^4!/A\rHH`\0	#A$; H&v	WCB͐0D*\"HQ$\\9 aHj	v+IS}HF^$\r׻[{#BH8)xBJҲmod.2d:\ZEGFAYȈ|dȨ_Ȩ{6+Y+OȫF7$DƽF\"&2Ͷ\ZV62/L\"A pdV5d2WP{H,E,!lECE$5yd,\0x>t}ȧ59duKvYKEJݑu#^ _4Z\"_G6=kF66 [ [hQI75ٶNGv\";a{#.C%!{]!}o咑oC. 5ޕi],rd2r46idTGcg,E+X29֔|FN22)(Wow;1rEB_ sqok,Hى\\UF.}\\q>;\rB\"׵\'N\"D*ddɶ(y\nJy\ZRRF4Q[~GmV\nNGQjVQ\Z	[QN(^Oގx.K2܄2.BELP\"PQV!=r\n=*((c=>Q=P6GA9Mw=QǶAsP\':-P\'&QQ^[PޏE(VIG$=\0BPͨj\'PG]\n)~_@(\n`(&A:P=Q )EnqGQ6Pb6v&E7@љWQ*(gJ|%IAIPҔ/(i%dBڢ\"\"b\\mP1Qq/\nQߨDpT(**JCB]IP	PZP7WnFE؎JƢ2VT	TtTZTf*k[*-ugDgW+IB?B寞F[WJJPeP]P* Zʸ:ԣ8׳+QO\ZbPOe7P5i*ZgTUc\Zj^QM;A5ZZP8]Tr\ned/ꕠեסsP7J7AinwƝw!T7~6jf}&Qfn7P/>>\'E}\rPQ_B/zo+Xf*P?kQQo#QQP!?OQ\rPQ_P?qMqЛrg\'r;\\wZGG+c~D[8Foyy\r5\rꞀV:QoB5IEhe@fmICV\r_@mE7ffgsܣmqmQ(އC	EL\'zg9O,<ϻ&9ɠm./n[΢ݎ~hoj9Q\'}rG:g\Zچ=>>JAFEA_<iIG_A_R/yT\"E2tߠl4`\Z\rA%Рh#h\Z\\胆|8)lEÕ2=hx\ZF|4NpA8hq4э34ch/4}fچfz!̌}h+4F(_o{\"M*F\0fh&ZPEhA=2:4PGG\\\\FG7q1]t\"\"rj:VNB_WAo@D>N\'CgUCg:\"tn~-n~:OE/g],@SХ貸Qt]tWtJgG?xǉj\'nSa)t-t-!]gh@7$_ԢMf\\t$wY\Z53]݊qApׇFAYlA+g1@!zgnCAfN:m9=d=\0F| =?s[+^W2+op5uid/F߼##ۏ̮bd~a-0(]bcvbcڪbtcKOb?l_wǨ]Ũ/bn`zoaԃ1Zg0:Xn9F7\\Jcm1#,c*AbLG]}KKMuUcl!aʜ\n1\n09ӯ1`)a[e0GZ1Λ1];9c/%M}9ǜ칅9߂99=vsn;La.Z^]>c.݇cb%qUSKb1G#l);׍Ơt10\rA+Ơ1^\\sCrÐg0w1܏zC00c%*5pbx0RHF(cD1b\r	b\"D!a\\`v`.bc1Wp͘xL?Lm/&6IǤ&R1i#9L$V`0#7)3VĔ)La08ʿGDS혧\Z+0SkSkԕԽoیi`^0/1MzLK**Ei}ƴmiyu0tb(a(̛vL#Yb}}yky:p[=ebüR0~0O0cc/0`&1MI\\dfmf\nUZ;zZ\ru9L<fzff33례q[3\nkfo̟&=bFfkb?fY ,gaV1k&0Z#fِlأ0B2pyM|VH>V)f\0y\r4v#}V5UMUj<\nj:\ZauTc:o;awc\rձ>X;I\ZdvkXݵ8<iBbj\rX^W=^j{`m~0w;CMaXg\n1;p݁uĺ`b	|w\r֫\n{23r{%E)_slֿ&pj+6\rşρ3X,\"б!,|g:ᨅE\Zâ|&-Bc1[\\X}6c87,,\'be²Y,;PnaeXw9,2ñ\"TJ~b%,V\Z~8Ćf\0`ÆIذy46^P`#FrƱQi+(}lBlL7ՎM\'aɅؔؔ9sl9׃M;y\n{#{u؛+؛\nfdc3JYav;^S؜/&ܽlnNl~#^`\"\Z-6cmؒ2p2^}x[[ލ>}4=*c2\Z$[[[j}m4}\Z׆m+¶bRmKZA؎l}·.{lbMb{w`:¾`Ya|_cvCNؑ5\'ر8X\rHq+KT#vNv\r\"aZ~~}׀M`g}Io`8b8x{|vp\0`2]`ҰM}\'Gc-oɘ+6dqʞU8tܖZVEp.)oRvqj9Zf?N!^Niv\r|ǷvRv`q&Πg003ۍ3c?bqBi|, ,i3Μb3O<35Y|(\n8$mգ88m26۫e;gOҌs\\z;xw%\0t+\Zwn,sI8s	on?,ɒw8_e8cW\r_G]hػ,^\\]\rwyWTA/ j8+jPNq0F?qP@>!>2p}q[xPNhp8uW~:\0#H_gpd\'8rEG9ꋣhή8m\\Ǹ3cUn8@%\'8z.88q\'yJ>pa[4q)pn\\Dr.r	U=RMͭUmŧlp	p	w*N*jqaʝt\n\\u.#.O=q{A[p\\A>\\v}\\	`bW\\ր+ggqVp1={zW=Yz\"uW_ksxy\\ǵZpmvp\\{g\\ggzW~^͛/\Zۿ\n}<o\07{7)7w\Z7q7\rGoFVq=p!YO^,T|=7޷fиYSY)sy܏Is\\HϔQߺ2܆\nnu3CmLilmG\r]W/*S-[[Y«Ujx}X^c\Zהy)p,uV;bzz9x}X^?+rop7\n;7FHSxE:~׾l~>-L=Vv~WwH5;/;d[GvJNgeǐ{n^\'n}^\rxߚ/xY)3w϶=ikL\Zk^w /AV I>zr\"px`c(1C\r}xOB*pg	qQlǣRSf3<:\0*mc\rxT2O;\'W񔃗<<Ւrxr<<#gMNlc<ϋxkx\"/z+K]6|,>Jϥ#Sy+7W	Z|\0>!>O>q,>%|r\"8O᯹h\\9EOoo!sX\Z&>>>$^_8k2_엍/a7|ez\n-|Z_`s]c]͏-L1|<|wz>w[3h~,p?Q?OOIO>__\Z>ώ4H*?drsu[iBQW僋zm~QGtKPF&(?Gج_IpRpݷ=*a{\\CPM#9Tj^A!A3bޟ=J	L\'t/v\Z~s9a[=B@$F!X5hl6yC	{{2Y}6\r?\"#8~\'Q&A#G\"{	G߸y^cL6\Zݹp6p<1Mh8K,\"x݈$x=3!xUIw	%`S0	Ww	߈	g~q?)vpnxpzp+upQFp\Z!DBB\0iK\0`s\n1! իȷk/[N%\'	k^b@ryJ ]#:,	d<yKv	lH%p#h Q%AbMT&D#DoQ+vܩ&\\)9OaGڙNK^\"{+<2!%3!~p]őp2-pV^	!\n!=-!N4 d&-١;˟	w1s=\\B~L(|n{C(.E(5F(dі\nRȾPYOx2Nx\Zut(>PJ+i\'<?:Ghd$T!x%%ұ\"Q!.yM~&tOd <CzG_o\Z	R`z:a$&aΕ00:L$|8M~u§)8s\\ѓ%nd*%7e·U·j6a\ZI>[@K#z\"_܇y\ZBwGE GXZ#,&6@2\"D=`|9MQi>qc-DgmH+m<8QQdB jA4F<In\"j[SDQ<Dm!ĝW>w\r\rJ{D0ɘ˗I@n\"ZGthǉh}fh\'ZmSv-{!\\\r}.oUc_2#OtiHtKt{Ety@tHt?G< C<-x1urѳ՗}$8\\,A.%aE/\'^TGU∁D\0c\0A:D4\"$	d\"Ypʘ$uhḎD\\<H\"R;\"tHkw\"2m!:$rglDN\"[Nvy<P(\"\'cDq.()X%J!RKbZ1bbؗQI<=CG%FEc1Hb8IEn!9 u$&>%Q\'!҈ijĴ[.o;oۺ3b&exkC7\'#wsb^n%1n1 X.\"<\'>xO,~XRM,$V޽L||0C%֘7)!\ZшĆ⋼Dbl,`eb˽XbkKbF# ؉\'h#;Jfz=*=vψ=/}iaľ%4#ۜ8gq(:8+q$EGcG87q\"h?qG<A	!N{#U~#7!.Pb⒊qL\\ Wv&k׷בB<\"iӦMHE$G	IiFRp\")^!)\"H\\Iq,@RHp$b+x#i$DzI=iEҊ\"iՔ\nH;$C$i\ZiriYdrKB2K2[M2P&!.veg,о$b7iwXi\r%Hz&	;EL* 9\"ى\"Iv\r4+i@`0tD=tOr&4ד\\}_<y$oݽǵI>|h|BHHƓN>$q\'P ]P#[%zL\nF\nVL\n]L|ݒ{<pF)@FI} $x-	z	:U%H1ĝD2H\"t!a$OԛDG\\%=#TAb\"*VGHygfK}Jul$$I)IR\Z7D\n\'_\"XRDҕ@\"\nFr\')ܖCZb~\'e&IGII/H7H7I&٤%Rf	}{t%rRn_Iy~HyUH&kq֝T`T|ThGzp6 \"TC* \'J&HegHeE2\0,GT>TqjTX%=TEIzOzJS$U[=$l$,&=>Mz@%=?#ɹyO!+Gj^ZeVI!V:=N`q;.\nA\Z\"zLH}i\rWR-Կ@\Z$\r%\rm]\'\rN\Z>r4<PA\Z&\ZFF[HP\ZOˤ\n҄O%ik%iO@.i6in7\niY҂1i=ҊR7LZNZ-%hCZJZ{HY?72YvSYn,7gG0	,ҞbdkmCdMd\ZY;Y	YoBHַ%룐dK䝤\"#86l\"ZMf6Ls.ټl [$aw6^6c&dwȶdۉlB ١i%og%Q/䣟`kcQcdep7uM>݊|<ŋ};C>9F}}dOPǷȧ{wl{@> EZN	89p¡MKGȗo+rp_T2S1!:24i}C!c؇d))1NF ިUzdL9r02*Lf#FdP-}?QGfY)dVH85iL\\-d|8Ckdioʚ/9\r9|%DRDvBY\'jg.Dk\"\' )Ԑ%Βo/%g\\O$g3w3䬮d`r%rȔS GYLy0r^9<94/rIQEʎA:C~49iVZޙ(\\ۆ!yOW|\'7Lˑ!7fGMh>ܬ`InD[ޑ[/%fɭ+*Eo*K\"W~׽.`5M\'r6sg߾J\'n%Ƀf\Z(RmT?\n<QAQSKnH) s \'/z-\ZˌciA?\n$y#m/_|.Eo%EN;\"nF(Ulil3~ʥΤS4vP(;St1->#PAi?s	\Z.&bLI1wPLQ̻:(߼(V-k766fA\rt؍nSR~@9\0.F9,rKh7\'c{c1[/<C&yq\\F9irdC/f[E9{rq0*7	ݡPp(&s%Eʥ\"J`EJ!\n%%X^j@PG(0v(>:JA}k\n=Xk)\n0XlL!s)J\nU@fRwS(̗֕N\ny\nt3/(&lE\n(a%b%_J8%7%6jw%d谛8$הSRe()]kk)<G(i)i)׿ZRn|\nQSR+)EJ?(y(\n%HwbRM)ͣ<\0lO)mYR҄{ޔE<|\'ao6r\'FylÎR4HybmAbSj)u\nw(u\0J֎R+Q귟<8$/Ki\0)z(?(c)mΙ\"K,.Jsu΢۷2mKy0~Cx{-eLHRp2y]2:2U\'CB|@C(3)?,(svU_\r_)(F\')\')&=Uo5ekn@lS6Xʿ9o/(>U{*OJ*ظSpT3T%3	U%ϐg_jj>NTTMTT݆cT&UtU/#U/)u\'%5UTӘj:>L5{M5o8LCLdA,9Mljӎj}7j}j	ږ8S,QQ,DR{P]~n?^Cu6`TuzRSzZdM=zO0^P@@٠^\n̥^B[ylt*Dk\n}GE%QGT\'e*j:b.S؇x/B%\ZQ^1:JҊdvs*s(~b:JKP#AT\"APP2\nGB*V|B?TJTIw(5ʋ\ZzN\rO}K\rI\roH+FWSc{q`jA25rJMݩOMRӞRo4SoR3SY*¨w3洞g_TQX`jI.jwCj^F-mZVvS\\>S>}B}ʐYjmC=#6/Pjܩ7m>ckҙ{_dM0<]_S=ԑԑzZuN=:=u|1:@~Eh~kPg39L%>\ZmÉ:WLGܡ6u.qQǩkwP׆R#S\"?cgip4YSM^Hgbi)4\'4o㴭rjirBjB!My\'Msl|Ek~DD38A3\0h0;͐fHyь\ZvLit |s*m5EZ4e4W44Ek\\?nƘfϭv`.}@I#wtYÊRHs\rNsZ_٠yJ;:Cy!Kh34o&vr(L.GDY|,|h)\\ک+^3:ڙ	(\\J/<E@;gL;GѦJ;oͦ)ӂ0MQ˦i!x\ZL#\rsm1iHY\ryX04\ZZEíw1_hD\0F{1ui,X\ZVع4Ε\Zh3&	74qtږMJEѐ#idZd4-jԆv\r8\\F|WiI>bZckߴkJiih_n`VnO:IKW\022)h},-{cvgZN-=TG1C\n6li[WfZv/Zq\nDVJh_io7{CҚ=?AnI=s=ü={Eʥ=W|Ek\Z az/ae!o5m5Ok\r伡:HZT\ne+UګikZ>>+ܚ](G{C:DO9E}}wJ+L{{.F{glK{w\\.|3m@ߒ6~6FKi+h\'YϿhXh{RitKi}}~Ia6XKH&lЦMcҾAh4wl\"6[,O}A~]2~-=9J[j}I[>B[yYhkuzșDh{LXh}u˕i+t%jJQ:}+	D4D_GhEט5lZ 56Lז*u{\'	tCS,hk+˶ۣneOB\ZGL[~mT#]8ݮ7n7J[G+I\02^uG\\At<So	=h>w~({N=)w}tύiNdLe}۰t?OKE3=t&ݿHP\\M뢟d3ͨ{+O/);/%/ZӃSyAt+:N#7ѡ^tLP	3xK>oD:7/N~ZtU:?q-(Ρ9tc}pAgWŅtaT).Lӥ-9hzz($=nrζ__I_?=\',\',{ӯiA6=\"===e=W\rN=f[\r߽}wp\'=OqE>ҡ(d?z\'_o3\nNjmjt&L<٩i3I=u\nGo8Eoj__p/[-Vjz?Nz.seUF?O6׬_\rf0akNw,A>	m6/;~ǝ\'7\'P}^vG\n}|Ӕ\\B_QWWWW^5\n}hzSJXfx#2\n}w;r\n\n-RbIRbC9+cs\"cM?c2c5e܅yШLeh3t61v_g1F/3HEivl!cWòc|êna}}aúc3whwÂa%þ+áuc~\r\04qS!G^4Ƒ$QJHKƱkW8:G2|<2|}13Ζ1䯌KɌ+&ی=sAƹ<ҹ%F\\(#>JP\0 3Q؂3`(ST;9~g_=d?3NQ|AfV14=.`0>1sGl-N#,C<q!mA3B/1\"3\"팫Y|Fˌ،FkEFJ#H\01T݌֌w2nP`,Ke,fjezH~#ʸcg_b8WF\r0q;QQԕxQ\\QqQb((me23O5J-N1!xhf4ƴ03Zw0Z]\"cF{wF5!㕎݊fQg^ceu2gCoI匑m!;\'	ZrތO?1>3c(Ƥ<c:P1ɘIƘe2arX|XYzʙ{Vgl@v3eϭr3g*V-{>3F~enfTߕ`gjT15fjǙ:\\<sǏ+L=_L=$s\'`f\ZNc\Z+m0wi2vgZgZ_ 1&\Zr;\'DC$<yɚh<rǜwt><&c0]_LoD;N{<fx>>KLߒgLӿ*®l?$OL@3	ĳ`n\"ǄJpoe&<KX)a\"}ҙ\'MLt1kLIgRәE&f2HoLde,S\Zb\n>3%\\fHyf(3;8s`̼\";̌Όy{3̌=deU3q;]}$,f93ofm&z7\rs[̌N\rf6]N<ͼby fT.N\r-ШY8̼1^g>Xg3K`̒rfɌ-Wf{1R\nr)11Yʬ[gVf1މ`Ù5?5GJϝh&o\"eYv\'3M/ݸNrgv\'1_mQbv^cvA]YefKb_OncV̱*o8L9/a1L12_0^̿#1c(kS-K;%wKZ{MV^RRbim$,m2󧏥ڑUa驯XX;ĲfϱL<,B&هedY\'LXV	b!u,;(^D־UX	֓,/YGVNXǰYǾ\\R+YYì,7tߒ:G3aL.&gಂ;Y7e.JX\0S] x6f,ts:B\Z	wY*\"ճ޲19ÊEE]bqYa,VA{;Źx;,v\0%tmb	Y\"K4\nteE \"wڰYWYW5ŬIXѵlVwŊ;Jֳw|`%hRRY6X׺cXi[Xi*٬[ڬ\'%ÙL^V֎V3+~#rmHV^6`+zqUlN`ֲJ.γ丬2\nUnzؑzĪ8Ȫxdz$Uuͪ	Y7j\rYf{BVKBp7\r5jcuDmaugO.zY=\'Y=&\r;b?߀ꯖkYCvyì6wֈNȡd֨F\nkWC\"kބEF_/k5QYǚXA4\\XSYo]mRiCUO5֜<k755k~Ŏg)֟x߉i֚dk=kkivvVV\"؛77|*-M9lS&ēZB-;vwVe`ay	٦ƛ٦l3ll8۲;mczmpmgv	f+bb_gJd;	lze:y&w}(a{v~e{)H^;lom[w%wNig3v@쳅=쳕g.QsgKrcK:`b&;sv\r?6`U\r![Ply6F\\a#U٨ltG66ZWb=β(96AuM\0k	Ml16YMvfSj,i07)cllh[-1eKؒslH[Z͖vCɇءaw##oQl/h옿eGqS+P;CvfUvA\ZN沯[\'m7WmٷFw2 |o);pފ}?~v|]br]Ƀ][.Wg?Ե`?l®sgW0&UXv~\Z]c~®eE-U^f7_fحZvǉ-.!V9S~kaNLnG>yǜa~Ö c26c\rG\'ϱSo1`OQ>w6\Zϻ}_A_Ir셳7쥑액0_eSc\r\\Y##ˑilJOerQ8jG!P{|6GRl5\nl}l{0nَ|Qas48Z~qstb78z?Z9679`Tg\'1f8f9!:+7g\'c]X?0\0?slq4g8v	gg?wC#E\Z`/ǹЃRqyqlad9ne99\'9N/-wu9iYK%笧\rl ČS#8pOs\Z9N@o/RP=RL\'<\0Ɂɐ8G8\'[!yqȖ2*PsWW8uWM5C0iMsOC-9c_9eW*GD7戾sBgp¤jO8g8[t2\'G3\'!ǅxI>㤍s97-8798Nz>((zNʹ1prZq_9\n8U\'8O9E41S(勜ǲ9o9\',95:1N#yq%OņiB8-ɏ9-7z8-VGNk\r8i+}i[t9b9\n8/99]͖noΛLΛ_#^ӛZ~3yk㼍伣p^rosr=8CӜX+_88c!!sGOYg98g9e΄53y:[\rOoIzʙ͙=ę̲_S-8oqs9K_sV,sVNpV9P\n[հ35Ά9p)+Aެĕ_ʍR|IWٿ<9Us -ܭ	NBW8WՎ8rups\rBVF\rv\\XIB%<ĵZ%qmev_{)r~rpE>krBXMCùUkHo#ܣ&s^.\\Mo={?qCqi.*\'^zxp=͹I\\?\\o-9Dړ\\\'?qzr6qq\Z\\Xm\r=g2=׸=/P^^GFp\n?`[\\xcи8. \\l_.a.]Q.ǥSpl/. &),r/	F-^\0W8QͮqydD;+J_irC0#7$7rĽBs^^} #(\'rcǸq?qs?s 9nrsnnʸ=\Z>{mʽt{ϽȽՐ̽g½f_fڸ\rYVmܬ	%n!nP7OΒ[^-<\'-[gsm4neF[)}>\r>1>3Z>s>W\Z6!r[1eBG[r_r?ss{κp{`y]gw\';bmw?}`DL~^+!xE7wj݈s73[a#w{;Lgq۹qW|f9wZwac\'_\'ҳ=sܿ\ZOy(ڡZw m(//OxOfoW|AB+e6t\'o[vo[{2OOtu>l]y<S<_]y\ny\0:tg̳dy }{yfxGdyN<W/xM:c7yy[\ZsyyU:3x^NN\0ΠA3Lv1û0]T\Znwòx&x{yGyP %Pby<E4OZ#<+j!*<bHNU:<btl1#W(c<CJL4wÏ\'	^jxB4OrxDO|1ㅾEE)EyQp>J_e^g/KLZRn/OnDh~Ļ5w;2//:/?ˊ*;;Kxw=k|;yw~wo xw+=H<+U^U>{<Ϋr«z{z0~^5WWÈժD\Z^=bi׬עk$0yL\n\0yoHh^o_H\r\ry[y1Wxyc/\Zx_xߣKx3ɏyƓx?2輟/ޯo2ޢs_8wz&o /TST\"S4_.Ć/Ϯ+xeOe`ʷ-l[\"[\'[[~o{W䫷*55=;;uwz|}6aoS77f;jdqo|\"\Z·T-/7F|O<Xo[roķo7S-mF<Ad!1X-i+&\nw??ōܐ?v\"y>٬?up53|$?\0?\'?\'>>6y#|@Y>·~aOZC|$}=ǟO36>NO)T|Z<O|30D3d󅽏|)	_z-\rԓaH;~պXE~?q7,yOWTN,\0tbyzu9y~C8?w/3>KwKFer?!$a2=_?j$/kr_:N~21~ü\Z~~:\"oY7iDۇ7_˾ww/+YL!spp0\'a@ٝ|?Ꮕ>ʟHL򿎻53S?nz_Co++CB\ZBF௽ȕ^ȕA4X@]}3@iX\n43MZ.w\'킝%?@mB\\`)0wFrFR%[`D`̇قݡVo{6}p>J` {Nu_z+pO8~wsY%8Z/p2(pG:.B`GN-Ix,^୺,89()T=i$YF\\2\"Dy.O	\0(\0fU\0=$x2RxA\0z	3O\0,\'%	:TW, ^NP_:\ns᳀U\"`8-Hg[W *@GN(@m\"t{U.D\\=KĊ8 N FCI|BHX$fn~ϞR!_gy?/\nn[NAZ t |$ANP  knA^1A>vfK`$(}ܷɿyf	Je\n뷂\nQ@a\nLT\n$ճN^\ZsOY&:\\Мp@<GK.x.,x dr]/\'/W?ArXkt^ c5OWy~A`#^QX	FGs>?|8/|Qco&>ɣ-Fogv\n\ns	߂NL\0]0-Tzf>b@Bh`፫`__,%&A\nPoS`P}VY4\\P[\\~QvX).j	uB\'	iBFKCBKyBcB\\	Hh 4שמ28*Uo%\0-}	Bvតֻo\nSIB6Nh]hwZWhwFH(O:xB}tSgdeΟ:^#tN\'N6B2йH,ty	]yB7WsxɞBB?=_?X\nV./^^R\'f݅A. `VBPm!.PBUnawBػGBBW$\nQBTP/\r_؏}B\\.Iz-\'V\n	_$!i!$\"dBLH~RO	Y.!++\\M&)\nBaPn/Cf=aaJ\nHxuQ!ɫv\n/	S}ׅig\Z7O;U	ob7soff\n:3;aIyaNj0OFFO6KZ	뫅\".aEa팰-DX%jV	kbgog+a}mV|W地i幡Ê\"x$/K}/_;_v?{v{o-	I.LXC8$%:?:m~~FplR8Z _-r$\"ڑ(*(ppvɊwippp\\+/}*ݭ$rQ,\\HM~#\\E׿	}=*Ԗ\"R85.RP0NxH1%VX1\'R:)R¶ʓDJ߶~mm5\0;ߞmO5T>t_E:\"|hǎsȀ=Z뉌{~L;̯͉v\r\Z,ǉ,-\"Nŝ\"+;]UHd[d\rl|D6,mXd,;Kdo4.YdhC@eP}Êˢèiѡ\0s?1ɈUy5&R&rՊ<@\"sբcY\"f?o>ul_HMtNJt|CtCQ,J\\-\n~]Q].ȊE@rfdGk\ZD`/.*/]\"9R.S̿*BGDTᔫD&%=CD.؛\\E6W%EFD\"HC΁\"dUeX%z5PSzK)J J%WR.NR/REiOEi?zE73onV-n>ݶ6meEwʈl4\n_/\rT;JRWQK;f\nvQE^T1@TeѓEO.=|Z!D^Du12?$yQӢEOԢ_&j]:\"P<&,^^PE~w^rD\nD=E}w)Ȉ>6%Fb$S羋>>}!͡hݒh1%}}i}+< NqE)ٿ4Wk_*\n_GzD&D˶OD+*kG>VՅvZܜhmH Z6&Zg&.޴lP\\m\\sX}XL PDw߃IbM/fYX+Xu,.4먿zb(Zl.6MMcŦEb3{%!bNŋUUn%w+xOAئPFl33(MtU-ŵ\nR~bxKuw͋?y+v\n#vS|`E3$JYf*v[֧O얈=vˋ=^nbްbhIWSDfS>]	s^šqq8(8G8{UDƅb/TP\\\Z?+t:asnbfE%F+GĘi\"\rĉ	AM1(&++by1q1Ͳ]L}+k.~@k1W1sO]j>6۾X.Žb-q-^敋öő{QWWq_\Z	MHqR8SY\'5i\r>߲[z3+6sg{~sFNsstyqQz^\\|[\\\\9(.&Kω+ߊ> b5/gԛ:q}7q5BqeUܴb/n cmLqs#PGܑ w_s~{[}Φⷼ{WߖCMgC}L\'\"!\nDْ+:,)\\pO(>$rVxflV<{&K<*]\"&k}!kg]Ŀ6J+?qix9\'PW\\+^So\\&8I6I䯜((Q$*V/9G$[C%~ܓl -ѾrI8WwOcUs\"љɔ)JP};D%1xaQ5ObfhSb4.1ђc{%B䝅d[bGb8,5}Vba.mXh%6ͻ[3M^u/URb\\_\0KrdjFl}FZ$qH_	x\Z`$%>,uT덑Tu119DI)^גݒ?%${K\\H.H\0ƉЎ?+\'A)`2_J|	n%d\'	e..7p%nXֿ]v+a>pHrQ^D\0\0ID y-ԄID7$U$dO+螕\\i\rDm<DHG%qubI$yG$u~ڋ_$7F%InI$SrgAMK.왔89H\nK\nI\n%F$%l$ŲIgIY+ER<%76II\'${$y0IcIc%ɋⳒ3O%MZwIӜY%#i+iS59B%~\'$/K^}t\'VHlz#)\")闼(pcH\'%	!%d84F2h!T$gT2&|!|||)|5|$v.o*~hwdFddmdVdnxɏÒx_;e$z?Ybd	8/YJI%$H֔~I֎VK֮J־$kS.%cRiMRYATTTTItuTc-UiLn&Uǔ\"J5Zo:T{T/IW/{NQTât$2Skǀryn9Ut$.Ԧp\\j= uaJKI|̒r:bGcSc\rRnۀx鉕RFW{\\dVwRzʠJzGzLMIϗK/{K/ٖJ/5J\0{)cJ\nB5KA3RXƠn~V	Of/E?	bRlHJPtRluPJQ*%RjjL)sCҬ,ä\\ͅ\0<*QFI\"YDf!Q{GeSv	%\n!H</9{s9{\09_U\0؀;=\\{@n}@K@Y4 /np\0X\0(\0r\08\0\0@1\0L\0k\0\0>\0~5R1\\\00ڏq\0n$0\0Bd@b\n\\\0_\Z\0\"4=5@\"@ǀ\"P\nP,n(\r((3\r\0JVJMg@T7:v:>(b0ic	!L^F:N\'|@g\Z\02E\0;x{u\'-F$oaNGS3@o<v_\nhk\0PH:`0<R7q:{ӕ\0^	LL2\'S/׻\0scJJ?+\0]\0V\0V/TT\"w\"i7_n8xܤ^T1n>\\3TTMT_\0f[cv}jujmw8p9ԃӁz/;\0\ZvvFK%@Yc/@COn@w#Nm@C{.ΨxБ<ct\0YS@wcGcc3o]g5IйMہ籯\Z/6^l؟[+N//`S:0o`0c,dnf^k>^}܀	0`\">cI?)0eL[L	L(\03[o\n;ٯs^oW2ywl\0P(l\0z\0AsX COE r­lk@xx\"A\r@T^M⭽D-K 0H\r$bg@*h:Ȋk@%nrm\\/)&@@:)P|%nt&L(;:oh\n|p\nX+d3?K5GjϣZړDco!E}F́Ok{¹pfg\'`+ruK<H`\'%s9`W\Zkp{<{fgIG9\0)E\Z%9pd\'puR7p-kgTpy788N|~h:N=oXZNgn^{?#|끿z܀?!*-	5K{ڿ X2_hCeIC2D9v\0R3RUwy xzIV>9x\nҌiR@A:>n	ڡo\nu`dXdØ XDɩ )_$ho>wо<YIPy:EtЛ\r4YiYmzd:\ntg:Gd=tK 4ܠ _gAA<x /\nWI5hw(\n>u\0|AA\Z7pPr$|ЅgAa@ᛋA P)(\rVPEj\0%Ԁ7AIW@)0Pʵ%P`\n\0J=z\rtc,(3(1(/\Zɉ|8o\\Y-\0Y s+j>gA@5aa@؂^n/r@Dh]Aa\0]0I sCABa(#$$6P\06s@rS\r*(oV:\nAŧJ鑠2D\Z5aK#`?OPm)P-OԈ\rz|z\nz!([j_+un2D@YzPsnh4<hd/\n4\Z-j{\r40h(h544l}4}hƥ4{:\04\'=1#VM	V} X3T\r$:ی[[}[\0o/\n\0 >`l|l\Z\Z+O{f&\nA``q{+Vw/`[nmض.||=qgBÕBC81\0>iH;mO	a``7[{2;2̍`XR5K*> Ϻ̂\'AY ^ph\n8}	84o/UGz\0ςcN׀cXo*8F\'Z\0\'~_kf>Sid4QC~\n8J|8?m\\,8|w~+.VB08^Cg|\nQGQ3`}F;s0Z,&[`g\Z2`=`:\Zت\0s̭``AXi\0-%jn{[<nH:le[*yG_<Tph\0\\|\\HWǶ!8i$T\0nxn: \0?ف`p3\0T\rnk\0RQ\0w<w@Z:AIo5?x[Oʑ>x\nOWX\\<zxd3<-`m.kx\\C_Or.\'_lOzgY9x:/i߀ך!ޏBL$Ey\"XŃ?0i	QٜlQcMC}\'/A`w;M2D;DǱ˼[?3<wɄCu V {AL {CL-Bm?	1GC,^\0XGAϸC6=9Z=nQ$)AlC- }xȉGg!j!n{\Z{=#|\0⁫CtALtBl ^\"Fa@|3!H\\H^2$	)\\2\\JC.DI!_k ?C@;-!qkF0Hk%9ZzȵyuquHZ6ȍ !\n	C2r 7!Y Y3슭qHNk8vv?rg;\n-yۦC\0N@	@`ڲlA;`es!xC#(Tl!7@\nKA,LyAh t!Orj~	aA	A8 *D^f \"\Z42\"\"3	y# =!ED1dRRfyXy6lԼ#!\r>	\nix\nҔV	yRIXAZW!@Z;@^\'A^{ ]HW/.an|jS|	գ@z}4 OA!>\\H_2U	2ԑNo|9/L\n=!ߓ ?: ?B.@f~C暝 s\"OMMy[m\";y/wmȟᓐ鐿q?r !>d\nTq/JuFTPU[Oy-G@kc\ZPm-$TAQn1T_\"tit盫]HAb	559pwBAM<辣9-jэ8~z=!!=jEpZsGlУP-PoPPd豟iP;7P; ~7a!,		u:U:o>uֺu=\nuvƻC]AOuauzn|T#Bϰޱ\'PCP?.W;@dnА%s=sCô@A/]J^(wh-4!MM~z]z4?M.~rCoj@3R[Л\'bY[j.y;8iAAPp\nIjAalb+PB(ZԷ:P.32\\t?@(߀r<PI*ԫ\nrOx*\r*Q*JnhAoiP9z.ȴZ\Z-}m\r}ZC2hUZ+	Z=`uǈF5ɖ\'\'&sFmB\0m\\>v@@[|Z-Vy\r4:ں4\rm=}9}}X8\r}gǇ_d~~j\n{\r<:b܂cow@G#q:\Zh\r6.ceX	51tb:y\rXBgbB\rBzBCe@f=+Z]tct[[wlcl#si\'J^C+00m/`jϘ0qؖd0lK)L=UN	ӹU?(1>3+a{m!a&\n0۪}s0aG)065a`,,vh%vXb܇Y\'s0a7ra\';SaNoa.`^$|y^aAs߰`x=Z5;vA4\"k\'aтM`16X,+U`qXXyXCX(#W`I$n , Yea7eʰ氬\n4,;B\rY g࿜`G-G!a.0<ge*aa0?%	FVqn9a9%Fclc\ZWƤjX`{0ws׸\rŻx0Fc`s0r/Lu&IF00iuLL拆ɿS^K;}؇\nFaa\n7eXէ\Z.X]1\0\r5N R3nss~6<T	{io{y/1ֽ \r{7#>S}~\n,}޾s6|lT\'l_8l|Ol267\0!¦wf\\`3jlNs\r`zq\ZxV\r0i;OؿZylXw_?WlDr\\s\n\\k9	5+[wޅ\nn746$<ໃl{\\*lk=?7\r7SXr_̂~=?Z?VkpG|S9{ܽvn}dNϾ:wA/<B1~X2\0v\r<,	<@&ʂj	xawz?)%4<o˅gug^\0fKsZwx+<cT8/Oa! 8c$8vG߃p8N:xFp\0Nj3M02\\&p9\0؅,c\\kgll\Z9ŋv:W^yZt^8!^DX719\no9\Zf/W]O8oʊo ߉*=?,u.<|(|؁G~^~섏>|\Zv>*|IT\'|Z|f8>z>{p>Z pjyXwtPPG(:F(/!qBlhKAn\"0\Zl\'&1Bl{Ѓl|@L!¢z!v|B!v5#Xnq=xB\'\00C|0A؏0_~p!ȶ ,mHjIZQ#O #6W#DXDmĉ\r\'K\'i))gkN\nt;yq8Bxovo#m*Da.\"IDuDPDpX\"D#q.@BN .ToE\\D\\Ba^0\0V?BĜCX#CIEE fD.DiDe\nqݧ\Zg%H#qDFq\n\"L\rq=&\ru7q<\"FY_By#EwS\Zw)`|xGf#UPn6q*:t?E\ZD_E8~m]<\\`2#XȿN?n9Q7\ZBHFHK!*{K:IBg.D\ZQm(~=(h#J~!J!pDY&<\0Q^xXp\nQy񘨈x\\vdrTyx\rXHG4~E4#~; eψf|/x0m@tl@tߩEt%goI:=!zJ=0ćO{0g/eP1YB@(+)qĸ/xڏ1=E>A]GGu#>!~M#~;\"\rB%k_kANC*KAn<ՆTEM @\"Uꫡȭǐڑ{1܌D4LX4!k#,@&t,ҤEܻ4>4o=<=<!DDAZK6MHsHǭ-\0%骑<X<\'B@z!.#bllR22 !C42ȪZy~\ny1bV12F+Kdcd~g!_ ,9 czqs,dTdy]3ddt62ug,25L9L+!Gf#o\Z\"Gf5^EN2ACvG歗\"Yא@FtD0c$3عDv H)$2f\\CՐ5$t߃$r[ۑkHڞ$-2cdԌ#9o-H^\'\rFlcPf=R0y)>A!Ep4R\"R+FJ_B!eIH/)d|p|xY T\03,h@!VixdQYYhEh vN \"rYUIU#j`Ybc##А\rcRdU&Y-N]ƐAȖ\rȶ3vc)}%\n8Zg5yzEv+Boo#,#W!{!?G}6\"nB~G~;=X܏OFl& gaQ?-uȥ}zȥ?rr\'o*rmpKFTMOTLT5&Q[`((GQZ{!(7j=6(Ԏ(ڋ5Q((ݨ=!Q{P{Q{PNԠ(3~{j?\Z?e\Zu\0{Mu\'Iկc#]s(k(XMԱ|/ʶa+;u|DKd8ʹd-e\0^rDpPF;Q^VϺe-EKP\\T@T>KT5TP8**	*4:\nBG,*lvuI<u%\0\" bPW3mPwF?ǡz$߫0uǨk9WP7_(2LQ2\\QXԝDKԝ_m j@\n(pMxֿEA_Dӯ(䛛(ԡz\Z;J((ʐ\0E5D1zx(61(@qQ7(OE	C	JQ\"$J%{&Q(i%J[ @ݻԌz@/Bj:J@&J7(\"ԣ֨JT2Tt0>UPn\n@lzz\".C_P\rhTuƂxTc)y\0-ն^>@uN::ߠ^{C܈zn\Zg/#PQ}.D$V9\ZM[A?@M\0&ݭQQG\"TԌ]Ouyn/=_y2.Ԓ\"jw>_/)fZ[pE+\\VިvUi+zIz,ZH	\\Vod5\'\ZhM.Z֎BkCb\0h;9+^GLERGħ\r޾B8<&Fݰr*4/1\rom&ޟ2>hmzދ~>FE&C;\'\'\'FNQSQhKhWӱRB?J9#>\ZB{ڣ}ѾF.h_EE;\n~8$iD[ډ;]>`G_/./,//f[Â6K&KtĬ?}9}}y\0%Vc_F_-My]SDAM]i@\';Gߎշ4ZtZE4:m8\Z΄}Ft*Aߤ/o>o؂AlށmG-2@K\ZԜעD4\rDyhhb4*F՗ч11hI4YGƚh\n\nMy悦û,{4\"4Gs͹SCmG\'Rx-*CK/{Ѕ<t]Cm\0cM{fsG׬ԭ\rtM&tm]~]܎n݄%G?~vg\0j,UA7ۍ~a	!jnE,۾;CЯEn{7o&tA@+z\Z=Tes z԰	1z\\=5BEO|@OBOCO1FXEϼT@;>A?^8Ԏ^LE/DF?i,ѿ/rK+BFG6FI)fi+fcfH>f[Q1a]1[ۺ1[`40Zǣ0گM1:3$fGc^5Ff̮*̮]okӵx>5YE+\\1s@Ѕc_>jډ9Xk;ƦYc{c{cg2_9㠰@LŜ::qqqρb<v`<V00gcb|9`|`1H_LP.&P~7:`7+cBԯaBcmń2h\ZmbL،1Rm(&Bs\n&z2&vW~&L&&&r&5I3zIb2_c2Nb201\0L6u1@|)+|0HrI?u`+b\0CPoahz).İ\ru0l3q5p0B6FL+Hf0El1̽;+ɘ׮`01*\'LI%.SyT	TݱTTwcj:SI31UP̋SVLkUL;rJ\r#LGs%塃z^Nـ.ü뾍y7ߋyo)ӏbٝMC9ke/0#;0s\07Qf*3ֆ$fj3u%3!a~q|Eg9%ܘ.v:kynf^,>eI,Oc,\ra\Zc01+Gl0!0kSG\nwaCjaX=ưa\r]7*]cU\0Kjvv6v4VV\r-v{75cu;bwy`w\Z<\n\Zj`w{>~Ě`M>c.k5{5߈5\\=tk뀵{4֖>݃KoHlƞHHÞX):`XT#Au6vƺb΄`7(b=\rwcz۪?سNسسE06lPlP=6x\rac/c/$`6bFaH*6r{y]8rylzl]׍nf_$[l)6i{769$\"6C{#&6C.fZfh\Z،\0p{67\\D:X{,Ў{c![V`,b7i#¢?Ģaw%X\\a,xKo\"d;,w`6,Yi`y\ZXWXVx+Yb?>P_>Y-;-[secfLb>zSTLV.c2ajؚغbl]n{[{퀭}ɻ+31tlӡ\0lU}6jE-LlKlK\n\rރ܄}}?Q(n-)}~GacGJؑ籣/ѿ&رs<X-v\nfc\'v&\0;P7c)a{ұ۞`b׊p\nBxn)qnKh	S]ũmDOq^8e8S8opZSqZtqQ],vG63֝ov;)=݊3M:ۧe37z3>;hw=;d>;3;.;g=w=\nw4g͸`i>y٭_˧m9&vg5qNFܩG8i=}pRpn8w%{^,3wAWU7ί?p2.f.\\%=1Ev8.Y!._يԾw lC%sp	tqI⮑Fppן qq)j޸Ժø+igqY[{rJ\Zp7V\08P!z3pHXr6$=S?㰌`.Woß#n}p8؞#>dȴ\ZG*q8DKñ8]N(1ĉu8w8HpdX.8+qJ\rSU4k**N㪵h\\*v*c4ppO[o}=Mk=;ukՄkµ}ŵρp/]jq*n:^W^y2Su9d?}}ܮ5|-z&go`+7`&;⾤p#:0ܘl7+[?nxqc7]~v73)T͆u?\'*Rqqܪp~qǸ?\ZpĎ?OqiVWkx\rx/IīU7^ë>loWكߚ}אk,k6^R\r9uܼ:)VxL^^\n~sxC<xÎho֍7f=yk7	77i7fMkxӧx3ތ׏[^[qRax+GxMx6W=?:w0;Da\'YOUO^vN`;%)!&w/{H{}1~_?AA \Z\\D7}9ǇO/kõNC\ZZEH=Hk|	|T7JS4J\r/D+⯺l_}\"U	wF	3ۗտSx,w|	K>[m\Zϩo߆\\؈]=\Z3=4ǃN,ࡵxy\nO#NxC<:\0s`0OXނ\'FIxR87<cώ7.^X<{2.x*^\"k}.|e_o3t|yy4a!4\"j_q52_v_!4\0p\'lu\\\ZY/\03|ۛq|?U\r{Go=O޽-y㇎CnE{X ~Lt?n\r\r?j,\n(O ~gDoBst	~a7OEJ	6~Y_WO<¯^UƯل9Ep6av6&k!a<ANPGB44 ZC	ZI\'݄m(;^1^SJU6`\"v$	L0\'X,= X+	>G8d3I8l&\"~\'^~D8\"j	6:	T6$y	c	#\'Ip\'u#<BQ./I-!BP!J~~ܟA}G0F@B䛻;+	W+	|B,N=#1q.ڷ*״	L!Y@HR۟R?4.!~+BΎaB؋󾃐F@L\0\0Bp\0ND\0PtӉ&h.#>VZ!I W(QeB@;@+K_W\ni2}^-ą Ȏ\"HxizAZKD(#vrEn.N;Bi?B组2urVC#9!P$Tv#rBD TO>\'uy,቉IA\0I/p3\"!0-m	WկjB,S+r2d2^DBJHW!8oF̦	#w9alw\nӄׄi<a%bG飄?>e_\'6&*c҉U+**D5D5^\ZeETߟDTg՟&j\ZKZkGguCWD]ؓCVJ˽EnLܵqqWcAsqKthz},,JFܿO4D_=\Z<%-R_zFK>#M핖{\":MtnSID&kukm}ݯ{qqo?̿!ѷx]?rݓ2I<AϚ:H<UO<oeA<_G\"^%^zM$F\\zKh\'FI\'Fm%FF W[8k:R(b6Rb:1\0141Ekʹ<)1+C3x`xk?Pm;\\bGĻNw@Dl\"DAL$B=0;DDDDd7PJDNZSDBHY wI:Drl\"vH%6D&\"5n9z,C(#\nD/kQr*(:Gfeݝ$ޓ!wI$>숏\nĊebw⑔XQLܖADvkk:b%AH\Z\'>׽N|Al6] [QNjkMvb=-b7Mb\Z{:&[{ ~%~zط#经Wؿ2JlA0M%G]ǧ	ɀJqpsqLUiF;؈%%F!K[fKv=ĥgĥz2ΘNCD\\\"?FR8CRX\')jPIHJדG$m8Lp@xk*ixIUIR;H\'\"mY!34|I%j(.6dB28$$$$$c5*i	iw$$d SH5$3{l!Q~$$Oųaҁ9pGա\'#*Q;\0($kzdt,\\dL$+\"/N:B@:y}tr8>)8:Hr.\\$7m	ɝ |>|HA$ɋx֟E\n!#&]HubHa]HHKqRd3)<))BtՔFz̝0<FJMJF~D^I\"t*)y[)U?\" tSpt/)o0)/twP:	x=	D&ߺ Hp\Z		AVDpUHs$R|D!jwE$fHDb) qI0@*I2$xCzM*\0\n]HEIH%AR)2lg\r<WHT>E\"U/I{>HKD\'\ZpCnL\ryH#餮xRYқ7\rHoWHoOe4%In\'}#}K$%͑ko><&\rl@ܯd$@6ia4$\r[FcHc\\Ict׺VQ3My~釧	i~GiiJZEZA@CM7NNV^7!\Z&RDd5Odd&7ɺO;(dN2Y!ܦLϓl&.\"n&D:@pdTyw-UYmB6oMxE>R%K><M>f V \"p옂 1K>@>EAv!4Ȟd3~7_\0%rur*94|@-B&r	6w~<\"_I%Whc7GcU/5xor|EN,LN%_\'7+}H9c!@#r zDΎ%j4Αzf{FPMTMdc2u2m8䔐Md̉d\\#K&yP2\r$O&E}d%2CT2\\) \\d6&@_d~%2L$6dI^,y,$Kdٛcdތ|%r.	9ș\\p\\bG.\'Ʌ*JrI\\G~\\H\0+{UrMru		epL6ry_\ZKrK-6In T!<I~F~ #H~m3O~O~C~gM~7si<SkE\nOIN[~HM&&ד-Ƕq!\\4y<uGy(y<Z<H /Ǒ\'\0jW9{JQAQPQzQwQ/P-T)(*KcCg7(\ZM\nm(;R(;}j󔝏S(PRR(FcY>xN1M1@1?{bbe K9L9jI9jiK0XS(6^(6uikm;>VPL8h>8NZPNJ)N\ruw/)vS\\6I).&(n0}{@ʙ)>R|$S|(~S)g>R8J8%4Ȇ&ES\")KȤyJdJJ7%ffr0r5tr(%yʵ(ɐce3J:LIO܄NRrSnkRR\0(\nȦv5@l(]h7\n̓KAXSM(^O\nHbT98=@R(WP()\\\n51B~B{C_0T(_(\nc5}IaoW\n\n{N=DW)7w(Qм\"$S((b\"=A:)rMʃvJ_J*p\ZI)eQRliRGy(<\n8C8hOϡT.nTQ)5&J J]\"屽;q6ʓ5J}]JyJSJ\nJy6Ji%)m\Zvw*MJG[Jnɐ򞸏ӵBY|͢|\"\\|ZPzSvFPh43(IKU<ʗ}/QLS(x[( {(\nQ)N](3)s|ZEO}W<g)ʒ*eOY\rU*D7Sҩ[T#\rnԍh-VE\'\'ߟnPU}Uj[[dԭ1_:-:/\n/S矦>Iw5UPw*ʩ;oS:Fc1{wS,S`{UvSvP-vRH<O=L0R+̩6S6v~b]\\zq\0?TG0qNdFuȦQ]AnROoP=lP=\nT)3\rgd/շ+E[\rMo{{R6P5`\Z\\8L\r?L=b@=WM-Q/msF?ArJr\ZS\Z̧lPcq\nj.}jaj;,5j:IMѦfS3OQ318j&9zZ\n5K+e\'fʩYԬY?6So=\Z>ME~QM,PrsiT(a\n3]ҨTTLe*͘_J%\ZdU\r*9vJ!pT S*g;K#\\\r8u\nYRO\"hUT@;P;ԩ?Q]7.RAEFŻ*%C,\"5ZYIO;Gַ>LmVS-P3$jsyR1\"ҞOmS/R;PNKdSjgj\0킦3料{FgFVO0~~Qw;Q//h[+7u[D$Q4SlI1IFm=@]1.&|f.RYGxԕoCu4E$M)RHS]o?FPNPOX\rMЗVOغ@ӌʧi4;iZl]v`ccMLM	mm\rm<fhD3?O3iIy*7ia^OWii!H,նc4S4+*f/Uff=Hov4}h\'Ni\'ݣ9М4{4Q/͵1Siôӑi_inʭ4w(}Q=<o@;{8Nh!1ZZ\Zy$BڅLOڅCkiC9Zx(-Bk|uLŭizwiIҒܬiIO\'\0ڵMkOhެޢ^J@Ci,DZv-[vvJݑJ\\GP]@/hX\ZH!74\Z2CC92h5\Z\r\\\Z|7pRF-ш4;IX~q-hX&\\!$f4F!MVF+\ngieᴇiljiU+*VS85OkL5l51h-UbZk-əN9C{i,N{Xu,ou^^I{})F;f8dC\\}}iJ!g(md66Vz6}$6^IA@Ѿ\rU4<6KTJhhs\n\'h%ݴET⟴Ki/V^-uVikWhk] L.}=	}C6}ß(g,}kq̀BtH ѷoWNR;\r=FDSqU}{}~-Eg~04ݒF:n n#nJ;nWK?XNO3\'w\'<tWO9E;ϑZI?{[Wq՜~6)hF񏢇$NCFC/_T_8B8O;M/]Gd//eӯh>_	_9WO5=J=Ezu=r[L]MO{NOo3)I=5=D\",&6=F-fqeMmI=W@ޣ&!WЕ:GDޢcIt.N<NϦ6SCi\ntfOgoF9* ḶN_t{+]{]TNrK2/E\\-~_~|~?˛u\"\nX=^H/Sdzn%zU?z]%)k)ETWzˮV=mzn=!j9gGk/F6rp?ypzFSSϥX?}\0E[	G#@/cfgWu>	;h3GA	}S4}΍II[n/C鿻{KOїCU+pʃNX}*렯~룯2@ §\'clu\0CyГ2ؔ8P`Ufώk`ehbh\\`h734;Km2to3vL]`走;;c\0\"%0wE_T9Za`88 f8d84̰܄fXV噌JG	%)k\"l3bvO3*&1qrTthp^g2df~p~D$sxU,bx{2|.gd00F/jqa5^ʸtÈG3.gdDYaDj2b2bw2bsD8F;cƵT\\F8#~F+o0ngdOO\"#7#yqr\nf?Eܯ{}˙e$iF9Ƞ`{3ytc`g0fp\\@c;KeG3C!dHܡ5S-Ƹlx:v`h#QQFR7zQ}Ȩx˨!uU3uHFFCF}4k\ZqhR.f4y[/hVƌ|F5s1uLFf-Ggtw20$3fY21z@?͌FWFVGSA;`111Rfa|;v#ac\"ȘX+caL10,Θa3->0c0SsBKNսunZywXRw>Pfnf*+h0U<r*c]3	L\rD&xht#SH2sgA\ns+{ӠMif\Z1\rG&FXؗsLS,Ӭњ?I3blL\r0?\09*iim<6<fXtqt<5t9tӝ)bqby_b0cWf]٢9czy7ɼhy1%vjZ~q֙y3%bOD233Mg3ʼ~;|OBWc<i`$f|>3so3s3kMf~ha10#qLF?l>0!ۨL[&f	dh\nGbbMԘL>0wI:$]D1I_7yLVB\n}	}ferۇܑ5&(?Te?WbtoSEcWg|P|5a~3X2O1K]bìl`V~D0J\'͘0C1:e60j=ϗ2s/3[μ`(1ۃݙ{|hf &&s̞4CGmgf/Og~fl|pb<`121:3f#_60b&Xs\ZaΙ1n1n1Q/똋Oo柭??Qe̿*+Y7&YJXHXN76\\b)Ϟf)/`m}tIT`mZ;R.eLV6gm^bm0`>eԔ,5,4K\rcuͰ4#4/YY,K,]^J,C62fb32b<ڻڷ6씜!|њe:Cu  ԁu됛uxe`Y1:XGXG*-YG\rlTX6=,1\\m#-;e븎)6	8։rz@Lf\\ߡY39.,/.6f(^D) sVЁ\nVp+S::u:?oȺ̃ue\n<̊|t}̊\rs`]\rźژĊxHfYoY7\'lY$V˗;5,5_lB1XI6	󚅫=aw(Ype1Όňta1XqG]eYe?YfKɒIa̰݃c?t_@YX+u\"[\"b*c9*\r**YamY,Yo*.C6cV\rϔU#ǲjFǅYO:YOX\r+DVFEV6eVSP)^zzVc5j?jm}jeuqYXL;XkaWYRXKY>[zY}s}k\Z <O|\Z\"ud)k85g<\"f}{Yo8k!ɉymc-aK%llEk[)[-{Bri:{\"{c\"ˌi\0{[u՘`SyΞ+[sՄ`nb:Uu\r?w2|;lOoٻu{ئmlSmm6g){el˝f1Y&	m>,eob7>Cvb>UbvI},A$}̜yd/,d{{Hi!loI>G\'cMbe]Rv%v\0f싾0#;uȌn6vT[!;&1ESv\n;FEΎwlf\'	b\'䩰r,٩G;٩z\roi77:~3K:zd-$;1Nؽt]m\"x \rf)lH\r5bC6:m1bcMlb8cٔllںlڶh6ftILClN0GaZ|%6v-a:	lٛP<?jΏఋcEJk3v1\"]b].ߩ~xن(O]%bWgW/alakg~9~~Y~B_ֹϨ+gkSB$mՌݮ\"``w屻o\Zo}ag.f؟7C\r1؋책,wT\Z{n>+T{ĂP*gٴz+{m^QX.(n(欷l\\ljTlv^l~QQQsGVqwq4~hjqeޜ9q8,G9c(>1,NqGpoϟ9\\@΁+CC$C\ra\nSÏ9Vͽ#8Gr:er==Ǳ;ʱq%G+(%Uq}Pp|^ɯp9۹8		\\s`s3RN	\'lb)a8ŉnDJ\r98ͼ8Qm(\'\nse9MYDpb9~9	$뗜T9a΍9GNmeC[?99*o89wrpqiq\0#9eY8[`\'W&o8D!q˶C	琕80z9Cpn;{%\n;XnQG|0G̥r${gsip\n8EcufRNq}N62sS S>h5c5֍S©;3ϩ<yay\Z<4fp\Z[9s\ZGwp)8;[9/KI-+]Mn(sه:yk*\0Pi<gl8	1@x?m gBÔ3i#8?G#l17sY9+g9+[9+C8.m\\\\\\}z\r\\ek5fQWS\"W3պ&j:a\\]wǦ!۸\\CBp5\ny5\'35I5ݐ/yo9wqy2\"̉{G%Q.uA&m^=\'!d3aX=yztҵ:f=s݆npI\\]+멠܎zp6=z3>bY]ܳS\\u[Y;Mnx+7\'n8n0l{\r5r^p{Ͻ ^{q7\r6r/}\\Fs4?pYnwu!7%ܒz{e7]|{G!7ĽFsau\\X5../sQ	\\bdKI\\J~.|KKqq\\De¹,\ZPD㊣qŠT+]J3rqާesܢn1[\nRsn|ϭ&q+ls+rvNs>>|}\ZgmmYmqz6xs+ϵprͧ/,r_/q[q/vq;4r;&np;wp_o]ݵ6ha~RD9۫rws[-` n;;6)~tp&_#FhzX2;`;yN;;r;p;	Yǝ].^..7r.iUŤqWw;xjxyJ{ZyJ(u<emO%#oHz5W){KmK@<]1~*O@~IyFI3uW7*vmX}vQy̝FyC<?x0_:Ϣw;Y?Y)ClBx.<ǼC:vxҭ&y1<b0C=yx>v|<9pxAuyA5일4/\\.E|<XbzfyWսyqyfxIVxI${޵y׿]_%KbxiJq4e/ލ\nͼ)/[n>e9y9x9rFyy_\0(ZSyண<4Ϝy򖇵ua[x`-i#syC{yL6ȣL1nW:c[<>)qy{<~\'8{\'jIͶ{yvyx{W^o:ƻfWuW8+HHJ\r/t*F-x,y9%$pWW}i=&^駼쳼S8 nƫO=%\rxOWO\Zx\r:2y,yo%5f4{u̔љTVu:u:;x]w7>9&ཉ){+{]&\\YOOO`oX=qc__lϩ;ռT,t7W})VҔo޿\0޿cyUx5S[9!oW8WXYWqo\'UmY|ռZ*0v]Ր5ҙ\nq,i*k)-?__,u;;ڶ3)|TGAg-;vKő.˷ w8?pE1X\ngo	^a^i/~\n5߆ZRwwKMua|vLf\rLV=K_ޟh}M;!:W\Zr§0kIfKiQ@??Ɓy˂m+2	j4ލʏ+\'-	q0o~J~j`%?e;?}=?#h3Oo%gog_~~|%PX=nf>22Y,%T>\\y^G+||ppOXvtA|n>ϧ2~/>qg:r>s)\n4>;ϛw8w%O%W%=o{~}nHA3_m/4vAEEKr~p$_~u_1ïͯ3?L?|+&,ܺZ%6߮xnv~X6͟>;tͫ/oj;=]3>U~F}#5/;/5XC:?TZ?^?q?_\\_x{{ i6%4_:_MռN[9 P:C4h(ؠ<)ظFV\"P{FlU>M@}q`zeL}[OR)I`W`S`tR`-0.p&c\ZZ}cOfO)ނ}@s9CyCBc(*G`sVnZ`:+8(Hp|9Rp,pH8\n\'/bssiu[)8ۏhAΊ TtPp1\"Jj+QpdRh r%z$j^*e\nb+o\n?\nj8hAR Gz>ZZ>.HW6[	27-\r7[Y\"A,AN3$Apg n\0*\0<\0@.*`+b\"$E2 @n7\0&	`B?V@t8	+	M)V@sF	h%LC8;(`\\0`LZ&,	I IHjb l@.\n3	f\n7UA#=AAŊ򜮠EAHzF釠&CP<\n\Z\r*_\rƬ\\l+RКV%XjIQ_یfAׄ:kAϠހo`<\rj	F]##HѸ`=SM}C/tSW?~LL\nfFm߂Eb~R.Tq`R_\\*[-X94.X	jH/V+Y!G/o	7n҄?U]̅[:\ZsV)RZ)ԾS)Z*	wwʄ;	zBzpFд/wAＧpWY9Fh&4Ob	-6od#m#\n]Z{ֿ\\vmiBLSx_xt]*;=X\n=n\n=Bc׫gBBU)YaCaW &ap00gQr)<WxB0h(OsD1^yW(nxrsiY¬[.&0`v 0&TT<%T\nH!($N~5.^3;B|e!qCs,*3Bʑe!]H	Yʅ<B&[ʄB+1\'>\'n&˄35cBaeaa/,k2Na!,\'>,*|4%b*	+KJkgڣZ7ZCvXWX\'cjYº§;w/	_Z/	o:o/?Kء뚄*þapՈpXJ8E8j RcMc/˄>_Ko(Tprpe,]pᢚppCc@˧E\n,H^&Kx_QF=/SznH_Wc\nFt3D;lD7D74]dT\'NG_dZ)2[,Z,/E,%䈎]lDvj\'D\'EN#~\"#e\"RXUMK)(yyYy./|V\"8;CY碳fD5BQӢQI(x[XGtQhgхECEQAtYUQr(H*%PsEI*뺖@(yWҐ\'E7z\ZEx*{QK.QeQ6Pt6OtV W^DubSvaaiE\"l1VmA\":^\\foq~8BEqyHŊd\"\"y0Et?2OI\n@Q\nQXT(wpMrFyLT*Ul^mmJqE!Q}V4M\rыK|ыE/D-oDZ֖{\0Q68IꗡuJEϯuu$LnŉE/DD˔D#EqD\"	Vh\\A4B4uh꧑臞\\4(ͽM~b\'EkU藃h\Z+s\ZOdh&ZMQ\"V|X齷XQQ\'VqU)D5hm\rbc\"hXO>$ֿc,6xTlVl!6RB{ۻŦPbWAŇ%Ķb;^A*O,`(vN.>\Z,vQX]2Q1ϋJ/jbbcb֌뽙ػO^\"W^oā@q`^qY_884HZ_P~\'|/VGS7ė7_(%2 K4։Rŉ\rit̷,9qqAMq-2- qn8&TC|,@ŀ\'b3bÜa1qN\0QnbEe1z,Wb$JӜCĴ/f9n{y1?+9>\"|]qy^%RsH\\iWUF5ĵfwgHӝO\rlqC팸QjyOA_\'~PKz_܆_,~6whįu]:⮒_wW=iBq?xtx0U<vOHBēC(}x6xv*&i~Gd$\'z9yW؂}WMxKK\r	վY:gK=OCqDiDDvmH6/Q7;(QΖl3-d\"Ȱh`1zD)ѿ\",5^!1K$-%{4Ht{\'ٿ:*1>!1Ϻ&9\\xYb\'Gb%o鮒K&J>J>HW %7$\"$Γ6SSH\\$.U=u&kRB&a)uǧIvJ-%!\Z%!ɒsW$O`%QE[$IN ®DK`pQɵ>d	IԆI\Z(IkFI2%BIfF} U%~![\"C2PO 3U܍?#N;(`%	d	L&^3t%GF	Z#C͓z	nK%BEȦIc%!@3#%ˎ΃nCbT\"\Z9,\r$r+{	ț7JP܋R\0%	IgII\"IiAcGG)	=$Œ3T\rI5JR{%MR\'it(4Jz2$4IIJ%=F{Nқh#;\"7[`$Œπ>@dt/՗LH|/H&H$?l:%?JJ|LCH$3=YZdwɢdX8!ɥJ6$+N7$=REmR@_bT~tt}6}<OTC%gY\\e]eWn&ՄJRRmR?=RJt{tg.eT#m|Oj#m$c.ݣ.5y\'\'Jͤm҃~CZR+R+Զ_(JjR\'SS?8IOOzzI=1R.Gԧa@zMs4$4D*=tG\Zz\"\r+	^uFlM^)NIcJcRPҸai|Id,Mn\'M[Jo`¤\rҌbM;Ҭ[<7iN4V4[Bz;+%͛dHBJaOiRTD{\"~פ#RSJ>W(4RmHiVRg!h2<LV)rF\"IR;C*W\"GQ4ztEZIZj\'-m)I˝]ޮH\rzH+N8K55Q[ڙۏJ1Kk9k鳇2鳶#s|PDzPC~,m\nDJ/Ϟ ڷK;J;<{N/xNݥ;wYA;ԍ=48I{Ic_[ҡᇯ>)ұ	{I:s,46kHgWsKҟ{:JHTHW=JWkӥke\nXjLxllGťT~KNy)S_x\"\\-i\rɴ*dZWA2-L[sA*)m!5ȗ.ӯNɌ5eƨ\\IWk};5do,,ŲR=١{dV22+zlj!;%Yl`eǲ@=2ͳ2pgO6wN̝ܕy	y\r|m4d|-#o9[)],W_,P\rd!G3e^Bd烃ea[DlE̗E._Ȣe3e1s;d12,,N/%$eIe1dp,_,Bˑ<Z\'K\r&\ndT_\rDF,9YvK\rQyxUQ>Аz\Z]IأPG`2|UM*2\\Mh$#&fH2My9*\09%1:dk&PƎ e*]L$|Ȥ%s{hٽk6\n~\nϞ9$Ȋ>esG @V\rOX;dreO\ZeƠLYcC3y㻬G,k]A,{I^ܕuh%{gsXnAa٧{C?Ybv祟lh\'S.l{l]ǽ岟e;d7iȖO8\n}rrrO}\rr]@Jb|s&*\\\\\\c]\\㰓\\+LȵZ9	rm#\\|\\\\tC\\X\\Ԉ\\U@mTn \'7h.7\n*~P>NJTDnj*7B}wͿNI8mY\'?4Jn#?)?b$?zUn1厼2`6sr\'L>F\"wiV\"!r7g{:v\\W	rwyyP:B^W/X-K,cqd%y:Vy[*f@*G#\'<ϲ׋ȓix\rI<@1]~S9@~T<%yNoy]I~{K~yn<q94ړ\'G?#G#9r̶Krl۲N39^+\'$?9#˩.UrZ g09g*y9rsEC\\&U~|?ZRG~=%F++\\MU9ٻBpM^]x	O^? o|?{,vPUyy;JA$ZRb$EC;Vʻ\"]W33w\nw&Y<I^ܐ@y쨼I>.h*ȇ2ɇ1QX\\UE>\'1\\\\pQ\0)#IeF(JJMJf*Ɉ*)Hx>|ss;܈j9s::sǯqw֝v8#}sVsڵ?o:Ot.k	z\0U\0E\0\\>@@Sue1Xm\\lDll>|D	،90Rg|Q\0# `Kf`K[&`{*`I]\0\0+SK5y	`]\0\ZM\0?bpؿp8 0pQ\0pK=	Ydxxi\Z\0^3q-\'V	xC1\0t4~EBZ	8}pJ?p^2 HU	NqK\0Dݲ}ΆǾ\0\\\0b-@d >\0 O#.QV\Z \n\"H\0$:$F?\0$$H=s\r\n=H|pg@pa7&mp\0Tn\0](ȹ\0((y(\Zz\r(ax\09]ܿp_zPT\0TU1l@՟x@mC/\n!\\h\rhtfM$\04݀,[@Wu\0P\n\0@Y\07\0@Zc@\0j3\0\0,\0\r H\n\0]\0=x\r\0w\0wE=\0=䰫\0E.r@ix\07\08@wg&P\r`d*`o `|\0030ud`\0L\0(`)m<`fY\0\0~*\0,D,\0K%|dPPuh?P6T\0U\\C\0:o:F@w!^7\07@C@7W+ǁ;\0wwG\0Z\0--{T6o3жp_*СoQ	t\\.\rwCx7˗X]_ǳ@ϭAǮZ}@h	@T\r\Z>>)J_\0þ<_O􀧧\0X|\0F/^8S y]GBlq;Nxb`|xnURtC`bW`\",\0\nLӯaPS`:\nxO`g`~` ~`CS;/	`ap)y#G#g2X%!XYX}oq5E`mz`<Xw3I\0󁭫?[-[ag/v@q\nbwY\0\0	#@b>H\0R&\nT  c\'Z@EZ,:P.^vK\0{!ۙowL0,yhP\ZQE|Ty<8n\r,\'.NUdل??R?_٣ooԍ~{2r	zH^V<ԅ \r7a@k@hAB@\ZfaoQiOh#\"hBd;;	vR֓o\r^b1~`@{?li,MA鍠R?e&\0Y]\0:2\Zrp w+Ǚu X|Aڪ  >yT\nr)ԀB.BσB^m}*ERZAg9XйG29>tj=1t/ /(\0t),tt\rt_jPrP9(\r	Je2\\@YOrBA)-7\'<F(N]P,\n*RAϠEGA{AQA}CAoՄ^^ŀj@uPNPyԨ]j>AsU@YA͟@-\ZAm(yWn@8;bJ@  _ATlBAȭ@A&V&etqD7k(`D{Al V4	jqox@gM I=Hh\0@E:ԽFԷu7P#YPE_1\ZZ\Z $A5ADS ˠ\Z@Q<h;$з:4Cw\'j#(]\\hA\r-TK>\0\nS_v6Xe\rVm<^v=X8+nm9X\r^61&olxu\0V`b]/=ւmo=}(l?| |!|@vhs	>d=jGs^~>~5m&ă>!o~%\'H s)8(2[8B8\"e;pT 8z8$8>~RD3	p)p	8er8}3pŋt[p:9	?g#Y/΀P,v͇[l8;-8\':8Y	}1]\0v{G	Jipk}pup;pm0\\w[\0dnH7OU悛RހXহV7Zf/fpkfcy: p[0k`N?0\"Dg/h0Ư/S}`ZR	B)]`0n;IOU`~X(<\r\r4tX,mw]IwU\0w:;؀IPz_oq#O(C4<m/L\rg^J3x\0=<{kW}d1_??bxY\nx)hAVn@V!jq~#/ !Zwa:Sk\r*!9\Zd> \0b(\'BLK \rSZL٣)ȖG\"Ȗ~E<6dK+2sFŐw!vٶ} 88.@3m .SqM)@\\vQG*vĳ9\nB>BxN;Rv9oC@Ai\\șo ɐ\"Hdf$_%wHlO%$.+$>Ur#H\\Hf~\\r=i$Oy-tOHV$\0r{yHދSHm4*.\0)<5B?C*i!Ut#U	Z.3-H}IHC@	!yNT4W!/A^A& /{9$@	q\'A@!ҝe\r\Z	0eAUQ-o*k@DiG RD!ʑwޛ,Hߥs7v@Ȉ0dA2M{>t\ZdLCB&Wl Sw} _OAl%AfL@~C~ *!9}3z+wG! !ib)dEUQ@UlĔ@U<cjfPlvڧPV~Te]%g[ɃnvHn@\rC܍nyIgA\'@mAA9ݾq+t))e,vu>5\ng[t?vW7Զ[辭}B}*]GK+zZuУbGCҠtc@c-޹P.PgfP\'NAO@f@ߋ!Gy#Їao36NгK[lgzChO|\n4=\ZYaA/BzCЄ$^ռ1hB+ZZ4i[hRhr7h(h\Z~~	iAsCo;@\nJ]IhacZ즀<|-y-i[߸-r>jVVfBjF\"}hm]U=v\0	mdNA~>5>)6#Lh\r3zmm/vC;.vp%P؅Pc(*By>P\\k(7zi\0JpJ?uʈ{B9P^~(y\rTZ\\Pg\'4r*b_UAcAݕ4thN\\9_h\nm[	UBDC\'5;Zv,\0tr*25EOs՞};	\\t4ʆ.}.z]fAW-`hLu+Lu\r\n[Ӧvô?ށi\r[,~fu[os\0*<5fHmEYYaVma60ga{ҁ=`{]Ek0`v~B=N\\;)=laxaZ yD梭sᭁid\\q0ׯ07O0rؿ.q0a\'`XG8,HcRwĀ9tQ1Q;[:Ȇ0]HքTb.\naS˰+;U`avm]:.,K=6xv=sv㎆AavXǵiP]\rI!d-t\rvo=\rVvV	{V	Ui`j`j@Ay}X\ZXNӸXӇ\r綍!fe}\ZeA˪Ў\0%aiX~ Z0K1FQLa```0uv1~<	Sa01LS.߄u`}iίaa7`ZaCذ)\r467q>que8l|6\r\\~<}][7W`\0[6VpRjccfe\\I-\0|mf*\\;z\0Sl_{<,8\roZ_7M]av;a?w0WwE50{j}{\Z0=^B_gM	pWpYSo&pP/܅\n\"m\rwo=epֵcwޫ0V_\'|OjOyz8Tx@a<zX]	z\nt`/?0fp\0~-\r~p<p~,B/xf<&s/<<>^~	>\nO_snSF4Swxd<C-<cIxF=<9<c~%)pg9X+nHuOw俅!H+:Rx=x-C=kUx٭Gc0Ax/{xmAx]E=A77~4xSW	*xKD3a\n޶^\Z)5rp{p)O#4;pNHÉkp=N3RYpk]\'s#p~Y8_.EGb\\bzeN&pb/\\+XKpe;8:\0ޟoDE\0|	A?u:GkO?=3rm\rǆ[	>//*/)q\rUF9y܃W0wS=߿\nK5B1t	Ch}<@t@u{X{RI\Zb0\0\"Ly3LIya\rcj%{aY@XŀVk,7!®]a7t$&bf002\nѱ8qh	b8\\p9pa#\\=nwaQ1?Bxp#G#\Z: _\\A!M	7\"@!9!¡[#\"v\"VT Bb1DWDFD|+\rpuv	q-z)\"Qu\nqm8t\n\"5hZփnhDdu\"n&W##ehDξ\ZDSDYMD>DVD!Dq\ndFDE}YU(؂(DTD#*=BT;vnB<@ L#U~CG<!j<Oe!*B<	vuG!bxx9uѮ6h\":|Ct0^#^MZ#\\#fBiCeG2#`5 GP\"U~B|Dk]m+E(XߠX#10l!<u#\'BF(G]NTw7w:,A\"C={fbp!\n:1:IGLCLJ_Ի _\"~E\"~\r\r fas4}?x ~O![+F#;R#u\\	1\Zw\ZG)A\ZpH#ertsru\n&roOvw\0i?A;G߾_ #H<K-W#=<><WG@_.Ez+>(ȓ۽\'ۢCd\">\Z&y+dydy@ƥq7ceK6+3ȫ-=kdҹ$d;2\n3B13+37WY\n?dgdߡ̯?o9,x,4B]9,vG KAӽ1{|YiR||E֩ \ry)yg59}ܚl]\ZBAۏlCC\"_\"{JHp^RBB(\"$4&\0	C#*NHO$*EbrL)$Id|dAm>Hv8h	)<\0 3܇Hi.~#|HBvy \nΑ1rDsoA\0 G?SI七rM䄧DANE\"EN\"gs?\r?_1Ş%ߝ1(K\rUjP<QjA1(uqNHWCiBiPkً(3F(GP/CZ?CmȯCBm428MGme|x58ezj!ԖI(}mž̿]/PQ2CͻXԞu}}ޣ(GP\0HI=H;d-roGy3QP(\'Q\'&QD{+P6GP!*<\'>?:Ey:S	u|\ryu/}\ru\r;P=V.wPWMPWŨkڣT\ZA\ru*u2fd$v?T-T>2*މUtoU*_A.ʷOP}ePZ1kP!Jv	:2U@=n.Dl@GմjKj~zH)pW$jjԼza)\nt`lqTnjZP-[PmRTu![Bʾܴ@GQ {Z:P\0R\r6mCBPxQ>\n! D(K1E@QgףPgpsE0\0>E,>O\\P\n\'p~%:%@d\\@)6(%؇<Du{QM>\Z&$_5V\ZPB\rnA\r&PYwHwQQcsQP:ϕ|a j\ZWA}rQTP7fP♨_	4Ԭ6u\'(	t.n/jZ%^BZ%Wqhu.Z{hM5kk_Ak|F@뿽Bo:R,kߢ=&:i=AڬP	|m36/G[L%Do}&#(z]?=J9zogz/:zm-poh_hx5a5ڻh5#\05+d 蠏&G{=Ġ}h?TpI\'\"Tv8X#:p$CFaЧ5ѧ#\n7BG3C_pDF\'B\'Ġ4nC_i\ZA_ѧIQۅDtZNt:GgFg^o@چ@gcй|t3;mbt$(L]T\ZW&@Oy*6t\0(]]B?-G?>YLGן)E?QA?1C? AF8n_-|GQhU4\rFj8h4\r4=@4иhM\ZCoCSo4y/{_\0тB(Z?33\n-9كm*D+X{P-.Dw=z}ot!0#Ϗ?c1ON\ri5zJ=SzD֋F8A\\A\ZBϢ||suNEE+փ0/̪cZg`DczcfM~ִ\r]~Y)#c֟	1l\nlYٔYfsn0U77f`<1\Zc\Z{UP4X&\\X?`b1V\\ fE1*ϳ\Z}90fqP881R1g4mi5̑Eq-ղ~H9jd9V97\Zsos㣛񱹏M<]00͘ɘLLx^L8-&&b>&&yl\0B&F[c[((\\S?I:|,Ĥham11U170z{07o217cbwb\nL!m)S܇ĔaJ1e10e0ṼvLO*%\ny&c-_<>k1,cj4ڇiby4ļv`9]\'N;yxD\05D;rz@CL10n59AycP^T,	߅A&l܊bp9ܐ`Cl_`1-NAO{0;;kyM+I8f83a7#=؀BLDc]0S=N\n@ufY9YۃYn\'`7w0+	USOܰ\ZxqvͱCص}&X#X\rXOMlkA5.:55Eb^csc]X&N]zVKֻ։NXdd-#[o?=`8=贄=x:`m3yX:31օz_\rӾ={,\"9:֧=ƞƞ2Ǟw-b`C◱-0\Z6,\rôc8&b#l%s8s$l	b-^^JMH3^9Jr^XMmMM.M{폽\Zі1pYcsKmzmUl^nl1[-j-a`/at>cͰyll9P*>(}~[i!V%?>5W_!ϳ-̻ؖV|lke<eKKNc,@ohtzcbRPXXf,~]Ewa/˰XKH%cX0\"~t\r,~5m5jf,	+>c	_RM\ZV)+ₕ걊hQU6*;خ9lwlwc\'g~w1v$0&015sؑv\nF=Q5؉_دt*?+sӳVE5o4u쿇b!\nR9SڂS}[e3Sli|Jŭy=[{-NX[g[[OH(H5ٸs8qN`qg+DEۢۊ㶒_Qmvcqqo%8oWq	wqb/\rs8nn_>q)i;w!i:^.[8}q|/|8eop\\.\\\0*\">	q=wqwvB;2paz@i3,\\Ԧ\\t@\'|P|dŭn]v][Klv]lKNK%K؎Kx^Kލ~`.2Y	w7Gj\nኍJ&pe;\n\\Ŗ6܃T܃SpV*O㪴}q5V걽\'m\\ca752qop-0\\ˮ\\^7\\^\\Q\\d\ZmupRpR(Hd pP8,b!?Ca(Qq8QcZPp̔Fs1[±6pN8K=N,](<qn!n+\\w3\\d\r(__½=t<=kdqv8n|}r&}g>Mo\\}2TG~G~F~Y~\nf-f/Upp&c}˸Ň?p+p>x2^ejs\n6װkNkk.66 Z00,M!~S#t( Oo7c4Ûnۈ*D{F3;4T;e]_5CV\n\nކߓ5;TU;X]t|.Γn#x?xjxIGx8Nb]AF-= )|-|<|]|%|->e	\ragX|<f>e|\n(bN|N>5 	?\Z	+)˧X|_eL\\ɇQG|Ets:\rWw\'EQM|iB}z||Y|Վ/*\n|k&\nW	~k3u^Q:o72yjOKO ֗mc^	3<*maaxD#ڶQcxt4\'\rOjWǓlSUxP</Ow|-xJ7YgP9vx^ي,N~x)x[^2N{vr==c%^p1>w|--k\Zw\'{?#b\'݃Yϝ/\'S.o]-OϖQu?}?Pp\Z }_s]_OPybJP}\ZBP3t\'+a-skl	ڟ?֝8AX!aC=DB3i6,A,¦@uWiњ!a1xdE12V\"ai=IO=p@pAp	ߢS?\\!fƇKJi\'[$_sp|0sf;\ZEN#؟E8u!lCݕBWNNNϼ\'pfH8@8[BBbG<ź(B)!~4p	dJFZSKKHIH}2EHYG<\ZK^O$#dV\'d\"b7&d9@~fE)8O_CL\'1A\nw&KxBɥRB-6?9BKBٮBY:D!T,~$<8PjBxt$8>P5KDw\"<{J\"((\'ڷ.:	τWv\0Q(&o	C	#@>d?-_<\'SMsj=E`%k	쇚 gGC!K ~%H	2OBۄn+s!zO&zS>L~%HM%{JDFV/	}	I<&|\nR\'|\"\'&Sw	S̭Wi_фwR\n	\rބ ¢__Kiz؄߄)kAU%ǉkk_Dpvc\rq^=hqT\nQ7{~TN4Hb\rV7\rx\ZoƞDs;1\ZqSsD<9{hjJS!xo#&-_O&#vD&ODD3W~K%:$:WΓnnzD6z[]J[}qSI\0w\0ZbX%1܋N l!#^#F}\'FAc1ċ$++k%bm:1$<Gî3iě/]pω9Ĝ?\\>mͿ{ĂkĻvFbR6bivD67)CUć6G:b]6bG\'͡z$\'Ӑ+gg\ngMM&pb[bb</Z#/{҈.ED2\"B	Pk\"F\"<AMk񷴈DoD2p7΂fMd1̃7L.\"3\"wҼBdA	DVn\"gۯIEXo\rD=(&]^b7==MȉX[s7;gwAD⻤Z;(q\\BG|__OL@D!yf#q̧8Nzu8MLY@@9MK&$l%o\".$.J3<H\\<VG\\dnI[F۲G\ZoMrœTHj\Z$W9$u$\'$>)I?i]Hf 3H:I_%m0.\"mH?<H6&!m6HOHBGQdbgO2%>@2!E&m${Yï,ntv?H4#Y!Yх$k{$^q*q P\0tE:@r&l>Fr1#yT<@kI>}H>E$\"lk߁-$S֓NZ΃IvRp/Rhx\n)ę3@\nCNϑ\"6:\"\"HgI΃_.KI1GϓbI`Rt\')A:)DJ(DJ #]!]]CJJ!]{FJʙ%eD23\rIYHY<I*Hَ\nRD\n)EUIK*R#DJJ;E*8C8TقT#U-jTISI\r-ƷIO[H<ҋo2RhfKjEj`Nj7DjGjۓ:O:Ɛ:^i^\'u6>\'u!LHV%	>	|Og gI{	{$#!$u7*.M%ϷOHxLj (\'~zƖ$r\rqYHb]8WI7&$@,IoHf$I/I\\q$E	I!BR^0$)$mRINMY#\rړص0O`1Gҧ\nҗi۾4HH7I?\"K+<C@OZXMZ\'-@ǝ|0&t+ȫɫW&EÞտY5N54ZOZgk\0:f~dV\ryȺt-d/yS ٨ōlD⒍&!&dS^\0:YV<\nyf8cvG\"sȖ.-V9!lMBU@6w{ad[\rn*-l!#י%癐EA䃇ޓ^\";t&;*GJדΒ݆u7CGG9NdߚVx)rh59Mr\"eO:y9ԥvp|:Ї|Ziz	쉵.!_(c^ɗX+䫥tKkUɷ~+ޓSȩflrzr+9W>Ň|*|Q79j/9K!g_#g>oKw󨜜@έ}A;NΣ=$߽jC.,&V-\"ryrWJ.N.ݭG.\rAo{\\:E._N./X!?\0= ?1!W!W{Ձ5^kDD~Z2K~&R#7 /|[uȭgmWmm]vCr:y4ؖ@\\$CD2d@10hHVqo;2q=TD&#^)&82&3xdv;25YE,<,,\"cbdYrYz3,V!Z䮱Jr)H&fߑJC~EQ,g׻//Cɝs{`\n3??6m\"\\l!~B<DE^ZN^zxwQAQQ9LYaKQۀhhdR4ߡh҉5R2e͏#-ZԞNC1ḥ@R\"(S6CR6c)gR|oL0)u)(g3!e[mn/#OŲ\nFAvXWGPlRlД}z(n(aG(f(G)A)$ʡ/) 0HgJ)ŭ4;E:M9r%Gӣ,P0J?O)aM3ȓR)Q.88F%!N0rYcrO r\'rhJU7klUJb(%HIRR>QP*P87JYJƓ\0JvJo\'%)LꜦ䅒(yT)w>q)c7Q>F;H){L)2Рx(m](QAJk5Z6|X/I닠)\r[)O;)])M&fJ$\\<iJ&ҢSAy!0(/(/(uYp LM@S )}~%k}P0Ng)L@R%)\na;BJ!kfP[7Ph-\n{\r͟Mp7Rx({Q`0Et\"m?IDyR=0J6J70Oy]A8~2DPfSލ(#g)#7)9PF|YlJ_u21bKLLuާL(v8ZwcMuٔ,1cBJU=R1eJYRAU?IljNRVZ}0Zs	U;Õ3a;UU\nUU?τj!j\0B5Xjn^mF5\"QRMf-}抷T/۶P]]KtjGLΥZPQm=%Խ-v+T{\Z=՞EI=xz)zpz(e$JuCnT.ST1z&QR/PP}2iTa{:z=S+U>LjTzcujiCj4DSc~S/n\\GI/ХW|/	zSpjҟcO$jz}{jft3[nPswCBy~ԼK|EIj\0z$ncj	dZ˔Z,-jZ6Z~ɄZH}pݓCÐ*U*gjּ\r9Ā|ڢ-|Q;7NQ!FUTI*\nK\"T_*Jd|{N*5J,qaT1JD8PҺTjʦPn[~OAR_îRߤRUSQfQ?l+~L~OJ6WX5:KNRo(o*7	JuBuR:ul{@S1~VzPISix=i\ny̥i.ii&Ѵiiiva4ӴMi!(!&f\ZCʏJ7ӶhShAc4(k3VLm3_h;}v,,hJDͪ<\nSAL#JU}K]zL+Fw{Jvv\\JsB{ќi.ڑ4S4W$[=2=>^^KcӼ^Wz||ۏ\"h\r JZ0h=-X|vHv>iEw\"9Ly[Zk*-49-Q Bھ\rkcdZ,-)LKBKMɢҫ/Ю_ݠiY#$9[c< ڝHZ!TVF`@+7Ch,CZE\Zڃ5{h5*-fh5=\Z0%ZY5=EZӪ/#ڴὴ|ZsPN{abUPA{aRC{EqjoO@EWh1\ZA\Z:OyC@\ZONup4rn\Z?zF6%L\Z#J?\rјJ\Zt­/Ɖqh\\qJk4E4EY\Z=5Lʦu7mu/zki}޴>k>o/Ox5C\r޺A{XE{\'\'ӆL{håN,j6CӦ̹o{Xo9i?^ͼ$f\riYI>\'7C+]C[I<,9WIu:隃k@t7:v/QD	\r=麱t;=7&Ls\\;s=醙[э9tYC\nH!K1IK[K\0mk}Mϸ218}t{l.qÄ\Zݱm~HHw2_;=}K?QB?cݕ3IwWGw{{[=ѽ^N}jEt?0DS=7NCadzez.=\rL-==b=ːSA?kHLXɦA9ONh><\ZEOJKO*\rlg\'=voޣ߂o1~aـ;Oۼ<x=\rN\'zAm84}z]za3\'D/zR\0MzŜjGZC~Hl׽(׽d9z?ƝgӟI&GzS*	VFoҟ=?~Jon7z[?[V=/8w4֟#*f;h3I@ot7QtDƌСB0:nEi	Utf:{:ʏKD|c*:%G`ttx:iG>fBiЙLJEg9tW:MB}Attqg.9r.KSte4 6G_G\r#?:.ݓ/>w/}CwwohLs?뉒>>S>_Fo=OK/so+WCUdcSz\\C=\ZCCpC6CX36\0qbelL^bl~`gk2B=\nÐ0=̰8:zT40\"M	Zɰ>dɰ3~d0삅OYuAÂ-#OEC_ka}uqcãiqtg2CXXq#+\\2N\'!S5wFjFOFF*dd3\"\"0\"^((qnGƹݏ1곌ح=-qVKT	m]FFx #a(B2n|b*qfm~e/3a<g /1JK71q:2@!BQ1Ȩ$3jnf 3\'u\rMͺ6/Wmƫ{\0l^lÀob@ޘ0+VD60pSbN1\'ގAoeПe0FZ3і!b2DW2$O30ay.!P4]EnH8GSӛx9fO%:c$1Hg}x1{1὚n+`|:̘ڜV̘10wW;a߀4|l\n\\faRg%1Qw̫?$1\rOz1v2[KL3Nys[Yȴl1JW6w{&62_fy8tjtA.K#LזL7\Z{%7:iLo\'\rG!yg\0f0=<{yҊ7iea2&z[A-$f\ry4fͼPf^[n3=e^}yLve&IQY>17f3B;3Ây3\"|gʼ5tdfOlc0o00M;qf̂Xfax 5Y4c`1K_~ffI1	̊WGϘ^՘,\'g-̦[矮2k/F2י{_2+O02_nb:0LL)	?<D_c왤LR3Ȥ~d=f3ُN1[\"LQ]_)^eJƘLY.SS^?캬J)avG0{!׵_oRtcwXpss%2?\Z3tWcṈ̉!Kp(K&>s,9Ng~EeNGBߏ0g3O0`=̅u̅Z/&_r<s%|2ZUmZ6:OZdb4XU,M)֚XkXkDu֗Y_t6toa(fi6q%,͇,,8=,.֖d<B-5k\"v[\rGN4k,UZ4ˊͲymړβȲVXv9}kXXLW`9ZYNo6d9sY.)X.MB*ֱjoh˷8dNN<:/+)\nhf&BڔЦ+PI+L&dvcE$\"`YsYы.LfńY1uXqGYW.}e%\ZU7JHfXilVzGV:Ǖu<Q̺q+3Wzy&5ĺuFu+n\01%\\IV%v<+^UȺsU*\\~*zi*w4u*Wc?*ob=/d=ȼzقUIAlX[XzV[]sGXTmY\rXϷ뱞6%KKwKz*i\\c^f(X`vςnlxς`\rr8c\ZYǋ,m=eYd+yZbFAK%ܛcYKZ̒;d	,Y(%qgz[\ZaYXCXw>n5e}>cnF-XF6~	kBe}adMNB7y.;\'B֯OkQm\'SֿY+YjOw+[#ɞiYSֺIek=cku6*:MlIưv&Ԙm(a;(IlI8{˭ۧwbwwwwe[-66g6*l[2.ڗ/%ycYۑ俋}S\rۥve&fqd䖰R~*\Z\'O鸰_h\"cI;jLv:v쐵쐛NIvysg\\g2yJvĳ+v9	170;fNd^b_Koe_{g_tN2jLN]xNKe:Ǿ!agazcg99oٷ,\rt+;þe*؏>ڿ@]n(c7ܯa7<`?Mf?%<2<vD.y\r9%ƍְWv{	Zaw\\ew4awb]lH0bþSp!`c;^;^lw\n&WaC6Mk˦Yq6j\'C|p[aν`=.寊J=vݝ~\\{(>{>=\\/aOb/a?|u=i5Aʞa{Y̞uȞyŞ+>{֜Iv\"ރ4c//rTd#8|*AʹjY\ZQYu,ggm1gQj:[>g]zg4	g0ѵT~;٨h1x+S9pɧqs]8JygJgggg;g\'y^ͱX%Xñdsvqug9m%#bǑsأs80q#xXnx@98G8p6rxp5x9>Þ_i\0		l	r}__pVsp`6ND?\'I0k9gq8C9V/8nshx_w:Ur.\\:ǹt#sϖpj\05\\r9i幜97[8f;9@MsSDz19\\6sgS47)QsJfrJwsJGwqʛ_r*9ba\r^N6S%3TxraO9O=˜zS!γt/NXӢSi٢Xq^p^M8OZ9}Ϋ_N@9\00tq૗8]	dZ(3ER8^)ҘCN\Zs9%ô:s8_8\\w#u	Gԭɑr8`Lp<)⼆Mr6[qp29ΜUU+Ѭa\'X@θ#gbdfW3&LoΙ~V3Ej.s殭,P8\0G8_\\@3WUr5_s^js}In(@sr7=K\ZsM^rtsr]ǜ>*Nrq\nwwe;dk_ڈ{ǹ{+GVcøJuәzakou0YQ=r/x\'c듺{Mp T87ninX7ōFuq˸죹11a1Xs{Q?{˾r/Y^&DqR͹	w	#L6A7rg57M݁&1iܴZn:f7br3ǸTn,7k˽iWʽ6ǽ)7g--Ev#Tnc	~3[[[HVG8pߦrFU\r>܆N/͏¹ͣG-wmk;/xH\'p\\\'\\kS.(\\D.$m5»ͅB}CM\\XU+r縈>g.B3)EIs\n8 #R$$.E<KeU$.5..os.u\n?qnW+v\']\'nuМۗX}m}K¸~D !N;1ٸ;r	pxp#\rxsXW=`ܙ{]?봸˸Wq.-p-ۈNCi݊iֺ֦Pyk{֥t֍6lm8nӵK~ЇxFf<H}A3_gncʳY\Zvt\rvμγ\Z&l*x{5sxv}!<5|Tf@_.C# ;Rwsn?<<xGOe$ry^abNXHx\'2!<xqv\09/H/IBG𺵼p	tw:=\\gʋX}Ŷk.n;ʋK0Y% y	?By_]Kt5yhnݚ{yf\\6xy_N\n<yS1BS8Ȁ+ʻW\'UD*w|U\"xx5OCx5+1^o\re32vl׆x{6kck;x1{JjxIia&by&O{<bSq#ui(fOx<lG+h$h1$yLYӃǚqv%<׃<iOX*<Q9u7S={j{׏ugyxCwFFpg\\ބI;o=o*/+7#o)>\\7w~G}[U7UjWWgWW#\Zo5\'kRC;E\r+|S|7i|_5|-s[WWo[\'o\r͸η0V?֗={|ۿ_}mc|zlwv.C#M,+ẅ\ZxHx+|J\r?3?0͎Ƞӣ~RSGN/HVc_u0~|?~a#R!^~bE:?Og(>o|gzo=j.g_:6g?g9>o.rc~^{u#_jǯkk}\rWFCqƚ$?~\"eʃ߾i+#Y5!c?6>,6K#I|ԏ|ȋOk\'P	3|>9c\"t>=*gv]s&\\F>>\r\r|Qv7_|x/p/\0lW\nIu~oW@v{`0~F?1&\Zg4%1c=_֟3Ng!V]8_rjU/\"+z*&/ՙ(uEFC@˳U%z.xPN@T@h.\Zax(01*0Y	vv]z,}%,ߛ\n96l{6l؝}&\ZwN;8L	2_NIkn?<*8tN3+8Z-8EplX\r-vPnI+D:/=*8W j l fA4U\"8??!`f*͂51[	.>!ÓlAY 9Qt|W\nңMQׇ\'\Z5\rH6A[=u9]AeAp vyAi`:AセjBA񡟂ӂtw4Y $Vp?,(3u/\Z	g		-2-gAǩWSWtj\0RC\0@\'ge}Z(N	P! j~G(\nTS(`CN\n3zё*	@<i)1Htt@6,P@hś4AWeYwmc@J04CS+Fq\'/I?SVӃ7󣂹^x[x(XZw@\\zp6mjߍBFLP+Z]&9 !P&g|jBP{	N(4E	*fd-շ0)[h	wbr6{6½wv.BVB`-~|=,WxP\'t<#t\n]l\ZRkZme]£m£kl7zL}\\˅\'ۅ;\n|Ha90Aa0h*E%ݲ\"k[\'<mOYNx&bBx͊0\".Ai#?\"FFx	/c#ج0a,Xx1aEh&#L\\^ L L.L.tm۱{[Gx+k»*EW\nKm.I>vg\n*VV\'VVwrIoj@<>#<-*RዊDa]a{v l\n;P+B!<|M E~\"\nQ؍BgG!LHDI.4֓*d̇B,:#\n\0mP~L($\'BY0U(:JS2v		=.\n{xU޴^ma}o\rDدc$p8%|phQ>+A1 Z1]8?(\\%<M8f,;w	G]O8!N:N>NAOi~<\"~\"Nv	d7	pf^[pvSpJpS%\\\\,\\,/\\B^k	HDn?DٗD<BDj:f\"5rCCQiN4>45^1\r\"\'kDDD7DzM\"#\"#5I~ٹ\nֺmK-mA\"kl\Z%A?DKDE\'D4\rE!UB#r7ܝ]EoE2EEm\r6c	E5	\"\"\rXYW\":(:e\':l%\'rjDAGvREfEEΞ/N\ZE.O/fxpe(QO8)%#RDLOx%-wrUJEˢD%\n߿$Uw\"Dƿ*l=D;7ED\ZE3E5ץfwz]TIH\'z5\\:+zC,FXԴST+z\'z!ڞ6^J;E7d͟EW^-\0\"pW=L^(BEf0E\"Za\nEBzI\'qPE2;!D^#[\"aU$$EbB$!GD}\"լHGR墮(Q\'DEPE}8Gk\\z,zQ-+\ZMΕ(\Zh/\ZgS+\ZY+\Z51}G>OD_^ESD#Nff 9c_?H|ѿ}bU\n*%5+X=)@]9HxE!px^b.-h\r(f[xh 63y+6n#6Ɗ-m2;Bߊw?.*[n[[M[v7!*Ų0kAkqXScB@\0V*v\n:!vo;_pym{{ǽ*hK*\'۞-{ȫ$>_M|4K|QؿؿQzڈ!gš=/v#6ƈ#~G/<:\">4T|qDUϙ_)NXNJPtT|\\|LFrhQ\\[V\nQahq:fZ%{B|]!<\ng.>7g?+g,s(ۂ	q~De5Q\\#_ߧe⇞ʘQq%xꟉQnG\\q\\,Mh%~vyL7?wCI<Gr+T2qW2^Se+n+n\'(ŋ*T1@{Apb\"U1z1r_#S]HB^x(i],ƙ8qĄ)1Q&&iŉIf\n1}TL/\"fًW7bKW$s׋<ł:Xl$HX:˽݇=V}soJoFS\"#&=l-4`S=6_(W{gF_\\^)BxcFph^$^\Z-^38VI4F*Mhn:OH:X7Mb\\ʖXbILG$[-%[%%|/Zd>d;Xd/dݿAldOdH.Zb׹Ub\' wEW%9ıdV;}%\Z(qy\ni$?%nU%aϕ#H\"HeJ|_{hIߒRI	sI(]JDDnWD<$9IՒsuIt休b$d$^Qr*Zri%\r$K9HKR$)T\0EV8H?uH|\r$ӯ@	~j䛑$wH\nz%E%Ż7H_?%jZ%m~Js$k\n75=Vw**;ɣFmI\rꑤF\"=.,9!\Z$A\'I\Z%;%σ%rI3v%@=Ht<$`	 ZFN(~I1dʕ$}Lg !9IHyq\n	UsIB\rH	*pfoJ-E\">zH\"Id:SyDJ(W4WHzr$+ Iwu`5E_F)y3a y<!2VJާJF[%:$zUk,$co5%[o)o$\r$(˃-7$F/K_vHh,%YJ,HUIUZIR6/RM	+TT˸Buwt3G&]7n#ՙH7`F6J7LzwI7N\'t:Iy\\;WtK}!VttއR˨R։=?{RDM8aRg%W)uɔzoz\Z2(=~!鉐Uғv[\'/$\r俗9KC\nih5M\Zږ&\r쒆-K13\Z陵(4ꢷ4ZWzA.@NєtqI`zui4sJ-\Z-iJ=vUz[zS\"Qo,-,-&-nQJKU]fiP)LzoBz﫥Fi9B놴bzACiJw:\\Z]#ђIk\Z5fmi]B.SUZ@;JKJceǤ-FҖK\Z/ʶH[ˣm6ݶD\n#R\rB=4)\"[)בbXc)Z %fI+R_ʯ\'JWK,_-RggrnJڛ,\r7oKKڤK(C#P]aGǘҏ$tK\'LeY:MNfJ2߮ UJIyPғV\ZrƨtetexXrrJh,[=M>iHd\ZdS2tL&*/[-ӶfSddzV2=z2_2}~L!SYKfp^f 39\'3w2s\Z5EfvخWf=\"2ٺl/\Zw9Gd ١ǲC횲C߸#sVKdGʳeo4dd76ʎyekȼU&˼NNmJP[Ȃ~_۱e*e0Yȝ+q,~YhGޥEn@\"wg\"ö\"eQ7dQOʢuʢb,zd1nbI,LcNC_&TE\0]=T_T5/K*\\+K#d7ʮd`o\rٌ,,kTv,[,dWdynYٝ@ٝ|YA\ZKV.+RM}\ZMmeAY2JVIΐ=z${FV=TVF\"^0ʖ=.kN.nK+Z٫RYaYg^@\'MeaH|rm,L[0dd	;>TFH\'#9!edᄌK1Kd,\nGNӣ|PLTU,0eG2iNt MօLuaȺzte=k%+p\\޺\rF|Wd#>>\\Y#etԙk\Z2싪lr!dOlrG6ul}},uXU6$-\\+[(?)]c+QpT/\\Š]+W!WZ/׈5T䚽b5OU/,rv\r>.7Pn\'On|?Nn<\"79BnN\06M\\[8Hۊ;;?;K]y]ݙ䖁r$-ܶTEnDq@n{N~0M~تO~:<Z%.B,ʽ.˽O}6}=\'V/OEʃ,yZyX<L9#w[{#u#F$y5cJhu+ظ:ye<D0$\n*lQh2&O<%懑_*O^\'h!<iy\'44%UH~G_~zMIyI^XV^L /BRG_kБ1WSU&>jS>Ky]ǰq[zTkNy-,yǟΡ\n9@/T9ǤWñNr\Z9biW,Gџr)ߐ夶e9yO,{*gٟ<ҊosT.\"ʅNrѹro\\$req;Wޓ$m7Va;|~Q%_\"8n\"%|G]\"@Oȧoȧ˧W 0Rwnb|pH/2U/;JMV.S+4PhPMxXcb]CzUbC.ņ}\neUIe;V+=&nX\\bs#MkEQVUbvbk]bJcǌbwbgkNy.՟run͕]L>Ka,%[z:8!>o/;DqbXqBKqs93ũ\n\"?RW{CL;#Sei*\"N)\"Bf|Ymsk+.pr0/((]H#PQe+߁*nlW܈Qd)ZE\"f\"W	W䭼R)Gw*\nڊ{6`EYzEȨꩢriAQsBQ۰Kݩx_h&)M),E5NduH&*:3ζK;7Wۂx=^鬠;+8k#F`+Xj\n#N6Rp}[\nZV*D\nqBU!9ѫ])d\"DPV_Pt*^߅*wzw؊GbbQ|bǏEO1bLb<T1uW1GeCSbrݢb2vǹCr}4w/yb^+J1]1b9ubL2ST?TT.Q5*(5_+BuJ\'(u*\r^*7K_)\r--6+w}MSZVZRڴQq(5J.Lyh`fVyHt\nB(WR:G7*]/+hT)]KJhc״QZWyGOyJy\"<iU4Rtse]20q{9Nz{A:f)fV03qהQ\'~\Ze|*2]e@yŦEyu2q212p[ev2IJQ&*(Sc*Sg+3E%̏ʬZ孔!eeNܴ2牵2#e>\",hWtw7;(kR\rn\'e[彏Qyʲte%Sڥ|?`+UVZceSdl<|\ZV6}S6{(_)8k|;	vZOV<vVQSઃJXQ.G+Wȭ딨X%,LU(\'*l%ز_IjIWRd))#cJW[p&)B%3SW9a_+94یUrMRЗ~/SJ!JVs|qRQt_R*(}۔}6Cʱ)D1Y9_PNeVN\\QN-\Z+?h+(Gqysu\\()!MBFȈPF	R(l*ٲGTRV}{i<ϙ{rQrɶW~:Wtj_QO_񿒿.u..).|wEw@@5.7P\'wVVkM\Z%=Ӏ\r\0mEδ=@גQVN66hlj\0l~\0}U%oB\0\0^޷r!~1`_%p-\n`j\0S\0\0O.\0\05\0Jv&`p88808{p;<8V8~n.ַpr}k+.഑Q	88w	s/H\0As\0B^\0B\ZPRũкpˀuS@m\' \\]s`n4_4|\Zws߻\rH3$eM߀sL@m5!#@L6p\r s\Z I4 u/N@qf@\nP6T8dyu@9wn9mw\0\r?g\0jk7=8\"bt~MIM6w{\0F\0mF_O@0@q@wS.CF|m=xD\rdcࣸ$` ;\n0|||-|6c0LNfA%`6\n;,	vp)ɷ\0\07O\0$<tkWH	\0J	RN0\0B!,4\0\0=0 i\\=p2X\"@~X4X{x		X2м*@ppձTZ$Pc-Pk\0j7mnn6\r;\0H/|n+9ܾg_p\'phxpk:6\0hhh3h\0ZNZ%-ZVǀ[]6F@@G5@G3QS\r謦t|r`\rR<X\n	HztgO=ozTz;^5a6^3C@j0m`ps9Zkๆ`+`9\rBh@WR`w``05\n>PƼ}8k``?kOIiɍ:LB#·\0ང%l^`v0;	j\r0wi\r_\rN߁O07%I\ra2:\rPO.Xw\rX(>\n|:u,d\0;)i`l||M-q\Z\0,\0yM\0;Ӏd`~`-7Q<ױW:%Rc_G5Pq+\"p,^Q+3kky{~\\mDr  \rNr\".@# Z	DD׏	$@\"r;;}sʀ0AJ2V ,o^X_rGs@@Y-PcPkdc&KFt˪ULzz\ZbHcbhh1h}d#h=Ai	\0醀A6<Az%Vg_/O=4m\rÀv:|qU\0%\rڭw	ǏڻZR2>	:sdy̫mAC@ԪAu?l0@Gg@X91+rh|.4|׃<\0@i΄UgA!cA?\0]\0\n4\n]q]\0\0nNNbWo=I%0ށn%%\r%WRmR$Ґ?A*;1s;k@w/A97r׃\n&@AEϠNWA%_J\ZA%$T	***@AUgA58}C\nTT\rzTzj}z\r\rzqԚ+;jryqs#Y6ǀ@>T^A21mA\n`\Z48h4)\Z(W&z@>/A\\EANwYG?Ǘݠ_\r߬}?/ \0Iܷ	k- oR@PKL\n8	~bt@l`Pq޼qC %\0A@\0Gu$}~$s&;Q?*wUs;̟k85Uu`݃wlޖog-Ɓw*h`&\\\"i.l^d6:E`ۛ`{ H6`v;\0_{*{?.O7y}kggY\0\0z68p&H]\\nkϞ_9|%G]G~\\_odۃof6ccqep\'\'26\0RFo_\'nԞല0pZp\'8]f\\7κ0΂~gby(p6{pA!p/pisp\\~\0\\q\\kg\\ץ?~\n7Og\Zg,sO;7gkw6MYt+)!W%Nq\n\n/;lM\0p	b3×)p5\Z|W8?xX?;YWG.G*Q(khggKSWU.:x!\rODx?{3\n+nKpp*_p`G`}6^Fgщ;00~5O)\0[``R_6	SV[`C0D4:6.Oz(-lr0;U\r[`WomQQ3;	Qg~hWA4L _ ZLE=DR!dS1ȖU3C}d[X.d[).\rc\n1l981bDs#b}\Z\"b)JrXbe΂bC?Bq8z8%/C!.!Bp n{Av{ěr:$H`I7$dTD[d\\P 2! B\" W9kidgHTr;FG8f\n&\Z$P\rS}w<zV\0W$G#Hҙ}HH*$=$k$z$S|rt䎟+N}zHv/$o\0ɯJ!! 鐢b1Č)&>)\nT.B9z?!Oml!O=[ OC\Z}!\ruAuyxȋZ\'(IOҜy9\ny>is١y.\r\ni}}Q\ritҡ	 ];!]^ȇUMCo =$HS/2212\0|2$d_X2i|;XLBfr!~C, _!Sk,1x{:\n	C6\rmB\n!n뇐6d@;L!S! a=Npv$ȿ\"\Z@Ĵ-i	D\n[kBWCzE?P,cZ=o]CAu=Uy-[@<ny-6t t{:cto\'}&C9\r=ح5\rݬ@͏jA36C-j.B-+^@bP;q:~Zu	z\nPWPYu0@Os\'B=;>\rPg	=wvoԏ@٨A)^ACCC~*BþC}+2hMЈЛh4;譇$,h\neZ	V\n]慴BB?f~\nZ֫V>CdЇ\'C&Ak.Bk&ڕ%h݅ih]F\Zn<\r	C/@vC[f^C[۠Sm3xhЮ`h9hG:?8Ё s.tpe:bkBbTc3Я@@@g{Ԡ?}?oFCT_.օ.((HB>A!}PV(|h\0nE\'A1R(dg\\<	JlN$PҭPқP(eV(m=W`HSeKrf PWPR2TJv|b)Tk*+ХuKա˾G-BNT<aƹ05`E0\'&0=õ0=Alki#Lv7l؎a{lvAF;\rLv	v]ؽf,L4a\003o0t雰Ca~ìa65}0{9}f?s9_aΤ#0(	0O07,#\0\0;q&TG/7滸]\ne@4,ˁmz޵	vnv.#|!vy<BvvI6E>M>)\"aaOK`WwG®=	\nEoа߽`1!JX,|K`hnn[[oRvRbB`))X,}	,	S*x=4	Ev0aZrXˁl\nC`E\\2xTV+5f]Ua!Xe&7C/=\r_8{:k*5:a/6a`6^j5yھ.>:l``]ᰮn[jX37X_#\Z>\r8[ÆN\rݸJs\r=TF`]1}񻰉5>.lum:6=l6\0KKn;I_W߇Za\'7\rg\n6!\naa6xS	/Sa̔,#G΃>xJ^L{a\nI&Lٿ>r>W{˂Du5#kn5lupn\r(\\.N\n\\N9|cq|S,|S)UW[[~moo߁~w#޿v9wy<i<\rFNG6 &ܴW7kO澥p:	Uv+n}nwan	~;tᎯTGvOɀ;];;?+Z]ݧt\'v\rpst~jm)wLx`e<\n~q6}\nCˋ0\"<\0!\r~}rEgcc\nlDD=x\"8<xO낧F{~Wz>~J?\n?\nRxwR<7u<L _+Soj+m\'|m[x5xa:m	xǝxP#{cGc!.ʏON\Z§ɽiW\\>> >*_I[2km\'UppM+.&pp|f8\'[7\\&`\0r\r.6iD\\+O+\ZJu\"d_.1uK*6)bxĚZqfIBwski$BMxmw3A^!bϋCc{I%#h xd\r=\\WC7UqMk08Gs\nؼqtlpB.!u1[-=Z8y	q<yl_\n^#r\0k\ZǤ5]\"hq~8d?8AmE\"EIs9\".V#.#BȈФ)fĕĕa>`D*)\"R#FD\"HH*@\\@!R3*w*w#,(DV}ܛs8(~(FN\"J`DEZ9oDuD\'ǵnZvu kE\r`\'s\nE9=Je&A>DDDˈۣGq.~чF|FG\\Bfd!~ 9#Q7\nau/R*bbbWDyTfbu1CbA\0]F,|E\0PpcD;	ߏ@o@\'OA׎AX<i>,E~g#D+_A[tr!4T!0byĲ+pCK#UF*KHu\0RGy\\불r/CnxԎ5GNF%E#u⑛8H=YRd	Rӎ]rJry\ZrW$rbޅHkHFȃ5H(%UãsHM\"mH6ҾyԝtJF:e#.\'H{vHI;ǯ\"]_ #=HϭiHϏEz f\rgba35_gH}ȳJ2B2\"rm-O, /_yդ\nyUV׀\"\'g\"?BFOA\\V)hEƮFN#iȄ=dJI2JtEJA})Eޝ+Df%	YH2?52_yY,A\"4EbeO3W5	9Ⱥ4M# 䓓OB-7#.ȧbdZ$U+_͆73w}k!ߟBy|>CvlF~`\"{TȞ?doٗ5쫲F\"^#۾ G GPgkx	CQ5Tԗ7m46-+UB@>9|50rG5A\nT ܮuw#7\np`QDKHT\rĎ5!$!2$/<F{HQ$cɐL\"Y${\\!FrS+܌H޺R<#cאR\rBJWFHsH)!xr3ܟ5ߐh2\rr3?\'JE @ڜRHDƩ֨EihrQkY4~Bi-֑x(-j>jCdJJg;Jw+d	jzԦjfJ+J/7}Pڹ\Z_>L	jn22ʓ]֡Ljo\'P7 P!/P(PƧQPTwGt2j&\06kr\ZI@Zk:%hAy0lQ˨\0*,**\\*h\niE@oBB?1PW7P47\"\\B]n$P{wvPqT$*~5x\ru;TJᡒ?P)ܙ._CeEg}De;@PlTTѽQԃ=2T	LUYBUD:٢j{$ZfT-;-AŜB\rA=rA_.B5<\Z\Z3rQRE^mCqM7P-!TK2tv6]G}+Ti<TW\Z#@?)T#jt58\Z^&FDR1\"V[|#j*IVw=.j/z례Q1(л^x<rDP6\nD!M((yt\n3݀JQء(-e])(\\[Q̖W-Dq0P]`J%\rD	zP=(/(Ű5j)F.jڊZar*돣Ugw˞L5]GkXZ58Ih͞{uI\r@JZǩ\rsmZw/zz$z*zs>l>z0;\'wi%\r#}[=oіcV76\r67ʌv\rhǧh\'KKvQ_]hhhhV._~Ov=.=ЧMhO\'ڗ\r}F\ZiBV!{oז@eWn@_50AGFGDG=BG7.7G+q^/ѷѷLзcۛ[-ę1tZgtitzC:#A@gFgiyV<Q(@#]@@C.=Շ.}쌮LwBW6+Dtu}f>	T,V9x~~|+6~S~A<nګn__{~1A݋ny]nxߪC]~/X}RA?Fנ?V=CZXg7LoE-I*YaM2(=@EmCOף?j*3ГFcoN8z*~[cvM=пG:04p7\ZACT0H\ZxFz~hƤd1h(\Zk?@8hw[49<BS.14s3}fǺ.\n4?	в1<Z.-ҋnn7uP@J.jQCa֬a4b0vlX>5݌ԷP`P0ztV~)Ƙ$f筯 )fw!c`b_b+S0\\0Ff㵶Cs0&iw011W0礼e`<iT ƙqi9cwaq/`\"c\\Uc܌o`4L/*\n`20~J)ƿVߡ	pb`\'V0D0G1e[0!ez11ݗ1\'va0ݘ(`.Lw&\Zp	I~II`2ba>`<0]1;arʌ19o09091yArL{S0\0mY++LeL)!Lyc(r7\0S҉0T7cg1M\Z1a]<\Zc\'QLrLØ?ibތy^`y!.4k`;17̫siLLͪdLt\01eaJ}0}=6~L\"f)dd\rRfk5fv3\n3e~d&ǎ\0ϔo_,1ca0sO?0:Zo]Bx&`\0N`,t@\Z0Vk2`C%ߴ	CQPFj4zna2°F1¹N\'F:G`đ@R/F^}Tt\rLS+ĪVbկ^êOcWnƮZpjjuupkz*5N\nvsE8V{֛Obw?\Z1=ݿ)\Z\Z2&C{XF)k~{YZ|njcmXT>kOu?uڥu9Vu+u==.wQUC`O3bo:Lu2kUggM؀ r+6[6f칼^칮.칟/NUb/^^^BWaC^a5`ݎv|/6C\'O7YaX*l<6?h&Kw/aSܱaރ8b9`o#a:asؼCl#)[w--ZV[VqV7ckbwbk?\'ac\'/a63C]웓ط;pß؎؎ﱝ]e/.ClWClw!]չ5a%bءءQpPv8R;rvEv,\0;Vو|;᥆?cf~;kJ??:;H;&;[u;ԃ]6{2 (,A?^ÂN>Ăo`7csx<`qKȋĒo	X*,{@Sb9XVbPXa%өXɯXQ4\0+K8~fba;lJ].]._ڇǩ:©WuyV[­#Xi=mVt6q[dYj5^_nmSۦm;\Z;n\\܎q;q{mpƳ+8c9A8\Z)άyqF88F-+¸;~wB2u\rݍsY¹Kp\'|q\'h#8H=\'Twp\0y\rg?y(\';Y;w\n.`.h!.xM\\2\\pBEo1..4	޻wٸwEwD.h2zY/\0\\.j	uEsp+.=󸛝Cbq14.N..>uw#.]).i#.9-ՊKـˈ؉2O2i%wgq9Ɓ\\N/w[Uq%qU2O\\yH%.W{d^{~\09W?k{5,;^!Zpp\n\\q:\"pIո ܇xs\\]\\OK\\\\R\\3\\_mǺ7\0=\'M@n07Tv71:[,[&N&p&K\npFnMXXfpwqŸKt=_{V~\nqkGq@-~#6q885:Cny>8d>9Išp+8LE\rCYY8G|sGȐ8G[wZ麅\r4_6ㄬ8QK\ZNlɺ6_7\0qxܿ#FxxUXWOkX5Fch^)[~*M[iDw[wk2}|^cxC7*0o8o5/\0\0(t=޸.olYMu?ěZ \"ޚ)(xm7D[ֺ~:wYul1ar-tJ|w\n>v	ć|_ߌ_uC}_2G+G؟_\r*49(1|T}|M{ckqI:~Oj:[\'w#wJlCnⳗ9\r_H8/\"?)ŐD||H/𻀯\0U*Y.Y5\'O\r[OĶ#hf42yy|S_||;{/oNw֗Ap|{2ߩ!?￾j?g	?,~t<W~rs~?\r?^uMxȡcxh5urxDYģ_x]<{Oޯg:aLJ6UϞ*-|i%x6%6Qxy^9ئ_qT7#t\"TmM5	VH} Ak;A#膟\'>$l̙$l|9OBЏHo1v~#2G0o`E0M0U\"	&	M3 |ٙph8`iz``ٗ`]F 	wR-H`7Jp#8m\0On!E8v\ZMp=CpmzEpJp+|Lp\'N!M8$*;\0k!8ȅp>d5ŷoaZm	e	ЮBNB!|[4rK!A{5$D7r	7`LBn!&Nz	BB!t.!l_EH\"d\"df2DB&pG#=B\'=pE7E>-%o%o.$p)_PF#TF\"Tn\"T-Zij#	k#<JxfxnP\'Գw	&yZ6=nC?	}$@zOY	ޜ 	Ca4DYW넯d60sDNEу\n;)c\"aG\\$̻#?ޯ&m<D\0 7MΏ\0RIeZD	\'BwPY\rcKZM`F	\',gD\n {hAdNAez3OW G5aE*a1ɍ4l\\BX)V&CU\\`U6_jSTjq)QR@\\{.0Qǻ%nDbBϿAoo!n\"nW9w׽ Fu\r>tfMO\"8dN<PE4ZH4Q@4I4H<4Gxh Zʮ▉V5DND+`pt1\rFN<rѡوW#:FM]zwגnDDC󟉞`;u4+F=w?J+#VH<JD\'>I%v*ʈ^G[&7\"[\'Dpl\"2Mj$^$Fj\"^{xI1\"bS1bB\01Y.1ELGL/K8|9B˅xh+1ˀDL\'sCE۫EbW,xN,q#qĊzĪ_!׉5km<F|B|TPN|^NXOu`nGl(%6xO|A|s*+3{.[\'7W;Fwލ^;b?- bJYE\"y{mϼ#w\nq&]q.ğGqqVI|\".At0\"$BD\Z#\"߉=D)\"QO$1\"O\"&9Md#%rQD^h\'ǈb=wwQq-QQ7AT]\'.>{N\\#. .\'.o%.\"WfH*u9U$U ImMi{aIpn]\'i7Ika?i$m=i3iIS	.u]M\0F/[=ҁ\'Iƺ$SC$գ7PUl9·Io!!^%9wΓ\\ߒ\\Av$$Ok7HX^O:\"4$&:JR}J8M~9D:j\'#Ր|mIAUHw&]\Z$]%!!],#]1$]!;\"H׼ȍ֤HKBIQ|R~R4ts*$WHUu-<)ȅO$#IfHIv;9;G)\"eUսI䤂=RwTcAzM*&]!U7*7j6GjO =Ҟ!=O/2&5{$5_t&v^Ajit I%-\"ZZ1cIVƤSR;O;O>2IU:oA1YoIS`̏bMqJM aّYI\0)	A`K$؈:	IȔFD\"x%$$)DK:ؑh_h1PVHbi!qo8\0ߚ$0%	I1$1$-\'\\$l$WƑR2~_JZVbHINzŒUnl\"ԔUdZY1y)ƤYUND~!;|g{[ԭ[^\"o%mEV#\'lH6M6~K6}\'m5#K\"Aid+{>V!o%ޠ|&aKIޒ|슑=dt$D\'\Z$@ȧm\"6M$nq\"ZۏϮJhrrP2tl}ЎF|/9`,By.rr#9ԃH`.WݓW/9꒯&_@RQ0fkɱ	g[[ȷRBrjir仝=6rn5rA\\$1Nܭ\'KZȥf6xCr!ry5\nJk*]ɵoRȵ(ri(04q7!9A|M~&%7o\"7`_)ޓ_wo۞\'=ɝjr`rr4r0f7@%%]\0rϓ3^Mdi\'yb{^ψz	oO8wT.۟%.\n@2(3`.2BH\'crȘds2NL!OL_dW2nI(-KdF2%!	%s5Gcd~Yֈ,8G:0Y(j!YTd;,[h#\ZJQ2#ȆRy%`EMY-hLQֺ)S)uwRjP6_@эxO-AS6S6l>mAe/ԙbeשk]-ʮ(`-_\0ޢ$FO)z)F1g7S)_S,=+W|:rjbCm=Ҥ8\rPfRuvQz(.)Ǵ3(nJA9J9aH91r/DPJ{pחM_E	ƺP3(S.S.\"(K(GR)]+2U:r	%3%#]Hy0rsОCsĒĔ1mDU \'JC6%3$%SlOddYܣdSPbR@J?j!hd{RJ)TlɡT=TTrl\n)5ƪog~g9sa\rņ(9bJ\"jKyclOy{N#.=]!4޻S:R:F(]AwC\"/ӊWѓ_$|ߦn)%iS)\0*eeTe\re잂2-emDsz9s\r+ʗ\03ʄjD^D\Zm74˔)Dm.ߢ|K|M,-R\0(o\n08yJTwS (0ػxx=qAO x\n͚%S+O),yB>6JU_0SIcGb)k)O0_HS$I^\'Er\"\'(4)EYL,\'R(KEAU]ʿÔZKTU%585W?P5R+S4zyUW9u9O?4[v.P{G+mnnPw{R\r6n\Z\\C7ojdI59E5Z_ZjEwv^vTPq9TTy3˱Iq2k*1+(MυꮒCu	dD=Ոz[޴a>#iW	5̿6G&k	멁ߩsiG\'tMjSjm굍`5FN7S^^F4Sc\\J/Ʃjb-5njĄij_}Ԕ)%Ԕ,jsWj.5-IM+Q3\n^S3FS3\rR；ޏ>S~PjaZ8X@-+mΠ<>>D-=J-Y-RONQkQhjqfLԧvS\0Omv\r7NmjD}OmTS\Z]S?QP?^~*@զ<=<A>:*:Q%>8*uFJZDB\"\ZPg\'\\{3ԟyԟM?Q瀫ǍׇT`)*XG\"O<b*HuyQqTLHTV*HenFPYT7aJM\ntTY{m\'U1yxFWMK7KS6\Z<iMh9Lӄޡ8A[fN\Z#62i0/i4~m\Zm4m|V*Mȝ*m[	mK?ڎM]]Kmwh{QH3\n7}&\r,R:,.,4+4[>vpvtA+93i.ճc]z8k:q͝B;QF;yE;JyZM;M}:ivhM;cwgILhӂb*iAoiX]yvJN$]h%c8ZT}5dڍ81-FTM۬O%4HL/Ĥ9ZDZJ-Hj@K@Kj2ve\Z&22hwiTCв|e!i/$ӊ6ZIv4eVgЪިѪӝhul;cc[ǂ\'ifZln,-Q)Pګ\rګB8e$\"A{Ў6М>ܟ^@|3M*cкW;hCtHnm>6J]mmu k9[L	m6mCKy\0s?ii\ZF4\Zd\Z$\r֏\'А1\ZwFxFDШ`\Zm-ư1=i\\]4\"L	?4_Mf7I\'4w460H[<O[@2@_𖮪\nվb\ZzXg#}o}}9MתOyKIgbƐ[M^[/Ow؂;Yro!ʑ\'.ݤI?=n7K7;QK?dH,O֠[MQhuQ5͖n~AJwEw,;z#Gu\ZNN4a3YaJw(yzq;M?qotϊ(A=׏Oo~ָ~=WАFzH<:C~_r~Qe~4=\">==kt3=R~}4=*=IO%㣵)_uۏZI=m8.Wg_EϨ-gLbZz# qzP\'=CC&dLeBx\0y=T^B7ѫ?#_O_h_@x&}czSZNz--^7Z7{ozIzG&ǘk@HP0}t!}X}\"ɀ>eRD\\_OA5D;3MXLСt\'::bC:f{њ:tk:z:@D\rt,چN,5-Db$H\'TtI:C.Ui{_>t~\'~xD3(t&@gl>ً:Y\r[I1]t1@?Ctdm/}/EЗK^EJWfj\'C\nPK`ubjc#Znf cEz\\vj	.C\'@=1t\'5*?N0vDE2v_ػ+cax͆abJ}wCfXQ3g##G4GR60,2OYos?Ùp9pI>p)8.|p+3P\rnG7q5qyڅ`xeex=0NO g`/~\0#Pd eYf{8_2)ud\\t#TNc\\s~θNfD3\"He7zQ3#ʣcĈm0\Zڌ5{ɥ)9T35Nw}w9]{݌|FѼ\nx\0xFپ2\'bŨQqgT3=3jgԌ%2ju׌GTu\'>3jE1\Z[MZWMM0F@Fs{od4c͂nƻ]?r8{F[=%#p*\0腕1512\0c1y1tvι~11_}1%c\\K80>j3>M1__ɖFq81gX\0\0eg2H%pw@n@=0020܍,`\'1p[|A0(7t4m!vVàN0*ܕFbpLZ@;|ac\rR1!PPf,F82f+ϲ+g/LOGn1U/0U0UfLLuX s~#0sx\'SDednn<ܲ~ٌ?pܭgs+~\Z=MLAAXti\rgҙ3G3N2-1sLwm-Iiw>~=>wi_ydh1k0K1,372]73ݞc[2O(T*LϝG!טgTg0UL){Y=3Yf@>3yƼe?Kd[G1i@fr?W-W.1b1`F\"ћ1c[љư7ki\nff3Aļ<:Lafc1̾Sny̆ي?\\q83X&3\',Rb9w2<f>$1K<R5fmJCf:}ZӉYSŬ)^bo`~1낿1?|rw0l/g>z|w)|e;l$0<`=Bg~Kb_`<}f~8T\r{ٯy9*9|;ǜx<9w9b1t+Ek|c\"s>}9g)g (&	΄1wL8#!0q<&;& I${2\'DII3晴d&\r c`L8?2LNeCgr\'0))[e`Z2!sERZ=yֲ/6Y:V,Xt3,o&c$kSkSYOmf:`qe2u0e²}uH}uH+e`Yj,[!œejHkrzr\"YYS,g\ZR7r!Nسyr?rgYS1ˬS#,}\0̵,&V@+9D\ZUVH\'+$;R7Ⱥ4ͺ4\n_e]9ǊeE6Ċn`EWn5bܙ̺\\?`ſy͊_4b^e%f`%5X~լqVJYV*(8~i,be	YsY9mT+вU8_z;t=VlVewV[{VU5U2`:*Xo\Z\0X92OӒUq)	~1w\rkW7IOXo_XWSdV\"ի>fcU(Y}ʝk+;XYq^/-oX߈67XӎXӤ8]֏WX֯eUP\\Hkn&5\reG|d-g-LZ\0;Y,\0~di,h~XY`P7XY3E`,r\r%ˢn!\"m+vM^X{WX\\q\ZKP%%r-g.d\nM\\k\'K4ǲ73,YKr/[t{U:^Vaׄq\ZZclRƳ`Zډ9W2{mԇt`&M7leogoϚcoߴm`6(>6薲&:؆l,&@2T6)+bTaD;feζ/e[E[b`ۘumlp=]\"mdHdMub;>e;RN&l\'9ٶ}ܸ}BeOLeĄ=اl*w;>/j*\\_yLz{E!Kv(;e;|:J?$;\"QǾzx}mڿ3Hh/ɎIc|mf뫳Kٷ؉^vꛭ0vv&}Gr}gye}qKbawO\"@vjxIvѬO1W3+Y\nO/v	svzvt-p~8\nc?a?re?hd?a?7b?~t;v-5^gI즵fKHWv;دg^[?[o*o߱[#mH}vG.]7re3O6;.!\'!\\{Qt)MlZ7{%k,{r=}+o\rx۰?N;P6FlHJ>F߹\nxq6CM6dr\rl%^~S܄&6-hc%\nle4{i$^92yG}gգ8\Zk8kՇ8qֽt嬏dp8\"\n6ު*g+(%ggm.gІ~WcTc{*%\Zs0;spvmcÕca;ȱϱ|~cc>9,{ȱPʱ1slW8vǲ8vi<_c]/xs&ǥs|\"s-$㖚qB=xxq|,9>8Μ38g9~&fll9NvN	}Npn9\'f!(\'I\\Ź\\͹ʑsE3\\\\MZÉlsnf97=/rnĀ9íĊ͜d=;5DN\'l\'d\'mN,ݱ=d}|\']N`\'Gt_)_)b8E½^}Ev<ȩxy&0>S{SSgVǩN<Z.<Y-k4X4qq^q9M\r6IW78\r8-\'9mW\"9mmv`Nԓ_z}X9=/9ɜ~OX׏JpWgtl+gl#3{3>;ę!p&x7]\Z,3~ΙnL9ęL̐ٶ`w?8O_Ŧ9uO9G8w98 A]8-`^rpyou\Zb9l[ˡ94}mpy+9z\Zp8!@!GP`98GW#ȑ r92شw\ZF]eBVr\rs׭]oӇںurcsg	sZdסp͒J#6ܽ\\C\r!5\\\Z\ZsM֌sMX@A3״(tkj5SFrQViVmV|׮u0uȺu纆p]q݊q#K&\\oZ֋`P\rBqksyPXd#КCFKn(6Ↄ+gp4pMEܫ)xn7nԫh+7\'rcX,76-.{M<+&}+׹i<n79n:Ǔ5fl5\\r[Z3ninJ7_-:V-rH0b/[~<\\>I>:}d#1TPmX66Rm)MܦC-W+wVV4=m,˚ە%q$R`.;2Y]!;Q;zņ;	~sΘjqgMqg	٥?\"?\"M?wZK΁;_t;SpNs]>\\ UゑH.~wpK_$.ћTTr1F.>:Kt%d..eq~.w\rjs\\%W\"sJ7K\\^rWPZOe3oOUڴ	orK5<<\r=Z!oj?O+.OtxbosJ:OIooLvg֗];3ܾg(w\'?\rϨMg3i];);(w+g.g\'goų`ϳcĳe<<y~nz򎼊99&iMVyNh i)sr2`myx\'y\'75<*|_|m%9..Y#yyam+yWixyKx1?bd5Xw/\nU:x+f^^0/u/\r<ˠy2xw^yxYxYy9Iqͺr^b/p^퇼b\Z^;^+۝+c\nx^Ż*^+҆˫ȫ&oI:y\r\'x\rm;y\rދ#RK&#iQ^t1$u^*}gp.׃$>>1My\"x>_x%AgF`&ox7SA{/&PxBywy`\'9om/9|1O\rBoW+w1PA\0yPA<PVf\0˙EzHz~zb+zG1l1طy=v<N/c.y͑<~HOOZ$D\r<AOShy\n1xoeoQ,᭔yUvYU>*b_w|U-__9k5ͪT6.ׇlN78MÊF[7oBte4]߃woq_^?j?ŋ\0`7M|\'|S|*m|ߥ|<52vl|g%rwKQf=Z=\'O2nOJO򽍳މR\Z#~\0Џ1ʾ?1+/mſOz*6_N_GlGn_\0z~Lc-?vۼ;\"ǢQ1~bu5?鮂;K\"~?mEY;tpM+<9~*\Zq#QtIj)Fo7NJҷ,[L/Z濾\Zcdo_wwzLw{՗h~&ȳ hc<?O}Nɟ~RşM	*Npҋr |Г>5>tM	ZCQpB\rc_cX|l]\'1EI|<ϠO|e>=5ՍC_|_#@ejLV.Xsy`͓-kwi>].h\nUu;=>k\n[\n\\ͮo[l~/J#!g٦\n})j\"	v.	vwiW\n&\ns>z	LOLZ.yA\\$xK`)^,(Xl9YvZuNj\'pnu\\m7{G8#N]x-8ZŢaϛ7\rkAK]A`]ܱ(zo)_\\\nBB``A#(տ%w@pKpUYpzt zAL F)~	RR_CiN:`;Ac Q  S&S*{nA<Aa@#BP~{2㨠ƷJPU*<</H\rvYP3U1sAv+Z}WvF	mjA%AG$hoLt)t>	cmnh>>\nzz}=F:A(Dz(LhU]_*U%\n	.1_`r`Rj\"(.!K,HKI0wF\0\niW;&(+`OpayI\0+@:U;+\'\ZdC@^- &Է4CfW\'`X	!>vUX )},ft,%FG,9,k	VcjժV՞\nպB3kᗄQ\r^pB}.\'zz;;}=B#oLChQh\"\"4\r+͓M_3V	B57\r[hQ&_:n&<sli9	XBdqL$<q{Vx <f.<z>zzB38tf9ᙸ|aPՈaHAb6Oxq.Yx0̵^n&<*^w^G\'Q\07avLxCKga̾ta̩X,a}¤䶫dn0#LR.L{+x,b\"{JxO7_xK(̆掯毬DE	l$¢w>hkaI4BXͽ/֢ͅ[º\ru:@a~DX\'*|)|6cϫ_F\nUMWyVc}f麰mz}[=x6\\\")W?tl#*XR8GGC;Tp*q(?i>Nk)\nݝ!8&>&Z	(A$l&1	6#:)kDy!ꀐ|Zh|\"dm.!Q`kW(\'\nNB])~ʿ\n+KBpg\0\"NtjTW,eurE}YFh-h-eQ>-i[tdSMlі#-+q{ 2Ut0GdֶUdZthS8W\'D9\"{-Nא-Lt)rz*rQƊ\\w\\D9\"We[]CEtj?G7VMN(K(:#:;<?Dn)]H@..%PZ/ܻFqTA$N];T#vU!4-2|!Eg鈢qD76nnEqt(G(q!Jz)JvÊ22=\\(;fTh((,*tMDDR닢RҶҟh5Qr=ל=)OT}>_T=L? M.=YZ=uh^ly#zQ<++9+z}\"j=^\"jm>&zm͚3E^ˢ.\r.n@G]-?!w>==\'D9/\Z<\rm<-\Z._\rƪtE_ɣ<d|蛱 v䈦=DAߢ`hna\\4;-,GFoLE\"pP~A.\'\rX:%auD^D\\\'\"}&\"?ћDLKuIĶ9!6{xnLH	8a\"ɟti@$-RL׊UUSUmū~9U5Īqb\03\'5;\ZzZFxCwn|xcQm;[;ĻĻmO\r_{Vl+bCbSqbbbzg-Bl);՟;+vO<,#S]4qg8J\\.igCDc/?_J9!C|[yAq_2AJ&\'oouIs$C$NNM\'?8,NZ_\"-%Si;6eBq^8/tXC\\xIM \"I\\kKhqهNq#88$; tY\\9e+rŋk>l׽x-~\\^\\U\\O~+~:)~$7ԔH^glf⦅OfqsLqW+Y8q˶_+oj;J;~}UqMq琸xp6Y<.W[\'_4\'k_O\\O\\OgGĿ<ĿWΊm+¾1ШFCHR]J~V\ZD!1y{ܳYYw%bVI>!f͋E);ŋ|I{RU+^JT~LIVGI46K4\rJdpDDdSdQ7ɖA=ADcdk]-CA>ނ\n}Yc#Vbz@ Y+LNX-\\.CJl\Z]$6L$׏HlKl.I7IӒ%|equiSsI[Kgk+k瘣]$@8ߑ}*	2ؒibCL\"k$\nQr-YQrf+2-$&YY-*aInHnhH~$飫%M;;ѯ$Hrn.Jr\'$yF.IQSIIIakP.)nwHJ%oK*=I*r$U}aՎ8IDDfܓԥa$uڒI:䉞8V#y攤<T i]AIN{G)-Ns%$HVa%c%dK2d2E2d{dn9Two@YJ=8JjBH0\'%*	5VB:EB\Z_%cJr뎄:!HHXׯJJD?$biݨD2a+7J$pźC]֒Cw%UMUUT5@f\'U}j@HJ.HYK^ͷ~II`̥ۦ	RNtOv԰\"Uz/5&w&RӧRنRվwXBz:/u&u\"JKБKW\'^ϸ/G#uUҠэsQ!}!I/UKÃH#W}WkupF_9*騔LђƉf7B	M҄n-/&um`m.$Ҕ\\iʋjijb4mRW%M-ͼNzǧWz7I4YzVi^}4{薕xs_ZڰNZއVH+wOK+[J,ӥU)Ҫ7ZҚ҇\r:FiOYx11G%}Ju+H\'HIK_aKWH?r^,dH[xG$KikV:iGgiǭ`i\'Wp_}RM7@B]?GoHjZҡG:ҡAtptD0-~.V,,CtPkۼW]`=%]HJ1RȵR`I\n@HP)EEjtX)6ew,_I	\");)3XJM;\"VR:o!_\0HRFӒ\"oR	]*Ke7\rʄ5ҥGKP)ZlCٚ\rue\"dæe2/\rd2ev22@l;2}q>roT!3L&_N61eo+ 2u2#<Vvn̴+3;!33\'H0Yz]vhJ0AOf_/_ˎ\'e2W)2[Q2ޏ2Wn[9W-T7/y ;ů|ZO|352ɲ@bY|\\X͏dSeh+Q+HGYk*\"Rvm^ٵeȦ<Y䈁,:,:,(%ݚ|,\r~&Kl˒ԣd)e;,\r,Yֻ]!Y.2LW#e<dųBYHVIV:%+)\\({KV$,\\jKd=lnreNŲ?rY;gdz2d/=^5^eeoY6kFYeY;)dz7z1eU\0\"L6I6&}֔}[̓MUȦiWduYXlÔEknD雲?òb_\r ɐd{e(?CMWp7;dNF+#>U/dp͢FFÒdtz8CZ#c+c18;d@Q(pjde\"k[ULQ&J/ʔ\rejtmٿ|3ٿ;rA|G`||MN|\\nuwɵdrA\\\\|q4Lc|`|\\wPMn#,߿n\0<VnG[n=Wn/7<+7~Gn֝-?l\"\\;+,2[\'o?#?~[~6MP\\@lQ?˝N4ȝF^OjOH=7=\n&f><χPr&r_gYX\\ȗ+TxF C_)IGjon<a ԓTqE:<gAJ$\'S~?@SۣyIpyK<oD^,/GKK+ҡ!y:OȳY8Ik!YZPy_Um\nYX ױ oem.v׃fyC);+;nYAZaI}||S>*!Ǣc?/ɿOlO˿ȧRgGgnȿuݑASb	\\ה*^ Tɡemr褳$J1r~p^zC_cw1XwДlR&\'ѳ\0;9u&gN3l<9Z29/맜a7œ\"HT,	5\'Kw˗DJ|vBC20XY6Uo>P?XqB8DabDicbK-XK}H-b\"I36S0M{U,]絧}D/obߧ\nNKH{TaHaQ=ܧ=械ߴpRp)pRp5Vx7+<9C^>\n/?mp¯Cﭦ*^sTy@<SnU};g)΋r).G*B+SbEx2VqcJqe(Xq\"nFq\"v@7lRYqrv\"q@t\"\"EUH>Td\0)R~T̄*r34ˊk]QIWQn()*G^CJ\"Eefuꨨnx󮢱^K챢l⥎UMk3׍-${o[E[t3?N蚹ިpW#S*>+(jl)btbl}dزbyիwV=\0T\0\Z\n\Zb@R O)PKx\n6a\n\"篂**)k|~Fg*]kV\nB;PޥPR(f3j\0Ŋ7J#MRP\\u%^jT+w+]t^Da\\czN3NSSأ\\5Ԣ?UW5+uՕ=+7QnnPnLVnJWv\\ոrTOv_OJCrK>-rrߵ*8 \r<ȉVTQTS*;tRZVZ(mΚ+N*cvE}U(#Nl-P:Sݕ.Tk/\r\\選rئBPl\\<$V~}RyM\'<+pWԅ*`z9tʋ\rʰAGW[_(#+\no)K)ofS(oT*\ro)K+5t)y221[mVemRw*ߤ(Z)KW(K}ʚ\'5,oovڕ|e퇲NT>ݩ|{M蠲!WHR>8|~G\"gV|6U_}TOnЭlWvR݉iʾȫʏeBr?TUYQ\Z##p-_%r\"kr2D~UNӔluWk))3sm-.J\0J	WBn)aKJ8UܥP\"[(Jq%앒$\nPm*)&Ԑ%\\ɜu*hC)OXr!bq\Zx >EC+rJi4.8\\CK\"B	NIIHT$\r%PT$RtҥzѠPznng@(%虳zCQe軣@(hP-/ˠygZ`|WA;=]Лz,~_R\r`F]Q}rp`<=۹`c$L5i%\'a50c\'Nyf`1Xt:eX\0]ym-=v`k0e,P+G,}4\nnu\\*en1_<﯁R^`tY|d;iC}gF}?=6&q:lUD6uNm9>qaot*xB D\'Bo@H*84JLpDg?9eD;A_eS}b,ؽ\rqVBEwU8b$N2$HRggP#87k=}.Az\\H_<2lKw2o~\\\nWՕpͰnV@T;p37Idc.=}\nBQX)<MG\njP|<<q_=yTCx\'\Z;~Ibp\\\0UGW_+\'x}F@Q&4jBh_@p2M2|w:[Ows|z3*`v֚aOYJ\ntB\r{.>Nި|\ZU~t/;΢8`\'/Aq!vQ{P#7WhpGeq8ƬtGKGJ>kU	/\"pb\Z/Vt)$MI6NiW4ph\rQ4[,`Q9CWh~Z\\-)Z^|izh2F2*C;l/:pK9.\rU!i=tz:WMDwQ\Z=\\G8=ߏC/Kw5zrBV\\7L\n5?{gMCߜz߃~I1@?nL@+9nx[bq_wp5{o{m^44_p?3x0\Zr6%x8ãNvq0[w\n}#y&<$Cɚ0?`=1c[/5eW+̲YSzK=f`Nbo읆7{oM?ǻ5e{e%j,BXd\\\n|şI?G,\\eϻ㳄h|	\r\n`5+kcո]ҿ_VX]\rk<W`Iob]5?N3n`Ky~Vٌ\rFI~dw~H3\0t${ȓI4?n.}r\\E=3Iig5˔zB}:H9/TPi@ѤMҠqir\\[B5\"i]J!H{Y霉a]7аwIo	=n&dL!/Ȱv>\rL%40M*J)\'iʢd^J&$hځ{4|+M7/d溚dnLH\r&d9͐mE}S9,%6GBBEF9ϥ%\Zts-M;L˜ywtsU\\Z@ՎeyŇeZgN>䛹|O%?05;6XPږ@}ӂhڇ(?K|Xc:M\'P52:H3/PTk\\	tjd+7(n1JP$JPkEl(Bg>J-Ԇ:?b)Q5S1o{A]J<(kv\"]u@^ 6Lv~B9FGʝ|r[]274PTDzÅ:*J]ORg_*\r2s*\ZHeP-Fs=U;2uIGһL ?fPÔ(-oRs~hKmKj_ګOuUs@\\ًʆp];-X!rSYq?Φr=VgU.yɪ]GSVmVuXm~\'eA}<љАJYpuM`<ڄeO``56#Va<x	#\r<[l̖x<a:O\'ڰd<Ý\')3٤L^3&i~ώW`M<[&b+,p{^0ZG;5t/_W˃?\rRmŮ&_ͫN]eyu-qِ=c&Bxe(ղ&{\'?bʾOoPf.@-\\~9]wmݣQq8~C8tq9ީO{pؚt˨6|s&ٕg#G_8ҹ#	c\r>QS?sLO>xO[ñ9VOo+pݕINMy(sy|qh}Ô8&_fk-|{Nѓw}||..(̅;\"ü(~ؖΏۺ\"pu.7IE\\Ѝ+^sa~i;n#fg\\Ńk5sN~S؅;n;m>rHn|Cp}4@?ֿ%MώY~^g3bگQP6]Q>Q\']jQ}!eWd5!Q䄋vhg}O\Z8Wt\"~XO)ݎ2줱*4$?C_Ā(EH<8(c*AƙdDjIˣdJLm6ފ5VQbuJSlU6Ķ־w]T)[dAHYxU8*%ʲԌeiL8ӫ4Y5tT#;WIɺ)	_+KY?{W4Lٺ3M(Jzi(;%X\'JzLҒvИ>rx\rkx+.WZ9D5?TPX-	+NH⑋XV()k^KJ`\'c%uFSi#$ӭHIsɪ\"Y%r6\'A\"$\'*Rr%ש@޺ɝR?T$R01J\n\'ΓBUyV*u\nq<EwIqMHIgy:J<$cʤ@I~yTx{HŶRY Uwe[BjޚKMZ=~B;NEMȓ9(\r{KۏО%.i|2 -fR+H_i>Gf͓gk{|ʷQ1]:HG\"nK\ZS MЧ$aͩfl?wZjȑ\0', 'no'),
 ('coreHashes', '\0\0\0\0\0\0\0\Za:2:{s:4:\"hash\";s:64:\"d9ed596f96c8ccc2ff71756e7a7789ad47a9752067b732a68b7de88a8e0c2077\";s:6:\"hashes\";s:127072:\"\0W7ht#	q)d$\0\0(ZYY@Iqȗ#T@\04ߗt\\vQ޹\'_ajxҦ\0E=jȋ|p8.½֤SGp\0EqxPa>bvDo4VG;a<\0^N弘ae|K-ܰɜ=\0b&F%|w*Qr;|/=(A<\0#B5j$#j!bNj\0ۧ4(KI|0qD.^v\0>|;(߯\\W*7?\nN2=7[Uo\0iք\"]^XD2](\0/o):4]_+̔c\0e*@t\"q	ȐN5H\0T|̅_S8O0μ¸06\0-bsG\n(hr\Z.n!ez.YxUi5G$PuvATʦDIXVfEWeG]q)6	jnNؤ^}0[PKXs+ȉawS[U`|WSPD羟Nhb!#8i>kq6RE5:\"ϱT_^gyzGL\"1U}6:l|(㜦q{V~u<Dho*cϬ0xcl$	4mo`vA:`{rf_S3/sm?d^͔0X0#q-ml*#TcxEyũH>$2]%*6\\dpۛ!s%]ZYoݿr;G\"Gu&w]-H\rRW\\5\'=Q7ai\rICpEKykѩ}ˣ\\$p\"&p+^\Z{5|f㵅SLo3ExѥUq`q4uZ[n8Or70H01YL$RRAhJ6Mw:/7.ڏPh.BU-ї\'Tsz+pM˻yULKCWa\\ˁ\n;0Ġ\"fАΟ\'\r͍DdMsǿڴ$2j),\n\' #69\nږmK2efte4\ZGG.fVy`)\".o[`ϐ\rnjnviU\n@,+!%u	re4+JuP$,WNP2\"Ş,|^y޲/\Z(A1]/ƅBMj:@ѫG+SfdVi\n6Wԑ\\<OEj2Q\r|X6/46J?XGX~uic\rpQ활\r?cLTӊqgȫ?crȸtdB\rTJ,Q$TDh((ZdzvO_;ƀEpY.&}_	QoSnn̵v\0)Ӥ:DILV\0yZ)K\nܘD~%Roc7\rL>1݈]^]RɢNFMJ,iI.2 >1Z;ר1ԁ$!W:	SxDq5/w_W:+f1zg\\YmxGO0jo].㖽B=f~:NFa6ա\nY \'i+`fGYbmUPMJڡ0&CvM$O4-K	o6lb1E;7x?-ǱZzE*nkEm@1sY#1$\Z=IbXBr?ͥ-!i>`]wBκ@kp&h4ԛ2f\'GIS}}R⥅JЛZ[`mI$=D֛&Ǿ@+բz=i S\Z\Z4ڶ1523\r#?EQLIm$ZB\Z!&͖Ck`7\'/]i5\0%%-)^\\\0t`k@UOŔcp>!8HB6=b!nz\0OS~K|$TlJbOwf\nTEg\ZU\rl{SYD7I.`Ï}#٧JKNeӌ&ЎuѡIqtn~T	_j-%?70i}eiZO&E+rXe{emX<:KSz_oeŭy^/?h;@rK%LPfc(|_]U͒o~MEs@Z2]i](J~n3ϝـhjqo2kLJQc\08|VANں)\rmMADos,$gJ	Ŗ7l}aw|gRLh!1R&\'kD\':8Yߤ\'\\\0|8(]xZvJ+~S$ً6vgAќʋQ?j`J2r)rk+`NiM2]<	h\n˥O35F\\\0,vS+p\n.\rJ*RT	!A&UBtG=_:\\]>i?η@ڹaKպ*Խ+]ҮgƉ^62G\rS|;)$=Xn!l=@A:V56Ux5Px&:VV-qXA9M4-t\n{}MI	AE0N.T0b([oYd% +[B f<3)|y-d]`,5l9ox;xZq@51aIxMOYU\rZtKϭuJOyŹ&Ҹ*ܲus#t1#4䂹\Z\'&8\0m9;:ͼff)I;Poi=DᎯ0Slhsgܺ{,`h`P*ͤ!j1m!~J\rO]Y<y}\Z>ɺHI|PBbe^Έ;VT1cj] k^O9A9/\Z%@b.` podf?jrYe|Hh>,ecRes5-D=<:3ϩM>r6Ԥ%zuۇ7}F[yx]kݭYr9IV,C2\"Vlp]l2Pf>Kp֚Jbvw`*w}*ʘ)>2qe^)PnGfR@Ol,>iv:`tQ*8\'<\nJ;H`Q؝6pqa%\r	\"An3HIs:Yae0BҲyPp\nﭾ!Λ&Ʌ\'M4BS+\'4&$ءVggog~m//&t+s\"#:Zܯ4㓉&_&6\"xF|w`AZ_+vL\r}NP6_Ұݾl2bqÜ$Uv	l,s\"\rm`YדUX^Ms6RH@	&冾Bx@dR#UOPgsHo)nWrtZM?%VDFv@*9Vμ[EBu}<\Z#d4*?dQ]Bx.|9D:h@Q/U\0-|_ۢ1g-+}Ԙ!^iBJ\\W]f@@w=	.]kZ1љmG]x0	14\"1IxGL[	>(GA:	64 2DMM$\r澐i\0	8\\ŬjAʔ5+XoTm_|	Myu$1ck_Kofm%	g)[.r\noi{4Q\n\r8H\rfX	vlٮ!Pm\n6|ϔK	~Cȫ7:s&ujt	+{Rلnt,Ǟ`|U		#t̹p=I\")F	֓-\nqUi-$h*ml	VhLC»>U8.`@<Kh	ͿU%OHޡ@~x\\6~\n*<ӳ?HM\'VL\'[R\n@&[DqSBN#FB\n*An.]Btv!WҧMw9F\n+P_tQVo7n\nz#8J\nGk~ngm.3\\\n1ijgָ\nv?u	fh62B?2\03}\nxmnV=OD\0T)U\n\\_9()7\n/S\'g߃v\n9dg~@|B-ڐ6=\nT[Cp(,_V+L\rۨI(.\nsHчc -y//?\r$M̤j3\naqYKJҔ΀p\ZJj\\P\n\nڷtn\rEanJ;}(ҙ.9\nX:Q}+O\\_	{ܓC\'ay:\n W\"w\05S Nrh\nC0pFdl\0\"u~2\"Tp\Z\nv[\0XZppi.c;~&\n&)h4_`FL<:`#pf\nRW#ވ Qē4E[\'z61kK(]1zukpR!YC8`dfh.^8!{FNL{z),\"wWSJǲKSuᾒMcccdD(Q\\\ra[J?T?Gd(stBUI+uCRSF2>3`v\':js(-N֠N3:VS;CT\n]CrJ2m5CZ\0/@@11S.>UB|2ӜOU}(԰tc2ĒZVR顃[l#4>1εEl|lh]:Yň3	\\gm̻1)q+#b^0rR_ҲYn,J́TNB(-g\\ICڞ:rn̿>TwD\nQ!@iDrȭ!wzL{Jy7-mG鴞Y[kEn#XviwR:M7KkRD. L9%SJ*n\'ͪt^VɹO*(7Y(Vz|%\0\'jlص$hTC՞N8kȺym-BYVAlͼ2VS#nX6XDUT=1O@,x )\r&d5s/,\"d\r%PcW-:\'2U\'Ftݩz\r1?;IB=S\Z2֥͐&׆ZB\r5CٖNskl\'t35\rQi^\ZB|fC-/rUY٢B\rX[cdpSs3%.X|Aw#(JL\ra{p9(A)ˡ̮SPVs6#i\rnu:Ft\Z\"P9qPRPA\rk<vWPvg(Hтc+d7\rYtW^}rIxۯu$/dMk\rU:w,&Kp&\Z\r7GٛrXylﳠ<U5p8n\rXd	D\nqbc\Zu\rٓC7,<p,L~rYs#\r\"(qq6ZNş&h\r\n*J6V^%W\\y\'h?II3z(BGQ#`pS:eJ&/ʝaɋ`\n}\Z\\x+G\\%RO6}㕓悫-FkRV6G_e\r\"}Q^uYtYsNldU|7tUFYnaIWRHjwHBBuXp\0bUe$OrΰYeJXpW	!L	oѦ?11]Q[7*a3Ǿh,Uc\\ki6uJ\n3*KviA&4=Dq!蓸֧f;4PZeO!vx.e8jY0\ZPP1S/0?U!͝6??Zvw=2H:)x.o\\JtLUoL~)6K5S$ʂ8⡧5gg73lsuؾyZwڠ0YE\0身i\\|7wq;,rLX\\35qv.R߼h<<thD$\\FM(b;ˏKg&\n-nzEja #[՝YdIdf@\\K2o؂/*~Hwc@2,P0x`ՁdZvs.k\Z5\0yX$j뤋I8@t={9v>:̷M\Zϵ\rBt\r3tC Y\nH$$T̞}^pfO]ǭN3%\r\\-AJKK7Pxe\'PHHP=,LN}\ZEO\\0uFOR\Z)ā;S\'bN<vwLSڻsT|>Qi}GD7OF5BNov:A_-3x\ZJB@ky50\nQ(;4.`Rw|lSPpkGM8ԹfEx;˝O[J`uOv&_-]E;|x$(t`\"/\Z=`>&oR֫	ڲ}Z	w%(4);\r;)6qi9C2td64KծAU)۳!Pdlw+>;O-dG;Ϸ6<wj;V4dkԷ܏>Dj,pk~*d}[H?iK[i/(^\\4c-Ȝ)͗۷@c.V_;q:uMXbWZ`Eض\rSky%/-u_EC?oTgNLC\"M61ɿ\\)ji]mb#6C2ao2ᨁFˁLW%\rVJ~p$P(q\0RS;\rs}o%XOwR	\\B;zb#qlESWDLex骴@m!~|dET9v,WыʀKK#\0f羀PP\0Aw:oHRRESGʏT-a*Qf,S7q̓<U*\";br^&7jFőұyZA\"Y!	=x`Jߩi.?w~/\"wU{Lf׏1:դy;&ۆ޹[rDbNv㤄\n\ZwrkHuEN/JYgSi)N]o}0<,eS</ܓ8CT2IUXjF\rPJ6\\d$Se=g۝JްS0ilww4:\"D=[Z\r#A@f31_<v(QNYCwo}z/+x\Z83ۀTё/*2^oܰ\n0\01x?F(8V/`8Іt2:]XK%	EL償t~nF^mKYN\"U[A7EOxƟ:Y{ 2gZ+j{hN.m۩+6r0qX{4a4=PҞ%^\\$~KObH$(\r_\ntl	6Ax	70)P;\01M{}i)-[\0=ֹ?+;Q/׬W/{lDAURprmm\rF6طi(\":@c:<R)%+:G%Cy*m?۴/\r!iAHK2w:%.;j@۴)H&RװRwciFz\r_c;QAJRQ6}%\0wQ1h~B׺ʌʤ!gy{8٢7\ngT1^0>\r劸֬+)7X[_u۱H]\"¡`nrXa;?~Rq3ٽR ar\0B<c=ORvBn|JIn;51VSK6ǐHiI (.fOdx,0XlJ.*Js9&$\rNZ/aUƏ`dL?>C|^vs_%W\rJ*fzKHvM,,z㡫?jk[0}FW@U0WgS2cFF|2`85SbG?e?q7#pjڥ|ɨ\0YO|aV3EFW^@l24K<\\/#\Zjp!CBڋTLX6jy\Z\nё4W\\\ZTM\\VdEබ|@])2ԕiqj\'Vp,KzMr#6hq	:@߮\r0lҞ6jZmc-kYxJ5_*]O\\sM\nT27oڠCg`c˰mupa\\|/Jy2fy2qt@WkmxGV͒׵pzk訍n!>x\\h|,e0?s4n,Lmu\Z^΅hU}1}=ziy\'\'|KW?[r(\r\Z3zػfW^P1Y2&ۑpAU%fG<+HH4ywy\'hzx\"v\\p$bo)cHvSn_(aWcʹA`kBʜѮ,2S^úD\Zѣ0?ޖft&!-U8<Gz<3\0R-k,u׼)\0\nk?R0}<̤. $^$mw޻`.A_[rE]J#+ߘ4D,EǡGfy5ܟ@nN	36M[yFRDm:m\\,T3y?PԈ+oKqraUWjj:MSC\0EpڎU=\\ف2%72B99k\r?rqQe-=Ozγ2z!.w\ZFPASӃPlZN!&Qw|c;\0,2aڢUPrYo:W3\"6uxhSئ3)]TCˎ1B\"$Ϥ_Y[^e\n41LHݩ̨<W`e	U&zտRB=PKqFu~\Z8W2\0	e`hp,-n};F \Z/q@Q!Xw>7.l8leQ,	naTߌCӀ#YU\"V1	]98}.@\rf[ɖ&1^g+fV`6)	5ESjrKuj%pA9Xc<_:l#(ǀv)ɣ,ĹvV-nzWE2DH!~\\ꩠFgJ\Zop\']Mi@P;VKiV(~n&^VTSn^Ey	u\0ci^Su%D{ox\\4\'10pG&oAMq5@= PxN^+5H9_r?MΩԴY5D`$BfyISWq؛rcW\nŒ+NA΢:W<\'dSB4,hܟ+{̗r~aAďcKAjTG/6\n]<E&@Ƿ(\0a{|,@haZݻN/F]\0cOJhÙLC	8׫hl2\"i\r2ӣ-୏XC +Ra,f6!\\I&C#2M8_6wsEUP[Wґ4L{4\ZUuw\'瞟hQi5z\r&Ђ`~\'\rQl;4ec1b0w~{wcj|m]a_d4N^\\~ʘ7q/\"]$&<Լ	QY)\ri\0\"4ߕml\"WKxI0$\r!L7K3@\"[q˯v1 K&.D,p	ڱ4zή)F\r8xNz$wFm$\"]Xe\"?|2Y	Ōt-	ࣟvTը2H`oHPOnuDpRֽRnOk2Ω@7 \'yUٙK;@I:7}.a	̑HMϩ:	qFCOc#y\r<եl4֬(w	]5Fn?`b8)k(S;wAq^;Tι[cJD_=$xB2냙$5)SjrxVIR-[ҟ1.;\"=1(C]e(d-|5QCv,?adkVlEWR*9)7mvXbڷ\'p	Z9@S\r0,t`2plsW)08aIpopABH7M) JOb\0!X+c͎Ǯԑ8@Ghar6rVB:\' 4-I9#\"iݔ[-l+\'2YU~nZcttMh?Dm%ʋd]\Z	MصB\Zr/O5%N̶\Z\nŬWOO,ԺNE\Z\r7hZBLG+vSd2\Zi\r/quVcx-ll8\ZÚZþި6W2lI96G\ZBXf\"ԭOݠ%K3ѓ93h\Z42o^iw$Se(I}P((\ZTcς6[LBcl\rxR()a?\Z[Iʙ`:}V\ZTDn+/`{\Z^\\%kOei:io\ZqRT=\0,\ZXD픚\ZhK8h\Zxy7{ zQ1+5:#Mu<\Zdhƨ,ȊaܑiK#A\ZtY-{RV ۷FR!%8`?O\ZIa^iJH:j:b\Z;4JpRӗڎXV\\2p&\n\ZmҴ`S|0	SsEAL\Z䜫:H2fם[Jm<x<0\Z7۴>0XϘ\ZKGUm0;A򳡆-vn\0]І{lCMvɾ@ƑT97C=yZ3Ήc3m!pr&,Y*l}Jpx5K5&\0CRdR5P,BiQf7Ꜯ&\'dWzғ|1Ɏz\"z|seQgJЭz-X+|@Vcx瘝s|0 )8m}.\rd_n5i?W):\\`^V=w=\"[<U܀ĵ9YCW-GMdz[gbꤼ&{737ki֐5є3N0P5y}@٪b1po4A{/\"ru0yLi(H\'v-3*3^c(^U#gphz{:7bc/LV9bar~D,?ѠGd)FAu``ڿoۭraچc,=sK>Pסe)9RB[|-s1ʎSPEGI45MCgY<-bO,w[6eJG7U]\\J5\\N(-\rX_j\r15-Q_Y\ng^ʸ\"|.Y|bO-b$t+8jK׹\ZX#[wwq51DjLH^t+?\Zci{íq@:[bdl9ր,ܱMS,elNr}6n\0O!\"j:(!b*C\rz\"{t\r =I)^sb\ZZ\nS\raL& v3+kCJI\Z<\0P>%@5v%( JaI\\ѓHO\'\n(Pӳ\nr	sJbmLh笇[\'{0luʒhkFNʨ\n,U|록X5)aTԩ %2Ryūi*%h%$)`v:#f.xd\n:xA-H>Jy;<I8w2A	ڸ؞02yK|_%d`29xmlQW薕U=dZ	ʒcWZ:wP{6Ly?طcI\n߾B2ߵzՠevz3ƘU{^qa%IBЛW<VA=lL^<kLsjҥ?bɖȒ|B?-(+xd6SPIjҗ:K-`UMun֧]BeIY\rf6y;6\r),P 6;\'6\" ds\r=V\"n*R-!`CG֋م\"^e\n|5.ް8!9:%\'&;CrAL*3q8$\"n$Foef$S4C\0}UJ5}&JmyNL5\r\Z0s3u6!$0KJ\r22ߖ]Ó\'L\0IMq2˪㏽\Z燧i(o)NޢVB nLc\rʿ52BG3u*0oBǯh }CoG}BdgD؉$O<L#1OF14.+kc*9\'q.;FrP\'l1e^>b6chNE4#\\GYZ>AQb&YZo>Qr͡i9\0T9\\>$2ݲjrwhqMTUЩw͙CHN\0I<.OƏͧfh_2E_T.ZuiYk.\\{g:FhdaGI\0q׹a\Z}*3yXZjoy\\oCw=usn@=]N1%P0.\"pTӜq(%7NO2\"hkUvr޴\'r-AD^EcZWq85qr@7VRۘ]7NijR\"~RO|⺥f`S:\rb-\\|ۃ9Egf]Hh~wwO\0LhD:m	3(TN,jpJ̺γSy9s68rMڠc4boT,>\n?j/&b\"\n<5.Bzn1YY]}{6^\roʠaXܖ^	捄s0ɻsy01)fx X`[Z76.-*PU-8m@e05\\wMv1.ʞRfq\"^hS;X~YY^ϻjcTxFw7?D?Fa\0-@h1+K(a]DR:[_I3ywtן#F3=22I8JpL]]}0nP\rQcJYB=niQ=NeձunS,hX:_U-JrS5btLȒ|n 4\0ْ\'/XMK,f\"*Z$4 %-b#6u|Ė}bJs6 .,2F*z&@;`x^#.W(` :kYMjxRցִP=T_U~Q Hʱy4BW@c\\JqGC WaQxD2-q%ol(]?A kuPt̊z\"qg=(0 l\n°&|\"wK~30,>P&w \'Ơ $nX37N<g YL&> G\Zu%X-) )>Q|	]vC, 7ćK4sNs	Q<s| \n	\Z?`%Tp6#IRlR ӌ[*ktC`x{c!ՙ\ZVWSst @W4n*tQ`EJ))e%C!Bw픴Q\r\Z-1O!Tvα!)u^)h\rȱ>uOK,hc$!,els\\055.fOte}!5AR/{CaF9Z_t%8,=۫!ZmNxI>W>%*r^#\\QD!]ͯ%uOb;Ͱ(2[\n_!i\\ ׌eQ\0rz.+;\0\Z)o53!\'o]tJ:soT!x6^q>F70VֵV>>!$1ŭ95\n2d\\aW\Zq3x!:qɴ&gz68֛d;tV;U!&x[w)ȃcNSa!>$wĜF\n%`IJM6o(!bFމg2oi\nNl+\nb!5Aà~I \\v(cF!(\'eЎ\r804@dD4KSkV!aZU/<rg$R4gZ0l!\r;m1ϼ.{r6@CHc^\"A!ĩtXQ\"ђm]2J\"TYKJ,/\\/ d\"h>:Q sikZ؝Ew}b\":+@b$TAt6r\":fnJ\"-vSX^\rˠ#\"JRIx9Wn\"aԙ\"L0]ӆ٥y)UeP^A\"S.87~96syjr\']s\0\"\\&S^\rxQf\"nNv?Kg^:mBlbZ\"$l}eX\\%\'AJ\"	.F͢Y\\gFy2\n\rMZ\"G$@PĹ\Z7~ԧOƦpdb\"):ze0E8=!7Ӻl<ZP\"/JK}uvaHQLE\"!zFۺ6&\ns|\"ʊǏ5\".Mp-zx)R.%.8\"،V2M.\\e#Nȡ>.:I\"_rЏMDZNa\"Lp6-@!#^kYڮXVFX65\"=\rB>\"H@Z#XVWΫ\"80#>nylvƩrK~8\";z`~g^_R5т(#ğ_ܵ?W/C+UKG#2s\'|x,q´ޣ\\\"\\*dq#Lj@P\\Eȼnx$Wҫr1پ6}#2;#/7\n QrsE&]IeYcg#Oyw;pӿzw,!:;umj)#SRm-zşQ\r: QV#fl~FcAmĽb\rV֯qP9iϯ#fW*o_\nU8_\r֣z#mbTɸ=V187>#_Ӂs(sxa{ۍ{A-##̨wA/c[&Ge\Zx%%=C[a#gCY<bIV?Ji^aUB#yĽTf<,9z,;P#ә>ho/>,Fm@`0#g#\06|РYD̰أwty#M+B*TvGǒ?oLJs#BoKmuqGKL5=O#V}驛F\'y#v	׼\"Ù6GJ#]=0\n\rĞ^\'<$_-\'8uPc6#	KEum$\rܷ2ݓϼ+BɡQ(-$F:6~QQ\':3~U$#\'b}$X:cľm]\"V$2	J8+n\nbO+92q$?\ZW7m(w{K\\۶׮jt$Cr{3;Ln,uw`7pE$Il;_W\Zd۩Έ\0fm$XA883k.b4DZ쥽$^W+NN	һ@yA$G+Z[($h/*ÅZOx+-롖HةTE$j^2	ܽ4`QQtyTr\'$l۵	ns}Z?|:$V&<% 旅.l㹯$E,_wMJI:W~$`5~VWClZ	|GN$۱lЯsF,ųeIx\Z:>;3$]:)~KF,B4w٨/c,H$ԑ<*Y+`p_/Ȟ)Od$`MHn#<K*\re%%klf;{݅T_<{x%[4d%S3BG\n9K\"Ufq*Aj5\'ϱ%Yy\Z@ڤ~&Ǩ1#2Qi׮%nMǮiD7@qV#vE>TCdW%v+4)%Oi+adgF2!T+%kr _SpE3%f3qEb<r]B[S@k1\'b%>fXJ&Ж>Zy2p#%07s\0\'zM|:9#h7dJa6!\\%ƲaU>ZZ	YD^@NN%%8X_Ҳ%$9ٔ*_[%܉`nTKxCt&Xy&̷-;בuH\\s!5\0&\nuOb&\"Mf?+AT(M&pj+Ҋ%s<\\$&am{[>Bv\\` :nwc)ߗ%Z0&|O	g)2*׫7o-r?&[on laϳtWLQOQc&ٖ`#tޙ,Q)D9&t*2~|1/U8VY}$&m4tXF@RʏbL&ӥYk\Zn߰XOڱhb)&!G!CoFQ`BQ\'l_JVSu8VHJyC\'DĂD1`گ/5)F1\'+F.}M>W\nwJ]}&#V\n\'(\0*Pg\Z$\"PHG!5jN\'@?B{uBti\'S?\n=PC\'F.1E)H;l/.n7|W*\'GLs\r+QN*+r;_1Y\'S{<?*f;/{\'v\'k7^Y6֨{J/՚ɺdN\'Q_+g*drVǠ\'*\'$1,;bL(˓̰O\rMgд\'iZ\"Ʈf=DFG\n_B>qY޴\'*ǋw)M>SY\nS4vna\'9_eZhZVa釦vu[*S\'N9rg_TȻkBy\'q&1,SNj64cG&Z_3j\'^5j%Vl{={m@\'m/lr8*l	=$枒=h79a\'j*,A.+-Tגּ*\'ٍNf[Og|\Z	+\'xrXk.~b5ǟ<M(:MQ =ߪyyLޢ(Cd?hvҺn*1ZV(=XtwɬD.=H\ZS\Z5w(?߾nT Z𦆽\\98vW\Z(E\0	73/>u0AH*$\\(\\ðw0#rF߼٥^GAcw,t(a8)~%cG:~\\\0p#tF?(fp\\3{?\"];>WqB5mo(nssTj+<$|rE~(y:wj51\Z!`<!_(wye\r63TQ-YT=G(Θ\\n lpuꑝ&]yiJ)(fqiIp,K(íļ\rC	vSKO]l]t(m}:փ{Fi\r~^`@2$(ڮwS4Blq`8zW:5HI)z4phziTv/԰x)!/PdtO;DCᤉ7P5)%^Vt_\"L&x?.Ҫ*|2OQ)JJQ%x\Z	r](R`)N\\nmE\ZkcQ(a)QF޶cBWk!)Z!YٍPA;]n)aQOhС/zàS\06`)}VOg-w/^w6!E~5On)!eФR݀zgg6эl[{)Q1٪p$2˝n#[z*/	*?|)X.\rjcT[q1ǿ]M:*&Sƽt0*%ҹ-m\\(<`}yx	[l* jY6XAS͐\0t_B*0?\rYoXd	:@MFI)*N骱wju\r3*P|˿(WaOBAe:+*RNڔ%>+߮6n^wj98*en|ӗQDU[M!B\ZX2Ugy*j4m3:P0\0\0O9`*k /YlI>CK:xAn6[*mҰǕ(ySlSXL	3QnT*YD>)k\'YO+j*UY2F*(9͌v&5d2|ќo<v8*nTHSaQpGegz*.C)iXF89ю,*jlJ[ĸدiu*_	*wVS1Y\';n_b6+%<hat>++BPxP\'\"XpThw\"e+(Oi~.I%ƥ?\"~Y之boQ\\Y+I* \"2:Gflp=+^Hu߲֨nTZ7+kd\Z\'ȍ,GwwqN+ZP2lv,,2RV~I+Zr\\azk̧αk+ Wqz\"[נ˽_{,\rNMd_z_T3$7Xc.5AX,XمWvY9bԁ\'7 }\n,#|xIh܈G:`3{_^c,m\ZrbJ|&\\\"C8)O},~8׿K3k.FP?R()ojrt,1^7\rx6$\'.SWF,lTѕ%P~Ȝxq\r޶f,gE^\"5¸6FO,ڀ1f,Ms]B#^X=d`,ԀJ`j0A\n*LzG,iS~?:5^:b\\BGQoz!bvE|,㯢/z]_Wpd.f-7bkٚA53gFEk|^ڒn^)-#;ŹDoIYMAu-4akO67ZޡR)&~	-;i\\3.\'=Ϗrs\'1\0<-FP9Nf ;hl4E-HP{cܻ:n{2sZq:7A)l-ӌl^.ԫ;	><;nC\\-ת1:c&h	ֳ4VF-,h8faPjgW>q\\q0-kyn:Q2 ?x-vw\\yU+.$aWݕ2.F-{=mMzʶKzgR*(.(2GKzj\",55+%{	W.~\rB|\\}:tJsfZ.%%،kɐTaEQdu8ٍ~3.)y\ZJ\n*Fh,TTuԃ N.KnG\'z=_ĨK\nO`r9.d-vۺŒ#u7)ғ{.{fZ%{34`zo<\":qe5Ab..I)6Zn)\"6\Z]\r3CFZW.Bx~Cd\r(olv+k\n.SP*6;]XRCɆ\regf.:%q/}!*:r\Z^E/uC;,!0AA+Cǟg23/ssZ*j)iбeQ3>s</^W)H\\y=Z3%1q^QdaH/&dxG:IVt͆YjM?R\"/#ׄז4$ǽ~r>-h%8X/,b2H=XӲ\0DNb1/.٘ÇKv\\)wS/70/!BsݒoBͻe}y^/>wi`S{oF:i8/M4H&ol=|@uQD}Wp/_9^`5JҼ,YajKEl/v \'I5R/^\nBR701nQ=*Q/|w΅jRzZHcxS Jb͌/YlezIGzzss=\\}/ԣZg\0cVץvdZ/	43sx|\"@-8,^F/GO%<\"!5Ĩ`0<hCJ/\0NKoʩۭ詡{ngg/|`zZ\0^\n͎#0\"\0@/XŃY]IO/)˲jtS+KUVSx\\/?<@qv4?rcm5/FA@TZ5a )LOfWRl!\"t/JtR8֓9HdFأ80!Q+7`G#\r)S<\Z{b0C?Bk\0\'́<ג+F/&\ZC0o7Ԃ؝^\ZtU:+0COܢ6YyK8<GTJ0)5iKejՈT|F$4t0F6^ʤp	,wR}nlDoYDȌ\Z0J;;Qx*,Uľ<g_;o-H0X!ލ\nB\"`Á6D KP?_0X73S;\03m&)$K>7wtT\"0[nڕrwe&E_JC䒈0iG/+UW3Ii\r·8صS 80sa`\"*m(|-=9ƄA@0(<~U-t.&]%/w1Ro0Q9\'j\rpWCmg0bu+<0Sb]^Dd0gк}bIYwe.G0pʊR^=Yo(a*7`0,d9ɘG\n6P$JC97,nH0qeR1:\'QDuhVwχ0\rXyq\\d]jŉ: +R(7Η0?@\nQƟq0	2zRo@0YiѾc1ˁ\Z[^r0\rHCx^\n#QY4NX1!3Q*\nX}(bz=./1&ZV0c;dClξP`c1/pJVQ2v앀]L9e?4J15V^,gK|#0Idlo1E(|TVc-N¿-~zn}.1\\^8.ljЅ4x]|1]T2J\\+	i6SvS,E1e䅁8oNT:w8<:1h\n@ސEA:\"H98GE1u\'Y	/%\0B\01-#$p&h5hJm9m.17H}htqEu6x]1SP^&! !\r\nO6\'R 6a\n-1H\"gyц*&\Zb&fK1_X#/I*DN|qx ]\n\\t1f@g<g-vIP8ၳ16s4>gHTs*NVB1\n	Tk5t{j.\ZB5$V{26?ô%I8#AaW=ҀVONhE2AWB]b}cޏB#2BQb9L\'͛BBT2DlyO_!DFjF^=-vQ\"T2v2Hs|k-D`]^9c,2SLb{Xsǅ*@)Q2vziM%\\Xt#$e*2{yC$%BE;4>f&b=r2})vD$t2.P엳2AG8Q2ӆJJ/CC7N֍׌\rji2MmQf!=s*2\"!-2ؗČ_g[)@23>,.2ٹ<dI=@M8>4c!^i N3fKfY8~Dh_驪%*&zF0-3(J{*\r[ܽ}W33)\"K\\,h+\\\")`/W339DkNd\rF$O2>acc;S3E!ރXO+)\r^gPǁJ3Oj}.j	^W/Q(ϿиhBC3Z:2$FyP7bء: yM3r=	aԅ6~1t}k3i刍Z++<A&n?%3J~wUV.gD%ޠ.P	<Q37H00ԭ*:>a_r`g3լKYCX-kg9[۳҄4P\Z+KibEWВq`r\nQL4\r(HO_)yJwL4K\0$|%ܰ^qB۱&K4,jE6@9&YPd4-;*B_|TB !\'o\nQn4We.e>uɑyVc@4gѓ7G>\\JZl24H}AC{Hh/}sfY4%C]q@m7kDW*_4]]@w:yٺX)%ǀ[btbsm/94%_^^[2ɝis.Ǫ-4ˁY2˽5Mf՞v2,.\\~4\Zr}McP\\GϢl8E5c[/8>8g1ZnBȥgx5IwNezվEs-M$g$5#_D؞;}6]&]&ig>W5$;/mkz 𙠓pA5*¨Po;,XȋyE[~5B`DSx|4q|ҭ^]5YY+W4~:j/:ّ,j5ox~,\ZF<H5ͱhYI&BiUI?ґ5	XxtB\Z}OL=\r6I5f`dP&r:]ﰻӏzW#[5`Hֺ>R5EOI6,:}u4!Z{Њw1&v1Ư?N@6=G!J|Gl̣8(xH,Q66G\rkH:\r,6Yէjh=Q$rFa6XW\r2Ya\nND;3>?)?V6k>׺	QHa[ב]{9F6tY~\'IY+65}jghy:6RPJÒ2]bD\r\0JnRiZ6}o\ZSuS4̀n\rh6\\楅Tb{)p2u,օɥ!wlb6ɕIңMka_G#1m6ռ|d5l¼g40\'B`V6\\\ntÝ\0`6͋&)nek\"Sh7ISXeiNn&役day7\n@3l,UlL԰XfRuDYRsm7MI.-*\r7ȧ\\ݱє@bdx?7)J2,\"\ZV#b{7\Z>Q;~ogYF7]UP*2Ҫ#bV EXj7b18!U=ɀm{YQ7m0 䞤3ţK7\nFg0bݕW 7nvhXd\"͉Jڈ7qp.}a\r`7nsB}@Ӆv7|\n636#6I? 7}>`J+iV]67ق\ZE.E{(YKhd`zk7IcH<==\"F)\0[!X\\7#q$TT)Foe\'&?Prj%o7@lDIR*)UҵR&\0e7|&,SWĦl~e|T5o8\0xq rgk*\"@TCRZ=f8K*}\"}uaک}#V^}^g8Kǖڴ\"-??,[{/Ou|Ep8`ѰMU8?i$\"O{8o0;ৗPj둪9I(hm~8~/S#WUD~c9uuTv8ړ1b;0eR juU``is92gK:raW;\'ӎ19fG3Csw[<h\\Ê;;OA(Ks9>|yɮ,naS>\\S9I<Ra~Te8JG,d[Js29P6ATa~R,~F\r։+o)\Za0p9PŠ`8_K#,lSVd*6T3-`~9T-Hȏ :91S\\\rb?FC9Wm\Z XQ?uM\0Gu7nO9e9Dg2[Oe-DqTnoK-9f`Ewo{)Q1W<ɋ9pmRzmAq*Z3V\n-91Yz=&3.T QA[$ɤZq97TBR#[\rO:K)X95V]*sꈻjq7˨39æ%!bdV@O GaM㾨\n{d9n~AbHcx;Bo>1<9J|UA6@)Y>$Uٚ駥6b\"9~%q2^JD3]Z4qT9]6z*6ujL\0<)+\09$2!躏uΙ)\0Я9qBYaهsdyPù(Cl;]%:Z?SjMa\0yJc/E#8s:\n1.V\\dS=\"E,vv0|:$Uy\Z\n*+ž+cy533e3:i\"R\"w`RIXL͖7ۉY:k6ZJWj?vA^a-YE8.,%:k\n<(Q -gvv]蚢ieUN:O3֛KiD--*3K/:j\'}!}DD%X6D:\'\Z?D-Sp\'Lo\"u`p:y8{#տm6mz6Y(9:me0i7Y,<Yވ-|:d eU&\0WC}>a4:_ll|S\nv\"2$r):i=\ZYeu)m냭}s?:\n[vg%Gpa?>m_k5:U#?_jL2S2UH^;R^y]%a3_);te;JE]Nj.1*EgWM;Wͭ%H)w<~D|7V<J;dߩ,Zz^uXј8}l$Y;glSɹ\0G,i8M\0;zmpKm\0\']s\Z)MR!\\U<;\r\0osoB>Ô]ucrբT;\Zm}gO_t%nȅۯw?;0NU-\n$ΡJ;чQZ[h^2u*;7DnRWN4@Js`I;Pֺv}MZֵ&V<JS;ϟj\\%zv}d83e_;@_M-Յ,(gBC\'4/;]A(1x&̮^l_k8c<F࠴\0D;PwQtsρ<5ꩺպv\"Șڪ<:G&D]ԃE3 	uݜt< `2!l~sDU=TR@I<!{]wfְz=~SA>nJ<\'<\'[Oe0Րu!X	g<7SdT	{~}&(94Y_S#+T\Z<?ni6~ϊzӭDzm\'={?63T<m2[gC|0ڌ<q#;&p6fĂ^8+:H<x:wLdd|G%N=s<\0͐$5ŵǙ![G7]5+<H.<1zff:/|5F\"<^}<P,vuSk53lD TZ~O<.xnEej?\'o2\Zh<:-Rr{<ԫ!q2{Q:΅2U?=A@5Ӿ;\"vkkaϛa⵴.kgE=%x,\'}<*puXpsH#r=Mbg`<CX6.4x§{=Qsf#1\"C+3b5|<PC=]m\'OP0;&x\"Φe=ڹ\\0$[#b=$H3f4DVrj!?=.	ە &IgCq[OS=dtz\\IgN\nd%?8e%`s2I>\"8*S@-bH\"aiEx>\"eY-:037,jO>rf	/lٸ$\ny+b+0ZH0wbVǝ>@ZHӐǓ9)W|9^~>	tN}%7 6>Ў<g\\^_9K:>PTϻ7r`K˒#F>EoG0W^ڭ>&in\0Y9>xf?)SvRKZnR>ԹW^;a*qoic>G+GY/Cꕻ܀6r&?O>uz/Aǚ	n5E-IGUh߳?	]M.nb4sT+H?ڟ>!dE_5;$~$&Ơ\r?) wYxmN#\"( 0wiIٹ2i?!a0?+m!ZuC<:>Gq?\'Ѐ|8i{_z_)-2=wmowС?,guV-Ub<eAǩKN?3ͳD[qJŎg*hY?5K϶jB *DP?4^?>ec2uu?H\'SD><56̧5c#_{8cf?QOxR\"&Z-Cj\r?_6b%㻧֪KxLb͟?h]0\0	BLJ?\r۴<~S1.QEm?YꝤ;ܮS{Bv,J{9?W^z\0Y*`\\P+-Z lo@$yZΤT+Ifؒc#pC@vPo4OuY7jѤ@s\'b N9E=оS0V{K@kX$ΩPB	=PS@*5]Gր3)A{Aq@:xcÆPVqt(*@CARA5P}%bI^C3@Lo֟Gj_x0`8C{p@`@Z=sX/$Xv\0uy8=7@^<۬\'=fn+~w;\0@`7ZǛbvP2t@hlqҀ@qbjuO ;x\Z{%y	*]@vKިk%~|``<5P.@|INAY:_I⡤a*)gF@~bR鏒Z^g4t\\E[]x.@ll4w2lq3P\"@F3\\;e0ہNQP\Z@;ExS\r=KA-py@@ɦ =Kwٸ\rk)\\Xsʑ] ܈@Q4PlN،F!KA$0jg\03dhfGTG)̷!A92!Z9^v*\0D8\Z=Qy\ZAbAv{/Gg^6~F\nĖSA	Az#RH[`Y|Җ\rxҬA5Nkj(W{l9XIk.Q\"#Ac76QN^\"Bz͍NA2,0F\rv<qb9&ǰs&/AZ%6PÙH[h\n@ <A/eʣP3sEbz%xK#TAjڱ]Uf89byFvw1$eAN~mDD*W \ne\Z^Dhu]A@z$zYumpܔ^6/bA8OвOzyK\Zt\\Aiߤ^fW͊ßv#\ZgaA)6.k#a\rUAe[	v̛3kg\n\"݌Atx</YD:=o	uB\07r\n75HτK~+DBoB5}\r}dT/ШȐ؎,BBI\\ccx|c\rwHN,4?B&JP:olG|P:q_p!~B*/zn-TfYzO|EVBF$b$.-zFneM*/|BV\n,O{Ƃ9Ң,BMZrDgKZy{!dVB<=P\'\rl5hhH@Cp32ɭvCcBR*8ŘT/]s.9T(BۥD~ǖܬB>\\_EqlOxy\naB\nġ?}VxqAaIwA\'6BIq0q\Z* Z>%C!lC6m菛ml 2}$\\A/C>0,c\0Jvy욓(T݄ICN6Z:cz15(Es{(MCnUc]L]Ģ6C1rCt[P9o&іcvCǡb;C]U:3<v=\r\\G)Cvm9)wlNd?>oC4)iǌ<1u\"CO5XW	NJ6C]ת.7fbʹo	$LpDC3(`e#b3Տ~;o4TCjU#HL\\Y%\"rS{tʪCܽ=#\\4C.f>)!\"gkCyԊJDoHy$+|C9~f~&%{	7ȡ[{aOyDg9ե+ww\'YJED2Pwr8IeW})sn\0D?j^*{2	Wc| ]ytDC\\N\ZK`ao2LJSw5:LTDHoBT\"/T[hN;*wo^DLSggݨ?猑ϞY1ћ hDk52o+פI0Dp\"bPmEN}^[:qfDTE)$Gets̮E\nD\"KꖌT+qr9tJv!!D%}ImF2=(\'+AXD\"e9VIm425CAP%_DƎ6SxhjﰌG]ii_DU;F=dZK/h-$X#D\0wVvRwo~MRDTX6_8T&\ZUc\Z~@Q3gTDz\nr#o8]q˩8gwD\nDKbu4iQ\':-!:	2Wi\\DN-I00?4zf<HnE(ڏK\"y69=a1c30mE*h5|y;f\rka퓤~NrE08L}qe%vB|:hwE73~K\027r\"U%-_:E:kfdtps*H@+I35_\Zr3EG-=|6W +xA0Icq_+EJVU2b7jMy8]nF}Z?4E`f;u\'wI$0Vo0H3]E}ZnՍ.G{$X(jyqo=E6x7nojah.e5E\'%Xm-QsĊKebbXpbE-8\nuT/§Ώixr& 3EQd8LܮŹ@#]sEЈ\ZT׵$;QE!!ͥ)r;n6EkS1$`^F ͥZZ(5JCk\"|dwqFkfSGK#:ݒmSk%FhޙHmkܲ=FwسY=!B\rJ9F!	P\r\'w:(Q\n=jlhjF+\"2|+FUÊ;YIፔ}f}|FCA>=h1XJWDX4\"=TXFVїa6yp\'3]\',F}&w=4qu\ZX?F{WB!F{KP:igF\\Z	(\0GpFy3n#;FR<`=#izAgDd)qFzgsf7BXзIwEFtv\Z:;`jʠBG^ЗαtGe)\\GnU>)_\Z1d/ڝ2>\ZJG\'AQhMVvS(Gl^~@yGB#(>+:Ծ\Zh/TGI}?\Z)[>\"n`CcfG]˽{0nّ)mwhnmTC&G^P[ְa+䂓݈mg ?Gsq\"qk,&u{ni>mGs}꣩~V/	ݭ[:Y\\Gt_!HXЫwcqe6>TkG~x%퍾˳>)d(\ZBNJ!G+8vͮ1g*=^5V逅\n\'G@PȃU! 91XYMQe \0׍`G?}o>UΌ5O*q&+v3\ZRmh@Ggr8,Bc]u_a\r̊;~GW\r\ZG$7iD>b^Ϯ4GĳYqU鄦l\"	,]fC\"sG\'Y75Tjd5:X}{GH{p<ZtMh`KALGc`B+91l%S;8B!G:}\\\r#}guHAf%1h*#\ZUEUh>B=rHp\r\0VQ]%<	&si\Z[HHeQe	=:2sO8OrȜŖH,o1@O>㍕R{5keH69ß$K&kѕ\0y}H9mPȥ\"Tթ/5{!#^HB]=|\rUJ¢ Iwj ~HN>+fVQщ2^H`kfNLh`o[agvEHaYB3GDۊY|_]H{8;sP%;q9\\}IWH٤]ê\0{/| odlJ/1HQ0z/t$ځ7)IH {\"!b(ArD]R;HJ` tHV{H5\"wqnG8xCZ(\07H3:Bk[e<KRT6uLbhI10%V`ޮfa8~(I;BSGlDkl,\0)IGQp5u\0c{}A>INE篏j4G\Z\Z}CJCIZ4ֻ{җ7taxВH1Iy\r|qSA*	}HPI|07ane;\\UI>ٽ^iliA$UM>l)$iIg-ӮP?{uORRr%~I?R`#C\'\'\"\\j\0aR_I3d7Z4U!VR\"߆Kod(IBqM 5{s6 liY,ɦde\reUI?5jn7+#IkScJR2_s{\n/vgLi:%JeN2\0Y by_BQJ(|\"Dw@΢w;`SE\']J0^iN餸yLms{(J;?[(*Q{84ᅶAfU5f;JWejJAU]1^s?Z\0JX#jwӚYUZ+v*+J]Ơ<SMvidz>অ&<dCJj;K;s\\2~4J~=;녞#	\"K\ZE+13J3AZ[;` 3˦oJ4+`b	\0Yy6WqDÅJ Vsf^0G\\JYF >%PMF?iOJ	p5vv8( Jbjb4Djw*4鱋p-:Vx@~JN@`P)@-8YX-JߏƁ}0.pe	G^~QyJ$E!\Z\"wONЇ^mJP#d	T먎=v*Qftz\nKI1Z.|=3S0\r8]+K3SxFHnZDa۳ws)*xK;PasznZ*dWđj]rKPF1)o47@VOfU5gKa;׾$(Ui{iN)hi\'T͌Y01KbC\ritꅣ\r?\Z6Ke]o?>M3<XKxd]p씟6r7q7nhXJ!KԴˑkHVAZ!ښ\\Khtâªx\0,\nywKzͼ3cޖ22?C@b_LKOEnAF>ڒd3\Z_0D)\'K\naڄh)Ĉ#巆BP$;L$QA\Z3oT֟xp\\Ci5L&z֏ͭ+	*&X&R&eLE\'JnE@lr!3Άv\rLOHTcK6.e;]Aes˿SFLS#Vo8ki.e\"kߦpLz7\ZUۼx{UW?EQK0\Z`hlL(pyp]&8,\"6$cM׳Z}uLf6=([х`#7~(aLO<e7j};h&K9< L&}Pܛ|b31ԁγLC해1%PǭVq{{r\"H.QLvQ4xA>krk-\0L:}%,\\}~8\\Oa8DsXLܨ\\H=c\ZIpbxn5IL*~ΠExI<\'ULhk_fBL]E;B/y/k]r\"< H$LRHxsq5]Mf9M\nA\'J@cVM|)=5c[!M\0(@hF(¨o\ZBFA\rw7M±MC-8V]\"?F/лMVsh$Cڝr+Bw&u&kMk_!:óa#\\	^1M997V%lz[B6\nqʕMY~q_$19w`\ZM[i%MAD.l.\Zn pTtMyL;-ڛ%Iu\\K|,̞f] M;*jh\04\'u\r_`t\"O͝4MĮ.4jW[a`A>?6eXMq\0q.2ݾA/^G/QtrMӬP=ȍM>lwov\0M~Yk@L\"#\"/;cvj~\0dMϸ\ZP\\x\09F\'?Շ=MSp}T.!$|N\\YNݝEh\Z,P.gKN9]`T*L)w\0+Ã-r]NA;ַo5906lÆlyzNL2hګF$H[=NR2\rQ${)NU{Wkz\\mlf#7N`?g\Z؂ˀzrze=s%>Np.j샣f7F,D2٭:2+,Nzҡr9;,=䗈dGyNȩx=.ےGnca(N\"?XhLf?e!#+ov`nN:Ǝ>%,7	g`ez,NvޏLTgwR\\Gh,Ne>h@J|jlŷp>UЏNj$-GE)&J4GꝝTNkӲG\':2]F+NYGDbi\\iRL<&\'?<U3XNWNlN4~ J&R\\xd׾tR_ O	Y@9P->5Uw\n\'ORkg)eFèl,@O٨|e]|mK~Fӂː;J\"O({\\ǨU^D%!䶣XXJO:XZ%M;	;?՗l%OCdo^r?Ӳd8&VOGޣY8+]^wtX]ݯs6QzOV/~Z<)r!h=X4XOeIVi\\q<:mWDlK̈́\'BIOpb6<Fϻi䲯Hp\082C*Oe/<H}	JtJ3KO%zwvW8XF]lUOg6r\r\npHַ̐|OAR`qL?׬O3vv\0Uow\0KOW\Z9aq(:3+*+m;O~xwU.]bfW`hW\\ܭmP\nkH6w#rv{0=頻\0i.PzZboBL]+n@$G*QhtP\nO#~# |F:Q>݄GPkSZz0DϫI,1h]jP=q\"\\&4o0iPB1Bʍ8aSh@<^!|\nPBH<}FJg=rvqPD+ˢRƆ5BhX]lWP_M4WM$\r]\n]|a*Pk:ESv\ZLa\"i\0SO2s=P~ؤX7LG0QdkL;}PV\nB^~Uh yr.F>6pNPps%\\* #Q=QCg8P1mK=Y4$	r֨\r(|/g˥$Pj\n\nhbZW>}noFb*RPĽ7_cZs82F%\ZFJ:7PP*HƲB?BnƤ1K ]sgP3JFÑm\0[l%$\rPK&O5\'RTˢ\"Lr<ϑ6P,\\Z` !s3PWJ\0w~\ry!R\Z[BE&@$\rPO\r\0݉U}$a)S~\'A\\KP%?kN&{(bG!㝨Q\rLd^!DG4gt׵ʚH\"QAYZbDeO0{Y0XvQ&g듣aI\Z5Ec&#M/Q8.f\Z`>z;+8$3Q>+]6\'Gq*r-UZ\\>#)MQJrZ#6\Zd&!;]sZ\ne7 QKP;XӦ_f)ӊC?*Qj4b$V7UM|RbBthQtAFB;<b|OPtgyWZQМhEcN0G	7=m0;]Q]Bἃr4?N&uZsQ^QJC}fL[`%%˚ſbiGQzzu}Ϙտ>g&98QH\'<~dhçr$uí0Q!tL7	\n,N{Nw9Q[#Tӯ`0QԎRIQN\\smGi&!0\'2QT\Z\"sԭZ\'@>=;FsP[Qˮ5w=Cz?\r.h+p\rW4UF0Q~uRkH%6tuY09|*/R|75I|f(j\0R(߳\\ߥH3U=NKRe{(TFQA	ǴNRr2+P;ʅr{\0L]ۇv+Ru8ip=J]wBRͪ՛2$!F~eH`URោa:hxE	gkA	+S֠ǃnDJH0h@ہ*Nt`JStBmۄ4t\\N9H6ÑSBdqRV+?򎻯0SKIr)},2xqj6+iDS^[m_,Y%q[GD=oS_RvFF5߳7s\"O\'GSh`.!1eUG19rj<b4$US,o5ȋ\0\'Yb-XjQ(,FS-yq./v5At*S1VDFET4fہNS\n@Gf_`IFaQm]-<S||I2!Vi趦AS̏[;cC\ZE4?6T	y^\n\\ew\ZKWrNe/{TX%Nuz~cƢC	W[Tz1PWj=bY\'ǪtNT)訓{\'TT2?%iI	`V-  ՊtTV\\-OKXǯ.ŹNЙu1^TY;GV\\7hW~O\\Q{\"T_ GlyN2Ni3Tge\\PMwQ{ki}\riTus)m[|lI\\³\ZɁmUTQ<Jhw)\n\\7<̽G\\TFHQX@fSBDh8VI?Tw_`zzv5`rP[}~3UːTϓ0.ð!hP1s0dTm9v.x9U9ț\ZA=CmYu\ZnUVΙpWx$?⇼PUcZal(+;\Z&E\"HyLU04+@qj?35Sr{ۈR;͎U;STS2.}1XSH&XE6UKCW͢/Z3\ZӶIqUW&k?un.No^Xۅ5PUi<T	,sTa6VUl6>8Sᒻfu8	q~$rUmPg[6m	ecY;UyB\'l;FVӸz`|\nC1BmUk\Z\"4i`FVm¬GXiEU۶B?wN -Čm\ZէUs(4>\0x}vX*WR\0>UWqPuUT=?V#20f~\\Uꚬ7EEԢn;魺9kUɧk)I)G55	fR7U𒃔`Λ)ͽHEl#ez@DUeDDkX5\\h=,U\Z8Z\0U.X}b,WsfyyEQF_[V,{+x}-\n uM8g>,l{TVA\0דDN`\n)Pk9WQҌŻ>VKaFqkNi7PVXWԖx@*kU?P6Ѣ\"5V_QZH؛N\\&IUb󚂇\Z|}VxG٘o)y0`cV࡛J[luXkUv\"PVXQ3L!h\"i#:@V̲D33>/Qu`ʤR@@V\nͳwœga\\~J8wN:mN+VEI0uX^@&2*֝XVbqPJ\0?HYzVq]5 .]@M*uǰbʝDLJ7V>Efw)\\QQ.Hz\rVU\\O8NOy!byAvZW\r5|aU͈3(|ɓkW֪2|0NҵxǣYO24pW;&c6pDX]`gP׌U]!Weō_ցݲ:Ɂ}@RWиEXWfC3Ku!7J!l7˾bԿWh?Cexl}$ӈOJc_WsyWhaϵ:[\"5acQQt	EWwR%G`{\\]3+G]l-`WyӀV]@aMxezEhsQgmgWx/4/\'x/֑-\ZzsyWo5ҁRj?UZ(O%zWxO`5$=U>oWѾ\r%,Z	A+u82,gL\Z_Ww~sR8Q,q!\\skMW9,P2e!X:^uIVnNYW} 8.tf0\'	WO}leVd`10bW@XXP H_0Nc\nZ`OX\Z?yv}hD.嬛Mv)X\Zp/}պ \r_<\"\Z!}X(覔7+Nb&1Y[; X(f\03Jm<\n%lrXHPpE%*+%tf`Xb}̿L,gCy~eb\'\n41Xc\"h.AbqKӹw_U@9Xp*-[DP<V8A#sAgSncƽXź= )e׎.xipXL]O}Fw	Vy\"#aq\"=rXe$<q>jM5̸z>6X!w4-<[EAbgzXPIJpe8 ,cm[X}wɗR67uMT!ܟʷ\r2XxEKƪ.,lX>w{oyi%UHqAcXr5yw]jγگzж\ZYE4eVLF/Uk,~Y?c*_a)\0|4St}-ʁYBRb-tsxco@ԾPɫYCϩϟ$p˯=qj=hs\"(\ZN)Y%FVOc$m3\rYl5pY=!\\^ox>S8Y-Y`x^.H#ƹ/24ēcY@e?W\\\'lm^9ďޮ-+Y7ɡܼa/c$ۮ7\rDr\\.FEY1n8DoXa0ɫqp&EZ4rB֏znբ> \'dRZG\n+:P|>sPc^M\"qZ%4\'\nC`Zó4cj/lZ6rUB!tRytJI0+dI\"1ZWjI\Zg*(T\n\\Lbr7tɀ\nEAZWr\\#͕	!^lt|oC lZ^x  -}:ɏ\\rNZb)VlJfdX#lW@ W ZS-`~nV\"\ZUMT;?ZӦ8yikP\Z3葊]Z֪m떕\"|OJ}^@ƻZՍZ/.)w}醶[\nxSSYP垫B_XK8Sa#[\n*k05Da4;\0/_7a[&(܇\0ΕljGn[\Z$k˹d?\\{\Zݐg/_,ip<[$r(ڛ8tbMq\0>5F[54(KL9&-kGRK$z,b6Fp[8si!@뮝{Bu$f<[D\nphSuo9a`\0B,\ri[e2<wt5Hm|ۯx#F)=h[e6S\"ñxakAyR[t;}n[ZVL[qTu!-.[u#\'KF}a~\ZY	1L.p[[8akI%\'n& G[)ߋT0uDWP\",Lǫ[I,޲ZF[%yKRb6=F\\ad[\n)>l=lV;Ow~ [f\'TOTef==&i[6;]qdJ\n}ʂɥD[yV |t\r\Z/]X\\m$[ȊD1VyEM	e\n~%U,+\\ɭGͫFV6BZ@۪2X4Mw\\Jt.N4\08\"̥A;(R[l6\\^;hz{aTB{`ȵ\\sq)|IJ<ͧ,xLI2[K0Pd\\xc,kWba̎2\n[e]\rsJ\\|߯T(t2Dn\\3\Z#\\#G71\0nXsd\\?B:{Ӗ73LΔJ\\283=}f.p{磨ƭ:md\\ARZn9lr(XuOmCC\\_{[GD%@Xo[tOx1\\HODĨ{d}d2sI1eO:yѪ\\$m]IE#(\"sc1.\\lCv!Bwnsۘ%y\ZY(\\=0b򜩲2֚ `sTR<\\3SR\0NEu=ߘo\\yT{MPu|)?\0@\\1B\\U6ӡj݀]bz܎6x+}\'rҙ] |$,bEw`&uI\"5`a]F5&-]V4dB@F])SwMU՝XQ=X|]<rֽ4j\nhNRz/>]A.ɤz.j/z]HB	m3сhܯ0x!ek-]JebUf7b^p3KOF܍⼶]NqCNٓԁ}~<a]`~$mg[K5NdjsiRF]fC-\\Oa+밎#i4x$jK]FHrP-sen|Xq\rmf`y]CŀPy(c:C#8]vY\nu)SEE\\>A?]LV]r6|Ww\'Y]V05,MΌ9nrDUu7]ؕY\'Tҹ0 P=<q^TȺ^ķ>`}jNG\\\'̅^>\"5J+fi7h&CϭX2\ZK^7qUd>VNchap9k<^>r=`7\Z)x^AG^7 ;6`*$^v_^Jp!<ʛYw\n)l^Nbu\Zx\'!T8o	yY|~C\'^W;s]-4V84^ͼ,i^g KcZ0(!~zW\":N^mm[(C,m.^vDG=msv^:UrUЬDUA6YfCb^Ujx{+\"&?5YpѵD?T^\n0{zs>Nz/@6R^̟LGZܯQ8VW9\nHb2^HR7-IAÿL#~{چUď~^݌)nTh):3\"WjEv9NnZ-mѵK^PK:`XYqpI~^e22eD\r/Vq^<,^.:%5)4Ncj,6|^׋܄yiTWaD#Fu2_2f\nw/ީ}\r<8Z$_M7ĘTf&%Z1S/-v_|BO\Z߭/Blk|S|dǈheP_,aLO0lӔB\\U{Er@4_-n2zYfy#ࡖVPM\"~_^_=>7b\n6h鶨Pj|\"xhy_?,Ibe}8\\Las/_T_:rcߘsN/]\n{zJ_duA#fE*.\nn9T\Z9pYbX_lbR,\'IheRD8}H_oYٱRQ_}GJ1m]~_8@zdf0p`oqqU:_7Q0WA-@\ZCTM2G_37~q/j\n9S#s_ՔJ\nZD.sA	1d Ͳ_64	PK_`I˨1?L_%MSK9$yg_G_$@\"4](XUjĳfIs҃_YUsEƹT4qPMDSF>C6_כ?&mH[JRc# M6E_,@\\S7loFPTިG9_3̥3*m	h\ZnM kX`>:6ԩf	µ(rP`>P͈˙$I+=ƛ0tW26S_<pH`>NgK)p&0L@e\Z`T.|	۞ĉ[bTI``tD;?^+ʓ5mP|&`{YhuAlTN-org`\nR ]s?Idi#8Gp`hs4DU.f$Ea<p[`\Z>f>-\n})ޞgGK!`!\r;^wjMRU\"&ݻIʝi<l^H`=Ix\'u|ΙK!`dIUgQ|X!f~jm%Zp`r{R.1BiKk)5M`S,Ы=3 R=hR1\ZM$a\\C҂LnU[ܠ{\'Ua\nU~Xs\\\r>cf\"a2>b[/Wtz\rlyoUda\'ɎDu9MJ5u|CmFhS00aC$qas6[`u֓@W]-ͧawAV >[GAI\Z cr\\lafKZX~ͺ3b]L<7a+J#\r/_TQPOl齎l?aE<2`\r_ra\n{!{Qدa~ͧZBvLj*Ah*bazC居Z݀;4r=Θ|aDmERBt\r?fQb\rC?DK}y/;|MT$?b-a?<\Z-r\r$Z|Y\nbG03⊼\rQQQ@vIF.3Mܲ%UbJm-ʧ553P#A{6\r54bgBxɖ)#B_ur߮+bW(:|[K0bKsmFdAیR$	bbٲJ4k&rhX+vOt$b0#ϦA*>pjqL*LN*\Z4b;ؽw\"S8\\z}N0bQ\ZBZQXNT6{hBqb􈀮9!X:\r3_:mcbqq[Jsآ_~4/`qbpd^R\n`	=dAc4es,c#ƈ|FwJ\0`w~^vEpLLcK͘G|\0wO>W! c:UeHCB\")Sε{c&~LRt j>گE@>Ǣ`cIH1Ũ?\"= \nw\"{xcSgy(0^xa&[5 fc`G٥T~zF+UȐY,cO`H;гCe]ϙTc9כaIaX8\rr,F\"C2Syc^\"쾓Ua?WSQgbɡcHoԓıRU~oϳ,P)RWFcj޾?l\'84F=/3;6)_qc.sH*-ب_:%;R\'KcʗBZ7;_Zevd$Gjw}XXyu2Z=Io*6d/e\\sS:짆$flmojd13\'mzU=&٪$?t׉$h\"wd5[&*%\rG8	pS-쩟q`97dBݑ\\EgE8\nƱz\\\rx/dPⱱX.]9FP+zdW\'MJe~vxh{s_|qaݴeͬdc3b[]	~?;\\[XkЗ`sdf/dBlهPQ=#djqe^1wK4IntfVC22@qdr\\=yZ].ɱ d|ImtP瀨96|d	Y@@+ғgʐ>$/d̃qx?\'?lJkS#dIX&܍s!,,\ZVwYLd0(X}v`\"dWi^$_fdri\"fvxʅeKA?S2dNWNVSCƨ!\\K;e!*Td902h,A*;3OAe4cr}cٸeKWCs$Xg-e5kyH~^}\\f#6e:iKp[8qBQě(3eTm?Uy7,K\rpSUn8ͷ@enR.	OFOXPhYC>WeY̻Ls{T=BrvIFUK:eEB	Lzt=F,faZ{ԲeJ*bV,CvbʃP~$eؓrJQ(O@_y\'+*&w\".eb|(G\ZrK<7f=EY\n2fVL$/DEfl/ioVL5rpHͅќ5!f1\')UɺO+pP\rkζf?sӊ1@cd`苲6fS~\'h,P.E1J>3&`B(Lfb\"=g.>{aۇaNl;)O&a,WfhP18jIU?7zju+j(>f9Ȇy7,W2)[*ogӦ\rW:Py}p!;\rc	%,g-Є#h;>	|3zBVg6BNp&\Zgq:sdg;74٣eZ=`7y!uT9V\ZgV|ӺgaWoE\"{QTS{>giI?F]	{[Ε$^#d	gAkD	dB(9Խ&gaaq$+q0k+&;\Z\nl$hg%b]Zjd)-pFj 9g >0n)X2)0?8yg>ٗYl\r\n	PmAg={wu2xj5?g;a¿]Xr~\nt¹n29g.$o8q;Z7tz?ǰ滬ڢ+gΪ#KQ]\n44wKgH7Iʊ|HiųlC޲ggdv|U=DFB;~jZfgӕWѦ\n[T\nuA[zGzah\rʒ۩#jE;ի}Qe-6ĀCh\"n9(ah޿[GQ<\"h\'+:ugcYcg=hh0zNW:\\jX%@f;hBkD]{8h~-2q aZzh\\|qA\"_;^gcw\r{PhZ}bΔrӍ>hh<gs).זW0xZHCDh]3l%Y+!Fo^=hռo8u\Z:8N7IM!\Zlj#7hpS=T_k. >UCmiVir	!8@DaE{i+;N3̖ EݶA乴+i:;0$PvF\nSp2ֹi[-R[4̠/IwFE	UUxi`WVdgz\0 *N᷌^eipZ&`Un$P9xA	ӉĽ\0iyHEѵ3E\":L\rXۀ,$|uWpi~::lwˉΤի8Qi(wAi}eP.P|S[wW&w4xiMW@U}POOJjr4M_E{i0yNG\\89\'1+8*HdiiYS\'댵`R^yg4in\"}Vu3)!ƫZϼ~\\C^&$iʱL.1ju0u/&S0iv*+&&@kM&Q͒iқoHӝJ1p@tit.%-x;\n>r#,K+ȷic\'͔Ҟ>:2nQn^Sih0=]8YE\n*ӽnsjh\nј(&EeI\\s`|jS=s̼*a	j!iH4]eL8\rSlcbj041@EX<\0+&Yj$6gCj6vt5r#gAWFٞ#Y ~j<	ѩ*$*srM`eҋ!j=8PNT\r]LTC\0\njG\'C1Khb*|YFjI\n&U@4o=w|xӡ^jPV]g2LRSlwBqKje+=˵hOd\n:t(t%1j|TT*/#[;U[B?,ܐ`5j4Cu\"B(7\rXF4uNcÈjP.cHqI<;whBNb8\\8cj	-%ZL9I~xmHՃjo9\nՠΒy[1	Ij\ZpISbʟS}_Väj&Zy\nr[!đ֑I}	I+j~˴nBA-ԘFOZ*3yA^j֯cQ1\0Fo fyHD0@)Cj]I\ZKxz՝^!bujA\0.ShN}וF|YE\Z>NjSwKa^&4	tB۬iki85{?}\"!AW,@zUklqUsn3\\}%2?rzB̲k2{z$\0+3QӉX˼ PkH%|QeHz\rYo6Fpi0[節kNIP-\Z7}HDC;ή>Ek]^=u\Z;d2kXD\'wMC\nᎺ\'k3/B	ߪ\Zp\"JghkɷdZqNЛ\Z,F\\\ZD+kUۜ[9؀jL2u9?uk]70Tq#C֠Ҳ0jkZu,=\'СǗ:̨kP;N3p\ZxqRWlֻqS)?\\Zԭ!?l=Q>|ZɊ>F5Yl!}[zm󪧥W#	\ZlLU[dg.\r5p\rQ<[vr0l_](7e/6dpk#lH݇\r]0${	%O!lK$s0FP|P\\VS&6B=ѲRli4쿦rnu)Kj5W	l-Cjؒg\\rľϸCICla{!hPw{%&Y0Ғ|tm\0\r>ȑOv<kaeC@mO]^-,qsr6V%Fڻmeч_TG\"^jU@s=Fц5|m\rXC9Sguh~RkYmemN\nTmG#И}ZYՀ\"m9(Լy[EAI\"Be]m;A\rd+j7qNy	v\"Pm`6뽩%Hjl̬?.ml|,C+IbI$Ө\ZHΣ^\"lQAmlԟB:,%c5iN9mnm>ގQQ0504|$8]Wp_Ltsm|i)m`mI}IdKj+9V̀j|,ĥm~<]xL1A8z\0-)@ʅmbO-7°Oa$Lw?JEQU8moyfrGT^5\\kp0[*!mv<.K	1\\ WPL`mשs]S7LAZ&<섖v߂fPFmmG =~5OURD\\Wqem؊}BP\'|{M2gבYmMڽݩ=FV7RͶ}9dg=mӥ\'麙RҀҌ*z#:,`$cm`ek}âyF[u\ne^m<Fhv%Eϑ1^AԻ\rmj8tɗK\r?G*znDs&UCn},i\0v_l\rn4cyp}%4mb&+uvBn5jAx3fL{iƎ9nB%E¶>9d[[}3+hl_nLz<kɅ7k-\ZAADפ`(2nZ\rc %mGV@m@vTIJKn\\ /J-+\rX*JiHndk.Cz]9fi0jϏ\'YGg>npggz g5s.n5LW4nq0#O}\"ENt!CnuйoLϳSocoUFa[ױe\0\\nTĉIvyOiǒ4Mxn-Q1H.x(jի8XDn!5]X뭛S;u<}3U8\' n-yu_\":~I8*2Yr5n;N9@I-z̹>Gq n0oF!V_1\'xhs<z=njwc=јZ7V=urhnG0%E(G&WX1tF!niL&M٘x=Nf[y=/So+UYݵߛr0~xOs,2wohQdM\0;HՏp7Co\0EŤCwh#9\\铽|o2q\",Hf!OצwZ=PLo5r+}o38Jo:G$.\Z%БFFhSu<oKSc3YW$y6Vl21@9>ovQ\"c4yIARKSUoQt\'FOSژU.Ro}\nd֑%?M웪;oׅCHla՘qnF}uo֑R`#:֥6dǈ8\Zox6}DP\rMb1a|iNpW|bO<fc#_V|\\;Zp\n}\0]tt!x L\'m,ifK#$sppm+>\\#J2=)\ZXӮ=P	~rp%h7=APc(@Ƽp%{erB	d>HK5-c1>}p(%x5IYKfMQ	ڭL_:Gp+4NdJu\05H{7`S_Fvp7RVĊ:^L~һ:TWWp<D9ٌ	DpH2LReGMpLdvX3\">bǄY_[Mϵ\'p0pTc Oj-΢	suj4IT#pkxѥLҗ)DAzYnV8p~$\ZtB@gZz^LͥpyJz\\EHՠT`\n\\7p%јȮWz̀+QSr=:5pYѹ!eu0v?.j[,Ĩ!pmӘD.uIdn1wp=DY\'cqŭgaw Oa<;9pu-i,pWc}hpp2W|[MQWwv$|Cp+L,Wy4m|Cq,\0:>|ACzlq(Fl苗njpEr-R~O࿾SN+Kq*ODlW2a\\,D%1<ܭqq.\Zk؀E#q\"q=1#;+\\^p$qY3i\'GC?o(\0\"+I}lq[8dws#bj:75qijje*ZHG[?=?jzԄFaFqzLk\">EưzxQe6qz+kאFz37-R6>#n&q}bNOnYV8YR3SHC\rjqϑ\0d@Л0l,֦tDqCP !3а_ d	ǸuuiGq YƱe$irhNFIl,oiqʣuG(aV腐7fzLmĳqú٫&UzHkoV!+lVOq$1W֑=J=<-\\#r\ZW	ܿd,ֈL_@JJApb\\r<Ke2K{EÅOr,	RBf0z^*Ha*:r4(^0F1st\nr4rKX?kz^C9X\ZeFY38_rVj-jn[Mw\n=pɲd4cr_!LPpf<vs$\'orl[MÇ\'H$>Q_r	L\r-\n}^\n)*〆Ю\0rbS䢈%VȟV[9n!ϏrY\0jo;q>w,uroZ`a%,@H\"J7xrm\"]=an$7-j\"\"4)NMrrNP_; b0fL\"9uS,r;/n#~؆p$`͚W}>rQ[OGO\'ԘLˇr]`8b@#TF\'w?ݒ6r߂CZZ{L!(;s#a\\8Q0sl}߯]6s\Zr:<[Rd}:Ydy(ѩP\"Ps\'j{FCh\'GMg0fs( 8(\Z>e6ARQ!3>φs+\rU\02#\Z~z݀hss.CU۠M^oSF86EsNlD\Z5̂2GWRFՖsP34	5>۲#vGpsP4ͮ4qo\"F\\	^:Qٷs#Xۖ+pFXT%??crSyNκ&I\\s_dYekP(HP6POsDVi߾[b*aVa	 sU$$Vgb\"lxms2il)1yjuHuMt5(I:E[t*̽vdW;1!lH9\'<	CftlT^7?1	[]#T#t:sr9ca>S|0+/\\3j@tByiC8ͿL4DQ\0oztG=9\0aʮb>\ZOzc1}tIq|\ZGwP8^6eNcf	trX#\'XlmRq{88F񀌋t2zvf#:M{%tЕs)WjDrDi<6NFtḹ]޸HZMmmu\r}[-BU`BErZnZ?*ufKM ]=_mA98\0u Nr8\r1\'p{qbs/u#gTd.CYgЋUWa{u)rB.pc=t\'s)<Iu-ѣAHZ64?ѧ:}u6,]g8MUd]87NXʢ}Mnu?|P4TVm+sqdm~)u@?Ԓ$p*%r(b=ϝAiu=ۦRnJ+^Z\'=U\'u@jh0/ \'0OMu;rjJ%0$UC:\ZY!u#eo^3|xPu	x{	_Eۏd(^6uHU?/:꺨Aw\0x2ښp>Bv\0WbmA[8iERS0E`7d~v\0kETv3dxeʙ\0z?`v7c\0|q[jQ[&LƗPNlv9\ZR\r2@]3z#\nq\r3v\'2Y./T}t bH<6Py-vxgggy)ΦҸs!@XQRc1Fv.ΡWԻlqHor\'Jm7bv26}۞\Z\nog$$@[C\\Vv3)<>ry(L1yU\nvfav4Z}k j>X˚WR/%j5tv6\\yvT\\M	FQKGu0v?Hmrq\0L>=e\nSRv@nL!ro\nڷĺvY<\r4e6oR;ՐC;v!zߨA1 `[-v;a\'\"s{Ct(~+~mu@v|Pu<>n4pR.sI<v2ςZ7QXwFu}v{_5[tZ;a+̝X\nx\\&va-iQYhJt	Hi2&i~v1RCօmמReV98xާwנ`g0O!+U\Z4jV9woHpÎ \"M^Y\"SՓwA!(v.Bc?[D\Z;vߍEUw&C}5Qْעu<4Uw+hLOw0?pn~(3e4B!QwƻLbw<[S%ln,-S~]MDpǌw=c^:^N[ X%%N,wDigk\Z#VJ PN]	Y\\8dʜwHoՌ79l\n!{O[OZjwM.#S{.휜DG8q(FwP:B!n$d2e|6ӹѮ:0wSt+\ZאַHHܷzHo\'3{w]<	^JdOhYHמt.(@,wfƿtoXXG\nFĜcIs*ߤwlE\'~N\r4dAˎ@7j;.W[gwGTĈч_|\'K\r,#scwqX9\0V\\%tw~Bͣaը1ԝu?n \Zodwc4yO.~H{_ʗVГw>Sa	?̜sziþw\n~;H4ǜ/t_vi%]w^q92:_k_]z`=*1w߹xo\0(+%5BBSrl?!Gw/bݱ\n]\nANA\0vLGx#oC:[L6lrz|w3:B=x\ZE\\k!\n\\D6R~x3z	lrgRMq;âh0:Ӷx3M1w:̪xM(y/2,x5r#ЇXt%JFCD\rΜ\0xKP%LaڡUx\nGUTxP1vo0{WOI- zwCExh@jAέΰhY*~it\nw\0%xQnggW.6Yz#IĲx$P&}`\\QyGpr*}9Yxŷ(G*&IAvф_R!?xȈ\'eŎ4m#8uVhxo?!lN;8g_[jל3&΂q3ȦQxTn^Jn\rC@ԠG\\xSn]Br/u<\rxY\Z>kEMR6.\r[xl,B%\\O!S<yRxԴW%\'7&\\az< AKo%|7Ky ݣx#\rjۤETCIfnZy-8<@<]Je<w^ۄCY0By8Vx^kjONl\"3`y9t$JfƟ\n[dwyK6h+>AW[,1/yc++S&a1gխ[yᗃĩnyd-fr\\>X1ʠ-QNyr:\'?eOFZ诮\03y8e(@$k(\Zy㈔4tFKv9g>M@yǧ8=u<&(3e_`\0yUb\'d04to/\Z+]!d:y\r!\rs|kFa2ڼ@\ZyW@]aX%Tyu~61ZɁ\\/[l(yL$L	rjkKjVx\0IszF+1@,0CJO!zb֬۳ygFbeE=zLjR3Z\n\ZГ(nf\rz$p~=Pp\'eyK!v^kzP*$	e(WI![(ܚ>< zUm{ڿY>p֥xw\nTmw\Z~Izee `~wG$us4oō8z$Egg9K93)U:Sz_J?Q)ϐaL^;VzrOU]LWq$NAwNz\"|5ܗ:lW8]PbNC~z-6i	F<>LO<kԨ1\nr\\zkϤcQ=oJ)\0.e2 ,zHma~B;@l\'eۼsDő;{3lp^3k;\nk{2w\rOHSuܟnӟܢ{u)x!D@|HF9Bu2\r<[?{5yȆdj2& =IU,qC<mU{@न$g+Eg[r3{M3#_B?ng<vw-i{\n{i;|-#qYd_;QH\\B%{saVmH	ٱ+r<ĸT;[{\rś911T_P,[D:w{n]\0ֈn\r<w˷X):{,t4S)hd;}K1{g/\\Eǰ\ZI|\'ᄛDi!H{OW=!̏W\\\0vR&~Gʽ#{ЩN7!QZ\0E1ͦڤ!g|m{cD1\"D]]=-c\\|]o(jF\'*١ƗEF$K#|hPi>@J6lQM㞂|#vh`JOAx\'^|(\\Q&j\"n	\nuѠ|4rcȐDV*{3F|Ed\rq#9\nJt|FYc~\'B _-dl0h|Qh[sob\"Af/$||U6s\ZJZ\r~5\Z|$ݚ|Y\r:l_ƙ=ݤ.M\n׺*|b)MGA\03Y\0QyL=|m!5zdlگ4uOln{+P;\r|q7rߍ{,\'̌\n_|&돕1`	B	Nt-se[|\Z$\"_wB&it\Z||@&o|X4Pu@Co9Rd|zp-vd.,[\Z|QbF|u_Nac:-;|pѨ7{͍+F;}U|ʃ[^Bcx͂Ő^@<=FD|ˆӰP<յ>DdA.G}}_|z,j=gȷ	TF!wd|N!xV$W8qIAC]1!	}^\Z%Eݷ2=c̃PF٫}_ئbqی(h=Fļ}CY҅8#j<Q\0Ƙ:/D}D	4?s.M*{TȇFd\r}c[/NHjnL\ZXm}eExI<gB\Z9skf(h}y#ũMssDj\"}{q}Pd,_P91+BwF~M}ʞ4!ʐY6Y%dXSٻ\0G}-6\'fnTY@y_{|n<	}m-+vi1s\nU8u})H@VbR\"\"ͥ0׹ok}	Wb2cfHByuP~e24x`Qx<C4_~\n-5RTw4}3}w3&y7~CpV_<rZJGԹ?ο\\~\"=Bc\Z\rzn3^~5:ܙFLWs@놘N7~>,O0F2vF\r}ɞkTZ;Ӣ~DZST̵p-7Eev_QymK\\)p~G686*\" f\Z=^\r~PjgkΖ	f:\"vEy0sߤd~QoE3RoJ9>Xε\"؇1~v~zS5ȢiyXpdH~x\"&/V!ca6ft^~r dKHq#%YZꗉ~^4**:rCs%uKhd~EUaqRh}?B@:䰧~Gl*h$*V{M&UlI\Z\\z~;Y줛NPl&4%\0~)+: 1Ŭ؈\"la@MSӽk~Մ:٫\rrq03aͽ!{-~v<gz_ݑ	RC	~5B[1E_\'&xmfR2Ih+Nq$,!%>o5&qZq-So4P9u,*3R WID[1hђ3X??$g`䶝`L\r9;`\\tMQDj7iDfba9S%,#̔c~rrwCpM\0wdJ]@ܶeu_(ujpP5\\֌(Dr3f!UHQ^3\nACsu<f8slpZ(Fc1\'濉j$cFePnaަ@#\0$6i2nt_ov߉pjOYvqQ,|a6-=S֍Ipd%_#kCӠ! !ns`)^aLik8>:Gs^u`J=TN`Q5cUFa=OŌܰT\\hX8GR\0z_B?<(Ќeou:@Go5 {`dQz]<{#G	;c\\73!}\020͌Bi\\5,k?L*_Ȅbu%dNv3 tp>?X?l:\"x9lPyfIu&p32ƀOkhWSb^S\r)[eD<݀g/{>\\I6R5.vߋ f6*#6:cKx:1#٨݆=$O/KfԺ>8~3>׍ހ\rY35)>FS=(k)Ytו䩋ż8]c>%9\rϤfzU<Mh&EN+рہH O>06}#<QnwkVYԇ/ @|ۀ\'&Z˥~oƗZږ\'6gi0B<a0[\0=U0-TK#i>l.Z0K]<l>&އCy\Z|W	Y|z>6}\\ y\\FeS#lt^5:~/b]{.\\+B BZ3#f4.xi:pYAdBK\r!U3J݁wypø\0EIntU]װhyR^2v *PL<ŧSҙw8ث܇Si.=$#	b/:LV䁜{l_3t ny@8\ZfU[Y<Tiִ	J]8Nػ4mTd6Wok,Ӯ?aGˊB7J?n)p)=jk\"/%>;ےg%@tlsj\0jrƂr6yZ.\\Ξ\0?`b{C\"$vR9yۍo4h:	\n*fƊ2gn2I {C[HrA\Zbۖ܆lWGUaGb{\nikTvQ4E\r0E)l`&@򩚺`\'a1k̖VS+\nWyM9>U:\nբ\06\rQ\\lz?9yNqJf0[;P\0X-\'*\0Ie#C/M;K\nAt/cC\n]\\J=\\\rRqL腪p/ĤDQ.Gȗ{<)MP|yE^8}ؚnt&O8(d56GJ\'C:R,;Z,\ZFB>,\\	Xwl4>o\Z[_6.$Kyo_3D&QB2\0T\\\'_MEw^Tw[Xj4sG5h)p\"K4c!\Z>$<\\&e\nP\\*Fy?|IhFIXFHE\Z*9ݶף/BF	>&уJ54A6#\"b2SvJ@{U1؝ڸ>)T}4:4SmVYW>\0\0qM[Ol\"o 舲3S\r(7_ Yo$bܤr924?y惀i>~fKJ` 3uxE梖^c|ٍ4|c8\\Þ9Y۳%L`N/~s܆4}?\\QC`Տ&m&=C}cS<%`	&IEibܱl@!C\'0:IWUsA@;J/8qڪgÃlDAבA=<h9)Alt©|yg8T:5,uڄFjX4\rW<0Y{V9\\.Ip?H[sBHxGqZ8/Z%Fw<+-;QngpՌplVNfVV.|vXN8D׉DGgB@]Byq+6ƀ=_7ky~mȝG|F:94uZ7>fثDiUgp٩v䪄{\0/9\'x~Ѱf7Qˊo ,|$Aߌ͝`s݄W_w\rz]޷vXք#bxN턦qFLg~~4Uڟ+\r ?ξz2l=!ߤ$x}܅e(866gPEt	sYkMcǳo1+Yl璻V#qϫp_jf?8omc5֒\\PM%ժ	T0J\0(=D*ۘӵ>\0Z(ׯ΂|\0#Ÿls@0jd2S*\rKT(g.كt}	zCS0j)wdV圥1J{hV \'Jb-i.9EA~+|%\0@mVw%%:3CQ#+g	e}@%s5FŒjfpvGVMvx!!90M֗y-t3oXDwX xTA]WeZ\0p7gKzXFDk5pB#:Np[Fd*n7d뷏1\Zh6x:i6Lf `Oz~\\Aj!^Eh{RPhO	gp3X|)F}h9P*K_	&Z2Ji;sb~~:~Uwi۫uEfIrqpEW?#܈*\\f}ժm۽24ji(S3\r25y\02ySСfU^x>p$!p[r\rf^nEi\0Fs\ZNaFRȫ?|Z=pU)\Z!:y4DY\06)|)0x;Q[5SɝȷdTK:oVLE2yE6_%Xc_+|V7T=ոN69\np=x/NӐFs/ȗ\ZCeܻiL$@V_%ņr(\rnb|8Қb^+򍭑MrV5-\r\rJ<$jAb׹W\"0AE=cݶG/twv7K㛴oGǧvtaAXm4@x5g@Ost7zQw\0,7x/@69	ЊE*#/p?iQkgƱy {#\\o%E9Pˎs]h͂R;bE:\07&[/=scҴLHDl_d+%nG#Hд%ܘr܇J<\nӔw2{SU%	N3y֜#](Q\'nyzMa|Z83P#W(P)\n՜7|#|ig>=th@~1J#x9QbvL\n\'brL\r8֒\\8cI~(0;Zų481O ik(r.PƌؤxnGAhYI壈0v6-Wk)(yjRv5ӓUē*\Z\"Lv::	ȔjF@V:2Gۈ~O_iS\nJI>)D3j\nEI5xp*I\r!	PifVqlFDVS><ɧX[\"v-V!v[8eE:Bǉ8!>EaCteQs,MzX{\\[(HfCPAvy5FY^4}!?~nDmnC!ֺ4K)݅3_ʈ_1[F*J@-$ވT$TDMR녹~F-5陂{ت\0Wx&_	3g_`Bwi[\'\nTT\0\"-v	kYd4 w񪰋;/u)٢X\r/_o[B\nKKxm|T*H9K@kdfdQ0?W*歘fa9ُڇ]S΅HDWIF~<X1g9]=-Ҍ>š08(\r4hHŔHblXT\n\0y\"aRTfB-.Rc/nM,=g$(}BݮD9i@]dE^CAm7tbv[5S{GRi6K73!stiq)ոJ\\(\'UƉR/\nfJhvi5rr\\z\"6q%	!kQ*;MuO*-\\jmkew[pԥ1%7cp!L7wg~]\'=,79v/_!PwS5b#fJWneoRެAW_fE}*B+vϘD-@AtwrFNR_\\e+! ho%9ӭك	KWe2P[, G7o\\;C(۔H\\ݘ9f/V|i3<Pin\ZEOVoCu	17,su͉v,KyJceFG2u]\"\\#3\nVdH-SL86ݶ;6	yO=PoУ?buה\0G\\%A\"^cίk܎oT+%$[[/tH/(ݎ2eq3۞H-Xt? LA$G?Cq꜆GGT|P:6hL6^EzPuK;l)c<S\"UBID\nm?5f𥋤\"M,O=:G>ꊴm`!l{_,DL+2i4ǄʊŅ.z;& qû9Ԁjփ7\nTtiCbOK̊㯦0NVɀkbX9Q\\\\m,zoFSIa)~aF=2\n)}$$N)ad*\'I<})ػP*lwKB}ޜs2C`h`W>!\"8zH0i V(+kaP)2\0Ւ\0U(rbwǋ9k\"m{R7a%,qJM0w)^_Π+\"g%甖O0[!<I9\"NEhܕAOk>f59%,<9;]9˲i0Ic;Ɗ@pХP\r{I\0(<Cy]1ԣ˿DGrc\nˋpC3Q3#9\\\n#Ihq24>M{us!Rd/hZSC	]_W-{WFvv4[i?irzGa׌/\nىpR?61.xl\">܁%|oʮo3dl݈s9?9:PkZI%-U?M$Le⢒U_F=`o^FpiO@^/X\r!h6Kw?o=7o|<ԛRSKVQLnwrzd^ЧGDC.%{?_z}+iU&4c?=ݽKD`($([䅠@h9<}R=-+K[;Ex,k x~6uz`؊ii7Rq3@nM5݁7-7#KT7n.=$qY\0\"M(\nOraHQ61%ٺxO[Aa\Z\"`҃=ȱRvHmf`lsWBB\nSd3WL+&쌑cD`_edvJNᕪ>bg2ZTHFS}!*rUjk$4mxYJ_\rk@7W	$w(MPXpC}ݪV.WPrE!oϦI]1PCN9\\f1	2vvm^Lyf(_<>MЍfvq\r7jZ2)i8&<0~퀍ybiXfK׻Z HWrRkLCʝڛ/x\0s-Qہ#\0n{]\rWh0@=rIKԮ~gğ0ȣ)!ѱK&@<\n%	d>?Ggt!3]#޳jN7|&?ǰղb>Y>r]bχ3X>m>ÃOUyvH\n;Qıg\"WAҧ_gsUM-Gm\"cm#{t##!6\'D!\\֡q<pZq3gl󪙛#iUP(sPg/Dg}#&H3&XwҼY:zq{I<sUxtWgAO/mưBrb,}71O[\'Gd7z\r|q-[IvxD!fϖcDFC ]5XQ\nx!sTP¾T1!`BIrQq\"ZF~ަ-dlW]!rtT$MKP\0⶞lO\'d]<Hݧr@Xa\"cƎ|W00R嬶8Nh.s)7\0;X\\tI7Sc4,O/`һ[%pP\ZcF~cRˆViMJ\n12\0x1X؎\rT=2&{$Ʒ`z#?@\\\0uٍ@kry~ĺC9lxu@Hy>7HfF4<\ZŎ]sLoxEl!\0gUg\nGv\"@:~CGKE`^-B\'F*S1?||w~`Ua=\n3-:oRF*&\rJsJ\rd^=P=ypyP*u]*hYefmVr%)ӂx	c`9yD#o\rpj@\'%(\r\"`4-XolKk$ѯf7yӖus#i$	\\Xi </jս\nڦ*ϒ\0+ؔ%V黉yw\Z110+ޠ]  \\UC_s!)~ʹݭ>Q5ƾbs\Zp.(Y*釨u%yyeSh\':x\\F`fsBX#MlW\0#_EٜL]Z2} ~8fHݧOw$}jEkw$؏h|aXxNGZn7RstŰ06<WU.s:I>T-6fOlb]9P𽅌@1^xzoU5e2y)q n +⯐U0iq ,1øώ,㐕}@L(͙VZg|_}U)87^*S$ @K^/T\Z2\"\n@+\nV)-d C+v5ƿ^54Ales^ؐפRcgӀQۋc@yЮ*]a/>^o</9?s:)1\"{/pTjٖ\\\Z?Mn{1)\n-QG\Z?Z}/3\'l:9w):I)̒]OC{dvc^̟9eQ_Wo{_T7QʂwL.谇M=B֑\r\0AtȑN\r>--bmYUMeI_i VHY(oߠ!k{ustټƒl|az455@	^n4k=\r	_K\"X]4@NS	twҠaF^E!@Z[|i(~\nTMOmKw`J4/ww-6̒ qnJ0\"dJݍR\Z5,jd\'YBcH7*(ߒ,$ީk3`tm5^7}MR`-xɒcr-A$:TV8&E75qYjY9MHEX[X]@G3:Omo]?G[!Y֒Sߏ1֓}dQ*t/^Röb=9@dr 2H4ъJMBѦ}\r202h(G:?{r\"\0\'5wݳt3c4Y\0VI:>	X\"FqU{iM$̵<4lؤ80/\n}J`3cl6HW	9z^q-76,svńTe}5;u+,3.-Ï9#F}E\'$$It&k -8lZ6>FY\\38fGOp>Kes!2YfxMw|W$<&h70k7N2wFuO4-@ctɷ3(y\"/S5 M38i)BC[ܚ~ZWKi7/ZHz&0,?R-ej2#XH\nd5\0·x\"}v}u0\nM\nd>ᓎ@,z\n&@]D6NI\"\"{4:g\rISlУ/m~Ynr87EC\nj1sD)U@3k{];ĉaՌQd8k55ai*UWs⇸s{qKcBψ*\0&Ƽ\0?woјS$GJNglc^^HH^zS&^F޿hY;knݔ|TSOcwDٛOeij3O)o\Z`N~u٩bX$Z٘Zݟi_L5>}R%ZA>%|@ւpw^o(fPk\"Eպl5zZ8q}\r2{$7F--s➛G2,a?dIu3mK=V\\ԇ|ޕ9PTnաc6\n{zt@;=JMZ}`෬e~vJ?\"/i\r<Hi5+:~p1KG{ƕ`ݸ¹\r? ytbg=!ӫQ69`\"-tP(cn/>)b@HO?5>PQ	F缃`;<v}\'P[Y%/?_@e&\'Gpp2[zDwNjÖ?Lu5Rev&-kUobE7ܼzL{{MTG.{})cI+@>H#qL=a.cU\ZMwJ× \'b\n}\ZQ!x\r5DQUK܅ޖ:(O.Xi+&	ME	zFgo1:ѳ\Z>A\rq70O|%6`	PIY;I(ϋYۖuf/Z\rGs<h4oWxۺ!Mz0V_.=*ym\0C{!YRa\"	`F?MUǭ[*a:&3ܸ<uLJP#=9+FsqIB:U{G@B=\'&ȖfC ~.n,1`o9]k\Zq4ٱxr*ӦwRZ	ZJh>E|7b{d8*YyїB.*	l2Q_d_,6QaA[ز=	2m@>@ATm~FmӠNll>hI2Y!ln}1dZחK7G?-U>tQ+qKz:n9>j5d3=YsNqqpcuȺtV5Ȥm9\Z8q}u}o8>&V&NA,\rjYnxIvIvԚ!2q#&a;Ll$d3\Z&2	%\r%~W+n}`+j	QC[\"!vO\r#-SZ8(ɃAҷh/v.O2W\n\n\\yq#16&Z\n8ӊUuBੋ9ELa=T/8,i?D/ - &~\'ɋݱٌ]!zDW+jJ(r]\n=+WU}O/inj4u9ϯ\\-/O5dXS^`M.NSIw*/\riwl%7Rc(Z=mۗA\'j;LB\"^/:qQoBf lG2Ĝw`wnN3=͟hKrriJ8[C=Sѡk{[kF`Rl>)퓆o807MRnwK\\iUVD}3y(s$T琱a	Aa|;Trɯ(&o{!2oʪD^D1+{^٫X(ߛ M[>mMCoMt}qqXAiYQMޘ\"#EJp~&w _ڙ6=uqe4_oqtp^Ba@^#$gKd/ė5\\HR].H%Eq Ʃcn\0p\ZYv1]@ôy$]6o~܇] OLHPx	9lKS#n6@#Gbb5_*BpX[u\0T9<	c&Aw\ZENYqi6-%1L˭ݐ;\Z2uY@\nWܑк%?;`,CՋBxVu(|/9Jې@hy(K4\ZU+hA\"?_6GAm!3h\"Vj`+*G6jq`8&R1`\r\Z{5yG\\0Mx[-<P6YE[3oHSVИE]:S*˚D{vJ-C:IJ*H]9[F|A9x~dr[;#;.HAۣc<Ep&U\nOKErBʳgUa1/qX夞d9SyrCT\0ѫ.ʹYbjNZM<hsսI\\5\'НLIxX`EѪB+Ap:G:,w&׳?/K$^ce?^ZdO#%Xxʆƛ-F8yd]3f^6Cwٛg~x! }+`a-Ӭ3+@wF_+x˷Ӏ+\'C`&oBh\066+u02ԭp\Z;Dibi\"r\Z@!:MuYSꥦ%Cp,\"GENNNL/4p`41Pcq271I^ЦDvnZUC7Upx,wÛ̀vNxklfB2QWkUڜ\"**RkhW`٭R|5nu-\\:ԜY\'KF\Z1ZS%4Vb*P[d8geͽC\Z\ZSj0134])ζK0қz\'uzu`̶$˜\"XMN͆&V\'#ǙO0-kq2wSc?dUH\nQ73hʫm<GM]3p+LKNǜHRf$|k|s\r̣64\rIbmH?C\nDԈt9! DW~<~J(u☵B&O瑊[m 7Am	,LCTNRщ@;COuJ9\"\ZOϧÉƓ{ONrXU镜Q٩\n i/$:tniKSf]cX\nn\ZFppJVA#\\1{A ûͥJOmO:ϙlW5T2DB$^Vygə~|\ZqQIW#(4\Zb=9-C/s#6ˮCۊ%G8q)ϥvǯj7Z\"Se($KVCm[;W8<{b\'ŏq`\n3o޳B@8Jcýn&Vɹ/[)ۻz[gE>b`*eNݓ\r	hHj	gQ.X]zѩ*gw/^xGq1%S9?R#B~::Xg5[mQӨCM.C\0W{4\\vkΝx[%@cن#\Z>O;jGgR0GlY(\"y4h/E삡p4337-sգ+׫vC,T1>K)||yDp䏂Bנ#A.{Ari=M-?3u;\\#SR\\;YߵzCF#L!N@69jc@% ܞ?L$bmjT0)庠|l`$\\{\"?~cj:èƞǇ\0(8GfWipJpMbVgC/V!W3Թi9*mVwkZP[:UjB5E $\r(ԇ~YG=C\nw9G)\\M0xa$k٥4a&dkGS#<x>)\"&%q٣u4KM$oݭ{A\rQIQ\Z(B}O^Q4uTv1)\\Nzo\'\n]g\ZuF(:\rSlVl&r\\;;PϼOaJaE7dh|qB\\)6ѾpDW{ۓ۾!$ʤ5g[9SZ6 >),(E<~<k\"`	[\Z)^Ktz `t^u]58ipvk\Zܟ%T1#W$)z/WL-ZE{Kѭv__\"l&ԟ3I49qZYFU	-&\"(6]\':rQFGߵ#b?yg	ViW\ZXJxڵՍq*V8,xҸ$ݠIBS; ɕ81lL\'\\udjFוVQC3x)!TU33Ws/wqa_KB	.AYDZ<Xm\nc{m]RWrޙV Baן秦FzJO#%ĞI,SMV[u\ruBVo#Iv4d?QlHJ6\\2me8(\\0\Z%he[>K5\Z*V\\z%xĦY1xYf[FX6cǠ*uk;)gRIb~\Z4V +ucr>\0_s;ϸBs1M+J5C$r<0Ġɋ[!͇黟\\d5crFP2ur~o(MFS*:l5\Z>ZDrgoEIHPg^]n0/Ǭs?FώIs\n4^TXr&Ԓl(EC4)\ZrK(12e^Zr#jWy5-e	G_m r?gWՠr2ѥ@F?&s~ՠ($̻.LxkWNg<\\Rg_13)16Oރ^L;ˋ.#LI.]+Jp(9ٰXΌ\n\0*p̕^ XE1oO3rߠ1nv\0jHk7q-;C9R_i$Ԋ6tqm4_rnՉ$u*&?e`=89=\0ܥE݉X8Ym	㞉QlA\n!gCn|I#*0\'pT,RrءA5s֊soʊ/]O]8\0qg_\Z^E6{:,\';ZB cNء\"!gxuE\r̉8i&F?w[℟迢Z q!\\\'-Qx\0LD-Z#SЦ[%ɚlz*mҢPW1 \\>͞uLv}:wP([fޡ0[[\nudv8fRDlաe$*}֢Zh\\wOWwSi7G;xV\"\0ݤƫH2`zw`oi0Vj\0يlj.B\'|Zøs-p0p@[Lfd@a1kv<+r	HbXҞLW1&@rJڇǞsb_`6K+l|S.P^l	l9/Ȭx`:eu)n\'\ZcK]QРL!jRkV=~R[C;>fMBR+mvn	t;=%JyR%0\nf/eÖIL*ԟrWt&BmvWU#wI$Klh5b4:ѕWnw=\r0CUR\"$dé6)IS\nE]mY5c\rwcD4AqQixWD2oF0+vBJX\0TPO]\Z8UmVq^o#ZBaCuwIT-$e*1h)ٿ vSh_=XDpi-wFa\ZPN;ˮhJ4mBB;3ӯhP;)ړVz\0Dr?{.<n;V.RyRTx\\h~D@n\\ǹivz{\Z]_q|@TbsBzV&Τk<tCz n`j\rMN\"Ag梑x%&yp5L&][RբYBѵ\0\\4:\rao|(;ҢL]검NjuzahpF3HO)->!\"\'$t-}M61p9ǡkTb:X%nܢxJ;vww|U-%=FM>gq=tGOwmjd)ߣ\0$Q%_{1ގ7څ\r,?zDx&fv8P?Alm :2MmX:~ڣ8,˴tT^ע+\0^U`<,MWt\\+TÄ\"^J%VCy3BVtIppFy/sܮ}GT@!QRm`+N*u6N[s<Ď) Z9QB\'G,~Ifř֛NoYt;\ZܕAwWIIw	|d2Lu=#JR9:x\Zz\'#m:uZǸ>8|{KiE<z?eL<M\\}v6\Z8zRv`\\.).^pĔ/E{~2	Evh:mwWdӨ$B|S1,|KY$TTL_|h@P%HD>ٿff?_2Y\0d#vTUЦ[TmGnamqY\nTorqKKcr <#P5rhf_Dm֔mN+K{VOu-Qd;++O;vD)(P9h],vɮvJM(0(&#쟴>_Q7%l|[l|ߘAIy~k\'$ё^Y\"awE.뤮5]~o]bT\nç-G=[FJ4@ŷqabnd\0nXf6?,=ʤ K\'9od?pGZ{e&\"S\nTkN&(uu0!ϩ7$V9դ\\`toG\"*+cW d+ΊM?\ZLrZ%\0\"lӥYM2<	VTo^%F_Dt!䍥mu9uH| ܖaQLU0\Z~{vhƇwRjIyphgss&:C㿩\rm9>zo|.󮥔\rǩP\'RIR\0)$u	kf]W^\n<贡b_ćȸ[G&R92&DDcQEQӂ_ofIo	}B3&Y$PʥA]]hi{ ԃƧcJ}|\nͯްA(>j2Oƞ}VOצwD{so	kjLAR	V)ϵ9D[.NVKuZ\'ނ?0;J;\0j=\"(P]<X4m%̆\'?2[Q耐8/sG7mw){\\I \'Q}mˮ$R4U:k$Gw 1@uiL0Kĸ:@E^؛36v!l{PVwS!nH+\"\0Ud:\nO*SРLل.\r>֛n]9^	aZ_phRf}	PޯZ{֢JZbRu+$Jp)#蘥>XV%z_X@KOuKMFq:RSO uѝ|=o%-t,u. \rHxeUUHK^Ǆ_%ך*\'Blm&^/ر-Mp#<_˥d^5ěn+܂ˬ\ns5*D^k2mi^+Qf\'N,ntR&*\rSPK?x7.՞*LuK֍v2Zg,z[^ׅYgv⭤YZV%Is!бj8>\0ئnGUvi3DCA6D`Ls<ŢtE>Ps\n#HNo&WZMls`bF+u\0#\r LmNߌuuc^=¡DU{.į.տ]d0ӧzEvGL7t|%\'4%fp#eh-h8q9\Zx	VG%%h/%R/ήqeGF^6`vBI	|2PS?hFMaȂUE~zާ#^8Zy7Uܲ={s&FW\nR_	\'Hu)WC}D&7,H)m-ENMA͛	,_~Y?ck_\0T0ykM38W\\Q7F\\\'F|S=Ւ\\[8(YYVd7{m`C9+efү6U\Zazߏ[_K}P0;rɑB@?@[P^3D5Vw\0\r\'TP΢`eέuK>fL//\'F9r\Z!p\'6D;%^-xh%O4y:X0^YuGyDQb(gEpֆriݙhF=yZQO/L%@=-e-I+Rz<\' іrvqSKU7Wߤ_i9qQo	A4fgSh%=ZN=_Qu~ҿ$3GU4&\" KFjT(5o[wOP\\>03	{ɟa6]0\n*()\nǞ\0zvVMAJUla1 ƷŨrX>5SƤH[{Pg٨V!6\"	BЃh9.F8ve8:c;%t}5;F[?EXnG~Zݸ\\B[)z츍mO~B|A&݆BJ8?3^_͢opʫUCgw(i~\0.l>Wv&qv+IN~WL |F KGO]5^AG\"$A[?:M2(VA/|b.4L\'iWFTЎؙr775F|DFIJ53m,YlwNƋFe\\\\y2#niF3Nrb03jg\\mPPjx੄5P$j\"`\"vR\nl_9ȧn\\\ZrR\\갪[Oo\\.a84r5$	C\n\ntYwrc\'Sy:G`}.,]|օпеI۩b̚w[$QӬh,a\ZcNCCnø詑ouj>]7!Ӈk\'ȝ\'cL:b_LXx0Iʪ+Q;/hE;?T8VܒA#I%d{F\0+\"6ƹȪJIZ;w%!W9ѱS	}9nN->tB/ԣ(q[T&7,Ǽ]m+7^꫒vK7[Eu\r:&i|:50= SUu5^_w|)W6c*&Ī]Z\r4t\ZwMiƐG>B\\gѪv`(1in 5U{Io4B]Sf1Ю#8ZL}OBȫ[y}BxwIZЧ&N-)͈滃~5|zI(:.*gH-#=a$--9\'cڪ?I&kEYB=b*ҿ3Ft5m{T<gF+j\'pQ\"}Fpz.T&lGMki_\ZQ\n](_,pgi1}.͇3wz$W<leP[?草p>H#j#E^C5őܔ)==mfht)\'z1*~6UE4[kP1wӮ\\^`Y~F9-a9RdlwjRaS(7Ʃ\r\'E^rn2ͪU?嗸W\\VeL,A/\" 4zX1][MT@JŁm4N2a0Nm).:Ҫ}]%vc݈(YUe%!TFo9j:Og7(dKQArU&Z~f,鷿ܻ\nd`4.{mϖS9\n]bG+\n(x7\"\"5nWIiaz_ݮo^2S\'VAFXj#[ͫ3H@!+siA$uN9T+ƺD=#wjxyӋhOB.h2;bIqS]B^	Q;fWV\0sl^}!/e*\'#Wl);*=$99Ocor]Ȭ-b`(d\n#D!άVeazUܞ|-T[7||Atuia20Ĭ]Fsf*M\'{Hsl\nmL7,M!mۖ\n=FK 	..>D(٪O-R6W=q;76o撴\rV>=5t[ߓ\0su1h,OTU̬$&^9]WgG\">Joe\'7Xw(ucJ[1\r\Z/yF&}=\\HV@r\"B3~YƼ\n\n.fd\\>8{ΆAHJE2>1}\0:aTM[-o	_\\f\\čjtz\"HPl缳?x4P,E宭}ab`Zn/^5)o嶏\05x%,_`@c?TDBu=781z`~R\')F]\r^n@h5⭱՘A-z򼂣.kѻ/񃭲V\"5PG7}j!mYZvrIƒp4{JYE܍xƵ(٫EƵ5d=?Nrs.PЁäO2:~,)ZUsk\\u$1JՖ31G3pRm珮<Ũ7iU\'z:	 6/z@6T&\0Cp˄($nTwV;LQ72N͋-m4|0\0;W4bQ(ɞ@tal2XcIRL 29^d6_V$C8t{S\\ Ib\'h5_\ZQɒi눙OsJ:h[ڮ	ۮ_/SttRʔWCUx~:rQ⨮wEpVѼsc`PEؑ]}܃wz,<?P&䮕#ssj6tvDzELZdM몶W9ITLcr\\h	=YkHTxDe:#o0mϿiyۂl|4hNO~%\n}\ZH[6aB2jf7fL~Elf\Z]ܤVB\0n%M/[;*&/_/!rz¾$et%Tn5?*BRgdm?*\r4&#4NeTsM!r٣0aT\0ڲ@ޮ.m)Nu40d0nh\"$\0$\rO;zjJ,nq U8cO\'xvW\"jC+o%~qO\rP\'GrHq\' [y-NIzc`#0ѿ߯;<	`>7Ts|46fB!{C*i΂\Z\"c9qLԬ *7pO6S`njVFmT`b3&.jݤ(qSjp!puzI0J\0&\\Ar־vW^ܨ/,Gpߜ@dß-ȧқxFkbszXh%MncCE+c:\0e\rު~\nMw_a<>VX\Zl5j~d3v_hi07ǧ?{e&ک\0͏\'4n@\Z.^di$Gٯ6-֢\0qxw&a\'vVҧ#cwr4w%}P,HR(T6a\"@Jm l/hSٰ &^Sh=.M\n6SQaHt8hs]\ZU*FRg:(B\\L|ԋ\Z/5Lr`[RBؙW*_5N^;&:\nW1*UyKeŰS!.!5C^ی	İ|vVuMM=rv^\"r-$ͰUq#\0HD`>v+OsCU)Ot߶/m3R?wZL 򣷢5cZS.^\'呰%J(V/+M餱\0.y36x> [/.tT]wpX%]~|4uoAf\\ĐQ(Ë\Z%|^]Y^F#c*(#\n=<e^ҷ\'#S=wW|K:\0kG%oC؂l\'N\np_Ď+$i7=I5iB4<ұ,FgMRhjYı/<)pQКP_sZ0TXA#6{K>~qI=!486>$VsyJy9D \Z_`X?4=!\\zRhp}@,rQ!UfY5uϱ\nEfaqZ:ұbLn-#[\"61zvi~3gF\Z4\Z/җ|CAb9g=><P0\r˵c+\r*+H\n$^ѱ&>HLi#a\"Of,8,M4a!_~њCO״&8Y:_؉\'qP#ŷ[`~;HkMXML`b:$d\r9\\+Ϳ<wC}\"	\nT)Q\\u:b&pű}BH.G;d\\ZCψ\Zo/bo#Wױ.]H>Z*0ooQwf<ɯ]qmf~pż=\n.5Y6}oџi-(~	Wρp`$<\\5wJkSf36ǧǛm0*@/WbowZl\'[ٔ\\6G,|8i1<2,8+wlUyu##ed	A3Q5Rp1\'rSlY(7wAO)FP]6~\"?BwMҳ(N`qدU]҆\0B]3۫#Cd5FC;ԩyN*)J-޴1vj.y1BǷqk\n*;z8jcq#c-aPF& \\(1(R^\rm)O7x{@*;=ۏ@s;Jʘ[ԗI>~4\r\Z$ACSwXZ{}ajD}b9-%\"!N_)\\*1ð5o3rX\Z&?V\n)K-M$A͌k	/mdӲjsEF<3g{\'mv~DEfM`GJy$:xty*Y߰%쳁^H\Z&E5CCq%.ABʣVڗC;7\"AbIYI\0:)ѷǥ`wcw\nNI+a\Zs Lzf#4C\rVv}iK4KTTb=2UኰOB`˳+T9]-!Ivs[h?Ƴ29{qKξД!I\0(I`ӷۯ	(hs-љG$%TBy uةxי;gdB]E\rr8ϳ+N+RfUPt	9xl2Ū[jƗIh*@I=hQۦх0rç\rbRvO~nw}߯gK3Տte$DvEZ6f+()!\"aDr9aC53{A{*эb2Kwwqҿo&GD͢a\\Lմ+^	pBJx7?Q[I!>@Y{<Na+⃞78c*QtS,8ν\0Y7tR~k{YD+)Y;]^e-+An5&_q4+SHx{?fm3`a󴻡.#,t\0W&;yc<qЌ25ݸ;Nk=xn%vA[y8n\n	(h!ekbHk[b0Qy7ǊE3Sjz$\ZM]68DzkTykm|-D68N?%aPŧ)]NC1CLW\\M!DJy7F(<\noM,Z`1OYﲆAQ2:*t\nhO|;z(\';wh{#6qY}6GWȏ!~Zãσ~SLKjJ|4<&Cn\roۼ0+ˍ>|PJP*ml@6Tѕ\"AlIH&dtM6&۵b8Z	k{<مJW~\\재2c\ntJmI!K3|M1j+H\\dyqE~߃!>\'cstZ*J^;6Գ\Z~IDծ$xPiAU-]=\rj1[Wf%>qp<Պ\n)^^c%Wm$:\'bL g}dA	,rwKw/>&zkʜjMU:~oh}5[;RfɈ5k_jQrQV\'dM2*^\0\nq#\Z䉩e޵ITv5܄Sy8#GyF$\nr`ZpGG*\rr\n>|Y&W4xW璪Z)\rԓ(ay{;˶2fQ,+<\\\0\\\'⮝	3Gd߬T*J\n^D1o=$(1\rۖ/zhT<]o:x<UqPJ}PII]y lH\npᶀu!4ߒjF\nz\\W|rbϒ\0E0+F7̚\r<!-:Z[Zjm`_2]\"{(40{֣}\rq;;)Dm[5!&`c>?`(ݮ>Hf=\\T-]gr{G[\ZxDsuͦޱ4EXD6\0ܗDCxbQfr03_LA_g20mz{T()1Z5-PqBҖMGx99d䁊N58\'Aз{}aБ8a;[\Z&+:3W뢅?\ryW$%[6Pm\\IY*%vbb<J<sjĺԴUz#Zv:.NMVrz$}9:qC>,|40F|=.2ǐ{E[rPE~P(^\\>]!r^8¥Z#u`x+I[0NM[xV\"2FqHƕ46#\r0J7\0[irB-p*iƭ1{(H ԌD /Clg9NvDB\"A@%\'+hL^^+#e).\\Q\"6z}_T4xma#E>uX$={+cܧloT\'.E]\"f)|nsMdm˸O;vWl+``B\\&kkhiqŅm	wb{Ag/Ÿsä6I--mDW42V9X-ԁ^LG8㸭DC<WFNB\Z 	{yWPJi\Z<@kqsa,jJ!wSޙ)==)eFKx:5D9@؂Ϩ\'<Mtv$d]#짛߸X[nJ@zvT\Z0:t{^!=.`8G?|#C=(6כiuh\"KS1R+/;iY.7/XM7~Y+/\\1nX \ZA\r҆ErBЋg%3׳Eq=v,V\"/C꒹=8uP	kŉ/LAN3)ECC=\0{ק\"};龡tOm_jWG\\bojH]x!+>Ԏz4J1~J9Km`v؋^GRf﹘&vcDOvcQ]P=$aFjF&|uPUMeG1⹳߹bۥ!	9~Ggl򪾨ȹΐ3|o?D^a@ CCN&PStizr{cYG*3\0ȇz=Bl3u@ÿc1,)a)qټqfL1J|b(#}\\EպʾUL&6\\Y?+c2$)68*Ȱ:E@}zPWE4Rc	ĉۓjڔ\'nM}9`AR)y$*[|˺VB&ipU .Vitt]\\;HIdDppSsJǢ\ZC2]h?ֆ~8lȪ4,Ǟ?𴺈lkJ㙸3g>ڷdGzfwSC<v\0f{8:\Z\09AB-\\\"RLFvɩơ-&iNJ)s+Nmugh2%.g0K>⏺G.P@J3tBkD|$Ts	#ya\\ګ:KB8co4>G1J`ZI=cBfeƷC\022JnMF2x<ƌ6&FL\r<\ZR#캝Ldp=@fIWX\"MB1QwoX4bxc)@D˥ka˯|9Y\"i*UL<6\'I>b5p<eZps}[Y!m#j%0bNtR&y.sE$i/8&s3o,\n߰j<BH@? agj%a,?]/1{Ƅ/:Qv>rr)qAo\r:;(S>B!V5R_Bx< |9\'bL*^Z\n\\ȩ|kZ=\"C(k\"!~53\rϛ$Lt*13p8At#?]Dw_XY5hn.ce\"ӌ	\ZS:vBi7J7]1kk1G¼,`|]$9`,w\r>-W7*<:gj6Tz308Xh^~m~ u׵ބ22RYRP4H9O}Xc@P`2_PVbBȭItJ̀rcGJ˴`nؘU\n=In}\'`C5֚%{A/^r)prAJBQvep) RNyHy+3H(H^eE1oy֌HFY?\n}Vք魘nr\0v1sN>cID٦I0-*F:Å=IH\'x\\\"\':*;:jl30dsc\0q|KF0_qYsBKbַb(7^:˽2dl@WHw\0	wWK9ٝ3C,wW̑>\nc6iS!ຉY8V#rQ$[)znáW;WѠݥpW]BS7jY4ciAW\\~YW4#a0<g|.JDSy\0aeԦG9~rsjJO}5e33mhyDQ(Ĥg^L\\FqA\"@[;Kkq?By:P\r\0!EÐ#MOzq~Γ8,՟/޸j!TNTح	䅬+.S^Qiͦ&YX1\"I+r|wT1a>00nio+\Zoo`yfny=Cժ8:ξeZTW0w X$q/£1S4ij#D]Uu_(K-nD(@&6oZ&$bX\\mfkJړIB()&.}_jhF(֫]*|Wjut.!\Zf=>/\'^OoE;3\'(?G>cgxWʡ̍V-EArDx++`c`/[΂-JHnOQ_*}܌|QБ\rq-FV0@Tن\nZ~\Z,o{l[UEX}AJvd\Z<`eaX9$Go)ոr?S*8q¾m)qppJNnxh\Za? 4FsfY2X7\n@k%|/@J:y$Lqrh)uF@1˞oA<TQǿ\r94Jb r1LLdO^,RNsSn/ħotU$D_P!d\0LpOk7NlLn\nq&x2*n;Y{uDW[dg{d Bsn9iS*LDE$Apfl_:YT^,FdΔPgẼV@P8S0JȪ)Z/@*6yR7,䓡D\rm}Q4%{{`\"2nE*V$ʷxcRYKSMO-vY |Iƀ^Q.aW(f˿b\n;UBgn½E9[9|<C+~TRBEnH.VR3+ֽfjv5+i#\"iR,k2qX8	֠,It8҂YܧG8)N*蹉*01G9!1}WF8|VapV\Z2$R9LG&m[ӏp(f$RzXZ8t80pVۍg<\nE:0o?%ڡcO\\ޱDic,7[8NGs?3UQf~-X5\rJV-c%#ep~8Ϛ]kdnOEŢ7?>A2Np$up6Y`ȏ#vR0u^/\'~,sJ$Tl>6H<oBr[n׬*ªXz\"ʣY_<\'}@iX^kVQ=ʧ!d~+Oigi!H\n\nu+o}Яn[hDe(ޝfO[v\Zdq|j?RN>AA{z=\0tWs	a݁iiW[/;qP~Sr|L8eV@5 ]UV1NkԆ	3Oʂل9kǋL[S8,^+\\鏯\")>(J,eh=UP|?7TvA2YB\\_da!\"QYP56#*OyԬ,s2xpFT-ou	TT>&Wm_xИ4rk)quF@IetʰKc5grkپSd1DSZ\":4RsGWėT\ZZ%u_H\"ȮV~	00jQaK0Rb=ѶX׮,c\n5ikhaߌ5>tٌ^8BrZ`^=1{K	~ظ1`\"L\\|w.Dk< drOj¼ڃ()#}GlJv)¿<~Ͱzuh,yqphO3A(Y)s0J/@(rO| A>m/[*nB_RG-YX/ZKq0$H]po=\'sX&͋E;\Z%*jf/i>;	Z\0*s\n7)]Vl^B>-t@^~W-O&4#h{Il1@lhbT7a+y$[7B7k;3Kd\0.e^7AAR&DGm1eE:âsl\\KǊmb\0V96 \'?nHÉvp\Z߾VۈZ6jjËH%fV֗M^^4\ZÝەt}y%Jn<~\Zjægmp(_YNjs>ESiò\"ӃƋT^ނw ]Eԫ.F=|V?\r&EHDu`F2<\"h	9ҭdЈVoc8Q1E/=\rX݃	h^/WXgjU@6%0I\rD4e6So5RZfޱ<Ÿv+vD>m\0a)7t2ͫA:yLª%XܚlYD};7s̻ƪ?ísͩ5D]#knn\r)1:\rxg	l!؜S\Zc/$.BEk\'ZFy|AvPUIEAL`L_2,Mt)of.z%ĕx\'u~ze|\\Ev2rĜv 7giUeޫtȾ!͓<AaOgĞǑK]Q_roXϳ.oA̳\r]y~1]	L(p_]p^8cLәnR\0R\Z\"\r hz\ZES)nnMRa\ZpK3=V#ejiN<V]\Zr?_}9zНfi`.=m\Zla<cGB\"$)8$W**fS/,Hk!]\ZjqBlGu%?ncfdvdGBwiJOZ@-.qHx7\0;4\0\ZoRD\ZJv\"(p{v;fˋ &UuuU^$d`v7fErR-yV*LgbJx.g0V샻ZesWTm^\"QќG(͢eK@^(1]!\'\\srKS#A/\\\n\Z\0c|ffś<=!-uW=T\0cᄒF`ŦO\r+\0pmA\nN85p BbtVV:Ϩ<(yk^m<e6amԮR%M1;@t!0%/;+(݀t\ZU)t	-b[)>\Z\rg6H\n w28+lroP@s>L{4`DMoaYmytP*\nDճ0AA\nkz}*$cS)KxX1Ӽ~bݥ9wEE3|:Gu,vlȾltdA4f@HeXqƁ\Zd%\n[Kn0!&^pƄ+nT\0o<\\?_.,OӔUƐfB䍎C<Zx0譃Ɯ5-Zdn3I\rC\ZHcAƨf}>^zTRsEy:vʋ8Ư<1ֳ-Pf@G\rGyƴ. g]Jz`$LKf<ƴsfOC|ut=)k% Ya@ųtF\\\r?vWCYnqC}8|M\\<d^\"ą9ޕANĔ򜜠\\bZ_uC,PI1[\02_H9znD	rY[\"?\"Zc񦱯g\r~ ǐV5?B $i1a0EQaQ2F\\>0/.\nw\'O-\\mo}%-\0{@\n{	ݒS/-6Rӊ\0Y\n痬}K³Z?A,\ZYum<slMaPL/+vwdǁSzQc\\N~(fZFJ~\n<ǔYMgE+UX57HEht6sǣ@x?LHexݸq*a.dNGkNךP\'hH>[Ұ[g-d9#	35{Gg{t<yS݀<N!)vX^\'P1|р8&dK]	E4v۬>t&gk\"\r+fUʰ4xY*RlգzUc\n5Kȷ84]$0T`1oF\"&\"9 (z&̱ȁuƧcujӄltȃogQfE-fȈIy\0]Qἣ(Ͳȳ(^zqp}ٳ?{.ՙGpȵ08S9M\\1ִnហ/{4ȻIŔqd<Plm,9/,I;?%y[.]_zaZ%U$DW-{};y*0՛s:@&O\nov#Ͻ0D##a~7ԺMާ/<]Ft֏\"O`3vTlΎ\rGW6,΃_{*O%EHL\rjMDѝbSF\\vl%\'Ͱ^3E>ˑY,XRk2QLOP(m|9pYuc?-F=DqJkfɢ::Kq35Fpu@ɮamș@DmPJɯ	j[IY|ԲbX$nG>LIɴ߁10Rzʵg\Z߁ԑ7Ȳ%B]g\"`.Eq-C96q <R_\nYBbS\"B-+GQJ2~snm1+uf\'sOdNtk9^{sx*X\nbsQh\ZP?Ly8&>IB+awqˏ\\N];L?sBis(܀zHO?۷G۠ԙ>Z	~yg-Gyvm\"GB&i7qʥv2Z}K_	jIl09Rʱ~o2\0?SV=ZsLMk;PhJK{+f0|#8:k ߪGG0hdr鎄\nljs!~BOl;iKe?>VPbAy+L/SՌ$.bne͞BxMgFhW~d\\1a\nTp@ǘvDz|3E6E	j\\P(gC?#$/TA}\\DU^\\m$Io*ẾV\0![ #އ*\Zmhp6o2&\\+\0P<IYM v\"	X8d9#Zѝo\nT#t9rd77:#!]6I03ѵ!RYBUxlrXwc<z!\nbOpL35pD^8DX#qֻ\'f.N!q?M*]- y3,4P9ƕˊ%(|⛩vq\0}\\lnˠ9HǱUhLgN{1W(w\n˺C\\=vpOW)[СM2SS{zb-ͨ4]?^Dk=3!Z=	kB§*PyX&%0V>\0VKN\"KPK/+R$f!띁>7Mi_\"4	Zg\"axh\"\'Mi55L)\\eVA7rdmĶbeT,WMz(=ǌ	<5/#PNgz\Z&x?49<c\'c:y4Og8ĲFG\0\nZ7|Aq+SO\rz~(fYaιy=A\r`]Ƣ V])#dOX1reT8k,Yh\\cYNiT7v1X~J=_[i\riJqo2ҋe}Xto|zJHް>̆Fñ#\rb48LI۵?2}̎1BSb`;\0&:Tu%f^ځ5̓>-Pc/srt)xK>l$,\Z̚Q\0u4J47:\"R,6\0\\̨tX\'Jܳaim>#Me̵ *o2d*_6c\nzpqJޱe X{~k\0a֒9pA&a&J_\"OTa\nS.7ĝX`j\nf}DErFJ?CNТr7eAVk];YE䙡m6%\\3de\nu8K8BTI)W\'|=]m8ŉn-`u&tߜSuj2kpW6{0@\n-t9$-VrTsYݥ/h)`63\n\0fByjZi\nFغ\0 µ#7fhCaT\"ё^>2^~\"-I-.\rQ1*a	D.6OG\npQj8.q}PҝJ:hQyyf\\u:66k<RV8:xȑ͈{g-Z}^0:~+>x[Pͨ8Q\\fMJJ8G\"獃N/6j)RV9 yORvnX3f%0y8x{No:KѰy+!1EÀ\'Uʏ %Ix`Lbɚ[_I%ǆm_|SLha\'\n	(\Z\"f_i\\G=X1!54V?g!٩!_#*B	:_$̻{ϛ@]ӎSC\03xS\ZN| \"hek>t3Sm*3^e9|#U6UOTbo~s/.yN+4[xV5+D\"G{\\u-TƩ\\Xi{ !7){d2SgzfĞMJKKY1·^\nbq<v`xKZW>GwΎuL%\0M0@ΕN:9R}5U\\_^s\n|Η)nS&[{T.6Yi*HY_Ψ4OoaR˯^Nrk/5έwJ.ֹ҈r~w=4jӐήOOy#MPubT2.tٰ݉ή޸F\ZgTi0bwiIL\0ƚ|C	&M6\"E;i`n7(}9/#T?DPX`dӂ|ћ:D3CSCklStUa\"6kHDUxKU>5Jʧ-LE{_E\0	RB}NsEC%\'ۓߟRf?\rUne\"4\0Cp/5|X@㺪gp.\n5_Uqڠs?K3^kǧ!\0޼L޽\rbգݭ,luݚ>-:[BǓ|*Cǣ@χ87!\"(Rϋ2\r\ZaDD{oό=_}+~(ȞevrC[mKϸ$a5QcVjv`dmmYQ,|:Kʒ%DL#bXWbp?\nQ@xHc*XOLa/{ؒawn\nyLIF)|#pSRNbTismTJ{)Aon;9%n[:mtog87PvZ:EFMs,6Lb!G3Jv^5K`GCЎLX]\'kAm]J7MBЙBz\Zk Vwnl)\rМTсFC)k|WjNɩZ]/e{вe^K\rs;SeD+Vc,/Nо;c\0ׄ5s+{u7^߭kF5-n!x`Oksu=J$u	8@Zx`#)+poPˤhzY[|`;]X˖<Rh#IJ* Tq\0t<bCK7jBYCn»̹)B#)\n@}nF>k7X*ve{}bIP0ιo-jC-WBBusٿ	#g2&*<Ԟ1V=(sSl.B+u\\ۧ-;-R8kp4C9RWJ̡f+VUm9jODzq蔷g\rӒdK:DѬ.AQ%8;+[}2\0O\nqbm~	+jDŧɽ5h˫\Zx$wB|9W8gk8Yljo\n`\r$%eG\Z8	cb#k uh(\\F#jW7\"eKCds2R\'Y.đ3E9D>	.2,!@%}1i}.k֛kgpݑby9YS[w\0m0H+\rq(2=]$ɆpLdGa2x~e_Za5ڹ-{UVdHrV(-W#Q?`GuGp~n-ғDjkh)fxwLQғsa\"o?Щc9Cҧ1 8,^2yI[u(Q-yj$ieYi{p\\8ڪf.$FL6wfj\\iAxkst~n¢^2๙fV)ʍ*^D.oR|D9O4[J	\"<Ɲ2,*5pGE?:zM$qeƭba2E!tdgj\"Xks	&Q=IjEN7\n;R}lpfVbmmhc\\J~9HJ$[x[֝~m/ȶ>ũT.),l;;o[ӆˉDgu\nY2.C0ÎM(Ӌ;sdO&hgC0u![+\0Ӟ*سjEW;>$:̈4dQ+aJӨ+`qs{9OFxvNms{Ӯ¾&j\0vS|.kӷĆ{线m-a.GB1n:sӸ9A!=׺a	LP:Ԝ̶:wyj=ҕī6xySy[9l:Z=?V2T%<΋̪ѬJb+/?B<\\|8W)\0j|(	yz633Wq\'x0`CAW\'>ݩK\"w-\0CV!)3UէyRԜI|y\' vdŌ#Ϯtԥ宂EO1\":9(TQ\"M4%&rOfA[Ȳ4ɏݐqU}R\"GǄLg+\0vQv1R2ߡ/Ɣ~Ϟ-\\ \Z@G>uyaxn`fw?6y}>m\nMR\rˢ\ZNtAFA\r|?\ZVyf`TØ`s[|CImyu>j\"e[8%\Z\rˤ\rN}RmD<k1\n%D{RӢ\0M+2Ӣ;\rM@jc3.R2-OeZ}{ 7tBR#\r\n0f_`۽\\\n}(nawC9-AIQED^Yl2Jjf\"3zW0YP{{yTzwyjmˬ\'fښGĒGN2*RmWF~mK$QՎ1m.JM\\kV?1 [`u>\0!,Օ>o* ,_wE]I`[3Ֆr\rGVpGG݊X3;՜5Iˆ3էKnLm\\UkJصlLզ`A^{Bb\rN\ZJ>#\n\"7`)w10.^Rb괚fՎRS\rG4(!OX*7Al\"&ap6fK)^o灐Os<A63A߯%wZ5-Dڼ@JS\\<Cޏ=s\'WI&\Z(vaToO,\ry\"ƺHoSvP	SKwcpU%(lfU}hp2+nDʭֆvBǑdX 1fvHy)l֚ă3͒\rΝĹTN3_*.֞&ur|i+Q`ŸM1U֠)8l/ZR=YpO2Iu>&˷uUĖ{kdo\\o~(y&jF%@I(.#5U[֋DB@i~1\'7Ö\0W2jʙ{`01]!֥\nc3*aVֆeƗԟ9ROt\rC_4czSsTAqcڷ59aO҄?tM)PHٹkώ%7f+$.~ӛMxkv\rns]%́Tĉҩ^{Ǝuj-{V=O\\j??f&:s[#RDs;ʅilbX.-t/ykOՇ|{W9mdJNRj8?|H!sђi{OT6{z480og3xFR.:+װ&䄇2C.aeE0,9\'ZS54G[\\e}*<|L;zxx?&WFf=x;Ҹ.uL)Ԝ2dL{035Y!U\nhq\\DGhB,;b&<C$H\n>TEGN`-*(q#ԜD]KXJnpiήo(F rr^$O5M&JDK0FNw0\\Ps-\"d,世n7z:nSKn؎\\X)Ш®4ʸcWþ#E5ӂe%/h]޲#ш9`vb9N/lRagLwԺQ\'b(c/:+~Z|\0u%rvBT iނNɫ/=1IDj0\\lM51(R;\\gՌe՞$_,j薶tC@ϊ&8Haq_/BuZ&?y=ӡC6d6m\\]vayT*fZ/8߬U(WU{-V͗8$4l\\L4y\rotf`8^`=@lTzŜ8)}~H}q٘\"[,T#H5\0F	\rRosٙ$ѰRej`^7葟%yٜM9\Z/\' ٞ4bVttkEp%~D`%\0;ٴ M\nWX\n躨||3ߜ++4,ٷ紱1]ֲlzbVPx̜=ŭ?/Č)-\'Lԗ x!Uw_nFa>e3;vztPi(d|\ZVw7BAzzMk+O5@&},pyF(%Ld\r*n=YNt,kL]*]>N5c	Ynl)\"qqpuu4F݆$ӕ_p~*60#?BTP|:X\Z@d\nf!B>j\\R^3VcZ=.\0܈\\\',(&M1^t&*/:7`P\nS!:b=.#R[$V<Z>f+mսRh_i;1zm6@d35(G\\ܧDoi	Pp*vw;X?=s|VFƢIdE<8mJ.Ewj#_\ZܞfnN7U//g#JKӒ]堹|MnYM\n}2 `Qv_\rzB^=څc:ܾ|@l\'e߲~چL-u5Zkw=03O* ;XJ\'z0ګŲT\"\\S@ޥ+0yrx9M,ڮ(\"Y<%I 0c+	Mv1ںQG䃞uGiԯg#dN,֢_5^W{KbFyPXp^Mƴs>\ZH.\rߏZ\\UDOtޔ&ŔLZO\Z4vdU==cx\\魞5\'ҵdջ`k_[aJ{p\ZE=(X\\s	pJTX~\\sAk\Z-=}Fb᜾TEw!}a}.& c-B\'Sj?t6SzåZ,jۂwT\\ +=ាb\'^xK.ۑ&\Z錷ې7~rbۣ԰<К~_m?##B	(ۥ~b%w\0 z9wsn>Dy1ۧ#)\"UGܑ]ۭM:EZ<v(@^eK\0۳}sYDk6M(kGNة\\B·Tj5D-8FQ\r%.m5R㖩\r;gPklr<CD0*\n)mx:.owpԴ6b@WFk-1q[42\Z@r: ӪNlTD,\';=%~	H``@}6[d=w\\+y%e-_+^J6^NihOJkfiBD̉I~.lvPgwv\r\"aMI\\P;b>꧒5>7Dublg=z^z)t?Ū鳊<)+$>S 4h\"hAD\'\'|6[kF=\nyifmR̗Ui؜!YhLa门b|\r,7@\\\'>0n+SK&sщ\\;Yq9wm3t	ЫQv#`i-1ٞUhܑǣg\n4 ]D$WܗEV8֋i;fe|ˤܝ.rYMDMKqĹzZpܣxL#!E~p#wp1[0L\nܱfXI`&:=^bKG\0.ܴ&#kpe`򷪱hfsIXNk:K:\"$_\ZgpSI{ǫ2jPfGi+YHK׀&f8Hk[%mrs+n0Of֠7yg\0x-8EmbE\rH	Zm\"6N`! B\'wCˮ.0{\'~K.sJIPګ&nR	2JX}k;\n5Vr4݊w?L)Kf4ٺ\ra~tnTݩzKuY.mi4*UTݴ\"cYO|D\0;.Ѵ*Nݿp\\/h#]\"\n=/MZփI33unM5Kh&bV\\%Z$iC1~s\\6rۘ\nΣ6tt|hfS?f_z`y(H2\nyπ8FpBkʫ.E\"y3(ɝO6Su՛Z&S,	p\nb!s!ͮ]>\nOj5RLCIeỔJe\0.SF>.wg:$\Z	V8{V9/jzbbhF+\0~XtǞC{%f\"Z_m=Z>D[{/m9qN9wN|\n֥sj*bTO5pp`)ޖp1iМ&19ޠ}D3̲ޚ$>*~wa\rxޥ\\}9QZ\rHO\Z+C3\r͇q,ޱ\n1$d8v^!*3#͜v@3&hN;yB\ZN 8	jxoXQl~?8ii8|LeI_y:&Rz<OT%x\Z܂it11EgU&21YI\nf	YᦊFrL7uSt֗pǯ$U-m ~V>򘀹EY\r,iՂ!\r2nD9T%T֖\r>ƾAY{,P\0~b\"܃n\0A=R<F{;xپ۶Ix3\nzǖ۝Qh-n&Ue\\Xj`nُ|&k2ʰS|I߆Ryrv@|z%Ӷp,ro;B5\0CyaFvVNcۊiBaTfX|jbdPCW>b$=Otǐ>G8jj48-sZԏsŝf?߅yRz5T\0DU磣	w̯ߌ\nrsgɴ5Z}̼ߌPܻ\0{QЩ#m,x\\`ar_ߔ}>&Iy	pby18gJ\nߠB.qf6*_-WI4K2ߧ)sg,He|\"j̋2(߹VNA=X\".\nŅi2~<gqԴTϗ~%>ԍ6m_5};[IFi|x7N*TZj\ru^kbڵ)P\0[\'.l7^\r?%RcIglQRx\ZˮR-SZo3ҳCAj	M^2ɖ<tfp\'P6߱)u@SCom94]2IeEkqh@N>އ͘RRSo sByc!l	MJh^`7Z=^ԯč1TgرDwhlԑ_x4\r[	\r+~\"j\\粃h_EV\"R҆c}oiӿFp&KIPʽD[E=3iJ[ax(aBtgP	B\"(QG<C<F\Zm_=|kBô4>]Ffw\'欚Evm8aĆJHڢ#eR7\"d#!E!,cl5B\\	W\"gܷ}}|CC0v0K\r-p4,KY(I xDQ/tvǹU8-4J\0)Sִ?k\"4Z.Z9\rkXe_^q(ѵ/̹h22&Xt-aZnmsNQ\"?mFN8?pi\ZhHz᎞O,khiYe8;w*Aފ&\'D:5`v>dk}<6 ȀKB۵&|UB\0Y;@7GJ۽揷+I-i3<e\n!d>a%+eT7 ҧgяd,w=	{|\ZZoϢ.p]U\ZeOlP&A{5/w?Z)H%K-xrNpꔨ%$,5%m,\nu(ޞw0KoHJ,a	rU9\'s?|R0AtRWE )օuTRYT6r\ZIZ)[w[]=`LÞV GLmJafo\0We2`:Z?^X=Gγb<HGwE21wha3(J@‵`iz y}fWmhGmM]H\ru:4̩i7[G쳙r/a4v)w}U+谆{3⥾ϵ瑉N)]W1+Z*ʠu<e\n,&ͭ1:If	ڦ%5@Q85ʂ1-5ymn*$\\lG*EM\nl׭m[-B8YٺdJ6S.V594*fH	r*\0Y㱿;+h<RV_u&R:ƹW\rbCJ9nFB yJ/adVBZLC;wxY^&^=xʆEs-y@Gy\Z}q-сo/@87?!c^H\0E*Iz3^MP4FlwRCH1\0H\rgf^Hq*v6Mg2IYg_,\ZI.&;ӾrV<SgU|4E+5C828ҝo\'?_8ۗ0]$47F\ZA#[RAr57{07f=9GcNyΟor|A\ZU\0jJΆPM6.\n?~oΥTXJ)*aL#Vŷ42B2,uʕn}~҂Z-36	>ӯ\Zz?<^޺%8\"yٱOlB=VGh!K<Jq;(5nOjnYZ5qPܠ4zgzBtWnW&c\'J@{Trq	*kJ+0}VLf6	ӆ`lI*H?6G}hoB %L@ĥbu(FHP\\ȯC9!cnN*NJg}Yv7Oh%.\"AX*䯂:roO\'7x9)yj?wk6(.Tv̯15Nb7ٳUw*)h	+ڞ\n)QNkU4JM\\V^1urYޥ1mwt&Cr\'BMFu\Zx/D9zH&U>+TKF(,`:7QǱ-FZQTƷn\r{Puυ~\r|FSa(J}ȟA\r1Pxzuѷ;gtS7Gn+Q1rgQ yg5.hfhm;k W8ˉntAbyMϐ;(uj?]$C&eZ%,zfw#nؔ50D*/rxPgb =#\0M)B\\eCAwwKHY\"0d~k:\nYïy.5 <ooP?DO%ڵN:({ZӌUJk#HT]^U\0Tją[ƷGֱ!IzA4N:ӊU	[y-)5_Ba\rc;pvgm-,_\"TP].힭j8\\3c\Z^@i# UcjHq.!۴	^U\rs;m幡F}I-6n$[$\n92%V0D2`qT&%q5y\nVڌHt:<k% (1.pIueIt9]\05^\Z!cxNdiGeAI@\'iۤz*bTJ-2<8Ko|nF&Q It-Z\r˅HF wb9ѿ\ZxRcI0{eQD {~aK\\-B\Z](5z!UN[a9{jB0PoUKjaWś\'yY曗>@-=	g_{-SP+fQp87i!*I6Kk	oyAw)}\\C	\n=Չ{o׶gbUh6XE.Run5jO\06\ntu=5Q%Ǜ|߂YM\\JabTjbGarU~\ZoZ\"Tɷ\rM +	`gOl:l}s1iJoZ3w/at?\\piEE,8)Tn,qSFzȲMRW3\\\rq1?XEGDfLSq`	ٷ炿E$>96g\0È];l\0l*\r\n%E\'tF䝆煶\Zf=?;[%j{jMa7痰fWeJSZwkXڱӍ~\n}@=\\YYC]Ǣ5cZ\rlYq\n\")\nSe]~&^vwŜv|چ`z`I{zC9]W9Ջʸoz=pr7\0H\n({S=gkyo?8Շ|BD137ţ遢\n<Yz\'jX`frQ\Zȿ4MF/-fr:CK\n8]PY5Hgb:<xݢX,s\Zi(6貿!gъk8&\\-38岟kn ϣ-dxj)dmx́߻?9ݱ|X!l%1+w$5Jck!ԛHFfK\ZR$HZY\n~P.x꜃ Nî(gFw@Ya_^f^(\rO>踭,\\qr*Llf<w;?ݚd t-8e0W~*>< *0V\04~tUgLQ磺1Zktx*5I鄳~㾥ݐnn\'-҉V>鈢ڛr],?i(R;}>QV!yvpc̒P`-e9rJK\'t>;髥ħgZCJo*^ɰ1NJRiBOӬBVhpC%Z}=s<۔[Z#g *\Z;1\ZE?Ic_c#ňM-[\"nE*9p:cZT\\:_&#`Q\n.	.E@ю.%Eg=N3>g|S(FjǕ\n;eX4PievWsoڋLQBWbexAj,prkjVi]A\"3#q Ɔ\Z)+l\0#<9\"ϕAvhzJ>AqW&zUV\nW8 `\0ayxHõנcΏͿͰ9O8^^]t*f%YE5<`Whj0g_MTJ\npc[_:E(.)&$*~(gf;c\0̢ce:Hb>R@\'=v@5)y&֫\r;&؛ƿػ5|V{׾A\rreAFzK`\"?EzcRz͞.V~!6k8W\'|ǘrfH	/A.ya餷#c^SA_7\'hcv]#\':zKl?Yk2W>-MPN`g?\\\n\rK\0J<ǘ3bxT:W*r-6fpxc,hoNI[\\`nB7$·#t\"Sm-C`ɊsE#)(A[h\'|kaOIh9A\08(?K\n͠ZNtaZf+Ǡ\nKbLDL94ݬJ݃ClE<aǈl.ēz]\n\Z:zs\0nĽ>e[7NJtt@`2Z\'SV\"*XAvkOxޡmdFFÅfa+6)rb4ʲg}SxvֻaʩD\05SS-*^Ӆ\\w%`0vl\r\n?4ɿr֍On_4`/-\'aYI|6`Z4\n\"l\'U8ykSlصA(GL8!<zKriImVe(iCx/?OEqi7A:3\r:?2=,+)̻ng3(Da!_y	QVGK҂sv@N\0}AvA$=08Qj`\Z98Ra>rZ!e%duH/l+ޠ.I6(웎yRj\nMx\r.s΂&쮝yY#ǳE	92vnjs,_Y{\Zk]ٛzJ^z{M9l+:A}00.@L3l囔\\HiܵxfLl#@Ťe+׹=So\nhѱً!J~ẞǡɹὙg\ryuCx;P{kyM#h.?t#ɠ\"z)`RI+_#ap[o|\':@A} E饬2,)w_DʉԶ͂6j40FSc\"~G8<\':M6/U9)OWT>S0\0;QO%$K	\'͕{)_ĝ#/q&O[O\"²,l?2j&,k$t3?iYϲYڷO5]I{ٚXLl#,\nWMbXzp)\'F{Pniq9o̳l5y9Mb&iKues<%qѬ6IF_\'Q73#5XNxL+֖}	gTj,)0f;7p>Dy(-s\'#֛XމΆ>풏9Fܐ𱐠dְH]@ePayŝ&)ԧ0x)/mۅrUz&[j}wREv{AG5Fi	y*dq]OX=>j*욬e3p]L}``DX1عWJ]cƈf	uJ0fj\0ցsZR~]*\"rdS2!{֣:=Nzg&$F,lK급/Í9zÜu\Z\"dm*\ZX͹[I|4r_xS*t^&/\\$r\\`ʳa7%eűCS6ǀh2.^Ww_NCnd,ypU~2ʩw:jU/t#L\"utPw\"Lx|(.ayѫu#\ZڄeuuI;o,1{[rѸ5b,B2+YGHQMp+i2vCm*iQLCH8RvJjo޼f2RFt	{[Ob4?fs^Y\0^%mp2X[j_aGv@2b\\\0~*JjT\Zw?/cg)eZ~&qN7 Z-r$E\Z3b\nNyoHNmQvaN/	Y!v46]3]3<ڗ<*=t󅡢pEKL[Mrx%\0b0qqĂ|x:_V5:USo2ҾPuA_*}~\'K9;4p\n+=UO}6Ԋ|}<yﭼ։Khxޫ(R1=~PwºT+In\r{M_໘`3x4L#\\rԹF \"$qc@\nCKnAO] `oCK.U8uiH<pShZذ/\r.O}9fPko2,=A}P#\r5k,PD+>J5딧n.\0URqk\'i_i,\nG+L.\rQ\0%\'ym_#?E1\0² 75mw>Z2Q2K=^NqQ\nIS}V#N7=ɷ5gD>h]3\n0_эWg1*VFIPxfvL@pR;KR[:[*w(1 yjL3ˇd\'V&}l]dOgV:5fHA~l!/6yԶ![^IٷO3E}{Yz#@XaͰ]()ck!~s~hq0X?8̅Hi,+x͵SE^>6\\V6 Ei*X,/6}%]v	\ZY<}]8c4=}Xj(	;wgָ,\\R0$koA{2#am\'Y#O(&\r\n0{z7jRv^0?2Dh4SG8RHe4ډ3z\ZrK,IޗOexџi}.kQ_39y\nb-5c,R3\'r.]9cxߚY9\\~fǶhj}upIXpھΩT/6FkTE;H	#ߛ{C\'Vۨ/H_n{FW?^ծV N	-js\Zjh߽CșIEbUa9e׽RX?楐1ih\ZҕXT9Eߎiц	v&=GVkr2C5m~q~;rfXᅸeXtŪ.+[咩H{v./s|UZAh$DUsI{\'\01rkDac#kQbm(({ia^\\vJMC`QA6_~jc,1F\n)7䩾!@	nK^$NVjq`JBZޅJX0u9>!v1vą>Ш&D6X]`=(fy2Э9exkzB46Hy/=u4_c	ο\'M|4gE;+\\)Hq{@dX{a2H=G6Cm:|!%p8Ug𿌫ANyqoʅ#&]#mVەrȹL=6mzQhZC TαiߠPom\\D5~!ЗeW_6|T->{rC\n=kRdj6T\'3H_cxNpnx{V@f!D.SJ/xknZ~q6Lꂨ$?{II%&V(Aw<䩻c$a=!3CPY.c%0b?O)Mퟴ[%>xd]?Z񴝞15q)9W/`kWV*_i_\'hMaCQW~K0X~D<>5O!	U\'IaӴ9+6fF7r,?OP\Zr(gau;YR>v\\?sk\\ ~mV|ݐ\0!ٖX6av/%1UEd_w\'ޢKGs*<vu.SA`\n	tp\'\\ˑ+&*u4c	\Z{\r@l(2u-VJˀzا`*#jxZ&\Z{C\rB]Y#<\0!_M~(k_MWFi]iˍBl@j!\0@Ų3pv`r9H(cWޏK\"$Gϭ\'6I\"Vɜ=0\Zh݆֭<e1L!ӳ\ZDKi@*SĘRg	rz2,oQϕFUlt*gV☲ù۬BjLNhZe%D\'G}wEk*	W،j|K\'lȈ<fdUƬ\\fHvIIwd4\"醗0_h^1-cjHtfݬ?D)\'hcF,4|iQlpt>%y1PbBR[B}\n[;	I2qU>n)̈́IxVV$Z=qUOc\n4\r\'R28F(>F2 \"Qj6h\'Vh~Ad7DcA\ZHzyIQ]o%<DNNM^^/jC9tbp\r<!!dep\Z	0mz%\ZN:J0L2\"L⯜t%>:1WRͩQi~^Gvr`G̃S$ 2|>YwMW[ I/H-j\r%D+P4g.{^W/![quT &gɖ\r.:)Q7ݣ h\"bY(VW|/5[rɷ*MlrnzWm:fO&y(H\n#_FD:1I}U\"\0HB&`8m!Uc%rT.qx=\0\"I8c_;k6RrE?{dG_A7c0+^Eh1{9U,%k1X\r LcN;<K{*kLE,t*J.	*歁\\5c%aPTgxȻ=|@ ԃ\\HVq2v5o,\07IѴE90.BAe4>]ySPk=9ifCu	l6E#Zt,#<\ZL4ZZ<&^SV?RÊ]	ͮ6RԤz8\\4wcysM)9@2.V/Bc5a\rRIG>?y;+\'SAED>qqa_؈K)A/YQ;#6ycȌʗjL2-[ 3]S.\\0הB/\njz\'aFL\ZH-L	`$p1/>:rVǙ=={OrRxgJ9G0>zc&IÆb4~*LQRkg!ifnb.*η$gwT#;?`?;\"AY|X;uaw?oabN$gI+R.e\Zptᣈ:\Z`\'8y`wW0PRƇ]Pd$*H9\n?g{gs	gOXI#n!F#Yȼv\"|:ݯCG#\nYE[Vwi%-%F\0[n1Sa+]BE2sŎ)?ԟB	*ZOےn+z`ߗ]^$dgGfmG8@~n?	x*ՑxkS략9URݼ\"EI {`z$쨀qZ6hֲCR=8Hΐ<>yy= ؃Gө&0*u\0u\r+M\nMƿ4f_MG%2q0/ғ:;eWGʈP,KA]H%AQD۞V蚹xRBBy%hWvǶm}nG. Ճg?rТjs$_D&֗H᝭s%vx-#?	T5)\\Np[>&]:.ѥׇ4UhnlhʫjF**\ZWnfrP#3w֢$¡桘3D\\[IwD=O$l\ZI9<0ox>L1\Z?f]t2Ј5IvC(߱wziC\038\'U$S(]4PcUv᢭(c̈́ɯTνڐ$_SЊ||nD~v-;&W0;7\"L~ޅLE`!)lʛhLO/̩3z4ΚC:Ufz^^Gn/pR1C̬202J΍<:_B!s*l6\"Q_ȹ2a7<\\U}\"As?C9`r0É\01yiN7,N]8ϪC,01Sͭ-abpYx{VcolNGqlkbañԟyb@Y(J5}׸dt`MuƂUz[w\\=ʼ\0[\nKix-b>,EdҔ\nN-\09pM0+~0:6r½c	h{M\\J,k\r?O\Z/ކf?xȃ9\rQP@\r\ZSz\nEOwF.P)n><WS)_]Ya\'kY_otr)CEIm/;ggŭƱ0`8^\\Ƌ~~J7$kSsYme(|.ŹzZ[몾lc읋qoןK֛+%؂!a29\n`F_h*y.ZۭP0\"j=xat\\Kh9wǏ;Z)K~Q[::js^Z@2nve)e_u!9]we<΁iJkNBSThZs*[?	POvDŌi*b*;ةDڨn/Nshwk1]\':&etbt*\n\'Z%$^*BR_~;Ak8\\=>J1~(Acqo%TFO-GzJTN>\'#.D=a:\'jK WHS`\ry~E~|\nRi)fl饔e})ld*ÀIF^ȯܒW@~ݘT`l 9睪PkKVd*bzHpf?@јݲIG]qM;>l\nA>khR8yOtldU^E%On޹~}qcs @\"/š|sP|0ô!J[h7e^JTuVڅ6bJR#ԲYunnOc\nizNy׊}˜.\Z^\nx+U1wz)\"4+B\\II%%\"ЖX~X4;;]*	&\"TQWvRid3m`a3\r45q$&Β9QO*zkBjdE,TgOrP~tgng(W{v^Z}ȐC6ݞ+?۸ZPd?P\\kO}H\"F+:̵LZKAxr^/\'D~4d`8`qr|\Zゐ5bT2ph=j#jR	𪏨|z03ܸOV1SlfwV1	l?.\rƨ;p-e*`[p5Uͳ{n!z[>ft4s^tE+WLկCҩχHhZ;P.s.1q+܋\r4$PduU18<KnspGRb:L0j}y슟WSh5GH;V((\ZB\0\rlŗBs#3?+WpPMk]<px_\"RLkiGGPP(ϞS3Q?(H|,;pH@yƄk}{[W{LG.vOǫ\"M\r6IcE,M+,ǖf MP[Y&\r,YDxxVތ\Z~VDZ6aW_tʩkgi\nB_[\074w5qy1Щ3&Ttȹ8=SPyYmmUIOF	!qO~þ`Ϸ7i.KK;3@\"_d/5%9U6>NcVMTpW \r0Z|\\T-BD\",Quܳn.A\ZXm,P\rJhxQ#\0tgFNv&W\"Ĳ}:kS-e&sc1hؗ]m3ĺXqÏj_y[+xEV0zxi\nF\n74欋\\M=OhL;-F\0U*/d.>z_MEMՏ-/v_څc?,U&\"R[R|L<uQRVxs	b[yiC\0Tq@W~{ṜgIU9\0ڡSwq\\(LpR^_mo<e{FEP\n-,5H:@\r%-,$yk\\3딢ߓ{B2AG<&%߼w$cTV¶\r|f7hCp\Z8wG+dUxXcѨV*6i(HXw6[|JaʹЖq^Oh;xA3-\rhM>kv7[ׇd̂zR<2K7II!1&j[656i8ntl*?/]\Z4tX*52.p·\"F6Zؙ\n$zz\r9`\\&S9~{-LKŝITi;u!7UeH> -%G(m\0DO;^Klظ!/?aFz#U%f{xi<f;KZ9ްNWj_H]͚VIR[냛BwsbN}qY7zoUu\'1k~P,oʂ-~Bʾi>1/##yXoa\\DŞhebh?)31us_sШd>V*R/\0ӷ~r%\"8lbκ\"7eE=n~͙\'2C/?	CQc2 Gehh݌^@˶\\},nۛ~AF,{<nн>!2_Ud~p7O\";}\ri\0', 'no'),
 ('scanFileProcessing', '', 'yes'),
 ('signatureUpdateTime', '1588437834', 'yes'),
 ('wfsd_engine', '\0\0\0\0\0\0YwW	OTvc;odƛ%H	j\"G41P򨪇F\"Avl7k͹러~Wo>]O38wd?rO]6鏷w7OVOͧ_ϿrͧvϷϽv:A??pn/OY/7zE}kwWÇwg/7ۿ\'\'w7_ԫ=oxW?\Zc.Ou\'[k}ۑۻwO请_vïOOn9_?f3Ƨ{?]Ku\\3yֹT[b+)Ww]_XwUzw|o)b4˵ﾻWUm,;RL*ӷ9Žy6MfI\\%vCI&,rX6or%>|: g_<͇~]ݻx/?//_?g|{χ?auvw_z~ka=}V[x+/}?n|6\\g:^,i}rMvqbv×e_?\\|lO?~;~o/}&w7?\'~z<z9oo>ϷwOsVǿ>?.ጽQcZ<|W?;|)=#}=oZΗ_-{x̟_,6;r\n{ծ߭ڻv|-ݶc1z{p_ݳSOmw>T\\xsϏ~~;DƲ-nްx؆ü|c<l~`7>>wLWoLාg<-_~Ǜq}^ڦ}U|cw^D+]yp|[\\=޽|wo_~=|~owYΟ&~M\r_}Lm?O<|`7wUGCZ󻻫|Gqoo+7hWo[|fuw6~cy	}N_|_8pgʚ~^84ϿzS/|?훞?{3Jؤ?>|u+awov&~yGfnw3n3ʏ_߼û]C7kz7{#fO^I=Ks[_#Q]z+q͗ŉ6,eyer/n|;÷nx/p2y!NnM4k˚]i9WPr&V\nq:Ӊ>~G\rw\\7}O?=zYK磻jW;&,<~G˹fg-atu=2,W~~fћw7/ZrO[B̀>Si=h\Zs1֖@o6uۑK|~ѷ~AWo~Ço#Ϭuqs٬v6`jumiy4S,k\\Zͥl}Go>m3-n)\'B9%NV>QKamRs\\b.nOZNo;gB~cg(s)e%ŵz7zޖ5@:iX-cl]_o7twVkks.b:^eZ󈩵a?eM17}~?6[x7y[іػPK13.+[XoN_0>ĴeK,=߹n\"߳}ۿt}vY܂kd%|q&[/q7lʓ{?+Z6A:\'11Fuڒxu9\\Cy9å|4xG2~槫<ZgH!Gi3rk̲3/VZ\ZXޒ,X\rKxsw^|tG(d[:5`x)=4Ļ%uE8bo>^ڃ;<<~zsͿϧueK묉u5q⺷=lh~t#V{6bPSycTqpʈMg%8XzD35;vv<Fڻx\\wןﮁea#6.jF7,l]N,bGeb:C<O˛OGjm6kk~$])|㜄uz~To,TSvs~\\헛oߋ⿹圽eS1%>ɬ6/%1je_g_cYR1\"S^vIvX.3N뱦L25kuɝm!`1 ̯~oii\\p^m2Ō/;N\\g|eX.ӯO`/\npr5wirZZ`qr3ܴfx\Zlomݙpu?֟9Zo~~::>Ťı[<˿fYU5٥nEk-4`w83۸GfZeM}unT~=~Dv5.,>݂Dpo1-rG9knoNn1kǫ+>Ețb\ZX[qb6vJ.\0bpNWl}B7կ>b\'j\nxSQ4!>%0rFV\Z Q{!xm\n\nN=6*LmQ(fce`ifuoWw,A+>0頤e6#\n9Հ9Z眼?]Fn̂7T@kz՘h3a.\\0<Dہʯ.}~s\n]f`[ùV]x)\\պ.h<&-BvzOAsxqpoܼ4Xe`faBx2f*\"Xj(f\0!-ݾǽp\Zzc\rFS{ۜM]Ӳ0)tsDN~Y[URnQ&$\r޳PORA@\"\rgj=x}ؾ>oTUԈ\\[vQ|7Ιv\r#\"l|8Hҹ\'5Z(*֥.\ravv+ǟ;d%&P|b+{?lrT.9A{\\ez`\0q֪ZSĢ\\6O>6;⦡\0VRiFHqC\Z83qˆ7c1pd?u_<]{ǯP\\-];xp+7\0\n1`Ӱ+Z=387WoN&km~,La-Dp2˼F.>Mz~/{nL00ܽ-q4 N;܉@e aSxG{wy\\/\r-q/qnEX,@bF0@%n/w\'Z],۸5Dci>aRK3O\ruϱaa6%\\-/=X\rD+Ge(ux	^[q@^ƶx`.A2+EȆ`K*aq[He:|mL8Ea07X<d=-\"f|{ۛOG^r_n?q7wShLO+zw k \ngG&Fphr\0{E󠠂7\\ndU<t9fX9	©Kcs/~y\r#?e厬\Zy+>mb)vX	%+ԏ>&t|w+L>\\&aW!nV4~0f19-\n\0Q<an\\\"\rl!7npg6\n [@ȩ|XU]#|pAc/D9cdc\0TA\Z)Dm1X96hT{i1+;e-isվ^> %[LNȒKAp¢!c<iJܾGE\0C`#P(2``ca3dEՇ	[v+6p\Z]T8FH/,q,x_h;(_m.~,gi\\mB:tGsd%U;x5ղbHCۇ_<ŰNԬpPS˫mXC+65}T8@r=-	cu}2ǁ:H7\'zq=\\T88\'RV+7wf/ՉB<\0pa#\0`\0kiv@n2\\\0Y><\0No_bȳ}+EpxQ\0Mt	\\G\'ph./|	\0ܿl.i/ˋY\0\0ձ\"S@Ĉk\r[<oExly0#Wr|0=gr/κw[=|?䇐)9XxN665=g&B{.K<GUϬ[Ygb5#ΐdB<ғ8={`ҬQ:&C~pNga˔Wwو\r0}mru3 t_-N\n_^\n OgǃԹ՝[{enw	G}\r4IT\n\n_s0;7z.<7V\"Ҹ%	ؾ͜pG~E?S8\rXcb*p%af5|fR<Ocqݸ@25DUKyQ\"f\n(5`*;ŃM$cL*=rFR\\䭭\'(ܿ]CY덌~;	Z\\xjRU-a!uŐ;X]Z8/CI`,]IEçmV\n\Zzm؀J`|_/ \0G3lЀǜǂ:Г(Gܚm}_|7GGA3B`zEѝ=5	4xU0@<ۑ7A>/r\r 2t;`mpM]͗nNJ\'\\ۧ\nwJ;]\rīԻXnEݾYg1J;8\'YbX,;f{`柹<\'aF7s\0VܳTXpQFl!\0цzs6yS$tR:ԦG]\\l䠃G2|}>~8[i`zY_TJB@X|v1Aʘ4>+6>|j,]v:\0>Q]rჭp\\sb X 4{`\Z6[8}C֡%wڱXqdΛwcûdԨԡ%wrsykTT:MvߟPr\r~uK[ˀrK\0X	;p8umQExFzɫgN~68fsg=P`-YAi&V~0b.aGKrq($`4i4q@P\0Xc\n~yx,_#y8<ly(?<g`eKwyfAB3Wqx9-kprM(̈́kEJ8Tz9p~\rEr5!7[>ElcƄY\\rq-7ds>\\\Zf%P.&\ZӺ\n\Z}1@.f}ȻnvstVp8\rT^?A@^\\jB5q6|3qo>}Kiv«pTErb\\E孲SZr\\,\r=2sz7v:DdytS VQ|D}|ed%yۏgv{c2oAAmJJ\r+\'=oj!9.(|DLl褢iLOM84A&\Z+]fBJX=.sy-Yn7PYkJqz%{cU0*Bq\n	KXsk\\Z=Gِ1ƒ2W TE|ePUYyױFϽbt>ި-Lwu̞h=/+v裵 0\0d]UNΩ7cT;c?=%RA3Xmxh`Il6.+{٧<M`[M\0ppYJ=\'WJo2vz2Q/ŝ\Za]s(/s(	|[@o~vuG>\r)/ٳk4tXT]d2k-hp^ϰg~h/+#gán7N\'S[\'b\\BXUcU曇\'wd0m0eQ\0lN\\\\\r`@F*^	KS/B\0(z.p.ee.rϣ$W̟oo<\r,3zjn}FP`@_C(O`+R){/ul`<>T+%V-L4q껎Դb;Tz|V(n]_S,qL*X G|ExroPm;Р\ZΜes`YǄ18@bUlC_B<ڣ-sR0t;_1ֺ.@1c{0\Z3V@ -^V2?~:7289&E;z͕O*\"Xr\\K/Wv]Yʏȅb`Ϯ%dFU>ǳ`́6VS&u+n/@/Yk/D\Z̀\ZA`ē[<b\'nywygn($fa%̄k\0X֨\0plE>\Zы\0c}͛O0|?;	\n2`?\n̓V:uWiv3}/SN:6\rvߔބ<D`\r;p\\?.6|JA7W:xyC:b):eTlW+iXpՂO4n6-P?hjdz*65.<z3`1.s`TdΡDv%xNlM ;1ɧ\\ݯ\"[^ݽ槓\0ޏ脧m*:Xxh+լZlA躬bIXyϪkܛO?\0y8$pPةRp\rpZ\0>ɞsZOk\\[l<عzV1ؽX5vᇺVrb0.|6PAdodڞ<#͒uJ@P*u΋|cB,ybYj\Z%=GuRЭoOՄ\rworqu\'P\')@-]k8rV@+!lEoqULdZMiQwN+`\\al8lۯRb_><\'N\\K욲|Zwae*?1YY}qɀVNCJnsۖ\ZKBWlp\0\Zk\n.5s\nF-\0Q%]s.pEĴ,byIe|glfWEzU$\'Cg;Q֔hg={1&u256Z|5!o-0ϊ8oE HzkY\\T	|]\n>3\"aU	HsK=-WcOXzDGvW֩j	[T!\0b%%n?}^J	{9\ZZR[&\0JNX!0xUatmkN(9jZR]1\\kp\00xLE)M5zQWHHK驭rbq9V]oe0~9\0BmfSd#ZE!h\'[4Ӎzǲ5l>#4L͐aGs	T=1*\\:E]\0MeeUPJrxl̻;M\Z3`SڈlEW.-93`(r8Tޜ?UK̄B@VΊ+ӧ\".+.K\0:lE|ĥmEZP<#PX%SRxz2Lm5U6\n+Prk,\Z>T́\\`PR\00sf_>ܟqd~V6iFnB*T4+VsNo2brev`QYV_KX<IUxw^c*?	rIZ1>[7o\n:W1TZCWOaj;c\Z؉l\0ȑUQne\rF{=sAѰZx&@b}pA\Z\Ze*@qՂBί4dՖ<IGaϪW[Dq 8uLXL&\Z4ו۹\Z?K+~-2mđ@f.2T<\0lj!kNƸф9\0á闭j$Z7$2sS80^8wusXV8ox\\FT\Z1[^ъV-xزH\0بmTZN{̺cЍʸ2ژ3\0}[!]qf}ZT>C;;?9־-f=F|Pf^rclM[ǈ\Z~X\"U`dq\rF9@}B-5	^6SLtđX\Z-{`e7c<+	XTrQ\r[i:>~a\r43$C\Z^mMoe7If\Z*\'\\{3qz!q	gYU?`^7,S6oWHTڊ\0v^J92!}H6#ok{y\nȷ_ =1k\\0UÃ}qjPSpU$NYM0Ed,\'u@Y`ɠ{uHٺB!<EMNpł]U[w{NvCpq@X)Ul48pc=Z7z4Ii\'c\'.=XpYF}mGgv)71rԧAjjQ*FFU?ɮ93av4b2\nr@?uyAp_R<v1ޣ?E-cZ՞`(Psna0./뢄+[uHit_>hEďI:~jqc*1i\nCx\":M^]*jARH`\r2b\'p=q	%/vUqQ:[9ba_D\' L&.LJ\"F+b.kh`\'&<n.\r*[0@nź~%YL$cJÿo_ޞ\\Q9/=,q,*{wc\"GxlZph0?\ry|Tr.lxH*<$*%T̀na8hE0\n&|LP@Ix0e\0rx*ǫ|D>ߏȎۿx\rbt1ٰk[ !Ś-BTU:W]>ɆQ\nYUz\r͋VP}	eڄ(WΏf\nB,4`s\Zoo%Ls\rjW~ۇ*^^\\M![1y7?JS}\r6@mMp[j,,Z)˩DP8o.NgLWlۋ<5[ -J%[$j$F*@nӕ勂7e򋪊5	|:]\'j}w7h:*\'WV[6u-WV|VΑ٪LPǟAm#$\00G0g.|6U8kLUqa$O|rwj,MjJq[ai)\Zo*ɞ:2 Ŵ.+XJ|wWwN)c%b	>EC.M#e\"ۼ=]p5E⠗f/;B	cR3NKt\nˡLn2\'p7w\\u{)S\\\0՝cEHb ܛ	7]DBpJS]9IOQ~JEKʶj/XWaWer?[tܔ\'\Zf?<ћJ&D\"y,kCKVAvTT^TY-ά(o;N9>7U#nzʺ-\Z\n	9۝?c~{#]Ɨ@zSn΁jںjjDnR%譇E)(>>ׯ28bӵNkz`.T]:>WDVP TZ)M<x}D%n^ѹC\0j8rfGpY,>hf!\ZBK\nrqSjȘy(M1Ϫ#PPqQT/ħ;Iߟ߸\'jrÐ\'1lkس*{<S(-vmjq}jB1>I\080&Pjyc5%q!\\`#W^70FۤW:JYF\n֩ǯ<T)Q2Wy\'(\0Eȓ_ƽm܍J2nƂ\nT)V[pZ|}C- GsBylSJb+݋e\\+E\rN=8d!Bk\'9 v;\Z$E8\\/#%SX5jق/7M-n\05LPbpX$^p*)8ٷ[\'aÑ}VoH-J\rZY&J䀇#A|9ܩMÏaZk\Z;F1.n\n%t_\\ijZ\0Z\'>$`/܂,?ɹQIc8T֚;ZwSduٍ\0D=SJ#{\0g]tDv(?YQ髚4ɀha\ncvoiAq\0$Ճ\"m\'qFTK*H5W9/}栗wW W|	os{O.Mz Щ?T\nb>VVüƥ>7n[?}w}89uX62:a5\Z71=C\ZDg[,w1wn`	Ao؟4e-f?PQ䭦TfAs+c)<8~)}VΏ.48D!JcӻIP\nU_kz}sݛ#j^r_\rM5+%f01uqĘ>f֠VձYǽ1@B.3wkrwIDOvP.˪-zNEȢܦu*e[0y1xLV\Zp,-dWNfeGֈ1:64NmÜdtSo>}|_fۆ>W(jJ\0T?g3\"AI\n=ޝԿ\0#lmJPW7L1@kxi\"%u3ǳD1dC\nKg$\nmR;h\n)cuea]99{ΏC9|:46N|FV+=LP86aXdCN#tZݒ7?|ݧٞu\0xE-yXn|Ƣ^Ğ\"UXp\0pvWzqR%{	GU@U)\ZOkH\'V;8;i^PeZL 2uLݱ5L/Ǣp@ J+8XJ4QZOklhVÃ.I3cIؔunr>+&W̉դW;ttZ@4Gu<y7{G^Ua\'Lg\"5NںnSQϟ~kB(w/U9!º5ލ(7S)w5թc{3wvZvfŬL\0@Չ%I۱R85vŮlNCT;tԟ\"GB&|9/E>ްW	UkI_1+\"FV5J60\0?สt`\n\nbo`VrVsp?d8u^N~}SlNT{WEv^z*ׁGU;@?8?UҞwiqFMg.xغVUx	ͩC{q\"7\\?Fa1mXqwϒ(0ՙl~P]Hҋ\\\'{{1z,w8ɧIwOtՁ!i<\Z6x#(X9%AA-=WZs윛6Rem,Ax\0sRl[M\"<xGAm*_\\\r4wB]6..k1#%8x|ޢ%W\08\nNjB.S|bk«5/e[F\\|wGd.n-OwgVɂy\nItqV=@$`}穃GDtApZuG[0xfmå[p;k($SndKdY\0,U6 \\VJaBJou\\H0X.FvsQs*rif1Vsij\ZȰC9}JnɊAf&3O2q:7{yNIt/{Fz_O3(7v~bCx 6ū8\nBģ&ìAAZz݅Z˔\"edgUu2Zrvp+\0hWƌ\ZA\'׏	vXWF]1[k⭸^}pq7!es|dN:y>MB\nFJ+0F+Hi\\a\r%b7X\"q^\"s<I=@7Zܵ40#e$9^f`o#]]~6ma\Z#GaJZ,.b,pf5{ujq8[l)?[|=RaOP((\\33u+0άҡ̊kU?WNWLݦmyV\" u*\"jj=g]0\Zi~oꎖeJ6R©\Z\0/VgU5nFNmp\"b~c}bJeXgו5*Z}F\Z 7\nNźPg{F,)\ZHt`&㷢 j:\rL %\\fp]_x!TXs1T-ZU\rkֵXLm4<^L{|<\nȰJuTٔXdQdZ6*du<ri{G?aJ|_}<ۙØX\'ǭklqIއ9־)yW)~|Y!$%sQR?qM͢*\nFIŲs<cOW_)t9/(!OPQB4\Zfԣޔx<HCJ%?^:t_NB+C*\\p%2sMeUdJzQoFjM}\nYXyyP/uL`rJ\rUc<\nJp9!CK춪o\ZyŮ*ژMH\\$t\'%7|gMb3e[;x,Y1lp>&>d))*;n}y`_\'@8mϓُC;;\"uj$NTNNYp@˦2PBP]\rN݆n5	(<,]x𖌆\rU\rw\n\r:	?)Uur%1>^Cݏ5[pw9jıJdӛ{JCٱ:<;tQz,cS:\Zptbb]\\ىzͲ^_0.1\'͒%Q\r͜6{%l^0bF7%ϷO#\r3vʐ0T*\nŔg;fQy\';$ma҆Х&!(>wb_.9}$疚ڏk\Zv|iQՌC^˒U}\0!s6\r߀	_uߥ{XO\'-~Zذ2\"3%MT\0[0~^476\"Ҭ~Q#ݫid\\5T@4K_\r7ȭ0ֲ1TϮ&Qz\"!Kr}5*qP,ki|(hR\rlWh$Yd\n.cʕؠF,fs]{5LS>J`4UĈxU:	IbO1|\\{*^x%}m5sYxALa,|uՀԴ\\F/iJ7bI˪ވHpu\rSߠg*~{+0|hո6ů\" F,3m\\\0\0{\"|F/<}UO\\JM5cm\'QR骁kY u)_:%(dc\r|%,pwQ pVw4DRzQ\0aSR\"fvf=\\Q|s M=I]G鰁:\"4?C)srVb?v-GW_{ݾX<nrEB!\r2a\0)NO kP\'=\'a/fq-Xo	3ӓ4G\\+V]?.W̫bWn-L\'%@l(mW\'3d]-^849-\nR#)XͶg\'uU5Iqf*J*İ:Gw&_F?\\?f{eFR\'d%AВ	R)qliHݞ\'r¨+7-	#:q~55\n֬i3	Q	o/W`$1\0OmXU38cFIHUc$oU}ؗU-DUmrN[ve%KpoO\0;ÇO\'{lJ.$a@~m>Tc,Bnb^fxhʬ\'f`>@@9\\%Ab\n.`u^@?+KjdwI>31uoa.Q\rELf6bPhow懴ibVWB̢way7.\n\0cH~Լx9`>ەwvQ4URNt[m\n=FU_!{vJFiM}eܔz+whZӱ`/lkثx|F=(Ql\Z|pbq7XMB !65\"x$+XE>yIq!`L)S7sԹM-z82F(|=5zƇ|Q@\Z]an@-]5B\ZVFx\rrY~//xвim+]Mآ^\0J4ăQrg\ZǥQzCl	l>3W_>!G֥\0f\\q!`EMҨHsS>VȮ:^aџg^TV+x]2ɺ\"U>./wyt:q-)Is<>5Q\"6=#/	\ZR){6_@v=Ym֪/~\0O9\0+=ԖbnN5XC+Cv^x4^Â%KGj|*a0_\rN=QbY5O^.Ko$\rp*0`>\Z\0O$ԥ!\r\"`Lp^V1jÞUFc[qiURGqu~TsxQDy	u87*lrisDL3de~b?!ZIG.pSP/\0\0qQ0?^CP1ɌEghTn뺂,\ZU:6q+%2]|wZ{~ÜD*I%MHXruCtB>~i`Ivf4HVdF\"0X\0zOi(VoJ\\?,o돷?]}x{{%:&,i0Ǆ^B[:QzX(	+]yIY~[,Uΰ?K8qdܾĝW|\0lq\rb0V5`x&>%O6_:sB\n2%O4;[5쀓$FTŭL\r*ǃdzYN@iF4MUxYjr>#&?IPss,ge|)$< WӋD땵,snzN<T\r)ҏ{?^rd?Nq1Uqc@zל\0-4MVgnn_\r5Շ3\n䌉-]Hfj )nj^sT!i}>֮¯7c-+\0D\"7f.d$ΛgEM\\3]hZ+[-Vb[0gdH\"hɽŬnq/Q{GJ&@Lb6.𣞋l11Vj6<E%D\';\\آkTs;TƋeJ]_%?4l==\rd;e\ni$vWgԄEe>פ)]%XNnM+a}f aZjtB2}r5e%ie4YJ EPj^L׽dsȧOcajpT}ܔmF&4o>88Iºo7p77O4\'.a?MUVM# Lʋq.C]FG[4ڶqpE%x؆?CR&+TkH4L5<)D{כyWUQp.삱jb,dj6	l\Z4qY.qR,7	u* 6I.WClyͥ	Vb\"A>T|wQ&e*	JP}3`H(׫Xî\nxlEO{Z]|DAkKVp}	)W|R\\.s!q:\\/\'G_kɪZ=4=G$IX\r6\\jآSQ\0F`<|>O\ZK}pkzehL!07WTx,y|{LȲI,*Zo(2 2a#	OR`|,݊.EJ\Z`x|L!ͷR=`L!ojCv](I]_\\\"5B4/.zk*<ls($|h:JOH9Gƀgk\\Ī:M5f:J	f\nl=L!4yH[jFPX̒}pd4M\"z.7{\rh-Hn4\'ج;wY$34Ms*)[{*4h?#a6J\0?0`x@[I>7`C70+}Po=]24R9Sb\'6e)[+ʧd6eXw0:W!E2<]\"[-8#jWf%z>e]?I5I٪-e/c5\0h)8Z<uѺy|\\Cn_$U֖|jfYTsƤn祩5;ڷ1:a f}O*BC7չmЈdHfhz\Zچ5p%*W_o?\nQ\ri$c\ZuU9ìUcܢXhE|˚%rg]O!@m\'D4ƒ1py\'b+jj>r!rzS䍃\Zx#Xdͫ054\ZۺUk8Z#y\Za.sQZc-y\r2I0}CÛki~k}vV8\\-5bW+Fjy5Uy&_@g;kG䜖&J\0?**&E@O[pk9DﴀV`N\\y*x>M2|Hy[k^s-YR.l$U!\Zd;jϴOܲujde={	-&UXhٚaR[հvgz,.g2ЬYT)%\rYBhOm᥇2+Gt\0jv>c+76a$Y\ZFb_/ϮXm	ikR^We1\"Оgu%,QL9O$\'NV2 0\r_\0҂g&\n,t\'X)<֫sdJr)r6 0e)sYs\\IZ	#A JEw&;[疐UbYL^bkQ0rP:<sUD퇛ٻ7v\\;z\0U]p?♍\r7Rx$ZSf߉\r?\'w&\rƕ4\rHyAJ٬u,kUh(DgUZiɏEЯ\'Xk9.k@7*kUt+ߵ	ά%REgDϸF\\EAP8u9y\0űݦvRǪܜPGkpu5ifɐl,PjY\ZԦhIq,?ˋ*ܐnDe\"KO@_j`1EuS&h<gΒGig{5*\n٦%Xan,o4*O{w/qɗnd+ղ=?an0@Ze̯X.LRHCa1j\Zr.?$wk~WzQahcp0Vh\nş%iPsZWW֋-9\0X\no-+rH{%`$Fr97*;C/|?[ۛ3)^Nu%o\0YUT\'G6\ZQ:W˸|IxhWXᅍ88cJsU~N,ڢVUVqOI$F\\\0	ILpfti\nDz١y[N\r*]}~DTdJTa&JS0CXʢ&\0GȤԴ\\Rw*nK48T0ErBkL>¢7l_Nn&֌u\Z-#QW T֬IULK1^-Ӧw1sxUi-`ejt`kKIa4qRgo${UZө{Ր`J{H\'W-\n`,Awl24\"lGa֚zRc1\n5ť7`/>t|-F?T(_ġ]ywovKAl5 rkXNRKUld!.6K\"ㇻoOjxDR@35V(wlIe\\bK5KL*]@YY]{׋ꆭU\\!!`d(?Q-|wq2T*fT5D8B=}#j,N\'i)HDs/W^G-nkS3($lWӋBq$p+Q,14M>	)z<>]ptKK-)CU^7ZsLnkc׻sSh;0{d$g1\')Oe^0%gmѫ:43+rTB\'f?Cr%3\0Win\Z	A}Hb*7p\r]w߃Q#oAhWb6j-\ZB?Sݮ\Z4@M%i\"g|9w\\ڥ®K@yY	7f8v\r;kl,f8ԨGϭAOek\'ʵE3&NT:zt&Lf%Z%ʶ_ĿD!R7In:snۘf9^%8WFybWK_[fJD6$ɻu*-q=Tƫ~9Ww=\\ݫ\\eQ*`Y:b51JitHK=0ڸZspzxw7O\n0q~تT\"iRkN}	ʃB\ZWIͮ*y_!ВWdx/Tx9T;x!Qu|ƨ\nJGӯ͉z&}sWęM5*1Ndr\r*>,\"8˦U՗jk!E)S\ZnkYtDckHGYqYUHc4j/V:=^A~:o~[g)̐~-N<L\\^\\*CNE,\ZφjWv07-EZ39{UFX4gIN΀8Et~˂2E\ZUBF\ZxڽVh>\'XJFSsBJnN\\	<O`\ZǫA*Qm\"#Q-MB>EP!GJF5YGX`<-]Z5.R:jS9qЖ=nAxZ\rm{,KV\rCS߫`|f_}^*Q}37-B[R-V-Rp7uEL<qbI+>hloi~ι\\X>U;0nYӎx!O6K[	0Pً>Gr`ﶮ0	W:BM)*}\r!ؓ+g\rc`	%:xLQV\ZH2x^Vu)j0LeئsWF\r$[a҉i調5Wܑi;[-/&a*5\roMN%}˯驰yYa)ҫg5u\"7L.}*rlIʘ^L\'\rY&8S|iHE(,,q֫2AR\\qMeT}{3wD\Z\"\06C^sp{4Cvn^KyKIܽp`ZC Wԯ/@nd~3\'7*|/]z(jΎ<_HKQN\".f)U(>5Hᓸ;~DO\\U}KרKFSY&,0Ux8\'܂)THj\"ajh*aP.O݊yD^=B]E\r)y\')V7z7\"PE@4(p̀:A/NP؎j02m	eqSXd$5m,>H\ZuW=O,p\rV^RO\r|Ez8QPe\ZMR\03JIۓ\0OuGT픾[!w暤x+\\ZOW)uyVXQHY9X0u7l\r\r[*}׫Nڍ\rgCTIyk\\,/Ll5=+#&זLo]4+-ݧ㑩sZ@xqO\0<[\rO̼u*\\Ǟx>\'odoț1`s܎`p5ՋpR{H0h*\rm<+:oGS\"\Z5J\ZspqSE[qE+2^W58|L*ĕ\0RP;>qQ*P:0XŖua/ßO^9lJ?EAQt)KX]ƨn*U{۹r+&h\0&&`퇂ǝT4+O~M|ux?n[FF-o?l3I9/NKx*htňcw&աw\'ǭ$~8J>W[\0\'K=L\Z;\nC	Ps^xXFVl俤8<Nv=V)ի@<-#$ߜ+;2ՄRaݎ	uv.kyUUbUʱZ\ZS!.`VnVUyj<7Jzc|owv]*:,&*vU`1Ǌw,߾(:}i\'4}}ZQJ \r[\ZMjSǝGs8 {@TV.ۨ[$IGխQ~.\nJ+b.M{,+FCbZǉwKd\n૶\\MCyvuk:c og\\Tn<?\'}5.*:k[~f۾g!\"xj݇b_\"$orP3Hrm1]q`uFYi>[UƹHl)q\"ˮ|tP&{DbOk,\\5Rxq@3I6Le	©;um_+|:}\Z,YD	fJVe|B(k\\N!ل==6_h>^#po?ՓIAj5qa@]Trҍ׬	=U<fTK<wzw>\\Orʉ[dH[Q.W,h.+e5k*	HF|uret7U5_QlEH<(jAPJ[ٛI١$Ec%.^Z\Z\\ue`m+0R?hKp\Z{\Z)Vׁ􀊚ruVG^mcesr˒plW-GF1ռbȋ>¿vJvv?lW9j\0\'AV5`بSց滭Hj`OFm|\\+_KnᢰbQu̒&vtzOfEZӈS$5JyWaЀt2j>L.HnU砊R-N\0\'awJCex ݺ!w4/%g4\r	父hS>Ǚ$T5Mw^ӴSI_Dt@e7] \rĴ4hwUnJbB+]]T\\i?R2rxb۪jݳΎU>\nmVFtɾs>weޕ[vHܩ9W\'{x3CU,\rՠTxDNWlcU: m\'r,701Yٓj54\"br-:0gtZMjm&zÍ5~yq]2G.	lS+-E	*y̲-OWʡ,7ߩqanj/Rjs_)¬Q\\,v\0$q6|2Liǭ/P	dؤ׬l4k\0S}Kg\0KCUϢq̻\0[jM\Z%Is<UӶD͑Yy|\0;.pkr^v3M%%F5\'FE\06G\"w.ˢbGʣy\">Lt`\r}{e]TbIDZ#h#^ԓgSČdb4zm;,=Y`펟=~Őiچ[Y(s*6ECpX-fFbYXQ7j8BSq:_\\-2m_5 F>*\0VV@>q>GN_l;̓c\\3?J`5R{sfQC>7F;P8oy%_`jYetE53 Zvh,\0td퓧ˇgSON?W\Z^*N3KyY~j,pVJ;%5qGWSiW͈LY8RU*Ư+C$_b	\")cq;~ҏ1h޽_؁8ɚu*N~){I-ES@nǣ,lwS+t0zϮFt5vlb\Z2hWlkx1|+D\"4tgwt +M*G,~J?85Ӣ+^â4Ԣ\ngWþ&g;)%=g=`Zy!ShACWޒj\\^aA9Y4\ZZ\" ZΒd̶6?YUVs-}@˩HecygF)#xFEOj1\n.)n\08\rNJXHy/y}^tAu(~x\'pNɘAls_8Y;n97-.>g?ġ=NؤólWHt6_\\X$9Dt?&8%JspcfMx.M\'WfzT\n6?\\#UD?`RTٸ\rUZ**,Lj)2)__ݽ=Vp\\b5X5Paa6Yf2]k/%\rw/AYU`ՒKhך\0*>\r.R>EWY23gȭ#MEUWam\n>䶜2-Z)Oz*9fT[+>p\nX7jW\rBBQW1o}v$׽`.^CCezwfl뵮L1_=[s2\Z3	!jf[)aOpJmm0Dl~[سƙXB7Q3}\\VՋc!_ Qxo	ǌU8\0/栔{I{ ퟷIW_]2[])J^\rMAN:\08>ǥja>ˎi|SZ+pD\ZVZn#JT8ڕ_ڣ}vvm~Hgښ\Z4e{IX+hҋS@,v0Z<]ZzJ\ZAbIWI֤<xjތؤwu4-\\rHlv;fsOlJdӳCPCSWeU\0ҟક]\Z39%\\l\'Bul[8Kljh]E?d..Yw?SX$%a0AO	9Zzb$4f Ď%w\Zv5.=og0,MȽ\Zk$yKbz5\'zj@хPV:4A߮xJ_V}X,T9OsS*\\Uǁ<\0l.]Z5EKЧyux9U/u0QEK\"Ffb!e3W}\\O^LDEK\'b0;qEbZ4|fK ۤ\";wSA|7%7[SD{뤥*W/a5HKC0%	@j_5gyzf^3\rOuU~rUi)$,`	x6=ΈȿωG~zw*XH3`NiޑY5M]=P^DXwAm?>pVח\nJtVԙ/U_طxT$BKCR:ե/愭lJ\\eK@0rMu?wLU5\Z.Q1`ILy\rCZf֤zA^P]<lI%&`3UA]A-Y@4nE0bܞ\Zyω asT9S=j~K\0\04Fcmh5LF3BtJ^#K+&9eI77@	AUMpD6KMZz蘾TX戮ϵ6_xȴ7lH&;`S\'qw(S-kc*,pIٕ(\09I7T\"P,j6.IR{J{3Q1R=OzW1\Zl,-\04ook:ƇZ v<B<tLk2FE\0&,33\n\ZZxfYxF.xIGӛ\'p\rZO$)$?Ɇ\rDwE\n*Π<fwgWջ7`bjjaw3l\01.1Uu	;\\J+ڵaPXJQ4%$)R@5UNm	xM\r\r[lRwio6{f7JXksR7(-\Z\"\"hd\\0u\nJDȀuB#/\rh5&4৮M7p2 r*Q.OgQCϓEzhY6ӸYR6b]ZCzlu_\n鄁IKpFLH5YSOvc!Sy<2>-懯Ug\'A%waShl\"!bn03z\"	T~da?|ݧc/*)V|t\\ukg<D&MT,dnI]YJ4IreUn\\eUxWA|3\rm2L]Dp6E[`*q<jTiXrX͆}H$K^Q.L+s<>6RA5m*rQYX;$u,NHDNukKkeϊ<[7W~z{LXX nUK92k*_5-X?z cVۇi\'o.7&\n(~y^5nAc0#v\'|<.^_U#Xcࢮ`Ȝ2Jaj	Zw;gViWaϋĦf5kb[R?85) Ca~$Tք%\rw\0Sղ2^kޏu^0<V{j)@.\'4	pj@r\n\Z95(8w_5$[Ez~[eB|{90)o816lGeyW)D%kx&`\"}MD3\\IQw]exR\nRVFVz}Il1\\_\row 3Eg*H\n:Ĕt*TxJu_mP!|bF[NW#4X)Kk{ŤH]E^FrΣR0)QUE&	5	0wdM\\Jz*rڙ#sIG<䲵M<<OήPh*p*9\'.kεj!Ss\\&6^.D*8B	K$hj11 1k.̀MŊUИ!\"iKuŠ/._`A~e.\'..I%<g3mfEd:QsJev@+;ԁ<rFn+6}V-jNR\nnDu%;_ؘ:(nbKEŚiϼ9gAÀRd}W#20/-\Z*ת	NǦlOлb\n\\?\rR	֪kfޙ~RB`	!#FTe5qDZuw{xrO֓):Uyʋmͩ:@%&4<Vl~b>Br	Z0h~ORPijxq]M;O}k7qَr^.Pl~,gW{T0NL-,ea5^DbUrrp7|ēE6N\n3%r8	pI-R9ȏ\\8gřwojʛM.k3\Z\Z96_!M5LPe|̵\rэ\n_mfn\"N~c^L)>UEqߡ]r!v-W\"gɀ+q+`m&=E8yGp:7J?Y4@,dVv5)xJlG`wlǓdft694WNpSCVA58qZε\\#Pbh>vۭ6k3\Z=5A>AUfٞ<쿝9[i\'`\0Yah|Wkh[=Q+XIWĶ]JZ3:XJ%_F\\4\0$8lW]HxR]`#\0tlm_WJ|2UVգ<\'tu<2JtrG^#1GMXZ\"v4\084JXHrk1#<Y^Mx`<#v\\,ݦ\Zg^+D_ͼ8\ZFn0\r͹4jTp*Blps)%ZRMԄ^C`?*[	zTZ4.KIc(TU4`imACO/hvi*+!ްTĂf$fXTN៚h(\"^*tU}\n4!\raI+^\\t$K;kw{/x`rߟ\Z=αZIRѰ	poچ|5K` \\klG9睺=Lܯ&jLWFi(ec334\\W,Q,?\\ݝ>4WV#N]itd4mBQmܾ\\><vs0m\0US5v1*pȼ&PMe#$r.Ȫnm\':Q.rSJbփTW \Zw$MT끦#xqqDE`0{\'wc6Yj5~%9ЅJasAIݭ\r߲\\ŗ)BͥZ[梖>oe)b؋Cmz@ Ú`4?5\n1j4h/ 9S*</99}B\naE\0ۜUc:P$J4_Q\"ܰ7?ܜVL5Bl\\,SAb[PQXSk=\0b^<`UXZcG-|~ECR^XfH0n0xcr	?}e?j0R(h\Z.Om\Z`fMC+`FB$]|XeF+:Oe5jzUZQ1:P4ٌ0R\\3b{us&Q%r:Ŕ~ryE焵@k_Z۶rT^^ZV;It}Wl{<ޟ?K\Z40ʚ\Zal\r+^Xn$o}ZYM}!5\'fG0;TMV%\n\0eȷ aV%\0~-\0=/5|IX\n\rltpJѨ)6nǍJ̪d]OGx>H+\'OuLKMӗ:rQ<]\Z@ZvDaF1^fݪ4l1%ΜjGŉ۴\rjp RU2`a\Z\nTÂg3)u\ZF5{\"\Zoc3pܒ_xM5ڨn˧Ke\Z$\0%A5=8&2zR{J,AA<iK?:]Zc*5$po\\^ 8 LVsf.K\ZSkon?\'~Iu1U \'c93u1g@|]<既JIeWjUT\02!,%&Cב%*M(v؎O[侫0-ćǗF]$1!EAExEe(ڔTwZ>DB@#2Ͳ䀮YDEbVM\"ty9r1>f=ZQ?ZERU-%F=~{ioSLZ><_r\0% WE#hj39s},yUt\'gayˈc,((_\r&tV(TfcW!xdͻm:`\05v0=fltQC06FR\ZkqCI(i ֆ{8V%_-4\"}u<!D;(wa\"k\0^,mnD ʢ`&YG<7#tj4ؖ$`(OIT\r7B;}PDb롞{GterǇN80J/>M	ՠiF3L\'/D[	;/\'OoSXFEcչ`>JT?zƠ`*K!ঙ4w{}>\r\\*]\'ΰĵڤLYNhR5WU{xقozR\r=XF,YPXos\0bˆ]FWשB?k/qmP12+?aQK8\rS-xw5:/ZJS\ZIr.QAwu%4iK@ٔ5㒭\0Dmj̿V)fM\\cKV\0d8f*\0Ɇ~qպ,gYKުQB]CֶIٹ)z$7Uwh@cY-z1hMrըT@[R`nepؠ1:!+pwGʁ0<b}[6cat9w^2\ZV:5u,ºYʟ\rsC}V]͎E#{ڷGL\rpD2m+kw v0(а/v]QPCBK\0\rQV	\0R;D\'O*O/da7qxMucMf	D#um9%(;NhJ\\\0C(ʓZ;X]b>pe%%*,<qڝ#}hc+)*\\d4.&J\rͻYUX.7OsT>UlO\ZԖjfc`c$MuW8pX|6rʡwc ̋\rqn\rCmAkIt9zJ9^l}m@ư81<؇&`)tW5&\rYW= n`UQ\\\nJZxDnjs?_BԼh﷡X+v$^~8&][V1|!dUUHIGiz18]a&#2;jW+=vp?	9KH[VuUKfi=cig5m+Uju(xzElYBIB:ݍQ&1v2OeNJR%.%yOes25m]̈́\\;E*צM\ZM[E2k:r!p\ZX*7ԆQ9.(=-]C.CJ8\0Z*?ʼa<7eeU1,EZvR5IfY*-Np\Z.8r5/NJ:7:W@GOyq֦<~|fKqW=\r#,/Ϛ+fn&\n8,z@^Cm~&f.za][YgL&j΂nHӈ]P+d;H?j1(}u**m8gL%f	c2t\ruc!ü97EY;,kp1e]0-RLm%$j>f.K,`9)*MrQ=k:5	B]]x}5%=aԼS)]P9go(Of&x@\n-\07X4:FU[N\0j8!ՇvNU?@2wS:_PN3yj J&LbhW\rFy;υO[률;1.7\r=ҬE#Noa\0U\'Ӛ~y\r,d3dn~T֢	/+v~zf_6QL[=T]`o\"bdTA9Q˦	\"-U\\Tq\\ۦɐ8Cl|}h\r4rV\ZmOsΎW= |ͪoE%σR_Wx]H\09ճJ!J\'ADkP\'3G5{X:ME^eD\Z-Q\Zs5; 5\0$R\nH5h*ϸx\'Gajy:	d`mUZo2VJ#3@apC>igÂ=Ue隕!9Ii+*|YAA\r4`JVɯ8~>`VpdƦ Ԩ@WR;\nSQeW<`W_rZlVbSLc+ó9[8<S=P(R+=<881hH]@P頢njL2e\Zo!pMl\ZG9Ycy7ohXNӑaolf9iU\r1On{wgEY\rj2\08Lޛ<\'#}j+, E(N.⌘L!hԆCfdΨG̔z\'.i5S/qңp\'T\"*J[]H.8J_\nz;!clO\\nlk6+mURxIaw@aUm\nK}:˫FI-gi\0_@lAgy`C^L{a93֍K	 Ѧͤen6%Қ\ZM]}y`#O\Zpk,\"k~t\Z#pԆ6\"	Uɿؓg4Mimn*t0`ni\0*B)nU竢,2UuV4BCFDѼa˞E	޴?0ۀ*S@^5]u[2b|Y![)Bh$P!qhPi3(~)6|FJ/HQ<U#FhmmN.U	.!6sG/󞂫/I+oL\r%VMP߮&TJo=g.yD	N\n3\ZgTOe*VWDH385ũM+zNy*vUjd\\.XPSZ ϑ5_jU<0%My9$Ϋfzg_b(0&3Sdh\ZT\nσ)X/cڦ0M?~t׎; \r`rQL/p&A9\naK葯K<5v$0M\\d#5f]V]Qig]T/̫17o$h]ql )-!]h!fEgiZLd|d\r	gM;{$Zti@Ćyb.<\rA>;8Rf^5Ү(԰i\0Ifڵ48\"Poa|SqI\ZJggdmjh荛4;(Z)\0/8wp-C4CH2xC~hɪ9Jl\"Ӄc}CTfTk;oeNZA˼!vY\nlJQCp5U-}jթ뎘)Ϩ?źww5G}x~aeTXĔ*<j(\rrtom|\'eA.\ro=P$SL\r\nb*\nM$iٱ9IT4^U4ldS◔ьU\"-\Zzca߄&%D	-^8K\nzrrt}$1\\:5<Ս=qM/̘攡m~+̙r`ۥg,\rҐTw[g;/t[{p%FZumMBV:~~V42KN3x5AO\r\0V4lIfQGs~$q$q-U(\"aŬn)\Z\nIxRf;8:}Qk2N	r%5U4ـ,W0s_/Rk\Z$`x/	MQRJCj/RS^ (T`Qd[^5Is5gX9D*5Р	9xEJe=埋ަ7U}Ժ)5U aY\\`\'=d[n.=џ:JG;H)SL:LM\'\rKNݴV#\rO;njelסA~b\",&DTt0;u*;^ޱ.Y!T麤aT^rYk6erX.}UcX+q	ſ8װYS#:D]x!q99B3N~ZLj(c>WȒiRORmVrrűI\0-hK,H\Z#:REMLefu~\Z?XӴy\Z#\0JծJ1U	l\0dЭS͠n*Fߋk}易Usr/a8\nkAAMK&IJ);-ZVp[5up\Z}*\r~\rA[ UZS~+If04흌IC[tĲi/#i1Q#A63Z칸3<jN}l\r\rP5.VGh>Oڡ+d1jx|pWpmlٞbt~5doùzxzá\n~3bK)F+\Z{0j}TAMF¶.SR|\nOe\"\n.9Y2U5.$5zm28,w|iE{Kc\n[9IsVtK	)ViM+VB\ZQ7>9;ɐ;\"Y,(noK̎c-l\0DnrsԸĦv-UR\\@:Jq4zͪ.\0Xqy6(ƌӚt\0@#Zpv-H\ZNw?$qpS#O\"J..>>F-`s}Z͐\Zkz5Z\n qyn!9z`\0cVLW%CXYnj;棉jL2bWSqlGMFMBwdhܰ%japnf_k6,^:FԧDF֜z;:\r>qU{9}y3dIk!UK(KE1#E:P)<WpΟ$~EaZȚ)?5Jzs\\GP\n3ѠUz)(?/e\\hR\"ƨ\"\'!1|J̑j@\"G	[ڷ료STX)G\04],07N`dS#߭K#)4!u)!}r-4}ʄx~rF؝M\\Dڂ|M;*ٮa瞩n/~	i5K]1\nc,D!A\ZTk1rΰ]xv)r\'>_+6>fɅgLxJuU`n7=X\".E#w3b_UZGQ\\QOD~ab=8}38!ߥR]#	\0(SJS77[I,Ԑq*\rٌyq0\ZR<+0aөw}Pɐf$49DEDv}_I+\\\nBgwF0Qc:֪m2í?	u|-rͪ9N\rm7A)Yvz -ciwt{mfS\"WBi!e̰KڥqܢW>ERJe%Bwg),[0}dssp4\Z{UCE%B^8\r{kלwx\Z1:|sh.85)Kj_|q*S2$flp=(F7~f\'HRnR^Gsa\'f[QhoK,67<#yp;zzk<6\0۬ҶPb׹D\rW2;nőoPb-zK÷췟O{(E\"@\0%=2tبh:\\PVCWiHiKrPOpq5\rG\Zƌ)hs0-\rw	\nR1{g0Z֜2*]U\n\0gnc)Ua[7yvf)OݑPIzfK7D\0]X?MY`^[~`־=T|//mA~J-V sm*\ruM)UY3\Zgl77XZU6mgIf\0s|nrKpӄ\n$DϚ4S\"I\ZΣU?핳YT8\'dw-^)YI1`mZ&&\\h}=\0%	Q-ޕH1أ^P`3v\\LzF#CFRwJ~66qtim,/;XΚX>}M>ab	qОbiMaK\rӓ	ЭW:8y毆G;fB\ZVk6{(Ns`cV16V繦!nJk۶X殱z.H]jtЪXְQs=RLj\Z$%s0j^}]~Ǘ2nI12x<uRb?VC`.ׂ!=,xxvr)xHbi\0F#Rj̚Quqim}~Cvt:z\\E>A0-96irf؝믅x.ڰ9Y/\ZC5yjm*vΚl0ajYԉ|Oj٣p}Q-P[\Z4,Gz<JY?d|\rG\'e.Qz#F<Ú\'ԃ4n7VEIfͼt[\"	l}Ėr@Լ?h3\rcǫIKږ.I/.[~)@૗>^6bKzvI_r4O2J+3vjp!=?Y{$kGm5\'\nNΐK7a\0]fku\'dv{Z@(E٫e)jHgn@}h\Z>TTIl\\VqN?ڈm،qH\nDuSUũY*=ry?ێSW&h{dxdI%JF	ku0!Zkg<\\oIy$ԛZ	.%\"	sJYχ8b8ͨنS{D\\\Z\n4vCq\0(	z]2~YڥbpwU8@Tgx6gvT7R%9\'E~]\0GkpF8KHZxUF\\{J[ԃR=?Mi,U7	:0\r,Ou\'8T6< v.LU#;UKXjjJ\\E>\nJ[5-\0,ݱ3|vo}1xd$+iM!b!+	EZC!P;p=\"F	{v>Hspdڃ,GI\ZxWq|؎w)ÿ1lL2;gX)5à/%Ĝ:49YRlsF%t!w7aϖZ#gDK8V	 Bb iQ\0c7W~[H&䡈դ5%jK\0N<Y0/M{U{dl[g}IҬUG)|a#6¶2P\ZsT 6`7, =t#dz^\"v^TA_Z|&R*}wY;NLvٸQa*[\rʠьi۴Zx#aj_y\"oޟ~]	X!#<*GZr^E~	k[$z\'\02\"uxFu=϶45,dڌ:CEmTT}C3;W?k{ a5,9cᑍ:ԅlW%j&حSI*!8	frץsH$}䧛Edᵲr8ߨ~낧0ixEl0)AGYHn1\Z8`n\rN&pG뷪VndU+c@Ȧ+r;pVQ7Rzv7րL,w8qe3=4!ӱglf(U+qȨf!Bw\r)\'j-$V}y{}1\0(`@\\񙚎VDL8OY<Θ\\\ZPz䥿rkez~Q.^hϭc뻪:U책B[:4S@d5?VU1jno450(zxu\'x2	ƨ:I+D\\@{xIoH1O	\\$܍h^25l\'9VL`#pk@?>Ҷ|E205P*֪3 ui*f\rz.Cb4曇/oxw<<yH:=U{\"U5]gvW\'=}Goy%\nmLoYFb6 )#n\\T0R|WOe RHrjv@--$/모\02@s?Cb\Z*ՃU;^jwn^r|YXS uG餺l8P{ts9\ZgqZj_ځ,i=J9suO\\ۋ:yga-Y#עjW)3s9d(|2XO>nLheQtFC;1Œk\ZȇNKf-n W`;Z}@72Yv*\0Ix	\"58u9dǒ[Yh\\o@rK,X/,YV[)𶰉Yz.3W|{	bydC5\nWE	c?\no=ǧg@mzΛTa6Yd\Zx3ה7\'Sή w	Qbjݒd,#CW %iaɼ	۬?o>{~m	x5%0UxU3SrTv\0\rrOJ:Ռmv^-x*/ci`7[Icj nO_/#\\6C6{\'ȕb$ZwYª{)T8i@	qJ hWsUIܖ[p*S=+pA<T!CP-[:7x8Y]Isj@ըn~Vqb+|\r:	\\TߩpG+6^j:1Hg:ܺ;%zva5ۛ=kbZl̀]VENU%;HI<VS<)@=$>864Q	&~`<&pQy$%%DKp|<tZ\\\nPk).Q^Qfb+ڔ!<&_>ܞj\Z.AڥUh\"64_i\n|]<3 G~SME06MꢃN%\n84.IԀswOi+qPY諚%@ERe\ri_6[Y۵0t4[FxdkzG\nXhe,\"ya\r#IhPM?E\\}PfѐKCM=4d9@e\Z凍p̚ƛMȸ\\nnayHUnq|ɢz᱓?)8c*sUPA?R7S<|Z=ΌKDORÍKj~tA<6H\'.{tb`D]gg+@5s#&a6\Z2Mvo>SD59dЌmQ#/XkM?Tj9N)\'=Gt/&k~\nc\\В.U(v^7n/= NEJ`-u̯+1.5S}x2tAh̤Bxˆc䲎1h9.טc]0ڡU$\rhrV%$۵9({x&xN?ԋ݃|pCT\'ܵ+:h	3Z$ݡ$Ă5&$2P0Sw\0FTՍnĪ3ͪ]jjw$ĞF+d7rR<|!raS4qS\n		b^aF	*T2K*w$Wo\r&m4\"=4?)mkT[mVɳ-Ƚ\Z4,gjJy9(jYwhB@\'Qi|۞[nuMu1$ϏY)4&ߨ|MsOQMwUAx?$o\0N\"\Z0,p34S-5X@nrx \Z1@\'\\NkIBڥĥΑ&>Wm.\n&mK#r|ÇÐdU^-8k]xeBԮB 	I$%iWrz\'\"IR@.07ըg\"jc&T>9b8hqT]6dwԙعt^tT49\'aQ6}P|{#7ݹD #ƪMgsyb|-AD,gj\"a	zcT^&B\0oIڵgQѮ?@r%^%\'\Z[CI䚯@\0K].\Z+51gx|~E>b,pQ`#D\'=Q:MU>_}t&;VJ8Ф_]Vӧ\0[-Qؠ:vwo>GlVpx8D3uQ%	ۉA\Z\'\0)\0۪._QK7hVb,K3Ii}]:`ӺMsR|2l7)lDKxHfdi5d)P1TUϡYvr4[+߶<OY?/\ZYbMyʣتT2\nMSxy|ݬ)^N@;7-&E@$v瑳ب)4ytO{Gpn0~Mƾq.jyLڎ\'HҀFMir6\nus2lđFUV[aIB]WGMg]~._\\O:z09F¢aahUn:[*)hUЦ\rys++7珘rniPgj.פ**hݘcV©	y=ҴWYYuhCCZ\n\\#Β$!9æ|ķg҃F=d\'1ch&¹$H\Z\'<MiMCX/}%\n>3]ѣʵ@5STHѺc/U6T̀	Fl#y׳ۑ<ցHu7^MUڮ,Tk7UeMc qu5ՙ#.KhDVVCIU/j杦W5Q\rho\\	Ŝ&MJ-v!I\r|UQE|^jQ{xPI\nkz0Mq՘fƖIy\\-!V=|q*Y3gٶ_ޟ\0I#xĳ \Z\n@C6<&9@H6	XaQ	1K>p͐/\'Ds<vק\Z:{ǹ9`\n\\\\=M	?츙{%Dt\Z9%<MѨ,?lbݦ[ՈULG#}׸<8.V\Z\'OcuOa&NUl7[FpŵG~)N+d-r۹Lϊ/GQ9sڢO;V[fI^x :/@.̓Rl8SeSLȚ	MIID\0<\r<!-5σ;+RN$&>F11VXFjUf퍴/*0I||v[ʴ~:IjE#kUBv#\07v\Zx潺Dv~?Fʟ[j<^ckm+MjpsD40)D^2*e+eR2qn˞eJ>fj䈒a\ZZ		kqͪh܋(dח\"i@bW[]n)UVjf˒\"WW.\rLq=Pox-+Se\'KUbJѵOhtVJcYs\'usn4i$X!|T->t*hn⇊WņŻ~׽Pς\0yFaX= 71ptУxïo_qHvoH[-w+,\ZKGC	\01_,quJÝӖOՌ\'*OeN-ҳ^;R\\iNJ@,cϺ;Doo+4寛ȉ,p\rR2\Z1<]{qݗv,{ɲ۰盟9\Za\'!?_\0MW6y5aH)\nMI-1O\'6wq@m[\0p\\ۤY\r78KUN.:l\\\\Vt	\")nʼHWQӪ63|qXZ\ZXmT\ZP+G]N^FqQj&pIpVMe96Krv8u^| @ݻS_\0-{{z5T<;4e(muOL`pZ>d}sGWi`jC\\%buxfC!-kuQuVxfͶ+vίlO,OTsYiT9v$KF`hD\Z9Lezu?`U5ViK,zY5Wn:xKCl([߶Ӱ_+nUV{@\\8RުKfj.qߠ>Ň$;48ԞJAgp*֍n\Z\'iՀ)p6Ap->])s3vRpƇU5֏\n4|gNF+rPpLkذ\'/F@ ה3/yU(5Fe08qΫ?*{G;X3tF\"YMY=]좯JJ2*S6.\n=}2W<ۢQ\'\0\\rRC=kP7t%&yZO߹<+I-ݜ90壥ʼihf&6$+}龽>-+Z\0~91j\"%2%XȳMvЌeU9g:ntsvdUՇ]NT7)Fֆr*}˲`/^<>[ŅJsq\"\r,$<m\0\'L3)<T>CVZ|/F\'WLXS2D+K3g\n$\\jZTYEӔo`7]ٛwӫ \ZP<s(!k\ZvŪg \\w|Lș8;C!긅 y@s/ҟH&0[\0닦9(\rl+H0RlihԡiV.w9YPpFٻU#)w؅d3Ww^ֱ\'kT\0XFOI)Z3R]	҃X\nǉRhbZ9܍\'+{4|8156UbY#=u;Q\"NU];,TՐ9,A+Ǳb[$iժѕA*xlݦpXCi\\Ѝ	iPU^\0bzKֱvM\' [,t[a.z;rV`lar,AKʣPZi\ZRcK (\0\Zi.̻jOFDs6ajԏ@Y3zSoѴ=i\0b5u5ؗ2et܋	];f\rluز46/s=L(^B$?A+>,<\'\r9R	pRik(w2%1p_턒RP\Z*\\37I*&\0\ZY5xoϗUaA4x`֮^wV5GWuc_xMV/Xγ;Ͻ͆ۯ~ROf:O	?kתz<#5ìx|}\r|\Z4TJQ{6/7osd],H\ZtpTX]-k}k=\\Ա:\r}I,T߄ڱ6>R.Wт&)5H_+t7pus1M<H-+5+\0k(2FdX tQy[wJ/v\Zͪ9qjƭ]u͐\058:j\\_SM*TrjRmS[GɊkEj\Zn//KoM#ײ\'pEF.d;KTj~\r	˳ǻUk&-ʸq޷JaI5m\Z cyvR#gϯ\0&\"MvoJ\ZԕxAiUK#3V;scI<4KU\'6[[%eIJw3k4QJRZ؀#Ǘȃ\"X2`BtIx+4bb .`L5~/l\n*{ȘCp~DRJYm\0+lxg,qdّegwzt,f7Nd-0\0S;{̈\0|{սںZuHyx78MKO@CRPw]|<#D^/-G|rߙ-/\Zb̜窯ɕF3\n9ӎ\"osVEphcbjZm/ƐcV;.;oNO*މm	j3VCEmqI{j0.7Tﺼs\"k(MhϦQi{tXL_@otT~xVVM)9(sӌޓ܈Ib6)	Ķ\"qjbj{8\\+G濿}c-$qh$Yq`r鎟p8r@\r}3HT\\R\'lˡU!tbbV}-d&,iɣ_\ZM)EewgKYFk6&*#W/h;zg\nyfE%_\05lifQvnc<jJ*gA/FeDmX:&߼8j׷mw\nn,Gor^sDf#[)z`_<|:U	UWgfCl(s]\0RbrDBC,G\0W牒4<@yoQeO?e-C_$[HAEU7QLFП<.#3=pVUL`2\r3PSؓqRyQf\\9.2#\0YPSIoX5<H&]UҏJ7u\r݋O:sMj9QıwkfbmXF-S]z1]c\"/ǇOyn&iB.u׷T@co<c\'?1\r3wfCyc!k(E\r<ΦQ\Z@Vء~¹yud֊{jkojiVFrx=\nuC-ؕ\0\r|wÿW\rY63Df).@\'dn-Hxu`BBlf`(rDALG*ЕM߅>8kZ&E~-]çϏߍ[M0Z\n:\')ĵӒvNFTl]$5EC#2UKE<Zlz<Eq}\r㵹>+*L>g}Үq{\\\"P`IuQ#)*P7O\\i5\"+qTfXeP_~7>_[`>_1΍\"\rOi8VBȢz lDs<*f<r~meyZ^IlJQxPV@Es1q.\'N?\0^\\IE٣߀O=1{]?L鴄B\'~=g)詧+Yt8/x\Z>0)5\'X!,xm|2=EZEERWG7.~~`bk[fC7dD74Y@@,2P)m{K1O>gvtXTCk\n\ZzYK.M(ƭO\ZZ~S+??~ZKGK}݇\08XPjsd1(#-ړaQ#YKE(eɨ1^(^.Y&B2N854Mx>2vo6[c{n|:B/#3-ڲ\"z8]W_wjM@6zpL7[R-\"\'\"mk*\"P=?}GK1}6Ipf@Ru4f*oPdQ}Qu\n%(Oa,F{X/#̠P*w?K8\n5\Z-RJ!@\'\"Fρ\"2\"aJkMHB޲?W[`C0\'¢j}mHW0kJWܖazr_.spO8qv؏զ3*TRW(y-Ȯm[݇ ٔP?Hݵa>WN\"I4\0TBw_Yol\n4]+	 4-^;*~_=|R	^2$Hmᮔ<\ru!=蹴?Ug苉#	Ļ~\'bZY@t ᐺ\nd{=P\n(-~?՝oENLa8.xA\r5bd@.`RP9V=}?\0ZEEOӰph­t=M\"TK7ӻf3?pCwe1n?)}1	-u3gӺCAGY+~G_v>LrP`]\rb_kFCUo%\0S:}Si#:uWKh@@eU\r$ee]Wy+J+FQ?5-7omYz#h\nd@X$3k^Ҵ`$]X)]au6:zVw\\4I뵂p}-\rgϘ~ioWwg},\ZH%:E?6z3寑RǰE(vEQ˯Jޏ?\\neC6)!^C-rmԗD)ﷴ>ۭR?\r[3`NXgR\'0^3jh\"$w/\"dP!˸4Ϙ\'t#5FFc{mwճQ[4̨J|v8i㣶aZLL{=Ufꊟ!p_?|_>k,*.DA7*U\"is:k\rM:nv[pKz~|-CKEQ=iE,ewgȵ7\nqdxvWoǿNVo|#6HWbv=!hGr#ou\\6SqkG6\nHQH˔ *r52hrdQοjwšZ7,۶,\\Q(:*tܧD.ݾtq٠hCiљl~oX3Y4!\nM͟M5:m<HtDYy,o:54Ė_?iyR׉)߷\rxLc`(>sUlmJB7ℒր$z{[ǂ[NOND!\ZTIw[h?B5\'#*wYSl~)HFhF%ەaCŌvƤŕpޗ޼|XZΘu]:Ȇ}n\rsj\rC4M	JnU^$7~$y7aZ6-!P&&[φqL(DuZ穞t+6MBr(dە9hBzpxG7S)HeXK[O6LFEatynGzZnʊ2DtV\\ѵZ&\nfR6}1tjHo\\kWh+?|Tn]\0CcږhFL9:kWIz~<J>2HO\r /k2JWkzFuI*6>upLu	.>	xϗI!djb냰~L/9wt኿$hfʡ\"CՙYO\"bwޭ֔1!.-s!zY+V*\"h6oo숎ݒp8DO.J]ܥ*$jƼ/:X~VXq4cvt\Z~f\\s\'	c\0-t0/M{_Xf++(3l),u*6rEJG:8la^%?F1ǌF|-Eۤ/7a_Nw<E#,j]үLN)dXRN(\rtku~Nد5N1zj:\"H+FM:<Uң#_<uSz*5rX=#3,.	ڸ2\Z%iod}/@Ẍ́7͈vLz\n_8T]kfu9f9_*?/\nJ$6D/\nld*J;gM\'jQ{!.9*j_OhR\nY0upR7;&£q\ZM{DP6aiSwB=YB1(H;PZY<G\'ְڅ%@#Y@r\r+!oc@ JC0}PQ|IKP\00ŝP(Not]1yX$ֳF\'2%7֔~Bi(yzpvyWm\n?WeDJ%檑{mkLSKtVl$\"\\3/-f{]}Lw_p\ng5*9$gϣ>MiޛslThiOTP8GΧ;50vߜc:u1m{yyY%ahN%Z竤	5$?.*ZmwgO-egu5@@+<tz \0k^^dwՠQצnuE=rC8	y\nݵ4koNϭ2Rc6c)rVخ᯿xw6@QFUL\"¨AX.<̺OFŖa7.P>R(>jK12ގB8)|9GR<gUܖitUZͰ4A35gW&\n+`%(I1%3Z,Ġ9He\"me[>}ן\n)	5>:g:p}fwSU\\4[b~2kvemJGs2ɭЮb4]9nU\Z͐yO>K3h4^u̟lDzEłb~tZjs/u_\r40WTwNhʭ v=3VSZֵaU<I\Z]4n좉J	jSWCQ6Nq\'I4оTB~sp&ɢY!vzrͿR\ZP(/͏oϨ݇BL8~0T]QȈ\\M{4hgGuזl̄xIHBK\\vK|wǙhOR{G$MEW|2匙`zUg\"(H~2܊s߭RUe (=1\\݋[VӷΔ+07MneŧruM\0_nG7˶@,gD7%06 e=b 1M}u܄].	ղY\"uz͐KI֠7Q/[`.s>gG\'\" HeXRFuA.׈ܤZc[B;ήh.d(]*j-Wn7	(bG%<ltJue=J\nLX~qqvQ\Zʴ@V`7\"s.ĔfQ\rj?1&fw/UL^\rw1`bX>\"e2S,*ΈW#$|I[$V6ʼÜ[&qwNKhmciYn;Gꈃ&α,^E6M(L\"S8_0t?z;2&v\r}\\)7\0ViƣYi(ܷՁ=nJf(ŵl%qx?g<+)\"r\n\nKņ[1O{)8\Z\\5i-Ӓ-jc~wCnB0{\'y4?_S,(^{j2(lim͈iMlh%0m$~+-Wuh*4<c[;Y5B̵BT,uD}س/WgU`\r۩j}xrFxB}Mnh=qN	ÛO	}D@`8 R1F5碘i2eZ:MPt\rn|x{n!l9}zbѵ!w1Sc8)dΓY珟3atFjJ-B8\n:\0}\Zb,rN֋c$ؕSϣk7%FbNIFDt%N%խ>1sŬV49(,*ĄYà\'יҴFr1gNA-iH}o_nLXd	\\0+v0/\"ܤe|$fR&;]^n&yL	3:n64D޿kiSGgmF\"ϨAnvMzF{	\\[B_JtU:NQ=X0R2a2f`Ru@&RP	?!jΗQiN.?Slbxꥡ\"bvSe6&שCW?>~ymr^TQK\n4pfDSv,#, R}-9˯U~8&d3eST+ C>BThthjϤpm{J=Bԟ:b-\\\nc϶Ν>X>F:yy|_yw-dPVs])2`!m]DU}\0%Y30%tdAzHO_1x8/Wq\Z۫&nsV%* DqZҏ0\'m]GsE۽[1ȣIhz-2ޭ[QE~X@r+ٴh\"g<\']4Y\rӗx	J]DlA!C)I[GQ_*;<m,x*k)K뢳t*(]LJĔŇ!eCjƄ&6z:	\nl<$t2?+en%M1et6+Gpe*q鳙?2yQ8:W:}͇Z@C̶NaHGbSq-EGW<o_?|ᣨ3{G{\rJi	jэ]I*fVhw\Zdw^|1g_*[;]UӴce\n}*-X4E˚1\\](@PJdq]ۍZ9\'䓵{]{	慐,/Tԡb0Tbz`E**`\r#D(9bb@b5䰿i̓bڕbaNW7;5|fGD.Vj~$ViV\'9姢;UR8Lwfu|>t6D Lw<{_h(\rU\r32I&BYkg^j2}C/R\ZDr%ҙul74u\Z?193`iъoo%Qk\",\r؛b\rvh)xy#CFE%rTNTZ4r9E݂	\Zٕ&B(TE}Yutnѹ)\nNO&Vt	{[#ɂ\"MfnfɰGqJ),Eעه76	%nLأ\Z.an6h	\r5)3Oݩ-@)pNe>|,)ft3ThDa,~)DJu873T**tdH:Ӓ,=wic 53D#lq6\Z:z|ZgOW\Z/RZKZD@uN*D+MߓPJQ酞-NSW}@ButӪۄ\Z|(DN9aL]mPd1kjǵ\">v+Q(d\rhr/j!<ɍeWb.sg: #ذO<ѷkHs r>=7r]lr\'D:SSRmzU\nW;$QƈNg:X`.`Q0:ܥy]׏_5V/B{ZTx҆hb±G!zS<	N81>7h]f}R]kTF3hS2\'S7.ՅZ/Btk<yUᬿށfHN`jUr=h\'ԖZO𵠶\'!;Xށv\\e\'(:!&mR6AQcΊ>Lkb/so~+x9$`2MY\'-bn=EHQ\\\"{vفK~~a)X`;:剷\"Ġ_gw:30G=\rn{\"-[\\AjF&LG(CM[ltWUAsUW.t\':7{BM\'ur>XLU䀹\"S SҸmt*$w\ZeCꈝ6K*2sGuN.)!ݵBiA=^f\'0ԗW5LNK_\r+kaU՛c3xJ7E-pCLqsaEIN^r<ښRO.LN5yںQ0lǧM\ZK7,osuyɿ2\'/R)pJMMlJ%bF^Sȗe˩[8ϫ7: ЈL:з\n\rwQd%>uߊ/c{9@Ԫ\n̢T㔣7[NRNW=\\r61+l?Kbo\\ZdA*6)̖=\ZFЈ:FkFw(,G1skCC[%d usdZC}Qmڙhi;**ߘS=x~b+UujۖW0)REA8-)G_F{\Z˹	SaW2?zVF)F}Aֺq{EU`^\\c[;vsaSKEE_iB\Z\'xr7U9=o)hB]Y>`\r?pBzMEq:V:kQk*l<K6M;A߇~߽%Q7;F+#m>ϹU^̠:Le	PrZ7\rs,b[L跜K>@W?AD#N\'CXHE@L#mBoOL>\n%uBd#,jT<tg*0\0K:_BKՎpD][,/(8(xCNXBBn]r9ux-zݔ}uЯ52vS}I<Mͻ+UBѻik@z6!\'-;\ny?qn`|Mţ(f \rǍ1CE-P4ZpIu\"؛梭sz,B3hUt#N/ls*a\rXA	چOS<8kGy`K\nfЉ	*zjlŷ3+l1V[\\]~$%vY\"{^ϫejĩ6Zg@*I<}iS\'F`A*(}­	?}-PV>\"Ʈ6^R?_FFʆ֢>.`;K\rMBym35fq=^.=~z܊-j7WFjq4\n>/$NGwWE*hkuBUɆxrDi[+6\0#f*L&WqHe8{Qy![?[]J:붥,,&vS̮fb \n=IǜDU->#v8^y=R6	b$QWОQ`\Zw0|gFة\r]zh#DfNst!2!6be.ef~@`/Mq_,.MLQFǐ`eKSaJ9۳G<<fFb\n鎙|^}|/W[E35`;P\0l>TKSȟ?*¹K4_oF_9w:\\h^Պ!;6NM((NFĭciΤ%ϿAXt6U\"PV/G}}ڙTa^?P建k%ET</)4`?+\03,+{V;l\'ahyc_KM@Bs\"H4n@K@7r\"otՏ_>~v}B6riZe.Dĕ)uj!p]o(Rd$]=7oT\nTs\\^\0Vk\'X6{4eC&~Фv8dpg/ylUTdyo Hi[lDGZ5boHiO߮G\"6Sjg1o&<\nR4\"\\~Zy{/D|w!hiigE(6Ru9-.\\j3gȦ_fzp=ʨ)mJB..&.L<ַii{%uK:]3AHH^&zz(EE&10N?}x-MGc_j]tV6o$ksV2Sֻ|qѾ\0Zn)Q.(]i_ǆIwZd&:Jz˝]ÌpCfC`t\0R\r17FشA)F:ヤ\\ϊAb	c6\\S:9\rEҭU3Ocoo\\nې=6C8^q߼vw4JmqJt\"w\Z\"mܩLx/ҙ=v LwɬzǀQaQJCxT7uB#َkoSBB?vXV&R3\"{A0Yo\\ څ\Z#\nDDd+k9]DWF`\"#իvU\rm(ƀLB]wC\0pn-|4\nlbm[/$U^%.&vEՏߛRЫٚ([9э¶Z_}Ռ\'ŝ\Z5[!eR\nƉ\nm	 49D%U;ICw9k̥Q::PntQGL3͕7|u5aSoV\n4Y\"N)Z4@1zɹXf\"Ʉfq{Qn[\Zq2{k8\r^en	{孴݆p%}3oX:.\Zi:-v=),- 1:ֈBbEQ%f|{ճxWeX>M]\0;q)Qlpv	hnNx0n(aOKoT)ojzS\nU\"UQ>Rm̵g:vL$V:LyW)Ԃf`z/le!{8z`\'	lmOoB[ucFE8;th3dhasf&Ҳ@m9ϟYq\r,wG-=\ZnhŌ\"X)i8|AW\"\'k_ư#Vbuq+\"|e	Q+)ꀚP?Dm?:n6}f(|\"iTYDQ+Уgܭ/.fIcs0/A02Url(cXOv(7z֚dARaO-yEm7OtJ]{PWJߴ+3R/@n-ҥ	&jqR(\nytRD6N9&/VoO©>xvurL#*LmI2>z\n~\ZGuZ4;{&mַ˂?NE1SG\rێ\0w)*Y8\0UHJhW`\"GA%nkcTyƜjIc\'e^Tc/ˆVVQxe&!gӌFA}:VkTt/{Cw\\͊kaBì#`l=CᆩX0J0HS$Pw,xYOB4:s>S2<Ynh}3lɤ37E(mXP,/WsBI#z=\ry)<QiMgP,[C>ps-5bxF-r`0%_EnQStz@8`8pIλv:Yk-/Z$BiLt$h5xؘwv%.[c5U(zdzZɱ0KhQvso^&)r9%;+sh\n/{Z/\"3½Z&b/٪DV:zlEǜt6qIb7tZ@p!ynGQ\0\ndb+Պ\nC[wF]HBH%mC#+?<$LJW{$Л(u@S\0P3Adp>N昗{3U 碧Oo\'Nnr.7qM>yWoàXv\"-֫_qG%3qR_i,:y[R\ZI#ذ٢wŔ\0mHjQP#l!n\\{]}~rw{hM勤!MK̠9Q6sbUXa,[sN/o^F-k[t\ZRp0vRF-Hv=˥}=Yo)ٝ6Z\')}a\n	fMi!;fh`΅;a]qp)|,ZsA7}$ڰm\"2̇؋\0af,Jw+9\n2wxE㗏neiSL:> &oa\'Vf!gei\0H@|7?U#yo6JEw	Em^\'-p:c8B;wǰڰ/UL<\n\Z܋Iӌ <m~R<h统sc1IA#<b&:bQЌ@#*rAT!C2xPf7U$_\n!hF5B 2\nݸm*4h6=*V[hʟ>|\'=ӊ	Kn¢]:%$!{#k̑:i\"Os=*x~s<hȇXFz*JtQ{C_/Qx%٩,v6*٢uhmґ(^X׳ѧW?<|y3\n-\"ع8nj&h\r3U!췥DRǥߢ!x&j BF`FmjI418뼒Lܕ јCE/Rﻍf2hh#b<u\\̛)*M,T\"~D7͒#	\rL:Wn}EXڱn\n]ۤ-^zͼ CґTR\'?/C~0\n.fBktt-d://yU>S H6)\n-R\n:az} Va)\0^4q;ex5L3\" 01\"gtlfXo~q[)!g2	h~p 7/h6fw>l9>gaD\nJBGk<6!CǗ\"ja)zltvbٙ^FGfa:X7K 0[akzpDK??ҒPXmsQu]~b1o!~hm%M?rQ\0s(D׫5}-B;êN1el֦ø,mi{P}nߟۮk#\\F(c5IhzyH^46^qE.w2I䅍A#fa02\'n\'>SmDx.olZ7`*c9cЬTiqUAH鼛4s橀~Gh/ܕ#.`()MMrp\rZNvsW8Xo$*JfR`ٚݔVZ$O*ςYbܨdOn6/?+~+fV$Ԛ3^\'J\rTN~\'Sb\nʿy]WCȝeDb+A4RseD,F_ў1:D`roLɌiYU(vď72c\"ڿIF{!`]d%~P4(%RALt/b~1>|z5Ǜ_؋Z\n8tj-_L\'D	}{orb$\"^41]NP`3KT|`\ntϷu@EEz֤iG/aw7JI { n_\nzݮ\\oj^)+ZN:s}2vXA+l\nʒՐe!6Dt}V<PvnUqA,yPlmE\0FCigCX&$j[\'J/yǞ󗏷nb8ۜt`&~(Nĝ)HoZc6i!S<[сV:%`BC>4h\\[ԡi_\n4(]΃O*h[w`AW=iU:լ#syV\"1RatMVm7j~׍7y\n=l4-/5()yC]WGH9D\r1>dqAZ*^0Bt3Ŏ-%|)̗$=|ӭy&DjBD\'aF52k}r&ǺP݅қ3\n8\\LZ3ϙ`7*ڴI\'P\"]cWT6	Zx:DWTT14\r3]U@gf@ }U}E\'nT2wU݌]3ue8|.*ģvlbN6OV_u<PI}0RL{c!Q]\\KaWV}:v*=\\+{ӸQ:/LoIY\0\'aS<txJOm_uXSjяHS5@%5^K`\nU|Ok( 7cOɓMc61IiD25K.OB㛽b}C	(\n!uiAL#<^R>Vf|F!;^\r_>y:߃dJ54E05)+pA(&8轠>i{]=r@l@8b^t\\NkH9ıX𖈉BKT8N`Қ n WYhAz5GiʨY*K-W5#&tUR.vMokF\\\\4h)$,޹\0wДQ]y	&5ZN}0[3z~-=5iU/dmP	\"\n^{e[oMFt+.#[d~=Ea% PyC@ʥo7D,\n`d,pPб8m=aVk,Bڵ7CX5A\"${^C|Z7Bs5EW-\"c 6ѵɫ%V;Ix-[p}sztφn\r*=7NupH3],8act_sԍf}VK$cP=̊R%\\qs`9g+w*#+`9E4IJLFDAEmmsEV&vzޮ7~7\n-,Wʍ_c㤽$gE-wS¸2GR29s_k񊻋kl/bLJY)/u662+s)ҹ*U9^)>A?~(yiËR{TV{sD>ge|?\Zς\Zu*I#7ҫSF8֧YW\\,lQ=_1+c*q9\'7fqgD\"t2GG(g0)(P#&\\zcp5ή	ӺXX?h|OP\\^ѓVO#ԧKu׹i8c\rFgolqo^PX;RD\nZ>#Pt1dv\"׷ƽRɓtQ@7(D2bU*0ff2dA3X詯5^}sI/\'%\Z7Ţ;1\nC$>͏V=F]?=j)Z.TX|p\r-sTh\'SI٢\'羌oҧc5{De$O;l.#Dw=e7n<-6SYu=ixߨ@ted(SAL<k!GIjYDWחY+Cg+׾ze#78!ey:&<1QHQApӭ^j޵e䒆)KOVL5n՝6.TL\\#xt/bZA/uhS܊z!4tDcbd-7.Bs0	&\'ZY ժihk-H\"-K4\\vUtĸ`J׬X!j)QĤ<s9џznCT$GƘNuZ[Q1C[hm,am¬4K;v|t!\n\\ڥ\ntňY!f;Jߘ?t	S8_rkJ,.zCCV` \nkryK	(@+}6qhE*4idj~	\r@37V;g>nrUQ7vZClw/m\ZV ؎nkYSsHkvzxrqsOA/`	Y<{ERgV?V}kvDeWO˯~x-7t6<\nQ\\ȧ7(\nu-͋a}<sshynv*i	e*\ZnC+fq>XЛEmP:RBfn>[\"=@ڢb{~P	Q]gCI&@F=~xv$RTJ4yjF@Sdyhg&5FA Z{!T0(z4ezM*L\0&KGAGYE^}WU;ϸJ4飓p\"xzjtRsBW\nAJW&\\koX&<d\rLTH,\"`*t(r٤}+#Vo;u-4n/=މu-R&]~b)v>%[&a|\rA{\nʽBY5	XXR 8R<<:E$F9}pqm0h%;	(ֹiψrGӢ/F}2\r:g\\K\0US׈B!ةmFA\'%5TQm3	\0zAtx Q{{һT-XO5i;D2cP>4_4+̔apؼº,9p|1FIQZX{R|\r6\'f9+G,PZyqęfJF1ԕR#K\\H #9.^$z;:fys4\n:>UAwzRG\ZS}͌*Nr~r]X\0qS$tTk4lf6&\"\rjwݿۧϟ᥮FuڢM&s8k`̞fL{Fo5NǇSh(*͡hV Dy#NCŋ0LN6O(yC^oR/#yBW\r\ZjZpn:-k!\"\rZ:3OBS={{n2P4g.C獲\'\n16{ho\'(\'S]Û-+T\0X ̖vnkr%`(S/ŭ;!xT_J`+׼ӻR掊FgbLH>mYbEvK#taW%N:2JkRxD^8@Z{[%:7)r7D~Xؙ)Mza\0k[̠)Ki?<|pE;47WM|qMlj,_rp&pGұL`0\"х6m/yI{{Fxjb*D\\QwUWihhAR} yuFbH|oV\\IӽOaKe&SqZ\\Gh&Ӷnu9uo$YJ~ mQ4rΫ2p\n,#z?:簃Jnsq.)&+`I{YCڷZ_W_p]M\nLrf6WJ+X*tJTmVO~כp7 h)J&I3;|\ZSle?d~|w}Z2e-m%C,0Rf\n[7?^b}S\rk:K2,MyԢr(o4o,\nk\"*,v_ͯץ,|\nT#Wt\Zmx\"OGˋ̘Z)TMĖ\rxpwUd3(D\'\rYͿHdg*PqbBSĆ	cv1]RlcYVtSQ\rS;NK긆/O\"WX,\"CCBޔVەGf&!悂i[\\<]Ӟ4/[y_8݁T9!Ě:^kZ}4qnt@6{(\0qDjA;#UetuJ3tmhBIA6͛wM0#\\Vq[q6=c-471%bF֎Dtܾ pu1H9ق6J؍MݴGK9]=%U:JKtRecVgѦE\Z!p @svmsbv$*\'<MN !m	*je~[چ׀Bx\"mwEnPGGBiF~nH4=CKD:\rQBSJ]~W0D\nΨj~$m}j?-e_E۰r(l\n\r)2-\n:\n󰴿<ȻE~# |3n%}e_*\rǱ_WdTԋP]>I/hdM *;̨oN 	iyKו,t;۩#cJ?7yd,:X\rd	4}W6d/JLc2r?4==sWuGsy^Mόt+h*LK&JbTPE/6bqڿ˧eZ)G?j{{pԆ1}/ &3[K*K+[ODí<G5嫕 \"\\SY~^}rީ@N]m:~4 }<V%𴪽6cS&؏e}d&Z[ 琛kVΣб\\[	IZq͗3;]}̸VNQ4ԡbT5ЈӋLS@4w&&ׅn:_F.\ZOQZN!QR+lT0ik$Mk;*bzT_\0<QRÉM$꩐ĨwXǝh]jkIZjGSϕڪbu\"TBt(fܕSУ_& <ḭ´f;x-?\\*divc0¤B;\'@%6P^ǫCb)aĲCBsqaG*l[ի܊TzF)ެKq<w\'vGrmtJ\"KdA馲PQ(rKWC\r *µJ-0XRM`+en<ն2QG^>&j\\bw֑$QeLS\'Vͮڳ/-<.=NGh\0u֫g:Հ]S=Nnvjgiٕn=\r\Zwփcly,Ž*B(a	t^g#\n\0T8ҡjXWB.=Ɏ\\e=hw\'$mdCtķ|F1N.Nִ@]qcŌnďRa	1rR%BHTu#e8rTQ3!<BOP!3aGB,b\"}v\r	ͮh/HdqK(vFGtƃ$#uqڽ¥\r#0ޕΒlG?pӣV_\"P`>}O00 ن*Ҕ\'5q\n	靛;\"_ *\Z5\ZOejm-ه퓲yDxo;ݿ}޼TEmi!>)\"aEïC:#S8B]qsx?\'gJdQ`谅8jy\n	n̾(p6}`(;Jr$Rl-*`eA\\wO\rU\rO˵eT^=I;ekH+a<3;]۟^[neC(Qd288J	EcPU8^N=I_GW3vjA[	LdFRZAǜKtڥ\"E]Qf׃Ҋ-mFBEyDBfs1QZhqȣbS?\'3\' ҽ-`wP+6Āp7j*jðKү!L2\'o&&u-:,\na#|~a?ݻ?\"R}yJ{@w`^ <EJvO5%XQzUVd<8U]՚\'uEZSv!7tv$\"@Yۚjy~_ߕOi3!;/r%DY4}ʈb\\\nb5b؟%,z˻z֛	S51`Bz08:\nN\'߼rw$Vu4^]DTœ@<}igi;5n݇?y{;*.X 97\0B/wO^ &[w_zc!@kKI*ndZjâ6\'oIwLT˵s(>r.ovU&O3 JFb*nv,vr\nfdt|qu5w@0&mGYO((sAXl<Hkz7e4BR0w\ZE\0S<c(*Ď:72SlYSUF;2l3N6]/jL>!\nv4R,Floa}6\'^>o˗k߼!IE)DpXb|M0Xi.m9Y+y1ǉ{]JpPesKqDd:Эڽ\r*X3Oo\\㘠L\rɒĸiU7PK64+,1ě}ѿ[i.џF?9.JMtdz,3 W77~\r__ӿDݿ}|\rR%MG6\nI-٣m{g~q E^L6)v<\rw\ns}qV8?aN1+=.S00L`;EmHm]oR<\"FA2o=^<vu\rZ3\\Rk\'}SmQ;?=k	P\\8HF	Ѿ2	)ỦXtaTe\'\'2\r-\"fjrhb5f\\%]`139ұl>j[LCWndfVdOE4Qzp,(ʤJ`v|\nV֑11#xRVDCpn\'V˰aN{(!zMD94͍,vGQ5h6,E ԨwO~u;r[Yoqʶ,NUV\n+\ru#j+Zo5Y-KF\'C%*m耖2Di=4\0z)X2MYQ5f=@H[Af_!*qϥ7oˍ+M+51DL\\P-naS̢}Y&fdܲr>m\0\nipl3Ve.F|Zۙɏ럯LUzxL*J\\-BLJ?,PHGgvITohBdj9auAݳbHֻ#n,:+bs˾wp(P*yTCv/Qhx((E6<[̓UCйIL	jn6ᶳ\\oepzdCKǏSw&G-dONZhO\n!)m3?\\lt!\0fK\ZXKA Tc@N,3;p߼;{[?p1-0);*؛kw{\"zʈXKT\Z҅fst\nI).O&#{++fcuj9;WOJ-I\"`]<}GoXʈfdqmiGRr--֍e\n(AA1jH(*($yPnhyGJo?+2ⶴRɁ0{BOaUq(|;;ӷעEJ!iSJh[ze[\r)<6bE\\yKhy͈KrH.nXa\ZUM՛8bZ-;G$a.$iC	Y<d\Zz\\GခдY1-;7ss?a/ww] YgbUi.F\Zr1&$1WkClJZ>W5nbӠ]@yFK?֢1\'̋ޜN2Zr~H\"05\"4T\Z~i#҉Gh33yq}K-&WlB6K0pP|&0sD!O\'֘Wͯ=V\\mz1^1hh[1͞gPͪClLQz|/1S.qD\'&m]}D;j>2$svnr7t /a2~\nLڪ;/^vфGF)QH\\YA]OEKfo>7w	yBD{8E|c%\\aGZMrzU_=^0*ҼiVNkt豭FDDvo\ZXmCxs7\nzVݿ0U_FLCZ6]8QZkxN5n\\S\rvĠ}})h:-PBXH}eGNPG`_Θߜ5fr=,Sc0oUF6Tz0]xfue>Õ\nOEo^}zx2A,*5@Np^*\'VWq!W~O{m\'ܦY	CT@ڭX515:F]:HⱵޗLqz;2\'zxFAoMZiGO\\O>\ZcZKH=ثneME3,b5)Ё&F1N%kHa&}ѓjḕ\rÔuk*+Wmx!MȸNo]|q;5n;%7^̥.kJ5of!C?fx鶀<0)dW}!w;_sWu\Z&BvΞHw={]g&0x\' 0_%sT :Jj4}ĉ)Raq>?ǿ>Lצ8!1X:b7^_77*ԕ}y4B/E1@T,6D]T2>Z\n1q`XǴ8\r_~|-x{}\0t$fa+(T32Q~Gt{\Zgodf]W5!>Y?`ER)__~F)w %j߮fu:V1E6E0\n*5.\nw@iDE[q940#|lPPóPofR0ƨ`~hV2硈q3]Hx*/`kϩ,9\Z&a*x\',c䎧[D﵈B(??ވ3\0Źʛo\nS.ƚ{O^J\'xGAq(]:=P~9Lvmɕ3kCG+MpW[>D++4.31}FtUh͑J3W{yS+}M-rt2P(ҔNzH0/8HSA)\n]61wdb@hE)5#):9LmP;+Ne5NY7\\~Y(2\nu:ʾau~FwoNR¾w77%M̡s3\'͑_7Ao3Mؘpث9)d\'`F)Hm0<f*O6<$fGpx}بk>rT#!\Z:UGzkF6Zѝwk1tZH\\s-3Yr-ߊwrT\"W6aq΄btJPa\"2?>7\0HJ -<=?XEq4$TqZs!\"\\D+:\ZCho/D	r)m\"H:G%P̑Sz~!DmMRV)Ru}9E2aakxY^#ؘQzBVŭmAH`\'׼ŊFP rj*m?_TQWl,>]%t\"#	lm{XHhh\Z_Txw<cH	Sc[:ubHjLA|Q\n{Un}.r5sY(]j:<*s\nŤh$\rцUnBaK5=4\Z>05Ra%C=B)άoWw!J߮rm(P5\"\n-\n4HQT6%N3ӖVbh(qHCw={^;21ߢ:oF#EWĚ\r׸a\"rM`c!a}ȋ1?X^z@_bgT4=sSX*ɸe=5\\&\\[s\nޚ\'ߗ=0k^MQ,QzMc+l揲hR]4B@TOĄZEֈ*mZx\0vT7{q}cUTo;6)4MgJb\r)lo^}R~|4ΦCi´bKDr{ءk-i 4:3*CcF03QJWqEWE|zn˾Q1}ⲧC{ϤF*\"JQ>70j̩\nS_k|v1\'En)J0һS#v&4DJmdf5{)1iwKgC\ZSEթ=hѧֽak6o\nr<ן^}|8uB_\Z>fQB\Zn4P1Q=%ÕA)=͓dѫ;(\"2=_:j5I7nc\ZڟQzh(pp ᱕u\\;{a\rbd~ϒxv~kX==GVO^l;;ίn+{O\0uŤ\n6*j\\u+S$0\Z(ݥUy}vo&fдgZqFx0@($M>}4sҬ8(G<eD76R6-Mw`*p:uSHq\r|XE;\n^z*	V4~TvMc	P[%B5)$m\0YD~}\nQⰎ\\K\r@exi+z.wa.#j_PN.޷9y9UcSM.6oE`0R1:%S[2ց7/\\vי3ƠeZ&DAخ@\\Z`ǗJ:\\\\r]\\ES	׏6~ۗhw-Lv`=NX.*8kiZ\niro*[iMi)	KxQtR9XI%qqa9!>QxZuHoGl-56׊ʍ想\"YvXiQ@$hJ,YD/f==xݵBgڃIAkb&r͉Y?z}zDOMᖝU)(#E_6Cbl:Np5և\0W\rQ@հHe?	]uXjHOEشQ̆3uE8GԳ\ZQt\rAE	ʧϹQWOeFA%׈˰B僧,t:gi?~ s\Z伊qx\ZFᮛ.0<0XG4_wj\'x6[F?@Ѡő1@۫Z\nzkڧA _N_i\Z`Ez-J`Z\n	¡-x_̦o\nؿE~0W߹J=۶N޹xi)APu7u%>P{f2S۹ꚢϱg\nPh\"䷩c=4e\\fIT?اP7kwg^L2xL\"tLxa?ǁ{.Dή*JU;ƹI3j_\n~B?kO\"ZVVZ&Ru\ZKo3^9Y=pKw6\08Xdq9-ÁV	,I~DMn>>?[kM#\'\\y1MrDp΋͜Yk٪H?[NqԽ=fYG\"6qB.,\np=y}{ۗerRXpz8KB)Uk4O{Q._T!c0ze\ngQ4_OJyM}3zCJWx:\'KikQPIjn&&Lw,?;јOo>?)#yTzHvESĆ8\re!n9tna>.XƵZ*#\'ze~?\\X>ŕty}SNbZnJ螢X\"2NjQZ(e[z_7n+i⥴jZZ5#zP2޽]K@T)AToچ|!f\ZL`p]kG|bA_\\OdWDI],~I\Z2bP\nM	wQv0Ex[ۂ	-o^VfU(PJPD3z^1Q!\\r$tţE\Z؎\nunC?<;޺\n,!WUq2矴Qɸշ,>Y[eNPziuNK-($\'*>_oE^I4Mk5+[h\r\'/m\'OS(<}HaK%!2Qc/zkLbD˨5.䶏?,tӧ^rg%\0)+o.IMh}Lh̦@vny&>*]GbvLm2OIZ\'HrJ39}X{~rz\"]\rF:f.VϴR܉ii!kr=hZPX,a۰fI)-oxSDB;6bIUssE4nz*\\Rd4sඍY3@O$\ZPE3Ňr%yBx#߭ٙ)u:ZU|C_nŜ:%y!c`j`|\"Kb\01v&&t{?\rrh-\ni-lkX%,B%Y8mً\'\nꖂmðegV*V-yNIt1yǷr0y(ߥ}GlZD5羗} hTFI&	Ǘw4#^}-X/$-[#n90VQ!,y5q\Z;|zRyۇnz|ܦpzZ81S&*A@Ш^PvΟ;~qü+n8e`k+3,S	k̅6 ?y nOIȫ-YDSh(>o$\nEfJ(c_y1J{ O5sD_}\\+>eK\nEzoT=LC)X<~Fєj*~ӏ_^*Bʦއ>\\bC@	k$gԹ6I:>\rWv%(7AiufvaiSP<vӌQ/i(OfxͻA!^!*gx$ r;L6|3=hDn%Ǣ=^\r!\ZsJ\n\n\"э61!fd\"dEt\\+݁X\r(1X-)0ӽx		6je0\n(|G?=|~|g_R@og.Y@hF}ˣ5P@*<w0\"kaߞb7[iB_$wS0!nCA/?os:*<+Ae[fCt+X74Cz>0J;ݽ6\Z0ƀ)n^ތ->(QmZih9<<|䵬̹~LNL{pE.ʌEQ;Hq)Ax=f\\xTkG\'X^P/KM;%0>r\n^(%_?<\r\\\r#tvE^q%-j<t.Ʉ\'ӫJ\"q_h~..P S3WBp\\?,T7!Vh}}C`-(QG]^\n^=emվu\"|X+!i|.l4pfYZ9PG^e>db\"x\ntN1v?_>}ۅ`>7Q(>#FVd2uCp)) oķCe b\"SN,H39SaWeOko0/fN[40լWCjz=rkd̟v1fX(arJZ[̥Mӛfګ\'Q-{dݫH?ݡ|c~)$Чp|D~b\rcдXޔ\0	[\\\"~	^pU-[Vr&3%ܳ	twn|̿2:=UJMz(:YʴgWPx|ܘŔkR\"XdF籒c@^)]1|ɜ6:\r`4, _THZnvYUُK*9]	+C:QPGv]/\nձnNc2NPqtRxnӹE~*UJS|TNbBʴJ\ni.;dZ1-~UzWO}N(\Zk-1kӴl(m}8I(w/lb35 e0+M\\H[t[$lId՗C\'<=\nUHDQPrF@+Eu<4\nUgz@/(n45q,D[oTF˝k=ΠZ }Ö饙ǽޥs*Ԯ,gr#Eʊ8AJttE\rR9b޻pjN7E5R:r+4ft%.\ZwӾ/o\'~=\"cQ\Z\n1Y@$+T)uuzbfB	bsw]txKϰEhcqT}imxm{nW.!oC\ri3G兘͏?^K]ڏyX&u`{|BaiS:8(4̢*z=k.<Az=ov2Td(EM_2?{t賞7N@wrl	Z~\rPlQIN,@n)9V̊^ט12Àĥe#nB7Z\'}? ʎ+h߂2	0Э7\n̏P47*\'1fF}eEs=/꠱}Tjm7;:Yu(g]]~^ok:ט$RقV9pAPI{<HJʘ[~+/CϺV{+\0CBۯ%\0RR~enR^a	m|+^m7Hg&XG-x\nL\rjnvOதl6b	Bwz)]AuKίafXp\rj:\\q<Eec̋g!Ճ+ܐ>k0a,Dt\\32M}\"\n𲍄N+B\ZOt69Df{)\ZKY<e=n{eg\Zw0Χ[yQ<E͍C)a*	p{,Vw@G˥`[i?$\"z|R~(LF)&[|	ǱC=	F)1oխYE\rDҶ5qXLK8,qo\0\0@	?vPooCaXK0)ɘW^5yy.X{{K&`P_M<έקOT2ѓ\Zo}\"\"\r#y5][/ị珟.<pk*ৡ8WY1o̦`N#2z	B%i]Fx ֟SםoB5C6FtT@ޱmx&1cxw?:\"dyW7XfLqwXc5}Vf/?7niffLv㎾0Jifbt!](SyZ%$A~[K>nizwT)%\'\ZŚKHȝnOaݰԪ֧`H!F5΀[1Ёm\"W%V*fx`FulɕF3W*1q@ZCz.vSkoV:\\iD]D,q\0ӗ9_yՕBa<2ji=X|m&r=RǇO_|i6oP1{z|҈(8ʅh$u%^.o\\1f,֐L*eƩM|W5,\\`w_zğv[H!p{F@WqVa(X(^0OAXvtC{ԧ0֣P;\0qH)B\']Mk@d#V҆YI0rCѩ?b}7(!-@5EtWCVw!3%vԲf0k]	@>Ni>+yaŲhTV͗zM5{y&5?A#}VWoik^G@+Q!ǽc$3+QOh\rScNMƊӴҧ8Tˑ;b_A%\"UKGz?VP˸-wL!fDFo+M|?y+`.v&:Lؼߕk*y];E7.\n%?pEp\'Gd(;u+/,L*GSh?\r\\Z\'+XPm%N:RZɢ\nJl&=+lRo?ZX	G[7;.zsqΊ.+,GT-NznezVPF{GIfwG5W 1XRyy5d*@Ђ_QxQt=GnV|G\r-:[4\\pé+̞?Xuf?j\r/1B/\nphx$d\"=mFh2t\rO|?n}pknAP02x<PjiwCvh:PF%4`sHfnDV4kdlw{9;GK?S謤10&UT.uJ:N;8[`?vMeݬQ?U]*PX#Z0DqHI;=WᑻWK13:qD\rl%wCnkyDQj8x \"2/g_Ń&7xo_3J\'ulz^a*A_ #UlCq:-rBzY[r[o]үxryS#f\"xk_^\0F.+:4²cjcP楟U>I3$Ix \Zժ??|(q\"\\\"Vyt\Z`\Z^.%([dtV$iR89Dwtip7^h&E4t<?hWiQ>a{QB1603^0P9j\\Pk\r`8ZC ][FçTyǴ{oZY\Z\"cи\\uN-Ru\"@^X]{b(?pV,\0<5=1rI%aUd;=[!S\rIyϾh-E\\ ~9OHlPz{{=\rS\ZVۋ:*\'\Zo3h)T(i}=+0qʄt|K)}+R?Vp %\"m˭~GzZd7鱟}^ t\"hoݯ\"@)oT%Aͦ]D]Цu\Z=?}0o&\03]cE{X忕PL&Nt5bzRRɗZׇ2\0OpI$C_VI5U%z	h+f+3K\nz~ku5/nJ))hژf݇h	*\"\'tc.ˮ˧Ǉ)2=@J:zR+cPyg\\,!w#ηwx.s|uS̵*rkVeS&ł/m(:a\0#PߩK^δ&ܦO?N=x:\00f8:N:_O>^4i(xQ&|HcڛI	5\0Cm9_??mFzb(%\\vOi>nruJQ\\N/ͽPbYcJa.& \0ǚ܃ӥ\rr\Z2Q|~/\n,ȳ/%D&PӒOeoЁCIv%4:E\Z{}:ߕÇ\\\\ו{_8x*Ǹ mR\'Dw8-މ xRe	)fLƢ¶sD˝$Nfh.{~K8P+\\JeBAS\Z-a:n2[/zKZe?i]>]앮t_-zs0TWy:7GYLp+lLHŐb8uCPw^x3,g&JfH3\'FL^T>\n\'q{?rz:ɚd\0v72P%VZy}MTZZ=vJuz|?_\\Oz31jCiꕃX56C0\"1/*!DOt#B_tb_4&ܒut}}Z.\\B塗_?r31EK]NqhhG3=WC<oK/C+f\\\0M:BK#EUgRTVZıdaK#W{<AёzA%wq-+Z֏ػưCD}ݷ	N }d%Nڌb\0X[$͒\0zV9[Q5-:[zkgX`;Ta9Wq8]B&H(fT^Oх?<|\nAع]+wdĒkdɓ\"<-88{wpp5Gx9a].L@Lq@pt\'\rYR\r޴o(3F*=ʌân2{+_oeE1kcMQ\rr5k*urU`̀e<%y$vC=ǳvv=V=% >TUf\Z&\"\ZĽEZ=9Vξ\r~$O;$2nڧ.&[zʄM\'Abq=l~raE1ҍ\"7\n\n18f7Fn1qǤč{\Z1*9b\'o=_<|Bl3jBj1NNä3P~CH7k4%/PQ=dh3|L4sHjB:y4|	;ܿr,6xVuFehHݥ}\Z㡣=_(~to~j!jv6`|A5]Ji눵nYM@R@?qu\0o9fWUyc(0#m-Zo\rN͎7mDDElDА\"ij[r%k!GWHIL+y~xᗷ_^}<U.\r\\14}7zHX}{OZ^:y~tI~{1?Qa	upm[<0K\'wx&]Al2WDj܇KN!4kC*\'GroH!odXMr\0\\:6tv6T_\0x64aWdo$fN\ZuKWU>ÖP	e!X/䷡\"2.jJ__4G4]go9:PU5}*E`QJǧK(|\'WQwVq!6gm.).l4Pt?nKgۇ<S\\Ki[B\\\r)ޔK#\rK[ySd|B^@I*gZ\nE4Dܽ\r$:D\';y!6N\"FCxX	*e88r*&UT+~Hi;W:@W(\rԙLmTIt\\)^C֖[P^X`>vݫZWtS@G;_I{P`lW+ ]{CA88~\\tΩLԕ8N쵉`~}lG-kqˠ׻*}\"\Z+݁#(4:C]\nNkk:N\"g(뒏7W1n}v[޼soae`N;lmqFA˹{Tr\"Q]XؼjGxXjӏڳSpWKq	?~D~YBzrg&Tl_Y	\"|h%dTУI#wFX܁)~	hʹ0ܘGLV}~@Jwd\'FbۓS3P+Ydv-SL\r\"4;)a+Ecg-v\ZA\'w[\"sgE)ȅQjD)N$r.=5\":w\"tޣj]Dl\Z|IݞADJ:ʋNirqO_E.)v,:&hV[)SNopR2AQ]9Tt&ns8DSBʽtJ+Qp%$sէZ˖΅h^VC\' 7\\}.GOa(]U\"q\nAS?t_Wa)=&/$ 5927 YS{>]UaI-#zF?[qAx(1 ר$_va!v||ҟza\ZWQGN4U6\'Ù&Tk6[Bt</heh\\*\'B)\0vrjatD;5ayN]G<|*q6EWm_Ki;^Rb7m8~zs֣j#4aTRϹOG~cٙr2\n\"|VCZ/!Fpa&2YHQ$mE1N^K<G\'[N_}z?yЗ4P~o?KY޻Ը]\n.0bڶQy8ye|ViL8t*B=~we-qn~^Ͽx-F	ELnn\0VI.禳1il>D{Shc-RĳʉjEa(lK\nD0z?+}o߽{xz\ZF.0M[Bʵ.)\0mD9=\"NCh1θ50I\\L72Ͱe5ˀs5nEpx *C\'}u`i*wݝ?bJ؂8u\Z~$Bsԯ\r^\Z\nQSsٗ\\L]li\"X.b^ӆqm۫͘*FUщeԙMg&8(sdʓ\"Z!A=oOADVvlէw0p@Gc\"rw!5)GjL5m2~6#/7*eVt\"CB%*5gw~PmN\\k`MwnyVx1}[0(sms\rk@BicN4tԙL0ZUB~!eLP}ȹ^^Ί%_J\n9+FS6-,D+1to()\\/vowR_F]>ZƺF8G\Zډ4ފ[VszI}mx}f`-vo\r*٘t: v/G+ӣCQwv,I\rk]Y1(0h~N0qq^zo\r\\_i(*XDm\\E1~#H&ݦb~=Śr|TLgHR\n\"E6SۈMq\n).E!;^	J<uܰ֍FtI0 ꊴ}(6*b؁O	u꣢2h\'2S4\"VlDhQ\\ؙPHP3	_HgJl@$z/rQޱf0n;Zz;	\\&3LB(*\ZQ)Sp	oIӋ:1\'^5:uiM9{r>FBJ9X}Vb|\rE^M?ivn>0n4&n{c8Pa~NgbNXNs$Wv\n=W[V1D\raE2\rC$B3(MD/֡뇏ߣmTgb+* WaCg+#PdkeZ_ndzsUNYjchw,a5v1h/eBXy&qE%bl]wi(#l\\ba\0[\ZA\'w\Z?|C|\Z;q+8p9em%7:)z807p\"cRLQeepi/vzM^d*e2y)sB\ZZ+ 8B+)y^|\'r\nw7Yt-&i8щs\r!g\'=4d\" ًnű8)<m29˭knPp(SYo*L*\'k;4@K%`ϭ]]|\nh=QMX2\r%x&8Q:\rv\rvO!E>h+n\0jdT~b#i-8Q\n57ϤQ[_B$_g+b\Zw.\n\n}X!TaXOmx pV\rH3*v6cG~9zlQE,Zqʅz8l2]#\n^%\n簵ҶE؆bE`VQTFZV{tkE\nU\nN_Bn,Vv0,\ZR2+{<~WyUtkۜqigTe]+>Xzb=PVmR%{HQiPdb1+\'(Vi̇+\rj-4at;#%VB\"-z6Kt]041c0zaf^l`k6V-z7\rumQ<}h2T	oyGI9lYE&a|M=ϋpf>B>$zbpVO(1.8j	VT<!dK&EDP!\rwasUDwDr5Y׏o/k$O\"eȫ֛>6-2L%zUBEWS!X0M\'EEɖNRV\\vb^UϪ@G ӝڷJt1#;K8LչS@-.·iƴS-|j}hL\'\ZИCs:q\ZQ4JXHX+[Hѷ۝Ίv&H52A#xOLV<-`R۷9]b)t0N]3\"fMt2|<5X1O6$c(jJR*ocW\rx[\',zUG4hh\0R´h,F :7?oroGua&aKg\rn0ـd<b҂7xw.lcHN%fm1TXI:oh%6F߿OZF#LZO&+fwE˭QL86.93\ZGk>Wh4f\nݭyd̆)ďLB@S#b[B\"_YRSj)3MM,kP\\,TZyN󇻉&&d蕭A<ATDՎ{\r\\9Q]S9X;ޙ<GT2 `Yq\Z<\nG}d4Zۄ\']փ۶Cy+\'Ok`2\nP	\n |E42G|KT#\"oӯxS}\r]>}sseM\"sHv08È+{}a<샊|BMӹg\\\nNņ%^1>KD&_BkЕe;m<ɹ1nE\r-5Ť@]c\nb٭}Šŗ\\W5Z}W*:sϋq~=]zJ\nL(>(1O{F_h/(/:m(E9jO7(_}d/DL.ԡˋR\'tzsXGe}B5E$v	:u=FYJC-VD=N{Nu5gl$	( Jz*ZapCbϼ_ztsqCB6j\\F%ɴ\n*ua?%Y-cI	WJ/O_WU]	ys=`(*3x+z}MOrd7Myqjֶ[6I9oPIOC\\zhU7g$^z<Yw)&#=ȴdmBq:h\"\r4]{[`SEaq/ta|rzhM\Z?KgM!up.7*QY=7\\и	[\rZ2 zf4.M)<6vL񚶌X$Ƚx=ZxUtOF{u\\BC6(!Ô\rvCܹy\Z,|;+}\ZP\r2SnL)t<^=y#lF#bkѦivD,_<ܟ2+|)q0REף\'\Z3SqԹ\\.1׉}::4_YB|x/y\0Wj`U(2GIdf+jhb/}_8=~&^K`,ur)P5j#ZHC%}_Dro;MPSR]NoqAI/ 2ȆhDY\r	o\Z1өӊ#RpJ=zn HcꀆVkBƠ&u]wQ8-ϙ:39lz %\" W`%ߓ\"r<@~Sז!OuĊGAC](.Ų1`ʪzs+E3[Ʒ:t< MR\\9vr)w)AȘD\"zM_Yroբx3V)<K7ӡ|e6^+:{KHRuN>\n*H)϶\r0xmhִ#D$svʥ>)nGeCHԥdŊpJ>̍\Z:̡^^.W,K\n\"Ezư/m@mHTUdj3/\0sd?󗇷#[\Z=3ce1/=a<U04A,qh-bcF\"HLpfZI][fyeg|kEPb>[xM\'RqY\'9=.2QǭS@\nMQjQa q<_t#J~F\\Q^cG\\LRi8_2`ARPШ)|`tJ\':l݄EQ3p@/nARy~ħ]jBi\nnh\'Tlжq!͢@R)h\'v:/O~x~;ѣ/>bE\"Jvc.5wKZ,Ću׸uVTt?b+E5͈Nl$whfXV\"O-ηDtO2\ZuetʥJ\nI_tJ~жR\"AǮւvSm?qvqH`v/]Iq<v9Xq]\"3FP̽ $JjNR0R+k=7Jyw_jtÕ@ϊem>\rUh2Zv4.#_g^Խ&$n\"Yl&ɸJWYSDLtvSK͸)]kYӧfp>&SiQ0SAHd?uG\'|b\"rl[[y%u$N$ʝm\n~,t@f}94wUx25z\"AUO_\r$.nۦUӴGƫxZ(Pb^Gd|0h\'\n#h{YzTLʙGחOץq4垐\"Eҧ֊4 ݭp̈́\":7\n-r҃0V1U(1ׂ~r3M|a[b`]\'ERzm̦I\0QQQ+Uَeݞxo%ڲ	m(\n̼$jN\Z}7(|_^Cphk`Q^6`jDOOij[Lb0\'iA.\ZW\'\rʌzD\n7^JyQ4ݢfcAnr:8hV+C(YlC(f顝@ǿ}n{<E\\\\5 2@T\0\'ڊB3}7PalQb.=_*=uZވeb)e\\5mW7OTЋѥqsZ0Pkd\'\ZN%Ss$g࣢Brt/~RB:gBP\0O#p]P\n~+:~\r\"9zM4NSg i;{xGAHILvzu;>^cYh\'Q|a]p֏~q	_Kze9DVB?q0(Lݸ^qbQ]b3u8~:#\Z7.|% ^W&ݨ(x_}H\'R2\'M;b+R(źBWYTZۅIM1w:ze@7Rdb6jK=	\r>R\'W[0$k;Pɧ6n\\\n\'\\i#ͯenB̚ER|GMEMP%JDT$zuHMODOhE$6\ZfҹJ:\\ן.82! O֬tQx٣60\"[:j*?3οyR5⩴QCKM*d$1#rv;_ݙ\rlX0vn)h=gEAw&	국k !F6v~O`>0.zJvzT7z`O\'PDQ#@76k	pz{\"̹<)٪}\\.nqqboVmsB-}QU{px[Dɞ0;-3%={4y%70}Cp^{KXJYBUS{\0gvƄ֞E&OiN߈?OͥoʽX\"h	\Z\nZr%m2Hs	~hN2y+X3I\rCq!N.ƬGۭpT?8~xUD4.)IH%ƁE6suLGe;3Rn*\Z4<Db<(ãlvGw-e) hF<RZhvh261pQ-ϭq].lT:*cްځ/fL5CX7$/啯wYw̻`ᮌ<md4FGg:\0ځuҧAՐc	l\noD~C?a6\n\'t$&zF]X˷mEl-xsqƈ5%c:fu;q-\0J=˾h\\0C]>rk\"sz&/4RM%v%/ꯥG3٠4UЁM7\"7O3zǓv%p{<XuNps͌Vc\\e):KF&	8Hd	rM9m]B)=nSrlsVd6\r\Z5ut\Zٻ{ɯ͙;]*m$1FTަ8o=`IvG/[㙷ҹ>e2#btB`]6X㧱Fxit΀w=V¶ioR6Jmm\n	UUM\\݇4=F]q#WnԖUlԻbN1m[eҌ[]UuiJ|7oER8 4r@\nEX?>fb@cu2}u)Wp7-5+\rngWTՂ)VOEBc& Sm>Yѿ\Z5̔+5/M®v:W>Bۯe^DƯ_3=-ij!bN5)Wі][N\\pZw׆^?;^J,D(ꣽ}VWemj=o01%͙޲+ڴb\"kd 7lRfsmEtp-&˧4&-ǈujI\0\\-R1nZؼW{!~Ӷ+b	(m\"\r5Q]/tA\Zdo]t(nT}헺w5diw~Ъ^PNm1\nz+pysTB;K`nuGҶϽxh/pz\rQu	bzCЦ}{fqaF漝c	\"Y\\絮v8mSߑgAƄ¤0Hް_߿=UJu8X\'}NYA;4Bs!nEN$`rLB.EDӶ]¨v~F4nڣ%AzW(Ver(]<C}:G,&䗫\nv\\{ÄQ@lu֣f4i@i}޽bګ-ֆrQ\Z\n^_]jԡry6r+4Sq*a)2#eGGe=4\'jHRG]s֣n\'\'z*pV\\ܿXbMeC\\/0\n2JO\rIZ\n\n?m9s6^HG5/p`&kp 9按.,\ZG	{ۍE߇1mY:y*/QPðoQ\Z.mmCԵ0FviLkI%E(n +YћA0g|mW3DPhb>OԂnHr@)۠rXbC\r+͏>ԝ^NM;JdicL:[VeڦNF4g\nu11WLV^ru!v!ˍB,zd;B)cfo*7C]/OmMšO?O:s5QћUieĸhtJs3s\nis5qL\n<<^\'i:Ud_	DFe3(<vN4R7CWz/{=7_q(#+\"IgR.\0}$TAB	1eSƑ|T`N9&1!<B\Za:G 91??BY3&_mlV\nʻnHan[)q$m\"U\\E,z,5Q4S\0\\[tr&gܑ3-ckUOD/?<=2\r`G\'?MFбWC/3c7#u.>E%eS\Z\r6SxUIZNDЕf楈/e/\'?=_k?cd~ma|\nO(/o>{>x˩/$)|O;\Zӟ7û\'K4SPS釞:Zˋe&zbEAײ6<*D~Z^rwy}yŨGH\0)Q*@BdHy?R4|oM?9Jb4&Q[hYD\\()D\\ghsR>H\n2KU+)g	z0z&LaXh.\\B	\'P8=O­GŨ3a7mZ&E֋6y7 wh7}\nq[ޒ-5[*Xı0-zf!+97}cGd\n[<\\\'h-Ix|􇗦\'VN\r<9}|;w|~TqCƢ\"|*.&!sw+e(Hϵ:7|Cu,GG|\0awD_jw7rTrj>pJ/w>~bw&	{B;h)	LDo>0\ng`xt}f~E{ƇM‾!{BrnRLa0ώ8y}/{bC\'Y0=3w{,my#3g?dh(1\nM8Y&6܃JI)/z#虮>3WAΖ1J7,f{tT.H`|[S@\\6zuB]~\0b~ëye̠ɉo\"ˊy\ZK1Xo(!.<Gp}\r;z@7>tc^^(HǎߙJʶ3	O?yxNAff>,葽v\Zׂ[7K$2HCj՜>\Z**4*1=JQrmnNܸ51ѯm {Jcw2hÓ<~JSTiltz>n)xQK%R}.$Wa(c74qVz77iGACW?#so|\n+e64Lu,0k&?۸MϙY\0)nzOd<F(d!z(P%)΋@]֦6~oiBxc2q%9e06BA؈u贉s<Th?8xL\'J=)E\rvXcrS/̢3mHPwSχfh~lb X=!bY.Z6Sxw_|yǿj\">W\0\n\nq(z榘I(yig::nq~WYr؄oe	uUk\"\r\0D7ipT᷷ܧǇ=OjUwJt\\\n!0V2oIhJWY\'Kpk1o)mbzY[a߳N\"m\"9)Vw툛Jh[4ȶ	h3vzrtP޼D.eA_}~y[\'^3??O?Ep2O)&pkhCi3cpsdT\\Qpkz-Ila_k1ݷ93Oo>՚կ=|>{=tY.Y=MC5^ֺ&#\nFbP<+Xw\0_NNfcr$zSE=F:օvvE-5W$?,#.؆\"\Z]\ZaC[j%WSjl&oq:_t=Y}0%\0ޞeD$)O#VeYP%Q^>n[$ZdF$2#n/??5uHyzyqMkP3u$s%?eO|ytcO}t$cҮ՗FxN6Tܐ1h`x®s\"_fyٳ\ZnYui,̀<Do\Z!#ODJv&\'v{X4\Z<RZM`{[r/͠`i\rQψc\rm}A)=L|yuyhrvHPH)`-)ňVcAh`	g0*U[g#oo\rgggGoswC.z}Fx?G(\0%Crd ht6@Xѽ_\"9hMq$@`N@YK⥿{蜺AG!9bKmY6W/6և(6KNOSdN5NY\'\"uT0E-Hu]G90Y~,4_$QʤJ<F1v-+8bj4˱M.Wwq|uIwq+Mk,BeMr⁒p 6QIpE|ku(o/E|tN./^o={>-=%6NE;{!1YBt[iđ2\"\'n6<y58Z8Ɇ,4`WZl&*52̔<(؜N!#Wӳk׊҄2F\n6H@b`Ygzc\ZٓD\rv8,)VJ$02Z*KӍFO8by\njg;痿DH8H]V=x= ^@#?enNۋܺEO+TWC蘶ѵZmJtZ6A@deprr)46ҾZl\rޓ=;;,/7X7J3!fM)+衩V\'3 =5~`<a9ӗ7ʛggzskBkg\"ϩjm/E90Z:y*ZbPA4f.Z}tx~Lڦ:P/A\0Y(l\\Mk8!\n\'=X-Ho^%7m}ʫ:/fA~\ntXhp7;v |_tL\ZyJsv*{zGyIM&Dsfu#P9D24\r]TRUCȴ 5Fw\"O?<4\\̈/zvGtygX@H犴bS(k[b6ݾZ,a|]XiSoxg;sH#xF(TM\nMR6TrHV1_>{=h{/7VN7T^mՙwNM]Lv-2tlrQtݜvU$ҊS=G;Z72Eؘ\nXp)dHzx~S׺]uPC]>yOa,v>9-=8e3R(6wwUA\" hC&I1V62:vaQ%zzL]Jc\Z<QDWP=\n~6=\n}<ݭ]eŪG$\Z\\_<NZ{4F\'B{Ϯ-,ޏ3VL1S*4XN@MW$Rbp֞td>VH~-bj԰#@\"AS\rmj(\"VbٸlMtQ&;;^ܬMfhHn1kkD	u$\0{O$u~<]5Rb4<CSaa\ZРqeZLwa~d\"uv^@4\"<iӳH!DJ!PӾKWsmP\Zz@[ʥ޷>\Zy[MC9Ͷ`XZtzN$@Ե#]}羏#\nv]扄,7zPrMjR%k\Zb \n[DwzܜE=\"I\rR{61ؼCnq[L58y*얮frlwu}yzwrc/YTV634{2sN墨`_×HQ&m|Vm!RÕ\")8cԧP\' xD#	X[hWZ=vwؿ_?Nl6RsF҈\ZXQCBQ c@a i#zT[_8(\0ǈ76}@<	G@(5\0;Q>x1y2_6cUp+m@$*^x&ĩMʾW\rMj	RX}|ן-~1L\0-22Jaơ(!f=REG=jⷧyrkʶR~)te^,}Ho\ZI&qS\0/4j#^DIʼ8-LgA܁%Iruek=hAV,LO\"LsTH6?L4P.CAm0jOiI{oڅ\n\0QTE#Q=5˨)@h\')1d,RC(خ]ʋAP[Yq0×L򰕞Y_\\u)=̌JϨ9\" sRZz?K ڿBcީOfS\\I\0\0̃KiXCԢCr1SXC?s=qA)azw<JFe*yS\rŨ9mN5 Ԑ=Ź(uӔ$80)@8PRp=K/9vTIc&:bma]zA8ViСj]Xr2{7\\oYP2񖃴[\'6p}=5aq@XBŷܜPVݮ>bW@*-PJ\\#~QNK>1A;i\Z}]tGM\"/2m@5)-2EJYYS%x׭_?@͊\"jMb#5\\Ťi9Qe҈mf)Gގ[Hc6d:ghM#Nsi5\"F<(UqģPAR7Wɯ_{iZ8~\"jvvy^\\#c׫-zŰC4hfҒE~vjؐdd:uJz;גN3E<DP=52(4*rFUZxt-`uH<icmVJV\09UzVZUF6Vzp%%V.eH\rΗ|dOb	ł.>zlIDGI*(}\Z&ǈj3XO4teD;hN\\+/,* \n@H@\'\'+$\")&Ȫꌍ#Y5JA9耥@\\յ@l2Ӳf\']BR7fVywq9ikJM<\0j[XMGq3P>*wr<ibFv	lbXnc٨?}HeqIf<YT\'སss\Zhs\ZG)@7xY7^ˌZ=l¡<GqIb+&atftEnU\n\rZJ(>*bI.`UK>fi4lR멧@۔ZD\",t26@ftNO@x0ݚ+Ff&̝[D`$\nV/H,wy+\'<\\7X;ߨ^mP\']6S)EIH&ȫG7;\\Ð݊E>@]V4\0\rl(;\r\"hGx/T$&~ו/&W\0Xzi,\r,dHqDKcj|v݌!䚺mƥ̛!zГxQ[`\nK`-Sޗ?!E ){ԣǰi@2kXms;\\h\0>dx8Pb{ZW#2B(s3jHb\08N)V9s@^XM+ 90%NjUȹ|fft{ṡ#%m`m](ձj{9޳$fsEԆ`\0Fu/xz_cLSS	iS\nQ *8s/[B-7竫4;LIdA~|SEs&D:G*NCÅެ1YBa}FIiFP$5ଁ-Ji?\r,6:\rVZJT{;Dpznvlݧ@u3V<؄5-CXÐS8[Lyty%5<|?~=Vċ/Jh=\rVݰ\0LC-t2DVǪ_j-3i`f-Cq^$#ڔ\n	nC19{狚њ-@s\Zz),f5zjYc )\nhP\'ƃ~.y$;08.;bkJ;TE\"XZ%]Eoų\\[K\rb:0h;{f+@dfw$}Xjs]y58&+ɀf5k \nmBcXr1`\n\\{o+Lv]J=!bJ=48</|ʳzj\"JpGvhurUꦥ҇qA %)VؚfR्Q>`yx=O_R\\JNK:`1U@O\ZWR\0ֳu<A]^\\9$jºWEDƾ1;%M@x9i6\0Pl=2^桊ζ+<Tab8[ΎfSHTHF\0Y687<PWV\0ٌ\Z\Z,x%WkоsOn\"# ZRՆha\ryCg!)b\0jwZXGz=\\uHZ!$A\\b%yjGɊ=B#m%DHENH;=\'/tKjvl%bf=l}1;wy68)qXo:\'\0Gir*{+[L):=2;5E,IH<B//.3OɁatdԮ%DAq\"Zi1SM1T	A35qkډ}A_l\n~HGq%zQM2\nxnG+<+\nr0\r͂H\0#.F|o2$ό<RQM$wd@ȴ7(P,:K$oWYgsPc3GʅςP.`9L8:K719cy7\\]]ܮL=b	1$\ZobC9kFGbŬSFp-\"!ݧΥ뤿z_^DnnPB:1ѐdLQm\'4ZaW3tss\nI@+5L!uXq3U[3%li43bLըӳ)Q2	DZD5+>4.$Hh()yʾd(HeM\r9\"q\0p^+{D|4Ys5:b=_8Mĩ\Z2DhA}paš#ԙ3[dS2g,;m8yG|˨\0>ւUllS0&ӽ|te\'ʎnZ[)FsϜv=bp{\rכF׾ȁ՗=Oߔ>l֙\0 MIL{	 \\~J_(%@i	ca{@馫Y9i/2zbO$Osd+[-jIαGd6i)wƎZL=.&FC I]z `iłB`˱(=i#VKjER꧴^3m@2D-}6O]Bϔ2ejX^&3J!ƌ#8ݜoOvZ眒ˎ6iֹHh䂱&6o鈔\"VXP@ڌ.j&AIK$J*d1\'\Z^\"r)8ke[NSa^~5oF3WOCƮU{rf\0a9%lLkeQFZEw>*`KYzYpfP`W 5r+i-_9	L+תi!6f\ZO~\"s8iśH]^o˛?.>yݧm]>aG~y?msx`\r6~A%ݲ8RQSLiØDR1ehB0l2}[c`Ų_~[/@%)@1DGk@U\0lũ	K[/ij\"ڒgX|{zyRluvJ/x5oϮ6׷?^<Oon7\'?pj<V4w6IA|q</DM\\2eL,祥1\".\'wK~_~./Ooh>V$HWxp[FՂ_*^.΄Wr9nk}yzO|s:k{$Y}=&p0 \n`%&j\0mЇ\\x1ᘱL7\'gfެm\0H1C7aF8lZh_BǠi$yT=ݿ/Dbw=<uFSb.8-ô.(UՎ5}%C^no_\\o_^nop4;#acPh!bJ7[o([0@9Q<svXgiOVovRU HZC(&\\5-^\"\'w\'/~<zbы\0\0MD\rei\"\0א\n6ͦ]^y§|/>ZYF8{02@4`i\"1݀ݞe	{ts@0\0B 5ZH$eKEiJ9`@Rrs]moYn9?yy0峓J?g\'~sÛuVI6HNsrӒ>W\n5!>E~bF[{0*ϸ_g_ޭї\\RMi95,dbbM]	F1oցOM\\a؂+[Bu:#6\"Lr-iE.af(\rڰzrrywq˕C\rT͐lƂO\rՕi	SՆii2|.ʎc/qDbGWGa߳B%:iEh\rr?xt$pS-51-]=QEaK){aP吵_X:NOCԙk-D8M|j]ﷷW̕p^Fd\0QC0rǾ(-Ecypo\\o?e=yQe=Lv :f87NmVpBB$^xBa皂ނOU`\nXJ]`De%jkԉ)x-sz~uz}yߏ]no.#U`(<eQ<iHxH\\F.Se\rY!cK+P0]vKKIM~o<&$OHpq1Y;d>RkX	HIä7Ȗ#u X<x\\f$.%߻땠TH\r(.Wݶ62Y0H$ʠX퀰>wM_ou+eI?wUGh\rth3i	5vD	^mp>5|0ʾ<{/^{4VYt@ƂwTOu٧g-ȿUE*\'d^镛 ׿n@=V:%t=WWJQag72%:В(ih1S}kcstVVhmaGՎF,\0-vQYpZXuSIeI0CwڼkzY!VROM3G&W1\"	KC+=\rT;s.$\rX60?k+x.VJR<Y|H,@,oXfEu>f0:+~\Z?VD/ /9L8Ɉ $ݮQD[yW6\nuxLܶRSZD		ˠ-Vԃ҄!:!ח./~}׷Np:nOM2}\'ųjWDSv*2Z)iSb@3H~Ωޏ]YxO]XBwA3xok$;C7\\}Z\r}UVZ@M7L_lK69kAMr]0H,dis?Ws{4qmSLCpo%Ǌedgmjw}cJ]o-{v])WgM(pH#9߭$߽$!Rw\ZBos˳XsH/Y!!8wiDB.N)n$ Jrl\\0$@Si?TOu@,\"L[M1I2(pY1YeG_ehz}ul%3v5m3ꈔV	~4^EA\Z\r\r@T57Go//=|HIu؁	=\Zee0&Ro%;,aK	ػɭ{lEK֧aʐZq8\Zr3jH	6O`^,~@Ǻ/{T\ne3[KZ:~ 6\0:\0`*IsUlF2)d\Z,t7(Je~@_%km}l>_xB)!6Js@g\08W3: qM\0lL*6f	W,7\0[f(m ʱIБJvc\'c-Qq5UpaSïrz\n`#pE0gSTNz/:\ZCShlc7ȗK^b=B)#Xm,9\0!^M(EG\n-[^5/^a	\'~NaI5z$hl^Kc	p%b8\n>{Ӌn׬Mͳ5u\0KʼgImݵr,u$MƇ\"稜!_x|=/?ޞt+敱8,&ՁԏVA؂JZ2=.Bd+D~{2j[EId@ϐā.,ĀxSDE!Xc*yj]mHª#(7܌GⒶ6 pZ	<2k5kSkÙB{PP\\@UlT}&7#+˄KCū쾱R]I@jKPr4~z0 \rX\09S7<Fc5V3zeSCƂXon)3Q[3𣊦;bǉ;$\0j9AaBL`_ZD|?y{9}9\nW\nEfUmeH@~xA+Վ|4r[bV{īKH*(@cz;͌atuU*o^OT\"5\ZA)6S؏tV\nw	Ӄۈ=?E;9F;-6TWⰻ8JJCh>j#t_q	^8f6{<!<(Hl#89Be#a.ͤj~!}D>qXeMZM콮EUx5+&\r6RJtg1h>cj)U``r}vo}}wRݎJ9%ڝsrKxKƈ%ۢS\0;\'8\n d.^ZbDi{n=)݅i}buBm.ܬBgӌX	65Հ)U\ZɮM,K(4ltjZ1}e\'g/7aJ6= :0G-cen&WaJV\09>O]YWE ʬ]h3+0K%qzӲu>нM]؛s\0ͬ+}PF5ȴgHt0A5\red1\rD6R|ˣ[Wsl^D`M~f\"rbvJuP:m6ӑ<.S^o7/V3J2%Fs51D	m.b[oMfL(\"pJ?m(_iܕh=Xjݘv\0Lɷc4Cc@V6\ZPtKX>]1D6)h\\l)W tt;h	X<~d˓kW;NO*KmG8J7IH`0!τ2-Nڨ-<4M!v۸y|}Fm]{E$EY%m;N(Y]\"3 zz@L\\7Gfn߬Mnu>XG߭T\ZMm\0[F0ܡٿhv]z.7׿>Z~t{lr&ʧƮ_;%y%R<\r={&[f2טsz}vEX8֮&#dZgԺH)!:4lj46@bodևP6KR\0lR\ZF	iO$b+ᒋJ\'+}DPyWRv-6@Ͷ#-uwX|=sp;mfdp,\Z)@iJc#[V\n5 вY|ʨx,A\Z3־ENY$jG{S\ZHALXGtaye3tnM[uUR/]{{P_H\nuӂלGۏ6~XbЗ>^[%`nl̫A	:M5u\\D\ZBޖ],SO|*)u1qsh#Ti6Xo[u7$^Ѐvgo^gfILZԒfBA-	4%-G\0}t0=?=@ծ?<ݞongWw.N^lO~ޮ_Ozl\'Op7 U &P]5vds9@_-+ie8AkvAq|*i&X_+A%g^S\\/]s$y\rkfA$utlnt	\0$MP,3F;zN_.O8n#G<l+MBOAg\rTE86b\n^c l)\0wT|KS-kM#Af7]^iҌca<#XtF@i@g6RΒ!+4Hk9^^<h7+$כ\"VFC\'x@\"0{->x	4ZnUoz ?\\CyKf1d*+ 9*Z%\'An՛ם\ZD3k^)F,.DsxޛsdDR#aǃ!+y7D-Ztyhx휬	؊`8,lm4\ZC:bm~Ay-^ܞ<]e%A0T79Mb\'!<3ZoNli\0Jc`v	w/?zp\\kdݜXe{M(8![G|VZ{?F~j/vv+-j$4;) _p4-v6jj\0hմ^ez9;ֹì4;FR|ZTqvyH_Ó+Z)}5T{oo~V;\0J+Kȏ58{\\|_h;ze?U3}1K;)	BT!KG\\)\rz:[ Y+?n?qs=]W3Of)>,X6!r)GF	-BqqϽ#=bV5&4lO\r3\0M6\nelKv\"9&B\n5is`܂Jh9i9G#A\"-8F^Pf;ߺ\0Wn\r#.(m`˨\"cIt \n;Wұnƽ:hSkd#Bɒ$\r֐5TbZQZ+Gﮉv&^s]OŴ@eiS<\0`\0l]}+r5)Q7V5I@⫆fñ&e,eII)9`(SE1z+a_9oz\'hts}tw{v~vR[.DƟ\'UX8\0\n;{#E:zZKWwv?_l.NϷO77oom%ULleRG\r>	j4nkm\'\Z:ifvi[\\&Oo|L0\\ey8Ry%YYGj/>]Ki 6\Zj1$(Ѝ2;MVm`Ok1%ķD?fRwtͶgbH-][S/\ZwYvXi14Azt\"o\"ˠğ\nu3aѠDJu?uf]BU}\nE]<\0ir[bZWM)q\Z$ɷ$yh9>J]a7p	h?WmF		ujPި5ݹ2vNKYZRX`b1(L`M;*Ԣk>Ĥbּgۛ4rx+)gFBAJMʽd{b0BC}\Ze.\r ʱqFY\0]T\'A2nfFqЧS^6]Vm[5WnD*WqVvYO*$rJcɜ!`Ǧ.vgiS9egOzX&Fǲ萢K֏ɨ7^~ݽIMY\ZjidQ 3\0vӐj(^]bAO\n}^noZ0<Gl!,:jql\n_˭pթ{/~ߏM?߭Ul-{j2z{H*X\0\n\'P{mn~Y֎GR$6#mRĠ m ~8?O|awIMvG5klT@k6h6A\0#o6|j?S JEJiNG%H4wT3\\&)*bB>h*+9ȍ7L.ZJ6=;R/н^<~x/>v_)T1Lb\0\\2P:s\r#$̔O{\n0Ȉ;o&\060.XKYJ{cn~XAc8pEV5.FUtBSG~`kWcdg>TCۗg9xm5\"]ș\"Bp>J?a].$T]?/~VѻKV[BZ=,`]H4t]ٳ3^ImגZHڳ\rOLH_`y#L2v\\Gb3O/okwϚ}\Z^\"f_Q.ft\'];bk^󷑁/_~}yGAa\'\'DW)N	g\',NqG_`^;VXDX<\\C75Dd=N@	$#\Zo>⽃Cp|wWg\0vaAz0X}HH}Ll\0B{L))I	F<ѿY%O6TuH2\ni]<<Gl}2\rre&u.u_[{hvQ݇U/3^҅M35\r-Q%5c\Zl9(_on_<ng)R|5[[}8\"91#\"T:G\rwQɑ;t?}篮,y=\\@gMᜠD@)8+ۢsnso]yz\nx.2vp|V8٥A8RU>MW멭ic	Bx(5pʣ\rCK2ҐBuHJpv$[jH~x`_oo7lͪ୤ZdՄYm_.NS]2~$t>Sm;+ fsrT~WWfա\r~$ރ<\ndallnzDRڽնj59<ˑۛjG0+Ƒz8	=dk3C_BQB6F1EȶVH7mi24M3	!%6#KTJkԝ4`zuS~`\ZT)82:-ZRSs# NdX^^p^	1<|6XF(9zZ\ZT!ޤ	yPX0<t6c?؅J͋zuu뒏+ujG9sp\Z5JevJ`7_(̠4<b	򚏵Fa{YknAZ;Id|ԙLJb q02M\0&;*V둍5\rt@9:B1(E\\Ҥ)ȝ66\"4|4TR|s۬>רg95 gc<IN,xAG7\0$\rߛoItُ󥃃u_>:=!aX^	ogL3N*dluW&`\roW(8@BΏ\\<69zJE\"Y3&4_3`+8>\"}\r)F7ejOŨjN8V`],? \\oN/{|9vM]m<\rn)ԆAclӵf)j7=zg۟,̿Yiґ%-8=pVT:ȱ:rp^j(4?k@!lg<ucv_Bt%>ZRU#ЇF8\\u+Ejq.p=\"\Z we=TUd׮\\7M1A{C 4ȭȡׂσkMc sށķOrӾ/6\'kȍR#hJ\nn!}fDq]GӮ*-l(fI2mF++8KE={Q|NE2kvyyۗ*~E|ݹ(6iJ/5*Õu\'g\0ǽ.)ęXnonpBWaD\nbs\"\ZdX^97<69gKj?+Qz4zd݈\r9̠\0A1Yn@{թ\"QZcw>WK<F`23c >ƔHd@ͦmR3S	6|S׳z]UmfOJߦP@gvhn֕A\'sp\rקtn}r3wGQĺd҂*9LE-@^!J1E25ɣ\"{식Zwes~v_-g@gN?igӂ:? xu<\r\n,g>EfKZ|>h{MWx؊M_(LQRZoj38SJbCUysExtb{?y<`9jN݂iGDpz7|EHfq̡i0-Ҋ>|XѧyPr\r d~, 	a½+\0\\>MBnZ_^g8)k-%Dc9#9\"\Z4`C.8lOQښ&\Z#?v?XV\Z5Iʬ\nDX\Z|	T\nM\rqАɤ%)ɇg9kMtu	Vt7VKi`Hۜ:괚x2/IBI7\'gs3/_nnWrTv֯#\"a;*\rrw)/u{T+ExR^{\ngD@|YNظ?b&ٗJ>}=7=X)6VMd3ezś쑋=s9LQ@Z5zf+!3\rMǀF<xbm댶tlV9?~ǧ+84tCq*\nrH_y/4P\0)ĂcG:-cg7@Ϫ0H^z%Dg)*!GμO)wET	T^áH0͋Ggkm-ET\ro.x~d:J#S2\0Wx$b$>+<| \\^Shn}_]9RQ2\"Bjh(M]=n{7GWhO(XlS5#~mK]mZ1-v~piz|;\0Zl4\0x:΃nG$q&\\\nֆ8\"\\\0Kw[;GzowJ.k5S/؏@	2Ô\0H[]ܦRRXsIu/={5R*;wM8hƕ\0YUE2}ˑ.15m䔕>}#N{Qǰ#dЊ  dnߣrx)SW8NԜNm19T%mi.3\0(%!E\02F=2tYdu1lĶUL9Z+mv	u63AtDZ%\'ޢ8,<lrSe15iss\0s<~5߷?NzW\n\"h4B\"p	F$-$^9fjivC]{zBN^\\ܾܬdP(~qpO)O:J1/WBHsݜMixfSk>nb\";}Jx=F+{%\r-nH2M!\Z$#3HO\ZD`=z?0b:{yvzFP|`_;$F\\\ZـWz\ZU~Ky3b!hG\'W<YfwV9h]x`K2a}~fS4R5\n> %v$SґsGVjE6\ZAr;k8l)nҺYG{`->ZJ&k7Z-}L=M8r[|\n~}*kg4JGة]d3NZu8elUYCb6T\r4B.K;+ö\n?ޞ/7ހ-˕k3~\"$`vi>Fpp:i\rP~qkܓ|2-9xx;U/Xf4LycU?1lc1y+1=\0Nf:ޑ\\;4]~+GVLɪ{=\'VKӢ&0F}@]k\Zּbk<Kl oM&:Gj\'254@┌=R)CO/諯Wn\"o`A~KrvAzghd\0JHSŭ\Z5/=[OQ R=0XG͂89CZ`,^FY-CZPڑ)eh:REI 6ԧ\'}Ɓwk̑90pW-Tnvcxp+\0g\n9K( q̵݂l\n\\\"pglT6^T YX,<B\0/+?HĠF\\u|b R87Of4ls=#qtc.)\rz(MUBFV\0vg`r\0{SdVOcu6^)5ejZVRt9@VEmM^/Jej|E Y\"][|6рϡł-TR:\Z}VՑְ^U7\0M\"w?Pht/谪th= }\"|r[n+7,+I0,rGx݌{GVp`k7E,꺉O}_.~;|L[὎Dks0 \'h@W`63d)R,񪊩;wOzW z<.NVgJw%Dghr8)i4t6@L0x0pv92?HkLKsJbSifU+1ض\0X\ZT:mD@d<㠶޾ߞ]oO־W@%tvWI	nNb9ŊY|{z\0fvT>sVǓF#vځ%6{-TYh$S7ڃoxOoVӖD:\re!)TlzkYXcQvjPmqպ@KZ,B`a18J\':k\rn]_^՚n!hvteFo\n*iT;\0tR1?:^k~pi^9.$e7s,\0)VDgWf&eW,*mH!WFQCP޻>+pzMbrҔ6u&QrH\na\0zG~ލ|e|gk&-E&Nl	-p6dG7wEuʹʄ1fs9RxV{K{e&d\rGW_W\n{ʢa\0\'87n^-k-\09~v7SY~؀]^g{b^L=xP1<+E:hf3\rUiXclT:@KxXĹ9ٜGRk+}ԳVYӰEL>ZOM\"mݣ`>.onwvRXy	θϗE3{\"6^:CN}9CNه6ĎȀ`*r> 9<:Y@p` 6d؆ҳFKΥ V\\2,xoCՅ[N)9\"h\0Ȫf嗧G\Z<C%{TT@Bhtb2Y/Jj*Ag϶gϗW\Z\\TM)U^ fbՔf|43d9gݻ#V?d\'kld6p5LE	imh\rNu9	˻GۗO;ƃsOɹiS+#F`s2@TtZ{Ao9>ZbA,N7ߙ:mRIH1Jh$o\rht#yzs\"i\"\0PNӦLл-nT)aEިV+ЗZ֜CJZHNkı)#|[-peil!:sD nnw\'_kkh|5W5mZl]X|$l$$N17+;uV#q̻Zm/9R!$\"OO/BT5\0ϣ\nkS-B7iًbnș7݅N{Pxsq~\\>=\0ڿt0<ahX:B2`flkG@{7)H*l[1)&gڬ3D(sgvZ\03x*tQ<XVq(z%̕\'%EXiȝ5}\n_le),vL9:|ZȐٔJ+\nF^Eu4w<q\Zux rXKW{/\0R8yiLT7	C\r4{L$\nFug@7xJB3Rk~\0QR}6͎q\Zh\r}B8&}Ίh̘ŔnSZoj6QVp]\01Wj6V#njɋΞmO~=9vkKL00VbY\0+8,`tfFRv^YkqOZP,Bi/)nV)X<v=S7}Œ#aeGV\n@ψ	q\r1 kHv\r%z|&\'6\'Xhh~io˸FiOK9bM1\r<\r\055\"oTr2L݇ʯ/O~^~Y3XVk\0\0R\rVZl\0ZJ!5@Mk!pzwq\nd28.4:؅AI\nc&Uތ槑8^w\Z#;W	\0 \"\"<u\Z	@4l<EwIf|o1amR1\0X\\ϲՊDX>\r˜\Z${kxknl	b<4s\0oǢ .MpVޏ+W0x՗}|d3ƌ4t.2\0Hư$8\0mȈģ>BfNkܡ8Ald\0Iȓ #	A4w4@VBE9E3b|m.#FQk#ƂZaPSzN\n_>]\"qFӛ[ۿon~^)~.U>wm)Lzv\n>8hŦv1Ӛ+:CSϒfxpgVB=sQ9s)}mB؃ȈA)fh&FJ$#6p&8uucLJ<kʛԇ3S8鳵őnDIn274\nM<>>Q\"yDo\"I|ut WFPsr,cw(~^tiin]\Zc֌М7{CdR]H\0H@`kKp8\'~8\' zWgzuJē݀NmuEL5s6!q0rZ<DO2ItJCDK=4pME2V>ǋt\rQ=4GA;rlK}^e/\r~dJ>^xel)5L\r*xx$ف#^p\rS>0z-Bl`yTz{syoTuК7+Wu\\=8u`9|G:Seǐjt˹Yvzo)R(5|/Y\r{Z6_G\n%:]HF=[ͪLms8\\@\Zk)i&\\(76R99İo͟$\"jí~Cj͍)Ey雄T\0%\0י>ܼ\np\ZkZB	:V-jHN͜}1:D\rzm;{Dn5[\'n5l#k(!$<h9<\\UE4սZ\\X]NFh=eh}4<c#+Dqry#woWܟO[{yƕJ+!b~ā)CK$--O`?\'v8w:Z\0~엕̴wv7[y	,NVlxr,(2ܗ̖$y%je\\j3c\n~ҵR[e:CQ\nEt6	LGv]:+)S\Z\\pyv7lE:wLB|ZjbJЕr@ړ[W#4\0&iĚfXz[f#ئ9$𹧖H4\n0@5AtNH+];:RkJE{l{%\'Xvg(:@z;F)Rc󈗊 a\0&/=\rjy˧X༒IY;s`!Rom\ZY;jpf/uZ[i?\'W͗T%]b6`H$ \"^,w!,\'o:QNP~_^<W?]ZvĲxD*g% d:vBPGFdEoo\rWƞ߫uz;7]b=\\\"{ɒmm_dNhծ1UwM=z,(R\r^6g3H@eG\ZݥW4Wf8?KL<x)l_n^\\%X:[xGƢa\Z͵(^[q0qeK\ZPXc!c2;kv{(]^QZ8vB\ZMc>*9>:?[_-,1aH`iEQK\ZLM1Ci6y5_V	<pȲ[ii}\rΘ<aTt&b\\^W~_rW5YИf}Oмކ2\\)9\0e^4`\\Wە1<쯇-kpC@¬X`8C^@	׃1=߻?5!<N\r\ZkE0at2bQVs􆽤M%J5j}il9֣\\J1!f ,\"b	oJi{>c$?Q?H]	;NvkI\"Åb,~S\"4\\%U5)RX@ i6Ǉ\n!޳}w,\n>WrAmL0G+\'|@	?ɑQgǕ6xw]@}֘\\h(Ot-EHNc]IC셸Y3&;cԮ\"@tM`\r	PZdxl(M˸M}XInn.ɋu&A%\0^YQ欅TNQ_]B[-Y\'^e/\ZjlYu{()tU2#J\'ɶw}RNg\r;N+E.n8=]c\ns,ƫ2G;|Qc;Izk{[qICO#/r]Ѯ^1eq1!F:pKFY7KthzU*$@m]\n9Bɛ`b&l!frytg-ts3^|c[B 6TS\n/aYf@fﯫT3 DHP\rQJ¹6HPyFd;ۜ4$vj|UX\\7VN#:0H1_+J1BYߊGP 7~Pj\\|uI11n0 ?)4swVw*%Gm3TKUhEHBb4\"v46\"eΙiq6B=	>i37|Cu4L_엳˵L	߶;kqfGhDp#=AˍNr޼jwy,G.Qoھ\\Ü}fLfc]#FfZocU)ҼI%w8rNȮ//*/ζ;-ʵ\n@t͠]Ǯ,fS7GkLib387\'U_<]!ZKQ55#@1sɖ)r`ˡl$E07Zmo<]\",TRY e2Z)*Y ILmՆ9Try//Yff	w^N\ZpZjBP{e4ZX	)r{`Kd۬Rv#ݯrR|Vd!\0b#:ZEK\0*3k𛏽G<ȾvKIGoliЂ!T㈾m\nprBD.ywK+6$iB{nPzxp[fHŁSoROtmoCkGeSrٺ+Kz8l lFaj>aIi֙h%կ۳kߵX]\0\Z<qB+0%RFu2Jv&Ƒb^>{v\'ç4WX\n!ˠBSDlW:<IV춑o3\n c+GQN4L]ekJc,{MyD4_kf{/u-J>T3HÐ垆&/Ӣs0ĦsԺ_\\݇v{{}nձQks1cQL4sT	!8Y+ۘ\"NSm	S{bX*/qܵ=ٞ]f]9L}SWyt8:.:&g*. s쏜wzQo-]	d?T}[g[yY]4>RmH1?)8=Whod\nBU!(uR댠=7en|{3RjJI:-EU:2S{n?]!PMH5E\r;z^ h!dM7Rl+ÞE\0\n(@2L!dr\n>2-~tD[]lr.T)99ېRwbx{sN=ğ}HRmSܾE>hB_i0qNf7EG?%%q$ٚxT71[>[iZk5K:hEA.mlʣMн$CoF,^h^%?|$;\Zxk4NJ12fvi8!vZا1#Iq\n>+~M_})!F5:9uEip+%Y@*~[ăQӮwg+l&VZ2^>9\0nܪᦗ$]}sy{u}pV*jJz$@#jNdRvmpslJLEl1e{qr\rIWݔ]6]۴f,S2Xy%b;df4HLE/5LO%\\ff;2rN^Aq8e<lWY\\|KODt>d\rU{Fj8\r״8^tH%K?<1_oo7X]z.\n\\7FYل8p[\0І\Z*ȼV2(^n[>Wf1t~6cfO[@]0vXG5@:BȜ}4ĉևA߻Jt(US@{SEh)lfloިH>l^A\ZV\\wHlLt(\'Q,⨃1y35Pߘ72\Z کdQ$@0OHiU-2Nґ\"}zxsX˚RE>N1&i	|e#l/ҏPfr%)An.ڪj%k)C\nX獛GHQ~NW\'B<׫Uabnj \0_@SGw9@X\ZR\"+O^;˟϶Vn2A:ǤejzI,t:6{猒5v\nKV+>Q1hдZ)>LӒ9F15	|QSς翍,>\0:1IBS$\0r[3U\Z4Rڱv .~5f#hDYF\n=X3d\rH֐</~٢DPƵQA$LaΘ|)`UÍ:֠ť[*HdFڂr]{6ׂβ.q2Ls-M1%;icK2H;ߏ~$2z6`S7αaNđrb6O`]\\]>^\\lO99\Zy\0jא&$U}Ql=m\noJ񟧽}?ۧ7g)O,@*azcS\0d{5Bge\Z*SRᅒv>ܴNfض+pyV}Xh#XڨbHwI/5dph+b:=;ٮOҍ0)=\0(\rę%\'	JRKá#tl\ZB&DE\'o=7[zH (4q!BFE8#_12Mt:=6Z[m渜z\\yFj@f|vwaCg6s=P潪W;1!7w~AfJw	uDϝ#\0	`̹iC0,{nQ9+0wub͕ԗ:8\njCشaˁ:VS//.OhZe$ZB5G4\"1Rn#JtcFmȵC! xc@hC\'X){<{fK]mn	a!\n	>Vh,`ە8ޔac\"JfFEx	Ĳ<?Id ]QD<[\Z3֫Uc5tz_ؑ9[y\r\\)&\nW.<jwJ{\r?B\'E`0fц֌Ukˮw4uF\nN{v:gϾ+~Z^߬W\n-yrJUY@p~RtBךO;%9/Rٿ׫ޤ.vK8aB{L&G4ttƙ:n7˳Oc@Mz(XocG$\0)v|\ZN\nAps*~9p~\"ygjo^\\RٗHCi\ZA4ޮWYvwg>۟6O֘uVdV{SA,dh\rȳQEDZnm.N_>\\Y fE㝱9s^Ȩt+)%Yp32)*t?wĬ>kx1!.&!z3gSD)S-~ӂt@Xfs-z/j5{`j9dq#Fhv&rjb,.ZkjOH)p_t :ޞpvh!\rHDaDt7\0Is\nlak_-z.Y20-c`3q[6	d%ͨ|H{`߰^Ou̪ّ0FRȭ:W{1>-\"NWjEr-quו=R^UV>4_s!G@pL5g6 \r9ZyJ|xQmnV7\'\'@*D6چ~JDQbc^֐\'\'ެTXs-@Шlb+DӔ}٤>dsCr\0\rL\'tF[JW|L\nliFOjjQBʛ&2R8v:\'j\rJM)*L9lc@-P[\ZEU[䢎Yfɽ=RN` 6Q\\>6[u8nZz)~84&\0:;Mp^nO[{+a=uo832.?*PP\0-\ns\0!r;廳U\"eg l.RcMEmKހqTuk.,ׇ	[^q,n.].4|j&JLxJۻ6IogaI\r\n|v,)}Z1DvEW{r]Ïӂ]+ZêV16kVgv;hJIr/YcfwxԵ&{\Z\08&RLt85Vɣ_l₳we8׎jNz~ts{t*2M:&MN\'رqW3KٿwM//R.Ҍ]aqT!)ӫif2{wC	PNNgdF|.pRn9ɴNr\r4t_&p:Q_gzۛǷ7?c?.UZ GURI\rwւ+{Hݬ-O}bpSy^9DBZ^)kRRC\Z8\'(3M^W^=ntm6N+3^Mf(CpH4/CZ߳i&{/|L#`k\\Y{H!Ԣ\"9(hݣC6M/Ïfg}ϞmO5	Q|<Z\nv-OU=+6q3blLW/=8\\2b+dbK6̧h+gsÄSc0B^z\ZkYC25h{y*Yd\"p+vd%dm8O-I}.ftFu|qF}+[(sV8*p9s}Z7\nZGq;(jMwJB^l5p L\"b\Zڗ [IUN{st]t0|49]{Y#:w<\rt!\\y#7Noݧ!뻟q$,5I\0D0FWh4SꋕCj=V:Vx\Z`՛91,	bfā)ԶL)TJH`ŀ@ʦvdy_EFzzo[v/prO-M8a̬ÉI!$fcW:ElȜ&ͱHG?IbJmp#?P>Ll*+N+P9<@䰍bGtAݲE՗w]QwG8c4}imn\Z 6`;S./4>Z*~-\\`X\n㨥\Zdbx,хxd$J|{d|\\#9w\"/X{eܧ\0ܴVQjk\"_)AэH}2哗k}a[6\0h_9mVچ>N\'o}#X$V\\xbcPɑg! .jK{O>eখڟLNXuFLE}D\n3\\\n&stŪD`k5@iz֜cHnV@D kTnfBEU,G\rqieϡmwlj_׾\\lVSԝA`}C٫?Vl&HD!2Z\06z{sxߩX}րstƅ8\'vB\Zt$apD#膺a_?[k0AVۻx8%)\'U;[\r0E`7襁ޑ:ӡ$}כ\Z꣆z%\r`zŎBjh\rjCg,X-\"8*#N}iQ>x|α3>g]28␜]fp9\'d~c+\']Z]TpL.Me|zs9f)18Z{vsN	Axg\0+.#\Z:\r״?,6gїsFՑ\n0}yo|=3>C%6^H[k;2|!5+nʃ&!dl\Z9Zܣ!Z_Zrfc:U=r_Q\"1\0^,u)E13r~*#.:׾>RD	ݝw+ J480V/V8;-K4O@t\0@fnN,20[\ZK&c@P3ՌP@FJ2[~v@C	5:X;`\Z:`)Fg+eZO[5MR_^viڈVQH^p\'%@SAbfQR;}gG\0 g#ޙ49V7`窋Yp kB^KT=dL_!WR9Sg-gKO?j9\\Uґ)S43Z>2RCL:QQ_^pf:ZK)25F=AjъZ\\l1#{cE$˯kԂm$6mQ5N	yVq$\Z9fPקW+ޚT%6u:*]ύu`1qagl\'HoL\rm|p<-o|:RĎmxښF0(]\0K@2CZdo_|мr^^l[A8HŻQ*;W5\05XLj\r˨Xw/WS땢n))ga}3OkZ#w0ǜcxof=n>Q?%)5eb2\rVSsPԐRk.ќT/_G?+D?ya1A^Bӻ8\rEҽܳ(%É8{3=ի+U6،Y}큲zH5qvdc0*@\\wkXI&:@jiG\0\n2cvE)翷ڶ-\Z,f\0L;/wgGDk吭O	`HcM7ѕ@eq͞4Sl+9YK떾0B졍hoP7*I+\\qe:R@ttx	T99[)<tӧxXf-vAͯ*]\rsţ,3@`Cgzk\\-r0c{y.׺8/Ͽ˷訛yk8actd|s%##c$=7w/n}Fbsw7dԢ-3جmq ()sN¬\n?r濮ϑ/֜*Z0tC	)dqQbGS@C/0`\Z=2F.@Xca\Zpj	~ a@-}ɟ?יq4C)23G=x찀_\0㼎Tъ\"O YA4BGjm]Rl5Tڌ\Znq$0ڜC#=Vo~8o]oL79\n_%!QGIKo6tc]1T0M#镍g_lH_\\D]UX.Y}YPk>ޢ}ehr\ra|v79\ZkqET\\j-5ת\'v6C˽؊mD\"#([m[kLf^O6\rh;V,fMliL\ZF[%}JHm zX0)avsxsOĴĵ\\f+[`,/{maJҒfIUIEKhsb_gWGB+%a\\/7B6/ň8]+C`0.ѯRYyX۳WTZZ0ZT1m\0ބlfj  *lK,	7|}F2^)F\0\\_ǑiƉEٖ)o#P\\De8ۑ3)=p$_5sgMH!\Z@ZCЭ$o ޺12*}*Yi(|6xG<* ]Y:R-\\Onۋڲ+t~1)K{itP\r娂/3[ycyo/^p	àHbP:nD,ԮXj^Pקr?뻿3+tv<K{;y->M2\0|b$UM&K F%!ܾ^?y<Zyn^O²\'` vȆxC\"Ӥ&u#^qBHtz]S֏8;81cx8 n[&9cqf\r-Ӵ9*sZ[j8Q%L<F;4EhGLJ<؀d!Jzuq$wWY,gcu3Cj\'L^і.08?:yy8!t:&jl2~	\njR-e:~(˾$}̂o];6ZCǛĘ}\ZF|(~;J:|7Q7Xar\ZG~H\0	34@Y\ZY	vmۺ*8V5o?9~l	:<0(\rM:\'px,ۚbט|ט+kbRe\0%$먩,4iS\"ź@X}ǀg/F#NipwC9C)cpY;g{yNUOY#iaz&ʜsH\n\0ԗ+/\Zx|.2\"\nɹ0pOW\\t>&7\n/Uq/+7DMM 8A4jPY)ZZj/A&[v\\nK1巿)vȔ7\ZBȞ]Y7	T߽}bFeɁ1aY(>e4\'|Sl(CۨrpE?̤J\0Z=da>@#[P3}CM\rUd.z\'}2M~kG5mR:\rGrM \'iDB@ه]CoW>\rDnVNŘΘNuZFi@Ȏ֋=.%Ckb^ci\nܧ ٙ\"Cz@h8Rj`jpy4q\Zm4*#ȕ\nBD`  4ALZ^ԢvYϝ&Jq4B2ai4ZX9EZp ˱%.k=#D籞FǙQן@7TzPuoـMR\0BA\ZAxI끃:Pq?}?ڿcL#9Y]Ƙc\rX8<Gn$p`BHo8^C*nte썤K1nwggtMtؘA$j\0OCv.7~Ѿvy\'#-Cض[6BܜVx>p?6~P/_Z.<Ok\Zf6=jlMiJd\',+:׏?_\\U)tr4\'^w)rvF`ౝL!yeJ9}BH%΅g#[|էfE*]\0	piCRZ23~rB)]!1M.][8[qM$jrz|v}Ϸ8Q]<_pz6SWa,eaR2(u឴O{X6o۵Zh&@ugiDatRdm8^kE.+w{WV(	q&	:G.qf!EIwWd<L5p/VP$|	B9!q p6pcO%W@zcu\Z\\7NI\rAKóÝk?Б07\'u--lkݩPbG/	3JC%OSB#xڙZ潌G*\ZNΪ5Z\ZAز-)u<2:G,T}\Z߷&ܟB7\'/6v-D͒P\0 \0ryCv!ق=@qlʷק@+wTkFZ5RAE_\r<9Pw,\'ĄB+>P]3nOPj<W+\n5M^U,9x1lt|X6P>aʾr[8b``yJFyw\0iL2+ڬNbYs~H6j{ƣ\ZcocXB6`\"Ipe3u\rh(fsZчp>z\\OBlQ:֌iGr٦N6b8(P22/./_4(H78?8\n}[o2V\'Imt+g++V{Ϥo&U\nvJ5%Mf\ZU\r(9^oVYYCV,%\\jUr}-<[,4<vRǋs`Fϡ0vy(	SZ!37Y1>ˈQcz\058ej>!ʡonӟ^ޮ\0g grEe[uy4a5p#=5[]Z>v<\0)]t@l1Y5TPg&A\nl6}\r8=yd	~Zu38)9!A5U_MBglSݴ^U-\"Uǧ1\"4ֿ+-\\9:!T7XݬWINN\ZLdUF/IԡPhylIbbػ}8O?Y}&LӚ$\nDDq4t2-D^Ӽ؞($c8r4BoQmΗv]Ip5T_<(ɤ{\\o&&ָj@e^V>p7|f5,ʌ)GIF>Y\nx^bSRJjsՇD>xPOVrvXqbZ?xga4<ـJ7\rH_A)}є^FZ)XKhbW}2X2#j![;ȋ_AfdâMWZQȒb69}_dfnpa?D>q|[au/L_۽RM,pԴ|o%)	\r4֋-H6@\"8}t,*L6P\Z\rfXkCp!`Jh\0H;RookB%pr|O\" v34+c{u\0r\\G\',e_zKǥtp͉+A\\,(~}ڂaW3&rK픎,G+m{ƕxMz\'!Z3CkhwZgQZr/C2&Q|tsd{rw\rlFz(S-gQcNN)b|Kb\rvSb׸E) h#w}Ҿv5Kf0c\Zs$pf\Z~ONNVɥv	ژ6Rh!rhʖy]JJ\"F{D~)~a#+fq̜\ZH^4$ʁ41mĦyc/^@3bM%SMf `s%8\rE#F?\neܣ;iLLlw	rW2G~a#\\M<ԵWɯ_^sܹOZ\0<\\G=vQ2f8`SL,r{{Huw38f+ YUie\'G~9䮳2-rdqx*+//.OoRtspkP9f1\r@z4U|\Zzien=k\0}_&<\"G%k\n\Z[%#<\0nqL6jU\ry\"^`9懶G[}\rMH`7s%+3DX!T8}H;ӄcBa+$KV&<@5\r0뵐(N\0Ti(`jŷNNzszzyf藕εL\0y(\ZXӍ\0\nvNl`41mR|h=fnSYEjL)ZEQtY%8CȳOe<74>?xͼ<QWO:, HKXgGttqÛ>xaϷ$J\n)#M΂?3-%NAm5a+Nih+v8xq+w>xesvx=m%~[5x1R8;	-TKFq=wˌ(13\ZoBwkR&NIV}o	\r	uQ3Ï(dm=|Я7^	0Z}˔3dnd56U޿7!s?}Tƶpf0p8fW*Fzv/$^\Z(eyAK~0Y7L?nEV`f8H͘69V,lޓ!eG;emQ7ݰ_┶nK@*\"R`8(kr/\Zu/oÙCw~uy4OˇQMǲҭ>+:\"30\0r*\nGZO~X$4{4G08nM\n\rTS)vV =ϲ78  (v@%/׊5s.ɡ[8Ep,jCDm?RCx.ow_=A>_IePA\\0}YM86rゼ5pM7ѡzi_-k\r\'<K)/bIQ:Xت	-Q 4=D<bw>8I>d\0a4ʽ\r	InYe2j\0Eo6/lC)ƒZsz\044\r8RY`g]O5?`kXk*\04zQܭkǗ\nB34䱅D1!;]K?WhV2>y*D\Z+Hs%PnDgn62ؼ1y=rChQR_lhE`m	4\Zh ^[q\rQR0^rN.etusV!GL<20P{*!Rݴ\Z+Ki\'LP-Ղ>_װ^=PSwXBCmIiIGNC+k奩\n#O85mI9[JsK1Ԗ\ndR]rqހp\\>u@\nwBͦOcݷ	:8m-O4u\r@$rh#.uqG//O)߶\n.ư\0`FP@@{<=l\rłSFB(cRfac\rsVvRWc½hpGնΩf!C\"Wחz^ۿbEh\'Ϻx8^r*\'!\0bt4g~MɧX2NjYԟ3@#c1ǃZ77\nsZtP\r2߽%`!LĎ6bNŔ.@刷q\Z<f0jTC{:dz[?zt*\rw m6@_h\ZwcGǲw:_tHfL:|Il˲5cс$9CWn]b\'iՙ<nxmce83vP6!pѠ1߽m޼Z6\"T73T Qx.fLbJJ	]lQ*\Zj`]]ί.@.uG%\0A%iơArhc}ndNoXR\nX&E5f3iTm9s6cqڿV})z4wmAy脭޶dg*6XT^*3r~-tNYq&\'zk-,G]GMjYVdsՀ^bTޛMkGʼh\rM%y+dpqZM`)*ji4Fts$2;mzhV\rA\r̵Y<R9V$#$ցزcyl,o	% d\"8iCa78Oڣh\09N\"Yو`cmc\ZQ6F>aq6\rShOo-ރ)!}ᫀČi8tL}{UF8t\0E\rFHc@[g\rO`8Yn_̯\Zumb[v)A\'*bJ͹d327\n~6݉Ǐhۧwnu%YM[@ Og\"?4H̓\rkkB	++$iAoc!i,&RT\0m0e\\\'XÝ.(v7N巻HKSvTLR\"fv\Z,ο;^޽WKnlY*i=s#vzFoeT2(Hnc@FK2[V|)KD[sHKH,I\ZK<0pBnT!#M9\ncCv*Β׼=qtޡNۥet/\"D<]z\0Mt8:_\Z#bH#gKy<Q3H>+RzZy(Z=7o6j1HZgGAVq\'ߜGd@(ԑ.١iNă\0_m\0Xߡcgv\\$d]P v*3Of1sEv <M>fgd\rutg9戏ԦcAĬ\'A8VZB_JSB[V]o.;N;2r0\\%M:;dK \Zg9v@8UYt\"|njZc^ll(0ku8৽Bcg?Ub5jl)<MQ;0Ri;\rNdׇtt!})ժAn6ԖU\ZXvQthC՛!>Q1Xػ/wga,rg]JVl.V-	kT*K!\'^H<*!וFKX,OlE}@bq>$SZkhYUřao.ñv//z	\0oPPU&	ұŜ}\'XnCd\n*~9j|,iѰ} D2P\0An	}b,/{4ˤmOY\0fIN-OӍFHS\0rd8yGG_7xdwP[1193A\Z6\r;>FCe{)Zܖ0M]\0rofy0q!\0׌mH\rρ0ZdO.Z(-$O]zЯQ|Ќ\ZgȩPhuӳ=LٱZBr\ZMSU<?Zx#t+]N{)Vl0eP&A~V\0э+7㻉z_Z:4?ȇiB)Ơ>R`MPk	.N;w,D^3ۖꃭMLc\r\094!\n\Z(	Ƅ6Sũ7GO=x@MǬTi\"bS\ZaլroX96=\\DRlqf&PGn[]0j؀6#1(2540W1g(v69|5D<mT\0%\'yzy3|+l7*Qi0\0j⪙4%Ҏ#6YE쇃Ѽe\rR=v5\\oU\nw&_Im|m8X*5ȆCq%~| HJq]^^aq\"C)6u<La۵0KZ5JG*\0~\ZFXA\r6q:# 5zG>4lIEH.f;m3埡ƘFF\nfjY\0Q\n53ni|:N0STXA7fdVB6O	̎n@\Z㺜ORrqw ݛ\0\rQE9TMi\\<HS%x~/7\\b.ƭ9\Z${E֜@*X8,8{)鎻y/w[:[4?TÈ5&;wQ#azfnyeߞ(^_o.[o1B/e\'\"%o3V];$X*\0x4awY8+o0B,v꼚ԙq&1taV+́P$؇N{/oV\n6_F\\j4(^ikLk5)ޞ/s\"d|(-@/!\"䊍\0<\"\"Ըf󂽐!z;8,v3V?[bj8k\Zh@~Hic_C|ƒF%H곛\0H١߿zu>8p-!dGJGZIy_[|[ٯU._|״\"Ԡ[$;3/bH@sJ*gۋ[+WVO${c5R-jOXRm+umBdqN1ntu}z`ԛ߯x~:}\\\\}.\rgG=N	I}tsb+t\r6ěϟzYH+VAwJ1UIɗ9)V@,ZoO\Z=vOڽׯ.M<l@k{KJ!QUNՂ+eedHRA8hy_it_m/,SÏK}{ K|-wrګm*\06fBm\n~>̧ሗgk\"q׉IeH8={3\Zv\n\nds1x15Vާdl2Y)1\'\0(,մmi#Hf\"biEcA5a]E/mݳz}-;ߝd>,l407v\rђ7XT8dC<Ol|\"aHaM.E eV7(p:i\0&7.ѓe*6WznO|iFl\0t9ʆ&RUp3\Z[I<ykR];Yj_y{v~yu|[*Nq`-bi\\)<ZJ\0=BHnckZWu?\Zys(t||rƋ`1E|Ҋ:IDN,ބΡ[	fK7oTwa;L0쥆*ZƹZC	* <Ȏ\n\Z$PҟTH6ŻRUv2 1$\Zz ڪcΪ̡j=t^9ܢ2	 ٦ӆZ`tƲFc$sHYeƿQ\'Fz4K@t,٥I˒CӠD_ͽ]\\faYlmC\0S\'KE>8Xۢt[zrn䉽}1նD~ޢ@gj-Z`1C4CӳS{buXή6[|+\nÍ&Zо\0CT$\rh`8l83Bl|orIw/VƐ6ѥj\\e\"J7٘rtFkoş:?[?}S>̨[+o|dob=HCXv3=.)QTU6S/5\\_ϥ#s1Nؓ/eW$K95r%<\"]$au\nU	X_EeTdN*`]-\"&>tvE>9K\"tS5@	\r_=Ϫ/o9*u_:Pɤ(Jrj	~8	ӎ~c\ZɁ{0Z61EL\r&FIJWpht/;Px3Q\\!#\0hEfH.|Ռll(rQNJ2 ߱-ZI例`8\Zǉ&Gz>z?\\O+\\aN4QwVj\"k̀WNۂ`)TkC#HQ\"X۾r>?Օ3U[ΘP`Ku\r3CͳR(7`OmK.,$K^(˛7lA-E=ئ%xp{}6П=xn^_7ѸBem\r_RY>(}?,}uj[\\	5,TSF䜇tXи:>Z3~%OM&җ?]V!3щMNlhgp]RLu9!duS{D{Qur5Õ*tUTʘlq9!\Zr$7h_}vqћZ@Z{w%;%G\0 90\'\0\rlZȪ\0{J\\YjO/r<N%j/icmt11ir79zau*<ӧx2{zጂg\0eKvS(gIJZd<#>VM]_-6d#}45V9E\\ŒIqtlӛaUnU\0IϮ$eV5bFf8r7TqNJʶSokAbҋT}:겄B5<qB-M˷.$slZGY\"ZѮ\"\\0!F(E-uaG/Kfk}YrJI{Ҍ8}43LiS|Tx\"fZFH)ރ΋\n8Μv6@,P$  ZT0\Z.ޜaZYCX|nOY(A!	)c? gAĤ9md+`gO>c#$`$=Q0g`dSh8g.UZlg}\'f}t7xowx(-٨T9ZҪ4m2HY<}sH\"w\'?y7Ź-s>Cfa[6cԄI3OT:xvx}%!go<8\r2:8ЃڭCqu PԒhY+v1\0io^hBC+@i3rk)-#or`Ld{i^|GZ\Z:mZ%PJE3\\y#JyR\0;ȆL\'cۮ_|<ܮHH&\rjbSQ%4Gޏ@hօ+_.%Cm$\ZNK]J7po\"A77wtOȇ=w#?)k4+^H>;:-]$\rrfG֚<UN;I/wgWVD-R]  \0$1sSg`N<f#zlk֡:~\"{~P<RtH%@ޜYe\nO.u?M˵$QiGsv\Z-=cw.<]m)wo8>\0մ뫛ݎ,H#B%	$ffk2H\0K&gO8VjlSE>EtTۋT3;S)\0;xjbw(\ZWss;HG*`ºxÏC!TE~nMlDPMBM:W Qkݝ|zlep_=BH-0%j@4ZM;_y`j@M_7#cu4t(>h7Ycn$aJIm241vH/e\'{UC|\\*5\Zz+`VhadU@4vl8í?Y7|G\'	TC\Zs\0F^4SGpo缜\n}\\iPڒ\ZEH5F|%%Eul%~?ł9h+{%䒔A.q0:\"$&G>CXJq43TaģR篻.Q΁d\0sAwzЌD拙l\n]Q	Z\r#P?fRk\"W6fi0%esף?:+{fQď\'\Z{u}N;X:Y8gIڙ&gM>n~j+3(M%8xvɦtL=ԮΑbn}?ĎeGrE] fv\\k$+J~)C:/IXao\0ͩV\r\"nyח	E:i=Fy\">frĒ5瑕B霿	b|@bB:v)\\?GAMV88z8}sPN*\'/\n.zTzE#O8PY8k[$nm9pg+wt(G%x\"3w`QXoX`8\r7O<JԴs9x檺T:-]-WEy}cD\"3Zac\\;H嗎o?~D(٦Th@ygX6\r?\'b@\r	rD_O_x/^_O]s0>2K}LSw0Ө4Ki+h([ʉ˧]vif>Sۻ-&H	!Bdm(%{=^k۟q~\\&:Fh%tzJTH:3X|Q\'Dk_vWFc#N \0Q$5Xb!kSq5>\"]Ȟ0Xْ\\m\r/vK_`NTob40;1JxVuS, 7\n`?/획_lk~VEY\'0FƆlAƔ6cIU>.s`.\"\Z2\0G+)Ec)QF QrG;#%XF-й>NR8cozʢ(o|-p\'r}*o	P\0*Fm\">h<،nolKP<x\0>))FlPiZ;EǷA_7&|	}r(ΰdaؚcE<.pqB1HVC9\'Wūt\"9GK[Cf!:~s\"D85V֜#vShſvo_Ϳ^7\rȢ]@ॳ6J yGbD~sܧc[)+<2z9fv:ٴtm8\nP,zSF`N(%{cF$,AŽ	ilXܞYN(/9}d9˻ۿ-HB){z\ZDgǊL<1{C4`\"mnh1ֽ] ٫gv\r:8ɤ1o$v:ir\0vL\Z^&9ju@l5\rY2b;ޅ#ؠ~qh5e	Ї+GŻEd\0%`U$\"fpueq!0Ƴ	[^9Ԏڶ>..5\n7דjQю\'f՗g쐑h5Rt6?HћC?yhSʲ\\1SCJI@T=d NOvSˉMN:[-cd9\"f^o-LFaN?6CPJr2`>h\nD*Jh\0$Q6ޛC(̭Ԗm~i0-n=& ^\Z}bt \\lōA=D\r~ICz\\G#	3r@푳lt,\r׃ 3\n~\0َoy`x݋Up[C2	A+٭|e@܊~Ru|+驗IN3󅽄ehK&!\"U׽d+16OM96B9G\'٫ؽ$=S6n<ռeDSJBㄕj2Q[%)ml(8ijώ>f=a[b $i8S2хر6WsVWhqG20\0G=}yfyJ5=Y`Nl={29?R__^^|߿RUd@$!ܥKl4>W,`\0jm? t:vGg\nf=g@MV]p\nK?Ds\0ͷG%|խF8a@YrRgD>UO|w77/V}]sPMnr`bm-#z\"pK`z+:䳿Wc`|/GMzUWo-6QRZ}E{jlayroo6:Yɮ\n.]sJlTAUӁC-\rI.-;FJ+$l\022Y}aaSVXSP&{wH~ZqXK1CF\0*+i1JobJPi Sck?0)q莸\'o^\\~9d}	/@9$RP\\G±ΘZ+KRk4quP^-Gs5&[54\"Pe?itljf\0\Z\Z]eȹ`:/3oJ[i2D5>4dAGYP-yK%3\n\0p6ʜ{}^/^+dҼ$`7jY!\02E\0n8ԒBtg<>r5WI{wwg8|gC (]2]s?#{7cn@[A3O㺳k/@%[nf\0,Ff,Xaaúc[\n[ ݟԵ@lkfҳF,KyE-6M\Z]fv=+\\o	lǑSР*93dUr>O<̃4\0\rh_~[\\)j[(87FJu=L)慠i҆61q\")O\"5⋕P`kMZk	A;1\r#,tѠ=<I;\rO;n@r-ۜKg[ɣ\'Z#NM\Z[ꉶi\'=FfTP<r]\\y}f3F\r]&(2f~YvN\n}+)5Tؠ\n|;cn{(g.Xp_%yp`Y7\n:\rE3킇4_H@t~m\"ȩClG? ;kRqf8T%o`gh*X^+0nw;ظ1yf	~Y>X@yz*%d`\"#Ϧh\Z[bꫲݩo]$\0lk\r\"&V7!Ȧ~N;4;dh-vpSc_Z4l]6Ad\Z}æ8G C7,>\0TZ>#>.u:ҞZCήɢ\0J`.y>T)TRܵ)<:Y\Zñ6rR~o<nS9ӇT٩8VD[	hҌMP\Z0r<z ݜnEq۸rwvk}\Z#rQi\"X(H6\0_[:~իh*J\r8(,;`anm!R0E\0	z|W̓2\"\n.sH87U;1Yc6w_\rRLXqu]ݷ7xu{uvy滧w?\\VYN0TäU]R SaOVaE`q\ng|<	TS7Ўf3զ2	\0 x\rtos;s}\nV]e@ؐBsaG\Zȁ9W\r8A\"iyW~֢I\rF Tj,UmzR&GJ/ѐH2~qfY@9\0i)\"3؈\01N!nW9@#d8Q{ت\nj#iQ[+>ؔJ]<\0̌N9ĺ2rc\"|go]tHԘq54oCϚ<}%ZAQ5f͵;͟FЕٲ*tsU߻IlE-:,~2FOeӿ}՗X≥wԌج [.-8Ib\0u܍LOֹ%+V6G/gWOa$0?wo΄C]:~QCaUR,\0ZJ7}}tƙs˟f׀cBU\"p%nF\"Pz=6V7g>^ougCP]Riy1MԐsۨ8e3ġD?yz-V>_͘o&ęJ\ne]=\"ӃHEt\' \rrO_^-({خ3c-g\0.vV\0ZC%ϐ>MBIn~apW0[|=߿^rCǏͧY]ux3\'V;&@`C2\'+1X28S*ퟢ3Z\r4YYAMPݡQ}E	8,U.{\\?jח~[Y\r\0lZ(Mж\n\0mG`v5l@5a=`ʢc@6uͼ1Ku,Ĵs;!ժb8}`_.|W8|1\0GxmQFUDԂzӐNbNo8,ZL^7	+fKGI[.j+lJ%4\r#7\0s	yb6w5=0?}\'rf\n	Um.pRC.y,`(nN aΎ6\ZH쟌$=OE:\0ToJp(>>d/gODU<֪vC(!9Q%̖h)`j\rl\\yP\0Op_;\Zda;f. FV;rGd)Cxh[[	թ*FlR1b-nxg&}\0s5R^:E\0K^;8[J~h13A,5EARaElP43#B\rW!n !.\r(TC=,}ϋׇƤn\ZMτeWJ1?*l 4^P\" K{ˠWlJ\"qHMrELʩ3zT\Z\"P\rnshX[AY[|Y:(y%\0W)iѣOL;dVŁ=cZ[sfB5+ ..`c*ehc\0R|P\"|GYȗEԱJO{i$VU|}Ot.$rataQcCfg\\*\"+KH!7եZ`wmKzz$Ou]պ\"RZ6l+44!Ăī)Fk\0@e?JQM݉ bqsvHﴑGo&I~18;֑F~`(ߑZ5ڂP<UZ\"a5&K/+ \\VwP1xj?}~޾Q,`e[Fֹdmj\"rHHTnm)L&xv_\'O^VIw1N9@1v=]A-̘zj1؊wMo.wW+ŢG^tn+\0biWOö94	\'}ؤ뫋_Z.3V	D\\-NRsq7Ϟ=c-݁`[2xhJst*\Zi\n[m^<g[\'a6by2c>L=;oAnj,D\Ze^5JoSHsS@͕Ooyzuz0o#̜q883	8pK\r;gxecuN/񃛳˧\">X$`K2V],!o@Ȭ,}	=\0LhKy|h-r	[<gՌF&8fl!ցWۑAs|e&L91XvǗo\0Þ-ԡw6\nh͙\\+\"?!F%mŲ\0rLk9?*mS6,jTy\rݦYo%\'BL*FɎjڟ;QG\Z?1F`0@|ht#Ֆ}g<\Z\rQ\Zj|jʻcDi[gtSЭ:Wc $\nQKbV&T	|o57vvdu) |M]KL*1I0tHB{Q?6EL3)JiT3Eʰw\nGmbTUSXŴc\Z\"lڅ@>\nR04=\0(-=DӁYݵf_XR\"	m<H,x+ٴY5 p7y~1SbT,hw Ȍ*;}ba	<qskcfdjbNܬŞ_=P^ي]G{ ~!(jaz8X<T\"1h핮7%p;nq6#.@E@ٰ\n8\0VjkqcKѽ?Q#4?n}_}˴&C&Fz3w6j|u\nMKP|[UyMEͦvXfoyiRl5S+Wa@G.z+~Q VbsE`XI]Y@4}\Zf3`\'$NX#gԑ<*p?;vwr\'ɻȐO,V5gH\nΏhX}@e4Z$Cş(9͝.kJ\0J,EM7XYp=8ʰ֪)>i5.q^Ͷ-*%dʫzjwhq\Z#L\rRX!0(2\05\\׀)2e\"\0ڜj:팧kir|0p3 A(w*Sj\'8rͤXRQd?SïL_l1&׮O?^tSjlilFhReuфg;8+2RkStg}Xatʏ$yKL\Zӂ{{ &׽q&^a>E`5ޞ|{c4~:]lK>CM8+f)ki#:VAb6\'oF(l95OX0pYpBzD4g-tQ:rErX*kC0*=\\-Nw4<$<`JȾ@iֻn3`^@k	&pĐX\0Ǻ*\Z~\\>zoANdSoflFK=B&/9ckVݦms$٣rlB-ڌڵPڴ\"G)Iu8;yڜDS	\0+4dZW;N`\"dc̠\rg/~\'O!Uё9Ӂ=tTXy`qՁ{HA&iF<n&E(i-*X&(5LOXvJ(wn%Mԕ660r7QdWCnʙ޺zWx*-\"sXo쾺9Xԏɕ\rĶ,-1ր ەR`[fx\'L?$͉>ڱ}Q\\!J+Fjh<M2Tm-\0t]	զ.%{B//vz#vrM\Z&Ndl<VHSfDv\":Qpؿ^T.Uǜ85}@>(2jr\0\'0 u!|>au~\n]۫=WO^dCW)eJÆƃG,`CYHQ3OYF|^^^swζu=\\\ZΔ«|鼚\"J%\rwsNnE/Q}&Za}		IзbĠ\"@쌴&Hb.ܪY+6\'Gה?lv+FWi!cs%2}4VW%ENrI,,3lSej\ndvICs7!OnvU2UĲ&\0\\STdOybZL5❛O_`ܽv]UEZgK1Q>Nߘ	nFt\r Fcr=>ķ/^_сu\\{j^w{coM3:BVLh#[B@~ZA}y[_Tvwڌ]tV#1fϓ=#f֖ڎ%!,ZD\'EzCNZHq:C6s4kj}\"$USpQ69N˟:P[;أ#kp\r(rFJ~\Znd$ɓNkc`=p9^>nl@plɢ)nH-v7Tfߟ\'SE_\\/^R	RxfYSU@ Z45Dpl6M8Une;` |z};\"/T*\r8u±ci\"Ѓ\rǉfz_$v[9(N-vǃw^FЮIwO͐D6fc\\+rQRR#ETc[l A*\0dcpRkJɿJ&wR\"ëo90\0GCu\":dTVZFMTL<дɰx{xB»`sIL,kW\0Ztt\"cՀ\nn5d_S\'m4dŔԆO/a^#Kko18H%_ҡ]=ٽws\0#i`D[*́^\\;Nkʉ-o? ۪EQ6q=}rU@%nwN\ZNa\0L<V}#\'fE }Ms{-m.&di#`S+?63s-6S@#+UȆ5LMH6:}4r1f*$`N\\F|.6;V\0Av4W	@9!G$l̬ӅuLl(ۻݛ\'6hT1:OːrG(oq|/&#P;\'.Z㳐v9-O?G\0f@Qb=:65S6`4I!%سˋ?vg\"m;F`Ҍ>K\Z8|	WNXG} 񄡼H\n\'f?J@8W9 $l^r\Zk\Z-AEש$K/hd)Ir[5CHG`\0@nIi\0Rc\n?rZ៻.Ţ1~\0\'C*<k\02S*\0{ՏMή.x(SuLGd)q564DL4lƩ\rs/Iyǒ&тe$^bM۬K%#RcP@Xzwҏw&_oTךCk.u\n+*5ncf+>c*\"KvFqWo^n{\'z(\0HR̔h(:;Wl\0CVα^d}4˛m\'o-ϑdttbcd	Q84d,J3#F`hE*ff0ZlSL&-\0.YxJu56)!\Z@\"ylQY>?wTߐx8@qdpTEmLZ`Y$H19D_V\rIڐ@dy/IJ!P޼ĈPoy۫MfJ>X}EY%c_aP:(3zqlLjX1Ùק}wO\\<9?볛\'W.eilO41Hv!̤P}x\'+EDnȃWOb?Gl@f<\Z#V@nS\"IKgaS (cH_3x)ӥ[ms؋$jo$ODV簇9	Jh2ԃZ#џSgNL\0X\Z0\Z1cfu!lڤ#_ja}r/ߍy\n<w@k2x\ZARG@/q#i~Elq_h#\n2rҘl\0aS;jd8AK)4j{c#ctkӻ9&!Gۖ밉cv31-G\rǩ//w.d~爮ȴWxR95\r>{t Hzqܾo:<ٽ~R$˭zw6?67@ϩX/?x|ol\'o.߽jw[0er\'7-\'km6I[#`V&Oɝfi?|EQo31>Z\Zne͞eFYmSJ_ݼ=\0e0FlDS0Ln5\Z\"ȲMSN=w@QƬ؀X lKm@]-]&`(*1֘t_{~4ղg?w\n<cwcv0%Yl\0<3Hkh\\/l<<`#M|Q\'ZB]P<:P\r<;ds>9{3DE(AkK\ZŴeIն\nG;1,FÙsS#~]hHYIgi`	+67\\4od4hǋD\"XCbO`id0<w*\'ZpTUEhv͎\r,m.;8%hl)wT)UrAMxMx[T0\Zejjb*e!J$by6\\gOPQq5o?s3heC)\Zñӿ\"vx.R__#6,Y3,m?`b&Fiw*vWʠXs\ZX-V jOΞy6\ZFVd^,qcHuu\'5\Z\\@tJm\\#gvL4I4pVA]ǳC%v]ݒTl@⌣O28)TrلVZ:F8_dvEH+_P_ǒl;EƑ#(	C$퀛q`u;m-1yk-̱O}>{{c/=wdr#\rk t}g#_ZPFBЊ44Ë1@d셜`iPg+j8%D(uٟ־ܽ9[Uls9փCZ~P̔ޔ:BKɧ[.hvlFX8먝z!5OyőpbLðe汷8Bs}oWy#:frK\0Jh	T8l0r|Y}+`wtdA\r۟\Zz.#T\0o[llئ<=2Eg*bu_#=BmHQ\"9-s\ZfR+2XhSQhֵ8wZ\'qP>,l\Z]Y12Q\0oIN@xb6Jh9C\0>?)ZPʀEb[\rӰM6@]9f-f\Zj,<(2?Lc>+$WtS4;mqb\ZR	XNA-a>˿T|vBP!A{FDfURHpE\ZBGEyOa0Gc675j9~TIa8|4+XjHQ9ή:Ktқbm\Z7+F#7.~ixJc:\rpA\")ay||zjiP8No.^_-3 )([f:rH9a@, $DJb4:Q9<p~>lQHv!T#&.	+YaBFuOmhvKt2(#GV>v_8(XF\0=r-Ѱ}s\0lL\\Kus/VQY`lM\04AjvRe?Nw256\\Q{g\\.GB3\0(ጂfRr- b[؏-r\\-b#@5&8DCLޢ7rRxc~2(ɱHˈy# IʹGXgo\"cz(-@geF^:KDԏMs8ф2Y,%fwfe1ĳ*81CӍR*ˀLH{${K2mtxsh961EFz8OLϐ?Av-\'\n?)C?G>$e^}D{uB)P7OTk\\Uw[&RcG\\8\n՟cT#܃8k$LGKE!{7cVQ|vc~Msn83.\0lgossM6۷(\'0IکR?qEk5?&_|\'^Nl>Y¨؎ɱ\\ڷˌ}u\\gwy}lVe*Of`T`<g}֑<gIOv-#nԲfԊF`-/W\Z/ьbe`C<km\"vtL0cszy3Q&88{}}uvyۋ߽\"nyެj5e6q\neM\n,\"-Z餁Jf\'Z6f|ac&\rlɛH8Щ90[fy#FNf#8\'ѪϮurQ+@l4@#(VGT	dX+īcZd$cږxZҭGB2	~elj\Z˭;_hW7_^^ZpQ뢙[Z)~LէQd4ܛ\rϣo=}VO=\0d&rPZZpkv \Z\0\"2Քg*SJ#s__.%OEs\rQ3JH5;8Nuy\ZI9Wb%XD[p\\E+@XFGT{)F$Ai	atoh\07\01_Z&{vsџ֢}tWL)6\"(#䎚L)yLq,K,cw]BP9ߑpawDmtA4u#[{HLuUC9Q;+/W`߿݂46BCq\0cL+VD8: :\'ΙF C7Q,Hn\\ܮkK\0m-4#cio(hQ^{#ۙO@4%D2f=G;aӬ˞TRDnI+\0#7*%\06+?ףbA\"0ˉBև&ɛ@:[\Z©;Pڑ|ľ,FaiU_=-eԆu̐?i5x~Rm28DUb^>-ŭ*3Њ3ۄbY-R!^&kV>x[pS$/\\Ӏ@j鳦NlR-vjV\ZĎ6ƃc8ZR\'	%:ASN\ZS6,7MCNTS+gV|4s5Fm@4 ^bilQm?̎E~\n\"&63xؕMxԖJqRmҙ@\ZŜ8O{5~̱wo.Dnʪs6\rH U{l?V7Om# e6\"ͤЀCxӭ\\erU59Ȕ,MJ̴#,Rdi/tT(~i%u5+y0Ԇ+3w娾p&2By\nTF%Atn˳\\߬ `m<RT5RV}(i	:<6#fI?Vjr@_ɑe)J5j]R90o+cMu}2т$Dt[?Vˆ(\r$ZҎAVɼtI6Pu`AJZ|{/}uA8\ZZZ\nU\Zm_Y\ncZ9\\,ar \";9tklj	R.9IdlsT wyJ7?]t\\T)Z}z&͙t\Z!pL~n-~\r:`o.(/^\\kɌ`%[6߶\0Mo+uļ\0NH>!g۝S	]+Թd<Tܔd0%4ONr\\W/\"\'c5W_^_脨T0lN#ā͠58m\Zș\'X}$wMxbP-8ZF\0\nDL-1C	^RăꈖM>}	~\r盪ع|{f9\0uӨŀHMs(@h5c%OoﯾCYz沣 _e_l5znSMI\"Eh\"@]t>ŭ@1J-uZIޛ% E3O#Yh8z37?{߯ϖ5c\0FE-Rpj\0SRz#,%\0]>iWA<O3<df,7$h9Қ\r8t?/<X{ó\\?@\\p<bMu-fӂ/A՚gN٬40I\rt}%7ǭm<YVd	LP۵9i,*9	Ӟ[\\n%.H.q8g*,2L)Di`	zʾ$N]?,q֣[~>	4PlBEZn6RпI>E-SجKehsp<[S6YZ\"	`q`{g|}@Ji5$N78>ek!h0Gʴs&:	oMCT?)b&NB=\'r_\\=?-<Qc39=4%Gr\ZskEQ1t_=VSxv͠W,\"n,<v41m;bA\r,H.ш(@z`8jA.S%E夵VDB!ᗇ^ԒZ !d]lw<\n~R\"\0J\0:PG!:|Q@TY6}~MhPh\n\\c{oME:i_y_r_/oΖR#)=@LTɽdfa9NDC9G6r]h1I	\nZSpI\0##gMi \"#eg,MS&8,H\ZEЫ6,ƆlӃjhODųڝVKBmZm6#cR{833M\"S\na(\\-{!\ZTyl@7?xUn\"SnD7.7,74 	t>3;,\rrzT!\nq蠾4, gۛi!ЎTflMV*\rJǟ~oܫ,0	gׄ೩>p2hV[լ\0#Qpϣ4Unpc^\\aŉsL\rt$/Dֹȫwp9j{6CSKh]^.i:Gl%kɵ\06,@>^&5klp8vhOצh~^٪6M@݁aȅAgoᐈi錝R@|q)ø\'7q;Z}\0}sqyq1QK(4KRsQl;-EC@i])_lvb3,yT/}p [=`:jM}LC*&o1ZЏ,AxJk6E\"eIp^Ӗ.HM!\";mbϳ	Hnю?Rnhwjuٌ*2`q5^uND)J\r	^Zj5(;q#9\ngw\0:L <^b@gߒ&(qZBO1+}!HlF-u_n}{svSב\\J$.\"L}^ϞTF+\n\"iGviJM=OV)Y4ެ3DC@23uq$\'&,iDSL3;>T=2-+`g %sdckKΫő*tLB9@5tTqx1*U_xmnJyt3M4}r~*)\\3-u&#ӵ![/]*?\'3a76;͢Agu`:[\"HȵqX).w43{ۧpWZ2\0\"ҿ>bHgBS|\0gÖ\\,o=~WmMjwSyvqE5W]v`]T.2{V/6(+[+G4˛ҟҔ(gfϴ,S*=if-PbrK .w-{ڨ-˻}UTsF97IdB\n8Bf#ULKYVڇbw?Wg笨-LtBHGACwNGxaҌuBíR/=vVELpD8wX^4KBliH3TȕpV<O((\nPvs0G\'6zw\"fܤ\rl&<򊂢El!\"tdJGӅo7w,C.nƢx ,l5[3|;Ȥa!\np6ΖmD%_]n#V\'o_߰{+.ʴf̖Sl*JR\n%,AU\0\rărb	C\'iNxlOyR\"1\0\"\r$#3R\ZTk%;[EhٓK6\"D\'ӳ3K1kbg+Xop:-u	\Z:.Ϯۣ=~E\0bQWe\rU;u^\'v4r\0ߚlTC%H\Zvʱ6.JУk O3\0eD\0@Ƶ\"\"%CH}v\n/M:d8g!	&yy2Ft3m:S6iO\Znևb>R˓#)БGLS35dpKX\\JYMUK0Z&zvzBc~X]ѩY|:Sc(K?iY߽:ӳ:yN}lIIUߔ4[Sei\"DcqGdD1[˻-]_^aNd+Mj^,l5&A3ƟJa,~}{t/Ͷfۋk%.kTKeDݛe(! 6\Z^k@`f6ɲ+jHf8U4np7\0\\P4@MmIZ\"䜩`Hi?`vE&c\"+]\0%L9xWl ׾ NkNOd+ُ(gp<)KMg-<1Ȳқ9BQ՜j#rd×:ٺ޽ZTt48Ga1Yx1Ei\Zݮ;c+㋧cUSƢkLw,#,1\ZbIYoXfQ_6v\06w3.%T<ضt0Arw{sz|.9oӔ#B]`S$̎1#kZU[^҇{[G+ix\Z\'X![D#2Ri3Tr\r4a4F~Pxe|goބi[ݍ)U:EX0\0̆2}scaLݬD@,M *EQ$6I\rz:[3q:?o.v+ݬ|}-5f?m&k	/oPS)?y2[j>~;rc%[8hAE얀.]O=7??dE0h,2mŬ)w5Kg+%n^VY\0oN7Ckf&\'vQ@Xl C!HMA85t%vh0܃p1ʚ!чw` 9M\0X84{v!-xSNdcFJEC\Z`ڝLkg5ؘ\\y cm?SBg585(NY-Pd*ܣq<XŢ=vtx6\rgKg\ruā3iNEl04$OF>w+m&`$]ݖ@bc6\"*NiMe\Z`)N]>s2X۬̝bH)f\08VQ:nm\\>(x4g7w+;HU&:oomˬ^Xx_<o{t#d`ݱ\"TxPzr-?=|o=n<Hk塨*\rs)7<+f\rN<=@b%	шf8&rng{EZS[n\0Luf.2*eX0w2^)%ZH>:laH;s\"\"K\nP&Og)b<osԛNR	^T?_o_zu.셄26%Ю\"Ҭ&k,MhvNRMXz|%VuYJ@smlnT`d`]C`9YͿ|vqŃvHhlLZ}GdmP\rMgyS(J/OX:@vXg+\"U6/Siez\\cZ=Kٻ0J)#wobP $;8p\0J/CG@$ف9529.XΒsǌDLo&:fmNy3=_T5j/=-{SCBaզ>oE[Jx|	?V+7HE*6Ed\rQ%X)FBs \Z[q͞!*//o\014MRd+)kqhFi9ɹd<nSV?8d1ZdaY̴hHR }06b9(w|!o?fEzҚ\0U&}ϒb(Ӕkn\rp;ev!ܷs9s0\"ǖ߯-<%{[,^CW(>5ω-Hl}*8B\"{~t&e\'uuk_{b`$IPD7:|J#D{O?߽yoVUL;updM-,WaVC]4F3-\0\nCHf>Z0rcqv6`NEi_\0/mƞo;\"ξFԿ~_.>vx.S78\neUK\'W4y$>Բo^^Eb6O\0^	0ue	CS-^B`WO4۽K>QFU\Z1xY~67D,\r8Ckp#g77 \"AumB9!`0yys0\rMq:Fo8(%2JaRޟBCAwV-y042`oڨLBK\'y;a@x%SzƛoeJt~\n!9<}ǆi-xqw$!A>V%Jd3Z\0QՕ$;M#<T}yG*[Y?wߜcM98\00iDh=86eN	Di,\0sE)+>=d}x@z(kUnbucmjfCn^|L.Smʥ宑%[0i\0ܬ=~SKkGeML`nXBX#h:m,zf4&Zq`\0yFsiJeR]<Gej:L;jN]kj7ו`ŏF.H<4٠GzսPs8nO~gwsb#Ϝ%(6ph2s.fl\02ˡVd,L~9a[͓U#^=#k#Δf7(cPg3t<IG064uf_̳ʌ&{y \Z~D\0aGiA{#0cqrmkE+e84ջJ D}o=1X$gYuE6AKJT[ܻ&~M)T>\nrF-@iڌZ{H%t1=.Ƿ|}9j|NyFM*k}Yr)J֪u)3RF2c)̆ܣ\"kFGp}o_筪|>o_=h3J{.bS\r\'Zgl[GF1_t\n\'*:{c{`v7Xꅱ$F%\'IhPb`SIPD0:.EORjHo.?\0nMMRP(.\\\'بގ8b@\Zn l{鿾}.iS2tLePi7!tVgbyxh7];0I1_%ZKdp6;Uww#8\ZPǆ%jG#:OqVYt*%iҫgI# P{~ࡋJQ!hd)wW?ycquInw0J-4:o\0 NCYA	Dlr+QrcfIiG̅$*1_Ԧ+5J8\\htdB@}꥛JA+پY;n]\nvl4\nǋ\0\0{(\"Dޏ\r-S-3Www?ۋ*]j,VHܺNQޭl<]<ǯ\"\'~deS*gCe\"UפNc5d\rP*\n1?ٿVOx^#Vd_ZA6I93CoF*5\r=uxz\\-BÉ*\0kiE}6:g3\0Mc]Cϳd6Dĺ&%Ɇ\n.	|93GH_Mk5~4uz[3E\0K8+KLjp</N=R͔,HxQ?b7OAPT@`+}l(D$9C]kl\0C\rEB>I_aܠxNozd- \0`@{CzysCUսمHaބM\0I\0A]śYi09YԄ;)0_XBӴ2Syݓ3W+?i-g\n\ng=\\K\\1yXa)Ma4hgs`qWoa3e8~:(z;|,CZkhD}LrzW;,7xJos|_Yܡ4g X<R;9OxҔP9ZLGDc\Z?\0OdՔ*D<,uT\\s\'J7b\\,r~q\"Jt59FT\Z˜nX^*vph4wjqtú6VP\0,>{ƙB%I5Cu,ێ*>#oPF\\vKEKN\n2@KsaT0SXSWn6ﺥ▥9_yKlVhp!AU]Ԑ\\8\0p5|b/4͇V.yN*w~RpBo>QƩq@z210\n=y_T!t3Z|\'\"C@a(VAĺP\\ad\0agwS/^?(,jRBl写6#Yq RqLaӸ4vG{\n$wMՑrlΕrWzѹЩ;-G\r|;{y_߯Ļ:0A@JYp:py&^f>r/Bw0RKe_/(G8||mؾ[4hFuq(%xq-+&zލ\Z>ѥߛŞ/ƛw+q5\Z!cN\n,oEfͮGnTr h=*Hd+ނoYdbc3Չ7/)a2\nNfXp\\] Dw7G)B>A9uȧR4\'D(;V\\q\rQn뻋˧svï\nez	׼γ9t5j񱆲]K54\0&ڒ&z\np}i\r@32\06ͅ=l3SqT\'N\r:{ٗK\001qg5+wJէޒ;ob.{N%o\"RikUSy1н[}N}ק}x;Q뵆^\0:B5}`?MO<!8, \"+dOVk!ڢ&5Grc-5vY?rՔhhC{t~q^\nHni[-eV\0ڲN!-/i8E|g(?:)>Lݗ9Q3Un*޴v.!dmS8c날gTs*d=	gwʀdJV.My*ĜR@pFy\0(\rkfoAtoKm.4T:U֙iY{%IYʻG15 9Z}G<Л}!zr<(\rA4Ac=ج\0đDM40\0/[<_KHjZl3ͺA;-ܨ)i#P`ukqOA|u@Ks@1؀|k0Qn f\0<C࡙56@hc1n&|5JU䞑J76`ܐ}8\Zu/|v\\>:\rt11S\"p\Z\0<mٔy(7Zr:C,K6;j\Z~828ݣ#zzivOu6\0BO0<zרTy)t>A$Gbm	&ؓ!鎫Wң*\nm(4(8*@;*ݺY\nXyǸ]MF7)D*;[õME܌\"lIL5@:|/)x[i2]!6ȮUY\ZLJ򜐉T+Xj`?v?>W ^xmبJń`%\0M X9\\13u%Ξ@W(>?d7 EU\0YS)詪Q{ƊM@diUmg	4gsSGN鞯7A|1F@iwZlSHeoQlS\0]Muۅ񛵓-8\n(69H4id5g\rZX[L\rSǰXl5d]7O]UQG`1*oų3s,2sR2M=V=7/q&>~ݼZ\'|Jp8\0aMtJVj(\r\Z-Qy}dQ(_&\'\ZJIT)2!P9F}nĺHdq-A]3iC$=]M9 wT-	,(Bk7*~]nqeײ=z<@	Eaܔ4Tf\0j{Ӟ;,	w.g,-mjHq53mRa$Xceszru}ݓ@r6rV MihkFZ(k+2ұv7@wd$\rQv:ߛRu|\rPRk$NsK^T}|^|wP(jJ|xkQ,9\0k\'{ALF|2ZEG()}oG^R)@UbsJJ\"GH5ⒽAgpH7\'}sYyk9\0M$	qLD\ZMe~xΗ{gru\'\r,PBwf1^1cq.V?l=q#d[d#9ی8m5\"??̡<EOڟ//oѻCֶ@\rJ4XFzm&b\"TI!)D~}yZ.aBC*%j5s!#~u \r:K7Uѵfē\n/=2ð	#9e09c.zl)+nn[Spi/.E85S\"U5JU!:Ŵ⊵ge7gӹX#b={p|Od$V)Ts`\"ȓm\Z >a8\nPm\r$KyMz^38\\3TPTSj422[Zt1R_%m\r7g7?<^?;_DCx2`q0|)tI`&	P`ɉBfݤ[\r[_ˈÁs$8k%&\rhN|;9sdjn1H=_wwOvtpyO/n-5֐G`\\O۩(͹t(VK*Pq2>K+yk7ڽ@$^aZ۝\r&4٘Nj/4+s^x!\"C;;<0֠8QP&)U1l+~?<Sf\Z\0>[,fbYr>\'fRCl={g\'?,N<w:25B(,CZ$ALD!{	$^1ڌzWg߳ұ|Es~Z\\e/2\\QI;@5eKp|fh	ϯwvi֜-A0l3B9fKʨXYNIhLz+O<h-\n&$^Y՚\Zڂi>c΅5zFO*ýs-K45\re	\Z:s_虉#0C\0Y3lg|qbd:Ciɷ|ELUMd\0j54w:8,҂:{cK~Sw/7gN|	pTp̖@,rkNCdt\0fL)G.ZT	crTzEw@KGHliZZȬ@ `4\"j\n]}l%[vm<Zt3o0NCSg)mJrɸ_>ub!>Dyj~*h\\(\'Xp궢7a	t)+8]<MVw(N&p/.ޞfZ*,S7{G<WYUh{4!\0#Ͷ\rzLoO<F.ԁ{x{JE \0NW)K#1O3\0VH]7^cE]\"XdK`s\0Rc\"U`P9PTO˶ÌC˾`1y}fzi2k*hkz%9LɦhUH\\??U}jPVfỲu)ԯ!GS-1vRI}7r<t\'IR6NڰW\'%O\n<`}D2UjJ-aj2#fa8E29Y8-(\nㇱ4K\'6/dcnQuz!lLD;\\)iNHTb>A\\8C\'On+bq:.xݪnBqËE<حI5FC0!pD{ҧĴ>:\rKjk\0ֲN7*M&id23_P+~s߶WoP{\n8`jאrcMۄ_fйLZ0\\ky3xdIaɌ8)\r97pyչmJL\'27g{աaq/T+j SCM4\Zl5{+--ImC)Q\n?78b 1ZwᴍD 2B6l@^WB<N|6<|v,Jɘr*uƐ\nu]sݺlTRẟDt__nڳsq{=?}v}KE\rо@\0!6\nO\0r*<>4$>OGW/^K{7-5lfG\0E{G2lr#)Uy^w6t7L?v\rx4s}ywW8`9Qƪ刷cׄLq.\Zdy~A$;;3\r`\0gtϘ~~#*J&Uv@9Gqʴx}TbÉ2z`ʏvG|}_XT+)S@>=o!pdc}LS-4.[|&TݸzIeGQ$rg*	e?mnŬ2:S)1Q78ؽj2HNf4Lص\Ze (<\"u\ZY9|azy}{[[78\"P(lp6rT8N}V@]?48-Wc{0.H\rMuvmV Gζ RqjSC2\Z$\\8	[z\0P_E `^GIP>j΅]B$7H<g2\0 ~aN(}_L!<;cF94HjJnjʞR]F?SN\0w`Cw*}\n>Dĉ(0/\Z҂ v\Z7I\'wH	72Xzĩҏfsyru⒎gsseXÅFBX\0M58~bŷ[@(M󵂷hv䅊JC\rJިR>YWowܿfL6ǋj@:rq03l\rGE|zMBo抟HV\06x:4g\03EhȊ^kQUyX`	\"5KJu1f[99&O	!H\rqʽnfr2_VWٗU94u#\0I8Q\Z`uTZ (s5SW4.#^2r,\0,y`-TWTAMD\nQLL҅R\raA㡇ckud\Z `,8F>Zӯlm[;hٯ\ZUR4ڱ\Z0F9K/dMVU>/jGE(LIGv5yL].\0%u/FYL3~laԡ(~E<RYsbQGΈv2vkȆ*\\\",D}O{|hWM	wjb;\'-FGtd@	(\"h]7!FDp/^󈼰Ƽx{o̚BLqw#le}WbV`UJ +uox\ZvPK\rAlt.[Ԇ#g	}34hN%,^$cU)IIˡKH\0xZ\Z2$dm.`&=\n`U30pÎNQZ%EzYm/cL~v\Zn^纲QyP\nu}t\'L·,CuVR(.݌s6c[}\r:\ZW-t?.JbMV!Q5蚶ji_d\\1QL]|guN^ZؙîRkcЦS\r\Z{V\\<ylaFharxU\\@ 8uL1Ôj-k9LavU$\'1ne?00ϖ؍GSh 1lm\rDwYqfBĞ8[-5Tښ=.:&\'\Z,j<fVmc9R[{tU|wwv~vw߻~L#S%kqMj^8\\ʔ9靆Wb]]iMn4_ī{y:dHoFSgToI}\Z$ȽcbKRJs07->?\0LZ7hf|Cp0`8OAX\Z)\\u1RJ-ԃkz:zw5Gw3TmCipt]c䜃1L7:O?;E`G`g\0@<8\n#g5F\r\0<ŵwy[KcCF\nU+\Z\\u!\reLS;.Ⱦ$UC-L$N=@}p,t0#9:vJllrsjV鈦T83J1RA-Qjv/p+>}laKϫ2G{UXzM7tL]IX:Ry#Tӿ\0nͱPְ+e̤!<b%vփ?N8fڦ4\Zv8\0C=:\\ܚ.Ȥo\n;F13dzs\ZgߙlBGCMgWv3XJ̴sP9D/9ē)ʻ]8G*12.,\nN}Q KVrQJ-OJ:J\'°g[\nz\Z@\'^s5S9u7GdU3FR.V {tT߬A@ބNF	!tQΒj`ӜEN𛰐NX9哃:^Ue.ƕݒ.]22;P1eqՌܓ2uǺyW\ZG}l\")Y[8CB+uaʠ<iM8T \0HW?&??\rVvc#Syd;z35,=E5uRD˧h}P/g?Ysf3M\0ϱ~d_ք\0ԛ8_9\\A_X*ﷵzrxAoϮvOnA^m\0Է=g<6k.tHW$IFSU:]xD蕵6ڍ#*\r9`k5JF sV,fFAqs9XR4;gCG3$9b=&Ll\nEd@훏^;^4w0)s-\ZQ6B|C@MLFEUbeq˫\Z!z/)E]l񭪝q8p`x:N5?fJ|޽Κ%1v>]\0ɂ?\0rA5OYQcd\0i?+x֠8{{-O.ֆR?}ԙn G-ճp\0&SDxژ)q${`JDk}eWBcT}V!Mk\r^c9~dP՘?VO)B	ew8I6|j36Y/~\nKA-<TNh<fw	ӿ{$i\0ޠRQ%VJ\r6T=\'fDޏ;ZOXcwPu:l]w>,]}M[m@j)inYԂxTزͥ:Ӊgw^sLVSTQb(=P?WVCP]fRT0ڳhksY#ґ\\K&:g;c\Z$1]	]5=6ΔKJ΃g196K!g7gDzߣ~>!=-@]\0x{\rфCj/ Fe+rUU-/~%5E.Wzy\ZLfp\'vfӠ$=\Zi3HGeSNZwrËEF\"64\Z;(eL\ZƆvfu&\"ǒ\\xwm+!	(XzTǒ5ʹ̌<߶WǻB*@ђ0v_cV	b{ۀ\nŜ1FFi)38MQ5DGE\Z/#~G?;AAEK8Id\"S!յ3xX+/Ğx20v m)#R2N\00G\Zm沭~h\ZQA(7W͋^m^:VOKYb#Q£5JNOm((fKkU<pkܡ/˫ߎ8xY+Hрmx;8wNxRr˱z3t=ّ={E}s,Ó!Io\n4R|Fl[Bm:8@ߍwb^F򖯏T΂999gLIz={@zlګs.^F9StORs32f:K;x>Is0h/O7ԣJШU}K=P@Gl:qqL`ۧR:R;\'Y˥zצMv&[SS;`v\0;;2{RCY,t*3Hŋ\0ì\ngvfy\nPx,ȔƲNrS|pH+HQ\01!)Bv?./^8iuiԌcCaV}8\Zs\n,lo=|>[&QK4NjRmfNctTE\rBlXcKcjU8oP*91H䡤@tƊtՋ\rۧ0\\a9-lnȖ.j8y~yu?x\rV$+8msF\"E!&uhL/cfP=]WՑ4`%%p1M2s\"$EGp-H!I,f}/-_6/Ogyۇu(\rdĩKE(6!Ґd)Pv?A__],2G\0l}t(՚dfq4JȅڤiLAWB~K67oɎfћ֦6.Vd6 $]4,s3}˘[GJ5:P7eM@%knyA9pP\n(W0ÕN^llZ\\nǁ36BBK_Q<QmvT0~ӴˋO7G%Yvh-QR\rT@YNZsnԻ\"tL}\"!{K%DHVm#ߊ6ۃ\n_>αn[x!R1CgJ\rXl7ڒ\0&RōP~ͣ}G4NyNc\r.͙64>QK-\0EiTgBuno/OH&u	8FV]rCC!sm.jlm.wޟkoxٽ:ǚOQ5\\Cւ\rV2SG\n\Zj|c?R|!_|E3A{+)F^괃\nT$Ȃ54Bj÷ܷkl㆛Qdw^Sjl?> @iB/A2@9=ag<Q-SPgn_!Q50!G^5*mBL E׮ʹpr6c#ĭ뗟}?ҿ߼8;BQCa\"bR658-QΜ\Zgv[f%`jEPEQ{*  Rm(\rBn><OD-\ru^؋+Rё@hGi,6[rƛ! hQm|YAs.mtZx@7.!bNOM;42Ѿ|u߾}}S?ڞ?=ߞy {*͔ID10ahgb5y>d.,}vʤ.MT0q: NX}\"S<>Py:;?nf_m]*)p\rԯDZ\0Fn\ZIpZM`\n-=/\"~lWm_Dy#\0RCы74փnҳ92H-Ji㡦>̏oO7c[\0JkjCpG5Y\'-d:\" G̜91FODO?vkɆpiEƣ`ߌf{&Y6e8&+ `GFrN66CENNNMl2jsM@8so]ɛ/?u8=iAU55fdX:@,b.ǩ%`z*Y6ZB>G7Ӄےn^.7Q\'h\Z#J!W3@Yo@\nenN3ާϩ>>=ozGMKn5x B%l:\nS0\Z@HέpYGjڝ%b[sIZ}ȡzZxH#TRx*ݗf5|ՎQ1mNRcT-:qF<\rMy:!>mW[wͲfEʨ0	cA~f`JZfVƬw	tb5\rtZI߾ؾ<m7^Ph	ٷt7c`~\0K\Z\n3 c%mܜ==<+1I1\ZQ25;qjК4PC*L1:n,mq]X<8DGjM)tvM#:	.3DU~{SR07\';cub}dd\\h\'Ol\0dc/A\n}OG+]^펔kA4(a:Q#6VMx\rsXKSmt}WB(-f_*fa~?\\\\o^Q\'[нqYG*kc1|Hv{E<a6{sr}fq.<#8slG\"f⍉C(nx\0Eiv*~9>bAYsmo>\n6H;WZrqΛM~T꣪v^>89b(*Z\\Rx	/Y[C\Zł:$l\Zjc{ Ɠ~!u<2P!GG|(mDHI2xsJ%(7o쳛k<^bJv}ڬbK\rQ=/^Z.XFL+{]t}uwEvzz~X}qԹw\0l	Cf\"3A]\0рf7DPi=d.:ߧ.Do/cf\'}Xc*5\ZUPlAWl,-p\n {ujYn7YzӪas7d\r*u`vZ]Gze4\0%jKohat>\'5\"GȍӇ(p[ړ5y\r3t_DrPDާiaa@<R}ҽ[s)=)Ј0=(&5cwO3gN9E8ࢻˈx+z_mniJ(UZ9.crjql(&:\Z㻊MmզА3{4;`|`юGE\r1Zvl-8:8lF\ZN)%s\ZGk P8gB\0ԅK\"CvGxR,b xErOaH6宣$oc\0Z街<Ҧ{Іj.?,#m؂<f\'I-\0(mxk\0D\0?L[t|o?;-*u GUhl1Z\\tBηh=^D\nwXڇm~sAA#\rd8pQYK]V/\0C3pMX[Y݃#ηj3@P&[3f98&Zc=fy.?N% h5	d)k7EiP>7&m2.rϡ (L;E?g<omB2y}{}zu3\\m_^y\rʣWnS˄0baO&8> yGzw5Cqn5ŶV\"I։Rgr룔fŘfog^OkR4EVi9%Gqf7q\Z|2Vɤh٠w4߶=|\'i^.ƯZǾs30*D	qQPA\0{A/Ro,[unfܠaq7\Z4\'SJĨ3(mv}/qX0hWB}b0%R@lˊ28_K}ӱ_Ļn4gD`1T|s\rc+vv\r# Be:\0F3H)4-Ҙ`%5__o/^ѫS$!/o7gGx^&0c̀\Z\rD*ۨbDjQBl;^~>{tehd?3sBe30weB\r\\Khy]PLHu_xpM7/7ώRo1xxЂtG}`;={Cz@֓tlN?\0b%ezQNa15,Ґ}IS#EsPEwLw?EoMdv\Zd=uȪ6lJg-kJv_C̿:gY\r;24	@n* q93+\"]5p*X!l&~큢G,]HKkhRdQ(-^LnKv0o?:̘eѧ`3b`X\Z$1(TXW[S+׋gw\"9RΧ}˩͒WT,g-_7~rc2. 95%+13FLՏMY9y~FxL6cHrdFɮeY+v\\Lz\Z^[if<Lv,[:@\0%D#%m\rE3%vʭw	GKAw\">^01`p;C5\\3AF2ZA\Z߇XU4jK>rm&BqlƠsλ-QOٹd85jtޜaO_Spӽ@qQOK[eh\0,]C`DHHP1zwn$}{&ACH\0l4jHx \ZJDS00q>~ob{ߎ*o&]D$FfQK7kcH)6>fU.L{~uyssqْ﬏)\nxh&٣Ms\0c9Lo1]{qXP3@\0,_6svyvrsq$s~c<W9z,8$}ƪkzG	#GrYMN+P}`P}F\0<{v}xI.vD*I@秷\"-%4xR79FXoD`(fsI;HW@j9,\'@.\rH>T;vuy}};K3Ǟpu{)ЭV:Dψ֗0Ƥps%GS-|=B>:҉ueJtY,l0aA	YLܴŷZ6%zܖL	\r\rz\\N1@pFRvLHalc#\\h*YWsC1#\"ښuVwa|{+1E2G\0@QW/d0vW]0cX\n!ZfO!@Z*^?|v昍\'q`|C-UHoB;\ZcIHϦx\"ҷ|9=_zȚT)\n]\"j+s=FyOb=\'`#Yo\rw޹n=vvɃQnn8jH3GV0:]8hrͳrMji&\nJ|Vlbf\Z/\nfhCg3NWG/.^_n(r$Xa3X]ɍHA(QZ+ٓ\"c\ZSSup~0?huS>Rv)x$I)ӦɄՆN\rۢmAT	\"Tm8PRTH&]\nXîZlP?Zq;	qR56ߙT6mqMQ&\Za/33[_{Wryu<.y6ӬGA`\"sdۍ\'DTv8k2p\0Tr[,7x/\nQ\nRa֪Atl5*>n\0\'\0t{ﱙn{y˲+W]LI#;d\nI0.1%*@Ef~˛ّ*GBu\"TXFx\'b\'>m*O\r,f\ZLGK9H-f\"3l&eOeQ飫L遤f}3IA,z,ݳ5Ӳ\0;7#Y\0o$dj%碕D0$@~\\؄\Z\rRŌ^Ql/yuy7\0Ĝs!0\"ZZ*_C6vȋZǷ0=/o\'O8s\0-3j!Or4KθJ>G$YmRDTi3xa/HK\0\rA\0J89#;*?\r1 >r7V\0LMY[4R s$.X}&{;ѓd\\MRd7[g6چH|k35ͤƚ$C[˗۳rzq@@-ߐ8mH1b!f\0qI)4/#pP^?o1fRWF9U\Z7IJ\r0\Z(>o>svS7\"Ǽj\'R=K%hNa9+q\nKNLx7SvӑHv7,?>\\%LԒ5xű+\"[ۘmƗSۘvG&qY8r6#9άx<4k0=y΄+0҂9kT\'gSB#לMum@a)0Fk1qTz0)o}8o/.6O7=\'yq߼cك\ZS}=á̀0|^OMIcŬ_6G*g5 <+pTʘ9Q-6sF.Վy!ɨ*ݱ@0J-H@V3$<OO5 \"w_~DQyH!Z] bd6T0\\B˔	dMJo,5ͽ*?c9H77a,I40vu$QdZI%VǑB%!,xg})H\"d>t\rnJjw1I? jtr\Z9b|=@}2$K6<I`N2<*C\Z\02\0ehUs:4Y~Փ@êvRҠU+~a{]]Ht}_\Zyǯίg=j/o@vj\\#BN3\\Ďci3Qȏ}*=g#ǒspmG4-Hٱ@Hy]SS8P4\"\'qy_/nv\rȝ\Z32liOS\rXJ@;A	O_u{\0:hADSZrV$b&]SPFAAm(k]\n *TQ	6QT, `ȩ@@#\r:e~2ڦٽQS%*PV9Ud.3\rGc\\սlO|o-Îb\\g\rq*L̦i}/x&)RӴ)\Z5H?7/P5%1lBS\rh>@D酪&*Gf뜳Łt\0:+w:HCٷݯU+{Ђa7vx$]ZSz-z\0Zh}GxTLmHњ<l7o^\\	Ȥ}\0` 1fKl-%Sv&D>[q{qZ~h):L8B*\"FD;s&5~ulnU4HJUI$L\ZlśvVEd[ɇa{bg`qVA(vNW\\\"/EZ(og \0aΪ~=4FZ J9LV\"J9\ZxSꢥAP^N/;k耺d8f-E,5LI8iÁ\nȝLf$ꎾF#=	ŵoC-lTvc(G\0\Zka/Dd͇m?c6̂1\n\'\\dabS7-Ylm@حQFh3,Fxx4%9hi!T>Lgݽ9X:#lTȯ8lZI0tH2 L\"k]NcR9\"v쯗zo\0PALxql 6[.xdY dP¨.1|l~z}|7\\{H^n)\reZ,6nTa1b\'.wGK\0ZBmH5vD.1񚫫]{)F6蛛͓x4%,id8T=^BmK@hvfbJӹ=_\\2\ZT=;L.}sϟ!-,9BSěb%xڀ(bm6lvRrCx2>5Zl0iBHpaD`S7S\'_	\0LHf\'1a 빯q]w7HGFEKʥ0\nIN\\%#g!eܭMS,Cǿu4WpG=@\rTJ|vݍ쬧|vɚG5ތPaˋ\'^_+x9(gg8\n6N6{|\'4\nl\'vmo凪,b ؀!!`\0D\"bio\\O:z}\0&SYD@Au%QPBTC8<%]n[\0s7߯.s-0B#yuGk\Zւkbzr\0EyJ@ͫ٘r1dKHhNfo!NĔHF>E#\02<T^ۜ3M*\ZKɕAx&Q(pJFJw\".Y;cy}Hۤ<Y8bG$A(\Zphb*ǒb\Z9tRN/oCZhRǮ`\0mn(c(jɾHM#qmz%W cL{kSxmB5v\'m8ҒɳZ6yimEs9p(}@Э?Sl66\0ue;m\rJ|{\\r/,\0BlEO#j-5)2	\'%L#j4vRx+c1S}>Nb!%Գɭ\Zx\0+@-(CUtIi~-~qzACYBH\0~ّYXsv8 ڍrO-5.3~\'X%:ΒZPV1@.`Bu@kCI*W04q9t\\GN62$_z9*!(6+Zd\"?Fy	!H# 1\r/9nCqFxuY[1b{Ji-^1\Zxݹ\0޽êD14L,%Αs֗ZQ-\0bjMvƸJ)0^S<]~Q|YϏt~\"(ݍA$vלDd	VGIk[!UGE=]%.0=lΌ̉*+}(lb%ly_\\]m~{.74	xA@bZEpL\0KQR!e~/;nr6\0O-\0 lHE.T0\Z)>ySuDsjaX:2!PcʂKҤ>!LN8V\0(o\\j{^TcGSUon*!F`!L7LH%P8<ZGV#(5f#82V)\0iF`-L\\W:*vr:tfe7gXG_no//w,P Ghϙ1je\r!\rrVEdbin_oQ_ε9$ͰXdzo6s#\r\rRÈ|C\"kҫ(\"3N(\ryJk:c|F:IIkv wKd,t0޷Ѵ4	:6bGhPߊ% TѪ=EtG5Q۩R}]7Vłw&plD!fA9b䔯c`!ҵ4sm}ɺb\r5\rbiզRZ*K\nxk_^;r.JzN5nar\0v5<F@M(|\r}#_k:c$ +ǃN~rkt+\r5v^mqNqo/G=ib.&xT#{b-C<NT@\n@?c-}>μ/cJ~9;x6y%1y[6aJ)A%jw[bds_.E\'[mW#SӀi\nq6yqr2̮hiK)T.q/YLꨳk\0gԦSb#YaEE1s>ͽ{)ͫ+,He)kΣT_\\T(g/mʽN{wɑ;ixΙݚ@f6N+8t0B+`Tm2b<΍40t_h{P_=%UmbS\0&tZ@M-J}7/Ύ1~X<]s6B2edfefo(f\Zu:ݷ^?>߾c7y,am\0-CexHzP`?3\0\rbc^Wڍn\\l$ĻY-(p(O\n\n@\'*]{0]ۛ\rva3%orȰ0<](Tr^Lm\nO[|}srv<s^%x,a\nEMaPRMw%ޣORʬI@jW\'?B)ZZ8RL-tȤ5wL[3ls-4\ZX:s2_>%(|s\\Y:s;Pc1QU3.z-k,xc4+:x0sѫ!\Z4+69F Ad6A6;X^JK>KB{z/_qw=XGX<E2>\0njRCi9FfǭfC$˧n9c\n733.P;AGZ`w+q?kVjF449}aU88}6H+Dcz{67).Ia\"Cܽu=A1<g[i7AY;9E}ז;R6\" 킰`8ͷ\"<ձM%bP?7JM/6.ԨH\'I(`zN~t `oܺV\'Kdl6|jcK|sU[ǪM46Pk{_JO?U~ٜ_	)PȄ3׀ip7C\0| Ʌ5>JJa_zP7gg#\'_|<ӑzRƄj;PH3a2JeTDЧ76/`:SꎍrDz˛c)ηr\Z5g@);Z#ٍeo\"̓n;_z}srH|gfa7:eIR|nHKa$f48^bY\0blpim{q#e1~\0\'\0Ӱc˰7+Egv*#\nr`\03^\\`v]Ümh@YξtՆDKiNEej!|6zsqd]\nﲗXmjQzQ3;wGT6~h͔žBAOq-:o\Z\r^mƎS=a{2i4Rr8Bͣ4]{`\\]~u#$z/56ecɃ\Zcdo9v+ֳqT\\GBjtBmXVdؓ;;fӞh<Yw3۷~1H\'Z\Z\"&\ZL4uӚXՀP@<eSocO&<6d xsT)Ul6#jΆ4r*Vq2bvl8Lk\'͐ڬQ~8h~e^Bmh>,5E\\Yia^H f1+#;ؗv2{fr \04G 5Z}QAKozyiE$goDBT2TdzҥIc<*6Znv<a5N9RӍ16\nvEerZ-O煴6EK6AYM?\\.u^|Ձ\01jz\r%b萍_\nLa_G%\"I͏\0䨥DD6L6nv=qNt9vcl5*bahW˜D0D#[Å<q>~\\Q\'$d-݇0jMA *s5QUiaFs?ڒ[,!]_1)CX)mc*^66~%ki^SPIp!v,u6i\"[c\Z-ލgS)uKoQN:\noTB:ufQ߬+\rrLеwָ9^G@&x\Z8$0-O֖8QCN/J\Zٲ/g9JTz5bNF\r; .X<ضt#ֹ\\aPY+JR$g)Z%\"d͔JON5a.%ΐTAjl㑹zP+${s?6oo6DD{mڽ]Lk%\n)Fp\\w6,^1Y#T-<=Pt\rD*G\'Z8ͦvfc@8?^ѥ΢a*DςၷIc5Թgm1^)Κ[	cKnc=p6D޵1DjkEpvB~^sEvXeFئQkXuc`XJwH2W}L	(!\\AH8b\'O_<]̑t%L1Blk$bdc= *H%iEC ;>\\((\Z<aS7dKkBÙe8u[;\n}@ڵI;~VSb[=Ӽ8&;P`\'gȩ:2HrO]c|/8(3[k#9m9L\0fŝXNLwcC6Ŵ.hEu:u,yU\"`ωn\n>>b:|:K7~FTnsl{lK 47l5b\"ՀE\n̅2株F?hfEHE3V.Jؑ\0SgoP##fԗfF;	J;ss4\'xLdKs(گB>#X3(0bstsX&!{W~6)ܞ\\^mA_|Wh&93 IA.$/iZlِ1e_9f.E}G1Ɇ(J!pBz_	\rL{W-v3*}SU\r1K08=ewqCy-mWon<d8WZѦwԬ34\rǉ\n\0J\\$Ij!FuSj$ou:J\n<>M.qEs8m66]uyz&c\nhʬFo>o̰!%chk[Fu)5.؃f1g(j{5Z>]j۳U]@xF,wa_7Տno_૳1|d{ͳ@q%1s4\"U\Z\nٱO njCYPQ6d,?gOkǴq\naYWޅHW~1\n5XK\0e%9#ۺ:\\J\\uNS&1ZNB~rA[{v}رےEzx?z\'UӨU\\{2i\Z-x;`\0xdpxc|A{+8շo_=+NS:KD\nHY5\nZ}8e*6rdEv.Z.ً?DX@&RHTQ`}K.|[7/A8*jeLk8.@non#0zI546R--şRHꌂOo`@`~plsqg(+J\n`_H:Re͢D54|}g{\"l}u}~\"JsՇ\'6ő\"_ڬ^[+lk\nvyhA\n٣wo,D/^舃\0fUt2ɲùtuVZjHJQxՓ_>r?/~HQ(0)SE@)\neN}Q*pJ\ZnbIbqyx\';#m̼+FJƱpd1^e5)N{7?ٱP\054(G5e8#`?XϏ&ڨw``CjCATielG̾TbriHt?2oxGjQ-c,q4lFy3U3r3U-2tbQ:\nvJJLI pL&_K6qLXwn1g_@U\0M\'6MU+m*3E6i/du㷗囗4GBc.\nŎxour`i=@u[VڂuJ1(^_a_ίP`v<knG\Z^%x4򤝳P_e\rj{p}`_-\"zZ[??mO__v؅\raHnWnCVshd\nwPX#PlF9pP2,G7\n<?Ձ/[l=|rsyPΛQJIzF =\'Vo_y7@~ק\0^^__ޮxLIG@	]&4y;ojAU(!#v?{~!l_cz}H=W)xƆ\nDPs|PèZ\\1~)͛/2\rHsĩ˳/.AԵHEbмX.t3:-D`h\0k[cwlsћgۛd~zr\\k/sMBN\"896gt2)?.K\"7+&>׏G\'Ԏnv.ZdUfdSkT&8QbK\"OFƶa}w3spC=Y-iF\0\n*H5Y	@f^o5Z[q[)RY.}>g/,N7N]k2;]/]}|<i8a7\0̐l?mE&N%8]M16Ydjꭙ]~O\\G.BJ,WPȚ܇9A)Uؼ(u5oBiadӧ`enk(`%p$I`]ęc8\ZLzdR~||O̶YMdlTavul2hj\Zn>bY+3t3\n+c\ZJuϜƨcJBsrbSII?Կc\n6(GFTsvt?АD`&x*n[Bxƾ##w5PI\r9).* oѳx,F,F-ֻj\0^{د77 <Ϯ6gaJ}K=z0&̮MHNDbE5a؂GT,iBZc	>ﾺ\\\rBenU0g~2L20tAtLZs\rŎQ\"mpdشsQJ1HJÁpjD;jQ#ithQH\'vZic4`7B.9A&HEf06b6hF[ `<ڞOγ\r Fs䩑n+\n_H0^L#c\ZGƉ\0l,M>ҊP	0kZ|\0\'lyئ~fY,usg^i6dn3e:6n1&#H.a`\".Ki/=g)v?~c0$<HHl][۰zXrV{rl\"tlw\nzx#t{d8@̍%XIϺ;3ۋ-bx.{k*`4&Nu^N_\"q<u:,ֈM\\>`³NҰ&Ų8+dCyjAЂ\Zf\Z`eN\nP|_>mpRyc1wsG8\nsw|OTE{ۚF[8C4cNxKnmu`=9YGP. ?޾ٟbQ5!(LR`gtwj\n]hL5Q#+6!l<٬1bT.;0:(\rHR5 7\"ʫY$df˨\r>xίo]O~c\\q#ܪ鵕\\˓,Z.d>	N<e9*oۋ=UDVqsZT>\\ &.8ּ\\2`f?#/rɅ_k(zddX/=us1p-+ gVsMQz\ZU֧ҷIka\'c]Uv\rS`Uئ`KnF̊(Fa}vi=[mIQuM݊&v`WVff.\0kv޼/\n6i0`\'q.F/NΞ<nΰKaQ|z+<xmgEz`:ɛ\n@Fz&[̻rGFgy|s?ZuRK}̌d\"VkARȆG~oߜ^^\\^=6~<.\nfz_Z+Et-4:%ř3eAO+:ƄR\"-&Ou~|?dW#Vo@Dr&\ZAN+bٷ=wceGtyzftߤo>NNt;RĲhdy͈貥\0 1@i5}1پق)Z9huKDlӞŻ$ߟRb>ZWY@j	SfƏÛB@KKU?.	AO6ΉJOkf{{:ܪ%\"n[&\0LF\Z@eSm]kU3\00Mqt$Ќ[Bt\nVzTEj[TnMo\'Kݓ\'!\'竝a+h\ZKnJ8ꈡ3(C9v$-vkDxzyfsu=p8?:%Sp4Z;㷄J]eO^ܛoI54$v闤Ȓ[d?==ceoLk5%!U5B2gXj^l`u+a~`{O8k(ѧ[@\"ź8BXdj+Ot\0VS_Jzb(X(7ӁŞvζKqsa٫+o-5ċZcCf{ڮܦ-5`IlfepZARkZzE(\nT8mc5y@`6I^V}jlOq:CR_0Tl3}fUEӆ-R\'yF6j F\rUCJ>;{=z+\06;9*\"$T;Q}[aUe\Z/O\rLnGzy}}j+\'___WzǢ֙\\a\"\n8qBDmvv]I^>%V޵~j-<sjQ6p(-AKZTZGQXӤu[#ݭ)秛`SX&:RqDfÚ\Zd&`b	ńYpν#`8kecɪв%K\";=́ι[Z_ڝׯ+5ُ\Zo	5rqpJZm$ A+^A	\Zt&ūoqّk}Ȳ֘}@xҭ	*\r@3+hd1gK`F5o5R%6V\r\rV*؝Nq,\0ܡY9QR_\ZC\Z6lRڟ*Qg\ZEWL;(M>7׏_0_WCYJ,C=k!!\n~,a(8	-ҙ-t^UB_~Z͖\"\'&ƻRh)du.6D@?|apO֪ Gu\rXRlG#h}U:McA?y _U]c?~ry|4s\n8@rwWlnʸ9]l_\'\0a|wB\"\'20	Ɠ[l9JQDx;)vh!,vvotYg+9{E\ZoY1ꐋB31`Es1qxߦdM7@({8q<NȓקRPJ+.		HS8	\'y:@+_~D0י/B?\05ZZ]L$#2u\np҄웿?\"zw ~1k9ǻOv.o^nJaP1ѷ(<UpF\ZiC[#:10tlB4AHiH`<i4vK~t_q_mU5vV@.P4xpKHv6&r}rMfMCv}|\\kan8/[Ei` b\"b88XqTgctRft}toVLxfs/@iV/.z&-	W2\\jM\nR;jy\ZT,\"˾s@ϬZzAJ\0{@:RZэU[n홍<Z=ڴ$m[<URklt?MNCWQq[n/R_Xzsoq4\\kg,݀{D.v\0DnRJĴKT(XyN*g\0\\SEq\\ɛͫWzuP,v?yIi˰]9p?\"N(;(ʾGd\ZՉ3\0mYxMS)7;ըN:@TXDa7\'0@G t>3f`ާ	x?a]y~y,2,XUIKsWRvM\0<?p^XKSx*l&PgM=ONrx`;]G~vj6uO	e8Fy3ZUebu)aH~˧W73\"6\Zֽ]g9D\'<*6\0LxXZWt8\'6G8ˎDylH#Hϊɒ7 haӏѾ!tCK<|7.,v`A-`c>f4KBؖS|`Q\"!UedZeWj:$\r*z\0XhW5Us|=i,ؾ 1{{|qhUPw=w>y|ynV`zG\0pp	aAhJk6V1vi=\0:]P*S) Ԍg?Se?#`2%FBS\r0rCo7~sVbR1,#,#^72&p][SķRSkӐc}Ֆ߷V\rrpɳ%]Lf@#ֱk}cMH(]*i|\\2N#׬J`5eP>\ZˍYM)^~}E4 KsPLQ^[o\rۤ0\nBEs;pC8)>Ҁ\"AˬLT3\\tB\Z0b{1{^íp<\rIbv\0剜!}Xc@hkä;czoc$6<:BD:W64rK!o68,{;NK\"?kaQ	7h\ZE[\n4y5\rxbn16R#hWIv%d(c$_7+ Mn?s݆騃lcH2>\\h@2kky~/iw\"TN\r\ZQKq٤\00XOa{*]{R7-Z7<\\il+ޞoO^}ΙI7:L7\noypBi		{{D	P͓6}UAz<J#&[L2de\"ُr3ӘB3?HBU\"xVU[Bv\\zC{36}^\0>حZCS\ZW\"4gPd<6\rX|A4^6 \Z5@,1 Gk\"3ձؑZW4Qh?\ns\'\0Hk\Z߹1 `U\0}JKcZB_)쓐nSX隲>&$8F_׫u=h#%zܕJ0)[`8~1Q{(\\vѹ<n6UW\'`Wˬٺ}4mCkkO|9c\r[ji[,D &Ҥ@o4sI `8=L$mN\Zw}7E7||]m\0C9ǌ!*3R$uSXah*e?/|\n SN[W|8r\r9_;4m(_vq}Z>7O\"Sw?clA}\'jCl=A>\rjWJ;hax\\@b-y44:]:u~&|ϖTP|ol+ǯK	LWD\Z5\"\0J|A`b $R=rZ^Y/TR,p¥uQSc\Zx6K-kxUk{EF[X6kXgx\r?*=n؛<19GMXm9I릙/_?>:q]ӝi&[s[%Hރ7$5Nw\"+S	ZpbZ~?9nžk]cd$&]W;g灣ěsЈ81}H\\#{JԘܕ@_BW2ݰX\Zۘ#*cAgah&+쳓A%_Qwa\0Q/!FDZg;+H7RV4_To\nnTvU4\0u̡spқ;\rbtsr4,j.,:F=Gb\0SbESup)Qv$AcBۜ>_0蔌ih 	U<7ec&8J\0qEx\'9ۇ5!E`96W;\0ic7`ٔdvhp&GiST/T._>f=(PnRM8I`ШJ4p9zA9ɇ}H\\hK̈́Zq;:.Mrj5R-8Fh;{LvrbD;J]0ts^T	Y1̈́_pN\nvr=o8<y,ZK=Xjdj${|̚<*ڇ}ѣ7\'Wd(3ˣZ0-6`}FHf̜+oDu<\']a7^\\>e7q}JǴapΣt;K]juW׳7qpnJ6/=dY1\Z\"Mtf2ڌm\Z3hi(zkL0fw4er\0\"oY\nHp <8U(Cnt;_x{1Rf9$z{]a3Xq-V\Z Gt_Ԁ&]AcvPV\0}~:m3ԫ:Z=yUTPJINil(7Nƌkr!l!\'7/O^l.D1-t[gȑ4I+\r텮g[5U3C\ZU*9$_} \'-k xq2r=*vT}Xz\\]gyΕD:<Kerhj>ۙ}b?Z],->rAj\"07\"QD\\rb)O8r~b@ْ/[#uŌƻ3]\"`Y=۳.:*H8lVjhe\"ƲsD9l./	(7hdg=m,q&[1QG&ɳa6QHa`N&KΆRLW\'*is鶡MCxj*PNTBޔkhbt]\'ooN6@-:\nub(Vcʍ|7]Qp?aW>$dX[τ	B]5%\nvWmI\Z[Ÿ.rx <2rraħk`:=U>4,D\\V|9[` S Wｆɓ/.4XfӢ!ec6̹Ap:s\'WiPj2cyoZG)\\bT)PNOO 8%VQx\\zg?tH룷Z;~^/ܹNZ7ҁs1`SNDTw5R	\'8. hlĬQ{g-ZPku_g$c}U6rmi45@,$OY߱+gks_=63$QpN3)*Z\ZhY\n.}#$Jx\Z{wn6gl^0IO4It )`ޱw/b`zϰ,xv}Gyhh\0lC\nHV\"IG>1^|\0o\ZW=bk{;(xKloZ	U)OgK=c6R#C7cwqQts}Vee4[7n\Zz] &=Qή~|b@mӏla;:ZLFɁ-h7s\ZAKG)cm}/s`埕GՐSʑ3t%E;\0d$ó\\oA<ϺHNhm F\rLQdNcӊ抓KkڼyWg2Vb%hbZ>RtNRL\"h^&mS>>H[/~ʄV=vm	B5G\0[Ł,?7|W-4mp4?}\'fL|<=UPdRxtt(#} :@&_Lu)=bk&7x\n;dE\0nC	\'X;RÑ\\8hm,aQ|v@@=u[.5JFԝ%:Z`6^uQ|r_l^r}h7RZxG^O%:,%Ayp<g==)~˛˓:ye_?}\ZPG].\r(2z,bC{)jX=XFʢ!%yKK)\0@\'g\r<(@8bO?JrRp8c_Pa^\0VsPavgPvP2-i\"UVvy#\n/7/.t~ǵ:7MЬ $iNhЗtv`bs\rb[go6@܁hwIpmQ	FFw34\"łpjCqpi-0!UݩUM) u\n=r9U(8cyțԗ,k8^-EH@TiOI;譟˛=^H05\0jw@/^$&Ј5@jްjk\09Dm0$%w+P~^*pTɡCQ$;B2L]q1s`,dW\rxVb_Ӥu;fdw5Py=$D#gydq`Ã5}v?c{6\nY0:i9n°I>>AHpc_Jh0O]E?z}Zu=W[-aLKl\0#9}/`̉ba>b^\nhF3-\'.$M\0!*n:eZ@br3xӋsd&ߦS\Z2خ9NZӨJ-SFyQfI!+Vj/uO׻h6+NXR~5XFP,BYDjޯN9ϾZ>!a\nKuۺN`IKO8ؽgg1tanaabKvu}`+lJ*xby9\0Q@`\0\0.ݥ;4v^]`e/f1\rW~=q\rW;Df={i1dPz\0Yt3\r,!g1\nİ[R_~ګmY99)9fjȻ(+IRJ9CX<iyūO7+:lijydҜo-r{]bcGN>}ZAY8?s!G\0i2eB)6%[2l?=QKq$\np9#>9`\\yf5şqj:a{suC=Ɏm\"&km˕m/\r6.tSfNilbeo$\\ThhfBN6)52Ȃ$9T1zH2;lN&zyR6Jɝ#gt8m\rC\r/s<tn%j:04=.+/,\Z9Wc^\r)ϑIy/^sm\n\"*7Mn)$\r,Bk4&}rQa[7}k\\/Qлat`wgmpDAUDeN`a&Yjᵮk ݉Au\0.j1؁P\\h>nȜ\nX̽tg)%{\\˛W\Zr5\0ZAjƃI|HG1dz ^ԓ͛#xI:c{(	)bh+CE\\b<°jvIyQvGpmұ!Ur|)/Z(Y\r[kCb>e&D,rC5$\'bTe\nl!F{/)?Av\rtiUR%V!K[p5u;2mt4\0[Uh ݸ;w/#Vw^ىY؞%̋ܒpXxe0W4>v؁.]ѧn-i! /`5GZq\"i<w}]LbY`{[_[bzo\n4Lc\0W<sI7a_@#Y9.yl..Nn*;\\cIJU,2őqowl\n`wIԟǭǯ./~{zڸe]GTㅳwH2@ĩ6%z7~\r7o8$8ZdI[\0R??YF\'|jӛ?,,WmJNj nOM<BiK1;*Y2@{@HrHsg~Yz/~{xڞOk!7e*f<iRxzqC^N嗁_ToA24@\"N@G(WW:57\nKNY=ҽ;NQ=<jAmV`KZgzX7\"zŦCz\n\"T iv̡K|LWssQ{|~ޮUNĤc /ɋA\"-sI3ǋSCK\'aGLlQ\"BOSABE,P|z1J:VǑw\09Z5Hl邪t\ZGǛ(:M >_,k	X?B!HFbfCX-^hQCo8	##0(7ƾ9)<l1\'fN#vm^`S=g\Z5&%:uhswG\'f`7:Z`2|vr\'jŶ?Z\'7Wm\0b|49$UtAT-TlaUC395y9{+BQ=:JZ})Bt+ViLE\'IO,VyC<Xl@pKQJιN@[.Ŋ1l	-.?	Zqn>\Z|꜋ۿPd\r|&av\"()ƁSoX@^x&SRlV\n6@M=gˠk]\0#ٺhKCc\'n&*.c#LHGdP{{wtH@Xg)e7h34T?4cMR7lV5ր!i*Q:}vΎ+R9uTel5r?NCp#@M=OrYR?ٓ\n\\bB+1&tq\Z	Xj=%n:T{v2QRi4Pi\Z-\\\0BE}ouN^l^^OT98g!(HᣱGԾE$^{ޱ>*??JPko^=L4R	Z074f-\0~=aGijŨ*5(qrekв&@d )l_953<.ֺ}j&GC\\	0^C4B#跌spXhq2aRE\"?B΢*g׼?;e{ueєo4XFA[\\_ޜI@:>5qw<;o54Sp>DjlnSAsĶP\'-5#,y	njnөpRTډ`ws䑯2g\n:\nC{wV7m\r}Md폗)1`]Uc\nH+=($,]aH3%Fgk0^Q6fD\rbv7c`NXV*[dH佶U@\0YXTt!2P3Mi5نhdF(糇	W-͒zG*G͞ne(y\\\n\\q0+b, XA5<Y$=LG݉^~ʭ=2	M]9曯#eEZvYF]TRG\0@ޗv]&{GnyV(S3P\nn\\Ah\n3E@9F̡TRk\"z9tJl]SiGiF7TmlThlWD\'94w.~C|1/nVkB|\0z<Xc]Ʋ&mthmDYx؇\"ؓZG4Sdޛ,^x6`dW䞥]?l5Vi2A-yO&CًE,\00]{q?\Zvڼ\"}eKa@;lSs=\\|Nx-+8\Z9WF⁓ϯ bOf0\Z\'%wUgPxזL^+Uf8&w}[*f&xYϭ\\51zuT3s	f	\"bVRmv0z~~=yz~qŢfVC9-D\nu2V1Ի뉿Yd8$ڢ\ZKp\ZxNgbŁr\nd48s7X*uk2<36\0؃.\r=vty!#c쑚.ڰI^`E)\"|3n:#?6X``%aViŲlk0A,C k@l5}\n-,\')g1r(|ˇ_㴯֬X@4tv([S,PNƲ>IhԱ@,;r	4.5m*>K!lӬXGzzA}Ń@#k6	57LmJЊ`*YcM(ɴ!HH\"Ӈ7]moN6α?W{[K\\0@	1E[\\\0QĦ .hl{ g,;7_յb9sLX$Z6G)S°U\\dc^^\\.ٞ\\m-{ :T\n7DhgnZ]wɱl0vW]\ZVOӠ%!XdԬQÜ糀\Zw)g ȁҥ__f+Wq+9YG=	^k%\r?&-9؃$B\r\0e0kFN4ӑ\0SQMq, \Zwۿ(͉|#ߘ[Bp={LWtpM؉F$8DÞsw3cyk3:DpNv1M	Ӫ\\Yܑ<xxizX~wUoN//.轱:;ڋfT9q;h^;1G;r5֔\0W\"(󅃜bO瀵sд.Mo1ΪT]s]Tݻ9[KYdΘ:\nRJ֭)q>3w8CggS6_cIo 9**]CfHt.^7v:yozg/d^_]kU+YwYCSYCZ)|i<I\0x[Vk;?8ffo~niJc6@8@%:K7=$la7K%CF5Z+ly$$WI)2S<\"FZvK+jӾw\ne%,)\02lPZ2$7ɬ ja郺N[s`kYGPk9N͔n$z@QYO|i,!*V{T^ \\]g(֍/dFB3uqBJjC>a׈/#:wS5.2d`#`bRк]#\Z{$]=nMx3OJk@Xt%s*ص\r4hkwTb9\'[H]az;7j\Zvg/Sj[;KuqT :?-&ǖ}Z{^_ܖj\ZCDbۂul;fov)N@zdM?\"\n?{~NutSF@,A6;;ڤl$v:k<Lyw>YKHc7KŮL2-v7\r-c/k E긵;$>׆]AkJJ@OЄ%ܒi99\0.yY\Z@+q_?X0oհsA	LyJ0xD<jO\n`ĜQ|f뽲S :#tcD56/T*C\"RVͬ<4Od2TgLNvMၳmrG{X큗sodyC)A[x\rF=Z{0\nupפgl,K?t8T!d$Tw!4eV[J@X2Zv=мs|@@\ZVa8\0̾2#be3l,(㖛?n\\|Ǳ](\Z:b!FC](9k,ytW4e41a奡eݧ.\'>ڞ_\'<XF6$lrSٳPMkTV@Momq쫸ZU,6:5GQ\rȄِځZ:^ЄDam[3+=WĵfA62J@/ZsAɰFȽ!/F8f0Ei$Aa/]b)Uxt¨K>ˋ߬FGFdjan\0uՔH\r`azKJ7BY<*d~ulLrN<L4`3t786mj&ʬ&Qo_c\'~fGJ,vv|kPAbt5\\hEA~U\\>ejRfCBO躑|wIftY:ڞ8to$͑E	W&ok8f|8cUVMSwe[wJ֐Lwؿx+~aCZ8O(}z7lM֥\ZP\\|uy~EI4Q@Kp\0*4fˤQJ	,2	?Я\"n~<2\\W nc9W\"P\nvp^UsOQɲk\0nl^4\0P[hzL6c?w7ܭ%\rȷwZ_]_hL⍤Ǡ4˥7!>nLCE^Pq7fQ݁M	02U$EolKta,gk\r^+2Ez*93T&ćht\0ʌZx`5[YΉO\\=_,~Δm)!T eX^A	 uo}#u`/s]&vde\n\nWNb~Vg[|W|律c\\Mt<(Z(`6^1\"F/f0D^a:5_ⵊӤ -#tS6ʭU\n4Je@`lW*MZ8ݳ4Z-^sW?CdKm[;P#N+У< \r?+XVN\0펙kdq2^0rҊު:6au[\ZX\'4Vrq`X,nى\0P*oF?1S+5OHE|$p\nƉ\r7\\J\Zjf4{M=P}y9yŖ3Qk)$%`S`e5ky)m1\\Ysڷ~~\Zk׆xkyOS\\J2\Z+q\'WOV>UJm{)eT9t?/6Ok(\ZN0AKQ;5IL(\'\0 .Tȱg!\rۜWizoJj\0PՂ-8#X-!;5tGT5Qts%l&l=T&aP{zjʉ7!(R\nPɈǮŸG+x<y2\'t1|P;a6+_6d<glRgWbi#a.v8XM<\0mrj{cdxM`Mn,\'89؅嬗Ԓ%;aC0\'c{֝gOh	^8xPgNڍO}<>0B()-p ɝ-;r,>\"/==m\0j^4m=i⻘q/۫6:6q!\\YP}V&*-LHqowYyo^ǻn˫߾[Yc|YB[$io;$`LI8.p>67~^y}\r\\[G/P2K#6b6	@GѱXcM&JP}NtZO`\r9P!Dз	7冮p#O)él|@xۯ}zz\'7/O^l.zXɘ\nL-\ZԷ\n%{\ZIAl8]>λ&<o	H2DS7~\ZvQtX@}S[wpj׿+\rl{ޮ[}s#㌦\\boTTG/g6<2T2tML*(ٯaZpo7q	˷S۹s3us|ӘNwWo߹^I6\0)IM[(hC,B2J³Kd?t?^\npRuHLމ\\[<Rq1;z\"4B\0r{䄿u[x=9W#f]\0sku|2{;\'vSfw50bSfjϓȟ+Md	\"`H`p\0HsInF(f~~\níp1\Z@{Koj.!Yz)qv8RZk\Z&RQdXww9CԮT\r;7vXк҅\Z):W?El$#t\Zߟe<f{\Z^F!(\00L+e\07x=IMsq\r0i߻׀^G*U\\0|OKNK<-́-λr~WJ@	]y_աr3H\rv`gCq8R\'1<aځ\rJ?z}=yzy.mO眉rhHmQ|}Dɼp}6PnW\Z;}\0pU`pmZ20W	\0kr4RL#]^XQ=[We3F^$N<T-[grs?AGPv)ePtNoVx/7/.V\'T8~pF!Ft`QDE>suXa;=?euB/ؓhTa(-ב\ZtYy:qxx_pst~6$E\n8_(,)6͇a\r;Ш9@;zBLVd$!f$d$`5s\Zz!FvǤw\Z%Dh&1਒i.:jZ<yJ#yz\\r)s}ҶôF%$Q6ކuJUm\n*C=áz*<0%v}St2Ⱥ@%a|ؼ\0zZfȕ\\mDT!3	k4r:\"CӞE^~ܾe>K&4u8y:\0ԇ\0U7ɣ8Jc=Pnv<>]Ňq{He?gc2+\Zuj uhsj\"ѻ9}ZrAfBG=1Ikj#%JC\n^fJ\noޫ?Em?U[lmm!ZUg,/	C)$Vքa.>hiTp:Y3T\nS҉g|vzv Q@csIVFxgIG99srLSNlj>`ކ՚\"ʮBUJ,3g0dp 쐻98>}msU-1Ô&^>6ŶFknΒs!tl&rp#ƽ[ׯO/__#G} Q\ro\rXȆ`)4.9{*74]>cJnj>31k99j:5Z^=vvU%4k5#c{Z?5ؽviJ4-=%m_k6VC 26uI½3=U-tk#XSg6\ZuC3>_\'p*{Aȍ3H\0\Z*xI\r!ZU~#XefG-niR~v\rLo&Y~VpڅiTlaҘٺig`V-^K{a5WzB;\0{P}FZLȠWITc;I*_,v9[Kr}ğTW)~Sge0bK\nԄņ3;nnH381kwN10cKBhca[{3sKa{$Vx!>\rjz]Ц;{>vAvq]Mb+(i$1d\'\Z yѝK5{9-aN&P!Rdgn\0$@\Z [\rYGT7#~;9J\nǓgO6sȑM!bgK\0(6\r(H:\Zb+oIJo{9իk7!OM;x_4t;zM\n-q\\ܠ .!\Zu\0j\r0oC\r\Z^/u+$lZ;1b\Z}AA#f<f?s[Q:q2*.cEIj1a+X@!@8ef7Af6ϖD\0Mp!ac6M\"6A%eaw}+\Z\"BvhY\"#O@@@a@\'ԚI9ڠ35im1Vw/\\\\?~ӓ\ZrlϭaƊPm8I)\"jIYRgvϵI=ovny~9=ݮW=-q8#k2a\Zǎ. `x;b#χS/^\\v-𐳫T! S*8\"\0_lI`M\0xaFs/);k_|ߎ|s|b :x	\'S]gA\0!BH1Au(WN!Hk<p4/M-T\\u,7prRtM5T~1sڻ6l.P|f}7av|ӰiΚ,t:+`\n&PJ8@g參<RHX8P;d8aYMĊOTvMJ2;PܕjvvytqH#GkYm\\	dY,5n3`Hy\0O29 aASr蕤_#1(}8#8L z67سdSG[ɍW@-vڒ56)s3&;<p*GS9\0j֭Qf|зخ6aFs&{}2V9#cX񳻢qwvoK\ZPV49\Z\"@Ej+cC+k,&Jyz)6q9,r._Qr}JL!Eܙ8&68GFU=f@dXsD/\"2yӟkm23T(R^kpdo8ZI\\6ThPg9/}XNZW8SPivphc\'%mj\nH.).r#[\Zqs>*rZԌ/iS+D\rDoX۳[U1m(&Gi[Jjce>Y`L9p@\n>BX\'+Ӑ54!]d#Kq3gRlCPT齝wv96s稄t[lvDIQ_jM Ȫ&/>WkMm3h?OKW?szns-Jئ l&+\Z)ހ\0̑l`papqISԎIa_KVun.ige)!4~ @ǣ\\\n&!0wOep4d3Ix5݂ېr222 WzO{+>Fo]kXArr\0JZ5ӴNptmj0\0F\\ʣk%i]dջ5T\n,v+JTn.K#,)~y匭-vՙì2?i~ɻVU)aDg\rA֔%4kUw(q/46OZfrV;;\0(o;o]\"鹀8!Ck $G8~`jUC(ɀJ$1tHhH!\0SJE5gPm0Ocс	0r4m6EUZ;.is\Z\n,D1Ct^9J <D\rY6#W%a	aIMXmű:\"sU#x0\Z7@燍-%IQ#҅b_>yӆ߼\\*n^|NL^:aFZszZ2n/nN<خ$;v[ZT-PҨ	5zD*zjD[~R#\0 \0t=5&pH]sG\rg/uS>;(OfGhbQLuL\'+EdЄE=&j8jG(%dZ-iaJm{v9߭G%NRˉWQ)L+ĹtGr3x`?a`sw4ܑnbւPX\ZPGV\'Oq,F.e\'Y\r&,%SOJK=$i9ߣDl/\r_-\0EB86OlYu4m#VDmbp-yU]5wuF\0W\\b|;\0s>9IzgnP%іD5INYksK-}Oz܉-TG\0*TEՋp#,\\\0C2zqDo7Gb*Zk9`=\"A֗#]?\\o۲.<;\")kZ@/+N~ؔo(	umTf<jl/3U%\"#)ب@1Eq!hi;P*Fe.]:5%Rܢ-9yZ#L7y.~\"\r@::Ս\\Zfi!\"kfӬ^vԯl\nZýtP`qeY38)Z*\ngcv;_zK\0Ϋgm~˙J:oBEn\\M(c^B҇_c\\:.={uh#z	0hYWX*d-1Ci*+ktlwx	?j;SѢ9tQҽ&%J-nλNXUpຮ厈q{CwϯPQM\r`QsԘhSZpđ.PR\Z`\'z#,oooW@jSW#Wjѥ\0S%i~F%SQ@}fR*.j:ڱNwa^4i=guĊnʳ	dXKjkj#b Kf`!͑V*_Ҽcm5Vc\0(3=B0V0L:Bwk$DauzA3_,/)YED*+jѤtdܬ\ZQ3U?C_\'Ċiܽ٤\rtCZ.:rMl\'7<HQv@];\',E7/^lE-FTh!9E`}`Bl멺lP)jmȭ>jϿ?0ٵB`8О_І@۽VzIP	Fxk߿ضHg4qz JMI ]0Wd:64^D)ytofن&46g]OG:8A||;\0rZ)}jL%Gf%\"+ !.[`)ųÿ]ۊȀf>]ĺǎV˦Qupj#,6H6W45{zqY5*xKYbpP2\nq\'[US{ ,o>|֥RY8aRe$(x8__on#p!&:|Cd;o?4$|\"S{ţ^2]gMY)?֑L{N%\"NO?Q9p9N!Z:w%\Z[(o\"#8V5\0,Gͽ3mewU)~sZWh!2}N@3=ĕ\n!a<G>\"&^	 rZi}pڌyo[8vܑ[\\qT\0TA;˚	ӌcnEHˣLu2SͳD~\"<Wߐ1oO9ZvVWzT^͒)tGu!95CߍX3$̌{w)+262Q/Ҍi#g7	).9̳}?˗Aoo5`\n+aXjBI@^iTUΔIԲʤ\\aL\'2g38m+6X58+/VKf\0Q>wgÔl\\^lE`MEhjǲd=o)ɬ?>[=nҭ69|eK/8@c7P2q*[e>W:HI>>){{}sgi ^IX11u@_@\'ڦ䪹E/X**Nsy\n;CU/Rƞ9\"2X;MH(sgI3QR@*ymTl0 6pFb+,sH;yڀv%wU\0\n$W,*=c\"d\\_\nB۸m=ܢnCj	mH1z\n5\'EC(G7[,ARcs]eLWn.^l{=!6\r޺dx?znqI,B\"TJn\'*T͏ޗ_V|^	b9 :gtW5\r9cK-j\r=ۇ*{>nB)d::[15\\Ls`x]^I JoE5hg}~j+SX\Z$eYQ5yg˔L\0t8\0&fZѻ}_a(/]|s y̸~#LdPUuRsD\r\ZӔ1+Hs6(DX`*vy)p\"2(@mQqsi\\|y{rlptG2flU`uR; Sl,q.dTК8;	Fl_94߿ԘW϶\"ue\0t\Zx֒FbB\"HK#20?^\\r#\'vGv5\0Y[!s\"pĆ7ab=}Qf{H٦:%dЀq#lf|P}=P5l\Z^9oHIP4+>rSmkJ< bYV\r6M*[8~D#:6 \0h1Csȿokۓl7Hk.!=ٛ&Vv{so}94aųo~~u{}nY\'`\rjk43Mq(7`\05oN,vV5\r$8T?@ϧ\0-@qv_MGb+GR	_\'9L|qG&)jCRlQğ]\Z_WoXx*,-1C??;|eaòF?4{On:UjKaXĦ\ršd|47iYa	%zruIuiM*@ݤjO!UʏՓ+/}$̶ۨ#W ;D@\r{Ŵ3uh88S?.رN _(klTLnD5\Zu Oć\nxr~U4,fJ~R͈n\Z!W4%˪Ft)\nX\\Qh<V>=-)\nuQPj#dchdBq*fщck>ͣn=~l 6@ygum Hކ΄6D@pu|Z}q/nf\"m1CNcK?dC	;⋵:BY\0B\")^{^T|{v1lA.GXD <]\\Cyi*E$\\|*eߋfMT}CmharqqHk\"ڭѯ1\nO^]fvE9M,[\r\\y|=ZY8>T/(q$V&J+,ZcyQHl6^:y9i}p\">4P/B[gD:QcD.9~:OfG(vvҳd{l1=b:kͰ~t`Y6YBhΈ]7NW=Ozp4\"UtO-^؝E皮d]Xz%IfW`\rxrK2_*<iwql\r\0B`SƼjl\"J#	c[̓YyXy\r.o^\\߼x.csuwgX\04WH\0\'׺I^_;ҟ-z9?#FrdP1MT=Azqox׼:p3)<>={W7+%vښ9S\n\0Ċ\\dR+aFsVzqR䭮kGmC$yyTe#15J\0hdZrw>ų-qI+U:P3\"RO^WX-Wo-Wfw7iL4G)l8\'8Rr5W/WX`\Zy\"8\n@yp/WϾs7Ȕl t?(-XqRCSqui#5m7ۉY|Y;mb`7\"$e8ܴ8esXeVT?N<ւNC^\"58M_猹QOpVӠ7?|rwճo/o\\<~\r<y\0%)}cP;0?	Dҍ2pIC3\\2lS,6K5SFWja\Z˔U %vpeU=4Nl!;mmV]4A<#:#80\\Q8<_#6+kd)\";[ȓ̆t*B\'c+{B.طX/U5jɸކ\\:D3@L\"KZ4Aw9_oOm\Z}siQw1/dmq[U_|GW{ַkM=ULcbx[8%{27I\'jAig](E0%4 wwp5U33tT԰\'_q>\\QZ$g.%`sZf!$\0\'|=ztƺڐ>1\\(J\n\"٪m݄6`2Jk\\`|\"XExsoo}KQJ)aXHD{=Fϸ܁6\npcV`0FU>_{&k]\Zhv@\"(#0KZQvrCBz*[o)0<\nM\Z5Fz+28ʌtJq PZ>Q7x/_)V\\E*0hmsX,FSmSg\\eC;z}ӿ|}pdRID\0,ǈqd\nD[\nܥ,7+w	7WU\'`%xț\Z@4/$:}Y6ǱڠW7o˛bG_`=]mY5~BU-m)\0\0 \'z\n\\fV\r󋻋bR\0	vWtAR/drW:zZ{X]V=!~~MhƄc[zA< !\"Mh7ĭ8BnG)J)ŧ٭!=k;-8ɦݾBc9\nǏiOO-6ѕ:>\"0\rl68PPf\"_M_w7j+Xwe pd1yVbEWtc20FNaw[l\'x15%NOҚUo:o$=ħcc)-ϟmFfR\rpQ\'.)Dф(8ǒW\0oƬqR9>\0\"̃[j*S!i)(!qTQ%+Gf`jInvfքn2B+b,*_CBG5mSjXYO,f}~VrOa\"SH\Zrzv>:>V3;9\\DEm~K\'nO^_hٍsZI\\2Φy\0V)\nR#F4\'Y⯮y})nHkX+UC*5\r\0W\riZy)\0P(g0 pĭۍ[7R	iN2򬦭}D&)ų6\n]CwdMij)2B,栫xI+i\\Ů_@Q^LLf>P3&J)8a ZW\0<[k+zqlvӏ=\'6Atn&X]:Rc\\jH٨YtYgBr>n9$KQKPscI2[gӓ7+ʬӥnqc/?{=P\0atN\nlFG64s0?\\?~/1;|;S0m],#1\0щDqTXx@k0HYR+Hl\"WUx5%?rlcj;zl5;F5q4tuYwVb&ˈ܇\n\r%ՕtڔD<k7\r*j*\"+Ra9 XH\0uMB|\0^sUz蜞Gj,8?-%\'JJߨ=T3#>Ka;)WHhC`LeU|<\0zWoEbS*{.GU|ynG.HQ|n5nc})G]-)*զyeTL5*(Q\'Ώ=6M.nI{\\͵\n19\\<pV\'fw*pQNӟ\\_zqm$;\'ME)\n\nB^o98{хE\riti5\Zdw(Xw[>Z{SJdK8)+ܓ]\roHc\n8X$,o4y1\"䀕UK9>k/$hK\n~idF٢6	\'@@({|6,\0AEJN[P;373$2VP䟕1T׆L;,=|n<ꦭE1\"x-0GAp|P~wo.]~LOOO޾z=-&ΉZI\\c+hq15\n.|[݅[󗻋*JM^rYA\'r n4Ȭ>O\nJ:WI:g<~YAiQvS\ZyQ.eK5\Ze2pr=<f(6ߊiBx5!-P\0ÄDOs>J?~Go{IO[,TW=mZpJm[>I`m4{Ǽ$?~@M:as8\\) )E(^Sr\r(CJkkQr*\r>=C\"*t;LQʸ`lrva݅\n?e;޿}ӭboφ?{D1\"~Tk G\'&2DrWGA̻FqXKzu6͛<Qn欿{uw&}TN2F Nn6ZKX?R\"Цa-.S\nk>68>%?;\0KoŎUDA]|M^u2k$\0&=SRa8T_7Uj8Z~G6S]F+y<s=e\0laHy?ӃN?\r[ 	v\ZuX\r\\ȧW3V[\\N8[c.W%oY(c}M_\"&ߒ1t	E\\\0Ɯ.HYƫ^[	:(@\rttZV`yy5H/^{j!UDf7_~fq(\0fKfɃ-a2rRU~	U_h#9aɻݭJQ|/%TY5%a1$@\\SS(\"\Z#}F]?l֔28{k`cytoM|)5p;#\0$,>I PzʃuvS`i8\r˙cY/N)j\\<2ii?ۭ@<<7JAD@_pd\nG^\\ϽdOՕ\nx؞wЅn[}ՆT,%< 8󪓔gGMʋvXVYE$֠kbwXX`]NXUcGDJP_a1p(!֒%C MSF+aom:?yEo؅H\r4LaITg^4^D;g\"ڠڃ5RJ5\nCAlKIẤuƬ?_S!^oфk(n\"v\ZL00qfX61h_<Of3eet9/U40Ja :W}[.p?p\Zv\Z5DF(Q\"BABd!C8Ze\r0Fe(N~h|xX:~˛Dr+\"Au(ht\rsuˣIܫ_NUl6hzMd+T.wɐȱR?(x->AN?jxġۺ»k3.!	P6Wr2K\0diIGՔ8]a3jld\0JCqNi\0mףּ (	NS?iǿ|ys[%y6B2@J.v\nj`Js[k5[թ}xpO~.oHq!m$P6Y|\nhzhBҹ#yse<9?G-n$vEcj	%~Oc}ۿnj:-͌$GR\"&}.Z|9}X>$d\n\\0CRpe,XB1d#Apw<bXC\'T(uEbԐ=1EJ[4?MZق5R;[vt94iQp  ڣ5Z.tB:##nY铽,V\\<cZr.\0y_y2\ZbrvڻħseuNX%a\0i\0\038$b%l1NKnջ}՛Rf_):,M-A)![*}!\'GiR>N9Y(186MT@z2IUШH쪝/bO9?|zJHlO-=	0sErɏrLU8Nov{f/8w\Z8KM^b^nB[qܳjsqjq,4+OvwqųGng>PP\ZGTOR<|bߙ_^\\|q|kOSe~jq2]Q7=bj<:\0	\0ؾw0VW/^c6q`=bOչJ	ǈ[*ޣh}v9ܬ~~￲@*}.fȅrv\0p\nrrQןY7\\m9QV%5d\"y{\'d	ya/x>2Y%+\ZQr(Dv0al]-\\/3\rϿܽyUL1$ _npiZ.]DdkG&HS[cќ*reή#][]a/9]Cq5:#Xg\'}.2p`KD0=AZ+ֻeYDǣZoo3a`KnAlgG eҝOj\0jl-)4_JlrX9;[\0ăF9զ\"ML~->7Ԝ#Ɗ[X	Ҽw\nsQѺ##F]Jb(LN-+\0i5MfSa)!$Nd\rB$K]Ga]~j\'a\\\01\"RlW@bY\rԑ;24dBW?լnlXY\0\"\r@LkT7l)Ԉyo_n7_謗5@Pz^+N0\0Tl_˱N2I?eCaɳg__lU&.BC+Ğ\\sP\ZXٳX|7\r`K¨ƒ9wvx0A磄0)REt\ZA9<IeDqX^?K\n_PAf\\עUJS:0>\nZ3R菲6LӘ_Xk̈́Aqs8%>g-f3ZKQ<т=NtMtQb\";H@	4(\'o=\'{NCx\\|sdknQ6]Ky!8ז\nk,8IX]tSbrR_Ja`9=gzDJog)yn˪~ɍ[YS;խQ\"ȰVpÊ2$=J揓jgv}s\r\nPō f\Zqetc9DgYon\03&C]Ż+d?Ͽ_^Ƚj%5y$Һ uv!	|K<zMb)ގ?+_%CyvXj|Y:awMj.6ͼO]3ǫq-Υ\ZSVTm8DqTjEK,ȎɈ}$ȳ_1((DE4>:JO@1J\Z:cgC$c(]z#DJ\"9vxZħl\rLc.>-¢{N3\nwo~ʹQZY+r|Ńψᭃ0D*JN&]`}9+RA58\rv:YS5hh;^S5壞Yx9 >~nRLZb3_jnT*|0i1h#<>;?;yoU@P_.\r\\ K,İuf0\0GnʟmUe#Dl`/ONJ(ϮD,<i\"busJU-(m\\@ЬbC,-@IKt\"#FಷY&/3t$H9U>i\"G8hXQ\0:PAV\08JώՍ]s-d7t\0!ʇ:pc$d3ڼBF=G䫐7;{.)\0K4~ojEGͳ|aPU\'=tPm\ZJ%85nH\'^emol-\0\Z=d1/-ՌT\\Wd\Z(XRm|<!_]|OV	I2K7v-v\0zu.4hp۳8{\\Gu\\/z^|Q`VvSfD\n^kR|N+;&Ka[7m1k%2لi/#G6rp;gn>Kmv0KUB?&H)6s^m&eagG!w{z{DĮXʥXQ},Ό{VcEp[QUq#X2\0\"ゟO50@D޷jvbѰCdמ\rܚ4Jan\'{P|j\\Woa}\"l>t n^)Dlr;`u&cX+&|0\'W[;)fq:LƩ4l\rGlANz|xˮȚSXqXf&l銳Ҡ\rtFYˈi)fduV$D\\(=J݇\'RYzUQs\\GO <j|PW\nЋyDBKSZ]cT%MϱQ֪#coE,`:)>|G%L\'㵁8Iuډb~o_27H2ؠj*bLPXsk9rUJ\rZR烒N%ӈiV)4q RݢS\0D55DJ<C,t+xϞ9q9&\\$.&H@bיGi\"5֗×yҠavta&7\"p6> \Z\'eD\\h.#4/>>[vuUG<袗&]=>!1	ͩ1:9/&߽o>j-mB[:]C\rVĘ&c]s{~_>K]sQ@(O\\n7+gxejo\0\'R(Q^zSk0zCR!NtDCk8s3,(֠6Ǚ$s:Ď+ۖVk!T〬dT4ԃ5\n:ݭ+^AZZ=6s˸uPJ[㣆Va+4AG\0!ݲ`8z#8cHjR@8w7d6H1`1-G?Z恸\Z&(8MSfbۚ4J+CRiSGSqZHV_&OV\"-rYCVt\r/!BP$ˣz{X8`2+5,\"HXsGDdg\'4oni	jt(vd=ۛK\0Nȼ3P\r\rclR?ǃ,4CtywHƤxvϤм	l\"ąlZirMiXݫ\Z1Z9-[qPr0g)X,T^d MCUftt#~. ͩtߒ<x	yP;ּ2K#%|c[wVZP[dJ88\'>R=o#\nˊHfS! VKz\ZG0\"i>6Z;G\0#/rdilϗC_zSA\nЂqCIi|㗣NP`Pi5\rXqA\rw{)\0Ē\Z1Er4L+*pLR{\ZS4]jޮŰq&\r!)ς%|h6z)]d_N6HEШz|?iQߪ\ZAfjSN9JvgԇC+󠗠|ul+u5`r6zL1?tVQQWkK\\9I1!}<aFiu\ZݬRc\'\"U9H9x, O:\\_;?-vf\"qĺJ\08@B!zOXϓ^֊cB+ϛ5WOpD5(6\\w].U-!}\ZxI%,JOkW(-u_(AD3x0^RUg]8UCϥ5A~F%nn+Zk\nxS\n6b!ԉ`ǺYiy?5T?\ZlՇ\nvj!Uh$Gt%#;W]\nfւMB\nmOB2`Ũ\ra>T;F-(bjJw&b\0x=7?]qA!	7+tp\Z0\"$ر9Β@Jsitg`OhFMg-ޠk=BBt=ЎS\\2re.1x~\\tN,N;\0%=Lp>swҕN `M1\"˖|h0?@ywOyqsyYRi`Pnզ!tΐVCLXUU_F:<vQmCY-W~a33f,tG|j{&]/0x`%ĵ^_=۰i8;\rL\\SJ7z%q7Zz!n\Z$ul(&壴qHj>rt%:JO6OB|즑%:f`	X\r_xه2P_\0%[j㴞-ɜ3\'A䏊?R&#CCͣ~x]}r͛L},>/	ʱr:@8+Ošۋ^zOlHgwe7Qd&ig⁨Ȏn%cQUݻ^$?rpӐg%@z_KiM܇c\\(\rr/L}=ꦖx0˲BR.T)t^L[\0n?\Z1)1/_=yY$r\"_ԱzP+BfܳC?7Vb6Jw>h\\!0Y5U,k!9MZpKqFo<nXNav]O BVLcAA]dO>ryZc1>MO/n=ym\0xశhòΚdY\0\ZXo3%5\Zh2P_iQyaVS䞚]`uY]q),G5|6Pz~(ȟXywW/o~yb;7+JѶ\nR@H%7:D\0tJ#g|.ؘy|͗޼yZǎjQLǪcBHyT@\0)޵c҉mhdzi1].RGeFKpB̫Hz#bيqq\"i:yiP|.b)!MpUNr%4Q!V?Yu9,?Fy|4I&WxpFjg[TɁPc+}P	\ZO<ֿKp5NڍP]-} MgMJ%?|o޳mabfh#hͅ@l\0@*KuT|\\!P͛˻͎>nц|1=UU\0=[eyHo/q?SlZ1dvWl+e͚Rvh5[v\'E+}rꇞۓj/9`.^n{\n^bI׶\ZE\naL]\rVXq>Xuxy*)hխڜND(U˳Z@H\"F?[ujc(Q>ӽ \r/FdcRNG@o7w\0Ћpb5Z\07qq9a6iՉhbPt\rY^`JLQ\ZMrBgL,<¢\0UFDXtV@CZo~*nRɦ32\0(tJ-!UE>ufZ*y$VCUK\'/.^oK1If	-$g}-Kfxdq4_~hys6ybLZ/f=F-9BTgYg xL\".wSmаzFq.\r7l#{vDף `SԖ\'<{v٫\'wp_]GI A\0\'%yZ^kRWzRlF9u\"FiZEA5]=Qs+>,:N:aFR/~\"Hsqv1c\n1tJs\ri\0?){5d$a}Eڳ֬v0|ۭ-̤]I\r͔*l!dTqӏG-:[jiLN>RVa{\nzۭ[\\Tqr\\e\nȅƍGY[|n8Sy# k\'N80.+i#wQ]Q͇t&\"Q7O|ݪyt\"j7Gpl4.q}$by		Dݾ6K96wx\"`U,ixYaD(QtH:Ϲk\r_<X,0}|<6\ZLs(cU	HlD	5%_VK%T	aƊ-uJblIu`p.^q:檟5r7oi rI])\r癊\nRwǅѝ71oT+ớzz!IG)KAelIHRNWءt\"zeϷ(o5(rBgGbHt*Ŀ\Zb>\ni|_oq_tb|vHNKYc\\YS:i#s\Z\"#<(j$BD*XM3M\nH8@6briى>lfWTg29<A:CU_8)/?:|1Dyۍӕ~7|n+Gy.\0UO;x(fQ4Ph^(NU;wOY~ɳwok˙pvBcFHZapg9U\n4KY>w-+p	/m]Y\0)\059פJ~\Z틺>s\Z?]|U<\n\0\'hQ|pJ핖[|\ZuZjAd&@˅5TA*%6||v^W>\n_{[i	0riR@њō87yԹN[C,3_65]u{F`EY+\Z8ʾuN;.V~wjH00(5CXQT,]\"ej\nx_Ɉm=bJG)m*UjY2\\Co.\"b_z\"ŧv1MV iq2tDn{	G6\'s惄!\"mb]*p%kBl(.F>|$XD+m5`6֏n8Lؖ\ZAle\0\0\0}KȈkUB\\-G_v404Cf3{E@$,%i@oy?~ۦJFiMa3iN`Ҧ~Ä>+~AQC?|ڴz&:Ӕĩt6t`3$\r%FtH1GGmans+P3ղf5p=<h3ZA\\J JewmA)~7\\S<v!+TN]\0U1K	>GMe|0\\[E3[a21\Z;8G0pR;\nJ\nQ/8ioE݆XocDAs7쳋\'m7FN|ؽU^+V\rܻ<@ّzeO2.|\Z}?}N57\r,c\'QC\Z@\n]|\r0,qzO!걷[6ج\Z7ʢDq!Mx|fgSҲPQ </n\r6}^G_\\f`qmECJEN~(%s%*^ퟟ1ު14j-v{\0yRю%ÚY{r Y :pZ,;.MqnL>`ӱ2pK8ƈrh\rKp15}kEJ>b~w\r5uQAF\rːA3DDvm@Ο 2Q:M6mA3:pf]a8E*Մ&8h啦V2<Ncۧ	={[]F!FE],URd,М()\'#bH{ |<Ky_}wUO>i]zm@ΞgKaV?\nwӏ\Z+\'zN28Ui͓&v*\rPdK-ypҧ9B$E (rrbq?/qD=w#dдܢbej#p\";̖ߧ^Y~rķغ$]_hRѬdlUN\0/:Ӹ1)\"mV~_{u~Us F蹁_S5B8؀Qܡgoظ__\0P4K+ZM\\UNPa.8לټK(ffw18/<tn:Tx{8?[m\r7bWh#sEqUԻ4{3.PS{Rm)<MA\\w)j`Ǥ]@=|7}f-7fijt_>̴@EI08^VNP:iE_]mݲ9i._݊F0%rU߁Hkg>77}s#6[3N!kva4;VG[UTW|_uiF:/xWg7mܖxPT6tciQMIL?$KZe.__m\"SU\"5}(ĲRN3+2nͅX:\\8j*dei)YED\"^9J/Ct6c-eVO3b=zB8\0 Q(n$Ukc`y&;V}gI1iKh~~q͏׺ܮS`,h$rH)1\01v\'IGfGwt*,C1Yo\\j<g& Zc޼{}uv?\n3Jb8F%\Z\00b.c6`DfQŗ?o棔^~>2ˈTЌ/<rhR+\"}E4|O8ԩĀ9ɛ\\w̸\0K5wG1]?r®~vy>\n<Rz57%$G\0ZKñS,\"\'wWo.]=9r!ܔs4\0͐óq=Q˫2kPB8n}%SC?\'Zȅ66IW}ȁӜWem8.GYMoi:<D?oﲧ9?iQ*DjF`Ƒ_IT3}l$}=yVr*{	k~\"ۀ|+]d%ŚҺ*`~ptKI;UJSmTCX:g::=\"{wY_ҥm+GνT\Z Bɳhʹ|L@Bྞi%M<͇WKGoxV\n>	FjEA|se:E}\Z^])%\n\rTR \\#؜zV*ta8%i=tvS/4rN@nٗĤf	M{_8$+|il\Z\\6YE\r!hldμ\"=BA ЦaѻWWiT#\0r4PRHv)\"E}8h-2\0߹U\n\"0%7`w/2>\n2qz˺[_c\nsc3ᩅK|zq}hHę\"ɴ\\ZBjkG۹C6G~މNS-ǤB@ގgSm!VpgG9d1-Ґ[8=z9)tFsYs/M.|KBzMb,k6q5ӔqK}{wO(>OMSQs\'\0O)#Z,㶼\ZUQM\ZOl>^뷇׫/w~IVz	!sĴ\'$S%b>o}yUTpxu\0>[+35	>5*x3kQ\n`BB FlFƄthD9ms\r>7Q9_h7ɮQ\Zcs1\Zp#E;w﮿prG]*ȾNw{Ƙf6GVpGs	\"5COʽϯ^ء『3:7,$Ɍ ó1Q@:u>1Wo_\\B52\0br\ZjB=OlD42XWM*~U[&_Ճ#|\':\n?ؓ\Z|<BE襮$Іgf~٢/&InwQytqp\\=ܲN}4\\4\Zqh\Z-9NӳDk-\r@f`lזhmw4΍ؘE8{OW_\\YnhydE/ѷÇ=C~8tMa0\0\0Ta4\"6vZzPy>(߳`^\r?0+lSA}m$>32^ZniV[üSBv	y7Yd2ZVL8@K\ZF6uVv| otىXBM=YDcA4;VI/rt#E.mfO@K_lթM5\"yD:\r߂Վj?[6gɱ!r1/Pj\r\ZXb}x{VsSetߒVV+~#rU-,p>˿\\xql-19^vHQAW	RbB\rc#j?-0qa;TZ%aw*\'鸠1X`J9.\"Ehpi{=HlҕjOVsG|m? 0Zy\0VH@@b|,j.n~w~:r4>;@Qx嬻\0o v:pyD;Sb{|)uxB)RQ?#7?x,߬˿O~Nvczө>Coaq\"6#R?p\rqut5󜘻;:}~CSm\\W	raxBs.7z8-x!K(vƚ_ya@v\\[\rGT05͖qē\r\'^X{ܚyg!T6kM8W0/cz-_gŇo__}0kO~\\x73\0k!<ZO3\0\0 -$F|u~yÿ{{`9=׭́Dh7W3Wf;|?n^}GZ[6hhBl%/U> Jgf5#\0x-l\nÒ[_%4R\nr9RrJZ/^N|i/<ƚ\0Z#rt}ܚkv`.ǈcXTQu0JzYȭ܄:cyw$t>epi۰8#Эfk~ՔygjD=K\r>g.SZe:FUWL9^fצsm1/!\Z:yK)]jC1=\'W]y͈ŬA]=ZnM\nh::WXV[\\=gyq4deV>gq [̀U^/*dOMn5zr{w۟6gu6nQ0-`0^>͆Y\nCGJ;c߾ޝ`Sqm4F5^rfy觞ZQ\'CWzoL\'v@\0E9ZIVS%#+nOm	ֻ_{\'Z)u Y[b Vꭃj!sS],@)OK)wRJ,W4cߖ4VfR+0Wx]ow_elF>.+20IR.20LCCrjtfog g{o8bU)\Z\0\'4q/lJZ}Le3Y7ã p+P?-r?q,#8:B4\'JbJӯ(a{;xhNq5J;Brop)P9&G#_G}Ue1CAQ`mS/tw\r\08`AXkbDBy!R=NvQZ@le\\ }ł֌ҀW*gkV8A\0\'G<lޅ92q:2L*uMxjBsּ+mUEܽiGn*$-9|\04sGR+?]󛋗o^\\Dw-λJT<橳{\n\0JeP\nV_AOaoyP6 E`B*׊IUxЃҳThvN\0{w7Oe\"RpJc18\r7\\WhY<JAaԷ{0Wz]uug3Gv=!rD.d9r~ӏ\"_|kdb\0T6:{7)z6\\\ZY&_\n8W9ɹ\0\\n5\0=4vl*	e{T>kL9\0\Z@:vl2v\n%eяn\rVUOeιێ3PҾna+^4P\r0|\ZJ:$y>{ObOpฟM[S\r(sC4[*3qTN(7X(X\0naŸ-.`(3霗϶9VB8P.8x9ĸz\\\0&yj\"~9^z8g\rimeU!4\n 2mi-,TɷqFo&=So>χF^^*RJDsϽ7$49P7@q+3\'g8gX@Nbgw{gid+H$,|@0ǉaX	Jɮι/wo@ٹOW\Z5\0iˠO -\'Psl\Z4`3joV%ә_k\\Ggj)!b!e:9_LٚT?l6|K7hҩ9ri撄Lk.E|s_];~@r\".f.b Yh2_gq2z~u{Mp+9dJ)mny5LWJg<ֽO.!Xu#\"(DΈf\rg\nuk!G>~罓-/\Z扤1;LjJ<zJ2J\nd4s^^@YZB\\Jcyn }l&G _nwVW&曋˫y9m69=Ka{WH4B+B	i};\\V-J]kdAwqv:PQ{\0:HʀmbQ;}0=1~pg,XgEWj|i@#H	9T\Z4\\ιз{Wkaw4<(iꗟU\n`}rj!)dRa{h&*4:-&gBBk\0jj@W}&|d\ZW;]dr5z]\0pˉSQÿ?ywà7{6Lғ<$Ad㼤bX%pJaj|]qqtޞKF_[c,QQ{.ӥk^)PR9Puڤqw3{Wqje\Z35I\rU23ɡ1\0\\7 tr\\g!w{;D{ϩ%a(!:R\0:l$9-s#)Rz.{DH[b\r4RaX11uMTiZ^Ϥ#Ck1&d\'[CEz&Dheo*6j0m_,3ǟiD\n񸾌:Z`ia!DiJH_GM(GDvYqrIԭ8\rqCI8#~. 	GQq߿:AP3-(<p-.\\ZrPW~.VZ+l	Z2H{ƨz󬜭0-A\Z݇rN-GS}Dtl6{3;hGʊͧqpdvn.;RT1,=-|37gcAuRߖ\Z˾5c>Yn7pvx	P-\0%LtnEvm{\nS:3uP>&2p槏C\\FZI29C{jWz)E-eel\0g\0)T:A3e_[$5f$]\\Sǎs}\ZGGV39R!,48Ԟ>yغw|\ZHgAst\"@v`%dZ]PCR\n9\'}cJSb;|`kHEmXbfo=PYwz5/an\\!@lQWM\\IS9P(h\rQjx}V\ne\0)m\r]\\̞3us~/@-m$+V-q 1:;Gcz\0ڎ&S&q^sw6ӁQs#M\'q`=wP1|\'6\n	P.d걎zNc]F$ccϴzGl>Zzl~bބw!	p*)O߿Z!qKg6-xFuw<,N}2vdtz\'b=&F-lvNw/*ΧUj\n}iCPNl-/A=/j~Wk].DS)Xt2Ns>_guyFڽ*3dMg{K*4Gl\0fo\0)I՜=#EIrPtzgoqMZsvAڣ.+\Z}JyT8p)r>ޛED%㉍({vr	\\Y;46Q2+FrvXv/霷۽dǞE@\rܕ\0,C\Z xAidhM9޺Ex-aaj9#֬ed,#=%߱TGKΩz?ݛlY~)1G>YJLtq\0[\0,|Lg=\\I㪕B,va7J\0k)x/WoVl5\reϳs7mQ~H^}u{7]߾˝_vr5]k*PUjqI΄D=9$@KZPNcCjsiR1\\U@T,|E9,8s8Ay舿ÿ<ysq{Ᏻ_#\Z:K$9\\)\0U\'h֜\Z~4j+$-qI>,;G@\\Oi!D;ph\nVzO{?Xk[<\Zbi[]`c$oYRrm|Ձ-;氇q޾{:[+etP-H!UOM8(gD8*^ݻ\nd{\\:K!AŘPRLSQ܏v=w@3N^,}{+!|LPiP#lu0g`3=(& Xvqo/o>`\r0{6س`&,USkHg?[ۛw_Kj`xbi!`nH>p;>&%*\'#dsˍ^|RTY68\r{^s[Mrw?cd#G*״~ւ-kpgF\n8:+/˽/Cp\ZՁc tI꽺5D\ZX5OЭG1_`r$s3Ri\\idIYGUi1˙YzdnZ\n`lѮ.O0+gѰ\\ ~ۻJXWJƑ8>Duhn\0o@:|tܱb\Z{\0ߓE#*=\nUCch~$q FP)Є-ǚ\'GN؟轱g۴qHV/O_V935̀hWnt[\r9E{+~`n`	a	`(3\rpKV3NcK$&)B4YhqEi<s>EN{\n:ˀa\\E0\0dR	Fw{X%\nρpQk;Ɲ#ٴbgI83v:#.\r5)&e)?xOqgPʖa5A4P`mdd$ R\r;Pܾ\\[21v0yt 0J9&C rZsvm\0 ?M0PH	6ۏ\"ռgH\ZəY1*˽Ugη\ZPi)9P~\Zxl$\0\0BY7}hs32qpREI(ÃBB՗ebe \\~y>ޝTJ*o4B+5&SuL^.k-ĖHzEDm55XY^5ŗwd*zkk\r	\\$ׂ s˽ۺLiQqqgf-,*Cpq#uXog\"xXUz藪%H槛t+`Cc=Kzf.Ś \\޽x}7Rg8$t@꘩Owу!|f9Arsݷxe|h۵M4jni*)^{:8iPk \\}]4az$0DErLi9!@h!G 8[#)iJec,my&IR9)wsJ/BU\Z\0MOn\r|qh*M[	Y(Cg>b{L,Oa@\04u6uXYL9j@ũj]rk΃D,mZ,No3?)V6fRyV<{G:`GQw\nEI^VpߓzK\\R)-q_*ȑh*qpFbaSw%ি嘏&W۵\nHt|ClFJPR>q.VaӚ@?yϸ}}Ww{$p\")JaU]\\wZaw|~fMgI9Z/_ܾzz}q|\':=R;K8C㸡>%y/qYwi7%`=6L]͜,]yNAZβZ~ޏ}6ǈnLj\rP6#0E+ZԳ#{wN>¹g@+nf=%iD|A\Z{\Zast\0py! Pu1U/O fXe.)uMfsYwel+4Pj.p nR\ZZ\\=@:NXs*D22f`n. BrqO_Ǫk$l6-sN9aKCИYXyL9~ԍ\nx˗__ڟ+F:Im<X\Z+Hӱ *lޑs_-թaFO!bAc+ KDAɊ`܉t4qC9bA4	&9@*($HDVʀHq]q7tV/wNJt[\'RlŅo5\"aozDCCG}si,lX=V[M/R\\ڌ&7~M<tQyǦAP>V\'5Ve߰zno^:d8`-VJq\0\0gpك-2l_+.#T4{AKw5ilRj};]QK^ ĄMR9g\'{x;$9E]S6ީ73#3!8Ggi)]W\\WSu\r<J)5I&.j8g=o޼oYXrl֑XȿH5{w/̶į29<*:(AOn.޾ܹl#uM!x\njw:[VA6k1iz5vWU^ұuZ% YSG髱x6\0g\"[qB\\}j睮-LjғO,5_Yeݲwp\r| ۣĳw_ݾ/!0>]p5hSBQ\Zi6jB*=ð֞Ç&!,s\0&ղ(s ?FUsnq\\\nyΩI\'++-6\nqkbKj8ے7\Zhl󻫝\\ZJJq&z*|].%H7i;GEHM8s-b1.<\'Y\ZwJ0P}Ab4=KioD\\ű#Dyy0-։%UlGmUَ\\eq֗d^#8aP\'5h\Zy:<sX\"]8M^{/gkF׳/*Xna]4\0mb_O>6ϧ.J\"~T圞{Z\"k7WeCʗVl?;6uK\0+XTzK\0r͕\Z8h֍<ZtCgMi]-GvZ~8>W$)zTmW5w08b=ٻ,j\ZOlH̀.4襛Tځ4\0[FsV9\n v.y{E.8^OB=v[!aFPq)@?yŢ_/LmAKM]^c}PͭPSqv>+\'xAyZ,M	\r0ѣtSDW\Zw\\_\"뻯3(:bJK<C=p<\"rLaޭYNßbdRH԰,W)2lRU\"Mgv[MRy;i9A+H2zOHYst(d$xsl9:\\WwP}+74MF)G;8k+J/4t4=ǭا_\'*aW3vcpZ~Lna]ax| ѰUe{q;\0,R4f >;4H>	Ms	~=5Q[h-V%ͯP$b&=Hh\r6|\'QYoRulIVH@R\r\'c7HUݵ|X\r);g-s+gxraUAT##ӾE~f]MGJRa<p#\Zh1P?($q$7?Y;7sHRC+]Ԟ-T-vKfճbkdbXl~xfTkmNA?\Z3x*]\0p<NAxN$\0]㇓UݓL*S`XC	k\Z@qI`;5NlCyNj~M#LE`ޞlK.+]MyU[|H]Y)og9UMGP	([5*fAPܽ*I͗_ϝlU\0kc#4J4 YRJ4**P\"Ԙ\ZzΆػ;|#-L<2VErlcrx\ZXca$pRj)}^d<V,Ϛja.wV9x/!Lcjo.`+wtl&@,8JI\rSVd*8\'}kxSʑ>E*mD#@^+hç4Dd~plc]#ނN\'=\rmyi`\"&bs/-Jq8^ivQuդK\Z`@(NE@\'-kz+=F%aRGC\rڈ\09Zkk>Q|hs;a\'WS-plY[@4d12<~8t?$u\0֌mžmuH)QZ5U289%|U$qysʁ.3i--ϥ)5V]}\r3ݹ\n B<5v0z+5UwA,>-1cL:>yMvYSc^}4s6a`M~pt+Es!YgjX04h\0KJҫEA\n2OElfbYk^HIudψzSBJ-<^fV\0:R9k~74k%\\k+.݊[QM\0ee38Jl@&n\\\\KKEB)\rpmZ5Bax\\s|hWo_3ɝm=c?ښ۳t/f-Z:czVky!̧{?L\"N})W\0XW:%!~ҕra>\n?qޒ	ڃ^E+d[rXK3jӺj^\0$`b%촸=\'j]8\0d+ѯİ<m|i%sLû0To.5t{LHkgV<i<C_Nv^\Zh ]JsFDg4]ƞpVMTW@\"f1d|:ntNQ웽wX6\rNzǼ$qB&gAei9w{?Sh2Gȑj\"!#\0Ңx\r7;gI0řc#vR:\\ц<wZbw|0J?յs*bogfRd\"F;Wi*&g|WU\"euhXkNUHg3})T5ŰVI21m\"2hFS.qHbMAK)ف1їZe[K89#R[mRRs2iW1(O(MHC$IwTúG)w}!y~u{ճۏ_-5ݯi8+#rĜZ2V@-pwcV\rkn!ԟ3w?/{H8ݞv黷4q޽`- Vb?:m-\"5\\H7z|0DT^uTc`X}ϰ}þMyX[s,;1cťp}\"29GȽGz_}gAȜJ	U(1ނ÷{ak|0k=NiU]\r6!7z%̀Q-f;ag?Zp}6ʍx,3]%z3X(ɃB#X܀G5ªLdqX]{q țG>\0f{+2zE$&@haW	kVl/R\Z=\'kl#P.9 lNx)!cy&\"{䙠$dZNZV2)>]melS}?Fܾ7XݏHZ~$,-ŭFd]]+V4>\'9Vğ2km{E*5f5Tpݑ!;\rӬGYs<ݨX3`U*e ]iqjMW-/o#>ޭc\'~iZ_~ȢfD(\n7be\r,85\n;ZvXoCww>Ƈ	@`eFf|&z\0:@MuH%+[coa@#MU5Xim\0g\\o.8H2Z+3]0:6i0uM=j\nP\r=K³ uc3P}d-@p5u\"9AroFDN$ESR(19H1:JQtM#T-*2ٿ쬥\0AN8l\\zEN)Rی{kƇ\\?Ovqq\'G{5rz0fڬ	(ڡ{\Z;>ӲYھ yMsj9Lxx]iP%.~6<9vɮ\\[r=t5ю˩iǿT<\"\nDKXI\'p6YSOC®jE57@.xjr08@# 簑(<g\ZlF֪\Z4ڢ8^;;;K3fRpBQ4V9gYy1#&n0Hm.TX.\'v[-DHD韊k8ȘGZWu@,R=5srf9dJC[wʨ\'NmB0X2GW\Z8} \\oo!]	(m\0\r@` W ׸QB}#Wq~rbe7R)5\\·2BGBPAg	-Wo$vӽ߁Bkw:IʊfP&8=Mp\rM3zPip/IV\n9ʈOGO^(\r}	HPν[\"40m|s⿄,쫆w 3\\Vg.9;_?̝M3\'hWs-ѽj-iR|Sɧ{A1R\nPG^芯VSK\n)gt>ۛ{T)RFXtg:u\Zj8|ۉHgLY{wHցTQ)䮔sM%X+G;gpg:4(+U|.-j@\'5xE+Zl,@:(P|Z^NX$T5<5)MOCsAp7cJXzά%UTJ\n^?jJY@]\n2BwMZZ1:\\d\nIF-,d]_3sQmiq׃Ub3TF<Nƻ¬`l`:؝dg\\/WAaXSsyUu䠠F$ilՆ@7msm ;r)[C\'9k{V_\"ޥC7RNnS\\팕[:KyhKcº~}s=VC-X-|:P4+>6_\\#8iˠ\'e#hL&v##9Oksd\0+m7Fu78ۻD\ni\0Bk^ȆLP(CKhKڻ Qko-ƀp[[}$>sNF->9`{}NػCԊȯdhWsB\nK}ج\nN\"qH[Hе+7O,TϹEd\'㚇Qb\0J]_ڊ@RQSē\"BkP)ҿT\riQj\nbu8\rs{Na\"h3k\nQ%\0\\dJ@4Fzs{O	X=<F~5D&ïSF<NpiҖtq,뫽h@_jvPGdC\0GtKI59\ZwX\0]N(9$(@Ռ}\0,6jJR*%E0b[o&30T*$ǯr:2WJ|YatȌ+V\0eK_1*;gݖcdAhLBג`sU܉sޢ^&qRNؔ}*nIzm<NKhyowXDcHn*(T9w:˗(l>k\Z{IWtѠm*5WL):eαt4g=><y0g[Ű EOfƩjU\\2XEi\0$STvYFbc\"UH(r󔦌)s+ 8ʱb|Ces!+qD;9$\r]VJU>\nf\07^j\\&z<]1̪6+7peF$ffbXJ\"j\\Ͳiow/@֌,l4c=NbcAEWOyVɑ0	P:3JYŅ	F;DfʂV,C#4pǤ3G{\n{\r2X\0\Z礫owժعU*TMc\\.ۃ`lj`Wޱ݅qXƊ*9:vǪ1\'W*ECu\nu˽S48r2@[ ٹN8*K~ Nv([y?ɱoNvj#𱢰wȤ])a<LpASZg,yxJ2#V)Jbg3UES0H<ƷQsQ\rScЕe٥U\0H٢~Ab;WV*+QPq^~{E*h<ZѕBvc!(+t<Gwuorٺn6>{PTB&(+5d\rȍߦ7430X= {O* \rd*\\F~|hNxË(6\\|_n\0SmϾe_Z;phZHu֡+&{IZb#d^BipauLZ\'6^{p\nqLT$d%R\Z{@Nmqhr3[ G&Lv%!臥҇Q,e@z^}L:P\0{ +WG[}Vgޅʝ{n)4\rH2#=9|iU;5KJ\Zk5<@k^-18\\)[*T# Nj,&щȷAA崮_\0 wj0RFҙ\09\'\\/$#* ^avDZi^Ϯ߼~sJ]c-BQs`Q>j,uUz:{\0*=+ٻe(&A	?XUu|Q7}(4sݻv\'SHJc\0 St	hR=y\n6cXp0Yv5SKX_@3f\0\n2eO;	6z΢]K{I!M @!Nr+[ :;`{M:_{O\Z6S<KUWn7P\nrZ$7Jg[T0ǥXő|\0@>(iʾf5vZCw˽9WEXa`Ii\0D.7zNҺu)bjim$Ԭ\"?MOQ˹ @/cg;cChQ:(uؾdp0c_qGO=T\'|9$h,TA+|ps!|\\ ԌWBp?ڧpO^__<ܻ1R{:{WTʱ)~Yb1*l{}\Z2-@cYB\0V19px3݌jfo&<V΁e7vco8ـ.M}9\'{=*?So 3@@BcRe%\"BxVHjo2-	}*@U=yO71g{WRA)x_j gN.MUYxJlDS9(o{4Fe-!zOoABdRAS`!xݻH53F\r:7`\"\\֬܇VB{|Ur\Z˿zr8fؚarQ<g\r՘[b\"Q+͏ɽnĨ;0)kIC1?5%`)\Zgs.݇i\'9]I)UZ¶Þ\nw9d\0n=i.J.>:H\'?kV\\a[H,)3Z,`L6\'k`s.QBql.=l%lv!T#R8~\r\"{,W=x\\\'R\ZL$C9+{]Pݩ\08K6v\0.Et	V!,\rȼ\r2]|?;۫1\"ghlqYB-FXt`0Z<K/v7ܬe@55FZ)dKFr	F6-QF{w\r}um@,@#ӥ\"xU@&Z5D7ۢڐ0JI}\0I #qMg5\\}|Ήc{\\*HvX,\"yH=c۰D;`)\ZiO9<C\n\0? )fgL\"ף^_<ݙn,SJy֬ \\qˆ|yu/Pd$؀2y(̔pq\rTiOA6l;rm(&T,]LKӆs\n]q\Z[f\0$|:g]%ԋv\n3vV}Kj.jG=g{dzլ5dɸx\'!ij3,祅]V?J.=]tE`pJ [,w\':-k^e|;G%{Z]~{8w\rGqj͔p;i@6W䣈iBY:i|Nv99+QR(Qձ-\'cT>K!|}+:QZa\0L\'drNkҴhrܦ>x왽>#\\\"9\0Vi=ZvTp^t0{SGs-\'OT˨oP\'t+Kb;0\0Ma뾳JWvshɑÜg\\+)眚pNOd332_866w)q7ngxn&RǢ}9H\nXx5l\n$Vtzt$%0\rJ̞:+*0֋X{K5z/gUXMyD#5VIlc\0w |\\\0\ZH*9L۽[CDnަI[K\rңQ\r%NF5UH {#%k57-@L##7ǏY[Sim\"a@cmbOPuoW\"$1q)י9S=r\r4@\"[XZ\0OVi}\n焇ć<f\0sv_[Q,N9ffϻA5\0qFAUMu&N#1-ԨtδޱbYlTkqymX(RX`Re쟀*u,#Ua;Ev%=XE||/Rpz.p<\0P4B-#%l\Z4<ѣX=\ZA*ۓ#Z\"aӔT(fN)bRx/8/CR\0*pױCq8SIme)CxCI#.R(ЁN*\r}n&hc\\J1W8$楮F126ikN-M(rj20]]x2[AǜD J0L\0n	}@P4Z\\$!HEw=G 4\'F崌^9lW04+E~d\n$!5H:<RA~(}G\'mm83GLx\Zuz0,+\ZHF9Y}(wEHqA*p@*P_0w:4H!Ϯ~\\Ы?(2$tޥ\0\\+)W^KDXP,z)+:z1:iB;]Łm|@=Pށ:7<_:79T\0ƶiZϙ\'e @yKO|!p(qKGKt6qM\0\0=Ki{؁+Qy̰Qu8tjE7)ZB1Ih#I3]]\nTv9;?F{Z%thHt\'8/&/;6X`r!Ų\0>ڰ~oGd):\nC,EJpzO;\nHO@Ɯ@w=J\"V%R2_$VxV!TBoT(iM).A㔧[wx`,Q=v^0%tQa;*qi:50?C}Zb ÖǤ\0/\0,^b1mnE:BѢF<WxiMRѺSDwS,QEH	ŅVG¡Oh_cm]]z+E!XB)8\"2/c۞E\\Fd@!1g; t;mFyBx18aJ-C:<Å3{Eٴq@ym	6mzRR~L{HYۂcv8ZpEe:+\\!x\nf&	ls$rrD>[ Ji|YzԌKԉ*OȠIJE+m|駩(31#vh\r(ȯTwhց}.^!Iuꦨ)L|iK`b]	oO=j($9MLm FH[ѓQB1;p#ͧUzK{ݪ@*sh?S?WT&ǌ\'yfZ)[}:r.L#xwR\"l^7e1sF7Ȱ^DRVff#AnL\riy7Mlmyg~WwR34Dͫw.=$m~[z>DF|lbh33q<;RC==\Zr#qCs-Fiif?Jߕ6F&GCʹRѾeR1CkiD)|5<XmPpxڵ`V꼜>iVLtʳmA׭./V]۳6G̲}zU47ݜwp o\\n{]O`XycB/qmV}顉1HBx7~v\0ӾԘQ1++ö.vҮxlՅHj\'uggmK4`׺?5:+X\nui>;6Cj|ofV_Y +zZy\\`ol	\\[#c\Z6#ނ5z^,F2JWo&4SkRfzrf;(rjgV\\aSY^O[sfA\r~J]Y02geB /ZF\\h03*r\\Vߛ<Ӕ*+]X/3(rxʌ{o3] *ȪoQ0幾<o6lыG2e@wsΧWYyP]hϦR|Zj=!SQ=<z.o&d(;lkp{Fzs^gyCoBFu~>\'y)&4L=h}uWY+BO䴧o~lS^DY};LMdFGЬÁ.f?l/pT\'#8[-P\\7\rz^Qm-j\nvhrd7F}fgVSzZ0ۼB7X٤Ţxl|`X<ѫ-H\r7f\"EolͧϯiSzr]r㺜d`]UecmȬ.yݴ\"XEtr\\o_]* $pfhN	Z&kV\\빮rVQvh?\'(H{s/d7i68	_],P]H܉6?=)`n~@cq/qlCv WNӇ~;(`edģmo)CJ9hnLafivCv{h~\0=ǈwH`ǿc?\0PLfFd]̶P8h/vy$┞5JiW @W_+*{ߪ~BzH<wewwM1ɧՏ-qe{ܡHz26ND]zKߛ.m\"O:=Q\':mǆO4F=Ѩ%\ZV9g=o[a/ZqDĀu`cC/\\6y\"LʩA~:GM\nrg+%TE8U̧eL/g*\\Cg5m*@<if{)GN4C\0XZ\\#|)+QY3.:h#NAVRS8diuzytQ2݌#ڇeDߚE\\>HZn<mR__$IVI~s}r?a/hm3؁|wlwe]/w,02=4d\"BxTZV܈\0\"AY=8C#0QæmLن!b^K#g`ؾa!׃HK\0;rn ]{kU(ݯV5t5i\0=oVpgjUQ9nt52fJO\ZYA{03=) d!gk{	aJ<@\0٪@KuF4늍H> ``N/Fdr +Jc]\\`ZMjOh޻l,]gVX}1,#Rnhy뺰1\rum%ZQϋ5nODAc]\Z3!CP]ra\rsֵpc`APwYԦ\rG<hV\0H?̀u--`Xh 5}o.\n=h\ZOpuOLaFkf;P/^셝%Ba(Cj|lhƓyt`\nՇ&#[/i}g)V9Sl\'x{x	-y5І陕BE>>ߒrUa[kk)_ggao_`֫.o^jXJ_=fݞ8r-|/Fi\"리^vƷGX|=xzg7>/\\?}v\r*ٍ[[B`=pVDg+o^i\Zxvu\rˣ([N;XNMaΈ5\\\rʀe7Ս>|K+f*zMo=1wO_Ė\\n*a>>޾dOݔ\0\\[w9Vޭ[B\r]rǼoO\'~ĪGbf؎9 4R3#6s[G\\n_]\n`oOzoWQv֞,T\"UWoԣYEҞZ,e+Ϧ~|hQc+Zƙ`p(}9FhBH5A52ݱÍZ٫eeͲ2<-+̸۶Y6r+|8d|hx[]-	Ե_ǉ9hV,ҵ]L%\0', 'no');
INSERT INTO `wp8b_wfconfig` VALUES('lastNotificationID', '54', 'no'),
 ('autoUpdateChoice', '1', 'yes'),
 ('wafStatusCallbackNonce', '', 'yes'),
 ('disclosureStates', 'a:2:{s:20:\"waf-options-advanced\";b:1;s:26:\"wf-scanner-options-general\";b:1;}', 'yes'),
 ('emailedIssuesList', 'a:14:{i:0;a:2:{s:7:\"ignoreC\";s:32:\"6fd0d290b978eab8027e6b79501ac149\";s:7:\"ignoreP\";s:32:\"6fd0d290b978eab8027e6b79501ac149\";}i:1;a:2:{s:7:\"ignoreC\";s:32:\"ae37eacb19b71f3528671e7e16219c61\";s:7:\"ignoreP\";s:32:\"33f9e7d0226498d5068910f4ae2c3b7b\";}i:2;a:2:{s:7:\"ignoreC\";s:32:\"5d2548e3f321cde1fafa1c0338b2aa5e\";s:7:\"ignoreP\";s:32:\"8de7dae4d20b02108bd88476ed1c5804\";}i:3;a:2:{s:7:\"ignoreC\";s:32:\"0362aa85f8b0ac752c14b280eb61a462\";s:7:\"ignoreP\";s:32:\"302a4f2e74e292d50debba04c07e4746\";}i:4;a:2:{s:7:\"ignoreC\";s:32:\"b9b9bc16d418e14f6db2644ae2ceb5ec\";s:7:\"ignoreP\";s:32:\"179ed34020c443c5ffd1bfa6b7bc28fa\";}i:5;a:2:{s:7:\"ignoreC\";s:32:\"214fca146e06350e612ee413a3af71d1\";s:7:\"ignoreP\";s:32:\"63c10cbe889c6575f07f532d27a727cf\";}i:6;a:2:{s:7:\"ignoreC\";s:32:\"e2421d76f5a49ed1e1ef220e3af0bf19\";s:7:\"ignoreP\";s:32:\"4511871607a35152f28b29b76dd38f34\";}i:7;a:2:{s:7:\"ignoreC\";s:32:\"efe7fa1593689942711064a5ac5e86a4\";s:7:\"ignoreP\";s:32:\"ab87ae54184e8637a5b860827b532506\";}i:8;a:2:{s:7:\"ignoreC\";s:32:\"f5cabfe91b14ca91b916655bba4a4ced\";s:7:\"ignoreP\";s:32:\"244af9ecec7627cc2af2f9e370cdf6ad\";}i:9;a:2:{s:7:\"ignoreC\";s:32:\"6d24b8cca1f1c812f1745d9eff53abe0\";s:7:\"ignoreP\";s:32:\"8b426f0d8d2c7c25388cc9aa7b488a9d\";}i:10;a:2:{s:7:\"ignoreC\";s:32:\"1d6aa494b68afa480ff98a29e8dd9258\";s:7:\"ignoreP\";s:32:\"1d6aa494b68afa480ff98a29e8dd9258\";}i:11;a:2:{s:7:\"ignoreC\";s:32:\"d0eb958d59fca734331561365c34e889\";s:7:\"ignoreP\";s:32:\"d0eb958d59fca734331561365c34e889\";}i:12;a:2:{s:7:\"ignoreC\";s:32:\"b5d2afca65453f298f96b3b19c28396e\";s:7:\"ignoreP\";s:32:\"b5d2afca65453f298f96b3b19c28396e\";}i:13;a:2:{s:7:\"ignoreC\";s:32:\"6b0db0875e4232894314d65c115aff36\";s:7:\"ignoreP\";s:32:\"6b0db0875e4232894314d65c115aff36\";}}', 'yes'),
 ('adminUserList', 'a:1:{i:1;i:1;}', 'yes'),
 ('originalScheduledScanStart', '1588469400', 'yes'),
 ('lastScheduledScanStart', '1588471054', 'yes'),
 ('totalLoginHits', '407', 'yes'),
 ('totalLogins', '9', 'yes'),
 ('lastAdminLogin', 'a:6:{s:6:\"userID\";i:1;s:8:\"username\";s:7:\"demoweb\";s:9:\"firstName\";s:0:\"\";s:8:\"lastName\";s:0:\"\";s:4:\"time\";s:28:\"Tue 11th August @ 03:37:22PM\";s:2:\"IP\";s:13:\"190.75.83.206\";}', 'yes'),
 ('totalAlertsSent', '10', 'yes'),
 ('lastEmailHash', '1597160244:803bbe99a73e2197872bcc00717deffd', 'yes'),
 ('lastPermissionsTemplateCheck', '1597160077', 'yes'),
 ('wordpressVersion', '5.4.2', 'yes'),
 ('wordpressThemeVersions', 'a:2:{s:13:\"kallyas-child\";s:5:\"4.0.0\";s:7:\"kallyas\";s:6:\"4.17.5\";}', 'yes');

/* INSERT TABLE DATA: wp8b_wffilemods */
INSERT INTO `wp8b_wffilemods` VALUES('\0+OW+', 'index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm]#NX,', 'Dz\n}_7x,9t:\'\r', '', 0, '?'),
 ('[/9}`:wP', 'license.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lil+z9q9=\0{\r', '.7h-Zs%|Cp)¯v', '', 0, '?'),
 ('a?_ˢ6jX', 'readme.html', 0, '\r{1yi<', '\r{1yi<', 'ɗ$}b<o\'_=GՠQUe', '', 0, '?'),
 ('Kgo#0', 'wp-activate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J,&', 'Zb?b~GU˻UJ~ȻL\'', '', 0, '?'),
 ('-)75y8cWv', 'wp-admin/about.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':W\0M)wVJ.m', ':9GA`/G(*]r7eJ/Z', '', 0, '?'),
 ('XH奥(:Z', 'wp-admin/admin-ajax.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@u1\"0', '\0鞈8Z?֣%D`L{E%\Z', '', 0, '?'),
 ('!1b݅9*\\', 'wp-admin/admin-footer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R#ttIrzXK', 'Vo梌>)xZEBO', '', 0, '?'),
 ('KUg0MU/ʇ', 'wp-admin/admin-functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xo_Բ)\nr', '(Z!.eTU92;ݏt5o^', '', 0, '?'),
 ('@mOW', 'wp-admin/admin-header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Wub7V4xV', '4进MrB =+S\"{1E', '', 0, '?'),
 (']@\n>ĺYn', 'wp-admin/admin-post.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S}dDTN\"F', 'Fԝq`멾r_Ȩ_\'I', '', 0, '?'),
 (',H(b_FO', 'wp-admin/admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ic?UA	!<', '?0M(5*W}RV/Yd2', '', 0, '?'),
 ('	Xt\\4vNI5j', 'wp-admin/async-upload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C8\n\\)V', '*חUF\nl9Sk\\UZ%Ͽ^&\"', '', 0, '?'),
 ('\"6\r+K{\Z!a', 'wp-admin/comment.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r.kP', 'Ib9SE8T2# \r\n', '', 0, '?'),
 ('kM̙Ysp', 'wp-admin/credits.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',[Oc', 'v_Uz(GJ0|G', '', 0, '?'),
 ('*O-Lτ\r[u', 'wp-admin/css/about-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mm/\\-nY0]', '`U\'^h\";k#V=fz&➏X', '', 0, '?'),
 ('Unɓb4lZ,I', 'wp-admin/css/about-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd@Ξ\ZIB', 'Fw`raWYa&=h,,', '', 0, '?'),
 ('A7\'C#wSs', 'wp-admin/css/about.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7j:>VT\\', '* 9H6طr69;KW},', '', 0, '?'),
 ('J!2\0', 'wp-admin/css/about.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7;1V s:l<', 'm7U{lTNx&G,', '', 0, '?'),
 ('mn9F6', 'wp-admin/css/admin-menu-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xtUu6ct', '\"X\'Ԏ05^mf c%ؿ+$', '', 0, '?'),
 ('T]\\g4źuP;', 'wp-admin/css/admin-menu-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^\Z3vN', 'għ95\\}BMJ{zD', '', 0, '?'),
 ('\"Z0\0ؿeԦp', 'wp-admin/css/admin-menu.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I\'GfLg1', '.,5FbR\'RQ^2I(^_&', '', 0, '?'),
 ('E58yWsO', 'wp-admin/css/admin-menu.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}ĸ4Â}?3', ';6J\rdVm\ZI', '', 0, '?'),
 ('`\n2', 'wp-admin/css/code-editor-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3u/c\0TB-', '4I\n7o^\ZڬVrt\nG', '', 0, '?'),
 ('=f;Vdl\"', 'wp-admin/css/code-editor-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')?sEH', 'yq}l[=	n(cLC', '', 0, '?'),
 ('LߨϤ(R', 'wp-admin/css/code-editor.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CAO^)', '/y14~(6>B&F,S', '', 0, '?'),
 ('~}{ >D}<', 'wp-admin/css/code-editor.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O+jwh3:N', '}c/ٖ)DeKxOdH|5p[[n', '', 0, '?'),
 ('Pa`Xu', 'wp-admin/css/color-picker-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_\'CZ^dMm:', '->tkfM3GO33Dq', '', 0, '?'),
 ('rW3᥾V', 'wp-admin/css/color-picker-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a*	\rY~A', 'ZݳߥZr׮T`<m?T', '', 0, '?'),
 ('F?C;$H\r\r', 'wp-admin/css/color-picker.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0\'kR\ZJޤs', 'nrWm4Y	~jh|l@', '', 0, '?'),
 ('ܡ9u_\\\n9\'', 'wp-admin/css/color-picker.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/w	2ڢ', 'h_A4&uм?sA$Eq.)*', '', 0, '?'),
 ('J|6}P,\rٛ', 'wp-admin/css/colors/_admin.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MxWM\\0', 'q(\0y\Zt!.Xmq_', '', 0, '?'),
 ('ue,\"\n	hg.', 'wp-admin/css/colors/_mixins.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r:chW/5x#b', 'Yċ5:u9CIlc{x', '', 0, '?'),
 ('=CѠ*TX4', 'wp-admin/css/colors/_variables.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|g<n12', 'W~ &xdYbyX)YJ1a', '', 0, '?'),
 ('58d`S61K>ۮv', 'wp-admin/css/colors/blue/colors-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'Fw\"Y/', 'h0sYr&.mgոX\'Z\n{x\\', '', 0, '?'),
 ('D8hFޛBViR', 'wp-admin/css/colors/blue/colors-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'УA3\nk', 'U/ݗl\'B:8pۜN', '', 0, '?'),
 ('FZYC83E', 'wp-admin/css/colors/blue/colors.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D`?Sir,B', 'M\'x0t_:	9of+', '', 0, '?'),
 ('tm6ۗq.=j', 'wp-admin/css/colors/blue/colors.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':T/) ؾ?d`', '}sӛ9+Eb9F\0O', '', 0, '?'),
 ('L>tN', 'wp-admin/css/colors/blue/colors.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5Iהg,)ZYM', '\\kS뚑n wW	!*~v', '', 0, '?'),
 ('juGCtO', 'wp-admin/css/colors/coffee/colors-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r)CGPChQa(', 'ksF?!ˈʪ]L=7,yjv+g', '', 0, '?'),
 ('q?%rp07q', 'wp-admin/css/colors/coffee/colors-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DIn\'BA', '>H-Õ\Zi1zk)_V6(\r~:', '', 0, '?'),
 ('ϴ 3P`#8^Z', 'wp-admin/css/colors/coffee/colors.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']/Aeg\\ ', 's/V(E\\ΠH^Uz', '', 0, '?'),
 ('eCDi!', 'wp-admin/css/colors/coffee/colors.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aߞa\0\"7ӣ', 'R3..ZGE)Q2%CԪHb', '', 0, '?'),
 ('xIH.9YBO', 'wp-admin/css/colors/coffee/colors.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9~8 z#C0^%a', '\0{Zr~d0|B|]ׄj܌Ix>', '', 0, '?'),
 ('jmEAXuw>܆', 'wp-admin/css/colors/ectoplasm/colors-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$Ye\'m2\"', '!RB%!(~@', '', 0, '?'),
 ('Dչ$Oa', 'wp-admin/css/colors/ectoplasm/colors-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݏvʭWB', 'V}*2%^b\\W!>{m?', '', 0, '?'),
 ('H\0ۙhC', 'wp-admin/css/colors/ectoplasm/colors.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Oט瞽', 'Uxx^֬J56T,B\\', '', 0, '?'),
 ('[#ܧ\Z>]<', 'wp-admin/css/colors/ectoplasm/colors.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rjr:b', 'hAmxL\'bb!|M', '', 0, '?'),
 ('MTq&[?>칊\n', 'wp-admin/css/colors/ectoplasm/colors.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q9+\"+', 'BmNhstNjAS4X\0$', '', 0, '?'),
 ('q%ű m+', 'wp-admin/css/colors/light/colors-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~bRB1ı', 'N?OD#/\'B	ןŬIk', '', 0, '?'),
 ('-f4]#\"ul', 'wp-admin/css/colors/light/colors-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'js\Z', '$(ΐG;XK7;q[E', '', 0, '?'),
 ('v{#lb\0}B', 'wp-admin/css/colors/light/colors.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3#	KG?=\nF', '>m5o9D.Wq\"uXx$&', '', 0, '?'),
 ('9(FRj2n6]', 'wp-admin/css/colors/light/colors.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gu-٥3#', 't{u\0+Qc\rCeAJ', '', 0, '?'),
 ('KS+e׎A@', 'wp-admin/css/colors/light/colors.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HG#<^o', '?=ҏE\ZMaXĺJ\"sk;3', '', 0, '?'),
 ('L?@.~O', 'wp-admin/css/colors/midnight/colors-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-ćGRN(i', '8>|]صXL12@ˮi\n\'~6n', '', 0, '?'),
 ('ᗏ3-4', 'wp-admin/css/colors/midnight/colors-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's[]>`<', 'S=EG:ǝ ޫ߲;X_', '', 0, '?'),
 (';bfȖ0x', 'wp-admin/css/colors/midnight/colors.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L`	Ɏ', ':eOFM<ozEǞZEB(', '', 0, '?'),
 ('_\rJL#@B', 'wp-admin/css/colors/midnight/colors.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>[}\'K³IVR6', ';d@e&7͟ߺ_ Y/', '', 0, '?'),
 ('w=ŢO&F', 'wp-admin/css/colors/midnight/colors.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&܍|DW!E4', 'SoGp{\"FuS&', '', 0, '?'),
 ('<(*A]O', 'wp-admin/css/colors/ocean/colors-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',Ts9v+', 'YP\nᡇ\')S\';nr', '', 0, '?'),
 ('{^WC', 'wp-admin/css/colors/ocean/colors-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':.[<sr~', '\"\r:IL	\'Z;<1U!;', '', 0, '?'),
 ('Ê5ff;,G!\'\'-', 'wp-admin/css/colors/ocean/colors.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B&  {', '	\0cJ\r]5\Zt,>', '', 0, '?'),
 ('*Tu\r~m', 'wp-admin/css/colors/ocean/colors.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tM\npt8ڞh', 'W	ʄ]UY1kMz&ۍ>', '', 0, '?'),
 ('-Ǹ%w=', 'wp-admin/css/colors/ocean/colors.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z|[l|ٱf%h', 'ɮ1uZRH6I\r	ź􇖈B', '', 0, '?'),
 ('j׻q.*;2', 'wp-admin/css/colors/sunrise/colors-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`]Cq', 'cD]PA͇nŉna21', '', 0, '?'),
 ('2jL,W\rW$', 'wp-admin/css/colors/sunrise/colors-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M\\<.', 'K.oY#K\0RbՇ60%@)Y\nP*', '', 0, '?'),
 ('y85æb', 'wp-admin/css/colors/sunrise/colors.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_l3*\03', 'LVS)A*e\'G\n `i', '', 0, '?'),
 ('-+emu\"x', 'wp-admin/css/colors/sunrise/colors.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wFw<3jVYZo', 'tQ\'Gڥ:;c.\"\0\\Wp\Z]', '', 0, '?'),
 ('SCRCl', 'wp-admin/css/colors/sunrise/colors.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V\Zz	h=', 'Q_n97L2$y:jSх', '', 0, '?'),
 ('W2DG7V', 'wp-admin/css/common-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K\\|Ң(xd', 'vl\nVdn`sq\r', '', 0, '?'),
 ('XHov', 'wp-admin/css/common-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>W(Q\ZQL', '\\{Pk.DRDLB', '', 0, '?'),
 ('p96èR', 'wp-admin/css/common.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}u.q\\', 'ϽXF~]#)tf>g\ZMeۧ', '', 0, '?'),
 ('\rvN[B&SL', 'wp-admin/css/common.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fIK\Z*58', 'V?rd ae9DG`kMW', '', 0, '?'),
 ('Vk9۴sֿ', 'wp-admin/css/customize-controls-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.O&@8ww-', '0ZwL7Ū)C9\\+\"#ꆒ', '', 0, '?'),
 ('pj֛`w', 'wp-admin/css/customize-controls-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Չ{p1\nܷ/z', 'S%غ	]jt_MjE^Sѯ', '', 0, '?'),
 ('?\n5H?', 'wp-admin/css/customize-controls.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qA\'V', 'r[U-6V1a4$jQщ', '', 0, '?'),
 ('.նZg{=', 'wp-admin/css/customize-controls.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sh4#X\n<k^', 'y\r)LVӄi˂\"W?J', '', 0, '?'),
 ('Oy k	b', 'wp-admin/css/customize-nav-menus-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$\0h*BfajE', 'Yyr[rB<[\nti*(', '', 0, '?'),
 ('HAf,$F-', 'wp-admin/css/customize-nav-menus-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!_A@@+1`gJ', 'cG.-,Fɯժ2O8<m!', '', 0, '?'),
 ('AlA~i^uØ', 'wp-admin/css/customize-nav-menus.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*4^+G(ߢ', 'o\'晱}z\n', '', 0, '?'),
 ('\0]pޑ	\rG', 'wp-admin/css/customize-nav-menus.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PG(h@', 'a`kt%j+Qm\nhƪWh~', '', 0, '?'),
 ('NHV}4G', 'wp-admin/css/customize-widgets-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iOqff\n~', 'F%ɸ\n@ǳËE|B.=', '', 0, '?'),
 ('4T(\\9\'3)', 'wp-admin/css/customize-widgets-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5\"S\rߴ}=', '0Nρp\',z)_ъ _E\ZYm;S.', '', 0, '?'),
 ('6$[O', 'wp-admin/css/customize-widgets.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X<.', 'LVuGs2CݯsBY/Y', '', 0, '?'),
 ('b|e~', 'wp-admin/css/customize-widgets.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"P9sIufz', '|Z@hhL\\R&Sݱ', '', 0, '?'),
 ('5?y<2', 'wp-admin/css/dashboard-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':fƾr@RE\\', ';>A-F	Hh\rV(}LNN', '', 0, '?'),
 ('Ms;\',-E', 'wp-admin/css/dashboard-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't߻GW\\֬EPqޯ', 's2k\ZBP$}I	0rϬ', '', 0, '?'),
 ('KqM{', 'wp-admin/css/dashboard.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UGD(ӜulM%', '\rSJk\0t1f', '', 0, '?'),
 ('+.eF', 'wp-admin/css/dashboard.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xG!(`B%0', 'pVu!:TA\r%MP', '', 0, '?'),
 ('8@)6yg[ysQR', 'wp-admin/css/deprecated-media-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n6!S8zZ\n$]c', ',12UˇDHm< ', '', 0, '?'),
 ('pt_ Y7LKt', 'wp-admin/css/deprecated-media-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȂCVW<^\Z', 'h\0n(MyR&ʉ19?', '', 0, '?'),
 ('X\"-{$48sx', 'wp-admin/css/deprecated-media.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OC9ٻAf', 'c`LH;c!k[L\'CbIaj', '', 0, '?'),
 ('4a[I}Hm)', 'wp-admin/css/deprecated-media.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0 y!', '~E\']ԛTs\05ԥ8i,Xra', '', 0, '?'),
 (']\"}[YR', 'wp-admin/css/edit-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C$HHF~', 'sqH+;f2@48T_Zs', '', 0, '?'),
 ('BH*mzN83', 'wp-admin/css/edit-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=B~g;E^Є>', 'ɘ֩K\r^VvIKc%z[&j', '', 0, '?'),
 ('\r::HH:d', 'wp-admin/css/edit.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.?LԞj.gx', 'ERfl;9Br@gÖ4tg=', '', 0, '?'),
 (',o!zj\"', 'wp-admin/css/edit.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=WUdPH', '%i<Tӊ|tvҬ(R&4', '', 0, '?'),
 ('6;I(Hm%f', 'wp-admin/css/farbtastic-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7\n){', 'T=Y#[vrHiaR', '', 0, '?'),
 ('OXg]<f@', 'wp-admin/css/farbtastic-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S@[\\,3|!', 'Sm\';d`eM0i=?>?{', '', 0, '?'),
 ('«-j=uN\\q\'', 'wp-admin/css/farbtastic.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8)}{Ch2U', '|ALMbxd8XjX.^\n\Z', '', 0, '?'),
 ('KnҋD&sRWU(', 'wp-admin/css/farbtastic.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#^:G(:k\n', '47Vf /DW3p', '', 0, '?'),
 ('OlqCcێ', 'wp-admin/css/forms-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' ,4!<mPg', '*d8.K<hs߇˙7Q\'\r', '', 0, '?'),
 ('{]\\ֵ	d', 'wp-admin/css/forms-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*-4dmS', '[~gMyfdr T O	6r։s', '', 0, '?'),
 ('(%#9yn', 'wp-admin/css/forms.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':bu+I,', 'L~|)Zi ^Ci', '', 0, '?'),
 ('łjDߋ.˖D', 'wp-admin/css/forms.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<	z\neKWo1', 'pto.]׺7V١F', '', 0, '?'),
 ('kM?uX', 'wp-admin/css/ie-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$iIEs@x6z}0', 'w22\rމ#<*Qf(', '', 0, '?'),
 ('vs%zF', 'wp-admin/css/ie-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ҶLXda`M', 'Ns\"*\'7p$ixȭv', '', 0, '?'),
 ('E&VN\"N', 'wp-admin/css/ie.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y`-z\0\\', 'vAH\0eq$WDjK+{j', '', 0, '?'),
 ('ѧ_4a!F', 'wp-admin/css/ie.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v', '׆dŪC*k]0ɾ\"Ͷ#8K', '', 0, '?'),
 ('w9=_\"h%v', 'wp-admin/css/install-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݢ\rN\\', 'Ǘ@w\017\"GE_<D	', '', 0, '?'),
 ('i-X8V[~E', 'wp-admin/css/install-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+ֹ(}h', 'V9ؐ^#Z\nR֗m7+w@M֩', '', 0, '?'),
 ('<9uj!$', 'wp-admin/css/install.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?-~Lḭk?m*', '~x?LW{nhd?V\r#dj%', '', 0, '?'),
 ('ʆnD㮖(', 'wp-admin/css/install.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm\npyS~_', '\0x//7I>k5*>IO', '', 0, '?'),
 ('\'-p-f', 'wp-admin/css/l10n-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xmǏ|sA', ']%FL\nILlf426G\'', '', 0, '?'),
 ('vâ,\\+Q֧', 'wp-admin/css/l10n-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OSGfK罚8]', 'dxk3rްVNĪet-', '', 0, '?'),
 ('2Die', 'wp-admin/css/l10n.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ĸP)|qr', 'wppS\"D.oMOmO\'baǋ0', '', 0, '?'),
 ('H4.\\:#', 'wp-admin/css/l10n.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+.[H\rϬ.k/ ', 'lgj-u\\$?)\\y6@', '', 0, '?'),
 ('y%Ǻ~ne\"V', 'wp-admin/css/list-tables-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zp\\~u]d^', 'Ml=MlV00CK0', '', 0, '?'),
 ('F%C0,', 'wp-admin/css/list-tables-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gA#\rxݬ69', '_D؎Ha\0>G\'FvN>\r', '', 0, '?'),
 ('|jx7(Q}0\'', 'wp-admin/css/list-tables.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A_Niwx', 'lԻea<L+IͨV!7f|a', '', 0, '?'),
 ('kLN\0x6@', 'wp-admin/css/list-tables.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DCї&/CxWH', '(-IxtOQFexi', '', 0, '?'),
 ('A{& V>Νs', 'wp-admin/css/login-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$*l4 ', 'õheǣsom6	Fyc', '', 0, '?'),
 ('h@Z%RF;ti\\m', 'wp-admin/css/login-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?\'b5ê=s', '8W5é-|:&qFw', '', 0, '?'),
 ('|jX|fb', 'wp-admin/css/login.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nƯ_54C8N', '6u~	gӇxt?gE7wN\rvP', '', 0, '?'),
 ('`&锥~K3/d', 'wp-admin/css/login.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PyGEI\r>\n', 'w@NK!Ia:I>S2(JD;3ؓ(J', '', 0, '?'),
 ('r\nb#', 'wp-admin/css/media-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K6hTvlh$\r', 'L1Z-ׄ̄<L=n؜ȋ-K', '', 0, '?'),
 ('zݿ&X❙6s', 'wp-admin/css/media-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e\\*ﻓtfZ', '0IQ#^z-|fOU̚QP(rm', '', 0, '?'),
 ('TDFK1', 'wp-admin/css/media.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2ù@', '=3	Լ_vR}2)S+˘96', '', 0, '?'),
 ('%Pb.8Gdt', 'wp-admin/css/media.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '++>B7BE', '!ab%:qla?˓', '', 0, '?'),
 ('\Zy8R#Oy', 'wp-admin/css/nav-menus-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oNՉSOaW', 'e1EYL^U!^zKk]D-', '', 0, '?'),
 ('D 2K|&', 'wp-admin/css/nav-menus-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=x`*Us	H', '\r諜1#XR\\\00\Z*', '', 0, '?'),
 ('qhnJj', 'wp-admin/css/nav-menus.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uW	@x>`Ǉ~*', 'צѲsT.wzj\n@10_Ue', '', 0, '?'),
 ('ZWtpNh', 'wp-admin/css/nav-menus.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S4QmY_', 'HBWc\r&b]˦%Zm-:{', '', 0, '?'),
 ('PhrV', 'wp-admin/css/revisions-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QoBts\n/', '0|<8\n8<JZ|@J@Vb', '', 0, '?'),
 ('@tR>GHhס', 'wp-admin/css/revisions-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kyi$w}f', 'ׇK;=)z&!_[', '', 0, '?'),
 (' a\"KwTbc1S', 'wp-admin/css/revisions.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aa_4)^', '.M>%g$(`fP+/CW{%y', '', 0, '?'),
 ('\nGƙn\Z@1+U]', 'wp-admin/css/revisions.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Dw<aܰ', 'A\r\0n>e\0))iVI71eG', '', 0, '?'),
 ('r{\Zk\"k', 'wp-admin/css/site-health-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' Iq=$o|', 'qGn ^ixi\0) R:t', '', 0, '?'),
 ('6ZfM;', 'wp-admin/css/site-health-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4^\"%9V\'aU)', '\nGV@ouWLUUk', '', 0, '?'),
 ('b񪥲K+xwF', 'wp-admin/css/site-health.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9Ӧwk#', '\r6;i(	T#3', '', 0, '?'),
 ('v6^AA/],6\'y:', 'wp-admin/css/site-health.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7F8T{5', '|,LOM)\ra^[?@ڕ\Z', '', 0, '?'),
 ('0rH\"YK]T', 'wp-admin/css/site-icon-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LDR*', 'Yin>j#KN%8TPO_,', '', 0, '?'),
 ('QWsA7d\n', 'wp-admin/css/site-icon-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`_?ބ=|+d', 'MS>j/\"K%qޣ~', '', 0, '?'),
 ('\'=!ZaajUQ', 'wp-admin/css/site-icon.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}Ep0lu', 'i>Ӻ#&2Z\'K(*', '', 0, '?'),
 ('n&n!崬', 'wp-admin/css/site-icon.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lˁxJTG', '+WV3(qFr;|^@', '', 0, '?'),
 ('g~w\Zhh', 'wp-admin/css/themes-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p\"YWM:8/J', 'xFU\n?>Fpn\nG\'o5\0j=Ǯ', '', 0, '?'),
 ('5At߂m0iz', 'wp-admin/css/themes-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2W@ks', 'Nܟz?V>~=[\0v}g5\r<', '', 0, '?'),
 ('Rш޿0', 'wp-admin/css/themes.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l2AlKb57', 'X\"XQUds{MX1}SnZP1', '', 0, '?'),
 ('fSuBͥ?^yO', 'wp-admin/css/themes.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X,!\0BA,', 'Rx,d)щ+Cg\Z&x0po', '', 0, '?'),
 ('3vU\Z3P^O ', 'wp-admin/css/widgets-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '³/qcw', '4i*h[6oAߒ2|zr', '', 0, '?'),
 ('sEΞqpB', 'wp-admin/css/widgets-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pĊP{M', '\\gn\\\'S훢ik@RgT', '', 0, '?'),
 ('!HUN&\"z', 'wp-admin/css/widgets.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.9nP', 'D8.FLQ-[^wP\nlE', '', 0, '?'),
 ('E}~M-]a', 'wp-admin/css/widgets.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'هvqp[w', 'Fm)0\'d,hxt6J`Rf%;T%', '', 0, '?'),
 ('֗]NRS{qv?', 'wp-admin/css/wp-admin-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',*i[p]<', 'r5SE?29/)_PJvVhR', '', 0, '?'),
 ('$(g(P/', 'wp-admin/css/wp-admin-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GQ5\'EYo0}_', '0|TFO 	..>CEj', '', 0, '?'),
 ('d4j2UV$P', 'wp-admin/css/wp-admin.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7#Q&M?»|[', 'QD6hPqqM9FO\\O', '', 0, '?'),
 ('j0wE}®R', 'wp-admin/css/wp-admin.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eUpʓHWtP!H', '^E-R\'#?lemL0kU@', '', 0, '?'),
 ('?0|5uơ', 'wp-admin/custom-background.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '㽫]0m7d', 'Z5\"=\0Tσqr/0QX^dn6', '', 0, '?'),
 ('uqg\Z\08hԭ\0', 'wp-admin/custom-header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y&', 'Θ4Cw@XdoN=w<~o', '', 0, '?'),
 (';?2S\0p', 'wp-admin/customize.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't_(ӛ# *', '\ZMS?]8eُֽy6h2g', '', 0, '?'),
 ('p?E^@\'PE', 'wp-admin/edit-comments.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':ǰ-G_X\'V+', '19J-3~sʩ0o', '', 0, '?'),
 ('\rb\\ɍ\Z', 'wp-admin/edit-form-advanced.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0118ÌO?)M', 'id\rx1:V\r(:邿98', '', 0, '?'),
 ('592^%<', 'wp-admin/edit-form-blocks.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%Z{9k[U(\Z4', 'YfQܸת!>sRn', '', 0, '?'),
 ('G7\ZI&:x', 'wp-admin/edit-form-comment.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D\0)%b\\', 'DG7-hpEM!v+6Q5', '', 0, '?'),
 ('\nb-V:|m', 'wp-admin/edit-link-form.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HCY~s', '-r}u6kvm:4Sj', '', 0, '?'),
 ('%8^V<t', 'wp-admin/edit-tag-form.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ܰo', 'k3br1x1H8C*aU', '', 0, '?'),
 ('h)UG@xv	', 'wp-admin/edit-tags.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '۬lI9Y;J', '@vJPwb&y', '', 0, '?'),
 ('YLah(', 'wp-admin/edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?A`=ZШ', 'F=fMV9G/m$=kFs=a', '', 0, '?'),
 ('I7߇S2&', 'wp-admin/erase-personal-data.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FΐdAq', ';懭rj}5-[{(', '', 0, '?'),
 ('pVYa\0צּ=', 'wp-admin/error_log', 0, '\Z8?u?', '\Z8?u?', 'Wt&u7aCN=\\P?Yj}\Z', '', 0, '?'),
 ('|-z-', 'wp-admin/export-personal-data.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rseO 9', '+5YX+((@GDNTu,a', '', 0, '?'),
 ('1|}dQ', 'wp-admin/export.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M-}> 0*fR', '\rl7B\nmU@=^{}ZEf,', '', 0, '?'),
 ('O&r蓏 ', 'wp-admin/freedoms.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's·N^*f', '\n[&.u/#347^t@', '', 0, '?'),
 ('W\"Sk:', 'wp-admin/images/align-center-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-r5*J7If', '8tf*JwT^H>1JDο', '', 0, '?'),
 ('&*dĆָ	H5', 'wp-admin/images/align-center.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	\Zݶ4ydY1e', '놽N3X!ljh`hA]J', '', 0, '?'),
 ('V9KgoX7', 'wp-admin/images/align-left-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i8O^c', '$kb>k&:	ڂa7Zcdm%', '', 0, '?'),
 ('mMtWB', 'wp-admin/images/align-left.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\y0dZo.h', '_]<#S\"B^U4_Q<!@x?J$K', '', 0, '?'),
 ('].ooȦM-n	', 'wp-admin/images/align-none-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XC)[-4', 'ߧ&QQp\"~\Z8S׊YS`', '', 0, '?'),
 ('MW	:ي', 'wp-admin/images/align-none.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eqd2u\r', 'g(1X{ [].TA', '', 0, '?'),
 ('vG.gA#r', 'wp-admin/images/align-right-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hl>r]lWx', 'V:h#ȆBT5i\0?cBc', '', 0, '?'),
 ('tnRؔ%^', 'wp-admin/images/align-right.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BOe#l@:P+\"v', 'ɳC?=&UyZ31!<c', '', 0, '?'),
 ('[QH\"pS1Ȫc', 'wp-admin/images/arrows-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' Q}ydb#6', ',c˿\Zi(~)\'8[A/Ix', '', 0, '?'),
 ('E#lL_&ܪ', 'wp-admin/images/arrows.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v$>>Y', 'YW(N32U;<.iDd!', '', 0, '?'),
 ('DS3.įy};', 'wp-admin/images/browser-rtl.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D\"ӠA\Z%̝', '+啧0pƜJMk qwXب', '', 0, '?'),
 ('H06', 'wp-admin/images/browser.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K\\b$F', '&$ĉ9~_SH_̓%L\'&', '', 0, '?'),
 ('G9q=ʥ[3?a', 'wp-admin/images/bubble_bg-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ϭqj\nX<', 'n%4L6{/Т[Ĭ?XW_A.r', '', 0, '?'),
 ('QuoPX\0Sڞ', 'wp-admin/images/bubble_bg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~g<ćI0', '\'+uW`-AS\'}S~Sb', '', 0, '?'),
 ('Lt593u^)', 'wp-admin/images/comment-grey-bubble-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TYŝ2s,\rm', 'DxT-wN	P{', '', 0, '?'),
 ('ebWA0d', 'wp-admin/images/comment-grey-bubble.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y*\'tF', '7	y񮌬U{ԟ`]m', '', 0, '?'),
 ('I\\jxg', 'wp-admin/images/date-button-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?a09JQ\Z', '*Q_(G:*ηd.', '', 0, '?'),
 ('a\'@T瑓', 'wp-admin/images/date-button.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v!0ϝ$\n-潮LT', 'hŵδ䘼n$q!I#', '', 0, '?'),
 ('j%Mɍp)Z', 'wp-admin/images/generic.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'[#98!', '{uK[g͆Ex{:߼lͨG', '', 0, '?'),
 ('\Z{g?3gڢ\Z', 'wp-admin/images/icons32-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%*g', '#!$@0g.;i3%!cHP=', '', 0, '?'),
 ('&N,6P', 'wp-admin/images/icons32-vs-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*04G4F	&Zi}\"', '.a}hw6WEʭ(3Jӭ9E', '', 0, '?'),
 ('L Ufu<', 'wp-admin/images/icons32-vs.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',P*{>vUf', '?UzP\\@`8g;\rE', '', 0, '?'),
 ('1WV(26', 'wp-admin/images/icons32.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '۬[m9J4\Z', 'DkCdi|a|+\rx̌', '', 0, '?'),
 ('L8\\ݼ+', 'wp-admin/images/imgedit-icons-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',\'6Ut', '?؎).l%<(_ 6`^c7', '', 0, '?'),
 ('{?\r\n\'', 'wp-admin/images/imgedit-icons.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K\\2}Gi;O', 'TN~-@N̞V\\(u$', '', 0, '?'),
 ('4ge>ߝ', 'wp-admin/images/list-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hջIS2ig', 'JpS_X#UB-z,', '', 0, '?'),
 ('Z\nuoK T;e', 'wp-admin/images/list.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>*ӳS', '\\wT[=baCk;c', '', 0, '?'),
 (')M^ûoz', 'wp-admin/images/loading.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@לx>c¢', '<\0ЅҩهqU%G7r\\*2J', '', 0, '?'),
 ('\0%3[$x\0.(', 'wp-admin/images/marker.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3*O2/3I2', '~T@\\vUI<pKa`T@cca', '', 0, '?'),
 ('@;5XVOZ', 'wp-admin/images/mask.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g~\"J䩎', '/<sԡ)\'.1jknK9Q', '', 0, '?'),
 ('@sZ^qv', 'wp-admin/images/media-button-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#WI\\?', '<:tnkbwi&	R\Z', '', 0, '?'),
 ('1EfQv#)\n0EkQ', 'wp-admin/images/media-button-image.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm	\'A', 'iķz[/\" X{o:', '', 0, '?'),
 ('a\\c,I\"5T#̋', 'wp-admin/images/media-button-music.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4^&$ouf&', 'wWd¼8PF6Aܴto-X\\a$', '', 0, '?'),
 ('NQ\"*hzrw|\Z', 'wp-admin/images/media-button-other.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q&T^]BBg\'', 'B\ZrFВPv-^fT,_i', '', 0, '?'),
 (')z]!?a', 'wp-admin/images/media-button-video.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>uewJ', 'Ye\"n+#@ƼZgVP\'', '', 0, '?'),
 ('a)TMWOoQ|', 'wp-admin/images/media-button.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6@pz^ye', '_\ZSjזY VZGen_', '', 0, '?'),
 ('\"N߬jj)\0N', 'wp-admin/images/menu-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jG{>^;$', '2]y#h29> ^s\rH	\ng', '', 0, '?'),
 ('* aF4uvU', 'wp-admin/images/menu-vs-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JZY<iYb', '\'FєE\07ɡ#>sePض', '', 0, '?'),
 ('t]ٟuuj', 'wp-admin/images/menu-vs.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qL,_;1/E', 'GiH|)E;\"_;ԣ4Իwly', '', 0, '?'),
 ('@XD\n\nRNt', 'wp-admin/images/menu.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r9#dY`	', 'lIE/(p\0pnT-Oz\"],=`', '', 0, '?'),
 ('F 8+)rP', 'wp-admin/images/no.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kd$ܟV7', '\n>~hZP\0U0;\' {)	>', '', 0, '?'),
 ('+DFܿTZ[H7', 'wp-admin/images/post-formats-vs.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SlH\\', 'etw|W{xy%K:QE7', '', 0, '?'),
 ('\0וoxi3%\r+]kg', 'wp-admin/images/post-formats.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K\0%3', '9ƺ&]nEua]iFƳ', '', 0, '?'),
 ('n]j7<3ISsQ', 'wp-admin/images/post-formats32-vs.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't.E5GN\Zv', '(Z,ImY,·ԗtGa', '', 0, '?'),
 ('œϔ=#6', 'wp-admin/images/post-formats32.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WY~O{+_LkE;', 'k<8._DKG[5e-I(0wh', '', 0, '?'),
 ('?{o_\'n', 'wp-admin/images/resize-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{3VVFVf%K', '懴y2qZo~([`\0`Ci\ZL\'', '', 0, '?'),
 ('3!9=6ݡ', 'wp-admin/images/resize-rtl-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MMH!YA', '2mo{|ny˃4(φ=', '', 0, '?'),
 ('I{?r]7', 'wp-admin/images/resize-rtl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nC%YfvF.z', '@St-]z\'+k2{j,QN~)	>', '', 0, '?'),
 ('~?JIb*׺eC', 'wp-admin/images/resize.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lN', '6󀏸&?5?sqGM`P;', '', 0, '?'),
 ('\nfY4&L', 'wp-admin/images/se.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȔB`.}\'7:', 'Y\"K{Ur:2JL', '', 0, '?'),
 ('X:8+˓2>V]8', 'wp-admin/images/sort-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aìk:bтvFj', '\'aK\0tGJBqXW*(J|1z[(', '', 0, '?'),
 ('[65+	n9', 'wp-admin/images/sort.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '* 3', 'vP-~xO\"	;', '', 0, '?'),
 ('J&_#3Sq', 'wp-admin/images/spinner-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '12^#8', '#˒=$c6	B46', '', 0, '?'),
 ('fi`=@To', 'wp-admin/images/spinner.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L\nD\noًj˲', 'zƄ\Z\"n\Zs(U/~7F^', '', 0, '?'),
 ('P1$\\*C', 'wp-admin/images/stars-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A#SMe.^', '[耿_(\rhYTqZ', '', 0, '?'),
 ('Fj!Y{.J=,', 'wp-admin/images/stars.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[><k{(', '/	\"Fa챔<SYg؉F@', '', 0, '?'),
 ('VrmKEpj6', 'wp-admin/images/w-logo-blue.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0Ȉk|Ѽ', 'OɗoCA/x<%4=?', '', 0, '?'),
 ('Jf3?_rC', 'wp-admin/images/w-logo-white.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nJvۢ~y\\', 'nD _;!GםcV0M9i=', '', 0, '?'),
 ('+gq6^\0', 'wp-admin/images/wheel.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E0 q0m\ZY%VX', '(]:=dqۅO{9ԀvȘ~', '', 0, '?'),
 ('%\\MA', 'wp-admin/images/wordpress-logo-white.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qPC-SPD', 'e4E?&DsAʬ;)@Xɒ', '', 0, '?'),
 ('tZQYz0跫', 'wp-admin/images/wordpress-logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ưyo88S`', 'bxLPͰ=^am1i', '', 0, '?'),
 ('c\"ml Ǟ>o', 'wp-admin/images/wordpress-logo.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N%dgp', '\"uj-QE\0[gLZ5MD:', '', 0, '?'),
 ('ںuM[\r', 'wp-admin/images/wpspin_light-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mSy\"C', '66SX6O}4>p\"\'1', '', 0, '?'),
 ('\"w%_K\\u', 'wp-admin/images/wpspin_light.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hkuR\r@9k', '!Fױ(#1:', '', 0, '?'),
 ('<la,bX,', 'wp-admin/images/xit-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ӂu:@4\rz<5', 'S\r}@~Q:Sc*d+Z_{R', '', 0, '?'),
 ('mz4LK', 'wp-admin/images/xit.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	3Xī9+6n~', ' sۨS,md\\YbƇo', '', 0, '?'),
 ('M&3\r3CMaQ{', 'wp-admin/images/yes.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+7܉\rqZQk', '=QG9%K,\r\ZFy', '', 0, '?'),
 ('TV\\', 'wp-admin/import.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2+ÝJϹhL#Rj', 'S\"udGANal6#ho', '', 0, '?'),
 ('ĳJ\n`|5,HT', 'wp-admin/includes/admin-filters.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'	\r	x		!6\0e', 'QRO ՓBsKڟ\\{', '', 0, '?'),
 ('D)bak{', 'wp-admin/includes/admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'\npZ,v', 'k_DRH{\0#6Z~}uV', '', 0, '?'),
 ('Ҫ*H\n;t', 'wp-admin/includes/ajax-actions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oTc~tzܞ', 'Yωq1}5\Z\\|FwxQ', '', 0, '?'),
 ('ΝH**.ځS', 'wp-admin/includes/bookmark.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƺR<W9`w', '\'AGjM3а6\ry:?', '', 0, '?'),
 ('\"wh', 'wp-admin/includes/class-automatic-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	O8?_;=0p', 'CLJ\\DƪN%:\"W<', '', 0, '?'),
 ('nкvnj=ͮ', 'wp-admin/includes/class-bulk-plugin-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '߃l=*fܷG9ݜ', '͋ȌˀG\0c{>.\'\'1e,', '', 0, '?'),
 (' \'_U;0/<', 'wp-admin/includes/class-bulk-theme-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʟHL˻)q', 'hh>ך4!S&zlg\"', '', 0, '?'),
 ('W7{(;:P?', 'wp-admin/includes/class-bulk-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A2?+Y', 'i;M3UP<XZz', '', 0, '?'),
 ('jUUX\Z/J/', 'wp-admin/includes/class-core-upgrader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-W%ET	().', 'u19:nlIq|%-&{', '', 0, '?'),
 ('ɡʧ~.)k', 'wp-admin/includes/class-custom-background.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/]]3H@\ryI', 'W,Σ67lZj9', '', 0, '?'),
 ('njP+', 'wp-admin/includes/class-custom-image-header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '20A&5l	57E', '}g_Du#g5om!Q˷V(u', '', 0, '?'),
 ('M\0c_d', 'wp-admin/includes/class-file-upload-upgrader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w;>xZs6', '[\"o^.q`Oצv<Q+FM4', '', 0, '?'),
 (':8Iaølm', 'wp-admin/includes/class-ftp-pure.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T&}\\3J \0', '\nS{UCdz$ya|8[', '', 0, '?'),
 ('afh=FT:6', 'wp-admin/includes/class-ftp-sockets.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q\"Pe<3i', '.\ZD-ày!̕l', '', 0, '?'),
 ('rp.u3zx', 'wp-admin/includes/class-ftp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?7^4\",\04j.', '~lXUAWAk', '', 0, '?'),
 (':X@\0{*֯', 'wp-admin/includes/class-language-pack-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1Kd%', 'I\'J8˵u_\rlP^4', '', 0, '?'),
 ('g~)~sʞI', 'wp-admin/includes/class-language-pack-upgrader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ym', '_#EbHST', '', 0, '?'),
 ('\"ơ7vs+', 'wp-admin/includes/class-pclzip.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l)[}MYd', 'J4?Lឃx\rk9%ϤR\Z5o', '', 0, '?'),
 ('W&ִ )+ڱ', 'wp-admin/includes/class-plugin-installer-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Gr[+V\0\r', '(dl\r%7\r޹98k', '', 0, '?'),
 ('h/͔jC\0n', 'wp-admin/includes/class-plugin-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3f\0a̲', 'G4v^1Po\\y/', '', 0, '?'),
 ('v)F~q?b', 'wp-admin/includes/class-plugin-upgrader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?	`%.am', ';wY{oX=z', '', 0, '?'),
 ('sIqF', 'wp-admin/includes/class-theme-installer-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '35`ҁ%il	', 'u.6qݫ][zD+I`*a?rf8', '', 0, '?'),
 ('H`\\ rYC', 'wp-admin/includes/class-theme-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rM,}1o5', 'E\'JFw\"9HՃ \rIQ\'D`', '', 0, '?'),
 ('3aDwPq', 'wp-admin/includes/class-theme-upgrader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HBc\":`^q', 'elR ~*8:fڌKj', '', 0, '?'),
 ('{y\"ҵݩ{', 'wp-admin/includes/class-walker-category-checklist.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w#qhT+!', 'i`!X|2֓h6F\0zP/G`^', '', 0, '?'),
 ('Qs|cL؜VH)', 'wp-admin/includes/class-walker-nav-menu-checklist.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>%s\r&a~)', 'W|MB7m>|o)b2q;', '', 0, '?'),
 ('ر-_}Zh\n\Z', 'wp-admin/includes/class-walker-nav-menu-edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J\09h׮ګ', '!h>sSRt32]', '', 0, '?'),
 ('!yF]', 'wp-admin/includes/class-wp-ajax-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QՂ,qsR', '/s=\ZKBjJZwmVE:', '', 0, '?'),
 ('Z\ZaYH\0 5~ ', 'wp-admin/includes/class-wp-automatic-updater.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k3\",?z3', '\n~+4CSLh\ZchMD.bV', '', 0, '?'),
 ('Ye.0s', 'wp-admin/includes/class-wp-comments-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yw>]I!>g', 'FLFFc/M]GruW', '', 0, '?'),
 ('&/dbdq2/', 'wp-admin/includes/class-wp-community-events.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0qbà3ʌÍQ', '˙+7Iye\nejJ\0bИwn', '', 0, '?'),
 ('XTCW_^og', 'wp-admin/includes/class-wp-debug-data.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fZM{eHn¯', '~z_BJsQb', '', 0, '?'),
 ('%f\\+,\0\\Y', 'wp-admin/includes/class-wp-filesystem-base.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~.`\rmc~b,[', 'Yq{~׵،2\'3Hs', '', 0, '?'),
 ('hFM<@`%q-', 'wp-admin/includes/class-wp-filesystem-direct.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WByy~D', 'pH{]yhVDH&	', '', 0, '?'),
 ('6̠,_qu', 'wp-admin/includes/class-wp-filesystem-ftpext.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~h5PX\r!', '!C:yZB{ʁ|`>\Zmy-', '', 0, '?'),
 ('PQE|E}7+', 'wp-admin/includes/class-wp-filesystem-ftpsockets.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W1H,ˍ6', 'b,\"E|VVBkrJMȋ', '', 0, '?'),
 ('j(g~jU#', 'wp-admin/includes/class-wp-filesystem-ssh2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'څC_\n', 'QR,8\rL@+F[Ü', '', 0, '?'),
 ('v]z3tB', 'wp-admin/includes/class-wp-importer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S%>䥎Rh', 'yE8BќӭA\rПz#J}V\Z', '', 0, '?'),
 ('vA\nGr3C9`', 'wp-admin/includes/class-wp-internal-pointers.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^I[8T䍍\\=', 'Y^9A\r+^-iLWjOF', '', 0, '?'),
 ('_(CM69', 'wp-admin/includes/class-wp-links-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L\ZVqThr', '\\UEǣw~ԝt|BNʵj\0', '', 0, '?'),
 ('UdMS$l', 'wp-admin/includes/class-wp-list-table-compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']Z;E\'', '>1WU\"&SId/Bt\"UW', '', 0, '?'),
 ('O	S#Yiv', 'wp-admin/includes/class-wp-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0[%Ւnf$\rvȀ', '=Ig0uatIL+', '', 0, '?'),
 ('Vb(ktW\"6(;ƴ', 'wp-admin/includes/class-wp-media-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kG:, KŜ', ',Ѧp866dkS\\hD', '', 0, '?'),
 ('spe', 'wp-admin/includes/class-wp-ms-sites-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rsuc Nռ', '[DOCʧUמTVh;կ', '', 0, '?'),
 ('wV!', 'wp-admin/includes/class-wp-ms-themes-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&nB0,', 'ڄ6chDHW((\"l@d\r', '', 0, '?'),
 ('i)33ܥs*', 'wp-admin/includes/class-wp-ms-users-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tf)j^wD', 'B|=AGȑxqä4Z<xy', '', 0, '?'),
 ('e.PȴNBSx[&', 'wp-admin/includes/class-wp-plugin-install-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I^6q꣹]p;', '5)OL̲nјۖ%O%', '', 0, '?'),
 ('[:q', 'wp-admin/includes/class-wp-plugins-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/,C{Gk+<', '{\076$\'7+LXn5', '', 0, '?'),
 ('c4L]˞Mc', 'wp-admin/includes/class-wp-post-comments-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@dB#&&', '{bk\r}	{=\\=6`l	', '', 0, '?'),
 ('Gȩ6\0Y', 'wp-admin/includes/class-wp-posts-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tNhhQ\r$dck', 'txڷSyZ7w.>N', '', 0, '?'),
 ('Sq`M', 'wp-admin/includes/class-wp-privacy-data-export-requests-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y7LrG[n', 'k%}1o.gMG&w&~', '', 0, '?'),
 (')`f,u4', 'wp-admin/includes/class-wp-privacy-data-removal-requests-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's;dFxgؔ', '-SڡʁLUGeM)', '', 0, '?'),
 ('5foޮ', 'wp-admin/includes/class-wp-privacy-policy-content.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|7P\Z_im.', 'RJaT7ݔnO=*K$', '', 0, '?'),
 ('fG<@៝N-', 'wp-admin/includes/class-wp-privacy-requests-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Vbƥy/+ܣֽ', 'ZoE <O8`9&Vv~L', '', 0, '?'),
 ('TMl', 'wp-admin/includes/class-wp-screen.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E0MqF', 'ib\\*rфfUC^E>', '', 0, '?'),
 ('%9\\ދ', 'wp-admin/includes/class-wp-site-health-auto-updates.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NG-l=gp', '*<yXsVv6щl\'Z(k0', '', 0, '?'),
 ('u1HM:E7/{', 'wp-admin/includes/class-wp-site-health.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zC+(UɠT', 'qc:a\0m5(o8V9', '', 0, '?'),
 ('\'Mw񑍷\rKj', 'wp-admin/includes/class-wp-site-icon.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nG+*e`rB', '=R&reXr9h\n )', '', 0, '?'),
 ('L#/۰*3\r', 'wp-admin/includes/class-wp-terms-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kV\0', 'UG.5-l,0ضq=', '', 0, '?'),
 ('\"ڕK[@G9', 'wp-admin/includes/class-wp-theme-install-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.U,	z', '=jq)v+Lu(ˊ.t?6\ZӠO\nGT^', '', 0, '?'),
 ('\"IFn@a}9', 'wp-admin/includes/class-wp-themes-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Te_̽n4#%', 'H[\r_PdV35A;GzG', '', 0, '?'),
 ('=@\\JpQm\\6', 'wp-admin/includes/class-wp-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sz$M(^p\'	', '^w\Z?6UQfYo+xl&', '', 0, '?'),
 ('zJXw{!\rF', 'wp-admin/includes/class-wp-upgrader-skins.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q\"ґ-щ', '.7j3?̶·?2UE.GW', '', 0, '?'),
 ('XGzX', 'wp-admin/includes/class-wp-upgrader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2rϳ	S', '^KiڽzBgyL˯z\"[Pz\"HJ', '', 0, '?'),
 ('x8[!>X', 'wp-admin/includes/class-wp-users-list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%R-:{o<', 's(M7r:v. 3c+', '', 0, '?'),
 ('|&;rLs5', 'wp-admin/includes/comment.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '榆a\\,uO؎', 'cdEO+\0̓{RaNӍD', '', 0, '?'),
 ('3koW5	k[mq', 'wp-admin/includes/continents-cities.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W_TӰIY֛', '2ɟtb;6@\Zq\'QHj	mѫ', '', 0, '?'),
 ('<	f%nO', 'wp-admin/includes/credits.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xl	', 'vEN߶ϣW!O	wjc灔VJ', '', 0, '?'),
 ('\\т?$̈́8', 'wp-admin/includes/dashboard.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pp0qGJ', 'g@޸u(|AB͐D:j*', '', 0, '?'),
 ('?E_)xڅ$', 'wp-admin/includes/deprecated.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2bҾu{vY!', '!K0cy1;F(яc', '', 0, '?'),
 ('x[e>M', 'wp-admin/includes/edit-tag-messages.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm-If3f\\Z', 'u-hyjL!zV-1nyFYÝ&', '', 0, '?'),
 ('>AB7Sz!e', 'wp-admin/includes/export.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qwj{Isˊ', 'Y֋qwGvj(V>i_', '', 0, '?'),
 ('QT*fP.', 'wp-admin/includes/file.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^!vM', '\'uo.0ղW9e', '', 0, '?'),
 ('7E#wŧj', 'wp-admin/includes/image-edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ez\\', '8{>ANqz!e*&fƏ1', '', 0, '?'),
 ('\0|9ue@', 'wp-admin/includes/image.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ib̓\0ڕw+', 'm.sMݡx(<=q8[?', '', 0, '?'),
 ('Ah)I\Z]GrE', 'wp-admin/includes/import.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\ܚ;', 'ADL;U˓s{j^ߙʃ', '', 0, '?'),
 ('cwk(43', 'wp-admin/includes/list-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pY$In~H', 'ݕAU,{_%EK	', '', 0, '?'),
 ('R=*dn', 'wp-admin/includes/media.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4W쟍tT', 'qlSiDEGג5O+.y', '', 0, '?'),
 ('\nqoqZVyX9', 'wp-admin/includes/menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N{=\"Wl7-', '\r\0tq?>Vч8v#', '', 0, '?'),
 ('HýiZU,HL', 'wp-admin/includes/meta-boxes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F\"Va', ':!)upe*UX=\n`?WMp.', '', 0, '?'),
 ('1eUMV^', 'wp-admin/includes/misc.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qRf[`.', '<|\'5WXn^<#j^[Ku@', '', 0, '?'),
 ('j<MDd4m', 'wp-admin/includes/ms-admin-filters.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';ƼzgL', 'tMpQ8=~bw/', '', 0, '?'),
 ('7*\"{\nK<', 'wp-admin/includes/ms-deprecated.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lt{0oޖ', '7<NoQF\0$jaϤ m\ri', '', 0, '?'),
 ('f霰f؟|hUL', 'wp-admin/includes/ms.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XfQl', 'F7`F\n[Ozޟk.', '', 0, '?'),
 ('(љ\0H<_', 'wp-admin/includes/nav-menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dv<^ލO*4', 'B H7\nﺊ\nԃ<v汆', '', 0, '?'),
 ('V׀\'hĈ+:', 'wp-admin/includes/network.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z\"?v(G\04', '۫qM:D6[c\Z͙I1O', '', 0, '?'),
 ('w`M>{', 'wp-admin/includes/noop.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xqj\Z!\r:', 'dˎJP[\n=QcP', '', 0, '?'),
 (';pR9+qpծ', 'wp-admin/includes/options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wbUzx|0 ', '+u8WN>3dr;U*`&', '', 0, '?'),
 ('R|Rx/bzn9\0*J', 'wp-admin/includes/plugin-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_78!@%', '\rF]\Z(nq-.*nhH', '', 0, '?'),
 ('q\"co>2Rh]', 'wp-admin/includes/plugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g	WZ7', 'l1VVѬ;=Ϛ(0T@Ĺ!1t', '', 0, '?'),
 ('5V\"$$_', 'wp-admin/includes/post.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&!Hœ})\r', 'OW#I;{*>[gw8', '', 0, '?'),
 ('-.xɤR', 'wp-admin/includes/privacy-tools.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '쳇>2PxD	', '2n~Nq\r\0QSq6Qp)M#', '', 0, '?'),
 ('x^m]̲/L4vU', 'wp-admin/includes/revision.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lWpdyaD6', '*ɋ\"+\0?o >eky;Yuu', '', 0, '?'),
 ('ǫ=m/^', 'wp-admin/includes/schema.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S	}\'sQ	', 'E`Ryv\'W7pس|', '', 0, '?'),
 ('(v|T— ¥', 'wp-admin/includes/screen.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Å/(/Iff', '4RxOc\ZIqy\"Cx/j	', '', 0, '?'),
 ('Z %/Zz9', 'wp-admin/includes/taxonomy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*ƴC\nr;', 'JA#V<$nΉwS*ߏY\'k', '', 0, '?'),
 ('2@jj\0kӲӘ', 'wp-admin/includes/template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ydiE7K', 'sKN:pG;ZVBC7', '', 0, '?'),
 ('~L*,<:', 'wp-admin/includes/theme-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4_a&', '+#>=]L8\0¬dh{rC[CG=ZP', '', 0, '?'),
 (']W/>}<8 VF', 'wp-admin/includes/theme.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nP8\0TqF', ';K_=Џk.t\r{8A)֩\Z', '', 0, '?'),
 ('8R6DHq-{:`', 'wp-admin/includes/translation-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2`4AiJ/', 'tDfir1[l?m+ĥj4/', '', 0, '?'),
 ('Uy/*%;', 'wp-admin/includes/update-core.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r[Y?.', '	bV6,[:r9<B6J', '', 0, '?'),
 ('].1\rPXL', 'wp-admin/includes/update.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ӻ^nܻ;=)', 'ak#p:U#\r,lHݶSđ', '', 0, '?'),
 ('=cه', 'wp-admin/includes/upgrade.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y<_M[A', ':4ibj3!\n5X+;A!', '', 0, '?'),
 ('Q (;ؠ|~R8b', 'wp-admin/includes/user.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|Cǡ\ndG`,', '1B$}MQdLFk2qR=#', '', 0, '?'),
 ('I.$U0]\'S_', 'wp-admin/includes/widgets.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A0WkNj', 'P.yoD2ֻX^@pI\"\\', '', 0, '?'),
 ('Ѻ\"P5^U\Zi', 'wp-admin/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!C: 3^', '~m9OF{6enrPS[', '', 0, '?'),
 ('Bj)qDS', 'wp-admin/install-helper.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Bny~Rm*', 'elԸ4KO}+H1oYy9', '', 0, '?'),
 ('6|;;8Q4k', 'wp-admin/install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ԩ\nm\rIV', '[3F*+\\#߷fa', '', 0, '?'),
 ('z;j2WD6[V', 'wp-admin/js/accordion.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']3mi䙶&', 'U?6RA鲣R)bn8', '', 0, '?'),
 ('^.jT}<I', 'wp-admin/js/accordion.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eԇ9Qs', 'O8d?1snth wPa', '', 0, '?'),
 ('fp\0!tDK', 'wp-admin/js/code-editor.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ɰOk14', '}dr/DI!XCz7hnNG', '', 0, '?'),
 ('| 4x\\Mn', 'wp-admin/js/code-editor.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~!K', 'DYI_~!|.x@dVL', '', 0, '?'),
 ('5\rk', 'wp-admin/js/color-picker.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ȁ/F\r6E', '@nTC#(\rZ8#IK&', '', 0, '?'),
 ('Hl{!D#!', 'wp-admin/js/color-picker.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pDk', 'L)\r߄~c8PlORc{1h~', '', 0, '?'),
 ('C/;)ّo', 'wp-admin/js/comment.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=WsP=m;/-', 'A7\'тtqƇ==.', '', 0, '?'),
 ('Qlg-', 'wp-admin/js/comment.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(CIAgiPS&i', 'a]2Q\0Uf$\r<', '', 0, '?'),
 ('w:}VP', 'wp-admin/js/common.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Et\r,P\\zD', 'rK̘	K;h*c\Z!#\n yXf', '', 0, '?'),
 ('_f $O<o', 'wp-admin/js/common.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z)k+]', 'ߎL.ʝ0B\0&Ik!lmJ\'4\r(_', '', 0, '?'),
 ('d1쵓-;O', 'wp-admin/js/custom-background.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X}{f/F	%\"T', 'hNNA%Ug\0RK,&\"ra9', '', 0, '?'),
 ('} yTZHcDJ', 'wp-admin/js/custom-background.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r&aXF,ˑQ', 'AԷQYa\Zg#njUXh', '', 0, '?'),
 ('C\nU', 'wp-admin/js/custom-header.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',U@T{', 'ZG*pJ\r5w;ތp,0,?', '', 0, '?'),
 ('nvpe}', 'wp-admin/js/customize-controls.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_h&/', 'F&J[?wcA;ŕY$|!$99)=', '', 0, '?'),
 ('dA#*Źo7', 'wp-admin/js/customize-controls.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ϡk`˳eP', 'F0+Q\0^#j%(J>z', '', 0, '?'),
 (':DJ$hǅ\r', 'wp-admin/js/customize-nav-menus.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z{O;q', 'v[oݝL~	a\'Oy2', '', 0, '?'),
 ('HGh\'xR~\n', 'wp-admin/js/customize-nav-menus.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FPRcRs', 'VG$$[+mĺv<8\n8', '', 0, '?'),
 (')[\"JH|jk$', 'wp-admin/js/customize-widgets.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ǋ\03+At', ';T+ig)iQ3 ', '', 0, '?'),
 ('fMx	+9U', 'wp-admin/js/customize-widgets.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^&n<Sf?o ', '%̮ݑ2󜕴.G?HeX', '', 0, '?'),
 ('ĸ:,p1Hr', 'wp-admin/js/dashboard.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8Z;X:q', 'UEkYpQJ0Lژ1Q!', '', 0, '?'),
 ('zpKC{\\>', 'wp-admin/js/dashboard.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}DK4gp@y!', ' B.:<,^V/SQ{@>݁H}', '', 0, '?'),
 ('`%ֽj\'P', 'wp-admin/js/edit-comments.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?\":bPNK', 'cHX&iR%.Ԓ	;!Τ', '', 0, '?'),
 ('F\'B/4{J{w', 'wp-admin/js/edit-comments.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3ʓ@9	0wL', '9]Vn8`D8qP`j', '', 0, '?'),
 ('R5?- S^H', 'wp-admin/js/editor-expand.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ι30b>:!K', '0NbCeZ\0B	>C8', '', 0, '?'),
 ('IV/6s', 'wp-admin/js/editor-expand.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rJd)8?', ':ZX݀gmֶ[Rvt:e\Z', '', 0, '?'),
 ('8=Ia%k~', 'wp-admin/js/editor.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',ɸ#\"[', '>uj{5NoJO/ڰ**', '', 0, '?'),
 ('⣣MOU', 'wp-admin/js/editor.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KۨÍm', '{PBhSNe	xv0HvʳWIB', '', 0, '?'),
 (';RyhRxK\r', 'wp-admin/js/farbtastic.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':T2Aq]4', 'btGp\0BM0zXJvZHAtM%', '', 0, '?'),
 ('/GΞӶ[ǜC', 'wp-admin/js/gallery.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?^DT!N', 'LGB=o\07|A!8(Fe', '', 0, '?'),
 (' I_X?', 'wp-admin/js/gallery.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DN*2J#+\0̙N', '-G|ě?0]JȪ!k4Yɬ02', '', 0, '?'),
 ('G_bc.,]&', 'wp-admin/js/image-edit.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^]^W<w@\0L', '\n\0G2N_Ve\\&?9KTU', '', 0, '?'),
 ('-Z:E:', 'wp-admin/js/image-edit.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aoPpm0]', 'i-\'ВΎak51F', '', 0, '?'),
 ('%nTߒ	^gXΰ', 'wp-admin/js/inline-edit-post.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@JTߛ~0\"xB', 'z?&h1pmn2crtG=T.50IK', '', 0, '?'),
 ('1o%qA', 'wp-admin/js/inline-edit-post.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[jKn<eh{Ϋ', '\"*f(0csJr{~*h2r_', '', 0, '?'),
 ('(q4P}5Ozk', 'wp-admin/js/inline-edit-tax.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p\\Tx⇤', '}sԑX_l;Km~v', '', 0, '?'),
 ('pl4[e', 'wp-admin/js/inline-edit-tax.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n(x!.ˆ', '>%n!B~?HzO7&', '', 0, '?'),
 ('lFc뒕L', 'wp-admin/js/iris.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '10!2}=n', 'K<<6[0j0vgJ=', '', 0, '?'),
 ('i\\=Xh$', 'wp-admin/js/language-chooser.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rIY:', 'Ćr@\"(r^Oe$ۜ)', '', 0, '?'),
 ('Z\Zxcyd\'', 'wp-admin/js/language-chooser.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7e]^J[2X', 'ӛxOqWb xM1l	NuTi', '', 0, '?'),
 ('QR\"@3vS', 'wp-admin/js/link.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8_4?zi;Uy', '6.o\\o`WZ_~)G\ZOq.rI', '', 0, '?'),
 ('|#԰#{', 'wp-admin/js/link.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y	yp>I[', 'I\rsZzYW|.-hkĺ', '', 0, '?'),
 ('nZ/1T:{&^/n', 'wp-admin/js/media-gallery.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	uς^', '#E9DU|c۳kHz_;+', '', 0, '?'),
 (':%H`!\rZ', 'wp-admin/js/media-gallery.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j Nx8p(b¡', '	u&*\r!?c^H%4}/', '', 0, '?'),
 ('^\\XPvS\\{', 'wp-admin/js/media-upload.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9\0{ystς', '}~G7}NK\rZ܍m*FFI', '', 0, '?'),
 ('el5sEúQ', 'wp-admin/js/media-upload.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pXϟ)>\n', '~\Zu]1A#V2U', '', 0, '?'),
 ('r(n՞jb\"', 'wp-admin/js/media.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.Dvk*0', '_K^| ?,\Z!EAA`X', '', 0, '?'),
 ('מy7mE5O_', 'wp-admin/js/media.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OI~ZUCI', '1_\'SK,NdL2Mzl', '', 0, '?'),
 (' It13&', 'wp-admin/js/nav-menu.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mo 7B:	\r2', 'Or;+¾\n9֐/5Z', '', 0, '?'),
 ('fyħ*!', 'wp-admin/js/nav-menu.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F2VYalci', 'oAZB>Sy\"pVcY(*&׺>', '', 0, '?'),
 ('\"\rJ\04\'i', 'wp-admin/js/password-strength-meter.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h\rAT]Yh;', 'Zn{a	QhzoF6n3J	', '', 0, '?'),
 ('Ȁ~_qIS', 'wp-admin/js/password-strength-meter.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ĭX(6UP', '|4Mcgԟe<6#8=ء(j|', '', 0, '?'),
 ('t6O\raȆf', 'wp-admin/js/plugin-install.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$얨owQ', 'KYV҄ɓ$8t.OFzd8B', '', 0, '?'),
 ('!Y0-z1dm>', 'wp-admin/js/plugin-install.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_P]إw\rH	', 'Ѷw/y[C\">yNN', '', 0, '?'),
 ('V댏$x', 'wp-admin/js/post.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iE;r%', 'uSXI&{,RD?-Է	j=t', '', 0, '?'),
 ('M?,5*K*f', 'wp-admin/js/post.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-!e<~f', 'WVMkϭ:%Ɖ8a5gEYr{', '', 0, '?'),
 ('P\'(?+z$', 'wp-admin/js/postbox.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':fb៙M>~', 'TC\'A&NBW>3N:\r`', '', 0, '?'),
 ('ORrD?', 'wp-admin/js/postbox.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')侲}\"@.Fh', 'UĪt_ܫW|\0?-<<', '', 0, '?'),
 ('AFk', 'wp-admin/js/privacy-tools.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gBH0rɂV', ':8C\Z.m	DཤX-Hc2', '', 0, '?'),
 ('fŭ8;slV', 'wp-admin/js/privacy-tools.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g3ToI', '?e	FlZ	-*a;C^', '', 0, '?'),
 ('\\9ѕFw', 'wp-admin/js/revisions.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LOeznUR', 'q:\\H-ƒViԍ$', '', 0, '?'),
 ('ke<F4', 'wp-admin/js/revisions.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '75\"s\r-Cz', '=bb+|.HՕƓs}LX.]ؚ', '', 0, '?'),
 ('KW&\0\0K\06G', 'wp-admin/js/set-post-thumbnail.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Nɖ=f悺4A', 'DueaO_-mz/+(qj', '', 0, '?'),
 ('TgslFʞLy', 'wp-admin/js/set-post-thumbnail.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X[~e1NZ', 'ȉiIǇN=ZAI~#&', '', 0, '?'),
 ('J8EDh+F', 'wp-admin/js/site-health.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'POK\0E\\o?)ִ', 'G>\'iꃝ,>n_)OX^(', '', 0, '?'),
 ('x`f,5ef2', 'wp-admin/js/site-health.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't-=$8	n*', '=q\ro3Ws^FA7]J(!u', '', 0, '?'),
 ('Z/{LtծF$', 'wp-admin/js/svg-painter.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x*wjq@', ')@ywb3\\ZK_', '', 0, '?'),
 ('U<?Y,ػ(', 'wp-admin/js/svg-painter.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S7])67p&', 'LL^\rn&mFЛMP', '', 0, '?'),
 ('G|$p֠+(', 'wp-admin/js/tags-box.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D\"tT%@Yrc', 'LYye2`箼Sf.`oa?isO', '', 0, '?'),
 ('J1MF<', 'wp-admin/js/tags-box.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'laIr[+*', '_!J[Yh23ewg|]M*', '', 0, '?'),
 ('}\\5\r$lW', 'wp-admin/js/tags-suggest.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\I^&9:?', 'HR[<,N~%ɜHj[A$O', '', 0, '?'),
 ('km|Kma0\"*k', 'wp-admin/js/tags-suggest.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[&X6H', 'tQo#qU	AsP', '', 0, '?'),
 ('{tE~PA1', 'wp-admin/js/tags.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0x9ɩ\ZY͎', 'I(嶔s\'gwHufo3^p', '', 0, '?'),
 ('fkjNUei4=%', 'wp-admin/js/tags.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E$[:;&5', 'c%}E[`Xh2ZeBV', '', 0, '?'),
 ('@F Ӡ(e*[', 'wp-admin/js/theme-plugin-editor.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Dt9_', '(@`Xyܛ;j<2ݾVp9/!:ox', '', 0, '?'),
 ('Nxډ\Z8yH\\', 'wp-admin/js/theme-plugin-editor.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1c)]q', ')N*VAUo<44\\ۃ`yD', '', 0, '?'),
 ('#\\/vXR', 'wp-admin/js/theme.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.ٿM;Bw', 'mo\rd~i4(//SW!LJSiO', '', 0, '?'),
 ('G6U2\01RJ', 'wp-admin/js/theme.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.er}8', 'Xل,fl>UHo;zX<K', '', 0, '?'),
 ('+9[BUEe', 'wp-admin/js/updates.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'_zı	B', 'g[+u\ZCvTـv]re5', '', 0, '?'),
 ('([dBQ', 'wp-admin/js/updates.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kNb۬', 'CE>ۏkm7zTklEO', '', 0, '?'),
 ('\'>[·', 'wp-admin/js/user-profile.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't6b%Eϵ', 'V-*kƚ,憯w|@dtM0', '', 0, '?'),
 ('HS!; ', 'wp-admin/js/user-profile.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '71UسP\'8', '/]Vi+}39	', '', 0, '?'),
 ('R¥Leq	&', 'wp-admin/js/user-suggest.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZaK=ls', '>n\"Sqt\"qzي*pZ#+x', '', 0, '?'),
 ('X$aB^', 'wp-admin/js/user-suggest.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ѝ̢VN3', 'cm[Tl5Qy;w0N!</躬', '', 0, '?'),
 ('&Ż(', 'wp-admin/js/widgets/custom-html-widgets.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nL\0$-', '\Z_Wf\rw\0 0ѱGrq@', '', 0, '?'),
 ('{\nRoR=\'g', 'wp-admin/js/widgets/custom-html-widgets.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$yN8O9_J', ' 8}\Z!\Z$`	L@u/Yj', '', 0, '?'),
 ('K]Cl7:D\0', 'wp-admin/js/widgets/media-audio-widget.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P IM;p8vn[S', '9jlxBeH:y%}c	TP_', '', 0, '?'),
 ('<|~E.Y^!]', 'wp-admin/js/widgets/media-audio-widget.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0!\0f$}VӇ', '<#I0VX_|QwtcN9׹', '', 0, '?'),
 ('~KɁwwfC', 'wp-admin/js/widgets/media-gallery-widget.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{c/I<', 'y\\RTܠUtmY(㻱̿', '', 0, '?'),
 ('yA0Xz(\'\\', 'wp-admin/js/widgets/media-gallery-widget.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-^5(>v', '%t!nqR)Ɯ\01^T́a*', '', 0, '?'),
 ('4y3%k ', 'wp-admin/js/widgets/media-image-widget.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';k#?cQ7(e', 'o{\rrh5Fww	LeFz]', '', 0, '?'),
 ('|N!;xN&gm', 'wp-admin/js/widgets/media-image-widget.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\':(7H1 DCu', 'SXW#DsDZ@_V#7β', '', 0, '?'),
 ('5ڜ2l2{', 'wp-admin/js/widgets/media-video-widget.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':ܥd|QSn', 'R;Twhm^䜺KLA', '', 0, '?'),
 ('˥̰MVЗeA', 'wp-admin/js/widgets/media-video-widget.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ԧQ># \r/M', 'ByN m_NRMB%ƤqW', '', 0, '?'),
 ('ņLGP(Ήȯ', 'wp-admin/js/widgets/media-widgets.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#Ja@c', '-xw2o1D7\Z	d7z=}I', '', 0, '?'),
 ('Q;(Mp*', 'wp-admin/js/widgets/media-widgets.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k+47T', 'qt;H3V\0h0Ut', '', 0, '?'),
 ('$TX@#A', 'wp-admin/js/widgets/text-widgets.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"ynk`G', 'iZdD0.ȍz\nF0z', '', 0, '?'),
 ('bpA+-+ʉ', 'wp-admin/js/widgets/text-widgets.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M>N#n', ',5yYBʼҽVT_egPrd', '', 0, '?'),
 ('RQb7f |~ۓ(', 'wp-admin/js/widgets.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\ȷHAQxr', ' \0ew]~#Nt}ooC}Dj', '', 0, '?'),
 ('Sx4@owN', 'wp-admin/js/widgets.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1:Փ<uoVB', '%{?gf9״>Q%xEp', '', 0, '?'),
 ('P73o	\0=', 'wp-admin/js/word-count.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J%׿0', '8E+j<SΙQo0XG\\飛', '', 0, '?'),
 ('Cg}|E', 'wp-admin/js/word-count.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-`^n', 'Q:ۀG;_!x6OS', '', 0, '?'),
 ('v4|><', 'wp-admin/js/xfn.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p)', 'v*K:	RzokM</k+', '', 0, '?'),
 ('頻yN<9o\Z<', 'wp-admin/js/xfn.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')Mi}5T', '?PHQ@aJC\04/wۄwv', '', 0, '?'),
 ('|Y>	Ɔ', 'wp-admin/link-add.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E!\'ljP^kI', '5:qφR_\\yh\rLIl', '', 0, '?'),
 ('B%v6I\"Jb4ӡT', 'wp-admin/link-manager.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~у!&cm', 'wS&r?QXWS|>ʺ-[', '', 0, '?'),
 ('~rC', 'wp-admin/link-parse-opml.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X~βEʥv', 's}ZA$Y>:5J>\Z~l]n', '', 0, '?'),
 (':{{79', 'wp-admin/link.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';9٨1', 'ݧ~F={D\"\nޖ(^Z', '', 0, '?'),
 ('6]jvWk\r3-', 'wp-admin/load-scripts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',_p#oԑT', 'DKv|	Est\0Pe_A4w', '', 0, '?'),
 ('W})Ӗ7e}59,', 'wp-admin/load-styles.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#DxEL', 'F0X:06{·c#yVQB3H6', '', 0, '?'),
 ('KOȖ93|<', 'wp-admin/maint/repair.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7I|F=᳖', ' <\0`Pn^2d+', '', 0, '?'),
 ('J{ֹZi^ùxI', 'wp-admin/media-new.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5igղ', 'Cs\04aF	V\r;ެ\"xpa', '', 0, '?'),
 ('}', 'wp-admin/media-upload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?f)nE', 'zE{jwiv=CF9LvPմ^', '', 0, '?'),
 ('ÏuL,&Ǒ\r1', 'wp-admin/media.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6Tuڢl@*[\"', 'V٭ǜ&NC$$$Fy V', '', 0, '?'),
 ('$īI^3', 'wp-admin/menu-header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'ߞCI0f5R', 'J^:Yy^;=ݸԼ	a<ͦQ', '', 0, '?'),
 ('\\D >F,', 'wp-admin/menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ޑ*4YKiJ', '}yi(6 Љ:69WƱg~:G8', '', 0, '?'),
 ('W{g- X\'=n8', 'wp-admin/moderation.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZEVUu', 'Fq61<wt&b1', '', 0, '?'),
 ('vw@HzF', 'wp-admin/ms-admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UjAڦYqu	', '\"G\nڔMhQ2l\'ܵ', '', 0, '?'),
 ('&ee\n3KvZ', 'wp-admin/ms-delete-site.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r?[=\':	', '[1,\\ɥmT]OP\"KF(\"9', '', 0, '?'),
 ('EV,%,SM=', 'wp-admin/ms-edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P3\n7|L?MtA', 'acsc\Z\"VL\\њ', '', 0, '?'),
 ('\"(}Gr	0V(', 'wp-admin/ms-options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~<bs\'+\ZQ', 'qJR_+VC%~d35kx', '', 0, '?'),
 ('-18;T/X]', 'wp-admin/ms-sites.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f3&S7F76', ',$yn)RHgh{$U', '', 0, '?'),
 ('=b6hst', 'wp-admin/ms-themes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':1R]	lI!#_J', '7EHPuZbG', '', 0, '?'),
 ('\\9', 'wp-admin/ms-upgrade-network.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qc8E%!', '	H_cQX̤ՏLsڭ', '', 0, '?'),
 ('kULǡ$', 'wp-admin/ms-users.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '³u~]*Cu\0', 'es}k_q}~G[5Qu!', '', 0, '?'),
 ('\rxݍ^\Z<;', 'wp-admin/my-sites.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2%8=%$\ZRf', 'mvC}ݧ*O=O', '', 0, '?'),
 ('Clo', 'wp-admin/nav-menus.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0A=pR\'&Y', '-t8TGh0~gƙKpf', '', 0, '?'),
 ('ol>x~I ', 'wp-admin/network/about.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~(4G', 'j/}Ӆ\0ES̤\\Hg#Z._', '', 0, '?'),
 ('ZQ4\\(܇', 'wp-admin/network/admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ϯ\r&Z3r\"', ':%;KiW@>U;#>', '', 0, '?'),
 ('+t%R?', 'wp-admin/network/credits.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B+KVe=', 'WNhK2ZFW\r08J5', '', 0, '?'),
 ('\'ڞ\0;?+VҪ', 'wp-admin/network/edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(^~avɽ0', '\nZz}K߄!Wtȧ)gF$S', '', 0, '?'),
 ('uF^GE+c', 'wp-admin/network/freedoms.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u6|tJ41', 'B;M7߃[9</', '', 0, '?'),
 ('\0C_\njD@k', 'wp-admin/network/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+)&c', '1t/g7O$U~4n7Z\Z;u)dkn', '', 0, '?'),
 (']PTkvt8A', 'wp-admin/network/menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ż\Z=> ɱl', 'yTQmUzDsg1^T\"igI', '', 0, '?'),
 ('[ixTq~Wve', 'wp-admin/network/plugin-editor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xJYFq^N', 'zwiL_*	!$cL*TqDN_', '', 0, '?'),
 ('p$^dZ', 'wp-admin/network/plugin-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't\\hW', 'aOUfʏ$~hD9lO/[x)', '', 0, '?'),
 ('\"Sέ`t@', 'wp-admin/network/plugins.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R\n.oƱ2bw', 'Agp/m,&Rqf9ey$=', '', 0, '?'),
 ('Jח_yzx6O', 'wp-admin/network/privacy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0>H\r5:6', '*]X8%KқR	Qf;\ne\r6\\', '', 0, '?'),
 ('=}CiHT', 'wp-admin/network/profile.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E3@%c ', '\\H.77QtUwݰAK,$A!Lz', '', 0, '?'),
 ('\Za]]A\'h', 'wp-admin/network/settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Rw?쭦\"Kh', 'ci]AΈUL]E2R+WJ44_:m', '', 0, '?'),
 ('/sC4', 'wp-admin/network/setup.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	wTA;}Ad', '韌\'MN+ƺRg', '', 0, '?'),
 ('+G*#f', 'wp-admin/network/site-info.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o3I OLnH', 'ાUd.=ܒqN	S\0\r|D', '', 0, '?'),
 ('yG\\`MR', 'wp-admin/network/site-new.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'JYEo4vM', 'a(]%S-QmʨӒ?JgiR\n', '', 0, '?'),
 ('yc0Og)ρMf', 'wp-admin/network/site-settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ˠzl$\0', 'åmF9[CgJS[ؙ?s}', '', 0, '?'),
 ('qhBc92', 'wp-admin/network/site-themes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2ûDr,', 'UL%{đ\\}xsv', '', 0, '?'),
 ('q@/ꦑٞ-M', 'wp-admin/network/site-users.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0͚j3{l', 'vʦ-bN`-1ld\nǒ]V]_	K', '', 0, '?'),
 ('n@AF', 'wp-admin/network/sites.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VB!Pp0', '4j2HO1ݝpZ(ȞDm', '', 0, '?'),
 ('{N2Qu=	', 'wp-admin/network/theme-editor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}b~@uˏJ', '\Zdc\\fu5=qאEcIa', '', 0, '?'),
 ('h|hEf:Ʊ2~', 'wp-admin/network/theme-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kJ>&/WC', 'Ǖ`F>^3MoMUU^\0', '', 0, '?'),
 ('!}=`*gZ=', 'wp-admin/network/themes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xɌ(\n2\r', '$UfBOZLM]', '', 0, '?'),
 ('7|oOUz\0Ef', 'wp-admin/network/update-core.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L;G_bu\'\\', 'v,I/L^ww\ZX12yTɣI~', '', 0, '?'),
 ('\\(wBI', 'wp-admin/network/update.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Θ͉`Zj+', '#2>>2ӢH\n', '', 0, '?'),
 ('rhvLk/', 'wp-admin/network/upgrade.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Bfգ', '8]y%r̚o6=l8LdLS-T', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('\00#9Z4j$', 'wp-admin/network/user-edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nd4VڋS~tɱź', 'oᕑ\"tySM8!9/?YX', '', 0, '?'),
 ('6K1(}/AX', 'wp-admin/network/user-new.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';F[jR[D', '&̸i(JQRjZ?uoTV', '', 0, '?'),
 ('	09-bͩW', 'wp-admin/network/users.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9ݡ\\~', 'B߽;U̬7OW\Z>.\'\r', '', 0, '?'),
 ('dlPOI', 'wp-admin/network.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DLWQ	9]', 'C1|r[$RzfU.P{', '', 0, '?'),
 ('JTV0DoTA［@', 'wp-admin/options-discussion.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':F9쥾ULX', '&FCXyZBTꅡu', '', 0, '?'),
 ('o[n3uʹP5', 'wp-admin/options-general.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#綁', 'DxLrӾ蠬z:n1eD,R', '', 0, '?'),
 ('\rѪ1s1=`(y', 'wp-admin/options-head.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cV8A#h:e׭/^', 'c҈^$kR2\r=ܫ@g2', '', 0, '?'),
 ('\\.1-:', 'wp-admin/options-media.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5t=gέ', '||Q!J*Zlzݧ|;', '', 0, '?'),
 (')t\r,Jڼ', 'wp-admin/options-permalink.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bNC=qͲ:', 'K2J8?۾!΀߰K7Ԗ=M', '', 0, '?'),
 ('$^6bH^*', 'wp-admin/options-privacy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O5oo\"ى=3L', 'Yj{ĬxMj#A [V', '', 0, '?'),
 ('ҲE5|ѵCd闼', 'wp-admin/options-reading.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(IJ%}i5%X', 'O7jUNe;F2|\'J', '', 0, '?'),
 ('L>ٟ#{6p}Y', 'wp-admin/options-writing.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nL<\Zuh', 'e0/%0~C>\\hvVr9\rt', '', 0, '?'),
 ('d(%J@G', 'wp-admin/options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uNvo|֤G', '\r8HLIap!>O̷ Vqx', '', 0, '?'),
 ('acCH\r=l@ĸ', 'wp-admin/plugin-editor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e$Lu^wh', '~8֪5LEϐ`G8f!^c%%=', '', 0, '?'),
 ('xjP!cx', 'wp-admin/plugin-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`N5(HjwKeh', 'SvV\")w91C1g+77', '', 0, '?'),
 ('O\\P5{R', 'wp-admin/plugins.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JAerTKI]q', 'jYQOM)ZJ)˗U:£\'', '', 0, '?'),
 ('kzߣboR', 'wp-admin/post-new.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sA7B', 'Ց=Oq!sQrURh_EЅef|3', '', 0, '?'),
 ('vAdsK]', 'wp-admin/post.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_j+', '@K+\'\nr{#lL_dvU컴', '', 0, '?'),
 ('Q`8M8', 'wp-admin/press-this.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'xq>/EQL', '>k(Bh\\ѫ͜:', '', 0, '?'),
 ('2|΢(ủtT', 'wp-admin/privacy-policy-guide.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '摞;fK|UW', '3=F!U<$t}b!1gGTW', '', 0, '?'),
 ('c餟(Ok1!͂', 'wp-admin/privacy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '==Eԕp#r', 'cFcu?oc]#T]|yW', '', 0, '?'),
 ('h4#3`-݈\"', 'wp-admin/profile.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0,g;ꙴ', 'CqN,`vS*Z[`m', '', 0, '?'),
 ('\\\0>+Fb', 'wp-admin/revision.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p{WC', '}<ԧYA{cͅkdf7Y', '', 0, '?'),
 ('c̎$\n\'@\r', 'wp-admin/setup-config.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'leQ=ٶJ5=Py', '^hܘ!¢24q+[lI02', '', 0, '?'),
 (';j|:1/', 'wp-admin/site-health-info.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':r-	R9D', 'JoDn\'Rpޮq{AٌRKOH', '', 0, '?'),
 ('-|VH%', 'wp-admin/site-health.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@k]hߩmO', 'Aܔ?UKP!ENAGƽtI3,', '', 0, '?'),
 ('|f,2T	', 'wp-admin/term.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bWRo(', 'ieO?^$1Ilg(5T.', '', 0, '?'),
 ('&`OQ5Q43', 'wp-admin/theme-editor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y\rrFQ', 'R9qُ7[]Z%h 3f?', '', 0, '?'),
 ('\n\rBp̭', 'wp-admin/theme-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6+s|ra', 'P3fߐ_[WI', '', 0, '?'),
 ('^[Xi	', 'wp-admin/themes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3O[ǓEѤ%', ']N	:@l>ct8+YaQ:CrT.', '', 0, '?'),
 ('7s\\]}AAwe1', 'wp-admin/tools.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r:fo\0VGr', ',w2чB\\oZiX\n#׀U', '', 0, '?'),
 ('!LT3ix', 'wp-admin/update-core.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(.GE]AJ{å', 'Аęφհ\Zm1;>(', '', 0, '?'),
 ('!o\rAv7e', 'wp-admin/update.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X8CPf~e', 'aE1l׮p%}0e	zcG', '', 0, '?'),
 ('^@ղ{\'_92', 'wp-admin/upgrade-functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[a@1.QZ', 'tˁ9{/yg1\'uVl', '', 0, '?'),
 ('j7r[,Z', 'wp-admin/upgrade.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IR:Ὗ	i^', 'Z Lbmpjָ?͛5--', '', 0, '?'),
 ('&t!0^gbJc,>3', 'wp-admin/upload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0V\'\"', 'O\0dǈҡ1j̠0જwW5m', '', 0, '?'),
 ('^9(-(Ųy 0q*', 'wp-admin/user/about.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!N 93nDl', 'rR89<;9i1lZQoC#Y', '', 0, '?'),
 ('1s)6ӶCΗ', 'wp-admin/user/admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T^1A|', 'Y%մ9N?\\v\\aM~݋', '', 0, '?'),
 ('~\r\ZK4(#', 'wp-admin/user/credits.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(팋#A;', 'uA+I/㊓\0nN1G8\ZD-', '', 0, '?'),
 ('R;lzO8m<3Nie', 'wp-admin/user/freedoms.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`U }\n', 'οzB+q5VlKlkZ/|', '', 0, '?'),
 ('[ꠏ|Koیb7', 'wp-admin/user/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xCS6LC2!u', '`Ky2Mplξ\"a\0אּtޡD', '', 0, '?'),
 ('y\0\"Q', 'wp-admin/user/menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zV', 'm\r)h0ECN`D[	$3', '', 0, '?'),
 ('\0lDdu^Y', 'wp-admin/user/privacy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dIU{x1A', 'FuX\0og:~h_5pt$', '', 0, '?'),
 ('`&X<aQVh\\', 'wp-admin/user/profile.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x8!xSj', 'Jfv^Dwۦ\nsBu/L', '', 0, '?'),
 ('=q\rljA+', 'wp-admin/user/user-edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<D\0\n#E', 'Xxno{\0\\䞿e[jZN', '', 0, '?'),
 ('Jh|0`ZpE', 'wp-admin/user-edit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U\r&*Ii~U', 'cCA\r_A\\V=(z', '', 0, '?'),
 (' *@ADғ=puE', 'wp-admin/user-new.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qwfƜ=Mrr\nd', '\Z2\0za\'\'؋ۍFmeNGc', '', 0, '?'),
 ('Pizta}a', 'wp-admin/users.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iǟYְu>', 'F#>[nn$&#:o!', '', 0, '?'),
 ('ThzPr', 'wp-admin/widgets.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Ng3\'c', '~	ol hmFr<YCM', '', 0, '?'),
 ('I:Bs#@', 'wp-blog-header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_BZF1y)', ';\Z/\\btI͝hw', '', 0, '?'),
 ('Sp>WrYE', 'wp-comments-post.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9\'$рZq2', '~+[%2+ꀌJFX\Z>b&', '', 0, '?'),
 ('~ťs\01y$L}h', 'wp-config-sample.php', 0, 'SӋh1', 'SӋh1', 'ꐐd`4	\\XLu$ǆŨdb', '', 0, '?'),
 ('vK;@saU1;	^', 'wp-config.php', 0, 'Ek{;kY]', 'Ek{;kY]', 'CH <42w ӊY|f߉)', '', 0, '?'),
 ('G}KW?dcŭ', 'wp-content/backups-dup-pro/20200208_frander_f6bb1414fce13c949773_20200208040505_installer.php', 0, 'V^IL\"', 'V^IL\"', 'c$tIIa?e\n!m\n_%\Z%w', '', 0, '?'),
 (')es%KME6B', 'wp-content/backups-dup-pro/20200209_main_c11a2dc19e35635d1153_20200209133358_installer.php', 0, 'f+$Xe/|\Z', 'f+$Xe/|\Z', 'LBa*\\xkKX55^', '', 0, '?'),
 ('8zD=&R*7', 'wp-content/backups-dup-pro/20200210_katysoccer_af4e5f31b5eb57e01658_20200210202208_installer.php', 0, '/ٴ', '/ٴ', '7)GKS۾Q%-W01', '', 0, '?'),
 ('MA\\IВ&n', 'wp-content/backups-dup-pro/20200211_kmikzeca_4184a572cd7a22612393_20200211203233_installer.php', 0, ')7ab<Z+gk\Z%', ')7ab<Z+gk\Z%', 'kQA؜=.f4-Mn˦l', '', 0, '?'),
 ('.BeET', 'wp-content/backups-dup-pro/20200211_lentes_d2b436c271b854844092_20200211191546_installer.php', 0, '=ՔvCB', '=ՔvCB', 'G\nNa7rq2{1-	ܙ', '', 0, '?'),
 ('E{]21}m', 'wp-content/backups-dup-pro/20200211_pizzeria_2cde327abf1ddb494204_20200211184356_installer.php', 0, '3)\rf', '3)\rf', 'ɫ6	Z&Ew9=W-f~@G\\', '', 0, '?'),
 ('OΚ-̅.n', 'wp-content/backups-dup-pro/20200212_alcaldiatomaslander_98d304ca2d1c4e5b5117_20200212155937_installer.php', 0, '4^nhZtJ', '4^nhZtJ', 'Kzcit\"QS1\0\'	!wd', '', 0, '?'),
 (')gU\Z%', 'wp-content/backups-dup-pro/20200212_asgo_cf9c79d958c039736352_20200212141130_installer.php', 0, '2a?XƸ[', '2a?XƸ[', 'h\ZBP-AAM٣ R}ظ;)', '', 0, '?'),
 ('KDIHPGU', 'wp-content/backups-dup-pro/20200218_insumosmedicos_b8f42bfefe12554c3364_20200218171440_installer.php', 0, 'ɒJ\nV\\:)', 'ɒJ\nV\\:)', 'aF̨hoA1\r;/', '', 0, '?'),
 ('P?&m', 'wp-content/backups-dup-pro/20200218_sitiodemo_24e790569362645b8626_20200218190134_installer.php', 0, '\'z) )l.9', '\'z) )l.9', '՜9dPHO2q*\r>', '', 0, '?'),
 ('i򨝁\Z5}\n', 'wp-content/backups-dup-pro/20200222_posadaeldoral_63437ef7253f3ad94829_20200222023647_installer.php', 0, 'W82ǵk', 'W82ǵk', 'FB|U8j`T\\bka~', '', 0, '?'),
 ('*4\\,&Ep', 'wp-content/backups-dup-pro/20200226_sitiodemo_753e55be1db2088e7340_20200226061206_installer.php', 0, '6D[ U3(f', '6D[ U3(f', '$]{$ۃ\"q$ʑpo\r.', '', 0, '?'),
 ('uaa9E\\	', 'wp-content/backups-dup-pro/20200227_beachtourmc_4e1e3fbd8d600e9c9692_20200227192539_installer.php', 0, 'o!ߓvm:', 'o!ߓvm:', '꽗fa}(,5|4\0}QܬX]!', '', 0, '?'),
 ('7t\rR+G~`cQ', 'wp-content/backups-dup-pro/20200227_fr8_8798135c5d576e5d1400_20200227110512_installer.php', 0, '_~B)R*7n', '_~B)R*7n', 'ϐ!M4n%*3*52K', '', 0, '?'),
 ('rLڲj', 'wp-content/backups-dup-pro/20200229_yates_7ee293fdb94d8d394049_20200229174222_installer.php', 0, 'cMxT?tI', 'cMxT?tI', 'n<\'7h%H3JQ8d', '', 0, '?'),
 ('x)Rb?f.', 'wp-content/backups-dup-pro/20200306_ssmadrerafols_77b17023f35b347e3834_20200306140338_installer.php', 0, '\r2\"|+W5-', '\r2\"|+W5-', ',3=[))wۥNl	h', '', 0, '?'),
 ('dD8rWVm#*', 'wp-content/backups-dup-pro/20200307_cargo_a20ee371ee5f686c4354_20200307033049_installer.php', 0, '&G0 rv^\Zja', '&G0 rv^\Zja', '̈́7A2]kD\0Ey6ypkI', '', 0, '?'),
 ('?Öt?K', 'wp-content/backups-dup-pro/20200311_tienda1_d133a3763f0571ba4547_20200311201812_installer.php', 0, 'Q[ഐ', 'Q[ഐ', 'I1~3/Ma\'m\"1_', '', 0, '?'),
 ('#tMi@fn', 'wp-content/backups-dup-pro/20200313_ssmadrerafols_4f02eeb96652c45b5118_20200313184439_installer.php', 0, ').<suE`', ').<suE`', '\'zȢ[>dF]-M\"', '', 0, '?'),
 ('anu1it', 'wp-content/backups-dup-pro/dtoken.php', 0, 'Z$ܱ?Nkn}', 'Z$ܱ?Nkn}', '\r\"=wF9	ą(`lG', '', 0, '?'),
 ('|̈*\'&m<', 'wp-content/backups-dup-pro/index.php', 0, 'Z$ܱ?Nkn}', 'Z$ܱ?Nkn}', '\r\"=wF9	ą(`lG', '', 0, '?'),
 ('N^#FՃp@f5\'', 'wp-content/backups-dup-pro/pizpa_60a6320ddb33add24042_20200210151611_installer.php', 0, 'WfĊ]D`D#S', 'WfĊ]D`D#S', '>|ɜF$n$!37놩C', '', 0, '?'),
 ('-^g̺@\0/', 'wp-content/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gD,V=\\bP', 'k~	UH\ZxPĀ<;X', '', 0, '?'),
 ('wi.w(M;0D', 'wp-content/plugins/akismet/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9|2-#', 'JS\\<Cޏ=s\'WI&\Z(vaTo', '', 0, '?'),
 ('I*:o', 'wp-content/plugins/akismet/LICENSE.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4MiHjJBc', '\0v1sN>cID٦I0-', '', 0, '?'),
 ('L\rȦ:nh\'', 'wp-content/plugins/akismet/_inc/akismet.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '״>/3', ':i\"R\"w`RIXL͖7ۉY', '', 0, '?'),
 ('̽ X$oB', 'wp-content/plugins/akismet/_inc/akismet.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's*O$9', 'Rͪ՛2$!F~eH`U', '', 0, '?'),
 ('<BʱA51ӱ', 'wp-content/plugins/akismet/_inc/form.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'4l*&i', 'MB1QwoX4bxc)@D˥k', '', 0, '?'),
 ('\'PT]	6~', 'wp-content/plugins/akismet/_inc/img/logo-full-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^K-^>As{', '%>:1WRͩQi~^G', '', 0, '?'),
 (')̃2kh! ', 'wp-content/plugins/akismet/akismet.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S-~E븜x5', 'y-d]`,5l9ox;', '', 0, '?'),
 ('jK&Y', 'wp-content/plugins/akismet/class.akismet-admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>`h4۵\'', 'ȳ(^zqp}ٳ?{.ՙGp', '', 0, '?'),
 ('f餧xMP]~B', 'wp-content/plugins/akismet/class.akismet-cli.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z qE9g:I', 'v26}۞\Z\nog$$@[C\\V', '', 0, '?'),
 ('H![?z>', 'wp-content/plugins/akismet/class.akismet-rest-api.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '⺅:K7&Z9Hc', '*F:Å=IH\'x\\\"\':', '', 0, '?'),
 ('lg<=l', 'wp-content/plugins/akismet/class.akismet-widget.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1O2e1rJj', '#TcxEyũH>', '', 0, '?'),
 ('pb~oBkZ', 'wp-content/plugins/akismet/class.akismet.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y#9ry\0ϭ', '\rˢ\ZNtAFA\r|?', '', 0, '?'),
 ('A$h՝`Qa', 'wp-content/plugins/akismet/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h PZݢ`Ef', '}5e33mhyDQ(', '', 0, '?'),
 ('o/d4x`', 'wp-content/plugins/akismet/readme.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ä1ϡ~Gϰ', 'st~n¢^2๙fV)', '', 0, '?'),
 ('!ۅ.4qdtP', 'wp-content/plugins/akismet/views/activate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{ETJ_qn', '·^\nbq<v`xKZW>Gw', '', 0, '?'),
 ('>Zbo&', 'wp-content/plugins/akismet/views/config.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ܥ&Fe@`', 'ۑ&\Z錷ې7~rb', '', 0, '?'),
 ('OKN\0Yn\"a', 'wp-content/plugins/akismet/views/connect-jp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sQX3', '\0.l>Wv&qv+IN~W', '', 0, '?'),
 ('\'\"znpaE', 'wp-content/plugins/akismet/views/enter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EGTA>sJ', 'FR<`=#izAgDd)q', '', 0, '?'),
 ('bE3g\'cZ (', 'wp-content/plugins/akismet/views/get.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ӵq\'7\0Y>', 'x[%@c', '', 0, '?'),
 ('Wd;C\rO', 'wp-content/plugins/akismet/views/notice.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(ﹴ~Co', '}GT@!QRm`+N*u6', '', 0, '?'),
 ('w#Q', 'wp-content/plugins/akismet/views/predefined.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#>ajϬa4', 'wsbN}qY7zoUu\'1', '', 0, '?'),
 ('}spK :', 'wp-content/plugins/akismet/views/setup.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eY]Z.^<&Un', 'G,|8i1<2,8+w', '', 0, '?'),
 (';;/JKmR0', 'wp-content/plugins/akismet/views/start.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qz\"\'\0\0Y7^kTj', '=P=ypyP*u]*', '', 0, '?'),
 ('sӣJ~k', 'wp-content/plugins/akismet/views/stats.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AFh`', '?O>uz/Aǚ	n5E-IGUh߳', '', 0, '?'),
 ('k8Q?<׊yp', 'wp-content/plugins/akismet/views/title.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XCN3|)-2Na', 'tCz n`j\rMN\"Ag', '', 0, '?'),
 ('dF=jHc', 'wp-content/plugins/akismet/wrapper.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']x\"YKJ', '\ZIa^iJH:j:b', '', 0, '?'),
 ('\0[^aD', 'wp-content/plugins/duplicator-pro/assets/css/images/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('vX<Y', 'wp-content/plugins/duplicator-pro/assets/css/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (' ]j+՜c-eKq', 'wp-content/plugins/duplicator-pro/assets/img/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('K?pk&&', 'wp-content/plugins/duplicator-pro/assets/img/logo-menu.svg', 0, 'm_46\ZYf.V+', 'm_46\ZYf.V+', '~@!nMK:]', '', 0, '?'),
 ('6JaiVt', 'wp-content/plugins/duplicator-pro/assets/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('l/@Uϣ^HJ', 'wp-content/plugins/duplicator-pro/assets/js/dp-kick.js', 0, 'RI{xd', 'RI{xd', '~V\']gfFOt^^7ш', '', 0, '?'),
 ('*s+cj', 'wp-content/plugins/duplicator-pro/assets/js/formstone/bundle.js', 0, '|]AeIg', '|]AeIg', 'ڹ)TF~Yj[_Q', '', 0, '?'),
 ('p2ݸi=uL', 'wp-content/plugins/duplicator-pro/assets/js/formstone/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('z8+RΫ(', 'wp-content/plugins/duplicator-pro/assets/js/handlebars.min.js', 0, 'ٞG.*U$#', 'ٞG.*U$#', '|@>A~ǥ^D<jw', '', 0, '?'),
 ('჉JEG?\'', 'wp-content/plugins/duplicator-pro/assets/js/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('p\rYZ', 'wp-content/plugins/duplicator-pro/assets/js/javascript.php', 0, 'pY(FD,', 'pY(FD,', 'ܯ|M~0~Yz76\"U9n', '', 0, '?'),
 ('MPtӦ폐s', 'wp-content/plugins/duplicator-pro/assets/js/jquery.qtip/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('5%}[#Ĥ//{', 'wp-content/plugins/duplicator-pro/assets/js/jquery.qtip/jquery.qtip.min.js', 0, '٫F\0Ǥw\0lVl', '٫F\0Ǥw\0lVl', '&h	$\\	.&iE:xK', '', 0, '?'),
 ('ӓ80ґ2', 'wp-content/plugins/duplicator-pro/assets/js/jstree/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('yWKa~\Z*', 'wp-content/plugins/duplicator-pro/assets/js/jstree/jstree.js', 0, '_hl ^I8<', '_hl ^I8<', '}L	0`|aQQ(;(ճ@', '', 0, '?'),
 ('[aɖy	`', 'wp-content/plugins/duplicator-pro/assets/js/jstree/jstree.min.js', 0, '`$G}΃L', '`$G}΃L', 'sV\'\\	-QI$꿐\"+΃', '', 0, '?'),
 ('77X\'e.+ķ', 'wp-content/plugins/duplicator-pro/assets/js/parsley.min.js', 0, 'z ;\'h%yR', 'z ;\'h%yR', 'W<{gvϺ4>tb9e', '', 0, '?'),
 ('<,ɨ\r.', 'wp-content/plugins/duplicator-pro/assets/webfonts/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('40w7{M', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Aws.php', 0, 'Fٖ\r1F	', 'Fٖ\r1F	', 'J܃~\0Fpwu	J1', '', 0, '?'),
 ('%}Pt.6fv', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/AbstractClient.php', 0, '`꼡u=3b>W', '`꼡u=3b>W', 'S2%.$[}A!', '', 0, '?'),
 ('޳kHޭH', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/AwsClientInterface.php', 0, 'c:X5P	', 'c:X5P	', 'WCOaT_](cUtau', '', 0, '?'),
 ('{ؙ`Mm~i<', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/ClientBuilder.php', 0, '0N>6Q', '0N>6Q', '^{^Zi<ڣw2ZY', '', 0, '?'),
 ('sdrD\rRb)R', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/DefaultClient.php', 0, 'p֪n;>B$!]', 'p֪n;>B$!]', '\"\nx,\\IJ-.!\'', '', 0, '?'),
 ('V$Xm)Ϳ&>', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/ExpiredCredentialsChecker.php', 0, 'c!uR\"Si ', 'c!uR\"Si ', 'Oh3!B[:\0(ԿS&4quTF', '', 0, '?'),
 ('oa3Km', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/ThrottlingErrorChecker.php', 0, '-|ѩW(', '-|ѩW(', 'Gg#/;>X=Mj_JL', '', 0, '?'),
 ('xĆ.LF', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/UploadBodyListener.php', 0, '`jQF[i_qIGY', '`jQF[i_qIGY', 'N&)3zf]9y7;2@T3', '', 0, '?'),
 (',p:ߌ*aX', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/UserAgentListener.php', 0, 'r4Jw', 'r4Jw', '!zkF7o~1M 3B\\w', '', 0, '?'),
 ('\Z	+\'q', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('y*{a{\0N', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/AwsQueryVisitor.php', 0, '\rE	pufM&7l)^', '\rE	pufM&7l)^', 'mZഔIbAyTe', '', 0, '?'),
 ('\\\0wzγX', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/JsonCommand.php', 0, '	hB^S*k', '	hB^S*k', '/VkF3tJ 95\r%oT', '', 0, '?'),
 ('LAF;^?', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/QueryCommand.php', 0, 'U_oǏ{', 'U_oǏ{', 'y޴-[!~v:.Z', '', 0, '?'),
 ('$8J8JGc', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/XmlResponseLocationVisitor.php', 0, 'bk!>~H', 'bk!>~H', 'Y6;mu16)0bcu', '', 0, '?'),
 ('sC(͊', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('jUscW<', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/AbstractCredentialsDecorator.php', 0, 'D5jY!V}\Z', 'D5jY!V}\Z', 'ǐ|x{Ŏ8Ro2Ir', '', 0, '?'),
 ('+etԐ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/AbstractRefreshableCredentials.php', 0, 'q7\0,N]5@z', 'q7\0,N]5@z', 'pvmhUȦ̪I1G;1nZOP', '', 0, '?'),
 ('Ԉ\Z=$', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/CacheableCredentials.php', 0, ')Ý0T@?M', ')Ý0T@?M', 'bweE07!An_=ڭjƑd', '', 0, '?'),
 ('YmA.\n(^ ֺ䀲', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/Credentials.php', 0, '=t.x^', '=t.x^', 'CS{\"&B:2UP+HS4', '', 0, '?'),
 ('>+]U?', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/CredentialsInterface.php', 0, 't%vxG<a', 't%vxG<a', 'Ke!Ur_,XYL<\Z', '', 0, '?'),
 ('Z rRzb6', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/NullCredentials.php', 0, '>g鰒E', '>g鰒E', 'w_Z3qMgAh%|@o16', '', 0, '?'),
 ('\n%m3D ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php', 0, 'E[ireGl', 'E[ireGl', '޽ `Zp%\0&޲8\nES', '', 0, '?'),
 ('ak(R,e', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\n5iJ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/ClientOptions.php', 0, 'g\'\'c |,', 'g\'\'c |,', 'O/?J=$|2t%.`Hj', '', 0, '?'),
 ('G˽lo7@', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/DateFormat.php', 0, 'gTÈ	N\Z', 'gTÈ	N\Z', '2`W(Ŭ.HM8i76\"', '', 0, '?'),
 ('=|B)S', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/Region.php', 0, 'Y.(8)N', 'Y.(8)N', 'RQM$Nj9E~0\rܩ^Ŀ', '', 0, '?'),
 ('\'e`{S', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/Size.php', 0, 'k		Gn', 'k		Gn', 'b?y\'n<T*_@ט`IǺV', '', 0, '?'),
 ('_.w.=r', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/Time.php', 0, 'נ#\rL~5P[&', 'נ#\rL~5P[&', 'I@W\n,8,zθ˘?a', '', 0, '?'),
 (' ,>p\"Z', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/UaString.php', 0, 'YΙ\'H<*ƨ8', 'YΙ\'H<*ƨ8', '>vn|@zFF4Y!nCzKl؟', '', 0, '?'),
 ('e 턀=x', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Hq/sH/', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum.php', 0, 'X~\\ҔrTZi/', 'X~\\ҔrTZi/', 'o%[q#_$\'KK', '', 0, '?'),
 ('Ox[', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/AwsExceptionInterface.php', 0, 'pQq.&q2', 'pQq.&q2', '@RV\\[Iڼ387dINSlF', '', 0, '?'),
 ('[ν\Z#FrX', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/BadMethodCallException.php', 0, '#õ&D$B', '#õ&D$B', 'V=6^aA\n3wf`', '', 0, '?'),
 ('fn枺\n\0', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/DomainException.php', 0, 'k8%y7v>', 'k8%y7v>', '2kLX\"zs7A,̍q}T', '', 0, '?'),
 ('֑x_@', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/ExceptionFactoryInterface.php', 0, '\'p$)˫', '\'p$)˫', 'V݉o:$oBVC:}{f', '', 0, '?'),
 ('Hs@o\r', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/ExceptionListener.php', 0, 'Jr9	(<\\7P', 'Jr9	(<\\7P', 'wR3q6]	eۊs', '', 0, '?'),
 ('q,Z\0dbzX', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/InstanceProfileCredentialsException.php', 0, 'l)<r~', 'l)<r~', '܆,+C:өac_c(0K', '', 0, '?'),
 ('gr3ZCg.', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/InvalidArgumentException.php', 0, '?5ӝwj1&£', '?5ӝwj1&£', '/CoNFւy&2saZyz1҈', '', 0, '?'),
 ('rQ\'Y&~', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/LogicException.php', 0, '-YH+Tʩ:', '-YH+Tʩ:', '\ro&Ϧi;K晖XDgkz?lVo\\G', '', 0, '?'),
 ('rRA:6J4.f', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/MultipartUploadException.php', 0, 'ƭ1PA\\', 'ƭ1PA\\', 'jXvLwG#5b܂GlRt6', '', 0, '?'),
 ('GyΤ.', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/NamespaceExceptionFactory.php', 0, 'JˆȐ_;k%L', 'JˆȐ_;k%L', 'o\r:vd͛KTD!{pMR;Xh', '', 0, '?'),
 ('!2~v<', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/OutOfBoundsException.php', 0, '<u5-U#', '<u5-U#', '߻iKdᇽm=/[l|gW\r', '', 0, '?'),
 ('Joxs5', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/OverflowException.php', 0, 'pUsaz\r!', 'pUsaz\r!', '(aJDe	\r0SV6}', '', 0, '?'),
 ('z41U}T1gcQ3', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php', 0, 'y4=R	9MCާp', 'y4=R	9MCާp', 'vo\'óiŷ=\'5\Z\'', '', 0, '?'),
 ('TfG~3', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php', 0, 'P\'c0-6l', 'P\'c0-6l', '[_P8*c\Zk(5\n', '', 0, '?'),
 ('NVg^Zck$', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/ExceptionParserInterface.php', 0, 'eH߁O', 'eH߁O', 'U:\"_	tT!t%@Eoy\\', '', 0, '?'),
 ('Ft#drR\\', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php', 0, '@ԽmsV$', '@ԽmsV$', 'K\0/NaY\0MT썿gq\"\n!-', '', 0, '?'),
 ('|\n^ᕿ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonRestExceptionParser.php', 0, '.sM\nZ1S', '.sM\nZ1S', 'LE{U,J-jy5&%\"', '', 0, '?'),
 ('sу?tXAdGj', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('fJ@2}a8`c9', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/RequiredExtensionNotLoadedException.php', 0, '25M\\p\0hR-', '25M\\p\0hR-', 'A\r.vHaLCߋ5rg䤖', '', 0, '?'),
 ('4au %A׫', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/RuntimeException.php', 0, '~T49MvPjB6', '~T49MvPjB6', 'T|pFCqj?jl4:', '', 0, '?'),
 ('VjRr]6', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/ServiceResponseException.php', 0, '/(R7', '/(R7', '0B]\rR;b\"6', '', 0, '?'),
 ('|_cd4\rz(d', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/TransferException.php', 0, 'I#\'Ti', 'I#\'Ti', '$Ox?VV#Jx>^\Zs', '', 0, '?'),
 ('Gɼ9wA{', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/UnexpectedValueException.php', 0, 'B:6mQϲ3@', 'B:6mQϲ3@', 'p֚\\OP@yԔï	', '', 0, '?'),
 ('CI<IjUQ\r^i$', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('P:ʡD(', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/Facade.php', 0, '͘<%ua(C_C', '͘<%ua(C_C', '2Ha,YZNr?I,u( ~,p)p[', '', 0, '?'),
 ('ʼ3?lU?7R(', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/FacadeInterface.php', 0, 'G_v\rdX&', 'G_v\rdX&', 'jf֩F]gNko', '', 0, '?'),
 ('	(LMCְJ#', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/facade-classes.php', 0, 'gF||igA	z', 'gF||igA	z', '>EŞOxEeo״rhtГlv', '', 0, '?'),
 ('i,2B^\0', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('`wg\Z\'\r~RJ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/ChunkHash.php', 0, 'bɫ柱/$', 'bɫ柱/$', ';Q/nNR5SC3ϧ}k&1	', '', 0, '?'),
 ('qu=y̐b', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/ChunkHashInterface.php', 0, '+ωâr9G', '+ωâr9G', 'c4Tڎ(okJ=wFV', '', 0, '?'),
 ('n(4߫', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/HashUtils.php', 0, 'jMV	O', 'jMV	O', '%Ҝs}ǁUu@\nfUl', '', 0, '?'),
 ('3	\"]Y~', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/TreeHash.php', 0, 'U>I\'y', 'U>I\'y', 'LZ;ge8:Ηv0 ', '', 0, '?'),
 ('ϧ?Kyh}', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('w\09J\np', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/HostNameUtils.php', 0, 'qnܗt2YiMh', 'qnܗt2YiMh', '<#p梑|~\'o*C?c', '', 0, '?'),
 ('>!oz<I', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/InstanceMetadataClient.php', 0, '%i\Zxgg7k', '%i\Zxgg7k', 'T tiYGQkfǋ', '', 0, '?'),
 ('64_G4', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php', 0, '<n]AaG|&', '<n]AaG|&', 'zQ\0\"#naŠ', '', 0, '?'),
 ('y=)8t', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\"ۥ⶷2UE**v,8', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\Z\\*9Z%x?', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIterator.php', 0, '|cg~', '|cg~', 'a14~\ZgA', '', 0, '?'),
 ('=\0Ww+ZQ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIteratorFactory.php', 0, '}.-^,UMXj', '}.-^,UMXj', '19֦Aܺ+#Jm77roq\r', '', 0, '?'),
 ('ښч4r١W', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Iterator/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('#slEU', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransfer.php', 0, '3:\rYLQ', '3:\rYLQ', ']*n2{s\\*LG[UuHi', '', 0, '?'),
 ('HFn;Ɣ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransferState.php', 0, '\r]o\r.nmA?', '\r]o\r.nmA?', 'IA67쐉g濥_дj/gN>', '', 0, '?'),
 ('cl)~', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php', 0, '*Dh\\臾cW', '*Dh\\臾cW', 'l|?\Zg?׀guZ,OG6xi', '', 0, '?'),
 ('ǸP!G;=k4F>', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadId.php', 0, 'Vt(x@nV', 'Vt(x@nV', '%D%c*^F\nlk\\_+', '', 0, '?'),
 ('07ȟዺO', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php', 0, '\naF!K', '\naF!K', '8-+(r\rLlZu\'}r', '', 0, '?'),
 ('vpzWp\Z-Nr', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferInterface.php', 0, '+f', '+f', 'y\"\\7CTdԲE61 *g', '', 0, '?'),
 ('p{aKlVk\\u', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferStateInterface.php', 0, 'ǖi1eRad4', 'ǖi1eRad4', '\"y#.Hml;`y SG9', '', 0, '?'),
 ('w+&*	^b,', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadIdInterface.php', 0, 'OJKumeR', 'OJKumeR', 'X_`w2frN*_>؄:g1w', '', 0, '?'),
 ('bo8]', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadPartInterface.php', 0, 'Ϻ|6bn', 'Ϻ|6bn', 'hvO/ZqՖ8Cl&\"', '', 0, '?'),
 ('K& *ODFM6', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('f\'mD@42Q', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('6ÎܚƹI:/\r*', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/aws-config.php', 0, 'w蚉7XGn', 'w蚉7XGn', 'rxw񜜦UMϦΤ7l', '', 0, '?'),
 ('tk(	oavſM', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('bHI/\0@', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/public-endpoints.php', 0, 'j\ra\'bC\n', 'j\ra\'bC\n', ':ТLr`N[dFŘ[K,', '', 0, '?'),
 ('2Tb8Y:·g', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/sdk1-config.php', 0, 'ڏ[j8zWh', 'ڏ[j8zWh', '^xX zm?iɹp\0R*I3W', '', 0, '?'),
 ('Di4t2Q&tݲ!0', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/RulesEndpointProvider.php', 0, '19SAY}TY', '19SAY}TY', '1\0\'k#yv[x(hm', '', 0, '?'),
 ('WDML!|-', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/AbstractSignature.php', 0, '#=10>u', '#=10>u', '%7l7 4[^&Vb', '', 0, '?'),
 ('i>;o6B	8', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/EndpointSignatureInterface.php', 0, 'Q`\'}oP狁', 'Q`\'}oP狁', 'G2\'fJIX!HSkj#$', '', 0, '?'),
 ('o+NC4x\rPRFw', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureInterface.php', 0, 'Ճ-<p3', 'Ճ-<p3', 'n/sj v縗5,5X݂CNEy\'.{', '', 0, '?'),
 ('fAloWjU', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureListener.php', 0, '`jd,\nƁ%$', '`jd,\nƁ%$', '4%LW/:FXvbU&%\'y[', '', 0, '?'),
 ('<6dUS)Ī', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureV2.php', 0, '1_\"NܕlY', '1_\"NܕlY', '%pul7,.ub#5Y7', '', 0, '?'),
 ('6:\Z}5l', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureV3Https.php', 0, 'ǨJdt1Xwƣ', 'ǨJdt1Xwƣ', '̦i%u@5 ?=sM΄', '', 0, '?'),
 ('+\\]A8~', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureV4.php', 0, 'b<St_&=', 'b<St_&=', '<JЕni_	\r?ׁ9])Z', '', 0, '?'),
 ('Wm\"n', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (']Ղ_^]5;', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/AbstractResourceWaiter.php', 0, '4(U$+ys\Z', '4(U$+ys\Z', '@T$r׭ڮspK#R\0]%K', '', 0, '?'),
 (':\"Ǥ3d`HJy', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/AbstractWaiter.php', 0, 'z\0i/PbG', 'z\0i/PbG', '׷@\r>fe̞PL#4', '', 0, '?'),
 ('X<lPZ&)w', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/CallableWaiter.php', 0, '+Wpq=-*6', '+Wpq=-*6', 'lE}@ӄ*p$mMisTU& ', '', 0, '?'),
 ('Eqw\0 TU ', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/CompositeWaiterFactory.php', 0, '#|S_yo', '#|S_yo', '|lgk6̙c5k', '', 0, '?'),
 ('=cPyE>J', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/ConfigResourceWaiter.php', 0, 'k<pA3d . ', 'k<pA3d . ', '#\"#ҧd9[spFo$0E', '', 0, '?'),
 ('n8#@ƕ/', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/ResourceWaiterInterface.php', 0, '͢ ~ϧ>OZ', '͢ ~ϧ>OZ', '\'Bvk}tZvv (+۵', '', 0, '?'),
 ('t-|JpyŚX]1', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterClassFactory.php', 0, '.=+t', '.=+t', 't\'J\\s\rtuھR}rfT:', '', 0, '?'),
 ('D줛J', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfig.php', 0, '|ZA>q\Z', '|ZA>q\Z', '	Nhc>\"%vǉ,r\Z$]	', '', 0, '?'),
 ('>j(74@Q', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfigFactory.php', 0, '&%d@a[', '&%d@a[', 'zߔ	}kWT#OcSm6:', '', 0, '?'),
 ('W=?yA', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterFactoryInterface.php', 0, '8کqS k', '8کqS k', 'f\ZL@NyWh=mH{Hcd7', '', 0, '?'),
 ('3!f^bmX', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterInterface.php', 0, 'wSUg&nF', 'wSUg&nF', 'I(;\'~.rو^r\"ew', '', 0, '?'),
 ('SRb})T', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('>P i|', 'wp-content/plugins/duplicator-pro/aws/Aws/Common/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('xe.$4N', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/AcpListener.php', 0, 'LT	N6', 'LT	N6', '*2!f<Sȅ%,', '', 0, '?'),
 ('4u;O3', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/BucketStyleListener.php', 0, '{33Qd', '{33Qd', '>\rԺYcH{f7yfi`ώ%', '', 0, '?'),
 ('a0l`h9^â', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Command/S3Command.php', 0, '/PuEk', '/PuEk', '~W5-b?F]K$^', '', 0, '?'),
 ('9\"L\0= ed)', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Command/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Xd7[|3;_S', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/CannedAcl.php', 0, '-+(FSLJ', '-+(FSLJ', 'J<?:)xdb4@	Kؓ', '', 0, '?'),
 (']OD[ρ\\', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/EncodingType.php', 0, '|ݾ4X0=', '|ݾ4X0=', 'd;~^iI(ɍT\0sX8', '', 0, '?'),
 (';C͛lс\0', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Event.php', 0, 'Isz2.-Ju', 'Isz2.-Ju', '4-?税g],\"-\rsd=nk!', '', 0, '?'),
 ('N$ltW', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/GranteeType.php', 0, '\"hP),;\rQ4', '\"hP),;\rQ4', 'RBq!J֖d˚@xUu֨Y', '', 0, '?'),
 ('eڨlXM', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Group.php', 0, 'RA\'M$\0d', 'RA\'M$\0d', '#n\\֨Jz~ogh)Au	o', '', 0, '?'),
 ('B,`@%O_<-', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/MFADelete.php', 0, '˪\0\0 P', '˪\0\0 P', '\0	\0N;J(N\"9JzS', '', 0, '?'),
 ('D{	H]뭺', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/MetadataDirective.php', 0, 'r	#!G\n', 'r	#!G\n', 'C`;.آ.Ea%Qvs', '', 0, '?'),
 ('XԖ@^T', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Payer.php', 0, '\rJ.JE7', '\rJ.JE7', 'B2zkeB$!m	އ>.\ZXp[e	', '', 0, '?'),
 ('_y68 ,', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Permission.php', 0, 'jpVx@`+', 'jpVx@`+', ' Fgp\\Qۡw;B{O+', '', 0, '?'),
 (';MQ=', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Protocol.php', 0, 'wTow6', 'wTow6', 'y=gRD[,N$G(q+Of', '', 0, '?'),
 ('Z2ɡdP', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/ServerSideEncryption.php', 0, 'BGވ4	', 'BGވ4	', '(f)wT0}0!lJ?(t', '', 0, '?'),
 (')N<ϒs`o', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Status.php', 0, 'tĻ,Ǌԓ', 'tĻ,Ǌԓ', '=L4SPUEpfE6+Y', '', 0, '?'),
 ('{ȵ(N+ΝK@', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Storage.php', 0, 'NY\\|sڛG', 'NY\\|sڛG', '&W-6F^6\ZtN&3Gx\0I', '', 0, '?'),
 ('4TDO', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/StorageClass.php', 0, 'rO\nԑd', 'rO\nԑd', ',IcWeR(0?A(,lO!8vD', '', 0, '?'),
 ('ς4q&)ƻ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Gq?47#', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/AccessDeniedException.php', 0, '	*uEt', '	*uEt', 'G\ZN9&ے~aUGvBæ\"', '', 0, '?'),
 ('֔ GuzDrڍ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/AccountProblemException.php', 0, 'ȍEM;', 'ȍEM;', 'mfF4w?K8U\Z$Q45я?_', '', 0, '?'),
 ('uaё*n\0	', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php', 0, '`iyԍ*O;}b*', '`iyԍ*O;}b*', ':+Yf\\йIu7I&', '', 0, '?'),
 ('lUܗ6_?\n(', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BadDigestException.php', 0, '%N\nAj#', '%N\nAj#', 'F2Q23<r/zZZ*}', '', 0, '?'),
 ('Qo\0&	f\0Q]wS;', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyExistsException.php', 0, '6=D\\(}4D', '6=D\\(}4D', '_ Ie:^3{Uv', '', 0, '?'),
 ('í!6&̏>\\', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php', 0, 'ο	\"0u<g.', 'ο	\"0u<g.', 'M[!J7]\"L!T#crKx+', '', 0, '?'),
 ('Ipr2ns8V', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BucketNotEmptyException.php', 0, '_o\0ɀv', '_o\0ɀv', '\nikW:j^\0	;=\Z', '', 0, '?'),
 ('A\Zg3ʡRشm', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/CredentialsNotSupportedException.php', 0, 'ϯ?WAS$', 'ϯ?WAS$', '\n\nCvE\"Ӫr\'꙼,', '', 0, '?'),
 ('Vs0: qc\"', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php', 0, '=vv4', '=vv4', '`6Dwҡ.FYs-U', '', 0, '?'),
 ('\nvW\0fU', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/DeleteMultipleObjectsException.php', 0, 'Id\'kKk', 'Id\'kKk', 'O\Z)&A\'m*\Z4SE&', '', 0, '?'),
 ('ǎ2\"W:w<Ζl3', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/EntityTooLargeException.php', 0, 'b14Ң<q՛', 'b14Ң<q՛', 'Ѻl+LiHy\'9', '', 0, '?'),
 ('d^#\0\r', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/EntityTooSmallException.php', 0, 'JJMbil$B_D', 'JJMbil$B_D', '9:SF@\\ɱ0`9d1', '', 0, '?'),
 ('RǋU-\"', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ExpiredTokenException.php', 0, 'Yv]{*N>zIDi', 'Yv]{*N>zIDi', '(\nb&#|@Hc', '', 0, '?'),
 ('OSl0sU\n', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/IllegalVersioningConfigurationException.php', 0, '_bX|Y\nE|ns&', '_bX|Y\nE|ns&', 'Z`،Bvn^8BQ$g=w%#', '', 0, '?'),
 ('	*YtW{n/C8', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/IncompleteBodyException.php', 0, 'W\Z[H\n,6/', 'W\Z[H\n,6/', '.mrWoI}*٨_U`', '', 0, '?'),
 ('E/Ԯ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php', 0, '}G]3WWۥ2', '}G]3WWۥ2', '\rrYɏ.g\0ujW@Z', '', 0, '?'),
 ('ݦPv[(`y', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InlineDataTooLargeException.php', 0, '<$}s$I-', '<$}s$I-', '4)vtsxeÊ!LYi	Acr҈iu\r', '', 0, '?'),
 ('&\0!_fN@ѓ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InternalErrorException.php', 0, 'u\rdۙ', 'u\rdۙ', 'J\\[@A	`i7;1\\F', '', 0, '?'),
 ('@3B(&3?r', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidAccessKeyIdException.php', 0, 'dL7˃~QeF', 'dL7˃~QeF', 'f}iah<8ʻIwV6ϛ', '', 0, '?'),
 ('{>]UL', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidAddressingHeaderException.php', 0, 'ڴ\\%ȷ*PlA', 'ڴ\\%ȷ*PlA', 'BcdoUfA!wꘔ]', '', 0, '?'),
 ('#1<9NΎc', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidArgumentException.php', 0, 'CI-ɲ', 'CI-ɲ', '_L<Dٻ9c7HsP|', '', 0, '?'),
 ('`f9S&۞', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketNameException.php', 0, '<egܧq!', '<egܧq!', 'BpEͯέ3e}p^.q', '', 0, '?'),
 ('N@gi!G', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketStateException.php', 0, 'hsV28T\'4', 'hsV28T\'4', 'sr\0,ø|} I5jA{', '', 0, '?'),
 ('ũC#yO', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidDigestException.php', 0, '%Vd=`RS', '%Vd=`RS', 'E}\0=KDeA', '', 0, '?'),
 ('=`#5?', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidLocationConstraintException.php', 0, 'S96RG+PC', 'S96RG+PC', '~p][+ƧI{2', '', 0, '?'),
 (':&?zZٯ9', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPartException.php', 0, '=<>`=:;pX1', '=<>`=:;pX1', 'PFH]9ôq\rDr64_v', '', 0, '?'),
 ('\rjکHh\0f4dy', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPartOrderException.php', 0, '\ZG\\4H?', '\ZG\\4H?', 'bhUOexAӌ0YA*', '', 0, '?'),
 (' nI.w:v]	', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPayerException.php', 0, '9%e%\rc9A', '9%e%\rc9A', '5k.9@gیf-}pi)(m', '', 0, '?'),
 ('diw+~\r:', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPolicyDocumentException.php', 0, '4{gJmvs', '4{gJmvs', '{y(	trm\ZȆ܌D|\\Єߐ', '', 0, '?'),
 ('e\02^', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidRangeException.php', 0, 'eJ#\"E\Z]', 'eJ#\"E\Z]', '\"BϡwM?jHi(~rԓd', '', 0, '?'),
 ('Qm<R{8X\\&', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidRequestException.php', 0, 'd8<>', 'd8<>', 'l HYSC.(;5WE_', '', 0, '?'),
 ('?H,dM瑰L', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidSOAPRequestException.php', 0, 'v\\3F@c', 'v\\3F@c', '<X\ZHα\Zo@c=XN+\\NGM', '', 0, '?'),
 ('\'ė\0zI<', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidSecurityException.php', 0, '%R)~Pvt8+', '%R)~Pvt8+', '˓CC=+㦺x? &k\0\"L', '', 0, '?'),
 ('\rAo%,W', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidStorageClassException.php', 0, '\0@m%B$Ά', '\0@m%B$Ά', '\'}!DM?,Aw=#L)1\0', '', 0, '?'),
 ('b/Pq;ŝv', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidTagErrorException.php', 0, 'k!@8b6', 'k!@8b6', 'UPdI]C#efVnmJYDq', '', 0, '?'),
 ('Z) =J', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php', 0, 'A_xzIi', 'A_xzIi', ';Y{jWaJy;\ZMʼ[', '', 0, '?'),
 ('0\0gwb?9', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidTokenException.php', 0, 'OAqQ\r\Z-$W^', 'OAqQ\r\Z-$W^', 't$?!]uĹ/DL_GzWLryK', '', 0, '?'),
 ('\r]vr$0', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidURIException.php', 0, 'iQ8h_S', 'iQ8h_S', 't!~@)`Č\Z,g)Q(', '', 0, '?'),
 ('@n[%JeiWn`', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/KeyTooLongException.php', 0, 'mG508', 'mG508', '9bG!&ߜPiid|Z', '', 0, '?'),
 ('-kL~h', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MalformedACLErrorException.php', 0, 'B!#', 'B!#', 'w\rr-푮VoKFB۪GMڞ', '', 0, '?'),
 ('`Wd7(E', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MalformedPOSTRequestException.php', 0, 'U:dj\n,JG:G', 'U:dj\n,JG:G', '\rS\"0GUT5GBP>9Z~', '', 0, '?'),
 ('GmiB<js', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MalformedXMLException.php', 0, '_fjwI>ib', '_fjwI>ib', '#\'T\ru䬡p){E4>	77l', '', 0, '?'),
 ('M`қ\"eH!:', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MaxMessageLengthExceededException.php', 0, 'N5j1m', 'N5j1m', 'E[%p\0p>4)ŗZ1#,r', '', 0, '?'),
 ('݌}ym', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php', 0, '/!?5J}hogԁ', '/!?5J}hogԁ', 'LׇDIF57\\zD|ZAd\r', '', 0, '?'),
 ('!c	9)', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MetadataTooLargeException.php', 0, '\'!L4\\wDcO', '\'!L4\\wDcO', 'x:koqf9KБ', '', 0, '?'),
 ('L?c\n}', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MethodNotAllowedException.php', 0, 'ÏG%HqN', 'ÏG%HqN', '*\rG/^WE*TI}\0+iۡ', '', 0, '?'),
 ('YƠ$NG;4', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingAttachmentException.php', 0, 'd־$ɟg', 'd־$ɟg', 'aѥu y3pF?k~Ǖ', '', 0, '?'),
 ('CLS}wrj3oJ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingContentLengthException.php', 0, 'Ja)|R`eQt', 'Ja)|R`eQt', 'O-˗ƚo0WLFW!y9l`.', '', 0, '?'),
 ('\nO&ꌿwK', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingRequestBodyErrorException.php', 0, 'sh쇂)Jh', 'sh쇂)Jh', 'P<T$Xg9]q+:y5QŲ7J%', '', 0, '?'),
 ('%x+&rQ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityElementException.php', 0, 'pƺ)]XZ4', 'pƺ)]XZ4', 'y\\<bB\0Ճ;7HK;', '', 0, '?'),
 ('\rDc*̲', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityHeaderException.php', 0, '^+s~N', '^+s~N', 'Z}H&%t\";݆?)|\\?a83S', '', 0, '?'),
 ('gW0C]M', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoLoggingStatusForKeyException.php', 0, '$kUs', '$kUs', '{up94ˡ_4LR,	2u4~y', '', 0, '?'),
 ('\\҃8dPWM', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketException.php', 0, '9zd\'BWn&', '9zd\'BWn&', '?l񲔾a?ZV,Jx:eO', '', 0, '?'),
 ('geFP9@4', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketPolicyException.php', 0, '[*ªU&@', '[*ªU&@', '80#i\nHҦ{AU,TŸck', '', 0, '?'),
 ('6$v\"+Dh', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchCORSConfigurationException.php', 0, ',$\"Ѵk', ',$\"Ѵk', '~QwCZK`\0o\n5', '', 0, '?'),
 ('{S{-P1\"N', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchKeyException.php', 0, 'GXʐ\"RӔ0=C', 'GXʐ\"RӔ0=C', 'Dh6t^.8-H\\+z-', '', 0, '?'),
 ('<|-NJ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php', 0, '\\-Rx;ۦ', '\\-Rx;ۦ', 'I16^,bhDDUh2\Z', '', 0, '?'),
 ('4~aldl', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchTagSetException.php', 0, '(MbSY(\'ց', '(MbSY(\'ց', 'Mi]zWӍ@', '', 0, '?'),
 ('J+,ړ[A^', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchUploadException.php', 0, '\rssW`6ٍ/', '\rssW`6ٍ/', '/12Y3I[A!X׿', '', 0, '?'),
 ('s*z!9|7\'l', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchVersionException.php', 0, 'R@yZ_', 'R@yZ_', 'wIin;r3&? :H', '', 0, '?'),
 ('Lkh-חCb[4[4', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php', 0, 'mm^V3Cl', 'mm^V3Cl', 'hUdkF\ZI9{>	<9', '', 0, '?'),
 ('g<նB', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NotImplementedException.php', 0, '?D\rv-', '?D\rv-', '/c<\rXՔ2\r$^@sQcb', '', 0, '?'),
 ('K\r)ڠĻՉ a', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NotSignedUpException.php', 0, 'ՀI Ͻ1hnKq', 'ՀI Ͻ1hnKq', ' p\ZopoHz\Zׇc`-l', '', 0, '?'),
 ('HL̜q', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NotSuchBucketPolicyException.php', 0, 'ۛ{W\0(', 'ۛ{W\0(', 'E4STAMCC9:񢑻	NNkeN)', '', 0, '?'),
 ('?mN>\nN', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php', 0, 'Plv?4I9', 'Plv?4I9', 'd챋>=K^?ij[+$E]J', '', 0, '?'),
 ('Ѿ|T>gF˾', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php', 0, 'Rer%>Vlh=e#', 'Rer%>Vlh=e#', 'tja@R(sJI4\"+z\'S', '', 0, '?'),
 ('c@SH[AHWL ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/OperationAbortedException.php', 0, '*N1EJJ#!ɪ', '*N1EJJ#!ɪ', '\0M+ۻ8ATy$\r', '', 0, '?'),
 ('\0ؒ_,Q', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/Parser/S3ExceptionParser.php', 0, '-G/wT{o4', '-G/wT{o4', ']]^W죟vSm|uR5', '', 0, '?'),
 ('Q/3w;', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/Parser/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ˉUkm@g_R', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/PermanentRedirectException.php', 0, 'mzY跄+&', 'mzY跄+&', 'DA	Md$2wuR>2$!%', '', 0, '?'),
 ('P&0߱DfN8', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/PreconditionFailedException.php', 0, '0Buj:ڊ', '0Buj:ڊ', '\\ұq\\11n+(ʯcic.?', '', 0, '?'),
 ('c*ψ	Xz:O', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RedirectException.php', 0, '˗.`i-ِ	', '˗.`i-ِ	', 'S0T.(4m3', '', 0, '?'),
 ('M*J`a5]', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestIsNotMultiPartContentException.php', 0, 'eܦ#c#R', 'eܦ#c#R', 'ɂX\\2i@rT3>', '', 0, '?'),
 ('=K n2*~', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestTimeTooSkewedException.php', 0, 'Z,#ҭ\'j}AD&,', 'Z,#ҭ\'j}AD&,', 'X-rn/v_^ވW$sCK', '', 0, '?'),
 ('K1bQ8', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestTimeoutException.php', 0, 'Z6q2VL*', 'Z6q2VL*', '2ekq:>qVKUtq9z', '', 0, '?'),
 ('F_ ]5:', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php', 0, 'O߮/ me0', 'O߮/ me0', 'YNMKXNC0\0.}IT{`=\nw&', '', 0, '?'),
 ('?\"+Z2Ph', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/S3Exception.php', 0, '`Ჰc߅', '`Ჰc߅', 'Ա\"UGLD߫\'r|d', '', 0, '?'),
 ('(|wD4)^', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ServiceUnavailableException.php', 0, '`\'1_k', '`\'1_k', '\Zw\n$}G&.|,KYigy', '', 0, '?'),
 ('\n	M7G	 \r', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/SignatureDoesNotMatchException.php', 0, 'nb-p&l?r5X+', 'nb-p&l?r5X+', '{/klSf=\rϱJll', '', 0, '?'),
 (':HFǪQI', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/SlowDownException.php', 0, '@R?bdb)', '@R?bdb)', ')s[>c}lnr$YU-Y1', '', 0, '?'),
 ('s*7\r|oLD', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/TemporaryRedirectException.php', 0, 'o9-\Z*Iutv', 'o9-\Z*Iutv', 'k_!+0vwYwpaI\r', '', 0, '?'),
 ('Qs\r\Z\\4I.', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/TokenRefreshRequiredException.php', 0, '(3>\'׮ ]', '(3>\'׮ ]', '1l\00|h\n-|hG{=̉', '', 0, '?'),
 ('i@$sƚ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/TooManyBucketsException.php', 0, '눃L֠gP6}y', '눃L֠gP6}y', 'h\Z{3:kSE]zB+ڂS', '', 0, '?'),
 ('w9\'M|F', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/UnexpectedContentException.php', 0, 'OcUoM', 'OcUoM', 'cG8J$(<]fa81*\0{$Ƀe', '', 0, '?'),
 ('y}^JRgyE%', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php', 0, 'r3D0z0u؊', 'r3D0z0u؊', '\'5 B\n<G͘.dn`eʒ', '', 0, '?'),
 ('*=8JB02', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php', 0, 'FZւ49', 'FZւ49', 'u3`!sܠN7m', '', 0, '?'),
 ('2euR0ZWÈ\0\n', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (':ә ۓqȤ\ZS', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/IncompleteMultipartUploadChecker.php', 0, '	6~\'	&`d', '	6~\'	&`d', ',22[ZrKd:nT]zHI\\', '', 0, '?'),
 ('0N15^ɬ%\ZfH͔', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListBucketsIterator.php', 0, 'XjqޓG', 'XjqޓG', 'Or3U8Y!蘠V\0H;', '', 0, '?'),
 ('[Qn mpG', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListMultipartUploadsIterator.php', 0, 'kki9+c(fr', 'kki9+c(fr', 'lX\rh>	\ZE#ֳM29RH26', '', 0, '?'),
 ('6\"ck;m$\rI', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListObjectVersionsIterator.php', 0, '\n\\UZZW', '\n\\UZZW', '~m-S$&ckx6x).\'D', '', 0, '?'),
 (':ۆGRuI\\x', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListObjectsIterator.php', 0, 'Xٚr;~n', 'Xٚr;~n', 'Mkd\"α!e:f\"[V', '', 0, '?'),
 ('J7*p\Z6R\'', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/OpendirIterator.php', 0, '~AxP\"#\Z5F', '~AxP\"#\Z5F', '\"8FH;p9:\Z0v]	\Z\0V', '', 0, '?'),
 ('EPwEң󾐷@', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('[c\\!ӣAZ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/Acp.php', 0, 'óܫ%MMڲ', 'óܫ%MMڲ', 'tOM;+Ӛhgn}_\nF^J[', '', 0, '?'),
 ('-T]x֬f=2', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/AcpBuilder.php', 0, 'JwS:tFn', 'JwS:tFn', 'xVӈBڽƌ5ҧTW^Jy|', '', 0, '?'),
 ('YI)\'ǎAe;', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/ClearBucket.php', 0, '`SƖ=', '`SƖ=', 'A&a_8%Z4a$%hB', '', 0, '?'),
 ('W2\Z-}', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsBatch.php', 0, 'X0Ο5`tVL\0', 'X0Ο5`tVL\0', '1m8μ/ءt\'jP-U\\', '', 0, '?'),
 ('~⟪\\ă곺\0\\', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsTransfer.php', 0, '-bi=\\d', '-bi=\\d', '^%fFPPӃx[q', '', 0, '?'),
 ('h\ZTir13,E', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/Grant.php', 0, 'ʥf.;?', 'ʥf.;?', '_MA\"x	#\0Y', '', 0, '?'),
 ('F\'6V#78', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/Grantee.php', 0, 'Jf)oP@4$', 'Jf)oP@4$', 'CCjQzܙ̻|.]sfS', '', 0, '?'),
 ('pK I_Ԓeo?', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/AbstractTransfer.php', 0, '+E7&', '+E7&', 'qߓ!2k)PAyꦤ', '', 0, '?'),
 (')yAQf5', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/ParallelTransfer.php', 0, 'SX4\01~Yo', 'SX4\01~Yo', '~aNXth̝+]', '', 0, '?'),
 ('EL)Ź3#i', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/SerialTransfer.php', 0, 'I]JVKѶwc7', 'I]JVKѶwc7', '0C9\\	mF@pҍy#OZ\r+w(', '', 0, '?'),
 ('Hr)', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/TransferState.php', 0, '@:\"\'', '@:\"\'', 'zW\0&0/:G-hBx+M', '', 0, '?'),
 ('HbM', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadBuilder.php', 0, 'U(i#:j<;W̷', 'U(i#:j<;W̷', 'zaԫ:XBqsэw|ޭߩiZ3', '', 0, '?'),
 ('ԹhlpZtrL', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadId.php', 0, '\'dK(;l%^`[', '\'dK(;l%^`[', 'oc#Rx>Ukq\n@?58ew', '', 0, '?'),
 ('o/ԓCHvY', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadPart.php', 0, 'X.qe,	', 'X.qe,	', 'o,PΎrsFKW͛{))', '', 0, '?'),
 ('䜲\ZP듩', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('< i1I', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/PostObject.php', 0, 'o/Tp+V', 'o/Tp+V', 'AlrXcϬ-݁2ym4caM`!&z\Z', '', 0, '?'),
 ('7*G~/rj', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('&C', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Resources/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('kյ~8w', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Resources/s3-2006-03-01.php', 0, ';f|]wצ4!ITq', ';f|]wצ4!ITq', '!Vk?w^Oo.u`Zz=l', '', 0, '?'),
 ('&\"f|ka', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/ResumableDownload.php', 0, 'c#\rp\"s\r\n\Z', 'c#\rp\"s\r\n\Z', 'uJq(,^؎%[ٕ9Z', '', 0, '?'),
 ('gSq!e', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3Client.php', 0, ';dAج,t+', ';dAج,t+', 'Za|߁=wlj߸U', '', 0, '?'),
 ('\"Ds+Q', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3Md5Listener.php', 0, 'Č̺d', 'Č̺d', '.L>#{\\kM->f\\E=	', '', 0, '?'),
 ('|fc7M', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3Signature.php', 0, '\0YAxHT', '\0YAxHT', 'JUXQQ.!¡1y', '', 0, '?'),
 ('9Ȕ\nrhטk2<', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3SignatureInterface.php', 0, '0\ZXcr', '0\ZXcr', 'nڛaKI9G5\'/U32B\'#', '', 0, '?'),
 ('S@k>T', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3SignatureV4.php', 0, '1(>މmU', '1(>މmU', '\0Op}jWQVS', '', 0, '?'),
 ('H8^K<p', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/SocketTimeoutChecker.php', 0, ',4YȦI_!k', ',4YȦI_!k', '	|a,0.oƯRAwLJ{', '', 0, '?'),
 ('V}מ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/SseCpkListener.php', 0, 't5}{uΩhQ', 't5}{uΩhQ', '\Z*	Eȯgf8#jUP', '', 0, '?'),
 ('xɷ_?|', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/StreamWrapper.php', 0, 'Yĝ|nm', 'Yĝ|nm', '7\rze]EN.4\\1LrFu9fH', '', 0, '?'),
 ('<٠Pso~z1', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/AbstractSync.php', 0, 'gxg.%G?', 'gxg.%G?', 'c5VO\0=\'>\rgim', '', 0, '?'),
 ('8A!ݑ9sy', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/AbstractSyncBuilder.php', 0, 'խuU7So6', 'խuU7So6', 'Zq)JYK[m>}G\"Z', '', 0, '?'),
 ('6>v%ϲ', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/ChangedFilesIterator.php', 0, '8ocK#\rAjC', '8ocK#\rAjC', '9QVl&3Y,٦i{\n͒ܳT', '', 0, '?'),
 ('!Kt~N{ `', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/DownloadSync.php', 0, '9VseU<', '9VseU<', '\\RC{V_U ]ȘΝ1U;', '', 0, '?'),
 ('r`x.d2', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/DownloadSyncBuilder.php', 0, 'ӡo˩݃W', 'ӡo˩݃W', '+{ƈ#}C *>i+<Zg', '', 0, '?'),
 ('La\'W\']2', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/FilenameConverterInterface.php', 0, 'vjdWM6', 'vjdWM6', 'iH]^8aי`@3+', '', 0, '?'),
 ('\'vL\ZC^', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/KeyConverter.php', 0, 'C8tevAR?S', 'C8tevAR?S', ')q5E~DZz\rI,u\"\n', '', 0, '?'),
 ('<7ɊD\"', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/UploadSync.php', 0, '\r)', '\r)', 'F~h[,bC3xf*^\0=', '', 0, '?'),
 ('(x4XxrzS', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/UploadSyncBuilder.php', 0, '`u&ţ?c', '`u&ţ?c', 'O7S/<IK0ќ798', '', 0, '?'),
 ('V/2#q', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('K~.7+P\r', 'wp-content/plugins/duplicator-pro/aws/Aws/S3/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\\齣\"j', 'wp-content/plugins/duplicator-pro/aws/Aws/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('19(Mdor\"`', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/AbstractHasDispatcher.php', 0, ';mjJ0853ti', ';mjJ0853ti', '6;dfʘGz+^zd1', '', 0, '?'),
 (';rQ0s.p', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Collection.php', 0, '.u305H}׀', '.u305H}׀', 'z<fg݆TE3kxQd23', '', 0, '?'),
 ('$`)ĳL$&x', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Event.php', 0, 'G@', 'G@', 'o]\\Kߠ`̐|EaқAÑ', '', 0, '?'),
 ('l5Ψs\rGmj', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/BadMethodCallException.php', 0, '\Z`#(c\ZQ', '\Z`#(c\ZQ', 'o8k7.JG.݋~yQ5e2', '', 0, '?'),
 ('hU8enªO,', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/ExceptionCollection.php', 0, ']:HM3T', ']:HM3T', 'v\\H>/=\\', '', 0, '?'),
 ('\\yٺOȇ^', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/GuzzleException.php', 0, ']ɡ}7S:<W', ']ɡ}7S:<W', 'Ѽov2+Ch6Xz\'p	/', '', 0, '?'),
 ('~C_ds\Z(', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/InvalidArgumentException.php', 0, 'z{P38.枆#i', 'z{P38.枆#i', 'U~/tB\\pyfKW@)4', '', 0, '?'),
 ('Nm7W4', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/RuntimeException.php', 0, 'Y@	:\"Ug\Z[', 'Y@	:\"Ug\Z[', 'GL˃M>c$CW', '', 0, '?'),
 ('rF)0mvqn	P', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/UnexpectedValueException.php', 0, ' 1;oKvOɹw', ' 1;oKvOɹw', '%t\"a˕4-Ev*s~D\rh7fQ', '', 0, '?'),
 ('\"tJR1n', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('O,K3m\"2#G', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/FromConfigInterface.php', 0, 't~[@J', 't~[@J', '[mII>OMKR', '', 0, '?'),
 ('hQT|V\r`', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/HasDispatcherInterface.php', 0, 'zX', 'zX', '$Qg->F3#YʚN{1{\\:\'hOݺ', '', 0, '?'),
 ('F3Yub|^8h', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/ToArrayInterface.php', 0, 'F}a?:Jd', 'F}a?:Jd', 'o(knhJI!]:My>', '', 0, '?'),
 ('ԑHΏt(=', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Version.php', 0, 'j2\Z\0Yr', 'j2\Z\0Yr', ':i;\Zt/\'_|Nd{u\'ovf7', '', 0, '?'),
 ('K>qC\0E', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('m:CŹ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/AbstractEntityBodyDecorator.php', 0, '\"2{%a', '\"2{%a', '*ZR	&A#!DrX.\\a', '', 0, '?'),
 (';,T\0a', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/CachingEntityBody.php', 0, '	? }#8F', '	? }#8F', 'HN}pеRF.PB*h!8', '', 0, '?'),
 ('4V', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Client.php', 0, 'F/g#q', 'F/g#q', 'D(pѝNu_e', '', 0, '?'),
 ('hIŜ7W~YQAzy', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/ClientInterface.php', 0, '@~|:O6', '@~|:O6', 'rw*uE~9E/Hmu,O\'fC', '', 0, '?'),
 ('FG\0\"oމJw', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlHandle.php', 0, 'z#	\0', 'z#	\0', '\rm~L\'E+=]2efpٷ6\"', '', 0, '?'),
 (',9f!K', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlMulti.php', 0, '0LNOڮ;h\n', '0LNOڮ;h\n', 'VO^NNH\'}V!@{l1䛵', '', 0, '?'),
 ('Nn`u c', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiInterface.php', 0, '[\Zk܌_iLMY', '[\Zk܌_iLMY', 'r[.3crI\rPX)4d07vC1s', '', 0, '?'),
 ('P{-eH]', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiProxy.php', 0, '8`Cy;K', '8`Cy;K', 'm^{\\[FB^,-~;kl,4', '', 0, '?'),
 ('GF.)lp~', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlVersion.php', 0, 'ND\rH', 'ND\rH', '\ZI`ӪcPA,̺ۚ_(', '', 0, '?'),
 ('㜃BXrL', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/RequestMediator.php', 0, 'O>G-:ִ[', 'O>G-:ִ[', 'Î/{$Ԝ{1򚨾Ii҃', '', 0, '?'),
 ('_Mub%', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('l\0\n7dq', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/EntityBody.php', 0, 'Ƞp&5,', 'Ƞp&5,', 'ME/`TFd},D͏ZVn\Z', '', 0, '?'),
 ('Jƒ-1', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/EntityBodyInterface.php', 0, '-)Md%Z?\0', '-)Md%Z?\0', '+{0O]g jM)s9DEO\Z', '', 0, '?'),
 ('\0Ɵk\rzP	ǈ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/BadResponseException.php', 0, 'X>GL6o\n', 'X>GL6o\n', '7	Ȯ.U7Ue`:5թ߁', '', 0, '?'),
 ('qg+N', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/ClientErrorResponseException.php', 0, '|ӸL鸂', '|ӸL鸂', '%a&ghCSp8]7^=', '', 0, '?'),
 ('K-4ݎ(LDfIp', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/CouldNotRewindStreamException.php', 0, 'L]~5s4Y!ZBY\0', 'L]~5s4Y!ZBY\0', 'AwA/ǌkj|$YMzJqFi', '', 0, '?'),
 (',~641', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/CurlException.php', 0, 'o SAL', 'o SAL', 'yhM#dFh4ԟh|\Zr', '', 0, '?'),
 ('\"rgM@', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/HttpException.php', 0, '\'gaUP0ӾL', '\'gaUP0ӾL', 'X़+}HuSBv@	Eۆi3s) 5', '', 0, '?'),
 ('G3MjVL-}', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/MultiTransferException.php', 0, '}4d	:2Cr(V', '}4d	:2Cr(V', '\Z;Ѓv#HsHҽ[Iro2Ò', '', 0, '?'),
 ('-+V1CPknB', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/RequestException.php', 0, '0>X<{:\Zވ	', '0>X<{:\Zވ	', '^xgz96G^q4', '', 0, '?'),
 ('Ey\"QL`', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/ServerErrorResponseException.php', 0, 'wt&qM{A', 'wt&qM{A', 'v;$xbnAxnmz,G\\_i', '', 0, '?'),
 ('\"fcH(yf!:n', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/TooManyRedirectsException.php', 0, 'OFM\n\Zv\nR', 'OFM\n\Zv\nR', 'H݃F:JJѴ\02ZE#o', '', 0, '?'),
 ('UD{eGH7', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('P(溃TB~g\Z', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/IoEmittingEntityBody.php', 0, 'aVլ9\'T{wm\'', 'aVլ9\'T{wm\'', '-\0,jl6 =]{E!!Mꔛ\\', '', 0, '?'),
 ('ohFv 7^', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/AbstractMessage.php', 0, 'e5Q<\'}_>', 'e5Q<\'}_>', 'B #S5\Zkbo?mܚ7[', '', 0, '?'),
 ('dEr>muc', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequest.php', 0, '̨~[gaʝ.K', '̨~[gaʝ.K', 'zׄ4bj،\Zi', '', 0, '?'),
 ('KB;A;B#', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequestInterface.php', 0, 'mv~ޕ d\'iBv', 'mv~ޕ d\'iBv', 'K7Q<QMbMӐwY:z', '', 0, '?'),
 ('KCvmZ$', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/CacheControl.php', 0, 'BnbuwHfPP', 'BnbuwHfPP', '\n\'\Zq4W.vJ7JI)/K', '', 0, '?'),
 ('A;U|', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderCollection.php', 0, 'G`=\n', 'G`=\n', 'ԊkԒ1ُnn\\p5G,Y<', '', 0, '?'),
 ('E	jPP,\" U', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactory.php', 0, 'd@G', 'd@G', '<eM! GbJP\n1˧5EApk', '', 0, '?'),
 ('W#<lo1', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactoryInterface.php', 0, '=9X =v6', '=9X =v6', '\Z\"npR&;W>W0s', '', 0, '?'),
 ('Uwt1z;', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderInterface.php', 0, '֧j', '֧j', ',\rL<n<pV.݋I*~<B2', '', 0, '?'),
 ('N}{`:6X)6', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/Link.php', 0, '-DYe%	OB{)', '-DYe%	OB{)', 'l\n9~)5P\'IS3nǠC.', '', 0, '?'),
 ('\0ӛ.ޤ\0', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (',^+I[Swl', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header.php', 0, 'JIa_)', 'JIa_)', '?.>(}EUI#DʽMc*', '', 0, '?'),
 ('ukYL9x\n', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/MessageInterface.php', 0, 'dB\\p', 'dB\\p', 'N#MIF_0xZbe\"\0lس&N֏	]:', '', 0, '?'),
 ('-%In\"2&', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/PostFile.php', 0, '5룢3T\ZϹirv%', '5룢3T\ZϹirv%', 'bAC;8[פ4˼E%;\Z', '', 0, '?'),
 (';?2\rL_lL׾', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/PostFileInterface.php', 0, 'J5@W##&', 'J5@W##&', '+qߥ3JKi9RSYǵ٢', '', 0, '?'),
 ('zvCEn', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Request.php', 0, 'E^Ta|#J', 'E^Ta|#J', '3/v	%*WfOդ', '', 0, '?'),
 ('18,!n\"fWFI', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/RequestFactory.php', 0, '6%:ް8', '6%:ް8', '3YfŒ鎎>^\',@uSc', '', 0, '?'),
 ('[xpKp', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/RequestFactoryInterface.php', 0, 'sp2=Dsx', 'sp2=Dsx', 'Lwo 䍖yΓk#鰖[Uy\0', '', 0, '?'),
 ('ۻטM0', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/RequestInterface.php', 0, 'ﮑ=TϺA', 'ﮑ=TϺA', '*l\'P`=:UG7[{b!D', '', 0, '?'),
 ('MWnVzQ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Response.php', 0, '+HdpfpflU%', '+HdpfpflU%', 'G?䘱7+A3G?Wxú{]R', '', 0, '?'),
 ('vPqǱ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('q輐T@`\0e', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Mimetypes.php', 0, 'ۺQ^h2R}', 'ۺQ^h2R}', 'C4M{`Q&v<~]', '', 0, '?'),
 ('kZ}x ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/CommaAggregator.php', 0, 'o;mEO;ͩc$Q', 'o;mEO;ͩc$Q', '}ja5P;Y)8R\\ṡ', '', 0, '?'),
 ('\ZlV', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/DuplicateAggregator.php', 0, 'lږbk@rc', 'lږbk@rc', 'fcyPUZ6@c&qh_M.Eg', '', 0, '?'),
 ('HC\0i*5!5', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/PhpAggregator.php', 0, '>.>.FQ', '>.>.FQ', 'D|	@A!;c}hf', '', 0, '?'),
 ('x`N2<', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php', 0, 'wIu>qSw,', 'wIu>qSw,', '\n$%xta%1{4(Kd䓧6', '', 0, '?'),
 ('\Z7(rmRh?C', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (',.ɎT+f', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryString.php', 0, '3b[$1^n(J3', '3b[$1^n(J3', 'ZU(.ca{m|[s?MO', '', 0, '?'),
 ('JE;b\'\ZuY1', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/ReadLimitEntityBody.php', 0, 'tŚ)4/XS-Ӈ', 'tŚ)4/XS-Ӈ', 'Z\reNWDo2C-ȣOSL', '', 0, '?'),
 ('(AL\"\0\nY ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/RedirectPlugin.php', 0, 'Xu*%', 'Xu*%', 'd.Tb\rҼ5v9wAA*?	f', '', 0, '?'),
 ('gVSc~p', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Resources/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Qoo:Y3', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/StaticClient.php', 0, 'H ژg', 'H ژg', 'rcy\'!*ts>\"84W~d', '', 0, '?'),
 ('[=^', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Url.php', 0, '2LykKt', '2LykKt', 'ҶKwFu{?]{H8h', '', 0, '?'),
 ('`&<D<:IkJ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\0曓!;w8k4', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/Inflector.php', 0, '9q@\0<Tq2', '9q@\0<Tq2', '2fF\' :;bZlREL~', '', 0, '?'),
 ('Aw&?E', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/InflectorInterface.php', 0, 'Z_&ߩ7by', 'Z_&ߩ7by', 'bΟy10G}ʁUaQ', '', 0, '?'),
 ('\\	O:NK R=_L', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/MemoizingInflector.php', 0, 'qm_2Y\"ձ', 'qm_2Y\"ձ', 'HRc\\X2_/-<6#{#y', '', 0, '?'),
 ('H%Md1c+', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/PreComputedInflector.php', 0, '/XFR[z:', '/XFR[z:', '[sy@8q3B%My\rH$(', '', 0, '?'),
 ('V2I=ZH4', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('瑑{	 Ǫ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParser.php', 0, 'ҿ2}X%iK', 'ҿ2}X%iK', 'F^R)g>ϡK:jX?PcD>T\"BIz', '', 0, '?'),
 ('d_!uydS', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParserInterface.php', 0, 'w̖pŁ', 'w̖pŁ', '4	Ir]}\'jretd4FuW\'', '', 0, '?'),
 ('gmHUfyjv', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Cookie/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('jS	$9X', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/AbstractMessageParser.php', 0, '41q^R\\z', '41q^R\\z', 'IL[RIylb+ ^͇U', '', 0, '?'),
 (',\'Eb`W%qgx', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/MessageParser.php', 0, 'ɅoNi0&', 'ɅoNi0&', '\0Bs5E҄C;N#Dgܖ\\g', '', 0, '?'),
 ('2\'VKeP:H', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/MessageParserInterface.php', 0, ' `h9', ' `h9', 'hN}pԿ+.oq7=SU', '', 0, '?'),
 ('\"q(S3j~w\n', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/PeclHttpMessageParser.php', 0, 'nYd!GpN', 'nYd!GpN', 'e	f///{e	x#<I\\', '', 0, '?'),
 ('E!BU2^&BS5y', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('t^]2kS', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/ParserRegistry.php', 0, 'вlDf>;C', 'вlDf>;C', 'Ōdo|fu)gE-ss:Id9&', '', 0, '?'),
 ('O9\r-Ѣ܁', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/PeclUriTemplate.php', 0, 'oUpmQ	', 'oUpmQ	', 'hv*[8A|khH1g|/;', '', 0, '?'),
 ('j	+WZ	)%', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplate.php', 0, 'btOt.c', 'btOt.c', '~Mܓ\"fKc5P}5SqM', '', 0, '?'),
 ('ݩr', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplateInterface.php', 0, 'Ҫ\Z\n8', 'Ҫ\Z\n8', 'qXLལfv3t-eP]H-V7!', '', 0, '?'),
 ('Qc\nA\'', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('T)qbˉqW/', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Url/UrlParser.php', 0, 'D{K3Ş', 'D{K3Ş', '@egX.P/!7HŲ2Mh', '', 0, '?'),
 ('j^YToA$', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Url/UrlParserInterface.php', 0, '[Ŋ(:KLk', '[Ŋ(:KLk', 'ThDoT:}:Ym5$\n', '', 0, '?'),
 ('z\0F}B?', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Url/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('^F\rJ@Y`', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('筘kR!etY\0!', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php', 0, 'jTysM\\', 'jTysM\\', 'JwdF疚>Y\rKB5vj\\<D΍', '', 0, '?'),
 ('@<̃˙dQ	I', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php', 0, 'H!t3', 'H!t3', 'Ub\Zv5{y	:%gf', '', 0, '?'),
 ('$HL=y|HK\0', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffLogger.php', 0, ']Q}`k^&$2+', ']Q}`k^&$2+', 'E3+S!;3@M', '', 0, '?'),
 ('qvt|7D	V', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffPlugin.php', 0, 'Bd&@]	', 'Bd&@]	', 'Wr̃=J&AdUe\"C0,*g', '', 0, '?'),
 ('\r)gf6VGV', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php', 0, 'd֫\"Z7', 'd֫\"Z7', '>RUwYȉf\'\'-', '', 0, '?'),
 ('D\rt0G 1', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php', 0, '\'@NB\r8xu', '\'@NB\r8xu', '9V^6.C<I,+=$', '', 0, '?'),
 ('Uu˕1', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php', 0, '|}n<MN', '|}n<MN', 'st܀>6\"B:)J:d축g*', '', 0, '?'),
 ('BrԶD', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php', 0, 'do͡=', 'do͡=', 'X@ǭ*%Lz8MK61i\nW', '', 0, '?'),
 ('N}<2WLL+', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php', 0, 'ImK?`', 'ImK?`', 'tQ(l0Ղ\\mUvH4-1ē1B', '', 0, '?'),
 ('rhcGM4JD', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php', 0, 'WAES[1F/', 'WAES[1F/', '1Lf\0)K[~xJO\\uB^', '', 0, '?'),
 ('!@x>^$', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php', 0, 'Y6<оE^_iH', 'Y6<оE^_iH', '\'d;i۝U*LQQ	Xhi6&<', '', 0, '?'),
 ('\0pBTXVLI', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php', 0, 'ި{hLߕ%', 'ި{hLߕ%', 'B4	\'ts_+VвڔEs', '', 0, '?'),
 ('e0 Ïgi\\', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php', 0, 'L0>n', 'L0>n', 'EjFFm;wfKn(G', '', 0, '?'),
 ('^, NQ@H\0P', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('5(L0AA[_', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/AbstractConfigLoader.php', 0, 'WG	=7T K', 'WG	=7T K', '? }\rtJ\0ic͇F4k@', '', 0, '?'),
 ('״	RIң', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilder.php', 0, 'Öe6x[_S', 'Öe6x[_S', '?O8>|[}?l<)', '', 0, '?'),
 ('`mR;J>WK', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderInterface.php', 0, 'tM;yXKKz', 'tM;yXKKz', ')bDdal˟+L', '', 0, '?'),
 ('	AW!I', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderLoader.php', 0, 'J[֣\Zxf#', 'J[֣\Zxf#', 'ÝC_iG*~!n', '', 0, '?'),
 ('\n]KǪ\0AG', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('3`M9傠W', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/CachingConfigLoader.php', 0, 's<4=S0$', 's<4=S0$', '\r.%\'H/h׉V} *AA\\b', '', 0, '?'),
 ('7cff&&', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Client.php', 0, '\"Bȣ_/jF', '\"Bȣ_/jF', 'ۓyD\'Ij}v,\nņ	a\0oe', '', 0, '?'),
 ('S\nh쿋U', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/ClientInterface.php', 0, '\Z4;[', '\Z4;[', 'xeo-O.Ip27', '', 0, '?'),
 ('{5}<Y+', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/AbstractCommand.php', 0, 'w\nCT{H', 'w\nCT{H', ' ɂ=a,\nU5d1tX«^-(', '', 0, '?'),
 ('`\r./F6N(jo', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/ClosureCommand.php', 0, '!Bj$', '!Bj$', 'ԶMސ#>\0`V)Af4I', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('/I	Ǖ(İd͍', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/CommandInterface.php', 0, 'kGs]O|lT#', 'kGs]O|lT#', '1$څJ*kJl=	[Am*	', '', 0, '?'),
 ('HSp}|', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/CreateResponseClassEvent.php', 0, 'K<z=07SRÊ', 'K<z=07SRÊ', '^j6	|Nt9b֝', '', 0, '?'),
 ('^r$HO-', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/DefaultRequestSerializer.php', 0, 'D;m/TgDs5tt', 'D;m/TgDs5tt', ']pI&\'1MIB;n+a!', '', 0, '?'),
 ('\'jx;YQ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/DefaultResponseParser.php', 0, '~!r)בW$-p', '~!r)בW$-p', 'j#=\"N9XIB1\nC˕1H}lE', '', 0, '?'),
 ('j%|', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/AliasFactory.php', 0, '|3KVDd', '|3KVDd', 'S{O3;}C	ajn2', '', 0, '?'),
 ('wI(4nã$o􇟎', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/CompositeFactory.php', 0, '{wa \0ɭ', '{wa \0ɭ', 'n&ڋ#=NH!\0RR5', '', 0, '?'),
 ('z\\+AI', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/ConcreteClassFactory.php', 0, 'q㬎S\Zվf', 'q㬎S\Zվf', 'IPr\Z,OS7;۰C=\"', '', 0, '?'),
 ('+\"쌙MvB', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/FactoryInterface.php', 0, 'Yz\"J_5$[P', 'Yz\"J_5$[P', '72z/lP(_P?\"XA(', '', 0, '?'),
 ('vEy؃\0&<', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/MapFactory.php', 0, '\'6L|7', '\'6L|7', '2؈WHsiuK(U', '', 0, '?'),
 ('1y1w 	\Z0#', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php', 0, 'Tڟ(@fpg', 'Tڟ(@fpg', ',{:FB_ivZ6ub	', '', 0, '?'),
 ('źg\0)W:+', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('maw=gH9', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php', 0, '={N3.,', '={N3.,', 'Wl,FMRN\ZBkw^|Nƫ', '', 0, '?'),
 ('9Ȓ\\fS', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php', 0, 'Ñ\ZW僫', 'Ñ\ZW僫', 'Iw)41T-Z$[[A', '', 0, '?'),
 ('bAQa:(\r', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php', 0, '`m{U#he', '`m{U#he', '\r5\08Ź_~@<Ko%R|_zAY', '', 0, '?'),
 ('M/~GSO', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php', 0, 'sχr}O;6', 'sχr}O;6', '7`ZN|ao\'9Wv&o', '', 0, '?'),
 ('&98>e=R', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php', 0, 'Za)֞rV', 'Za)֞rV', '\nSTx){$gd	|d<|', '', 0, '?'),
 ('4D jzA.', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php', 0, 'd礲	F2%\\d`', 'd礲	F2%\\d`', 'N١ҍIj\0Ɋl J!ya-', '', 0, '?'),
 ('e㎔-0', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php', 0, '\Z\'^NW%wdI', '\Z\'^NW%wdI', 'lhț;͘Y_ |Cn*@', '', 0, '?'),
 ('ed5W9', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php', 0, '.(!>An#<G', '.(!>An#<G', '{LYVr?O室\\ض\0', '', 0, '?'),
 ('U+_g\\m', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php', 0, '9t\ne]K~,', '9t\ne]K~,', 'EF2s/`\n]XǋkȺz={I', '', 0, '?'),
 ('~$n}T\n', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php', 0, 'B&7vs,.', 'B&7vs,.', 'hbA5)\n}S', '', 0, '?'),
 ('q&!X87N^Tj', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('jYm/t	j', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php', 0, '}eeUXN*$T', '}eeUXN*$T', '\Z	4$T\\O~K=4Kj߇\\\n	', '', 0, '?'),
 ('M(/*%K??oy', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php', 0, 'ݬq]bsZ{\Zj', 'ݬq]bsZ{\Zj', '/}n?L\ZO}G4w%t{a', '', 0, '?'),
 ('HGnOtmF^', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php', 0, 'N%ZR9f', 'N%ZR9f', '%r\nKaUdd#z5Z', '', 0, '?'),
 ('!m8*!s', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php', 0, '$ʧXTU', '$ʧXTU', ':7^h%̼8\ZrYZ!+', '', 0, '?'),
 ('5H 0a', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php', 0, 'Yxvs5{`$', 'Yxvs5{`$', '}0˯r̲]4TETL-', '', 0, '?'),
 ('ӄК<L', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php', 0, '\'3T-Noa2', '\'3T-Noa2', '_r}KuGbufe/wΜgmXO', '', 0, '?'),
 ('׃\'F]:_', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php', 0, 'qp)JiDs', 'qp)JiDs', 'OOɫ͚jTBIt1x`\r$q', '', 0, '?'),
 ('W0eYk;', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php', 0, 'tzѸڶB~R+', 'tzѸڶB~R+', '?<6\0#Q!=h혪', '', 0, '?'),
 ('}wڅAdipE,.', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (';\ZE+Y', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php', 0, '`._?&\'h', '`._?&\'h', 'A\Z6\ru\'IbXU[#t#\'t', '', 0, '?'),
 ('cu\'f0i*', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Zʂ{>y^5', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/OperationCommand.php', 0, '`2t#2 ', '`2t#2 ', 'x^#E7碭YY#\r-wMOQQ', '', 0, '?'),
 ('t]w\Zw,', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/OperationResponseParser.php', 0, 'AJ0	B[', 'AJ0	B[', 'b;ȾRXo\'վ]\'&K\r߳}', '', 0, '?'),
 ('kA쿖bm@W%', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/RequestSerializerInterface.php', 0, '~]\'p}A=05V', '~]\'p}A=05V', '$T[$NMNe\rU6pBޯ', '', 0, '?'),
 ('7\"e#y _', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/ResponseClassInterface.php', 0, '2tLc_ܓ', '2tLc_ܓ', 'O~GCs*󽿺3U`E', '', 0, '?'),
 ('sZܙWP', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/ResponseParserInterface.php', 0, 'JVO_fL', 'JVO_fL', 'E38zݤude?\\', '', 0, '?'),
 (']ע!4+i\"', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('heƠqrR\n/K', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/ConfigLoaderInterface.php', 0, ',ң]/$P^j3Ѧ', ',ң]/$P^j3Ѧ', 'I:l\ZGQlnՓIi5+', '', 0, '?'),
 ('9\nR3c	', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/Operation.php', 0, '\'j`Q<rkkA)=', '\'j`Q<rkkA)=', '0?^|zT*$||DVB\rcU`', '', 0, '?'),
 ('۽~bkԑ\0N@', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/OperationInterface.php', 0, 'W	+.@X\rl', 'W	+.@X\rl', '7jlgZS\'Bƪ+&\\}S', '', 0, '?'),
 ('4w:X|\\!MnN', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/Parameter.php', 0, '\\fIQ17A', '\\fIQ17A', 'ISVڧ\Zc:&\\7پ8c|', '', 0, '?'),
 ('JEþ#9)d', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/SchemaFormatter.php', 0, '_˥ v׫l\Ze', '_˥ v׫l\Ze', ' ;c:׊I7 /3nm', '', 0, '?'),
 ('R%$1Nű17\\', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/SchemaValidator.php', 0, '-G7|', '-G7|', 'VPDI)]Ћ7:.StL', '', 0, '?'),
 ('rc입$0d', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescription.php', 0, 'm 2\Z', 'm 2\Z', 'pImC0\r}=BG	@+Ş', '', 0, '?'),
 ('bl&', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionInterface.php', 0, '/B', '/B', '#YgNw\'@\"?', '', 0, '?'),
 ('S=tQmʄ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionLoader.php', 0, 'af3a,T', 'af3a,T', ')Q0.spE#hP/vM,\nW~', '', 0, '?'),
 ('6dlE#(qM\\C', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ValidatorInterface.php', 0, 'Hc?[Ӟ\ZD', 'Hc?[Ӟ\ZD', '\Zy)6\n!}eZ)`CFa@2ͷ;w', '', 0, '?'),
 (']*	F\'', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Qosxݽ#i', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/CommandException.php', 0, '{WӲ@{}[_', '{WӲ@{}[_', 'F|D\Z*l\0HV<`\Z\'A6g\0', '', 0, '?'),
 ('RUo7#.1', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/CommandTransferException.php', 0, 'Ei!*3r(H', 'Ei!*3r(H', 'NNT~(E~olfًn\Z	', '', 0, '?'),
 ('E\n,x}', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/DescriptionBuilderException.php', 0, '2IL} qrUR5', '2IL} qrUR5', '7\'\\s̅؍Δ8\ri', '', 0, '?'),
 ('<\'3t/_', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/InconsistentClientTransferException.php', 0, 'H5_v:', 'H5_v:', 'g\0~ϵ!t~FBD@!ɏ', '', 0, '?'),
 ('MXu(	@ ', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ResponseClassException.php', 0, '`W-vZj\0(R~', '`W-vZj\0(R~', '5&ÝO\04CD\n0\'S', '', 0, '?'),
 ('@$x Yc\r', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ServiceBuilderException.php', 0, 'A9Ch?_?S', 'A9Ch?_?S', 'ӊ\r8ܢ?5UŸqn', '', 0, '?'),
 ('d~GKٹգ`$/', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ServiceNotFoundException.php', 0, '2M$0\"9=', '2M$0\"9=', 'XAe{S`;.\n -', '', 0, '?'),
 ('3\n.', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ValidationException.php', 0, 'D+FN-', 'D+FN-', '5\Z]K/0=@oYl/߱k', '', 0, '?'),
 ('vo`̃', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('zڰֵ47P;', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php', 0, '_r|.ؾQi}\0)4', '_r|.ؾQi}\0)4', '&/@~	p)ƈ5\"0T+', '', 0, '?'),
 ('wǲMbO', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php', 0, '@nҷ\Z@2{Uz', '@nҷ\Z@2{Uz', '䧕e#	Ȯ\nz+MLP!p_Kr', '', 0, '?'),
 (';&X<;3hqZ,&!@', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/MapResourceIteratorFactory.php', 0, 'h', 'h', 't5\Z˜ۛ\'	Zi`v܉g+ť', '', 0, '?'),
 ('yF3A1Eș<\"', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/Model.php', 0, '\'W\0TOKW', '\'W\0TOKW', '`Ӱ )כ*̵\Z-{]g', '', 0, '?'),
 ('*(kEsI', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIterator.php', 0, '^᫅}Z~jK}', '^᫅}Z~jK}', '$R5ާqM>SDg\ZX', '', 0, '?'),
 ('pz	e޴pg', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php', 0, '\\A]5̡R2', '\\A]5̡R2', '\'hR<I1gYoDLs|ۢ\"9', '', 0, '?'),
 ('tZc5Jpx', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorClassFactory.php', 0, '#H;UNVNId', '#H;UNVNId', ']g#CPg#pK-y-ݖ', '', 0, '?'),
 ('nҍD@&', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php', 0, '_\\ޛ#zbY', '_\\ޛ#zbY', 'mݩuVGxapr', '', 0, '?'),
 ('_ۛq9te|!', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorInterface.php', 0, 'S\\2?b', 'S\\2?b', 'qӞm`zJ<\0(x=', '', 0, '?'),
 ('CZu\rUMM', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('?+ƂOqI', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('M)ypՉ.', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/PhpStreamRequestFactory.php', 0, 'qy<@9u$C', 'qy<@9u$C', '\"W\ZXD(ʭߎ (UV.qJ', '', 0, '?'),
 ('eHREW1\r)\"-', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/Stream.php', 0, 'g<kiZQzA', 'g<kiZQzA', 'f&L_CZh\Z@څQON?\r\n', '', 0, '?'),
 ('Pæq;SQb(j', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/StreamInterface.php', 0, 'Ĉa', 'Ĉa', '7kVI\Z5ya\"?G=	XYC', '', 0, '?'),
 ('/fw\"k)CcV', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/StreamRequestFactoryInterface.php', 0, '-dr6gTz=', '-dr6gTz=', '!l\0=XTauZS', '', 0, '?'),
 ('(]:\0mmq', 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ufM\\?M~°Bm', 'wp-content/plugins/duplicator-pro/aws/Guzzle/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('LX|[з6', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/ContainerAwareEventDispatcher.php', 0, '\rϔs.6̇a ', '\rϔs.6̇a ', '(*@4Yٝ\0X֊Ʀ:p', '', 0, '?'),
 ('G23rr{[<f', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/RegisterListenersPass.php', 0, '{!Ń&G3', '{!Ń&G3', 'mO5C&ܑf(Mjy\"#', '', 0, '?'),
 ('\\z7¨PcTH', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('UN,tc$f֒_', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/Event.php', 0, '.\r*^{L', '.\r*^{L', '\"=Чk&?\\e}oVfs6/2ĬW', '', 0, '?'),
 ('#oIj\0ڏ', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcher.php', 0, 'yno]8:~\0', 'yno]8:~\0', '	=vOi%IA\n=(R', '', 0, '?'),
 ('ԣtX', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcherInterface.php', 0, '	p<,>@(NJ>\Z', '	p<,>@(NJ>\Z', 'kBp]Ƹ/>\rhsw', '', 0, '?'),
 ('\"\nY$)M', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventSubscriberInterface.php', 0, '\rySZy5', '\rySZy5', 'x&NEfӻcl3!ac,', '', 0, '?'),
 ('w1PَS', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/GenericEvent.php', 0, 'i&a_B>/', 'i&a_B>/', '͓I$Ppf\Z!;/{=o<', '', 0, '?'),
 ('wٚOf', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/ImmutableEventDispatcher.php', 0, 'u\r\nL<h', 'u\r\nL<h', 'pn=߂}	$^vZI	yV2E', '', 0, '?'),
 ('3>JIkz]c', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('dƨ\"(GG^#ߙT', 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('5Ǆ\"P>K', 'wp-content/plugins/duplicator-pro/aws/Symfony/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('(V:|Pɤ7', 'wp-content/plugins/duplicator-pro/aws/aws-autoloader.php', 0, 'Jd\ntP=H龜', 'Jd\ntP=H龜', ' X\ZJosBY \0.Q<O', '', 0, '?'),
 ('+lL.-oNl7', 'wp-content/plugins/duplicator-pro/aws/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('XJWYky>aQ', 'wp-content/plugins/duplicator-pro/classes/class.archive.config.php', 0, ';\'C 颠!\n$o', ';\'C 颠!\n$o', 'W+8|w5kRT4~X', '', 0, '?'),
 ('Y2|46\n', 'wp-content/plugins/duplicator-pro/classes/class.constants.php', 0, 'xfRO<,$=n+', 'xfRO<,$=n+', '8_UP_P)_יI۴O4', '', 0, '?'),
 ('ިVzrvlD)', 'wp-content/plugins/duplicator-pro/classes/class.crypt.blowfish.php', 0, '\ZsBd', '\ZsBd', 'J*^\nZL{j.	[\Zg?+k\0	Y', '', 0, '?'),
 ('Ncai2', 'wp-content/plugins/duplicator-pro/classes/class.crypt.custom.php', 0, '_״z<P', '_״z<P', 'R+H*\ZRd!lfYO)a', '', 0, '?'),
 ('[,FEnXY+T?', 'wp-content/plugins/duplicator-pro/classes/class.db.php', 0, 'P_+OM濁]', 'P_+OM濁]', '[4̏kY18F%#DԅX_', '', 0, '?'),
 ('Nn̖;Y#', 'wp-content/plugins/duplicator-pro/classes/class.enhanced.plugin.updater.php', 0, 'p\nU\'|p{N', 'p\nU\'|p{N', 'N2rzC),y[_2h	\'z!΋|m', '', 0, '?'),
 ('v,xGbX', 'wp-content/plugins/duplicator-pro/classes/class.exceptions.php', 0, ' ^p\'bNŬO\\', ' ^p\'bNŬO\\', '\"L<SN6v8IbW칫%[0', '', 0, '?'),
 ('EF_C ari', 'wp-content/plugins/duplicator-pro/classes/class.io.php', 0, 'QUߟ30', 'QUߟ30', 'qׇpJz±Qngߛ', '', 0, '?'),
 ('3kz/T.te', 'wp-content/plugins/duplicator-pro/classes/class.logging.php', 0, 'Utu#|bB', 'Utu#|bB', '-(7t90XqM<|Pn-k', '', 0, '?'),
 ('~%s賣C]O]uh', 'wp-content/plugins/duplicator-pro/classes/class.package.pagination.php', 0, '3NҊ{%', '3NҊ{%', 'OH0k4wQܰnd+^UO', '', 0, '?'),
 ('H:|tۧ', 'wp-content/plugins/duplicator-pro/classes/class.password.php', 0, '<B}k', '<B}k', '\nʢH\\lɭlqK]^I\0w;', '', 0, '?'),
 ('\ry9Ot@4', 'wp-content/plugins/duplicator-pro/classes/class.php.log.php', 0, '	>\nXιjr', '	>\nXιjr', '.cB!.H	dG׫?Gr', '', 0, '?'),
 ('oaEpodHn}', 'wp-content/plugins/duplicator-pro/classes/class.scan.check.php', 0, '@Q;`@; ', '@Q;`@; ', 'J!Qp9+|Kw\\yIY6ĨK:k', '', 0, '?'),
 ('(ie_o6m5+', 'wp-content/plugins/duplicator-pro/classes/class.server.php', 0, 'lg/ĳdz9[', 'lg/ĳdz9[', 'GD\'3C_	`KDlB[	%\0', '', 0, '?'),
 ('2],8X\\=', 'wp-content/plugins/duplicator-pro/classes/class.system.checker.php', 0, '	ek(yv3', '	ek(yv3', '#}Q1|%|<ORcb&\\Oy', '', 0, '?'),
 ('nVD6;', 'wp-content/plugins/duplicator-pro/classes/class.wp.list.table.php', 0, '^O3-S', '^O3-S', '?ƦHI4&ROp&1n/_8`jQm', '', 0, '?'),
 ('Y$_ ', 'wp-content/plugins/duplicator-pro/classes/entities/class.brand.entity.php', 0, 'יaMӲ', 'יaMӲ', 'gD{J]J*~^\\u7ۦw', '', 0, '?'),
 ('^[}.[2*m', 'wp-content/plugins/duplicator-pro/classes/entities/class.duparchive.expandstate.entity.php', 0, 'm庁03@__', 'm庁03@__', '\Z\0m9#&', '', 0, '?'),
 ('ލ.S5$|<', 'wp-content/plugins/duplicator-pro/classes/entities/class.global.entity.php', 0, 'bs RϥbR', 'bs RϥbR', '3>fD\rk4SA', '', 0, '?'),
 ('TJ|t/]fX]W', 'wp-content/plugins/duplicator-pro/classes/entities/class.json.entity.base.php', 0, 'CJ\0͹c', 'CJ\0͹c', 'T|^\0WPhRMc', '', 0, '?'),
 ('#v*7P)', 'wp-content/plugins/duplicator-pro/classes/entities/class.package.template.entity.php', 0, ')oL]\n', ')oL]\n', 'q\nfK~4ՓWyTr}.', '', 0, '?'),
 ('NMWiO.', 'wp-content/plugins/duplicator-pro/classes/entities/class.profilelogs.entity.php', 0, '0[B	e', '0[B	e', '^v:)BQC?o', '', 0, '?'),
 ('ڃw$Xǔ.lz', 'wp-content/plugins/duplicator-pro/classes/entities/class.schedule.entity.php', 0, 'wKP#E:Ye', 'wKP#E:Ye', '\\u8e	zI@v^G', '', 0, '?'),
 ('5cG', 'wp-content/plugins/duplicator-pro/classes/entities/class.secure.global.entity.php', 0, '2 DRڵt', '2 DRڵt', 'ȏܿ|X Ɛ/;\nwd(y', '', 0, '?'),
 ('!fbP1k&', 'wp-content/plugins/duplicator-pro/classes/entities/class.storage.entity.php', 0, '*mgf9', '*mgf9', 'hYLrs:Y.	.^^L\n)GD`', '', 0, '?'),
 ('F_0 	5', 'wp-content/plugins/duplicator-pro/classes/entities/class.system.global.entity.php', 0, 'za\rB\Z-\rU\r2', 'za\rB\Z-\rU\r2', '3}Qjbĥ&2qɅz', '', 0, '?'),
 ('I\0\'\nbY', 'wp-content/plugins/duplicator-pro/classes/entities/class.verifiers.php', 0, 'ɟo\r4', 'ɟo\r4', 'e;=R %9o<ݬ=@;=', '', 0, '?'),
 (' )IHëa', 'wp-content/plugins/duplicator-pro/classes/entities/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('KAv>VT', 'wp-content/plugins/duplicator-pro/classes/environment/class.db.checker.php', 0, '{Ů\r?34+o', '{Ů\r?34+o', 'dE[е6p -Z^VC@5', '', 0, '?'),
 ('ًS3z(aQ', 'wp-content/plugins/duplicator-pro/classes/environment/class.environment.checker.php', 0, 'eR\\aΏX	\ZX]', 'eR\\aΏX	\ZX]', '_X)kM0\0لjZmTP}+', '', 0, '?'),
 ('mt\"AjJK~', 'wp-content/plugins/duplicator-pro/classes/environment/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\\QG>?˜', 'wp-content/plugins/duplicator-pro/classes/environment/interface.checker.php', 0, 'zG頟4#܀', 'zG頟4#܀', 'r=_5V Vi~Uzv}~P', '', 0, '?'),
 ('\Z yIIf˃', 'wp-content/plugins/duplicator-pro/classes/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('gHGh.', 'wp-content/plugins/duplicator-pro/classes/net/class.ftp.chunker.php', 0, 'عMa\n', 'عMa\n', 'ԵoNPV$w=>2', '', 0, '?'),
 ('I1PHW%ӳ', 'wp-content/plugins/duplicator-pro/classes/net/class.u.gdrive.php', 0, 'yHbAeȨ', 'yHbAeȨ', 'Jk(ݝQY-#	*eIۣLUY', '', 0, '?'),
 ('bpM+\nĀ', 'wp-content/plugins/duplicator-pro/classes/net/class.u.onedrive.php', 0, 'AC:xH\n', 'AC:xH\n', '!i^XDĕդ-h\ZLS', '', 0, '?'),
 (')8yx}fnc', 'wp-content/plugins/duplicator-pro/classes/net/class.u.s3.php', 0, 'tŭ3&rB', 'tŭ3&rB', '?s.GT_,׀t\Z-չ\nw*8', '', 0, '?'),
 ('=cx˦72`k&T,', 'wp-content/plugins/duplicator-pro/classes/net/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (')lr	ۘ/!c2ڔ', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.available.php', 0, '\"}Ц{d', '\"}Ц{d', ')Kx˾L9^a>>q3?0\"n', '', 0, '?'),
 ('qGF՝A	?', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.filters.php', 0, 'P?qB:	}', 'P?qB:	}', 'j7ͪ<)?\0\0h!\"\'WQ_', '', 0, '?'),
 ('qX/!', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.php', 0, 'W?/Ac1za', 'W?/Ac1za', 'ʮ-Cw_N05ѡE~<йV%O+oa', '', 0, '?'),
 ('	bf^o', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.shellzip.php', 0, '%it', '%it', '`_dbOhkM2sDˌ۪G', '', 0, '?'),
 ('I08DX`', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.zip.php', 0, '.$EoB!!Ұn}', '.$EoB!!Ұn}', '/{*gFOL?;\Z*m5ܟ`/X9', '', 0, '?'),
 ('m%\"H2', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.database.php', 0, '3نWk\0RL$', '3نWk\0RL$', 'S.\r\'ݍӞex?+', '', 0, '?'),
 ('چv8i!h)', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.installer.php', 0, '/&2ώ5N', '/&2ώ5N', '-M\rTMaT\Z*/	wx4C', '', 0, '?'),
 ('\Zµb', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.multisite.php', 0, 'qBӡf\'@=', 'qBӡf\'@=', '> \\.|8]=p	鑲', '', 0, '?'),
 ('Kl$7(', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.php', 0, '2/~Ճ\Z\Z ', '2/~Ճ\Z\Z ', 't&XYL27/VOLj', '', 0, '?'),
 ('mf:$m', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.runner.php', 0, 'j?gvDJ', 'j?gvDJ', 'v2*eJ46\\@DԐF\n', '', 0, '?'),
 ('}ǁ5Ph+3u', 'wp-content/plugins/duplicator-pro/classes/package/class.pack.upload.info.php', 0, '7bNoӘz\"C', '7bNoӘz\"C', '/	 LeKruvBd8 K', '', 0, '?'),
 ('v9\"H3x', 'wp-content/plugins/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.php', 0, '@|Cb	\r4)a	', '@|Cb	\r4)a	', '3X}a1\"(%\\uf\"F', '', 0, '?'),
 ('\"D]|b@\ZF&q', 'wp-content/plugins/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.create.php', 0, '_\n%5$', '_\n%5$', ';WfQѥ3;̎ɽVTTz\rq:', '', 0, '?'),
 ('5\n{K%', 'wp-content/plugins/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.expand.php', 0, 'ڱn,(Hc', 'ڱn,(Hc', 's W? Yypi[WI+~', '', 0, '?'),
 ('ۻ8ZDIWCE', 'wp-content/plugins/duplicator-pro/classes/package/duparchive/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('(xp[?I;', 'wp-content/plugins/duplicator-pro/classes/package/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\0OCqPЇ!$', 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.alert.php', 0, 'p*zO?M\0I*', 'p*zO?M\0I*', '̂ʸ\r_[3Dzb0-aW T', '', 0, '?'),
 ('5edctw\r', 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.dialog.php', 0, ';Е\'W{<g', ';Е\'W{<g', 'XȠW$T՟k GH%shdX?]', '', 0, '?'),
 ('6ǗHa;铡?', 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.messages.php', 0, 'MjOX}è', 'MjOX}è', 'd*@v};@nkh\n\Zߙg', '', 0, '?'),
 ('?Ҋ50\n', 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.notice.php', 0, '6[Rp', '6[Rp', '.02EDVXΜ!XexrM=', '', 0, '?'),
 ('C[*\r9', 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.php', 0, '6DEr)w', '6DEr)w', '|w3@މNID-__.', '', 0, '?'),
 ('5q`oЗ', 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.screen.base.php', 0, 'E@7lUAe', 'E@7lUAe', 'xrP=9徼439Hb\\)(|	', '', 0, '?'),
 ('([YB\rt', 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.viewstate.php', 0, '+7Q\'~@M]g', '+7Q\'~@M]g', '8(Ys.vc]P*Q', '', 0, '?'),
 ('s{ ', 'wp-content/plugins/duplicator-pro/classes/ui/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('_0L\\hJ&', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.date.php', 0, '0TնĆ<6 ', '0TնĆ<6 ', 'vz?)zWYZ[\0U', '', 0, '?'),
 ('yquPZl^_9', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.import.php', 0, 'u$GV|2-', 'u$GV|2-', '} wSI,WƅXI%*a>', '', 0, '?'),
 (')\nD\rYYrnf', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.json.php', 0, '8xW{酆', '8xW{酆', '\r&6\nS1pdi`4TCh', '', 0, '?'),
 ('*Ci8a:7', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.license.php', 0, '&Ȫ$]m', '&Ȫ$]m', 'T%^$[!#Z\n$Fz>\'\r?8Z', '', 0, '?'),
 ('_wP{k\r`J', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.low.php', 0, '>-̢L,', '>-̢L,', '3uҹ8evT$4U	', '', 0, '?'),
 ('\nfY+暕9.', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.multisite.php', 0, '<XaCf$\n', '<XaCf$\n', '\"ZnTFѓF݀ͽ*(^R]#2˦H', '', 0, '?'),
 ('ƌ+T̰pk', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.php', 0, 'DB!}I', 'DB!}I', '(WOC\0Ut$^X]^:', '', 0, '?'),
 ('_c|', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.settings.php', 0, 'DB5IM', 'DB5IM', 'q<Qü~3m\'gƔHAi', '', 0, '?'),
 ('6m%rs`\rcw', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.shell.php', 0, '2i/H\0!K ', '2i/H\0!K ', 'G,8mc XPǅM@wej', '', 0, '?'),
 ('bz~ȩbvVi', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.string.php', 0, 'Yq6^ O؃&Њ', 'Yq6^ O؃&Њ', '63u=/ąEEq#N͹', '', 0, '?'),
 ('a3SEqs8vv\"', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.tree.files.php', 0, 'Kڒ__ˮs', 'Kڒ__ˮs', 'b,3_\r\rl 2{?J-', '', 0, '?'),
 ('%t	xRPS', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.upgrade.php', 0, '$p2yx/g\"ѵ', '$p2yx/g\"ѵ', '`asj|M99bE', '', 0, '?'),
 ('ǋy},zP', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.validator.php', 0, '{R^ϛ>mK', '{R^ϛ>mK', '`w\'<q+\\1H:2JM<nͨK\rs0', '', 0, '?'),
 ('Q;fܰ(`s', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.wp.php', 0, ',	^xt%Fqv', ',	^xt%Fqv', '_Fyrf]\0O-!6', '', 0, '?'),
 ('A-7 ', 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.zip.php', 0, 'mhz', 'mhz', 'o}Q8WtZG', '', 0, '?'),
 ('c+\'bo6', 'wp-content/plugins/duplicator-pro/classes/utilities/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('L؍MI_208', 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.test.debug.php', 0, '6eҏ?K@', '6eҏ?K@', 'OZw`\nUr USPkl8Mn¡', '', 0, '?'),
 ('v契xۑ0Na', 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.test.package.build.php', 0, 'l`7[eK b. ', 'l`7[eK b. ', '4JNnuю#m,cc*\\', '', 0, '?'),
 ('[WM,@TNp', 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.u.test.abstract.php', 0, 'D-!Tfg R', 'D-!Tfg R', 'IM%Qa)I?TT6H$:', '', 0, '?'),
 ('8%@02', 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.u.test.result.php', 0, '2}Pa\\x', '2}Pa\\x', '<]aYdTvȝB\rF:', '', 0, '?'),
 ('\0oTB=@i', 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.u.tests.manager.php', 0, 'v({ת5#', 'v({ת5#', 'ʎVz;x\00gu\0E,:\0z2', '', 0, '?'),
 ('KE-@^Q', 'wp-content/plugins/duplicator-pro/classes/utilities/wordpress.core.files.php', 0, '~ym?{\r', '~ym?{\r', 't9a QX2o07܋', '', 0, '?'),
 ('s_3E*[', 'wp-content/plugins/duplicator-pro/ctrls/class.web.services.php', 0, 'm#g4', 'm#g4', 'Ƭr;@\nR|\\ 5d\nc#&Lg', '', 0, '?'),
 ('	#f4f', 'wp-content/plugins/duplicator-pro/ctrls/ctrl.base.php', 0, '^BhJ,.', '^BhJ,.', '89R=TKΆ>;i', '', 0, '?'),
 ('HQg}uFh_Ѩ', 'wp-content/plugins/duplicator-pro/ctrls/ctrl.package.php', 0, 'Vsr(4u+tk', 'Vsr(4u+tk', '~.fSjWk8Z;4pa΄Чa', '', 0, '?'),
 ('/+Nl`yZ', 'wp-content/plugins/duplicator-pro/ctrls/ctrl.schedule.php', 0, ';3_ҁ3\'$', ';3_ҁ3\'$', ')/7&fbie;:~', '', 0, '?'),
 ('a{\r;]#dI{0', 'wp-content/plugins/duplicator-pro/ctrls/ctrl.tools.php', 0, '?<2]Hi', '?<2]Hi', '{)R0X{^ւAm-ˬ98g', '', 0, '?'),
 ('}D-O$V{\Z', 'wp-content/plugins/duplicator-pro/ctrls/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('RD}a\rL!b', 'wp-content/plugins/duplicator-pro/debug/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('JHʽN', 'wp-content/plugins/duplicator-pro/debug/main.php', 0, 'Rm7i4', 'Rm7i4', 'ڭ~q\"eWw\Z0ƑZH<j=}', '', 0, '?'),
 ('sZ,\r)n', 'wp-content/plugins/duplicator-pro/debug/tst.packages.php', 0, '+1\"(}˓x}b', '+1\"(}˓x}b', '1H5n\\ն6	&ٿ@%(', '', 0, '?'),
 ('G;!,i<8', 'wp-content/plugins/duplicator-pro/debug/tst.tools.php', 0, '\'OJpZp1', '\'OJpZp1', 'j3!CePA=c^$', '', 0, '?'),
 ('vv|mbAsn', 'wp-content/plugins/duplicator-pro/define.php', 0, '}00wBJ^', '}00wBJ^', 'O+Y֣	8 QSg\"կr4s', '', 0, '?'),
 ('8!,(?&gD', 'wp-content/plugins/duplicator-pro/duplicator-pro.php', 0, 'sGW_a', 'sGW_a', 'N_lXE_+gcWa', '', 0, '?'),
 ('7/k	%9g', 'wp-content/plugins/duplicator-pro/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('lqk0NR}', 'wp-content/plugins/duplicator-pro/installer/dtoken.php', 0, 'M̛Z{hcZ', 'M̛Z{hcZ', 'K	\'.TRI!{\"lf_4AR', '', 0, '?'),
 ('07&LU', 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/class.api.php', 0, ',&^:9OCmt=jR2F', ',&^:9OCmt=jR2F', 'W@ʩ:qЄՆM	hc둾bR', '', 0, '?'),
 ('uLf|s', 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/class.cpnl.base.php', 0, 'B/xG3}B', 'B/xG3}B', 'seKbd\\`B[M-*8m`', '', 0, '?'),
 (' xr/wD', 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/class.cpnl.ctrl.php', 0, '<1IkڑQj7K', '<1IkڑQj7K', 'aRi	9(`1XD\n1Y', '', 0, '?'),
 ('=\r	wXJ3', 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/index.php', 0, '@eU\0OvZ', '@eU\0OvZ', 'emI:ņ\nD˒', '', 0, '?'),
 (' |\r}oJ8r>', 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/router.php', 0, ']S.g6Ǵuq', ']S.g6Ǵuq', 'eun%Odغmt6U', '', 0, '?'),
 ('`Ҥ͐L', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/font-awesome/css/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Z^bT d3', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/font-awesome/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('@U0))/+', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/font-awesome/webfonts/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('6WZ=Ы', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/images/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\\3LФ\"/D={', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.css.php', 0, 'JTa\"[', 'JTa\"[', 'W%%qъxοs(mV0_[}', '', 0, '?'),
 ('N4:Uf98|', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.js.php', 0, '?9/ǹÀ', '?9/ǹÀ', 'Xuւs5^P%P9U>D', '', 0, '?'),
 ('z>?O(E3', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.libs.css.php', 0, ']+?Pru', ']+?Pru', '>2{\\k5?)eR*!=c', '', 0, '?'),
 ('ޞphG]|EV', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.libs.js.php', 0, 'ʱ!/+#r.z', 'ʱ!/+#r.z', '*GD\"~Ի@ƍq &mkmf', '', 0, '?'),
 ('݅Ё-svxB', 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('kZT\Z3\"&nB', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/EventIterator.php', 0, 'Q1H(J', 'Q1H(J', 'ePmnZy`f~ju=+Z{oK', '', 0, '?'),
 ('zO\Z]', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/GenericSeekableIterator.php', 0, 'Ic qqh9!', 'Ic qqh9!', 'G\\b%jENH]', '', 0, '?'),
 ('($m^~d', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/class.s3.iterator.php', 0, '):S̾`1(A', '):S̾`1(A', '{f.WƝM|!=\'K)x', '', 0, '?'),
 ('Nޤ\'s#', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunk.s3.manager.php', 0, '22mS7>', '22mS7>', 'К`>u7/+,lH', '', 0, '?'),
 ('%\r|hheG', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager.php', 0, 'n;c', 'n;c', ',@Z6SnF.zU>|\";', '', 0, '?'),
 ('Ma`7s	X', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager_file.php', 0, 'M*5(+X[/', 'M*5(+X[/', 'hIӨ\Zu]e\"!(D%\rO\',Neo', '', 0, '?'),
 ('O$ix+M', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Crypt/Base.php', 0, '\Zl*|=i|C\r', '\Zl*|=i|C\r', 'U}*K8)FxT,', '', 0, '?'),
 ('ޝ.^>Z%[', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Crypt/Random.php', 0, '@\'-P*ij^J', '@\'-P*ij^J', '՞u*[Mq|Lj-Xk', '', 0, '?'),
 ('d,\"PkH', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Crypt/Rijndael.php', 0, 'xrxak\rG', 'xrxak\rG', 'h|y)mtz**P\'vyFgcY', '', 0, '?'),
 ('e(/^J#G2cy', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.crypt.php', 0, '\\\0H>\"y', '\\\0H>\"y', 'J<>D7\n-Э|gtz', '', 0, '?'),
 ('5cɥEbQq', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.csrf.php', 0, '|:Z%', '|:Z%', '^n8vHx;ݓiW~mG', '', 0, '?'),
 ('RF$o,T', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.db.php', 0, ':u0yD#', ':u0yD#', 'Xˋp7E/WS82:D\0\'\n', '', 0, '?'),
 ('A\n4g>DD\'R/e', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.engine.php', 0, 'Eo;G_ө^-I', 'Eo;G_ө^-I', ')sXIX㹸/iCS\nc/>d/', '', 0, '?'),
 ('b\n.ǽIOI\r9p', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.http.php', 0, 'WO\rZc+tnY*,', 'WO\rZc+tnY*,', 'P+Y5 \"A\"(TC\0b', '', 0, '?'),
 ('\Z|(MKL_+', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.installer.state.php', 0, 'ԞQIK;bi4', 'ԞQIK;bi4', '3^8ڇ}gR]Gގy5>ٶ', '', 0, '?'),
 ('4\n!\0XDX', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.logging.php', 0, '6,xĵJz', '6,xĵJz', 'xDw37b+!/(}\n>De', '', 0, '?'),
 ('qBlEGUP^1C_', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.password.php', 0, '\'nouȣO\n+G', '\'nouȣO\n+G', '_|QK\r~U:6ΩEK', '', 0, '?'),
 (' \r', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.s3.func.php', 0, '[t+\'ƻ', '[t+\'ƻ', '4,˂\rxӯ0J$XqΠ', '', 0, '?'),
 ('Xc\0{Sf_~m', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.server.php', 0, 'hٹ$&sJC', 'hٹ$&sJC', '6y֏NtVx9*LedQݺ|', '', 0, '?'),
 ('nJ`F8)pRe', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.view.php', 0, 'ԬR\ZK;1\Zo', 'ԬR\ZK;1\Zo', '2M`_ă>@C ;', '', 0, '?'),
 ('굓੷Ee', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.archive.config.php', 0, ',D%Бf_', ',D%Бf_', 'P8)8s?c}sB|/', '', 0, '?'),
 ('/yE*5Z^Q', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.boot.php', 0, 'Ph+9\'', 'Ph+9\'', 'fsթk\\Qj{%θl=Iޙk', '', 0, '?'),
 (',;hدAn', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.conf.srv.php', 0, '~#KGcS$', '~#KGcS$', '$oPJ:jx_Nlܴlk', '', 0, '?'),
 ('rwi\0Es2', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.conf.wp.php', 0, '\0>x%]9_X^', '\0>x%]9_X^', 'CXu\"FAɭ`s/A&e5', '', 0, '?'),
 ('Nا`LQ!', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.constants.php', 0, 'bhŞ8VF\Z', 'bhŞ8VF\Z', 'l#ŜiUOu-MJ#[i', '', 0, '?'),
 ('\'vJa)GR', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('%:Cfv_', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('!0_lL\n', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.exceptions.php', 0, 'cБHE`	', 'cБHE`	', '=;!(r2 ]:D2䊉D', '', 0, '?'),
 ('\Zҹo\rQ?0', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.html.php', 0, 'mdp7I9V', 'mdp7I9V', '^5%[ݐ~iMw~kaXd$  ^', '', 0, '?'),
 ('M+ߵW| ', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.multisite.php', 0, '1r\0k', '1r\0k', '{rR2cňʯkۂ}`0v+', '', 0, '?'),
 ('eTVeuW', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.notices.manager.php', 0, '/IZZs%\nO', '/IZZs%\nO', 'ٌ~97]_J^	#', '', 0, '?'),
 ('^Px', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.php', 0, '̂7683U)ry', '̂7683U)ry', ';(r+l^y*8w\"j|', '', 0, '?'),
 (' AShTF	惓Qǥ', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.remove.redundant.data.php', 0, '\0$@\Z>iTZQ-', '\0$@\Z>iTZQ-', 'cqW!g;oU9UZv', '', 0, '?'),
 ('ƳQ=u¥', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.search.reaplce.manager.php', 0, 'kL\\~{Gsɠ', 'kL\\~{Gsɠ', 's@͡S}[bG\'?=#A# #', '', 0, '?'),
 ('\nsOcFeIɣ!', 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('$$Ɍ.u', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.base.php', 0, 'oݷf7]&([', 'oݷf7]&([', 'k4y%Ш<\n$y$ewX4', '', 0, '?'),
 ('+m;gC', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.extraction.php', 0, '{<v32ϳ$%', '{<v32ϳ$%', 'y<Xa;px%Y\\]\0}B:~', '', 0, '?'),
 ('/(L< I}', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.php', 0, '2\'E_%T{OaO', '2\'E_%T{OaO', '	J &FY*vٳ#1', '', 0, '?'),
 ('Dt]:F0s+', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.base.php', 0, 'Fy}Ԍ]ϑ', 'Fy}Ԍ]ϑ', 'WqfQGZyl9>\r\n]Q', '', 0, '?'),
 ('\rc3O&p{Uj', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbinstall.php', 0, '<ug]nT\"H', '<ug]nT\"H', 'eĘl(\'xLW9+CA$lap[|', '', 0, '?'),
 (')QVHׯ', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbtest.php', 0, '?5bhV3MX#ڢ', '?5bhV3MX#ڢ', 'Dv̂:J~,3))?Kp', '', 0, '?'),
 ('+t V}+e@', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s3.php', 0, '릳I@~*SJ)\0', '릳I@~*SJ)\0', '˺ Jʸ	)w\Zbz:.\"i2U', '', 0, '?'),
 ('މ$\"`', 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('8un;', 'wp-content/plugins/duplicator-pro/installer/dup-installer/index.php', 0, '<|8g`', '<|8g`', 'NǍǡG3*\Z#b#,E8_', '', 0, '?'),
 ('d<tیL9', 'wp-content/plugins/duplicator-pro/installer/dup-installer/main.installer.php', 0, '(,Z)Í2FE)', '(,Z)Í2FE)', '!0l&l_(:d8˰', '', 0, '?'),
 ('b|ݛ[Ʉ5k`', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('94$qw1f@C\Z', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.api.php', 0, 'j0H3!nǛ', 'j0H3!nǛ', ' O\"jXQdF,gxkEc{', '', 0, '?'),
 ('hZ#Wo[', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.exception.php', 0, '	}]}fɀ-Ľ', '	}]}fɀ-Ľ', '$\n,̌9 q棬HY', '', 0, '?'),
 ('dԅHj\n ;p', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.help.php', 0, 'p?1ZY', 'p?1ZY', '~H@/sPFI#sZcd', '', 0, '?'),
 ('\Z\"R:o', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.init1.php', 0, ',䉡,M\\', ',䉡,M\\', 'dzqf{shp5{ӀK', '', 0, '?'),
 ('V|wέ8\\y^', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s1.base.php', 0, 'x>{V\"Y', 'x>{V\"Y', 'kB/{ARp^Zd}.nI@', '', 0, '?'),
 ('2Y!s5b', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s1.terms.php', 0, '˝8\'7D', '˝8\'7D', '󛮤Q#fI[crMqF4', '', 0, '?'),
 ('-\"kQb	yt', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.base.php', 0, 'w(9&d', 'w(9&d', '{\r\0sM!Qb,Q^	;', '', 0, '?'),
 ('ؾ.aPO', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.basic.php', 0, 'V@\'E=_&sm\'', 'V@\'E=_&sm\'', 'OwLr\nGt>+:%,jć%ZC[', '', 0, '?'),
 (' @BGbOj', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.cpnl.php', 0, '{+\'bA\"', '{+\'bA\"', '1xu}]0g`N!ou\n(O', '', 0, '?'),
 ('?mlM{/8', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.dbtest.php', 0, '.Y7	R', '.Y7	R', '&T]jPD*C̟I7a/', '', 0, '?'),
 ('#,wWY7ֈ\"[@', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s3.php', 0, 'Vy\0#V&Q', 'Vy\0#V&Q', 'gjyΝ@8V^b', '', 0, '?'),
 ('Y7XE9\"\0	', 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s4.php', 0, ':z*A5', ':z*A5', '+ݛo5~WjoO', '', 0, '?'),
 ('!\rI?', 'wp-content/plugins/duplicator-pro/installer/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('٣5`qw98\n,	', 'wp-content/plugins/duplicator-pro/lang/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\\g=EbxJQ ', 'wp-content/plugins/duplicator-pro/lib/DropPHP/DropboxClient.php', 0, '?w!>OFY~', '?w!>OFY~', 'ϊE3t-/~*9raBCkFkk', '', 0, '?'),
 ('\nf4P?)p2', 'wp-content/plugins/duplicator-pro/lib/DropPHP/DropboxV2Client.php', 0, 'BhAh|$QmH', 'BhAh|$QmH', 'G!ckXV<whzSQ\0', '', 0, '?'),
 ('u*aQYrO', 'wp-content/plugins/duplicator-pro/lib/DropPHP/OAuthSimple.php', 0, '⡜(][b]9', '⡜(][b]9', 'L(	sQ[Rl.S\'\Z i', '', 0, '?'),
 ('o\\n؜Tba|v{', 'wp-content/plugins/duplicator-pro/lib/DropPHP/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('s^_R>epOIY', 'wp-content/plugins/duplicator-pro/lib/ca/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('],d[t/OJI', 'wp-content/plugins/duplicator-pro/lib/certificates/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('7W%G=2օB1', 'wp-content/plugins/duplicator-pro/lib/config/class.wp.config.tranformer.php', 0, '_aMwM@-', '_aMwM@-', 'his	`> X3rY%Ok', '', 0, '?'),
 ('ty#fЀ', 'wp-content/plugins/duplicator-pro/lib/config/class.wp.config.tranformer.src.php', 0, 'v̵Uy~A(b', 'v̵Uy~A(b', '\'<ѽCچ0N{K{', '', 0, '?'),
 ('`BN;`Y', 'wp-content/plugins/duplicator-pro/lib/cron/csd_parser.php', 0, 'V972xspUw', 'V972xspUw', '`uvPQJ֩ rXoG\'', '', 0, '?'),
 ('98:\n\npzHCR', 'wp-content/plugins/duplicator-pro/lib/cron/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Ӊ%\njT', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.constants.php', 0, 'e.\r&`D', 'e.\r&`D', 'hzY^G?F\r`` ', '', 0, '?'),
 ('Jڇ4QAC', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.engine.php', 0, 'cb,', 'cb,', 'lUO[FiN!<GaZ', '', 0, '?'),
 ('t}!-[~~gV', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.loggerbase.php', 0, 'XaW6', 'XaW6', '+pqvKOUiJ}>', '', 0, '?'),
 ('=be:HE}', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.mini.expander.php', 0, '3WBn`τ', '3WBn`τ', 'AX.mndbȕ&.K$$t&', '', 0, '?'),
 ('BrpY^SW-`i', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.processing.failure.php', 0, '7T$w۝ӹs', '7T$w۝ӹs', 'C\ZߞZ3P>G$X<&D\n\\.', '', 0, '?'),
 ('FwC,\'ST', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.directory.php', 0, '0y俘1oc', '0y俘1oc', '62+cp\\].޴Wߝf,-퇮', '', 0, '?'),
 ('5B\'bԼ}', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.file.php', 0, 'IQNɾmN', 'IQNɾmN', '\"zM2ŹAyuXY¥Va #', '', 0, '?'),
 ('xP<;9oAt|', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.glob.php', 0, 'q0Z^cBX', 'q0Z^cBX', 'Q\"ZlP	sԣ6\\իׂP\Z', '', 0, '?'),
 ('&`zлAO8_&', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.php', 0, 'rnJx)3Yt', 'rnJx)3Yt', '[FN*G\0^E9mB]<', '', 0, '?'),
 ('O^|', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.u.php', 0, 'mE\ZBr(\'', 'mE\ZBr(\'', '-:auQ{V\\AZo_', '', 0, '?'),
 ('ޞkE6sO', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('f2^)ԓ', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Bz|o &й8vJ', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.directory.php', 0, 'sHP/S#ܨl', 'sHP/S#ܨl', '@3~S\"-8ˈJqrESտ', '', 0, '?'),
 ('\n@ u<0\0', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.file.php', 0, '6ϥڇ(#b4m', '6ϥڇ(#b4m', '#9V:\n`9xJJI!TA', '', 0, '?'),
 ('\r6t=DNc', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/processors/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Y7 LK|\'/', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.base.php', 0, ',k_ο', ',k_ο', '@cuw:-U#R~K>zB1_15', '', 0, '?'),
 (' 6J}Lhyx', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.create.php', 0, '_.Rz', '_.Rz', '/ށS5llt؜o˯', '', 0, '?'),
 ('SHZ-hѱw\rd', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.expand.php', 0, 'M<-J[', 'M<-J[', 'Ӡ|vz~H]rs', '', 0, '?'),
 ('CҹuǄnj', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simplecreate.php', 0, '*Ԃ7M4J6', '*Ԃ7M4J6', 'J⒛QmF{ERQ\")zОz\0[', '', 0, '?'),
 ('E6+6', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simpleexpand.php', 0, '\\/)5i憲^', '\\/)5i憲^', '|!Q\0bڪ`Tp%t}N:>^', '', 0, '?'),
 (']>:mv0', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('$\0xU', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.u.json.php', 0, 'ݩ.|6\"', 'ݩ.|6\"', 'դ5/-8zL1}:tרhE', '', 0, '?'),
 ('-	#^сbG8', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.php', 0, 'e2L$Bn\Z', 'e2L$Bn\Z', 'aɇ\"B8.)_jR!', '', 0, '?'),
 ('Tb\rz`kE', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.scan.php', 0, '-*L~wW1', '-*L~wW1', '\"<!{ՠCN\'L\\{', '', 0, '?'),
 ('l6=#Ֆ\"', 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('m2mB=!U', 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/class.daws.constants.php', 0, 'Fp:l|T', 'Fp:l|T', 'ZkEyjz`J<Z1?VAb2\Z', '', 0, '?'),
 ('ca jagVi\\\0\0	}', 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/class.daws.state.expand.php', 0, 'x`r\rm', 'x`r\rm', 'L<m~Bt[ĝ6v', '', 0, '?'),
 ('oadO\niyH', 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/daws.php', 0, 'ÞsB0', 'ÞsB0', '*9k2trϱ9/S\'pcN!v\r', '', 0, '?'),
 ('	H\nxʙ', 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\\̛qkl', 'wp-content/plugins/duplicator-pro/lib/dup_archive/define.php', 0, '\0[OhYyV^z', '\0[OhYyV^z', ';C	\nm)㇮8-4\\{n', '', 0, '?'),
 ('l|g˼c\\fMg', 'wp-content/plugins/duplicator-pro/lib/dup_archive/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('|gSu62', 'wp-content/plugins/duplicator-pro/lib/edd/EDD_SL_Plugin_Updater.php', 0, 'Fg~R\n|x', 'Fg~R\n|x', '@VN6\'9_҅\"F(QG', '', 0, '?'),
 ('1IkuCwcl-\\', 'wp-content/plugins/duplicator-pro/lib/edd/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('$Pc@K\'&-', 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.constants.php', 0, '\'~sfB', '\'~sfB', 'rBAƈe芷}t(4\nO', '', 0, '?'),
 ('c۔Oaҋ', 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.state.php', 0, '{)&yG.', '{)&yG.', 'HHJV	j;۩.Ao*P', '', 0, '?'),
 ('\\t7dpid', 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.u.delete.php', 0, 'P#:ƈˡ3', 'P#:ƈˡ3', 'emrڿ!(4#:EE', '', 0, '?'),
 ('o9K1嚣ݱ', 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.u.move.php', 0, '{SM{Q', '{SM{Q', '37B4@*V.Ģ9LF\\^#d%a', '', 0, '?'),
 ('L=~.', 'wp-content/plugins/duplicator-pro/lib/fileops/fileops.php', 0, 'cdќ=~', 'cdќ=~', 'Tp\rThR~Dvƺ', '', 0, '?'),
 ('$RߥFxoqc', 'wp-content/plugins/duplicator-pro/lib/fileops/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('>M\ZRPmRYs_', 'wp-content/plugins/duplicator-pro/lib/forceutf8/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Qa!a', 'wp-content/plugins/duplicator-pro/lib/forceutf8/src/Encoding.php', 0, '*9`dg`Z\r\\Ky', '*9`dg`Z\r\\Ky', '4mHtMQd8e+=dۘĘ', '', 0, '?'),
 ('-Nfl	RϋOpբЭ', 'wp-content/plugins/duplicator-pro/lib/forceutf8/src/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('X+/T9ֿ', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/Abstract.php', 0, 'K4Ɏ(9	', 'K4Ɏ(9	', '~4CjvĢkp.\ZmѮrZYm', '', 0, '?'),
 (',4GѝC/2', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/Exception.php', 0, 'MseO6x', 'MseO6x', '۔ғG9YT8jAR\".$F', '', 0, '?'),
 ('Z*N]\0)', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/OAuth2.php', 0, '>kv[f0', '>kv[f0', '\0rv׭d9ϐ^泷Ǆb^*`s', '', 0, '?'),
 (';O$1F`', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('-\Z2N\"', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/Abstract.php', 0, '7VM8XK', '7VM8XK', 'qޞRyy#ؐ}b!', '', 0, '?'),
 ('dۭu\r', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/Exception.php', 0, 'yśBកK', 'yśBកK', '-̝p,r7}:/t8IRe', '', 0, '?'),
 ('tE 3Kl:', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/File.php', 0, 'ߕW<R~\njxj', 'ߕW<R~\njxj', 'Z^(~;0rE', '', 0, '?'),
 ('Dc;ǫl\'', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/Null.php', 0, 'Rpb4-&', 'Rpb4-&', '/\ZA<She2|So-\n', '', 0, '?'),
 ('wšhtb.', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('@_[=[m!', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Client.php', 0, 'h4	ʴ$;Q', 'h4	ʴ$;Q', '1\"zssoFu\r<', '', 0, '?'),
 ('͕OpE', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Collection.php', 0, 'q?͢Y ', 'q?͢Y ', 'f975hvlmv\n', '', 0, '?'),
 ('R<\Z,:mH', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Config.php', 0, '\r1kR	\n', '\r1kR	\n', '4jN  ryF:1w|?pD5', '', 0, '?'),
 ('\"Nv4Ey|1\"', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Exception.php', 0, '1\Zk(}', '1\Zk(}', '\nyMd+6׉IΣ͟x\n', '', 0, '?'),
 ('zf\n|m3', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/Batch.php', 0, '6st	V:', '6st	V:', 'r;\\Sۿ8CΗ`ZA;', '', 0, '?'),
 ('@ug<', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/CacheParser.php', 0, 'y㞬[%ul,bz', 'y㞬[%ul,bz', '1\0ML5pnjC2Yq˿lI6{', '', 0, '?'),
 ('Y/k(4U.:', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/MediaFileUpload.php', 0, 'ѰMn`9Ui', 'ѰMn`9Ui', 'ceGGc2\"s<hPtMB&', '', 0, '?'),
 ('!^jt', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/REST.php', 0, 'q\"%,\r(b͛7', 'q\"%,\r(b͛7', 'R(?22\ryLW)뻄(2icЌ9', '', 0, '?'),
 ('Z\r^s$J:k', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/Request.php', 0, '<8~ʡi}j', '<8~ʡi}j', ':X1M\\#Os\\#j|}&[', '', 0, '?'),
 ('<D*Oejn3', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Mc\n?$', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Abstract.php', 0, 'FO\0蠄׽M', 'FO\0蠄׽M', '~2}n`9n.XݨUt55wg0', '', 0, '?'),
 ('tڎ\"1', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Curl.php', 0, 'rf|`;1(', 'rf|`;1(', '\n6.e\"˼ZWG', '', 0, '?'),
 ('(\'d.uq', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Exception.php', 0, 'x9NÕ', 'x9NÕ', 'SDZٯZZǑ~i<$l͞S$\Z', '', 0, '?'),
 ('_T]M_^_T', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Stream.php', 0, 'MSjOKJ', 'MSjOKJ', 'ԍk\\go.vdO_Š', '', 0, '?'),
 ('R *:', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('o\n^QF|', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/Abstract.php', 0, 'P=oĮYj\nݻ', 'P=oĮYj\nݻ', '\";n0F#-4K%47', '', 0, '?'),
 ('G@(J`n\0Ysc', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/Exception.php', 0, 'S#HS=d8([', 'S#HS=d8([', 'i7{])5|U**p1S', '', 0, '?'),
 ('0&!(2q+>', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/File.php', 0, '/2<}CG-_5;3', '/2<}CG-_5;3', 'Q-\rqBج?Tlvн', '', 0, '?'),
 ('ǎaZoK	%', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/Null.php', 0, 't:޼eJa\"g_', 't:޼eJa\"g_', '=DG$@HZɘ~r\ZϻT', '', 0, '?'),
 ('8az18U$]', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('rl|TҜSF', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Model.php', 0, '!dL56\Z|N', '!dL56\Z|N', '`x\nJ8HRhf\0[Wrn=', '', 0, '?'),
 ('w=y\ZuSY-;>', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Drive.php', 0, ';,庣y9', ';,庣y9', '!/|mnHPh[i', '', 0, '?'),
 ('J\"B1jtx', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Exception.php', 0, 'EJd0NϜ', 'EJd0NϜ', 'V\Zgul3j[:-4', '', 0, '?'),
 ('?oȻzG|v!', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Oauth2.php', 0, '.|(q|ӠO!&', '.|(q|ӠO!&', '5v5uO\'e3׫D', '', 0, '?'),
 ('$׶^-Y0-', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Resource.php', 0, 'J63B^3', 'J63B^3', '.W?#<_2/ڐ	s', '', 0, '?'),
 ('8;%4.̎/', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('mYR\Z7r4\r', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service.php', 0, '\\۲:DӤ?}S/', '\\۲:DӤ?}S/', ':U{2X,K7^4H', '', 0, '?'),
 ('d?+]x>czQ', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/Exception.php', 0, 'RG]>?|1]wH', 'RG]>?|1]wH', 'ZQzia*hwClapb}u_', '', 0, '?'),
 ('ԡϰWwSf', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/Retryable.php', 0, 'WڹjJy', 'WڹjJy', 't-dV?\\+Ņ(trW#̓', '', 0, '?'),
 ('x~Z\r#!', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/Runner.php', 0, 'vhFsP-8E', 'vhFsP-8E', '}ޅ\nOh\rBOH	3J', '', 0, '?'),
 (')&^̛', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('@]9Dɡm^', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Utils/URITemplate.php', 0, 'y~3S׈m҅uxU', 'y~3S׈m҅uxU', 'xQ\"\0wAX#\0Rai', '', 0, '?'),
 ('%qZU	', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Utils/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('׋\'\"W?&hūq', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Utils.php', 0, '}WG	', '}WG	', '$c{qEt>7:iĂ4j}Rf', '', 0, '?'),
 ('F\'\\NK$', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/autoload.php', 0, '3A:鈹Y(r?', '3A:鈹Y(r?', 'i^<@(ClU<?Iύf [k-', '', 0, '?'),
 ('D7\"CO[L0', 'wp-content/plugins/duplicator-pro/lib/google/apiclient/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('nEl)eMb^691', 'wp-content/plugins/duplicator-pro/lib/google/class.enhanced.google.media.file.upload.php', 0, ',\'ڎ\"ꚨ v@_', ',\'ڎ\"ꚨ v@_', 'E_N%I}]G-b(Y', '', 0, '?'),
 ('/Gv0bfuh=', 'wp-content/plugins/duplicator-pro/lib/google/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (';J<n\\2uR', 'wp-content/plugins/duplicator-pro/lib/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('`nN\rq', 'wp-content/plugins/duplicator-pro/lib/onedrive/autoload.php', 0, '\Z$kuiӫ', '\Z$kuiӫ', 'YC숯V\Zmݡ6\0Mo\0', '', 0, '?'),
 ('ǀ4+0De', 'wp-content/plugins/duplicator-pro/lib/onedrive/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Hb;\"\'}SEG\rI', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Client.php', 0, '?5\Z)71@&hb', '?5\Z)71@&hb', '8G%Ei=i:uIRd\r1', '', 0, '?'),
 ('a΢Ǳ\"', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/DriveItem.php', 0, 'r+Hcn', 'r+Hcn', '<R&p̜*=P)|%', '', 0, '?'),
 ('zwMIlW$', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/File.php', 0, 'qg\r	~NJ1', 'qg\r	~NJ1', 'Hk{Ⱦ[Z؆u?A', '', 0, '?'),
 ('wBɔk~c', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Folder.php', 0, 'J	Uv1}\r/', 'J	Uv1}\r/', '}b-Nf!n\\rxAyn{֛', '', 0, '?'),
 ('1:&&u*', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehavior.php', 0, '7{NUf_9', '7{NUf_9', 'd>4ţ\n\0l7$phW0', '', 0, '?'),
 ('Cv$V<PE', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehaviorParameterizer.php', 0, '^m1fY:TF+', '^m1fY:TF+', 'II(!vĠi0}Skts', '', 0, '?'),
 (' ,+#L=\n1G5', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/ResumableUploader.php', 0, 'Al_ơU', 'Al_ơU', '.~ r%e +0%:\'ܚI(', '', 0, '?'),
 ('Â\01؄%P', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamBackEnd.php', 0, '*=H*ex ', '*=H*ex ', '_7qpҵ;#ݓ\ZN-;Hϋf', '', 0, '?'),
 (';d?r\\X;G\Z', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamOpener.php', 0, 'wzbٚ6A%TI	', 'wzbٚ6A%TI	', 'Z˖RT}yzO\".ү30eE', '', 0, '?'),
 ('ZܭmdSR', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('6fLx', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('+O!œ', 'wp-content/plugins/duplicator-pro/lib/onedrive/src/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('a,\"Sf', 'wp-content/plugins/duplicator-pro/lib/pcrypt/cipher/blowfish.php', 0, '<e4,n5u\\', '<e4,n5u\\', '5\ntO\ng%͇~k9N', '', 0, '?'),
 ('W]H/bvZ', 'wp-content/plugins/duplicator-pro/lib/pcrypt/cipher/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('z[b{uVV-', 'wp-content/plugins/duplicator-pro/lib/pcrypt/class.pcrypt.php', 0, 'd#ΩtK#=s', 'd#ΩtK#=s', 'B~oL.\rd\r$/~d7l', '', 0, '?'),
 ('C̱_PT', 'wp-content/plugins/duplicator-pro/lib/pcrypt/example.php', 0, 'CHI|t', 'CHI|t', '(U_:+:[Ȗuca', '', 0, '?'),
 ('ե EkY&', 'wp-content/plugins/duplicator-pro/lib/pcrypt/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ڕ؟wJp<', 'wp-content/plugins/duplicator-pro/lib/phpseclib/autoload.php', 0, '?*Ǳ\r', '?*Ǳ\r', 'v\'߻ŭB%2p+ɛ1N*&%', '', 0, '?'),
 ('kƛ2S{Af\'', 'wp-content/plugins/duplicator-pro/lib/phpseclib/class.phpseclib.php', 0, '0ε+_G-', '0ε+_G-', '%`KfWPI;Гt|Ĕ쀔9Z', '', 0, '?'),
 ('h3_o', 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/ClassLoader.php', 0, 'cOd!FuM؅', 'cOd!FuM؅', 'S-GR e!m{Zflv]', '', 0, '?'),
 ('\"AyĦ\r\0', 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_classmap.php', 0, 'Hz*m6Q', 'Hz*m6Q', 'uɣ,9Q>\n؉]@pF;`f', '', 0, '?'),
 ('Eh<=G-eюX', 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_namespaces.php', 0, 'g$_hηMq', 'g$_hηMq', 'KkawlcVu(]\ro>E', '', 0, '?'),
 (']1;M]', 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_psr4.php', 0, 'HH< <', 'HH< <', 'cH3\"{kq0\r{nڸ', '', 0, '?'),
 ('Ho~@ ܁', 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_real.php', 0, 'S6Uw[䞉-', 'S6Uw[䞉-', '>cQg>9aJxeAƩ쨄m=2l ', '', 0, '?'),
 ('P0WU', 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_static.php', 0, 'JRܾ33', 'JRܾ33', '#nS#_q]3eN2K', '', 0, '?'),
 ('ѭRGٲ7P', 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/include_paths.php', 0, 'HfS7\nBQj', 'HfS7\nBQj', '2vYP?3aȃmm/A', '', 0, '?'),
 ('3=.sVs{', 'wp-content/plugins/duplicator-pro/lib/phpseclib/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('x]	>	M\Z', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/AES.php', 0, 'G-17^p', 'G-17^p', 'ck],K]ֆBn&KzʇKZ&\n', '', 0, '?'),
 ('rȯx5Ka@^ڶʮ', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Base.php', 0, '5@R4oWs', '5@R4oWs', 'XoX-\rqj}~?:A||s', '', 0, '?'),
 ('pᡶ12~E3;', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Blowfish.php', 0, '*;.Ch', '*;.Ch', '1xuOձϑ1eڈ|sM֚H	ڨ', '', 0, '?'),
 ('Qٰ=[', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/DES.php', 0, 'E6P4.\\\\cI', 'E6P4.\\\\cI', 'YìUc	<|X2\\}', '', 0, '?'),
 ('N\0䑵', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Hash.php', 0, 'P]sky$', 'P]sky$', '}OL,UJ8k', '', 0, '?'),
 ('ۡ2RG4bAT', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC2.php', 0, '&tQ7:d&', '&tQ7:d&', 'mmWo;Zwg+Quc\0|R*|', '', 0, '?'),
 ('䮜פR>7', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC4.php', 0, '6cy]wdL', '6cy]wdL', '9]mGiea}K!', '', 0, '?'),
 ('Ax51\rKR', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RSA.php', 0, ']Ϧ8-(|d', ']Ϧ8-(|d', '\Z~ϰ^=JfxI~ݺ\n/', '', 0, '?'),
 ('M*b>(Iևz', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Random.php', 0, 'p/juH1*', 'p/juH1*', '2MCibMV6נ8oT!+\r1(', '', 0, '?'),
 ('\rwr\n', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Rijndael.php', 0, 's!Jjm	', 's!Jjm	', 'U_4 ؊viRS4+>.G,]', '', 0, '?'),
 ('|\0[}1a< l', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/TripleDES.php', 0, 'FӁm^Ħ}^C\Z|e', 'FӁm^Ħ}^C\Z|e', 'j\0\Z6F9r$7Epb%', '', 0, '?'),
 ('5a?ʵt', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Twofish.php', 0, 'PR.z_', 'PR.z_', 's	6<Di^ܘFXv6{\\\\N', '', 0, '?'),
 ('|wlY\r];JU ', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('v\0!h稭C.?q', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ANSI.php', 0, 'n8P2oS)', 'n8P2oS)', 'lT,K	`LGyimt25H', '', 0, '?'),
 ('TV](a', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/Element.php', 0, '*ȶS\rw>', '*ȶS\rw>', 'ٺ|/̠Gc7k^s', '', 0, '?'),
 ('߼R.\\L\rd', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ǋ=Fu:[%l', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1.php', 0, 'jH0`[5S$', 'jH0`[5S$', 'E:Z\'vk?hHT7Fê@jXx', '', 0, '?'),
 ('ex,/Q', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/X509.php', 0, '$,*5Uiv$', '$,*5Uiv$', 'hHRO)T$nρL)\Z\"wq?', '', 0, '?'),
 ('*pJkc|c', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('4GreUb=W2', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Math/BigInteger.php', 0, '<q`x[$z6', '<q`x[$z6', '3\0w#+VN&K', '', 0, '?'),
 ('f&-oNg', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Math/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('gYLڨ', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SCP.php', 0, 'dw\r`', 'dw\r`', '@\'MG2boV,^d(', '', 0, '?'),
 ('@\\٠rt^', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/Stream.php', 0, '<n_q\'7', '<n_q\'7', 'dMaT;fdM.qaȂeUM׺d5', '', 0, '?'),
 ('Ut6t|r0Z7', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('+Ej!L', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP.php', 0, '?vO\n', '?vO\n', 'C!),>eI{`', '', 0, '?'),
 ('?Ug@jx', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH1.php', 0, '1Ry Xb2S', '1Ry Xb2S', '}PngҖbEjx;w+67\'', '', 0, '?'),
 ('4/IW&ɭn[p8', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH2.php', 0, '8*ա+', '8*ա+', '6a\r7\nj.TPѷ=k1%', '', 0, '?'),
 ('PПb}	`BqTV', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\0<FP yn', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent/Identity.php', 0, ',Z:3ڏvk%8', ',Z:3ڏvk%8', '{z6RVjֵ\"\"6', '', 0, '?'),
 ('lw/A+k\0]E\"$ֽ', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent.php', 0, '|\"v%cA0', '|\"v%cA0', '72IwCCPk%\0]BWQ', '', 0, '?'),
 ('^@P\'=tp', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('@2?*r&', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('G^q/U9㕚', 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ϜDn|yd<C$', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.exceptions.php', 0, '$ݙ]?9', '$ݙ]?9', 'U\\D4&#^=$r0v{\Z]', '', 0, '?'),
 ('@]ʱo]Ig)', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.logger.php', 0, '6xoWzX', '6xoWzX', 'kֿv*uEX&EW', '', 0, '?'),
 ('(q㜴Uw3', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.io.php', 0, 'KJ[%', 'KJ[%', ':JѫHV3#=\'y%Ğ?O', '', 0, '?'),
 ('3#\0IJOHQ', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.net.php', 0, 'GQ)]', 'GQ)]', 'sYr1iEjM=~\re|', '', 0, '?'),
 ('HbsI?P]o', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.os.php', 0, '}L_E', '}L_E', 'ڮK\\sR[q:rtŏ*+L', '', 0, '?'),
 (' =<&nv#z!Y', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.stream.php', 0, 'A<2R/G', 'A<2R/G', '8O\nߖ2%UA[ɢ\nkBer', '', 0, '?'),
 ('\Z(1o3R', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.string.php', 0, 'cJhJ7WK', 'cJhJ7WK', 'j;=9\nHc\nS9Lq\"', '', 0, '?'),
 ('-sMxY?.M', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.ui.php', 0, ':K]]Y', ':K]]Y', 'DO@qdf\rA_7O`.', '', 0, '?'),
 ('Jݺf^)', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.url.php', 0, 'ŵM,	oQF', 'ŵM,	oQF', 'ERFnrM}{kyglLߩ', '', 0, '?'),
 ('sM??QS^', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.util.php', 0, 'u-]9*Q', 'u-]9*Q', '(bK)ZZiF(X)j3', '', 0, '?'),
 ('ЯÌa>3', 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.wp.php', 0, 'ߢ߽\0ڟ\' Z\\ܾ', 'ߢ߽\0ڟ\' Z\\ܾ', '0&/!vD3tE:֊', '', 0, '?'),
 ('L};\n\\ޗ', 'wp-content/plugins/duplicator-pro/lib/snaplib/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ZUBh|', 'wp-content/plugins/duplicator-pro/lib/snaplib/snaplib.all.php', 0, 'aĞ3k=I', 'aĞ3k=I', '5L&84}:^\\', '', 0, '?'),
 ('}|B١򠸹J', 'wp-content/plugins/duplicator-pro/lib/snaplib/wordpress.core.files.php', 0, 's;[%\r z\'', 's;[%\r z\'', ',60Exz@<', '', 0, '?'),
 ('u<bbV]', 'wp-content/plugins/duplicator-pro/tools/da-installer-extractor.php', 0, 'byY3]uKN`', 'byY3]uKN`', 'O4H4A\Z&[mv\\fWe', '', 0, '?'),
 ('>̇$yڏ\')', 'wp-content/plugins/duplicator-pro/tools/db-test.php', 0, 'w.Hk̩WA', 'w.Hk̩WA', '$WZ*L`Ț3^(0AT', '', 0, '?'),
 ('؉I&s\nkg5', 'wp-content/plugins/duplicator-pro/tools/file-renamer.php', 0, 'g==q^\"mV', 'g==q^\"mV', '{ް¬b31\"P`X(p8lF', '', 0, '?'),
 ('E~!\"m?\r6V\\', 'wp-content/plugins/duplicator-pro/tools/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('.?vDe.hbE}2', 'wp-content/plugins/duplicator-pro/uninstall.php', 0, 'k~<VL!\"F8qݴf\"', 'k~<VL!\"F8qݴf\"', 'qۨcˤU⢶\Zlq`*I', '', 0, '?'),
 ('rUڶ6+dV', 'wp-content/plugins/duplicator-pro/views/inc.header.php', 0, 'LiW%f3L', 'LiW%f3L', 'W>~${濰5zIs=l6', '', 0, '?'),
 ('zM;ks^', 'wp-content/plugins/duplicator-pro/views/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('8w`cF&', 'wp-content/plugins/duplicator-pro/views/packages/controller.php', 0, 'jM-|ۯXOw1', 'jM-|ۯXOw1', '=B26_AXeNMOFdUK', '', 0, '?'),
 ('d:F($*', 'wp-content/plugins/duplicator-pro/views/packages/details/controller.php', 0, 'L;]Ŏl\Z=', 'L;]Ŏl\Z=', ' svBm8铷 ˪\rn[', '', 0, '?'),
 ('܇\"]\rx%O>', 'wp-content/plugins/duplicator-pro/views/packages/details/detail.php', 0, '&nZD7', '&nZD7', '-avew=f,Ԇ}*jy', '', 0, '?'),
 ('\0h2E{', 'wp-content/plugins/duplicator-pro/views/packages/details/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('N=qYk', 'wp-content/plugins/duplicator-pro/views/packages/details/transfer.php', 0, 'ά4=8', 'ά4=8', '`u)n\ZqKՂjL1d', '', 0, '?'),
 (',\03S*ś#', 'wp-content/plugins/duplicator-pro/views/packages/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Zߥ7܋', 'wp-content/plugins/duplicator-pro/views/packages/main/controller.php', 0, ')\\JE.eF\'', ')\\JE.eF\'', '#^0D\Z4 eQp\n9}*', '', 0, '?'),
 ('?ELJ2{Q״j', 'wp-content/plugins/duplicator-pro/views/packages/main/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('暯R0%ɵc?', 'wp-content/plugins/duplicator-pro/views/packages/main/packages.php', 0, 'ݷIkԝWIDa', 'ݷIkԝWIDa', '4blX.Y4\'{H#9gq5r', '', 0, '?'),
 ('&uKƑ', 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup0.base.php', 0, ',`i։', ',`i։', '\nXx!4a^g Yq', '', 0, '?'),
 ('3RWhi', 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup1.reqs.php', 0, '|_s', '|_s', 'eʥgu\\,HatF$\"', '', 0, '?'),
 ('x5i4', 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup2.store.php', 0, 'HIPQ4rۯ{TV', 'HIPQ4rۯ{TV', '|dVȟt\nƄhH!K/t', '', 0, '?'),
 ('{Ia\ZD`r', 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup3.archive.php', 0, 'ixGXˍeB{', 'ixGXˍeB{', '*ȥJ a1tЄl	NF!z\09s', '', 0, '?'),
 ('lA', 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup4.install.php', 0, 'ӹ84JۍMۋ', 'ӹ84JۍMۋ', '@{S7\r{>a%GF#l=', '', 0, '?'),
 ('\'kխQ*,;', 'wp-content/plugins/duplicator-pro/views/packages/main/s2.scan1.base.php', 0, 'RF#|^G2', 'RF#|^G2', 'SJ04g4;ml9k', '', 0, '?'),
 (']\"Al_+0O', 'wp-content/plugins/duplicator-pro/views/packages/main/s2.scan2.server.php', 0, 'OhL~FJֳ', 'OhL~FJֳ', 'يlTd.sZ;{.MX<	', '', 0, '?'),
 ('[CqH1孎', 'wp-content/plugins/duplicator-pro/views/packages/main/s2.scan3.archive.php', 0, 'prj2ؼ;', 'prj2ؼ;', ';Q7m3UxeeP9', '', 0, '?'),
 ('h\0qnc10\Z6', 'wp-content/plugins/duplicator-pro/views/packages/screen.php', 0, '!XFi', '!XFi', '~-rL7PmО', '', 0, '?'),
 ('4i	nI', 'wp-content/plugins/duplicator-pro/views/schedules/controller.php', 0, '&UPl Qb', '&UPl Qb', 'Zt\Zftf21`,Gj	', '', 0, '?'),
 ('at1ުM!_', 'wp-content/plugins/duplicator-pro/views/schedules/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('rg~} 8\n)', 'wp-content/plugins/duplicator-pro/views/schedules/schedule.controller.php', 0, '2V3!}j', '2V3!}j', 'xUW>p>\'<\rNv8pt', '', 0, '?'),
 ('D6/ٸ8Ӯ', 'wp-content/plugins/duplicator-pro/views/schedules/schedule.edit.php', 0, '>3+;c	\n@r', '>3+;c	\n@r', '*֙4ȎW\re', '', 0, '?'),
 ('&!x3-_(-', 'wp-content/plugins/duplicator-pro/views/schedules/schedule.list.php', 0, 'xk)뗵Aݍ\0', 'xk)뗵Aݍ\0', 'vfnZ<Ͷt6fdԕfbw', '', 0, '?'),
 ('Ы$l3\Zj8', 'wp-content/plugins/duplicator-pro/views/settings/controller.php', 0, 'mk8d0U5\0^<i', 'mk8d0U5\0^<i', '	4ZL18zѝo<8Uc', '', 0, '?'),
 ('r}Pʽ.', 'wp-content/plugins/duplicator-pro/views/settings/general/inc.feature.php', 0, '8d祵G4he1', '8d祵G4he1', 'yU5d(O4%r+/', '', 0, '?'),
 ('?*>ftuR', 'wp-content/plugins/duplicator-pro/views/settings/general/inc.general.php', 0, '2&.]ƭA6', '2&.]ƭA6', '2Te>-uD$<}T', '', 0, '?'),
 ('Mr~0dEGI	', 'wp-content/plugins/duplicator-pro/views/settings/general/inc.migrate.php', 0, 'O\nZY2e㺷U', 'O\nZY2e㺷U', ':O:\n)/<̓O[hgT', '', 0, '?'),
 ('T7Z\ZHDUt', 'wp-content/plugins/duplicator-pro/views/settings/general/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (')nrlū<', 'wp-content/plugins/duplicator-pro/views/settings/general/main.php', 0, 'd+kIku', 'd+kIku', 'n}UDg\\HтWKvHJ|', '', 0, '?'),
 (';vӹoĢ[P[G', 'wp-content/plugins/duplicator-pro/views/settings/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (';!', 'wp-content/plugins/duplicator-pro/views/settings/licensing.php', 0, 'flT2Tbu', 'flT2Tbu', '}eNd\"f<u^CX\'Ik', '', 0, '?'),
 ('+d{(Qq3:', 'wp-content/plugins/duplicator-pro/views/settings/package/inc.advanced.php', 0, 'ё*(,\r', 'ё*(,\r', '?-;}fVS?~K6yNhKz\rM', '', 0, '?'),
 (']JR13n', 'wp-content/plugins/duplicator-pro/views/settings/package/inc.basic.php', 0, '7X%t&', '7X%t&', '76;U`?|u[s,<]\r(', '', 0, '?'),
 ('ro\'|XeߦL', 'wp-content/plugins/duplicator-pro/views/settings/package/inc.brand.edit.php', 0, ';ӭ~)pKIrL)', ';ӭ~)pKIrL)', 'X-Ĵ9>%ߥ2ذ\'', '', 0, '?'),
 ('Vb}\\٪(x', 'wp-content/plugins/duplicator-pro/views/settings/package/inc.brand.list.php', 0, 'pOP\Zq', 'pOP\Zq', '2lv=Bt%f#TKTkPA>', '', 0, '?'),
 ('SrFZpk', 'wp-content/plugins/duplicator-pro/views/settings/package/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('2wir,B', 'wp-content/plugins/duplicator-pro/views/settings/package/main.php', 0, 'THwl-\Z|Q%', 'THwl-\Z|Q%', ')RI\r-TլAnD_', '', 0, '?'),
 ('}ry^q4 p', 'wp-content/plugins/duplicator-pro/views/settings/schedule.php', 0, 'Mz{d\"o', 'Mz{d\"o', 'd*O)}^r];	', '', 0, '?'),
 ('\Z6z93', 'wp-content/plugins/duplicator-pro/views/settings/storage.php', 0, '.\r995', '.\r995', 'd6ݔzGLH&L<| =/', '', 0, '?'),
 ('4ٞ[^D', 'wp-content/plugins/duplicator-pro/views/storage/controller.php', 0, 'p;p@].&5|4', 'p;p@].&5|4', 'L3&z;h\r1j6܆]((CsFz', '', 0, '?'),
 ('T\'M	WA', 'wp-content/plugins/duplicator-pro/views/storage/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('x+\'', 'wp-content/plugins/duplicator-pro/views/storage/storage.controller.php', 0, 'F+>HTve4U', 'F+>HTve4U', '#\nv*P%HVXy\rm=NjB.', '', 0, '?'),
 ('H@?u\\', 'wp-content/plugins/duplicator-pro/views/storage/storage.edit.default.php', 0, 'fJ	`h7Q', 'fJ	`h7Q', 'R\rnn91\n8 -*', '', 0, '?'),
 ('_0oGq', 'wp-content/plugins/duplicator-pro/views/storage/storage.edit.php', 0, '()VNk)a{mq', '()VNk)a{mq', 'iNB\'UIwjx)g\"TN4Ta', '', 0, '?'),
 ('}U-leEb+1', 'wp-content/plugins/duplicator-pro/views/storage/storage.list.php', 0, 'eA-w1s', 'eA-w1s', '!:|e/)Nyu/', '', 0, '?'),
 ('r~ywR\0Q', 'wp-content/plugins/duplicator-pro/views/tools/controller.php', 0, '74t) pr', '74t) pr', '֐9o#@%a@;\nHeoc', '', 0, '?'),
 ('		hrA0', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/diagnostic.php', 0, 'C8A\0i\0', 'C8A\0i\0', 't .ɕ\"_Bc\Z', '', 0, '?'),
 ('hĻ3/', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.data.php', 0, 'V\n\rи', 'V\n\rи', '8tۦkv]wrP+', '', 0, '?'),
 (';hAJj>5R\"&', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.phpinfo.php', 0, 'CvY8\rNә7\'V', 'CvY8\rNә7\'V', '[RNɅ麛Peˆ³Ŏ', '', 0, '?'),
 (' 5X W\Z~\n', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.settings.php', 0, 'l8Y>a*ɍ[L', 'l8Y>a*ɍ[L', 'Lu|d;eNۜRgQmi', '', 0, '?'),
 ('cˍIJ[', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.validator.php', 0, 'r򍅢no3ma', 'r򍅢no3ma', 'Z j:Eȍn꣉N0,vg', '', 0, '?'),
 ('9?{gw^Ӝ)\n', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (',uvt BZL', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/log.php', 0, '_78mf>z', '_78mf>z', 'Lc\0_Ǜ)iެW', '', 0, '?'),
 ('Ѓ3	clwL]~4pk', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/main.php', 0, 'e9R~j]', 'e9R~j]', '-LUM=;c` zu[s\n1?', '', 0, '?'),
 ('hISe.It', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/phplogs.php', 0, '8#:8lY', '8#:8lY', 'o;lz_D]j>\\-b\'@ׄ', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('l!͚8', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/support.php', 0, 'i\"|F#', 'i\"|F#', 'jn*nUƩM!hL][', '', 0, '?'),
 ('Ҭ|LZ~?Y\0', 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/tests.php', 0, '//aQ-˓P', '//aQ-˓P', 'T륖Qc;pȯ)m', '', 0, '?'),
 ('4TxIserD', 'wp-content/plugins/duplicator-pro/views/tools/import.php', 0, '>9N745@', '>9N745@', '軩OLQG\rDCd|', '', 0, '?'),
 (']bSho0LΎ(', 'wp-content/plugins/duplicator-pro/views/tools/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (')*Z`v@', 'wp-content/plugins/duplicator-pro/views/tools/support.php', 0, '&V]8\'E\r\',w', '&V]8\'E\r\',w', ' Q_I)6!a#ttUi', '', 0, '?'),
 ('	8~\"w#', 'wp-content/plugins/duplicator-pro/views/tools/templates/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Iuqe>', 'wp-content/plugins/duplicator-pro/views/tools/templates/main.php', 0, '9\rX)X', '9\rX)X', 'nYU\'^%Z@\'\rL}', '', 0, '?'),
 ('ERpHuT%=p', 'wp-content/plugins/duplicator-pro/views/tools/templates/template.edit.php', 0, ':	', ':	', '(8i{ˆ°KѢ՟9R-9', '', 0, '?'),
 ('.2d򥷭', 'wp-content/plugins/duplicator-pro/views/tools/templates/template.list.php', 0, 'xXff?@B	', 'xXff?@B	', '9oOj3${N3\"L0#', '', 0, '?'),
 ('puwSɴ0', 'wp-content/plugins/hello.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Et5\0Pw', 'fs	uc~0bI&5)', '', 0, '?'),
 ('0*W', 'wp-content/plugins/index.php', 0, 'gD,V=\\bP', 'gD,V=\\bP', 'k~	UH\ZxPĀ<;X', '', 0, '?'),
 ('M^wBi/8', 'wp-content/plugins/login-customizer/CHANGELOG.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n{sK&\0B0', 'i. )t p-7@Xg^\"Ŕ2K', '', 0, '?'),
 (',iNӜ;	', 'wp-content/plugins/login-customizer/assets/logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wNe7T=TTP,', '?ꅯhCoƻ', '', 0, '?'),
 ('^lА+\ZR1', 'wp-content/plugins/login-customizer/assets/orbit-fox.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '˻Co9mI$', '^qȌs\ZfsVrg5הZ', '', 0, '?'),
 ('CCgjE', 'wp-content/plugins/login-customizer/assets/templates/dark.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rljsʺ', '֞p#\'&Ĺf#tM.', '', 0, '?'),
 ('m2Mh', 'wp-content/plugins/login-customizer/assets/templates/material.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',?,㾺X&Ms', '`J<\\0{.I=KWhH\0=', '', 0, '?'),
 ('(Rӆ^', 'wp-content/plugins/login-customizer/assets/templates/original.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ޡR_0kP', '0Km*P6-QVx', '', 0, '?'),
 ('\n$/!PL=F', 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/alpha-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZD\0sOx\"H}{', 'vKuH#xf~Qpet5tY', '', 0, '?'),
 ('<Sp4{m', 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/assets/css/alpha-control.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}C$s*(ה(z', 'ǡ9>Z;=\0?S\\@[c|iG', '', 0, '?'),
 ('LXO=rFlj', 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/assets/img/transparency-grid.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[^QǪ\r:;5', '˝?#O	CM\\\n\0VY', '', 0, '?'),
 ('Ơk/d6ٞru', 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/assets/js/alpha-control.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w; G', 'Sx.)s4h _z8{	!ߊP', '', 0, '?'),
 ('\0x)tg44Qr', 'wp-content/plugins/login-customizer/inc/customizer/controls/cool-stuff/assets/css/cool-stuff-control.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e7CvW@H\rJ', 'pI7XȎ	fD#]MĀ(5', '', 0, '?'),
 ('Gsw̺{Ap/', 'wp-content/plugins/login-customizer/inc/customizer/controls/cool-stuff/cool-stuff-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Pi0}aM', '\'(pGK;|~DO3,\Z', '', 0, '?'),
 ('G\n˚٢OL	', 'wp-content/plugins/login-customizer/inc/customizer/controls/padding/assets/css/padding-control.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lr	ܾA', 'm%*s5`2&㡶?,`z', '', 0, '?'),
 ('\"~\"m<+m\0\nQ', 'wp-content/plugins/login-customizer/inc/customizer/controls/padding/assets/js/padding-control.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/]ռ344X4', 'N\0rI2	:޿$ZG>n', '', 0, '?'),
 ('{[)j}AO7', 'wp-content/plugins/login-customizer/inc/customizer/controls/padding/padding-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LVi=$~3', '>\"6$2Yn,ޥ', '', 0, '?'),
 ('WGG`', 'wp-content/plugins/login-customizer/inc/customizer/controls/radio-images/assets/css/radio-images-control.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yvl*6rNb', '_OWSܛ\nIeVӻI', '', 0, '?'),
 ('⍅E֩eI\n\r', 'wp-content/plugins/login-customizer/inc/customizer/controls/radio-images/radio-images-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cpr=BUK', '{~ԌKtp/*+c_m\n~s', '', 0, '?'),
 ('80e:yiE/gh', 'wp-content/plugins/login-customizer/inc/customizer/controls/range-slider/assets/css/range-slider-control.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7b&K~)(', 'DAbo=\"҄vb=f,0\Z', '', 0, '?'),
 (',NvO\Zs0|', 'wp-content/plugins/login-customizer/inc/customizer/controls/range-slider/assets/js/range-slider-control.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!oyn`mD', 'M1\\@(\'}{5', '', 0, '?'),
 ('ܾ!', 'wp-content/plugins/login-customizer/inc/customizer/controls/range-slider/range-slider-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʫmj𮍊H:', '_Y\'7;CNGRx&x69=P', '', 0, '?'),
 ('	Kx{>', 'wp-content/plugins/login-customizer/inc/customizer/controls/toggle/assets/css/toggle-control.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3-Kﻭ2\"\"\rm', '_	)&E]5b%OJ@+\Zk\Z', '', 0, '?'),
 ('[O	Cnp', 'wp-content/plugins/login-customizer/inc/customizer/controls/toggle/assets/js/toggle-control.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#wQw1@y', 'r(+\Z^@AD^', '', 0, '?'),
 ('~	d||^', 'wp-content/plugins/login-customizer/inc/customizer/controls/toggle/toggle-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q>\'Z+35l', 'v#>Cjj?.*8?', '', 0, '?'),
 ('9a-m:', 'wp-content/plugins/login-customizer/inc/customizer/css/customizer.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('ާ(9;s>k', 'wp-content/plugins/login-customizer/inc/customizer/custom-code.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '//\'K', ':5VWìm(2lLȇ/4-', '', 0, '?'),
 ('ޡ.=+', 'wp-content/plugins/login-customizer/inc/customizer/customizer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/ut7Pa;', ']Q<]1,YMVa7ΰ\"', '', 0, '?'),
 ('\0ͦ 6͹dc', 'wp-content/plugins/login-customizer/inc/customizer/functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QbdVcAXq$', '^HFU,DLR/̣NX6@HY', '', 0, '?'),
 ('32?D3|', 'wp-content/plugins/login-customizer/inc/customizer/js/customizer-preview.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	ME\r\04} G', '<я\rҵCƥʒa\\4N', '', 0, '?'),
 ('#e	g+', 'wp-content/plugins/login-customizer/inc/customizer/js/customizer.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DZL?;~ey,w', '2w\rF3a\rC{JGKe!q{', '', 0, '?'),
 ('x(ه;=n?x', 'wp-content/plugins/login-customizer/inc/customizer/sanitizers.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#C@,Y', '\0JgIP5z(z:p9k=2gR', '', 0, '?'),
 (']DFcۺs', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-background.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h\'uz\'Ӭ', '82h~P5aY,<\"zZ_f', '', 0, '?'),
 ('mSrԸT!', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-button.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"rm!7#>i', 'ޯߏq(K{KUtZ\'', '', 0, '?'),
 ('I>沄iGthj+', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-code.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hF鐡.', 'DugfP|G-\'mÓ\r', '', 0, '?'),
 ('\nG~S\Z', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-fields.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6Tgy?kW', 'C̯мA\"p*o?{h!u4FW', '', 0, '?'),
 ('{ }(\nrY{', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-form.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WZFP1\0', 'wEԉ`kU=p6U\0*TP0u', '', 0, '?'),
 ('sU0J)C', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-logo.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ëj\'WBh', 'ib3#؞пi[\nw?O', '', 0, '?'),
 ('M5ls*9\\N', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-more.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9#)ph/4٩:\rH', '/QrΥKy,xb}B5v+Ѓl>kh', '', 0, '?'),
 ('0Qe}zu', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-other.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@5\"y_)\n\0', '@8c2w0/*θ}^Y{<\rUuv', '', 0, '?'),
 ('o6]a\rW', 'wp-content/plugins/login-customizer/inc/customizer/sections/section-templates.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A{S)WhE;', 'եZ4uILOsxD4\0f', '', 0, '?'),
 (',[=c\"X*/S', 'wp-content/plugins/login-customizer/inc/include-page-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZcRsP8͇)', 'oŞ1{\r;_E0?ژ', '', 0, '?'),
 ('YT֜', 'wp-content/plugins/login-customizer/inc/initial-setup.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O(,)ą', 'Zc6Ֆj:@=zBXhʐ	Mb', '', 0, '?'),
 ('g˛Kzr>(,', 'wp-content/plugins/login-customizer/inc/mailin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IaI', 'o:DeABP~# )_3$k', '', 0, '?'),
 ('fhi0o0[9>', 'wp-content/plugins/login-customizer/inc/template-login-customizer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LH>x[ܡ;', 'E#uU=\"0mȭvL_', '', 0, '?'),
 ('vTPS+', 'wp-content/plugins/login-customizer/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ؠתB\nwt', '݇r\r,Z\'l;4 xn_\no_', '', 0, '?'),
 ('7;\n.u', 'wp-content/plugins/login-customizer/languages/login-customizer.pot', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ey}L', '<qcN(ܮ=؞N\"nz17v{R', '', 0, '?'),
 ('$2 i&B\0wcX3', 'wp-content/plugins/login-customizer/login-customizer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fLW>ZH', ';1fp* W{[M', '', 0, '?'),
 ('~	X-', 'wp-content/plugins/login-customizer/readme.md', 0, 'ޡO\"h¼[\\v', 'ޡO\"h¼[\\v', 'sFtz=ӕvI\\\rp', '', 0, '?'),
 ('ӹS#|SHJv\0\'', 'wp-content/plugins/login-customizer/readme.txt', 0, '4|\"Wih', '4|\"Wih', 'Y}\r2pnzRє8Û', '', 0, '?'),
 ('w([\'9', 'wp-content/plugins/login-customizer/screenshot-1.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O*Ef 8', '\rȭU>#Z}Z\'ZL3@Rs', '', 0, '?'),
 ('ʚgêV', 'wp-content/plugins/login-customizer/screenshot-2.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q\0}7z ', '/a4d}E\0;#', '', 0, '?'),
 ('FV4:^8', 'wp-content/plugins/login-customizer/setup.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z %g\"{R5', 'œr^\'k6H|Kc-\\Jt', '', 0, '?'),
 ('Usj6\"`z', 'wp-content/plugins/login-customizer/themeisle-hash.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' \ZTf]f~', 'x\ZxL]hTqx:oxZ,w	ݽ', '', 0, '?'),
 (' _2vxKE>8', 'wp-content/plugins/login-customizer/vendor/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'7BC, P', 'qv{\"E倗X}qqUK9ɇ;', '', 0, '?'),
 ('!<HD', 'wp-content/plugins/login-customizer/vendor/autoload_52.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/l	uYϮڷ', ' 3if)/Uʝ^^sr', '', 0, '?'),
 ('Y\Z )jej', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M+SO]', 'x6@\nqvdR>{8^_pQ', '', 0, '?'),
 ('A\ndi\"8ů', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-endpoints.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$ESV܏>A[O2\r', '/`1T^ۇ\04ۙ>\ZVxhaTO', '', 0, '?'),
 ('(n&W\"O', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-deactivate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iEfa', 'C*5U	ڞEDbfyȆ', '', 0, '?'),
 ('*P-kS7@', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-factory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nkk7ߧk3', ':	֜~?Gp%*,w\']f)', '', 0, '?'),
 ('Jǰn9& e66', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-review.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`7Z:\\?,nJ', 'buoc6KQX&D', '', 0, '?'),
 ('}81{\nX*\n5g', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-translate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6*ft&', '&׉`>`6Bx ĥy-L', '', 0, '?'),
 ('5^qwIE<', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݿ((Hl*e', 'ZUadRy#	<.', '', 0, '?'),
 ('IT9SzV', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-licenser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uWh', 'i?d{-%<U+U:_Lf', '', 0, '?'),
 ('=t#', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-loader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wMHDݓ', '[rB[)߬,T179', '', 0, '?'),
 ('s]\0INrf', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-logger.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BJx=$0y', '\'E4cpu5Ђ\\-<,', '', 0, '?'),
 ('X!ÂD_U', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-notification-manager.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5\0{S;', 'F~MZp\r{)e\Z%؍bKufs', '', 0, '?'),
 ('//S*\"\ndj', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-product.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&\re2W', 'I+:=._rׄC%9gN', '', 0, '?'),
 ('ͩ0\\jV\'0C\n', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-rollback.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y1aTز*Ui', '~X/@i=@3uP0', '', 0, '?'),
 ('oAj_+$q\n', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget-dashboard-blog.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`/.!m4', '~H.\0w.P=\0MyJa>', '', 0, '?'),
 ('L3/{C', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yl\0͞w9:', 'Pt<_dS(yy(j\n', '', 0, '?'),
 ('+Tz\\o_!', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widgets-factory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=7BHIqdLo', ' C41ثaFN/̱I', '', 0, '?'),
 ('/,JC', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nokf^D:', '	]f3}DF\0 1 ', '', 0, '?'),
 ('\'U>utS]', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6vKL)k', 'T3sr_Y7q˴Wek}8', '', 0, '?'),
 ('\0Hۜ\rmY', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/load.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fꀔa\Zp-', 'W5U0顷	鶔r2\0BRRK(', '', 0, '?'),
 ('.?PP,Z\Z0+', 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/start.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'χۆG8', '=ʻSEƽg}nވ\n`FIt', '', 0, '?'),
 ('h$', 'wp-content/plugins/login-customizer/vendor/composer/ClassLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~1ηP *.', 'k<.&4Vןp', '', 0, '?'),
 ('i_w[ͻԍ', 'wp-content/plugins/login-customizer/vendor/composer/ClassLoader52.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȹ	Z^+}i', 'N{>Zށd@iVwWU;', '', 0, '?'),
 ('aSD?o', 'wp-content/plugins/login-customizer/vendor/composer/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')4FS˼', '\rOs`NwZv', '', 0, '?'),
 ('\0 ĳqvKТؠ', 'wp-content/plugins/login-customizer/vendor/composer/autoload_classmap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 ('WYAT7&xcu', 'wp-content/plugins/login-customizer/vendor/composer/autoload_files.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5NA', '?g|}apEM=*׸P})', '', 0, '?'),
 ('n͐LǎFXz;', 'wp-content/plugins/login-customizer/vendor/composer/autoload_namespaces.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	ꯚ9Yx', 'r.p$ғM&fqC', '', 0, '?'),
 ('@kJ3q+HI', 'wp-content/plugins/login-customizer/vendor/composer/autoload_psr4.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':\0>}LQ\0', '_U\0]q=Չf\\/	@d\r+v*(', '', 0, '?'),
 ('q|dF79', 'wp-content/plugins/login-customizer/vendor/composer/autoload_real.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_1ӧyz', ',#sǯEd7|zƿr/2', '', 0, '?'),
 ('}_	v', 'wp-content/plugins/login-customizer/vendor/composer/autoload_real_52.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ŮL1J', 'g\'k\Z\\1m,vSиw8', '', 0, '?'),
 ('̑\"	!/ȹ', 'wp-content/plugins/login-customizer/vendor/composer/installed.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tϐ`(\r', '$2.)H|cBiC1\0vVm%', '', 0, '?'),
 (';{%𗡲54', 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z-fm֙', 'ybޞp@m˻d6En0+!8', '', 0, '?'),
 ('7\rF\'Skc', 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/b`\"t', 'P6%1dlLش=;a%baV', '', 0, '?'),
 ('#`:!~', 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ܮ&<}rb\\V', 'E+Y}n\'[rN۝!	>X22', '', 0, '?'),
 ('GdWiAe|', 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/AutoloadGenerator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd\Z\r(v:`N\n', 'qG\"w%\Zۻށg\\4^W', '', 0, '?'),
 ('~JH', 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/ClassLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȹ	Z^+}i', 'N{>Zށd@iVwWU;', '', 0, '?'),
 ('){`kD wg', 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/Generator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7j`1e=jv', '\0\0%ȰW\n\0IHG(', '', 0, '?'),
 ('0R)/K\"', 'wp-content/plugins/revslider/admin/assets/css/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('i\0Ֆ>ŭ)', 'wp-content/plugins/revslider/admin/assets/icons/MaterialIcons-Regular.svg', 0, 'eYLP/(:', 'eYLP/(:', '坴YCN:Q9kdZkxO', '', 0, '?'),
 ('\r{2T\rv0', 'wp-content/plugins/revslider/admin/assets/images/sources/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('n]|{ QW', 'wp-content/plugins/revslider/admin/assets/index.php', 0, '{J!u?}s', '{J!u?}s', 'Aũ`97}b>MHJHh|Fj', '', 0, '?'),
 ('!QMe^@aq;QR', 'wp-content/plugins/revslider/admin/assets/js/modules/admin.min.js', 0, ')aPE2Cd', ')aPE2Cd', '{4Kgǲ`\'d', '', 0, '?'),
 ('\'9ddh^uM', 'wp-content/plugins/revslider/admin/assets/js/modules/editor.min.js', 0, 'ZT;j', 'ZT;j', 'B7xtۇ%wd]', '', 0, '?'),
 ('8CGa↞Vg', 'wp-content/plugins/revslider/admin/assets/js/modules/help.js', 0, ';Amܝ:6ZD\n', ';Amܝ:6ZD\n', '|GC\0ʨ|xqA0mywW', '', 0, '?'),
 ('Yq  #\n~&\Z', 'wp-content/plugins/revslider/admin/assets/js/modules/overview.min.js', 0, 'q3ڻh', 'q3ڻh', '/J\r\rs4SYc9ptcR>`%', '', 0, '?'),
 ('4[KaiY9', 'wp-content/plugins/revslider/admin/assets/js/modules/tooltip.js', 0, 'ugiQ1ϾڤT', 'ugiQ1ϾڤT', '(F8qQ\nBL	aWP', '', 0, '?'),
 ('CUAOB', 'wp-content/plugins/revslider/admin/assets/js/plugins/codemirror.js', 0, '4G%-q', '4G%-q', 'Y!P\'xiPlE.e?5', '', 0, '?'),
 ('O{\Z]Nޣ', 'wp-content/plugins/revslider/admin/assets/js/plugins/penner-easing.js', 0, 'H##ډ>Q^', 'H##ډ>Q^', 'F*Q	61jp\rI>\'', '', 0, '?'),
 ('Ԅ׆k抜k-', 'wp-content/plugins/revslider/admin/assets/js/plugins/utils.min.js', 0, 'i~\"yL4L', 'i~\"yL4L', '[jvnO88TW:)P ˎ	', '', 0, '?'),
 ('d`gsN', 'wp-content/plugins/revslider/admin/assets/js/plugins/wavesurfer.js', 0, 'fB8U\\Nx', 'fB8U\\Nx', '}ƸG#3>~Vôf9', '', 0, '?'),
 ('buDv_%US', 'wp-content/plugins/revslider/admin/assets/js/shortcode_generator/shortcode_generator.js', 0, '{:jb7Ӏ', '{:jb7Ӏ', '`=(\nL/WkyG^{#\'z\'y', '', 0, '?'),
 ('\'@ܓi\n', 'wp-content/plugins/revslider/admin/assets/js/shortcode_generator/tinymce.js', 0, 'M\n>Ϡ\"k_FS', 'M\n>Ϡ\"k_FS', 'AJXzm%XYgAF77 Uğ', '', 0, '?'),
 ('dJ)ԵRw', 'wp-content/plugins/revslider/admin/assets/js/shortcode_generator/vc.js', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('!ϕfPG', 'wp-content/plugins/revslider/admin/includes/addons.class.php', 0, '7X@Ԫu3f', '7X@Ԫu3f', 'xL	D`4$ystP\Z|^', '', 0, '?'),
 ('>򂿘^jAw\"', 'wp-content/plugins/revslider/admin/includes/debug.php', 0, 'iSl-fnm', 'iSl-fnm', '`$bt\"̔d|!qX', '', 0, '?'),
 ('GI8L1c', 'wp-content/plugins/revslider/admin/includes/export-html.class.php', 0, '\Z \n8 ', '\Z \n8 ', ';dt[[F)^l/K&fI`.', '', 0, '?'),
 ('^#\\KZxVX', 'wp-content/plugins/revslider/admin/includes/export.class.php', 0, '^W', '^W', 'lKazmչܑn', '', 0, '?'),
 ('wON`XK)kb4彮', 'wp-content/plugins/revslider/admin/includes/folder.class.php', 0, 'Oǝ5(]q', 'Oǝ5(]q', 'Ġ\"MPHrLF=cK=V!\"Qd', '', 0, '?'),
 (')\0B)+\':f', 'wp-content/plugins/revslider/admin/includes/functions-admin.class.php', 0, 'ew\n;`', 'ew\n;`', '>PBvU~)J\'Vf;', '', 0, '?'),
 ('<u0Qd#', 'wp-content/plugins/revslider/admin/includes/help.class.php', 0, 'Sp6\\\0', 'Sp6\\\0', 'lJ	UcLD4sn8^l7,k', '', 0, '?'),
 ('Bn	eN', 'wp-content/plugins/revslider/admin/includes/import.class.php', 0, '3~a˔Q`@ɟ', '3~a˔Q`@ɟ', '5oC\0]Oy^\\s', '', 0, '?'),
 ('Ws*uJs-', 'wp-content/plugins/revslider/admin/includes/license.class.php', 0, '5vED~B', '5vED~B', 'UT}eEWVN5g+X|B', '', 0, '?'),
 ('BSBZ2(_\r', 'wp-content/plugins/revslider/admin/includes/loadbalancer.class.php', 0, 'jq_Tш8#', 'jq_Tш8#', 'ɋ2Qd	\'auE}', '', 0, '?'),
 ('NlܕK\\^', 'wp-content/plugins/revslider/admin/includes/newsletter.class.php', 0, '>Z&;+t@ ', '>Z&;+t@ ', '\\Kg܏4+0f\Z\nWs', '', 0, '?'),
 ('v3\"R^bZ', 'wp-content/plugins/revslider/admin/includes/plugin-update.class.php', 0, ';-', ';-', 'F~%實uj	%\r,a\\$_', '', 0, '?'),
 ('!Lc\ndC=', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/elementor/elementor-widget.class.php', 0, 'pJi``_%l', 'pJi``_%l', 'x@^Ȓ5믙LO*++', '', 0, '?'),
 ('U`):Bt*', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/elementor/elementor.class.php', 0, 'IvBer-2Du}', 'IvBer-2Du}', '8خ:p\\c\r0lR&Y@', '', 0, '?'),
 ('kSkHčËƿ', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/dist/blocks.build.js', 0, 'EpSt/', 'EpSt/', '\"ĪP,øX=`A+', '', 0, '?'),
 ('˄ސidv', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/gutenberg-block.php', 0, 'uC,tñ\r\\', 'uC,tñ\r\\', '%!Grz0,7ىZ*A', '', 0, '?'),
 ('-ꁠqujˮm', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/plugin.php', 0, 'BLB\Z!G', 'BLB\Z!G', '5C-NLp<q4Z', '', 0, '?'),
 ('t@OW܊Pu', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/assets/images/js-wapuu.svg', 0, 'a},1', 'a},1', '\nawv)Ep<B_}YJ\0\"ixo<\'', '', 0, '?'),
 ('י`.A5', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/blocks.js', 0, ')CxVR', ')CxVR', 'XV$ 9l?%<7jcc0J\Z>', '', 0, '?'),
 ('\r\Z	0', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/gutenberg-block.php', 0, '9xJy\r!>', '9xJy\r!>', ']M=GEɮ\rMnȖ4+', '', 0, '?'),
 ('܏-s{R-', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/deprecated.js', 0, 'c$ส:vo\'', 'c$ส:vo\'', '\Z1Yޱe_Qz	CgzoG1', '', 0, '?'),
 ('\"x={F<\Z', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/index.js', 0, 'ޢF$', 'ޢF$', '۰!a=lwt{l*E', '', 0, '?'),
 ('ckxP:vn', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revSliderImage.js', 0, 'I\nl8\\hr', 'I\nl8\\hr', '{Mx\nHvp<N7N0 L', '', 0, '?'),
 ('h{z	Q>', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revslider.js', 0, 'dZ8O䯬t', 'dZ8O䯬t', 's\rZCeS\"ʿ%JRkFkȰ8', '', 0, '?'),
 ('(>}d3,', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/shortcode_generator.class.php', 0, 'J㨓&B', 'J㨓&B', '`De\ZC\\cKБ%K', '', 0, '?'),
 ('StRϚ|', 'wp-content/plugins/revslider/admin/includes/shortcode_generator/wpbakery/wpbakery.class.php', 0, 'Q3bІٷ', 'Q3bІٷ', 't>Fr&;h/ jz}G', '', 0, '?'),
 (']ΰy 3⻙-', 'wp-content/plugins/revslider/admin/includes/template.class.php', 0, 'ZR@EIBڳ|{:3', 'ZR@EIBڳ|{:3', '{dܡˢЅ݊%\Z6X', '', 0, '?'),
 ('TԸocrbZi', 'wp-content/plugins/revslider/admin/includes/tooltips.class.php', 0, 'gQŤo\0', 'gQŤo\0', '#˺Tr s\"(]&WS', '', 0, '?'),
 ('M(ͅ[:', 'wp-content/plugins/revslider/admin/includes/widget.class.php', 0, ',:P =*g\"', ',:P =*g\"', '`T-{\\$\Z`Meɘ%Nl\rYF', '', 0, '?'),
 ('B_.Jڣ', 'wp-content/plugins/revslider/admin/index.php', 0, '{J!u?}s', '{J!u?}s', 'Aũ`97}b>MHJHh|Fj', '', 0, '?'),
 (')ǿ.#SXxAO', 'wp-content/plugins/revslider/admin/revslider-admin.class.php', 0, '핇Ҍ5Vh', '핇Ҍ5Vh', '5q	K\Zr4L֌}vt0<i\'4Cs', '', 0, '?'),
 ('o+-/#EG^!?\n', 'wp-content/plugins/revslider/admin/views/builder-layer-forms.php', 0, 'i\\^ٔ)]', 'i\\^ٔ)]', '\r7P{}ɱB2Jo=`܅', '', 0, '?'),
 ('@q\'3<-\nh', 'wp-content/plugins/revslider/admin/views/builder-nav-forms.php', 0, '*qyY]=', '*qyY]=', 'uDh8u7ZZ?̞JSC*v*', '', 0, '?'),
 (']X H', 'wp-content/plugins/revslider/admin/views/builder-slide-forms.php', 0, '8EF籷e?', '8EF籷e?', 'I-QAg9Uh&d	EDv:', '', 0, '?'),
 ('yNӊx3+', 'wp-content/plugins/revslider/admin/views/builder-slider-forms.php', 0, 'Ur', 'Ur', 'E9Ah^\0z\ZJSĤ3)0\0', '', 0, '?'),
 ('0/\03', 'wp-content/plugins/revslider/admin/views/builder-timeline.php', 0, '!ޥr\"xWz', '!ޥr\"xWz', 'r+t`̩-p?ݚyh', '', 0, '?'),
 ('3LkC6Ʊ4', 'wp-content/plugins/revslider/admin/views/builder.php', 0, 'Cs,1j', 'Cs,1j', '8wL A]nEYa', '', 0, '?'),
 ('2Ț?qlnhD/', 'wp-content/plugins/revslider/admin/views/features/add_ons.php', 0, 'eFp^l7\\hu', 'eFp^l7\\hu', 'a<ggG欱g~S>', '', 0, '?'),
 ('ljKDW ~', 'wp-content/plugins/revslider/admin/views/features/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 (';a.mͰa=d', 'wp-content/plugins/revslider/admin/views/features/layer_animations.php', 0, 'C69~SM8\r.', 'C69~SM8\r.', 'b\0hnW/h0 AR9D\"qi3', '', 0, '?'),
 ('*#wO|', 'wp-content/plugins/revslider/admin/views/features/object_library.php', 0, '߿P4M', '߿P4M', 'o*;{Bb݅}Fw,<UU', '', 0, '?'),
 ('yB0N!P', 'wp-content/plugins/revslider/admin/views/features/premade_template.php', 0, 'aeg~(', 'aeg~(', ')\n5{EMBˎN_', '', 0, '?'),
 ('@XͶ%\',x', 'wp-content/plugins/revslider/admin/views/features/support.php', 0, ':Q#eDF>4Q/', ':Q#eDF>4Q/', '3GҺN`S4\0D.\r7', '', 0, '?'),
 ('X-zznό', 'wp-content/plugins/revslider/admin/views/footer.php', 0, '~8.`', '~8.`', 'X1\n^ba10Ww_/d\09', '', 0, '?'),
 ('@_q', 'wp-content/plugins/revslider/admin/views/header.php', 0, 'E&bB)d<', 'E&bB)d<', ')̣\nZ.EY.~9xb5{5', '', 0, '?'),
 ('S?sƛ', 'wp-content/plugins/revslider/admin/views/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('N	', 'wp-content/plugins/revslider/admin/views/modals-builder.php', 0, '=,CtuWI', '=,CtuWI', '|(+FFNl OMHl>4', '', 0, '?'),
 ('?aB/', 'wp-content/plugins/revslider/admin/views/modals-copyright.php', 0, '~=/|)gפ]S', '~=/|)gפ]S', 'D¿FD\ZV\rFǹ|xvО	', '', 0, '?'),
 ('VT;\0E r\"͡', 'wp-content/plugins/revslider/admin/views/modals-general.php', 0, '!ru	Y	6B`', '!ru	Y	6B`', '|-N:cЕG#in<V', '', 0, '?'),
 ('U险GА]L', 'wp-content/plugins/revslider/admin/views/modals-overview.php', 0, '3GyAXuqل', '3GyAXuqل', '>1s1v|k>FsDP{PT	', '', 0, '?'),
 ('%}\"\",/', 'wp-content/plugins/revslider/admin/views/overview.php', 0, '6FHrCW&\Z', '6FHrCW&\Z', '^_t\07Ho\r\r`Hyj\'oo', '', 0, '?'),
 ('RЄlЉ)Ç^?', 'wp-content/plugins/revslider/backup/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('pI#w6K\rD', 'wp-content/plugins/revslider/includes/InstagramScraper/Endpoints.php', 0, '2X@N〯~🜳	', '2X@N〯~🜳	', ')1j͐=˱Ƒ2Q\r\"ץ)', '', 0, '?'),
 ('Aa*Mt', 'wp-content/plugins/revslider/includes/InstagramScraper/Exception/InstagramAuthException.php', 0, '< ', '< ', ' א%9gx\0]>gVO|Y', '', 0, '?'),
 ('e4(-g`RBD', 'wp-content/plugins/revslider/includes/InstagramScraper/Exception/InstagramException.php', 0, '^NIle.\\M0!', '^NIle.\\M0!', '3^9\Z{g5?pw0\0', '', 0, '?'),
 ('ZEr]_1E', 'wp-content/plugins/revslider/includes/InstagramScraper/Exception/InstagramNotFoundException.php', 0, '2b9<', '2b9<', ':LH*l1[!)񗚻b', '', 0, '?'),
 ('r7hBbR,АZ', 'wp-content/plugins/revslider/includes/InstagramScraper/Instagram.php', 0, 'nҖPr$jU', 'nҖPr$jU', 'b?izx~6ߣ7ꕺF<$ƧC', '', 0, '?'),
 ('aZTfkW', 'wp-content/plugins/revslider/includes/InstagramScraper/InstagramQueryId.php', 0, '>}Q)0ɚf', '>}Q)0ɚf', 'k/e\n\nu,Se㐫N4x-', '', 0, '?'),
 ('<s89.61ax', 'wp-content/plugins/revslider/includes/InstagramScraper/Instagram_old.php', 0, 'GA.&}-ˡF', 'GA.&}-ˡF', '1[C.qe~2b', '', 0, '?'),
 ('_ƉFC', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/AbstractModel.php', 0, '4\Z,/*-(W	s)', '4\Z,/*-(W	s)', '&62t<29	7Cd8DN', '', 0, '?'),
 ('KoP#hb', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Account.php', 0, '۩/$w#', '۩/$w#', '}r,rTEJ8DR0\"0u', '', 0, '?'),
 (':^sDK|L', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/CarouselMedia.php', 0, 'j&e[U\r.\0H', 'j&e[U\r.\0H', 'w|8(%%G`Ng', '', 0, '?'),
 ('\"ߴn\\cCx', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Comment.php', 0, 'J˯T\ne', 'J˯T\ne', '-_.]/J\ZkS5Z', '', 0, '?'),
 ('(Cb$v#fs', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Like.php', 0, 's7R\ZS8$\"A', 's7R\ZS8$\"A', '˅*CͣY	|J|L{4', '', 0, '?'),
 ('W^;D\0B', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Location.php', 0, 'TVK ʶ', 'TVK ʶ', 'T:cRmB%	nv)rL', '', 0, '?'),
 (' EY>Q	`+', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Media.php', 0, 'Egx~aj|	Eج', 'Egx~aj|	Eج', 'ZCO8Ny>\\p\'@$C', '', 0, '?'),
 ('#\rSfӠ&', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Story.php', 0, '-RF+e+S4wn4', '-RF+e+S4wn4', 'K\r9=W*]W1:#16Sى', '', 0, '?'),
 ('uWIAy~c$5', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Tag.php', 0, '|b],?	g', '|b],?	g', '{6z:Jȧ^l5xd?Χ', '', 0, '?'),
 ('ǉ[GZWuY', 'wp-content/plugins/revslider/includes/InstagramScraper/Model/UserStories.php', 0, '.O}0{', '.O}0{', ']<F!pbǝQ%5_\\\"9˜}g', '', 0, '?'),
 ('P(TC9ݯ', 'wp-content/plugins/revslider/includes/InstagramScraper/Traits/ArrayLikeTrait.php', 0, '҄D?M', '҄D?M', '~LXy^BXN&i!8z`S', '', 0, '?'),
 ('.,Ѯm\0\"\'Y', 'wp-content/plugins/revslider/includes/InstagramScraper/Traits/InitializerTrait.php', 0, 'JSsrw)vP', 'JSsrw)vP', '\'ݔ\ZG8uM]i+D(żwn⼁', '', 0, '?'),
 ('Q^H\02Z\'sE', 'wp-content/plugins/revslider/includes/InstagramScraper.php', 0, '~͏SY;', '~͏SY;', 'TR^`<5\rQ݊7-hQ<', '', 0, '?'),
 ('tNRUz5M/?', 'wp-content/plugins/revslider/includes/Unirest/Exception.php', 0, '_)DL@\";\'', '_)DL@\";\'', 'SҵВdnSn5ʩd\'', '', 0, '?'),
 ('Ul(8 0', 'wp-content/plugins/revslider/includes/Unirest/Method.php', 0, '6R[d[<', '6R[d[<', 'T˙a(9ek˞(^#gC', '', 0, '?'),
 ('=ٱz Q', 'wp-content/plugins/revslider/includes/Unirest/Request/Body.php', 0, 'EeNe<d7.	܈', 'EeNe<d7.	܈', 'fBusmOՈM(1', '', 0, '?'),
 ('&k)s\"', 'wp-content/plugins/revslider/includes/Unirest/Request.php', 0, 'z=|u?7E', 'z=|u?7E', '{RoJ\'\Zx?y2h蟒', '', 0, '?'),
 ('FA\Z7ҁ', 'wp-content/plugins/revslider/includes/Unirest/Response.php', 0, 'w&-Äh(?6u;\rO', 'w&-Äh(?6u;\rO', '掎vh\0v\rKuf\\', '', 0, '?'),
 (')ÃAܨHƁ~@', 'wp-content/plugins/revslider/includes/Unirest.php', 0, '=Lc}.', '=Lc}.', '5.dr(ALPBl)1s>s', '', 0, '?'),
 ('\"3&j\0v', 'wp-content/plugins/revslider/includes/aq-resizer.class.php', 0, 'rUrua', 'rUrua', 'PnN\0oٰҩs:oʹJu', '', 0, '?'),
 (':lt{t4', 'wp-content/plugins/revslider/includes/backwards.php', 0, '\rH𞏊rkJ_h', '\rH𞏊rkJ_h', 'epWzV&/-Į0ު6{ҔA', '', 0, '?'),
 ('@D8Sd', 'wp-content/plugins/revslider/includes/basic-css.php', 0, '^Cgɻ	\0.Bu', '^Cgɻ	\0.Bu', '`~KZq;;xpLwi\n', '', 0, '?'),
 ('iMA;o7', 'wp-content/plugins/revslider/includes/coloreasing.class.php', 0, '{<c?\Z<', '{<c?\Z<', '֕nV֓/!\rA:o7.Q', '', 0, '?'),
 ('T[/88,UG', 'wp-content/plugins/revslider/includes/colorpicker.class.php', 0, 'JlL8\ru?', 'JlL8\ru?', 'jCMHkK\r`6N[ל;\'', '', 0, '?'),
 ('x}YAOR`#X', 'wp-content/plugins/revslider/includes/cssparser.class.php', 0, 'FTq]b', 'FTq]b', 'W]E}Ww:cgu', '', 0, '?'),
 ('9dֱCSR', 'wp-content/plugins/revslider/includes/data.class.php', 0, 'D', 'D', 'V\nd3Oadv\0Vhˬ\"	Y', '', 0, '?'),
 ('Ic6I\\', 'wp-content/plugins/revslider/includes/em-integration.class.php', 0, 'ŽQw245', 'ŽQw245', '\r3.{1n]]X$pc,%\r', '', 0, '?'),
 ('؅ѐYM,wtP߈', 'wp-content/plugins/revslider/includes/extension.class.php', 0, 'xdaG,', 'xdaG,', '7gD\'Si\ZrEAZ', '', 0, '?'),
 ('+NEjP]/', 'wp-content/plugins/revslider/includes/external-sources.class.php', 0, '^- {\Z{Oa*', '^- {\Z{Oa*', 'ӛL{*.F^EϫŬЙ', '', 0, '?'),
 ('vNc	刞jtx', 'wp-content/plugins/revslider/includes/favorite.class.php', 0, 'IVD30#UP', 'IVD30#UP', 'q;+W8#cU0c9é\\hc', '', 0, '?'),
 ('qbt=$\0a', 'wp-content/plugins/revslider/includes/functions.class.php', 0, 'oP222\"nJ', 'oP222\"nJ', '_<ΧVJjpr3MC$~', '', 0, '?'),
 ('܂l*x&ER', 'wp-content/plugins/revslider/includes/googlefonts.php', 0, 'Vp+脨NG%<R', 'Vp+脨NG%<R', '?6>B	zX2#k3bO', '', 0, '?'),
 ('I\"+', 'wp-content/plugins/revslider/includes/navigation.class.php', 0, 't>mr\rf', 't>mr\rf', 'maK;<ɻ/J{U&6ݞ\\(', '', 0, '?'),
 (')ޤx7xy', 'wp-content/plugins/revslider/includes/navigations.php', 0, '\Z\'ߡΟf\Zj(K', '\Z\'ߡΟf\Zj(K', '~D9Ϊ]ꅌm&Umb\rPyګ', '', 0, '?'),
 (':K+50@', 'wp-content/plugins/revslider/includes/object-library.class.php', 0, 'Ro&/0xB', 'Ro&/0xB', ']3hn^LIyNQ+n-m/o', '', 0, '?'),
 ('*\'\rO3', 'wp-content/plugins/revslider/includes/output.class.php', 0, '=hJLvO', '=hJLvO', '\nT0V!i+\r\Z|nz:d\n(T', '', 0, '?'),
 ('8yo 8', 'wp-content/plugins/revslider/includes/page-template.class.php', 0, 'KlvÈ\Z=', 'KlvÈ\Z=', '(b\'<L!`<h-cJ\'', '', 0, '?'),
 ('5+};&', 'wp-content/plugins/revslider/includes/slide.class.php', 0, '#.^(\\|', '#.^(\\|', '6\nhL$2\\YLt7<x', '', 0, '?'),
 ('U~WXv_#2', 'wp-content/plugins/revslider/includes/slider.class.php', 0, 'ӂ\Z_/Ҿ& C ', 'ӂ\Z_/Ҿ& C ', 'QBSR^cgt#n32F^πN@e', '', 0, '?'),
 (' Z,o', 'wp-content/plugins/revslider/includes/update.class.php', 0, 't>`).݃S', 't>`).݃S', 'q4$#0\'!yžw\"T^', '', 0, '?'),
 ('e7ah΢t`~', 'wp-content/plugins/revslider/includes/woocommerce.class.php', 0, '	5\'`Nb.\r=', '	5\'`Nb.\r=', 'CLzq6n{B}Y̆zG(F', '', 0, '?'),
 ('b]zL5|;A5', 'wp-content/plugins/revslider/includes/wpml.class.php', 0, '^<P7*m=', '^<P7*m=', 'gaV`*v{>]wJKj!BF', '', 0, '?'),
 ('Gl>GΚ', 'wp-content/plugins/revslider/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('6;#	%l+', 'wp-content/plugins/revslider/languages/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('*eZkV{', 'wp-content/plugins/revslider/public/assets/assets/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('EL/ғ\Z[', 'wp-content/plugins/revslider/public/assets/assets/sources/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('	_dAnk.', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_3d_rotation_24px.svg', 0, 'V>\ZC', 'V>\ZC', '(4 0*`1؎V);S\ZJRA', '', 0, '?'),
 ('V(Bڀ\\u<3', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_accessibility_24px.svg', 0, 'v1\ZǷ\096-/]', 'v1\ZǷ\096-/]', 'KeS`oY,B	cqp', '', 0, '?'),
 ('^:kCŒ^', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_accessible_24px.svg', 0, 'ukvd+', 'ukvd+', 'Ҿ$P1XӷAMB.{#t5iȔX', '', 0, '?'),
 ('[m:X	*', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_balance_24px.svg', 0, '.`y\0\Z$fޛ', '.`y\0\Z$fޛ', 'O2aufGaܩl\"\'%\'J]', '', 0, '?'),
 ('J6F\r?', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_balance_wallet_24px.svg', 0, '#8؃KZ', '#8؃KZ', '\r6\"DNE_\0ܬO^EG', '', 0, '?'),
 ('.!&V', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_box_24px.svg', 0, 'm,0', 'm,0', 'ɵLť#ЈE4.4դ \\', '', 0, '?'),
 ('#ԃ$7Qg', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_circle_24px.svg', 0, 't.[gW6', 't.[gW6', 'ՇO8dL-m?dw.GG:$u', '', 0, '?'),
 (';99Awa', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_add_shopping_cart_24px.svg', 0, 'D9V	,Rk', 'D9V	,Rk', '0Ķrx	]x{dE(o2d', '', 0, '?'),
 ('ic`*L', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_24px.svg', 0, '\'48;;q8@', '\'48;;q8@', 'U	\"\"غH-	J=p', '', 0, '?'),
 ('rue$!U6Oj', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_add_24px.svg', 0, ']4&?\rR4軉N', ']4&?\rR4軉N', 'ѕ~=+:s	vbO50.\r#\00d', '', 0, '?'),
 ('R.<zm^)i', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_off_24px.svg', 0, 'BJĶw<r', 'BJĶw<r', 'o#e҉(fR\"ǮԠ霊CN', '', 0, '?'),
 ('Es.W1\Z|~>', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_on_24px.svg', 0, 'G^(3\njn', 'G^(3\njn', '?No!u=EHCuyc:n', '', 0, '?'),
 ('~g1@2', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_all_out_24px.svg', 0, '7v\"Q5', '7v\"Q5', 'PY7W76^&Ӗ쑮@Oe', '', 0, '?'),
 ('C\"\"#7a\'', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_android_24px.svg', 0, '!BͶ4%`w4޵', '!BͶ4%`w4޵', 'Bj>ij\'L󓿌Gq\rkB7d:', '', 0, '?'),
 ('>:U=l\r', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_announcement_24px.svg', 0, '^^*gj', '^^*gj', '!ŉg\Z%\rO~UMB*}n', '', 0, '?'),
 ('5YSyB', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_aspect_ratio_24px.svg', 0, '^ySr', '^ySr', '>!lߖl	Ѣ޲%;', '', 0, '?'),
 ('OU.`', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assessment_24px.svg', 0, '*5\":(;7+', '*5\":(;7+', 'aO;L;_)~ԍ?ഥ:', '', 0, '?'),
 ('6\\O+6KV	t.', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_24px.svg', 0, '(Jط7p_', '(Jط7p_', 'tTɃKUMZCnHnhgX', '', 0, '?'),
 ('t~eL1]EQ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_ind_24px.svg', 0, 'ē٪p*o', 'ē٪p*o', '\'ďh00	\\yzBl', '', 0, '?'),
 ('?umOPP]B', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_late_24px.svg', 0, 'J@}Pх5<\n', 'J@}Pх5<\n', '2#ЙV.S#x8euz', '', 0, '?'),
 ('mjoȔ6Q', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_return_24px.svg', 0, 'Nk', 'Nk', ',\"\"D_gC64H', '', 0, '?'),
 ('H?Dډ?~z\n', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_returned_24px.svg', 0, 'I}\\ȝ5', 'I}\\ȝ5', 'J8(lK\ZZ_JsɘJ', '', 0, '?'),
 ('uE<#RJ\\M25', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_turned_in_24px.svg', 0, 'V(`peV', 'V(`peV', 'gSUn}rIS޷O9-f', '', 0, '?'),
 ('k?w0B\\e', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_autorenew_24px.svg', 0, 'ˡp,', 'ˡp,', '7m.0J?5}ON:I+脏#8f', '', 0, '?'),
 ('!4t#AB', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_backup_24px.svg', 0, 'f#/&M4Ֆ', 'f#/&M4Ֆ', 'ͳJŹ2jt6}aWT%SO', '', 0, '?'),
 ('gCU^PD́', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_book_24px.svg', 0, ';CY;hP', ';CY;hP', '\Zq27:k~cL:m', '', 0, '?'),
 ('oTF>%Sa', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_bookmark_24px.svg', 0, ':TJMAR', ':TJMAR', 'R2syn8\"G7gwH$h', '', 0, '?'),
 ('*i\rM4B[v', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_bookmark_border_24px.svg', 0, 'B#R%Ba', 'B#R%Ba', '&D\rDb^K\nZ{0B`0\0#', '', 0, '?'),
 ('UQȕPj', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_bug_report_24px.svg', 0, '8b=WhqMh', '8b=WhqMh', 'z\Zl.ݹTgunfRc\\V', '', 0, '?'),
 ('v+Qo\rg', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_build_24px.svg', 0, 'TtJU~#V[6', 'TtJU~#V[6', 'C\\\0\"˟	0\'+F~b`C@fk1', '', 0, '?'),
 ('<>vA%Fn', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_cached_24px.svg', 0, 'iB.L^9.', 'iB.L^9.', 'le&>g`m.X9T,a	-o', '', 0, '?'),
 ('ݪ\"ӓ]z', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_camera_enhance_24px.svg', 0, '(a%*%', '(a%*%', 'B˜i\nkк\ZƋLL9ڛ)|', '', 0, '?'),
 ('/ӞV//Q', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_card_giftcard_24px.svg', 0, 'Ⱦ|sO#4c', 'Ⱦ|sO#4c', 'UbTLrg$T)\\w^X', '', 0, '?'),
 ('cRN3WO.\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_card_membership_24px.svg', 0, '\0gv\\1|z', '\0gv\\1|z', 'Mri\"C։LbZ`|g&', '', 0, '?'),
 ('r´+0z{OJ^', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_card_travel_24px.svg', 0, 'P)C*@F$', 'P)C*@F$', '& :VQ\0_E	uN]', '', 0, '?'),
 ('lʉ~\npՉV', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_change_history_24px.svg', 0, '3jς{6p^K', '3jς{6p^K', 'ꬵZ!圕\0~I.DyG', '', 0, '?'),
 ('iqr-s', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_check_circle_24px.svg', 0, 'q\0;G1', 'q\0;G1', 'Z܁4B}-WF+_,W', '', 0, '?'),
 ('<9RXR@d', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_chrome_reader_mode_24px.svg', 0, '~=9<I?f', '~=9<I?f', 'PX$n%W\'bKI*>k', '', 0, '?'),
 ('*>\'bDX?aY*', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_class_24px.svg', 0, ';CY;hP', ';CY;hP', '\Zq27:k~cL:m', '', 0, '?'),
 ('=\0Q\'YH', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_code_24px.svg', 0, ':V\"v ', ':V\"v ', 'aFހV?n}+9W`', '', 0, '?'),
 ('(2 Q\"k6=K', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_compare_arrows_24px.svg', 0, '\Zۮn+yCPjb', '\Zۮn+yCPjb', '0DI}4|Ƥ.D5VI׊.h%', '', 0, '?'),
 ('HhILR÷W', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_copyright_24px.svg', 0, '21oG㎭', '21oG㎭', 'ב\"];ޡZ~6FDn*', '', 0, '?'),
 ('f$5svS2', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_credit_card_24px.svg', 0, 'zG}},-3X', 'zG}},-3X', ']|cƈ\n\\އpӧ!ξ\Z', '', 0, '?'),
 ('~ud0Znr', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_dashboard_24px.svg', 0, 'Nm/Nϩ', 'Nm/Nϩ', 'T-qEN\rj[%9=->', '', 0, '?'),
 ('Mhć򉌉', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_date_range_24px.svg', 0, 'r^(-NL>', 'r^(-NL>', '4ϾʎVR$׸󳀙ٖ<&\\', '', 0, '?'),
 ('as\Zos', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_delete_24px.svg', 0, '֌NAg?)?y', '֌NAg?)?y', 'BWW>U\rM-⧒,u!', '', 0, '?'),
 ('A\"|>uڔ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_description_24px.svg', 0, 'd16cby]', 'd16cby]', '3ބښqBDoL70Ps', '', 0, '?'),
 ('Kg3sU-8B', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_dns_24px.svg', 0, '2PyؑP=Z', '2PyؑP=Z', 'FRNgo_?OCwl0', '', 0, '?'),
 ('4?܏Noo', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_done_24px.svg', 0, '͓`ݫ6E~', '͓`ݫ6E~', 'Gwv_kk;bz#tͶ', '', 0, '?'),
 ('	sw4@澵', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_done_all_24px.svg', 0, '<\n+', '<\n+', 'd9;2\\&Vh-FS32_H', '', 0, '?'),
 ('	ҡ@RɄj(', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_donut_large_24px.svg', 0, 'gA~6*OMfY3', 'gA~6*OMfY3', 'xwrxw3N0ơˢoEe݁渖\02', '', 0, '?'),
 ('ٽ_sU:+', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_donut_small_24px.svg', 0, '\nIu\0n(\"9', '\nIu\0n(\"9', '_مXm=ۋiŤP\'\nJUV', '', 0, '?'),
 ('W3\0b78:', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_eject_24px.svg', 0, 'T̝sLrb%V', 'T̝sLrb%V', 'dAj\r86#Ӈ:쓋!', '', 0, '?'),
 ('66$md;w', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_event_24px.svg', 0, ':ɘ', ':ɘ', 'M!LAY(;3B~z2}iYJWU', '', 0, '?'),
 ('^Sr.sO', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_event_seat_24px.svg', 0, '0R\'`~Lh6', '0R\'`~Lh6', 'M9\'\'$K(#^gK\Z', '', 0, '?'),
 ('̣M?|%c!', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_exit_to_app_24px.svg', 0, 'RKq^cG*', 'RKq^cG*', 'ǊA{M5_	e֛G\ZmQ(a`', '', 0, '?'),
 ('CTkm5\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_explore_24px.svg', 0, 'M4\rll', 'M4\rll', 'Eˣ/OS9hZ\\Td\'h', '', 0, '?'),
 ('!VI8n=u', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_extension_24px.svg', 0, 'e9]/\0]PL+', 'e9]/\0]PL+', 'sc}ZE4>q*]eϰ|', '', 0, '?'),
 ('N߇&u;A', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_face_24px.svg', 0, '\\0^c2!ۚ%', '\\0^c2!ۚ%', 'aNHxjbEgl)\r.r|6', '', 0, '?'),
 ('وT={96?@H', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_favorite_24px.svg', 0, '\'?0&~\"A2`', '\'?0&~\"A2`', 'N#ә&;oE\rnlN.s2R/k', '', 0, '?'),
 ('Lhz_i\nn)\"4', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_favorite_border_24px.svg', 0, '$L', '$L', 'rK<݅qeNS%<\n\0k', '', 0, '?'),
 ('\0n~jC', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_feedback_24px.svg', 0, '?ә`EC	-,p', '?ә`EC	-,p', 'c3\rmpi	2S8;h	mz', '', 0, '?'),
 ('AmNO?', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_find_in_page_24px.svg', 0, '^ʞ|?=O020', '^ʞ|?=O020', 'S\"2ȋ:a5p]C<:F}ܽ)^', '', 0, '?'),
 ('Yfѥ┧', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_find_replace_24px.svg', 0, '̟}R)bn', '̟}R)bn', ']{ރ1ڽ7scRc2޳M', '', 0, '?'),
 ('>xے		4', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_fingerprint_24px.svg', 0, 'ivaa\"[*%f2', 'ivaa\"[*%f2', ',9,9ooNS}qGx` 1c&c', '', 0, '?'),
 ('95-iC~j\'', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flight_land_24px.svg', 0, 'ܫؘa*jK\r:', 'ܫؘa*jK\r:', 'r?ݖNA{pȻڅ[a$ES', '', 0, '?'),
 ('ܵ[g9Ĭ ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flight_takeoff_24px.svg', 0, '(%m_QbRβ~\Z', '(%m_QbRβ~\Z', 'iU;A¯+aPDw/bV+X\n]', '', 0, '?'),
 ('=i~I1l', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flip_to_back_24px.svg', 0, '#9!QD@?b', '#9!QD@?b', '\\jvݘ	5d)aP]ا-\"', '', 0, '?'),
 ('Y2@rX\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flip_to_front_24px.svg', 0, 'ZK}1gc', 'ZK}1gc', '+#eD	cW\nomħ', '', 0, '?'),
 ('3E^tRw rb', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_gavel_24px.svg', 0, 'Q%Epzb', 'Q%Epzb', 'ZEܴ>Ok:ݎo', '', 0, '?'),
 ('cr%:AXE%U\0', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_get_app_24px.svg', 0, 'T7_tn3,g', 'T7_tn3,g', '7dd=jpha\\(/ήۢ', '', 0, '?'),
 ('aRU', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_gif_24px.svg', 0, 'a-Dd?\\ WXlW', 'a-Dd?\\ WXlW', '0ЖF=͢ڷW]~鴗\Zk;p|ک', '', 0, '?'),
 ('4CNu', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_grade_24px.svg', 0, '<M7Ty~OJio', '<M7Ty~OJio', 'ͨigΐgOx8lĵ', '', 0, '?'),
 ('1k)m5g\rI', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_group_work_24px.svg', 0, 'I=^}q6w', 'I=^}q6w', 'ޣ*&nR3\n7Fh.!', '', 0, '?'),
 ('fqi&:', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_help_24px.svg', 0, '\'JCqev~oQ', '\'JCqev~oQ', 'tqO8\\.Yla<', '', 0, '?'),
 ('^V䂘!IA', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_help_outline_24px.svg', 0, '5\'@<Jv}?', '5\'@<Jv}?', 'tսJb}FEtyc)x', '', 0, '?'),
 ('hTHV=W>&s', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_highlight_off_24px.svg', 0, '#X׻3뽒@wV', '#X׻3뽒@wV', 'LbCN@q<Zr>(uHձ/\r', '', 0, '?'),
 ('@4Ѧ)@I', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_history_24px.svg', 0, '@.j˝F:mf', '@.j˝F:mf', '7)\\*\0du.iTb8醼OZ]', '', 0, '?'),
 ('AȺ*iMLE', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_home_24px.svg', 0, 'ۂ#i|\n(', 'ۂ#i|\n(', '\'%Hym﬑PIlfO', '', 0, '?'),
 ('ʘ{	k2I ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_hourglass_empty_24px.svg', 0, '~ce%if', '~ce%if', ' W:lc͍\nWhX3\\J', '', 0, '?'),
 ('OGϏjD}', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_hourglass_full_24px.svg', 0, '*{6d', '*{6d', '-KCl^,3NCj\\&4gq՝', '', 0, '?'),
 (' cNE~E)5j', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_http_24px.svg', 0, 'J\n)x	', 'J\n)x	', '~Ƥl{P6A_~SB=P1/', '', 0, '?'),
 ('M)\n$(Dg@s0w', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_https_24px.svg', 0, 'D?-_XuR', 'D?-_XuR', '\'܀e\'6h\0Vt*H', '', 0, '?'),
 ('_ԢF$\r', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_important_devices_24px.svg', 0, '=#\\!>;h˽', '=#\\!>;h˽', 'yuipăY8Q}o{lt', '', 0, '?'),
 ('4?}:Pmi=', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_info_24px.svg', 0, 'FX\0Z1f+', 'FX\0Z1f+', 't<ڴ.~`xxxҼmZ', '', 0, '?'),
 ('7aݒ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_info_outline_24px.svg', 0, 'O2>C09', 'O2>C09', 'a?85]~|ls;m\"', '', 0, '?'),
 ('⪪82c=t*l', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_input_24px.svg', 0, '4yb`_Of', '4yb`_Of', '-h\"ogɒN TEJC*r', '', 0, '?'),
 ('郸FP9\"V', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_invert_colors_24px.svg', 0, 'Ihh^]wPٲ\Z', 'Ihh^]wPٲ\Z', 'ڌ8CPjO|HA+[rM6', '', 0, '?'),
 ('GG\"(d)׿]', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_label_24px.svg', 0, 'D[fE8.;:S', 'D[fE8.;:S', '^sbݪǨ!^JG(%~}=	-ph', '', 0, '?'),
 ('sât]sa_<H', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_label_outline_24px.svg', 0, 'nr', 'nr', '{\0(n&9ׁ;K6f3', '', 0, '?'),
 (',]>۱̏h', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_language_24px.svg', 0, 'ND ǩg;+M', 'ND ǩg;+M', '2AL߇2Oy', '', 0, '?'),
 ('nHɾެͧ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_launch_24px.svg', 0, ' /Epn{-!', ' /Epn{-!', 'H;\0\Zc^*\'%rN=', '', 0, '?'),
 ('ÇJoD\rZR', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lightbulb_outline_24px.svg', 0, ')ݧ6\n', ')ݧ6\n', '6٭5JOWqJ\Z6L4AA2', '', 0, '?'),
 ('1o7$Tԁ`r', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_line_style_24px.svg', 0, 'R<jN5Ov', 'R<jN5Ov', '\nߵ?#%w(7_B', '', 0, '?'),
 ('LWYk!M', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_line_weight_24px.svg', 0, '\n {\nbن\0r', '\n {\nbن\0r', '* mD2ȉ3lX\n0WJI1', '', 0, '?'),
 ('^C>.!\0Y>}', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_list_24px.svg', 0, '3.v;moU', '3.v;moU', 'lM(M~6OEo_\"I', '', 0, '?'),
 ('	7XÕL\0l', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lock_24px.svg', 0, 'D?-_XuR', 'D?-_XuR', '\'܀e\'6h\0Vt*H', '', 0, '?'),
 ('L?\n-Vd}	', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lock_open_24px.svg', 0, '^},}*^],c', '^},}*^],c', '\Z1*bSHв(V&TzV?MXJ', '', 0, '?'),
 ('L}P5shyq%', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lock_outline_24px.svg', 0, '~1ߊ!I', '~1ߊ!I', '-uKHO\nT)0N P9', '', 0, '?'),
 ('FNj[p', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_loyalty_24px.svg', 0, '8L\'aۊh', '8L\'aۊh', 'K\'ujֶÕv LHmZ*l', '', 0, '?'),
 ('J;9', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_markunread_mailbox_24px.svg', 0, '/Tj`8h', '/Tj`8h', 'Cy\\P;(5sPflti+9', '', 0, '?'),
 ('ѯ0sS՚U)', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_motorcycle_24px.svg', 0, '>Ft;]', '>Ft;]', 'y7W(4b_ԹX~', '', 0, '?'),
 ('˩9e\"_N73txr\r', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_note_add_24px.svg', 0, 'Y(Ekjjj\"a', 'Y(Ekjjj\"a', 'Z!MWGV+ur- Gaw', '', 0, '?'),
 ('G>ypq)q', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_offline_pin_24px.svg', 0, 'ۻ)y#⧈<q', 'ۻ)y#⧈<q', ' 4P}-Lu!q4[\'x', '', 0, '?'),
 ('`}=*kT', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_opacity_24px.svg', 0, 'Q}C{2x', 'Q}C{2x', 'I!12c\".0rg4', '', 0, '?'),
 ('*2;ZBUv', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_open_in_browser_24px.svg', 0, 'wG%!Vnq', 'wG%!Vnq', '\n!sy_\nh', '', 0, '?'),
 ('?#i%\"|ʉ+', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_open_in_new_24px.svg', 0, ' /Epn{-!', ' /Epn{-!', 'H;\0\Zc^*\'%rN=', '', 0, '?'),
 ('E)X@31W', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_open_with_24px.svg', 0, '_s[-+f0', '_s[-+f0', 'vs7eYZ<\\T', '', 0, '?'),
 ('fגè&~$Ŷs', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pageview_24px.svg', 0, 'E.zɼoyI', 'E.zɼoyI', '@C]#Nb]d6\"2!', '', 0, '?'),
 ('><QzU0V_', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pan_tool_24px.svg', 0, '݈tA\\Z%', '݈tA\\Z%', '8.-:}m-9K$3.}h', '', 0, '?'),
 ('^).U$', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_payment_24px.svg', 0, 'zG}},-3X', 'zG}},-3X', ']|cƈ\n\\އpӧ!ξ\Z', '', 0, '?'),
 (']F[E¿', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_camera_mic_24px.svg', 0, 'S	^EzN', 'S	^EzN', '-ȥpz#5j-Xͅڊ\\$8H', '', 0, '?'),
 ('ӏOJg-[Epp', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_contact_calendar_24px.svg', 0, 'ӌ}LKm}', 'ӌ}LKm}', '\nCf,n^BNH	y\Z[U7t', '', 0, '?'),
 ('Q̓Ԙ״Z@', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_data_setting_24px.svg', 0, 'X6TXD~{Ĳ p', 'X6TXD~{Ĳ p', '#FB˄ʠhNѨ- 8>', '', 0, '?'),
 ('scAvpD', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_device_information_24px.svg', 0, '\\+	SK', '\\+	SK', 'Ua\Za/6I*&A\0JwW0j$', '', 0, '?'),
 ('zL+c4Y', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_identity_24px.svg', 0, '@Ĥu@u\\', '@Ĥu@u\\', 'uك#spO_=NAbmt6', '', 0, '?'),
 ('4k%,X\0e,6K', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_media_24px.svg', 0, '9;?(WO1`', '9;?(WO1`', 'l\n/+#?<^2HN', '', 0, '?'),
 (')k6 ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_phone_msg_24px.svg', 0, '%,?&s', '%,?&s', 'B>kMbiP:qlBiqkĳ܁Zd', '', 0, '?'),
 ('E/!mфdq_1', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_scan_wifi_24px.svg', 0, 'W_MJxx|ZH', 'W_MJxx|ZH', '>%cuѢ3Lї~\'H9(пa,', '', 0, '?'),
 ('p1KM,rN', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pets_24px.svg', 0, '8Mʨ!Gt\ZpP', '8Mʨ!Gt\ZpP', '|_m -e9UQwiERۭ.', '', 0, '?'),
 ('rWz/~[', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_picture_in_picture_24px.svg', 0, 'oEvx 9kty', 'oEvx 9kty', '\'?_Z&iYn', '', 0, '?'),
 ('&XU_Nf#%', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_picture_in_picture_alt_24px.svg', 0, 'vru\\+X%)+T', 'vru\\+X%)+T', 'і$<}LǃH](Dkp*', '', 0, '?'),
 ('!\'b\"{o', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_play_for_work_24px.svg', 0, 'Uf+}ˮ', 'Uf+}ˮ', 'rvzntco&z6P	MdF', '', 0, '?'),
 ('Zp`O`o', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_polymer_24px.svg', 0, '/@7fO(', '/@7fO(', ';\'XS	_4S3zr{', '', 0, '?'),
 ('qv.eu	WPH', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_power_settings_new_24px.svg', 0, 'g{ۻE@$$6a', 'g{ۻE@$$6a', 'f1~I\np|uRFAԿgFK#', '', 0, '?'),
 ('#`\\T{ňw', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pregnant_woman_24px.svg', 0, 'rJFUَ\"͙Ss4', 'rJFUَ\"͙Ss4', 'M`s#OH~aӍ(p%LdY', '', 0, '?'),
 ('H\04D&n', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_print_24px.svg', 0, ')>0\nG\ZrQF', ')>0\nG\ZrQF', ']$pz:\'CR\0syL9#?', '', 0, '?'),
 ('aM&թ;?_6', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_query_builder_24px.svg', 0, '\n8l}+QG ', '\n8l}+QG ', '~2`[éYR:ٗέ0\0#$s(', '', 0, '?'),
 ('A͐!;\n', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_question_answer_24px.svg', 0, '#5\\#N', '#5\\#N', 'HFS:9zӣ^]\n', '', 0, '?'),
 ('+aIo=K]lQ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_receipt_24px.svg', 0, '@_\"qn%\0#&0p', '@_\"qn%\0#&0p', 'h(5\r^X̦4FRC', '', 0, '?'),
 ('73h\rC3p.', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_record_voice_over_24px.svg', 0, 'K88wrm', 'K88wrm', 'Ewt\0ty6mkX061@%h', '', 0, '?'),
 ('7\0D,N䢣', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_redeem_24px.svg', 0, 'Ⱦ|sO#4c', 'Ⱦ|sO#4c', 'UbTLrg$T)\\w^X', '', 0, '?'),
 ('`ǣe]+VW', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_reorder_24px.svg', 0, '!n>qMVa˿-', '!n>qMVa˿-', '\'#oaP\rRÆ$x:A', '', 0, '?'),
 ('/ӱ`7$', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_report_problem_24px.svg', 0, 'k(1:bck', 'k(1:bck', '*t蛪tmSIo2\r|o۲2k', '', 0, '?'),
 ('{גuZ[ݽ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_restore_24px.svg', 0, '@.j˝F:mf', '@.j˝F:mf', '7)\\*\0du.iTb8醼OZ]', '', 0, '?'),
 ('me#ETп', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_room_24px.svg', 0, 'I}Ԛ^޵Q\Zw', 'I}Ԛ^޵Q\Zw', '\\]:0cA7kT`	(\0', '', 0, '?'),
 ('Q$L\n\rB', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_rounded_corner_24px.svg', 0, '27Y~)V\Zo4', '27Y~)V\Zo4', 'O<f+JoِddO]Ց', '', 0, '?'),
 ('R晐:K;L', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_rowing_24px.svg', 0, '+@!kH*ct', '+@!kH*ct', 'j9\nJxAE.	T93', '', 0, '?'),
 ('E.Sr\'\Z1I', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_schedule_24px.svg', 0, '\n8l}+QG ', '\n8l}+QG ', '~2`[éYR:ٗέ0\0#$s(', '', 0, '?'),
 ('G}Qdqhﴹ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_search_24px.svg', 0, 'w>LG-', 'w>LG-', '! -+@ؖ.޻P;;', '', 0, '?'),
 ('.+HLh`', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_24px.svg', 0, '\'eO @', '\'eO @', 'uDIF!\'>A?OG<', '', 0, '?'),
 (']?B\r?V4', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_applications_24px.svg', 0, '6~Qs4|$t', '6~Qs4|$t', '_Ԇ89W:\nȔ9ր\Zwz{!', '', 0, '?'),
 ('ys2lq!', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_backup_restore_24px.svg', 0, '[3t_E0[]', '[3t_E0[]', 'EOp@KMX,0&(b\rA/', '', 0, '?'),
 ('g$S5ÀS', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_bluetooth_24px.svg', 0, '\ZK9(\r<n-', '\ZK9(\r<n-', '\0[j#Ȓ;rvw!&xH+d', '', 0, '?'),
 ('AwFI', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_brightness_24px.svg', 0, ' @^ZOf\"+', ' @^ZOf\"+', 'H~- li&5j- o.1', '', 0, '?'),
 ('}\\HJr(()', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_cell_24px.svg', 0, '$5Q\n(hm', '$5Q\n(hm', '.LcC(u+FhuAN7', '', 0, '?'),
 ('7h_ye', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_ethernet_24px.svg', 0, 'A\0\"z?bB', 'A\0\"z?bB', 'ꡖp\"!19*NL`', '', 0, '?'),
 ('LNS\'', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_antenna_24px.svg', 0, '*,Ԇ]{H', '*,Ԇ]{H', '$Ng\nS\0Չ\\:ܬ9[SS', '', 0, '?'),
 ('52=\n눲r2', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_component_24px.svg', 0, 'q`y_-Kc\\', 'q`y_-Kc\\', 'vA-iSfE$Yf{2', '', 0, '?'),
 ('\"&#S}fUw', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_composite_24px.svg', 0, 'q`y_-Kc\\', 'q`y_-Kc\\', 'vA-iSfE$Yf{2', '', 0, '?'),
 ('xg[vF~7\'', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_hdmi_24px.svg', 0, '/Lt;!kҾ', '/Lt;!kҾ', 'FLEQF3ba\rJ$ƏL/Ϩ<2', '', 0, '?'),
 ('+s1pڦ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_svideo_24px.svg', 0, '2GLv)', '2GLv)', '(׻i2\rQ(J|ǖ	*x', '', 0, '?'),
 ('׹(GpBխttw', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_overscan_24px.svg', 0, '=^l\Z/ETNA', '=^l\Z/ETNA', '\nv=Os(˔[\"&$-^', '', 0, '?'),
 ('SySEPNU', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_phone_24px.svg', 0, '<s$3G/S', '<s$3G/S', 'Lh\rS__+ZH_(ߓpA ', '', 0, '?'),
 ('Jhv', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_power_24px.svg', 0, '(.`w\'?;.', '(.`w\'?;.', '\'Fye]X^_ftM9૛뺐', '', 0, '?'),
 ('fu\'_\\Ѱ/k]0', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_remote_24px.svg', 0, '~,L<COp:q', '~,L<COp:q', 'ǥ6_R~@.ULpaUi', '', 0, '?'),
 ('[{x74֮>\"ׁ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_voice_24px.svg', 0, ';Ջ	i$', ';Ջ	i$', 'XĪVu.Q>x/b{Aj', '', 0, '?'),
 ('yCa:s]OO,', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shop_24px.svg', 0, 'G\'(TF\"O', 'G\'(TF\"O', '\'DU+ҥYB8\'', '', 0, '?'),
 (':mP', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shop_two_24px.svg', 0, 'l.h\nA', 'l.h\nA', 'Oc^$B6I1aCȑ~oz', '', 0, '?'),
 ('z!!jOQѮ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shopping_basket_24px.svg', 0, 'm\\i&URP\'`\"G/', 'm\\i&URP\'`\"G/', '%ތiR9w=\\`o5\r\0-~m[', '', 0, '?'),
 ('QUuU>', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shopping_cart_24px.svg', 0, '|F5CV:', '|F5CV:', 'Ԟe;nTGKk`߈68', '', 0, '?'),
 ('XHR)I6', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_speaker_notes_24px.svg', 0, 'P#qb\0&[/4', 'P#qb\0&[/4', '--]NU\n?:I0;5-1A', '', 0, '?'),
 ('9^GYM4', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_spellcheck_24px.svg', 0, 'w]O\\:N', 'w]O\\:N', 'vnC;e_fs2Sθن[K<i', '', 0, '?'),
 ('xT)>PV!Sa', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_stars_24px.svg', 0, 'RbvM)B', 'RbvM)B', '	\n1[ǎCh4Dׄ.d?U:', '', 0, '?'),
 ('}*q7', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_store_24px.svg', 0, 'Cؗ5D=_E', 'Cؗ5D=_E', 'TW+ݳ4\r$Y.&}\0v', '', 0, '?'),
 ('\\wY|eIs!>i', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_subject_24px.svg', 0, 'sk\'э3#', 'sk\'э3#', '{P+\\贜CRL7mڹO,nm', '', 0, '?'),
 ('bP7P<*', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_supervisor_account_24px.svg', 0, 'hX\\drn˘F2', 'hX\\drn˘F2', '-Yos%=ܼms\'X2V', '', 0, '?'),
 ('7sBl#J}-', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_swap_horiz_24px.svg', 0, 'O8HW߻9+J', 'O8HW߻9+J', 'umbqo:XMF&', '', 0, '?'),
 (',ݡQ$Q︿?h', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_swap_vert_24px.svg', 0, '=JxbYxm', '=JxbYxm', '4pҗU钩.\0snASQ{', '', 0, '?'),
 ('\"ȿ\0xy', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_swap_vertical_circle_24px.svg', 0, 'A@\Z6GCDJ', 'A@\Z6GCDJ', '\'E{҂3E,.zN-	ΣlndL', '', 0, '?'),
 ('K\\anNNg@T', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_system_update_alt_24px.svg', 0, 'ÒH*6NMﴉ', 'ÒH*6NMﴉ', '~$flm%a~X,$\\i', '', 0, '?'),
 ('wz.@Izv', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_tab_24px.svg', 0, '^q~R{ 2Wu', '^q~R{ 2Wu', 'ĩzʍ	k\Zyc\ZJ	{ 6Z ', '', 0, '?'),
 ('(Bi#\nkol', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_tab_unselected_24px.svg', 0, '`̃~f', '`̃~f', 's=5%m4Bj+8QKDj?', '', 0, '?'),
 ('7\rD![JNü\ZȻ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_theaters_24px.svg', 0, 'H\r2Rڤ', 'H\r2Rڤ', 'jf0k߶zc~ъ@r^f0.', '', 0, '?'),
 ('`buCeK;', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_thumb_down_24px.svg', 0, 'o<LB勂/7>', 'o<LB勂/7>', 'q*ޘilwvq]ө\0{R', '', 0, '?'),
 ('wwelmd', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_thumb_up_24px.svg', 0, 'K{Wǒܟk', 'K{Wǒܟk', 'Av\\GU#tB _t7HS,g', '', 0, '?'),
 ('@6RRu4', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_thumbs_up_down_24px.svg', 0, '/Ѣ\nқ', '/Ѣ\nқ', '<~#D{ȏ5\neȨɎςylg\r', '', 0, '?'),
 ('Lٻd|zVlȫc', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_timeline_24px.svg', 0, '\0cd͂Q', '\0cd͂Q', 'y$MbzN7#yt,xo', '', 0, '?'),
 ('h M(ޟDb', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_toc_24px.svg', 0, 'F\naD<\0u', 'F\naD<\0u', 'M2*R3;j\\Cj', '', 0, '?'),
 ('ט\"ԓ%Tbv', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_today_24px.svg', 0, 'ұ=%F', 'ұ=%F', ')8qT5lf\\MU8};', '', 0, '?'),
 (' 4&ǟ	M0', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_toll_24px.svg', 0, '_Z\'9TNd', '_Z\'9TNd', '˳*:˛\rO_sƯ/+#', '', 0, '?'),
 ('б0Z<XU\"*', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_touch_app_24px.svg', 0, 'g&\\,oI0Un', 'g&\\,oI0Un', ']\\wz_K͠{;Dsd', '', 0, '?'),
 ('FUC4UO%9O', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_track_changes_24px.svg', 0, 'NZnnMAp:7k', 'NZnnMAp:7k', 'e9(U@{	yՕH?pEp#', '', 0, '?'),
 ('8HbMA', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_translate_24px.svg', 0, '\ngQOc', '\ngQOc', 'Nv^?ˌ\0mS*)ii}=_', '', 0, '?'),
 ('+D/Z@wG%', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_trending_down_24px.svg', 0, 'B$H!\0+]~H>\n', 'B$H!\0+]~H>\n', ';Apՠ>g~~>\\Nv:9i', '', 0, '?'),
 ('TR1m0~', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_trending_flat_24px.svg', 0, '{#s$cm', '{#s$cm', 'W)sZNd$;vթnn@@Z?usW', '', 0, '?'),
 ('}QpwQ', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_trending_up_24px.svg', 0, 'ZnagJ', 'ZnagJ', 'e<Sg@,a긙#4', '', 0, '?'),
 ('!GSgLlye', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_turned_in_24px.svg', 0, ':TJMAR', ':TJMAR', 'R2syn8\"G7gwH$h', '', 0, '?'),
 ('-?_)Hvlhs', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_turned_in_not_24px.svg', 0, 'B#R%Ba', 'B#R%Ba', '&D\rDb^K\nZ{0B`0\0#', '', 0, '?'),
 ('vTI3N\'~a0e', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_update_24px.svg', 0, 'O@nA^O', 'O@nA^O', '|/cҋ#XqR.tĘx=4', '', 0, '?'),
 ('ż>&8b³),', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_verified_user_24px.svg', 0, '|(s0$r{j', '|(s0$r{j', 'Ή(Zvo$z >{Y,Nk.Q', '', 0, '?'),
 ('eAIPa', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_agenda_24px.svg', 0, 'bsn\n', 'bsn\n', ']A/sa92۟84ׇ\ZׁPH', '', 0, '?'),
 ('譬^m\0	', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_array_24px.svg', 0, '\r)Utk*Y\"P', '\r)Utk*Y\"P', '.	\Z	fJsW.ETa', '', 0, '?'),
 ('a.oME`Y', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_carousel_24px.svg', 0, 'c`^2MpEddt', 'c`^2MpEddt', 'xW=7$v>RkO8+Z̧', '', 0, '?'),
 ('݆M8fn\'OP', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_column_24px.svg', 0, '$\r{\"\0zz^R8', '$\r{\"\0zz^R8', 'yǹvTi*gP^n`oy', '', 0, '?'),
 ('oycΏه', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_day_24px.svg', 0, '3u9:U:k_', '3u9:U:k_', 'ҡKt\r5X\")1%h\"^\rZ>+1~', '', 0, '?'),
 ('iy}~.@', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_headline_24px.svg', 0, 'R>M+diR{', 'R>M+diR{', 'j #cs$LiLp', '', 0, '?'),
 ('LqwiOem', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_list_24px.svg', 0, 'W<#IK!', 'W<#IK!', 'XDe{̋6M#%3`>}o7', '', 0, '?'),
 ('E\ZJC', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_module_24px.svg', 0, 'i@NikR4\0', 'i@NikR4\0', 'o)ɴviI/!KO/\n8', '', 0, '?'),
 ('*q0$rac4', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_quilt_24px.svg', 0, 'k\0wAIk$', 'k\0wAIk$', '/{i!6,NFx]-|HAI^I', '', 0, '?'),
 ('#n8R_:\'FƖ\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_stream_24px.svg', 0, 'JVq[ICj', 'JVq[ICj', '@/\Z:jz:\'y>yzQ\n', '', 0, '?'),
 ('*d)nː', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_week_24px.svg', 0, '[o<5', '[o<5', 'LÜI3\\3@I.\ry<ExfhJ꧷', '', 0, '?'),
 ('K8E9', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_visibility_24px.svg', 0, '(dDN=!_2ك', '(dDN=!_2ك', '$7Q\rRt5,y}VOތr', '', 0, '?'),
 (';C_8Rx', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_visibility_off_24px.svg', 0, '/jƮPY', '/jƮPY', 'g5|h$Lign$6g', '', 0, '?'),
 ('_QA=Gv', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_watch_later_24px.svg', 0, 'D;IAEj>', 'D;IAEj>', '1HP~QH1*}.G}	1E', '', 0, '?'),
 ('1EVoE', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_work_24px.svg', 0, 'wVduCz9l', 'wVduCz9l', '}[m\07vZϓE|%N', '', 0, '?'),
 ('܀.5Fqߟ[~', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_youtube_searched_for_24px.svg', 0, 'OEiVke', 'OEiVke', 'EviX^=B&}(^SmGC', '', 0, '?'),
 ('^aDV0%', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_zoom_in_24px.svg', 0, 'DTyz8\"S', 'DTyz8\"S', 'J^.k_gvbs%J|D', '', 0, '?'),
 ('\n5W\ZL\\t?', 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_zoom_out_24px.svg', 0, 'l	Tqp{2', 'l	Tqp{2', 'T~E>;4%)N!iew}5p;nhR', '', 0, '?'),
 ('lk+', 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_add_alert_24px.svg', 0, 'tǌroY)m', 'tǌroY)m', 'B\\+Ι:[M8bX\r*Y', '', 0, '?'),
 ('1lDÁ2}h1', 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_error_24px.svg', 0, '[c1Z{SRM', '[c1Z{SRM', 'Q:T\0\'SD{mY2tC#n/', '', 0, '?'),
 ('ihm(й:>', 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_error_outline_24px.svg', 0, 'wK\\ĶÙ', 'wK\\ĶÙ', 'zaψe}Gt$}{P	Ȁ', '', 0, '?'),
 ('\rXl^#C', 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_warning_24px.svg', 0, 'k(1:bck', 'k(1:bck', '*t蛪tmSIo2\r|o۲2k', '', 0, '?'),
 ('smoo\rXxbb0', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_add_to_queue_24px.svg', 0, '2EjgXFzo', '2EjgXFzo', 'UHp3عaл', '', 0, '?'),
 ('PF]qN', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_airplay_24px.svg', 0, '%b]v4)+\r', '%b]v4)+\r', ';yDNFHp\ZETyb22_', '', 0, '?'),
 ('d3', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_album_24px.svg', 0, '#S\06-4', '#S\06-4', 'O>5cIf܎sGl8z[4', '', 0, '?'),
 ('UIF:\"]=', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_art_track_24px.svg', 0, 'siS?L\\U@97', 'siS?L\\U@97', '\Ze*F̒KDG<W>', '', 0, '?'),
 ('u30Bi>#zCeEz', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_av_timer_24px.svg', 0, '\rM\n', '\rM\n', 'gi{GB29I嬩ul!', '', 0, '?'),
 ('@p\n`R', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_closed_caption_24px.svg', 0, 'n1\0<x׈v=A$', 'n1\0<x׈v=A$', 'd9`\'-LA[r[g8W?~e', '', 0, '?'),
 ('p8yqM', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_equalizer_24px.svg', 0, 'e|L#=\Z7J', 'e|L#=\Z7J', '>$<z=BH9 90fR+SWaKsx', '', 0, '?'),
 ('eHvI4.', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_explicit_24px.svg', 0, 'yOAqQ}\"Ҭ2', 'yOAqQ}\"Ҭ2', '!IG-i`cb{fkT̑#', '', 0, '?'),
 ('f̟in;U', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fast_forward_24px.svg', 0, 'NwkvO4', 'NwkvO4', 'gO]tʱ>4<%4uJwr!==', '', 0, '?'),
 ('c|1l{N', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fast_rewind_24px.svg', 0, '/+p7@', '/+p7@', ':FV\ZnQ.yWLiV', '', 0, '?'),
 ('J^\0ՠ\\[', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_dvr_24px.svg', 0, 'G5\0', 'G5\0', 'Ò]gq-aȠ.Kw)0\'', '', 0, '?'),
 (';oؼencUyE@', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_manual_record_24px.svg', 0, 'K{q', 'K{q', 'B_v\\L:X/pٞg挲G.`t	Af', '', 0, '?'),
 ('CgG̕09s', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_new_24px.svg', 0, 'Y<iCY0l', 'Y<iCY0l', 'Ez>heR(!ԩ\"D&zt3Y', '', 0, '?'),
 ('8|8x0', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_pin_24px.svg', 0, 'd)tndI', 'd)tndI', 'G3 UtIn_36P', '', 0, '?'),
 ('W]MС6n', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_smart_record_24px.svg', 0, '8ѯֹ2ti', '8ѯֹ2ti', 'Fam5kS	R;BNW9', '', 0, '?'),
 ('>9EOXۥ', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_forward_10_24px.svg', 0, 'bClꟗ^<#{', 'bClꟗ^<#{', 'O0#ʯVf82uqD: N>e\\', '', 0, '?'),
 ('5KB7SߒOt ', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_forward_30_24px.svg', 0, 'x<i]$w4', 'x<i]$w4', '!;+h\"ݔzc=ɏ$C27.', '', 0, '?'),
 ('**[ƊtI ~', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_forward_5_24px.svg', 0, 'OE]}U', 'OE]}U', '[3\0HE eB0oDk', '', 0, '?'),
 ('/8P%$߷', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_games_24px.svg', 0, '	pT=2e\Z$', '	pT=2e\Z$', '[twݫjPeW>Üc4\'Xa	', '', 0, '?'),
 ('=uw1$eZ6^,', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_hd_24px.svg', 0, '--o', '--o', '\"B1H5Lj4ȍ\"onxWG\\', '', 0, '?'),
 ('k-\'Ϸ0v', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_hearing_24px.svg', 0, '{{|o7a', '{{|o7a', 'F|I}na05%F', '', 0, '?'),
 ('D>IFo', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_high_quality_24px.svg', 0, 'Gl*G8_#<', 'Gl*G8_#<', 'xm<|n7j\\\"#jZ/1AS', '', 0, '?'),
 ('1T)y2iY', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_library_add_24px.svg', 0, 'rĚK', 'rĚK', '˛KiF(6yvstUXVĺA', '', 0, '?'),
 ('Va04\Zx1R', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_library_books_24px.svg', 0, 'q ehNP&z', 'q ehNP&z', '+ЉHlc\\2!^<J<j3e<', '', 0, '?'),
 ('\"C6Vµ	.', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_library_music_24px.svg', 0, '؃#rw', '؃#rw', 'T\r-QךH}{5,2', '', 0, '?'),
 ('c+\'qɐJ3', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_loop_24px.svg', 0, 'r/2%&.V', 'r/2%&.V', 'h)u⬉!{G\0\0\0xY#iDV', '', 0, '?'),
 ('\'[kCOcc', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_mic_24px.svg', 0, '+ \n1b7c	<', '+ \n1b7c	<', 'ms;-n s<i;b#\0DsiOXxY', '', 0, '?'),
 ('9r/E_', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_mic_none_24px.svg', 0, 'V\'-0*~', 'V\'-0*~', 'v@ՄM \Z+!\r*', '', 0, '?'),
 ('D0R(\n', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_mic_off_24px.svg', 0, 'g^VgK-$', 'g^VgK-$', 'b}U۫:oZ󨳲t[qpៜ0#O', '', 0, '?'),
 ('5bp\')3?V', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_movie_24px.svg', 0, '|>ed:U', '|>ed:U', 'Xc\Z3V.M(9rLi', '', 0, '?'),
 ('UAM)P', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_music_video_24px.svg', 0, '~f̨_', '~f̨_', 'STύfsL5lF|\rp7C=7Uw\r+0', '', 0, '?'),
 ('L^[0!_./', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_new_releases_24px.svg', 0, 'Z3˰rLnf', 'Z3˰rLnf', '#N?76Ҷ2Gk5j5E|', '', 0, '?'),
 (':]69w*6}(G', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_not_interested_24px.svg', 0, '0}} w', '0}} w', '幑姥6wXK]I;x4', '', 0, '?'),
 ('Sȏ<`,^s', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_pause_24px.svg', 0, '\\h\0=9\"', '\\h\0=9\"', 'mldJYEA_}Ѯrw\nY9', '', 0, '?'),
 ('v\" \r\"', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_pause_circle_filled_24px.svg', 0, '_My9TKVq(', '_My9TKVq(', 'ojLV)fXhcbyQ', '', 0, '?'),
 ('5x{3x5эNrB', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_pause_circle_outline_24px.svg', 0, 'L0wר4', 'L0wר4', '	<1x9L405X@!vk_KTϫ>', '', 0, '?'),
 ('CiJdIDrD]p', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_play_arrow_24px.svg', 0, 'vt3ڛ?x', 'vt3ڛ?x', '_ [hS[?kLDQ%Nr+Ҫ', '', 0, '?'),
 (',4z\"fQ', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_play_circle_filled_24px.svg', 0, '~CΥ>]ȡ*7', '~CΥ>]ȡ*7', '_8gIOB=<Me\0o^H', '', 0, '?'),
 ('S|rT\'l', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_play_circle_outline_24px.svg', 0, 'xxCx', 'xxCx', 'aѹ0bE?iV~GrDa4؀', '', 0, '?'),
 ('XzL`bWΰw', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_playlist_add_24px.svg', 0, 'II/7DjYdS', 'II/7DjYdS', '\']I˕wr7Z\"4KA=	*', '', 0, '?'),
 ('Iw6)\'\0H4', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_playlist_add_check_24px.svg', 0, '9q6ȈC\rvg>_', '9q6ȈC\rvg>_', '䘡%E.5pIp>NWk', '', 0, '?'),
 ('t\'epU=Y;', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_playlist_play_24px.svg', 0, '%hӐ׿r4', '%hӐ׿r4', 'w8QOڂ]:KBHJs', '', 0, '?'),
 ('&jv+', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_queue_24px.svg', 0, 'rĚK', 'rĚK', '˛KiF(6yvstUXVĺA', '', 0, '?'),
 ('\Z]CV1uO7N', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_queue_music_24px.svg', 0, '\\ZcF30', '\\ZcF30', 'm=Mŏ\rl\"`1qG\Z6~,6', '', 0, '?'),
 (':8c`L{&', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_queue_play_next_24px.svg', 0, 'ngMmDMJ#Q	', 'ngMmDMJ#Q	', 'zJY\'])[N\ry!mF3o', '', 0, '?'),
 ('Qt޿άǿ', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_radio_24px.svg', 0, 'G/WX}9}!', 'G/WX}9}!', '7W,!Wqv`d}ef),d', '', 0, '?'),
 ('2`a|Z', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_recent_actors_24px.svg', 0, 'Iaoެi', 'Iaoެi', 'x5\n`Zz_=zC0e.\Z`	0', '', 0, '?'),
 ('Tk|B*%p_V5', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_remove_from_queue_24px.svg', 0, 'zU;}B^J]\n\0\"N', 'zU;}B^J]\n\0\"N', 'Kٛ:bVf9IZ1', '', 0, '?'),
 (']-m-sS', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_repeat_24px.svg', 0, 'e˼jl', 'e˼jl', 'V7^В^\"4!vv', '', 0, '?'),
 ('G~Tx', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_repeat_one_24px.svg', 0, 'ao R\n321', 'ao R\n321', '`)|\0H2\nBK˓>ZT#y`', '', 0, '?'),
 ('^0uZz', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_10_24px.svg', 0, 'B	)', 'B	)', 'YP)!6MM./sip\Z', '', 0, '?'),
 ('T\ZZS>', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_24px.svg', 0, 'HÊ^#', 'HÊ^#', '\\6.^DϪ~|,<y', '', 0, '?'),
 ('bc=~+[zPY', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_30_24px.svg', 0, 'rN	-W6a`', 'rN	-W6a`', '.8}?]nIj\0ԥi.', '', 0, '?'),
 ('7	dH', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_5_24px.svg', 0, 'f4Pŏـ', 'f4Pŏـ', '7k!dPg_7ol:X챍?1', '', 0, '?'),
 ('LYȑ', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_shuffle_24px.svg', 0, 'BX\03ժ`l', 'BX\03ժ`l', '\r+/ʱvdD<d	\rsq幞ss', '', 0, '?'),
 ('M۟Èɸc', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_skip_next_24px.svg', 0, '\Z\'*m&ًE', '\Z\'*m&ًE', 'cuI?7M&8[UM\nL', '', 0, '?'),
 ('X]*:>?VcT', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_skip_previous_24px.svg', 0, '	1GKa&w͖', '	1GKa&w͖', '4?\"	j`lP//', '', 0, '?'),
 ('*L\n^b\\UjՅXb', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_slow_motion_video_24px.svg', 0, 'zⳭ|0\0Wo', 'zⳭ|0\0Wo', 'q͝MH!\rark&Yh>b', '', 0, '?'),
 ('ძo\Z:jT', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_snooze_24px.svg', 0, '޾H\Z,]P', '޾H\Z,]P', 'ˊKՈDf~-}˄[m', '', 0, '?'),
 ('9ĥ:ؑAu', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_sort_by_alpha_24px.svg', 0, '+Mo%|fi', '+Mo%|fi', '~xش{xވ>6غn>2Eo', '', 0, '?'),
 ('sg=vYC\0', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_stop_24px.svg', 0, ')*XƳ<C/p', ')*XƳ<C/p', 'hk\0a%ͺ}\\̪MQ9@', '', 0, '?'),
 ('iqӛ{fB', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_subscriptions_24px.svg', 0, '+^G\0w)T]', '+^G\0w)T]', ']=	m0w8Iz3 b', '', 0, '?'),
 ('jIX<Reԙ', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_subtitles_24px.svg', 0, 'tq`g#', 'tq`g#', '嵾pBvyk tw8 řΞ[96', '', 0, '?'),
 ('k92hCMz', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_surround_sound_24px.svg', 0, '	&ƕϢP`', '	&ƕϢP`', 'gX\'f9I)Z#AHZ\0:', '', 0, '?'),
 ('wט\"˧e8S&Tm', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_video_library_24px.svg', 0, 'G5.nO\ZbNuF', 'G5.nO\ZbNuF', '|\Z(CvknWWU.C[o`!', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('\n\n@0L|_ 2', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_videocam_24px.svg', 0, '3ʠ7', '3ʠ7', '(.W\n$ھHа \ZG\"FG', '', 0, '?'),
 ('bto;', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_videocam_off_24px.svg', 0, 'жí\"', 'жí\"', 'mjr+t\'\"Iu@ZW^O|', '', 0, '?'),
 ('1`bߟ:v\\g4T', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_down_24px.svg', 0, '#ITU;H#H', '#ITU;H#H', 'S:삫f#Ռ/J;4E˳w-', '', 0, '?'),
 ('$刯ބ6mV1', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_mute_24px.svg', 0, '*IXk+[Hc', '*IXk+[Hc', 't\Z8h!NR2Y\0|0', '', 0, '?'),
 ('⺵ɱ[)a', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_off_24px.svg', 0, 'fk}J(OK', 'fk}J(OK', '\\!sʻr\ZVM%/˙\'', '', 0, '?'),
 ('g)(q4t^', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_up_24px.svg', 0, 'lz\rmq\0\'x', 'lz\rmq\0\'x', 'ݺQjk7:otv', '', 0, '?'),
 ('ы*bYk', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_web_24px.svg', 0, '=>D3*l^', '=>D3*l^', '஥MB+P\ZYwOYwhr', '', 0, '?'),
 ('N\Z3o[', 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_web_asset_24px.svg', 0, 'a\raWW]/rJc', 'a\raWW]/rJc', '7\n˷988>7ch5wY!%', '', 0, '?'),
 ('ވ|.X', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/NewTux.svg', 0, '!m8w2#ͫ=', '!m8w2#ͫ=', ']ANY($nU[0', '', 0, '?'),
 ('>X 3g/B=', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/abacus.svg', 0, 'ifqs>J0', 'ifqs>J0', '\nJhtr[k*Wpa#O[v{', '', 0, '?'),
 ('CI\"iٳb', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/address-book.svg', 0, 'X\ZK:8D^(s', 'X\ZK:8D^(s', '__u( ,8$O`5', '', 0, '?'),
 ('(܁RLK ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/address-book2.svg', 0, 'R7rR\rw3', 'R7rR\rw3', '\rI^c>ڮuB7[4öU', '', 0, '?'),
 ('MG3=@j', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/aim.svg', 0, ',)%\Z$}Ng', ',)%\Z$}Ng', '؞-	\0[	C61^C`.+', '', 0, '?'),
 ('IR!K<lS{', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/alarm.svg', 0, 'ot̾TC{=sS', 'ot̾TC{=sS', '>bb$\"\ZܪR1]h.$\\HA', '', 0, '?'),
 ('5~iPw', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/apple.svg', 0, 'o6<@', 'o6<@', 'Qxucv>Ġ2x', '', 0, '?'),
 ('SkQ0v̧hX ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/arrow-left.svg', 0, 'qbl&lz', 'qbl&lz', 'Yk}%up6f_ާ4sL#x5_\'H', '', 0, '?'),
 ('wu,qء', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/arrow-right.svg', 0, 'q媑ar\0=1', 'q媑ar\0=1', 'PSǿFZ]fƆPL\":Y`', '', 0, '?'),
 ('P˦!#kSP	%', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/arrows-updown.svg', 0, 'J^Ahfkr4', 'J^Ahfkr4', '\r4W{XGZ!ҭznfF&B\0ԓ', '', 0, '?'),
 ('\'嫲v}_', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/atm-cash.svg', 0, 'x1Iohz', 'x1Iohz', '%jΤIZ7T y(pl,\0is', '', 0, '?'),
 ('ׇgGi*d	?', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award1.svg', 0, '{ 2NC*D{', '{ 2NC*D{', 'NNeCU\0D', '', 0, '?'),
 (' S00d|dU[g', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award2.svg', 0, 'A\\z#0Ǩ', 'A\\z#0Ǩ', 'vX*\"Ku?Ȋ!C', '', 0, '?'),
 ('\0O.bE@sC@\ZJ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award3.svg', 0, 'ȚK\ZN69\'&K', 'ȚK\ZN69\'&K', ',KDQcx0m', '', 0, '?'),
 ('6V29V(	tY', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award4.svg', 0, 'PRx~챕!', 'PRx~챕!', '|Ž`YH(^f,6i`T^-[E%', '', 0, '?'),
 ('w08GXv', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award5.svg', 0, '7َ2iN} ', '7َ2iN} ', '\"*!ϙ*ErM[9f.*݃8B', '', 0, '?'),
 ('8@)\'', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/badge01.svg', 0, 'L\"\0=', 'L\"\0=', '\ntU~asg	41J', '', 0, '?'),
 ('(&Fv	}', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/badge02.svg', 0, '-Q.1qK7=', '-Q.1qK7=', '5I\'aM\nI<ۙ=51~', '', 0, '?'),
 ('7ɷD)\'A', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bank.svg', 0, '^wy#)Y\"', '^wy#)Y\"', '$pyD:h*[%Oo㕁', '', 0, '?'),
 ('Ƣ\"XƣlRա', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bank2.svg', 0, 'W{z%=T/7+/', 'W{z%=T/7+/', '2_)bb^PhPM', '', 0, '?'),
 ('pВ-K-', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bell.svg', 0, 'h;om<s', 'h;om<s', '=_;%Y7Df[?\\p{e', '', 0, '?'),
 ('3uvKѮfǶ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/binoculars.svg', 0, 'z>jߡ!X[G', 'z>jߡ!X[G', 'T-E}:u0]d/3!', '', 0, '?'),
 ('$Xh+}', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bomb.svg', 0, 'lS{*x$', 'lS{*x$', 'oS~EQg{Lwkvn¿j8', '', 0, '?'),
 ('k	qs^_}L', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bonsai.svg', 0, 'i:j#', 'i:j#', 'c4]vwfvCF2vAxHI1', '', 0, '?'),
 ('<H:S5', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/book-apple.svg', 0, 'OU8iԥ$e7', 'OU8iԥ$e7', 'b}$ŖbJ1Ћ\"${%vu\n;uQ', '', 0, '?'),
 (')gd9m2', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/book.svg', 0, '_pU ]\nq%kA', '_pU ]\nq%kA', 'F_\rbm^OI_W:2J<\0*6ɪ', '', 0, '?'),
 ('C|9/x}W', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bookmark.svg', 0, '](\09', '](\09', 'l`-5a@<Gb\n^*\"=q', '', 0, '?'),
 ('n&[F܄^_', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/box.svg', 0, 'EÃAzq|f', 'EÃAzq|f', 'gjŦV|e7c\04~$%p$됶', '', 0, '?'),
 ('+i_o{KX\\d', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/brain.svg', 0, 'X.2A}Ng', 'X.2A}Ng', 'M~/T(ؠB}b%~p', '', 0, '?'),
 ('Z$<z\"', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/briefcase.svg', 0, '7Q!MEv͹+@', '7Q!MEv͹+@', '$IvrG2e2&\nS5h;', '', 0, '?'),
 ('o$Zw-5L\n', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/browser01.svg', 0, '\nX=', '\nX=', 'Q\r.=VXNh2c', '', 0, '?'),
 ('k(\0ǭM', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/browser02.svg', 0, '_]$_B', '_]$_B', 'A={9ʚڹs&CJ0KGw=AIW', '', 0, '?'),
 (']MrzW94', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/buildings.svg', 0, '4@׉)1ƋtR', '4@׉)1ƋtR', '6ӣeDBzRµs', '', 0, '?'),
 ('dG);O', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/buy-sign.svg', 0, '=?IOTP', '=?IOTP', 'rL5\0_^psjUNBR', '', 0, '?'),
 ('\0nz]', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calculator1.svg', 0, 'BzkwJ', 'BzkwJ', '·Q//y;]jbEX', '', 0, '?'),
 ('l!D)4', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calculator2.svg', 0, '`\0WPΛ$', '`\0WPΛ$', '1A\0K;tUrV\'\ZE', '', 0, '?'),
 ('uEz!ySr', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calculator3.svg', 0, 'Sx\"!wJV$', 'Sx\"!wJV$', 'D2E;Uq6(j5nj0; ', '', 0, '?'),
 (',Yv(ty2/', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar1.svg', 0, 'xVЇS8J', 'xVЇS8J', '+(\Zx)u]}j}ᬡjB_=;', '', 0, '?'),
 (':R*bchl', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar2.svg', 0, 'eM\"zD(', 'eM\"zD(', 'bP	`<t/d^8O{b/i', '', 0, '?'),
 ('X.\ZKdBzl|', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar3.svg', 0, '#Se3~ϫr', '#Se3~ϫr', 'ExI4k{B*\'X2L', '', 0, '?'),
 ('?@n۴n\ZW', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar4.svg', 0, '@_LFo', '@_LFo', 'CpB%~mY_NP1zJ', '', 0, '?'),
 ('Z\nTsf^cV', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar5.svg', 0, '䆊Ydx', '䆊Ydx', '(b\nW!T|Xi-\nˇD', '', 0, '?'),
 ('dZpz;\"H3cU', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/certificate.svg', 0, '*;CMC)Й*', '*;CMC)Й*', 'tFNQ#l]BܲLX\'g\\\0ŵi', '', 0, '?'),
 ('>Dref0c', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/champagne.svg', 0, 'gNϡ(', 'gNϡ(', 'g*b.8B¢[ջv`)ef', '', 0, '?'),
 ('tZf	OylZR', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character01.svg', 0, 'U:JVh', 'U:JVh', 'R>S@>DeTC `OGyW{', '', 0, '?'),
 ('xZh36+', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character02.svg', 0, 'OBW>3', 'OBW>3', 'H\"j<cOng', '', 0, '?'),
 ('T7b1**', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character03.svg', 0, 'eU|z0\'+', 'eU|z0\'+', 'Ơ/*^̫Wr:K䷆A1zD,', '', 0, '?'),
 ('f5@]^', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character04.svg', 0, 'hw(\"', 'hw(\"', 'nZ5EX<7=O4(#T.a', '', 0, '?'),
 ('uFV\'j~H', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character05.svg', 0, 'Ҙv(`\n9 -$fy', 'Ҙv(`\n9 -$fy', '[pyד8gɑ9̤QqufG', '', 0, '?'),
 ('dfg\nJ_SHl', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character06.svg', 0, 'jCW7P.U', 'jCW7P.U', 'v(y)7W/?%n~', '', 0, '?'),
 ('p\n-\"l\"l', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character07.svg', 0, 'N+r\nO9d', 'N+r\nO9d', '~cEt.kz%0J/\Z { ', '', 0, '?'),
 ('\nt5:>\r', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character08.svg', 0, '(ۭsU7B', '(ۭsU7B', 'QuohRW4LкB`uBƈ.U', '', 0, '?'),
 ('0Z<eQ_', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart-analysis.svg', 0, 'RaMY', 'RaMY', 'ozOH8[?*t0X\\:', '', 0, '?'),
 ('ԥ-S<`4', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart-board.svg', 0, '(;gB]h', '(;gB]h', 'a+pgR	ǅ_zn*n9e=', '', 0, '?'),
 ('IjR\'0u', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart-pyramid.svg', 0, 'Z7q.4UW', 'Z7q.4UW', '9ix,zά8u~)6ݔM)%l', '', 0, '?'),
 ('20BAv$o9', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart01.svg', 0, ':ffG+Z˩', ':ffG+Z˩', '[aLpJ_̪(ZkvĎ', '', 0, '?'),
 ('A6X\rQI=\'', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart02.svg', 0, '}]kb4!	w.{', '}]kb4!	w.{', 'PJL\"Ն|p#PqP7Cc,', '', 0, '?'),
 ('dQ~', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart03.svg', 0, '\"\\m#YR\0', '\"\\m#YR\0', '}g%̦~@(BFӻ$:', '', 0, '?'),
 ('z3!ec', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart04.svg', 0, 'WXn	dG', 'WXn	dG', 'UDŸ}$֖mI3AB\'wHD', '', 0, '?'),
 ('	sMCto\0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart05.svg', 0, '6ąs', '6ąs', '^/PUD\\ v/Ec6', '', 0, '?'),
 ('vջaR9L', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart06.svg', 0, 'laK@VLv(', 'laK@VLv(', 'GMaPX5*-EpM4PSe>', '', 0, '?'),
 ('_Z%', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart07.svg', 0, 'o0LQٗc\"n', 'o0LQٗc\"n', '6^4L\'Go80^Qg%gLٛ', '', 0, '?'),
 ('iO	0@X(Y ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart08.svg', 0, '6`Iy{4+|o', '6`Iy{4+|o', 'X5Rʩ{G:}A\0^ˊ', '', 0, '?'),
 ('>nPOwh97vvb9', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart09.svg', 0, ')TMb78;', ')TMb78;', '{gYL:T;uV+', '', 0, '?'),
 ('Da&8\\؞', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart10.svg', 0, '/g	dNӾ^jݨ`', '/g	dNӾ^jݨ`', ';?\r][t\0ǭ	dT', '', 0, '?'),
 ('Qz4[4I\0#x', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart11.svg', 0, 'K-辰	MÞ5', 'K-辰	MÞ5', 'O י#z2y;/O]\Z\\U7>', '', 0, '?'),
 ('#ipV3', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart12.svg', 0, 'ai7(', 'ai7(', 'ئ\\Ӝ3hc.ALh|r)', '', 0, '?'),
 ('0VR	s6s', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart13.svg', 0, 'ɣC1}9|E', 'ɣC1}9|E', 'sؿ88ޖnQmm|\0', '', 0, '?'),
 ('\rn~$fBݮ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart14.svg', 0, 'OZP5ݖa#', 'OZP5ݖa#', 'q!9axdeG', '', 0, '?'),
 ('\r92[', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart15.svg', 0, 'x(RBO,,)', 'x(RBO,,)', 'Kbx~MjQ2yTP1', '', 0, '?'),
 ('`avn4?ZGi', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart16.svg', 0, '+&ŧ@te(', '+&ŧ@te(', '3*\0}WJ]@JPNerMߐR', '', 0, '?'),
 ('\\Q;\'Xr', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart17.svg', 0, ':ixYY/T', ':ixYY/T', 'ͻ!\'fxZS/\\yk(', '', 0, '?'),
 ('OSe7cLu', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart18.svg', 0, 'ySկ\0	+G[', 'ySկ\0	+G[', 'Ա}_\n]xO`zr\\tXGV', '', 0, '?'),
 ('$CqZYuJ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart19.svg', 0, '%N\'GH', '%N\'GH', '\\r[w[Ukуhf\Zzt%i-t/', '', 0, '?'),
 ('*l{)', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart20.svg', 0, '=&N1ݳII', '=&N1ݳII', 'C^i3}Y[Ș|-u`', '', 0, '?'),
 ('\Z&$Ю[i', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart21.svg', 0, 'i\'\0S<', 'i\'\0S<', 'T!<;,޸\'V9g$-=U', '', 0, '?'),
 ('ĉqZ;Gp', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chat.svg', 0, '66W˧X,im', '66W˧X,im', '9gD.K@ȋ^)^MD&P', '', 0, '?'),
 ('`VNr', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/checklist.svg', 0, 'k$}Ng-', 'k$}Ng-', 'ċZ a\'I^gx+?=', '', 0, '?'),
 ('bd˒mHb]6A', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/checklist2.svg', 0, 'TefI(R', 'TefI(R', 'C}Zi xZ\\4\'u]N:0D', '', 0, '?'),
 ('\'t1\'QdW(|', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/checklist3.svg', 0, 'u<b^_L*uUMk', 'u<b^_L*uUMk', '{M>g#dx', '', 0, '?'),
 ('H)9V+', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chemistry.svg', 0, 'Ȅ*yel', 'Ȅ*yel', 'Uc^9@ˌ;v:O8|D', '', 0, '?'),
 ('5ŀedH0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chess-knight.svg', 0, 'zsu4-X*Tp', 'zsu4-X*Tp', '\"o0ݟ=Ofע)', '', 0, '?'),
 ('Bl@!2ӊ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chess-rook.svg', 0, '\\Hȑ', '\\Hȑ', 'WB\\Ѐ99cEEZ', '', 0, '?'),
 ('Ƚ3۴Ǉ\\t', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chess.svg', 0, '\\SkDpw&s	q', '\\SkDpw&s	q', 'mkr+]h^\n3WT\r\'n', '', 0, '?'),
 ('}n8-q>Wĝ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/clock.svg', 0, 'O5Kn[ƙ\0G+R;', 'O5Kn[ƙ\0G+R;', 'Kĕ*p;ë.[\ZkbJJ#`', '', 0, '?'),
 ('?oB97Uq', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/closed-sign.svg', 0, '33]t', '33]t', '8dXP\Z-].e\nGЏL!', '', 0, '?'),
 ('\0wMTTܞby', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/cloud-coins.svg', 0, 'lV3ꞦMN', 'lV3ꞦMN', '\r7z:XᏭl{R\\', '', 0, '?'),
 ('p^2{*', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/cloud-down.svg', 0, 'K]p!s]', 'K]p!s]', 'm\rZ\Zgg	\0jjLy', '', 0, '?'),
 ('<@:\n 7', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/cloud-up.svg', 0, '`59*_\\C@', '`59*_\\C@', 'nI:E#RQF?綩m', '', 0, '?'),
 ('>i%U,EL', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/coffee.svg', 0, '	7X݅؋', '	7X݅؋', 'dr%;]#!~o-mor \Z}', '', 0, '?'),
 (';T=fGϽeW', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/conference.svg', 0, '.zG\r\ZS3	ES}', '.zG\r\ZS3	ES}', '&#PFL+8(.AH}{5@w:]', '', 0, '?'),
 ('Xn[Inߢ\n6^', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/contact-book.svg', 0, '(1ߜtnf<{!', '(1ߜtnf<{!', '$57\"Xҕ\0{Ç9 1Цw', '', 0, '?'),
 ('vfNxZk̊F', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/coupon.svg', 0, 'W1갑UsS', 'W1갑UsS', 'nڛQ\"`TJ4/ZXP.', '', 0, '?'),
 ('z$~Jo', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/credit-card.svg', 0, 'n\0jY', 'n\0jY', 'K\ZDk#i{^&', '', 0, '?'),
 ('.>vP[1[', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/crown.svg', 0, '\r_/n\rt8twuga', '\r_/n\rt8twuga', 'OE`WSK/qfLa<1', '', 0, '?'),
 ('>-0e\r%)go?', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/currencies.svg', 0, 'YVK1', 'YVK1', '3UvaNGz.ƚWyGSΘ\rm', '', 0, '?'),
 ('RdO!lH,', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/database.svg', 0, '1~mk!}b', '1~mk!}b', '!^TTGV6Z>oS&', '', 0, '?'),
 ('X-##cu', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/delivery.svg', 0, 'ý\n5xl|OtM)', 'ý\n5xl|OtM)', '.\0ãGsI1\r6 #<}', '', 0, '?'),
 ('A1\Zfz;t1', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/diagram-hierarchy.svg', 0, 'sɫ(', 'sɫ(', '&!Ho[Mb<50)r	', '', 0, '?'),
 ('ii	AQ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/diamond.svg', 0, 'U\nǭG9', 'U\nǭG9', '=>wow(w\'qRN >', '', 0, '?'),
 ('V`kA4%j', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/dollar.svg', 0, 'Raif9ưsZА', 'Raif9ưsZА', '#^0Dx*8\0&', '', 0, '?'),
 (':|XH\0\\Il\'', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/drawer.svg', 0, ';y<2&5&x]43', ';y<2&5&x]43', '\nGGOqCFqY5k|nWRUJ', '', 0, '?'),
 ('԰Q\"Ku\n', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/egg.svg', 0, '{	<]Rc\'K', '{	<]Rc\'K', '?\0BΓP CmxӢ\nsHGJ', '', 0, '?'),
 ('ԪItT{', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/emblem.svg', 0, 'h%V+\'L5', 'h%V+\'L5', ')\08!PE$lX;zD)3', '', 0, '?'),
 ('lLs>TB', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/envelope-money.svg', 0, 'u\'v0Ϳ\n', 'u\'v0Ϳ\n', 'J@#6	zF\rrUm|埬', '', 0, '?'),
 ('-ھ&\0\'$<K>', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/envelopes.svg', 0, 'ukbvQD', 'ukbvQD', 'o\n7 T8ݍۀPe6,wV', '', 0, '?'),
 ('|@кѶȽ1jJ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/euro.svg', 0, 'XbU{,', 'XbU{,', '	?-|*J_\nDʻ@*!R', '', 0, '?'),
 ('ɼj0\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/exchange.svg', 0, '}aCK', '}aCK', '7k~0hN(E0k|6f', '', 0, '?'),
 ('ir`O 3RTs\"', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/exit.svg', 0, 'd$+ꞂB02o°y', 'd$+ꞂB02o°y', '0cde客Ey2ۍ', '', 0, '?'),
 ('bxǖOZ<C', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/factory.svg', 0, 'Y6!,^1HP\nP', 'Y6!,^1HP\nP', '~Ԇt\\IQPd(4C\Z\r', '', 0, '?'),
 ('Rzһ(5\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/fax.svg', 0, '.\"#p@', '.\"#p@', '\\LY*cb9M9Ӥ3', '', 0, '?'),
 ('kLZYCX>ڭ\nP1', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file01.svg', 0, '\0\"\'vu5.e', '\0\"\'vu5.e', 'cʙb!\'yʞi-io)', '', 0, '?'),
 ('LΩ\'\rPDv', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file02.svg', 0, '0$#4=+X7Y', '0$#4=+X7Y', 'eP%j`\\>+\0aǌ2l', '', 0, '?'),
 ('UvX7r(', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file03.svg', 0, '_\'3<5[咟', '_\'3<5[咟', '<ޥڲ5WAe!8,', '', 0, '?'),
 ('Svng1{', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file04.svg', 0, 'Ï@ot', 'Ï@ot', 'vjX?w޷D)9', '', 0, '?'),
 (' lYgwZ.', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file05.svg', 0, '};\Z8I', '};\Z8I', 'hBbkjVva2 ay4Zd', '', 0, '?'),
 ('±	73Ѯ8', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file06.svg', 0, '}V.]E|;W', '}V.]E|;W', '!\ni,@mv\rJ^/k', '', 0, '?'),
 ('\r4MmwE\'BA0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file07.svg', 0, '^->/\"', '^->/\"', '@,##ߟw-V(5=', '', 0, '?'),
 ('9*}~o\\V', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file08.svg', 0, 's`bSCa}f', 's`bSCa}f', 'Fn&8+\njB?ь♮_', '', 0, '?'),
 ('p<!ڈ ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file09.svg', 0, 'V,', 'V,', '=7~MO\"c}{c_2;{L W$', '', 0, '?'),
 ('JZ-°IŇ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file10.svg', 0, 'LYwt-T', 'LYwt-T', '3RSR(^SiSFoX(uEZc', '', 0, '?'),
 ('ܠ4_+;Ѩ2', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/files.svg', 0, '-2Tdz', '-2Tdz', 'Ply	^~M\n0 8', '', 0, '?'),
 ('N6`f.{0:', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/fire.svg', 0, 'L&X2\0Ѵ3', 'L&X2\0Ѵ3', 'FQ	ӵ\rK5&eS_*WFev', '', 0, '?'),
 ('BLNyjr?', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/fish.svg', 0, 'N\nGIm', 'N\nGIm', 'QR7p}=Cң۹8XCN', '', 0, '?'),
 ('4_dmLk\rl.', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/flag.svg', 0, 'G[Dd\\<', 'G[Dd\\<', '(;ov-SK=Zk0У=$\r$g#', '', 0, '?'),
 ('bIB skԜ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-add.svg', 0, '(AЩF1', '(AЩF1', 'o=d\\;zN lҫD)R0Wg2¦\Z%', '', 0, '?'),
 (']\nry6fY	', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-delete.svg', 0, 'Ns/^\rY}', 'Ns/^\rY}', 'w[h8\0*L	4\'\rAnO.=.', '', 0, '?'),
 ('fATvϧ4', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-online.svg', 0, '\'\'fRd \\^', '\'\'fRd \\^', '_34;j:HsapK)V;T*', '', 0, '?'),
 ('Le\'J^[', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-private.svg', 0, '8Xpbm9[ 3:', '8Xpbm9[ 3:', ')΢vM%uEƓo٧⯧+R', '', 0, '?'),
 ('GE9=\rF', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-remove.svg', 0, ':eڔS^$', ':eڔS^$', 's\n墠\Zp\"n)dH-5.jǮ_', '', 0, '?'),
 ('\Z#nZ,', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder.svg', 0, '=((TDƍ0', '=((TDƍ0', '`y3汮ʀ.Ctb*R{Eh\\', '', 0, '?'),
 ('t𓓦1dHXϓBH', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folders.svg', 0, 'Ɖ	[T+ݏ', 'Ɖ	[T+ݏ', '1̋чP\"8/eYIFRV', '', 0, '?'),
 ('&^9fV!.ө', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/funnel-money.svg', 0, 'Y܌8', 'Y܌8', '<QA#xlk~#޳)S$m', '', 0, '?'),
 ('<}', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/funnel.svg', 0, '`u8sEJη', '`u8sEJη', 'CոSuD!R3EeϪ', '', 0, '?'),
 ('aX0eR;}', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gauge.svg', 0, 'oT\r.T$p', 'oT\r.T$p', 'kuUi~۳p:#Ϡ*^', '', 0, '?'),
 ('֩6%Ôa', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gauge2.svg', 0, 'N|ub3', 'N|ub3', '17U辫m.d|\'O<\"', '', 0, '?'),
 ('ջg_H9S22v', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gears1.svg', 0, '~oKYP鑟+\0', '~oKYP鑟+\0', 'UЮ 58QT傾o\'$+?*)', '', 0, '?'),
 ('r܈v$֊J@', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gears2.svg', 0, '4#rհXKt@װ', '4#rհXKt@װ', 'ġZ%|Epl;stŧ?', '', 0, '?'),
 ('M9NH0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/glasses-moustache.svg', 0, '$2$I&', '$2$I&', '\Z֖\'c=In\rM%ܖGK~a', '', 0, '?'),
 ('?\0:A8fy', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/globe-money.svg', 0, '(\r۴0', '(\r۴0', '+=\rOw/qF诐Y!WAMl', '', 0, '?'),
 ('bch{\rqY5]', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/globe.svg', 0, '>VD<<', '>VD<<', '/ZJ,Ւ3!|Y#', '', 0, '?'),
 ('¤SG,NQ*\0&*', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/globe2.svg', 0, '4ƁF7V!mq\\҄', '4ƁF7V!mq\\҄', '#^va7N^·iْq $', '', 0, '?'),
 ('Twzɂ\'\n=)p', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/graduation-hat.svg', 0, '\Zn\"im}', '\Zn\"im}', 'B\"w2_4œqƨKZjx[r', '', 0, '?'),
 ('NJ4}s;[', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-globe.svg', 0, '\\)@Z]r', '\\)@Z]r', 'ZUnR#bɀ}vL9$Il', '', 0, '?'),
 ('|ZE3~PCX%', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-key.svg', 0, '4.,GK\\i@\"', '4.,GK\\i@\"', 'M4eq\Z~.Vfΐ_9t', '', 0, '?'),
 ('-kRO^', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-money.svg', 0, ' ݡ؇\Zl', ' ݡ؇\Zl', 'Y=\"!\'?j#?', '', 0, '?'),
 ('v3cAkaƎa\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-money2.svg', 0, 'Yy\rpC', 'Yy\rpC', '\r :t6b!fw\\/EΩnS', '', 0, '?'),
 ('SErUx\\', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/handshake.svg', 0, ' v&\ZHR', ' v&\ZHR', '}`lW\rz(zqLmQ<l(F', '', 0, '?'),
 ('iWN@zw@', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hat-moustache.svg', 0, 'ZA>k&ʘV', 'ZA>k&ʘV', '8ý\\^\'(+{y谥\r', '', 0, '?'),
 ('ԧb\\)zq\"?P', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hat.svg', 0, 'PF5=#DP\\', 'PF5=#DP\\', ' lӳʬL;g?\n ', '', 0, '?'),
 ('>;kۉ8?', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-arrows.svg', 0, '@)mzY膐\\ԛh', '@)mzY膐\\ԛh', '*\'WQ[i%J{t=DPgc%;]', '', 0, '?'),
 ('S7{&ϳVQ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-battery.svg', 0, 'E\"ǻ#k', 'E\"ǻ#k', 'gUQP\\0wʪ~8', '', 0, '?'),
 ('.ٹGsO7', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-check.svg', 0, '?2nP[<', '?2nP[<', 'IAE☪{88:`}uTyD&', '', 0, '?'),
 ('m4?(Pri}', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-compass.svg', 0, 'WA5sX&z', 'WA5sX&z', '<\nUR\nrWވZXĕ', '', 0, '?'),
 ('Pu]`;&n', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-dollar.svg', 0, 'AiS6k&:o', 'AiS6k&:o', '5D5y\0ƈ0I&rZAY=d', '', 0, '?'),
 ('5q͌Afcl', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-exclamation.svg', 0, 'ޛnJπ\\0ǂ_|', 'ޛnJπ\\0ǂ_|', 'Ld)o`1`}È|HDB-', '', 0, '?'),
 ('h6!{\rz', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-flash.svg', 0, 'uE-OҶ\Zkk', 'uE-OҶ\Zkk', 'Uxm9g H_yop9K_kN', '', 0, '?'),
 ('Nf\n2n@4bhG', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-gauge.svg', 0, 'eMGL', 'eMGL', '\nFIpN{d74E?ⲥK>q', '', 0, '?'),
 ('J\0B\r', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-gears.svg', 0, '?S`(ԢX', '?S`(ԢX', 'cI|(1T,E}g/֫', '', 0, '?'),
 ('8W6F\'x', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-hourglass.svg', 0, '>eG0Ѻ\r', '>eG0Ѻ\r', '1.vHB0&pe1J\\G\"', '', 0, '?'),
 ('?D핅F[< ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-idea.svg', 0, 'RB\r*mw8', 'RB\r*mw8', '\'s)5Lh/35*xtb', '', 0, '?'),
 ('zNľb{gel>', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-question.svg', 0, 'vS\Zz\Z', 'vS\Zz\Z', 'Վ2X	w[fzٍ}', '', 0, '?'),
 ('CزdWW$w', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-structure.svg', 0, 'nbiUI', 'nbiUI', '6z;.O |oؠ/Qґ;Gh', '', 0, '?'),
 ('\'+.F`vz>', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head.svg', 0, '+O]', '+O]', 'FZ+Ҁty/0op:aq^I', '', 0, '?'),
 ('\0\"{s :', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/headquarters.svg', 0, '!*5z<>?2', '!*5z<>?2', ').fٖtS̐c&?\n{S琮', '', 0, '?'),
 ('q6br6*', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hourglass.svg', 0, 'Iqq?2S+c', 'Iqq?2S+c', '@i?WhslM\'ѩ[:2', '', 0, '?'),
 ('\ZkFv&cg:', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hours.svg', 0, 'U?gPAL1.', 'U?gPAL1.', 'rۊX_Yȕr9n7V\\\rL', '', 0, '?'),
 ('\nF xv*?/', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/incoming.svg', 0, 'B1;hEG jȴ', 'B1;hEG jȴ', '4\\6m0,@d+F\"^vͶsH̯_', '', 0, '?'),
 ('fahֲ`;', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/ingots.svg', 0, '2*z>2', '2*z>2', 'T)}?f3[Ѹ$wZ', '', 0, '?'),
 ('\0Kqwn', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/key.svg', 0, '*h>P:	', '*h>P:	', '¼#35?hщ%', '', 0, '?'),
 ('\"#pI~\'', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/key2.svg', 0, 'o\'I`O6%', 'o\'I`O6%', '6tÀRdc+αҠ^=', '', 0, '?'),
 ('@\rr!Xێ9{T', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/keyboard.svg', 0, '+S䃺Mo<2>', '+S䃺Mo<2>', 'kP$ώ=w	4{C\'\ZLxVi*', '', 0, '?'),
 ('}٠G=D', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/label.svg', 0, '5WnGT>', '5WnGT>', '_LF\ZQxws21c잓+R', '', 0, '?'),
 ('^U|fH^k\\', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lamp.svg', 0, '?;# pá', '?;# pá', '0\'Qi|c/j0(\\ߧ', '', 0, '?'),
 ('#c#Bkb-,Lt', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-article.svg', 0, 'iԇ|!HG<', 'iԇ|!HG<', 'XcaL+Dg:6Քt\'8_T', '', 0, '?'),
 ('y^eI88HP', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-cart.svg', 0, 'K-k˞<\0', 'K-k˞<\0', '}\0w/TAxz+~LYo.Zy', '', 0, '?'),
 ('G8C	+{', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart.svg', 0, 'p%hKJL|', 'p%hKJL|', 'P\Z$Q\'¨4v}Y\rKj(', '', 0, '?'),
 ('{Nk2x', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart2.svg', 0, '{EMPqr)̼6', '{EMPqr)̼6', 'f?`df6\\t;R`E3d\Zx#', '', 0, '?'),
 ('m݅\"恅t)B', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-diagram.svg', 0, '[ѥͤ', '[ѥͤ', '2\r\'}%a	BW̝x\\', '', 0, '?'),
 ('[>\\%/Xߨ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-envelope.svg', 0, '@z]Do6,8', '@z]Do6,8', '{T*니\rn$bwkw#Ū)&', '', 0, '?'),
 ('UrC?Iؒ+A\0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-finance.svg', 0, '}u),mv', '}u),mv', 'ԦZ-8[81<-m;ʆ', '', 0, '?'),
 ('qH*tG WXz{m', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-privacy.svg', 0, 'އs쵭As,e', 'އs쵭As,e', 'hvͼB #+-PG6gk', '', 0, '?'),
 ('M|R\\Юcv', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-settings.svg', 0, '3ߪr@#CW', '3ߪr@#CW', '@Z)i\rXPiY-', '', 0, '?'),
 ('zp#>)4', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-user.svg', 0, '2MX,\"J96', '2MX,\"J96', '\rj7I8fr6R̠;VD\Z1M', '', 0, '?'),
 ('_Zlͭz`', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop.svg', 0, 'Po]|\r', 'Po]|\r', 'Ӣ9\\MϏҜD39MQ8%', '', 0, '?'),
 ('2J4SE,F![', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb-green.svg', 0, '.nQ{z\\VT', '.nQ{z\\VT', 'ui\"c~V\n!|[', '', 0, '?'),
 ('F\r,@>\0Ord', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb.svg', 0, '-YrFNO֮', '-YrFNO֮', 'c*\nߡXLpKHo=I', '', 0, '?'),
 ('\n\Z`;O#', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lightning.svg', 0, 'HU\r(:\rM', 'HU\r(:\rM', 'Aй6\Z]!:p.W\"ad>', '', 0, '?'),
 ('z-;ne', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/like.svg', 0, 'k6a5TS|6', 'k6a5TS|6', 'm7%YVXX1${|	B\0h', '', 0, '?'),
 ('q(q,A', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lock.svg', 0, 'RjX=?Fh', 'RjX=?Fh', ',L	Yi1{0E<@gOd', '', 0, '?'),
 ('WʰQaƙhW', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/magnet-money.svg', 0, 'ތm%M', 'ތm%M', '$YIsҕ,1/\"*=6!C', '', 0, '?'),
 ('\ZR@vPN', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/magnifying-glass.svg', 0, 'q#z', 'q#z', 'E޲!d<pRQX>	d\n!p)', '', 0, '?'),
 ('_U$=923	', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager-globe.svg', 0, '~j9Pu\0', '~j9Pu\0', 'N\rG`nAI{|]i{ӹ\Z', '', 0, '?'),
 ('\"VIwk>m', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager-idea.svg', 0, 'ч#U¹l?', 'ч#U¹l?', '\\\"SjZjh6[f)e', '', 0, '?'),
 ('KW\\[/1\0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager01.svg', 0, 'IdҾ*m', 'IdҾ*m', 'Hvt#)ƜPE', '', 0, '?'),
 ('\n5d?Y:c=h', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager02.svg', 0, 'YxlJ\r\\', 'YxlJ\r\\', ']R2t.5tٺMNj\"SUq~\"', '', 0, '?'),
 ('ҊѺR=\Z \n_', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/meditation.svg', 0, 'Uk@e\"', 'Uk@e\"', 'BΗe3Ljpxzq\'&', '', 0, '?'),
 ('lPe5ض-@\0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/megaphone.svg', 0, '2)D??MRh', '2)D??MRh', '[:i4`]#m\\0.900-oP5\0H', '', 0, '?'),
 ('Nx`z', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money-growth.svg', 0, '|BF', '|BF', '|)v.ܤOHGO\\zl!Z´6', '', 0, '?'),
 ('z G1eRx h', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money-scales.svg', 0, 'W\'쾏', 'W\'쾏', '\rPG_9.ksD\0`C3	!<', '', 0, '?'),
 ('G>s߼zϐ@', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money.svg', 0, '5վR8\\5', '5վR8\\5', '5.W&e!P;):Y!C', '', 0, '?'),
 ('6sJ_D', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money2.svg', 0, 'J㱸9Nb', 'J㱸9Nb', '۸/șHcE', '', 0, '?'),
 ('HR%N_sm~4hf', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money3.svg', 0, 'GJc_(@	', 'GJc_(@	', '[7#Sv)LG#y\0jZ|x?[', '', 0, '?'),
 ('U@W;(M%', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money4.svg', 0, 'JUy	r(랏', 'JUy	r(랏', 'V(07?&VͰֆ~/\n\r觮V|`e', '', 0, '?'),
 ('۳7	8t<', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money5.svg', 0, '\0;1{^72', '\0;1{^72', 'XC&=K2;;`A=\"n', '', 0, '?'),
 ('X\ZZa݌\r', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money6.svg', 0, '̻Ԇp>$\r)', '̻Ԇp>$\r)', '9Bp)Cߍ!2<\rLLT', '', 0, '?'),
 ('Vdj\r$NdtF', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/monitor.svg', 0, 'P$S$;.c', 'P$S$;.c', '\rۂӋt4B\\?8M&[<ֆA꣑', '', 0, '?'),
 ('ƓGX9=9\r', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/mouse.svg', 0, 'ru\\10`?', 'ru\\10`?', 'zi_qȇ`te5Yp\n2,۱c', '', 0, '?'),
 ('ON~52:', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/nest-money.svg', 0, 'ұM|\'C\'V', 'ұM|\'C\'V', '-}]\Z%޸\r*$ԹOU\rEY', '', 0, '?'),
 ('R@b$tJx]Q', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-jobs.svg', 0, '|ʅ\0LN', '|ʅ\0LN', 'ӗdV	!/j1W)H5#\0r	', '', 0, '?'),
 ('E_kKuvo2', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-pen.svg', 0, '҆3rPn', '҆3rPn', 'ɥJ!hH7%Z\"HS;$0aӟai9', '', 0, '?'),
 ('	yo6=6\'Ț(', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/newspaper.svg', 0, 'h.ڼ۟k0', 'h.ڼ۟k0', 'cWvpl=,WT=h+', '', 0, '?'),
 ('̝B%Nk', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/note-paper.svg', 0, 'S6%7G%B', 'S6%7G%B', '1Ux|!⟏n9IxdT:', '', 0, '?'),
 ('7M}ATHf', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/office-chair.svg', 0, 'y\rƽ1<m5~', 'y\rƽ1<m5~', '^n3\"ڼ82- E@a7_m[', '', 0, '?'),
 ('qn(\nև!', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/open-sign.svg', 0, 'ˡ\\L;\\\\g', 'ˡ\\L;\\\\g', '\ZShKa>V,=}8USWc<U', '', 0, '?'),
 ('O,.淎\n?iY', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/outgoing.svg', 0, '>_b73', '>_b73', 'tȎ*`JJ֕kG s#g', '', 0, '?'),
 ('Dc\'d_ȜX', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/paper-clip.svg', 0, '\ZMZH(Jj', '\ZMZH(Jj', 'JS^廊j5w;#--', '', 0, '?'),
 ('ןz		=Zy', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/paper-plane.svg', 0, '\ZMZH(Jj', '\ZMZH(Jj', 'JS^廊j5w;#--', '', 0, '?'),
 ('y-?bN _', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pen.svg', 0, 'ut Of[-', 'ut Of[-', 'ÊK4c#2?|VR\nO->ע{', '', 0, '?'),
 ('{1rf|!l\r8', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pen2.svg', 0, '`g0|&Jg', '`g0|&Jg', 't&فXH%hu\"wАVH@	', '', 0, '?'),
 ('D93Wd#', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pencil.svg', 0, '&|❝,f:qCYL;', '&|❝,f:qCYL;', 'Dؒy[vQq~λrRS', '', 0, '?'),
 ('QJfR{E', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pens-pencils.svg', 0, '6GΪT', '6GΪT', '\\g?+%0D3p\rU H7ǋ͗k', '', 0, '?'),
 ('j,ΐI}\'u,', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-arrows06.svg', 0, 'vOH%,3}䤎LZ', 'vOH%,3}䤎LZ', '\r1vO_<х(%{ub', '', 0, '?'),
 ('q})|gֵh~&', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-gears.svg', 0, 'Ě!H?O', 'Ě!H?O', 'E]дerV6*(;', '', 0, '?'),
 ('E,UuuEt66', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-handshake.svg', 0, 'UP>ZvB$', 'UP>ZvB$', 'm-4тdɜ3p.6xDLT[', '', 0, '?'),
 ('`Y\"V*', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-idea.svg', 0, 'Ɏ#-X2', 'Ɏ#-X2', '>%ݧ\"\"nXjQ:8', '', 0, '?'),
 ('	whʫL', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting.svg', 0, '4V6tX#.8`X', '4V6tX#.8`X', '1$b\r7$^Fx} ;!361', '', 0, '?'),
 ('7.?>F2;', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting02.svg', 0, 'n	;qa', 'n	;qa', 'XCJ|`]0yW0J5hxR,~', '', 0, '?'),
 ('WOP6e', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-search01.svg', 0, '_\04OV\"!', '_\04OV\"!', 'E-}a!U>Vz߸tqP1Z\"%', '', 0, '?'),
 ('Q/[ؔ\nF(0e', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-search02.svg', 0, 'wH|}\r\nM_\"Io', 'wH|}\r\nM_\"Io', 'nbs)+\\۳r|c&7@', '', 0, '?'),
 ('욗=͔6m\0', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure.svg', 0, 'XjfE*#[', 'XjfE*#[', '$KU\n}w`\"Rp#%>6$B*=ǎ', '', 0, '?'),
 ('j:P', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure01.svg', 0, '|adD!I', '|adD!I', 'dʭ7#Q\"%Mz3\\\0wx', '', 0, '?'),
 ('j[ͫbF', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure02.svg', 0, 'x`CsWj', 'x`CsWj', '\ZRӧ>c.V\0hWU_\n	v[', '', 0, '?'),
 ('l6zZ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure03.svg', 0, 'C4I1ɡFT\'SF', 'C4I1ɡFT\'SF', '9)<;ǵ$c@Klceug%X\Z@G\Z', '', 0, '?'),
 ('bJȨCK', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure04.svg', 0, 'x>8sf&}', 'x>8sf&}', '~J|5iK=`H불G<Zf', '', 0, '?'),
 ('`f9(', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure05.svg', 0, '`P\0m%v', '`P\0m%v', 'Gͫ~H\'\n-y`ebaLQ', '', 0, '?'),
 ('\nCAD8xp', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure06.svg', 0, '\rr1Ii\n+o', '\rr1Ii\n+o', '\nbB:&# \0e(nq', '', 0, '?'),
 ('zmĿ3&', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure07.svg', 0, '^4Ț ', '^4Ț ', '|: XP\\SqZ=+', '', 0, '?'),
 ('m ad7z', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/percent.svg', 0, 'n`l5Z\r', 'n`l5Z\r', 'Dbj~V>yrE6u1j&t', '', 0, '?'),
 ('Z[f/}bI\'', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/periscopemoney.svg', 0, 'H.l􂁄*d', 'H.l􂁄*d', '4\r-_\";OAx_P', '', 0, '?'),
 ('>CK$z9b', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows01.svg', 0, 'I )Zf\\n', 'I )Zf\\n', 'V{Tr*+o^)J{rWY\'', '', 0, '?'),
 ('T{bǸP-Zr', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows012.svg', 0, 'ش:\n\"zJ', 'ش:\n\"zJ', '\n,3DM.jk0>7', '', 0, '?'),
 ('\'cdL8$8', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows02.svg', 0, '	{>O#v^@', '	{>O#v^@', 'GE645۲Q_2VlET', '', 0, '?'),
 ('GVE$5G݁[yb', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows022.svg', 0, 'a\0 ǧCƔ^^', 'a\0 ǧCƔ^^', ',4te_<M6?~rF;6M}', '', 0, '?'),
 ('ZLWz[gh', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows03.svg', 0, 'DngBBtT{', 'DngBBtT{', 'w!w0(HҨLvBb\Z=c', '', 0, '?'),
 ('Lt6j8\'2(', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-checkmark.svg', 0, '#b\\1CW', '#b\\1CW', 'Qjl riv\0M+~3', '', 0, '?'),
 ('O}', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-cross.svg', 0, ',<M$mR4hĆ', ',<M$mR4hĆ', 'ٲ_(\rhW~{f', '', 0, '?'),
 ('^)b̏.c@<D', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-data.svg', 0, 'LہH7\"`0', 'LہH7\"`0', 'ua~s?\0Qm{Hks_/Cš@_j', '', 0, '?'),
 ('*0n\\b', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-dollar.svg', 0, 'حujӟ֕P', 'حujӟ֕P', 'tY~93ղ邦	F1Bb', '', 0, '?'),
 ('vGPXpmR', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-finance.svg', 0, '}+WXQ\0T', '}+WXQ\0T', '\"Z8b:c~ئJ0cɶo_R', '', 0, '?'),
 ('-\rypF', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-flag.svg', 0, '[*LVL+<g7w', '[*LVL+<g7w', 'xBto]΋ߛ!2n5xQ7k@ڲ2', '', 0, '?'),
 ('5#zgGiS~', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-globe.svg', 0, 'has::~V', 'has::~V', '7#\n*ٚ1 --lԨJT\'K%[', '', 0, '?'),
 ('^4x@', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-idea02.svg', 0, '7RA*k', '7RA*k', 'sy]\rjx1u@<\rTF', '', 0, '?'),
 ('eЎ=wM[v)', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-info.svg', 0, 'B۾Ӹ\ryȀ`%', 'B۾Ӹ\ryȀ`%', '/zLNGaԷ	C+Hq]', '', 0, '?'),
 ('\r/QewE', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-puzzle.svg', 0, '%cȥAV,yl[', '%cȥAV,yl[', 'ztdZפ\"ñs>mqE,', '', 0, '?'),
 ('0򾮉r^?lA{', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-scales.svg', 0, '-~;\0@&~', '-~;\0@&~', 'Zu;tj\ru..A.L', '', 0, '?'),
 (':C>&\r8\0i\r', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-time.svg', 0, '9{-', '9{-', '!1ָ~>g \\1\Zy+ѹ', '', 0, '?'),
 ('XOy1 S', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-umbrella.svg', 0, 'E,yav', 'E,yav', '7㿾ΕuIOdh!Kdt@', '', 0, '?'),
 ('E|}zBM>', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/phone.svg', 0, 'I%+S8?', 'I%+S8?', '\0mpFut+xQHb6', '', 0, '?'),
 ('#ufUiR', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart01.svg', 0, 'L|R\'pg', 'L|R\'pg', 'v\n]igVH\ZY^.pvO', '', 0, '?'),
 ('\r|ۈ-C	[P', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart02.svg', 0, 'oq', 'oq', '-WKAK|\r	vB@C+ ', '', 0, '?'),
 ('k@fx@', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/piggy-bank.svg', 0, 'B賴OC\r7u', 'B賴OC\r7u', 'trA<H.8	w,+5}Ν', '', 0, '?'),
 ('׌ZۥE?lw2', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pin.svg', 0, 'ZQCJ:8', 'ZQCJ:8', '-I)6?uY=[oSDz', '', 0, '?'),
 ('SYCO2瘍', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/plant-money.svg', 0, 'C4x;|', 'C4x;|', '2\'ɣZDKUvWX.1}', '', 0, '?'),
 ('CB}&Uсl(C', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/plant.svg', 0, 'Kk%82|9҅', 'Kk%82|9҅', 'V/h|l\r&O9\0r-Red', '', 0, '?'),
 ('V10xVA-S', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pound.svg', 0, 'rft~XjH', 'rft~XjH', '`c/@6.t!Z_\rtvZ', '', 0, '?'),
 ('	_:Oig', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/presentation.svg', 0, 'l\r,_ȇ', 'l\r,_ȇ', 'Ϲ*}d0G\Zno#`FA9_e\"', '', 0, '?'),
 ('џȩm2', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/presentation02.svg', 0, ',kTngUdjW', ',kTngUdjW', 'VCHfR&7&~pwH>Y', '', 0, '?'),
 ('m;gxI', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart02.svg', 0, 'N:y)', 'N:y)', 'x!4/e.ͱvFj,DoW', '', 0, '?'),
 (']>ՌW%n6', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart03.svg', 0, '#WB5Tђ^', '#WB5Tђ^', ' dҤ\',ewA	ڑ>+=', '', 0, '?'),
 ('k\rHR!N(', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart04.svg', 0, ' N\rS1*^MO', ' N\rS1*^MO', ';еT\Z\0b3xUʏ@MO', '', 0, '?'),
 ('C5#;8v ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-laurels.svg', 0, '҃0<$', '҃0<$', '~ݱjz	mD`2=_g-Op', '', 0, '?'),
 ('fr9}2EN', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-megaphone.svg', 0, '##ȋĪ`_', '##ȋĪ`_', 'b1\"v}t3#;twg', '', 0, '?'),
 ('2)DC', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-stairs.svg', 0, '#qÐWl!1', '#qÐWl!1', 'c(;/Rs+͵ڧFWjY', '', 0, '?'),
 ('_+]:<', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/printer.svg', 0, 'ziʁ\Z՚', 'ziʁ\Z՚', 'kRV,!n89ń?', '', 0, '?'),
 ('^\0vV~G[o)k', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/profile.svg', 0, '-3>VxuH@b\\', '-3>VxuH@b\\', '>AHs!PgG\0>s', '', 0, '?'),
 ('v~rI:簀}K', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pulse.svg', 0, ' LTaOGQ', ' LTaOGQ', 'Zze;Wci\\Q*N~i', '', 0, '?'),
 ('j͠[B\Zg', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/puzzle.svg', 0, 'RdZ#cRmq_1', 'RdZ#cRmq_1', 'u4nQ@FmRh4ߘ9y', '', 0, '?'),
 ('c?`dQl', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/quill.svg', 0, '5Ň&>%iL', '5Ň&>%iL', 'x2<agɇ\0h=JCn/96Oi', '', 0, '?'),
 ('teKSHv', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/recycle.svg', 0, '1[VUS+ӆ-', '1[VUS+ӆ-', 'c `XXG;{Y}ƫVbJwX', '', 0, '?'),
 ('zySU', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/rocket.svg', 0, '}b[,۰北0', '}b[,۰北0', 'yM	ǩȁu%Q(>~fc', '', 0, '?'),
 ('FGŜA?KM', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/rocket2.svg', 0, '|;.lw8}', '|;.lw8}', 'cK?Xb?tF4O+]uf3a\'%&/', '', 0, '?'),
 ('g݆ёB$%', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/ruble.svg', 0, 'BN#Rw	1@', 'BN#Rw	1@', 'ǪkCIҒ3#rA?Xg`', '', 0, '?'),
 ('fUn=@', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/ruler-compasses.svg', 0, ':\0fA&sP0', ':\0fA&sP0', ';@U8^ŀf/?G`1YKy', '', 0, '?'),
 ('Dz iC(=', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/safe.svg', 0, '%gލz݁Mq̻H', '%gލz݁Mq̻H', 'q}_B	QݰP35gФ', '', 0, '?'),
 ('dchŢP9a', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/sale-sign.svg', 0, '49h	[+', '49h	[+', '&x>}[ͣqJ', '', 0, '?'),
 ('VF*G', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/satellite-dish.svg', 0, 'mOgF.-Z~', 'mOgF.-Z~', 'VצThiKf+\\}6E^yݞ2\Z', '', 0, '?'),
 ('&i\Z(d1', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/scales.svg', 0, 'u妪d_Ei-j>', 'u妪d_Ei-j>', 'p\Z+CDZĕ,Rz\'', '', 0, '?'),
 ('/<J 	ۉY', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/scissors.svg', 0, 'QݫmJtQ{z~ܴ', 'QݫmJtQ{z~ܴ', 'Ť1d}Ågsvϣz,', '', 0, '?'),
 ('c\0P]u;VVj', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/security.svg', 0, '÷MER~}', '÷MER~}', '3BX@S;2c\0#', '', 0, '?'),
 ('dP2g?Zp:', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/send.svg', 0, 'iOK!k', 'iOK!k', '2;WxG=TW<Wj', '', 0, '?'),
 ('5;zHۅ,IPa', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/shield.svg', 0, 'Ca|lH', 'Ca|lH', '<~ED^qFT\\&є', '', 0, '?'),
 ('~A}Cy~,sJ4t', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/shopping-cart.svg', 0, '\"5K$zoZPyF', '\"5K$zoZPyF', 'Toy\\*|L!DTMn', '', 0, '?'),
 ('\\6%\rA', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/sign.svg', 0, 'UEB5', 'UEB5', 'GKNZ`m#>', '', 0, '?'),
 ('wY\0TCg\r', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-chart.svg', 0, 'Wr#/>7\Z', 'Wr#/>7\Z', 'wEM0pLKH׳_\"', '', 0, '?'),
 ('/Q>+ޝ,m-/', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-exclamation.svg', 0, '`o\rSC)0K', '`o\rSC)0K', 'r2eħ5(9C>[6.W{o', '', 0, '?'),
 ('[l/U.OݏE|=m', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-gears.svg', 0, '㆏oUд<C', '㆏oUд<C', 'z4>nH\r!5笺q.X', '', 0, '?'),
 ('E1\'\'Kŀ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-growth.svg', 0, 'ę\Z9TO', 'ę\Z9TO', 'Gs*\"{UȂan*Cc', '', 0, '?'),
 ('=NK(l#Ƽce8', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-money.svg', 0, '[Vt3\rn~C', '[Vt3\rn~C', 'ݜpw ^=|Uxૼy.N', '', 0, '?'),
 ('T1(\"_', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-user.svg', 0, '߻iҩ\Z', '߻iҩ\Z', '[kdb	SFb;	\"9ΞSy&Q,', '', 0, '?'),
 ('!U_\\m~>', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone.svg', 0, '%X7EZ%>', '%X7EZ%>', 'Ծ^`Uipm\ZGyfgQ|H?\"', '', 0, '?'),
 ('k\nlQlS?	\n', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/speaker.svg', 0, '[wP+hn׃R', '[wP+hn׃R', 'FʸִLP5UV񶳖rjOS}`V', '', 0, '?'),
 ('&xYWA[qlV', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/speaker02.svg', 0, '/U\ZgW}3٩\Z', '/U\ZgW}3٩\Z', 'AZT`q,0c*b1{hs?', '', 0, '?'),
 ('qt簽)\rPq]$', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/speech-bubble.svg', 0, '${1P}U', '${1P}U', 'ecT&m>\\Dԡk$', '', 0, '?'),
 ('on)j6X!yU(', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/stamp.svg', 0, '\'in\n4hT', '\'in\n4hT', '@mqKC^ҫk4KZﶦ߸6X', '', 0, '?'),
 ('V\\ͯHPvK̒', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/star.svg', 0, '` 9\\)jk', '` 9\\)jk', 'd	\nf?\\B!Dt9ƺ6', '', 0, '?'),
 ('Lao$7', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/steering-wheel.svg', 0, '%7\0/A', '%7\0/A', 'W-O<$~W', '', 0, '?'),
 ('$NJfaIwC', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/strategy03.svg', 0, 'W?C޼ln', 'W?C޼ln', ')t9LY\n,A\rE؄@r\"YO3', '', 0, '?'),
 ('J\rOLY>', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/strategy1.svg', 0, 'B\Zhyj(|ԕ', 'B\Zhyj(|ԕ', 'G2#oh.SE%\"VRϵ\\Uƫ4', '', 0, '?'),
 (']\"M<-q|', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/strategy2.svg', 0, 'PD>b;<0YGPEK', 'PD>b;<0YGPEK', '\nP>,{Φ ;%\n', '', 0, '?'),
 ('#Vnt=G\r&', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/support-person.svg', 0, '}31g\\	', '}31g\\	', 'V7~($y]p졧_n5', '', 0, '?'),
 ('\rM])	5%', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-article.svg', 0, 'rk\\aK', 'rk\\aK', '	=#ľFBbf0SzcguU', '', 0, '?'),
 ('jۆ0]', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart.svg', 0, 'd>B\Z&ܦ', 'd>B\Z&ܦ', 'A\'L+\Z\0W@ j', '', 0, '?'),
 ('Ŵ\Zd|+', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart2.svg', 0, 'x)r*\rI0.0g', 'x)r*\rI0.0g', 'c>+\\L͑60\nN䅷f(|\'z', '', 0, '?'),
 ('!iB\\省<', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart3.svg', 0, 'lCy/yyQ', 'lCy/yyQ', 'RDՌgd8VO$_k', '', 0, '?'),
 ('Im(<p3R', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart.svg', 0, 'СͶU&\r-', 'СͶU&\r-', 'Kbe^:x	ngDڽ$', '', 0, '?'),
 ('9O>̲', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart2.svg', 0, 'f\r?g{3', 'f\r?g{3', '_aiB͛PTNzmIi#(nA\n', '', 0, '?'),
 ('mR;4', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet.svg', 0, 'G7ro9>', 'G7ro9>', 'H0\'܁l9L-RګFNPk!', '', 0, '?'),
 ('LL!\0\0868U', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/target.svg', 0, 'Q*@2/U', 'Q*@2/U', '܌cُ<.K%=@>@7I1 Ad', '', 0, '?'),
 ('|}Du=/dN', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/team.svg', 0, 'RԼ8;B0;Y', 'RԼ8;B0;Y', 'Xx`WsVi*xzRnQB<L', '', 0, '?'),
 ('\rG#=x)*m', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/telescope.svg', 0, '\'+j,Uˡw', '\'+j,Uˡw', 'YSiM%C煳4Z`,', '', 0, '?'),
 ('z5<v8DڲK6', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tie.svg', 0, '^fɢMkq>+', '^fɢMkq>+', 'wd-HOވO`ѕ)\\h', '', 0, '?'),
 ('CN=A_', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tools.svg', 0, '~_zԸ', '~_zԸ', '%ss-\Z;ՂX,&/_!', '', 0, '?'),
 (',LۥK.\"', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tools2.svg', 0, 'юSP', 'юSP', ')țY<d.7]\n\\Mx', '', 0, '?'),
 (' ;flR(', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/trash-bin.svg', 0, '7#JzeVfT', '7#JzeVfT', 'kixo2ף+m͢', '', 0, '?'),
 ('g$.HqUP', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/umbrella.svg', 0, '$|9ۏ1Mk', '$|9ۏ1Mk', 'p	`yt\r)d7V\ncGg&', '', 0, '?'),
 ('IC7t15Jʻ/˰', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user01.svg', 0, 'f6a*@%Oy', 'f6a*@%Oy', '48\\9Dx}SxA\ZSx', '', 0, '?'),
 ('~Eu&6<eWVoV', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user02.svg', 0, 'v^ap2\\', 'v^ap2\\', 'A^y)Xx/?pocJ', '', 0, '?'),
 ('7rO;*^', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user03.svg', 0, 'OfW>%0', 'OfW>%0', 'x{M|R+@-I5a\0y', '', 0, '?'),
 ('nVj||n;\\', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user04.svg', 0, '%n0mtF', '%n0mtF', '؊,O!Zf+Q6WJ)FXPv', '', 0, '?'),
 ('ޝC\0s\n', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user05.svg', 0, '2+(Ýۄl', '2+(Ýۄl', 'Lo\\6/ALN5$=1', '', 0, '?'),
 ('6H\n<Xf{', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user06.svg', 0, '{_lt6', '{_lt6', 'SVp_^i\"PS˹.4h)s', '', 0, '?'),
 ('tF.qD8\"!', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user07.svg', 0, '\0e{V^', '\0e{V^', 'Kzgo\\#Y6egINا', '', 0, '?'),
 ('wcU(6(GS=', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user08.svg', 0, '@`W1x;Ùxs', '@`W1x;Ùxs', '_[f|>m>S\n\0JЍ', '', 0, '?'),
 ('\nݒA}jk$', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user09.svg', 0, '(m_򾍝940', '(m_򾍝940', '\\QV/EiVh}?X)xǹF9i', '', 0, '?'),
 ('mPhW/o@Ϛ', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/users.svg', 0, '{Lt,a\\ܴ', '{Lt,a\\ܴ', '8`?`N]軲ZjԦ', '', 0, '?'),
 ('!+;qiv\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/venn-diagram.svg', 0, 'sX?|z\'%U', 'sX?|z\'%U', '\\ZJ\"1V\0&~N\\', '', 0, '?'),
 ('@ojX\\B', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/wallet.svg', 0, '3ڑiT.ҫv', '3ڑiT.ҫv', ']h8HA!=C*L', '', 0, '?'),
 ('3mųYI', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/wrench.svg', 0, 'hs4>>cx;', 'hs4>>cx;', 'Qoo{tbZk+\0', '', 0, '?'),
 ('[^~*5`', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/yen.svg', 0, 'fr^TD&_', 'fr^TD&_', 'M3h|J]}@f= 7=', '', 0, '?'),
 ('l,pBկLz', 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/yinyang.svg', 0, '[D)˯]4W\\', '[D)˯]4W\\', 'Ʊ!QY}fS[i^&lo\'', '', 0, '?'),
 ('z2T#]nS', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_business_24px.svg', 0, '!lIWH<Y', '!lIWH<Y', 'n@q=ТA]VJRՖҷM%yA', '', 0, '?'),
 ('qYWCrin', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_24px.svg', 0, '8WFKE?mTDv', '8WFKE?mTDv', 'T1x.~cEbԏGAv', '', 0, '?'),
 ('޵tZJ$', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_end_24px.svg', 0, 'ɯ~	Zv<a', 'ɯ~	Zv<a', 'Er<^_/EF6:ZdCҢ\rĦrFIw', '', 0, '?'),
 ('=Vm\'/l', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_made_24px.svg', 0, '*KY f%U@', '*KY f%U@', '\Z&֌,C\rc	<Y߃xZ	', '', 0, '?'),
 ('&vs8H\rL', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_merge_24px.svg', 0, '޲:4)!*t', '޲:4)!*t', 'kƕ[/kB|>\\`rt=VE=', '', 0, '?'),
 ('pk=5wOuz+', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_missed_24px.svg', 0, 'ƴ6ܛLA@J', 'ƴ6ܛLA@J', '\Z{ڕX gm|ձ\';\0', '', 0, '?'),
 ('g_m', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_missed_outgoing_24px.svg', 0, '\r<xR⠄R|&h', '\r<xR⠄R|&h', 'HbI s=VApxx.J', '', 0, '?'),
 ('\n8,]!ˉN', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_received_24px.svg', 0, '!(d 8!]_P', '!(d 8!]_P', 'm:ө:p当ēLIex19]', '', 0, '?'),
 ('3f{d@m', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_split_24px.svg', 0, 'a4XlL\\', 'a4XlL\\', '\rF5gm!s{Uq?+', '', 0, '?'),
 ('1v/.YVU`', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_chat_24px.svg', 0, '\'D]qaNJ', '\'D]qaNJ', 'POqE~\'S*y:M', '', 0, '?'),
 ('4^N-8j', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_chat_bubble_24px.svg', 0, 'ju\'T:', 'ju\'T:', 'y(+ܳ20A\\(4\'yt1', '', 0, '?'),
 ('ݺ9Hɍ%@YF', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_chat_bubble_outline_24px.svg', 0, 'ⓒÀު', 'ⓒÀު', 'Pa	gO ;Fsv\069ޟg$m2 ', '', 0, '?'),
 ('hV1xb]', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_clear_all_24px.svg', 0, 'n4H2u{[', 'n4H2u{[', '	07S_L0<W', '', 0, '?'),
 ('h kE~\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_comment_24px.svg', 0, 'VaQ^$IGʭ', 'VaQ^$IGʭ', 'g;\ZSސuD/=zO|G', '', 0, '?'),
 ('\\LەÔ\r!7', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_contact_mail_24px.svg', 0, 's[qC㒓', 's[qC㒓', 'i񘉁c*Oj+H\'aHpdDՊ', '', 0, '?'),
 ('_`]Bɽ+', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_contact_phone_24px.svg', 0, ' ŽR\ZR', ' ŽR\ZR', '9Qp`d]hHJ˘', '', 0, '?'),
 ('#R|q j/', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_contacts_24px.svg', 0, ']%cX]\':!I', ']%cX]\':!I', 'B3ӗU&GJ|%yKZ̲Ote', '', 0, '?'),
 ('nŲ(x,=`LUW', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_dialer_sip_24px.svg', 0, '%t߸ѓQ,', '%t߸ѓQ,', '|+&]Ͷp\'F޶tMr(>te', '', 0, '?'),
 ('ˍN.A6B|', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_dialpad_24px.svg', 0, '	H]', '	H]', 'g\ZHM9)dXK}x', '', 0, '?'),
 ('W7\\c!\\', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_email_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('Wp[<Kׄ', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_forum_24px.svg', 0, '#5\\#N', '#5\\#N', 'HFS:9zӣ^]\n', '', 0, '?'),
 ('vGQ6T\n', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_import_contacts_24px.svg', 0, 'Y-Ah3\r', 'Y-Ah3\r', 'וa]֮<\0>?~_L', '', 0, '?'),
 ('CM%K.IW;(=', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_import_export_24px.svg', 0, '|Ӣ\rezd|5', '|Ӣ\rezd|5', '5EaIj\n^_V$%cu-X˥', '', 0, '?'),
 ('%joz|%*{\'', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_invert_colors_off_24px.svg', 0, '*}V_', '*}V_', 'mDK+f=&}w', '', 0, '?'),
 ('oX2.j\ZGtR', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_live_help_24px.svg', 0, 'c/j e*cY', 'c/j e*cY', 'ӊp+b<.	˴//H', '', 0, '?'),
 ('XlR3&mi', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_location_off_24px.svg', 0, 'iۡGBF.%\n%', 'iۡGBF.%\n%', 'm}5<<x(,\n\'7@<ACpggOX', '', 0, '?'),
 ('R:S̝', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_location_on_24px.svg', 0, 'I}Ԛ^޵Q\Zw', 'I}Ԛ^޵Q\Zw', '\\]:0cA7kT`	(\0', '', 0, '?'),
 ('Y/X0@', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_mail_outline_24px.svg', 0, 'iρk>.֦j', 'iρk>.֦j', 'Z?0!:Y{aK$:.|:֛_A', '', 0, '?'),
 ('<k\nrWB', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_message_24px.svg', 0, '.[m3%f', '.[m3%f', '/fU58~ꢗLs^', '', 0, '?'),
 ('jT|\"6y', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_no_sim_24px.svg', 0, 'r\ni#څU', 'r\ni#څU', '\\N	VXDkYc<U ', '', 0, '?'),
 ('ӋԚ(j~T]', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phone_24px.svg', 0, '8WFKE?mTDv', '8WFKE?mTDv', 'T1x.~cEbԏGAv', '', 0, '?'),
 ('Β\'fo>2pyC3\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_erase_24px.svg', 0, 'uF\0YQWt', 'uF\0YQWt', '9آ(cRظ<`~Vew', '', 0, '?'),
 ('_(ļΝp', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_lock_24px.svg', 0, 'ieVgX0cњ*a', 'ieVgX0cњ*a', 'kZ%&!2;iXD', '', 0, '?'),
 ('>$$gi^', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_ring_24px.svg', 0, '$+[50D', '$+[50D', '\r~	φefΠ̧dL$', '', 0, '?'),
 ('jƖ3JܪlI', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_setup_24px.svg', 0, 'e5ܸܷU|E1', 'e5ܸܷU|E1', '^Zu-:\"]#XES!MF	\\', '', 0, '?'),
 ('؋)T[	r', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_portable_wifi_off_24px.svg', 0, 'OvnZy', 'OvnZy', '\"	oA|w	gwwY\'+', '', 0, '?'),
 ('S-O:R$h', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_present_to_all_24px.svg', 0, 'K@7\0YkH', 'K@7\0YkH', '~ūbO zK,*-\0Y!S,', '', 0, '?'),
 ('\n\",֢뒒', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_ring_volume_24px.svg', 0, '5q*ap~#[', '5q*ap~#[', '=<^\"Fݸ@ϳ:yO8on', '', 0, '?'),
 ('	%%|&0d?', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_screen_share_24px.svg', 0, 'hA6.C7', 'hA6.C7', '1[6w;$eF=b', '', 0, '?'),
 ('<>$c', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_speaker_phone_24px.svg', 0, 'FcƹS.\n&!/I', 'FcƹS.\n&!/I', 'Їq2&;^\0xf~?', '', 0, '?'),
 ('5n!Y|', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_current_landscape_24px.svg', 0, 'ߎX]r3}[k', 'ߎX]r3}[k', 'fX\n\'$UaBp\rSf\rR', '', 0, '?'),
 ('=	A@\'[^:/', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_current_portrait_24px.svg', 0, '0SܼB_6?!zE', '0SܼB_6?!zE', '3ajb\07H+&6;(F7ލ$', '', 0, '?'),
 (' Ƶq264', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_primary_landscape_24px.svg', 0, 'ߎX]r3}[k', 'ߎX]r3}[k', 'fX\n\'$UaBp\rSf\rR', '', 0, '?'),
 ('>\\Ja', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_primary_portrait_24px.svg', 0, '0SܼB_6?!zE', '0SܼB_6?!zE', '3ajb\07H+&6;(F7ލ$', '', 0, '?'),
 ('KGNeM*rW', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stop_screen_share_24px.svg', 0, '$<tU<', '$<tU<', 'K	cwbXE~o lM7f&', '', 0, '?'),
 ('VӒG8.m', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_swap_calls_24px.svg', 0, 'k\r&Jg', 'k\r&Jg', '?TR4kPEeMl[Ay', '', 0, '?'),
 ('=[aiU|y¶', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_textsms_24px.svg', 0, 'R5!6/!+', 'R5!6/!+', '\\s\nm;{s(\nC(E8\'+\n', '', 0, '?'),
 (',c*Q5շ', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_voicemail_24px.svg', 0, '7PY7<3H', '7PY7<3H', 'WsǅBD+I#', '', 0, '?'),
 ('Q7m6Q\nW', 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_vpn_key_24px.svg', 0, 'O&6Pjne', 'O&6Pjne', '\'d\0;\'ߊ i', '', 0, '?'),
 ('r.\nl _\"\rW', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_24px.svg', 0, '\"TXE<wU}vk', '\"TXE<wU}vk', 'mk:O{:W֠cM<', '', 0, '?'),
 ('8T)P#2/^', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_box_24px.svg', 0, '5ّT8G\r{', '5ّT8G\r{', 'Weg	}44!Eaz!/Av;<o}', '', 0, '?'),
 ('SaG.$`', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_circle_24px.svg', 0, 'K`|!u-\Zy', 'K`|!u-\Zy', '̊gPjΡhRtSy4Ρ@.nx', '', 0, '?'),
 (' +*@\n\'', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_circle_outline_24px.svg', 0, '0KC#8:˩@j', '0KC#8:˩@j', '\np\0aj5_eHDnl', '', 0, '?'),
 ('^y87z_fRŠ', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_archive_24px.svg', 0, '$];-7hp', '$];-7hp', '籚\0TyQXI8\nԊ', '', 0, '?'),
 ('l{o1_80', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_backspace_24px.svg', 0, 'WﾡQ={a', 'WﾡQ={a', '.ťƇâx8bћӪM', '', 0, '?'),
 (')$on1Hf|', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_block_24px.svg', 0, 'wJ2]|\rEa', 'wJ2]|\rEa', '|N\ZYeڟ~+5\'wL;@5-', '', 0, '?'),
 ('[&Sc3Z6D~', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_clear_24px.svg', 0, 'F_\Zd\"', 'F_\Zd\"', 'MrY5tJ$YI ?^', '', 0, '?'),
 ('|^?ԽJ#[$', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_content_copy_24px.svg', 0, '[$V\"!', '[$V\"!', 'f1y\0Py[\"%\ZEsH8D', '', 0, '?'),
 ('YOiZf|-w', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_content_cut_24px.svg', 0, 'j\n]pDe', 'j\n]pDe', 'E	\nSJ1\'h?qD', '', 0, '?'),
 ('\Z%[h==i', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_content_paste_24px.svg', 0, '&$1+a?U', '&$1+a?U', 'kFNEκ߭D|\Z	6#Ɣv', '', 0, '?'),
 ('vV)1TѶ\"JM', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_create_24px.svg', 0, '905Hq^\Z', '905Hq^\Z', 'vu;ׁO<KR`ֽӯ$~', '', 0, '?'),
 ('^xSKvO', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_drafts_24px.svg', 0, 'YoDMډ0Bˈ', 'YoDMډ0Bˈ', '\\Ehf\nR:Q\"~KVBO\n', '', 0, '?'),
 ('ePi7+$\0f', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_filter_list_24px.svg', 0, 'RRM.I', 'RRM.I', 'ǈ$I,0\'YkO', '', 0, '?'),
 ('[`.WPA', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_flag_24px.svg', 0, 'Lh2~ ', 'Lh2~ ', '*]4\0AtJ[.vt[I', '', 0, '?'),
 ('אS\n8Q&Nx:', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_font_download_24px.svg', 0, 'P\"@^?߅\0T', 'P\"@^?߅\0T', '!Mv<?_mf#', '', 0, '?'),
 ('*V\rX\ZK+Wvo', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_forward_24px.svg', 0, '\"f[EPX\0#', '\"f[EPX\0#', '(hрZNk\Z[A!~*c)\0', '', 0, '?'),
 ('ԍkr\\>Sē', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_gesture_24px.svg', 0, '>֠\0HngxD', '>֠\0HngxD', 'YŲ*ĈucGari', '', 0, '?'),
 ('~[Ķi{,,2', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_inbox_24px.svg', 0, 'Y8B,tqWM5X', 'Y8B,tqWM5X', '<98`)\'~R!\r', '', 0, '?'),
 (']51&\n p', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_link_24px.svg', 0, '`t쭇J/', '`t쭇J/', 'm.<Y??n\Z`jxh', '', 0, '?'),
 ('\0Q\rBJ%', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_mail_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('yQy`5WG^', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_markunread_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('I(IyI%%v@1', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_move_to_inbox_24px.svg', 0, '9kZ^]w', '9kZ^]w', 'e+cDjSewlB', '', 0, '?'),
 ('rӼʿB!', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_next_week_24px.svg', 0, 'F>H(eNM', 'F>H(eNM', '-=$̪pnG9H19g&+Kx', '', 0, '?'),
 ('0{K,a+gA', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_redo_24px.svg', 0, 'Sl̠4Dom', 'Sl̠4Dom', 'Bi(E[?3e>;vw}z', '', 0, '?'),
 ('#PCNYT)', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_remove_24px.svg', 0, ']`!r+TqW', ']`!r+TqW', '4>2T\\dww`\ZUH', '', 0, '?'),
 ('y\'L.eHƪ<v', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_remove_circle_24px.svg', 0, '{uWwܘXN', '{uWwܘXN', 'B+wOR.אZ;w:|', '', 0, '?'),
 ('o^4l:K`ܛ18', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_remove_circle_outline_24px.svg', 0, '/P܏%\r~9ez', '/P܏%\r~9ez', '?6I)^FۜQT%aqw,TKK', '', 0, '?'),
 (')7`UƢB', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_reply_24px.svg', 0, 'H4+jʛv*', 'H4+jʛv*', 'k/BU:4!(0.0*<E', '', 0, '?'),
 ('4-\08&Lq', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_reply_all_24px.svg', 0, '	螥s', '	螥s', 'y~/tbLdN5e=sTb', '', 0, '?'),
 ('Xۛ6l', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_report_24px.svg', 0, '{w.p{Es!x', '{w.p{Es!x', 'ic.\\k r;𘳍;QUÈ5', '', 0, '?'),
 ('n\"	i', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_save_24px.svg', 0, '=ktHS', '=ktHS', ',CLJkp\"b(y@c956', '', 0, '?'),
 ('^hF\"_֘nl', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_select_all_24px.svg', 0, '##', '##', '|n萆c*Cmg\0', '', 0, '?'),
 ('0p;=:Np1', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_send_24px.svg', 0, '7Ú', '7Ú', '|($yKA=Aޅ\03.GwO', '', 0, '?'),
 ('K~ͭF+', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_sort_24px.svg', 0, 'dqY8\"	\r', 'dqY8\"	\r', 'lܾl8K2i&f~h^)KYG~', '', 0, '?'),
 ('KVE', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_text_format_24px.svg', 0, 'ghҬ`', 'ghҬ`', ';n;ȌJybĪbh},', '', 0, '?'),
 ('>dQ(\"[9LNr*', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_unarchive_24px.svg', 0, '#{iKuUo', '#{iKuUo', '@QgD*b8[%+ D1`X', '', 0, '?'),
 ('.B~ WԈjV', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_undo_24px.svg', 0, 'CNafVRRYC', 'CNafVRRYC', 'WGvC5lܻ\'TwA3iXSAb=', '', 0, '?'),
 ('|%\'I\Z|<', 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_weekend_24px.svg', 0, '8Tسr	Ո', '8Tسr	Ո', '2d?۾zAZNM=uXR|k{,', '', 0, '?'),
 ('~\\EN؉Āç', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_access_alarm_24px.svg', 0, '\'48;;q8@', '\'48;;q8@', 'U	\"\"غH-	J=p', '', 0, '?'),
 ('tg׽`޳;])', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_access_alarms_24px.svg', 0, ']mֳw(M\rEQ05', ']mֳw(M\rEQ05', 'dȟ[2o6t1,i`4RR5', '', 0, '?'),
 ('Zd+dA', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_access_time_24px.svg', 0, '\n8l}+QG ', '\n8l}+QG ', '~2`[éYR:ٗέ0\0#$s(', '', 0, '?'),
 ('E՗_G<^', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_add_alarm_24px.svg', 0, ']4&?\rR4軉N', ']4&?\rR4軉N', 'ѕ~=+:s	vbO50.\r#\00d', '', 0, '?'),
 (';2]}Ž', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_airplanemode_active_24px.svg', 0, 'Aہ&lo|[E', 'Aہ&lo|[E', 'P\'ooLC~ovPad}~', '', 0, '?'),
 ('@J]ka=', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_airplanemode_inactive_24px.svg', 0, '^\'QW1ڜ', '^\'QW1ڜ', 'fRָm;rν@qhɶ7c', '', 0, '?'),
 ('2e\'$\ZL', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_20_24px.svg', 0, 'mqup:&me', 'mqup:&me', 'RdפpS\Zx)q.]X*Ǌ\nh', '', 0, '?'),
 ('A|ୢ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_30_24px.svg', 0, '\Z9UJ\n', '\Z9UJ\n', 'BQiA KgFa~i$3', '', 0, '?'),
 ('>q$', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_50_24px.svg', 0, 'wf\\8W0@}', 'wf\\8W0@}', 'U4CѯQQ9y;\'Lhc', '', 0, '?'),
 ('XgmTd+(ݻ:', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_60_24px.svg', 0, '\n-uPvt', '\n-uPvt', 'ɲa|#=0p_фIO~\rS\"9', '', 0, '?'),
 ('+A)l', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_80_24px.svg', 0, 'M-j=ѵbg', 'M-j=ѵbg', 'SI#pw8\nOv`\\x', '', 0, '?'),
 ('VDv+', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_90_24px.svg', 0, '+jCx%', '+jCx%', 'D vSw9Ot\\FdkW?؋', '', 0, '?'),
 ('rH\\{_̶5', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_alert_24px.svg', 0, '3.Il\'k-r', '3.Il\'k-r', '.hy\'7\\4+}-r', '', 0, '?'),
 ('[aI^s`/', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_20_24px.svg', 0, 'ܳ]Y1+4$<[\\', 'ܳ]Y1+4$<[\\', '3}<_.^j#fwB_Oj', '', 0, '?'),
 ('2U8f<D]', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_30_24px.svg', 0, '~661D', '~661D', 'ᖀv8Qa(wI+|', '', 0, '?'),
 ('#ybu|4G', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_50_24px.svg', 0, 'WtKb@B', 'WtKb@B', '|afi\'WקUS4', '', 0, '?'),
 ('_}', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_60_24px.svg', 0, '@ȫ?/[', '@ȫ?/[', 'c\0|\n\rřP5,r&-H', '', 0, '?'),
 ('VWeo', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_80_24px.svg', 0, ')Cy^]l_T', ')Cy^]l_T', '%-St\0٭m)z\n	.;+', '', 0, '?'),
 ('	=y\r\ne\0+I', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_90_24px.svg', 0, 'o[Gd!5 ', 'o[Gd!5 ', '*=V9Z\n\ncnl\Z|u5VyQ', '', 0, '?'),
 ('G&&\\|~?', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_full_24px.svg', 0, '=nV~tM', '=nV~tM', '1ΰQTŁ(#>~}WwLq', '', 0, '?'),
 ('\rTs&%n', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_full_24px.svg', 0, '%mh\Z{FI$۝', '%mh\Z{FI$۝', '=mYu\"^D{. d', '', 0, '?'),
 ('Q_*vRJ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_std_24px.svg', 0, '%mh\Z{FI$۝', '%mh\Z{FI$۝', '=mYu\"^D{. d', '', 0, '?'),
 (',&VM.', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_unknown_24px.svg', 0, 'u~/d\Z', 'u~/d\Z', '!	溩p֟ƻfn=Kfn[YMB', '', 0, '?'),
 ('7;5Xd5::E', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_24px.svg', 0, '%x_j', '%x_j', '9VxC$BH.^ұC4R', '', 0, '?'),
 ('F@yZ=', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_connected_24px.svg', 0, 'SAը)/~xaF', 'SAը)/~xaF', 'mvH1\\ȒKZҹ', '', 0, '?'),
 ('5sMq', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_disabled_24px.svg', 0, '3L1y#BF\na', '3L1y#BF\na', 'cX,.1X-\0ߓ?f1r', '', 0, '?'),
 ('ݘ@?ڮDy', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_searching_24px.svg', 0, 'c\r;Ǐ_', 'c\r;Ǐ_', '>TV\nC~8LOɁYvK˶De\'%', '', 0, '?'),
 ('`]R4#w\r\n', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_auto_24px.svg', 0, '0=TP#8@qU', '0=TP#8@qU', 's4n2K4FЇ,#\nPYKڻ', '', 0, '?'),
 ('1Cv:5', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_high_24px.svg', 0, 'zQD	˙s', 'zQD	˙s', '&QKv%N\0uIvY', '', 0, '?'),
 ('9Rbd<Mo@\\d=', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_low_24px.svg', 0, '0|Mܹ', '0|Mܹ', 't=]&d}qz7mnu', '', 0, '?'),
 ('YG2bpr^mH', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_medium_24px.svg', 0, 'TB0yyHL\'Y{', 'TB0yyHL\'Y{', '𕷅ar9.&%\0+>', '', 0, '?'),
 ('}\r\0]9U', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_data_usage_24px.svg', 0, 'KK4Lΰq;', 'KK4Lΰq;', 'B\'8KN¡(4HAw3*?', '', 0, '?'),
 ('\nt\'P.', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_developer_mode_24px.svg', 0, '$g\ZXYy:', '$g\ZXYy:', 'ԟp+\\m>o_ƟiWDhEIztY', '', 0, '?'),
 ('*SI(nO%{GzT', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_devices_24px.svg', 0, 'S4X	~W', 'S4X	~W', 'aAF\\.1\Z]rYS@|5w', '', 0, '?'),
 ('\\\'=S%%bS($', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_dvr_24px.svg', 0, 'Pf_=Fro', 'Pf_=Fro', '\">bMĥ]ڃS&', '', 0, '?'),
 ('.AG%ǙBdU', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_gps_fixed_24px.svg', 0, 'G~)5o!g', 'G~)5o!g', 'W?ړ-JAV۩TS`o{+', '', 0, '?'),
 ('|z( R)fj', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_gps_not_fixed_24px.svg', 0, '>xEyQ/bV', '>xEyQ/bV', 'SBށG;+bp_@=,n[M', '', 0, '?'),
 ('%޹Q\r=', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_gps_off_24px.svg', 0, '%ůuœ\0ǌ', '%ůuœ\0ǌ', 'S1iKѡnKg-t#<:մ-', '', 0, '?'),
 ('dBqo|', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_graphic_eq_24px.svg', 0, '^H}Tǚe	+', '^H}Tǚe	+', '*UY-}9޳\rMC~', '', 0, '?'),
 ('J*g6ʟ~vp@', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_location_disabled_24px.svg', 0, '%ůuœ\0ǌ', '%ůuœ\0ǌ', 'S1iKѡnKg-t#<:մ-', '', 0, '?'),
 ('a?\"}Bh', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_location_searching_24px.svg', 0, '>xEyQ/bV', '>xEyQ/bV', 'SBށG;+bp_@=,n[M', '', 0, '?'),
 ('-YM\'$NW~', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_network_cell_24px.svg', 0, '8;5z	N#7\'+\0', '8;5z	N#7\'+\0', 'K9~B&XXvd}qr[', '', 0, '?'),
 ('\roM:Xk', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_network_wifi_24px.svg', 0, '1C', '1C', 'V+b(8L%m\nI', '', 0, '?'),
 ('6g$ 3Ydv@', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_nfc_24px.svg', 0, '%g:ZBw7VP', '%g:ZBw7VP', '%?$^ uզY\0@kW;.*', '', 0, '?'),
 ('(~?#0ҹ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_lock_landscape_24px.svg', 0, '\"t=Yo', '\"t=Yo', 'ճe!}#[}ƒb+fՍ<', '', 0, '?'),
 ('i[^sT<ź{7', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_lock_portrait_24px.svg', 0, ',$qeO`.DP', ',$qeO`.DP', 'fٟMҖ*M\Z!,bq3k\nN', '', 0, '?'),
 ('fc~spѹ߁3', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_lock_rotation_24px.svg', 0, ',U,bWTY<~', ',U,bWTY<~', 'M1h|/zCn*:a@=|', '', 0, '?'),
 ('ݜ^qE~}(', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_rotation_24px.svg', 0, ':=6F0q', ':=6F0q', 'yr!w\0}@xɳp=9G049', '', 0, '?'),
 (',\\ާp҉^v', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_sd_storage_24px.svg', 0, '$NoIgB', '$NoIgB', 'gl 7IՁA=', '', 0, '?'),
 ('n̑4[j|', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_settings_system_daydream_24px.svg', 0, '83y!-R', '83y!-R', '-)GR/̓ZDC+s^+Z', '', 0, '?'),
 ('bWǠU>X\r.e	', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_0_bar_24px.svg', 0, 'ߨTM-Ht!Sl4', 'ߨTM-Ht!Sl4', 'Mv%w4uFxA[#>x$', '', 0, '?'),
 ('XxI]Ͽ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_1_bar_24px.svg', 0, 'h,mVOU', 'h,mVOU', 'byu\Z\'/Um3|ƎUd	\Z', '', 0, '?'),
 ('ڗʧfV', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_2_bar_24px.svg', 0, 'i4wP	9\r/', 'i4wP	9\r/', '^w#a/\'= Y-KGwڙ', '', 0, '?'),
 ('	*\"A\"', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_3_bar_24px.svg', 0, '8;5z	N#7\'+\0', '8;5z	N#7\'+\0', 'K9~B&XXvd}qr[', '', 0, '?'),
 ('/l%pf`\n', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_4_bar_24px.svg', 0, 'Ef=qzr\\', 'Ef=qzr\\', 'X%й0Yhj}1R', '', 0, '?'),
 ('E[@N\\8}+', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_0_bar_24px.svg', 0, '>+~PԆ){8*', '>+~PԆ){8*', '+pFLÚ`nnWOwA\',', '', 0, '?'),
 ('jHGw,ƙ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_1_bar_24px.svg', 0, '.6%=', '.6%=', '0+1XҍI}bP@\\B', '', 0, '?'),
 ('N_	L\'8YZ2', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_2_bar_24px.svg', 0, '}ߔ`њh', '}ߔ`њh', '׏GD3W*pG#Z~_0Z', '', 0, '?'),
 ('JLpdq', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_3_bar_24px.svg', 0, 'G#I֑/E', 'G#I֑/E', 'S!Wni}COB\\Ѓ[T', '', 0, '?'),
 ('fkUCM\0w?&', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_4_bar_24px.svg', 0, 'U\0{\r>Uy', 'U\0{\r>Uy', 'Vto\n)V/4^*4G}_5A', '', 0, '?'),
 ('t9t_mF', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_no_sim_24px.svg', 0, 'r\ni#څU', 'r\ni#څU', '\\N	VXDkYc<U ', '', 0, '?'),
 ('8IH܂\"ڜ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_null_24px.svg', 0, 'o7K_¼', 'o7K_¼', '4mj{|>|MjZZ%}~', '', 0, '?'),
 ('_:Q\ZoC}EH', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_off_24px.svg', 0, '0(=*M', '0(=*M', ';64bAoo8anri[h', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('m[s*W,XÐ:', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_0_bar_24px.svg', 0, '\nRȮid\Zf', '\nRȮid\Zf', 'fnjvmuϛ\"Bץ▁9|7', '', 0, '?'),
 ('!mL\\Fb', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_24px.svg', 0, 'vJ쫻6BHr|', 'vJ쫻6BHr|', 'ǜkFK}sizmWf;~c', '', 0, '?'),
 ('kյ0Qo', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_lock_24px.svg', 0, 'sM7/$', 'sM7/$', '[tїtwch3', '', 0, '?'),
 ('FY4\0M\"B#&', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_24px.svg', 0, '8p_|\'Fwn2G', '8p_|\'Fwn2G', 'OS4Beph5G0', '', 0, '?'),
 ('%Qp\ni̮#&', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_lock_24px.svg', 0, 'X_Kat%[=_Z', 'X_Kat%[=_Z', 'Sk-q6пRe+nI&', '', 0, '?'),
 ('J#j2\r|T', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_24px.svg', 0, '1C', '1C', 'V+b(8L%m\nI', '', 0, '?'),
 ('+Y\\^', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_lock_24px.svg', 0, '7fu3beG', '7fu3beG', 'pDПrc,zj?jOZN', '', 0, '?'),
 ('~LZ#ڞ8ne', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_24px.svg', 0, 'K:g2?Bi$V', 'K:g2?Bi$V', '-$16#|M[\rR$Fw!', '', 0, '?'),
 ('e|6)', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_lock_24px.svg', 0, ']j0^Pӯ-m', ']j0^Pӯ-m', '>qwFb6 Z|GoQ{+Lo', '', 0, '?'),
 ('Ӗe!Lݹ\0N', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_off_24px.svg', 0, '}Nuz}f', '}Nuz}f', '>yE\ZkF~>#/]̧:', '', 0, '?'),
 ('7ֆ3i{d2', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_1_bar_26x24px.svg', 0, ']tNw+', ']tNw+', 'iڮ-gf@7!W~Z̀-', '', 0, '?'),
 ('W>.N//pىǆ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_2_bar_26x24px.svg', 0, 'Hgc$', 'Hgc$', '>3x^r!RH.rwC퀽\r', '', 0, '?'),
 ('`k$i޽j`', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_3_bar_26x24px.svg', 0, '\ZDB', '\ZDB', 'v;b}\0j?I޴igQ\"т`C', '', 0, '?'),
 ('G\'`7)̼\\', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_4_bar_26x24px.svg', 0, 'ZJX̦Z', 'ZJX̦Z', 'G@F,u~xlnHp\09$f\'pU', '', 0, '?'),
 ('T͓\nah>', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_1_26x24px.svg', 0, 'eT}=', 'eT}=', '?RGDߐOe4Sᣱ=[I', '', 0, '?'),
 ('OEk&O', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_26x24px.svg', 0, 'ᴨQX', 'ᴨQX', '8.i-߇L.W掲 aNa', '', 0, '?'),
 ('X#8Lbd', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_2_26x24px.svg', 0, '=#R51', '=#R51', '佶Q賚\rɭP.M\ZH\\ɭ|	V', '', 0, '?'),
 ('社eHp', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_3_26x24px.svg', 0, 'ߍ],+u8', 'ߍ],+u8', ' \'u}.0(\'э^.gE', '', 0, '?'),
 ('urD>1SSX', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_4_26x24px.svg', 0, '4,YnTx', '4,YnTx', '߅z\nc,\"daq!P3hr', '', 0, '?'),
 ('NBaW)	$:Ε', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_not_connected_26x24px.svg', 0, '\\uDG7', '\\uDG7', '98]y\0\"w?u}Ҿau9p', '', 0, '?'),
 ('\\JL~yzb,', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_null_26x24px.svg', 0, 'L	5$RZ(:', 'L	5$RZ(:', 'ʖ~Pa#;Ϧ~ TL', '', 0, '?'),
 ('y2%ÅI>-eJ', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_storage_24px.svg', 0, '	FPb!', '	FPb!', 'n\"_~	E+P@OSp_^*\"', '', 0, '?'),
 ('EMZ;x$>:_~', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_usb_24px.svg', 0, 'SG*m4iS', 'SG*m4iS', 'QeaxH$Hu*\')g\0', '', 0, '?'),
 ('ѠܱUfO)	0', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_wallpaper_24px.svg', 0, 'ǸN<\rI}6', 'ǸN<\rI}6', '#׫Njˇl?[߭:Cls', '', 0, '?'),
 ('tWϾL4]T\'C', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_widgets_24px.svg', 0, 'P̚]|SN', 'P̚]|SN', '0{K^BF!mDq<	B', '', 0, '?'),
 ('Fz#\n)7Z', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_wifi_lock_24px.svg', 0, '闘Mȕїz', '闘Mȕїz', '0 e(pz~\ZKE', '', 0, '?'),
 ('-7OnWvE', 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_wifi_tethering_24px.svg', 0, 'z0No,g+jG', 'z0No,g+jG', '@h9K5<Б =K	j0\"', '', 0, '?'),
 ('~ag+', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_attach_file_24px.svg', 0, '`BkΩm.', '`BkΩm.', 'wQwV,?Aέ00hv:y,$4', '', 0, '?'),
 ('!\r\"Z~+	', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_attach_money_24px.svg', 0, '	xJxr\r5', '	xJxr\r5', '֘oX2[?Nd+A=', '', 0, '?'),
 ('wRҾz\'*m3@d', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_all_24px.svg', 0, 'd@ő\nb2', 'd@ő\nb2', 'y	e	Mti[xS.$.3\'pF', '', 0, '?'),
 ('gasܧ4', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_bottom_24px.svg', 0, 'Geɘ[v', 'Geɘ[v', 'wb:D^\'܈', '', 0, '?'),
 ('-纖(\"Cj', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_clear_24px.svg', 0, 'H;{ei:*', 'H;{ei:*', 'ʆc	uݬ$q\"@', '', 0, '?'),
 ('e\0s\n>\"', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_color_24px.svg', 0, '|HXz׋١U', '|HXz׋١U', 'I)}	J|yrˇ]eE\'', '', 0, '?'),
 ('kH[lfz,', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_horizontal_24px.svg', 0, 'G8FG{(	', 'G8FG{(	', '!.Tu#׿m~\0DXϮm^#5A*r', '', 0, '?'),
 ('>s:1`-tv', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_inner_24px.svg', 0, '<cU$oBDg', '<cU$oBDg', 'eSNvŧLov', '', 0, '?'),
 ('#.*o', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_left_24px.svg', 0, 'C²q+|.v', 'C²q+|.v', '\\]h;_sUht:\r05AUgλzh1', '', 0, '?'),
 ('ZT+#E닽\'', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_outer_24px.svg', 0, 'A,0^_,=', 'A,0^_,=', '?\ZSb\\cW_Bf9le̍|@', '', 0, '?'),
 ('zz (rӍy', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_right_24px.svg', 0, 'MXTF}]', 'MXTF}]', 'uBIEg0r>FBxj', '', 0, '?'),
 ('1E:Le', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_style_24px.svg', 0, '4nġ]\\hm\0', '4nġ]\\hm\0', 'Ǹ`KoC9_kx8c.', '', 0, '?'),
 ('rڌ$j:', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_top_24px.svg', 0, '-\'͚q%C[7', '-\'͚q%C[7', 'm]P0+jHPN9yk˛>O4n', '', 0, '?'),
 ('&hEuX', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_vertical_24px.svg', 0, 'Dc\\s!V\\j0f', 'Dc\\s!V\\j0f', '2et.\'9rᬲK,-(񬡡t', '', 0, '?'),
 ('<ћb\Z՛ĳ\0C', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_drag_handle_24px.svg', 0, '8/JU~.[s', '8/JU~.[s', 'D:Ul0M翿ފo', '', 0, '?'),
 ('Ŕ&\"U', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_center_24px.svg', 0, '݄!]qXrq', '݄!]qXrq', '5B$\rkPxG3\"LrٳI\naK', '', 0, '?'),
 ('{)aq,8Nq|nTm', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_justify_24px.svg', 0, '-ި>I^', '-ި>I^', 'atvO	kH', '', 0, '?'),
 ('Y9/Y~', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_left_24px.svg', 0, 'v%_skV', 'v%_skV', 'O>3YJ/P@Vy]]~.$', '', 0, '?'),
 ('扽v;tC', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_right_24px.svg', 0, 'q;.y}r>', 'q;.y}r>', '3&\r.LFHu\"̚*a9p', '', 0, '?'),
 (':6L4Lm', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_bold_24px.svg', 0, '|ǟXNb>', '|ǟXNb>', 'xlwm̛9zmW8', '', 0, '?'),
 ('}!~{s_Y^y0', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_clear_24px.svg', 0, '[|A.-ޮb', '[|A.-ޮb', 'Md;]<&#RK|=;-ٖhcn\\\"', '', 0, '?'),
 ('aL\\#љ', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_color_fill_24px.svg', 0, 'WUXU', 'WUXU', '\0 |	E6\\EToRSR', '', 0, '?'),
 ('݂{mU.`dY', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_color_reset_24px.svg', 0, '݌OXW*X', '݌OXW*X', 'm2\'9җ\\,\nN1', '', 0, '?'),
 ('clAlC]Xh', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_color_text_24px.svg', 0, 'S0BIVI', 'S0BIVI', '[QiZD@F;֣lPK ', '', 0, '?'),
 ('RMw}9Gv', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_indent_decrease_24px.svg', 0, '#+9Dbݞ֍ZѢ', '#+9Dbݞ֍ZѢ', ']kO-zd\"T(ُ\n!^\"\"jqZ', '', 0, '?'),
 ('`5', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_indent_increase_24px.svg', 0, 'EO&t\'p1', 'EO&t\'p1', '3y2Zb:I04 \\#9ͭB:', '', 0, '?'),
 ('ˈ-X$%', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_italic_24px.svg', 0, 'ΐKakܶ', 'ΐKakܶ', 'ص)]d$(g[[Uv', '', 0, '?'),
 ('~EDynY3r', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_line_spacing_24px.svg', 0, 'sG{\ZGż:', 'sG{\ZGż:', '.s7y{w˔Uw', '', 0, '?'),
 ('\nAQ|t`', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_list_bulleted_24px.svg', 0, 'ٷ=/ּƣC჋', 'ٷ=/ּƣC჋', '#ޤchMn:Uw\0&N!', '', 0, '?'),
 ('	>ݫXAdQ', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_list_numbered_24px.svg', 0, 'bQw:ĀTX׸7', 'bQw:ĀTX׸7', '\\M\n\nxN&@}7', '', 0, '?'),
 ('F.ѝ}:', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_paint_24px.svg', 0, 'xjG[b', 'xjG[b', '|omwK:\n2', '', 0, '?'),
 ('zU%&0-_y', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_quote_24px.svg', 0, 'QE/XNf', 'QE/XNf', 'k\\oXc]?\\ث,c[Xw_7', '', 0, '?'),
 ('ɩ%<8_%', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_shapes_24px.svg', 0, '8F9D}', '8F9D}', '[	/]Oϼrn]E~s', '', 0, '?'),
 ('?j50}΋h\0M', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_size_24px.svg', 0, 'x/Z-FB4', 'x/Z-FB4', '\ny?ܾ%a,49Ĳy\'d;F/', '', 0, '?'),
 ('}.`Et_{>', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_strikethrough_24px.svg', 0, '[#,\'/', '[#,\'/', '!3D5P8= \nz:AvVʄ1', '', 0, '?'),
 ('3)u3', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_textdirection_l_to_r_24px.svg', 0, '%qɀ\Zt', '%qɀ\Zt', '|$q\"2JfVwP	U', '', 0, '?'),
 ('>4;O.R', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_textdirection_r_to_l_24px.svg', 0, '\\`ɱA[FB', '\\`ɱA[FB', '%єvl\"Y@zЛg', '', 0, '?'),
 ('?Z;zP0Cq', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_underlined_24px.svg', 0, '[A|1H;>', '[A|1H;>', 'J(T	%_3tҐ5#01<', '', 0, '?'),
 ('M(m2yN>U+cB', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_functions_24px.svg', 0, 'Bfx', 'Bfx', 'p^\"x\\.7ɚ,@', '', 0, '?'),
 ('\')+f\Zp', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_highlight_24px.svg', 0, 'ډm7.[>C_', 'ډm7.[>C_', '!Rj/6=KܓNa1', '', 0, '?'),
 ('OeGslŰrfal', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_chart_24px.svg', 0, '*5\":(;7+', '*5\":(;7+', 'aO;L;_)~ԍ?ഥ:', '', 0, '?'),
 ('p\0ywUY', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_comment_24px.svg', 0, 'h/32/ʝm', 'h/32/ʝm', 'EP)xiMZƥy^` }#^1ݽ', '', 0, '?'),
 (';&no΢в', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_drive_file_24px.svg', 0, 'Gx4Cyt', 'Gx4Cyt', 'fC4k#@0b7.jɡg\n', '', 0, '?'),
 ('t\r)g_k,', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_emoticon_24px.svg', 0, 'l!qM+x k-', 'l!qM+x k-', '\0ꧤ^vޕO͍rr0#t', '', 0, '?'),
 ('$MBKMY', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_invitation_24px.svg', 0, ':ɘ', ':ɘ', 'M!LAY(;3B~z2}iYJWU', '', 0, '?'),
 (']{d.EApK{', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_link_24px.svg', 0, '`t쭇J/', '`t쭇J/', 'm.<Y??n\Z`jxh', '', 0, '?'),
 ('ӁCծ+9Qܗ', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_photo_24px.svg', 0, 'vːͦF18?', 'vːͦF18?', 'ɧbN=,g8r	(MXjOA`s', '', 0, '?'),
 ('/-2\nbu/', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_linear_scale_24px.svg', 0, 'ŒX!P\\:', 'ŒX!P\\:', 'g4@MPckd#*GiVj~', '', 0, '?'),
 ('r`}s', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_merge_type_24px.svg', 0, '޲:4)!*t', '޲:4)!*t', 'kƕ[/kB|>\\`rt=VE=', '', 0, '?'),
 ('p >ܗ,6M', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_mode_comment_24px.svg', 0, '\Z $V2_', '\Z $V2_', 'pکbܚ9Yp@GkERqeЀͧ', '', 0, '?'),
 (';\n)QB-x', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_mode_edit_24px.svg', 0, '905Hq^\Z', '905Hq^\Z', 'vu;ׁO<KR`ֽӯ$~', '', 0, '?'),
 ('Bz29l*i1$', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_money_off_24px.svg', 0, 'b+&VR', 'b+&VR', ']B[Vy3y *-Ķu6', '', 0, '?'),
 ('${\nIHG7b', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_publish_24px.svg', 0, '-_(\nBOqS', '-_(\nBOqS', 'sOB;8$XH4', '', 0, '?'),
 ('0Fj/-M\0rː', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_short_text_24px.svg', 0, 'Sdd n', 'Sdd n', ' IuHQ~/b7dmV\nl', '', 0, '?'),
 ('ӫR>jI1', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_space_bar_24px.svg', 0, 'b?ľ\ro', 'b?ľ\ro', 'K6wX~)isԏ~Q֪/%ڑ', '', 0, '?'),
 ('WWKwp@`܃՞', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_strikethrough_s_24px.svg', 0, 'Kt\n[d}y_', 'Kt\n[d}y_', '^Ju<8*z>a\n**.X', '', 0, '?'),
 (' S	{J2', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_text_fields_24px.svg', 0, '<[m(7#\".', '<[m(7#\".', '+Y200?m*\0D;\'G', '', 0, '?'),
 ('UkG޴', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_vertical_align_bottom_24px.svg', 0, '8ⅼeE&O', '8ⅼeE&O', 'B).nDEl*Yi-S ', '', 0, '?'),
 ('[է!ig', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_vertical_align_center_24px.svg', 0, 'Ɗd`v+{#T$', 'Ɗd`v+{#T$', 'P6p}m	fڳ)|)N0#', '', 0, '?'),
 ('߃NT98u4zj#', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_vertical_align_top_24px.svg', 0, '||PpqYd!', '||PpqYd!', 'r/}w#\n$u)c1aƒr', '', 0, '?'),
 ('ג٠R.G', 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_wrap_text_24px.svg', 0, 'Hph@0sc', 'Hph@0sc', 'TAMop>)ܷF9سq\nc', '', 0, '?'),
 ('#p`C$3ڎ%\05', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_attachment_24px.svg', 0, 's{&\"v羨v', 's{&\"v羨v', '^DK9@O؈kxW', '', 0, '?'),
 ('\Z[*~7', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_24px.svg', 0, '3cV~Lj', '3cV~Lj', '.~ڌ|nxe:TEDOR[', '', 0, '?'),
 ('\rf9@K+\rX', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_circle_24px.svg', 0, 'qf(l>&u7', 'qf(l>&u7', 'Cbdk=tv@<xSgAƁ\n', '', 0, '?'),
 ('T,R{lj', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_done_24px.svg', 0, 'K.\08` ', 'K.\08` ', '2l/Vsa\'ѭ;vykmT', '', 0, '?'),
 ('v\0ϨUMe', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_download_24px.svg', 0, ',|,Z', ',|,Z', '/\nTj)&ZBQ$@wn}&sH\r', '', 0, '?'),
 (';\"#@BIy\0i', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_off_24px.svg', 0, '2&\\Gdء^\"6$', '2&\\Gdء^\"6$', 'xq54OlZ!4\Z6', '', 0, '?'),
 ('-Z3', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_queue_24px.svg', 0, 'ܓǌaK-*ig', 'ܓǌaK-*ig', 'iQZ&6oLCR+w\n\r|3.\rm', '', 0, '?'),
 ('(K~:,<U\0]', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_upload_24px.svg', 0, 'f#/&M4Ֆ', 'f#/&M4Ֆ', 'ͳJŹ2jt6}aWT%SO', '', 0, '?'),
 ('6&`WtXݸqg', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_create_new_folder_24px.svg', 0, 'r; ی', 'r; ی', 'TFs3hmKgH~6gho$P', '', 0, '?'),
 ('y`Ɣ\"Fo', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_file_download_24px.svg', 0, 'T7_tn3,g', 'T7_tn3,g', '7dd=jpha\\(/ήۢ', '', 0, '?'),
 ('F9ECWT-Ǳ>', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_file_upload_24px.svg', 0, 'oS{!+r|', 'oS{!+r|', 'Jh㯋#3mĤcڎ23\"}', '', 0, '?'),
 ('(z>\Zm', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_folder_24px.svg', 0, 'p5l_4U<	>', 'p5l_4U<	>', '$-vģ\0-n\ZcĞߡT\rU', '', 0, '?'),
 ('F\'хI+`A5', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_folder_open_24px.svg', 0, 'v\'\Z5K$r.mU', 'v\'\Z5K$r.mU', '\"`f(mE*PS+I>MHrD', '', 0, '?'),
 ('Y1xj=@3\r', 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_folder_shared_24px.svg', 0, 'BdalS', 'BdalS', '$t2rn7ndf)#\\L&{\\', '', 0, '?'),
 ('M&|ShŨ', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_cast_24px.svg', 0, 'rǙBU&', 'rǙBU&', ']B\\9f!u%7\\2]P\\U|', '', 0, '?'),
 ('\\%V(֐d۷|', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_cast_connected_24px.svg', 0, 'n9SNj(1', 'n9SNj(1', 'sIVJiAiOn_mT', '', 0, '?'),
 ('I7w=ǫiH	', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_computer_24px.svg', 0, '2iݿJކ?R', '2iݿJކ?R', '=EkdB`&[{iPUTx', '', 0, '?'),
 ('iqK(\'1', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_desktop_mac_24px.svg', 0, 'd8V!>(.A', 'd8V!>(.A', 'l]%\'sڌ5;Wn g', '', 0, '?'),
 ('aqt\0U&zE,', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_desktop_windows_24px.svg', 0, '=Z/˟p', '=Z/˟p', '4әWнq{ėHg_b3+U/-_', '', 0, '?'),
 ('M%.\'9n', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_developer_board_24px.svg', 0, 'y8W<w ?', 'y8W<w ?', 'I=HG?\"CH?Es[3_', '', 0, '?'),
 ('ar	t@\'ol', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_device_hub_24px.svg', 0, 'ʩpCA*X', 'ʩpCA*X', 'ɪ(\'Hkt;Lwpʂ?044', '', 0, '?'),
 ('\"PnC.', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_devices_other_24px.svg', 0, 'f? au`{s', 'f? au`{s', '?RlFNN;cF@&', '', 0, '?'),
 ('J`I2|%^_', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_dock_24px.svg', 0, '!_;Wr', '!_;Wr', ';~y>l!;8{g', '', 0, '?'),
 ('56_o', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_gamepad_24px.svg', 0, '	pT=2e\Z$', '	pT=2e\Z$', '[twݫjPeW>Üc4\'Xa	', '', 0, '?'),
 ('&\nXL', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_headset_24px.svg', 0, 'i7$o}|N.', 'i7$o}|N.', 'Q^nufǙ|c\n/w{h', '', 0, '?'),
 ('L/߹t;v{', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_headset_mic_24px.svg', 0, 'fQ\nnμ', 'fQ\nnμ', 'xT\"QnvT3\\\00G qwϚ7', '', 0, '?'),
 ('WgFCx', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_24px.svg', 0, ';pT65,', ';pT65,', '?_@0z89,!\\qe', '', 0, '?'),
 ('\ns.._PP.M', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_down_24px.svg', 0, 'wJ~Is\'%', 'wJ~Is\'%', '4Yio(\rۻZ䙤\"Cex`0s', '', 0, '?'),
 ('9B/2 df', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_left_24px.svg', 0, 'RV*:2Q', 'RV*:2Q', 'L}\'BۿξG&_\\', '', 0, '?'),
 ('ߟzFnJV', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_right_24px.svg', 0, '=\nT\\׍GCA', '=\nT\\׍GCA', '47q\ZQپ\\`jή<XM P', '', 0, '?'),
 ('kv4&Fu,', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_up_24px.svg', 0, '];s', '];s', '%6cL}V6iemWYoWLJSF', '', 0, '?'),
 ('#JjðvY#P_F', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_backspace_24px.svg', 0, '%yE', '%yE', '6l}\r\0i8Mj@:k<A؏\rԒ', '', 0, '?'),
 ('rY܊e}', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_capslock_24px.svg', 0, 'n BcA704x', 'n BcA704x', '#b %ͷ?Q\Z\r-dF̶wU', '', 0, '?'),
 ('x?', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_hide_24px.svg', 0, '2Mo^Yt\\\'N', '2Mo^Yt\\\'N', 'xX_c~G$a惉', '', 0, '?'),
 ('hc;tVj[zt', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_return_24px.svg', 0, 'H/?0\r9*΢\"', 'H/?0\r9*΢\"', 'dh5\0oB+l*]qaGZ', '', 0, '?'),
 (')cRYG.Th:[', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_tab_24px.svg', 0, 'Q37}$nrHN', 'Q37}$nrHN', 'JVd.8;4yL֧}?ףP/', '', 0, '?'),
 ('7_}\Ze', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_voice_24px.svg', 0, 'd1*ұ߾)', 'd1*ұ߾)', 'ק{zYР^\0RqR%<)a', '', 0, '?'),
 ('e|6\nW', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_24px.svg', 0, '\Z\'`A]\"=E', '\Z\'`A]\"=E', 'qo|>Ǆ%ÝvδѿӋ', '', 0, '?'),
 ('cX9ݎkE	c=+', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_chromebook_24px.svg', 0, '܈Ñd&.F', '܈Ñd&.F', 'pʛ;.|KlCG1\"', '', 0, '?'),
 ('94tS\rRŹ', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_mac_24px.svg', 0, '-?Zr', '-?Zr', '<El(p#wWg1X76', '', 0, '?'),
 ('l01xb', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_windows_24px.svg', 0, '*&U^]l,', '*&U^]l,', '05plj|Ң(\Z9L', '', 0, '?'),
 ('EIF,Ŧh', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_memory_24px.svg', 0, '\0]K\rM', '\0]K\rM', '*r<\Z󱃕Ŝ.w!; vI_ow', '', 0, '?'),
 ('hG>Ž6)t o', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_mouse_24px.svg', 0, 'JftΊNI10', 'JftΊNI10', 'Ѭ/\Zd3=$)P	f⫤', '', 0, '?'),
 ('_\'k}ul\'', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phone_android_24px.svg', 0, ',c+', ',c+', '?h5^e;k!ҵYy:U6\'11', '', 0, '?'),
 ('Ko{txF6', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phone_iphone_24px.svg', 0, 'REgx*ޑַ', 'REgx*ޑַ', ')Ĳ7NjttxZ\'D', '', 0, '?'),
 ('o(v?1$n', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phonelink_24px.svg', 0, 'S4X	~W', 'S4X	~W', 'aAF\\.1\Z]rYS@|5w', '', 0, '?'),
 (',zd\Zߡ7\"7R', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phonelink_off_24px.svg', 0, '.j8$_KxѨx', '.j8$_KxѨx', '_\Zo\n|Ѽ\04 vۭеם', '', 0, '?'),
 ('F7z#<', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_power_input_24px.svg', 0, 'D9ߴN?[', 'D9ߴN?[', '{ܺ{/|ݘAJ\"p;}RyIo', '', 0, '?'),
 ('2ywGnd[)q', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_router_24px.svg', 0, 'vS4gB', 'vS4gB', 'ѝvɰ2O7\n1SpU)3G', '', 0, '?'),
 ('De#2R', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_scanner_24px.svg', 0, '0J!DJ', '0J!DJ', '/a{e_G&&kʠ', '', 0, '?'),
 ('	-5JdtU', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_security_24px.svg', 0, 'uRX(\rz;\"/', 'uRX(\rz;\"/', 'ᘐ8N-Ę~W!o\nXW2.,ܓ', '', 0, '?'),
 ('vIK]YLe', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_sim_card_24px.svg', 0, '`OeM.z1b;', '`OeM.z1b;', 'zlwIbDi9/Gke!Y2\\', '', 0, '?'),
 ('Yc⸓,%JeE', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_smartphone_24px.svg', 0, '{F\rAxPN(', '{F\rAxPN(', '꒖S|X.ori\ZN{A^\Z+', '', 0, '?'),
 ('fad+qCKSg', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_speaker_24px.svg', 0, 'jbsA\Z', 'jbsA\Z', 'sleJvu[8׶L~M\\y', '', 0, '?'),
 ('{4.(u07Ƶ', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_speaker_group_24px.svg', 0, '6?eQ', '6?eQ', ' 2)KSo=n', '', 0, '?'),
 ('̓aQM*#zD', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tablet_24px.svg', 0, 'N\\ׯp9@r]{', 'N\\ׯp9@r]{', '2l/m@ًIx^+BF|%2', '', 0, '?'),
 ('$MET~', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tablet_android_24px.svg', 0, '9%kv', '9%kv', 'Jb\rWOZTG5@Kl', '', 0, '?'),
 ('_DsDdC', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tablet_mac_24px.svg', 0, 'w+dm\Z#HUL', 'w+dm\Z#HUL', 'K9?bv?oXjwSZVz\r8', '', 0, '?'),
 (',i<(>u2&', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_toys_24px.svg', 0, ',%I\r\0ô]', ',%I\r\0ô]', 'ft|\nXʸ\\dRWTtkMc', '', 0, '?'),
 ('e\\vtAVA', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tv_24px.svg', 0, 'ֵΆ~G=F5', 'ֵΆ~G=F5', '65At	p˙!S7e߁6C', '', 0, '?'),
 ('tkom<wU+', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_videogame_asset_24px.svg', 0, '?%\0&ǪFs ', '?%\0&ǪFs ', 'rJe/d;.Z8.̈1*LB', '', 0, '?'),
 ('$U\'Hè', 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_watch_24px.svg', 0, '<(!Zyg', '<(!Zyg', '~v4;0swULAkD$z+', '', 0, '?'),
 ('j֨x蘈dJ/1S', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_add_a_photo_24px.svg', 0, 'cY zs{', 'cY zs{', '\0ml_,S?HیWn<\"^', '', 0, '?'),
 ('~=bpz', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_add_to_photos_24px.svg', 0, 'rĚK', 'rĚK', '˛KiF(6yvstUXVĺA', '', 0, '?'),
 ('6)߄hӖc', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_adjust_24px.svg', 0, '*K;WTŨw', '*K;WTŨw', 'Yf1>O7T#=>@3e', '', 0, '?'),
 ('n0m_epٓVp', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_assistant_24px.svg', 0, 'aĬ+ͬc	o}s', 'aĬ+ͬc	o}s', 'B\"Q|_ZDl%@-RDBd', '', 0, '?'),
 (':H,3>w\\C', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_assistant_photo_24px.svg', 0, 'Lh2~ ', 'Lh2~ ', '*]4\0AtJ[.vt[I', '', 0, '?'),
 ('e*nVf3	7w', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_audiotrack_24px.svg', 0, '`84Têޞ-R', '`84Têޞ-R', '8<ekI?[l0`y:ծ', '', 0, '?'),
 ('Frum	E]C', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_circular_24px.svg', 0, 'ķ޾Ew(WD>ͩ', 'ķ޾Ew(WD>ͩ', ':uZ\"ʵ\\0oPx\\#U', '', 0, '?'),
 ('5˅ў+b:i', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_linear_24px.svg', 0, '!Hll](', '!Hll](', '~zfhy3^F42@}rԜ΂', '', 0, '?'),
 ('&cE8_bwݦ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_off_24px.svg', 0, 'v\\$=!v|,&ʒ(', 'v\\$=!v|,&ʒ(', 'F3늈ܔ݆DNq磝Zbth', '', 0, '?'),
 ('ޚW*Hɒ\n:', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_on_24px.svg', 0, 'ƹurd{dfN', 'ƹurd{dfN', 'sgh[km4CqTB', '', 0, '?'),
 ('UD<RIdxp', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_1_24px.svg', 0, 'dB*Mvˤ\"', 'dB*Mvˤ\"', '/jTdxtmg1&$Fb7=', '', 0, '?'),
 ('AQn<ET', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_2_24px.svg', 0, '\ZJǽSa!N3%[', '\ZJǽSa!N3%[', 'tS{@\'U[ڴodHVmC', '', 0, '?'),
 ('؏ Qiw8HJU', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_3_24px.svg', 0, '~()PŒ/;apD', '~()PŒ/;apD', 'q_AJ~M3E;{', '', 0, '?'),
 ('[,{L', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_4_24px.svg', 0, 'EhD~t\Z', 'EhD~t\Z', ',8mYY	+5)y9\0', '', 0, '?'),
 ('\Zcm[H-ޫ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_5_24px.svg', 0, '0|Mܹ', '0|Mܹ', 't=]&d}qz7mnu', '', 0, '?'),
 ('d׸.,Qf', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_6_24px.svg', 0, 'TB0yyHL\'Y{', 'TB0yyHL\'Y{', '𕷅ar9.&%\0+>', '', 0, '?'),
 ('』\"}?TUL', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_7_24px.svg', 0, 'zQD	˙s', 'zQD	˙s', '&QKv%N\0uIvY', '', 0, '?'),
 ('OELvLŸ\Z6V&', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_broken_image_24px.svg', 0, '̺R\00P', '̺R\00P', 'O3Ϊ)j\nmU07Cn', '', 0, '?'),
 ('D o1Ct@I', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brush_24px.svg', 0, 'v `$', 'v `$', 'cΣvi[4&r &&xX!', '', 0, '?'),
 ('w~IvX%', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_24px.svg', 0, '\rdm+>_MNt@T', '\rdm+>_MNt@T', 'X	DC7^=CP', '', 0, '?'),
 ('7>b4PSq2', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_alt_24px.svg', 0, 'Oa6Y%C', 'Oa6Y%C', 'l6ꏀ].rC\r;E', '', 0, '?'),
 ('GQWc䮉I}8(', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_front_24px.svg', 0, 'NL6Wx', 'NL6Wx', '9oxp(~8N=)', '', 0, '?'),
 ('dqm:8w2', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_rear_24px.svg', 0, '|uUAKY', '|uUAKY', ')N8jsٟjzvN=54Csq >', '', 0, '?'),
 (',fυRo3^', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_roll_24px.svg', 0, ';z\r[Y~', ';z\r[Y~', '98\\t3Ŝ*`@6GWl,a', '', 0, '?'),
 ('%ޖlK0<-@', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_center_focus_strong_24px.svg', 0, '5FW~\'', '5FW~\'', 'XR+N|+=,Y\r[\0ukT)', '', 0, '?'),
 ('sZiF|\Z2j', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_center_focus_weak_24px.svg', 0, 'E~}!ow*J', 'E~}!ow*J', '^V!\'emHp?e56', '', 0, '?'),
 ('6r<n?ϓ\no{', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_collections_24px.svg', 0, 'Ǻi\ZKC^\"l', 'Ǻi\ZKC^\"l', 'gcפY:Cz+:', '', 0, '?'),
 ('dMDBkk', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_collections_bookmark_24px.svg', 0, '|ýZI0\Z\'', '|ýZI0\Z\'', 'd%Qj{l`\Z[`7aː\\$', '', 0, '?'),
 ('%x<+', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_color_lens_24px.svg', 0, ' \n֎&\\', ' \n֎&\\', 'KS_zݞV_^+', '', 0, '?'),
 ('Dݣ<-	=', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_colorize_24px.svg', 0, ' JPp;-8!', ' JPp;-8!', '?6IgE`Х.\\}OrC[H\0', '', 0, '?'),
 ('\'<~W@Q놃', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_compare_24px.svg', 0, '55lrgev7#Jɇ', '55lrgev7#Jɇ', 'VC`\\vKbZ1N0̓', '', 0, '?'),
 ('5$K0\'-_b?Ԣy', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_control_point_24px.svg', 0, 'B+=', 'B+=', 'xFcVҪKGX*Dr֊C', '', 0, '?'),
 ('@{srfsP$', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_control_point_duplicate_24px.svg', 0, '(V\'\\X4eZ', '(V\'\\X4eZ', ';^(]~\n5nJ4=F+C', '', 0, '?'),
 ('K`+H47', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_16_9_24px.svg', 0, 'L%=4+R', 'L%=4+R', 'RG4dDI7(MOr57>	LX?S', '', 0, '?'),
 ('y2o$lju8', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_24px.svg', 0, 'zWܹ۠', 'zWܹ۠', '4ڛ`vXM <m>Yd\rfz', '', 0, '?'),
 ('tw=̟\'3_^_', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_3_2_24px.svg', 0, '|pX$Ȭo(N', '|pX$Ȭo(N', 'C~_=<+y_P+Ma3O]i', '', 0, '?'),
 ('%_2\r2k', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_5_4_24px.svg', 0, '<CK|~9m', '<CK|~9m', '٢˻L(*g3aKրCI+', '', 0, '?'),
 ('cnm1bpm', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_7_5_24px.svg', 0, '^T,Js', '^T,Js', '|斪kĀ.G\0c<YmC~', '', 0, '?'),
 ('V:xBwq\ra', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_din_24px.svg', 0, 'pN\n!L\'-Qu9~', 'pN\n!L\'-Qu9~', '縷kABٸJu\\E\nvӳ/2lS', '', 0, '?'),
 (';6ޠn\0\n\"j~', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_free_24px.svg', 0, '=wK\0<X\'', '=wK\0<X\'', 'ӑӂ3dZI,Xa:', '', 0, '?'),
 ('!9\0|~1~#', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_landscape_24px.svg', 0, '<CK|~9m', '<CK|~9m', '٢˻L(*g3aKրCI+', '', 0, '?'),
 ('6HU^&FW', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_original_24px.svg', 0, '\\:\r9CXs<', '\\:\r9CXs<', '|<CHiws=lǕb', '', 0, '?'),
 ('xx (VV', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_portrait_24px.svg', 0, '95T$A/', '95T$A/', 'XAjqr&x`@ųvcLk5', '', 0, '?'),
 ('UVaF\0XX\ZV', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_rotate_24px.svg', 0, 'ey3\"', 'ey3\"', '&48;7K\rzD,BCH', '', 0, '?'),
 ('tZݵ\nV', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_square_24px.svg', 0, '0?ocY', '0?ocY', 'oKSqoؖY,h98[I', '', 0, '?'),
 ('/dewפ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_dehaze_24px.svg', 0, 'x>.\"bN', 'x>.\"bN', 'HG΃at/2Շ<9Zd', '', 0, '?'),
 ('Uvq\"/,', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_details_24px.svg', 0, '^9/&s.-g', '^9/&s.-g', 'ʴ])|g\Z\' ', '', 0, '?'),
 ('A碶~(b\'k7', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_edit_24px.svg', 0, '905Hq^\Z', '905Hq^\Z', 'vu;ׁO<KR`ֽӯ$~', '', 0, '?'),
 ('	tZ`J_\'3l', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_24px.svg', 0, 'XtTGlO', 'XtTGlO', 'j9S(Ls຾jiN', '', 0, '?'),
 ('6)T(', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_neg_1_24px.svg', 0, '{]^6~ab', '{]^6~ab', '|/*s1s45֫eRxJo\\', '', 0, '?'),
 ('rO?]\"W_', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_neg_2_24px.svg', 0, 'Fא[wM2*B', 'Fא[wM2*B', '~of/fN;\\', '', 0, '?'),
 ('{{y혰=ѕzN\'', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_plus_1_24px.svg', 0, 'B\\Rto|s])0', 'B\\Rto|s])0', ' 7kuu51\Zy2NƧ', '', 0, '?'),
 ('-\"u5R', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_plus_2_24px.svg', 0, '\'v:L2_ReyG\Z', '\'v:L2_ReyG\Z', 'R{+i.~Ν.*2~jh8ĺ~s', '', 0, '?'),
 ('4e*п%wK', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_zero_24px.svg', 0, 'b#J[y', 'b#J[y', 'cEA$\ZF{[\"	σH', '', 0, '?'),
 ('HoC\\/[', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_1_24px.svg', 0, '\07>', '\07>', '4BYN4sa-1Ng5ZvbO0M', '', 0, '?'),
 ('jxhypV&!', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_24px.svg', 0, ' m\',)|ɠfz', ' m\',)|ɠfz', '!gX	E1M*PY;,	ZI', '', 0, '?'),
 ('u/LGqZG^', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_2_24px.svg', 0, ';5DT%Ⱥd.', ';5DT%Ⱥd.', '%nG&AxXSKz	*M2j[-M|절', '', 0, '?'),
 ('!Wxm\"~L\\n', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_3_24px.svg', 0, '#P\\<taSEZ', '#P\\<taSEZ', 'lK9ڱeRncl+%1S', '', 0, '?'),
 ('\\5B!Eh', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_4_24px.svg', 0, '~jĽpa*ӭ·', '~jĽpa*ӭ·', '`.3blΖod4AFnJ ', '', 0, '?'),
 ('[tIpp\\`', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_5_24px.svg', 0, 'k\'G\r5ͪ', 'k\'G\r5ͪ', 'nVrEYM10oģurb&', '', 0, '?'),
 ('ˋ	UqݿEr', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_6_24px.svg', 0, '-\09.a9p{', '-\09.a9p{', 'IϑUd9ҳ5\njOv\0', '', 0, '?'),
 ('Q+]*P!|', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_7_24px.svg', 0, 'xB\',}m', 'xB\',}m', '&fTpU;Rԙ=L-鱕', '', 0, '?'),
 ('+o@JCSj', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_8_24px.svg', 0, 'Rx?(', 'Rx?(', '	]iw,\\\r*Djk,', '', 0, '?'),
 ('m|s#P^', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_9_24px.svg', 0, 'fل!q\nu\Z`', 'fل!q\nu\Z`', 'ٻ)\">ڽ(D\r5', '', 0, '?'),
 ('-.cX_S+G', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_9_plus_24px.svg', 0, 'KHYR\0', 'KHYR\0', 'b}le8wr8EЂx ', '', 0, '?'),
 ('TkT8DXd', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_b_and_w_24px.svg', 0, '~pY{a®g%㿷', '~pY{a®g%㿷', 'GcΣ#P	0̶/Wc7G]6=7b', '', 0, '?'),
 ('lj5V\"Ͼh]', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_center_focus_24px.svg', 0, 'qMR{EDR', 'qMR{EDR', 'וL4k:аO+Z&wAMD', '', 0, '?'),
 ('GDw$~s', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_drama_24px.svg', 0, 'x.2-S`ȮN', 'x.2-S`ȮN', 'n*Ƌ	$1}}yP[A-.}=', '', 0, '?'),
 ('R.E>3H', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_frames_24px.svg', 0, '%D[K(qe`/#', '%D[K(qe`/#', '^K]?4~*q^怲br', '', 0, '?'),
 (']syQ-<h', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_hdr_24px.svg', 0, 'Dp\0)[Y', 'Dp\0)[Y', 'E酲.~I/tKޖDXy{E', '', 0, '?'),
 ('!0}g]S', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_none_24px.svg', 0, 'TQON4mޚ', 'TQON4mޚ', ',\\K;nC}T\'|	5RJ', '', 0, '?'),
 ('Qsno5XMݽZ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_tilt_shift_24px.svg', 0, 'C! \\Δĳ', 'C! \\Δĳ', '<	\0VσeȪ2©&ӱ*tk0', '', 0, '?'),
 ('rܟM(#`', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_vintage_24px.svg', 0, 's\'\n~4', 's\'\n~4', 'UuxcZzoBdj:>', '', 0, '?'),
 ('2i\n0m', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flare_24px.svg', 0, 'RBQ\'v', 'RBQ\'v', 'B|(<nȃ*Tc', '', 0, '?'),
 ('	͞x AzGm3', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flash_auto_24px.svg', 0, 'zj<;6', 'zj<;6', 'le@PNӋcfQf&4=K', '', 0, '?'),
 ('i].hNBtR6', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flash_off_24px.svg', 0, 'K8x!y`A', 'K8x!y`A', '&qU\0N/Q\0!I\'BL', '', 0, '?'),
 ('t?_|i3w', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flash_on_24px.svg', 0, 'F`ñ@(', 'F`ñ@(', '\n=HX>擁e-khk	3', '', 0, '?'),
 ('n E<Rdʩ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flip_24px.svg', 0, '_oR94浛', '_oR94浛', 'RXAn1y\ZALWͺ(Y', '', 0, '?'),
 (':h #롕`', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_gradient_24px.svg', 0, '1=4O', '1=4O', '>˖]%<])J#86@yn', '', 0, '?'),
 ('^BU0y rc', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_grain_24px.svg', 0, 'u8aF|֑', 'u8aF|֑', 'ʭy>Vyo8/v<', '', 0, '?'),
 ('AGb[]^', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_grid_off_24px.svg', 0, '22OP2', '22OP2', 'ހ9(WX=VQm	ȅyd\Z6^', '', 0, '?'),
 ('>Ɯ\\Y΢Pm', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_grid_on_24px.svg', 0, 't|n>+TN', 't|n>+TN', '\\KA/?Nc\"3 10>9\0y)[M', '', 0, '?'),
 ('MؾIbznR', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_off_24px.svg', 0, '|:\rh7G̣_', '|:\rh7G̣_', '%}@`=ig7?B`iCr?y', '', 0, '?'),
 ('b<?31\r\\gX1', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_on_24px.svg', 0, 'y-+ e', 'y-+ e', '+#\0S>(*fv', '', 0, '?'),
 ('N[>.`ړ%ǚݖ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_strong_24px.svg', 0, 'wjn>iz&G', 'wjn>iz&G', 'Ҁs<:y{CdK;] ,', '', 0, '?'),
 ('Q)̋pZp*', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_weak_24px.svg', 0, '[bu', '[bu', '&+z4=oX?Nv', '', 0, '?'),
 ('^zDG\"ܚ:', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_healing_24px.svg', 0, 'd]=ӟ۷', 'd]=ӟ۷', 'Q11\0$<˟xCGKUIH', '', 0, '?'),
 ('v*g1,y', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_image_24px.svg', 0, 'vːͦF18?', 'vːͦF18?', 'ɧbN=,g8r	(MXjOA`s', '', 0, '?'),
 ('ط6.-;	ե[g', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_image_aspect_ratio_24px.svg', 0, '{HSڳuf%5cO', '{HSڳuf%5cO', '<[ĭPn8~9 ~MU', '', 0, '?'),
 ('_]o+,K', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_iso_24px.svg', 0, '-ʘȜFox', '-ʘȜFox', 'H\'8W8ciA$bDG(;h', '', 0, '?'),
 ('lr&C=u', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_landscape_24px.svg', 0, 'Dp\0)[Y', 'Dp\0)[Y', 'E酲.~I/tKޖDXy{E', '', 0, '?'),
 ('4tt>\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_leak_add_24px.svg', 0, ']v\r\"\ZS8`~}\n', ']v\r\"\ZS8`~}\n', 'R+gk ܢGU0(\Z', '', 0, '?'),
 ('8w|a', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_leak_remove_24px.svg', 0, '.$Η~[uJ$', '.$Η~[uJ$', 'y1b\Z3*W?DCxqATȡ2D', '', 0, '?'),
 ('v%tx>12', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_lens_24px.svg', 0, '^z9eP', '^z9eP', 'Y~.*&/)᫰\\cdf*', '', 0, '?'),
 ('9x/>L+s\"l', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_linked_camera_24px.svg', 0, ',Qɻ׆FB*u', ',Qɻ׆FB*u', 'X0cs<szg]K>i[', '', 0, '?'),
 ('o?\rKZ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_24px.svg', 0, 'Q⃽Q}tF', 'Q⃽Q}tF', 'p?+RטF\0S0Y`(+', '', 0, '?'),
 ('[}e\'', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_3_24px.svg', 0, '6e` ̝GԳ#/', '6e` ̝GԳ#/', 'R#7JSJQPgW4Ӂ', '', 0, '?'),
 ('Q\"FIܢ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_4_24px.svg', 0, 'a}x:O@', 'a}x:O@', '5>8╃`Mj(ahPjs]t', '', 0, '?'),
 ('vGo&\'\'3N?', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_5_24px.svg', 0, 'ٯϐmdHP', 'ٯϐmdHP', ';k}߫\\vltWFCODsy', '', 0, '?'),
 ('m08~`ryc ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_6_24px.svg', 0, 'aow-/P=:', 'aow-/P=:', 'wGT®|<>/w', '', 0, '?'),
 ('bbNSk', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_one_24px.svg', 0, 'nI4B', 'nI4B', 'y*32{aݨzÛ2J', '', 0, '?'),
 ('pԣ*ra', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_two_24px.svg', 0, 'XyhBµ@*_', 'XyhBµ@*_', 'lJ+Vҹۋ2x«%PH.~+T', '', 0, '?'),
 ('A-W:zt', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_loupe_24px.svg', 0, 't5ā+T#qC', 't5ā+T#qC', 'Awa5Y*IL{8)R-o	k', '', 0, '?'),
 ('\0`p\rtT.b', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_monochrome_photos_24px.svg', 0, 'c΄>', 'c΄>', 'Dáq׷<t-΋/*r', '', 0, '?'),
 ('(?׹(CQ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_movie_creation_24px.svg', 0, '|>ed:U', '|>ed:U', 'Xc\Z3V.M(9rLi', '', 0, '?'),
 ('zxb\\A(Uk:f', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_movie_filter_24px.svg', 0, '.!tTe,P', '.!tTe,P', '疁t0(%DE', '', 0, '?'),
 (')KWotds|&', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_music_note_24px.svg', 0, 'c]=h@', 'c]=h@', 'f/ Dj1ɾ3A8:ZRɸHI', '', 0, '?'),
 ('=\\减M^BO', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_nature_24px.svg', 0, '2_I\\KV|', '2_I\\KV|', 'KwUՌަY4w\0	\rJy', '', 0, '?'),
 ('\Z#\n`ѵ!', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_nature_people_24px.svg', 0, '\\2Cw#', '\\2Cw#', 'YƀY07<2ҩg!W`C|!GW', '', 0, '?'),
 ('!`I3{', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_navigate_before_24px.svg', 0, 'իr)', 'իr)', '^^Ղ{;O՝tHbBBO]U\nv', '', 0, '?'),
 ('C\\X?', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_navigate_next_24px.svg', 0, '/3\\-%C', '/3\\-%C', 'Ɉ>5~D.51ōݿ@8KiRrK\'', '', 0, '?'),
 ('ʬ-}G\0^l', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_palette_24px.svg', 0, ' \n֎&\\', ' \n֎&\\', 'KS_zݞV_^+', '', 0, '?'),
 ('`+j~_3:jb', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_24px.svg', 0, 'EhWa\Z,', 'EhWa\Z,', '!2|؈=OʌXwǄ5:7]T܉', '', 0, '?'),
 ('/|ڀ4b', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_fish_eye_24px.svg', 0, 'J~]ܪP-', 'J~]ܪP-', '=S-?vQlPcaT@Y_O\'', '', 0, '?'),
 ('AQh\r\"؞', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_horizontal_24px.svg', 0, 'd.c>YgD{', 'd.c>YgD{', '|,OAo|e*+_\"_]0', '', 0, '?'),
 (',5sY(?*jf', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_vertical_24px.svg', 0, '>2 \0JRx', '>2 \0JRx', '\ZFp)()*qW!,', '', 0, '?'),
 (' }\Z++{1%\\', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_wide_angle_24px.svg', 0, 'd\Z뢥z\"D', 'd\Z뢥z\"D', '<~8n ܀\0>ˤo[s', '', 0, '?'),
 ('}&*\rwc', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_24px.svg', 0, 'vːͦF18?', 'vːͦF18?', 'ɧbN=,g8r	(MXjOA`s', '', 0, '?'),
 ('ͳ)p-3iX.Ep', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_album_24px.svg', 0, 'iV&HlS>;İ}', 'iV&HlS>;İ}', 'sHx{$tt`!0f', '', 0, '?'),
 ('ĵ}b칖%', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_camera_24px.svg', 0, 'Oa6Y%C', 'Oa6Y%C', 'l6ꏀ].rC\r;E', '', 0, '?'),
 ('3NbߜR}\0', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_filter_24px.svg', 0, '9oj+w', '9oj+w', 'b8\r^,us', '', 0, '?'),
 ('m$MZyg', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_library_24px.svg', 0, 'Ǻi\ZKC^\"l', 'Ǻi\ZKC^\"l', 'gcפY:Cz+:', '', 0, '?'),
 (' c	^9:Ů', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_size_select_actual_24px.svg', 0, '(zRun# d#q', '(zRun# d#q', 'E}*MLR \0r̝', '', 0, '?'),
 ('mmX2,p', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_size_select_large_24px.svg', 0, 'm.ĝ	;', 'm.ĝ	;', 'F;l!h8H\rهCb\0', '', 0, '?'),
 ('>%ٵa', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_size_select_small_24px.svg', 0, 'ڠ\"_J:u\rߤ', 'ڠ\"_J:u\rߤ', 'vA_R\0\'}Kcmv&.$', '', 0, '?'),
 ('-\nǪ9§5\0', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_picture_as_pdf_24px.svg', 0, 'Pd=2*늬(\Z', 'Pd=2*늬(\Z', '1d\\\\}oVi3	d0y', '', 0, '?'),
 ('}Ea_A4%)2', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_portrait_24px.svg', 0, '(]-Gn\r/', '(]-Gn\r/', ',\0n6EeI98́a:4s<	?\n', '', 0, '?'),
 ('G\'~I~O(Ǫ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_remove_red_eye_24px.svg', 0, '(dDN=!_2ك', '(dDN=!_2ك', '$7Q\rRt5,y}VOތr', '', 0, '?'),
 ('\nd6X\"i', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_rotate_90_degrees_ccw_24px.svg', 0, 'B@vp	k0,', 'B@vp	k0,', '1اs#vHp8ժNGU\'<', '', 0, '?'),
 ('jX^fKI\'LU', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_rotate_left_24px.svg', 0, 'JtDHv>2=', 'JtDHv>2=', '#}\08Q5yX4£Q.`f~ms', '', 0, '?'),
 ('\\܀٠rit', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_rotate_right_24px.svg', 0, 'wĨrw', 'wĨrw', '8$B@bf_2', '', 0, '?'),
 ('\0NUGJB', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_slideshow_24px.svg', 0, '$.d<]IDtO', '$.d<]IDtO', '3M]\'tbqh#E\r[2UF', '', 0, '?'),
 ('w1B{\n-DI?', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_straighten_24px.svg', 0, '~A\' ', '~A\' ', 'Ujs1\n=,jh[#yB', '', 0, '?'),
 ('N~j/s_', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_style_24px.svg', 0, 'R$ԥ', 'R$ԥ', '@l1TzV4W[=r', '', 0, '?'),
 ('dWM)g', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_switch_camera_24px.svg', 0, 'K|^9h,1S', 'K|^9h,1S', 'ܑrيyDoܚ2{\ZʮF', '', 0, '?'),
 ('?&y8oD~P7[I', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_switch_video_24px.svg', 0, '@rd\\yEIFh\0', '@rd\\yEIFh\0', '΅ r \\/9Qixnu&', '', 0, '?'),
 ('OBaOI', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_tag_faces_24px.svg', 0, 'l!qM+x k-', 'l!qM+x k-', '\0ꧤ^vޕO͍rr0#t', '', 0, '?'),
 ('/#^/\n#~u', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_texture_24px.svg', 0, ' a/:~)IX', ' a/:~)IX', 'I;,,Dg]D.0\r9b', '', 0, '?'),
 ('U<:-$vC+', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timelapse_24px.svg', 0, 'mɤ?Ʉ|!b', 'mɤ?Ʉ|!b', 'qxG.ݞ҈R[֜*qBA', '', 0, '?'),
 ('īA\nD4', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_10_24px.svg', 0, 'v-/{{z˜\r', 'v-/{{z˜\r', '&.0C]GUG u`', '', 0, '?'),
 ('nko/]', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_24px.svg', 0, 'sk+vp', 'sk+vp', 'o\"%:tU3,uvH\nqc8[', '', 0, '?'),
 ('J16a?\')88ry', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_3_24px.svg', 0, '6C.\"\\j', '6C.\"\\j', 'EtC֞nKJ΂C~uO\r@,', '', 0, '?'),
 ('O:R?Gnm\\', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_off_24px.svg', 0, '=ɫ/.Y*', '=ɫ/.Y*', 'R͕&N؂VLXbxľ', '', 0, '?'),
 ('9K:S', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_tonality_24px.svg', 0, 'AfΨv@:ɊF)', 'AfΨv@:ɊF)', '%6@h&HFM(5yQϥ', '', 0, '?'),
 ('8zƴUw', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_transform_24px.svg', 0, 'I-h4k[', 'I-h4k[', 'm\Z<;47KGiQ7ԂQo\nm', '', 0, '?'),
 ('<VɧG+*', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_tune_24px.svg', 0, 'l]\n%猠mWg.', 'l]\n%猠mWg.', 'U{ӚD)2b-:Ϝ', '', 0, '?'),
 ('4&+)+7ޤr+q', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_view_comfy_24px.svg', 0, 'xº0f;', 'xº0f;', 'C\nC25T!/)2R0Z(3k`8_', '', 0, '?'),
 (']3I4qF&M', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_view_compact_24px.svg', 0, '^=y\no\Z8ˌ#Q', '^=y\no\Z8ˌ#Q', 'yqj㧬9}<\0F6D֣jr_LȀ', '', 0, '?'),
 ('-%\'Cy', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_vignette_24px.svg', 0, 'Bu Eubo>d', 'Bu Eubo>d', '>߬GْmFSWł-', '', 0, '?'),
 ('slk\\lZ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_auto_24px.svg', 0, 'z\n.]YvP27', 'z\n.]YvP27', '\"v=;B\0P`	뒝{p[Lb', '', 0, '?'),
 ('>i7q \r˝\ZGD', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_cloudy_24px.svg', 0, 'Hc$:kOY', 'Hc$:kOY', 'k^׷Xr-	?1]-o:?\0z;R', '', 0, '?'),
 ('RX7_Cڪħ', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_incandescent_24px.svg', 0, '\"=.&գ', '\"=.&գ', 'jOM:ΥqotG!$YU4f', '', 0, '?'),
 ('/3Vэ7 B', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_iridescent_24px.svg', 0, 'ˮ%t%', 'ˮ%t%', 'OQT_f8:4ʌOH?2', '', 0, '?'),
 ('M墒6BO>', 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_sunny_24px.svg', 0, 'E<5]ֶx', 'E<5]ֶx', 'E<o\0ޣ,;m\\ PdJ{', '', 0, '?'),
 ('\ri*\\', 'wp-content/plugins/revslider/public/assets/assets/svg/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('܍<\'ӌ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_add_location_24px.svg', 0, '\0`>8\n8', '\0`>8\n8', 'x11&2^*J/c@fK~<.[_,', '', 0, '?'),
 ('J~_#)#n', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_beenhere_24px.svg', 0, 'l)Y!!Ǌ{e1', 'l)Y!!Ǌ{e1', 'b״\0ۧ^S:t]VWđ2', '', 0, '?'),
 ('Нs&1p', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_24px.svg', 0, 'ԡI\\7g;;Ie', 'ԡI\\7g;;Ie', '}<1@m+9O!=4=sr', '', 0, '?'),
 ('\08qat0曑', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_bike_24px.svg', 0, 'd9BVt9m', 'd9BVt9m', '|*\'SlZy!b(\"?5haRۑQ', '', 0, '?'),
 ('BvgqMܑh', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_boat_24px.svg', 0, ',|Ev ʬ ', ',|Ev ʬ ', 'Mke&eЩuyũ,F', '', 0, '?'),
 ('p	w/NlCP]U', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_bus_24px.svg', 0, '\ZV~q^', '\ZV~q^', 'XMNjѻlYkx[8r\\;Hd?ۂ', '', 0, '?'),
 ('	M\"౎s=]O', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_car_24px.svg', 0, '׎ZXkux', '׎ZXkux', 'CX.a2}/~ ݊UB{', '', 0, '?'),
 ('BD`l$', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_railway_24px.svg', 0, '+HF|z~^-0', '+HF|z~^-0', '\0KIzCY\r.DO +', '', 0, '?'),
 ('K+T5 L', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_run_24px.svg', 0, '	Pצ}eX', '	Pצ}eX', 'ѹx:I4gU^v5\'-}', '', 0, '?'),
 (';1䧉r2I', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_subway_24px.svg', 0, '%a_q?=', '%a_q?=', '麸HLK*s+3y\rj5', '', 0, '?'),
 ('Vη;jb6XF', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_transit_24px.svg', 0, '%a_q?=', '%a_q?=', '麸HLK*s+3y\rj5', '', 0, '?'),
 ('^jIGβt', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_walk_24px.svg', 0, 'QoLmi-', 'QoLmi-', 'F,O:c(+Gr', '', 0, '?'),
 ('Vv)~k', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_edit_location_24px.svg', 0, ']#b	-', ']#b	-', 'а\"0kv[ׯ1.`fi]F', '', 0, '?'),
 ('FrK~Aj#S\'A', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_flight_24px.svg', 0, 'Aہ&lo|[E', 'Aہ&lo|[E', 'P\'ooLC~ovPad}~', '', 0, '?'),
 ('w_9MzG', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_hotel_24px.svg', 0, '1<io X', '1<io X', 'hzΝ&:I+9~Cy@J/s2i\n', '', 0, '?'),
 ('jO򟴸RcT', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_layers_24px.svg', 0, 'gs6cUQWF', 'gs6cUQWF', 'fTHșTKE۬J^5]^', '', 0, '?'),
 ('Q\\@ɉ*m', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_layers_clear_24px.svg', 0, '?h-sJ', '?h-sJ', '2%r?5ɗ9%ďLu_K	', '', 0, '?'),
 ('Ƭ0\nHܣ>8@', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_activity_24px.svg', 0, '?z/OTZF', '?z/OTZF', '\'A$\0M$6%Oxh=NYUꅠҸ', '', 0, '?'),
 ('m6hDF\n', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_airport_24px.svg', 0, '}fY6Xq\'', '}fY6Xq\'', 'q:I\\4BTڙ@o@ms', '', 0, '?'),
 ('_J&~', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_atm_24px.svg', 0, 'qѸWm', 'qѸWm', 'e}wR4\'p&D)#', '', 0, '?'),
 ('a6z\n^a', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_bar_24px.svg', 0, 'CH-]VHR', 'CH-]VHR', 'ˢZ$	{tm9}0\r', '', 0, '?'),
 ('jU]ɚ]D̞߼4\r', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_cafe_24px.svg', 0, '~)Q,\0m', '~)Q,\0m', '¯=shֳB=LOEaq', '', 0, '?'),
 ('[fȲ^ǆp:', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_car_wash_24px.svg', 0, 'VE$}F-?Xu', 'VE$}F-?Xu', 'vQPHQ#_)[E', '', 0, '?'),
 ('vuv<#', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_convenience_store_24px.svg', 0, '*\0D', '*\0D', 'Ї#\\9s^Mk |I$ƃG[\r8', '', 0, '?'),
 ('wADtRG:$TPI', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_dining_24px.svg', 0, 'kxxj@h3G', 'kxxj@h3G', '¿Sx>F4j,7ϵlX2]_', '', 0, '?'),
 ('shC]6̔_', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_drink_24px.svg', 0, 'FVLh', 'FVLh', 'Ǝt<ߍZugFr1', '', 0, '?'),
 ('cWZq܆', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_florist_24px.svg', 0, 'TY*Ui', 'TY*Ui', '\Z.2qNbjỳP9[vι', '', 0, '?'),
 ('=ol,f8S', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_gas_station_24px.svg', 0, '_<݊`ڲa}m', '_<݊`ڲa}m', '(tw8FD	gj$>\0J', '', 0, '?'),
 ('1Ƀ٢@@:', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_grocery_store_24px.svg', 0, '|F5CV:', '|F5CV:', 'Ԟe;nTGKk`߈68', '', 0, '?'),
 ('՜f+!X_~c', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_hospital_24px.svg', 0, 'E $Qǋ', 'E $Qǋ', 'PgҮM!sUAp_4ʉݚpg', '', 0, '?'),
 ('	}	0+gj', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_hotel_24px.svg', 0, '1<io X', '1<io X', 'hzΝ&:I+9~Cy@J/s2i\n', '', 0, '?'),
 ('^3dNkŦ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_laundry_service_24px.svg', 0, '>yl;6pFV', '>yl;6pFV', '<-p936ћh9c#Fae', '', 0, '?'),
 ('%8Âo׿', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_library_24px.svg', 0, '</H*KniXeOp', '</H*KniXeOp', ']fdI3DJ-Y', '', 0, '?'),
 ('8\nɫkg݄', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_mall_24px.svg', 0, '̔\nm<f', '̔\nm<f', '3Ԏ>`}3`ao\ZfzD', '', 0, '?'),
 ('ʸvsQBC', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_movies_24px.svg', 0, 'H\r2Rڤ', 'H\r2Rڤ', 'jf0k߶zc~ъ@r^f0.', '', 0, '?'),
 ('Pi8=1<\"7ۮ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_offer_24px.svg', 0, '^|`۪', '^|`۪', '\\ra0Vwlt1.h{=gȀ', '', 0, '?'),
 ('m,c)\"~;̵', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_parking_24px.svg', 0, 'V\rƱ=Ɛ)r', 'V\rƱ=Ɛ)r', 's#-!/t0 ~ ~', '', 0, '?'),
 ('-8yhN1]', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_pharmacy_24px.svg', 0, '$9GsjL', '$9GsjL', '<C@:kN@E%74wjjL+{n0', '', 0, '?'),
 ('OP0-Pd', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_phone_24px.svg', 0, '8WFKE?mTDv', '8WFKE?mTDv', 'T1x.~cEbԏGAv', '', 0, '?'),
 ('Peß ԁaރ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_pizza_24px.svg', 0, '弍<B[(v`', '弍<B[(v`', 'Sf-{W|[\\topĕ{@\0ݷ', '', 0, '?'),
 ('v(x\0W', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_play_24px.svg', 0, '?z/OTZF', '?z/OTZF', '\'A$\0M$6%Oxh=NYUꅠҸ', '', 0, '?'),
 ('iݣ[~?X', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_post_office_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('K?gX/k\"', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_printshop_24px.svg', 0, ')>0\nG\ZrQF', ')>0\nG\ZrQF', ']$pz:\'CR\0syL9#?', '', 0, '?'),
 ('apv3x3?4\rG:', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_see_24px.svg', 0, 'Oa6Y%C', 'Oa6Y%C', 'l6ꏀ].rC\r;E', '', 0, '?'),
 ('5Y\n+/9\\Γh', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_shipping_24px.svg', 0, '[(3KPu@zpA', '[(3KPu@zpA', 'd\0pQ7E{(H%g8\'92*', '', 0, '?'),
 ('Vm)Ɗ)~ע', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_taxi_24px.svg', 0, '*Tc+a0', '*Tc+a0', 'AOdƁ{ߺzWqO\\ s', '', 0, '?'),
 ('@!LIc', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_map_24px.svg', 0, '늯БFu', '늯БFu', 'ME6<_V\"m\'^.', '', 0, '?'),
 ('dߩ*-i=', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_my_location_24px.svg', 0, 'G~)5o!g', 'G~)5o!g', 'W?ړ-JAV۩TS`o{+', '', 0, '?'),
 ('=8z(s0gp_', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_navigation_24px.svg', 0, 'ʏ2cLi\rĭ#`+', 'ʏ2cLi\rĭ#`+', 'ɔeV%_X\"Cw衢i0', '', 0, '?'),
 ('fގw#=T', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_near_me_24px.svg', 0, '%|3~u', '%|3~u', 'm9\'oYYI{r', '', 0, '?'),
 ('S\"%K', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_person_pin_24px.svg', 0, '-N0|Vn\"', '-N0|Vn\"', '=*/gك\r\0gZ]%', '', 0, '?'),
 ('|S4:lŪ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_person_pin_circle_24px.svg', 0, 'eD\\=Ϳ\ZT', 'eD\\=Ϳ\ZT', '>}\0,\"% \0%nse2р[y', '', 0, '?'),
 ('$0\"\r2$ϑ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_pin_drop_24px.svg', 0, 'g^4C\\p\Z', 'g^4C\\p\Z', 'ݺM.bz9\r=~ȉ#O', '', 0, '?'),
 ('k%]\rSY.MgR', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_place_24px.svg', 0, 'I}Ԛ^޵Q\Zw', 'I}Ԛ^޵Q\Zw', '\\]:0cA7kT`	(\0', '', 0, '?'),
 ('ZxZ-l?', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_rate_review_24px.svg', 0, 'Mb:h~}*\\Yt', 'Mb:h~}*\\Yt', 'KlOo̠YǮcKBy]39', '', 0, '?'),
 ('$Dd|*Һ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_restaurant_menu_24px.svg', 0, 'kxxj@h3G', 'kxxj@h3G', '¿Sx>F4j,7ϵlX2]_', '', 0, '?'),
 ('ث\05WK=3Q', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_satellite_24px.svg', 0, 'Aw..AEC.ȃ', 'Aw..AEC.ȃ', 'NJފuz8	R3Cե', '', 0, '?'),
 ('Ţ\\,$\n^_O', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_store_mall_directory_24px.svg', 0, 'Cؗ5D=_E', 'Cؗ5D=_E', 'TW+ݳ4\r$Y.&}\0v', '', 0, '?'),
 ('Kg.zr', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_terrain_24px.svg', 0, 'Dp\0)[Y', 'Dp\0)[Y', 'E酲.~I/tKޖDXy{E', '', 0, '?'),
 ('d	Tṷ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_traffic_24px.svg', 0, 'H@hO#Y)', 'H@hO#Y)', '	6`܀*oQXR\Zwk\'Fd!', '', 0, '?'),
 ('XgEŌJ', 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_zoom_out_map_24px.svg', 0, '`6c-dO_', '`6c-dO_', 'ط*i?5}@Nzi`QSƆƓ8TGL', '', 0, '?'),
 ('V a+E0p', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_apps_24px.svg', 0, '|{->9*x', '|{->9*x', 'PH\'! N30k\'\'Z?kOWG', '', 0, '?'),
 ('-Ȝ\"r.+0|', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_apps_36px.svg', 0, ';?bXƿ\\', ';?bXƿ\\', '3CJ;C]Q+FngCʝt', '', 0, '?'),
 ('aKyl^*n솖', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_back_24px.svg', 0, '~ThO', '~ThO', '0se]\nIܬ/:chmO#', '', 0, '?'),
 ('o!GZ', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_back_36px.svg', 0, 'B?.GwgP', 'B?.GwgP', 'BNǃV[Q@J2c8B!\r8Nt', '', 0, '?'),
 ('A!9iFp', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_downward_24px.svg', 0, 'Zm) -!A', 'Zm) -!A', 'QPdJws*jZl}[	u\"Z', '', 0, '?'),
 ('>|\Z.\'8+R', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_24px.svg', 0, '!H293T', '!H293T', 'y|UpD<tnh7e,', '', 0, '?'),
 ('jT+Q}iYC', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_36px.svg', 0, 'p[6Rxk`+0-B', 'p[6Rxk`+0-B', 'k2Z0G6D^@0|U', '', 0, '?'),
 ('Zss', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_circle_24px.svg', 0, '\\7b', '\\7b', 'Bkt`g_TȌuAP:͙^@d', '', 0, '?'),
 ('c[yC8{Hu', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_24px.svg', 0, 'A,t\02l!', 'A,t\02l!', '͇\'BS\'#ȧ7ݵ$#QTLdNMcr', '', 0, '?'),
 ('bN	gz5좼', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_36px.svg', 0, '!uVsX', '!uVsX', 'Z$<0DXU尧!~9T', '', 0, '?'),
 ('ғ8KbBBG9K#q', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_24px.svg', 0, 'h)㕑SK', 'h)㕑SK', '䧙*\'B3xZgB)cw	>F9y', '', 0, '?'),
 ('.-\\.r', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_36px.svg', 0, 'SA@g', 'SA@g', '\"6=A<ӦŹ)\"E', '', 0, '?'),
 ('׷FZYd?', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_upward_24px.svg', 0, 'ɈB2cj\r>4', 'ɈB2cj\r>4', ']/7s{wsif`IQwV,\"J', '', 0, '?'),
 ('1:OG춀\\M}', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_cancel_24px.svg', 0, 'B.RpcR1[q', 'B.RpcR1[q', 'i?MOQz3翖$.|;fk', '', 0, '?'),
 ('e!3%pu', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_cancel_36px.svg', 0, '4TvW4', '4TvW4', ' XK#f O|[\n', '', 0, '?'),
 ('Z+̷5G', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_check_24px.svg', 0, 'K;\"6\ZGpʟ', 'K;\"6\ZGpʟ', '~}U*^5\0!1^čHl39a', '', 0, '?'),
 ('|07-6Y', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_check_36px.svg', 0, 'k,ZM6C', 'k,ZM6C', ' vH+T˶8(yeAn', '', 0, '?'),
 ('_,S)$\0', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_left_24px.svg', 0, 'իr)', 'իr)', '^^Ղ{;O՝tHbBBO]U\nv', '', 0, '?'),
 ('*\'N.\"%c멒', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_left_36px.svg', 0, '*_c6aѫ[oq7', '*_c6aѫ[oq7', 'M5XhDd?tYꁥb2:|1J.', '', 0, '?'),
 ('gj3!\r@}', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_right_24px.svg', 0, '/3\\-%C', '/3\\-%C', 'Ɉ>5~D.51ōݿ@8KiRrK\'', '', 0, '?'),
 ('s9g#^a[;', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_right_36px.svg', 0, 'dblj*s', 'dblj*s', 'ww X\0O@Hd2[{sNi', '', 0, '?'),
 ('|:\"}\'	b', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_close_24px.svg', 0, 'F_\Zd\"', 'F_\Zd\"', 'MrY5tJ$YI ?^', '', 0, '?'),
 ('bdaQJY4', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_close_36px.svg', 0, '7\">.}}\ZB?P4N', '7\">.}}\ZB?P4N', 'ˉåBhPZ@?vF)更16', '', 0, '?'),
 ('DmZ)D;B%>I', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_less_24px.svg', 0, 'C`B9ߟV,', 'C`B9ߟV,', 'rb=PtlC5wdNyLaR~Uk', '', 0, '?'),
 ('X\r8ژV\'dR', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_less_36px.svg', 0, 'bwk$I(#b/', 'bwk$I(#b/', 'b7Si]p,!iQX}03ߩTCh', '', 0, '?'),
 ('pT-9Z`>~', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_more_24px.svg', 0, 'wDzNv#Lηl', 'wDzNv#Lηl', '$\nV?H\ra2G	(\"Uz<U:', '', 0, '?'),
 ('oaf}?E', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_more_36px.svg', 0, 'ܟtio', 'ܟtio', '(GRꊢjR;c\ZUDvc', '', 0, '?'),
 ('\\sV>\')Cs', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_24px.svg', 0, '\'!.L|*', '\'!.L|*', 'Թ?e\\\rHȔ#k!vj^z+', '', 0, '?'),
 ('t/02I\'', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_36px.svg', 0, '\'_|<%Kx]u', '\'_|<%Kx]u', 'K;j4kN\"6;@AV|SS', '', 0, '?'),
 ('B!6``	e', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_24px.svg', 0, 'OsTJ٪g', 'OsTJ٪g', '+ۑ=qDX3d,!', '', 0, '?'),
 ('^A=vV\Z', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_36px.svg', 0, 'L:F&g', 'L:F&g', '9(SjB[sR첍\\\Z!k', '', 0, '?'),
 (',\'P?Cu', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_menu_24px.svg', 0, ' Oa7M[|', ' Oa7M[|', 'yEmqц)G+#wZ4ݹ', '', 0, '?'),
 ('W]d(~i', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_menu_36px.svg', 0, ')VS=G(,', ')VS=G(,', ']ÖLduɒyI,3', '', 0, '?'),
 ('H?l2t,', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_horiz_24px.svg', 0, '\"݊Il9knٛ', '\"݊Il9knٛ', 's	!E\\)|܇R!4Zg̃', '', 0, '?'),
 ('\n@6&O\r<{Sj', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_horiz_36px.svg', 0, '44gd3&', '44gd3&', 'Ն^dx}yI04\03,EAU', '', 0, '?'),
 ('x mCFuCl&w', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_vert_24px.svg', 0, 'lx1%f', 'lx1%f', 'Ha\'2 \\RF\rݴ2-', '', 0, '?'),
 ('oY2=A*<', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_vert_36px.svg', 0, '6=[', '6=[', '7h+^j*\n(\n\\ G*pCP', '', 0, '?'),
 ('eQy|h.#y', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_refresh_24px.svg', 0, 'aw\r}O\rqsEP\0U@H', 'aw\r}O\rqsEP\0U@H', 'Hn;XNei@VDH-ܱ$\'NV', '', 0, '?'),
 ('TE?jz', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_refresh_36px.svg', 0, 'z٤*gb', 'z٤*gb', '#ON4OG,\0ۢQ,4_5k[P)', '', 0, '?'),
 ('KzԼR]6\\', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_left_24px.svg', 0, 'M0dx.5', 'M0dx.5', 'f/xq\0Z|Li[)]', '', 0, '?'),
 ('uVA&WysOX', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_right_24px.svg', 0, 'ͷEɻJE7', 'ͷEɻJE7', '@_\'h%BüO?B\'', '', 0, '?'),
 ('Lʵ*\0\03	', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_less_24px.svg', 0, 'vT\'vD', 'vT\'vD', 'Y-3{?M#\"udE', '', 0, '?'),
 ('}DixHCz^T\0Y', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_less_36px.svg', 0, '1C)$[{', '1C)$[{', 'uyζ`Ɣvܸ\ZYdUT&\Zf', '', 0, '?'),
 ('9qr	MBD\r', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_more_24px.svg', 0, 'a%-~uh', 'a%-~uh', 'qBW==GL],c+t*W', '', 0, '?'),
 ('%B:e}&', 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_more_36px.svg', 0, '1s4UW`jF', '1s4UW`jF', '6p:ȋN$Y\"2kgMc!	(', '', 0, '?'),
 ('gS~6>ɺ[Z', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_adb_24px.svg', 0, '#jVILts@', '#jVILts@', 'ߑ5Pǔg1YGq*}\r\nr%L', '', 0, '?'),
 ('O9\nqcx5', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_24px.svg', 0, 'Y\r~Px', 'Y\r~Px', 'ѳ^մbpFNQؚ_f39Jt', '', 0, '?'),
 ('GoUjmZG	qo', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_angled_24px.svg', 0, '|l]ɹdf', '|l]ɹdf', '}Ϟ.ܗk,/y-Qj7W3', '', 0, '?'),
 ('QPUv;Z3', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_individual_suite_24px.svg', 0, '{,q<+\'', '{,q<+\'', 'MMU4@VxG0V\rp&/N}', '', 0, '?'),
 ('J:xUjZi\'՘@', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_extra_24px.svg', 0, '#JY*\"V', '#JY*\"V', 'laqNNN،\Z=کl', '', 0, '?'),
 ('\\F\\E94W+', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_normal_24px.svg', 0, '&FqiiЃu8', '&FqiiЃu8', '`	\nsF:1cq*s\0u', '', 0, '?'),
 ('$>#9l', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_reduced_24px.svg', 0, 'R<hd', 'R<hd', ':KgU\r{An1ٻjO,', '', 0, '?'),
 ('}b~', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_extra_24px.svg', 0, '3XѶG	\ZQ', '3XѶG	\ZQ', '%Ax%8_MS/)LfkJh`F', '', 0, '?'),
 ('KQԉ+]d', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_normal_24px.svg', 0, '*I\"I[', '*I\"I[', 'ͦŉ!Uw]sVHI~%/', '', 0, '?'),
 ('o~5ץ\\Ծ', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_bluetooth_audio_24px.svg', 0, 'c\r;Ǐ_', 'c\r;Ǐ_', '>TV\nC~8LOɁYvK˶De\'%', '', 0, '?'),
 ('n\01 \n@', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_confirmation_number_24px.svg', 0, '܄4\\t_', '܄4\\t_', '*),$	O*>p07g\'Q6\0Z', '', 0, '?'),
 ('$:}j ', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_disc_full_24px.svg', 0, '+Փv2', '+Փv2', 'xڮg7,.o<5Pf4]rK', '', 0, '?'),
 ('m8Iyc', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_24px.svg', 0, '0}} w', '0}} w', '幑姥6wXK]I;x4', '', 0, '?'),
 ('q|!\\RxO', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_alt_24px.svg', 0, '0)u)m', '0)u)m', 'hz?딡s;1Wk\"D͟', '', 0, '?'),
 ('h+DAN', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_drive_eta_24px.svg', 0, ']g>p~ܼv', ']g>p~ܼv', 'P,tZ%WDxW@Ow`Z,/', '', 0, '?'),
 ('),l]j;ZU', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_enhanced_encryption_24px.svg', 0, 'VZSF[/n', 'VZSF[/n', '!<Y%TnrU?UPI2', '', 0, '?'),
 ('<i/+\0[G5', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_event_available_24px.svg', 0, 'ANȭ_0ԭ\ZD̢', 'ANȭ_0ԭ\ZD̢', ')F2%z\'0:2u$\r1E', '', 0, '?'),
 ('\"9M*?fW', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_event_busy_24px.svg', 0, 'v&/gͣC', 'v&/gͣC', 'Tg9B9)pYvJ', '', 0, '?'),
 ('5M%\\Ku/J', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_event_note_24px.svg', 0, '\"fOFX', '\"fOFX', '9-Z]ۨm2ECcKO*KB:S', '', 0, '?'),
 ('\"31v|hw', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_folder_special_24px.svg', 0, 'z7sU]>#', 'z7sU]>#', 'ەՎposf\Zw\0$sPmEԛ&', '', 0, '?'),
 ('rnA:5c=3', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_live_tv_24px.svg', 0, 'LŻeư', 'LŻeư', 'hfЉ\ZYc+Cϡ &֦', '', 0, '?'),
 ('\Z!wr^ÅW', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_mms_24px.svg', 0, '~&Qăpt8Zo', '~&Qăpt8Zo', '`8q4?sBzK97N1^;X', '', 0, '?'),
 ('&AǝiU', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_more_24px.svg', 0, 'G%Yav\"B', 'G%Yav\"B', ';NhG<\\u#P2t@r(h]EN\0', '', 0, '?'),
 ('/	!\ZdsJ', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_network_check_24px.svg', 0, 'wu) H', 'wu) H', 'O]*1Ck\0&g5םt', '', 0, '?'),
 ('_&O >TF2F>', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_network_locked_24px.svg', 0, 'V|S LOƝre', 'V|S LOƝre', '-aK /hJ\0Xr7pZ΃z#', '', 0, '?'),
 ('-]0F$', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_no_encryption_24px.svg', 0, '|)djO~l	Z', '|)djO~l	Z', '\"ŀIq6yeS[z<\0V3·Yn ~B@', '', 0, '?'),
 ('2\\\\(#', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_ondemand_video_24px.svg', 0, ';̄r9n', ';̄r9n', 'Hr+0Ow#bCD=mkҍ\'|', '', 0, '?'),
 ('Z#o9_', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_personal_video_24px.svg', 0, 'Kh}e;gĲwU', 'Kh}e;gĲwU', '?dz2`~v\ZQ1خ*Ҕqd', '', 0, '?'),
 ('kiu̥,heG2', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_bluetooth_speaker_24px.svg', 0, 'ҞlGnNv(/', 'ҞlGnNv(/', 'ST;`L;$uPd:\Zgf\r', '', 0, '?'),
 ('$$oQqmvyH%', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_forwarded_24px.svg', 0, '(Kmx};`y|J', '(Kmx};`y|J', '=Y8n-[\r%N%|DDmZ	K{', '', 0, '?'),
 ('@A/Ń	h', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_in_talk_24px.svg', 0, 'fbǤ(Mus', 'fbǤ(Mus', 'lͤzxӞd_[%g1eKHrJD4', '', 0, '?'),
 ('O\rK7', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_locked_24px.svg', 0, 's\r)߄_', 's\r)߄_', '$h\0zHH	C5&cy6', '', 0, '?'),
 ('#?\'Y}6k!U', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_missed_24px.svg', 0, 'pCTul', 'pCTul', 'rԸm%\nDp	?\n3', '', 0, '?'),
 ('\'F=(bJ\'$0', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_paused_24px.svg', 0, '\r\"2=3v$', '\r\"2=3v$', '|\03k9RIJ]g!Pkn', '', 0, '?'),
 ('>0\rP', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_power_24px.svg', 0, '`p.*', '`p.*', '\ZO&h4nܲQ	', '', 0, '?'),
 ('P$k[\r[', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_rv_hookup_24px.svg', 0, 'U9rm7D\"C', 'U9rm7D\"C', '$0M[\'+`Bŗu6[RY', '', 0, '?'),
 ('BFa^A\"', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sd_card_24px.svg', 0, '$NoIgB', '$NoIgB', 'gl 7IՁA=', '', 0, '?'),
 ('M#-߿&Y}', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sim_card_alert_24px.svg', 0, '0N\r\'0M8~W', '0N\r\'0M8~W', '\n1k%fE%P	gzxڹ', '', 0, '?'),
 ('E%j6dI@B', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sms_24px.svg', 0, 'R5!6/!+', 'R5!6/!+', '\\s\nm;{s(\nC(E8\'+\n', '', 0, '?'),
 ('=Y0K?', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sms_failed_24px.svg', 0, '?ә`EC	-,p', '?ә`EC	-,p', 'c3\rmpi	2S8;h	mz', '', 0, '?'),
 ('(M#$=~Հ}', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sync_24px.svg', 0, 'r/2%&.V', 'r/2%&.V', 'h)u⬉!{G\0\0\0xY#iDV', '', 0, '?'),
 ('v;Ryc>)\ZY', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sync_disabled_24px.svg', 0, 'wɺOn', 'wɺOn', '6V0V	\"\'?7X6', '', 0, '?'),
 ('(զ̂W꧷', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sync_problem_24px.svg', 0, '\n¶wd߻My', '\n¶wd߻My', '=dR]=<ɃwưYVfZ\Z?', '', 0, '?'),
 ('JͶ[2۰0', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_system_update_24px.svg', 0, 'C.BjmiǷ', 'C.BjmiǷ', 'ttNGytJ5o X', '', 0, '?'),
 ('48+C%(Vc', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_tap_and_play_24px.svg', 0, 'hj_ΎٿEA', 'hj_ΎٿEA', 'I|І$Ƨ~ax]m76	$k', '', 0, '?'),
 ('Yq_[@', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_time_to_leave_24px.svg', 0, ']g>p~ܼv', ']g>p~ܼv', 'P,tZ%WDxW@Ow`Z,/', '', 0, '?'),
 ('!\n-L+', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_vibration_24px.svg', 0, 'j%+qX9CV', 'j%+qX9CV', '\"g\Z2<n\r<4+NL#', '', 0, '?'),
 ('`\0\nNr)1', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_voice_chat_24px.svg', 0, ';vXg8', ';vXg8', ':jm|o	τX6{x<va@n', '', 0, '?'),
 ('I ]\ZB\Zm%', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_vpn_lock_24px.svg', 0, '-j9:D:E^', '-j9:D:E^', 'JUXFGTm[p32#', '', 0, '?'),
 ('dCKᰈm', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_wc_24px.svg', 0, 'uJۂiNg', 'uJۂiNg', 'CNjנ9ZݐGv\"', '', 0, '?'),
 ('v>.Io', 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_wifi_24px.svg', 0, 'V=Bj2gUA', 'V=Bj2gUA', '!7v4V>A[dT36|\r\0', '', 0, '?'),
 ('hp?](VÞtK', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_ac_unit_24px.svg', 0, '?`vzs>>', '?`vzs>>', '@~ę:vYO{y3,@t', '', 0, '?'),
 ('n^|+a<t', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_airport_shuttle_24px.svg', 0, 'M6U^-\ZP', 'M6U^-\ZP', '!юtkvfh^5vNJ!#&', '', 0, '?'),
 ('j|$ؓy4', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_all_inclusive_24px.svg', 0, '=\\iqw', '=\\iqw', 'MJ\\r\Zŏ߹nkoZ4', '', 0, '?'),
 ('iy!T:', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_beach_access_24px.svg', 0, 'xIb3', 'xIb3', 'tG\r#lĺC*Lxg;jn', '', 0, '?'),
 ('$42{Eb\0;L', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_business_center_24px.svg', 0, '8f΃8sؓJ', '8f΃8sؓJ', '@*VK\0\0S^\'Mؘ', '', 0, '?'),
 ('_ו*P', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_casino_24px.svg', 0, 'de@b3l', 'de@b3l', 'P)\nNXݕ>-\\U.s2˭', '', 0, '?'),
 ('s\"_W', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_child_care_24px.svg', 0, 'd>+`', 'd>+`', 'NIZtmlIPjG^$Ax', '', 0, '?'),
 ('ꐹ.\r1\n', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_child_friendly_24px.svg', 0, '\":X?&\\c', '\":X?&\\c', 'Iw.djH:q]9-Y&M\'q', '', 0, '?'),
 ('gViC,Q', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_fitness_center_24px.svg', 0, '2@[e#WO', '2@[e#WO', '~:N\\\0rtc2p	hF%Q7-', '', 0, '?'),
 ('p͔A+', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_free_breakfast_24px.svg', 0, 'Cc\ndb,_֨', 'Cc\ndb,_֨', 'H9仹nCobo/hl', '', 0, '?'),
 ('i3,wRuة', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_golf_course_24px.svg', 0, '91Fkm[҅U', '91Fkm[҅U', 'lĠ6;\rlט/\Z_^&v]\\7yG', '', 0, '?'),
 ('n\\~0ظL-', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_hot_tub_24px.svg', 0, 'Pƭ_bNUc]z', 'Pƭ_bNUc]z', '.pA+Qvge]	\'V\"{}', '', 0, '?'),
 ('|_]23<><', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_kitchen_24px.svg', 0, 'nI\\FB&hF', 'nI\\FB&hF', '\"W=y$4wM@T>', '', 0, '?'),
 (')(\0C),LG', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_pool_24px.svg', 0, '$3N|jY', '$3N|jY', 'ra`Uc:Yoj\Z\\&.[', '', 0, '?'),
 ('\0ή;d<N?', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_room_service_24px.svg', 0, '$!Mk(', '$!Mk(', '?ڹi&uV\'C\rGTEZ\"', '', 0, '?'),
 ('?6(\0&l0ϰ', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_smoke_free_24px.svg', 0, 'cyʂNdf', 'cyʂNdf', '{NKVg⋭4]+\'0絏', '', 0, '?'),
 ('ϰ\r$QJL2AE', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_smoking_rooms_24px.svg', 0, 'Jt5|LGU', 'Jt5|LGU', 'ֺ6sa[3(]AH$25w0', '', 0, '?'),
 ('~RCھ<]', 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_spa_24px.svg', 0, '\\it}]G䄟(', '\\it}]G䄟(', '51YxY=ICSx(', '', 0, '?'),
 ('l<K[', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_cake_24px.svg', 0, '&m\ZF:>2O`\\', '&m\ZF:>2O`\\', 'a3kWSAM\\3^ƹH', '', 0, '?'),
 ('9ÒfxO@x', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_domain_24px.svg', 0, '!lIWH<Y', '!lIWH<Y', 'n@q=ТA]VJRՖҷM%yA', '', 0, '?'),
 ('ʦuSG(B', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_group_24px.svg', 0, 'LbshGn ', 'LbshGn ', 'Pe[FyƟ6VQwW^', '', 0, '?'),
 ('3#xDi', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_group_add_24px.svg', 0, '\\c:p', '\\c:p', 'o7ہnH&K>P@~\'!DKSRƇ', '', 0, '?'),
 ('SV˯Pv', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_location_city_24px.svg', 0, '` BGNYh:O', '` BGNYh:O', ' ß>6K\\ֲ~H˿Xgf', '', 0, '?'),
 ('6m\\*ݦ', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_mood_24px.svg', 0, 'l!qM+x k-', 'l!qM+x k-', '\0ꧤ^vޕO͍rr0#t', '', 0, '?'),
 ('!yW>:\0?zX6a_', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_mood_bad_24px.svg', 0, 'ƫPff\'', 'ƫPff\'', '%Z06HJr#ͩ\\jOUíw', '', 0, '?'),
 ('C?\Zw=̗O/g7', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_24px.svg', 0, 'R](w٧n', 'R](w٧n', 'eo>yg\\PK34+we\0', '', 0, '?'),
 (':k1I', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_active_24px.svg', 0, ' *g)d', ' *g)d', ']p46,.VM~=n-\'', '', 0, '?'),
 ('S?|ѿ', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_none_24px.svg', 0, '\\=.>VB|\Z', '\\=.>VB|\Z', '\\\\3N1Ka,+?Wʋ\0', '', 0, '?'),
 (';7C+߱', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_off_24px.svg', 0, 'yOi.u.>', 'yOi.u.>', '$ZpyfNOGN@c', '', 0, '?'),
 ('w:Z&?\Z6v', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_paused_24px.svg', 0, 'k]gGHv+', 'k]gGHv+', '5TLykzLc6	!Nެ\",Ӹ', '', 0, '?'),
 ('\ZzX8NDi', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_pages_24px.svg', 0, 'H֑\"Xo3S	', 'H֑\"Xo3S	', 'uY*DS6/#\r{gDm d\0', '', 0, '?'),
 ('U(νT扰qc', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_party_mode_24px.svg', 0, '0^0', '0^0', 'VV%oHKմYL', '', 0, '?'),
 ('>;ph.t$\r', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_people_24px.svg', 0, 'LbshGn ', 'LbshGn ', 'Pe[FyƟ6VQwW^', '', 0, '?'),
 ('S\na%&DΉ$', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_people_outline_24px.svg', 0, ',:,^BVm', ',:,^BVm', 'Uԋhy0F9zUp| ij\0', '', 0, '?'),
 ('LS\r\n$', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_person_24px.svg', 0, 'mxn]}0mW', 'mxn]}0mW', 'G#nk\'RMm+\02,', '', 0, '?'),
 ('%hZ', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_person_add_24px.svg', 0, '\\*s2*I', '\\*s2*I', 'ڵ8-Jaˑ}%Qk', '', 0, '?'),
 ('C2EWZJZ', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_person_outline_24px.svg', 0, '@Ĥu@u\\', '@Ĥu@u\\', 'uك#spO_=NAbmt6', '', 0, '?'),
 ('<bfl~$Q', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_plus_one_24px.svg', 0, 'awަiH', 'awަiH', '\r	fL`*:NB!*3gg', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('oG$Wbw', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_poll_24px.svg', 0, '*5\":(;7+', '*5\":(;7+', 'aO;L;_)~ԍ?ഥ:', '', 0, '?'),
 ('AN%cؚS\n', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_public_24px.svg', 0, '٩CC*Ty;', '٩CC*Ty;', 'pRZJ%Q)_8b1(', '', 0, '?'),
 ('*r\\H25WdV4b', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_school_24px.svg', 0, 'v {_([', 'v {_([', 's孹`	N~8҃˅	\noQ', '', 0, '?'),
 ('hT֢I1;', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_share_24px.svg', 0, 'D}	#;>iQ', 'D}	#;>iQ', 'IMݻtOϓzOeO\ZzIP', '', 0, '?'),
 ('hy2Fĉoz`8E', 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_whatshot_24px.svg', 0, '4,8cc+J', '4,8cc+J', '2_Moe,83Nv3H!', '', 0, '?'),
 (']A?<', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_check_box_24px.svg', 0, 'R89\0v', 'R89\0v', 'n߈TcQF/YOΙGđ', '', 0, '?'),
 ('6\0?j?o/m', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_check_box_outline_blank_24px.svg', 0, 'b!\nd\ZH@', 'b!\nd\ZH@', 'f	9`c-xd+.v{\'', '', 0, '?'),
 (';bja|@M (`', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_indeterminate_check_box_24px.svg', 0, 'Oq%yEIfc', 'Oq%yEIfc', '/mήpU&ֺ~qqW', '', 0, '?'),
 ('pfȃ~Jk߽|', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_radio_button_checked_24px.svg', 0, '/$O\\FДcRGk', '/$O\\FДcRGk', '$lP6֗\"sxN1EX6	0 ', '', 0, '?'),
 (' 0KM}z', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_radio_button_unchecked_24px.svg', 0, 'BWVYC>\n\"U', 'BWVYC>\n\"U', 'c&xO|ޛcaibg=w|5', '', 0, '?'),
 ('w*j%(', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_star_24px.svg', 0, '<M7Ty~OJio', '<M7Ty~OJio', 'ͨigΐgOx8lĵ', '', 0, '?'),
 ('Ϥ)r;\"/RD50', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_star_border_24px.svg', 0, 'Z^(D1', 'Z^(D1', 'ijN*7dt5ِ#+,\0\"', '', 0, '?'),
 ('<]MVU', 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_star_half_24px.svg', 0, 'b ~?ZY', 'b ~?ZY', '\ZP8đCdy~({2Q', '', 0, '?'),
 ('Jcnaj4П o', 'wp-content/plugins/revslider/public/assets/css/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('G>DsȤ\0', 'wp-content/plugins/revslider/public/assets/fonts/font-awesome/fonts/fontawesome-webfont.svg', 0, '.murI1G', '.murI1G', 'Lr7D@yɂ]NK(tiG9Tm=', '', 0, '?'),
 ('0\'`c2_', 'wp-content/plugins/revslider/public/assets/fonts/font-awesome/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('ֵȫX7qc\Z>', 'wp-content/plugins/revslider/public/assets/fonts/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('x\nPL50]*', 'wp-content/plugins/revslider/public/assets/fonts/material/MaterialIcons-Regular.svg', 0, 'eYLP/(:', 'eYLP/(:', '坴YCN:Q9kdZkxO', '', 0, '?'),
 ('0q@G6k', 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/css/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('14J<okXj', 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.svg', 0, '&x<fJ`Ml', '&x<fJ`Ml', '7oϲ`w!=FJ ]Ү²', '', 0, '?'),
 ('KXsS>d', 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('U\ZDȫ΃<[', 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('Ó]ɚdQv', 'wp-content/plugins/revslider/public/assets/fonts/revicons/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('`<6V޾	9{', 'wp-content/plugins/revslider/public/assets/fonts/revicons/revicons.svg', 0, 'BT }9O', 'BT }9O', ',:4^a{rrC\":9\"n*', '', 0, '?'),
 ('<*1%GɫV9)', 'wp-content/plugins/revslider/public/assets/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('\nhjfm8:c', 'wp-content/plugins/revslider/public/assets/js/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('*|Cݩ 9N\0Q~', 'wp-content/plugins/revslider/public/assets/js/rbtools.min.js', 0, 'wwoOpz]nX', 'wwoOpz]nX', '%[a*ky6)6ߨ?̇', '', 0, '?'),
 ('9َ3	SbP', 'wp-content/plugins/revslider/public/assets/js/rs6.min.js', 0, 's8Pv', 's8Pv', 'mzj)5Yu\Zz,D;\"0X', '', 0, '?'),
 (',3I!<]d', 'wp-content/plugins/revslider/public/includes/functions-public.class.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('l4Z\\X', 'wp-content/plugins/revslider/public/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('Tw͔\n4Ó0', 'wp-content/plugins/revslider/public/revslider-front.class.php', 0, 'jz(ߴH=:,', 'jz(ߴH=:,', 'ܙX\rKܚm[D1u', '', 0, '?'),
 ('|6ի\ZM%p', 'wp-content/plugins/revslider/public/views/revslider-page-template.php', 0, 'Hw[<P|V', 'Hw[<P|V', '\\JgKnd&S盛2|w)^%kVΜR', '', 0, '?'),
 ('O\\)3P54', 'wp-content/plugins/revslider/release_log.html', 0, '?x^Yx', '?x^Yx', 'E1̑53d]8[.|V', '', 0, '?'),
 ('f2|b5֤', 'wp-content/plugins/revslider/revslider.php', 0, '>?\0ЋêAB', '>?\0ЋêAB', 'XT^L\nnB;Rch=', '', 0, '?'),
 ('6\Z#iW?T=', 'wp-content/plugins/revslider/uninstall.php', 0, 'ﵯM\"{@]q(', 'ﵯM\"{@]q(', '(5\rHq\n-wWci{k,{', '', 0, '?'),
 ('8!KWt', 'wp-content/plugins/revslider/welcome.html', 0, '!ֳUS|vӂ', '!ֳUS|vӂ', 'aU1gն\Zɓmn', '', 0, '?'),
 ('%hBAA~)t', 'wp-content/plugins/updraftplus/admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '((6hIys', 'pgoO+u_t\'N?ma^\r', '', 0, '?'),
 ('_IxF', 'wp-content/plugins/updraftplus/backup.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ޣ(% PY?H', 'Q[Q@jX,b6Vڀ', '', 0, '?'),
 ('W>i=k+', 'wp-content/plugins/updraftplus/central/bootstrap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DPa\rtAxx', ']SB`z>M׮+-~%8 +)Td', '', 0, '?'),
 ('lꌘb;W4R', 'wp-content/plugins/updraftplus/central/classes/automatic-upgrader-skin-compatibility.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ɼUŬ)@', ';BYB`z\'i	hIv}jG', '', 0, '?'),
 ('_)q!|cH', 'wp-content/plugins/updraftplus/central/classes/class-automatic-upgrader-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z\r<7DJ,Z', 'უNW0spZAV1[hq^', '', 0, '?'),
 ('`Hpֈn\'!г', 'wp-content/plugins/updraftplus/central/commands.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0K_W#', 'ȫ|gjًM>2rl', '', 0, '?'),
 ('Ṩ\n-Mu/$Al', 'wp-content/plugins/updraftplus/central/listener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W/71?J', 'W{R{<1aVh7SIck,G', '', 0, '?'),
 ('`(5w!O', 'wp-content/plugins/updraftplus/central/modules/analytics.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X\'x3q', 'Lj64E42dp\Z{쯂', '', 0, '?'),
 ('rN+ĩ#3W', 'wp-content/plugins/updraftplus/central/modules/comments.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'US\r1Ff', ':+u[i@$', '', 0, '?'),
 ('gm P	Yޞ\r', 'wp-content/plugins/updraftplus/central/modules/core.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L(q(\02yyv', 'Z#@.;xnRt׷Ii3bk', '', 0, '?'),
 ('a{3=a', 'wp-content/plugins/updraftplus/central/modules/media.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x1G׏R', 'pO]!Kh^NeCGԕJ[*fI-', '', 0, '?'),
 ('~ZdS3\rR', 'wp-content/plugins/updraftplus/central/modules/plugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'otƫHk濁', '_n#مO6\Zxf~?\'', '', 0, '?'),
 ('<p0rRJ', 'wp-content/plugins/updraftplus/central/modules/posts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yp:f e*+\n', 'RmH4=Fy3/t̹', '', 0, '?'),
 ('#IyZ%tl:\0F', 'wp-content/plugins/updraftplus/central/modules/theme.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']Ad=K', 'p(6-z>F+Mޠ,}q#', '', 0, '?'),
 (',\"\\$-h?y@\\', 'wp-content/plugins/updraftplus/central/modules/updates.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';n!I@{2', '`1SR!S}XRF', '', 0, '?'),
 ('6ōxU', 'wp-content/plugins/updraftplus/central/modules/users.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wv\'H:jP', 'Ex$m${u&$;f', '', 0, '?'),
 ('ʆ\n>P7\"', 'wp-content/plugins/updraftplus/changelog.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Dj\'uЕ', 'qsĺ,s\Z4nJzaM2+lVZpzB', '', 0, '?'),
 ('h}Mv1\ZQlO', 'wp-content/plugins/updraftplus/class-updraftplus.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wĴ4I0<*', 'H\n&\0Lڂ|-:;\\PuTg', '', 0, '?'),
 ('t& #ıwJ', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-fix.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^=$(d#f', 'Rxʛk\ZoR&Ċ\0Pr)u#', '', 0, '?'),
 ('6<c)!c', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-fix.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7bK-Uvk', 'IfWVBA	\0zZ:K', '', 0, '?'),
 ('d4ِJtP5	nh', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-plain-buttons.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm|,>.˞P@', '`#pUfH@eam/KE7B3ł', '', 0, '?'),
 ('䀹SL_+p9', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-plain-buttons.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x24S[Cq', 'O]DHvN>u޾_7', '', 0, '?'),
 ('%H[ѥ|׊', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yLZX\Z', 'ٲBv,42b-2	>+{P;Y', '', 0, '?'),
 ('ьp#o\04\0', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sr3%2\Z%', 'rU*sp\n$(bGPd', '', 0, '?'),
 ('W62', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-dark.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?Yi9Xp', '9u5ʮd^3,F5Z뼳=', '', 0, '?'),
 ('Pdק!\0', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-dark.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R%[)tlU?/', 'r>KhH@XU7o+<BKIS', '', 0, '?'),
 ('bM^', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-default.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ՂNڃ$', 'G!Ƕ[\"pbaQ', '', 0, '?'),
 (';\Zͥ', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-default.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0zoYרEP|', '@f{<qM`\'\"5?EZi}m-', '', 0, '?'),
 ('Yߍ3Ac\r', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square-dark.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ѫd!f7|', 'jZt@b\\$f+}7@', '', 0, '?'),
 ('\\L6OAfW7l', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square-dark.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'הLhRx', '!2[^{W9wDi	?.E', '', 0, '?'),
 ('u\\6@gI+H.', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0nXJKw', ':vqR번ZZT#', '', 0, '?'),
 ('A^򓱝P3k', 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"(!#_,', '3W4EsWou0JW', '', 0, '?'),
 ('j2#I', 'wp-content/plugins/updraftplus/css/updraftplus-admin.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q$#fv)', 'e~Tod]Zaj\r7H', '', 0, '?'),
 ('ԎB\"Z1?', 'wp-content/plugins/updraftplus/css/updraftplus-admin.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|JFYP^', '`|\ZOm92MI$R=kY8D', '', 0, '?'),
 ('_?X\"D1GU\nA', 'wp-content/plugins/updraftplus/css/updraftplus-admin.min.css.map', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Rqy(-M', '~NYNm8xIP\r', '', 0, '?'),
 ('\\hRSC8', 'wp-content/plugins/updraftplus/css/updraftplus-notices.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's |f.~C', 'z8A!༂9ݫYG\Z ', '', 0, '?'),
 ('C&ģl\rjg|2', 'wp-content/plugins/updraftplus/css/updraftplus-notices.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/٬|b3;', '$6R^D\nzݒf{o͕TI(', '', 0, '?'),
 ('X1i[', 'wp-content/plugins/updraftplus/css/updraftplus-notices.min.css.map', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n@`gT{L	', '}re\n;8L}W%<xK#', '', 0, '?'),
 ('ȭᎣJׯ\0', 'wp-content/plugins/updraftplus/css/updraftplus-tour.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SVm:S@UI[', 'p0dqI F\"ϰԺ\nw', '', 0, '?'),
 ('><Kܰđ\0\r', 'wp-content/plugins/updraftplus/css/updraftplus-tour.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K6;L*\nΌ', '2d01II2<֢	=V0', '', 0, '?'),
 ('K\'\Zfw>', 'wp-content/plugins/updraftplus/css/updraftplus-tour.min.css.map', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&Ɖ1|0ou', '3!c\\~0*ǀ6	C', '', 0, '?'),
 ('E]Z', 'wp-content/plugins/updraftplus/css/updraftplus-tour.scss', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'amٗB衙je', 'D텏#\\bqxų۽g/s', '', 0, '?'),
 ('q,<wLG\"E', 'wp-content/plugins/updraftplus/example-decrypt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U8d#:#', 'iM,;-4)yͼj5w', '', 0, '?'),
 ('^qg`oZ', 'wp-content/plugins/updraftplus/images/addons-images/all.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0PfΘ', '}/WBQ1:~ x~ n $', '', 0, '?'),
 ('6˧i\'9', 'wp-content/plugins/updraftplus/images/addons-images/autobackup.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+tnjK', '-gvA>Es]Jzt', '', 0, '?'),
 ('<_(=^r', 'wp-content/plugins/updraftplus/images/addons-images/azure.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tYקe{SD', '1vof8MRX>+*}	+r', '', 0, '?'),
 ('^S', 'wp-content/plugins/updraftplus/images/addons-images/backblaze.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƫT2MВ', '?LT0ޓ\nh+', '', 0, '?'),
 ('[0{B&^', 'wp-content/plugins/updraftplus/images/addons-images/cloudfiles-enhanced.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ph@$Wv', 'Um\ZA.F+xn(A', '', 0, '?'),
 ('\Z}̪-K\0H', 'wp-content/plugins/updraftplus/images/addons-images/dropbox-folders.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',JAx?F4(', '(W1r	%sYV-x2y(ހ', '', 0, '?'),
 ('GpF:', 'wp-content/plugins/updraftplus/images/addons-images/fixtime.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?P^б 8nQLm', '|@ЌC-D?^ 1[?O<', '', 0, '?'),
 ('C>hZ8N`ya', 'wp-content/plugins/updraftplus/images/addons-images/google-enhanced.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W~p㙲', 'EvH:pGʦT[9ӣ\"7w6', '', 0, '?'),
 ('0H\\6{옙Z', 'wp-content/plugins/updraftplus/images/addons-images/googlecloud.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'cf{=E', 'yAZ82i^<ϝ{V\rE[!7U\\', '', 0, '?'),
 ('Dpi.', 'wp-content/plugins/updraftplus/images/addons-images/importer.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2upg{!	', 'zth5S?z\'Mt1zֆ\\[', '', 0, '?'),
 ('IűYm', 'wp-content/plugins/updraftplus/images/addons-images/incremental.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WگĊnNLt', 'v\\z\"|gz\0դw+$<P', '', 0, '?'),
 ('({,*q7%B(', 'wp-content/plugins/updraftplus/images/addons-images/lockadmin.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm\\˃J{]', 'PוLXwV	J<EPƦp', '', 0, '?'),
 ('Yg7$B[-', 'wp-content/plugins/updraftplus/images/addons-images/migrator.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>^]\"\" ^@', 'F52:҃{PQ5.)}z\0	w', '', 0, '?'),
 (')#`5t1Si', 'wp-content/plugins/updraftplus/images/addons-images/moredatabase.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/a!\\-H=k1M', '\"$}\']lAwK셳Ms=\ZDT[', '', 0, '?'),
 ('xa1[9~3@Z', 'wp-content/plugins/updraftplus/images/addons-images/morefiles.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V@ug', 'VB{6O	`', '', 0, '?'),
 ('{@DkFJGno	', 'wp-content/plugins/updraftplus/images/addons-images/morestorage.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qP', '&G4 8#+u^Ɣ#dHXa$', '', 0, '?'),
 ('?C^Gв', 'wp-content/plugins/updraftplus/images/addons-images/multisite.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j\0;>;JH-', 'ZH9+dvW,1FK', '', 0, '?'),
 ('٦y&^A', 'wp-content/plugins/updraftplus/images/addons-images/noadverts.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+40*R', 'pK8A*{m C<^	%ǣ6D0Ո', '', 0, '?'),
 ('43_K60', 'wp-content/plugins/updraftplus/images/addons-images/onedrive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O\" ÆhO	', '(aF_N\\R4j(s0A^W', '', 0, '?'),
 ('Nkw5n.Mm-X', 'wp-content/plugins/updraftplus/images/addons-images/reporting.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ASΤ%d', 'Wª&i;2v666MM', '', 0, '?'),
 ('h\"ϼ!&\\8', 'wp-content/plugins/updraftplus/images/addons-images/s3-enhanced.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V`HH.ܱ$|\'u', 'D\0@\Zϓ\\Z<?\'Tf8w', '', 0, '?'),
 (' \'Dyl0&*G', 'wp-content/plugins/updraftplus/images/addons-images/sftp.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(0凓9Yua:ܮ', 'g6F-\'1P]07i.P\'', '', 0, '?'),
 (',N4bp!', 'wp-content/plugins/updraftplus/images/addons-images/webdav.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AR,|K?', 'bEf]&Z\nH͙B	H>@7lYx(n', '', 0, '?'),
 ('>DR&Qiޡ', 'wp-content/plugins/updraftplus/images/addons-images/wp-cli.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n6g@!]', 'T6yZ˫e4@P[\nLM', '', 0, '?'),
 ('˥BmNi', 'wp-content/plugins/updraftplus/images/automaticbackup.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+tnjK', '-gvA>Es]Jzt', '', 0, '?'),
 ('u\0 J\"Y\\0\r:', 'wp-content/plugins/updraftplus/images/aws_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '85q.$y', '>t+FrZ&!/U^Ye>Y}', '', 0, '?'),
 ('ɯbd', 'wp-content/plugins/updraftplus/images/azure.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5ֱxgY', 'YS~8_\ZI|_5(6ມ', '', 0, '?'),
 ('Vt4axƄXϫf\n', 'wp-content/plugins/updraftplus/images/backblaze.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z]wm@|', 'k6%V$qu;\ZSG{', '', 0, '?'),
 ('J/I', 'wp-content/plugins/updraftplus/images/dashicon.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vlcaf', '|Zu<$(\Z&Dҡ&', '', 0, '?'),
 ('N-g<-w\ZEV', 'wp-content/plugins/updraftplus/images/dreamobjects_logo-horiz-2013.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.\ZwJ뙧@E:/', 'iAGƇ/18V|ZC+<', '', 0, '?'),
 ('}@$B:^', 'wp-content/plugins/updraftplus/images/dropbox-logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zG0>o', ',\np\ZJVįsEA gƈ', '', 0, '?'),
 ('x{Α\"^a6\r', 'wp-content/plugins/updraftplus/images/googlecloud.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Af\0L X&', '0EzBʣZ<KL8u`۶Jo', '', 0, '?'),
 ('|9-5\Z3 r', 'wp-content/plugins/updraftplus/images/googledrive_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'\Z_|9', 'ca\Zq=@OwF^1[', '', 0, '?'),
 ('hf\'2ӔUw', 'wp-content/plugins/updraftplus/images/icons/azure.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r~I>	iX*', ':fxu%oXw|ipӯc|#j', '', 0, '?'),
 ('`\Z0>ll', 'wp-content/plugins/updraftplus/images/icons/backblaze.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"Ws}zs', 'rN3\\PA\nv*5@ZF', '', 0, '?'),
 ('V5̮Cn', 'wp-content/plugins/updraftplus/images/icons/cloudfiles.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'\ryzj,lg\nn', '#ۀuc\ZC_`?a', '', 0, '?'),
 ('i[{', 'wp-content/plugins/updraftplus/images/icons/dreamobjects.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b9扷G%2^~', '-\'vɈn5kw]#ƾV[', '', 0, '?'),
 ('_-ݧ.\Z', 'wp-content/plugins/updraftplus/images/icons/dropbox.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '٘0Ex31?]', 's2o\ZB/uGA;\"mVŊL[', '', 0, '?'),
 ('ԿepZɟy', 'wp-content/plugins/updraftplus/images/icons/email.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E.cKo|s-', '٭\Zq]^A\nba9ZPmuL%wH', '', 0, '?'),
 ('S!wnN7M)m]e', 'wp-content/plugins/updraftplus/images/icons/folder.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h\0!T<\ZA^0', '3QAr(}l藪6\"|lL@', '', 0, '?'),
 ('8 wa5', 'wp-content/plugins/updraftplus/images/icons/googlecloud.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VJVQYJa?', 'dk\'\0H-L裷b7|a팠^', '', 0, '?'),
 ('`0Vm=Yc', 'wp-content/plugins/updraftplus/images/icons/googledrive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6:\022m=v', '4||	+R\'=Ci|}n', '', 0, '?'),
 ('y}&iZL5֘\0(', 'wp-content/plugins/updraftplus/images/icons/lock.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n\nS*qEGa', '(,6a[|gӠ^voA\Z-', '', 0, '?'),
 ('e&@j\0', 'wp-content/plugins/updraftplus/images/icons/onedrive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\LMl흜Z]\'', 'z߄(e/ThRDm\Z7', '', 0, '?'),
 ('#=gA-j<k\\', 'wp-content/plugins/updraftplus/images/icons/openstack.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DnR$	H`', 't6~\02*By=}', '', 0, '?'),
 ('[r M_A7O', 'wp-content/plugins/updraftplus/images/icons/s3.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zč?7!G', '\ZLr&>e`\rZo x6', '', 0, '?'),
 ('m +7f\">)', 'wp-content/plugins/updraftplus/images/icons/updraftvault.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A	RʂD,d', 'W\Z𖽪R^xǧpꝍS3\ZU', '', 0, '?'),
 ('}gWcX]OY', 'wp-content/plugins/updraftplus/images/icons/webdav.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rd(>', 'ϡ\n-eSWd[@2-/U', '', 0, '?'),
 ('gSQ>썀0m', 'wp-content/plugins/updraftplus/images/notices/black_friday.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Pc(0w', '/aj/39/J,J^AbB', '', 0, '?'),
 (')q:x', 'wp-content/plugins/updraftplus/images/notices/christmas.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '௤]\\2E_4', 'pJL7w}߃b&^', '', 0, '?'),
 ('bjwʜT\0', 'wp-content/plugins/updraftplus/images/notices/keyy_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	\"o)W/', '(i.ثo?bFCEvwK', '', 0, '?'),
 ('Zj?`9Plu', 'wp-content/plugins/updraftplus/images/notices/locksettings.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm\\˃J{]', 'PוLXwV	J<EPƦp', '', 0, '?'),
 ('\Z\nU;eLɝ3n', 'wp-content/plugins/updraftplus/images/notices/metaslider_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8zr<ڮZӱ', 'hY6\r;M@6YMT\Z8	(', '', 0, '?'),
 ('6M*ߛƮ', 'wp-content/plugins/updraftplus/images/notices/new_year.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=uNwta^\r0', 'ri!2Z:djvt~q', '', 0, '?'),
 ('u>RP]', 'wp-content/plugins/updraftplus/images/notices/reporting.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ASΤ%d', 'Wª&i;2v666MM', '', 0, '?'),
 ('i\'}\r`~4', 'wp-content/plugins/updraftplus/images/notices/spring.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/#ZxFe^', 'h%?dd;\"^5', '', 0, '?'),
 ('h~\\@0M5YH', 'wp-content/plugins/updraftplus/images/notices/summer.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TBE\r', 'd,=>alxƩU6y', '', 0, '?'),
 ('\ngbxDe57', 'wp-content/plugins/updraftplus/images/notices/support.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aQLwצ?', '߯i\0a1)+#_x_', '', 0, '?'),
 ('^`h>!#17cE', 'wp-content/plugins/updraftplus/images/notices/updraft_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݲetޡ½6', '(Xv\06vU+gj{\"3', '', 0, '?'),
 ('o8$v3;4㾦', 'wp-content/plugins/updraftplus/images/notices/wp_optimize_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qdBnR˶\0w', '!*ug{IpGL>W\"VR׶r', '', 0, '?'),
 (']d5TPt\\', 'wp-content/plugins/updraftplus/images/onedrive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Mz8J$g˱', 'tnJ6tC\"}JZY', '', 0, '?'),
 ('pwÃ1D	5', 'wp-content/plugins/updraftplus/images/other-plugins/keyy.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2Wl0Tʜ', ':8ȎHr#\"Qg>DHbAp', '', 0, '?'),
 ('ߙ?uE8', 'wp-content/plugins/updraftplus/images/other-plugins/meta-slider.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}sۜWn3$', '0c/ABo딱a^%	j9$_^', '', 0, '?'),
 ('\\ՙ\\z~c궛', 'wp-content/plugins/updraftplus/images/other-plugins/updraft-central.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"RPWh!ka', '\r܌ЍQ+<bBH`U\ZJ\0	', '', 0, '?'),
 ('iS.߬_?UZ6', 'wp-content/plugins/updraftplus/images/other-plugins/wp-optimize.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1N>W K~', 'P8c1m@?w(k[R', '', 0, '?'),
 ('W]}$SK\"N6', 'wp-content/plugins/updraftplus/images/padlock-150.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G\\&_{}[', 'S\Zzw%Dj^vIq', '', 0, '?'),
 ('M#|(R;', 'wp-content/plugins/updraftplus/images/rackspacecloud-logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b7[ ]', 'xDp֐a\'BjESm|', '', 0, '?'),
 ('g\'kJ\n', 'wp-content/plugins/updraftplus/images/ud-logo-150.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SҬTd6uP', '˽1D4HH	[Y', '', 0, '?'),
 ('j	eo*', 'wp-content/plugins/updraftplus/images/ud-logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CjMѓ\'ː\\', 'wyB1btW\"l%t)Qp,Jb.', '', 0, '?'),
 ('udVN;<f|OG', 'wp-content/plugins/updraftplus/images/udlogo-rotating.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':Z]zG2ІhG.,', '7eBKKj18T(#x -f', '', 0, '?'),
 ('rQ}SD5%Ar ', 'wp-content/plugins/updraftplus/images/udp-logo-white.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ot#,\\~g', '|0g<Z\\>:\\L;Lh', '', 0, '?'),
 ('%]:QQ|obP', 'wp-content/plugins/updraftplus/images/updraft_central_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' (?O7Id ', '\0K\'UV\\L&KU5RRp', '', 0, '?'),
 ('P+jR', 'wp-content/plugins/updraftplus/images/updraft_cross.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a/=dW`[?', '%zJQvY^ O4@FhHwP', '', 0, '?'),
 ('+H:RȊKM', 'wp-content/plugins/updraftplus/images/updraft_freev.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~I+b$\0~[A~{+', 'gT8FԴIS}?\0[A', '', 0, '?'),
 ('V>-23y', 'wp-content/plugins/updraftplus/images/updraft_premv.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2 ]Fx\"', 'o&j\"Yu<r\0lK0J', '', 0, '?'),
 ('D>[a}RO', 'wp-content/plugins/updraftplus/images/updraft_tick.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7u{/=$\nhK', '|UȡR\"#)1]@h0~|?', '', 0, '?'),
 ('r=;ٞ{', 'wp-content/plugins/updraftplus/images/updraft_vault_logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K+sBn6\r', 's(Y\06;qZ$S5$l:q', '', 0, '?'),
 ('x|McB+@ЩwKT', 'wp-content/plugins/updraftplus/images/updraftcentral_cloud.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j\0;>;JH-', 'ZH9+dvW,1FK', '', 0, '?'),
 ('7%Nrm', 'wp-content/plugins/updraftplus/images/updraftclone_logo_white.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T*65\nj3\Z_', '0PZ?fAStiB*o-3', '', 0, '?'),
 ('һ_\"sŤ\rF!', 'wp-content/plugins/updraftplus/images/updraftvault-150.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';\\VbXç', ',{[N%iTr>#kٸEhu', '', 0, '?'),
 ('\nCMfDu', 'wp-content/plugins/updraftplus/images/upraftplus-clone-screenshot.jpg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';OWӳjW', '	ɠh;GiBs\n', '', 0, '?'),
 ('Kmr.Dŧ\\}', 'wp-content/plugins/updraftplus/includes/Dropbox2/API.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '45&U{t=', 'q.ƚ,y:8[zj\'', '', 0, '?'),
 ('i?!,j4', 'wp-content/plugins/updraftplus/includes/Dropbox2/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U$af*on', 's%Ծ;-JǼ/p f', '', 0, '?'),
 ('Cv4', 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Consumer/ConsumerAbstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dy\0^\"=', 's.N%	k\rlG!<QH#g:S', '', 0, '?'),
 ('df\")=6b', 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Consumer/Curl.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bE!!i<', 'R5}%NxT\03/okrc<G', '', 0, '?'),
 ('EN#CĴ.3', 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Consumer/WordPress.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'syqFWT\rҮ', 'Ēܠ5T.:{\Zk[Ze~', '', 0, '?'),
 ('ܷJL>#', 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Storage/Encrypter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j}Ӹ=EV5\0', 'VLaAQ#`1w\ZnRI	nLaz', '', 0, '?'),
 ('V,յ', 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Storage/StorageInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Wb\\9', 'zQz=UZjD9', '', 0, '?'),
 ('\n|ˬӜcj`{', 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Storage/WordPress.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q,S볘ր!', '*7^b_(åv#f{	&', '', 0, '?'),
 ('\\X\r:l]@H7', 'wp-content/plugins/updraftplus/includes/Google/Auth/Abstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']r31Vp=', 'oȉϵ>\Z&!:', '', 0, '?'),
 ('23Qۿ-4', 'wp-content/plugins/updraftplus/includes/Google/Auth/AppIdentity.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e\n	jwեM0', '<L3ojP̲Ƴ/`P@u$OC(', '', 0, '?'),
 ('|iHr', 'wp-content/plugins/updraftplus/includes/Google/Auth/AssertionCredentials.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2|va=ϧ]޼', '\\\0\Z@ږޕq+PǮg', '', 0, '?'),
 ('eӐD\"\\', 'wp-content/plugins/updraftplus/includes/Google/Auth/ComputeEngine.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HLʘXs)r', 'A|9vqBN-2Uxa', '', 0, '?'),
 ('*\rh}h(', 'wp-content/plugins/updraftplus/includes/Google/Auth/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(^A+ Cr', 'of#+{0_06hYTZ5N6', '', 0, '?'),
 ('yk_Uk,e=', 'wp-content/plugins/updraftplus/includes/Google/Auth/LoginTicket.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!+\\)3a\nc', '#Plݔ|-<$LsQP6DU-', '', 0, '?'),
 ('`%ֆY', 'wp-content/plugins/updraftplus/includes/Google/Auth/OAuth2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';z*N4냗Ʉw@', 'Ɵǃum<5HGI/;9kxO/ٛ', '', 0, '?'),
 ('q8', 'wp-content/plugins/updraftplus/includes/Google/Auth/Simple.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Phx3X\"6', ' UÜ+Pb-\\@sc?#q;kr', '', 0, '?'),
 ('2$$K&fw ݪ', 'wp-content/plugins/updraftplus/includes/Google/Cache/Abstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0]\'9w', ';DK[#3&W<ԏzAQ$x', '', 0, '?'),
 ('Ys\\\nd', 'wp-content/plugins/updraftplus/includes/Google/Cache/Apc.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JY^V*JǱ^', 'w;QQ3[oZWvtiVI?', '', 0, '?'),
 ('\na08', 'wp-content/plugins/updraftplus/includes/Google/Cache/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ur*vOxqf', 'KW4&]atpGh\r圫', '', 0, '?'),
 ('yAoډ', 'wp-content/plugins/updraftplus/includes/Google/Cache/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VQ~l<$T', '$tE\0HBeCӫ2J:W', '', 0, '?'),
 ('bl	-vr$L8', 'wp-content/plugins/updraftplus/includes/Google/Cache/Memcache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SG5ޏ}r+', 't!{y	 ]bF6\0ȯdyȤy', '', 0, '?'),
 ('M1	Zg&\'ѫ', 'wp-content/plugins/updraftplus/includes/Google/Cache/Null.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TpF8\'٫Ƌ', '巧?|ap4x`ȷ,yP%\r3', '', 0, '?'),
 ('n/Ρ~Zx~6', 'wp-content/plugins/updraftplus/includes/Google/Client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?mHoA', 'k_3;L?.M1}SH`!', '', 0, '?'),
 ('}Ob >?2y', 'wp-content/plugins/updraftplus/includes/Google/Collection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y6x5Mq', '5́2|TR/nw*Җ', '', 0, '?'),
 (' uFPjkq=k', 'wp-content/plugins/updraftplus/includes/Google/Config.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l!W8աRM]', 'm#:hWw45:C+*N:', '', 0, '?'),
 ('6\"ג', 'wp-content/plugins/updraftplus/includes/Google/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ZK/', 'Ʒ-)۵إz9Ip*#I	', '', 0, '?'),
 ('}ġ\"Zѝ\'', 'wp-content/plugins/updraftplus/includes/Google/Http/Batch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5kkL&ވ', 'Uѕ+fz:*]b', '', 0, '?'),
 ('ixE@VE\"', 'wp-content/plugins/updraftplus/includes/Google/Http/CacheParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wOT| th$x', 'ȾWp*;zJW{]ilc', '', 0, '?'),
 ('#SVպ', 'wp-content/plugins/updraftplus/includes/Google/Http/MediaFileUpload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7gm)0U', 'Z]TV{!?u`gD&L&', '', 0, '?'),
 ('ZfZS#T', 'wp-content/plugins/updraftplus/includes/Google/Http/REST.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nk>,fې-', 'gS,$O\"jO\\wAMެ~', '', 0, '?'),
 ('uGP3*xOӍe', 'wp-content/plugins/updraftplus/includes/Google/Http/Request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wc,&0;d', 'Ǟ]UGi\\4\Z\'Xi2d', '', 0, '?'),
 ('AT{nN]', 'wp-content/plugins/updraftplus/includes/Google/IO/Abstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';QJ ?`?$2r 8', 'C	gG[|6Up=BQX[t$', '', 0, '?'),
 ('OHB{(', 'wp-content/plugins/updraftplus/includes/Google/IO/Curl.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<jf#-X', 'P7aV%~zk1cb', '', 0, '?'),
 ('WԾޥ9)', 'wp-content/plugins/updraftplus/includes/Google/IO/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7԰-}6', 'E\'`ߢ\rh%oקD1', '', 0, '?'),
 ('2WEbeYYi', 'wp-content/plugins/updraftplus/includes/Google/IO/Stream.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n\\<@ ', 'gehWȕĜw}/SPĺuy!', '', 0, '?'),
 ('8QIf', 'wp-content/plugins/updraftplus/includes/Google/IO/cacerts.pem', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'>qGYٖCd1', 'E4ab`\0)Ui(@ψ[;', '', 0, '?'),
 ('0߁.8n4k_M', 'wp-content/plugins/updraftplus/includes/Google/Logger/Abstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rc9]q)', 'i\"ڲM,\'PC', '', 0, '?'),
 ('odeZ', 'wp-content/plugins/updraftplus/includes/Google/Logger/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'þ?P||0r', 'Q%ֱȣ6j$S%2cJ', '', 0, '?'),
 ('XUqn\ZҸ\'2@', 'wp-content/plugins/updraftplus/includes/Google/Logger/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ׁ8_p@}', 'mOtOh;)ً,\'J', '', 0, '?'),
 ('1D\Zu#O', 'wp-content/plugins/updraftplus/includes/Google/Logger/Null.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ig+ 3', '\'hN,^12;#(Z\'', '', 0, '?'),
 (':Jo%', 'wp-content/plugins/updraftplus/includes/Google/Logger/Psr.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '׳π{\\6}', 'ˁe?ŴŒuCdm\"KX\'', '', 0, '?'),
 ('oM2B0!4S', 'wp-content/plugins/updraftplus/includes/Google/Model.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GWŹx', 'a-<M>w OB%ƇKS7', '', 0, '?'),
 ('9ڊ$F.{', 'wp-content/plugins/updraftplus/includes/Google/Service/Audit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '36!LleD', 'Xj૷X4PQF.<\r)Pb@', '', 0, '?'),
 ('{\"`[(', 'wp-content/plugins/updraftplus/includes/Google/Service/Container.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U\"L;s', ':\0ORQZ\'vYv;`^J)r\r', '', 0, '?'),
 ('B5A1EAg3k5', 'wp-content/plugins/updraftplus/includes/Google/Service/Datastore.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}vƈZX_', 'm\"OL(Hy@|w0깃\ZI', '', 0, '?'),
 ('^tK>Txu', 'wp-content/plugins/updraftplus/includes/Google/Service/Directory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y$]j;{N', '\0<]wuXq9L{-\r뺎}o|e#', '', 0, '?'),
 ('\'q{Z>', 'wp-content/plugins/updraftplus/includes/Google/Service/Dns.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<<j*', '`\\AB[A[y/gxLr', '', 0, '?'),
 ('(i\'r>A3', 'wp-content/plugins/updraftplus/includes/Google/Service/Drive.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A6o6QH', 'hBtV`dU!jwǌ:e`', '', 0, '?'),
 ('6@0^zcJq-', 'wp-content/plugins/updraftplus/includes/Google/Service/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cE-QJ7Ύ', '̫\"..TB`\"L\"վ>', '', 0, '?'),
 ('Ŀ7md[t<', 'wp-content/plugins/updraftplus/includes/Google/Service/GroupsMigration.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=}Κ/<y', 'D2e`IIQ>e#H,O&xFb', '', 0, '?'),
 ('8Lomf~', 'wp-content/plugins/updraftplus/includes/Google/Service/Groupssettings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n-ӋGxѠume', 'f(%U;3q_La}v|hc', '', 0, '?'),
 ('.qBOcUF5', 'wp-content/plugins/updraftplus/includes/Google/Service/IdentityToolkit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.ڋ=QeeH?', '#Ke1S;uO+|߿*', '', 0, '?'),
 ('xt{ܨ>	J', 'wp-content/plugins/updraftplus/includes/Google/Service/Licensing.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C/brA', 'f	.Z%Q-0zւc', '', 0, '?'),
 ('6)xTzތ\0', 'wp-content/plugins/updraftplus/includes/Google/Service/Logging.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*A@rQGXy', '\\k^NTpYmUP\\', '', 0, '?'),
 ('*z8nZS', 'wp-content/plugins/updraftplus/includes/Google/Service/Oauth2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Iyby4MgcΞ', '^!$y[X\\g֧gN\'3(hm', '', 0, '?'),
 ('6BC3cE6', 'wp-content/plugins/updraftplus/includes/Google/Service/Reports.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aBU-K', '|G^:QodO4\"^\0B[Ok\r&4w\r:,', '', 0, '?'),
 ('կpQz\Z', 'wp-content/plugins/updraftplus/includes/Google/Service/Resource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P!^((Ni4', 'SkUzPx-5_\Z4i', '', 0, '?'),
 (']mˍ b', 'wp-content/plugins/updraftplus/includes/Google/Service/Resourceviews.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qVN+X_', '9Míb>[sW6\\O', '', 0, '?'),
 ('fR9]V#rs', 'wp-content/plugins/updraftplus/includes/Google/Service/Storage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ha;x.^~}', '[`]͍]ǜݪ7mA\ng', '', 0, '?'),
 (';A', 'wp-content/plugins/updraftplus/includes/Google/Service/Tasks.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%E[Ys\0ֿ', '3,JvaၕP2V\04N}W', '', 0, '?'),
 ('c\Z%', 'wp-content/plugins/updraftplus/includes/Google/Service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƣyu\rXON,', 'c5rIeNZ71A\"q`%', '', 0, '?'),
 ('8!?Η`t', 'wp-content/plugins/updraftplus/includes/Google/Signer/Abstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6SW', ':\'Lr3Wٙsć', '', 0, '?'),
 ('z!38T_މ:', 'wp-content/plugins/updraftplus/includes/Google/Signer/P12.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TR+6|8', '4]Ⱪ@q?ulEv%jPr', '', 0, '?'),
 ('\reKg.q', 'wp-content/plugins/updraftplus/includes/Google/Task/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b48	BI$Z', 'Vn@1[)ޕ{G jC顴ǝ:O', '', 0, '?'),
 ('Z=ӓj` ', 'wp-content/plugins/updraftplus/includes/Google/Task/Retryable.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qeS4', ']R \r8]\'CｍĽV', '', 0, '?'),
 ('M[?ObU6$ޚ', 'wp-content/plugins/updraftplus/includes/Google/Task/Runner.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{a\"Z*/Df', '\"H(Tz/eԂ{D\'\r7u\\,E', '', 0, '?'),
 ('p{UʏКtecC4CDj', 'wp-content/plugins/updraftplus/includes/Google/Utils/URITemplate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ߘ	zg(', 'NGEʭ<^@{oZGR', '', 0, '?'),
 ('ٯ]+Wf', 'wp-content/plugins/updraftplus/includes/Google/Utils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+3q;yr', 's*a~TкYTnܟ(\Z', '', 0, '?'),
 ('ŸMȻՠIך', 'wp-content/plugins/updraftplus/includes/Google/Verifier/Abstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qz\'N', 'XVUc<j\"f.{a?', '', 0, '?'),
 ('ٙ[y?m\"', 'wp-content/plugins/updraftplus/includes/Google/Verifier/Pem.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#Uۙ*@', 'l@[uuPj%2Aˇp(w&x_', '', 0, '?'),
 ('*q*6\r6z\\', 'wp-content/plugins/updraftplus/includes/Google/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7z6܋xTLE', '5ZbyoOXr\060]Dv', '', 0, '?'),
 ('؆[Br̳$W', 'wp-content/plugins/updraftplus/includes/S3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rg_|ތ嵠D', '-j|u<Qn0nZO\Z', '', 0, '?'),
 ('^Psiy/a', 'wp-content/plugins/updraftplus/includes/S3compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?h	C]t', 'a{`5`݂4h勭pd', '', 0, '?'),
 ('o$ܳ', 'wp-content/plugins/updraftplus/includes/cacert.pem', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?,>bǧ(x', '\"+X*eC|ΡB)+0yf', '', 0, '?'),
 ('ȶIU͖', 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/loader.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X@uiL\"', 'jXw=wsKw%o<qbZNF', '', 0, '?'),
 ('#$Pi\Z', 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I&I=UeNR', '؈P~_^AR.}%:', '', 0, '?'),
 ('LTϩ5#co', 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R\r	OAM', 'B~E~ˡQ(\nd³ h', '', 0, '?'),
 ('[Hq Xh]', 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i?VAua', '(zQ_>Hl)-0oKa$N', '', 0, '?'),
 ('rzֳJ8g7ED`', 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.css.map', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vdc)+', '/dNeS:*~weV+Ҳfh', '', 0, '?'),
 ('T6\07]s', 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rG̏pKT', '\nZ/Q\nl.)Oު,Pe2<lٗ', '', 0, '?'),
 ('Tյ|gmxqH', 'wp-content/plugins/updraftplus/includes/checkout-embed/class-udp-checkout-embed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Oҕ4oV', 'VBO(ǀMoY:+g2ܰ', '', 0, '?'),
 ('ߩ@?#e(', 'wp-content/plugins/updraftplus/includes/checkout-embed/products.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$h}pX\r', 'rd=ZŨ/ۢzvsD\"ycȎ꼖', '', 0, '?'),
 ('%\"T< ', 'wp-content/plugins/updraftplus/includes/checkout-embed/readme.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'er$mI', '9^C+9e@^[u{/lο nh', '', 0, '?'),
 ('ڈAnպE', 'wp-content/plugins/updraftplus/includes/class-backup-history.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',a+QAkP', 'xC	n\0ɢQ\Z~z0M|', '', 0, '?'),
 ('fNɕW~EP', 'wp-content/plugins/updraftplus/includes/class-commands.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sal+-3Qs', 'zzO yClvo(h#7\"', '', 0, '?'),
 ('!Q~máj', 'wp-content/plugins/updraftplus/includes/class-database-utility.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'piL$X2-s0', 'im:nVxc6e[S2:8in', '', 0, '?'),
 ('vň&CQ', 'wp-content/plugins/updraftplus/includes/class-filesystem-functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W.0#S`YŁ', 'ɹwmM}Q~+8C!PV*Ūt', '', 0, '?'),
 ('JIn;q', 'wp-content/plugins/updraftplus/includes/class-job-scheduler.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=-ei$t', 'R똚Q	Ĥ?[^57*Ƽ', '', 0, '?'),
 ('_npt]iGp', 'wp-content/plugins/updraftplus/includes/class-manipulation-functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T?J%讲F', '(إaCSg|D,2zxӘK', '', 0, '?'),
 ('5Fc?', 'wp-content/plugins/updraftplus/includes/class-partialfileservlet.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_4/F(', 'BXASr!kbfq`B@*c', '', 0, '?'),
 ('\rqU', 'wp-content/plugins/updraftplus/includes/class-remote-send.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zIK=ɺ', ':\r\ZOO2ZQj٘ۿ\0', '', 0, '?'),
 ('hɝru', 'wp-content/plugins/updraftplus/includes/class-semaphore.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'mfd\n˜o', 'h]֝O\rbJe=F\"1[rTr\'k<', '', 0, '?'),
 ('f`:]khz', 'wp-content/plugins/updraftplus/includes/class-storage-methods-interface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DtCx', ' @0q`Vޏh\"h', '', 0, '?'),
 ('C-4^#yN T', 'wp-content/plugins/updraftplus/includes/class-udrpc.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']W\'dQkfù\0', 'pX\'9j8dKU\0aŗw\rY', '', 0, '?'),
 (')əɗ', 'wp-content/plugins/updraftplus/includes/class-updraft-dashboard-news.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E/ZvˉE$a', '|(J(3>Y(ᐩq)4d', '', 0, '?'),
 ('rQoZ>', 'wp-content/plugins/updraftplus/includes/class-updraftcentral-updraftplus-commands.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xf54P', 's\razA9O^Zs2yJۧN~McC؎', '', 0, '?'),
 ('gBRY?fڱoPcϗZ', 'wp-content/plugins/updraftplus/includes/class-updraftplus-encryption.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G	S`쓌U', 'j\r4jL9\0@)zHO)(.~V', '', 0, '?'),
 ('HB͜[!+<,', 'wp-content/plugins/updraftplus/includes/class-wpadmin-commands.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j&ucsZ/', '<_ݤ䶨;8dyݽJ[', '', 0, '?'),
 ('QicA', 'wp-content/plugins/updraftplus/includes/class-zip.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b[a|X', 'z?j*n\"9Y]iz*9', '', 0, '?'),
 ('U!]ɲ^W.\\', 'wp-content/plugins/updraftplus/includes/cloudfiles/cloudfiles.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '򘉱#q~O', 'kk[wrnoI', '', 0, '?'),
 ('\\!&z', 'wp-content/plugins/updraftplus/includes/cloudfiles/cloudfiles_exceptions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v!e(i:hZ', 'i3F\0i7\'TdLF\0M}M', '', 0, '?'),
 ('@1uM{', 'wp-content/plugins/updraftplus/includes/cloudfiles/cloudfiles_http.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&gKdC.ĵ&', '?S>ȃH\'M-oԭ|c&', '', 0, '?'),
 ('P`D#|H!-u ', 'wp-content/plugins/updraftplus/includes/ftp.class.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ɳT:v\"x\"', '>qql!9Y\\ Rb', '', 0, '?'),
 ('5(Ƴn;ӎmA%\Z', 'wp-content/plugins/updraftplus/includes/get-cpanel-quota-usage.pl', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w3kߚ', 'Ka_]pvϩ-`Ƹ+VYlW', '', 0, '?'),
 ('Yt\Z6A', 'wp-content/plugins/updraftplus/includes/google-extensions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' CCzX95J', 'q^(ّ1 yqQ', '', 0, '?'),
 ('x8CTX7jcF', 'wp-content/plugins/updraftplus/includes/handlebars/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JI׹5<', 'ZFp4kYП\rƔ*]=	279', '', 0, '?'),
 ('\0p@', 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B\ZT~)d', 'uR!^\\M,Q0\r<B', '', 0, '?'),
 ('<3q;iz', 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@ߋK\'\rOe', 'y\n@k_-se@/+KP;V', '', 0, '?'),
 ('ޓCMp6Yz', 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.runtime.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ly<ߚdZE', '~`Z@+[1a\"^qg[&99', '', 0, '?'),
 ('4rp$DD0I]', 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.runtime.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h̏0-1ڈd', 'ܯb]fz4$C\0Gi', '', 0, '?'),
 ('ǤB\"(~g', 'wp-content/plugins/updraftplus/includes/images/ui-bg_diagonals-thick_18_b81900_40x40.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?X\'G9h\\d1$U', 'C]JiX^v,(', '', 0, '?'),
 ('Qu}WN', 'wp-content/plugins/updraftplus/includes/images/ui-bg_diagonals-thick_20_666666_40x40.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']8TP\nFL', 'Xk8m(3Lָ熼[\r', '', 0, '?'),
 (')˼*$aT', 'wp-content/plugins/updraftplus/includes/images/ui-bg_flat_10_000000_40x100.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R:7g D4', '\nT^{x}\\mB5?Ge', '', 0, '?'),
 ('gCA\riNb', 'wp-content/plugins/updraftplus/includes/images/ui-bg_glass_100_f6f6f6_1x400.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|=`\0O4A	', 'dUlMN4k\'DOxZ%k', '', 0, '?'),
 ('ԽG3P*K', 'wp-content/plugins/updraftplus/includes/images/ui-bg_glass_100_fdf5ce_1x400.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ѿCTrW\'dc', 'װXHj\'H*ڮA|BSng', '', 0, '?'),
 ('IB{θZ*_', 'wp-content/plugins/updraftplus/includes/images/ui-bg_glass_65_ffffff_1x400.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȩ_=n>6', 'u)#-iLI W)m\0+z\\Z67', '', 0, '?'),
 ('Iqt5GmƧ', 'wp-content/plugins/updraftplus/includes/images/ui-bg_gloss-wave_35_f6a828_500x100.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UeZEKx?r L', 'd$)o^`? ]%nIb', '', 0, '?'),
 ('&kh\0F', 'wp-content/plugins/updraftplus/includes/images/ui-bg_highlight-soft_100_eeeeee_1x100.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g-*`@', 'P#Kh̿R0#b,m', '', 0, '?'),
 ('Au2?m0', 'wp-content/plugins/updraftplus/includes/images/ui-bg_highlight-soft_75_ffe45c_1x100.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':\0N22&', 'Z]\02}\"^۫txr', '', 0, '?'),
 ('Wkl', 'wp-content/plugins/updraftplus/includes/images/ui-icons_222222_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"Pw?mvt-S{', 'p˽	JH\"UQY;@[-', '', 0, '?'),
 ('FC˄4~.', 'wp-content/plugins/updraftplus/includes/images/ui-icons_228ef1_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	eo\n4#~}W', '\0\"pGyNp~* 7n\'؍', '', 0, '?'),
 ('ݽԦDUu', 'wp-content/plugins/updraftplus/includes/images/ui-icons_ef8c08_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{.7+\0K', 'ʫf\nJT3hY\\c1M8l5E6r\\', '', 0, '?'),
 ('_ef', 'wp-content/plugins/updraftplus/includes/images/ui-icons_ffd27a_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P7419', '2ppki˭!S,^e', '', 0, '?'),
 ('%(7s&ܻ', 'wp-content/plugins/updraftplus/includes/images/ui-icons_ffffff_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Cj6@Oΐ', '\'4[`ϐ?˓ܖS\Z\npժ[m', '', 0, '?'),
 ('OX\ra87vb', 'wp-content/plugins/updraftplus/includes/jquery-ui.custom.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Қr~Sj~', 'gRM@T)hn2', '', 0, '?'),
 ('|j[<0kTXCu\r', 'wp-content/plugins/updraftplus/includes/jquery-ui.custom.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@600Z_Qq', '}hs :i+5/Oʨc;;', '', 0, '?'),
 ('\\$jp\\&ʊ!Mw', 'wp-content/plugins/updraftplus/includes/jquery-ui.custom.min.css.map', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=0{&', '#Iՙ鉴pm+D*~', '', 0, '?'),
 ('}ǽ', 'wp-content/plugins/updraftplus/includes/jquery.blockUI.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\ڰx1#=', 'q΂<Ae󺷊Ց~hP', '', 0, '?'),
 ('\ZJ͙ǧRj', 'wp-content/plugins/updraftplus/includes/jquery.blockUI.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-\"	\Z=L', 'i)M	|JoCf.P$Elg`l(', '', 0, '?'),
 ('x$\n3y7\Z', 'wp-content/plugins/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{SAk(uI5s', 'Iv+BޭՉcd6\"O\\', '', 0, '?'),
 ('0ZvTQH', 'wp-content/plugins/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-ϣ;Gi$rG9c$', 'ϯ|/X\n2G:@{\rAL{	', '', 0, '?'),
 ('rR/#+7<^', 'wp-content/plugins/updraftplus/includes/jstree/jstree.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yᮨ-\0;k', 'F;֕#\rus(\0nט', '', 0, '?'),
 ('	Vq%l#', 'wp-content/plugins/updraftplus/includes/jstree/jstree.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HCDLg?', 'iunhai[[J&8sopp', '', 0, '?'),
 ('NަgCI:', 'wp-content/plugins/updraftplus/includes/jstree/themes/default/32px.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!BWIN\'ŸM', 'Cz \0(_DAذf(\r', '', 0, '?'),
 ('*ty	7(Zsr;0w', 'wp-content/plugins/updraftplus/includes/jstree/themes/default/40px.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}/ڜ:sPeaO', 'GOԆJN}aTĞ|<G=%', '', 0, '?'),
 ('Y-8gm<Z28$Q`', 'wp-content/plugins/updraftplus/includes/jstree/themes/default/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '΄RSslB	ǥ', '+wf<G[>OK~j{Zͱ', '', 0, '?'),
 ('\0wG=ǣwJ', 'wp-content/plugins/updraftplus/includes/jstree/themes/default/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wĴ\0thZP', 'Գ|̶\Z\"A8Rwh򚧞Qo', '', 0, '?'),
 ('ju%Ɋ\r\0Fҧg', 'wp-content/plugins/updraftplus/includes/jstree/themes/default/throbber.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g^x l', 's\nHK!֐gkn\0w', '', 0, '?'),
 (')k&\\`_i)', 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/32px.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7\0rn8I)xk', 'c]02$J$B3DA', '', 0, '?'),
 ('kQ{^\ZL_Ҽ', 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/40px.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P\"UGQ|H', 'K	?ES=a\n3{wDam', '', 0, '?'),
 ('ΠM-h', 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '裐hmH^q', '\\,\r_b=z_x\\NiL', '', 0, '?'),
 ('ሳ֊ZрW 9þ', 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Zi\ZS\"f@J', 'mxp/lH>41G>3D<Mvr', '', 0, '?'),
 ('jծhq|', 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/throbber.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '//d!\rg', '^+tSbQ\\VPtccOV', '', 0, '?'),
 ('&x9\niRu', 'wp-content/plugins/updraftplus/includes/labelauty/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vx\ra m.UR', 'tN\ZqJ@ev,BDس)oq', '', 0, '?'),
 ('4lAj,', 'wp-content/plugins/updraftplus/includes/labelauty/images/input-checked.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ah<jH#늭\n', 'K\\pd;uӤ\05f]s8=R', '', 0, '?'),
 ('S4`Z8\ZMi\0', 'wp-content/plugins/updraftplus/includes/labelauty/images/input-unchecked.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k5 /hl*', 'yj/9@\0h', '', 0, '?'),
 ('n1v-\0kqf', 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W\"rWRn ʴ;', 'r4b{1<[Ƴ޹,WL>EY', '', 0, '?'),
 ('B\'Ll\nABK`?', 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ª/9T9I', '7\ZĆ8l8N-9', '', 0, '?'),
 ('crrJ;_z{TM', 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M$驱	v', '$_ƿl`GBx\0tY8e{h', '', 0, '?'),
 ('=6Z1fM\Z1F!', 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.min.css.map', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%.%2n,.){', '*ѫ[w-YePB1VVbP,', '', 0, '?'),
 ('\rY_D<{:', 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!mH@4٨', 'l3 ==ݕ흖xeHLY&#', '', 0, '?'),
 ('h/=b\"	/#o', 'wp-content/plugins/updraftplus/includes/tether/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zpإi', 'B?\"{\n``|HWju', '', 0, '?'),
 ('Lf\\e<GGU:', 'wp-content/plugins/updraftplus/includes/tether/tether.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3\'Gr|(xx', 'D=F:\0}ZD\n2_;fTq', '', 0, '?'),
 ('O1\r', 'wp-content/plugins/updraftplus/includes/tether/tether.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yyiz', 'Ui(9ￌbUT,RΕS', '', 0, '?'),
 ('3\n\rn1', 'wp-content/plugins/updraftplus/includes/tether-shepherd/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BF=ǑG:\nI', 'VS}\\K<+ϵݜ?7', '', 0, '?'),
 ('a#%-2cؓ', 'wp-content/plugins/updraftplus/includes/tether-shepherd/shepherd.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\&T+K', 'j\\33IU޾8eP\nJ-j\']lv', '', 0, '?'),
 ('[6	`{	z', 'wp-content/plugins/updraftplus/includes/tether-shepherd/shepherd.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n+bA|-X', 'g7>^rֲYgd7羊`=', '', 0, '?'),
 ('QZOIrKV', 'wp-content/plugins/updraftplus/includes/tether-shepherd/tether.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '٬MU6/A1', '\nG#sUWN', '', 0, '?'),
 ('h	\0hq{A', 'wp-content/plugins/updraftplus/includes/updraft-admin-common.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%\Z\0+dlt', 'A5oTs\"LmAti}Ǜ0=5J.', '', 0, '?'),
 ('N/z\Z[\rZU}', 'wp-content/plugins/updraftplus/includes/updraft-admin-common.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hD;\rY9+qd', '(n{x-qlhD8<JTA#wv,h', '', 0, '?'),
 ('z63D<[tˍ', 'wp-content/plugins/updraftplus/includes/updraft-notices.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Қēх>', 'zg%P\rdq*~l\0\nA~I', '', 0, '?'),
 ('D{W1', 'wp-content/plugins/updraftplus/includes/updraft-restorer-skin-compatibility.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&C;e', 'O7ޚn#xY6fUK', '', 0, '?'),
 ('S%M䑱j7+PAK', 'wp-content/plugins/updraftplus/includes/updraft-restorer-skin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wφac', 'Ru$`\\3w]~Weֵ', '', 0, '?'),
 (']a]2wԢ', 'wp-content/plugins/updraftplus/includes/updraftcentral.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']};SHI~*', '?W=)0\\i{\'Ś[u', '', 0, '?'),
 ('Z	?b/$5', 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-auto-login.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':2w9\n', '؈0XLS!\"8Y&]^;Ӝ,', '', 0, '?'),
 (':e7ѿn86', 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-dash-notice.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>\nL#M|', '?Ni,!˘#>6x2ËLF', '', 0, '?'),
 ('\\$Fxm', 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-restore.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.m5;CϿ', '2GL\r#:N\0}ҲOd\ZM,', '', 0, '?'),
 ('b=ufF/!ͨ', 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-status.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fs	\nXmfX', '/ReZ2#)x\"/o,it2', '', 0, '?'),
 ('?U˕209Pw', 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-user-notice.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ճ*cƞ䨰', 'Ly8.0LtY\\3ͽ;JEi_=', '', 0, '?'),
 ('253k	', 'wp-content/plugins/updraftplus/includes/updraftplus-clone.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3oy\"b', '~<X9S¦U\'ҽ%4', '', 0, '?'),
 ('mZ|%d', 'wp-content/plugins/updraftplus/includes/updraftplus-login.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Vߦ1rnez', 'K:\ZEwqˀ=y/^%y\rݹC', '', 0, '?'),
 ('ì;_EsDێ', 'wp-content/plugins/updraftplus/includes/updraftplus-notices.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tiRwxw~5', 'uCҭHYTmx9 ~`3s', '', 0, '?'),
 ('s0?BWǣ!', 'wp-content/plugins/updraftplus/includes/updraftplus-tour.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XpISt✓-]YB', 'ɄE4o\'a7fcNĔx', '', 0, '?'),
 ('5ivb@~)', 'wp-content/plugins/updraftplus/includes/updraftvault.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']fFk<듅', 'XN}]|(`k!O0Hn[q', '', 0, '?'),
 ('H;c)[', 'wp-content/plugins/updraftplus/index.html', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IixC;y5', 'gp	؟g	R	ya8>]o', '', 0, '?'),
 ('dߨ6 #<˯', 'wp-content/plugins/updraftplus/js/tour.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QҴH*޶b&_', 'Z.5ҋp?ȘQFG?7', '', 0, '?'),
 (',Sma+', 'wp-content/plugins/updraftplus/js/tour.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>^<]䠽', 'ɐHnJiu4ՈF!@+垭', '', 0, '?'),
 ('ҩ]|y=x', 'wp-content/plugins/updraftplus/js/updraft-admin-restore.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N=lؿ', '\0j9Q}[Kp_4pP:AgE>=)u', '', 0, '?'),
 ('2>lMff', 'wp-content/plugins/updraftplus/js/updraft-admin-restore.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wEr', '8H!Ah/~\"I`üET78[', '', 0, '?'),
 ('9U^X#nr', 'wp-content/plugins/updraftplus/languages/updraftplus-af.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G\01', ',&_u_r^9V\0#', '', 0, '?'),
 ('7lk8', 'wp-content/plugins/updraftplus/languages/updraftplus-af.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@>|)e', '#vEn7M4-(Sw`z', '', 0, '?'),
 ('쾅<jv', 'wp-content/plugins/updraftplus/languages/updraftplus-ar.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/˶ͨO>#', '[15YxOl;;{`׉Q-$XzR', '', 0, '?'),
 ('D͝WS', 'wp-content/plugins/updraftplus/languages/updraftplus-ar.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$;::O.', '0#2e\n_Nm{d3JقiCx', '', 0, '?'),
 ('Op+~m4KN\n', 'wp-content/plugins/updraftplus/languages/updraftplus-bg_BG.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yz\'++17', 'SRb9)\"dsq7Ug\"', '', 0, '?'),
 ('$㦰<;|q', 'wp-content/plugins/updraftplus/languages/updraftplus-bg_BG.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ϣ`a#SGdA', '#uߡ5^pc2\\Eh\\', '', 0, '?'),
 ('ӹʱ4Y#c+,', 'wp-content/plugins/updraftplus/languages/updraftplus-bn_BD.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FY9.SݠY', 'p8Kw3Fd}U\r(F\nC', '', 0, '?'),
 ('$͔p腴3y', 'wp-content/plugins/updraftplus/languages/updraftplus-bn_BD.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J?G\Z%p>-U', ')	ZHKKrsfu2[X3', '', 0, '?'),
 (',_ i.0X', 'wp-content/plugins/updraftplus/languages/updraftplus-bs_BA.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eƣ-Bu2[u', 'ߢx=޺wЩ\ZK>rpW	R', '', 0, '?'),
 ('\Z@I#\rF&>', 'wp-content/plugins/updraftplus/languages/updraftplus-bs_BA.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kºnk\'dͽ', 'Ȓ]҄`8{0RD&', '', 0, '?'),
 ('$5/ޑ*W', 'wp-content/plugins/updraftplus/languages/updraftplus-ca.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DW+a\" 5', 'Q4T9Rqc߽;', '', 0, '?'),
 ('k2.g/\rn', 'wp-content/plugins/updraftplus/languages/updraftplus-ca.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pY˛͜)', '=wN0yFa\rR:<V;_', '', 0, '?'),
 ('%HZՄ*', 'wp-content/plugins/updraftplus/languages/updraftplus-da_DK.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mQm,\\D#0', 'NxEFr$׵`AC@&l3Ϛ-', '', 0, '?'),
 ('E>\0:%)C<', 'wp-content/plugins/updraftplus/languages/updraftplus-da_DK.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VⰊ8\\mд', 'D\"%b\'/eB0sֲB<Qpظ', '', 0, '?'),
 (')\0bRVPU\'', 'wp-content/plugins/updraftplus/languages/updraftplus-el.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P(k\0<8', 'oeBsL~-Ci,NQ\ZipI)W#', '', 0, '?'),
 ('*m<Dqmh(ۙ', 'wp-content/plugins/updraftplus/languages/updraftplus-el.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȥeGƜU\n', '@{2 Iʯ/_ 	!ImzZ', '', 0, '?'),
 ('? !&40P1)', 'wp-content/plugins/updraftplus/languages/updraftplus-es_AR.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2)\n񜲧v/	jQ', ',1lXHuL/\07[wz@Zңq', '', 0, '?'),
 ('ߠwө!', 'wp-content/plugins/updraftplus/languages/updraftplus-es_AR.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':2v xvf', '\\`\"x֖*L		XmB>', '', 0, '?'),
 ('BO\'\r2Ǚ', 'wp-content/plugins/updraftplus/languages/updraftplus-es_CO.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd{+ 2', '_v\0FxRp%vJӵIڄ', '', 0, '?'),
 ('p DE', 'wp-content/plugins/updraftplus/languages/updraftplus-es_CO.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sk#9l^,e0', '5VhG$ +H{%]L[\0\\', '', 0, '?'),
 ('\'p?uK', 'wp-content/plugins/updraftplus/languages/updraftplus-es_MX.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ꢀ:q)P^ŐW,', '.0vٔFa\n9qg(Ǖ*1', '', 0, '?'),
 (';yǌ', 'wp-content/plugins/updraftplus/languages/updraftplus-es_MX.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iX\'9k\rzN', '\nm\0j%Y@\0I:+U', '', 0, '?'),
 ('d2M_\\Pd', 'wp-content/plugins/updraftplus/languages/updraftplus-es_VE.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7$V.C([b#g', 'S\"#b?*Y:06QpR1V', '', 0, '?'),
 ('(yX>Φt', 'wp-content/plugins/updraftplus/languages/updraftplus-es_VE.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'btpC:1\n1Į', '\Z@\"0fIծ/4Ϣ٢9<P', '', 0, '?'),
 ('2MxFЙX', 'wp-content/plugins/updraftplus/languages/updraftplus-eu.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ri@˾RN', ';ͼ`OdZN\ZPi9j\'@w0', '', 0, '?'),
 ('c\"8\r+Am', 'wp-content/plugins/updraftplus/languages/updraftplus-eu.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(MW+[`\\3G', '(IxW/L<jC/X6w{=h', '', 0, '?'),
 ('o2%F^ף4', 'wp-content/plugins/updraftplus/languages/updraftplus-fa_IR.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '҉>{E<.U\"貯bE', 'wX`Wc]і\'G@\nԠRn', '', 0, '?'),
 ('76{ &~lg', 'wp-content/plugins/updraftplus/languages/updraftplus-fa_IR.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V\";J', 'r-ҊPgzE#aL', '', 0, '?'),
 ('a1I 3Ƈo6', 'wp-content/plugins/updraftplus/languages/updraftplus-fi.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7u3\\D|', 'UP|\\\"c>zvg2XB', '', 0, '?'),
 ('PzW3|/A&Wr', 'wp-content/plugins/updraftplus/languages/updraftplus-fi.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Os~xT\0', '\0(Zqw-]aJv#-:', '', 0, '?'),
 ('HSf\nSq', 'wp-content/plugins/updraftplus/languages/updraftplus-fr_CA.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OD|;A^P<;hJ', '<#t\\Cz~Om!jwCUj06{_>', '', 0, '?'),
 ('39r6ȯ', 'wp-content/plugins/updraftplus/languages/updraftplus-fr_CA.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9r`4;wkZ', '~~|H.{>V	LZ۪R#?f/', '', 0, '?'),
 ('c4*)]+6eoY', 'wp-content/plugins/updraftplus/languages/updraftplus-he_IL.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i.MǢгlXmTu(', 'ъ61.-r.s3ٸ', '', 0, '?'),
 ('jԏmbq݅ͥ', 'wp-content/plugins/updraftplus/languages/updraftplus-he_IL.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y>01#뎍', '3!YI+zC_>RoS!nF\0', '', 0, '?'),
 ('\'3P@P_\r', 'wp-content/plugins/updraftplus/languages/updraftplus-hi_IN.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C,@ݏC&hgONM', 'їaMFQB}j', '', 0, '?'),
 ('ME[S7czƛ', 'wp-content/plugins/updraftplus/languages/updraftplus-hi_IN.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+1W)O|', '_p~{GlzD9:7Ce-', '', 0, '?'),
 ('\Zpif)Jܨ7', 'wp-content/plugins/updraftplus/languages/updraftplus-hu_HU.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(%\Z$%	g$', 'qOYnwWRudc,Hk ', '', 0, '?'),
 ('\\\rSj{', 'wp-content/plugins/updraftplus/languages/updraftplus-hu_HU.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H;)b^\\z', ':Qs$~9ۃJ5', '', 0, '?'),
 ('Fxb\\WZT!qY', 'wp-content/plugins/updraftplus/languages/updraftplus-id_ID.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?teN\nĿbw', '_,:eͪI#}t=OSb*', '', 0, '?'),
 ('PLN}0윣^', 'wp-content/plugins/updraftplus/languages/updraftplus-id_ID.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']OOT,@5	g<', '}.9dG>Z]xfl', '', 0, '?'),
 ('E؜f`^', 'wp-content/plugins/updraftplus/languages/updraftplus-ja.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+l{IK!h̄', 'jz0\'FWpN25J**', '', 0, '?'),
 ('H.Kp/sBn', 'wp-content/plugins/updraftplus/languages/updraftplus-ja.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~Jxx', 'z`bEƸU4Ǚz?\"S', '', 0, '?'),
 ('ά\"0ٵ|', 'wp-content/plugins/updraftplus/languages/updraftplus-ko_KR.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(cQ^=5U:', '<SՄݴ^ԝձ8^', '', 0, '?'),
 ('.9=RX	5+(W', 'wp-content/plugins/updraftplus/languages/updraftplus-ko_KR.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eH`OG', 'nW@p|N|\'4wVɑ3', '', 0, '?'),
 ('+arDt2', 'wp-content/plugins/updraftplus/languages/updraftplus-lt_LT.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b.x2\"3fps', 'Cz^䒭CixN;\0', '', 0, '?'),
 ('$%ւU', 'wp-content/plugins/updraftplus/languages/updraftplus-lt_LT.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V5J$Z鍷', 'o	9dӃIK_\0t\"AO', '', 0, '?'),
 ('kCjS<<b%', 'wp-content/plugins/updraftplus/languages/updraftplus-nl_NL.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ӊ![+l}U', 'ftp(^B\"ʤ~T!Lk', '', 0, '?'),
 ('zm^', 'wp-content/plugins/updraftplus/languages/updraftplus-nl_NL.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'k@Y', '\n<AA>%*LoO82', '', 0, '?'),
 ('	\Z0G;]:G@', 'wp-content/plugins/updraftplus/languages/updraftplus-no.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`	Vgx', 'ZN=y2@S^kIJKwYw', '', 0, '?'),
 ('\0e_vJ/J', 'wp-content/plugins/updraftplus/languages/updraftplus-no.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W/3O|ɭ', 'ږ=;!b\"', '', 0, '?'),
 ('<r٣\"qܸ', 'wp-content/plugins/updraftplus/languages/updraftplus-pt_BR.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S(̦x(l1G', '+l}/JW\naV3B)!8B', '', 0, '?'),
 ('%Rfx?\"D', 'wp-content/plugins/updraftplus/languages/updraftplus-pt_BR.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '֓> 8̞', '.Lei[Aydl\\LQja\"o', '', 0, '?'),
 ('q %Pd', 'wp-content/plugins/updraftplus/languages/updraftplus-ru_RU.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')VЌvXgխ', '\Zm/}F燈f\njAgJ\Z', '', 0, '?'),
 ('f,b', 'wp-content/plugins/updraftplus/languages/updraftplus-ru_RU.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LF\'LV\Zjf', 'cаͷKo @jk@AjwJ', '', 0, '?'),
 ('+Dɛ,\ntBw', 'wp-content/plugins/updraftplus/languages/updraftplus-sk_SK.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.ج&\'ɓ', 'D>.t4S,#e\\5\\z<ȑ[', '', 0, '?'),
 ('$fevmx-&', 'wp-content/plugins/updraftplus/languages/updraftplus-sk_SK.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E-VWsIή', 'ǚ(b7uQQcQR5', '', 0, '?'),
 ('˜cr_4}', 'wp-content/plugins/updraftplus/languages/updraftplus-sl_SI.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G?z<b1?', 'Ϝk	o\'5UνOy', '', 0, '?'),
 ('S]/}rt', 'wp-content/plugins/updraftplus/languages/updraftplus-sl_SI.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u4*FJg', '^VFrP Dd0-x\'˴', '', 0, '?'),
 ('n$;,\'rA', 'wp-content/plugins/updraftplus/languages/updraftplus-sr_RS.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	q*$e', ',b+k-BkܢSF', '', 0, '?'),
 ('6T<`䰥] ', 'wp-content/plugins/updraftplus/languages/updraftplus-sr_RS.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '--%`\"9{Q', 'CRekx#5J֠XS', '', 0, '?'),
 ('ʈw{c{\"@', 'wp-content/plugins/updraftplus/languages/updraftplus-te.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'quBU', ')bn8*\0Zfȣ;xC8Q', '', 0, '?'),
 ('q.', 'wp-content/plugins/updraftplus/languages/updraftplus-te.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@/O', '\"I#Z ^R7֤ͼY}', '', 0, '?'),
 ('0uE\r+\\ۦ\n', 'wp-content/plugins/updraftplus/languages/updraftplus-th.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F^bQ`6|\n]', '+;=t.$o!F.y(a', '', 0, '?'),
 ('}!-2', 'wp-content/plugins/updraftplus/languages/updraftplus-th.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȮV:ný', 'vh>*ۆn\ZqO>b', '', 0, '?'),
 ('q*J7', 'wp-content/plugins/updraftplus/languages/updraftplus-tl.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rn#[cYe', 'ly7w\r2A~㹙\rBol\\~', '', 0, '?'),
 ('-0@恎Q', 'wp-content/plugins/updraftplus/languages/updraftplus-tl.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_! \"5', '%}&g$\ZRz2Q]9D\"y', '', 0, '?'),
 ('T(2z', 'wp-content/plugins/updraftplus/languages/updraftplus-tr_TR.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lr!Ӊ*', '>dWY#8wd1ҹ', '', 0, '?'),
 ('6wd3ƎQ}g', 'wp-content/plugins/updraftplus/languages/updraftplus-tr_TR.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':[yŏ@K', '˂u-P\r|$XnԏJɇ݇', '', 0, '?'),
 ('2]]B}*5D#', 'wp-content/plugins/updraftplus/languages/updraftplus-ur.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?$A7mW}', '8k5%OTоR?:2qJ%:', '', 0, '?'),
 ('$yfX', 'wp-content/plugins/updraftplus/languages/updraftplus-ur.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{2nHԇ', 'Xb(8\'rsujKCyBk3QT20P', '', 0, '?'),
 ('Awb~_}<	', 'wp-content/plugins/updraftplus/languages/updraftplus-vi.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '˷t\'', 'vihZ]\Z\"*VuEuϭg', '', 0, '?'),
 ('RxfGDgV', 'wp-content/plugins/updraftplus/languages/updraftplus-vi.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1sL#\r5ұH', 'b5YNU@/xn+', '', 0, '?'),
 ('tΐw)(!RcO', 'wp-content/plugins/updraftplus/languages/updraftplus-zh_CN.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E|rCy', '7XZo`s<~AlV', '', 0, '?'),
 ('R:!ٺ`\n', 'wp-content/plugins/updraftplus/languages/updraftplus-zh_CN.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W#I2m3', '?ٴ͍Ɓժ~QD2K}', '', 0, '?'),
 ('AO+om', 'wp-content/plugins/updraftplus/languages/updraftplus-zh_HK.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AZ7nS.3', 'BF`\09l	QCx.T', '', 0, '?'),
 ('>_]Wn0', 'wp-content/plugins/updraftplus/languages/updraftplus-zh_HK.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wG|t\0˭', '\\a7;%m\rPQ~bE)Ǒ3\0', '', 0, '?'),
 ('R {pH*\0', 'wp-content/plugins/updraftplus/languages/updraftplus-zh_TW.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'%*<o', '}5lCc\rOv4q&1oY~', '', 0, '?'),
 ('ʡx\0Nn0', 'wp-content/plugins/updraftplus/languages/updraftplus-zh_TW.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&dD!}*6m', '8lm1=!j@wG+', '', 0, '?'),
 ('j(i,q0ҙ Ȟ', 'wp-content/plugins/updraftplus/languages/updraftplus.pot', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$c', '`4nHPky<4\0', '', 0, '?'),
 ('#Ĳά/', 'wp-content/plugins/updraftplus/methods/addon-base-v2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{M#.VS\rL', 'hw3ͤ`rOg;Y;', '', 0, '?'),
 ('5Yv]0.', 'wp-content/plugins/updraftplus/methods/addon-not-yet-present.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QԝS,^a\r0', '4/ie_\niyߌdDSy+', '', 0, '?'),
 ('{gb$tI', 'wp-content/plugins/updraftplus/methods/azure.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k92hnIV', '\n`v(?UJ=5uI]', '', 0, '?'),
 ('*qdqAv', 'wp-content/plugins/updraftplus/methods/backblaze.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~Uŝ\Zz]', 'B~:]_OLAN/!qpf	N)|rO', '', 0, '?'),
 ('6,uֵy!y(g', 'wp-content/plugins/updraftplus/methods/backup-module.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3>M{zFT', 'w\\yBK*T5UɼPCv<', '', 0, '?'),
 ('.z!\\-Aaj', 'wp-content/plugins/updraftplus/methods/cloudfiles-new.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=S\0}p><	*', '`	V1@y\"Y=&)', '', 0, '?'),
 ('ukJ]{VTԥI', 'wp-content/plugins/updraftplus/methods/cloudfiles.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g	}؋%L', 'MTJvb\0o\0;ofP\n5\rdT<', '', 0, '?'),
 ('xqqc|!', 'wp-content/plugins/updraftplus/methods/dreamobjects.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n\rFk>\ZP', 'ץ@-8f8}Qv', '', 0, '?'),
 ('s2\0e)܋', 'wp-content/plugins/updraftplus/methods/dropbox.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V2\0/=!', 'tP>ᗨyWNmRj7E|O', '', 0, '?'),
 ('+Tx*0r~', 'wp-content/plugins/updraftplus/methods/email.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>7ohH\'q7', '\"oe[ 9{P	hg }3\'FW', '', 0, '?'),
 ('`-}i_pB', 'wp-content/plugins/updraftplus/methods/ftp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']?tb$ء,', 'Ktq4AH`)\ZY1*dm', '', 0, '?'),
 ('s\rY0h[8 4~', 'wp-content/plugins/updraftplus/methods/googlecloud.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ժ\'hzx', 'lJ5ELgnjH\'f.C*|O', '', 0, '?'),
 ('f{r#y`#', 'wp-content/plugins/updraftplus/methods/googledrive.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZʱN', '7[O鹆?=bVdJxT', '', 0, '?'),
 ('m<%}W($', 'wp-content/plugins/updraftplus/methods/insufficient.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's\0=+K', 'x&=(>dHS%ۘ2', '', 0, '?'),
 ('+tabғ', 'wp-content/plugins/updraftplus/methods/onedrive.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PktrR', 'm*=qBG\ZPho+9X\0^<xr˴	', '', 0, '?'),
 ('`Pn7\0 ', 'wp-content/plugins/updraftplus/methods/openstack-base.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X#+cWv', 'P7 cn[LMsLxqC1z\"|', '', 0, '?'),
 ('NKa]Q/', 'wp-content/plugins/updraftplus/methods/openstack.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Li8{va', 'my<0wzzކDr#', '', 0, '?'),
 ('hTԕw\0\'F', 'wp-content/plugins/updraftplus/methods/openstack2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5Ёie+ݫ', '+PsD6)7ꤧɵH\ZKQ?h', '', 0, '?'),
 ('^dGF%', 'wp-content/plugins/updraftplus/methods/remotesend.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r:Gr]2a', 'aC.~M!`kXʦL', '', 0, '?'),
 ('|F(-}ݧ\"H', 'wp-content/plugins/updraftplus/methods/s3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>@DtYpZ', '(#3^L4|TJj,O*', '', 0, '?'),
 ('P0Z\nSgd', 'wp-content/plugins/updraftplus/methods/s3generic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a~F(\'KU', 'sX$!\0#;\rPBN\n', '', 0, '?'),
 ('5o%8|֚', 'wp-content/plugins/updraftplus/methods/sftp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0XtI', '1o?U=0кV0FO%HSf', '', 0, '?'),
 ('hIKr(', 'wp-content/plugins/updraftplus/methods/template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dj5aF@=)%6', 'UNy\\.9Oo|]', '', 0, '?'),
 ('m\'I\"TMW}', 'wp-content/plugins/updraftplus/methods/updraftvault.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8Ml<s9', '\"HB^<\\Jyorc.}f', '', 0, '?'),
 ('Jn>c` ', 'wp-content/plugins/updraftplus/methods/webdav.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#+;', '!f,FȠJ۰h1M+?^X', '', 0, '?'),
 ('*A1^)͡', 'wp-content/plugins/updraftplus/options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm=hvu&9n~', 'C)!Lo\"\nPfOH`a<*', '', 0, '?'),
 ('(7V@+TMC', 'wp-content/plugins/updraftplus/readme.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1w\Z:]7(W', 'gH c:~~<\"2kB@', '', 0, '?'),
 ('*kK,{JS/d/', 'wp-content/plugins/updraftplus/restorer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd%b[|\n&AW', '.EM(\\i*u˒{', '', 0, '?'),
 ('i:xAH=\r3N', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/advanced-tools.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')\0{ƴK[', 'Z<?>J2F~ǒ241Z| ', '', 0, '?'),
 ('5Λ\0eo', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/export-settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JJK(	L\ZXw>!', 'c!ݶ!\0C@J,(eMÏ<S]Z', '', 0, '?'),
 ('p >*oȃ', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/lock-admin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!j<V@뼤!A5m', 'g|*u̳9[ռɕb', '', 0, '?'),
 ('Ƞf1hf', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/search-replace.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ߨ^|a:⥒-', 'k]o!~Xo~9;ʏwhǹC?B', '', 0, '?'),
 ('sE\01J_p0yŹ', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/site-info.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q9ūHr ', '<;7ײ`$[ńmlf*', '', 0, '?'),
 ('*4ЬJRRI<', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/tools-menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#U.#1#{', ']UҚ0Ev\Ztߐ,ҢCl9n	', '', 0, '?'),
 (':82EB', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/total-size.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q0$|޻\"', 'F=R#u*C~d89K', '', 0, '?'),
 ('Vq(¨a#', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/updraftcentral.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f)F|{8\n&', '=`s$U˶#	j[~)k\\m', '', 0, '?'),
 ('$n+F*c\Z', 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/wipe-settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '96x^~Xp#', '#rFI;KɀԢ5b{!OV', '', 0, '?'),
 ('}SU2', 'wp-content/plugins/updraftplus/templates/wp-admin/notices/autobackup-notice.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qyv?/', '	cYR#z1wNu\n', '', 0, '?'),
 ('?L 	Щ.\n', 'wp-content/plugins/updraftplus/templates/wp-admin/notices/bottom-notice.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/7ҤhY$o+', '_4BWIC%v|I\n8׀$9O:', '', 0, '?'),
 ('蛢3םSg', 'wp-content/plugins/updraftplus/templates/wp-admin/notices/horizontal-notice.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hq[{mo:', 'UO8y3N|nL^xB7m&2^§', '', 0, '?'),
 ('C?-I(<$', 'wp-content/plugins/updraftplus/templates/wp-admin/notices/report-plain.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i5\\|', 'aFzoT*g󩿞 Ĭ֐5a', '', 0, '?'),
 ('%iF\Z\"6 ', 'wp-content/plugins/updraftplus/templates/wp-admin/notices/report.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',fSL-I\'v', 'L7H)Т+L\n=<*1\rsɳ', '', 0, '?'),
 ('3EU\"Lw\r', 'wp-content/plugins/updraftplus/templates/wp-admin/notices/thanks-for-using-main-dash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q+fOQRHj', '<(ddb=Ā%0\nN3#', '', 0, '?'),
 ('6cf\r8.k', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/backupnow-modal.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۍ\0}cuE', 'ݓ8y& r4؃>aI8妣x', '', 0, '?'),
 ('u[ۡ6t', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/delete-and-restore-modals.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tN2K}$', ' 6 &+ \"_\'_;r', '', 0, '?'),
 ('=ݖg!Q', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/downloading-and-restoring.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N=Rzge`', 'yg[R-򞥗	l{)K/', '', 0, '?'),
 ('>\Z!A\0E2\\8', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/exclude-modal.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gW&g(. ', '2g;\0	,T~`<ŊfzyE+', '', 0, '?'),
 ('P=W,*)', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-heading.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4I\nZHu', ']^M;Y~\rm@tE]9J', '', 0, '?'),
 ('ߥ]\\;Lc9R\Z', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-submit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z+|x', 'u/DL:E\0~edxfQ', '', 0, '?'),
 ('ƛ=Bqf=x', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/existing-backups-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-Gޮ\\SȰ', '-0<2\r	;2#.}(׶ma\Z-6p', '', 0, '?'),
 ('_yH_y¦E7t', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/file-backup-exclude.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.L=[Go`^', 'D><\Zޮ4K`?SLp', '', 0, '?'),
 ('RPcZb', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/footer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zJi', '{]{`jnا1*', '', 0, '?'),
 ('`{CUVz/Z-', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/form-contents.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']Nsʹ W ', '6A~v7@?$P&e*iy', '', 0, '?'),
 ('bchGmey|D', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fqA2\n\0y', 'Tv	*7\n|tK_i%7}\"Q\Z', '', 0, '?'),
 ('a&_	\'/\n', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/migrator-no-migrator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ǩ8;p#+h', 'Loq_~u+`ǒe\\YM', '', 0, '?'),
 ('lF[FʬIs', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/tab-addons.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.sp$e\"6', '4?;PJM/5ܴ;؎,', '', 0, '?'),
 (']g(^', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/tab-backups.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[I\\L', 'T,f0#.U$kor5o', '', 0, '?'),
 ('GHK	\";#fhO', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/tab-bar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p*~NhAa9', 'J1O\ndmOƲB\0cM5_QR%z|', '', 0, '?'),
 ('IHb=j', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/take-backup.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4.I|%', 'tzr72%tlZ߇pj>8QUu', '', 0, '?'),
 ('1&J\'#25o0', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/temporary-clone.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jsJ=!r3!', 'o?\rصN(&Br-C[', '', 0, '?'),
 ('3G(F;ݰsty', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/updraftcentral-connect.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ͱ˱__)', '\"P9>gMs/0*\"?.kPt', '', 0, '?'),
 ('HPzruԳxq', 'wp-content/plugins/updraftplus/templates/wp-admin/settings/upload-backups-modal.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c-/;x&', ',/r+ERrEi4,`\0', '', 0, '?'),
 ('\rۯjo\Zm?	`];', 'wp-content/plugins/updraftplus/updraftplus.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7ݞ\"[N:s-', 'ί;6ZM& 0q,\r!', '', 0, '?'),
 ('#RyGU,', 'wp-content/plugins/updraftplus/vendor/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-CX\\`a#S{$', 'Aqк	ad]0*M', '', 0, '?'),
 ('bx肞+?\"', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/LICENSE.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JX+/*F', 'XҶN6qTX%IM-زjsޑ', '', 0, '?'),
 ('$Ҹ-蓼ٖҵk', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/NOTICE.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N#bd', '%@yW\n]l.\"Oʿ[_', '', 0, '?'),
 ('6Dzj[', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '˫p\0︽%4 u[', 'm^S9uM*sB?Z?\"KJ=', '', 0, '?'),
 ('VJLR(o!Sh+', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Aws.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm$vl7aXC', 'Շ&Jp!sLw@G-', '', 0, '?'),
 ('J+iJ%', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AbstractClient.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z]<Q{c', 'f\n\0@\05UcMr!t0\"k', '', 0, '?'),
 ('~-FA&+-?', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AwsClientInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TR]A@+4g', '},0HU݊EeuύV;wG', '', 0, '?'),
 ('=0T\\Ņ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ClientBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '͛$)?', ')QDګ|(FMiV^tO', '', 0, '?'),
 ('\rIڡXvm', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/DefaultClient.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EozO=K', ']M\ZJ,q-Ց&8', '', 0, '?'),
 ('k٦#CHge̗y', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ExpiredCredentialsChecker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ﯕKS+', 'P):/S@F\'`=)蔶] ', '', 0, '?'),
 ('O\ZXf͜', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ThrottlingErrorChecker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '21G$[', 'm,avJ[_7)I\"fo	u۬', '', 0, '?'),
 ('jnVR=4ʔ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UploadBodyListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?i]', 'I]Rpzm\0ѡMO6~mס8+', '', 0, '?'),
 ('v_I7:W$ֈޅ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UserAgentListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P5+0$!|', '{=<\n,/7(et>礶eK s', '', 0, '?'),
 ('=+n6y!]1', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/AwsQueryVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'diTܘ', 'uxd&Q*Bpt8(Vg[', '', 0, '?'),
 ('rB.xl', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/JsonCommand.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k^|KSLsg', '=P LJֽ[1v_H7)F', '', 0, '?'),
 ('mG@}bETZ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/QueryCommand.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GH}l	g', 'SGWXZ2HDLf4', '', 0, '?'),
 ('+^$7Y', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/XmlResponseLocationVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EzziW[Z\"|9H', 'V;t4ZCvɝ3#G7Do', '', 0, '?'),
 ('JB?!\'Ax', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractCredentialsDecorator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '棔5,.ը!', 'Ey/azyiX&owW1', '', 0, '?'),
 ('?j[-~0', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractRefreshableCredentials.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k#\\tLh;=', '@+Ŧ^NXr&[:Zj', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('s_=g\"V;', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CacheableCredentials.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';l-a۬Z%G|', 'BĂE0ktYuCxG)m', '', 0, '?'),
 ('Ag#1ԏV]', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/Credentials.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sʙU6aZN', '-\\=ٸ[9O~%M\nÇ36:n', '', 0, '?'),
 ('n~M#k|', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CredentialsInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',8.6', 'Gg^n|*0>їS/*HPrGԚ', '', 0, '?'),
 ('4\'g#4ʯ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/NullCredentials.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',8.`PHDևN', 'T}xd{qZDW+1|) c', '', 0, '?'),
 ('qC4Ǵ5u\'/yd', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ѠUn!lL1', '9\rVZiNﮧYLl;\"D', '', 0, '?'),
 ('F ?1aFc\"6', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/ClientOptions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OTx5Og', 'vʒÐd%46lHo#i', '', 0, '?'),
 ('9Vͷi=%04(', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/DateFormat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A+)d', '[ OuT\\Y|蝯;WȚ|', '', 0, '?'),
 ('F׽Tr<', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Region.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uHW_++', 'X+xKb^N\niEj)wy{ԕ>>', '', 0, '?'),
 ('.6<[;So', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Size.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-I@=<', 'bxėn*R}9i<`JT-ƼD', '', 0, '?'),
 ('t*ƨ<[', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Time.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_nv1', 'sC|3\\+^pܝ Na', '', 0, '?'),
 ('8+X', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/UaString.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BS2Lo', '-:./7d8g`+Pzh\0', '', 0, '?'),
 ('ݨNVЈ9tfLl', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`qϵ=wf4', '֐>EɤO\r;70W@=\0', '', 0, '?'),
 ('i94+蝙䋂', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/AwsExceptionInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rҳ', 'd~fWT}+F_\"Z+f<)', '', 0, '?'),
 ('I[Hm/', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/BadMethodCallException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u, !\n', 'a?(Ɋ	;qU,fqzX5m', '', 0, '?'),
 ('iajKq', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/DomainException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6eC\\XU=', 'K<+R}1#4R', '', 0, '?'),
 ('6<l', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionFactoryInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`廦*&a>O<', 'W\0*0Ooø+zSs', '', 0, '?'),
 ('Eݽ\'`ch#C', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',HiySU~', '3\"odW/f\\6ZnZ', '', 0, '?'),
 ('P$qo$Kؤ:H', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InstanceProfileCredentialsException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!킖(\'I0fC', '3sǶ~?\\M:8', '', 0, '?'),
 ('~ۛ .Db', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InvalidArgumentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd\0enjeR>7', 'x H#:!Sĸ*g', '', 0, '?'),
 ('o=BK,4mx', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/LogicException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SvBtO*.m', 'q 0@斒X1$,w1lէk', '', 0, '?'),
 ('Qq؂noP', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/MultipartUploadException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1a5,7׻', ',+&2SLo]Gtg8++te5OV', '', 0, '?'),
 ('f=׼', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/NamespaceExceptionFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_Τd].', 'je.z\0Iz', '', 0, '?'),
 ('b`sX Y', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OutOfBoundsException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ںmʸ]', 'MJ(1y(F-&^HVҮ', '', 0, '?'),
 ('nH*|wg', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OverflowException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZVVBSy9-u,:', '\0&Ѕ8=y9	aXFN4u', '', 0, '?'),
 ('/m>I#vnk', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R@={}QV{&\r', '05g=Oe撰AꁧA$', '', 0, '?'),
 ('\'A\0UZjt4', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@Y6㎚7', '.~o%3u}Ww?]\0Q̚K&', '', 0, '?'),
 ('c', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/ExceptionParserInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	d<WhJU', '\r3.k\nůFa]l-VTJ', '', 0, '?'),
 ('Tc==g#I', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';M༄Л2o', 'zT|?7±@?3ͥ7X', '', 0, '?'),
 ('gdCZ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonRestExceptionParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',ktN0+Я', 'mⱺK<ByC 8@REHGH	4', '', 0, '?'),
 ('9\"@RZ4', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RequiredExtensionNotLoadedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')G熵\Z\"', '1UŕFtA\r1*x', '', 0, '?'),
 ('>7L', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RuntimeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iBʷA.\\Ӗ ', 'zσ!L,N]vY=KoN', '', 0, '?'),
 ('4V#7JNZ\"o', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ServiceResponseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '><v艗$sHt$', 'WyPuGcU{BO+p?', '', 0, '?'),
 ('z\0EtV', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/TransferException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iv)4JQ{[]@', '7׎Zr-1Ĵ>5X3%', '', 0, '?'),
 ('BesA53', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/UnexpectedValueException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	-C_+', '\0!Q船;duxgˈUZKXA\"n', '', 0, '?'),
 ('e?sH8', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/Facade.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S\"NRz7', 'eQ3d/۵\0)J`@*+q!gz', '', 0, '?'),
 (',ʓCn+', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/FacadeInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GH6mw=', 'w\\7l[W1K\'GdCIUrwF=', '', 0, '?'),
 ('];\0 `\")ӶL', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/facade-classes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd}Cf=Fc%', ' j*.[:cU1\0h', '', 0, '?'),
 ('fv!(0Dgkx-1', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ԓ\\YdoM', 'Ufs73ڎM*m2K(', '', 0, '?'),
 ('\n?0#t^|`', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHashInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|̫&dDԤk', 'F:>p[', '', 0, '?'),
 ('\'PAww5bW', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/HashUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[<aua_%P', '%|<a|F]iGL`9', '', 0, '?'),
 ('$M=m', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/TreeHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vk:M', '\ZY)\"R?6d	O\'PCy', '', 0, '?'),
 (':CtD4', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/HostNameUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':snb', '۾=ȣ\00I,xC&)\Z', '', 0, '?'),
 ('[oE))sZaE', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/InstanceMetadataClient.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VYug&9(', '\\p,\'qS+CME!30ͥ+x', '', 0, '?'),
 ('$@yѡ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.D\Zf1?Ӿ', 'wLRPg\\ҥ=;hRF]w/߃', '', 0, '?'),
 ('r|81=', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}ؙ+oߦ&', '\\!eZd+2\"ju`M\n', '', 0, '?'),
 ('W\'#A[7<9', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIteratorFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CMU;d򫳅1', '*}Y(i	~T	bNON', '', 0, '?'),
 ('R\r\rxl]e', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=iJwXB+', 'y1J-:IR#\rT', '', 0, '?'),
 ('eG\"J', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransferState.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9\"tUB\rGT', 'ڊ bP_6Vܗ', '', 0, '?'),
 ('#82嘨\r	Ѝ`', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>=@Xee', 'zF#=_YSDg9yOy=\"Q;', '', 0, '?'),
 ('Jn;MS6O\ZFr', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadId.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o s}\0R', 'Q\Z\"Yuk^QQYky1C', '', 0, '?'),
 ('}Y}Yy', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\[F)3', ',.BFܻ擦FCйLRPgvׄ ', '', 0, '?'),
 ('Mw^rL<+Dd', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l`\rtiqZ', '&/z#E7M>f/', '', 0, '?'),
 ('bp=Z\\Qڿ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferStateInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zRV6#.1', '\n*\r8<Ye}r&Y', '', 0, '?'),
 ('|D)v8', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadIdInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'$^sl.2;\n/', 't\ry\0Uձ:B\0W ap', '', 0, '?'),
 ('BnNJG', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadPartInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>Ɛ', '<mfx<~_rAh\0y', '', 0, '?'),
 ('L$IOn;\rZ ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/aws-config.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '11Ja\0\Z', '26|OȻ;&;A|Q@6_Z6', '', 0, '?'),
 (']k2-4+', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/public-endpoints.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')@8E[̴_t', ':ТLr`N[dFŘ[K,', '', 0, '?'),
 ('4xyKt4', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/sdk1-config.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '߫ؔ^U=', '^xX zm?iɹp\0R*I3W', '', 0, '?'),
 ('f\\ i	v ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/RulesEndpointProvider.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zm=jiZOW', '➁6 h6aT>2=oPuD', '', 0, '?'),
 (':rpg{1JK', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/AbstractSignature.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fpaf\"_l ', '&|2z@$H4n£\n\0+1', '', 0, '?'),
 ('y{fPG͕', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/EndpointSignatureInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IV{B.', '\0k\'n㭓[|@Q', '', 0, '?'),
 ('O3$(aoZe', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W݅+-', ');jCS>]2s~91͍', '', 0, '?'),
 ('	]X', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YTCge˨', 'T0N9\rފKS} s5', '', 0, '?'),
 ('xB|þ\r.[;q', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"20WRZ', '\\؟ZcEfb5.XqNt', '', 0, '?'),
 ('9w|.', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV3Https.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.Wk3	N', 'E[k;\\Dמ\Zg)b(&Hӓ\"V', '', 0, '?'),
 ('-7;v`!(', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV4.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?\rLޕ', 'Myz_~jJ{#-\ZAq73YU`', '', 0, '?'),
 ('f*	$!}_*N`=', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractResourceWaiter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w:gGAyt', 'ߕX H|#72', '', 0, '?'),
 ('ȐhufDvé3', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractWaiter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ύ`4C', 'TT^.!#bPr\\c08', '', 0, '?'),
 ('*q0utGf', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CallableWaiter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eTM+)y7', 'n,󹍇gK6T˷ܲ:h', '', 0, '?'),
 ('L)D-?k', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CompositeWaiterFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's򺰧)9сI5', '&(8B2jOlm\"+]', '', 0, '?'),
 ('\"\r8s8ޘ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ConfigResourceWaiter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hv4bpڞ', ' %%;6OV\"ū|', '', 0, '?'),
 ('Ѩ>p', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ResourceWaiterInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ځ|A0g~b', 'f={m=\"˒FHXxǆebi', '', 0, '?'),
 ('U	sSR+4', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterClassFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K#4k]', '7oKڔs Fj^1uK)Ƃo', '', 0, '?'),
 ('R2|jn', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfig.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\30P', 'eKVx5zz{m\Z', '', 0, '?'),
 ('\njW;!', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfigFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k0\ZhxV\'x', 'qyP+)htu8rI', '', 0, '?'),
 ('_\nxK[L?\Za', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterFactoryInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4\\YBǶ#Io', 'O}BX:{~ɅR', '', 0, '?'),
 ('C〿Ib', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Zj%,Y$D#9K', '1Ew/ѡ`6_/ܫl', '', 0, '?'),
 ('-.8U`u*', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/AcpListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0.!8GRBw', 'IWIkN\\	%tcq59bF', '', 0, '?'),
 ('{7ժpA', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/BucketStyleListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p\"+o6x	', '.Gt=yD\ZB<', '', 0, '?'),
 ('7QDPSl<', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Command/S3Command.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=^9tP\Z#\'Ì', 'Ti|\\wQ-OeǑ\Zcp', '', 0, '?'),
 ('%kyKK1', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/CannedAcl.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',|c\\yGGO', 'Lj[~ 1eY&7u>jkb', '', 0, '?'),
 ('KuԊE%Z', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/EncodingType.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zBؾj', '=Q0UDm$v0-<|V,Q', '', 0, '?'),
 ('$`.Ob	', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Event.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$1e)', '%\\fm-nC5AZ9i\n', '', 0, '?'),
 ('ηWC<g-PBk', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/GranteeType.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}ɹ_!o^(', 'p\Z}y-K*cHWeو', '', 0, '?'),
 ('(ͫ8?t#3TH', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Group.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lA0_', '\'F-2 {	4uWR .Gi<', '', 0, '?'),
 ('F|.$#', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MFADelete.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!axv^uK8\n', 'ͦ%o޽÷h~V\Z!\"Wu', '', 0, '?'),
 ('I[\0}i	', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MetadataDirective.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'N@ZtTa', 'ENFϐM1YP\nI39*d', '', 0, '?'),
 ('Oqo%9t', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Payer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z8a֞', 'J(D`|1 *\r^vHJ)', '', 0, '?'),
 ('Z{rZ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Permission.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '٠k,\"9G=', '],E4\ZDlj\'r\nCB#ݿ', '', 0, '?'),
 ('\"͹*>\r.3qH', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Protocol.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2ӿnYcfp', '&\Z^MK[9R3vP\\r]', '', 0, '?'),
 ('fTu};r!', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/ServerSideEncryption.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HӤ@@jA ', ':iؚ4I{Y1NuDx', '', 0, '?'),
 ('1\'V\"57', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Status.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ow\'k', 'b Jx̘x3J!II\'', '', 0, '?'),
 ('g!\'ERK+cVsr', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Storage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f/At:M%', '\nkH~POw^LitQə+	_3|#', '', 0, '?'),
 ('[	cC`ĆN76V', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/StorageClass.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '66]N<%g->ȭ', 'Qyyj^fhod#ݻo[WXg', '', 0, '?'),
 ('M֓_-?>\n', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccessDeniedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ϛ~3D@mԔ', '\0ou̟~I$6bɓS?C~', '', 0, '?'),
 ('u!,Mw1Yե', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccountProblemException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NjOf=$=&ƚ', 'HATԢO\0^<C brQu+', '', 0, '?'),
 ('wO+oz', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\1~<fo/', 'f$2DrKLWF2	 ы)', '', 0, '?'),
 ('N`@j<.%', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BadDigestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|S}-:ZFA^', '\\\ZTwr@\Zc;OҲʻ2', '', 0, '?'),
 ('&Ӛ2n`', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyExistsException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j\':\rcGxA', '1k _Y܂V5bn8@]Hz	', '', 0, '?'),
 ('*ɜ;5/P32', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rƝ\ZP', 'K[:۹M=X蘑kkn', '', 0, '?'),
 ('*`z//;', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketNotEmptyException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C\nF\\|', '3.Viq>jy).%L{ՄUV', '', 0, '?'),
 ('Iy+VB\"J20J', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CredentialsNotSupportedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(ߊvİ}!', 'Hv59#*sw2Ȫnkc', '', 0, '?'),
 ('\'~\n>鋅%', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fC/˿^ .`&', ':QmmI*ޞƼ_Z', '', 0, '?'),
 ('0XӍ̨Rzc', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/DeleteMultipleObjectsException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^EݫʗZ', 'Dub@9rgo24+ͻ,$ |w', '', 0, '?'),
 ('O4zb>.{V', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooLargeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c[a@YQmiX', 'YuMx-+0A0kn2๚sh', '', 0, '?'),
 ('%[?XI]eJ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooSmallException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DіNN', 'T4xQ<aE=7<p}', '', 0, '?'),
 ('POY', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ExpiredTokenException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<=<Y', '.W.[0ޣIS;+o', '', 0, '?'),
 ('J[/ϘoߢBX', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IllegalVersioningConfigurationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u0ʛyb8a', 'pWX]\\DE!h){go@v{oS', '', 0, '?'),
 ('+>qFh[(t]q', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncompleteBodyException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8hW?KAif~^', '-sMB\n<-L_zD\'Nh', '', 0, '?'),
 ('P fz\'%]UG#', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w{7*)l', '_G3IkμeGTjIK!', '', 0, '?'),
 ('\r58O	DLu6x', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InlineDataTooLargeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\C3Qm<`', 'd2nIMV	\"}zNe', '', 0, '?'),
 ('\r\"1', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InternalErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vi5P\r\n(J', ' n\\.d_v!]1@lE	h!', '', 0, '?'),
 ('U%3vgI', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAccessKeyIdException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2o3vBۋ', 'vk(h\rqW=1#', '', 0, '?'),
 ('r)m\'Qtt', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAddressingHeaderException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V#g1', '+C6\riׯ1l`P', '', 0, '?'),
 ('Mcجخ;	', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidArgumentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&Ma\n|/	YY', 'sOi2٨9wa⤅W', '', 0, '?'),
 ('ҺEV', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketNameException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8wLgR9ZqL\r', '~q D-$8nrlT=', '', 0, '?'),
 ('H`Jg2J', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketStateException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S=I\ngk|', '<D7O֐3yQ1', '', 0, '?'),
 ('Ɓ̊e,ck', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidDigestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I,#0@', '$oOTܝ	}| C4K\Z#', '', 0, '?'),
 ('1_\'Qs08@', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidLocationConstraintException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd)L2*if', '&vIR>LH$/n)N>', '', 0, '?'),
 ('.@yx[&M', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yrENq(*K.', '%\'DV#:tNPB`>1Q3', '', 0, '?'),
 ('/+gUY*', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartOrderException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(DJBÿrPVT', 'ꨡ9aZ$[,XJr\nB', '', 0, '?'),
 ('lHe@ϑ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPayerException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f/@>M\0GXm', '{9mcϜ^哢wzV>M$W', '', 0, '?'),
 ('ͮLQBfq', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPolicyDocumentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$p#\ZX3*a', '0oS;&v9jRZILį0r', '', 0, '?'),
 ('{D3+cC5$', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRangeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5ΠPDq2', 'vU|dO@0P3[>R', '', 0, '?'),
 ('&ioDT8I', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRequestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DhQk', 'lKf(9΋bHQ\'!μ+', '', 0, '?'),
 ('H=6ܹXZ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSOAPRequestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y<aZZ[K', 'nۊ	X\\D9]Uڥ\"P0iE', '', 0, '?'),
 ('h-=	o:', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSecurityException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2]z`ϵE,', 'S\\מAbу,A1P9 ڇCiX.', '', 0, '?'),
 ('*N7Ɨ\n!', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidStorageClassException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W0qxi!8', '@Cц7?&s(?/s{\'\na', '', 0, '?'),
 ('lXPciy6', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTagErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(\"f]h0\"Ѹ\'N', '#w	)V 1\"gD%wq~?z', '', 0, '?'),
 ('K~16', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tCn`', 'K!8GPprge[όu', '', 0, '?'),
 ('4ar', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTokenException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DYr\r;f', 'ڼ^)?fe4z*\\ҩ+H', '', 0, '?'),
 ('PSpR', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidURIException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9\\Lfxf,fG', ' ÎXQ?OϞ\n/0=ASR', '', 0, '?'),
 ('7?߽oi(?', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/KeyTooLongException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LIH\r', 'kytEUUT;=qe(1+ͣs', '', 0, '?'),
 ('}#\Zgc', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedACLErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '71IL̷b', '%=kyuRtIjQ%', '', 0, '?'),
 ('nBP-`\"6)', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedPOSTRequestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j\rO.}q^8', 'SEUba	gɵ$\"a\0', '', 0, '?'),
 ('7pE48Ƙa0\Z', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedXMLException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?>\rgJա', '-&mV2\'bCfEWsÊ9', '', 0, '?'),
 ('D\r֤a3', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxMessageLengthExceededException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '㘲\r3a&G[', '=>/_cjk;	sgMwBPƦNaπ ', '', 0, '?'),
 ('\\Wm7\'/}BHl', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '</0Su?e3', '􁟹m\n޻yW\0', '', 0, '?'),
 ('fx=<', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MetadataTooLargeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IpZUatom', 'ʐO$Fn$}\\x+AccYs', '', 0, '?'),
 ('^?Vks3Q6\Zr', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MethodNotAllowedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8^$_Z\0s', 'k_\rz]PjWa[HE!4(x', '', 0, '?'),
 ('}Df6]\n4YǸ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingAttachmentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ؙftn o\'', '|0DaIDe:\"CT', '', 0, '?'),
 ('a.~Nr$d\"J', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingContentLengthException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u!\Z/uÑ', 'Qsǥ|̀jT2&}j', '', 0, '?'),
 ('[xbҊ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingRequestBodyErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@+FC!L\nI', '(BDlGLo7S?0oB\nXE', '', 0, '?'),
 ('\ZOTi A1', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityElementException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<n\"\0DR>d', 'IL\0_Bqj@ĥ?', '', 0, '?'),
 ('?UGo^T', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityHeaderException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PH|xjY', 'nc*=Ñ0$+p|`lyRo', '', 0, '?'),
 ('&B&eb', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoLoggingStatusForKeyException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';UMX++=', 'WYˣWʢVWidZӓ8*T\n', '', 0, '?'),
 ('|׵\\O+X', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ggqۧc̕', 'Ĭ	F~Lf&C8G`)', '', 0, '?'),
 (' At', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketPolicyException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PẁC~}?5p', 'dYd/\'rfPz\rqFr!d4r', '', 0, '?'),
 ('7HҜOYC4', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchCORSConfigurationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xD3K402fȕ', '}d322zw;\"7\nOpJF', '', 0, '?'),
 (' ߒSǽ9Z?', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchKeyException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yڛWҰ?߫', 'L>4gR֝+m<', '', 0, '?'),
 ('þ1\r6}', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'!,@m!W+', 'OE\"pI`#b}A-sasXp', '', 0, '?'),
 ('ǩVߪB', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kPV?JLQe2', '*){ޜT=*>\\}܀vS:X', '', 0, '?'),
 ('<ճlb) j', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hgtIʳ*', '#n-uu!E.dP0eG&[', '', 0, '?'),
 ('X6\Z~T*K', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchUploadException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}rv5~Y2G|', 'j>s`u}|4N_RaV', '', 0, '?'),
 ('YYm\\DT4', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchVersionException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qv3Q\\V', '*7Z8P\r繏Jhu׵O=!z', '', 0, '?'),
 ('JWQ&%Xn#!-2', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ثDޕ;L]', 'r,Tv}G[(I=`ﻱwN癬H', '', 0, '?'),
 ('#$PTL zl', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotImplementedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ms0_ɵp', 'G2oB3]Ty\\!z߇q8]', '', 0, '?'),
 ('s@C4 	9', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSignedUpException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+jY\Zr|x', 'UBFˀX/px^C8', '', 0, '?'),
 ('˽AVzd{9`\n', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSuchBucketPolicyException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qK+p̴', '+O~\r)En\0`Y', '', 0, '?'),
 ('ژpǛ$', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I*Iʫ6X', '<aZ/#6\n]I=Ϛ[x', '', 0, '?'),
 ('8L)s0ӣx{J', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':v.\rQ', 'Y颉J1N}g7e(', '', 0, '?'),
 ('@7o;{ ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/OperationAbortedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+M`c}', 'c8ῑ{qrXwiJ%·X', '', 0, '?'),
 ('@@ʹgc@Ϙs', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/Parser/S3ExceptionParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'સv,6c', 'm),-VnzDȕB=4X', '', 0, '?'),
 ('\n%̽5ꢊ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PermanentRedirectException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aFN1<˝ޝn', 'Zh+Qۑq<R0', '', 0, '?'),
 (';wO?0ښB\Z}a', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PreconditionFailedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	b)ɐ9h]', 'k~	RJ\0tD<Q[Lic', '', 0, '?'),
 ('or1sw2S1', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RedirectException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%삆U|Ȃ D', 'J5\0VU}$3_%C}hb6', '', 0, '?'),
 ('dk[D&	D%N', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestIsNotMultiPartContentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#9xzFI3', '@3VFbd<,`d\"', '', 0, '?'),
 ('@Ck5V82tF;B', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeTooSkewedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+ty\"WoM?', ';iݯu].\"l񛀗WFX >', '', 0, '?'),
 ('-\"9\"J%xm.', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeoutException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3.\'2\Z@UP', '\0dX3׶p\':6udSQop4؝6`', '', 0, '?'),
 ('֫ɚیr97*', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b]`NU7$', 'ʼ\',Tw<խ	]\n', '', 0, '?'),
 ('QC', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/S3Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D\\TwkclJ', 'A)$aȦk_\run^\rJUys)hP', '', 0, '?'),
 ('cq}adx', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ServiceUnavailableException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N[	m|`,', ';|Hfg)vLnuMݘVr3@a', '', 0, '?'),
 ('l@Ďm+]l;', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SignatureDoesNotMatchException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' y<\"PϮEE', '\'ޭF00YL_az', '', 0, '?'),
 ('9t~`M3Kor', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SlowDownException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',jV|eͻkf', 'P\0!ޝ)z Kܦ#NUY8', '', 0, '?'),
 (',2BLh>3', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TemporaryRedirectException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=-YJV-tI', '/J.%Z4TgAN5.', '', 0, '?'),
 ('<5u*+R=_+', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TokenRefreshRequiredException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':0Zކ\Z', 'd*4s$5~`:&n4a', '', 0, '?'),
 ('B=*O/>', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TooManyBucketsException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7G`E3o 5C?', 'бa`9IS;5Rv$:NEۆ', '', 0, '?'),
 ('vΙlH$1<', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnexpectedContentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Zz\Zp^\"8>', '=_qp-N_0\"ʥ%', '', 0, '?'),
 ('&*45	;8H', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݬM42+', '=R9C5w6GMA', '', 0, '?'),
 ('[oTNhh$|', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pA\"ǣ|', 'K׬\n׃kNa/dIruU\'-', '', 0, '?'),
 ('J{-mR\"', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/IncompleteMultipartUploadChecker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	WNa	/m^', 'Em5+շĵ4X.yV1', '', 0, '?'),
 ('@UB\0@[Wq', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListBucketsIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')cF_%', '`!\ZbeXPAxHgUbo', '', 0, '?'),
 ('mh١6[w?a', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListMultipartUploadsIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ː[Z?\r\Z$', '50Hݷiǻee:vѵ', '', 0, '?'),
 ('1ZBHxh; g', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectVersionsIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\>y2]', 'ʰɓhq	á0s7F$', '', 0, '?'),
 (' Z', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectsIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')ipJe-', '$PO@$j7m.|ɠ<v&I\"4$', '', 0, '?'),
 ('X#	\r\rp\r', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/OpendirIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z@P#2', 'p=\ZTa-h8BFR.鎿I', '', 0, '?'),
 ('*B3ss$7\Z)\r[', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Acp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=u5FJ/+D', '{n\Zp8(35shx\Z', '', 0, '?'),
 ('R}<[(1!', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/AcpBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|=\"`(r', 'W{s0\')dgy)~\rw', '', 0, '?'),
 ('{y\r\rT1\n>', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/ClearBucket.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RJ꾽r\0', '7WIEܖ:a,GB.E\Zh8F%l', '', 0, '?'),
 ('Iiu񅬔7', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsBatch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$l̅!8!', 'Qpݪ4DD/c$_(|', '', 0, '?'),
 ('(Ιztc', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BEpc', '=mtf\"56ﾠfM=Xc', '', 0, '?'),
 ('^7}$)t4BW', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grant.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Pkr\\ܚ', '2!+q9&Nq&°\ZZ', '', 0, '?'),
 ('?z;_', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grantee.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k6r;HpjԪ', 'vaN?O, -1qV1:>', '', 0, '?'),
 ('eY/	nc,T', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/AbstractTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')27@n\nHG;', 'C\\f9%Z@y\"@M', '', 0, '?'),
 ('I\'nI\'', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/ParallelTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Af\\$ep5P;', 'y-m=̳|~wuv2UT1,', '', 0, '?'),
 ('dTF/p/l', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/SerialTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pN3\ri', 'YPK6h5R_M`U$굽/A', '', 0, '?'),
 ('\rRl0+', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/TransferState.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EHLrhƣF_Yb', 'bNm^-m&1GN1~2Ȍ4', '', 0, '?'),
 ('B#|5*޻I҇/', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!i}ط]', '0OOEofmf{\0AS', '', 0, '?'),
 ('3Fj$ِl:]', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadId.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	%؄!la', '8EN=l(#D<$', '', 0, '?'),
 ('A&n6~9o+ F', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadPart.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '))\rb?', 'm97+UmށgߕPej0EdO', '', 0, '?'),
 ('xir8zb#', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/PostObject.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fs#G8^', 'wb\"piDn-=m', '', 0, '?'),
 ('%v[8+', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Resources/s3-2006-03-01.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qI{\0(0TM\"&', 'zum\rERٶ-!=QN\Z,', '', 0, '?'),
 ('𧩏1ĶP', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/ResumableDownload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WfQ[[', ')ϱ#VJ̙û/̋', '', 0, '?'),
 ('Z	F#\Z+I8>', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iF%lnaGJu[', 'm&=GV ׄcRùD', '', 0, '?'),
 ('ZKpJP[', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Md5Listener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a!fʟD', '14԰K%`r$@	URB6[5', '', 0, '?'),
 ('ꙺUҹ4\"#*Y', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Signature.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' 7[Ud', 'ԈL{VP2.\0Jp+o&ɭ', '', 0, '?'),
 ('GE3?D', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8+<Wx/G', 'XpWU{n CuCX=ӭ5{', '', 0, '?'),
 ('\Z }%;|ɝ3w', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureV4.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?! |k,[N\0', 'ذr7Z5̷ыߩcN+&f(38Ơ', '', 0, '?'),
 ('[g0A\\qԥS3f', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SocketTimeoutChecker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ưk\'f\0	|Ha', 'mK]&h쐓V@\"TIYPK9', '', 0, '?'),
 ('Pc/o5,', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SseCpkListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wDFӉ6', 'a|{a[\\ߚo?i!^$t', '', 0, '?'),
 ('3YSV', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/StreamWrapper.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')5=SV;', '~ϘM&e[UȰT	', '', 0, '?'),
 ('WAYV+', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSync.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ϓ|g~$', 'W\0l/$oX\0sr*\'yd', '', 0, '?'),
 ('{L', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSyncBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mU{', 'Mx,9|IƄOÞH\"G', '', 0, '?'),
 (':=c\\Zϑ`KBC', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/ChangedFilesIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`}VtPSapw#', '=;@5W\"d?\0K1c', '', 0, '?'),
 ('P!.Xb%:PJ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSync.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+>ZQ', 'rc(,W@PyZg;ts)YX ', '', 0, '?'),
 ('RیyfºbjV', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSyncBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D1<H-Z', '$oKnbS>wll$36\\', '', 0, '?'),
 ('tjrn1NE', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/FilenameConverterInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6}YNm}', '\rL\n	t)ZwD5p\n$ϨZMI', '', 0, '?'),
 ('[gn_rpx', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/KeyConverter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '˨\\.Zd	H', '=p<JFN˞AnD-P', '', 0, '?'),
 ('Q5PAd', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSync.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'rz+2以G', '++BYgfU\'^1ݡĆ', '', 0, '?'),
 ('\0,Qlx ^CQ', 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSyncBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Tܷè\")!i', '6rј	%)QUT>!m(C', '', 0, '?'),
 ('xճ=,=', 'wp-content/plugins/updraftplus/vendor/composer/ClassLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 ('F6g{Y R', 'wp-content/plugins/updraftplus/vendor/composer/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']_#D\0', '\Z ے%4~N~Gh!b:wɌ\'', '', 0, '?'),
 ('b<SKz;K\n', 'wp-content/plugins/updraftplus/vendor/composer/autoload_classmap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '߶TZ,pj{', 'J-F i%,5tzno~', '', 0, '?'),
 ('dI\0gIm', 'wp-content/plugins/updraftplus/vendor/composer/autoload_files.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rOD,fR', '37,|agj큜(WFV', '', 0, '?'),
 ('8cDHz万q0', 'wp-content/plugins/updraftplus/vendor/composer/autoload_namespaces.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZRIRPfG', 'FVIJӒ)Q	d	A\"Θt]', '', 0, '?'),
 ('A?OyA/Z<', 'wp-content/plugins/updraftplus/vendor/composer/autoload_psr4.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f!b}^pKk)', 'mHdGB\\$j0]O;s&', '', 0, '?'),
 (']=\r65', 'wp-content/plugins/updraftplus/vendor/composer/autoload_real.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'I{.g9@', 'd [ecPu 	$\0|*/=у\\', '', 0, '?'),
 ('xQG9nJ|', 'wp-content/plugins/updraftplus/vendor/composer/autoload_static.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oH]n^Pg', '<hlSo\"	]8ڼHX', '', 0, '?'),
 ('@]qur|7.5z', 'wp-content/plugins/updraftplus/vendor/composer/include_paths.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BUE&DLQ 6!', '3zl\Z#@U預ZllȪ', '', 0, '?'),
 (')Crp),=e', 'wp-content/plugins/updraftplus/vendor/composer/installed.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ѿ0\r\'(P%\"', 'Mmiq(nϣ(*J;@{!\0DE', '', 0, '?'),
 ('-mDdͰ', 'wp-content/plugins/updraftplus/vendor/eher/oauth/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aon#煵', '\'n+d2]	k81', '', 0, '?'),
 ('<vKŨf+hM', 'wp-content/plugins/updraftplus/vendor/eher/oauth/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\Q95j*>LqX', 'س	ίBe4\0՜Ӂ8ie˳+}', '', 0, '?'),
 ('9bEg<n', 'wp-content/plugins/updraftplus/vendor/eher/oauth/phpunit.xml.dist', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{ouW	:', 'O\"u5=R[y>ɂR}@', '', 0, '?'),
 ('cx~9*Ru', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Consumer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<MWz', 'Eh1v[5KQosEeÿEEk', '', 0, '?'),
 ('x\nԇt,,:n', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/HmacSha1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eꮲI56{4U', ']~G9٫q)],d', '', 0, '?'),
 ('J@p[+;', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthDataStore.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(IY', '5⣏#\ZDʠLM7Pi&(', '', 0, '?'),
 ('V)-Vd', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"ȍbxw)Q', 'h- K<Ax<#7&PI. #{', '', 0, '?'),
 ('?>hkx/m', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthServer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yp?m}', 'O3޻zT\Z*k6\rƁ\Z', '', 0, '?'),
 ('BrIu)b', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/PlainText.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`|2j?3', 'ߌ\"%=ќ/^6ZYg', '', 0, '?'),
 ('4pٺgv猔#', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oX>>LZ4\\', 'DkF\" 2h|Tie$~*>TZ', '', 0, '?'),
 ('о.k', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/RsaSha1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's	׵Fa>', 'q .>\0܂ď+qM4W', '', 0, '?'),
 ('*y4b=^_0', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/SignatureMethod.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xw+;axjt|', '|ts|E*UƔ*kݹ', '', 0, '?'),
 ('9 Lk_', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Token.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qw<\Z-60', 'E\'\'阌2\"սм|gE', '', 0, '?'),
 ('QUWܕ味', 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't>XQ!V', 'sX_լ(c\0BӄOOU`R', '', 0, '?'),
 (':t1Χ%Neb', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/CHANGELOG.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VO', '.%+r= CN#ll\"', '', 0, '?'),
 ('sG}-+vqi', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B,n\Z:tUɾ', 'f6Ѳ`UEjD5*a\ZEQ<', '', 0, '?'),
 ('O_gHgM|A', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4p%3v', '7ab2>xs\"\"PP/5', '', 0, '?'),
 ('SǴl>U*\r=', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/UPGRADING.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{!\Z\rHDZL', 'ts|͡K~/i%j', '', 0, '?'),
 ('QLd}', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/build.xml', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VO~`CX};`Y', 'x\"\n}5q涒kAO8@7?', '', 0, '?'),
 ('c\r?8wF}#', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VymT*,b ', 'ML:=~;$2u\"Zޮv*', '', 0, '?'),
 ('Oj~ּk86', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/phar-stub.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WDKXa', 'vq$uBq2\Z/|PT', '', 0, '?'),
 ('z80Ct', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/phpunit.xml.dist', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F(;biMa', 'G[_l(OA\'0DP', '', 0, '?'),
 ('otp4u', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/AbstractBatchDecorator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'յk!&', 'ⱉ¤	AgϚRX-\0', '', 0, '?'),
 ('口SfF\\', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Batch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',1@b9', '$-GZ˵yǀ\n_BTQ(', '', 0, '?'),
 ('WV\rI~', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XEm3+O^[(u', '`5Hмʄ5d7h!Ca|\'!', '', 0, '?'),
 ('Qyqmr', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureDivisor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T]^P\0k	n', ']3n˹0Zb-peW	', '', 0, '?'),
 ('xsgrS', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CVsybo3`>j#', 'wA/e{zwW&	1ogR]D', '', 0, '?'),
 ('P}L3', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchCommandTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q)XMԭ`@Fv', 'V%9d6M5I', '', 0, '?'),
 ('$2(j,Ѷ?h', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchDivisorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`?2K4t', '~a?oH3`])#)7N+_c', '', 0, '?'),
 ('==xD>*y3', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0#%', '\\6QX{:ֽ	aoZ\\B\ZeJA3', '', 0, '?'),
 ('\Zad8p', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchRequestTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qӨ\'=]', 'q#6W۝\'	VCocઋܨm', '', 0, '?'),
 ('#FĚn', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchSizeDivisor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(#hW_Ev[29!}', 'σG/.drU꩜%8,D', '', 0, '?'),
 ('\0빤>ߡb', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchTransferInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.$E5s{m', 'ȲRk<[z?BP<PA8d]L`|', '', 0, '?'),
 ('ʘGʥo`D', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Exception/BatchTransferException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?O$+dz\0\0', 'cjevFwJߛR4G\"Fo', '', 0, '?'),
 ('(#D(4ڛf', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/ExceptionBufferingBatch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.ʹoCc*Yq', 'jb(^54k6\0EDl\r#\\2', '', 0, '?'),
 ('3y0K bxu', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/FlushingBatch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nl)sc', '}De\'/\"XM/xx%kZۓX', '', 0, '?'),
 ('7?/qm.', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/HistoryBatch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bʼ:Qs', 'M#%yߴenY=ՃaM', '', 0, '?'),
 ('C\ZO\"v![', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/NotifyingBatch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ӑqhj!$:EB', '})!Hs6s\'\nجu?aXK)1pf', '', 0, '?'),
 ('O\r8ƳsO', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VwP3Pi_DGuC', 'j]7Jtwῑ(2(܄Gq', '', 0, '?'),
 ('Fj8\n97T', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/AbstractCacheAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ҙ[e9\rT', '+*[J}ShoJ=[<ٔAL', '', 0, '?'),
 ('F1	ٛ)H', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CڥK*Z|4t', 'ŃbF_asxq`8D!},-', '', 0, '?'),
 ('v竸6Kڐ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j&y\"@tQ', ';0Bc#jukIirR\"L93(', '', 0, '?'),
 ('<6ˤhlb>R_', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/ClosureCacheAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a|	XŤD5Su[~', '9zwL5{!?Y!	f', '', 0, '?'),
 ('CDE', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/DoctrineCacheAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}RDjƻd@', '(t<MAˮ~?$ Кۘ\\2Y9', '', 0, '?'),
 ('\ncn$8:n#j.', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/NullCacheAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sB.QoWkG_', '&殪T>Iecu?~:%%:h\Z', '', 0, '?'),
 ('arqAb@r', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf1CacheAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*I\\V:rd', '!78>vYY^9Nem4J@aܽ', '', 0, '?'),
 (']L<|<2V=T', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf2CacheAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[&E\rR37Cg,', 'T\\`\ZWn/L n:Zfb$$Nv[', '', 0, '?'),
 ('*[h5i^s', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=^_\0F7S', 'R	\0FH\n#^yh+r', '', 0, '?'),
 ('7#i/74ZB', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/AbstractHasDispatcher.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ngb<g[', '\Z#\'Ǔf\n	i=', '', 0, '?'),
 (']\"!29mD7', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Collection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$HLj 	[', 'Y0u_[/PέWQ:', '', 0, '?'),
 ('w.YsT]6]]r', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Event.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9%	(²', '>jKfg]/fMU', '', 0, '?'),
 ('y]|Q', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/BadMethodCallException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' Mߌu.<', 'ݴ߂0b}?\n SHBuL	\"', '', 0, '?'),
 ('qp|<\0*\"=l', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/ExceptionCollection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' 7o-&hR=', 'XY}öN\">C:%l*IgY', '', 0, '?'),
 ('iy91a*s3', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/GuzzleException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tVLmm8b-{e', 'W|FUhy	Tm\r', '', 0, '?'),
 ('n+zohsW', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/InvalidArgumentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vFό:p&`', '1FǛc%Lo]f+[zgy', '', 0, '?'),
 ('RĢAYH', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/RuntimeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P_:)q`{#', 'ibN)֑Q)S#7.', '', 0, '?'),
 ('\Zs)`', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/UnexpectedValueException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!3,S\'', '%:׶sFJp*kb_Fjׂ/L', '', 0, '?'),
 ('0%v+BɌ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/FromConfigInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>bY	PHV', 'c@$ 7ihkğ\ZVuI', '', 0, '?'),
 ('P$u匨((]oRd', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/HasDispatcherInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۨ0k~l<J4', '~_vPGm, CT@*`QN', '', 0, '?'),
 ('&	4|xun', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/ToArrayInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TfXO\'0x', '_al_	~9`r\'p', '', 0, '?'),
 ('(\ni	0', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Version.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\05;ZW', '!\n襗uv2}', '', 0, '?'),
 ('gIk@i@#', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_\0y>eg', '](\'Ip	lCZ41V:Ia.A=4', '', 0, '?'),
 ('̤3kM62D]', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/AbstractEntityBodyDecorator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6Ԧ#hlܞs', 'Y(zk\\ӎ̉1D~Dr$ցˎew', '', 0, '?'),
 ('HL[k%̸qp', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/CachingEntityBody.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U\nfvQ_x%c', 'gdVW8H8-\0E<#{[?x\n', '', 0, '?'),
 ('@)z', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-%5vF\0*', 'У!Vat 1j[x\\sBw', '', 0, '?'),
 ('k;f5k', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ClientInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@l7	3;5sS', 'ƒuHn@d]O$H4', '', 0, '?'),
 ('F; !~l^m', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlHandle.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ll8_6$-	Hg', '\Z2*)OQkG̗*򍵥', '', 0, '?'),
 ('qšbb53', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMulti.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%xqZlZ<?s', '	\n\0vuڗw>_iRav', '', 0, '?'),
 ('\"!O\0[]\04<', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u~i84YkC', '%3	iF̥K\n\02$gsA^2,~', '', 0, '?'),
 ('H/%,/6', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiProxy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڊI_\rtW0', '3LCŊ&Q\027,ރ\ZS]', '', 0, '?'),
 ('դi_玝ΚD\r4', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlVersion.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xW }t]-', 't6FŃ6a#T]>&r{8', '', 0, '?'),
 ('B((ƹݵ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/RequestMediator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rQlW$', 'k|zL\rٖ)PG URKE*j', '', 0, '?'),
 ('#dbiV<', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBody.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^}NYs}7', 'Y\Z_\\a?tbV', '', 0, '?'),
 ('\ro(>R8Gts', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBodyInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ɣ/\\m[~q)', 'X,7jDdv;ft', '', 0, '?'),
 ('}RR^6n,xŁ-I', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/BadResponseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.5}ֲ&6j(~', '~^jlS︐2<8nnIuz', '', 0, '?'),
 ('T))jG|I	Qq', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ClientErrorResponseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʰL@j\nn', 'bƦھuN2GuWtWE', '', 0, '?'),
 ('٬OƤ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CouldNotRewindStreamException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\$tkW', 'ɥ\r k(\0>#\0Z:t]u%.', '', 0, '?'),
 ('@s@/fDS', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CurlException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/OAIΗP', '(,?Lxk3IHh]qW!', '', 0, '?'),
 (')\\EA&b', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/HttpException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y\0leԄ1,}\r', 'dIޗ5K)7?OJ\"jU<K', '', 0, '?'),
 ('Fuйs`!', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/MultiTransferException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r{_d]أ	To', '\'%G2G0qlOLm`0G5\'', '', 0, '?'),
 ('|+7>!ܨr?M', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/RequestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}d	', 'ۇT&#JqN&ߔ\ZKGڂ*', '', 0, '?'),
 ('^^[(J@`5i', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ServerErrorResponseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&!K<UZʛ', 'H?ٗKHwJ5>шa&y>', '', 0, '?'),
 ('C\';Mb5\Z', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/TooManyRedirectsException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sl', '1䎰TݐV@~pVWΧR', '', 0, '?'),
 ('VWo/\\HY', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/IoEmittingEntityBody.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D@<(xHm', '{o\nLO/>e|r)Mqb\n!{\ZB', '', 0, '?'),
 ('4P\0ze8zB', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/AbstractMessage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oSO', 'E8Ӛ%\0 %8\0_`mt', '', 0, '?'),
 ('~HN6|', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequest.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[Hޥ0i5', '!WҪN\0֫(r88A3F4', '', 0, '?'),
 ('Zt\\\0!>\nTIAt', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequestInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tNJS8', 'piz1qaڪ&_;O', '', 0, '?'),
 ('\Z%OH%p', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/CacheControl.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_.@ap', '0f2F=d1RG7/E$Ǣ', '', 0, '?'),
 ('.[=\nc0', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderCollection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RG0n\ny\nh', '1Fi  8bsHľu1t_', '', 0, '?'),
 ('q', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z4ۡ(g[', 'wkj.LT?=EUݛEm', '', 0, '?'),
 ('䋊V!2d-\n', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactoryInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(Eɿ\'j+.T}', 'HٲyGy?-n g`a', '', 0, '?'),
 ('Н_O%^\0)Ł', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Wq{:|e&M', 'f*K}-ݲ$Op*$\'PV', '', 0, '?'),
 ('Y5g', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/Link.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\/]dCHo-', 'x[`ܧfGng.wW|0', '', 0, '?'),
 ('.\\_kfHO', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ஃLz*Bg', 'CԑV,b<pUl%g6', '', 0, '?'),
 ('︀ܹXu_J', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/MessageInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k2bQ-?a', 'xr}`1\08>u6o:', '', 0, '?'),
 ('\\LlA*', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFile.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}9mZ', '8ds~K}AHX%', '', 0, '?'),
 ('\\WdϞ+\nnW', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFileInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' &ʾ\0\"d', 'i8HL&<y<\0 C\0{H6nL', '', 0, '?'),
 ('0^\r', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'æY-[~ ', '+ǡ8ȖJ5r&+<@', '', 0, '?'),
 ('lic`V-,', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';7:ǐY\n,', '-KT?-Ao-0A\Z{', '', 0, '?'),
 ('xb\rrW', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactoryInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nhaw*', 'fk@ϱL1<0Qz3.%', '', 0, '?'),
 ('qXo9F+_', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CǡhF.I`', '1A\"kk%!D\\I,YJ', '', 0, '?'),
 ('4R	:|WTӶBb', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Response.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l	\'Cٽ', 'b4d1K\rQf׬lLHܓ', '', 0, '?'),
 ('+>h )', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Mimetypes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')o<Yb\\f', 'ε?4JcIX̉{̩AȔOy', '', 0, '?'),
 ('/UREǬ6', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/CommaAggregator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gjGm*fYE\\T', '{ޞwn\0qɖ:w$\'WN+Q', '', 0, '?'),
 ('[]cim]Z42', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/DuplicateAggregator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']/p=}qd	;', '\0@do3*Dg㽅6ѴaMvsN', '', 0, '?'),
 ('X12mƇr', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/PhpAggregator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&&4K', 'e=26dAu,#ܥxpri;', '', 0, '?'),
 ('\'tZ<.ն', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n\Zl-cNX\'*7', '	\'e\'es{@^u\0', '', 0, '?'),
 ('[x%0hN,z', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryString.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tTnJxx', '!Y4#@ZJD~4_$', '', 0, '?'),
 ('=K3p*=2l', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ReadLimitEntityBody.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's,sqԟ\0߭b?', 'aVlK~W9!!A\\4Og', '', 0, '?'),
 ('LGE$74', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/RedirectPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2,E4lCA', ':8\'Ii`7s0pL', '', 0, '?'),
 ('~7y&EI', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Resources/cacert.pem', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l32hL-YL', '\\An(W-`[K+v!k;[*#', '', 0, '?'),
 ('RK1Z&A', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/StaticClient.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0_s7=Iǚ', 'y^$Jzz1!x\Z', '', 0, '?'),
 ('Hr>\'=y', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Url.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kNc*&bԏ9F', 'S#I\Z1MX_f^', '', 0, '?'),
 ('Υq:q', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B]jaGCc', '5\n?GU\"g$W@)HY', '', 0, '?'),
 ('GK\n-', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/Inflector.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	BPKS0', '8nhT^}=\'EJP9|', '', 0, '?'),
 ('bFD\n;+', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/InflectorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u3UGT>-', 'Mi\Z3+R}q1IA', '', 0, '?'),
 ('I扙m|h', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/MemoizingInflector.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	z).N<QWT', '\\_ չbw#|.#E,;7Y', '', 0, '?'),
 ('ڊE5^d;', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/PreComputedInflector.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+~P3', '7a?\'l}ƭ/a$^^', '', 0, '?'),
 ('ȣ˕v', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.7N?gK\r}\\', ':qb!J,\\y|*1', '', 0, '?'),
 (';n7Ϸ2', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/AppendIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~#[hoD', ']W7Ci&\'T};', '', 0, '?'),
 ('\ZUcsچH{=', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/ChunkedIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~jmd', '898`գ5i-I\Zj', '', 0, '?'),
 ('zFGUk&', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/FilterIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~\rUFb{iI˦', 'gr&[m\nxHsx\')9ʻ\"A|', '', 0, '?'),
 ('\n19o', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MapIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}(/D.OUtk(', '96E >S#0bf3Y', '', 0, '?'),
 ('j\\hյ\Z', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MethodProxyIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EW!\"`h2', 'IʩdϦ/a4Pu3\rn', '', 0, '?'),
 ('30i]G;', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r\nY)X', '-	ayR[~ُ2', '', 0, '?'),
 ('.Bݝ]P\0yuŴR:p', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NYf-&}', 'OGUO-\"N=·MAC(', '', 0, '?'),
 ('J?<B<kI', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/AbstractLogAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%r(Z2jvۿ', 'VutV_T|#=Yao_\01&', '', 0, '?'),
 ('aGQ7E', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ArrayLogAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|\\؏Ͷjh/4', '*& ;~\"0Fܩjݬ\ZCMc ', '', 0, '?'),
 ('kvcу}1', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ClosureLogAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yF_\0W7ψ', '\0B1z4;V`V9&x', '', 0, '?'),
 ('GNП>e-1vk.de', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/LogAdapterInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gIz.FV:%', '!G儱\0:JAQnZegop|G', '', 0, '?'),
 ('OEA:)(N.ɹ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MessageFormatter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TM*c4E-\'a', '^VĿLPp1Ye#C)', '', 0, '?'),
 ('MlN# x', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MonologLogAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IpF߷o', '4.I0!0yxr](FWJV', '', 0, '?'),
 ('PB)^.L*', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/PsrLogAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U\Z+@D1', 'C<g:xU93Jۖ1\"D', '', 0, '?'),
 ('nQC_$', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf1LogAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V_k\0yĴ', 'v,r4Wp4û*L}xFX/', '', 0, '?'),
 ('Da\\', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf2LogAdapter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nŶYpAkb߉0', '__7]>o7v$-*qX@k\"}F', '', 0, '?'),
 ('Riݨ	Y&j', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q /y SkP5', ':\Z	\nO+a0H!$Av', '', 0, '?'),
 ('^Jb]ryM', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~p_\ZGr 4]', 'K6#o;͖җ	\Z]8NkJ܂', '', 0, '?'),
 ('>A1@a?,', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParserInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Fq͚|#lf', 'Z﵆{5[:!˪', '', 0, '?'),
 ('n0_ڃ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/AbstractMessageParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڲ9c%4k(A5', '˫])LpղxQx%)', '', 0, '?'),
 ('@tQ.}խla+', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',O/ݷ)', '}Ubf|UU٦)fG[9', '', 0, '?'),
 ('j!iOگA^', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParserInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?So\0\Zq9', 'QYzoy^r\\YT8Ɠ،', '', 0, '?'),
 ('x	Ptw\r', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/PeclHttpMessageParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l|1aSÉ8', 'bO=J3EƂs~}e2`kG@', '', 0, '?'),
 ('NSw\'Vey', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/ParserRegistry.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8WYl@\n', '^SWu;QO!ЌsPY͊[', '', 0, '?'),
 ('ӠQVժ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/PeclUriTemplate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O qYYsi', 'cy۫8 O_O>Y§s{%', '', 0, '?'),
 ('AF؅+6U', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ś!^۴+EB', 'a=X\n<9&[LP', '', 0, '?'),
 ('>}^ۛj', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplateInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' ⁀*νjDX', '6	^Q\\s!w$N90$', '', 0, '?'),
 ('ۉvD{', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ef\rh2+\Z1Ԍ(', 'BbgFJ9?ItaAkTl_', '', 0, '?'),
 ('*قI8AR', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParserInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ˌ:Z-', 'balrziQT	SZѓfJk', '', 0, '?'),
 ('{+BSY\0K(', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b2A\'%k', 'Sŵ@Oڪs1', '', 0, '?'),
 ('^\'6ْ{DwBz', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Async/AsyncPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kt', 'TMFjE S(S', '', 0, '?'),
 ('Lǰ@v~', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Async/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۭgZ]̓i7NW', '\'ȏɘRCBٖo`et5BD', '', 0, '?'),
 (':v{V~,', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&=_r2', 'yK;.T\rrs![,.	o,', '', 0, '?'),
 ('*C.\\zx1', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sÿ1.k', 'YZL\0 --a8e\":\\c0', '', 0, '?'),
 ('aBr9d1', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffLogger.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.څR`uDLHP', 'XQt<bmy9#08e3+hn\Z', '', 0, '?'),
 ('b]$vn\rE', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RR͔%', ':rBm.eFF\ncR/\":v5_#LV', '', 0, '?'),
 ('b~no4', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5Խ18/|o/', 'cyz]|a\"樘e', '', 0, '?'),
 ('\\݊;9vC@sԭ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n/h>', '6WD2Ҷ0zdV:SR0h>', '', 0, '?'),
 ('\\h~vgdvS', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8H].̇n\"В9', '|ƴϋ2rgmRl\"`)L', '', 0, '?'),
 ('p`vDX}', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z\0ݽDhĻ%', '\ZϗjĄ!3\r	4>', '', 0, '?'),
 ('03VAtx]', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bt,p7bT', ';4GI7C-R}29', '', 0, '?'),
 ('$\'XRѥʶ۠', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DCiun550g', 'd.ҹ4?-͸e8Qጦ\"', '', 0, '?'),
 ('dփ4ױM/', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z3]^\0sm', '	j_\nV;t\\p8\n', '', 0, '?'),
 ('Ք{۪55ͥ\\', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EJs@qNB>0', '=F|I*5vhOvAhn', '', 0, '?'),
 ('#.ɷLc', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[Qf{B9A', 'PUn[%=_#u_', '', 0, '?'),
 ('=zA4', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '${A\" _K', 'w j)~q	\'q@%M', '', 0, '?'),
 ('š_1]99)}', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheKeyProviderInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a^q-5EZCRA', '=s-oS@TA_ʏe<E{B\n', '', 0, '?'),
 ('AqR', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CachePlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';0K=2g@͍', 'R\\#o; *+zs{JV-F', '', 0, '?'),
 ('%1<qWf	&١', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheStorageInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^F<)ҿ՜l', '뿦\'PT~;MC+@get', '', 0, '?'),
 ('L*̕$G', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CallbackCanCacheStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&/{h4x2', 'MNcc&?)v+<(A\'\04z3v', '', 0, '?'),
 ('SdRI*⌈G9O', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CanCacheStrategyInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sY(XwK7', 'fy!OylF5v Dwi/', '', 0, '?'),
 ('QGgXkq;j', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheKeyProvider.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_e㙩ͮ+', 'i|\r5+j/*sZvD', '', 0, '?'),
 ('`C*r', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheStorage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p~\\\'acl', 'VP%oa<DH+ƶ', '', 0, '?'),
 ('\nΌbm0!1', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCanCacheStrategy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rܜG#i=ö/<', '<t@/|£`ʻ+I\"2ɞ', '', 0, '?'),
 ('GQΚͣ`A\'', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultRevalidation.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '⩩mPyS', '%b<24!cIgc(;cD9', '', 0, '?'),
 ('ΡfWyL,YU', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DenyRevalidation.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w5y؝w]bg', '55dNae^G', '', 0, '?'),
 ('>q^8č/Q', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/RevalidationInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')ETQFu', 'TT\'h.k{&F\'v\0/`\0pcif53', '', 0, '?'),
 ('^pI|\0_yfѹ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/SkipRevalidation.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M9a\'', 'b<w:$t/׼@\n_', '', 0, '?'),
 ('\Ze_m', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l*3E>', 'er8ѓ[hx<1e\r5v+K+w', '', 0, '?'),
 ('%,R_ۀF', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Cookie.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2aC?\rfqn', 'iáꧭx\'AWyVpR5', '', 0, '?'),
 ('s<B){KgO', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/ArrayCookieJar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g;5JDc', '<\"R{1}6y6o', '', 0, '?'),
 ('.RF4	jyn', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/CookieJarInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'Xw<hJLڏ', 'Lr\0QTTdmorƃ4Qj', '', 0, '?'),
 ('4xI:uoQ.\'', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/FileCookieJar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/>!LG', '_\'D6 ЯPY{01MG Ha\0[', '', 0, '?'),
 ('D=xX6ت', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookiePlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[t.ޱƳuu8{', 'ro_Fw\Z$w?@q]Qbf2o', '', 0, '?'),
 ('^輹L&L:', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Exception/InvalidCookieException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jzm#Ir\ny', 'da\ng-GC7~Fܳ+2gh', '', 0, '?'),
 ('yBYW\ZV=5', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MgPyR%:P\ra', '*&=Q!^6Nזm*W9', '', 0, '?'),
 ('43ko3q1W', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/CurlAuth/CurlAuthPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5j>?~[-{', 'wNuǃro;ADfa', '', 0, '?'),
 ('@uX\n\"', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/CurlAuth/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7(]/I3\"', 'xϯemD|A+?f7r[ؾ.', '', 0, '?'),
 ('WbLU^,=@', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponseExceptionInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&3f=g-\n', 'QNF0;7xQ!|h\\?V', '', 0, '?'),
 ('d2[*^Mtlc', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponsePlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ez{8;j\Za', '\\F#am\rX|tARW', '', 0, '?'),
 ('%O6O8', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/Exception/ErrorResponseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9CZg', 'YRWeup{³R>', '', 0, '?'),
 (';F0ߍ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$1yRmq', 'jV=}59ʒ[JF7ګ?', '', 0, '?'),
 ('@Hd3&ʩ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/History/HistoryPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eHs\rORif', 'iմLĢȬ7q\Zp\r]V^', '', 0, '?'),
 ('*9\rSb;;', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/History/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7!,3#$2`', ')l<]s4ʊG', '', 0, '?'),
 ('*YF	N7F`7	', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Log/LogPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{(A,d1B', '#>ig[r1?U0\0', '', 0, '?'),
 ('9=tiv', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Log/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6I0$6m', 'u6a{A0#bTCAm4de', '', 0, '?'),
 ('ʨv.p', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/CommandContentMd5Plugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dIJ>\\', 'c&??rpipWRpE\0è', '', 0, '?'),
 (',L+AO8a=', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/Md5ValidatorPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!+vmٷ޲|', '[Qiv[*G_)C}', '', 0, '?'),
 ('ʯ①1W', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j`nhY\r`', '~el8ڭ-ֆj@BOz([', '', 0, '?'),
 ('/?\rhg;E&T', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Mock/MockPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~S5>,oV.ϡle', '.ѩ\"rF;VڞD', '', 0, '?'),
 ('RlVRѪ@̧', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Mock/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hٞ9l', '{:@q?8U_wxy', '', 0, '?'),
 ('Ii軼\Za', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Oauth/OauthPlugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_mAB\rM%FQ', 'z!.>1YHhd@\Z', '', 0, '?'),
 ('	v5ߙt', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Oauth/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0o֬ļq*', 'P6L*\n_.7.ۤ\0', '', 0, '?'),
 ('I$)ӄ.i\rߖ\0A', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r:{yiQ(b*', '\n46ͳBwcI6A#', '', 0, '?'),
 ('5qn`s~n˝', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/AbstractConfigLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݢyi1+Ɛ^', '%\n|_,JJiX/1	2o@', '', 0, '?'),
 ('Dl)4-0', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'\\/	v', '5>@)n*]uٵb9v/', '', 0, '?'),
 ('W)YG0Aւ?J\Z', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e U\n~ɹ', 'wd\'{.w;Ξ\Z@vH`E7', '', 0, '?'),
 ('$ltyu;R3', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sdu\0Nkga', 'QD?\'>.זBBǶ,Uk', '', 0, '?'),
 ('wDs.}P4H', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/CachingConfigLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',iS\'d', 'VKw0n~1[Z]\00Ot', '', 0, '?'),
 ('\'\"(̟BҬZ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h~gx#}u', 'l*\"J)m1nΈ;$OX1', '', 0, '?'),
 ('zԤХE\'64', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ClientInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ibZKhdL\\', '$CĄ05H~1;p1%Zd>toá', '', 0, '?'),
 ('{(zM', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/AbstractCommand.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^ުz)~c', '^Uw1xNۭE!XNq^d|GJq', '', 0, '?'),
 ('LTn3T+]Op&', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ClosureCommand.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8v0~ۜ߭R$', '1UxfjoI}', '', 0, '?'),
 ('[2:S?/j', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CommandInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OA\'9\'+;姗ax', '!C,V-g$FxZܷ뗆l', '', 0, '?'),
 ('&	Jko', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CreateResponseClassEvent.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3n.nPh=', 's; 2i/[?ڪ;ﻰő`', '', 0, '?'),
 ('\r~/t1jIe*', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultRequestSerializer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p)]zj', '~9%GWB', '', 0, '?'),
 ('\\,p4T', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultResponseParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OjjbwX3', '@\"UsXW5&qVHOr', '', 0, '?'),
 ('aGj>', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/AliasFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rUQGjD5_;', 'c/F;gG}*RFSQɡ\\V', '', 0, '?'),
 ('*\ZJ\ZX7n', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/CompositeFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-\\AbQ*wDD', '(]h?\":X\r.\Zpߵ', '', 0, '?'),
 ('}Dx\">. qq', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ConcreteClassFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n\nz!w><T', 'ȸGnq6S{\nYkO!޿C(t', '', 0, '?'),
 ('*K)]pȡ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/FactoryInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`r?}\\', '5-tP\"xX0w\"2q', '', 0, '?'),
 ('$)J\r`?3', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/MapFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DEW\'&', '\"\'/M-T~JoDu', '', 0, '?'),
 ('7ThSm{\r]', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hPmpC3V', '֎Mg錷3ccɂdw!ͧ', '', 0, '?'),
 ('9w', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E!fD]rKԚ', '0pX7A\Zlǚy2\rfY+', '', 0, '?'),
 ('ߪnnp|', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mYQy', '2ǲ\0}?C\"͋§\r9C', '', 0, '?'),
 ('%eݍw|', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"lѼ)&L{6gG', ';f6)T\"', '', 0, '?'),
 ('/E?', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't>e=8', 'ƤeIMܾ_5L~R㹆Meߝ`Ѩ', '', 0, '?'),
 ('+}>c,-', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	:gJď', '@k*_rd:g$T|&;', '', 0, '?'),
 ('vڝvJ3', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%k7ۻ+', 'h˨d0*U|\Z7!sJˁ̋.', '', 0, '?'),
 ('./CA\0v', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jJI`\rLw', 'I=Q (9ιop/HY', '', 0, '?'),
 ('>9.p;ql', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']D.,Xe', 'nxitS韻C>JZ', '', 0, '?'),
 (' qqUzA~\"', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZJ@M/e_L', '[w-,=LĴ\0)ا{Ζ:K', '', 0, '?'),
 ('Mtm@0IU*T', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UUx3Je)&', 'xꟃEHUiOX32', '', 0, '?'),
 ('\0XnS#5MJ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kȅ{G߭', 'q.9ꃊ)QK!Wtt[\ne', '', 0, '?'),
 ('vq5B@Pf]6Hha', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ͩ#3', 'ֽ=lB壥\0O<d\n', '', 0, '?'),
 ('?U\\|R΢', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C2O?LJ.\"', 'VBں]!$[m3H;?Iglї݃)&a', '', 0, '?'),
 ('k-ow&<}}', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƫY\\Ӥ7iIчU', '\Z}WT0+A ff', '', 0, '?'),
 ('0', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nAjJm8W^IM', 'E|6EJ5XK}\"F>3<f', '', 0, '?'),
 ('D\"enC[`', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#)^sP$', 'ૠHK51FWt=ĖE_Lr~h', '', 0, '?'),
 ('$};/ꃲ{1', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>{O<܅b1', 'o8%d=D-ojSYJK$7', '', 0, '?'),
 ('dd!\n\'0+', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/\"W.r`xD', '|G7W߉\r	)NJQ`J}g\"Q', '', 0, '?'),
 ('jxҁl\\G', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '72c,Y', 'pxeP̋_X\\$8MJZx|', '', 0, '?'),
 ('g\nVT+5', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationCommand.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SO6-7#h\r', 'sNtxwp{', '', 0, '?'),
 ('#;bM[sF,J', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationResponseParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'es!\Z', '	cuZ[Y\0^uO() \0&TL3', '', 0, '?'),
 ('7Ҏ)5?_\\', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/RequestSerializerInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'$Cd\"}|k@', 'XA54Ե7,mҕJ`ݫ\Z', '', 0, '?'),
 ('gn\Z@', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseClassInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pyud#΁S$5', 'Rmե8/fx:Ӑto5~ą[V', '', 0, '?'),
 ('_3t cT!X', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseParserInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xNwy[8', 'YT rlQT\"@u?3x	?', '', 0, '?'),
 ('i뽼i?=', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ConfigLoaderInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+	qL+Sm', 'h\0wgA[Yz?y!ɳ~s', '', 0, '?'),
 ('H$`\rDG|BY', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Operation.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EVI%wF', 'BTXTh96\nrm*>6JM_Lr', '', 0, '?'),
 ('\r\nٽl\'wR7[', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/OperationInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yc٬D[nDK', '+/\r-/-tg!Qhq$', '', 0, '?'),
 ('ԗBLYЄd', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Parameter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Bmu\ZU@', 'hG?ei낲ݿ٘I/d3ة', '', 0, '?'),
 ('/[H3}[F(', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaFormatter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S5»9', 'Z@[	8ƍ>;\'+N', '', 0, '?'),
 ('=܀AjAc', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaValidator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W9Pڠ&B', 'TB>4څJz\'PvUfn', '', 0, '?'),
 ('|js', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescription.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{<B[224;͎=', 'brcs\nvU[/84El!֋', '', 0, '?'),
 ('*ɬ~|$', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pvRGUy\r	f', '$0(p,_;%g=r*p%p', '', 0, '?'),
 ('%hi\r\0IV', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"1:o8c', 'V9{3HO$w_wߝ\':', '', 0, '?'),
 ('KV	llhkukI', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ValidatorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pjmɑ>gGT', '{G!j\Zox', '', 0, '?'),
 ('YB3$', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X:4tqnhm', 'G{]apGRj|)TAd\ZƧVǮ[t', '', 0, '?'),
 ('Z(aK1\'Ẏ', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandTransferException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W.h.C^d', 'dR5e(`cfyTrDٓ', '', 0, '?'),
 ('k$`1.Jr.u', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/DescriptionBuilderException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^{oq>', 'M-βX{Adozm(g>', '', 0, '?'),
 (']KU%9-7)', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/InconsistentClientTransferException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4\'Sh]8B?=', 'Jy)N0ǖܠAħNi*\"ls	', '', 0, '?'),
 (']H߹v;	TLc9', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ResponseClassException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$iMrIa&#', ' I_ځY8;ǋy?', '', 0, '?'),
 ('s(#</4\0', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceBuilderException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',(^N4', 'ܤR#liici:3QG&h_Ƨ', '', 0, '?'),
 ('eZ|˸	v*', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceNotFoundException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',&e5jƛR ', 'ɶ+(,[O\0,_:hJb', '', 0, '?'),
 ('i3,\"uĉZ4\"E', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ValidationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kBGbw>!+', 'z FߓoeU&uw3\Ztc&', '', 0, '?'),
 ('!QKbY.&', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ow&kc', 'grF\n.oUPdǱdgW', '', 0, '?'),
 ('g??a\\-', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rp=þk\n', ' +Y|vssxe\\ zKfI&', '', 0, '?'),
 ('00ɝ4ɥ^u', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/MapResourceIteratorFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I&殀!!T.\"', 'xBfgQU/erUUko8', '', 0, '?'),
 ('Clpt.', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/Model.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	sHYӨ*', '\Z1%Eb}鳢t/DL5', '', 0, '?'),
 ('\Zb@k.i.p', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Bb=x\ZS', '\niV5Ki}EAt7̉\rt)f|<P', '', 0, '?'),
 ('\"soƯaa晐', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$H7RE~', '`\\8j~\ZTR}Du', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('5^Uy#x\rIHt', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorClassFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lN6Y)K/R', 'Gvd\"-ϰ>ɖht#E$[/L', '', 0, '?'),
 ('z[R5v3x', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ghGi\0*T\"\n}', 'GBh	䋚czs\Z,', '', 0, '?'),
 ('ðJ:KqS7Iv', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ge_d٬\n', 'ZGgE\"?3L/', '', 0, '?'),
 ('COU0.&', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z=L9|CR_', 'sި59\\9\ZIƸ>9', '', 0, '?'),
 ('Ƽ®p}tQ$N', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/PhpStreamRequestFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WVѐFQ#ԂB', '0fdgI{{]3t;Rsd', '', 0, '?'),
 ('T(Tved$f', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/Stream.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1\0!', 'j	f\'gH\"Ex2b~F\\e4', '', 0, '?'),
 ('٪#|1\\2Um', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2,ANS[', '%gt隆lpXIѥI@C̲r', '', 0, '?'),
 ('[gPYϖD', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamRequestFactoryInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v-HXH/0D', 'OJ褼TkQ\r.LzY%0DU2', '', 0, '?'),
 ('B2U/HDS', 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's\";K9,>s', 'V}\nK4Tbߡ.S\n͇', '', 0, '?'),
 ('siˆ\"', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/CHANGELOG-1.0.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c;0(I>K\r', ')E]Nee8\\sR)Z', '', 0, '?'),
 ('pn52Wc', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/CHANGELOG-1.1.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xԾ#9 #-c;', '^\0yP	8P4uQ\064(/]2\Z.', '', 0, '?'),
 ('ds^iVb媏bW', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/CHANGELOG-1.2.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kܵ|X/ւA', 'Sl/nPܠfح0Dz9z', '', 0, '?'),
 ('ecW ;3cv|R', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/Gemfile', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wFQBm\ref', 'cȹ#>\r0RrGI', '', 0, '?'),
 (':IwGftF)', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@Fxhh6', '0Ԡ\\Moefoer<)|\ZmDP', '', 0, '?'),
 ('ʼ*M2y', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Oƒ~a', '0uwb/*|<fXL\"Bg\\', '', 0, '?'),
 ('aP`A6qQ ', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w6᭰c\0#', '`R?Ȍ\\1t\n<', '', 0, '?'),
 ('hOMK-\n\n', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/package.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{P2˹kXA', 'Pi5SRyۓ7|G\nB', '', 0, '?'),
 ('F,¢\'!T', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'egJMٝH\\', '%h?\nӺ1EoP/f/\ZY', '', 0, '?'),
 ('sM\Z{}', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Bg/m', 'j](R\Z9N_=k$', '', 0, '?'),
 ('F[RslݘMz', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollectionInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k>9Ǧ:̭', 'ʸT޺%KRǕi>=b', '', 0, '?'),
 ('6p}s', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}/m}硑', '+8Zk`~)v1٪', '', 0, '?'),
 ('}H;a', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetReference.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ӯ-/-', 'jv6];PWf.)苲!-*', '', 0, '?'),
 ('pfxFlc94\"|', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/BaseAsset.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1Xw?m\\$', 'Г pĩ(c3o8%B5IhsL͐U', '', 0, '?'),
 (' smPB8', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/FileAsset.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qg$$5k', '\"eo8oZ\\\"xz%5pa\r', '', 0, '?'),
 ('c]/U`b', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/GlobAsset.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I4RJC0NB>', 'UC81`d\n		YVG<.pu', '', 0, '?'),
 ('r^\rA.]5iy', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/HttpAsset.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[G?hm0b_', '\r]ZhQ6!\'~.bꂨd8I', '', 0, '?'),
 ('q|\rn]>B*y', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionFilterIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7Ү<$ٛ ', '%m.[6A2^aa#(R=\r#*', '', 0, '?'),
 ('tZ@WյE~', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.dY)L', 'sh7tJE_\"0\Z', '', 0, '?'),
 ('\Zc;$Q\"̑=', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/StringAsset.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jTWMIMe', '?-yeP/#', '', 0, '?'),
 (' Q', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetManager.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q`A[\n\\a\0', 'B[p?mpm~#FE,y\0ק', '', 0, '?'),
 ('clhJ>8M', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetWriter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BIb ^wF', 'zEky\nE;1]GmY|', '', 0, '?'),
 ('	Į<~G~', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ApcCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cs* ݦ,R', '\negj]CVsʀE5fDq', '', 0, '?'),
 ('F䃴`\n', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ArrayCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e2Cdn', 'Ai=\']&p#݉1{]\r', '', 0, '?'),
 ('e<LzcU$', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/CacheInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Έ  Cr\Z`', '|ML2~ܥ@&bҺ', '', 0, '?'),
 ('wι2', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ConfigCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h-Sa٬', 'ڤrpu0哗Χ*/I\nU(', '', 0, '?'),
 ('}Y9ØU<', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ExpiringCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/VDS@,2~^ԡ', 'rE\n(16ȇ\\:;fg&Is', '', 0, '?'),
 ('Klb\\1Y', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/FilesystemCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#瞻!\'%8', '̿.o]0!RI凁@ޙ4Ll', '', 0, '?'),
 ('U%DX6fu', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c>#lPE::', '?dr!HY\0@0u[', '', 0, '?'),
 ('tƇwWLD', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/FilterException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~&{Q', '/x%Rl:H4%', '', 0, '?'),
 ('$w(_-sB', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticExtension.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w`̕~?P 3\Z', 'qW:[WM5JnDoRqdT˛J', '', 0, '?'),
 ('\nz(0}', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterFunction.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7}XzA', '$&jzpF#+ec΢{tDY۲', '', 0, '?'),
 ('	X=\'M=@j', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterInvoker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|:a}|x', 'Aĵ VّwCP|aQԹH', '', 0, '?'),
 ('|-I5', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterNode.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=W)}n+SҖs', '.J3\0}\"v\\:ޭק&ǚ#?i;', '', 0, '?'),
 ('&}h5ije&{', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticNode.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'чˀKa\\cxTy', '-dzQ)c8Z>@ΤS?', '', 0, '?'),
 ('Y^2H%y9W', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticTokenParser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QXJu*U\rf]O*O', '<f}{HOڥE>FM', '', 0, '?'),
 ('zGd', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigFormulaLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|7F03jU', 'B*Gtb(MI5s	^F,A', '', 0, '?'),
 ('8e^㰆|Fe', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '79/W9|v', 'Brda7ӷ8`K;l9(Xȸ', '', 0, '?'),
 ('x.а].&Yv', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/ValueContainer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G4Y@Zm/܌v%', 'ӍBߤ-kMdH0,$?,fM<', '', 0, '?'),
 ('{@<Ǚi', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/AssetFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VR.r', ']KU\"4KX^\n.?e@P2e', '', 0, '?'),
 ('SkT$i;oc', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/LazyAssetManager.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʖ	DY', 'DdC:160\rwʍxks-x', '', 0, '?'),
 ('|8\nbMmeNJ', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/BasePhpFormulaLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5,^iME', '	3s2aT3O\nԏh&GBd/', '', 0, '?'),
 ('_qf5Ԍ4', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/CachedFormulaLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nYn}7~ \0\\', 't䣛&`Zz><|XЛzgP', '', 0, '?'),
 ('gjTd(kHo', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FormulaLoaderInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qo@H#', 'p$)f2m4QLRk', '', 0, '?'),
 ('ܺq{dKBw_', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FunctionCallsFormulaLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ԇ]\rNj', 'qkkxL.=E0Ux', '', 0, '?'),
 ('T4,{\\[', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/CoalescingDirectoryResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RV_', 'I\rk],TT	.6X', '', 0, '?'),
 ('&d*ibv!', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/DirectoryResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9^\'J', 'Nj]sCU\'+Ěw2[GDwk;', '', 0, '?'),
 ('wr؋ui', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/FileResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>pv', '3SJ*oiU˗-u	!', '', 0, '?'),
 ('=_^1G', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/IteratorResourceInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!Ȍ%LB{T\\', ')2!lnڡq!', '', 0, '?'),
 ('Ec3$yaXz', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/ResourceInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rfqǏt٠', 'V\\]]*@>|z}\'\"\'M', '', 0, '?'),
 ('wq5X\"5H', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/CacheBustingWorker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F+/*(', 'ޏ;|>}\\p$pʲBZ', '', 0, '?'),
 ('ie@R', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/EnsureFilterWorker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}z7#sFx#', '<_~\nE^l~!,wk7dZf+', '', 0, '?'),
 ('p\rl', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/WorkerInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Cյ_|\nrׅ', 'r\r:NEQa=e!:8F/', '', 0, '?'),
 ('Ά)\'5M&&', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/AutoprefixerFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\08:R\')S', 'lJcmDe\ZL!(\nS', '', 0, '?'),
 ('E\"݄Q́', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseCssFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3z~iiҠGg6|', '	GT{;\n*KXBM3ooN3@H', '', 0, '?'),
 ('nI.r(\\', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseNodeFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_CvLSNP', '9;Z\0#ĵ{7l', '', 0, '?'),
 ('(~	X[', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseProcessFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&:(]u#OaI&', 'YQ<CdT\nζ.Z`RC/', '', 0, '?'),
 ('(*(\rXռ', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CallablesFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '# .Vk', 'qaTbrl\n80k', '', 0, '?'),
 ('ZS}`V\Z~cR', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CleanCssFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')*7r0', 'Ø+\\@)>\01yWbkX\'z', '', 0, '?'),
 ('N\rEl\"+͇3', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CoffeeScriptFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%Q-j\rnE', '_р\rQ{O[nB=<o*6	$.5x', '', 0, '?'),
 ('N<\\_ȴTy*', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CompassFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n\\F\'', ':|zB=9Rd^{jdׄd<', '', 0, '?'),
 ('\";y=ea', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssCacheBustingFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z)gpx3\'?', 'nLةnmx&8Q1\n', '', 0, '?'),
 ('+e2xq&_}', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssEmbedFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EWEX$pE', 'ϫ\'W?	ET#[I(', '', 0, '?'),
 ('3O-rR;', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssImportFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vĜL}8o8', '8;T,D2z*{0C', '', 0, '?'),
 ('j@-3U4Y', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssMinFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']}iYT?', '/tϜTji7:U8Lv@7JW', '', 0, '?'),
 ('`V̻lf', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssRewriteFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PU$޳iR', 'JY\"뱅NÆ;k M@Bʅ}', '', 0, '?'),
 ('Mzt/i]Z', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DartFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M~#]Ek', 'f~=qTV/3OK>X', '', 0, '?'),
 ('T9&vV2I', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DependencyExtractorInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƺ\\0?Buc', 'p/dX+d;bN/Z', '', 0, '?'),
 ('ϘP$d\\G', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/EmberPrecompileFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cU', 'ye\riSrOsX$/J', '', 0, '?'),
 (']\Zkfs?3$/', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterCollection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@aN~Q[7', ')-ҎLF~ <`p$+r.f g', '', 0, '?'),
 ('K9AW|87', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~:1Ho o', 'P<qrMЉb(He=-zJњKM{6', '', 0, '?'),
 ('GJ ~M}JZO', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/BaseCompilerFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c8;ç)ua', 'E1tԨ;VКm\"zTQRi', '', 0, '?'),
 ('\'łEg3#\\', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerApiFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D7r\0t֧HSK|m', 'VHƴf-X ^o', '', 0, '?'),
 ('B<R\'#%׸', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerJarFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.%8RaY͌', 'dM\"B]_\0z2kN\rZ2 sy', '', 0, '?'),
 ('!(/1/w60', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GssFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rӜvg0', '&L+\rm<BZk\0\\O{z%', '', 0, '?'),
 ('Fjoii92L)', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HandlebarsFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j\\r\n\"F', 'uߩ\nFA\\VWnHMJ', '', 0, '?'),
 ('bx%rq', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HashableInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Za<ã_WSX', ',^Ev+蟸8M\nn\0A', '', 0, '?'),
 ('~\n񌵭', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5#	fD+GZ', 'ep$cz/R}h\"8n8\n$', '', 0, '?'),
 ('tfQ/KP', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinPlusFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's8~`xST3', '9sov\no5_iX_@', '', 0, '?'),
 ('*FnM\"', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSqueezeFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p	UМbݼ,', 'aLYakGcT]\'P|*d\Zt', '', 0, '?'),
 ('IP+h', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegoptimFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c-\"gSr`', '(ܧ2R/K|L;S@I', '', 0, '?'),
 ('Pd^d]N ', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegtranFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_7\\&@\n', '§ ]$1TtZ\"efNcn:]dd', '', 0, '?'),
 ('YGl<K', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i&x)OV@V\0', '\njh?zQ({(=', '', 0, '?'),
 ('zO|b2+&S', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessphpFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yDyF?K>\n0', '6qW{zXb$͒z\\H@ ', '', 0, '?'),
 ('#h*l=zQ8', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/MinifyCssCompressorFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I*GKn>dܶ', 'r!Ftpv=2', '', 0, '?'),
 ('|hR~', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/OptiPngFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mgWΊE', 'j%\nCo	ڎf\\-d♍)mQpx', '', 0, '?'),
 ('cq8/lCpm', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackagerFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+\'?=_\0<y', 'z	:ԋ/p2(U({sw&	j~f1T4', '', 0, '?'),
 ('\"[*vOKx-6V', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackerFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mzz=fAH', ',n͞I6Y+d', '', 0, '?'),
 ('P&{C', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PhpCssEmbedFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@-}C3,7', '~>K@h~\'\r7DNyLr', '', 0, '?'),
 ('V\n$]', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PngoutFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<qb(C', ',\r$KjݶOvv	_#\n', '', 0, '?'),
 ('/*%,gcR', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ReactJsxFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '85Yb{f[W', ':7Cւa@ش٥3X&{rbp', '', 0, '?'),
 ('x/x+{!', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/RooleFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/0ۿf\'a\n|!', '(\Z	60\0HmnODL-,vdo', '', 0, '?'),
 ('\r#9p,ਧX', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/BaseSassFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '֫:[m?!P?p', '\n#`bn	H=,k䩱K', '', 0, '?'),
 ('~Ec j', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/SassFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f:Ucl\n', ':\rk<0Չd47=H4{\rG', '', 0, '?'),
 ('p+\ZAnO&', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/ScssFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&rԶ\\Y슞E2N', '}KMg(5&m\Zm3xF%l@V', '', 0, '?'),
 ('lO +', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SassphpFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PŞj6X߈v', 'L._son&A6wO8\"k', '', 0, '?'),
 ('@5*CēE', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ScssphpFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yt\ndfN', 'fJ6<&biG#jG\re^', '', 0, '?'),
 ('bÙ6,/=', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SeparatorFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kɽF[±', '^M	m697J4cu', '', 0, '?'),
 ('	P>(|67d', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SprocketsFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' EIr0 첯9', 'ٰNE4AÞ(\nB>[`X@', '', 0, '?'),
 ('m\nx4@=', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/StylusFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VR\"iR:|/', 'ULc5>\\܍mdݰY(\n6}\"', '', 0, '?'),
 ('\r,SwT^', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/TypeScriptFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~>L/*<', 'K\rJH3yAQ&\'JU0', '', 0, '?'),
 ('SP| \"\"qu', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyCssFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+GB0e5\r', ']-V3إ3R*]j1', '', 0, '?'),
 ('bWyz:\'', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJs2Filter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r1_&-^', ';m 8l[o,g~ujy2', '', 0, '?'),
 ('Wn3O\"', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJsFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fvj=mJFp\Zc', 'rmW[ u~.k4i?TI', '', 0, '?'),
 ('V:S˭%0Q8', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/BaseCompressorFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6	;cTYi', 'Q\n[jUxfhݳaz\Zfǻ>', '', 0, '?'),
 ('HHƶ/qթP4\\', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/CssCompressorFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tAdH', 'TFXEsyyl\"HIj', '', 0, '?'),
 ('zE;|\0', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/JsCompressorFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ap%^\"', '=z=O8kB\'8UPnOj:<', '', 0, '?'),
 ('Tw\n6{', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/FilterManager.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FLr(؟KG', 'ƓN;Q^\rO]WY', '', 0, '?'),
 ('D=b[*WgM', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/CssUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ro,WNSC', 'v<bA5h~G5)qbn', '', 0, '?'),
 ('4pĐ\r]`N\"^', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/FilesystemUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '֖E15zHKKmgY', 'g@n\"[E:7n', '', 0, '?'),
 ('|8T~D\n', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/LessUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J.()%t', 'NV!5#阥7Z&(lբ', '', 0, '?'),
 ('\Z,ڀF', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/SassUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bnR1M', '٢\\zGVy?2#DS*', '', 0, '?'),
 ('@:@=o`0+', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/TraversableString.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/.{#D=DhpH', '+<}ej\r:	Wę&cp6°}w}0', '', 0, '?'),
 ('rߺVK[731=', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/VarUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}.&o͔i', '}b($Cǻ4^0jYtq', '', 0, '?'),
 (')Y` Ьxvz', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/ValueSupplierInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`ߴ\'n>	`', '\\$W1U@g,Nd@8', '', 0, '?'),
 ('[[ۈn_Z	9ps', 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kgW-ZV\0', 'nx!!Jeb2kA۸|1', '', 0, '?'),
 ('$w ym', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/AUTHORS', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@g^?^m', '<6  Aa=*4OH\\;$sd= h', '', 0, '?'),
 ('`<LCuTX]\r', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/BACKERS.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bmcJ>,', 'DfE(bkB\r&M&FPi', '', 0, '?'),
 ('LVJ\\+', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sh)~GRwp,', ']傼S#`<Y', '', 0, '?'),
 ('ٍ\rQ=w05\'', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~t4#Nrm:', 'Vҧ5zD=Y:앋8r\Zt5qD', '', 0, '?'),
 (',-ɀ$?@C1-', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/appveyor.yml', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GLc\"H4j', 'UrT	p)MS3Jh:?', '', 0, '?'),
 ('I?$9\\_oʕ', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bcşJ.m\\', 'gda39LkOd,nR>A', '', 0, '?'),
 ('.MA\r41', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/AES.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x)0R', '	[1ʢ!hhu', '', 0, '?'),
 ('4@Dj`u', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Base.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}1W\\_', '̒Oл?\\)¡an#`0', '', 0, '?'),
 ('Usd3ȧ', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Blowfish.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`H6t\rY`', '^)?{YQJEx%3`x<o%>N', '', 0, '?'),
 ('O,.\'y1ԺKvP', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/DES.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*<дH,\n5$', '?bz4w	\r#pPթРQgw', '', 0, '?'),
 ('/ΰFٞ?', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Hash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G\0 p', '}V+k5O^ݺ1;m{@z', '', 0, '?'),
 ('=7UUv7\0', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v\nK\'Z5D', 'wBF͞}yGg(V:	', '', 0, '?'),
 ('-#ߓ\'EDA', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC4.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>=&nEh`ۉ;\0[', 'ϣ)V\'5\r6S[,)', '', 0, '?'),
 ('u88%[	X', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RSA.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c8vJq!Y', 'T) tA\"Zcw]lZVy', '', 0, '?'),
 ('=hȄk҃(', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Random.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Og} -g', 'RAhHaZbFc1d|\'&pL;', '', 0, '?'),
 ('/\rZq\'\rIi', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Rijndael.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xrxak\rG', 'h|y)mtz**P\'vyFgcY', '', 0, '?'),
 ('4BE4s_X', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/TripleDES.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iڼM>(', '7CUX	nUU¿Bi%Ȁm', '', 0, '?'),
 ('\\2]k^', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Twofish.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ί\rFA', 'r3۾hi-\\kBqsC\nujG', '', 0, '?'),
 ('oc̐ܺP4/]', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ANSI.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gS?͆IPC٭x_', '9\rTQ\n֨A(њWZ', '', 0, '?'),
 ('IpmdWJ', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ASN1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rdt% *n', 'Gs\0g_tȊi՟R\\!', '', 0, '?'),
 ('*O[%*V޶', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/X509.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G!B?Q	>%', 'CPFȫ\'\'\\LOt<', '', 0, '?'),
 ('fGBKH\"WvĴ', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Math/BigInteger.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c%I~˽B\"', '*Ĝֈ;%kwcPrPB^_\rd', '', 0, '?'),
 ('ʽ;,-Gc}ꗟ', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SCP.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SVkP$', 'zSqŚ13AVl*del*ȔP', '', 0, '?'),
 ('!=[d3?', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP/Stream.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q!SGJ9o[C', '/Fu~\rf\nޡ/T3ϸQ', '', 0, '?'),
 ('>s?i}r%7', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dwW|', '.X&lV1C:v0ّC', '', 0, '?'),
 ('9w2~s5E;?', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b&_5kKm	~', 'iU1y\0#FM\\]\Z', '', 0, '?'),
 ('\n<y nmtE=', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MJV5J4', '#t0B|)SK9ց', '', 0, '?'),
 ('!n*]z,F', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH/Agent.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AdwJ2OK', 'u:})33gkH/a7*%*', '', 0, '?'),
 ('P;_kR%kݰn', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH_Agent.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';b\r5E', '61E)\riJK஫/@̋e*', '', 0, '?'),
 ('?R0+TUvLQ\0', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/bootstrap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|Ȱ`-cqF', 'Jϋ&rɪ;9]F', '', 0, '?'),
 ('& b׺g$*V', 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/openssl.cnf', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@#V,aq|Mg', '0^ª#vp< ,xI+,\\', '', 0, '?'),
 ('YwzKσ', 'wp-content/plugins/updraftplus/vendor/psr/log/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZtbryI79J2~', 'KԼiEl19GRMC', '', 0, '?'),
 ('\Zg+o9/bv', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/AbstractLogger.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&`~SaS&', '7Z?ΙAu*/\0G#2F', '', 0, '?'),
 ('O', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/InvalidArgumentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}/X5$9/e', ';5bGSB:e}!q|z6', '', 0, '?'),
 ('S\rUk~Fb+s', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LogLevel.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"aB]9\r9xC', 'nYy\"\0\nd#.eg56d\\>^', '', 0, '?'),
 ('|[f', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ϬmMtѼJ', 'f.%*ƚWnCsSi', '', 0, '?'),
 ('7\"zZJNs', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareTrait.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"G}=\r,&5', '`ٿF`=fy`4nI\0N%', '', 0, '?'),
 ('{6UP\r$P', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lFIg+4', 'S:ZBQ5g@Q	vLgD\n', '', 0, '?'),
 ('A9G]D#M#q{', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerTrait.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C2\\՘80', 'MEIe_sZx/|;Jz·M-', '', 0, '?'),
 ('yK:x}0JFm', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/NullLogger.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',$jB', 'ʃ>7KO}\"HsWÜx', '', 0, '?'),
 (')\n/]\n5J\'', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/Test/LoggerInterfaceTest.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ӟnτ', 'mhP2U>z#^$A(', '', 0, '?'),
 ('10ؐ_5', 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/Test/TestLogger.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_c>\Z=sw', 'Z,$Ҽ\'}q(ϝT^', '', 0, '?'),
 (' HzK~E=r', 'wp-content/plugins/updraftplus/vendor/psr/log/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0sRV1u_', '..vv:38OAi)', '', 0, '?'),
 ('XO1{F`', 'wp-content/plugins/updraftplus/vendor/psr/log/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wkfeDd$I', '\ZF0	4=ND28GY', '', 0, '?'),
 ('-AJfۭb', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/CONTRIBUTING.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b\0uWD$,bEW6', 'O7ęҵ2rF?+\rq38', '', 0, '?'),
 ('])Ѻg', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[dcӮ$', 'ECð_6fgԳ5g', '', 0, '?'),
 ('~fgk', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?i5:.8X', 'jl0	[olQroĿ3{', '', 0, '?'),
 ('$87O_c', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/apigen.neon', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's}Xe{.9\\', 'VE{CmJ#@R-#J3', '', 0, '?'),
 ('wVk{K*', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=/Iki', 'S!?H\r3fެ)@[?fE', '', 0, '?'),
 ('܂&:/\0\"_HF_', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/ArrayAccess.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w|ZTs>Yՠ', '8׾9MjqjzZ)yH', '', 0, '?'),
 ('I}9Lg', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Base.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-PV=lAY', 'KAtYKLRb]q3iv', '', 0, '?'),
 ('4puDI', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ArrayCollection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~eoVU-', '+(TEBn`UHK0v6v48A', '', 0, '?'),
 ('GƦ<-', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/PaginatedIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DKUIjwB', '_jsI6*ºLL\'OV@Jk', '', 0, '?'),
 ('Juami\"d', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ResourceIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ץ/%#kvF_(', 'dB3nqDo}Ϧu	?6', '', 0, '?'),
 ('a)[+o91a\Z)', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8.LLp^', 'yAb-&3CO^', '', 0, '?'),
 ('۩^*%ANiA', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Datetime.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w\"Q3C\\', '\"TMoNFGE	+:+e', '', 0, '?'),
 ('0_j}8IAh', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2uMf', 'U8T¹7ˢL\"(H±', '', 0, '?'),
 ('aóhG^i', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Mime.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*cwmĎf', '(~TX듊(y>*}ܿTSle', '', 0, '?'),
 ('uӨ+̧xTd', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3i&j%9ݜ2', 'KAS\'}\rT8W\Z_L8!%@', '', 0, '?'),
 ('nFu}҉', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Size.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4<k5M\'_D', '0+fUSn|+M<0.+qHKTh`F', '', 0, '?'),
 ('\0\'rO5,8B', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f6\'Z mˡI', 'hh&9EyG;\n#O(~', '', 0, '?'),
 ('cҤ|.L~', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r2:&t~m', '\'(;U=J\rf-rZy/6ިm9', '', 0, '?'),
 ('3kN%_IT', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncHttpError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JЃː&D}', 'FԒ	VI_fn\0', '', 0, '?'),
 ('NRi|CW', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncTimeoutError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ߝECMI`', '8r\ZBxon)=٣cR', '', 0, '?'),
 ('#>Cjӈb!', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AttributeError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hvM?0qh', '8TD{1)[ݴ1Fpe', '', 0, '?'),
 ('S?5L!	*', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AuthenticationError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W{]m	emH', 'ȋh?eu-3ƝP\r)+\rW}=C', '', 0, '?'),
 (')	wJa^(', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/BaseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$u9$hoy%', '7t:s{(,5U)fr7Ox!', '', 0, '?'),
 ('a\'[~p', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ց\\:vø', ';Y]]0Y2hiITnHRF', '', 0, '?'),
 ('&K&ڄXg', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnHttpError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dwU@71	,5', '}~n*k({CM3\0$', '', 0, '?'),
 ('J[dEb', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnNotAvailableError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j\0+6}F\Zٽv3', 'C*}&DZ|n([<', '', 0, '?'),
 ('\Ze\n/]\Z1', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnTtlError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uU\'x~1ÞK', '^\\NxN˰gZ´xi}p4#', '', 0, '?'),
 ('y)wQ!\03`M', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CollectionException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bB!~-Ȇ٭', '>TkH~;oELwpJ\Z', '', 0, '?'),
 ('gD	S', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerCreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nCiS<:Ӹ', '\r9X琅>C!Rxf\\[\'Mǌ', '', 0, '?'),
 ('j@u', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerDeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tԞBޓr7', 'Kı\\:.XSʠEmn\n\0k\\#Z', '', 0, '?'),
 ('Oc[\'ɭ}G', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4Șz3(', 'A7;iДpyKMe)\Z6-', '', 0, '?'),
 ('_185', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNameError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',7fS\'G\'C', '$)C:ʤ\r F4@N=', '', 0, '?'),
 ('LVr@sRC}', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotEmptyError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Jc1z{\'/@EHl>', '(\0- !ߨ:k΢>I\n.Wma', '', 0, '?'),
 ('u\\itz+', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotFoundError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U ,26LM', '\Z\0KTa\r`y*{', '', 0, '?'),
 ('Zʧ#cg/~', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oجѢ3;]T\Z]', 'VI\")B&QJҊ!ٞ\"vC', '', 0, '?'),
 ('gRN', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateUpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' ⮆<_jS<J', '#2k6O؀CJlxN3m91B4', '', 0, '?'),
 ('cОM', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CredentialError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FY?ʊ1s/', '<lI!/{KS|i$6', '', 0, '?'),
 ('2:]\Z<Atb\0,', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseCreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	t2npU^', 'Rù;@0Z`$\\X7ԭȅN{ͻ`	', '', 0, '?'),
 (':RL?&=', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseDeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';yCh}V~>Y', 't9cv|u4NkjE}?5$r/', '', 0, '?'),
 ('^^\\ .޻v\\', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseListError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*soTP29\",]n', '潜n1:7?ܷ!՝âv', '', 0, '?'),
 ('l\nVgƪ', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseNameError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Ku', '?p&kw\Z\"Glr', '', 0, '?'),
 ('CdQ}s_Z $', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseUpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=e@M=&;', ':KТA?y?M|L2', '', 0, '?'),
 ('~y\0dx![>&', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')z<a 0x\"', 'PxeÕV4\0\"\n1ë)6\n', '', 0, '?'),
 ('[t>mк0', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DocumentError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Ov', 'I|zl*\ZUMo-L},`OܷOZ', '', 0, '?'),
 ('[$ַYN;d\"', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DomainError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Nmulv:', '$YJK|oq)]o', '', 0, '?'),
 ('UT}^C	<+', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EmptyResponseError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~j\"W ', 'zY5>:zuW0瀟@#pV@', '', 0, '?'),
 ('nL@H9`', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EndpointError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+%DV=\r~\rL', 'ñ^Ab	#+&Ӧ+UV?s', '', 0, '?'),
 ('U^$lD=Y', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/FlavorError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XoS\\,J\'e', '3_}\"\'\"po+PYE%P', '', 0, '?'),
 ('!\'\Z^SUJo', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ForbiddenOperationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ji\Zm LZ	D', '2lX\'LKs5w<+vN1bDqG`', '', 0, '?'),
 ('#3J:qɭ_', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P^ZF{t_K', 'ʨY=I\r\\S\no0Zz', '', 0, '?'),
 ('Kߨ)@\Z-', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpForbiddenError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\']{xN}', 'Sh);ѩDJfvṗ', '', 0, '?'),
 ('u1>Jel6', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpOverLimitError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pm/d^\rJNo', ']jqn;oz\r	O(H0ࣉ', '', 0, '?'),
 ('ڌ\\D2f&c', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpResponseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!ą,\\kTw', '\0罼%|_[xVh-', '', 0, '?'),
 ('UpHs,M\r*a', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpRetryError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3D0ɺ\'1>M', '\r_y?&oG϶Nn', '', 0, '?'),
 ('Q.izU/Q>', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpTimeoutError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9#w>ò7~<?', 'B\rSj/}~[7P@Ef\"ğ', '', 0, '?'),
 (')»F&ڮh', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUnauthorizedError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/{܇AK&', '<t0ٸS}!/\njʘkDPB', '', 0, '?'),
 ('LwfxΘM', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUrlError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'שa_}Gֶl', 'H[μCQH*EBR\rrt.!=Tx', '', 0, '?'),
 ('d\\oܕκZ', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IOError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{LƲ(', '߁PuQ;琮JG%U', '', 0, '?'),
 ('vzZqr\\@', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IdRequiredError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n,(O', '%͊:SRuI\0G\r,h:[', '', 0, '?'),
 ('01ޟs', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ImageError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' \rVjԈQa', 'p(@k7,Gq?`WF', '', 0, '?'),
 ('Ţ%8vs6', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceCreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ztKi\ZIAW', 'ůC(#\r(\0\'[Θm;x', '', 0, '?'),
 ('\r!ޗL0', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceDeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q59,\rE[9+', '-S\\RkWԩbc S扩', '', 0, '?'),
 ('6BT	8ѝ8', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kth*-x8', 'vyQMhb ', '', 0, '?'),
 ('R~P}*cI:', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceFlavorError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6+5I燋Vp[', '(RYo3\'^D)P,|t', '', 0, '?'),
 ('IA@fAb', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceNotFound.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BZI^', 'dzZb:^=\'S\Z.*=^w1', '', 0, '?'),
 ('b]a255la', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceUpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a\n3p*~\ne=\r', 'pfg!U_#xB,p', '', 0, '?'),
 ('&C|\rUC8', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidArgumentError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ri4Db-${\\I;', 'L͂nM\n2', '', 0, '?'),
 ('\0OiVi`]', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIdTypeError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/I;FAr', 'ʡ.JFoP0@\\ƀh%z>?p', '', 0, '?'),
 ('ՐWB\"Q', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIpTypeError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W+^?ŚЦt\"', '+~=Ladߓ350ϱ]M,7*ϙG͋', '', 0, '?'),
 ('.t9kst7r', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidParameterError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZaJyN_', '*쁮\r<ZłBw^', '', 0, '?'),
 ('i些b6eg', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidRequestError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aMZX	K', 'XBNyU(ү 9@W7l;', '', 0, '?'),
 (';X!\0k.', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidTemplateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nͣMİ97y;', 'U\"qϛgiaY[{\0Rh', '', 0, '?'),
 ('ڛ!{EM$', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/JsonError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K7hh.:k', ')ln#\'SfBߩ/ ĩ', '', 0, '?'),
 (']E4jd)(\Zx+', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/LoggingException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ԝ-+GJ垸', '	/r\"D5˨g>@.D*', '', 0, '?'),
 ('v(>1{L6', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataCreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&\0t\0Cng', 'z/΅H:`R=iXWz2&', '', 0, '?'),
 ('j\n9?KCgO5', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataDeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	hI09*wQ', '퉝IXa[T-J<6)\'Qa', '', 0, '?'),
 ('35SZ;׎x%@', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>1}nafZc(', 'y&<Cֆ7bi	7*!b', '', 0, '?'),
 ('	˦3;e\"', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataJsonError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z1M	gՎ\r', '<HpKѤF\rV:K\Z3', '', 0, '?'),
 ('9 Á!m', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataKeyError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qGlX\ZpJ', 'Noqbw8=Dn7w\0t#}\'v', '', 0, '?'),
 ('$\0Slaşq|\'', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataPrefixError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`imq\r{l\Z', '\Z[6qϽHO\\gnBdG6', '', 0, '?'),
 ('G0YVr޼*', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataUpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';&γe!xh>', '\ri\Z]\"zebw<<\ZZA', '', 0, '?'),
 ('\n¢#ȮU', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MisMatchedChecksumError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7Js?K', 'ޅAOVs9|nyOt', '', 0, '?'),
 ('p:7j!=b#3M', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MissingValueError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B}6K~S', 'Em:\Z+cg*icNyLR', '', 0, '?'),
 ('<n|ޫ0);z', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NameError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|G -As', 'ke v0Q7]<	 eǤ', '', 0, '?'),
 ('@b$YD!A', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkCreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|N\"g)RH', ' 1/*-c{Ԗ&4Mcl3ix=,', '', 0, '?'),
 ('<ajYwr', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkDeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&p	NK', 'vu?>-*/l&	<sXam', '', 0, '?'),
 ('Սs0LBO0&A', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R[h\r}$z', 'W2I\\j^Xs1fpҩ4', '', 0, '?'),
 ('U|Jy>߄cc', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V;Ǎc{', '޳tg%vb	x@\Z[G[JM', '', 0, '?'),
 ('p*1E\'J-S', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUrlError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k$b\0R', '\\\nd(pb#\'&4|>C', '', 0, '?'),
 ('~c5R\"@2', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoContentTypeError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Vi.()v4', '{cx\0x+,d7ri=4x', '', 0, '?'),
 ('n|MOs', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoNameError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']\\B{0G', '\')LYi9>;Bq]\r8', '', 0, '?'),
 ('cKK{7ⴔ)', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjFetchError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l{A(F', '\0	|扭+uP?zCڹ', '', 0, '?'),
 ('FSNfZ\"u', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectCopyError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8)wd', '븪\0d\nT92T嫼VIj0iǵ0<', '', 0, '?'),
 ('h5oC[֒\\˘^Vq7', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/\"΃Yp&F`', 'n,^G~{	S+7ȱ|', '', 0, '?'),
 ('H\0E6@', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RebuildError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(M+Cmk>Bh', '7 	x 1h1$].-_\Z6', '', 0, '?'),
 ('%^p', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RecordTypeError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K6-Sh\"t0˹w', '3\ne*9_	Pw/hY&', '', 0, '?'),
 ('(BY]2\\~Ky', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceBucketException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'JWf*', 'ɳ-6Tv+3#kA˩ LU', '', 0, '?'),
 ('<;H=t~bc:', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceNotFoundException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ąK?↖\\b', '?8&􌠺QfVn^\\<', '', 0, '?'),
 ('Wf&[Oص?Sȏ', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RuntimeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', './*Mi͗', 'sV\"P$}]ućy[rX', '', 0, '?'),
 ('eRWUʖhr', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerActionError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pR);\Z`زy8', '=˨៪<RE\'<,2Y>Ql?o', '', 0, '?'),
 ('tx^z', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerCreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|JtvnUn%%k', '\"\0n)^ʙTO\Z<W<d', '', 0, '?'),
 ('-\0a[Q>', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerDeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nq\0M_0K', 'gtW}TVeiX+X', '', 0, '?'),
 ('J2<\\8Z%', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerImageScheduleError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cG<ӈ޼/', 'ɼ}6Ny(G+n\"+8P', '', 0, '?'),
 ('b//)A1', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerIpsError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';RcP\ZM', 'zEFEؖHm', '', 0, '?'),
 ('lG_Jt', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerJsonError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e`o>HLRU', '~֗AzI-]:ȾE_h6h>', '', 0, '?'),
 ('G9\0&&', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i#҃{9N溵', '^#bdޞW@قv\0arv}:', '', 0, '?'),
 ('UbxBUA[m`J', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUrlError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=5\n-~(bjg]Z}(', 'sO3a}WUp9&AhW', '', 0, '?'),
 ('??#$K', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServiceException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<}\rBƕ70q', 'J@JlS4zCk85', '', 0, '?'),
 ('}_pHD<', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/SnapshotError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n8&i\"', '?Nȟ(U5uQ?6y?Pڲ\Z', '', 0, '?'),
 ('>͙xft\n', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/TempUrlMethodError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2E!EsGe?_', 'P#YfGGÓoJd02JEn><', '', 0, '?'),
 ('}a][ܪ^', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KS+2HAN', 'Y0ZlٚN#h\nN3)', '', 0, '?'),
 ('_9w[o', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownParameterError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7`\"pq!Y\\', '?ҨX%oAӖr%tO.9l޼', '', 0, '?'),
 ('B](P˶', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnrecognizedServiceError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4yEM3f', 'u^MSw(7\0HXZdU', '', 0, '?'),
 ('6#-y', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedExtensionError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f^;.#x!n', 'q<6C\"|3[\Z;^L_ͩf', '', 0, '?'),
 ('tNZ3Ҿ°', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedFeatureExtension.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M8\\3<nBeo', 'zHQ v:LY+6k1', '', 0, '?'),
 ('<ae7z*', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedVersionError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q\"HqyDMB', 'cMPJ=@HPZv*Q[A', '', 0, '?'),
 ('o%@g)`M', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<8l%W9O', 'Ro:mQ:PS6лwy[', '', 0, '?'),
 ('<U֒-\Z/k\Z?Z', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UrlError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*4k<M', 'W+O֦`։ӻogV]ce', '', 0, '?'),
 ('(+,VvP', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserCreateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P^oձ,c', 'Y;9M~jGO+|R$}|k', '', 0, '?'),
 ('hOM->J-Q:', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserDeleteError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '˃$f', '1\r{l5\Z(;o,b]hF*5L', '', 0, '?'),
 ('%4>]\Zw', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserListError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ő%uHI', 'Np>ujۉJ2E	7', '', 0, '?'),
 ('x(-MmWL2', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserNameError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FQ:X', '\'qܺY~8~}	2:&Mn', '', 0, '?'),
 ('4*6k\\,Yhv', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserUpdateError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#5m7`Y,o¾v', 'Ǔl\0ErɿS)bJkx\"n', '', 0, '?'),
 ('PnyK', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>ǯɇ\"Q\Z, ', 'oLyۘG=^{om#j8\"lL', '', 0, '?'),
 ('BGF@k+ѓ<s+', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeTypeError.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>~@Jb.', ' %C/j.E;.3[8Ѹ>', '', 0, '?'),
 ('l\'yK~K ', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '֙\rCӳ]E', 'e3t@MnS7(1\ne', '', 0, '?'),
 ('<\\g	F', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/Formatter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#,ZE', '.E}l_wT\nV;	P;', '', 0, '?'),
 ('j@PrF͊馕', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/RequestSubscriber.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',<B>_C#', 'sjZ\\N7`a[\0MZI\\ߵ3\n@Ӟ-', '', 0, '?'),
 ('fOߠ%bi\Z', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Lang.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nKTq', 'r?swa\"]ve\ZśelڈBwy', '', 0, '?'),
 ('~[\"+\Zqu', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Log/Logger.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G	&\"˸', 'DE8J	jGDGУr', '', 0, '?'),
 ('Z;s~X', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Metadata.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ERtH@GqVV\Zc', ')}3	-hS,ʇ/ח\\N', '', 0, '?'),
 ('<Y{䕾]$j', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/PersistentObject.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N(ڢP6ʚ', 'nΰuXXywVTܳJ\rx', '', 0, '?'),
 ('fYûmEgxD', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/BaseResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l3T&qK.', '/M|I,InKUk.4EKp%', '', 0, '?'),
 ('!CaP-%v\"`', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/NovaResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~%D ;CF', 'I=ao4r6ь!TvMw', '', 0, '?'),
 ('؂i>Ǯd', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/PersistentResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?㽷Ƶ븆', ';)\'\"ά[\"bַX\Zja', '', 0, '?'),
 ('gJӯE--+', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/ReadOnlyResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*+_@{4Gc', 'erO,v*\rbz7~}', '', 0, '?'),
 ('w6?k_+R', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/AbstractService.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C@\\dP', '0yWb/Vbp*0:\".:Qo⽸', '', 0, '?'),
 ('Aǟ8;%\0Eg', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Catalog.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(\Ze\nExqX', 'ևD7߽iT0Bl!rm081', '', 0, '?'),
 ('>E~\0擾W', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogItem.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#@~;#hZ&QI', '4<`8&8paljf$', '', 0, '?'),
 (']9Qo.\nO', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogService.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_7:-UMkJe', ':Ac\0>Ԡ+)#89Ie', '', 0, '?'),
 ('7W_%9Z', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Endpoint.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tCD|i', '*TAY4C(.u\\-q	Y', '', 0, '?'),
 ('~#\rϳ1e', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/NovaService.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ٚF870F', '|kGӄ,.Mn/迕\ZtT', '', 0, '?'),
 ('ЋVjLMzثѺ', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rB^}<CO\"', '5¸VAw\0ZpCRr3HrX', '', 0, '?'),
 ('oxƗW7', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't*#5/\'', '#iޖM@B[/  u9gMm', '', 0, '?'),
 ('Mϩ,ҁXGK', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Constants/User.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڵ@q\'=', 'uKٍWaK~~\"*', '', 0, '?'),
 ('ǂM}GA', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Role.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7ESe<', '>f^1Pf<9DJRDyM', '', 0, '?'),
 ('vP6)U3ah', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Tenant.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Pxe%Ȁ8', 'Xfρ}46NcKKQG\Z', '', 0, '?'),
 ('[\r1K8', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Token.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8*آsz!', ')9<bӿ@Qhɢg;̀e>g~Q', '', 0, '?'),
 ('2 =5a~+,\'j', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/User.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#7@>\"B*', '[6-S.8:}:ͳ,', '', 0, '?'),
 (')t*b<[', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƕ-p%\nrk', '\'ݺ0pa3!(u}LV۽', '', 0, '?'),
 ('aKvꬩFF', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/AbstractService.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x쑡p6JXr0I', '4H\nUlSs1NseW*\0', '', 0, '?'),
 ('f/,\\!\n\n', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/CDNService.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q*+\"2t', '<+yĂɇ@nq@B=|J8C&㎫', '', 0, '?'),
 ('1LgzB<', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/Header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9#z#X(', '5E\0mMf_$r3]6#', '', 0, '?'),
 ('XQ:Iqա0cr', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/UrlType.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z$+_', 'Ew;JT_m4iZx#Bnd\Zd	', '', 0, '?'),
 ('eckO*]', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Enum/ReturnType.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D}ΤwSo!fp', 'l[7;YA*nJo', '', 0, '?'),
 ('ɱ0,x(!c', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/BulkOperationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ҝI\n R', ':c\Zі\n	جM\r\"N`G{	', '', 0, '?'),
 ('h#ٕQY-ai', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ContainerException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p.͋S4;ɭC+s', 'ZI|YE=PCZ\Z@[o9&=', '', 0, '?'),
 ('0jYr\r[{\0', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ObjectNotFoundException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|\0%ql', 'L#ZO<e\rG$M', '', 0, '?'),
 ('?_t׺P', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/StreamException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۂth0Ht{', '/sGx8\'1*Xă:\\ga', '', 0, '?'),
 ('ļ	Y|pt4(', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/UploadException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RTU', 'η\ZzCh`Ha;:n,n3', '', 0, '?'),
 ('.7f[', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractContainer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xE)*o^d?', '/\"vo06Ȇ1{d\0qd\0Po', '', 0, '?'),
 (')knVmGe', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractResource.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Bi\r:\r@P', '1\"WQ$\"I7g6\'Xe', '', 0, '?'),
 ('yvfsYb', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Account.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<^Pj%^6{', '-f]wUoTe({?ǀ', '', 0, '?'),
 ('Б!t$0v&$8', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/CDNContainer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}\Zyb7#', 'P5tk4tI5pmNȗo-', '', 0, '?'),
 ('H	)', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Container.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kZohݏa', '4ԆʇP45|', '', 0, '?'),
 ('<&laL(4V^+', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/ContainerMetadata.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"sC>X', 'A_&-(+h;sĕOcrh9]', '', 0, '?'),
 ('\n(ٓh', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/DataObject.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sF߳Mi/', '$-o(Fh1|Qq޴ϸEn', '', 0, '?'),
 ('Qٳ4f|\nN', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N?dLt', 'p`ȿ|b	Ќh.@s-', '', 0, '?'),
 ('(]Ex{<3', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/AbstractTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ŀ޷v,Z3kCD', 'gOD>+MUAx', '', 0, '?'),
 ('~\rr㴄}\\*', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConcurrentTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JbK$C', 'y+qjHq[Hj', '', 0, '?'),
 ('HF]w?yvy', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConsecutiveTransfer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lo_YҼ', '?Uؚ7I9޶\'TTŎ#ƚ', '', 0, '?'),
 ('lLXiUv8F', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ContainerMigration.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!-0\r#`1U=b$71', 'l0\ZKn񋤉E>\"\\=', '', 0, '?'),
 ('Hbh519', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/DirectorySync.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[Օ#5Mm:i', '[d`zb^R/vC|dBԘ', '', 0, '?'),
 ('AuPsaUs\"', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_ASx', '6kIA͌eL{%3i:', '', 0, '?'),
 ('\0m`!st\0P\0 ', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferPart.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kzs>靡', '!]1!{D3^U6Ι*nh^', '', 0, '?'),
 ('JvOB Ri<', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferState.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%>ߗH)RM', '\"_Nsɐf N?RHn', '', 0, '?'),
 ('拳ĉ3no9', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/OpenStack.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J<ӧsvL%', 'Qr&OY2⑺^̲%(4u', '', 0, '?'),
 ('\\Q^z7Kb\nh^', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Rackspace.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '͒#\rcN', '&HU6ed7v\n_Ӓkd', '', 0, '?'),
 ('1\ng4F.Ke', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Version.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WåHx', 'R}2Micg srw׻w', '', 0, '?'),
 ('$q|#\"	ҹ<', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/php-opencloud.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ĵ֜Pb', 'UTXpŚd8wy>8ǈT\r+x(', '', 0, '?'),
 ('$K>w`^', 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/phpunit.xml.dist', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '߿\Z|{j:s6', 't	~(V	d<FO+[^', '', 0, '?'),
 ('OX,ԫza\"', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/CHANGELOG.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't]gN+8J;q', 'NbߥI\na^ wҬy-G;Rs', '', 0, '?'),
 ('d@Qۅ-Y', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/ContainerAwareEventDispatcher.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&Sq@⬠c', '㣜h&GG5!!wb1-@', '', 0, '?'),
 ('> jꈬZRÏ0', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcher.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6qYmc>u;r', '1Ή:_d@g.koE=9K?l', '', 0, '?'),
 ('AÙ} ', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcherInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	ZU\\#En(P', 's4:W}uq;q\'@zNFľ`', '', 0, '?'),
 ('N3I՛;$', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Debug/WrappedListener.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2K/̇', 'L+zNDE\rvcg0q\nMu', '', 0, '?'),
 ('D\'iQI', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/DependencyInjection/RegisterListenersPass.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qQ:֊3r', 'qԵ\nvZgBz?-)5[Pz', '', 0, '?'),
 ('t$0	,]b&', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Event.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JyPJ', 'Q1vVx`љ\r]=\r', '', 0, '?'),
 ('Jwޏ.?', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/EventDispatcher.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Jt}Vf\\q', ']9@\Z+yUV I', '', 0, '?'),
 (',㺢z] !0Y', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/EventDispatcherInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=cP)ȇG', 'S\"r1JŸ	6*)-{', '', 0, '?'),
 (',Z\nK(', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/EventSubscriberInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dT̚d', '%Uqzύ4k41؊btDFy', '', 0, '?'),
 ('e&cay~k!', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/GenericEvent.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/beX%t', 'ηMzE\r-\'Q>Z攫	R<ا', '', 0, '?'),
 ('3+oY	', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/ImmutableEventDispatcher.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rJƷ\\L5h', '=]\rGl\">!ط.ye6f*', '', 0, '?'),
 (',iT Ne!g	', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6pmzx', '<&\008߫`\0BH)\0iv', '', 0, '?'),
 ('3b<ף|lZoq', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3`t\0c^8Eg', '{oͅ-WFNB&#p', '', 0, '?'),
 ('qH6', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'wy1V,', 'P5(/z[N1KFW	', '', 0, '?'),
 ('ɊWisG~ ', 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/phpunit.xml.dist', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' Rauj)D_8', '@q>>)Sf,MDsgl', '', 0, '?'),
 ('t^fijԷ', 'wp-content/plugins/updraftplus/vendor/symfony/process/CHANGELOG.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GY-8\\EEI24', '꼜O\'\ZRp#7.(,޳3gsv', '', 0, '?'),
 ('}Bؠq_N^u', 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/ExceptionInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r:FJ!y]\n', 'g&mnY\'~:) 4.k', '', 0, '?'),
 ('\0*=/#k#', 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/InvalidArgumentException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yd=l򟳺', 'e=. onҴԿgБeu', '', 0, '?'),
 ('KZ[f:R', 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/LogicException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r>\'[zquM', '`\'ӭƀ˞O02U &h^i', '', 0, '?'),
 ('~7}/[sa', 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/ProcessFailedException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A0J', 'B)RIepVLv%^', '', 0, '?'),
 ('mB:R\Z`[g[v', 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/ProcessTimedOutException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0`s~z^', 'SX*>cB\\:4F+Vq\\-Sy', '', 0, '?'),
 ('hI|\"', 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/RuntimeException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QsPSRz0w[-g', 'FI\\O˄Ʊ[?4{YC', '', 0, '?'),
 ('cx8Sq', 'wp-content/plugins/updraftplus/vendor/symfony/process/ExecutableFinder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'İA{h9&iﳪ', '|(n~#f	_UٌqLXj', '', 0, '?'),
 ('%b	Fy4', 'wp-content/plugins/updraftplus/vendor/symfony/process/InputStream.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ލ^\\\r\0-[', '.b1r^+sFRc', '', 0, '?'),
 ('\nc#<QD', 'wp-content/plugins/updraftplus/vendor/symfony/process/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M^Ͳ=n=Yzy', '0B=M^4dN\0`)*Di', '', 0, '?'),
 ('ި+^', 'wp-content/plugins/updraftplus/vendor/symfony/process/PhpExecutableFinder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '` ,K<BxNmp', 'w	 7.몘9Vw%))UMT]\r\\', '', 0, '?'),
 ('DBR0cZxz', 'wp-content/plugins/updraftplus/vendor/symfony/process/PhpProcess.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.&N9pAK|S', 'R;ީ osZp:\rY\"', '', 0, '?'),
 (' EaŐ=', 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/AbstractPipes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';<vYUrIa', 'E1jNl|ato<S', '', 0, '?'),
 ('*Ii9\n?', 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/PipesInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|f=֏w&;', 'x׽S+@VvKH', '', 0, '?'),
 ('xmf>>%\n', 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/UnixPipes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a*Z;٧,H;', '0/rD$͆i8B', '', 0, '?'),
 ('00{Xdy', 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/WindowsPipes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"*ilբGռZ', 'tsMER)[d', '', 0, '?'),
 ('^e&yԴ\'', 'wp-content/plugins/updraftplus/vendor/symfony/process/Process.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*Z+8?%ﺆW', 'bd~\"yOsXECA6\'Djm', '', 0, '?'),
 ('Kz[hOe', 'wp-content/plugins/updraftplus/vendor/symfony/process/ProcessBuilder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*;ftt2j', 'TpPj{J1sSa@sҰC', '', 0, '?'),
 ('k&ADj#p}g', 'wp-content/plugins/updraftplus/vendor/symfony/process/ProcessUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iE\'', 'iHJ\'woQ2w]Y^kT', '', 0, '?'),
 ('[SNRXFAvX', 'wp-content/plugins/updraftplus/vendor/symfony/process/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X`M\n`', 'LY\nM F?.\r8qRradئ|', '', 0, '?'),
 ('E9ۅϝ:	', 'wp-content/plugins/updraftplus/vendor/symfony/process/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dŹP%V.Hs', '$L~*._.&Gp=WuL`', '', 0, '?'),
 ('#l;K', 'wp-content/plugins/updraftplus/vendor/symfony/process/phpunit.xml.dist', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`&KT', '!y<o5xUk	>UhM+', '', 0, '?'),
 ('*(*+Wjcp', 'wp-content/plugins/wordfence/crypto/vendor/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3Կ:V	U\'', '|<P*tg3dYs/', '', 0, '?'),
 ('BImS967X', 'wp-content/plugins/wordfence/crypto/vendor/composer/ClassLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 ('S\npލG%', 'wp-content/plugins/wordfence/crypto/vendor/composer/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']_#D\0', '\Z ے%4~N~Gh!b:wɌ\'', '', 0, '?'),
 ('a5ͅB_s', 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_classmap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 ('kPP1<', 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_files.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oul_4@', '6b% \"ʴsJp38ӷSǙ:', '', 0, '?'),
 ('MAH\0[d_!', 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_namespaces.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5,}vĨ3G)', 'Er4@\0ԡ$z3$l\Z`iexl', '', 0, '?'),
 ('8YvC[,', 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_psr4.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':\0>}LQ\0', '_U\0]q=Չf\\/	@d\r+v*(', '', 0, '?'),
 ('Zp%\'n\ZWj', 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_real.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ț)W0\nM', ';3Ub}V k\'Yr\nrH)6', '', 0, '?'),
 ('PK2I)', 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_static.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3[hkda4p', '&!7^@9NBT*8', '', 0, '?'),
 ('&PDt?5u1Ym', 'wp-content/plugins/wordfence/crypto/vendor/composer/installed.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' =I,', 'AQTcqPBbt\0', '', 0, '?'),
 ('N\'!\rBj3', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\H!#>bW', '&xwαh)œ@5m.)9R', '', 0, '?'),
 ('F|wZQ,O', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/dist/random_compat.phar.pubkey', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6?\n	:{Q%', 'ZIK/Iw¥OvyEBi\\$G&', '', 0, '?'),
 ('O4ǳWQ\0R', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/dist/random_compat.phar.pubkey.asc', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>ǈ\"Cix', 'x眪!}\ZWd', '', 0, '?'),
 ('.U	Y=', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/byte_safe_strings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h`VAf', '<\\G;1#kLà(փ', '', 0, '?'),
 ('>GOjPlB', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/cast_to_int.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$]\\', 'ؚx\"o*I\nQjT(G\Z.\Z', '', 0, '?'),
 ('1-g97', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/error_polyfill.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#fG\rւBg 0', 'c(k12Qw4?0', '', 0, '?'),
 ('461mYR', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nH\0u} `', 'R&Xd[49VI', '', 0, '?'),
 ('\rX+-Ta', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_com_dotnet.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' O>A+=\Z,', 'UsDMÙd(\0ā~', '', 0, '?'),
 (' vbu)', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_dev_urandom.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=Y@_x', 'ް\Z^3ɟvU.a\r]fhI(sA', '', 0, '?'),
 ('PJt1z', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!EP]ǡ;', '<\0\rIB=\"P8D\"L~I[', '', 0, '?'),
 ('wË9/,+1', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium_legacy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g۰/*C,k#', 'avxu흶j=ISD{!', '', 0, '?'),
 ('YV29}D8', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_mcrypt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CZ?@JN_ji<\Z', '<H\"F@%1`7<	}', '', 0, '?'),
 ('PIcDƾ', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_int.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JsǙB', 'ERJbȸI\"t],qP1\\fD', '', 0, '?'),
 ('IooԆ5nuѭH', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KAct&', ';8%&h1RnJ g0-p\"F1*ts', '', 0, '?'),
 ('??Q$P.:X6', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-fast.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|K-	', '3\\3L\r?B8X\ZN8wCNU=M', '', 0, '?'),
 ('ƄNB׭', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-pedantic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~dNc@G#,', '.\"K|[\0:H/?', '', 0, '?'),
 ('^&`RyJ', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y}Jk>', '/O	¹kbz_B]U', '', 0, '?'),
 ('-췓9ExZ', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/constants.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-glrc]\0', 'AB-q=3zfRrWM4V)', '', 0, '?'),
 ('yKv.\Z', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/namespaced.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5@?U', 'Ʊ#q(Ysq)}', '', 0, '?'),
 ('?HhD0	', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/php72compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^R[XITe)', 'u9 :YnU:syg50=	CW5$eA=', '', 0, '?'),
 ('\n:X2Lnc', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/sodium_compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q(P7APؐdh', 'N~!)Nc~\\n.lFv', '', 0, '?'),
 ('Z(|Z', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QUp~ocÊ4Nt', 'Lnl2@ΐ>hi,uJYH\\L,B', '', 0, '?'),
 ('ν}V+tB', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/BLAKE2b.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '꤀x٠%cl', 'N8,caeΟi<5p$', '', 0, '?'),
 ('!Id]5$[~', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/Ctx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oL k\'k1', '1\\Qt*J%s&', '', 0, '?'),
 ('\'|?>', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/IetfCtx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LaDJ?Z', '=F==<_%=M?u/', '', 0, '?'),
 ('IPEXtFH%', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0Lv[c)?', 'Ch!݀F$}wd7b(!pIF.L', '', 0, '?'),
 ('W= \\\'x\"W}d', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Fe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'թK^㥾', 'M8:naƋGZqQdý!\'&g1', '', 0, '?'),
 ('ZяݒS', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Cached.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l\Z^ZHG%O', 'mc;\ny㐲0,5F|=C', '', 0, '?'),
 (',zeY#uJ~[P\r', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P1p1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' OpR{ҵGݍ', 'Y:BP5Ms_.ن֎', '', 0, '?'),
 ('BKAa<l2', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XߓŒ\"X36DQ', '!l..GI\n7oeѿ\';I\n\n', '', 0, '?'),
 ('\\\Ze	)Up', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȑH\Zb>VDR2', 'rћJԑI/\nOY}xņU ', '', 0, '?'),
 ('bq/Fk', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Precomp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7¤\rFg', 'nV\'VV)F|*ᑝ2Nz', '', 0, '?'),
 ('^Sx_?uGD', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/H.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Hd9<Cˤbl', 'K.Boࣸvb%S~1K', '', 0, '?'),
 ('N=f>$KHT', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?G{g', 'ĀР<W;-\Z񀍙(C+,MUW6', '', 0, '?'),
 ('/؊!N>\n', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Ed25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f<_2S^IZ', 'iݯ8{iq!dՍAz', '', 0, '?'),
 ('YBWy	+BOmz', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#:N\'DxN', '[_|А~E+~E(`_', '', 0, '?'),
 ('KLx<CHe\Z', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-ENĂۛ(\nn', 'Ѭ}^EF>ڂB', '', 0, '?'),
 ('F1+\Z#+d{w{', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.D6pir`fw=', '2KJ73x2M2&+LL', '', 0, '?'),
 ('ESc+#)', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uNmSC{', 'P~{p}x{82hXx', '', 0, '?'),
 ('!Plu6CZ', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Salsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Pe1', 'T*+z]ʜ;>\n3]?x', '', 0, '?'),
 ('ia{-\Zؙo', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/SipHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}<܎s9', 'Q\'r t7=s*a`<zo_', '', 0, '?'),
 ('\"8Y74O<', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'diBDJD5O', 'NaiB\rAO]@P', '', 0, '?'),
 ('jֹJ0Y', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/X25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p0W\"F)8O', '5)&BoK]ػrm`%hO', '', 0, '?'),
 ('	\")\"0Io', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/XChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zq\Zsq776', 'CDa$=f[Q4JW7l).=%', '', 0, '?'),
 ('ZLOl', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Xsalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CFhz', 'oő\nwnpL+;~t2P*ƃ6', '', 0, '?'),
 ('d`#)?ϳ0(w', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Crypto.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' oY-)EHd', 'l,8ETCeylaS;)\'\"d`z', '', 0, '?'),
 ('G<7et/W', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[f0Lş\r{VW', '\'&ܔ[m`ϊc2E%WGW䉷', '', 0, '?'),
 ('th	,Gx\"M', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZP}>j ', 'Mya;>p:/f', '', 0, '?'),
 (' GʴGtؑ', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/BLAKE2b.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lkm>[?', 'c+ZY:{\nJPc\"{4u#', '', 0, '?'),
 ('qL>#Q\0', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/Ctx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BgY', ':IZCZ8ȰL]m', '', 0, '?'),
 ('xLKx 2Is!#Q', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/IetfCtx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rUCB\"', ')M쩂tUδԪF.', '', 0, '?'),
 ('%#t4x', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yW0{XnZ0', '\0AVRXȕ~d^/)@R', '', 0, '?'),
 ('P NtD݌n\"', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Fe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a!,^q', 'X߇pՔZЉֱo\r=˸<!~3', '', 0, '?'),
 ('$P`\0gX', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Cached.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yF\\2', '2ks\\>RI:nHȿDm!zz', '', 0, '?'),
 ('Z9}.Jk=', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P1p1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8I\Z\nӣ', 'i>zR@kW6uky', '', 0, '?'),
 ('Pbw=i', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\\ZIw5AlLۢ', 'K{8fl7sRh嗋I', '', 0, '?'),
 ('-\'gP\\', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9V#ҹ4', 'GpfHv\Zx81C[4A', '', 0, '?'),
 ('AK<jgsr', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Precomp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4Kb(\\pB-', 'ճ* ʰ	[q˜Pk', '', 0, '?'),
 (' ލ<:9|6', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/H.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-_b->O\\苃', 'sɔg%riCPw%{J', '', 0, '?'),
 ('vLM.f%OMR', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4V+=?k\r', '_x:nOsO:d\'\0N=k', '', 0, '?'),
 ('͍ρbB', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Ed25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I%0\\L-', 'bhppv״O#u 5/=9ň)', '', 0, '?'),
 ('oC\"Qty', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+%', '4!H:6>lEEc#a{A{', '', 0, '?'),
 ('*b*ee', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x\\8zM~.', 'vR\0S~[\rҮ6o:Ś\r]', '', 0, '?'),
 ('HY6oD{LH', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zl쇌1gE', ';}-\Z	Ud)sD%R', '', 0, '?'),
 ('➞^՘R', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ohg[', '߁.-h4`9S _\r)I(W', '', 0, '?'),
 ('%$MqT<', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Salsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CUO\ZߠxtH', 'G\n\"_/Agh	U?SsHבYٳ', '', 0, '?'),
 ('̙~Ȍî+byȁ', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/SipHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{숊z;5!', 'D\ZLޠΔa]n\nL&\n', '', 0, '?'),
 ('K0\rܐcn', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ÅKW<S\Z|r_', 'E`w`>.2V\"\0Mp\r 9', '', 0, '?'),
 ('?U\'_l.p', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/X25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o>B	IN-y', 'hl[(l~QuFM	', '', 0, '?'),
 ('gxAȢ}g', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zIjcYKC\0', 'PRV*Īi}kVX', '', 0, '?'),
 (']*.>`Ef', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kFh瀁1-', '6!omݎ^.^@˨v7	I}', '', 0, '?'),
 ('l/<UZA', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/BLAKE2b.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ͣrZw', '#J<L6zqN0f8Z', '', 0, '?'),
 ('-\\[Jץ', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/Ctx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F1	M]', 'A8{!Vt<SqHoh4y`By', '', 0, '?'),
 ('of?3P1\"', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/IetfCtx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g\"̤/OY\'', '8eTet\r jP/J<^rӥz', '', 0, '?'),
 ('71}\n', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '12+;FнNM', 'w\"*5U T@nyȳ^au\'', '', 0, '?'),
 ('wy*XO\nG', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Fe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NVl~m[%Wt', 'Pq\0V{|0m\0;2f@U', '', 0, '?'),
 ('W8h!ɩkĉ\'', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Cached.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rRUb*\0\'', 'x<sBZ2jRM\'0%$i{ V', '', 0, '?'),
 ('ͥ`FJSu', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P1p1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kz+UŸ(5\\', '8:oI9,=zDk8;{A{\Zij', '', 0, '?'),
 ('Ia\n؎a', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>\Z\Z+,', '*y$MQ[q:h\")XTC\0\\k', '', 0, '?'),
 ('cYF}j`', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3b(浏К', 'n;<	Ǖ-Wt]<su', '', 0, '?'),
 ('u_~!\0', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Precomp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y=\nY992', '6\Z/py5EحOE', '', 0, '?'),
 ('o	lѴcd', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/H.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n@LjwD', '\r8d8sڇ6FȌ', '', 0, '?'),
 ('~+qX\"`', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oaQ|g4&', 'cUX+]Wvd=,Z0)\\', '', 0, '?'),
 ('h]CA*', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Ed25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZbO6IcD', '`ude?s7dCQ}Y/', '', 0, '?'),
 ('_npaV', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>*L1˵\"k%F+', 'ZiMfUvi-})f\"Mnd?X', '', 0, '?'),
 ('Xp~0D', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Woe~oB2_;', '5qSrL]OXsq+l<ɒ', '', 0, '?'),
 ('A?]\\8PMTl', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int32.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CB)cae', '[}D\0OV:~-\"~mBh\"<pW', '', 0, '?'),
 ('BPXW6', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int64.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' QAL󚜆U', 'G\n<.\ZWrʪØ)', '', 0, '?'),
 ('[\'/;', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D2E\\t.-', 'U\n/miMyE-QM^\0QL9hT', '', 0, '?'),
 ('a@WrQwZ\n.', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ܑzg<N\n?o6f', 'REgX3JAc!a_S{', '', 0, '?'),
 (' K iDt', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Salsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Zz#H', 'n]x\Z_ѪkB-a&̃', '', 0, '?'),
 ('_#U1pGS', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/SipHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Zrtw(e', 'ҿDI<^i2dW]G_-+A8W', '', 0, '?'),
 ('?FϸAR1', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pԏd0lN&7+', '^s\n@G,ږ\n;|3P	nԔ/\rzA\"\nd', '', 0, '?'),
 ('/	E:KR寥v', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/X25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0Vή?b4', '=ޣ4:$dXWRXN >', '', 0, '?'),
 ('z9	`d3\0Iay', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' @^8J', 'ؽ@B-Km-Ȼ\Z2p', '', 0, '?'),
 ('B@R*GxF4N}', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'_?Sş\Z]y', '6[-,9YRr\rY\"-an6$', '', 0, '?'),
 ('GGa\"', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ÕmANR', ' *J/(sg YD]و̨|\0z', '', 0, '?'),
 ('aJr&-D', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto32.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b]݆щpW', 'ド$⨇\r׶oޖGǗq#7', '', 0, '?'),
 ('XX*!2~', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƌ@N`Xg', 'Q&3Ɓ_+i	uqI+:	IO', '', 0, '?'),
 ('TL ߈,]զm', 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/SodiumException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8	:{We', '6{w^GkΫ25b\r񓫄', '', 0, '?'),
 ('O	5mCf', 'wp-content/plugins/wordfence/css/activity-report-widget.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J^x;yc', 'ӡfaMWv+W%}`DN', '', 0, '?'),
 (')?) l\0', 'wp-content/plugins/wordfence/css/diff.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '܀g		$`rQ', '$hEJ^54<$ӭYc&', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES(']@\ZJCy>ł', 'wp-content/plugins/wordfence/css/dt_table.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gJbjJ9k:', 'o[PHyЊ}iGc~<cDR:D', '', 0, '?'),
 ('iț,7bWSe', 'wp-content/plugins/wordfence/css/fullLog.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e.i`΁Uv', '?>?hξ[²Pu{puaa', '', 0, '?'),
 ('hr\Z;%e-x', 'wp-content/plugins/wordfence/css/images/ui-icons_444444_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GJu;QZ6', '\\MUKhQwCiVJ\'', '', 0, '?'),
 ('2v\'9\rz', 'wp-content/plugins/wordfence/css/images/ui-icons_555555_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pbD@pG+', '*DZ>Bg&YY4(</', '', 0, '?'),
 ('\Z R[\'>', 'wp-content/plugins/wordfence/css/images/ui-icons_777620_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J\\c7yxгl', '~qV*\'1]3^m', '', 0, '?'),
 ('2r}Vĥ$^n/', 'wp-content/plugins/wordfence/css/images/ui-icons_777777_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h^n=(&݂N&', 'SDIBz_-?(YpEyƹA', '', 0, '?'),
 ('\\7Qo', 'wp-content/plugins/wordfence/css/images/ui-icons_cc0000_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|%;wQ8@', 'wi>6Ƭ4.NC\Z4IO', '', 0, '?'),
 ('vO#JN+쁁', 'wp-content/plugins/wordfence/css/images/ui-icons_ffffff_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aa+JD$2J', '/#?TiOLyvuTKɤ\\ػ', '', 0, '?'),
 ('āz8̡\rHt);', 'wp-content/plugins/wordfence/css/iptraf.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ebf.\nV[xPh', 'J-@ ]-	cqWQ$8', '', 0, '?'),
 ('(410\rьR[', 'wp-content/plugins/wordfence/css/jquery-ui-timepicker-addon.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')ef#`P~7n', '-mznNFE\0ѭ\\vqsL?Z\Z', '', 0, '?'),
 ('rtxn#ehl', 'wp-content/plugins/wordfence/css/jquery-ui.min.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}O^0tGGQ', 'ٍ$rb=phxK5]8QRjn4', '', 0, '?'),
 ('w̹5O+a', 'wp-content/plugins/wordfence/css/jquery-ui.structure.min.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#/h<U', 'ni뗅NvX7Y]D', '', 0, '?'),
 ('\'w1ϰ', 'wp-content/plugins/wordfence/css/jquery-ui.theme.min.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bK0bxљ]', '4\ncE2=V{+\\goЅO', '', 0, '?'),
 ('Ts@,g,', 'wp-content/plugins/wordfence/css/main.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';诘SoȢ-', '\n2V\'Kf94Qr: 2', '', 0, '?'),
 ('q#/Ni', 'wp-content/plugins/wordfence/css/phpinfo.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>Q!0w/蓴', 'a@|I\r=\Z^εd)[W', '', 0, '?'),
 ('f\Z&4X2e]mى', 'wp-content/plugins/wordfence/css/wf-adminbar.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0\"CϷTb', 'hS䘷*g5)!}BlNE', '', 0, '?'),
 ('UzfLȔ@k', 'wp-content/plugins/wordfence/css/wf-colorbox.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PX)p!N8j', 'ot0\rP2NiKu', '', 0, '?'),
 ('dh', 'wp-content/plugins/wordfence/css/wf-font-awesome.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'MًV:', '997dIOu-%enԻ1I', '', 0, '?'),
 (',j\n((|k/;m', 'wp-content/plugins/wordfence/css/wf-global.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p]$ڡ\n', '淇tj?\"E\0$Ӝ Nhq3{', '', 0, '?'),
 ('9&ޝZz+d', 'wp-content/plugins/wordfence/css/wf-ionicons.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Alsj⯃', 'ג4ˮvM`VZ', '', 0, '?'),
 ('\nQo7gEj', 'wp-content/plugins/wordfence/css/wf-onboarding.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/KwtG\'(', 'mǸ${&W>.{?Wo)=H', '', 0, '?'),
 ('SDXiK', 'wp-content/plugins/wordfence/css/wf-roboto-font.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']Ouݵ', '+hJ~ʆ*a*Gb67\r:', '', 0, '?'),
 ('p2r}m_G', 'wp-content/plugins/wordfence/css/wfselect2.min.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c3,BV', 'ڑt4U\";t7\ZJyrb@', '', 0, '?'),
 ('bj`#x!', 'wp-content/plugins/wordfence/css/wordfenceBox.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CWY~H#]', 'r{\ZI5O1QӇC', '', 0, '?'),
 ('͎3עJynĀM', 'wp-content/plugins/wordfence/fonts/fontawesome-webfont.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nq*ZF)2', '&4\"\rQjXmN\"?Po\\?', '', 0, '?'),
 ('2\Z {DZ-', 'wp-content/plugins/wordfence/fonts/ionicons.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hI15[I]J', '*\\&t䭨\\	gTw,1', '', 0, '?'),
 ('ZQ!*', 'wp-content/plugins/wordfence/fonts/roboto-KFOkCnqEu92Fr1Mu51xGIzQXKMnyrYk.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`y\0#xsGJt', 'Arx?j#CFOG-S$', '', 0, '?'),
 ('jtZܿ,', 'wp-content/plugins/wordfence/fonts/roboto-KFOkCnqEu92Fr1Mu51xIIzQXKMny.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'raai', '{JLͻ&{{T:B', '', 0, '?'),
 ('>uʸ!4N2', 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmEU9fBBc-AMP6lQ.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',;L\'dee', '+GT}m)*[c5ZN-v>', '', 0, '?'),
 ('m{@m', 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmEU9fChc-AMP6lbBP.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oLFʒ4i--', 'Cc#1_|Z  1ɾYx', '', 0, '?'),
 ('ӕ\nt0', 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmSU5fBBc-AMP6lQ.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mpGaBNX>(', '%-*Ψ6Fi\rWϹM׽WI:vD', '', 0, '?'),
 ('и+:3XnNtexX', 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmSU5fChc-AMP6lbBP.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{W7h>', '	2mw3)zWgv{AfHu`Co', '', 0, '?'),
 ('G:Z]Y!tI\"', 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmWUlfBBc-AMP6lQ.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jI78{rP', 'UkZM=OEwDw |I;', '', 0, '?'),
 (']K{ٯ`{,', 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmWUlfChc-AMP6lbBP.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+EYH<YPK=S', 'ۋ&:^G&B2PC~', '', 0, '?'),
 ('pwQFcߠb*', 'wp-content/plugins/wordfence/fonts/roboto-KFOmCnqEu92Fr1Mu4mxMKTU1Kg.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@$qG2k5$z', 'ֆF*`\'O triR:j0W\Z=j', '', 0, '?'),
 ('U]R)Ym', 'wp-content/plugins/wordfence/fonts/roboto-KFOmCnqEu92Fr1Mu7GxMKTU1Kvnz.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nj09', '\ZҨ2#s:Р\n		vØ+l', '', 0, '?'),
 ('4;`߯z?	{Ǟ@', 'wp-content/plugins/wordfence/images/2fa-whole.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h»$\ZPfX', 'ƪɝU[Z~^d\'Xٮ', '', 0, '?'),
 ('26,̞|keL\ns', 'wp-content/plugins/wordfence/images/2fa1.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/)h\\ hG8', 'C%0z)f @t>ɶ{T8o', '', 0, '?'),
 ('J=R\'t^}\n', 'wp-content/plugins/wordfence/images/2fa2.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0H', 'npʅG06KqJ]J', '', 0, '?'),
 ('様7^b\"', 'wp-content/plugins/wordfence/images/back_disabled.jpg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hgi>', '䏛N7g΋?Fb!}ݿC鳇', '', 0, '?'),
 ('׮Fps4', 'wp-content/plugins/wordfence/images/back_enabled.jpg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']H', '9퇥)R$px#q {#LO', '', 0, '?'),
 ('n\n\0܁-i', 'wp-content/plugins/wordfence/images/blocking.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'-Hf<1', 'A5Y9\0OtqЖL\\}a&', '', 0, '?'),
 ('^yG=ڜFg;3á', 'wp-content/plugins/wordfence/images/button-grad-grey.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RCTy?', 'DH~ϨP_{!', '', 0, '?'),
 ('N7A\0nnV֑', 'wp-content/plugins/wordfence/images/checkbox.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"G\r6|􈘀\'', 'y~`w(j~=뤼&ݴQ>`^x', '', 0, '?'),
 ('oYڅX', 'wp-content/plugins/wordfence/images/flags.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W7 (˿!\Z7', 'Bx0%Ly6!X\\z/<n6=\ZW', '', 0, '?'),
 ('.E[Jlx', 'wp-content/plugins/wordfence/images/forward_disabled.jpg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M_Z?N)Ҋ:5', '/<>O&ȕJR݇e}(m', '', 0, '?'),
 ('\0hKf\0', 'wp-content/plugins/wordfence/images/forward_enabled.jpg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U\0/3e4e', '0Q7018ު9-z9ؽqSrĒP', '', 0, '?'),
 ('窒u\rZJW+', 'wp-content/plugins/wordfence/images/help.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$N;\'M Y', '\Z7\0r/iz;ki,=LZg', '', 0, '?'),
 ('٘\"Pܞ,', 'wp-content/plugins/wordfence/images/icons/ajax24.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K:m𙗣P', 'j*edoX~7&N9|L', '', 0, '?'),
 ('\' oS', 'wp-content/plugins/wordfence/images/icons/ajax3.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mwߴtꍓ\'\ns', 'dz\nyKƮ\'#]x	VJR.=:', '', 0, '?'),
 ('y&aA7]Dm', 'wp-content/plugins/wordfence/images/icons/ajaxRed16.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%B\ng2;', 'D,AJlOSpe؇&', '', 0, '?'),
 ('4=', 'wp-content/plugins/wordfence/images/icons/ajaxScan.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʖѴ~fi', 'ߩ0ԍѦƻH\n¡;', '', 0, '?'),
 ('j&V164', 'wp-content/plugins/wordfence/images/icons/ajaxWhite32x32.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r9 #{', 'ﾱnѿ0c~NrAug~ΔI', '', 0, '?'),
 ('(x*J,LÛn<K', 'wp-content/plugins/wordfence/images/icons/arrow_refresh.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kw``|}$G', 'u/2/@H_Ilh/aU:	', '', 0, '?'),
 ('6[f9? _', 'wp-content/plugins/wordfence/images/icons/bullet_yellow.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J&ɌԔQ<', '1Nߗ׍?*ií!FMp9^.', '', 0, '?'),
 (']*J', 'wp-content/plugins/wordfence/images/icons/email_go.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jEH).', '& qC1QU_.O31!&۴', '', 0, '?'),
 ('`%{+', 'wp-content/plugins/wordfence/images/icons/error128.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':%7!.', '{h\0,]zkV{җ6nG\nxs9', '', 0, '?'),
 ('z5*\ZADZCkj', 'wp-content/plugins/wordfence/images/icons/magnifier.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uO{:qcV\'', ' atvdQ0(IjƖO$e(*', '', 0, '?'),
 ('Ρ~ߓ:eo', 'wp-content/plugins/wordfence/images/icons/tick128.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ğch4\"', 'V}X e~G[C峆5', '', 0, '?'),
 (';`$r$=', 'wp-content/plugins/wordfence/images/icons/warning128.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pGIt*Np=', '*/ȾstA}.b\'\\', '', 0, '?'),
 ('u64E~:', 'wp-content/plugins/wordfence/images/icons/working-indicator.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VF{N	\'G', 'fXRZ|:Ob=f[y5 ~	', '', 0, '?'),
 ('X@%1Ci', 'wp-content/plugins/wordfence/images/lightbox-controls.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm]a\\$', 'Ǘh?S):i@h.Xg', '', 0, '?'),
 ('?z6aDz', 'wp-content/plugins/wordfence/images/loading.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K:m𙗣P', 'j*edoX~7&N9|L', '', 0, '?'),
 ('Kjh', 'wp-content/plugins/wordfence/images/loading_background.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'2p\nKX', 'Ύ%XŖF1s;Lzr璻', '', 0, '?'),
 ('ﾘQ)B\n,', 'wp-content/plugins/wordfence/images/loading_large.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y{ObUW~Y˙', 'p8\'	t:Qo]{5G1E', '', 0, '?'),
 ('s♼{DR[k1I', 'wp-content/plugins/wordfence/images/logo.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zFހW\rl~6', 'V{Q9V	J	Xqڀc', '', 0, '?'),
 ('z^}¤hh3\rw', 'wp-content/plugins/wordfence/images/options.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VѴA', 'D:bw#^4BKIP?	znV_', '', 0, '?'),
 ('xD.m~<2', 'wp-content/plugins/wordfence/images/ratelimiting.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0[MɞyP', '@Sy\'N+kB3J!PbƖ', '', 0, '?'),
 ('QoH*(', 'wp-content/plugins/wordfence/images/sort_asc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',I+ƾ=', 'dCTe&,)ѴFG\ZdON', '', 0, '?'),
 ('57N	C=-c', 'wp-content/plugins/wordfence/images/sort_asc.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&DKzS§0', 'NQ*TZ%P%jܑtZn/', '', 0, '?'),
 ('lXwB*XW', 'wp-content/plugins/wordfence/images/sort_asc_disabled.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Oɧ*X9e', 'v\Z|5.YX Z鹁Ź', '', 0, '?'),
 ('x_,[5', 'wp-content/plugins/wordfence/images/sort_asc_disabled.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ǐ#a]2', '[8lYckl	u#KVn', '', 0, '?'),
 ('?Yvq_ۮXO', 'wp-content/plugins/wordfence/images/sort_both.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%BQxSV.D', '6\"@Xg\'W7wgJq', '', 0, '?'),
 ('	7f	`', 'wp-content/plugins/wordfence/images/sort_both.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dm	8f|Y', '~%ۉ%>BlouI)ȉ7g', '', 0, '?'),
 ('7c.$P!\"򹚆', 'wp-content/plugins/wordfence/images/sort_desc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<j_ˊR2', '*-9.HGO6/L):Cdz', '', 0, '?'),
 ('ZD:-h${ma', 'wp-content/plugins/wordfence/images/sort_desc.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?զ)X?N', 'bEԚB#:(#=_(\Z|U#', '', 0, '?'),
 ('xy!q).ˉ\"', 'wp-content/plugins/wordfence/images/sort_desc_disabled.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm͟r 9', ';	_Yt7KsmC\ro', '', 0, '?'),
 ('usT­BB', 'wp-content/plugins/wordfence/images/sort_desc_disabled.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J%{OZ\"/o', '^*n^\0m+!NkɌ/ԯ^k', '', 0, '?'),
 ('o\'RD-\0o', 'wp-content/plugins/wordfence/images/support.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Cl$rn<.', '$MԮ&(ᩘs^	Ϣ*N', '', 0, '?'),
 ('PC<	vnR8', 'wp-content/plugins/wordfence/images/tools.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@cI', 'Y=RB)	~ܖݟr', '', 0, '?'),
 ('O+[IBmm\'', 'wp-content/plugins/wordfence/images/wf-central-logo.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q(VѤ', '\0{\rߘJ/ ^+,S', '', 0, '?'),
 ('@:<o|J-e', 'wp-content/plugins/wordfence/images/wf-error-badge.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EQts	Mzy', '殙F`a݀kmEQ+~', '', 0, '?'),
 ('#-g\\L%3S݋B#\r', 'wp-content/plugins/wordfence/images/wf-horizontal.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E%Zlo9͒', '0	6ӭIvhJ`', '', 0, '?'),
 ('FVOd%|u', 'wp-content/plugins/wordfence/images/wordfence-logo.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p]j-', '8#̄(8O\"	+h\"Fb', '', 0, '?'),
 ('E(zRA1;eNqD3', 'wp-content/plugins/wordfence/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2eª\\og', ' oMJ#A|ߎ(;6R\n', '', 0, '?'),
 ('w(>6Xwg', 'wp-content/plugins/wordfence/js/Chart.bundle.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5]ddf', '>`NN`N\"KӞckG<;', '', 0, '?'),
 ('}wK:\\\Z', 'wp-content/plugins/wordfence/js/admin.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g<Z uq', 'x[c\0=/jv[', '', 0, '?'),
 ('Dǭ9Kh^', 'wp-content/plugins/wordfence/js/admin.ajaxWatcher.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CCW\Z^beD', '	CJhF$Dq|,7EH;N', '', 0, '?'),
 ('/ӈVQ&@O', 'wp-content/plugins/wordfence/js/admin.liveTraffic.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/[n1uu}', ')䓣Ad98PV+H25J', '', 0, '?'),
 ('\0O?%IS', 'wp-content/plugins/wordfence/js/date.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jPER_c', 'B=0dƩ\"BtUc^1>q&', '', 0, '?'),
 ('	Tt/=x>', 'wp-content/plugins/wordfence/js/jquery-ui-timepicker-addon.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '89\"zzVv*]', 'ۆ%%l:Jf<bqPPt˯}ߝ\"f', '', 0, '?'),
 ('l<%!\r', 'wp-content/plugins/wordfence/js/jquery.colorbox-min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y5=q)', 'H4\\v/XGK:gkl', '', 0, '?'),
 ('b)+Y.-	', 'wp-content/plugins/wordfence/js/jquery.colorbox.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(O0%69e3j', '{L#\r]\ngL8P,@Ir,{ ', '', 0, '?'),
 ('\'>rWUb҄o', 'wp-content/plugins/wordfence/js/jquery.dataTables.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<\\ ͕h', 'vAo;uD3$WB95_\" ', '', 0, '?'),
 ('m:փh', 'wp-content/plugins/wordfence/js/jquery.qrcode.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ԹXp`me<', 'wP\0pzuYDSz(WߥP3$S', '', 0, '?'),
 ('q\r8&jC9?\0', 'wp-content/plugins/wordfence/js/jquery.tmpl.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\}\"7ڷDZ', '.IH\Zg\0H!7`gޠZzȄž6|', '', 0, '?'),
 ('h {lӖ ', 'wp-content/plugins/wordfence/js/jquery.tools.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':-Eՠx$B', ',4~aTlS fQO	fTӵ;)', '', 0, '?'),
 ('a_&R\'', 'wp-content/plugins/wordfence/js/knockout-3.3.0.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_B8lc^', '5J9hALg@`uwo3\0I>', '', 0, '?'),
 ('gjqw.`', 'wp-content/plugins/wordfence/js/wfdashboard.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ԽP`{i', '=Pzr!?w\Z/d!LӪ1!', '', 0, '?'),
 ('>cP', 'wp-content/plugins/wordfence/js/wfdropdown.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rpc\'\Z', 'SGs8;Z!זJu1z?', '', 0, '?'),
 ('D٪&D$Wl', 'wp-content/plugins/wordfence/js/wfglobal.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7欑iW5ulR', '$hd^Sƨ5Y٭a$', '', 0, '?'),
 ('\nܐjx]Whm :', 'wp-content/plugins/wordfence/js/wfpopover.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';&mAhlMPZX', '_.V袏X4Ni_k=C3', '', 0, '?'),
 ('AyhL=<]A', 'wp-content/plugins/wordfence/js/wfselect2.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J!.i', 'lk}[ZjA.!=+5+~q 1', '', 0, '?'),
 ('R1?YVDt', 'wp-content/plugins/wordfence/lib/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E\"xK{8dS', 'C\'r9@Kކtw#@k', '', 0, '?'),
 ('\'FEAvQMv', 'wp-content/plugins/wordfence/lib/Diff/Renderer/Abstract.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>\r5]xVI\'i', 'G݅\'!YE3P5adM', '', 0, '?'),
 ('y1-/fIנ', 'wp-content/plugins/wordfence/lib/Diff/Renderer/Html/Array.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '09\rɘadP', 'F*OОq^lgz,I?bR]KֳE', '', 0, '?'),
 ('-n$.#g%}', 'wp-content/plugins/wordfence/lib/Diff/Renderer/Html/SideBySide.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' OّCHؖs ', 'pXuc{-K׏ژ/OnE0)JB', '', 0, '?'),
 ('`c0\\3', 'wp-content/plugins/wordfence/lib/Diff/SequenceMatcher.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O\"%éODZj', 'Z?=b\0D\ZZ\'˿_pwѻ,:', '', 0, '?'),
 ('ۖJBwC|Mv', 'wp-content/plugins/wordfence/lib/Diff.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5VzY]#yRJݮ', 'YM\"z)tϖ*cwL\01w$d', '', 0, '?'),
 ('Ը%\ZDyZ', 'wp-content/plugins/wordfence/lib/GeoLite2-Country.mmdb', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '㷏Ӽ\r*\\\"5', 'p.翗2M,\'[C-͠G', '', 0, '?'),
 ('J![W6ݧ', 'wp-content/plugins/wordfence/lib/IPTraf.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WJmLIg!', '0b@i[%g<F', '', 0, '?'),
 ('^2^T:mJ:', 'wp-content/plugins/wordfence/lib/IPTrafList.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n)e7e', '\'|\0!t|ux^&5l', '', 0, '?'),
 ('au\"9s?H', 'wp-content/plugins/wordfence/lib/WFLSPHP52Compatability.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%1sËG', 'EWٳ?4@U?0bP+h', '', 0, '?'),
 ('Kߺb', 'wp-content/plugins/wordfence/lib/compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>zxC}', 'Nܓ#dtB!\"M՞==@o', '', 0, '?'),
 ('SP;^ƭzI', 'wp-content/plugins/wordfence/lib/conntest.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q\rƉ(.Aˬ', 'J&grb+\'Id	1HLWreO', '', 0, '?'),
 ('fNdL', 'wp-content/plugins/wordfence/lib/cronview.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e(t@nr', 'Z4,hz=>M}G/[0l\"iK', '', 0, '?'),
 ('\Z;5(OOR', 'wp-content/plugins/wordfence/lib/dashboard/widget_content_countries.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȎcP\"', 'זD䟹45JbOɝHR@', '', 0, '?'),
 ('zvo:B%', 'wp-content/plugins/wordfence/lib/dashboard/widget_content_ips.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݻ1(wmF', 'B6;M8\Z&', '', 0, '?'),
 ('\rҗr׾ \n\Z', 'wp-content/plugins/wordfence/lib/dashboard/widget_content_logins.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!Pyt8턺P6q', 'kwQ)\'J~MEsrXY_Gf!', '', 0, '?'),
 ('$o1T2]l', 'wp-content/plugins/wordfence/lib/dashboard/widget_countries.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rmnZB ', '݃EZ?wȖ͖s!7cJ70', '', 0, '?'),
 ('Ws{NhPr㼱', 'wp-content/plugins/wordfence/lib/dashboard/widget_ips.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZcQ\nbd7,Ze', 'ZL)1-|Y(|@.N_ϋu', '', 0, '?'),
 ('e؟v笪Ej', 'wp-content/plugins/wordfence/lib/dashboard/widget_localattacks.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/]L/Gb;', '$y\r\npu ?A8KΙTcVa', '', 0, '?'),
 ('L.\nw;[', 'wp-content/plugins/wordfence/lib/dashboard/widget_logins.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g#@Xs', 'ĪN29WDWO0ѽmGN', '', 0, '?'),
 ('u;Ȍ0qw=', 'wp-content/plugins/wordfence/lib/dashboard/widget_networkattacks.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ԶwK>~\rg', '#Nu}WL!\\Z 8\0;k{', '', 0, '?'),
 ('k6*H	u١', 'wp-content/plugins/wordfence/lib/dashboard/widget_notifications.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5$g؟_ ', '53=xLܑm?Z97P.', '', 0, '?'),
 ('\\^s,z(', 'wp-content/plugins/wordfence/lib/dashboard/widget_tdf.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2\'p[UaH', '?}mwDqn2R\\', '', 0, '?'),
 ('6Ri*5æ', 'wp-content/plugins/wordfence/lib/dbview.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƍݵ1苙nzk', 'DOhB;4U7o/g8i+̷', '', 0, '?'),
 (')\0e_5=', 'wp-content/plugins/wordfence/lib/diffResult.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0wJn', '_^>8L\\{P', '', 0, '?'),
 ('#\n/PZ~h', 'wp-content/plugins/wordfence/lib/email_genericAlert.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L)&낆(', 'j{bXN#R5[׍m', '', 0, '?'),
 ('Fe	57[', 'wp-content/plugins/wordfence/lib/email_newIssues.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`=dHgO5', 'Qi$?K^%9$O@0eƼR;x ;n`', '', 0, '?'),
 ('^u}G', 'wp-content/plugins/wordfence/lib/email_unlockRequest.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{<2m', 'RpM>d*', '', 0, '?'),
 ('e\0hLщ', 'wp-content/plugins/wordfence/lib/email_unsubscribeRequest.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#}_*mD×cvW', 'm$G+59TEx7B{/,u7', '', 0, '?'),
 ('*Q.	-c%D', 'wp-content/plugins/wordfence/lib/flags.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ic磭c-', '8YCO0j{\ZxDĖxO', '', 0, '?'),
 ('$-#q`l$Wۉ', 'wp-content/plugins/wordfence/lib/live_activity.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2>(]/@ꏞf', 'QըW`~N_wID$J3', '', 0, '?'),
 ('dTofҷbS', 'wp-content/plugins/wordfence/lib/menu_dashboard.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r͝ݭ5', 'oc@e ᤶg\ZVj', '', 0, '?'),
 ('ޒ?IΩi%gy', 'wp-content/plugins/wordfence/lib/menu_dashboard_options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j~i\'Z?', '=x=)ZuY\"FF2]', '', 0, '?'),
 ('WP旃^qy', 'wp-content/plugins/wordfence/lib/menu_firewall.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm2_MjV', '\"!bXȉr3Oe{0', '', 0, '?'),
 ('3dyjV', 'wp-content/plugins/wordfence/lib/menu_firewall_blocking.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[? ?', 'b}STbcvʄ/{', '', 0, '?'),
 ('Ͷjʃఱ-', 'wp-content/plugins/wordfence/lib/menu_firewall_blocking_options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h;BD:', '\Z@\\ɔ\rqB,CKτw.z', '', 0, '?'),
 ('6cbkki3@H', 'wp-content/plugins/wordfence/lib/menu_firewall_waf.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e(# ({秡<(s', '%=oVBkC%Ir(?ceC', '', 0, '?'),
 ('0dۦZP2o', 'wp-content/plugins/wordfence/lib/menu_firewall_waf_options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ua~v', '/[+!)fhfĳXF8/H7', '', 0, '?'),
 ('WM{h(', 'wp-content/plugins/wordfence/lib/menu_options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bSMLan', 'hfX^Ԝ n', '', 0, '?'),
 ('z8 L{q', 'wp-content/plugins/wordfence/lib/menu_scanner.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݻyz|', '-uݼ>̺n~ut&)F&;qfJkSO', '', 0, '?'),
 ('I|K9({sX', 'wp-content/plugins/wordfence/lib/menu_scanner_credentials.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ff:&,[', 'B&$q>P\nϾz&G<6Ǵ:', '', 0, '?'),
 ('OHI!K!0[', 'wp-content/plugins/wordfence/lib/menu_scanner_options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '; 9\0b!Q', '@&O\ZqR_w)RǐlL`wүi,', '', 0, '?'),
 ('-jާ ~hyb', 'wp-content/plugins/wordfence/lib/menu_support.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yy0\'Ofx2;D', '.F!x,p	[\'E\Z̻,', '', 0, '?'),
 ('ojyV', 'wp-content/plugins/wordfence/lib/menu_tools.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gԌpPIg[=', 'V!ޟƚ_z=|yaXȏ', '', 0, '?'),
 ('!##sw:\rH*$q', 'wp-content/plugins/wordfence/lib/menu_tools_diagnostic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7<Ճʟ9\nK', 'ёSvm(6V\nlv', '', 0, '?'),
 ('!Tۦ	lI\n', 'wp-content/plugins/wordfence/lib/menu_tools_importExport.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$^k>T|', 'k^XR1, c=\\', '', 0, '?'),
 ('UI_Ym_', 'wp-content/plugins/wordfence/lib/menu_tools_livetraffic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ss,(q', 'kPs_|S}lV{G]0܁t', '', 0, '?'),
 ('@L߯7٭kقE', 'wp-content/plugins/wordfence/lib/menu_tools_twoFactor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jlF+>Tm/av~3', 'Zfk%y,?SCU=lhѕ', '', 0, '?'),
 ('Cs\\\ns\'m', 'wp-content/plugins/wordfence/lib/menu_tools_whois.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0JM(]\Z7w', '[:QݔqF/qG;N@Kq08ΤO`[', '', 0, '?'),
 ('7\"妿W\rѽ', 'wp-content/plugins/wordfence/lib/menu_wordfence_central.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nՆKvOԜ\'\0', '^{A荗.Fخ\"m)>T', '', 0, '?'),
 ('@ȯ&Oo', 'wp-content/plugins/wordfence/lib/noc1.key', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9eb\0PO', '_ujP-KOAܫ', '', 0, '?'),
 ('kU/^ ', 'wp-content/plugins/wordfence/lib/rest-api/wfRESTAuthenticationController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd:ǽ	X̩TI', 'IS:3+̢$i_if:A', '', 0, '?'),
 ('HC)C', 'wp-content/plugins/wordfence/lib/rest-api/wfRESTBaseController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yK\nu@x', 'Aݶ݁;_|sȤ4_)zaKQEe!', '', 0, '?'),
 ('e-RȉL:', 'wp-content/plugins/wordfence/lib/rest-api/wfRESTConfigController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-n(֟5> a.\'', 'j^!yfӳucwWx', '', 0, '?'),
 ('i/pEt\nl', 'wp-content/plugins/wordfence/lib/rest-api/wfRESTScanController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5oQ4)dT', 'Dt3v\Z%jlf%O)&&1L', '', 0, '?'),
 ('F{A', 'wp-content/plugins/wordfence/lib/sysinfo.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۍQꅳ9', '!D#D\"0zt6IHԆ\\0̈\Zd', '', 0, '?'),
 ('M~^x;', 'wp-content/plugins/wordfence/lib/unknownFiles.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n✚o\"* b', 'p}\'5HZ%[*:^^i', '', 0, '?'),
 ('LR7QToG|{', 'wp-content/plugins/wordfence/lib/viewFullActivityLog.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@lM3JtOF@', '[`\\pǣTb>=PivO', '', 0, '?'),
 ('ٵ\nhJxdvԃ]', 'wp-content/plugins/wordfence/lib/wf503.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A)+Љ', 'o+lѥarЙ\nyÂ', '', 0, '?'),
 ('2]hqu:T6EU', 'wp-content/plugins/wordfence/lib/wfAPI.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Cx3v@Q$)g\r', 'kBhl%ܟGa=R @Ξ{', '', 0, '?'),
 ('Ɇ8pŻѵV', 'wp-content/plugins/wordfence/lib/wfActivityReport.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>	[\Z᷎x4', '+|\Z#*NθBND]|\0', '', 0, '?'),
 ('zoܲ~b', 'wp-content/plugins/wordfence/lib/wfAdminNoticeQueue.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K\r4X.', 'lvl	](W7+0-', '', 0, '?'),
 ('Ni~	`WE', 'wp-content/plugins/wordfence/lib/wfAlerts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']5+6.ZM.', '7ɟSYPW	OXxy*ieHY', '', 0, '?'),
 ('ދ1Fa', 'wp-content/plugins/wordfence/lib/wfArray.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'Fbaۆₑ1ʤ/', 'n2q8D-AR>xqYq$ ш', '', 0, '?'),
 ('-=QCwtnL#', 'wp-content/plugins/wordfence/lib/wfBrowscap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\re.b', 'HznO#/tɚ\"U Ai', '', 0, '?'),
 ('XJp', 'wp-content/plugins/wordfence/lib/wfBrowscapCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TQxj', '1YTЈqW6݋h	', '', 0, '?'),
 ('1]M|KFZ', 'wp-content/plugins/wordfence/lib/wfBulkCountries.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9	+OyծurO3\n', 'X&o1\'cgmlySt\r', '', 0, '?'),
 ('ґ-\r{,', 'wp-content/plugins/wordfence/lib/wfCache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7 ƿsy', '|uIPwh5ڎ.m\"*n_ 9JP', '', 0, '?'),
 ('hJD㰗G n', 'wp-content/plugins/wordfence/lib/wfCentralAPI.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ăa\\F', '!)-5%xi=F$07~\n', '', 0, '?'),
 ('Z4<n?e', 'wp-content/plugins/wordfence/lib/wfConfig.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'LKkD', '>k\rM)ɱ]jާ2%{/L', '', 0, '?'),
 ('8ÛZEQ$}UPT', 'wp-content/plugins/wordfence/lib/wfCrawl.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1铇ܙ~\rm', '%&9	/DXG؞߇U4', '', 0, '?'),
 ('ڥ^i$&', 'wp-content/plugins/wordfence/lib/wfCredentialsController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z\0իw6', '76ay5?}%.]؞uS', '', 0, '?'),
 ('xβЦA	<', 'wp-content/plugins/wordfence/lib/wfCrypt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CR`9|e', 'U͊sds9;COȤ@', '', 0, '?'),
 ('J^\Z7uGk+', 'wp-content/plugins/wordfence/lib/wfDB.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P_<-1__Iu', '%dd_\01@TY$A', '', 0, '?'),
 ('ikmCxʷ', 'wp-content/plugins/wordfence/lib/wfDashboard.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&4.', 'U0@\0\'21k^ͅEi.E', '', 0, '?'),
 ('7ruF@J,', 'wp-content/plugins/wordfence/lib/wfDateLocalization.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4K_J2Cmcͭt', 'Djy,Lwa <U S', '', 0, '?'),
 ('l9=h,>&', 'wp-content/plugins/wordfence/lib/wfDiagnostic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0n3', '`MTRLl&)hZ/%', '', 0, '?'),
 ('F\ZC1P', 'wp-content/plugins/wordfence/lib/wfDict.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y LZ!bEl', '.{0Je{5-~[T$Ğ', '', 0, '?'),
 ('A0ff` Kǁ}', 'wp-content/plugins/wordfence/lib/wfDirectoryIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n+Z/_\Zxuv', 'u;IVa[~㵭TZ\\^yJj', '', 0, '?'),
 ('q5@*=&\\X', 'wp-content/plugins/wordfence/lib/wfHelperBin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';!ȍ4QX#', 'չ%-^qUqMeY', '', 0, '?'),
 ('PM\ZI̸ݭY`r', 'wp-content/plugins/wordfence/lib/wfHelperString.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OVFaDV44ܪ', '2-7na5A>cִ\ZNA-p{Qn\Z', '', 0, '?'),
 ('ikCT,', 'wp-content/plugins/wordfence/lib/wfIPWhitelist.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ϝq,ؾ\\', '5%v_E[P3w,=s$bF', '', 0, '?'),
 ('1ϣI', 'wp-content/plugins/wordfence/lib/wfImportExportController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HM.', 'ƌZ>2ì<\rsJ2*', '', 0, '?'),
 ('jsw2pqS', 'wp-content/plugins/wordfence/lib/wfIssues.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/lCx[SZ', 'MUSdWF\Zاg', '', 0, '?'),
 ('(>f0\Zg[|', 'wp-content/plugins/wordfence/lib/wfJWT.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}{ jNcK', '0mhN`xx~HLjsOP,', '', 0, '?'),
 ('ؠ]fP', 'wp-content/plugins/wordfence/lib/wfLockedOut.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GOFb\Zxh^b', 's`D֐KY2@ckmbE(>2', '', 0, '?'),
 ('w+\"+$^', 'wp-content/plugins/wordfence/lib/wfLog.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4ޒ	N3G', 'o[G\n^/;LA^)R', '', 0, '?'),
 ('\\h RX<C', 'wp-content/plugins/wordfence/lib/wfMD5BloomFilter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '߅w@LOR', 'EFjrč;s΀.f:ϤF', '', 0, '?'),
 ('w:k@DiWQ', 'wp-content/plugins/wordfence/lib/wfModuleController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oIƷkb', '7.ݰ̿UL>\"TM5]>', '', 0, '?'),
 ('tǱ%F', 'wp-content/plugins/wordfence/lib/wfNotification.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0Ǎ V2(dhVD', 'SaYgj+| JM8', '', 0, '?'),
 ('+3pU', 'wp-content/plugins/wordfence/lib/wfOnboardingController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y%̍ų<', 'ŔWF&x\Z	\"gߠ;=Dٗx', '', 0, '?'),
 ('TоR\'{', 'wp-content/plugins/wordfence/lib/wfPersistenceController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%kyiMO*', 'X(30\r\n\nPE̠ 9', '', 0, '?'),
 ('mqPoD0*L', 'wp-content/plugins/wordfence/lib/wfRESTAPI.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\8H mi+', '++Ɵ0͂b=[㜁', '', 0, '?'),
 ('ތt+\\+XaZU', 'wp-content/plugins/wordfence/lib/wfScan.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';jڹ%a`', '$>3Tp9INO\n$', '', 0, '?'),
 ('6XԪ4[_=t', 'wp-content/plugins/wordfence/lib/wfScanEngine.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VfJEtw', 'gNIq[n678ֆ>\'W\ZN\\X', '', 0, '?'),
 ('bHzfWgw', 'wp-content/plugins/wordfence/lib/wfSchema.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O@	|O', 'gvK%oiS7.]siH2:p', '', 0, '?'),
 ('K2;<Dkub', 'wp-content/plugins/wordfence/lib/wfStyle.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's1_ek2R', 'j颎_c6323օ]Gs}.\n', '', 0, '?'),
 ('sk6/н', 'wp-content/plugins/wordfence/lib/wfSupportController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uIWԝV', 'ns=\rT4>Q}ql', '', 0, '?'),
 ('hLJHX#0', 'wp-content/plugins/wordfence/lib/wfUnlockMsg.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6]u})e', ':%ozN]	&4U', '', 0, '?'),
 ('e\\1tƋ<	', 'wp-content/plugins/wordfence/lib/wfUpdateCheck.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4\Z@Xg	kv{t', '\Zެ%)I0P?CHk@rMzlH` F', '', 0, '?'),
 ('Q49LzJ', 'wp-content/plugins/wordfence/lib/wfUtils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Dgm<\n', 'LRZIR\\^ӿ#(mc~ 6ڡ', '', 0, '?'),
 ('@GteY\\\'>O', 'wp-content/plugins/wordfence/lib/wfVersionCheckController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~\Zyh[*[ǥ', 'q\rzչ4kÛ>ڌj\'$a9]\n', '', 0, '?'),
 ('eŐnA', 'wp-content/plugins/wordfence/lib/wfView.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '⇲*!P\'|%\Z', '\0+FoL (\\.w g{&:όH', '', 0, '?'),
 ('v{Cҧ4I', 'wp-content/plugins/wordfence/lib/wfViewResult.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9ֿYCA4|p', '{30pDr%#Mz_ϔK}Ao6MR', '', 0, '?'),
 ('ݡ=NxK`*', 'wp-content/plugins/wordfence/lib/wordfenceClass.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M\r3', '6Dⵃaݼ\Z<lr	9:L', '', 0, '?'),
 ('kHm1`0ѹ_', 'wp-content/plugins/wordfence/lib/wordfenceConstants.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%7qčH', 'D@*uS\\QxO`æs2SMy9', '', 0, '?'),
 ('X-4J_3', 'wp-content/plugins/wordfence/lib/wordfenceHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y;U\'a', 'gJ1kkWx7e}Uulmy.', '', 0, '?'),
 ('z|*6S\\53', 'wp-content/plugins/wordfence/lib/wordfenceScanner.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jMʺR\'iț', '(\\ 21&NHU', '', 0, '?'),
 ('h<]OpNCƴ', 'wp-content/plugins/wordfence/lib/wordfenceURLHoover.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '͠؄C\ZƽYR%:.', '&@bJR%XGhg>q', '', 0, '?'),
 ('Jl1', 'wp-content/plugins/wordfence/models/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E\"xK{8dS', 'C\'r9@Kކtw#@k', '', 0, '?'),
 ('`&%eFgd', 'wp-content/plugins/wordfence/models/block/wfBlock.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'znK_', '7Y.ڔn!ڒ\Ze', '', 0, '?'),
 ('j4-O ՄrL\n', 'wp-content/plugins/wordfence/models/block/wfRateLimit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$1D\'wm', 'E&&\na~b+\Z)jMpM', '', 0, '?'),
 ('֔ߚy(qDw', 'wp-content/plugins/wordfence/models/common/wfGeoIP2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YJs@jrjtm', '3ÑѲs\r&z=dspJx3w', '', 0, '?'),
 ('g]e!^(PK', 'wp-content/plugins/wordfence/models/common/wfTab.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2T}HW\'<}\\', 'Z¥|sS8e3Eؗ$ܜ-h', '', 0, '?'),
 ('X~Vzl!_]/-3', 'wp-content/plugins/wordfence/models/firewall/wfFirewall.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2\\fG݉R', 'b4g챔Fadm)D=@g', '', 0, '?'),
 ('9XU7z', 'wp-content/plugins/wordfence/models/page/wfPage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tbo i%HXwXv', 'ƅ1h/jw<U\\kq%s|W6', '', 0, '?'),
 ('O܎$8Je', 'wp-content/plugins/wordfence/models/scanner/wfScanner.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f(\n4tf', '_;ĈS^ɐ\ZY', '', 0, '?'),
 (',:3չC@~', 'wp-content/plugins/wordfence/modules/login-security/classes/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aabvr', 'C\'r9@Kކtw#@k', '', 0, '?'),
 ('@={&}_', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/ajax.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fŴSz', 'L?T`^]=#|\"/\ZHm:/wH', '', 0, '?'),
 ('/-TǻT<S', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/captcha.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-\ruZE:	', '^<1t>SM_3k!$', '', 0, '?'),
 ('\ZO3F5K;@ ', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/cron.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@q\\}[', '[TnEjd($:!hΝ\0s><', '', 0, '?'),
 ('@qG-$|', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/db.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gPʋi[', 'DeJ\Zfxb	x\'P:U', '', 0, '?'),
 ('p\\*e\n\rψ', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/notices.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z83?wW', '\r.l]\\)	Zqp]_^uJ\n%', '', 0, '?'),
 ('Vrz(nol*', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/permissions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y״>UɆ', 'Ru\Z`\\6ÃMR\r3Z!C|s,P{', '', 0, '?'),
 ('SCi1ۭj', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p\\E(i', '4O+oc.`_U>8', '', 0, '?'),
 ('{4.##', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/support.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nʆwqF', 'R	j[8ح͸WEH̅aI', '', 0, '?'),
 ('ȁ#/\06', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/time.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4ӹu;P', 'aD,ǭ+vFe\"+!1t', '', 0, '?'),
 ('&	Ytz(\Z', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/totp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j.\\0*	[', 'f8\'!RFL˙^w', '', 0, '?'),
 ('HCTp(^l', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/users.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '٣gR 3', '}{cV\"z9NY8JW', '', 0, '?'),
 ('L\Z|=c', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/whitelist.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B0oǔ', '7/QƐՐwg:?#{sɟ', '', 0, '?'),
 ('S	g	Nd', 'wp-content/plugins/wordfence/modules/login-security/classes/controller/wordfencels.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y]4x\"Dw^', 'S5_\'玚ES-1WMLju^]c', '', 0, '?'),
 ('Wx\ZTa7{', 'wp-content/plugins/wordfence/modules/login-security/classes/model/asset.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G|s,=K#', '6ly6ɦi3U,E[鲓9', '', 0, '?'),
 ('o1iL5z$7', 'wp-content/plugins/wordfence/modules/login-security/classes/model/compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u1\\8;#j-', 'P|l_Z3z<NɧK', '', 0, '?'),
 ('%w45X泞', 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto/base2n.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't^I\']!', 'Ǧbt5fckdm', '', 0, '?'),
 ('.7fw9Pm@', 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto/jwt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0H#IHD', 'voVYx?\n\n&3c-\r8m', '', 0, '?'),
 ('w@IeRf7', 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto/symmetric.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hR', '=mH/\neC3u58', '', 0, '?'),
 ('t[[=6u7;YT', 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4s[lAc4f', 'ƺ>y.~yK^)*f6F', '', 0, '?'),
 ('\rz@_ÐmdM', 'wp-content/plugins/wordfence/modules/login-security/classes/model/ip.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '96f;0', 'mgc%i\ZnAB@wFz;y`\rN', '', 0, '?'),
 ('rY\0S(z|', 'wp-content/plugins/wordfence/modules/login-security/classes/model/notice.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-Gbyf|S', 'oG5}[`nxܡ^@B#lb', '', 0, '?'),
 ('cp	PU3/', 'wp-content/plugins/wordfence/modules/login-security/classes/model/request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&ܮM,~/r', 'F;W]&z~o\'/q+', '', 0, '?'),
 ('2p)tI', 'wp-content/plugins/wordfence/modules/login-security/classes/model/settings/db.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' \0\">y>=', 'xVQ/}琾:(3&%UJoC', '', 0, '?'),
 ('ǖd!s<XЯ', 'wp-content/plugins/wordfence/modules/login-security/classes/model/settings/wpoptions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*1{,˾ʂ', '<G$U+kL>\0hahBS-', '', 0, '?'),
 ('-_mq+1', 'wp-content/plugins/wordfence/modules/login-security/classes/model/settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h㠲ieɡ', 'IHMp\\Nh\n׈NF=-Z=hO', '', 0, '?'),
 ('-6Yw@i=', 'wp-content/plugins/wordfence/modules/login-security/classes/model/text/html.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OhO<FҬ', 'PJHtNsnd*F\'WWaq]', '', 0, '?'),
 ('H)jHj', 'wp-content/plugins/wordfence/modules/login-security/classes/model/text/javascript.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V\'BlIf\"c', 'O$U?\nRyV=TZ', '', 0, '?'),
 ('g\Z\\\r`=m', 'wp-content/plugins/wordfence/modules/login-security/classes/model/tokenbucket.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P\rL{ǀ', 'VZ+&\rЩU;L)R!ӵ', '', 0, '?'),
 ('U.G\0h7K', 'wp-content/plugins/wordfence/modules/login-security/classes/model/view/tab.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{ǲ겊T', 's׷my([~MNԘ;i', '', 0, '?'),
 (';DthEG>H', 'wp-content/plugins/wordfence/modules/login-security/classes/model/view/title.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o\\', 'Zm$zpuCVgIgIN', '', 0, '?'),
 ('#:SkU{', 'wp-content/plugins/wordfence/modules/login-security/classes/model/view.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*:?l]u', '2P탚=w=7Ar\nfQ~,B', '', 0, '?'),
 ('c&&-w\\', 'wp-content/plugins/wordfence/modules/login-security/css/admin-global.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-SH1@kQұ', '^H2m<LAm	NG)Iw:D', '', 0, '?'),
 ('ܰN,vNs<', 'wp-content/plugins/wordfence/modules/login-security/css/admin.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S%v#)ݩ5!', 'Bixu\n1܎ͺ2{', '', 0, '?'),
 ('|k< a:g', 'wp-content/plugins/wordfence/modules/login-security/css/colorbox.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<w\ri컎vL*x', 'Nb\r̎/?+\'bi\'W$@i\0', '', 0, '?'),
 ('((48S%_S', 'wp-content/plugins/wordfence/modules/login-security/css/font-awesome.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N2J娳YB瘱', '\ZPL㨒ZitA7d', '', 0, '?'),
 ('V2\0yJ:', 'wp-content/plugins/wordfence/modules/login-security/css/ionicons.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*ƣٿc;z', 'NJs@3	:h)7K<\\N+', '', 0, '?'),
 ('m-Q:9', 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui-timepicker-addon.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AMA@|', 'u\ZӚ1!b \"0SBȓ>rEk', '', 0, '?'),
 ('@C4XPxp}', 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui.min.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l.(KpQ', 'ٍ$rb=phxK5]8QRjn4', '', 0, '?'),
 (']%qN', 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui.structure.min.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')/4;$۔ެvi\\', 'ni뗅NvX7Y]D', '', 0, '?'),
 ('`\'%_\\', 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui.theme.min.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kXZb5', '[\0NEggdq\r*\'I', '', 0, '?'),
 ('CE&I9H*', 'wp-content/plugins/wordfence/modules/login-security/css/login.1587658822.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm᳀2rmV', 'rJ]s682!\ZpG', '', 0, '?'),
 ('ow*\nΛ΢GҜ]', 'wp-content/plugins/wordfence/modules/login-security/img/header.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p]j-', '8#̄(8O\"	+h\"Fb', '', 0, '?'),
 ('}CwXTC', 'wp-content/plugins/wordfence/modules/login-security/img/lightbox-controls.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm]a\\$', 'Ǘh?S):i@h.Xg', '', 0, '?'),
 ('\\1݃%VE|<N', 'wp-content/plugins/wordfence/modules/login-security/img/loading.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K:m𙗣P', 'j*edoX~7&N9|L', '', 0, '?'),
 ('E?tB9bvF`1', 'wp-content/plugins/wordfence/modules/login-security/img/loading_background.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'2p\nKX', 'Ύ%XŖF1s;Lzr璻', '', 0, '?'),
 ('%fW	P0}+', 'wp-content/plugins/wordfence/modules/login-security/img/menu.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p]j-', '8#̄(8O\"	+h\"Fb', '', 0, '?'),
 ('MzŭY', 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_444444_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GJu;QZ6', '\\MUKhQwCiVJ\'', '', 0, '?'),
 ('f rp(p$', 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_555555_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pbD@pG+', '*DZ>Bg&YY4(</', '', 0, '?'),
 ('Jլ4\rn', 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_777620_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J\\c7yxгl', '~qV*\'1]3^m', '', 0, '?'),
 ('s4RX>O', 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_777777_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h^n=(&݂N&', 'SDIBz_-?(YpEyƹA', '', 0, '?'),
 ('H%,', 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_cc0000_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|%;wQ8@', 'wi>6Ƭ4.NC\Z4IO', '', 0, '?'),
 ('b0݀>j\"G', 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_ffffff_256x240.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aa+JD$2J', '/#?TiOLyvuTKɤ\\ػ', '', 0, '?'),
 ('n.\\G;\\', 'wp-content/plugins/wordfence/modules/login-security/js/admin-global.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LgD5w\'|IGV5', '}њ@PF)M$jp{e', '', 0, '?'),
 ('9JF49)b', 'wp-content/plugins/wordfence/modules/login-security/js/admin.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',Q5\Z*yy!s', 'J\"qUKa\'1_NXG`揧W>', '', 0, '?'),
 ('$\"3*1&', 'wp-content/plugins/wordfence/modules/login-security/js/jquery-ui-timepicker-addon.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '89\"zzVv*]', 'ۆ%%l:Jf<bqPPt˯}ߝ\"f', '', 0, '?'),
 ('?\Z/t&\'', 'wp-content/plugins/wordfence/modules/login-security/js/jquery.colorbox.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lYZiਆ3\02[', '(A#F~+FghS.b', '', 0, '?'),
 ('c&뛆paA0', 'wp-content/plugins/wordfence/modules/login-security/js/jquery.colorbox.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lWeU{9', 'G8=\0> 3wg3.4', '', 0, '?'),
 ('*^4g|/:', 'wp-content/plugins/wordfence/modules/login-security/js/jquery.qrcode.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ԹXp`me<', 'wP\0pzuYDSz(WߥP3$S', '', 0, '?'),
 ('9wM>Ώ\0+B>', 'wp-content/plugins/wordfence/modules/login-security/js/jquery.tmpl.min.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\}\"7ڷDZ', '.IH\Zg\0H!7`gޠZzȄž6|', '', 0, '?'),
 ('RAG\'a*/', 'wp-content/plugins/wordfence/modules/login-security/js/login.1587658822.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~Vtj:', '.y@Ive\Z?gdhO\0', '', 0, '?'),
 ('dtS0[\\Og:', 'wp-content/plugins/wordfence/modules/login-security/views/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aabvr', 'C\'r9@Kކtw#@k', '', 0, '?'),
 ('@~}cQ\'J', 'wp-content/plugins/wordfence/modules/login-security/views/common/modal-prompt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%9;%mM6Z', '6-2Xjݒ[lÆL	\'8FJ', '', 0, '?'),
 ('jp\0Z', 'wp-content/plugins/wordfence/modules/login-security/views/email/login-verification.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڸ\rܚ', '-ͤE[G4/`rV', '', 0, '?'),
 ('#ynہ彐[hr\\U', 'wp-content/plugins/wordfence/modules/login-security/views/manage/activate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pߓ', 'd\'_C\'\"Şh3', '', 0, '?'),
 ('4#հ}', 'wp-content/plugins/wordfence/modules/login-security/views/manage/code.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/D\rmb y_', '$+;f7{O/gp~', '', 0, '?'),
 ('O潼m$݋&_', 'wp-content/plugins/wordfence/modules/login-security/views/manage/deactivate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1z¶~pQ.)!\\', 'or[AR~~Gu߰QNZk\0QSeO', '', 0, '?'),
 ('#\' ~/zF', 'wp-content/plugins/wordfence/modules/login-security/views/manage/regenerate.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XZ\\h=95', '.Z2~b8Ȟu', '', 0, '?'),
 ('EB3A-\r&!T', 'wp-content/plugins/wordfence/modules/login-security/views/onboarding/standalone-header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CG\ndnMv', '篺wFO^ `&|p.0E)\ZL', '', 0, '?'),
 ('sݜÞ3', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-captcha-threshold.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Nc0)נZ;b', '5KO5QJÂPpUW', '', 0, '?'),
 ('uC~7\nWe', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-captcha.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')OA?fSZp', ',m?j❄3T!ⱝ/@', '', 0, '?'),
 ('mAp	1GU/', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-ip-source.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q)\Z6ˏr1\n1ڑ', '$I.\Zڴ}\'iD50V-B(', '', 0, '?'),
 ('Fm', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-label.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|<>sZKze', '̆;nE!Z\ZVV Hw', '', 0, '?'),
 ('k7|dT;', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-require-2fa.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZɵP! r', 'wXXl@gIz,>W7\rX', '', 0, '?'),
 ('낏\r?8[9kQ\'s', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-select.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8E7CS', 'dقM.N8U8ࠆOY=wD', '', 0, '?'),
 ('2?!u܆\"', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-switch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[(AɊh', 'ͳߘQ6̨!*XxMMu@', '', 0, '?'),
 ('\Z&cR< FiC', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-text.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r%1cvG\\%', '-r@Yik~oeɲv*+', '', 0, '?'),
 ('j\nj<c@BX', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-textarea.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3qטwUͰR', 'JwYwun[&DFLV-2L', '', 0, '?'),
 ('I<UCMdZ', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-boolean-switch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VIބŌ._', 'ёli߉.N /siTj!l', '', 0, '?'),
 ('wDI-EIl', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-multiple.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T%a;B3>|CX', 'B;,y_:$E5B0\0', '', 0, '?'),
 ('F\ruDb7', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-segmented.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pVF&KkH', '+.^-$70	]xrv+cgPM', '', 0, '?'),
 ('|:xZ~*wl', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-select.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6G5n;E>', 'Q2Ƽw|!l?sTMmu*({', '', 0, '?'),
 ('\rP)4_\"\'1', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-sub.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nυ	L?06C', '\'-OR\"Nxn~l<W', '', 0, '?'),
 ('*沫QN', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-textarea.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1hIbۓa', '6NSNY2m=@ke(!z|g', '', 0, '?'),
 ('/qRR|', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R!z@;Ve', '#l#к;	KAH9Q@	B~', '', 0, '?'),
 ('$QsPR3}/', 'wp-content/plugins/wordfence/modules/login-security/views/options/option-token.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>N.RyEEn', '0Q~0Sbgsx:E my\\O', '', 0, '?'),
 ('8=[ձ', 'wp-content/plugins/wordfence/modules/login-security/views/page/manage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~PG$!2(s`', 'פ:yRJ`l|BHw75!', '', 0, '?'),
 ('CIS7<', 'wp-content/plugins/wordfence/modules/login-security/views/page/page.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ш>\\gǡ$c', 'iiGCNFL)7%ʙ', '', 0, '?'),
 ('\ZL6N1;8', 'wp-content/plugins/wordfence/modules/login-security/views/page/section-title.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"w^\nk6', '!5@a6to5(Ds\nKf', '', 0, '?'),
 ('g[z\0ή', 'wp-content/plugins/wordfence/modules/login-security/views/page/settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MQ@ǮI', '~rbwTNs;3fB)A', '', 0, '?'),
 ('T\rfV+ j', 'wp-content/plugins/wordfence/modules/login-security/views/page/tabbar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gxXJTbx', 'fx/xG\n856	Z+', '', 0, '?'),
 ('˩6f/6YjI\0W', 'wp-content/plugins/wordfence/modules/login-security/views/settings/options.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XUt\\HD', 'w>Ȗ@UFg݃{=-ڪ5', '', 0, '?'),
 ('Yg$zH.Y', 'wp-content/plugins/wordfence/modules/login-security/views/settings/user-stats.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uD~Fe	U', ';\ne@dw`4g\r', '', 0, '?'),
 ('dkJQAw6im<B1', 'wp-content/plugins/wordfence/modules/login-security/wordfence-login-security.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lv>%\0uj]', 'X\ZMx)T?q', '', 0, '?'),
 ('vFI2hn', 'wp-content/plugins/wordfence/readme.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	Š=YL/n', 'g8quvoǆ)9Kb\"=', '', 0, '?'),
 (';Lt׬Cɣ', 'wp-content/plugins/wordfence/tmp/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Iz~i,L', '	HQIqzڤp9C4>H3G', '', 0, '?'),
 ('\"C*.', 'wp-content/plugins/wordfence/vendor/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E\"xK{8dS', 'C\'r9@Kކtw#@k', '', 0, '?'),
 ('=S6aXo,2', 'wp-content/plugins/wordfence/vendor/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nV8\\Bs', '7h>8but^^Rx26#i(', '', 0, '?'),
 ('_k4!*}݄ ', 'wp-content/plugins/wordfence/vendor/composer/ClassLoader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 ('0&Y', 'wp-content/plugins/wordfence/vendor/composer/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']_#D\0', '\Z ے%4~N~Gh!b:wɌ\'', '', 0, '?'),
 ('\"0rN1M#', 'wp-content/plugins/wordfence/vendor/composer/autoload_classmap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 ('t!\Z%\n', 'wp-content/plugins/wordfence/vendor/composer/autoload_namespaces.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5,}vĨ3G)', 'Er4@\0ԡ$z3$l\Z`iexl', '', 0, '?'),
 ('s˱Y*uO', 'wp-content/plugins/wordfence/vendor/composer/autoload_psr4.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*qBItӟA<\"', '6qQ`d!cf.Bxq', '', 0, '?'),
 ('~Ӹbc\Z$@$*', 'wp-content/plugins/wordfence/vendor/composer/autoload_real.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+>r*mI', 'E\0.¿¯1F(Dfuv˔', '', 0, '?'),
 ('!֐(yJo*J', 'wp-content/plugins/wordfence/vendor/composer/autoload_static.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B\\BH+)	', '84E3I6-9!zGL5', '', 0, '?'),
 ('k}:VNG', 'wp-content/plugins/wordfence/vendor/composer/ca-bundle/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x>PHe6[GF5', 'q!홐%ހP٧Hr.L~', '', 0, '?'),
 ('p1	?J@', 'wp-content/plugins/wordfence/vendor/composer/ca-bundle/res/cacert.pem', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ǧn3Q2G', 'd\"fݎ6em`zP<KO', '', 0, '?'),
 ('O=h\0}OrLb', 'wp-content/plugins/wordfence/vendor/composer/ca-bundle/src/CaBundle.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZU~L5@\ZVU', '/rTrmGс\r%e\r|[', '', 0, '?'),
 (']mٲ	▭', 'wp-content/plugins/wordfence/vendor/composer/installed.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>w̩	&J)', 'M,P:k\nN2[s\nWze]oN', '', 0, '?'),
 ('6N]bNR', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/.gitmodules', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڄ q?s1U', 'REkks&]!i_\"y~Ka', '', 0, '?'),
 ('ECW``-', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/.php_cs', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_@e3bB', 'Lؤ@J9OhG@@Z!\08#l(', '', 0, '?'),
 ('ccgu', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';8e_TƽW', 'ݬISP\"a 7J6QSv_y', '', 0, '?'),
 ('k|DD*@4', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Database/Reader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nAgv1Pص', '0o*\rvAo3:juy', '', 0, '?'),
 (']jRX', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/AddressNotFoundException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '//Rj.', '3\'X\ro`/D/3\Z', '', 0, '?'),
 ('ZgUi1iƾx=', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/AuthenticationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dW,XEEo', 'l?)&&PP$@\\/', '', 0, '?'),
 ('{Z\n0D\rOM*Ut', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/GeoIp2Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N	SX?z', 'Ԧ\nٲLKY1%X7~*', '', 0, '?'),
 ('퇴u46', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/HttpException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lfk<\r\n', 'R!O]pI\n\\VP9=!?', '', 0, '?'),
 ('K?ra#Qh', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/InvalidRequestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IaRɞ%x', 'M bd]FiPOZq', '', 0, '?'),
 ('^4j|I', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/OutOfQueriesException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5H*f$ʝӐ', 'ƝiczP1\"ݢӛoTWry*F', '', 0, '?'),
 ('܆R(\'2WhpG', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/AbstractModel.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@ҏHC5̨[\0', 'Xf:Mt˃#sD4(NGF', '', 0, '?'),
 ('[0^', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/AnonymousIp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'emgݜ|<뼸Dh', '+%G<t1]I5m\Z}E>;', '', 0, '?'),
 ('vV5ǃDu', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Asn.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڄ\n1h;!', 'Mϡ	pk)!\r', '', 0, '?'),
 ('QKQ95Ɣ`', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/City.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>Y!\\zJX', 'B*yL˰au\"t\Z4Z۳Nk¥', '', 0, '?'),
 ('+b\nDfX2YC', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/ConnectionType.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dS:-N!Q0\"', '6)?^\"F*g|&RΠ\0	', '', 0, '?'),
 ('eiy,:T)', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Country.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0Q#2ЏR', '~G)R7i-#R 9Hǫ b', '', 0, '?'),
 ('%~WN82QO', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Domain.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n4F0JC nk', 'Cb,\"\">jŊAlD', '', 0, '?'),
 (']r:@I', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Enterprise.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6:2kP3', '%uMp,.\0@Zqr/Q', '', 0, '?'),
 ('%D?m1QZ\"cAXQq', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Insights.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G=1\nV0', '8}>k6`uideHP^', '', 0, '?'),
 ('Dmuϣ!I5H', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Isp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pٽP]G', '| )YM,30\Z*9p', '', 0, '?'),
 ('V<r\nQ]jvXP', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/ProviderInterface.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z*Nfټ{', 'i˶|1v.4[(m@f>', '', 0, '?'),
 ('J?#͌$M7c', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/AbstractPlaceRecord.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`I.:`PR', '#zR\ZHU>BnP,\'eTtߺ', '', 0, '?'),
 ('MӼ7T~', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/AbstractRecord.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$kA`lwy', '7\r4	춥Q\nc>c\n>Pf84Hk', '', 0, '?'),
 ('wejZqI', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/City.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(,Eڎ;', '5+SsY>%r975[I=`<2M', '', 0, '?'),
 (':1()p]V1-ȩ', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Continent.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qDLa[	?$', 'Gs\0\r/1v=pS-yE.U', '', 0, '?'),
 ('݈3+P\r', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Country.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',0Z%', 'g^M9=&*M{Xb0*u', '', 0, '?'),
 ('\rBeׯE7', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Location.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y}`8vFJ', 'U߆([r嵳gh嬵!m9(\"', '', 0, '?'),
 ('k1/͓ݐ%=', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/MaxMind.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Dqd6+\"U', 'Is;֮ikE@)', '', 0, '?'),
 ('F[㵋Pѳ@', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Postal.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MbP\"xY@0', '\'n*2nԋ)a(_Iqɘ{', '', 0, '?'),
 ('&ɚ%)W&i', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/RepresentedCountry.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>XVDm|P6\n', 'l=b:џ	RZ		6', '', 0, '?'),
 ('P[DXPa', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Subdivision.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';uSl', 'M>:\r&V`\Z:O0Sv;\0Vw', '', 0, '?'),
 ('tV<C', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Traits.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';HoĴ`׳m%', '(l]hЮa	yfh0v\'uvm', '', 0, '?'),
 ('&Yzq[Ff@', 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/WebService/Client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ⶨ;*?z', ':O.\'~y@Y`FMN:n.;q@', '', 0, '?'),
 ('`I,y oY', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';8e_TƽW', 'ݬISP\"a 7J6QSv_y', '', 0, '?'),
 ('d=@hs:k}', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/AuthenticationException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K#lJPe0ug۔', 'UWMslL9#TbWj?\\u', '', 0, '?'),
 ('T.)m&I', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/HttpException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '41l#}pzk1', 'h	_֚!E4\ZvF', '', 0, '?'),
 ('ؽ)uҶewl', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/InsufficientFundsException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mhOലf.I', 'oOb9_b-4-x%T5E9\'', '', 0, '?'),
 ('\Z3H{ǲ', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidInputException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r Ϭn+n', '^qNТ&yN~\'S//>}p', '', 0, '?'),
 ('])TN25F', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidRequestException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GR˗c?qt', '֝Rz5B,nɲ\nHoڨ|', '', 0, '?'),
 ('-[S_عQ', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/IpAddressNotFoundException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1:!G~qic', '^DCguPT!>W\Zk~_5\n8', '', 0, '?'),
 ('2]&֔#^Fq', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/PermissionRequiredException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2΢	/E!<s', '\\=53	ώv_%2A?$', '', 0, '?'),
 ('85\\Rqo-=', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/WebServiceException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h$x /', '<bobnAE7_GK', '', 0, '?'),
 ('ȿ-`uo', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'am;SV#mI', 'R9F47i}ʧC^%', '', 0, '?'),
 ('m>\00X&^Q', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/CurlRequest.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pKz`)9_@', 'aғYeq7YTcȊi$Wت/!,', '', 0, '?'),
 ('ۅnPE6T', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/Request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KdWؿEW', 'RW].dasJMLq+p},', '', 0, '?'),
 ('ӎA}ҎWZ5=*t', 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/RequestFactory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b;v\'g~k', 'm!MJ\"v>,0\0՜ɫ &jِ', '', 0, '?'),
 ('i\Z![8$\"', 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';8e_TƽW', 'ݬISP\"a 7J6QSv_y', '', 0, '?'),
 ('SdlzsV7', 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V~МIXP/$', 'sem/;֘ aZH`g3', '', 0, '?'),
 ('%\\(w&', 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Decoder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I\0$K  	', 'Vp\Z1͌э\'=~ٲF_u\\P', '', 0, '?'),
 ('ϏRCOh', 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/InvalidDatabaseException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '06.tzxo', ';p^\03Թ( Aaw', '', 0, '?'),
 ('O5e;hzw@W', 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Metadata.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z<{~Gf(', ',ב[\Z@+?xPА', '', 0, '?'),
 ('k%\r0̯IN6D\'y', 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g+کdݬ@', 'wbjYStc IdQ', '', 0, '?'),
 ('\Z[`0CI$T\'', 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')H$I3^0', 'Dsmr?vjzMo3=b0KR#', '', 0, '?'),
 ('~iI;ݭ]AS', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/cacert.pem', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '54⓿`', 'DOo;oO]+\05]/\"޸&Q', '', 0, '?'),
 ('I6U\r73p', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/falsepositive.key', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h<|7b', '_^F\";+r&Z~ӦQ|5', '', 0, '?'),
 ('nvZYV', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/init.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`I,Bz1', 'Q52<iiNKOb2d', '', 0, '?'),
 ('BJOzD', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/config.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{1MRKE_/', '|qUUѿÎ|zG>*ۜ\"I;', '', 0, '?'),
 ('Pdc3', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/http.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<i\"KNX,', 'Cѝ⁪r+^YhjzZ', '', 0, '?'),
 ('^Q6lJ!	ͦ', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/json.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd#k', 'tw}?e	hBT92uCv7', '', 0, '?'),
 ('߹V=\"#n	', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/parser/lexer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xb#!YiJ', 'nd@=[cg?N}־Rxl]X', '', 0, '?'),
 ('rMܴ-\nS', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/parser/parser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(wٯ(_', 'b<Wr,M۫Pp>Nn', '', 0, '?'),
 ('X/\0	', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/parser/sqli.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!^(m0G', '9*u1Q: \'s{>/_\'', '', 0, '?'),
 ('n09jv8\"', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CVS+:c|O쬋	', 't=1i\Zn\0N!*iF', '', 0, '?'),
 ('ҭ_VlKg!p1', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/rules.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|D#DD3)', 'h=UuVU-Jށ\'Q;2rg', '', 0, '?'),
 ('!O4bCRRfO', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/storage/file.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zzn', 'Ei!p\0\'R5R$#', '', 0, '?'),
 ('IW9aW3(', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/storage/mysql.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g\n4x%$0', '^,5؎j,ҧQQhs', '', 0, '?'),
 ('c[b]ݽJF', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/storage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J\\4', '!ʁ)wj%pջڞ56q袌m#w', '', 0, '?'),
 ('СqD֚?iX', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/utils.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r!(i.+)Қ\"{', 'ZQ[QG7؍E\"', '', 0, '?'),
 ('\'`F̔~Ė', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/view.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C؍0+C', '`>&i(ŹCf&>Y\"', '', 0, '?'),
 ('<xB', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/waf.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8)1%Lzi', 'G0gXĨ̷u|x)ifWw5;P', '', 0, '?'),
 ('\n@g+T;V', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/xmlrpc.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f\r@)뻚', ';_Im1\n9|!޶', '', 0, '?'),
 ('8K ?O]ʹY', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/rules.key', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZlY^[F\r2xʻ', '6=Sq-5 )EL}AViA]', '', 0, '?'),
 ('xVM>n{Oǟ', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/403-blacklist.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '96N\Z!JYU', ',yS1̥;x5GiO9', '', 0, '?'),
 ('Aػ#\"j', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/403-roadblock.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W1Dn_\Z', '\ZȊ͚\"[%=<F7?h7<', '', 0, '?'),
 ('Q6K4H', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/403.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hDg]ov<N', 'iQƌ\nux\00æp~R/', '', 0, '?'),
 ('rI\0ygE!2\0C', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/503-lockout.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Jl9re.', '7\0|$<9&-MBՌ֌', '', 0, '?'),
 ('j)nQ8ޮD', 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/503.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{߸\ZĚ', 't^17&;*	v[^G*=d$', '', 0, '?'),
 ('{ \rSlſ	', 'wp-content/plugins/wordfence/views/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E\"xK{8dS', 'C\'r9@Kކtw#@k', '', 0, '?'),
 (':f?bj.', 'wp-content/plugins/wordfence/views/blocking/block-list.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LYPͺK\ne', ']SO	o*+uX:ʆw', '', 0, '?'),
 ('r7/y*aڛP] 0', 'wp-content/plugins/wordfence/views/blocking/blocking-create.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4JPЩsB', 'r~5\n̊4GșA', '', 0, '?'),
 ('fpjH\'', 'wp-content/plugins/wordfence/views/blocking/blocking-status.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ˮ_Xk', '4>1^fs{q\'	ީM', '', 0, '?'),
 ('hx*(&kO', 'wp-content/plugins/wordfence/views/blocking/country-block-map.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uyGF,{Xz', '%Ԝ5;x^)G(o', '', 0, '?'),
 ('4ہ;0.*', 'wp-content/plugins/wordfence/views/blocking/country-modal.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-^A?', 'axR;,\'K?QߦH', '', 0, '?'),
 ('m5^u9>', 'wp-content/plugins/wordfence/views/blocking/option-bypass-cookie.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PAf0	/ (w1X', 'IRR\nߎd;I3G', '', 0, '?'),
 ('1?ox<?6', 'wp-content/plugins/wordfence/views/blocking/option-bypass-redirect.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"5y \"\'f', 'agLSSPU:̈p5Q<>Fr', '', 0, '?'),
 ('4ToiEt', 'wp-content/plugins/wordfence/views/blocking/options-group-advanced-country.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '䜮`Su8', 'h]sUsj=(GfvacS', '', 0, '?'),
 ('2ģ_Dx', 'wp-content/plugins/wordfence/views/common/block-navigation-option.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O~}t.K', 'MNF`\r9ӫrP,Q', '', 0, '?'),
 (',@Q', 'wp-content/plugins/wordfence/views/common/indeterminate-progress.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I\"sg4\\(8', '@Zn\"ξ~QՔ8sP\073', '', 0, '?'),
 ('BUjv\\ѣ(', 'wp-content/plugins/wordfence/views/common/license.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y^@:Fgq]p!J', 'Ѝ]|\\͏\\G$y[\\J\"', '', 0, '?'),
 ('llxL,7WN', 'wp-content/plugins/wordfence/views/common/modal-prompt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h\r$o', 'l?9Rw\"H^\rs\ZD:Fa', '', 0, '?'),
 (']pR/$1', 'wp-content/plugins/wordfence/views/common/page-fixed-tabbar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M#Ƃ,nj9{', '+N)¨L	Kz(', '', 0, '?'),
 ('x|sKa', 'wp-content/plugins/wordfence/views/common/page-help.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2o\0X#83~', '$>\n\ZW)O\0(\nݮ\08', '', 0, '?'),
 ('ˋ_o!\'ur', 'wp-content/plugins/wordfence/views/common/page-tabbar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')\ZtU2Ec0\'', 'úM..8ѹ>NwjZWb*B', '', 0, '?'),
 ('qqC$@', 'wp-content/plugins/wordfence/views/common/page-title.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aA\'4=Gg', 'R{hC;_	G+RzrTz`4', '', 0, '?'),
 ('%G]f@%Z', 'wp-content/plugins/wordfence/views/common/section-subtitle.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KcDÃ۬', 'ZJwsh5MEu/jg[-', '', 0, '?'),
 ('%?)', 'wp-content/plugins/wordfence/views/common/section-title.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w]QVմi', 'qr*-TN5\rOc;ma', '', 0, '?'),
 ('w	+j', 'wp-content/plugins/wordfence/views/common/status-circular.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ').=g', 'q4^\"-9\nd1qO,', '', 0, '?'),
 ('^O|\':QǙE', 'wp-content/plugins/wordfence/views/common/status-critical.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q[[_Y[ʛJ{&', 'nI\Zg[\0MZ1]', '', 0, '?'),
 ('sՌQ7o', 'wp-content/plugins/wordfence/views/common/status-detail.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ѿD\0|sW', '\n*vQ(Giu3@4*', '', 0, '?'),
 ('#7rY\0i', 'wp-content/plugins/wordfence/views/common/status-tooltip.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%e\rFdE0sB', '%MbuI]CI\n6z}B4', '', 0, '?'),
 ('Dd.P˴{-yog', 'wp-content/plugins/wordfence/views/common/status-warning.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mfuֺg-g\0C=v', 'N<\r;d*8+)\ZbO?0E', '', 0, '?'),
 ('p̓02@PFtk', 'wp-content/plugins/wordfence/views/common/unsubscribe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}}sJK', 'a\0k5	-\0oDx۠8u%\'', '', 0, '?'),
 ('Mx1ǋTmR_2o', 'wp-content/plugins/wordfence/views/dashboard/global-status.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.1(>\ZVE~', 'Ih棗ht;a6N*z', '', 0, '?'),
 ('{[/ڑ', 'wp-content/plugins/wordfence/views/dashboard/option-howgetips.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ϤSZ2=ǌ^', '\0Ԋw\Z)6Zp-lP-ND', '', 0, '?'),
 ('bE4t=', 'wp-content/plugins/wordfence/views/dashboard/options-group-alert.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z!Hмhڣ', '(t$nèOҨ,B@,Lo|', '', 0, '?'),
 ('~Ⱦ/mր!', 'wp-content/plugins/wordfence/views/dashboard/options-group-dashboard.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&m:7v=', '\nqYۡ>h_P', '', 0, '?'),
 ('̋qB3aY-', 'wp-content/plugins/wordfence/views/dashboard/options-group-email-summary.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6#>{zq\nS%M', 'pRA7ZQjCpNa=M', '', 0, '?'),
 ('Q.ì\\XeOI', 'wp-content/plugins/wordfence/views/dashboard/options-group-general.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':nn)', 'g #ztJȴY12cƳ\"Pow', '', 0, '?'),
 (',M;v', 'wp-content/plugins/wordfence/views/dashboard/options-group-import.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=S0lK@^=', 'υ<URY@*cs', '', 0, '?'),
 (' 5rDg籃', 'wp-content/plugins/wordfence/views/dashboard/options-group-license.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{1i6Lx`3r', 'žĄDP9Lh҅o-', '', 0, '?'),
 (']oMseJ4', 'wp-content/plugins/wordfence/views/dashboard/options-group-view-customization.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~H`b\0nvB JQ\"', 'F˲IG6gV)0k', '', 0, '?'),
 ('PM˝=U', 'wp-content/plugins/wordfence/views/dashboard/status-payment-expiring.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'raX\'z\05+\"7', 'v$r_syYU{ؘ?C', '', 0, '?'),
 ('7\0tt.', 'wp-content/plugins/wordfence/views/dashboard/status-renewing.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'an$6\"', 'tɢC-?\'(uꢦAT-1ba:', '', 0, '?'),
 ('OSYWz!8ʣj', 'wp-content/plugins/wordfence/views/gdpr/banner.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*K`;\0}', ',cn9۝$O`&pTOXiس', '', 0, '?'),
 ('QcmuX\Z3B+X', 'wp-content/plugins/wordfence/views/gdpr/disabled-overlay.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!*o2¯$', 'TCWD9-Χ0(\ZJi', '', 0, '?'),
 ('B!vݡɶ', 'wp-content/plugins/wordfence/views/onboarding/banner.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0͒l\0B', ',{=#\nOQݥWpYEY2>X4h', '', 0, '?'),
 ('mהF@$~r', 'wp-content/plugins/wordfence/views/onboarding/disabled-overlay.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b՗ln', 'ya2-@\"=*\'', '', 0, '?'),
 ('/7ñcxpg', 'wp-content/plugins/wordfence/views/onboarding/fresh-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ނ!)(N+U', '#Ό|pPҰ,mkyt\r܏@6', '', 0, '?'),
 (';%N!9\nL&N', 'wp-content/plugins/wordfence/views/onboarding/modal-final-attempt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yuJɶg', 'l3Ä\ncwx~eLhP\Zے9', '', 0, '?'),
 ('3,cvk', 'wp-content/plugins/wordfence/views/onboarding/overlay.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iŮ9e`2', 'ZMGXL;$xMi|Q%ŽY2$_', '', 0, '?'),
 ('+\ZDZe}', 'wp-content/plugins/wordfence/views/onboarding/plugin-header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kQ4ڌtS*', 'Qh9\07MN64>\\', '', 0, '?'),
 ('\'Ac,	~6ܦ', 'wp-content/plugins/wordfence/views/onboarding/tour-overlay.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':% );\0', '\Z\'ġ맪.s\'sd4^I', '', 0, '?'),
 ('Zd*Yژ', 'wp-content/plugins/wordfence/views/options/block-all-options-controls.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '95IB\"a', 'VG37R(@\n,\n	w', '', 0, '?'),
 ('eҕhV\"', 'wp-content/plugins/wordfence/views/options/block-controls.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8 5U,e\n4(', 'S|POdɇ&ٲ-', '', 0, '?'),
 (',\ZJ\'AWh', 'wp-content/plugins/wordfence/views/options/option-label.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Lgf', '_\r\0\0Z}})v[4', '', 0, '?'),
 ('``\'l`=X(', 'wp-content/plugins/wordfence/views/options/option-select.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q5C&', 'cU3AW\n(:F@zAgG&j9', '', 0, '?'),
 (' oƕt_\0.', 'wp-content/plugins/wordfence/views/options/option-switch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'miE>WcZaig', '&՚j:g&*56yɨdq4֙', '', 0, '?'),
 ('Җ6M֦5wH', 'wp-content/plugins/wordfence/views/options/option-text.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}KmwK5 IO', '+dn\\/M+{x/(h\Z-z%1r', '', 0, '?'),
 ('YmRlX\0:', 'wp-content/plugins/wordfence/views/options/option-textarea.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ac[DO+.f\Z', '~?\\|q4τ>jW\06wQEg=z[', '', 0, '?'),
 ('20mK:r²\\0\nB', 'wp-content/plugins/wordfence/views/options/option-toggled-boolean-switch.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',+[Rֈ', 'lFVjFlV˱VǞB`', '', 0, '?'),
 ('d\nv;O1:,Tn', 'wp-content/plugins/wordfence/views/options/option-toggled-multiple.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!0K܃5{PD(', '{`α0HoG🨶Mo$P', '', 0, '?'),
 ('.麉D0uL-c', 'wp-content/plugins/wordfence/views/options/option-toggled-segmented.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B|ssGo1x', '\n9VW |:]\\)d^U#', '', 0, '?'),
 ('$%#_U_d', 'wp-content/plugins/wordfence/views/options/option-toggled-select.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"p+No+T', 'Xq?\'Є,Uэf[@aWh', '', 0, '?'),
 ('\rzDD', 'wp-content/plugins/wordfence/views/options/option-toggled-sub.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z(a|Α]x', '͏̽U$q9eg\Zrn_aHC', '', 0, '?'),
 ('DT[-U', 'wp-content/plugins/wordfence/views/options/option-toggled-textarea.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '눣E	xbH$t', 'Fm0jC,W$=9nԫ', '', 0, '?'),
 ('*	ą\\', 'wp-content/plugins/wordfence/views/options/option-toggled.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']KrYwB', 'knS	3&Y=Ձ_+?Hƪ%', '', 0, '?'),
 ('7ڔ!2x%XN3', 'wp-content/plugins/wordfence/views/options/option-token.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WY7o	_Ӏ?', ' AQNe\ZywsG@ZI&L', '', 0, '?'),
 ('몳@ =y`', 'wp-content/plugins/wordfence/views/options/options-title.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E0\"#', '֩y\n	ĳXH-<f	c', '', 0, '?'),
 ('T??:q׮Pah\'', 'wp-content/plugins/wordfence/views/reports/activity-report-email-inline.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!߹5HIUw', '&V&Yue1H)L?p=~-a', '', 0, '?'),
 ('Nd#R+r\0s[', 'wp-content/plugins/wordfence/views/reports/activity-report.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}wu!nU', 'k\Z>,z>\r\rKMAI;~', '', 0, '?'),
 ('p{\r %>/Z:', 'wp-content/plugins/wordfence/views/scanner/issue-base.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ǢϚtpAy', '8PciCQVJ+6?pT6\Zzd', '', 0, '?'),
 ('ܑKݓ%eP^U', 'wp-content/plugins/wordfence/views/scanner/issue-checkGSB.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T&#i]<{', 'EPmh>*HS8SFpXbdU8', '', 0, '?'),
 ('%|ݽ>?v{j', 'wp-content/plugins/wordfence/views/scanner/issue-checkHowGetIPs.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':>ޤ+~tͫ*', 'I|^ψg?nƏAd]68R', '', 0, '?'),
 ('ep\r}u_4', 'wp-content/plugins/wordfence/views/scanner/issue-checkSpamIP.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Xcb7qNS', 'MG] ?ugPp1,(V^', '', 0, '?'),
 ('Du\rɲ\Z', 'wp-content/plugins/wordfence/views/scanner/issue-commentBadURL.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4Z?d⢡', '1XaRpLrIO%%|\rVge\0-b^n=', '', 0, '?'),
 ('cG(`E', 'wp-content/plugins/wordfence/views/scanner/issue-configReadable.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' QL', 'R21?ǌ*=bͥ}X&MƷ', '', 0, '?'),
 ('$|c \\~', 'wp-content/plugins/wordfence/views/scanner/issue-control-edit-comment.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' ;͏(vpoq', 'z-\0Aj@ 8cT&՞', '', 0, '?'),
 ('SHLenPq7č', 'wp-content/plugins/wordfence/views/scanner/issue-control-edit-post.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nZHUϘ', 'ݓ!#hlts):}*aEglTD', '', 0, '?'),
 ('ΦHc^)', 'wp-content/plugins/wordfence/views/scanner/issue-control-edit-user.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Dd4\'T)', 'KPUwxd!)n1w<m.ǳf', '', 0, '?'),
 ('(dwI\0:\rXx1DC', 'wp-content/plugins/wordfence/views/scanner/issue-control-hide-file.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y_V^\n%pc', 'dWgme˰5Ҡ:;W\'', '', 0, '?'),
 ('\'@S D', 'wp-content/plugins/wordfence/views/scanner/issue-control-ignore.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\Pm@n', '4āLsFm\Z^\ZDQ', '', 0, '?'),
 (')6#_̟SAF', 'wp-content/plugins/wordfence/views/scanner/issue-control-repair.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[оڰA9(n', 'ߑJ[4#~H8ȉB9+/mv', '', 0, '?'),
 ('u78¸KԊkh', 'wp-content/plugins/wordfence/views/scanner/issue-control-show-details.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I6ϲē]', 'yh;}<6yZ$	M>K(\\#&\"\rej', '', 0, '?'),
 ('eXǌ.\\(&d', 'wp-content/plugins/wordfence/views/scanner/issue-coreUnknown.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'رm:h\rGZڋY', 't8uUUSĒqfS3iiu', '', 0, '?'),
 ('/0)\Z', 'wp-content/plugins/wordfence/views/scanner/issue-database.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[ \nRoN7|', '~❃gd&w[uo|t}', '', 0, '?'),
 ('Xɘy_7XN/', 'wp-content/plugins/wordfence/views/scanner/issue-diskSpace.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z.*:î+1', '\Zޔeg)QRCAm', '', 0, '?'),
 ('4\n	m]ĿЊ', 'wp-content/plugins/wordfence/views/scanner/issue-easyPassword.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[+e[eϙfW', 'QAu&{AiXPK[{0Qk', '', 0, '?'),
 ('VtS-', 'wp-content/plugins/wordfence/views/scanner/issue-file.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?}Ɠ.Μe1U', 'MTzX`પmO]$sX', '', 0, '?'),
 (';fJ1˘+C', 'wp-content/plugins/wordfence/views/scanner/issue-geoipSupport.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0<^=f', 's]ѽj$	↜Skik', '', 0, '?'),
 ('BQaU%', 'wp-content/plugins/wordfence/views/scanner/issue-knownfile.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G^=p=$\Z2', 'RK6N\"3*\"J/0ix0', '', 0, '?'),
 ('wei!<sy\n', 'wp-content/plugins/wordfence/views/scanner/issue-optionBadURL.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't\"N+՛L', '67E0܃ՐC{\\adPb2+pW;P', '', 0, '?'),
 ('㱛 V9{b', 'wp-content/plugins/wordfence/views/scanner/issue-postBadTitle.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd+l@h', '3i]m&	s֯Igeok/M', '', 0, '?'),
 ('!<B4\ZS}', 'wp-content/plugins/wordfence/views/scanner/issue-postBadURL.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u@ަ$,', 'dٍ|]Q!Qw;`7Zf', '', 0, '?'),
 ('\n#T?׻', 'wp-content/plugins/wordfence/views/scanner/issue-publiclyAccessible.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=3n.ZK7Rb~<', 'LؖknHN\n$ʨ#', '', 0, '?'),
 ('H %9lԅE', 'wp-content/plugins/wordfence/views/scanner/issue-skippedPaths.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ROIIԥ{', '9YZA}7=:\'FoG\'Rɹ_-', '', 0, '?'),
 ('n[	X}0', 'wp-content/plugins/wordfence/views/scanner/issue-spamvertizeCheck.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%ؘ5aO_', '3½}߈6-x%uv', '', 0, '?'),
 ('$7y]N', 'wp-content/plugins/wordfence/views/scanner/issue-suspiciousAdminUsers.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P<\0cAFLN', 'R]`[2#XÉi(E\n`rJ', '', 0, '?'),
 ('$SCkdW', 'wp-content/plugins/wordfence/views/scanner/issue-timelimit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J7^њOi', '5QgwBH.f<<Zh&V', '', 0, '?'),
 ('d0ٷ\ZԌn', 'wp-content/plugins/wordfence/views/scanner/issue-wafStatus.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<38xuFRĖȦE', 'n?Qbz	٢)S*,Z', '', 0, '?'),
 ('\"LJ1C4ND', 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginAbandoned.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jv[pջBM', '	)Yt\rb/\Z㲰i\r88', '', 0, '?'),
 ('=F혣ÆK&', 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginRemoved.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9:7]6hVo', '߫/LkOTbdSEiL9~8', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES(',\r	gH6', 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginUpgrade.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aRp#p', 'rL-RW&P!aS0T', '', 0, '?'),
 (';NQ>', 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginVulnerable.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tvwX\n_Yg!', 'r;\Z G[i$)v]j7im#', '', 0, '?'),
 ('rJ<p>Z', 'wp-content/plugins/wordfence/views/scanner/issue-wfThemeUpgrade.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9¡^-,措Eg', 'X0\rvfŭ-$ZuYS ', '', 0, '?'),
 ('|T]:Y$=\'h', 'wp-content/plugins/wordfence/views/scanner/issue-wfUpgrade.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DOۏ~*s/', 'c^\0]*ζז\\T1msd# ^U', '', 0, '?'),
 ('L.dDv', 'wp-content/plugins/wordfence/views/scanner/issue-wpscan_directoryList.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i0j82\ns', 'v\\qY{S<|+{(m?)D=', '', 0, '?'),
 ('mavMvK\Z', 'wp-content/plugins/wordfence/views/scanner/issue-wpscan_fullPathDiscl.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tGN8	6', 'YV)ceW/Zmҳn\'n\0MK~', '', 0, '?'),
 ('zh9ꈦXp+', 'wp-content/plugins/wordfence/views/scanner/no-issues.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xt-|Fe', '_?7c:_@EJs[', '', 0, '?'),
 ('C.yj\0o*f', 'wp-content/plugins/wordfence/views/scanner/option-scan-signatures.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dzGf\'Pidi', 'T1%R2VPRJB\\ˈgen', '', 0, '?'),
 ('sAsYD]', 'wp-content/plugins/wordfence/views/scanner/options-group-advanced.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RYtO`6qz', 'cV*}zc*(6`=9no${', '', 0, '?'),
 ('e}0wTnv_g~', 'wp-content/plugins/wordfence/views/scanner/options-group-basic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',z7\nɲߞ', 'Ab.hNh|:H-=(1fJ', '', 0, '?'),
 ('NTZto\r%F', 'wp-content/plugins/wordfence/views/scanner/options-group-general.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_Վ7;__', ':Wn%JzW7&NH<\"dKe', '', 0, '?'),
 (' ń1r}mJGWR', 'wp-content/plugins/wordfence/views/scanner/options-group-performance.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iLxЊsf', 'da16hr76[)ՋOM罒z', '', 0, '?'),
 ('lxy\Z\"', 'wp-content/plugins/wordfence/views/scanner/options-group-scan-schedule.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ź-܉|JU', 'V\rc7g6抭VmCP', '', 0, '?'),
 ('<3v&F', 'wp-content/plugins/wordfence/views/scanner/scan-failed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Eۻ04r', 'H?MqK-4l_<*=܀ňp+', '', 0, '?'),
 ('հ	̋ȲS', 'wp-content/plugins/wordfence/views/scanner/scan-progress-detailed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' j<c(SCJ', 'r3H[~2.<_J3{T{XӼPq', '', 0, '?'),
 ('|]D\Z.E', 'wp-content/plugins/wordfence/views/scanner/scan-progress-element.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J!%IWb', 'tẁ~sg\n+A}bLNu', '', 0, '?'),
 ('pխ^@#Ԓ', 'wp-content/plugins/wordfence/views/scanner/scan-progress.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%\nrE?m', 'Qf\0.<:;6\"{N+mE', '', 0, '?'),
 ('\'_iYm1R', 'wp-content/plugins/wordfence/views/scanner/scan-results.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8΂,\\', 'SHS6p_2*\rTD\0G9', '', 0, '?'),
 ('4$ꎪ', 'wp-content/plugins/wordfence/views/scanner/scan-scheduling.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0W쮜)Ǣ±', 'b¥USw툒g:=P', '', 0, '?'),
 ('F_qCF!o4p', 'wp-content/plugins/wordfence/views/scanner/scan-starter.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E `b{{v\r', 'qFxgTA]Mk^>\'UB', '', 0, '?'),
 ('D!VD+', 'wp-content/plugins/wordfence/views/scanner/scan-type.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_Zb4ګ*', 'w.\0/\"kzvHQ6s&>`KRC', '', 0, '?'),
 ('KKOfSdiB0Ov', 'wp-content/plugins/wordfence/views/scanner/scanner-status.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ޑ[.ɕl\\:', '&k0lcX**?\rܒ', '', 0, '?'),
 ('9~\0{@', 'wp-content/plugins/wordfence/views/scanner/site-cleaning-beta-sigs.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',)Rqy|4.', '%U<GH[.!e˂t,gsɄ', '', 0, '?'),
 ('&#pJh', 'wp-content/plugins/wordfence/views/scanner/site-cleaning-bottom.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',Is0w4Q', 'E\"v+󴄏bo}xa{:@E', '', 0, '?'),
 ('o}C܊8EG', 'wp-content/plugins/wordfence/views/scanner/site-cleaning-high-sense.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sTDzҧm', '5؄:\"sx4Ҹ\09`\Zi?', '', 0, '?'),
 ('Ŋ6@L(`', 'wp-content/plugins/wordfence/views/scanner/site-cleaning.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5w1,5bdvF', 'g\"g2ߚ}qA?$)d', '', 0, '?'),
 ('mñ~R?', 'wp-content/plugins/wordfence/views/tools/options-group-2fa.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ONjPv4', 'm]n>nFf;Gf-m_L4b\'', '', 0, '?'),
 ('j5fj', 'wp-content/plugins/wordfence/views/tools/options-group-live-traffic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5_+EG', 's}RB|KzI[Y)r', '', 0, '?'),
 ('/=+HhE14ʆ', 'wp-content/plugins/wordfence/views/tours/login-security.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v,DWp-Iu)!', 'pRVs-9<Rꗚ֣uqL', '', 0, '?'),
 ('֋8[0ʊ', 'wp-content/plugins/wordfence/views/waf/debug.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FM@i-M', '	;B@EŻ߬ue}', '', 0, '?'),
 ('y66lMC', 'wp-content/plugins/wordfence/views/waf/firewall-status.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lw\0i75G', '\'WֵDrDBeH\n@\":=!M#f', '', 0, '?'),
 ('÷g$Ms', 'wp-content/plugins/wordfence/views/waf/option-rate-limit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sgb0Cm@X', ';<`ҶsfRХC^W^	]<!>', '', 0, '?'),
 ('@\Z!zrWp', 'wp-content/plugins/wordfence/views/waf/option-rules.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' {<\Z\0\r\Z$', '4fŜ\"\"ł>2L\0\"k1S\nw', '', 0, '?'),
 ('2X69G3\Z+}A6', 'wp-content/plugins/wordfence/views/waf/option-whitelist.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ψ-˯3w', 'G_`8B؎P\n\",\'HŨ', '', 0, '?'),
 ('zɐ@//@', 'wp-content/plugins/wordfence/views/waf/options-group-advanced-firewall.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IN~dFe', 'lBoS)ޥ9o!ǻm#$', '', 0, '?'),
 ('[Ӄ2W', 'wp-content/plugins/wordfence/views/waf/options-group-basic-firewall.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '03*66-FU.', 'TQ&n)&MgDgШ', '', 0, '?'),
 ('K<H<7E,l', 'wp-content/plugins/wordfence/views/waf/options-group-brute-force.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ŏqў¯/	\n', 'W_\rF_H\07	iatr؈M=', '', 0, '?'),
 ('!y\'Ub#}', 'wp-content/plugins/wordfence/views/waf/options-group-rate-limiting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r0Wò(=', '6/E8t*FRH?\"', '', 0, '?'),
 ('gs)m%', 'wp-content/plugins/wordfence/views/waf/options-group-whitelisted.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ViK۹v?', '-L#syܥjswBt\'ш;8=', '', 0, '?'),
 ('nAj+uVG7d', 'wp-content/plugins/wordfence/views/waf/status-tooltip-learning-mode.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ُ8l%', '!]`_.\\? .\ZbɐGQe)m', '', 0, '?'),
 ('=	]}*<.', 'wp-content/plugins/wordfence/views/waf/waf-install-manual.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$x~)[ڜz', '7R N`n^?()^RΚĖ', '', 0, '?'),
 ('\\H:u3%Fw', 'wp-content/plugins/wordfence/views/waf/waf-install-success.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{rb^?', '/\\2CeL+:pZ', '', 0, '?'),
 ('ZDl=컫', 'wp-content/plugins/wordfence/views/waf/waf-install.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']cE^GMSf', '\\H.T:ďg]B|͌|{=pǵ', '', 0, '?'),
 ('u[D', 'wp-content/plugins/wordfence/views/waf/waf-modal-wrapper.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nγUǩ7PF', 'f4֒p.Օ*^Nl8A', '', 0, '?'),
 ('p:,`OlL(A', 'wp-content/plugins/wordfence/views/waf/waf-uninstall-success.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*sf2', '|\rߣ2잿9/%[7m{Eu-', '', 0, '?'),
 ('Ao\rZԔ_t', 'wp-content/plugins/wordfence/views/waf/waf-uninstall.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wxlMI\0lT㐥', 'lEN1-R|pG^;ï1', '', 0, '?'),
 ('YJ|[DyY', 'wp-content/plugins/wordfence/waf/.htaccess', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E\"xK{8dS', 'C\'r9@Kކtw#@k', '', 0, '?'),
 ('Ha+̰I', 'wp-content/plugins/wordfence/waf/bootstrap.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3*?)\ZSK*', 'FZg)g 30	z\r', '', 0, '?'),
 ('X\\shv]iB', 'wp-content/plugins/wordfence/waf/wfWAFGeoIP2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '݇(0,mG_Y3', '^)oBfg*VP?~u:', '', 0, '?'),
 ('\0D`8Rɲ%', 'wp-content/plugins/wordfence/waf/wfWAFIPBlocksController.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}`iy', 'Tܯ19^ջP\'Ld%k|P؞', '', 0, '?'),
 ('%7娳', 'wp-content/plugins/wordfence/waf/wfWAFUserIPRange.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yFH\'\'nގ', 'KD[Rஞ 5:grP7*X\Z', '', 0, '?'),
 ('E#-v376Ť', 'wp-content/plugins/wordfence/wordfence.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݏtxPfq', '}$zīWNgN/>U', '', 0, '?'),
 ('+*Zf>\r«', 'wp-content/plugins/wp-cerber/admin/cerber-settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T|KL/R.~h%', '֞$g&iDJVByvo{YC', '', 0, '?'),
 ('ZVZ@Z9d8', 'wp-content/plugins/wp-cerber/assets/admin.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LDi&?{l 7n', 'V1a|Ú/vltX\\p4lِ', '', 0, '?'),
 ('\\Ohq2.', 'wp-content/plugins/wp-cerber/assets/admin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b_ũOW<w%\'', 'AM wׁ+T֖KJJ#', '', 0, '?'),
 ('ZY<}*aF', 'wp-content/plugins/wp-cerber/assets/ajax-loader.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V:dbEFR', 'zkG AKyhbah', '', 0, '?'),
 ('	J.\'Vn{|T', 'wp-content/plugins/wp-cerber/assets/bgwidget.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`}\Z#]s	T', '\\x\Z]Q*4@xLc.r', '', 0, '?'),
 ('Gqb٫	s', 'wp-content/plugins/wp-cerber/assets/bn2ra.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8^ְsO', 'gc};\'B9ق\Z4CWJR%', '', 0, '?'),
 ('SD~pv', 'wp-content/plugins/wp-cerber/assets/bn3ra.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J\n`ehG}', 'Ul,/gQg\'	I&', '', 0, '?'),
 ('qXr:Hx[', 'wp-content/plugins/wp-cerber/assets/flags/ad.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm\Z3	{/_s_5', 'j~+EA9M\Zec0T', '', 0, '?'),
 ('+lHmӿnQ', 'wp-content/plugins/wp-cerber/assets/flags/ae.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '* X4^', 'ظ,&9uO)Sղ?(2ᖘLq9,', '', 0, '?'),
 ('|O<VX@', 'wp-content/plugins/wp-cerber/assets/flags/af.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qW_\".zAa', 'X+$@yUg!NSζdP', '', 0, '?'),
 ('oj̄C-#|E', 'wp-content/plugins/wp-cerber/assets/flags/ag.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ig(4ej52^G', '2M`O?iXeBqx', '', 0, '?'),
 ('2>[{Lj0s', 'wp-content/plugins/wp-cerber/assets/flags/ai.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_]àa{', '*[3#h\"M@]lΉ05>Иۖf', '', 0, '?'),
 ('L?\n\nx@', 'wp-content/plugins/wp-cerber/assets/flags/al.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#S{r<', 'GU0<>.]fX[I\07', '', 0, '?'),
 ('9v@onr*', 'wp-content/plugins/wp-cerber/assets/flags/am.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3(vߩM$Cݣn', 'c4n6WV^:sݺ#', '', 0, '?'),
 ('PyXn', 'wp-content/plugins/wp-cerber/assets/flags/an.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B\ZEsF\r8', 'ZiLzq`{ۯۇn	fNzY3i', '', 0, '?'),
 ('2|MJ/͆^}', 'wp-content/plugins/wp-cerber/assets/flags/ao.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K\'cufq', '9&[؊|&ʘ<HR', '', 0, '?'),
 (',U(ejR.XP', 'wp-content/plugins/wp-cerber/assets/flags/aq.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('z]Őx\'!*[,', 'wp-content/plugins/wp-cerber/assets/flags/ar.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IauKc io1', 'R2$͗[G`d;TC\0ԙU', '', 0, '?'),
 ('l1r$~A)', 'wp-content/plugins/wp-cerber/assets/flags/as.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X/Z3', 'UŰ\r^W}Ux\"C@Scul', '', 0, '?'),
 (',x\ZppL', 'wp-content/plugins/wp-cerber/assets/flags/at.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v$<dkmy\\g', 'g߇;o*^U㋥GjJ>ED\\%', '', 0, '?'),
 ('})Z#4c4', 'wp-content/plugins/wp-cerber/assets/flags/au.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZNn[', '|SQw\0jGN*Mv%', '', 0, '?'),
 ('g<)t.F', 'wp-content/plugins/wp-cerber/assets/flags/aw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'egqAŎRAj?&v', 'J	MwPs0)nFb', '', 0, '?'),
 ('Pal&:)VI', 'wp-content/plugins/wp-cerber/assets/flags/ax.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lho%>T', 'Ku*Q(giC`i0ȇR.c', '', 0, '?'),
 ('a\'0E\nj', 'wp-content/plugins/wp-cerber/assets/flags/az.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'djCO#MP4`jzG', '=KLJv͎\ZG詋3z6', '', 0, '?'),
 ('cEcc/2F', 'wp-content/plugins/wp-cerber/assets/flags/ba.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S߫ܟ]A;\Z', '\Z2u2S9{ӨGD+1', '', 0, '?'),
 ('@L<m^cIc', 'wp-content/plugins/wp-cerber/assets/flags/bb.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0(zcq', '7!Ky=]b\neO-3{/QȳRҳL', '', 0, '?'),
 ('h_-\rus{t', 'wp-content/plugins/wp-cerber/assets/flags/bd.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_RjQk.4', 'kj8F/)5aC,12OH\'', '', 0, '?'),
 ('S򽟈beL', 'wp-content/plugins/wp-cerber/assets/flags/be.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YZxʭT/ ', '4nMMe)񤉓<IaP1K~#`G', '', 0, '?'),
 ('3)e/`/\rPh=', 'wp-content/plugins/wp-cerber/assets/flags/bf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' >=$.', 'Ȋ:h.n(xD⃪F\"{`iN\0#', '', 0, '?'),
 ('92R]X~i', 'wp-content/plugins/wp-cerber/assets/flags/bg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[g:؀uOc', '{hs`W\\vnOF\ZrJs', '', 0, '?'),
 ('~C>xh\r', 'wp-content/plugins/wp-cerber/assets/flags/bh.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Tx\n=CS\ZfPF|', '(=AEheSJ駄_Ve2ZE&j', '', 0, '?'),
 ('{1u.b}κ0$', 'wp-content/plugins/wp-cerber/assets/flags/bi.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',|\\_27k	', 'vJȢ\"DWK9q	Q^F%aA', '', 0, '?'),
 ('Y SzX^', 'wp-content/plugins/wp-cerber/assets/flags/bj.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ẑ(,ߨP}r', '`	UYģÇ/5T\"5', '', 0, '?'),
 ('6n[lv񺦼q', 'wp-content/plugins/wp-cerber/assets/flags/bl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('N\0f~;I', 'wp-content/plugins/wp-cerber/assets/flags/bm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yg¶Mnz', '<@ H*eթG)-CIԲ^', '', 0, '?'),
 ('hxhM*S', 'wp-content/plugins/wp-cerber/assets/flags/bn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C.Msg:', 's@Zd}x-r^x8Z.', '', 0, '?'),
 ('\\\r :#K', 'wp-content/plugins/wp-cerber/assets/flags/bo.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0-avv', '=IS}@lU%s=FG41R\'', '', 0, '?'),
 ('or籽', 'wp-content/plugins/wp-cerber/assets/flags/bq.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('y&eWK6]H', 'wp-content/plugins/wp-cerber/assets/flags/br.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ն=Xo#', 'lYC#fݽ\Z\'4	fk>χO}', '', 0, '?'),
 ('1tv39]AaC-', 'wp-content/plugins/wp-cerber/assets/flags/bs.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rt\ZcKo', '_o	&\'&QR~E1d', '', 0, '?'),
 ('9L/gJ)3', 'wp-content/plugins/wp-cerber/assets/flags/bt.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6@^؟JH;2:', '	\'A-êurdƹQ', '', 0, '?'),
 ('T޼q%<>zբ', 'wp-content/plugins/wp-cerber/assets/flags/bv.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j.#0P', '2!u6#=%ӹOC4	\ZrM', '', 0, '?'),
 ('&=Nu#y', 'wp-content/plugins/wp-cerber/assets/flags/bw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A]GG9P', '#OmT>O://c/Pu$0', '', 0, '?'),
 ('FԺ6ފ\0Q', 'wp-content/plugins/wp-cerber/assets/flags/by.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Fƞ01', 'R8;kmlXV6V\"ď', '', 0, '?'),
 ('m!U߄U', 'wp-content/plugins/wp-cerber/assets/flags/bz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Wڜ', '0^k ReqCGQ\"', '', 0, '?'),
 ('sGS4', 'wp-content/plugins/wp-cerber/assets/flags/ca.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q1I;pls', 'BxzUO..tXB@ͤ%', '', 0, '?'),
 ('Gۉ\\}', 'wp-content/plugins/wp-cerber/assets/flags/cc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' .-6׈C#', '&iy__vV>~d', '', 0, '?'),
 ('yw-p`)', 'wp-content/plugins/wp-cerber/assets/flags/cd.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|E\0{+k`֚o', 'bf&<9\nTĔn\Z~\Z,!', '', 0, '?'),
 ('U]>rք{v', 'wp-content/plugins/wp-cerber/assets/flags/cf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CoG`?', '\0m٢KKǡNЙT	', '', 0, '?'),
 ('0uRD{1', 'wp-content/plugins/wp-cerber/assets/flags/cg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oK*A4@T$', 'ŔwEiavA}z[ɵ76C', '', 0, '?'),
 ('kLǤe(ȸK', 'wp-content/plugins/wp-cerber/assets/flags/ch.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CkgiTIކ', 'R:=bU|O@R˂}-', '', 0, '?'),
 ('=NgÈW;', 'wp-content/plugins/wp-cerber/assets/flags/ci.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vyd2¹', '.=D	dԢ)*k,8Dˬ', '', 0, '?'),
 ('!,(?#', 'wp-content/plugins/wp-cerber/assets/flags/ck.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'[8A3;yg', '3{;ߍ2Dh}(', '', 0, '?'),
 ('Hɪ\Z퟽4ͻ', 'wp-content/plugins/wp-cerber/assets/flags/cl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xQaAߜ', ' Iײ|01aKըr%բ(ظlR', '', 0, '?'),
 ('\ZM`yᕙd', 'wp-content/plugins/wp-cerber/assets/flags/cm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!.`tsI01', 'F]gZBNto	Qm,j', '', 0, '?'),
 ('\ZN\Z`i̳%ج0', 'wp-content/plugins/wp-cerber/assets/flags/cn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A-V|֬S', 'j_\r49>x+EXHdFK`', '', 0, '?'),
 ('R<%݌D-', 'wp-content/plugins/wp-cerber/assets/flags/co.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@]\"^K0eu>', '=ӨĹ^ٜn_?*`s<;2', '', 0, '?'),
 ('j3]pBR!Iq', 'wp-content/plugins/wp-cerber/assets/flags/cr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v.\Zg9V', 't~ V7VL$D\0p;\"\ZX1', '', 0, '?'),
 ('ȣgӰǱCs', 'wp-content/plugins/wp-cerber/assets/flags/cs.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qȥ`', '3#xUN^[ ^1a֌GX9PP', '', 0, '?'),
 ('DVɪl-XC`\\', 'wp-content/plugins/wp-cerber/assets/flags/cu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ѝhm!73.', 'PbLO*]3o	}zxN', '', 0, '?'),
 ('/V	X[\n', 'wp-content/plugins/wp-cerber/assets/flags/cv.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#!C@', '#wQuguw[ȥ~', '', 0, '?'),
 ('|W<|ƀJ', 'wp-content/plugins/wp-cerber/assets/flags/cw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('4mT曢A', 'wp-content/plugins/wp-cerber/assets/flags/cx.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^fmW}}]', 'db\'f-LZ\0g ]_׭\'o', '', 0, '?'),
 ('ط;\0', 'wp-content/plugins/wp-cerber/assets/flags/cy.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'do||/$Bl', '븻Òc.\"0Ci+\Z\Z{pċa', '', 0, '?'),
 ('д\0N莦v\n=t', 'wp-content/plugins/wp-cerber/assets/flags/cz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cR}SJ', 'm*1\"vlř:\\f?.؟i\0', '', 0, '?'),
 ('m{8]ך<', 'wp-content/plugins/wp-cerber/assets/flags/de.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NJ&z\\ҿ~i', 'Ū3J:2;;pJkL~', '', 0, '?'),
 (',a(f>k', 'wp-content/plugins/wp-cerber/assets/flags/dj.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '02cV>!>', 'A|L0ܷH̠Y', '', 0, '?'),
 ('\\d;ѳbI%@', 'wp-content/plugins/wp-cerber/assets/flags/dk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K\nl7D!', '%wr6U^/16a\'<bB', '', 0, '?'),
 ('aͮ(o:`', 'wp-content/plugins/wp-cerber/assets/flags/dm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e<-.w', 'h*W̕|l0jhWp:z[V,', '', 0, '?'),
 ('_Sަ:{j}', 'wp-content/plugins/wp-cerber/assets/flags/do.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n*{\04sV', '\n/HҾ/\\-ܧRx', '', 0, '?'),
 ('ꐏFrH}@$bF-', 'wp-content/plugins/wp-cerber/assets/flags/dz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}ZA', '~\nÀo\'x\0Xh.}%', '', 0, '?'),
 ('?Z8.G', 'wp-content/plugins/wp-cerber/assets/flags/ec.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K׏* k&(ʬjJ', 'Bd=Zj?r/{\Z7MF\'n-Zi', '', 0, '?'),
 ('1! I<Em#', 'wp-content/plugins/wp-cerber/assets/flags/ee.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|h~\rO', 'RBᣛ݇84ɐ6B\0ȸ:l-IB', '', 0, '?'),
 ('\\mՀ;', 'wp-content/plugins/wp-cerber/assets/flags/eg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C֙x8\0 ', '_ih<[NsD}?\'CY', '', 0, '?'),
 ('(=,*F\n^Jv', 'wp-content/plugins/wp-cerber/assets/flags/eh.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<n7W6^\Z', 'IauK+<?`]n]m|PّS', '', 0, '?'),
 ('ZS=\0vH', 'wp-content/plugins/wp-cerber/assets/flags/er.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PՔ#ӕ?.O]', '\0D?J1nd&%6\"ᅃ. ', '', 0, '?'),
 ('ut ɪ', 'wp-content/plugins/wp-cerber/assets/flags/es.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݵ*M,M\'A@K', '򐈄c`MCu6ם)X%|GWִ>', '', 0, '?'),
 ('6ck6_sx$>\"', 'wp-content/plugins/wp-cerber/assets/flags/et.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8ZltS\"', 'c/s]\Z`Rꩧ`֌EP', '', 0, '?'),
 ('766? X,-6)', 'wp-content/plugins/wp-cerber/assets/flags/eu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't;zCoػ@', 'm2A,%(#%c)+w', '', 0, '?'),
 ('gC1N(q;3)h', 'wp-content/plugins/wp-cerber/assets/flags/ez.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('Ȯr&xq', 'wp-content/plugins/wp-cerber/assets/flags/fi.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ќ0Ce#', 'r\r=O֓bt:ٚU$R?}t', '', 0, '?'),
 ('<$CDO#', 'wp-content/plugins/wp-cerber/assets/flags/fj.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':yZd=\\lr', 'Cȶ]*sl湘Jڀ<e', '', 0, '?'),
 ('`#Q?>6)', 'wp-content/plugins/wp-cerber/assets/flags/fk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!OwB<oa9E', 'k؊2M&C9&0dHlq~9q', '', 0, '?'),
 ('i֯1oR!', 'wp-content/plugins/wp-cerber/assets/flags/fm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=KbF!Xټh[(@', '/_SL`ZII(1', '', 0, '?'),
 ('=IUcOG', 'wp-content/plugins/wp-cerber/assets/flags/fo.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jX?c0<GIa~', 'lNwʭ!Xuw_9{-]L/ܐ', '', 0, '?'),
 ('G^2G%k', 'wp-content/plugins/wp-cerber/assets/flags/fr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nFs{7}X#@Vؐ', 'KCZpYJ\01 7aƎF', '', 0, '?'),
 ('Ee&0\'0٣', 'wp-content/plugins/wp-cerber/assets/flags/ga.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`#HG)4X', 'NvXaa 	%QUSJX;M.Gj', '', 0, '?'),
 ('mI.E~ps', 'wp-content/plugins/wp-cerber/assets/flags/gb.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o;T+<&', '=޺\ZPͿ\\ȝF_\\', '', 0, '?'),
 ('$i6]}+', 'wp-content/plugins/wp-cerber/assets/flags/gd.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(*GkηG֊', 'KdhJJqyG|-<r	S[l', '', 0, '?'),
 ('<b!', 'wp-content/plugins/wp-cerber/assets/flags/ge.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AwJ#ܿdF', '6oMXݕD֖M+', '', 0, '?'),
 ('DT\'{_̤ؤP7', 'wp-content/plugins/wp-cerber/assets/flags/gf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nFs{7}X#@Vؐ', 'KCZpYJ\01 7aƎF', '', 0, '?'),
 ('s,jj3', 'wp-content/plugins/wp-cerber/assets/flags/gg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('nHHХR?', 'wp-content/plugins/wp-cerber/assets/flags/gh.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',La^#de\'', '^sVz3:4i[K', '', 0, '?'),
 ('\ZB V݄K', 'wp-content/plugins/wp-cerber/assets/flags/gi.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',K]0ȥR', '/ifhrZ(b2\Z>˾->', '', 0, '?'),
 ('Eim/f\\8+Z', 'wp-content/plugins/wp-cerber/assets/flags/gl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8+xO,o*}9', 'J\'Ѫ(6֌臚#{dpI', '', 0, '?'),
 ('.	r\ZQ', 'wp-content/plugins/wp-cerber/assets/flags/gm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S\'A)zU$', ']Z!p1{f^EQ3sH', '', 0, '?'),
 ('6W(\'P4', 'wp-content/plugins/wp-cerber/assets/flags/gn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MMH,', 'nrA[/Á*f|DeTJCJ', '', 0, '?'),
 ('{19+sh', 'wp-content/plugins/wp-cerber/assets/flags/gp.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CG_t?9rK', 'hd0)m3aͱQDV}', '', 0, '?'),
 ('	wEr} ', 'wp-content/plugins/wp-cerber/assets/flags/gq.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '׾\r>.ⶱG', 'd^fr=mMY,', '', 0, '?'),
 ('}l}%CKc}NH\Z', 'wp-content/plugins/wp-cerber/assets/flags/gr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f\0$*0B֏*', ',ǱW?lGkQq', '', 0, '?'),
 ('#^ ̉Θ!Mz?{{', 'wp-content/plugins/wp-cerber/assets/flags/gs.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~\Z7co#.', 'o=bieU\ZN1>Vy..3Z`', '', 0, '?'),
 ('gE\nXF)4\0y\'', 'wp-content/plugins/wp-cerber/assets/flags/gt.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eQ2\Z>^', '\ndJj7ؖSya{SmԲ', '', 0, '?'),
 ('Oil%βf', 'wp-content/plugins/wp-cerber/assets/flags/gu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iņ-\0hHBs', 'p,aL|vLY*[T$+', '', 0, '?'),
 ('0զ', 'wp-content/plugins/wp-cerber/assets/flags/gw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*qWMf2c', 'dn;Lm%\"NAoZE!J_͆', '', 0, '?'),
 ('1G[DqWt', 'wp-content/plugins/wp-cerber/assets/flags/gy.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qB}>_', 'L:,B[aa<w*@', '', 0, '?'),
 ('DE.Gྠb9k8L=', 'wp-content/plugins/wp-cerber/assets/flags/hk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i.@C_', '52Kx襹*ȪbB;b*\"', '', 0, '?'),
 ('@6ߝ\0AhHc', 'wp-content/plugins/wp-cerber/assets/flags/hm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZNn[', '|SQw\0jGN*Mv%', '', 0, '?'),
 ('NlIV,Z', 'wp-content/plugins/wp-cerber/assets/flags/hn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';Ҿ:', 'e{9[۫pNk83)t$<5', '', 0, '?'),
 (']Dd33t', 'wp-content/plugins/wp-cerber/assets/flags/hr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZOe..o', 'eT\\B;vu!\0~\" P;', '', 0, '?'),
 ('<t@zfjrh', 'wp-content/plugins/wp-cerber/assets/flags/ht.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Wѭb;t', '#{՞p.3T[KjPx=', '', 0, '?'),
 ('[w[ﾩ\r	|2I)', 'wp-content/plugins/wp-cerber/assets/flags/hu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C.FL\ncQ', 'g.XaMwMa-#lW=h1Uh', '', 0, '?'),
 (']Mp vP', 'wp-content/plugins/wp-cerber/assets/flags/id.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o\'!*HkV\0<', '~\0`vo\\ETZeᜊzeA`[HF', '', 0, '?'),
 (':ҝ\Zdm*v', 'wp-content/plugins/wp-cerber/assets/flags/ie.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tHt`Mˉ.2*', 'HX \Z۴n\0ynn', '', 0, '?'),
 ('IQM{:\r|6ce', 'wp-content/plugins/wp-cerber/assets/flags/il.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D~324Z', 'b=؜1<:1ƭnn`%ޘϮ', '', 0, '?'),
 (' pE4q&?J', 'wp-content/plugins/wp-cerber/assets/flags/im.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('T:Dğ.&l\Z?&A', 'wp-content/plugins/wp-cerber/assets/flags/in.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FweIɻj籏{\n', '4x\n<~z{VЯ\"N', '', 0, '?'),
 ('H\Z.hRbn', 'wp-content/plugins/wp-cerber/assets/flags/io.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<eeC', 'ɫ-)il\na1}!}~	pd', '', 0, '?'),
 (',愵Xաy%!o', 'wp-content/plugins/wp-cerber/assets/flags/iq.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(C!>hF', '=zZ!i74\'j\"DC͎(', '', 0, '?'),
 ('\0Ob5o', 'wp-content/plugins/wp-cerber/assets/flags/ir.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dVMt^,7xD', 'i֚b5J?]+Hr8', '', 0, '?'),
 ('+^њ\rk', 'wp-content/plugins/wp-cerber/assets/flags/is.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4o$^z1Tɪ', 'XƠ8\'*ӱ4$G\"JD8@6', '', 0, '?'),
 ('MB!:', 'wp-content/plugins/wp-cerber/assets/flags/it.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{/z]>F@B', 'ⴟk 9bmd6l{e o', '', 0, '?'),
 ('Le`d˻W', 'wp-content/plugins/wp-cerber/assets/flags/je.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('VhG!j\'', 'wp-content/plugins/wp-cerber/assets/flags/jm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bF/+d9', '\nƼH_TT2[_oxu', '', 0, '?'),
 ('.I\\', 'wp-content/plugins/wp-cerber/assets/flags/jo.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z>\Z➶6A3+Lh', '\'\"5zFaLK3pr*=.>aq\"', '', 0, '?'),
 ('޸Ѥ;D', 'wp-content/plugins/wp-cerber/assets/flags/jp.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Jn@Aל^', '7^qU` 	}wͧh', '', 0, '?'),
 ('SK8kfkXҍ\\', 'wp-content/plugins/wp-cerber/assets/flags/ke.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eKPSPX', '_/6pp	64zI\0ֱÉf', '', 0, '?'),
 ('GRm)', 'wp-content/plugins/wp-cerber/assets/flags/kg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8]/E0%gQյQ', '3$fRx)@\\e.3\ZΩ\r`pY', '', 0, '?'),
 ('A\\ݛ-7\Z1', 'wp-content/plugins/wp-cerber/assets/flags/kh.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*\0B/\ro5;', 'm~~B)~D?ID', '', 0, '?'),
 ('2u\"<g@f%', 'wp-content/plugins/wp-cerber/assets/flags/ki.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kȶ', '\"&9ʈ7lZP퇢 j/', '', 0, '?'),
 ('Wf0\nD	/\'', 'wp-content/plugins/wp-cerber/assets/flags/km.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%&\'zV', ';NS6:݇u͙rx ', '', 0, '?'),
 ('kۚ	#푥sePY', 'wp-content/plugins/wp-cerber/assets/flags/kn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?\Z׋%q$', 'g-)ASZvZ-<.aءUن+', '', 0, '?'),
 ('J>Uv0', 'wp-content/plugins/wp-cerber/assets/flags/kp.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ze+jU+]', 'ĀNɳ2.@+-YzI', '', 0, '?'),
 ('\0ceU`{g', 'wp-content/plugins/wp-cerber/assets/flags/kr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SUґ0Pl{ip', 'Zy\Z(rQNӌb[P', '', 0, '?'),
 ('M\\-Dkf', 'wp-content/plugins/wp-cerber/assets/flags/kw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Hp8V$vL\rY]', '&\\m0Iz{<>|\'L', '', 0, '?'),
 ('ͤ8B¸]E|', 'wp-content/plugins/wp-cerber/assets/flags/ky.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M dpV,d', 'QP8TG{jrNK-,/lj	', '', 0, '?'),
 ('45 -rS', 'wp-content/plugins/wp-cerber/assets/flags/kz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0OCtЛ>i3', '>ū[h@HXXՈk55gDD', '', 0, '?'),
 ('3S#ǣ+Ke\0Ⱦ', 'wp-content/plugins/wp-cerber/assets/flags/la.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3MU\'\Zkrc&', '[lԬ`l !_>kwdXp_', '', 0, '?'),
 ('K\Z }ȑׄː', 'wp-content/plugins/wp-cerber/assets/flags/lb.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',6uƤs%D^P)', '!slQ_~mInG).', '', 0, '?'),
 ('º\06R&q', 'wp-content/plugins/wp-cerber/assets/flags/lc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?x2\Zˁ%*', 'dVd5w$E,Ư{l', '', 0, '?'),
 ('[\'LFd+k', 'wp-content/plugins/wp-cerber/assets/flags/li.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#f9%QZ!;', '`A/\\) 5/簤GJ`', '', 0, '?'),
 ('J$R_o', 'wp-content/plugins/wp-cerber/assets/flags/lk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm t', 'vlatbNuG:<?7=', '', 0, '?'),
 ('Ou6oG', 'wp-content/plugins/wp-cerber/assets/flags/lr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!a!^KGC ,', 'b쁣=Q*IGTG	!]E9', '', 0, '?'),
 ('~FӡqTMB', 'wp-content/plugins/wp-cerber/assets/flags/ls.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h?\0rɝE?', 't?B\0{!eWhٲv', '', 0, '?'),
 ('Fnʹ=8_?F', 'wp-content/plugins/wp-cerber/assets/flags/lt.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z\0Hb', 'lwL+uŢUJ&', '', 0, '?'),
 ('\Z3	bws0{/!Bm', 'wp-content/plugins/wp-cerber/assets/flags/lu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#xI@K', 'f\04;)x6ҽՖx&Xwv', '', 0, '?'),
 ('b9GQEґ', 'wp-content/plugins/wp-cerber/assets/flags/lv.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.JqW6A`>', '\0jn!-xv+ujD<7!5#', '', 0, '?'),
 ('w\ZplUzQ', 'wp-content/plugins/wp-cerber/assets/flags/ly.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r,ʁ]rV', 't\njMl0^f&`ʃ', '', 0, '?'),
 ('+4#EWl3', 'wp-content/plugins/wp-cerber/assets/flags/ma.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E3цҖ`?n~', 'Lx9yՌ6luтlCae@', '', 0, '?'),
 ('\',r\n\n\r\Z3', 'wp-content/plugins/wp-cerber/assets/flags/mc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3\"0\r2O>=D1\0', '00V>K[5_R~dy \nsS', '', 0, '?'),
 ('{]]R\n]', 'wp-content/plugins/wp-cerber/assets/flags/md.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z6>xD\ZL/x\n', '[Ρj*Z\'ӛU!Wa\\', '', 0, '?'),
 (')SlW)lhJ\'.', 'wp-content/plugins/wp-cerber/assets/flags/me.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{H`C~^8X', '&P-urkP\"~aZޢ', '', 0, '?'),
 ('!`Li\0Ըu', 'wp-content/plugins/wp-cerber/assets/flags/mf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('Y&6ڳ6', 'wp-content/plugins/wp-cerber/assets/flags/mg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_;PIH\\', 'd|-ucPVOh`_', '', 0, '?'),
 ('LyRB9k', 'wp-content/plugins/wp-cerber/assets/flags/mh.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l\0oէ3ˠ', 'ܰ\n\0\'6GRZH-`Ș	', '', 0, '?'),
 ('\ZŴԭxvwE\nv', 'wp-content/plugins/wp-cerber/assets/flags/mk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xZxe', 'Ŷvews֝wxYԌ[@eQCj', '', 0, '?'),
 ('D?ļ\n', 'wp-content/plugins/wp-cerber/assets/flags/ml.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hϸ-1՞3', 'A\0]ҕ#:\r402WA%)V\n', '', 0, '?'),
 ('~\"3fBcD', 'wp-content/plugins/wp-cerber/assets/flags/mm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CNU2tJ', '$5AK`?w{\'502?II`', '', 0, '?'),
 ('ɔ/	yT5:Dh', 'wp-content/plugins/wp-cerber/assets/flags/mn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!{)YJ', '/ҹ;9\0d֑]>', '', 0, '?'),
 ('65\nNx/\0', 'wp-content/plugins/wp-cerber/assets/flags/mo.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aM7-VD%', 'KvFIۨ0ghHVR', '', 0, '?'),
 ('\ZR虒<Fc֛;', 'wp-content/plugins/wp-cerber/assets/flags/mp.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4^>!i2Dh', 'k\"zƽAis\"Aǽ(\Z9', '', 0, '?'),
 ('vT!)aH', 'wp-content/plugins/wp-cerber/assets/flags/mq.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zs׳Wh', 'JU2V\\hѦZt/Q', '', 0, '?'),
 ('OJ?CzV^21', 'wp-content/plugins/wp-cerber/assets/flags/mr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nYkF@', 'cnfoaYdM@0ODI\nx', '', 0, '?'),
 ('Ҡ5i*Ǡ', 'wp-content/plugins/wp-cerber/assets/flags/ms.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '֠G/Ҳ', 'cZ/n[`=\Z4~+)%k', '', 0, '?'),
 (' Łq\Z{>d-', 'wp-content/plugins/wp-cerber/assets/flags/mt.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z\nrCZ2Y', 'Xga-\0s!\nZF>X\Z', '', 0, '?'),
 ('\"Z_Z\0\0y', 'wp-content/plugins/wp-cerber/assets/flags/mu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i1($+a', 'm )5pPP:|Xu\0j', '', 0, '?'),
 ('o*nFߘ7', 'wp-content/plugins/wp-cerber/assets/flags/mv.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'FꠈT[~', 'dE4{P-B:Þ${FF', '', 0, '?'),
 ('\0skkTu3So\\', 'wp-content/plugins/wp-cerber/assets/flags/mw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/aDo=hs', '4[Պ\'6NRP15}\Zs', '', 0, '?'),
 ('\ZYÅjxU#6k', 'wp-content/plugins/wp-cerber/assets/flags/mx.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rW6;%', 'E&80`\ZQ3`w]#ע', '', 0, '?'),
 ('$&AÆJ_!6', 'wp-content/plugins/wp-cerber/assets/flags/my.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QGM ;k=', '_PL0\0:sP㱤bG6Ia', '', 0, '?'),
 (':x3L&3ſhD', 'wp-content/plugins/wp-cerber/assets/flags/mz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kv)QHvz', 'Aq#7FtˎY\\jňV:ܯ', '', 0, '?'),
 ('B$[\nfIZ&[', 'wp-content/plugins/wp-cerber/assets/flags/na.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' BzzQ\"', '5o]- )Qb~\0', '', 0, '?'),
 ('o4}+8O', 'wp-content/plugins/wp-cerber/assets/flags/nc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!5A/g4SH', '.)Po\\rd	!NZӅ88E', '', 0, '?'),
 ('_r#Eȯ̪%', 'wp-content/plugins/wp-cerber/assets/flags/ne.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H`R$`}L\0\"', 'h~w=+^Q#Wt/	w~j+', '', 0, '?'),
 ('T><_\"g', 'wp-content/plugins/wp-cerber/assets/flags/nf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2rJizڜS', 'Pw.^}\Zފڝ3q{', '', 0, '?'),
 ('@)uXtȤ0', 'wp-content/plugins/wp-cerber/assets/flags/ng.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']mBC@͚', 'H!RɁ=[?aqμYو_hw', '', 0, '?'),
 ('_/dyY\r}$ʓ', 'wp-content/plugins/wp-cerber/assets/flags/ni.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0MZsu/', 'Cd0HF|\neʅp_SӲ@\0@1<ۊ', '', 0, '?'),
 ('r±2\"}	,7', 'wp-content/plugins/wp-cerber/assets/flags/nl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K+Z59)|', '/\ns!-?k>yU ', '', 0, '?'),
 ('DUuZFZ', 'wp-content/plugins/wp-cerber/assets/flags/no.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j.#0P', '2!u6#=%ӹOC4	\ZrM', '', 0, '?'),
 ('l|.2z<x', 'wp-content/plugins/wp-cerber/assets/flags/np.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ǭ|]#(', 'Շ\nD$	\nVFvʸ_K~\\', '', 0, '?'),
 ('5Er', 'wp-content/plugins/wp-cerber/assets/flags/nr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*s|ǮrSt[', 'bp%a,%Mq^4$}J', '', 0, '?'),
 ('1cUd/R	', 'wp-content/plugins/wp-cerber/assets/flags/nu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '׭YC=7Ѝ', 'zf7?vF`)c۱s`$+', '', 0, '?'),
 ('fW4%', 'wp-content/plugins/wp-cerber/assets/flags/nz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X	77c.ujߖl', '4ȯYI4T)H;rdQgӅ', '', 0, '?'),
 ('b.ӛ', 'wp-content/plugins/wp-cerber/assets/flags/om.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r]-KK<ݳ8', ';8KKIkO[\0vU[JR$ ', '', 0, '?'),
 ('Zp_Z	JIqm`', 'wp-content/plugins/wp-cerber/assets/flags/pa.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',Y]v\"', '.oC]1%lЕUl\Z#', '', 0, '?'),
 ('N6?`$QilL', 'wp-content/plugins/wp-cerber/assets/flags/pe.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':ZdD\'y1', '8,0M߀҃WO1q', '', 0, '?'),
 ('wDZ/IE20y	ק', 'wp-content/plugins/wp-cerber/assets/flags/pf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S\'>Gx:', ' 5C}Z;Tq,H-˻', '', 0, '?'),
 ('?qHl(2m', 'wp-content/plugins/wp-cerber/assets/flags/pg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';[*', '9O#x_v	~%W\Z', '', 0, '?'),
 ('.XvQa*CeN', 'wp-content/plugins/wp-cerber/assets/flags/ph.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '06zD\'w ', '?ͺmVyiz2	BC	mjX', '', 0, '?'),
 ('Kbwy.3{¥', 'wp-content/plugins/wp-cerber/assets/flags/pk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '00%[.', 'GjۀH$׃m\'^ On', '', 0, '?'),
 ('iԹ/s(?z', 'wp-content/plugins/wp-cerber/assets/flags/pl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'؍JS$', '-v_ꉱNM+o	cxD]', '', 0, '?'),
 ('9nP,A', 'wp-content/plugins/wp-cerber/assets/flags/pm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J\')v\rC', '`&k$\nuxdshRZ\r (Qf', '', 0, '?'),
 ('!VTg\"O\r.2L', 'wp-content/plugins/wp-cerber/assets/flags/pn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E~&Xlx', 'g\'G5ɒ<tȺyol|Uӫ', '', 0, '?'),
 ('c׭z85Y', 'wp-content/plugins/wp-cerber/assets/flags/pr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M_6ptz', 'nSX\Zhm29q\ZZ', '', 0, '?'),
 ('2Eγŷ', 'wp-content/plugins/wp-cerber/assets/flags/ps.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IP-6@%', '%ADEPǕ|uĆC!', '', 0, '?'),
 ('<bXUM@\\!', 'wp-content/plugins/wp-cerber/assets/flags/pt.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8,t7s\'=K^', 'qd<Q\Zfe-	%75[1+iuG', '', 0, '?'),
 ('<y\"v0p+\'', 'wp-content/plugins/wp-cerber/assets/flags/pw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Tk	e', '.ڜ/VeRxPi_', '', 0, '?'),
 ('W5Ν>_`|', 'wp-content/plugins/wp-cerber/assets/flags/py.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UƸ_`U', 'sd-ǁ&ǂv	&l:V', '', 0, '?'),
 ('\0+A.\\', 'wp-content/plugins/wp-cerber/assets/flags/qa.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z%4om)|$I', 'F{tT$(lVq5O*g', '', 0, '?'),
 ('k\0`}4v', 'wp-content/plugins/wp-cerber/assets/flags/re.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nFs{7}X#@Vؐ', 'KCZpYJ\01 7aƎF', '', 0, '?'),
 ('ՙ5qV#Y', 'wp-content/plugins/wp-cerber/assets/flags/ro.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iNCEѩ-', 'J7d[^k`\0v?ł;%`a[)', '', 0, '?'),
 ('wR1[PBz', 'wp-content/plugins/wp-cerber/assets/flags/rs.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H]el_LS', '9qpp~##7bo/j|bLl', '', 0, '?'),
 ('_f>*_\n', 'wp-content/plugins/wp-cerber/assets/flags/ru.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qj/53\r', 'z\rf/x.5Q&iHCn0', '', 0, '?'),
 ('z@z[Pѐ', 'wp-content/plugins/wp-cerber/assets/flags/rw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&ĽC6ޯL', 'y\n<P^5zg\\\"f\\Sp81s', '', 0, '?'),
 ('{=ا{\no}]v', 'wp-content/plugins/wp-cerber/assets/flags/sa.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']pڌEYYzٶ', '0{A3HX~z\nT', '', 0, '?'),
 ('*r%Y3/hNp', 'wp-content/plugins/wp-cerber/assets/flags/sb.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v5J䈒?Qo<', 'T	kw#Af3A2͂M', '', 0, '?'),
 ('φ{)e]ŝ4ܴ', 'wp-content/plugins/wp-cerber/assets/flags/sc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e\'hz\ZuRm', '1Wb[^\'JZO\0.\n )', '', 0, '?'),
 ('Ĉψx>H', 'wp-content/plugins/wp-cerber/assets/flags/sd.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ys)x', '	ZL2Hjoi', '', 0, '?'),
 ('\'t\\JZAh', 'wp-content/plugins/wp-cerber/assets/flags/se.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5r5E&a_&	', 'WhLP!#OQkJNj9u`$c', '', 0, '?'),
 ('`gfW\n&OPw', 'wp-content/plugins/wp-cerber/assets/flags/sg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*FYK	a', 'ԨVmfEk$;]N_q^4(', '', 0, '?'),
 ('a-b$GΙ', 'wp-content/plugins/wp-cerber/assets/flags/sh.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U{ͤ:ud', 'R<,lI@Xߠ.#pFg%1O6', '', 0, '?'),
 ('}=\"$x', 'wp-content/plugins/wp-cerber/assets/flags/si.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ez|9', 'ո	+}x͐侟?#', '', 0, '?'),
 ('L7HnWEDM', 'wp-content/plugins/wp-cerber/assets/flags/sj.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j.#0P', '2!u6#=%ӹOC4	\ZrM', '', 0, '?'),
 ('A#UuO', 'wp-content/plugins/wp-cerber/assets/flags/sk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Iq!-\"jU]P', '!$2E@eKz\\x<GF	', '', 0, '?'),
 (']x6a[|', 'wp-content/plugins/wp-cerber/assets/flags/sl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nUr̨^̧\0', 'h+ѩEfp\Ztт5XT:K6', '', 0, '?'),
 ('	)axu', 'wp-content/plugins/wp-cerber/assets/flags/sm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y4fun', 'v-d1Y20-*', '', 0, '?'),
 ('#W\nY,!Z*', 'wp-content/plugins/wp-cerber/assets/flags/sn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7-#9uQ', 'i}23&ܓw0rwJ,', '', 0, '?'),
 (']:]6Q(s-B', 'wp-content/plugins/wp-cerber/assets/flags/so.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9:vU:{', 'I˱	-frǏck@3`	=', '', 0, '?'),
 ('3=^7PRA', 'wp-content/plugins/wp-cerber/assets/flags/sr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NTI`$x\"v', 'J!^α}ݓ$RM~icP', '', 0, '?'),
 ('żeE@}-', 'wp-content/plugins/wp-cerber/assets/flags/ss.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('N<w()/E.bI', 'wp-content/plugins/wp-cerber/assets/flags/st.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'elIy`f', 'x˹50s	.:l', '', 0, '?'),
 (',Je;', 'wp-content/plugins/wp-cerber/assets/flags/sv.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GZk}Ϸ	>', '?Ύ~-yPh#sbP\Z=1tՈY', '', 0, '?'),
 ('nUNQ6Hk', 'wp-content/plugins/wp-cerber/assets/flags/sx.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L,Ֆ4', '=DwN+UaF0^.sG?', '', 0, '?'),
 ('Qt$oGoE$:', 'wp-content/plugins/wp-cerber/assets/flags/sy.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oi&\00$l6', '/<7\nW6H~GK \"L', '', 0, '?'),
 ('\r[8)r}8e', 'wp-content/plugins/wp-cerber/assets/flags/sz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']{W:(Բ', 'PJUI\",uVoƞdQ*z', '', 0, '?'),
 ('*_\"', 'wp-content/plugins/wp-cerber/assets/flags/tc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SpI703CP', '[Vc\"Z}tan%PB\ZgFYw', '', 0, '?'),
 ('\'Y֖>vǡ', 'wp-content/plugins/wp-cerber/assets/flags/td.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'бnHБ', 'rJVO>\Z~dƨn`ik\Z\\', '', 0, '?'),
 ('42i[O', 'wp-content/plugins/wp-cerber/assets/flags/tf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z``O.˛', 'r4&,lbFr~T<阈', '', 0, '?'),
 ('ϘFvD̫H', 'wp-content/plugins/wp-cerber/assets/flags/tg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f/f|f~8', '=JUV1HkEOZoD\\׭', '', 0, '?'),
 ('kVGd/', 'wp-content/plugins/wp-cerber/assets/flags/th.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wVtc3GG', 'o#ߗ|!\\AL=UހLqYp', '', 0, '?'),
 ('p4{', 'wp-content/plugins/wp-cerber/assets/flags/tj.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EK|$1(', '5J	Aa\\Ldz4~U', '', 0, '?'),
 ('0I\Z8\'x', 'wp-content/plugins/wp-cerber/assets/flags/tk.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȕneYT', 'I/:5s ;#bi)4k ', '', 0, '?'),
 ('yHz\"\\', 'wp-content/plugins/wp-cerber/assets/flags/tl.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y/`3˸:Ldǉ', 'q\0HP+m lK(H', '', 0, '?'),
 ('\Zv\0̀Fn8', 'wp-content/plugins/wp-cerber/assets/flags/tm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sd&&/', 'pDƱqߙccDJcT5@Uv\n', '', 0, '?'),
 ('$NP9', 'wp-content/plugins/wp-cerber/assets/flags/tn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0$Z,a8&1', 'E[\"-+Npmfp+W', '', 0, '?'),
 ('\'ѯHo3kVX', 'wp-content/plugins/wp-cerber/assets/flags/to.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9Unze', '^7\r)KFdFG6B(\0_*', '', 0, '?'),
 ('M[\Z2hT	K', 'wp-content/plugins/wp-cerber/assets/flags/tr.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<~QkdIr&-!', '\"i0M˩VJc]3\n[', '', 0, '?'),
 ('t{*aMr̎', 'wp-content/plugins/wp-cerber/assets/flags/tt.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Wp}yœ_.', 'DqY\'?t}ut!_r^', '', 0, '?'),
 ('td!b΢ɪ', 'wp-content/plugins/wp-cerber/assets/flags/tv.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JPށ߼J', '۽ɇRZNPbXc9h;', '', 0, '?'),
 ('q0\\y*3Q>vJ', 'wp-content/plugins/wp-cerber/assets/flags/tw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ښ .;X', 'UӤSQ׈{5𐮆c-y', '', 0, '?'),
 ('jo8Dk', 'wp-content/plugins/wp-cerber/assets/flags/tz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j01_NM', '_i`K@D4=Z2QcuY!z=', '', 0, '?'),
 ('r_YrL8;8E', 'wp-content/plugins/wp-cerber/assets/flags/ua.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V	i#Ʉ\r', '۽,jI7=3I\0\"M7H', '', 0, '?'),
 ('AVf', 'wp-content/plugins/wp-cerber/assets/flags/ug.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hUǊ}', ';TWm	(Izҁh2', '', 0, '?'),
 ('C)VxzϞΩtP', 'wp-content/plugins/wp-cerber/assets/flags/um.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FxQos:h\0AqY', '?85ϝroe[UԦM\\', '', 0, '?'),
 ('KɹjwDx', 'wp-content/plugins/wp-cerber/assets/flags/us.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JVw\Z]Ay', 'LCI`^J4=0CC}', '', 0, '?'),
 ('Y>17{6\">2f*:', 'wp-content/plugins/wp-cerber/assets/flags/uy.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'txd)b}PJkJ@8', '	ꬬ0b\0JdczE!(CP', '', 0, '?'),
 ('	e1n2cΧ', 'wp-content/plugins/wp-cerber/assets/flags/uz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.SUAR-Ƌ', 'Ț1}\n{%`Tbh3ٷ.D', '', 0, '?'),
 ('mx&LKQM', 'wp-content/plugins/wp-cerber/assets/flags/va.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'odل0Bߵ߽s', '[=px	LE^4|~30yx\Z&', '', 0, '?'),
 ('k[҄.? FRp@', 'wp-content/plugins/wp-cerber/assets/flags/vc.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C)y$%E', 'NhА!o:s1o~%`', '', 0, '?'),
 ('{o/oh9a', 'wp-content/plugins/wp-cerber/assets/flags/ve.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g^ٔwXc', 'Z\\[.Mq2]lALJfC', '', 0, '?'),
 ('^ lkBK', 'wp-content/plugins/wp-cerber/assets/flags/vg.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CXBJ\'2', '`Ga\02%̛7\\H=gs%', '', 0, '?'),
 ('\'}j=A>\r9', 'wp-content/plugins/wp-cerber/assets/flags/vi.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j.f& Sj', ')Am{MD&ʑaG\rmMf', '', 0, '?'),
 ('Z~Y/l*&', 'wp-content/plugins/wp-cerber/assets/flags/vn.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f6J%Cv,\nc', '_1:LvQܺ.|', '', 0, '?'),
 ('+&|1 w6b*', 'wp-content/plugins/wp-cerber/assets/flags/vu.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&@C.J#', ';\0ěk=GW$۳', '', 0, '?'),
 ('֏+=#Jn', 'wp-content/plugins/wp-cerber/assets/flags/wf.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2iq*@Rr\n', '}AxhIzT]As0;yE', '', 0, '?'),
 ('r~\Z', 'wp-content/plugins/wp-cerber/assets/flags/ws.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2MrZYܑzr', '$!9d98E\".0JK`', '', 0, '?'),
 ('-4u\Zo', 'wp-content/plugins/wp-cerber/assets/flags/ye.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't?H&@\r\rJ', '~p\"&qƝq*۔QVY\\F', '', 0, '?'),
 ('ePfo!J%', 'wp-content/plugins/wp-cerber/assets/flags/yt.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FE=W=\'', '-*U	K-:햴Oա3', '', 0, '?'),
 ('\ZKa2SckI', 'wp-content/plugins/wp-cerber/assets/flags/za.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	֨˅hqd', 'sΔ֫V``R	;cϯ', '', 0, '?'),
 ('0ň}mX9q', 'wp-content/plugins/wp-cerber/assets/flags/zm.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\|eDgk^', 'yЩ&VUą;}D4E3)\\', '', 0, '?'),
 ('](7^U', 'wp-content/plugins/wp-cerber/assets/flags/zw.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\^~E,Tl', 'SY2r5SaJ\"tJ@ArC', '', 0, '?'),
 ('iX~Ҟl )', 'wp-content/plugins/wp-cerber/assets/fonts/cerber.eot', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IW\na1m-6>', 'a{RԈrɿ=n5[:bc', '', 0, '?'),
 ('dg!čF\\mB', 'wp-content/plugins/wp-cerber/assets/fonts/cerber.ttf', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TTϦ)fH@^', 'Vr:z/*IvGgX', '', 0, '?'),
 ('uqmƇ', 'wp-content/plugins/wp-cerber/assets/fonts/cerber.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@.XG', 'Vn;DvFz,TkU.,ub\Z', '', 0, '?'),
 (',F1,iIs', 'wp-content/plugins/wp-cerber/assets/fonts/roboto/LICENSE.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's6ɮͯvB,O', 'ݬISP\"a 7J6QSv_y', '', 0, '?'),
 (')+]gg', 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Bold.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fѭ,Uz1h', '\ZûFn\ZJOpmOnDJ+', '', 0, '?'),
 ('N*yVyQQj§,C', 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Light.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Gd1ȓX*_j%\r', 'IXS>;]^q3\"`d59', '', 0, '?'),
 ('fzl Hexr', 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Medium.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ދt1FB0MOKQ>', '\\^/d``_kfӑހV+YD', '', 0, '?'),
 ('\nD%a-Iq', 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Regular.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[-\\pRkI', 'hXʀF^1it8OqS).', '', 0, '?'),
 ('ƚŏHWn\'i', 'wp-content/plugins/wp-cerber/assets/goo-translate.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#c\"C!㋫xo', '>Cv^/VrcCƨK(P', '', 0, '?'),
 (']xH	ylF', 'wp-content/plugins/wp-cerber/assets/icon-128x128.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' ^\nxm2!Ѹ', '׋qO<~vM~Oc^6\'\"?', '', 0, '?'),
 ('6Iӌ2@fqa', 'wp-content/plugins/wp-cerber/assets/icon-256x256.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WZgTBeGb', '\ZD/jgJ\0lAt$~', '', 0, '?'),
 ('ۖL.b', 'wp-content/plugins/wp-cerber/assets/icons/fonts/crb.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(bE?\"MqH\Z', '\\;߇Md^njףI`\\Ux\"d', '', 0, '?'),
 ('#CvnОKvz', 'wp-content/plugins/wp-cerber/assets/icons/fonts/crb.ttf', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~s3xO}', 'gʪw[Ag\rf-&Yq`7MbOI', '', 0, '?'),
 ('o?ݬ', 'wp-content/plugins/wp-cerber/assets/icons/fonts/crb.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uMGb!ߤ', ' !Ós*n@NAz|os}', '', 0, '?'),
 ('\nL0Qod`\\;', 'wp-content/plugins/wp-cerber/assets/icons/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/J,', 'ĺ=8_\0|+0Xj&^\0=5', '', 0, '?'),
 ('a&ST\"l9', 'wp-content/plugins/wp-cerber/assets/inspector.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'znd*kPj', '	o7Xvo\ZCDjp', '', 0, '?'),
 ('+SS=o)I', 'wp-content/plugins/wp-cerber/assets/magnific/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a3HWX\0\'Al&', 'DQZ7ӳ\r[G#q#W14Wf', '', 0, '?'),
 ('nIoc!', 'wp-content/plugins/wp-cerber/assets/magnific/jquery.magnific-popup.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l$Ȼ0bn', 'mS$^|T8đ=ظlF`p', '', 0, '?'),
 ('%~2\" ض=ǿ\Z^', 'wp-content/plugins/wp-cerber/assets/magnific/magnific-popup.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0vre\n`', 'X;Ɛ9@ujm[F\"!', '', 0, '?'),
 ('/iZج [?*', 'wp-content/plugins/wp-cerber/assets/multi/license.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uE.0Ȁb[', ']=2F(Cҷ\Zc93ЄK@', '', 0, '?'),
 ('U7v\n', 'wp-content/plugins/wp-cerber/assets/multi/multi.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\ݕDE', 'W>)pM!=V#qu&,N+', '', 0, '?'),
 (';+&YĐ', 'wp-content/plugins/wp-cerber/assets/multi/multi.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z/WnU#֬VK', '\"%6rHB)xfL]4t', '', 0, '?'),
 ('7OPsΩpW', 'wp-content/plugins/wp-cerber/assets/multi/multi.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P? a80$', '*}AB/*o%;5k;3', '', 0, '?'),
 ('!?M\"Qe>', 'wp-content/plugins/wp-cerber/assets/nexus.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UXsq-*ȳ', '˶o`7 \"/pWAaNo', '', 0, '?'),
 ('4}TkD\'W', 'wp-content/plugins/wp-cerber/assets/rateit.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')3Ud/{\ZK3E', ',-3\"a~Pc8FM', '', 0, '?'),
 ('\rElZ}I8+V', 'wp-content/plugins/wp-cerber/assets/rateit2.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B_[r]sTj', 'Uu8X*O\'bS,+|tV֭( S', '', 0, '?'),
 ('恴Lޠe/u', 'wp-content/plugins/wp-cerber/assets/scanner.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '()f.0?', 'zr@2XY`\' {9c	hԔ7', '', 0, '?'),
 ('T?,%,zG%', 'wp-content/plugins/wp-cerber/assets/select2/LICENSE.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ABQ,:	\rj', 'Z5LѾR9	`C)M', '', 0, '?'),
 ('irHFnA\nAS=', 'wp-content/plugins/wp-cerber/assets/select2/dist/css/select2.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TAOKot', 'lN_-\n|\r蒝vy$k', '', 0, '?'),
 ('tU;56|4Ql', 'wp-content/plugins/wp-cerber/assets/select2/dist/js/select2.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|Ԋ23\\:=', '	<(*WvЋtwr_ti	', '', 0, '?'),
 ('@j=', 'wp-content/plugins/wp-cerber/assets/sh/scripts/shBrushPhp.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nR1G˕\nhc', ' ^bVl!,G3/', '', 0, '?'),
 ('(C\n֊bAk6FS', 'wp-content/plugins/wp-cerber/assets/sh/scripts/shCore.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Hl7B20O', '%{*ZO5D\n¦+1Tc#`', '', 0, '?'),
 ('8םG2*Ğ', 'wp-content/plugins/wp-cerber/assets/sh/styles/shCore.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`L1Rg<1&', 'g΀0!r()uTT^۽SVv', '', 0, '?'),
 ('xm5o-]Ž', 'wp-content/plugins/wp-cerber/assets/sh/styles/shThemeDefault.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Jx_rZ', '6 Քۻ!|dp', '', 0, '?'),
 ('\'q ec', 'wp-content/plugins/wp-cerber/assets/tpicker/jquery.timepicker.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oDZ3nRw', 'c4r)|V_kZn:\"Q%', '', 0, '?'),
 ('^\r6&ҖF;oB', 'wp-content/plugins/wp-cerber/assets/tpicker/jquery.timepicker.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P%S%<?\Z\\', 'gO:!rhʀ6\'wfDz', '', 0, '?'),
 ('9)&{SdG', 'wp-content/plugins/wp-cerber/assets/wp-admin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '׮^Qq0', 'Ō$)e/߬Nn$|a[#', '', 0, '?'),
 ('V1)~O', 'wp-content/plugins/wp-cerber/assets/wrench.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D3CbC-2!Q', ';մxjE%ZPc', '', 0, '?'),
 ('&PVwSs', 'wp-content/plugins/wp-cerber/cerber-2fa.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZrGR2 \0q', '\rKt\raP޹!c^m$98', '', 0, '?'),
 ('(]dJ\rl', 'wp-content/plugins/wp-cerber/cerber-addons.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '],\\J=:W[', 'yyA\0f7#zT@(', '', 0, '?'),
 ('Fg5F\n+93', 'wp-content/plugins/wp-cerber/cerber-ds.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B\"+\n.\0}', 'mt\'TUFZȓP\'gO3DWt_', '', 0, '?'),
 (';4[`̃', 'wp-content/plugins/wp-cerber/cerber-lab.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>wH5\n!', 'JS!QM!\rY!*k|fE&A', '', 0, '?'),
 ('*3Gү$I', 'wp-content/plugins/wp-cerber/cerber-load.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6c)ĈbD3R', 's+?،^2ڸd	#1}o ', '', 0, '?'),
 ('\ZVտ', 'wp-content/plugins/wp-cerber/cerber-maintenance.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd}<|\rt', ')ivNA[#6d>o׫', '', 0, '?'),
 ('9%y$\"o.1', 'wp-content/plugins/wp-cerber/cerber-news.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' W-IlMg', 'Y&Q\"wT8]ǥV0#2x8', '', 0, '?'),
 ('ĆcĳB;', 'wp-content/plugins/wp-cerber/cerber-pluggable.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nڰ\Zq|1', 'Ԛg!E#Pk̰ޛ\0XwXW', '', 0, '?'),
 ('-wTrY90y`', 'wp-content/plugins/wp-cerber/cerber-request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C8&\Z', 'U\r~Q-F,ڸnY|ۿ0', '', 0, '?'),
 ('k2n', 'wp-content/plugins/wp-cerber/cerber-scanner.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@0qB8 ', '3Adu3n;UgVn!o%i', '', 0, '?'),
 ('PY$Bz4z', 'wp-content/plugins/wp-cerber/cerber-tools.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RScq\"mM', 's߼M2{ɯfѦ4T;', '', 0, '?'),
 ('*C<q̐@!', 'wp-content/plugins/wp-cerber/cerber-users.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3)pf:?c9', 'oۀnJˊT\n%Z(', '', 0, '?'),
 ('y\"jY\0u<c', 'wp-content/plugins/wp-cerber/changelog.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I,\r}5o', 'lNAߠ\Z:z2g0ý՚0', '', 0, '?'),
 (';p+|', 'wp-content/plugins/wp-cerber/common.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\U,p/', ',|;@vYBֻx}%#U', '', 0, '?'),
 ('EuukMOuX', 'wp-content/plugins/wp-cerber/dashboard.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zGT:Ytr', '<ot>C{*\Z3XX', '', 0, '?'),
 ('ͤ T-', 'wp-content/plugins/wp-cerber/index.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z=v]V', 'k~	UH\ZxPĀ<;X', '', 0, '?'),
 ('┬E+,', 'wp-content/plugins/wp-cerber/jetflow.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y{\\O1\"', 'BRGʯ`cRo]ٔԭ]ROY', '', 0, '?'),
 ('uz,(u0', 'wp-content/plugins/wp-cerber/languages/wp-cerber-bs_BA.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}h\r\"^i]9)q', 'E[ٔo9.QL\"3', '', 0, '?'),
 ('Vr2Fk\0<h', 'wp-content/plugins/wp-cerber/languages/wp-cerber-bs_BA.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rD.֡h-', '`A\"f*B2$e Vr̜3', '', 0, '?'),
 ('ZYS,w]½-f{', 'wp-content/plugins/wp-cerber/languages/wp-cerber-cs_CZ.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qnr)^ٔmO', '?	6.C9Vo85//?x', '', 0, '?'),
 ('56AAѹA\r	', 'wp-content/plugins/wp-cerber/languages/wp-cerber-cs_CZ.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C[w׺]QJ', 'U7e:%\Zp^\r=Bdc}\n', '', 0, '?'),
 ('\'^	} -RȖ4', 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_CH.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qkmf--=?	ox', 'vĬኾ+]^CR.ؠ$bCf', '', 0, '?'),
 ('n1u`z@ң', 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_CH.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WSۨ', 'M4#\\gZK2=Yh\'\\', '', 0, '?'),
 ('ouU-g(<Ol', 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_DE.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X5~Łч', 'Vļ3£ZSTdPNrt=S]J', '', 0, '?'),
 ('ITݩ~7', 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_DE.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F		z7[j', '> дk-8$ku\r4Ԭ', '', 0, '?'),
 ('*х1-k0', 'wp-content/plugins/wp-cerber/languages/wp-cerber-es_ES.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!u/=', 'TB>[Yu\"O,[as\r', '', 0, '?'),
 (')KK;t~', 'wp-content/plugins/wp-cerber/languages/wp-cerber-es_ES.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bwn߃|7w', 'jwhGvMxT~Vew<\"`J<', '', 0, '?'),
 ('$t\\p=-a', 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_CA.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ԇ@k$', '|Q/8o@zn XOFUJ)Jѯ', '', 0, '?'),
 ('u)!̧X', 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_CA.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3(;	5t/', '66s#Sx_	frC6w9', '', 0, '?'),
 ('S!)qO', 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_FR.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5qgN^hF.x', '(k.E&-}?X9l`\'hu-', '', 0, '?'),
 ('$R\\r-y', 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_FR.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rpyq@y`9', 'lp²cSFKك!摾\Zkuu]b', '', 0, '?'),
 ('nE%̶uPYX', 'wp-content/plugins/wp-cerber/languages/wp-cerber-it_IT.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '㺗n~\\`', '8\Z55PlaV|Woz', '', 0, '?'),
 ('Q\\>:37', 'wp-content/plugins/wp-cerber/languages/wp-cerber-it_IT.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|( ~9l\Z`_', '^_@*%F^DF*;|pv', '', 0, '?'),
 ('Ć~7cƱۃG', 'wp-content/plugins/wp-cerber/languages/wp-cerber-lt_LT.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%:rלZL]', 'qA$%Re$e`!e:|PB;', '', 0, '?'),
 ('wL<qoj|', 'wp-content/plugins/wp-cerber/languages/wp-cerber-lt_LT.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tb1MwW4[?', 'I\n4sD|xypeM̀M', '', 0, '?'),
 ('[U)$(\r', 'wp-content/plugins/wp-cerber/languages/wp-cerber-nb_NO.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|=K\"Z0=o', 'a0{5<p\"s', '', 0, '?'),
 ('zn^\0kܦ{&', 'wp-content/plugins/wp-cerber/languages/wp-cerber-nb_NO.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P\"c\\', 'v+>v!ɐOpmi', '', 0, '?'),
 ('7.8T)w^', 'wp-content/plugins/wp-cerber/languages/wp-cerber-nl_NL.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ū\nq:YHs', 'RU58uLIQPQm;\rxNB3', '', 0, '?'),
 ('P?~&\n0]', 'wp-content/plugins/wp-cerber/languages/wp-cerber-nl_NL.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sahU΄:d#', 'Ka(s!gw\\TV oey\Z3l\"', '', 0, '?'),
 ('1jSJmQs7', 'wp-content/plugins/wp-cerber/languages/wp-cerber-pl_PL.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\\nҟR~', 'IU(FXKgoew{^', '', 0, '?'),
 ('\\ڋpIT6', 'wp-content/plugins/wp-cerber/languages/wp-cerber-pl_PL.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$W`jLB3@', 'kڎ_\"Xь,AcLMĻrNB', '', 0, '?'),
 ('k{m% D', 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_BR.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4|S5w76ae.', '!@08:?\'d>\r	Bn', '', 0, '?'),
 ('21)nZ', 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_BR.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5N', '^?t}?CeApr3C<m', '', 0, '?'),
 ('p8UY?(?9ـB', 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_PT.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ٌM!\Z', 'N=xp9ԦpHсbᚕUS1\n[', '', 0, '?'),
 ('\nB/ޕ6h9g', 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_PT.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iՍflFb\Z', 'CS3nw_#m٠!!R_2', '', 0, '?'),
 ('oO~3{K', 'wp-content/plugins/wp-cerber/languages/wp-cerber-ru_RU.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H<Nrt', '*~Ά~X5y~OS', '', 0, '?'),
 ('zWz', 'wp-content/plugins/wp-cerber/languages/wp-cerber-ru_RU.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?q\ZI`', 'ok\'axu[Dn~q_', '', 0, '?'),
 ('l2SM/A', 'wp-content/plugins/wp-cerber/languages/wp-cerber-sr_RS.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}h\r\"^i]9)q', 'E[ٔo9.QL\"3', '', 0, '?'),
 ('C݆w\rf \\', 'wp-content/plugins/wp-cerber/languages/wp-cerber-sr_RS.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rD.֡h-', '`A\"f*B2$e Vr̜3', '', 0, '?'),
 ('):F:!', 'wp-content/plugins/wp-cerber/languages/wp-cerber-sv_SE.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D kqJb', 'd\'$+m*LRBۮH', '', 0, '?'),
 ('#49%8n{Ӂt', 'wp-content/plugins/wp-cerber/languages/wp-cerber-sv_SE.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4[怜', 'S甝[$t6٩T\'9uiC', '', 0, '?'),
 ('ӟj/pO\\)?H', 'wp-content/plugins/wp-cerber/languages/wp-cerber-uk.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bs.Ju37#g}', ' l_7DLpbUy=59/', '', 0, '?'),
 ('K9\ZFQȸ\r$^&p', 'wp-content/plugins/wp-cerber/languages/wp-cerber-uk.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oqA~P	', '*qn>4&ogeeʓ˹^5', '', 0, '?'),
 ('LΊ67m', 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_CN.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.1۠Rg{tJ', '*^BiΔ>CF]3', '', 0, '?'),
 ('jX&=', 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_CN.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N=a\0Hk', 'z\nKI!W?ߤlUz$', '', 0, '?'),
 ('2?k>\"J]Sa!', 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_TW.mo', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#*Qb', '7:\'UR7r,cRF$%/#{mIc', '', 0, '?'),
 ('^VRD<; 3T', 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_TW.po', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x׹nVh', 'e(}4bm;R6/Y%oY', '', 0, '?'),
 ('E$Kcm', 'wp-content/plugins/wp-cerber/languages/wp-cerber.pot', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q0|4:d9', 'UbJVW&>)*읖CZߑ', '', 0, '?'),
 ('2lƳ;-6', 'wp-content/plugins/wp-cerber/modules/aaa-wp-cerber.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	~K|)9', 'fǵ!Ҳ\'Tc|bz7<', '', 0, '?'),
 ('#煽$8f5mv5', 'wp-content/plugins/wp-cerber/nexus/cerber-nexus-master.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h_2>,[%', '<\0B5TY.4WtV', '', 0, '?'),
 ('EDc9>	v', 'wp-content/plugins/wp-cerber/nexus/cerber-nexus-slave.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's-#42_3J', '&,8%B#3\"d9 `', '', 0, '?'),
 ('^cm]s~', 'wp-content/plugins/wp-cerber/nexus/cerber-nexus.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b.@s{Yߛg', 'r\\(0\nB%hOW', '', 0, '?'),
 ('SA@=Yv', 'wp-content/plugins/wp-cerber/nexus/cerber-slave-list.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}MZg9eq\Z\\', '(\'Lzv,yn[\\', '', 0, '?'),
 (':u?͜PF{SM', 'wp-content/plugins/wp-cerber/readme.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ce<},?', '56n=I%Ad\0Ӥ&b!sXz*', '', 0, '?'),
 ('NH;勁\Zl ', 'wp-content/plugins/wp-cerber/ripe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<RJ(b', 'sygi\"Ӧn%/qɕM', '', 0, '?'),
 ('k:Qq\\e@{H', 'wp-content/plugins/wp-cerber/settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|bP\nX', '@X97>4v́:rz', '', 0, '?'),
 ('<̅tP^h', 'wp-content/plugins/wp-cerber/whois.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C8{[67d', 'Er\n	1&t[c.F3DYq\Z', '', 0, '?'),
 ('}(^8,~hyg', 'wp-content/plugins/wp-cerber/wp-cerber.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Wq/\rъV', 'TصJDD8AY&<n?MMRu', '', 0, '?'),
 ('J}FE\09', 'wp-content/themes/index.php', 0, 'gD,V=\\bP', 'gD,V=\\bP', 'k~	UH\ZxPĀ<;X', '', 0, '?'),
 ('p؟.\'J\n`', 'wp-content/themes/kallyas/404-smart-area.php', 0, ',\"ǊF1y+', ',\"ǊF1y+', 'ע&g}%LXo', '', 0, '?'),
 ('Ô)\'/+O', 'wp-content/themes/kallyas/404-standard.php', 0, 'z۞\ZlT\nb_uCQ', 'z۞\ZlT\nb_uCQ', '\r\0k:duX7Fh#!>', '', 0, '?'),
 ('+\\XMBנ	]b4', 'wp-content/themes/kallyas/404.php', 0, 'מNjs5\'', 'מNjs5\'', ';NUev(b[rʜ!JB', '', 0, '?'),
 ('$Sn^H6f[', 'wp-content/themes/kallyas/addons/countdown/jquery.countdown.min.js', 0, 'y坣)SY', 'y坣)SY', 'Vg1KǏYۣ@l	3', '', 0, '?'),
 ('g6</\ZRP', 'wp-content/themes/kallyas/addons/flickrfeed/jquery.jflickrfeed.min.js', 0, '\n-yR', '\n-yR', 'ehk03&P\nn^͑8 &sr', '', 0, '?'),
 ('uXl^DX', 'wp-content/themes/kallyas/addons/isotope-addons/packery-mode.pkgd.min.js', 0, '?,lSa', '?,lSa', 'o! in\"1!FD9\0ޮ', '', 0, '?'),
 ('m	Zmq5CjhBD8', 'wp-content/themes/kallyas/addons/jquery_loupe/jquery.loupe.js', 0, 'cV[%U|μ2', 'cV[%U|μ2', '^`A\'[Mׯ+7`+w\0\"gl<', '', 0, '?'),
 ('bˢ\nlEY6+ ', 'wp-content/themes/kallyas/addons/kl_socialicons_font/kl-social-icons.svg', 0, 'M@/', 'M@/', 'iƒ0В,	OL`WR\ZV@', '', 0, '?'),
 ('ȬɇMA', 'wp-content/themes/kallyas/addons/raphael_diagram/init.js', 0, '[45×<k{2', '[45×<k{2', '8-9[OđDh]~\np<', '', 0, '?'),
 ('u@0ʅP', 'wp-content/themes/kallyas/addons/raphael_diagram/raphael.js', 0, '=Pds^=.Kԃ', '=Pds^=.Kԃ', ';KI6geg!)|>Bi+', '', 0, '?'),
 ('ց9Y&<m', 'wp-content/themes/kallyas/addons/sc_weather/fonts/icomoon.svg', 0, 'G^*', 'G^*', '224(JFrEs(ﾁx^', '', 0, '?'),
 ('x	/]L÷P', 'wp-content/themes/kallyas/addons/scrollmagic/debug.addIndicators.min.js', 0, 'd>R1[<', 'd>R1[<', 'wG>Gq0YQwD(}\0d(', '', 0, '?'),
 ('̏>\01TDE', 'wp-content/themes/kallyas/addons/scrollmagic/scrollMagic-fullPacked.js', 0, 't\\wR+ʦ', 't\\wR+ʦ', 'b,0u#c8ka2\'/e1aē,Yw', '', 0, '?'),
 ('f-铗?Nq', 'wp-content/themes/kallyas/addons/scrollmagic/scrollmagic-tweenlite.js', 0, 'Cx=ϘX-', 'Cx=ϘX-', '=Ic۸ndbLi\0n~Lu', '', 0, '?'),
 ('#;	ǲMcM', 'wp-content/themes/kallyas/addons/scrollmagic/scrollmagic.js', 0, 'h0b}', 'h0b}', 'G&:hM63\0ip l', '', 0, '?'),
 ('pftW1lm', 'wp-content/themes/kallyas/addons/slick/slick.js', 0, 'wevBd', 'wevBd', 'ePt7\nGGC_`ʄs=ϾS Vu*3\Z', '', 0, '?'),
 ('7H՞\r8\0~', 'wp-content/themes/kallyas/addons/slick/slick.min.js', 0, 'w}`cm', 'w}`cm', '#@ᣧ3VS,[vBԃƵ', '', 0, '?'),
 (';7Jsh[D:', 'wp-content/themes/kallyas/addons/smooth_scroll/SmoothScroll.js', 0, 'Q*nt\Zˏ', 'Q*nt\Zˏ', 'g$J%1IUƸeU', '', 0, '?'),
 ('\rϒ{', 'wp-content/themes/kallyas/addons/smooth_scroll/SmoothScroll.min.js', 0, '{uUnx4|Ȣ', '{uUnx4|Ȣ', 'pwet9ŹYX#', '', 0, '?'),
 ('hJfܮ(Lj#', 'wp-content/themes/kallyas/addons/wowjs/wow.js', 0, 'U3S\\:?', 'U3S\\:?', 'Pl|X	oaI9(Ӣ4CI336B', '', 0, '?'),
 ('U))%q6S_', 'wp-content/themes/kallyas/archive-documentation.php', 0, '¾Tjq[', '¾Tjq[', 'y쟳	OđG1JBf48f\"q', '', 0, '?'),
 ('$9C	S}R', 'wp-content/themes/kallyas/archive-portfolio.php', 0, '5\nvJE`', '5\nvJE`', 'a5^HQ0B*rT/', '', 0, '?'),
 ('i\n\0mqxhdҥU^', 'wp-content/themes/kallyas/archive.php', 0, 'yk`ы0v?', 'yk`ы0v?', 'ͅCX}pN0bcD썅4nc', '', 0, '?'),
 ('YgX^ˏ3', 'wp-content/themes/kallyas/blog-columns.php', 0, 'JqNrb]89', 'JqNrb]89', 'DQFF_K9j^\ZD', '', 0, '?'),
 ('uÍ֨::t', 'wp-content/themes/kallyas/blog-default.php', 0, 'O=\n8s@\'', 'O=\n8s@\'', '2jqIKt^EQ[Fsd', '', 0, '?'),
 ('\"j,Ն}', 'wp-content/themes/kallyas/comments.php', 0, 'b(kn:8', 'b(kn:8', '7M @(g~Zv\\{*;=)', '', 0, '?'),
 ('TlS`\Zg\Zѱ', 'wp-content/themes/kallyas/components/blog/blog-default-def_classic.php', 0, 'E쨐#-f', 'E쨐#-f', 'xA=[hg{ud%d3[', '', 0, '?'),
 ('>Ї@fx', 'wp-content/themes/kallyas/components/blog/blog-default-def_modern.php', 0, 'Fj:ܰiSnTjRs', 'Fj:ܰiSnTjRs', 'nâV>V,_;l j|	x^3;8׵^6', '', 0, '?'),
 ('&£4\Zk\neY|\"', 'wp-content/themes/kallyas/components/blog/blog-item-comments.php', 0, ']&\\ek栘', ']&\\ek栘', 'SmwC_M1c-nen;9V|^c=', '', 0, '?'),
 ('.G(Q]}th5', 'wp-content/themes/kallyas/components/blog/blog-links.php', 0, '۩>lkW3', '۩>lkW3', '	cgIZR.J]-(P.OU6T', '', 0, '?'),
 ('+.:[/', 'wp-content/themes/kallyas/components/blog/blog-meta.php', 0, 'b0Eo. 5', 'b0Eo. 5', 'Ƨ~4!AF/g l5', '', 0, '?'),
 ('}LZIn', 'wp-content/themes/kallyas/components/blog/blog-noposts.php', 0, '+W}$XS', '+W}$XS', '&I8y3/MSzNB', '', 0, '?'),
 ('f=yH', 'wp-content/themes/kallyas/components/blog/blog-pagination.php', 0, 'xneמ~', 'xneמ~', '@\r|jƆDtp2r@', '', 0, '?'),
 ('ʡ\ZKdv.ZY ', 'wp-content/themes/kallyas/components/blog/default-classic/blog-bottom.php', 0, '9	|	ެM', '9	|	ެM', 'ެ%T0m΃Q^TK&\Z', '', 0, '?'),
 ('Tk5Zyʹ\n', 'wp-content/themes/kallyas/components/blog/default-classic/blog-content.php', 0, '\Z.=< ]/p', '\Z.=< ]/p', 'iL>\r#q摮O	^Y۠', '', 0, '?'),
 ('.ǍV/', 'wp-content/themes/kallyas/components/blog/default-modern/blog-footer.php', 0, '%5Ej', '%5Ej', 'r\'Cڣ<Oa\n1HEf', '', 0, '?'),
 ('U`D_>Z#3', 'wp-content/themes/kallyas/components/blog/default-modern/blog-header.php', 0, 'IӦjY\n+dh!u', 'IӦjY\n+dh!u', ';>FޥCK$e=:4&w1', '', 0, '?'),
 ('\"On2SK>', 'wp-content/themes/kallyas/components/blog/default-modern/blog-img.php', 0, '5!.~-', '5!.~-', '4[rޑ˿DZ	gRV', '', 0, '?'),
 ('ʵG%c', 'wp-content/themes/kallyas/components/blog/default-modern/blog-readmore.php', 0, '\0	\n͆([o', '\0	\n͆([o', 'rJȴD &~?]a=1!]rx>', '', 0, '?'),
 ('\0<b\ryݘg', 'wp-content/themes/kallyas/components/blog/default-modern/blog-title.php', 0, '5;V!WN@', '5;V!WN@', 'lӘmq\"J10(|\n=,', '', 0, '?'),
 ('gC[LXũG|', 'wp-content/themes/kallyas/components/blog/default-single-classic/single-author.php', 0, '>hl', '>hl', 'xEQ1\"ZT{\r_FU/', '', 0, '?'),
 ('1zg͉\Z+', 'wp-content/themes/kallyas/components/blog/default-single-classic/single-content.php', 0, ')nًp', ')nًp', 'h	Cc- 3uoٓFB ', '', 0, '?'),
 ('|[|KY', 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details-author.php', 0, '9~IvU', '9~IvU', '~(vATkU˩#j^y\\ri', '', 0, '?'),
 ('&^sJDC', 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details-category.php', 0, '-*z^N/G', '-*z^N/G', 'ED6T|p%2\Z`Ё_Hq}', '', 0, '?'),
 ('Z3|e}s', 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details-date.php', 0, '}Xd%65', '}Xd%65', '4#մ+>ͲJ4wo|Kxi%6$%', '', 0, '?'),
 ('0\0Ǆԧۘ\r\'(', 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details.php', 0, '4ڻ%Vg0', '4ڻ%Vg0', 'NoBJ>Ћ٤nsޱ', '', 0, '?'),
 ('{o{j4[w.I', 'wp-content/themes/kallyas/components/blog/default-single-classic/single-main.php', 0, 'J	|vPLx', 'J	|vPLx', 'K+CNߴv2ZK(', '', 0, '?'),
 ('6R^Rx o\"', 'wp-content/themes/kallyas/components/blog/default-single-common/single-pagelinks.php', 0, '+\nB9$n', '+\nB9$n', '4^adj7Dv#%݈j|-', '', 0, '?'),
 ('zBu}L$QX', 'wp-content/themes/kallyas/components/blog/default-single-common/single-related-item.php', 0, '6kq', '6kq', 'Ǚ,&wPmK;&s/i]', '', 0, '?'),
 ('A\"8**y\nU?S7', 'wp-content/themes/kallyas/components/blog/default-single-common/single-related-title.php', 0, '\nLjBz ǓI', '\nLjBz ǓI', '`Eb%\\ҞSͳax?pKǄ*q%', '', 0, '?'),
 ('GDb>Ж]ľz', 'wp-content/themes/kallyas/components/blog/default-single-common/single-related.php', 0, '(+@q/bn', '(+@q/bn', '[yit&_\0 !EQH1\Z', '', 0, '?'),
 ('\"\n{W\0+$x', 'wp-content/themes/kallyas/components/blog/default-single-common/single-social-custom.php', 0, 'rU7d퐱', 'rU7d퐱', '_IT\0F54Ia	x', '', 0, '?'),
 ('&y7kDc$\rc', 'wp-content/themes/kallyas/components/blog/default-single-common/single-social-generic.php', 0, 'erRT,w', 'erRT,w', 'LaЂq\"*#-pR}=', '', 0, '?'),
 ('Eld\\ ', 'wp-content/themes/kallyas/components/blog/default-single-common/single-social.php', 0, '1}1=0\rM', '1}1=0\rM', '<E\0pr/W[K;*ְ)۟_', '', 0, '?'),
 ('X;l~s`I', 'wp-content/themes/kallyas/components/blog/default-single-common/single-tags.php', 0, '2o|I(', '2o|I(', '6g	?jwd>Sr&Ҫbk΃S', '', 0, '?'),
 ('ȧ3\'{l', 'wp-content/themes/kallyas/components/blog/default-single-modern/single-content.php', 0, ';{o@]', ';{o@]', '<eueI(21usu', '', 0, '?'),
 ('qΏgT)	k', 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details-author.php', 0, 'YxmN\nJA', 'YxmN\nJA', ')ߍ	OEv-:ƤoW7ݥe', '', 0, '?'),
 ('5;\rCi', 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details-category.php', 0, '(]*A	$qZT', '(]*A	$qZT', '2;+K\0\n߅=q61e', '', 0, '?'),
 ('3qi<ځQ', 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details-date.php', 0, 'e<\'˨λ{[B', 'e<\'˨λ{[B', 'ME8>y\nu4`!', '', 0, '?'),
 ('j|L;x	1˦', 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details.php', 0, 'G@{S', 'G@{S', 'hDL0S}tGK2W\0M@', '', 0, '?'),
 ('T3b1;V', 'wp-content/themes/kallyas/components/blog/default-single-modern/single-main.php', 0, ' :fHmQ', ' :fHmQ', 'ƛ\\چugaG00b=Z\0ʻ', '', 0, '?'),
 ('vzRAM5+z', 'wp-content/themes/kallyas/components/blog/multicolumns/blog-content.php', 0, 'OR@sy(1', 'OR@sy(1', '_,S7%=N0αS?', '', 0, '?'),
 ('Ӑ		0\ZOB', 'wp-content/themes/kallyas/components/blog/multicolumns/blog-media.php', 0, 'Sd%c?ŁewR\Z', 'Sd%c?ŁewR\Z', '>CDC\'t%U\"ױ`Zy[_', '', 0, '?'),
 ('N2ʁC1	ya', 'wp-content/themes/kallyas/components/blog/multicolumns/blog-tags.php', 0, 'Au\ZA', 'Au\ZA', '2xgYD}dŕK{_\0ʔ', '', 0, '?'),
 ('0{hSHg\"', 'wp-content/themes/kallyas/components/masks/mask3.php', 0, 'iKgݔ`^|', 'iKgݔ`^|', '=I\r3w^=LT,1.r', '', 0, '?'),
 ('ى B:Mb', 'wp-content/themes/kallyas/components/masks/mask4.php', 0, 'Z0P', 'Z0P', '\rniQ*~ٶi', '', 0, '?'),
 ('e8@AkQ0', 'wp-content/themes/kallyas/components/masks/mask5.php', 0, '(؍*X8', '(؍*X8', 'J*u_Z%s}Dt\"9', '', 0, '?'),
 ('\'12`\0', 'wp-content/themes/kallyas/components/masks/mask6.php', 0, 'xflKDs', 'xflKDs', 't|):P0%Xty)J', '', 0, '?'),
 (':ʻ`ly', 'wp-content/themes/kallyas/components/masks/mask7.php', 0, 'Ͻi', 'Ͻi', 'E U6~e!\Zטw\0bw', '', 0, '?'),
 ('\0d8;a[ut6', 'wp-content/themes/kallyas/components/masks/mask8.php', 0, '&\ZË#', '&\ZË#', '\'\r\'Az]4\rt=)6-bN', '', 0, '?'),
 ('iI0z\'D', 'wp-content/themes/kallyas/components/masks/masks-functions.php', 0, '5<B', '5<B', '-rhdyS?:5*_ܔ', '', 0, '?'),
 ('iA:gI5MMz', 'wp-content/themes/kallyas/components/theme-header/header-components.php', 0, 'zw7GL)y:', 'zw7GL)y:', 's<@5q\"4lXl', '', 0, '?'),
 ('0R19Fo޳', 'wp-content/themes/kallyas/components/theme-header/header-main.php', 0, 'A[>=gm|\Z', 'A[>=gm|\Z', 'qK¯\r*IC问/jLZ', '', 0, '?'),
 ('g[r)+ )7-\\', 'wp-content/themes/kallyas/components/theme-header/header-markup-bottom.php', 0, 'YW9G ', 'YW9G ', '=\"\ZX*\n°_|o\0r^ ', '', 0, '?'),
 ('C ޾#U#Ru', 'wp-content/themes/kallyas/components/theme-header/header-markup-main.php', 0, 'ޮIeFjP!c6nf', 'ޮIeFjP!c6nf', '~rA54ek^lc7IsdH', '', 0, '?'),
 ('|GkU9E1', 'wp-content/themes/kallyas/components/theme-header/header-markup-topbar.php', 0, '\"/\"d#O', '\"/\"d#O', 'nT~Yi&DL46+fc`Q', '', 0, '?'),
 ('XȄ\0_', 'wp-content/themes/kallyas/components/theme-header/header-markup.php', 0, 'koC8xq>', 'koC8xq>', 'tQqL&hMMj<U', '', 0, '?'),
 ('EpUZ\0*', 'wp-content/themes/kallyas/components/theme-header/header-style-default.php', 0, 'ޕ&ŨAs`̎R', 'ޕ&ŨAs`̎R', 'PEF,O*>i8B%u5J^', '', 0, '?'),
 ('\0=qd', 'wp-content/themes/kallyas/components/theme-header/header-style1.php', 0, ')5=QԸ', ')5=QԸ', ' 6lk9h\0O_)+d', '', 0, '?'),
 ('Z?ְb0v2<', 'wp-content/themes/kallyas/components/theme-header/header-style10.php', 0, 'T\r=|טxJ', 'T\r=|טxJ', '<~)\0*BHZO≮0', '', 0, '?'),
 ('X4(K=`oGW', 'wp-content/themes/kallyas/components/theme-header/header-style11.php', 0, 'L\rػdnUiA', 'L\rػdnUiA', 'C	9&ж6ak_Pr˪R', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('sUieC{b', 'wp-content/themes/kallyas/components/theme-header/header-style12.php', 0, '~!Ƴ\'&yL', '~!Ƴ\'&yL', 'Tl](\"Vu6&%o:&VSr', '', 0, '?'),
 ('D.t', 'wp-content/themes/kallyas/components/theme-header/header-style13.php', 0, '/.kO', '/.kO', 'jWjK{5Nzvƛs-', '', 0, '?'),
 ('^Th{֔Y0,', 'wp-content/themes/kallyas/components/theme-header/header-style14.php', 0, '{*A#', '{*A#', 'J(Mcِ_r-^', '', 0, '?'),
 ('3@PG\0', 'wp-content/themes/kallyas/components/theme-header/header-style15.php', 0, 'y?g$ϜLsaD', 'y?g$ϜLsaD', 'Dwhs976FJrvFPwo8', '', 0, '?'),
 ('32,b	\"q', 'wp-content/themes/kallyas/components/theme-header/header-style16.php', 0, 'E-\r,C_~', 'E-\r,C_~', '$ңɩm}K>XE6>]!n', '', 0, '?'),
 ('{,d', 'wp-content/themes/kallyas/components/theme-header/header-style17.php', 0, 's1ahmj', 's1ahmj', 'W=SW\"?\\֭ey/QcSg', '', 0, '?'),
 ('U,ÑΩTEM', 'wp-content/themes/kallyas/components/theme-header/header-style2.php', 0, '<Ν4q', '<Ν4q', 'GNǀ!1p\rd`Yy\'C8p', '', 0, '?'),
 ('4h\"\n+6L#8', 'wp-content/themes/kallyas/components/theme-header/header-style3.php', 0, 'Dw/41V`0>', 'Dw/41V`0>', '%\"UѺBT9w5鬢,y)s', '', 0, '?'),
 ('*ׂ30\nDFf', 'wp-content/themes/kallyas/components/theme-header/header-style4.php', 0, '0Ig(\\vM', '0Ig(\\vM', '^LFX$6oW\Zyij ', '', 0, '?'),
 ('y\Z,7Cհd	<', 'wp-content/themes/kallyas/components/theme-header/header-style5.php', 0, 'avIC', 'avIC', 'C#];.6	?qi eE>Y', '', 0, '?'),
 ('R_R{ǡ<*ܮ', 'wp-content/themes/kallyas/components/theme-header/header-style6.php', 0, '޿ytr7Y', '޿ytr7Y', '\ntip\r)jQYÕ01', '', 0, '?'),
 ('dGWM', 'wp-content/themes/kallyas/components/theme-header/header-style7.php', 0, '\'91sC赨Obr', '\'91sC赨Obr', 'n\r?GzΫqpOVNn.)\'V+', '', 0, '?'),
 ('0*Gu+', 'wp-content/themes/kallyas/components/theme-header/header-style8.php', 0, 'ݖؕS', 'ݖؕS', '\rc&\\8뇓YJsu\n^,R{qX', '', 0, '?'),
 ('D>Uc-e*', 'wp-content/themes/kallyas/components/theme-header/header-style9.php', 0, '{-Bfa/', '{-Bfa/', ';]eM*Ν#Pd_XQTP', '', 0, '?'),
 ('3.ߨSI\Z', 'wp-content/themes/kallyas/components/theme-subheader/subheader-default.php', 0, 'fM&Aҿ?', 'fM&Aҿ?', 'kϕfۣWv1~asP;A', '', 0, '?'),
 ('	B\'rWd,z?', 'wp-content/themes/kallyas/components/theme-subheader/subheader-documentation.php', 0, '˓*Lh}i;', '˓*Lh}i;', '3*!3,GZ1\Z;0WRT', '', 0, '?'),
 ('AܗD{&A', 'wp-content/themes/kallyas/css/dynamic_css.php', 0, 'RAWBxT', 'RAWBxT', '^!V %Q*?;', '', 0, '?'),
 ('h+qyM<(', 'wp-content/themes/kallyas/deprecated.php', 0, '-VӴe|Yu\\}P', '-VӴe|Yu\\}P', 'F˩W`KAx=oH>]', '', 0, '?'),
 ('9ÒO,i', 'wp-content/themes/kallyas/fonts/glyphicons-halflings-regular.svg', 0, '!Fhey#-e[', '!Fhey#-e[', '$6`|y+^	8c%k', '', 0, '?'),
 ('2~pz;', 'wp-content/themes/kallyas/footer.php', 0, '{A ƋW', '{A ƋW', 'ΐZ$a\0`sMh9\ZR7', '', 0, '?'),
 ('tK#', 'wp-content/themes/kallyas/framework/class-gdpr.php', 0, 'aI`=a:', 'aI`=a:', 'µ9}{ь!T<D=V8R 2', '', 0, '?'),
 ('w-\nn', 'wp-content/themes/kallyas/framework/compatibility/config.php', 0, 'e/B\Z ', 'e/B\Z ', 'o]@V\"ʊ^ۯL!gګv:', '', 0, '?'),
 ('jo9ʜ9+u', 'wp-content/themes/kallyas/framework/compatibility/framework.php', 0, '\"fTe\\/kH\\', '\"fTe\\/kH\\', 'P\"9W:Ja(\Z^ڡ%Xsu', '', 0, '?'),
 ('9il<*x', 'wp-content/themes/kallyas/framework/compatibility/metafields.php', 0, '}|ׁCi\\', '}|ׁCi\\', 'ZA\Zl\\E(M]vѼuVwfk', '', 0, '?'),
 ('?7偦3a@Gk', 'wp-content/themes/kallyas/framework/compatibility/shortcodes.php', 0, '=ۙ ǐmJq', '=ۙ ǐmJq', 's*WU\0.)izYx,', '', 0, '?'),
 ('7BlOf\Z', 'wp-content/themes/kallyas/framework/compatibility/termmeta.php', 0, 'a0E<0oVbFY', 'a0E<0oVbFY', 'YsjWɖ>\"wǫ*jP', '', 0, '?'),
 ('tCHu	', 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/admin-mega-menu.js', 0, 'Pf^^k7΅3', 'Pf^^k7΅3', 'Ycx+TԞQ`4uZ	h06ME;sm', '', 0, '?'),
 ('}Dׄa9(^', 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/html.js', 0, ')\nE\rRߗ~', ')\nE\rRߗ~', 'ۊ\n4DSc6\"]9', '', 0, '?'),
 ('_1;::o', 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/zn_modal.js', 0, '2B0eT;rO', '2B0eT;rO', 'Ҫ4f؞$Y#λJա+)', '', 0, '?'),
 ('>JMH/.', 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/zn_theme_ajax_callback.js', 0, 's3p\Zr!', 's3p\Zr!', 'f.?O\Z_{gR!b', '', 0, '?'),
 ('llcl	Nlj+', 'wp-content/themes/kallyas/framework/hg-theme-framework/hg-theme-framework.php', 0, 'dpE', 'dpE', '3n!_wuHșYu4', '', 0, '?'),
 ('+8D׭', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/addons_manager/class-addons-manager.php', 0, '3g5iYyb', '3g5iYyb', ',d;jΆgɕ.LH', '', 0, '?'),
 ('x+Z˫hk', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/addons_manager/ui/tmpl-addons-list.php', 0, 'ΰtplY#;R/', 'ΰtplY#;R/', 'o#kL~Fo(zW\ZBE\"J', '', 0, '?'),
 (')JjZs*JT', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_about.js', 0, '4)/jACZE', '4)/jACZE', 'xǐ\'S5,f/ڨ9\ng{>N', '', 0, '?'),
 ('$hzb|q', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_theme_check.js', 0, 'Tϵc+-~ʀ', 'Tϵc+-~ʀ', 'u~\Zn1cYg\'LړyJ(-', '', 0, '?'),
 ('7a/ϡz;,', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/class-zn-admin.php', 0, 'A1HW', 'A1HW', '>CUhD;f4$3o?]u', '', 0, '?'),
 ('MWN^%', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_DemoImportHelper.php', 0, '8G*mQ', '8G*mQ', '# )5(Fu/.55Hm%8', '', 0, '?'),
 ('{+B/;*i.&', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_ThemeDemoImporter.php', 0, 'z}J~gTzSi=', 'z}J~gTzSi=', ':ge>`mͷ`J-iN9Y', '', 0, '?'),
 ('&I]g[XTe', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-init.js', 0, 'ȉS>MKo%', 'ȉS>MKo%', 'Sob6gQAB%?,y/\nJ*he', '', 0, '?'),
 ('ZSO]Az[', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-manager.js', 0, '[˙yB%8n', '[˙yB%8n', 'RW\"/\'FK\rR?!K`*uG', '', 0, '?'),
 ('	ߘn\"	', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/content-tmpl.php', 0, 'E6L', 'E6L', ' 0)Bűs94?>pC{', '', 0, '?'),
 ('dٮh00AT84', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/dummy_data-tmpl.php', 0, 'T)㜊X%T', 'T)㜊X%T', 'afs͘,%;\"Lp0p>', '', 0, '?'),
 ('`;\'\nKyQF', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/footer-tmpl.php', 0, 'udcI2ӀP', 'udcI2ӀP', '&QV|FO%]ohY6٥\Z !#', '', 0, '?'),
 ('4b$;X:ÀI', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/form-register-theme-tmpl.php', 0, '41/I\'	G`', '41/I\'	G`', '0|@Od^.2ڄ2R̥r', '', 0, '?'),
 ('?@nY:', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/header-tmpl.php', 0, 'Pk͚&lx\"l', 'Pk͚&lx\"l', 'e̡VU;>0X1~(\n;n5Ax?', '', 0, '?'),
 ('0beTZ\Zt', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/register-tmpl.php', 0, '\Z4;OZ', '\Z4;OZ', '\n/wd0a~9{z:!LT3wnʥ', '', 0, '?'),
 ('I/]$|p=', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check-amazon.php', 0, '`$zn%)', '`$zn%)', '#E2*igd]V@rf@', '', 0, '?'),
 ('(D,.\"X/:B', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check.php', 0, 'iFgDk', 'iFgDk', '\0j>\\\re8G*K	>6J', '', 0, '?'),
 ('_i/>B', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/api/ZN_HogashDashboard.php', 0, '6tԊ̈́-', '6tԊ̈́-', 'LhY֥;k)9:Yiq', '', 0, '?'),
 ('B*ӦkM1-', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/components/ajax-load-more.php', 0, 'xiE}bnxN 3', 'xiE}bnxN 3', 'jw?v4#	^3A>L:Ł?QT$', '', 0, '?'),
 ('+ɚ2@tX!', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/components/index.php', 0, '}{ݓQR$!Y', '}{ݓQR$!Y', '][GhÝB+6lpw', '', 0, '?'),
 ('sZ#mr\"A-0', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/dependency-management/class-dependency-management.php', 0, 'lӃ5|/B', 'lӃ5|/B', 'ijL\r9uv(t4n2+za-', '', 0, '?'),
 ('(]W^j>)L', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/dependency-management/ui/frontend-notice.php', 0, '7\'P2xMϒ', '7\'P2xMϒ', 'y/_jUGto1%F&r0 Z', '', 0, '?'),
 ('Ҹd;j<b(', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-backend.php', 0, 'ZɃ΄', 'ZɃ΄', 'Ou!;.3zomxlb+>', '', 0, '?'),
 ('hIf', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-frontend.php', 0, 'pt&؈p', 'pt&؈p', '1(nY2L?\Z|za=X', '', 0, '?'),
 ('*`m	EN4u{', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-helper.php', 0, 'Ydlפv', 'Ydlפv', '@xqp#^O&a=G\\H$', '', 0, '?'),
 ('Hܓ.a', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-image-helpers.php', 0, '=d%u;#', '=d%u;#', '6IK(f\ZNNsiDڬ\\%-T', '', 0, '?'),
 ('lG$HYd', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/theme_ajax.php', 0, 'Aɰs.', 'Aɰs.', 'r~ċ{!QBigڨ\"y\nAM[a', '', 0, '?'),
 ('_<chLk', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/html/class-html-integration.php', 0, 'y?lm\\s#z', 'y?lm\\s#z', 'Z^u5Z];]|:d2iLLWBjM', '', 0, '?'),
 ('M~BjC', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/html/fields/theme_import_export.php', 0, '@\\,\"tb', '@\\,\"tb', 'i1|*3T-w_لHcs', '', 0, '?'),
 ('I!u6', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/installer/class-theme-install.php', 0, 'k!)W\n)|ĕ', 'k!)W\n)|ĕ', '~j<bFJNղӨv?Jn', '', 0, '?'),
 ('.h$T^t6', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-about.php', 0, 'f@?', 'f@?', '~,CO=<wC\"Io', '', 0, '?'),
 ('TYc~ZmҤz\n', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-update.php', 0, '.ǻ68g1A', '.ǻ68g1A', ']7R C_X\"Agw}', '', 0, '?'),
 ('X0$k|[Ge1K', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/integrations/admin-bar.php', 0, 'ywjQb', 'ywjQb', 'Q=fB:y?،p@', '', 0, '?'),
 ('ɂPx73G\\(', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/integrations/rev-slider-integration.php', 0, '^!]-b', '^!]-b', 'Sp¯^vkv~=gw\nqj0+\ZG ', '', 0, '?'),
 ('\'Ca fld', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/integrations/znhgfw_integration.php', 0, '~i:xmn', '~i:xmn', 'sх%;(&j+Jh9M+խd', '', 0, '?'),
 ('6bmTc3/g[X', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu-admin.php', 0, '$`', '$`', '9s6m45]`r5fj', '', 0, '?'),
 ('OI#emu', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu.php', 0, '6x;G*jDË', '6x;G*jDË', 'u|( .ުLVeTîR	', '', 0, '?'),
 ('ZR\\btc', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/options-exporter/ZnThemeImportExport.php', 0, 'aֳBUnr', 'aֳBUnr', '9fLj71㚼|0usdk', '', 0, '?'),
 ('orj\'n', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/scripts-manager/class-scripts-manager.php', 0, 'y_mGv$d7', 'y_mGv$d7', 'ؖ߇s`Q%RU$z}=', '', 0, '?'),
 ('9zRkeƩl*iI', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/updater/class-theme-updater.php', 0, '|QHnUa', '|QHnUa', '	9o7.Ih+e6Ͱ,ZԫчF', '', 0, '?'),
 ('/@q2bC\rcD', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/updater/inc/options.php', 0, 'ZxĂwA&4', 'ZxĂwA&4', '|\\T@2zeW*Vj', '', 0, '?'),
 ('){1-?Gs', 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/utility/class-utility.php', 0, ';TjyB', ';TjyB', '#@>Ea7b\r-', '', 0, '?'),
 ('T EKaOܓ', 'wp-content/themes/kallyas/framework/hogash-mailchimp/assets/js/hg-mailchimp.js', 0, '0q0Bc', '0q0Bc', '\ng\r	D[d=:%F', '', 0, '?'),
 ('ԁ2貃ސO@', 'wp-content/themes/kallyas/framework/hogash-mailchimp/hogash-mailchimp.php', 0, '%fc}SL!', '%fc}SL!', 'k(3}Ċѥ2ME/22', '', 0, '?'),
 ('ԙW5\n_rKv', 'wp-content/themes/kallyas/framework/hogash-mailchimp/includes/options.php', 0, '>Q|}', '>Q|}', '&f)b`-z5Ʌڗ', '', 0, '?'),
 ('C_ѤD(MS', 'wp-content/themes/kallyas/framework/hogash-mailchimp/lib/HG_MCAPI.php', 0, 'ܷ3ap@p\'G', 'ܷ3ap@p\'G', '5\'vվSkw', '', 0, '?'),
 ('wn/', 'wp-content/themes/kallyas/framework/hogash-mailchimp/lib/class_gdpr.php', 0, 'bXND꤅Pw7\r', 'bXND꤅Pw7\r', '5F	teRorEiWpˬo', '', 0, '?'),
 ('uo汾R]', 'wp-content/themes/kallyas/framework/hogash-mailchimp/pb_element/newsletter/newsletter.php', 0, ':mv', ':mv', '\'g	w/&yo\\&:MkB+?', '', 0, '?'),
 ('	(t0Ol2', 'wp-content/themes/kallyas/framework/hogash-mailchimp/widget/widget-mailchimp.php', 0, '3\'S.', '3\'S.', 'OaC\0^V&򟱮\">:$', '', 0, '?'),
 ('Cvp:~S`~v5', 'wp-content/themes/kallyas/framework/zion-builder/assets/icons/zn-framework.svg', 0, 'y76=L**', 'y76=L**', 'wIK[RiRyTY_C]+;a\n', '', 0, '?'),
 ('rޮ{e旊p/', 'wp-content/themes/kallyas/framework/zion-builder/assets/img/pb_col_plus_x.svg', 0, '!ܾ<H}a', '!ܾ<H}a', 'ɷeٵb:\'AjY', '', 0, '?'),
 ('Kg }|aÍ', 'wp-content/themes/kallyas/framework/zion-builder/assets/img/pb_col_plus_y.svg', 0, 'YǿO q;k/', 'YǿO q;k/', 'bOLf%W5t5Ñj', '', 0, '?'),
 ('(BFPG%A', 'wp-content/themes/kallyas/framework/zion-builder/assets/img/svg-icons.svg', 0, 'f\ZʓF?SЪ', 'f\ZʓF?SЪ', 'f+_0Q1;3E KErfF%F', '', 0, '?'),
 ('bY5!\nct', 'wp-content/themes/kallyas/framework/zion-builder/assets/js/admin/edit-screen.js', 0, '[7b', '[7b', '#\\ڼ=TnU\0bQE߃7[', '', 0, '?'),
 ('3_Hw}bW.}\r', 'wp-content/themes/kallyas/framework/zion-builder/assets/js/admin/yoast-integration.js', 0, 'Y\0>T@\rgO', 'Y\0>T@\rgO', 'őBg_jI5.I[kmӼIE', '', 0, '?'),
 ('nÍTtqOΰg', 'wp-content/themes/kallyas/framework/zion-builder/dist/gutenberg_integration.bundle.js', 0, 'Ժmi\"sҠ$', 'Ժmi\"sҠ$', '\07ڒJqSh$>oEo', '', 0, '?'),
 ('[&CA', 'wp-content/themes/kallyas/framework/zion-builder/dist/znpb_editor.bundle.js', 0, '!WO|hP', '!WO|hP', 'I.VM+Ƀ^TR}Q,A]NxڠW', '', 0, '?'),
 ('Fat&#\n/', 'wp-content/themes/kallyas/framework/zion-builder/dist/znpb_frontend.bundle.js', 0, 'G4PQw<31I', 'G4PQw<31I', 'R`w	 `W244\0PM&Ќl!]<(&', '', 0, '?'),
 ('?s_Pf\n=', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/img/select-arrow.svg', 0, 'J[{y', 'J[{y', '9@gq{k5EL5~M', '', 0, '?'),
 ('LG,=PՖ\rEv', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.js', 0, 'ZX+ތAo', 'ZX+ތAo', 'a<4\0xc{M7\ZbN#', '', 0, '?'),
 ('<jPR1\ZqʉZ.', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.min.js', 0, '>ԲwCu @S', '>ԲwCu @S', 'ù*:$[Hw9S\Zh`m4\n', '', 0, '?'),
 ('4*0H#%PHs', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.js', 0, ',0$', ',0$', 'Q\0704ro`GP	$/!', '', 0, '?'),
 ('lySQ6`Lx', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.min.js', 0, '-PtT\0>ۏ', '-PtT\0>ۏ', 'B։i;O5uR#ɓ_wg%Z|', '', 0, '?'),
 ('N\rhy׍uy\r\n', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.isotope.min.js', 0, '\'u>^&/7JJx', '\'u>^&/7JJx', ':7@}W\\L\nAtSf	-L', '', 0, '?'),
 ('_r1飫|', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.timepicker.min.js', 0, '<Mn>9}', '<Mn>9}', '2366qad_T	S0.n', '', 0, '?'),
 ('!D=W1!I%', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/ace.js', 0, '̝jޢ(', '̝jޢ(', 'u+$HfGǬPDxEyr)8\'', '', 0, '?'),
 ('5g5L\\!5', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-css.js', 0, 'ΪS@', 'ΪS@', '[h񞥿f`cY)\ntYMS', '', 0, '?'),
 ('/kcT^Y2,', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-html.js', 0, 'sXu)8p', 'sXu)8p', 'ْɂcs4\nDSuv(', '', 0, '?'),
 (')Y&Q-s\0hx', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-javascript.js', 0, 'jkmjb', 'jkmjb', 'BWפX(t{#H2FJq̥', '', 0, '?'),
 ('x$0I#', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/theme-chrome.js', 0, 'U \0g[㵍', 'U \0g[㵍', '>+_qk[eGg\\^5<Cr ', '', 0, '?'),
 ('VSYeNYA', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-css.js', 0, ' e<aڠN', ' e<aڠN', '3TYs1uzz\'__|w$&Ҭs', '', 0, '?'),
 ('4vѦѧVyS', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-html.js', 0, '^kQV+\0A1', '^kQV+\0A1', 'LoTo(|3O^za#', '', 0, '?'),
 ('G͗XY))`', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-javascript.js', 0, '\0ʲ|)W', '\0ʲ|)W', '\rHH;蜰)}d.QrL', '', 0, '?'),
 ('>[`q\r', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/wp-color-picker-alpha.js', 0, 'F=+.Տ', 'F=+.Տ', 'TwdWP\0c٩+KkwOrߚi', '', 0, '?'),
 ('UP\nD0_`/', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_html_script.js', 0, 'n#?b`S`&U', 'n#?b`S`&U', 'ӵ3<>Ԍ56eͪ|H', '', 0, '?'),
 ('l͎/', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_media.js', 0, 'ك9I\"ֲ6ȩr3', 'ك9I\"ֲ6ȩr3', 'χ{]yk|Y`RWK>U', '', 0, '?'),
 ('.k9+Tcg/', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_modal.js', 0, '\\2Ey/l', '\\2Ey/l', 'c/ #߿x4\\	^', '', 0, '?'),
 ('6?W	/ax-:', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/class-znhgfw.php', 0, 'woaf}_', 'woaf}_', '&37\Zul\nl$Hː	i<yh', '', 0, '?'),
 ('%\r2JX2', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/hg-framework.php', 0, 'V+}]Ni', 'V+}]Ni', 'Yʬ37>]c^f	5', '', 0, '?'),
 ('>_L?', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/font-manager/ZnTypekitClient.php', 0, 'X\'\"j4`e\r|\0', 'X\'\"j4`e\r|\0', 'a/N4gH|l#=\'2b', '', 0, '?'),
 ('qD)~U,9#', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/font-manager/class-font-manager.php', 0, 'P-V8n8', 'P-V8n8', '51\'	Pc:\nMUenZX', '', 0, '?'),
 ('#CzQ)=', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/font-manager/google_fonts.php', 0, '(RGըu%W', '(RGըu%W', '(y/-YT$!\0NJ&,ik', '', 0, '?'),
 ('#6', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-color-helpers.php', 0, ',=1@VGN}', ',=1@VGN}', 'xh[qZ\Z;Wذn\'y', '', 0, '?'),
 ('*	mA', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-helpers.php', 0, 'Z)1>g@', 'Z)1>g@', 'õvsKn\"z\\돞ƈy~{', '', 0, '?'),
 ('ݜ\"\ni', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/helpers/loader.php', 0, 'HtۺuuRB', 'HtۺuuRB', 'N:4*-\Za1Pm>i', '', 0, '?'),
 ('OAݜlO\\', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-data-source.php', 0, 'NkEn\n 8\"', 'NkEn\n 8\"', '|d#A{`${HWݔ]T', '', 0, '?'),
 ('C\0/*', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-field.php', 0, '0eXUGbhS\'', '0eXUGbhS\'', 'ްh\0uw&4ϹV%,Y^]ypuHN', '', 0, '?'),
 ('6\Z\r+2;k\\', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-form.php', 0, '50:˭O', '50:˭O', '{\Zm(R0ʜv9t\0b,&PN1', '', 0, '?'),
 ('\0].GL/fn|', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-html.php', 0, 'dB*&n5Ȑ', 'dB*&n5Ȑ', ']:\ZDlJS~[hVfɑ', '', 0, '?'),
 ('a̢R̶c', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/data_source/class-pages-data-source.php', 0, 'gE(SNf', 'gE(SNf', '<K@~_@?`-	k#UmɕK', '', 0, '?'),
 ('u}\0\rߛ', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/background.php', 0, 'Au1ؔ\\/uL`G', 'Au1ؔ\\/uL`G', '0LFpQ*tlOӇ?ay\r', '', 0, '?'),
 ('$0[B*', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/boxmodel.php', 0, 'V2vRn#U5', 'V2vRn#U5', 'wϓ4޾wdHdme', '', 0, '?'),
 ('\ZI%k|', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/buttons.php', 0, '];|,˱f', '];|,˱f', 'a9T K>LD8;8Z\r', '', 0, '?'),
 ('\Z*{ǷU1I', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/checkbox.php', 0, '+IШ/m~H7i2', '+IШ/m~H7i2', 'WrlvJ,F4i\Zu!Ks9', '', 0, '?'),
 ('5jîjS', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/colorpicker.php', 0, 'B\0IWw', 'B\0IWw', 'ͥltS]Kg6+ͨ&n', '', 0, '?'),
 ('3lq~8Q-(~cx', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_format.php', 0, '0w6B!B\'z', '0w6B!B\'z', 'F֐D߻A_XԂuDTu', '', 0, '?'),
 ('$r&t_\\Ex=', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_picker.php', 0, '[iM]', '[iM]', '~ͯe3#!Rn*8a	Z[_A\"', '', 0, '?'),
 (',u6d9AK$7', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/day_picker.php', 0, 'sRI', 'sRI', 'N-W2/8	؃$%', '', 0, '?'),
 ('%&w_;i-XC', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/font.php', 0, 'ZkT1', 'ZkT1', '=fyҍ%vP~F3Nz=ޠ5]k?', '', 0, '?'),
 ('Z6\Z', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/gallery.php', 0, 'z2/Pw*T', 'z2/Pw*T', '_b;3P\'hR&?-imh.0)s!', '', 0, '?'),
 ('3f5Smݍǧg0', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group.php', 0, 'ɟrF$+', 'ɟrF$+', '1\r\n{Y/FFMB.EiJ\r`U!9/', '', 0, '?'),
 ('`#,a', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_select.php', 0, '$\"i	hVg^i', '$\"i	hVg^i', '{\ZTTYMjZjʜ|f٬zM', '', 0, '?'),
 ('Bq1;z!^n1', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_text.php', 0, 'gE<̌eA*', 'gE<̌eA*', '8a$&|u\n{ۡm`{\r*=', '', 0, '?'),
 ('HH\n[\'', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/hidden.php', 0, ')gLЪ$䓝', ')gLЪ$䓝', 'IR6X$D/)ZlKeO', '', 0, '?'),
 ('xu:V\n>WPir&', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/icon_list.php', 0, 'b&ES\0NH', 'b&ES\0NH', 'eʒMW$sb>[c;1vaF', '', 0, '?'),
 ('rO$-#<X\\', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/image_size.php', 0, 'yWY@', 'yWY@', '5!eB^fO֑&[ivj{', '', 0, '?'),
 ('okb!$ĞP', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/link.php', 0, '\ZRnΪ=Nқ', '\ZRnΪ=Nқ', 's$v\rfzs!FƋ)', '', 0, '?'),
 ('85.~$3', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/media.php', 0, '\n60c\\C', '\n60c\\C', 'ljt11%9:.$66~6', '', 0, '?'),
 ('\0\\|V2B(\'R', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/options_wrapper.php', 0, 'Ĕ_j\\\rz', 'Ĕ_j\\\rz', '>Aujt~r02?-Wq}^C5P򵆩', '', 0, '?'),
 ('o=QF-{&', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/radio_image.php', 0, 'W1BZZHH', 'W1BZZHH', '3sjH#|xJ!', '', 0, '?'),
 ('fD[D@h)', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/select.php', 0, 'c(cߨ04D', 'c(cߨ04D', '^StUEP{qNtikQ2', '', 0, '?'),
 ('n&MJ162Hi', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/sidebar.php', 0, 'ۊTȢUJ_', 'ۊTȢUJ_', '9\Z9g[D\ZW@F$cdy3', '', 0, '?'),
 ('fz%27JM~:', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/slider.php', 0, '\'{sčÄc', '\'{sčÄc', '=Pzs7O=U7K?l2', '', 0, '?'),
 ('\\0CwܐNI', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_select.php', 0, 'ײ#/y	G\0', 'ײ#/y	G\0', 'J\"F\'*/qvT\nիG', '', 0, '?'),
 ('g).]a\r\'', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_slider.php', 0, 'yd\\~oW\'d', 'yd\\~oW\'d', '{QVM5(C;/cT8OB', '', 0, '?'),
 ('\Zd}*', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/tabbed_form.php', 0, '+\nRWq7', '+\nRWq7', 'q_C%kS	]}:*gr`h', '', 0, '?'),
 ('	wu<x6', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/text.php', 0, 'EgI\\A;$', 'EgI\\A;$', '\0l_ؙI0:\"Pxgq\".K', '', 0, '?'),
 ('H-*5d6Jl\0', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/textarea.php', 0, 'п$␡-G', 'п$␡-G', 'Q55і.pkV4/R\'O', '', 0, '?'),
 ('D3HiO]', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle.php', 0, ')m˻xr͏>', ')m˻xr͏>', 'xr֪C/6jJ\\s\"R,Tr_', '', 0, '?'),
 ('8qݖ~r8v8', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle2.php', 0, 'Q5^\ZOI}q ', 'Q5^\ZOI}q ', 'HaKFj\nab+ ]ޓ\"', '', 0, '?'),
 ('dDpa+kb', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/upload.php', 0, '̕a\rj', '̕a\rj', '.=iwQhps񨃬+=1e/k+Z', '', 0, '?'),
 ('h_.ئvb[ ', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/visual_editor.php', 0, 'S6Ŗ4.tyaə^', 'S6Ŗ4.tyaə^', 'kgYGC@m`ZnhD', '', 0, '?'),
 ('l$$F', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/widget_positions.php', 0, 'rI8sY\Z~.', 'rI8sY\Z~.', '0XFͯ+\Z3=iܒwPX[', '', 0, '?'),
 ('Jc@F#\"', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_ajax_call.php', 0, '\Z2D|?', '\Z2D|?', '^r8OGHQ^Z9#\\[p~\n', '', 0, '?'),
 ('\"K\rJj6FDf', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_google_fonts_setup.php', 0, 'Il8#15nۚx', 'Il8#15nۚx', 'YFkK~mQB4%ѺltxF', '', 0, '?'),
 ('!rs{>', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_message.php', 0, '6Q5}BZe>\0X', '6Q5}BZe>\0X', 'jw4}6K5oy!g', '', 0, '?'),
 ('|9}O˔}fƺ+ڕ', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_radio.php', 0, 'Mju\r8KZ$F', 'Mju\r8KZ$F', '@_7$CN-7)G~FNZYɑ', '', 0, '?'),
 ('\n\nd!{H', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_title.php', 0, 'VyM.庻1LwX', 'VyM.庻1LwX', '\Z_b婏/A2|x7', '', 0, '?'),
 ('@XQ\\igu', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/forms/theme_form.php', 0, ']|}~=?|vߏ', ']|}~=?|vߏ', '\\)ɢ0F2eӂ1I&䧿Vϫ', '', 0, '?'),
 (',\Zbk[W*y8u', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/icon-manager/class-icon-manager.php', 0, '\nvȻM5', '\nvȻM5', '󸸤y,.νΗdڸ^Ar', '', 0, '?'),
 ('T(o2$', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/image-resizer/class-image-resize.php', 0, '&?Ry;', '&?Ry;', 'tyzZ@]y)ܷҭV1', '', 0, '?'),
 ('E@l\"|A', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/metaboxes/class-metabox.php', 0, 'LݺEAl%', 'LݺEAl%', 'at9=hp1Y@[G', '', 0, '?'),
 ('ۚ:[Pӛ7¨	V', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/permalinks/class-permalinks.php', 0, '<Ç\r<Ip', '<Ç\r<Ip', 'yf\'3:(F4Y=\\Inc ', '', 0, '?'),
 ('Pp,l;+q', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/scripts-manager/class-scripts-manager.php', 0, '~@|', '~@|', 'TiO\'ѾM6Mg\"6y)H+	r', '', 0, '?'),
 ('S_+tp1', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/HG_Shortcode.php', 0, '雄l]Y3_', '雄l]Y3_', 'o1%$\nLZ3ʪ]u>d', '', 0, '?'),
 (',U*Wscl\r', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/class-shortcodes-manager.php', 0, '	2on0', '	2on0', '[<\n\"AhI(Ti3', '', 0, '?'),
 ('Ժĸ%6:ךwR', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/taxonomies/class-termmeta.php', 0, '&sOK{:4VS', '&sOK{:4VS', '/&\\<WgVFOfw~', '', 0, '?'),
 ('Y[Ͳ.', 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/utility/class-utility.php', 0, 'nc@jU\\z;oQ', 'nc@jU\\z;oQ', '\0\0ܑV])ow=\0\'/=ai', '', 0, '?'),
 ('1Kʂ\nL', 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionElement.php', 0, 'fafp=fN=', 'fafp=fN=', '`Ц{jxtvnV3!pd!', '', 0, '?'),
 ('zХxO:nW', 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionElementsManager.php', 0, 'ٙ$)H+	Jm', 'ٙ$)H+	Jm', ' En\0?I#L6{yuՈ', '', 0, '?'),
 ('wхkrYdr', 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionPageBuilderCustomCode.php', 0, '䦠?5>$T', '䦠?5>$T', 'fl+=o-#һsgy4ςz', '', 0, '?'),
 ('_BSbÐB', 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionPageBuilderFrontend.php', 0, 'Дaʟ', 'Дaʟ', 'v.kd<vo\nPAWGޮ\\', '', 0, '?'),
 ('|X,HOً!Lz', 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionScriptsManager.php', 0, 'ݗIgɢ#%Iu', 'ݗIgɢ#%Iu', 'eK,[4H[-!\\DAh_U<&', '', 0, '?'),
 ('ciNY\'g=', 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionWordPressSearch.php', 0, '٘pUWD', '٘pUWD', '(~3_oˮF=%B*y ', '', 0, '?'),
 (']nA,\'', 'wp-content/themes/kallyas/framework/zion-builder/inc/admin/ZionPageBuilderAdmin.php', 0, 'HH;oIxS', 'HH;oIxS', '.{YQ1)5\\p\\[`cb&]', '', 0, '?'),
 ('JXܗeҋ¾1)', 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/ZionEditor.php', 0, '{-pSսCS', '{-pSսCS', 'ӬKh$]Bx56Ҙ', '', 0, '?'),
 (',ú3^{S!', 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/ZionPageBuilderExportHelper.php', 0, 'MoDB\rؔ<8', 'MoDB\rؔ<8', '4W\0b:iYY)_D0 [\"', '', 0, '?'),
 ('8n\ZNܧ', 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/ZionTemplateSystem.php', 0, '03)GhJ', '03)GhJ', 'O\0qM@wxc', '', 0, '?'),
 ('19KV3<', 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/class-page-builder-ajax.php', 0, '5v١5rr/nv', '5v١5rr/nv', '1L66Qvv{H״5&x\\(e', '', 0, '?'),
 ('^4ARk,t|א', 'wp-content/themes/kallyas/framework/zion-builder/inc/helpers/helpers-frontend.php', 0, ']kQ*sJ@', ']kQ*sJ@', 'aY印=^toꪁbb#', '', 0, '?'),
 ('E*\"ݬ{ـ*', 'wp-content/themes/kallyas/framework/zion-builder/inc/helpers/helpers-help.php', 0, 'f4ޖґCq', 'f4ޖґCq', '\0G>*giPh!>\'ʠdS\rB', '', 0, '?'),
 ('n^y\rU0Gu', 'wp-content/themes/kallyas/framework/zion-builder/inc/index-page-builder.php', 0, '!$<xn>', '!$<xn>', '[8\ntxކ\na\\-]', '', 0, '?'),
 ('\Z-Yղ \'', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/class-base-integration.php', 0, '=MYV4J', '=MYV4J', ')1\"bLG@\Zos 3kN0', '', 0, '?'),
 ('t=\\ ōC,+.', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/class-integration-manager.php', 0, 'XL$ZE+-', 'XL$ZE+-', '\Z/Hu.TD\r&@ct+-', '', 0, '?'),
 ('͔\r<', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg.php', 0, 'iV/ӽ', 'iV/ӽ', 'EF.O9a+2B;MYohQ8', '', 0, '?'),
 ('r+Y5q?', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg_integration.php', 0, '2·	', '2·	', '_x@\no	6&{߹tl', '', 0, '?'),
 ('N|(Ua{DcKM', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_nextgengallery_integration.php', 0, '@SwK{\\ߜ', '@SwK{\\ߜ', ';\rrR1ZT]YM2Je|/1', '', 0, '?'),
 ('Z\"[uXo\'AнW', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_paid_membership_integration.php', 0, 'IHZ\'j', 'IHZ\'j', 'mdY\ZFɻIqJf):r(-b', '', 0, '?'),
 ('/fٜ8V', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_polylang_integration.php', 0, '%[.2M.V51', '%[.2M.V51', 'E W{wſBj؉ A', '', 0, '?'),
 ('RNb,!34', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_woocommerce_integration.php', 0, 'b\n>o7?ّ3', 'b\n>o7?ّ3', 'W-0hI%4{-d$\rA	', '', 0, '?'),
 ('ypYQ\\h', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_revisions.php', 0, '`=4Օe', '`=4Օe', 'NNa|KqOMrmȩE\"H/p\0<ߙnk', '', 0, '?'),
 ('H.Mj', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_widgets.php', 0, '|I\\Ry\'', '|I\\Ry\'', 'pA.6-I>\\ewWf:', '', 0, '?'),
 ('*[)	(DW=&', 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_yoast_integration.php', 0, ']87EdM', ']87EdM', '8k\Zd>dc{s&_~', '', 0, '?'),
 ('dTkO\0iBh', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/accordion/accordion.php', 0, '%)lbL@j', '%)lbL@j', 'e/R۵aח|{↿k5V;', '', 0, '?'),
 ('ߣu<-#', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/anchor_point/anchor_point.php', 0, '{؄ʢZlm', '{؄ʢZlm', '4\0ي[MZ\ngY0gFx', '', 0, '?'),
 ('yQJRT?S', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/button/button.php', 0, 'xөF䒛qd', 'xөF䒛qd', '!IPݻ?3\nS\0Ml	: ', '', 0, '?'),
 ('eҔiK	t6]Y', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/column/column.php', 0, '\'Éa6oE#', '\'Éa6oE#', ' K8eK]$oc`?sQ;+|*', '', 0, '?'),
 ('MS.]m䪘\0V', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/contact_form/cf-template.php', 0, '>{}2NŠEZ}x', '>{}2NŠEZ}x', '*?tIB+gЀ/`br=!', '', 0, '?'),
 ('H8Ai?CG .z-', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/contact_form/contact_form.php', 0, 'aU&H~~', 'aU&H~~', 'Ƈ&>)}mWxU==a', '', 0, '?'),
 ('D0ZpEug', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/custom_html/custom_html.php', 0, '<*;F۽qX@', '<*;F۽qX@', 'G^Ab7eƇ1;+%\0\0', '', 0, '?'),
 ('fNÆZ-6', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/google_map/assets/gmaps.js', 0, 'IY', 'IY', 'nޛ!8bqyPbrȀ9N', '', 0, '?'),
 ('\rU0W\0U', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/google_map/google_map.php', 0, '8(:w%', '8(:w%', 'aLQA\n\\Jn KCbXU<u', '', 0, '?'),
 ('A(F[OKG&yq', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/heading/heading.php', 0, '6hhƁ', '6hhƁ', '1\'7d@p:u:dx6FVT', '', 0, '?'),
 ('A\0F72Ǌb', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/icon/icon.php', 0, 'E::<A\ZQ', 'E::<A\ZQ', '#OԁNs?Ffʞ6Ei4\r', '', 0, '?'),
 ('ȗ&űlS2H6', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/icon_list/icon_list.php', 0, 'z$MQT*', 'z$MQT*', 'E\"ɁyApZ8Tysq$Q1j', '', 0, '?'),
 ('h2H,5', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/image/image.php', 0, 'Ċ\rZ7kU', 'Ċ\rZ7kU', 'm\'JS,*ś#f*7a+S', '', 0, '?'),
 ('o	)W\\YfR', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/revolution_slider/revolution_slider.php', 0, 'VV\Z͝8n\0qX', 'VV\Z͝8n\0qX', '½j`&B\0W+1Ib', '', 0, '?'),
 ('٫~l5ʢq', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/section/section.php', 0, 'dW@ѤO', 'dW@ѤO', 'SoK\ng`(ZEIlQN,>`', '', 0, '?'),
 ('AdT ', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/separator/separator.php', 0, '~|Rgbye7&ڱ', '~|Rgbye7&ڱ', '5U(q\nd%@phb', '', 0, '?'),
 ('B\"s}\'O', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/sidebar/sidebar.php', 0, '\0y0(E:1o', '\0y0(E:1o', '#~Tں.5 ]Y\n3,.*+a*of', '', 0, '?'),
 ('ǀJA8-?N!', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/smart_area/smart_area.php', 0, '|*WAp\\', '|*WAp\\', 'LͨrzS竟u1>rwPt', '', 0, '?'),
 ('dR]C9,u', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/smart_container/smart_container.php', 0, 'L㩘П5', 'L㩘П5', '%(IZ7h34kAkL[T3okko&؆Ee', '', 0, '?'),
 ('Ͷt-\0 m', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/spacer/spacer.php', 0, '<9QF1u<*>NO', '<9QF1u<*>NO', 'x&~VV͌_p&', '', 0, '?'),
 ('݌\Zf(&Tc5', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/tabs/tabs.php', 0, '(H!Ť\0', '(H!Ť\0', '8?۲͗j.Yn$-!', '', 0, '?'),
 ('\n\ntG!_', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/text_box/text_box.php', 0, 'mhP|', 'mhP|', '_k%D\0a{}!̇W#7<%Pj', '', 0, '?'),
 ('zFLf3', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/video/video.php', 0, '|}6G;E', '|}6G;E', '`=3nngQOdňdL*S+p', '', 0, '?'),
 ('wQ+T۵B+\Z	', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/widget/options.php', 0, 'yjƑFw', 'yjƑFw', 'jĖq{RjDhYK8>YgӋ1y', '', 0, '?'),
 ('#\'(\nr', 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/widget/widget.php', 0, 'J٧\r-f', 'J٧\r-f', 'Ӊ_1c\nB/GHH', '', 0, '?'),
 ('1_j,kRQ', 'wp-content/themes/kallyas/framework/zion-builder/inc/smart_areas/ZionSmartArea.php', 0, 'dy#ܠR=', 'dy#ܠR=', 'Q\\\0AMttA(	', '', 0, '?'),
 ('O', 'wp-content/themes/kallyas/framework/zion-builder/inc/utility/ZionUtility.php', 0, '\ZH-䎅&\'jbz', '\ZH-䎅&\'jbz', 'p,sst\n\'u6M;A!HJ.x\0', '', 0, '?'),
 ('\0Y1\rԥ;)', 'wp-content/themes/kallyas/framework/zion-builder/zion-builder.php', 0, 'sCCQN', 'sCCQN', '@\\?wܰmFp@- ', '', 0, '?'),
 ('ϕyQ{Kt[', 'wp-content/themes/kallyas/framework/zn-framework.php', 0, 'F2nߒSyM,T\nt', 'F2nߒSyM,T\nt', '#2صaǾt$Tz\'', '', 0, '?'),
 ('}?lzη\' ', 'wp-content/themes/kallyas/functions.php', 0, '`u\ZimzE', '`u\ZimzE', '\"(CcSV7i +iqL', '', 0, '?'),
 ('ThIvdK3bG', 'wp-content/themes/kallyas/header.php', 0, 'Fڋ\\Q-5', 'Fڋ\\Q-5', 'rw2N^AѢEj8{.\\Z+', '', 0, '?'),
 ('<2SR1QG', 'wp-content/themes/kallyas/images/admin/header-styles/style1.svg', 0, 'rD-V=|xA', 'rD-V=|xA', 'dFH5kۅ*G\0V<d[eX<SN`ʘ', '', 0, '?'),
 ('t(fpR<', 'wp-content/themes/kallyas/images/admin/header-styles/style10.svg', 0, 'qC}1p', 'qC}1p', '/\\{-U|#/Hē!kHR*', '', 0, '?'),
 ('#\0EVWfE', 'wp-content/themes/kallyas/images/admin/header-styles/style2.svg', 0, '}]/и/f', '}]/и/f', 'K/%\nkʭ\ZGL(CmLq5', '', 0, '?'),
 ('.x̄', 'wp-content/themes/kallyas/images/admin/header-styles/style3.svg', 0, 'OJ#?+f', 'OJ#?+f', '\"OFfM1\n5I;+W', '', 0, '?'),
 ('9Wc', 'wp-content/themes/kallyas/images/admin/header-styles/style4.svg', 0, '56M14ߩYܷ1', '56M14ߩYܷ1', 'WE^e:w%,BDe', '', 0, '?'),
 ('=Ձy2=', 'wp-content/themes/kallyas/images/admin/header-styles/style5.svg', 0, '_@~F3N', '_@~F3N', 'bc\Z~\rϕrG< yYr', '', 0, '?'),
 ('(p@`n', 'wp-content/themes/kallyas/images/admin/header-styles/style6.svg', 0, 'ɹlUkWEh', 'ɹlUkWEh', '6fa+Y\\!1^Ţ\'<z', '', 0, '?'),
 ('ٰ:7W&	y?', 'wp-content/themes/kallyas/images/admin/header-styles/style7.svg', 0, 'z7LKZ;<', 'z7LKZ;<', 'YuHbyO{*m', '', 0, '?'),
 ('9$?sߟU', 'wp-content/themes/kallyas/images/admin/header-styles/style8.svg', 0, 'Rv`-', 'Rv`-', 'L+|2t_e}*^', '', 0, '?'),
 ('OgL}I{', 'wp-content/themes/kallyas/images/admin/header-styles/style9.svg', 0, 'G;-e\\	$Tю', 'G;-e\\	$Tю', 'QewkD++?LI׍', '', 0, '?'),
 ('\n9;N9>', 'wp-content/themes/kallyas/images/admin/product-styles/product-style-01.svg', 0, 'c|ѳ', 'c|ѳ', 'a*_ODSāb6k\"׬{', '', 0, '?'),
 ('D_B&G3ۼ-', 'wp-content/themes/kallyas/images/admin/product-styles/product-style-02.svg', 0, 'ρSh', 'ρSh', '˘4`H1K*azl-j', '', 0, '?'),
 ('Iip;ӊZ', 'wp-content/themes/kallyas/images/admin/product-styles/product-style-more.svg', 0, 'q=3Ɣ', 'q=3Ɣ', '@!(PIEJCzD|Wop', '', 0, '?'),
 ('៻4.\Z_N9', 'wp-content/themes/kallyas/images/admin/site-layout/boxed.svg', 0, 'C(A1YzS?', 'C(A1YzS?', '.W\0]?f_GBw', '', 0, '?'),
 (':1Vl(zb3', 'wp-content/themes/kallyas/images/admin/site-layout/fullwidth.svg', 0, '\ZèB܈g', '\ZèB܈g', '^r_/bQA>:sj0NélJ', '', 0, '?'),
 ('ssK&F0', 'wp-content/themes/kallyas/images/circle-arr-hover.svg', 0, 'jf+2,YMc', 'jf+2,YMc', 'VL\0[	eK۵6', '', 0, '?'),
 ('#W({`z%\0@Ƒl', 'wp-content/themes/kallyas/images/devices/iphone6.svg', 0, '>ù}ޮ*,y', '>ù}ޮ*,y', '5nà]*ϝ\'DխܮVO+(9', '', 0, '?'),
 ('%utih0', 'wp-content/themes/kallyas/images/devices/macbook-air.svg', 0, 'hR2RZsL', 'hR2RZsL', 'xe6!rc}!kOʦc)-g', '', 0, '?'),
 (',.vhsM', 'wp-content/themes/kallyas/images/devices/macbook.svg', 0, 'Cmcl0rY', 'Cmcl0rY', 'Z?_T4bEcN\\M!N6', '', 0, '?'),
 ('{.7|6ra', 'wp-content/themes/kallyas/images/index.html', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('!acT', 'wp-content/themes/kallyas/images/kallyas-logo-dark.svg', 0, 'FbZK\\Z&', 'FbZK\\Z&', '8<`B$&/&V\n7\ng', '', 0, '?'),
 ('<kup]hR\r', 'wp-content/themes/kallyas/images/kallyas-logo-sticky.svg', 0, '\rV8,4nO}NgM', '\rV8,4nO}NgM', '\"	v5LCqWs	pt2[7΁Y', '', 0, '?'),
 ('aͳHӢ 5d', 'wp-content/themes/kallyas/images/kallyas-logo.svg', 0, '>Z`ǮL\Z\"gz', '>Z`ǮL\Z\"gz', 'Ǒ99[;U!/-I#Fr9z6\r3', '', 0, '?'),
 ('Ƒ(eSs9쓚', 'wp-content/themes/kallyas/images/macbook-air.svg', 0, 'hR2RZsL', 'hR2RZsL', 'xe6!rc}!kOʦc)-g', '', 0, '?'),
 ('\'\\T|;', 'wp-content/themes/kallyas/images/macbook.svg', 0, 'Cmcl0rY', 'Cmcl0rY', 'Z?_T4bEcN\\M!N6', '', 0, '?'),
 ('{E[2=6Ey.', 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-added-listing-dark.svg', 0, 'R~%&V\r\ZLc', 'R~%&V\r\ZLc', 'X\"dAL!fH9O?լ', '', 0, '?'),
 ('QzG!,MSR', 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-added-listing-light.svg', 0, ';eAr?Bo', ';eAr?Bo', 'sF8mK=NjbAB', '', 0, '?'),
 ('*A ҷ[r>', 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-listing-dark.svg', 0, '16&ǲxoZ1d', '16&ǲxoZ1d', 'PF4k;MB^c)\"a[ ', '', 0, '?'),
 ('^c)M`N', 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-listing-light.svg', 0, 'I2PKSfxnn', 'I2PKSfxnn', 't} X\'. :͎gL=', '', 0, '?'),
 ('\Z&Q^nMP', 'wp-content/themes/kallyas/images/products_listing_icons/ico-more-listing-dark.svg', 0, 'q&.ZkX', 'q&.ZkX', 'lԕǺ2N h\0/b(<TF ', '', 0, '?'),
 ('t闦à\rS[p\"', 'wp-content/themes/kallyas/images/products_listing_icons/ico-more-listing-light.svg', 0, '\\-s籙azڔ', '\\-s籙azڔ', 'RĮo5´;؋VDq', '', 0, '?'),
 (':BJ8p\Z0', 'wp-content/themes/kallyas/images/ring-alt.svg', 0, '#MnW3]x;', '#MnW3]x;', 'qalJHW&@0Ϊ-m', '', 0, '?'),
 ('3bMڃ', 'wp-content/themes/kallyas/images/select-arrow-dark.svg', 0, 'c|SAz_', 'c|SAz_', ' aJUۋZs8/sAp.$UE', '', 0, '?'),
 ('lL e', 'wp-content/themes/kallyas/images/select-arrow.svg', 0, 'J[{y', 'J[{y', '9@gq{k5EL5~M', '', 0, '?'),
 ('P\r@?v', 'wp-content/themes/kallyas/images/step-separator-dark.svg', 0, 'E,d9_r9LP)\Z', 'E,d9_r9LP)\Z', 'KvݛQ	`$L <c˅L', '', 0, '?'),
 ('$ou=6', 'wp-content/themes/kallyas/images/step-separator.svg', 0, '_ruva&', '_ruva&', 'RB0TQS/&B[+\'+_FQ', '', 0, '?'),
 ('Fs=7LwB2^', 'wp-content/themes/kallyas/inc/details-portfolio-fields.php', 0, ')h;֌bkt', ')h;֌bkt', '?ٱR洘J;8.8<۵k/IWڵV', '', 0, '?'),
 ('Ý_xnOJ', 'wp-content/themes/kallyas/inc/details-portfolio-related.php', 0, 'x`$@$', 'x`$@$', '\' %WqrUn4TA\\u', '', 0, '?'),
 ('	\nuȿ', 'wp-content/themes/kallyas/inc/details-portfolio.php', 0, 'HnOg^Dp', 'HnOg^Dp', '!5	,9+8v\"+\'', '', 0, '?'),
 ('~1OY\\4N', 'wp-content/themes/kallyas/inc/loop-portfolio-media.php', 0, 'd3jZM{', 'd3jZM{', '%\nfLf~>IV', '', 0, '?'),
 ('Յt舏\'qS', 'wp-content/themes/kallyas/inc/loop-portfolio_carousel.php', 0, 'go\0W	8m;', 'go\0W	8m;', ',\"YUmkFY5]3', '', 0, '?'),
 ('J\Z_0;Pѕ;', 'wp-content/themes/kallyas/inc/loop-portfolio_category.php', 0, '5Grd{tpb>', '5Grd{tpb>', '6^vܺ_IXZ[OA', '', 0, '?'),
 ('*O6=?G', 'wp-content/themes/kallyas/inc/loop-portfolio_category_item.php', 0, 'Zp>18Vԅ', 'Zp>18Vԅ', '&c[-N\n-6m^fAH\r2\n', '', 0, '?'),
 ('3bJwg>T', 'wp-content/themes/kallyas/inc/loop-portfolio_sortable.php', 0, '!,ܘ+&h89', '!,ܘ+&h89', 'Bam~IƓu5&?bќ)', '', 0, '?'),
 ('d/$q	f0#/', 'wp-content/themes/kallyas/inc/loop-portfolio_sortable_content.php', 0, 's\Z3^S\ni', 's\Z3^S\ni', ';sDOEo=(1y\'@Mmn', '', 0, '?'),
 ('n\\Rɵ{p', 'wp-content/themes/kallyas/inc/page-content-view-page.inc.php', 0, '{#r{I;<', '{#r{I;<', 'vbx(>hĀ{kM[', '', 0, '?'),
 ('-Q^Log', 'wp-content/themes/kallyas/inc/page-content-view-portfolio.inc.php', 0, 'Gw\Z}ɒkqM', 'Gw\Z}ɒkqM', 'IJngqXS6I\rE	9(', '', 0, '?'),
 ('0P/	6tRi', 'wp-content/themes/kallyas/inc/page-content-view-post.inc.php', 0, '{s.QCOjb', '{s.QCOjb', '0(<R%#zƌFWGGDF;', '', 0, '?'),
 ('iM\0B@', 'wp-content/themes/kallyas/inc/password-protected.inc.php', 0, 'RX5/9e]jl', 'RX5/9e]jl', '{=Є\'>GS(ʮ-V^t', '', 0, '?'),
 ('.rYV\0ȍK', 'wp-content/themes/kallyas/inc/single-product-template.php', 0, '=ݤpj', '=ݤpj', '.Q鶮eoi>rZԓZΨ', '', 0, '?'),
 ('	&\r/	d', 'wp-content/themes/kallyas/index.php', 0, 'vP@ŀ\0-', 'vP@ŀ\0-', 'v_xkw|fdFj]l7!', '', 0, '?'),
 ('Qwn65Lx', 'wp-content/themes/kallyas/js/plugins-src/debouncedresize.js', 0, 'ET4F{s', 'ET4F{s', 'Jfc,psJOFkd1[-a', '', 0, '?'),
 ('\0244D', 'wp-content/themes/kallyas/js/plugins-src/echo.js', 0, 'Ujc,8F>', 'Ujc,8F>', 'u*\Zb`d,}F', '', 0, '?'),
 ('85zJF', 'wp-content/themes/kallyas/js/plugins-src/fitvids.js', 0, 'W:5W\nn', 'W:5W\nn', '8I͔XǍ .l	Q|T', '', 0, '?'),
 ('bsWVd5B', 'wp-content/themes/kallyas/js/plugins-src/imagesloaded.pkgd.min.js', 0, 'H	/łߖMD', 'H	/łߖMD', 'bT6SJ>!+O\'\r|I;<ԾJ', '', 0, '?'),
 ('l\Zx([;A', 'wp-content/themes/kallyas/js/plugins-src/jquery.easing.js', 0, '弬y]1xgu', '弬y]1xgu', '.h!Dg%&KP	\0t\ng', '', 0, '?'),
 ('v&tX#L9AQ 5', 'wp-content/themes/kallyas/js/plugins-src/magnificPopup.js', 0, '-t=q\Zd\ZM', '-t=q\Zd\ZM', 'ؒRT.h/\"zqyfg', '', 0, '?'),
 ('-a;	5', 'wp-content/themes/kallyas/js/plugins.min.js', 0, 'b9`9C', 'b9`9C', '6z/!ٿBb2VkG<r@Ssb', '', 0, '?'),
 ('Y50}^', 'wp-content/themes/kallyas/js/znscript.js', 0, 'W\r\ZG4\Z', 'W\r\ZG4\Z', 'VR|eLM\']a0W_Jfڜ', '', 0, '?'),
 ('pɝ5<?', 'wp-content/themes/kallyas/js/znscript.min.js', 0, '%)q\0yD#^-.', '%)q\0yD#^-.', 'skV0b\"Z6qH;ϴ+1ZTf', '', 0, '?'),
 ('ef1QRC`O', 'wp-content/themes/kallyas/page-coming-soon.php', 0, 'gM(HC#', 'gM(HC#', '>\r1A&Cu҈~\\Q|w&F0', '', 0, '?'),
 ('(i^IPH', 'wp-content/themes/kallyas/page.php', 0, '%%ՁSwRt', '%%ՁSwRt', 'w1! Fkȿk#\\/', '', 0, '?'),
 ('\Z\\&98\r', 'wp-content/themes/kallyas/pagebuilder/elements/TH_3DCuteSlider/TH_3DCuteSlider.php', 0, '  Q+P?ĭ_b', '  Q+P?ĭ_b', '380:)\"m(Sg@sre\'J', '', 0, '?'),
 (')KA&.\'Q\'%', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Accordion/TH_Accordion.php', 0, '_eYL\n', '_eYL\n', 'V|_eG4$し\ZDd|7o', '', 0, '?'),
 ('ླGؐ[v', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Accordion/inc/ui.inc.php', 0, '2O5;5e', '2O5;5e', 'eB<v]\rkDR,MqjЅҷ', '', 0, '?'),
 (':]4;߻0', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ActionBox/TH_ActionBox.php', 0, '/*CCc`>\'', '/*CCc`>\'', 'ZRX);ei\00\"A?%uI\'If', '', 0, '?'),
 ('20Xl\n~3', 'wp-content/themes/kallyas/pagebuilder/elements/TH_BigSocial/TH_BigSocial.php', 0, 'v۾x2\Z-', 'v۾x2\Z-', 'R  x2@\0e}:R)ƍ\n%', '', 0, '?'),
 ('o[L+\nCo+gb', 'wp-content/themes/kallyas/pagebuilder/elements/TH_BlogArchive/TH_BlogArchive.php', 0, 'ՀZ3ތwI^u ', 'ՀZ3ތwI^u ', '^gW9x!3ǋ\'+5}P8hW', '', 0, '?'),
 (',b8]Ѯ7Ů', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Buttons/TH_Buttons.php', 0, '͋vb	h>B4g_', '͋vb	h>B4g_', 'ѭ{pv#WK2', '', 0, '?'),
 ('^f3r]D3j', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CSS3Panels/TH_CSS3Panels.php', 0, '$Y@9cRG,Z', '$Y@9cRG,Z', 'I0 \rJs<mы7#|:b\r', '', 0, '?'),
 (';dxX2<', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CallOutBanner/TH_CallOutBanner.php', 0, 'ZdJ$ Ln', 'ZdJ$ Ln', 'Q\r4iB߯%=i\'v0ZY̰{$', '', 0, '?'),
 ('2\rDk\')', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircleTitleTextBox/TH_CircleTitleTextBox.php', 0, 'ػH\nSAEg', 'ػH\nSAEg', 'b|jB:1}\ne_ORmL', '', 0, '?'),
 ('lʶ ޥP}', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularCatalogueCarousel/TH_CircularCatalogueCarousel.php', 0, 'wu\nQL', 'wu\nQL', '儺Db<<2%fB`:', '', 0, '?'),
 ('!ႁ̵N', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle1/TH_CircularContentStyle1.php', 0, '$VQ[ʙGϓ25', '$VQ[ʙGϓ25', '{\n+^eg:na>Hc', '', 0, '?'),
 ('$I\rP&+%$', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle1/inc/ui.inc.php', 0, 'i.^)6#8A', 'i.^)6#8A', 'ԛ`V+f%Mx', '', 0, '?'),
 ('茮HBb', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle2/TH_CircularContentStyle2.php', 0, '-%T', '-%T', '\"i׻+EҊSF4Jy~F?', '', 0, '?'),
 ('Phӆޅ/˳s4T', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle2/inc/ui.inc.php', 0, '$oAQH', '$oAQH', 'Ѭ\0F[d+\\pP?ZQwI K<R ', '', 0, '?'),
 ('E}xU\n=', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Comments/TH_Comments.php', 0, '<ʦ9|<O׳[', '<ʦ9|<O׳[', 'SOhK5&\'i2fQa\\JPv\Z?', '', 0, '?'),
 ('$Y䖙XDց`25', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Countdown/TH_Countdown.php', 0, 'w8RLZѾ\ZY9', 'w8RLZѾ\ZY9', '1?o뾏AR2<\rJk', '', 0, '?'),
 ('b*Oc|#Nԇ', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CustomMenu/TH_CustomMenu.php', 0, 'M,΢]\Z', 'M,΢]\Z', '\';\'\rS\ZvGwwQv', '', 0, '?'),
 ('X`\',ѵaK㊰', 'wp-content/themes/kallyas/pagebuilder/elements/TH_CustomSubHeaderLayout/TH_CustomSubHeaderLayout.php', 0, '\rmNp', '\rmNp', 'H6:{ErTv B/rWմa', '', 0, '?'),
 ('\\tHSמNff', 'wp-content/themes/kallyas/pagebuilder/elements/TH_DevicesImages/TH_DevicesImages.php', 0, '<b[-\Z', '<b[-\Z', '\\D|}u3ˍǡoTX.S=0~', '', 0, '?'),
 ('h5⽕i', 'wp-content/themes/kallyas/pagebuilder/elements/TH_DevicesImages/style.php', 0, '`dX', '`dX', '.CDH9dPNwe', '', 0, '?'),
 ('4дs63Y:N', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Documentation/TH_Documentation.php', 0, '&~)~ѕ', '&~)~ѕ', '=p+ s܋=a\" XYdUA', '', 0, '?'),
 ('@xHZ^E', 'wp-content/themes/kallyas/pagebuilder/elements/TH_DocumentationHeader/TH_DocumentationHeader.php', 0, 'F8Y\nAJ4+', 'F8Y\nAJ4+', 'f>!-㎉^J\\@LE\Zmvȣ', '', 0, '?'),
 ('<T\n3^', 'wp-content/themes/kallyas/pagebuilder/elements/TH_FancySlider/TH_FancySlider.php', 0, '}׵[u U', '}׵[u U', 'D*ll/RIax	ll', '', 0, '?'),
 ('zpCJۙ־>s', 'wp-content/themes/kallyas/pagebuilder/elements/TH_FeaturesBoxes/TH_FeaturesBoxes.php', 0, 'p,=0?8;\0', 'p,=0?8;\0', 'ŖZi;qEIˈ{^3z\\\r', '', 0, '?'),
 (',~Z@ٲ3|', 'wp-content/themes/kallyas/pagebuilder/elements/TH_FeaturesBoxes/inc/ui.inc.php', 0, '&j1ї?.Xj', '&j1ї?.Xj', 'mf6K\n.oӎ}ɒ^	e', '', 0, '?'),
 ('H2fe\n-{Ș', 'wp-content/themes/kallyas/pagebuilder/elements/TH_FeaturesBoxes2/TH_FeaturesBoxes2.php', 0, '\Zz\ZT^eHk', '\Zz\ZT^eHk', '5luН\r\\pLMC$}	!MD', '', 0, '?'),
 ('wO-(7o/{?c', 'wp-content/themes/kallyas/pagebuilder/elements/TH_FlexSlider/TH_FlexSlider.php', 0, 'a\nT!ka3C', 'a\nT!ka3C', 'w7Ρ\";3	,(0\'	\Zh8b', '', 0, '?'),
 ('ׅhMPVg', 'wp-content/themes/kallyas/pagebuilder/elements/TH_FlickrFeed/TH_FlickrFeed.php', 0, '#z|a', '#z|a', ')·_͍E)F|}x\n<', '', 0, '?'),
 ('3X7Vـ', 'wp-content/themes/kallyas/pagebuilder/elements/TH_GridPhotoGallery/TH_GridPhotoGallery.php', 0, ' ǽ=l', ' ǽ=l', 'sOiӔDxE^jZR#u~l', '', 0, '?'),
 ('\"ko\"0F', 'wp-content/themes/kallyas/pagebuilder/elements/TH_HistoricElement/TH_HistoricElement.php', 0, 'rv)Q', 'rv)Q', ':{\0k9$OUqK$m', '', 0, '?'),
 ('K*m5T\0*\n', 'wp-content/themes/kallyas/pagebuilder/elements/TH_HorizontalTabs/TH_HorizontalTabs.php', 0, '\Z]m gVD2', '\Z]m gVD2', 'La8d}naL󋸁I12', '', 0, '?'),
 ('/\0ʜ_dj4z', 'wp-content/themes/kallyas/pagebuilder/elements/TH_HoverBox/TH_HoverBox.php', 0, '^wd', '^wd', 'ER#!&!P	2kE.2', '', 0, '?'),
 ('YqW2&M+', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/TH_ICarousel.php', 0, 'Xf++\"VW', 'Xf++\"VW', 'kO\"`FjBn]f{>oN3}', '', 0, '?'),
 ('?kKπדa	?', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/assets/icarousel.packed.js', 0, 'a(e OrU', 'a(e OrU', '0>k\'|F1g֗nc*w-/', '', 0, '?'),
 ('ޠGSa@p', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/assets/jquery.mousewheel.js', 0, 'Lʛ_)e', 'Lʛ_)e', '2\'EtO\'\Z\r$xMՈ=;\r', '', 0, '?'),
 ('\"%U^麣', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/assets/raphael-min.js', 0, 'VIt@SkJ', 'VIt@SkJ', 'PGb]ts觼ߟO,', '', 0, '?'),
 ('1\"yϵvnJ]s-', 'wp-content/themes/kallyas/pagebuilder/elements/TH_IconBox/TH_IconBox.php', 0, 'rGEK&ߟjl', 'rGEK&ߟjl', '8-4`Cǅ\'+\r)Dn/*q', '', 0, '?'),
 ('(ٷgF./_', 'wp-content/themes/kallyas/pagebuilder/elements/TH_IconBoxesGrid/TH_IconBoxesGrid.php', 0, '37?{*3}0', '37?{*3}0', '-2!&#]]lv3~$\r0', '', 0, '?'),
 ('=gH>칏@0', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ImageBox/TH_ImageBox.php', 0, '\'Z2Јs3', '\'Z2Јs3', 'U2?s敘~a\'K3U8ē ', '', 0, '?'),
 ('}4>', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ImageBox2/TH_ImageBox2.php', 0, 'F=xD97', 'F=xD97', '4TiKK{3!KI8*ʆ', '', 0, '?'),
 ('=OV/%', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ImageGallery/TH_ImageGallery.php', 0, 'SzȦG2D', 'SzȦG2D', 'm>û6DlI(B3=', '', 0, '?'),
 ('DjN+Tb', 'wp-content/themes/kallyas/pagebuilder/elements/TH_InfoBox/TH_InfoBox.php', 0, 'DGz#', 'DGz#', 'fvfӸ7a}h\\CvL!Y', '', 0, '?'),
 ('l\nԔ3^O', 'wp-content/themes/kallyas/pagebuilder/elements/TH_InfoBox2/TH_InfoBox2.php', 0, 'v>~½_', 'v>~½_', 'sdޜ:v>ISeSGk', '', 0, '?'),
 ('ݩfϕ!t+n', 'wp-content/themes/kallyas/pagebuilder/elements/TH_IosSlider/TH_IosSlider.php', 0, '`6XJN|;x1', '`6XJN|;x1', 'Gb(ũ6:6vܮG	p{Wf{+pbg', '', 0, '?'),
 ('sވHjJ֗baA', 'wp-content/themes/kallyas/pagebuilder/elements/TH_IosSlider/inc/ui.inc.php', 0, 'E+W̍\'>28!', 'E+W̍\'>28!', '!b\\yBUu|4֣Aϐܣ[', '', 0, '?'),
 ('=\r|a4hNY!', 'wp-content/themes/kallyas/pagebuilder/elements/TH_IosSlider2/TH_IosSlider2.php', 0, '6a/m', '6a/m', '#XXZæ<y,/Sq<', '', 0, '?'),
 ('RH76,C', 'wp-content/themes/kallyas/pagebuilder/elements/TH_KeywordsElement/TH_KeywordsElement.php', 0, '-8Ȳ#XyT&', '-8Ȳ#XyT&', 'ez5Ֆ>A3=ZJ Ɠh', '', 0, '?'),
 ('۸הm`<VAD', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LaptopSlider/TH_LaptopSlider.php', 0, '\Z럧9}', '\Z럧9}', '1.I\\h暙)JW-O\0~', '', 0, '?'),
 ('K&f+N', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LaptopSlider/assets/macbook-air.svg', 0, 'hR2RZsL', 'hR2RZsL', 'xe6!rc}!kOʦc)-g', '', 0, '?'),
 ('7v\'2A\nA', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LaptopSlider/style.php', 0, '.F]\rp', '.F]\rp', '(Q)\\rՏ/iﭤJt', '', 0, '?'),
 ('Ԕp\nE;\'R', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts/TH_LatestPosts.php', 0, '6ȃN\Zۋt', '6ȃN\Zۋt', 'EES[*-oڧm\Z', '', 0, '?'),
 ('vɕeg', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts2/TH_LatestPosts2.php', 0, '5{o.&Xe]', '5{o.&Xe]', 'lN1ڭ#%gU%\\Qc\r6P', '', 0, '?'),
 ('*Zi(y8ů s', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts3/TH_LatestPosts3.php', 0, '}Uh |\r', '}Uh |\r', 'β{o\r||}>|A b', '', 0, '?'),
 ('AF/;0]]', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts4/TH_LatestPosts4.php', 0, 'tTBV-\'u', 'tTBV-\'u', ';C\\Daj]A려&==', '', 0, '?'),
 ('&\'Z<', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/default-style.php', 0, '^@x)xoDE=', '^@x)xoDE=', '*;\"D1z*Q-(@', '', 0, '?'),
 ('p}~3jcbp!', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/kl-style-2.php', 0, 'xŧcwh,', 'xŧcwh,', '/1QtGzGEE{:o[', '', 0, '?'),
 ('3\\[\'5$[', 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPostsCarousel/TH_LatestPostsCarousel.php', 0, 's5]', 's5]', ',Kyl㿞.ڈlQos\Zcg;', '', 0, '?'),
 ('H*+cm!}\'I', 'wp-content/themes/kallyas/pagebuilder/elements/TH_MediaContainer/TH_MediaContainer.php', 0, 'hw\'', 'hw\'', 'e\0{iEOzMP>45w_u', '', 0, '?'),
 ('_E\"Yxmp=kM', 'wp-content/themes/kallyas/pagebuilder/elements/TH_NewsletterBox/TH_NewsletterBox.php', 0, '5O~T}+Ս_q,', '5O~T}+Ս_q,', 'I.ο՘΍(Y%0M(cە', '', 0, '?'),
 ('b9bcJC', 'wp-content/themes/kallyas/pagebuilder/elements/TH_NivoSlider/TH_NivoSlider.php', 0, 'K::7<m', 'K::7<m', 'V_?v`2:^|6&\r', '', 0, '?'),
 ('\nIr</ī', 'wp-content/themes/kallyas/pagebuilder/elements/TH_NivoSlider/assets/jquery.nivo.slider.pack.js', 0, 'bױ\r', 'bױ\r', '[b҆):M:GH@', '', 0, '?'),
 ('V50CpKLm', 'wp-content/themes/kallyas/pagebuilder/elements/TH_NivoSlider/style.php', 0, '!W5t(', '!W5t(', ';FNG=\ZChtIϞ', '', 0, '?'),
 ('2A_=թ\\', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PageContent/TH_PageContent.php', 0, 'a\rȂ!&:D', 'a\rȂ!&:D', 'Z7?9^rӣH_m0', '', 0, '?'),
 ('K[<78', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PartnersLogos/TH_PartnersLogos.php', 0, '5(,m\\', '5(,m\\', '{HT8\n9n(/P', '', 0, '?'),
 ('yg~De߻e]J', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PartnersTestimonials/TH_PartnersTestimonials.php', 0, '}jlx@8i!', '}jlx@8i!', '(pRU?gcB9\\#,', '', 0, '?'),
 (';/XR$', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/TH_PhotoGallery.php', 0, 'nؼI<-r-\\', 'nؼI<-r-\\', 'zQ{h (VkPL2<[Um\Zx', '', 0, '?'),
 ('|u0&<Y', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/images/album-gallery.svg', 0, 'Ægʯ=/', 'Ægʯ=/', 'kq[jD/Ћe;ظY튬l', '', 0, '?'),
 ('$⽳L', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/images/normal-gallery.svg', 0, 'A>#\r1gG/', 'A>#\r1gG/', 'X}}\'8cH?UFe', '', 0, '?'),
 ('%U6̞!ą', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/images/slideshow-gallery.svg', 0, 'qJr&s-', 'qJr&s-', '(=dX\rKD?l$b<N[}', '', 0, '?'),
 ('bvoL]z', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhpCode/TH_PhpCode.php', 0, '$VMΌr', '$VMΌr', '\\==ecB\Zf9.tFj9vZ7', '', 0, '?'),
 ('P-> - ', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PortfolioArchive/TH_PortfolioArchive.php', 0, 'YWk\'Ɖ}/', 'YWk\'Ɖ}/', 'z?>ce-z\\m$5', '', 0, '?'),
 ('\0bKDk', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PortfolioContent/TH_PortfolioContent.php', 0, 'gcVu@ϖ', 'gcVu@ϖ', 'I[x13f-G8Fhw`', '', 0, '?'),
 ('4\rB=J', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PortfolioSlider/TH_PortfolioSlider.php', 0, 'P;}OOJjc', 'P;}OOJjc', 'H	f1Ѓ˿j.i%v%Sy #', '', 0, '?'),
 ('tEљż mA', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PostContent/TH_PostContent.php', 0, '`v6䜾Cm', '`v6䜾Cm', 'M	u52&;mzA_+M4J', '', 0, '?'),
 ('Gf\0', 'wp-content/themes/kallyas/pagebuilder/elements/TH_PricingTable/TH_PricingTable.php', 0, '*:q S|{>', '*:q S|{>', '[STfLSK^T<A^UH', '', 0, '?'),
 ('2:*.Q#w\0Yv', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ProductArchive/TH_ProductArchive.php', 0, 'AسE\076D', 'AسE\076D', '#z/%gBd', '', 0, '?'),
 ('/3 Tv8Q#', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ProductContent/TH_ProductContent.php', 0, '^O+t{', '^O+t{', 'L{y2yqrm	\'ҡ<ǉJ1', '', 0, '?'),
 ('B7]g(', 'wp-content/themes/kallyas/pagebuilder/elements/TH_RecentWork/TH_RecentWork.php', 0, 'r){nK\n:I', 'r){nK\n:I', 'G{s|9hUlT\0R))-', '', 0, '?'),
 ('E5D@ g{_', 'wp-content/themes/kallyas/pagebuilder/elements/TH_RecentWork2/TH_RecentWork2.php', 0, 'RXJ$v7;ݎd', 'RXJ$v7;ݎd', 'Qn%>A%,', '', 0, '?'),
 ('t๠&1&O', 'wp-content/themes/kallyas/pagebuilder/elements/TH_RecentWork3/TH_RecentWork3.php', 0, '/%Ew', '/%Ew', 'nUWT+8|?Udz\\O3', '', 0, '?'),
 ('\0@YMiV?Ew', 'wp-content/themes/kallyas/pagebuilder/elements/TH_RevolutionSlider/TH_RevolutionSlider.php', 0, '3T[\rw#Mi', '3T[\rw#Mi', 'qEa~\0Ĥ%M3[f', '', 0, '?'),
 ('hˤ/Q[,ur', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ScreenshotsBox/TH_ScreenshotsBox.php', 0, '\'db<+l', '\'db<+l', '7ͭn3B\0ّE-~S.>W5>ƅ', '', 0, '?'),
 ('76E̓a', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ScreenshotsBox/style.php', 0, '[1wh%)', '[1wh%)', 'eO(iKη5g#R\0rh', '', 0, '?'),
 ('E{ˑ;=td.R_', 'wp-content/themes/kallyas/pagebuilder/elements/TH_SearchBox/TH_SearchBox.php', 0, 'ׁ#\\{/׃|', 'ׁ#\\{/׃|', '\nfS7.qS%˸J24jTf9M', '', 0, '?'),
 ('2X;Ta\r|wk0', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ServiceBox/TH_ServiceBox.php', 0, ';%N%u\r ', ';%N%u\r ', '2:&LV4|c+ƭejB]8/', '', 0, '?'),
 ('xo2L', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ServicesElement/TH_ServicesElement.php', 0, '{:)\\^-xF9|', '{:)\\^-xF9|', '^Lz8	eW\nx.;%\'d]/-', '', 0, '?'),
 ('៾ftU1\0', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ShopFeatures/TH_ShopFeatures.php', 0, '#_)nfpsP', '#_)nfpsP', 'H	m[}DK!t:?f', '', 0, '?'),
 ('OGLҲԞ[', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ShopLimitedOffers/TH_ShopLimitedOffers.php', 0, 'vd9?-H\noLy', 'vd9?-H\noLy', 'd6;7I.DVzw\'\nȣq ', '', 0, '?'),
 ('K\"[	b)rs', 'wp-content/themes/kallyas/pagebuilder/elements/TH_ShopProductsPresentation/TH_ShopProductsPresentation.php', 0, 'k*h@zE/m', 'k*h@zE/m', 'c:s}OQtUi<~FtHE]', '', 0, '?'),
 ('1O3A`y\n', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Sidebar/TH_Sidebar.php', 0, ']L\n5~', ']L\n5~', 'jk\07VT͆6+i', '', 0, '?'),
 ('TV\\m2s7', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Skills/TH_Skills.php', 0, 'zg7+ptE', 'zg7+ptE', 'އ8hu1D|ʻ@>i:XЊ32Bj;', '', 0, '?'),
 ('_c.J2', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Skills/diagram_el.js', 0, '\Z\"', '\Z\"', 'F}ӊoBj :#ܐL', '', 0, '?'),
 ('44HvK\"SB', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Skills/raphael-min.js', 0, ')Wc~F', ')Wc~F', '=\0>F$Fpp5\n@x@P,\r.', '', 0, '?'),
 ('_ommj.N', 'wp-content/themes/kallyas/pagebuilder/elements/TH_SocialIcons/TH_SocialIcons.php', 0, '~DG', '~DG', 'wjlvt%<)u(9s{dPR', '', 0, '?'),
 ('$A&S\"̔%', 'wp-content/themes/kallyas/pagebuilder/elements/TH_SpacerElement/TH_SpacerElement.php', 0, 'QǓН;~3,', 'QǓН;~3,', 'H5pe׮M\'0bIލֳxS\nvb\r', '', 0, '?'),
 ('eV̊chUp)', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StageImageBox/TH_StageImageBox.php', 0, 'TŘ\nD:', 'TŘ\nD:', '[zG^D!)Kp:&lv', '', 0, '?'),
 ('Vd)L2̺', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentBoxes/TH_StaticContentBoxes.php', 0, 'pZuKa\rb', 'pZuKa\rb', '1Cw,ewAנv2\'F`dI', '', 0, '?'),
 ('aBz41_3', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentDefault/TH_StaticContentDefault.php', 0, '&wu/%Bu);', '&wu/%Bu);', 'H7m\nOD;4WqھN:tj	', '', 0, '?'),
 ('\'?+tp:\nЩL', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentEventCountdown/TH_StaticContentEventCountdown.php', 0, 'fuEZ|ï\"', 'fuEZ|ï\"', 'vMH9!bg?:O#o2$', '', 0, '?'),
 ('@1퉂', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentProductLoupe/TH_StaticContentProductLoupe.php', 0, '铳YRk', '铳YRk', '/dQ\\Ӿ8X,W{rt8;', '', 0, '?'),
 ('ɮo!BJ Hx	', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentReservationForm/TH_StaticContentReservationForm.php', 0, 'c4I/p.', 'c4I/p.', 'Ҧ>M\"-ѭKv4Sdqx3fI', '', 0, '?'),
 ('2kE\0il', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentShowroomCarousel/TH_StaticContentShowroomCarousel.php', 0, 'qJE	S~', 'qJE	S~', '7>(y5mEYHDw_\rFrhPr', '', 0, '?'),
 ('Sc͈B<Z', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentSimpleText/TH_StaticContentSimpleText.php', 0, 'N@j?,ߘ+\r$', 'N@j?,ߘ+\r$', '²\n&9Cl\\^E3!)', '', 0, '?'),
 (':_rO$0neN', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentSimpleTextFullWidth/TH_StaticContentSimpleTextFullWidth.php', 0, 'YDol1', 'YDol1', 'V{ݪswC7,ݰ)%Q)', '', 0, '?'),
 ('5Io)/c+', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentTextAndRegister/TH_StaticContentTextAndRegister.php', 0, 'Ƞ6sk(q\ZFY', 'Ƞ6sk(q\ZFY', '٨S,F?xS*z;¿؊(', '', 0, '?'),
 ('	Rmnq]?	?', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentTextAndVideo/TH_StaticContentTextAndVideo.php', 0, '\rH3jVD2I', '\rH3jVD2I', 'wOߪ{\"o	{*Sl', '', 0, '?'),
 ('bm\ngF', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentTextPop/TH_StaticContentTextPop.php', 0, '/`WM\"q', '/`WM\"q', 'EXruסqvߝ>|MB', '', 0, '?'),
 ('Gk1{oM', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentVideo/TH_StaticContentVideo.php', 0, '!Tp[V]<iQt', '!Tp[V]<iQt', '@;<ܿ9MA&A^`,', '', 0, '?'),
 ('Ҷ%zgXfn', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentVideoBackground/TH_StaticContentVideoBackground.php', 0, 'i{{F3z', 'i{{F3z', 'E)卂|SnVML	U.&', '', 0, '?'),
 ('<.踍', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/TH_StaticContentWeatherBox.php', 0, '×[a 7}\\^', '×[a 7}\\^', 'E!/hEQ\Zar:A_Z\Zj', '', 0, '?'),
 ('Jپio(', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/scwb.js', 0, '<qZ^I^i', '<qZ^I^i', 'q7tMY\\[', '', 0, '?'),
 ('@|qs', 'wp-content/themes/kallyas/pagebuilder/elements/TH_Statistics/TH_Statistics.php', 0, '>զ[:pSnp', '>զ[:pSnp', '<! /+iQ', '', 0, '?'),
 ('H*G=	\"', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StatsBox/TH_StatsBox.php', 0, '\ZIe7rwgq', '\ZIe7rwgq', 'eh@~8hVe({ֆ', '', 0, '?'),
 ('T$Cs2>v', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox/TH_StepsBox.php', 0, '}ׯh(_', '}ׯh(_', ')ѕ9zY4\\{gwH\nB.', '', 0, '?'),
 ('g^ō5\0ڡѾ=', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox2/TH_StepsBox2.php', 0, '75Sǫ5', '75Sǫ5', ';#7::F\')38AB', '', 0, '?'),
 ('}^g J', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox3/TH_StepsBox3.php', 0, '|8d$T)B', '|8d$T)B', 'OtwGGJ8[Ru	b?F|p=', '', 0, '?'),
 ('Q\ZjIv\rT', 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox4/TH_StepsBox4.php', 0, 'rF\Z Kr', 'rF\Z Kr', ' R)x\"ѮvvRO', '', 0, '?'),
 ('i@\nF+', 'wp-content/themes/kallyas/pagebuilder/elements/TH_TeamBox/TH_TeamBox.php', 0, 'o«b{|{<', 'o«b{|{<', 'gMlX{yZ$2E)dT*I', '', 0, '?'),
 ('[bڀzFJ%', 'wp-content/themes/kallyas/pagebuilder/elements/TH_TestimonialBox/TH_TestimonialBox.php', 0, '},!@t', '},!@t', '6L2/xqUhiGؾUuϢ', '', 0, '?'),
 ('sPn/=', 'wp-content/themes/kallyas/pagebuilder/elements/TH_TestimonialFader/TH_TestimonialFader.php', 0, 'njLњBSGx', 'njLњBSGx', 'ե\nիnillXRoUqr\\:z(\n\'', '', 0, '?'),
 ('.?Q', 'wp-content/themes/kallyas/pagebuilder/elements/TH_TestimonialSlider/TH_TestimonialSlider.php', 0, 'U)EnNS', 'U)EnNS', 'Wq`U]a/wbS]V<mA', '', 0, '?'),
 ('d&%|0_~	<\\}', 'wp-content/themes/kallyas/pagebuilder/elements/TH_TextBox/TH_TextBox.php', 0, 'gF\Zmj_J', 'gF\Zmj_J', 'Wy\n&Z\rbWv', '', 0, '?'),
 ('\"c7+6D#K', 'wp-content/themes/kallyas/pagebuilder/elements/TH_TitleElement/TH_TitleElement.php', 0, 'GW)5B0', 'GW)5B0', '+#uO`ܟ3ud @?ƻ,(Ľv-', '', 0, '?'),
 ('s$tl,\ZB^', 'wp-content/themes/kallyas/pagebuilder/elements/TH_VerticalTabs/TH_VerticalTabs.php', 0, 'nPTq>1`vvA', 'nPTq>1`vvA', 'ITC\"wY2E*,*.§', '', 0, '?'),
 ('u72\r8#NMt', 'wp-content/themes/kallyas/pagebuilder/elements/TH_VideoBox/TH_VideoBox.php', 0, 'Kcn%5h', 'Kcn%5h', 'G.Ax@WVM\0\n*T<q,lba', '', 0, '?'),
 ('/v0HL-ﯵ_', 'wp-content/themes/kallyas/pagebuilder/elements/TH_WowSlider/TH_WowSlider.php', 0, 'eiY3Ƶ ', 'eiY3Ƶ ', 'd\nwO#$.	߯>P!+Q', '', 0, '?'),
 ('~qH>rbB\0', 'wp-content/themes/kallyas/pagebuilder/elements/TH_WowSlider/assets/wowslider.js', 0, 'fv[~N0rGݼe', 'fv[~N0rGݼe', '/VDՕH@W\"u+{ʝ	5)h', '', 0, '?'),
 ('Iq>BqS_q', 'wp-content/themes/kallyas/pagebuilder/elements/TH_WowSlider/style.php', 0, '%Oe؎Hb', '%Oe؎Hb', 'Rգ\'}>oDdeg4j&yw', '', 0, '?'),
 ('[W滂ee$', 'wp-content/themes/kallyas/pagebuilder/elements/anchor_point/anchor_point.php', 0, 'Nmv\'r', 'Nmv\'r', 'bK!i\rA	ͻ7Ӝ0j=kr', '', 0, '?'),
 ('7x#zu/-Y', 'wp-content/themes/kallyas/pagebuilder/elements/button/button.php', 0, '}}SSG3', '}}SSG3', '֫*Bf;\n`fN[w7σrQ&', '', 0, '?'),
 ('YW~>5u4|H', 'wp-content/themes/kallyas/pagebuilder/elements/column/column.php', 0, 'XɁ ŗ', 'XɁ ŗ', 'HgLFb8Zbu 5lPie', '', 0, '?'),
 ('*8Y(', 'wp-content/themes/kallyas/pagebuilder/elements/contact_form/cf-template.php', 0, 'VzQ}c	_2\0', 'VzQ}c	_2\0', 'ެZ,4SIFc-@ŞU', '', 0, '?'),
 ('3iW0莹 $', 'wp-content/themes/kallyas/pagebuilder/elements/contact_form/contact_form.php', 0, '\"ԆR.ԼA', '\"ԆR.ԼA', 'BP#,36gbZGTS0M9J', '', 0, '?'),
 ('g=ZC', 'wp-content/themes/kallyas/pagebuilder/elements/custom_container/custom_container.php', 0, '֒\Z	:Qy', '֒\Z	:Qy', 'qj>lT6`SbF w(D', '', 0, '?'),
 ('UoYwq#MF?⠡', 'wp-content/themes/kallyas/pagebuilder/elements/custom_html/custom_html.php', 0, ',3am\0SB', ',3am\0SB', 'h,>U\"ľĺkZ.]\r_0', '', 0, '?'),
 ('{@pcrm)', 'wp-content/themes/kallyas/pagebuilder/elements/google_map/assets/gmaps.js', 0, '	棶QX -<&', '	棶QX -<&', '<z][AZV T0B.ViP', '', 0, '?'),
 ('hW}m7', 'wp-content/themes/kallyas/pagebuilder/elements/google_map/assets/markerclusterer.js', 0, 'FLVn!k=k', 'FLVn!k=k', 'svCh>eʴ\n9p?JQ\nCޛ/>', '', 0, '?'),
 ('/\Z1', 'wp-content/themes/kallyas/pagebuilder/elements/google_map/google_map.php', 0, ';$m{ޡY+B', ';$m{ޡY+B', 'aUHmAn3l᭢Tzs\ZIJ', '', 0, '?'),
 ('	EQ[@hNP	', 'wp-content/themes/kallyas/pagebuilder/elements/list/list.php', 0, 'q^|O', 'q^|O', '\\\'ro5\0})}J_\ZԴX\ZI', '', 0, '?'),
 (')osų<', 'wp-content/themes/kallyas/pagebuilder/elements/multi_layered/multi_layered.php', 0, '߹L8ad', '߹L8ad', 'u©_&-9\'2&2(YWj\r=f', '', 0, '?'),
 ('r@7۷\Z[M+', 'wp-content/themes/kallyas/pagebuilder/elements/pb_template/pb_template.php', 0, '?񄚡w', '?񄚡w', 'PbN]qCIj԰>oRn(H^', '', 0, '?'),
 ('m4gf&OD', 'wp-content/themes/kallyas/pagebuilder/elements/price_list/price_list.php', 0, 'tz;BC,O', 'tz;BC,O', 'H}\0AgtdJ$  T#XpC', '', 0, '?'),
 ('(296#qm', 'wp-content/themes/kallyas/pagebuilder/elements/section/section.php', 0, '{Y?{z;', '{Y?{z;', '#+hFv\\GdTP(s;=P', '', 0, '?'),
 ('xcs*;ʌ', 'wp-content/themes/kallyas/pagebuilder/elements/separator/separator.php', 0, 'qGѮ㑭6c', 'qGѮ㑭6c', '#HکGX]޶|', '', 0, '?'),
 ('5]/YҝDl7', 'wp-content/themes/kallyas/pagebuilder/elements/skill-bars/skill-bars.php', 0, 'eK\Zy	\'L', 'eK\Zy	\'L', '\\Ejĝ+lTJKy\0', '', 0, '?'),
 ('3lcNtbJ', 'wp-content/themes/kallyas/pagebuilder/elements/smart_carousel/smart_carousel.php', 0, 'L$>iv0h', 'L$>iv0h', 'g)\"}͌q_/C9<-}U<', '', 0, '?'),
 ('q˚6X6E=', 'wp-content/themes/kallyas/pagebuilder/elements/smart_slider/options.inc.php', 0, 'zPH	pD', 'zPH	pD', '#p#&]#+ ', '', 0, '?'),
 ('TBmՕȷ?', 'wp-content/themes/kallyas/pagebuilder/elements/smart_slider/smart_slider.php', 0, 'qoh$Rai^;', 'qoh$Rai^;', 'T\'S.#wrl^yW\rLܱԥ?', '', 0, '?'),
 ('S(ҬQLd+', 'wp-content/themes/kallyas/pagebuilder/elements/sticky_section_lite/sticky_section_lite.php', 0, '稌د6XBG@u}', '稌د6XBG@u}', 'C{%_/VrOʹͫJLڤ', '', 0, '?'),
 ('\'\n<i;=B}', 'wp-content/themes/kallyas/pagebuilder/elements/tweetbox/tweetbox.php', 0, 'Na%Bt', 'Na%Bt', '&J^O#3Hl1o։d', '', 0, '?'),
 ('rnʎkVOT', 'wp-content/themes/kallyas/pagebuilder/elements/widget/options.php', 0, '+*>h#eS', '+*>h#eS', 'jĖq{RjDhYK8>YgӋ1y', '', 0, '?'),
 ('?+NsQC', 'wp-content/themes/kallyas/pagebuilder/elements/widget/widget.php', 0, '=F|Sb09', '=F|Sb09', '2s yU	@1GUmht', '', 0, '?'),
 ('ϯ-]NL\Z|Q*', 'wp-content/themes/kallyas/search.php', 0, 'ລdߑ/&K', 'ລdߑ/&K', 'ԭX6l2~C]\"֎P=i@', '', 0, '?'),
 ('Afo3B&(~', 'wp-content/themes/kallyas/searchform.php', 0, ' ?', ' ?', 'xm\Z&G)%i8`X{1wO', '', 0, '?'),
 ('T-8&-be', 'wp-content/themes/kallyas/sidebar.php', 0, 'ܪ7P', 'ܪ7P', '/\Z ͗Ӆ\0kY~<ؒ\r)dv', '', 0, '?'),
 ('$<q\0vh{', 'wp-content/themes/kallyas/single-documentation.php', 0, 'Í$1vU|y', 'Í$1vU|y', 'hpNwBEƶ!Ƹ?p`UR', '', 0, '?'),
 ('QG\n', 'wp-content/themes/kallyas/single-portfolio.php', 0, '01eƨn', '01eƨn', 'o>8c7UFCݽ˛tM)\\', '', 0, '?'),
 ('N$oNBtGW6l', 'wp-content/themes/kallyas/single.php', 0, '͎(yon', '͎(yon', 'rw-0e=7fLɧA@', '', 0, '?'),
 ('ҡe[sT	\\ۘ', 'wp-content/themes/kallyas/taxonomy-documentation_category.php', 0, '_J7b\nK֠=u', '_J7b\nK֠=u', 'r7))\ZK`yv%', '', 0, '?'),
 ('I*\Zt4A', 'wp-content/themes/kallyas/taxonomy-project_category.php', 0, '`ln@\\CY', '`ln@\\CY', '%\rL++懝ً\0KOU>ldVӥ-', '', 0, '?'),
 ('4>Ync(Э\n', 'wp-content/themes/kallyas/template_helpers/helper-functions.php', 0, 'PVd&|Zѿi', 'PVd&|Zѿi', 'gqBD.Wץdwk0[r', '', 0, '?'),
 ('C6Sdby62', 'wp-content/themes/kallyas/template_helpers/icons/glyphicons_halflingsregular/glyphicons_halflingsregular.svg', 0, '!Fhey#-e[', '!Fhey#-e[', '$6`|y+^	8c%k', '', 0, '?'),
 ('vNEC', 'wp-content/themes/kallyas/template_helpers/icons/glyphicons_halflingsregular/icon_list.php', 0, 'dh:\Z.S &g', 'dh:\Z.S &g', 'g?x[EbƜ{ǛejN4', '', 0, '?'),
 ('4ȹkJɽ,', 'wp-content/themes/kallyas/template_helpers/icons/kl-social-icons/icon_list.php', 0, 'ִCBe6', 'ִCBe6', '܏[&T]692{,s膐j,', '', 0, '?'),
 ('?ML', 'wp-content/themes/kallyas/template_helpers/icons/kl-social-icons/kl-social-icons.svg', 0, 'װt\0iMY\Z', 'װt\0iMY\Z', '¦S3a^r>\n`MlT{4dq', '', 0, '?'),
 ('\n$1fxp!Q', 'wp-content/themes/kallyas/template_helpers/metaboxes/metaboxes.php', 0, 'N\0g%', 'N\0g%', 'qU>o	^0Cϥ쯇b', '', 0, '?'),
 ('_镃y\'', 'wp-content/themes/kallyas/template_helpers/metaboxes/metaboxes_locations.php', 0, '%Sk/?w', '%Sk/?w', '~&PpaEi\nUlq', '', 0, '?'),
 ('RL}XPO@', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/404-page-options.php', 0, ',\n`:Mj', ',\n`:Mj', 'pk@7?wTnqY', '', 0, '?'),
 ('yފϦUc ', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/advanced-options.php', 0, 'TjRk	', 'TjRk	', '`p3ѶA4=[|h68 ;AAg4Q', '', 0, '?'),
 ('d~~.n}&\'.', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/blog-options/archive-options.php', 0, 'HT.r\\T)', 'HT.r\\T)', '5Qڮ%^Z|NBJ:Zb$Z', '', 0, '?'),
 ('69:ܚcޮM', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/blog-options/single-blog-item-options.php', 0, 'e.\\fǔukw', 'e.\\fǔukw', 'Yh[j8A[u\'Ѣ!(#', '', 0, '?'),
 ('Ɲ\0ѫk', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/color-options/color-options-palette.php', 0, 'R^O^ʟA)1I', 'R^O^ʟA)1I', 'Lnd(9<DI;d)', '', 0, '?'),
 ('$@\n,wq(=', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/color-options/color-options.php', 0, '%\0{eb(', '%\0{eb(', 'oՅ7r]W{_gk;^ivtU|', '', 0, '?'),
 ('isp3w`\rM', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/coming-soon-options.php', 0, 'miF\n7eH', 'miF\n7eH', 'ϔ[-L?QA,_bfGd', '', 0, '?'),
 ('XIڞwhӺϚm', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/documentation-options.php', 0, 'Yc)~38ẃz', 'Yc)~38ẃz', '!AeR)ʥ]5ypk4(J`\'EWn', '', 0, '?'),
 ('NWB^GC&Db2`', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/alternative-font-options.php', 0, 'L4Gn`P%s', 'L4Gn`P%s', 'ñt\\$\":a>EQ', '', 0, '?'),
 ('ɭ=ڲh`._7', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/body-fonts-options.php', 0, '%[3a8h', '%[3a8h', 'X/AZK 0	d͈ш', '', 0, '?'),
 (' 1g	\ZTh', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/general-font-options.php', 0, 'Y%C%DBB', 'Y%C%DBB', '97\\Tp&WmLcC=W\Zwh\\', '', 0, '?'),
 ('Un9Lap}', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/headings-options.php', 0, 'V5l>\r\0', 'V5l>\r\0', '#;̪2Qnwa2O|N\nV\nk', '', 0, '?'),
 ('D0۷JD#%w', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/main-menu-font-options.php', 0, '?Ri зh3NC=', '?Ri зh3NC=', 'I$t-G7B\ZI2Zfoo', '', 0, '?'),
 ('/*M%5W', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/cta-options.php', 0, 'f\0j0P', 'f\0j0P', 't*\r|\rsT&7?.tF3', '', 0, '?'),
 ('\nӓ_p', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/default-header-options.php', 0, 'X\n՜SAc~', 'X\n՜SAc~', '\' ̱$FgE ~39', '', 0, '?'),
 ('pj9H>', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/footer-options.php', 0, '$+\rd4 ', '$+\rd4 ', '_wqP\n#<Xy[6a\\fF', '', 0, '?'),
 (';ĩ?Kn\0', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/general-options.php', 0, 'ltC?v!^O', 'ltC?v!^O', 'mPye[KKUÌB>$s', '', 0, '?'),
 ('J7g$0NK', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/google-analytics-options.php', 0, '#@4߭Ϳ%q', '#@4߭Ϳ%q', 'hcMQ,d\ZA?9', '', 0, '?'),
 ('H[w_v}hr', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/google-maps-options.php', 0, '0a7F6EE', '0a7F6EE', '<dQxF\nRg|\")[<h', '', 0, '?'),
 ('/]#5CZѥ', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/header-advanced-options.php', 0, 'OhX\r<ٹXl', 'OhX\r<ٹXl', 'Z-1+qWn!JZ5eOWG', '', 0, '?'),
 ('H:SQ	1H yF', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/header-options.php', 0, '¿͵\'9LF.', '¿͵\'9LF.', '1~\0zi6\rY@', '', 0, '?'),
 ('ѿ)t1\\BMb', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/infocard-options.php', 0, 'X\Zs~D', 'X\Zs~D', 'Т\0TDA5	K%JlKQAp(<~V', '', 0, '?'),
 ('xjcSWqf!9', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/logo-options.php', 0, 'PW[g3', 'PW[g3', 'i	m]N\nQ\r&)EzGЕ1i', '', 0, '?'),
 ('|L,W\Z±3', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/nav-options.php', 0, 'c(n0VVnE', 'c(n0VVnE', 'zk71#)Cƺ&_LչҴ\rV', '', 0, '?'),
 ('\\.qfv', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/recaptcha-options.php', 0, ']\'s{E>σW', ']\'s{E>σW', 'ô\\%DweOwE\"H@@T', '', 0, '?'),
 ('q#V\\sd', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/layout-options.php', 0, ',\\\nv\"', ',\\\nv\"', 'c˹S^nL/T9tk$', '', 0, '?'),
 ('r佩#5#jج', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/pb-templates.php', 0, 'D*aED}', 'D*aED}', 'UMmT,؄ԗmkaYX_', '', 0, '?'),
 ('WW~e', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/portfolio-options.php', 0, ' Kv1', ' Kv1', '\\	)ɦD.K>\"\n6b}YS', '', 0, '?'),
 ('TlXz\'tϥ', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/unlimited-headers-options.php', 0, '֎>\0䀟E8', '֎>\0䀟E8', '~0!#i33Hw;p', '', 0, '?'),
 ('aD$_^@', 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/unlimited-sidebars.php', 0, '|o᝹WE', '|o᝹WE', '0T§1z>@(`+Eῇtk', '', 0, '?'),
 ('e:}fz', 'wp-content/themes/kallyas/template_helpers/options/theme-options.php', 0, 'r?\r%', 'r?\r%', 'WbNQėw76S%J׻3fxN\r', '', 0, '?'),
 ('EiVvM13', 'wp-content/themes/kallyas/template_helpers/options/theme-pages.php', 0, 'рg	se%	', 'рg	se%	', '{<։eg69', '', 0, '?'),
 ('(gSN~M', 'wp-content/themes/kallyas/template_helpers/pagebuilder/page_options.php', 0, '-`~_d)~S', '-`~_d)~S', '{@/\"ܺUɦ\"+BtЮ`', '', 0, '?'),
 ('KssS	]&_Ϙ', 'wp-content/themes/kallyas/template_helpers/pagebuilder/pagebuilder-animations.php', 0, 'I$(8\0', 'I$(8\0', '|d^L8c*l80W', '', 0, '?'),
 ('MNI Yh', 'wp-content/themes/kallyas/template_helpers/pagebuilder/pagebuilder-functions.php', 0, ')\r/Q', ')\r/Q', 'a(,¥SCS1\ry%AT){', '', 0, '?'),
 ('\0ӌ8YPɊ', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/ht_year.php', 0, '[C`wVn\'m', '[C`wVn\'m', 'g,S17BNԝ_T4ݵ', '', 0, '?'),
 ('Q5?GkQn', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_accordion.php', 0, 'uU2UV', 'uU2UV', '\'Ő\0a\'eTcI$ncE\0[r', '', 0, '?'),
 ('LTd׌ 9', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_accordion_container.php', 0, '-}[~;!cDрl', '-}[~;!cDрl', '|X`t\"]()r6@Q', '', 0, '?'),
 ('3AОg', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_accordion_panel.php', 0, '8CZE[hY\\<', '8CZE[hY\\<', '\rX`ZJ&Cz#~WHin&', '', 0, '?'),
 ('\"u}C\02̣\"', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_script_shortcode.php', 0, 'z&e5PzLN', 'z&e5PzLN', 'lfRRDbbhgX+GGWJ', '', 0, '?'),
 ('L1x9瀦j', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_blockquote.php', 0, ' .i|~8	9', ' .i|~8	9', 'yL xWٸ8;', '', 0, '?'),
 ('#~2<Ϋ', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_buttons.php', 0, 'ϗůCi^v_<', 'ϗůCi^v_<', 'bɋg=0$)љS&L|O=]Ui', '', 0, '?'),
 (']g^aq[BoN', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_code.php', 0, 'o9ȲADS', 'o9ȲADS', 'ałan#Maٺg_O\09_', '', 0, '?'),
 ('8n?6', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_column.php', 0, '-Ѥ@]', '-Ѥ@]', 'lS]%yxk\ZU5\Z^L0pf!', '', 0, '?'),
 ('/5\\O\0A', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h1a.php', 0, 'lsM)d*{D', 'lsM)d*{D', 'cc~2\\F^I/ڿm[4}G', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('Ga27wP', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h2a.php', 0, 'x[y eqan 4', 'x[y eqan 4', ' =/g3rF#1/.1M\'Azd', '', 0, '?'),
 ('8]n\0C٥0gc', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h3a.php', 0, '脃ָ5\01֬', '脃ָ5\01֬', 'zgrwd8IZR\0Py', '', 0, '?'),
 ('&\"t+H', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h4a.php', 0, 'kWR3*#7\nfw', 'kWR3*#7\nfw', 'm86fA~Tɠ%t۳mxcM\r`', '', 0, '?'),
 ('cLWO6;nKd\r(', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h5a.php', 0, 'ƽ~R@=u', 'ƽ~R@=u', 'DxCHۧ[[uukzAI͂', '', 0, '?'),
 ('y\ZsCLG<K7e', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h6a.php', 0, 'a	M8^', 'a	M8^', '5i<cs(&<颒6ʟ=fA', '', 0, '?'),
 ('6^\rH`[', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_icons.php', 0, 'zc	q7Xiߙ', 'zc	q7Xiߙ', '@B:s+76w;\'Ӟ,', '', 0, '?'),
 ('M)#w(', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_list.php', 0, 'kA֗)$	Qdz', 'kA֗)$	Qdz', '	CrVgug`,wů/', '', 0, '?'),
 ('q۳M D', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_one_fourth_columns.php', 0, 'D3\\B\"-_w7', 'D3\\B\"-_w7', 'ԅ?ǽaR;/;mY', '', 0, '?'),
 ('OVoj:05a(', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_caption.php', 0, '_gezL-Kk', '_gezL-Kk', '(u\\\0Jyh`X/1$hPv~', '', 0, '?'),
 ('PׂАl:Z', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_column.php', 0, 'S-\\UP`;5', 'S-\\UP`;5', '>`Zv[[M]>', '', 0, '?'),
 ('}8Z-7g', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_table.php', 0, '!g2sɏn', '!g2sɏn', '4^ACi~g-KG1Y[)3', '', 0, '?'),
 ('%(\\8', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_qr.php', 0, '&	rqnvs9I', '&	rqnvs9I', '̪:%PB۴X)UrR:us', '', 0, '?'),
 ('	W3/2o', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_row.php', 0, 'R>BÀ |[SU', 'R>BÀ |[SU', '6ӭ2LrXj\0P	{', '', 0, '?'),
 ('y9E0u%4', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_sitemap.php', 0, 'YB\'qi\\', 'YB\'qi\\', 'j`|clv\0dNw0`	A)', '', 0, '?'),
 ('I.tפm{_', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skill.php', 0, 's[m6I+', 's[m6I+', '\"Oa,)1D?+*\ZQ˹0a', '', 0, '?'),
 ('Q_I#ms', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skills.php', 0, 'G1#A(w;\"', 'G1#A(w;\"', '(Ir[\rM{7ô', '', 0, '?'),
 ('rE	\0]<+a', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_social_share_icons.php', 0, '߳oG՝}\rO', '߳oG՝}\rO', ' ăH>}>8.;!y5&mg+dY', '', 0, '?'),
 ('LLXO\r/', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_subtitle.php', 0, '\n@ぽ^', '\n@ぽ^', '^5٘fUMB4g!7dO@=@0', '', 0, '?'),
 ('0tS*ݴb-', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tab.php', 0, '@m&IM#*!o\0R', '@m&IM#*!o\0R', '3[\'c8әw!TN0l#', '', 0, '?'),
 ('R6erv', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_table.php', 0, 'xp|す^', 'xp|す^', '_Wm]6$kWϘ_̏6)', '', 0, '?'),
 ('5Ql-,8', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tabs.php', 0, 'ԑ6^=|', 'ԑ6^=|', '-B.-ʰ`\nzlߡpVs4U\")O\'', '', 0, '?'),
 ('+iюO%Dջ', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_columns.php', 0, 'g:~\"mfBW', 'g:~\"mfBW', 'g(J77u}BcކXm', '', 0, '?'),
 ('`\\ZMut`', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_fourth_columns.php', 0, 'MxV<!', 'MxV<!', 'H٠~}#k42)`*$v1!G,', '', 0, '?'),
 ('h2Ǻ{ϫ!6E', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tooltip.php', 0, '%عN,ƋݱA', '%عN,ƋݱA', 'Q0.HDua|8Hhj4', '', 0, '?'),
 ('okc2:O', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_columns.php', 0, ' ܍)Xe#[', ' ܍)Xe#[', 'M(us\\ں33I档', '', 0, '?'),
 ('bwpŶD)T2(', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_third_columns.php', 0, ':ȜG[Q͑b', ':ȜG[Q͑b', '^\'#ΊƏߠ*cU', '', 0, '?'),
 ('NN[{pV3B', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_znhg_qr.php', 0, '0T0+߆q', '0T0+߆q', '%^/[ԋ\nSNy_	X7\r32/9', '', 0, '?'),
 ('\0O\0A1\0', 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/znhg_alternative_header.php', 0, 'זp9E', 'זp9E', 'yٟY_ENH?D|l', '', 0, '?'),
 ('D ryȼ', 'wp-content/themes/kallyas/template_helpers/shortcodes/shortcodes.php', 0, 'ٮrTE]', 'ٮrTE]', 'F9a#܄uN0\nQ*\r', '', 0, '?'),
 ('VEȏEQ^', 'wp-content/themes/kallyas/template_helpers/termmeta/termoptions.php', 0, 'o7}LEd', 'o7}LEd', 'kpq5\"oACZiZtޞ', '', 0, '?'),
 ('= Q/Pk٧', 'wp-content/themes/kallyas/template_helpers/theme_layout_manager.php', 0, '+~aE1<', '+~aE1<', 'X΁qI)PbRRO#iUߋ\0G\n', '', 0, '?'),
 ('QbeWekCS', 'wp-content/themes/kallyas/template_helpers/tweeter-helper.php', 0, '?払_b^', '?払_b^', 'OZ^8AY*ZWs_hI', '', 0, '?'),
 ('ٕYd', 'wp-content/themes/kallyas/template_helpers/update/scripts/kallyas-update-4.0.0.php', 0, 'y3ږ&Kp0', 'y3ږ&Kp0', ';Ur~<1ᇜt|MF+\ZMgH\r~.', '', 0, '?'),
 ('HyoiNlC$u۩', 'wp-content/themes/kallyas/template_helpers/update/update_config.php', 0, '\n=$櫻^', '\n=$櫻^', '|q:\'\0Ssh]7Be@Q', '', 0, '?'),
 (';5@b[', 'wp-content/themes/kallyas/template_helpers/vendors/general/general-vendor.php', 0, 'δA@JL<>', 'δA@JL<>', 'm&{Ͳl\0wx:}', '', 0, '?'),
 ('*0ˮk͑hi', 'wp-content/themes/kallyas/template_helpers/vendors/geo-directory/functions-geo-directory.php', 0, '!c_uo', '!c_uo', 'n3T{{eb\'QɾZ<.CH0', '', 0, '?'),
 ('HHs', 'wp-content/themes/kallyas/template_helpers/vendors/hogash-post-love/config.php', 0, 'z\rc\ZTI*da', 'z\rc\ZTI*da', 'SMv4*כSskw', '', 0, '?'),
 ('t71[暩t', 'wp-content/themes/kallyas/template_helpers/vendors/sensei/functions-sensei.php', 0, '\'[H\nKJ܊', '\'[H\nKJ܊', '.b>\n:|xӳ꿄і', '', 0, '?'),
 ('_;<jmQ', 'wp-content/themes/kallyas/template_helpers/vendors/simple-job-board/functions-sjb.php', 0, 'QKuf\Z', 'QKuf\Z', 'aM+P@	|Uj|6Ӌ\0(', '', 0, '?'),
 ('SRRsU@@', 'wp-content/themes/kallyas/template_helpers/vendors/wp-hotel-booking/wp-hotel-booking.php', 0, '\03', '\03', '6\\vZx%ߪ#V', '', 0, '?'),
 ('Pet7@OC\0Nu~', 'wp-content/themes/kallyas/template_helpers/widgets/twitter/OAuth.php', 0, '-M݋E}a', '-M݋E}a', 'IoXEh_NF$NT68#', '', 0, '?'),
 ('y6K5S', 'wp-content/themes/kallyas/template_helpers/widgets/twitter/twitteroauth.php', 0, '#SO4TcOP', '#SO4TcOP', '9[\'$2Ȗs\'@{@=r', '', 0, '?'),
 ('Vso Bl', 'wp-content/themes/kallyas/template_helpers/widgets/widget-archive.php', 0, '%ذ3g&', '%ذ3g&', ')j҃{[j)SRhXiC;', '', 0, '?'),
 ('9/F7\"\ZBv', 'wp-content/themes/kallyas/template_helpers/widgets/widget-blog-categories.php', 0, '+v,RW64\\nύ', '+v,RW64\\nύ', 'Fӧ6FiH?*$R\ZO', '', 0, '?'),
 ('D\rՍW)', 'wp-content/themes/kallyas/template_helpers/widgets/widget-contact-details.php', 0, 'd@)D#;', 'd@)D#;', ',Ǉ-ߠ]XAwC\rvj(\0', '', 0, '?'),
 ('i\'ZԃnN7', 'wp-content/themes/kallyas/template_helpers/widgets/widget-flickr.php', 0, ':\nn\0X', ':\nn\0X', 'Tr=rL[vɃd5D', '', 0, '?'),
 ('Iٓ)Jy', 'wp-content/themes/kallyas/template_helpers/widgets/widget-latest_posts.php', 0, 'p2Jϣ', 'p2Jϣ', 'x*N2&VFln:b8', '', 0, '?'),
 ('֘>4suﾱ2}', 'wp-content/themes/kallyas/template_helpers/widgets/widget-mailchimp.php', 0, '-qsU_a@k\\', '-qsU_a@k\\', '!:J9I*8wPGx\r\ZN&', '', 0, '?'),
 ('t4K#f', 'wp-content/themes/kallyas/template_helpers/widgets/widget-menu.php', 0, '{:G\\3쪐', '{:G\\3쪐', 'N8y[r#^B1e_B$', '', 0, '?'),
 ('\ZBE<*lF', 'wp-content/themes/kallyas/template_helpers/widgets/widget-social_buttons.php', 0, 'lG=49$p', 'lG=49$p', 'IAj6z܈Dlb	,y|Lr', '', 0, '?'),
 ('ᮕRwVM^M', 'wp-content/themes/kallyas/template_helpers/widgets/widget-tag-cloud.php', 0, 'ɲQZy`x:', 'ɲQZy`x:', '}cop%!m}T~H>{', '', 0, '?'),
 ('iԿh˴XY5-,', 'wp-content/themes/kallyas/template_helpers/widgets/widget-twitter.php', 0, 'fyS-z', 'fyS-z', 'X-Zs$\'9?U3', '', 0, '?'),
 ('%+!vqn', 'wp-content/themes/kallyas/template_helpers/widgets/widgets.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('	|xGTAO', 'wp-content/themes/kallyas/template_helpers/zion-integration/class_kallyas_integration.php', 0, '}j2.\\', '}j2.\\', 'lχŧsw$5a\Z\"Ӯ0u-', '', 0, '?'),
 (' ɧ\"', 'wp-content/themes/kallyas/template_helpers/zion-integration/kallyas-element-base.php', 0, 'o;Gm#', 'o;Gm#', '/r3Y`t#ީDkt', '', 0, '?'),
 ('́\0#O', 'wp-content/themes/kallyas/th-action-hooks.php', 0, '\nZO9\'', '\nZO9\'', 'xaTif26\0w}A@B<', '', 0, '?'),
 (' ƨW3Q', 'wp-content/themes/kallyas/th-custom-hooks.php', 0, '0:\'0qSψG!', '0:\'0qSψG!', 'U2S%(>݋M1>ՋM', '', 0, '?'),
 ('YS0h', 'wp-content/themes/kallyas/th-filter-hooks.php', 0, 'W0t;qolHw', 'W0t;qolHw', '\ZjآN\\crijgjɚ', '', 0, '?'),
 (';\\4G', 'wp-content/themes/kallyas/theme-functions-override.php', 0, 'b hnr', 'b hnr', 'Z<n\'i:6oI\"gR\Z:I', '', 0, '?'),
 ('qǩ\0.\"\n', 'wp-content/themes/kallyas/woocommerce/product-searchform.php', 0, 'Ɩ7ls|', 'Ɩ7ls|', 'l9CqȪhPw]NsJO}x+h', '', 0, '?'),
 ('@vk y.', 'wp-content/themes/kallyas/woocommerce/product_gallery_v2/product_gallery.js', 0, 'K\r(ʛX', 'K\r(ʛX', 'R``\'>虧\rv؛\Zl_f', '', 0, '?'),
 ('nDw4X7;W6', 'wp-content/themes/kallyas/woocommerce/single-product-default.php', 0, '=Uqpe+$', '=Uqpe+$', '}y<}XKW_XJ$}\0OO5', '', 0, '?'),
 ('hqd5;E$', 'wp-content/themes/kallyas/woocommerce/single-product-style3.php', 0, 'lbę\'C{j', 'lbę\'C{j', 'm=i!91ɵ,~P\r0<f,x+', '', 0, '?'),
 ('cK\0<', 'wp-content/themes/kallyas/woocommerce/woo_options.php', 0, 'W\rU%,RMJP', 'W\rU%,RMJP', '{}oSmXIr\rn', '', 0, '?'),
 ('7?\"u\"y', 'wp-content/themes/kallyas/woocommerce/zn-woocommerce-init.php', 0, 'AK,.g\'|$z', 'AK,.g\'|$z', 'ʌ\n&6Q:TBݖv', '', 0, '?'),
 ('Tx\'vC\\\n', 'wp-content/themes/kallyas/woocommerce/zn-woocommerce-v2.php', 0, '@F`78S^w?hV', '@F`78S^w?hV', '̔<3Rk*f #ۂhT%X&', '', 0, '?'),
 ('@DՋ7hfk`', 'wp-content/themes/kallyas/woocommerce/zn-woocommerce-v3.php', 0, 'M8~?5pK', 'M8~?5pK', 'TcP/j`E/brR(n{', '', 0, '?'),
 ('D¤', 'wp-content/themes/kallyas-child/functions.php', 0, 'zqaP#	0-', 'zqaP#	0-', '-U&NSL$nA-*\0Ƭќ', '', 0, '?'),
 ('c\Z[m', 'wp-content/themes/kallyas-child/js/zn_script_child.js', 0, 'JR0«8N', 'JR0«8N', '[s4Fݑ7ևbW', '', 0, '?'),
 ('NVr>l', 'wp-content/updraft/index.html', 0, 'nrp@_Y', 'nrp@_Y', '>4o9JSrެs\\%', '', 0, '?'),
 ('7\\n5.夊/~', 'wp-content/updraft/plugins-old/akismet/_inc/akismet.js', 0, 's*O$9', 's*O$9', 'Rͪ՛2$!F~eH`U', '', 0, '?'),
 ('0ixPS˞;K', 'wp-content/updraft/plugins-old/akismet/_inc/form.js', 0, '\'4l*&i', '\'4l*&i', 'MB1QwoX4bxc)@D˥k', '', 0, '?'),
 ('d|:g]l<', 'wp-content/updraft/plugins-old/akismet/akismet.php', 0, 'S-~E븜x5', 'S-~E븜x5', 'y-d]`,5l9ox;', '', 0, '?'),
 ('5]4988pe', 'wp-content/updraft/plugins-old/akismet/class.akismet-admin.php', 0, '>`h4۵\'', '>`h4۵\'', 'ȳ(^zqp}ٳ?{.ՙGp', '', 0, '?'),
 ('K~h%r', 'wp-content/updraft/plugins-old/akismet/class.akismet-cli.php', 0, 'Z qE9g:I', 'Z qE9g:I', 'v26}۞\Z\nog$$@[C\\V', '', 0, '?'),
 ('9QlTq', 'wp-content/updraft/plugins-old/akismet/class.akismet-rest-api.php', 0, '⺅:K7&Z9Hc', '⺅:K7&Z9Hc', '*F:Å=IH\'x\\\"\':', '', 0, '?'),
 ('*vd~? ', 'wp-content/updraft/plugins-old/akismet/class.akismet-widget.php', 0, '1O2e1rJj', '1O2e1rJj', '#TcxEyũH>', '', 0, '?'),
 ('N\'r3L\ZN', 'wp-content/updraft/plugins-old/akismet/class.akismet.php', 0, 'Y#9ry\0ϭ', 'Y#9ry\0ϭ', '\rˢ\ZNtAFA\r|?', '', 0, '?'),
 ('5\'4D(B', 'wp-content/updraft/plugins-old/akismet/index.php', 0, 'h PZݢ`Ef', 'h PZݢ`Ef', '}5e33mhyDQ(', '', 0, '?'),
 ('!OioX*c', 'wp-content/updraft/plugins-old/akismet/views/activate.php', 0, '{ETJ_qn', '{ETJ_qn', '·^\nbq<v`xKZW>Gw', '', 0, '?'),
 ('TQťB4n;Q', 'wp-content/updraft/plugins-old/akismet/views/config.php', 0, 'ܥ&Fe@`', 'ܥ&Fe@`', 'ۑ&\Z錷ې7~rb', '', 0, '?'),
 ('|]>.Xh5n\"', 'wp-content/updraft/plugins-old/akismet/views/connect-jp.php', 0, 'sQX3', 'sQX3', '\0.l>Wv&qv+IN~W', '', 0, '?'),
 (';\0wpS', 'wp-content/updraft/plugins-old/akismet/views/enter.php', 0, 'EGTA>sJ', 'EGTA>sJ', 'FR<`=#izAgDd)q', '', 0, '?'),
 ('k=hM ', 'wp-content/updraft/plugins-old/akismet/views/get.php', 0, 'Ӵq\'7\0Y>', 'Ӵq\'7\0Y>', 'x[%@c', '', 0, '?'),
 ('l}3(s=F', 'wp-content/updraft/plugins-old/akismet/views/notice.php', 0, '(ﹴ~Co', '(ﹴ~Co', '}GT@!QRm`+N*u6', '', 0, '?'),
 (';!d)՚ľ	6v', 'wp-content/updraft/plugins-old/akismet/views/predefined.php', 0, '#>ajϬa4', '#>ajϬa4', 'wsbN}qY7zoUu\'1', '', 0, '?'),
 (',=,bng', 'wp-content/updraft/plugins-old/akismet/views/setup.php', 0, 'eY]Z.^<&Un', 'eY]Z.^<&Un', 'G,|8i1<2,8+w', '', 0, '?'),
 ('_kȸ  QbYȤ', 'wp-content/updraft/plugins-old/akismet/views/start.php', 0, 'Qz\"\'\0\0Y7^kTj', 'Qz\"\'\0\0Y7^kTj', '=P=ypyP*u]*', '', 0, '?'),
 ('TR', 'wp-content/updraft/plugins-old/akismet/views/stats.php', 0, 'AFh`', 'AFh`', '?O>uz/Aǚ	n5E-IGUh߳', '', 0, '?'),
 ('{۶}\0\'|\nF', 'wp-content/updraft/plugins-old/akismet/views/title.php', 0, 'XCN3|)-2Na', 'XCN3|)-2Na', 'tCz n`j\rMN\"Ag', '', 0, '?'),
 ('q8k^F5f', 'wp-content/updraft/plugins-old/akismet/wrapper.php', 0, ']x\"YKJ', ']x\"YKJ', '\ZIa^iJH:j:b', '', 0, '?'),
 ('Yʸ\ZEG/ц.', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-admin-js.js', 0, 'KiVnY', 'KiVnY', 'k|~\"EjQ1:ږ', '', 0, '?'),
 ('uMc{գkB\nN', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-public-js.js', 0, '&8I%#vv', '&8I%#vv', '76l44˺06	;zedQ', '', 0, '?'),
 ('<2xev8\Z', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-timecircles.js', 0, 'h^Co-)\Zz@', 'h^Co-)\Zz@', '+ZZ	?uvFk/	Hb', '', 0, '?'),
 ('<}д2j', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-ui-timepicker-addon.js', 0, '2C3~]', '2C3~]', '	D4adkLK7K7\rE,~U,.', '', 0, '?'),
 ('tSJqA֖t~#', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/countdown-timer.php', 0, ';XE fI', ';XE fI', '$\Z1tCjȵ	Tk', '', 0, '?'),
 ('~}#>', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/class-wpcdt-admin.php', 0, '{BVVo?V&', '{BVVo?V&', 'n+eԦ&qJM|?4\r,ԙ', '', 0, '?'),
 ('X$Eg', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/metabox/wpcdt-sett-metabox.php', 0, '~\r*jL<B\r	', '~\r*jL<B\r	', ',Z.bK͈x/\rtO4)sl', '', 0, '?'),
 ('xO\0Nf(\0e \n', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/settings/hire-us.php', 0, 'y/l?', 'y/l?', '!(&O]3\r!B;7G', '', 0, '?'),
 ('g̺Ja', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/settings/premium.php', 0, '\".BR', '\".BR', '-c3oaO.ލsI4/E', '', 0, '?'),
 ('$K/m@V', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/wpcdt-how-it-work.php', 0, 'Uj0W', 'Uj0W', '~$mW],NQWx;', '', 0, '?'),
 ('Õ^hASwm#', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/class-wpcdt-script.php', 0, 'fjLAoP', 'fjLAoP', 'jlo]X8A$', '', 0, '?'),
 ('mgBnVZLΗ', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/shortcode/wpcdt-shortcode.php', 0, 'r57} w', 'r57} w', 'ث_ɩ[t[4GX=I7X_k*\'', '', 0, '?'),
 ('|̠nT]Mu', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/wpcdt-functions.php', 0, 'V^I1q', 'V^I1q', 'u,\\b|,OVUՙ', '', 0, '?'),
 ('96*;', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/wpcdt-post-types.php', 0, 'uF&fD', 'uF&fD', '-\rmՉQVyP}&2', '', 0, '?'),
 ('7xHe9ŋ', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/assets/js/wpos-anylc-admin.js', 0, 'ٌqU\0\ZfC', 'ٌqU\0\ZfC', 'ɑܖq	Uvkh^ɩYS', '', 0, '?'),
 ('`hk7j߈', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/includes/class-anylc-admin.php', 0, 'p)>A}s\0', 'p)>A}s\0', 'S#EMit`=ft<yۼZw&	', '', 0, '?'),
 (')>D,RB', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/includes/class-anylc-script.php', 0, 'hwE;liX	U', 'hwE;liX	U', '(yԺ_\rW=okN,%K', '', 0, '?'),
 ('\0NaN1,', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/includes/wpos-anylc-function.php', 0, '*Xo\Zpsj', '*Xo\Zpsj', 'xE(JQzgҲ@إP˩l', '', 0, '?'),
 (':sw2', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/templates/analytic.php', 0, 'bz-f;xWi', 'bz-f;xWi', 'kƌq2}S8c_FB', '', 0, '?'),
 ('HWŤ@V\\', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/templates/offers.php', 0, 'd]1!ZE\\@}', 'd]1!ZE\\@}', 'AP➔^XK0-$V\0y?F', '', 0, '?'),
 (']4e:dȢPezB', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/templates/optout-popup.php', 0, '6~/q-', '6~/q-', '\r.Xuz>^Fv[2wU`y&', '', 0, '?'),
 ('\'#MM\\PwI+', 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/wpos-analytics.php', 0, '%(=n', '%(=n', 'rY@8/>3ߝUv$Z', '', 0, '?'),
 ('{LllVM', 'wp-content/updraft/plugins-old/duplicator-pro/assets/css/images/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('7cg$8vW+v+', 'wp-content/updraft/plugins-old/duplicator-pro/assets/css/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('p_\r^G_$M', 'wp-content/updraft/plugins-old/duplicator-pro/assets/img/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('bjjz˰\r0', 'wp-content/updraft/plugins-old/duplicator-pro/assets/img/logo-menu.svg', 0, 'm_46\ZYf.V+', 'm_46\ZYf.V+', '~@!nMK:]', '', 0, '?'),
 ('?X{V^$U\0,x', 'wp-content/updraft/plugins-old/duplicator-pro/assets/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('cX{.q̦', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/dp-kick.js', 0, 'RI{xd', 'RI{xd', '~V\']gfFOt^^7ш', '', 0, '?'),
 ('p{t(', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/formstone/bundle.js', 0, '|]AeIg', '|]AeIg', 'ڹ)TF~Yj[_Q', '', 0, '?'),
 ('}nDicI}q', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/formstone/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\0|', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/handlebars.min.js', 0, 'ٞG.*U$#', 'ٞG.*U$#', '|@>A~ǥ^D<jw', '', 0, '?'),
 ('ںZ9VzX', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ox:cl7*3%\r', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/javascript.php', 0, 'pY(FD,', 'pY(FD,', 'ܯ|M~0~Yz76\"U9n', '', 0, '?'),
 ('-8EmTKhxTѫ', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jquery.qtip/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('*\"U5m\"}u', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jquery.qtip/jquery.qtip.min.js', 0, '٫F\0Ǥw\0lVl', '٫F\0Ǥw\0lVl', '&h	$\\	.&iE:xK', '', 0, '?'),
 ('bv QdDy', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jstree/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('1^-ʹV', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jstree/jstree.js', 0, '_hl ^I8<', '_hl ^I8<', '}L	0`|aQQ(;(ճ@', '', 0, '?'),
 ('nM	*\0', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jstree/jstree.min.js', 0, '`$G}΃L', '`$G}΃L', 'sV\'\\	-QI$꿐\"+΃', '', 0, '?'),
 ('w{p98M', 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/parsley.min.js', 0, 'z ;\'h%yR', 'z ;\'h%yR', 'W<{gvϺ4>tb9e', '', 0, '?'),
 ('WMH*nt]1t\"', 'wp-content/updraft/plugins-old/duplicator-pro/assets/webfonts/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('=\0/7xϐ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Aws.php', 0, 'Fٖ\r1F	', 'Fٖ\r1F	', 'J܃~\0Fpwu	J1', '', 0, '?'),
 ('G;]+k͘qJ&', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/AbstractClient.php', 0, '`꼡u=3b>W', '`꼡u=3b>W', 'S2%.$[}A!', '', 0, '?'),
 (' s^bK\"0 ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/AwsClientInterface.php', 0, 'c:X5P	', 'c:X5P	', 'WCOaT_](cUtau', '', 0, '?'),
 ('?IShH,aU', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/ClientBuilder.php', 0, '0N>6Q', '0N>6Q', '^{^Zi<ڣw2ZY', '', 0, '?'),
 ('cOJaS;5p', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/DefaultClient.php', 0, 'p֪n;>B$!]', 'p֪n;>B$!]', '\"\nx,\\IJ-.!\'', '', 0, '?'),
 ('p8.6DJWfLY', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/ExpiredCredentialsChecker.php', 0, 'c!uR\"Si ', 'c!uR\"Si ', 'Oh3!B[:\0(ԿS&4quTF', '', 0, '?'),
 ('SS}gg', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/ThrottlingErrorChecker.php', 0, '-|ѩW(', '-|ѩW(', 'Gg#/;>X=Mj_JL', '', 0, '?'),
 ('>+fu(7mH^', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/UploadBodyListener.php', 0, '`jQF[i_qIGY', '`jQF[i_qIGY', 'N&)3zf]9y7;2@T3', '', 0, '?'),
 ('f	m tx', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/UserAgentListener.php', 0, 'r4Jw', 'r4Jw', '!zkF7o~1M 3B\\w', '', 0, '?'),
 ('\n*F1q¿8d3\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('`(,d{qkw', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/AwsQueryVisitor.php', 0, '\rE	pufM&7l)^', '\rE	pufM&7l)^', 'mZഔIbAyTe', '', 0, '?'),
 ('RװRmܫ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/JsonCommand.php', 0, '	hB^S*k', '	hB^S*k', '/VkF3tJ 95\r%oT', '', 0, '?'),
 ('@hOXehdh', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/QueryCommand.php', 0, 'U_oǏ{', 'U_oǏ{', 'y޴-[!~v:.Z', '', 0, '?'),
 ('&\'M)UENR&f', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/XmlResponseLocationVisitor.php', 0, 'bk!>~H', 'bk!>~H', 'Y6;mu16)0bcu', '', 0, '?'),
 ('ph&{', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (']_&=\n', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/AbstractCredentialsDecorator.php', 0, 'D5jY!V}\Z', 'D5jY!V}\Z', 'ǐ|x{Ŏ8Ro2Ir', '', 0, '?'),
 ('o9#_fl_)熫', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/AbstractRefreshableCredentials.php', 0, 'q7\0,N]5@z', 'q7\0,N]5@z', 'pvmhUȦ̪I1G;1nZOP', '', 0, '?'),
 ('vV8ZG|$B', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/CacheableCredentials.php', 0, ')Ý0T@?M', ')Ý0T@?M', 'bweE07!An_=ڭjƑd', '', 0, '?'),
 ('ʭ9YSN*', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/Credentials.php', 0, '=t.x^', '=t.x^', 'CS{\"&B:2UP+HS4', '', 0, '?'),
 ('^yycB?nL=%', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/CredentialsInterface.php', 0, 't%vxG<a', 't%vxG<a', 'Ke!Ur_,XYL<\Z', '', 0, '?'),
 ('KB15', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/NullCredentials.php', 0, '>g鰒E', '>g鰒E', 'w_Z3qMgAh%|@o16', '', 0, '?'),
 ('vw\ro=bRV', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php', 0, 'E[ireGl', 'E[ireGl', '޽ `Zp%\0&޲8\nES', '', 0, '?'),
 ('\"\ZT6\Zՠ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('MX:dț', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/ClientOptions.php', 0, 'g\'\'c |,', 'g\'\'c |,', 'O/?J=$|2t%.`Hj', '', 0, '?'),
 ('ݐQ+PJt	', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/DateFormat.php', 0, 'gTÈ	N\Z', 'gTÈ	N\Z', '2`W(Ŭ.HM8i76\"', '', 0, '?'),
 ('Bg}$ÜI~=K*W', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/Region.php', 0, 'Y.(8)N', 'Y.(8)N', 'RQM$Nj9E~0\rܩ^Ŀ', '', 0, '?'),
 ('Ii?', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/Size.php', 0, 'k		Gn', 'k		Gn', 'b?y\'n<T*_@ט`IǺV', '', 0, '?'),
 (';莧ƹX(ܳ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/Time.php', 0, 'נ#\rL~5P[&', 'נ#\rL~5P[&', 'I@W\n,8,zθ˘?a', '', 0, '?'),
 ('Vd3!<:s', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/UaString.php', 0, 'YΙ\'H<*ƨ8', 'YΙ\'H<*ƨ8', '>vn|@zFF4Y!nCzKl؟', '', 0, '?'),
 ('=Qv[_HXZ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\naFd6A;3~QbH', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum.php', 0, 'X~\\ҔrTZi/', 'X~\\ҔrTZi/', 'o%[q#_$\'KK', '', 0, '?'),
 ('n}	,4B', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/AwsExceptionInterface.php', 0, 'pQq.&q2', 'pQq.&q2', '@RV\\[Iڼ387dINSlF', '', 0, '?'),
 ('wTvn6[ot', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/BadMethodCallException.php', 0, '#õ&D$B', '#õ&D$B', 'V=6^aA\n3wf`', '', 0, '?'),
 ('19d`{C', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/DomainException.php', 0, 'k8%y7v>', 'k8%y7v>', '2kLX\"zs7A,̍q}T', '', 0, '?'),
 ('.!\Z>3ZdNd_9z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/ExceptionFactoryInterface.php', 0, '\'p$)˫', '\'p$)˫', 'V݉o:$oBVC:}{f', '', 0, '?'),
 ('D!E|~7z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/ExceptionListener.php', 0, 'Jr9	(<\\7P', 'Jr9	(<\\7P', 'wR3q6]	eۊs', '', 0, '?'),
 ('e欆#Fp{', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/InstanceProfileCredentialsException.php', 0, 'l)<r~', 'l)<r~', '܆,+C:өac_c(0K', '', 0, '?'),
 ('֏	Eぬ\n@k:v', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/InvalidArgumentException.php', 0, '?5ӝwj1&£', '?5ӝwj1&£', '/CoNFւy&2saZyz1҈', '', 0, '?'),
 ('=	m&Tď', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/LogicException.php', 0, '-YH+Tʩ:', '-YH+Tʩ:', '\ro&Ϧi;K晖XDgkz?lVo\\G', '', 0, '?'),
 ('Il\\,V3L9', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/MultipartUploadException.php', 0, 'ƭ1PA\\', 'ƭ1PA\\', 'jXvLwG#5b܂GlRt6', '', 0, '?'),
 ('33PEA_', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/NamespaceExceptionFactory.php', 0, 'JˆȐ_;k%L', 'JˆȐ_;k%L', 'o\r:vd͛KTD!{pMR;Xh', '', 0, '?'),
 ('~\'@Z-', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/OutOfBoundsException.php', 0, '<u5-U#', '<u5-U#', '߻iKdᇽm=/[l|gW\r', '', 0, '?'),
 ('|%`)&BY', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/OverflowException.php', 0, 'pUsaz\r!', 'pUsaz\r!', '(aJDe	\r0SV6}', '', 0, '?'),
 ('<`ɋ:', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php', 0, 'y4=R	9MCާp', 'y4=R	9MCާp', 'vo\'óiŷ=\'5\Z\'', '', 0, '?'),
 ('ILZ/}', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php', 0, 'P\'c0-6l', 'P\'c0-6l', '[_P8*c\Zk(5\n', '', 0, '?'),
 ('8dRQ#', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/ExceptionParserInterface.php', 0, 'eH߁O', 'eH߁O', 'U:\"_	tT!t%@Eoy\\', '', 0, '?'),
 ('WBA1cnv', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php', 0, '@ԽmsV$', '@ԽmsV$', 'K\0/NaY\0MT썿gq\"\n!-', '', 0, '?'),
 ('oP\nmH\nO', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonRestExceptionParser.php', 0, '.sM\nZ1S', '.sM\nZ1S', 'LE{U,J-jy5&%\"', '', 0, '?'),
 ('h\'%<ݦ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ڎmr', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/RequiredExtensionNotLoadedException.php', 0, '25M\\p\0hR-', '25M\\p\0hR-', 'A\r.vHaLCߋ5rg䤖', '', 0, '?'),
 ('rLG2Wc', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/RuntimeException.php', 0, '~T49MvPjB6', '~T49MvPjB6', 'T|pFCqj?jl4:', '', 0, '?'),
 ('b`w9;>?\0ܚ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/ServiceResponseException.php', 0, '/(R7', '/(R7', '0B]\rR;b\"6', '', 0, '?'),
 ('Bc<FN\0ڪc', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/TransferException.php', 0, 'I#\'Ti', 'I#\'Ti', '$Ox?VV#Jx>^\Zs', '', 0, '?'),
 ('æxʱ`sU}J', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/UnexpectedValueException.php', 0, 'B:6mQϲ3@', 'B:6mQϲ3@', 'p֚\\OP@yԔï	', '', 0, '?'),
 ('!9qs', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (')?4X^/J', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/Facade.php', 0, '͘<%ua(C_C', '͘<%ua(C_C', '2Ha,YZNr?I,u( ~,p)p[', '', 0, '?'),
 ('@UO%zA', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/FacadeInterface.php', 0, 'G_v\rdX&', 'G_v\rdX&', 'jf֩F]gNko', '', 0, '?'),
 ('H*raLgM', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/facade-classes.php', 0, 'gF||igA	z', 'gF||igA	z', '>EŞOxEeo״rhtГlv', '', 0, '?'),
 ('^FA01I\\1', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('dzw#/A5k', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/ChunkHash.php', 0, 'bɫ柱/$', 'bɫ柱/$', ';Q/nNR5SC3ϧ}k&1	', '', 0, '?'),
 ('5t߬Al,TX%', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/ChunkHashInterface.php', 0, '+ωâr9G', '+ωâr9G', 'c4Tڎ(okJ=wFV', '', 0, '?'),
 ('_YVĝ|J', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/HashUtils.php', 0, 'jMV	O', 'jMV	O', '%Ҝs}ǁUu@\nfUl', '', 0, '?'),
 ('ё\0w.\Z2ØZ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/TreeHash.php', 0, 'U>I\'y', 'U>I\'y', 'LZ;ge8:Ηv0 ', '', 0, '?'),
 ('uU67\r', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('6<6m%:', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/HostNameUtils.php', 0, 'qnܗt2YiMh', 'qnܗt2YiMh', '<#p梑|~\'o*C?c', '', 0, '?'),
 (',`r|ƵNr\nz', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/InstanceMetadataClient.php', 0, '%i\Zxgg7k', '%i\Zxgg7k', 'T tiYGQkfǋ', '', 0, '?'),
 ('Rܼ6C(9UN', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php', 0, '<n]AaG|&', '<n]AaG|&', 'zQ\0\"#naŠ', '', 0, '?'),
 ('1ySq3<P3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('u26&', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('%J#\n', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIterator.php', 0, '|cg~', '|cg~', 'a14~\ZgA', '', 0, '?'),
 ('I2f=[I/]', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIteratorFactory.php', 0, '}.-^,UMXj', '}.-^,UMXj', '19֦Aܺ+#Jm77roq\r', '', 0, '?'),
 ('z^{e,.', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Iterator/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('x@v\'N_', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransfer.php', 0, '3:\rYLQ', '3:\rYLQ', ']*n2{s\\*LG[UuHi', '', 0, '?'),
 ('YTa8Ez[', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransferState.php', 0, '\r]o\r.nmA?', '\r]o\r.nmA?', 'IA67쐉g濥_дj/gN>', '', 0, '?'),
 ('wT#5O!%7uG', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php', 0, '*Dh\\臾cW', '*Dh\\臾cW', 'l|?\Zg?׀guZ,OG6xi', '', 0, '?'),
 ('/qqoZ+Q,', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadId.php', 0, 'Vt(x@nV', 'Vt(x@nV', '%D%c*^F\nlk\\_+', '', 0, '?'),
 ('xw\\<vgP', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php', 0, '\naF!K', '\naF!K', '8-+(r\rLlZu\'}r', '', 0, '?'),
 ('p}Wè+gKk', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferInterface.php', 0, '+f', '+f', 'y\"\\7CTdԲE61 *g', '', 0, '?'),
 ('F}aK6:', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferStateInterface.php', 0, 'ǖi1eRad4', 'ǖi1eRad4', '\"y#.Hml;`y SG9', '', 0, '?'),
 (';b@\r\'\"@', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadIdInterface.php', 0, 'OJKumeR', 'OJKumeR', 'X_`w2frN*_>؄:g1w', '', 0, '?'),
 ('\':TtV](^', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadPartInterface.php', 0, 'Ϻ|6bn', 'Ϻ|6bn', 'hvO/ZqՖ8Cl&\"', '', 0, '?'),
 ('-2	U_p', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('zA1ݬ&bv', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\Zo g?uG_R\0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/aws-config.php', 0, 'w蚉7XGn', 'w蚉7XGn', 'rxw񜜦UMϦΤ7l', '', 0, '?'),
 ('˘X5{7', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('CWт3J', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/public-endpoints.php', 0, 'j\ra\'bC\n', 'j\ra\'bC\n', ':ТLr`N[dFŘ[K,', '', 0, '?'),
 ('X{IӃ6$\"', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/sdk1-config.php', 0, 'ڏ[j8zWh', 'ڏ[j8zWh', '^xX zm?iɹp\0R*I3W', '', 0, '?'),
 ('@ܔ\"=Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/RulesEndpointProvider.php', 0, '19SAY}TY', '19SAY}TY', '1\0\'k#yv[x(hm', '', 0, '?'),
 ('	d*Ǖ-̽kb', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/AbstractSignature.php', 0, '#=10>u', '#=10>u', '%7l7 4[^&Vb', '', 0, '?'),
 (']@u[Ѕ\r4I_', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/EndpointSignatureInterface.php', 0, 'Q`\'}oP狁', 'Q`\'}oP狁', 'G2\'fJIX!HSkj#$', '', 0, '?'),
 ('|8zv', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureInterface.php', 0, 'Ճ-<p3', 'Ճ-<p3', 'n/sj v縗5,5X݂CNEy\'.{', '', 0, '?'),
 ('YrӰ\n@p19', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureListener.php', 0, '`jd,\nƁ%$', '`jd,\nƁ%$', '4%LW/:FXvbU&%\'y[', '', 0, '?'),
 ('	|\n\0\n7:', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureV2.php', 0, '1_\"NܕlY', '1_\"NܕlY', '%pul7,.ub#5Y7', '', 0, '?'),
 ('?hCNQ_l', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureV3Https.php', 0, 'ǨJdt1Xwƣ', 'ǨJdt1Xwƣ', '̦i%u@5 ?=sM΄', '', 0, '?'),
 ('`,$q', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureV4.php', 0, 'b<St_&=', 'b<St_&=', '<JЕni_	\r?ׁ9])Z', '', 0, '?'),
 ('ՄI!&', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('p#7oL', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/AbstractResourceWaiter.php', 0, '4(U$+ys\Z', '4(U$+ys\Z', '@T$r׭ڮspK#R\0]%K', '', 0, '?'),
 ('`RG|p?!/', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/AbstractWaiter.php', 0, 'z\0i/PbG', 'z\0i/PbG', '׷@\r>fe̞PL#4', '', 0, '?'),
 ('SZ`b1$hK', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/CallableWaiter.php', 0, '+Wpq=-*6', '+Wpq=-*6', 'lE}@ӄ*p$mMisTU& ', '', 0, '?'),
 ('	46ZUE', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/CompositeWaiterFactory.php', 0, '#|S_yo', '#|S_yo', '|lgk6̙c5k', '', 0, '?'),
 ('c0sF`o', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/ConfigResourceWaiter.php', 0, 'k<pA3d . ', 'k<pA3d . ', '#\"#ҧd9[spFo$0E', '', 0, '?'),
 (':dRtZA65', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/ResourceWaiterInterface.php', 0, '͢ ~ϧ>OZ', '͢ ~ϧ>OZ', '\'Bvk}tZvv (+۵', '', 0, '?'),
 ('eV>[0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterClassFactory.php', 0, '.=+t', '.=+t', 't\'J\\s\rtuھR}rfT:', '', 0, '?'),
 ('arU{@s^|', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfig.php', 0, '|ZA>q\Z', '|ZA>q\Z', '	Nhc>\"%vǉ,r\Z$]	', '', 0, '?'),
 ('{ݢ|ųw', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfigFactory.php', 0, '&%d@a[', '&%d@a[', 'zߔ	}kWT#OcSm6:', '', 0, '?'),
 ('YM}̒rg~z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterFactoryInterface.php', 0, '8کqS k', '8کqS k', 'f\ZL@NyWh=mH{Hcd7', '', 0, '?'),
 ('d^3UJ$^3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterInterface.php', 0, 'wSUg&nF', 'wSUg&nF', 'I(;\'~.rو^r\"ew', '', 0, '?'),
 ('7n\n_{rjU', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('F=\"̦OK', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('@jR1v١', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/AcpListener.php', 0, 'LT	N6', 'LT	N6', '*2!f<Sȅ%,', '', 0, '?'),
 ('\\NɑvJXkS', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/BucketStyleListener.php', 0, '{33Qd', '{33Qd', '>\rԺYcH{f7yfi`ώ%', '', 0, '?'),
 ('_YC?', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Command/S3Command.php', 0, '/PuEk', '/PuEk', '~W5-b?F]K$^', '', 0, '?'),
 ('de{=\0?|LN', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Command/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('T\Zx1', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/CannedAcl.php', 0, '-+(FSLJ', '-+(FSLJ', 'J<?:)xdb4@	Kؓ', '', 0, '?'),
 (' Ʋ4:Z7', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/EncodingType.php', 0, '|ݾ4X0=', '|ݾ4X0=', 'd;~^iI(ɍT\0sX8', '', 0, '?'),
 ('i	4/ Vo', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Event.php', 0, 'Isz2.-Ju', 'Isz2.-Ju', '4-?税g],\"-\rsd=nk!', '', 0, '?'),
 (';ƽIV@', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/GranteeType.php', 0, '\"hP),;\rQ4', '\"hP),;\rQ4', 'RBq!J֖d˚@xUu֨Y', '', 0, '?'),
 ('/4;4]W', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Group.php', 0, 'RA\'M$\0d', 'RA\'M$\0d', '#n\\֨Jz~ogh)Au	o', '', 0, '?'),
 ('V2	#lpG#yN', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/MFADelete.php', 0, '˪\0\0 P', '˪\0\0 P', '\0	\0N;J(N\"9JzS', '', 0, '?'),
 ('T8$(`', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/MetadataDirective.php', 0, 'r	#!G\n', 'r	#!G\n', 'C`;.آ.Ea%Qvs', '', 0, '?'),
 ('D*h)S', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Payer.php', 0, '\rJ.JE7', '\rJ.JE7', 'B2zkeB$!m	އ>.\ZXp[e	', '', 0, '?'),
 ('.o*', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Permission.php', 0, 'jpVx@`+', 'jpVx@`+', ' Fgp\\Qۡw;B{O+', '', 0, '?'),
 ('T`7^\nv6)', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Protocol.php', 0, 'wTow6', 'wTow6', 'y=gRD[,N$G(q+Of', '', 0, '?'),
 (')a?laOR', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/ServerSideEncryption.php', 0, 'BGވ4	', 'BGވ4	', '(f)wT0}0!lJ?(t', '', 0, '?'),
 ('?3ZDХQn9', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Status.php', 0, 'tĻ,Ǌԓ', 'tĻ,Ǌԓ', '=L4SPUEpfE6+Y', '', 0, '?'),
 ('C$6)Sڑ<', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Storage.php', 0, 'NY\\|sڛG', 'NY\\|sڛG', '&W-6F^6\ZtN&3Gx\0I', '', 0, '?'),
 ('W\0_7>Eʵ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/StorageClass.php', 0, 'rO\nԑd', 'rO\nԑd', ',IcWeR(0?A(,lO!8vD', '', 0, '?'),
 ('RL50W', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\r\n^ŐWh', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/AccessDeniedException.php', 0, '	*uEt', '	*uEt', 'G\ZN9&ے~aUGvBæ\"', '', 0, '?'),
 ('ßŸs9ݟ\'', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/AccountProblemException.php', 0, 'ȍEM;', 'ȍEM;', 'mfF4w?K8U\Z$Q45я?_', '', 0, '?'),
 ('tVDڽ!=RD:', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php', 0, '`iyԍ*O;}b*', '`iyԍ*O;}b*', ':+Yf\\йIu7I&', '', 0, '?'),
 ('.T*&D,--w', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BadDigestException.php', 0, '%N\nAj#', '%N\nAj#', 'F2Q23<r/zZZ*}', '', 0, '?'),
 ('\\6$Y^ʠ\0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyExistsException.php', 0, '6=D\\(}4D', '6=D\\(}4D', '_ Ie:^3{Uv', '', 0, '?'),
 ('*_ބA', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php', 0, 'ο	\"0u<g.', 'ο	\"0u<g.', 'M[!J7]\"L!T#crKx+', '', 0, '?'),
 ('1]|OЌSk', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BucketNotEmptyException.php', 0, '_o\0ɀv', '_o\0ɀv', '\nikW:j^\0	;=\Z', '', 0, '?'),
 ('m$);~,|:', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/CredentialsNotSupportedException.php', 0, 'ϯ?WAS$', 'ϯ?WAS$', '\n\nCvE\"Ӫr\'꙼,', '', 0, '?'),
 (',?%N', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php', 0, '=vv4', '=vv4', '`6Dwҡ.FYs-U', '', 0, '?'),
 ('򣾢NV,j[', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/DeleteMultipleObjectsException.php', 0, 'Id\'kKk', 'Id\'kKk', 'O\Z)&A\'m*\Z4SE&', '', 0, '?'),
 (')N1\\$Jju', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/EntityTooLargeException.php', 0, 'b14Ң<q՛', 'b14Ң<q՛', 'Ѻl+LiHy\'9', '', 0, '?'),
 (')]pT62', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/EntityTooSmallException.php', 0, 'JJMbil$B_D', 'JJMbil$B_D', '9:SF@\\ɱ0`9d1', '', 0, '?'),
 ('%.(Y', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ExpiredTokenException.php', 0, 'Yv]{*N>zIDi', 'Yv]{*N>zIDi', '(\nb&#|@Hc', '', 0, '?'),
 ('.cf-9SF3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/IllegalVersioningConfigurationException.php', 0, '_bX|Y\nE|ns&', '_bX|Y\nE|ns&', 'Z`،Bvn^8BQ$g=w%#', '', 0, '?'),
 ('iZTšXPҍ^+', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/IncompleteBodyException.php', 0, 'W\Z[H\n,6/', 'W\Z[H\n,6/', '.mrWoI}*٨_U`', '', 0, '?'),
 ('ρ=-EG', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php', 0, '}G]3WWۥ2', '}G]3WWۥ2', '\rrYɏ.g\0ujW@Z', '', 0, '?'),
 ('v\rP\'3t=pM.\0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InlineDataTooLargeException.php', 0, '<$}s$I-', '<$}s$I-', '4)vtsxeÊ!LYi	Acr҈iu\r', '', 0, '?'),
 ('zZ<\"BpA', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InternalErrorException.php', 0, 'u\rdۙ', 'u\rdۙ', 'J\\[@A	`i7;1\\F', '', 0, '?'),
 ('3g泱ڶ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidAccessKeyIdException.php', 0, 'dL7˃~QeF', 'dL7˃~QeF', 'f}iah<8ʻIwV6ϛ', '', 0, '?'),
 ('5tfZj$', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidAddressingHeaderException.php', 0, 'ڴ\\%ȷ*PlA', 'ڴ\\%ȷ*PlA', 'BcdoUfA!wꘔ]', '', 0, '?'),
 ('$b*q*%', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidArgumentException.php', 0, 'CI-ɲ', 'CI-ɲ', '_L<Dٻ9c7HsP|', '', 0, '?'),
 ('߈\'+∻mpl', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketNameException.php', 0, '<egܧq!', '<egܧq!', 'BpEͯέ3e}p^.q', '', 0, '?'),
 ('d$Pd5', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketStateException.php', 0, 'hsV28T\'4', 'hsV28T\'4', 'sr\0,ø|} I5jA{', '', 0, '?'),
 ('S)^qZ/F', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidDigestException.php', 0, '%Vd=`RS', '%Vd=`RS', 'E}\0=KDeA', '', 0, '?'),
 ('=%Vjb\'͖@e', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidLocationConstraintException.php', 0, 'S96RG+PC', 'S96RG+PC', '~p][+ƧI{2', '', 0, '?'),
 (')Q%=L=A|i', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPartException.php', 0, '=<>`=:;pX1', '=<>`=:;pX1', 'PFH]9ôq\rDr64_v', '', 0, '?'),
 ('\0Щyp', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPartOrderException.php', 0, '\ZG\\4H?', '\ZG\\4H?', 'bhUOexAӌ0YA*', '', 0, '?'),
 (',]', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPayerException.php', 0, '9%e%\rc9A', '9%e%\rc9A', '5k.9@gیf-}pi)(m', '', 0, '?'),
 ('	O\0NspP', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPolicyDocumentException.php', 0, '4{gJmvs', '4{gJmvs', '{y(	trm\ZȆ܌D|\\Єߐ', '', 0, '?'),
 ('>yQw;`v-?', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidRangeException.php', 0, 'eJ#\"E\Z]', 'eJ#\"E\Z]', '\"BϡwM?jHi(~rԓd', '', 0, '?'),
 ('wd', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidRequestException.php', 0, 'd8<>', 'd8<>', 'l HYSC.(;5WE_', '', 0, '?'),
 (',ڍM%', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidSOAPRequestException.php', 0, 'v\\3F@c', 'v\\3F@c', '<X\ZHα\Zo@c=XN+\\NGM', '', 0, '?'),
 ('Seڌ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidSecurityException.php', 0, '%R)~Pvt8+', '%R)~Pvt8+', '˓CC=+㦺x? &k\0\"L', '', 0, '?'),
 ('GŗXe\0y=8', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidStorageClassException.php', 0, '\0@m%B$Ά', '\0@m%B$Ά', '\'}!DM?,Aw=#L)1\0', '', 0, '?'),
 ('4HYq-<', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidTagErrorException.php', 0, 'k!@8b6', 'k!@8b6', 'UPdI]C#efVnmJYDq', '', 0, '?'),
 ('uʗʍ7t', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php', 0, 'A_xzIi', 'A_xzIi', ';Y{jWaJy;\ZMʼ[', '', 0, '?'),
 ('W{|	\'Aރaq', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidTokenException.php', 0, 'OAqQ\r\Z-$W^', 'OAqQ\r\Z-$W^', 't$?!]uĹ/DL_GzWLryK', '', 0, '?'),
 ('8Ns^', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidURIException.php', 0, 'iQ8h_S', 'iQ8h_S', 't!~@)`Č\Z,g)Q(', '', 0, '?'),
 ('lg͋Ƹ)GRx', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/KeyTooLongException.php', 0, 'mG508', 'mG508', '9bG!&ߜPiid|Z', '', 0, '?'),
 ('$M?$', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MalformedACLErrorException.php', 0, 'B!#', 'B!#', 'w\rr-푮VoKFB۪GMڞ', '', 0, '?'),
 ('3H(CVEQ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MalformedPOSTRequestException.php', 0, 'U:dj\n,JG:G', 'U:dj\n,JG:G', '\rS\"0GUT5GBP>9Z~', '', 0, '?'),
 ('V\"\rJlO#', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MalformedXMLException.php', 0, '_fjwI>ib', '_fjwI>ib', '#\'T\ru䬡p){E4>	77l', '', 0, '?'),
 ('R#3&W?', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MaxMessageLengthExceededException.php', 0, 'N5j1m', 'N5j1m', 'E[%p\0p>4)ŗZ1#,r', '', 0, '?'),
 ('op5lnM(/', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php', 0, '/!?5J}hogԁ', '/!?5J}hogԁ', 'LׇDIF57\\zD|ZAd\r', '', 0, '?'),
 ('t!<b0<A8Kh', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MetadataTooLargeException.php', 0, '\'!L4\\wDcO', '\'!L4\\wDcO', 'x:koqf9KБ', '', 0, '?'),
 ('zۣcb', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MethodNotAllowedException.php', 0, 'ÏG%HqN', 'ÏG%HqN', '*\rG/^WE*TI}\0+iۡ', '', 0, '?'),
 ('7Ϫ.Y', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingAttachmentException.php', 0, 'd־$ɟg', 'd־$ɟg', 'aѥu y3pF?k~Ǖ', '', 0, '?'),
 ('ъٓn׈2KĂD', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingContentLengthException.php', 0, 'Ja)|R`eQt', 'Ja)|R`eQt', 'O-˗ƚo0WLFW!y9l`.', '', 0, '?'),
 ('l<\n^;3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingRequestBodyErrorException.php', 0, 'sh쇂)Jh', 'sh쇂)Jh', 'P<T$Xg9]q+:y5QŲ7J%', '', 0, '?'),
 ('*_dr', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityElementException.php', 0, 'pƺ)]XZ4', 'pƺ)]XZ4', 'y\\<bB\0Ճ;7HK;', '', 0, '?'),
 ('#`Y@#Yf', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityHeaderException.php', 0, '^+s~N', '^+s~N', 'Z}H&%t\";݆?)|\\?a83S', '', 0, '?'),
 ('sPgG@O%', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoLoggingStatusForKeyException.php', 0, '$kUs', '$kUs', '{up94ˡ_4LR,	2u4~y', '', 0, '?'),
 ('1RDnZ4|', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketException.php', 0, '9zd\'BWn&', '9zd\'BWn&', '?l񲔾a?ZV,Jx:eO', '', 0, '?'),
 ('ջtjGMʫU2', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketPolicyException.php', 0, '[*ªU&@', '[*ªU&@', '80#i\nHҦ{AU,TŸck', '', 0, '?'),
 ('EnpiL3A', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchCORSConfigurationException.php', 0, ',$\"Ѵk', ',$\"Ѵk', '~QwCZK`\0o\n5', '', 0, '?'),
 ('+M6M>ݹW', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchKeyException.php', 0, 'GXʐ\"RӔ0=C', 'GXʐ\"RӔ0=C', 'Dh6t^.8-H\\+z-', '', 0, '?'),
 ('YR+', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php', 0, '\\-Rx;ۦ', '\\-Rx;ۦ', 'I16^,bhDDUh2\Z', '', 0, '?'),
 ('6RJp\Zwe', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchTagSetException.php', 0, '(MbSY(\'ց', '(MbSY(\'ց', 'Mi]zWӍ@', '', 0, '?'),
 ('vP͹kïߜ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchUploadException.php', 0, '\rssW`6ٍ/', '\rssW`6ٍ/', '/12Y3I[A!X׿', '', 0, '?'),
 ('!nWd%Juo', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchVersionException.php', 0, 'R@yZ_', 'R@yZ_', 'wIin;r3&? :H', '', 0, '?'),
 ('Մǋ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php', 0, 'mm^V3Cl', 'mm^V3Cl', 'hUdkF\ZI9{>	<9', '', 0, '?'),
 ('$3]O|䠥fLac', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NotImplementedException.php', 0, '?D\rv-', '?D\rv-', '/c<\rXՔ2\r$^@sQcb', '', 0, '?'),
 ('NL衯GDt@^', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NotSignedUpException.php', 0, 'ՀI Ͻ1hnKq', 'ՀI Ͻ1hnKq', ' p\ZopoHz\Zׇc`-l', '', 0, '?'),
 ('痫72;Sz%\r', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NotSuchBucketPolicyException.php', 0, 'ۛ{W\0(', 'ۛ{W\0(', 'E4STAMCC9:񢑻	NNkeN)', '', 0, '?'),
 ('\'_@WŨ!^̗\"', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php', 0, 'Plv?4I9', 'Plv?4I9', 'd챋>=K^?ij[+$E]J', '', 0, '?'),
 ('=dc	c+Be', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php', 0, 'Rer%>Vlh=e#', 'Rer%>Vlh=e#', 'tja@R(sJI4\"+z\'S', '', 0, '?'),
 ('Dd?.^V#h\r', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/OperationAbortedException.php', 0, '*N1EJJ#!ɪ', '*N1EJJ#!ɪ', '\0M+ۻ8ATy$\r', '', 0, '?'),
 ('\'\"h', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/Parser/S3ExceptionParser.php', 0, '-G/wT{o4', '-G/wT{o4', ']]^W죟vSm|uR5', '', 0, '?'),
 ('QB?	QzΣe*', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/Parser/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Yzl#TUuNoXE', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/PermanentRedirectException.php', 0, 'mzY跄+&', 'mzY跄+&', 'DA	Md$2wuR>2$!%', '', 0, '?'),
 ('89\ne9{Ѿc(4I', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/PreconditionFailedException.php', 0, '0Buj:ڊ', '0Buj:ڊ', '\\ұq\\11n+(ʯcic.?', '', 0, '?'),
 ('ÁuKO\ZkWQWLL(', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RedirectException.php', 0, '˗.`i-ِ	', '˗.`i-ِ	', 'S0T.(4m3', '', 0, '?'),
 ('yM6NU7@', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestIsNotMultiPartContentException.php', 0, 'eܦ#c#R', 'eܦ#c#R', 'ɂX\\2i@rT3>', '', 0, '?'),
 ('M(Ks0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestTimeTooSkewedException.php', 0, 'Z,#ҭ\'j}AD&,', 'Z,#ҭ\'j}AD&,', 'X-rn/v_^ވW$sCK', '', 0, '?'),
 ('(̔0:B}', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestTimeoutException.php', 0, 'Z6q2VL*', 'Z6q2VL*', '2ekq:>qVKUtq9z', '', 0, '?'),
 ('RЙ\\+F8<z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php', 0, 'O߮/ me0', 'O߮/ me0', 'YNMKXNC0\0.}IT{`=\nw&', '', 0, '?'),
 ('ݧRE!K', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/S3Exception.php', 0, '`Ჰc߅', '`Ჰc߅', 'Ա\"UGLD߫\'r|d', '', 0, '?'),
 ('sŰ\Zrt3w', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ServiceUnavailableException.php', 0, '`\'1_k', '`\'1_k', '\Zw\n$}G&.|,KYigy', '', 0, '?'),
 ('e/q$\rӻ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/SignatureDoesNotMatchException.php', 0, 'nb-p&l?r5X+', 'nb-p&l?r5X+', '{/klSf=\rϱJll', '', 0, '?'),
 ('㽈mONAV;n', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/SlowDownException.php', 0, '@R?bdb)', '@R?bdb)', ')s[>c}lnr$YU-Y1', '', 0, '?'),
 ('im mIN\rv', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/TemporaryRedirectException.php', 0, 'o9-\Z*Iutv', 'o9-\Z*Iutv', 'k_!+0vwYwpaI\r', '', 0, '?'),
 ('p5@f9(', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/TokenRefreshRequiredException.php', 0, '(3>\'׮ ]', '(3>\'׮ ]', '1l\00|h\n-|hG{=̉', '', 0, '?'),
 ('gY\0(`u<*', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/TooManyBucketsException.php', 0, '눃L֠gP6}y', '눃L֠gP6}y', 'h\Z{3:kSE]zB+ڂS', '', 0, '?'),
 ('U9r0\rJ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/UnexpectedContentException.php', 0, 'OcUoM', 'OcUoM', 'cG8J$(<]fa81*\0{$Ƀe', '', 0, '?'),
 ('ze@!d)t', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php', 0, 'r3D0z0u؊', 'r3D0z0u؊', '\'5 B\n<G͘.dn`eʒ', '', 0, '?'),
 ('zXqS', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php', 0, 'FZւ49', 'FZւ49', 'u3`!sܠN7m', '', 0, '?'),
 ('LGQ_Z^y2[', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\nr+viE\'', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/IncompleteMultipartUploadChecker.php', 0, '	6~\'	&`d', '	6~\'	&`d', ',22[ZrKd:nT]zHI\\', '', 0, '?'),
 ('1TSɉDL?q', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListBucketsIterator.php', 0, 'XjqޓG', 'XjqޓG', 'Or3U8Y!蘠V\0H;', '', 0, '?'),
 ('Iq:Wd=H3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListMultipartUploadsIterator.php', 0, 'kki9+c(fr', 'kki9+c(fr', 'lX\rh>	\ZE#ֳM29RH26', '', 0, '?'),
 ('iKLiu', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListObjectVersionsIterator.php', 0, '\n\\UZZW', '\n\\UZZW', '~m-S$&ckx6x).\'D', '', 0, '?'),
 ('MF7', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListObjectsIterator.php', 0, 'Xٚr;~n', 'Xٚr;~n', 'Mkd\"α!e:f\"[V', '', 0, '?'),
 ('6\0!MhK4C#', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/OpendirIterator.php', 0, '~AxP\"#\Z5F', '~AxP\"#\Z5F', '\"8FH;p9:\Z0v]	\Z\0V', '', 0, '?'),
 ('MW1v빑', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Ƚ_Ȱ:', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/Acp.php', 0, 'óܫ%MMڲ', 'óܫ%MMڲ', 'tOM;+Ӛhgn}_\nF^J[', '', 0, '?'),
 ('0sA1', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/AcpBuilder.php', 0, 'JwS:tFn', 'JwS:tFn', 'xVӈBڽƌ5ҧTW^Jy|', '', 0, '?'),
 ('dlވfXF	a', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/ClearBucket.php', 0, '`SƖ=', '`SƖ=', 'A&a_8%Z4a$%hB', '', 0, '?'),
 ('ѽ:~᫙%', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsBatch.php', 0, 'X0Ο5`tVL\0', 'X0Ο5`tVL\0', '1m8μ/ءt\'jP-U\\', '', 0, '?'),
 ('uɞސ룄بnHr', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsTransfer.php', 0, '-bi=\\d', '-bi=\\d', '^%fFPPӃx[q', '', 0, '?'),
 ('ǅ2LHɉ$', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/Grant.php', 0, 'ʥf.;?', 'ʥf.;?', '_MA\"x	#\0Y', '', 0, '?'),
 ('iCL$wgq', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/Grantee.php', 0, 'Jf)oP@4$', 'Jf)oP@4$', 'CCjQzܙ̻|.]sfS', '', 0, '?'),
 ('Si݈w?W', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/AbstractTransfer.php', 0, '+E7&', '+E7&', 'qߓ!2k)PAyꦤ', '', 0, '?'),
 (' ZYg޴cFX', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/ParallelTransfer.php', 0, 'SX4\01~Yo', 'SX4\01~Yo', '~aNXth̝+]', '', 0, '?'),
 ('3W;Vez|\"K', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/SerialTransfer.php', 0, 'I]JVKѶwc7', 'I]JVKѶwc7', '0C9\\	mF@pҍy#OZ\r+w(', '', 0, '?'),
 (')ɷ*GRj', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/TransferState.php', 0, '@:\"\'', '@:\"\'', 'zW\0&0/:G-hBx+M', '', 0, '?'),
 (',F)%n`', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadBuilder.php', 0, 'U(i#:j<;W̷', 'U(i#:j<;W̷', 'zaԫ:XBqsэw|ޭߩiZ3', '', 0, '?'),
 ('8;eM\0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadId.php', 0, '\'dK(;l%^`[', '\'dK(;l%^`[', 'oc#Rx>Ukq\n@?58ew', '', 0, '?'),
 ('e\06 =7', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadPart.php', 0, 'X.qe,	', 'X.qe,	', 'o,PΎrsFKW͛{))', '', 0, '?'),
 ('lP/\"mI9', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('|&S&\0í9U[l', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/PostObject.php', 0, 'o/Tp+V', 'o/Tp+V', 'AlrXcϬ-݁2ym4caM`!&z\Z', '', 0, '?'),
 ('sۺٖ 9y', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('W3Ze', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Resources/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('kYte', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Resources/s3-2006-03-01.php', 0, ';f|]wצ4!ITq', ';f|]wצ4!ITq', '!Vk?w^Oo.u`Zz=l', '', 0, '?'),
 ('S%\r{^Txq', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/ResumableDownload.php', 0, 'c#\rp\"s\r\n\Z', 'c#\rp\"s\r\n\Z', 'uJq(,^؎%[ٕ9Z', '', 0, '?'),
 ('mm]<)~9`', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3Client.php', 0, ';dAج,t+', ';dAج,t+', 'Za|߁=wlj߸U', '', 0, '?'),
 ('9.w^q5^fYD', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3Md5Listener.php', 0, 'Č̺d', 'Č̺d', '.L>#{\\kM->f\\E=	', '', 0, '?'),
 ('OO(g', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3Signature.php', 0, '\0YAxHT', '\0YAxHT', 'JUXQQ.!¡1y', '', 0, '?'),
 ('CXQb', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3SignatureInterface.php', 0, '0\ZXcr', '0\ZXcr', 'nڛaKI9G5\'/U32B\'#', '', 0, '?'),
 ('V Aff,jY', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3SignatureV4.php', 0, '1(>މmU', '1(>މmU', '\0Op}jWQVS', '', 0, '?'),
 ('M$I', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/SocketTimeoutChecker.php', 0, ',4YȦI_!k', ',4YȦI_!k', '	|a,0.oƯRAwLJ{', '', 0, '?'),
 ('RI!11 ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/SseCpkListener.php', 0, 't5}{uΩhQ', 't5}{uΩhQ', '\Z*	Eȯgf8#jUP', '', 0, '?'),
 ('}}w;[bD', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/StreamWrapper.php', 0, 'Yĝ|nm', 'Yĝ|nm', '7\rze]EN.4\\1LrFu9fH', '', 0, '?'),
 ('s	6S\"庍Z3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/AbstractSync.php', 0, 'gxg.%G?', 'gxg.%G?', 'c5VO\0=\'>\rgim', '', 0, '?'),
 ('{ߗ\"ar', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/AbstractSyncBuilder.php', 0, 'խuU7So6', 'խuU7So6', 'Zq)JYK[m>}G\"Z', '', 0, '?'),
 ('-\'\\<_', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/ChangedFilesIterator.php', 0, '8ocK#\rAjC', '8ocK#\rAjC', '9QVl&3Y,٦i{\n͒ܳT', '', 0, '?'),
 (']]qū))J(', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/DownloadSync.php', 0, '9VseU<', '9VseU<', '\\RC{V_U ]ȘΝ1U;', '', 0, '?'),
 ('W.-DQZ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/DownloadSyncBuilder.php', 0, 'ӡo˩݃W', 'ӡo˩݃W', '+{ƈ#}C *>i+<Zg', '', 0, '?'),
 ('2`UjE\0+', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/FilenameConverterInterface.php', 0, 'vjdWM6', 'vjdWM6', 'iH]^8aי`@3+', '', 0, '?'),
 ('d?ıqo', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/KeyConverter.php', 0, 'C8tevAR?S', 'C8tevAR?S', ')q5E~DZz\rI,u\"\n', '', 0, '?'),
 ('N!\Zi?', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/UploadSync.php', 0, '\r)', '\r)', 'F~h[,bC3xf*^\0=', '', 0, '?'),
 ('t4cY6', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/UploadSyncBuilder.php', 0, '`u&ţ?c', '`u&ţ?c', 'O7S/<IK0ќ798', '', 0, '?'),
 ('@bLXՖ4 {', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('#VP\'K)=', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('GD\0jԍU', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('jm	tkT', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/AbstractHasDispatcher.php', 0, ';mjJ0853ti', ';mjJ0853ti', '6;dfʘGz+^zd1', '', 0, '?'),
 ('Zi1׭\'nC?z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Collection.php', 0, '.u305H}׀', '.u305H}׀', 'z<fg݆TE3kxQd23', '', 0, '?'),
 ('?с1*;Zt', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Event.php', 0, 'G@', 'G@', 'o]\\Kߠ`̐|EaқAÑ', '', 0, '?'),
 ('d#YJ~\'', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/BadMethodCallException.php', 0, '\Z`#(c\ZQ', '\Z`#(c\ZQ', 'o8k7.JG.݋~yQ5e2', '', 0, '?'),
 ('\ZL˪KiEBn1', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/ExceptionCollection.php', 0, ']:HM3T', ']:HM3T', 'v\\H>/=\\', '', 0, '?'),
 ('3\\Ǡ\"Mp=X_\Z<s', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/GuzzleException.php', 0, ']ɡ}7S:<W', ']ɡ}7S:<W', 'Ѽov2+Ch6Xz\'p	/', '', 0, '?'),
 ('=/MW~:qB', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/InvalidArgumentException.php', 0, 'z{P38.枆#i', 'z{P38.枆#i', 'U~/tB\\pyfKW@)4', '', 0, '?'),
 ('P {6,o[o^&', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/RuntimeException.php', 0, 'Y@	:\"Ug\Z[', 'Y@	:\"Ug\Z[', 'GL˃M>c$CW', '', 0, '?'),
 ('EI!я<>', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/UnexpectedValueException.php', 0, ' 1;oKvOɹw', ' 1;oKvOɹw', '%t\"a˕4-Ev*s~D\rh7fQ', '', 0, '?'),
 ('DC6@noW', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('{}%Sꢬ$7V', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/FromConfigInterface.php', 0, 't~[@J', 't~[@J', '[mII>OMKR', '', 0, '?'),
 ('xx\\۴zx_qwɗ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/HasDispatcherInterface.php', 0, 'zX', 'zX', '$Qg->F3#YʚN{1{\\:\'hOݺ', '', 0, '?'),
 ('!8#d)\'y!?', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/ToArrayInterface.php', 0, 'F}a?:Jd', 'F}a?:Jd', 'o(knhJI!]:My>', '', 0, '?'),
 ('P\n3 gUcT', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Version.php', 0, 'j2\Z\0Yr', 'j2\Z\0Yr', ':i;\Zt/\'_|Nd{u\'ovf7', '', 0, '?'),
 ('^*?f5', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('k\\\0;Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/AbstractEntityBodyDecorator.php', 0, '\"2{%a', '\"2{%a', '*ZR	&A#!DrX.\\a', '', 0, '?'),
 ('X79%qg', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/CachingEntityBody.php', 0, '	? }#8F', '	? }#8F', 'HN}pеRF.PB*h!8', '', 0, '?'),
 ('|	ħ32', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Client.php', 0, 'F/g#q', 'F/g#q', 'D(pѝNu_e', '', 0, '?'),
 ('ʫtK\ZGHi', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/ClientInterface.php', 0, '@~|:O6', '@~|:O6', 'rw*uE~9E/Hmu,O\'fC', '', 0, '?'),
 ('hZMAbݒC', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlHandle.php', 0, 'z#	\0', 'z#	\0', '\rm~L\'E+=]2efpٷ6\"', '', 0, '?'),
 ('EOꍥݕX	R', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlMulti.php', 0, '0LNOڮ;h\n', '0LNOڮ;h\n', 'VO^NNH\'}V!@{l1䛵', '', 0, '?'),
 ('\'blg?R7', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiInterface.php', 0, '[\Zk܌_iLMY', '[\Zk܌_iLMY', 'r[.3crI\rPX)4d07vC1s', '', 0, '?'),
 ('m&Đ댋 lN', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiProxy.php', 0, '8`Cy;K', '8`Cy;K', 'm^{\\[FB^,-~;kl,4', '', 0, '?'),
 ('\"As,cCYX\"', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlVersion.php', 0, 'ND\rH', 'ND\rH', '\ZI`ӪcPA,̺ۚ_(', '', 0, '?'),
 ('J,AT3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/RequestMediator.php', 0, 'O>G-:ִ[', 'O>G-:ִ[', 'Î/{$Ԝ{1򚨾Ii҃', '', 0, '?'),
 ('[k!8d=', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\r\Z$}Rk', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/EntityBody.php', 0, 'Ƞp&5,', 'Ƞp&5,', 'ME/`TFd},D͏ZVn\Z', '', 0, '?'),
 ('N\0!\n˸!U', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/EntityBodyInterface.php', 0, '-)Md%Z?\0', '-)Md%Z?\0', '+{0O]g jM)s9DEO\Z', '', 0, '?'),
 ('\\Hh\r', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/BadResponseException.php', 0, 'X>GL6o\n', 'X>GL6o\n', '7	Ȯ.U7Ue`:5թ߁', '', 0, '?'),
 ('HM:vƌc#;', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/ClientErrorResponseException.php', 0, '|ӸL鸂', '|ӸL鸂', '%a&ghCSp8]7^=', '', 0, '?'),
 ('CY\ZT{3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/CouldNotRewindStreamException.php', 0, 'L]~5s4Y!ZBY\0', 'L]~5s4Y!ZBY\0', 'AwA/ǌkj|$YMzJqFi', '', 0, '?'),
 ('&3m) 9$<', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/CurlException.php', 0, 'o SAL', 'o SAL', 'yhM#dFh4ԟh|\Zr', '', 0, '?'),
 ('22WP6\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/HttpException.php', 0, '\'gaUP0ӾL', '\'gaUP0ӾL', 'X़+}HuSBv@	Eۆi3s) 5', '', 0, '?'),
 ('rB=L\\`8', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/MultiTransferException.php', 0, '}4d	:2Cr(V', '}4d	:2Cr(V', '\Z;Ѓv#HsHҽ[Iro2Ò', '', 0, '?'),
 ('9Leu[m\rC', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/RequestException.php', 0, '0>X<{:\Zވ	', '0>X<{:\Zވ	', '^xgz96G^q4', '', 0, '?'),
 ('pR@K', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/ServerErrorResponseException.php', 0, 'wt&qM{A', 'wt&qM{A', 'v;$xbnAxnmz,G\\_i', '', 0, '?'),
 ('Ə9~M-\Zavl԰T', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/TooManyRedirectsException.php', 0, 'OFM\n\Zv\nR', 'OFM\n\Zv\nR', 'H݃F:JJѴ\02ZE#o', '', 0, '?'),
 ('N8!^e\nr', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('y8=|2', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/IoEmittingEntityBody.php', 0, 'aVլ9\'T{wm\'', 'aVլ9\'T{wm\'', '-\0,jl6 =]{E!!Mꔛ\\', '', 0, '?'),
 ('>LK', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/AbstractMessage.php', 0, 'e5Q<\'}_>', 'e5Q<\'}_>', 'B #S5\Zkbo?mܚ7[', '', 0, '?'),
 ('&ED2v^;Σ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequest.php', 0, '̨~[gaʝ.K', '̨~[gaʝ.K', 'zׄ4bj،\Zi', '', 0, '?'),
 ('oXP1REm', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequestInterface.php', 0, 'mv~ޕ d\'iBv', 'mv~ޕ d\'iBv', 'K7Q<QMbMӐwY:z', '', 0, '?'),
 ('}%GbZ꯭|[q1', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/CacheControl.php', 0, 'BnbuwHfPP', 'BnbuwHfPP', '\n\'\Zq4W.vJ7JI)/K', '', 0, '?'),
 ('Svi\'&~\\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderCollection.php', 0, 'G`=\n', 'G`=\n', 'ԊkԒ1ُnn\\p5G,Y<', '', 0, '?'),
 ('m7j=.	', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactory.php', 0, 'd@G', 'd@G', '<eM! GbJP\n1˧5EApk', '', 0, '?'),
 ('s)&XqȡbXh', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactoryInterface.php', 0, '=9X =v6', '=9X =v6', '\Z\"npR&;W>W0s', '', 0, '?'),
 ('?=mWy^fƆ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderInterface.php', 0, '֧j', '֧j', ',\rL<n<pV.݋I*~<B2', '', 0, '?'),
 ('shimaW', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/Link.php', 0, '-DYe%	OB{)', '-DYe%	OB{)', 'l\n9~)5P\'IS3nǠC.', '', 0, '?'),
 ('7yD\'e%W\n', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('p=	Ҹl;D', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header.php', 0, 'JIa_)', 'JIa_)', '?.>(}EUI#DʽMc*', '', 0, '?'),
 ('yhOl9Ebg', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/MessageInterface.php', 0, 'dB\\p', 'dB\\p', 'N#MIF_0xZbe\"\0lس&N֏	]:', '', 0, '?'),
 ('#\"D^,HÄ!Ң.', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/PostFile.php', 0, '5룢3T\ZϹirv%', '5룢3T\ZϹirv%', 'bAC;8[פ4˼E%;\Z', '', 0, '?'),
 ('M	b:՛\"', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/PostFileInterface.php', 0, 'J5@W##&', 'J5@W##&', '+qߥ3JKi9RSYǵ٢', '', 0, '?'),
 ('/׉Y97e^%', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Request.php', 0, 'E^Ta|#J', 'E^Ta|#J', '3/v	%*WfOդ', '', 0, '?'),
 ('3\'!OE%3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/RequestFactory.php', 0, '6%:ް8', '6%:ް8', '3YfŒ鎎>^\',@uSc', '', 0, '?'),
 ('yPŤzV{', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/RequestFactoryInterface.php', 0, 'sp2=Dsx', 'sp2=Dsx', 'Lwo 䍖yΓk#鰖[Uy\0', '', 0, '?'),
 ('ɏc;\Z,J', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/RequestInterface.php', 0, 'ﮑ=TϺA', 'ﮑ=TϺA', '*l\'P`=:UG7[{b!D', '', 0, '?'),
 ('}?:ROZ_O^\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Response.php', 0, '+HdpfpflU%', '+HdpfpflU%', 'G?䘱7+A3G?Wxú{]R', '', 0, '?'),
 ('߱e8F2m?4\"', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('-ZAtEy`@;', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Mimetypes.php', 0, 'ۺQ^h2R}', 'ۺQ^h2R}', 'C4M{`Q&v<~]', '', 0, '?'),
 ('\r1	yrq', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/CommaAggregator.php', 0, 'o;mEO;ͩc$Q', 'o;mEO;ͩc$Q', '}ja5P;Y)8R\\ṡ', '', 0, '?'),
 ('Yoov	', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/DuplicateAggregator.php', 0, 'lږbk@rc', 'lږbk@rc', 'fcyPUZ6@c&qh_M.Eg', '', 0, '?'),
 ('~w;a.F(', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/PhpAggregator.php', 0, '>.>.FQ', '>.>.FQ', 'D|	@A!;c}hf', '', 0, '?'),
 ('tϛoKm\'', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php', 0, 'wIu>qSw,', 'wIu>qSw,', '\n$%xta%1{4(Kd䓧6', '', 0, '?'),
 ('xkmQTߑ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('^3-m	w$\"hf', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryString.php', 0, '3b[$1^n(J3', '3b[$1^n(J3', 'ZU(.ca{m|[s?MO', '', 0, '?'),
 ('4/IrGhܒs9', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/ReadLimitEntityBody.php', 0, 'tŚ)4/XS-Ӈ', 'tŚ)4/XS-Ӈ', 'Z\reNWDo2C-ȣOSL', '', 0, '?'),
 ('BB\\U8H', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/RedirectPlugin.php', 0, 'Xu*%', 'Xu*%', 'd.Tb\rҼ5v9wAA*?	f', '', 0, '?'),
 ('q6p%vpS', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Resources/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('mBb!925v', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/StaticClient.php', 0, 'H ژg', 'H ژg', 'rcy\'!*ts>\"84W~d', '', 0, '?'),
 ('_\0Cs', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Url.php', 0, '2LykKt', '2LykKt', 'ҶKwFu{?]{H8h', '', 0, '?'),
 ('nB x# B', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('oKiILH\\C', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/Inflector.php', 0, '9q@\0<Tq2', '9q@\0<Tq2', '2fF\' :;bZlREL~', '', 0, '?'),
 ('2mSHB', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/InflectorInterface.php', 0, 'Z_&ߩ7by', 'Z_&ߩ7by', 'bΟy10G}ʁUaQ', '', 0, '?'),
 ('E|,8 k', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/MemoizingInflector.php', 0, 'qm_2Y\"ձ', 'qm_2Y\"ձ', 'HRc\\X2_/-<6#{#y', '', 0, '?'),
 ('QHSQS\'\0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/PreComputedInflector.php', 0, '/XFR[z:', '/XFR[z:', '[sy@8q3B%My\rH$(', '', 0, '?'),
 ('.nm.$H', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('쫫yÁ+Xg<8R', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParser.php', 0, 'ҿ2}X%iK', 'ҿ2}X%iK', 'F^R)g>ϡK:jX?PcD>T\"BIz', '', 0, '?'),
 ('BŐ>toQ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParserInterface.php', 0, 'w̖pŁ', 'w̖pŁ', '4	Ir]}\'jretd4FuW\'', '', 0, '?'),
 ('#\\?Ð}', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Cookie/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\03I`::%{>', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/AbstractMessageParser.php', 0, '41q^R\\z', '41q^R\\z', 'IL[RIylb+ ^͇U', '', 0, '?'),
 (' t2ŃP\rBg떼', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/MessageParser.php', 0, 'ɅoNi0&', 'ɅoNi0&', '\0Bs5E҄C;N#Dgܖ\\g', '', 0, '?'),
 ('T\ntL-$x', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/MessageParserInterface.php', 0, ' `h9', ' `h9', 'hN}pԿ+.oq7=SU', '', 0, '?'),
 (':G翻1W?}\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/PeclHttpMessageParser.php', 0, 'nYd!GpN', 'nYd!GpN', 'e	f///{e	x#<I\\', '', 0, '?'),
 ('Gvm̽3', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('3<\'NLe$', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/ParserRegistry.php', 0, 'вlDf>;C', 'вlDf>;C', 'Ōdo|fu)gE-ss:Id9&', '', 0, '?'),
 ('Z\neߨM', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/PeclUriTemplate.php', 0, 'oUpmQ	', 'oUpmQ	', 'hv*[8A|khH1g|/;', '', 0, '?'),
 ('{&vw>s', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplate.php', 0, 'btOt.c', 'btOt.c', '~Mܓ\"fKc5P}5SqM', '', 0, '?'),
 ('F`XW~', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplateInterface.php', 0, 'Ҫ\Z\n8', 'Ҫ\Z\n8', 'qXLལfv3t-eP]H-V7!', '', 0, '?'),
 ('IO{N~\rwR', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('`aiZa0\nT', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Url/UrlParser.php', 0, 'D{K3Ş', 'D{K3Ş', '@egX.P/!7HŲ2Mh', '', 0, '?'),
 ('`~O+Ha;', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Url/UrlParserInterface.php', 0, '[Ŋ(:KLk', '[Ŋ(:KLk', 'ThDoT:}:Ym5$\n', '', 0, '?'),
 ('	YhI', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Url/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('rt7\'', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('cfBUN', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php', 0, 'jTysM\\', 'jTysM\\', 'JwdF疚>Y\rKB5vj\\<D΍', '', 0, '?'),
 ('vC.Ao\"\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php', 0, 'H!t3', 'H!t3', 'Ub\Zv5{y	:%gf', '', 0, '?'),
 ('HBd*cK', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffLogger.php', 0, ']Q}`k^&$2+', ']Q}`k^&$2+', 'E3+S!;3@M', '', 0, '?'),
 ('\n2`qPO*ye', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffPlugin.php', 0, 'Bd&@]	', 'Bd&@]	', 'Wr̃=J&AdUe\"C0,*g', '', 0, '?'),
 (',kNQ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php', 0, 'd֫\"Z7', 'd֫\"Z7', '>RUwYȉf\'\'-', '', 0, '?'),
 ('0M\nD#l20', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php', 0, '\'@NB\r8xu', '\'@NB\r8xu', '9V^6.C<I,+=$', '', 0, '?'),
 ('M/޳#m2,', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php', 0, '|}n<MN', '|}n<MN', 'st܀>6\"B:)J:d축g*', '', 0, '?'),
 ('-SxKR\n', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php', 0, 'do͡=', 'do͡=', 'X@ǭ*%Lz8MK61i\nW', '', 0, '?'),
 (';Uoٍjb;<Ꝭ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php', 0, 'ImK?`', 'ImK?`', 'tQ(l0Ղ\\mUvH4-1ē1B', '', 0, '?'),
 ('G|h	/kv|', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php', 0, 'WAES[1F/', 'WAES[1F/', '1Lf\0)K[~xJO\\uB^', '', 0, '?'),
 ('JOV)r@x', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php', 0, 'Y6<оE^_iH', 'Y6<оE^_iH', '\'d;i۝U*LQQ	Xhi6&<', '', 0, '?'),
 ('ֱ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php', 0, 'ި{hLߕ%', 'ި{hLߕ%', 'B4	\'ts_+VвڔEs', '', 0, '?'),
 ('I{(tͧwƛ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php', 0, 'L0>n', 'L0>n', 'EjFFm;wfKn(G', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES(':AaD', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('OՆ2B\r**i', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/AbstractConfigLoader.php', 0, 'WG	=7T K', 'WG	=7T K', '? }\rtJ\0ic͇F4k@', '', 0, '?'),
 (',A*-EL', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilder.php', 0, 'Öe6x[_S', 'Öe6x[_S', '?O8>|[}?l<)', '', 0, '?'),
 ('Rʢ.4\'%T', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderInterface.php', 0, 'tM;yXKKz', 'tM;yXKKz', ')bDdal˟+L', '', 0, '?'),
 ('%	Qג^(<', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderLoader.php', 0, 'J[֣\Zxf#', 'J[֣\Zxf#', 'ÝC_iG*~!n', '', 0, '?'),
 ('[F($~\"be`', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('52dg]', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/CachingConfigLoader.php', 0, 's<4=S0$', 's<4=S0$', '\r.%\'H/h׉V} *AA\\b', '', 0, '?'),
 ('_Ɔ\r;\"8h3+S', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Client.php', 0, '\"Bȣ_/jF', '\"Bȣ_/jF', 'ۓyD\'Ij}v,\nņ	a\0oe', '', 0, '?'),
 ('|!1ʰۮ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/ClientInterface.php', 0, '\Z4;[', '\Z4;[', 'xeo-O.Ip27', '', 0, '?'),
 ('RC@&>CP ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/AbstractCommand.php', 0, 'w\nCT{H', 'w\nCT{H', ' ɂ=a,\nU5d1tX«^-(', '', 0, '?'),
 ('x=dMW36', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/ClosureCommand.php', 0, '!Bj$', '!Bj$', 'ԶMސ#>\0`V)Af4I', '', 0, '?'),
 ('ĵwalC%aX', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/CommandInterface.php', 0, 'kGs]O|lT#', 'kGs]O|lT#', '1$څJ*kJl=	[Am*	', '', 0, '?'),
 ('\n	BTX	', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/CreateResponseClassEvent.php', 0, 'K<z=07SRÊ', 'K<z=07SRÊ', '^j6	|Nt9b֝', '', 0, '?'),
 ('\0A3b_h,6ݝky', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/DefaultRequestSerializer.php', 0, 'D;m/TgDs5tt', 'D;m/TgDs5tt', ']pI&\'1MIB;n+a!', '', 0, '?'),
 ('\"\"=F	d<', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/DefaultResponseParser.php', 0, '~!r)בW$-p', '~!r)בW$-p', 'j#=\"N9XIB1\nC˕1H}lE', '', 0, '?'),
 ('Pw^㺛', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/AliasFactory.php', 0, '|3KVDd', '|3KVDd', 'S{O3;}C	ajn2', '', 0, '?'),
 ('`mn\0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/CompositeFactory.php', 0, '{wa \0ɭ', '{wa \0ɭ', 'n&ڋ#=NH!\0RR5', '', 0, '?'),
 ('_x R', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/ConcreteClassFactory.php', 0, 'q㬎S\Zվf', 'q㬎S\Zվf', 'IPr\Z,OS7;۰C=\"', '', 0, '?'),
 ('6-\'lg̗[', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/FactoryInterface.php', 0, 'Yz\"J_5$[P', 'Yz\"J_5$[P', '72z/lP(_P?\"XA(', '', 0, '?'),
 ('dc9', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/MapFactory.php', 0, '\'6L|7', '\'6L|7', '2؈WHsiuK(U', '', 0, '?'),
 ('b2;s[ujL', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php', 0, 'Tڟ(@fpg', 'Tڟ(@fpg', ',{:FB_ivZ6ub	', '', 0, '?'),
 ('Y6?-o.]<ŴH', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('/F\Z=F=', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php', 0, '={N3.,', '={N3.,', 'Wl,FMRN\ZBkw^|Nƫ', '', 0, '?'),
 (';yTs^w', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php', 0, 'Ñ\ZW僫', 'Ñ\ZW僫', 'Iw)41T-Z$[[A', '', 0, '?'),
 ('	P̖[龚}2߅]', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php', 0, '`m{U#he', '`m{U#he', '\r5\08Ź_~@<Ko%R|_zAY', '', 0, '?'),
 ('`ZS$h`', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php', 0, 'sχr}O;6', 'sχr}O;6', '7`ZN|ao\'9Wv&o', '', 0, '?'),
 ('F+*Ӕ\0a	=G', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php', 0, 'Za)֞rV', 'Za)֞rV', '\nSTx){$gd	|d<|', '', 0, '?'),
 ('0=Hfvt', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php', 0, 'd礲	F2%\\d`', 'd礲	F2%\\d`', 'N١ҍIj\0Ɋl J!ya-', '', 0, '?'),
 (';u=Nx+E', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php', 0, '\Z\'^NW%wdI', '\Z\'^NW%wdI', 'lhț;͘Y_ |Cn*@', '', 0, '?'),
 ('ZzRŐR3?', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php', 0, '.(!>An#<G', '.(!>An#<G', '{LYVr?O室\\ض\0', '', 0, '?'),
 ('ZΥ<=\03B', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php', 0, '9t\ne]K~,', '9t\ne]K~,', 'EF2s/`\n]XǋkȺz={I', '', 0, '?'),
 ('sʿ|?{T', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php', 0, 'B&7vs,.', 'B&7vs,.', 'hbA5)\n}S', '', 0, '?'),
 ('{yOu]', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\'E1tl[X`v', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php', 0, '}eeUXN*$T', '}eeUXN*$T', '\Z	4$T\\O~K=4Kj߇\\\n	', '', 0, '?'),
 ('ҲwdcOF{p^Ap', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php', 0, 'ݬq]bsZ{\Zj', 'ݬq]bsZ{\Zj', '/}n?L\ZO}G4w%t{a', '', 0, '?'),
 ('I<F 5oL<^', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php', 0, 'N%ZR9f', 'N%ZR9f', '%r\nKaUdd#z5Z', '', 0, '?'),
 ('iA`XݡJT>', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php', 0, '$ʧXTU', '$ʧXTU', ':7^h%̼8\ZrYZ!+', '', 0, '?'),
 ('jWފ\ZviF.ΐ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php', 0, 'Yxvs5{`$', 'Yxvs5{`$', '}0˯r̲]4TETL-', '', 0, '?'),
 ('b|V0&', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php', 0, '\'3T-Noa2', '\'3T-Noa2', '_r}KuGbufe/wΜgmXO', '', 0, '?'),
 ('	SD6D=', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php', 0, 'qp)JiDs', 'qp)JiDs', 'OOɫ͚jTBIt1x`\r$q', '', 0, '?'),
 ('뷋%\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php', 0, 'tzѸڶB~R+', 'tzѸڶB~R+', '?<6\0#Q!=h혪', '', 0, '?'),
 ('n2qؠo', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('g$܀s<-B', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php', 0, '`._?&\'h', '`._?&\'h', 'A\Z6\ru\'IbXU[#t#\'t', '', 0, '?'),
 ('`|s7TWg', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('LĘCSNz', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/OperationCommand.php', 0, '`2t#2 ', '`2t#2 ', 'x^#E7碭YY#\r-wMOQQ', '', 0, '?'),
 (';#+``Q|h', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/OperationResponseParser.php', 0, 'AJ0	B[', 'AJ0	B[', 'b;ȾRXo\'վ]\'&K\r߳}', '', 0, '?'),
 ('NF̥#\\p֓m;a', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/RequestSerializerInterface.php', 0, '~]\'p}A=05V', '~]\'p}A=05V', '$T[$NMNe\rU6pBޯ', '', 0, '?'),
 ('Cdc$1{znxI', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/ResponseClassInterface.php', 0, '2tLc_ܓ', '2tLc_ܓ', 'O~GCs*󽿺3U`E', '', 0, '?'),
 ('Ѿ]nMS', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/ResponseParserInterface.php', 0, 'JVO_fL', 'JVO_fL', 'E38zݤude?\\', '', 0, '?'),
 ('	қo:8ތ(Tc^', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('~ѹh', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/ConfigLoaderInterface.php', 0, ',ң]/$P^j3Ѧ', ',ң]/$P^j3Ѧ', 'I:l\ZGQlnՓIi5+', '', 0, '?'),
 ('ݫ^BwSnK', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/Operation.php', 0, '\'j`Q<rkkA)=', '\'j`Q<rkkA)=', '0?^|zT*$||DVB\rcU`', '', 0, '?'),
 ('EZ1\ZGE', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/OperationInterface.php', 0, 'W	+.@X\rl', 'W	+.@X\rl', '7jlgZS\'Bƪ+&\\}S', '', 0, '?'),
 ('_` \ZeuR>\'', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/Parameter.php', 0, '\\fIQ17A', '\\fIQ17A', 'ISVڧ\Zc:&\\7پ8c|', '', 0, '?'),
 ('`|w:_q', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/SchemaFormatter.php', 0, '_˥ v׫l\Ze', '_˥ v׫l\Ze', ' ;c:׊I7 /3nm', '', 0, '?'),
 ('}~ߪ	]#', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/SchemaValidator.php', 0, '-G7|', '-G7|', 'VPDI)]Ћ7:.StL', '', 0, '?'),
 ('[G9U(lG', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescription.php', 0, 'm 2\Z', 'm 2\Z', 'pImC0\r}=BG	@+Ş', '', 0, '?'),
 ('xqDS', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionInterface.php', 0, '/B', '/B', '#YgNw\'@\"?', '', 0, '?'),
 ('ew\\tz۽', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionLoader.php', 0, 'af3a,T', 'af3a,T', ')Q0.spE#hP/vM,\nW~', '', 0, '?'),
 ('815&', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ValidatorInterface.php', 0, 'Hc?[Ӟ\ZD', 'Hc?[Ӟ\ZD', '\Zy)6\n!}eZ)`CFa@2ͷ;w', '', 0, '?'),
 ('c͡l|', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('}|Z֓b5]~', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/CommandException.php', 0, '{WӲ@{}[_', '{WӲ@{}[_', 'F|D\Z*l\0HV<`\Z\'A6g\0', '', 0, '?'),
 ('ν-\nHGoy', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/CommandTransferException.php', 0, 'Ei!*3r(H', 'Ei!*3r(H', 'NNT~(E~olfًn\Z	', '', 0, '?'),
 ('mVn5E#', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/DescriptionBuilderException.php', 0, '2IL} qrUR5', '2IL} qrUR5', '7\'\\s̅؍Δ8\ri', '', 0, '?'),
 ('*׃Rs', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/InconsistentClientTransferException.php', 0, 'H5_v:', 'H5_v:', 'g\0~ϵ!t~FBD@!ɏ', '', 0, '?'),
 ('ifYc5hwջu2', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ResponseClassException.php', 0, '`W-vZj\0(R~', '`W-vZj\0(R~', '5&ÝO\04CD\n0\'S', '', 0, '?'),
 ('~6/EVeM', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ServiceBuilderException.php', 0, 'A9Ch?_?S', 'A9Ch?_?S', 'ӊ\r8ܢ?5UŸqn', '', 0, '?'),
 ('˟jQ!', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ServiceNotFoundException.php', 0, '2M$0\"9=', '2M$0\"9=', 'XAe{S`;.\n -', '', 0, '?'),
 ('`9\"%\'\Za', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ValidationException.php', 0, 'D+FN-', 'D+FN-', '5\Z]K/0=@oYl/߱k', '', 0, '?'),
 ('E?:[Ml鞅', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (')wI5 t]zQ+&', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php', 0, '_r|.ؾQi}\0)4', '_r|.ؾQi}\0)4', '&/@~	p)ƈ5\"0T+', '', 0, '?'),
 ('\nzT+SMS', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php', 0, '@nҷ\Z@2{Uz', '@nҷ\Z@2{Uz', '䧕e#	Ȯ\nz+MLP!p_Kr', '', 0, '?'),
 ('UM\'sEИ=', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/MapResourceIteratorFactory.php', 0, 'h', 'h', 't5\Z˜ۛ\'	Zi`v܉g+ť', '', 0, '?'),
 ('C)*K_', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/Model.php', 0, '\'W\0TOKW', '\'W\0TOKW', '`Ӱ )כ*̵\Z-{]g', '', 0, '?'),
 ('ޕ2lǈx:\Z', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIterator.php', 0, '^᫅}Z~jK}', '^᫅}Z~jK}', '$R5ާqM>SDg\ZX', '', 0, '?'),
 ('k-ld8Co', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php', 0, '\\A]5̡R2', '\\A]5̡R2', '\'hR<I1gYoDLs|ۢ\"9', '', 0, '?'),
 ('cn85o5', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorClassFactory.php', 0, '#H;UNVNId', '#H;UNVNId', ']g#CPg#pK-y-ݖ', '', 0, '?'),
 ('*Oxv\'IP', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php', 0, '_\\ޛ#zbY', '_\\ޛ#zbY', 'mݩuVGxapr', '', 0, '?'),
 ('x\'3O', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorInterface.php', 0, 'S\\2?b', 'S\\2?b', 'qӞm`zJ<\0(x=', '', 0, '?'),
 ('	Ns\nX ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('1\\pp7t1', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('@ɿT\0BN=f_*', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/PhpStreamRequestFactory.php', 0, 'qy<@9u$C', 'qy<@9u$C', '\"W\ZXD(ʭߎ (UV.qJ', '', 0, '?'),
 ('v	,ְＥD', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/Stream.php', 0, 'g<kiZQzA', 'g<kiZQzA', 'f&L_CZh\Z@څQON?\r\n', '', 0, '?'),
 ('a>? 6ڻ0', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/StreamInterface.php', 0, 'Ĉa', 'Ĉa', '7kVI\Z5ya\"?G=	XYC', '', 0, '?'),
 ('5wW\Zp:]~\\', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/StreamRequestFactoryInterface.php', 0, '-dr6gTz=', '-dr6gTz=', '!l\0=XTauZS', '', 0, '?'),
 ('s!zQpH	', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('`|n}Y', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (';c\Z9ΐ Vj', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/ContainerAwareEventDispatcher.php', 0, '\rϔs.6̇a ', '\rϔs.6̇a ', '(*@4Yٝ\0X֊Ʀ:p', '', 0, '?'),
 ('\nH%<\"Nq)l#', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/RegisterListenersPass.php', 0, '{!Ń&G3', '{!Ń&G3', 'mO5C&ܑf(Mjy\"#', '', 0, '?'),
 ('5+.WYdOfƏ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (' H\ZƩxӔI_', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/Event.php', 0, '.\r*^{L', '.\r*^{L', '\"=Чk&?\\e}oVfs6/2ĬW', '', 0, '?'),
 ('mϺDvB)', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcher.php', 0, 'yno]8:~\0', 'yno]8:~\0', '	=vOi%IA\n=(R', '', 0, '?'),
 ('6[߅C4FF', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcherInterface.php', 0, '	p<,>@(NJ>\Z', '	p<,>@(NJ>\Z', 'kBp]Ƹ/>\rhsw', '', 0, '?'),
 ('ǏRKS4', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventSubscriberInterface.php', 0, '\rySZy5', '\rySZy5', 'x&NEfӻcl3!ac,', '', 0, '?'),
 ('nPE_l˹*', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/GenericEvent.php', 0, 'i&a_B>/', 'i&a_B>/', '͓I$Ppf\Z!;/{=o<', '', 0, '?'),
 ('o}%65', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/ImmutableEventDispatcher.php', 0, 'u\r\nL<h', 'u\r\nL<h', 'pn=߂}	$^vZI	yV2E', '', 0, '?'),
 ('(=*55wHAR)', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('lۊ1x>)', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('3x9\"aovS;S', 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('-SNEGԦ@9Mm', 'wp-content/updraft/plugins-old/duplicator-pro/aws/aws-autoloader.php', 0, 'Jd\ntP=H龜', 'Jd\ntP=H龜', ' X\ZJosBY \0.Q<O', '', 0, '?'),
 ('3&ܗ', 'wp-content/updraft/plugins-old/duplicator-pro/aws/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('X\'\r15', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.archive.config.php', 0, ';\'C 颠!\n$o', ';\'C 颠!\n$o', 'W+8|w5kRT4~X', '', 0, '?'),
 ('R\0@ВBos\"ƞ', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.constants.php', 0, 'xfRO<,$=n+', 'xfRO<,$=n+', '8_UP_P)_יI۴O4', '', 0, '?'),
 ('q @%ee$r', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.crypt.blowfish.php', 0, '\ZsBd', '\ZsBd', 'J*^\nZL{j.	[\Zg?+k\0	Y', '', 0, '?'),
 ('?I4Z*', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.crypt.custom.php', 0, '_״z<P', '_״z<P', 'R+H*\ZRd!lfYO)a', '', 0, '?'),
 ('mt舉\\+', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.db.php', 0, 'P_+OM濁]', 'P_+OM濁]', '[4̏kY18F%#DԅX_', '', 0, '?'),
 ('1h\Z\\bq1<&h2@', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.enhanced.plugin.updater.php', 0, 'p\nU\'|p{N', 'p\nU\'|p{N', 'N2rzC),y[_2h	\'z!΋|m', '', 0, '?'),
 ('֍  `Cȏ7', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.exceptions.php', 0, ' ^p\'bNŬO\\', ' ^p\'bNŬO\\', '\"L<SN6v8IbW칫%[0', '', 0, '?'),
 ('/N52mpW', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.io.php', 0, 'QUߟ30', 'QUߟ30', 'qׇpJz±Qngߛ', '', 0, '?'),
 ('J+\"j{3L', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.logging.php', 0, 'Utu#|bB', 'Utu#|bB', '-(7t90XqM<|Pn-k', '', 0, '?'),
 ('^\Z;\',', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.package.pagination.php', 0, '3NҊ{%', '3NҊ{%', 'OH0k4wQܰnd+^UO', '', 0, '?'),
 ('p@}D!OJ,', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.password.php', 0, '<B}k', '<B}k', '\nʢH\\lɭlqK]^I\0w;', '', 0, '?'),
 ('^q//5!8', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.php.log.php', 0, '	>\nXιjr', '	>\nXιjr', '.cB!.H	dG׫?Gr', '', 0, '?'),
 ('}ϫhmπz˄0', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.scan.check.php', 0, '@Q;`@; ', '@Q;`@; ', 'J!Qp9+|Kw\\yIY6ĨK:k', '', 0, '?'),
 ('d}52<\Z$', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.server.php', 0, 'lg/ĳdz9[', 'lg/ĳdz9[', 'GD\'3C_	`KDlB[	%\0', '', 0, '?'),
 (')\0Ey', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.system.checker.php', 0, '	ek(yv3', '	ek(yv3', '#}Q1|%|<ORcb&\\Oy', '', 0, '?'),
 ('cp\Z-MP', 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.wp.list.table.php', 0, '^O3-S', '^O3-S', '?ƦHI4&ROp&1n/_8`jQm', '', 0, '?'),
 ('6g7s˽ʙ%', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.brand.entity.php', 0, 'יaMӲ', 'יaMӲ', 'gD{J]J*~^\\u7ۦw', '', 0, '?'),
 ('.9/&띎d', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.duparchive.expandstate.entity.php', 0, 'm庁03@__', 'm庁03@__', '\Z\0m9#&', '', 0, '?'),
 ('r-T|;oV\'', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.global.entity.php', 0, 'bs RϥbR', 'bs RϥbR', '3>fD\rk4SA', '', 0, '?'),
 ('3F)\ZZ&[L', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.json.entity.base.php', 0, 'CJ\0͹c', 'CJ\0͹c', 'T|^\0WPhRMc', '', 0, '?'),
 ('`{j\'\"@2', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.package.template.entity.php', 0, ')oL]\n', ')oL]\n', 'q\nfK~4ՓWyTr}.', '', 0, '?'),
 ('~L\"ۡ`<w~N', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.profilelogs.entity.php', 0, '0[B	e', '0[B	e', '^v:)BQC?o', '', 0, '?'),
 ('{_Og', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.schedule.entity.php', 0, 'wKP#E:Ye', 'wKP#E:Ye', '\\u8e	zI@v^G', '', 0, '?'),
 ('nbZtJȆF', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.secure.global.entity.php', 0, '2 DRڵt', '2 DRڵt', 'ȏܿ|X Ɛ/;\nwd(y', '', 0, '?'),
 ('@$W\Z)mu', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.storage.entity.php', 0, '*mgf9', '*mgf9', 'hYLrs:Y.	.^^L\n)GD`', '', 0, '?'),
 ('F6y_', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.system.global.entity.php', 0, 'za\rB\Z-\rU\r2', 'za\rB\Z-\rU\r2', '3}Qjbĥ&2qɅz', '', 0, '?'),
 ('-n{@%Dz', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.verifiers.php', 0, 'ɟo\r4', 'ɟo\r4', 'e;=R %9o<ݬ=@;=', '', 0, '?'),
 ('Aba]Nև\0', 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('IיUFc05`', 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/class.db.checker.php', 0, '{Ů\r?34+o', '{Ů\r?34+o', 'dE[е6p -Z^VC@5', '', 0, '?'),
 ('л\"Fy$', 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/class.environment.checker.php', 0, 'eR\\aΏX	\ZX]', 'eR\\aΏX	\ZX]', '_X)kM0\0لjZmTP}+', '', 0, '?'),
 ('ܿS*', 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('R3csLG\'03*9', 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/interface.checker.php', 0, 'zG頟4#܀', 'zG頟4#܀', 'r=_5V Vi~Uzv}~P', '', 0, '?'),
 ('zkl', 'wp-content/updraft/plugins-old/duplicator-pro/classes/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\0/\nt<h', 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.ftp.chunker.php', 0, 'عMa\n', 'عMa\n', 'ԵoNPV$w=>2', '', 0, '?'),
 ('F8.O\0ڊ*', 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.u.gdrive.php', 0, 'yHbAeȨ', 'yHbAeȨ', 'Jk(ݝQY-#	*eIۣLUY', '', 0, '?'),
 ('0/H]', 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.u.onedrive.php', 0, 'AC:xH\n', 'AC:xH\n', '!i^XDĕդ-h\ZLS', '', 0, '?'),
 ('\Z,v?ST', 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.u.s3.php', 0, 'tŭ3&rB', 'tŭ3&rB', '?s.GT_,׀t\Z-չ\nw*8', '', 0, '?'),
 ('¥_daN\\', 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('K,4 Seа,', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.available.php', 0, '\"}Ц{d', '\"}Ц{d', ')Kx˾L9^a>>q3?0\"n', '', 0, '?'),
 ('2G<V)S F', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.filters.php', 0, 'P?qB:	}', 'P?qB:	}', 'j7ͪ<)?\0\0h!\"\'WQ_', '', 0, '?'),
 ('\0`Y2ZUH}', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.php', 0, 'W?/Ac1za', 'W?/Ac1za', 'ʮ-Cw_N05ѡE~<йV%O+oa', '', 0, '?'),
 ('XA-2', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.shellzip.php', 0, '%it', '%it', '`_dbOhkM2sDˌ۪G', '', 0, '?'),
 ('\Z>Bdj1', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.zip.php', 0, '.$EoB!!Ұn}', '.$EoB!!Ұn}', '/{*gFOL?;\Z*m5ܟ`/X9', '', 0, '?'),
 ('m|3S:\r', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.database.php', 0, '3نWk\0RL$', '3نWk\0RL$', 'S.\r\'ݍӞex?+', '', 0, '?'),
 ('[Bx@a<ޅR[', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.installer.php', 0, '/&2ώ5N', '/&2ώ5N', '-M\rTMaT\Z*/	wx4C', '', 0, '?'),
 ('3FZ\'>~', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.multisite.php', 0, 'qBӡf\'@=', 'qBӡf\'@=', '> \\.|8]=p	鑲', '', 0, '?'),
 (']ǳ\\^Ew]', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.php', 0, '2/~Ճ\Z\Z ', '2/~Ճ\Z\Z ', 't&XYL27/VOLj', '', 0, '?'),
 ('Uq:b Z+n>b9', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.runner.php', 0, 'j?gvDJ', 'j?gvDJ', 'v2*eJ46\\@DԐF\n', '', 0, '?'),
 ('GW:}\\R!', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.upload.info.php', 0, '7bNoӘz\"C', '7bNoӘz\"C', '/	 LeKruvBd8 K', '', 0, '?'),
 ('5/b!|', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.php', 0, '@|Cb	\r4)a	', '@|Cb	\r4)a	', '3X}a1\"(%\\uf\"F', '', 0, '?'),
 ('˃(B|!0)', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.create.php', 0, '_\n%5$', '_\n%5$', ';WfQѥ3;̎ɽVTTz\rq:', '', 0, '?'),
 ('OtoxoT}', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.expand.php', 0, 'ڱn,(Hc', 'ڱn,(Hc', 's W? Yypi[WI+~', '', 0, '?'),
 ('[#>t-:)r', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('{T?av%z{a#', 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('xQC: -O', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.alert.php', 0, 'p*zO?M\0I*', 'p*zO?M\0I*', '̂ʸ\r_[3Dzb0-aW T', '', 0, '?'),
 ('P%\nGa|w', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.dialog.php', 0, ';Е\'W{<g', ';Е\'W{<g', 'XȠW$T՟k GH%shdX?]', '', 0, '?'),
 ('D[48', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.messages.php', 0, 'MjOX}è', 'MjOX}è', 'd*@v};@nkh\n\Zߙg', '', 0, '?'),
 ('h>\n漍=q', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.notice.php', 0, '6[Rp', '6[Rp', '.02EDVXΜ!XexrM=', '', 0, '?'),
 ('sߊdib?J!k', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.php', 0, '6DEr)w', '6DEr)w', '|w3@މNID-__.', '', 0, '?'),
 ('Zܪ愪p)=', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.screen.base.php', 0, 'E@7lUAe', 'E@7lUAe', 'xrP=9徼439Hb\\)(|	', '', 0, '?'),
 ('Iegʫ\Z@+', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.viewstate.php', 0, '+7Q\'~@M]g', '+7Q\'~@M]g', '8(Ys.vc]P*Q', '', 0, '?'),
 ('v\")/9E~k?Ȩ', 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('~ՉRxWB', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.date.php', 0, '0TնĆ<6 ', '0TնĆ<6 ', 'vz?)zWYZ[\0U', '', 0, '?'),
 ('ꓰ{7OsL|', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.import.php', 0, 'u$GV|2-', 'u$GV|2-', '} wSI,WƅXI%*a>', '', 0, '?'),
 ('&ɳ\"r[	H\n^5', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.json.php', 0, '8xW{酆', '8xW{酆', '\r&6\nS1pdi`4TCh', '', 0, '?'),
 ('BafnXV9', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.license.php', 0, '&Ȫ$]m', '&Ȫ$]m', 'T%^$[!#Z\n$Fz>\'\r?8Z', '', 0, '?'),
 ('Xُ{?;', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.low.php', 0, '>-̢L,', '>-̢L,', '3uҹ8evT$4U	', '', 0, '?'),
 ('!wwDHL', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.multisite.php', 0, '<XaCf$\n', '<XaCf$\n', '\"ZnTFѓF݀ͽ*(^R]#2˦H', '', 0, '?'),
 ('yrˏ5SDL+|', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.php', 0, 'DB!}I', 'DB!}I', '(WOC\0Ut$^X]^:', '', 0, '?'),
 ('\0J&~0&v86', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.settings.php', 0, 'DB5IM', 'DB5IM', 'q<Qü~3m\'gƔHAi', '', 0, '?'),
 ('={ȋT2', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.shell.php', 0, '2i/H\0!K ', '2i/H\0!K ', 'G,8mc XPǅM@wej', '', 0, '?'),
 ('@-Ou\05', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.string.php', 0, 'Yq6^ O؃&Њ', 'Yq6^ O؃&Њ', '63u=/ąEEq#N͹', '', 0, '?'),
 ('T#~XΆx<', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.tree.files.php', 0, 'Kڒ__ˮs', 'Kڒ__ˮs', 'b,3_\r\rl 2{?J-', '', 0, '?'),
 ('ZdxѧԉTN', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.upgrade.php', 0, '$p2yx/g\"ѵ', '$p2yx/g\"ѵ', '`asj|M99bE', '', 0, '?'),
 ('[w~tyy', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.validator.php', 0, '{R^ϛ>mK', '{R^ϛ>mK', '`w\'<q+\\1H:2JM<nͨK\rs0', '', 0, '?'),
 ('by|$l LV+', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.wp.php', 0, ',	^xt%Fqv', ',	^xt%Fqv', '_Fyrf]\0O-!6', '', 0, '?'),
 (' ۡOH7ay', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.zip.php', 0, 'mhz', 'mhz', 'o}Q8WtZG', '', 0, '?'),
 ('o~-Q~k', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('D\Z5Ӱ*^g\\', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.test.debug.php', 0, '6eҏ?K@', '6eҏ?K@', 'OZw`\nUr USPkl8Mn¡', '', 0, '?'),
 (' p^vDQi)b', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.test.package.build.php', 0, 'l`7[eK b. ', 'l`7[eK b. ', '4JNnuю#m,cc*\\', '', 0, '?'),
 ('hI̴8׼@', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.u.test.abstract.php', 0, 'D-!Tfg R', 'D-!Tfg R', 'IM%Qa)I?TT6H$:', '', 0, '?'),
 ('AO;&9ԸL', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.u.test.result.php', 0, '2}Pa\\x', '2}Pa\\x', '<]aYdTvȝB\rF:', '', 0, '?'),
 ('p3Mb8', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.u.tests.manager.php', 0, 'v({ת5#', 'v({ת5#', 'ʎVz;x\00gu\0E,:\0z2', '', 0, '?'),
 ('dB>Yj', 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/wordpress.core.files.php', 0, '~ym?{\r', '~ym?{\r', 't9a QX2o07܋', '', 0, '?'),
 ('ԋ~EgQKި', 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/class.web.services.php', 0, 'm#g4', 'm#g4', 'Ƭr;@\nR|\\ 5d\nc#&Lg', '', 0, '?'),
 ('WMMߦ', 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.base.php', 0, '^BhJ,.', '^BhJ,.', '89R=TKΆ>;i', '', 0, '?'),
 ('6> Ama', 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.package.php', 0, 'Vsr(4u+tk', 'Vsr(4u+tk', '~.fSjWk8Z;4pa΄Чa', '', 0, '?'),
 ('rĒS?0jB', 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.schedule.php', 0, ';3_ҁ3\'$', ';3_ҁ3\'$', ')/7&fbie;:~', '', 0, '?'),
 ('jw55b!', 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.tools.php', 0, '?<2]Hi', '?<2]Hi', '{)R0X{^ւAm-ˬ98g', '', 0, '?'),
 ('?n,ea', 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('s6m@I;', 'wp-content/updraft/plugins-old/duplicator-pro/debug/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('[phGa', 'wp-content/updraft/plugins-old/duplicator-pro/debug/main.php', 0, 'Rm7i4', 'Rm7i4', 'ڭ~q\"eWw\Z0ƑZH<j=}', '', 0, '?'),
 ('rI:m9o', 'wp-content/updraft/plugins-old/duplicator-pro/debug/tst.packages.php', 0, '+1\"(}˓x}b', '+1\"(}˓x}b', '1H5n\\ն6	&ٿ@%(', '', 0, '?'),
 ('؈Ө\\.2̑', 'wp-content/updraft/plugins-old/duplicator-pro/debug/tst.tools.php', 0, '\'OJpZp1', '\'OJpZp1', 'j3!CePA=c^$', '', 0, '?'),
 ('ك', 'wp-content/updraft/plugins-old/duplicator-pro/define.php', 0, '}00wBJ^', '}00wBJ^', 'O+Y֣	8 QSg\"կr4s', '', 0, '?'),
 ('w1Q@vQ9Zg', 'wp-content/updraft/plugins-old/duplicator-pro/duplicator-pro.php', 0, 'sGW_a', 'sGW_a', 'N_lXE_+gcWa', '', 0, '?'),
 ('%zsR\n؂ߘw', 'wp-content/updraft/plugins-old/duplicator-pro/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('m&K%)?bV', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dtoken.php', 0, 'M̛Z{hcZ', 'M̛Z{hcZ', 'K	\'.TRI!{\"lf_4AR', '', 0, '?'),
 ('Pʕ+ 9!0/', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/class.api.php', 0, ',&^:9OCmt=jR2F', ',&^:9OCmt=jR2F', 'W@ʩ:qЄՆM	hc둾bR', '', 0, '?'),
 ('hJ_a:', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/class.cpnl.base.php', 0, 'B/xG3}B', 'B/xG3}B', 'seKbd\\`B[M-*8m`', '', 0, '?'),
 (':ʏaί', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/class.cpnl.ctrl.php', 0, '<1IkڑQj7K', '<1IkڑQj7K', 'aRi	9(`1XD\n1Y', '', 0, '?'),
 ('!f7pm', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/index.php', 0, '@eU\0OvZ', '@eU\0OvZ', 'emI:ņ\nD˒', '', 0, '?'),
 ('յ*v\rGL:\n', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/router.php', 0, ']S.g6Ǵuq', ']S.g6Ǵuq', 'eun%Odغmt6U', '', 0, '?'),
 ('uӸ nh4', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/font-awesome/css/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (']&-.1', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/font-awesome/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('_8\'Ud\r', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/font-awesome/webfonts/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('/ow;?c_5', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/images/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('sH\Z9+4q/v0', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.css.php', 0, 'JTa\"[', 'JTa\"[', 'W%%qъxοs(mV0_[}', '', 0, '?'),
 ('y@8*褺mF.', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.js.php', 0, '?9/ǹÀ', '?9/ǹÀ', 'Xuւs5^P%P9U>D', '', 0, '?'),
 ('.`\'#n;V', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.libs.css.php', 0, ']+?Pru', ']+?Pru', '>2{\\k5?)eR*!=c', '', 0, '?'),
 ('nn.(?a', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.libs.js.php', 0, 'ʱ!/+#r.z', 'ʱ!/+#r.z', '*GD\"~Ի@ƍq &mkmf', '', 0, '?'),
 ('»Fo?:', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('dNbVǮ', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/EventIterator.php', 0, 'Q1H(J', 'Q1H(J', 'ePmnZy`f~ju=+Z{oK', '', 0, '?'),
 ('7ULu2', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/GenericSeekableIterator.php', 0, 'Ic qqh9!', 'Ic qqh9!', 'G\\b%jENH]', '', 0, '?'),
 ('nH3ǳ؞-\\FV', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/class.s3.iterator.php', 0, '):S̾`1(A', '):S̾`1(A', '{f.WƝM|!=\'K)x', '', 0, '?'),
 ('Dy{HF', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunk.s3.manager.php', 0, '22mS7>', '22mS7>', 'К`>u7/+,lH', '', 0, '?'),
 ('W?3{4L:', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager.php', 0, 'n;c', 'n;c', ',@Z6SnF.zU>|\";', '', 0, '?'),
 ('/7k\Z/', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager_file.php', 0, 'M*5(+X[/', 'M*5(+X[/', 'hIӨ\Zu]e\"!(D%\rO\',Neo', '', 0, '?'),
 ('nEc2EN|D', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Crypt/Base.php', 0, '\Zl*|=i|C\r', '\Zl*|=i|C\r', 'U}*K8)FxT,', '', 0, '?'),
 ('m~xJA!+m\08', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Crypt/Random.php', 0, '@\'-P*ij^J', '@\'-P*ij^J', '՞u*[Mq|Lj-Xk', '', 0, '?'),
 ('V^m̙Z\'', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Crypt/Rijndael.php', 0, 'xrxak\rG', 'xrxak\rG', 'h|y)mtz**P\'vyFgcY', '', 0, '?'),
 ('L.<*Joy', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.crypt.php', 0, '\\\0H>\"y', '\\\0H>\"y', 'J<>D7\n-Э|gtz', '', 0, '?'),
 ('Tдy1{_1*?@', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.csrf.php', 0, '|:Z%', '|:Z%', '^n8vHx;ݓiW~mG', '', 0, '?'),
 ('\0%z9}BD', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.db.php', 0, ':u0yD#', ':u0yD#', 'Xˋp7E/WS82:D\0\'\n', '', 0, '?'),
 ('tb00|', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.engine.php', 0, 'Eo;G_ө^-I', 'Eo;G_ө^-I', ')sXIX㹸/iCS\nc/>d/', '', 0, '?'),
 ('_̷4XǬ{Ftr', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.http.php', 0, 'WO\rZc+tnY*,', 'WO\rZc+tnY*,', 'P+Y5 \"A\"(TC\0b', '', 0, '?'),
 ('C*8|Lw\":l/', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.installer.state.php', 0, 'ԞQIK;bi4', 'ԞQIK;bi4', '3^8ڇ}gR]Gގy5>ٶ', '', 0, '?'),
 ('gOѱW', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.logging.php', 0, '6,xĵJz', '6,xĵJz', 'xDw37b+!/(}\n>De', '', 0, '?'),
 ('@F6', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.password.php', 0, '\'nouȣO\n+G', '\'nouȣO\n+G', '_|QK\r~U:6ΩEK', '', 0, '?'),
 ('#|YSjB0m~', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.s3.func.php', 0, '[t+\'ƻ', '[t+\'ƻ', '4,˂\rxӯ0J$XqΠ', '', 0, '?'),
 ('~Q?b', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.server.php', 0, 'hٹ$&sJC', 'hٹ$&sJC', '6y֏NtVx9*LedQݺ|', '', 0, '?'),
 ('H/N`.E\Z', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.view.php', 0, 'ԬR\ZK;1\Zo', 'ԬR\ZK;1\Zo', '2M`_ă>@C ;', '', 0, '?'),
 ('v%eވJy', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.archive.config.php', 0, ',D%Бf_', ',D%Бf_', 'P8)8s?c}sB|/', '', 0, '?'),
 ('tOdoޓ', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.boot.php', 0, 'Ph+9\'', 'Ph+9\'', 'fsթk\\Qj{%θl=Iޙk', '', 0, '?'),
 ('*^%fVil\"', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.conf.srv.php', 0, '~#KGcS$', '~#KGcS$', '$oPJ:jx_Nlܴlk', '', 0, '?'),
 (',TR\0Zo', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.conf.wp.php', 0, '\0>x%]9_X^', '\0>x%]9_X^', 'CXu\"FAɭ`s/A&e5', '', 0, '?'),
 ('&Ef{', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.constants.php', 0, 'bhŞ8VF\Z', 'bhŞ8VF\Z', 'l#ŜiUOu-MJ#[i', '', 0, '?'),
 (':έƉ	<h', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('4	Rs1<cKt', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('4j멾̷K', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.exceptions.php', 0, 'cБHE`	', 'cБHE`	', '=;!(r2 ]:D2䊉D', '', 0, '?'),
 ('\',_	O(\0RT&', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.html.php', 0, 'mdp7I9V', 'mdp7I9V', '^5%[ݐ~iMw~kaXd$  ^', '', 0, '?'),
 ('iPFQweL', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.multisite.php', 0, '1r\0k', '1r\0k', '{rR2cňʯkۂ}`0v+', '', 0, '?'),
 ('Mn=AW,,', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.notices.manager.php', 0, '/IZZs%\nO', '/IZZs%\nO', 'ٌ~97]_J^	#', '', 0, '?'),
 ('Х19i(naq', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.php', 0, '̂7683U)ry', '̂7683U)ry', ';(r+l^y*8w\"j|', '', 0, '?'),
 ('\"3a\'3\Zz\'-', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.remove.redundant.data.php', 0, '\0$@\Z>iTZQ-', '\0$@\Z>iTZQ-', 'cqW!g;oU9UZv', '', 0, '?'),
 ('hf;^	cAK', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.search.reaplce.manager.php', 0, 'kL\\~{Gsɠ', 'kL\\~{Gsɠ', 's@͡S}[bG\'?=#A# #', '', 0, '?'),
 ('X)4\"cVK', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ju^k@', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.base.php', 0, 'oݷf7]&([', 'oݷf7]&([', 'k4y%Ш<\n$y$ewX4', '', 0, '?'),
 ('|80|xNb=W', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.extraction.php', 0, '{<v32ϳ$%', '{<v32ϳ$%', 'y<Xa;px%Y\\]\0}B:~', '', 0, '?'),
 ('͹ʺ2HQ', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.php', 0, '2\'E_%T{OaO', '2\'E_%T{OaO', '	J &FY*vٳ#1', '', 0, '?'),
 ('8LW[(E^cn;', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.base.php', 0, 'Fy}Ԍ]ϑ', 'Fy}Ԍ]ϑ', 'WqfQGZyl9>\r\n]Q', '', 0, '?'),
 (',`,|\\Sń', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbinstall.php', 0, '<ug]nT\"H', '<ug]nT\"H', 'eĘl(\'xLW9+CA$lap[|', '', 0, '?'),
 ('ЁJdph\0', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbtest.php', 0, '?5bhV3MX#ڢ', '?5bhV3MX#ڢ', 'Dv̂:J~,3))?Kp', '', 0, '?'),
 ('<3yo', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s3.php', 0, '릳I@~*SJ)\0', '릳I@~*SJ)\0', '˺ Jʸ	)w\Zbz:.\"i2U', '', 0, '?'),
 ('W\"*fvvpiA', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('JRΩ.1G', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/index.php', 0, '<|8g`', '<|8g`', 'NǍǡG3*\Z#b#,E8_', '', 0, '?'),
 ('\'|Y=<P\\', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/main.installer.php', 0, '(,Z)Í2FE)', '(,Z)Í2FE)', '!0l&l_(:d8˰', '', 0, '?'),
 ('I\ZǮ{!', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('4P@j1fIR`?', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.api.php', 0, 'j0H3!nǛ', 'j0H3!nǛ', ' O\"jXQdF,gxkEc{', '', 0, '?'),
 ('@0X6R*D', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.exception.php', 0, '	}]}fɀ-Ľ', '	}]}fɀ-Ľ', '$\n,̌9 q棬HY', '', 0, '?'),
 ('rP^yڣ@(', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.help.php', 0, 'p?1ZY', 'p?1ZY', '~H@/sPFI#sZcd', '', 0, '?'),
 ('\n\"ⶔ\ZD=G', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.init1.php', 0, ',䉡,M\\', ',䉡,M\\', 'dzqf{shp5{ӀK', '', 0, '?'),
 ('S R%S|', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s1.base.php', 0, 'x>{V\"Y', 'x>{V\"Y', 'kB/{ARp^Zd}.nI@', '', 0, '?'),
 (':i\rTdk', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s1.terms.php', 0, '˝8\'7D', '˝8\'7D', '󛮤Q#fI[crMqF4', '', 0, '?'),
 ('Zf)rD<4F', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.base.php', 0, 'w(9&d', 'w(9&d', '{\r\0sM!Qb,Q^	;', '', 0, '?'),
 ('-q$pz\rz5', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.basic.php', 0, 'V@\'E=_&sm\'', 'V@\'E=_&sm\'', 'OwLr\nGt>+:%,jć%ZC[', '', 0, '?'),
 ('KE2UR1$', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.cpnl.php', 0, '{+\'bA\"', '{+\'bA\"', '1xu}]0g`N!ou\n(O', '', 0, '?'),
 ('5L\0R2{', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.dbtest.php', 0, '.Y7	R', '.Y7	R', '&T]jPD*C̟I7a/', '', 0, '?'),
 ('y:,F&@\\uh', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s3.php', 0, 'Vy\0#V&Q', 'Vy\0#V&Q', 'gjyΝ@8V^b', '', 0, '?'),
 ('JYD;yNYS', 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s4.php', 0, ':z*A5', ':z*A5', '+ݛo5~WjoO', '', 0, '?'),
 ('8(GnUFgނB', 'wp-content/updraft/plugins-old/duplicator-pro/installer/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\" Eml̪	y', 'wp-content/updraft/plugins-old/duplicator-pro/lang/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('>JL=bRO7\n?;', 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/DropboxClient.php', 0, '?w!>OFY~', '?w!>OFY~', 'ϊE3t-/~*9raBCkFkk', '', 0, '?'),
 ('!z,1]]Bˎ\Z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/DropboxV2Client.php', 0, 'BhAh|$QmH', 'BhAh|$QmH', 'G!ckXV<whzSQ\0', '', 0, '?'),
 ('ɢ#ǻNvLA', 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/OAuthSimple.php', 0, '⡜(][b]9', '⡜(][b]9', 'L(	sQ[Rl.S\'\Z i', '', 0, '?'),
 ('1;Nv9(1 ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('4r\"tㅸ+*', 'wp-content/updraft/plugins-old/duplicator-pro/lib/ca/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('8Qgr1n', 'wp-content/updraft/plugins-old/duplicator-pro/lib/certificates/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('QU<', 'wp-content/updraft/plugins-old/duplicator-pro/lib/config/class.wp.config.tranformer.php', 0, '_aMwM@-', '_aMwM@-', 'his	`> X3rY%Ok', '', 0, '?'),
 ('u95GI1k}ҕ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/config/class.wp.config.tranformer.src.php', 0, 'v̵Uy~A(b', 'v̵Uy~A(b', '\'<ѽCچ0N{K{', '', 0, '?'),
 ('0PkQH҇#', 'wp-content/updraft/plugins-old/duplicator-pro/lib/cron/csd_parser.php', 0, 'V972xspUw', 'V972xspUw', '`uvPQJ֩ rXoG\'', '', 0, '?'),
 ('G*.Rf', 'wp-content/updraft/plugins-old/duplicator-pro/lib/cron/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('054.ܹ\Zr(z:x', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.constants.php', 0, 'e.\r&`D', 'e.\r&`D', 'hzY^G?F\r`` ', '', 0, '?'),
 ('EkTq̌\Zt', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.engine.php', 0, 'cb,', 'cb,', 'lUO[FiN!<GaZ', '', 0, '?'),
 ('5zts17m8', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.loggerbase.php', 0, 'XaW6', 'XaW6', '+pqvKOUiJ}>', '', 0, '?'),
 ('a&Kf', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.mini.expander.php', 0, '3WBn`τ', '3WBn`τ', 'AX.mndbȕ&.K$$t&', '', 0, '?'),
 ('zs: I', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.processing.failure.php', 0, '7T$w۝ӹs', '7T$w۝ӹs', 'C\ZߞZ3P>G$X<&D\n\\.', '', 0, '?'),
 ('LM[z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.directory.php', 0, '0y俘1oc', '0y俘1oc', '62+cp\\].޴Wߝf,-퇮', '', 0, '?'),
 ('3pQi2e', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.file.php', 0, 'IQNɾmN', 'IQNɾmN', '\"zM2ŹAyuXY¥Va #', '', 0, '?'),
 ('8R)\\;', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.glob.php', 0, 'q0Z^cBX', 'q0Z^cBX', 'Q\"ZlP	sԣ6\\իׂP\Z', '', 0, '?'),
 ('KB<|`dK1', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.php', 0, 'rnJx)3Yt', 'rnJx)3Yt', '[FN*G\0^E9mB]<', '', 0, '?'),
 ('r)9P\Zw&<', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.u.php', 0, 'mE\ZBr(\'', 'mE\ZBr(\'', '-:auQ{V\\AZo_', '', 0, '?'),
 ('\ZykZh?h', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('gns?', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ONm(\04)kth', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.directory.php', 0, 'sHP/S#ܨl', 'sHP/S#ܨl', '@3~S\"-8ˈJqrESտ', '', 0, '?'),
 ('$<%q 3', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.file.php', 0, '6ϥڇ(#b4m', '6ϥڇ(#b4m', '#9V:\n`9xJJI!TA', '', 0, '?'),
 ('|t)@EG', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/processors/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('5IbC|pR', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.base.php', 0, ',k_ο', ',k_ο', '@cuw:-U#R~K>zB1_15', '', 0, '?'),
 ('^xȥq0SE', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.create.php', 0, '_.Rz', '_.Rz', '/ށS5llt؜o˯', '', 0, '?'),
 (']㟝,M˩', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.expand.php', 0, 'M<-J[', 'M<-J[', 'Ӡ|vz~H]rs', '', 0, '?'),
 ('HҨ<p<uݐ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simplecreate.php', 0, '*Ԃ7M4J6', '*Ԃ7M4J6', 'J⒛QmF{ERQ\")zОz\0[', '', 0, '?'),
 ('L-_k-Z^', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simpleexpand.php', 0, '\\/)5i憲^', '\\/)5i憲^', '|!Q\0bڪ`Tp%t}N:>^', '', 0, '?'),
 ('5ݾ}{C]x', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('a7Jy7MBXye,', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.u.json.php', 0, 'ݩ.|6\"', 'ݩ.|6\"', 'դ5/-8zL1}:tרhE', '', 0, '?'),
 ('+k	_b`Ȕ#', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.php', 0, 'e2L$Bn\Z', 'e2L$Bn\Z', 'aɇ\"B8.)_jR!', '', 0, '?'),
 ('ʷ벘aAe`', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.scan.php', 0, '-*L~wW1', '-*L~wW1', '\"<!{ՠCN\'L\\{', '', 0, '?'),
 ('ԍWPI\'', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('%{[&vf', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/class.daws.constants.php', 0, 'Fp:l|T', 'Fp:l|T', 'ZkEyjz`J<Z1?VAb2\Z', '', 0, '?'),
 ('.~)5I^', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/class.daws.state.expand.php', 0, 'x`r\rm', 'x`r\rm', 'L<m~Bt[ĝ6v', '', 0, '?'),
 ('-̻!G\"	w/\Z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/daws.php', 0, 'ÞsB0', 'ÞsB0', '*9k2trϱ9/S\'pcN!v\r', '', 0, '?'),
 ('~m$1S\nO[', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\'$.G', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/define.php', 0, '\0[OhYyV^z', '\0[OhYyV^z', ';C	\nm)㇮8-4\\{n', '', 0, '?'),
 ('>\ns(,T', 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\n~-/z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/edd/EDD_SL_Plugin_Updater.php', 0, 'Fg~R\n|x', 'Fg~R\n|x', '@VN6\'9_҅\"F(QG', '', 0, '?'),
 ('L.Q$vq=}WV', 'wp-content/updraft/plugins-old/duplicator-pro/lib/edd/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('l>6EG', 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.constants.php', 0, '\'~sfB', '\'~sfB', 'rBAƈe芷}t(4\nO', '', 0, '?'),
 ('F]\"³\\Т(', 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.state.php', 0, '{)&yG.', '{)&yG.', 'HHJV	j;۩.Ao*P', '', 0, '?'),
 ('ƌ-v4~}', 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.u.delete.php', 0, 'P#:ƈˡ3', 'P#:ƈˡ3', 'emrڿ!(4#:EE', '', 0, '?'),
 ('rU6B9{m', 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.u.move.php', 0, '{SM{Q', '{SM{Q', '37B4@*V.Ģ9LF\\^#d%a', '', 0, '?'),
 ('a	', 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/fileops.php', 0, 'cdќ=~', 'cdќ=~', 'Tp\rThR~Dvƺ', '', 0, '?'),
 ('|5Ē5wh6_', 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('kr_B:', 'wp-content/updraft/plugins-old/duplicator-pro/lib/forceutf8/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('JpЃ&', 'wp-content/updraft/plugins-old/duplicator-pro/lib/forceutf8/src/Encoding.php', 0, '*9`dg`Z\r\\Ky', '*9`dg`Z\r\\Ky', '4mHtMQd8e+=dۘĘ', '', 0, '?'),
 ('o1MuJ歭g7K', 'wp-content/updraft/plugins-old/duplicator-pro/lib/forceutf8/src/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('mUQe8B0yN!', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/Abstract.php', 0, 'K4Ɏ(9	', 'K4Ɏ(9	', '~4CjvĢkp.\ZmѮrZYm', '', 0, '?'),
 ('Ҷ4lʶ0:nTQ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/Exception.php', 0, 'MseO6x', 'MseO6x', '۔ғG9YT8jAR\".$F', '', 0, '?'),
 ('~rS:=&ƶ}', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/OAuth2.php', 0, '>kv[f0', '>kv[f0', '\0rv׭d9ϐ^泷Ǆb^*`s', '', 0, '?'),
 ('H%hI8]=z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('M̅鿀#ݮ(l/', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/Abstract.php', 0, '7VM8XK', '7VM8XK', 'qޞRyy#ؐ}b!', '', 0, '?'),
 ('\r1M#Ho|', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/Exception.php', 0, 'yśBកK', 'yśBកK', '-̝p,r7}:/t8IRe', '', 0, '?'),
 ('rm]8Q,#~z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/File.php', 0, 'ߕW<R~\njxj', 'ߕW<R~\njxj', 'Z^(~;0rE', '', 0, '?'),
 ('ˊt9̌_9', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/Null.php', 0, 'Rpb4-&', 'Rpb4-&', '/\ZA<She2|So-\n', '', 0, '?'),
 ('h,ys$sJ[)(', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('o62\0? ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Client.php', 0, 'h4	ʴ$;Q', 'h4	ʴ$;Q', '1\"zssoFu\r<', '', 0, '?'),
 ('1u, aE(Z;E', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Collection.php', 0, 'q?͢Y ', 'q?͢Y ', 'f975hvlmv\n', '', 0, '?'),
 ('%JKӤ\0!', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Config.php', 0, '\r1kR	\n', '\r1kR	\n', '4jN  ryF:1w|?pD5', '', 0, '?'),
 ('J2&M}>!', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Exception.php', 0, '1\Zk(}', '1\Zk(}', '\nyMd+6׉IΣ͟x\n', '', 0, '?'),
 ('v\nº_JӠ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/Batch.php', 0, '6st	V:', '6st	V:', 'r;\\Sۿ8CΗ`ZA;', '', 0, '?'),
 ('i	2Ug6', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/CacheParser.php', 0, 'y㞬[%ul,bz', 'y㞬[%ul,bz', '1\0ML5pnjC2Yq˿lI6{', '', 0, '?'),
 ('XFi*\n|Z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/MediaFileUpload.php', 0, 'ѰMn`9Ui', 'ѰMn`9Ui', 'ceGGc2\"s<hPtMB&', '', 0, '?'),
 ('֨q%\\	rm$', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/REST.php', 0, 'q\"%,\r(b͛7', 'q\"%,\r(b͛7', 'R(?22\ryLW)뻄(2icЌ9', '', 0, '?'),
 ('җ.', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/Request.php', 0, '<8~ʡi}j', '<8~ʡi}j', ':X1M\\#Os\\#j|}&[', '', 0, '?'),
 ('eZ&<=5-', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('>.T80\n', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Abstract.php', 0, 'FO\0蠄׽M', 'FO\0蠄׽M', '~2}n`9n.XݨUt55wg0', '', 0, '?'),
 ('Ιf|q36l', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Curl.php', 0, 'rf|`;1(', 'rf|`;1(', '\n6.e\"˼ZWG', '', 0, '?'),
 ('^EDhq\n', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Exception.php', 0, 'x9NÕ', 'x9NÕ', 'SDZٯZZǑ~i<$l͞S$\Z', '', 0, '?'),
 ('D.g}4Q!', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Stream.php', 0, 'MSjOKJ', 'MSjOKJ', 'ԍk\\go.vdO_Š', '', 0, '?'),
 ('ŀ	8', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('莞t´3', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/Abstract.php', 0, 'P=oĮYj\nݻ', 'P=oĮYj\nݻ', '\";n0F#-4K%47', '', 0, '?'),
 (';!+8MlZ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/Exception.php', 0, 'S#HS=d8([', 'S#HS=d8([', 'i7{])5|U**p1S', '', 0, '?'),
 ('&~/>4eP', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/File.php', 0, '/2<}CG-_5;3', '/2<}CG-_5;3', 'Q-\rqBج?Tlvн', '', 0, '?'),
 ('i	5xZB', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/Null.php', 0, 't:޼eJa\"g_', 't:޼eJa\"g_', '=DG$@HZɘ~r\ZϻT', '', 0, '?'),
 ('~V(cUv,\0wY', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('R |[\' Rl', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Model.php', 0, '!dL56\Z|N', '!dL56\Z|N', '`x\nJ8HRhf\0[Wrn=', '', 0, '?'),
 ('Q^-l%!', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Drive.php', 0, ';,庣y9', ';,庣y9', '!/|mnHPh[i', '', 0, '?'),
 ('`|[G	Ϥ8', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Exception.php', 0, 'EJd0NϜ', 'EJd0NϜ', 'V\Zgul3j[:-4', '', 0, '?'),
 ('ƚu1O\r,a', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Oauth2.php', 0, '.|(q|ӠO!&', '.|(q|ӠO!&', '5v5uO\'e3׫D', '', 0, '?'),
 ('-I/}G!~', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Resource.php', 0, 'J63B^3', 'J63B^3', '.W?#<_2/ڐ	s', '', 0, '?'),
 ('³$@utM:', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('#^9*}߉R', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service.php', 0, '\\۲:DӤ?}S/', '\\۲:DӤ?}S/', ':U{2X,K7^4H', '', 0, '?'),
 ('),֒ݪEl', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/Exception.php', 0, 'RG]>?|1]wH', 'RG]>?|1]wH', 'ZQzia*hwClapb}u_', '', 0, '?'),
 (')<Q', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/Retryable.php', 0, 'WڹjJy', 'WڹjJy', 't-dV?\\+Ņ(trW#̓', '', 0, '?'),
 ('[ zGb', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/Runner.php', 0, 'vhFsP-8E', 'vhFsP-8E', '}ޅ\nOh\rBOH	3J', '', 0, '?'),
 ('H5F\nF', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('O72oZy$q0[%', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Utils/URITemplate.php', 0, 'y~3S׈m҅uxU', 'y~3S׈m҅uxU', 'xQ\"\0wAX#\0Rai', '', 0, '?'),
 ('dgF&*0ɵ@', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Utils/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('YmA`0o', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Utils.php', 0, '}WG	', '}WG	', '$c{qEt>7:iĂ4j}Rf', '', 0, '?'),
 ('5\r4(', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/autoload.php', 0, '3A:鈹Y(r?', '3A:鈹Y(r?', 'i^<@(ClU<?Iύf [k-', '', 0, '?'),
 ('Ș7\\]+', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('.ΓwWFPÚl](', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/class.enhanced.google.media.file.upload.php', 0, ',\'ڎ\"ꚨ v@_', ',\'ڎ\"ꚨ v@_', 'E_N%I}]G-b(Y', '', 0, '?'),
 (';Êм', 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('?j[$_\Z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('J.\\o^f', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/autoload.php', 0, '\Z$kuiӫ', '\Z$kuiӫ', 'YC숯V\Zmݡ6\0Mo\0', '', 0, '?'),
 ('9\'y{eUCY', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (';.{a򩌺G)!', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Client.php', 0, '?5\Z)71@&hb', '?5\Z)71@&hb', '8G%Ei=i:uIRd\r1', '', 0, '?'),
 ('bE8]', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/DriveItem.php', 0, 'r+Hcn', 'r+Hcn', '<R&p̜*=P)|%', '', 0, '?'),
 ('syܕX:[R', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/File.php', 0, 'qg\r	~NJ1', 'qg\r	~NJ1', 'Hk{Ⱦ[Z؆u?A', '', 0, '?'),
 ('w>z!]{', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Folder.php', 0, 'J	Uv1}\r/', 'J	Uv1}\r/', '}b-Nf!n\\rxAyn{֛', '', 0, '?'),
 ('DDdg@', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehavior.php', 0, '7{NUf_9', '7{NUf_9', 'd>4ţ\n\0l7$phW0', '', 0, '?'),
 ('w({\\e', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehaviorParameterizer.php', 0, '^m1fY:TF+', '^m1fY:TF+', 'II(!vĠi0}Skts', '', 0, '?'),
 ('k^1i6', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/ResumableUploader.php', 0, 'Al_ơU', 'Al_ơU', '.~ r%e +0%:\'ܚI(', '', 0, '?'),
 ('yC=@o@+', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamBackEnd.php', 0, '*=H*ex ', '*=H*ex ', '_7qpҵ;#ݓ\ZN-;Hϋf', '', 0, '?'),
 ('cA4)fQ}', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamOpener.php', 0, 'wzbٚ6A%TI	', 'wzbٚ6A%TI	', 'Z˖RT}yzO\".ү30eE', '', 0, '?'),
 ('lbE5*Ve', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('E(~iiSX09', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('rJ|8xL(g', 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('qZ<\"4Uj', 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/cipher/blowfish.php', 0, '<e4,n5u\\', '<e4,n5u\\', '5\ntO\ng%͇~k9N', '', 0, '?'),
 ('p4S *Z!@', 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/cipher/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('S<%2', 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/class.pcrypt.php', 0, 'd#ΩtK#=s', 'd#ΩtK#=s', 'B~oL.\rd\r$/~d7l', '', 0, '?'),
 ('al ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/example.php', 0, 'CHI|t', 'CHI|t', '(U_:+:[Ȗuca', '', 0, '?'),
 ('ĺXhjhK4٣', 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ِobS eY3', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/autoload.php', 0, '?*Ǳ\r', '?*Ǳ\r', 'v\'߻ŭB%2p+ɛ1N*&%', '', 0, '?'),
 ('k|\"', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/class.phpseclib.php', 0, '0ε+_G-', '0ε+_G-', '%`KfWPI;Гt|Ĕ쀔9Z', '', 0, '?'),
 (']i> <)E', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/ClassLoader.php', 0, 'cOd!FuM؅', 'cOd!FuM؅', 'S-GR e!m{Zflv]', '', 0, '?'),
 ('y$Fp\"H5kN', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_classmap.php', 0, 'Hz*m6Q', 'Hz*m6Q', 'uɣ,9Q>\n؉]@pF;`f', '', 0, '?'),
 ('Mlc(N', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_namespaces.php', 0, 'g$_hηMq', 'g$_hηMq', 'KkawlcVu(]\ro>E', '', 0, '?'),
 ('\'ឫc1j~\ne', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_psr4.php', 0, 'HH< <', 'HH< <', 'cH3\"{kq0\r{nڸ', '', 0, '?'),
 ('\Z9h6j]r', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_real.php', 0, 'S6Uw[䞉-', 'S6Uw[䞉-', '>cQg>9aJxeAƩ쨄m=2l ', '', 0, '?'),
 ('uf[5,', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_static.php', 0, 'JRܾ33', 'JRܾ33', '#nS#_q]3eN2K', '', 0, '?'),
 ('jIN	\"', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/include_paths.php', 0, 'HfS7\nBQj', 'HfS7\nBQj', '2vYP?3aȃmm/A', '', 0, '?'),
 ('_k\'VZi8h', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('*w{lQ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/AES.php', 0, 'G-17^p', 'G-17^p', 'ck],K]ֆBn&KzʇKZ&\n', '', 0, '?'),
 ('MŔk0g', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Base.php', 0, '5@R4oWs', '5@R4oWs', 'XoX-\rqj}~?:A||s', '', 0, '?'),
 ('oi-+)ɑlW?>', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Blowfish.php', 0, '*;.Ch', '*;.Ch', '1xuOձϑ1eڈ|sM֚H	ڨ', '', 0, '?'),
 ('l;t\n0B', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/DES.php', 0, 'E6P4.\\\\cI', 'E6P4.\\\\cI', 'YìUc	<|X2\\}', '', 0, '?'),
 ('h:uf	Y', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Hash.php', 0, 'P]sky$', 'P]sky$', '}OL,UJ8k', '', 0, '?'),
 ('`\'X[ڀxz\0:S', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC2.php', 0, '&tQ7:d&', '&tQ7:d&', 'mmWo;Zwg+Quc\0|R*|', '', 0, '?'),
 ('\0$yr', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC4.php', 0, '6cy]wdL', '6cy]wdL', '9]mGiea}K!', '', 0, '?'),
 ('<d|\\0]', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RSA.php', 0, ']Ϧ8-(|d', ']Ϧ8-(|d', '\Z~ϰ^=JfxI~ݺ\n/', '', 0, '?'),
 ('i=+2\\\"', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Random.php', 0, 'p/juH1*', 'p/juH1*', '2MCibMV6נ8oT!+\r1(', '', 0, '?'),
 ('*3ۈ*=j', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Rijndael.php', 0, 's!Jjm	', 's!Jjm	', 'U_4 ؊viRS4+>.G,]', '', 0, '?'),
 ('T(GO\Z.df', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/TripleDES.php', 0, 'FӁm^Ħ}^C\Z|e', 'FӁm^Ħ}^C\Z|e', 'j\0\Z6F9r$7Epb%', '', 0, '?'),
 ('Cޝ:Q94\\>gd)', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Twofish.php', 0, 'PR.z_', 'PR.z_', 's	6<Di^ܘFXv6{\\\\N', '', 0, '?'),
 ('جY\"5n\n', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('|Q83\Z+', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ANSI.php', 0, 'n8P2oS)', 'n8P2oS)', 'lT,K	`LGyimt25H', '', 0, '?'),
 ('f-O>뚫E', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/Element.php', 0, '*ȶS\rw>', '*ȶS\rw>', 'ٺ|/̠Gc7k^s', '', 0, '?'),
 ('lHToT9', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('y&r+pیٚj', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1.php', 0, 'jH0`[5S$', 'jH0`[5S$', 'E:Z\'vk?hHT7Fê@jXx', '', 0, '?'),
 ('hMԾa=\n', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/X509.php', 0, '$,*5Uiv$', '$,*5Uiv$', 'hHRO)T$nρL)\Z\"wq?', '', 0, '?'),
 ('acփp', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('1\ZWm@', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Math/BigInteger.php', 0, '<q`x[$z6', '<q`x[$z6', '3\0w#+VN&K', '', 0, '?'),
 ('K  SK', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Math/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('8BuK.ԗtA', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SCP.php', 0, 'dw\r`', 'dw\r`', '@\'MG2boV,^d(', '', 0, '?'),
 ('\0,F[n|{', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/Stream.php', 0, '<n_q\'7', '<n_q\'7', 'dMaT;fdM.qaȂeUM׺d5', '', 0, '?'),
 ('P~ǿh4B	', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('H	ZC<냉f', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP.php', 0, '?vO\n', '?vO\n', 'C!),>eI{`', '', 0, '?'),
 ('(lgZ]?', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH1.php', 0, '1Ry Xb2S', '1Ry Xb2S', '}PngҖbEjx;w+67\'', '', 0, '?'),
 ('4N\Z7Ӹd', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH2.php', 0, '8*ա+', '8*ա+', '6a\r7\nj.TPѷ=k1%', '', 0, '?'),
 ('\\9<dub2', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('e5G/<ãZ ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent/Identity.php', 0, ',Z:3ڏvk%8', ',Z:3ڏvk%8', '{z6RVjֵ\"\"6', '', 0, '?'),
 ('aB!_lRnp{', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent.php', 0, '|\"v%cA0', '|\"v%cA0', '72IwCCPk%\0]BWQ', '', 0, '?'),
 ('E1ͱڪb', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('sŴ-\Z].3I', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('rBF[$\n', 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/index.php', 0, '7!\\F9l', '7!\\F9l', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (']ݢoj', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.exceptions.php', 0, '$ݙ]?9', '$ݙ]?9', 'U\\D4&#^=$r0v{\Z]', '', 0, '?'),
 ('C^SsA', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.logger.php', 0, '6xoWzX', '6xoWzX', 'kֿv*uEX&EW', '', 0, '?'),
 ('hYiFgr*\Z', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.io.php', 0, 'KJ[%', 'KJ[%', ':JѫHV3#=\'y%Ğ?O', '', 0, '?'),
 ('֌JܒsB', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.net.php', 0, 'GQ)]', 'GQ)]', 'sYr1iEjM=~\re|', '', 0, '?'),
 ('kNEIPB', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.os.php', 0, '}L_E', '}L_E', 'ڮK\\sR[q:rtŏ*+L', '', 0, '?'),
 ('yM:Pd&y', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.stream.php', 0, 'A<2R/G', 'A<2R/G', '8O\nߖ2%UA[ɢ\nkBer', '', 0, '?'),
 ('=QEY\\', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.string.php', 0, 'cJhJ7WK', 'cJhJ7WK', 'j;=9\nHc\nS9Lq\"', '', 0, '?'),
 (']T??HZVq', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.ui.php', 0, ':K]]Y', ':K]]Y', 'DO@qdf\rA_7O`.', '', 0, '?'),
 ('Ws&wtg#O', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.url.php', 0, 'ŵM,	oQF', 'ŵM,	oQF', 'ERFnrM}{kyglLߩ', '', 0, '?'),
 ('Ai\nD=<ٛ', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.util.php', 0, 'u-]9*Q', 'u-]9*Q', '(bK)ZZiF(X)j3', '', 0, '?'),
 ('YS#ƺg~', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.wp.php', 0, 'ߢ߽\0ڟ\' Z\\ܾ', 'ߢ߽\0ڟ\' Z\\ܾ', '0&/!vD3tE:֊', '', 0, '?'),
 ('^fRwy׵', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('q8)|\0QM\\', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/snaplib.all.php', 0, 'aĞ3k=I', 'aĞ3k=I', '5L&84}:^\\', '', 0, '?'),
 ('`Ψ40<Z6U', 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/wordpress.core.files.php', 0, 's;[%\r z\'', 's;[%\r z\'', ',60Exz@<', '', 0, '?'),
 ('ƨ_1y', 'wp-content/updraft/plugins-old/duplicator-pro/tools/da-installer-extractor.php', 0, 'byY3]uKN`', 'byY3]uKN`', 'O4H4A\Z&[mv\\fWe', '', 0, '?'),
 ('MXq7y', 'wp-content/updraft/plugins-old/duplicator-pro/tools/db-test.php', 0, 'w.Hk̩WA', 'w.Hk̩WA', '$WZ*L`Ț3^(0AT', '', 0, '?'),
 ('}3y6`(P', 'wp-content/updraft/plugins-old/duplicator-pro/tools/file-renamer.php', 0, 'g==q^\"mV', 'g==q^\"mV', '{ް¬b31\"P`X(p8lF', '', 0, '?'),
 ('ZiDZ~W\Z8O', 'wp-content/updraft/plugins-old/duplicator-pro/tools/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (':fS0fg', 'wp-content/updraft/plugins-old/duplicator-pro/uninstall.php', 0, 'k~<VL!\"F8qݴf\"', 'k~<VL!\"F8qݴf\"', 'qۨcˤU⢶\Zlq`*I', '', 0, '?'),
 ('N\n@muG\\,k', 'wp-content/updraft/plugins-old/duplicator-pro/views/inc.header.php', 0, 'LiW%f3L', 'LiW%f3L', 'W>~${濰5zIs=l6', '', 0, '?'),
 ('} R:s2l<xRE$', 'wp-content/updraft/plugins-old/duplicator-pro/views/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('6Q\r\0HSN@', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/controller.php', 0, 'jM-|ۯXOw1', 'jM-|ۯXOw1', '=B26_AXeNMOFdUK', '', 0, '?'),
 ('1:HGGB)^', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/controller.php', 0, 'L;]Ŏl\Z=', 'L;]Ŏl\Z=', ' svBm8铷 ˪\rn[', '', 0, '?'),
 ('\Zl>,oI', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/detail.php', 0, '&nZD7', '&nZD7', '-avew=f,Ԇ}*jy', '', 0, '?'),
 ('ʛԜtUdJ', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 (' w>DP>H', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/transfer.php', 0, 'ά4=8', 'ά4=8', '`u)n\ZqKՂjL1d', '', 0, '?'),
 ('sQL,ZRq`\'n', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('ӚB̄	q!y', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/controller.php', 0, ')\\JE.eF\'', ')\\JE.eF\'', '#^0D\Z4 eQp\n9}*', '', 0, '?'),
 ('6î48y#', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('f%:aI<umR', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/packages.php', 0, 'ݷIkԝWIDa', 'ݷIkԝWIDa', '4blX.Y4\'{H#9gq5r', '', 0, '?'),
 ('`ځ?w8^', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup0.base.php', 0, ',`i։', ',`i։', '\nXx!4a^g Yq', '', 0, '?'),
 ('8\\XU=\'yo', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup1.reqs.php', 0, '|_s', '|_s', 'eʥgu\\,HatF$\"', '', 0, '?'),
 (').\Zei{L', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup2.store.php', 0, 'HIPQ4rۯ{TV', 'HIPQ4rۯ{TV', '|dVȟt\nƄhH!K/t', '', 0, '?'),
 ('>zNkieY\n', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup3.archive.php', 0, 'ixGXˍeB{', 'ixGXˍeB{', '*ȥJ a1tЄl	NF!z\09s', '', 0, '?'),
 ('7I\Zc~_', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup4.install.php', 0, 'ӹ84JۍMۋ', 'ӹ84JۍMۋ', '@{S7\r{>a%GF#l=', '', 0, '?'),
 ('!|UJg%\nⓔq', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s2.scan1.base.php', 0, 'RF#|^G2', 'RF#|^G2', 'SJ04g4;ml9k', '', 0, '?'),
 ('mIx:T· ,4', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s2.scan2.server.php', 0, 'OhL~FJֳ', 'OhL~FJֳ', 'يlTd.sZ;{.MX<	', '', 0, '?'),
 ('~1U\'', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s2.scan3.archive.php', 0, 'prj2ؼ;', 'prj2ؼ;', ';Q7m3UxeeP9', '', 0, '?'),
 ('w>akG', 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/screen.php', 0, '!XFi', '!XFi', '~-rL7PmО', '', 0, '?'),
 ('ڕXʉ:&C7', 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/controller.php', 0, '&UPl Qb', '&UPl Qb', 'Zt\Zftf21`,Gj	', '', 0, '?'),
 ('=!#꿗+', 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('D]1I	U3u ', 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/schedule.controller.php', 0, '2V3!}j', '2V3!}j', 'xUW>p>\'<\rNv8pt', '', 0, '?'),
 ('W\0\"Rʰo', 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/schedule.edit.php', 0, '>3+;c	\n@r', '>3+;c	\n@r', '*֙4ȎW\re', '', 0, '?'),
 ('NPƱL9', 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/schedule.list.php', 0, 'xk)뗵Aݍ\0', 'xk)뗵Aݍ\0', 'vfnZ<Ͷt6fdԕfbw', '', 0, '?'),
 ('X˔lU\"4', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/controller.php', 0, 'mk8d0U5\0^<i', 'mk8d0U5\0^<i', '	4ZL18zѝo<8Uc', '', 0, '?'),
 ('ФH^Nql2F~', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/inc.feature.php', 0, '8d祵G4he1', '8d祵G4he1', 'yU5d(O4%r+/', '', 0, '?'),
 ('j`|', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/inc.general.php', 0, '2&.]ƭA6', '2&.]ƭA6', '2Te>-uD$<}T', '', 0, '?'),
 ('<J@%PiV.!', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/inc.migrate.php', 0, 'O\nZY2e㺷U', 'O\nZY2e㺷U', ':O:\n)/<̓O[hgT', '', 0, '?'),
 ('0N\Zn6', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Ung\\r\0', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/main.php', 0, 'd+kIku', 'd+kIku', 'n}UDg\\HтWKvHJ|', '', 0, '?'),
 ('E~[ᣪ', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('9|dddR[_\Zv', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/licensing.php', 0, 'flT2Tbu', 'flT2Tbu', '}eNd\"f<u^CX\'Ik', '', 0, '?'),
 ('{Su}', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.advanced.php', 0, 'ё*(,\r', 'ё*(,\r', '?-;}fVS?~K6yNhKz\rM', '', 0, '?'),
 ('Z:,ybP\ZIK', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.basic.php', 0, '7X%t&', '7X%t&', '76;U`?|u[s,<]\r(', '', 0, '?'),
 ('2ZxȢ', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.brand.edit.php', 0, ';ӭ~)pKIrL)', ';ӭ~)pKIrL)', 'X-Ĵ9>%ߥ2ذ\'', '', 0, '?'),
 ('0fk`IY0', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.brand.list.php', 0, 'pOP\Zq', 'pOP\Zq', '2lv=Bt%f#TKTkPA>', '', 0, '?'),
 ('OwDV', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('\'pi;4lL>z', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/main.php', 0, 'THwl-\Z|Q%', 'THwl-\Z|Q%', ')RI\r-TլAnD_', '', 0, '?'),
 ('7EzEv_0', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/schedule.php', 0, 'Mz{d\"o', 'Mz{d\"o', 'd*O)}^r];	', '', 0, '?'),
 ('زEH0\"\\q', 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/storage.php', 0, '.\r995', '.\r995', 'd6ݔzGLH&L<| =/', '', 0, '?'),
 ('BƎ1fkOe', 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/controller.php', 0, 'p;p@].&5|4', 'p;p@].&5|4', 'L3&z;h\r1j6܆]((CsFz', '', 0, '?'),
 ('n3~|7', 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('Ρ\n3l>>N', 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.controller.php', 0, 'F+>HTve4U', 'F+>HTve4U', '#\nv*P%HVXy\rm=NjB.', '', 0, '?'),
 ('/6\rXPD4g%f', 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.edit.default.php', 0, 'fJ	`h7Q', 'fJ	`h7Q', 'R\rnn91\n8 -*', '', 0, '?'),
 ('$\re]h̺U+', 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.edit.php', 0, '()VNk)a{mq', '()VNk)a{mq', 'iNB\'UIwjx)g\"TN4Ta', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('i&=d@׫', 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.list.php', 0, 'eA-w1s', 'eA-w1s', '!:|e/)Nyu/', '', 0, '?'),
 ('t+\\;lWЊ', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/controller.php', 0, '74t) pr', '74t) pr', '֐9o#@%a@;\nHeoc', '', 0, '?'),
 ('6xU~{׿jT', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/diagnostic.php', 0, 'C8A\0i\0', 'C8A\0i\0', 't .ɕ\"_Bc\Z', '', 0, '?'),
 ('?aWCQ__zg', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.data.php', 0, 'V\n\rи', 'V\n\rи', '8tۦkv]wrP+', '', 0, '?'),
 ('	ͪ|EcL', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.phpinfo.php', 0, 'CvY8\rNә7\'V', 'CvY8\rNә7\'V', '[RNɅ麛Peˆ³Ŏ', '', 0, '?'),
 ('mn:4$', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.settings.php', 0, 'l8Y>a*ɍ[L', 'l8Y>a*ɍ[L', 'Lu|d;eNۜRgQmi', '', 0, '?'),
 ('\0\'$o', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.validator.php', 0, 'r򍅢no3ma', 'r򍅢no3ma', 'Z j:Eȍn꣉N0,vg', '', 0, '?'),
 ('7.sL\0?ͤ)[i[', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('rחhaAV7', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/log.php', 0, '_78mf>z', '_78mf>z', 'Lc\0_Ǜ)iެW', '', 0, '?'),
 ('/qY!D!M)oYB3}', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/main.php', 0, 'e9R~j]', 'e9R~j]', '-LUM=;c` zu[s\n1?', '', 0, '?'),
 ('f1uΣXK', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/phplogs.php', 0, '8#:8lY', '8#:8lY', 'o;lz_D]j>\\-b\'@ׄ', '', 0, '?'),
 ('\'oN[o+', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/support.php', 0, 'i\"|F#', 'i\"|F#', 'jn*nUƩM!hL][', '', 0, '?'),
 ('ȱ,ڄw#{:', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/tests.php', 0, '//aQ-˓P', '//aQ-˓P', 'T륖Qc;pȯ)m', '', 0, '?'),
 ('᫸bL߆N', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/import.php', 0, '>9N745@', '>9N745@', '軩OLQG\rDCd|', '', 0, '?'),
 ('\rS\'33%:P', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('u(>V:^0`', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/support.php', 0, '&V]8\'E\r\',w', '&V]8\'E\r\',w', ' Q_I)6!a#ttUi', '', 0, '?'),
 ('0^=o_RAGjY\"', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/index.php', 0, ';IaFVʼQ%', ';IaFVʼQ%', 'Lk\r`:)ʏ1V_7zPZx:E', '', 0, '?'),
 ('S۷L,*i', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/main.php', 0, '9\rX)X', '9\rX)X', 'nYU\'^%Z@\'\rL}', '', 0, '?'),
 ('ݻ\0jPx4', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/template.edit.php', 0, ':	', ':	', '(8i{ˆ°KѢ՟9R-9', '', 0, '?'),
 ('cT&AL,>u', 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/template.list.php', 0, 'xXff?@B	', 'xXff?@B	', '9oOj3${N3\"L0#', '', 0, '?'),
 ('+g', 'wp-content/updraft/plugins-old/hello.php', 0, 'Et5\0Pw', 'Et5\0Pw', 'fs	uc~0bI&5)', '', 0, '?'),
 ('=UQO', 'wp-content/updraft/plugins-old/index.php', 0, 'gD,V=\\bP', 'gD,V=\\bP', 'k~	UH\ZxPĀ<;X', '', 0, '?'),
 ('yVzM\">W', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/alpha/alpha-control.php', 0, 'ZD\0sOx\"H}{', 'ZD\0sOx\"H}{', 'vKuH#xf~Qpet5tY', '', 0, '?'),
 ('gyaP<\02', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/alpha/assets/js/alpha-control.js', 0, 'w; G', 'w; G', 'Sx.)s4h _z8{	!ߊP', '', 0, '?'),
 ('ܩ5͎.Z<1', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/cool-stuff/cool-stuff-control.php', 0, 'Pi0}aM', 'Pi0}aM', '\'(pGK;|~DO3,\Z', '', 0, '?'),
 ('7 ?fuZ@', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/padding/assets/js/padding-control.js', 0, '/]ռ344X4', '/]ռ344X4', 'N\0rI2	:޿$ZG>n', '', 0, '?'),
 ('˻[`\r;i', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/padding/padding-control.php', 0, 'LVi=$~3', 'LVi=$~3', '>\"6$2Yn,ޥ', '', 0, '?'),
 ('\n:њo_', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/radio-images/radio-images-control.php', 0, 'cpr=BUK', 'cpr=BUK', '{~ԌKtp/*+c_m\n~s', '', 0, '?'),
 ('ԔF4ҷ-NQm}C', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/range-slider/assets/js/range-slider-control.js', 0, '!oyn`mD', '!oyn`mD', 'M1\\@(\'}{5', '', 0, '?'),
 ('-ƶ\"b@ڵ', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/range-slider/range-slider-control.php', 0, 'ʫmj𮍊H:', 'ʫmj𮍊H:', '_Y\'7;CNGRx&x69=P', '', 0, '?'),
 ('u8x>hwğ', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/toggle/assets/js/toggle-control.js', 0, '#wQw1@y', '#wQw1@y', 'r(+\Z^@AD^', '', 0, '?'),
 ('}Q}[', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/toggle/toggle-control.php', 0, 'q>\'Z+35l', 'q>\'Z+35l', 'v#>Cjj?.*8?', '', 0, '?'),
 (')c_?&XO', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/custom-code.php', 0, '//\'K', '//\'K', ':5VWìm(2lLȇ/4-', '', 0, '?'),
 ('tH_ b<If*', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/customizer.php', 0, '/ut7Pa;', '/ut7Pa;', ']Q<]1,YMVa7ΰ\"', '', 0, '?'),
 (':		B\nL', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/functions.php', 0, 'QbdVcAXq$', 'QbdVcAXq$', '^HFU,DLR/̣NX6@HY', '', 0, '?'),
 ('XKK\0b	L', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/js/customizer-preview.js', 0, '	ME\r\04} G', '	ME\r\04} G', '<я\rҵCƥʒa\\4N', '', 0, '?'),
 ('ԌDB*', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/js/customizer.js', 0, 'DZL?;~ey,w', 'DZL?;~ey,w', '2w\rF3a\rC{JGKe!q{', '', 0, '?'),
 ('\\J떅HNFS\Z%', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sanitizers.php', 0, '#C@,Y', '#C@,Y', '\0JgIP5z(z:p9k=2gR', '', 0, '?'),
 ('[*Ò', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-background.php', 0, 'h\'uz\'Ӭ', 'h\'uz\'Ӭ', '82h~P5aY,<\"zZ_f', '', 0, '?'),
 ('hNn/6wy', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-button.php', 0, '\"rm!7#>i', '\"rm!7#>i', 'ޯߏq(K{KUtZ\'', '', 0, '?'),
 ('1O?dhshe', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-code.php', 0, 'hF鐡.', 'hF鐡.', 'DugfP|G-\'mÓ\r', '', 0, '?'),
 ('e]N/1h<', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-fields.php', 0, '6Tgy?kW', '6Tgy?kW', 'C̯мA\"p*o?{h!u4FW', '', 0, '?'),
 ('.k[a<bi?yj', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-form.php', 0, 'WZFP1\0', 'WZFP1\0', 'wEԉ`kU=p6U\0*TP0u', '', 0, '?'),
 ('7_..bP\"', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-logo.php', 0, 'ëj\'WBh', 'ëj\'WBh', 'ib3#؞пi[\nw?O', '', 0, '?'),
 ('Wl9@W\'T', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-more.php', 0, '9#)ph/4٩:\rH', '9#)ph/4٩:\rH', '/QrΥKy,xb}B5v+Ѓl>kh', '', 0, '?'),
 ('U]5<RFzO', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-other.php', 0, '@5\"y_)\n\0', '@5\"y_)\n\0', '@8c2w0/*θ}^Y{<\rUuv', '', 0, '?'),
 ('LaSy}=', 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-templates.php', 0, 'A{S)WhE;', 'A{S)WhE;', 'եZ4uILOsxD4\0f', '', 0, '?'),
 ('(&//BS', 'wp-content/updraft/plugins-old/login-customizer/inc/include-page-template.php', 0, '\ZcRsP8͇)', '\ZcRsP8͇)', 'oŞ1{\r;_E0?ژ', '', 0, '?'),
 ('=KZ`Ր=Q', 'wp-content/updraft/plugins-old/login-customizer/inc/initial-setup.php', 0, 'O(,)ą', 'O(,)ą', 'Zc6Ֆj:@=zBXhʐ	Mb', '', 0, '?'),
 ('al	Qi@', 'wp-content/updraft/plugins-old/login-customizer/inc/mailin.php', 0, 'IaI', 'IaI', 'o:DeABP~# )_3$k', '', 0, '?'),
 ('`y}xb\"', 'wp-content/updraft/plugins-old/login-customizer/inc/template-login-customizer.php', 0, 'LH>x[ܡ;', 'LH>x[ܡ;', 'E#uU=\"0mȭvL_', '', 0, '?'),
 ('\ZL;Ø', 'wp-content/updraft/plugins-old/login-customizer/index.php', 0, 'ؠתB\nwt', 'ؠתB\nwt', '݇r\r,Z\'l;4 xn_\no_', '', 0, '?'),
 ('u\\Z(5=J@', 'wp-content/updraft/plugins-old/login-customizer/login-customizer.php', 0, 'fLW>ZH', 'fLW>ZH', ';1fp* W{[M', '', 0, '?'),
 ('񺾔,PB', 'wp-content/updraft/plugins-old/login-customizer/setup.php', 0, 'z %g\"{R5', 'z %g\"{R5', 'œr^\'k6H|Kc-\\Jt', '', 0, '?'),
 ('Tvp', 'wp-content/updraft/plugins-old/login-customizer/vendor/autoload.php', 0, '\'7BC, P', '\'7BC, P', 'qv{\"E倗X}qqUK9ɇ;', '', 0, '?'),
 ('xǡbሽq]', 'wp-content/updraft/plugins-old/login-customizer/vendor/autoload_52.php', 0, '/l	uYϮڷ', '/l	uYϮڷ', ' 3if)/Uʝ^^sr', '', 0, '?'),
 ('p_=+_LSGI', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-endpoints.php', 0, '$ESV܏>A[O2\r', '$ESV܏>A[O2\r', '/`1T^ۇ\04ۙ>\ZVxhaTO', '', 0, '?'),
 ('bwoֺOrp', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-deactivate.php', 0, 'iEfa', 'iEfa', 'C*5U	ڞEDbfyȆ', '', 0, '?'),
 ('	YR}rv', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-factory.php', 0, '\nkk7ߧk3', '\nkk7ߧk3', ':	֜~?Gp%*,w\']f)', '', 0, '?'),
 ('KcKPwQ', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-review.php', 0, '`7Z:\\?,nJ', '`7Z:\\?,nJ', 'buoc6KQX&D', '', 0, '?'),
 ('4\':pj5', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-translate.php', 0, '6*ft&', '6*ft&', '&׉`>`6Bx ĥy-L', '', 0, '?'),
 ('ơx\\tP8\n', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback.php', 0, 'ݿ((Hl*e', 'ݿ((Hl*e', 'ZUadRy#	<.', '', 0, '?'),
 ('r@᣼/T+', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-licenser.php', 0, 'uWh', 'uWh', 'i?d{-%<U+U:_Lf', '', 0, '?'),
 ('M˻Aťj', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-loader.php', 0, 'wMHDݓ', 'wMHDݓ', '[rB[)߬,T179', '', 0, '?'),
 ('Y5M6', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-logger.php', 0, 'BJx=$0y', 'BJx=$0y', '\'E4cpu5Ђ\\-<,', '', 0, '?'),
 ('CwsԒb;l', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-notification-manager.php', 0, '5\0{S;', '5\0{S;', 'F~MZp\r{)e\Z%؍bKufs', '', 0, '?'),
 ('B=w_!', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-product.php', 0, '&\re2W', '&\re2W', 'I+:=._rׄC%9gN', '', 0, '?'),
 ('aE\0\r', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-rollback.php', 0, 'Y1aTز*Ui', 'Y1aTز*Ui', '~X/@i=@3uP0', '', 0, '?'),
 ('{KlɬEP', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget-dashboard-blog.php', 0, '`/.!m4', '`/.!m4', '~H.\0w.P=\0MyJa>', '', 0, '?'),
 ('),', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget.php', 0, 'Yl\0͞w9:', 'Yl\0͞w9:', 'Pt<_dS(yy(j\n', '', 0, '?'),
 ('(hYPmOY|*', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widgets-factory.php', 0, '=7BHIqdLo', '=7BHIqdLo', ' C41ثaFN/̱I', '', 0, '?'),
 ('-wQJ^ei', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/index.php', 0, '6vKL)k', '6vKL)k', 'T3sr_Y7q˴Wek}8', '', 0, '?'),
 ('0f\Z<Y([', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/load.php', 0, 'fꀔa\Zp-', 'fꀔa\Zp-', 'W5U0顷	鶔r2\0BRRK(', '', 0, '?'),
 ('3تNYes', 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/start.php', 0, 'χۆG8', 'χۆG8', '=ʻSEƽg}nވ\n`FIt', '', 0, '?'),
 ('^7w', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/ClassLoader.php', 0, '~1ηP *.', '~1ηP *.', 'k<.&4Vןp', '', 0, '?'),
 ('\rICAU@', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/ClassLoader52.php', 0, 'ȹ	Z^+}i', 'ȹ	Z^+}i', 'N{>Zށd@iVwWU;', '', 0, '?'),
 ('>Ȍ=c', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_classmap.php', 0, 'EӤ㭇Mg', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 ('TC9L0t^', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_files.php', 0, '5NA', '5NA', '?g|}apEM=*׸P})', '', 0, '?'),
 ('A\0piq.', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_namespaces.php', 0, '	ꯚ9Yx', '	ꯚ9Yx', 'r.p$ғM&fqC', '', 0, '?'),
 ('Hah|_', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_psr4.php', 0, ':\0>}LQ\0', ':\0>}LQ\0', '_U\0]q=Չf\\/	@d\r+v*(', '', 0, '?'),
 ('NϨ<+WϮ', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_real.php', 0, '_1ӧyz', '_1ӧyz', ',#sǯEd7|zƿr/2', '', 0, '?'),
 ('f#,36mn', 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_real_52.php', 0, 'ŮL1J', 'ŮL1J', 'g\'k\Z\\1m,vSиw8', '', 0, '?'),
 ('^Ts 9?6', 'wp-content/updraft/plugins-old/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/AutoloadGenerator.php', 0, 'd\Z\r(v:`N\n', 'd\Z\r(v:`N\n', 'qG\"w%\Zۻށg\\4^W', '', 0, '?'),
 ('\nlw\"2ǌI', 'wp-content/updraft/plugins-old/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/ClassLoader.php', 0, 'ȹ	Z^+}i', 'ȹ	Z^+}i', 'N{>Zށd@iVwWU;', '', 0, '?'),
 ('ϡ$!&&	G', 'wp-content/updraft/plugins-old/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/Generator.php', 0, '7j`1e=jv', '7j`1e=jv', '\0\0%ȰW\n\0IHG(', '', 0, '?'),
 ('Y}{_tE]', 'wp-content/updraft/plugins-old/post-types-order/compatibility/LiteSpeed_Cache.php', 0, '\Z\0Ef(\rbP', '\Z\0Ef(\rbP', '|~HH#\rSMJ%KZ)_m8', '', 0, '?'),
 ('x/=㠃', 'wp-content/updraft/plugins-old/post-types-order/compatibility/the-events-calendar.php', 0, 'kVX\0\ra', 'kVX\0\ra', '1;oH|5K@O2b\"6ӳ', '', 0, '?'),
 ('}Yd#A', 'wp-content/updraft/plugins-old/post-types-order/include/class.cpto.php', 0, 'Ny\\.', 'Ny\\.', '_BgQ_^H\\upZqu5~S', '', 0, '?'),
 ('3Ǵؙ:wu', 'wp-content/updraft/plugins-old/post-types-order/include/class.functions.php', 0, 'P}zM#', 'P}zM#', 'ˑ˹V|Ԟ}?89	r', '', 0, '?'),
 (']iκD\"', 'wp-content/updraft/plugins-old/post-types-order/include/class.options.php', 0, 't@p[]$', 't@p[]$', 'Spat|E\rQ@g~Z', '', 0, '?'),
 (',ǪMJA9\'=z', 'wp-content/updraft/plugins-old/post-types-order/include/class.walkers.php', 0, '8gDPPzǎ', '8gDPPzǎ', '	NXi#$#gb#3lMtZ5', '', 0, '?'),
 ('QΜQ^]`', 'wp-content/updraft/plugins-old/post-types-order/js/cpt.js', 0, '{㽴bv\0ӣO', '{㽴bv\0ӣO', 'T \0;2W 3h1', '', 0, '?'),
 ('I8b/h', 'wp-content/updraft/plugins-old/post-types-order/post-types-order.php', 0, 'uDH,', 'uDH,', '&A?[CLN|~޵a.5', '', 0, '?'),
 ('n\0G=1S:', 'wp-content/updraft/plugins-old/revslider/admin/assets/css/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('#r<]B', 'wp-content/updraft/plugins-old/revslider/admin/assets/icons/MaterialIcons-Regular.svg', 0, 'eYLP/(:', 'eYLP/(:', '坴YCN:Q9kdZkxO', '', 0, '?'),
 ('cjKh SEa,', 'wp-content/updraft/plugins-old/revslider/admin/assets/images/sources/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('c0yXx\"&H)', 'wp-content/updraft/plugins-old/revslider/admin/assets/index.php', 0, '{J!u?}s', '{J!u?}s', 'Aũ`97}b>MHJHh|Fj', '', 0, '?'),
 ('1\'j&c!\'@f', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/admin.min.js', 0, ')aPE2Cd', ')aPE2Cd', '{4Kgǲ`\'d', '', 0, '?'),
 ('K/qL,', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/editor.min.js', 0, 'ZT;j', 'ZT;j', 'B7xtۇ%wd]', '', 0, '?'),
 ('7?yt)a@?j', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/help.js', 0, ';Amܝ:6ZD\n', ';Amܝ:6ZD\n', '|GC\0ʨ|xqA0mywW', '', 0, '?'),
 ('B]mCZ͸', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/overview.min.js', 0, 'q3ڻh', 'q3ڻh', '/J\r\rs4SYc9ptcR>`%', '', 0, '?'),
 ('ꅎcΌ 0Z-', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/tooltip.js', 0, 'ugiQ1ϾڤT', 'ugiQ1ϾڤT', '(F8qQ\nBL	aWP', '', 0, '?'),
 ('f9e/eڡ', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/codemirror.js', 0, '4G%-q', '4G%-q', 'Y!P\'xiPlE.e?5', '', 0, '?'),
 (',>xt', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/penner-easing.js', 0, 'H##ډ>Q^', 'H##ډ>Q^', 'F*Q	61jp\rI>\'', '', 0, '?'),
 ('6=D\0ji', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/utils.min.js', 0, 'i~\"yL4L', 'i~\"yL4L', '[jvnO88TW:)P ˎ	', '', 0, '?'),
 ('?Vb/z', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/wavesurfer.js', 0, 'fB8U\\Nx', 'fB8U\\Nx', '}ƸG#3>~Vôf9', '', 0, '?'),
 ('6z{ZM', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/shortcode_generator/shortcode_generator.js', 0, '{:jb7Ӏ', '{:jb7Ӏ', '`=(\nL/WkyG^{#\'z\'y', '', 0, '?'),
 ('(ԡ`<v\ZÛo', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/shortcode_generator/tinymce.js', 0, 'M\n>Ϡ\"k_FS', 'M\n>Ϡ\"k_FS', 'AJXzm%XYgAF77 Uğ', '', 0, '?'),
 (']<j}z\"ϕ', 'wp-content/updraft/plugins-old/revslider/admin/assets/js/shortcode_generator/vc.js', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('d=[`JT', 'wp-content/updraft/plugins-old/revslider/admin/includes/addons.class.php', 0, '7X@Ԫu3f', '7X@Ԫu3f', 'xL	D`4$ystP\Z|^', '', 0, '?'),
 ('M!xGi>c', 'wp-content/updraft/plugins-old/revslider/admin/includes/debug.php', 0, 'iSl-fnm', 'iSl-fnm', '`$bt\"̔d|!qX', '', 0, '?'),
 ('x\nsUrgܗ', 'wp-content/updraft/plugins-old/revslider/admin/includes/export-html.class.php', 0, '\Z \n8 ', '\Z \n8 ', ';dt[[F)^l/K&fI`.', '', 0, '?'),
 ('&.!YX', 'wp-content/updraft/plugins-old/revslider/admin/includes/export.class.php', 0, '^W', '^W', 'lKazmչܑn', '', 0, '?'),
 ('ǝ(W!o/', 'wp-content/updraft/plugins-old/revslider/admin/includes/folder.class.php', 0, 'Oǝ5(]q', 'Oǝ5(]q', 'Ġ\"MPHrLF=cK=V!\"Qd', '', 0, '?'),
 ('lGA\nj', 'wp-content/updraft/plugins-old/revslider/admin/includes/functions-admin.class.php', 0, 'ew\n;`', 'ew\n;`', '>PBvU~)J\'Vf;', '', 0, '?'),
 ('&IMc[', 'wp-content/updraft/plugins-old/revslider/admin/includes/help.class.php', 0, 'Sp6\\\0', 'Sp6\\\0', 'lJ	UcLD4sn8^l7,k', '', 0, '?'),
 ('A3Cq', 'wp-content/updraft/plugins-old/revslider/admin/includes/import.class.php', 0, '3~a˔Q`@ɟ', '3~a˔Q`@ɟ', '5oC\0]Oy^\\s', '', 0, '?'),
 ('u`\\@sИ*m', 'wp-content/updraft/plugins-old/revslider/admin/includes/license.class.php', 0, '5vED~B', '5vED~B', 'UT}eEWVN5g+X|B', '', 0, '?'),
 ('w9<ud8A', 'wp-content/updraft/plugins-old/revslider/admin/includes/loadbalancer.class.php', 0, 'jq_Tш8#', 'jq_Tш8#', 'ɋ2Qd	\'auE}', '', 0, '?'),
 ('R;mĝsYq', 'wp-content/updraft/plugins-old/revslider/admin/includes/newsletter.class.php', 0, '>Z&;+t@ ', '>Z&;+t@ ', '\\Kg܏4+0f\Z\nWs', '', 0, '?'),
 ('%I:v3-j', 'wp-content/updraft/plugins-old/revslider/admin/includes/plugin-update.class.php', 0, ';-', ';-', 'F~%實uj	%\r,a\\$_', '', 0, '?'),
 ('Ge݇sK', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/elementor/elementor-widget.class.php', 0, 'pJi``_%l', 'pJi``_%l', 'x@^Ȓ5믙LO*++', '', 0, '?'),
 ('TQPKtWE`', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/elementor/elementor.class.php', 0, 'IvBer-2Du}', 'IvBer-2Du}', '8خ:p\\c\r0lR&Y@', '', 0, '?'),
 ('j8q6ۮ', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/dist/blocks.build.js', 0, 'EpSt/', 'EpSt/', '\"ĪP,øX=`A+', '', 0, '?'),
 ('#R|k8', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/gutenberg-block.php', 0, 'uC,tñ\r\\', 'uC,tñ\r\\', '%!Grz0,7ىZ*A', '', 0, '?'),
 ('6Pew', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/plugin.php', 0, 'BLB\Z!G', 'BLB\Z!G', '5C-NLp<q4Z', '', 0, '?'),
 ('\n kCռ', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/assets/images/js-wapuu.svg', 0, 'a},1', 'a},1', '\nawv)Ep<B_}YJ\0\"ixo<\'', '', 0, '?'),
 (',ˮ*(kc', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/blocks.js', 0, ')CxVR', ')CxVR', 'XV$ 9l?%<7jcc0J\Z>', '', 0, '?'),
 (' 5MQ\ZGZڻE', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/gutenberg-block.php', 0, '9xJy\r!>', '9xJy\r!>', ']M=GEɮ\rMnȖ4+', '', 0, '?'),
 ('ʙ$ZT9R퉫-H', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/deprecated.js', 0, 'c$ส:vo\'', 'c$ส:vo\'', '\Z1Yޱe_Qz	CgzoG1', '', 0, '?'),
 ('/t56q!FPW', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/index.js', 0, 'ޢF$', 'ޢF$', '۰!a=lwt{l*E', '', 0, '?'),
 ('-?Z)4M\'~.', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revSliderImage.js', 0, 'I\nl8\\hr', 'I\nl8\\hr', '{Mx\nHvp<N7N0 L', '', 0, '?'),
 ('\'PnizFj/', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revslider.js', 0, 'dZ8O䯬t', 'dZ8O䯬t', 's\rZCeS\"ʿ%JRkFkȰ8', '', 0, '?'),
 ('{:\r]OJƺ', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/shortcode_generator.class.php', 0, 'J㨓&B', 'J㨓&B', '`De\ZC\\cKБ%K', '', 0, '?'),
 ('xf\r\'', 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/wpbakery/wpbakery.class.php', 0, 'Q3bІٷ', 'Q3bІٷ', 't>Fr&;h/ jz}G', '', 0, '?'),
 ('YWY(d)a`K', 'wp-content/updraft/plugins-old/revslider/admin/includes/template.class.php', 0, 'ZR@EIBڳ|{:3', 'ZR@EIBڳ|{:3', '{dܡˢЅ݊%\Z6X', '', 0, '?'),
 ('Y$8_\rX', 'wp-content/updraft/plugins-old/revslider/admin/includes/tooltips.class.php', 0, 'gQŤo\0', 'gQŤo\0', '#˺Tr s\"(]&WS', '', 0, '?'),
 ('>\0=-sX؈', 'wp-content/updraft/plugins-old/revslider/admin/includes/widget.class.php', 0, ',:P =*g\"', ',:P =*g\"', '`T-{\\$\Z`Meɘ%Nl\rYF', '', 0, '?'),
 ('}_<e	%G', 'wp-content/updraft/plugins-old/revslider/admin/index.php', 0, '{J!u?}s', '{J!u?}s', 'Aũ`97}b>MHJHh|Fj', '', 0, '?'),
 ('Ft?+ ', 'wp-content/updraft/plugins-old/revslider/admin/revslider-admin.class.php', 0, '핇Ҍ5Vh', '핇Ҍ5Vh', '5q	K\Zr4L֌}vt0<i\'4Cs', '', 0, '?'),
 ('f(X~lB\\d', 'wp-content/updraft/plugins-old/revslider/admin/views/builder-layer-forms.php', 0, 'i\\^ٔ)]', 'i\\^ٔ)]', '\r7P{}ɱB2Jo=`܅', '', 0, '?'),
 ('} бPw(OW&', 'wp-content/updraft/plugins-old/revslider/admin/views/builder-nav-forms.php', 0, '*qyY]=', '*qyY]=', 'uDh8u7ZZ?̞JSC*v*', '', 0, '?'),
 ('Q-^usu', 'wp-content/updraft/plugins-old/revslider/admin/views/builder-slide-forms.php', 0, '8EF籷e?', '8EF籷e?', 'I-QAg9Uh&d	EDv:', '', 0, '?'),
 ('O\0`z\'B', 'wp-content/updraft/plugins-old/revslider/admin/views/builder-slider-forms.php', 0, 'Ur', 'Ur', 'E9Ah^\0z\ZJSĤ3)0\0', '', 0, '?'),
 ('}>{zmJiw', 'wp-content/updraft/plugins-old/revslider/admin/views/builder-timeline.php', 0, '!ޥr\"xWz', '!ޥr\"xWz', 'r+t`̩-p?ݚyh', '', 0, '?'),
 ('lv-g7n', 'wp-content/updraft/plugins-old/revslider/admin/views/builder.php', 0, 'Cs,1j', 'Cs,1j', '8wL A]nEYa', '', 0, '?'),
 ('mh{fx', 'wp-content/updraft/plugins-old/revslider/admin/views/features/add_ons.php', 0, 'eFp^l7\\hu', 'eFp^l7\\hu', 'a<ggG欱g~S>', '', 0, '?'),
 ('ͪ,X\0c', 'wp-content/updraft/plugins-old/revslider/admin/views/features/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('q<R-ki', 'wp-content/updraft/plugins-old/revslider/admin/views/features/layer_animations.php', 0, 'C69~SM8\r.', 'C69~SM8\r.', 'b\0hnW/h0 AR9D\"qi3', '', 0, '?'),
 ('#G=PT\'G.%ǳ', 'wp-content/updraft/plugins-old/revslider/admin/views/features/object_library.php', 0, '߿P4M', '߿P4M', 'o*;{Bb݅}Fw,<UU', '', 0, '?'),
 ('Ba*@D\0V', 'wp-content/updraft/plugins-old/revslider/admin/views/features/premade_template.php', 0, 'aeg~(', 'aeg~(', ')\n5{EMBˎN_', '', 0, '?'),
 ('q{Bɉz\r2f2)', 'wp-content/updraft/plugins-old/revslider/admin/views/features/support.php', 0, ':Q#eDF>4Q/', ':Q#eDF>4Q/', '3GҺN`S4\0D.\r7', '', 0, '?'),
 ('5Ymqh', 'wp-content/updraft/plugins-old/revslider/admin/views/footer.php', 0, '~8.`', '~8.`', 'X1\n^ba10Ww_/d\09', '', 0, '?'),
 ('MafӛTYό', 'wp-content/updraft/plugins-old/revslider/admin/views/header.php', 0, 'E&bB)d<', 'E&bB)d<', ')̣\nZ.EY.~9xb5{5', '', 0, '?'),
 (']f>d7', 'wp-content/updraft/plugins-old/revslider/admin/views/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('t<_eY3', 'wp-content/updraft/plugins-old/revslider/admin/views/modals-builder.php', 0, '=,CtuWI', '=,CtuWI', '|(+FFNl OMHl>4', '', 0, '?'),
 ('{Dg=KXy5', 'wp-content/updraft/plugins-old/revslider/admin/views/modals-copyright.php', 0, '~=/|)gפ]S', '~=/|)gפ]S', 'D¿FD\ZV\rFǹ|xvО	', '', 0, '?'),
 ('d@Wn/!!i<', 'wp-content/updraft/plugins-old/revslider/admin/views/modals-general.php', 0, '!ru	Y	6B`', '!ru	Y	6B`', '|-N:cЕG#in<V', '', 0, '?'),
 ('\ZUV.ǫgy)', 'wp-content/updraft/plugins-old/revslider/admin/views/modals-overview.php', 0, '3GyAXuqل', '3GyAXuqل', '>1s1v|k>FsDP{PT	', '', 0, '?'),
 ('ilΨ\r##y(', 'wp-content/updraft/plugins-old/revslider/admin/views/overview.php', 0, '6FHrCW&\Z', '6FHrCW&\Z', '^_t\07Ho\r\r`Hyj\'oo', '', 0, '?'),
 (']	1Vm\Z2}', 'wp-content/updraft/plugins-old/revslider/backup/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('0.\0@%M%>?_', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Endpoints.php', 0, '2X@N〯~🜳	', '2X@N〯~🜳	', ')1j͐=˱Ƒ2Q\r\"ץ)', '', 0, '?'),
 ('n>]qh', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Exception/InstagramAuthException.php', 0, '< ', '< ', ' א%9gx\0]>gVO|Y', '', 0, '?'),
 ('\r^B?f%\nd', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Exception/InstagramException.php', 0, '^NIle.\\M0!', '^NIle.\\M0!', '3^9\Z{g5?pw0\0', '', 0, '?'),
 ('[q%Lmz?G-', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Exception/InstagramNotFoundException.php', 0, '2b9<', '2b9<', ':LH*l1[!)񗚻b', '', 0, '?'),
 ('7p,:(ܢ\"', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Instagram.php', 0, 'nҖPr$jU', 'nҖPr$jU', 'b?izx~6ߣ7ꕺF<$ƧC', '', 0, '?'),
 ('1莭\rPavR', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/InstagramQueryId.php', 0, '>}Q)0ɚf', '>}Q)0ɚf', 'k/e\n\nu,Se㐫N4x-', '', 0, '?'),
 ('ܥ)z ;tѧ', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Instagram_old.php', 0, 'GA.&}-ˡF', 'GA.&}-ˡF', '1[C.qe~2b', '', 0, '?'),
 ('1FЩe', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/AbstractModel.php', 0, '4\Z,/*-(W	s)', '4\Z,/*-(W	s)', '&62t<29	7Cd8DN', '', 0, '?'),
 (')Je=', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Account.php', 0, '۩/$w#', '۩/$w#', '}r,rTEJ8DR0\"0u', '', 0, '?'),
 ('h#B,M+', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/CarouselMedia.php', 0, 'j&e[U\r.\0H', 'j&e[U\r.\0H', 'w|8(%%G`Ng', '', 0, '?'),
 ('skTgB`', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Comment.php', 0, 'J˯T\ne', 'J˯T\ne', '-_.]/J\ZkS5Z', '', 0, '?'),
 ('ϣC|', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Like.php', 0, 's7R\ZS8$\"A', 's7R\ZS8$\"A', '˅*CͣY	|J|L{4', '', 0, '?'),
 ('RxЉE~', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Location.php', 0, 'TVK ʶ', 'TVK ʶ', 'T:cRmB%	nv)rL', '', 0, '?'),
 ('S:wiWCș~[I', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Media.php', 0, 'Egx~aj|	Eج', 'Egx~aj|	Eج', 'ZCO8Ny>\\p\'@$C', '', 0, '?'),
 ('^uNrCv', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Story.php', 0, '-RF+e+S4wn4', '-RF+e+S4wn4', 'K\r9=W*]W1:#16Sى', '', 0, '?'),
 ('iJ;*wAcKGS`^', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Tag.php', 0, '|b],?	g', '|b],?	g', '{6z:Jȧ^l5xd?Χ', '', 0, '?'),
 ('O@y#', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/UserStories.php', 0, '.O}0{', '.O}0{', ']<F!pbǝQ%5_\\\"9˜}g', '', 0, '?'),
 ('L\ZT#', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Traits/ArrayLikeTrait.php', 0, '҄D?M', '҄D?M', '~LXy^BXN&i!8z`S', '', 0, '?'),
 ('G5J	S', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Traits/InitializerTrait.php', 0, 'JSsrw)vP', 'JSsrw)vP', '\'ݔ\ZG8uM]i+D(żwn⼁', '', 0, '?'),
 (']zO4mMq.', 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper.php', 0, '~͏SY;', '~͏SY;', 'TR^`<5\rQ݊7-hQ<', '', 0, '?'),
 ('57B\030yK', 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Exception.php', 0, '_)DL@\";\'', '_)DL@\";\'', 'SҵВdnSn5ʩd\'', '', 0, '?'),
 ('7\nr:+5;RF', 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Method.php', 0, '6R[d[<', '6R[d[<', 'T˙a(9ek˞(^#gC', '', 0, '?'),
 ('xOݎە}', 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Request/Body.php', 0, 'EeNe<d7.	܈', 'EeNe<d7.	܈', 'fBusmOՈM(1', '', 0, '?'),
 ('`ѳN`:D!P', 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Request.php', 0, 'z=|u?7E', 'z=|u?7E', '{RoJ\'\Zx?y2h蟒', '', 0, '?'),
 ('y.zɓ1', 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Response.php', 0, 'w&-Äh(?6u;\rO', 'w&-Äh(?6u;\rO', '掎vh\0v\rKuf\\', '', 0, '?'),
 ('n\'b', 'wp-content/updraft/plugins-old/revslider/includes/Unirest.php', 0, '=Lc}.', '=Lc}.', '5.dr(ALPBl)1s>s', '', 0, '?'),
 ('N[٭P|n', 'wp-content/updraft/plugins-old/revslider/includes/aq-resizer.class.php', 0, 'rUrua', 'rUrua', 'PnN\0oٰҩs:oʹJu', '', 0, '?'),
 ('j&}fxpr', 'wp-content/updraft/plugins-old/revslider/includes/backwards.php', 0, '\rH𞏊rkJ_h', '\rH𞏊rkJ_h', 'epWzV&/-Į0ު6{ҔA', '', 0, '?'),
 ('TtZke6D', 'wp-content/updraft/plugins-old/revslider/includes/basic-css.php', 0, '^Cgɻ	\0.Bu', '^Cgɻ	\0.Bu', '`~KZq;;xpLwi\n', '', 0, '?'),
 ('d,?`C\Z\'t', 'wp-content/updraft/plugins-old/revslider/includes/coloreasing.class.php', 0, '{<c?\Z<', '{<c?\Z<', '֕nV֓/!\rA:o7.Q', '', 0, '?'),
 ('^GmPBL7', 'wp-content/updraft/plugins-old/revslider/includes/colorpicker.class.php', 0, 'JlL8\ru?', 'JlL8\ru?', 'jCMHkK\r`6N[ל;\'', '', 0, '?'),
 ('iAP', 'wp-content/updraft/plugins-old/revslider/includes/cssparser.class.php', 0, 'FTq]b', 'FTq]b', 'W]E}Ww:cgu', '', 0, '?'),
 ('4Ո,e@', 'wp-content/updraft/plugins-old/revslider/includes/data.class.php', 0, 'D', 'D', 'V\nd3Oadv\0Vhˬ\"	Y', '', 0, '?'),
 ('c~9Qn=0', 'wp-content/updraft/plugins-old/revslider/includes/em-integration.class.php', 0, 'ŽQw245', 'ŽQw245', '\r3.{1n]]X$pc,%\r', '', 0, '?'),
 ('rXi π', 'wp-content/updraft/plugins-old/revslider/includes/extension.class.php', 0, 'xdaG,', 'xdaG,', '7gD\'Si\ZrEAZ', '', 0, '?'),
 ('TZS:s?-L', 'wp-content/updraft/plugins-old/revslider/includes/external-sources.class.php', 0, '^- {\Z{Oa*', '^- {\Z{Oa*', 'ӛL{*.F^EϫŬЙ', '', 0, '?'),
 ('ĵ\"YNf\ZI', 'wp-content/updraft/plugins-old/revslider/includes/favorite.class.php', 0, 'IVD30#UP', 'IVD30#UP', 'q;+W8#cU0c9é\\hc', '', 0, '?'),
 ('Zw', 'wp-content/updraft/plugins-old/revslider/includes/functions.class.php', 0, 'oP222\"nJ', 'oP222\"nJ', '_<ΧVJjpr3MC$~', '', 0, '?'),
 ('ͨ_~gNQj*', 'wp-content/updraft/plugins-old/revslider/includes/googlefonts.php', 0, 'Vp+脨NG%<R', 'Vp+脨NG%<R', '?6>B	zX2#k3bO', '', 0, '?'),
 ('Us&ʿm_tK', 'wp-content/updraft/plugins-old/revslider/includes/navigation.class.php', 0, 't>mr\rf', 't>mr\rf', 'maK;<ɻ/J{U&6ݞ\\(', '', 0, '?'),
 ('o?Kñ:Z;1', 'wp-content/updraft/plugins-old/revslider/includes/navigations.php', 0, '\Z\'ߡΟf\Zj(K', '\Z\'ߡΟf\Zj(K', '~D9Ϊ]ꅌm&Umb\rPyګ', '', 0, '?'),
 ('jˏZ~k:nIr', 'wp-content/updraft/plugins-old/revslider/includes/object-library.class.php', 0, 'Ro&/0xB', 'Ro&/0xB', ']3hn^LIyNQ+n-m/o', '', 0, '?'),
 ('1=K', 'wp-content/updraft/plugins-old/revslider/includes/output.class.php', 0, '=hJLvO', '=hJLvO', '\nT0V!i+\r\Z|nz:d\n(T', '', 0, '?'),
 ('ƴMD@Qpb', 'wp-content/updraft/plugins-old/revslider/includes/page-template.class.php', 0, 'KlvÈ\Z=', 'KlvÈ\Z=', '(b\'<L!`<h-cJ\'', '', 0, '?'),
 ('K*	-;', 'wp-content/updraft/plugins-old/revslider/includes/slide.class.php', 0, '#.^(\\|', '#.^(\\|', '6\nhL$2\\YLt7<x', '', 0, '?'),
 ('%aS|/(<zaɳ', 'wp-content/updraft/plugins-old/revslider/includes/slider.class.php', 0, 'ӂ\Z_/Ҿ& C ', 'ӂ\Z_/Ҿ& C ', 'QBSR^cgt#n32F^πN@e', '', 0, '?'),
 ('l-NH@Ҁ65', 'wp-content/updraft/plugins-old/revslider/includes/update.class.php', 0, 't>`).݃S', 't>`).݃S', 'q4$#0\'!yžw\"T^', '', 0, '?'),
 ('kkB3db^O', 'wp-content/updraft/plugins-old/revslider/includes/woocommerce.class.php', 0, '	5\'`Nb.\r=', '	5\'`Nb.\r=', 'CLzq6n{B}Y̆zG(F', '', 0, '?'),
 ('r', 'wp-content/updraft/plugins-old/revslider/includes/wpml.class.php', 0, '^<P7*m=', '^<P7*m=', 'gaV`*v{>]wJKj!BF', '', 0, '?'),
 ('\rSvp\'%Py', 'wp-content/updraft/plugins-old/revslider/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('V_\'a04v', 'wp-content/updraft/plugins-old/revslider/languages/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('\"mnZR@lK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('±2VI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/sources/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('򨁔{8qv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_3d_rotation_24px.svg', 0, 'V>\ZC', 'V>\ZC', '(4 0*`1؎V);S\ZJRA', '', 0, '?'),
 ('$ug	5{/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_accessibility_24px.svg', 0, 'v1\ZǷ\096-/]', 'v1\ZǷ\096-/]', 'KeS`oY,B	cqp', '', 0, '?'),
 (':=<Ms', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_accessible_24px.svg', 0, 'ukvd+', 'ukvd+', 'Ҿ$P1XӷAMB.{#t5iȔX', '', 0, '?'),
 ('\'0h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_balance_24px.svg', 0, '.`y\0\Z$fޛ', '.`y\0\Z$fޛ', 'O2aufGaܩl\"\'%\'J]', '', 0, '?'),
 ('!;0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_balance_wallet_24px.svg', 0, '#8؃KZ', '#8؃KZ', '\r6\"DNE_\0ܬO^EG', '', 0, '?'),
 ('Lw6bPG\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_box_24px.svg', 0, 'm,0', 'm,0', 'ɵLť#ЈE4.4դ \\', '', 0, '?'),
 ('-k\Z1d4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_circle_24px.svg', 0, 't.[gW6', 't.[gW6', 'ՇO8dL-m?dw.GG:$u', '', 0, '?'),
 ('[aEPs27zSu@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_add_shopping_cart_24px.svg', 0, 'D9V	,Rk', 'D9V	,Rk', '0Ķrx	]x{dE(o2d', '', 0, '?'),
 ('),ˇf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_24px.svg', 0, '\'48;;q8@', '\'48;;q8@', 'U	\"\"غH-	J=p', '', 0, '?'),
 ('^Z`h&^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_add_24px.svg', 0, ']4&?\rR4軉N', ']4&?\rR4軉N', 'ѕ~=+:s	vbO50.\r#\00d', '', 0, '?'),
 ('fiaҡwYP>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_off_24px.svg', 0, 'BJĶw<r', 'BJĶw<r', 'o#e҉(fR\"ǮԠ霊CN', '', 0, '?'),
 ('FnPb_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_on_24px.svg', 0, 'G^(3\njn', 'G^(3\njn', '?No!u=EHCuyc:n', '', 0, '?'),
 (';N);^gY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_all_out_24px.svg', 0, '7v\"Q5', '7v\"Q5', 'PY7W76^&Ӗ쑮@Oe', '', 0, '?'),
 ('FduLw,.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_android_24px.svg', 0, '!BͶ4%`w4޵', '!BͶ4%`w4޵', 'Bj>ij\'L󓿌Gq\rkB7d:', '', 0, '?'),
 ('x^U\Zk-%+[', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_announcement_24px.svg', 0, '^^*gj', '^^*gj', '!ŉg\Z%\rO~UMB*}n', '', 0, '?'),
 ('06:kĀ4vv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_aspect_ratio_24px.svg', 0, '^ySr', '^ySr', '>!lߖl	Ѣ޲%;', '', 0, '?'),
 ('VfnAWXk<o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assessment_24px.svg', 0, '*5\":(;7+', '*5\":(;7+', 'aO;L;_)~ԍ?ഥ:', '', 0, '?'),
 (']Bly_x/x.s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_24px.svg', 0, '(Jط7p_', '(Jط7p_', 'tTɃKUMZCnHnhgX', '', 0, '?'),
 ('^8M?	\Zp!t', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_ind_24px.svg', 0, 'ē٪p*o', 'ē٪p*o', '\'ďh00	\\yzBl', '', 0, '?'),
 ('b|\0veL\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_late_24px.svg', 0, 'J@}Pх5<\n', 'J@}Pх5<\n', '2#ЙV.S#x8euz', '', 0, '?'),
 ('oV6X*Z%xƟ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_return_24px.svg', 0, 'Nk', 'Nk', ',\"\"D_gC64H', '', 0, '?'),
 ('Lې\"K1D2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_returned_24px.svg', 0, 'I}\\ȝ5', 'I}\\ȝ5', 'J8(lK\ZZ_JsɘJ', '', 0, '?'),
 ('ܒJb5?+M', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_turned_in_24px.svg', 0, 'V(`peV', 'V(`peV', 'gSUn}rIS޷O9-f', '', 0, '?'),
 ('΃!g\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_autorenew_24px.svg', 0, 'ˡp,', 'ˡp,', '7m.0J?5}ON:I+脏#8f', '', 0, '?'),
 ('֚NZWيC=Hź', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_backup_24px.svg', 0, 'f#/&M4Ֆ', 'f#/&M4Ֆ', 'ͳJŹ2jt6}aWT%SO', '', 0, '?'),
 ('3bE25פ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_book_24px.svg', 0, ';CY;hP', ';CY;hP', '\Zq27:k~cL:m', '', 0, '?'),
 ('4:,4s]حKD', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_bookmark_24px.svg', 0, ':TJMAR', ':TJMAR', 'R2syn8\"G7gwH$h', '', 0, '?'),
 (']ޗ0 \rqf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_bookmark_border_24px.svg', 0, 'B#R%Ba', 'B#R%Ba', '&D\rDb^K\nZ{0B`0\0#', '', 0, '?'),
 (']ٔy?3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_bug_report_24px.svg', 0, '8b=WhqMh', '8b=WhqMh', 'z\Zl.ݹTgunfRc\\V', '', 0, '?'),
 ('9Q^?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_build_24px.svg', 0, 'TtJU~#V[6', 'TtJU~#V[6', 'C\\\0\"˟	0\'+F~b`C@fk1', '', 0, '?'),
 ('gcoTUdE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_cached_24px.svg', 0, 'iB.L^9.', 'iB.L^9.', 'le&>g`m.X9T,a	-o', '', 0, '?'),
 (')Z㪹', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_camera_enhance_24px.svg', 0, '(a%*%', '(a%*%', 'B˜i\nkк\ZƋLL9ڛ)|', '', 0, '?'),
 ('\Ztx?IohbFE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_card_giftcard_24px.svg', 0, 'Ⱦ|sO#4c', 'Ⱦ|sO#4c', 'UbTLrg$T)\\w^X', '', 0, '?'),
 (';vJ\nn', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_card_membership_24px.svg', 0, '\0gv\\1|z', '\0gv\\1|z', 'Mri\"C։LbZ`|g&', '', 0, '?'),
 (',y\0z&<\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_card_travel_24px.svg', 0, 'P)C*@F$', 'P)C*@F$', '& :VQ\0_E	uN]', '', 0, '?'),
 ('\Z4(\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_change_history_24px.svg', 0, '3jς{6p^K', '3jς{6p^K', 'ꬵZ!圕\0~I.DyG', '', 0, '?'),
 ('Ӥ;6-dʙF]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_check_circle_24px.svg', 0, 'q\0;G1', 'q\0;G1', 'Z܁4B}-WF+_,W', '', 0, '?'),
 ('*A?Ў7x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_chrome_reader_mode_24px.svg', 0, '~=9<I?f', '~=9<I?f', 'PX$n%W\'bKI*>k', '', 0, '?'),
 ('PH~۰53', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_class_24px.svg', 0, ';CY;hP', ';CY;hP', '\Zq27:k~cL:m', '', 0, '?'),
 ('H>+<UAT8Y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_code_24px.svg', 0, ':V\"v ', ':V\"v ', 'aFހV?n}+9W`', '', 0, '?'),
 ('\rP|$P<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_compare_arrows_24px.svg', 0, '\Zۮn+yCPjb', '\Zۮn+yCPjb', '0DI}4|Ƥ.D5VI׊.h%', '', 0, '?'),
 ('gǁ	lw	CݧC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_copyright_24px.svg', 0, '21oG㎭', '21oG㎭', 'ב\"];ޡZ~6FDn*', '', 0, '?'),
 ('%j@8C6&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_credit_card_24px.svg', 0, 'zG}},-3X', 'zG}},-3X', ']|cƈ\n\\އpӧ!ξ\Z', '', 0, '?'),
 ('[gNaCY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_dashboard_24px.svg', 0, 'Nm/Nϩ', 'Nm/Nϩ', 'T-qEN\rj[%9=->', '', 0, '?'),
 ('L#j)(\nHwE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_date_range_24px.svg', 0, 'r^(-NL>', 'r^(-NL>', '4ϾʎVR$׸󳀙ٖ<&\\', '', 0, '?'),
 ('Bu\0p ^\nMq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_delete_24px.svg', 0, '֌NAg?)?y', '֌NAg?)?y', 'BWW>U\rM-⧒,u!', '', 0, '?'),
 ('4hm\ZI#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_description_24px.svg', 0, 'd16cby]', 'd16cby]', '3ބښqBDoL70Ps', '', 0, '?'),
 ('.Da!uC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_dns_24px.svg', 0, '2PyؑP=Z', '2PyؑP=Z', 'FRNgo_?OCwl0', '', 0, '?'),
 ('yᚿbT~c mu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_done_24px.svg', 0, '͓`ݫ6E~', '͓`ݫ6E~', 'Gwv_kk;bz#tͶ', '', 0, '?'),
 ('dehhy彳', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_done_all_24px.svg', 0, '<\n+', '<\n+', 'd9;2\\&Vh-FS32_H', '', 0, '?'),
 ('$}몏GiV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_donut_large_24px.svg', 0, 'gA~6*OMfY3', 'gA~6*OMfY3', 'xwrxw3N0ơˢoEe݁渖\02', '', 0, '?'),
 ('#3?v|M64', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_donut_small_24px.svg', 0, '\nIu\0n(\"9', '\nIu\0n(\"9', '_مXm=ۋiŤP\'\nJUV', '', 0, '?'),
 ('_Xq<]b\'Uw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_eject_24px.svg', 0, 'T̝sLrb%V', 'T̝sLrb%V', 'dAj\r86#Ӈ:쓋!', '', 0, '?'),
 ('_SdQ.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_event_24px.svg', 0, ':ɘ', ':ɘ', 'M!LAY(;3B~z2}iYJWU', '', 0, '?'),
 ('dI3\'5', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_event_seat_24px.svg', 0, '0R\'`~Lh6', '0R\'`~Lh6', 'M9\'\'$K(#^gK\Z', '', 0, '?'),
 ('\0\rkx}<MF', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_exit_to_app_24px.svg', 0, 'RKq^cG*', 'RKq^cG*', 'ǊA{M5_	e֛G\ZmQ(a`', '', 0, '?'),
 (')i\n\0i	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_explore_24px.svg', 0, 'M4\rll', 'M4\rll', 'Eˣ/OS9hZ\\Td\'h', '', 0, '?'),
 ('j\'=Lp>H(]q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_extension_24px.svg', 0, 'e9]/\0]PL+', 'e9]/\0]PL+', 'sc}ZE4>q*]eϰ|', '', 0, '?'),
 ('˃LM8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_face_24px.svg', 0, '\\0^c2!ۚ%', '\\0^c2!ۚ%', 'aNHxjbEgl)\r.r|6', '', 0, '?'),
 ('b䐡m\'}{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_favorite_24px.svg', 0, '\'?0&~\"A2`', '\'?0&~\"A2`', 'N#ә&;oE\rnlN.s2R/k', '', 0, '?'),
 ('zgZG	E', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_favorite_border_24px.svg', 0, '$L', '$L', 'rK<݅qeNS%<\n\0k', '', 0, '?'),
 ('y7^;ZEQ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_feedback_24px.svg', 0, '?ә`EC	-,p', '?ә`EC	-,p', 'c3\rmpi	2S8;h	mz', '', 0, '?'),
 ('D>,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_find_in_page_24px.svg', 0, '^ʞ|?=O020', '^ʞ|?=O020', 'S\"2ȋ:a5p]C<:F}ܽ)^', '', 0, '?'),
 ('Ű4XD%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_find_replace_24px.svg', 0, '̟}R)bn', '̟}R)bn', ']{ރ1ڽ7scRc2޳M', '', 0, '?'),
 ('w/^|WEB4@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_fingerprint_24px.svg', 0, 'ivaa\"[*%f2', 'ivaa\"[*%f2', ',9,9ooNS}qGx` 1c&c', '', 0, '?'),
 ('\0efaE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flight_land_24px.svg', 0, 'ܫؘa*jK\r:', 'ܫؘa*jK\r:', 'r?ݖNA{pȻڅ[a$ES', '', 0, '?'),
 ('\'6{\"@\"x[i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flight_takeoff_24px.svg', 0, '(%m_QbRβ~\Z', '(%m_QbRβ~\Z', 'iU;A¯+aPDw/bV+X\n]', '', 0, '?'),
 ('8Gz>l', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flip_to_back_24px.svg', 0, '#9!QD@?b', '#9!QD@?b', '\\jvݘ	5d)aP]ا-\"', '', 0, '?'),
 ('+(ڧ/!UY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flip_to_front_24px.svg', 0, 'ZK}1gc', 'ZK}1gc', '+#eD	cW\nomħ', '', 0, '?'),
 ('yN>22硸X', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_gavel_24px.svg', 0, 'Q%Epzb', 'Q%Epzb', 'ZEܴ>Ok:ݎo', '', 0, '?'),
 ('i<x\Z+`@\Z{O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_get_app_24px.svg', 0, 'T7_tn3,g', 'T7_tn3,g', '7dd=jpha\\(/ήۢ', '', 0, '?'),
 ('\\G9v\'{^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_gif_24px.svg', 0, 'a-Dd?\\ WXlW', 'a-Dd?\\ WXlW', '0ЖF=͢ڷW]~鴗\Zk;p|ک', '', 0, '?'),
 ('Bi	IARE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_grade_24px.svg', 0, '<M7Ty~OJio', '<M7Ty~OJio', 'ͨigΐgOx8lĵ', '', 0, '?'),
 ('uŒV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_group_work_24px.svg', 0, 'I=^}q6w', 'I=^}q6w', 'ޣ*&nR3\n7Fh.!', '', 0, '?'),
 ('சtsbd9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_help_24px.svg', 0, '\'JCqev~oQ', '\'JCqev~oQ', 'tqO8\\.Yla<', '', 0, '?'),
 ('=ZZ+|ׯ,S', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_help_outline_24px.svg', 0, '5\'@<Jv}?', '5\'@<Jv}?', 'tսJb}FEtyc)x', '', 0, '?'),
 ('9|,\ZPf~Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_highlight_off_24px.svg', 0, '#X׻3뽒@wV', '#X׻3뽒@wV', 'LbCN@q<Zr>(uHձ/\r', '', 0, '?'),
 ('@\ZUcJ1)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_history_24px.svg', 0, '@.j˝F:mf', '@.j˝F:mf', '7)\\*\0du.iTb8醼OZ]', '', 0, '?'),
 ('oW#1Aq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_home_24px.svg', 0, 'ۂ#i|\n(', 'ۂ#i|\n(', '\'%Hym﬑PIlfO', '', 0, '?'),
 ('\"T	tE|@[B', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_hourglass_empty_24px.svg', 0, '~ce%if', '~ce%if', ' W:lc͍\nWhX3\\J', '', 0, '?'),
 ('ꊳ\n{n \0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_hourglass_full_24px.svg', 0, '*{6d', '*{6d', '-KCl^,3NCj\\&4gq՝', '', 0, '?'),
 ('d.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_http_24px.svg', 0, 'J\n)x	', 'J\n)x	', '~Ƥl{P6A_~SB=P1/', '', 0, '?'),
 ('6\"$4\0GT', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_https_24px.svg', 0, 'D?-_XuR', 'D?-_XuR', '\'܀e\'6h\0Vt*H', '', 0, '?'),
 ('b&\ZZ-n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_important_devices_24px.svg', 0, '=#\\!>;h˽', '=#\\!>;h˽', 'yuipăY8Q}o{lt', '', 0, '?'),
 ('cc{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_info_24px.svg', 0, 'FX\0Z1f+', 'FX\0Z1f+', 't<ڴ.~`xxxҼmZ', '', 0, '?'),
 ('cݸ8(c', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_info_outline_24px.svg', 0, 'O2>C09', 'O2>C09', 'a?85]~|ls;m\"', '', 0, '?'),
 ('^I^fPWQ{{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_input_24px.svg', 0, '4yb`_Of', '4yb`_Of', '-h\"ogɒN TEJC*r', '', 0, '?'),
 ('\\RTbVW\r\0ر', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_invert_colors_24px.svg', 0, 'Ihh^]wPٲ\Z', 'Ihh^]wPٲ\Z', 'ڌ8CPjO|HA+[rM6', '', 0, '?'),
 ('\npҲíޣ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_label_24px.svg', 0, 'D[fE8.;:S', 'D[fE8.;:S', '^sbݪǨ!^JG(%~}=	-ph', '', 0, '?'),
 ('a', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_label_outline_24px.svg', 0, 'nr', 'nr', '{\0(n&9ׁ;K6f3', '', 0, '?'),
 ('K*ד@M,*gy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_language_24px.svg', 0, 'ND ǩg;+M', 'ND ǩg;+M', '2AL߇2Oy', '', 0, '?'),
 ('3:=<edNkџc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_launch_24px.svg', 0, ' /Epn{-!', ' /Epn{-!', 'H;\0\Zc^*\'%rN=', '', 0, '?'),
 ('T-4Fgw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lightbulb_outline_24px.svg', 0, ')ݧ6\n', ')ݧ6\n', '6٭5JOWqJ\Z6L4AA2', '', 0, '?'),
 ('ĜI	)Hm', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_line_style_24px.svg', 0, 'R<jN5Ov', 'R<jN5Ov', '\nߵ?#%w(7_B', '', 0, '?'),
 (' ?~ÏaɈ^ѵ]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_line_weight_24px.svg', 0, '\n {\nbن\0r', '\n {\nbن\0r', '* mD2ȉ3lX\n0WJI1', '', 0, '?'),
 ('Tw?zjĔ-rX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_list_24px.svg', 0, '3.v;moU', '3.v;moU', 'lM(M~6OEo_\"I', '', 0, '?'),
 ('OW5u,r)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lock_24px.svg', 0, 'D?-_XuR', 'D?-_XuR', '\'܀e\'6h\0Vt*H', '', 0, '?'),
 ('v^lVhD2R ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lock_open_24px.svg', 0, '^},}*^],c', '^},}*^],c', '\Z1*bSHв(V&TzV?MXJ', '', 0, '?'),
 ('\rNT?䮒c{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lock_outline_24px.svg', 0, '~1ߊ!I', '~1ߊ!I', '-uKHO\nT)0N P9', '', 0, '?'),
 ('\nb48\Zι', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_loyalty_24px.svg', 0, '8L\'aۊh', '8L\'aۊh', 'K\'ujֶÕv LHmZ*l', '', 0, '?'),
 ('B>`s8P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_markunread_mailbox_24px.svg', 0, '/Tj`8h', '/Tj`8h', 'Cy\\P;(5sPflti+9', '', 0, '?'),
 ('3Pl?\\=܉,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_motorcycle_24px.svg', 0, '>Ft;]', '>Ft;]', 'y7W(4b_ԹX~', '', 0, '?'),
 ('bC (`ο', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_note_add_24px.svg', 0, 'Y(Ekjjj\"a', 'Y(Ekjjj\"a', 'Z!MWGV+ur- Gaw', '', 0, '?'),
 ('R7\0\ZjK.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_offline_pin_24px.svg', 0, 'ۻ)y#⧈<q', 'ۻ)y#⧈<q', ' 4P}-Lu!q4[\'x', '', 0, '?'),
 ('͍}\0q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_opacity_24px.svg', 0, 'Q}C{2x', 'Q}C{2x', 'I!12c\".0rg4', '', 0, '?'),
 ('\rܮ	j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_open_in_browser_24px.svg', 0, 'wG%!Vnq', 'wG%!Vnq', '\n!sy_\nh', '', 0, '?'),
 ('H&gClTK2f&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_open_in_new_24px.svg', 0, ' /Epn{-!', ' /Epn{-!', 'H;\0\Zc^*\'%rN=', '', 0, '?'),
 ('c|%s<=Ь	~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_open_with_24px.svg', 0, '_s[-+f0', '_s[-+f0', 'vs7eYZ<\\T', '', 0, '?'),
 ('Ywǫ@K', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pageview_24px.svg', 0, 'E.zɼoyI', 'E.zɼoyI', '@C]#Nb]d6\"2!', '', 0, '?'),
 ('1]ıq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pan_tool_24px.svg', 0, '݈tA\\Z%', '݈tA\\Z%', '8.-:}m-9K$3.}h', '', 0, '?'),
 ('K.o\'mͯ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_payment_24px.svg', 0, 'zG}},-3X', 'zG}},-3X', ']|cƈ\n\\އpӧ!ξ\Z', '', 0, '?'),
 (']i*QN8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_camera_mic_24px.svg', 0, 'S	^EzN', 'S	^EzN', '-ȥpz#5j-Xͅڊ\\$8H', '', 0, '?'),
 (',gf&QQ\\j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_contact_calendar_24px.svg', 0, 'ӌ}LKm}', 'ӌ}LKm}', '\nCf,n^BNH	y\Z[U7t', '', 0, '?'),
 ('%a/T83n;\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_data_setting_24px.svg', 0, 'X6TXD~{Ĳ p', 'X6TXD~{Ĳ p', '#FB˄ʠhNѨ- 8>', '', 0, '?'),
 ('(gWh<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_device_information_24px.svg', 0, '\\+	SK', '\\+	SK', 'Ua\Za/6I*&A\0JwW0j$', '', 0, '?'),
 ('F|9C#@,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_identity_24px.svg', 0, '@Ĥu@u\\', '@Ĥu@u\\', 'uك#spO_=NAbmt6', '', 0, '?'),
 ('XH7i\0FLT', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_media_24px.svg', 0, '9;?(WO1`', '9;?(WO1`', 'l\n/+#?<^2HN', '', 0, '?'),
 ('4(\n-b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_phone_msg_24px.svg', 0, '%,?&s', '%,?&s', 'B>kMbiP:qlBiqkĳ܁Zd', '', 0, '?'),
 ('\0Rn,\\y-bq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_scan_wifi_24px.svg', 0, 'W_MJxx|ZH', 'W_MJxx|ZH', '>%cuѢ3Lї~\'H9(пa,', '', 0, '?'),
 ('L(]d\n.:ܮd', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pets_24px.svg', 0, '8Mʨ!Gt\ZpP', '8Mʨ!Gt\ZpP', '|_m -e9UQwiERۭ.', '', 0, '?'),
 ('7_O=>}i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_picture_in_picture_24px.svg', 0, 'oEvx 9kty', 'oEvx 9kty', '\'?_Z&iYn', '', 0, '?'),
 ('=hFNh', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_picture_in_picture_alt_24px.svg', 0, 'vru\\+X%)+T', 'vru\\+X%)+T', 'і$<}LǃH](Dkp*', '', 0, '?'),
 ('<CZc)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_play_for_work_24px.svg', 0, 'Uf+}ˮ', 'Uf+}ˮ', 'rvzntco&z6P	MdF', '', 0, '?'),
 ('ƅFHpS', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_polymer_24px.svg', 0, '/@7fO(', '/@7fO(', ';\'XS	_4S3zr{', '', 0, '?'),
 ('-=Uׅ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_power_settings_new_24px.svg', 0, 'g{ۻE@$$6a', 'g{ۻE@$$6a', 'f1~I\np|uRFAԿgFK#', '', 0, '?'),
 ('F$ue\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pregnant_woman_24px.svg', 0, 'rJFUَ\"͙Ss4', 'rJFUَ\"͙Ss4', 'M`s#OH~aӍ(p%LdY', '', 0, '?'),
 ('LQCS^.0G', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_print_24px.svg', 0, ')>0\nG\ZrQF', ')>0\nG\ZrQF', ']$pz:\'CR\0syL9#?', '', 0, '?'),
 ('՚ЊFI$z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_query_builder_24px.svg', 0, '\n8l}+QG ', '\n8l}+QG ', '~2`[éYR:ٗέ0\0#$s(', '', 0, '?'),
 ('>z60', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_question_answer_24px.svg', 0, '#5\\#N', '#5\\#N', 'HFS:9zӣ^]\n', '', 0, '?'),
 ('$ӪF,[%sa', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_receipt_24px.svg', 0, '@_\"qn%\0#&0p', '@_\"qn%\0#&0p', 'h(5\r^X̦4FRC', '', 0, '?'),
 ('L(``ߣs<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_record_voice_over_24px.svg', 0, 'K88wrm', 'K88wrm', 'Ewt\0ty6mkX061@%h', '', 0, '?'),
 ('$Ev5]3,z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_redeem_24px.svg', 0, 'Ⱦ|sO#4c', 'Ⱦ|sO#4c', 'UbTLrg$T)\\w^X', '', 0, '?'),
 ('zMD|]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_reorder_24px.svg', 0, '!n>qMVa˿-', '!n>qMVa˿-', '\'#oaP\rRÆ$x:A', '', 0, '?'),
 ('Hsq=[%X', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_report_problem_24px.svg', 0, 'k(1:bck', 'k(1:bck', '*t蛪tmSIo2\r|o۲2k', '', 0, '?'),
 ('}/7SQwf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_restore_24px.svg', 0, '@.j˝F:mf', '@.j˝F:mf', '7)\\*\0du.iTb8醼OZ]', '', 0, '?'),
 ('b9%z`무=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_room_24px.svg', 0, 'I}Ԛ^޵Q\Zw', 'I}Ԛ^޵Q\Zw', '\\]:0cA7kT`	(\0', '', 0, '?'),
 (')zސ/P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_rounded_corner_24px.svg', 0, '27Y~)V\Zo4', '27Y~)V\Zo4', 'O<f+JoِddO]Ց', '', 0, '?'),
 ('`Ti;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_rowing_24px.svg', 0, '+@!kH*ct', '+@!kH*ct', 'j9\nJxAE.	T93', '', 0, '?'),
 ('CKpYn@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_schedule_24px.svg', 0, '\n8l}+QG ', '\n8l}+QG ', '~2`[éYR:ٗέ0\0#$s(', '', 0, '?'),
 ('Ij{eߍ2X', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_search_24px.svg', 0, 'w>LG-', 'w>LG-', '! -+@ؖ.޻P;;', '', 0, '?'),
 ('	QҔaƋo', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_24px.svg', 0, '\'eO @', '\'eO @', 'uDIF!\'>A?OG<', '', 0, '?'),
 ('~zyHO\'*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_applications_24px.svg', 0, '6~Qs4|$t', '6~Qs4|$t', '_Ԇ89W:\nȔ9ր\Zwz{!', '', 0, '?'),
 ('r*)&mbbuv2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_backup_restore_24px.svg', 0, '[3t_E0[]', '[3t_E0[]', 'EOp@KMX,0&(b\rA/', '', 0, '?'),
 ('d	|\Z(>ZC[i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_bluetooth_24px.svg', 0, '\ZK9(\r<n-', '\ZK9(\r<n-', '\0[j#Ȓ;rvw!&xH+d', '', 0, '?'),
 ('V:lbi\n\\\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_brightness_24px.svg', 0, ' @^ZOf\"+', ' @^ZOf\"+', 'H~- li&5j- o.1', '', 0, '?'),
 ('[\0aS=~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_cell_24px.svg', 0, '$5Q\n(hm', '$5Q\n(hm', '.LcC(u+FhuAN7', '', 0, '?'),
 ('Zb8j?P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_ethernet_24px.svg', 0, 'A\0\"z?bB', 'A\0\"z?bB', 'ꡖp\"!19*NL`', '', 0, '?'),
 ('Wէʄ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_antenna_24px.svg', 0, '*,Ԇ]{H', '*,Ԇ]{H', '$Ng\nS\0Չ\\:ܬ9[SS', '', 0, '?'),
 ('<CFow2s{Ʌ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_component_24px.svg', 0, 'q`y_-Kc\\', 'q`y_-Kc\\', 'vA-iSfE$Yf{2', '', 0, '?'),
 ('*%/DGf$I', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_composite_24px.svg', 0, 'q`y_-Kc\\', 'q`y_-Kc\\', 'vA-iSfE$Yf{2', '', 0, '?'),
 ('f{8fF<xr', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_hdmi_24px.svg', 0, '/Lt;!kҾ', '/Lt;!kҾ', 'FLEQF3ba\rJ$ƏL/Ϩ<2', '', 0, '?'),
 ('H^	D%4a', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_svideo_24px.svg', 0, '2GLv)', '2GLv)', '(׻i2\rQ(J|ǖ	*x', '', 0, '?'),
 ('\\l9v#+a*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_overscan_24px.svg', 0, '=^l\Z/ETNA', '=^l\Z/ETNA', '\nv=Os(˔[\"&$-^', '', 0, '?'),
 ('swFKSm2$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_phone_24px.svg', 0, '<s$3G/S', '<s$3G/S', 'Lh\rS__+ZH_(ߓpA ', '', 0, '?'),
 ('WC%?e#od', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_power_24px.svg', 0, '(.`w\'?;.', '(.`w\'?;.', '\'Fye]X^_ftM9૛뺐', '', 0, '?'),
 ('^s)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_remote_24px.svg', 0, '~,L<COp:q', '~,L<COp:q', 'ǥ6_R~@.ULpaUi', '', 0, '?'),
 ('.O\"FBU(Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_voice_24px.svg', 0, ';Ջ	i$', ';Ջ	i$', 'XĪVu.Q>x/b{Aj', '', 0, '?'),
 ('~@\n)xTP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shop_24px.svg', 0, 'G\'(TF\"O', 'G\'(TF\"O', '\'DU+ҥYB8\'', '', 0, '?'),
 ('O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shop_two_24px.svg', 0, 'l.h\nA', 'l.h\nA', 'Oc^$B6I1aCȑ~oz', '', 0, '?'),
 ('HԨP/.#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shopping_basket_24px.svg', 0, 'm\\i&URP\'`\"G/', 'm\\i&URP\'`\"G/', '%ތiR9w=\\`o5\r\0-~m[', '', 0, '?'),
 ('f`@2ۥNEP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shopping_cart_24px.svg', 0, '|F5CV:', '|F5CV:', 'Ԟe;nTGKk`߈68', '', 0, '?'),
 (')#ڥTUcuEhA', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_speaker_notes_24px.svg', 0, 'P#qb\0&[/4', 'P#qb\0&[/4', '--]NU\n?:I0;5-1A', '', 0, '?'),
 ('kfɲ]+[`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_spellcheck_24px.svg', 0, 'w]O\\:N', 'w]O\\:N', 'vnC;e_fs2Sθن[K<i', '', 0, '?'),
 ('Y5ɢ\'L* |N', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_stars_24px.svg', 0, 'RbvM)B', 'RbvM)B', '	\n1[ǎCh4Dׄ.d?U:', '', 0, '?'),
 ('iU~cŦJ\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_store_24px.svg', 0, 'Cؗ5D=_E', 'Cؗ5D=_E', 'TW+ݳ4\r$Y.&}\0v', '', 0, '?'),
 ('Z*쁨\r&+BԊ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_subject_24px.svg', 0, 'sk\'э3#', 'sk\'э3#', '{P+\\贜CRL7mڹO,nm', '', 0, '?'),
 ('/GRː', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_supervisor_account_24px.svg', 0, 'hX\\drn˘F2', 'hX\\drn˘F2', '-Yos%=ܼms\'X2V', '', 0, '?'),
 ('\'(A~דs', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_swap_horiz_24px.svg', 0, 'O8HW߻9+J', 'O8HW߻9+J', 'umbqo:XMF&', '', 0, '?'),
 ('4E=D֮&ix', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_swap_vert_24px.svg', 0, '=JxbYxm', '=JxbYxm', '4pҗU钩.\0snASQ{', '', 0, '?'),
 ('%\\$Rt', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_swap_vertical_circle_24px.svg', 0, 'A@\Z6GCDJ', 'A@\Z6GCDJ', '\'E{҂3E,.zN-	ΣlndL', '', 0, '?'),
 ('_xaDo	`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_system_update_alt_24px.svg', 0, 'ÒH*6NMﴉ', 'ÒH*6NMﴉ', '~$flm%a~X,$\\i', '', 0, '?'),
 ('UWFL', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_tab_24px.svg', 0, '^q~R{ 2Wu', '^q~R{ 2Wu', 'ĩzʍ	k\Zyc\ZJ	{ 6Z ', '', 0, '?'),
 ('>BR?5xu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_tab_unselected_24px.svg', 0, '`̃~f', '`̃~f', 's=5%m4Bj+8QKDj?', '', 0, '?'),
 ('>\\OſBi	Kzۮs', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_theaters_24px.svg', 0, 'H\r2Rڤ', 'H\r2Rڤ', 'jf0k߶zc~ъ@r^f0.', '', 0, '?'),
 ('n9\\q=\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_thumb_down_24px.svg', 0, 'o<LB勂/7>', 'o<LB勂/7>', 'q*ޘilwvq]ө\0{R', '', 0, '?'),
 ('+:3ޑT', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_thumb_up_24px.svg', 0, 'K{Wǒܟk', 'K{Wǒܟk', 'Av\\GU#tB _t7HS,g', '', 0, '?'),
 ('	r-&<m', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_thumbs_up_down_24px.svg', 0, '/Ѣ\nқ', '/Ѣ\nқ', '<~#D{ȏ5\neȨɎςylg\r', '', 0, '?'),
 ('IQt8)E', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_timeline_24px.svg', 0, '\0cd͂Q', '\0cd͂Q', 'y$MbzN7#yt,xo', '', 0, '?'),
 ('^lVMI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_toc_24px.svg', 0, 'F\naD<\0u', 'F\naD<\0u', 'M2*R3;j\\Cj', '', 0, '?'),
 ('/{ V*W', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_today_24px.svg', 0, 'ұ=%F', 'ұ=%F', ')8qT5lf\\MU8};', '', 0, '?'),
 ('3m.b[dNw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_toll_24px.svg', 0, '_Z\'9TNd', '_Z\'9TNd', '˳*:˛\rO_sƯ/+#', '', 0, '?'),
 ('TV_xMGaD', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_touch_app_24px.svg', 0, 'g&\\,oI0Un', 'g&\\,oI0Un', ']\\wz_K͠{;Dsd', '', 0, '?'),
 ('s~v#$gz^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_track_changes_24px.svg', 0, 'NZnnMAp:7k', 'NZnnMAp:7k', 'e9(U@{	yՕH?pEp#', '', 0, '?'),
 ('<?3BWk', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_translate_24px.svg', 0, '\ngQOc', '\ngQOc', 'Nv^?ˌ\0mS*)ii}=_', '', 0, '?'),
 ('*6`3{s奊<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_trending_down_24px.svg', 0, 'B$H!\0+]~H>\n', 'B$H!\0+]~H>\n', ';Apՠ>g~~>\\Nv:9i', '', 0, '?'),
 ('xPuWȜ	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_trending_flat_24px.svg', 0, '{#s$cm', '{#s$cm', 'W)sZNd$;vթnn@@Z?usW', '', 0, '?'),
 ('S^_ <0B<a', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_trending_up_24px.svg', 0, 'ZnagJ', 'ZnagJ', 'e<Sg@,a긙#4', '', 0, '?'),
 ('&	ER;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_turned_in_24px.svg', 0, ':TJMAR', ':TJMAR', 'R2syn8\"G7gwH$h', '', 0, '?'),
 ('gaxW7h\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_turned_in_not_24px.svg', 0, 'B#R%Ba', 'B#R%Ba', '&D\rDb^K\nZ{0B`0\0#', '', 0, '?'),
 ('4{Oki', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_update_24px.svg', 0, 'O@nA^O', 'O@nA^O', '|/cҋ#XqR.tĘx=4', '', 0, '?'),
 ('BcMIds', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_verified_user_24px.svg', 0, '|(s0$r{j', '|(s0$r{j', 'Ή(Zvo$z >{Y,Nk.Q', '', 0, '?'),
 ('\"#ƯFf;uX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_agenda_24px.svg', 0, 'bsn\n', 'bsn\n', ']A/sa92۟84ׇ\ZׁPH', '', 0, '?'),
 ('9oq\Z\n(q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_array_24px.svg', 0, '\r)Utk*Y\"P', '\r)Utk*Y\"P', '.	\Z	fJsW.ETa', '', 0, '?'),
 ('KCv2[.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_carousel_24px.svg', 0, 'c`^2MpEddt', 'c`^2MpEddt', 'xW=7$v>RkO8+Z̧', '', 0, '?'),
 ('7[0NKn#8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_column_24px.svg', 0, '$\r{\"\0zz^R8', '$\r{\"\0zz^R8', 'yǹvTi*gP^n`oy', '', 0, '?'),
 ('SRS@z栦', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_day_24px.svg', 0, '3u9:U:k_', '3u9:U:k_', 'ҡKt\r5X\")1%h\"^\rZ>+1~', '', 0, '?'),
 ('7Ȧ=k', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_headline_24px.svg', 0, 'R>M+diR{', 'R>M+diR{', 'j #cs$LiLp', '', 0, '?'),
 ('EI੃|\0M6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_list_24px.svg', 0, 'W<#IK!', 'W<#IK!', 'XDe{̋6M#%3`>}o7', '', 0, '?'),
 ('@.+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_module_24px.svg', 0, 'i@NikR4\0', 'i@NikR4\0', 'o)ɴviI/!KO/\n8', '', 0, '?'),
 ('qi!52Jd2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_quilt_24px.svg', 0, 'k\0wAIk$', 'k\0wAIk$', '/{i!6,NFx]-|HAI^I', '', 0, '?'),
 ('txtUMj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_stream_24px.svg', 0, 'JVq[ICj', 'JVq[ICj', '@/\Z:jz:\'y>yzQ\n', '', 0, '?'),
 ('bj\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_week_24px.svg', 0, '[o<5', '[o<5', 'LÜI3\\3@I.\ry<ExfhJ꧷', '', 0, '?'),
 ('grFFNf0V', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_visibility_24px.svg', 0, '(dDN=!_2ك', '(dDN=!_2ك', '$7Q\rRt5,y}VOތr', '', 0, '?'),
 ('LJ㪷1j$s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_visibility_off_24px.svg', 0, '/jƮPY', '/jƮPY', 'g5|h$Lign$6g', '', 0, '?'),
 ('h5UE6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_watch_later_24px.svg', 0, 'D;IAEj>', 'D;IAEj>', '1HP~QH1*}.G}	1E', '', 0, '?'),
 ('YmMً', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_work_24px.svg', 0, 'wVduCz9l', 'wVduCz9l', '}[m\07vZϓE|%N', '', 0, '?'),
 ('JB7EØi', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_youtube_searched_for_24px.svg', 0, 'OEiVke', 'OEiVke', 'EviX^=B&}(^SmGC', '', 0, '?'),
 ('#\"Pk>S', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_zoom_in_24px.svg', 0, 'DTyz8\"S', 'DTyz8\"S', 'J^.k_gvbs%J|D', '', 0, '?'),
 ('[	\nܱc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_zoom_out_24px.svg', 0, 'l	Tqp{2', 'l	Tqp{2', 'T~E>;4%)N!iew}5p;nhR', '', 0, '?'),
 ('g\rB1\'cu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_add_alert_24px.svg', 0, 'tǌroY)m', 'tǌroY)m', 'B\\+Ι:[M8bX\r*Y', '', 0, '?'),
 ('\nlג&q&f߳|H', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_error_24px.svg', 0, '[c1Z{SRM', '[c1Z{SRM', 'Q:T\0\'SD{mY2tC#n/', '', 0, '?'),
 ('\nޑem', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_error_outline_24px.svg', 0, 'wK\\ĶÙ', 'wK\\ĶÙ', 'zaψe}Gt$}{P	Ȁ', '', 0, '?'),
 ('[\0v)KC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_warning_24px.svg', 0, 'k(1:bck', 'k(1:bck', '*t蛪tmSIo2\r|o۲2k', '', 0, '?'),
 ('smclט', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_add_to_queue_24px.svg', 0, '2EjgXFzo', '2EjgXFzo', 'UHp3عaл', '', 0, '?'),
 ('`Q\06*LYg', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_airplay_24px.svg', 0, '%b]v4)+\r', '%b]v4)+\r', ';yDNFHp\ZETyb22_', '', 0, '?'),
 ('vLg\r{s]ʖ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_album_24px.svg', 0, '#S\06-4', '#S\06-4', 'O>5cIf܎sGl8z[4', '', 0, '?'),
 ('!܅~.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_art_track_24px.svg', 0, 'siS?L\\U@97', 'siS?L\\U@97', '\Ze*F̒KDG<W>', '', 0, '?'),
 ('BQ/l1Dل', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_av_timer_24px.svg', 0, '\rM\n', '\rM\n', 'gi{GB29I嬩ul!', '', 0, '?'),
 ('\\\Zf$lk,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_closed_caption_24px.svg', 0, 'n1\0<x׈v=A$', 'n1\0<x׈v=A$', 'd9`\'-LA[r[g8W?~e', '', 0, '?'),
 ('C(IEb', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_equalizer_24px.svg', 0, 'e|L#=\Z7J', 'e|L#=\Z7J', '>$<z=BH9 90fR+SWaKsx', '', 0, '?'),
 ('aO\r\\wQ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_explicit_24px.svg', 0, 'yOAqQ}\"Ҭ2', 'yOAqQ}\"Ҭ2', '!IG-i`cb{fkT̑#', '', 0, '?'),
 ('!%~t5j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fast_forward_24px.svg', 0, 'NwkvO4', 'NwkvO4', 'gO]tʱ>4<%4uJwr!==', '', 0, '?'),
 ('jgD/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fast_rewind_24px.svg', 0, '/+p7@', '/+p7@', ':FV\ZnQ.yWLiV', '', 0, '?'),
 ('\0[n({}	\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_dvr_24px.svg', 0, 'G5\0', 'G5\0', 'Ò]gq-aȠ.Kw)0\'', '', 0, '?'),
 ('\ZiH9iZc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_manual_record_24px.svg', 0, 'K{q', 'K{q', 'B_v\\L:X/pٞg挲G.`t	Af', '', 0, '?'),
 ('yޯ,s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_new_24px.svg', 0, 'Y<iCY0l', 'Y<iCY0l', 'Ez>heR(!ԩ\"D&zt3Y', '', 0, '?'),
 ('	1BD<y6н', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_pin_24px.svg', 0, 'd)tndI', 'd)tndI', 'G3 UtIn_36P', '', 0, '?'),
 ('A w~q\n7S', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_smart_record_24px.svg', 0, '8ѯֹ2ti', '8ѯֹ2ti', 'Fam5kS	R;BNW9', '', 0, '?'),
 ('cwH-x\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_forward_10_24px.svg', 0, 'bClꟗ^<#{', 'bClꟗ^<#{', 'O0#ʯVf82uqD: N>e\\', '', 0, '?'),
 ('5+[d', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_forward_30_24px.svg', 0, 'x<i]$w4', 'x<i]$w4', '!;+h\"ݔzc=ɏ$C27.', '', 0, '?'),
 ('˳Yb', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_forward_5_24px.svg', 0, 'OE]}U', 'OE]}U', '[3\0HE eB0oDk', '', 0, '?'),
 ('g瑐\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_games_24px.svg', 0, '	pT=2e\Z$', '	pT=2e\Z$', '[twݫjPeW>Üc4\'Xa	', '', 0, '?'),
 ('Bb}:W\'	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_hd_24px.svg', 0, '--o', '--o', '\"B1H5Lj4ȍ\"onxWG\\', '', 0, '?'),
 ('ױ>Sw1qUj2eU', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_hearing_24px.svg', 0, '{{|o7a', '{{|o7a', 'F|I}na05%F', '', 0, '?'),
 ('HJGT\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_high_quality_24px.svg', 0, 'Gl*G8_#<', 'Gl*G8_#<', 'xm<|n7j\\\"#jZ/1AS', '', 0, '?'),
 ('|:$7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_library_add_24px.svg', 0, 'rĚK', 'rĚK', '˛KiF(6yvstUXVĺA', '', 0, '?'),
 ('A|>	sn`Ȅ1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_library_books_24px.svg', 0, 'q ehNP&z', 'q ehNP&z', '+ЉHlc\\2!^<J<j3e<', '', 0, '?'),
 ('I\Z;_?f\"@Q^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_library_music_24px.svg', 0, '؃#rw', '؃#rw', 'T\r-QךH}{5,2', '', 0, '?'),
 ('Lf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_loop_24px.svg', 0, 'r/2%&.V', 'r/2%&.V', 'h)u⬉!{G\0\0\0xY#iDV', '', 0, '?'),
 ('s4ȡRrml', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_mic_24px.svg', 0, '+ \n1b7c	<', '+ \n1b7c	<', 'ms;-n s<i;b#\0DsiOXxY', '', 0, '?'),
 ('Ƶ_<\0H', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_mic_none_24px.svg', 0, 'V\'-0*~', 'V\'-0*~', 'v@ՄM \Z+!\r*', '', 0, '?'),
 ('en{d', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_mic_off_24px.svg', 0, 'g^VgK-$', 'g^VgK-$', 'b}U۫:oZ󨳲t[qpៜ0#O', '', 0, '?'),
 ('bdsk	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_movie_24px.svg', 0, '|>ed:U', '|>ed:U', 'Xc\Z3V.M(9rLi', '', 0, '?'),
 (',oTƤ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_music_video_24px.svg', 0, '~f̨_', '~f̨_', 'STύfsL5lF|\rp7C=7Uw\r+0', '', 0, '?'),
 ('h1*?M،?=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_new_releases_24px.svg', 0, 'Z3˰rLnf', 'Z3˰rLnf', '#N?76Ҷ2Gk5j5E|', '', 0, '?'),
 ('zFf\"|na	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_not_interested_24px.svg', 0, '0}} w', '0}} w', '幑姥6wXK]I;x4', '', 0, '?'),
 ('=4V!-/\'fN|', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_pause_24px.svg', 0, '\\h\0=9\"', '\\h\0=9\"', 'mldJYEA_}Ѯrw\nY9', '', 0, '?'),
 ('Ih\0T!W+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_pause_circle_filled_24px.svg', 0, '_My9TKVq(', '_My9TKVq(', 'ojLV)fXhcbyQ', '', 0, '?'),
 ('BB?,jۋ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_pause_circle_outline_24px.svg', 0, 'L0wר4', 'L0wר4', '	<1x9L405X@!vk_KTϫ>', '', 0, '?'),
 ('1na<C4)e', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_play_arrow_24px.svg', 0, 'vt3ڛ?x', 'vt3ڛ?x', '_ [hS[?kLDQ%Nr+Ҫ', '', 0, '?'),
 ('9r	r\0V1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_play_circle_filled_24px.svg', 0, '~CΥ>]ȡ*7', '~CΥ>]ȡ*7', '_8gIOB=<Me\0o^H', '', 0, '?'),
 ('L]>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_play_circle_outline_24px.svg', 0, 'xxCx', 'xxCx', 'aѹ0bE?iV~GrDa4؀', '', 0, '?'),
 ('\rtݲo`g', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_playlist_add_24px.svg', 0, 'II/7DjYdS', 'II/7DjYdS', '\']I˕wr7Z\"4KA=	*', '', 0, '?'),
 ('2qJ-z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_playlist_add_check_24px.svg', 0, '9q6ȈC\rvg>_', '9q6ȈC\rvg>_', '䘡%E.5pIp>NWk', '', 0, '?'),
 (']\ZWsLЖ݄', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_playlist_play_24px.svg', 0, '%hӐ׿r4', '%hӐ׿r4', 'w8QOڂ]:KBHJs', '', 0, '?'),
 ('EZx3y1@ٰ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_queue_24px.svg', 0, 'rĚK', 'rĚK', '˛KiF(6yvstUXVĺA', '', 0, '?'),
 ('\r<i>!e\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_queue_music_24px.svg', 0, '\\ZcF30', '\\ZcF30', 'm=Mŏ\rl\"`1qG\Z6~,6', '', 0, '?'),
 ('JAZq7>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_queue_play_next_24px.svg', 0, 'ngMmDMJ#Q	', 'ngMmDMJ#Q	', 'zJY\'])[N\ry!mF3o', '', 0, '?'),
 ('C[C3NSJ/VL', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_radio_24px.svg', 0, 'G/WX}9}!', 'G/WX}9}!', '7W,!Wqv`d}ef),d', '', 0, '?'),
 ('\0?LNj>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_recent_actors_24px.svg', 0, 'Iaoެi', 'Iaoެi', 'x5\n`Zz_=zC0e.\Z`	0', '', 0, '?'),
 ('ސsb	Olt', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_remove_from_queue_24px.svg', 0, 'zU;}B^J]\n\0\"N', 'zU;}B^J]\n\0\"N', 'Kٛ:bVf9IZ1', '', 0, '?'),
 ('|W\".q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_repeat_24px.svg', 0, 'e˼jl', 'e˼jl', 'V7^В^\"4!vv', '', 0, '?'),
 ('̌v{Rݳ{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_repeat_one_24px.svg', 0, 'ao R\n321', 'ao R\n321', '`)|\0H2\nBK˓>ZT#y`', '', 0, '?'),
 ('N>\ZS_.W}o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_10_24px.svg', 0, 'B	)', 'B	)', 'YP)!6MM./sip\Z', '', 0, '?'),
 ('ރ$#m1o ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_24px.svg', 0, 'HÊ^#', 'HÊ^#', '\\6.^DϪ~|,<y', '', 0, '?'),
 ('^jiFwi	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_30_24px.svg', 0, 'rN	-W6a`', 'rN	-W6a`', '.8}?]nIj\0ԥi.', '', 0, '?'),
 ('\'dobb0_kkt', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_5_24px.svg', 0, 'f4Pŏـ', 'f4Pŏـ', '7k!dPg_7ol:X챍?1', '', 0, '?'),
 ('A\r\Ze', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_shuffle_24px.svg', 0, 'BX\03ժ`l', 'BX\03ժ`l', '\r+/ʱvdD<d	\rsq幞ss', '', 0, '?'),
 ('4ܓnFz,\r2-', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_skip_next_24px.svg', 0, '\Z\'*m&ًE', '\Z\'*m&ًE', 'cuI?7M&8[UM\nL', '', 0, '?'),
 ('=HUڷ䬠@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_skip_previous_24px.svg', 0, '	1GKa&w͖', '	1GKa&w͖', '4?\"	j`lP//', '', 0, '?'),
 ('dBuZeP:', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_slow_motion_video_24px.svg', 0, 'zⳭ|0\0Wo', 'zⳭ|0\0Wo', 'q͝MH!\rark&Yh>b', '', 0, '?'),
 ('i6.ǈ]?\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_snooze_24px.svg', 0, '޾H\Z,]P', '޾H\Z,]P', 'ˊKՈDf~-}˄[m', '', 0, '?'),
 ('z3Mgc}v	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_sort_by_alpha_24px.svg', 0, '+Mo%|fi', '+Mo%|fi', '~xش{xވ>6غn>2Eo', '', 0, '?'),
 ('UZqV׊Y\\\r\ZF', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_stop_24px.svg', 0, ')*XƳ<C/p', ')*XƳ<C/p', 'hk\0a%ͺ}\\̪MQ9@', '', 0, '?'),
 ('Izu+ܶ*)Dk،', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_subscriptions_24px.svg', 0, '+^G\0w)T]', '+^G\0w)T]', ']=	m0w8Iz3 b', '', 0, '?'),
 ('cG*\r`ʠS', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_subtitles_24px.svg', 0, 'tq`g#', 'tq`g#', '嵾pBvyk tw8 řΞ[96', '', 0, '?'),
 ('ZKrIAM}', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_surround_sound_24px.svg', 0, '	&ƕϢP`', '	&ƕϢP`', 'gX\'f9I)Z#AHZ\0:', '', 0, '?'),
 ('1LeC0ފz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_video_library_24px.svg', 0, 'G5.nO\ZbNuF', 'G5.nO\ZbNuF', '|\Z(CvknWWU.C[o`!', '', 0, '?'),
 ('U,F+G', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_videocam_24px.svg', 0, '3ʠ7', '3ʠ7', '(.W\n$ھHа \ZG\"FG', '', 0, '?'),
 ('m>\nd2z|Co', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_videocam_off_24px.svg', 0, 'жí\"', 'жí\"', 'mjr+t\'\"Iu@ZW^O|', '', 0, '?'),
 ('z\0٧t', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_down_24px.svg', 0, '#ITU;H#H', '#ITU;H#H', 'S:삫f#Ռ/J;4E˳w-', '', 0, '?'),
 ('xJ2uWFΟ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_mute_24px.svg', 0, '*IXk+[Hc', '*IXk+[Hc', 't\Z8h!NR2Y\0|0', '', 0, '?'),
 ('{\rYC.ͫs', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_off_24px.svg', 0, 'fk}J(OK', 'fk}J(OK', '\\!sʻr\ZVM%/˙\'', '', 0, '?'),
 ('?ŸwzY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_up_24px.svg', 0, 'lz\rmq\0\'x', 'lz\rmq\0\'x', 'ݺQjk7:otv', '', 0, '?'),
 ('*%F3/HX~Unf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_web_24px.svg', 0, '=>D3*l^', '=>D3*l^', '஥MB+P\ZYwOYwhr', '', 0, '?'),
 ('[-Lsw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_web_asset_24px.svg', 0, 'a\raWW]/rJc', 'a\raWW]/rJc', '7\n˷988>7ch5wY!%', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('WK^쫇:y4tj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/NewTux.svg', 0, '!m8w2#ͫ=', '!m8w2#ͫ=', ']ANY($nU[0', '', 0, '?'),
 ('6ǀ9h(9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/abacus.svg', 0, 'ifqs>J0', 'ifqs>J0', '\nJhtr[k*Wpa#O[v{', '', 0, '?'),
 ('M7#:V>UL', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/address-book.svg', 0, 'X\ZK:8D^(s', 'X\ZK:8D^(s', '__u( ,8$O`5', '', 0, '?'),
 ('tEh#Y%IP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/address-book2.svg', 0, 'R7rR\rw3', 'R7rR\rw3', '\rI^c>ڮuB7[4öU', '', 0, '?'),
 ('f\nDv\rfCz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/aim.svg', 0, ',)%\Z$}Ng', ',)%\Z$}Ng', '؞-	\0[	C61^C`.+', '', 0, '?'),
 ('KO@¢7i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/alarm.svg', 0, 'ot̾TC{=sS', 'ot̾TC{=sS', '>bb$\"\ZܪR1]h.$\\HA', '', 0, '?'),
 ('\'3e__oX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/apple.svg', 0, 'o6<@', 'o6<@', 'Qxucv>Ġ2x', '', 0, '?'),
 (' hd,l?CW', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/arrow-left.svg', 0, 'qbl&lz', 'qbl&lz', 'Yk}%up6f_ާ4sL#x5_\'H', '', 0, '?'),
 ('{.U]$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/arrow-right.svg', 0, 'q媑ar\0=1', 'q媑ar\0=1', 'PSǿFZ]fƆPL\":Y`', '', 0, '?'),
 ('CQ*CڰoN', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/arrows-updown.svg', 0, 'J^Ahfkr4', 'J^Ahfkr4', '\r4W{XGZ!ҭznfF&B\0ԓ', '', 0, '?'),
 ('\nz`\nj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/atm-cash.svg', 0, 'x1Iohz', 'x1Iohz', '%jΤIZ7T y(pl,\0is', '', 0, '?'),
 ('4$O෽', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award1.svg', 0, '{ 2NC*D{', '{ 2NC*D{', 'NNeCU\0D', '', 0, '?'),
 ('H\nު^\\CY4%JK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award2.svg', 0, 'A\\z#0Ǩ', 'A\\z#0Ǩ', 'vX*\"Ku?Ȋ!C', '', 0, '?'),
 ('0!zMb', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award3.svg', 0, 'ȚK\ZN69\'&K', 'ȚK\ZN69\'&K', ',KDQcx0m', '', 0, '?'),
 ('*JEß@\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award4.svg', 0, 'PRx~챕!', 'PRx~챕!', '|Ž`YH(^f,6i`T^-[E%', '', 0, '?'),
 (']s?}]6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award5.svg', 0, '7َ2iN} ', '7َ2iN} ', '\"*!ϙ*ErM[9f.*݃8B', '', 0, '?'),
 ('@R|5RA', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/badge01.svg', 0, 'L\"\0=', 'L\"\0=', '\ntU~asg	41J', '', 0, '?'),
 ('CI\nl/[v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/badge02.svg', 0, '-Q.1qK7=', '-Q.1qK7=', '5I\'aM\nI<ۙ=51~', '', 0, '?'),
 ('ʕI<&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bank.svg', 0, '^wy#)Y\"', '^wy#)Y\"', '$pyD:h*[%Oo㕁', '', 0, '?'),
 ('Hz:Ԑ9l', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bank2.svg', 0, 'W{z%=T/7+/', 'W{z%=T/7+/', '2_)bb^PhPM', '', 0, '?'),
 ('bXc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bell.svg', 0, 'h;om<s', 'h;om<s', '=_;%Y7Df[?\\p{e', '', 0, '?'),
 ('+yj\Z}?uʩf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/binoculars.svg', 0, 'z>jߡ!X[G', 'z>jߡ!X[G', 'T-E}:u0]d/3!', '', 0, '?'),
 ('1rO(1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bomb.svg', 0, 'lS{*x$', 'lS{*x$', 'oS~EQg{Lwkvn¿j8', '', 0, '?'),
 ('!QgY/UCt', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bonsai.svg', 0, 'i:j#', 'i:j#', 'c4]vwfvCF2vAxHI1', '', 0, '?'),
 ('wE%6\0(', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/book-apple.svg', 0, 'OU8iԥ$e7', 'OU8iԥ$e7', 'b}$ŖbJ1Ћ\"${%vu\n;uQ', '', 0, '?'),
 ('] W\nV!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/book.svg', 0, '_pU ]\nq%kA', '_pU ]\nq%kA', 'F_\rbm^OI_W:2J<\0*6ɪ', '', 0, '?'),
 ('SϝvCc7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bookmark.svg', 0, '](\09', '](\09', 'l`-5a@<Gb\n^*\"=q', '', 0, '?'),
 ('%ԣMS[KN27', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/box.svg', 0, 'EÃAzq|f', 'EÃAzq|f', 'gjŦV|e7c\04~$%p$됶', '', 0, '?'),
 ('S֘', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/brain.svg', 0, 'X.2A}Ng', 'X.2A}Ng', 'M~/T(ؠB}b%~p', '', 0, '?'),
 ('0j@J0	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/briefcase.svg', 0, '7Q!MEv͹+@', '7Q!MEv͹+@', '$IvrG2e2&\nS5h;', '', 0, '?'),
 ('eH}! azx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/browser01.svg', 0, '\nX=', '\nX=', 'Q\r.=VXNh2c', '', 0, '?'),
 ('\"vG>O8Ȯm', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/browser02.svg', 0, '_]$_B', '_]$_B', 'A={9ʚڹs&CJ0KGw=AIW', '', 0, '?'),
 ('ѥ52', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/buildings.svg', 0, '4@׉)1ƋtR', '4@׉)1ƋtR', '6ӣeDBzRµs', '', 0, '?'),
 ('ڬHE)vE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/buy-sign.svg', 0, '=?IOTP', '=?IOTP', 'rL5\0_^psjUNBR', '', 0, '?'),
 ('3L?mܢv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calculator1.svg', 0, 'BzkwJ', 'BzkwJ', '·Q//y;]jbEX', '', 0, '?'),
 ('ZPjk.Jdu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calculator2.svg', 0, '`\0WPΛ$', '`\0WPΛ$', '1A\0K;tUrV\'\ZE', '', 0, '?'),
 ('V|fg\0&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calculator3.svg', 0, 'Sx\"!wJV$', 'Sx\"!wJV$', 'D2E;Uq6(j5nj0; ', '', 0, '?'),
 ('oĴ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar1.svg', 0, 'xVЇS8J', 'xVЇS8J', '+(\Zx)u]}j}ᬡjB_=;', '', 0, '?'),
 ('(?m1j3vC(+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar2.svg', 0, 'eM\"zD(', 'eM\"zD(', 'bP	`<t/d^8O{b/i', '', 0, '?'),
 ('Wfg4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar3.svg', 0, '#Se3~ϫr', '#Se3~ϫr', 'ExI4k{B*\'X2L', '', 0, '?'),
 ('\Ze@|\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar4.svg', 0, '@_LFo', '@_LFo', 'CpB%~mY_NP1zJ', '', 0, '?'),
 ('lbfo|R:ͩ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar5.svg', 0, '䆊Ydx', '䆊Ydx', '(b\nW!T|Xi-\nˇD', '', 0, '?'),
 ('mȵBv9b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/certificate.svg', 0, '*;CMC)Й*', '*;CMC)Й*', 'tFNQ#l]BܲLX\'g\\\0ŵi', '', 0, '?'),
 ('#E/\0P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/champagne.svg', 0, 'gNϡ(', 'gNϡ(', 'g*b.8B¢[ջv`)ef', '', 0, '?'),
 ('})|H䥟', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character01.svg', 0, 'U:JVh', 'U:JVh', 'R>S@>DeTC `OGyW{', '', 0, '?'),
 ('Q`\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character02.svg', 0, 'OBW>3', 'OBW>3', 'H\"j<cOng', '', 0, '?'),
 ('w	ۖ#_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character03.svg', 0, 'eU|z0\'+', 'eU|z0\'+', 'Ơ/*^̫Wr:K䷆A1zD,', '', 0, '?'),
 ('Y2}o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character04.svg', 0, 'hw(\"', 'hw(\"', 'nZ5EX<7=O4(#T.a', '', 0, '?'),
 ('G<5T}3If', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character05.svg', 0, 'Ҙv(`\n9 -$fy', 'Ҙv(`\n9 -$fy', '[pyד8gɑ9̤QqufG', '', 0, '?'),
 ('5Z`TQ b&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character06.svg', 0, 'jCW7P.U', 'jCW7P.U', 'v(y)7W/?%n~', '', 0, '?'),
 ('Ĭؓh|', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character07.svg', 0, 'N+r\nO9d', 'N+r\nO9d', '~cEt.kz%0J/\Z { ', '', 0, '?'),
 ('+_\'UT', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character08.svg', 0, '(ۭsU7B', '(ۭsU7B', 'QuohRW4LкB`uBƈ.U', '', 0, '?'),
 ('#2YO=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart-analysis.svg', 0, 'RaMY', 'RaMY', 'ozOH8[?*t0X\\:', '', 0, '?'),
 ('¹{ZBh}Kc|Q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart-board.svg', 0, '(;gB]h', '(;gB]h', 'a+pgR	ǅ_zn*n9e=', '', 0, '?'),
 ('&a+\".섎x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart-pyramid.svg', 0, 'Z7q.4UW', 'Z7q.4UW', '9ix,zά8u~)6ݔM)%l', '', 0, '?'),
 ('n9˛Bmb*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart01.svg', 0, ':ffG+Z˩', ':ffG+Z˩', '[aLpJ_̪(ZkvĎ', '', 0, '?'),
 (')]jfBv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart02.svg', 0, '}]kb4!	w.{', '}]kb4!	w.{', 'PJL\"Ն|p#PqP7Cc,', '', 0, '?'),
 ('q>ī80R`lE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart03.svg', 0, '\"\\m#YR\0', '\"\\m#YR\0', '}g%̦~@(BFӻ$:', '', 0, '?'),
 ('*|቏#BAഎ,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart04.svg', 0, 'WXn	dG', 'WXn	dG', 'UDŸ}$֖mI3AB\'wHD', '', 0, '?'),
 ('Im3B', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart05.svg', 0, '6ąs', '6ąs', '^/PUD\\ v/Ec6', '', 0, '?'),
 ('G\'<6`gL0؋Cq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart06.svg', 0, 'laK@VLv(', 'laK@VLv(', 'GMaPX5*-EpM4PSe>', '', 0, '?'),
 ('6 y-Q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart07.svg', 0, 'o0LQٗc\"n', 'o0LQٗc\"n', '6^4L\'Go80^Qg%gLٛ', '', 0, '?'),
 ('ȅ\Z?$բ{mEe', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart08.svg', 0, '6`Iy{4+|o', '6`Iy{4+|o', 'X5Rʩ{G:}A\0^ˊ', '', 0, '?'),
 ('kQuTZy ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart09.svg', 0, ')TMb78;', ')TMb78;', '{gYL:T;uV+', '', 0, '?'),
 ('RЬi;ԝNh{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart10.svg', 0, '/g	dNӾ^jݨ`', '/g	dNӾ^jݨ`', ';?\r][t\0ǭ	dT', '', 0, '?'),
 ('J,{%<Ҷ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart11.svg', 0, 'K-辰	MÞ5', 'K-辰	MÞ5', 'O י#z2y;/O]\Z\\U7>', '', 0, '?'),
 ('Rm|/3Q۩Ah', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart12.svg', 0, 'ai7(', 'ai7(', 'ئ\\Ӝ3hc.ALh|r)', '', 0, '?'),
 ('!oMC`al', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart13.svg', 0, 'ɣC1}9|E', 'ɣC1}9|E', 'sؿ88ޖnQmm|\0', '', 0, '?'),
 ('YF,TIx@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart14.svg', 0, 'OZP5ݖa#', 'OZP5ݖa#', 'q!9axdeG', '', 0, '?'),
 (')Wl@-\n~q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart15.svg', 0, 'x(RBO,,)', 'x(RBO,,)', 'Kbx~MjQ2yTP1', '', 0, '?'),
 ('JY\nhm~m', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart16.svg', 0, '+&ŧ@te(', '+&ŧ@te(', '3*\0}WJ]@JPNerMߐR', '', 0, '?'),
 ('KçgH|~C#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart17.svg', 0, ':ixYY/T', ':ixYY/T', 'ͻ!\'fxZS/\\yk(', '', 0, '?'),
 ('0\Z֜|q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart18.svg', 0, 'ySկ\0	+G[', 'ySկ\0	+G[', 'Ա}_\n]xO`zr\\tXGV', '', 0, '?'),
 ('=e1HskUn', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart19.svg', 0, '%N\'GH', '%N\'GH', '\\r[w[Ukуhf\Zzt%i-t/', '', 0, '?'),
 ('WJng[K!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart20.svg', 0, '=&N1ݳII', '=&N1ݳII', 'C^i3}Y[Ș|-u`', '', 0, '?'),
 ('fMf^\"me$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart21.svg', 0, 'i\'\0S<', 'i\'\0S<', 'T!<;,޸\'V9g$-=U', '', 0, '?'),
 ('`wR5:ǏJ/O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chat.svg', 0, '66W˧X,im', '66W˧X,im', '9gD.K@ȋ^)^MD&P', '', 0, '?'),
 (',كZ~H1l', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/checklist.svg', 0, 'k$}Ng-', 'k$}Ng-', 'ċZ a\'I^gx+?=', '', 0, '?'),
 ('юhMv!v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/checklist2.svg', 0, 'TefI(R', 'TefI(R', 'C}Zi xZ\\4\'u]N:0D', '', 0, '?'),
 ('Pvώ4t', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/checklist3.svg', 0, 'u<b^_L*uUMk', 'u<b^_L*uUMk', '{M>g#dx', '', 0, '?'),
 ('cݗmHYC_p', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chemistry.svg', 0, 'Ȅ*yel', 'Ȅ*yel', 'Uc^9@ˌ;v:O8|D', '', 0, '?'),
 ('6Sv\0D4@A', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chess-knight.svg', 0, 'zsu4-X*Tp', 'zsu4-X*Tp', '\"o0ݟ=Ofע)', '', 0, '?'),
 ('|=3F\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chess-rook.svg', 0, '\\Hȑ', '\\Hȑ', 'WB\\Ѐ99cEEZ', '', 0, '?'),
 ('胃\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chess.svg', 0, '\\SkDpw&s	q', '\\SkDpw&s	q', 'mkr+]h^\n3WT\r\'n', '', 0, '?'),
 ('_cCe16.y>I', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/clock.svg', 0, 'O5Kn[ƙ\0G+R;', 'O5Kn[ƙ\0G+R;', 'Kĕ*p;ë.[\ZkbJJ#`', '', 0, '?'),
 ('3s6Q\rz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/closed-sign.svg', 0, '33]t', '33]t', '8dXP\Z-].e\nGЏL!', '', 0, '?'),
 ('-rYŀv&y_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/cloud-coins.svg', 0, 'lV3ꞦMN', 'lV3ꞦMN', '\r7z:XᏭl{R\\', '', 0, '?'),
 ('^g2Lm\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/cloud-down.svg', 0, 'K]p!s]', 'K]p!s]', 'm\rZ\Zgg	\0jjLy', '', 0, '?'),
 (':]йB4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/cloud-up.svg', 0, '`59*_\\C@', '`59*_\\C@', 'nI:E#RQF?綩m', '', 0, '?'),
 ('SJD\"{ռ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/coffee.svg', 0, '	7X݅؋', '	7X݅؋', 'dr%;]#!~o-mor \Z}', '', 0, '?'),
 ('ȷ}`{ea', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/conference.svg', 0, '.zG\r\ZS3	ES}', '.zG\r\ZS3	ES}', '&#PFL+8(.AH}{5@w:]', '', 0, '?'),
 ('k3ӿ&yg', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/contact-book.svg', 0, '(1ߜtnf<{!', '(1ߜtnf<{!', '$57\"Xҕ\0{Ç9 1Цw', '', 0, '?'),
 ('җQW *ܰw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/coupon.svg', 0, 'W1갑UsS', 'W1갑UsS', 'nڛQ\"`TJ4/ZXP.', '', 0, '?'),
 ('禯vBu6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/credit-card.svg', 0, 'n\0jY', 'n\0jY', 'K\ZDk#i{^&', '', 0, '?'),
 ('+w5=4aacK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/crown.svg', 0, '\r_/n\rt8twuga', '\r_/n\rt8twuga', 'OE`WSK/qfLa<1', '', 0, '?'),
 ('%$ \\29\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/currencies.svg', 0, 'YVK1', 'YVK1', '3UvaNGz.ƚWyGSΘ\rm', '', 0, '?'),
 ('-8uC;Y[\rr', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/database.svg', 0, '1~mk!}b', '1~mk!}b', '!^TTGV6Z>oS&', '', 0, '?'),
 ('>u+-.D', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/delivery.svg', 0, 'ý\n5xl|OtM)', 'ý\n5xl|OtM)', '.\0ãGsI1\r6 #<}', '', 0, '?'),
 ('-Ъ;S?mAF\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/diagram-hierarchy.svg', 0, 'sɫ(', 'sɫ(', '&!Ho[Mb<50)r	', '', 0, '?'),
 ('(Uu7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/diamond.svg', 0, 'U\nǭG9', 'U\nǭG9', '=>wow(w\'qRN >', '', 0, '?'),
 ('c<țI1Fp', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/dollar.svg', 0, 'Raif9ưsZА', 'Raif9ưsZА', '#^0Dx*8\0&', '', 0, '?'),
 (',ZGDy`0\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/drawer.svg', 0, ';y<2&5&x]43', ';y<2&5&x]43', '\nGGOqCFqY5k|nWRUJ', '', 0, '?'),
 ('W(3)OA2Y+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/egg.svg', 0, '{	<]Rc\'K', '{	<]Rc\'K', '?\0BΓP CmxӢ\nsHGJ', '', 0, '?'),
 ('k^ 5\\i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/emblem.svg', 0, 'h%V+\'L5', 'h%V+\'L5', ')\08!PE$lX;zD)3', '', 0, '?'),
 ('~t\\RFbTK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/envelope-money.svg', 0, 'u\'v0Ϳ\n', 'u\'v0Ϳ\n', 'J@#6	zF\rrUm|埬', '', 0, '?'),
 ('#\0EۇlVy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/envelopes.svg', 0, 'ukbvQD', 'ukbvQD', 'o\n7 T8ݍۀPe6,wV', '', 0, '?'),
 ('ͣFhxj2N\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/euro.svg', 0, 'XbU{,', 'XbU{,', '	?-|*J_\nDʻ@*!R', '', 0, '?'),
 ('Eo°(*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/exchange.svg', 0, '}aCK', '}aCK', '7k~0hN(E0k|6f', '', 0, '?'),
 ('Óa963', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/exit.svg', 0, 'd$+ꞂB02o°y', 'd$+ꞂB02o°y', '0cde客Ey2ۍ', '', 0, '?'),
 ('$]bRk(* ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/factory.svg', 0, 'Y6!,^1HP\nP', 'Y6!,^1HP\nP', '~Ԇt\\IQPd(4C\Z\r', '', 0, '?'),
 ('䬉\r \r6(', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/fax.svg', 0, '.\"#p@', '.\"#p@', '\\LY*cb9M9Ӥ3', '', 0, '?'),
 ('boڅ =+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file01.svg', 0, '\0\"\'vu5.e', '\0\"\'vu5.e', 'cʙb!\'yʞi-io)', '', 0, '?'),
 ('wP\"|&9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file02.svg', 0, '0$#4=+X7Y', '0$#4=+X7Y', 'eP%j`\\>+\0aǌ2l', '', 0, '?'),
 ('<	MY#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file03.svg', 0, '_\'3<5[咟', '_\'3<5[咟', '<ޥڲ5WAe!8,', '', 0, '?'),
 ('Cўl', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file04.svg', 0, 'Ï@ot', 'Ï@ot', 'vjX?w޷D)9', '', 0, '?'),
 ('!(\nL̽y	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file05.svg', 0, '};\Z8I', '};\Z8I', 'hBbkjVva2 ay4Zd', '', 0, '?'),
 (')MzH_/w', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file06.svg', 0, '}V.]E|;W', '}V.]E|;W', '!\ni,@mv\rJ^/k', '', 0, '?'),
 ('(d8tt;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file07.svg', 0, '^->/\"', '^->/\"', '@,##ߟw-V(5=', '', 0, '?'),
 ('%2t֭1n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file08.svg', 0, 's`bSCa}f', 's`bSCa}f', 'Fn&8+\njB?ь♮_', '', 0, '?'),
 ('`8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file09.svg', 0, 'V,', 'V,', '=7~MO\"c}{c_2;{L W$', '', 0, '?'),
 ('w/%.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file10.svg', 0, 'LYwt-T', 'LYwt-T', '3RSR(^SiSFoX(uEZc', '', 0, '?'),
 (';9;7:J.6_	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/files.svg', 0, '-2Tdz', '-2Tdz', 'Ply	^~M\n0 8', '', 0, '?'),
 ('9~-7!|E', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/fire.svg', 0, 'L&X2\0Ѵ3', 'L&X2\0Ѵ3', 'FQ	ӵ\rK5&eS_*WFev', '', 0, '?'),
 ('2pr\"i@/h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/fish.svg', 0, 'N\nGIm', 'N\nGIm', 'QR7p}=Cң۹8XCN', '', 0, '?'),
 ('=G.E`U0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/flag.svg', 0, 'G[Dd\\<', 'G[Dd\\<', '(;ov-SK=Zk0У=$\r$g#', '', 0, '?'),
 ('=vB\r*dY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-add.svg', 0, '(AЩF1', '(AЩF1', 'o=d\\;zN lҫD)R0Wg2¦\Z%', '', 0, '?'),
 ('DC0׷e_ӑu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-delete.svg', 0, 'Ns/^\rY}', 'Ns/^\rY}', 'w[h8\0*L	4\'\rAnO.=.', '', 0, '?'),
 ('\"-uTYN', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-online.svg', 0, '\'\'fRd \\^', '\'\'fRd \\^', '_34;j:HsapK)V;T*', '', 0, '?'),
 ('5NI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-private.svg', 0, '8Xpbm9[ 3:', '8Xpbm9[ 3:', ')΢vM%uEƓo٧⯧+R', '', 0, '?'),
 ('Y?\rJ$>\"c', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-remove.svg', 0, ':eڔS^$', ':eڔS^$', 's\n墠\Zp\"n)dH-5.jǮ_', '', 0, '?'),
 ('p}35\\ȤV)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder.svg', 0, '=((TDƍ0', '=((TDƍ0', '`y3汮ʀ.Ctb*R{Eh\\', '', 0, '?'),
 ('*$ͩ<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folders.svg', 0, 'Ɖ	[T+ݏ', 'Ɖ	[T+ݏ', '1̋чP\"8/eYIFRV', '', 0, '?'),
 ('+2Af=}\ZnZg', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/funnel-money.svg', 0, 'Y܌8', 'Y܌8', '<QA#xlk~#޳)S$m', '', 0, '?'),
 ('<@;,(wI%ҋ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/funnel.svg', 0, '`u8sEJη', '`u8sEJη', 'CոSuD!R3EeϪ', '', 0, '?'),
 ('hG8֎', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gauge.svg', 0, 'oT\r.T$p', 'oT\r.T$p', 'kuUi~۳p:#Ϡ*^', '', 0, '?'),
 ('Is-B,A4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gauge2.svg', 0, 'N|ub3', 'N|ub3', '17U辫m.d|\'O<\"', '', 0, '?'),
 ('gM@jW{-ᬑ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gears1.svg', 0, '~oKYP鑟+\0', '~oKYP鑟+\0', 'UЮ 58QT傾o\'$+?*)', '', 0, '?'),
 ('|Gt#6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gears2.svg', 0, '4#rհXKt@װ', '4#rհXKt@װ', 'ġZ%|Epl;stŧ?', '', 0, '?'),
 ('tzf\"7C\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/glasses-moustache.svg', 0, '$2$I&', '$2$I&', '\Z֖\'c=In\rM%ܖGK~a', '', 0, '?'),
 ('eD(Jb}\"1v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/globe-money.svg', 0, '(\r۴0', '(\r۴0', '+=\rOw/qF诐Y!WAMl', '', 0, '?'),
 ('Z(FupIV\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/globe.svg', 0, '>VD<<', '>VD<<', '/ZJ,Ւ3!|Y#', '', 0, '?'),
 ('wJm/?/\')', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/globe2.svg', 0, '4ƁF7V!mq\\҄', '4ƁF7V!mq\\҄', '#^va7N^·iْq $', '', 0, '?'),
 ('_xK,w=@*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/graduation-hat.svg', 0, '\Zn\"im}', '\Zn\"im}', 'B\"w2_4œqƨKZjx[r', '', 0, '?'),
 ('qyBH4\ZÜӄx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-globe.svg', 0, '\\)@Z]r', '\\)@Z]r', 'ZUnR#bɀ}vL9$Il', '', 0, '?'),
 ('3ZSJ๜FK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-key.svg', 0, '4.,GK\\i@\"', '4.,GK\\i@\"', 'M4eq\Z~.Vfΐ_9t', '', 0, '?'),
 ('Id[c][\nhne', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-money.svg', 0, ' ݡ؇\Zl', ' ݡ؇\Zl', 'Y=\"!\'?j#?', '', 0, '?'),
 ('V` .%b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-money2.svg', 0, 'Yy\rpC', 'Yy\rpC', '\r :t6b!fw\\/EΩnS', '', 0, '?'),
 ('.KDgf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/handshake.svg', 0, ' v&\ZHR', ' v&\ZHR', '}`lW\rz(zqLmQ<l(F', '', 0, '?'),
 ('_0_/9X', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hat-moustache.svg', 0, 'ZA>k&ʘV', 'ZA>k&ʘV', '8ý\\^\'(+{y谥\r', '', 0, '?'),
 ('oA\0k', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hat.svg', 0, 'PF5=#DP\\', 'PF5=#DP\\', ' lӳʬL;g?\n ', '', 0, '?'),
 ('ǟ%GxY,Io', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-arrows.svg', 0, '@)mzY膐\\ԛh', '@)mzY膐\\ԛh', '*\'WQ[i%J{t=DPgc%;]', '', 0, '?'),
 ('D*JO>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-battery.svg', 0, 'E\"ǻ#k', 'E\"ǻ#k', 'gUQP\\0wʪ~8', '', 0, '?'),
 ('F/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-check.svg', 0, '?2nP[<', '?2nP[<', 'IAE☪{88:`}uTyD&', '', 0, '?'),
 ('G/_E7!Ї6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-compass.svg', 0, 'WA5sX&z', 'WA5sX&z', '<\nUR\nrWވZXĕ', '', 0, '?'),
 ('#J@W_`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-dollar.svg', 0, 'AiS6k&:o', 'AiS6k&:o', '5D5y\0ƈ0I&rZAY=d', '', 0, '?'),
 ('A*4B,#뺀', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-exclamation.svg', 0, 'ޛnJπ\\0ǂ_|', 'ޛnJπ\\0ǂ_|', 'Ld)o`1`}È|HDB-', '', 0, '?'),
 ('^&qT=0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-flash.svg', 0, 'uE-OҶ\Zkk', 'uE-OҶ\Zkk', 'Uxm9g H_yop9K_kN', '', 0, '?'),
 ('ZdX !\"Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-gauge.svg', 0, 'eMGL', 'eMGL', '\nFIpN{d74E?ⲥK>q', '', 0, '?'),
 ('o6o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-gears.svg', 0, '?S`(ԢX', '?S`(ԢX', 'cI|(1T,E}g/֫', '', 0, '?'),
 ('.ϕUkRy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-hourglass.svg', 0, '>eG0Ѻ\r', '>eG0Ѻ\r', '1.vHB0&pe1J\\G\"', '', 0, '?'),
 ('544%_>o,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-idea.svg', 0, 'RB\r*mw8', 'RB\r*mw8', '\'s)5Lh/35*xtb', '', 0, '?'),
 ('ǚ&҄1w\\Wn', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-question.svg', 0, 'vS\Zz\Z', 'vS\Zz\Z', 'Վ2X	w[fzٍ}', '', 0, '?'),
 ('ڝz d۪Ft', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-structure.svg', 0, 'nbiUI', 'nbiUI', '6z;.O |oؠ/Qґ;Gh', '', 0, '?'),
 ('@ۚ:eg1yEe', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head.svg', 0, '+O]', '+O]', 'FZ+Ҁty/0op:aq^I', '', 0, '?'),
 ('\0S7&o^\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/headquarters.svg', 0, '!*5z<>?2', '!*5z<>?2', ').fٖtS̐c&?\n{S琮', '', 0, '?'),
 ('pT\r\ZwT', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hourglass.svg', 0, 'Iqq?2S+c', 'Iqq?2S+c', '@i?WhslM\'ѩ[:2', '', 0, '?'),
 ('!;)3JSz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hours.svg', 0, 'U?gPAL1.', 'U?gPAL1.', 'rۊX_Yȕr9n7V\\\rL', '', 0, '?'),
 ('M7{w*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/incoming.svg', 0, 'B1;hEG jȴ', 'B1;hEG jȴ', '4\\6m0,@d+F\"^vͶsH̯_', '', 0, '?'),
 ('<,dla$\r*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/ingots.svg', 0, '2*z>2', '2*z>2', 'T)}?f3[Ѹ$wZ', '', 0, '?'),
 ('5#L1}', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/key.svg', 0, '*h>P:	', '*h>P:	', '¼#35?hщ%', '', 0, '?'),
 ('*҅C(', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/key2.svg', 0, 'o\'I`O6%', 'o\'I`O6%', '6tÀRdc+αҠ^=', '', 0, '?'),
 ('qJթ9F', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/keyboard.svg', 0, '+S䃺Mo<2>', '+S䃺Mo<2>', 'kP$ώ=w	4{C\'\ZLxVi*', '', 0, '?'),
 ('_:\"v{n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/label.svg', 0, '5WnGT>', '5WnGT>', '_LF\ZQxws21c잓+R', '', 0, '?'),
 ('@H{gp[v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lamp.svg', 0, '?;# pá', '?;# pá', '0\'Qi|c/j0(\\ߧ', '', 0, '?'),
 ('zD,_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-article.svg', 0, 'iԇ|!HG<', 'iԇ|!HG<', 'XcaL+Dg:6Քt\'8_T', '', 0, '?'),
 ('E˜	V', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-cart.svg', 0, 'K-k˞<\0', 'K-k˞<\0', '}\0w/TAxz+~LYo.Zy', '', 0, '?'),
 ('M ^̈!J', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart.svg', 0, 'p%hKJL|', 'p%hKJL|', 'P\Z$Q\'¨4v}Y\rKj(', '', 0, '?'),
 ('pK>}bR;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart2.svg', 0, '{EMPqr)̼6', '{EMPqr)̼6', 'f?`df6\\t;R`E3d\Zx#', '', 0, '?'),
 ('*u+H:3\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-diagram.svg', 0, '[ѥͤ', '[ѥͤ', '2\r\'}%a	BW̝x\\', '', 0, '?'),
 ('Z|ߣԐ~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-envelope.svg', 0, '@z]Do6,8', '@z]Do6,8', '{T*니\rn$bwkw#Ū)&', '', 0, '?'),
 ('V?~t', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-finance.svg', 0, '}u),mv', '}u),mv', 'ԦZ-8[81<-m;ʆ', '', 0, '?'),
 ('ks@\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-privacy.svg', 0, 'އs쵭As,e', 'އs쵭As,e', 'hvͼB #+-PG6gk', '', 0, '?'),
 ('Q\n(׀\Z{\ru', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-settings.svg', 0, '3ߪr@#CW', '3ߪr@#CW', '@Z)i\rXPiY-', '', 0, '?'),
 ('jv灳E>y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-user.svg', 0, '2MX,\"J96', '2MX,\"J96', '\rj7I8fr6R̠;VD\Z1M', '', 0, '?'),
 ('(ՐeOތ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop.svg', 0, 'Po]|\r', 'Po]|\r', 'Ӣ9\\MϏҜD39MQ8%', '', 0, '?'),
 ('x;ɷ065zj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb-green.svg', 0, '.nQ{z\\VT', '.nQ{z\\VT', 'ui\"c~V\n!|[', '', 0, '?'),
 (' أ	u(Bj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb.svg', 0, '-YrFNO֮', '-YrFNO֮', 'c*\nߡXLpKHo=I', '', 0, '?'),
 ('yiUZ#)rpz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lightning.svg', 0, 'HU\r(:\rM', 'HU\r(:\rM', 'Aй6\Z]!:p.W\"ad>', '', 0, '?'),
 (')r4t<u', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/like.svg', 0, 'k6a5TS|6', 'k6a5TS|6', 'm7%YVXX1${|	B\0h', '', 0, '?'),
 (' o&7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lock.svg', 0, 'RjX=?Fh', 'RjX=?Fh', ',L	Yi1{0E<@gOd', '', 0, '?'),
 ('\'|gL,!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/magnet-money.svg', 0, 'ތm%M', 'ތm%M', '$YIsҕ,1/\"*=6!C', '', 0, '?'),
 ('Cނatp', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/magnifying-glass.svg', 0, 'q#z', 'q#z', 'E޲!d<pRQX>	d\n!p)', '', 0, '?'),
 ('!q~\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager-globe.svg', 0, '~j9Pu\0', '~j9Pu\0', 'N\rG`nAI{|]i{ӹ\Z', '', 0, '?'),
 ('(-3q&DH', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager-idea.svg', 0, 'ч#U¹l?', 'ч#U¹l?', '\\\"SjZjh6[f)e', '', 0, '?'),
 ('FL5CZIw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager01.svg', 0, 'IdҾ*m', 'IdҾ*m', 'Hvt#)ƜPE', '', 0, '?'),
 ('ћNqdvE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager02.svg', 0, 'YxlJ\r\\', 'YxlJ\r\\', ']R2t.5tٺMNj\"SUq~\"', '', 0, '?'),
 ('7avP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/meditation.svg', 0, 'Uk@e\"', 'Uk@e\"', 'BΗe3Ljpxzq\'&', '', 0, '?'),
 ('$\Z_&\ZcÚ7>d!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/megaphone.svg', 0, '2)D??MRh', '2)D??MRh', '[:i4`]#m\\0.900-oP5\0H', '', 0, '?'),
 ('afM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money-growth.svg', 0, '|BF', '|BF', '|)v.ܤOHGO\\zl!Z´6', '', 0, '?'),
 ('(\"A-PGK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money-scales.svg', 0, 'W\'쾏', 'W\'쾏', '\rPG_9.ksD\0`C3	!<', '', 0, '?'),
 ('_2*$]\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money.svg', 0, '5վR8\\5', '5վR8\\5', '5.W&e!P;):Y!C', '', 0, '?'),
 ('e$w VB$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money2.svg', 0, 'J㱸9Nb', 'J㱸9Nb', '۸/șHcE', '', 0, '?'),
 ('yqkv+R)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money3.svg', 0, 'GJc_(@	', 'GJc_(@	', '[7#Sv)LG#y\0jZ|x?[', '', 0, '?'),
 ('	GW5+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money4.svg', 0, 'JUy	r(랏', 'JUy	r(랏', 'V(07?&VͰֆ~/\n\r觮V|`e', '', 0, '?'),
 ('ݑ#h$S#\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money5.svg', 0, '\0;1{^72', '\0;1{^72', 'XC&=K2;;`A=\"n', '', 0, '?'),
 ('B#&Uú6RM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money6.svg', 0, '̻Ԇp>$\r)', '̻Ԇp>$\r)', '9Bp)Cߍ!2<\rLLT', '', 0, '?'),
 ('JsFV&V%	Տ3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/monitor.svg', 0, 'P$S$;.c', 'P$S$;.c', '\rۂӋt4B\\?8M&[<ֆA꣑', '', 0, '?'),
 ('=+k_LJ8\\~x.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/mouse.svg', 0, 'ru\\10`?', 'ru\\10`?', 'zi_qȇ`te5Yp\n2,۱c', '', 0, '?'),
 ('lp˜j&Yvr', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/nest-money.svg', 0, 'ұM|\'C\'V', 'ұM|\'C\'V', '-}]\Z%޸\r*$ԹOU\rEY', '', 0, '?'),
 ('V\nΌ9򗽼>d', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-jobs.svg', 0, '|ʅ\0LN', '|ʅ\0LN', 'ӗdV	!/j1W)H5#\0r	', '', 0, '?'),
 ('р=Mo-B~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-pen.svg', 0, '҆3rPn', '҆3rPn', 'ɥJ!hH7%Z\"HS;$0aӟai9', '', 0, '?'),
 ('⮌?0\r:)+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/newspaper.svg', 0, 'h.ڼ۟k0', 'h.ڼ۟k0', 'cWvpl=,WT=h+', '', 0, '?'),
 ('\\aΝĬ@ٕ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/note-paper.svg', 0, 'S6%7G%B', 'S6%7G%B', '1Ux|!⟏n9IxdT:', '', 0, '?'),
 ('e\"%)t', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/office-chair.svg', 0, 'y\rƽ1<m5~', 'y\rƽ1<m5~', '^n3\"ڼ82- E@a7_m[', '', 0, '?'),
 ('?x$~)ÉYZY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/open-sign.svg', 0, 'ˡ\\L;\\\\g', 'ˡ\\L;\\\\g', '\ZShKa>V,=}8USWc<U', '', 0, '?'),
 ('eMYOhs@د', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/outgoing.svg', 0, '>_b73', '>_b73', 'tȎ*`JJ֕kG s#g', '', 0, '?'),
 ('H-Yy\0\0RY	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/paper-clip.svg', 0, '\ZMZH(Jj', '\ZMZH(Jj', 'JS^廊j5w;#--', '', 0, '?'),
 (':VK Ue.v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/paper-plane.svg', 0, '\ZMZH(Jj', '\ZMZH(Jj', 'JS^廊j5w;#--', '', 0, '?'),
 ('6jQk5O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pen.svg', 0, 'ut Of[-', 'ut Of[-', 'ÊK4c#2?|VR\nO->ע{', '', 0, '?'),
 ('a`e94͟@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pen2.svg', 0, '`g0|&Jg', '`g0|&Jg', 't&فXH%hu\"wАVH@	', '', 0, '?'),
 ('PZ<*Hu5 ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pencil.svg', 0, '&|❝,f:qCYL;', '&|❝,f:qCYL;', 'Dؒy[vQq~λrRS', '', 0, '?'),
 ('ϵ2,ؽɭ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pens-pencils.svg', 0, '6GΪT', '6GΪT', '\\g?+%0D3p\rU H7ǋ͗k', '', 0, '?'),
 ('*/}|grON', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-arrows06.svg', 0, 'vOH%,3}䤎LZ', 'vOH%,3}䤎LZ', '\r1vO_<х(%{ub', '', 0, '?'),
 ('O%c8!2S', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-gears.svg', 0, 'Ě!H?O', 'Ě!H?O', 'E]дerV6*(;', '', 0, '?'),
 ('=c\'f̂', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-handshake.svg', 0, 'UP>ZvB$', 'UP>ZvB$', 'm-4тdɜ3p.6xDLT[', '', 0, '?'),
 ('.0].', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-idea.svg', 0, 'Ɏ#-X2', 'Ɏ#-X2', '>%ݧ\"\"nXjQ:8', '', 0, '?'),
 ('[a-+#;ɓ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting.svg', 0, '4V6tX#.8`X', '4V6tX#.8`X', '1$b\r7$^Fx} ;!361', '', 0, '?'),
 ('`wZU9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting02.svg', 0, 'n	;qa', 'n	;qa', 'XCJ|`]0yW0J5hxR,~', '', 0, '?'),
 ('vIOC6F', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-search01.svg', 0, '_\04OV\"!', '_\04OV\"!', 'E-}a!U>Vz߸tqP1Z\"%', '', 0, '?'),
 ('pխANr@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-search02.svg', 0, 'wH|}\r\nM_\"Io', 'wH|}\r\nM_\"Io', 'nbs)+\\۳r|c&7@', '', 0, '?'),
 ('8|_:', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure.svg', 0, 'XjfE*#[', 'XjfE*#[', '$KU\n}w`\"Rp#%>6$B*=ǎ', '', 0, '?'),
 ('P	[_0owpl', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure01.svg', 0, '|adD!I', '|adD!I', 'dʭ7#Q\"%Mz3\\\0wx', '', 0, '?'),
 ('DW: ;#d>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure02.svg', 0, 'x`CsWj', 'x`CsWj', '\ZRӧ>c.V\0hWU_\n	v[', '', 0, '?'),
 ('u:f<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure03.svg', 0, 'C4I1ɡFT\'SF', 'C4I1ɡFT\'SF', '9)<;ǵ$c@Klceug%X\Z@G\Z', '', 0, '?'),
 ('oQwp', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure04.svg', 0, 'x>8sf&}', 'x>8sf&}', '~J|5iK=`H불G<Zf', '', 0, '?'),
 ('CKd=oq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure05.svg', 0, '`P\0m%v', '`P\0m%v', 'Gͫ~H\'\n-y`ebaLQ', '', 0, '?'),
 ('GtLhl!uz_(f', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure06.svg', 0, '\rr1Ii\n+o', '\rr1Ii\n+o', '\nbB:&# \0e(nq', '', 0, '?'),
 ('W\\Ji2t~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure07.svg', 0, '^4Ț ', '^4Ț ', '|: XP\\SqZ=+', '', 0, '?'),
 ('oܧ֠*nނx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/percent.svg', 0, 'n`l5Z\r', 'n`l5Z\r', 'Dbj~V>yrE6u1j&t', '', 0, '?'),
 (' Kfq:o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/periscopemoney.svg', 0, 'H.l􂁄*d', 'H.l􂁄*d', '4\r-_\";OAx_P', '', 0, '?'),
 (';>^+\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows01.svg', 0, 'I )Zf\\n', 'I )Zf\\n', 'V{Tr*+o^)J{rWY\'', '', 0, '?'),
 ('P @?\ry	9/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows012.svg', 0, 'ش:\n\"zJ', 'ش:\n\"zJ', '\n,3DM.jk0>7', '', 0, '?'),
 ('$q o\Z\r<<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows02.svg', 0, '	{>O#v^@', '	{>O#v^@', 'GE645۲Q_2VlET', '', 0, '?'),
 ('Bǽfg^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows022.svg', 0, 'a\0 ǧCƔ^^', 'a\0 ǧCƔ^^', ',4te_<M6?~rF;6M}', '', 0, '?'),
 ('4^{_؟DA2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows03.svg', 0, 'DngBBtT{', 'DngBBtT{', 'w!w0(HҨLvBb\Z=c', '', 0, '?'),
 (' `I^G', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-checkmark.svg', 0, '#b\\1CW', '#b\\1CW', 'Qjl riv\0M+~3', '', 0, '?'),
 ('hiʖ]Ïc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-cross.svg', 0, ',<M$mR4hĆ', ',<M$mR4hĆ', 'ٲ_(\rhW~{f', '', 0, '?'),
 ('HYlH', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-data.svg', 0, 'LہH7\"`0', 'LہH7\"`0', 'ua~s?\0Qm{Hks_/Cš@_j', '', 0, '?'),
 ('IN&lEw!C', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-dollar.svg', 0, 'حujӟ֕P', 'حujӟ֕P', 'tY~93ղ邦	F1Bb', '', 0, '?'),
 ('\0opLy95g', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-finance.svg', 0, '}+WXQ\0T', '}+WXQ\0T', '\"Z8b:c~ئJ0cɶo_R', '', 0, '?'),
 ('LBks΀i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-flag.svg', 0, '[*LVL+<g7w', '[*LVL+<g7w', 'xBto]΋ߛ!2n5xQ7k@ڲ2', '', 0, '?'),
 ('RGW(a0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-globe.svg', 0, 'has::~V', 'has::~V', '7#\n*ٚ1 --lԨJT\'K%[', '', 0, '?'),
 ('skqUs3y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-idea02.svg', 0, '7RA*k', '7RA*k', 'sy]\rjx1u@<\rTF', '', 0, '?'),
 ('1,b\"QV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-info.svg', 0, 'B۾Ӹ\ryȀ`%', 'B۾Ӹ\ryȀ`%', '/zLNGaԷ	C+Hq]', '', 0, '?'),
 ('_{:(uޟ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-puzzle.svg', 0, '%cȥAV,yl[', '%cȥAV,yl[', 'ztdZפ\"ñs>mqE,', '', 0, '?'),
 ('ANO彚G!\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-scales.svg', 0, '-~;\0@&~', '-~;\0@&~', 'Zu;tj\ru..A.L', '', 0, '?'),
 ('M]xo0j)q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-time.svg', 0, '9{-', '9{-', '!1ָ~>g \\1\Zy+ѹ', '', 0, '?'),
 ('xMGt\"!H', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-umbrella.svg', 0, 'E,yav', 'E,yav', '7㿾ΕuIOdh!Kdt@', '', 0, '?'),
 ('Z1-<P$m,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/phone.svg', 0, 'I%+S8?', 'I%+S8?', '\0mpFut+xQHb6', '', 0, '?'),
 ('1|4<kF{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart01.svg', 0, 'L|R\'pg', 'L|R\'pg', 'v\n]igVH\ZY^.pvO', '', 0, '?'),
 ('(H6	cz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart02.svg', 0, 'oq', 'oq', '-WKAK|\r	vB@C+ ', '', 0, '?'),
 ('Xfb$wQ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/piggy-bank.svg', 0, 'B賴OC\r7u', 'B賴OC\r7u', 'trA<H.8	w,+5}Ν', '', 0, '?'),
 (';vB#͕', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pin.svg', 0, 'ZQCJ:8', 'ZQCJ:8', '-I)6?uY=[oSDz', '', 0, '?'),
 ('	<z-', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/plant-money.svg', 0, 'C4x;|', 'C4x;|', '2\'ɣZDKUvWX.1}', '', 0, '?'),
 ('R0ǻsl4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/plant.svg', 0, 'Kk%82|9҅', 'Kk%82|9҅', 'V/h|l\r&O9\0r-Red', '', 0, '?'),
 ('G/1*\rb', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pound.svg', 0, 'rft~XjH', 'rft~XjH', '`c/@6.t!Z_\rtvZ', '', 0, '?'),
 ('\rjf\n\\U', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/presentation.svg', 0, 'l\r,_ȇ', 'l\r,_ȇ', 'Ϲ*}d0G\Zno#`FA9_e\"', '', 0, '?'),
 ('ɧre@e', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/presentation02.svg', 0, ',kTngUdjW', ',kTngUdjW', 'VCHfR&7&~pwH>Y', '', 0, '?'),
 ('Jy&HT]x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart02.svg', 0, 'N:y)', 'N:y)', 'x!4/e.ͱvFj,DoW', '', 0, '?'),
 ('k\0ed:e', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart03.svg', 0, '#WB5Tђ^', '#WB5Tђ^', ' dҤ\',ewA	ڑ>+=', '', 0, '?'),
 ('tٻ1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart04.svg', 0, ' N\rS1*^MO', ' N\rS1*^MO', ';еT\Z\0b3xUʏ@MO', '', 0, '?'),
 ('wﬤj-', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-laurels.svg', 0, '҃0<$', '҃0<$', '~ݱjz	mD`2=_g-Op', '', 0, '?'),
 ('_ђ\ZtdH҅', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-megaphone.svg', 0, '##ȋĪ`_', '##ȋĪ`_', 'b1\"v}t3#;twg', '', 0, '?'),
 ('J9ӷS;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-stairs.svg', 0, '#qÐWl!1', '#qÐWl!1', 'c(;/Rs+͵ڧFWjY', '', 0, '?'),
 ('\'Y\Z^t`?ў', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/printer.svg', 0, 'ziʁ\Z՚', 'ziʁ\Z՚', 'kRV,!n89ń?', '', 0, '?'),
 ('7RNV炗M1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/profile.svg', 0, '-3>VxuH@b\\', '-3>VxuH@b\\', '>AHs!PgG\0>s', '', 0, '?'),
 ('@ݳ%ő/ͭ_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pulse.svg', 0, ' LTaOGQ', ' LTaOGQ', 'Zze;Wci\\Q*N~i', '', 0, '?'),
 ('2a!H3=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/puzzle.svg', 0, 'RdZ#cRmq_1', 'RdZ#cRmq_1', 'u4nQ@FmRh4ߘ9y', '', 0, '?'),
 ('ha*.1fk?\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/quill.svg', 0, '5Ň&>%iL', '5Ň&>%iL', 'x2<agɇ\0h=JCn/96Oi', '', 0, '?'),
 ('vn/vۡ\"P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/recycle.svg', 0, '1[VUS+ӆ-', '1[VUS+ӆ-', 'c `XXG;{Y}ƫVbJwX', '', 0, '?'),
 ('9f-g<jJ>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/rocket.svg', 0, '}b[,۰北0', '}b[,۰北0', 'yM	ǩȁu%Q(>~fc', '', 0, '?'),
 ('wipdWg', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/rocket2.svg', 0, '|;.lw8}', '|;.lw8}', 'cK?Xb?tF4O+]uf3a\'%&/', '', 0, '?'),
 ('IArYW`+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/ruble.svg', 0, 'BN#Rw	1@', 'BN#Rw	1@', 'ǪkCIҒ3#rA?Xg`', '', 0, '?'),
 ('HYwYӬC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/ruler-compasses.svg', 0, ':\0fA&sP0', ':\0fA&sP0', ';@U8^ŀf/?G`1YKy', '', 0, '?'),
 ('j4h~T#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/safe.svg', 0, '%gލz݁Mq̻H', '%gލz݁Mq̻H', 'q}_B	QݰP35gФ', '', 0, '?'),
 ('=Xuym', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/sale-sign.svg', 0, '49h	[+', '49h	[+', '&x>}[ͣqJ', '', 0, '?'),
 ('+;p3H|8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/satellite-dish.svg', 0, 'mOgF.-Z~', 'mOgF.-Z~', 'VצThiKf+\\}6E^yݞ2\Z', '', 0, '?'),
 ('B-%\\\"l@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/scales.svg', 0, 'u妪d_Ei-j>', 'u妪d_Ei-j>', 'p\Z+CDZĕ,Rz\'', '', 0, '?'),
 ('I!bgn_ ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/scissors.svg', 0, 'QݫmJtQ{z~ܴ', 'QݫmJtQ{z~ܴ', 'Ť1d}Ågsvϣz,', '', 0, '?'),
 ('=M\0&8XXf#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/security.svg', 0, '÷MER~}', '÷MER~}', '3BX@S;2c\0#', '', 0, '?'),
 ('Xm@P8B{S', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/send.svg', 0, 'iOK!k', 'iOK!k', '2;WxG=TW<Wj', '', 0, '?'),
 ('a~ ZX%hK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/shield.svg', 0, 'Ca|lH', 'Ca|lH', '<~ED^qFT\\&є', '', 0, '?'),
 ('v2+Y6	8*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/shopping-cart.svg', 0, '\"5K$zoZPyF', '\"5K$zoZPyF', 'Toy\\*|L!DTMn', '', 0, '?'),
 ('7g8}zn', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/sign.svg', 0, 'UEB5', 'UEB5', 'GKNZ`m#>', '', 0, '?'),
 ('H\"5s\rue', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-chart.svg', 0, 'Wr#/>7\Z', 'Wr#/>7\Z', 'wEM0pLKH׳_\"', '', 0, '?'),
 ('I&2\nM\rm', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-exclamation.svg', 0, '`o\rSC)0K', '`o\rSC)0K', 'r2eħ5(9C>[6.W{o', '', 0, '?'),
 ('j,(:!\" ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-gears.svg', 0, '㆏oUд<C', '㆏oUд<C', 'z4>nH\r!5笺q.X', '', 0, '?'),
 ('#=5x`g', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-growth.svg', 0, 'ę\Z9TO', 'ę\Z9TO', 'Gs*\"{UȂan*Cc', '', 0, '?'),
 ('\\זfl{b#m', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-money.svg', 0, '[Vt3\rn~C', '[Vt3\rn~C', 'ݜpw ^=|Uxૼy.N', '', 0, '?'),
 ('7MsU', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-user.svg', 0, '߻iҩ\Z', '߻iҩ\Z', '[kdb	SFb;	\"9ΞSy&Q,', '', 0, '?'),
 ('bK1]\r(^E@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone.svg', 0, '%X7EZ%>', '%X7EZ%>', 'Ծ^`Uipm\ZGyfgQ|H?\"', '', 0, '?'),
 ('StPzPXoȺ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/speaker.svg', 0, '[wP+hn׃R', '[wP+hn׃R', 'FʸִLP5UV񶳖rjOS}`V', '', 0, '?'),
 ('h:=c0u8x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/speaker02.svg', 0, '/U\ZgW}3٩\Z', '/U\ZgW}3٩\Z', 'AZT`q,0c*b1{hs?', '', 0, '?'),
 ('up*9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/speech-bubble.svg', 0, '${1P}U', '${1P}U', 'ecT&m>\\Dԡk$', '', 0, '?'),
 ('g-Θ\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/stamp.svg', 0, '\'in\n4hT', '\'in\n4hT', '@mqKC^ҫk4KZﶦ߸6X', '', 0, '?'),
 ('`h?Ep/M', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/star.svg', 0, '` 9\\)jk', '` 9\\)jk', 'd	\nf?\\B!Dt9ƺ6', '', 0, '?'),
 ('<;OwC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/steering-wheel.svg', 0, '%7\0/A', '%7\0/A', 'W-O<$~W', '', 0, '?'),
 ('SiF Zy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/strategy03.svg', 0, 'W?C޼ln', 'W?C޼ln', ')t9LY\n,A\rE؄@r\"YO3', '', 0, '?'),
 ('O(eKaW^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/strategy1.svg', 0, 'B\Zhyj(|ԕ', 'B\Zhyj(|ԕ', 'G2#oh.SE%\"VRϵ\\Uƫ4', '', 0, '?'),
 ('a-\nCuٔ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/strategy2.svg', 0, 'PD>b;<0YGPEK', 'PD>b;<0YGPEK', '\nP>,{Φ ;%\n', '', 0, '?'),
 ('UQB\ZN4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/support-person.svg', 0, '}31g\\	', '}31g\\	', 'V7~($y]p졧_n5', '', 0, '?'),
 ('i|׽ASHL<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-article.svg', 0, 'rk\\aK', 'rk\\aK', '	=#ľFBbf0SzcguU', '', 0, '?'),
 ('YwOPiOI=FP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart.svg', 0, 'd>B\Z&ܦ', 'd>B\Z&ܦ', 'A\'L+\Z\0W@ j', '', 0, '?'),
 ('lʗDXf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart2.svg', 0, 'x)r*\rI0.0g', 'x)r*\rI0.0g', 'c>+\\L͑60\nN䅷f(|\'z', '', 0, '?'),
 ('gd}E]+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart3.svg', 0, 'lCy/yyQ', 'lCy/yyQ', 'RDՌgd8VO$_k', '', 0, '?'),
 ('=Ơ/\\З', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart.svg', 0, 'СͶU&\r-', 'СͶU&\r-', 'Kbe^:x	ngDڽ$', '', 0, '?'),
 ('On:HSu !', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart2.svg', 0, 'f\r?g{3', 'f\r?g{3', '_aiB͛PTNzmIi#(nA\n', '', 0, '?'),
 ('M^հ;W|8z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet.svg', 0, 'G7ro9>', 'G7ro9>', 'H0\'܁l9L-RګFNPk!', '', 0, '?'),
 ('E|h tA', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/target.svg', 0, 'Q*@2/U', 'Q*@2/U', '܌cُ<.K%=@>@7I1 Ad', '', 0, '?'),
 ('\'\nD?q^\Z/vc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/team.svg', 0, 'RԼ8;B0;Y', 'RԼ8;B0;Y', 'Xx`WsVi*xzRnQB<L', '', 0, '?'),
 ('jT,X', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/telescope.svg', 0, '\'+j,Uˡw', '\'+j,Uˡw', 'YSiM%C煳4Z`,', '', 0, '?'),
 ('hC%\"G~h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tie.svg', 0, '^fɢMkq>+', '^fɢMkq>+', 'wd-HOވO`ѕ)\\h', '', 0, '?'),
 ('qO*j(bQL', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tools.svg', 0, '~_zԸ', '~_zԸ', '%ss-\Z;ՂX,&/_!', '', 0, '?'),
 ('s!3{$r807', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tools2.svg', 0, 'юSP', 'юSP', ')țY<d.7]\n\\Mx', '', 0, '?'),
 ('S.HTt>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/trash-bin.svg', 0, '7#JzeVfT', '7#JzeVfT', 'kixo2ף+m͢', '', 0, '?'),
 ('?P5_6fMZ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/umbrella.svg', 0, '$|9ۏ1Mk', '$|9ۏ1Mk', 'p	`yt\r)d7V\ncGg&', '', 0, '?'),
 ('r1nvk', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user01.svg', 0, 'f6a*@%Oy', 'f6a*@%Oy', '48\\9Dx}SxA\ZSx', '', 0, '?'),
 ('?&J(ĚZP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user02.svg', 0, 'v^ap2\\', 'v^ap2\\', 'A^y)Xx/?pocJ', '', 0, '?'),
 ('گ$_ʋtFI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user03.svg', 0, 'OfW>%0', 'OfW>%0', 'x{M|R+@-I5a\0y', '', 0, '?'),
 ('*ho@}i恔3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user04.svg', 0, '%n0mtF', '%n0mtF', '؊,O!Zf+Q6WJ)FXPv', '', 0, '?'),
 ('obB؇]|:<_8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user05.svg', 0, '2+(Ýۄl', '2+(Ýۄl', 'Lo\\6/ALN5$=1', '', 0, '?'),
 ('<7OoJ{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user06.svg', 0, '{_lt6', '{_lt6', 'SVp_^i\"PS˹.4h)s', '', 0, '?'),
 ('\Zt-oDY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user07.svg', 0, '\0e{V^', '\0e{V^', 'Kzgo\\#Y6egINا', '', 0, '?'),
 ('Mh˻é_{`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user08.svg', 0, '@`W1x;Ùxs', '@`W1x;Ùxs', '_[f|>m>S\n\0JЍ', '', 0, '?'),
 ('N^ʜ\naߺ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user09.svg', 0, '(m_򾍝940', '(m_򾍝940', '\\QV/EiVh}?X)xǹF9i', '', 0, '?'),
 ('rTߓU:`arM	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/users.svg', 0, '{Lt,a\\ܴ', '{Lt,a\\ܴ', '8`?`N]軲ZjԦ', '', 0, '?'),
 ('LP\reZ\rq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/venn-diagram.svg', 0, 'sX?|z\'%U', 'sX?|z\'%U', '\\ZJ\"1V\0&~N\\', '', 0, '?'),
 ('{ӱmb0#&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/wallet.svg', 0, '3ڑiT.ҫv', '3ڑiT.ҫv', ']h8HA!=C*L', '', 0, '?'),
 ('W5)b\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/wrench.svg', 0, 'hs4>>cx;', 'hs4>>cx;', 'Qoo{tbZk+\0', '', 0, '?'),
 ('\n#&gF', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/yen.svg', 0, 'fr^TD&_', 'fr^TD&_', 'M3h|J]}@f= 7=', '', 0, '?'),
 ('*H?I4j.YI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/yinyang.svg', 0, '[D)˯]4W\\', '[D)˯]4W\\', 'Ʊ!QY}fS[i^&lo\'', '', 0, '?'),
 ('\ZNKiOyPǗ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_business_24px.svg', 0, '!lIWH<Y', '!lIWH<Y', 'n@q=ТA]VJRՖҷM%yA', '', 0, '?'),
 ('ʭ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_24px.svg', 0, '8WFKE?mTDv', '8WFKE?mTDv', 'T1x.~cEbԏGAv', '', 0, '?'),
 ('u-/z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_end_24px.svg', 0, 'ɯ~	Zv<a', 'ɯ~	Zv<a', 'Er<^_/EF6:ZdCҢ\rĦrFIw', '', 0, '?'),
 ('G\"QNq\\fẤ-v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_made_24px.svg', 0, '*KY f%U@', '*KY f%U@', '\Z&֌,C\rc	<Y߃xZ	', '', 0, '?'),
 ('JNqi\"o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_merge_24px.svg', 0, '޲:4)!*t', '޲:4)!*t', 'kƕ[/kB|>\\`rt=VE=', '', 0, '?'),
 ('ؗxBsJ^əՂf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_missed_24px.svg', 0, 'ƴ6ܛLA@J', 'ƴ6ܛLA@J', '\Z{ڕX gm|ձ\';\0', '', 0, '?'),
 ('\'N-u.g', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_missed_outgoing_24px.svg', 0, '\r<xR⠄R|&h', '\r<xR⠄R|&h', 'HbI s=VApxx.J', '', 0, '?'),
 ('ڀ	]v㉝', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_received_24px.svg', 0, '!(d 8!]_P', '!(d 8!]_P', 'm:ө:p当ēLIex19]', '', 0, '?'),
 ('jI\"܀5', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_split_24px.svg', 0, 'a4XlL\\', 'a4XlL\\', '\rF5gm!s{Uq?+', '', 0, '?'),
 ('KŨH_c`=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_chat_24px.svg', 0, '\'D]qaNJ', '\'D]qaNJ', 'POqE~\'S*y:M', '', 0, '?'),
 (',U5j><徏', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_chat_bubble_24px.svg', 0, 'ju\'T:', 'ju\'T:', 'y(+ܳ20A\\(4\'yt1', '', 0, '?'),
 (';^wa~Ţ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_chat_bubble_outline_24px.svg', 0, 'ⓒÀު', 'ⓒÀު', 'Pa	gO ;Fsv\069ޟg$m2 ', '', 0, '?'),
 ('boir*CS', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_clear_all_24px.svg', 0, 'n4H2u{[', 'n4H2u{[', '	07S_L0<W', '', 0, '?'),
 ('BySo2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_comment_24px.svg', 0, 'VaQ^$IGʭ', 'VaQ^$IGʭ', 'g;\ZSސuD/=zO|G', '', 0, '?'),
 ('\03%I>n ٟ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_contact_mail_24px.svg', 0, 's[qC㒓', 's[qC㒓', 'i񘉁c*Oj+H\'aHpdDՊ', '', 0, '?'),
 ('vHlԍӔR%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_contact_phone_24px.svg', 0, ' ŽR\ZR', ' ŽR\ZR', '9Qp`d]hHJ˘', '', 0, '?'),
 ('ty_|	d', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_contacts_24px.svg', 0, ']%cX]\':!I', ']%cX]\':!I', 'B3ӗU&GJ|%yKZ̲Ote', '', 0, '?'),
 ('qþ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_dialer_sip_24px.svg', 0, '%t߸ѓQ,', '%t߸ѓQ,', '|+&]Ͷp\'F޶tMr(>te', '', 0, '?'),
 ('(wU9Uk', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_dialpad_24px.svg', 0, '	H]', '	H]', 'g\ZHM9)dXK}x', '', 0, '?'),
 ('lc0Zb', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_email_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('.Q,wSX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_forum_24px.svg', 0, '#5\\#N', '#5\\#N', 'HFS:9zӣ^]\n', '', 0, '?'),
 ('ݪ%DCI\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_import_contacts_24px.svg', 0, 'Y-Ah3\r', 'Y-Ah3\r', 'וa]֮<\0>?~_L', '', 0, '?'),
 ('$\\e88L', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_import_export_24px.svg', 0, '|Ӣ\rezd|5', '|Ӣ\rezd|5', '5EaIj\n^_V$%cu-X˥', '', 0, '?'),
 ('/fd', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_invert_colors_off_24px.svg', 0, '*}V_', '*}V_', 'mDK+f=&}w', '', 0, '?'),
 ('G+>)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_live_help_24px.svg', 0, 'c/j e*cY', 'c/j e*cY', 'ӊp+b<.	˴//H', '', 0, '?'),
 ('qđҘw&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_location_off_24px.svg', 0, 'iۡGBF.%\n%', 'iۡGBF.%\n%', 'm}5<<x(,\n\'7@<ACpggOX', '', 0, '?'),
 ('qvh6T)|I', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_location_on_24px.svg', 0, 'I}Ԛ^޵Q\Zw', 'I}Ԛ^޵Q\Zw', '\\]:0cA7kT`	(\0', '', 0, '?'),
 ('ea9&~,l5', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_mail_outline_24px.svg', 0, 'iρk>.֦j', 'iρk>.֦j', 'Z?0!:Y{aK$:.|:֛_A', '', 0, '?'),
 ('	\réyCND#6x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_message_24px.svg', 0, '.[m3%f', '.[m3%f', '/fU58~ꢗLs^', '', 0, '?'),
 ('\\*>-D;5^!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_no_sim_24px.svg', 0, 'r\ni#څU', 'r\ni#څU', '\\N	VXDkYc<U ', '', 0, '?'),
 ('qV!MnKII', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phone_24px.svg', 0, '8WFKE?mTDv', '8WFKE?mTDv', 'T1x.~cEbԏGAv', '', 0, '?'),
 ('k`<Q,/F', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_erase_24px.svg', 0, 'uF\0YQWt', 'uF\0YQWt', '9آ(cRظ<`~Vew', '', 0, '?'),
 ('afB`+|', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_lock_24px.svg', 0, 'ieVgX0cњ*a', 'ieVgX0cњ*a', 'kZ%&!2;iXD', '', 0, '?'),
 ('`\"AY),m', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_ring_24px.svg', 0, '$+[50D', '$+[50D', '\r~	φefΠ̧dL$', '', 0, '?'),
 ('08ѻq䡤\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_setup_24px.svg', 0, 'e5ܸܷU|E1', 'e5ܸܷU|E1', '^Zu-:\"]#XES!MF	\\', '', 0, '?'),
 ('l\'\\˼', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_portable_wifi_off_24px.svg', 0, 'OvnZy', 'OvnZy', '\"	oA|w	gwwY\'+', '', 0, '?'),
 ('uDXWF(2>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_present_to_all_24px.svg', 0, 'K@7\0YkH', 'K@7\0YkH', '~ūbO zK,*-\0Y!S,', '', 0, '?'),
 ('@\\( \r!m', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_ring_volume_24px.svg', 0, '5q*ap~#[', '5q*ap~#[', '=<^\"Fݸ@ϳ:yO8on', '', 0, '?'),
 ('>ӝTrT!\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_screen_share_24px.svg', 0, 'hA6.C7', 'hA6.C7', '1[6w;$eF=b', '', 0, '?'),
 ('4xtՀ\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_speaker_phone_24px.svg', 0, 'FcƹS.\n&!/I', 'FcƹS.\n&!/I', 'Їq2&;^\0xf~?', '', 0, '?'),
 ('m9(	V0>h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_current_landscape_24px.svg', 0, 'ߎX]r3}[k', 'ߎX]r3}[k', 'fX\n\'$UaBp\rSf\rR', '', 0, '?'),
 ('(O:G\"_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_current_portrait_24px.svg', 0, '0SܼB_6?!zE', '0SܼB_6?!zE', '3ajb\07H+&6;(F7ލ$', '', 0, '?'),
 ('Hނjb\\o`N', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_primary_landscape_24px.svg', 0, 'ߎX]r3}[k', 'ߎX]r3}[k', 'fX\n\'$UaBp\rSf\rR', '', 0, '?'),
 ('TNaH(	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_primary_portrait_24px.svg', 0, '0SܼB_6?!zE', '0SܼB_6?!zE', '3ajb\07H+&6;(F7ލ$', '', 0, '?'),
 ('5̸4|9o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stop_screen_share_24px.svg', 0, '$<tU<', '$<tU<', 'K	cwbXE~o lM7f&', '', 0, '?'),
 ('?vҁ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_swap_calls_24px.svg', 0, 'k\r&Jg', 'k\r&Jg', '?TR4kPEeMl[Ay', '', 0, '?'),
 ('n;x]tCq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_textsms_24px.svg', 0, 'R5!6/!+', 'R5!6/!+', '\\s\nm;{s(\nC(E8\'+\n', '', 0, '?'),
 ('QOٳo/\\i$\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_voicemail_24px.svg', 0, '7PY7<3H', '7PY7<3H', 'WsǅBD+I#', '', 0, '?'),
 ('YԼw\'lAiѮ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_vpn_key_24px.svg', 0, 'O&6Pjne', 'O&6Pjne', '\'d\0;\'ߊ i', '', 0, '?'),
 ('yBoۣ`+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_24px.svg', 0, '\"TXE<wU}vk', '\"TXE<wU}vk', 'mk:O{:W֠cM<', '', 0, '?'),
 ('&hMf?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_box_24px.svg', 0, '5ّT8G\r{', '5ّT8G\r{', 'Weg	}44!Eaz!/Av;<o}', '', 0, '?'),
 ('ӝ`5O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_circle_24px.svg', 0, 'K`|!u-\Zy', 'K`|!u-\Zy', '̊gPjΡhRtSy4Ρ@.nx', '', 0, '?'),
 ('	͐wԐ?fxuu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_circle_outline_24px.svg', 0, '0KC#8:˩@j', '0KC#8:˩@j', '\np\0aj5_eHDnl', '', 0, '?'),
 ('`IY]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_archive_24px.svg', 0, '$];-7hp', '$];-7hp', '籚\0TyQXI8\nԊ', '', 0, '?'),
 ('0AQXUsFC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_backspace_24px.svg', 0, 'WﾡQ={a', 'WﾡQ={a', '.ťƇâx8bћӪM', '', 0, '?'),
 ('w{ۑS;V6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_block_24px.svg', 0, 'wJ2]|\rEa', 'wJ2]|\rEa', '|N\ZYeڟ~+5\'wL;@5-', '', 0, '?'),
 (';\ZUݥc\\4)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_clear_24px.svg', 0, 'F_\Zd\"', 'F_\Zd\"', 'MrY5tJ$YI ?^', '', 0, '?'),
 ('Y|rEӛF', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_content_copy_24px.svg', 0, '[$V\"!', '[$V\"!', 'f1y\0Py[\"%\ZEsH8D', '', 0, '?'),
 ('xQ=-W', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_content_cut_24px.svg', 0, 'j\n]pDe', 'j\n]pDe', 'E	\nSJ1\'h?qD', '', 0, '?'),
 ('ר5򽻛9=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_content_paste_24px.svg', 0, '&$1+a?U', '&$1+a?U', 'kFNEκ߭D|\Z	6#Ɣv', '', 0, '?'),
 ('fDdPo%Q\\h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_create_24px.svg', 0, '905Hq^\Z', '905Hq^\Z', 'vu;ׁO<KR`ֽӯ$~', '', 0, '?'),
 ('Z4\\Y`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_drafts_24px.svg', 0, 'YoDMډ0Bˈ', 'YoDMډ0Bˈ', '\\Ehf\nR:Q\"~KVBO\n', '', 0, '?'),
 ('tKݕjI0[z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_filter_list_24px.svg', 0, 'RRM.I', 'RRM.I', 'ǈ$I,0\'YkO', '', 0, '?'),
 ('\Zq64=GW', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_flag_24px.svg', 0, 'Lh2~ ', 'Lh2~ ', '*]4\0AtJ[.vt[I', '', 0, '?'),
 ('!1ĻIx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_font_download_24px.svg', 0, 'P\"@^?߅\0T', 'P\"@^?߅\0T', '!Mv<?_mf#', '', 0, '?'),
 ('_QzG/?7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_forward_24px.svg', 0, '\"f[EPX\0#', '\"f[EPX\0#', '(hрZNk\Z[A!~*c)\0', '', 0, '?'),
 ('7.` g+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_gesture_24px.svg', 0, '>֠\0HngxD', '>֠\0HngxD', 'YŲ*ĈucGari', '', 0, '?'),
 ('\Z#.\\	m', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_inbox_24px.svg', 0, 'Y8B,tqWM5X', 'Y8B,tqWM5X', '<98`)\'~R!\r', '', 0, '?'),
 ('y=4X$^ԥfFo', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_link_24px.svg', 0, '`t쭇J/', '`t쭇J/', 'm.<Y??n\Z`jxh', '', 0, '?'),
 ('0\0FE(ܩ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_mail_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('cVq)\Z+>o', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_markunread_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('[}ri\'yK݈', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_move_to_inbox_24px.svg', 0, '9kZ^]w', '9kZ^]w', 'e+cDjSewlB', '', 0, '?'),
 ('㧰q&b%0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_next_week_24px.svg', 0, 'F>H(eNM', 'F>H(eNM', '-=$̪pnG9H19g&+Kx', '', 0, '?'),
 (')_D&\"LV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_redo_24px.svg', 0, 'Sl̠4Dom', 'Sl̠4Dom', 'Bi(E[?3e>;vw}z', '', 0, '?'),
 ('5qć}uM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_remove_24px.svg', 0, ']`!r+TqW', ']`!r+TqW', '4>2T\\dww`\ZUH', '', 0, '?'),
 ('E}Ycn0r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_remove_circle_24px.svg', 0, '{uWwܘXN', '{uWwܘXN', 'B+wOR.אZ;w:|', '', 0, '?'),
 ('q\Z^\Z@	{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_remove_circle_outline_24px.svg', 0, '/P܏%\r~9ez', '/P܏%\r~9ez', '?6I)^FۜQT%aqw,TKK', '', 0, '?'),
 ('J(!l_\\%M', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_reply_24px.svg', 0, 'H4+jʛv*', 'H4+jʛv*', 'k/BU:4!(0.0*<E', '', 0, '?'),
 ('bu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_reply_all_24px.svg', 0, '	螥s', '	螥s', 'y~/tbLdN5e=sTb', '', 0, '?'),
 ('\ZTalX6w&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_report_24px.svg', 0, '{w.p{Es!x', '{w.p{Es!x', 'ic.\\k r;𘳍;QUÈ5', '', 0, '?'),
 ('rrP-Pe', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_save_24px.svg', 0, '=ktHS', '=ktHS', ',CLJkp\"b(y@c956', '', 0, '?'),
 ('m\"[X$g7*.b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_select_all_24px.svg', 0, '##', '##', '|n萆c*Cmg\0', '', 0, '?'),
 ('l~3H⧻', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_send_24px.svg', 0, '7Ú', '7Ú', '|($yKA=Aޅ\03.GwO', '', 0, '?'),
 ('&d5Re+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_sort_24px.svg', 0, 'dqY8\"	\r', 'dqY8\"	\r', 'lܾl8K2i&f~h^)KYG~', '', 0, '?'),
 ('W1b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_text_format_24px.svg', 0, 'ghҬ`', 'ghҬ`', ';n;ȌJybĪbh},', '', 0, '?'),
 ('BpiS\'h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_unarchive_24px.svg', 0, '#{iKuUo', '#{iKuUo', '@QgD*b8[%+ D1`X', '', 0, '?'),
 (' Nz7/F8Vaq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_undo_24px.svg', 0, 'CNafVRRYC', 'CNafVRRYC', 'WGvC5lܻ\'TwA3iXSAb=', '', 0, '?'),
 ('At|:s[\r6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_weekend_24px.svg', 0, '8Tسr	Ո', '8Tسr	Ո', '2d?۾zAZNM=uXR|k{,', '', 0, '?'),
 ('l?Ff~Qh', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_access_alarm_24px.svg', 0, '\'48;;q8@', '\'48;;q8@', 'U	\"\"غH-	J=p', '', 0, '?'),
 ('i*pSB', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_access_alarms_24px.svg', 0, ']mֳw(M\rEQ05', ']mֳw(M\rEQ05', 'dȟ[2o6t1,i`4RR5', '', 0, '?'),
 ('}V]9^-\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_access_time_24px.svg', 0, '\n8l}+QG ', '\n8l}+QG ', '~2`[éYR:ٗέ0\0#$s(', '', 0, '?'),
 ('K$ѵ\r`&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_add_alarm_24px.svg', 0, ']4&?\rR4軉N', ']4&?\rR4軉N', 'ѕ~=+:s	vbO50.\r#\00d', '', 0, '?'),
 ('{ގhܖBq\\l', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_airplanemode_active_24px.svg', 0, 'Aہ&lo|[E', 'Aہ&lo|[E', 'P\'ooLC~ovPad}~', '', 0, '?'),
 ('.gwVw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_airplanemode_inactive_24px.svg', 0, '^\'QW1ڜ', '^\'QW1ڜ', 'fRָm;rν@qhɶ7c', '', 0, '?'),
 ('H(Irk~,P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_20_24px.svg', 0, 'mqup:&me', 'mqup:&me', 'RdפpS\Zx)q.]X*Ǌ\nh', '', 0, '?'),
 ('ՙk+>G', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_30_24px.svg', 0, '\Z9UJ\n', '\Z9UJ\n', 'BQiA KgFa~i$3', '', 0, '?'),
 ('bpN|O`#Ǩ\0?Q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_50_24px.svg', 0, 'wf\\8W0@}', 'wf\\8W0@}', 'U4CѯQQ9y;\'Lhc', '', 0, '?'),
 ('b<qsQE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_60_24px.svg', 0, '\n-uPvt', '\n-uPvt', 'ɲa|#=0p_фIO~\rS\"9', '', 0, '?'),
 (';N\'WT^O?0g', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_80_24px.svg', 0, 'M-j=ѵbg', 'M-j=ѵbg', 'SI#pw8\nOv`\\x', '', 0, '?'),
 ('=F	Jz!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_90_24px.svg', 0, '+jCx%', '+jCx%', 'D vSw9Ot\\FdkW?؋', '', 0, '?'),
 ('qXpwو', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_alert_24px.svg', 0, '3.Il\'k-r', '3.Il\'k-r', '.hy\'7\\4+}-r', '', 0, '?'),
 ('	\"j!yzh`e', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_20_24px.svg', 0, 'ܳ]Y1+4$<[\\', 'ܳ]Y1+4$<[\\', '3}<_.^j#fwB_Oj', '', 0, '?'),
 ('E(x~ZW90', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_30_24px.svg', 0, '~661D', '~661D', 'ᖀv8Qa(wI+|', '', 0, '?'),
 ('HdC/+{-x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_50_24px.svg', 0, 'WtKb@B', 'WtKb@B', '|afi\'WקUS4', '', 0, '?'),
 ('jTsheO', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_60_24px.svg', 0, '@ȫ?/[', '@ȫ?/[', 'c\0|\n\rřP5,r&-H', '', 0, '?'),
 ('m򍸎l7j+v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_80_24px.svg', 0, ')Cy^]l_T', ')Cy^]l_T', '%-St\0٭m)z\n	.;+', '', 0, '?'),
 ('I5˜ܓdM@{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_90_24px.svg', 0, 'o[Gd!5 ', 'o[Gd!5 ', '*=V9Z\n\ncnl\Z|u5VyQ', '', 0, '?'),
 ('\"{XK^BF', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_full_24px.svg', 0, '=nV~tM', '=nV~tM', '1ΰQTŁ(#>~}WwLq', '', 0, '?'),
 ('1-5]knj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_full_24px.svg', 0, '%mh\Z{FI$۝', '%mh\Z{FI$۝', '=mYu\"^D{. d', '', 0, '?'),
 ('\rHqs\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_std_24px.svg', 0, '%mh\Z{FI$۝', '%mh\Z{FI$۝', '=mYu\"^D{. d', '', 0, '?'),
 ('igm}6		P0v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_unknown_24px.svg', 0, 'u~/d\Z', 'u~/d\Z', '!	溩p֟ƻfn=Kfn[YMB', '', 0, '?'),
 ('2T(7R\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_24px.svg', 0, '%x_j', '%x_j', '9VxC$BH.^ұC4R', '', 0, '?'),
 ('yT9EϝV運', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_connected_24px.svg', 0, 'SAը)/~xaF', 'SAը)/~xaF', 'mvH1\\ȒKZҹ', '', 0, '?'),
 ('ݮ5CCs+޸', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_disabled_24px.svg', 0, '3L1y#BF\na', '3L1y#BF\na', 'cX,.1X-\0ߓ?f1r', '', 0, '?'),
 ('BݖN:ZSX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_searching_24px.svg', 0, 'c\r;Ǐ_', 'c\r;Ǐ_', '>TV\nC~8LOɁYvK˶De\'%', '', 0, '?'),
 ('^ꃿ-5v\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_auto_24px.svg', 0, '0=TP#8@qU', '0=TP#8@qU', 's4n2K4FЇ,#\nPYKڻ', '', 0, '?'),
 ('qו!L&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_high_24px.svg', 0, 'zQD	˙s', 'zQD	˙s', '&QKv%N\0uIvY', '', 0, '?'),
 ('@n7ǜ:', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_low_24px.svg', 0, '0|Mܹ', '0|Mܹ', 't=]&d}qz7mnu', '', 0, '?'),
 ('*O$a>p9t{L\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_medium_24px.svg', 0, 'TB0yyHL\'Y{', 'TB0yyHL\'Y{', '𕷅ar9.&%\0+>', '', 0, '?'),
 ('b>4ΰM*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_data_usage_24px.svg', 0, 'KK4Lΰq;', 'KK4Lΰq;', 'B\'8KN¡(4HAw3*?', '', 0, '?'),
 ('~=uۋqr7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_developer_mode_24px.svg', 0, '$g\ZXYy:', '$g\ZXYy:', 'ԟp+\\m>o_ƟiWDhEIztY', '', 0, '?'),
 ('G0Hgh~||', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_devices_24px.svg', 0, 'S4X	~W', 'S4X	~W', 'aAF\\.1\Z]rYS@|5w', '', 0, '?'),
 ('dٿ>lb9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_dvr_24px.svg', 0, 'Pf_=Fro', 'Pf_=Fro', '\">bMĥ]ڃS&', '', 0, '?'),
 ('xOJ;v', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_gps_fixed_24px.svg', 0, 'G~)5o!g', 'G~)5o!g', 'W?ړ-JAV۩TS`o{+', '', 0, '?'),
 ('9Cq\nv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_gps_not_fixed_24px.svg', 0, '>xEyQ/bV', '>xEyQ/bV', 'SBށG;+bp_@=,n[M', '', 0, '?'),
 ('5LN^LN̻s\\8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_gps_off_24px.svg', 0, '%ůuœ\0ǌ', '%ůuœ\0ǌ', 'S1iKѡnKg-t#<:մ-', '', 0, '?'),
 ('HS__b@Gqq2w2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_graphic_eq_24px.svg', 0, '^H}Tǚe	+', '^H}Tǚe	+', '*UY-}9޳\rMC~', '', 0, '?'),
 ('`rƐ\rh53,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_location_disabled_24px.svg', 0, '%ůuœ\0ǌ', '%ůuœ\0ǌ', 'S1iKѡnKg-t#<:մ-', '', 0, '?'),
 ('C*+,b[s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_location_searching_24px.svg', 0, '>xEyQ/bV', '>xEyQ/bV', 'SBށG;+bp_@=,n[M', '', 0, '?'),
 ('AOҔ1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_network_cell_24px.svg', 0, '8;5z	N#7\'+\0', '8;5z	N#7\'+\0', 'K9~B&XXvd}qr[', '', 0, '?'),
 ('eQi,7	j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_network_wifi_24px.svg', 0, '1C', '1C', 'V+b(8L%m\nI', '', 0, '?'),
 (',>*S7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_nfc_24px.svg', 0, '%g:ZBw7VP', '%g:ZBw7VP', '%?$^ uզY\0@kW;.*', '', 0, '?'),
 ('l``F', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_lock_landscape_24px.svg', 0, '\"t=Yo', '\"t=Yo', 'ճe!}#[}ƒb+fՍ<', '', 0, '?'),
 ('BPd\0$٩ƒ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_lock_portrait_24px.svg', 0, ',$qeO`.DP', ',$qeO`.DP', 'fٟMҖ*M\Z!,bq3k\nN', '', 0, '?'),
 (']+̬', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_lock_rotation_24px.svg', 0, ',U,bWTY<~', ',U,bWTY<~', 'M1h|/zCn*:a@=|', '', 0, '?'),
 ('CPnKnqB', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_rotation_24px.svg', 0, ':=6F0q', ':=6F0q', 'yr!w\0}@xɳp=9G049', '', 0, '?'),
 ('YxKMD,=w', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_sd_storage_24px.svg', 0, '$NoIgB', '$NoIgB', 'gl 7IՁA=', '', 0, '?'),
 ('}_ڗi|', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_settings_system_daydream_24px.svg', 0, '83y!-R', '83y!-R', '-)GR/̓ZDC+s^+Z', '', 0, '?'),
 ('c3/I%^C', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_0_bar_24px.svg', 0, 'ߨTM-Ht!Sl4', 'ߨTM-Ht!Sl4', 'Mv%w4uFxA[#>x$', '', 0, '?'),
 ('xb\\;uOS;q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_1_bar_24px.svg', 0, 'h,mVOU', 'h,mVOU', 'byu\Z\'/Um3|ƎUd	\Z', '', 0, '?'),
 ('ڌ\nxzyY}7vR', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_2_bar_24px.svg', 0, 'i4wP	9\r/', 'i4wP	9\r/', '^w#a/\'= Y-KGwڙ', '', 0, '?'),
 ('NH8NtYR)$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_3_bar_24px.svg', 0, '8;5z	N#7\'+\0', '8;5z	N#7\'+\0', 'K9~B&XXvd}qr[', '', 0, '?'),
 ('llF[q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_4_bar_24px.svg', 0, 'Ef=qzr\\', 'Ef=qzr\\', 'X%й0Yhj}1R', '', 0, '?'),
 ('Nte(!h\"n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_0_bar_24px.svg', 0, '>+~PԆ){8*', '>+~PԆ){8*', '+pFLÚ`nnWOwA\',', '', 0, '?'),
 ('T<0tQEv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_1_bar_24px.svg', 0, '.6%=', '.6%=', '0+1XҍI}bP@\\B', '', 0, '?'),
 ('h6Heu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_2_bar_24px.svg', 0, '}ߔ`њh', '}ߔ`њh', '׏GD3W*pG#Z~_0Z', '', 0, '?'),
 ('\'CK`E癠y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_3_bar_24px.svg', 0, 'G#I֑/E', 'G#I֑/E', 'S!Wni}COB\\Ѓ[T', '', 0, '?'),
 ('8qLӽ\'$I5', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_4_bar_24px.svg', 0, 'U\0{\r>Uy', 'U\0{\r>Uy', 'Vto\n)V/4^*4G}_5A', '', 0, '?'),
 ('8c͙Nd=4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_no_sim_24px.svg', 0, 'r\ni#څU', 'r\ni#څU', '\\N	VXDkYc<U ', '', 0, '?'),
 ('GѝSF*e', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_null_24px.svg', 0, 'o7K_¼', 'o7K_¼', '4mj{|>|MjZZ%}~', '', 0, '?'),
 ('ڶ*>ԓ]n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_off_24px.svg', 0, '0(=*M', '0(=*M', ';64bAoo8anri[h', '', 0, '?'),
 ('~ߒ#mb9k{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_0_bar_24px.svg', 0, '\nRȮid\Zf', '\nRȮid\Zf', 'fnjvmuϛ\"Bץ▁9|7', '', 0, '?'),
 ('HyT?dx}S', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_24px.svg', 0, 'vJ쫻6BHr|', 'vJ쫻6BHr|', 'ǜkFK}sizmWf;~c', '', 0, '?'),
 ('pLOll\'b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_lock_24px.svg', 0, 'sM7/$', 'sM7/$', '[tїtwch3', '', 0, '?'),
 ('jduSN,쉬', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_24px.svg', 0, '8p_|\'Fwn2G', '8p_|\'Fwn2G', 'OS4Beph5G0', '', 0, '?'),
 ('Z\\j(#2jK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_lock_24px.svg', 0, 'X_Kat%[=_Z', 'X_Kat%[=_Z', 'Sk-q6пRe+nI&', '', 0, '?'),
 ('DJ@*r6aS', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_24px.svg', 0, '1C', '1C', 'V+b(8L%m\nI', '', 0, '?'),
 ('>AJ_Ѵg!2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_lock_24px.svg', 0, '7fu3beG', '7fu3beG', 'pDПrc,zj?jOZN', '', 0, '?'),
 ('XpL1:I=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_24px.svg', 0, 'K:g2?Bi$V', 'K:g2?Bi$V', '-$16#|M[\rR$Fw!', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('|wB*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_lock_24px.svg', 0, ']j0^Pӯ-m', ']j0^Pӯ-m', '>qwFb6 Z|GoQ{+Lo', '', 0, '?'),
 ('i;Mb\\.Q\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_off_24px.svg', 0, '}Nuz}f', '}Nuz}f', '>yE\ZkF~>#/]̧:', '', 0, '?'),
 ('	,q_s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_1_bar_26x24px.svg', 0, ']tNw+', ']tNw+', 'iڮ-gf@7!W~Z̀-', '', 0, '?'),
 ('鮘MZ(7g3m_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_2_bar_26x24px.svg', 0, 'Hgc$', 'Hgc$', '>3x^r!RH.rwC퀽\r', '', 0, '?'),
 ('^&ɫM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_3_bar_26x24px.svg', 0, '\ZDB', '\ZDB', 'v;b}\0j?I޴igQ\"т`C', '', 0, '?'),
 ('%Oկ=p\Zj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_4_bar_26x24px.svg', 0, 'ZJX̦Z', 'ZJX̦Z', 'G@F,u~xlnHp\09$f\'pU', '', 0, '?'),
 ('Q\Z/CM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_1_26x24px.svg', 0, 'eT}=', 'eT}=', '?RGDߐOe4Sᣱ=[I', '', 0, '?'),
 ('|mXg9y4\\E', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_26x24px.svg', 0, 'ᴨQX', 'ᴨQX', '8.i-߇L.W掲 aNa', '', 0, '?'),
 ('4D', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_2_26x24px.svg', 0, '=#R51', '=#R51', '佶Q賚\rɭP.M\ZH\\ɭ|	V', '', 0, '?'),
 ('/49F<\rAP#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_3_26x24px.svg', 0, 'ߍ],+u8', 'ߍ],+u8', ' \'u}.0(\'э^.gE', '', 0, '?'),
 ('F+\09	)+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_4_26x24px.svg', 0, '4,YnTx', '4,YnTx', '߅z\nc,\"daq!P3hr', '', 0, '?'),
 ('Weѡ7ԣT!c', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_not_connected_26x24px.svg', 0, '\\uDG7', '\\uDG7', '98]y\0\"w?u}Ҿau9p', '', 0, '?'),
 ('WJ\n	\na6O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_null_26x24px.svg', 0, 'L	5$RZ(:', 'L	5$RZ(:', 'ʖ~Pa#;Ϧ~ TL', '', 0, '?'),
 ('Sܘ4Qn\n(', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_storage_24px.svg', 0, '	FPb!', '	FPb!', 'n\"_~	E+P@OSp_^*\"', '', 0, '?'),
 ('	L)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_usb_24px.svg', 0, 'SG*m4iS', 'SG*m4iS', 'QeaxH$Hu*\')g\0', '', 0, '?'),
 (':D`S:o1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_wallpaper_24px.svg', 0, 'ǸN<\rI}6', 'ǸN<\rI}6', '#׫Njˇl?[߭:Cls', '', 0, '?'),
 ('QuB<kO;\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_widgets_24px.svg', 0, 'P̚]|SN', 'P̚]|SN', '0{K^BF!mDq<	B', '', 0, '?'),
 ('W0\riH', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_wifi_lock_24px.svg', 0, '闘Mȕїz', '闘Mȕїz', '0 e(pz~\ZKE', '', 0, '?'),
 ('š}Ff8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_wifi_tethering_24px.svg', 0, 'z0No,g+jG', 'z0No,g+jG', '@h9K5<Б =K	j0\"', '', 0, '?'),
 ('ѭZ@?Lx$J\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_attach_file_24px.svg', 0, '`BkΩm.', '`BkΩm.', 'wQwV,?Aέ00hv:y,$4', '', 0, '?'),
 ('1Qg4ҫ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_attach_money_24px.svg', 0, '	xJxr\r5', '	xJxr\r5', '֘oX2[?Nd+A=', '', 0, '?'),
 ('VpC3xgqv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_all_24px.svg', 0, 'd@ő\nb2', 'd@ő\nb2', 'y	e	Mti[xS.$.3\'pF', '', 0, '?'),
 ('#֫;8A~!t', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_bottom_24px.svg', 0, 'Geɘ[v', 'Geɘ[v', 'wb:D^\'܈', '', 0, '?'),
 ('zѝǁ^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_clear_24px.svg', 0, 'H;{ei:*', 'H;{ei:*', 'ʆc	uݬ$q\"@', '', 0, '?'),
 ('q$ڒ̜n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_color_24px.svg', 0, '|HXz׋١U', '|HXz׋١U', 'I)}	J|yrˇ]eE\'', '', 0, '?'),
 ('lp/(*~٥C', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_horizontal_24px.svg', 0, 'G8FG{(	', 'G8FG{(	', '!.Tu#׿m~\0DXϮm^#5A*r', '', 0, '?'),
 ('o08OKr}Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_inner_24px.svg', 0, '<cU$oBDg', '<cU$oBDg', 'eSNvŧLov', '', 0, '?'),
 ('\Z곂uvw\n\Z0*[', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_left_24px.svg', 0, 'C²q+|.v', 'C²q+|.v', '\\]h;_sUht:\r05AUgλzh1', '', 0, '?'),
 ('GFROVj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_outer_24px.svg', 0, 'A,0^_,=', 'A,0^_,=', '?\ZSb\\cW_Bf9le̍|@', '', 0, '?'),
 ('`oęKKX\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_right_24px.svg', 0, 'MXTF}]', 'MXTF}]', 'uBIEg0r>FBxj', '', 0, '?'),
 (';tfBܴ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_style_24px.svg', 0, '4nġ]\\hm\0', '4nġ]\\hm\0', 'Ǹ`KoC9_kx8c.', '', 0, '?'),
 ('0N\"\n^UM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_top_24px.svg', 0, '-\'͚q%C[7', '-\'͚q%C[7', 'm]P0+jHPN9yk˛>O4n', '', 0, '?'),
 ('d\\:8!L', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_vertical_24px.svg', 0, 'Dc\\s!V\\j0f', 'Dc\\s!V\\j0f', '2et.\'9rᬲK,-(񬡡t', '', 0, '?'),
 ('MMrnObj|', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_drag_handle_24px.svg', 0, '8/JU~.[s', '8/JU~.[s', 'D:Ul0M翿ފo', '', 0, '?'),
 ('t;W<m3 ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_center_24px.svg', 0, '݄!]qXrq', '݄!]qXrq', '5B$\rkPxG3\"LrٳI\naK', '', 0, '?'),
 ('d^P\0Ƽœ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_justify_24px.svg', 0, '-ި>I^', '-ި>I^', 'atvO	kH', '', 0, '?'),
 ('2=ŪVe\'6ݜ%n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_left_24px.svg', 0, 'v%_skV', 'v%_skV', 'O>3YJ/P@Vy]]~.$', '', 0, '?'),
 ('(FQ1С\00\nG', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_right_24px.svg', 0, 'q;.y}r>', 'q;.y}r>', '3&\r.LFHu\"̚*a9p', '', 0, '?'),
 ('cXg]&>N%C', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_bold_24px.svg', 0, '|ǟXNb>', '|ǟXNb>', 'xlwm̛9zmW8', '', 0, '?'),
 ('\rȁdOJ@Ks', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_clear_24px.svg', 0, '[|A.-ޮb', '[|A.-ޮb', 'Md;]<&#RK|=;-ٖhcn\\\"', '', 0, '?'),
 ('gd2Ut7Ug', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_color_fill_24px.svg', 0, 'WUXU', 'WUXU', '\0 |	E6\\EToRSR', '', 0, '?'),
 ('9Ȫq>,˖', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_color_reset_24px.svg', 0, '݌OXW*X', '݌OXW*X', 'm2\'9җ\\,\nN1', '', 0, '?'),
 ('bʪ\07r\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_color_text_24px.svg', 0, 'S0BIVI', 'S0BIVI', '[QiZD@F;֣lPK ', '', 0, '?'),
 ('_i[@s(+I^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_indent_decrease_24px.svg', 0, '#+9Dbݞ֍ZѢ', '#+9Dbݞ֍ZѢ', ']kO-zd\"T(ُ\n!^\"\"jqZ', '', 0, '?'),
 ('Jx,	R%Xz{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_indent_increase_24px.svg', 0, 'EO&t\'p1', 'EO&t\'p1', '3y2Zb:I04 \\#9ͭB:', '', 0, '?'),
 ('mȤx\ZA*z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_italic_24px.svg', 0, 'ΐKakܶ', 'ΐKakܶ', 'ص)]d$(g[[Uv', '', 0, '?'),
 ('9r@\\nS3Vy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_line_spacing_24px.svg', 0, 'sG{\ZGż:', 'sG{\ZGż:', '.s7y{w˔Uw', '', 0, '?'),
 ('rM\':3ט9t', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_list_bulleted_24px.svg', 0, 'ٷ=/ּƣC჋', 'ٷ=/ּƣC჋', '#ޤchMn:Uw\0&N!', '', 0, '?'),
 ('>b\'-\\ƣ6V', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_list_numbered_24px.svg', 0, 'bQw:ĀTX׸7', 'bQw:ĀTX׸7', '\\M\n\nxN&@}7', '', 0, '?'),
 (';kq2%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_paint_24px.svg', 0, 'xjG[b', 'xjG[b', '|omwK:\n2', '', 0, '?'),
 ('bd9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_quote_24px.svg', 0, 'QE/XNf', 'QE/XNf', 'k\\oXc]?\\ث,c[Xw_7', '', 0, '?'),
 ('2qC\"*Xn', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_shapes_24px.svg', 0, '8F9D}', '8F9D}', '[	/]Oϼrn]E~s', '', 0, '?'),
 ('8o<,r[7/y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_size_24px.svg', 0, 'x/Z-FB4', 'x/Z-FB4', '\ny?ܾ%a,49Ĳy\'d;F/', '', 0, '?'),
 ('[?5{Oɾ5\'p', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_strikethrough_24px.svg', 0, '[#,\'/', '[#,\'/', '!3D5P8= \nz:AvVʄ1', '', 0, '?'),
 ('#RI4>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_textdirection_l_to_r_24px.svg', 0, '%qɀ\Zt', '%qɀ\Zt', '|$q\"2JfVwP	U', '', 0, '?'),
 ('b=`BZJ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_textdirection_r_to_l_24px.svg', 0, '\\`ɱA[FB', '\\`ɱA[FB', '%єvl\"Y@zЛg', '', 0, '?'),
 ('/V&98C9p', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_underlined_24px.svg', 0, '[A|1H;>', '[A|1H;>', 'J(T	%_3tҐ5#01<', '', 0, '?'),
 ('q{*\'G', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_functions_24px.svg', 0, 'Bfx', 'Bfx', 'p^\"x\\.7ɚ,@', '', 0, '?'),
 ('HZ%DXC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_highlight_24px.svg', 0, 'ډm7.[>C_', 'ډm7.[>C_', '!Rj/6=KܓNa1', '', 0, '?'),
 ('7v$6Le@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_chart_24px.svg', 0, '*5\":(;7+', '*5\":(;7+', 'aO;L;_)~ԍ?ഥ:', '', 0, '?'),
 ('sUpz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_comment_24px.svg', 0, 'h/32/ʝm', 'h/32/ʝm', 'EP)xiMZƥy^` }#^1ݽ', '', 0, '?'),
 ('XH`9;I', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_drive_file_24px.svg', 0, 'Gx4Cyt', 'Gx4Cyt', 'fC4k#@0b7.jɡg\n', '', 0, '?'),
 ('N	;˦', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_emoticon_24px.svg', 0, 'l!qM+x k-', 'l!qM+x k-', '\0ꧤ^vޕO͍rr0#t', '', 0, '?'),
 ('GL	7\'\r?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_invitation_24px.svg', 0, ':ɘ', ':ɘ', 'M!LAY(;3B~z2}iYJWU', '', 0, '?'),
 ('7Z\"F\'L:i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_link_24px.svg', 0, '`t쭇J/', '`t쭇J/', 'm.<Y??n\Z`jxh', '', 0, '?'),
 (';N;COы#\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_photo_24px.svg', 0, 'vːͦF18?', 'vːͦF18?', 'ɧbN=,g8r	(MXjOA`s', '', 0, '?'),
 ('(h&}', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_linear_scale_24px.svg', 0, 'ŒX!P\\:', 'ŒX!P\\:', 'g4@MPckd#*GiVj~', '', 0, '?'),
 (' шm:Jf[G', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_merge_type_24px.svg', 0, '޲:4)!*t', '޲:4)!*t', 'kƕ[/kB|>\\`rt=VE=', '', 0, '?'),
 ('RN}<Mb/@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_mode_comment_24px.svg', 0, '\Z $V2_', '\Z $V2_', 'pکbܚ9Yp@GkERqeЀͧ', '', 0, '?'),
 ('tk#9Hy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_mode_edit_24px.svg', 0, '905Hq^\Z', '905Hq^\Z', 'vu;ׁO<KR`ֽӯ$~', '', 0, '?'),
 ('3\"\Z(s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_money_off_24px.svg', 0, 'b+&VR', 'b+&VR', ']B[Vy3y *-Ķu6', '', 0, '?'),
 ('G%QXz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_publish_24px.svg', 0, '-_(\nBOqS', '-_(\nBOqS', 'sOB;8$XH4', '', 0, '?'),
 ('=pJtM۬', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_short_text_24px.svg', 0, 'Sdd n', 'Sdd n', ' IuHQ~/b7dmV\nl', '', 0, '?'),
 ('@LcGX#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_space_bar_24px.svg', 0, 'b?ľ\ro', 'b?ľ\ro', 'K6wX~)isԏ~Q֪/%ڑ', '', 0, '?'),
 ('ut<%m\'B!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_strikethrough_s_24px.svg', 0, 'Kt\n[d}y_', 'Kt\n[d}y_', '^Ju<8*z>a\n**.X', '', 0, '?'),
 ('y~J2Ӄ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_text_fields_24px.svg', 0, '<[m(7#\".', '<[m(7#\".', '+Y200?m*\0D;\'G', '', 0, '?'),
 ('*Ai]rD', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_vertical_align_bottom_24px.svg', 0, '8ⅼeE&O', '8ⅼeE&O', 'B).nDEl*Yi-S ', '', 0, '?'),
 ('tھzm7U', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_vertical_align_center_24px.svg', 0, 'Ɗd`v+{#T$', 'Ɗd`v+{#T$', 'P6p}m	fڳ)|)N0#', '', 0, '?'),
 ('f wu!e]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_vertical_align_top_24px.svg', 0, '||PpqYd!', '||PpqYd!', 'r/}w#\n$u)c1aƒr', '', 0, '?'),
 ('.@c,\Z1N!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_wrap_text_24px.svg', 0, 'Hph@0sc', 'Hph@0sc', 'TAMop>)ܷF9سq\nc', '', 0, '?'),
 ('~t3̨ƣ\Zsg4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_attachment_24px.svg', 0, 's{&\"v羨v', 's{&\"v羨v', '^DK9@O؈kxW', '', 0, '?'),
 ('y!*;\nA9lz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_24px.svg', 0, '3cV~Lj', '3cV~Lj', '.~ڌ|nxe:TEDOR[', '', 0, '?'),
 ('\0PV HR', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_circle_24px.svg', 0, 'qf(l>&u7', 'qf(l>&u7', 'Cbdk=tv@<xSgAƁ\n', '', 0, '?'),
 ('\\}1`lq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_done_24px.svg', 0, 'K.\08` ', 'K.\08` ', '2l/Vsa\'ѭ;vykmT', '', 0, '?'),
 ('Uf;Hq0GG', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_download_24px.svg', 0, ',|,Z', ',|,Z', '/\nTj)&ZBQ$@wn}&sH\r', '', 0, '?'),
 ('|@&Y?6w#	{c', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_off_24px.svg', 0, '2&\\Gdء^\"6$', '2&\\Gdء^\"6$', 'xq54OlZ!4\Z6', '', 0, '?'),
 ('\\;(vRXw;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_queue_24px.svg', 0, 'ܓǌaK-*ig', 'ܓǌaK-*ig', 'iQZ&6oLCR+w\n\r|3.\rm', '', 0, '?'),
 ('גsҏ1Y1W', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_upload_24px.svg', 0, 'f#/&M4Ֆ', 'f#/&M4Ֆ', 'ͳJŹ2jt6}aWT%SO', '', 0, '?'),
 ('٠iIW6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_create_new_folder_24px.svg', 0, 'r; ی', 'r; ی', 'TFs3hmKgH~6gho$P', '', 0, '?'),
 ('f2qL3Е', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_file_download_24px.svg', 0, 'T7_tn3,g', 'T7_tn3,g', '7dd=jpha\\(/ήۢ', '', 0, '?'),
 ('>mA<j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_file_upload_24px.svg', 0, 'oS{!+r|', 'oS{!+r|', 'Jh㯋#3mĤcڎ23\"}', '', 0, '?'),
 ('@`lU)~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_folder_24px.svg', 0, 'p5l_4U<	>', 'p5l_4U<	>', '$-vģ\0-n\ZcĞߡT\rU', '', 0, '?'),
 ('(7*rV-@pc31', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_folder_open_24px.svg', 0, 'v\'\Z5K$r.mU', 'v\'\Z5K$r.mU', '\"`f(mE*PS+I>MHrD', '', 0, '?'),
 ('x W{(0_{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_folder_shared_24px.svg', 0, 'BdalS', 'BdalS', '$t2rn7ndf)#\\L&{\\', '', 0, '?'),
 ('6:`ӛLnm4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_cast_24px.svg', 0, 'rǙBU&', 'rǙBU&', ']B\\9f!u%7\\2]P\\U|', '', 0, '?'),
 ('N2@}P~LK<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_cast_connected_24px.svg', 0, 'n9SNj(1', 'n9SNj(1', 'sIVJiAiOn_mT', '', 0, '?'),
 ('v;\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_computer_24px.svg', 0, '2iݿJކ?R', '2iݿJކ?R', '=EkdB`&[{iPUTx', '', 0, '?'),
 ('٧jj76', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_desktop_mac_24px.svg', 0, 'd8V!>(.A', 'd8V!>(.A', 'l]%\'sڌ5;Wn g', '', 0, '?'),
 ('m:TMoQ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_desktop_windows_24px.svg', 0, '=Z/˟p', '=Z/˟p', '4әWнq{ėHg_b3+U/-_', '', 0, '?'),
 ('tSaGFྣ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_developer_board_24px.svg', 0, 'y8W<w ?', 'y8W<w ?', 'I=HG?\"CH?Es[3_', '', 0, '?'),
 ('	N[˾h\\c ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_device_hub_24px.svg', 0, 'ʩpCA*X', 'ʩpCA*X', 'ɪ(\'Hkt;Lwpʂ?044', '', 0, '?'),
 ('F49k/W', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_devices_other_24px.svg', 0, 'f? au`{s', 'f? au`{s', '?RlFNN;cF@&', '', 0, '?'),
 ('2f\"^\0ٿ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_dock_24px.svg', 0, '!_;Wr', '!_;Wr', ';~y>l!;8{g', '', 0, '?'),
 ('@\n5SW:Q[%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_gamepad_24px.svg', 0, '	pT=2e\Z$', '	pT=2e\Z$', '[twݫjPeW>Üc4\'Xa	', '', 0, '?'),
 ('i[KC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_headset_24px.svg', 0, 'i7$o}|N.', 'i7$o}|N.', 'Q^nufǙ|c\n/w{h', '', 0, '?'),
 ('I_E$Y?\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_headset_mic_24px.svg', 0, 'fQ\nnμ', 'fQ\nnμ', 'xT\"QnvT3\\\00G qwϚ7', '', 0, '?'),
 ('C,0Cl9(', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_24px.svg', 0, ';pT65,', ';pT65,', '?_@0z89,!\\qe', '', 0, '?'),
 ('Os;װ-k`5	{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_down_24px.svg', 0, 'wJ~Is\'%', 'wJ~Is\'%', '4Yio(\rۻZ䙤\"Cex`0s', '', 0, '?'),
 ('i2rГKL7vxG', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_left_24px.svg', 0, 'RV*:2Q', 'RV*:2Q', 'L}\'BۿξG&_\\', '', 0, '?'),
 ('8\r5-N!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_right_24px.svg', 0, '=\nT\\׍GCA', '=\nT\\׍GCA', '47q\ZQپ\\`jή<XM P', '', 0, '?'),
 ('\nΓ7\nNӲ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_up_24px.svg', 0, '];s', '];s', '%6cL}V6iemWYoWLJSF', '', 0, '?'),
 ('WL<|9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_backspace_24px.svg', 0, '%yE', '%yE', '6l}\r\0i8Mj@:k<A؏\rԒ', '', 0, '?'),
 ('_4|-뎪ƨ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_capslock_24px.svg', 0, 'n BcA704x', 'n BcA704x', '#b %ͷ?Q\Z\r-dF̶wU', '', 0, '?'),
 (',^\"AÅuYPYVD', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_hide_24px.svg', 0, '2Mo^Yt\\\'N', '2Mo^Yt\\\'N', 'xX_c~G$a惉', '', 0, '?'),
 ('e%sч+R%k&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_return_24px.svg', 0, 'H/?0\r9*΢\"', 'H/?0\r9*΢\"', 'dh5\0oB+l*]qaGZ', '', 0, '?'),
 ('y]n:)$Z}', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_tab_24px.svg', 0, 'Q37}$nrHN', 'Q37}$nrHN', 'JVd.8;4yL֧}?ףP/', '', 0, '?'),
 ('DQL,0y/ם', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_voice_24px.svg', 0, 'd1*ұ߾)', 'd1*ұ߾)', 'ק{zYР^\0RqR%<)a', '', 0, '?'),
 ('r07Rx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_24px.svg', 0, '\Z\'`A]\"=E', '\Z\'`A]\"=E', 'qo|>Ǆ%ÝvδѿӋ', '', 0, '?'),
 ('E1μ`ͩRfD\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_chromebook_24px.svg', 0, '܈Ñd&.F', '܈Ñd&.F', 'pʛ;.|KlCG1\"', '', 0, '?'),
 ('*J:yߍ\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_mac_24px.svg', 0, '-?Zr', '-?Zr', '<El(p#wWg1X76', '', 0, '?'),
 ('qI:l0F`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_windows_24px.svg', 0, '*&U^]l,', '*&U^]l,', '05plj|Ң(\Z9L', '', 0, '?'),
 ('T<$\"hz(Lh', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_memory_24px.svg', 0, '\0]K\rM', '\0]K\rM', '*r<\Z󱃕Ŝ.w!; vI_ow', '', 0, '?'),
 (';ŋI/\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_mouse_24px.svg', 0, 'JftΊNI10', 'JftΊNI10', 'Ѭ/\Zd3=$)P	f⫤', '', 0, '?'),
 ('//3-ֻX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phone_android_24px.svg', 0, ',c+', ',c+', '?h5^e;k!ҵYy:U6\'11', '', 0, '?'),
 ('^{{?IO[iK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phone_iphone_24px.svg', 0, 'REgx*ޑַ', 'REgx*ޑַ', ')Ĳ7NjttxZ\'D', '', 0, '?'),
 ('LʪChmon', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phonelink_24px.svg', 0, 'S4X	~W', 'S4X	~W', 'aAF\\.1\Z]rYS@|5w', '', 0, '?'),
 ('F*mRu*h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phonelink_off_24px.svg', 0, '.j8$_KxѨx', '.j8$_KxѨx', '_\Zo\n|Ѽ\04 vۭеם', '', 0, '?'),
 ('\0J0a/L\\XAK', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_power_input_24px.svg', 0, 'D9ߴN?[', 'D9ߴN?[', '{ܺ{/|ݘAJ\"p;}RyIo', '', 0, '?'),
 ('Ep>nV6r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_router_24px.svg', 0, 'vS4gB', 'vS4gB', 'ѝvɰ2O7\n1SpU)3G', '', 0, '?'),
 ('\rlD&ȃ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_scanner_24px.svg', 0, '0J!DJ', '0J!DJ', '/a{e_G&&kʠ', '', 0, '?'),
 ('YM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_security_24px.svg', 0, 'uRX(\rz;\"/', 'uRX(\rz;\"/', 'ᘐ8N-Ę~W!o\nXW2.,ܓ', '', 0, '?'),
 ('~/CD7ik', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_sim_card_24px.svg', 0, '`OeM.z1b;', '`OeM.z1b;', 'zlwIbDi9/Gke!Y2\\', '', 0, '?'),
 ('N˰lMC=O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_smartphone_24px.svg', 0, '{F\rAxPN(', '{F\rAxPN(', '꒖S|X.ori\ZN{A^\Z+', '', 0, '?'),
 ('z so-\nȾG', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_speaker_24px.svg', 0, 'jbsA\Z', 'jbsA\Z', 'sleJvu[8׶L~M\\y', '', 0, '?'),
 ('d$KBYw%\n6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_speaker_group_24px.svg', 0, '6?eQ', '6?eQ', ' 2)KSo=n', '', 0, '?'),
 ('AuN_F2ԅR', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tablet_24px.svg', 0, 'N\\ׯp9@r]{', 'N\\ׯp9@r]{', '2l/m@ًIx^+BF|%2', '', 0, '?'),
 ('%dAAKo6(By', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tablet_android_24px.svg', 0, '9%kv', '9%kv', 'Jb\rWOZTG5@Kl', '', 0, '?'),
 ('(0W*1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tablet_mac_24px.svg', 0, 'w+dm\Z#HUL', 'w+dm\Z#HUL', 'K9?bv?oXjwSZVz\r8', '', 0, '?'),
 ('SV\ZEP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_toys_24px.svg', 0, ',%I\r\0ô]', ',%I\r\0ô]', 'ft|\nXʸ\\dRWTtkMc', '', 0, '?'),
 ('02M!\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tv_24px.svg', 0, 'ֵΆ~G=F5', 'ֵΆ~G=F5', '65At	p˙!S7e߁6C', '', 0, '?'),
 ('fMt\'`uӲ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_videogame_asset_24px.svg', 0, '?%\0&ǪFs ', '?%\0&ǪFs ', 'rJe/d;.Z8.̈1*LB', '', 0, '?'),
 ('iivtSz\"4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_watch_24px.svg', 0, '<(!Zyg', '<(!Zyg', '~v4;0swULAkD$z+', '', 0, '?'),
 ('XcIFQ;G', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_add_a_photo_24px.svg', 0, 'cY zs{', 'cY zs{', '\0ml_,S?HیWn<\"^', '', 0, '?'),
 ('̃\"I\'KE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_add_to_photos_24px.svg', 0, 'rĚK', 'rĚK', '˛KiF(6yvstUXVĺA', '', 0, '?'),
 ('C1Iq޸L4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_adjust_24px.svg', 0, '*K;WTŨw', '*K;WTŨw', 'Yf1>O7T#=>@3e', '', 0, '?'),
 ('a%yA(hmv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_assistant_24px.svg', 0, 'aĬ+ͬc	o}s', 'aĬ+ͬc	o}s', 'B\"Q|_ZDl%@-RDBd', '', 0, '?'),
 ('B̭dȴᥐ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_assistant_photo_24px.svg', 0, 'Lh2~ ', 'Lh2~ ', '*]4\0AtJ[.vt[I', '', 0, '?'),
 ('0syH', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_audiotrack_24px.svg', 0, '`84Têޞ-R', '`84Têޞ-R', '8<ekI?[l0`y:ծ', '', 0, '?'),
 ('-d xѫgM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_circular_24px.svg', 0, 'ķ޾Ew(WD>ͩ', 'ķ޾Ew(WD>ͩ', ':uZ\"ʵ\\0oPx\\#U', '', 0, '?'),
 ('\noiPji\ZT', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_linear_24px.svg', 0, '!Hll](', '!Hll](', '~zfhy3^F42@}rԜ΂', '', 0, '?'),
 ('	3?ko`M<\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_off_24px.svg', 0, 'v\\$=!v|,&ʒ(', 'v\\$=!v|,&ʒ(', 'F3늈ܔ݆DNq磝Zbth', '', 0, '?'),
 ('yWm,	㬐W\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_on_24px.svg', 0, 'ƹurd{dfN', 'ƹurd{dfN', 'sgh[km4CqTB', '', 0, '?'),
 ('Lăh~|z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_1_24px.svg', 0, 'dB*Mvˤ\"', 'dB*Mvˤ\"', '/jTdxtmg1&$Fb7=', '', 0, '?'),
 ('r=^;$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_2_24px.svg', 0, '\ZJǽSa!N3%[', '\ZJǽSa!N3%[', 'tS{@\'U[ڴodHVmC', '', 0, '?'),
 ('xE1\nA', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_3_24px.svg', 0, '~()PŒ/;apD', '~()PŒ/;apD', 'q_AJ~M3E;{', '', 0, '?'),
 ('O-)\"J29', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_4_24px.svg', 0, 'EhD~t\Z', 'EhD~t\Z', ',8mYY	+5)y9\0', '', 0, '?'),
 ('O:)pZzk1!}}', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_5_24px.svg', 0, '0|Mܹ', '0|Mܹ', 't=]&d}qz7mnu', '', 0, '?'),
 ('!##fO\'so9*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_6_24px.svg', 0, 'TB0yyHL\'Y{', 'TB0yyHL\'Y{', '𕷅ar9.&%\0+>', '', 0, '?'),
 ('I:BXx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_7_24px.svg', 0, 'zQD	˙s', 'zQD	˙s', '&QKv%N\0uIvY', '', 0, '?'),
 ('$G\'[i', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_broken_image_24px.svg', 0, '̺R\00P', '̺R\00P', 'O3Ϊ)j\nmU07Cn', '', 0, '?'),
 ('I\nH`n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brush_24px.svg', 0, 'v `$', 'v `$', 'cΣvi[4&r &&xX!', '', 0, '?'),
 (':\0iEـ6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_24px.svg', 0, '\rdm+>_MNt@T', '\rdm+>_MNt@T', 'X	DC7^=CP', '', 0, '?'),
 ('gZt!%j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_alt_24px.svg', 0, 'Oa6Y%C', 'Oa6Y%C', 'l6ꏀ].rC\r;E', '', 0, '?'),
 (';VhQt>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_front_24px.svg', 0, 'NL6Wx', 'NL6Wx', '9oxp(~8N=)', '', 0, '?'),
 ('s\n[aəK	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_rear_24px.svg', 0, '|uUAKY', '|uUAKY', ')N8jsٟjzvN=54Csq >', '', 0, '?'),
 ('5LE7|Eh', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_roll_24px.svg', 0, ';z\r[Y~', ';z\r[Y~', '98\\t3Ŝ*`@6GWl,a', '', 0, '?'),
 ('=,Ko+n`4', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_center_focus_strong_24px.svg', 0, '5FW~\'', '5FW~\'', 'XR+N|+=,Y\r[\0ukT)', '', 0, '?'),
 ('mޤx?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_center_focus_weak_24px.svg', 0, 'E~}!ow*J', 'E~}!ow*J', '^V!\'emHp?e56', '', 0, '?'),
 ('cI}HE', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_collections_24px.svg', 0, 'Ǻi\ZKC^\"l', 'Ǻi\ZKC^\"l', 'gcפY:Cz+:', '', 0, '?'),
 ('ٍ[q&ݭ3t*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_collections_bookmark_24px.svg', 0, '|ýZI0\Z\'', '|ýZI0\Z\'', 'd%Qj{l`\Z[`7aː\\$', '', 0, '?'),
 ('tX>߇|x3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_color_lens_24px.svg', 0, ' \n֎&\\', ' \n֎&\\', 'KS_zݞV_^+', '', 0, '?'),
 ('Yk6KSJ<aǔ$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_colorize_24px.svg', 0, ' JPp;-8!', ' JPp;-8!', '?6IgE`Х.\\}OrC[H\0', '', 0, '?'),
 ('1?!\Zu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_compare_24px.svg', 0, '55lrgev7#Jɇ', '55lrgev7#Jɇ', 'VC`\\vKbZ1N0̓', '', 0, '?'),
 ('&La[t|', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_control_point_24px.svg', 0, 'B+=', 'B+=', 'xFcVҪKGX*Dr֊C', '', 0, '?'),
 ('@+<T#r\0`+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_control_point_duplicate_24px.svg', 0, '(V\'\\X4eZ', '(V\'\\X4eZ', ';^(]~\n5nJ4=F+C', '', 0, '?'),
 (')v\"Ϝ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_16_9_24px.svg', 0, 'L%=4+R', 'L%=4+R', 'RG4dDI7(MOr57>	LX?S', '', 0, '?'),
 ('fڻ=(&tA!', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_24px.svg', 0, 'zWܹ۠', 'zWܹ۠', '4ڛ`vXM <m>Yd\rfz', '', 0, '?'),
 ('Ok\Z+s|\nf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_3_2_24px.svg', 0, '|pX$Ȭo(N', '|pX$Ȭo(N', 'C~_=<+y_P+Ma3O]i', '', 0, '?'),
 ('08 ᣆMňx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_5_4_24px.svg', 0, '<CK|~9m', '<CK|~9m', '٢˻L(*g3aKրCI+', '', 0, '?'),
 ('iu.]Ӵ&s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_7_5_24px.svg', 0, '^T,Js', '^T,Js', '|斪kĀ.G\0c<YmC~', '', 0, '?'),
 (' -Գ=85', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_din_24px.svg', 0, 'pN\n!L\'-Qu9~', 'pN\n!L\'-Qu9~', '縷kABٸJu\\E\nvӳ/2lS', '', 0, '?'),
 ('\ZMe@:t{b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_free_24px.svg', 0, '=wK\0<X\'', '=wK\0<X\'', 'ӑӂ3dZI,Xa:', '', 0, '?'),
 ('6i\\xvs', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_landscape_24px.svg', 0, '<CK|~9m', '<CK|~9m', '٢˻L(*g3aKրCI+', '', 0, '?'),
 ('8r>YfNb9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_original_24px.svg', 0, '\\:\r9CXs<', '\\:\r9CXs<', '|<CHiws=lǕb', '', 0, '?'),
 ('+#Jn', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_portrait_24px.svg', 0, '95T$A/', '95T$A/', 'XAjqr&x`@ųvcLk5', '', 0, '?'),
 ('ix:33\r$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_rotate_24px.svg', 0, 'ey3\"', 'ey3\"', '&48;7K\rzD,BCH', '', 0, '?'),
 ('W3s P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_square_24px.svg', 0, '0?ocY', '0?ocY', 'oKSqoؖY,h98[I', '', 0, '?'),
 ('2`[0Vl\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_dehaze_24px.svg', 0, 'x>.\"bN', 'x>.\"bN', 'HG΃at/2Շ<9Zd', '', 0, '?'),
 ('E򻕮J[lO}%Y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_details_24px.svg', 0, '^9/&s.-g', '^9/&s.-g', 'ʴ])|g\Z\' ', '', 0, '?'),
 ('u2djW=<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_edit_24px.svg', 0, '905Hq^\Z', '905Hq^\Z', 'vu;ׁO<KR`ֽӯ$~', '', 0, '?'),
 ('P%TpY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_24px.svg', 0, 'XtTGlO', 'XtTGlO', 'j9S(Ls຾jiN', '', 0, '?'),
 ('l|壳lBcfA\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_neg_1_24px.svg', 0, '{]^6~ab', '{]^6~ab', '|/*s1s45֫eRxJo\\', '', 0, '?'),
 ('~=~J{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_neg_2_24px.svg', 0, 'Fא[wM2*B', 'Fא[wM2*B', '~of/fN;\\', '', 0, '?'),
 ('ܼiaBZ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_plus_1_24px.svg', 0, 'B\\Rto|s])0', 'B\\Rto|s])0', ' 7kuu51\Zy2NƧ', '', 0, '?'),
 ('TǚtjF8Cބ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_plus_2_24px.svg', 0, '\'v:L2_ReyG\Z', '\'v:L2_ReyG\Z', 'R{+i.~Ν.*2~jh8ĺ~s', '', 0, '?'),
 ('MC6Q mple', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_zero_24px.svg', 0, 'b#J[y', 'b#J[y', 'cEA$\ZF{[\"	σH', '', 0, '?'),
 ('??e~|mԛN$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_1_24px.svg', 0, '\07>', '\07>', '4BYN4sa-1Ng5ZvbO0M', '', 0, '?'),
 ('NgqрI]E\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_24px.svg', 0, ' m\',)|ɠfz', ' m\',)|ɠfz', '!gX	E1M*PY;,	ZI', '', 0, '?'),
 ('Jz{txGm.H-', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_2_24px.svg', 0, ';5DT%Ⱥd.', ';5DT%Ⱥd.', '%nG&AxXSKz	*M2j[-M|절', '', 0, '?'),
 ('/飐ȔL', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_3_24px.svg', 0, '#P\\<taSEZ', '#P\\<taSEZ', 'lK9ڱeRncl+%1S', '', 0, '?'),
 ('\nT*vW\rB\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_4_24px.svg', 0, '~jĽpa*ӭ·', '~jĽpa*ӭ·', '`.3blΖod4AFnJ ', '', 0, '?'),
 ('MNt4ٕ/?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_5_24px.svg', 0, 'k\'G\r5ͪ', 'k\'G\r5ͪ', 'nVrEYM10oģurb&', '', 0, '?'),
 ('fW=;c2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_6_24px.svg', 0, '-\09.a9p{', '-\09.a9p{', 'IϑUd9ҳ5\njOv\0', '', 0, '?'),
 ('g]2T\Z\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_7_24px.svg', 0, 'xB\',}m', 'xB\',}m', '&fTpU;Rԙ=L-鱕', '', 0, '?'),
 ('U_nW%n:', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_8_24px.svg', 0, 'Rx?(', 'Rx?(', '	]iw,\\\r*Djk,', '', 0, '?'),
 ('aů:QWm', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_9_24px.svg', 0, 'fل!q\nu\Z`', 'fل!q\nu\Z`', 'ٻ)\">ڽ(D\r5', '', 0, '?'),
 ('>Vqy7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_9_plus_24px.svg', 0, 'KHYR\0', 'KHYR\0', 'b}le8wr8EЂx ', '', 0, '?'),
 ('[`W8w8t5\'', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_b_and_w_24px.svg', 0, '~pY{a®g%㿷', '~pY{a®g%㿷', 'GcΣ#P	0̶/Wc7G]6=7b', '', 0, '?'),
 ('g\"Ъ4={', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_center_focus_24px.svg', 0, 'qMR{EDR', 'qMR{EDR', 'וL4k:аO+Z&wAMD', '', 0, '?'),
 (':DQ(,#*e', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_drama_24px.svg', 0, 'x.2-S`ȮN', 'x.2-S`ȮN', 'n*Ƌ	$1}}yP[A-.}=', '', 0, '?'),
 ('4vZW\'VTy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_frames_24px.svg', 0, '%D[K(qe`/#', '%D[K(qe`/#', '^K]?4~*q^怲br', '', 0, '?'),
 ('ޏZ.YQK\"~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_hdr_24px.svg', 0, 'Dp\0)[Y', 'Dp\0)[Y', 'E酲.~I/tKޖDXy{E', '', 0, '?'),
 ('^.S2ej', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_none_24px.svg', 0, 'TQON4mޚ', 'TQON4mޚ', ',\\K;nC}T\'|	5RJ', '', 0, '?'),
 ('{XFn형', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_tilt_shift_24px.svg', 0, 'C! \\Δĳ', 'C! \\Δĳ', '<	\0VσeȪ2©&ӱ*tk0', '', 0, '?'),
 ('c0Jצ0ׇ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_vintage_24px.svg', 0, 's\'\n~4', 's\'\n~4', 'UuxcZzoBdj:>', '', 0, '?'),
 ('\nnyWkJ̏MX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flare_24px.svg', 0, 'RBQ\'v', 'RBQ\'v', 'B|(<nȃ*Tc', '', 0, '?'),
 ('Vn¥%{>S_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flash_auto_24px.svg', 0, 'zj<;6', 'zj<;6', 'le@PNӋcfQf&4=K', '', 0, '?'),
 ('.-%r`fk', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flash_off_24px.svg', 0, 'K8x!y`A', 'K8x!y`A', '&qU\0N/Q\0!I\'BL', '', 0, '?'),
 ('QӖ0:@\nlI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flash_on_24px.svg', 0, 'F`ñ@(', 'F`ñ@(', '\n=HX>擁e-khk	3', '', 0, '?'),
 ('.DZl`9_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flip_24px.svg', 0, '_oR94浛', '_oR94浛', 'RXAn1y\ZALWͺ(Y', '', 0, '?'),
 ('n[3[-', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_gradient_24px.svg', 0, '1=4O', '1=4O', '>˖]%<])J#86@yn', '', 0, '?'),
 ('ݱ|EGjyԞ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_grain_24px.svg', 0, 'u8aF|֑', 'u8aF|֑', 'ʭy>Vyo8/v<', '', 0, '?'),
 (']@oh}HkX_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_grid_off_24px.svg', 0, '22OP2', '22OP2', 'ހ9(WX=VQm	ȅyd\Z6^', '', 0, '?'),
 ('L\\v\r~9p|-Di', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_grid_on_24px.svg', 0, 't|n>+TN', 't|n>+TN', '\\KA/?Nc\"3 10>9\0y)[M', '', 0, '?'),
 ('_?;xp&>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_off_24px.svg', 0, '|:\rh7G̣_', '|:\rh7G̣_', '%}@`=ig7?B`iCr?y', '', 0, '?'),
 ('`oC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_on_24px.svg', 0, 'y-+ e', 'y-+ e', '+#\0S>(*fv', '', 0, '?'),
 ('Zh|-', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_strong_24px.svg', 0, 'wjn>iz&G', 'wjn>iz&G', 'Ҁs<:y{CdK;] ,', '', 0, '?'),
 ('4@i).u}', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_weak_24px.svg', 0, '[bu', '[bu', '&+z4=oX?Nv', '', 0, '?'),
 ('6꟫vraëy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_healing_24px.svg', 0, 'd]=ӟ۷', 'd]=ӟ۷', 'Q11\0$<˟xCGKUIH', '', 0, '?'),
 ('יo$>FB', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_image_24px.svg', 0, 'vːͦF18?', 'vːͦF18?', 'ɧbN=,g8r	(MXjOA`s', '', 0, '?'),
 ('}8󁦼.A3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_image_aspect_ratio_24px.svg', 0, '{HSڳuf%5cO', '{HSڳuf%5cO', '<[ĭPn8~9 ~MU', '', 0, '?'),
 ('S<l_\\)iaȅ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_iso_24px.svg', 0, '-ʘȜFox', '-ʘȜFox', 'H\'8W8ciA$bDG(;h', '', 0, '?'),
 ('xJ-\ne˜', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_landscape_24px.svg', 0, 'Dp\0)[Y', 'Dp\0)[Y', 'E酲.~I/tKޖDXy{E', '', 0, '?'),
 ('y*v;zKv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_leak_add_24px.svg', 0, ']v\r\"\ZS8`~}\n', ']v\r\"\ZS8`~}\n', 'R+gk ܢGU0(\Z', '', 0, '?'),
 ('wIfz~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_leak_remove_24px.svg', 0, '.$Η~[uJ$', '.$Η~[uJ$', 'y1b\Z3*W?DCxqATȡ2D', '', 0, '?'),
 ('93T>\0?\np?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_lens_24px.svg', 0, '^z9eP', '^z9eP', 'Y~.*&/)᫰\\cdf*', '', 0, '?'),
 ('=>)N\n=.wu', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_linked_camera_24px.svg', 0, ',Qɻ׆FB*u', ',Qɻ׆FB*u', 'X0cs<szg]K>i[', '', 0, '?'),
 ('768>ˢW0W>x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_24px.svg', 0, 'Q⃽Q}tF', 'Q⃽Q}tF', 'p?+RטF\0S0Y`(+', '', 0, '?'),
 ('X~(z&', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_3_24px.svg', 0, '6e` ̝GԳ#/', '6e` ̝GԳ#/', 'R#7JSJQPgW4Ӂ', '', 0, '?'),
 ('sh]8pqz;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_4_24px.svg', 0, 'a}x:O@', 'a}x:O@', '5>8╃`Mj(ahPjs]t', '', 0, '?'),
 ('(KTiaOXg', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_5_24px.svg', 0, 'ٯϐmdHP', 'ٯϐmdHP', ';k}߫\\vltWFCODsy', '', 0, '?'),
 ('?]gჷYc],', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_6_24px.svg', 0, 'aow-/P=:', 'aow-/P=:', 'wGT®|<>/w', '', 0, '?'),
 ('M.5ݛ][xN', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_one_24px.svg', 0, 'nI4B', 'nI4B', 'y*32{aݨzÛ2J', '', 0, '?'),
 ('zWOi', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_two_24px.svg', 0, 'XyhBµ@*_', 'XyhBµ@*_', 'lJ+Vҹۋ2x«%PH.~+T', '', 0, '?'),
 ('.<=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_loupe_24px.svg', 0, 't5ā+T#qC', 't5ā+T#qC', 'Awa5Y*IL{8)R-o	k', '', 0, '?'),
 ('uӈJ@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_monochrome_photos_24px.svg', 0, 'c΄>', 'c΄>', 'Dáq׷<t-΋/*r', '', 0, '?'),
 ('\nurS֣J^Z2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_movie_creation_24px.svg', 0, '|>ed:U', '|>ed:U', 'Xc\Z3V.M(9rLi', '', 0, '?'),
 ('<)=?۱J^w', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_movie_filter_24px.svg', 0, '.!tTe,P', '.!tTe,P', '疁t0(%DE', '', 0, '?'),
 ('+Ըӽxpp,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_music_note_24px.svg', 0, 'c]=h@', 'c]=h@', 'f/ Dj1ɾ3A8:ZRɸHI', '', 0, '?'),
 ('!0}P+`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_nature_24px.svg', 0, '2_I\\KV|', '2_I\\KV|', 'KwUՌަY4w\0	\rJy', '', 0, '?'),
 ('ZBCqB/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_nature_people_24px.svg', 0, '\\2Cw#', '\\2Cw#', 'YƀY07<2ҩg!W`C|!GW', '', 0, '?'),
 ('r(`EBNHsd\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_navigate_before_24px.svg', 0, 'իr)', 'իr)', '^^Ղ{;O՝tHbBBO]U\nv', '', 0, '?'),
 ('W%z)K@Yq', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_navigate_next_24px.svg', 0, '/3\\-%C', '/3\\-%C', 'Ɉ>5~D.51ōݿ@8KiRrK\'', '', 0, '?'),
 ('-\nҘm1r	@4?%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_palette_24px.svg', 0, ' \n֎&\\', ' \n֎&\\', 'KS_zݞV_^+', '', 0, '?'),
 ('b9Ѷ<?Y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_24px.svg', 0, 'EhWa\Z,', 'EhWa\Z,', '!2|؈=OʌXwǄ5:7]T܉', '', 0, '?'),
 ('mQbᚃ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_fish_eye_24px.svg', 0, 'J~]ܪP-', 'J~]ܪP-', '=S-?vQlPcaT@Y_O\'', '', 0, '?'),
 ('LM>nW4\Z*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_horizontal_24px.svg', 0, 'd.c>YgD{', 'd.c>YgD{', '|,OAo|e*+_\"_]0', '', 0, '?'),
 ('A@HcJ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_vertical_24px.svg', 0, '>2 \0JRx', '>2 \0JRx', '\ZFp)()*qW!,', '', 0, '?'),
 ('7]_N', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_wide_angle_24px.svg', 0, 'd\Z뢥z\"D', 'd\Z뢥z\"D', '<~8n ܀\0>ˤo[s', '', 0, '?'),
 (' .Q$7\n !', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_24px.svg', 0, 'vːͦF18?', 'vːͦF18?', 'ɧbN=,g8r	(MXjOA`s', '', 0, '?'),
 ('fWc4|j=ULo', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_album_24px.svg', 0, 'iV&HlS>;İ}', 'iV&HlS>;İ}', 'sHx{$tt`!0f', '', 0, '?'),
 ('g\'߂RO', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_camera_24px.svg', 0, 'Oa6Y%C', 'Oa6Y%C', 'l6ꏀ].rC\r;E', '', 0, '?'),
 ('g_?~c', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_filter_24px.svg', 0, '9oj+w', '9oj+w', 'b8\r^,us', '', 0, '?'),
 ('\0yv{S%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_library_24px.svg', 0, 'Ǻi\ZKC^\"l', 'Ǻi\ZKC^\"l', 'gcפY:Cz+:', '', 0, '?'),
 ('^F!eGJ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_size_select_actual_24px.svg', 0, '(zRun# d#q', '(zRun# d#q', 'E}*MLR \0r̝', '', 0, '?'),
 ('G-|', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_size_select_large_24px.svg', 0, 'm.ĝ	;', 'm.ĝ	;', 'F;l!h8H\rهCb\0', '', 0, '?'),
 ('$YXM7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_size_select_small_24px.svg', 0, 'ڠ\"_J:u\rߤ', 'ڠ\"_J:u\rߤ', 'vA_R\0\'}Kcmv&.$', '', 0, '?'),
 ('_A:GpZ\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_picture_as_pdf_24px.svg', 0, 'Pd=2*늬(\Z', 'Pd=2*늬(\Z', '1d\\\\}oVi3	d0y', '', 0, '?'),
 ('ag:p', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_portrait_24px.svg', 0, '(]-Gn\r/', '(]-Gn\r/', ',\0n6EeI98́a:4s<	?\n', '', 0, '?'),
 ('7B\"H&t5', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_remove_red_eye_24px.svg', 0, '(dDN=!_2ك', '(dDN=!_2ك', '$7Q\rRt5,y}VOތr', '', 0, '?'),
 ('ZƳ|n\'P]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_rotate_90_degrees_ccw_24px.svg', 0, 'B@vp	k0,', 'B@vp	k0,', '1اs#vHp8ժNGU\'<', '', 0, '?'),
 ('F9)e:V%p\ZW', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_rotate_left_24px.svg', 0, 'JtDHv>2=', 'JtDHv>2=', '#}\08Q5yX4£Q.`f~ms', '', 0, '?'),
 ('ob]69q}m{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_rotate_right_24px.svg', 0, 'wĨrw', 'wĨrw', '8$B@bf_2', '', 0, '?'),
 ('bA', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_slideshow_24px.svg', 0, '$.d<]IDtO', '$.d<]IDtO', '3M]\'tbqh#E\r[2UF', '', 0, '?'),
 ('4<%\n', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_straighten_24px.svg', 0, '~A\' ', '~A\' ', 'Ujs1\n=,jh[#yB', '', 0, '?'),
 ('<gAG\' á', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_style_24px.svg', 0, 'R$ԥ', 'R$ԥ', '@l1TzV4W[=r', '', 0, '?'),
 ('s煇v	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_switch_camera_24px.svg', 0, 'K|^9h,1S', 'K|^9h,1S', 'ܑrيyDoܚ2{\ZʮF', '', 0, '?'),
 ('-\'Q3ڙ>Y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_switch_video_24px.svg', 0, '@rd\\yEIFh\0', '@rd\\yEIFh\0', '΅ r \\/9Qixnu&', '', 0, '?'),
 ('D;A7>*ݝI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_tag_faces_24px.svg', 0, 'l!qM+x k-', 'l!qM+x k-', '\0ꧤ^vޕO͍rr0#t', '', 0, '?'),
 ('H]˄0Hҷkl:', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_texture_24px.svg', 0, ' a/:~)IX', ' a/:~)IX', 'I;,,Dg]D.0\r9b', '', 0, '?'),
 ('u_c	8x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timelapse_24px.svg', 0, 'mɤ?Ʉ|!b', 'mɤ?Ʉ|!b', 'qxG.ݞ҈R[֜*qBA', '', 0, '?'),
 ('[wm\\Q/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_10_24px.svg', 0, 'v-/{{z˜\r', 'v-/{{z˜\r', '&.0C]GUG u`', '', 0, '?'),
 ('c]NiQ]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_24px.svg', 0, 'sk+vp', 'sk+vp', 'o\"%:tU3,uvH\nqc8[', '', 0, '?'),
 (':;Xq(|6P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_3_24px.svg', 0, '6C.\"\\j', '6C.\"\\j', 'EtC֞nKJ΂C~uO\r@,', '', 0, '?'),
 ('Yi7tZt6%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_off_24px.svg', 0, '=ɫ/.Y*', '=ɫ/.Y*', 'R͕&N؂VLXbxľ', '', 0, '?'),
 ('VA07AQضS', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_tonality_24px.svg', 0, 'AfΨv@:ɊF)', 'AfΨv@:ɊF)', '%6@h&HFM(5yQϥ', '', 0, '?'),
 ('PPwD*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_transform_24px.svg', 0, 'I-h4k[', 'I-h4k[', 'm\Z<;47KGiQ7ԂQo\nm', '', 0, '?'),
 ('Na\"`\'A$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_tune_24px.svg', 0, 'l]\n%猠mWg.', 'l]\n%猠mWg.', 'U{ӚD)2b-:Ϝ', '', 0, '?'),
 ('iibs6N7`%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_view_comfy_24px.svg', 0, 'xº0f;', 'xº0f;', 'C\nC25T!/)2R0Z(3k`8_', '', 0, '?'),
 ('0Ճ&($flg', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_view_compact_24px.svg', 0, '^=y\no\Z8ˌ#Q', '^=y\no\Z8ˌ#Q', 'yqj㧬9}<\0F6D֣jr_LȀ', '', 0, '?'),
 ('@&y.\06pT7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_vignette_24px.svg', 0, 'Bu Eubo>d', 'Bu Eubo>d', '>߬GْmFSWł-', '', 0, '?'),
 ('Պ\"6Mv)w<W]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_auto_24px.svg', 0, 'z\n.]YvP27', 'z\n.]YvP27', '\"v=;B\0P`	뒝{p[Lb', '', 0, '?'),
 ('\\)77_;', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_cloudy_24px.svg', 0, 'Hc$:kOY', 'Hc$:kOY', 'k^׷Xr-	?1]-o:?\0z;R', '', 0, '?'),
 ('{I:_7?P', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_incandescent_24px.svg', 0, '\"=.&գ', '\"=.&գ', 'jOM:ΥqotG!$YU4f', '', 0, '?'),
 ('UDG\ZW:', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_iridescent_24px.svg', 0, 'ˮ%t%', 'ˮ%t%', 'OQT_f8:4ʌOH?2', '', 0, '?'),
 ('v&U', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_sunny_24px.svg', 0, 'E<5]ֶx', 'E<5]ֶx', 'E<o\0ޣ,;m\\ PdJ{', '', 0, '?'),
 ('r-̀\Z~g\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('$HhomX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_add_location_24px.svg', 0, '\0`>8\n8', '\0`>8\n8', 'x11&2^*J/c@fK~<.[_,', '', 0, '?'),
 ('g1,@}h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_beenhere_24px.svg', 0, 'l)Y!!Ǌ{e1', 'l)Y!!Ǌ{e1', 'b״\0ۧ^S:t]VWđ2', '', 0, '?'),
 ('πw,Se2Y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_24px.svg', 0, 'ԡI\\7g;;Ie', 'ԡI\\7g;;Ie', '}<1@m+9O!=4=sr', '', 0, '?'),
 ('xSl1K4JV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_bike_24px.svg', 0, 'd9BVt9m', 'd9BVt9m', '|*\'SlZy!b(\"?5haRۑQ', '', 0, '?'),
 (' H,5ʺ ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_boat_24px.svg', 0, ',|Ev ʬ ', ',|Ev ʬ ', 'Mke&eЩuyũ,F', '', 0, '?'),
 ('9y.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_bus_24px.svg', 0, '\ZV~q^', '\ZV~q^', 'XMNjѻlYkx[8r\\;Hd?ۂ', '', 0, '?'),
 ('5yHZTHnTC2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_car_24px.svg', 0, '׎ZXkux', '׎ZXkux', 'CX.a2}/~ ݊UB{', '', 0, '?'),
 ('ޏ\Z+Dwv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_railway_24px.svg', 0, '+HF|z~^-0', '+HF|z~^-0', '\0KIzCY\r.DO +', '', 0, '?'),
 ('L&\0 &vEz', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_run_24px.svg', 0, '	Pצ}eX', '	Pצ}eX', 'ѹx:I4gU^v5\'-}', '', 0, '?'),
 ('4sN0%̊zӞ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_subway_24px.svg', 0, '%a_q?=', '%a_q?=', '麸HLK*s+3y\rj5', '', 0, '?'),
 ('m>d', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_transit_24px.svg', 0, '%a_q?=', '%a_q?=', '麸HLK*s+3y\rj5', '', 0, '?'),
 ('giSdFq	֔', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_walk_24px.svg', 0, 'QoLmi-', 'QoLmi-', 'F,O:c(+Gr', '', 0, '?'),
 ('홦ʮRF#xx', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_edit_location_24px.svg', 0, ']#b	-', ']#b	-', 'а\"0kv[ׯ1.`fi]F', '', 0, '?'),
 ('[ŹGaPǜ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_flight_24px.svg', 0, 'Aہ&lo|[E', 'Aہ&lo|[E', 'P\'ooLC~ovPad}~', '', 0, '?'),
 ('C?c	nA\Z(oJ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_hotel_24px.svg', 0, '1<io X', '1<io X', 'hzΝ&:I+9~Cy@J/s2i\n', '', 0, '?'),
 ('8s9?fI/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_layers_24px.svg', 0, 'gs6cUQWF', 'gs6cUQWF', 'fTHșTKE۬J^5]^', '', 0, '?'),
 ('oz\r/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_layers_clear_24px.svg', 0, '?h-sJ', '?h-sJ', '2%r?5ɗ9%ďLu_K	', '', 0, '?'),
 ('p!P#Ȋ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_activity_24px.svg', 0, '?z/OTZF', '?z/OTZF', '\'A$\0M$6%Oxh=NYUꅠҸ', '', 0, '?'),
 ('Y8eK-k\"`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_airport_24px.svg', 0, '}fY6Xq\'', '}fY6Xq\'', 'q:I\\4BTڙ@o@ms', '', 0, '?'),
 ('M\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_atm_24px.svg', 0, 'qѸWm', 'qѸWm', 'e}wR4\'p&D)#', '', 0, '?'),
 ('W)\rIL%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_bar_24px.svg', 0, 'CH-]VHR', 'CH-]VHR', 'ˢZ$	{tm9}0\r', '', 0, '?'),
 ('ӈ)R\Zteq*9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_cafe_24px.svg', 0, '~)Q,\0m', '~)Q,\0m', '¯=shֳB=LOEaq', '', 0, '?'),
 ('ζԯ0(.,x', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_car_wash_24px.svg', 0, 'VE$}F-?Xu', 'VE$}F-?Xu', 'vQPHQ#_)[E', '', 0, '?'),
 ('k^@YG', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_convenience_store_24px.svg', 0, '*\0D', '*\0D', 'Ї#\\9s^Mk |I$ƃG[\r8', '', 0, '?'),
 ('WD\"!u(a90sl', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_dining_24px.svg', 0, 'kxxj@h3G', 'kxxj@h3G', '¿Sx>F4j,7ϵlX2]_', '', 0, '?'),
 ('$`|Vpo', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_drink_24px.svg', 0, 'FVLh', 'FVLh', 'Ǝt<ߍZugFr1', '', 0, '?'),
 ('OYr:\Zk:KI', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_florist_24px.svg', 0, 'TY*Ui', 'TY*Ui', '\Z.2qNbjỳP9[vι', '', 0, '?'),
 ('LB(k?=@Yt', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_gas_station_24px.svg', 0, '_<݊`ڲa}m', '_<݊`ڲa}m', '(tw8FD	gj$>\0J', '', 0, '?'),
 ('˝L]k2@<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_grocery_store_24px.svg', 0, '|F5CV:', '|F5CV:', 'Ԟe;nTGKk`߈68', '', 0, '?'),
 ('gem9Դd', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_hospital_24px.svg', 0, 'E $Qǋ', 'E $Qǋ', 'PgҮM!sUAp_4ʉݚpg', '', 0, '?'),
 ('+}{%/Eic', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_hotel_24px.svg', 0, '1<io X', '1<io X', 'hzΝ&:I+9~Cy@J/s2i\n', '', 0, '?'),
 ('S;CLB<rD', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_laundry_service_24px.svg', 0, '>yl;6pFV', '>yl;6pFV', '<-p936ћh9c#Fae', '', 0, '?'),
 ('pop~#W`z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_library_24px.svg', 0, '</H*KniXeOp', '</H*KniXeOp', ']fdI3DJ-Y', '', 0, '?'),
 ('7swEh ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_mall_24px.svg', 0, '̔\nm<f', '̔\nm<f', '3Ԏ>`}3`ao\ZfzD', '', 0, '?'),
 ('Zt?¸wO', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_movies_24px.svg', 0, 'H\r2Rڤ', 'H\r2Rڤ', 'jf0k߶zc~ъ@r^f0.', '', 0, '?'),
 ('7ԅlTlP', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_offer_24px.svg', 0, '^|`۪', '^|`۪', '\\ra0Vwlt1.h{=gȀ', '', 0, '?'),
 ('KYݹ~wB8rc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_parking_24px.svg', 0, 'V\rƱ=Ɛ)r', 'V\rƱ=Ɛ)r', 's#-!/t0 ~ ~', '', 0, '?'),
 ('5I3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_pharmacy_24px.svg', 0, '$9GsjL', '$9GsjL', '<C@:kN@E%74wjjL+{n0', '', 0, '?'),
 (':ǐbٰ\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_phone_24px.svg', 0, '8WFKE?mTDv', '8WFKE?mTDv', 'T1x.~cEbԏGAv', '', 0, '?'),
 (',\\9_*3с\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_pizza_24px.svg', 0, '弍<B[(v`', '弍<B[(v`', 'Sf-{W|[\\topĕ{@\0ݷ', '', 0, '?'),
 ('\'@a,w', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_play_24px.svg', 0, '?z/OTZF', '?z/OTZF', '\'A$\0M$6%Oxh=NYUꅠҸ', '', 0, '?'),
 ('K崃°', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_post_office_24px.svg', 0, '1v):΢Xgu0', '1v):΢Xgu0', '^#Ûwzsn{Ѭ\",-ii', '', 0, '?'),
 ('icL:\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_printshop_24px.svg', 0, ')>0\nG\ZrQF', ')>0\nG\ZrQF', ']$pz:\'CR\0syL9#?', '', 0, '?'),
 ('S#NV|t6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_see_24px.svg', 0, 'Oa6Y%C', 'Oa6Y%C', 'l6ꏀ].rC\r;E', '', 0, '?'),
 ('\"G3~$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_shipping_24px.svg', 0, '[(3KPu@zpA', '[(3KPu@zpA', 'd\0pQ7E{(H%g8\'92*', '', 0, '?'),
 ('K[lvtGu`-@,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_taxi_24px.svg', 0, '*Tc+a0', '*Tc+a0', 'AOdƁ{ߺzWqO\\ s', '', 0, '?'),
 ('菬I4_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_map_24px.svg', 0, '늯БFu', '늯БFu', 'ME6<_V\"m\'^.', '', 0, '?'),
 ('|e%V>#O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_my_location_24px.svg', 0, 'G~)5o!g', 'G~)5o!g', 'W?ړ-JAV۩TS`o{+', '', 0, '?'),
 ('ZT~D~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_navigation_24px.svg', 0, 'ʏ2cLi\rĭ#`+', 'ʏ2cLi\rĭ#`+', 'ɔeV%_X\"Cw衢i0', '', 0, '?'),
 ('%hNp>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_near_me_24px.svg', 0, '%|3~u', '%|3~u', 'm9\'oYYI{r', '', 0, '?'),
 ('4*rU7QA', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_person_pin_24px.svg', 0, '-N0|Vn\"', '-N0|Vn\"', '=*/gك\r\0gZ]%', '', 0, '?'),
 ('_vn@~U', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_person_pin_circle_24px.svg', 0, 'eD\\=Ϳ\ZT', 'eD\\=Ϳ\ZT', '>}\0,\"% \0%nse2р[y', '', 0, '?'),
 ('?Wi@6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_pin_drop_24px.svg', 0, 'g^4C\\p\Z', 'g^4C\\p\Z', 'ݺM.bz9\r=~ȉ#O', '', 0, '?'),
 ('g,7Mc|@j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_place_24px.svg', 0, 'I}Ԛ^޵Q\Zw', 'I}Ԛ^޵Q\Zw', '\\]:0cA7kT`	(\0', '', 0, '?'),
 (',&\\DG ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_rate_review_24px.svg', 0, 'Mb:h~}*\\Yt', 'Mb:h~}*\\Yt', 'KlOo̠YǮcKBy]39', '', 0, '?'),
 ('Q:7?%?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_restaurant_menu_24px.svg', 0, 'kxxj@h3G', 'kxxj@h3G', '¿Sx>F4j,7ϵlX2]_', '', 0, '?'),
 ('>E<ќc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_satellite_24px.svg', 0, 'Aw..AEC.ȃ', 'Aw..AEC.ȃ', 'NJފuz8	R3Cե', '', 0, '?'),
 ('Mi?dֿ\0c_u', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_store_mall_directory_24px.svg', 0, 'Cؗ5D=_E', 'Cؗ5D=_E', 'TW+ݳ4\r$Y.&}\0v', '', 0, '?'),
 ('.&]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_terrain_24px.svg', 0, 'Dp\0)[Y', 'Dp\0)[Y', 'E酲.~I/tKޖDXy{E', '', 0, '?'),
 ('֢~7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_traffic_24px.svg', 0, 'H@hO#Y)', 'H@hO#Y)', '	6`܀*oQXR\Zwk\'Fd!', '', 0, '?'),
 ('zp+Zj\'lo', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_zoom_out_map_24px.svg', 0, '`6c-dO_', '`6c-dO_', 'ط*i?5}@Nzi`QSƆƓ8TGL', '', 0, '?'),
 ('W{ӈo', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_apps_24px.svg', 0, '|{->9*x', '|{->9*x', 'PH\'! N30k\'\'Z?kOWG', '', 0, '?'),
 ('D-hnD T{', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_apps_36px.svg', 0, ';?bXƿ\\', ';?bXƿ\\', '3CJ;C]Q+FngCʝt', '', 0, '?'),
 ('Xd@~괗', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_back_24px.svg', 0, '~ThO', '~ThO', '0se]\nIܬ/:chmO#', '', 0, '?'),
 (' ^5-㌃', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_back_36px.svg', 0, 'B?.GwgP', 'B?.GwgP', 'BNǃV[Q@J2c8B!\r8Nt', '', 0, '?'),
 ('lUe)<]&~6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_downward_24px.svg', 0, 'Zm) -!A', 'Zm) -!A', 'QPdJws*jZl}[	u\"Z', '', 0, '?'),
 ('툿MW0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_24px.svg', 0, '!H293T', '!H293T', 'y|UpD<tnh7e,', '', 0, '?'),
 ('Yb', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_36px.svg', 0, 'p[6Rxk`+0-B', 'p[6Rxk`+0-B', 'k2Z0G6D^@0|U', '', 0, '?'),
 (')B9C@.Lb', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_circle_24px.svg', 0, '\\7b', '\\7b', 'Bkt`g_TȌuAP:͙^@d', '', 0, '?'),
 ('\0R[Yq1', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_24px.svg', 0, 'A,t\02l!', 'A,t\02l!', '͇\'BS\'#ȧ7ݵ$#QTLdNMcr', '', 0, '?'),
 ('672g1g', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_36px.svg', 0, '!uVsX', '!uVsX', 'Z$<0DXU尧!~9T', '', 0, '?'),
 ('R]<%%^$sy\Z^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_24px.svg', 0, 'h)㕑SK', 'h)㕑SK', '䧙*\'B3xZgB)cw	>F9y', '', 0, '?'),
 ('ŋfKHOD', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_36px.svg', 0, 'SA@g', 'SA@g', '\"6=A<ӦŹ)\"E', '', 0, '?'),
 ('6F', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_upward_24px.svg', 0, 'ɈB2cj\r>4', 'ɈB2cj\r>4', ']/7s{wsif`IQwV,\"J', '', 0, '?'),
 ('<v|d:N', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_cancel_24px.svg', 0, 'B.RpcR1[q', 'B.RpcR1[q', 'i?MOQz3翖$.|;fk', '', 0, '?'),
 ('$BDC24_g]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_cancel_36px.svg', 0, '4TvW4', '4TvW4', ' XK#f O|[\n', '', 0, '?'),
 ('R]:g:湖K', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_check_24px.svg', 0, 'K;\"6\ZGpʟ', 'K;\"6\ZGpʟ', '~}U*^5\0!1^čHl39a', '', 0, '?'),
 ('`ϫwGCV5~w%MX', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_check_36px.svg', 0, 'k,ZM6C', 'k,ZM6C', ' vH+T˶8(yeAn', '', 0, '?'),
 ('.ovY=ڃ8`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_left_24px.svg', 0, 'իr)', 'իr)', '^^Ղ{;O՝tHbBBO]U\nv', '', 0, '?'),
 ('u#ɜ3g9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_left_36px.svg', 0, '*_c6aѫ[oq7', '*_c6aѫ[oq7', 'M5XhDd?tYꁥb2:|1J.', '', 0, '?'),
 ('ll5', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_right_24px.svg', 0, '/3\\-%C', '/3\\-%C', 'Ɉ>5~D.51ōݿ@8KiRrK\'', '', 0, '?'),
 ('tw\n32', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_right_36px.svg', 0, 'dblj*s', 'dblj*s', 'ww X\0O@Hd2[{sNi', '', 0, '?'),
 ('.U\\)yuBd+^k0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_close_24px.svg', 0, 'F_\Zd\"', 'F_\Zd\"', 'MrY5tJ$YI ?^', '', 0, '?'),
 ('ͩfJ!Py', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_close_36px.svg', 0, '7\">.}}\ZB?P4N', '7\">.}}\ZB?P4N', 'ˉåBhPZ@?vF)更16', '', 0, '?'),
 ('f~?J+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_less_24px.svg', 0, 'C`B9ߟV,', 'C`B9ߟV,', 'rb=PtlC5wdNyLaR~Uk', '', 0, '?'),
 ('kNrG/^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_less_36px.svg', 0, 'bwk$I(#b/', 'bwk$I(#b/', 'b7Si]p,!iQX}03ߩTCh', '', 0, '?'),
 ('GՏT', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_more_24px.svg', 0, 'wDzNv#Lηl', 'wDzNv#Lηl', '$\nV?H\ra2G	(\"Uz<U:', '', 0, '?'),
 ('\"\r\\H', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_more_36px.svg', 0, 'ܟtio', 'ܟtio', '(GRꊢjR;c\ZUDvc', '', 0, '?'),
 ('|x!U	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_24px.svg', 0, '\'!.L|*', '\'!.L|*', 'Թ?e\\\rHȔ#k!vj^z+', '', 0, '?'),
 ('bjǦBXm', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_36px.svg', 0, '\'_|<%Kx]u', '\'_|<%Kx]u', 'K;j4kN\"6;@AV|SS', '', 0, '?'),
 ('\Z?Tq5O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_24px.svg', 0, 'OsTJ٪g', 'OsTJ٪g', '+ۑ=qDX3d,!', '', 0, '?'),
 ('ps1j+ob\r', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_36px.svg', 0, 'L:F&g', 'L:F&g', '9(SjB[sR첍\\\Z!k', '', 0, '?'),
 ('xDu0ˮq=OIA', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_menu_24px.svg', 0, ' Oa7M[|', ' Oa7M[|', 'yEmqц)G+#wZ4ݹ', '', 0, '?'),
 ('.\0l6&}zb+?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_menu_36px.svg', 0, ')VS=G(,', ')VS=G(,', ']ÖLduɒyI,3', '', 0, '?'),
 ('\\F[snk0@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_horiz_24px.svg', 0, '\"݊Il9knٛ', '\"݊Il9knٛ', 's	!E\\)|܇R!4Zg̃', '', 0, '?'),
 ('*\0~cb%e	\n+', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_horiz_36px.svg', 0, '44gd3&', '44gd3&', 'Ն^dx}yI04\03,EAU', '', 0, '?'),
 ('\0(s|Y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_vert_24px.svg', 0, 'lx1%f', 'lx1%f', 'Ha\'2 \\RF\rݴ2-', '', 0, '?'),
 ('ll[w', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_vert_36px.svg', 0, '6=[', '6=[', '7h+^j*\n(\n\\ G*pCP', '', 0, '?'),
 ('#&fKWoQ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_refresh_24px.svg', 0, 'aw\r}O\rqsEP\0U@H', 'aw\r}O\rqsEP\0U@H', 'Hn;XNei@VDH-ܱ$\'NV', '', 0, '?'),
 ('F\Z!P΋gSR', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_refresh_36px.svg', 0, 'z٤*gb', 'z٤*gb', '#ON4OG,\0ۢQ,4_5k[P)', '', 0, '?'),
 ('\\YV-z%z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_left_24px.svg', 0, 'M0dx.5', 'M0dx.5', 'f/xq\0Z|Li[)]', '', 0, '?'),
 ('-&w]Le\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_right_24px.svg', 0, 'ͷEɻJE7', 'ͷEɻJE7', '@_\'h%BüO?B\'', '', 0, '?'),
 ('!SD@]Y}S-3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_less_24px.svg', 0, 'vT\'vD', 'vT\'vD', 'Y-3{?M#\"udE', '', 0, '?'),
 ('p%V6NRJ%%0B@', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_less_36px.svg', 0, '1C)$[{', '1C)$[{', 'uyζ`Ɣvܸ\ZYdUT&\Zf', '', 0, '?'),
 ('OmzѪ0R.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_more_24px.svg', 0, 'a%-~uh', 'a%-~uh', 'qBW==GL],c+t*W', '', 0, '?'),
 ('0:ܧs\rH', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_more_36px.svg', 0, '1s4UW`jF', '1s4UW`jF', '6p:ȋN$Y\"2kgMc!	(', '', 0, '?'),
 ('n\nЭVaD.If\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_adb_24px.svg', 0, '#jVILts@', '#jVILts@', 'ߑ5Pǔg1YGq*}\r\nr%L', '', 0, '?'),
 (']QdQ	ܫ%[', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_24px.svg', 0, 'Y\r~Px', 'Y\r~Px', 'ѳ^մbpFNQؚ_f39Jt', '', 0, '?'),
 ('n4Ƀ/', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_angled_24px.svg', 0, '|l]ɹdf', '|l]ɹdf', '}Ϟ.ܗk,/y-Qj7W3', '', 0, '?'),
 ('UiqSB', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_individual_suite_24px.svg', 0, '{,q<+\'', '{,q<+\'', 'MMU4@VxG0V\rp&/N}', '', 0, '?'),
 ('LXAt:\\!>W', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_extra_24px.svg', 0, '#JY*\"V', '#JY*\"V', 'laqNNN،\Z=کl', '', 0, '?'),
 ('DZ@q\"&c-iA\"M\Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_normal_24px.svg', 0, '&FqiiЃu8', '&FqiiЃu8', '`	\nsF:1cq*s\0u', '', 0, '?'),
 ('AEKhnW', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_reduced_24px.svg', 0, 'R<hd', 'R<hd', ':KgU\r{An1ٻjO,', '', 0, '?'),
 ('>~3I[+d4Az,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_extra_24px.svg', 0, '3XѶG	\ZQ', '3XѶG	\ZQ', '%Ax%8_MS/)LfkJh`F', '', 0, '?'),
 ('di@{ǔ8m', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_normal_24px.svg', 0, '*I\"I[', '*I\"I[', 'ͦŉ!Uw]sVHI~%/', '', 0, '?'),
 (' g-&s', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_bluetooth_audio_24px.svg', 0, 'c\r;Ǐ_', 'c\r;Ǐ_', '>TV\nC~8LOɁYvK˶De\'%', '', 0, '?'),
 ('RzG+\"}DV8Ĥ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_confirmation_number_24px.svg', 0, '܄4\\t_', '܄4\\t_', '*),$	O*>p07g\'Q6\0Z', '', 0, '?'),
 ('IP;\"!Ù', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_disc_full_24px.svg', 0, '+Փv2', '+Փv2', 'xڮg7,.o<5Pf4]rK', '', 0, '?'),
 ('7.rYk&||Z', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_24px.svg', 0, '0}} w', '0}} w', '幑姥6wXK]I;x4', '', 0, '?'),
 ('ybm՚^_#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_alt_24px.svg', 0, '0)u)m', '0)u)m', 'hz?딡s;1Wk\"D͟', '', 0, '?'),
 ('3pIZrTV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_drive_eta_24px.svg', 0, ']g>p~ܼv', ']g>p~ܼv', 'P,tZ%WDxW@Ow`Z,/', '', 0, '?'),
 (';Liȱ¾\\', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_enhanced_encryption_24px.svg', 0, 'VZSF[/n', 'VZSF[/n', '!<Y%TnrU?UPI2', '', 0, '?'),
 ('5sG\"@Fv', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_event_available_24px.svg', 0, 'ANȭ_0ԭ\ZD̢', 'ANȭ_0ԭ\ZD̢', ')F2%z\'0:2u$\r1E', '', 0, '?'),
 ('k&S |:j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_event_busy_24px.svg', 0, 'v&/gͣC', 'v&/gͣC', 'Tg9B9)pYvJ', '', 0, '?'),
 ('gCD^e`5$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_event_note_24px.svg', 0, '\"fOFX', '\"fOFX', '9-Z]ۨm2ECcKO*KB:S', '', 0, '?'),
 (' +', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_folder_special_24px.svg', 0, 'z7sU]>#', 'z7sU]>#', 'ەՎposf\Zw\0$sPmEԛ&', '', 0, '?'),
 ('+E2`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_live_tv_24px.svg', 0, 'LŻeư', 'LŻeư', 'hfЉ\ZYc+Cϡ &֦', '', 0, '?'),
 ('4^_d/-Ŗ*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_mms_24px.svg', 0, '~&Qăpt8Zo', '~&Qăpt8Zo', '`8q4?sBzK97N1^;X', '', 0, '?'),
 ('#AE\nFjZm', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_more_24px.svg', 0, 'G%Yav\"B', 'G%Yav\"B', ';NhG<\\u#P2t@r(h]EN\0', '', 0, '?'),
 ('@3m&7qIS', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_network_check_24px.svg', 0, 'wu) H', 'wu) H', 'O]*1Ck\0&g5םt', '', 0, '?'),
 ('HKj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_network_locked_24px.svg', 0, 'V|S LOƝre', 'V|S LOƝre', '-aK /hJ\0Xr7pZ΃z#', '', 0, '?'),
 ('j.NUZ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_no_encryption_24px.svg', 0, '|)djO~l	Z', '|)djO~l	Z', '\"ŀIq6yeS[z<\0V3·Yn ~B@', '', 0, '?'),
 ('{%\0uXq pg', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_ondemand_video_24px.svg', 0, ';̄r9n', ';̄r9n', 'Hr+0Ow#bCD=mkҍ\'|', '', 0, '?'),
 ('8p^_`q#$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_personal_video_24px.svg', 0, 'Kh}e;gĲwU', 'Kh}e;gĲwU', '?dz2`~v\ZQ1خ*Ҕqd', '', 0, '?'),
 ('|x5m30', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_bluetooth_speaker_24px.svg', 0, 'ҞlGnNv(/', 'ҞlGnNv(/', 'ST;`L;$uPd:\Zgf\r', '', 0, '?'),
 ('etT>7|D7', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_forwarded_24px.svg', 0, '(Kmx};`y|J', '(Kmx};`y|J', '=Y8n-[\r%N%|DDmZ	K{', '', 0, '?'),
 ('|!6e1l_', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_in_talk_24px.svg', 0, 'fbǤ(Mus', 'fbǤ(Mus', 'lͤzxӞd_[%g1eKHrJD4', '', 0, '?'),
 ('].owBMo8pCf', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_locked_24px.svg', 0, 's\r)߄_', 's\r)߄_', '$h\0zHH	C5&cy6', '', 0, '?'),
 ('ϧnBW;TC', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_missed_24px.svg', 0, 'pCTul', 'pCTul', 'rԸm%\nDp	?\n3', '', 0, '?'),
 ('ߢ&8_U', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_paused_24px.svg', 0, '\r\"2=3v$', '\r\"2=3v$', '|\03k9RIJ]g!Pkn', '', 0, '?'),
 ('5B,İ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_power_24px.svg', 0, '`p.*', '`p.*', '\ZO&h4nܲQ	', '', 0, '?'),
 ('R׾1-', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_rv_hookup_24px.svg', 0, 'U9rm7D\"C', 'U9rm7D\"C', '$0M[\'+`Bŗu6[RY', '', 0, '?'),
 ('jGK(B)Uc', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sd_card_24px.svg', 0, '$NoIgB', '$NoIgB', 'gl 7IՁA=', '', 0, '?'),
 ('lA!jZ\n,7\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sim_card_alert_24px.svg', 0, '0N\r\'0M8~W', '0N\r\'0M8~W', '\n1k%fE%P	gzxڹ', '', 0, '?'),
 ('0OBx>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sms_24px.svg', 0, 'R5!6/!+', 'R5!6/!+', '\\s\nm;{s(\nC(E8\'+\n', '', 0, '?'),
 ('!ULF797ؕRul', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sms_failed_24px.svg', 0, '?ә`EC	-,p', '?ә`EC	-,p', 'c3\rmpi	2S8;h	mz', '', 0, '?'),
 ('*z\0M˯O', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sync_24px.svg', 0, 'r/2%&.V', 'r/2%&.V', 'h)u⬉!{G\0\0\0xY#iDV', '', 0, '?'),
 ('Gi?', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sync_disabled_24px.svg', 0, 'wɺOn', 'wɺOn', '6V0V	\"\'?7X6', '', 0, '?'),
 ('Kw帬`#', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sync_problem_24px.svg', 0, '\n¶wd߻My', '\n¶wd߻My', '=dR]=<ɃwưYVfZ\Z?', '', 0, '?'),
 ('\Zd4h', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_system_update_24px.svg', 0, 'C.BjmiǷ', 'C.BjmiǷ', 'ttNGytJ5o X', '', 0, '?'),
 ('JK_cWh%)', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_tap_and_play_24px.svg', 0, 'hj_ΎٿEA', 'hj_ΎٿEA', 'I|І$Ƨ~ax]m76	$k', '', 0, '?'),
 ('w,鸇*', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_time_to_leave_24px.svg', 0, ']g>p~ܼv', ']g>p~ܼv', 'P,tZ%WDxW@Ow`Z,/', '', 0, '?'),
 ('d)zV+9', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_vibration_24px.svg', 0, 'j%+qX9CV', 'j%+qX9CV', '\"g\Z2<n\r<4+NL#', '', 0, '?'),
 ('](\0DFn=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_voice_chat_24px.svg', 0, ';vXg8', ';vXg8', ':jm|o	τX6{x<va@n', '', 0, '?'),
 ('ח%6 ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_vpn_lock_24px.svg', 0, '-j9:D:E^', '-j9:D:E^', 'JUXFGTm[p32#', '', 0, '?'),
 ('99Lr0K[V=', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_wc_24px.svg', 0, 'uJۂiNg', 'uJۂiNg', 'CNjנ9ZݐGv\"', '', 0, '?'),
 ('$-\ZVY^', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_wifi_24px.svg', 0, 'V=Bj2gUA', 'V=Bj2gUA', '!7v4V>A[dT36|\r\0', '', 0, '?'),
 ('fȾL(ͩ2<\Zy', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_ac_unit_24px.svg', 0, '?`vzs>>', '?`vzs>>', '@~ę:vYO{y3,@t', '', 0, '?'),
 ('9.Ƭеc\0', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_airport_shuttle_24px.svg', 0, 'M6U^-\ZP', 'M6U^-\ZP', '!юtkvfh^5vNJ!#&', '', 0, '?'),
 ('x\0OI|\0n۫@X', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_all_inclusive_24px.svg', 0, '=\\iqw', '=\\iqw', 'MJ\\r\Zŏ߹nkoZ4', '', 0, '?'),
 (')uA2AV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_beach_access_24px.svg', 0, 'xIb3', 'xIb3', 'tG\r#lĺC*Lxg;jn', '', 0, '?'),
 ('~1܈ʣA`', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_business_center_24px.svg', 0, '8f΃8sؓJ', '8f΃8sؓJ', '@*VK\0\0S^\'Mؘ', '', 0, '?'),
 ('_#:V?<', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_casino_24px.svg', 0, 'de@b3l', 'de@b3l', 'P)\nNXݕ>-\\U.s2˭', '', 0, '?'),
 ('֭eU,', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_child_care_24px.svg', 0, 'd>+`', 'd>+`', 'NIZtmlIPjG^$Ax', '', 0, '?'),
 (':I_J/K', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_child_friendly_24px.svg', 0, '\":X?&\\c', '\":X?&\\c', 'Iw.djH:q]9-Y&M\'q', '', 0, '?'),
 ('^A-kV', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_fitness_center_24px.svg', 0, '2@[e#WO', '2@[e#WO', '~:N\\\0rtc2p	hF%Q7-', '', 0, '?'),
 ('%%RYλS', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_free_breakfast_24px.svg', 0, 'Cc\ndb,_֨', 'Cc\ndb,_֨', 'H9仹nCobo/hl', '', 0, '?'),
 ('&y	&ؔ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_golf_course_24px.svg', 0, '91Fkm[҅U', '91Fkm[҅U', 'lĠ6;\rlט/\Z_^&v]\\7yG', '', 0, '?'),
 ('X\"', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_hot_tub_24px.svg', 0, 'Pƭ_bNUc]z', 'Pƭ_bNUc]z', '.pA+Qvge]	\'V\"{}', '', 0, '?'),
 ('|-Ю螘\\9%\"2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_kitchen_24px.svg', 0, 'nI\\FB&hF', 'nI\\FB&hF', '\"W=y$4wM@T>', '', 0, '?'),
 ('sƒ\r\Z%', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_pool_24px.svg', 0, '$3N|jY', '$3N|jY', 'ra`Uc:Yoj\Z\\&.[', '', 0, '?'),
 ('ӹe4S8d', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_room_service_24px.svg', 0, '$!Mk(', '$!Mk(', '?ڹi&uV\'C\rGTEZ\"', '', 0, '?'),
 ('3e|Ӓْ>', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_smoke_free_24px.svg', 0, 'cyʂNdf', 'cyʂNdf', '{NKVg⋭4]+\'0絏', '', 0, '?'),
 ('/	9{Q&MU#(', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_smoking_rooms_24px.svg', 0, 'Jt5|LGU', 'Jt5|LGU', 'ֺ6sa[3(]AH$25w0', '', 0, '?'),
 ('pَ>d?X', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_spa_24px.svg', 0, '\\it}]G䄟(', '\\it}]G䄟(', '51YxY=ICSx(', '', 0, '?'),
 ('sp<Bmժ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_cake_24px.svg', 0, '&m\ZF:>2O`\\', '&m\ZF:>2O`\\', 'a3kWSAM\\3^ƹH', '', 0, '?'),
 ('ldBnBd', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_domain_24px.svg', 0, '!lIWH<Y', '!lIWH<Y', 'n@q=ТA]VJRՖҷM%yA', '', 0, '?'),
 ('W@(x.Sn', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_group_24px.svg', 0, 'LbshGn ', 'LbshGn ', 'Pe[FyƟ6VQwW^', '', 0, '?'),
 ('\Z1xVCii', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_group_add_24px.svg', 0, '\\c:p', '\\c:p', 'o7ہnH&K>P@~\'!DKSRƇ', '', 0, '?'),
 ('V(jqIC?1&O~', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_location_city_24px.svg', 0, '` BGNYh:O', '` BGNYh:O', ' ß>6K\\ֲ~H˿Xgf', '', 0, '?'),
 ('\0Q5(j͵ܫW', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_mood_24px.svg', 0, 'l!qM+x k-', 'l!qM+x k-', '\0ꧤ^vޕO͍rr0#t', '', 0, '?'),
 ('\n4\rk	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_mood_bad_24px.svg', 0, 'ƫPff\'', 'ƫPff\'', '%Z06HJr#ͩ\\jOUíw', '', 0, '?'),
 ('r#&b{A~(', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_24px.svg', 0, 'R](w٧n', 'R](w٧n', 'eo>yg\\PK34+we\0', '', 0, '?'),
 ('y)Gu:M2X8', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_active_24px.svg', 0, ' *g)d', ' *g)d', ']p46,.VM~=n-\'', '', 0, '?'),
 ('ZܙA<\r\rY', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_none_24px.svg', 0, '\\=.>VB|\Z', '\\=.>VB|\Z', '\\\\3N1Ka,+?Wʋ\0', '', 0, '?'),
 ('K@1T]B^j', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_off_24px.svg', 0, 'yOi.u.>', 'yOi.u.>', '$ZpyfNOGN@c', '', 0, '?'),
 ('\00XM·X.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_paused_24px.svg', 0, 'k]gGHv+', 'k]gGHv+', '5TLykzLc6	!Nެ\",Ӹ', '', 0, '?'),
 ('2T?Ff6y', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_pages_24px.svg', 0, 'H֑\"Xo3S	', 'H֑\"Xo3S	', 'uY*DS6/#\r{gDm d\0', '', 0, '?'),
 ('HZR2#[', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_party_mode_24px.svg', 0, '0^0', '0^0', 'VV%oHKմYL', '', 0, '?'),
 ('_L;s_OM', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_people_24px.svg', 0, 'LbshGn ', 'LbshGn ', 'Pe[FyƟ6VQwW^', '', 0, '?'),
 ('4f.KPM)3', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_people_outline_24px.svg', 0, ',:,^BVm', ',:,^BVm', 'Uԋhy0F9zUp| ij\0', '', 0, '?'),
 ('%Lbdw', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_person_24px.svg', 0, 'mxn]}0mW', 'mxn]}0mW', 'G#nk\'RMm+\02,', '', 0, '?'),
 ('c8Y2', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_person_add_24px.svg', 0, '\\*s2*I', '\\*s2*I', 'ڵ8-Jaˑ}%Qk', '', 0, '?'),
 ('y|w]', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_person_outline_24px.svg', 0, '@Ĥu@u\\', '@Ĥu@u\\', 'uك#spO_=NAbmt6', '', 0, '?'),
 ('x\'Qy;a', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_plus_one_24px.svg', 0, 'awަiH', 'awަiH', '\r	fL`*:NB!*3gg', '', 0, '?'),
 ('4_*+VPހ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_poll_24px.svg', 0, '*5\":(;7+', '*5\":(;7+', 'aO;L;_)~ԍ?ഥ:', '', 0, '?'),
 ('h^&\nPW!MD6', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_public_24px.svg', 0, '٩CC*Ty;', '٩CC*Ty;', 'pRZJ%Q)_8b1(', '', 0, '?'),
 ('\ZyN$', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_school_24px.svg', 0, 'v {_([', 'v {_([', 's孹`	N~8҃˅	\noQ', '', 0, '?'),
 ('\\kA>\Z3YpJ', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_share_24px.svg', 0, 'D}	#;>iQ', 'D}	#;>iQ', 'IMݻtOϓzOeO\ZzIP', '', 0, '?'),
 ('u\Zox\'zIh', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_whatshot_24px.svg', 0, '4,8cc+J', '4,8cc+J', '2_Moe,83Nv3H!', '', 0, '?'),
 ('6b', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_check_box_24px.svg', 0, 'R89\0v', 'R89\0v', 'n߈TcQF/YOΙGđ', '', 0, '?'),
 ('~<c:KR.', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_check_box_outline_blank_24px.svg', 0, 'b!\nd\ZH@', 'b!\nd\ZH@', 'f	9`c-xd+.v{\'', '', 0, '?'),
 ('+Yֆ䣖_ʾ	', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_indeterminate_check_box_24px.svg', 0, 'Oq%yEIfc', 'Oq%yEIfc', '/mήpU&ֺ~qqW', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('a\"3Q', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_radio_button_checked_24px.svg', 0, '/$O\\FДcRGk', '/$O\\FДcRGk', '$lP6֗\"sxN1EX6	0 ', '', 0, '?'),
 ('Ou;df', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_radio_button_unchecked_24px.svg', 0, 'BWVYC>\n\"U', 'BWVYC>\n\"U', 'c&xO|ޛcaibg=w|5', '', 0, '?'),
 ('~csԡ$dj', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_star_24px.svg', 0, '<M7Ty~OJio', '<M7Ty~OJio', 'ͨigΐgOx8lĵ', '', 0, '?'),
 ('ЬL', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_star_border_24px.svg', 0, 'Z^(D1', 'Z^(D1', 'ijN*7dt5ِ#+,\0\"', '', 0, '?'),
 ('U_cp;N0WB', 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_star_half_24px.svg', 0, 'b ~?ZY', 'b ~?ZY', '\ZP8đCdy~({2Q', '', 0, '?'),
 (']B\"', 'wp-content/updraft/plugins-old/revslider/public/assets/css/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('Acg5', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/font-awesome/fonts/fontawesome-webfont.svg', 0, '.murI1G', '.murI1G', 'Lr7D@yɂ]NK(tiG9Tm=', '', 0, '?'),
 (' >I/):', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/font-awesome/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('r\'v_sR,#y	', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('P#JBJ8vF', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/material/MaterialIcons-Regular.svg', 0, 'eYLP/(:', 'eYLP/(:', '坴YCN:Q9kdZkxO', '', 0, '?'),
 ('mPa-ޥ=Tv\\', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/css/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('=1	n:\08/J', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.svg', 0, '&x<fJ`Ml', '&x<fJ`Ml', '7oϲ`w!=FJ ]Ү²', '', 0, '?'),
 ('!^`LImfտ', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('ޱFrp.98', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('m$X]	`', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/revicons/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('aAE^ҲP*U', 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/revicons/revicons.svg', 0, 'BT }9O', 'BT }9O', ',:4^a{rrC\":9\"n*', '', 0, '?'),
 ('ő\0', 'wp-content/updraft/plugins-old/revslider/public/assets/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('r 1;S', 'wp-content/updraft/plugins-old/revslider/public/assets/js/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('ЖnEy6', 'wp-content/updraft/plugins-old/revslider/public/assets/js/rbtools.min.js', 0, 'wwoOpz]nX', 'wwoOpz]nX', '%[a*ky6)6ߨ?̇', '', 0, '?'),
 ('{;Her:I', 'wp-content/updraft/plugins-old/revslider/public/assets/js/rs6.min.js', 0, 's8Pv', 's8Pv', 'mzj)5Yu\Zz,D;\"0X', '', 0, '?'),
 ('$5x6c!', 'wp-content/updraft/plugins-old/revslider/public/includes/functions-public.class.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('~hrwIvG1', 'wp-content/updraft/plugins-old/revslider/public/index.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('z\rmo.*:dc', 'wp-content/updraft/plugins-old/revslider/public/revslider-front.class.php', 0, 'jz(ߴH=:,', 'jz(ߴH=:,', 'ܙX\rKܚm[D1u', '', 0, '?'),
 ('SI~nPB3C', 'wp-content/updraft/plugins-old/revslider/public/views/revslider-page-template.php', 0, 'Hw[<P|V', 'Hw[<P|V', '\\JgKnd&S盛2|w)^%kVΜR', '', 0, '?'),
 ('kؼzy-D0', 'wp-content/updraft/plugins-old/revslider/release_log.html', 0, '?x^Yx', '?x^Yx', 'E1̑53d]8[.|V', '', 0, '?'),
 ('il08\":\n', 'wp-content/updraft/plugins-old/revslider/revslider.php', 0, '>?\0ЋêAB', '>?\0ЋêAB', 'XT^L\nnB;Rch=', '', 0, '?'),
 ('(~EW#8', 'wp-content/updraft/plugins-old/revslider/uninstall.php', 0, 'ﵯM\"{@]q(', 'ﵯM\"{@]q(', '(5\rHq\n-wWci{k,{', '', 0, '?'),
 ('֫Jc˕DkT', 'wp-content/updraft/plugins-old/revslider/welcome.html', 0, '!ֳUS|vӂ', '!ֳUS|vӂ', 'aU1gն\Zɓmn', '', 0, '?'),
 ('+ܒj*}\0	S', 'wp-content/updraft/plugins-old/updraftplus/admin.php', 0, '((6hIys', '((6hIys', 'pgoO+u_t\'N?ma^\r', '', 0, '?'),
 ('ϭ!:c2tp', 'wp-content/updraft/plugins-old/updraftplus/backup.php', 0, '1ޣ(% PY?H', '1ޣ(% PY?H', 'Q[Q@jX,b6Vڀ', '', 0, '?'),
 ('o̐', 'wp-content/updraft/plugins-old/updraftplus/central/bootstrap.php', 0, 'DPa\rtAxx', 'DPa\rtAxx', ']SB`z>M׮+-~%8 +)Td', '', 0, '?'),
 ('-x\"귺9P\'+', 'wp-content/updraft/plugins-old/updraftplus/central/classes/automatic-upgrader-skin-compatibility.php', 0, 'ɼUŬ)@', 'ɼUŬ)@', ';BYB`z\'i	hIv}jG', '', 0, '?'),
 ('}d&-%S', 'wp-content/updraft/plugins-old/updraftplus/central/classes/class-automatic-upgrader-skin.php', 0, 'Z\r<7DJ,Z', 'Z\r<7DJ,Z', 'უNW0spZAV1[hq^', '', 0, '?'),
 ('8&|Ώ', 'wp-content/updraft/plugins-old/updraftplus/central/commands.php', 0, '0K_W#', '0K_W#', 'ȫ|gjًM>2rl', '', 0, '?'),
 ('aaQۊ ', 'wp-content/updraft/plugins-old/updraftplus/central/listener.php', 0, 'W/71?J', 'W/71?J', 'W{R{<1aVh7SIck,G', '', 0, '?'),
 ('۾xa{!tQ./', 'wp-content/updraft/plugins-old/updraftplus/central/modules/analytics.php', 0, 'X\'x3q', 'X\'x3q', 'Lj64E42dp\Z{쯂', '', 0, '?'),
 ('^M#SfGmp', 'wp-content/updraft/plugins-old/updraftplus/central/modules/comments.php', 0, 'US\r1Ff', 'US\r1Ff', ':+u[i@$', '', 0, '?'),
 ('o]nM:b', 'wp-content/updraft/plugins-old/updraftplus/central/modules/core.php', 0, 'L(q(\02yyv', 'L(q(\02yyv', 'Z#@.;xnRt׷Ii3bk', '', 0, '?'),
 ('59X1xB', 'wp-content/updraft/plugins-old/updraftplus/central/modules/media.php', 0, 'x1G׏R', 'x1G׏R', 'pO]!Kh^NeCGԕJ[*fI-', '', 0, '?'),
 ('0z%*/J6y', 'wp-content/updraft/plugins-old/updraftplus/central/modules/plugin.php', 0, 'otƫHk濁', 'otƫHk濁', '_n#مO6\Zxf~?\'', '', 0, '?'),
 ('fSZƠ\'jW \"1', 'wp-content/updraft/plugins-old/updraftplus/central/modules/posts.php', 0, 'yp:f e*+\n', 'yp:f e*+\n', 'RmH4=Fy3/t̹', '', 0, '?'),
 ('{/6*]', 'wp-content/updraft/plugins-old/updraftplus/central/modules/theme.php', 0, ']Ad=K', ']Ad=K', 'p(6-z>F+Mޠ,}q#', '', 0, '?'),
 ('&B9JȨ', 'wp-content/updraft/plugins-old/updraftplus/central/modules/updates.php', 0, ';n!I@{2', ';n!I@{2', '`1SR!S}XRF', '', 0, '?'),
 ('pB>V8P', 'wp-content/updraft/plugins-old/updraftplus/central/modules/users.php', 0, 'wv\'H:jP', 'wv\'H:jP', 'Ex$m${u&$;f', '', 0, '?'),
 ('is6c&*!o2', 'wp-content/updraft/plugins-old/updraftplus/class-updraftplus.php', 0, 'wĴ4I0<*', 'wĴ4I0<*', 'H\n&\0Lڂ|-:;\\PuTg', '', 0, '?'),
 ('͹m`˜mQ', 'wp-content/updraft/plugins-old/updraftplus/example-decrypt.php', 0, 'U8d#:#', 'U8d#:#', 'iM,;-4)yͼj5w', '', 0, '?'),
 ('];<*Yƭ!x', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/API.php', 0, '45&U{t=', '45&U{t=', 'q.ƚ,y:8[zj\'', '', 0, '?'),
 (':7]Y}', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/Exception.php', 0, 'U$af*on', 'U$af*on', 's%Ծ;-JǼ/p f', '', 0, '?'),
 ('R\ZǛy\'\r', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Consumer/ConsumerAbstract.php', 0, 'dy\0^\"=', 'dy\0^\"=', 's.N%	k\rlG!<QH#g:S', '', 0, '?'),
 ('c~fVX&bMi', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Consumer/Curl.php', 0, 'bE!!i<', 'bE!!i<', 'R5}%NxT\03/okrc<G', '', 0, '?'),
 ('R-XPpӯN_', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Consumer/WordPress.php', 0, 'syqFWT\rҮ', 'syqFWT\rҮ', 'Ēܠ5T.:{\Zk[Ze~', '', 0, '?'),
 ('_6X)', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Storage/Encrypter.php', 0, 'j}Ӹ=EV5\0', 'j}Ӹ=EV5\0', 'VLaAQ#`1w\ZnRI	nLaz', '', 0, '?'),
 ('fBBXE', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Storage/StorageInterface.php', 0, 'Wb\\9', 'Wb\\9', 'zQz=UZjD9', '', 0, '?'),
 ('\\,zvB6{', 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Storage/WordPress.php', 0, 'q,S볘ր!', 'q,S볘ր!', '*7^b_(åv#f{	&', '', 0, '?'),
 ('AދuIx', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/Abstract.php', 0, ']r31Vp=', ']r31Vp=', 'oȉϵ>\Z&!:', '', 0, '?'),
 ('GBp63ђ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/AppIdentity.php', 0, 'e\n	jwեM0', 'e\n	jwեM0', '<L3ojP̲Ƴ/`P@u$OC(', '', 0, '?'),
 ('qd$]eCׅZ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/AssertionCredentials.php', 0, '2|va=ϧ]޼', '2|va=ϧ]޼', '\\\0\Z@ږޕq+PǮg', '', 0, '?'),
 ('E\09=u\'\0`', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/ComputeEngine.php', 0, 'HLʘXs)r', 'HLʘXs)r', 'A|9vqBN-2Uxa', '', 0, '?'),
 ('1m2U', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/Exception.php', 0, '(^A+ Cr', '(^A+ Cr', 'of#+{0_06hYTZ5N6', '', 0, '?'),
 (':\rd:|)x', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/LoginTicket.php', 0, '!+\\)3a\nc', '!+\\)3a\nc', '#Plݔ|-<$LsQP6DU-', '', 0, '?'),
 ('WbK>\"_', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/OAuth2.php', 0, ';z*N4냗Ʉw@', ';z*N4냗Ʉw@', 'Ɵǃum<5HGI/;9kxO/ٛ', '', 0, '?'),
 ('@6	7(\nw', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/Simple.php', 0, 'Phx3X\"6', 'Phx3X\"6', ' UÜ+Pb-\\@sc?#q;kr', '', 0, '?'),
 ('#:I\r\r (', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Abstract.php', 0, '\0]\'9w', '\0]\'9w', ';DK[#3&W<ԏzAQ$x', '', 0, '?'),
 ('\rQ/Ap\"p+', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Apc.php', 0, 'JY^V*JǱ^', 'JY^V*JǱ^', 'w;QQ3[oZWvtiVI?', '', 0, '?'),
 ('aLDd', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Exception.php', 0, 'Ur*vOxqf', 'Ur*vOxqf', 'KW4&]atpGh\r圫', '', 0, '?'),
 (',UeZz ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/File.php', 0, 'VQ~l<$T', 'VQ~l<$T', '$tE\0HBeCӫ2J:W', '', 0, '?'),
 ('aZcw\\D-<', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Memcache.php', 0, 'SG5ޏ}r+', 'SG5ޏ}r+', 't!{y	 ]bF6\0ȯdyȤy', '', 0, '?'),
 ('R -}ǜd', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Null.php', 0, 'TpF8\'٫Ƌ', 'TpF8\'٫Ƌ', '巧?|ap4x`ȷ,yP%\r3', '', 0, '?'),
 ('7`e|Ay', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Client.php', 0, '?mHoA', '?mHoA', 'k_3;L?.M1}SH`!', '', 0, '?'),
 ('C-*T$', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Collection.php', 0, 'y6x5Mq', 'y6x5Mq', '5́2|TR/nw*Җ', '', 0, '?'),
 ('I`L+2ؽQ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Config.php', 0, 'l!W8աRM]', 'l!W8աRM]', 'm#:hWw45:C+*N:', '', 0, '?'),
 ('`yVuOk,k&', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Exception.php', 0, '1ZK/', '1ZK/', 'Ʒ-)۵إz9Ip*#I	', '', 0, '?'),
 ('\ZܣM蟒=v', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/Batch.php', 0, '5kkL&ވ', '5kkL&ވ', 'Uѕ+fz:*]b', '', 0, '?'),
 ('C	cHk`XC', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/CacheParser.php', 0, 'wOT| th$x', 'wOT| th$x', 'ȾWp*;zJW{]ilc', '', 0, '?'),
 (')>\ZpG\Z3}&', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/MediaFileUpload.php', 0, '7gm)0U', '7gm)0U', 'Z]TV{!?u`gD&L&', '', 0, '?'),
 (';dؼ|XZ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/REST.php', 0, 'nk>,fې-', 'nk>,fې-', 'gS,$O\"jO\\wAMެ~', '', 0, '?'),
 ('6\':B0AEπ-/', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/Request.php', 0, 'wc,&0;d', 'wc,&0;d', 'Ǟ]UGi\\4\Z\'Xi2d', '', 0, '?'),
 ('-MVєїa', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Abstract.php', 0, ';QJ ?`?$2r 8', ';QJ ?`?$2r 8', 'C	gG[|6Up=BQX[t$', '', 0, '?'),
 ('z-\'9-B_elR', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Curl.php', 0, '<jf#-X', '<jf#-X', 'P7aV%~zk1cb', '', 0, '?'),
 ('Rd]|N8/}', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Exception.php', 0, '7԰-}6', '7԰-}6', 'E\'`ߢ\rh%oקD1', '', 0, '?'),
 ('W$5j\"{_7', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Stream.php', 0, 'n\\<@ ', 'n\\<@ ', 'gehWȕĜw}/SPĺuy!', '', 0, '?'),
 ('oX{;\n r', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Abstract.php', 0, 'rc9]q)', 'rc9]q)', 'i\"ڲM,\'PC', '', 0, '?'),
 (']1B8g', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Exception.php', 0, 'þ?P||0r', 'þ?P||0r', 'Q%ֱȣ6j$S%2cJ', '', 0, '?'),
 ('<5xsut\\hӏG', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/File.php', 0, 'ׁ8_p@}', 'ׁ8_p@}', 'mOtOh;)ً,\'J', '', 0, '?'),
 ('Ny/f`7\0c', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Null.php', 0, 'ig+ 3', 'ig+ 3', '\'hN,^12;#(Z\'', '', 0, '?'),
 ('IWF5tPs', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Psr.php', 0, '׳π{\\6}', '׳π{\\6}', 'ˁe?ŴŒuCdm\"KX\'', '', 0, '?'),
 ('!\Zf㔒m:', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Model.php', 0, 'GWŹx', 'GWŹx', 'a-<M>w OB%ƇKS7', '', 0, '?'),
 ('HOл_', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Audit.php', 0, '36!LleD', '36!LleD', 'Xj૷X4PQF.<\r)Pb@', '', 0, '?'),
 (']ÔnJ\rM7', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Container.php', 0, 'U\"L;s', 'U\"L;s', ':\0ORQZ\'vYv;`^J)r\r', '', 0, '?'),
 ('\"IZUi', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Datastore.php', 0, '}vƈZX_', '}vƈZX_', 'm\"OL(Hy@|w0깃\ZI', '', 0, '?'),
 ('	wg\\h]i\Z', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Directory.php', 0, 'Y$]j;{N', 'Y$]j;{N', '\0<]wuXq9L{-\r뺎}o|e#', '', 0, '?'),
 ('㐍/O\'To\\g2t', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Dns.php', 0, '<<j*', '<<j*', '`\\AB[A[y/gxLr', '', 0, '?'),
 ('7 pϺSO+', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Drive.php', 0, 'A6o6QH', 'A6o6QH', 'hBtV`dU!jwǌ:e`', '', 0, '?'),
 ('QC&TRP', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Exception.php', 0, 'cE-QJ7Ύ', 'cE-QJ7Ύ', '̫\"..TB`\"L\"վ>', '', 0, '?'),
 ('Z%9t=', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/GroupsMigration.php', 0, '=}Κ/<y', '=}Κ/<y', 'D2e`IIQ>e#H,O&xFb', '', 0, '?'),
 ('iIO\Zڢrx', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Groupssettings.php', 0, '\n-ӋGxѠume', '\n-ӋGxѠume', 'f(%U;3q_La}v|hc', '', 0, '?'),
 ('{Vr\0Z*', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/IdentityToolkit.php', 0, '.ڋ=QeeH?', '.ڋ=QeeH?', '#Ke1S;uO+|߿*', '', 0, '?'),
 ('o[i~<*݁NlRF', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Licensing.php', 0, 'C/brA', 'C/brA', 'f	.Z%Q-0zւc', '', 0, '?'),
 ('@jG,\\7?', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Logging.php', 0, '*A@rQGXy', '*A@rQGXy', '\\k^NTpYmUP\\', '', 0, '?'),
 ('l&HdGH vjJ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Oauth2.php', 0, 'Iyby4MgcΞ', 'Iyby4MgcΞ', '^!$y[X\\g֧gN\'3(hm', '', 0, '?'),
 ('H\n7PBl~e', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Reports.php', 0, 'aBU-K', 'aBU-K', '|G^:QodO4\"^\0B[Ok\r&4w\r:,', '', 0, '?'),
 ('gSv~{b#', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Resource.php', 0, 'P!^((Ni4', 'P!^((Ni4', 'SkUzPx-5_\Z4i', '', 0, '?'),
 ('P\"m_IN', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Resourceviews.php', 0, 'qVN+X_', 'qVN+X_', '9Míb>[sW6\\O', '', 0, '?'),
 ('IBZ,0/', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Storage.php', 0, 'ha;x.^~}', 'ha;x.^~}', '[`]͍]ǜݪ7mA\ng', '', 0, '?'),
 ('#x&\"nӮT', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Tasks.php', 0, '%E[Ys\0ֿ', '%E[Ys\0ֿ', '3,JvaၕP2V\04N}W', '', 0, '?'),
 ('\nE|@\'4ޘ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service.php', 0, 'ƣyu\rXON,', 'ƣyu\rXON,', 'c5rIeNZ71A\"q`%', '', 0, '?'),
 ('G*wbӰhI', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Signer/Abstract.php', 0, '6SW', '6SW', ':\'Lr3Wٙsć', '', 0, '?'),
 ('\"NR', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Signer/P12.php', 0, 'TR+6|8', 'TR+6|8', '4]Ⱪ@q?ulEv%jPr', '', 0, '?'),
 ('ئ0j<̎', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Task/Exception.php', 0, 'b48	BI$Z', 'b48	BI$Z', 'Vn@1[)ޕ{G jC顴ǝ:O', '', 0, '?'),
 ('YZqLGa:', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Task/Retryable.php', 0, 'qeS4', 'qeS4', ']R \r8]\'CｍĽV', '', 0, '?'),
 ('}MO-KFKÂ', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Task/Runner.php', 0, '{a\"Z*/Df', '{a\"Z*/Df', '\"H(Tz/eԂ{D\'\r7u\\,E', '', 0, '?'),
 ('%f}ROF', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Utils/URITemplate.php', 0, 'ߘ	zg(', 'ߘ	zg(', 'NGEʭ<^@{oZGR', '', 0, '?'),
 ('X)ikxmgBR', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Utils.php', 0, '+3q;yr', '+3q;yr', 's*a~TкYTnܟ(\Z', '', 0, '?'),
 ('$TCyFA>z', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Verifier/Abstract.php', 0, 'qz\'N', 'qz\'N', 'XVUc<j\"f.{a?', '', 0, '?'),
 ('%ZmYI>~K\'', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Verifier/Pem.php', 0, '#Uۙ*@', '#Uۙ*@', 'l@[uuPj%2Aˇp(w&x_', '', 0, '?'),
 (';!nh?l', 'wp-content/updraft/plugins-old/updraftplus/includes/Google/autoload.php', 0, '7z6܋xTLE', '7z6܋xTLE', '5ZbyoOXr\060]Dv', '', 0, '?'),
 ('hȎ^󍏔~', 'wp-content/updraft/plugins-old/updraftplus/includes/S3.php', 0, '\rg_|ތ嵠D', '\rg_|ތ嵠D', '-j|u<Qn0nZO\Z', '', 0, '?'),
 ('M3 W^w', 'wp-content/updraft/plugins-old/updraftplus/includes/S3compat.php', 0, '?h	C]t', '?h	C]t', 'a{`5`݂4h勭pd', '', 0, '?'),
 ('Jk$A ɨ', 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/assets/loader.svg', 0, 'X@uiL\"', 'X@uiL\"', 'jXw=wsKw%o<qbZNF', '', 0, '?'),
 ('eh?YONjyGm', 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.js', 0, 'R\r	OAM', 'R\r	OAM', 'B~E~ˡQ(\nd³ h', '', 0, '?'),
 ('3ֽ@d7IN', 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.js', 0, 'rG̏pKT', 'rG̏pKT', '\nZ/Q\nl.)Oު,Pe2<lٗ', '', 0, '?'),
 ('<S\Z&p', 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/class-udp-checkout-embed.php', 0, 'Oҕ4oV', 'Oҕ4oV', 'VBO(ǀMoY:+g2ܰ', '', 0, '?'),
 ('>:_)$f', 'wp-content/updraft/plugins-old/updraftplus/includes/class-backup-history.php', 0, ',a+QAkP', ',a+QAkP', 'xC	n\0ɢQ\Z~z0M|', '', 0, '?'),
 ('bm5>B@XZ', 'wp-content/updraft/plugins-old/updraftplus/includes/class-commands.php', 0, 'Sal+-3Qs', 'Sal+-3Qs', 'zzO yClvo(h#7\"', '', 0, '?'),
 ('J`P	E#', 'wp-content/updraft/plugins-old/updraftplus/includes/class-database-utility.php', 0, 'piL$X2-s0', 'piL$X2-s0', 'im:nVxc6e[S2:8in', '', 0, '?'),
 ('4{OM\\\nۭwm', 'wp-content/updraft/plugins-old/updraftplus/includes/class-filesystem-functions.php', 0, 'W.0#S`YŁ', 'W.0#S`YŁ', 'ɹwmM}Q~+8C!PV*Ūt', '', 0, '?'),
 ('6CqH', 'wp-content/updraft/plugins-old/updraftplus/includes/class-job-scheduler.php', 0, '=-ei$t', '=-ei$t', 'R똚Q	Ĥ?[^57*Ƽ', '', 0, '?'),
 ('ÓS -\0Pny*', 'wp-content/updraft/plugins-old/updraftplus/includes/class-manipulation-functions.php', 0, 'T?J%讲F', 'T?J%讲F', '(إaCSg|D,2zxӘK', '', 0, '?'),
 ('\\ِ5KT7', 'wp-content/updraft/plugins-old/updraftplus/includes/class-partialfileservlet.php', 0, '_4/F(', '_4/F(', 'BXASr!kbfq`B@*c', '', 0, '?'),
 ('i{w^G֟H', 'wp-content/updraft/plugins-old/updraftplus/includes/class-remote-send.php', 0, 'zIK=ɺ', 'zIK=ɺ', ':\r\ZOO2ZQj٘ۿ\0', '', 0, '?'),
 ('$sq', 'wp-content/updraft/plugins-old/updraftplus/includes/class-semaphore.php', 0, '\'mfd\n˜o', '\'mfd\n˜o', 'h]֝O\rbJe=F\"1[rTr\'k<', '', 0, '?'),
 ('Uu*V̾Ȱf', 'wp-content/updraft/plugins-old/updraftplus/includes/class-storage-methods-interface.php', 0, 'DtCx', 'DtCx', ' @0q`Vޏh\"h', '', 0, '?'),
 ('N,mT?\\*V', 'wp-content/updraft/plugins-old/updraftplus/includes/class-udrpc.php', 0, ']W\'dQkfù\0', ']W\'dQkfù\0', 'pX\'9j8dKU\0aŗw\rY', '', 0, '?'),
 ('eEig\'v', 'wp-content/updraft/plugins-old/updraftplus/includes/class-updraft-dashboard-news.php', 0, 'E/ZvˉE$a', 'E/ZvˉE$a', '|(J(3>Y(ᐩq)4d', '', 0, '?'),
 ('EATڳ', 'wp-content/updraft/plugins-old/updraftplus/includes/class-updraftcentral-updraftplus-commands.php', 0, 'Xf54P', 'Xf54P', 's\razA9O^Zs2yJۧN~McC؎', '', 0, '?'),
 ('i.*`5]F', 'wp-content/updraft/plugins-old/updraftplus/includes/class-updraftplus-encryption.php', 0, 'G	S`쓌U', 'G	S`쓌U', 'j\r4jL9\0@)zHO)(.~V', '', 0, '?'),
 ('q\nwZi', 'wp-content/updraft/plugins-old/updraftplus/includes/class-wpadmin-commands.php', 0, 'j&ucsZ/', 'j&ucsZ/', '<_ݤ䶨;8dyݽJ[', '', 0, '?'),
 ('W:?S', 'wp-content/updraft/plugins-old/updraftplus/includes/class-zip.php', 0, 'b[a|X', 'b[a|X', 'z?j*n\"9Y]iz*9', '', 0, '?'),
 ('샧[\ZZ*lk', 'wp-content/updraft/plugins-old/updraftplus/includes/cloudfiles/cloudfiles.php', 0, '򘉱#q~O', '򘉱#q~O', 'kk[wrnoI', '', 0, '?'),
 ('b޲}', 'wp-content/updraft/plugins-old/updraftplus/includes/cloudfiles/cloudfiles_exceptions.php', 0, 'v!e(i:hZ', 'v!e(i:hZ', 'i3F\0i7\'TdLF\0M}M', '', 0, '?'),
 ('|M>yF', 'wp-content/updraft/plugins-old/updraftplus/includes/cloudfiles/cloudfiles_http.php', 0, '&gKdC.ĵ&', '&gKdC.ĵ&', '?S>ȃH\'M-oԭ|c&', '', 0, '?'),
 ('W{T?@+i;', 'wp-content/updraft/plugins-old/updraftplus/includes/ftp.class.php', 0, 'ɳT:v\"x\"', 'ɳT:v\"x\"', '>qql!9Y\\ Rb', '', 0, '?'),
 ('fv\nX\n\"-d2', 'wp-content/updraft/plugins-old/updraftplus/includes/google-extensions.php', 0, ' CCzX95J', ' CCzX95J', 'q^(ّ1 yqQ', '', 0, '?'),
 ('BE/-g', 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.js', 0, 'B\ZT~)d', 'B\ZT~)d', 'uR!^\\M,Q0\r<B', '', 0, '?'),
 ('zVIJK-Nd]\"N', 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.min.js', 0, '@ߋK\'\rOe', '@ߋK\'\rOe', 'y\n@k_-se@/+KP;V', '', 0, '?'),
 ('s)O$s%ǐ<Ǌ', 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.runtime.js', 0, 'ly<ߚdZE', 'ly<ߚdZE', '~`Z@+[1a\"^qg[&99', '', 0, '?'),
 ('c[kW74@', 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.runtime.min.js', 0, 'h̏0-1ڈd', 'h̏0-1ڈd', 'ܯb]fz4$C\0Gi', '', 0, '?'),
 ('%cAzY,#', 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.blockUI.js', 0, '\\ڰx1#=', '\\ڰx1#=', 'q΂<Ae󺷊Ց~hP', '', 0, '?'),
 ('BrA6M', 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.blockUI.min.js', 0, '-\"	\Z=L', '-\"	\Z=L', 'i)M	|JoCf.P$Elg`l(', '', 0, '?'),
 ('SNļ=F', 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.js', 0, '{SAk(uI5s', '{SAk(uI5s', 'Iv+BޭՉcd6\"O\\', '', 0, '?'),
 (')wAә|U#i.V', 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.min.js', 0, '-ϣ;Gi$rG9c$', '-ϣ;Gi$rG9c$', 'ϯ|/X\n2G:@{\rAL{	', '', 0, '?'),
 ('j#LV\n[2~)', 'wp-content/updraft/plugins-old/updraftplus/includes/jstree/jstree.js', 0, 'Yᮨ-\0;k', 'Yᮨ-\0;k', 'F;֕#\rus(\0nט', '', 0, '?'),
 ('E{#	0]?3<', 'wp-content/updraft/plugins-old/updraftplus/includes/jstree/jstree.min.js', 0, 'HCDLg?', 'HCDLg?', 'iunhai[[J&8sopp', '', 0, '?'),
 ('Ut>L\"[', 'wp-content/updraft/plugins-old/updraftplus/includes/labelauty/jquery-labelauty.js', 0, 'ª/9T9I', 'ª/9T9I', '7\ZĆ8l8N-9', '', 0, '?'),
 ('wE7=K0', 'wp-content/updraft/plugins-old/updraftplus/includes/labelauty/jquery-labelauty.min.js', 0, '!mH@4٨', '!mH@4٨', 'l3 ==ݕ흖xeHLY&#', '', 0, '?'),
 ('Q)M R&FYw}', 'wp-content/updraft/plugins-old/updraftplus/includes/tether/tether.js', 0, '3\'Gr|(xx', '3\'Gr|(xx', 'D=F:\0}ZD\n2_;fTq', '', 0, '?'),
 ('~1<}Zr', 'wp-content/updraft/plugins-old/updraftplus/includes/tether/tether.min.js', 0, 'Yyiz', 'Yyiz', 'Ui(9ￌbUT,RΕS', '', 0, '?'),
 ('bt+Ǉ', 'wp-content/updraft/plugins-old/updraftplus/includes/tether-shepherd/shepherd.js', 0, '\\&T+K', '\\&T+K', 'j\\33IU޾8eP\nJ-j\']lv', '', 0, '?'),
 ('l |OsּaM', 'wp-content/updraft/plugins-old/updraftplus/includes/tether-shepherd/shepherd.min.js', 0, '\n+bA|-X', '\n+bA|-X', 'g7>^rֲYgd7羊`=', '', 0, '?'),
 ('Ov:', 'wp-content/updraft/plugins-old/updraftplus/includes/tether-shepherd/tether.js', 0, '٬MU6/A1', '٬MU6/A1', '\nG#sUWN', '', 0, '?'),
 ('Ȣuw܀wn', 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-admin-common.js', 0, '%\Z\0+dlt', '%\Z\0+dlt', 'A5oTs\"LmAti}Ǜ0=5J.', '', 0, '?'),
 ('lT;<bh\Z', 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-admin-common.min.js', 0, 'hD;\rY9+qd', 'hD;\rY9+qd', '(n{x-qlhD8<JTA#wv,h', '', 0, '?'),
 ('>\rYZ2W-|U', 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-notices.php', 0, 'Қēх>', 'Қēх>', 'zg%P\rdq*~l\0\nA~I', '', 0, '?'),
 ('v\rֿzEj#]5:', 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-restorer-skin-compatibility.php', 0, '&C;e', '&C;e', 'O7ޚn#xY6fUK', '', 0, '?'),
 ('Qyk+ᦹ]T', 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-restorer-skin.php', 0, 'wφac', 'wφac', 'Ru$`\\3w]~Weֵ', '', 0, '?'),
 ('b\rdA^', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftcentral.php', 0, ']};SHI~*', ']};SHI~*', '?W=)0\\i{\'Ś[u', '', 0, '?'),
 ('ӋvHӡE', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-auto-login.php', 0, ':2w9\n', ':2w9\n', '؈0XLS!\"8Y&]^;Ӝ,', '', 0, '?'),
 ('P<p\Z*Z', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-dash-notice.php', 0, '>\nL#M|', '>\nL#M|', '?Ni,!˘#>6x2ËLF', '', 0, '?'),
 ('S\\ZT\"', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-restore.php', 0, '.m5;CϿ', '.m5;CϿ', '2GL\r#:N\0}ҲOd\ZM,', '', 0, '?'),
 ('Cb\rc\'ͳ$k$r', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-status.php', 0, 'fs	\nXmfX', 'fs	\nXmfX', '/ReZ2#)x\"/o,it2', '', 0, '?'),
 ('Ѳ)yG', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-user-notice.php', 0, 'ճ*cƞ䨰', 'ճ*cƞ䨰', 'Ly8.0LtY\\3ͽ;JEi_=', '', 0, '?'),
 ('W	BX', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-clone.php', 0, '3oy\"b', '3oy\"b', '~<X9S¦U\'ҽ%4', '', 0, '?'),
 ('	F4L{', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-login.php', 0, 'Vߦ1rnez', 'Vߦ1rnez', 'K:\ZEwqˀ=y/^%y\rݹC', '', 0, '?'),
 ('@CȯdW', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-notices.php', 0, 'tiRwxw~5', 'tiRwxw~5', 'uCҭHYTmx9 ~`3s', '', 0, '?'),
 ('B>ٞ', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-tour.php', 0, 'XpISt✓-]YB', 'XpISt✓-]YB', 'ɄE4o\'a7fcNĔx', '', 0, '?'),
 ('Hoߟaې`H', 'wp-content/updraft/plugins-old/updraftplus/includes/updraftvault.php', 0, ']fFk<듅', ']fFk<듅', 'XN}]|(`k!O0Hn[q', '', 0, '?'),
 ('7w+?V.', 'wp-content/updraft/plugins-old/updraftplus/index.html', 0, 'IixC;y5', 'IixC;y5', 'gp	؟g	R	ya8>]o', '', 0, '?'),
 ('cj+XU ', 'wp-content/updraft/plugins-old/updraftplus/js/tour.js', 0, 'QҴH*޶b&_', 'QҴH*޶b&_', 'Z.5ҋp?ȘQFG?7', '', 0, '?'),
 ('w[/.Rkӎ', 'wp-content/updraft/plugins-old/updraftplus/js/tour.min.js', 0, '>^<]䠽', '>^<]䠽', 'ɐHnJiu4ՈF!@+垭', '', 0, '?'),
 ('xg!$| *z', 'wp-content/updraft/plugins-old/updraftplus/js/updraft-admin-restore.js', 0, 'N=lؿ', 'N=lؿ', '\0j9Q}[Kp_4pP:AgE>=)u', '', 0, '?'),
 ('^v!Nx5fIQ', 'wp-content/updraft/plugins-old/updraftplus/js/updraft-admin-restore.min.js', 0, 'wEr', 'wEr', '8H!Ah/~\"I`üET78[', '', 0, '?'),
 ('wQE\rDl*', 'wp-content/updraft/plugins-old/updraftplus/methods/addon-base-v2.php', 0, '{M#.VS\rL', '{M#.VS\rL', 'hw3ͤ`rOg;Y;', '', 0, '?'),
 ('\0*>d', 'wp-content/updraft/plugins-old/updraftplus/methods/addon-not-yet-present.php', 0, 'QԝS,^a\r0', 'QԝS,^a\r0', '4/ie_\niyߌdDSy+', '', 0, '?'),
 ('tEGg:Z/.j', 'wp-content/updraft/plugins-old/updraftplus/methods/azure.php', 0, 'k92hnIV', 'k92hnIV', '\n`v(?UJ=5uI]', '', 0, '?'),
 ('8dɉi%1{s#', 'wp-content/updraft/plugins-old/updraftplus/methods/backblaze.php', 0, '~Uŝ\Zz]', '~Uŝ\Zz]', 'B~:]_OLAN/!qpf	N)|rO', '', 0, '?'),
 ('Lh=8Yb', 'wp-content/updraft/plugins-old/updraftplus/methods/backup-module.php', 0, '3>M{zFT', '3>M{zFT', 'w\\yBK*T5UɼPCv<', '', 0, '?'),
 ('֓˕}?', 'wp-content/updraft/plugins-old/updraftplus/methods/cloudfiles-new.php', 0, '=S\0}p><	*', '=S\0}p><	*', '`	V1@y\"Y=&)', '', 0, '?'),
 ('tz^L(r+P', 'wp-content/updraft/plugins-old/updraftplus/methods/cloudfiles.php', 0, 'g	}؋%L', 'g	}؋%L', 'MTJvb\0o\0;ofP\n5\rdT<', '', 0, '?'),
 ('ETݻQմs', 'wp-content/updraft/plugins-old/updraftplus/methods/dreamobjects.php', 0, 'n\rFk>\ZP', 'n\rFk>\ZP', 'ץ@-8f8}Qv', '', 0, '?'),
 ('s@;ٸeg', 'wp-content/updraft/plugins-old/updraftplus/methods/dropbox.php', 0, 'V2\0/=!', 'V2\0/=!', 'tP>ᗨyWNmRj7E|O', '', 0, '?'),
 ('P9m4w_y0', 'wp-content/updraft/plugins-old/updraftplus/methods/email.php', 0, '>7ohH\'q7', '>7ohH\'q7', '\"oe[ 9{P	hg }3\'FW', '', 0, '?'),
 ('Y:f7', 'wp-content/updraft/plugins-old/updraftplus/methods/ftp.php', 0, ']?tb$ء,', ']?tb$ء,', 'Ktq4AH`)\ZY1*dm', '', 0, '?'),
 ('[Slm!.i', 'wp-content/updraft/plugins-old/updraftplus/methods/googlecloud.php', 0, 'Ժ\'hzx', 'Ժ\'hzx', 'lJ5ELgnjH\'f.C*|O', '', 0, '?'),
 ('Rssv\".', 'wp-content/updraft/plugins-old/updraftplus/methods/googledrive.php', 0, 'ZʱN', 'ZʱN', '7[O鹆?=bVdJxT', '', 0, '?'),
 ('PP', 'wp-content/updraft/plugins-old/updraftplus/methods/insufficient.php', 0, 's\0=+K', 's\0=+K', 'x&=(>dHS%ۘ2', '', 0, '?'),
 (']B,Zv{', 'wp-content/updraft/plugins-old/updraftplus/methods/onedrive.php', 0, 'PktrR', 'PktrR', 'm*=qBG\ZPho+9X\0^<xr˴	', '', 0, '?'),
 ('r/;ٜ6KśO', 'wp-content/updraft/plugins-old/updraftplus/methods/openstack-base.php', 0, 'X#+cWv', 'X#+cWv', 'P7 cn[LMsLxqC1z\"|', '', 0, '?'),
 ('Y1QptKarPg', 'wp-content/updraft/plugins-old/updraftplus/methods/openstack.php', 0, 'Li8{va', 'Li8{va', 'my<0wzzކDr#', '', 0, '?'),
 ('/5\\o\'1X', 'wp-content/updraft/plugins-old/updraftplus/methods/openstack2.php', 0, '5Ёie+ݫ', '5Ёie+ݫ', '+PsD6)7ꤧɵH\ZKQ?h', '', 0, '?'),
 ('föiFIÉ8', 'wp-content/updraft/plugins-old/updraftplus/methods/remotesend.php', 0, 'r:Gr]2a', 'r:Gr]2a', 'aC.~M!`kXʦL', '', 0, '?'),
 ('h+Ms', 'wp-content/updraft/plugins-old/updraftplus/methods/s3.php', 0, '>@DtYpZ', '>@DtYpZ', '(#3^L4|TJj,O*', '', 0, '?'),
 ('j|5:ʐ', 'wp-content/updraft/plugins-old/updraftplus/methods/s3generic.php', 0, 'a~F(\'KU', 'a~F(\'KU', 'sX$!\0#;\rPBN\n', '', 0, '?'),
 ('78Į(w;\ZS', 'wp-content/updraft/plugins-old/updraftplus/methods/sftp.php', 0, '\0XtI', '\0XtI', '1o?U=0кV0FO%HSf', '', 0, '?'),
 ('Y6O9G,6[$', 'wp-content/updraft/plugins-old/updraftplus/methods/template.php', 0, 'dj5aF@=)%6', 'dj5aF@=)%6', 'UNy\\.9Oo|]', '', 0, '?'),
 ('!_', 'wp-content/updraft/plugins-old/updraftplus/methods/updraftvault.php', 0, '8Ml<s9', '8Ml<s9', '\"HB^<\\Jyorc.}f', '', 0, '?'),
 ('zdq3aGI`\n?', 'wp-content/updraft/plugins-old/updraftplus/methods/webdav.php', 0, '#+;', '#+;', '!f,FȠJ۰h1M+?^X', '', 0, '?'),
 ('ÖdLnm', 'wp-content/updraft/plugins-old/updraftplus/options.php', 0, 'm=hvu&9n~', 'm=hvu&9n~', 'C)!Lo\"\nPfOH`a<*', '', 0, '?'),
 ('HwQ]*/F	x', 'wp-content/updraft/plugins-old/updraftplus/restorer.php', 0, 'd%b[|\n&AW', 'd%b[|\n&AW', '.EM(\\i*u˒{', '', 0, '?'),
 ('W=@G|bO', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/advanced-tools.php', 0, ')\0{ƴK[', ')\0{ƴK[', 'Z<?>J2F~ǒ241Z| ', '', 0, '?'),
 ('l5\nf+gt1', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/export-settings.php', 0, 'JJK(	L\ZXw>!', 'JJK(	L\ZXw>!', 'c!ݶ!\0C@J,(eMÏ<S]Z', '', 0, '?'),
 ('!TҌwБ', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/lock-admin.php', 0, '!j<V@뼤!A5m', '!j<V@뼤!A5m', 'g|*u̳9[ռɕb', '', 0, '?'),
 ('UA.چeS', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/search-replace.php', 0, 'ߨ^|a:⥒-', 'ߨ^|a:⥒-', 'k]o!~Xo~9;ʏwhǹC?B', '', 0, '?'),
 ('B6IޣX', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/site-info.php', 0, 'q9ūHr ', 'q9ūHr ', '<;7ײ`$[ńmlf*', '', 0, '?'),
 ('\0r_jir_	x\\', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/tools-menu.php', 0, '#U.#1#{', '#U.#1#{', ']UҚ0Ev\Ztߐ,ҢCl9n	', '', 0, '?'),
 (']96v^b', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/total-size.php', 0, 'Q0$|޻\"', 'Q0$|޻\"', 'F=R#u*C~d89K', '', 0, '?'),
 ('J_g', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/updraftcentral.php', 0, 'f)F|{8\n&', 'f)F|{8\n&', '=`s$U˶#	j[~)k\\m', '', 0, '?'),
 ('\Z}lIr', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/wipe-settings.php', 0, '96x^~Xp#', '96x^~Xp#', '#rFI;KɀԢ5b{!OV', '', 0, '?'),
 ('ޫc>\\jLe', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/autobackup-notice.php', 0, 'Qyv?/', 'Qyv?/', '	cYR#z1wNu\n', '', 0, '?'),
 (')OVTrX', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/bottom-notice.php', 0, '/7ҤhY$o+', '/7ҤhY$o+', '_4BWIC%v|I\n8׀$9O:', '', 0, '?'),
 (':P\r],岹', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/horizontal-notice.php', 0, 'hq[{mo:', 'hq[{mo:', 'UO8y3N|nL^xB7m&2^§', '', 0, '?'),
 ('s\ZKcX顷R!', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/report-plain.php', 0, 'i5\\|', 'i5\\|', 'aFzoT*g󩿞 Ĭ֐5a', '', 0, '?'),
 ('б߳Z$57D', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/report.php', 0, ',fSL-I\'v', ',fSL-I\'v', 'L7H)Т+L\n=<*1\rsɳ', '', 0, '?'),
 ('λ9!`H\'', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/thanks-for-using-main-dash.php', 0, 'Q+fOQRHj', 'Q+fOQRHj', '<(ddb=Ā%0\nN3#', '', 0, '?'),
 ('L0/W%\"Qĥ', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/backupnow-modal.php', 0, 'ۍ\0}cuE', 'ۍ\0}cuE', 'ݓ8y& r4؃>aI8妣x', '', 0, '?'),
 ('L@', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/delete-and-restore-modals.php', 0, 'tN2K}$', 'tN2K}$', ' 6 &+ \"_\'_;r', '', 0, '?'),
 ('yI&aWQ=)', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/downloading-and-restoring.php', 0, 'N=Rzge`', 'N=Rzge`', 'yg[R-򞥗	l{)K/', '', 0, '?'),
 ('xPjGVnp\'', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/exclude-modal.php', 0, 'gW&g(. ', 'gW&g(. ', '2g;\0	,T~`<ŊfzyE+', '', 0, '?'),
 (',>=U6t̡', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-heading.php', 0, '4I\nZHu', '4I\nZHu', ']^M;Y~\rm@tE]9J', '', 0, '?'),
 ('Q߇Yf[', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-submit.php', 0, '\Z+|x', '\Z+|x', 'u/DL:E\0~edxfQ', '', 0, '?'),
 ('I7xiq', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/existing-backups-table.php', 0, '-Gޮ\\SȰ', '-Gޮ\\SȰ', '-0<2\r	;2#.}(׶ma\Z-6p', '', 0, '?'),
 ('\"-b(0', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/file-backup-exclude.php', 0, '.L=[Go`^', '.L=[Go`^', 'D><\Zޮ4K`?SLp', '', 0, '?'),
 ('ǎt~\'', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/footer.php', 0, 'zJi', 'zJi', '{]{`jnا1*', '', 0, '?'),
 ('g?+L\'.', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/form-contents.php', 0, ']Nsʹ W ', ']Nsʹ W ', '6A~v7@?$P&e*iy', '', 0, '?'),
 ('kR3X', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/header.php', 0, 'fqA2\n\0y', 'fqA2\n\0y', 'Tv	*7\n|tK_i%7}\"Q\Z', '', 0, '?'),
 ('͒5&`F`', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/migrator-no-migrator.php', 0, 'Ǩ8;p#+h', 'Ǩ8;p#+h', 'Loq_~u+`ǒe\\YM', '', 0, '?'),
 ('\r1 _{<', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/tab-addons.php', 0, '.sp$e\"6', '.sp$e\"6', '4?;PJM/5ܴ;؎,', '', 0, '?'),
 ('|v0oVDR', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/tab-backups.php', 0, '[I\\L', '[I\\L', 'T,f0#.U$kor5o', '', 0, '?'),
 ('BWlLvh~^RH-W', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/tab-bar.php', 0, 'p*~NhAa9', 'p*~NhAa9', 'J1O\ndmOƲB\0cM5_QR%z|', '', 0, '?'),
 ('ـKhڤ2', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/take-backup.php', 0, '4.I|%', '4.I|%', 'tzr72%tlZ߇pj>8QUu', '', 0, '?'),
 ('C	f \"l', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/temporary-clone.php', 0, 'jsJ=!r3!', 'jsJ=!r3!', 'o?\rصN(&Br-C[', '', 0, '?'),
 ('%)Zrmu\Z', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/updraftcentral-connect.php', 0, 'Ͱ˱__)', 'Ͱ˱__)', '\"P9>gMs/0*\"?.kPt', '', 0, '?'),
 ('X1.M', 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/upload-backups-modal.php', 0, 'c-/;x&', 'c-/;x&', ',/r+ERrEi4,`\0', '', 0, '?'),
 ('qT sQ', 'wp-content/updraft/plugins-old/updraftplus/updraftplus.php', 0, '7ݞ\"[N:s-', '7ݞ\"[N:s-', 'ί;6ZM& 0q,\r!', '', 0, '?'),
 ('\'Xv_', 'wp-content/updraft/plugins-old/updraftplus/vendor/autoload.php', 0, '-CX\\`a#S{$', '-CX\\`a#S{$', 'Aqк	ad]0*M', '', 0, '?'),
 ('9HMVN', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Aws.php', 0, 'm$vl7aXC', 'm$vl7aXC', 'Շ&Jp!sLw@G-', '', 0, '?'),
 ('9ڊ4nC', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AbstractClient.php', 0, '\Z]<Q{c', '\Z]<Q{c', 'f\n\0@\05UcMr!t0\"k', '', 0, '?'),
 ('-7ue|d(', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AwsClientInterface.php', 0, 'TR]A@+4g', 'TR]A@+4g', '},0HU݊EeuύV;wG', '', 0, '?'),
 ('*~iKZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ClientBuilder.php', 0, '͛$)?', '͛$)?', ')QDګ|(FMiV^tO', '', 0, '?'),
 ('^&e )q', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/DefaultClient.php', 0, 'EozO=K', 'EozO=K', ']M\ZJ,q-Ց&8', '', 0, '?'),
 ('\"$qNĲeގd', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ExpiredCredentialsChecker.php', 0, 'ﯕKS+', 'ﯕKS+', 'P):/S@F\'`=)蔶] ', '', 0, '?'),
 ('ijy!6', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ThrottlingErrorChecker.php', 0, '21G$[', '21G$[', 'm,avJ[_7)I\"fo	u۬', '', 0, '?'),
 ('S*&', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UploadBodyListener.php', 0, '?i]', '?i]', 'I]Rpzm\0ѡMO6~mס8+', '', 0, '?'),
 ('^`1/&G$	]', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UserAgentListener.php', 0, 'P5+0$!|', 'P5+0$!|', '{=<\n,/7(et>礶eK s', '', 0, '?'),
 ('-hxbLLLvU(', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/AwsQueryVisitor.php', 0, 'diTܘ', 'diTܘ', 'uxd&Q*Bpt8(Vg[', '', 0, '?'),
 ('D?m', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/JsonCommand.php', 0, 'k^|KSLsg', 'k^|KSLsg', '=P LJֽ[1v_H7)F', '', 0, '?'),
 ('B]mZK_hn', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/QueryCommand.php', 0, 'GH}l	g', 'GH}l	g', 'SGWXZ2HDLf4', '', 0, '?'),
 ('浈AE>P', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/XmlResponseLocationVisitor.php', 0, 'EzziW[Z\"|9H', 'EzziW[Z\"|9H', 'V;t4ZCvɝ3#G7Do', '', 0, '?'),
 ('rʌ4M#t\"', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractCredentialsDecorator.php', 0, '棔5,.ը!', '棔5,.ը!', 'Ey/azyiX&owW1', '', 0, '?'),
 ('\'xiHbhx/f', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractRefreshableCredentials.php', 0, 'k#\\tLh;=', 'k#\\tLh;=', '@+Ŧ^NXr&[:Zj', '', 0, '?'),
 ('\'M7o(1V\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CacheableCredentials.php', 0, ';l-a۬Z%G|', ';l-a۬Z%G|', 'BĂE0ktYuCxG)m', '', 0, '?'),
 ('ãkocm7]', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/Credentials.php', 0, 'sʙU6aZN', 'sʙU6aZN', '-\\=ٸ[9O~%M\nÇ36:n', '', 0, '?'),
 ('1۲\0דZz{', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CredentialsInterface.php', 0, ',8.6', ',8.6', 'Gg^n|*0>їS/*HPrGԚ', '', 0, '?'),
 ('\Z/}D5XP\\z	', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/NullCredentials.php', 0, ',8.`PHDևN', ',8.`PHDևN', 'T}xd{qZDW+1|) c', '', 0, '?'),
 ('~v5%+aB<', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php', 0, 'ѠUn!lL1', 'ѠUn!lL1', '9\rVZiNﮧYLl;\"D', '', 0, '?'),
 ('kNE?)%~Sc', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/ClientOptions.php', 0, 'OTx5Og', 'OTx5Og', 'vʒÐd%46lHo#i', '', 0, '?'),
 ('py wXݒK\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/DateFormat.php', 0, 'A+)d', 'A+)d', '[ OuT\\Y|蝯;WȚ|', '', 0, '?'),
 ('p#nzWCIP:', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Region.php', 0, 'uHW_++', 'uHW_++', 'X+xKb^N\niEj)wy{ԕ>>', '', 0, '?'),
 ('Άʟq\"Q#5S34', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Size.php', 0, '-I@=<', '-I@=<', 'bxėn*R}9i<`JT-ƼD', '', 0, '?'),
 ('U(ⴥJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Time.php', 0, '_nv1', '_nv1', 'sC|3\\+^pܝ Na', '', 0, '?'),
 ('t;p%H.qU~m#c', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/UaString.php', 0, 'BS2Lo', 'BS2Lo', '-:./7d8g`+Pzh\0', '', 0, '?'),
 ('+twBC', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum.php', 0, '`qϵ=wf4', '`qϵ=wf4', '֐>EɤO\r;70W@=\0', '', 0, '?'),
 ('GZ*}|', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/AwsExceptionInterface.php', 0, '\rҳ', '\rҳ', 'd~fWT}+F_\"Z+f<)', '', 0, '?'),
 ('S2߲]c\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/BadMethodCallException.php', 0, 'u, !\n', 'u, !\n', 'a?(Ɋ	;qU,fqzX5m', '', 0, '?'),
 ('c˦*\0ǚ%m', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/DomainException.php', 0, '6eC\\XU=', '6eC\\XU=', 'K<+R}1#4R', '', 0, '?'),
 ('eQ<@,tEJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionFactoryInterface.php', 0, '`廦*&a>O<', '`廦*&a>O<', 'W\0*0Ooø+zSs', '', 0, '?'),
 ('_Mj1~{ٔ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionListener.php', 0, ',HiySU~', ',HiySU~', '3\"odW/f\\6ZnZ', '', 0, '?'),
 ('+@2!c5!', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InstanceProfileCredentialsException.php', 0, '!킖(\'I0fC', '!킖(\'I0fC', '3sǶ~?\\M:8', '', 0, '?'),
 ('(.Wb v(G#Q', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InvalidArgumentException.php', 0, 'd\0enjeR>7', 'd\0enjeR>7', 'x H#:!Sĸ*g', '', 0, '?'),
 (';|O<uXz|ܖ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/LogicException.php', 0, 'SvBtO*.m', 'SvBtO*.m', 'q 0@斒X1$,w1lէk', '', 0, '?'),
 ('k{k%$A§', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/MultipartUploadException.php', 0, '1a5,7׻', '1a5,7׻', ',+&2SLo]Gtg8++te5OV', '', 0, '?'),
 ('DwOҞ[\ZL,', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/NamespaceExceptionFactory.php', 0, '_Τd].', '_Τd].', 'je.z\0Iz', '', 0, '?'),
 ('O\"jEL(~:~', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OutOfBoundsException.php', 0, 'ںmʸ]', 'ںmʸ]', 'MJ(1y(F-&^HVҮ', '', 0, '?'),
 ('3dVmν``U', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OverflowException.php', 0, 'ZVVBSy9-u,:', 'ZVVBSy9-u,:', '\0&Ѕ8=y9	aXFN4u', '', 0, '?'),
 ('MELk', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php', 0, 'R@={}QV{&\r', 'R@={}QV{&\r', '05g=Oe撰AꁧA$', '', 0, '?'),
 (':!FnPB&', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php', 0, '@Y6㎚7', '@Y6㎚7', '.~o%3u}Ww?]\0Q̚K&', '', 0, '?'),
 ('ǾnK}S', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/ExceptionParserInterface.php', 0, '	d<WhJU', '	d<WhJU', '\r3.k\nůFa]l-VTJ', '', 0, '?'),
 ('i\nuW', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php', 0, ';M༄Л2o', ';M༄Л2o', 'zT|?7±@?3ͥ7X', '', 0, '?'),
 ('wR[z/', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonRestExceptionParser.php', 0, ',ktN0+Я', ',ktN0+Я', 'mⱺK<ByC 8@REHGH	4', '', 0, '?'),
 ('?uY', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RequiredExtensionNotLoadedException.php', 0, ')G熵\Z\"', ')G熵\Z\"', '1UŕFtA\r1*x', '', 0, '?'),
 ('݉wykE8I', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RuntimeException.php', 0, 'iBʷA.\\Ӗ ', 'iBʷA.\\Ӗ ', 'zσ!L,N]vY=KoN', '', 0, '?'),
 ('\\#^DU˨}', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ServiceResponseException.php', 0, '><v艗$sHt$', '><v艗$sHt$', 'WyPuGcU{BO+p?', '', 0, '?'),
 ('WYw{z=04s', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/TransferException.php', 0, 'iv)4JQ{[]@', 'iv)4JQ{[]@', '7׎Zr-1Ĵ>5X3%', '', 0, '?'),
 ('ȱsn~\rv\"B', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/UnexpectedValueException.php', 0, '	-C_+', '	-C_+', '\0!Q船;duxgˈUZKXA\"n', '', 0, '?'),
 ('W(w\\w|', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/Facade.php', 0, 'S\"NRz7', 'S\"NRz7', 'eQ3d/۵\0)J`@*+q!gz', '', 0, '?'),
 (':by>$?X_', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/FacadeInterface.php', 0, 'GH6mw=', 'GH6mw=', 'w\\7l[W1K\'GdCIUrwF=', '', 0, '?'),
 ('\ZUz/', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/facade-classes.php', 0, 'd}Cf=Fc%', 'd}Cf=Fc%', ' j*.[:cU1\0h', '', 0, '?'),
 ('|>\'B^', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHash.php', 0, '1ԓ\\YdoM', '1ԓ\\YdoM', 'Ufs73ڎM*m2K(', '', 0, '?'),
 ('\'}8*ɌG_o$Y', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHashInterface.php', 0, '|̫&dDԤk', '|̫&dDԤk', 'F:>p[', '', 0, '?'),
 ('B/*a\'ۂ>4fu', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/HashUtils.php', 0, '[<aua_%P', '[<aua_%P', '%|<a|F]iGL`9', '', 0, '?'),
 (' ي}~S', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/TreeHash.php', 0, 'vk:M', 'vk:M', '\ZY)\"R?6d	O\'PCy', '', 0, '?'),
 ('bQIc>n$!ZYI', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/HostNameUtils.php', 0, ':snb', ':snb', '۾=ȣ\00I,xC&)\Z', '', 0, '?'),
 ('Id`6dRT0', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/InstanceMetadataClient.php', 0, 'VYug&9(', 'VYug&9(', '\\p,\'qS+CME!30ͥ+x', '', 0, '?'),
 ('=zi%NDp', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php', 0, '.D\Zf1?Ӿ', '.D\Zf1?Ӿ', 'wLRPg\\ҥ=;hRF]w/߃', '', 0, '?'),
 (']7U,sN', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIterator.php', 0, '}ؙ+oߦ&', '}ؙ+oߦ&', '\\!eZd+2\"ju`M\n', '', 0, '?'),
 ('˧V2o|\n -', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIteratorFactory.php', 0, 'CMU;d򫳅1', 'CMU;d򫳅1', '*}Y(i	~T	bNON', '', 0, '?'),
 ('\r+6', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransfer.php', 0, '=iJwXB+', '=iJwXB+', 'y1J-:IR#\rT', '', 0, '?'),
 ('ԗp;Ml2rJ;3', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransferState.php', 0, '9\"tUB\rGT', '9\"tUB\rGT', 'ڊ bP_6Vܗ', '', 0, '?'),
 ('jxLƠ_~', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php', 0, '>=@Xee', '>=@Xee', 'zF#=_YSDg9yOy=\"Q;', '', 0, '?'),
 ('BTIbNʡa3b', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadId.php', 0, 'o s}\0R', 'o s}\0R', 'Q\Z\"Yuk^QQYky1C', '', 0, '?'),
 ('7{vـy\n_', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php', 0, '\\[F)3', '\\[F)3', ',.BFܻ擦FCйLRPgvׄ ', '', 0, '?'),
 (',\r=A', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferInterface.php', 0, 'l`\rtiqZ', 'l`\rtiqZ', '&/z#E7M>f/', '', 0, '?'),
 (']/[* 9', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferStateInterface.php', 0, 'zRV6#.1', 'zRV6#.1', '\n*\r8<Ye}r&Y', '', 0, '?'),
 ('dQ74o5o', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadIdInterface.php', 0, '\'$^sl.2;\n/', '\'$^sl.2;\n/', 't\ry\0Uձ:B\0W ap', '', 0, '?'),
 ('\"S}:?1', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadPartInterface.php', 0, '>Ɛ', '>Ɛ', '<mfx<~_rAh\0y', '', 0, '?'),
 ('ǠbeF]K', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/aws-config.php', 0, '11Ja\0\Z', '11Ja\0\Z', '26|OȻ;&;A|Q@6_Z6', '', 0, '?'),
 ('տbv,B_B?jXZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/public-endpoints.php', 0, ')@8E[̴_t', ')@8E[̴_t', ':ТLr`N[dFŘ[K,', '', 0, '?'),
 ('ptzr	l', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/sdk1-config.php', 0, '߫ؔ^U=', '߫ؔ^U=', '^xX zm?iɹp\0R*I3W', '', 0, '?'),
 ('-ף\n(;nb#', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/RulesEndpointProvider.php', 0, '\Zm=jiZOW', '\Zm=jiZOW', '➁6 h6aT>2=oPuD', '', 0, '?'),
 ('	\rj05', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/AbstractSignature.php', 0, 'fpaf\"_l ', 'fpaf\"_l ', '&|2z@$H4n£\n\0+1', '', 0, '?'),
 ('6ʢ홍d4:', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/EndpointSignatureInterface.php', 0, 'IV{B.', 'IV{B.', '\0k\'n㭓[|@Q', '', 0, '?'),
 ('>u@̌Cvq', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureInterface.php', 0, 'W݅+-', 'W݅+-', ');jCS>]2s~91͍', '', 0, '?'),
 ('?J50x..Qe', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureListener.php', 0, 'YTCge˨', 'YTCge˨', 'T0N9\rފKS} s5', '', 0, '?'),
 ('bN챿Az', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV2.php', 0, '\"20WRZ', '\"20WRZ', '\\؟ZcEfb5.XqNt', '', 0, '?'),
 ('xPrMП', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV3Https.php', 0, '.Wk3	N', '.Wk3	N', 'E[k;\\Dמ\Zg)b(&Hӓ\"V', '', 0, '?'),
 ('8fb~8tB', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV4.php', 0, '?\rLޕ', '?\rLޕ', 'Myz_~jJ{#-\ZAq73YU`', '', 0, '?'),
 ('s12R o', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractResourceWaiter.php', 0, 'w:gGAyt', 'w:gGAyt', 'ߕX H|#72', '', 0, '?'),
 (';6^ON^[', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractWaiter.php', 0, 'ύ`4C', 'ύ`4C', 'TT^.!#bPr\\c08', '', 0, '?'),
 ('viEQlX-P', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CallableWaiter.php', 0, 'eTM+)y7', 'eTM+)y7', 'n,󹍇gK6T˷ܲ:h', '', 0, '?'),
 ('cZf<#N', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CompositeWaiterFactory.php', 0, 's򺰧)9сI5', 's򺰧)9сI5', '&(8B2jOlm\"+]', '', 0, '?'),
 (':W$ל', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ConfigResourceWaiter.php', 0, 'hv4bpڞ', 'hv4bpڞ', ' %%;6OV\"ū|', '', 0, '?'),
 ('>U+,i)\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ResourceWaiterInterface.php', 0, 'ځ|A0g~b', 'ځ|A0g~b', 'f={m=\"˒FHXxǆebi', '', 0, '?'),
 ('«?ӳ(4b', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterClassFactory.php', 0, 'K#4k]', 'K#4k]', '7oKڔs Fj^1uK)Ƃo', '', 0, '?'),
 ('FYփn', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfig.php', 0, '\\30P', '\\30P', 'eKVx5zz{m\Z', '', 0, '?'),
 ('Ct|7P', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfigFactory.php', 0, 'k0\ZhxV\'x', 'k0\ZhxV\'x', 'qyP+)htu8rI', '', 0, '?'),
 ('[zuHSpT', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterFactoryInterface.php', 0, '4\\YBǶ#Io', '4\\YBǶ#Io', 'O}BX:{~ɅR', '', 0, '?'),
 (' PєPT', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterInterface.php', 0, 'Zj%,Y$D#9K', 'Zj%,Y$D#9K', '1Ew/ѡ`6_/ܫl', '', 0, '?'),
 ('Z1D67', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/AcpListener.php', 0, '0.!8GRBw', '0.!8GRBw', 'IWIkN\\	%tcq59bF', '', 0, '?'),
 ('eQMg1b7I$', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/BucketStyleListener.php', 0, 'p\"+o6x	', 'p\"+o6x	', '.Gt=yD\ZB<', '', 0, '?'),
 ('@8rz', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Command/S3Command.php', 0, '=^9tP\Z#\'Ì', '=^9tP\Z#\'Ì', 'Ti|\\wQ-OeǑ\Zcp', '', 0, '?'),
 ('dZiY03(~M', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/CannedAcl.php', 0, ',|c\\yGGO', ',|c\\yGGO', 'Lj[~ 1eY&7u>jkb', '', 0, '?'),
 ('uby3%up_', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/EncodingType.php', 0, 'zBؾj', 'zBؾj', '=Q0UDm$v0-<|V,Q', '', 0, '?'),
 ('am8!n(Ƥ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Event.php', 0, '$1e)', '$1e)', '%\\fm-nC5AZ9i\n', '', 0, '?'),
 ('Z,yA', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/GranteeType.php', 0, '}ɹ_!o^(', '}ɹ_!o^(', 'p\Z}y-K*cHWeو', '', 0, '?'),
 ('┵͠r32Q[', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Group.php', 0, 'lA0_', 'lA0_', '\'F-2 {	4uWR .Gi<', '', 0, '?'),
 ('Tٟ^*87', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MFADelete.php', 0, '!axv^uK8\n', '!axv^uK8\n', 'ͦ%o޽÷h~V\Z!\"Wu', '', 0, '?'),
 ('2cnW:Ic', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MetadataDirective.php', 0, '\'N@ZtTa', '\'N@ZtTa', 'ENFϐM1YP\nI39*d', '', 0, '?'),
 ('M|12.6D', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Payer.php', 0, 'Z8a֞', 'Z8a֞', 'J(D`|1 *\r^vHJ)', '', 0, '?'),
 ('<fwb)ӱҘ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Permission.php', 0, '٠k,\"9G=', '٠k,\"9G=', '],E4\ZDlj\'r\nCB#ݿ', '', 0, '?'),
 ('	@ƹ_h*e3', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Protocol.php', 0, '2ӿnYcfp', '2ӿnYcfp', '&\Z^MK[9R3vP\\r]', '', 0, '?'),
 ('+;Y z+Z^', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/ServerSideEncryption.php', 0, 'HӤ@@jA ', 'HӤ@@jA ', ':iؚ4I{Y1NuDx', '', 0, '?'),
 ('q@ C3', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Status.php', 0, 'ow\'k', 'ow\'k', 'b Jx̘x3J!II\'', '', 0, '?'),
 ('lqY((', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Storage.php', 0, 'f/At:M%', 'f/At:M%', '\nkH~POw^LitQə+	_3|#', '', 0, '?'),
 ('<mIjf[', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/StorageClass.php', 0, '66]N<%g->ȭ', '66]N<%g->ȭ', 'Qyyj^fhod#ݻo[WXg', '', 0, '?'),
 ('!|\'%\'%', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccessDeniedException.php', 0, 'Ϛ~3D@mԔ', 'Ϛ~3D@mԔ', '\0ou̟~I$6bɓS?C~', '', 0, '?'),
 ('3D@Xq񮼵a', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccountProblemException.php', 0, 'NjOf=$=&ƚ', 'NjOf=$=&ƚ', 'HATԢO\0^<C brQu+', '', 0, '?'),
 ('H/\Z%x!4WF:', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php', 0, '\\1~<fo/', '\\1~<fo/', 'f$2DrKLWF2	 ы)', '', 0, '?'),
 ('Yc`TgM', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BadDigestException.php', 0, '|S}-:ZFA^', '|S}-:ZFA^', '\\\ZTwr@\Zc;OҲʻ2', '', 0, '?'),
 ('&c)>\"|E', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyExistsException.php', 0, 'j\':\rcGxA', 'j\':\rcGxA', '1k _Y܂V5bn8@]Hz	', '', 0, '?'),
 ('yǗm~T', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php', 0, '\rƝ\ZP', '\rƝ\ZP', 'K[:۹M=X蘑kkn', '', 0, '?'),
 ('?:@XAV', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketNotEmptyException.php', 0, 'C\nF\\|', 'C\nF\\|', '3.Viq>jy).%L{ՄUV', '', 0, '?'),
 ('Q`;Η-?', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CredentialsNotSupportedException.php', 0, '(ߊvİ}!', '(ߊvİ}!', 'Hv59#*sw2Ȫnkc', '', 0, '?'),
 ('g<Q8m&!i', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php', 0, 'fC/˿^ .`&', 'fC/˿^ .`&', ':QmmI*ޞƼ_Z', '', 0, '?'),
 ('#)#gW}', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/DeleteMultipleObjectsException.php', 0, '^EݫʗZ', '^EݫʗZ', 'Dub@9rgo24+ͻ,$ |w', '', 0, '?'),
 ('+dӒ-', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooLargeException.php', 0, 'c[a@YQmiX', 'c[a@YQmiX', 'YuMx-+0A0kn2๚sh', '', 0, '?'),
 ('\nT*Û]Z>h', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooSmallException.php', 0, 'DіNN', 'DіNN', 'T4xQ<aE=7<p}', '', 0, '?'),
 ('1$ʐª#y', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ExpiredTokenException.php', 0, '<=<Y', '<=<Y', '.W.[0ޣIS;+o', '', 0, '?'),
 ('P+!r~j	/t', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IllegalVersioningConfigurationException.php', 0, 'u0ʛyb8a', 'u0ʛyb8a', 'pWX]\\DE!h){go@v{oS', '', 0, '?'),
 ('\"^)D\'Ց', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncompleteBodyException.php', 0, '8hW?KAif~^', '8hW?KAif~^', '-sMB\n<-L_zD\'Nh', '', 0, '?'),
 ('J[a$J3', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php', 0, 'w{7*)l', 'w{7*)l', '_G3IkμeGTjIK!', '', 0, '?'),
 ('\Z\nG/k!', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InlineDataTooLargeException.php', 0, '\\C3Qm<`', '\\C3Qm<`', 'd2nIMV	\"}zNe', '', 0, '?'),
 ('\\UxRSR', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InternalErrorException.php', 0, 'vi5P\r\n(J', 'vi5P\r\n(J', ' n\\.d_v!]1@lE	h!', '', 0, '?'),
 ('\nIzK8)u', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAccessKeyIdException.php', 0, '2o3vBۋ', '2o3vBۋ', 'vk(h\rqW=1#', '', 0, '?'),
 (':Ivo_Sxk%', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAddressingHeaderException.php', 0, 'V#g1', 'V#g1', '+C6\riׯ1l`P', '', 0, '?'),
 ('Y8}+n\"lR', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidArgumentException.php', 0, '&Ma\n|/	YY', '&Ma\n|/	YY', 'sOi2٨9wa⤅W', '', 0, '?'),
 ('&y6\"f*b٘b', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketNameException.php', 0, '8wLgR9ZqL\r', '8wLgR9ZqL\r', '~q D-$8nrlT=', '', 0, '?'),
 ('b#S^i', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketStateException.php', 0, 'S=I\ngk|', 'S=I\ngk|', '<D7O֐3yQ1', '', 0, '?'),
 ('>lµ`<', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidDigestException.php', 0, 'I,#0@', 'I,#0@', '$oOTܝ	}| C4K\Z#', '', 0, '?'),
 ('%}D/X|:', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidLocationConstraintException.php', 0, 'd)L2*if', 'd)L2*if', '&vIR>LH$/n)N>', '', 0, '?'),
 ('yc׶\ZVl', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartException.php', 0, 'yrENq(*K.', 'yrENq(*K.', '%\'DV#:tNPB`>1Q3', '', 0, '?'),
 ('Z\"NCTRe\n', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartOrderException.php', 0, '(DJBÿrPVT', '(DJBÿrPVT', 'ꨡ9aZ$[,XJr\nB', '', 0, '?'),
 ('\00UL+2q', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPayerException.php', 0, 'f/@>M\0GXm', 'f/@>M\0GXm', '{9mcϜ^哢wzV>M$W', '', 0, '?'),
 ('$ZsE:', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPolicyDocumentException.php', 0, '$p#\ZX3*a', '$p#\ZX3*a', '0oS;&v9jRZILį0r', '', 0, '?'),
 ('SOd', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRangeException.php', 0, '5ΠPDq2', '5ΠPDq2', 'vU|dO@0P3[>R', '', 0, '?'),
 ('\r=`e={dQO\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRequestException.php', 0, 'DhQk', 'DhQk', 'lKf(9΋bHQ\'!μ+', '', 0, '?'),
 ('$l}|]d-bmR', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSOAPRequestException.php', 0, 'Y<aZZ[K', 'Y<aZZ[K', 'nۊ	X\\D9]Uڥ\"P0iE', '', 0, '?'),
 ('yq&PJb,#{', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSecurityException.php', 0, '2]z`ϵE,', '2]z`ϵE,', 'S\\מAbу,A1P9 ڇCiX.', '', 0, '?'),
 ('7,Q<\\_?', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidStorageClassException.php', 0, 'W0qxi!8', 'W0qxi!8', '@Cц7?&s(?/s{\'\na', '', 0, '?'),
 ('_NR\Z_b', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTagErrorException.php', 0, '(\"f]h0\"Ѹ\'N', '(\"f]h0\"Ѹ\'N', '#w	)V 1\"gD%wq~?z', '', 0, '?'),
 ('c;)1oi', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php', 0, 'tCn`', 'tCn`', 'K!8GPprge[όu', '', 0, '?'),
 ('QW.}f3N', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTokenException.php', 0, 'DYr\r;f', 'DYr\r;f', 'ڼ^)?fe4z*\\ҩ+H', '', 0, '?'),
 ('~92ǔńJ.', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidURIException.php', 0, '9\\Lfxf,fG', '9\\Lfxf,fG', ' ÎXQ?OϞ\n/0=ASR', '', 0, '?'),
 ('i%eMd$\'mV', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/KeyTooLongException.php', 0, 'LIH\r', 'LIH\r', 'kytEUUT;=qe(1+ͣs', '', 0, '?'),
 ('ȷR~H6}`Ɍ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedACLErrorException.php', 0, '71IL̷b', '71IL̷b', '%=kyuRtIjQ%', '', 0, '?'),
 ('¢(|iB<', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedPOSTRequestException.php', 0, 'j\rO.}q^8', 'j\rO.}q^8', 'SEUba	gɵ$\"a\0', '', 0, '?'),
 ('cf,ůg', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedXMLException.php', 0, '?>\rgJա', '?>\rgJա', '-&mV2\'bCfEWsÊ9', '', 0, '?'),
 ('xIK\rT{', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxMessageLengthExceededException.php', 0, '㘲\r3a&G[', '㘲\r3a&G[', '=>/_cjk;	sgMwBPƦNaπ ', '', 0, '?'),
 ('%\rE~,4f,', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php', 0, '</0Su?e3', '</0Su?e3', '􁟹m\n޻yW\0', '', 0, '?'),
 ('Q}v݉iN', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MetadataTooLargeException.php', 0, 'IpZUatom', 'IpZUatom', 'ʐO$Fn$}\\x+AccYs', '', 0, '?'),
 ('{B.POX?cq;', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MethodNotAllowedException.php', 0, '8^$_Z\0s', '8^$_Z\0s', 'k_\rz]PjWa[HE!4(x', '', 0, '?'),
 ('#O8T~E6', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingAttachmentException.php', 0, 'ؙftn o\'', 'ؙftn o\'', '|0DaIDe:\"CT', '', 0, '?'),
 ('O#	r\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingContentLengthException.php', 0, 'u!\Z/uÑ', 'u!\Z/uÑ', 'Qsǥ|̀jT2&}j', '', 0, '?'),
 ('iKREIK_', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingRequestBodyErrorException.php', 0, '@+FC!L\nI', '@+FC!L\nI', '(BDlGLo7S?0oB\nXE', '', 0, '?'),
 (')W HH', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityElementException.php', 0, '<n\"\0DR>d', '<n\"\0DR>d', 'IL\0_Bqj@ĥ?', '', 0, '?'),
 ('\0ch', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityHeaderException.php', 0, 'PH|xjY', 'PH|xjY', 'nc*=Ñ0$+p|`lyRo', '', 0, '?'),
 ('@h;`P6qn),#a', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoLoggingStatusForKeyException.php', 0, ';UMX++=', ';UMX++=', 'WYˣWʢVWidZӓ8*T\n', '', 0, '?'),
 ('$nMuIY', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketException.php', 0, 'ggqۧc̕', 'ggqۧc̕', 'Ĭ	F~Lf&C8G`)', '', 0, '?'),
 ('4OHpBC', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketPolicyException.php', 0, 'PẁC~}?5p', 'PẁC~}?5p', 'dYd/\'rfPz\rqFr!d4r', '', 0, '?'),
 ('1N|eܓø2R4*', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchCORSConfigurationException.php', 0, 'xD3K402fȕ', 'xD3K402fȕ', '}d322zw;\"7\nOpJF', '', 0, '?'),
 ('d]=Q͗cn', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchKeyException.php', 0, 'yڛWҰ?߫', 'yڛWҰ?߫', 'L>4gR֝+m<', '', 0, '?'),
 ('̐g}~y\r3ag', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php', 0, '\'!,@m!W+', '\'!,@m!W+', 'OE\"pI`#b}A-sasXp', '', 0, '?'),
 ('3[M', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetErrorException.php', 0, 'kPV?JLQe2', 'kPV?JLQe2', '*){ޜT=*>\\}܀vS:X', '', 0, '?'),
 ('Q{	N478Ie', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetException.php', 0, 'hgtIʳ*', 'hgtIʳ*', '#n-uu!E.dP0eG&[', '', 0, '?'),
 ('+\Zi/a&e{ǚ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchUploadException.php', 0, '}rv5~Y2G|', '}rv5~Y2G|', 'j>s`u}|4N_RaV', '', 0, '?'),
 ('5sВ,I?', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchVersionException.php', 0, 'Qv3Q\\V', 'Qv3Q\\V', '*7Z8P\r繏Jhu׵O=!z', '', 0, '?'),
 ('+Jea:_,', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php', 0, 'ثDޕ;L]', 'ثDޕ;L]', 'r,Tv}G[(I=`ﻱwN癬H', '', 0, '?'),
 ('Zib{8', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotImplementedException.php', 0, 'ms0_ɵp', 'ms0_ɵp', 'G2oB3]Ty\\!z߇q8]', '', 0, '?'),
 ('\"L@$Mz', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSignedUpException.php', 0, '+jY\Zr|x', '+jY\Zr|x', 'UBFˀX/px^C8', '', 0, '?'),
 ('\n#N\"r', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSuchBucketPolicyException.php', 0, 'qK+p̴', 'qK+p̴', '+O~\r)En\0`Y', '', 0, '?'),
 ('grNhΐp', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php', 0, 'I*Iʫ6X', 'I*Iʫ6X', '<aZ/#6\n]I=Ϛ[x', '', 0, '?'),
 ('#F<	', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php', 0, ':v.\rQ', ':v.\rQ', 'Y颉J1N}g7e(', '', 0, '?'),
 ('{Z> jN?^', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/OperationAbortedException.php', 0, '+M`c}', '+M`c}', 'c8ῑ{qrXwiJ%·X', '', 0, '?'),
 ('M_U7Oq', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/Parser/S3ExceptionParser.php', 0, 'સv,6c', 'સv,6c', 'm),-VnzDȕB=4X', '', 0, '?'),
 ('(P\00ӈ\'6W87', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PermanentRedirectException.php', 0, 'aFN1<˝ޝn', 'aFN1<˝ޝn', 'Zh+Qۑq<R0', '', 0, '?'),
 ('ߘPz+:d', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PreconditionFailedException.php', 0, '	b)ɐ9h]', '	b)ɐ9h]', 'k~	RJ\0tD<Q[Lic', '', 0, '?'),
 ('ͧG$1#dmҫ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RedirectException.php', 0, '%삆U|Ȃ D', '%삆U|Ȃ D', 'J5\0VU}$3_%C}hb6', '', 0, '?'),
 ('O\'[{?q', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestIsNotMultiPartContentException.php', 0, '#9xzFI3', '#9xzFI3', '@3VFbd<,`d\"', '', 0, '?'),
 ('CZK~x', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeTooSkewedException.php', 0, '+ty\"WoM?', '+ty\"WoM?', ';iݯu].\"l񛀗WFX >', '', 0, '?'),
 ('Omu!JrU', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeoutException.php', 0, '3.\'2\Z@UP', '3.\'2\Z@UP', '\0dX3׶p\':6udSQop4؝6`', '', 0, '?'),
 ('4Ca)	BH', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php', 0, 'b]`NU7$', 'b]`NU7$', 'ʼ\',Tw<խ	]\n', '', 0, '?'),
 ('Qҧᜀc^M', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/S3Exception.php', 0, 'D\\TwkclJ', 'D\\TwkclJ', 'A)$aȦk_\run^\rJUys)hP', '', 0, '?'),
 (',GU>]T', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ServiceUnavailableException.php', 0, 'N[	m|`,', 'N[	m|`,', ';|Hfg)vLnuMݘVr3@a', '', 0, '?'),
 ('r*Ы\'|', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SignatureDoesNotMatchException.php', 0, ' y<\"PϮEE', ' y<\"PϮEE', '\'ޭF00YL_az', '', 0, '?'),
 ('}L^|(', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SlowDownException.php', 0, ',jV|eͻkf', ',jV|eͻkf', 'P\0!ޝ)z Kܦ#NUY8', '', 0, '?'),
 ('Dt\r>', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TemporaryRedirectException.php', 0, '=-YJV-tI', '=-YJV-tI', '/J.%Z4TgAN5.', '', 0, '?'),
 ('x_\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TokenRefreshRequiredException.php', 0, ':0Zކ\Z', ':0Zކ\Z', 'd*4s$5~`:&n4a', '', 0, '?'),
 ('~䣀ޮSk`', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TooManyBucketsException.php', 0, '7G`E3o 5C?', '7G`E3o 5C?', 'бa`9IS;5Rv$:NEۆ', '', 0, '?'),
 ('AV4Q-&&9', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnexpectedContentException.php', 0, 'Zz\Zp^\"8>', 'Zz\Zp^\"8>', '=_qp-N_0\"ʥ%', '', 0, '?'),
 ('OTMM;8ot', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php', 0, 'ݬM42+', 'ݬM42+', '=R9C5w6GMA', '', 0, '?'),
 ('\'7I+W熡', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php', 0, 'pA\"ǣ|', 'pA\"ǣ|', 'K׬\n׃kNa/dIruU\'-', '', 0, '?'),
 ('+Pa5|gq j', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/IncompleteMultipartUploadChecker.php', 0, '	WNa	/m^', '	WNa	/m^', 'Em5+շĵ4X.yV1', '', 0, '?'),
 ('_ f_k', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListBucketsIterator.php', 0, ')cF_%', ')cF_%', '`!\ZbeXPAxHgUbo', '', 0, '?'),
 ('`N', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListMultipartUploadsIterator.php', 0, 'ː[Z?\r\Z$', 'ː[Z?\r\Z$', '50Hݷiǻee:vѵ', '', 0, '?'),
 ('SZ?<4', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectVersionsIterator.php', 0, '\\>y2]', '\\>y2]', 'ʰɓhq	á0s7F$', '', 0, '?'),
 ('c5И7U', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectsIterator.php', 0, ')ipJe-', ')ipJe-', '$PO@$j7m.|ɠ<v&I\"4$', '', 0, '?'),
 ('\ry? ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/OpendirIterator.php', 0, '\Z@P#2', '\Z@P#2', 'p=\ZTa-h8BFR.鎿I', '', 0, '?'),
 ('ּУ1O', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Acp.php', 0, '=u5FJ/+D', '=u5FJ/+D', '{n\Zp8(35shx\Z', '', 0, '?'),
 ('P+ǌNw#e,', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/AcpBuilder.php', 0, '|=\"`(r', '|=\"`(r', 'W{s0\')dgy)~\rw', '', 0, '?'),
 ('Ot).5܇3', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/ClearBucket.php', 0, 'RJ꾽r\0', 'RJ꾽r\0', '7WIEܖ:a,GB.E\Zh8F%l', '', 0, '?'),
 ('tao\Zb?', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsBatch.php', 0, '$l̅!8!', '$l̅!8!', 'Qpݪ4DD/c$_(|', '', 0, '?'),
 ('MPEL8ߕ{z', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsTransfer.php', 0, 'BEpc', 'BEpc', '=mtf\"56ﾠfM=Xc', '', 0, '?'),
 ('\Z:|H7HC?\r', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grant.php', 0, 'Pkr\\ܚ', 'Pkr\\ܚ', '2!+q9&Nq&°\ZZ', '', 0, '?'),
 ('`48+^U', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grantee.php', 0, 'k6r;HpjԪ', 'k6r;HpjԪ', 'vaN?O, -1qV1:>', '', 0, '?'),
 ('O@ZodeWJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/AbstractTransfer.php', 0, ')27@n\nHG;', ')27@n\nHG;', 'C\\f9%Z@y\"@M', '', 0, '?'),
 ('EcrM\0bߙ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/ParallelTransfer.php', 0, 'Af\\$ep5P;', 'Af\\$ep5P;', 'y-m=̳|~wuv2UT1,', '', 0, '?'),
 ('JRtk', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/SerialTransfer.php', 0, 'pN3\ri', 'pN3\ri', 'YPK6h5R_M`U$굽/A', '', 0, '?'),
 ('Xzmy˵', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/TransferState.php', 0, 'EHLrhƣF_Yb', 'EHLrhƣF_Yb', 'bNm^-m&1GN1~2Ȍ4', '', 0, '?'),
 ('kY7&/z]', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadBuilder.php', 0, '!i}ط]', '!i}ط]', '0OOEofmf{\0AS', '', 0, '?'),
 ('YiI&Ge\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadId.php', 0, '	%؄!la', '	%؄!la', '8EN=l(#D<$', '', 0, '?'),
 ('j&J؇P,^>', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadPart.php', 0, '))\rb?', '))\rb?', 'm97+UmށgߕPej0EdO', '', 0, '?'),
 ('/8E[χ7J', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/PostObject.php', 0, 'fs#G8^', 'fs#G8^', 'wb\"piDn-=m', '', 0, '?'),
 ('H̔KųYP3', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Resources/s3-2006-03-01.php', 0, 'qI{\0(0TM\"&', 'qI{\0(0TM\"&', 'zum\rERٶ-!=QN\Z,', '', 0, '?'),
 ('BNCk-Oa', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/ResumableDownload.php', 0, 'WfQ[[', 'WfQ[[', ')ϱ#VJ̙û/̋', '', 0, '?'),
 ('^Iʝm|', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Client.php', 0, 'iF%lnaGJu[', 'iF%lnaGJu[', 'm&=GV ׄcRùD', '', 0, '?'),
 ('&Th	l>\n͠VT', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Md5Listener.php', 0, 'a!fʟD', 'a!fʟD', '14԰K%`r$@	URB6[5', '', 0, '?'),
 ('˒!~5w03rX', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Signature.php', 0, ' 7[Ud', ' 7[Ud', 'ԈL{VP2.\0Jp+o&ɭ', '', 0, '?'),
 (')L6ޭ4.', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureInterface.php', 0, '8+<Wx/G', '8+<Wx/G', 'XpWU{n CuCX=ӭ5{', '', 0, '?'),
 ('Amݧv', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureV4.php', 0, '?! |k,[N\0', '?! |k,[N\0', 'ذr7Z5̷ыߩcN+&f(38Ơ', '', 0, '?'),
 ('\rC\\i', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SocketTimeoutChecker.php', 0, 'Ưk\'f\0	|Ha', 'Ưk\'f\0	|Ha', 'mK]&h쐓V@\"TIYPK9', '', 0, '?'),
 ('`2P2z', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SseCpkListener.php', 0, 'wDFӉ6', 'wDFӉ6', 'a|{a[\\ߚo?i!^$t', '', 0, '?'),
 ('apm+ne', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/StreamWrapper.php', 0, ')5=SV;', ')5=SV;', '~ϘM&e[UȰT	', '', 0, '?'),
 (')ؽΣN3(x', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSync.php', 0, 'ϓ|g~$', 'ϓ|g~$', 'W\0l/$oX\0sr*\'yd', '', 0, '?'),
 (',\n\'$J', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSyncBuilder.php', 0, 'mU{', 'mU{', 'Mx,9|IƄOÞH\"G', '', 0, '?'),
 ('x*pֵ', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/ChangedFilesIterator.php', 0, '`}VtPSapw#', '`}VtPSapw#', '=;@5W\"d?\0K1c', '', 0, '?'),
 ('\'\ZA,\r)a-', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSync.php', 0, '+>ZQ', '+>ZQ', 'rc(,W@PyZg;ts)YX ', '', 0, '?'),
 ('cauBz#', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSyncBuilder.php', 0, 'D1<H-Z', 'D1<H-Z', '$oKnbS>wll$36\\', '', 0, '?'),
 (':9*$T	p\\|j', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/FilenameConverterInterface.php', 0, '6}YNm}', '6}YNm}', '\rL\n	t)ZwD5p\n$ϨZMI', '', 0, '?'),
 ('_JfE1D\n\ZTt', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/KeyConverter.php', 0, '˨\\.Zd	H', '˨\\.Zd	H', '=p<JFN˞AnD-P', '', 0, '?'),
 ('N5f貅:r=', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSync.php', 0, '\'rz+2以G', '\'rz+2以G', '++BYgfU\'^1ݡĆ', '', 0, '?'),
 ('>\rڭep!g<', 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSyncBuilder.php', 0, 'Tܷè\")!i', 'Tܷè\")!i', '6rј	%)QUT>!m(C', '', 0, '?'),
 ('y·+4', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/ClassLoader.php', 0, '|%*T*`', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 ('z}snzzu', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_classmap.php', 0, '߶TZ,pj{', '߶TZ,pj{', 'J-F i%,5tzno~', '', 0, '?'),
 ('ifF.2#w-', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_files.php', 0, 'rOD,fR', 'rOD,fR', '37,|agj큜(WFV', '', 0, '?'),
 ('I<)21', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_namespaces.php', 0, '\ZRIRPfG', '\ZRIRPfG', 'FVIJӒ)Q	d	A\"Θt]', '', 0, '?'),
 ('h􋄠,]e', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_psr4.php', 0, 'f!b}^pKk)', 'f!b}^pKk)', 'mHdGB\\$j0]O;s&', '', 0, '?'),
 ('\n!<eѰa2', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_real.php', 0, '\'I{.g9@', '\'I{.g9@', 'd [ecPu 	$\0|*/=у\\', '', 0, '?'),
 ('\\U7Cثp', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_static.php', 0, 'oH]n^Pg', 'oH]n^Pg', '<hlSo\"	]8ڼHX', '', 0, '?'),
 ('<.?M[)U-^', 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/include_paths.php', 0, 'BUE&DLQ 6!', 'BUE&DLQ 6!', '3zl\Z#@U預ZllȪ', '', 0, '?'),
 ('ODh]\n5', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Consumer.php', 0, '<MWz', '<MWz', 'Eh1v[5KQosEeÿEEk', '', 0, '?'),
 ('ho4{F]?͢s?_', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/HmacSha1.php', 0, 'eꮲI56{4U', 'eꮲI56{4U', ']~G9٫q)],d', '', 0, '?'),
 ('\ny_&L߁*=B', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthDataStore.php', 0, '(IY', '(IY', '5⣏#\ZDʠLM7Pi&(', '', 0, '?'),
 ('nBp~b)', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthException.php', 0, '\"ȍbxw)Q', '\"ȍbxw)Q', 'h- K<Ax<#7&PI. #{', '', 0, '?'),
 ('.}`ȕ6jS<8', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthServer.php', 0, 'yp?m}', 'yp?m}', 'O3޻zT\Z*k6\rƁ\Z', '', 0, '?'),
 ('߂P-', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/PlainText.php', 0, '`|2j?3', '`|2j?3', 'ߌ\"%=ќ/^6ZYg', '', 0, '?'),
 ('vCSlN^a', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Request.php', 0, 'oX>>LZ4\\', 'oX>>LZ4\\', 'DkF\" 2h|Tie$~*>TZ', '', 0, '?'),
 ('q[ed-]', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/RsaSha1.php', 0, 's	׵Fa>', 's	׵Fa>', 'q .>\0܂ď+qM4W', '', 0, '?'),
 ('.M_eT', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/SignatureMethod.php', 0, 'xw+;axjt|', 'xw+;axjt|', '|ts|E*UƔ*kݹ', '', 0, '?'),
 (',ESA:', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Token.php', 0, 'qw<\Z-60', 'qw<\Z-60', 'E\'\'阌2\"սм|gE', '', 0, '?'),
 ('w=>zϗS6', 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Util.php', 0, 't>XQ!V', 't>XQ!V', 'sX_լ(c\0BӄOOU`R', '', 0, '?'),
 ('JKz7\"na8', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/phar-stub.php', 0, 'WDKXa', 'WDKXa', 'vq$uBq2\Z/|PT', '', 0, '?'),
 ('h˕Ȍ\0?0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/AbstractBatchDecorator.php', 0, 'յk!&', 'յk!&', 'ⱉ¤	AgϚRX-\0', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('weLé', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Batch.php', 0, ',1@b9', ',1@b9', '$-GZ˵yǀ\n_BTQ(', '', 0, '?'),
 ('shzQ̒	u', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchBuilder.php', 0, 'XEm3+O^[(u', 'XEm3+O^[(u', '`5Hмʄ5d7h!Ca|\'!', '', 0, '?'),
 (',偮-y', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureDivisor.php', 0, 'T]^P\0k	n', 'T]^P\0k	n', ']3n˹0Zb-peW	', '', 0, '?'),
 ('4[=H', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureTransfer.php', 0, 'CVsybo3`>j#', 'CVsybo3`>j#', 'wA/e{zwW&	1ogR]D', '', 0, '?'),
 ('{nFN(l', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchCommandTransfer.php', 0, 'q)XMԭ`@Fv', 'q)XMԭ`@Fv', 'V%9d6M5I', '', 0, '?'),
 ('Npe)țvG=ޮ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchDivisorInterface.php', 0, '`?2K4t', '`?2K4t', '~a?oH3`])#)7N+_c', '', 0, '?'),
 ('ͧ`=.\r', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchInterface.php', 0, '\0#%', '\0#%', '\\6QX{:ֽ	aoZ\\B\ZeJA3', '', 0, '?'),
 ('0FU㿦`0d', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchRequestTransfer.php', 0, 'qӨ\'=]', 'qӨ\'=]', 'q#6W۝\'	VCocઋܨm', '', 0, '?'),
 ('gWӏNtG&', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchSizeDivisor.php', 0, '(#hW_Ev[29!}', '(#hW_Ev[29!}', 'σG/.drU꩜%8,D', '', 0, '?'),
 ('DЪ8ː0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchTransferInterface.php', 0, '.$E5s{m', '.$E5s{m', 'ȲRk<[z?BP<PA8d]L`|', '', 0, '?'),
 ('\"pBN=ФZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Exception/BatchTransferException.php', 0, '?O$+dz\0\0', '?O$+dz\0\0', 'cjevFwJߛR4G\"Fo', '', 0, '?'),
 ('®\'M>6\r6rÒ\n', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/ExceptionBufferingBatch.php', 0, '.ʹoCc*Yq', '.ʹoCc*Yq', 'jb(^54k6\0EDl\r#\\2', '', 0, '?'),
 ('%o\'eв', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/FlushingBatch.php', 0, '\nl)sc', '\nl)sc', '}De\'/\"XM/xx%kZۓX', '', 0, '?'),
 ('WS~IJ^wc}', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/HistoryBatch.php', 0, 'bʼ:Qs', 'bʼ:Qs', 'M#%yߴenY=ՃaM', '', 0, '?'),
 ('}\" v?p', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/NotifyingBatch.php', 0, 'ӑqhj!$:EB', 'ӑqhj!$:EB', '})!Hs6s\'\nجu?aXK)1pf', '', 0, '?'),
 ('FJL҇\Z/', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/AbstractCacheAdapter.php', 0, 'ҙ[e9\rT', 'ҙ[e9\rT', '+*[J}ShoJ=[<ٔAL', '', 0, '?'),
 ('Ω~~', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterFactory.php', 0, 'CڥK*Z|4t', 'CڥK*Z|4t', 'ŃbF_asxq`8D!},-', '', 0, '?'),
 ('$dE\n]', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterInterface.php', 0, 'j&y\"@tQ', 'j&y\"@tQ', ';0Bc#jukIirR\"L93(', '', 0, '?'),
 ('.VX}\";\\', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/ClosureCacheAdapter.php', 0, 'a|	XŤD5Su[~', 'a|	XŤD5Su[~', '9zwL5{!?Y!	f', '', 0, '?'),
 ('~,)15=$-', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/DoctrineCacheAdapter.php', 0, '}RDjƻd@', '}RDjƻd@', '(t<MAˮ~?$ Кۘ\\2Y9', '', 0, '?'),
 ('e\0S!f', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/NullCacheAdapter.php', 0, 'sB.QoWkG_', 'sB.QoWkG_', '&殪T>Iecu?~:%%:h\Z', '', 0, '?'),
 ('4([Ww6', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf1CacheAdapter.php', 0, '*I\\V:rd', '*I\\V:rd', '!78>vYY^9Nem4J@aܽ', '', 0, '?'),
 ('\n8@@Qm`XD', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf2CacheAdapter.php', 0, '[&E\rR37Cg,', '[&E\rR37Cg,', 'T\\`\ZWn/L n:Zfb$$Nv[', '', 0, '?'),
 ('\"Vv?K', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/AbstractHasDispatcher.php', 0, 'Ngb<g[', 'Ngb<g[', '\Z#\'Ǔf\n	i=', '', 0, '?'),
 ('G2+p:v^', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Collection.php', 0, '$HLj 	[', '$HLj 	[', 'Y0u_[/PέWQ:', '', 0, '?'),
 ('l2Xɤ|', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Event.php', 0, '9%	(²', '9%	(²', '>jKfg]/fMU', '', 0, '?'),
 ('lh-vccG-V', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/BadMethodCallException.php', 0, ' Mߌu.<', ' Mߌu.<', 'ݴ߂0b}?\n SHBuL	\"', '', 0, '?'),
 ('=ö%hwY', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/ExceptionCollection.php', 0, ' 7o-&hR=', ' 7o-&hR=', 'XY}öN\">C:%l*IgY', '', 0, '?'),
 ('C/\ZW\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/GuzzleException.php', 0, 'tVLmm8b-{e', 'tVLmm8b-{e', 'W|FUhy	Tm\r', '', 0, '?'),
 ('0~ﺷKz', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/InvalidArgumentException.php', 0, 'vFό:p&`', 'vFό:p&`', '1FǛc%Lo]f+[zgy', '', 0, '?'),
 ('E[#(Ӈ]qZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/RuntimeException.php', 0, 'P_:)q`{#', 'P_:)q`{#', 'ibN)֑Q)S#7.', '', 0, '?'),
 ('^܉b\r+䬇\n', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/UnexpectedValueException.php', 0, '!3,S\'', '!3,S\'', '%:׶sFJp*kb_Fjׂ/L', '', 0, '?'),
 ('@ՊH=[3[z\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/FromConfigInterface.php', 0, '>bY	PHV', '>bY	PHV', 'c@$ 7ihkğ\ZVuI', '', 0, '?'),
 ('az9i_֨Π=', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/HasDispatcherInterface.php', 0, 'ۨ0k~l<J4', 'ۨ0k~l<J4', '~_vPGm, CT@*`QN', '', 0, '?'),
 (']#|>~A$+~', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/ToArrayInterface.php', 0, 'TfXO\'0x', 'TfXO\'0x', '_al_	~9`r\'p', '', 0, '?'),
 ('n6f', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Version.php', 0, '\05;ZW', '\05;ZW', '!\n襗uv2}', '', 0, '?'),
 (':ODt-\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/AbstractEntityBodyDecorator.php', 0, '6Ԧ#hlܞs', '6Ԧ#hlܞs', 'Y(zk\\ӎ̉1D~Dr$ցˎew', '', 0, '?'),
 ('~N\0zS3%', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/CachingEntityBody.php', 0, 'U\nfvQ_x%c', 'U\nfvQ_x%c', 'gdVW8H8-\0E<#{[?x\n', '', 0, '?'),
 ('؂fvZ\"', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Client.php', 0, '-%5vF\0*', '-%5vF\0*', 'У!Vat 1j[x\\sBw', '', 0, '?'),
 ('\"77R\'H\\T', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ClientInterface.php', 0, '@l7	3;5sS', '@l7	3;5sS', 'ƒuHn@d]O$H4', '', 0, '?'),
 ('.\"¹WP', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlHandle.php', 0, 'Ll8_6$-	Hg', 'Ll8_6$-	Hg', '\Z2*)OQkG̗*򍵥', '', 0, '?'),
 ('ք)pAΆ]5$', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMulti.php', 0, '%xqZlZ<?s', '%xqZlZ<?s', '	\n\0vuڗw>_iRav', '', 0, '?'),
 ('#S KG1 ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiInterface.php', 0, 'u~i84YkC', 'u~i84YkC', '%3	iF̥K\n\02$gsA^2,~', '', 0, '?'),
 ('r\Z(\0$-', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiProxy.php', 0, 'ڊI_\rtW0', 'ڊI_\rtW0', '3LCŊ&Q\027,ރ\ZS]', '', 0, '?'),
 ('/!NAZ3{Ghx', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlVersion.php', 0, 'xW }t]-', 'xW }t]-', 't6FŃ6a#T]>&r{8', '', 0, '?'),
 ('*	RIU', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/RequestMediator.php', 0, '\rQlW$', '\rQlW$', 'k|zL\rٖ)PG URKE*j', '', 0, '?'),
 ('\r1cMv', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBody.php', 0, '^}NYs}7', '^}NYs}7', 'Y\Z_\\a?tbV', '', 0, '?'),
 ('Ջt_J\0%', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBodyInterface.php', 0, 'Ɣ/\\m[~q)', 'Ɣ/\\m[~q)', 'X,7jDdv;ft', '', 0, '?'),
 ('ژanC', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/BadResponseException.php', 0, '.5}ֲ&6j(~', '.5}ֲ&6j(~', '~^jlS︐2<8nnIuz', '', 0, '?'),
 ('S룶ޣ7l\"aI{', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ClientErrorResponseException.php', 0, 'ʰL@j\nn', 'ʰL@j\nn', 'bƦھuN2GuWtWE', '', 0, '?'),
 ('g!h', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CouldNotRewindStreamException.php', 0, '\\$tkW', '\\$tkW', 'ɥ\r k(\0>#\0Z:t]u%.', '', 0, '?'),
 ('*b.c9ᶷg\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CurlException.php', 0, '/OAIΗP', '/OAIΗP', '(,?Lxk3IHh]qW!', '', 0, '?'),
 ('bM|漊zO_ɚ3', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/HttpException.php', 0, 'Y\0leԄ1,}\r', 'Y\0leԄ1,}\r', 'dIޗ5K)7?OJ\"jU<K', '', 0, '?'),
 ('1TlSQQo', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/MultiTransferException.php', 0, 'r{_d]أ	To', 'r{_d]أ	To', '\'%G2G0qlOLm`0G5\'', '', 0, '?'),
 ('M9y;?#P6Y/D', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/RequestException.php', 0, '}d	', '}d	', 'ۇT&#JqN&ߔ\ZKGڂ*', '', 0, '?'),
 ('y-V', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ServerErrorResponseException.php', 0, '&!K<UZʛ', '&!K<UZʛ', 'H?ٗKHwJ5>шa&y>', '', 0, '?'),
 ('퓇p\\@:w[', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/TooManyRedirectsException.php', 0, 'Sl', 'Sl', '1䎰TݐV@~pVWΧR', '', 0, '?'),
 ('L0VdvZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/IoEmittingEntityBody.php', 0, 'D@<(xHm', 'D@<(xHm', '{o\nLO/>e|r)Mqb\n!{\ZB', '', 0, '?'),
 ('%eg([R', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/AbstractMessage.php', 0, 'oSO', 'oSO', 'E8Ӛ%\0 %8\0_`mt', '', 0, '?'),
 ('&oar.wsK', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequest.php', 0, '[Hޥ0i5', '[Hޥ0i5', '!WҪN\0֫(r88A3F4', '', 0, '?'),
 ('8e$', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequestInterface.php', 0, 'tNJS8', 'tNJS8', 'piz1qaڪ&_;O', '', 0, '?'),
 (':ꃖR]RNN', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/CacheControl.php', 0, '_.@ap', '_.@ap', '0f2F=d1RG7/E$Ǣ', '', 0, '?'),
 ('$\\s0G>}N', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderCollection.php', 0, 'RG0n\ny\nh', 'RG0n\ny\nh', '1Fi  8bsHľu1t_', '', 0, '?'),
 ('|k4_f},X', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactory.php', 0, 'Z4ۡ(g[', 'Z4ۡ(g[', 'wkj.LT?=EUݛEm', '', 0, '?'),
 ('#K	QB', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactoryInterface.php', 0, '(Eɿ\'j+.T}', '(Eɿ\'j+.T}', 'HٲyGy?-n g`a', '', 0, '?'),
 ('@`Iw5)2', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderInterface.php', 0, 'Wq{:|e&M', 'Wq{:|e&M', 'f*K}-ݲ$Op*$\'PV', '', 0, '?'),
 ('2̿>j¬y', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/Link.php', 0, '\\/]dCHo-', '\\/]dCHo-', 'x[`ܧfGng.wW|0', '', 0, '?'),
 ('U\0yetÓ0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header.php', 0, 'ஃLz*Bg', 'ஃLz*Bg', 'CԑV,b<pUl%g6', '', 0, '?'),
 ('_dԢDxJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/MessageInterface.php', 0, 'k2bQ-?a', 'k2bQ-?a', 'xr}`1\08>u6o:', '', 0, '?'),
 ('XO', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFile.php', 0, '}9mZ', '}9mZ', '8ds~K}AHX%', '', 0, '?'),
 ('J+^:', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFileInterface.php', 0, ' &ʾ\0\"d', ' &ʾ\0\"d', 'i8HL&<y<\0 C\0{H6nL', '', 0, '?'),
 ('7V%)wB.', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Request.php', 0, 'æY-[~ ', 'æY-[~ ', '+ǡ8ȖJ5r&+<@', '', 0, '?'),
 ('r9\"Agknl', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactory.php', 0, ';7:ǐY\n,', ';7:ǐY\n,', '-KT?-Ao-0A\Z{', '', 0, '?'),
 ('H)HyP', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactoryInterface.php', 0, 'nhaw*', 'nhaw*', 'fk@ϱL1<0Qz3.%', '', 0, '?'),
 ('\0uƚ&XЩ-', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestInterface.php', 0, 'CǡhF.I`', 'CǡhF.I`', '1A\"kk%!D\\I,YJ', '', 0, '?'),
 ('c̼n8|\Z$', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Response.php', 0, 'l	\'Cٽ', 'l	\'Cٽ', 'b4d1K\rQf׬lLHܓ', '', 0, '?'),
 ('EcxD!B', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Mimetypes.php', 0, ')o<Yb\\f', ')o<Yb\\f', 'ε?4JcIX̉{̩AȔOy', '', 0, '?'),
 ('k}K\'ў', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/CommaAggregator.php', 0, 'gjGm*fYE\\T', 'gjGm*fYE\\T', '{ޞwn\0qɖ:w$\'WN+Q', '', 0, '?'),
 ('_^瓊PlE', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/DuplicateAggregator.php', 0, ']/p=}qd	;', ']/p=}qd	;', '\0@do3*Dg㽅6ѴaMvsN', '', 0, '?'),
 ('!ٌt,\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/PhpAggregator.php', 0, '&&4K', '&&4K', 'e=26dAu,#ܥxpri;', '', 0, '?'),
 ('X-i5)O ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php', 0, 'n\Zl-cNX\'*7', 'n\Zl-cNX\'*7', '	\'e\'es{@^u\0', '', 0, '?'),
 ('eR8\Z<', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryString.php', 0, 'tTnJxx', 'tTnJxx', '!Y4#@ZJD~4_$', '', 0, '?'),
 ('T2dg\"z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ReadLimitEntityBody.php', 0, 's,sqԟ\0߭b?', 's,sqԟ\0߭b?', 'aVlK~W9!!A\\4Og', '', 0, '?'),
 ('[ Qg', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/RedirectPlugin.php', 0, '2,E4lCA', '2,E4lCA', ':8\'Ii`7s0pL', '', 0, '?'),
 (',ݍBMȤ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/StaticClient.php', 0, '0_s7=Iǚ', '0_s7=Iǚ', 'y^$Jzz1!x\Z', '', 0, '?'),
 ('Rv;{e͉-', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Url.php', 0, 'kNc*&bԏ9F', 'kNc*&bԏ9F', 'S#I\Z1MX_f^', '', 0, '?'),
 ('Oǿ+\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/Inflector.php', 0, '	BPKS0', '	BPKS0', '8nhT^}=\'EJP9|', '', 0, '?'),
 ('dL.[¼=', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/InflectorInterface.php', 0, 'u3UGT>-', 'u3UGT>-', 'Mi\Z3+R}q1IA', '', 0, '?'),
 ('Ү\nny', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/MemoizingInflector.php', 0, '	z).N<QWT', '	z).N<QWT', '\\_ չbw#|.#E,;7Y', '', 0, '?'),
 ('X1+.>@>L', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/PreComputedInflector.php', 0, '+~P3', '+~P3', '7a?\'l}ƭ/a$^^', '', 0, '?'),
 ('z$k*\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/AppendIterator.php', 0, '~#[hoD', '~#[hoD', ']W7Ci&\'T};', '', 0, '?'),
 ('Y\nkg$\r,', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/ChunkedIterator.php', 0, '~jmd', '~jmd', '898`գ5i-I\Zj', '', 0, '?'),
 (')z3Hjv o', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/FilterIterator.php', 0, '~\rUFb{iI˦', '~\rUFb{iI˦', 'gr&[m\nxHsx\')9ʻ\"A|', '', 0, '?'),
 ('z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MapIterator.php', 0, '}(/D.OUtk(', '}(/D.OUtk(', '96E >S#0bf3Y', '', 0, '?'),
 ('^J~\r\\^*=oA', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MethodProxyIterator.php', 0, 'EW!\"`h2', 'EW!\"`h2', 'IʩdϦ/a4Pu3\rn', '', 0, '?'),
 ('.jO0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/AbstractLogAdapter.php', 0, '%r(Z2jvۿ', '%r(Z2jvۿ', 'VutV_T|#=Yao_\01&', '', 0, '?'),
 ('JgȻf#.ۚ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ArrayLogAdapter.php', 0, '|\\؏Ͷjh/4', '|\\؏Ͷjh/4', '*& ;~\"0Fܩjݬ\ZCMc ', '', 0, '?'),
 ('^\0K', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ClosureLogAdapter.php', 0, 'yF_\0W7ψ', 'yF_\0W7ψ', '\0B1z4;V`V9&x', '', 0, '?'),
 ('뇻TolZ+H', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/LogAdapterInterface.php', 0, 'gIz.FV:%', 'gIz.FV:%', '!G儱\0:JAQnZegop|G', '', 0, '?'),
 ('lץ\r00j8m', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MessageFormatter.php', 0, 'TM*c4E-\'a', 'TM*c4E-\'a', '^VĿLPp1Ye#C)', '', 0, '?'),
 ('0\'ە@', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MonologLogAdapter.php', 0, 'IpF߷o', 'IpF߷o', '4.I0!0yxr](FWJV', '', 0, '?'),
 ('g70VU`Iz', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/PsrLogAdapter.php', 0, 'U\Z+@D1', 'U\Z+@D1', 'C<g:xU93Jۖ1\"D', '', 0, '?'),
 ('Y!L}>wA8D', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf1LogAdapter.php', 0, 'V_k\0yĴ', 'V_k\0yĴ', 'v,r4Wp4û*L}xFX/', '', 0, '?'),
 ('pO:tL}+oJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf2LogAdapter.php', 0, '\nŶYpAkb߉0', '\nŶYpAkb߉0', '__7]>o7v$-*qX@k\"}F', '', 0, '?'),
 ('cz<A6c', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParser.php', 0, '~p_\ZGr 4]', '~p_\ZGr 4]', 'K6#o;͖җ	\Z]8NkJ܂', '', 0, '?'),
 ('GEzkņ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParserInterface.php', 0, 'Fq͚|#lf', 'Fq͚|#lf', 'Z﵆{5[:!˪', '', 0, '?'),
 ('`jT;K', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/AbstractMessageParser.php', 0, 'ڲ9c%4k(A5', 'ڲ9c%4k(A5', '˫])LpղxQx%)', '', 0, '?'),
 ('L6?NZaV', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParser.php', 0, ',O/ݷ)', ',O/ݷ)', '}Ubf|UU٦)fG[9', '', 0, '?'),
 ('c)]^', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParserInterface.php', 0, '?So\0\Zq9', '?So\0\Zq9', 'QYzoy^r\\YT8Ɠ،', '', 0, '?'),
 ('yA?ZfMeK]e4', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/PeclHttpMessageParser.php', 0, 'l|1aSÉ8', 'l|1aSÉ8', 'bO=J3EƂs~}e2`kG@', '', 0, '?'),
 ('-AF\0DN', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/ParserRegistry.php', 0, '8WYl@\n', '8WYl@\n', '^SWu;QO!ЌsPY͊[', '', 0, '?'),
 ('	2gf4Gq', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/PeclUriTemplate.php', 0, 'O qYYsi', 'O qYYsi', 'cy۫8 O_O>Y§s{%', '', 0, '?'),
 ('x=}#', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplate.php', 0, 'Ś!^۴+EB', 'Ś!^۴+EB', 'a=X\n<9&[LP', '', 0, '?'),
 ('TߔH]=\"', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplateInterface.php', 0, ' ⁀*νjDX', ' ⁀*νjDX', '6	^Q\\s!w$N90$', '', 0, '?'),
 ('ͤfJϥ7', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParser.php', 0, 'ef\rh2+\Z1Ԍ(', 'ef\rh2+\Z1Ԍ(', 'BbgFJ9?ItaAkTl_', '', 0, '?'),
 ('U5u', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParserInterface.php', 0, 'ˌ:Z-', 'ˌ:Z-', 'balrziQT	SZѓfJk', '', 0, '?'),
 ('w\nvv9hv[x1', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Async/AsyncPlugin.php', 0, 'kt', 'kt', 'TMFjE S(S', '', 0, '?'),
 ('6?p<!y[cvk', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php', 0, '&=_r2', '&=_r2', 'yK;.T\rrs![,.	o,', '', 0, '?'),
 ('\Zsx&ha\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php', 0, 'Sÿ1.k', 'Sÿ1.k', 'YZL\0 --a8e\":\\c0', '', 0, '?'),
 ('Ra4Z/\0\"2F', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffLogger.php', 0, '.څR`uDLHP', '.څR`uDLHP', 'XQt<bmy9#08e3+hn\Z', '', 0, '?'),
 ('#xt3!R', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffPlugin.php', 0, 'RR͔%', 'RR͔%', ':rBm.eFF\ncR/\":v5_#LV', '', 0, '?'),
 ('ueC_,ém', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php', 0, '5Խ18/|o/', '5Խ18/|o/', 'cyz]|a\"樘e', '', 0, '?'),
 ('˶Q}l\\ذ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php', 0, '\n/h>', '\n/h>', '6WD2Ҷ0zdV:SR0h>', '', 0, '?'),
 ('Wtwqk>i.', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php', 0, '8H].̇n\"В9', '8H].̇n\"В9', '|ƴϋ2rgmRl\"`)L', '', 0, '?'),
 ('m)4x*', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php', 0, 'z\0ݽDhĻ%', 'z\0ݽDhĻ%', '\ZϗjĄ!3\r	4>', '', 0, '?'),
 ('G\'ȶS[', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php', 0, 'bt,p7bT', 'bt,p7bT', ';4GI7C-R}29', '', 0, '?'),
 ('0&(Th', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php', 0, 'DCiun550g', 'DCiun550g', 'd.ҹ4?-͸e8Qጦ\"', '', 0, '?'),
 ('1\r\0^*.n/9', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php', 0, '\Z3]^\0sm', '\Z3]^\0sm', '	j_\nV;t\\p8\n', '', 0, '?'),
 ('+N;$&\Zg\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php', 0, 'EJs@qNB>0', 'EJs@qNB>0', '=F|I*5vhOvAhn', '', 0, '?'),
 ('S5Av9wDmR', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php', 0, '[Qf{B9A', '[Qf{B9A', 'PUn[%=_#u_', '', 0, '?'),
 ('0nxL', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheKeyProviderInterface.php', 0, 'a^q-5EZCRA', 'a^q-5EZCRA', '=s-oS@TA_ʏe<E{B\n', '', 0, '?'),
 ('QB)J=', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CachePlugin.php', 0, ';0K=2g@͍', ';0K=2g@͍', 'R\\#o; *+zs{JV-F', '', 0, '?'),
 ('&3ۈHP4f', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheStorageInterface.php', 0, '^F<)ҿ՜l', '^F<)ҿ՜l', '뿦\'PT~;MC+@get', '', 0, '?'),
 ('\rV0Z#}xvi+', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CallbackCanCacheStrategy.php', 0, '&/{h4x2', '&/{h4x2', 'MNcc&?)v+<(A\'\04z3v', '', 0, '?'),
 ('i*\n1,)[', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CanCacheStrategyInterface.php', 0, 'sY(XwK7', 'sY(XwK7', 'fy!OylF5v Dwi/', '', 0, '?'),
 ('- ?̰', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheKeyProvider.php', 0, '_e㙩ͮ+', '_e㙩ͮ+', 'i|\r5+j/*sZvD', '', 0, '?'),
 ('	7@8KFP[', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheStorage.php', 0, 'p~\\\'acl', 'p~\\\'acl', 'VP%oa<DH+ƶ', '', 0, '?'),
 ('p^ybg&g', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCanCacheStrategy.php', 0, 'rܜG#i=ö/<', 'rܜG#i=ö/<', '<t@/|£`ʻ+I\"2ɞ', '', 0, '?'),
 (',(b3h(e|', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultRevalidation.php', 0, '⩩mPyS', '⩩mPyS', '%b<24!cIgc(;cD9', '', 0, '?'),
 ('@ݬ|x7:m', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DenyRevalidation.php', 0, 'w5y؝w]bg', 'w5y؝w]bg', '55dNae^G', '', 0, '?'),
 ('G:):`N', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/RevalidationInterface.php', 0, ')ETQFu', ')ETQFu', 'TT\'h.k{&F\'v\0/`\0pcif53', '', 0, '?'),
 ('R2E&\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/SkipRevalidation.php', 0, 'M9a\'', 'M9a\'', 'b<w:$t/׼@\n_', '', 0, '?'),
 ('\063M}', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Cookie.php', 0, '2aC?\rfqn', '2aC?\rfqn', 'iáꧭx\'AWyVpR5', '', 0, '?'),
 ('؅\rJY~-MVS', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/ArrayCookieJar.php', 0, 'g;5JDc', 'g;5JDc', '<\"R{1}6y6o', '', 0, '?'),
 ('mlrH08]', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/CookieJarInterface.php', 0, '\'Xw<hJLڏ', '\'Xw<hJLڏ', 'Lr\0QTTdmorƃ4Qj', '', 0, '?'),
 ('H29?81=', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/FileCookieJar.php', 0, '/>!LG', '/>!LG', '_\'D6 ЯPY{01MG Ha\0[', '', 0, '?'),
 ('bY5UR', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookiePlugin.php', 0, '[t.ޱƳuu8{', '[t.ޱƳuu8{', 'ro_Fw\Z$w?@q]Qbf2o', '', 0, '?'),
 ('8;R̳}Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Exception/InvalidCookieException.php', 0, 'jzm#Ir\ny', 'jzm#Ir\ny', 'da\ng-GC7~Fܳ+2gh', '', 0, '?'),
 ('r#}ӒkO', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/CurlAuth/CurlAuthPlugin.php', 0, '5j>?~[-{', '5j>?~[-{', 'wNuǃro;ADfa', '', 0, '?'),
 ('gc_NG', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponseExceptionInterface.php', 0, '&3f=g-\n', '&3f=g-\n', 'QNF0;7xQ!|h\\?V', '', 0, '?'),
 ('1M:C\r6}a^', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponsePlugin.php', 0, 'Ez{8;j\Za', 'Ez{8;j\Za', '\\F#am\rX|tARW', '', 0, '?'),
 ('=j7\n0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/Exception/ErrorResponseException.php', 0, '9CZg', '9CZg', 'YRWeup{³R>', '', 0, '?'),
 ('%,H6>1', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/History/HistoryPlugin.php', 0, 'eHs\rORif', 'eHs\rORif', 'iմLĢȬ7q\Zp\r]V^', '', 0, '?'),
 ('aWXֽ٣#>#', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Log/LogPlugin.php', 0, '{(A,d1B', '{(A,d1B', '#>ig[r1?U0\0', '', 0, '?'),
 ('NO}R)sь;', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/CommandContentMd5Plugin.php', 0, 'dIJ>\\', 'dIJ>\\', 'c&??rpipWRpE\0è', '', 0, '?'),
 ('Nzhs', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/Md5ValidatorPlugin.php', 0, '!+vmٷ޲|', '!+vmٷ޲|', '[Qiv[*G_)C}', '', 0, '?'),
 ('<aݐz7', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Mock/MockPlugin.php', 0, '~S5>,oV.ϡle', '~S5>,oV.ϡle', '.ѩ\"rF;VڞD', '', 0, '?'),
 ('z=vU*ݜ_<5D', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Oauth/OauthPlugin.php', 0, '_mAB\rM%FQ', '_mAB\rM%FQ', 'z!.>1YHhd@\Z', '', 0, '?'),
 ('P.S\0}Kh', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/AbstractConfigLoader.php', 0, 'ݢyi1+Ɛ^', 'ݢyi1+Ɛ^', '%\n|_,JJiX/1	2o@', '', 0, '?'),
 ('-A?MT0;9WBk', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilder.php', 0, '\'\\/	v', '\'\\/	v', '5>@)n*]uٵb9v/', '', 0, '?'),
 ('jA7|if(', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderInterface.php', 0, 'e U\n~ɹ', 'e U\n~ɹ', 'wd\'{.w;Ξ\Z@vH`E7', '', 0, '?'),
 ('-,n\n>>kg', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderLoader.php', 0, 'Sdu\0Nkga', 'Sdu\0Nkga', 'QD?\'>.זBBǶ,Uk', '', 0, '?'),
 ('fsIB=r>g', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/CachingConfigLoader.php', 0, ',iS\'d', ',iS\'d', 'VKw0n~1[Z]\00Ot', '', 0, '?'),
 ('FyhǽN', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Client.php', 0, 'h~gx#}u', 'h~gx#}u', 'l*\"J)m1nΈ;$OX1', '', 0, '?'),
 ('g[uBGizsE3G', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ClientInterface.php', 0, 'ibZKhdL\\', 'ibZKhdL\\', '$CĄ05H~1;p1%Zd>toá', '', 0, '?'),
 ('[a#', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/AbstractCommand.php', 0, '^ުz)~c', '^ުz)~c', '^Uw1xNۭE!XNq^d|GJq', '', 0, '?'),
 ('\\s/{(L̵', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ClosureCommand.php', 0, '8v0~ۜ߭R$', '8v0~ۜ߭R$', '1UxfjoI}', '', 0, '?'),
 ('LM.%VYd', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CommandInterface.php', 0, 'OA\'9\'+;姗ax', 'OA\'9\'+;姗ax', '!C,V-g$FxZܷ뗆l', '', 0, '?'),
 ('}VJO`M5/\r', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CreateResponseClassEvent.php', 0, '3n.nPh=', '3n.nPh=', 's; 2i/[?ڪ;ﻰő`', '', 0, '?'),
 ('e`\rղa', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultRequestSerializer.php', 0, 'p)]zj', 'p)]zj', '~9%GWB', '', 0, '?'),
 ('CR\"l5u<y{', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultResponseParser.php', 0, 'OjjbwX3', 'OjjbwX3', '@\"UsXW5&qVHOr', '', 0, '?'),
 ('\niB4\'Պ^+', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/AliasFactory.php', 0, '\rUQGjD5_;', '\rUQGjD5_;', 'c/F;gG}*RFSQɡ\\V', '', 0, '?'),
 ('lN;Vvd', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/CompositeFactory.php', 0, '-\\AbQ*wDD', '-\\AbQ*wDD', '(]h?\":X\r.\Zpߵ', '', 0, '?'),
 ('V~Rݡݤyx @', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ConcreteClassFactory.php', 0, 'n\nz!w><T', 'n\nz!w><T', 'ȸGnq6S{\nYkO!޿C(t', '', 0, '?'),
 ('PA\r?^>', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/FactoryInterface.php', 0, '`r?}\\', '`r?}\\', '5-tP\"xX0w\"2q', '', 0, '?'),
 ('	y[^?Y', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/MapFactory.php', 0, 'DEW\'&', 'DEW\'&', '\"\'/M-T~JoDu', '', 0, '?'),
 ('n0s(Ú\\]<f', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php', 0, 'hPmpC3V', 'hPmpC3V', '֎Mg錷3ccɂdw!ͧ', '', 0, '?'),
 ('Nw5e浳\\Uxu', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php', 0, 'E!fD]rKԚ', 'E!fD]rKԚ', '0pX7A\Zlǚy2\rfY+', '', 0, '?'),
 ('I)葍K@4I', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php', 0, 'mYQy', 'mYQy', '2ǲ\0}?C\"͋§\r9C', '', 0, '?'),
 ('缂ac', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php', 0, '\"lѼ)&L{6gG', '\"lѼ)&L{6gG', ';f6)T\"', '', 0, '?'),
 ('Wt[?ĦHƣ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php', 0, 't>e=8', 't>e=8', 'ƤeIMܾ_5L~R㹆Meߝ`Ѩ', '', 0, '?'),
 (']%l9L', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php', 0, '	:gJď', '	:gJď', '@k*_rd:g$T|&;', '', 0, '?'),
 ('@[saPEߦ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php', 0, '%k7ۻ+', '%k7ۻ+', 'h˨d0*U|\Z7!sJˁ̋.', '', 0, '?'),
 ('jcR*Y߉ ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php', 0, 'jJI`\rLw', 'jJI`\rLw', 'I=Q (9ιop/HY', '', 0, '?'),
 ('r~\0+B {4<', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php', 0, ']D.,Xe', ']D.,Xe', 'nxitS韻C>JZ', '', 0, '?'),
 ('3r3`&4', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php', 0, '\ZJ@M/e_L', '\ZJ@M/e_L', '[w-,=LĴ\0)ا{Ζ:K', '', 0, '?'),
 ('A|\nUjR/', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php', 0, 'UUx3Je)&', 'UUx3Je)&', 'xꟃEHUiOX32', '', 0, '?'),
 ('u×zb/', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php', 0, 'Kȅ{G߭', 'Kȅ{G߭', 'q.9ꃊ)QK!Wtt[\ne', '', 0, '?'),
 ('~\Z<M`GO{N', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php', 0, '1ͩ#3', '1ͩ#3', 'ֽ=lB壥\0O<d\n', '', 0, '?'),
 ('|-\r7	d@l', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php', 0, 'C2O?LJ.\"', 'C2O?LJ.\"', 'VBں]!$[m3H;?Iglї݃)&a', '', 0, '?'),
 (']P)8K3x댠', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php', 0, 'ƫY\\Ӥ7iIчU', 'ƫY\\Ӥ7iIчU', '\Z}WT0+A ff', '', 0, '?'),
 ('v֎\'NqFDƮ:', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php', 0, '\nAjJm8W^IM', '\nAjJm8W^IM', 'E|6EJ5XK}\"F>3<f', '', 0, '?'),
 ('u˺M9T', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php', 0, '#)^sP$', '#)^sP$', 'ૠHK51FWt=ĖE_Lr~h', '', 0, '?'),
 ('wRjf`Z{', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php', 0, '>{O<܅b1', '>{O<܅b1', 'o8%d=D-ojSYJK$7', '', 0, '?'),
 ('[+06-', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php', 0, '/\"W.r`xD', '/\"W.r`xD', '|G7W߉\r	)NJQ`J}g\"Q', '', 0, '?'),
 ('2+aQ<', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php', 0, '72c,Y', '72c,Y', 'pxeP̋_X\\$8MJZx|', '', 0, '?'),
 ('h{ea`,_o', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationCommand.php', 0, 'SO6-7#h\r', 'SO6-7#h\r', 'sNtxwp{', '', 0, '?'),
 (';s`\\', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationResponseParser.php', 0, 'es!\Z', 'es!\Z', '	cuZ[Y\0^uO() \0&TL3', '', 0, '?'),
 ('Sа7Ȗ(', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/RequestSerializerInterface.php', 0, '\'$Cd\"}|k@', '\'$Cd\"}|k@', 'XA54Ե7,mҕJ`ݫ\Z', '', 0, '?'),
 (')(f1', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseClassInterface.php', 0, 'pyud#΁S$5', 'pyud#΁S$5', 'Rmե8/fx:Ӑto5~ą[V', '', 0, '?'),
 ('ԅ8n8/y', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseParserInterface.php', 0, 'xNwy[8', 'xNwy[8', 'YT rlQT\"@u?3x	?', '', 0, '?'),
 ('/#}ڷjܠ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ConfigLoaderInterface.php', 0, '+	qL+Sm', '+	qL+Sm', 'h\0wgA[Yz?y!ɳ~s', '', 0, '?'),
 ('><|tEлo', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Operation.php', 0, 'EVI%wF', 'EVI%wF', 'BTXTh96\nrm*>6JM_Lr', '', 0, '?'),
 ('}3pC_-Z&64', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/OperationInterface.php', 0, 'Yc٬D[nDK', 'Yc٬D[nDK', '+/\r-/-tg!Qhq$', '', 0, '?'),
 ('=dZpehnr$', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Parameter.php', 0, 'Bmu\ZU@', 'Bmu\ZU@', 'hG?ei낲ݿ٘I/d3ة', '', 0, '?'),
 ('p&`Z6z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaFormatter.php', 0, 'S5»9', 'S5»9', 'Z@[	8ƍ>;\'+N', '', 0, '?'),
 ('+@5Uc', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaValidator.php', 0, 'W9Pڠ&B', 'W9Pڠ&B', 'TB>4څJz\'PvUfn', '', 0, '?'),
 ('#9a@0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescription.php', 0, '{<B[224;͎=', '{<B[224;͎=', 'brcs\nvU[/84El!֋', '', 0, '?'),
 ('-Źz^G', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionInterface.php', 0, 'pvRGUy\r	f', 'pvRGUy\r	f', '$0(p,_;%g=r*p%p', '', 0, '?'),
 ('õ!-pw%`kT', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionLoader.php', 0, '\"1:o8c', '\"1:o8c', 'V9{3HO$w_wߝ\':', '', 0, '?'),
 (')oTX=', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ValidatorInterface.php', 0, 'pjmɑ>gGT', 'pjmɑ>gGT', '{G!j\Zox', '', 0, '?'),
 ('$X︈<_ ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandException.php', 0, 'X:4tqnhm', 'X:4tqnhm', 'G{]apGRj|)TAd\ZƧVǮ[t', '', 0, '?'),
 ('ː7^\"g,%', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandTransferException.php', 0, 'W.h.C^d', 'W.h.C^d', 'dR5e(`cfyTrDٓ', '', 0, '?'),
 ('?,xm=]yX#', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/DescriptionBuilderException.php', 0, '^{oq>', '^{oq>', 'M-βX{Adozm(g>', '', 0, '?'),
 ('4/|g)iU', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/InconsistentClientTransferException.php', 0, '4\'Sh]8B?=', '4\'Sh]8B?=', 'Jy)N0ǖܠAħNi*\"ls	', '', 0, '?'),
 ('L<x^*', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ResponseClassException.php', 0, '$iMrIa&#', '$iMrIa&#', ' I_ځY8;ǋy?', '', 0, '?'),
 ('5vƱA쒢jŬ', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceBuilderException.php', 0, ',(^N4', ',(^N4', 'ܤR#liici:3QG&h_Ƨ', '', 0, '?'),
 ('q8L@6|}Q3\0Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceNotFoundException.php', 0, ',&e5jƛR ', ',&e5jƛR ', 'ɶ+(,[O\0,_:hJb', '', 0, '?'),
 ('@/A+<~G55', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ValidationException.php', 0, 'kBGbw>!+', 'kBGbw>!+', 'z FߓoeU&uw3\Ztc&', '', 0, '?'),
 ('{$]Lٌw}', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php', 0, 'ow&kc', 'ow&kc', 'grF\n.oUPdǱdgW', '', 0, '?'),
 ('?<g;O/\r>', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php', 0, '\rp=þk\n', '\rp=þk\n', ' +Y|vssxe\\ zKfI&', '', 0, '?'),
 ('`Zc	4	-=', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/MapResourceIteratorFactory.php', 0, 'I&殀!!T.\"', 'I&殀!!T.\"', 'xBfgQU/erUUko8', '', 0, '?'),
 ('\\₱đAxx', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/Model.php', 0, '	sHYӨ*', '	sHYӨ*', '\Z1%Eb}鳢t/DL5', '', 0, '?'),
 ('ft\\[9', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIterator.php', 0, 'Bb=x\ZS', 'Bb=x\ZS', '\niV5Ki}EAt7̉\rt)f|<P', '', 0, '?'),
 ('MtyEmw\\T@', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php', 0, '$H7RE~', '$H7RE~', '`\\8j~\ZTR}Du', '', 0, '?'),
 ('4ҝN:s%{', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorClassFactory.php', 0, 'lN6Y)K/R', 'lN6Y)K/R', 'Gvd\"-ϰ>ɖht#E$[/L', '', 0, '?'),
 ('MAx~2Pw', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php', 0, 'ghGi\0*T\"\n}', 'ghGi\0*T\"\n}', 'GBh	䋚czs\Z,', '', 0, '?'),
 ('nakOu', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorInterface.php', 0, 'ge_d٬\n', 'ge_d٬\n', 'ZGgE\"?3L/', '', 0, '?'),
 ('\\\rL>{GOk\r\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/PhpStreamRequestFactory.php', 0, 'WVѐFQ#ԂB', 'WVѐFQ#ԂB', '0fdgI{{]3t;Rsd', '', 0, '?'),
 ('UݷV̳C\\', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/Stream.php', 0, '1\0!', '1\0!', 'j	f\'gH\"Ex2b~F\\e4', '', 0, '?'),
 ('`8G5\nP', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamInterface.php', 0, '2,ANS[', '2,ANS[', '%gt隆lpXIѥI@C̲r', '', 0, '?'),
 (',v=PqYy\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamRequestFactoryInterface.php', 0, 'v-HXH/0D', 'v-HXH/0D', 'OJ褼TkQ\r.LzY%0DU2', '', 0, '?'),
 ('^F7ӣ)	', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCache.php', 0, 'egJMٝH\\', 'egJMٝH\\', '%h?\nӺ1EoP/f/\ZY', '', 0, '?'),
 ('!\0.3|yy}', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollection.php', 0, 'Bg/m', 'Bg/m', 'j](R\Z9N_=k$', '', 0, '?'),
 ('dtt\'=', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollectionInterface.php', 0, 'k>9Ǧ:̭', 'k>9Ǧ:̭', 'ʸT޺%KRǕi>=b', '', 0, '?'),
 ('ExU\'\'[/', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetInterface.php', 0, '}/m}硑', '}/m}硑', '+8Zk`~)v1٪', '', 0, '?'),
 ('_\'\0I2?', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetReference.php', 0, 'ӯ-/-', 'ӯ-/-', 'jv6];PWf.)苲!-*', '', 0, '?'),
 ('fPvJSkbʠ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/BaseAsset.php', 0, '1Xw?m\\$', '1Xw?m\\$', 'Г pĩ(c3o8%B5IhsL͐U', '', 0, '?'),
 ('RP!Ibq/!', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/FileAsset.php', 0, 'qg$$5k', 'qg$$5k', '\"eo8oZ\\\"xz%5pa\r', '', 0, '?'),
 ('	|4˘|l1\\~', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/GlobAsset.php', 0, 'I4RJC0NB>', 'I4RJC0NB>', 'UC81`d\n		YVG<.pu', '', 0, '?'),
 ('*mG', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/HttpAsset.php', 0, '[G?hm0b_', '[G?hm0b_', '\r]ZhQ6!\'~.bꂨd8I', '', 0, '?'),
 ('x$}', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionFilterIterator.php', 0, '7Ү<$ٛ ', '7Ү<$ٛ ', '%m.[6A2^aa#(R=\r#*', '', 0, '?'),
 ('ɦ-sg=&Hf!-', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionIterator.php', 0, '.dY)L', '.dY)L', 'sh7tJE_\"0\Z', '', 0, '?'),
 ('BEc~ᣉ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/StringAsset.php', 0, 'jTWMIMe', 'jTWMIMe', '?-yeP/#', '', 0, '?'),
 ('s\rb;uRw;nq', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetManager.php', 0, 'Q`A[\n\\a\0', 'Q`A[\n\\a\0', 'B[p?mpm~#FE,y\0ק', '', 0, '?'),
 ('6Dإl', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetWriter.php', 0, 'BIb ^wF', 'BIb ^wF', 'zEky\nE;1]GmY|', '', 0, '?'),
 ('+VȄ\r)ȟb', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ApcCache.php', 0, 'cs* ݦ,R', 'cs* ݦ,R', '\negj]CVsʀE5fDq', '', 0, '?'),
 ('Gi=~ę\rD', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ArrayCache.php', 0, 'e2Cdn', 'e2Cdn', 'Ai=\']&p#݉1{]\r', '', 0, '?'),
 ('NP*zpT^A', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/CacheInterface.php', 0, 'Έ  Cr\Z`', 'Έ  Cr\Z`', '|ML2~ܥ@&bҺ', '', 0, '?'),
 ('8~0Ju?2', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ConfigCache.php', 0, 'h-Sa٬', 'h-Sa٬', 'ڤrpu0哗Χ*/I\nU(', '', 0, '?'),
 ('r82I{_:', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ExpiringCache.php', 0, '/VDS@,2~^ԡ', '/VDS@,2~^ԡ', 'rE\n(16ȇ\\:;fg&Is', '', 0, '?'),
 ('~bT,ڂJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/FilesystemCache.php', 0, '#瞻!\'%8', '#瞻!\'%8', '̿.o]0!RI凁@ޙ4Ll', '', 0, '?'),
 ('Ǉ\"ȮvQnRK7', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/Exception.php', 0, 'c>#lPE::', 'c>#lPE::', '?dr!HY\0@0u[', '', 0, '?'),
 ('1_+K>-', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/FilterException.php', 0, '~&{Q', '~&{Q', '/x%Rl:H4%', '', 0, '?'),
 ('_', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticExtension.php', 0, 'w`̕~?P 3\Z', 'w`̕~?P 3\Z', 'qW:[WM5JnDoRqdT˛J', '', 0, '?'),
 ('\0H9{LXG', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterFunction.php', 0, '7}XzA', '7}XzA', '$&jzpF#+ec΢{tDY۲', '', 0, '?'),
 ('#8=%iL', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterInvoker.php', 0, '|:a}|x', '|:a}|x', 'Aĵ VّwCP|aQԹH', '', 0, '?'),
 ('寵FZtcHa', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterNode.php', 0, '=W)}n+SҖs', '=W)}n+SҖs', '.J3\0}\"v\\:ޭק&ǚ#?i;', '', 0, '?'),
 ('_aL1y*5\\5', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticNode.php', 0, 'чˀKa\\cxTy', 'чˀKa\\cxTy', '-dzQ)c8Z>@ΤS?', '', 0, '?'),
 ('gyKSx^', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticTokenParser.php', 0, 'QXJu*U\rf]O*O', 'QXJu*U\rf]O*O', '<f}{HOڥE>FM', '', 0, '?'),
 ('(H@S^`', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigFormulaLoader.php', 0, '|7F03jU', '|7F03jU', 'B*Gtb(MI5s	^F,A', '', 0, '?'),
 ('h}+Pxn\\5', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigResource.php', 0, '79/W9|v', '79/W9|v', 'Brda7ӷ8`K;l9(Xȸ', '', 0, '?'),
 ('ޚ4;<3gq', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/ValueContainer.php', 0, 'G4Y@Zm/܌v%', 'G4Y@Zm/܌v%', 'ӍBߤ-kMdH0,$?,fM<', '', 0, '?'),
 ('-kjH);p\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/AssetFactory.php', 0, 'VR.r', 'VR.r', ']KU\"4KX^\n.?e@P2e', '', 0, '?'),
 ('0l{C!Dr', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/LazyAssetManager.php', 0, 'ʖ	DY', 'ʖ	DY', 'DdC:160\rwʍxks-x', '', 0, '?'),
 ('@ʘGϺz`', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/BasePhpFormulaLoader.php', 0, '5,^iME', '5,^iME', '	3s2aT3O\nԏh&GBd/', '', 0, '?'),
 ('1C9vY-!', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/CachedFormulaLoader.php', 0, '\nYn}7~ \0\\', '\nYn}7~ \0\\', 't䣛&`Zz><|XЛzgP', '', 0, '?'),
 ('#!', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FormulaLoaderInterface.php', 0, 'Qo@H#', 'Qo@H#', 'p$)f2m4QLRk', '', 0, '?'),
 ('\Z2sX;-P', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FunctionCallsFormulaLoader.php', 0, 'Ԇ]\rNj', 'Ԇ]\rNj', 'qkkxL.=E0Ux', '', 0, '?'),
 ('k@XJ	8cDh', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/CoalescingDirectoryResource.php', 0, 'RV_', 'RV_', 'I\rk],TT	.6X', '', 0, '?'),
 ('R@^3-S%', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/DirectoryResource.php', 0, '9^\'J', '9^\'J', 'Nj]sCU\'+Ěw2[GDwk;', '', 0, '?'),
 ('`݉ZrL6', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/FileResource.php', 0, '>pv', '>pv', '3SJ*oiU˗-u	!', '', 0, '?'),
 ('!6]\\I', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/IteratorResourceInterface.php', 0, '!Ȍ%LB{T\\', '!Ȍ%LB{T\\', ')2!lnڡq!', '', 0, '?'),
 ('BjϥbEo ?', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/ResourceInterface.php', 0, '\rfqǏt٠', '\rfqǏt٠', 'V\\]]*@>|z}\'\"\'M', '', 0, '?'),
 ('moFT\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/CacheBustingWorker.php', 0, 'F+/*(', 'F+/*(', 'ޏ;|>}\\p$pʲBZ', '', 0, '?'),
 ('\",)#`B', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/EnsureFilterWorker.php', 0, '}z7#sFx#', '}z7#sFx#', '<_~\nE^l~!,wk7dZf+', '', 0, '?'),
 (':cf}倁$\n', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/WorkerInterface.php', 0, 'Cյ_|\nrׅ', 'Cյ_|\nrׅ', 'r\r:NEQa=e!:8F/', '', 0, '?'),
 ('\'s6:7A9XD', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/AutoprefixerFilter.php', 0, '\08:R\')S', '\08:R\')S', 'lJcmDe\ZL!(\nS', '', 0, '?'),
 ('o嬶	^', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseCssFilter.php', 0, '3z~iiҠGg6|', '3z~iiҠGg6|', '	GT{;\n*KXBM3ooN3@H', '', 0, '?'),
 ('evs\"q', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseNodeFilter.php', 0, '_CvLSNP', '_CvLSNP', '9;Z\0#ĵ{7l', '', 0, '?'),
 ('p [Ea', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseProcessFilter.php', 0, '&:(]u#OaI&', '&:(]u#OaI&', 'YQ<CdT\nζ.Z`RC/', '', 0, '?'),
 ('G=n; !=:_', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CallablesFilter.php', 0, '# .Vk', '# .Vk', 'qaTbrl\n80k', '', 0, '?'),
 ('Pw#T', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CleanCssFilter.php', 0, ')*7r0', ')*7r0', 'Ø+\\@)>\01yWbkX\'z', '', 0, '?'),
 ('Zy\'}fmX<', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CoffeeScriptFilter.php', 0, '%Q-j\rnE', '%Q-j\rnE', '_р\rQ{O[nB=<o*6	$.5x', '', 0, '?'),
 ('!8%D\'H', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CompassFilter.php', 0, 'n\\F\'', 'n\\F\'', ':|zB=9Rd^{jdׄd<', '', 0, '?'),
 ('ip]wz', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssCacheBustingFilter.php', 0, '\Z)gpx3\'?', '\Z)gpx3\'?', 'nLةnmx&8Q1\n', '', 0, '?'),
 ('htq@Yw', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssEmbedFilter.php', 0, 'EWEX$pE', 'EWEX$pE', 'ϫ\'W?	ET#[I(', '', 0, '?'),
 ('N=$*;e3', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssImportFilter.php', 0, 'vĜL}8o8', 'vĜL}8o8', '8;T,D2z*{0C', '', 0, '?'),
 ('f[4#Y_m', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssMinFilter.php', 0, ']}iYT?', ']}iYT?', '/tϜTji7:U8Lv@7JW', '', 0, '?'),
 ('>&\"~y', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssRewriteFilter.php', 0, 'PU$޳iR', 'PU$޳iR', 'JY\"뱅NÆ;k M@Bʅ}', '', 0, '?'),
 ('JP\\L^M>0', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DartFilter.php', 0, 'M~#]Ek', 'M~#]Ek', 'f~=qTV/3OK>X', '', 0, '?'),
 ('X_\"g\nWCP\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DependencyExtractorInterface.php', 0, 'ƺ\\0?Buc', 'ƺ\\0?Buc', 'p/dX+d;bN/Z', '', 0, '?'),
 ('ȐtO\r)', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/EmberPrecompileFilter.php', 0, 'cU', 'cU', 'ye\riSrOsX$/J', '', 0, '?'),
 ('k	*x=$ƙO\0\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterCollection.php', 0, '@aN~Q[7', '@aN~Q[7', ')-ҎLF~ <`p$+r.f g', '', 0, '?'),
 ('ɺ³6{	p', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterInterface.php', 0, '~:1Ho o', '~:1Ho o', 'P<qrMЉb(He=-zJњKM{6', '', 0, '?'),
 ('H*$8vW׮', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/BaseCompilerFilter.php', 0, 'c8;ç)ua', 'c8;ç)ua', 'E1tԨ;VКm\"zTQRi', '', 0, '?'),
 ('\\QJ*	\"å', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerApiFilter.php', 0, 'D7r\0t֧HSK|m', 'D7r\0t֧HSK|m', 'VHƴf-X ^o', '', 0, '?'),
 ('0C7D5g', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerJarFilter.php', 0, '.%8RaY͌', '.%8RaY͌', 'dM\"B]_\0z2kN\rZ2 sy', '', 0, '?'),
 ('T\niyNsڌ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GssFilter.php', 0, '\rӜvg0', '\rӜvg0', '&L+\rm<BZk\0\\O{z%', '', 0, '?'),
 ('uVK\'&z=l', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HandlebarsFilter.php', 0, 'j\\r\n\"F', 'j\\r\n\"F', 'uߩ\nFA\\VWnHMJ', '', 0, '?'),
 ('BU*0 ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HashableInterface.php', 0, 'Za<ã_WSX', 'Za<ã_WSX', ',^Ev+蟸8M\nn\0A', '', 0, '?'),
 ('Q@zQcy;yx', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinFilter.php', 0, '5#	fD+GZ', '5#	fD+GZ', 'ep$cz/R}h\"8n8\n$', '', 0, '?'),
 ('clܕP-', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinPlusFilter.php', 0, 's8~`xST3', 's8~`xST3', '9sov\no5_iX_@', '', 0, '?'),
 ('fz6p', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSqueezeFilter.php', 0, 'p	UМbݼ,', 'p	UМbݼ,', 'aLYakGcT]\'P|*d\Zt', '', 0, '?'),
 ('DP4#4z', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegoptimFilter.php', 0, 'c-\"gSr`', 'c-\"gSr`', '(ܧ2R/K|L;S@I', '', 0, '?'),
 ('/9gr[(~k', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegtranFilter.php', 0, '_7\\&@\n', '_7\\&@\n', '§ ]$1TtZ\"efNcn:]dd', '', 0, '?'),
 ('pRjr?\Z6', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessFilter.php', 0, 'i&x)OV@V\0', 'i&x)OV@V\0', '\njh?zQ({(=', '', 0, '?'),
 ('O1Q!qi@\"', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessphpFilter.php', 0, 'yDyF?K>\n0', 'yDyF?K>\n0', '6qW{zXb$͒z\\H@ ', '', 0, '?'),
 ('9c4(', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/MinifyCssCompressorFilter.php', 0, 'I*GKn>dܶ', 'I*GKn>dܶ', 'r!Ftpv=2', '', 0, '?'),
 ('!2`*_', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/OptiPngFilter.php', 0, 'mgWΊE', 'mgWΊE', 'j%\nCo	ڎf\\-d♍)mQpx', '', 0, '?'),
 ('jLs/JV?', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackagerFilter.php', 0, '+\'?=_\0<y', '+\'?=_\0<y', 'z	:ԋ/p2(U({sw&	j~f1T4', '', 0, '?'),
 (']0\'K0\rR?', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackerFilter.php', 0, 'mzz=fAH', 'mzz=fAH', ',n͞I6Y+d', '', 0, '?'),
 ('\'\r>疹Nn0', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PhpCssEmbedFilter.php', 0, '@-}C3,7', '@-}C3,7', '~>K@h~\'\r7DNyLr', '', 0, '?'),
 ('®NĳqVQ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PngoutFilter.php', 0, '<qb(C', '<qb(C', ',\r$KjݶOvv	_#\n', '', 0, '?'),
 ('7\nزW', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ReactJsxFilter.php', 0, '85Yb{f[W', '85Yb{f[W', ':7Cւa@ش٥3X&{rbp', '', 0, '?'),
 ('|NϜ7=;~*,', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/RooleFilter.php', 0, '/0ۿf\'a\n|!', '/0ۿf\'a\n|!', '(\Z	60\0HmnODL-,vdo', '', 0, '?'),
 ('uFA\'Dd', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/BaseSassFilter.php', 0, '֫:[m?!P?p', '֫:[m?!P?p', '\n#`bn	H=,k䩱K', '', 0, '?'),
 ('\')%ϗ{', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/SassFilter.php', 0, 'f:Ucl\n', 'f:Ucl\n', ':\rk<0Չd47=H4{\rG', '', 0, '?'),
 ('L-u!&', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/ScssFilter.php', 0, '&rԶ\\Y슞E2N', '&rԶ\\Y슞E2N', '}KMg(5&m\Zm3xF%l@V', '', 0, '?'),
 ('W7j:Pƭ|', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SassphpFilter.php', 0, 'PŞj6X߈v', 'PŞj6X߈v', 'L._son&A6wO8\"k', '', 0, '?'),
 ('PW0_D;H<BY', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ScssphpFilter.php', 0, 'yt\ndfN', 'yt\ndfN', 'fJ6<&biG#jG\re^', '', 0, '?'),
 ('6$> v', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SeparatorFilter.php', 0, 'kɽF[±', 'kɽF[±', '^M	m697J4cu', '', 0, '?'),
 ('T1{ϛwϝ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SprocketsFilter.php', 0, ' EIr0 첯9', ' EIr0 첯9', 'ٰNE4AÞ(\nB>[`X@', '', 0, '?'),
 ('9V\"+x', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/StylusFilter.php', 0, 'VR\"iR:|/', 'VR\"iR:|/', 'ULc5>\\܍mdݰY(\n6}\"', '', 0, '?'),
 ('C\'qc`dɀK', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/TypeScriptFilter.php', 0, '~>L/*<', '~>L/*<', 'K\rJH3yAQ&\'JU0', '', 0, '?'),
 ('@s{C', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyCssFilter.php', 0, '+GB0e5\r', '+GB0e5\r', ']-V3إ3R*]j1', '', 0, '?'),
 ('I=fl)5Kl6*', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJs2Filter.php', 0, '\r1_&-^', '\r1_&-^', ';m 8l[o,g~ujy2', '', 0, '?'),
 (':\'Kܘ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJsFilter.php', 0, 'fvj=mJFp\Zc', 'fvj=mJFp\Zc', 'rmW[ u~.k4i?TI', '', 0, '?'),
 ('[J%]', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/BaseCompressorFilter.php', 0, '6	;cTYi', '6	;cTYi', 'Q\n[jUxfhݳaz\Zfǻ>', '', 0, '?'),
 ('\\غBD{dh', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/CssCompressorFilter.php', 0, 'tAdH', 'tAdH', 'TFXEsyyl\"HIj', '', 0, '?'),
 ('T-eDйNʼ', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/JsCompressorFilter.php', 0, 'ap%^\"', 'ap%^\"', '=z=O8kB\'8UPnOj:<', '', 0, '?'),
 ('f-;vs.', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/FilterManager.php', 0, 'FLr(؟KG', 'FLr(؟KG', 'ƓN;Q^\rO]WY', '', 0, '?'),
 ('KBް57', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/CssUtils.php', 0, 'Ro,WNSC', 'Ro,WNSC', 'v<bA5h~G5)qbn', '', 0, '?'),
 ('}CϾ0R', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/FilesystemUtils.php', 0, '֖E15zHKKmgY', '֖E15zHKKmgY', 'g@n\"[E:7n', '', 0, '?'),
 ('s\0TwK#U<', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/LessUtils.php', 0, 'J.()%t', 'J.()%t', 'NV!5#阥7Z&(lբ', '', 0, '?'),
 ('hmLT*=܌#rO\n	', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/SassUtils.php', 0, 'bnR1M', 'bnR1M', '٢\\zGVy?2#DS*', '', 0, '?'),
 ('8\\pUɹMu/', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/TraversableString.php', 0, '/.{#D=DhpH', '/.{#D=DhpH', '+<}ej\r:	Wę&cp6°}w}0', '', 0, '?'),
 ('\\27*=./', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/VarUtils.php', 0, '}.&o͔i', '}.&o͔i', '}b($Cǻ4^0jYtq', '', 0, '?'),
 (' 4	Dkr', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/ValueSupplierInterface.php', 0, '`ߴ\'n>	`', '`ߴ\'n>	`', '\\$W1U@g,Nd@8', '', 0, '?'),
 ('u̥.;)at', 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/functions.php', 0, 'kgW-ZV\0', 'kgW-ZV\0', 'nx!!Jeb2kA۸|1', '', 0, '?'),
 ('f6BH', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/AES.php', 0, 'x)0R', 'x)0R', '	[1ʢ!hhu', '', 0, '?'),
 ('g`Ps', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Base.php', 0, '}1W\\_', '}1W\\_', '̒Oл?\\)¡an#`0', '', 0, '?'),
 ('\Z\rOh\nї`2', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Blowfish.php', 0, '`H6t\rY`', '`H6t\rY`', '^)?{YQJEx%3`x<o%>N', '', 0, '?'),
 ('ڹPܛ>%', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/DES.php', 0, '*<дH,\n5$', '*<дH,\n5$', '?bz4w	\r#pPթРQgw', '', 0, '?'),
 ('TYm=\"', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Hash.php', 0, 'G\0 p', 'G\0 p', '}V+k5O^ݺ1;m{@z', '', 0, '?'),
 ('˄-\0\ZnS', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC2.php', 0, 'v\nK\'Z5D', 'v\nK\'Z5D', 'wBF͞}yGg(V:	', '', 0, '?'),
 ('46>}4(t/A', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC4.php', 0, '>=&nEh`ۉ;\0[', '>=&nEh`ۉ;\0[', 'ϣ)V\'5\r6S[,)', '', 0, '?'),
 ('@d+|>q~[', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RSA.php', 0, 'c8vJq!Y', 'c8vJq!Y', 'T) tA\"Zcw]lZVy', '', 0, '?'),
 ('#ma3jFA3', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Random.php', 0, 'Og} -g', 'Og} -g', 'RAhHaZbFc1d|\'&pL;', '', 0, '?'),
 ('yTcwj', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Rijndael.php', 0, 'xrxak\rG', 'xrxak\rG', 'h|y)mtz**P\'vyFgcY', '', 0, '?'),
 ('7Z?TitQ', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/TripleDES.php', 0, 'iڼM>(', 'iڼM>(', '7CUX	nUU¿Bi%Ȁm', '', 0, '?'),
 ('Jt:ǵ]D}f', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Twofish.php', 0, '1ί\rFA', '1ί\rFA', 'r3۾hi-\\kBqsC\nujG', '', 0, '?'),
 ('r$o3jJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ANSI.php', 0, 'gS?͆IPC٭x_', 'gS?͆IPC٭x_', '9\rTQ\n֨A(њWZ', '', 0, '?'),
 ('i*i', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ASN1.php', 0, '\rdt% *n', '\rdt% *n', 'Gs\0g_tȊi՟R\\!', '', 0, '?'),
 (' Q@4Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/X509.php', 0, 'G!B?Q	>%', 'G!B?Q	>%', 'CPFȫ\'\'\\LOt<', '', 0, '?'),
 ('zxEL|4z@', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Math/BigInteger.php', 0, 'c%I~˽B\"', 'c%I~˽B\"', '*Ĝֈ;%kwcPrPB^_\rd', '', 0, '?'),
 ('#^Xj^\0G[q', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SCP.php', 0, 'SVkP$', 'SVkP$', 'zSqŚ13AVl*del*ȔP', '', 0, '?'),
 ('h(pL', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP/Stream.php', 0, 'q!SGJ9o[C', 'q!SGJ9o[C', '/Fu~\rf\nޡ/T3ϸQ', '', 0, '?'),
 ('`	\04#\0N0\n', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP.php', 0, 'dwW|', 'dwW|', '.X&lV1C:v0ّC', '', 0, '?'),
 ('z0z_*_&Hbt', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH1.php', 0, 'b&_5kKm	~', 'b&_5kKm	~', 'iU1y\0#FM\\]\Z', '', 0, '?'),
 ('M	48G', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH2.php', 0, 'MJV5J4', 'MJV5J4', '#t0B|)SK9ց', '', 0, '?'),
 ('Ři@qW]73P]', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH/Agent.php', 0, 'AdwJ2OK', 'AdwJ2OK', 'u:})33gkH/a7*%*', '', 0, '?'),
 ('aƈV!%', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH_Agent.php', 0, ';b\r5E', ';b\r5E', '61E)\riJK஫/@̋e*', '', 0, '?'),
 ('gvݗ>&\ZaD)', 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/bootstrap.php', 0, '|Ȱ`-cqF', '|Ȱ`-cqF', 'Jϋ&rɪ;9]F', '', 0, '?'),
 ('tΪxT\'Jz', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/AbstractLogger.php', 0, '&`~SaS&', '&`~SaS&', '7Z?ΙAu*/\0G#2F', '', 0, '?'),
 ('2Sg.Sd?]6Ud', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/InvalidArgumentException.php', 0, '}/X5$9/e', '}/X5$9/e', ';5bGSB:e}!q|z6', '', 0, '?'),
 ('>N~UǓzc', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LogLevel.php', 0, '\"aB]9\r9xC', '\"aB]9\r9xC', 'nYy\"\0\nd#.eg56d\\>^', '', 0, '?'),
 ('^W|x@Z[&*', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareInterface.php', 0, 'ϬmMtѼJ', 'ϬmMtѼJ', 'f.%*ƚWnCsSi', '', 0, '?'),
 ('JrU', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareTrait.php', 0, '\"G}=\r,&5', '\"G}=\r,&5', '`ٿF`=fy`4nI\0N%', '', 0, '?'),
 ('DךzC+r-', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerInterface.php', 0, 'lFIg+4', 'lFIg+4', 'S:ZBQ5g@Q	vLgD\n', '', 0, '?'),
 (']-%V>', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerTrait.php', 0, 'C2\\՘80', 'C2\\՘80', 'MEIe_sZx/|;Jz·M-', '', 0, '?'),
 ('46cZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/NullLogger.php', 0, ',$jB', ',$jB', 'ʃ>7KO}\"HsWÜx', '', 0, '?'),
 ('0@es.Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/Test/LoggerInterfaceTest.php', 0, 'Ӟnτ', 'Ӟnτ', 'mhP2U>z#^$A(', '', 0, '?'),
 ('Z)QE15?7', 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/Test/TestLogger.php', 0, '_c>\Z=sw', '_c>\Z=sw', 'Z,$Ҽ\'}q(ϝT^', '', 0, '?'),
 ('g3洃>d!`', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/ArrayAccess.php', 0, 'w|ZTs>Yՠ', 'w|ZTs>Yՠ', '8׾9MjqjzZ)yH', '', 0, '?'),
 ('fBv\n!:T', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Base.php', 0, '-PV=lAY', '-PV=lAY', 'KAtYKLRb]q3iv', '', 0, '?'),
 ('ؤ0\0IWĳ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ArrayCollection.php', 0, '~eoVU-', '~eoVU-', '+(TEBn`UHK0v6v48A', '', 0, '?'),
 (',/JmAs.', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/PaginatedIterator.php', 0, 'DKUIjwB', 'DKUIjwB', '_jsI6*ºLL\'OV@Jk', '', 0, '?'),
 ('D8DP47n\'E', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ResourceIterator.php', 0, 'ץ/%#kvF_(', 'ץ/%#kvF_(', 'dB3nqDo}Ϧu	?6', '', 0, '?'),
 ('e!T:DTJ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection.php', 0, '8.LLp^', '8.LLp^', 'yAb-&3CO^', '', 0, '?'),
 ('N/0r^', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Datetime.php', 0, 'w\"Q3C\\', 'w\"Q3C\\', '\"TMoNFGE	+:+e', '', 0, '?'),
 ('Pȼð', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Header.php', 0, '2uMf', '2uMf', 'U8T¹7ˢL\"(H±', '', 0, '?'),
 ('W(7f\nG9\\m', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Mime.php', 0, '*cwmĎf', '*cwmĎf', '(~TX듊(y>*}ܿTSle', '', 0, '?'),
 ('7C.U', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Service.php', 0, '3i&j%9ݜ2', '3i&j%9ݜ2', 'KAS\'}\rT8W\Z_L8!%@', '', 0, '?'),
 ('$I*ngIҢ?', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Size.php', 0, '4<k5M\'_D', '4<k5M\'_D', '0+fUSn|+M<0.+qHKTh`F', '', 0, '?'),
 ('vǷnuFU', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/State.php', 0, 'f6\'Z mˡI', 'f6\'Z mˡI', 'hh&9EyG;\n#O(~', '', 0, '?'),
 ('Z\0w`Vw', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncError.php', 0, 'r2:&t~m', 'r2:&t~m', '\'(;U=J\rf-rZy/6ިm9', '', 0, '?'),
 ('tҀ-rX', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncHttpError.php', 0, 'JЃː&D}', 'JЃː&D}', 'FԒ	VI_fn\0', '', 0, '?'),
 ('_9r/p', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncTimeoutError.php', 0, 'ߝECMI`', 'ߝECMI`', '8r\ZBxon)=٣cR', '', 0, '?'),
 ('\"E[AmAVk', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AttributeError.php', 0, 'hvM?0qh', 'hvM?0qh', '8TD{1)[ݴ1Fpe', '', 0, '?'),
 ('\0\nз+_xed ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AuthenticationError.php', 0, 'W{]m	emH', 'W{]m	emH', 'ȋh?eu-3ƝP\r)+\rW}=C', '', 0, '?'),
 ('Qζ1*hQ2', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/BaseException.php', 0, '$u9$hoy%', '$u9$hoy%', '7t:s{(,5U)fr7Ox!', '', 0, '?'),
 ('̢wig^>', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnError.php', 0, 'Ց\\:vø', 'Ց\\:vø', ';Y]]0Y2hiITnHRF', '', 0, '?'),
 ('k\Zmk&uߘ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnHttpError.php', 0, 'dwU@71	,5', 'dwU@71	,5', '}~n*k({CM3\0$', '', 0, '?'),
 ('I.ڇ*4*>1&HV', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnNotAvailableError.php', 0, 'j\0+6}F\Zٽv3', 'j\0+6}F\Zٽv3', 'C*}&DZ|n([<', '', 0, '?'),
 ('OyiWA:8V', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnTtlError.php', 0, 'uU\'x~1ÞK', 'uU\'x~1ÞK', '^\\NxN˰gZ´xi}p4#', '', 0, '?'),
 ('Os\Z6I|', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CollectionException.php', 0, 'bB!~-Ȇ٭', 'bB!~-Ȇ٭', '>TkH~;oELwpJ\Z', '', 0, '?'),
 ('r_`(', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerCreateError.php', 0, 'nCiS<:Ӹ', 'nCiS<:Ӹ', '\r9X琅>C!Rxf\\[\'Mǌ', '', 0, '?'),
 ('ttw	ub', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerDeleteError.php', 0, 'tԞBޓr7', 'tԞBޓr7', 'Kı\\:.XSʠEmn\n\0k\\#Z', '', 0, '?'),
 ('^2hg', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerError.php', 0, '4Șz3(', '4Șz3(', 'A7;iДpyKMe)\Z6-', '', 0, '?'),
 ('zPLp#I', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNameError.php', 0, ',7fS\'G\'C', ',7fS\'G\'C', '$)C:ʤ\r F4@N=', '', 0, '?'),
 ('\'5Sٙ{1*	%D', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotEmptyError.php', 0, 'Jc1z{\'/@EHl>', 'Jc1z{\'/@EHl>', '(\0- !ߨ:k΢>I\n.Wma', '', 0, '?'),
 ('-x[I', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotFoundError.php', 0, 'U ,26LM', 'U ,26LM', '\Z\0KTa\r`y*{', '', 0, '?'),
 (':u>NoD%', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateError.php', 0, 'oجѢ3;]T\Z]', 'oجѢ3;]T\Z]', 'VI\")B&QJҊ!ٞ\"vC', '', 0, '?'),
 ('Pv\"<AGfO', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateUpdateError.php', 0, ' ⮆<_jS<J', ' ⮆<_jS<J', '#2k6O؀CJlxN3m91B4', '', 0, '?'),
 ('^\Zk^.', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CredentialError.php', 0, 'FY?ʊ1s/', 'FY?ʊ1s/', '<lI!/{KS|i$6', '', 0, '?'),
 ('[$4:<d(g', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseCreateError.php', 0, '	t2npU^', '	t2npU^', 'Rù;@0Z`$\\X7ԭȅN{ͻ`	', '', 0, '?'),
 ('CryX{\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseDeleteError.php', 0, ';yCh}V~>Y', ';yCh}V~>Y', 't9cv|u4NkjE}?5$r/', '', 0, '?'),
 ('}[IIǡɉ>', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseListError.php', 0, '*soTP29\",]n', '*soTP29\",]n', '潜n1:7?ܷ!՝âv', '', 0, '?'),
 ('!MEa`n+', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseNameError.php', 0, '`Ku', '`Ku', '?p&kw\Z\"Glr', '', 0, '?'),
 ('nc>', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseUpdateError.php', 0, '=e@M=&;', '=e@M=&;', ':KТA?y?M|L2', '', 0, '?'),
 ('+SDafk', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DeleteError.php', 0, ')z<a 0x\"', ')z<a 0x\"', 'PxeÕV4\0\"\n1ë)6\n', '', 0, '?'),
 ('qpqҫAD', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DocumentError.php', 0, '`Ov', '`Ov', 'I|zl*\ZUMo-L},`OܷOZ', '', 0, '?'),
 ('&cosT', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DomainError.php', 0, 'Nmulv:', 'Nmulv:', '$YJK|oq)]o', '', 0, '?'),
 ('II7kIB%\nv', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EmptyResponseError.php', 0, '~j\"W ', '~j\"W ', 'zY5>:zuW0瀟@#pV@', '', 0, '?'),
 ('#Bx', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EndpointError.php', 0, '+%DV=\r~\rL', '+%DV=\r~\rL', 'ñ^Ab	#+&Ӧ+UV?s', '', 0, '?'),
 ('(((i]§\n12', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/FlavorError.php', 0, 'XoS\\,J\'e', 'XoS\\,J\'e', '3_}\"\'\"po+PYE%P', '', 0, '?'),
 ('y(VF', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ForbiddenOperationException.php', 0, 'ji\Zm LZ	D', 'ji\Zm LZ	D', '2lX\'LKs5w<+vN1bDqG`', '', 0, '?'),
 ('wEQX|', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpError.php', 0, 'P^ZF{t_K', 'P^ZF{t_K', 'ʨY=I\r\\S\no0Zz', '', 0, '?'),
 ('=6+(RǊםR', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpForbiddenError.php', 0, '\']{xN}', '\']{xN}', 'Sh);ѩDJfvṗ', '', 0, '?'),
 ('>/hCΤ秝?', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpOverLimitError.php', 0, 'pm/d^\rJNo', 'pm/d^\rJNo', ']jqn;oz\r	O(H0ࣉ', '', 0, '?'),
 ('uB a}', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpResponseException.php', 0, '!ą,\\kTw', '!ą,\\kTw', '\0罼%|_[xVh-', '', 0, '?'),
 ('vk', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpRetryError.php', 0, '3D0ɺ\'1>M', '3D0ɺ\'1>M', '\r_y?&oG϶Nn', '', 0, '?'),
 ('MM<HU', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpTimeoutError.php', 0, '9#w>ò7~<?', '9#w>ò7~<?', 'B\rSj/}~[7P@Ef\"ğ', '', 0, '?'),
 ('x2*t\Z>', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUnauthorizedError.php', 0, '/{܇AK&', '/{܇AK&', '<t0ٸS}!/\njʘkDPB', '', 0, '?'),
 ('Հ}EBIPnr)', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUrlError.php', 0, 'שa_}Gֶl', 'שa_}Gֶl', 'H[μCQH*EBR\rrt.!=Tx', '', 0, '?'),
 (' I\"p\Zc', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IOError.php', 0, '{LƲ(', '{LƲ(', '߁PuQ;琮JG%U', '', 0, '?'),
 ('f\0IS#R', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IdRequiredError.php', 0, 'n,(O', 'n,(O', '%͊:SRuI\0G\r,h:[', '', 0, '?'),
 ('LBbc?', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ImageError.php', 0, ' \rVjԈQa', ' \rVjԈQa', 'p(@k7,Gq?`WF', '', 0, '?'),
 ('\0\'V&Mj_', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceCreateError.php', 0, 'ztKi\ZIAW', 'ztKi\ZIAW', 'ůC(#\r(\0\'[Θm;x', '', 0, '?'),
 (' {Ov5ml', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceDeleteError.php', 0, 'q59,\rE[9+', 'q59,\rE[9+', '-S\\RkWԩbc S扩', '', 0, '?'),
 ('`ʔWm{', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceError.php', 0, 'kth*-x8', 'kth*-x8', 'vyQMhb ', '', 0, '?'),
 ('$b>Tr ׹', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceFlavorError.php', 0, '6+5I燋Vp[', '6+5I燋Vp[', '(RYo3\'^D)P,|t', '', 0, '?'),
 ('l0{Mtc;B', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceNotFound.php', 0, 'BZI^', 'BZI^', 'dzZb:^=\'S\Z.*=^w1', '', 0, '?'),
 ('pcaò~`#', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceUpdateError.php', 0, 'a\n3p*~\ne=\r', 'a\n3p*~\ne=\r', 'pfg!U_#xB,p', '', 0, '?'),
 ('$8y`RG', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidArgumentError.php', 0, 'ri4Db-${\\I;', 'ri4Db-${\\I;', 'L͂nM\n2', '', 0, '?'),
 ('a</IMrU', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIdTypeError.php', 0, '/I;FAr', '/I;FAr', 'ʡ.JFoP0@\\ƀh%z>?p', '', 0, '?'),
 ('z*1pg&|', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIpTypeError.php', 0, 'W+^?ŚЦt\"', 'W+^?ŚЦt\"', '+~=Ladߓ350ϱ]M,7*ϙG͋', '', 0, '?'),
 (',m&FOKXthv', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidParameterError.php', 0, '\ZaJyN_', '\ZaJyN_', '*쁮\r<ZłBw^', '', 0, '?'),
 ('dpG(Tϭm', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidRequestError.php', 0, 'aMZX	K', 'aMZX	K', 'XBNyU(ү 9@W7l;', '', 0, '?'),
 (']Q\0$Uuvm\nG', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidTemplateError.php', 0, '\nͣMİ97y;', '\nͣMİ97y;', 'U\"qϛgiaY[{\0Rh', '', 0, '?'),
 ('$s4Lj]\ZlU\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/JsonError.php', 0, 'K7hh.:k', 'K7hh.:k', ')ln#\'SfBߩ/ ĩ', '', 0, '?'),
 ('!6S۰.uZ_', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/LoggingException.php', 0, 'Ԝ-+GJ垸', 'Ԝ-+GJ垸', '	/r\"D5˨g>@.D*', '', 0, '?'),
 ('(S1l2Nztk', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataCreateError.php', 0, '&\0t\0Cng', '&\0t\0Cng', 'z/΅H:`R=iXWz2&', '', 0, '?'),
 ('tA-I\"&+', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataDeleteError.php', 0, '	hI09*wQ', '	hI09*wQ', '퉝IXa[T-J<6)\'Qa', '', 0, '?'),
 ('EnܑWD\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataError.php', 0, '>1}nafZc(', '>1}nafZc(', 'y&<Cֆ7bi	7*!b', '', 0, '?'),
 ('IrK`i<*g/', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataJsonError.php', 0, '\Z1M	gՎ\r', '\Z1M	gՎ\r', '<HpKѤF\rV:K\Z3', '', 0, '?'),
 ('m^׸%Bq', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataKeyError.php', 0, 'qGlX\ZpJ', 'qGlX\ZpJ', 'Noqbw8=Dn7w\0t#}\'v', '', 0, '?'),
 ('=BsIu4eҠ,', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataPrefixError.php', 0, '`imq\r{l\Z', '`imq\r{l\Z', '\Z[6qϽHO\\gnBdG6', '', 0, '?'),
 ('/[x@J-_LƉ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataUpdateError.php', 0, ';&γe!xh>', ';&γe!xh>', '\ri\Z]\"zebw<<\ZZA', '', 0, '?'),
 ('];G9G\'\nP', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MisMatchedChecksumError.php', 0, '7Js?K', '7Js?K', 'ޅAOVs9|nyOt', '', 0, '?'),
 ('lKU!A ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MissingValueError.php', 0, 'B}6K~S', 'B}6K~S', 'Em:\Z+cg*icNyLR', '', 0, '?'),
 ('9r)T\\j\"', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NameError.php', 0, '|G -As', '|G -As', 'ke v0Q7]<	 eǤ', '', 0, '?'),
 ('*oHm|4˽k', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkCreateError.php', 0, '|N\"g)RH', '|N\"g)RH', ' 1/*-c{Ԗ&4Mcl3ix=,', '', 0, '?'),
 ('_cӎA', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkDeleteError.php', 0, '&p	NK', '&p	NK', 'vu?>-*/l&	<sXam', '', 0, '?'),
 ('R5sG#=Z=', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkError.php', 0, 'R[h\r}$z', 'R[h\r}$z', 'W2I\\j^Xs1fpҩ4', '', 0, '?'),
 ('h3@D<zv', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUpdateError.php', 0, 'V;Ǎc{', 'V;Ǎc{', '޳tg%vb	x@\Z[G[JM', '', 0, '?'),
 (')#0]F', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUrlError.php', 0, 'k$b\0R', 'k$b\0R', '\\\nd(pb#\'&4|>C', '', 0, '?'),
 ('Ȏ[DBR/}', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoContentTypeError.php', 0, 'Vi.()v4', 'Vi.()v4', '{cx\0x+,d7ri=4x', '', 0, '?'),
 ('/,\"_BB4sszj', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoNameError.php', 0, ']\\B{0G', ']\\B{0G', '\')LYi9>;Bq]\r8', '', 0, '?'),
 ('%i:)J,v', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjFetchError.php', 0, 'l{A(F', 'l{A(F', '\0	|扭+uP?zCڹ', '', 0, '?'),
 ('JmJTi', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectCopyError.php', 0, '8)wd', '8)wd', '븪\0d\nT92T嫼VIj0iǵ0<', '', 0, '?'),
 ('!Lք5', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectError.php', 0, '/\"΃Yp&F`', '/\"΃Yp&F`', 'n,^G~{	S+7ȱ|', '', 0, '?'),
 ('ŗc;۞u{', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RebuildError.php', 0, '(M+Cmk>Bh', '(M+Cmk>Bh', '7 	x 1h1$].-_\Z6', '', 0, '?'),
 ('T{	=d/$', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RecordTypeError.php', 0, 'K6-Sh\"t0˹w', 'K6-Sh\"t0˹w', '3\ne*9_	Pw/hY&', '', 0, '?'),
 (')#Εjn', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceBucketException.php', 0, '\'JWf*', '\'JWf*', 'ɳ-6Tv+3#kA˩ LU', '', 0, '?'),
 ('Ni!\"t', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceNotFoundException.php', 0, 'ąK?↖\\b', 'ąK?↖\\b', '?8&􌠺QfVn^\\<', '', 0, '?'),
 ('fS0Uu\\l\'xL', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RuntimeException.php', 0, './*Mi͗', './*Mi͗', 'sV\"P$}]ućy[rX', '', 0, '?'),
 (';bAĐ9fF', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerActionError.php', 0, 'pR);\Z`زy8', 'pR);\Z`زy8', '=˨៪<RE\'<,2Y>Ql?o', '', 0, '?'),
 (']|iw}	oY\nm', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerCreateError.php', 0, '|JtvnUn%%k', '|JtvnUn%%k', '\"\0n)^ʙTO\Z<W<d', '', 0, '?'),
 (':]ΥEvMqD9', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerDeleteError.php', 0, 'nq\0M_0K', 'nq\0M_0K', 'gtW}TVeiX+X', '', 0, '?'),
 ('R҇ͨv^', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerImageScheduleError.php', 0, 'cG<ӈ޼/', 'cG<ӈ޼/', 'ɼ}6Ny(G+n\"+8P', '', 0, '?'),
 ('lt#hK', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerIpsError.php', 0, ';RcP\ZM', ';RcP\ZM', 'zEFEؖHm', '', 0, '?'),
 (';BL/}|?X', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerJsonError.php', 0, 'e`o>HLRU', 'e`o>HLRU', '~֗AzI-]:ȾE_h6h>', '', 0, '?'),
 ('R\n2l', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUpdateError.php', 0, 'i#҃{9N溵', 'i#҃{9N溵', '^#bdޞW@قv\0arv}:', '', 0, '?'),
 (' C4qf', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUrlError.php', 0, '=5\n-~(bjg]Z}(', '=5\n-~(bjg]Z}(', 'sO3a}WUp9&AhW', '', 0, '?'),
 ('asjya', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServiceException.php', 0, '<}\rBƕ70q', '<}\rBƕ70q', 'J@JlS4zCk85', '', 0, '?'),
 ('\'WE]r\n@b', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/SnapshotError.php', 0, '\n8&i\"', '\n8&i\"', '?Nȟ(U5uQ?6y?Pڲ\Z', '', 0, '?'),
 ('NnHAxjʹc\\', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/TempUrlMethodError.php', 0, '2E!EsGe?_', '2E!EsGe?_', 'P#YfGGÓoJd02JEn><', '', 0, '?'),
 ('V͓D6.-=s~', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownError.php', 0, 'KS+2HAN', 'KS+2HAN', 'Y0ZlٚN#h\nN3)', '', 0, '?'),
 ('+a/+', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownParameterError.php', 0, '7`\"pq!Y\\', '7`\"pq!Y\\', '?ҨX%oAӖr%tO.9l޼', '', 0, '?'),
 ('\07#\'˻(', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnrecognizedServiceError.php', 0, '4yEM3f', '4yEM3f', 'u^MSw(7\0HXZdU', '', 0, '?'),
 ('\r<Wn_7qI', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedExtensionError.php', 0, 'f^;.#x!n', 'f^;.#x!n', 'q<6C\"|3[\Z;^L_ͩf', '', 0, '?'),
 ('Ez>d&̿', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedFeatureExtension.php', 0, 'M8\\3<nBeo', 'M8\\3<nBeo', 'zHQ v:LY+6k1', '', 0, '?'),
 ('B|m5^z+s\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedVersionError.php', 0, 'Q\"HqyDMB', 'Q\"HqyDMB', 'cMPJ=@HPZv*Q[A', '', 0, '?'),
 ('wíM}[p1BR', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UpdateError.php', 0, '<8l%W9O', '<8l%W9O', 'Ro:mQ:PS6лwy[', '', 0, '?'),
 ('psxʞt4p', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UrlError.php', 0, '*4k<M', '*4k<M', 'W+O֦`։ӻogV]ce', '', 0, '?'),
 ('zmz**z3', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserCreateError.php', 0, 'P^oձ,c', 'P^oձ,c', 'Y;9M~jGO+|R$}|k', '', 0, '?'),
 ('`ȏgLI\n K\04x\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserDeleteError.php', 0, '˃$f', '˃$f', '1\r{l5\Z(;o,b]hF*5L', '', 0, '?'),
 ('ާUa٢rS}', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserListError.php', 0, 'Ő%uHI', 'Ő%uHI', 'Np>ujۉJ2E	7', '', 0, '?'),
 ('7$.J', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserNameError.php', 0, 'FQ:X', 'FQ:X', '\'qܺY~8~}	2:&Mn', '', 0, '?'),
 ('\"b\Zѭ3', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserUpdateError.php', 0, '#5m7`Y,o¾v', '#5m7`Y,o¾v', 'Ǔl\0ErɿS)bJkx\"n', '', 0, '?'),
 ('\ZB2ܖ\Z', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeError.php', 0, '>ǯɇ\"Q\Z, ', '>ǯɇ\"Q\Z, ', 'oLyۘG=^{om#j8\"lL', '', 0, '?'),
 ('lQ!O', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeTypeError.php', 0, '>~@Jb.', '>~@Jb.', ' %C/j.E;.3[8Ѹ>', '', 0, '?'),
 ('ΠVv\"\Z%EaD', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Client.php', 0, '֙\rCӳ]E', '֙\rCӳ]E', 'e3t@MnS7(1\ne', '', 0, '?'),
 ('fN>+{l', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/Formatter.php', 0, '#,ZE', '#,ZE', '.E}l_wT\nV;	P;', '', 0, '?'),
 ('O]qJCe\'', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/RequestSubscriber.php', 0, ',<B>_C#', ',<B>_C#', 'sjZ\\N7`a[\0MZI\\ߵ3\n@Ӟ-', '', 0, '?'),
 ('-ih-_', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Lang.php', 0, '\nKTq', '\nKTq', 'r?swa\"]ve\ZśelڈBwy', '', 0, '?'),
 ('N.=yԬ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Log/Logger.php', 0, 'G	&\"˸', 'G	&\"˸', 'DE8J	jGDGУr', '', 0, '?'),
 ('18U [~n{s', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Metadata.php', 0, 'ERtH@GqVV\Zc', 'ERtH@GqVV\Zc', ')}3	-hS,ʇ/ח\\N', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES(',Lt/-bY', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/PersistentObject.php', 0, 'N(ڢP6ʚ', 'N(ڢP6ʚ', 'nΰuXXywVTܳJ\rx', '', 0, '?'),
 ('~r9wT{V1', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/BaseResource.php', 0, 'l3T&qK.', 'l3T&qK.', '/M|I,InKUk.4EKp%', '', 0, '?'),
 ('kIv]/jj', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/NovaResource.php', 0, '~%D ;CF', '~%D ;CF', 'I=ao4r6ь!TvMw', '', 0, '?'),
 ('Ѐ|aB0.ȁV', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/PersistentResource.php', 0, '?㽷Ƶ븆', '?㽷Ƶ븆', ';)\'\"ά[\"bַX\Zja', '', 0, '?'),
 (';V', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/ReadOnlyResource.php', 0, '*+_@{4Gc', '*+_@{4Gc', 'erO,v*\rbz7~}', '', 0, '?'),
 ('qAyӵ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/AbstractService.php', 0, 'C@\\dP', 'C@\\dP', '0yWb/Vbp*0:\".:Qo⽸', '', 0, '?'),
 ('e]\'S{n@', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Catalog.php', 0, '(\Ze\nExqX', '(\Ze\nExqX', 'ևD7߽iT0Bl!rm081', '', 0, '?'),
 ('Q߭', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogItem.php', 0, '#@~;#hZ&QI', '#@~;#hZ&QI', '4<`8&8paljf$', '', 0, '?'),
 ('a˓CggCS', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogService.php', 0, '_7:-UMkJe', '_7:-UMkJe', ':Ac\0>Ԡ+)#89Ie', '', 0, '?'),
 ('|xn&Jn9', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Endpoint.php', 0, 'tCD|i', 'tCD|i', '*TAY4C(.u\\-q	Y', '', 0, '?'),
 ('\"u2<%˧', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/NovaService.php', 0, 'ٚF870F', 'ٚF870F', '|kGӄ,.Mn/迕\ZtT', '', 0, '?'),
 ('ɒ}tָqU', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceBuilder.php', 0, '\rB^}<CO\"', '\rB^}<CO\"', '5¸VAw\0ZpCRr3HrX', '', 0, '?'),
 ('~ߚ@+nRZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceInterface.php', 0, 't*#5/\'', 't*#5/\'', '#iޖM@B[/  u9gMm', '', 0, '?'),
 ('QR2]bgi', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Constants/User.php', 0, 'ڵ@q\'=', 'ڵ@q\'=', 'uKٍWaK~~\"*', '', 0, '?'),
 ('gj68VSW/', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Role.php', 0, '7ESe<', '7ESe<', '>f^1Pf<9DJRDyM', '', 0, '?'),
 (';L]}Y!Xr', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Tenant.php', 0, 'Pxe%Ȁ8', 'Pxe%Ȁ8', 'Xfρ}46NcKKQG\Z', '', 0, '?'),
 ('\rsu>Gi', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Token.php', 0, '8*آsz!', '8*آsz!', ')9<bӿ@Qhɢg;̀e>g~Q', '', 0, '?'),
 ('{r8;|*x[<d', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/User.php', 0, '#7@>\"B*', '#7@>\"B*', '[6-S.8:}:ͳ,', '', 0, '?'),
 ('1\\(΋Ae', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Service.php', 0, 'ƕ-p%\nrk', 'ƕ-p%\nrk', '\'ݺ0pa3!(u}LV۽', '', 0, '?'),
 ('Y(-m}JX.S;', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/AbstractService.php', 0, 'x쑡p6JXr0I', 'x쑡p6JXr0I', '4H\nUlSs1NseW*\0', '', 0, '?'),
 ('cSS@\\', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/CDNService.php', 0, 'q*+\"2t', 'q*+\"2t', '<+yĂɇ@nq@B=|J8C&㎫', '', 0, '?'),
 ('{bh$$]>', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/Header.php', 0, '9#z#X(', '9#z#X(', '5E\0mMf_$r3]6#', '', 0, '?'),
 ('J/$\"e^', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/UrlType.php', 0, 'z$+_', 'z$+_', 'Ew;JT_m4iZx#Bnd\Zd	', '', 0, '?'),
 ('5=HO7W\r', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Enum/ReturnType.php', 0, 'D}ΤwSo!fp', 'D}ΤwSo!fp', 'l[7;YA*nJo', '', 0, '?'),
 ('嫩eD3wS_', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/BulkOperationException.php', 0, 'ҝI\n R', 'ҝI\n R', ':c\Zі\n	جM\r\"N`G{	', '', 0, '?'),
 ('vEOFqéjZ', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ContainerException.php', 0, 'p.͋S4;ɭC+s', 'p.͋S4;ɭC+s', 'ZI|YE=PCZ\Z@[o9&=', '', 0, '?'),
 ('zMy_C', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ObjectNotFoundException.php', 0, '|\0%ql', '|\0%ql', 'L#ZO<e\rG$M', '', 0, '?'),
 ('GS\nxK', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/StreamException.php', 0, 'ۂth0Ht{', 'ۂth0Ht{', '/sGx8\'1*Xă:\\ga', '', 0, '?'),
 (' 1	*', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/UploadException.php', 0, 'RTU', 'RTU', 'η\ZzCh`Ha;:n,n3', '', 0, '?'),
 ('Ƌp`/+]Px', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractContainer.php', 0, 'xE)*o^d?', 'xE)*o^d?', '/\"vo06Ȇ1{d\0qd\0Po', '', 0, '?'),
 ('%=\ZD{OẼN', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractResource.php', 0, 'Bi\r:\r@P', 'Bi\r:\r@P', '1\"WQ$\"I7g6\'Xe', '', 0, '?'),
 ('$\Z.K', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Account.php', 0, '<^Pj%^6{', '<^Pj%^6{', '-f]wUoTe({?ǀ', '', 0, '?'),
 ('&LV\ZN[ܙ͋', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/CDNContainer.php', 0, '}\Zyb7#', '}\Zyb7#', 'P5tk4tI5pmNȗo-', '', 0, '?'),
 ('C2e!:wxB', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Container.php', 0, 'kZohݏa', 'kZohݏa', '4ԆʇP45|', '', 0, '?'),
 ('|+Qׁ7Cb', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/ContainerMetadata.php', 0, '\"sC>X', '\"sC>X', 'A_&-(+h;sĕOcrh9]', '', 0, '?'),
 ('Qs\'{^X', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/DataObject.php', 0, 'sF߳Mi/', 'sF߳Mi/', '$-o(Fh1|Qq޴ϸEn', '', 0, '?'),
 ('6\nN3/#2>', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Service.php', 0, 'N?dLt', 'N?dLt', 'p`ȿ|b	Ќh.@s-', '', 0, '?'),
 ('S?ާLdI', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/AbstractTransfer.php', 0, 'ŀ޷v,Z3kCD', 'ŀ޷v,Z3kCD', 'gOD>+MUAx', '', 0, '?'),
 ('hh>g?I', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConcurrentTransfer.php', 0, 'JbK$C', 'JbK$C', 'y+qjHq[Hj', '', 0, '?'),
 ('gl,ܢ<yD9', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConsecutiveTransfer.php', 0, 'Lo_YҼ', 'Lo_YҼ', '?Uؚ7I9޶\'TTŎ#ƚ', '', 0, '?'),
 ('ZN>+l,m|l', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ContainerMigration.php', 0, '!-0\r#`1U=b$71', '!-0\r#`1U=b$71', 'l0\ZKn񋤉E>\"\\=', '', 0, '?'),
 ('9J\"I-qV', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/DirectorySync.php', 0, '[Օ#5Mm:i', '[Օ#5Mm:i', '[d`zb^R/vC|dBԘ', '', 0, '?'),
 ('-*ACCIkt', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferBuilder.php', 0, '_ASx', '_ASx', '6kIA͌eL{%3i:', '', 0, '?'),
 ('\01 uXtT', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferPart.php', 0, 'Kzs>靡', 'Kzs>靡', '!]1!{D3^U6Ι*nh^', '', 0, '?'),
 ('jA?uݾL(3Y', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferState.php', 0, '%>ߗH)RM', '%>ߗH)RM', '\"_Nsɐf N?RHn', '', 0, '?'),
 (':0ȣ<!\0', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/OpenStack.php', 0, 'J<ӧsvL%', 'J<ӧsvL%', 'Qr&OY2⑺^̲%(4u', '', 0, '?'),
 ('9o=D5+u', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Rackspace.php', 0, '͒#\rcN', '͒#\rcN', '&HU6ed7v\n_Ӓkd', '', 0, '?'),
 ('iΰxuoT', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Version.php', 0, 'WåHx', 'WåHx', 'R}2Micg srw׻w', '', 0, '?'),
 ('C\rv,d}y', 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/php-opencloud.php', 0, 'ĵ֜Pb', 'ĵ֜Pb', 'UTXpŚd8wy>8ǈT\r+x(', '', 0, '?'),
 ('SoqOqr,آ', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/ContainerAwareEventDispatcher.php', 0, '&Sq@⬠c', '&Sq@⬠c', '㣜h&GG5!!wb1-@', '', 0, '?'),
 ('O:.`D.KDm', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcher.php', 0, '6qYmc>u;r', '6qYmc>u;r', '1Ή:_d@g.koE=9K?l', '', 0, '?'),
 (']\'Q\'e:', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcherInterface.php', 0, '	ZU\\#En(P', '	ZU\\#En(P', 's4:W}uq;q\'@zNFľ`', '', 0, '?'),
 ('|M#B*MGM', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Debug/WrappedListener.php', 0, '2K/̇', '2K/̇', 'L+zNDE\rvcg0q\nMu', '', 0, '?'),
 ('&gE\"?\'@', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/DependencyInjection/RegisterListenersPass.php', 0, 'qQ:֊3r', 'qQ:֊3r', 'qԵ\nvZgBz?-)5[Pz', '', 0, '?'),
 ('Ɇ)N^L~2/', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Event.php', 0, 'JyPJ', 'JyPJ', 'Q1vVx`љ\r]=\r', '', 0, '?'),
 ('z9j%P', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/EventDispatcher.php', 0, 'Jt}Vf\\q', 'Jt}Vf\\q', ']9@\Z+yUV I', '', 0, '?'),
 ('5u$KN$', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/EventDispatcherInterface.php', 0, '=cP)ȇG', '=cP)ȇG', 'S\"r1JŸ	6*)-{', '', 0, '?'),
 ('a4sP078!', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/EventSubscriberInterface.php', 0, 'dT̚d', 'dT̚d', '%Uqzύ4k41؊btDFy', '', 0, '?'),
 ('Bt̠5D-g', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/GenericEvent.php', 0, '/beX%t', '/beX%t', 'ηMzE\r-\'Q>Z攫	R<ا', '', 0, '?'),
 ('z*N4(W]', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/ImmutableEventDispatcher.php', 0, 'rJƷ\\L5h', 'rJƷ\\L5h', '=]\rGl\">!ط.ye6f*', '', 0, '?'),
 ('DPGI!0o9', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/ExceptionInterface.php', 0, 'r:FJ!y]\n', 'r:FJ!y]\n', 'g&mnY\'~:) 4.k', '', 0, '?'),
 ('c\06`12@', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/InvalidArgumentException.php', 0, 'Yd=l򟳺', 'Yd=l򟳺', 'e=. onҴԿgБeu', '', 0, '?'),
 ('@i5o-.;\"R\\-', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/LogicException.php', 0, 'r>\'[zquM', 'r>\'[zquM', '`\'ӭƀ˞O02U &h^i', '', 0, '?'),
 ('\nn4i~.\r', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/ProcessFailedException.php', 0, 'A0J', 'A0J', 'B)RIepVLv%^', '', 0, '?'),
 ('ENlJ$>', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/ProcessTimedOutException.php', 0, '\0`s~z^', '\0`s~z^', 'SX*>cB\\:4F+Vq\\-Sy', '', 0, '?'),
 ('Oy}GV', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/RuntimeException.php', 0, 'QsPSRz0w[-g', 'QsPSRz0w[-g', 'FI\\O˄Ʊ[?4{YC', '', 0, '?'),
 ('T~nahdq0', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/ExecutableFinder.php', 0, 'İA{h9&iﳪ', 'İA{h9&iﳪ', '|(n~#f	_UٌqLXj', '', 0, '?'),
 ('\0F͜.1{', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/InputStream.php', 0, 'ލ^\\\r\0-[', 'ލ^\\\r\0-[', '.b1r^+sFRc', '', 0, '?'),
 ('/s}p', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/PhpExecutableFinder.php', 0, '` ,K<BxNmp', '` ,K<BxNmp', 'w	 7.몘9Vw%))UMT]\r\\', '', 0, '?'),
 ('o4~LPU}', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/PhpProcess.php', 0, '.&N9pAK|S', '.&N9pAK|S', 'R;ީ osZp:\rY\"', '', 0, '?'),
 ('DLYC(2`T.', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/AbstractPipes.php', 0, ';<vYUrIa', ';<vYUrIa', 'E1jNl|ato<S', '', 0, '?'),
 ('jM\nr([\rK?C', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/PipesInterface.php', 0, '|f=֏w&;', '|f=֏w&;', 'x׽S+@VvKH', '', 0, '?'),
 ('^vVu', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/UnixPipes.php', 0, 'a*Z;٧,H;', 'a*Z;٧,H;', '0/rD$͆i8B', '', 0, '?'),
 ('г6ầsp', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/WindowsPipes.php', 0, '\"*ilբGռZ', '\"*ilբGռZ', 'tsMER)[d', '', 0, '?'),
 ('7|t', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Process.php', 0, '*Z+8?%ﺆW', '*Z+8?%ﺆW', 'bd~\"yOsXECA6\'Djm', '', 0, '?'),
 ('f,|&ϴ', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/ProcessBuilder.php', 0, '*;ftt2j', '*;ftt2j', 'TpPj{J1sSa@sҰC', '', 0, '?'),
 ('i}sC', 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/ProcessUtils.php', 0, 'iE\'', 'iE\'', 'iHJ\'woQ2w]Y^kT', '', 0, '?'),
 ('31$,k0gJ', 'wp-content/updraft/plugins-old/woo-lucky-wheel/admin/admin.php', 0, 'E33&zKp', 'E33&zKp', '\rt򣜉;紛s]l', '', 0, '?'),
 ('=T4|\Z8', 'wp-content/updraft/plugins-old/woo-lucky-wheel/admin/mailchimp.php', 0, '	iu5.s', '	iu5.s', 'IU0YȀ^4*$8\0Wq{d,i˝ӆd', '', 0, '?'),
 ('_̒I8', 'wp-content/updraft/plugins-old/woo-lucky-wheel/fonts/semantic/icons.svg', 0, 't☼z%ҽXhU.', 't☼z%ҽXhU.', '\'#I \0(0\\k4', '', 0, '?'),
 ('\nf\Zm-):O)', 'wp-content/updraft/plugins-old/woo-lucky-wheel/fonts/woocommerce-lucky-wheel.svg', 0, '$LvD+: ', '$LvD+: ', 'vz|@	r	/Qna{FW.B', '', 0, '?'),
 ('Դ-z', 'wp-content/updraft/plugins-old/woo-lucky-wheel/frontend/frontend.php', 0, 'm̷6(?Z', 'm̷6(?Z', ':;	&+P$\"wRJ5/=PKn\'', '', 0, '?'),
 ('O	b^\ZlwC', 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/data.php', 0, '\"%;N', '\"%;N', 'J誷D\0qT3*Q', '', 0, '?'),
 ('nj.;Td5I]{,', 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/functions.php', 0, '.ghg-d', '.ghg-d', 'o*GD.K*+j{}F*QB\rD+y', '', 0, '?'),
 ('Pސ', 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/includes.php', 0, '/', '/', '¦?2i|od', '', 0, '?'),
 ('H\"C', 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/mobile_detect.php', 0, 'X~x|Fԁ$', 'X~x|Fԁ$', '\nܯ0pA7,HM', '', 0, '?'),
 ('e\"Űyn*', 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/support.php', 0, '6<VIk}', '6<VIk}', 'ξyQS|NALAU?OC', '', 0, '?'),
 ('a껣Su\0w', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/admin-javascript.js', 0, '9atq\nE@xp\Z', '9atq\nE@xp\Z', 'o%\r^{C-\Z6ŗb4Ig', '', 0, '?'),
 ('j3(L̶už%', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/checkbox.js', 0, 'j!Stq%P', 'j!Stq%P', 'ճ`:}$j,E3pF륦', '', 0, '?'),
 ('NiS@:xo', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/dropdown.min.js', 0, 'fٻBw\0PP', 'fٻBw\0PP', '\'\n0Ϸ,\\Zk', '', 0, '?'),
 ('h?Tn$', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/form.js', 0, 'T	ʌ1sLC', 'T	ʌ1sLC', '.Bs:r}??ZOʖF<', '', 0, '?'),
 ('lar]c', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/jquery.address-1.6.min.js', 0, '_)33k]A9B	', '_)33k]A9B	', 'cc \nw	rYY?KG', '', 0, '?'),
 ('`A缭7r', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/jquery.fontselect.min.js', 0, '!]w0r', '!]w0r', '6,3t:{ӄ @ZK&KV7vc', '', 0, '?'),
 ('bU\\~x䏡', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/select2.js', 0, '\r`bd', '\r`bd', 'ߚv+2*,_i\nzVGV >', '', 0, '?'),
 (',>%庯̓', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/tab.js', 0, 'lK5BUM', 'lK5BUM', '\r)w%_EaՋ	Cw', '', 0, '?'),
 ('z&\0y/7Q,', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/transition.min.js', 0, '`Sx{v$Y4', '`Sx{v$Y4', ']P\"SapFbcO=Űk', '', 0, '?'),
 ('bkucNEޝ', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/woocommerce-lucky-wheel-mobile.js', 0, '\r:>G\n\n>', '\r:>G\n\n>', 'ʬ#\0PBۇ\r83wk5\Z$', '', 0, '?'),
 ('.\\;_O', 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/woocommerce-lucky-wheel.js', 0, '9C}ub٪$', '9C}ub٪$', 'r)m_N3+pw;^{yWp', '', 0, '?'),
 ('lfjK5bQ', 'wp-content/updraft/plugins-old/woo-lucky-wheel/woo-lucky-wheel.php', 0, 'jw0wM', 'jw0wM', '$uv`|&%QxRhuKv~', '', 0, '?'),
 ('u\05z', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/admin.js', 0, ']ɾʣ.l', ']ɾʣ.l', 'g0+cb9AK|(k<?;', '', 0, '?'),
 ('Qc$+5XC\Z', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/admin.min.js', 0, '<\'|', '<\'|', '<,Eecm`]y]RBp)', '', 0, '?'),
 ('\'FSJ	Y\"J', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/bluebird.js', 0, '\\K-\0H2<', '\\K-\0H2<', ';\'\"\\~:7uINJ', '', 0, '?'),
 ('̆tK+qt-?', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/bluebird.min.js', 0, '\nl#=E8', '\nl#=E8', '3V³o ȏ@Y¢(7Zzo\'4', '', 0, '?'),
 ('J<i	􌾷', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/divi_woo_layout_injector.js', 0, 'BbJ+Ӄj-\'b', 'BbJ+Ӄj-\'b', '-HY?kT:	35;|z[\"Rf', '', 0, '?'),
 ('?Ҵe8; (Ps_', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/divi_woo_layout_injector.min.js', 0, 'Zx_-k	$,L', 'Zx_-k	$,L', 'D~f<X#U|w\0M', '', 0, '?'),
 ('y_fu', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/form-field-dependency.js', 0, 'U:q<!q', 'U:q<!q', ':Th(!LC	̃C', '', 0, '?'),
 ('ش,И{>IB', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/form-field-dependency.min.js', 0, 'MO /om\"1', 'MO /om\"1', '#-TXk%AfBOf):l]y', '', 0, '?'),
 ('H28Ciވ\\', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/frontend.js', 0, 'wp*\"B36', 'wp*\"B36', 'T&,$e{+', '', 0, '?'),
 ('+T3EvNæ}*', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/frontend.min.js', 0, 'PKwZn͏\nOdy', 'PKwZn͏\nOdy', 'iǡ\"5f0-iH<mAh', '', 0, '?'),
 ('M8q \"F\'', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-admin.js', 0, 'g8޸(', 'g8޸(', 'E!d#ҪH)*ҴS(n', '', 0, '?'),
 ('t3\Zn2b', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-admin.min.js', 0, 'J>gDdX*_', 'J>gDdX*_', '-wN5HT,4\"Q9o(', '', 0, '?'),
 ('کT77[%', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-backbone-modal.js', 0, 'F		2', 'F		2', '	\\rԲ<0»-EPSy', '', 0, '?'),
 ('J\01[', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-backbone-modal.min.js', 0, 'B\nI$U+N', 'B\nI$U+N', '5_$ m\n6c=Iנ՘	', '', 0, '?'),
 ('p$Vh;', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wp-color-picker-alpha.js', 0, '\"X\Z(>.p', '\"X\Z(>.p', 'rn@\n#-\r\\CeScE', '', 0, '?'),
 ('h\rrZ-!', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wp-color-picker-alpha.min.js', 0, 'QJwU7|', 'QJwU7|', 'k[-3!5x85PJ(', '', 0, '?'),
 ('вϞb', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wvs-customize-alpha-color-control.js', 0, '3Tvj@ D	t\'', '3Tvj@ D	t\'', 'uϺ&H(\ZMTmtW', '', 0, '?'),
 ('<%1Lp`', 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wvs-customize-alpha-color-control.min.js', 0, 'qH\"CURH', 'qH\"CURH', ' 	94)={O^wR:;ȩ', '', 0, '?'),
 ('u=lGA', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-woo-variation-swatches-export-import.php', 0, 'h[)Voy,j', 'h[)Voy,j', 'X|<ԫK<~8Iiz/Կ#', '', 0, '?'),
 ('L||g-tʈO', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-customize-alpha-color-control.php', 0, 'lCbK{', 'lCbK{', '׋-\0F*Z]\Z>|̖^f\\', '', 0, '?'),
 ('G\rHԯ6^', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-customize-heading.php', 0, 'E,8C\0|', 'E,8C\0|', 'CˬdU#`G:iq8\n', '', 0, '?'),
 ('~R&4察@Q:Z', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-customizer.php', 0, 'ՓeMKr7c|V8', 'ՓeMKr7c|V8', 'P\Z;w|:ZSw	2*v!', '', 0, '?'),
 ('8q\\d%7\'', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-settings-api.php', 0, 'J8àˠ`k', 'J8àˠ`k', 'nC7@Mr<\n{̝ShI', '', 0, '?'),
 ('[NXngb', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-term-meta.php', 0, '.$:_Nd', '.$:_Nd', 'Ud-\0KF`& < p', '', 0, '?'),
 ('wM>t\0O,x', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/deactive-feedback-dialog.php', 0, 'PZAdq6Pş_B', 'PZAdq6Pş_B', 'π)̗|՞!kKٚ', '', 0, '?'),
 ('&hFB0', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/functions.php', 0, 'ip?][ob', 'ip?][ob', 'Rx:aeEE2?><', '', 0, '?'),
 ('7f/Gj졃뽤!', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/hooks.php', 0, 'd%:#|RlL', 'd%:#|RlL', 'Jkufa=ޖ\'36T`\Z^', '', 0, '?'),
 ('rHl`eW', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/stylesheet.php', 0, '`4i|؅=-\nPW', '`4i|؅=-\nPW', '8I[`]TܛsN.\0', '', 0, '?'),
 ('oU3\Zms', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/themes-support.php', 0, '1u\Zs', '1u\Zs', 'ஏ%HKUlf<\ZѾRPu\\07Q', '', 0, '?'),
 ('GW1%Va,j', 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/tutorials.php', 0, 'mC]VbKg', 'mC]VbKg', ';gy, egP*fL6ޥ\r*i', '', 0, '?'),
 ('?eLHcӇ', 'wp-content/updraft/plugins-old/woo-variation-swatches/uninstall.php', 0, '8pze&B\Zɏ', '8pze&B\Zɏ', 's7KU<%rtOvH', '', 0, '?'),
 ('6wzgc/`if', 'wp-content/updraft/plugins-old/woo-variation-swatches/webpack.mix.js', 0, 'A~]L', 'A~]L', 'Z0ڍg/]ڬ7N̗u0.', '', 0, '?'),
 (';pD)3|^d', 'wp-content/updraft/plugins-old/woo-variation-swatches/woo-variation-swatches.php', 0, 'dAT}4xm\Z', 'dAT}4xm\Z', 'uacgٚBEs', '', 0, '?'),
 ('J\\Z\nMT', 'wp-content/updraft/plugins-old/woocommerce/assets/css/photoswipe/default-skin/default-skin.svg', 0, 'WZMwg)C', 'WZMwg)C', '5#tjVc6\nPn1o\'', '', 0, '?'),
 ('P}3M	x', 'wp-content/updraft/plugins-old/woocommerce/assets/fonts/WooCommerce.svg', 0, 'ٷMg+F.^b', 'ٷMg+F.^b', '_Ź5{x\\\\xԋ4λ', '', 0, '?'),
 ('~RxT\\ubB]3]', 'wp-content/updraft/plugins-old/woocommerce/assets/fonts/star.svg', 0, '^sG\0yn9', '^sG\0yn9', 'c\"CB\rJ\\;k', '', 0, '?'),
 (';}f&ÿ#', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/amex.svg', 0, '6Q4Vr', '6Q4Vr', 'p4fEPN.:,xaX', '', 0, '?'),
 ('YGBjb\rC', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/diners.svg', 0, 'sn݄D?.', 'sn݄D?.', 'D\\j*Ciï77\nJ:^L@EI', '', 0, '?'),
 ('Z_Nt;H', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/discover.svg', 0, 'QBXpU?z', 'QBXpU?z', 'ZKN<_\rh3ݧFՊŕD', '', 0, '?'),
 ('|52V/&`A2C', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/jcb.svg', 0, '؜A~ht\"Ga', '؜A~ht\"Ga', '\Z\ZHF $lwz,K܄', '', 0, '?'),
 (' M漵b##s', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/laser.svg', 0, '2f6g)B', '2f6g)B', '8QjV\'4Ⰻ̎n\0b(Ό', '', 0, '?'),
 ('go\'.2Bd', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/maestro.svg', 0, '\Z}Ԇ,Y?k<', '\Z}Ԇ,Y?k<', '	t3831>Y#vB=', '', 0, '?'),
 ('BLeUf^[(', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/mastercard.svg', 0, '3c״ѕ)d', '3c״ѕ)d', '(\0\0.kߦ0w/:Ç9N_q', '', 0, '?'),
 (';$hBaʏD&', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/visa.svg', 0, 'yWkM6z', 'yWkM6z', 'W!Q>nΣx!_\r;F', '', 0, '?'),
 ('/SG۲@Q>', 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/loader.svg', 0, 'r7c)[w^', 'r7c)[w^', 'Be vO+\Z*eҿW3~', '', 0, '?'),
 ('0&SOOo1>', 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-facebook-icon.svg', 0, '60n\"%ө', '60n\"%ө', '_I*1L5\"+zfn-VL', '', 0, '?'),
 ('!Fwhcq\Z', 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-mailchimp-icon.svg', 0, 'd}\0bB.A', 'd}\0bB.A', '&X:k8ag=(й7~7t5>', '', 0, '?'),
 ('!^&h3o\"<', 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-storefront-icon.svg', 0, '#W|0LB', '#W|0LB', 'XcDf>HBV!\\報ɐ\"\'-', '', 0, '?'),
 ('{4\rke\0pFZ.', 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-taxes-icon.svg', 0, 'QA^\0OW!R', 'QA^\0OW!R', 'ZQzoc#1b w.I.Jk7\nx', '', 0, '?'),
 ('ݓkFw%/B', 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-woocommerce-admin-icon.svg', 0, 'BuSGԊ?', 'BuSGԊ?', '0ne!>#p^JE3', '', 0, '?'),
 ('+ӕ\nbJ;d', 'wp-content/updraft/plugins-old/woocommerce/assets/images/woocommerce_logo.svg', 0, '~Q7jaMq', '~Q7jaMq', '/{oHvIuR6/Ѧ*\'G', '', 0, '?'),
 (' ()F>(', 'wp-content/updraft/plugins-old/woocommerce/assets/js/accounting/accounting.js', 0, '>~z)B7', '>~z)B7', '9QJ;vg1iE\0@KO', '', 0, '?'),
 ('x	hFXh*', 'wp-content/updraft/plugins-old/woocommerce/assets/js/accounting/accounting.min.js', 0, 'ry%bPU', 'ry%bPU', 'ӀOd;]>oWgɵ', '', 0, '?'),
 ('wH/bB\'1', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/api-keys.js', 0, '/Vԍ{\r\\}x', '/Vԍ{\r\\}x', 'FCT;/; {O?s,.sL+62V', '', 0, '?'),
 ('7.vn*^Z\Z', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/api-keys.min.js', 0, '!\\ 5GLH', '!\\ 5GLH', '5:ߩ6ا!UAc_Ǉ,', '', 0, '?'),
 ('\rF3s+Byy', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/backbone-modal.js', 0, '7܋隧a', '7܋隧a', '[Q3~Qc_ڏ>N\Z<]', '', 0, '?'),
 ('ǪKbjK烵h', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/backbone-modal.min.js', 0, ':\n^PD߯', ':\n^PD߯', '(d^\r|p:>&\Z?', '', 0, '?'),
 ('<=\':Z', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/marketplace-suggestions.js', 0, '7YA;', '7YA;', 'F[׏ru+x\Z Y9', '', 0, '?'),
 ('UM&-n٤й', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/marketplace-suggestions.min.js', 0, 'pFbNYE', 'pFbNYE', 'PR$R=NHN[?Le<*`', '', 0, '?'),
 ('ʞMk?\0J!', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-coupon.js', 0, '|H}uTDnN#', '|H}uTDnN#', 'PmKRq7UA<je!$v', '', 0, '?'),
 ('WB(aL$\0', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-coupon.min.js', 0, 'uw$nq1IvѬ0', 'uw$nq1IvѬ0', 'dĶ=MG3ƶpqT7kgu', '', 0, '?'),
 ('@3h}׊', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-order.js', 0, 'A¸m$\"C!2', 'A¸m$\"C!2', 'T-MlEM?x{Y\0\Z]W2P', '', 0, '?'),
 ('b?@엎1,z', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-order.min.js', 0, 'N)sҎ', 'N)sҎ', 'ǒ(X^*5e R;*@x', '', 0, '?'),
 ('RN3$@V^L', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product-variation.js', 0, 'q*uÍK=g', 'q*uÍK=g', 'V8aq0Kxrd>i^* k', '', 0, '?'),
 (' EaHh', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product-variation.min.js', 0, 'ǉDW3uV!|', 'ǉDW3uV!|', 'On?3|iɪ\0/sL0)\'', '', 0, '?'),
 ('!\\_3\'\0GM', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product.js', 0, 'T\rÐ+` |?', 'T\rÐ+` |?', '֓WTYlBP̃7EϩL\n', '', 0, '?'),
 ('[<qt', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product.min.js', 0, 'Rb\Z\\n', 'Rb\Z\\n', 'ΚV\\ ޱua)vZ[t^{', '', 0, '?'),
 ('B.}>Q$G}z', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes.js', 0, '|wƷ6 xR~', '|wƷ6 xR~', 'U$Ly@WN:%Ezl', '', 0, '?'),
 ('6{6:.', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes.min.js', 0, '*qsx8*', '*qsx8*', '~T]i=$', '', 0, '?'),
 ('FScfň', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/network-orders.js', 0, '\r`T\nQl', '\r`T\nQl', 'Tڴ:ӿz+{7ԶOu', '', 0, '?'),
 ('jcag	Sz\0', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/network-orders.min.js', 0, '95@=9tЇ', '95@=9tЇ', 'z6gz	#dGb', '', 0, '?'),
 ('捝qA~ԥ+C', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/product-ordering.js', 0, 'r\ZQ_t^', 'r\ZQ_t^', 'v3̵T̵rE0\"#3Eq!EWH!Q', '', 0, '?'),
 ('`*d]LΤkQ', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/product-ordering.min.js', 0, '뺤 $wac5C', '뺤 $wac5C', '\n\"\"z8iQ:}FcmEI-', '', 0, '?'),
 ('yr{۰f', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/quick-edit.js', 0, ')uʴ	xf.', ')uʴ	xf.', 'Q.z;`Sery6', '', 0, '?'),
 ('(ONSsBRD', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/quick-edit.min.js', 0, '\'+wyE_', '\'+wyE_', '	]z˰1nUDwwKrK\r', '', 0, '?'),
 ('eԉnR1', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/reports.js', 0, 'Է	ؾۺoe(=A', 'Է	ؾۺoe(=A', 'v^C\\/g?+I6vB', '', 0, '?'),
 ('cbFQF.0;vN', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/reports.min.js', 0, '~u	i\\', '~u	i\\', 'ٽ؟1u@\0/kyZ6\\', '', 0, '?'),
 ('d]ĦA\n>', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings-views-html-settings-tax.js', 0, 'Qyt	T', 'Qyt	T', '/7g<Dc{P#qi@t+W&\r', '', 0, '?'),
 ('p}1Mgm8', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings-views-html-settings-tax.min.js', 0, 'F[S{hO80ػ', 'F[S{hO80ػ', 'ҔBI&v<_k΁cTw쏀', '', 0, '?'),
 ('m5UNz$', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings.js', 0, '3f-y_\nmc_', '3f-y_\nmc_', 'cFۂvpdleϙ', '', 0, '?'),
 ('\n3zSk2oa', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings.min.js', 0, 'U@d)NXn^¼', 'U@d)NXn^¼', '|M%2N#`\'BI3|9', '', 0, '?'),
 ('v\Z~tU', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/system-status.js', 0, ' ͢o=8	', ' ͢o=8	', 'dg9ZP?p,XW', '', 0, '?'),
 ('Ԣ*#g', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/system-status.min.js', 0, '\Z\rT	\'yqdVL', '\Z\rT	\'yqdVL', ';jq>ͻS\n_|IE', '', 0, '?'),
 ('>@8{+X3', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/term-ordering.js', 0, 'uԤQG#', 'uԤQG#', '2wڥQΗS̏,#|~-U9E', '', 0, '?'),
 ('9}+y/IW', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/term-ordering.min.js', 0, '\0`\nw5\0\Z\Z+W}', '\0`\nw5\0\Z\Z+W}', '2RgW Nz00b\"	IX!+|', '', 0, '?'),
 ('pfο`-\0e{', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/users.js', 0, '0A_$d;p\\', '0A_$d;p\\', '*G<F\"N)#;\'	JkҖIB2i*', '', 0, '?'),
 ('Ϥ=DnA', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/users.min.js', 0, 'MC7Z2|||XKߎ', 'MC7Z2|||XKߎ', '림Y*Y0 7jst', '', 0, '?'),
 ('(\"/Ό]JK', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-clipboard.js', 0, 'ֲ\01ݒh{', 'ֲ\01ݒh{', '(0UμFOQnٌp8Aٷڤ', '', 0, '?'),
 ('\Zm.*8(ظ3', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-clipboard.min.js', 0, 'qR^\ZXcB%+k', 'qR^\ZXcB%+k', 'n```ɸ<YnǾ#FB%oȡ;)', '', 0, '?'),
 (' \'nLLR|`', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-enhanced-select.js', 0, ')\06<C\0Z', ')\06<C\0Z', 'Y9G|aK\\+nϴ\\A', '', 0, '?'),
 (':1O$fy[\"0', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-enhanced-select.min.js', 0, 'qm͢1*\n-\Z', 'qm͢1*\n-\Z', 'G!)!A:YϽΒݾ/2]B4', '', 0, '?'),
 ('=og&@,8', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-orders.js', 0, '^9&Nyc$.[', '^9&Nyc$.[', 'anM?&V=;fE<', '', 0, '?'),
 ('HZEyinJT', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-orders.min.js', 0, '_	@DS)', '_	@DS)', 'z#p:׹$.fG󁯫Pݗ\r1O`e', '', 0, '?'),
 ('4Xʀ]Q9H+', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-export.js', 0, 'uXyn|\0D,Ov', 'uXyn|\0D,Ov', '{|Qb֠vt\Zkδ{n0gyˌÚ', '', 0, '?'),
 ('=L\"Rek	~', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-export.min.js', 0, '{Tq+Ի|{`/J', '{Tq+Ի|{`/J', '	%*KVFeB8ijDVtLS', '', 0, '?'),
 ('nkK.{2$閰', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-import.js', 0, '`E9\"\ZdĔy', '`E9\"\ZdĔy', ' \0jlWĒoH1#r0oO[_', '', 0, '?'),
 ('t;/\':uK', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-import.min.js', 0, '5\"5ꢎS#', '5\"5ꢎS#', '=9	,ZO\Z}HbgHO6t', '', 0, '?'),
 ('t;Ye', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-setup.js', 0, '.Fb\'Mlwѯ', '.Fb\'Mlwѯ', 'Ts{/g/-`6r}qc', '', 0, '?'),
 ('IYҟB`A', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-setup.min.js', 0, '`),)UaX', '`),)UaX', '&a;wQbaW2Zs[A=vP&5', '', 0, '?'),
 ('\"H(NV\'Y}n', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-classes.js', 0, '* QW9k<E', '* QW9k<E', 'V |a%4/\'xF֐?', '', 0, '?'),
 ('\'Uc[ct', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-classes.min.js', 0, 'PG[8_', 'PG[8_', '/3V,3(\'I\\z6c\\7Bt~8z', '', 0, '?'),
 ('56fx뷶L', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zone-methods.js', 0, '͈}/3[ڑI', '͈}/3[ڑI', 'X[Z\\*\0-NY', '', 0, '?'),
 ('U6IP', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zone-methods.min.js', 0, '.\nPP', '.\nPP', 'HH2:6@Ht&ϰGb\r<VN', '', 0, '?'),
 ('*\nEvX', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zones.js', 0, 'bTvGllf', 'bTvGllf', 'R~c[IYa-!GW\0^J:\"', '', 0, '?'),
 ('g6[t;*z', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zones.min.js', 0, '3m_\"alsQ', '3m_\"alsQ', '\"%-M\0JqQL*`_5v', '', 0, '?'),
 ('|poWPѦ', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/woocommerce_admin.js', 0, 'ˤҋ\"]', 'ˤҋ\"]', 'f$NmDdݭ-򺪶_W\"Lh]$', '', 0, '?'),
 ('lu	)PPʮy', 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/woocommerce_admin.min.js', 0, 'Vbe2b(', 'Vbe2b(', '/(V.<f܅&y	%|rh}Pߛ', '', 0, '?'),
 ('݊QTߐu:\0Ȟ', 'wp-content/updraft/plugins-old/woocommerce/assets/js/flexslider/jquery.flexslider.js', 0, '~ف2yWh', '~ف2yWh', 'E^`tZ0/&\"5\r+t3)1', '', 0, '?'),
 ('*^̔ #', 'wp-content/updraft/plugins-old/woocommerce/assets/js/flexslider/jquery.flexslider.min.js', 0, ':T>۠Nm\nS', ':T>۠Nm\nS', ',8q8Wj}>Yq\"U}gBl=۹z', '', 0, '?'),
 ('_Ѩt`@zC', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-payment-method.js', 0, 'tsCq5M\"c~', 'tsCq5M\"c~', '1yANv6g9:f٤\\)w7', '', 0, '?'),
 ('[\"B', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-payment-method.min.js', 0, 'HPMMؗ^', 'HPMMؗ^', 'aP\r&&0ȝhh^$r', '', 0, '?'),
 (';o:@zY', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart-variation.js', 0, '1GJeeܳnd', '1GJeeܳnd', '	V6t\01`9Un	9r', '', 0, '?'),
 ('c m1f,ᔾ', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart-variation.min.js', 0, '\Z)-+H', '\Z)-+H', 'z9bGm|l[3 `K', '', 0, '?'),
 ('!w0OuT', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart.js', 0, 'nyd2YY', 'nyd2YY', 'ЃDk[g9,ȔDiEA_', '', 0, '?'),
 ('5\"OgS', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart.min.js', 0, '\0V2EW+B', '\0V2EW+B', ']\ZNW2hFJ٦Wi:w', '', 0, '?'),
 ('o$I{G', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/address-i18n.js', 0, 'pEtOpDĖv', 'pEtOpDĖv', 'AEsm~tBJ/HC׼RO', '', 0, '?'),
 ('(XӮW\n=E#D', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/address-i18n.min.js', 0, 'z7,u)cX', 'z7,u)cX', 'E:߅?@~^ ]!yVXh	{', '', 0, '?'),
 ('F:u}욱', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart-fragments.js', 0, 'P@!i.>', 'P@!i.>', 'C`hjW;S;db1[@u', '', 0, '?'),
 ('RS\nGIT`:', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart-fragments.min.js', 0, '5G\\H', '5G\\H', '1Xim\n=phȯc&5;u', '', 0, '?'),
 ('\r7F03	', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart.js', 0, 'UE!z_\r)\r', 'UE!z_\r)\r', 'WvBxl9=o~.Ncr', '', 0, '?'),
 ('#s,&m2,', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart.min.js', 0, 'U^fٿ\'	a', 'U^fٿ\'	a', '\rdVOԒv!4@{R+\"\'', '', 0, '?'),
 ('pyot', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/checkout.js', 0, 'D-xyV@', 'D-xyV@', 'C4j3>Dā\\UTUVʱ+\n', '', 0, '?'),
 ('PQUox', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/checkout.min.js', 0, 'd&z\nAp3Us', 'd&z\nAp3Us', '0-׷:۸*M\0NmڪQΚ', '', 0, '?'),
 ('ts],^iҝB', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/country-select.js', 0, '军NŢ-<3', '军NŢ-<3', 'KzՎ/:9sGs?]]L=', '', 0, '?'),
 (')إY-A5F.', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/country-select.min.js', 0, '(`C', '(`C', 'Z2+x{Xv])4>c|,k', '', 0, '?'),
 (']RۈT5', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/credit-card-form.js', 0, '~wh%\\', '~wh%\\', 'D~	mL9l<;~bp9FMtVl', '', 0, '?'),
 ('Y+kuL', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/credit-card-form.min.js', 0, '\0)FP6=nL1', '\0)FP6=nL1', '̓OgytD?alTQ}AK', '', 0, '?'),
 ('08#ZX`ckE', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/geolocation.js', 0, 'Ȟ4ojV', 'Ȟ4ojV', ';o휌i7FID{Ӫ#', '', 0, '?'),
 ('_vכXJxL', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/geolocation.min.js', 0, 'ĜL!Mݏ@{B', 'ĜL!Mݏ@{B', 'Cߡ:Nqvld+Bi~Io', '', 0, '?'),
 ('!U`<', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/lost-password.js', 0, '\0HY[_f', '\0HY[_f', 'Dݷz{..2	Ɛa', '', 0, '?'),
 ('OslX', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/lost-password.min.js', 0, 'JxDّV\n', 'JxDّV\n', 'X3q0l7Pk[ ?3+\Z', '', 0, '?'),
 ('{P`֋*»', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/password-strength-meter.js', 0, 'u!^%ԓ:\n', 'u!^%ԓ:\n', 'W7k\Z$~I~|\Z(@$gy%WW', '', 0, '?'),
 ('j6֖oU__', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/password-strength-meter.min.js', 0, '1t;;\n95', '1t;;\n95', '+ I3\\eק1c', '', 0, '?'),
 ('h8Nh4', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/price-slider.js', 0, '\\r[bAOR', '\\r[bAOR', 'R\rni޽7LB\n8mƞ\roOX', '', 0, '?'),
 ('|!mǇ^', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/price-slider.min.js', 0, 'Q&UA\0', 'Q&UA\0', '\'`%$XtcTjF9', '', 0, '?'),
 ('SjXqR]?', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/single-product.js', 0, 'FTotPblRdP', 'FTotPblRdP', 'q>8\r\\R;w ((m>Tp8', '', 0, '?'),
 ('8ok', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/single-product.min.js', 0, '_@{؜F\"', '_@{؜F\"', '會ߑvvq~\\3*M)OV', '', 0, '?'),
 ('\'cdPaCi', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/tokenization-form.js', 0, 'ABAMI%_ߖ', 'ABAMI%_ߖ', 'n+҅@<!`,Δn', '', 0, '?'),
 ('O/buK>LP', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/tokenization-form.min.js', 0, '/-hW1TG(7 ', '/-hW1TG(7 ', 'OVraٽPB.3)kn', '', 0, '?'),
 ('9C9\n\0]\'', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/woocommerce.js', 0, 'Md7^+$', 'Md7^+$', 'dԚ)1qjH\n6m{6S', '', 0, '?'),
 ('IOWk', 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/woocommerce.min.js', 0, '@5v^Rci', '@5v^Rci', 'Lѕڙ:w32׿MqyJ9J', '', 0, '?'),
 ('U<Tmq=˝', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-blockui/jquery.blockUI.js', 0, '[04Fb', '[04Fb', 'f?O=*c#/f)ݢc', '', 0, '?'),
 ('X.ʞ-Y3', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-blockui/jquery.blockUI.min.js', 0, 'ilMb{m\ruf', 'ilMb{m\ruf', 'Zo?аfG?A5ws7/ܔ', '', 0, '?'),
 (')o%7Q%֚', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-cookie/jquery.cookie.js', 0, 'y/$P=TM', 'y/$P=TM', '=Lӯ5BJj0u_aMY`', '', 0, '?'),
 ('8[傖~9', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-cookie/jquery.cookie.min.js', 0, '?[cjZC^b', '?[cjZC^b', 'ewR8MSK\n#m\\.', '', 0, '?'),
 ('\'W-G#ZCSEw', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.js', 0, '5Q./:\n,', '5Q./:\n,', '	\'ˎ껞o	(:Vp<Ht|', '', 0, '?'),
 ('#£y>Mʹ', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.min.js', 0, '@tΎ}#I', '@tΎ}#I', 't`ڡgA)d[҈hTTg!', '', 0, '?'),
 ('ΌC~4ؗ\'^Y', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.pie.js', 0, 'z;5FdMɬ', 'z;5FdMɬ', '|U㢭F4:aF])', '', 0, '?'),
 ('h7Re$7Ts#T', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.pie.min.js', 0, 'Dx0]N{', 'Dx0]N{', '\Z\n׃s$S_/@O\\', '', 0, '?'),
 ('ku@F-Uj\0', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.resize.js', 0, 'fDU$', 'fDU$', 'ezN{80NofL%\n**H/\ns`^', '', 0, '?'),
 ('tFS<k:-', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.resize.min.js', 0, 'IG1B<љ', 'IG1B<љ', '(f\"59_:YgE#^', '', 0, '?'),
 ('V)`WBT8', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.stack.js', 0, '5:ǡ0-<B', '5:ǡ0-<B', 'Y]AS!c-TNřIƚ', '', 0, '?'),
 ('S^XfP]', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.stack.min.js', 0, 'hs	8JDh', 'hs	8JDh', '&RyF5gX6z>PWW^', '', 0, '?'),
 (',Ⱦuu{', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.time.js', 0, 'WD5z)I', 'WD5z)I', '$Ą@yUNR^1gy?QL-w', '', 0, '?'),
 ('GѕH5՗8', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.time.min.js', 0, 'lK	@Eu', 'lK	@Eu', '{;Uk%I=weTW\rw', '', 0, '?'),
 ('E1gI,ܛqs', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-payment/jquery.payment.js', 0, '-6żCe', '-6żCe', '3ABDSD;|Mcg\0=Uv89', '', 0, '?'),
 ('\"m61:480', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-payment/jquery.payment.min.js', 0, '	zkRMsi', '	zkRMsi', '2fa<TaTӒM+5,] G', '', 0, '?'),
 ('H>ۭ8;6', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-qrcode/jquery.qrcode.js', 0, 'rKGj@', 'rKGj@', 'q\0+vh1epW^~am', '', 0, '?'),
 ('#\0kצ2}~cŉ*', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-qrcode/jquery.qrcode.min.js', 0, '&4UhZ	\ZVU', '&4UhZ	\ZVU', 's?}VyfvPsCr+f', '', 0, '?'),
 ('HY(-', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-serializejson/jquery.serializejson.js', 0, 't9O/׮$\r', 't9O/׮$\r', 'ez1)P,GItY$\'\'O򑞩', '', 0, '?'),
 ('p_ld|T ', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-serializejson/jquery.serializejson.min.js', 0, 'S+\Z2V6\'', 'S+\Z2V6\'', '5tYt{\nkP04-.R', '', 0, '?'),
 ('L{=өYvъ,i', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-tiptip/jquery.tipTip.js', 0, 'eK[u=tv3', 'eK[u=tv3', '򰢺/{f곕E\r{Q2S-CxC/Nn', '', 0, '?'),
 (' =b>¹:<', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-tiptip/jquery.tipTip.min.js', 0, '1IaK!*2', '1IaK!*2', '[_6^)\nzb1', '', 0, '?'),
 ('EU|I+', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-ui-touch-punch/jquery-ui-touch-punch.js', 0, 'YLxkb҂K', 'YLxkb҂K', '$˰TWՉ{%(Lο5', '', 0, '?'),
 ('̅|o}Zi	', 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-ui-touch-punch/jquery-ui-touch-punch.min.js', 0, 'OT27,4 n', 'OT27,4 n', 'xhw;qR', '', 0, '?'),
 ('|Ӟ2XM^', 'wp-content/updraft/plugins-old/woocommerce/assets/js/js-cookie/js.cookie.js', 0, 'n:Zsw8', 'n:Zsw8', '_V-ǦHXȘ>', '', 0, '?'),
 ('I.ndL\0', 'wp-content/updraft/plugins-old/woocommerce/assets/js/js-cookie/js.cookie.min.js', 0, '?nb[e墄', '?nb[e墄', '6~dR Qgc^9iD', '', 0, '?'),
 ('b&/akݶ0j', 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe-ui-default.js', 0, 'Ldnx', 'Ldnx', 'FQM:oC*ǚY7R6V', '', 0, '?'),
 ('=ln]\nLK', 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe-ui-default.min.js', 0, 'g5@,ѱB`', 'g5@,ѱB`', '*&FƄSSYK	cAI!4uh&M', '', 0, '?'),
 ('{krlOr', 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe.js', 0, 'B\ntRhV8m', 'B\ntRhV8m', 't\nyhq\n&bD\Z(X7x', '', 0, '?'),
 ('7arS˴}', 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe.min.js', 0, 'sRyo2@', 'sRyo2@', '-0yƜ$V	VV=33aP?*ܮ', '', 0, '?'),
 ('(Ē$.\Z]', 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.init.js', 0, 'Q#Ns', 'Q#Ns', 'Md	7u\Z+iӏd*#', '', 0, '?'),
 ('\0q&ͨ$', 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.init.min.js', 0, '^ _=', '^ _=', 'gd]Ϸp~5yfh7-ĵQTgG', '', 0, '?'),
 ('Q|j\r\Z', 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.js', 0, '翂%NC8cB', '翂%NC8cB', '9 LxÁOZijW$4', '', 0, '?'),
 ('n	{`[0', 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.min.js', 0, '3S2=mTW', '3S2=mTW', '֥tpǩMܒ2ӥĳ', '', 0, '?'),
 ('mw7.~}14q', 'wp-content/updraft/plugins-old/woocommerce/assets/js/round/round.js', 0, 'bLŨZH+j^', 'bLŨZH+j^', '1W\'\nK]vYϧX~\r`hW@', '', 0, '?'),
 ('l->pAʊZ', 'wp-content/updraft/plugins-old/woocommerce/assets/js/round/round.min.js', 0, 'FӍ҆{W5', 'FӍ҆{W5', 'D;<_{qe*\rhЈR$?Hcql', '', 0, '?'),
 ('\r{o{', 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.full.js', 0, 'S#G`\0עRxmc', 'S#G`\0עRxmc', 'I;QYk^P&~ɮ?W', '', 0, '?'),
 ('f1GXJ7,', 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.full.min.js', 0, '`s`R֍T9', '`s`R֍T9', 'إI%40ur=TOTE\0/p\'', '', 0, '?'),
 ('DkF SB', 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.js', 0, 'ms<bc\'>', 'ms<bc\'>', 'ߚv+2*,_i\nzVGV >', '', 0, '?'),
 ('!$9G97s', 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.min.js', 0, '!P	0\\>', '!P	0\\>', 'zCdw>R= t:dcKgK.XC]Ny', '', 0, '?'),
 ('4eL.pQ?b', 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.full.js', 0, 'LFL\'SC1Ţ)', 'LFL\'SC1Ţ)', 'e8ϡH\rieIT	+', '', 0, '?'),
 ('[\r4>\r', 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.full.min.js', 0, 'n!\'{͓\Z', 'n!\'{͓\Z', 'g(;PJJה&az\'6\'p@	a', '', 0, '?'),
 ('	!7T+{', 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.js', 0, 'u7_=\04zke칭', 'u7_=\04zke칭', '1//	}{m^U<{b', '', 0, '?'),
 ('2 k-', 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.min.js', 0, 'S(h~q7r', 'S(h~q7r', '?JK{ͦ\rQL`:\n7bߐ', '', 0, '?'),
 ('|(\"-yG%5>T', 'wp-content/updraft/plugins-old/woocommerce/assets/js/stupidtable/stupidtable.js', 0, 'F5NE?Vcu_؂', 'F5NE?Vcu_؂', '!uWP@<ߋ~EVw[8', '', 0, '?'),
 ('\"bF$\'', 'wp-content/updraft/plugins-old/woocommerce/assets/js/stupidtable/stupidtable.min.js', 0, 'H	|(7S9΁', 'H	|(7S9΁', 'Zd`hY/=pJm', '', 0, '?'),
 ('$o38!5~', 'wp-content/updraft/plugins-old/woocommerce/assets/js/zeroclipboard/jquery.zeroclipboard.js', 0, '/,Z\')h#&', '/,Z\')h#&', ' feyC>vd:7 ', '', 0, '?'),
 ('d6JmhUU(', 'wp-content/updraft/plugins-old/woocommerce/assets/js/zeroclipboard/jquery.zeroclipboard.min.js', 0, 'd)\ZaJ+', 'd)\ZaJ+', '86Qi~6?+T!cy[$}YW', '', 0, '?'),
 ('Ya1|I', 'wp-content/updraft/plugins-old/woocommerce/assets/js/zoom/jquery.zoom.js', 0, '.asל\"al', '.asל\"al', 'a6]*RS{LQc', '', 0, '?'),
 ('W\nI~<>', 'wp-content/updraft/plugins-old/woocommerce/assets/js/zoom/jquery.zoom.min.js', 0, 'kr.F', 'kr.F', '\rKT)(T	V|ODug', '', 0, '?'),
 ('zX7SLOJ', 'wp-content/updraft/plugins-old/woocommerce/i18n/continents.php', 0, 'C!;Qy', 'C!;Qy', 'ף$U!kcU.FvΤ', '', 0, '?'),
 ('\n\' HX	T8', 'wp-content/updraft/plugins-old/woocommerce/i18n/countries.php', 0, '5\n\nKA;vjIe', '5\n\nKA;vjIe', '}HZUhbr}-G', '', 0, '?'),
 ('w&rL$uG', 'wp-content/updraft/plugins-old/woocommerce/i18n/locale-info.php', 0, '˕!fʠLq\r4Z', '˕!fʠLq\r4Z', 'd[%Lg۴7x)q#)', '', 0, '?'),
 ('*쯝t', 'wp-content/updraft/plugins-old/woocommerce/i18n/phone.php', 0, '%Tu~NÓ', '%Tu~NÓ', '\r\' nd䱪 :xYfyu~', '', 0, '?'),
 ('c+\nzTrwfXk', 'wp-content/updraft/plugins-old/woocommerce/i18n/states.php', 0, '܎79*=P', '܎79*=P', 'Y\\KP;X\'\'M(G)=mTR/', '', 0, '?'),
 ('F[0Rʜ', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-data.php', 0, '`܂C^}', '`܂C^}', '##AWzrЭB?%-7	\Zc=m', '', 0, '?'),
 ('DLB\'!\"SYQ%', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-deprecated-hooks.php', 0, 'ro\"0w@', 'ro\"0w@', '/7̮fW%Ry{~LQOdxeH', '', 0, '?'),
 ('ɇv&/S\r4', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-integration.php', 0, '\nQPQ=֮6-', '\nQPQ=֮6-', '\\1J,]n^!&\'`K2C', '', 0, '?'),
 ('2dpRZru', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-log-handler.php', 0, 'adt`gxlV', 'adt`gxlV', '^h%|yr4', '', 0, '?'),
 ('2íbتs', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-object-query.php', 0, 'h%mB', 'h%mB', '0ׁӊH&[y+NѰxbOn$7E', '', 0, '?'),
 ('DQ\nUr', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-order.php', 0, 'U<06tw56Y', 'U<06tw56Y', 'S*lȺN?S(J;:!v;R', '', 0, '?'),
 ('(*j3', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-payment-gateway.php', 0, 'cIR]Ə@', 'cIR]Ə@', 'CL5CH(}:Jyy?bi\ne0t', '', 0, '?'),
 ('Db?Mn(', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-payment-token.php', 0, 'm.\nL}Z!<', 'm.\nL}Z!<', 'OˉpYXEL3', '', 0, '?'),
 ('D[G6-I-¹', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-privacy.php', 0, 'V|bd\nC֤g\n', 'V|bd\nC֤g\n', 'Jiΰqm}$4Zp', '', 0, '?'),
 ('utZX>%', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-product.php', 0, 'hÕ9yJFL', 'hÕ9yJFL', 'q.fٖu\0Xl?PUώ', '', 0, '?'),
 ('Vs<3n-S2', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-session.php', 0, 'XS틭,+S', 'XS틭,+S', 'fV0IK/\"]0uL3y\n', '', 0, '?'),
 ('\rmNW', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-settings-api.php', 0, 'zS/¾/{', 'zS/¾/{', 'q\'\\(NWq?^a.ڍn', '', 0, '?'),
 ('s<ioZTΈw', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-shipping-method.php', 0, 'Uaukib>T', 'Uaukib>T', 'l)\"do\"srdػi_Tt|', '', 0, '?'),
 ('v5ŉ%Ą', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-widget.php', 0, '0\'8/	כ>(', '0\'8/	כ>(', 'aa?qON:8D0H}u', '', 0, '?'),
 ('e>G*VlQi', 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/class-wc-background-process.php', 0, '1rĩ҅:XIi/', '1rĩ҅:XIi/', 'd0eg4Rϣ.ygtKj', '', 0, '?'),
 ('()2bk', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-addons.php', 0, 'W\'Icu', 'W\'Icu', 'BRtz:Qr&eh$5YQs9P6', '', 0, '?'),
 ('!5 ҽ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-api-keys-table-list.php', 0, '$-t)+u\'', '$-t)+u\'', '8\"lw(lo`f4¨3$@E', '', 0, '?'),
 ('7S.m#%@ᇃ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-api-keys.php', 0, '7jvwr3.', '7jvwr3.', '\n\0UtૣzRǑԽ+', '', 0, '?'),
 ('#F\nL?b0[g', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-assets.php', 0, '_yOAk>', '_yOAk>', 'k6&ƥz`H\'b[iڋ:T1', '', 0, '?'),
 ('%pRA,D', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-attributes.php', 0, 'էյ-\0j+>', 'էյ-\0j+>', '\Z*~:yXPѷBz@oſ@', '', 0, '?'),
 ('0$P- t', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-customize.php', 0, 'K=Ql6md', 'K=Ql6md', 'v|bE\'.JQƔ.J', '', 0, '?'),
 ('dd?3zf0k', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-dashboard.php', 0, 'O\"QzeIs', 'O\"QzeIs', '=dJwZUmٳ|dغ=aHU', '', 0, '?'),
 ('eSO=w&\\', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-duplicate-product.php', 0, '$XX>$!+', '$XX>$!+', 'Uw̥37Q1Im6JVYJ27', '', 0, '?'),
 ('O4\\#D.', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-exporters.php', 0, 'E6q{; ,)`', 'E6q{; ,)`', 'sԁ<k24\'JZO@Tye<\"', '', 0, '?'),
 ('_N~g4b\n', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-help.php', 0, 'Wz\"v*$Zk', 'Wz\"v*$Zk', '*\'ڣ\"ߗ9%\"h7]', '', 0, '?'),
 ('r`Q-uRd<2', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-importers.php', 0, 'htӕg!VEk', 'htӕg!VEk', 'Mw]F[ײ2vQ`ٙ2.j', '', 0, '?'),
 ('P\'M0', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-log-table-list.php', 0, 'qf=9', 'qf=9', '%U*FJ\"UuD67-', '', 0, '?'),
 ('x[tꆗ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-menus.php', 0, 'Ԑ~BgRen', 'Ԑ~BgRen', 'tr#\Z;Չ=45&v', '', 0, '?'),
 ('P1\"ţ}wMxu', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-meta-boxes.php', 0, '_zu}]eS\Z', '_zu}]eS\Z', 'Ʈqwk<X!*D=4J\Z$#', '', 0, '?'),
 ('!>ϳ[', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-notices.php', 0, '+\0bpY', '+\0bpY', 'Ӕ+uҕ4VoDG`', '', 0, '?'),
 ('{\rv', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-permalink-settings.php', 0, 'Xsm2cu*', 'Xsm2cu*', '=.?<TB[6g6k\ZDM', '', 0, '?'),
 ('K꺗+h', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-pointers.php', 0, '\0y~wWUMss', '\0y~wWUMss', '\0O${c]ԦbE%Qt[aCS\"', '', 0, '?'),
 ('w+Us	H9m6', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-post-types.php', 0, '.znN@w', '.znN@w', '	U_i0UUQ\'v8GEN', '', 0, '?'),
 ('ϰl*:X', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-profile.php', 0, 'Uґ;=h', 'Uґ;=h', '5\Z1z\rq_)BH', '', 0, '?'),
 ('A*,\"\\CuJ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-reports.php', 0, '63>^eAF\0', '63>^eAF\0', 'eot tw?譮\Z(\0{L', '', 0, '?'),
 ('q?~b\rCK', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-settings.php', 0, ',3ea	', ',3ea	', '	\ry1%J$\Z=WD$', '', 0, '?'),
 ('|1QM1=', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-setup-wizard.php', 0, '!n\'<+8]', '!n\'<+8]', '4A!sߩ%hH`u{ǖ', '', 0, '?'),
 ('閶3J/c}', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-status.php', 0, '/OŲNJt', '/OŲNJt', ':.%$#穞dd>1;q', '', 0, '?'),
 ('Ev2ڙW', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-taxonomies.php', 0, '](z!ųiiF', '](z!ųiiF', '>vӋVR7imW/CBM8', '', 0, '?'),
 ('t[4G%k+z', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-webhooks-table-list.php', 0, 'ݬ6W', 'ݬ6W', 'e+gP5YI,a^O&CE', '', 0, '?'),
 ('LR?r-1^ķ.', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-webhooks.php', 0, '2oMZ%(p^', '2oMZ%(p^', 'Hy{G49UDI̙8#pi', '', 0, '?'),
 ('v\\Ґv90I\"\"', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin.php', 0, '=p?U+', '=p?U+', 'XmjPed+Ay:wAN_\rBx', '', 0, '?'),
 ('!]aBc$>.', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-api.php', 0, 'W{ՠZN|', 'W{ՠZN|', 'L}50y\\}]isNvGgre', '', 0, '?'),
 ('\Z5*K-_D9\"G', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-compat.php', 0, 'YIFYV8', 'YIFYV8', '¢\\|]᝖kdZg|MQ', '', 0, '?'),
 ('25Ŕɡl-*G', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-options.php', 0, '.\0&3nzn', '.\0&3nzn', 'ZhŹhAækdeHh$.ջ', '', 0, '?'),
 ('Y4^֨\ng~0On', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-plugin-info.php', 0, 'ڙsNKh[?', 'ڙsNKh[?', 'GeTfˉYI', '', 0, '?'),
 ('Y\0,.,QU', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-updater.php', 0, 'h8Ѧ)kȳY', 'h8Ѧ)kȳY', '\0H$fY4hqV-ȣ}<IIu', '', 0, '?'),
 ('4ؖ+E^D|', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper.php', 0, 'ž{\0\Zf`#5', 'ž{\0\Zf`#5', 'eE%dhFNwa][	ag', '', 0, '?'),
 ('ˠ\0tBМ \"W', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-helper-compat.php', 0, '\0~\r}}<DP', '\0~\r}}<DP', 'FLJPRnE2߾9rV15', '', 0, '?'),
 ('GB+aiD&<', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-main.php', 0, 'Vlw	KK', 'Vlw	KK', '%H	y4zˠ\r-D[\Z?', '', 0, '?'),
 ('h\\tme~dlD', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-oauth-start.php', 0, '!,e<~D', '!,e<~D', '< \nUv|K]', '', 0, '?'),
 ('J|QSֺG', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-section-account.php', 0, 'bf,WY16', 'bf,WY16', 'O6:r;QSyFJ:*', '', 0, '?'),
 ('=]\\ncU', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-section-nav.php', 0, 'ߙ?%kQ', 'ߙ?%kQ', '1PBBM(\"/P5Fz,j5;h	Y', '', 0, '?'),
 ('gqک7Lb', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-section-notices.php', 0, 'D+dZpr', 'D+dZpr', '1TYȅT47&evLP/&n^', '', 0, '?'),
 ('-v5ice', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/class-wc-product-csv-importer-controller.php', 0, 'YaRYT+W', 'YaRYT+W', '1ِ^_lo~\\P726', '', 0, '?'),
 ('=1P^@Թ|C', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/class-wc-tax-rate-importer.php', 0, 'p;3_蘍3', 'p;3_蘍3', 'Uc\Z&h\\Y:*\rG6?{@Lκ4dK', '', 0, '?'),
 ('@Ԯ/t[UZ/', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/default.php', 0, '{zv3Fe\0', '{zv3Fe\0', '81ΊInz?ƚ2cHzU#', '', 0, '?'),
 ('I .)Ѣ1U', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/generic.php', 0, 'wilj6Tbmh', 'wilj6Tbmh', 'R\'˯n\"}z', '', 0, '?'),
 ('wumdYWw', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/mappings.php', 0, '4qDR9|', '4qDR9|', '0m\\ÖⷘҩB', '', 0, '?'),
 ('\0۶', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/shopify.php', 0, 'z\0$SYKv܈', 'z\0$SYKv܈', '9,kdZei|T7A1S?[Q', '', 0, '?'),
 ('.\"5,\0', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/wordpress.php', 0, 'LB)zkH', 'LB)zkH', 'Ab\0ʆPOTe\Z	a}\Z', '', 0, '?'),
 ('9zTA?WG5z', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-done.php', 0, '4X~?k', '4X~?k', '?\"c{\'ꊚ!o9', '', 0, '?'),
 ('\Z.N@GuDz3\Z', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-footer.php', 0, '(hv$mpn+w', '(hv$mpn+w', 'ӥ?$VOnkmJt̶', '', 0, '?'),
 ('ڡ[G;+f', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-header.php', 0, 'm;\rheHf', 'm;\rheHf', 'FyF1Iv%hd弸', '', 0, '?'),
 ('ڦm\"68ta', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-mapping.php', 0, 'DG¨[_', 'DG¨[_', 'ebǈMgR+M ,K\Z', '', 0, '?'),
 ('\nxuxS', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-progress.php', 0, '3#YA޿`iOF	|', '3#YA޿`iOF	|', 'kځfyw]VL%NG	 L', '', 0, '?'),
 ('İiAv:mIz(', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-steps.php', 0, 'EKdvFlql', 'EKdvFlql', '+[\'&Gjvscl1Գp', '', 0, '?'),
 ('_w:9c_c', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-product-csv-import-form.php', 0, '=M<4R', '=M<4R', 'I.gŉ1ㆎ;UK\"\'j', '', 0, '?'),
 ('+EB۴7D[', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/abstract-class-wc-admin-list-table.php', 0, '9^g\0ĝ|', '9^g\0ĝ|', '5Bꂺ찕yܹi\'sQӥJp', '', 0, '?'),
 ('R?zY&\nB', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/class-wc-admin-list-table-coupons.php', 0, '&tZ{u<g\ZN', '&tZ{u<g\ZN', '-FjBKG5o0j6jF', '', 0, '?'),
 (']7f5{2ӎ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/class-wc-admin-list-table-orders.php', 0, '&&PRD-', '&&PRD-', 'uP;dӞz/@|g', '', 0, '?'),
 ('h!d1i4qg', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/class-wc-admin-list-table-products.php', 0, 'V6P\'xa', 'V6P\'xa', 'lUuu#raPx!CP', '', 0, '?'),
 ('B\n|f LE9', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/class-wc-marketplace-suggestions.php', 0, 'pʂ\0HW#', 'pʂ\0HW#', 'R7Z5^͂7.6kTߏUD', '', 0, '?'),
 ('SQk鉿kЗ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/class-wc-marketplace-updater.php', 0, ':j 2h', ':j 2h', 'z$kŪʭv[Uf$\r8g', '', 0, '?'),
 ('P1^PTY.', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/templates/html-product-data-extensions.php', 0, '4~Urp', '4~Urp', 'p\"V1`5\r', '', 0, '?'),
 ('c(˔^WKN^x', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/views/container.php', 0, 'Z̘hJi*4', 'Z̘hJi*4', 'MY\r-\01Jbi', '', 0, '?'),
 (')dKߙ!89x', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-coupon-data.php', 0, '$ ڵtXd\\', '$ ڵtXd\\', 'fV<;{?$%y.FRV3y\'N', '', 0, '?'),
 ('J;7M5\")', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-actions.php', 0, 'jt-F:-\Zn', 'jt-F:-\Zn', 'dkɛ\'PoKFPG\n', '', 0, '?'),
 ('=teY\'w', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-data.php', 0, '`k\rh}?q', '`k\rh}?q', '>SFDb]Ɍ#_tz', '', 0, '?'),
 ('Hr4E*', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-downloads.php', 0, 'q-_)˵XBJzU', 'q-_)˵XBJzU', 'JpfqH5td#O%|N', '', 0, '?'),
 ('2rxfٍy', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-items.php', 0, '$Ģ8	xa', '$Ģ8	xa', '!՝\Zl1Oe>I', '', 0, '?'),
 ('.ME1', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-notes.php', 0, '&o4쯘0', '&o4쯘0', 'bE>4W#', '', 0, '?'),
 ('7>Bx2Fr=}', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-data.php', 0, 'X\\ۉB9yB#m.', 'X\\ۉB9yB#m.', 'DX!~P\0$<D~  <d}t', '', 0, '?'),
 ('Zz\"E1!;', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-images.php', 0, ')xvAjcy', ')xvAjcy', '2-eGpW&\\36`1z3ʵ^', '', 0, '?'),
 ('y&qNZ(t', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-reviews.php', 0, 'p=*@03;', 'p=*@03;', ']~adD{c\r7', '', 0, '?'),
 ('n}2OڋSFh', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-short-description.php', 0, 'LbyDz02', 'LbyDz02', '7֙&+D\'prBqZ5`*	Z', '', 0, '?'),
 ('sru`\'#f', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-download-permission.php', 0, '۵H(f<榖', '۵H(f<榖', 'ĞL{\0=VG{D5Wb}΂\ZZ', '', 0, '?'),
 ('^sH', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-fee.php', 0, '8 h$PD;iPT', '8 h$PD;iPT', '/-`(ވ7Gs=\02l', '', 0, '?'),
 ('r%]', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-item-meta.php', 0, '[~MPf{3', '[~MPf{3', '(C_$&xƶy&5ω|.E~F\ra', '', 0, '?'),
 ('\nF', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-item.php', 0, 'xLjya=', 'xLjya=', '\r^6 +XNc|9%qv觏p', '', 0, '?'),
 ('c7{oLQDS', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-items.php', 0, '+@\\F2x(9=H', '+@\\F2x(9=H', 'vTATeKUd=ђJɡ̗V&K', '', 0, '?'),
 ('IÎasX', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-notes.php', 0, '[\'^_:4uM', '[\'^_:4uM', '[MU/t`6rX>G%ҙ\'', '', 0, '?'),
 ('G&6>S', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-refund.php', 0, '禧_IDZ', '禧_IDZ', 'ʰ`Ph:J	\\o7ΧcQw', '', 0, '?'),
 ('}|,N8r', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-shipping.php', 0, 'Bܔ\"B_uRW', 'Bܔ\"B_uRW', '+x\"UNAT-#)i·}߾', '', 0, '?'),
 ('\\4\n!5FH\"!\'', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-attribute.php', 0, 'LA P7s', 'LA P7s', '2jʝeCЎa&oy?QՐ', '', 0, '?'),
 ('t*]', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-advanced.php', 0, 'F/n8fr', 'F/n8fr', 'nUiIE?o?x3[袂@z', '', 0, '?'),
 ('03/K]P#', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-attributes.php', 0, '*0YA', '*0YA', 'q:hPb!gkcB\0)a\"~*', '', 0, '?'),
 ('X% A,#\\', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-general.php', 0, '_O\'YVX', '_O\'YVX', 'U06҂0pg&\"K{w:5bɘp.Z', '', 0, '?'),
 ('o\n\nAUKM', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-inventory.php', 0, 'pAWɶ7`\r', 'pAWɶ7`\r', '\'id,x6go@HP]Q ', '', 0, '?'),
 ('kzE0\rB9̃', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-linked-products.php', 0, '᥾YW;v', '᥾YW;v', '\rka*iR)gSDIBh z ', '', 0, '?'),
 ('vH\"Љ!T~', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-panel.php', 0, '+0ꩫu 5', '+0ꩫu 5', 'h%нV-Vިy6ڔʍ', '', 0, '?'),
 ('F}4p{w', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-shipping.php', 0, '8~`', '8~`', 'E-.:q-Q~|6C.+Pm<', '', 0, '?'),
 ('G5ȳsE\n]', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-variations.php', 0, 'nh:_zQ@', 'nh:_zQ@', 'NW2Cb䎡T\"4D\ZC~+', '', 0, '?'),
 ('b_K]', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-download.php', 0, 'qK,ێ', 'qK,ێ', 'J!$\\/\\mgj3@', '', 0, '?'),
 ('Ju~>\"[h5+@_dA', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-variation-download.php', 0, 'ZKY kl~', 'ZKY kl~', '$d_o=Yy%(5M+#o^wF', '', 0, '?'),
 ('h_S:@AKr', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-variation-admin.php', 0, 'IwG8lgs', 'IwG8lgs', 'Uq\rfZ,su\"z', '', 0, '?'),
 ('Hnz	c#', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/notes/class-wc-notes-run-db-update.php', 0, 'Srs=}', 'Srs=}', '$po?x>̏}ƀL,W', '', 0, '?'),
 ('UQc\\vGiF', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/class-wc-plugin-updates.php', 0, 'u>g܇&Σ', 'u>g܇&Σ', 'e\'#ik|\r5.$л2w\0VXv.', '', 0, '?'),
 ('}	 V9U[^}&', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/class-wc-plugins-screen-updates.php', 0, ',\r3', ',\r3', '`!A¯x:QDXΒt >@', '', 0, '?'),
 ('o<F0Kք', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/class-wc-updates-screen-updates.php', 0, '[=tr1yAe', '[=tr1yAe', 'X(ߊ\n9[2Dy\'egB9\'', '', 0, '?'),
 ('WFٸ7\Z,f\\', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/views/html-notice-untested-extensions-inline.php', 0, 'MadA۶Gx', 'MadA۶Gx', ':~\\k_0$X\"{uD␚', '', 0, '?'),
 ('«7BI&', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/views/html-notice-untested-extensions-modal.php', 0, '|e\Zh\ng%\\N', '|e\Zh\ng%\\N', 'h%ryhsg2(AR', '', 0, '?'),
 (';b*Zg8S', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-admin-report.php', 0, '!<?c޴ڻCMz5', '!<?c޴ڻCMz5', 't \"ĄNAc[9%?=', '', 0, '?'),
 ('\\dk\rl~T', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-coupon-usage.php', 0, 'mVJ7AC\"~', 'mVJ7AC\"~', '\r&+Уg,ՄΈZHE', '', 0, '?'),
 ('^|*]\r', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-customer-list.php', 0, 'VД\0Լ\nM+', 'VД\0Լ\nM+', 'g\Z-ưׯW.U&7h%VTnۢ', '', 0, '?'),
 ('!B}n', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-customers.php', 0, '*C3Ed\\g^', '*C3Ed\\g^', 'kY߷BhmOtϩ\0c%', '', 0, '?'),
 ('&o;-L<t:\r', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-downloads.php', 0, 'R.;4\nL', 'R.;4\nL', 'a䁕Qs}>u[PE[:hڕ', '', 0, '?'),
 ('~2)8', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-low-in-stock.php', 0, 'Xey.-hj', 'Xey.-hj', 'ɞ!-7Mw>p4zћ\0q@Ym', '', 0, '?'),
 ('צ`7-G', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-most-stocked.php', 0, ']4>wX', ']4>wX', 'Nx=d!\ZH[Ztm\'pga', '', 0, '?'),
 ('i_tTg}.', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-out-of-stock.php', 0, 'j0	\"5*(krU', 'j0	\"5*(krU', '\\hotna|5k3bZUo', '', 0, '?'),
 ('Ԫv%E9](', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-sales-by-category.php', 0, '82UR\0|{s', '82UR\0|{s', 'NEmbصS	v	gnV{YHcdR\rj', '', 0, '?'),
 ('m-K]]z', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-sales-by-date.php', 0, ';Aq', ';Aq', 'jMzLD21{TJGKX9+', '', 0, '?'),
 ('V ՚:(ygo', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-sales-by-product.php', 0, 'zΆq-\\', 'zΆq-\\', 'j^EsYbLX\rG96<8Gjz', '', 0, '?'),
 ('^ci \0`X', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-stock.php', 0, '4#*[4', '4#*[4', '᫽|	/>ƛJ>JXBD\0ݼx', '', 0, '?'),
 ('E-x8gf_-', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-taxes-by-code.php', 0, '<+TPo}', '<+TPo}', 'B7\"ŀȞ\"-=rD{hCiO', '', 0, '?'),
 ('^zz!}]*', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-taxes-by-date.php', 0, '))ל d', '))ל d', 'I\nXm1QkxǫV', '', 0, '?'),
 ('Eި', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-accounts.php', 0, '?p7eetCmn', '?p7eetCmn', '#z\"ܘ6c\rWV-5kUЃ+)^', '', 0, '?'),
 ('6~Y=b6', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-advanced.php', 0, '$7I2C/\ZQب', '$7I2C/\ZQب', '-+Ζ$f;Y\ZuX{t>', '', 0, '?'),
 ('s)-+\\XR', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-checkout.php', 0, 'ei\",E@JΞ', 'ei\",E@JΞ', 'HYH)\09C;ʹT*', '', 0, '?'),
 ('c&c<L]-', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-emails.php', 0, '3I\0;\nE', '3I\0;\nE', 'l(aS%ʦwh98=`F\0\"CLX|J', '', 0, '?'),
 ('#&>nD&̚ n', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-general.php', 0, 'L_?5pK', 'L_?5pK', '[t%PFF#E ۫(D:', '', 0, '?'),
 ('0\\Nl`sZ2', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-integrations.php', 0, 'm	oDc(_', 'm	oDc(_', '<\nrvS>RΕ\\9^ui?ve%A', '', 0, '?'),
 ('|P[h-#c', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-page.php', 0, 'Ri`dƻ', 'Ri`dƻ', 'Ig\Z:p~X2Iv!DJ2X.)', '', 0, '?'),
 ('\rڑ(', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-payment-gateways.php', 0, 'BɨIWgLNp', 'BɨIWgLNp', 'ג ᎜}\nw/^	D', '', 0, '?'),
 ('BWGR\ZL', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-products.php', 0, 'ud׬qjz \r_', 'ud׬qjz \r_', 'Rz\r\0!\"5a-\0͈.l', '', 0, '?'),
 ('IGOVn', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-shipping.php', 0, 'E[|<?eu16$', 'E[|<?eu16$', '\rw+(3=5o!h\ZzJZ~%\neO', '', 0, '?'),
 ('@fڑ$B!', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-tax.php', 0, '?I*PH\\*', '?I*PH\\*', '3ތ廹&jfdIgSQc', '', 0, '?'),
 ('\Z=V', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/class-wc-settings-rest-api.php', 0, 'Ke >RE,', 'Ke >RE,', '?X0\rI䒤V<dV俸\n;T+/', '', 0, '?'),
 ('#Тh+$pC4', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-classes.php', 0, '4<Jd:/F', '4<Jd:/F', 'L!LizP6vbW\0޸t5', '', 0, '?'),
 ('Asl0', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-zone-methods.php', 0, 'v[ɂwC8=9s)', 'v[ɂwC8=9s)', '`X{5V6\"kU6C', '', 0, '?'),
 ('y#Z<B', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-zones-instance.php', 0, '-ca\'-LY', '-ca\'-LY', 'Δ)K)>Ez.+`XM;=', '', 0, '?'),
 ('\0(]6', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-zones.php', 0, 'GbRAaRR\\', 'GbRAaRR\\', '$|-g(\"\Z$Op LlO#', '', 0, '?'),
 ('%\'Vi\\nd', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-keys-edit.php', 0, 'ћG|jΉҬ', 'ћG|jΉҬ', ' xB>o5bh:fx~Z`ES', '', 0, '?'),
 ('q~', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-settings-tax.php', 0, '$Jy_0o8>', '$Jy_0o8>', 'DEZb`N5lQB*,`0', '', 0, '?'),
 ('@^	', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-webhooks-edit.php', 0, 'ũ\\Y\n#Y@', 'ũ\\Y\n#Y@', '/zz)],?.kLaU=x㐀7d', '', 0, '?'),
 ('&IJ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/settings-tax.php', 0, '}Ԛ?0j!U{', '}Ԛ?0j!U{', '?lDmt,߃6:a b~', '', 0, '?'),
 ('}.^VP\"W', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-addons.php', 0, 'BΩ9', 'BΩ9', 'Z&6\"`l^Eh}x;]Ԥ}KM', '', 0, '?'),
 ('i4e	>', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-product-export.php', 0, 'Aލ2zNq', 'Aލ2zNq', 'r~ղ\Z@\n{b\n	h;X', '', 0, '?'),
 ('՗ϢM7<', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-reports.php', 0, 'K|)ͥ`', 'K|)ͥ`', 'ۮTӚ\0.KnԲf(,w9*6', '', 0, '?'),
 ('pW{YEbn\r', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-logs-db.php', 0, '	<nD1U;hT', '	<nD1U;hT', '|iM5wqg(;>s|:MU', '', 0, '?'),
 ('vVW4\n ɖ?', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-logs.php', 0, '8>ŉŢ2_:\0g', '8>ŉŢ2_:\0g', 'Iv%D4Q/0hz`&\n#n{', '', 0, '?'),
 ('bRݓ:a', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-report.php', 0, '݁Dť3z^m', '݁Dť3z^m', '%qv2|$|ʦUN(\r\Z:p\0', '', 0, '?'),
 ('ƶQC[fFQ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-tools.php', 0, '{	h-ىbN\0w', '{	h-ىbN\0w', '\\Ю=*|kA//VU\Z', '', 0, '?'),
 ('5F	', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status.php', 0, 'p=o zd#5', 'p=o zd#5', '_ITFXI[@In7a', '', 0, '?'),
 ('6@Lp{', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-settings.php', 0, 'OLV+4', 'OLV+4', '<2E0|EW\n%fNf޻u', '', 0, '?'),
 ('\\io2}U:', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-bulk-edit-product.php', 0, 'ÓU8ڥ\'', 'ÓU8ڥ\'', '%pW1Ӆ}}rK\0&', '', 0, '?'),
 ('R#u5-', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-email-template-preview.php', 0, '̷߻QU3', '̷߻QU3', 'a]ye d\\\"g@1I³Z12A,&', '', 0, '?'),
 ('lG\Zm;', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-custom.php', 0, '%d\n6q>r', '%d\n6q>r', ':D⓳]EjYufwU', '', 0, '?'),
 ('!92/\n\\5b', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-install.php', 0, 'ːT{ݓnaUE', 'ːT{ݓnaUE', ')\"7[+P?BZy', '', 0, '?'),
 ('5HY&vQ:', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-legacy-shipping.php', 0, ' #o&A3', ' #o&A3', ',` 2&K`ru8_-', '', 0, '?'),
 ('[)Q^', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-maxmind-license-key.php', 0, '\\T2hDnMkJ', '\\T2hDnMkJ', '\nU\Z]\\\nOaӘ<^\0', '', 0, '?'),
 ('@5\Zd/-	@U] ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-no-shipping-methods.php', 0, '0sಞ\"b{', '0sಞ\"b{', 'L󝰌9(ݻzUa13=', '', 0, '?'),
 ('T1', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-redirect-only-download.php', 0, '3RtDhc\0', '3RtDhc\0', '=)_#*rSLaJ=', '', 0, '?'),
 ('4X@boL|z', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-regenerating-lookup-table.php', 0, '?۬,aUp\Z', '?۬,aUp\Z', '\"xt.=:Nω', '', 0, '?'),
 ('$r[6 Uh0', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-regenerating-thumbnails.php', 0, '>V@);Z', '>V@);Z', '-5[sJfٲge姊\ryuWHag=', '', 0, '?'),
 ('n9Ц9v', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-secure-connection.php', 0, 'jCA[Ak;', 'jCA[Ak;', 'ԩVBO{ֿ~', '', 0, '?'),
 ('8!:kV/JVJ-', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-template-check.php', 0, 'Ju[:Fp*', 'Ju[:Fp*', 'eIѢ[nAu2l:3Tm˳', '', 0, '?'),
 ('A)Hn\"Ƣ', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-update.php', 0, 'w#ipX,', 'w#ipX,', 'Z\r?pSd\"M_ގɪ5', '', 0, '?'),
 ('9`Je1,@E\Z', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-updated.php', 0, '8.\'ZXMK͋1', '8.\'ZXMK͋1', '3\\>u\Z2;P4kw]_', '', 0, '?'),
 ('i@.Bqnە_', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-updating.php', 0, '-#?4$࣮', '-#?4$࣮', 'nNԷTW=xk(W*LX|>9\\\n', '', 0, '?'),
 ('|Z6c`-', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-wp-php-minimum-requirements.php', 0, '@N\0|,\0', '@N\0|,\0', '0*U\"#<h\0.Y1a', '', 0, '?'),
 ('ZTL1j\n<', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-quick-edit-product.php', 0, 'dS[BQ:gP)', 'dS[BQ:gP)', '\\BkXP*`x4Q;\"%W', '', 0, '?'),
 ('kBmn+(7', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-report-by-date.php', 0, ']M\r6~ET', ']M\r6~ET', 'tѧ6=q谶o>`U㦸Z', '', 0, '?'),
 ('(w4', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/wc-admin-functions.php', 0, 'oPfAX', 'oPfAX', 'b?1q~u/ME	Ӛxb.', '', 0, '?'),
 ('K>ÀĬ؃s', 'wp-content/updraft/plugins-old/woocommerce/includes/admin/wc-meta-box-functions.php', 0, 'N-x^Ƣ$J', 'N-x^Ƣ$J', 'L/O#dFSb[T| b31', '', 0, '?'),
 ('.\'B}5rj', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-ajax.php', 0, 'd6WЊBz&E\r	', 'd6WЊBz&E\r	', '(Ӛ мO={]׺gz-\0', '', 0, '?'),
 ('%pj6b', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-api.php', 0, 'Hn8\n~A\"C7', 'Hn8\n~A\"C7', '15\"PVY=#-|WѶ	', '', 0, '?'),
 ('PahF', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-auth.php', 0, 'Ic=7%[', 'Ic=7%[', 'T-\'22_qY1', '', 0, '?'),
 ('EFÉǮ\Zk', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-autoloader.php', 0, '/tx', '/tx', 'ڪG+xh:ܔ)R\0PVTK', '', 0, '?'),
 ('<srzYV:\"', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-background-emailer.php', 0, 'xF~	f)&', 'xF~	f)&', 'ͿlR[Ǆ6\rAHzg^', '', 0, '?'),
 ('mA-fEfZ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-background-updater.php', 0, 'b^T	3gW', 'b^T	3gW', '(GG#T~VǤ\\N', '', 0, '?'),
 ('̓+@1B2', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-breadcrumb.php', 0, 'S!<dQ', 'S!<dQ', 'ݍ*Qax	3ii6\0l', '', 0, '?'),
 ('L̘Wi6', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cache-helper.php', 0, 'QgLP^\"w', 'QgLP^\"w', ';\r\r{mǾF\r6uZc7 ߨǿ', '', 0, '?'),
 ('Y[\nތh', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart-fees.php', 0, '\"+]@HUJ', '\"+]@HUJ', ';Rgx\0wi0t<Xק', '', 0, '?'),
 ('Jz#~R1; x', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart-session.php', 0, '3A>fU&', '3A>fU&', 'eD!2*6M3+SUD:', '', 0, '?'),
 ('dQN)_J!', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart-totals.php', 0, 'c*gyrF', 'c*gyrF', 'ooJP\0(QIT.ȑZ(׾', '', 0, '?'),
 ('C<Eq*M', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart.php', 0, '&2I(cY1j5e', '&2I(cY1j5e', '2wJ+ O\\c:Ly2J#\"ĝD', '', 0, '?'),
 ('wx\'!Bs$찾V', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-checkout.php', 0, '\',\r5<PN\r', '\',\r5<PN\r', '{M;jZ{\ZDXFoT	;tK', '', 0, '?'),
 ('A (K.\nq', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cli.php', 0, 'lnj ȁ_y]', 'lnj ȁ_y]', '9p[f;Z2ϐ>tBP0T\0', '', 0, '?'),
 ('cQ\0p̑Eu2', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-comments.php', 0, 'DSi(J2\ndl4', 'DSi(J2\ndl4', '\0KN3U.\'`.60', '', 0, '?'),
 ('m\'d\n@UZ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-countries.php', 0, 'bM/oK', 'bM/oK', '\0[@J,Nf5E64', '', 0, '?'),
 ('~fzEx|3', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-coupon.php', 0, '22/Uڼ5~', '22/Uڼ5~', ']B tt)[!Аn^tmx', '', 0, '?'),
 ('TiH1w', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-customer-download-log.php', 0, 'x*ɸr\rǆtz]', 'x*ɸr\rǆtz]', 'dO>Qd!.{>X', '', 0, '?'),
 ('yrc YUA禘z', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-customer-download.php', 0, 'בE6_\'LX8]i', 'בE6_\'LX8]i', 'Tu0)%]g+0_ѾZ', '', 0, '?'),
 ('.\'#Vs7Vyȅ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-customer.php', 0, 'G5M?Dk', 'G5M?Dk', 'WvҴr:L?ǍA', '', 0, '?'),
 ('sE:c5\"]%', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-data-exception.php', 0, 'j\"^6ݚe#s_', 'j\"^6ݚe#s_', 'kO])&9(B>^$\'RaZ$B5', '', 0, '?'),
 ('	\ru.fw(', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-data-store.php', 0, '>KL(zV\'KF=7', '>KL(zV\'KF=7', 'iv~gjD(n@V;&b>', '', 0, '?'),
 ('o\ryY&F', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-datetime.php', 0, 'R7vPF`< ln', 'R7vPF`< ln', '<:OP_`LH;r', '', 0, '?'),
 ('KC\"^`', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-deprecated-action-hooks.php', 0, '#%\"%(7=V@ ', '#%\"%(7=V@ ', '1I(b0^B\r0!ơw;', '', 0, '?'),
 ('r8g4\"ȣ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-deprecated-filter-hooks.php', 0, '@[2hm?d,\"', '@[2hm?d,\"', 'HZ	</)ӳL\n~', '', 0, '?'),
 ('}P>ql', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-discounts.php', 0, 'i&nJ5ǙG', 'i&nJ5ǙG', ',UGHP|%hf\'bIoO', '', 0, '?'),
 ('8F*4l\rIv', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-download-handler.php', 0, 'K\"o%w,R', 'K\"o%w,R', '?7oiՏz?\\/򀇷5{H\rԴ.4am', '', 0, '?'),
 (']n2qj}ca', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-emails.php', 0, ':xJV׍', ':xJV׍', '0k`<Y=~\"fLE0gR0', '', 0, '?'),
 ('NqT/74aI^', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-embed.php', 0, '8L,=9', '8L,=9', 'tcAMLl`i6u.\r\\j', '', 0, '?'),
 ('v13	Px1Z1A', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-form-handler.php', 0, 'oH[֬', 'oH[֬', '!]\\4\nQ_\"	ѝEvn#o29e(', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('B^&(9ԯj ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-frontend-scripts.php', 0, '+\"-!', '+\"-!', '2W{8:)iCJ`n@Ϣ	O', '', 0, '?'),
 ('1YZr ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-geo-ip.php', 0, ']mL2x]', ']mL2x]', 'M,0Yes@t%U=daޑ', '', 0, '?'),
 ('vf\\mFF60', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-geolite-integration.php', 0, 'QsfdL~', 'QsfdL~', '7)/Sh\n?PJO5XM', '', 0, '?'),
 ('^|N\Z]\0$Fdy', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-geolocation.php', 0, '7At@kq', '7At@kq', 'y$8:xKFф9Qʯe2', '', 0, '?'),
 ('+G9?XM', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-https.php', 0, '-fxQ~!KD', '-fxQ~!KD', ';_d	9F-%{Kt', '', 0, '?'),
 ('⛭H', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-install.php', 0, 'b9gee*A', 'b9gee*A', '9\'M	ȂS)lLTK{pd', '', 0, '?'),
 ('&eƤԉ\r;\n8a', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-integrations.php', 0, '_#6DXx', '_#6DXx', '	kؼFRUdVM}O', '', 0, '?'),
 ('xI\rӇ<ޱ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-log-levels.php', 0, 'z8v4o', 'z8v4o', '_%XP*\07Uf0a0/E', '', 0, '?'),
 ('o2=t}', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-logger.php', 0, '\Zs\rZ-Vlj', '\Zs\rZ-Vlj', 'W4\nT=fX+ܼzsS', '', 0, '?'),
 ('-m=[l@', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-meta-data.php', 0, 'YSt\'d\0&', 'YSt\'d\0&', 'm]\0?f8%/}E\ZĢ,M', '', 0, '?'),
 ('99z֜Àw4J', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-factory.php', 0, '	)', '	)', 'o%^[VmgR[D', '', 0, '?'),
 ('ei3g\Zu*', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-coupon.php', 0, 'kQaZ2Cԡ͌5', 'kQaZ2Cԡ͌5', ',d:&~15CAa9\0t', '', 0, '?'),
 ('=nPG`q<g񬫵P', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-fee.php', 0, '\Z	g8y', '\Z	g8y', 'Kؚm?q\",3R㵕5>', '', 0, '?'),
 ('f(/[=A \r', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-meta.php', 0, '&\nN4bCn,?', '&\nN4bCn,?', '}:a\0pRGN^:E~', '', 0, '?'),
 ('{g5`,k', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-product.php', 0, 'GA\n)h8%', 'GA\n)h8%', 'IhӼyDMü6ኛ', '', 0, '?'),
 ('Fv{h', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-shipping.php', 0, 'y2ho', 'y2ho', 'ZTv2}_u7P;Ӂ4ך', '', 0, '?'),
 ('*˜(.܁s', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-tax.php', 0, '~[Hj/', '~[Hj/', 'nB)aLEi0+ߵ', '', 0, '?'),
 ('M\ncZʗ*Z', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item.php', 0, ',fcfLd', ',fcfLd', 'MZ11vT-DuͨL)WUT', '', 0, '?'),
 (')Dk5-,', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-query.php', 0, 'C4', 'C4', 'r	yn&0Cureގm', '', 0, '?'),
 ('yEN0iFV', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-refund.php', 0, '7`g٨ʫ+-+', '7`g٨ʫ+-+', 'EC(Oă[.ϐ(j>=Ia\0.', '', 0, '?'),
 ('H\04FR2F', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order.php', 0, 'w~mS', 'w~mS', 'o\r!O;;tj0tC\n', '', 0, '?'),
 ('><{<', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-payment-gateways.php', 0, '>ޒm[c2}', '>ޒm[c2}', 'B=+gS;B&c	', '', 0, '?'),
 ('Xؖ:xw', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-payment-tokens.php', 0, 'wM\0~@\n', 'wM\0~@\n', 's7\'1P4Mbm]qZ95fy', '', 0, '?'),
 ('{zOV', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-post-data.php', 0, ')\Ze4J,v', ')\Ze4J,v', '*H.~XKZChc8[M	', '', 0, '?'),
 (' ӂU^>', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-post-types.php', 0, 'QuTJ\n:', 'QuTJ\n:', 'hF#ȓ٧y\'`^0.b_=fP>', '', 0, '?'),
 ('-\r24U\0~;M!+', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy-background-process.php', 0, '8╳v{f', '8╳v{f', '▔LvQQ+a~*', '', 0, '?'),
 ('TآMcz\"t', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy-erasers.php', 0, 'i[92zSv\n', 'i[92zSv\n', 'Z!<]Z`L86&[%_3,x灧', '', 0, '?'),
 ('=(#=\Z3', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy-exporters.php', 0, 'I=Vņ:,', 'I=Vņ:,', 'JGEA)mR&|&\0', '', 0, '?'),
 ('*}{[(Y3g%', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy.php', 0, '|\"t7?', '|\"t7?', 'MJZ9Vl(k	X=|X2', '', 0, '?'),
 ('h5ݒf', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-attribute.php', 0, 'C{E0ת1', 'C{E0ת1', 'pPTTPRnZ\'d:6B]Ŝ', '', 0, '?'),
 ('5c\nUё~', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-download.php', 0, 'MD֬!IXrZ(', 'MD֬!IXrZ(', '2̢4Ex<ЌT(N9\'', '', 0, '?'),
 ('HU%fX+', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-external.php', 0, 's(x3+`t@', 's(x3+`t@', '(YoqVlk{tBևv', '', 0, '?'),
 ('t\0>Atg', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-factory.php', 0, 'iʤO6w', 'iʤO6w', 'c!2hz$Q4N`', '', 0, '?'),
 ('ԚNoK[bĽ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-grouped.php', 0, 'K¯\']', 'K¯\']', 'A+N\0=u}5E<b\"sW1BBl', '', 0, '?'),
 ('OC7l', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-query.php', 0, 'ǽwdMiՒMu', 'ǽwdMiՒMu', '詛iL~`	څ\Zy/[	G{', '', 0, '?'),
 ('^\ZQ-9', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-simple.php', 0, '#	N-Yj\n', '#	N-Yj\n', 'w$W;砰7Y}\0<icR', '', 0, '?'),
 ('0\\nE:=', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-variable.php', 0, 'iy/i|^', 'iy/i|^', 'yĂ)_t2H]˚', '', 0, '?'),
 ('(\Z\'\Z]:', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-variation.php', 0, 'Ŷ>ogPa>', 'Ŷ>ogPa>', 'RF\"iʋ{h0eܷ!', '', 0, '?'),
 ('k.E.Obk?', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-query.php', 0, 'B+\rL*g', 'B+\rL*g', 'mo-}%|', '', 0, '?'),
 ('nȶY_SS', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-rate-limiter.php', 0, 'ӍT\Z{*؏i', 'ӍT\Z{*؏i', 'eQ`EO־1(E\r~֋ ', '', 0, '?'),
 ('w3֢TY={iՇC', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-regenerate-images-request.php', 0, 'wLaCx~r', 'wLaCx~r', 'K:^%xN\"0B7?V:QE', '', 0, '?'),
 ('\0KB!U5\nקߥa', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-regenerate-images.php', 0, '#U,jBp^', '#U,jBp^', 'y;r,%)Äp¯Ets', '', 0, '?'),
 ('ok57#=X$', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-register-wp-admin-settings.php', 0, '\rQ1C\Zش8', '\rQ1C\Zش8', '(U\"TݴϐU#>2Le', '', 0, '?'),
 ('6=O|*,G', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-rest-authentication.php', 0, '|	tqCNw/z', '|	tqCNw/z', '0[3ςSIj.osca$?=C', '', 0, '?'),
 ('-\Zie#{', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-rest-exception.php', 0, '$(eZ\\o)tV', '$(eZ\\o)tV', 'm>oD.<2G0[dKvSE[	/', '', 0, '?'),
 ('`T1bcؒx#', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-session-handler.php', 0, 'FX{0qpC~i', 'FX{0qpC~i', 'UQ!L@\\W]Ru sW', '', 0, '?'),
 ('\Z\Zq%WL', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping-rate.php', 0, 'EJHF_', 'EJHF_', 'r{4`ҳj.o%|', '', 0, '?'),
 ('dk>,\"iԠ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping-zone.php', 0, '\0\\WqJs,|', '\0\\WqJs,|', 'O+A|\0#Eέh<NJ	', '', 0, '?'),
 ('AZt<eTdpq', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping-zones.php', 0, 'C3wN5r9', 'C3wN5r9', '#=.״*LoF\rv6c3', '', 0, '?'),
 ('ELx?W', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping.php', 0, 'R;-pkO{', 'R;-pkO{', 'ޚ];H\Z*vG^*F<\0', '', 0, '?'),
 ('@Aءճq!p', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shortcodes.php', 0, 'h wޤ]Z$c', 'h wޤ]Z$c', '\0NT/@gv̰Q=V;yH', '', 0, '?'),
 ('>/bu֠M\\', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-structured-data.php', 0, '|7%ǂ{w+9', '|7%ǂ{w+9', '\ZH{P#ޥIlc\nwfQ`/8`up', '', 0, '?'),
 ('^ŦkA7\0', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-tax.php', 0, '{Ez@USlH\'', '{Ez@USlH\'', '<[nȾE\ZR =,s4Ět', '', 0, '?'),
 ('d3\\KD	', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-template-loader.php', 0, 'j<o`@a\'^V;', 'j<o`@a\'^V;', '*pRzV|>[XG: f8', '', 0, '?'),
 ('jwYݥqQ', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-tracker.php', 0, '5j0>5&l/', '5j0>5&l/', ';UDdiaFe5yU&	1\n9', '', 0, '?'),
 ('O4H=/s[$', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-validation.php', 0, '>t	]!n0', '>t	]!n0', 'ugW@?HINFBP4', '', 0, '?'),
 ('3JO	xAJos', 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-webhook.php', 0, 'ɅNttg/', 'ɅNttg/', 'G5q*fdm=`/)', '', 0, '?'),
 ('SjsB', 'wp-content/updraft/plugins-old/woocommerce/includes/class-woocommerce.php', 0, 'uqn)ٺ@!', 'uqn)ٺ@!', 'yy\'݂xq$Y05+]Q6!f', '', 0, '?'),
 ('ʰ!\0jPi?%TW', 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-rest-command.php', 0, 'm;3W.<', 'm;3W.<', '#hӛOr[\0g-mtm,pF};', '', 0, '?'),
 ('	3\\Am&8 ', 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-runner.php', 0, 'P$ny	%>ڢ6', 'P$ny	%>ڢ6', '\'v{T[`T\"_vAb].fhO[L', '', 0, '?'),
 ('\Ze1G)^P|', 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-tool-command.php', 0, '@ԏDW', '@ԏDW', '\\z	I;c!2ο)#$d|P', '', 0, '?'),
 ('oԞ6PQbC', 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-update-command.php', 0, 'W4(A$Ocs', 'W4(A$Ocs', '	Vx!B،@rU,n\nY&', '', 0, '?'),
 ('UwQ#T\r!o', 'wp-content/updraft/plugins-old/woocommerce/includes/customizer/class-wc-customizer-control-cropping.php', 0, 'Fķ^<%z1', 'Fķ^<%z1', '?{{Sqc4-7^_{	F', '', 0, '?'),
 ('~)oW{', 'wp-content/updraft/plugins-old/woocommerce/includes/customizer/class-wc-shop-customizer.php', 0, '[gh\n Z', '[gh\n Z', 'YG଀!Oy\0B UtU', '', 0, '?'),
 ('v\00u\'\')G4i', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/abstract-wc-order-data-store-cpt.php', 0, 'H=BytCM', 'H=BytCM', ']D\ZC8^1)֩\"Sh1 َ', '', 0, '?'),
 ('`9AƉMu', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/abstract-wc-order-item-type-data-store.php', 0, 'X6S.', 'X6S.', 'R	Du_&,rQn', '', 0, '?'),
 ('!9}RK', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-coupon-data-store-cpt.php', 0, 'ORs&44', 'ORs&44', '%7Q\ru57օP|7<>l ', '', 0, '?'),
 ('$-YHS0b', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-data-store-session.php', 0, 'vVSɖSU', 'vVSɖSU', 'e5Yt_\r=L8#YxX(', '', 0, '?'),
 ('ebf90', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-data-store.php', 0, 'I&L(wo]b', 'I&L(wo]b', '\n%BI\0gGpDٽuvBm', '', 0, '?'),
 ('r\\@%3)/', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-download-data-store.php', 0, 'öbWtKLT@\rl', 'öbWtKLT@\rl', 'j$wlO7{eܢ*Fz>', '', 0, '?'),
 ('*\0]X~\n', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-download-log-data-store.php', 0, '>A坽N', '>A坽N', 'Y__GFF^c|vփx	-', '', 0, '?'),
 ('\0\\s+-CP[', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-data-store-wp.php', 0, '\ZD;8:|I', '\ZD;8:|I', 'ÉĽߖD=wm>K˓f', '', 0, '?'),
 (';2AL6Z|', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-data-store-cpt.php', 0, '(>B2)0', '(>B2)0', 'r;8Pc$QYEb0GDMr+', '', 0, '?'),
 ('|bL', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-coupon-data-store.php', 0, 'S|r;Ef', 'S|r;Ef', '+\0Nup`+y͠x*:>', '', 0, '?'),
 ('nQʆ1sp', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-data-store.php', 0, 'e̱wS', 'e̱wS', '径i70w;ySr֒27U{', '', 0, '?'),
 ('롅$|qHY', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-fee-data-store.php', 0, 's\n=65 4yN', 's\n=65 4yN', 'htǙu^rG5])\'ꉛI', '', 0, '?'),
 ('bRvgTnE	(O', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-product-data-store.php', 0, 'AaE҆y7@', 'AaE҆y7@', ')e I4q3Е5\\\ZԮ11Ol', '', 0, '?'),
 ('${q:\'VП\\Q', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-shipping-data-store.php', 0, 'XF։cN', 'XF։cN', '/`aKgâ\\|ZQL', '', 0, '?'),
 ('m2_,\rQݰ', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-tax-data-store.php', 0, 'ȨH=2\Z', 'ȨH=2\Z', 'כk+J\\h9CNmz\Z|Ĩ', '', 0, '?'),
 ('\'y#1ԼjXTn', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-refund-data-store-cpt.php', 0, '^d5`p', '^d5`p', 'kF=dN*Mz(L', '', 0, '?'),
 ('o|AD(1\r', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-payment-token-data-store.php', 0, '52m΢W!', '52m΢W!', 'HMU=ܫLF:ȳ\\	)O', '', 0, '?'),
 ('V/rc!ǔgP#', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-data-store-cpt.php', 0, '6[GĦ8{EO_', '6[GĦ8{EO_', 'WHxN@08\rw', '', 0, '?'),
 ('K@;B', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-grouped-data-store-cpt.php', 0, 'ɀ3hb', 'ɀ3hb', 'Jn5:4z)ʮO(	', '', 0, '?'),
 ('ȩ^j', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-variable-data-store-cpt.php', 0, '6;V<ɨޒ!.', '6;V<ɨޒ!.', '\n /Ԥ*}\'Cq3GɃ', '', 0, '?'),
 ('c_tAn0\'u', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-variation-data-store-cpt.php', 0, 'p[h_]v%Ⱥ', 'p[h_]v%Ⱥ', 'L/R}fGޗ\'7y', '', 0, '?'),
 ('y9$+\'', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-shipping-zone-data-store.php', 0, 'P\rxnu\n?', 'P\rxnu\n?', '|իx2#ï{%}R5k', '', 0, '?'),
 ('\'}\"|-c', 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-webhook-data-store.php', 0, '}GmddDjV\\', '}GmddDjV\\', 'Л@# tpD%U%', '', 0, '?'),
 ('af}t', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-cancelled-order.php', 0, 'N_69-uL*e', 'N_69-uL*e', '\Zf#>)lӐ_j1', '', 0, '?'),
 ('y\ZaB1Ȼ6$', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-completed-order.php', 0, '^yEӲl5', '^yEӲl5', '|Yx0ku2)hE:卤V', '', 0, '?'),
 ('נҋ/1', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-invoice.php', 0, 'R/\"S&7σF-A$', 'R/\"S&7σF-A$', '\nٓY@ႏ>$$gLuHȫ', '', 0, '?'),
 ('2p~Ms{', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-new-account.php', 0, 'Qa3vKd	', 'Qa3vKd	', ';\"]|n.Hќ4e=H', '', 0, '?'),
 ('ԅpLS(', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-note.php', 0, '(͑g6	', '(͑g6	', 'KI,T@|Al\rX4f', '', 0, '?'),
 ('.74<cz<`H)h', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-on-hold-order.php', 0, '%bnIa\')~>', '%bnIa\')~>', 'dHQW.wƸ:#g$', '', 0, '?'),
 ('hPo(ab\\', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-processing-order.php', 0, '\"VQ*K&APj', '\"VQ*K&APj', 'y(cwwic:}43gx$b3aNZ', '', 0, '?'),
 ('|^ PVE', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-refunded-order.php', 0, 'ɊQ\\	ms.Z', 'ɊQ\\	ms.Z', 'D\r}u|\r	<aG1`GJ*F', '', 0, '?'),
 ('&,:zjPNy\\', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-reset-password.php', 0, '\0CkK> ', '\0CkK> ', 'F\"Y@isG@ 2\05ߵ(', '', 0, '?'),
 ('\'(w~\ZAl=l', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-failed-order.php', 0, 'OTL<uJy)^', 'OTL<uJy)^', 'U ڷ!K:\Z\\SOj[', '', 0, '?'),
 ('l>&E%', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-new-order.php', 0, 'w듰lvCܟ', 'w듰lvCܟ', ')aWau\0w~C[	ofײ8y', '', 0, '?'),
 (')F*K`)', 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email.php', 0, '%(bA', '%(bA', '2vw++O[BB+g\'', '', 0, '?'),
 ('QvfF{xZ1:', 'wp-content/updraft/plugins-old/woocommerce/includes/export/abstract-wc-csv-batch-exporter.php', 0, 'Qoi5g', 'Qoi5g', 'NOܕpR^xP', '', 0, '?'),
 ('ˬ&\nS\\ч', 'wp-content/updraft/plugins-old/woocommerce/includes/export/abstract-wc-csv-exporter.php', 0, '7:G#̍@T', '7:G#̍@T', ';~rK*c[9Ђh)k', '', 0, '?'),
 ('jVIW|\0Q', 'wp-content/updraft/plugins-old/woocommerce/includes/export/class-wc-product-csv-exporter.php', 0, 'g?\0櫙z*', 'g?\0櫙z*', 'Q3X,,z	`Kxyz', '', 0, '?'),
 ('h\\`\\#\nd', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/bacs/class-wc-gateway-bacs.php', 0, ':o^\\CE<t8', ':o^\\CE<t8', 'u`V#IMOETyc@<Za', '', 0, '?'),
 ('[*/GzvE', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/cheque/class-wc-gateway-cheque.php', 0, 'i3JC] Ba', 'i3JC] Ba', 'LVkkuP1Gm/,#\Z2+E-', '', 0, '?'),
 ('Q׋vKof4', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/class-wc-payment-gateway-cc.php', 0, 'ܖcV?J-HȂ', 'ܖcV?J-HȂ', 'dĚƼ7H9^\rʐ\Z~\"', '', 0, '?'),
 ('5A,iFh', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/class-wc-payment-gateway-echeck.php', 0, '\0NiXq!/&7Ju`', '\0NiXq!/&7Ju`', 's۲ˈMJ6s&ܐ/', '', 0, '?'),
 ('a]	u֫', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/cod/class-wc-gateway-cod.php', 0, '\'hhgݬU*\\{.', '\'hhgݬU*\\{.', 'KbދX\"-9$._=d\"Gl', '', 0, '?'),
 ('vcT8QJ?;', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/assets/js/paypal-admin.js', 0, '\n9%\"ނkՉ', '\n9%\"ނkՉ', 'P<rf#icѤ],Y', '', 0, '?'),
 ('PgԱ$R	2', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/assets/js/paypal-admin.min.js', 0, 'L~͘-c', 'L~͘-c', 'xcϴhYEʛ\0	FM<udal', '', 0, '?'),
 ('ZO', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/class-wc-gateway-paypal.php', 0, 'q@Ԑӧx', 'q@Ԑӧx', '-8űzgr	^sx@/', '', 0, '?'),
 ('?|r|^r', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-api-handler.php', 0, '~%2ژ;\rM', '~%2ژ;\rM', 'W{78V$˥gY', '', 0, '?'),
 ('h2$lw nOl', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-ipn-handler.php', 0, 's<`b~ U', 's<`b~ U', '[1+K`SfT92o)', '', 0, '?'),
 ('Eof_%L1', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-pdt-handler.php', 0, 'YgW\'o', 'YgW\'o', ']svvuS[pURv(H', '', 0, '?'),
 ('SJ-NqΈZ', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-request.php', 0, '0=J9\n(?q', '0=J9\n(?q', 'Ȇ	n%faNrjH^L\r^W', '', 0, '?'),
 ('܎;*su!n4e', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-response.php', 0, '2	RDg', '2	RDg', 'ֺ\"P ?S_E}7,eݭ', '', 0, '?'),
 (' ~N\n{', 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/settings-paypal.php', 0, 'lZp J3.JO', 'lZp J3.JO', '!RAPvXRݙrGԯ@R@', '', 0, '?'),
 ('l ~+X', 'wp-content/updraft/plugins-old/woocommerce/includes/import/abstract-wc-product-importer.php', 0, '1ηAJ', '1ηAJ', ';Iz\0\0UP=YUyQ', '', 0, '?'),
 ('\"X~lأq~p', 'wp-content/updraft/plugins-old/woocommerce/includes/import/class-wc-product-csv-importer.php', 0, '˪}nk_O%g', '˪}nk_O%g', '2zNC5D', '', 0, '?'),
 ('Oҿy\'z', 'wp-content/updraft/plugins-old/woocommerce/includes/integrations/maxmind-geolocation/class-wc-integration-maxmind-database-service.php', 0, 'sq\\\"53ϻ', 'sq\\\"53ϻ', 'y$aEW6CinL=9', '', 0, '?'),
 ('qҺP>Q+', 'wp-content/updraft/plugins-old/woocommerce/includes/integrations/maxmind-geolocation/class-wc-integration-maxmind-geolocation.php', 0, 'ڥ\r+-_ώ9', 'ڥ\r+-_ώ9', 'Xѥ/&=TזLs3iw=', '', 0, '?'),
 ('*GF?s2_T', 'wp-content/updraft/plugins-old/woocommerce/includes/integrations/maxmind-geolocation/views/html-admin-options.php', 0, 'Hui]!', 'Hui]!', 'XP5AAQvȜ,\'>', '', 0, '?'),
 ('\nh1 ^.=,', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-abstract-order-data-store-interface.php', 0, '*wf31', '*wf31', ',\\z1b?m7:wY', '', 0, '?'),
 ('  1XS<', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-coupon-data-store-interface.php', 0, 'f8<NMw', 'f8<NMw', '8\'H*%0D: dʹcgh', '', 0, '?'),
 ('$:ͅC1^Д>aJ', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-customer-data-store-interface.php', 0, 'CoA3o\nAd', 'CoA3o\nAd', '$c2d*mg%Љ', '', 0, '?'),
 ('٘D', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-customer-download-data-store-interface.php', 0, 'Mgn4\n\0i', 'Mgn4\n\0i', ';cNEFu@j]P0', '', 0, '?'),
 ('}qȠ', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-customer-download-log-data-store-interface.php', 0, '^{\'p	cX', '^{\'p	cX', 'm*}@\0H}Y]%ٮb\\a', '', 0, '?'),
 ('~\r+Pw?', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-importer-interface.php', 0, 'G\Z5', 'G\Z5', '@[/uR>..h !zC', '', 0, '?'),
 ('Q!aP', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-log-handler-interface.php', 0, '3Ka1_4*BAU', '3Ka1_4*BAU', 'r)S^v1֌V NZ.', '', 0, '?'),
 ('Ӭ\naA8:', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-logger-interface.php', 0, '<	EU', '<	EU', 'j\\yn~EY6;Q$L0', '', 0, '?'),
 ('R\\yO:\r3aʛ=', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-object-data-store-interface.php', 0, 'qLdC\"', 'qLdC\"', 'hzq*og)Bʗsv', '', 0, '?'),
 ('vp\'`zJA', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-data-store-interface.php', 0, 'L\'T8N,4+I', 'L\'T8N,4+I', 'yc|uXy`iNC#', '', 0, '?'),
 ('sȭd	c?h8', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-item-data-store-interface.php', 0, 'Ǽ4Ek>ȋ', 'Ǽ4Ek>ȋ', '{f蒰Z$PS`5_n47', '', 0, '?'),
 ('­]6Pw', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-item-product-data-store-interface.php', 0, '\n_ǬQ%R', '\n_ǬQ%R', 'vpsr%@24细ڕW_dpϏ', '', 0, '?'),
 ('yTx]^ߡΤ', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-item-type-data-store-interface.php', 0, 'CfVqu;\"6S&', 'CfVqu;\"6S&', '@HP]ICp?', '', 0, '?'),
 ('3MoA;H%Un', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-refund-data-store-interface.php', 0, '>$:Ly{K', '>$:Ly{K', '@-\\%(ƽh$=Nq$&Z*Űm', '', 0, '?'),
 ('eTžy', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-payment-token-data-store-interface.php', 0, '/y= juu', '/y= juu', '/ћ١=o*D`DKj', '', 0, '?'),
 ('ξ.4Km\\\080y', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-product-data-store-interface.php', 0, 'sDfJ&~K', 'sDfJ&~K', 'C0@Ԟ\nbD&m\'BQP', '', 0, '?'),
 ('d5f΂@]@_K', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-product-variable-data-store-interface.php', 0, '.8W3ۉ\'0', '.8W3ۉ\'0', 'd_-N&Daah5\":[*', '', 0, '?'),
 ('SWj\"', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-queue-interface.php', 0, 'Nǿec<K_', 'Nǿec<K_', ':vFXc&Cw1پmi6', '', 0, '?'),
 ('付.>mt', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-shipping-zone-data-store-interface.php', 0, ')5GٵvU', ')5GٵvU', 'L\0$_ׇ=?o7]Q\r', '', 0, '?'),
 ('M\n\0EX޴y', 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-webhooks-data-store-interface.php', 0, '\'SY씱F~tZ', '\'SY씱F~tZ', '*ag\'?=QɑχC', '', 0, '?'),
 ('0ā:m:ӆ', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/abstract-wc-legacy-order.php', 0, 'SaQ@4A', 'SaQ@4A', 'fұ|;=|(c(}>[', '', 0, '?'),
 ('qk?ĕ-FE', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/abstract-wc-legacy-payment-token.php', 0, '$PE\n!\\0', '$PE\n!\\0', '	RcyֆKq8ZeNQ\'Zπ', '', 0, '?'),
 ('\0Wo0[\n', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/abstract-wc-legacy-product.php', 0, '=\ZN/\rH5', '=\ZN/\rH5', 'k&$CM1ߨ\rNq-#4z', '', 0, '?'),
 ('T̟V|=+ȋ', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/class-wc-rest-legacy-coupons-controller.php', 0, 'C3b+o', 'C3b+o', '\\sɹ<+&\\ў5]gG', '', 0, '?'),
 ('ދb_{MWl=<', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/class-wc-rest-legacy-orders-controller.php', 0, 'Ƹ?d5qUM', 'Ƹ?d5qUM', '5iQ@u||89\\lMbո', '', 0, '?'),
 ('S{hDV', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/class-wc-rest-legacy-products-controller.php', 0, '7D\'E܁D', '7D\'E܁D', 'lyֱn]sfMa!G', '', 0, '?'),
 ('m]\\bzq@', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-authentication.php', 0, 'eU+A`fxv', 'eU+A`fxv', '#pTiye:  RrvJ', '', 0, '?'),
 ('1P҄-', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-coupons.php', 0, '0δAXsYLs', '0δAXsYLs', '(Rpҥ)DbY|[[\"Qjnؒ', '', 0, '?'),
 ('UMBqrm\ZRG', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-customers.php', 0, 'OXSѦ|', 'OXSѦ|', '2%-ɓI#9vms:˙Kr', '', 0, '?'),
 ('akϫe[yX', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-json-handler.php', 0, 'ѧNEsX@', 'ѧNEsX@', '^=\\px[ҰemÈbQ', '', 0, '?'),
 ('vxα0FiZw', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-orders.php', 0, '?nލ', '?nލ', '=>bHJ5?/[;ȢI,+a', '', 0, '?'),
 ('SZ<?@=-R', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-products.php', 0, '\Zq>Ｕ', '\Zq>Ｕ', '_HȈɎ)/D0L]', '', 0, '?'),
 ('v-eVe\'F3Rh', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-reports.php', 0, '*.ͪ=RvV', '*.ͪ=RvV', 'p@=]1Jt̳gXGD', '', 0, '?'),
 ('\r9s=', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-resource.php', 0, 'th\'&d\0', 'th\'&d\0', 'C;alrjsĽwg\0hO', '', 0, '?'),
 ('D1ݕ7z~wi', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-server.php', 0, 'Z莄', 'Z莄', 'jߟum|g~3 D.I>!όP', '', 0, '?'),
 (')!W\"', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-xml-handler.php', 0, 'j%B&\'{', 'j%B&\'{', 'l6._<\Zo49x+Hڳ%&8`', '', 0, '?'),
 ('H\\Φ-5tBJ', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/interface-wc-api-handler.php', 0, 'Ͱ/P', 'Ͱ/P', ',\rE;Y\'Fwqv4E;vd', '', 0, '?'),
 ('Z@\"', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-authentication.php', 0, ']2k6`K,V7', ']2k6`K,V7', 'FiqD+Z!!h(7UeSNPZu:_', '', 0, '?'),
 ('{;kSY/d.2?', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-coupons.php', 0, 'č NW', 'č NW', ')¥rK&¿qlJKJYඬ', '', 0, '?'),
 ('Hr̯*K{', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-customers.php', 0, 'A#FbB', 'A#FbB', ';;GlcETWԂ벻', '', 0, '?'),
 ('p-ZYKSn', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-exception.php', 0, 't泞`\r!Mg', 't泞`\r!Mg', '\"Є֒]of얶\rq`f=2-A', '', 0, '?'),
 ('2Ǡb$.p', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-json-handler.php', 0, 'I\"cv#*', 'I\"cv#*', 'b<BX;HJg9A[Eó\Z', '', 0, '?'),
 ('ef?c;Jy', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-orders.php', 0, 'Ivke5}W9', 'Ivke5}W9', '\ZhnS\nyZxZ+/\0U<', '', 0, '?'),
 ('-Q$\'c3E\\`9W', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-products.php', 0, 'ӏ~ݧdk:c', 'ӏ~ݧdk:c', 'lNcq?xİ]q{Aӧ4QIp', '', 0, '?'),
 ('661e[O', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-reports.php', 0, '־v51#9Ά', '־v51#9Ά', '߬\\Sebn֭:|;O6̳ɻ', '', 0, '?'),
 ('<[Q\'Cw6', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-resource.php', 0, 'Ei:', 'Ei:', '1ʚ۸.lz!!~a@;L>mZ', '', 0, '?'),
 (',ů۫Eb@', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-server.php', 0, '^ SaG,\"d', '^ SaG,\"d', 'Ԋj ?TNՈ.{ۨ(uUK', '', 0, '?'),
 ('ָ}A$CAHŊ|', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-webhooks.php', 0, '	:TLaO\r$r', '	:TLaO\r$r', 'UXIҡt&	y0Qh=J\0', '', 0, '?'),
 ('/NЃq', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/interface-wc-api-handler.php', 0, 'nHR섧', 'nHR섧', '_{qf3YIV)Ucj&\"u\"z', '', 0, '?'),
 ('B:ęc$~', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-authentication.php', 0, '9NW*', '9NW*', 'ˢb9s&W[,Ћ_sOF,֌&', '', 0, '?'),
 ('FP$h3u-a', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-coupons.php', 0, 'B5ko5zN', 'B5ko5zN', 'Vxx_JY`[P', '', 0, '?'),
 ('[/z$5', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-customers.php', 0, 'kked', 'kked', '\" \'ҙ^#ԛh52;^h\n^\Z\r', '', 0, '?'),
 ('B\nSCs}c', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-exception.php', 0, 't泞`\r!Mg', 't泞`\r!Mg', '\"Є֒]of얶\rq`f=2-A', '', 0, '?'),
 ('I8ݟB@]?', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-json-handler.php', 0, 'I\"cv#*', 'I\"cv#*', 'b<BX;HJg9A[Eó\Z', '', 0, '?'),
 ('+8[ h', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-orders.php', 0, '	A%<1/', '	A%<1/', '\0)]UvǿEՖ', '', 0, '?'),
 ('?]}xD\'n\nb', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-products.php', 0, '\':yꠜ[BE`?', '\':yꠜ[BE`?', 'Q;sE}؛֭fC Ͽ', '', 0, '?'),
 (']DAy.', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-reports.php', 0, 'Z(6	9i', 'Z(6	9i', 'Nސ\\ATWNT)/X', '', 0, '?'),
 ('l.^P~`f', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-resource.php', 0, '=\\um.T\rX', '=\\um.T\rX', '~bQ\0bN46{!wY,f', '', 0, '?'),
 ('3hĆɐpW', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-server.php', 0, 'vQ\'DC\rE', 'vQ\'DC\rE', ' Fv/nدb\'eMB', '', 0, '?'),
 ('AǷ(rv%f6', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-taxes.php', 0, 'tm.WTq', 'tm.WTq', '))892Qi)@}K锛>inٸ', '', 0, '?'),
 ('BXI/O', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-webhooks.php', 0, '	:TLaO\r$r', '	:TLaO\r$r', 'UXIҡt&	y0Qh=J\0', '', 0, '?'),
 ('qoWGvm', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/interface-wc-api-handler.php', 0, 'nHR섧', 'nHR섧', '_{qf3YIV)Ucj&\"u\"z', '', 0, '?'),
 ('Mce[f-', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-api.php', 0, 'a\"P#J\ZE', 'a\"P#J\ZE', '^V0sRA^K|Zm&%*', '', 0, '?'),
 ('2#)8\n\rl/', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-cart.php', 0, '\\8\Zt!ƹ', '\\8\Zt!ƹ', 'Wlj*{Gƾ{7M', '', 0, '?'),
 ('Yb(^_i', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-coupon.php', 0, 'FuCzJZs^2', 'FuCzJZs^2', 'ݫR~vryUʡ\\J)Xhηi', '', 0, '?'),
 ('Kv/G(Ѡ4YU	', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-customer.php', 0, '=F1rc\n\\7\n', '=F1rc\n\\7\n', '\'٣IPLgm	?63Sl(L', '', 0, '?'),
 ('ue!=7', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-shipping-zone.php', 0, '۠<nx#X', '۠<nx#X', '4KWNd\n&@+ƁRv#', '', 0, '?'),
 ('ǄhAh\Z<Uu', 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-webhook.php', 0, '%wL_7i\\:', '%wL_7i\\:', 'Q1-`;x_=c]Ȑ	>', '', 0, '?'),
 ('L7}Yw', 'wp-content/updraft/plugins-old/woocommerce/includes/libraries/class-wc-eval-math.php', 0, 'y\'NDV$', 'y\'NDV$', 'PXfۤw\'`ow\"ϴ!\0+\rm`', '', 0, '?'),
 ('S~{j\\', 'wp-content/updraft/plugins-old/woocommerce/includes/libraries/wp-async-request.php', 0, 'aJ)HHN\n', 'aJ)HHN\n', 'Ai8ʱCBvb,kn:z', '', 0, '?'),
 ('\\(3', 'wp-content/updraft/plugins-old/woocommerce/includes/libraries/wp-background-process.php', 0, 'DGxW\\J', 'DGxW\\J', 'n\Z߷atdF>֝vW	Dn', '', 0, '?'),
 (';AC%T3|$', 'wp-content/updraft/plugins-old/woocommerce/includes/log-handlers/class-wc-log-handler-db.php', 0, '9wճS', '9wճS', '6WyCp\\#,a]`Z\n)', '', 0, '?'),
 ('9h!)I', 'wp-content/updraft/plugins-old/woocommerce/includes/log-handlers/class-wc-log-handler-email.php', 0, 'VHJgB]ّ', 'VHJgB]ّ', '#˿ŴI˓\0dxQ4˃$/ilR', '', 0, '?'),
 ('z\0ld\')', 'wp-content/updraft/plugins-old/woocommerce/includes/log-handlers/class-wc-log-handler-file.php', 0, 'p\Zk8', 'p\Zk8', 'i蜾x̎5_HCd', '', 0, '?'),
 ('Ach(', 'wp-content/updraft/plugins-old/woocommerce/includes/payment-tokens/class-wc-payment-token-cc.php', 0, '\'l*αG:d', '\'l*αG:d', 'L{Xs!7Uo(\"ǢM	;Aa', '', 0, '?'),
 ('?h09aהL߄S', 'wp-content/updraft/plugins-old/woocommerce/includes/payment-tokens/class-wc-payment-token-echeck.php', 0, 'ë!GI:8', 'ë!GI:8', 'y>sVE(yU5ٛO0\0', '', 0, '?'),
 ('u&zUo^#n', 'wp-content/updraft/plugins-old/woocommerce/includes/queue/class-wc-action-queue.php', 0, '+픚', '+픚', '299q0+ﴅ	T@\r;k.m5\n', '', 0, '?'),
 ('D*߆RЫdy', 'wp-content/updraft/plugins-old/woocommerce/includes/queue/class-wc-queue.php', 0, ';iBsX^+', ';iBsX^+', 'a\"}9EAa\')K~', '', 0, '?'),
 ('@G/', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/flat-rate/class-wc-shipping-flat-rate.php', 0, '{ \'/E\'Ky', '{ \'/E\'Ky', '&^2V	Fr0avyϻ', '', 0, '?'),
 ('d/_HHWm~6', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/flat-rate/includes/settings-flat-rate.php', 0, '|\0-vy\\I8', '|\0-vy\\I8', '=Q5oruF3Df~YCX:', '', 0, '?'),
 ('r%', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/free-shipping/class-wc-shipping-free-shipping.php', 0, 'sU5^Vc)a', 'sU5^Vc)a', 'UEMR\rm̀1Z', '', 0, '?'),
 ('Pt+/S1@:', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-flat-rate/class-wc-shipping-legacy-flat-rate.php', 0, 'Poj((\\', 'Poj((\\', 'DPWINm?NJ4ꅰ\0:', '', 0, '?'),
 ('tTX\0A\0AY', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-flat-rate/includes/settings-flat-rate.php', 0, 'Ag! ]w', 'Ag! ]w', '5/\ZYQM	&pWSغ\r<', '', 0, '?'),
 ('윉Erk_', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-free-shipping/class-wc-shipping-legacy-free-shipping.php', 0, '-Ʋ0?\Z<)', '-Ʋ0?\Z<)', 'b$⟁Nd4Ԭ߲', '', 0, '?'),
 ('Ӏ|:.1k', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-international-delivery/class-wc-shipping-legacy-international-delivery.php', 0, '6U4E', '6U4E', 'Z\\w1,4Uע0NX[', '', 0, '?'),
 ('\\seK', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-local-delivery/class-wc-shipping-legacy-local-delivery.php', 0, '=g6ݹXfӓ', '=g6ݹXfӓ', 'CT%}n1nV/W_7', '', 0, '?'),
 ('qN&9<', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-local-pickup/class-wc-shipping-legacy-local-pickup.php', 0, '{Qb(;', '{Qb(;', 'd0H@N4xL[I', '', 0, '?'),
 ('nj azt]	', 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/local-pickup/class-wc-shipping-local-pickup.php', 0, 'Ҭt[d \'ς', 'Ҭt[d \'ς', 'Rʯ8S2\\8&Ys)\\BhZ', '', 0, '?'),
 ('3 3dc݉', 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-cart.php', 0, 'h|2_6	yj', 'h|2_6	yj', 'ytۊMZAhYZS', '', 0, '?'),
 ('t݀K\rñi', 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-checkout.php', 0, 'lpGx2fRqQ', 'lpGx2fRqQ', '*o_ui{J60MCQ%%U5N-H', '', 0, '?'),
 ('C-hy֪]?', 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-my-account.php', 0, 'Lˑ-Oȹn', 'Lˑ-Oȹn', '84ڡ\'\"ms@\Za+>n\'#', '', 0, '?'),
 ('p6\"/Yv@', 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-order-tracking.php', 0, 'Ll!\'n訢i`F#t[', 'Ll!\'n訢i`F#t[', '\nOشl剌v)^#RK\ne', '', 0, '?'),
 (' O(i', 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-products.php', 0, 'lp]h\'', 'lp]h\'', ',|u@KZ]x*;?P1,y', '', 0, '?'),
 ('iZ?L', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-eleven.php', 0, '۱2V_;m', '۱2V_;m', 'Jb<BZE/fʤ~9!Z>w', '', 0, '?'),
 ('9Ou=\"8C', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-fifteen.php', 0, '7}Hv|H', '7}Hv|H', '^jMfw+RcG18', '', 0, '?'),
 ('n^94?', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-fourteen.php', 0, 'Ui>;bāwv', 'Ui>;bāwv', '\n|/r~UrrQI', '', 0, '?'),
 ('5޺Xjt\r\'֎', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-nineteen.php', 0, '՗vbLV}AY', '՗vbLV}AY', 'YXOɶ%(־9$M>8', '', 0, '?'),
 ('BVf3>', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-seventeen.php', 0, 'zʝ-`q9_u8', 'zʝ-`q9_u8', 'Ȩ{GxQX	8oĽ?', '', 0, '?'),
 ('^\0P]9', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-sixteen.php', 0, ';<z4Z͹\nBǿn', ';<z4Z͹\nBǿn', 'y0tFyzv㺄s', '', 0, '?'),
 ('GdϢ~S0', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-ten.php', 0, '5`g/(g{', '5`g/(g{', 'F!L?*,6<|(WY', '', 0, '?'),
 ('rDP8z&', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-thirteen.php', 0, 'Zo*0;\\g<', 'Zo*0;\\g<', 'J}c״)]H_-`̟Y', '', 0, '?'),
 ('\\-%o\0Q$66', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-twelve.php', 0, 'QM=ʫGm\'', 'QM=ʫGm\'', 'Di_o=4N33DC^\"', '', 0, '?'),
 ('	[m!9+h2K7', 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-twenty.php', 0, '<\083\Z', '<\083\Z', 'C}UzuA\"/ULHB4\Zh|_o', '', 0, '?'),
 ('`:dɘ&', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-site-tracking.php', 0, 'xf9}b', 'xf9}b', '؋DA\"3UUKr(2u3', '', 0, '?'),
 ('p{.c', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks-client.php', 0, '_z	t=\'+', '_z	t=\'+', 'Zڭw[!g҉h}G+ӹ|l:M', '', 0, '?'),
 ('BH5ծH-', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks-event.php', 0, '@vRA¾K', '@vRA¾K', ',kE`hU(8&_j*', '', 0, '?'),
 ('=tbMcDa', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks-footer-pixel.php', 0, 'm ?Gv!%Bz', 'm ?Gv!%Bz', '# wrcz>@UjZ\Z6h', '', 0, '?'),
 ('U/{\'2\0ݏf', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks.php', 0, '܊qT#L\Z', '܊qT#L\Z', '\rkXI}Xٱ%I]F\\f^f$', '', 0, '?'),
 ('o};1.؆J', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-admin-setup-wizard-tracking.php', 0, 'w\nY_*o^', 'w\nY_*o^', '[ :^nQ\r;Xxۃ', '', 0, '?'),
 ('>}xE>f3', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-coupons-tracking.php', 0, 'UwАg,sac', 'UwАg,sac', '>K{O2~m~I_2uHl', '', 0, '?'),
 ('?ж:8ttA', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-extensions-tracking.php', 0, '|H$OVP6#Gc', '|H$OVP6#Gc', 'jN	,\nzSΜ`&$v', '', 0, '?'),
 ('3vRwZ', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-importer-tracking.php', 0, 'D .[=', 'D .[=', 'HX>ds&E>[s	\0~^C[9', '', 0, '?'),
 (']갉aMC?2', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-orders-tracking.php', 0, '\n\0vX', '\n\0vX', 'XUNm\rKN<@', '', 0, '?'),
 ('N\ZNΣ', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-products-tracking.php', 0, 'yCC{F\'Jb%', 'yCC{F\'Jb%', '!f\0/ys9LD4	', '', 0, '?'),
 (']\0%d	:t\0', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-settings-tracking.php', 0, 'CN\"z;EB', 'CN\"z;EB', 'L3OL=zO3_', '', 0, '?'),
 ('&Yrf&2?<', 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-status-tracking.php', 0, 'x4Fn~8\n', 'x4Fn~8\n', '@5j(\rIH\no^r}r+z}]', '', 0, '?'),
 (':ϣ	xIߜq', 'wp-content/updraft/plugins-old/woocommerce/includes/traits/trait-wc-item-totals.php', 0, ')ڰ\"%y@', ')ڰ\"%y@', 'j9+h:QUxFB >5AUgn', '', 0, '?'),
 ('8=u3x', 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-product-cat-dropdown-walker.php', 0, '%.C*]˻ohH', '%.C*]˻ohH', 'lƬ[omzو#AYM{', '', 0, '?'),
 ('Fi!i$,F', 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-product-cat-list-walker.php', 0, 'D?Kϳcf(6VY', 'D?Kϳcf(6VY', 'sųmj~j/ɍ,ik9', '', 0, '?'),
 ('q$w2;s4\0?Ho)f', 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-wc-product-cat-dropdown-walker.php', 0, 'mΒ95L׭', 'mΒ95L׭', 'Д	̤5X^AJI{\'>nYD', '', 0, '?'),
 ('ɤe4-	ep>', 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-wc-product-cat-list-walker.php', 0, 'fyŹw-', 'fyŹw-', '1\"Q@mއpɣ T7', '', 0, '?'),
 ('˒`.d\\^\n', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-account-functions.php', 0, 'It\rp}zj', 'It\rp}zj', 's+k#ARc\n\nr', '', 0, '?'),
 ('݇\\\n', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-attribute-functions.php', 0, 'ÿVgZ{L', 'ÿVgZ{L', 'QLx\'L7Ю`f~]M3\Z;hk', '', 0, '?'),
 ('ax5C@?\Z`h', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-cart-functions.php', 0, 'uTq|Frp', 'uTq|Frp', 't02q4;K;8֋(!kSR', '', 0, '?'),
 ('t?[奍Zᾓ', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-conditional-functions.php', 0, '$F#[OK', '$F#[OK', '.Wq&4%<#w1', '', 0, '?'),
 ('lm|VQv', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-core-functions.php', 0, '#ykuvOɘyD', '#ykuvOɘyD', 'KޏdFiA:i_cou', '', 0, '?'),
 ('3H\"E*z', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-coupon-functions.php', 0, 'uVJ^՝', 'uVJ^՝', 'o8BÌCL*&SY`D6', '', 0, '?'),
 ('G4;SW4', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-deprecated-functions.php', 0, '\0b\\	/eL', '\0b\\	/eL', '䡩 EbLl\\+K};W<', '', 0, '?'),
 ('lGd#4:=idX', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-formatting-functions.php', 0, '=+Uc<Wb', '=+Uc<Wb', 'wnO1r}? \r9.a\\G', '', 0, '?'),
 ('5)NҼx+@p$', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-notice-functions.php', 0, 'TSkb', 'TSkb', 'ўF\n߫gNzR$(?<Uh#fa', '', 0, '?'),
 ('G+GT?', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-order-functions.php', 0, 's$)uc=@Q', 's$)uc=@Q', 'Cft7Y	~<j+;', '', 0, '?'),
 ('!m]4P颇', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-order-item-functions.php', 0, '<tGsxKeB\\~', '<tGsxKeB\\~', '\">f &3jHZR_59alW]ߕfE', '', 0, '?'),
 ('@vbyL=-<', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-page-functions.php', 0, '~&\r?2~', '~&\r?2~', 'ZͮJU6n<^C.', '', 0, '?'),
 (']4)?{dǉ', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-product-functions.php', 0, '>&ZAM[Υ\"', '>&ZAM[Υ\"', '>6*UwU-R<6;JͶ󡓫\n', '', 0, '?'),
 ('\nvc=t\\`', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-rest-functions.php', 0, '\ZϹ1>B', '\ZϹ1>B', 't\'d1cFnCЃ,߁<7m[\Z', '', 0, '?'),
 ('^t<\\x!', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-stock-functions.php', 0, '$MDTKiEM', '$MDTKiEM', 'S)ԵZ*.R2T[cWc', '', 0, '?'),
 ('u<b^VC2w\0', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-template-functions.php', 0, 'X\\Oǃ', 'X\\Oǃ', ',%؋w)M\Zâ^~`m_', '', 0, '?'),
 (')E\Z', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-template-hooks.php', 0, '(Xmʋ*ʜB', '(Xmʋ*ʜB', ' }	VsNNu/=UUZ9	', '', 0, '?'),
 ('Bb:^D', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-term-functions.php', 0, 'U./N', 'U./N', ',0ft9{d	pp[* m6', '', 0, '?'),
 ('\0C@MπsygZ', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-update-functions.php', 0, 'Kx#YH', 'Kx#YH', 'g6Er-U|.*MpS.WD', '', 0, '?'),
 ('׌Aɭl@~', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-user-functions.php', 0, 'DF2|#Ҽgq!', 'DF2|#Ҽgq!', 'k>]v;H(/ed^6{', '', 0, '?'),
 ('>z;%|', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-webhook-functions.php', 0, 'K@(Lu@)', 'K@(Lu@)', '|0`OU&Wkv_', '', 0, '?'),
 ('wr{*', 'wp-content/updraft/plugins-old/woocommerce/includes/wc-widget-functions.php', 0, '~Iۻ&Ry]v', '~Iۻ&Ry]v', 'KiJKZ|1s3;P\\', '', 0, '?'),
 ('$zI', 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/class-wc-wccom-site-installer-requirements-check.php', 0, '/HVc.0%g@', '/HVc.0%g@', 'dGA6(Wm\n&Au~G2@br_', '', 0, '?'),
 ('odT<>mh\"', 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/class-wc-wccom-site-installer.php', 0, 'utK', 'utK', 'x/Ӡp2;]', '', 0, '?'),
 ('^,{B', 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/class-wc-wccom-site.php', 0, 'a*@(^`Uy5Y', 'a*@(^`Uy5Y', 'jT$]	NKm4w\Zر>i', '', 0, '?'),
 ('M#ǵMF;~5', 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/rest-api/class-wc-rest-wccom-site-installer-errors.php', 0, 'U\'G[Z7몐Pg', 'U\'G[Z7몐Pg', '\06F: sXcb_z8^	2	', '', 0, '?'),
 ('\'(7gN,KX,T', 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/rest-api/endpoints/class-wc-rest-wccom-site-installer-controller.php', 0, '=}%	n\n.M', '=}%	n\n.M', 'Yy\nA&%=*P:9N$', '', 0, '?'),
 ('!}F}(', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-cart.php', 0, '-XQHW', '-XQHW', 'W\'Cj~]y\"j\"n,)K4Ã:E', '', 0, '?'),
 ('׹x-NA`u', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-layered-nav-filters.php', 0, 'mIY󬔆_Pp', 'mIY󬔆_Pp', 'w3vޠţDZ\'\"m4ͣ`QfA', '', 0, '?'),
 ('i+T\Zo.a7', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-layered-nav.php', 0, ':/7?IWn_', ':/7?IWn_', 'Y\rLݜ׳9`\nR', '', 0, '?'),
 ('QCZB.w', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-price-filter.php', 0, '^@b\\Hj[b}', '^@b\\Hj[b}', '|dĤf%ecXBzE1Լ;', '', 0, '?'),
 (' `x!ѳ5G', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-product-categories.php', 0, 'Q(<]=G', 'Q(<]=G', '.3θsfUBdY=2hS', '', 0, '?'),
 ('mWI)Elv<', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-product-search.php', 0, '|\0MEͭ>I', '|\0MEͭ>I', 'ʪ!ް=3 0Ȋ	ʦVv8\r_', '', 0, '?'),
 ('U#_\"?', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-product-tag-cloud.php', 0, 'P~IT{NU', 'P~IT{NU', 'Ax>nr0aPpg_\ZrNL', '', 0, '?'),
 ('3gd]ƻ\\	', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-products.php', 0, '~7c̎ʉ>X', '~7c̎ʉ>X', 'ej7\rX𑚦\"٭bYdn0%', '', 0, '?'),
 ('`ef|A߮70', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-rating-filter.php', 0, 'UӇHk;XA', 'UӇHk;XA', ']{*m`nai$vzDH]@$', '', 0, '?'),
 ('Ki\0kir	8', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-recent-reviews.php', 0, '8b{R⺹', '8b{R⺹', '֑ߡIgXMLc\\#J^', '', 0, '?'),
 ('ҦɄvB00\nHz;*', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-recently-viewed.php', 0, '\\\"ٶEڒ W', '\\\"ٶEڒ W', ';Yuf03ωf_8	|)', '', 0, '?'),
 ('C(7GCMN', 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-top-rated-products.php', 0, '~ù~', '~ù~', '%Q	h*^wPF\nnJuy', '', 0, '?'),
 ('R=<(J23', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/action-scheduler.php', 0, '&1m|^', '&1m|^', 'E,A8m8{	@D', '', 0, '?'),
 ('f\"rap?|*', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_ActionClaim.php', 0, 'e<iY^0Y&', 'e<iY^0Y&', '_v&ZYwDڀg]^9۔ufd', '', 0, '?'),
 ('W>ڕtc>\0Nz', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_ActionFactory.php', 0, 'ڳM<`LEkzR', 'ڳM<`LEkzR', 'gw\ZdY6SVBz', '', 0, '?'),
 ('/5![ڥ):', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_AdminView.php', 0, '@v4Ɋlcޮ&f', '@v4Ɋlcޮ&f', 'm(Ό6.隶#B0PV;', '', 0, '?'),
 ('a\'4E?w5#]\"', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_AsyncRequest_QueueRunner.php', 0, 'ѦxQ\'XX 虅~e', 'ѦxQ\'XX 虅~e', 'Y*<{~eօ]|b5*z(5`~', '', 0, '?'),
 ('x/TfIlG', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_Compatibility.php', 0, 'suvv$18', 'suvv$18', 'Tdޡi6`^!̋nJ䵥X%)', '', 0, '?'),
 ('Tqϲ}|~\\Cn', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_DataController.php', 0, 'PvU$g>.', 'PvU$g>.', '4܀2Zh6k./@\n]f=_k\n', '', 0, '?'),
 ('60+K	j', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_DateTime.php', 0, '^F*c', '^F*c', ']\"D.|eA>M|$\nT', '', 0, '?'),
 ('e0Wp>TLz', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_Exception.php', 0, 'k\rǒߤb5.', 'k\rǒߤb5.', '+y60<ʲ4D`(i JU\'{', '', 0, '?'),
 ('Fh\"^q79\rX', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_FatalErrorMonitor.php', 0, '=,##.!o', '=,##.!o', 'A,=%`	y!v5x7', '', 0, '?'),
 ('Њ1e)	㼨', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_InvalidActionException.php', 0, '((>pu!*', '((>pu!*', '/5aXD0;=sM6i\"psuA*#j', '', 0, '?'),
 ('d&W9FypD', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_ListTable.php', 0, ':y5mJٴ}', ':y5mJٴ}', '<Vlnrc\rp+hfS', '', 0, '?'),
 ('<6-&]𰎷WK', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_LogEntry.php', 0, '|@m|X9p9', '|@m|X9p9', '#j/7OY0K+b+', '', 0, '?'),
 ('w6Zc', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_NullLogEntry.php', 0, '4bBVN-`$', '4bBVN-`$', 'c)NkY\r$oB5!&*ցd	4', '', 0, '?'),
 ('+;<DF^fp', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_OptionLock.php', 0, 'i˰guzS\n)\r', 'i˰guzS\n)\r', '&1RpOչKu.iN/50&', '', 0, '?'),
 (' }Ant;6z', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_QueueCleaner.php', 0, '\ZX<$(W\\', '\ZX<$(W\\', '64Ȭnqw,̎tB=X5', '', 0, '?'),
 ('U{&猣F9d', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_QueueRunner.php', 0, '-I~¢?r', '-I~¢?r', '[zVdu.eH-5tI[b', '', 0, '?'),
 (';1`9xa}', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_Versions.php', 0, '[&ĩ%,ڥx', '[&ĩ%,ڥx', '\n\\)gIlӫ_,a*`-r+I', '', 0, '?'),
 ('wGGz&b', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_WPCommentCleaner.php', 0, 'ɖ$ðBc', 'ɖ$ðBc', 'kKEs412G=7', '', 0, '?'),
 ('cd6}/nC|', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_wcSystemStatus.php', 0, 'U0`\Zcl8}', 'U0`\Zcl8}', ':--+MΦD*1sEts~', '', 0, '?'),
 ('\Zw07֚8', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/ActionScheduler_WPCLI_QueueRunner.php', 0, 'ZhҕV( m4{', 'ZhҕV( m4{', '؎t]C^6@$)OH:J', '', 0, '?'),
 ('\0Zeʬ齍#c', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/ActionScheduler_WPCLI_Scheduler_command.php', 0, 'Qd1xkr', 'Qd1xkr', '-Pk[ug\r o6*', '', 0, '?'),
 ('#Cι\\PYGJ1', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/Migration_Command.php', 0, 'k<]^ܴ=3c', 'k<]^ܴ=3c', '*\n`3q^,,G/H', '', 0, '?'),
 ('ӅX/G;?', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/ProgressBar.php', 0, 'OS=&.^Ǳ', 'OS=&.^Ǳ', '4,Sh\'SgնkI\rН', '', 0, '?'),
 ('1\0+\'ݵĆ', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler.php', 0, 'I(\\fBwֿd', 'I(\\fBwֿd', 'vp#xPLWL.X`4,P', '', 0, '?'),
 ('\0T~B{\n+,', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_ListTable.php', 0, 'F|m/7}??', 'F|m/7}??', 'ÞLo\\$vN}R;%cMr,eg', '', 0, '?'),
 ('\Z\rTIAx}', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_QueueRunner.php', 0, 'Cm\n摋#V', 'Cm\n摋#V', 'PsscK#f8q6`;', '', 0, '?'),
 ('7rU.먳1u', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_RecurringSchedule.php', 0, 'NU\ru/m(Rd', 'NU\ru/m(Rd', 'sy|)\'CB؛efO8mIl\nowa|>', '', 0, '?'),
 ('eCxl}?B', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_Schedule.php', 0, '0\Z', '0\Z', 'tEt\0fReETϛ WaDߩ', '', 0, '?'),
 ('U[bCg	q', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_Schema.php', 0, 'KR:^hS(H{\"W', 'KR:^hS(H{\"W', '$;Ut\\\\E:x)EtgH', '', 0, '?'),
 ('Rq(<@\Z.V9', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Lock.php', 0, 'O	ROA7Kg', 'O	ROA7Kg', '\\j*毽aYt[jM7鍣\Z', '', 0, '?'),
 ('\"? \\O	', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Logger.php', 0, 'aOW(v!', 'aOW(v!', 'Q\\Wm%\0ơb~Ϊ8\"TO', '', 0, '?'),
 ('3ǻ*-&:', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Store.php', 0, 'g __g~', 'g __g~', '6FTcIFk],spS6鰭', '', 0, '?'),
 ('EԌe,c啓', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_TimezoneHelper.php', 0, 'VY<S{l1', 'VY<S{l1', 'GLd5uP=Hz}Gݍn#d֎?KЈE', '', 0, '?'),
 ('ǽ4r{d\\', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_Action.php', 0, '\ra-', '\ra-', ' :9$ԧ<e\Z', '', 0, '?'),
 ('TU&E7)ݕFL', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_CanceledAction.php', 0, 'SS !F|rHj.L', 'SS !F|rHj.L', '6h}?!E)rZ\'~PRZ$-,', '', 0, '?'),
 ('\ZY&-THm͹', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_FinishedAction.php', 0, '!dt', '!dt', 'Z:ЫwiGe&g;((f\'Ӈ', '', 0, '?'),
 ('M_ErNչk', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_NullAction.php', 0, 'ȎeWS<', 'ȎeWS<', 'H\Zta!IcU||i\'', '', 0, '?'),
 ('5WG18!', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_DBLogger.php', 0, '/>\r[F', '/>\r[F', 's2+c`_o.b%nʳir', '', 0, '?'),
 ('}t	0L;', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_DBStore.php', 0, 'CfR$Y+_r+ku', 'CfR$Y+_r+ku', 'ѐ\n6u 5Мv\nr?ED,-[aX', '', 0, '?'),
 ('a)N[t', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_HybridStore.php', 0, 'vbq3', 'vbq3', '<|G?j؇0C\Zy.q', '', 0, '?'),
 ('8zb0`ԥJYu', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpCommentLogger.php', 0, '{ X', '{ X', '0Tv]\"T&Qհ5', '', 0, '?'),
 ('j`}Z\"', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore.php', 0, '5Z#xE13V', '5Z#xE13V', 'xgdEtGhd$]&lK', '', 0, '?'),
 ('ak\0ƋsZ@', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore_PostStatusRegistrar.php', 0, 'KF ş57{', 'KF ş57{', '*Vu~DW)rajj8+', '', 0, '?'),
 ('UYI@ G %G1', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore_PostTypeRegistrar.php', 0, '$c\ZVi&[ى7', '$c\ZVi&[ى7', '܃rՄ\Z%V;\"N1͇\'nW', '', 0, '?'),
 ('r>M(\0qJ', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore_TaxonomyRegistrar.php', 0, 'iMPP!&7(', 'iMPP!&7(', '9)ђڰ`;TkoT#֊', '', 0, '?'),
 ('g;D:_NO', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/ActionMigrator.php', 0, '[+XiQj&8p', '[+XiQj&8p', '-쁪V{n1H%F1W', '', 0, '?'),
 ('B㊰̗\r', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/ActionScheduler_DBStoreMigrator.php', 0, 'Ɏ؍\\9{Z', 'Ɏ؍\\9{Z', 'gCA$pade\'\Z$S8p[', '', 0, '?'),
 (':Ip6g@ץ', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/BatchFetcher.php', 0, 'E[~%4', 'E[~%4', 'QFjd6Kl(xNgXlt', '', 0, '?'),
 ('rkzn\\~cYn', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Config.php', 0, '$-0ϟj', '$-0ϟj', '37o\\27	\"d/\rA\\8&A', '', 0, '?'),
 ('%\'Ƣ/>G', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Controller.php', 0, '07NxB]', '07NxB]', '\'˃|!g>/~2|6X==j`r', '', 0, '?'),
 ('Mbvs\Zb΀T-', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/DryRun_ActionMigrator.php', 0, '!Tnu`\'3Sח', '!Tnu`\'3Sח', '~LX@П*7=Itٶ9f*', '', 0, '?'),
 ('k%JJVP	2', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/DryRun_LogMigrator.php', 0, 'DYp\'9', 'DYp\'9', 'ؐN:=5%w*l]vHnl', '', 0, '?'),
 ('eɽކo7h)', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/LogMigrator.php', 0, 'ٻxd䬖i;', 'ٻxd䬖i;', ' 飣C05w\rX`%\"QP', '', 0, '?'),
 ('y[r$\n4Ҝ8o', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Runner.php', 0, 'C|Unmgw\"', 'C|Unmgw\"', 'Djl9%KBɑ$\'H6gM', '', 0, '?'),
 ('3koyb', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Scheduler.php', 0, '\'4\nBqfā?', '\'4\nBqfā?', '\"=\"=\0鮇\0%(', '', 0, '?'),
 ('-yR!v', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_CanceledSchedule.php', 0, 'Ө	zbA̾', 'Ө	zbA̾', 'Eguk\r	m\\Qm6\\;W<7', '', 0, '?'),
 ('%``}VulG', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_CronSchedule.php', 0, 'W\"2(\'HKyv', 'W\"2(\'HKyv', ';[9#j(d*Z7V]J2AY', '', 0, '?'),
 (' }8\rAl<A', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_IntervalSchedule.php', 0, 'dB7;6ZU2', 'dB7;6ZU2', 'ѵ8EN$J0G!I~&;(tk\Z\":Y', '', 0, '?'),
 ('I]\Z*Nuum', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_NullSchedule.php', 0, 'wΪ!m_A', 'wΪ!m_A', 'K26Еʬ\'QpQ^n\r$|', '', 0, '?'),
 ('01O:θކ4', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_Schedule.php', 0, 'vt;ZNmļ', 'vt;ZNmļ', '\"-ܢumsw>vuJԡX[6', '', 0, '?'),
 ('T\\CbN&Ks', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_SimpleSchedule.php', 0, '^y	15d~UhFR', '^y	15d~UhFR', ';]D5Vo`/_qgyy.!', '', 0, '?'),
 ('+b鴛\Z\\1YX', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schema/ActionScheduler_LoggerSchema.php', 0, 'L{4O0Bm&', 'L{4O0Bm&', '#gtS9E5}S΃S', '', 0, '?'),
 ('C!4SW-', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schema/ActionScheduler_StoreSchema.php', 0, 'n5Q> sz\n\'k', 'n5Q> sz\n\'k', 'ՂGP[C.09j,Bਏ', '', 0, '?'),
 ('|H~\'I㣢', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_Abstract_QueueRunner_Deprecated.php', 0, '\"鰂g~.Db#', '\"鰂g~.Db#', ' #\Zm-0@ʖDGь', '', 0, '?'),
 ('z)9dҺ\Z&v', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_AdminView_Deprecated.php', 0, 'v?_Q', 'v?_Q', 'Vܢ18U\r&]_RPf~9Od\0LIwv', '', 0, '?'),
 ('hoSvײBUsi', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_Schedule_Deprecated.php', 0, '	ĕ[lCà]', '	ĕ[lCà]', '_Q>h.XMmP4W=+.', '', 0, '?'),
 ('ItX/wC-Nϙ', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_Store_Deprecated.php', 0, '7::XFƝ0\'P', '7::XFƝ0\'P', '/ nf<%n)9lf׭Ύu', '', 0, '?'),
 (')-<I\0\0?a', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/functions.php', 0, 'B\'){b\\t!\0', 'B\'){b\\t!\0', '˂~+b\\IeQ9il9{69', '', 0, '?'),
 ('`9 qY?X', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/functions.php', 0, '[8:Es', '[8:Es', '3+J)1ɜR\r\'MN\r9', '', 0, '?'),
 ('|}E3lb', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/WP_Async_Request.php', 0, '4`|D$WE', '4`|D$WE', '}v>ydƗUs;h', '', 0, '?'),
 ('cm=C=', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression.php', 0, 'ځ\'h/;\r', 'ځ\'h/;\r', 'YU-yE8dUnH4H37Dn%', '', 0, '?'),
 ('(\'97Dm', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_AbstractField.php', 0, 'WXvvlX8', 'WXvvlX8', 'qdwLԹL90k9dZ+T`', '', 0, '?'),
 (')OT5J0P', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_DayOfMonthField.php', 0, 'iOԂbt4\\', 'iOԂbt4\\', 'ڒ5fCSQ\0Q)=\Zk$\0I', '', 0, '?'),
 ('bCT\']N', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_DayOfWeekField.php', 0, 'tl\0e&.d\nfg', 'tl\0e&.d\nfg', 'ZfeL\r0KLȊ&', '', 0, '?'),
 ('fuj\nƿ)a', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_FieldFactory.php', 0, 'ˮY񪻛y\nn8', 'ˮY񪻛y\nn8', '_(|0CԢdp([x*z&<^', '', 0, '?'),
 ('Q!em\"N6,', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_FieldInterface.php', 0, ';GJY3p', ';GJY3p', '-X.Ik\'qxsy	U1/', '', 0, '?'),
 (')	(te/', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_HoursField.php', 0, '/1\\5U֖?', '/1\\5U֖?', '>bb$x݌	ǒHwK.~7ui', '', 0, '?'),
 (':ܔS2UwIh', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_MinutesField.php', 0, 'bkQ2', 'bkQ2', 'Ԅ4ޚnqӸ$?\rMfP\nTIp', '', 0, '?'),
 ('B#qH6^\n(', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_MonthField.php', 0, 'b$ }[', 'b$ }[', 'S]KsDÀviIt%j=\'', '', 0, '?'),
 ('PÜԾ_OA', 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_YearField.php', 0, '4DfpTx', '4DfpTx', 'N@7)(60&^', '', 0, '?'),
 ('BZ.Bq~>', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/app/index.js', 0, 'C-Ki@#ҷ,Az', 'C-Ki@#ҷ,Az', 'yϿIyƤu[.SO ', '', 0, '?'),
 ('1?agݵp_C', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/components/index.js', 0, 'lO~s6%', 'lO~s6%', '#Ȓ,D$$g;3&7I$a', '', 0, '?'),
 ('QyԘA1q[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/csv-export/index.js', 0, 'fI*	)iN\'yx', 'fI*	)iN\'yx', '2\ni,V5ޘv*k:c4)*E', '', 0, '?'),
 ('t{Yp}f', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/currency/index.js', 0, 'mO]ۖ~&\"', 'mO]ۖ~&\"', 'q9{4ɖJh]F|¤L', '', 0, '?'),
 ('bmڐh', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/date/index.js', 0, '8OmY@H', '8OmY@H', '|>YbcCc ENH93DcP', '', 0, '?'),
 ('cz$e_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/navigation/index.js', 0, '`OEw!w-x', '`OEw!w-x', '##R nف.^Q:톨5@#', '', 0, '?'),
 ('\\ӆ:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/number/index.js', 0, '\ZZl=fp', '\ZZl=fp', 'eAVŞdn&\ZJ8o*|y}', '', 0, '?'),
 ('3-Y\Z̓s', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-homepage-notice.js', 0, 'bG3#1k2e', 'bG3#1k2e', 'SA~\n豏:iP\"8@P|vJt', '', 0, '?'),
 ('\0(H?{zbFdwT9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-product-import-notice.js', 0, '?aiG#O,:#k', '?aiG#O,:#k', '~}-%|Rǔ\'CsKHWm', '', 0, '?'),
 ('KIfM3g', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-product-notice.js', 0, '۸[1ie4', '۸[1ie4', 'rYoYnV}[¿fn', '', 0, '?'),
 ('\nms\r\"Y|', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-tax-notice.js', 0, '@IX9\n׮\\', '@IX9\n׮\\', 'Ъe?T*r@#^gῖ', '', 0, '?'),
 ('ٳ)ZSBGeՖ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/images/empty-content.svg', 0, '\ZrM\0yNv+', '\ZrM\0yNv+', 'YeZ;7?X	qQt$', '', 0, '?'),
 ('YI{8+ƾ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/connect-existing-pages.php', 0, 'MuJԤ<', 'MuJԤ<', '2I\\|8(1p \n\0Bλ\"lD', '', 0, '?'),
 ('g@ Znh6$', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/core-functions.php', 0, '}0pPm,qi&u', '}0pPm,qi&u', 'IAWIm+4m.W\"!X', '', 0, '?'),
 ('v׎Mn1-Hzت', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/emails/html-admin-report-export-download.php', 0, 'k4J\\2XͰ', 'k4J\\2XͰ', 'a\"]q<eE}ds3\\', '', 0, '?'),
 ('K.{#6{U#0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/emails/plain-admin-report-export-download.php', 0, 'Lu6`HnCl h', 'Lu6`HnCl h', 'N||j$**-1/ōu', '', 0, '?'),
 ('T;SxKC0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/feature-config.php', 0, '$6\"l', '$6\"l', 'YG\0\rP̫lqU5\n', '', 0, '?'),
 ('SG<^]\'Æ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/page-controller-functions.php', 0, ';7޶`c@ENpz', ';7޶`c@ENpz', '!G&Э-z>$EsczE', '', 0, '?'),
 ('u:9l$Z\0ZFw', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/wc-admin-update-functions.php', 0, 'a&5/^3U', 'a&5/^3U', '}zEQJvD1]6d<p', '', 0, '?'),
 ('y%1ߴQab', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Coupons.php', 0, 'kOl)i^Pw', 'kOl)i^Pw', '$\'\n2%~\rlRjr} *(9', '', 0, '?'),
 ('zkJ=\"+J9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Customers.php', 0, '71C([̪', '71C([̪', '1rH_&*>^OME^?{~', '', 0, '?'),
 ('7c%uC\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Data.php', 0, '=նڣX1X96g', '=նڣX1X96g', 'CH,}wX9\nx_\0', '', 0, '?'),
 ('Ϗϻ䣙-F^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/DataCountries.php', 0, '+kS1vE0Q', '+kS1vE0Q', 'c\r±CHzdEPa/=;}\r\']', '', 0, '?'),
 ('B!/$CqCg', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/DataDownloadIPs.php', 0, '/eCٷb\0:', '/eCٷb\0:', 'l9~6\"Ν	ur\\', '', 0, '?'),
 ('X|y%!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Init.php', 0, 'A&,cK	c', 'A&,cK	c', 'ōĢjz9yb<c`nF', '', 0, '?'),
 ('3\r	Y#\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Leaderboards.php', 0, 'Y1TD*vP', 'Y1TD*vP', '7A㧢{\\^_kN[L3l', '', 0, '?'),
 ('nro=UI\n;z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/NoteActions.php', 0, 'GxPe!A&CI', 'GxPe!A&CI', '>Bo_\Z(9jFRkfp\ntjp', '', 0, '?'),
 (' RS;ե', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Notes.php', 0, 'Ie@xj', 'Ie@xj', '.LTbwY#bňpZ=7A', '', 0, '?'),
 ('Iv;L MCT\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingPlugins.php', 0, ']wXK[Y.', ']wXK[Y.', '#HQk	٦1u0딞k', '', 0, '?'),
 ('2aCVff|', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingProfile.php', 0, 'C`.:ih\0N', 'C`.:ih\0N', 'jbG\r&/@e[К\Z&L\\', '', 0, '?'),
 ('z\rQ;QC', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingTasks.php', 0, '-SByt;', '-SByt;', '61+HJM0\\r', '', 0, '?'),
 ('Cd\n{rR,', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingThemes.php', 0, ')u6', ')u6', 'di?\0\\!N6g[sxMC', '', 0, '?'),
 (':_KvE/?Q߼;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Options.php', 0, 'a̼zvMR7Z#}', 'a̼zvMR7Z#}', '=3ba̔{arU>\\', '', 0, '?'),
 ('HPd6v', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Orders.php', 0, 'GF%S`y;`j', 'GF%S`y;`j', 'Rݤ&4n7ij|mUQ5', '', 0, '?'),
 ('r/?;rS)#M,', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/ProductCategories.php', 0, '+a뭛D!).', '+a뭛D!).', '!sy>RPbV', '', 0, '?'),
 ('nU:q4?J3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/ProductReviews.php', 0, '⹶!W@\Z', '⹶!W@\Z', 'sxO)W=I*Bubl', '', 0, '?'),
 ('\\P	Ll2!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/ProductVariations.php', 0, 'q/[<ٴ', 'q/[<ٴ', '@7\Z\Zv}$. K;q0,', '', 0, '?'),
 ('9@EMQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Products.php', 0, 'qʗփ', 'qʗփ', 'yNzTu\0:5a-U', '', 0, '?'),
 ('Vmx_d9Уݯ}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Cache.php', 0, 'زs&\Z=', 'زs&\Z=', 'jB$x`ܩE#,%;/', '', 0, '?'),
 ('B(m۔<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Categories/Controller.php', 0, '\'6ځč\0', '\'6ځč\0', '<h\Z*@7]ᕀu\0#Ć3r=', '', 0, '?'),
 ('SN/2:d', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Categories/DataStore.php', 0, 'jtMÙb_8\\', 'jtMÙb_8\\', 'Ɇ@56b\\edx.otBi', '', 0, '?'),
 ('a~ A[(oZ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Categories/Query.php', 0, 'uloREQ`w', 'uloREQ`w', '8Ipd~o!i\Z	Y7zR41', '', 0, '?'),
 ('|#M\0ʳh', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Controller.php', 0, '8D&-#v', '8D&-#v', 'Cn2$6mK\rb`)\0', '', 0, '?'),
 ('.%)G|Vp', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Controller.php', 0, 'θsr\0X', 'θsr\0X', '.9`1@ɂ臉GKax`', '', 0, '?'),
 ('܆sJJd$en', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/DataStore.php', 0, 'т~rztz', 'т~rztz', '0icFַJAS裕`/ j', '', 0, '?'),
 ('QӚL!!wdj', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Query.php', 0, '2o\"%', '2o\"%', 'ғp;k^B̈rG9n8t\0K2', '', 0, '?'),
 ('xmƄï#', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/Controller.php', 0, ' Jbïi\\rN', ' Jbïi\\rN', ',ɄusD!L(#*y+jX', '', 0, '?'),
 ('\'u8.D', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/DataStore.php', 0, 'qD=}\Z%\">', 'qD=}\Z%\">', 'qYܺJV9DorQr%4', '', 0, '?'),
 ('@^p2N', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/Query.php', 0, '	~`}:\rn', '	~`}:\rn', 'PÈvGRD}$K#׏8v\'	0', '', 0, '?'),
 ('e/ieTrjX', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/Segmenter.php', 0, '輭bHa{e', '輭bHa{e', '4Dun!-E\nF3', '', 0, '?'),
 ('h-\"Z T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Controller.php', 0, '+\r_06', '+\r_06', '<3\rn>*oU;~)\'', '', 0, '?'),
 ('ԆXd&', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/DataStore.php', 0, '`|\n#H8=\\1', '`|\n#H8=\\1', 'ɑǺinn-xۛ䠫i', '', 0, '?'),
 (':5%2\Zl1[>', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Query.php', 0, 'uH\\rEu', 'uH\\rEu', 'ucΊƬ\n\"v	z扑\0(', '', 0, '?'),
 ('O{0}?O', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Stats/Controller.php', 0, 'VvfQDqn', 'VvfQDqn', 'P&7\\mGG>Pm', '', 0, '?'),
 ('#ʨ%R!G7l', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Stats/DataStore.php', 0, '\ngr#[:', '\ngr#[:', 'ƣa93:yl\"!lسΟk', '', 0, '?'),
 ('`Z)$rO', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Stats/Query.php', 0, '󶞏7c\"@x', '󶞏7c\"@x', 'ȄLMg1轡7.BP*!e', '', 0, '?'),
 (',Q_\"p :F', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/DataStore.php', 0, 'lȍ,\0@8+', 'lȍ,\0@8+', 'Gvט1pTcqƧ$ڋqF[', '', 0, '?'),
 ('ly3&B)	', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/DataStoreInterface.php', 0, 'Uv#G\ry2ħk', 'Uv#G\ry2ħk', 'x8ÉQv1dƲ-}Z+', '', 0, '?'),
 ('48>+aӬJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Controller.php', 0, 'vs3g/;Z', 'vs3g/;Z', 'UJZeΦB\\@', '', 0, '?'),
 ('gA/_WWbU', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/DataStore.php', 0, '2=Q28YL', '2=Q28YL', 'l6oiN`Ed7KW|\"b', '', 0, '?'),
 ('\nfG\'=0tϘ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Files/Controller.php', 0, 'V>/_K(d', 'V>/_K(d', 'Q\Zd/j<%@>Q,\'<+0Z6', '', 0, '?'),
 ('<V+bTb_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Query.php', 0, 'NH9=a8:', 'NH9=a8:', 'DY e:geOt6oO', '', 0, '?'),
 ('nblA\09', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Stats/Controller.php', 0, '	xμq^F$', '	xμq^F$', '猉~S\0Iɯ+~Jt[u,-', '', 0, '?'),
 ('	GR.~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Stats/DataStore.php', 0, '훠,:))3B', '훠,:))3B', 't`/\n1#r%hg܊||my o', '', 0, '?'),
 ('C\nXWG}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Stats/Query.php', 0, 'cp\"Ɠ', 'cp\"Ɠ', '#4iyt1l|Y1RvqR', '', 0, '?'),
 ('c\'0바', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Export/Controller.php', 0, 'J8~*F', 'J8~*F', '~ڇhoEEom2i@\0', '', 0, '?'),
 ('[*a', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/ExportableInterface.php', 0, '=3VN{+X_X', '=3VN{+X_X', 'ft&̬(@\\lƧ}~|_z>', '', 0, '?'),
 ('uL0Q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/ExportableTraits.php', 0, 'QXePg9ՁGF', 'QXePg9ՁGF', ']Uu[{û$P', '', 0, '?'),
 ('fҮgnɚvI', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Import/Controller.php', 0, 'EK¼tg', 'EK¼tg', 'YG9Ame jFi>cSYm', '', 0, '?'),
 ('u4TY)T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Controller.php', 0, '|6', '|6', 'Rv21iG6 9{B', '', 0, '?'),
 ('s{L<\n`3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/DataStore.php', 0, '13`^jR', '13`^jR', '/Ϯ\Zv0K.1;', '', 0, '?'),
 ('|ʞLO]<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Query.php', 0, 'd+<`unN', 'd+<`unN', '?1Ec6F1y26=(?[`q2', '', 0, '?'),
 ('o&	Z(E!\'b', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/Controller.php', 0, '4:&n	T\nW', '4:&n	T\nW', '*tXQQSИPbM)R&h', '', 0, '?'),
 ('ۭ?= YGS', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/DataStore.php', 0, '%QW],u', '%QW],u', 'B)D=3vŗQXïTV{%n-j', '', 0, '?'),
 ('9\\D', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/Query.php', 0, '$h[toQT3', '$h[toQT3', '1BO`2<}ʿ', '', 0, '?'),
 ('PŊGDlz+}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/Segmenter.php', 0, '|T7 \'A1', '|T7 \'A1', '!iKQ߱+xmCYZ]', '', 0, '?'),
 ('h	uS4S', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/ParameterException.php', 0, '&\"]z(5', '&\"]z(5', 'KoI>96Ui74\n^', '', 0, '?'),
 ('p2J-[c', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/PerformanceIndicators/Controller.php', 0, 'p/kX+L', 'p/kX+L', 'O8(B%5պPs3〢(', '', 0, '?'),
 ('n,H', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Controller.php', 0, '2FjM\Z#əP', '2FjM\Z#əP', '~g5v<OCLVHz `\\>Y', '', 0, '?'),
 ('Ṯ@;Z^Ju{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/DataStore.php', 0, 'J!W\"ROM', 'J!W\"ROM', 'g۠bmb\r ``4\"Xv&u', '', 0, '?'),
 ('Z\nig\"^.', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Query.php', 0, '01b^i,', '01b^i,', 'Ϯ a{\Z?9H;I-NҨL', '', 0, '?'),
 ('s8QA6e_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/Controller.php', 0, 'eNnwn>|', 'eNnwn>|', ':±&\'QX1oxNPvb-', '', 0, '?'),
 (' Y=OJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/DataStore.php', 0, 'Em\rHϴ*', 'Em\rHϴ*', 'Vt.Q,%\n\"KF #O', '', 0, '?'),
 ('#13_K', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/Query.php', 0, 'mN\"\\8w8Τ', 'mN\"\\8w8Τ', 'iRk6mM~y79GݓI4', '', 0, '?'),
 ('7|\n[bx', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/Segmenter.php', 0, '84$a', '84$a', 'O?/<\r1xl', '', 0, '?'),
 ('\0%^q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Query.php', 0, '8&yMMR7cn9', '8&yMMR7cn9', '3KWmT#/&MШv/*nl', '', 0, '?'),
 ('`vO}=@c', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Revenue/Query.php', 0, 'I٘w~^M9hmL\'', 'I٘w~^M9hmL\'', 'u΁-fY*A/PC}z)\Z(', '', 0, '?'),
 ('XJ\n{	', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Revenue/Stats/Controller.php', 0, 'N[a\\\"ε', 'N[a\\\"ε', ' N+mMϝQ ?-\"hf^f!(', '', 0, '?'),
 ('=kܙ4i', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Segmenter.php', 0, 'mqcG8}5X\"', 'mqcG8}5X\"', 'wgʠ|!R*v$~r]6', '', 0, '?'),
 ('@j}7\'Yq', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/SqlQuery.php', 0, '&7ӪHrp', '&7ӪHrp', 'Z%)ioaI8!OOx', '', 0, '?'),
 ('lWh\ns/\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Controller.php', 0, 'pOQ/f`:%H', 'pOQ/f`:%H', 'U_w%5FZ)%9U\"ԯq', '', 0, '?'),
 ('y˭a93+q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Stats/Controller.php', 0, 'CfSOxJF', 'CfSOxJF', 'z\ZXWr<\nE(D,\ZPl;', '', 0, '?'),
 ('	O\\`0j', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Stats/DataStore.php', 0, ',X(wW6M', ',X(wW6M', '<f@,؊@cZ~,黤#ǝ', '', 0, '?'),
 ('ى\n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Stats/Query.php', 0, ']t\0_}', ']t\0_}', 'kr^!.&Re', '', 0, '?'),
 (',8U̱@ϫI', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Controller.php', 0, 'A$Lb\"h', 'A$Lb\"h', 'w1/6)6RA\nx6V\"!.', '', 0, '?'),
 ('8,`/zk3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/DataStore.php', 0, 'm6?%fņU', 'm6?%fņU', 'V?twـUq/t?J', '', 0, '?'),
 ('f/	!~1=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Query.php', 0, 'CIs\'l', 'CIs\'l', '0,qPA0U΃齽m,.~;aMI', '', 0, '?'),
 ('pjnt', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/Controller.php', 0, '͛*ĿW@`$', '͛*ĿW@`$', 'HR$ثؐ}Ic', '', 0, '?'),
 ('aOr#VguŶ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/DataStore.php', 0, 'Evqjdwi_', 'Evqjdwi_', '$ħE/dW{@[Q	uĂ', '', 0, '?'),
 ('DrjƊD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/Query.php', 0, 'Gd\"/:Fۢ', 'Gd\"/:Fۢ', '/r#\"f[9*XM@%;rX<', '', 0, '?'),
 ('Y%hRlU', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/Segmenter.php', 0, 'vX%pއj', 'vX%pއj', 'ִhHtx9W9i\0à', '', 0, '?'),
 ('TJJ/a%w', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/TimeInterval.php', 0, '΂)bq', '΂)bq', '7tME^(Xhܤ\rni', '', 0, '?'),
 ('Okmk8>ŲX ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Variations/Controller.php', 0, 'P)[TN};\rG[', 'P)[TN};\rG[', '*@P;xԟ?0$fV6P', '', 0, '?'),
 ('hd256', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Variations/DataStore.php', 0, 'NEAs0R ', 'NEAs0R ', '\\Vz굳mwfզ', '', 0, '?'),
 ('(?5 iS7kh', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Variations/Query.php', 0, '/y- ', '/y- ', 'zSk:`Q<51:\\Y3?', '', 0, '?'),
 ('+;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/SettingOptions.php', 0, 'XhEÈA', 'XhEÈA', 'X(!gQ5K^', '', 0, '?'),
 ('wM :fP3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Taxes.php', 0, ']:)^8v', ']:)^8v', '`s)!>km\'bũ\rv)kk', '', 0, '?'),
 ('~J|1<\'WC', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Themes.php', 0, 'B\ZFQ$', 'B\ZFQ$', 'GC}Io@v%*+g\0nR7', '', 0, '?'),
 ('O	mn2>', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/CategoryLookup.php', 0, '(HxJNxߴ', '(HxJNxߴ', '\nSfNsӽEGV$Ԍ~!', '', 0, '?'),
 ('Rn]a:E_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Events.php', 0, '?}K˜Tif', '?}K˜Tif', 'xhVZLHQ\\K$Հ^', '', 0, '?'),
 ('#G~ONQ\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/FeaturePlugin.php', 0, 'm88_To', 'm88_To', '|(SiJ.{,T>]Igl]-B', '', 0, '?'),
 ('	jڶZ\n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/ActivityPanels.php', 0, ']+xDGЕ\'3', ']+xDGЕ\'3', 'eyl>F9rkqn-GF7Lr4i͆', '', 0, '?'),
 ('G|l=5DT', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/Analytics.php', 0, '\nB\'X:k', '\nB\'X:k', '׹TAhChYQ]TF\0', '', 0, '?'),
 ('PeL9l', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/AnalyticsDashboard.php', 0, ',\'rEή\Z', ',\'rEή\Z', 'X./zI	;BӬ!./', '', 0, '?'),
 ('[	n\r-w', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/Onboarding.php', 0, 'S_3\n', 'S_3\n', 'D@xse.^(r6bΐ7^', '', 0, '?'),
 ('ʍN^Beɛ]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/OnboardingTasks.php', 0, 'k۩`#', 'k۩`#', 'ؔa(ܜ_SLMKHcg1 n@', '', 0, '?'),
 ('!ڟ\0SV菥bZ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Install.php', 0, 'f^ۃp', 'f^ۃp', '3܅yo\'Mh0ބA', '', 0, '?'),
 ('w͡[X', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Loader.php', 0, 'r-6fuǥ', 'r-6fuǥ', 'oZنAsu&`]鋖MA0>qft', '', 0, '?'),
 ('ns{>,h', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/DataStore.php', 0, '?&L4e@', '?&L4e@', 'rvSW p]&_ԟRL', '', 0, '?'),
 ('LmXT!AclQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/NoteTraits.php', 0, '0қΉG}@\0~[', '0қΉG}@\0~[', '^ǈ]ATEV997Iu3', '', 0, '?'),
 ('98\\>{ɖ\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Note.php', 0, '+gJ茅lÛ`', '+gJ茅lÛ`', '3`P2|d1 Uܨ6ξ`\r', '', 0, '?'),
 ('	xKs,bY;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes.php', 0, '*]B]ew9#', '*]B]ew9#', ':=x|YѬ\r\\<T=+\\Ja4E', '', 0, '?'),
 ('yez:ٽJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Add_First_Product.php', 0, 'ҋ\02*;DR_\\f', 'ҋ\02*;DR_\\f', '<:AEN}[pm2kYz!!aN', '', 0, '?'),
 ('ioR{O)3O', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Deactivate_Plugin.php', 0, 'Pb~nC5O', 'Pb~nC5O', '{BV4/ఒ}?̙XJ@', '', 0, '?'),
 ('(HHb\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Facebook_Extension.php', 0, 'Z	7.}f', 'Z	7.}f', 'mm$vFY2Q;0QAE^', '', 0, '?'),
 ('/UoMֶ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Giving_Feedback_Notes.php', 0, 'M>\0駳	\"', 'M>\0駳	\"', 'voȥ\ZPTԥ_nEN]jiܿ	(', '', 0, '?'),
 ('aG-	則b^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Historical_Data.php', 0, '9Gkwn/4', '9Gkwn/4', 'gJKYAZ|]r6,oI7T', '', 0, '?'),
 ('W:$#$', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Mobile_App.php', 0, '㹱M~U', '㹱M~U', 'u\ZtvIFWW1ZAz&_}', '', 0, '?'),
 ('o4Xui+Q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_New_Sales_Record.php', 0, ',7sASn,', ',7sASn,', '<)1\\UGzkmլ#yBR5', '', 0, '?'),
 ('l#ǰ	%&_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Onboarding.php', 0, 'k\"5l93', 'k\"5l93', 'ʉrtJ]OeGjZE8v', '', 0, '?'),
 ('\0	', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Onboarding_Email_Marketing.php', 0, '\n7h;R8<', '\n7h;R8<', 'x=L\'aٗL7w:)2i\0Q', '', 0, '?'),
 ('`Ggx6NO', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Onboarding_Profiler.php', 0, '@7]& DY>', '@7]& DY>', '\Zxh2gSŨv.\ZƠIu8', '', 0, '?'),
 ('s9h3MduL', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Order_Milestones.php', 0, 'HW{', 'HW{', '+s̬V\'ezӯ9Fr?\"|a', '', 0, '?'),
 ('fVf >+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Settings_Notes.php', 0, 'iŝq䗷QI', 'iŝq䗷QI', 'BCL	A7R%٭', '', 0, '?'),
 ('l?3-tMw˕4', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Tracking_Opt_In.php', 0, 'Q*>:_', 'Q*>:_', 'I\n6E&$3(.P:FKXGͬ=', '', 0, '?'),
 ('7烉;XwK', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Welcome_Message.php', 0, 'O#$g}\\h]o~', 'O#$g}\\h]o~', 'FVan|0`:C),-', '', 0, '?'),
 ('ࣄe0\'/', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Woo_Subscriptions_Notes.php', 0, '\'\'%{sS^Av', '\'\'%{sS^Av', 'Q\'m^zs	b{%̀HG', '', 0, '?'),
 ('/do+~p', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/Order.php', 0, 'gkHT<a	iq', 'gkHT<a	iq', 'JӮ;@zweI#|TjDS', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('C$Z1nU=L', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/OrderRefund.php', 0, 'OJ', 'OJ', '\0qX~d\"$5N\ZY]f', '', 0, '?'),
 ('D~:VrV', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/OrderTraits.php', 0, '߶W.<a!)Q', '߶W.<a!)Q', 's\0z<w梵?س>Ҭy', '', 0, '?'),
 ('7jtRxC_E', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/ThemeUpgrader.php', 0, 'pl[X[	ǉ{', 'pl[X[	ǉ{', '8#OҺs-5x', '', 0, '?'),
 ('g *ډs6', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/ThemeUpgraderSkin.php', 0, '8\0qeGhD', '8\0qeGhD', '7ѽv@qa', '', 0, '?'),
 ('1Ғ*aۗ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Package.php', 0, '$	=J{hv', '$	=J{hv', '_8]1yg^Q)ðτ=@', '', 0, '?'),
 ('j`?=LW*', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/PageController.php', 0, 'ȷ^.=RIg', 'ȷ^.=RIg', 'Xȑ>!(KZ+j7@', '', 0, '?'),
 ('NA2&?K7]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportCSVEmail.php', 0, '@hNoR', '@hNoR', '$ф{lş^\\(\Zf\nJD:', '', 0, '?'),
 ('wf:=,--!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportCSVExporter.php', 0, 'MaMA\'Rh\nI', 'MaMA\'Rh\nI', '\0#PBI| ,UZ-6kF', '', 0, '?'),
 ('_^3б', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportExporter.php', 0, '4ŸEL[\Zr@Z,', '4ŸEL[\Zr@Z,', 'S@YaDNI_ơj򄚪j`5\r', '', 0, '?'),
 ('!	+0{б}T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportsSync.php', 0, '	di\n\Zfs', '	di\n\Zfs', 'ebj5GCRXپ]k.ʭ', '', 0, '?'),
 ('ksvIEg\Z^-', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/CustomersScheduler.php', 0, 'J`}M\'֩', 'J`}M\'֩', '8{hdЄy!a{r6\0\"', '', 0, '?'),
 ('~5d4w i', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/ImportInterface.php', 0, 'T5byе', 'T5byе', '[ոלRuEX6H&oW', '', 0, '?'),
 ('̵qX{u1[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/ImportScheduler.php', 0, 'lr`ë́[', 'lr`ë́[', '7׉*FXFyz6x', '', 0, '?'),
 ('EY%G<\']', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/OrdersScheduler.php', 0, 'M/8n3}!Zc', 'M/8n3}!Zc', 'Q`mCHW}JÅGk5G', '', 0, '?'),
 ('|co%R87', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/SchedulerTraits.php', 0, ']&%}cBz!>', ']&%}cBz!>', '/lӺĬ1ȶʁ <1gqWRUtxtj', '', 0, '?'),
 ('VDC=Eu\"`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/uninstall.php', 0, 'QƄJh/R{', 'QƄJh/R{', 'pe޲cdܠ71XM/\nb', '', 0, '?'),
 ('>.#G?(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/autoload.php', 0, '6{}`aj', '6{}`aj', 'PӴBgEkj\"I_|=\Z', '', 0, '?'),
 ('cZ>=\rZ*<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/autoload_packages.php', 0, 'E;ʛq_', 'E;ʛq_', '%/MsF>FO6iܫN', '', 0, '?'),
 ('6?wӣDZh', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/automattic/jetpack-autoloader/src/AutoloadGenerator.php', 0, 'Q\'lZKep8tj', 'Q\'lZKep8tj', 'T	Eo\Z<\r:s|*\'D͸f=q\nl', '', 0, '?'),
 ('PtXM', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/automattic/jetpack-autoloader/src/CustomAutoloaderPlugin.php', 0, '\Zx}~\'SBȁ_=it', '\Zx}~\'SBȁ_=it', 'LOd&mtҸsR<ÜY', '', 0, '?'),
 ('$7Oȋ$K', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/automattic/jetpack-autoloader/src/autoload.php', 0, 'ݟ\Zfi(p\0tp', 'ݟ\Zfi(p\0tp', 'H+_c~qgg/	-:&eC', '', 0, '?'),
 ('^&jRQ~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/ClassLoader.php', 0, '{X-[pw', '{X-[pw', 'p{/[jߐ·~e', '', 0, '?'),
 ('xl\nd\00ƂC', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_classmap.php', 0, 'EӤ㭇Mg', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 ('ɹU->\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_classmap_package.php', 0, 'ܣt$`εZdc', 'ܣt$`εZdc', '2.\n/\\kQY=2z\r', '', 0, '?'),
 ('7Y{^Ns}o', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_namespaces.php', 0, '5,}vĨ3G)', '5,}vĨ3G)', 'Er4@\0ԡ$z3$l\Z`iexl', '', 0, '?'),
 ('\"|;Na', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_psr4.php', 0, '~b[k', '~b[k', 'z	y-ؠm|zK05\ZqD', '', 0, '?'),
 ('\'Dq)<ӷT', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_real.php', 0, '_E3dʔЋ', '_E3dʔЋ', 'VqVQepq\'&h~', '', 0, '?'),
 ('Ԇ|9&6zi!HZ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_static.php', 0, '~چ2(J', '~چ2(J', 'ϼP\0N]6rxĴIc', '', 0, '?'),
 ('7JA?}^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AglInstaller.php', 0, 'Cc=W*Dg', 'Cc=W*Dg', '3(W~;M<dz4', '', 0, '?'),
 ('jK1&', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AimeosInstaller.php', 0, 'EWMi6=<*@}m', 'EWMi6=<*@}m', 'DRV\\ŭ<7ty	,8YmL', '', 0, '?'),
 ('-xkvqaX', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AnnotateCmsInstaller.php', 0, '1csDh%[p!4\"', '1csDh%[p!4\"', ';<EU%HwDDˋ8T', '', 0, '?'),
 ('.ycyr:a', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AsgardInstaller.php', 0, 'LJM', 'LJM', 'V\n#\nA@,c]:a# a\n&7', '', 0, '?'),
 ('\'׋y ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AttogramInstaller.php', 0, 'oGE\r', 'oGE\r', '}DlqX\"aGGuVX}=', '', 0, '?'),
 ('%}B\rI\r9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/BaseInstaller.php', 0, '!mV9q}', '!mV9q}', 't.tX@iZT7&\\&-Yd', '', 0, '?'),
 ('}H*::_)-qp', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/BitrixInstaller.php', 0, 'h!fŪe%Q', 'h!fŪe%Q', 'XTQms`DPç,|쫺d8', '', 0, '?'),
 ('>Nb', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/BonefishInstaller.php', 0, 'u\".O	\"O-B', 'u\".O	\"O-B', '`Ś睤ybktBI', '', 0, '?'),
 ('\\*F	Rif숁', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CakePHPInstaller.php', 0, '6k_sx', '6k_sx', 'h;[8{ܠ^xx\r', '', 0, '?'),
 ('$N[-J|6]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ChefInstaller.php', 0, 't&r@;f', 't&r@;f', 'iifzΰP\\B<Wٴp2,T', '', 0, '?'),
 ('k^;~Zh', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CiviCrmInstaller.php', 0, 'eSu-՘}', 'eSu-՘}', 'ix_Kn&F:ra0', '', 0, '?'),
 ('w*^x', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ClanCatsFrameworkInstaller.php', 0, '՝Vo5ڐ\\', '՝Vo5ڐ\\', '>9Y\rYOC4huG[', '', 0, '?'),
 ('m(.$f_	(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CockpitInstaller.php', 0, '֗6>,!', '֗6>,!', 'Sſ`0$ RW>c:5ΚMä', '', 0, '?'),
 ('\rs_ʓ43T:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CodeIgniterInstaller.php', 0, 'H=u]R9', 'H=u]R9', 'Km}DS7ښL<ya', '', 0, '?'),
 ('!+p6c@&14e', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Concrete5Installer.php', 0, 't	m!~A^S', 't	m!~A^S', '#L?OM6r/W_~', '', 0, '?'),
 ('lQc=@O', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CraftInstaller.php', 0, 'إg]b', 'إg]b', 'gD>IB9LI	*1160C|', '', 0, '?'),
 ('N0\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CroogoInstaller.php', 0, 'AvE\"M\\M', 'AvE\"M\\M', '4(eI892-뱎ļ~]', '', 0, '?'),
 ('9*GX*v=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DecibelInstaller.php', 0, '+r\"`lҮvv', '+r\"`lҮvv', '#5}͏	\\fWİ~C`Oc,', '', 0, '?'),
 ('OU]azǋo', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DframeInstaller.php', 0, ';<JE&$dc', ';<JE&$dc', 'q%>D$$:jk z;', '', 0, '?'),
 ('U7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DokuWikiInstaller.php', 0, '}=%7\\8V', '}=%7\\8V', 'wHp[w2@u\Z\"LHa6Q', '', 0, '?'),
 ('qHp\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DolibarrInstaller.php', 0, '	m_d&Ժ0w', '	m_d&Ժ0w', '0슿ksφz@ⱇ)T+', '', 0, '?'),
 ('\rW(\"xmz]E', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DrupalInstaller.php', 0, '\ZE_r9?Z', '\ZE_r9?Z', 'c\r`t܅4Lʝjo:#u##Y', '', 0, '?'),
 ('>ǿ^on', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ElggInstaller.php', 0, 'Ṕxǐ', 'Ṕxǐ', 'DmMY|x\"<ALfpx3)H\"', '', 0, '?'),
 ('I߸P[hH', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/EliasisInstaller.php', 0, ':8ٷI', ':8ٷI', '\0x\Za&*U<Ƌ]yܻ', '', 0, '?'),
 ('(2Go;٘', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ExpressionEngineInstaller.php', 0, 'oGY>y*^Y', 'oGY>y*^Y', 'Mr%k!󂥲Ӳz݁	)C', '', 0, '?'),
 ('v6b䭘', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/EzPlatformInstaller.php', 0, '@5$uoa ', '@5$uoa ', 'N8f?l}i\Znp}', '', 0, '?'),
 ('#m~Uu!(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/FuelInstaller.php', 0, '^q{3\\g', '^q{3\\g', 'NӮNAWuh#\"8)eM16', '', 0, '?'),
 ('g</MM', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/FuelphpInstaller.php', 0, '@K{~tbYb', '@K{~tbYb', '\nȞ]r6	ÚZ{TVc.Gv~', '', 0, '?'),
 ('aԅ*8#18,]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/GravInstaller.php', 0, '>ޑU@^L]', '>ޑU@^L]', ')LB|@\"UeJEWz ', '', 0, '?'),
 ('UܙЁq', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/HuradInstaller.php', 0, 'U-07\n}m\\^', 'U-07\n}m\\^', 'dTa߰`+>/!!^bg$\n', '', 0, '?'),
 ('|yXHwcE0WQD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ImageCMSInstaller.php', 0, '[}_ەX', '[}_ەX', ';ܶڏiKx好[\0ܥ}*3', '', 0, '?'),
 ('/̟]7\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Installer.php', 0, '\'	L}RV', '\'	L}RV', ']^l`%y/NШXϻN\Z', '', 0, '?'),
 ('&Ǒq[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ItopInstaller.php', 0, ',JDũ', ',JDũ', '8}+{3{9\nBx=\'0', '', 0, '?'),
 ('	Rjw', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/JoomlaInstaller.php', 0, '\0fHpg!NO\'', '\0fHpg!NO\'', 'ߓ2ns?AN\ng;', '', 0, '?'),
 ('B]s', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KanboardInstaller.php', 0, '*3]<]\'', '*3]<]\'', 'нrt}Q7@I=}amu(Q', '', 0, '?'),
 ('qə(v<X:h j', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KirbyInstaller.php', 0, '(J_?+4h', '(J_?+4h', '	<?~C2B ?', '', 0, '?'),
 ('}t\\?Tp1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KnownInstaller.php', 0, 'H.(N7\r', 'H.(N7\r', '_Gd11gY1~>B$tX', '', 0, '?'),
 ('{\0kc̆', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KodiCMSInstaller.php', 0, 'X_c\'xM9', 'X_c\'xM9', '`S,wD9kC\05β19jB[', '', 0, '?'),
 ('6G$Q/M', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KohanaInstaller.php', 0, 'Z \"I/', 'Z \"I/', '\"[&Pz>|֪!HX1b', '', 0, '?'),
 ('Ix.aB%', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LanManagementSystemInstaller.php', 0, 'Pf9O6{l', 'Pf9O6{l', 'X>>2򽿉=I̱FҁKŝl\"', '', 0, '?'),
 ('f*h񽁗', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LaravelInstaller.php', 0, '=`w26d', '=`w26d', '6ŷWh	0W?ޝYǝm', '', 0, '?'),
 ('gŇ3,Tp', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LavaLiteInstaller.php', 0, 's@4	\ZDw', 's@4	\ZDw', '+Yv2\ZBP@bHIe4M', '', 0, '?'),
 ('FJ>U\0d6', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LithiumInstaller.php', 0, '!{hȡR2˪퀨6', '!{hȡR2˪퀨6', '(1qKCD?~Ԩ~OT $&~#>', '', 0, '?'),
 ('jMrU/֊1}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MODULEWorkInstaller.php', 0, '٢j@\nN', '٢j@\nN', 'pv$L΋,*ʸ/;R˥', '', 0, '?'),
 ('$e+w24{C\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MODXEvoInstaller.php', 0, ' Ќ~^F', ' Ќ~^F', '(o8@.z۹	\n!q66bp}', '', 0, '?'),
 ('\0FqLq', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MagentoInstaller.php', 0, '{Fs', '{Fs', 'CfjI\0QnmJI*', '', 0, '?'),
 ('\nL:.(st', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MajimaInstaller.php', 0, 'XU+4]\nj2` ', 'XU+4]\nj2` ', 's)Wg>\0vw@Ceц', '', 0, '?'),
 ('EH]:`բ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MakoInstaller.php', 0, '6gO5| ', '6gO5| ', 'pns#dF$W͕(Q76', '', 0, '?'),
 ('e%\\	/', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MauticInstaller.php', 0, ';y%poѨ', ';y%poѨ', '_/y1R%+a-DY6	,,', '', 0, '?'),
 ('Q}?)3$s\n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MayaInstaller.php', 0, 'g\0p	f/l:', 'g\0p	f/l:', ')_TM\"4\0ٜ(', '', 0, '?'),
 ('JT.h}$', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MediaWikiInstaller.php', 0, 'd3ͮ%.Y', 'd3ͮ%.Y', '\n &<j}J̌vn^wo[', '', 0, '?'),
 ('-?q[K&R3V', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MicroweberInstaller.php', 0, '#[1E=\'?½', '#[1E=\'?½', 'n=}JqY9)fM$&R!w', '', 0, '?'),
 ('G\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ModxInstaller.php', 0, 'DMR{iPc', 'DMR{iPc', '&w\"<?Hf>\ZR1%B', '', 0, '?'),
 ('^)pb~>[N', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MoodleInstaller.php', 0, '\"fڞّaϐg', '\"fڞّaϐg', 'Rs4Jqh~chfUFl_`', '', 0, '?'),
 ('@e\n&.c', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OctoberInstaller.php', 0, '=\n8u', '=\n8u', '!|\'n{ML;vO1', '', 0, '?'),
 ('wHKxţ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OntoWikiInstaller.php', 0, '0R$|~\nv', '0R$|~\nv', 'kipE0mŗ1tMFeZ\nRR', '', 0, '?'),
 ('e8U_4$ ,=c', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OsclassInstaller.php', 0, 'H\'Hyr\n', 'H\'Hyr\n', 'ߓK4e߂S]n', '', 0, '?'),
 ('7V}x1bzz', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OxidInstaller.php', 0, 'KE6P\0I6', 'KE6P\0I6', 'U=^k\\p\'}4֌&dtfhU3[', '', 0, '?'),
 ('ENX[Eל', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PPIInstaller.php', 0, 'mĎ妁\r\"Bx~', 'mĎ妁\r\"Bx~', 'PL`\'R<DJU>1D,', '', 0, '?'),
 ('\Z5o fqo', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PhiftyInstaller.php', 0, 'jB8', 'jB8', 'er5EdH?\ZaARd', '', 0, '?'),
 ('4<EEˬ Gr', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PhpBBInstaller.php', 0, '},S=T8', '},S=T8', 'ъcY25%=dt}~^?', '', 0, '?'),
 ('\\E\"_0K\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PimcoreInstaller.php', 0, ';J;`ƒ nH', ';J;`ƒ nH', '\r~$#,[5gtW]I{8r(', '', 0, '?'),
 ('O<O:=`,;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PiwikInstaller.php', 0, 'u̎#!?5', 'u̎#!?5', 'pi=z+#8=n~}', '', 0, '?'),
 ('>*!ah', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PlentymarketsInstaller.php', 0, 'ź>pҸ]T:', 'ź>pҸ]T:', 'lO|TKf.`~4,XvIt', '', 0, '?'),
 ('/`CBﮥL', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Plugin.php', 0, 'Y9:<ﳽйS', 'Y9:<ﳽйS', 'δ:v%Ȟ#{GBWG', '', 0, '?'),
 ('23K', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PortoInstaller.php', 0, '`	={`F\ZG7', '`	={`F\ZG7', 'c6y )Sq![dkm', '', 0, '?'),
 ('|t[XuX', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PrestashopInstaller.php', 0, '!Hh', '!Hh', '9.YlSAXNo*bl', '', 0, '?'),
 ('IBGjH', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PuppetInstaller.php', 0, 'bUyͅ\08', 'bUyͅ\08', 'bSx\\hT/[ĭux+)D+n<', '', 0, '?'),
 ('PWut*', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PxcmsInstaller.php', 0, '0v-T8', '0v-T8', 'i;Hʳ=wRm:@6C|Q	,', '', 0, '?'),
 ('Vޜ57up', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/RadPHPInstaller.php', 0, 'R\"	\r{9q+E^[', 'R\"	\r{9q+E^[', 'Ol]%$RCombTr>\ZG', '', 0, '?'),
 ('DIXh', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ReIndexInstaller.php', 0, 'OÝY,\\-\Z*', 'OÝY,\\-\Z*', 'V#|q1Vׁ-(#خ3-', '', 0, '?'),
 ('4|.)A', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Redaxo5Installer.php', 0, ')^R!-', ')^R!-', '``1\02\'UA݌ !^B', '', 0, '?'),
 ('k8#;xa\Z(8JS', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/RedaxoInstaller.php', 0, 'F[|.1x	&XfN', 'F[|.1x	&XfN', 'Dm1%nݛ_dr \rJ3Tr', '', 0, '?'),
 ('#C2~9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/RoundcubeInstaller.php', 0, 'lcc*~j=p*u', 'lcc*~j=p*u', '<&J#s\\.,G$lt<IW5', '', 0, '?'),
 ('x!A☐M1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SMFInstaller.php', 0, '8I0mj@0%U', '8I0mj@0%U', '{{o]vrlSaXrPΓ?%.E', '', 0, '?'),
 ('U ~3DK', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ShopwareInstaller.php', 0, 'KKyޫpr]', 'KKyޫpr]', '\Z\n=I#Z\\4l֙u`', '', 0, '?'),
 ('E1T;7T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SilverStripeInstaller.php', 0, 'P-^03͙5', 'P-^03͙5', '>-且T	1&047lT', '', 0, '?'),
 ('x$|T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SiteDirectInstaller.php', 0, 'Y6oz/C', 'Y6oz/C', 'e׺k+oC @ƹOK<hS_', '', 0, '?'),
 ('͉H!l(l\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SyDESInstaller.php', 0, 'W}B=H', 'W}B=H', 'jPG\ruDc=p\Ztzm6=', '', 0, '?'),
 ('kǱ\\&5:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Symfony1Installer.php', 0, 'LQ\09mM', 'LQ\09mM', '|3,Ux`i@?f.@F/x}h#', '', 0, '?'),
 ('w<HbChQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TYPO3CmsInstaller.php', 0, 'OEeZYE&', 'OEeZYE&', 'WsGr(Q9A_©>+\'', '', 0, '?'),
 ('ר^I5-', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TYPO3FlowInstaller.php', 0, ',oFD:N4', ',oFD:N4', 'jKbʍy,`y5ofڮ_e', '', 0, '?'),
 ('anC%;ߍ(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TaoInstaller.php', 0, '^7Y+\Z͟UC', '^7Y+\Z͟UC', '%WJ5^U7}Z0gw', '', 0, '?'),
 ('NYHB\rp', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TheliaInstaller.php', 0, 'R#tXɃt}7FI7', 'R#tXɃt}7FI7', '1xk_,_{p\'-Zʻ', '', 0, '?'),
 ('EJNk!+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TuskInstaller.php', 0, 'R\\L뺵\'Q', 'R\\L뺵\'Q', '0&MsԎ̩c|	av', '', 0, '?'),
 ('T;/', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/UserFrostingInstaller.php', 0, 'Bмzֵ_', 'Bмzֵ_', 'V-2޸<n{s?IݸW>fs(', '', 0, '?'),
 ('C\')+Q{M', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/VanillaInstaller.php', 0, '$c63>nM\"', '$c63>nM\"', 'd1ޙGp#\\3f\'.', '', 0, '?'),
 ('RtYP)J$!9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/VgmcpInstaller.php', 0, 'zr>U<z1xe', 'zr>U<z1xe', '2LY6[Sj@K#', '', 0, '?'),
 ('VW%ǮFv', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/WHMCSInstaller.php', 0, 'HW7PA,Ix\'', 'HW7PA,Ix\'', '>:iIsk~+Kl)si', '', 0, '?'),
 ('\0&(w%N', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/WolfCMSInstaller.php', 0, 'LĜLȐr4r', 'LĜLȐr4r', '\r&s3H)CN)1\nJ', '', 0, '?'),
 (',VejG/qV', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/WordPressInstaller.php', 0, 'ՁU3ҾPm', 'ՁU3ҾPm', 'oa/jnuFX]S{u', '', 0, '?'),
 ('插f^|^\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/YawikInstaller.php', 0, 'UR)}g)vWs', 'UR)}g)vWs', 'QT@k\"!9Ca', '', 0, '?'),
 ('W;eq', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ZendInstaller.php', 0, '<TW<l0ӵ', '<TW<l0ӵ', 'ۡ-ON~*_>g<', '', 0, '?'),
 ('Hfm8V|?q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ZikulaInstaller.php', 0, 'K8Idpo?E', 'K8Idpo?E', 'T!H	ؘ,Ca~KOPJ9', '', 0, '?'),
 ('ztӷujjt', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/bootstrap.php', 0, 'Ɲ\n%\0', 'Ɲ\n%\0', 'g&AgpI84\ZBj', '', 0, '?'),
 ('vPoӤ׻ C', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/woocommerce-admin.php', 0, 'b~K6ץ0_/', 'b~K6ץ0_/', '4|@V3\\PPtI(9jg', '', 0, '?'),
 ('|â', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/block-error.svg', 0, '2+%ML.f{>(', '2+%ML.f{>(', '8Lt`ViPR/nIA{]Q', '', 0, '?'),
 ('ܷUSC!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/grid.svg', 0, '-hZTΛw', '-hZTΛw', '$ʛAaH i(V#Wܡ-1sJ', '', 0, '?'),
 ('թ8P47:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/no-matching-products.svg', 0, 'C*yU`J', 'C*yU`J', 'ښuQC7lHa~\0ad.Z', '', 0, '?'),
 ('z|q\r0khi', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/no-products.svg', 0, 'ؐ*Ð/=:w', 'ؐ*Ð/=:w', 'ehހ9.Sڀrd{<d', '', 0, '?'),
 ('jWx۫4J ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/button/index.js', 0, 'nA$Xj', 'nA$Xj', '-\Z<\\]XVO	=*Ix', '', 0, '?'),
 ('\"`v;4a@', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/image/index.js', 0, 'fEqB', 'fEqB', '9\n\0b{|W$`YI', '', 0, '?'),
 ('iy9Ldvh', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/index.js', 0, '>ܞ\nA6~6.', '>ܞ\nA6~6.', '\Z<\nאއ(	NP#LVc[3[', '', 0, '?'),
 ('잆>Y\n̨8F', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/price/index.js', 0, '\'uհ k,31c', '\'uհ k,31c', 'Uhȥ,pf7`sW5yDE', '', 0, '?'),
 ('.Tݭ2', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/rating/index.js', 0, ':iv4dk', ':iv4dk', ':\r;%s{Ftɋ꟨qxy', '', 0, '?'),
 ('e\Z0;\\5<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/sale-badge/index.js', 0, 'Tzke]', 'Tzke]', 'C?0&N|ŋi@:\Z(asRw', '', 0, '?'),
 ('%\\N+!\\5', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/shared-config.js', 0, '%> Ew', '%> Ew', '#mʷ`)XmORt4 l51{Wՠ_', '', 0, '?'),
 ('&\0{;Y޷S*', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/summary/index.js', 0, 'hOJmE<e-', 'hOJmE<e-', 'A$Q\ZU~$SXЁUwO}y', '', 0, '?'),
 ('}桌', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/title/index.js', 0, 'mУ.h@', 'mУ.h@', '!-I5@;j()gKܠvgk#', '', 0, '?'),
 ('^\';~I4+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/button/index.js', 0, 'dk\'^\0', 'dk\'^\0', '| Zs\rZ,:[\"{/', '', 0, '?'),
 (';4+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/image/index.js', 0, 'NG6·/', 'NG6·/', 'tOAb7+\Z^3Fm1G', '', 0, '?'),
 (' 8,9Esj', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/index.js', 0, '}PkZ7cd߼y', '}PkZ7cd߼y', 'ȱ{\\n?lKI+?:=Ǩ{=', '', 0, '?'),
 ('}3A\0C', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/price/index.js', 0, 'x\"5u6fo', 'x\"5u6fo', ',1eX^yb3	{!Lӽ,1Qd\r>', '', 0, '?'),
 ('Ak伕rzϕz[Y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/rating/index.js', 0, '1/_dVubt', '1/_dVubt', 'SIkî.T*Ŗ̮DE`', '', 0, '?'),
 ('OB|%%u\n@J8', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/sale-badge/index.js', 0, 'Û-fHiHOn', 'Û-fHiHOn', 'P*spp\Z^cIE?`?TD', '', 0, '?'),
 ('ere9I', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/summary/index.js', 0, 'I;O oj⺪', 'I;O oj⺪', '[a;GTWt&3!#02\'jcS', '', 0, '?'),
 ('>=N`^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/title/index.js', 0, 'V%PjXTGx', 'V%PjXTGx', 'HV5)Q̧ݘDfb60', '', 0, '?'),
 ('<1d _<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/block-error-boundary/block-error.js', 0, '{a/m=l6]}LQE', '{a/m=l6]}LQE', 'e`͐?p\ncva', '', 0, '?'),
 ('\\4O܃VJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/block-error-boundary/index.js', 0, 'yV‗L', 'yV‗L', '?ޢ?qSGfK3t0(T', '', 0, '?'),
 ('7N4-9::7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/checkbox-list/index.js', 0, '/M!e#A|', '/M!e#A|', 'n%\0rRCؼNO44\\+%t*', '', 0, '?'),
 ('J˰$9~r%JO', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/checkout/form-step/index.js', 0, '\"\\BxpB0', '\"\\BxpB0', '0TI8yO>_+)%aX', '', 0, '?'),
 ('\"~{ds#;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/label/index.js', 0, 'xBh#?h:Iӑ|', 'xBh#?h:Iӑ|', '${Cx.Q\0v<RJbVj\Z\ZK', '', 0, '?'),
 ('l\0O5nGqH\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/label/test/__snapshots__/index.js.snap', 0, 'iҸ(Өbq', 'iҸ(Өbq', 'ʳٴ/U5GCK', '', 0, '?'),
 ('M\0%GLj%c*[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/label/test/index.js', 0, 'x&J^ Q', 'x&J^ Q', 'wYNMŝߑs2G', '', 0, '?'),
 ('Ξ	5(Qo', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/load-more-button/index.js', 0, '%mߧm', '%mߧm', 'ˢ(*&ldvG̈́UP2', '', 0, '?'),
 ('7$sM0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/pagination/index.js', 0, 'g|fs%9_1', 'g|fs%9_1', 'FMZӦ,HUH>_p', '', 0, '?'),
 ('83fωN^yi', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/pagination/test/index.js', 0, '!rvX\r 3z8', '!rvX\r 3z8', 't֨ݞ}5w)K\'=d\"', '', 0, '?'),
 ('>/fXd', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/pagination/utils.js', 0, '6HqTЅ2', '6HqTЅ2', 'zщQ8lKe.8dQSh', '', 0, '?'),
 ('Ns͟0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/constrain-range-slider-values.js', 0, '&Y8\r:W', '&Y8\r:W', 'f\0AXXKU/0S0_\\5', '', 0, '?'),
 ('hWfjXԟ[I', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/index.js', 0, '!>\r>QV', '!>\r>QV', '⋾sҎDC֌w', '', 0, '?'),
 ('*\\i+3@x', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/price-input.js', 0, 'ᓃULKml\"', 'ᓃULKml\"', '=4]t #K\'xјzɃMl00', '', 0, '?'),
 ('5~Зűdk\ni', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/price-label.js', 0, 'k;d܃Z', 'k;d܃Z', 'B.Ib3KҰre`VvX,/', '', 0, '?'),
 ('Kge <@', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/submit-button.js', 0, ',9dmXh=', ',9dmXh=', 'mG*Uu	lkãjd뻅\Z;', '', 0, '?'),
 ('N*,>.a', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/test/constrain-range-slider-values.js', 0, '2x!%qVƑ', '2x!%qVƑ', '\\,^+_#N`]}\0\rdy]', '', 0, '?'),
 ('*sMD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/container.js', 0, '6W-:>', '6W-:>', '[u&H .Q&<', '', 0, '?'),
 ('B鋺=^D', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/index.js', 0, 'D\0CMY', 'D\0CMY', 'W\r}\\X빦l3', '', 0, '?'),
 ('b\Za&G%!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/no-matching-products.js', 0, 'RtB\r-[@H', 'RtB\r-[@H', '?t4dK:wttv}6m', '', 0, '?'),
 ('+y[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/no-products.js', 0, '-TLB鲝+', '-TLB鲝+', 'tK$c+S\nD3\\}m(f@', '', 0, '?'),
 ('&^yI8X', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list-item/index.js', 0, 'z\r5CY', 'z\r5CY', 'JPfc(-fUU3EC_bEY', '', 0, '?'),
 ('$\0>l؃f~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list-item/utils.js', 0, '`F;04<', '`F;04<', 'PA7׎ʃ(;i[\r', '', 0, '?'),
 ('D&}3!G7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-sort-select/index.js', 0, ';?K18Kb', ';?K18Kb', ')ۼ\nrTd.\n4!H1?', '', 0, '?'),
 ('	}l7#? \'f', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/read-more/index.js', 0, '~\"R\"acu', '~\"R\"acu', '#&Z\'w0tL3FztF ', '', 0, '?'),
 ('d1ܛܖ\'9LJjM', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/read-more/test/index.js', 0, 'O`U', 'O`U', 'ݩш8c08`k]!\n', '', 0, '?'),
 ('+M+hǚ{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/read-more/utils.js', 0, 'ʞ7A ?/=\ZK', 'ʞ7A ?/=\ZK', '\'7s+I6zBwokb#V', '', 0, '?'),
 ('B~khS', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/review-list/index.js', 0, '8?##%', '8?##%', '1vCpv(aKo/x0', '', 0, '?'),
 ('	zeO', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/review-list-item/index.js', 0, 'p;sB7.Զr', 'p;sB7.Զr', 'k!\0.9- \0Оypx5RgͲ', '', 0, '?'),
 ('p]Lam', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/review-sort-select/index.js', 0, 'pߙIrY*', 'pߙIrY*', '(]CL)8Β軁', '', 0, '?'),
 ('nR/e[A9,~G;r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/sort-select/index.js', 0, 'TƞA\r꺾-SF', 'TƞA\r꺾-SF', 'F^w?\nYF7C^A{g(a', '', 0, '?'),
 ('SoԀ_X', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/inner-block-configuration-context.js', 0, '`nr2Ag', '`nr2Ag', '4<aJƜAEc6{E', '', 0, '?'),
 ('\"2q\\EEcIP', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/product-layout-context.js', 0, 'HpՄp-k;', 'HpՄp-k;', 'oz,o4d|&p% ', '', 0, '?'),
 ('=Տ@Jge', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/query-state-context.js', 0, 'i`%)0$b9:', 'i`%)0$b9:', '=<E[jߤ3l xJhU6', '', 0, '?'),
 ('Żףwźgn0}^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/test/utils.js', 0, '֚څVuR', '֚څVuR', 'l$޳Q@94', '', 0, '?'),
 (')|0Zv+q6', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/utils.js', 0, 'HlRk{2(L', 'HlRk{2(L', 'Ll(b\\|qƜ_Z', '', 0, '?'),
 ('`Ya,\rҠZ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/test/with-component-id.js', 0, 'Jmv^eGRY', 'Jmv^eGRY', '%)?yΣ<^\'jFmi\0Îπ99\'	yI', '', 0, '?'),
 (':|#y&}X', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/test/with-products.js', 0, 'Kl~2~', 'Kl~2~', '{4.X`=6qG|0GrG', '', 0, '?'),
 ('	6B6K!K\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/test/with-reviews.js', 0, 'wkdT.', 'wkdT.', '\08&d4ڤMK{sA\0P3:E,p', '', 0, '?'),
 (']<;\r9H[c', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/utils.js', 0, 'wü]!S%x', 'wü]!S%x', ':9[=tQŬ(zK+o9lٌG', '', 0, '?'),
 ('ۅ߃nBI~Q#', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-component-id.js', 0, '\'@4Fc脘]\'', '\'@4Fc脘]\'', '-t(\nHV)wB=2ήHh', '', 0, '?'),
 ('8\'Kasߞ0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-products.js', 0, '>95\0', '>95\0', '/3tqկ\0	\0)XB\"͜E', '', 0, '?'),
 ('ׅu/(^oN3\ZW', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-reviews.js', 0, 'C9N\r.V7y', 'C9N\r.V7y', '^αnHH.	}ǂӫe|', '', 0, '?'),
 ('H2CRAy[k', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-scroll-to-top/index.js', 0, 'fo4iJIE ', 'fo4iJIE ', '!q~{uqM5PB}Zý', '', 0, '?'),
 ('7xHea=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-scroll-to-top/test/index.js', 0, '13*]\"boƴ', '13*]\"boƴ', 'am%wD\r!B!F[ql', '', 0, '?'),
 ('(\n(κӪ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/index.js', 0, 'pB\';(!{W!B$l2', 'pB\';(!{W!B$l2', '\'\\M\nY1!<>;>\'(3', '', 0, '?'),
 ('{Oқ0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-collection.js', 0, 'z]tlM$', 'z]tlM$', 'xf\\0ZY\'=;&#', '', 0, '?'),
 ('Wƴ\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-previous.js', 0, ')*pxl', ')*pxl', '0\0j=,>У78P^2|1;\0', '', 0, '?'),
 ('nLCj0\'g', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-query-state.js', 0, '\'?5Juj7', '\'?5Juj7', '-uMx:.&5ie7`S\r;', '', 0, '?'),
 ('9W-Dk--Wi', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-shallow-equal.js', 0, '\\ƫ¾T', '\\ƫ¾T', ')?c+P.<7l,oV;L[2', '', 0, '?'),
 ('|h\Z<(=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-store-products.js', 0, '&ψ\"ŎXfwU\\', '&ψ\"ŎXfwU\\', 'KWYX\"ef\'E', '', 0, '?'),
 ('| +	Rx', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-collection-data.js', 0, '|\'m;_ύ{WB', '|\'m;_ύ{WB', 'uFvߣNQ!LT/ \n', '', 0, '?'),
 ('=M$3 +Et]Py', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-collection-header.js', 0, ';@ji', ';@ji', 'bm}z:\'ԕ<ތKX@_G|z', '', 0, '?'),
 ('/3$kTm=o', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-collection.js', 0, '7#hj', '7#hj', 'Gg(3?5#JUS}\Z', '', 0, '?'),
 ('#0}_3뽉Lx', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-previous.js', 0, 'T)\'U', 'T)\'U', '?F;qcLpɟlV\ZϮ', '', 0, '?'),
 (' \'{pvc.+K{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-query-state.js', 0, '\0ׁ%_:% Ɨf', '\0ׁ%_:% Ɨf', ' YmՁK_', '', 0, '?'),
 ('Vg,(Ŏ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-shallow-equal.js', 0, 'WH1@b,	%', 'WH1@b,	%', '\n|X{\0#먖yn&j', '', 0, '?'),
 ('=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-store-products.js', 0, 'gn\'IԵ', 'gn\'IԵ', '!H};`ة6G]t`^', '', 0, '?'),
 ('c&3y/', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/errors.js', 0, 'Zhb:7*V', 'Zhb:7*V', '\\D2bΨk^YfZ DsezKsp)M', '', 0, '?'),
 ('r\Z~C&3U', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/index.js', 0, 'X|릥lMa', 'X|릥lMa', 'j%+氥Ƌxۑv( /', '', 0, '?'),
 ('%k#\0(U', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/price.js', 0, '̣lL]n^e:', '̣lL]n^e:', '+5͝Ed˞?*\\wA8fL@', '', 0, '?'),
 ('eHk&bAL}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/test/errors.js', 0, '=MȔ$rwvf', '=MȔ$rwvf', '_6f^RifPnDdI\r#s', '', 0, '?'),
 ('\n,2(!a\n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/test/price.js', 0, '1oQoA(hK', '1oQoA(hK', '\'hV8o/OD3', '', 0, '?'),
 ('kVYT&@G\n1/', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/active-attribute-filters.js', 0, 'քΫʰzEl%', 'քΫʰzEl%', 'aE(I;5\"@fdvs<\ZQ<Z]', '', 0, '?'),
 ('P\\~T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/block.js', 0, ',hmد,WcHu\\', ',hmد,WcHu\\', 'uDaO|%8Gq', '', 0, '?'),
 ('%_ahO', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/edit.js', 0, '!nk?eA', '!nk?eA', '}ѡ\niعUT)', '', 0, '?'),
 ('h(\n8?', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/frontend.js', 0, 'Ycj7Mdx', 'Ycj7Mdx', '=cD>Y|ֻf|{UM=gQ/Q', '', 0, '?'),
 ('tOL', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/index.js', 0, '/ǲkώ0%IG\r', '/ǲkώ0%IG\r', '+T<m\'p$\\ޮ$qv+', '', 0, '?'),
 ('Ywm4d{=e%', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/utils.js', 0, '_6QF2+<Ud.', '_6QF2+<Ud.', 'Qe﷓8\\Fow \":N', '', 0, '?'),
 ('۪6w,\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/block.js', 0, 'g>s·\n', 'g>s·\n', 'f\rjnE<D!\Z>k:>Edʝ', '', 0, '?'),
 ('Z\"Α9L\n?', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/edit.js', 0, 'ȟYʮs\Z`', 'ȟYʮs\Z`', '.Rxӄ;/. ^ܟb\'-6P', '', 0, '?'),
 ('ѿ+2P<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/frontend.js', 0, 'vN?}edQE', 'vN?}edQE', 'X4:DC֯Ο[4B̙w͝7', '', 0, '?'),
 ('>kug\rco2:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/index.js', 0, 's\'D٧\'', 's\'D٧\'', '5WL?|,VZԗ7C3V\"Lo6', '', 0, '?'),
 ('zrs>E<i\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/block.js', 0, '>߼s#j\'Eb', '>߼s#j\'Eb', 'QY$Q r.\0yE\0o', '', 0, '?'),
 ('x( ce\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/example.js', 0, '3LpEky[\0', '3LpEky[\0', '|xY_\Z`xtu~7xe?\ZC.', '', 0, '?'),
 ('E\n`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/index.js', 0, '4͟W((vG{|', '4͟W((vG{|', '/\0wr$<`M\"B.^\n4x\\', '', 0, '?'),
 ('M,V.O', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/utils.js', 0, ')v7UpxZ', ')v7UpxZ', '>>;\nk&{gj\n:t\Zy', '', 0, '?'),
 ('BY*?(ÊC', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/block.js', 0, 'A1MT2\"ʑx', 'A1MT2\"ʑx', '3ꖽe^b	,pY{yڲ', '', 0, '?'),
 ('Jky', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/example.js', 0, '.\nA_\\', '.\nA_\\', 'D=^	Ȕ?ıC4?ud', '', 0, '?'),
 ('^<%q]\'<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/index.js', 0, '0Z\n̞-', '0Z\n̞-', '?lZl@m(\ZD\r\'\"6m', '', 0, '?'),
 ('*U))6f\r	H', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/utils.js', 0, 'pWl	sA,6', 'pWl	sA,6', '*gdBzBY1qh\rY', '', 0, '?'),
 ('eW@s\r##I', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/handpicked-products/block.js', 0, 'qv?f%gCښ', 'qv?f%gCښ', '\'m3ݳecmeA3', '', 0, '?'),
 ('}mTCU<m<;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/handpicked-products/index.js', 0, '.\\>gGj/', '.\\>gGj/', 'X%dg+ZP<rg؉ƅ', '', 0, '?'),
 ('APڀ@;72', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/block.js', 0, 'DmDüJ/}3', 'DmDüJ/}3', 'CO،\'`?qix\"qll[', '', 0, '?'),
 ('b>&D7[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/constants.js', 0, 'dUfy\"r', 'dUfy\"r', 'NKyN`Ma`=]&Ԩ1!	', '', 0, '?'),
 ('hgRB7iY', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/edit.js', 0, '^W!A+QWU', '^W!A+QWU', 'hNNA!tVW3CczI', '', 0, '?'),
 ('=̿r5#.R${', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/frontend.js', 0, '_LSR', '_LSR', 'Q\"@O+QcH0Aí*', '', 0, '?'),
 ('{BB+2m`Nߗ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/index.js', 0, 'R@\n', 'R@\n', '4@[03IŪLev;V', '', 0, '?'),
 ('	s725)\"Wf', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/test/use-price-constraints.js', 0, '\'6ZD', '\'6ZD', '-WyK{\ZWLP3x|_a|#3e', '', 0, '?'),
 ('r6|6jr5c', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/use-price-constraints.js', 0, 'ݷ	\n5ϙ>', 'ݷ	\n5ϙ>', 'IzyXևmN|;mb|CҞNt', '', 0, '?'),
 ('0=R҉| c', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-best-sellers/block.js', 0, '8,3K/;\'3', '8,3K/;\'3', '8VbYH3|pO+8h\Z', '', 0, '?'),
 ('!<쇋g', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-best-sellers/index.js', 0, 'P71;1VGp', 'P71;1VGp', '2<RޠZ+\"t=3', '', 0, '?'),
 ('{T4y6\rȐÐ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-categories/block.js', 0, 'ٙIQMX0o', 'ٙIQMX0o', 'Yl6ي$aB?3_iu}j', '', 0, '?'),
 ('x9\Zi;.', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-categories/index.js', 0, '`kE/D', '`kE/D', 'ڦwbNJR!ZZ\nfu}q#', '', 0, '?'),
 ('SћFB@', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-category/block.js', 0, 'D嫔hDy%', 'D嫔hDy%', '\"3ZXݙpb!W_WoNM', '', 0, '?'),
 ('3p2/Mo', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-category/index.js', 0, 's-o-!', 's-o-!', 'J%qwQ0`N9RP[9}', '', 0, '?'),
 ('e&K*Y2', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-new/block.js', 0, '0|]# E', '0|]# E', 'q&ra7cp', '', 0, '?'),
 ('89XحG<\Z;	', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-new/index.js', 0, '+D;V,0y', '+D;V,0y', '.n~	/v?pV-NKrԽ', '', 0, '?'),
 ('̫y\nZ6([', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-on-sale/block.js', 0, 'YMjp#xYSj', 'YMjp#xYSj', 'WhU-p.\"椇k:pv+D', '', 0, '?'),
 ('n2P@\\~o:\n\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-on-sale/index.js', 0, 'yϡ _̆[', 'yϡ _̆[', '0V2υCy$.l(9Y]#܇', '', 0, '?'),
 ('g{UwMI', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-search/block.js', 0, 'cqr/P;', 'cqr/P;', '>];dE2\ZtMldĘJ΋8M', '', 0, '?'),
 ('dRgLpi', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-search/edit.js', 0, '\"-Ȑ*\0q\n!#', '\"-Ȑ*\0q\n!#', 'g*wi#-Y r1?2a&h', '', 0, '?'),
 ('J?T6Tg16', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-search/index.js', 0, 'Oy0b H', 'Oy0b H', '4]Z4!8\0aB', '', 0, '?'),
 ('}~i,Zy0b', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-tag/block.js', 0, 'a?mbfy\r({aX', 'a?mbfy\r({aX', 'ړ;O=\'.Q$]\"$#:T', '', 0, '?'),
 ('v|nӄ$F);', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-tag/index.js', 0, 'n;%u1=Jp', 'n;%u1=Jp', 'Ƃ!`ܬeo$	;\0y[sVl', '', 0, '?'),
 ('_ܪbGB', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-top-rated/block.js', 0, 'Y$`m܇4', 'Y$`m܇4', 't;p!T؀	g4\r*', '', 0, '?'),
 ('u;sp;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-top-rated/index.js', 0, 'lH34.2|/pѡ$', 'lH34.2|/pѡ$', 'Ȗ++U_[+c>(;ᚬHRVX', '', 0, '?'),
 ('_\\je;:ͳڣ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/block.js', 0, 'oا\0b&j&', 'oا\0b&j&', 'X묱:S9|lrVOkg', '', 0, '?'),
 ('򮑜)\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/edit.js', 0, 'w9H7$tM<', 'w9H7$tM<', 'td r+5OwSF', '', 0, '?'),
 ('пN%0.y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/frontend.js', 0, '*;9ac:S', '*;9ac:S', '	5q,I{6r8er}gnFĈSN', '', 0, '?'),
 ('ҮdWYͤ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/index.js', 0, 'Or~b	1', 'Or~b	1', 'BNi\0!Ŵ7pg-A/ۗLÏ', '', 0, '?'),
 ('jp}aPeF', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/attributes.js', 0, 'D\ZmUWœ,4~', 'D\ZmUWœ,4~', 'KM)a$Cm?bmafU{', '', 0, '?'),
 ('ج+=1[Πp', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/base-utils.js', 0, '<*2桮Ռ', '<*2桮Ռ', 'C$p~D\"mqZb~', '', 0, '?'),
 ('e?kb{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/edit.js', 0, ']\0%B;,{', ']\0%B;,{', 'SS\n\nܑ-dFvYL', '', 0, '?'),
 ('җ=/|t_\0C', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/utils.js', 0, '3&n	|i/', '3&n	|i/', 'ٝT.n\':y1B eYS', '', 0, '?'),
 ('a\0&u?tA', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products-by-attribute/block.js', 0, 'S\0yf=rPh', 'S\0yf=rPh', 'ӬCGH{5BMt{9', '', 0, '?'),
 ('\Zo^FOJ<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products-by-attribute/index.js', 0, 'U^\nM]', 'U^\nM]', 'b.}@./pLÙ#pm', '', 0, '?'),
 ('6dU', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/all-reviews/edit.js', 0, '	\rWu\"#\n', '	\rWu\"#\n', 'Z蓃Xh>0XIzN!-d9AHc[', '', 0, '?'),
 ('h&djAo', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/all-reviews/index.js', 0, '&Ρ\n%.}$', '&Ρ\n%.}$', '/`?&Js}1@\Z)QaԯO', '', 0, '?'),
 ('MFB͉r2,v', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/all-reviews/no-reviews-placeholder.js', 0, 'OD\nY', 'OD\nY', '&߮;5oxXksP<Dd#x~', '', 0, '?'),
 ('QwK``y]\"T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/attributes.js', 0, 'qL', 'qL', '͊Η8:@@*(^ҳ8/*', '', 0, '?'),
 ('\Ztl-7d>~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/edit-utils.js', 0, 'x_)k^', 'x_)k^', '>ٮUV`\\ISe7O%19(5', '', 0, '?'),
 ('yQD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/editor-block.js', 0, 'Q\n\0FD', 'Q\n\0FD', 'FC	H6xnc$ϯ;(lu', '', 0, '?'),
 (')vxZ@', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/editor-container-block.js', 0, 'UqmCTT`', 'UqmCTT`', 'ƴS~4!Duf?\rxKza', '', 0, '?'),
 ('R]@VZYbS', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/example.js', 0, ' |^@8c\0Kj', ' |^@8c\0Kj', '@V|+IBbČor%K\0c[v[', '', 0, '?'),
 ('œPGQ}ܝ1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/frontend-block.js', 0, 'y{`X3', 'y{`X3', 'a0S@4lPQpIH@l(;- ', '', 0, '?'),
 ('adDx\r!ސ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/frontend-container-block.js', 0, 'Ĕr^_[3X', 'Ĕr^_[3X', 'DcuoF{$A(vfN=n8>', '', 0, '?'),
 ('B{BJG]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/frontend.js', 0, '#Fg+ru+6', '#Fg+ru+6', 'iIbbb^}Z	Ga@', '', 0, '?'),
 ('ud\0XJ\'w', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-category/edit.js', 0, '^\0a<?E', '^\0a<?E', '/7^.kfv8&~4v %t]se', '', 0, '?'),
 ('}vm҆\n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-category/index.js', 0, '2ͣp:,	̼y6', '2ͣp:,	̼y6', '\'+(\Z{h?rU8W\\fB', '', 0, '?'),
 ('wſSf8]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-category/no-reviews-placeholder.js', 0, 'djFe\\;', 'djFe\\;', 'A\'T+ `\\[rIX!.C7', '', 0, '?'),
 ('eeO!35b', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-product/edit.js', 0, '\'0iKd=', '\'0iKd=', ');(:S\0`3~mQth', '', 0, '?'),
 ('$HZ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-product/index.js', 0, 'HR\rA$', 'HR\rA$', 'ld\"<uh\nD\rށYWWMkm', '', 0, '?'),
 ('T\0F:NO޲Ң.', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-product/no-reviews-placeholder.js', 0, '[:FG<䊴С', '[:FG<䊴С', 'u\n,Iǭp6]PhiIhA}aIu', '', 0, '?'),
 ('0`_ԻJJ;N', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/save.js', 0, '-9uU8Ԅ', '-9uU8Ԅ', '`j6!O{+]|8@!c#', '', 0, '?'),
 ('S4Ho@xL', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/utils.js', 0, 'O&tA', 'O&tA', '*h%9q+{[ˏ,', '', 0, '?'),
 ('%I?,P:H', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/get-registered-inner-blocks.js', 0, '|>x6`AMz', '|>x6`AMz', '9G\ZÃ\0$j~cI', '', 0, '?'),
 ('C-~3U\n>T ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/index.js', 0, 'Ἣ%yN\'yx', 'Ἣ%yN\'yx', '[\0DpBwQCTe\Z\rǠ/', '', 0, '?'),
 ('y\'tz\0ma7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/register-inner-block.js', 0, 'ξKQ\"', 'ξKQ\"', '[&!F[qϠ,m~', '', 0, '?'),
 ('|_wdQHP6|$_n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/registered-blocks-init.js', 0, '{rk߶\0:.', '{rk߶\0:.', 'n;.;#\n$Z[3N_', '', 0, '?'),
 ('e6NF6g9#U', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/test/index.js', 0, '&MSHJ9d(L', '&MSHJ9d(L', 'ύk~tWnϩ;L~3f/', '', 0, '?'),
 ('!\n7Ș&\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/block-title/index.js', 0, '][\\ZML', '][\\ZML', '7@䘣!L&YWAi', '', 0, '?'),
 ('qAХǻο<I', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/error-placeholder/error-message.js', 0, 'aǀhuZfoI', 'aǀhuZfoI', '\\ a*YU\Z]B=A[|F2', '', 0, '?'),
 ('(rC.y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/error-placeholder/index.js', 0, ')SZR', ')SZR', 'or-N9pfYa\\{c', '', 0, '?'),
 ('Rq@l7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/grid-content-control/index.js', 0, '\"ͻO3!)', '\"ͻO3!)', 'rA)<Ђ%q\ZefbVZe', '', 0, '?'),
 ('?eꡨzIi', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/grid-layout-control/index.js', 0, '\0_cAfB', '\0_cAfB', 'Jmh7fFd>֖,', '', 0, '?'),
 ('(=lYOcF', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/heading-toolbar/heading-level-icon.js', 0, 'Lje e', 'Lje e', '0tH#`ZPRwD/mE@+', '', 0, '?'),
 ('S2I\0\'n썍9{\')', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/heading-toolbar/index.js', 0, '!q$\0گKe', '!q$\0گKe', '2>Ԇpw<_0\r=	ƕtU\"', '', 0, '?'),
 ('O_pD0V', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/all-reviews.js', 0, '%\\e5Oaf\0Crtl', '%\\e5Oaf\0Crtl', 'oAF}@eзXJIv', '', 0, '?'),
 ('gH!cX', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/checkbox-checked.js', 0, '4i0.L.Z', '4i0.L.Z', '=zδyV/՗W<?nJ#', '', 0, '?'),
 ('nھ>FZaD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/checkbox-unchecked.js', 0, 'DnH\0}(0', 'DnH\0}(0', '>~aTNTK\0[+wx.N', '', 0, '?'),
 ('qגނƲN', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/external.js', 0, '7VrR9Ǥ*', '7VrR9Ǥ*', 'qk0m\0:۟Dʝ{h䓴', '', 0, '?'),
 ('QA,ɍ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/folder-star.js', 0, '`&`=c͡', '`&`=c͡', '	cT\\)߉r^%6y', '', 0, '?'),
 ('^ճ{yt\\\n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/folder.js', 0, '\"+r9X`&', '\"+r9X`&', 'j|@aDmnk(18TRj1At6Fu', '', 0, '?'),
 ('&d7$_3<!^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/index.js', 0, 'u>,;JȬI<', 'u>,;JȬI<', 'kV5}\0Kɑc^j3(SRq', '', 0, '?'),
 ('tF	8aL\00\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/money.js', 0, 'Gf-|IrQ', 'Gf-|IrQ', 'nm`_H}XA\rx`Vu', '', 0, '?'),
 ('P>yRȰ.+~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/new-releases.js', 0, 'ĪU76ns|\"H', 'ĪU76ns|\"H', 'zz$?o1\r?Zqu2*}G', '', 0, '?'),
 ('bNA+k~lj$Y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/product-on-sale.js', 0, 'ur	MK+', 'ur	MK+', 'rv]qLҊ<Ix4@mj', '', 0, '?'),
 ('Ynp\rB<˿^\rJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/product-search.js', 0, '}ilDF%ؙ', '}ilDF%ؙ', 'Ɖٕ9ƥɟ)LT&', '', 0, '?'),
 ('e\"[SK', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/product-tag.js', 0, '@0`xH@|', '@0`xH@|', '!߃j+N1N%N7d4', '', 0, '?'),
 ('ʵ{	Z+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/radio-selected.js', 0, 'RKj\'ea', 'RKj\'ea', 'J/\rsV-Ximo\r5JK\nK^', '', 0, '?'),
 ('158?+q֌G', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/radio-unselected.js', 0, 'aw{bl', 'aw{bl', 'MMNv*^EHk N*q', '', 0, '?'),
 ('J\"mN%`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/reviews-by-category.js', 0, 'y!b:%Q', 'y!b:%Q', '.R4\'mdǭ<z˶3(WR', '', 0, '?'),
 ('f}\'sGY\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/reviews-by-product.js', 0, 'z7ܩh8\'', 'z7ܩh8\'', 'բQ|xeEڀ^0ҷ>d', '', 0, '?'),
 ('uccta\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/widgets.js', 0, '2\'\0lha', '2\'\0lha', 'YڰEޒѾm?/:fIt=<j', '', 0, '?'),
 ('07U3k4,]\'\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/woo.js', 0, '>rˎS!kU', '>rˎS!kU', '5og8ZXӹzS.=*ӂ(', '', 0, '?'),
 ('%oƜ#r̅5', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-attribute-term-control/index.js', 0, 'r5P{1', 'r5P{1', '*~GTxJIBK4ݵB<\'x\\$@', '', 0, '?'),
 ('Aǩ8CFF', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-category-control/index.js', 0, '[J(p5&', '[J(p5&', 'HY*z8VVqQ(򒄾+', '', 0, '?'),
 ('\'^;%q\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-control/index.js', 0, '~g`Jc1', '~g`Jc1', 'GʷgQ7k_3F|8+', '', 0, '?'),
 ('<f?4]r3D', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-orderby-control/index.js', 0, '~-Zi8>i', '~-Zi8>i', 'D$r|Y6@Zg\\\"]EbECp', '', 0, '?'),
 ('f\"\Z(XJna', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-preview/index.js', 0, '([\Zm', '([\Zm', 'Xwmn[t=tk7<$|6\nY]', '', 0, '?'),
 ('O{l.,T', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-preview/test/__snapshots__/index.js.snap', 0, 'S\0^4}&', 'S\0^4}&', 'a):ʆ/骏l[OeK', '', 0, '?'),
 ('b>(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-preview/test/index.js', 0, 'kӉV/.-\"Hc', 'kӉV/.-\"Hc', 'A%d~1s\\VM\"9u(_$I', '', 0, '?'),
 ('çf:NR/{\\]a', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-tag-control/index.js', 0, ';[Kf>ݞ', ';[Kf>ݞ', '$u\'9\n],HӀv뷷/t\0', '', 0, '?'),
 ('x|c/sDĀ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/products-control/index.js', 0, '-LF\nqn', '-LF\nqn', 'ǽPu]5Ǝ`	', '', 0, '?'),
 ('NVC<!lT\"d}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/toggle-button-control/index.js', 0, 'i]XpPH)', 'i]XpPH)', '\"aN^O-ۨ>HU}1*IZ#i? ', '', 0, '?'),
 ('Xe\"{m	N3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/utils/index.js', 0, 'ZHЅu;\0H', 'ZHЅu;\0H', '#Qs(~Dr)]a\Zaes2', '', 0, '?'),
 ('iOCʓbr', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/action-types.js', 0, 'GRE/6MĞc', 'GRE/6MĞc', '2]-b ~x()\n}Z', '', 0, '?'),
 ('Ֆ?ƟIm', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/actions.js', 0, '\\;BЂLx', '\\;BЂLx', 'ո(_,D+N5Au$q_#', '', 0, '?'),
 ('ZVL`\'Nm', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/constants.js', 0, '\rsi{b9', '\rsi{b9', ')>+ızkDyTiG', '', 0, '?'),
 ('&zvD]`쒡', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/controls.js', 0, '<GZ/Nb\"9}S', '<GZ/Nb\"9}S', '\n&OKcHK_c[IWCz', '', 0, '?'),
 (' >\0ˬ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/index.js', 0, 'UTj\\jW7)', 'UTj\\jW7)', '/>Mr\"ua$n\rZ{O9L	0', '', 0, '?'),
 ('c]J_\'GԔ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/reducers.js', 0, '.JA%\Z', '.JA%\Z', 'oehb2+;>S<\nDy<q', '', 0, '?'),
 ('pv ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/resolvers.js', 0, 'E&r)Afts', 'E&r)Afts', '1CO\\Av$6kiX|', '', 0, '?'),
 (';)\"FAK', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/selectors.js', 0, 'dg#dwc', 'dg#dwc', 'yt8T<\'\0{]4', '', 0, '?'),
 ('_+,6·+&^(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/test/reducers.js', 0, '[u؈PDnknh', '[u؈PDnknh', '\rB+߇)ߏAb5	uh\0lȭq', '', 0, '?'),
 ('oxyY%', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/test/resolvers.js', 0, 'FQݽyDM2nn', 'FQݽyDM2nn', '\nfZsbuQ1!DRJ)O', '', 0, '?'),
 ('24[[㡭?', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/test/selectors.js', 0, 'Tx>6q', 'Tx>6q', 'Ժ=rXfs\r.HE}f', '', 0, '?'),
 ('4%P迪', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/constants.js', 0, 'vkl5', 'vkl5', 'V\"MM\nQsgYL<#`', '', 0, '?'),
 ('-4Mbg=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/index.js', 0, 'N|phj(L', 'N|phj(L', '\nA2(5Ը3p1jլM', '', 0, '?'),
 ('y]Zy', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/action-types.js', 0, 'j', 'j', 'Pz`*OҔvڅM', '', 0, '?'),
 ('cj(zVHQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/actions.js', 0, 'ME[~\'\']>', 'ME[~\'\']>', 'Bg%z5ܘG6HPb`҄', '', 0, '?'),
 ('SQ[&', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/constants.js', 0, 'ә0>M(&4', 'ә0>M(&4', '2*.\Z/kqwk5\'ߠʧǭ', '', 0, '?'),
 ('9*T#', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/index.js', 0, '{z	XwkD', '{z	XwkD', '-BONJrw-!sKlCP +.', '', 0, '?'),
 ('oqg&ƙ7pe_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/reducers.js', 0, 'V	\Z\Z', 'V	\Z\Z', '\ry\0}5÷ A!z	/l?', '', 0, '?'),
 ('M\Zxn_\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/selectors.js', 0, '5\Zǣ\'ƁJ4', '5\Zǣ\'ƁJ4', '$]7MXJw9g\Zߺt(mM)q:', '', 0, '?'),
 ('~Om[Ga,', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/test/reducers.js', 0, 'o(*().', 'o(*().', '`Eʎ6 \'.?Ͱ!NvMs', '', 0, '?'),
 ('pē~݊u9Q{Q`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/test/selectors.js', 0, 'Q8_)_K\0', 'Q8_)_K\0', 'l?Z!/$9`Ϊ7A}N', '', 0, '?'),
 ('4D6bS', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/utils.js', 0, 'vv2	6Ori', 'vv2	6Ori', 'Ú \Zw7.\\Sk+N4', '', 0, '?'),
 ('?ا(T%\nS', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/action-types.js', 0, ']o\ZuS', ']o\ZuS', 'P;F߭7?&\0q6̦K~Ϟ#', '', 0, '?'),
 ('gOx/=<P', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/actions.js', 0, '	jHRZ', '	jHRZ', '(ذ_+H}yx{\'S<z\Z', '', 0, '?'),
 ('c9Z-޹', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/constants.js', 0, 'B\nʵ)歜', 'B\nʵ)歜', 'nb>*G\"?C>˕6BD', '', 0, '?'),
 ('du\\da?', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/index.js', 0, 'tQ{;l~Eey\0', 'tQ{;l~Eey\0', '(rlZD#H\r]m0_K=E	$P', '', 0, '?'),
 (';f<grI>l0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/reducers.js', 0, '\Z\rGQ\\[', '\Z\rGQ\\[', 'X9âzo|!\rs?r', '', 0, '?'),
 ('1s>L/\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/resolvers.js', 0, ' }5', ' }5', 'n\\q]?ՏJp7we=_4Y', '', 0, '?'),
 (':XGq\rg', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/selectors.js', 0, 'h\ndGݑ}', 'h\ndGݑ}', 'v|<S\'\r}`WYu=d;9', '', 0, '?'),
 ('ƔtSyN&Q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/reducers.js', 0, '$!?H', '$!?H', 'уgvP*Zu ך	7FLfZ', '', 0, '?'),
 ('#מ<3:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/resolvers.js', 0, '_9@PX\"', '_9@PX\"', '~I@vNw|ꎯ;vm\'S', '', 0, '?'),
 ('9+At^uI|R', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/selectors.js', 0, '^mcU)R', '^mcU)R', 'qXh7P0k+j8q6', '', 0, '?'),
 ('1X7%[\0X?X*', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/utils.js', 0, '\Z͆-\n\'~)B', '\Z͆-\n\'~)B', 'skK-@6\Z26&e1v', '', 0, '?'),
 ('|^^?^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/utils.js', 0, '𯀑#+x', '𯀑#+x', 'Vlw5[!pz%*A', '', 0, '?'),
 ('$tp/U\"=W', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/utils/has-in-state.js', 0, '\\Xがwo,', '\\Xがwo,', 'aFU\\Yh`r8rW0`cdf7', '', 0, '?'),
 ('vmNae/KJB', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/utils/index.js', 0, ';\\/Zx', ';\\/Zx', '$m[<8@&BNw,lq', '', 0, '?'),
 (' {y0]8\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/utils/update-state.js', 0, 'VvJ({Pp', 'VvJ({Pp', '/R!hY-cbV.+ϊzLJ', '', 0, '?'),
 ('{\0*x', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/index.js', 0, '␛-(\r', '␛-(\r', 'ڣ惡uxQeӤEM|M)EpI7', '', 0, '?'),
 ('7SsF', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-attributes.js', 0, 'O3O+CT', 'O3O+CT', 'ؑ07;R;AU̱>K-_\0', '', 0, '?'),
 ('AB07X9Y{oK', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-categories.js', 0, '瀛Һ>-', '瀛Һ>-', '&ŞXrY7	RoJF\Z', '', 0, '?'),
 ('LBs3py?', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-category.js', 0, '\r;HL', '\r;HL', 'ו0,Ե%\Z	dc\\\"', '', 0, '?'),
 ('W\r,JIq', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-product-variations.js', 0, '~e8&*kk7Ed', '~e8&*kk7Ed', 'F4js6Ty&WyT(m8R.', '', 0, '?'),
 ('EJE}8b7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-product.js', 0, ' K|=h\rT', ' K|=h\rT', '7(`ySI`=ΙVuz=TP', '', 0, '?'),
 ('vX\ZbAbkⓂ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-searched-products.js', 0, 'u$X!2R', 'u$X!2R', ',psP|e?qJ', '', 0, '?'),
 ('tEMWK$FFsG', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-transform-single-select-to-multiple-select.js', 0, 'ݿmSd#i', 'ݿmSd#i', '	ݪdg4oE_3\'yMC}_/', '', 0, '?'),
 ('e{|6', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-attributes.js', 0, 's*7X9nK', 's*7X9nK', 'dBˠyXx+/Ҁ9', '', 0, '?'),
 ('wY\05&\'/&Y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-categories.js', 0, '9rʗnn8u\Z`', '9rʗnn8u\Z`', '1SBGcǸpBD.T\n@', '', 0, '?'),
 ('E*PAvYS؅', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-category.js', 0, 'PH15<z׍WB', 'PH15<z׍WB', '7n1=.{Gh/2e3', '', 0, '?'),
 ('9f5x ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-product-variations.js', 0, '\"Ǐg<E', '\"Ǐg<E', ':Dw¿ӫL_3(\ZWUw', '', 0, '?'),
 ('hAbLyn', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-product.js', 0, 'sGG毌ݳS', 'sGG毌ݳS', '\\9HXY@j?η', '', 0, '?'),
 (',yp$H	$C', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-rest-api-hydration.js', 0, ':YoTl<ʯ', ':YoTl<ʯ', '<@\'\0dOp5#\0E\Zu-^3д$', '', 0, '?'),
 ('~#S9F\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-searched-products.js', 0, 'H/ΉƭX', 'H/ΉƭX', 'o,/ L;nb0	!_%F݊U', '', 0, '?'),
 ('=nNs<Ҕ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-transform-single-select-to-multiple-select.js', 0, '5\rꝊ\nNѠd', '5\rꝊ\nNѠd', '|ܘ>QP?|eiۄYoP{C6', '', 0, '?'),
 ('*9g6^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/index.js', 0, '$r%', '$r%', '˂YG:w0SKa?Y;sUN', '', 0, '?'),
 ('vPL-?|gAUS', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/categories.js', 0, 'I\"@-n', 'I\"@-n', 'lFhPa˒ŗ ]ȫ`T', '', 0, '?'),
 ('KAX,b;\r/.4.A^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/grid-block.js', 0, 'CDT DjI@.', 'CDT DjI@.', '\0wx8`QGm3', '', 0, '?'),
 ('Ǒ\rl}y2f', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/index.js', 0, '6--V', '6--V', '\0\rfV쀠%L#ʊ.Xُ', '', 0, '?'),
 ('6\\\0srmq\nb', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/products.js', 0, '3.[\'<-mTbI', '3.[\'<-mTbI', 'Kn6s;\ZWOǀB3N', '', 0, '?'),
 ('3j|nO', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/reviews.js', 0, '->+,iI', '->+,iI', 'rr|>5Qi&O', '', 0, '?'),
 ('~]ނ-WlHG', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/blocks/constants.js', 0, 'XfvMT~', 'XfvMT~', 'x:-4N_:08ޟ.KuN~', '', 0, '?'),
 ('ha4ks(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/blocks/endpoints.js', 0, ',E8}畞', ',E8}畞', '\r+om~dӧJ-\'', '', 0, '?'),
 ('p8쬏W', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/blocks/index.js', 0, '>^X+LUgmg', '>^X+LUgmg', ';X*Vjsm5M<),&xN', '', 0, '?'),
 ('\\lvJHg݃p', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/default-constants.js', 0, 'a)3<', 'a)3<', '8m;/GQmaqp^L$#ӫv', '', 0, '?'),
 ('Ͳ48\\yj̗\0<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/get-setting.js', 0, 'cQxX\rUh', 'cQxX\rUh', '6ZC8T{ͨeY+R8PЭ.$7f', '', 0, '?'),
 ('RH$?2m', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/index.js', 0, '\"횧KֻUD', '\"횧KֻUD', 'I:U-q݂-_F !G', '', 0, '?'),
 ('[9YW\"*', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/set-setting.js', 0, 'ς㌱xx@', 'ς㌱xx@', 'a#}?j {0,I,kSVzr', '', 0, '?'),
 ('&\0?(<u#\0ʪ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/settings-init.js', 0, '0RU\Zu', '0RU\Zu', '~*hǺ/.(h:Dτ', '', 0, '?'),
 ('{8Mx', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/test/compare-with-wp-version.js', 0, '@xp,+', '@xp,+', ':0\0ĝcTt+16N4^1D', '', 0, '?'),
 ('E*\rNN\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/test/get-setting.js', 0, ' Fp+T7|z', ' Fp+T7|z', 'c\0E{x>e9\ZJg0/fY->', '', 0, '?'),
 ('$ɲ쮠mŘ7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/test/set-setting.js', 0, 'Mx.ƖK76n', 'Mx.ƖK76n', 'Eqi\rGnv0YevI', '', 0, '?'),
 ('yMB4p8', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/attributes-query.js', 0, '`a@<!\n5', '`a@<!\n5', 'U:rt}ڍu#?[?kz%', '', 0, '?'),
 ('\Z2Zl:ض\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/attributes.js', 0, '>\rLE:Wl', '>\rLE:Wl', '%FDfeEnP7B*\n:FW', '', 0, '?'),
 ('!}BK|8Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/deprecations.js', 0, 'Ei-4	', 'Ei-4	', 'RcU|*QؾC޹h.Pt4y', '', 0, '?'),
 ('zΝ:Se', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/get-query.js', 0, '6Fpޫ\n+u9VD', '6Fpޫ\n+u9VD', '$BjH6r5mAOGJUX2g^', '', 0, '?'),
 ('xT\nҧ<vn9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/get-shortcode.js', 0, '=FLs#D^', '=FLs#D^', ']S縉<$-Rz0KUcI_', '', 0, '?'),
 ('ű噔XLzq*+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/products.js', 0, 'Fg\\\\a5Jx', 'Fg\\\\a5Jx', '/q^}%wJyZU:BK', '', 0, '?'),
 ('SAJ@_ ,', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/render-frontend.js', 0, 'tM4\Z474/', 'tM4\Z474/', 'x\Z!\"̷\"|k.#eli+Yɟ', '', 0, '?'),
 ('F(]O*Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/shared-attributes.js', 0, 'vg]%', 'vg]%', '<}Q[를@f$\0*', '', 0, '?'),
 ('%%#aޖP', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/test/get-query.js', 0, '6P>~fq', '6P>~fq', '|­\Z@ˋ=k,Hcaݓ\"͌;_', '', 0, '?'),
 ('j60ͫ\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/test/products.js', 0, 'w_Y?~]y[V', 'w_Y?~]y[V', '[\0c1[\Zlt\rUv[ ', '', 0, '?'),
 ('\rw=\0\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/active-filters-frontend.js', 0, 'PIlvOdnR', 'PIlvOdnR', 'iGI	sx8K-Yʦ', '', 0, '?'),
 ('wph', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/active-filters.js', 0, '1iMBjXG', '1iMBjXG', 'm:Ŧ6\nF\'0_Q', '', 0, '?'),
 ('D\nɏ`М{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-products-frontend.js', 0, 'OB@.yv\ZY', 'OB@.yv\ZY', 'F+V2W:sJ8\nXS Ya', '', 0, '?'),
 ('bZI:\\{y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-products.js', 0, '~_z1.Sf', '~_z1.Sf', 'vUvc˳%\r3ƥt}*<b9MZH', '', 0, '?'),
 ('}+f˖<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-reviews-legacy.js', 0, '\rZhQT', '\rZhQT', '3/Χ\\Oq2>nNJ', '', 0, '?'),
 ('@{G<=B', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-reviews.js', 0, 'FA4iz^q(p', 'FA4iz^q(p', 'SXmOA@BE=SiH.r&9Y', '', 0, '?'),
 ('621(\"!~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/attribute-filter-frontend.js', 0, 's\"\0,-;\Z', 's\"\0,-;\Z', '-co!C<+XA8V;', '', 0, '?'),
 ('c!_Ib>u`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/attribute-filter.js', 0, '޴M4ƍ\\#', '޴M4ƍ\\#', 'W,T5kc|9ZACVdF5\'H', '', 0, '?'),
 ('(G)#~f`Up', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/block-error-boundary-legacy.js', 0, ']yLQ', ']yLQ', '48$EH~\\-0 2bWyH', '', 0, '?'),
 ('~chpz躟W', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/block-error-boundary.js', 0, '5q`h{Q', '5q`h{Q', '=W8EC0̥ݧnUIDr$', '', 0, '?'),
 ('t\nrz', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/blocks-legacy.js', 0, 'f!', 'f!', 'LWRQ(Ql0hv>`', '', 0, '?'),
 ('rQ}ll;c1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/blocks.js', 0, 'l&IƶQvX+', 'l&IƶQvX+', 'eH},|52}=a;Xj,\\x', '', 0, '?'),
 ('h3IRD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-category-legacy.js', 0, 'Q)i\r7i7M@', 'Q)i\r7i7M@', 'LRAkoc)t[M	N+L0', '', 0, '?'),
 ('_/K*', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-category.js', 0, '	|	g?f1', '	|	g?f1', '#e_0R̤(e<Pٷ laX', '', 0, '?'),
 ('D6<^,O<,(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-product-legacy.js', 0, 'ۅiίL`', 'ۅiίL`', 'jΜ`uq\0}f=fTpU17', '', 0, '?'),
 ('\nK(f\"CէKR', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-product.js', 0, '-ev笖įr', '-ev笖įr', '$tI3U+v\\|]zR*&e', '', 0, '?'),
 ('$Il Ht::', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/handpicked-products-legacy.js', 0, 'jwaJ3', 'jwaJ3', '|H._w.d@d#9@iT2v', '', 0, '?'),
 ('GUۈb16&)wː', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/handpicked-products.js', 0, '2W8re`', '2W8re`', 'g4\Z^2KRءf,Du', '', 0, '?'),
 ('l(Ԡp<OrE', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/price-filter-frontend.js', 0, '#1r܁', '#1r܁', 'ua;)do94maIy', '', 0, '?'),
 ('Uh$M6+{E[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/price-filter.js', 0, '2<g', '2<g', '1.u7CN;h?5k~0:', '', 0, '?'),
 ('?GХd\r}1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-best-sellers-legacy.js', 0, 'RgQ', 'RgQ', 'ZYu/>?@Vݸ^pfhbH%Մ', '', 0, '?'),
 ('+ȷ(Zc', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-best-sellers.js', 0, 'teTU', 'teTU', '3|c)G&$n\'̆#B1(_0', '', 0, '?'),
 ('8#nz7RHR', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-categories-legacy.js', 0, '%S7G[', '%S7G[', 'ﱶ}&n*]+2]?7wC4', '', 0, '?'),
 ('4]ـn1\Z3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-categories.js', 0, 'TJ@&`', 'TJ@&`', '>ʱoTywcm$MH:1', '', 0, '?'),
 ('R򓹮<q\\6l', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-category-legacy.js', 0, 'z^M^Tu', 'z^M^Tu', '6ώok:G-05v;wz', '', 0, '?'),
 ('Ͼ2mf8', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-category.js', 0, 'FaMxqPE?\'', 'FaMxqPE?\'', '+cz>2QQ	Щ#˴t:־V', '', 0, '?'),
 ('y;܃,>ՎS9ZM', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-new-legacy.js', 0, '4:dõshP', '4:dõshP', 'ۑċcy߳BjPÈ~=Nx{', '', 0, '?'),
 ('gW$h\r2w', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-new.js', 0, 'n Qjppr', 'n Qjppr', 'xO$\' Od!jD\Z', '', 0, '?'),
 ('ZRH׺Q.R1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-on-sale-legacy.js', 0, 'Cם\0r`', 'Cם\0r`', '4iA-[ߠR:خ\r% U_rPq', '', 0, '?'),
 ('XyQ(.tZHY', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-on-sale.js', 0, 'sC-}\\&Sy', 'sC-}\\&Sy', 'P_$[2ݱ?m(1*6xOqp', '', 0, '?'),
 ('l,w%FڎJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-search-legacy.js', 0, 'δH`nl%Pd', 'δH`nl%Pd', 'zF:`Csϸ,v7\\bb', '', 0, '?'),
 ('Zx[c{t	{d*', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-search.js', 0, '\"۵`[j^', '\"۵`[j^', '}U9URصkb\nu#{B', '', 0, '?'),
 ('PQ\"Y{R^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-tag-legacy.js', 0, '7]@\":xW9(', '7]@\":xW9(', '6V	yLc(!bB^H', '', 0, '?'),
 (',B.|4t', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-tag.js', 0, '7iLU', '7iLU', ' `;y~9\\Dc9rFUE,@N', '', 0, '?'),
 ('\\Ds}H&', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-top-rated-legacy.js', 0, '_2[P>Փ', '_2[P>Փ', '0머:`.M`S߀I$', '', 0, '?'),
 ('D9rT@嬤', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-top-rated.js', 0, 'ΌkR50~', 'ΌkR50~', 'jݱ}ybE?aVxI)6Xz', '', 0, '?'),
 (']qL<?Ҁ[;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/products-by-attribute-legacy.js', 0, '\'e\rBF', '\'e\rBF', 'm9j֗SgT[\\-^__U', '', 0, '?'),
 ('GB^ b˸', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/products-by-attribute.js', 0, 'bf:yPl', 'bf:yPl', 'dh*Ds+Ut\n@M6$T', '', 0, '?'),
 ('.Ͻ;ꟲY', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-category-legacy.js', 0, 'B⩰>3u', 'B⩰>3u', 's&]s!m}=xJL`@p\\sۣ', '', 0, '?'),
 ('ёLG8P=v>U', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-category.js', 0, '#8&?tl', '#8&?tl', '!W_iџ3HF8C	U', '', 0, '?'),
 ('ǅщEZȨ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-product-legacy.js', 0, '\"b뜺P=', '\"b뜺P=', 'K/FL\0ۆɒ\\TX(Q<', '', 0, '?'),
 ('oxR)k« ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-product.js', 0, 'is?ya3', 'is?ya3', 'Q6/J)\'UYC*ʿ^O', '', 0, '?'),
 ('N;4`cv@𲔬^}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-frontend-legacy.js', 0, 'v0ZHK', 'v0ZHK', 'T_R}V]掿߁>y\r93l-@Uz', '', 0, '?'),
 ('G-xi󣸁1_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-frontend.js', 0, 'n(uZ6\07', 'n(uZ6\07', 'qxb|V:J3y=#D	xP5`Iim', '', 0, '?'),
 ('$ǭH', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/vendors-legacy.js', 0, '\"Ҟ\'ߡ!H', '\"Ҟ\'ߡ!H', '樁V$썧xv?Ґ{', '', 0, '?'),
 (')K-Buo', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/vendors.js', 0, '?=mӬ	jb', '?=mӬ	jb', 'Xca^yƹӰm)sˮd<\\', '', 0, '?'),
 ('U#x~RgL[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/wc-blocks-data.js', 0, 'BD-o`su', 'BD-o`su', 'pැtF\"ݲYn~]i8;ŎV', '', 0, '?'),
 ('V!\'gI', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/wc-blocks-registry.js', 0, 'ᑺ%[)i\0xM=+1', 'ᑺ%[)i\0xM=+1', 'c3xĐR|#M3^.', '', 0, '?'),
 ('*Axmת짓', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/wc-settings.js', 0, 'Iw\0]', 'Iw\0]', 'oQ^f.?a-sM_', '', 0, '?'),
 ('Q>Uv|\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets/Api.php', 0, 'DHdo\'', 'DHdo\'', 'Gu#edh>_]b+\r]\r0D', '', 0, '?'),
 ('\"\"Sf!4]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets/AssetDataRegistry.php', 0, '\"!1+&+l', '\"!1+&+l', 'SS8+ׅysm#K&A', '', 0, '?'),
 ('y\rzgj\0?', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets/BackCompatAssetDataRegistry.php', 0, '{ń`r.Hw/', '{ń`r.Hw/', 'v{w?51wͽ4g\rx>I', '', 0, '?'),
 ('r\\\Z/<{Bf', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets.php', 0, 'ݟ85/;i', 'ݟ85/;i', '7YwA?)V|s3Pz᪫ܨc', '', 0, '?'),
 ('?=źM*mtn', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AbstractBlock.php', 0, 'l;yґt]w', 'l;yґt]w', 'qb|7l]Kkʮ:\"8y-I', '', 0, '?'),
 ('\rp>F0J', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AbstractDynamicBlock.php', 0, 't#S?qC]aܨz', 't#S?qC]aܨz', 'W(@^!\n?v6\'FʛWU', '', 0, '?'),
 ('\\RK׏.󰆫!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AbstractProductGrid.php', 0, 'vm	', 'vm	', ']Y&aߋ_7@,/)B?q)k', '', 0, '?'),
 (',NzJlsMR\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ActiveFilters.php', 0, '`ŉN&0S;a3,', '`ŉN&0S;a3,', '4-@\Z~$>T', '', 0, '?'),
 ('IO1\ZԦ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AllProducts.php', 0, '/\r.9\r', '/\r.9\r', 'C.L_#js)*.:֋(<zM', '', 0, '?'),
 ('u3o¹Wrc', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AllReviews.php', 0, 'H\0TJ(bN', 'H\0TJ(bN', '[MAsZ@0X7T*\\I', '', 0, '?'),
 ('*=rw1\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AttributeFilter.php', 0, '|VD*TP', '|VD*TP', 'U#x3\Zn}{Ys˵$ȗ<', '', 0, '?'),
 ('4Eƾ.V', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/FeaturedCategory.php', 0, '7Ak1fw', '7Ak1fw', 'a$24⫹!D*ȂRa+;', '', 0, '?'),
 ('֍9CjmX', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/FeaturedProduct.php', 0, 'SVղ!Ƅ|', 'SVղ!Ƅ|', 'Vn](,\rc6`\'I~-G', '', 0, '?'),
 ('bKUNhWZ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/HandpickedProducts.php', 0, 'x @%]#r/', 'x @%]#r/', 'i%/h8][޼P\0^W\r(', '', 0, '?'),
 (',7I,2ar', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/PriceFilter.php', 0, '\rU48ZI', '\rU48ZI', 'ǟdU[dUD{SI_zj8e', '', 0, '?'),
 ('Jub^r.', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductBestSellers.php', 0, '9W>wP', '9W>wP', ' _]	\ny  2qR6,s+S{', '', 0, '?'),
 ('PR_ƻD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductCategories.php', 0, '\'ƶ8ͰfPWa', '\'ƶ8ͰfPWa', 's͌\nC=V{\08Y', '', 0, '?'),
 (':*g)Gĩqsm', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductCategory.php', 0, 'c]|INº', 'c]|INº', ']\\#U_:Lx@w3)(tGo', '', 0, '?'),
 ('$e8Ǣ)Q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductNew.php', 0, 'Y!(Q5Gח^', 'Y!(Q5Gח^', 'm,vN_+lR%', '', 0, '?'),
 ('$xhӋ\n,', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductOnSale.php', 0, 'ZKOblsN', 'ZKOblsN', '7leq#NQId>uIX1', '', 0, '?'),
 ('=ɡĆ<Tث', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductSearch.php', 0, 'jHel+', 'jHel+', 'ikOׯ\Z+	,ivWe', '', 0, '?'),
 ('.\\MŚ[0k\"]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductTag.php', 0, '\"]EhHWa', '\"]EhHWa', 'J4ŧ^NN,ਧkFF]\\', '', 0, '?'),
 ('kLS	&Ҍ:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductTopRated.php', 0, '7vC)y&w:W', '7vC)y&w:W', 'ĤRtGd{vO=E&%.0r', '', 0, '?'),
 ('o8y\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductsByAttribute.php', 0, 'آ}Y', 'آ}Y', 'XbGO&2fo={~12Bw', '', 0, '?'),
 ('mM\n]>PIgQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ReviewsByCategory.php', 0, '㵨ʘ4', '㵨ʘ4', '9|tE;ΰv\'\n', '', 0, '?'),
 ('5X7a9MW', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ReviewsByProduct.php', 0, 'S+6LӦc', 'S+6LӦc', '4]x\ZJG#\'@6', '', 0, '?'),
 ('~gOT36&֫zD ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Domain/Bootstrap.php', 0, 'QE\n`0U.h', 'QE\n`0U.h', '0йo.k-_\0ԫ\"', '', 0, '?'),
 ('Is+e;#+(.H\n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Domain/Package.php', 0, 'Deҗ#0 ', 'Deҗ#0 ', 'BO>ieQyML<\ZFrIKqg', '', 0, '?'),
 ('|쳅X', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Library.php', 0, 'z.M%*', 'z.M%*', '1PX-Z0ycea', '', 0, '?'),
 ('\"FFp6v\Zu', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Package.php', 0, 'x?qV=I%hT', 'x?qV=I%hT', '\ZWH=ֵPκr,l[-+', '', 0, '?'),
 ('5?$gNd=\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/AbstractDependencyType.php', 0, '}ֻ;u\0&c½`(', '}ֻ;u\0&c½`(', 'Csф뷸Z3vgtݡutɗG', '', 0, '?'),
 ('eCp\"l?S{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/Container.php', 0, ',Kt', ',Kt', '5kt)lA.D	[', '', 0, '?'),
 ('9qe0䫟', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/FactoryType.php', 0, ':I:ÀO+rL', ':I:ÀO+rL', 'qfB@Gus)\rrugǆ`Gy|', '', 0, '?'),
 ('#c/R}24', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/SharedType.php', 0, '+w[K1g', '+w[K1g', 'Qtӷ\nv*?ZL~6͑24Q\r', '', 0, '?'),
 ('f?D{=Qpz', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/Cart.php', 0, '\nZ\"$Y%I', '\nZ\"$Y%I', '{L/Pn<5c2`ё', '', 0, '?'),
 ('\nB4%lYR&', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductAttributeTerms.php', 0, 'V&[!1B3d', 'V&[!1B3d', 'oGš?#\\4CD', '', 0, '?'),
 ('w[-x?J~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductAttributes.php', 0, 'X꺰[L\Z', 'X꺰[L\Z', '\'0``-)(q:S;Eax', '', 0, '?'),
 ('U*</+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductCategories.php', 0, '>Ѽ{I[', '>Ѽ{I[', '\Zc;\0-\n?A8m', '', 0, '?'),
 ('dĜ~3G	', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductReviews.php', 0, 'pFqh^?P\'D', 'pFqh^?P\'D', 'ENwe2\0ZP\Z\\fIC', '', 0, '?'),
 ('X&a۞&', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductTags.php', 0, '܄uֱPa`', '܄uֱPa`', 'Ū3$T)l۬k(򌈦;', '', 0, '?'),
 ('|G+//P:d', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/Products.php', 0, 'eATB\\\Z', 'eATB\\\Z', 't&0e\\.xL|oU5S,^\\>', '', 0, '?'),
 ('j1\0M-JiƔ<B', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/Variations.php', 0, '֏xX˘MZ7r', '֏xX˘MZ7r', 'c>;%R2M-\nZ!%uI', '', 0, '?'),
 ('?eU~\r瘿e', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/Cart.php', 0, '9X[!tsJt', '9X[!tsJt', 'i)%9V)\r|EʢJy', '', 0, '?'),
 ('2*.7G@]9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/CartItems.php', 0, '`aOCOz]', '`aOCOz]', 'oȄǛ8B@s2 ', '', 0, '?'),
 ('СHhoʮi{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/ProductAttributeTerms.php', 0, 'Z\"n(02', 'Z\"n(02', '?\\\ror\rŕfjg\rA厞آ', '', 0, '?'),
 ('ni#,NxB ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/ProductAttributes.php', 0, '@^&8', '@^&8', 'y0E68o-D܏U0fCR', '', 0, '?'),
 ('֒H:86c̣', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/ProductCollectionData.php', 0, 'Y:vFQD', 'Y:vFQD', '\\֦LȇlNnHa	', '', 0, '?'),
 ('4!9# :*4', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/Products.php', 0, '?̕0?\0D6', '?̕0?\0D6', 'TXܡ1VCz5o}_', '', 0, '?'),
 ('?Ԍ%{.fз', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/AbstractSchema.php', 0, 'pDϚiWn2Y_g', 'pDϚiWn2Y_g', '5]dq2}>ԙ;`', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('I*ak', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/CartItemSchema.php', 0, 'Fnb\"wº	', 'Fnb\"wº	', 'T\'|G[RՕ\'l+6L{@;', '', 0, '?'),
 ('{~\0CΫX', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/CartSchema.php', 0, '8;\r|t', '8;\r|t', '\'f8%eȨФfkZ', '', 0, '?'),
 ('V.9gCCs;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/ProductAttributeSchema.php', 0, 'pGFH`nm', 'pGFH`nm', '>fƲJ0n1\'75\rTV.', '', 0, '?'),
 ('jܗxέJR`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/ProductSchema.php', 0, 'LRRhM\r', 'LRRhM\r', '?-\0慁LVQPT', '', 0, '?'),
 ('|k~Ojq ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/TermSchema.php', 0, 'mL,hAjI܀', 'mL,hAjI܀', 'og~u+=YXIzRPJDb', '', 0, '?'),
 ('fCn^PJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/CartController.php', 0, '2Z_pwO', '2Z_pwO', 'SOlA{?;ch$UO7', '', 0, '?'),
 ('y,eKsaoȕ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/Pagination.php', 0, '#aU', '#aU', '9Dz!H\rt@tٕT7 ]#w', '', 0, '?'),
 ('o|}Kh0`d0 ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/ProductFiltering.php', 0, '!+bݕC5[', '!+bݕC5[', 'cR*&w*_w0cCk', '', 0, '?'),
 ('*\rVPu.a', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/ProductQuery.php', 0, '\n&5eUh', '\n&5eUh', 'UM|V%aTMcji[6', '', 0, '?'),
 ('1H;Ua{Cݢ~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/TermQuery.php', 0, '5\ZO\'X ', '5\ZO\'X ', '+9?g\\>:0/C-;\n\"f#s', '', 0, '?'),
 ('^s1i9%J%', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Utilities/ProductImages.php', 0, '6-}N', '6-}N', '_Uv<D<;7;Dh6>3eY', '', 0, '?'),
 ('q۽=3{(9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi.php', 0, 'qy*@$jG,', 'qy*@$jG,', 'wjl~4n̿7}f`', '', 0, '?'),
 ('`nʻyuŝ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Utils/BlocksWpQuery.php', 0, '{\"\0ÁJx', '{\"\0ÁJx', 'HnNv8xK+4t뀮', '', 0, '?'),
 ('$#\"yU=.y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/autoload.php', 0, 'EϰW@8', 'EϰW@8', 'y+,K牡\\ZE0+,', '', 0, '?'),
 ('GT_4?0r\Z/0K', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/autoload_packages.php', 0, 'F\rH͒. ', 'F\rH͒. ', 'K/S·a754rc)mmqhߝ', '', 0, '?'),
 ('|;1+~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/automattic/jetpack-autoloader/src/AutoloadGenerator.php', 0, '߬	Ew[kL_\Z', '߬	Ew[kL_\Z', '7c(x\n2奵T6Ƞ+?2C', '', 0, '?'),
 ('S	\n\Z%\\^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/automattic/jetpack-autoloader/src/CustomAutoloaderPlugin.php', 0, '\Zx}~\'SBȁ_=it', '\Zx}~\'SBȁ_=it', 'LOd&mtҸsR<ÜY', '', 0, '?'),
 ('o|3AtH', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/automattic/jetpack-autoloader/src/autoload.php', 0, 'H 0\\pѨ5NGS', 'H 0\\pѨ5NGS', 'haiw1$똂:OR#g*or/', '', 0, '?'),
 ('q$gV@E\Z,v\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/ClassLoader.php', 0, '|%*T*`', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 ('8,]v,', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_classmap.php', 0, 'EӤ㭇Mg', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 (']a:.8;-m', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_classmap_package.php', 0, '/q]H1e(', '/q]H1e(', 'ړm\0`N+׹ժG', '', 0, '?'),
 ('#6!/\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_namespaces.php', 0, '5,}vĨ3G)', '5,}vĨ3G)', 'Er4@\0ԡ$z3$l\Z`iexl', '', 0, '?'),
 ('QP.%<S', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_psr4.php', 0, 'SPm`#\Z', 'SPm`#\Z', ')._QJ}$0>)@=;d\'_', '', 0, '?'),
 (',,CaKn>', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_real.php', 0, '@s{j]H״', '@s{j]H״', 'p;J6x1AUPj', '', 0, '?'),
 ('f\\\ZJ\Z)L;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_static.php', 0, 'O2.ݝ_B', 'O2.ݝ_B', '[6m\rMbƌ\0\ZRͪ1t', '', 0, '?'),
 ('i={1ze', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AglInstaller.php', 0, 'Cc=W*Dg', 'Cc=W*Dg', '3(W~;M<dz4', '', 0, '?'),
 ('aMj҉)', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AimeosInstaller.php', 0, 'EWMi6=<*@}m', 'EWMi6=<*@}m', 'DRV\\ŭ<7ty	,8YmL', '', 0, '?'),
 ('c$\"`y)', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AnnotateCmsInstaller.php', 0, '1csDh%[p!4\"', '1csDh%[p!4\"', ';<EU%HwDDˋ8T', '', 0, '?'),
 ('؄o:fnz\nO', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AsgardInstaller.php', 0, 'LJM', 'LJM', 'V\n#\nA@,c]:a# a\n&7', '', 0, '?'),
 ('.2_넢iB', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AttogramInstaller.php', 0, 'oGE\r', 'oGE\r', '}DlqX\"aGGuVX}=', '', 0, '?'),
 ('ByLUڶa', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/BaseInstaller.php', 0, '!mV9q}', '!mV9q}', 't.tX@iZT7&\\&-Yd', '', 0, '?'),
 ('*Ǣßd', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/BitrixInstaller.php', 0, 'h!fŪe%Q', 'h!fŪe%Q', 'XTQms`DPç,|쫺d8', '', 0, '?'),
 ('\rC.Ŷ	bF\'7', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/BonefishInstaller.php', 0, 'u\".O	\"O-B', 'u\".O	\"O-B', '`Ś睤ybktBI', '', 0, '?'),
 (':+g\"v+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CakePHPInstaller.php', 0, '6k_sx', '6k_sx', 'h;[8{ܠ^xx\r', '', 0, '?'),
 ('\'UM\"7y,a ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ChefInstaller.php', 0, 't&r@;f', 't&r@;f', 'iifzΰP\\B<Wٴp2,T', '', 0, '?'),
 ('CѠK', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CiviCrmInstaller.php', 0, 'eSu-՘}', 'eSu-՘}', 'ix_Kn&F:ra0', '', 0, '?'),
 ('j\\}UYו$4', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ClanCatsFrameworkInstaller.php', 0, '՝Vo5ڐ\\', '՝Vo5ڐ\\', '>9Y\rYOC4huG[', '', 0, '?'),
 ('Gv5ӕL ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CockpitInstaller.php', 0, '֗6>,!', '֗6>,!', 'Sſ`0$ RW>c:5ΚMä', '', 0, '?'),
 ('\":RwoSs', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CodeIgniterInstaller.php', 0, 'H=u]R9', 'H=u]R9', 'Km}DS7ښL<ya', '', 0, '?'),
 ('pʯ\\=@5i,;o', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Concrete5Installer.php', 0, 't	m!~A^S', 't	m!~A^S', '#L?OM6r/W_~', '', 0, '?'),
 ('}3\\LWGbx', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CraftInstaller.php', 0, 'إg]b', 'إg]b', 'gD>IB9LI	*1160C|', '', 0, '?'),
 ('1w[#V[zG', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CroogoInstaller.php', 0, 'AvE\"M\\M', 'AvE\"M\\M', '4(eI892-뱎ļ~]', '', 0, '?'),
 (')՜d', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DecibelInstaller.php', 0, '+r\"`lҮvv', '+r\"`lҮvv', '#5}͏	\\fWİ~C`Oc,', '', 0, '?'),
 ('FID)z\"Ϯ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DframeInstaller.php', 0, ';<JE&$dc', ';<JE&$dc', 'q%>D$$:jk z;', '', 0, '?'),
 ('46P݌ٯJ绕', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DokuWikiInstaller.php', 0, '}=%7\\8V', '}=%7\\8V', 'wHp[w2@u\Z\"LHa6Q', '', 0, '?'),
 ('\'{CVdd+!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DolibarrInstaller.php', 0, '	m_d&Ժ0w', '	m_d&Ժ0w', '0슿ksφz@ⱇ)T+', '', 0, '?'),
 ('\r.|(uX׵', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DrupalInstaller.php', 0, '\ZE_r9?Z', '\ZE_r9?Z', 'c\r`t܅4Lʝjo:#u##Y', '', 0, '?'),
 ('OxxV+i', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ElggInstaller.php', 0, 'Ṕxǐ', 'Ṕxǐ', 'DmMY|x\"<ALfpx3)H\"', '', 0, '?'),
 ('{AyQ/', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/EliasisInstaller.php', 0, ':8ٷI', ':8ٷI', '\0x\Za&*U<Ƌ]yܻ', '', 0, '?'),
 ('s_G|}8\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ExpressionEngineInstaller.php', 0, 'oGY>y*^Y', 'oGY>y*^Y', 'Mr%k!󂥲Ӳz݁	)C', '', 0, '?'),
 ('O;м<$K=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/EzPlatformInstaller.php', 0, '@5$uoa ', '@5$uoa ', 'N8f?l}i\Znp}', '', 0, '?'),
 ('{8Jc\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/FuelInstaller.php', 0, '^q{3\\g', '^q{3\\g', 'NӮNAWuh#\"8)eM16', '', 0, '?'),
 ('vTL0).=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/FuelphpInstaller.php', 0, '@K{~tbYb', '@K{~tbYb', '\nȞ]r6	ÚZ{TVc.Gv~', '', 0, '?'),
 ('WowdZRP@?', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/GravInstaller.php', 0, '>ޑU@^L]', '>ޑU@^L]', ')LB|@\"UeJEWz ', '', 0, '?'),
 ('M#_ lHW', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/HuradInstaller.php', 0, 'U-07\n}m\\^', 'U-07\n}m\\^', 'dTa߰`+>/!!^bg$\n', '', 0, '?'),
 ('K07r^3%#f[o', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ImageCMSInstaller.php', 0, '[}_ەX', '[}_ەX', ';ܶڏiKx好[\0ܥ}*3', '', 0, '?'),
 ('|\ZX\"Q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Installer.php', 0, '\'	L}RV', '\'	L}RV', ']^l`%y/NШXϻN\Z', '', 0, '?'),
 ('I3-ks9[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ItopInstaller.php', 0, ',JDũ', ',JDũ', '8}+{3{9\nBx=\'0', '', 0, '?'),
 ('rP§ۧ[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/JoomlaInstaller.php', 0, '\0fHpg!NO\'', '\0fHpg!NO\'', 'ߓ2ns?AN\ng;', '', 0, '?'),
 ('x1=$#Wc?׉', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KanboardInstaller.php', 0, '*3]<]\'', '*3]<]\'', 'нrt}Q7@I=}amu(Q', '', 0, '?'),
 ('PӢqbb=Y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KirbyInstaller.php', 0, '(J_?+4h', '(J_?+4h', '	<?~C2B ?', '', 0, '?'),
 ('\Zy@6QD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KnownInstaller.php', 0, 'H.(N7\r', 'H.(N7\r', '_Gd11gY1~>B$tX', '', 0, '?'),
 ('ekasiu\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KodiCMSInstaller.php', 0, 'X_c\'xM9', 'X_c\'xM9', '`S,wD9kC\05β19jB[', '', 0, '?'),
 ('@qؼe5\\E', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KohanaInstaller.php', 0, 'Z \"I/', 'Z \"I/', '\"[&Pz>|֪!HX1b', '', 0, '?'),
 ('67K&xֿ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LanManagementSystemInstaller.php', 0, 'Pf9O6{l', 'Pf9O6{l', 'X>>2򽿉=I̱FҁKŝl\"', '', 0, '?'),
 ('QVW$9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LaravelInstaller.php', 0, '=`w26d', '=`w26d', '6ŷWh	0W?ޝYǝm', '', 0, '?'),
 ('yUj턛GSR', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LavaLiteInstaller.php', 0, 's@4	\ZDw', 's@4	\ZDw', '+Yv2\ZBP@bHIe4M', '', 0, '?'),
 ('3 x$bݻkI', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LithiumInstaller.php', 0, '!{hȡR2˪퀨6', '!{hȡR2˪퀨6', '(1qKCD?~Ԩ~OT $&~#>', '', 0, '?'),
 ('\Z2&a\\\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MODULEWorkInstaller.php', 0, '٢j@\nN', '٢j@\nN', 'pv$L΋,*ʸ/;R˥', '', 0, '?'),
 ('.3^d/wW', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MODXEvoInstaller.php', 0, ' Ќ~^F', ' Ќ~^F', '(o8@.z۹	\n!q66bp}', '', 0, '?'),
 ('n\'e=mU|\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MagentoInstaller.php', 0, '{Fs', '{Fs', 'CfjI\0QnmJI*', '', 0, '?'),
 ('.\Z&&HID#@3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MajimaInstaller.php', 0, 'XU+4]\nj2` ', 'XU+4]\nj2` ', 's)Wg>\0vw@Ceц', '', 0, '?'),
 ('필K)owA(', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MakoInstaller.php', 0, '6gO5| ', '6gO5| ', 'pns#dF$W͕(Q76', '', 0, '?'),
 ('Rot$LTV', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MauticInstaller.php', 0, ';y%poѨ', ';y%poѨ', '_/y1R%+a-DY6	,,', '', 0, '?'),
 ('P+ϗ\'AY?|', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MayaInstaller.php', 0, 'g\0p	f/l:', 'g\0p	f/l:', ')_TM\"4\0ٜ(', '', 0, '?'),
 ('eHPyS\"2', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MediaWikiInstaller.php', 0, 'd3ͮ%.Y', 'd3ͮ%.Y', '\n &<j}J̌vn^wo[', '', 0, '?'),
 ('&	QKw', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MicroweberInstaller.php', 0, '#[1E=\'?½', '#[1E=\'?½', 'n=}JqY9)fM$&R!w', '', 0, '?'),
 (':y=b#f$', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ModxInstaller.php', 0, 'DMR{iPc', 'DMR{iPc', '&w\"<?Hf>\ZR1%B', '', 0, '?'),
 ('._y~&', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MoodleInstaller.php', 0, '\"fڞّaϐg', '\"fڞّaϐg', 'Rs4Jqh~chfUFl_`', '', 0, '?'),
 ('V~lA', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OctoberInstaller.php', 0, '=\n8u', '=\n8u', '!|\'n{ML;vO1', '', 0, '?'),
 ('7sV]i', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OntoWikiInstaller.php', 0, '0R$|~\nv', '0R$|~\nv', 'kipE0mŗ1tMFeZ\nRR', '', 0, '?'),
 ('y?3F7))J', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OsclassInstaller.php', 0, 'H\'Hyr\n', 'H\'Hyr\n', 'ߓK4e߂S]n', '', 0, '?'),
 ('lN0?kαo', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OxidInstaller.php', 0, 'KE6P\0I6', 'KE6P\0I6', 'U=^k\\p\'}4֌&dtfhU3[', '', 0, '?'),
 ('dHJ^', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PPIInstaller.php', 0, 'mĎ妁\r\"Bx~', 'mĎ妁\r\"Bx~', 'PL`\'R<DJU>1D,', '', 0, '?'),
 ('<e\0:UJ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PhiftyInstaller.php', 0, 'jB8', 'jB8', 'er5EdH?\ZaARd', '', 0, '?'),
 ('z7WI |׋MW', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PhpBBInstaller.php', 0, '},S=T8', '},S=T8', 'ъcY25%=dt}~^?', '', 0, '?'),
 (':Y,|P#sw', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PimcoreInstaller.php', 0, ';J;`ƒ nH', ';J;`ƒ nH', '\r~$#,[5gtW]I{8r(', '', 0, '?'),
 ('	\0\\,?@', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PiwikInstaller.php', 0, 'u̎#!?5', 'u̎#!?5', 'pi=z+#8=n~}', '', 0, '?'),
 ('qzpRVhL5mQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PlentymarketsInstaller.php', 0, 'ź>pҸ]T:', 'ź>pҸ]T:', 'lO|TKf.`~4,XvIt', '', 0, '?'),
 ('zP=1H/CcW', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Plugin.php', 0, 'Y9:<ﳽйS', 'Y9:<ﳽйS', 'δ:v%Ȟ#{GBWG', '', 0, '?'),
 ('Q?og*.зg', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PortoInstaller.php', 0, '`	={`F\ZG7', '`	={`F\ZG7', 'c6y )Sq![dkm', '', 0, '?'),
 ('Xz', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PrestashopInstaller.php', 0, '!Hh', '!Hh', '9.YlSAXNo*bl', '', 0, '?'),
 ('UunkF7*eD>', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PuppetInstaller.php', 0, 'bUyͅ\08', 'bUyͅ\08', 'bSx\\hT/[ĭux+)D+n<', '', 0, '?'),
 ('Ք8d\0ؿD!-3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PxcmsInstaller.php', 0, '0v-T8', '0v-T8', 'i;Hʳ=wRm:@6C|Q	,', '', 0, '?'),
 ('cКUpp$', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/RadPHPInstaller.php', 0, 'R\"	\r{9q+E^[', 'R\"	\r{9q+E^[', 'Ol]%$RCombTr>\ZG', '', 0, '?'),
 ('A:+c\\8+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ReIndexInstaller.php', 0, 'OÝY,\\-\Z*', 'OÝY,\\-\Z*', 'V#|q1Vׁ-(#خ3-', '', 0, '?'),
 ('Px?\Z+\'\"', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Redaxo5Installer.php', 0, ')^R!-', ')^R!-', '``1\02\'UA݌ !^B', '', 0, '?'),
 ('Ŗ$JQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/RedaxoInstaller.php', 0, 'F[|.1x	&XfN', 'F[|.1x	&XfN', 'Dm1%nݛ_dr \rJ3Tr', '', 0, '?'),
 ('O]8iXWT1@', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/RoundcubeInstaller.php', 0, 'lcc*~j=p*u', 'lcc*~j=p*u', '<&J#s\\.,G$lt<IW5', '', 0, '?'),
 ('D6wD?4', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SMFInstaller.php', 0, '8I0mj@0%U', '8I0mj@0%U', '{{o]vrlSaXrPΓ?%.E', '', 0, '?'),
 ('\r(mХs ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ShopwareInstaller.php', 0, 'KKyޫpr]', 'KKyޫpr]', '\Z\n=I#Z\\4l֙u`', '', 0, '?'),
 ('!j\"W3w', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SilverStripeInstaller.php', 0, 'P-^03͙5', 'P-^03͙5', '>-且T	1&047lT', '', 0, '?'),
 ('*Q{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SiteDirectInstaller.php', 0, 'Y6oz/C', 'Y6oz/C', 'e׺k+oC @ƹOK<hS_', '', 0, '?'),
 ('cm^\\I', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SyDESInstaller.php', 0, 'W}B=H', 'W}B=H', 'jPG\ruDc=p\Ztzm6=', '', 0, '?'),
 ('r+(`W\nӦd', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Symfony1Installer.php', 0, 'LQ\09mM', 'LQ\09mM', '|3,Ux`i@?f.@F/x}h#', '', 0, '?'),
 ('㑰!f', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TYPO3CmsInstaller.php', 0, 'OEeZYE&', 'OEeZYE&', 'WsGr(Q9A_©>+\'', '', 0, '?'),
 ('3:65\r%', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TYPO3FlowInstaller.php', 0, ',oFD:N4', ',oFD:N4', 'jKbʍy,`y5ofڮ_e', '', 0, '?'),
 ('MM\nq5<', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TaoInstaller.php', 0, '^7Y+\Z͟UC', '^7Y+\Z͟UC', '%WJ5^U7}Z0gw', '', 0, '?'),
 ('wGlJ񷴎k', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TheliaInstaller.php', 0, 'R#tXɃt}7FI7', 'R#tXɃt}7FI7', '1xk_,_{p\'-Zʻ', '', 0, '?'),
 ('GxAs>V', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TuskInstaller.php', 0, 'R\\L뺵\'Q', 'R\\L뺵\'Q', '0&MsԎ̩c|	av', '', 0, '?'),
 ('֖1#,nyL#', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/UserFrostingInstaller.php', 0, 'Bмzֵ_', 'Bмzֵ_', 'V-2޸<n{s?IݸW>fs(', '', 0, '?'),
 ('M[ H', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/VanillaInstaller.php', 0, '$c63>nM\"', '$c63>nM\"', 'd1ޙGp#\\3f\'.', '', 0, '?'),
 ('l\0>ZN*oH', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/VgmcpInstaller.php', 0, 'zr>U<z1xe', 'zr>U<z1xe', '2LY6[Sj@K#', '', 0, '?'),
 ('E(7?$n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/WHMCSInstaller.php', 0, 'HW7PA,Ix\'', 'HW7PA,Ix\'', '>:iIsk~+Kl)si', '', 0, '?'),
 ('aw瞈}=.n;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/WolfCMSInstaller.php', 0, 'LĜLȐr4r', 'LĜLȐr4r', '\r&s3H)CN)1\nJ', '', 0, '?'),
 ('	6Jj-t=', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/WordPressInstaller.php', 0, 'ՁU3ҾPm', 'ՁU3ҾPm', 'oa/jnuFX]S{u', '', 0, '?'),
 ('3lPjT3QQ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/YawikInstaller.php', 0, 'UR)}g)vWs', 'UR)}g)vWs', 'QT@k\"!9Ca', '', 0, '?'),
 ('.Oc\Z>', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ZendInstaller.php', 0, '<TW<l0ӵ', '<TW<l0ӵ', 'ۡ-ON~*_>g<', '', 0, '?'),
 ('\")]M:1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ZikulaInstaller.php', 0, 'K8Idpo?E', 'K8Idpo?E', 'T!H	ؘ,Ca~KOPJ9', '', 0, '?'),
 ('kd%)o;', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/bootstrap.php', 0, 'Ɲ\n%\0', 'Ɲ\n%\0', 'g&AgpI84\ZBj', '', 0, '?'),
 ('k6U	\rȗ復W', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/woocommerce-gutenberg-products-block.php', 0, 'RrW]|Xr-', 'RrW]|Xr-', ',fg牓e$O+Czt-v', '', 0, '?'),
 ('2\ZǒK_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-coupons-v1-controller.php', 0, 'Wa##)', 'Wa##)', '\0l#NVs FC!@#;', '', 0, '?'),
 ('\Z9껯㷘j', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-customer-downloads-v1-controller.php', 0, 'F?5\nE99Amba', 'F?5\nE99Amba', 'WB٦sE#^Ձ@ {4QoG', '', 0, '?'),
 ('^\'Flر', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-customers-v1-controller.php', 0, 'c\\ksWA`n', 'c\\ksWA`n', 'aϩ.r?0cDL =e,.L:M', '', 0, '?'),
 ('Mbb\\i#\re_', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-order-notes-v1-controller.php', 0, '`r|O8', '`r|O8', 'pI3Ck=&K~\r2:', '', 0, '?'),
 ('s38PP]n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-order-refunds-v1-controller.php', 0, 'd1#<8O', 'd1#<8O', 'c\\pSu&-{O~|\r}#', '', 0, '?'),
 (']|=ƚiT3', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-orders-v1-controller.php', 0, 'O<3V8h7\\<', 'O<3V8h7\\<', 'Lh\'5{}Fh \'<t', '', 0, '?'),
 ('v<+', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-attribute-terms-v1-controller.php', 0, 'Ic	+5P', 'Ic	+5P', 'Uo\'|°A먠>BAN@9	', '', 0, '?'),
 ('X%AL̯p', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-attributes-v1-controller.php', 0, '\0sV6*ĸ~ѿ', '\0sV6*ĸ~ѿ', 'nEzw\'r~jP\"W@<', '', 0, '?'),
 ('\"_Hx', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-categories-v1-controller.php', 0, 'Kf{ْ]V\\4', 'Kf{ْ]V\\4', 'iɗcIsTjZ.3qQbFz*c77', '', 0, '?'),
 ('9`#,i', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-reviews-v1-controller.php', 0, '\reUkEˇ*', '\reUkEˇ*', 'Bͭk8U<ۙm0>{5,', '', 0, '?'),
 ('\\s\rݷOr}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-shipping-classes-v1-controller.php', 0, 'n}?G\ZL6?', 'n}?G\ZL6?', '񅘙jmrZr\rj\n%i/(-/;', '', 0, '?'),
 ('Tտ̧4', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-tags-v1-controller.php', 0, '7&)6G?,', '7&)6G?,', 'Vbqbu{{ȇNvh', '', 0, '?'),
 ('؊܇%', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-products-v1-controller.php', 0, 'U |9T^', 'U |9T^', 'T\"5`W0%<Ibv', '', 0, '?'),
 ('	,ymnn', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-report-sales-v1-controller.php', 0, 'J5&\Zo/Z', 'J5&\Zo/Z', 'QV\"F:94mA[', '', 0, '?'),
 ('g~R	x\Z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-report-top-sellers-v1-controller.php', 0, 'G#(P\0', 'G#(P\0', 'ZHKjv!C-l+\nʙ<*V', '', 0, '?'),
 ('(@@ZZM9', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-reports-v1-controller.php', 0, ',FVuPUD\r', ',FVuPUD\r', '>;,mledsAv,', '', 0, '?'),
 ('\"ﮘEG', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-tax-classes-v1-controller.php', 0, '~lVdo<T', '~lVdo<T', '\\\ZsћO,VA˱ы', '', 0, '?'),
 ('>ii<͘yQgk~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-taxes-v1-controller.php', 0, '=(\"1b/O', '=(\"1b/O', '|TH8Ecli&P', '', 0, '?'),
 ('Xѣ-1CI|', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-webhook-deliveries-v1-controller.php', 0, ';1k', ';1k', 'pg#Vk0qsHձȪй5', '', 0, '?'),
 ('`PH\r+Ņ֚}5', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-webhooks-v1-controller.php', 0, 'Ui\\-񟀒t^V|', 'Ui\\-񟀒t^V|', 'b:q]aWLpd^\05x,', '', 0, '?'),
 ('vM-І[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-coupons-v2-controller.php', 0, 'jfjT#>S-', 'jfjT#>S-', 'MeE\nE;t׉Iec+=*', '', 0, '?'),
 ('/!e6ڱ6Ɛ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-customer-downloads-v2-controller.php', 0, '.Fj:`', '.Fj:`', 'lُa@^ƨ5MKk\';S4\Z', '', 0, '?'),
 (',{Zu*n', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-customers-v2-controller.php', 0, 'CUA;tU.pRL', 'CUA;tU.pRL', '\n= [9JK)$6/\05E', '', 0, '?'),
 ('.%e.V`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-network-orders-v2-controller.php', 0, '	J0 71', '	J0 71', '1M=@xi>:&g^Dj', '', 0, '?'),
 ('\\?&,e', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-order-notes-v2-controller.php', 0, ');)(*jT', ');)(*jT', 'qqfV%\rί\r&;>!qQ', '', 0, '?'),
 ('M:\n*z', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-order-refunds-v2-controller.php', 0, '9B;a', '9B;a', 'L8dc:!T/2<1:vܳ', '', 0, '?'),
 ('\0*E͠[>C[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-orders-v2-controller.php', 0, 'f~c޽7', 'f~c޽7', '|^*j\"]9:\ZqTAݭ', '', 0, '?'),
 ('޾u#g-', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-payment-gateways-v2-controller.php', 0, '@I', '@I', '&Q ͎Ow|+w4$T', '', 0, '?'),
 ('\Zd/]x?C', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-attribute-terms-v2-controller.php', 0, 'N>|W^', 'N>|W^', 'f6+3|!Py1cYZ', '', 0, '?'),
 ('a֙)rM4', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-attributes-v2-controller.php', 0, 'ɞ@>Rދ	Se', 'ɞ@>Rދ	Se', ':6siF\"QҶU#*ǓV\"-', '', 0, '?'),
 ('92v:', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-categories-v2-controller.php', 0, '#YYxL_=', '#YYxL_=', '_9TGC9`]EG.E]', '', 0, '?'),
 ('֘P>R[E', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-reviews-v2-controller.php', 0, '}wy\"', '}wy\"', 'yBbVg.MxzHN׆!5{6', '', 0, '?'),
 ('uF-dþPa', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-shipping-classes-v2-controller.php', 0, 'k_ m}&\r\ZEM', 'k_ m}&\r\ZEM', 'F%3]	r\\i:d;\'JP\0ˏ', '', 0, '?'),
 ('b DRf%	', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-tags-v2-controller.php', 0, 'Eɑ!?v|<2P', 'Eɑ!?v|<2P', 'Wւ90\'R?lL;vIB(*zWJ6u^', '', 0, '?'),
 (',w	A', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-variations-v2-controller.php', 0, 'ݚ@׀~ש', 'ݚ@׀~ש', 'nۍ0\044e(vtLVN', '', 0, '?'),
 ('tI۞m@Ai	{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-products-v2-controller.php', 0, '\'QL8m秱L-', '\'QL8m秱L-', '򵛸Fۯ:##6Q~\0F#D\"\n', '', 0, '?'),
 ('N\';wa', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-report-sales-v2-controller.php', 0, '$D@\Z]^', '$D@\Z]^', '/s\\KNߎkZ}\r0&', '', 0, '?'),
 ('N𹠫\"Q{', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-report-top-sellers-v2-controller.php', 0, 'Ӵ~	S`a}Z', 'Ӵ~	S`a}Z', 'm$\n4h\Z4֜6<-FƋF', '', 0, '?'),
 ('&DU65', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-reports-v2-controller.php', 0, '\\dke?;>', '\\dke?;>', '7p%0PǾBכ', '', 0, '?'),
 ('ԙ<Ц0|', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-setting-options-v2-controller.php', 0, '\Z]Q:,', '\Z]Q:,', 'l7\0nv|\nbQGHIըAJ\"', '', 0, '?'),
 ('0vj`Y,', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-settings-v2-controller.php', 0, 'a=3', 'a=3', 'hgQu|ǯy[8BtRimt.w', '', 0, '?'),
 ('xX^+%ŉun\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-methods-v2-controller.php', 0, '\0ף\'FV5', '\0ף\'FV5', 'PK\\4sR9R+_SY', '', 0, '?'),
 ('L8MtP', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-zone-locations-v2-controller.php', 0, '\ZiهDE6<', '\ZiهDE6<', '&D=t_?]D!', '', 0, '?'),
 ('|dgr8φP', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-zone-methods-v2-controller.php', 0, '.ko_GRo', '.ko_GRo', '?ħȵFэSFjDUjD&ٚ', '', 0, '?'),
 ('Y7;HgHǥ6x', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-zones-v2-controller.php', 0, 'BSr}>(H', 'BSr}>(H', 'SA\nC[Ĺ;I+\n}', '', 0, '?'),
 ('edೂ}8Q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-system-status-tools-v2-controller.php', 0, 'e$\r4uY>', 'e$\r4uY>', '4A bZMs\"gp(%5l|K', '', 0, '?'),
 ('\"sLH-Kޟ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-system-status-v2-controller.php', 0, '\Zѵe =', '\Zѵe =', '-ZAo(=wMovZX2', '', 0, '?'),
 ('t0aП6]F', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-tax-classes-v2-controller.php', 0, 'lqQ', 'lqQ', '[9y^$b`4g0mQx', '', 0, '?'),
 ('p3F{p@g[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-taxes-v2-controller.php', 0, 'a\0us\\', 'a\0us\\', 'l Ve+.b03yh', '', 0, '?'),
 ('bf`\r05C[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-webhook-deliveries-v2-controller.php', 0, '<Ց', '<Ց', 'ދy	vf0e@suK14Z', '', 0, '?'),
 ('ǉ<^~	', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-webhooks-v2-controller.php', 0, 'vAݯ(<TD6', 'vAݯ(<TD6', '*jܿ%M;7]Q>8߂', '', 0, '?'),
 ('X	!5hl[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-controller.php', 0, '\n`xmr\"b', '\n`xmr\"b', '~*r&%ĢjS2O[ͤ', '', 0, '?'),
 ('A-1Q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-coupons-controller.php', 0, 'c2\'7l', 'c2\'7l', 'JjoFiEbd\r*864o\"/', '', 0, '?'),
 (';ə֡N@.', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-crud-controller.php', 0, 'VpG?4Հ Y#', 'VpG?4Հ Y#', 'E\\\n\0t?!Wac}\'s', '', 0, '?'),
 ('ڮ;ݐ\\l`', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-customer-downloads-controller.php', 0, '|B\n.V6u', '|B\n.V6u', '^P	Jl[ fuv', '', 0, '?'),
 ('({|[', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-customers-controller.php', 0, 'j(C>/', 'j(C>/', 'ދ Ǩ\\\'n<o?B<u[q', '', 0, '?'),
 ('$A֌ߧ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-continents-controller.php', 0, 't	wbկH', 't	wbկH', '\Z\0j!MՕ\" TM', '', 0, '?'),
 ('\04/؝(Ed', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-controller.php', 0, '1qϫD|mHEd', '1qϫD|mHEd', '+`/81ʕJ', '', 0, '?'),
 ('@B3xB=ڶ\0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-countries-controller.php', 0, 'ɹ!r씇', 'ɹ!r씇', '8G9;:B\\5*C׵^zqQ;', '', 0, '?'),
 ('X#r&g5', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-currencies-controller.php', 0, 'NlEw3h- 8N', 'NlEw3h- 8N', 'y-gNbM`3d[-&P', '', 0, '?'),
 ('ÖrPH', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-network-orders-controller.php', 0, '/ɺbmmWyN#', '/ɺbmmWyN#', 'SޜɼUqM$\"=誩wx{*', '', 0, '?'),
 ('\"skVZ	i', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-order-notes-controller.php', 0, '\r 8	^I)d', '\r 8	^I)d', 'd%Ygi!`7Wqk', '', 0, '?'),
 ('izDqj`w\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-order-refunds-controller.php', 0, '}M*doz8.', '}M*doz8.', 'VAj{c7İ~uK', '', 0, '?'),
 ('#-G\"޲', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-orders-controller.php', 0, 'I]}0bQ	', 'I]}0bQ	', '{.!l1(.uy\0AKNf^1', '', 0, '?'),
 ('̒쇲>ɯD', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-payment-gateways-controller.php', 0, 'j{AU&', 'j{AU&', 'su~cv8z3z', '', 0, '?'),
 ('A\ZGa~\\', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-posts-controller.php', 0, 'd0}C]', 'd0}C]', 'H\0eE|IgW\0', '', 0, '?'),
 ('F5L8Jk[pvY', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-attribute-terms-controller.php', 0, '˷_3VkP', '˷_3VkP', 'QŃ*,?LMf^nCmcU7', '', 0, '?'),
 ('0ѐzXw', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-attributes-controller.php', 0, 'b|\naHI޹C', 'b|\naHI޹C', 'i<Mԋ\"gR\nX$({Du', '', 0, '?'),
 ('\n]YM\Z\'', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-categories-controller.php', 0, 'gK;Tsc)', 'gK;Tsc)', '`r#(2\ndX֛Uvѵ', '', 0, '?'),
 (')r66', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-reviews-controller.php', 0, 'GQ!~cm>1', 'GQ!~cm>1', '>Mr)oC,,ӹLz\n	', '', 0, '?'),
 ('uliő', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-shipping-classes-controller.php', 0, 'Xω7X@', 'Xω7X@', '\\{lĀĝw\';C;|eR', '', 0, '?'),
 ('}j<	pU=%a6 ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-tags-controller.php', 0, 'ǶP)]RU', 'ǶP)]RU', '<`BzRO;Zz4-Iw~', '', 0, '?'),
 ('ke&*lTnJV', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-variations-controller.php', 0, 'r镑dl*I', 'r镑dl*I', 'y8Bh:]s<®Sޑ', '', 0, '?'),
 ('hGŏqpI', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-products-controller.php', 0, 'ge<\r', 'ge<\r', 'u4,$oc9*Y{VDde1', '', 0, '?'),
 (']5B7*q', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-coupons-totals-controller.php', 0, ',«K1B', ',«K1B', 'i(f8VzLq@\" \Z', '', 0, '?'),
 ('`±)w]ē\r', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-customers-totals-controller.php', 0, 'dpܰ#I2a', 'dpܰ#I2a', 'Z^*5\0{.F-{', '', 0, '?'),
 ('y=ӅH\nd){@', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-orders-totals-controller.php', 0, '6_QFeC', '6_QFeC', '8to	őHtglAk@/', '', 0, '?'),
 ('vY- R>$', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-products-totals-controller.php', 0, '4lb(d', '4lb(d', 'eDc0?8uoU4zU\n', '', 0, '?'),
 ('A$ȿH+$', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-reviews-totals-controller.php', 0, 'n*Y51$W', 'n*Y51$W', '\rg2_̰y{Jt?iKgLd', '', 0, '?'),
 ('$5&_h}', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-sales-controller.php', 0, ':EGPmtr]', ':EGPmtr]', 'O)\n	\0ZNW.`0X#R\\oS[', '', 0, '?'),
 ('hb^xI>%', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-top-sellers-controller.php', 0, '\\Lr}m', '\\Lr}m', 'n@M\0>`o*cGV', '', 0, '?'),
 ('TfDvT', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-reports-controller.php', 0, 'g/(}\0Iqǜp', 'g/(}\0Iqǜp', '5!R2WH./XctuM\r', '', 0, '?'),
 ('X&4z2M', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-setting-options-controller.php', 0, '9m\nǾG&u', '9m\nǾG&u', 'uhFy[p7eyUS3t)', '', 0, '?'),
 ('h\nsB(M/', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-settings-controller.php', 0, 'F.W:}o', 'F.W:}o', '\0\'B*s|k1%;-WGzZ9Y', '', 0, '?'),
 ('{hxz', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-methods-controller.php', 0, '+Y\ZGC3P', '+Y\ZGC3P', 'JmVu#fl(wҘsH', '', 0, '?'),
 ('7ir..eP~y', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zone-locations-controller.php', 0, ';_P3LpCj', ';_P3LpCj', '&f\nVێTApe	~', '', 0, '?'),
 ('/<2ei|tE', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zone-methods-controller.php', 0, 'h5s', 'h5s', ';,uV?_jtn=dulM', '', 0, '?'),
 ('ջ>if0\ZMZ', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zones-controller-base.php', 0, '/_`1o;VoG', '/_`1o;VoG', 'm&9L&hќƒ-', '', 0, '?'),
 ('B8)x4U]', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zones-controller.php', 0, '7bv}DPU[', '7bv}DPU[', '8!g+rNNt; Y,', '', 0, '?'),
 ('-]նVZ[K', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-system-status-controller.php', 0, 'YhyZ#u\\', 'YhyZ#u\\', '\'tgQpC;Э!&a30', '', 0, '?'),
 ('vi^/r͊g1', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-system-status-tools-controller.php', 0, '0ߡGd%', '0ߡGd%', 'w&H݌	v	,O', '', 0, '?'),
 ('33a)y\n;^L', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-tax-classes-controller.php', 0, 'Azݧ-yHa?', 'Azݧ-yHa?', 'd=@;Cv12`XB-', '', 0, '?'),
 ('r2ks', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-taxes-controller.php', 0, 'ep;̹q\\', 'ep;̹q\\', 'πP\'mf+uQ5LTΛq', '', 0, '?'),
 ('-#c˽RFyD~', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-terms-controller.php', 0, '⛸5,C	', '⛸5,C	', 'Q\0f*77ٺ{5', '', 0, '?'),
 ('d[=qoSX!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-webhooks-controller.php', 0, 'N H.x\0Ɔp!\r', 'N H.x\0Ɔp!\r', 'xcl\\sYјS0B\r4qf', '', 0, '?'),
 ('.3<qɨ_$!', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Package.php', 0, '*btz~X6.w', '*btz~X6.w', '^F8V`5\r-s n', '', 0, '?'),
 ('L+M\\(4:0', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Server.php', 0, '_BVl@.', '_BVl@.', 'u3{3yuݏ\ZmEDKG̺Jj', '', 0, '?'),
 ('vh@02z4', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Utilities/ImageAttachment.php', 0, '?WK^Qj ', '?WK^Qj ', '|^?7X0xm\nҺ\"', '', 0, '?'),
 ('.%EN3+^[vk', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Utilities/SingletonTrait.php', 0, '+g7|v\\WVIڋ', '+g7|v\\WVIڋ', 'T$/ZSJ`=Ut}VGU\'z', '', 0, '?'),
 ('t:\n;	K2', 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/woocommerce-rest-api.php', 0, 'Ab\"v5f	-yc', 'Ab\"v5f	-yc', '7sm#^[[e?E.M#}\\z', '', 0, '?'),
 ('ۥ #.c~', 'wp-content/updraft/plugins-old/woocommerce/src/Autoloader.php', 0, 'oHE`[V', 'oHE`[V', 'BWqy2ڡϺiYcŰOID<', '', 0, '?'),
 ('3理blr', 'wp-content/updraft/plugins-old/woocommerce/src/Packages.php', 0, '\n2U&y', '\n2U&y', 'q)3x#03VF\'ʹZlO*D', '', 0, '?'),
 ('ӵ=cKJ8U', 'wp-content/updraft/plugins-old/woocommerce/templates/archive-product.php', 0, '\'ĜK83Yns=/p', '\'ĜK83Yns=/p', 'RC3\\\"7A-4(', '', 0, '?'),
 (')ٷBxHҾ', 'wp-content/updraft/plugins-old/woocommerce/templates/auth/footer.php', 0, '}sKH;j7', '}sKH;j7', 'UK)کѕcm\\ڡճ bI', '', 0, '?'),
 ('/uu)YΚ4l', 'wp-content/updraft/plugins-old/woocommerce/templates/auth/form-grant-access.php', 0, 'Zýx39χ=G', 'Zýx39χ=G', '-D$ŝ) ko5_<VP?߯', '', 0, '?'),
 ('5V0?t^Ș.', 'wp-content/updraft/plugins-old/woocommerce/templates/auth/form-login.php', 0, '9;j^ވC', '9;j^ވC', '\"ah҅]c ,,P\rT[', '', 0, '?'),
 ('ZDi\"9r)[', 'wp-content/updraft/plugins-old/woocommerce/templates/auth/header.php', 0, 'w$h\nY:F', 'w$h\nY:F', 'ò<[<.ug孩e2gd', '', 0, '?'),
 ('{\"hmRR', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-empty.php', 0, '\rObu_!9', '\rObu_!9', ' A7D&hK\n_xʅ', '', 0, '?'),
 ('sѝJh[<', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-item-data.php', 0, '2}iĒLo', '2}iĒLo', 'l璿ۊFP̗<0,eL4', '', 0, '?'),
 ('\ZE&Bj', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-shipping.php', 0, 'Ӑ\Z\"&.x', 'Ӑ\Z\"&.x', ']\ZC_7WvC;', '', 0, '?'),
 ('߯@B8UPC4zW', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-totals.php', 0, 'nr\0&7Fʹ', 'nr\0&7Fʹ', '!9Mq\'*ZFjJ{?V:h	', '', 0, '?'),
 ('1%z`.0{Sv', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart.php', 0, 'm@vT\0a', 'm@vT\0a', 'Mτ\rOZ\rI1$\"R	4&', '', 0, '?'),
 ('bk䈺A!!', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cross-sells.php', 0, '\n)<,QOŏ', '\n)<,QOŏ', 'E(8NdB;-]-9n5Pm+&', '', 0, '?'),
 ('_McЕ\Z', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/mini-cart.php', 0, 'TPA׾5.\"e4', 'TPA׾5.\"e4', 'oyQ޾2ڥx~ԋ7BwF', '', 0, '?'),
 ('e>FV', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/proceed-to-checkout-button.php', 0, '\ZV z{ټqϻ', '\ZV z{ټqϻ', 'R\rȤ%Yx\\_l~P7qDPR', '', 0, '?'),
 ('%%;\no	Jٟ϶', 'wp-content/updraft/plugins-old/woocommerce/templates/cart/shipping-calculator.php', 0, '_%XU㒍T3', '_%XU㒍T3', '屴\n#EhLTxlK륧)H', '', 0, '?'),
 ('b>Ո֊', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/cart-errors.php', 0, 'xa:뇧OP|', 'xa:뇧OP|', 'NX {CV|=qrkWyrTn9', '', 0, '?'),
 ('9eQiAvJ', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-billing.php', 0, 'N-v1\"$Ȭ~', 'N-v1\"$Ȭ~', '=r_|@R+&AVwQϱa', '', 0, '?'),
 ('\Z{\0', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-checkout.php', 0, '򅓙lMa~\'b', '򅓙lMa~\'b', '@2˫AdŌ[rsɀ', '', 0, '?'),
 ('WmQ)qGC', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-coupon.php', 0, '9wk1 e<+', '9wk1 e<+', 'RVCxc\\wCX<\nh37Z2=(', '', 0, '?'),
 ('g]t	2', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-login.php', 0, 'TWvdLeNLqP', 'TWvdLeNLqP', 'U%oT	|>bX#RiЖ', '', 0, '?'),
 ('F,qxG', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-pay.php', 0, '\n90KVhL', '\n90KVhL', 'WtOkҷMƌ\Z0vo', '', 0, '?'),
 ('YXK/]na', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-shipping.php', 0, '{HE`p-', '{HE`p-', 'Fg9a\Z<t݆zMӅ.֍Xʜ', '', 0, '?'),
 ('XY\Zc!7Cw', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/order-receipt.php', 0, 'ƴc|$,{(', 'ƴc|$,{(', '\'ۣ@͏Q\\K6J%', '', 0, '?'),
 ('w2Q\n\\(*WO', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/payment-method.php', 0, 'hop,`K(t', 'hop,`K(t', '>[ylTԖފ6L\"^zwۯ', '', 0, '?'),
 ('ɹ$e:q', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/payment.php', 0, '3˺t{7L', '3˺t{7L', 'jmm42\'|/uΑ0u', '', 0, '?'),
 ('R\"2{-K', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/review-order.php', 0, '>X<߷', '>X<߷', '^Gez6g[9ͩJdIr Y^', '', 0, '?'),
 ('X5J瓲', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/terms.php', 0, ':]C;m?', ':]C;m?', '?J\"g5pj9[1a', '', 0, '?'),
 (')ɓHa\0', 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/thankyou.php', 0, '\r!`+(\'SQ', '\r!`+(\'SQ', 'Fd*Yg,n,Et(z\\', '', 0, '?'),
 ('DWN#Pa,\n5', 'wp-content/updraft/plugins-old/woocommerce/templates/content-product.php', 0, '@s\rd(Md', '@s\rd(Md', 'HsGۖ#[EY\"lSN', '', 0, '?'),
 ('}y=Xg??', 'wp-content/updraft/plugins-old/woocommerce/templates/content-product_cat.php', 0, 'ѽȢsFrv\Z', 'ѽȢsFrv\Z', 'tSI~Hwʭ\'\rk|:K', '', 0, '?'),
 ('n\n4uz<!<Z', 'wp-content/updraft/plugins-old/woocommerce/templates/content-single-product.php', 0, 't5OWX%Nz', 't5OWX%Nz', 'i9If,tpPzeC3G̘', '', 0, '?'),
 ('		:ӫ@<n', 'wp-content/updraft/plugins-old/woocommerce/templates/content-widget-price-filter.php', 0, '*YIȧ-藮}N', '*YIȧ-藮}N', 'n7eֿniSĦ!%\01', '', 0, '?'),
 ('c	\0A', 'wp-content/updraft/plugins-old/woocommerce/templates/content-widget-product.php', 0, 'voc67}qc', 'voc67}qc', 'Z{@=hc>,|p', '', 0, '?'),
 ('9P@t8@uDf_', 'wp-content/updraft/plugins-old/woocommerce/templates/content-widget-reviews.php', 0, ' y!B2Su>', ' y!B2Su>', 'ܩ̔ǹ8mՠ0[;ܘQ8=\n', '', 0, '?'),
 ('H[khTu', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/admin-cancelled-order.php', 0, '݇Mo\\3!|', '݇Mo\\3!|', 'j{3(|q1|s>!~\'+N', '', 0, '?'),
 ('/W	sՏM', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/admin-failed-order.php', 0, '3)ߘH\"L2', '3)ߘH\"L2', 'iW}Kl8j_,7%H럣WC%', '', 0, '?'),
 ('ox1Hm̆\"#', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/admin-new-order.php', 0, '[DLy`bP', '[DLy`bP', ': ӈ.K[ebCC8kN!', '', 0, '?'),
 ('rSM6zCP4J', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-completed-order.php', 0, '[´.\0b}rE', '[´.\0b}rE', 'Q?d(OYtv<~^	O', '', 0, '?'),
 ('s!RJ}!', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-invoice.php', 0, 'L\Z:k_', 'L\Z:k_', '&rLͻ0罨#աWV\rbwzg^', '', 0, '?'),
 ('YˇRԦM R', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-new-account.php', 0, 'c582r6(Mӯ', 'c582r6(Mӯ', 'n\r#	3:#4$d*?ˍ܊jh', '', 0, '?'),
 ('vx4jN', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-note.php', 0, '|ם&{AX', '|ם&{AX', 'GRZɊNUoÎ`@BV ;忯Y', '', 0, '?'),
 ('_\r\n', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-on-hold-order.php', 0, '9\Z`', '9\Z`', '+:uw&xSle*LqpNk0q', '', 0, '?'),
 ('	,ޚs6@a', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-processing-order.php', 0, '!EMLn%7w5', '!EMLn%7w5', '{GIL2Yl[+.>u', '', 0, '?'),
 ('8', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-refunded-order.php', 0, ')%tV>mpm', ')%tV>mpm', 'MN_R;G`Kc\ZeeaǾ', '', 0, '?'),
 (':3z}\"0W_9gZ', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-reset-password.php', 0, 'F݂H*Q', 'F݂H*Q', '[m}1˳IY;zg4', '', 0, '?'),
 ('`P,kߞ	n', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-addresses.php', 0, ')ĺAM\\Tc', ')ĺAM\\Tc', 'XPSqfkD.يNh.', '', 0, '?'),
 ('}[]bce<1', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-customer-details.php', 0, '@tLuחrNa', '@tLuחrNa', 'bdCq9>:I|*Ի*Qi(', '', 0, '?'),
 ('9)!\r+o׋z', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-downloads.php', 0, 'xj7`>:', 'xj7`>:', 'a{Ϭn׿e\nx7SL@\Z@hn', '', 0, '?'),
 ('˺2\r̤3>', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-footer.php', 0, 'j:Z7dV', 'j:Z7dV', '~Sho3s!e̲3ś8>', '', 0, '?'),
 ('4\ra\r7', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-header.php', 0, '82\'(x&n', '82\'(x&n', 'JV2Ο巩xK}(眠', '', 0, '?'),
 ('nG~lj', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-order-details.php', 0, 'i+0c.ץ@`', 'i+0c.ץ@`', ',yLۋb^9Bsu wvCU', '', 0, '?'),
 ('WL[n\"*v', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-order-items.php', 0, '\'8c	', '\'8c	', 'Awju~fx%*Y:\0~eR՗', '', 0, '?'),
 ('g.jR+9?s@M', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-styles.php', 0, '2>)1}h3T', '2>)1}h3T', 'ىH	Ět.=-]@xH', '', 0, '?'),
 ('1]A]', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/admin-cancelled-order.php', 0, '?)!QT/dsv', '?)!QT/dsv', '!\rv=hAKnmb', '', 0, '?'),
 (' {Vjd', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/admin-failed-order.php', 0, ']Pqԯ', ']Pqԯ', '}\Z;Ep\'N!N1ȉUv', '', 0, '?'),
 ('PՄg)!G', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/admin-new-order.php', 0, 'yt=4D}/', 'yt=4D}/', 'i%֚s>z{O	Q', '', 0, '?'),
 ('>at8x', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-completed-order.php', 0, 'tt7nXs =u', 'tt7nXs =u', 'pfwr:M,8a,O\"', '', 0, '?'),
 ('rBt֮螽T', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-invoice.php', 0, 'w2g<\n\n?VR', 'w2g<\n\n?VR', ']l-ǿ[<d\0Y\0kފdyq\\', '', 0, '?'),
 ('4*	lZy ', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-new-account.php', 0, 'H-X\r\n_', 'H-X\r\n_', '๩EXY:Yȼ_\08e&\0׎', '', 0, '?'),
 ('&[8%Fں$', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-note.php', 0, '9}:Y&S:', '9}:Y&S:', '$e,eye@<_8!', '', 0, '?'),
 ('.l)]r]&+?', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-on-hold-order.php', 0, '*b.X(\'2', '*b.X(\'2', 'PgrY7eukY|!mFMv', '', 0, '?'),
 ('!^_BZƋҨ', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-processing-order.php', 0, 'Oy,X$ΐ/4@', 'Oy,X$ΐ/4@', '@\ZL{0Ls\'qj6)x', '', 0, '?'),
 ('H>#\Z$XT%7', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-refunded-order.php', 0, 'h1)-iA	', 'h1)-iA	', ':zJt%iZS3;ZTUӍ', '', 0, '?'),
 ('љHͧMVbM݅I', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-reset-password.php', 0, 'gHE`R', 'gHE`R', ' w\nHV\"IieAJ=', '', 0, '?'),
 ('.02,6rp', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-addresses.php', 0, 'H3nJc<_T', 'H3nJc<_T', '{S0֙S^3z\'ae+a}i;)', '', 0, '?'),
 ('Y\n`7.', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-customer-details.php', 0, 'PE_rj!\'', 'PE_rj!\'', 'Q|8>*aeƦJk\r5', '', 0, '?'),
 ('\'VSV\0(_', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-downloads.php', 0, '5]rf	', '5]rf	', 'EIFHY \\b`^vUZ', '', 0, '?'),
 ('- sxW', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-order-details.php', 0, '\'Gh|BQ', '\'Gh|BQ', 'D3ˊ~oϻṊق', '', 0, '?'),
 ('3j0Q⤯}', 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-order-items.php', 0, '_g\Ze4', '_g\Ze4', 'ĵxVE_5a1_5Nx', '', 0, '?'),
 ('(IUğ82򷱁c', 'wp-content/updraft/plugins-old/woocommerce/templates/global/breadcrumb.php', 0, 'jANo.>\Z$', 'jANo.>\Z$', 'Z;\r\'IR cZϡ}M,oC', '', 0, '?'),
 ('@+~a', 'wp-content/updraft/plugins-old/woocommerce/templates/global/form-login.php', 0, 's\rW}	', 's\rW}	', 'Qi6#!~{(-JFA<eT', '', 0, '?'),
 ('YI!]', 'wp-content/updraft/plugins-old/woocommerce/templates/global/quantity-input.php', 0, '}:\ZKνp!', '}:\ZKνp!', 'GET90Sa׹cic VWp', '', 0, '?'),
 ('xI)>RBܜ', 'wp-content/updraft/plugins-old/woocommerce/templates/global/sidebar.php', 0, 'X4+\Zz7vIeN', 'X4+\Zz7vIeN', 'tq?Σ~$1vє9+', '', 0, '?'),
 ('9ͬJU\'', 'wp-content/updraft/plugins-old/woocommerce/templates/global/wrapper-end.php', 0, '+zJȑ', '+zJȑ', 'S1؜pȯW|/8RP\"', '', 0, '?'),
 ('`LAZq', 'wp-content/updraft/plugins-old/woocommerce/templates/global/wrapper-start.php', 0, 'L+^Q\0=?IH', 'L+^Q\0=?IH', 'F</;bZcєr2?\nh)', '', 0, '?'),
 ('ӦaZg\rCKe{', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/add-to-cart.php', 0, '$󟈕ȗQ', '$󟈕ȗQ', 'hHT̟,v, ͆WfEw', '', 0, '?'),
 ('.}Ris\nuL؂K7', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/loop-end.php', 0, '=%%|0$O%d', '=%%|0$O%d', 'yRtVT=BӻsVSE!', '', 0, '?'),
 ('pqY]EC', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/loop-start.php', 0, ';\0aX\\\Zn', ';\0aX\\\Zn', 'AMŨT=0\\p`{?', '', 0, '?'),
 ('{s1e', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/no-products-found.php', 0, 'ͽCowH', 'ͽCowH', 'Qc:S@A\"Ҭ2P򸡮I', '', 0, '?'),
 ('lhH8e\nD ', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/orderby.php', 0, '!`N].', '!`N].', 'n\nd!Wy~pa81He:3', '', 0, '?'),
 ('x\rP0> ', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/pagination.php', 0, 'd W1', 'd W1', 'dzVfQf9pDGm', '', 0, '?'),
 ('8<81Օ', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/price.php', 0, '#nWc]V0Kt', '#nWc]V0Kt', 'G)kT%~Y_:,Yz~>^c', '', 0, '?'),
 ('{wU\r)\"CLBxK', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/rating.php', 0, '2qm[:霈as_º', '2qm[:霈as_º', '\Z#קv?&	Qyg/\\', '', 0, '?'),
 ('1$P$', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/result-count.php', 0, '%D|ڊZN2', '%D|ڊZN2', 'W\nupe|~ztT*', '', 0, '?'),
 ('Rm0]\\', 'wp-content/updraft/plugins-old/woocommerce/templates/loop/sale-flash.php', 0, '1f9Ǭ]ij', '1f9Ǭ]ij', 'OLw	(rOK]_sI\r', '', 0, '?'),
 ('Ca\r6\Z}', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/dashboard.php', 0, 'K*oߨkkT', 'K*oߨkkT', '3cyʃP4  EY8)}yR', '', 0, '?'),
 ('7-dJ1*', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/downloads.php', 0, '	yxkM^bO', '	yxkM^bO', 'L`Z5Ϟ8S<顅vP~G.ıSK', '', 0, '?'),
 ('\Z$B0t', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-add-payment-method.php', 0, '4\'?^c\">j', '4\'?^c\">j', 'kFtRHB=?@SLd:} ', '', 0, '?'),
 ('+zaDzo/', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-edit-account.php', 0, '\'sDS\rB+Wp', '\'sDS\rB+Wp', 'Bc!y\\jS]U]_Zq', '', 0, '?'),
 (':#iW`93', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-edit-address.php', 0, '.zd', '.zd', 'g:\ZS<P𽳄nȈibR<lE', '', 0, '?'),
 ('bkY+󱮍<,K ', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-login.php', 0, 'dߞ@4\'7@', 'dߞ@4\'7@', '!Wn >|Ma&\nzC', '', 0, '?'),
 ('^ ;WS95t|', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-lost-password.php', 0, '6M.X^}y', '6M.X^}y', 'H2R)BULnOPy', '', 0, '?'),
 ('6±C=I', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-reset-password.php', 0, '?Z+:M', '?Z+:M', ':9΍ h(\r1*9=', '', 0, '?'),
 ('H\"ljoZ@', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/lost-password-confirmation.php', 0, 'g}EDeh~7\'z&', 'g}EDeh~7\'z&', 'R7Ȓ=n	icfōt`', '', 0, '?'),
 ('t\\zw!', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-account.php', 0, ' ?Ml	M`', ' ?Ml	M`', '^/TăInT\Zx.G', '', 0, '?'),
 ('vAl+,', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-address.php', 0, '1Uoȍt4i~', '1Uoȍt4i~', 'Ћw->GI*S\r6\"iQFN', '', 0, '?'),
 ('>E+)bx~', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-downloads.php', 0, '8R[kQ9c', '8R[kQ9c', '6G{k@:D\Zބ$\'|2C', '', 0, '?'),
 ('I!!=\\b', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-orders.php', 0, 'TB~%:\n', 'TB~%:\n', 'ERnx.\\K!]wp6', '', 0, '?'),
 ('od5\0lh;Gk', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/navigation.php', 0, '[o\Z>}Ǩ', '[o\Z>}Ǩ', 'ָ%B(\\<4p\'C\Z~8', '', 0, '?'),
 ('`8D*.\0J', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/orders.php', 0, 'vx6̮JC', 'vx6̮JC', '2)jo..yY.BV\n', '', 0, '?'),
 ('MY*kE#', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/payment-methods.php', 0, '=5߰<$Dm', '=5߰<$Dm', '2Iy	ZXIB\"̀T:wgˇ', '', 0, '?'),
 ('Ujߤ}X5iO', 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/view-order.php', 0, ':{\Zy}y$', ':{\Zy}y$', 'Dȑn|Ed!o	˧CUq', '', 0, '?'),
 ('\Z@\ZڸT', 'wp-content/updraft/plugins-old/woocommerce/templates/notices/error.php', 0, '} f2|+3m|', '} f2|+3m|', '#k\\ރ)2;q5n![g\0', '', 0, '?'),
 ('Ssi`J', 'wp-content/updraft/plugins-old/woocommerce/templates/notices/notice.php', 0, 'R{ٲH4#q', 'R{ٲH4#q', 'H\nOUp`_`blKXK?o', '', 0, '?'),
 ('8gPWR쮉!.', 'wp-content/updraft/plugins-old/woocommerce/templates/notices/success.php', 0, 'H0|6?k399', 'H0|6?k399', '$hD1Hzc`RZˋ', '', 0, '?'),
 ('caNUGTh;(c', 'wp-content/updraft/plugins-old/woocommerce/templates/order/form-tracking.php', 0, 'ˏ*\n	A', 'ˏ*\n	A', '#ua\\ުaQ^ݫhIR	', '', 0, '?'),
 ('LE=c', 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-again.php', 0, 'sS|90&m ', 'sS|90&m ', 'q.!odl`	I:#p=(IE (', '', 0, '?'),
 ('҅΍RL:h', 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-details-customer.php', 0, 'MVQ\"u&3', 'MVQ\"u&3', 'r\'\n))S|\Z v', '', 0, '?'),
 ('Q5TpĸF', 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-details-item.php', 0, 'n7qs]YZw', 'n7qs]YZw', 'Á~\0ssu+=&J;\\+)\'!r`', '', 0, '?'),
 ('4{0EӨ5F', 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-details.php', 0, 'y^EΥPKdY', 'y^EΥPKdY', '~Z@qEɵHR$~><)oPK', '', 0, '?'),
 ('_:MmrI', 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-downloads.php', 0, '6]eh:', '6]eh:', '˞*4Pe\rfqMe', '', 0, '?'),
 ('>;_/!ɼl$', 'wp-content/updraft/plugins-old/woocommerce/templates/order/tracking.php', 0, 's>\\fۦW', 's>\\fۦW', 'ح_AkoP~`;Vmϔgj', '', 0, '?'),
 ('I.5O˰zy', 'wp-content/updraft/plugins-old/woocommerce/templates/product-searchform.php', 0, 'ֽ,O)t|e', 'ֽ,O)t|e', '0\"̩ه.\"RM/-)\\1', '', 0, '?'),
 ('Mr&3UOh%\"F\\\r9', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/external.php', 0, 'DN\'awkcuce', 'DN\'awkcuce', 'tN,-v\"Эc(ղBY', '', 0, '?'),
 ('!\"h=sznз', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/grouped.php', 0, '}f+ d]\"@Vz*', '}f+ d]\"@Vz*', 'aB3-e4d[E`c5{b&k', '', 0, '?'),
 ('!.uxwO', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/simple.php', 0, 'd,\r\rHg', 'd,\r\rHg', '.LR\rPwOq5\r.y9F|', '', 0, '?'),
 ('n/	k	pf&', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/variable.php', 0, '$vXGJ\ZzK)Dd', '$vXGJ\ZzK)Dd', 'cN1)fr߫p78A>\n(b', '', 0, '?'),
 ('EB.LIuG', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/variation-add-to-cart-button.php', 0, 'aB|_`B', 'aB|_`B', '|\Z@x!SM{!`Lz/::\0', '', 0, '?'),
 ('ɣ`ˁvϙD', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/variation.php', 0, '周>8r.l(O', '周>8r.l(O', 'eZE:,6}', '', 0, '?'),
 ('\\\"ʦ7_ZwB', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/meta.php', 0, '0Jp;tW8', '0Jp;tW8', 'u?.*b-RWa\\GkwѓWSh', '', 0, '?'),
 ('\r-4P[C5', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/photoswipe.php', 0, '`da\0\"_uıq', '`da\0\"_uıq', '\0|Qn57{}Aֻ&', '', 0, '?'),
 ('8?9:9ת', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/price.php', 0, 'uBY̹!Q ', 'uBY̹!Q ', 'Edy;@kqGB+U-x-Y', '', 0, '?'),
 ('f Hd\\^~=p', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/product-attributes.php', 0, 'hJ-m;:Oz', 'hJ-m;:Oz', 'ʗqxLXЖuf)w2AJdB%', '', 0, '?'),
 ('u*Grfw<i*L', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/product-image.php', 0, '\0E.mVc', '\0E.mVc', 'q99|(Gד9R±Oe3', '', 0, '?'),
 ('sr]MLL\'', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/product-thumbnails.php', 0, '܂)֭\\5\Z3\'-Q', '܂)֭\\5\Z3\'-Q', '|c .n3X<5dȩ%7zD', '', 0, '?'),
 ('Id?;', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/rating.php', 0, '\ZX 7', '\ZX 7', 'JT1ew\'\rZjw [', '', 0, '?'),
 ('kj%8Ex~Vo', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/related.php', 0, '|EQj?7\rp!', '|EQj?7\rp!', 'C?8k`ÕshqdH(aq', '', 0, '?'),
 ('⵴+yEh#', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/review-meta.php', 0, 'L|ٝu', 'L|ٝu', '+:K[O\'k6,&', '', 0, '?'),
 ('cˤlxSvB', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/review-rating.php', 0, ' q^Y(G', ' q^Y(G', '\n?R$}Gٛ٣|TJ\",i', '', 0, '?'),
 ('0>s	4^N', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/review.php', 0, '4d**bhUg;', '4d**bhUg;', 'g:a(?(1[|nSdhZ', '', 0, '?'),
 ('V+kI/#', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/sale-flash.php', 0, '>eR+ɢ3s', '>eR+ɢ3s', '}Shg	FeNޏͼd', '', 0, '?'),
 ('F7wґۢ2k', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/share.php', 0, 'p텫gVXp&JI', 'p텫gVXp&JI', 'Tgu#V|ZiKy(#=', '', 0, '?'),
 ('CgT\\%', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/short-description.php', 0, 'S^9RJ^ELCy]', 'S^9RJ^ELCy]', 'Z:XxS04\ngMzT|', '', 0, '?'),
 ('\r`mJl', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/stock.php', 0, '4fa$}MGGt-', '4fa$}MGGt-', '\n\nDhWŔy5LF3}~~v\'', '', 0, '?'),
 ('l9507\r<\\', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/tabs/additional-information.php', 0, 'QZVf&JA', 'QZVf&JA', '}5!F,C4*kmX(J', '', 0, '?'),
 ('*	?IU', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/tabs/description.php', 0, 'm\\Գ0\rM', 'm\\Գ0\rM', 'il[vRw&0ZLL{FG', '', 0, '?'),
 ('.G&s[R', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/tabs/tabs.php', 0, '7%R,^]', '7%R,^]', '{nsl3@9iEEvJ', '', 0, '?'),
 ('hf cRNCݺ', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/title.php', 0, '9M7%@b%*', '9M7%@b%*', '/?#Pjr1{t;c', '', 0, '?'),
 ('L\ZYVI0;', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/up-sells.php', 0, 'KEPf', 'KEPf', 'qA}*\\+L691~Б L', '', 0, '?'),
 ('#kc5yx1', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product-reviews.php', 0, 'NFN=Noʹ	', 'NFN=Noʹ	', 'ԋBߚ-7g7ą\'\r3bek', '', 0, '?'),
 ('(;ۜI,SE', 'wp-content/updraft/plugins-old/woocommerce/templates/single-product.php', 0, 'w|d', 'w|d', 'CIhAr4su^*<KŔ0T', '', 0, '?'),
 (';#u&lM	s1ƻ', 'wp-content/updraft/plugins-old/woocommerce/templates/taxonomy-product_cat.php', 0, '6mFms_A', '6mFms_A', 'oP/\"Dy]&iޚ}R', '', 0, '?'),
 ('MmB[To', 'wp-content/updraft/plugins-old/woocommerce/templates/taxonomy-product_tag.php', 0, 'A*,*|>', 'A*,*|>', 'IЌu\r~ʬbż\rOC<nV ', '', 0, '?'),
 ('^;zU6k2-/\'', 'wp-content/updraft/plugins-old/woocommerce/uninstall.php', 0, '寅䮣뼉', '寅䮣뼉', 'I*hغÎ)\'=z힨4\r\09', '', 0, '?'),
 ('qY.f:', 'wp-content/updraft/plugins-old/woocommerce/vendor/autoload.php', 0, 'k˓G^߲Gmx', 'k˓G^߲Gmx', 'QyQ%2M42AXUd:̠', '', 0, '?'),
 ('4n4ʃ묿6@VD', 'wp-content/updraft/plugins-old/woocommerce/vendor/autoload_packages.php', 0, 'i}v$-,&P', 'i}v$-,&P', 'XM)r5to(К\ZԴ|', '', 0, '?'),
 ('BoAk8@', 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-autoloader/src/AutoloadGenerator.php', 0, '߬	Ew[kL_\Z', '߬	Ew[kL_\Z', '7c(x\n2奵T6Ƞ+?2C', '', 0, '?'),
 ('Ecyo', 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-autoloader/src/CustomAutoloaderPlugin.php', 0, '\Zx}~\'SBȁ_=it', '\Zx}~\'SBȁ_=it', 'LOd&mtҸsR<ÜY', '', 0, '?'),
 ('F\nހX;	q', 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-autoloader/src/autoload.php', 0, '&UjnA ', '&UjnA ', '`@%H&i좻q$FqjA&t\n', '', 0, '?'),
 ('q		+\0*OpXh', 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-constants/src/class-constants.php', 0, '룆Xݜ\\', '룆Xݜ\\', 'f(tk:z.7x)<kw9!Ny', '', 0, '?'),
 ('\rWh.', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/ClassLoader.php', 0, '|%*T*`', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 ('5S|2S@#?һ', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_classmap.php', 0, ',h:8|s', ',h:8|s', '0B7)_]R!adnUp!d2', '', 0, '?'),
 ('P}!fH', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_classmap_package.php', 0, 'Q=\'Ʈ.j,', 'Q=\'Ʈ.j,', ')KAMp~w{Oc[c)', '', 0, '?'),
 ('<\0	i@0E+\Z', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_namespaces.php', 0, '5,}vĨ3G)', '5,}vĨ3G)', 'Er4@\0ԡ$z3$l\Z`iexl', '', 0, '?'),
 ('lƤP', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_psr4.php', 0, '$=GVLIf', '$=GVLIf', 'My+54H\'`oO\\yȼQuG', '', 0, '?'),
 ('{h+-', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_real.php', 0, 'Pj&\r\'YJ', 'Pj&\r\'YJ', '^ʵtjd[\n$', '', 0, '?'),
 ('\\]J֙h%', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_static.php', 0, 'i Z;nEB(*', 'i Z;nEB(*', '2mp*E`>bHDrOtj>yY', '', 0, '?'),
 ('fh{)_|72Ra', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AglInstaller.php', 0, 'Cc=W*Dg', 'Cc=W*Dg', '3(W~;M<dz4', '', 0, '?'),
 ('Z (t2v	', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AimeosInstaller.php', 0, 'EWMi6=<*@}m', 'EWMi6=<*@}m', 'DRV\\ŭ<7ty	,8YmL', '', 0, '?'),
 ('g>\'lx=$bAG|', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AnnotateCmsInstaller.php', 0, '1csDh%[p!4\"', '1csDh%[p!4\"', ';<EU%HwDDˋ8T', '', 0, '?'),
 ('_v-`̄X}', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AsgardInstaller.php', 0, 'LJM', 'LJM', 'V\n#\nA@,c]:a# a\n&7', '', 0, '?'),
 ('4>m!\0', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AttogramInstaller.php', 0, 'oGE\r', 'oGE\r', '}DlqX\"aGGuVX}=', '', 0, '?'),
 ('i\Z,rJqצ', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/BaseInstaller.php', 0, '!mV9q}', '!mV9q}', 't.tX@iZT7&\\&-Yd', '', 0, '?'),
 (';HCȦW#', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/BitrixInstaller.php', 0, 'h!fŪe%Q', 'h!fŪe%Q', 'XTQms`DPç,|쫺d8', '', 0, '?'),
 ('$Jg,Sm', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/BonefishInstaller.php', 0, 'u\".O	\"O-B', 'u\".O	\"O-B', '`Ś睤ybktBI', '', 0, '?'),
 ('V,/c2jZ', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CakePHPInstaller.php', 0, '6k_sx', '6k_sx', 'h;[8{ܠ^xx\r', '', 0, '?'),
 (':?\Zs3', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ChefInstaller.php', 0, 't&r@;f', 't&r@;f', 'iifzΰP\\B<Wٴp2,T', '', 0, '?'),
 ('\r%UPԑ!6', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CiviCrmInstaller.php', 0, 'eSu-՘}', 'eSu-՘}', 'ix_Kn&F:ra0', '', 0, '?'),
 ('8T}ܓk', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ClanCatsFrameworkInstaller.php', 0, '՝Vo5ڐ\\', '՝Vo5ڐ\\', '>9Y\rYOC4huG[', '', 0, '?'),
 ('B\r0tUT', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CockpitInstaller.php', 0, '֗6>,!', '֗6>,!', 'Sſ`0$ RW>c:5ΚMä', '', 0, '?'),
 ('{)v{|cf+q;B', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CodeIgniterInstaller.php', 0, 'H=u]R9', 'H=u]R9', 'Km}DS7ښL<ya', '', 0, '?'),
 ('H}ya-5', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Concrete5Installer.php', 0, 't	m!~A^S', 't	m!~A^S', '#L?OM6r/W_~', '', 0, '?'),
 ('}r)ٜ?T ˟ ', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CraftInstaller.php', 0, 'إg]b', 'إg]b', 'gD>IB9LI	*1160C|', '', 0, '?'),
 ('~/0Yf', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CroogoInstaller.php', 0, 'AvE\"M\\M', 'AvE\"M\\M', '4(eI892-뱎ļ~]', '', 0, '?'),
 ('xԓ|7NWn@', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DecibelInstaller.php', 0, '+r\"`lҮvv', '+r\"`lҮvv', '#5}͏	\\fWİ~C`Oc,', '', 0, '?'),
 ('\ri)Phrn', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DframeInstaller.php', 0, ';<JE&$dc', ';<JE&$dc', 'q%>D$$:jk z;', '', 0, '?'),
 ('ܛw!SόYj', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DokuWikiInstaller.php', 0, '}=%7\\8V', '}=%7\\8V', 'wHp[w2@u\Z\"LHa6Q', '', 0, '?'),
 ('!zik', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DolibarrInstaller.php', 0, '	m_d&Ժ0w', '	m_d&Ժ0w', '0슿ksφz@ⱇ)T+', '', 0, '?'),
 ('5D=D_F=)', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DrupalInstaller.php', 0, '\ZE_r9?Z', '\ZE_r9?Z', 'c\r`t܅4Lʝjo:#u##Y', '', 0, '?'),
 ('!z\rEda', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ElggInstaller.php', 0, 'Ṕxǐ', 'Ṕxǐ', 'DmMY|x\"<ALfpx3)H\"', '', 0, '?'),
 ('v|oNEx', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/EliasisInstaller.php', 0, ':8ٷI', ':8ٷI', '\0x\Za&*U<Ƌ]yܻ', '', 0, '?'),
 ('5rvͻ,f#', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ExpressionEngineInstaller.php', 0, 'oGY>y*^Y', 'oGY>y*^Y', 'Mr%k!󂥲Ӳz݁	)C', '', 0, '?'),
 ('Usok VD', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/EzPlatformInstaller.php', 0, '@5$uoa ', '@5$uoa ', 'N8f?l}i\Znp}', '', 0, '?'),
 ('plc\r7jn', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/FuelInstaller.php', 0, '^q{3\\g', '^q{3\\g', 'NӮNAWuh#\"8)eM16', '', 0, '?'),
 ('{#xN~$', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/FuelphpInstaller.php', 0, '@K{~tbYb', '@K{~tbYb', '\nȞ]r6	ÚZ{TVc.Gv~', '', 0, '?'),
 ('A*i\".h-', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/GravInstaller.php', 0, '>ޑU@^L]', '>ޑU@^L]', ')LB|@\"UeJEWz ', '', 0, '?'),
 ('s8AB\'1Gʂ', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/HuradInstaller.php', 0, 'U-07\n}m\\^', 'U-07\n}m\\^', 'dTa߰`+>/!!^bg$\n', '', 0, '?'),
 ('mKK@;\Ze6', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ImageCMSInstaller.php', 0, '[}_ەX', '[}_ەX', ';ܶڏiKx好[\0ܥ}*3', '', 0, '?'),
 ('CC\03O[', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Installer.php', 0, '\'	L}RV', '\'	L}RV', ']^l`%y/NШXϻN\Z', '', 0, '?'),
 ('}]\0sk\\`\'', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ItopInstaller.php', 0, ',JDũ', ',JDũ', '8}+{3{9\nBx=\'0', '', 0, '?'),
 ('igDޞ4', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/JoomlaInstaller.php', 0, '\0fHpg!NO\'', '\0fHpg!NO\'', 'ߓ2ns?AN\ng;', '', 0, '?'),
 ('BX~{', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KanboardInstaller.php', 0, '*3]<]\'', '*3]<]\'', 'нrt}Q7@I=}amu(Q', '', 0, '?'),
 ('S<bخM', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KirbyInstaller.php', 0, '(J_?+4h', '(J_?+4h', '	<?~C2B ?', '', 0, '?'),
 ('HB$W4O׵', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KnownInstaller.php', 0, 'H.(N7\r', 'H.(N7\r', '_Gd11gY1~>B$tX', '', 0, '?'),
 ('\Z!v{e', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KodiCMSInstaller.php', 0, 'X_c\'xM9', 'X_c\'xM9', '`S,wD9kC\05β19jB[', '', 0, '?'),
 (']bcMD', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KohanaInstaller.php', 0, 'Z \"I/', 'Z \"I/', '\"[&Pz>|֪!HX1b', '', 0, '?'),
 ('C6B::7', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LanManagementSystemInstaller.php', 0, 'Pf9O6{l', 'Pf9O6{l', 'X>>2򽿉=I̱FҁKŝl\"', '', 0, '?'),
 ('$ ϞgI<n[', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LaravelInstaller.php', 0, '=`w26d', '=`w26d', '6ŷWh	0W?ޝYǝm', '', 0, '?'),
 ('E,IU:\"', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LavaLiteInstaller.php', 0, 's@4	\ZDw', 's@4	\ZDw', '+Yv2\ZBP@bHIe4M', '', 0, '?'),
 ('_Ou{a\n\rZ8S', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LithiumInstaller.php', 0, '!{hȡR2˪퀨6', '!{hȡR2˪퀨6', '(1qKCD?~Ԩ~OT $&~#>', '', 0, '?'),
 ('-cgI(#eK', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MODULEWorkInstaller.php', 0, '٢j@\nN', '٢j@\nN', 'pv$L΋,*ʸ/;R˥', '', 0, '?'),
 ('\r2g҅ɏ1\"q\0', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MODXEvoInstaller.php', 0, ' Ќ~^F', ' Ќ~^F', '(o8@.z۹	\n!q66bp}', '', 0, '?'),
 ('Wd-z>pR', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MagentoInstaller.php', 0, '{Fs', '{Fs', 'CfjI\0QnmJI*', '', 0, '?'),
 ('˲60uݚX', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MajimaInstaller.php', 0, 'XU+4]\nj2` ', 'XU+4]\nj2` ', 's)Wg>\0vw@Ceц', '', 0, '?'),
 ('>\rn@AA*ڋG', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MakoInstaller.php', 0, '6gO5| ', '6gO5| ', 'pns#dF$W͕(Q76', '', 0, '?'),
 ('W\0', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MauticInstaller.php', 0, ';y%poѨ', ';y%poѨ', '_/y1R%+a-DY6	,,', '', 0, '?'),
 ('RRpr~hX5', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MayaInstaller.php', 0, 'g\0p	f/l:', 'g\0p	f/l:', ')_TM\"4\0ٜ(', '', 0, '?'),
 ('nhvf=̽', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MediaWikiInstaller.php', 0, 'd3ͮ%.Y', 'd3ͮ%.Y', '\n &<j}J̌vn^wo[', '', 0, '?'),
 ('T>׺VF\rn?:Z', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MicroweberInstaller.php', 0, '#[1E=\'?½', '#[1E=\'?½', 'n=}JqY9)fM$&R!w', '', 0, '?'),
 ('ۼfzj)xF:', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ModxInstaller.php', 0, 'DMR{iPc', 'DMR{iPc', '&w\"<?Hf>\ZR1%B', '', 0, '?'),
 ('zv(kvGr', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MoodleInstaller.php', 0, '\"fڞّaϐg', '\"fڞّaϐg', 'Rs4Jqh~chfUFl_`', '', 0, '?'),
 ('yTCBu#', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OctoberInstaller.php', 0, '=\n8u', '=\n8u', '!|\'n{ML;vO1', '', 0, '?'),
 ('<ca7-	Y', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OntoWikiInstaller.php', 0, '0R$|~\nv', '0R$|~\nv', 'kipE0mŗ1tMFeZ\nRR', '', 0, '?'),
 ('h)%f>gk', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OsclassInstaller.php', 0, 'H\'Hyr\n', 'H\'Hyr\n', 'ߓK4e߂S]n', '', 0, '?'),
 ('0Eՠ)m', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OxidInstaller.php', 0, 'KE6P\0I6', 'KE6P\0I6', 'U=^k\\p\'}4֌&dtfhU3[', '', 0, '?'),
 ('o2?iMa\\?', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PPIInstaller.php', 0, 'mĎ妁\r\"Bx~', 'mĎ妁\r\"Bx~', 'PL`\'R<DJU>1D,', '', 0, '?'),
 (']>;;', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PhiftyInstaller.php', 0, 'jB8', 'jB8', 'er5EdH?\ZaARd', '', 0, '?'),
 ('Z\"0H', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PhpBBInstaller.php', 0, '},S=T8', '},S=T8', 'ъcY25%=dt}~^?', '', 0, '?'),
 ('h}', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PimcoreInstaller.php', 0, ';J;`ƒ nH', ';J;`ƒ nH', '\r~$#,[5gtW]I{8r(', '', 0, '?'),
 ('hdfp\r\"', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PiwikInstaller.php', 0, 'u̎#!?5', 'u̎#!?5', 'pi=z+#8=n~}', '', 0, '?'),
 ('R~Rsd>', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PlentymarketsInstaller.php', 0, 'ź>pҸ]T:', 'ź>pҸ]T:', 'lO|TKf.`~4,XvIt', '', 0, '?'),
 ('7T\re]', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Plugin.php', 0, 'Y9:<ﳽйS', 'Y9:<ﳽйS', 'δ:v%Ȟ#{GBWG', '', 0, '?'),
 ('\0ЯܖtK1', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PortoInstaller.php', 0, '`	={`F\ZG7', '`	={`F\ZG7', 'c6y )Sq![dkm', '', 0, '?'),
 ('Tv3oaGP', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PrestashopInstaller.php', 0, '!Hh', '!Hh', '9.YlSAXNo*bl', '', 0, '?'),
 ('DUA/gv', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PuppetInstaller.php', 0, 'bUyͅ\08', 'bUyͅ\08', 'bSx\\hT/[ĭux+)D+n<', '', 0, '?'),
 (']4=8G:6(', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PxcmsInstaller.php', 0, '0v-T8', '0v-T8', 'i;Hʳ=wRm:@6C|Q	,', '', 0, '?'),
 ('~y؟U\'', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/RadPHPInstaller.php', 0, 'R\"	\r{9q+E^[', 'R\"	\r{9q+E^[', 'Ol]%$RCombTr>\ZG', '', 0, '?'),
 ('joY{$z-\\', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ReIndexInstaller.php', 0, 'OÝY,\\-\Z*', 'OÝY,\\-\Z*', 'V#|q1Vׁ-(#خ3-', '', 0, '?'),
 ('QY+\Z˃.J', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Redaxo5Installer.php', 0, ')^R!-', ')^R!-', '``1\02\'UA݌ !^B', '', 0, '?'),
 ('cm;d', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/RedaxoInstaller.php', 0, 'F[|.1x	&XfN', 'F[|.1x	&XfN', 'Dm1%nݛ_dr \rJ3Tr', '', 0, '?'),
 ('d<U=rPP~o', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/RoundcubeInstaller.php', 0, 'lcc*~j=p*u', 'lcc*~j=p*u', '<&J#s\\.,G$lt<IW5', '', 0, '?'),
 ('\n[|eV#$', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SMFInstaller.php', 0, '8I0mj@0%U', '8I0mj@0%U', '{{o]vrlSaXrPΓ?%.E', '', 0, '?'),
 ('e,OwGure j', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ShopwareInstaller.php', 0, 'KKyޫpr]', 'KKyޫpr]', '\Z\n=I#Z\\4l֙u`', '', 0, '?'),
 ('hgvB', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SilverStripeInstaller.php', 0, 'P-^03͙5', 'P-^03͙5', '>-且T	1&047lT', '', 0, '?'),
 ('P᱆*N', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SiteDirectInstaller.php', 0, 'Y6oz/C', 'Y6oz/C', 'e׺k+oC @ƹOK<hS_', '', 0, '?'),
 ('FUs?\nI5R', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SyDESInstaller.php', 0, 'W}B=H', 'W}B=H', 'jPG\ruDc=p\Ztzm6=', '', 0, '?'),
 ('ڊ!\"y^Q', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Symfony1Installer.php', 0, 'LQ\09mM', 'LQ\09mM', '|3,Ux`i@?f.@F/x}h#', '', 0, '?'),
 ('	Ͱ8{', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TYPO3CmsInstaller.php', 0, 'OEeZYE&', 'OEeZYE&', 'WsGr(Q9A_©>+\'', '', 0, '?'),
 ('iڪoc}', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TYPO3FlowInstaller.php', 0, ',oFD:N4', ',oFD:N4', 'jKbʍy,`y5ofڮ_e', '', 0, '?'),
 ('yhKDhM~', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TaoInstaller.php', 0, '^7Y+\Z͟UC', '^7Y+\Z͟UC', '%WJ5^U7}Z0gw', '', 0, '?'),
 ('Y4$}،}', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TheliaInstaller.php', 0, 'R#tXɃt}7FI7', 'R#tXɃt}7FI7', '1xk_,_{p\'-Zʻ', '', 0, '?'),
 ('$4\Z:ѳboew', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TuskInstaller.php', 0, 'R\\L뺵\'Q', 'R\\L뺵\'Q', '0&MsԎ̩c|	av', '', 0, '?'),
 ('nUɽo', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/UserFrostingInstaller.php', 0, 'Bмzֵ_', 'Bмzֵ_', 'V-2޸<n{s?IݸW>fs(', '', 0, '?'),
 ('ދ\ZU>z9V', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/VanillaInstaller.php', 0, '$c63>nM\"', '$c63>nM\"', 'd1ޙGp#\\3f\'.', '', 0, '?'),
 ('i\"9;NѴ׺', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/VgmcpInstaller.php', 0, 'zr>U<z1xe', 'zr>U<z1xe', '2LY6[Sj@K#', '', 0, '?'),
 ('zܢlF\'!҅3', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/WHMCSInstaller.php', 0, 'HW7PA,Ix\'', 'HW7PA,Ix\'', '>:iIsk~+Kl)si', '', 0, '?'),
 ('k1pݰ&', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/WolfCMSInstaller.php', 0, 'LĜLȐr4r', 'LĜLȐr4r', '\r&s3H)CN)1\nJ', '', 0, '?'),
 ('JkӇH', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/WordPressInstaller.php', 0, 'ՁU3ҾPm', 'ՁU3ҾPm', 'oa/jnuFX]S{u', '', 0, '?'),
 ('xPoIݴie', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/YawikInstaller.php', 0, 'UR)}g)vWs', 'UR)}g)vWs', 'QT@k\"!9Ca', '', 0, '?'),
 ('[=wu蕵b', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ZendInstaller.php', 0, '<TW<l0ӵ', '<TW<l0ӵ', 'ۡ-ON~*_>g<', '', 0, '?'),
 ('Ѧß$.', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ZikulaInstaller.php', 0, 'K8Idpo?E', 'K8Idpo?E', 'T!H	ؘ,Ca~KOPJ9', '', 0, '?'),
 ('6y&:\"F)*', 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/bootstrap.php', 0, 'Ɲ\n%\0', 'Ɲ\n%\0', 'g&AgpI84\ZBj', '', 0, '?'),
 ('GY,', 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/autoload.php', 0, 'V~МIXP/$', 'V~МIXP/$', 'sem/;֘ aZH`g3', '', 0, '?'),
 ('};t$Ôy', 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Decoder.php', 0, 'X&p+N<Lz\"+', 'X&p+N<Lz\"+', '\0})ŵcIT@.in~$@qaT', '', 0, '?'),
 ('uccfk', 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/InvalidDatabaseException.php', 0, '!f(\'AU', '!f(\'AU', 'u^#w\"ψRf7V		J-3A7', '', 0, '?'),
 ('W\";[	qܶ!', 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Metadata.php', 0, 'nɮT}', 'nɮT}', 'SBrkrEi\r>1מ*O', '', 0, '?'),
 ('A~ESZ۩g[', 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Util.php', 0, 'g+کdݬ@', 'g+کdݬ@', 'wbjYStc IdQ', '', 0, '?'),
 ('\"F`Eґd', 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader.php', 0, 'ykHa*UN', 'ykHa*UN', 'HA~mM\Zt仝f֡^Tj /d', '', 0, '?'),
 (' Y;&ɤլ', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/CssInliner.php', 0, 'r۶*\ZCײs2R', 'r۶*\ZCײs2R', 'q3u\'\'Zv<x~㢰#Vڰ$', '', 0, '?'),
 ('<AV3O4apWƊ', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/AbstractHtmlProcessor.php', 0, '[eD)', '[eD)', 'zsj	l)>afgR1B˱HԱ/', '', 0, '?'),
 ('^:`MĹ', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/CssToAttributeConverter.php', 0, 'M9(,Gwi', 'M9(,Gwi', 'g],hڔR\nq|?*AVH$\r', '', 0, '?'),
 ('.xKK u߫a', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/HtmlNormalizer.php', 0, '` }gz\rVX;|', '` }gz\rVX;|', 'QZUF7Yqxv}nၰ]7', '', 0, '?'),
 ('6zI$|`X', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/HtmlPruner.php', 0, '~sj4pgA', '~sj4pgA', '4WM\\:EQ0:El&;\'R?', '', 0, '?'),
 ('3KoX5g!cA', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/Utilities/ArrayIntersector.php', 0, '\0?%,\\', '\0?%,\\', 'v{w\rEm;;WkfT߀Y\'', '', 0, '?'),
 ('(ߊ\\9M', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/Utilities/CssConcatenator.php', 0, '^*ѣp', '^*ѣp', 'Sy#csaW#&,iL`', '', 0, '?'),
 ('BoGB7z', 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier.php', 0, '=JQW\Z', '=JQW\Z', '	\"\ZQN_<k$3_Q', '', 0, '?'),
 ('#$oF|Supp', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/CssSelectorConverter.php', 0, 'HuW)Zy Q', 'HuW)Zy Q', 'navy9\'U6ɱEwꩧ', '', 0, '?'),
 ('txUezFM<', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/ExceptionInterface.php', 0, 'V9p', 'V9p', 'vDr8j?\ZwJ+%~ c#h\'\\', '', 0, '?'),
 ('+]7_8vwi', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/ExpressionErrorException.php', 0, 'ʓ/9&F0V\"\"', 'ʓ/9&F0V\"\"', 'KibTߚӸwQK', '', 0, '?'),
 ('NouKŭ%L({\n', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/InternalErrorException.php', 0, ']Jʑ*', ']Jʑ*', '`-W]yn-%l+VqZ1/_ m9p', '', 0, '?'),
 ('lNZLŧ34\"%a', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/ParseException.php', 0, 'ͻI)ys5ga>Ә', 'ͻI)ys5ga>Ә', 'AkwkOq6I̢iCJM\Zqb', '', 0, '?'),
 ('J1aTFJ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/SyntaxErrorException.php', 0, '<?3A9', '<?3A9', 'gT2E$Ï`=Z~_', '', 0, '?'),
 ('w9:ʙh', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/AbstractNode.php', 0, 'VO$v҇', 'VO$v҇', '9D٠t{-J白GdE*', '', 0, '?'),
 ('iL1-J', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/AttributeNode.php', 0, '%NrJ', '%NrJ', '	\'40kBhHR!-~H`?bt*ݾNF', '', 0, '?'),
 ('-^L\0?E', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/ClassNode.php', 0, 'ů+sSlC', 'ů+sSlC', 'y\\Bwә)R`HwIy', '', 0, '?'),
 ('kbaybC]', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/CombinedSelectorNode.php', 0, 'rl:u\Z-', 'rl:u\Z-', 'I.őUsoն};YKq;>\"', '', 0, '?'),
 ('?IO5hw\05]KC', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/ElementNode.php', 0, 'GUG8G', 'GUG8G', 'F	Ѵt{	32RY6c:H]', '', 0, '?'),
 ('\"փsԟ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/FunctionNode.php', 0, 'a!{z5^<2%\0:', 'a!{z5^<2%\0:', '{H,j6=䯟EK8f/wfi', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('Pƣ*]>U\\', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/HashNode.php', 0, 'PGSM[b', 'PGSM[b', 'yjJn/#LnGyTrv5u|D', '', 0, '?'),
 (',Rǯe:', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/NegationNode.php', 0, ';(FQYxPY', ';(FQYxPY', 'e5a,_>WOQ\"\0\rE', '', 0, '?'),
 ('C֐+Vu\\0', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/NodeInterface.php', 0, '\0u\ZCH$r', '\0u\ZCH$r', 'CME\'D[0NN3\r+M5&tdc', '', 0, '?'),
 ('BMf2س94', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/PseudoNode.php', 0, '/1H!;L֮wo', '/1H!;L֮wo', '(\0;šby>]31;!\ncc', '', 0, '?'),
 ('GyQ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/SelectorNode.php', 0, '@ՌAG[k~', '@ՌAG[k~', '-\\>͏qдDw]\rSS', '', 0, '?'),
 ('׬zڡ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/Specificity.php', 0, 'q3{U]M', 'q3{U]M', ' nx>#[M08]~', '', 0, '?'),
 ('3b1jI])j', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/CommentHandler.php', 0, ')b΢@BIyG', ')b΢@BIyG', 'YpKԣ1˻U$@)2]|#tM\n', '', 0, '?'),
 ('}\rb8\"!X#', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/HandlerInterface.php', 0, '1Ƀ[c+$', '1Ƀ[c+$', 'd\\\\QF	YBم\rFoWq4ff', '', 0, '?'),
 ('<\Znh', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/HashHandler.php', 0, '	iCKXݗ', '	iCKXݗ', 'r%O>f8UKJld|', '', 0, '?'),
 ('֊8\ZJWS,', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/IdentifierHandler.php', 0, ' \\cx4P\n', ' \\cx4P\n', '0AGߔo\\', '', 0, '?'),
 ('$.tp+?', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/NumberHandler.php', 0, 'qt}Ɯ(?)0\0', 'qt}Ɯ(?)0\0', 'i#\r\"d\\GN$`XX', '', 0, '?'),
 ('IPxc|', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/StringHandler.php', 0, 'O3ʋQ', 'O3ʋQ', '\\c\Z{BʏH/R 꾾#Z', '', 0, '?'),
 ('=T[ؒjgK ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/WhitespaceHandler.php', 0, 'lB\"fr', 'lB\"fr', '6`B+O)Q/抔yއ', '', 0, '?'),
 ('Ce?Q	ds', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Parser.php', 0, '\'9xu[|G@', '\'9xu[|G@', 't4T\\*f?Zk?!_\ZnUeYJ', '', 0, '?'),
 ('sd;,;', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/ParserInterface.php', 0, 'Us&]W1', 'Us&]W1', 'CZ¤ [e<``[-^', '', 0, '?'),
 ('И?G}1\ZJŧ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Reader.php', 0, '\Z^u4r', '\Z^u4r', 'Z=\\bEhGGBi}x\\', '', 0, '?'),
 (']ĳ8a<', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/ClassParser.php', 0, 'DR(uRΌy<+', 'DR(uRΌy<+', '\"9.h!f*Pp', '', 0, '?'),
 ('j6Wnqk', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/ElementParser.php', 0, '`TdJ=).', '`TdJ=).', 'QmWqn _3LR?', '', 0, '?'),
 ('.wQ.mc', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/EmptyStringParser.php', 0, '|:KTXh', '|:KTXh', 'ф24>I{0,|$\\ZУN', '', 0, '?'),
 ('iOqlWHXl', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/HashParser.php', 0, '<=7cmԤ\n85', '<=7cmԤ\n85', '<ӷb|NVDbPJ^n1X\r', '', 0, '?'),
 ('(;!Z<3ӻ<', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Token.php', 0, 'hs\n!v', 'hs\n!v', '^t*|mX<_.', '', 0, '?'),
 ('TKr', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/TokenStream.php', 0, '?b2', '?b2', 'c/UX/T^#=\r蘒90ktnB', '', 0, '?'),
 ('\')uy', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Tokenizer/Tokenizer.php', 0, '{/<x.kVc', '{/<x.kVc', 'tx*#A&kԛ1', '', 0, '?'),
 ('[@߯T', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Tokenizer/TokenizerEscaping.php', 0, 'T`1Jle', 'T`1Jle', '7) 9!,Hg-ԨnQ6', '', 0, '?'),
 ('qEH:=:-', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Tokenizer/TokenizerPatterns.php', 0, '\\ҢX3\r!HQ', '\\ҢX3\r!HQ', '>`O$.J.LIR~@', '', 0, '?'),
 ('kr_IYc\n', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/CssSelectorConverterTest.php', 0, 'ItP/-:}T/', 'ItP/-:}T/', 'y>{(h6e;^(bS', '', 0, '?'),
 ('C燦W&`\n', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/AbstractNodeTest.php', 0, 'ʧJe!Gd>', 'ʧJe!Gd>', 'l+\"n?gVua%T\'._O{', '', 0, '?'),
 ('x@6\'', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/AttributeNodeTest.php', 0, '!\rh-GK,)n', '!\rh-GK,)n', '4L)AOnE{z(V', '', 0, '?'),
 ('\\xVY$(', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/ClassNodeTest.php', 0, 'xoxO7)*', 'xoxO7)*', '\Z̦>2uQ:!)\\', '', 0, '?'),
 ('@\Z5:::t3', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/CombinedSelectorNodeTest.php', 0, '߭rMz5Wd', '߭rMz5Wd', 'Z[D9`rscz)]Yj `{Ⳃ', '', 0, '?'),
 ('i5jk', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/ElementNodeTest.php', 0, 'ڌgB|', 'ڌgB|', '/\r\r0E+!ThK0', '', 0, '?'),
 ('F7:l\\', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/FunctionNodeTest.php', 0, ':!\nQU= o', ':!\nQU= o', 'ݖ8sヶ5-,k\\', '', 0, '?'),
 ('!Qלd5', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/HashNodeTest.php', 0, '3 psuFQr)\"', '3 psuFQr)\"', ')x>MmN%F_\r2b[λ8', '', 0, '?'),
 ('ȗ3Q).|', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/NegationNodeTest.php', 0, 'aeDv', 'aeDv', 'Ea@P5bD$\\x\nY', '', 0, '?'),
 ('ȃ(:v2*}', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/PseudoNodeTest.php', 0, '˯TYz', '˯TYz', '$63cn`:<o<^w', '', 0, '?'),
 ('tȡoSѻvr', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/SelectorNodeTest.php', 0, 'k[[Z._1҄', 'k[[Z._1҄', 'G8JfdjnB9%1qo}Z/', '', 0, '?'),
 ('\"|{z', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/SpecificityTest.php', 0, '6ms?Y\nSM', '6ms?Y\nSM', '[w<.\n\nZ', '', 0, '?'),
 ('Rhu\n\'', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/AbstractHandlerTest.php', 0, '5q1<u', '5q1<u', '0E4M)g\0S<x\r', '', 0, '?'),
 ('eKl,yB', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/CommentHandlerTest.php', 0, '+t/T_', '+t/T_', 'ڪɚ&eë|b!qH', '', 0, '?'),
 ('P핈je9`', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/HashHandlerTest.php', 0, 'M~wo \nu', 'M~wo \nu', '1=#esҭpՄ8W', '', 0, '?'),
 ('g}hTk<]Fl', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/IdentifierHandlerTest.php', 0, 'a+Z/iS', 'a+Z/iS', '*Xj&PiP@LoЗ}3㗂', '', 0, '?'),
 ('(kE_]', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/NumberHandlerTest.php', 0, 'eя9Y4˅>{\r', 'eя9Y4˅>{\r', 'C7_̖RB;7bZMɦ', '', 0, '?'),
 ('aL΋1M%', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/StringHandlerTest.php', 0, 'Qy2UAv\rȂ', 'Qy2UAv\rȂ', 'g6m!ퟋs3H@zT[j2r,', '', 0, '?'),
 ('].Ǳ޻NwG', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/WhitespaceHandlerTest.php', 0, '1{Tgo3[', '1{Tgo3[', ':ike]ye*i-אZ@O#', '', 0, '?'),
 ('-*2]mD3', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/ParserTest.php', 0, 'C\n)\\Z', 'C\n)\\Z', '_hojJMN{lo)Y!ϻd9', '', 0, '?'),
 ('`³oᮦ%c.', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/ReaderTest.php', 0, 'G$PN', 'G$PN', '.&\n$}5*qχ`Ϲ[', '', 0, '?'),
 ('yL7V/J', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/ClassParserTest.php', 0, '-&[ZŵJY', '-&[ZŵJY', 's\\Զ\0%MGolAtEqq', '', 0, '?'),
 (',;T|}.', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/ElementParserTest.php', 0, 'dJ,Q\'', 'dJ,Q\'', 'FNl\\L*Ywu', '', 0, '?'),
 ('MuMcA{̸^', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/EmptyStringParserTest.php', 0, '5hgl[', '5hgl[', '\\[`f۞QWq ^', '', 0, '?'),
 ('`-0Fǖ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/HashParserTest.php', 0, 'n\0Xƹ/', 'n\0Xƹ/', 'j,\"HRC7;\naZȐC', '', 0, '?'),
 ('؀ḋ@0!;\"\r{', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/TokenStreamTest.php', 0, '.dfQ	{', '.dfQ	{', 'Z5m@ͽMևHe&2', '', 0, '?'),
 ('GƐD|_M{\\㱴', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/XPath/Fixtures/ids.html', 0, 'e}]\n', 'e}]\n', '{T{or\\[}-\nfk', '', 0, '?'),
 ('xf+-YuX', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/XPath/Fixtures/shakespear.html', 0, 'X\nG)ȱ\ZB', 'X\nG)ȱ\ZB', 'N4ʕWA\0(OOT1Y?X', '', 0, '?'),
 ('?	x+Ȯ', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/XPath/TranslatorTest.php', 0, 'BRny̧dDSs', 'BRny̧dDSs', 'G8\"ߚ*I:ap[', '', 0, '?'),
 ('x[\'@Qf', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/AbstractExtension.php', 0, '\"߼{]$>E/h', '\"߼{]$>E/h', 'q0/cӮ\r!\"68./vgۦ3', '', 0, '?'),
 ('1\"\\Ѷ\r=', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/AttributeMatchingExtension.php', 0, '1N[m0', '1N[m0', 'M8c`V\n>#?', '', 0, '?'),
 ('#%ZD6׌6', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/CombinationExtension.php', 0, '|ǐj\r', '|ǐj\r', '%|Jb<HEI)b:1y}u', '', 0, '?'),
 ('qY,N-\r^:', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/ExtensionInterface.php', 0, '~HiR', '~HiR', 'ΓP\r̈́\"ՂIK\\uG08', '', 0, '?'),
 ('Ķ\'}u)U䖠A', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/FunctionExtension.php', 0, 'QXgw_-Φ\0', 'QXgw_-Φ\0', 'Ft<a	Jsz(7#', '', 0, '?'),
 ('Ԃ\"\\C', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/HtmlExtension.php', 0, 'h4sb؃gE', 'h4sb؃gE', ');¿ken<q', '', 0, '?'),
 ('u)s̊/{,j', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/NodeExtension.php', 0, '6Njo>4ߟR%', '6Njo>4ߟR%', 'uG7OzbEG2г\noó', '', 0, '?'),
 ('oBǼzz', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/PseudoClassExtension.php', 0, '\nĮ₡}t>Ue`', '\nĮ₡}t>Ue`', 'aL+nCDǿ^[H߭R', '', 0, '?'),
 ('^p(JB89XG 2', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Translator.php', 0, '@Z1f\\xlo?<Ax*', '@Z1f\\xlo?<Ax*', '|;xJt6O[x\"LsP<w}^', '', 0, '?'),
 ('TAz1ILq', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/TranslatorInterface.php', 0, '\ZOe#a\"$5', '\ZOe#a\"$5', '%AR@>LN\"(~j1gq4\'擭1', '', 0, '?'),
 ('f]h0USYy', 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/XPathExpr.php', 0, 'z_\0e', 'z_\0e', '- 4>k@0gAg2ƙŉ', '', 0, '?'),
 ('?ۮi#[]%', 'wp-content/updraft/plugins-old/woocommerce/woocommerce.php', 0, 'jǛ5C*', 'jǛ5C*', '&B2!oylUGrF0/9', '', 0, '?'),
 ('tؾ(˼', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/autoload.php', 0, '3Կ:V	U\'', '3Կ:V	U\'', '|<P*tg3dYs/', '', 0, '?'),
 ('} o\"2', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/ClassLoader.php', 0, '|%*T*`', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 ('4\'㷅ӭ+]', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_classmap.php', 0, 'EӤ㭇Mg', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 ('_/Msf', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_files.php', 0, 'oul_4@', 'oul_4@', '6b% \"ʴsJp38ӷSǙ:', '', 0, '?'),
 ('gKڛ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_namespaces.php', 0, '5,}vĨ3G)', '5,}vĨ3G)', 'Er4@\0ԡ$z3$l\Z`iexl', '', 0, '?'),
 ('at\Z@ꌔDes', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_psr4.php', 0, ':\0>}LQ\0', ':\0>}LQ\0', '_U\0]q=Չf\\/	@d\r+v*(', '', 0, '?'),
 ('}dyّ̪J),]', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_real.php', 0, 'Ț)W0\nM', 'Ț)W0\nM', ';3Ub}V k\'Yr\nrH)6', '', 0, '?'),
 (',	!QlW', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_static.php', 0, '3[hkda4p', '3[hkda4p', '&!7^@9NBT*8', '', 0, '?'),
 ('%h*JĆ\"!o', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/byte_safe_strings.php', 0, 'h`VAf', 'h`VAf', '<\\G;1#kLà(փ', '', 0, '?'),
 ('VK!', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/cast_to_int.php', 0, '$]\\', '$]\\', 'ؚx\"o*I\nQjT(G\Z.\Z', '', 0, '?'),
 ('J60OFZ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/error_polyfill.php', 0, '#fG\rւBg 0', '#fG\rւBg 0', 'c(k12Qw4?0', '', 0, '?'),
 ('I:57VzS%L|', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random.php', 0, 'nH\0u} `', 'nH\0u} `', 'R&Xd[49VI', '', 0, '?'),
 ('bOC-I\rp', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_com_dotnet.php', 0, ' O>A+=\Z,', ' O>A+=\Z,', 'UsDMÙd(\0ā~', '', 0, '?'),
 ('허06s֡', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_dev_urandom.php', 0, '=Y@_x', '=Y@_x', 'ް\Z^3ɟvU.a\r]fhI(sA', '', 0, '?'),
 ('CjwZ;J4K+bw', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium.php', 0, '!EP]ǡ;', '!EP]ǡ;', '<\0\rIB=\"P8D\"L~I[', '', 0, '?'),
 ('ߣ*AvTfu', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium_legacy.php', 0, 'g۰/*C,k#', 'g۰/*C,k#', 'avxu흶j=ISD{!', '', 0, '?'),
 ('iTG&˅:^0Ƭ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_mcrypt.php', 0, 'CZ?@JN_ji<\Z', 'CZ?@JN_ji<\Z', '<H\"F@%1`7<	}', '', 0, '?'),
 ('k#4S5}Ӥ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_int.php', 0, 'JsǙB', 'JsǙB', 'ERJbȸI\"t],qP1\\fD', '', 0, '?'),
 (':e@.Uo(d', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-fast.php', 0, '|K-	', '|K-	', '3\\3L\r?B8X\ZN8wCNU=M', '', 0, '?'),
 ('qʼ߶4Ǽ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-pedantic.php', 0, '~dNc@G#,', '~dNc@G#,', '.\"K|[\0:H/?', '', 0, '?'),
 ('9OEÎ\\{1', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/autoload.php', 0, 'y}Jk>', 'y}Jk>', '/O	¹kbz_B]U', '', 0, '?'),
 ('f\ruo', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/constants.php', 0, '-glrc]\0', '-glrc]\0', 'AB-q=3zfRrWM4V)', '', 0, '?'),
 ('\n݇h2ْ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/namespaced.php', 0, '5@?U', '5@?U', 'Ʊ#q(Ysq)}', '', 0, '?'),
 ('MxAkp\Z', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/php72compat.php', 0, '^R[XITe)', '^R[XITe)', 'u9 :YnU:syg50=	CW5$eA=', '', 0, '?'),
 ('m4KhEU{.:', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/sodium_compat.php', 0, 'Q(P7APؐdh', 'Q(P7APؐdh', 'N~!)Nc~\\n.lFv', '', 0, '?'),
 ('0|[T', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Compat.php', 0, 'QUp~ocÊ4Nt', 'QUp~ocÊ4Nt', 'Lnl2@ΐ>hi,uJYH\\L,B', '', 0, '?'),
 ('𮥦z%.,', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/BLAKE2b.php', 0, '꤀x٠%cl', '꤀x٠%cl', 'N8,caeΟi<5p$', '', 0, '?'),
 ('l`ʖV-\'S8/', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/Ctx.php', 0, 'oL k\'k1', 'oL k\'k1', '1\\Qt*J%s&', '', 0, '?'),
 ('OXvWn', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/IetfCtx.php', 0, 'LaDJ?Z', 'LaDJ?Z', '=F==<_%=M?u/', '', 0, '?'),
 ('`cgtq8U', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20.php', 0, '\0Lv[c)?', '\0Lv[c)?', 'Ch!݀F$}wd7b(!pIF.L', '', 0, '?'),
 ('[jSd+-~/>', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Fe.php', 0, 'թK^㥾', 'թK^㥾', 'M8:naƋGZqQdý!\'&g1', '', 0, '?'),
 ('(lwk6', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Cached.php', 0, 'l\Z^ZHG%O', 'l\Z^ZHG%O', 'mc;\ny㐲0,5F|=C', '', 0, '?'),
 ('Cwf2(˅kjr', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P1p1.php', 0, ' OpR{ҵGݍ', ' OpR{ҵGݍ', 'Y:BP5Ms_.ن֎', '', 0, '?'),
 ('\rgŪS^uȶ}', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P2.php', 0, 'XߓŒ\"X36DQ', 'XߓŒ\"X36DQ', '!l..GI\n7oeѿ\';I\n\n', '', 0, '?'),
 ('i4K a\0H', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P3.php', 0, 'ȑH\Zb>VDR2', 'ȑH\Zb>VDR2', 'rћJԑI/\nOY}xņU ', '', 0, '?'),
 ('}}y.xi7J', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Precomp.php', 0, '7¤\rFg', '7¤\rFg', 'nV\'VV)F|*ᑝ2Nz', '', 0, '?'),
 ('~~tڪw8-@/', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/H.php', 0, 'Hd9<Cˤbl', 'Hd9<Cˤbl', 'K.Boࣸvb%S~1K', '', 0, '?'),
 ('yw>\n(m~!*`', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519.php', 0, '?G{g', '?G{g', 'ĀР<W;-\Z񀍙(C+,MUW6', '', 0, '?'),
 ('+&+=#	{z', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Ed25519.php', 0, 'f<_2S^IZ', 'f<_2S^IZ', 'iݯ8{iq!dՍAz', '', 0, '?'),
 ('g}mu?nNwY', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HChaCha20.php', 0, '#:N\'DxN', '#:N\'DxN', '[_|А~E+~E(`_', '', 0, '?'),
 ('3O+9[۸&4Y', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HSalsa20.php', 0, '-ENĂۛ(\nn', '-ENĂۛ(\nn', 'Ѭ}^EF>ڂB', '', 0, '?'),
 ('E#?]*Й J7v', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305/State.php', 0, '.D6pir`fw=', '.D6pir`fw=', '2KJ73x2M2&+LL', '', 0, '?'),
 ('b4R<Hlr', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305.php', 0, 'uNmSC{', 'uNmSC{', 'P~{p}x{82hXx', '', 0, '?'),
 ('3Krm忕.>+4', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Salsa20.php', 0, 'Pe1', 'Pe1', 'T*+z]ʜ;>\n3]?x', '', 0, '?'),
 ('g]1.jr@^', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/SipHash.php', 0, '}<܎s9', '}<܎s9', 'Q\'r t7=s*a`<zo_', '', 0, '?'),
 ('H.y/', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Util.php', 0, 'diBDJD5O', 'diBDJD5O', 'NaiB\rAO]@P', '', 0, '?'),
 ('y:jy<5', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/X25519.php', 0, 'p0W\"F)8O', 'p0W\"F)8O', '5)&BoK]ػrm`%hO', '', 0, '?'),
 ('43WVs', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/XChaCha20.php', 0, 'zq\Zsq776', 'zq\Zsq776', 'CDa$=f[Q4JW7l).=%', '', 0, '?'),
 ('5Cu~\\V9M?', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Xsalsa20.php', 0, 'CFhz', 'CFhz', 'oő\nwnpL+;~t2P*ƃ6', '', 0, '?'),
 ('cyj.', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Crypto.php', 0, ' oY-)EHd', ' oY-)EHd', 'l,8ETCeylaS;)\'\"d`z', '', 0, '?'),
 ('/W>ii!Zht', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/File.php', 0, '[f0Lş\r{VW', '[f0Lş\r{VW', '\'&ܔ[m`ϊc2E%WGW䉷', '', 0, '?'),
 ('_K2z-H', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Compat.php', 0, '\ZP}>j ', '\ZP}>j ', 'Mya;>p:/f', '', 0, '?'),
 ('6e*Ay', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/BLAKE2b.php', 0, 'Lkm>[?', 'Lkm>[?', 'c+ZY:{\nJPc\"{4u#', '', 0, '?'),
 ('\r4C\"', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/Ctx.php', 0, 'BgY', 'BgY', ':IZCZ8ȰL]m', '', 0, '?'),
 ('Zl3Zŝ}E4	g', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/IetfCtx.php', 0, '\rUCB\"', '\rUCB\"', ')M쩂tUδԪF.', '', 0, '?'),
 ('k}OOsYJ腧', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20.php', 0, 'yW0{XnZ0', 'yW0{XnZ0', '\0AVRXȕ~d^/)@R', '', 0, '?'),
 ('0z]9%|+D{', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Fe.php', 0, 'a!,^q', 'a!,^q', 'X߇pՔZЉֱo\r=˸<!~3', '', 0, '?'),
 ('l[6a!M', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Cached.php', 0, 'yF\\2', 'yF\\2', '2ks\\>RI:nHȿDm!zz', '', 0, '?'),
 ('rJkÇbF,s\0h', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P1p1.php', 0, '8I\Z\nӣ', '8I\Z\nӣ', 'i>zR@kW6uky', '', 0, '?'),
 ('8HG', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P2.php', 0, '\\\ZIw5AlLۢ', '\\\ZIw5AlLۢ', 'K{8fl7sRh嗋I', '', 0, '?'),
 ('?ޱq!iԄ͔', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P3.php', 0, '9V#ҹ4', '9V#ҹ4', 'GpfHv\Zx81C[4A', '', 0, '?'),
 (';(o5', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Precomp.php', 0, '4Kb(\\pB-', '4Kb(\\pB-', 'ճ* ʰ	[q˜Pk', '', 0, '?'),
 ('f^|mm/&', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/H.php', 0, '-_b->O\\苃', '-_b->O\\苃', 'sɔg%riCPw%{J', '', 0, '?'),
 ('6wt?YVP: ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519.php', 0, '4V+=?k\r', '4V+=?k\r', '_x:nOsO:d\'\0N=k', '', 0, '?'),
 ('}hr	`-A7K', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Ed25519.php', 0, 'I%0\\L-', 'I%0\\L-', 'bhppv״O#u 5/=9ň)', '', 0, '?'),
 ('C:Q	GhX', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HChaCha20.php', 0, '+%', '+%', '4!H:6>lEEc#a{A{', '', 0, '?'),
 ('LB5TՉtG', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HSalsa20.php', 0, 'x\\8zM~.', 'x\\8zM~.', 'vR\0S~[\rҮ6o:Ś\r]', '', 0, '?'),
 ('6skӬ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305/State.php', 0, '\Zl쇌1gE', '\Zl쇌1gE', ';}-\Z	Ud)sD%R', '', 0, '?'),
 ('uC)чxY_^(Xn', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305.php', 0, 'ohg[', 'ohg[', '߁.-h4`9S _\r)I(W', '', 0, '?'),
 ('=6)J[]v9\01	', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Salsa20.php', 0, 'CUO\ZߠxtH', 'CUO\ZߠxtH', 'G\n\"_/Agh	U?SsHבYٳ', '', 0, '?'),
 ('RCn}؜h', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/SipHash.php', 0, '{숊z;5!', '{숊z;5!', 'D\ZLޠΔa]n\nL&\n', '', 0, '?'),
 ('vg$9٥', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Util.php', 0, 'ÅKW<S\Z|r_', 'ÅKW<S\Z|r_', 'E`w`>.2V\"\0Mp\r 9', '', 0, '?'),
 ('mF^Kr~h\")', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/X25519.php', 0, 'o>B	IN-y', 'o>B	IN-y', 'hl[(l~QuFM	', '', 0, '?'),
 ('u@R3=^yZ2Cn', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XChaCha20.php', 0, 'zIjcYKC\0', 'zIjcYKC\0', 'PRV*Īi}kVX', '', 0, '?'),
 ('c@e޿N', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XSalsa20.php', 0, 'kFh瀁1-', 'kFh瀁1-', '6!omݎ^.^@˨v7	I}', '', 0, '?'),
 ('	G3zqR8m', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/BLAKE2b.php', 0, 'ͣrZw', 'ͣrZw', '#J<L6zqN0f8Z', '', 0, '?'),
 ('RK䬉QW{', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/Ctx.php', 0, 'F1	M]', 'F1	M]', 'A8{!Vt<SqHoh4y`By', '', 0, '?'),
 ('rI̖ӛ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/IetfCtx.php', 0, 'g\"̤/OY\'', 'g\"̤/OY\'', '8eTet\r jP/J<^rӥz', '', 0, '?'),
 ('oI|ݎ@wxT3E', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20.php', 0, '12+;FнNM', '12+;FнNM', 'w\"*5U T@nyȳ^au\'', '', 0, '?'),
 ('+s{Fݟ\nXR/%', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Fe.php', 0, 'NVl~m[%Wt', 'NVl~m[%Wt', 'Pq\0V{|0m\0;2f@U', '', 0, '?'),
 ('sLN	6Q.', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Cached.php', 0, 'rRUb*\0\'', 'rRUb*\0\'', 'x<sBZ2jRM\'0%$i{ V', '', 0, '?'),
 ('2r7iiIf', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P1p1.php', 0, 'Kz+UŸ(5\\', 'Kz+UŸ(5\\', '8:oI9,=zDk8;{A{\Zij', '', 0, '?'),
 ('=YJ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P2.php', 0, '>\Z\Z+,', '>\Z\Z+,', '*y$MQ[q:h\")XTC\0\\k', '', 0, '?'),
 ('ͬ~a5f M9', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P3.php', 0, '3b(浏К', '3b(浏К', 'n;<	Ǖ-Wt]<su', '', 0, '?'),
 ('RGf;X6R.Kq', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Precomp.php', 0, 'Y=\nY992', 'Y=\nY992', '6\Z/py5EحOE', '', 0, '?'),
 ('\'\nʮ3[qĽ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/H.php', 0, '\n@LjwD', '\n@LjwD', '\r8d8sڇ6FȌ', '', 0, '?'),
 ('nk)t7h=', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519.php', 0, 'oaQ|g4&', 'oaQ|g4&', 'cUX+]Wvd=,Z0)\\', '', 0, '?'),
 ('S2FįZCJ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Ed25519.php', 0, 'ZbO6IcD', 'ZbO6IcD', '`ude?s7dCQ}Y/', '', 0, '?'),
 ('Z\rvdw', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HChaCha20.php', 0, '>*L1˵\"k%F+', '>*L1˵\"k%F+', 'ZiMfUvi-})f\"Mnd?X', '', 0, '?'),
 ('G0\r]2Wj	j', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HSalsa20.php', 0, 'Woe~oB2_;', 'Woe~oB2_;', '5qSrL]OXsq+l<ɒ', '', 0, '?'),
 ('s`	}Γ', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int32.php', 0, 'CB)cae', 'CB)cae', '[}D\0OV:~-\"~mBh\"<pW', '', 0, '?'),
 ('(]q͝q', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int64.php', 0, ' QAL󚜆U', ' QAL󚜆U', 'G\n<.\ZWrʪØ)', '', 0, '?'),
 ('j:(M覀?q', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305/State.php', 0, 'D2E\\t.-', 'D2E\\t.-', 'U\n/miMyE-QM^\0QL9hT', '', 0, '?'),
 ('Ufk֍Y\Zhik', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305.php', 0, 'ܑzg<N\n?o6f', 'ܑzg<N\n?o6f', 'REgX3JAc!a_S{', '', 0, '?'),
 ('`nNp`5~VK', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Salsa20.php', 0, 'Zz#H', 'Zz#H', 'n]x\Z_ѪkB-a&̃', '', 0, '?'),
 ('Z\nx2VL˸', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/SipHash.php', 0, 'Zrtw(e', 'Zrtw(e', 'ҿDI<^i2dW]G_-+A8W', '', 0, '?'),
 ('D^!x', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Util.php', 0, 'pԏd0lN&7+', 'pԏd0lN&7+', '^s\n@G,ږ\n;|3P	nԔ/\rzA\"\nd', '', 0, '?'),
 ('DӞ	Zp', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/X25519.php', 0, '\0Vή?b4', '\0Vή?b4', '=ޣ4:$dXWRXN >', '', 0, '?'),
 ('^yƠՃq', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XChaCha20.php', 0, ' @^8J', ' @^8J', 'ؽ@B-Km-Ȼ\Z2p', '', 0, '?'),
 ('}4;<.#d', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XSalsa20.php', 0, '\'_?Sş\Z]y', '\'_?Sş\Z]y', '6[-,9YRr\rY\"-an6$', '', 0, '?'),
 ('VWԾKQ8', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto.php', 0, 'ÕmANR', 'ÕmANR', ' *J/(sg YD]و̨|\0z', '', 0, '?'),
 ('Qւ\Z', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto32.php', 0, 'b]݆щpW', 'b]݆щpW', 'ド$⨇\r׶oޖGǗq#7', '', 0, '?'),
 ('CaƸ+5[', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/File.php', 0, 'ƌ@N`Xg', 'ƌ@N`Xg', 'Q&3Ɓ_+i	uqI+:	IO', '', 0, '?'),
 ('V#<9˝', 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/SodiumException.php', 0, '8	:{We', '8	:{We', '6{w^GkΫ25b\r񓫄', '', 0, '?'),
 ('鱾ed@?pd', 'wp-content/updraft/plugins-old/wordfence/images/2fa-whole.svg', 0, 'h»$\ZPfX', 'h»$\ZPfX', 'ƪɝU[Z~^d\'Xٮ', '', 0, '?'),
 ('D_bh 48|f', 'wp-content/updraft/plugins-old/wordfence/images/2fa1.svg', 0, '/)h\\ hG8', '/)h\\ hG8', 'C%0z)f @t>ɶ{T8o', '', 0, '?'),
 ('1pK欠u6=D', 'wp-content/updraft/plugins-old/wordfence/images/2fa2.svg', 0, '\0H', '\0H', 'npʅG06KqJ]J', '', 0, '?'),
 ('J	ttU:~', 'wp-content/updraft/plugins-old/wordfence/images/blocking.svg', 0, '\'-Hf<1', '\'-Hf<1', 'A5Y9\0OtqЖL\\}a&', '', 0, '?'),
 (' ]4', 'wp-content/updraft/plugins-old/wordfence/images/options.svg', 0, 'VѴA', 'VѴA', 'D:bw#^4BKIP?	znV_', '', 0, '?'),
 ('GI-cb3QUmC1', 'wp-content/updraft/plugins-old/wordfence/images/ratelimiting.svg', 0, '\0[MɞyP', '\0[MɞyP', '@Sy\'N+kB3J!PbƖ', '', 0, '?'),
 ('$4R0<Փ', 'wp-content/updraft/plugins-old/wordfence/images/support.svg', 0, 'Cl$rn<.', 'Cl$rn<.', '$MԮ&(ᩘs^	Ϣ*N', '', 0, '?'),
 ('-Q7yC{p~', 'wp-content/updraft/plugins-old/wordfence/images/tools.svg', 0, '@cI', '@cI', 'Y=RB)	~ܖݟr', '', 0, '?'),
 ('@LI	а\\', 'wp-content/updraft/plugins-old/wordfence/images/wf-central-logo.svg', 0, 'q(VѤ', 'q(VѤ', '\0{\rߘJ/ ^+,S', '', 0, '?'),
 ('6y/|zg\rQn', 'wp-content/updraft/plugins-old/wordfence/images/wf-horizontal.svg', 0, 'E%Zlo9͒', 'E%Zlo9͒', '0	6ӭIvhJ`', '', 0, '?'),
 ('=OFF|', 'wp-content/updraft/plugins-old/wordfence/images/wordfence-logo.svg', 0, 'p]j-', 'p]j-', '8#̄(8O\"	+h\"Fb', '', 0, '?'),
 ('շBdc`+,?', 'wp-content/updraft/plugins-old/wordfence/index.php', 0, '2eª\\og', '2eª\\og', ' oMJ#A|ߎ(;6R\n', '', 0, '?'),
 ('?I~$	v/', 'wp-content/updraft/plugins-old/wordfence/js/Chart.bundle.min.1581523568.js', 0, '5]ddf', '5]ddf', '>`NN`N\"KӞckG<;', '', 0, '?'),
 ('V3Fʷ풒j', 'wp-content/updraft/plugins-old/wordfence/js/admin.1581523568.js', 0, 'g<Z uq', 'g<Z uq', 'x[c\0=/jv[', '', 0, '?'),
 ('qLTG', 'wp-content/updraft/plugins-old/wordfence/js/admin.ajaxWatcher.1581523568.js', 0, 'CCW\Z^beD', 'CCW\Z^beD', '	CJhF$Dq|,7EH;N', '', 0, '?'),
 ('=Ӣ\'e\"', 'wp-content/updraft/plugins-old/wordfence/js/admin.liveTraffic.1581523568.js', 0, '/[n1uu}', '/[n1uu}', ')䓣Ad98PV+H25J', '', 0, '?'),
 ('&<MRK8', 'wp-content/updraft/plugins-old/wordfence/js/date.1581523568.js', 0, 'jPER_c', 'jPER_c', 'B=0dƩ\"BtUc^1>q&', '', 0, '?'),
 ('w1bPT', 'wp-content/updraft/plugins-old/wordfence/js/jquery-ui-timepicker-addon.1581523568.js', 0, '89\"zzVv*]', '89\"zzVv*]', 'ۆ%%l:Jf<bqPPt˯}ߝ\"f', '', 0, '?'),
 ('oJ+w!gV&', 'wp-content/updraft/plugins-old/wordfence/js/jquery.colorbox-min.1581523568.js', 0, 'Y5=q)', 'Y5=q)', 'H4\\v/XGK:gkl', '', 0, '?'),
 ('k@xk-̾', 'wp-content/updraft/plugins-old/wordfence/js/jquery.colorbox.1581523568.js', 0, '(O0%69e3j', '(O0%69e3j', '{L#\r]\ngL8P,@Ir,{ ', '', 0, '?'),
 ('C6z]>Li', 'wp-content/updraft/plugins-old/wordfence/js/jquery.dataTables.min.1581523568.js', 0, '<\\ ͕h', '<\\ ͕h', 'vAo;uD3$WB95_\" ', '', 0, '?'),
 ('KH?7`4gK', 'wp-content/updraft/plugins-old/wordfence/js/jquery.qrcode.min.1581523568.js', 0, 'ԹXp`me<', 'ԹXp`me<', 'wP\0pzuYDSz(WߥP3$S', '', 0, '?'),
 ('@ŋ.p', 'wp-content/updraft/plugins-old/wordfence/js/jquery.tmpl.min.1581523568.js', 0, '\\}\"7ڷDZ', '\\}\"7ڷDZ', '.IH\Zg\0H!7`gޠZzȄž6|', '', 0, '?'),
 ('񄟼$c1', 'wp-content/updraft/plugins-old/wordfence/js/jquery.tools.min.1581523568.js', 0, ':-Eՠx$B', ':-Eՠx$B', ',4~aTlS fQO	fTӵ;)', '', 0, '?'),
 ('{bZM娇i', 'wp-content/updraft/plugins-old/wordfence/js/knockout-3.3.0.1581523568.js', 0, '_B8lc^', '_B8lc^', '5J9hALg@`uwo3\0I>', '', 0, '?'),
 ('^>׻/', 'wp-content/updraft/plugins-old/wordfence/js/wfdashboard.1581523568.js', 0, 'ԽP`{i', 'ԽP`{i', '=Pzr!?w\Z/d!LӪ1!', '', 0, '?'),
 ('Ǫ&mԀ5Z', 'wp-content/updraft/plugins-old/wordfence/js/wfdropdown.1581523568.js', 0, 'rpc\'\Z', 'rpc\'\Z', 'SGs8;Z!זJu1z?', '', 0, '?'),
 ('~cʭ:', 'wp-content/updraft/plugins-old/wordfence/js/wfglobal.1581523568.js', 0, '7欑iW5ulR', '7欑iW5ulR', '$hd^Sƨ5Y٭a$', '', 0, '?'),
 ('ʍRХѳ*P;ؐ', 'wp-content/updraft/plugins-old/wordfence/js/wfpopover.1581523568.js', 0, ';&mAhlMPZX', ';&mAhlMPZX', '_.V袏X4Ni_k=C3', '', 0, '?'),
 ('Qagi-JE', 'wp-content/updraft/plugins-old/wordfence/js/wfselect2.min.1581523568.js', 0, 'J!.i', 'J!.i', 'lk}[ZjA.!=+5+~q 1', '', 0, '?'),
 ('ȩMۉN', 'wp-content/updraft/plugins-old/wordfence/lib/Diff/Renderer/Abstract.php', 0, '>\r5]xVI\'i', '>\r5]xVI\'i', 'G݅\'!YE3P5adM', '', 0, '?'),
 ('̐yW~FKsR', 'wp-content/updraft/plugins-old/wordfence/lib/Diff/Renderer/Html/Array.php', 0, '09\rɘadP', '09\rɘadP', 'F*OОq^lgz,I?bR]KֳE', '', 0, '?'),
 ('-\0	', 'wp-content/updraft/plugins-old/wordfence/lib/Diff/Renderer/Html/SideBySide.php', 0, ' OّCHؖs ', ' OّCHؖs ', 'pXuc{-K׏ژ/OnE0)JB', '', 0, '?'),
 ('kƣ\"XuȵB\0f#b', 'wp-content/updraft/plugins-old/wordfence/lib/Diff/SequenceMatcher.php', 0, 'O\"%éODZj', 'O\"%éODZj', 'Z?=b\0D\ZZ\'˿_pwѻ,:', '', 0, '?'),
 ('T!>j\nnk', 'wp-content/updraft/plugins-old/wordfence/lib/Diff.php', 0, '5VzY]#yRJݮ', '5VzY]#yRJݮ', 'YM\"z)tϖ*cwL\01w$d', '', 0, '?'),
 ('dX-DeH_', 'wp-content/updraft/plugins-old/wordfence/lib/IPTraf.php', 0, 'WJmLIg!', 'WJmLIg!', '0b@i[%g<F', '', 0, '?'),
 ('?0N7^:]S\\', 'wp-content/updraft/plugins-old/wordfence/lib/IPTrafList.php', 0, '<4wwZ%A', '<4wwZ%A', '~\n)^\n20*\"$;ZmOc', '', 0, '?'),
 ('Mniý', 'wp-content/updraft/plugins-old/wordfence/lib/WFLSPHP52Compatability.php', 0, '%1sËG', '%1sËG', 'EWٳ?4@U?0bP+h', '', 0, '?'),
 ('MwϒY\\Q}x:\'	', 'wp-content/updraft/plugins-old/wordfence/lib/compat.php', 0, '>zxC}', '>zxC}', 'Nܓ#dtB!\"M՞==@o', '', 0, '?'),
 ('aT9%B', 'wp-content/updraft/plugins-old/wordfence/lib/conntest.php', 0, 'q\rƉ(.Aˬ', 'q\rƉ(.Aˬ', 'J&grb+\'Id	1HLWreO', '', 0, '?'),
 (';lGWmG#^\Z', 'wp-content/updraft/plugins-old/wordfence/lib/cronview.php', 0, 'e(t@nr', 'e(t@nr', 'Z4,hz=>M}G/[0l\"iK', '', 0, '?'),
 ('= K`%j\\', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_content_countries.php', 0, 'ȎcP\"', 'ȎcP\"', 'זD䟹45JbOɝHR@', '', 0, '?'),
 ('6Ír)cMM', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_content_ips.php', 0, 'ݻ1(wmF', 'ݻ1(wmF', 'B6;M8\Z&', '', 0, '?'),
 ('Fe4==h8Wy', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_content_logins.php', 0, '!Pyt8턺P6q', '!Pyt8턺P6q', 'kwQ)\'J~MEsrXY_Gf!', '', 0, '?'),
 ('Eg\nGGE	', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_countries.php', 0, '\rmnZB ', '\rmnZB ', '݃EZ?wȖ͖s!7cJ70', '', 0, '?'),
 ('!ɇh?9\Z\0', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_ips.php', 0, '\ZcQ\nbd7,Ze', '\ZcQ\nbd7,Ze', 'ZL)1-|Y(|@.N_ϋu', '', 0, '?'),
 ('vvb3aЭ', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_localattacks.php', 0, '/]L/Gb;', '/]L/Gb;', '$y\r\npu ?A8KΙTcVa', '', 0, '?'),
 ('9 H7wGmlY\Zd', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_logins.php', 0, 'g#@Xs', 'g#@Xs', 'ĪN29WDWO0ѽmGN', '', 0, '?'),
 ('gʷ-Q', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_networkattacks.php', 0, 'ԶwK>~\rg', 'ԶwK>~\rg', '#Nu}WL!\\Z 8\0;k{', '', 0, '?'),
 ('Nfbk>', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_notifications.php', 0, '5$g؟_ ', '5$g؟_ ', '53=xLܑm?Z97P.', '', 0, '?'),
 ('BC|ᱲ,˱%', 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_tdf.php', 0, '2\'p[UaH', '2\'p[UaH', '?}mwDqn2R\\', '', 0, '?'),
 ('cl%g=1J', 'wp-content/updraft/plugins-old/wordfence/lib/dbview.php', 0, 'ƍݵ1苙nzk', 'ƍݵ1苙nzk', 'DOhB;4U7o/g8i+̷', '', 0, '?'),
 ('1.X\nxD;sU', 'wp-content/updraft/plugins-old/wordfence/lib/diffResult.php', 0, '0wJn', '0wJn', '_^>8L\\{P', '', 0, '?'),
 ('Q T%u6	', 'wp-content/updraft/plugins-old/wordfence/lib/email_genericAlert.php', 0, 'L)&낆(', 'L)&낆(', 'j{bXN#R5[׍m', '', 0, '?'),
 ('.$m=KUd', 'wp-content/updraft/plugins-old/wordfence/lib/email_newIssues.php', 0, '&(/xwXΨ', '&(/xwXΨ', '%:\"|j!Wr,F/K~x', '', 0, '?'),
 ('knۢ9a_', 'wp-content/updraft/plugins-old/wordfence/lib/email_unlockRequest.php', 0, '{<2m', '{<2m', 'RpM>d*', '', 0, '?'),
 ('\"<[</.K!', 'wp-content/updraft/plugins-old/wordfence/lib/email_unsubscribeRequest.php', 0, '#}_*mD×cvW', '#}_*mD×cvW', 'm$G+59TEx7B{/,u7', '', 0, '?'),
 ('9 \0@ء%Y>', 'wp-content/updraft/plugins-old/wordfence/lib/flags.php', 0, 'ic磭c-', 'ic磭c-', '8YCO0j{\ZxDĖxO', '', 0, '?'),
 ('rG[SE\\ag', 'wp-content/updraft/plugins-old/wordfence/lib/live_activity.php', 0, '2>(]/@ꏞf', '2>(]/@ꏞf', 'QըW`~N_wID$J3', '', 0, '?'),
 ('2=D@ǰY', 'wp-content/updraft/plugins-old/wordfence/lib/menu_dashboard.php', 0, 'r͝ݭ5', 'r͝ݭ5', 'oc@e ᤶg\ZVj', '', 0, '?'),
 ('Px-yy&@', 'wp-content/updraft/plugins-old/wordfence/lib/menu_dashboard_options.php', 0, 'j~i\'Z?', 'j~i\'Z?', '=x=)ZuY\"FF2]', '', 0, '?'),
 ('}Tg#Ps', 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall.php', 0, 'm2_MjV', 'm2_MjV', '\"!bXȉr3Oe{0', '', 0, '?'),
 ('3O!ډp/', 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_blocking.php', 0, '[? ?', '[? ?', 'b}STbcvʄ/{', '', 0, '?'),
 ('4𴧔`}wP	', 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_blocking_options.php', 0, 'h;BD:', 'h;BD:', '\Z@\\ɔ\rqB,CKτw.z', '', 0, '?'),
 ('vc|aQ%', 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_waf.php', 0, 'e(# ({秡<(s', 'e(# ({秡<(s', '%=oVBkC%Ir(?ceC', '', 0, '?'),
 ('3k})=$-O', 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_waf_options.php', 0, 'ua~v', 'ua~v', '/[+!)fhfĳXF8/H7', '', 0, '?'),
 ('i@nzy9ГC', 'wp-content/updraft/plugins-old/wordfence/lib/menu_options.php', 0, '$ShDM-62q', '$ShDM-62q', 'h\ZFa>޻{_+B-O@ ', '', 0, '?'),
 ('FbI8_Č=', 'wp-content/updraft/plugins-old/wordfence/lib/menu_scanner.php', 0, 'ݻyz|', 'ݻyz|', '-uݼ>̺n~ut&)F&;qfJkSO', '', 0, '?'),
 ('\n/(]', 'wp-content/updraft/plugins-old/wordfence/lib/menu_scanner_credentials.php', 0, 'ff:&,[', 'ff:&,[', 'B&$q>P\nϾz&G<6Ǵ:', '', 0, '?'),
 ('&NP?S	 ', 'wp-content/updraft/plugins-old/wordfence/lib/menu_scanner_options.php', 0, '; 9\0b!Q', '; 9\0b!Q', '@&O\ZqR_w)RǐlL`wүi,', '', 0, '?'),
 ('$L|)|%\n', 'wp-content/updraft/plugins-old/wordfence/lib/menu_support.php', 0, 'yy0\'Ofx2;D', 'yy0\'Ofx2;D', '.F!x,p	[\'E\Z̻,', '', 0, '?'),
 ('4\Z$mݻD~8', 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools.php', 0, 'gԌpPIg[=', 'gԌpPIg[=', 'V!ޟƚ_z=|yaXȏ', '', 0, '?'),
 ('>&q\\', 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_diagnostic.php', 0, '7<Ճʟ9\nK', '7<Ճʟ9\nK', 'ёSvm(6V\nlv', '', 0, '?'),
 ('{$\"G<x', 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_importExport.php', 0, '$^k>T|', '$^k>T|', 'k^XR1, c=\\', '', 0, '?'),
 ('K#,jaU),', 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_livetraffic.php', 0, 'Bqqỳ䢗6', 'Bqqỳ䢗6', 'g &cp -jpstcⒺsI', '', 0, '?'),
 ('hGc}g', 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_twoFactor.php', 0, 'jlF+>Tm/av~3', 'jlF+>Tm/av~3', 'Zfk%y,?SCU=lhѕ', '', 0, '?'),
 ('\'fɎ>@:5f/c', 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_whois.php', 0, '\0JM(]\Z7w', '\0JM(]\Z7w', '[:QݔqF/qG;N@Kq08ΤO`[', '', 0, '?'),
 ('44ޥk\0\00u', 'wp-content/updraft/plugins-old/wordfence/lib/menu_wordfence_central.php', 0, 'nՆKvOԜ\'\0', 'nՆKvOԜ\'\0', '^{A荗.Fخ\"m)>T', '', 0, '?'),
 ('C&2$g', 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTAuthenticationController.php', 0, 'd:ǽ	X̩TI', 'd:ǽ	X̩TI', 'IS:3+̢$i_if:A', '', 0, '?'),
 ('8CmOyU8i', 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTBaseController.php', 0, 'yK\nu@x', 'yK\nu@x', 'Aݶ݁;_|sȤ4_)zaKQEe!', '', 0, '?'),
 ('һR6s)u1', 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTConfigController.php', 0, '-n(֟5> a.\'', '-n(֟5> a.\'', 'j^!yfӳucwWx', '', 0, '?'),
 ('\\ڃC\Z5E\0ެĥ', 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTScanController.php', 0, '5oQ4)dT', '5oQ4)dT', 'Dt3v\Z%jlf%O)&&1L', '', 0, '?'),
 ('LL|\"$זF', 'wp-content/updraft/plugins-old/wordfence/lib/sysinfo.php', 0, 'ۍQꅳ9', 'ۍQꅳ9', '!D#D\"0zt6IHԆ\\0̈\Zd', '', 0, '?'),
 ('l8c_WQ$\Z', 'wp-content/updraft/plugins-old/wordfence/lib/unknownFiles.php', 0, 'n✚o\"* b', 'n✚o\"* b', 'p}\'5HZ%[*:^^i', '', 0, '?'),
 (' D\ZG!Ӧ', 'wp-content/updraft/plugins-old/wordfence/lib/viewFullActivityLog.php', 0, '@lM3JtOF@', '@lM3JtOF@', '[`\\pǣTb>=PivO', '', 0, '?'),
 ('M휣ENd0{', 'wp-content/updraft/plugins-old/wordfence/lib/wf503.php', 0, 'EGůL[o', 'EGůL[o', 'lg_iċrY2d', '', 0, '?'),
 ('ӂk@Eʎ', 'wp-content/updraft/plugins-old/wordfence/lib/wfAPI.php', 0, 'Cx3v@Q$)g\r', 'Cx3v@Q$)g\r', 'kBhl%ܟGa=R @Ξ{', '', 0, '?'),
 ('P.-', 'wp-content/updraft/plugins-old/wordfence/lib/wfActivityReport.php', 0, '>	[\Z᷎x4', '>	[\Z᷎x4', '+|\Z#*NθBND]|\0', '', 0, '?'),
 ('.DD!u', 'wp-content/updraft/plugins-old/wordfence/lib/wfAdminNoticeQueue.php', 0, 'K\r4X.', 'K\r4X.', 'lvl	](W7+0-', '', 0, '?'),
 ('Jȱt	R\n˶', 'wp-content/updraft/plugins-old/wordfence/lib/wfAlerts.php', 0, ']5+6.ZM.', ']5+6.ZM.', '7ɟSYPW	OXxy*ieHY', '', 0, '?'),
 (':7י', 'wp-content/updraft/plugins-old/wordfence/lib/wfArray.php', 0, '\'Fbaۆₑ1ʤ/', '\'Fbaۆₑ1ʤ/', 'n2q8D-AR>xqYq$ ш', '', 0, '?'),
 ('p9wẏq', 'wp-content/updraft/plugins-old/wordfence/lib/wfBrowscap.php', 0, '\re.b', '\re.b', 'HznO#/tɚ\"U Ai', '', 0, '?'),
 ('^M\ZQX~', 'wp-content/updraft/plugins-old/wordfence/lib/wfBrowscapCache.php', 0, 'TQxj', 'TQxj', '1YTЈqW6݋h	', '', 0, '?'),
 ('~2sZmo?]%?_', 'wp-content/updraft/plugins-old/wordfence/lib/wfBulkCountries.php', 0, '9	+OyծurO3\n', '9	+OyծurO3\n', 'X&o1\'cgmlySt\r', '', 0, '?'),
 ('21ʓ(', 'wp-content/updraft/plugins-old/wordfence/lib/wfCache.php', 0, '7 ƿsy', '7 ƿsy', '|uIPwh5ڎ.m\"*n_ 9JP', '', 0, '?'),
 ('g^q\ZV\ZWr', 'wp-content/updraft/plugins-old/wordfence/lib/wfCentralAPI.php', 0, 'ăa\\F', 'ăa\\F', '!)-5%xi=F$07~\n', '', 0, '?'),
 ('JtD%<a}ׇ', 'wp-content/updraft/plugins-old/wordfence/lib/wfConfig.php', 0, '\'9XYW4', '\'9XYW4', '@g;͚\\oƌW7\nBH\"', '', 0, '?'),
 ('=P\"xSkΗ!V\nt', 'wp-content/updraft/plugins-old/wordfence/lib/wfCrawl.php', 0, '1铇ܙ~\rm', '1铇ܙ~\rm', '%&9	/DXG؞߇U4', '', 0, '?'),
 ('w3[/9!e', 'wp-content/updraft/plugins-old/wordfence/lib/wfCredentialsController.php', 0, 'Z\0իw6', 'Z\0իw6', '76ay5?}%.]؞uS', '', 0, '?'),
 ('m\\N5rp0Df', 'wp-content/updraft/plugins-old/wordfence/lib/wfCrypt.php', 0, 'CR`9|e', 'CR`9|e', 'U͊sds9;COȤ@', '', 0, '?'),
 ('/fo0G', 'wp-content/updraft/plugins-old/wordfence/lib/wfDB.php', 0, 'P_<-1__Iu', 'P_<-1__Iu', '%dd_\01@TY$A', '', 0, '?'),
 (',j\'	\"\nIvі', 'wp-content/updraft/plugins-old/wordfence/lib/wfDashboard.php', 0, '&4.', '&4.', 'U0@\0\'21k^ͅEi.E', '', 0, '?'),
 ('`Yuy%4', 'wp-content/updraft/plugins-old/wordfence/lib/wfDateLocalization.php', 0, '4K_J2Cmcͭt', '4K_J2Cmcͭt', 'Djy,Lwa <U S', '', 0, '?'),
 ('ӭ$', 'wp-content/updraft/plugins-old/wordfence/lib/wfDiagnostic.php', 0, '\0n3', '\0n3', '`MTRLl&)hZ/%', '', 0, '?'),
 ('TZOtE!g', 'wp-content/updraft/plugins-old/wordfence/lib/wfDict.php', 0, 'y LZ!bEl', 'y LZ!bEl', '.{0Je{5-~[T$Ğ', '', 0, '?'),
 ('3Yo6v', 'wp-content/updraft/plugins-old/wordfence/lib/wfDirectoryIterator.php', 0, '\n+Z/_\Zxuv', '\n+Z/_\Zxuv', 'u;IVa[~㵭TZ\\^yJj', '', 0, '?'),
 ('}(7b׃8\"', 'wp-content/updraft/plugins-old/wordfence/lib/wfHelperBin.php', 0, ';!ȍ4QX#', ';!ȍ4QX#', 'չ%-^qUqMeY', '', 0, '?'),
 ('+|F=?{a', 'wp-content/updraft/plugins-old/wordfence/lib/wfHelperString.php', 0, 'OVFaDV44ܪ', 'OVFaDV44ܪ', '2-7na5A>cִ\ZNA-p{Qn\Z', '', 0, '?'),
 ('@M0|l1', 'wp-content/updraft/plugins-old/wordfence/lib/wfIPWhitelist.php', 0, 'ϝq,ؾ\\', 'ϝq,ؾ\\', '5%v_E[P3w,=s$bF', '', 0, '?'),
 ('yD^>r\r\r', 'wp-content/updraft/plugins-old/wordfence/lib/wfImportExportController.php', 0, 'HM.', 'HM.', 'ƌZ>2ì<\rsJ2*', '', 0, '?'),
 ('XsDɞ\n(', 'wp-content/updraft/plugins-old/wordfence/lib/wfIssues.php', 0, 'hťPmŝ\\', 'hťPmŝ\\', 'f1J8p6J#gTU79iw-k', '', 0, '?'),
 ('8]/`G#f8', 'wp-content/updraft/plugins-old/wordfence/lib/wfJWT.php', 0, '}{ jNcK', '}{ jNcK', '0mhN`xx~HLjsOP,', '', 0, '?'),
 ('͉~`[}\rn', 'wp-content/updraft/plugins-old/wordfence/lib/wfLockedOut.php', 0, 'i1EqE<UB', 'i1EqE<UB', 'nmo6}x9>,>kYuuś', '', 0, '?'),
 ('ͮSeh(7', 'wp-content/updraft/plugins-old/wordfence/lib/wfLog.php', 0, '4ޒ	N3G', '4ޒ	N3G', 'o[G\n^/;LA^)R', '', 0, '?'),
 ('!neVk', 'wp-content/updraft/plugins-old/wordfence/lib/wfMD5BloomFilter.php', 0, '߅w@LOR', '߅w@LOR', 'EFjrč;s΀.f:ϤF', '', 0, '?'),
 ('%^ٻ1ѿiF$', 'wp-content/updraft/plugins-old/wordfence/lib/wfModuleController.php', 0, 'oIƷkb', 'oIƷkb', '7.ݰ̿UL>\"TM5]>', '', 0, '?'),
 ('ܵpHŔ®', 'wp-content/updraft/plugins-old/wordfence/lib/wfNotification.php', 0, '\0Ǎ V2(dhVD', '\0Ǎ V2(dhVD', 'SaYgj+| JM8', '', 0, '?'),
 ('[<n:RX', 'wp-content/updraft/plugins-old/wordfence/lib/wfOnboardingController.php', 0, '	,#\r+', '	,#\r+', 'h]*?Y\\!rfyExQ[q=', '', 0, '?'),
 ('&Vݼ(}5p', 'wp-content/updraft/plugins-old/wordfence/lib/wfPersistenceController.php', 0, '%kyiMO*', '%kyiMO*', 'X(30\r\n\nPE̠ 9', '', 0, '?'),
 ('|o hvx', 'wp-content/updraft/plugins-old/wordfence/lib/wfRESTAPI.php', 0, '\\8H mi+', '\\8H mi+', '++Ɵ0͂b=[㜁', '', 0, '?'),
 ('!!\'\"PyɌ', 'wp-content/updraft/plugins-old/wordfence/lib/wfScan.php', 0, ';jڹ%a`', ';jڹ%a`', '$>3Tp9INO\n$', '', 0, '?'),
 ('hl37ʄ^', 'wp-content/updraft/plugins-old/wordfence/lib/wfScanEngine.php', 0, '9%tBȴjE', '9%tBȴjE', '\nwpYOuoqd', '', 0, '?'),
 ('vI>/^WGXH*', 'wp-content/updraft/plugins-old/wordfence/lib/wfSchema.php', 0, 'O@	|O', 'O@	|O', 'gvK%oiS7.]siH2:p', '', 0, '?'),
 ('M=j1 9;yg', 'wp-content/updraft/plugins-old/wordfence/lib/wfStyle.php', 0, 's1_ek2R', 's1_ek2R', 'j颎_c6323օ]Gs}.\n', '', 0, '?'),
 ('Ip[\"UMeZy', 'wp-content/updraft/plugins-old/wordfence/lib/wfSupportController.php', 0, 'uIWԝV', 'uIWԝV', 'ns=\rT4>Q}ql', '', 0, '?'),
 ('\nP|K6~E=O', 'wp-content/updraft/plugins-old/wordfence/lib/wfUnlockMsg.php', 0, '6]u})e', '6]u})e', ':%ozN]	&4U', '', 0, '?'),
 ('΄ T:ssr', 'wp-content/updraft/plugins-old/wordfence/lib/wfUpdateCheck.php', 0, '4\Z@Xg	kv{t', '4\Z@Xg	kv{t', '\Zެ%)I0P?CHk@rMzlH` F', '', 0, '?'),
 ('\Z4,a7\'U8|@', 'wp-content/updraft/plugins-old/wordfence/lib/wfUtils.php', 0, 'bp&ޜ$ݐ', 'bp&ޜ$ݐ', 'wF!PҜLtKK', '', 0, '?'),
 ('Y0^mC', 'wp-content/updraft/plugins-old/wordfence/lib/wfVersionCheckController.php', 0, '~\Zyh[*[ǥ', '~\Zyh[*[ǥ', 'q\rzչ4kÛ>ڌj\'$a9]\n', '', 0, '?'),
 ('T2-\rO', 'wp-content/updraft/plugins-old/wordfence/lib/wfView.php', 0, '⇲*!P\'|%\Z', '⇲*!P\'|%\Z', '\0+FoL (\\.w g{&:όH', '', 0, '?'),
 ('W}aj\"<P', 'wp-content/updraft/plugins-old/wordfence/lib/wfViewResult.php', 0, '9ֿYCA4|p', '9ֿYCA4|p', '{30pDr%#Mz_ϔK}Ao6MR', '', 0, '?'),
 ('&Gyl&\'q', 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceClass.php', 0, 'X|>\"iD\'G', 'X|>\"iD\'G', '!#gIs`Kԇz@]*', '', 0, '?'),
 ('_`hH\00', 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceConstants.php', 0, '/<]b*2', '/<]b*2', '%myG}M;vSGEf 65', '', 0, '?'),
 ('4Ic!3n', 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceHash.php', 0, 'SsAWlԦEm', 'SsAWlԦEm', '᎚Y/|ro?z!c6', '', 0, '?'),
 ('i؁J*', 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceScanner.php', 0, 'jMʺR\'iț', 'jMʺR\'iț', '(\\ 21&NHU', '', 0, '?'),
 ('վnugˏ', 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceURLHoover.php', 0, '͠؄C\ZƽYR%:.', '͠؄C\ZƽYR%:.', '&@bJR%XGhg>q', '', 0, '?'),
 ('n4N%܏Խd', 'wp-content/updraft/plugins-old/wordfence/models/block/wfBlock.php', 0, 'znK_', 'znK_', '7Y.ڔn!ڒ\Ze', '', 0, '?'),
 (')!sQ`ǴKTrQ', 'wp-content/updraft/plugins-old/wordfence/models/block/wfRateLimit.php', 0, '$1D\'wm', '$1D\'wm', 'E&&\na~b+\Z)jMpM', '', 0, '?'),
 ('I9+Dn<1ь', 'wp-content/updraft/plugins-old/wordfence/models/common/wfGeoIP2.php', 0, 'YJs@jrjtm', 'YJs@jrjtm', '3ÑѲs\r&z=dspJx3w', '', 0, '?'),
 ('Qg$|b', 'wp-content/updraft/plugins-old/wordfence/models/common/wfTab.php', 0, '2T}HW\'<}\\', '2T}HW\'<}\\', 'Z¥|sS8e3Eؗ$ܜ-h', '', 0, '?'),
 (' y+|4\ZF&', 'wp-content/updraft/plugins-old/wordfence/models/firewall/wfFirewall.php', 0, '2\\fG݉R', '2\\fG݉R', 'b4g챔Fadm)D=@g', '', 0, '?'),
 ('V*Ynu\0c-p', 'wp-content/updraft/plugins-old/wordfence/models/page/wfPage.php', 0, 'tbo i%HXwXv', 'tbo i%HXwXv', 'ƅ1h/jw<U\\kq%s|W6', '', 0, '?'),
 ('>elS%e8_Y', 'wp-content/updraft/plugins-old/wordfence/models/scanner/wfScanner.php', 0, 'f(\n4tf', 'f(\n4tf', '_;ĈS^ɐ\ZY', '', 0, '?'),
 ('kYeΝZ!', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/ajax.php', 0, 'fŴSz', 'fŴSz', 'L?T`^]=#|\"/\ZHm:/wH', '', 0, '?'),
 ('vkCg\r', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/captcha.php', 0, '-\ruZE:	', '-\ruZE:	', '^<1t>SM_3k!$', '', 0, '?'),
 ('qPZ6X', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/cron.php', 0, '@q\\}[', '@q\\}[', '[TnEjd($:!hΝ\0s><', '', 0, '?'),
 ('ӹop%c', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/db.php', 0, 'gPʋi[', 'gPʋi[', 'DeJ\Zfxb	x\'P:U', '', 0, '?'),
 ('k88ļ;h}x>@', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/notices.php', 0, 'z83?wW', 'z83?wW', '\r.l]\\)	Zqp]_^uJ\n%', '', 0, '?'),
 ('ÞD./', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/permissions.php', 0, 'Y״>UɆ', 'Y״>UɆ', 'Ru\Z`\\6ÃMR\r3Z!C|s,P{', '', 0, '?'),
 ('GByi ', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/settings.php', 0, 'p\\E(i', 'p\\E(i', '4O+oc.`_U>8', '', 0, '?'),
 ('ҪZ,Qu', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/support.php', 0, '\nʆwqF', '\nʆwqF', 'R	j[8ح͸WEH̅aI', '', 0, '?'),
 ('{7{\00yD', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/time.php', 0, '4ӹu;P', '4ӹu;P', 'aD,ǭ+vFe\"+!1t', '', 0, '?'),
 ('o|\\m$P', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/totp.php', 0, 'j.\\0*	[', 'j.\\0*	[', 'f8\'!RFL˙^w', '', 0, '?'),
 ('j3ĿQH<:~5', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/users.php', 0, '٣gR 3', '٣gR 3', '}{cV\"z9NY8JW', '', 0, '?'),
 ('4d\'c_xm;J<i', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/whitelist.php', 0, 'B0oǔ', 'B0oǔ', '7/QƐՐwg:?#{sɟ', '', 0, '?'),
 ('ѥ8CL1t', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/wordfencels.php', 0, 'y]4x\"Dw^', 'y]4x\"Dw^', 'S5_\'玚ES-1WMLju^]c', '', 0, '?'),
 ('CW>[~F', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/asset.php', 0, 'G|s,=K#', 'G|s,=K#', '6ly6ɦi3U,E[鲓9', '', 0, '?'),
 ('3Ijڥi_', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/compat.php', 0, 'u1\\8;#j-', 'u1\\8;#j-', 'P|l_Z3z<NɧK', '', 0, '?'),
 ('o֌Hjيpm{', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto/base2n.php', 0, 't^I\']!', 't^I\']!', 'Ǧbt5fckdm', '', 0, '?'),
 ('Hi+.?[I', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto/jwt.php', 0, '0H#IHD', '0H#IHD', 'voVYx?\n\n&3c-\r8m', '', 0, '?'),
 ('>q3!{v5B??', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto/symmetric.php', 0, 'hR', 'hR', '=mH/\neC3u58', '', 0, '?'),
 ('Ώap@,', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto.php', 0, '4s[lAc4f', '4s[lAc4f', 'ƺ>y.~yK^)*f6F', '', 0, '?'),
 ('a`QɐO', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/ip.php', 0, '96f;0', '96f;0', 'mgc%i\ZnAB@wFz;y`\rN', '', 0, '?'),
 ('UYN', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/notice.php', 0, '-Gbyf|S', '-Gbyf|S', 'oG5}[`nxܡ^@B#lb', '', 0, '?'),
 ('C\Zmnsrzl', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/request.php', 0, '&ܮM,~/r', '&ܮM,~/r', 'F;W]&z~o\'/q+', '', 0, '?'),
 ('\r+1(P^', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/settings/db.php', 0, ' \0\">y>=', ' \0\">y>=', 'xVQ/}琾:(3&%UJoC', '', 0, '?'),
 ('~]A0\rv', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/settings/wpoptions.php', 0, '*1{,˾ʂ', '*1{,˾ʂ', '<G$U+kL>\0hahBS-', '', 0, '?'),
 (')|e;S!JSU', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/settings.php', 0, 'h㠲ieɡ', 'h㠲ieɡ', 'IHMp\\Nh\n׈NF=-Z=hO', '', 0, '?'),
 ('$>ؙLmU`4n', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/text/html.php', 0, 'OhO<FҬ', 'OhO<FҬ', 'PJHtNsnd*F\'WWaq]', '', 0, '?'),
 ('rnd\rl_%I~', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/text/javascript.php', 0, 'V\'BlIf\"c', 'V\'BlIf\"c', 'O$U?\nRyV=TZ', '', 0, '?'),
 (',yzN<XCMg', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/tokenbucket.php', 0, 'P\rL{ǀ', 'P\rL{ǀ', 'VZ+&\rЩU;L)R!ӵ', '', 0, '?'),
 (']\'Xvwfwt', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/view/tab.php', 0, '{ǲ겊T', '{ǲ겊T', 's׷my([~MNԘ;i', '', 0, '?'),
 ('o-JjJ', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/view/title.php', 0, 'o\\', 'o\\', 'Zm$zpuCVgIgIN', '', 0, '?'),
 ('`@GaZw', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/view.php', 0, '*:?l]u', '*:?l]u', '2P탚=w=7Ar\nfQ~,B', '', 0, '?'),
 ('	1:̾', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/img/header.svg', 0, 'p]j-', 'p]j-', '8#̄(8O\"	+h\"Fb', '', 0, '?'),
 ('ۅ͋YSA', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/img/menu.svg', 0, 'p]j-', 'p]j-', '8#̄(8O\"	+h\"Fb', '', 0, '?'),
 ('nhkEd9w,', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/admin-global.1581523568.js', 0, 'LgD5w\'|IGV5', 'LgD5w\'|IGV5', '}њ@PF)M$jp{e', '', 0, '?'),
 ('nN@ԻXGe', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/admin.1581523568.js', 0, ',Q5\Z*yy!s', ',Q5\Z*yy!s', 'J\"qUKa\'1_NXG`揧W>', '', 0, '?'),
 ('é:!m]', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery-ui-timepicker-addon.1581523568.js', 0, '89\"zzVv*]', '89\"zzVv*]', 'ۆ%%l:Jf<bqPPt˯}ߝ\"f', '', 0, '?'),
 ('&O4ɠ%\"/', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.colorbox.1581523568.js', 0, 'lYZiਆ3\02[', 'lYZiਆ3\02[', '(A#F~+FghS.b', '', 0, '?'),
 ('fN {2=zcG', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.colorbox.min.1581523568.js', 0, 'lWeU{9', 'lWeU{9', 'G8=\0> 3wg3.4', '', 0, '?'),
 (':O4:-UgBZI', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.qrcode.min.1581523568.js', 0, 'ԹXp`me<', 'ԹXp`me<', 'wP\0pzuYDSz(WߥP3$S', '', 0, '?'),
 ('~HFӟt`0+', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.tmpl.min.1581523568.js', 0, '\\}\"7ڷDZ', '\\}\"7ڷDZ', '.IH\Zg\0H!7`gޠZzȄž6|', '', 0, '?'),
 ('~12=KB?dhumx', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/login.1581523568.js', 0, '~Vtj:', '~Vtj:', '.y@Ive\Z?gdhO\0', '', 0, '?'),
 ('Jxۻb>ֽN Q', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/common/modal-prompt.php', 0, '%9;%mM6Z', '%9;%mM6Z', '6-2Xjݒ[lÆL	\'8FJ', '', 0, '?'),
 ('-o>{F', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/email/login-verification.php', 0, 'ڸ\rܚ', 'ڸ\rܚ', '-ͤE[G4/`rV', '', 0, '?'),
 ('@iBV2a', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/activate.php', 0, 'pߓ', 'pߓ', 'd\'_C\'\"Şh3', '', 0, '?'),
 ('sij\0-ws}', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/code.php', 0, '/D\rmb y_', '/D\rmb y_', '$+;f7{O/gp~', '', 0, '?'),
 ('8A5N\"&\\~.', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/deactivate.php', 0, '1z¶~pQ.)!\\', '1z¶~pQ.)!\\', 'or[AR~~Gu߰QNZk\0QSeO', '', 0, '?'),
 ('E$~Iq-', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/regenerate.php', 0, 'XZ\\h=95', 'XZ\\h=95', '.Z2~b8Ȟu', '', 0, '?'),
 ('AH0x3L ', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/onboarding/standalone-header.php', 0, 'CG\ndnMv', 'CG\ndnMv', '篺wFO^ `&|p.0E)\ZL', '', 0, '?'),
 ('fb-r՟Ve&G?', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-captcha-threshold.php', 0, 'Nc0)נZ;b', 'Nc0)נZ;b', '5KO5QJÂPpUW', '', 0, '?'),
 ('	:) Y', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-captcha.php', 0, ')OA?fSZp', ')OA?fSZp', ',m?j❄3T!ⱝ/@', '', 0, '?'),
 ('k_W|BVYsrH', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-ip-source.php', 0, 'q)\Z6ˏr1\n1ڑ', 'q)\Z6ˏr1\n1ڑ', '$I.\Zڴ}\'iD50V-B(', '', 0, '?'),
 ('&G}{Uv8G,w', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-label.php', 0, '|<>sZKze', '|<>sZKze', '̆;nE!Z\ZVV Hw', '', 0, '?'),
 (';!', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-require-2fa.php', 0, '\ZɵP! r', '\ZɵP! r', 'wXXl@gIz,>W7\rX', '', 0, '?'),
 (';sw66:$Ph', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-select.php', 0, '8E7CS', '8E7CS', 'dقM.N8U8ࠆOY=wD', '', 0, '?'),
 ('S~ݗ', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-switch.php', 0, '[(AɊh', '[(AɊh', 'ͳߘQ6̨!*XxMMu@', '', 0, '?'),
 ('8(O#\\K', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-text.php', 0, 'r%1cvG\\%', 'r%1cvG\\%', '-r@Yik~oeɲv*+', '', 0, '?'),
 ('͊.B\0kq', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-textarea.php', 0, '3qטwUͰR', '3qטwUͰR', 'JwYwun[&DFLV-2L', '', 0, '?'),
 ('oo<B\\s1B', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-boolean-switch.php', 0, 'VIބŌ._', 'VIބŌ._', 'ёli߉.N /siTj!l', '', 0, '?'),
 ('z);h', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-multiple.php', 0, 'T%a;B3>|CX', 'T%a;B3>|CX', 'B;,y_:$E5B0\0', '', 0, '?'),
 ('\\VyWNdb', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-segmented.php', 0, 'pVF&KkH', 'pVF&KkH', '+.^-$70	]xrv+cgPM', '', 0, '?'),
 ('3ɛ\\{5W', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-select.php', 0, '6G5n;E>', '6G5n;E>', 'Q2Ƽw|!l?sTMmu*({', '', 0, '?'),
 ('}Q_pQC', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-sub.php', 0, '\nυ	L?06C', '\nυ	L?06C', '\'-OR\"Nxn~l<W', '', 0, '?'),
 ('RW[y!\"\Z\'M', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-textarea.php', 0, '1hIbۓa', '1hIbۓa', '6NSNY2m=@ke(!z|g', '', 0, '?'),
 ('ꅲ7N8', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled.php', 0, 'R!z@;Ve', 'R!z@;Ve', '#l#к;	KAH9Q@	B~', '', 0, '?'),
 ('1x-lǯy', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-token.php', 0, '>N.RyEEn', '>N.RyEEn', '0Q~0Sbgsx:E my\\O', '', 0, '?'),
 ('|2E?6\ZfX', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/manage.php', 0, '~PG$!2(s`', '~PG$!2(s`', 'פ:yRJ`l|BHw75!', '', 0, '?'),
 ('BJV=Eؚi%', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/page.php', 0, '7\0~;L޾', '7\0~;L޾', 'DT}3=T$\\Z\rY/E', '', 0, '?'),
 ('RDZB]', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/section-title.php', 0, '\"w^\nk6', '\"w^\nk6', '!5@a6to5(Ds\nKf', '', 0, '?'),
 ('bvſ)n', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/settings.php', 0, 'MQ@ǮI', 'MQ@ǮI', '~rbwTNs;3fB)A', '', 0, '?'),
 ('\"\'yg^\0u', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/tabbar.php', 0, 'gxXJTbx', 'gxXJTbx', 'fx/xG\n856	Z+', '', 0, '?'),
 ('dQgGNc+Ix', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/settings/options.php', 0, 'XUt\\HD', 'XUt\\HD', 'w>Ȗ@UFg݃{=-ڪ5', '', 0, '?'),
 ('2IBe-Bx\r', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/settings/user-stats.php', 0, 'uD~Fe	U', 'uD~Fe	U', ';\ne@dw`4g\r', '', 0, '?'),
 ('LpIm?', 'wp-content/updraft/plugins-old/wordfence/modules/login-security/wordfence-login-security.php', 0, '@+Z\0f:M:b', '@+Z\0f:M:b', 'M|4{7?9	>]dQMRC0', '', 0, '?'),
 ('M>bژ2', 'wp-content/updraft/plugins-old/wordfence/vendor/autoload.php', 0, 'nV8\\Bs', 'nV8\\Bs', '7h>8but^^Rx26#i(', '', 0, '?'),
 ('Pzy\\xn.4H0', 'wp-content/updraft/plugins-old/wordfence/vendor/composer/ClassLoader.php', 0, '|%*T*`', '|%*T*`', '289vu3n	C2sva/', '', 0, '?'),
 (';@:ӃF=DJ2', 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_classmap.php', 0, 'EӤ㭇Mg', 'EӤ㭇Mg', 'Q*\'B+Eߞ:myuW', '', 0, '?'),
 ('	H{}Fl$', 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_namespaces.php', 0, '5,}vĨ3G)', '5,}vĨ3G)', 'Er4@\0ԡ$z3$l\Z`iexl', '', 0, '?'),
 ('0՘֣tMB<}', 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_psr4.php', 0, '*qBItӟA<\"', '*qBItӟA<\"', '6qQ`d!cf.Bxq', '', 0, '?'),
 ('ݰ9/9T+', 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_real.php', 0, '+>r*mI', '+>r*mI', 'E\0.¿¯1F(Dfuv˔', '', 0, '?'),
 ('ޗ/+;YM2', 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_static.php', 0, 'B\\BH+)	', 'B\\BH+)	', '84E3I6-9!zGL5', '', 0, '?'),
 ('\"\Zo2_!n0', 'wp-content/updraft/plugins-old/wordfence/vendor/composer/ca-bundle/src/CaBundle.php', 0, 'ZU~L5@\ZVU', 'ZU~L5@\ZVU', '/rTrmGс\r%e\r|[', '', 0, '?'),
 ('bs	#cn', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Database/Reader.php', 0, '\nAgv1Pص', '\nAgv1Pص', '0o*\rvAo3:juy', '', 0, '?'),
 ('z^)\rJg', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/AddressNotFoundException.php', 0, '//Rj.', '//Rj.', '3\'X\ro`/D/3\Z', '', 0, '?'),
 ('m,Ϋ\';l', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/AuthenticationException.php', 0, 'dW,XEEo', 'dW,XEEo', 'l?)&&PP$@\\/', '', 0, '?'),
 ('gdZ&8u', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/GeoIp2Exception.php', 0, 'N	SX?z', 'N	SX?z', 'Ԧ\nٲLKY1%X7~*', '', 0, '?'),
 ('.ha}o_zLP|t	', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/HttpException.php', 0, 'lfk<\r\n', 'lfk<\r\n', 'R!O]pI\n\\VP9=!?', '', 0, '?'),
 ('s4ptx6G', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/InvalidRequestException.php', 0, 'IaRɞ%x', 'IaRɞ%x', 'M bd]FiPOZq', '', 0, '?'),
 ('$E*-&k', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/OutOfQueriesException.php', 0, '5H*f$ʝӐ', '5H*f$ʝӐ', 'ƝiczP1\"ݢӛoTWry*F', '', 0, '?'),
 ('hi\'4?U', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/AbstractModel.php', 0, '@ҏHC5̨[\0', '@ҏHC5̨[\0', 'Xf:Mt˃#sD4(NGF', '', 0, '?'),
 (',_ex(9.q>', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/AnonymousIp.php', 0, 'emgݜ|<뼸Dh', 'emgݜ|<뼸Dh', '+%G<t1]I5m\Z}E>;', '', 0, '?'),
 ('V(\rn`W', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Asn.php', 0, 'ڄ\n1h;!', 'ڄ\n1h;!', 'Mϡ	pk)!\r', '', 0, '?'),
 ('yw};J\'y', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/City.php', 0, '>Y!\\zJX', '>Y!\\zJX', 'B*yL˰au\"t\Z4Z۳Nk¥', '', 0, '?'),
 ('XlE)î', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/ConnectionType.php', 0, 'dS:-N!Q0\"', 'dS:-N!Q0\"', '6)?^\"F*g|&RΠ\0	', '', 0, '?'),
 (' ?idJ', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Country.php', 0, '\0Q#2ЏR', '\0Q#2ЏR', '~G)R7i-#R 9Hǫ b', '', 0, '?'),
 ('dVIWVZSA.', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Domain.php', 0, 'n4F0JC nk', 'n4F0JC nk', 'Cb,\"\">jŊAlD', '', 0, '?'),
 ('t̛ͥ\"ݙ=}', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Enterprise.php', 0, '6:2kP3', '6:2kP3', '%uMp,.\0@Zqr/Q', '', 0, '?'),
 ('\r.D=OQ!ԑ퀁', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Insights.php', 0, 'G=1\nV0', 'G=1\nV0', '8}>k6`uideHP^', '', 0, '?'),
 ('f7䔔\ZCV', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Isp.php', 0, 'pٽP]G', 'pٽP]G', '| )YM,30\Z*9p', '', 0, '?'),
 ('Dm]+k', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/ProviderInterface.php', 0, 'Z*Nfټ{', 'Z*Nfټ{', 'i˶|1v.4[(m@f>', '', 0, '?'),
 ('4J$Fh', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/AbstractPlaceRecord.php', 0, '`I.:`PR', '`I.:`PR', '#zR\ZHU>BnP,\'eTtߺ', '', 0, '?'),
 ('C#l5qlnq', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/AbstractRecord.php', 0, '$kA`lwy', '$kA`lwy', '7\r4	춥Q\nc>c\n>Pf84Hk', '', 0, '?'),
 ('>[Rr뎁', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/City.php', 0, '(,Eڎ;', '(,Eڎ;', '5+SsY>%r975[I=`<2M', '', 0, '?'),
 ('2`A`I', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Continent.php', 0, 'qDLa[	?$', 'qDLa[	?$', 'Gs\0\r/1v=pS-yE.U', '', 0, '?'),
 ('tخ^$2m', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Country.php', 0, ',0Z%', ',0Z%', 'g^M9=&*M{Xb0*u', '', 0, '?'),
 ('SaFzI#Z/v', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Location.php', 0, 'Y}`8vFJ', 'Y}`8vFJ', 'U߆([r嵳gh嬵!m9(\"', '', 0, '?'),
 ('{}ZˋX-B,^<', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/MaxMind.php', 0, 'Dqd6+\"U', 'Dqd6+\"U', 'Is;֮ikE@)', '', 0, '?'),
 ('!jYv', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Postal.php', 0, 'MbP\"xY@0', 'MbP\"xY@0', '\'n*2nԋ)a(_Iqɘ{', '', 0, '?'),
 ('|b5pI\"GuΓ#m', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/RepresentedCountry.php', 0, '>XVDm|P6\n', '>XVDm|P6\n', 'l=b:џ	RZ		6', '', 0, '?'),
 ('z.V5by0Y', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Subdivision.php', 0, ';uSl', ';uSl', 'M>:\r&V`\Z:O0Sv;\0Vw', '', 0, '?'),
 ('X_$>X;\'1', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Traits.php', 0, ';HoĴ`׳m%', ';HoĴ`׳m%', '(l]hЮa	yfh0v\'uvm', '', 0, '?'),
 ('/@e?\"p', 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/WebService/Client.php', 0, 'ⶨ;*?z', 'ⶨ;*?z', ':O.\'~y@Y`FMN:n.;q@', '', 0, '?'),
 ('ү=[oϲN_]', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/AuthenticationException.php', 0, 'K#lJPe0ug۔', 'K#lJPe0ug۔', 'UWMslL9#TbWj?\\u', '', 0, '?'),
 ('ۼH%Ed', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/HttpException.php', 0, '41l#}pzk1', '41l#}pzk1', 'h	_֚!E4\ZvF', '', 0, '?'),
 ('[c`׳	vs)', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/InsufficientFundsException.php', 0, 'mhOലf.I', 'mhOലf.I', 'oOb9_b-4-x%T5E9\'', '', 0, '?'),
 ('AQO>L', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidInputException.php', 0, 'r Ϭn+n', 'r Ϭn+n', '^qNТ&yN~\'S//>}p', '', 0, '?'),
 ('p\ZV$zXGM', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidRequestException.php', 0, 'GR˗c?qt', 'GR˗c?qt', '֝Rz5B,nɲ\nHoڨ|', '', 0, '?'),
 ('c!l9mX', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/IpAddressNotFoundException.php', 0, '1:!G~qic', '1:!G~qic', '^DCguPT!>W\Zk~_5\n8', '', 0, '?'),
 ('oeUu$9]', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/PermissionRequiredException.php', 0, '2΢	/E!<s', '2΢	/E!<s', '\\=53	ώv_%2A?$', '', 0, '?'),
 ('Gd|{9s', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/WebServiceException.php', 0, 'h$x /', 'h$x /', '<bobnAE7_GK', '', 0, '?'),
 ('Rvdސr.re', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Client.php', 0, 'am;SV#mI', 'am;SV#mI', 'R9F47i}ʧC^%', '', 0, '?'),
 ('6vb_oOvq', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/CurlRequest.php', 0, 'pKz`)9_@', 'pKz`)9_@', 'aғYeq7YTcȊi$Wت/!,', '', 0, '?'),
 ('v2I7', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/Request.php', 0, 'KdWؿEW', 'KdWؿEW', 'RW].dasJMLq+p},', '', 0, '?'),
 ('<4>oQ܋', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/RequestFactory.php', 0, 'b;v\'g~k', 'b;v\'g~k', 'm!MJ\"v>,0\0՜ɫ &jِ', '', 0, '?'),
 ('=s\'(T623z-', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/autoload.php', 0, 'V~МIXP/$', 'V~МIXP/$', 'sem/;֘ aZH`g3', '', 0, '?'),
 ('#L+$W6ME', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Decoder.php', 0, 'I\0$K  	', 'I\0$K  	', 'Vp\Z1͌э\'=~ٲF_u\\P', '', 0, '?'),
 ('%nd)(ʮ|A$', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/InvalidDatabaseException.php', 0, '06.tzxo', '06.tzxo', ';p^\03Թ( Aaw', '', 0, '?'),
 ('*9{hƁY6;', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Metadata.php', 0, 'Z<{~Gf(', 'Z<{~Gf(', ',ב[\Z@+?xPА', '', 0, '?'),
 ('ѾKR2', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Util.php', 0, 'g+کdݬ@', 'g+کdݬ@', 'wbjYStc IdQ', '', 0, '?'),
 ('bfPk{1wa', 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader.php', 0, ')H$I3^0', ')H$I3^0', 'Dsmr?vjzMo3=b0KR#', '', 0, '?'),
 ('~?{~Gh', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/init.php', 0, '`I,Bz1', '`I,Bz1', 'Q52<iiNKOb2d', '', 0, '?'),
 (';iQ,T9gSx', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/config.php', 0, '{1MRKE_/', '{1MRKE_/', '|qUUѿÎ|zG>*ۜ\"I;', '', 0, '?'),
 ('3lKX۲', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/http.php', 0, '<i\"KNX,', '<i\"KNX,', 'Cѝ⁪r+^YhjzZ', '', 0, '?'),
 ('>Zyo', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/json.php', 0, 'd#k', 'd#k', 'tw}?e	hBT92uCv7', '', 0, '?'),
 ('>d\Zd7+', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/parser/lexer.php', 0, 'xb#!YiJ', 'xb#!YiJ', 'nd@=[cg?N}־Rxl]X', '', 0, '?'),
 ('$iKk,<@', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/parser/parser.php', 0, '(wٯ(_', '(wٯ(_', 'b<Wr,M۫Pp>Nn', '', 0, '?'),
 ('V;w_sp4cŀ', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/parser/sqli.php', 0, '!^(m0G', '!^(m0G', '9*u1Q: \'s{>/_\'', '', 0, '?'),
 ('\nvڧTix\ZH', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/request.php', 0, 'CVS+:c|O쬋	', 'CVS+:c|O쬋	', 't=1i\Zn\0N!*iF', '', 0, '?'),
 ('gt	o\rTE', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/rules.php', 0, '|D#DD3)', '|D#DD3)', 'h=UuVU-Jށ\'Q;2rg', '', 0, '?'),
 ('+}C;lAx+', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/storage/file.php', 0, 'zzn', 'zzn', 'Ei!p\0\'R5R$#', '', 0, '?'),
 ('LfT(=sߜT', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/storage/mysql.php', 0, 'g\n4x%$0', 'g\n4x%$0', '^,5؎j,ҧQQhs', '', 0, '?'),
 ('f.YQ\\n', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/storage.php', 0, 'J\\4', 'J\\4', '!ʁ)wj%pջڞ56q袌m#w', '', 0, '?'),
 ('4&X2L/', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/utils.php', 0, '\r!(i.+)Қ\"{', '\r!(i.+)Қ\"{', 'ZQ[QG7؍E\"', '', 0, '?'),
 ('~]5F}]', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/view.php', 0, 'C؍0+C', 'C؍0+C', '`>&i(ŹCf&>Y\"', '', 0, '?'),
 ('U2,f@\Z', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/waf.php', 0, 'gP r摧u\\', 'gP r摧u\\', 'A,Z<oAfw!', '', 0, '?'),
 ('z\Zđ\'/1', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/xmlrpc.php', 0, 'f\r@)뻚', 'f\r@)뻚', ';_Im1\n9|!޶', '', 0, '?'),
 ('ՍK\\d\'\nZ8&', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/403-blacklist.php', 0, '96N\Z!JYU', '96N\Z!JYU', ',yS1̥;x5GiO9', '', 0, '?'),
 ('T&PzH5på', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/403-roadblock.php', 0, '\Z]\0(Xz', '\Z]\0(Xz', '茏P.)g8]4B5U;>JfÖ3}', '', 0, '?'),
 ('Wќ\ZiQs4', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/403.php', 0, 'R\0nW[_', 'R\0nW[_', '\rM#:A{qcD/>', '', 0, '?'),
 ('tUwIk:(Nr1', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/503-lockout.php', 0, 'o?MH|~E\"\'', 'o?MH|~E\"\'', 'o}[W%J+=5$)\'2ΨK', '', 0, '?'),
 ('z0e\\N	DM֊', 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/503.php', 0, 'yw2!_', 'yw2!_', 'xؑpw>oO׀L%#lH', '', 0, '?'),
 ('V޵DB҆*o', 'wp-content/updraft/plugins-old/wordfence/views/blocking/block-list.php', 0, 'LYPͺK\ne', 'LYPͺK\ne', ']SO	o*+uX:ʆw', '', 0, '?'),
 ('8í+UR', 'wp-content/updraft/plugins-old/wordfence/views/blocking/blocking-create.php', 0, '4JPЩsB', '4JPЩsB', 'r~5\n̊4GșA', '', 0, '?'),
 ('E\'Z)ؤ!nE', 'wp-content/updraft/plugins-old/wordfence/views/blocking/blocking-status.php', 0, 'ˮ_Xk', 'ˮ_Xk', '4>1^fs{q\'	ީM', '', 0, '?'),
 ('?Yc)930:', 'wp-content/updraft/plugins-old/wordfence/views/blocking/country-block-map.php', 0, 'uyGF,{Xz', 'uyGF,{Xz', '%Ԝ5;x^)G(o', '', 0, '?'),
 ('9,N_+pL', 'wp-content/updraft/plugins-old/wordfence/views/blocking/country-modal.php', 0, '-^A?', '-^A?', 'axR;,\'K?QߦH', '', 0, '?'),
 ('P\r%X@', 'wp-content/updraft/plugins-old/wordfence/views/blocking/option-bypass-cookie.php', 0, 'PAf0	/ (w1X', 'PAf0	/ (w1X', 'IRR\nߎd;I3G', '', 0, '?'),
 ('K2\n\\d ', 'wp-content/updraft/plugins-old/wordfence/views/blocking/option-bypass-redirect.php', 0, '\"5y \"\'f', '\"5y \"\'f', 'agLSSPU:̈p5Q<>Fr', '', 0, '?'),
 ('،\0C<\n', 'wp-content/updraft/plugins-old/wordfence/views/blocking/options-group-advanced-country.php', 0, '䜮`Su8', '䜮`Su8', 'h]sUsj=(GfvacS', '', 0, '?'),
 ('Yt>זjj', 'wp-content/updraft/plugins-old/wordfence/views/common/block-navigation-option.php', 0, 'O~}t.K', 'O~}t.K', 'MNF`\r9ӫrP,Q', '', 0, '?'),
 ('{yn,LeD;SR', 'wp-content/updraft/plugins-old/wordfence/views/common/indeterminate-progress.php', 0, 'I\"sg4\\(8', 'I\"sg4\\(8', '@Zn\"ξ~QՔ8sP\073', '', 0, '?'),
 ('>uA/$SZ', 'wp-content/updraft/plugins-old/wordfence/views/common/license.php', 0, 'y^@:Fgq]p!J', 'y^@:Fgq]p!J', 'Ѝ]|\\͏\\G$y[\\J\"', '', 0, '?'),
 ('mrsa\'R', 'wp-content/updraft/plugins-old/wordfence/views/common/modal-prompt.php', 0, 'h\r$o', 'h\r$o', 'l?9Rw\"H^\rs\ZD:Fa', '', 0, '?'),
 ('J.CݤkL', 'wp-content/updraft/plugins-old/wordfence/views/common/page-fixed-tabbar.php', 0, 'M#Ƃ,nj9{', 'M#Ƃ,nj9{', '+N)¨L	Kz(', '', 0, '?'),
 ('Bv{R0s4>', 'wp-content/updraft/plugins-old/wordfence/views/common/page-help.php', 0, '2o\0X#83~', '2o\0X#83~', '$>\n\ZW)O\0(\nݮ\08', '', 0, '?'),
 ('\"4^ꈮفfx', 'wp-content/updraft/plugins-old/wordfence/views/common/page-tabbar.php', 0, ')\ZtU2Ec0\'', ')\ZtU2Ec0\'', 'úM..8ѹ>NwjZWb*B', '', 0, '?'),
 ('ю2;P', 'wp-content/updraft/plugins-old/wordfence/views/common/page-title.php', 0, 'aA\'4=Gg', 'aA\'4=Gg', 'R{hC;_	G+RzrTz`4', '', 0, '?'),
 ('IZ:<', 'wp-content/updraft/plugins-old/wordfence/views/common/section-subtitle.php', 0, 'KcDÃ۬', 'KcDÃ۬', 'ZJwsh5MEu/jg[-', '', 0, '?'),
 ('Q8-窱AK-Y', 'wp-content/updraft/plugins-old/wordfence/views/common/section-title.php', 0, 'w]QVմi', 'w]QVմi', 'qr*-TN5\rOc;ma', '', 0, '?'),
 (';o@', 'wp-content/updraft/plugins-old/wordfence/views/common/status-circular.php', 0, ').=g', ').=g', 'q4^\"-9\nd1qO,', '', 0, '?'),
 ('øTVW1t`', 'wp-content/updraft/plugins-old/wordfence/views/common/status-critical.php', 0, 'Q[[_Y[ʛJ{&', 'Q[[_Y[ʛJ{&', 'nI\Zg[\0MZ1]', '', 0, '?'),
 ('agЀײ', 'wp-content/updraft/plugins-old/wordfence/views/common/status-detail.php', 0, 'ѿD\0|sW', 'ѿD\0|sW', '\n*vQ(Giu3@4*', '', 0, '?'),
 ('h6۞m', 'wp-content/updraft/plugins-old/wordfence/views/common/status-tooltip.php', 0, '%e\rFdE0sB', '%e\rFdE0sB', '%MbuI]CI\n6z}B4', '', 0, '?'),
 ('gL3%h', 'wp-content/updraft/plugins-old/wordfence/views/common/status-warning.php', 0, 'mfuֺg-g\0C=v', 'mfuֺg-g\0C=v', 'N<\r;d*8+)\ZbO?0E', '', 0, '?'),
 ('m%Ka8y', 'wp-content/updraft/plugins-old/wordfence/views/common/unsubscribe.php', 0, '}}sJK', '}}sJK', 'a\0k5	-\0oDx۠8u%\'', '', 0, '?'),
 ('*CۿfN', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/global-status.php', 0, '.1(>\ZVE~', '.1(>\ZVE~', 'Ih棗ht;a6N*z', '', 0, '?'),
 ('Evs]Y굅', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/option-howgetips.php', 0, 'ϤSZ2=ǌ^', 'ϤSZ2=ǌ^', '\0Ԋw\Z)6Zp-lP-ND', '', 0, '?'),
 ('ȻڶF2Y46', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-alert.php', 0, '\Z!Hмhڣ', '\Z!Hмhڣ', '(t$nèOҨ,B@,Lo|', '', 0, '?'),
 ('r*(MM?', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-dashboard.php', 0, '&m:7v=', '&m:7v=', '\nqYۡ>h_P', '', 0, '?'),
 ('X\'w۔du.', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-email-summary.php', 0, '6#>{zq\nS%M', '6#>{zq\nS%M', 'pRA7ZQjCpNa=M', '', 0, '?'),
 ('HFU\\Qr@T9', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-general.php', 0, ':nn)', ':nn)', 'g #ztJȴY12cƳ\"Pow', '', 0, '?'),
 ('ģLkDb\\', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-import.php', 0, '=S0lK@^=', '=S0lK@^=', 'υ<URY@*cs', '', 0, '?'),
 (';YP͵j\0GS2', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-license.php', 0, '{1i6Lx`3r', '{1i6Lx`3r', 'žĄDP9Lh҅o-', '', 0, '?'),
 ('q/_͞ba', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-view-customization.php', 0, '~H`b\0nvB JQ\"', '~H`b\0nvB JQ\"', 'F˲IG6gV)0k', '', 0, '?'),
 ('0CВc', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/status-payment-expiring.php', 0, 'raX\'z\05+\"7', 'raX\'z\05+\"7', 'v$r_syYU{ؘ?C', '', 0, '?'),
 ('z?n2[', 'wp-content/updraft/plugins-old/wordfence/views/dashboard/status-renewing.php', 0, 'an$6\"', 'an$6\"', 'tɢC-?\'(uꢦAT-1ba:', '', 0, '?'),
 ('PC`6w&P]VZ', 'wp-content/updraft/plugins-old/wordfence/views/gdpr/banner.php', 0, '*K`;\0}', '*K`;\0}', ',cn9۝$O`&pTOXiس', '', 0, '?'),
 ('qSoK^7', 'wp-content/updraft/plugins-old/wordfence/views/gdpr/disabled-overlay.php', 0, '!*o2¯$', '!*o2¯$', 'TCWD9-Χ0(\ZJi', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('[%.cr{', 'wp-content/updraft/plugins-old/wordfence/views/onboarding/banner.php', 0, '0͒l\0B', '0͒l\0B', ',{=#\nOQݥWpYEY2>X4h', '', 0, '?'),
 ('\Zz|\r	', 'wp-content/updraft/plugins-old/wordfence/views/onboarding/disabled-overlay.php', 0, 'b՗ln', 'b՗ln', 'ya2-@\"=*\'', '', 0, '?'),
 ('T)GFIcF5S', 'wp-content/updraft/plugins-old/wordfence/views/onboarding/fresh-install.php', 0, 'ނ!)(N+U', 'ނ!)(N+U', '#Ό|pPҰ,mkyt\r܏@6', '', 0, '?'),
 ('L\\wzF0', 'wp-content/updraft/plugins-old/wordfence/views/onboarding/modal-final-attempt.php', 0, 'yuJɶg', 'yuJɶg', 'l3Ä\ncwx~eLhP\Zے9', '', 0, '?'),
 ('!*LG/', 'wp-content/updraft/plugins-old/wordfence/views/onboarding/overlay.php', 0, 'iŮ9e`2', 'iŮ9e`2', 'ZMGXL;$xMi|Q%ŽY2$_', '', 0, '?'),
 ('bNfVsJQT', 'wp-content/updraft/plugins-old/wordfence/views/onboarding/plugin-header.php', 0, 'kQ4ڌtS*', 'kQ4ڌtS*', 'Qh9\07MN64>\\', '', 0, '?'),
 ('_MM\\Ji>;', 'wp-content/updraft/plugins-old/wordfence/views/onboarding/tour-overlay.php', 0, ':% );\0', ':% );\0', '\Z\'ġ맪.s\'sd4^I', '', 0, '?'),
 ('{d;	=lt', 'wp-content/updraft/plugins-old/wordfence/views/options/block-all-options-controls.php', 0, '95IB\"a', '95IB\"a', 'VG37R(@\n,\n	w', '', 0, '?'),
 ('/iR5j:x{Z', 'wp-content/updraft/plugins-old/wordfence/views/options/block-controls.php', 0, '8 5U,e\n4(', '8 5U,e\n4(', 'S|POdɇ&ٲ-', '', 0, '?'),
 ('G_3v!\0', 'wp-content/updraft/plugins-old/wordfence/views/options/option-label.php', 0, '`Lgf', '`Lgf', '_\r\0\0Z}})v[4', '', 0, '?'),
 ('{\rv:', 'wp-content/updraft/plugins-old/wordfence/views/options/option-select.php', 0, 'q5C&', 'q5C&', 'cU3AW\n(:F@zAgG&j9', '', 0, '?'),
 ('ږxTxBT˔c', 'wp-content/updraft/plugins-old/wordfence/views/options/option-switch.php', 0, 'miE>WcZaig', 'miE>WcZaig', '&՚j:g&*56yɨdq4֙', '', 0, '?'),
 ('M<\rDԨg', 'wp-content/updraft/plugins-old/wordfence/views/options/option-text.php', 0, '}KmwK5 IO', '}KmwK5 IO', '+dn\\/M+{x/(h\Z-z%1r', '', 0, '?'),
 ('u\nlkMIo', 'wp-content/updraft/plugins-old/wordfence/views/options/option-textarea.php', 0, 'Ac[DO+.f\Z', 'Ac[DO+.f\Z', '~?\\|q4τ>jW\06wQEg=z[', '', 0, '?'),
 ('Qg	&^0[0', 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-boolean-switch.php', 0, ',+[Rֈ', ',+[Rֈ', 'lFVjFlV˱VǞB`', '', 0, '?'),
 ('AG[', 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-multiple.php', 0, '!0K܃5{PD(', '!0K܃5{PD(', '{`α0HoG🨶Mo$P', '', 0, '?'),
 ('XmAXVl,', 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-segmented.php', 0, 'B|ssGo1x', 'B|ssGo1x', '\n9VW |:]\\)d^U#', '', 0, '?'),
 ('01w3pM', 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-select.php', 0, '\"p+No+T', '\"p+No+T', 'Xq?\'Є,Uэf[@aWh', '', 0, '?'),
 ('d9+)\\wʘ', 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-sub.php', 0, '\Z(a|Α]x', '\Z(a|Α]x', '͏̽U$q9eg\Zrn_aHC', '', 0, '?'),
 ('\nxf%l>\'', 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-textarea.php', 0, '눣E	xbH$t', '눣E	xbH$t', 'Fm0jC,W$=9nԫ', '', 0, '?'),
 ('\";\nݵy', 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled.php', 0, ']KrYwB', ']KrYwB', 'knS	3&Y=Ձ_+?Hƪ%', '', 0, '?'),
 ('&K\0Qݨν', 'wp-content/updraft/plugins-old/wordfence/views/options/option-token.php', 0, 'WY7o	_Ӏ?', 'WY7o	_Ӏ?', ' AQNe\ZywsG@ZI&L', '', 0, '?'),
 ('G\Z', 'wp-content/updraft/plugins-old/wordfence/views/options/options-title.php', 0, 'E0\"#', 'E0\"#', '֩y\n	ĳXH-<f	c', '', 0, '?'),
 ('I=g/Ŷ=?', 'wp-content/updraft/plugins-old/wordfence/views/reports/activity-report-email-inline.php', 0, '!߹5HIUw', '!߹5HIUw', '&V&Yue1H)L?p=~-a', '', 0, '?'),
 ('i2$?$A', 'wp-content/updraft/plugins-old/wordfence/views/reports/activity-report.php', 0, '}wu!nU', '}wu!nU', 'k\Z>,z>\r\rKMAI;~', '', 0, '?'),
 ('eƐҞY, i', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-base.php', 0, 'ǢϚtpAy', 'ǢϚtpAy', '8PciCQVJ+6?pT6\Zzd', '', 0, '?'),
 ('%{S', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-checkGSB.php', 0, 'T&#i]<{', 'T&#i]<{', 'EPmh>*HS8SFpXbdU8', '', 0, '?'),
 ('nI^\rrl5!\"', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-checkHowGetIPs.php', 0, ':>ޤ+~tͫ*', ':>ޤ+~tͫ*', 'I|^ψg?nƏAd]68R', '', 0, '?'),
 ('\'vY| %Yj', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-checkSpamIP.php', 0, '`Xcb7qNS', '`Xcb7qNS', 'MG] ?ugPp1,(V^', '', 0, '?'),
 ('{ͅe8', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-commentBadURL.php', 0, '4Z?d⢡', '4Z?d⢡', '1XaRpLrIO%%|\rVge\0-b^n=', '', 0, '?'),
 ('$n!G۠j7', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-configReadable.php', 0, ' QL', ' QL', 'R21?ǌ*=bͥ}X&MƷ', '', 0, '?'),
 ('DK° {', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-edit-comment.php', 0, ' ;͏(vpoq', ' ;͏(vpoq', 'z-\0Aj@ 8cT&՞', '', 0, '?'),
 (' $6<\'^', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-edit-post.php', 0, 'nZHUϘ', 'nZHUϘ', 'ݓ!#hlts):}*aEglTD', '', 0, '?'),
 ('	Pem\\6P\r', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-edit-user.php', 0, 'Dd4\'T)', 'Dd4\'T)', 'KPUwxd!)n1w<m.ǳf', '', 0, '?'),
 ('TxBQ\r{A', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-hide-file.php', 0, 'y_V^\n%pc', 'y_V^\n%pc', 'dWgme˰5Ҡ:;W\'', '', 0, '?'),
 ('s&G >', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-ignore.php', 0, '\\Pm@n', '\\Pm@n', '4āLsFm\Z^\ZDQ', '', 0, '?'),
 ('d\'U|?w', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-repair.php', 0, '[оڰA9(n', '[оڰA9(n', 'ߑJ[4#~H8ȉB9+/mv', '', 0, '?'),
 (' fꑒ5<', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-show-details.php', 0, 'I6ϲē]', 'I6ϲē]', 'yh;}<6yZ$	M>K(\\#&\"\rej', '', 0, '?'),
 ('ֆUN<>V202W', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-coreUnknown.php', 0, 'رm:h\rGZڋY', 'رm:h\rGZڋY', 't8uUUSĒqfS3iiu', '', 0, '?'),
 ('y팇b[h޺B%', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-database.php', 0, '[ \nRoN7|', '[ \nRoN7|', '~❃gd&w[uo|t}', '', 0, '?'),
 ('X>kJY', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-diskSpace.php', 0, '\Z.*:î+1', '\Z.*:î+1', '\Zޔeg)QRCAm', '', 0, '?'),
 ('J\\\'oq.,', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-easyPassword.php', 0, '[+e[eϙfW', '[+e[eϙfW', 'QAu&{AiXPK[{0Qk', '', 0, '?'),
 ('?ߖ`K֩', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-file.php', 0, '?}Ɠ.Μe1U', '?}Ɠ.Μe1U', 'MTzX`પmO]$sX', '', 0, '?'),
 ('eyh8j', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-geoipSupport.php', 0, '\0<^=f', '\0<^=f', 's]ѽj$	↜Skik', '', 0, '?'),
 ('>94n	.)˺', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-knownfile.php', 0, 'G^=p=$\Z2', 'G^=p=$\Z2', 'RK6N\"3*\"J/0ix0', '', 0, '?'),
 ('rYFFq8{ .u', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-optionBadURL.php', 0, 't\"N+՛L', 't\"N+՛L', '67E0܃ՐC{\\adPb2+pW;P', '', 0, '?'),
 ('K}\nA7]|$HV', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-postBadTitle.php', 0, 'd+l@h', 'd+l@h', '3i]m&	s֯Igeok/M', '', 0, '?'),
 ('AP?2H', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-postBadURL.php', 0, 'u@ަ$,', 'u@ަ$,', 'dٍ|]Q!Qw;`7Zf', '', 0, '?'),
 ('KLKUr*E8s', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-publiclyAccessible.php', 0, '=3n.ZK7Rb~<', '=3n.ZK7Rb~<', 'LؖknHN\n$ʨ#', '', 0, '?'),
 ('ax+5yL;', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-skippedPaths.php', 0, 'ROIIԥ{', 'ROIIԥ{', '9YZA}7=:\'FoG\'Rɹ_-', '', 0, '?'),
 ('9!P%W5', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-spamvertizeCheck.php', 0, '%ؘ5aO_', '%ؘ5aO_', '3½}߈6-x%uv', '', 0, '?'),
 ('?20|YV\' MfM', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-suspiciousAdminUsers.php', 0, 'P<\0cAFLN', 'P<\0cAFLN', 'R]`[2#XÉi(E\n`rJ', '', 0, '?'),
 ('d\nV<J؄', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-timelimit.php', 0, 'J7^њOi', 'J7^њOi', '5QgwBH.f<<Zh&V', '', 0, '?'),
 ('<!JX[+B', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wafStatus.php', 0, '<38xuFRĖȦE', '<38xuFRĖȦE', 'n?Qbz	٢)S*,Z', '', 0, '?'),
 ('{E(0\"]>K4Q', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginAbandoned.php', 0, 'jv[pջBM', 'jv[pջBM', '	)Yt\rb/\Z㲰i\r88', '', 0, '?'),
 (']#,8#$yR^-a', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginRemoved.php', 0, '9:7]6hVo', '9:7]6hVo', '߫/LkOTbdSEiL9~8', '', 0, '?'),
 ('^\0.ǚhpkZ', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginUpgrade.php', 0, 'aRp#p', 'aRp#p', 'rL-RW&P!aS0T', '', 0, '?'),
 ('m}GՒ', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginVulnerable.php', 0, 'tvwX\n_Yg!', 'tvwX\n_Yg!', 'r;\Z G[i$)v]j7im#', '', 0, '?'),
 ('=<L?', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfThemeUpgrade.php', 0, '9¡^-,措Eg', '9¡^-,措Eg', 'X0\rvfŭ-$ZuYS ', '', 0, '?'),
 ('t\\ki&S', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfUpgrade.php', 0, 'DOۏ~*s/', 'DOۏ~*s/', 'c^\0]*ζז\\T1msd# ^U', '', 0, '?'),
 (']`dT8', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wpscan_directoryList.php', 0, 'i0j82\ns', 'i0j82\ns', 'v\\qY{S<|+{(m?)D=', '', 0, '?'),
 ('9P1R.', 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wpscan_fullPathDiscl.php', 0, 'tGN8	6', 'tGN8	6', 'YV)ceW/Zmҳn\'n\0MK~', '', 0, '?'),
 ('Ar60?X\0', 'wp-content/updraft/plugins-old/wordfence/views/scanner/no-issues.php', 0, 'xt-|Fe', 'xt-|Fe', '_?7c:_@EJs[', '', 0, '?'),
 (',ttQ|CqjN', 'wp-content/updraft/plugins-old/wordfence/views/scanner/option-scan-signatures.php', 0, 'dzGf\'Pidi', 'dzGf\'Pidi', 'T1%R2VPRJB\\ˈgen', '', 0, '?'),
 ('sPo6', 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-advanced.php', 0, 'RYtO`6qz', 'RYtO`6qz', 'cV*}zc*(6`=9no${', '', 0, '?'),
 ('HOSax~', 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-basic.php', 0, ',z7\nɲߞ', ',z7\nɲߞ', 'Ab.hNh|:H-=(1fJ', '', 0, '?'),
 ('WC\"{d1l', 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-general.php', 0, '_Վ7;__', '_Վ7;__', ':Wn%JzW7&NH<\"dKe', '', 0, '?'),
 ('C(.>}4m', 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-performance.php', 0, 'iLxЊsf', 'iLxЊsf', 'da16hr76[)ՋOM罒z', '', 0, '?'),
 ('u@\n', 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-scan-schedule.php', 0, 'Ź-܉|JU', 'Ź-܉|JU', 'V\rc7g6抭VmCP', '', 0, '?'),
 ('1-nih	', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-failed.php', 0, 'Eۻ04r', 'Eۻ04r', 'H?MqK-4l_<*=܀ňp+', '', 0, '?'),
 ('bM{zI}7x', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-progress-detailed.php', 0, ' j<c(SCJ', ' j<c(SCJ', 'r3H[~2.<_J3{T{XӼPq', '', 0, '?'),
 (')\Z[-\0˫Y', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-progress-element.php', 0, 'J!%IWb', 'J!%IWb', 'tẁ~sg\n+A}bLNu', '', 0, '?'),
 ('!6A}j', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-progress.php', 0, '%\nrE?m', '%\nrE?m', 'Qf\0.<:;6\"{N+mE', '', 0, '?'),
 ('%l~ȹc.', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-results.php', 0, '8΂,\\', '8΂,\\', 'SHS6p_2*\rTD\0G9', '', 0, '?'),
 ('m	Oș|q<', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-scheduling.php', 0, '\0W쮜)Ǣ±', '\0W쮜)Ǣ±', 'b¥USw툒g:=P', '', 0, '?'),
 ('?ׄ\0\\rV[פ^', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-starter.php', 0, 'E `b{{v\r', 'E `b{{v\r', 'qFxgTA]Mk^>\'UB', '', 0, '?'),
 ('5CtRlD6', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-type.php', 0, '_Zb4ګ*', '_Zb4ګ*', 'w.\0/\"kzvHQ6s&>`KRC', '', 0, '?'),
 ('P[[Vʻ̑\n', 'wp-content/updraft/plugins-old/wordfence/views/scanner/scanner-status.php', 0, 'ޑ[.ɕl\\:', 'ޑ[.ɕl\\:', '&k0lcX**?\rܒ', '', 0, '?'),
 ('~q?;Tv', 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning-beta-sigs.php', 0, ',)Rqy|4.', ',)Rqy|4.', '%U<GH[.!e˂t,gsɄ', '', 0, '?'),
 ('5\n=s8\Z', 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning-bottom.php', 0, ',Is0w4Q', ',Is0w4Q', 'E\"v+󴄏bo}xa{:@E', '', 0, '?'),
 ('E\n̂+kfI\'', 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning-high-sense.php', 0, 'sTDzҧm', 'sTDzҧm', '5؄:\"sx4Ҹ\09`\Zi?', '', 0, '?'),
 ('v@^nԈ<', 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning.php', 0, '5w1,5bdvF', '5w1,5bdvF', 'g\"g2ߚ}qA?$)d', '', 0, '?'),
 (':eY)I8-R', 'wp-content/updraft/plugins-old/wordfence/views/tools/options-group-2fa.php', 0, 'ONjPv4', 'ONjPv4', 'm]n>nFf;Gf-m_L4b\'', '', 0, '?'),
 ('SjXk\\/UkbJ', 'wp-content/updraft/plugins-old/wordfence/views/tools/options-group-live-traffic.php', 0, '5_+EG', '5_+EG', 's}RB|KzI[Y)r', '', 0, '?'),
 ('6mQ/wԍ', 'wp-content/updraft/plugins-old/wordfence/views/tours/login-security.php', 0, '#?canՐSK\Z^', '#?canՐSK\Z^', '/a~-2y]yp!Y蝅EK_', '', 0, '?'),
 ('$a6', 'wp-content/updraft/plugins-old/wordfence/views/waf/debug.php', 0, 'FM@i-M', 'FM@i-M', '	;B@EŻ߬ue}', '', 0, '?'),
 ('v\":\Z0', 'wp-content/updraft/plugins-old/wordfence/views/waf/firewall-status.php', 0, 'lw\0i75G', 'lw\0i75G', '\'WֵDrDBeH\n@\":=!M#f', '', 0, '?'),
 ('\n%hBQ9', 'wp-content/updraft/plugins-old/wordfence/views/waf/option-rate-limit.php', 0, '\"ăEzZGS 0', '\"ăEzZGS 0', '4%pDM_Mi׽D{F', '', 0, '?'),
 ('Ft\Z\nޓ?5Ҟ', 'wp-content/updraft/plugins-old/wordfence/views/waf/option-rules.php', 0, ' {<\Z\0\r\Z$', ' {<\Z\0\r\Z$', '4fŜ\"\"ł>2L\0\"k1S\nw', '', 0, '?'),
 ('ct5eπ', 'wp-content/updraft/plugins-old/wordfence/views/waf/option-whitelist.php', 0, 'Ψ-˯3w', 'Ψ-˯3w', 'G_`8B؎P\n\",\'HŨ', '', 0, '?'),
 (':-{Jt', 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-advanced-firewall.php', 0, 'IN~dFe', 'IN~dFe', 'lBoS)ޥ9o!ǻm#$', '', 0, '?'),
 ('ţw\'k?^[J', 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-basic-firewall.php', 0, '03*66-FU.', '03*66-FU.', 'TQ&n)&MgDgШ', '', 0, '?'),
 ('\0\Z]d)U#E', 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-brute-force.php', 0, 'Ŏqў¯/	\n', 'Ŏqў¯/	\n', 'W_\rF_H\07	iatr؈M=', '', 0, '?'),
 ('mLA#[', 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-rate-limiting.php', 0, 'ȁ)\\Qq9F#', 'ȁ)\\Qq9F#', 'l$DЦm	,N8', '', 0, '?'),
 ('4]pWo\\', 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-whitelisted.php', 0, 'ViK۹v?', 'ViK۹v?', '-L#syܥjswBt\'ш;8=', '', 0, '?'),
 ('nKB5?\0Ox', 'wp-content/updraft/plugins-old/wordfence/views/waf/status-tooltip-learning-mode.php', 0, 'ُ8l%', 'ُ8l%', '!]`_.\\? .\ZbɐGQe)m', '', 0, '?'),
 ('?{7ʭim', 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-install-manual.php', 0, '$x~)[ڜz', '$x~)[ڜz', '7R N`n^?()^RΚĖ', '', 0, '?'),
 ('s|%\\]KH\\', 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-install-success.php', 0, '{rb^?', '{rb^?', '/\\2CeL+:pZ', '', 0, '?'),
 ('qY9-sJ\'', 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-install.php', 0, ']cE^GMSf', ']cE^GMSf', '\\H.T:ďg]B|͌|{=pǵ', '', 0, '?'),
 ('7l:(p*뾊\'', 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-modal-wrapper.php', 0, 'nγUǩ7PF', 'nγUǩ7PF', 'f4֒p.Օ*^Nl8A', '', 0, '?'),
 ('Ӡ~~J>:Z+>', 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-uninstall-success.php', 0, '*sf2', '*sf2', '|\rߣ2잿9/%[7m{Eu-', '', 0, '?'),
 ('ULF\'JPPncH', 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-uninstall.php', 0, 'wxlMI\0lT㐥', 'wxlMI\0lT㐥', 'lEN1-R|pG^;ï1', '', 0, '?'),
 ('hGY)ӯr', 'wp-content/updraft/plugins-old/wordfence/waf/bootstrap.php', 0, 'Z>86Ww ', 'Z>86Ww ', 'VQ\\q;=<JA>F', '', 0, '?'),
 ('a\Z^~\\n\'k߀', 'wp-content/updraft/plugins-old/wordfence/waf/wfWAFGeoIP2.php', 0, '݇(0,mG_Y3', '݇(0,mG_Y3', '^)oBfg*VP?~u:', '', 0, '?'),
 ('GObi	S3\05', 'wp-content/updraft/plugins-old/wordfence/waf/wfWAFIPBlocksController.php', 0, '}`iy', '}`iy', 'Tܯ19^ջP\'Ld%k|P؞', '', 0, '?'),
 ('\"y>b%yq', 'wp-content/updraft/plugins-old/wordfence/waf/wfWAFUserIPRange.php', 0, 'yFH\'\'nގ', 'yFH\'\'nގ', 'KD[Rஞ 5:grP7*X\Z', '', 0, '?'),
 ('H!C꩹ ', 'wp-content/updraft/plugins-old/wordfence/wordfence.php', 0, 's癴xv?0', 's癴xv?0', 'яTJumySHר4\"1', '', 0, '?'),
 ('EY&4', 'wp-content/updraft/plugins-old/wp-cerber/admin/cerber-settings.php', 0, 'T|KL/R.~h%', 'T|KL/R.~h%', '֞$g&iDJVByvo{YC', '', 0, '?'),
 ('Iy@ES', 'wp-content/updraft/plugins-old/wp-cerber/assets/admin.js', 0, 'b_ũOW<w%\'', 'b_ũOW<w%\'', 'AM wׁ+T֖KJJ#', '', 0, '?'),
 ('<\n},', 'wp-content/updraft/plugins-old/wp-cerber/assets/icons/fonts/crb.svg', 0, '(bE?\"MqH\Z', '(bE?\"MqH\Z', '\\;߇Md^njףI`\\Ux\"d', '', 0, '?'),
 ('D\Z:Gs]91', 'wp-content/updraft/plugins-old/wp-cerber/assets/magnific/jquery.magnific-popup.min.js', 0, 'l$Ȼ0bn', 'l$Ȼ0bn', 'mS$^|T8đ=ظlF`p', '', 0, '?'),
 ('gд~ɓ2Ci', 'wp-content/updraft/plugins-old/wp-cerber/assets/multi/multi.js', 0, '\Z/WnU#֬VK', '\Z/WnU#֬VK', '\"%6rHB)xfL]4t', '', 0, '?'),
 ('B;WG(', 'wp-content/updraft/plugins-old/wp-cerber/assets/multi/multi.min.js', 0, 'P? a80$', 'P? a80$', '*}AB/*o%;5k;3', '', 0, '?'),
 ('yR\nc', 'wp-content/updraft/plugins-old/wp-cerber/assets/scanner.js', 0, '()f.0?', '()f.0?', 'zr@2XY`\' {9c	hԔ7', '', 0, '?'),
 ('qnb)O4+Pu', 'wp-content/updraft/plugins-old/wp-cerber/assets/select2/dist/js/select2.min.js', 0, '|Ԋ23\\:=', '|Ԋ23\\:=', '	<(*WvЋtwr_ti	', '', 0, '?'),
 ('ѐqlg(', 'wp-content/updraft/plugins-old/wp-cerber/assets/sh/scripts/shBrushPhp.js', 0, '\nR1G˕\nhc', '\nR1G˕\nhc', ' ^bVl!,G3/', '', 0, '?'),
 ('*[Xv{#!b', 'wp-content/updraft/plugins-old/wp-cerber/assets/sh/scripts/shCore.js', 0, 'Hl7B20O', 'Hl7B20O', '%{*ZO5D\n¦+1Tc#`', '', 0, '?'),
 ('jKI!B;!h', 'wp-content/updraft/plugins-old/wp-cerber/assets/tpicker/jquery.timepicker.min.js', 0, 'P%S%<?\Z\\', 'P%S%<?\Z\\', 'gO:!rhʀ6\'wfDz', '', 0, '?'),
 ('K%i!}Y:', 'wp-content/updraft/plugins-old/wp-cerber/assets/wp-admin.js', 0, '׮^Qq0', '׮^Qq0', 'Ō$)e/߬Nn$|a[#', '', 0, '?'),
 ('V\Z@6^oiZ&', 'wp-content/updraft/plugins-old/wp-cerber/cerber-2fa.php', 0, 'ZrGR2 \0q', 'ZrGR2 \0q', '\rKt\raP޹!c^m$98', '', 0, '?'),
 ('3vYtĒ\\\0ڕ', 'wp-content/updraft/plugins-old/wp-cerber/cerber-addons.php', 0, '],\\J=:W[', '],\\J=:W[', 'yyA\0f7#zT@(', '', 0, '?'),
 ('KDژв\"rp', 'wp-content/updraft/plugins-old/wp-cerber/cerber-ds.php', 0, 'B\"+\n.\0}', 'B\"+\n.\0}', 'mt\'TUFZȓP\'gO3DWt_', '', 0, '?'),
 ('A \\9.aJNݜ', 'wp-content/updraft/plugins-old/wp-cerber/cerber-lab.php', 0, '>wH5\n!', '>wH5\n!', 'JS!QM!\rY!*k|fE&A', '', 0, '?'),
 ('\'RyWe/4q', 'wp-content/updraft/plugins-old/wp-cerber/cerber-load.php', 0, '6c)ĈbD3R', '6c)ĈbD3R', 's+?،^2ڸd	#1}o ', '', 0, '?'),
 ('3K7gO^ZpF', 'wp-content/updraft/plugins-old/wp-cerber/cerber-maintenance.php', 0, 'd}<|\rt', 'd}<|\rt', ')ivNA[#6d>o׫', '', 0, '?'),
 ('\"mNZW?', 'wp-content/updraft/plugins-old/wp-cerber/cerber-news.php', 0, ' W-IlMg', ' W-IlMg', 'Y&Q\"wT8]ǥV0#2x8', '', 0, '?'),
 ('(b\"@od', 'wp-content/updraft/plugins-old/wp-cerber/cerber-pluggable.php', 0, 'nڰ\Zq|1', 'nڰ\Zq|1', 'Ԛg!E#Pk̰ޛ\0XwXW', '', 0, '?'),
 ('EH؈m', 'wp-content/updraft/plugins-old/wp-cerber/cerber-request.php', 0, 'C8&\Z', 'C8&\Z', 'U\r~Q-F,ڸnY|ۿ0', '', 0, '?'),
 ('CQ6ߗw$', 'wp-content/updraft/plugins-old/wp-cerber/cerber-scanner.php', 0, '@0qB8 ', '@0qB8 ', '3Adu3n;UgVn!o%i', '', 0, '?'),
 ('\Z$Z8:Lx', 'wp-content/updraft/plugins-old/wp-cerber/cerber-tools.php', 0, 'RScq\"mM', 'RScq\"mM', 's߼M2{ɯfѦ4T;', '', 0, '?'),
 ('8(sRI', 'wp-content/updraft/plugins-old/wp-cerber/cerber-users.php', 0, '3)pf:?c9', '3)pf:?c9', 'oۀnJˊT\n%Z(', '', 0, '?'),
 ('\\jTczЩe', 'wp-content/updraft/plugins-old/wp-cerber/common.php', 0, '\\U,p/', '\\U,p/', ',|;@vYBֻx}%#U', '', 0, '?'),
 ('sT}$Ubب5', 'wp-content/updraft/plugins-old/wp-cerber/dashboard.php', 0, 'zGT:Ytr', 'zGT:Ytr', '<ot>C{*\Z3XX', '', 0, '?'),
 ('˰_7@N.wUp#X', 'wp-content/updraft/plugins-old/wp-cerber/index.php', 0, 'z=v]V', 'z=v]V', 'k~	UH\ZxPĀ<;X', '', 0, '?'),
 ('&bpTKIxJ̜^', 'wp-content/updraft/plugins-old/wp-cerber/jetflow.php', 0, 'y{\\O1\"', 'y{\\O1\"', 'BRGʯ`cRo]ٔԭ]ROY', '', 0, '?'),
 ('duzYk', 'wp-content/updraft/plugins-old/wp-cerber/modules/aaa-wp-cerber.php', 0, '	~K|)9', '	~K|)9', 'fǵ!Ҳ\'Tc|bz7<', '', 0, '?'),
 ('sNA\\7YẂ', 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-nexus-master.php', 0, 'h_2>,[%', 'h_2>,[%', '<\0B5TY.4WtV', '', 0, '?'),
 ('!HoD4\ZUb0N', 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-nexus-slave.php', 0, 's-#42_3J', 's-#42_3J', '&,8%B#3\"d9 `', '', 0, '?'),
 ('bU/˩', 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-nexus.php', 0, 'b.@s{Yߛg', 'b.@s{Yߛg', 'r\\(0\nB%hOW', '', 0, '?'),
 ('6OGhR՛h', 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-slave-list.php', 0, '}MZg9eq\Z\\', '}MZg9eq\Z\\', '(\'Lzv,yn[\\', '', 0, '?'),
 ('oYfwI\0ԠqĨ', 'wp-content/updraft/plugins-old/wp-cerber/ripe.php', 0, '<RJ(b', '<RJ(b', 'sygi\"Ӧn%/qɕM', '', 0, '?'),
 ('v(IYs刪bxv', 'wp-content/updraft/plugins-old/wp-cerber/settings.php', 0, '|bP\nX', '|bP\nX', '@X97>4v́:rz', '', 0, '?'),
 ('T=EMX5*J', 'wp-content/updraft/plugins-old/wp-cerber/whois.php', 0, 'C8{[67d', 'C8{[67d', 'Er\n	1&t[c.F3DYq\Z', '', 0, '?'),
 ('̇B-', 'wp-content/updraft/plugins-old/wp-cerber/wp-cerber.php', 0, 'Wq/\rъV', 'Wq/\rъV', 'TصJDD8AY&<n?MMRu', '', 0, '?'),
 ('+\\\ro\0', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith-infs.js', 0, '+g\'}9', '+g\'}9', 'wX;J=ɧiˍepM2&', '', 0, '?'),
 ('EL_.w.3#', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith-infs.min.js', 0, '&Vy*7QL', '&Vy*7QL', 'w]h3RdCw730v|B0p{\rW', '', 0, '?'),
 ('6%L\Z)5i', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith.infinitescroll.js', 0, 'K	M0Ɋ', 'K	M0Ɋ', 'q )q1ՉuHY՚', '', 0, '?'),
 ('ħ*G@', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith.infinitescroll.min.js', 0, 'G_91ɪ', 'G_91ɪ', 'fdEީq?n4B6g\rk', '', 0, '?'),
 ('x*\0qs\'c\0', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/class.yith-infs-admin.php', 0, 'DsAӪ]_ݞY\n', 'DsAӪ]_ݞY\n', 'v\0n>,iO\\R', '', 0, '?'),
 ('k3YJp}U{', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/class.yith-infs-frontend.php', 0, 'j:_nϔ', 'j:_nϔ', '*c?UrACye|', '', 0, '?'),
 ('|#@5A㔆&', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/class.yith-infs.php', 0, ')ᎽVTU7', ')ᎽVTU7', 'CqJͮnR>߂~GUV', '', 0, '?'),
 ('\rk.?\n ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/functions.yith-infs.php', 0, 'bdU:W[\ZVf', 'bdU:W[\ZVf', 'XLJ/<(uJfMՕ', '', 0, '?'),
 ('Xo୙C|JЭ@', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/init.php', 0, 'E2KB~GFP', 'E2KB~GFP', 'hkEE[^tjpаg9#T', '', 0, '?'),
 ('3Pni\nm*e+', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/fonts/yith-icon.svg', 0, '`[!}-', '`[!}-', ',NޠlȰhJx8{ppJT', '', 0, '?'),
 ('`Ŋ,\nΗ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/images/arrow_down.svg', 0, '3kLs', '3kLs', 'Ɣ-2n|Qm96&[ɼT6=h', '', 0, '?'),
 (';7+Qf|SPG', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/images/yith-icon.svg', 0, 'צ~<0', 'צ~<0', '-3LM\nrώ	l2}', '', 0, '?'),
 ('~\',r5', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/codemirror/codemirror.js', 0, 'Hg!0!8', 'Hg!0!8', 'dJ>Af}tj7+=lBhw', '', 0, '?'),
 ('6@Ae2qb>\'', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/codemirror/javascript.js', 0, '>J=)Z}', '>J=)Z}', 'mwJ܌Ab.FkN0L', '', 0, '?'),
 ('^R#T5', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/how-to.js', 0, '$şC6e1&b', '$şC6e1&b', 'Ȗp%A } \nA<N_٬', '', 0, '?'),
 ('լp;\ZD}7', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/how-to.min.js', 0, 'jRg0N7', 'jRg0N7', '}b]O+l(b.l-Bgt0', '', 0, '?'),
 ('L;gaD<', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/javascript-md5/md5.min.js', 0, 'H!Y3Pj`-', 'H!Y3Pj`-', ';͝t[/{&rCƷYF;ܭ7;', '', 0, '?'),
 ('!\ZRs34', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/jquery.colorbox.js', 0, '	j4DHj!Y', '	j4DHj!Y', '?r&s:0;W֏g\\VF#`1-', '', 0, '?'),
 ('h\'ݴ=4\n׮D+', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/jquery.colorbox.min.js', 0, '>W\'	vx', '>W\'	vx', 'O\0ħeβxPJw2NsT!', '', 0, '?'),
 ('-E0s]?^8', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/metabox.js', 0, '#wWzX i', '#wWzX i', '.g8M9f8[8vZ-a\\9', '', 0, '?'),
 ('3#&Uo4l', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/metabox.min.js', 0, 'y,:qbtsq\ZV', 'y,:qbtsq\ZV', 'nKOWhLsĥ]T)', '', 0, '?'),
 ('@K<6', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/multisite-updater.js', 0, 'K\ny	}\"LT', 'K\ny	}\"LT', 'Q,ˬ¨PƮ', '', 0, '?'),
 (']q΄,O_', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/multisite-updater.min.js', 0, ')uOmTfH', ')uOmTfH', 'ӆWc}vDgj4\"FAM', '', 0, '?'),
 ('  i]\"?', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/wp-pages.js', 0, '.-,0h\n', '.-,0h\n', 'bruKzpYը{̟+\"(tT+', '', 0, '?'),
 ('KO7ç7 MfK', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/wp-pages.min.js', 0, '7%V8', '7%V8', 't1F]U1\0PUB젰MGE^?o', '', 0, '?'),
 ('RzF-Q\"\0', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-cpt-unlimited.js', 0, '_%n*qa+\"', '_%n*qa+\"', 'AԌK.ԗ~\"zw>', '', 0, '?'),
 ('9^qzdd.`oJKS', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-cpt-unlimited.min.js', 0, 'R|22ûY', 'R|22ûY', '[P	)e]FQmuȮ-.', '', 0, '?'),
 (' ?òdP', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-plugin-panel.js', 0, '?%]IPwǿ', '?%]IPwǿ', ' |l(#\rQ OLZiD*D', '', 0, '?'),
 ('ZT+&ͯV', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-plugin-panel.min.js', 0, 'VƵp~NW', 'VƵp~NW', '8TF#LS>/AxX \'b·', '', 0, '?'),
 ('C9d S39c', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-wp-pointer.js', 0, '\r3b;GZ 	:', '\r3b;GZ 	:', '٥KuKG/ALvG ՁUe', '', 0, '?'),
 ('P&@', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-wp-pointer.min.js', 0, '#JY\\`˸4', '#JY\\`˸4', 'OguM і[0,.BʠX؎', '', 0, '?'),
 ('ս-k@*\\fY\".', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-colorpicker.min.js', 0, 'B=3O5rZw攡*', 'B=3O5rZw攡*', '`::CQ[\"SȚ%2?', '', 0, '?'),
 ('-l;2\nX~xZ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-dashboard.js', 0, 'Җ\0nWK~', 'Җ\0nWK~', '4=Ҭ\0doC!', '', 0, '?'),
 ('DKP䎡/}', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-dashboard.min.js', 0, 'f~1IO', 'f~1IO', 'K\r<=yY~t', '', 0, '?'),
 ('К%޶위y\r ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select-wc-2.6.js', 0, 't][9,8fQ', 't][9,8fQ', '^\'\r`M+Ѷ<\nߣÕd', '', 0, '?'),
 ('\\XڦꮡO', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select-wc-2.6.min.js', 0, 'RLyפyOU', 'RLyפyOU', '*+}4n9\"=Ahp', '', 0, '?'),
 ('C%Ӗ	`', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select.js', 0, 'Mrtغlř', 'Mrtغlř', 'l(9\Zڈ1ET{CLDCB', '', 0, '?'),
 ('(dv ̢?Y¢', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select.min.js', 0, 'S ,ȣe\r', 'S ,ȣe\r', 'ښ`Ryo쿸h%-]<nTA', '', 0, '?'),
 ('ygyX-', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-fields.js', 0, '6Apr8@Kx{', '6Apr8@Kx{', ' zn0$՞u,', '', 0, '?'),
 ('}.D4<u;\nKh', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-fields.min.js', 0, 'Aut\\I_:P', 'Aut\\I_:P', 'u)\n}?Ґ*z/egz_nM', '', 0, '?'),
 ('>qn=٣~7', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-gutenberg.js', 0, 'Ǭ(џ/', 'Ǭ(џ/', '$HFf!O\\i`ج', '', 0, '?'),
 ('sK5(\Zjf', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-gutenberg.min.js', 0, '(d&M\'U\\a', '(d&M\'U\\a', '2m.W\ZW9RuXr{jez?\n', '', 0, '?'),
 ('=\'^,!v', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-promo.js', 0, '3N3CIQw', '3N3CIQw', '	f6U*.R#\Z\Zn/', '', 0, '?'),
 ('k,&7OHsw_', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-promo.min.js', 0, '`Z\'mJ&h 5ɇ5', '`Z\'mJ&h 5ɇ5', '  \0e,UV-ls\ZB,)', '', 0, '?'),
 ('lt^', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-system-info.js', 0, 'Xm\\W\"k', 'Xm\\W\"k', 'О<!2]4nr9[-pR', '', 0, '?'),
 ('4jtTcW%K/', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-system-info.min.js', 0, 'Bb1eJoNs', 'Bb1eJoNs', '4tÇi|-tɭR R', '', 0, '?'),
 ('y8ROq%', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-update-plugins.js', 0, 'RWߗ!?', 'RWߗ!?', ' |1&\Z8ڽ;Md,ⰾ', '', 0, '?'),
 ('t`36>)S	t', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-update-plugins.min.js', 0, 'ic	Ss\0&Ă', 'ic	Ss\0&Ă', 'j.CWI]٘-s螸=CA$', '', 0, '?'),
 (']scV7mAb5NB>', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/init.php', 0, 'W1	G.B$', 'W1	G.B$', '2ҙSyǾ7.+BMfc	f', '', 0, '?'),
 ('칍˖zws', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/privacy/yit-privacy-plugin-abstract.php', 0, '/UuCa9', '/UuCa9', '=$\"9=	Rl4S8|UN:', '', 0, '?'),
 ('23=h1rӍ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/privacy/yit-privacy.php', 0, '.\'_E )-at', '.\'_E )-at', '6R,+P-)4\0	', '', 0, '?'),
 ('}E*M6\\m', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/promo/yith-promo.php', 0, '6!8L', '6!8L', 'D[X	jsƛ>$ݐ:Y3=`', '', 0, '?'),
 ('-å]EBm;\"s', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-ajax.php', 0, '3#\"Er', '3#\"Er', '\Zx+5\"!6]\":<7y', '', 0, '?'),
 ('v[P?iȄ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-assets.php', 0, '4ZV>u&&', '4ZV>u&&', 'NWJ-%)*w`Gx9', '', 0, '?'),
 ('գkVS(', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-cpt-unlimited.php', 0, 'Fa>ns2Z+&', 'Fa>ns2Z+&', '>6:\"Y\"tUT$ܾ+1=	F', '', 0, '?'),
 ('a%xqVjg', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-debug.php', 0, 'z<2m', 'z<2m', 'ˎ?\0>ormc\r\ZTXԦ', '', 0, '?'),
 ('*@#s37', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-icons.php', 0, 'r}(\Z[m', 'r}(\Z[m', '*RVõ@K\n\\5PN[g', '', 0, '?'),
 ('7x/GxH\"', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-metabox.php', 0, 'Atksza#z', 'Atksza#z', '&E\n\\O.mL>C', '', 0, '?'),
 ('#7$0q\'e', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-common.php', 0, '\Z{h*i#', '\Z{h*i#', 'KEGdO0R<oNVol', '', 0, '?'),
 ('Wi30N?Z', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-gradients.php', 0, '~-أ!', '~-أ!', 'h7Y\'=(;m9<.b7XdFUL`o', '', 0, '?'),
 ('gǌ-FK', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-licence.php', 0, '`9YA ^7u', '`9YA ^7u', '}X3^[*G9NҨf\'', '', 0, '?'),
 ('@\ZNಋ8O%', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-panel-wc.php', 0, 'ٷP&g!', 'ٷP&g!', 'HaЂYⷮg|?Is\ZB5', '', 0, '?'),
 ('/', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-panel.php', 0, 'gFCЫ}fG\'r^', 'gFCЫ}fG\'r^', 'ܚtf@bPB> /s/ݪ', '', 0, '?'),
 ('!!3o,.]', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-subpanel.php', 0, '%Uށ@\' ', '%Uށ@\' ', 'd#R#4n/h7kUd|', '', 0, '?'),
 ('\'LDAH', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-pointers.php', 0, '1n}r9*~dH晩', '1n}r9*~dH晩', '/݇BR^I@Tdc̓a-', '', 0, '?'),
 ('B8:wm', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-theme-licence.php', 0, '(4[oLYSp', '(4[oLYSp', 'je2^l7}}+{4\"F', '', 0, '?'),
 ('7?mq_Րݦ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-upgrade.php', 0, '~j[V6', '~j[V6', 'M&\nD:	\"ᖨ.21duW9', '', 0, '?'),
 ('-߆ZL~', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-video.php', 0, 'c4	', 'c4	', 'B_~we\\s\Zd:.GOF', '', 0, '?'),
 ('alIO~', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yith-dashboard.php', 0, 'S1>ΞS[&', 'S1>ΞS[&', '6-V~W%wdUyZ:1/G', '', 0, '?'),
 ('߸2j7ܑ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yith-gutenberg.php', 0, 'nuViᚫle', 'nuViᚫle', '=!y_^v.Phbҽ)ҝ', '', 0, '?'),
 ('D]фC,Id<', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yith-system-status.php', 0, 'm45(3&K3re8', 'm45(3&K3re8', 'E񇦛R\"Z@V\nwYG', '', 0, '?'),
 ('~x!N%/Z', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-customers.php', 0, '%]T?֢CS', '%]T?֢CS', '^ĺŖCf\nxZ\r57_Z&', '', 0, '?'),
 (']!W@T', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-posts.php', 0, 'dg)*K{\\', 'dg)*K{\\', '\\GaW͠~F2>y(@@', '', 0, '?'),
 ('\'!©ʊ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-products.php', 0, 'ǇQn4', 'ǇQn4', 'QޒT3@j\Z=q', '', 0, '?'),
 ('5KM5)K', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-terms.php', 0, 'sq\ZV}̉\"', 'sq\ZV}̉\"', '$i݆X{-XDR9U󟏉A', '', 0, '?'),
 ('oCC	dV#', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/buttons.php', 0, '6\r{ka\"E', '6\r{ka\"E', '`Ӥ\\O\"Aѝ>מݴ', '', 0, '?'),
 ('o%gzz-\\', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/checkbox-array.php', 0, '?|3=', '?|3=', 'vT6{uV,\0hcAN\nP\'', '', 0, '?'),
 ('(;b	Q', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/checkbox.php', 0, 'upXR7w', 'upXR7w', '[r铺^zOoeCz[=6+', '', 0, '?'),
 ('Ga28j', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/colorpicker.php', 0, '	]se`JH4T', '	]se`JH4T', 't6F~rͲZ+\0Ƽd\'015', '', 0, '?'),
 ('OwA5G\'x', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/country-select.php', 0, 'sܱbg', 'sܱbg', 'Zĳ]S\'!H(CˠEhHLnmoK', '', 0, '?'),
 ('nSwq#', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/custom.php', 0, 'bTNЬ~s~', 'bTNЬ~s~', '~I^4.ڤ\Zh~7R՟tZ', '', 0, '?'),
 ('159$V`˻&	V', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/customtabs.php', 0, 'W\0=DÝsv', 'W\0=DÝsv', '}J2&D!nwB', '', 0, '?'),
 ('\nq;S4O	', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/date-format.php', 0, '~5', '~5', '3@*G8j7ʏ	z]s', '', 0, '?'),
 ('5b_', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/datepicker.php', 0, '\'^J\"	QXP', '\'^J\"	QXP', 'c.6ՠwI<2#T\0\'G\\', '', 0, '?'),
 ('1U(\"SK', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/hidden.php', 0, '_)qqa#LG~', '_)qqa#LG~', 'NB1r%TIlkb', '', 0, '?'),
 ('p\'^IT<*', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/html.php', 0, 'o,ޘVi', 'o,ޘVi', '\"׋hz\nt|[', '', 0, '?'),
 ('zԉWkC)', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/icons.php', 0, 'nv8Hh܎_Nikφ8', 'nv8Hh܎_Nikφ8', 'B\rr\r7oe%j;`dPPL', '', 0, '?'),
 ('.@σzg̽#ж5', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/image-gallery.php', 0, 'd#R]5KE', 'd#R]5KE', 'fo@+>L<+{U.', '', 0, '?'),
 ('nzZ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/list-table.php', 0, '(XRmN', '(XRmN', '-z46_0\0<FU/+ꡑ5', '', 0, '?'),
 ('M>YJ`1i', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/multi-colorpicker.php', 0, '7bf3b\0!=eo5xr', '7bf3b\0!=eo5xr', 'dnQ1Ut[#x13/\r}@', '', 0, '?'),
 ('¨D$\'', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/multi-select.php', 0, 'cC\"A8qB', 'cC\"A8qB', '! N65}ح&d', '', 0, '?'),
 ('USR*5.n8}', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/number.php', 0, 'jB	Ga{ڎ	2', 'jB	Ga{ڎ	2', 'mu9N[=XOjo;Hך', '', 0, '?'),
 ('\';\n1v*k', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/onoff.php', 0, 'w[BJaQ!i', 'w[BJaQ!i', '9Du?JF{D$k', '', 0, '?'),
 ('*F6-}', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/password.php', 0, '9Lhvs.j', '9Lhvs.j', '*zi1%sajlth[ˤYyn', '', 0, '?'),
 ('Pg81ID', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/preview.php', 0, '~w$)\"-߭', '~w$)\"-߭', 'y>y\'(݁NZKi;', '', 0, '?'),
 ('/,Om1W@', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/radio.php', 0, 'VK\nzU@h4K', 'VK\nzU@h4K', 'nՊU!ck\ZHd*|d.', '', 0, '?'),
 ('*f.@6E[7L*', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/resources/select2-wc-2.6.php', 0, '|Ll3T.n', '|Ll3T.n', '2U>gmh;I)hcx$', '', 0, '?'),
 ('\"ￒOy?iA', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/resources/select2.php', 0, '!US', '!US', 'e(4f+\\Qu Q.', '', 0, '?'),
 ('S3=tnYD,d', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select-buttons.php', 0, '[[FVw.', '[[FVw.', 'VY4ҌQHX*^t{#H', '', 0, '?'),
 ('CǄ+', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select-images.php', 0, 'Dt0I$\'ș', 'Dt0I$\'ș', '~~ο97p1dԣ+T1', '', 0, '?'),
 (';Mї\0awV^hQ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select-mailchimp.php', 0, 'V[F뽉', 'V[F뽉', '\n=hܢWh\0ܾS$Ys[Ku', '', 0, '?'),
 ('7%$BΎ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select.php', 0, 'ZIzX8NdRk*', 'ZIzX8NdRk*', '(8;+jTmqSr*e~-x-', '', 0, '?'),
 ('	WnήԵm', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/sep.php', 0, '0ۯ0qy', '0ۯ0qy', 'YʁWXܪU\"JgC蒋	KY', '', 0, '?'),
 ('&fr=}\rp', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/sidebarlist.php', 0, 'NZln\\=Z;MP', 'NZln\\=Z;MP', '5T75cӮiU\ZY{zR', '', 0, '?'),
 ('kcPϴAN8o', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/sidebars.php', 0, 'c* VOW', 'c* VOW', '-[PeCPH5H9gM7qI	', '', 0, '?'),
 ('N	+MiS', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/simple-text.php', 0, 'T^,Ҽ{>d', 'T^,Ҽ{>d', 'ۗu`*?Ih>{B2ј\r]', '', 0, '?'),
 ('@le\0Kq:', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/slider.php', 0, '?0-aRt:p_', '?0-aRt:p_', '6!zv:7jEMN^cw\rf\0,', '', 0, '?'),
 ('/\rf\\7R֜W', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/text-array.php', 0, 'HeɾvdlP3', 'HeɾvdlP3', 'Z\Z{/A֌Il5u\\Ai', '', 0, '?'),
 ('$\0	]TVqB4', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/text-button.php', 0, 'rЫ', 'rЫ', 'oLϩ]E+I3sl', '', 0, '?'),
 ('O ok', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/text.php', 0, 'R1=%	L', 'R1=%	L', 'dsPlEXM_8', '', 0, '?'),
 ('?37j^Qrɼ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/textarea-codemirror.php', 0, '$~p*̞J', '$~p*̞J', 'iv-I\"&%9`7a?%', '', 0, '?'),
 ('~88ຽ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/textarea-editor.php', 0, '	k\rO2-+', '	k\rO2-+', 'P\nHVg~6;S#Nz ', '', 0, '?'),
 ('r;Wdb\nE', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/textarea.php', 0, 'Bǚt3`=a!ɕ', 'Bǚt3`=a!ɕ', ',\n[vY31d&|utwi\Z`c:', '', 0, '?'),
 ('Iv\Z^xj/6V', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/title.php', 0, 'շ`cp2<', 'շ`cp2<', '[p^Q*3H}W6[Jlh|f', '', 0, '?'),
 ('SYsyA', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/toggle-element-fixed.php', 0, '\rƄ#AV22', '\rƄ#AV22', 'O1mg`ZhmvS-,Oi', '', 0, '?'),
 ('g%X\\-', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/toggle-element.php', 0, '\0<4=', '\0<4=', '#ү:|n&}TnY\\\nʈ\'x', '', 0, '?'),
 ('G\nß$1-', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/upload.php', 0, '$Nn)H ', '$Nn)H ', '80%c3T1AH\rC', '', 0, '?'),
 ('k׻+Xo/E', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/metaboxes/field-row.php', 0, 'c38^V1', 'c38^V1', '!bB;v0TKYuC}<Q', '', 0, '?'),
 ('UIy,\"N', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/metaboxes/tab.php', 0, 'qM_rW\Z', 'qM_rW\Z', '\n4]X=A^d+;ڀ;P', '', 0, '?'),
 ('Y;%M޲', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/metaboxes/types/icon-list.php', 0, 'Qձpi2滖V4', 'Qձpi2滖V4', 's\"sП`3%ԐO(Zr', '', 0, '?'),
 ('ĞrXTÇ', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/infobox.php', 0, '~˽lw?', '~˽lw?', 'Ɵ#QsDDnG\rwv;)3!', '', 0, '?'),
 ('ބEsg', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/panel-field-container.php', 0, '#jhҩL', '#jhҩL', 'UPF+ߩas8Z?8i', '', 0, '?'),
 ('z@S:0uډ\Z`', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/sub-tabs-nav.php', 0, '<֔p(', '<֔p(', 'Dwa.録fH\Z3g3Ͳ', '', 0, '?'),
 ('fFC9z7<P', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-form.php', 0, '9<y\Zkc', '9<y\Zkc', 'l?\0*%*&=4\r!GSw', '', 0, '?'),
 ('07ʴ&+X', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-option-row.php', 0, '֪L$4', '֪L$4', 'h-tgL_t!}8S2;*%4F', '', 0, '?'),
 ('#U`{жxs', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-panel.php', 0, 'ې^Qy', 'ې^Qy', '?y~[\Z#0V-Jt\0/', '', 0, '?'),
 ('ͤD7brW;^', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-upload.php', 0, '\Z;gY`V', '\Z;gY`V', 'JKemȨh&ҫݍX;_lhA', '', 0, '?'),
 ('6*~| O', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/privacy/html-policy-content.php', 0, '4{Q8Bۇ', '4{Q8Bۇ', 'yT#Y?Dhf	[v18', '', 0, '?'),
 ('0cs\n[j', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/sysinfo/system-information-panel.php', 0, '\n`&mL8&h\\~<', '\n`&mL8&h\\~<', 'ez˅φ)Ϥ3Y*d:!E<', '', 0, '?'),
 ('wm\\TC}F(', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/upgrade/changelog.php', 0, 'RRD!;<*', 'RRD!;<*', '@xhO=]\'r)HI', '', 0, '?'),
 ('d', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/upgrade/error.php', 0, 'EP!⌑߻T', 'EP!⌑߻T', '.mN=PZ', '', 0, '?'),
 ('N^\r®]MQn', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-deactive-plugin.php', 0, 'Ed\r=Nٯa6!', 'Ed\r=Nٯa6!', '\nB0%(1uI[k[\r@', '', 0, '?'),
 ('t\nt;a.q_,9X', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-functions.php', 0, '/4ăIђl=', '/4ăIђl=', 'Y*΃۝=\\j\ZfG+];г *w', '', 0, '?'),
 ('\0ָ6_32+E', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-plugin-registration-hook.php', 0, '\Z9_=Vb', '\Z9_=Vb', '0\nӏa8Y:vS©XG5', '', 0, '?'),
 ('\'z$O', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-plugin.php', 0, '4En_^m\"k_', '4En_^m\"k_', '\"p*g\n+V\'3!', '', 0, '?'),
 ('3?;%MZ}!C', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-woocommerce-compatibility.php', 0, 'AHh\0ǫ', 'AHh\0ǫ', '䕬fK+HI.єH', '', 0, '?'),
 ('hjj)<z', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-options/general-options.php', 0, 'Q>jC(W>', 'Q>jC(W>', ',hV\r)#\0[M@4i>K', '', 0, '?'),
 ('/g-4O\"', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-options/premium-options.php', 0, 'Щ*ԙ_(CR', 'Щ*ԙ_(CR', 'q	n3\ZM2_J$2', '', 0, '?'),
 ('q\nj}~\0\0', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-options/video-box.php', 0, ':YBG|_;', ':YBG|_;', 'Xt40r$A1y02!]XP', '', 0, '?'),
 ('[QUOkFvu{U', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/templates/admin/premium.php', 0, 'lkقlͯƩ', 'lkقlͯƩ', 'ڛlbPNer-	[!_#}J', '', 0, '?'),
 ('\0+<>v$s', 'wp-content/updraft/plugins-old/yith-infinite-scrolling/uninstall.php', 0, 'YkIA`|', 'YkIA`|', '4Yz\0?ӡzsZ&&tK\ZC>Q9', '', 0, '?'),
 ('N.', 'wp-content/updraft/themes-old/index.php', 0, 'gD,V=\\bP', 'gD,V=\\bP', 'k~	UH\ZxPĀ<;X', '', 0, '?'),
 (',Dg]C', 'wp-content/updraft/themes-old/kallyas/404-smart-area.php', 0, ',\"ǊF1y+', ',\"ǊF1y+', 'ע&g}%LXo', '', 0, '?'),
 ('x鴧V2N', 'wp-content/updraft/themes-old/kallyas/404-standard.php', 0, 'z۞\ZlT\nb_uCQ', 'z۞\ZlT\nb_uCQ', '\r\0k:duX7Fh#!>', '', 0, '?'),
 ('\Z2#B', 'wp-content/updraft/themes-old/kallyas/404.php', 0, 'מNjs5\'', 'מNjs5\'', ';NUev(b[rʜ!JB', '', 0, '?'),
 ('4.Kx8^I\0', 'wp-content/updraft/themes-old/kallyas/addons/countdown/jquery.countdown.min.js', 0, 'y坣)SY', 'y坣)SY', 'Vg1KǏYۣ@l	3', '', 0, '?'),
 ('gT&Țav', 'wp-content/updraft/themes-old/kallyas/addons/flickrfeed/jquery.jflickrfeed.min.js', 0, '\n-yR', '\n-yR', 'ehk03&P\nn^͑8 &sr', '', 0, '?'),
 ('4cF\ni-7\Z', 'wp-content/updraft/themes-old/kallyas/addons/isotope-addons/packery-mode.pkgd.min.js', 0, '?,lSa', '?,lSa', 'o! in\"1!FD9\0ޮ', '', 0, '?'),
 ('6Wnڢ5s_h\0', 'wp-content/updraft/themes-old/kallyas/addons/jquery_loupe/jquery.loupe.js', 0, 'cV[%U|μ2', 'cV[%U|μ2', '^`A\'[Mׯ+7`+w\0\"gl<', '', 0, '?'),
 ('?zf}vd;Ӽ', 'wp-content/updraft/themes-old/kallyas/addons/kl_socialicons_font/kl-social-icons.svg', 0, 'M@/', 'M@/', 'iƒ0В,	OL`WR\ZV@', '', 0, '?'),
 ('VWg{S', 'wp-content/updraft/themes-old/kallyas/addons/raphael_diagram/init.js', 0, '[45×<k{2', '[45×<k{2', '8-9[OđDh]~\np<', '', 0, '?'),
 ('OO&ኁ+˕', 'wp-content/updraft/themes-old/kallyas/addons/raphael_diagram/raphael.js', 0, '=Pds^=.Kԃ', '=Pds^=.Kԃ', ';KI6geg!)|>Bi+', '', 0, '?'),
 ('oP£̉', 'wp-content/updraft/themes-old/kallyas/addons/sc_weather/fonts/icomoon.svg', 0, 'G^*', 'G^*', '224(JFrEs(ﾁx^', '', 0, '?'),
 ('ߍ/s:`9an', 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/debug.addIndicators.min.js', 0, 'd>R1[<', 'd>R1[<', 'wG>Gq0YQwD(}\0d(', '', 0, '?'),
 ('\riPU', 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/scrollMagic-fullPacked.js', 0, 't\\wR+ʦ', 't\\wR+ʦ', 'b,0u#c8ka2\'/e1aē,Yw', '', 0, '?'),
 ('TM\n҈\r\n', 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/scrollmagic-tweenlite.js', 0, 'Cx=ϘX-', 'Cx=ϘX-', '=Ic۸ndbLi\0n~Lu', '', 0, '?'),
 ('Vp:;)f|=', 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/scrollmagic.js', 0, 'h0b}', 'h0b}', 'G&:hM63\0ip l', '', 0, '?'),
 ('c0Bi8ݑ4', 'wp-content/updraft/themes-old/kallyas/addons/slick/slick.js', 0, 'wevBd', 'wevBd', 'ePt7\nGGC_`ʄs=ϾS Vu*3\Z', '', 0, '?'),
 ('NJQ\'+0$Q', 'wp-content/updraft/themes-old/kallyas/addons/slick/slick.min.js', 0, 'w}`cm', 'w}`cm', '#@ᣧ3VS,[vBԃƵ', '', 0, '?'),
 ('b<vؖ-I', 'wp-content/updraft/themes-old/kallyas/addons/smooth_scroll/SmoothScroll.js', 0, 'Q*nt\Zˏ', 'Q*nt\Zˏ', 'g$J%1IUƸeU', '', 0, '?'),
 ('$\nrv1՚0', 'wp-content/updraft/themes-old/kallyas/addons/smooth_scroll/SmoothScroll.min.js', 0, '{uUnx4|Ȣ', '{uUnx4|Ȣ', 'pwet9ŹYX#', '', 0, '?'),
 ('̡Sϻ\n', 'wp-content/updraft/themes-old/kallyas/addons/wowjs/wow.js', 0, 'U3S\\:?', 'U3S\\:?', 'Pl|X	oaI9(Ӣ4CI336B', '', 0, '?'),
 ('AXoFN#p', 'wp-content/updraft/themes-old/kallyas/archive-documentation.php', 0, '¾Tjq[', '¾Tjq[', 'y쟳	OđG1JBf48f\"q', '', 0, '?'),
 ('R\Z7MnRWV2', 'wp-content/updraft/themes-old/kallyas/archive-portfolio.php', 0, '5\nvJE`', '5\nvJE`', 'a5^HQ0B*rT/', '', 0, '?'),
 (':\"ƓPcro', 'wp-content/updraft/themes-old/kallyas/archive.php', 0, 'yk`ы0v?', 'yk`ы0v?', 'ͅCX}pN0bcD썅4nc', '', 0, '?'),
 ('6Q>oZݢ1Ԕ˜5', 'wp-content/updraft/themes-old/kallyas/blog-columns.php', 0, 'JqNrb]89', 'JqNrb]89', 'DQFF_K9j^\ZD', '', 0, '?'),
 (' -vg-*\n_4F', 'wp-content/updraft/themes-old/kallyas/blog-default.php', 0, 'O=\n8s@\'', 'O=\n8s@\'', '2jqIKt^EQ[Fsd', '', 0, '?'),
 ('x(s91R', 'wp-content/updraft/themes-old/kallyas/comments.php', 0, 'b(kn:8', 'b(kn:8', '7M @(g~Zv\\{*;=)', '', 0, '?'),
 ('[.0,:HvE', 'wp-content/updraft/themes-old/kallyas/components/blog/blog-default-def_classic.php', 0, 'E쨐#-f', 'E쨐#-f', 'xA=[hg{ud%d3[', '', 0, '?'),
 ('F(\"61FSݡ', 'wp-content/updraft/themes-old/kallyas/components/blog/blog-default-def_modern.php', 0, 'Fj:ܰiSnTjRs', 'Fj:ܰiSnTjRs', 'nâV>V,_;l j|	x^3;8׵^6', '', 0, '?'),
 ('J5\"wy8S&8q', 'wp-content/updraft/themes-old/kallyas/components/blog/blog-item-comments.php', 0, ']&\\ek栘', ']&\\ek栘', 'SmwC_M1c-nen;9V|^c=', '', 0, '?'),
 ('+S6ɼ7:s\Z', 'wp-content/updraft/themes-old/kallyas/components/blog/blog-links.php', 0, '۩>lkW3', '۩>lkW3', '	cgIZR.J]-(P.OU6T', '', 0, '?'),
 ('ݗٵ@y,Oh]', 'wp-content/updraft/themes-old/kallyas/components/blog/blog-meta.php', 0, 'b0Eo. 5', 'b0Eo. 5', 'Ƨ~4!AF/g l5', '', 0, '?'),
 ('gXb\nqte| t?', 'wp-content/updraft/themes-old/kallyas/components/blog/blog-noposts.php', 0, '+W}$XS', '+W}$XS', '&I8y3/MSzNB', '', 0, '?'),
 ('üa~zTS!', 'wp-content/updraft/themes-old/kallyas/components/blog/blog-pagination.php', 0, 'xneמ~', 'xneמ~', '@\r|jƆDtp2r@', '', 0, '?'),
 (' ͍AmiA', 'wp-content/updraft/themes-old/kallyas/components/blog/default-classic/blog-bottom.php', 0, '9	|	ެM', '9	|	ެM', 'ެ%T0m΃Q^TK&\Z', '', 0, '?'),
 ('CEDUe', 'wp-content/updraft/themes-old/kallyas/components/blog/default-classic/blog-content.php', 0, '\Z.=< ]/p', '\Z.=< ]/p', 'iL>\r#q摮O	^Y۠', '', 0, '?'),
 ('?S%*t\"n', 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-footer.php', 0, '%5Ej', '%5Ej', 'r\'Cڣ<Oa\n1HEf', '', 0, '?'),
 ('Їp%c4[*\ZC\\', 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-header.php', 0, 'IӦjY\n+dh!u', 'IӦjY\n+dh!u', ';>FޥCK$e=:4&w1', '', 0, '?'),
 ('ƨ^53y', 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-img.php', 0, '5!.~-', '5!.~-', '4[rޑ˿DZ	gRV', '', 0, '?'),
 ('(85#xɾ', 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-readmore.php', 0, '\0	\n͆([o', '\0	\n͆([o', 'rJȴD &~?]a=1!]rx>', '', 0, '?'),
 ('9x\"j=H`\Z', 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-title.php', 0, '5;V!WN@', '5;V!WN@', 'lӘmq\"J10(|\n=,', '', 0, '?'),
 ('7`È3', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-author.php', 0, '>hl', '>hl', 'xEQ1\"ZT{\r_FU/', '', 0, '?'),
 ('\'%B_/v{ybh', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-content.php', 0, ')nًp', ')nًp', 'h	Cc- 3uoٓFB ', '', 0, '?'),
 ('=(qZb&<', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details-author.php', 0, '9~IvU', '9~IvU', '~(vATkU˩#j^y\\ri', '', 0, '?'),
 ('.jzS0<\"', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details-category.php', 0, '-*z^N/G', '-*z^N/G', 'ED6T|p%2\Z`Ё_Hq}', '', 0, '?'),
 ('ΒK\\\\JIZ', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details-date.php', 0, '}Xd%65', '}Xd%65', '4#մ+>ͲJ4wo|Kxi%6$%', '', 0, '?'),
 ('CR|cJǥ\n', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details.php', 0, '4ڻ%Vg0', '4ڻ%Vg0', 'NoBJ>Ћ٤nsޱ', '', 0, '?'),
 ('K죤{=Rje', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-main.php', 0, 'J	|vPLx', 'J	|vPLx', 'K+CNߴv2ZK(', '', 0, '?'),
 ('~Cધ', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-pagelinks.php', 0, '+\nB9$n', '+\nB9$n', '4^adj7Dv#%݈j|-', '', 0, '?'),
 ('y\0g~hu', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-related-item.php', 0, '6kq', '6kq', 'Ǚ,&wPmK;&s/i]', '', 0, '?'),
 ('ܱٯE2И', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-related-title.php', 0, '\nLjBz ǓI', '\nLjBz ǓI', '`Eb%\\ҞSͳax?pKǄ*q%', '', 0, '?'),
 ('wє=jbI', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-related.php', 0, '(+@q/bn', '(+@q/bn', '[yit&_\0 !EQH1\Z', '', 0, '?'),
 ('`/NL#΀fU', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-social-custom.php', 0, 'rU7d퐱', 'rU7d퐱', '_IT\0F54Ia	x', '', 0, '?'),
 ('^$\nDU@܋/]', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-social-generic.php', 0, 'erRT,w', 'erRT,w', 'LaЂq\"*#-pR}=', '', 0, '?'),
 ('s1*7zP', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-social.php', 0, '1}1=0\rM', '1}1=0\rM', '<E\0pr/W[K;*ְ)۟_', '', 0, '?'),
 ('lt\"zRl', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-tags.php', 0, '2o|I(', '2o|I(', '6g	?jwd>Sr&Ҫbk΃S', '', 0, '?'),
 ('\nt]2', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-content.php', 0, ';{o@]', ';{o@]', '<eueI(21usu', '', 0, '?'),
 ('\\[Ba^cHI', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details-author.php', 0, 'YxmN\nJA', 'YxmN\nJA', ')ߍ	OEv-:ƤoW7ݥe', '', 0, '?'),
 ('@rlOŔ݆', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details-category.php', 0, '(]*A	$qZT', '(]*A	$qZT', '2;+K\0\n߅=q61e', '', 0, '?'),
 ('Pb\0-گZ', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details-date.php', 0, 'e<\'˨λ{[B', 'e<\'˨λ{[B', 'ME8>y\nu4`!', '', 0, '?'),
 ('}KI`_퐑i', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details.php', 0, 'G@{S', 'G@{S', 'hDL0S}tGK2W\0M@', '', 0, '?'),
 ('=~}p2(Pҝ\r\n', 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-main.php', 0, ' :fHmQ', ' :fHmQ', 'ƛ\\چugaG00b=Z\0ʻ', '', 0, '?'),
 ('n!ijh4wF', 'wp-content/updraft/themes-old/kallyas/components/blog/multicolumns/blog-content.php', 0, 'OR@sy(1', 'OR@sy(1', '_,S7%=N0αS?', '', 0, '?'),
 ('ga6]~e', 'wp-content/updraft/themes-old/kallyas/components/blog/multicolumns/blog-media.php', 0, 'Sd%c?ŁewR\Z', 'Sd%c?ŁewR\Z', '>CDC\'t%U\"ױ`Zy[_', '', 0, '?'),
 ('86٩YRD', 'wp-content/updraft/themes-old/kallyas/components/blog/multicolumns/blog-tags.php', 0, 'Au\ZA', 'Au\ZA', '2xgYD}dŕK{_\0ʔ', '', 0, '?'),
 ('3ج͹Q5', 'wp-content/updraft/themes-old/kallyas/components/masks/mask3.php', 0, 'iKgݔ`^|', 'iKgݔ`^|', '=I\r3w^=LT,1.r', '', 0, '?'),
 ('\'Oفr5)]', 'wp-content/updraft/themes-old/kallyas/components/masks/mask4.php', 0, 'Z0P', 'Z0P', '\rniQ*~ٶi', '', 0, '?'),
 ('2-A?&7Xw', 'wp-content/updraft/themes-old/kallyas/components/masks/mask5.php', 0, '(؍*X8', '(؍*X8', 'J*u_Z%s}Dt\"9', '', 0, '?'),
 ('%\n[\'=5P', 'wp-content/updraft/themes-old/kallyas/components/masks/mask6.php', 0, 'xflKDs', 'xflKDs', 't|):P0%Xty)J', '', 0, '?'),
 ('@߭[OMX*\n', 'wp-content/updraft/themes-old/kallyas/components/masks/mask7.php', 0, 'Ͻi', 'Ͻi', 'E U6~e!\Zטw\0bw', '', 0, '?'),
 ('.Ǜf#@7', 'wp-content/updraft/themes-old/kallyas/components/masks/mask8.php', 0, '&\ZË#', '&\ZË#', '\'\r\'Az]4\rt=)6-bN', '', 0, '?'),
 ('jRM#kH/', 'wp-content/updraft/themes-old/kallyas/components/masks/masks-functions.php', 0, '5<B', '5<B', '-rhdyS?:5*_ܔ', '', 0, '?'),
 ('⒘Orмwg', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-components.php', 0, 'zw7GL)y:', 'zw7GL)y:', 's<@5q\"4lXl', '', 0, '?'),
 ('VS.63\0i*:\"', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-main.php', 0, 'A[>=gm|\Z', 'A[>=gm|\Z', 'qK¯\r*IC问/jLZ', '', 0, '?'),
 ('T%3', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup-bottom.php', 0, 'YW9G ', 'YW9G ', '=\"\ZX*\n°_|o\0r^ ', '', 0, '?'),
 (';۶ƶ.c53P', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup-main.php', 0, 'ޮIeFjP!c6nf', 'ޮIeFjP!c6nf', '~rA54ek^lc7IsdH', '', 0, '?'),
 ('\'$@df|)ˡ6', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup-topbar.php', 0, '\"/\"d#O', '\"/\"d#O', 'nT~Yi&DL46+fc`Q', '', 0, '?'),
 ('߷xEb2Th', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup.php', 0, 'koC8xq>', 'koC8xq>', 'tQqL&hMMj<U', '', 0, '?'),
 ('?kjfN` ', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style-default.php', 0, 'ޕ&ŨAs`̎R', 'ޕ&ŨAs`̎R', 'PEF,O*>i8B%u5J^', '', 0, '?'),
 ('Lb6$LL', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style1.php', 0, ')5=QԸ', ')5=QԸ', ' 6lk9h\0O_)+d', '', 0, '?'),
 ('q<R0Y9ן', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style10.php', 0, 'T\r=|טxJ', 'T\r=|טxJ', '<~)\0*BHZO≮0', '', 0, '?'),
 ('յ[V5O}h.', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style11.php', 0, 'L\rػdnUiA', 'L\rػdnUiA', 'C	9&ж6ak_Pr˪R', '', 0, '?'),
 ('+-BNӛ/', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style12.php', 0, '~!Ƴ\'&yL', '~!Ƴ\'&yL', 'Tl](\"Vu6&%o:&VSr', '', 0, '?'),
 ('J&\Z2G', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style13.php', 0, '/.kO', '/.kO', 'jWjK{5Nzvƛs-', '', 0, '?'),
 ('2ew', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style14.php', 0, '{*A#', '{*A#', 'J(Mcِ_r-^', '', 0, '?'),
 ('KXzJ7', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style15.php', 0, 'y?g$ϜLsaD', 'y?g$ϜLsaD', 'Dwhs976FJrvFPwo8', '', 0, '?'),
 ('Gm8AG\\', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style16.php', 0, 'E-\r,C_~', 'E-\r,C_~', '$ңɩm}K>XE6>]!n', '', 0, '?'),
 ('b\rb]1*', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style17.php', 0, 's1ahmj', 's1ahmj', 'W=SW\"?\\֭ey/QcSg', '', 0, '?'),
 ('Ry-Df;3k>Hr', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style2.php', 0, '<Ν4q', '<Ν4q', 'GNǀ!1p\rd`Yy\'C8p', '', 0, '?'),
 ('-[Xm*Zz', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style3.php', 0, 'Dw/41V`0>', 'Dw/41V`0>', '%\"UѺBT9w5鬢,y)s', '', 0, '?'),
 ('WrBݐ|Qٗb', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style4.php', 0, '0Ig(\\vM', '0Ig(\\vM', '^LFX$6oW\Zyij ', '', 0, '?'),
 ('YFFkWWI)!}', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style5.php', 0, 'avIC', 'avIC', 'C#];.6	?qi eE>Y', '', 0, '?'),
 ('B6Ϭ!v', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style6.php', 0, '޿ytr7Y', '޿ytr7Y', '\ntip\r)jQYÕ01', '', 0, '?'),
 ('<\r\'#MJ£\Z', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style7.php', 0, '\'91sC赨Obr', '\'91sC赨Obr', 'n\r?GzΫqpOVNn.)\'V+', '', 0, '?'),
 ('D!}=Y', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style8.php', 0, 'ݖؕS', 'ݖؕS', '\rc&\\8뇓YJsu\n^,R{qX', '', 0, '?'),
 ('[jJ=87', 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style9.php', 0, '{-Bfa/', '{-Bfa/', ';]eM*Ν#Pd_XQTP', '', 0, '?'),
 ('0$#y47_A', 'wp-content/updraft/themes-old/kallyas/components/theme-subheader/subheader-default.php', 0, 'fM&Aҿ?', 'fM&Aҿ?', 'kϕfۣWv1~asP;A', '', 0, '?'),
 ('|a*\nP}', 'wp-content/updraft/themes-old/kallyas/components/theme-subheader/subheader-documentation.php', 0, '˓*Lh}i;', '˓*Lh}i;', '3*!3,GZ1\Z;0WRT', '', 0, '?'),
 ('K\"Ϫ\'S', 'wp-content/updraft/themes-old/kallyas/css/dynamic_css.php', 0, 'RAWBxT', 'RAWBxT', '^!V %Q*?;', '', 0, '?'),
 ('x@#ɕ>?A', 'wp-content/updraft/themes-old/kallyas/deprecated.php', 0, '-VӴe|Yu\\}P', '-VӴe|Yu\\}P', 'F˩W`KAx=oH>]', '', 0, '?'),
 ('5Se..U_n%', 'wp-content/updraft/themes-old/kallyas/fonts/glyphicons-halflings-regular.svg', 0, '!Fhey#-e[', '!Fhey#-e[', '$6`|y+^	8c%k', '', 0, '?'),
 ('_wvj.v', 'wp-content/updraft/themes-old/kallyas/footer.php', 0, '{A ƋW', '{A ƋW', 'ΐZ$a\0`sMh9\ZR7', '', 0, '?'),
 ('%p]8\\r', 'wp-content/updraft/themes-old/kallyas/framework/class-gdpr.php', 0, 'aI`=a:', 'aI`=a:', 'µ9}{ь!T<D=V8R 2', '', 0, '?'),
 (',wx2', 'wp-content/updraft/themes-old/kallyas/framework/compatibility/config.php', 0, 'e/B\Z ', 'e/B\Z ', 'o]@V\"ʊ^ۯL!gګv:', '', 0, '?'),
 ('~!25P*', 'wp-content/updraft/themes-old/kallyas/framework/compatibility/framework.php', 0, '\"fTe\\/kH\\', '\"fTe\\/kH\\', 'P\"9W:Ja(\Z^ڡ%Xsu', '', 0, '?'),
 ('fGlɨ', 'wp-content/updraft/themes-old/kallyas/framework/compatibility/metafields.php', 0, '}|ׁCi\\', '}|ׁCi\\', 'ZA\Zl\\E(M]vѼuVwfk', '', 0, '?'),
 ('f>b4ܔ', 'wp-content/updraft/themes-old/kallyas/framework/compatibility/shortcodes.php', 0, '=ۙ ǐmJq', '=ۙ ǐmJq', 's*WU\0.)izYx,', '', 0, '?'),
 ('1hQ8m׺', 'wp-content/updraft/themes-old/kallyas/framework/compatibility/termmeta.php', 0, 'a0E<0oVbFY', 'a0E<0oVbFY', 'YsjWɖ>\"wǫ*jP', '', 0, '?'),
 (']\"m6^YW', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/admin-mega-menu.js', 0, 'Pf^^k7΅3', 'Pf^^k7΅3', 'Ycx+TԞQ`4uZ	h06ME;sm', '', 0, '?'),
 ('+tQ$gWKVP', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/html.js', 0, ')\nE\rRߗ~', ')\nE\rRߗ~', 'ۊ\n4DSc6\"]9', '', 0, '?'),
 ('(_6:ܦ\'	(a', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/zn_modal.js', 0, '2B0eT;rO', '2B0eT;rO', 'Ҫ4f؞$Y#λJա+)', '', 0, '?'),
 ('$B~\nT#', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/zn_theme_ajax_callback.js', 0, 's3p\Zr!', 's3p\Zr!', 'f.?O\Z_{gR!b', '', 0, '?'),
 ('ki	HOJnp\rh', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/hg-theme-framework.php', 0, 'dpE', 'dpE', '3n!_wuHșYu4', '', 0, '?'),
 ('ajyr\0(', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/addons_manager/class-addons-manager.php', 0, '3g5iYyb', '3g5iYyb', ',d;jΆgɕ.LH', '', 0, '?'),
 ('\n(&:y', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/addons_manager/ui/tmpl-addons-list.php', 0, 'ΰtplY#;R/', 'ΰtplY#;R/', 'o#kL~Fo(zW\ZBE\"J', '', 0, '?'),
 ('n)q8Q4', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_about.js', 0, '4)/jACZE', '4)/jACZE', 'xǐ\'S5,f/ڨ9\ng{>N', '', 0, '?'),
 ('wK^a	', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_theme_check.js', 0, 'Tϵc+-~ʀ', 'Tϵc+-~ʀ', 'u~\Zn1cYg\'LړyJ(-', '', 0, '?'),
 ('?w_(9O1:', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/class-zn-admin.php', 0, 'A1HW', 'A1HW', '>CUhD;f4$3o?]u', '', 0, '?'),
 ('~D\\߆,z', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_DemoImportHelper.php', 0, '8G*mQ', '8G*mQ', '# )5(Fu/.55Hm%8', '', 0, '?'),
 ('퍘oC^\Z_\0', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_ThemeDemoImporter.php', 0, 'z}J~gTzSi=', 'z}J~gTzSi=', ':ge>`mͷ`J-iN9Y', '', 0, '?'),
 ('t\\%$N&', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-init.js', 0, 'ȉS>MKo%', 'ȉS>MKo%', 'Sob6gQAB%?,y/\nJ*he', '', 0, '?'),
 ('RQމd\Zne6', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-manager.js', 0, '[˙yB%8n', '[˙yB%8n', 'RW\"/\'FK\rR?!K`*uG', '', 0, '?'),
 ('?Ns !/Wz\rA', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/content-tmpl.php', 0, 'E6L', 'E6L', ' 0)Bűs94?>pC{', '', 0, '?'),
 ('\rKZr&S', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/dummy_data-tmpl.php', 0, 'T)㜊X%T', 'T)㜊X%T', 'afs͘,%;\"Lp0p>', '', 0, '?'),
 ('?t;*i ', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/footer-tmpl.php', 0, 'udcI2ӀP', 'udcI2ӀP', '&QV|FO%]ohY6٥\Z !#', '', 0, '?'),
 (':.y\nF8ek', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/form-register-theme-tmpl.php', 0, '41/I\'	G`', '41/I\'	G`', '0|@Od^.2ڄ2R̥r', '', 0, '?'),
 ('\"0', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/header-tmpl.php', 0, 'Pk͚&lx\"l', 'Pk͚&lx\"l', 'e̡VU;>0X1~(\n;n5Ax?', '', 0, '?'),
 ('[^kI<}R', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/register-tmpl.php', 0, '\Z4;OZ', '\Z4;OZ', '\n/wd0a~9{z:!LT3wnʥ', '', 0, '?'),
 ('\Z[p쒉ڟTO', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check-amazon.php', 0, '`$zn%)', '`$zn%)', '#E2*igd]V@rf@', '', 0, '?'),
 ('8\0gy\0!K?d', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check.php', 0, 'iFgDk', 'iFgDk', '\0j>\\\re8G*K	>6J', '', 0, '?'),
 ('Y2	HO-', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/api/ZN_HogashDashboard.php', 0, '6tԊ̈́-', '6tԊ̈́-', 'LhY֥;k)9:Yiq', '', 0, '?'),
 ('tK:?2+%KT', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/components/ajax-load-more.php', 0, 'xiE}bnxN 3', 'xiE}bnxN 3', 'jw?v4#	^3A>L:Ł?QT$', '', 0, '?'),
 ('e#^H:j', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/components/index.php', 0, '}{ݓQR$!Y', '}{ݓQR$!Y', '][GhÝB+6lpw', '', 0, '?'),
 ('.FiTrlH', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/dependency-management/class-dependency-management.php', 0, 'lӃ5|/B', 'lӃ5|/B', 'ijL\r9uv(t4n2+za-', '', 0, '?'),
 ('Ϊ9`lGE:+', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/dependency-management/ui/frontend-notice.php', 0, '7\'P2xMϒ', '7\'P2xMϒ', 'y/_jUGto1%F&r0 Z', '', 0, '?'),
 ('\0t-JT5', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-backend.php', 0, 'ZɃ΄', 'ZɃ΄', 'Ou!;.3zomxlb+>', '', 0, '?'),
 ('$NÜy=', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-frontend.php', 0, 'pt&؈p', 'pt&؈p', '1(nY2L?\Z|za=X', '', 0, '?'),
 ('(`t\'\r\rV', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-helper.php', 0, 'Ydlפv', 'Ydlפv', '@xqp#^O&a=G\\H$', '', 0, '?'),
 ('2Cie(1', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-image-helpers.php', 0, '=d%u;#', '=d%u;#', '6IK(f\ZNNsiDڬ\\%-T', '', 0, '?'),
 ('p{s\0', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/theme_ajax.php', 0, 'Aɰs.', 'Aɰs.', 'r~ċ{!QBigڨ\"y\nAM[a', '', 0, '?'),
 ('S,\0ƚ1', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/html/class-html-integration.php', 0, 'y?lm\\s#z', 'y?lm\\s#z', 'Z^u5Z];]|:d2iLLWBjM', '', 0, '?'),
 ('x^d(\\dU', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/html/fields/theme_import_export.php', 0, '@\\,\"tb', '@\\,\"tb', 'i1|*3T-w_لHcs', '', 0, '?'),
 ('r%[Ԅљ', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/installer/class-theme-install.php', 0, 'k!)W\n)|ĕ', 'k!)W\n)|ĕ', '~j<bFJNղӨv?Jn', '', 0, '?'),
 ('vԇ+%H2b̼#', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-about.php', 0, 'f@?', 'f@?', '~,CO=<wC\"Io', '', 0, '?'),
 ('I9\r\nϸ', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-update.php', 0, '.ǻ68g1A', '.ǻ68g1A', ']7R C_X\"Agw}', '', 0, '?'),
 ('׭}uV[1g%', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/integrations/admin-bar.php', 0, 'ywjQb', 'ywjQb', 'Q=fB:y?،p@', '', 0, '?'),
 ('\nAP?̤ق', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/integrations/rev-slider-integration.php', 0, '^!]-b', '^!]-b', 'Sp¯^vkv~=gw\nqj0+\ZG ', '', 0, '?'),
 (',$ücc9p', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/integrations/znhgfw_integration.php', 0, '~i:xmn', '~i:xmn', 'sх%;(&j+Jh9M+խd', '', 0, '?'),
 ('lvR}\0#f4e', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu-admin.php', 0, '$`', '$`', '9s6m45]`r5fj', '', 0, '?'),
 ('Bv`4m͏', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu.php', 0, '6x;G*jDË', '6x;G*jDË', 'u|( .ުLVeTîR	', '', 0, '?'),
 ('/	;T;JQyW', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/options-exporter/ZnThemeImportExport.php', 0, 'aֳBUnr', 'aֳBUnr', '9fLj71㚼|0usdk', '', 0, '?'),
 ('npw䫽zH', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/scripts-manager/class-scripts-manager.php', 0, 'y_mGv$d7', 'y_mGv$d7', 'ؖ߇s`Q%RU$z}=', '', 0, '?'),
 ('òMlejnub', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/updater/class-theme-updater.php', 0, '|QHnUa', '|QHnUa', '	9o7.Ih+e6Ͱ,ZԫчF', '', 0, '?'),
 ('L{$^>', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/updater/inc/options.php', 0, 'ZxĂwA&4', 'ZxĂwA&4', '|\\T@2zeW*Vj', '', 0, '?'),
 ('3<6įT?	', 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/utility/class-utility.php', 0, ';TjyB', ';TjyB', '#@>Ea7b\r-', '', 0, '?'),
 ('\08n^~', 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/assets/js/hg-mailchimp.js', 0, '0q0Bc', '0q0Bc', '\ng\r	D[d=:%F', '', 0, '?'),
 ('~Jc<)9', 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/hogash-mailchimp.php', 0, '%fc}SL!', '%fc}SL!', 'k(3}Ċѥ2ME/22', '', 0, '?'),
 ('_)W;ܙ@', 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/includes/options.php', 0, '>Q|}', '>Q|}', '&f)b`-z5Ʌڗ', '', 0, '?'),
 (';7\'Rg6', 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/lib/HG_MCAPI.php', 0, 'ܷ3ap@p\'G', 'ܷ3ap@p\'G', '5\'vվSkw', '', 0, '?'),
 ('bE?V\r', 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/lib/class_gdpr.php', 0, 'bXND꤅Pw7\r', 'bXND꤅Pw7\r', '5F	teRorEiWpˬo', '', 0, '?'),
 ('P@E', 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/pb_element/newsletter/newsletter.php', 0, ':mv', ':mv', '\'g	w/&yo\\&:MkB+?', '', 0, '?'),
 ('Wj1?Ү', 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/widget/widget-mailchimp.php', 0, '3\'S.', '3\'S.', 'OaC\0^V&򟱮\">:$', '', 0, '?'),
 ('x?CP)c', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/icons/zn-framework.svg', 0, 'y76=L**', 'y76=L**', 'wIK[RiRyTY_C]+;a\n', '', 0, '?'),
 (']̹ͅB)+', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/img/pb_col_plus_x.svg', 0, '!ܾ<H}a', '!ܾ<H}a', 'ɷeٵb:\'AjY', '', 0, '?'),
 ('6ov~@B=6', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/img/pb_col_plus_y.svg', 0, 'YǿO q;k/', 'YǿO q;k/', 'bOLf%W5t5Ñj', '', 0, '?'),
 ('E1\\ l?#~', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/img/svg-icons.svg', 0, 'f\ZʓF?SЪ', 'f\ZʓF?SЪ', 'f+_0Q1;3E KErfF%F', '', 0, '?'),
 (' YϬUգ9H', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/js/admin/edit-screen.js', 0, '[7b', '[7b', '#\\ڼ=TnU\0bQE߃7[', '', 0, '?'),
 ('ٖ,DNa', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/js/admin/yoast-integration.js', 0, 'Y\0>T@\rgO', 'Y\0>T@\rgO', 'őBg_jI5.I[kmӼIE', '', 0, '?'),
 ('29\Z ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/dist/gutenberg_integration.bundle.js', 0, 'Ժmi\"sҠ$', 'Ժmi\"sҠ$', '\07ڒJqSh$>oEo', '', 0, '?'),
 ('J|nZW,#[Y', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/dist/znpb_editor.bundle.js', 0, '!WO|hP', '!WO|hP', 'I.VM+Ƀ^TR}Q,A]NxڠW', '', 0, '?'),
 ('i@!\r[', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/dist/znpb_frontend.bundle.js', 0, 'G4PQw<31I', 'G4PQw<31I', 'R`w	 `W244\0PM&Ќl!]<(&', '', 0, '?'),
 ('uu3O\ZHXx', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/img/select-arrow.svg', 0, 'J[{y', 'J[{y', '9@gq{k5EL5~M', '', 0, '?'),
 ('N<[4:D@ɣ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.js', 0, 'ZX+ތAo', 'ZX+ތAo', 'a<4\0xc{M7\ZbN#', '', 0, '?'),
 ('foKΓU:', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.min.js', 0, '>ԲwCu @S', '>ԲwCu @S', 'ù*:$[Hw9S\Zh`m4\n', '', 0, '?'),
 ('쿓()رF', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.js', 0, ',0$', ',0$', 'Q\0704ro`GP	$/!', '', 0, '?'),
 ('m+\'-Vj', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.min.js', 0, '-PtT\0>ۏ', '-PtT\0>ۏ', 'B։i;O5uR#ɓ_wg%Z|', '', 0, '?'),
 ('!@h2n@a', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.isotope.min.js', 0, '\'u>^&/7JJx', '\'u>^&/7JJx', ':7@}W\\L\nAtSf	-L', '', 0, '?'),
 ('as&sk$', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.timepicker.min.js', 0, '<Mn>9}', '<Mn>9}', '2366qad_T	S0.n', '', 0, '?'),
 ('Gr1fz%Rn', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/ace.js', 0, '̝jޢ(', '̝jޢ(', 'u+$HfGǬPDxEyr)8\'', '', 0, '?'),
 ('^u7rrۭMגS', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-css.js', 0, 'ΪS@', 'ΪS@', '[h񞥿f`cY)\ntYMS', '', 0, '?'),
 ('O\n/8jH$i', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-html.js', 0, 'sXu)8p', 'sXu)8p', 'ْɂcs4\nDSuv(', '', 0, '?'),
 ('e9暫8:J?@', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-javascript.js', 0, 'jkmjb', 'jkmjb', 'BWפX(t{#H2FJq̥', '', 0, '?'),
 ('hTSKV	J', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/theme-chrome.js', 0, 'U \0g[㵍', 'U \0g[㵍', '>+_qk[eGg\\^5<Cr ', '', 0, '?'),
 ('<] \n@0d-', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-css.js', 0, ' e<aڠN', ' e<aڠN', '3TYs1uzz\'__|w$&Ҭs', '', 0, '?'),
 ('#Y+64j', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-html.js', 0, '^kQV+\0A1', '^kQV+\0A1', 'LoTo(|3O^za#', '', 0, '?'),
 ('	2$o', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-javascript.js', 0, '\0ʲ|)W', '\0ʲ|)W', '\rHH;蜰)}d.QrL', '', 0, '?'),
 (')y\Ze[', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/wp-color-picker-alpha.js', 0, 'F=+.Տ', 'F=+.Տ', 'TwdWP\0c٩+KkwOrߚi', '', 0, '?'),
 ('GNN_Ô@RiA', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_html_script.js', 0, 'n#?b`S`&U', 'n#?b`S`&U', 'ӵ3<>Ԍ56eͪ|H', '', 0, '?'),
 ('><Ip[\\\'S', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_media.js', 0, 'ك9I\"ֲ6ȩr3', 'ك9I\"ֲ6ȩr3', 'χ{]yk|Y`RWK>U', '', 0, '?'),
 ('sh¬уz', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_modal.js', 0, '\\2Ey/l', '\\2Ey/l', 'c/ #߿x4\\	^', '', 0, '?'),
 ('+N@,@', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/class-znhgfw.php', 0, 'woaf}_', 'woaf}_', '&37\Zul\nl$Hː	i<yh', '', 0, '?'),
 ('.2~\ns$<', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/hg-framework.php', 0, 'V+}]Ni', 'V+}]Ni', 'Yʬ37>]c^f	5', '', 0, '?'),
 ('Nd-K8\n', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/font-manager/ZnTypekitClient.php', 0, 'X\'\"j4`e\r|\0', 'X\'\"j4`e\r|\0', 'a/N4gH|l#=\'2b', '', 0, '?'),
 ('WM{b', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/font-manager/class-font-manager.php', 0, 'P-V8n8', 'P-V8n8', '51\'	Pc:\nMUenZX', '', 0, '?'),
 ('\0RvD~DR3\\', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/font-manager/google_fonts.php', 0, '(RGըu%W', '(RGըu%W', '(y/-YT$!\0NJ&,ik', '', 0, '?'),
 ('@<,\ZG;', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-color-helpers.php', 0, ',=1@VGN}', ',=1@VGN}', 'xh[qZ\Z;Wذn\'y', '', 0, '?'),
 ('SR} ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-helpers.php', 0, 'Z)1>g@', 'Z)1>g@', 'õvsKn\"z\\돞ƈy~{', '', 0, '?'),
 ('$ݛPڕK,y4<$', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/helpers/loader.php', 0, 'HtۺuuRB', 'HtۺuuRB', 'N:4*-\Za1Pm>i', '', 0, '?'),
 ('q>oέ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-data-source.php', 0, 'NkEn\n 8\"', 'NkEn\n 8\"', '|d#A{`${HWݔ]T', '', 0, '?'),
 (']H\nZ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-field.php', 0, '0eXUGbhS\'', '0eXUGbhS\'', 'ްh\0uw&4ϹV%,Y^]ypuHN', '', 0, '?'),
 ('}W=٢', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-form.php', 0, '50:˭O', '50:˭O', '{\Zm(R0ʜv9t\0b,&PN1', '', 0, '?'),
 ('/,Seu', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-html.php', 0, 'dB*&n5Ȑ', 'dB*&n5Ȑ', ']:\ZDlJS~[hVfɑ', '', 0, '?'),
 (',vTo0T5gh', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/data_source/class-pages-data-source.php', 0, 'gE(SNf', 'gE(SNf', '<K@~_@?`-	k#UmɕK', '', 0, '?'),
 ('Jqa9䁧SH', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/background.php', 0, 'Au1ؔ\\/uL`G', 'Au1ؔ\\/uL`G', '0LFpQ*tlOӇ?ay\r', '', 0, '?'),
 ('~*Ǖ?PZ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/boxmodel.php', 0, 'V2vRn#U5', 'V2vRn#U5', 'wϓ4޾wdHdme', '', 0, '?'),
 ('ÍvB#Cs', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/buttons.php', 0, '];|,˱f', '];|,˱f', 'a9T K>LD8;8Z\r', '', 0, '?'),
 ('viKR&$\n`\"', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/checkbox.php', 0, '+IШ/m~H7i2', '+IШ/m~H7i2', 'WrlvJ,F4i\Zu!Ks9', '', 0, '?'),
 ('n6\'Ib0e', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/colorpicker.php', 0, 'B\0IWw', 'B\0IWw', 'ͥltS]Kg6+ͨ&n', '', 0, '?'),
 ('?c#5\Z', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_format.php', 0, '0w6B!B\'z', '0w6B!B\'z', 'F֐D߻A_XԂuDTu', '', 0, '?'),
 ('{gS[⬘2b_', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_picker.php', 0, '[iM]', '[iM]', '~ͯe3#!Rn*8a	Z[_A\"', '', 0, '?'),
 ('aI\\R)KNw', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/day_picker.php', 0, 'sRI', 'sRI', 'N-W2/8	؃$%', '', 0, '?'),
 ('izk\Z\0W', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/font.php', 0, 'ZkT1', 'ZkT1', '=fyҍ%vP~F3Nz=ޠ5]k?', '', 0, '?'),
 ('&TǠR74', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/gallery.php', 0, 'z2/Pw*T', 'z2/Pw*T', '_b;3P\'hR&?-imh.0)s!', '', 0, '?'),
 ('+$C75z|}L', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group.php', 0, 'ɟrF$+', 'ɟrF$+', '1\r\n{Y/FFMB.EiJ\r`U!9/', '', 0, '?'),
 ('p|7	M	', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_select.php', 0, '$\"i	hVg^i', '$\"i	hVg^i', '{\ZTTYMjZjʜ|f٬zM', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('ڜM\"y-Kr^', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_text.php', 0, 'gE<̌eA*', 'gE<̌eA*', '8a$&|u\n{ۡm`{\r*=', '', 0, '?'),
 ('?A@<', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/hidden.php', 0, ')gLЪ$䓝', ')gLЪ$䓝', 'IR6X$D/)ZlKeO', '', 0, '?'),
 ('L*WlTBsl', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/icon_list.php', 0, 'b&ES\0NH', 'b&ES\0NH', 'eʒMW$sb>[c;1vaF', '', 0, '?'),
 ('?G1TF*9', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/image_size.php', 0, 'yWY@', 'yWY@', '5!eB^fO֑&[ivj{', '', 0, '?'),
 ('\"RrwI', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/link.php', 0, '\ZRnΪ=Nқ', '\ZRnΪ=Nқ', 's$v\rfzs!FƋ)', '', 0, '?'),
 ('hkY![V(+LH', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/media.php', 0, '\n60c\\C', '\n60c\\C', 'ljt11%9:.$66~6', '', 0, '?'),
 ('/:@%XT', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/options_wrapper.php', 0, 'Ĕ_j\\\rz', 'Ĕ_j\\\rz', '>Aujt~r02?-Wq}^C5P򵆩', '', 0, '?'),
 ('%[p:(@^', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/radio_image.php', 0, 'W1BZZHH', 'W1BZZHH', '3sjH#|xJ!', '', 0, '?'),
 ('?_3Uh', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/select.php', 0, 'c(cߨ04D', 'c(cߨ04D', '^StUEP{qNtikQ2', '', 0, '?'),
 ('R<c١YB', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/sidebar.php', 0, 'ۊTȢUJ_', 'ۊTȢUJ_', '9\Z9g[D\ZW@F$cdy3', '', 0, '?'),
 ('L)Xp۫u%', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/slider.php', 0, '\'{sčÄc', '\'{sčÄc', '=Pzs7O=U7K?l2', '', 0, '?'),
 ('oZQb)Jl%]', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_select.php', 0, 'ײ#/y	G\0', 'ײ#/y	G\0', 'J\"F\'*/qvT\nիG', '', 0, '?'),
 (']Sn\n{7uu', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_slider.php', 0, 'yd\\~oW\'d', 'yd\\~oW\'d', '{QVM5(C;/cT8OB', '', 0, '?'),
 ('%ou)YÙ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/tabbed_form.php', 0, '+\nRWq7', '+\nRWq7', 'q_C%kS	]}:*gr`h', '', 0, '?'),
 ('nl^ڗ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/text.php', 0, 'EgI\\A;$', 'EgI\\A;$', '\0l_ؙI0:\"Pxgq\".K', '', 0, '?'),
 ('䔸n%H	ܠ:F', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/textarea.php', 0, 'п$␡-G', 'п$␡-G', 'Q55і.pkV4/R\'O', '', 0, '?'),
 ('%aAv4SB', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle.php', 0, ')m˻xr͏>', ')m˻xr͏>', 'xr֪C/6jJ\\s\"R,Tr_', '', 0, '?'),
 ('t,H,3Z}b', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle2.php', 0, 'Q5^\ZOI}q ', 'Q5^\ZOI}q ', 'HaKFj\nab+ ]ޓ\"', '', 0, '?'),
 ('3,K{{sV3', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/upload.php', 0, '̕a\rj', '̕a\rj', '.=iwQhps񨃬+=1e/k+Z', '', 0, '?'),
 ('	.P;.', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/visual_editor.php', 0, 'S6Ŗ4.tyaə^', 'S6Ŗ4.tyaə^', 'kgYGC@m`ZnhD', '', 0, '?'),
 ('shvl(qE+', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/widget_positions.php', 0, 'rI8sY\Z~.', 'rI8sY\Z~.', '0XFͯ+\Z3=iܒwPX[', '', 0, '?'),
 ('\n\n3', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_ajax_call.php', 0, '\Z2D|?', '\Z2D|?', '^r8OGHQ^Z9#\\[p~\n', '', 0, '?'),
 ('=6; އ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_google_fonts_setup.php', 0, 'Il8#15nۚx', 'Il8#15nۚx', 'YFkK~mQB4%ѺltxF', '', 0, '?'),
 ('10S\nNQ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_message.php', 0, '6Q5}BZe>\0X', '6Q5}BZe>\0X', 'jw4}6K5oy!g', '', 0, '?'),
 ('&~~64⮬J', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_radio.php', 0, 'Mju\r8KZ$F', 'Mju\r8KZ$F', '@_7$CN-7)G~FNZYɑ', '', 0, '?'),
 ('l(/_$!@O\n', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_title.php', 0, 'VyM.庻1LwX', 'VyM.庻1LwX', '\Z_b婏/A2|x7', '', 0, '?'),
 ('r>nbIx^u', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/forms/theme_form.php', 0, ']|}~=?|vߏ', ']|}~=?|vߏ', '\\)ɢ0F2eӂ1I&䧿Vϫ', '', 0, '?'),
 ('Ů$[v]qrz#', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/icon-manager/class-icon-manager.php', 0, '\nvȻM5', '\nvȻM5', '󸸤y,.νΗdڸ^Ar', '', 0, '?'),
 ('R8Fyݕ\'%', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/image-resizer/class-image-resize.php', 0, '&?Ry;', '&?Ry;', 'tyzZ@]y)ܷҭV1', '', 0, '?'),
 ('6\r;wyʬi', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/metaboxes/class-metabox.php', 0, 'LݺEAl%', 'LݺEAl%', 'at9=hp1Y@[G', '', 0, '?'),
 ('s0b\0V*h_9O', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/permalinks/class-permalinks.php', 0, '<Ç\r<Ip', '<Ç\r<Ip', 'yf\'3:(F4Y=\\Inc ', '', 0, '?'),
 ('ڴ)9;;v', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/scripts-manager/class-scripts-manager.php', 0, '~@|', '~@|', 'TiO\'ѾM6Mg\"6y)H+	r', '', 0, '?'),
 ('z06s#', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/HG_Shortcode.php', 0, '雄l]Y3_', '雄l]Y3_', 'o1%$\nLZ3ʪ]u>d', '', 0, '?'),
 ('IA]\Zc\Z', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/class-shortcodes-manager.php', 0, '	2on0', '	2on0', '[<\n\"AhI(Ti3', '', 0, '?'),
 ('FLpb/', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/taxonomies/class-termmeta.php', 0, '&sOK{:4VS', '&sOK{:4VS', '/&\\<WgVFOfw~', '', 0, '?'),
 ('ĕ}*', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/utility/class-utility.php', 0, 'nc@jU\\z;oQ', 'nc@jU\\z;oQ', '\0\0ܑV])ow=\0\'/=ai', '', 0, '?'),
 ('+Dr6AV !KS', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionElement.php', 0, 'fafp=fN=', 'fafp=fN=', '`Ц{jxtvnV3!pd!', '', 0, '?'),
 ('ׅq;d]N', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionElementsManager.php', 0, 'ٙ$)H+	Jm', 'ٙ$)H+	Jm', ' En\0?I#L6{yuՈ', '', 0, '?'),
 ('0,3 d(3_', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionPageBuilderCustomCode.php', 0, '䦠?5>$T', '䦠?5>$T', 'fl+=o-#һsgy4ςz', '', 0, '?'),
 ('kf?b', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionPageBuilderFrontend.php', 0, 'Дaʟ', 'Дaʟ', 'v.kd<vo\nPAWGޮ\\', '', 0, '?'),
 ('I?%V5\0m', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionScriptsManager.php', 0, 'ݗIgɢ#%Iu', 'ݗIgɢ#%Iu', 'eK,[4H[-!\\DAh_U<&', '', 0, '?'),
 (';#p.\"-z,', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionWordPressSearch.php', 0, '٘pUWD', '٘pUWD', '(~3_oˮF=%B*y ', '', 0, '?'),
 ('oQ\"6g', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/admin/ZionPageBuilderAdmin.php', 0, 'HH;oIxS', 'HH;oIxS', '.{YQ1)5\\p\\[`cb&]', '', 0, '?'),
 ('gU!Y+', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/ZionEditor.php', 0, '{-pSսCS', '{-pSսCS', 'ӬKh$]Bx56Ҙ', '', 0, '?'),
 ('`q', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/ZionPageBuilderExportHelper.php', 0, 'MoDB\rؔ<8', 'MoDB\rؔ<8', '4W\0b:iYY)_D0 [\"', '', 0, '?'),
 ('ƥgP\0EE\r=nWF', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/ZionTemplateSystem.php', 0, '03)GhJ', '03)GhJ', 'O\0qM@wxc', '', 0, '?'),
 ('<Mi	', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/class-page-builder-ajax.php', 0, '5v١5rr/nv', '5v١5rr/nv', '1L66Qvv{H״5&x\\(e', '', 0, '?'),
 ('~ﰼ溄j', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/helpers/helpers-frontend.php', 0, ']kQ*sJ@', ']kQ*sJ@', 'aY印=^toꪁbb#', '', 0, '?'),
 ('\ri0WVε@', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/helpers/helpers-help.php', 0, 'f4ޖґCq', 'f4ޖґCq', '\0G>*giPh!>\'ʠdS\rB', '', 0, '?'),
 ('S}	4@lo', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/index-page-builder.php', 0, '!$<xn>', '!$<xn>', '[8\ntxކ\na\\-]', '', 0, '?'),
 ('5\"G', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/class-base-integration.php', 0, '=MYV4J', '=MYV4J', ')1\"bLG@\Zos 3kN0', '', 0, '?'),
 ('gHwEŐ7', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/class-integration-manager.php', 0, 'XL$ZE+-', 'XL$ZE+-', '\Z/Hu.TD\r&@ct+-', '', 0, '?'),
 ('9Xy|\n%aybW', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg.php', 0, 'iV/ӽ', 'iV/ӽ', 'EF.O9a+2B;MYohQ8', '', 0, '?'),
 ('j`|9=T', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg_integration.php', 0, '2·	', '2·	', '_x@\no	6&{߹tl', '', 0, '?'),
 ('ai<J\"ru3i', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_nextgengallery_integration.php', 0, '@SwK{\\ߜ', '@SwK{\\ߜ', ';\rrR1ZT]YM2Je|/1', '', 0, '?'),
 ('4`K\"_AvG', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_paid_membership_integration.php', 0, 'IHZ\'j', 'IHZ\'j', 'mdY\ZFɻIqJf):r(-b', '', 0, '?'),
 ('ϘYȋ7v|', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_polylang_integration.php', 0, '%[.2M.V51', '%[.2M.V51', 'E W{wſBj؉ A', '', 0, '?'),
 ('\\y2W$bX	', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_woocommerce_integration.php', 0, 'b\n>o7?ّ3', 'b\n>o7?ّ3', 'W-0hI%4{-d$\rA	', '', 0, '?'),
 ('Ƣi6SvQ5}r', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_revisions.php', 0, '`=4Օe', '`=4Օe', 'NNa|KqOMrmȩE\"H/p\0<ߙnk', '', 0, '?'),
 ('ߑpt.', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_widgets.php', 0, '|I\\Ry\'', '|I\\Ry\'', 'pA.6-I>\\ewWf:', '', 0, '?'),
 ('7\"Wvu{Sd(`:', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_yoast_integration.php', 0, ']87EdM', ']87EdM', '8k\Zd>dc{s&_~', '', 0, '?'),
 ('%\n:O}1', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/accordion/accordion.php', 0, '%)lbL@j', '%)lbL@j', 'e/R۵aח|{↿k5V;', '', 0, '?'),
 ('k:6*F0\'7u_\"r', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/anchor_point/anchor_point.php', 0, '{؄ʢZlm', '{؄ʢZlm', '4\0ي[MZ\ngY0gFx', '', 0, '?'),
 ('pd3d|X<|\"', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/button/button.php', 0, 'xөF䒛qd', 'xөF䒛qd', '!IPݻ?3\nS\0Ml	: ', '', 0, '?'),
 ('mi쎺o|*', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/column/column.php', 0, '\'Éa6oE#', '\'Éa6oE#', ' K8eK]$oc`?sQ;+|*', '', 0, '?'),
 ('B(tLGz|D', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/contact_form/cf-template.php', 0, '>{}2NŠEZ}x', '>{}2NŠEZ}x', '*?tIB+gЀ/`br=!', '', 0, '?'),
 ('SLV\rfP', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/contact_form/contact_form.php', 0, 'aU&H~~', 'aU&H~~', 'Ƈ&>)}mWxU==a', '', 0, '?'),
 ('Hk|j0b', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/custom_html/custom_html.php', 0, '<*;F۽qX@', '<*;F۽qX@', 'G^Ab7eƇ1;+%\0\0', '', 0, '?'),
 ('L׈tDkO', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/google_map/assets/gmaps.js', 0, 'IY', 'IY', 'nޛ!8bqyPbrȀ9N', '', 0, '?'),
 ('Ks', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/google_map/google_map.php', 0, '8(:w%', '8(:w%', 'aLQA\n\\Jn KCbXU<u', '', 0, '?'),
 ('CJ֫d;Ud', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/heading/heading.php', 0, '6hhƁ', '6hhƁ', '1\'7d@p:u:dx6FVT', '', 0, '?'),
 ('FU) ]+W', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/icon/icon.php', 0, 'E::<A\ZQ', 'E::<A\ZQ', '#OԁNs?Ffʞ6Ei4\r', '', 0, '?'),
 ('!vwR\"FWJ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/icon_list/icon_list.php', 0, 'z$MQT*', 'z$MQT*', 'E\"ɁyApZ8Tysq$Q1j', '', 0, '?'),
 ('(z;,ɘНG', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/image/image.php', 0, 'Ċ\rZ7kU', 'Ċ\rZ7kU', 'm\'JS,*ś#f*7a+S', '', 0, '?'),
 ('9KV&-+', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/revolution_slider/revolution_slider.php', 0, 'VV\Z͝8n\0qX', 'VV\Z͝8n\0qX', '½j`&B\0W+1Ib', '', 0, '?'),
 ('D:ۦImrاw', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/section/section.php', 0, 'dW@ѤO', 'dW@ѤO', 'SoK\ng`(ZEIlQN,>`', '', 0, '?'),
 ('Xnt*``<A', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/separator/separator.php', 0, '~|Rgbye7&ڱ', '~|Rgbye7&ڱ', '5U(q\nd%@phb', '', 0, '?'),
 ('|@4\0Q9RH', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/sidebar/sidebar.php', 0, '\0y0(E:1o', '\0y0(E:1o', '#~Tں.5 ]Y\n3,.*+a*of', '', 0, '?'),
 ('1IM', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/smart_area/smart_area.php', 0, '|*WAp\\', '|*WAp\\', 'LͨrzS竟u1>rwPt', '', 0, '?'),
 ('dn+[', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/smart_container/smart_container.php', 0, 'L㩘П5', 'L㩘П5', '%(IZ7h34kAkL[T3okko&؆Ee', '', 0, '?'),
 ('m,ixV', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/spacer/spacer.php', 0, '<9QF1u<*>NO', '<9QF1u<*>NO', 'x&~VV͌_p&', '', 0, '?'),
 ('φX\'9lf', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/tabs/tabs.php', 0, '(H!Ť\0', '(H!Ť\0', '8?۲͗j.Yn$-!', '', 0, '?'),
 ('CP~10b>', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/text_box/text_box.php', 0, 'mhP|', 'mhP|', '_k%D\0a{}!̇W#7<%Pj', '', 0, '?'),
 ('t7K={', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/video/video.php', 0, '|}6G;E', '|}6G;E', '`=3nngQOdňdL*S+p', '', 0, '?'),
 ('_x~', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/widget/options.php', 0, 'yjƑFw', 'yjƑFw', 'jĖq{RjDhYK8>YgӋ1y', '', 0, '?'),
 ('j@`v\\cv\ZU', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/widget/widget.php', 0, 'J٧\r-f', 'J٧\r-f', 'Ӊ_1c\nB/GHH', '', 0, '?'),
 ('B!j\rldJ', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/smart_areas/ZionSmartArea.php', 0, 'dy#ܠR=', 'dy#ܠR=', 'Q\\\0AMttA(	', '', 0, '?'),
 ('$P\\3:$nmG', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/utility/ZionUtility.php', 0, '\ZH-䎅&\'jbz', '\ZH-䎅&\'jbz', 'p,sst\n\'u6M;A!HJ.x\0', '', 0, '?'),
 ('{î ++', 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/zion-builder.php', 0, 'sCCQN', 'sCCQN', '@\\?wܰmFp@- ', '', 0, '?'),
 ('	z\'9-u', 'wp-content/updraft/themes-old/kallyas/framework/zn-framework.php', 0, 'F2nߒSyM,T\nt', 'F2nߒSyM,T\nt', '#2صaǾt$Tz\'', '', 0, '?'),
 ('{Qqj(P\\ˋ΍', 'wp-content/updraft/themes-old/kallyas/functions.php', 0, '`u\ZimzE', '`u\ZimzE', '\"(CcSV7i +iqL', '', 0, '?'),
 ('*9-I', 'wp-content/updraft/themes-old/kallyas/header.php', 0, 'Fڋ\\Q-5', 'Fڋ\\Q-5', 'rw2N^AѢEj8{.\\Z+', '', 0, '?'),
 ('f.|d', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style1.svg', 0, 'rD-V=|xA', 'rD-V=|xA', 'dFH5kۅ*G\0V<d[eX<SN`ʘ', '', 0, '?'),
 ('q~R=3w', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style10.svg', 0, 'qC}1p', 'qC}1p', '/\\{-U|#/Hē!kHR*', '', 0, '?'),
 ('jvy\ZXH', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style2.svg', 0, '}]/и/f', '}]/и/f', 'K/%\nkʭ\ZGL(CmLq5', '', 0, '?'),
 ('Cms0u\r^\'', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style3.svg', 0, 'OJ#?+f', 'OJ#?+f', '\"OFfM1\n5I;+W', '', 0, '?'),
 ('|xR%ɟ', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style4.svg', 0, '56M14ߩYܷ1', '56M14ߩYܷ1', 'WE^e:w%,BDe', '', 0, '?'),
 ('wN˼\Z>7X', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style5.svg', 0, '_@~F3N', '_@~F3N', 'bc\Z~\rϕrG< yYr', '', 0, '?'),
 ('4o}0b$t,;', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style6.svg', 0, 'ɹlUkWEh', 'ɹlUkWEh', '6fa+Y\\!1^Ţ\'<z', '', 0, '?'),
 ('tvXNpU ', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style7.svg', 0, 'z7LKZ;<', 'z7LKZ;<', 'YuHbyO{*m', '', 0, '?'),
 ('\nL)V ', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style8.svg', 0, 'Rv`-', 'Rv`-', 'L+|2t_e}*^', '', 0, '?'),
 ('t\0lD', 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style9.svg', 0, 'G;-e\\	$Tю', 'G;-e\\	$Tю', 'QewkD++?LI׍', '', 0, '?'),
 ('PO(j7T،b', 'wp-content/updraft/themes-old/kallyas/images/admin/product-styles/product-style-01.svg', 0, 'c|ѳ', 'c|ѳ', 'a*_ODSāb6k\"׬{', '', 0, '?'),
 ('sy!bȲC蘬e', 'wp-content/updraft/themes-old/kallyas/images/admin/product-styles/product-style-02.svg', 0, 'ρSh', 'ρSh', '˘4`H1K*azl-j', '', 0, '?'),
 ('ı3\nYRk$', 'wp-content/updraft/themes-old/kallyas/images/admin/product-styles/product-style-more.svg', 0, 'q=3Ɣ', 'q=3Ɣ', '@!(PIEJCzD|Wop', '', 0, '?'),
 ('s*pE8+˔&', 'wp-content/updraft/themes-old/kallyas/images/admin/site-layout/boxed.svg', 0, 'C(A1YzS?', 'C(A1YzS?', '.W\0]?f_GBw', '', 0, '?'),
 ('`L\'LAޜH', 'wp-content/updraft/themes-old/kallyas/images/admin/site-layout/fullwidth.svg', 0, '\ZèB܈g', '\ZèB܈g', '^r_/bQA>:sj0NélJ', '', 0, '?'),
 ('-&!h', 'wp-content/updraft/themes-old/kallyas/images/circle-arr-hover.svg', 0, 'jf+2,YMc', 'jf+2,YMc', 'VL\0[	eK۵6', '', 0, '?'),
 ('?A頯%-', 'wp-content/updraft/themes-old/kallyas/images/devices/iphone6.svg', 0, '>ù}ޮ*,y', '>ù}ޮ*,y', '5nà]*ϝ\'DխܮVO+(9', '', 0, '?'),
 ('zDOJصa9\r?', 'wp-content/updraft/themes-old/kallyas/images/devices/macbook-air.svg', 0, 'hR2RZsL', 'hR2RZsL', 'xe6!rc}!kOʦc)-g', '', 0, '?'),
 ('F6=A-', 'wp-content/updraft/themes-old/kallyas/images/devices/macbook.svg', 0, 'Cmcl0rY', 'Cmcl0rY', 'Z?_T4bEcN\\M!N6', '', 0, '?'),
 ('B1&#rLgn', 'wp-content/updraft/themes-old/kallyas/images/index.html', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('i]4NFedW', 'wp-content/updraft/themes-old/kallyas/images/kallyas-logo-dark.svg', 0, 'FbZK\\Z&', 'FbZK\\Z&', '8<`B$&/&V\n7\ng', '', 0, '?'),
 ('JBFdRWAD', 'wp-content/updraft/themes-old/kallyas/images/kallyas-logo-sticky.svg', 0, '\rV8,4nO}NgM', '\rV8,4nO}NgM', '\"	v5LCqWs	pt2[7΁Y', '', 0, '?'),
 (' zP12', 'wp-content/updraft/themes-old/kallyas/images/kallyas-logo.svg', 0, '>Z`ǮL\Z\"gz', '>Z`ǮL\Z\"gz', 'Ǒ99[;U!/-I#Fr9z6\r3', '', 0, '?'),
 ('rǰ[~i6\Z', 'wp-content/updraft/themes-old/kallyas/images/macbook-air.svg', 0, 'hR2RZsL', 'hR2RZsL', 'xe6!rc}!kOʦc)-g', '', 0, '?'),
 ('̇$OM#{p', 'wp-content/updraft/themes-old/kallyas/images/macbook.svg', 0, 'Cmcl0rY', 'Cmcl0rY', 'Z?_T4bEcN\\M!N6', '', 0, '?'),
 ('K?\ny;r\n;WY%1', 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-added-listing-dark.svg', 0, 'R~%&V\r\ZLc', 'R~%&V\r\ZLc', 'X\"dAL!fH9O?լ', '', 0, '?'),
 ('}\05;!', 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-added-listing-light.svg', 0, ';eAr?Bo', ';eAr?Bo', 'sF8mK=NjbAB', '', 0, '?'),
 ('5uPQnؐb*z', 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-listing-dark.svg', 0, '16&ǲxoZ1d', '16&ǲxoZ1d', 'PF4k;MB^c)\"a[ ', '', 0, '?'),
 ('MǤnJm5R', 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-listing-light.svg', 0, 'I2PKSfxnn', 'I2PKSfxnn', 't} X\'. :͎gL=', '', 0, '?'),
 ('~3\\} v}V', 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-more-listing-dark.svg', 0, 'q&.ZkX', 'q&.ZkX', 'lԕǺ2N h\0/b(<TF ', '', 0, '?'),
 ('\'76F8\\Ɗ', 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-more-listing-light.svg', 0, '\\-s籙azڔ', '\\-s籙azڔ', 'RĮo5´;؋VDq', '', 0, '?'),
 ('Oiz9*', 'wp-content/updraft/themes-old/kallyas/images/ring-alt.svg', 0, '#MnW3]x;', '#MnW3]x;', 'qalJHW&@0Ϊ-m', '', 0, '?'),
 ('79x&qD\'tu', 'wp-content/updraft/themes-old/kallyas/images/select-arrow-dark.svg', 0, 'c|SAz_', 'c|SAz_', ' aJUۋZs8/sAp.$UE', '', 0, '?'),
 ('v\\n', 'wp-content/updraft/themes-old/kallyas/images/select-arrow.svg', 0, 'J[{y', 'J[{y', '9@gq{k5EL5~M', '', 0, '?'),
 ('3}nYI${Ƴk', 'wp-content/updraft/themes-old/kallyas/images/step-separator-dark.svg', 0, 'E,d9_r9LP)\Z', 'E,d9_r9LP)\Z', 'KvݛQ	`$L <c˅L', '', 0, '?'),
 ('qEG', 'wp-content/updraft/themes-old/kallyas/images/step-separator.svg', 0, '_ruva&', '_ruva&', 'RB0TQS/&B[+\'+_FQ', '', 0, '?'),
 ('+7~,CU', 'wp-content/updraft/themes-old/kallyas/inc/details-portfolio-fields.php', 0, ')h;֌bkt', ')h;֌bkt', '?ٱR洘J;8.8<۵k/IWڵV', '', 0, '?'),
 ('O)TaAȞ*', 'wp-content/updraft/themes-old/kallyas/inc/details-portfolio-related.php', 0, 'x`$@$', 'x`$@$', '\' %WqrUn4TA\\u', '', 0, '?'),
 ('pI>xAe', 'wp-content/updraft/themes-old/kallyas/inc/details-portfolio.php', 0, 'HnOg^Dp', 'HnOg^Dp', '!5	,9+8v\"+\'', '', 0, '?'),
 ('2K/八8', 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio-media.php', 0, 'd3jZM{', 'd3jZM{', '%\nfLf~>IV', '', 0, '?'),
 ('l)guK1зq>', 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_carousel.php', 0, 'go\0W	8m;', 'go\0W	8m;', ',\"YUmkFY5]3', '', 0, '?'),
 ('kk[Fz!8V', 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_category.php', 0, '5Grd{tpb>', '5Grd{tpb>', '6^vܺ_IXZ[OA', '', 0, '?'),
 ('d;z3 bN^', 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_category_item.php', 0, 'Zp>18Vԅ', 'Zp>18Vԅ', '&c[-N\n-6m^fAH\r2\n', '', 0, '?'),
 ('St7]]?$8\"', 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_sortable.php', 0, '!,ܘ+&h89', '!,ܘ+&h89', 'Bam~IƓu5&?bќ)', '', 0, '?'),
 ('0*nsih#M', 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_sortable_content.php', 0, 's\Z3^S\ni', 's\Z3^S\ni', ';sDOEo=(1y\'@Mmn', '', 0, '?'),
 ('e[E\"P[', 'wp-content/updraft/themes-old/kallyas/inc/page-content-view-page.inc.php', 0, '{#r{I;<', '{#r{I;<', 'vbx(>hĀ{kM[', '', 0, '?'),
 ('iBs-:2ӯ', 'wp-content/updraft/themes-old/kallyas/inc/page-content-view-portfolio.inc.php', 0, 'Gw\Z}ɒkqM', 'Gw\Z}ɒkqM', 'IJngqXS6I\rE	9(', '', 0, '?'),
 ('W\n', 'wp-content/updraft/themes-old/kallyas/inc/page-content-view-post.inc.php', 0, '{s.QCOjb', '{s.QCOjb', '0(<R%#zƌFWGGDF;', '', 0, '?'),
 ('	@uި]A~', 'wp-content/updraft/themes-old/kallyas/inc/password-protected.inc.php', 0, 'RX5/9e]jl', 'RX5/9e]jl', '{=Є\'>GS(ʮ-V^t', '', 0, '?'),
 ('!BIO41', 'wp-content/updraft/themes-old/kallyas/inc/single-product-template.php', 0, '=ݤpj', '=ݤpj', '.Q鶮eoi>rZԓZΨ', '', 0, '?'),
 ('Z!s\'_mA2\\', 'wp-content/updraft/themes-old/kallyas/index.php', 0, 'vP@ŀ\0-', 'vP@ŀ\0-', 'v_xkw|fdFj]l7!', '', 0, '?'),
 ('nm(g׽', 'wp-content/updraft/themes-old/kallyas/js/plugins-src/debouncedresize.js', 0, 'ET4F{s', 'ET4F{s', 'Jfc,psJOFkd1[-a', '', 0, '?'),
 ('ƕxs=\reZl', 'wp-content/updraft/themes-old/kallyas/js/plugins-src/echo.js', 0, 'Ujc,8F>', 'Ujc,8F>', 'u*\Zb`d,}F', '', 0, '?'),
 ('HHHXȗo1D', 'wp-content/updraft/themes-old/kallyas/js/plugins-src/fitvids.js', 0, 'W:5W\nn', 'W:5W\nn', '8I͔XǍ .l	Q|T', '', 0, '?'),
 (';pC4MA', 'wp-content/updraft/themes-old/kallyas/js/plugins-src/imagesloaded.pkgd.min.js', 0, 'H	/łߖMD', 'H	/łߖMD', 'bT6SJ>!+O\'\r|I;<ԾJ', '', 0, '?'),
 ('jt8cwA/~A/', 'wp-content/updraft/themes-old/kallyas/js/plugins-src/jquery.easing.js', 0, '弬y]1xgu', '弬y]1xgu', '.h!Dg%&KP	\0t\ng', '', 0, '?'),
 ('H01%S', 'wp-content/updraft/themes-old/kallyas/js/plugins-src/magnificPopup.js', 0, '-t=q\Zd\ZM', '-t=q\Zd\ZM', 'ؒRT.h/\"zqyfg', '', 0, '?'),
 ('kWJJ~q', 'wp-content/updraft/themes-old/kallyas/js/plugins.min.js', 0, 'b9`9C', 'b9`9C', '6z/!ٿBb2VkG<r@Ssb', '', 0, '?'),
 ('[M#:?Tc=', 'wp-content/updraft/themes-old/kallyas/js/znscript.js', 0, 'W\r\ZG4\Z', 'W\r\ZG4\Z', 'VR|eLM\']a0W_Jfڜ', '', 0, '?'),
 ('iVISj5	h', 'wp-content/updraft/themes-old/kallyas/js/znscript.min.js', 0, '%)q\0yD#^-.', '%)q\0yD#^-.', 'skV0b\"Z6qH;ϴ+1ZTf', '', 0, '?'),
 ('P,:ɑO6W', 'wp-content/updraft/themes-old/kallyas/page-coming-soon.php', 0, 'gM(HC#', 'gM(HC#', '>\r1A&Cu҈~\\Q|w&F0', '', 0, '?'),
 ('Whw9e|݃2', 'wp-content/updraft/themes-old/kallyas/page.php', 0, '%%ՁSwRt', '%%ՁSwRt', 'w1! Fkȿk#\\/', '', 0, '?'),
 ('=~\'txoT$', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_3DCuteSlider/TH_3DCuteSlider.php', 0, '  Q+P?ĭ_b', '  Q+P?ĭ_b', '380:)\"m(Sg@sre\'J', '', 0, '?'),
 ('g)>d?', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Accordion/TH_Accordion.php', 0, '_eYL\n', '_eYL\n', 'V|_eG4$し\ZDd|7o', '', 0, '?'),
 ('V|CAI', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Accordion/inc/ui.inc.php', 0, '2O5;5e', '2O5;5e', 'eB<v]\rkDR,MqjЅҷ', '', 0, '?'),
 ('e\\wN$/XCs', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ActionBox/TH_ActionBox.php', 0, '/*CCc`>\'', '/*CCc`>\'', 'ZRX);ei\00\"A?%uI\'If', '', 0, '?'),
 ('VMZݰ]', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_BigSocial/TH_BigSocial.php', 0, 'v۾x2\Z-', 'v۾x2\Z-', 'R  x2@\0e}:R)ƍ\n%', '', 0, '?'),
 ('(ZՁ9{', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_BlogArchive/TH_BlogArchive.php', 0, 'ՀZ3ތwI^u ', 'ՀZ3ތwI^u ', '^gW9x!3ǋ\'+5}P8hW', '', 0, '?'),
 ('\0(}lo', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Buttons/TH_Buttons.php', 0, '͋vb	h>B4g_', '͋vb	h>B4g_', 'ѭ{pv#WK2', '', 0, '?'),
 ('{p(HFFKX{ʾ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CSS3Panels/TH_CSS3Panels.php', 0, '$Y@9cRG,Z', '$Y@9cRG,Z', 'I0 \rJs<mы7#|:b\r', '', 0, '?'),
 ('镆98$DiTQ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CallOutBanner/TH_CallOutBanner.php', 0, 'ZdJ$ Ln', 'ZdJ$ Ln', 'Q\r4iB߯%=i\'v0ZY̰{$', '', 0, '?'),
 ('(bR77\0(', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircleTitleTextBox/TH_CircleTitleTextBox.php', 0, 'ػH\nSAEg', 'ػH\nSAEg', 'b|jB:1}\ne_ORmL', '', 0, '?'),
 (';kxv9', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularCatalogueCarousel/TH_CircularCatalogueCarousel.php', 0, 'wu\nQL', 'wu\nQL', '儺Db<<2%fB`:', '', 0, '?'),
 ('ri2caψʵ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle1/TH_CircularContentStyle1.php', 0, '$VQ[ʙGϓ25', '$VQ[ʙGϓ25', '{\n+^eg:na>Hc', '', 0, '?'),
 ('qOݸCt', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle1/inc/ui.inc.php', 0, 'i.^)6#8A', 'i.^)6#8A', 'ԛ`V+f%Mx', '', 0, '?'),
 ('h^$n\"|y,|S]', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle2/TH_CircularContentStyle2.php', 0, '-%T', '-%T', '\"i׻+EҊSF4Jy~F?', '', 0, '?'),
 ('\r\\8D6!4A`-#%', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle2/inc/ui.inc.php', 0, '$oAQH', '$oAQH', 'Ѭ\0F[d+\\pP?ZQwI K<R ', '', 0, '?'),
 ('ѱfFr\r1', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Comments/TH_Comments.php', 0, '<ʦ9|<O׳[', '<ʦ9|<O׳[', 'SOhK5&\'i2fQa\\JPv\Z?', '', 0, '?'),
 ('+2ơb͛)B\\', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Countdown/TH_Countdown.php', 0, 'w8RLZѾ\ZY9', 'w8RLZѾ\ZY9', '1?o뾏AR2<\rJk', '', 0, '?'),
 ('L(?Ww>', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CustomMenu/TH_CustomMenu.php', 0, 'M,΢]\Z', 'M,΢]\Z', '\';\'\rS\ZvGwwQv', '', 0, '?'),
 ('ߜM&~3\\::', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CustomSubHeaderLayout/TH_CustomSubHeaderLayout.php', 0, '\rmNp', '\rmNp', 'H6:{ErTv B/rWմa', '', 0, '?'),
 ('om*uƔT=', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_DevicesImages/TH_DevicesImages.php', 0, '<b[-\Z', '<b[-\Z', '\\D|}u3ˍǡoTX.S=0~', '', 0, '?'),
 ('4\rz3|HW', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_DevicesImages/style.php', 0, '`dX', '`dX', '.CDH9dPNwe', '', 0, '?'),
 ('=/ŵPlbkE8', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Documentation/TH_Documentation.php', 0, '&~)~ѕ', '&~)~ѕ', '=p+ s܋=a\" XYdUA', '', 0, '?'),
 ('Y_7PƳԇ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_DocumentationHeader/TH_DocumentationHeader.php', 0, 'F8Y\nAJ4+', 'F8Y\nAJ4+', 'f>!-㎉^J\\@LE\Zmvȣ', '', 0, '?'),
 ('8C۵1', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FancySlider/TH_FancySlider.php', 0, '}׵[u U', '}׵[u U', 'D*ll/RIax	ll', '', 0, '?'),
 ('i\"l<4E', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FeaturesBoxes/TH_FeaturesBoxes.php', 0, 'p,=0?8;\0', 'p,=0?8;\0', 'ŖZi;qEIˈ{^3z\\\r', '', 0, '?'),
 ('AhM;Md3=Y', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FeaturesBoxes/inc/ui.inc.php', 0, '&j1ї?.Xj', '&j1ї?.Xj', 'mf6K\n.oӎ}ɒ^	e', '', 0, '?'),
 (']\05J]w5=', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FeaturesBoxes2/TH_FeaturesBoxes2.php', 0, '\Zz\ZT^eHk', '\Zz\ZT^eHk', '5luН\r\\pLMC$}	!MD', '', 0, '?'),
 ('jB)Z\nCz', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FlexSlider/TH_FlexSlider.php', 0, 'a\nT!ka3C', 'a\nT!ka3C', 'w7Ρ\";3	,(0\'	\Zh8b', '', 0, '?'),
 ('0WpHAE4(2\Z\rM', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FlickrFeed/TH_FlickrFeed.php', 0, '#z|a', '#z|a', ')·_͍E)F|}x\n<', '', 0, '?'),
 ('mr\'\"̣ۉs', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_GridPhotoGallery/TH_GridPhotoGallery.php', 0, ' ǽ=l', ' ǽ=l', 'sOiӔDxE^jZR#u~l', '', 0, '?'),
 ('f#ǹn.', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_HistoricElement/TH_HistoricElement.php', 0, 'rv)Q', 'rv)Q', ':{\0k9$OUqK$m', '', 0, '?'),
 ('+^d߸', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_HorizontalTabs/TH_HorizontalTabs.php', 0, '\Z]m gVD2', '\Z]m gVD2', 'La8d}naL󋸁I12', '', 0, '?'),
 ('1/d', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_HoverBox/TH_HoverBox.php', 0, '^wd', '^wd', 'ER#!&!P	2kE.2', '', 0, '?'),
 ('I?iN/)', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/TH_ICarousel.php', 0, 'Xf++\"VW', 'Xf++\"VW', 'kO\"`FjBn]f{>oN3}', '', 0, '?'),
 ('b#\')', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/assets/icarousel.packed.js', 0, 'a(e OrU', 'a(e OrU', '0>k\'|F1g֗nc*w-/', '', 0, '?'),
 ('b|&?lZeJmH', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/assets/jquery.mousewheel.js', 0, 'Lʛ_)e', 'Lʛ_)e', '2\'EtO\'\Z\r$xMՈ=;\r', '', 0, '?'),
 ('M#\0R	6', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/assets/raphael-min.js', 0, 'VIt@SkJ', 'VIt@SkJ', 'PGb]ts觼ߟO,', '', 0, '?'),
 ('.ۀe2', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IconBox/TH_IconBox.php', 0, 'rGEK&ߟjl', 'rGEK&ߟjl', '8-4`Cǅ\'+\r)Dn/*q', '', 0, '?'),
 ('`_mI[^1', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IconBoxesGrid/TH_IconBoxesGrid.php', 0, '37?{*3}0', '37?{*3}0', '-2!&#]]lv3~$\r0', '', 0, '?'),
 ('V&v=(7Qp', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ImageBox/TH_ImageBox.php', 0, '\'Z2Јs3', '\'Z2Јs3', 'U2?s敘~a\'K3U8ē ', '', 0, '?'),
 ('w69>*\Z', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ImageBox2/TH_ImageBox2.php', 0, 'F=xD97', 'F=xD97', '4TiKK{3!KI8*ʆ', '', 0, '?'),
 ('jE-9Şë', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ImageGallery/TH_ImageGallery.php', 0, 'SzȦG2D', 'SzȦG2D', 'm>û6DlI(B3=', '', 0, '?'),
 ('~n#茘}3bN?', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_InfoBox/TH_InfoBox.php', 0, 'DGz#', 'DGz#', 'fvfӸ7a}h\\CvL!Y', '', 0, '?'),
 (';,BXE', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_InfoBox2/TH_InfoBox2.php', 0, 'v>~½_', 'v>~½_', 'sdޜ:v>ISeSGk', '', 0, '?'),
 ('IFݬ\"', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IosSlider/TH_IosSlider.php', 0, '`6XJN|;x1', '`6XJN|;x1', 'Gb(ũ6:6vܮG	p{Wf{+pbg', '', 0, '?'),
 ('Za\ru}', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IosSlider/inc/ui.inc.php', 0, 'E+W̍\'>28!', 'E+W̍\'>28!', '!b\\yBUu|4֣Aϐܣ[', '', 0, '?'),
 ('ԉD;kX=', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IosSlider2/TH_IosSlider2.php', 0, '6a/m', '6a/m', '#XXZæ<y,/Sq<', '', 0, '?'),
 ('&\0`&e^', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_KeywordsElement/TH_KeywordsElement.php', 0, '-8Ȳ#XyT&', '-8Ȳ#XyT&', 'ez5Ֆ>A3=ZJ Ɠh', '', 0, '?'),
 ('FGwܻ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LaptopSlider/TH_LaptopSlider.php', 0, '\Z럧9}', '\Z럧9}', '1.I\\h暙)JW-O\0~', '', 0, '?'),
 ('\rD\'nǎcq±', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LaptopSlider/assets/macbook-air.svg', 0, 'hR2RZsL', 'hR2RZsL', 'xe6!rc}!kOʦc)-g', '', 0, '?'),
 ('wy(燇', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LaptopSlider/style.php', 0, '.F]\rp', '.F]\rp', '(Q)\\rՏ/iﭤJt', '', 0, '?'),
 ('	UBT5Xf', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts/TH_LatestPosts.php', 0, '6ȃN\Zۋt', '6ȃN\Zۋt', 'EES[*-oڧm\Z', '', 0, '?'),
 ('wι.\r9T', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts2/TH_LatestPosts2.php', 0, '5{o.&Xe]', '5{o.&Xe]', 'lN1ڭ#%gU%\\Qc\r6P', '', 0, '?'),
 ('D$Vzu퐜j', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts3/TH_LatestPosts3.php', 0, '}Uh |\r', '}Uh |\r', 'β{o\r||}>|A b', '', 0, '?'),
 ('4`rl*.97u;g\"', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts4/TH_LatestPosts4.php', 0, 'tTBV-\'u', 'tTBV-\'u', ';C\\Daj]A려&==', '', 0, '?'),
 ('qIH\0>O4_?', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/default-style.php', 0, '^@x)xoDE=', '^@x)xoDE=', '*;\"D1z*Q-(@', '', 0, '?'),
 ('sLoE', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/kl-style-2.php', 0, 'xŧcwh,', 'xŧcwh,', '/1QtGzGEE{:o[', '', 0, '?'),
 ('1ˀle(Q', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPostsCarousel/TH_LatestPostsCarousel.php', 0, 's5]', 's5]', ',Kyl㿞.ڈlQos\Zcg;', '', 0, '?'),
 ('\0x\'+M', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_MediaContainer/TH_MediaContainer.php', 0, 'hw\'', 'hw\'', 'e\0{iEOzMP>45w_u', '', 0, '?'),
 ('xɔOC29,', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NewsletterBox/TH_NewsletterBox.php', 0, '5O~T}+Ս_q,', '5O~T}+Ս_q,', 'I.ο՘΍(Y%0M(cە', '', 0, '?'),
 ('M<=\\i', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NivoSlider/TH_NivoSlider.php', 0, 'K::7<m', 'K::7<m', 'V_?v`2:^|6&\r', '', 0, '?'),
 ('Cň*IֵbA:*', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NivoSlider/assets/jquery.nivo.slider.pack.js', 0, 'bױ\r', 'bױ\r', '[b҆):M:GH@', '', 0, '?'),
 ('Z~{(%s', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NivoSlider/style.php', 0, '!W5t(', '!W5t(', ';FNG=\ZChtIϞ', '', 0, '?'),
 ('\0\n͐', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PageContent/TH_PageContent.php', 0, 'a\rȂ!&:D', 'a\rȂ!&:D', 'Z7?9^rӣH_m0', '', 0, '?'),
 ('L$C,h ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PartnersLogos/TH_PartnersLogos.php', 0, '5(,m\\', '5(,m\\', '{HT8\n9n(/P', '', 0, '?'),
 ('Ӡ-g5.', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PartnersTestimonials/TH_PartnersTestimonials.php', 0, '}jlx@8i!', '}jlx@8i!', '(pRU?gcB9\\#,', '', 0, '?'),
 ('JȈy\0fM', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/TH_PhotoGallery.php', 0, 'nؼI<-r-\\', 'nؼI<-r-\\', 'zQ{h (VkPL2<[Um\Zx', '', 0, '?'),
 ('[l\r9I	Л', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/images/album-gallery.svg', 0, 'Ægʯ=/', 'Ægʯ=/', 'kq[jD/Ћe;ظY튬l', '', 0, '?'),
 ('7F)z6V3~', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/images/normal-gallery.svg', 0, 'A>#\r1gG/', 'A>#\r1gG/', 'X}}\'8cH?UFe', '', 0, '?'),
 ('S\0rrzb', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/images/slideshow-gallery.svg', 0, 'qJr&s-', 'qJr&s-', '(=dX\rKD?l$b<N[}', '', 0, '?'),
 ('9cRtU', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhpCode/TH_PhpCode.php', 0, '$VMΌr', '$VMΌr', '\\==ecB\Zf9.tFj9vZ7', '', 0, '?'),
 ('9IϘ	!;', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PortfolioArchive/TH_PortfolioArchive.php', 0, 'YWk\'Ɖ}/', 'YWk\'Ɖ}/', 'z?>ce-z\\m$5', '', 0, '?'),
 ('R06CG_d! ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PortfolioContent/TH_PortfolioContent.php', 0, 'gcVu@ϖ', 'gcVu@ϖ', 'I[x13f-G8Fhw`', '', 0, '?'),
 ('c\Z-@.', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PortfolioSlider/TH_PortfolioSlider.php', 0, 'P;}OOJjc', 'P;}OOJjc', 'H	f1Ѓ˿j.i%v%Sy #', '', 0, '?'),
 ('=x[60', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PostContent/TH_PostContent.php', 0, '`v6䜾Cm', '`v6䜾Cm', 'M	u52&;mzA_+M4J', '', 0, '?'),
 (' m&q)MX', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PricingTable/TH_PricingTable.php', 0, '*:q S|{>', '*:q S|{>', '[STfLSK^T<A^UH', '', 0, '?'),
 ('@_UPlq^', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ProductArchive/TH_ProductArchive.php', 0, 'AسE\076D', 'AسE\076D', '#z/%gBd', '', 0, '?'),
 ('ϔSQ}w^', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ProductContent/TH_ProductContent.php', 0, '^O+t{', '^O+t{', 'L{y2yqrm	\'ҡ<ǉJ1', '', 0, '?'),
 ('}XOS', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RecentWork/TH_RecentWork.php', 0, 'r){nK\n:I', 'r){nK\n:I', 'G{s|9hUlT\0R))-', '', 0, '?'),
 ('Y5؄)Q', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RecentWork2/TH_RecentWork2.php', 0, 'RXJ$v7;ݎd', 'RXJ$v7;ݎd', 'Qn%>A%,', '', 0, '?'),
 ('U)`Cυ`n_', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RecentWork3/TH_RecentWork3.php', 0, '/%Ew', '/%Ew', 'nUWT+8|?Udz\\O3', '', 0, '?'),
 ('.t+^80¤Lf', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RevolutionSlider/TH_RevolutionSlider.php', 0, '3T[\rw#Mi', '3T[\rw#Mi', 'qEa~\0Ĥ%M3[f', '', 0, '?'),
 ('h\\/9\\+\0z', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ScreenshotsBox/TH_ScreenshotsBox.php', 0, '\'db<+l', '\'db<+l', '7ͭn3B\0ّE-~S.>W5>ƅ', '', 0, '?'),
 ('C6[kV+', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ScreenshotsBox/style.php', 0, '[1wh%)', '[1wh%)', 'eO(iKη5g#R\0rh', '', 0, '?'),
 ('wM}}]L', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_SearchBox/TH_SearchBox.php', 0, 'ׁ#\\{/׃|', 'ׁ#\\{/׃|', '\nfS7.qS%˸J24jTf9M', '', 0, '?'),
 ('Hȹr\"腋_', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ServiceBox/TH_ServiceBox.php', 0, ';%N%u\r ', ';%N%u\r ', '2:&LV4|c+ƭejB]8/', '', 0, '?'),
 ('-dԱsġ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ServicesElement/TH_ServicesElement.php', 0, '{:)\\^-xF9|', '{:)\\^-xF9|', '^Lz8	eW\nx.;%\'d]/-', '', 0, '?'),
 ('b@U	)s#', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ShopFeatures/TH_ShopFeatures.php', 0, '#_)nfpsP', '#_)nfpsP', 'H	m[}DK!t:?f', '', 0, '?'),
 ('H6;#\0Y#', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ShopLimitedOffers/TH_ShopLimitedOffers.php', 0, 'vd9?-H\noLy', 'vd9?-H\noLy', 'd6;7I.DVzw\'\nȣq ', '', 0, '?'),
 ('#@ygH', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ShopProductsPresentation/TH_ShopProductsPresentation.php', 0, 'k*h@zE/m', 'k*h@zE/m', 'c:s}OQtUi<~FtHE]', '', 0, '?'),
 ('W\"<K=\re', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Sidebar/TH_Sidebar.php', 0, ']L\n5~', ']L\n5~', 'jk\07VT͆6+i', '', 0, '?'),
 ('84U@#	', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Skills/TH_Skills.php', 0, 'zg7+ptE', 'zg7+ptE', 'އ8hu1D|ʻ@>i:XЊ32Bj;', '', 0, '?'),
 ('q:!//ҍ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Skills/diagram_el.js', 0, '\Z\"', '\Z\"', 'F}ӊoBj :#ܐL', '', 0, '?'),
 ('\n7XKQ~', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Skills/raphael-min.js', 0, ')Wc~F', ')Wc~F', '=\0>F$Fpp5\n@x@P,\r.', '', 0, '?'),
 (']IZL.L', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_SocialIcons/TH_SocialIcons.php', 0, '~DG', '~DG', 'wjlvt%<)u(9s{dPR', '', 0, '?'),
 (']\n58Җ8', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_SpacerElement/TH_SpacerElement.php', 0, 'QǓН;~3,', 'QǓН;~3,', 'H5pe׮M\'0bIލֳxS\nvb\r', '', 0, '?'),
 ('6YJG', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StageImageBox/TH_StageImageBox.php', 0, 'TŘ\nD:', 'TŘ\nD:', '[zG^D!)Kp:&lv', '', 0, '?'),
 ('~C.M', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentBoxes/TH_StaticContentBoxes.php', 0, 'pZuKa\rb', 'pZuKa\rb', '1Cw,ewAנv2\'F`dI', '', 0, '?'),
 ('4_91*rHx', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentDefault/TH_StaticContentDefault.php', 0, '&wu/%Bu);', '&wu/%Bu);', 'H7m\nOD;4WqھN:tj	', '', 0, '?'),
 ('֎Eou', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentEventCountdown/TH_StaticContentEventCountdown.php', 0, 'fuEZ|ï\"', 'fuEZ|ï\"', 'vMH9!bg?:O#o2$', '', 0, '?'),
 ('-b᷎3`}J', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentProductLoupe/TH_StaticContentProductLoupe.php', 0, '铳YRk', '铳YRk', '/dQ\\Ӿ8X,W{rt8;', '', 0, '?'),
 (';a\01t.r(', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentReservationForm/TH_StaticContentReservationForm.php', 0, 'c4I/p.', 'c4I/p.', 'Ҧ>M\"-ѭKv4Sdqx3fI', '', 0, '?'),
 ('9&xl)', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentShowroomCarousel/TH_StaticContentShowroomCarousel.php', 0, 'qJE	S~', 'qJE	S~', '7>(y5mEYHDw_\rFrhPr', '', 0, '?'),
 ('(\'ҏbr@_ܨ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentSimpleText/TH_StaticContentSimpleText.php', 0, 'N@j?,ߘ+\r$', 'N@j?,ߘ+\r$', '²\n&9Cl\\^E3!)', '', 0, '?'),
 ('M0v0RnءZ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentSimpleTextFullWidth/TH_StaticContentSimpleTextFullWidth.php', 0, 'YDol1', 'YDol1', 'V{ݪswC7,ݰ)%Q)', '', 0, '?'),
 ('up+\rY', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentTextAndRegister/TH_StaticContentTextAndRegister.php', 0, 'Ƞ6sk(q\ZFY', 'Ƞ6sk(q\ZFY', '٨S,F?xS*z;¿؊(', '', 0, '?'),
 ('?FzӑQ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentTextAndVideo/TH_StaticContentTextAndVideo.php', 0, '\rH3jVD2I', '\rH3jVD2I', 'wOߪ{\"o	{*Sl', '', 0, '?'),
 ('KU]\nW\nL', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentTextPop/TH_StaticContentTextPop.php', 0, '/`WM\"q', '/`WM\"q', 'EXruסqvߝ>|MB', '', 0, '?'),
 ('ū}f#', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentVideo/TH_StaticContentVideo.php', 0, '!Tp[V]<iQt', '!Tp[V]<iQt', '@;<ܿ9MA&A^`,', '', 0, '?'),
 ('<>;ڻ?c\n', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentVideoBackground/TH_StaticContentVideoBackground.php', 0, 'i{{F3z', 'i{{F3z', 'E)卂|SnVML	U.&', '', 0, '?'),
 ('ҡ<1\"r', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/TH_StaticContentWeatherBox.php', 0, '×[a 7}\\^', '×[a 7}\\^', 'E!/hEQ\Zar:A_Z\Zj', '', 0, '?'),
 ('Sdwje', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/scwb.js', 0, '<qZ^I^i', '<qZ^I^i', 'q7tMY\\[', '', 0, '?'),
 ('ʶ~', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Statistics/TH_Statistics.php', 0, '>զ[:pSnp', '>զ[:pSnp', '<! /+iQ', '', 0, '?'),
 ('ۤlK&F7Dv', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StatsBox/TH_StatsBox.php', 0, '\ZIe7rwgq', '\ZIe7rwgq', 'eh@~8hVe({ֆ', '', 0, '?'),
 ('W43Lk8', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox/TH_StepsBox.php', 0, '}ׯh(_', '}ׯh(_', ')ѕ9zY4\\{gwH\nB.', '', 0, '?'),
 ('BAZ8\\:7\0[', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox2/TH_StepsBox2.php', 0, '75Sǫ5', '75Sǫ5', ';#7::F\')38AB', '', 0, '?'),
 ('ն-k;}Q\n/', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox3/TH_StepsBox3.php', 0, '|8d$T)B', '|8d$T)B', 'OtwGGJ8[Ru	b?F|p=', '', 0, '?'),
 ('\\JN~<\0P4|8u%', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox4/TH_StepsBox4.php', 0, 'rF\Z Kr', 'rF\Z Kr', ' R)x\"ѮvvRO', '', 0, '?'),
 ('[]ǆ\\vZ؂', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TeamBox/TH_TeamBox.php', 0, 'o«b{|{<', 'o«b{|{<', 'gMlX{yZ$2E)dT*I', '', 0, '?'),
 ('m\\d{OǂCt', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TestimonialBox/TH_TestimonialBox.php', 0, '},!@t', '},!@t', '6L2/xqUhiGؾUuϢ', '', 0, '?'),
 ('p3K#Rt9', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TestimonialFader/TH_TestimonialFader.php', 0, 'njLњBSGx', 'njLњBSGx', 'ե\nիnillXRoUqr\\:z(\n\'', '', 0, '?'),
 ('/L\Znz`', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TestimonialSlider/TH_TestimonialSlider.php', 0, 'U)EnNS', 'U)EnNS', 'Wq`U]a/wbS]V<mA', '', 0, '?'),
 ('lKD\Z2ǷĪ\"', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TextBox/TH_TextBox.php', 0, 'gF\Zmj_J', 'gF\Zmj_J', 'Wy\n&Z\rbWv', '', 0, '?'),
 ('\\o	j=0h', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TitleElement/TH_TitleElement.php', 0, 'GW)5B0', 'GW)5B0', '+#uO`ܟ3ud @?ƻ,(Ľv-', '', 0, '?'),
 ('/Ni>MB', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_VerticalTabs/TH_VerticalTabs.php', 0, 'nPTq>1`vvA', 'nPTq>1`vvA', 'ITC\"wY2E*,*.§', '', 0, '?'),
 ('-n@0]+a+', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_VideoBox/TH_VideoBox.php', 0, 'Kcn%5h', 'Kcn%5h', 'G.Ax@WVM\0\n*T<q,lba', '', 0, '?'),
 ('?\r8Q0', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_WowSlider/TH_WowSlider.php', 0, 'eiY3Ƶ ', 'eiY3Ƶ ', 'd\nwO#$.	߯>P!+Q', '', 0, '?'),
 ('Yswp', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_WowSlider/assets/wowslider.js', 0, 'fv[~N0rGݼe', 'fv[~N0rGݼe', '/VDՕH@W\"u+{ʝ	5)h', '', 0, '?'),
 ('ӍU7rlgn>^', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_WowSlider/style.php', 0, '%Oe؎Hb', '%Oe؎Hb', 'Rգ\'}>oDdeg4j&yw', '', 0, '?'),
 ('>6:Ɵ?R3J', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/anchor_point/anchor_point.php', 0, 'Nmv\'r', 'Nmv\'r', 'bK!i\rA	ͻ7Ӝ0j=kr', '', 0, '?'),
 ('pcþU?t', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/button/button.php', 0, '}}SSG3', '}}SSG3', '֫*Bf;\n`fN[w7σrQ&', '', 0, '?'),
 ('`5mK~mZZ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/column/column.php', 0, 'XɁ ŗ', 'XɁ ŗ', 'HgLFb8Zbu 5lPie', '', 0, '?'),
 ('L\\B', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/contact_form/cf-template.php', 0, 'VzQ}c	_2\0', 'VzQ}c	_2\0', 'ެZ,4SIFc-@ŞU', '', 0, '?'),
 ('иziFOuum', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/contact_form/contact_form.php', 0, '\"ԆR.ԼA', '\"ԆR.ԼA', 'BP#,36gbZGTS0M9J', '', 0, '?'),
 ('L?7W', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/custom_container/custom_container.php', 0, '֒\Z	:Qy', '֒\Z	:Qy', 'qj>lT6`SbF w(D', '', 0, '?'),
 ('%\"(%)k%', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/custom_html/custom_html.php', 0, ',3am\0SB', ',3am\0SB', 'h,>U\"ľĺkZ.]\r_0', '', 0, '?'),
 ('`EҠ!cC!', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/google_map/assets/gmaps.js', 0, '	棶QX -<&', '	棶QX -<&', '<z][AZV T0B.ViP', '', 0, '?'),
 ('@0yIA', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/google_map/assets/markerclusterer.js', 0, 'FLVn!k=k', 'FLVn!k=k', 'svCh>eʴ\n9p?JQ\nCޛ/>', '', 0, '?'),
 ('uEJzP^u^', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/google_map/google_map.php', 0, ';$m{ޡY+B', ';$m{ޡY+B', 'aUHmAn3l᭢Tzs\ZIJ', '', 0, '?'),
 ('\Z1HZblP', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/list/list.php', 0, 'q^|O', 'q^|O', '\\\'ro5\0})}J_\ZԴX\ZI', '', 0, '?'),
 ('$?Y\Z#h<', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/multi_layered/multi_layered.php', 0, '߹L8ad', '߹L8ad', 'u©_&-9\'2&2(YWj\r=f', '', 0, '?'),
 ('^,2҂Nl耻', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/pb_template/pb_template.php', 0, '?񄚡w', '?񄚡w', 'PbN]qCIj԰>oRn(H^', '', 0, '?'),
 ('Bf)=@L\ZC#W', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/price_list/price_list.php', 0, 'tz;BC,O', 'tz;BC,O', 'H}\0AgtdJ$  T#XpC', '', 0, '?'),
 ('l$6okcAn#', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/section/section.php', 0, '{Y?{z;', '{Y?{z;', '#+hFv\\GdTP(s;=P', '', 0, '?'),
 ('[(\"MO\0w', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/separator/separator.php', 0, 'qGѮ㑭6c', 'qGѮ㑭6c', '#HکGX]޶|', '', 0, '?'),
 ('!Ph', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/skill-bars/skill-bars.php', 0, 'eK\Zy	\'L', 'eK\Zy	\'L', '\\Ejĝ+lTJKy\0', '', 0, '?'),
 ('\n͟ퟹ,j', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/smart_carousel/smart_carousel.php', 0, 'L$>iv0h', 'L$>iv0h', 'g)\"}͌q_/C9<-}U<', '', 0, '?'),
 ('\'	M$\\<\0j\'>', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/smart_slider/options.inc.php', 0, 'zPH	pD', 'zPH	pD', '#p#&]#+ ', '', 0, '?'),
 ('v,h q?T6i', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/smart_slider/smart_slider.php', 0, 'qoh$Rai^;', 'qoh$Rai^;', 'T\'S.#wrl^yW\rLܱԥ?', '', 0, '?'),
 ('Tl>]8.slE`', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/sticky_section_lite/sticky_section_lite.php', 0, '稌د6XBG@u}', '稌د6XBG@u}', 'C{%_/VrOʹͫJLڤ', '', 0, '?'),
 ('}PbR&g', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/tweetbox/tweetbox.php', 0, 'Na%Bt', 'Na%Bt', '&J^O#3Hl1o։d', '', 0, '?'),
 ('ScR)YZ6', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/widget/options.php', 0, '+*>h#eS', '+*>h#eS', 'jĖq{RjDhYK8>YgӋ1y', '', 0, '?'),
 ('\'xޏ', 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/widget/widget.php', 0, '=F|Sb09', '=F|Sb09', '2s yU	@1GUmht', '', 0, '?'),
 ('Ԓ(=ݝS', 'wp-content/updraft/themes-old/kallyas/search.php', 0, 'ລdߑ/&K', 'ລdߑ/&K', 'ԭX6l2~C]\"֎P=i@', '', 0, '?'),
 ('QyHl\n{ZS', 'wp-content/updraft/themes-old/kallyas/searchform.php', 0, ' ?', ' ?', 'xm\Z&G)%i8`X{1wO', '', 0, '?'),
 ('9iU23', 'wp-content/updraft/themes-old/kallyas/sidebar.php', 0, 'ܪ7P', 'ܪ7P', '/\Z ͗Ӆ\0kY~<ؒ\r)dv', '', 0, '?'),
 ('$DZPElF', 'wp-content/updraft/themes-old/kallyas/single-documentation.php', 0, 'Í$1vU|y', 'Í$1vU|y', 'hpNwBEƶ!Ƹ?p`UR', '', 0, '?'),
 ('1v\nW>&t', 'wp-content/updraft/themes-old/kallyas/single-portfolio.php', 0, '01eƨn', '01eƨn', 'o>8c7UFCݽ˛tM)\\', '', 0, '?'),
 (']Yq\Zk!', 'wp-content/updraft/themes-old/kallyas/single.php', 0, '͎(yon', '͎(yon', 'rw-0e=7fLɧA@', '', 0, '?'),
 (')oj\"l', 'wp-content/updraft/themes-old/kallyas/taxonomy-documentation_category.php', 0, '_J7b\nK֠=u', '_J7b\nK֠=u', 'r7))\ZK`yv%', '', 0, '?'),
 ('>A4Z}', 'wp-content/updraft/themes-old/kallyas/taxonomy-project_category.php', 0, '`ln@\\CY', '`ln@\\CY', '%\rL++懝ً\0KOU>ldVӥ-', '', 0, '?'),
 ('jhYqcsDh', 'wp-content/updraft/themes-old/kallyas/template_helpers/helper-functions.php', 0, 'PVd&|Zѿi', 'PVd&|Zѿi', 'gqBD.Wץdwk0[r', '', 0, '?'),
 ('ոܜ', 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/glyphicons_halflingsregular/glyphicons_halflingsregular.svg', 0, '!Fhey#-e[', '!Fhey#-e[', '$6`|y+^	8c%k', '', 0, '?'),
 ('^E|LgZ\'7', 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/glyphicons_halflingsregular/icon_list.php', 0, 'dh:\Z.S &g', 'dh:\Z.S &g', 'g?x[EbƜ{ǛejN4', '', 0, '?'),
 ('|\nr2\\3', 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/kl-social-icons/icon_list.php', 0, 'ִCBe6', 'ִCBe6', '܏[&T]692{,s膐j,', '', 0, '?'),
 ('	lQGZ\rJ2', 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/kl-social-icons/kl-social-icons.svg', 0, 'װt\0iMY\Z', 'װt\0iMY\Z', '¦S3a^r>\n`MlT{4dq', '', 0, '?'),
 ('XZBq{`2g9', 'wp-content/updraft/themes-old/kallyas/template_helpers/metaboxes/metaboxes.php', 0, 'N\0g%', 'N\0g%', 'qU>o	^0Cϥ쯇b', '', 0, '?'),
 ('6\0$F3>f@', 'wp-content/updraft/themes-old/kallyas/template_helpers/metaboxes/metaboxes_locations.php', 0, '%Sk/?w', '%Sk/?w', '~&PpaEi\nUlq', '', 0, '?'),
 ('7в\rfX$OJB\"', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/404-page-options.php', 0, ',\n`:Mj', ',\n`:Mj', 'pk@7?wTnqY', '', 0, '?'),
 ('u\\rdQC', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/advanced-options.php', 0, 'TjRk	', 'TjRk	', '`p3ѶA4=[|h68 ;AAg4Q', '', 0, '?'),
 ('i/?.ȷ', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/blog-options/archive-options.php', 0, 'HT.r\\T)', 'HT.r\\T)', '5Qڮ%^Z|NBJ:Zb$Z', '', 0, '?'),
 ('9mPy{=', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/blog-options/single-blog-item-options.php', 0, 'e.\\fǔukw', 'e.\\fǔukw', 'Yh[j8A[u\'Ѣ!(#', '', 0, '?'),
 ('Ð2Ґ*^is0', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/color-options/color-options-palette.php', 0, 'R^O^ʟA)1I', 'R^O^ʟA)1I', 'Lnd(9<DI;d)', '', 0, '?'),
 ('eto]D,', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/color-options/color-options.php', 0, '%\0{eb(', '%\0{eb(', 'oՅ7r]W{_gk;^ivtU|', '', 0, '?'),
 (']', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/coming-soon-options.php', 0, 'miF\n7eH', 'miF\n7eH', 'ϔ[-L?QA,_bfGd', '', 0, '?'),
 ('88曜!\r', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/documentation-options.php', 0, 'Yc)~38ẃz', 'Yc)~38ẃz', '!AeR)ʥ]5ypk4(J`\'EWn', '', 0, '?'),
 ('4<x?SOPu%', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/alternative-font-options.php', 0, 'L4Gn`P%s', 'L4Gn`P%s', 'ñt\\$\":a>EQ', '', 0, '?'),
 ('\"fLp2Tޡ', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/body-fonts-options.php', 0, '%[3a8h', '%[3a8h', 'X/AZK 0	d͈ш', '', 0, '?'),
 ('`\Z^L_p', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/general-font-options.php', 0, 'Y%C%DBB', 'Y%C%DBB', '97\\Tp&WmLcC=W\Zwh\\', '', 0, '?'),
 ('$)pEJqt2A', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/headings-options.php', 0, 'V5l>\r\0', 'V5l>\r\0', '#;̪2Qnwa2O|N\nV\nk', '', 0, '?'),
 ('2cweH2q', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/main-menu-font-options.php', 0, '?Ri зh3NC=', '?Ri зh3NC=', 'I$t-G7B\ZI2Zfoo', '', 0, '?'),
 ('IK@%-U]D', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/cta-options.php', 0, 'f\0j0P', 'f\0j0P', 't*\r|\rsT&7?.tF3', '', 0, '?'),
 ('ZOHśPMq', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/default-header-options.php', 0, 'X\n՜SAc~', 'X\n՜SAc~', '\' ̱$FgE ~39', '', 0, '?'),
 ('ø\Zc', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/footer-options.php', 0, '$+\rd4 ', '$+\rd4 ', '_wqP\n#<Xy[6a\\fF', '', 0, '?'),
 ('B*2_at', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/general-options.php', 0, 'ltC?v!^O', 'ltC?v!^O', 'mPye[KKUÌB>$s', '', 0, '?'),
 ('W4_qOo\"-@', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/google-analytics-options.php', 0, '#@4߭Ϳ%q', '#@4߭Ϳ%q', 'hcMQ,d\ZA?9', '', 0, '?'),
 ('i\Z9!H|}', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/google-maps-options.php', 0, '0a7F6EE', '0a7F6EE', '<dQxF\nRg|\")[<h', '', 0, '?'),
 ('fgi|}', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/header-advanced-options.php', 0, 'OhX\r<ٹXl', 'OhX\r<ٹXl', 'Z-1+qWn!JZ5eOWG', '', 0, '?'),
 ('͈Y}X9hns%Y', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/header-options.php', 0, '¿͵\'9LF.', '¿͵\'9LF.', '1~\0zi6\rY@', '', 0, '?'),
 ('\'515sa', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/infocard-options.php', 0, 'X\Zs~D', 'X\Zs~D', 'Т\0TDA5	K%JlKQAp(<~V', '', 0, '?'),
 ('\0!Gvвғ', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/logo-options.php', 0, 'PW[g3', 'PW[g3', 'i	m]N\nQ\r&)EzGЕ1i', '', 0, '?'),
 ('),Yյ\"', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/nav-options.php', 0, 'c(n0VVnE', 'c(n0VVnE', 'zk71#)Cƺ&_LչҴ\rV', '', 0, '?'),
 ('!W{].', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/recaptcha-options.php', 0, ']\'s{E>σW', ']\'s{E>σW', 'ô\\%DweOwE\"H@@T', '', 0, '?'),
 ('M6PBj!', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/layout-options.php', 0, ',\\\nv\"', ',\\\nv\"', 'c˹S^nL/T9tk$', '', 0, '?'),
 ('hPq(Wц', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/pb-templates.php', 0, 'D*aED}', 'D*aED}', 'UMmT,؄ԗmkaYX_', '', 0, '?'),
 ('B&+/^>E.', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/portfolio-options.php', 0, ' Kv1', ' Kv1', '\\	)ɦD.K>\"\n6b}YS', '', 0, '?'),
 ('Yu^!u', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/unlimited-headers-options.php', 0, '֎>\0䀟E8', '֎>\0䀟E8', '~0!#i33Hw;p', '', 0, '?'),
 ('8g=lQ=OB', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/unlimited-sidebars.php', 0, '|o᝹WE', '|o᝹WE', '0T§1z>@(`+Eῇtk', '', 0, '?'),
 ('X_\r9;X;v', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options.php', 0, 'r?\r%', 'r?\r%', 'WbNQėw76S%J׻3fxN\r', '', 0, '?'),
 ('c`\"b:nA', 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-pages.php', 0, 'рg	se%	', 'рg	se%	', '{<։eg69', '', 0, '?'),
 ('hyZ\'\r(R', 'wp-content/updraft/themes-old/kallyas/template_helpers/pagebuilder/page_options.php', 0, '-`~_d)~S', '-`~_d)~S', '{@/\"ܺUɦ\"+BtЮ`', '', 0, '?'),
 ('g>Qz', 'wp-content/updraft/themes-old/kallyas/template_helpers/pagebuilder/pagebuilder-animations.php', 0, 'I$(8\0', 'I$(8\0', '|d^L8c*l80W', '', 0, '?'),
 (';}txٍ-B', 'wp-content/updraft/themes-old/kallyas/template_helpers/pagebuilder/pagebuilder-functions.php', 0, ')\r/Q', ')\r/Q', 'a(,¥SCS1\ry%AT){', '', 0, '?'),
 ('öRr%\"a[', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/ht_year.php', 0, '[C`wVn\'m', '[C`wVn\'m', 'g,S17BNԝ_T4ݵ', '', 0, '?'),
 ('W(=Y4^Q]FG', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_accordion.php', 0, 'uU2UV', 'uU2UV', '\'Ő\0a\'eTcI$ncE\0[r', '', 0, '?'),
 ('ge+MD}', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_accordion_container.php', 0, '-}[~;!cDрl', '-}[~;!cDрl', '|X`t\"]()r6@Q', '', 0, '?'),
 (')M]Mb+TA,k w', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_accordion_panel.php', 0, '8CZE[hY\\<', '8CZE[hY\\<', '\rX`ZJ&Cz#~WHin&', '', 0, '?'),
 ('͝Nx/yKqTE', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_script_shortcode.php', 0, 'z&e5PzLN', 'z&e5PzLN', 'lfRRDbbhgX+GGWJ', '', 0, '?'),
 ('YsG|^2', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_blockquote.php', 0, ' .i|~8	9', ' .i|~8	9', 'yL xWٸ8;', '', 0, '?'),
 ('-\"`@[B:Y', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_buttons.php', 0, 'ϗůCi^v_<', 'ϗůCi^v_<', 'bɋg=0$)љS&L|O=]Ui', '', 0, '?'),
 ('ˮ!\0D\r:h$', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_code.php', 0, 'o9ȲADS', 'o9ȲADS', 'ałan#Maٺg_O\09_', '', 0, '?'),
 ('G))\')Xj', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_column.php', 0, '-Ѥ@]', '-Ѥ@]', 'lS]%yxk\ZU5\Z^L0pf!', '', 0, '?'),
 ('ddOq!ݮ', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h1a.php', 0, 'lsM)d*{D', 'lsM)d*{D', 'cc~2\\F^I/ڿm[4}G', '', 0, '?'),
 ('¹*\no5(J', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h2a.php', 0, 'x[y eqan 4', 'x[y eqan 4', ' =/g3rF#1/.1M\'Azd', '', 0, '?'),
 ('SaK͹/JM', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h3a.php', 0, '脃ָ5\01֬', '脃ָ5\01֬', 'zgrwd8IZR\0Py', '', 0, '?'),
 ('m!If|}OD', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h4a.php', 0, 'kWR3*#7\nfw', 'kWR3*#7\nfw', 'm86fA~Tɠ%t۳mxcM\r`', '', 0, '?'),
 ('ytlr;EMr', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h5a.php', 0, 'ƽ~R@=u', 'ƽ~R@=u', 'DxCHۧ[[uukzAI͂', '', 0, '?'),
 ('cQZ', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h6a.php', 0, 'a	M8^', 'a	M8^', '5i<cs(&<颒6ʟ=fA', '', 0, '?'),
 (',NgP`B)$', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_icons.php', 0, 'zc	q7Xiߙ', 'zc	q7Xiߙ', '@B:s+76w;\'Ӟ,', '', 0, '?'),
 ('Y ryNm1c', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_list.php', 0, 'kA֗)$	Qdz', 'kA֗)$	Qdz', '	CrVgug`,wů/', '', 0, '?'),
 ('Xx}S	}0l-', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_one_fourth_columns.php', 0, 'D3\\B\"-_w7', 'D3\\B\"-_w7', 'ԅ?ǽaR;/;mY', '', 0, '?'),
 ('oSDj}', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_caption.php', 0, '_gezL-Kk', '_gezL-Kk', '(u\\\0Jyh`X/1$hPv~', '', 0, '?'),
 ('uZuoQxKxR\n', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_column.php', 0, 'S-\\UP`;5', 'S-\\UP`;5', '>`Zv[[M]>', '', 0, '?'),
 ('gȾb,8Jc', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_table.php', 0, '!g2sɏn', '!g2sɏn', '4^ACi~g-KG1Y[)3', '', 0, '?'),
 ('}My}S', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_qr.php', 0, '&	rqnvs9I', '&	rqnvs9I', '̪:%PB۴X)UrR:us', '', 0, '?'),
 ('VQQ1S|<o', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_row.php', 0, 'R>BÀ |[SU', 'R>BÀ |[SU', '6ӭ2LrXj\0P	{', '', 0, '?'),
 ('n18Ia@{', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_sitemap.php', 0, 'YB\'qi\\', 'YB\'qi\\', 'j`|clv\0dNw0`	A)', '', 0, '?'),
 ('MpfT׾/`', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skill.php', 0, 's[m6I+', 's[m6I+', '\"Oa,)1D?+*\ZQ˹0a', '', 0, '?'),
 ('{uv(\'Pݠ', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skills.php', 0, 'G1#A(w;\"', 'G1#A(w;\"', '(Ir[\rM{7ô', '', 0, '?'),
 ('\r#هd)5', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_social_share_icons.php', 0, '߳oG՝}\rO', '߳oG՝}\rO', ' ăH>}>8.;!y5&mg+dY', '', 0, '?'),
 ('mCۏYyX', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_subtitle.php', 0, '\n@ぽ^', '\n@ぽ^', '^5٘fUMB4g!7dO@=@0', '', 0, '?'),
 ('.+RJvۧ', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tab.php', 0, '@m&IM#*!o\0R', '@m&IM#*!o\0R', '3[\'c8әw!TN0l#', '', 0, '?'),
 (':sZΥTr)', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_table.php', 0, 'xp|す^', 'xp|す^', '_Wm]6$kWϘ_̏6)', '', 0, '?'),
 ('o{鬒P', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tabs.php', 0, 'ԑ6^=|', 'ԑ6^=|', '-B.-ʰ`\nzlߡpVs4U\")O\'', '', 0, '?'),
 ('47Jj.&', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_columns.php', 0, 'g:~\"mfBW', 'g:~\"mfBW', 'g(J77u}BcކXm', '', 0, '?'),
 ('_j:s0r;S', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_fourth_columns.php', 0, 'MxV<!', 'MxV<!', 'H٠~}#k42)`*$v1!G,', '', 0, '?'),
 ('.R7͗BBk,0o', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tooltip.php', 0, '%عN,ƋݱA', '%عN,ƋݱA', 'Q0.HDua|8Hhj4', '', 0, '?'),
 ('6@ac5InI', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_columns.php', 0, ' ܍)Xe#[', ' ܍)Xe#[', 'M(us\\ں33I档', '', 0, '?'),
 ('FILÞՇ!ս', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_third_columns.php', 0, ':ȜG[Q͑b', ':ȜG[Q͑b', '^\'#ΊƏߠ*cU', '', 0, '?'),
 (':#o{', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_znhg_qr.php', 0, '0T0+߆q', '0T0+߆q', '%^/[ԋ\nSNy_	X7\r32/9', '', 0, '?'),
 (',`><k.', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/znhg_alternative_header.php', 0, 'זp9E', 'זp9E', 'yٟY_ENH?D|l', '', 0, '?'),
 ('>#MaƋ', 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/shortcodes.php', 0, 'ٮrTE]', 'ٮrTE]', 'F9a#܄uN0\nQ*\r', '', 0, '?'),
 ('ɡ(4L:', 'wp-content/updraft/themes-old/kallyas/template_helpers/termmeta/termoptions.php', 0, 'o7}LEd', 'o7}LEd', 'kpq5\"oACZiZtޞ', '', 0, '?'),
 ('}\'!\"_Xi*.^Y', 'wp-content/updraft/themes-old/kallyas/template_helpers/theme_layout_manager.php', 0, '+~aE1<', '+~aE1<', 'X΁qI)PbRRO#iUߋ\0G\n', '', 0, '?'),
 ('٤yXh', 'wp-content/updraft/themes-old/kallyas/template_helpers/tweeter-helper.php', 0, '?払_b^', '?払_b^', 'OZ^8AY*ZWs_hI', '', 0, '?'),
 ('_cGN', 'wp-content/updraft/themes-old/kallyas/template_helpers/update/scripts/kallyas-update-4.0.0.php', 0, 'y3ږ&Kp0', 'y3ږ&Kp0', ';Ur~<1ᇜt|MF+\ZMgH\r~.', '', 0, '?'),
 ('p)9\'»C', 'wp-content/updraft/themes-old/kallyas/template_helpers/update/update_config.php', 0, '\n=$櫻^', '\n=$櫻^', '|q:\'\0Ssh]7Be@Q', '', 0, '?'),
 ('i(PEcV', 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/general/general-vendor.php', 0, 'δA@JL<>', 'δA@JL<>', 'm&{Ͳl\0wx:}', '', 0, '?'),
 ('Ggh0m', 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/geo-directory/functions-geo-directory.php', 0, '!c_uo', '!c_uo', 'n3T{{eb\'QɾZ<.CH0', '', 0, '?'),
 ('OݙP镀;', 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/hogash-post-love/config.php', 0, 'z\rc\ZTI*da', 'z\rc\ZTI*da', 'SMv4*כSskw', '', 0, '?'),
 ('!Rȹ2j!', 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/sensei/functions-sensei.php', 0, '\'[H\nKJ܊', '\'[H\nKJ܊', '.b>\n:|xӳ꿄і', '', 0, '?'),
 ('Z>iImw6\0l[', 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/simple-job-board/functions-sjb.php', 0, 'QKuf\Z', 'QKuf\Z', 'aM+P@	|Uj|6Ӌ\0(', '', 0, '?'),
 ('kuiJFO*', 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/wp-hotel-booking/wp-hotel-booking.php', 0, '\03', '\03', '6\\vZx%ߪ#V', '', 0, '?'),
 ('cvG\\p]', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/twitter/OAuth.php', 0, '-M݋E}a', '-M݋E}a', 'IoXEh_NF$NT68#', '', 0, '?'),
 ('q]|)', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/twitter/twitteroauth.php', 0, '#SO4TcOP', '#SO4TcOP', '9[\'$2Ȗs\'@{@=r', '', 0, '?'),
 ('G\ZFj_ɘ', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-archive.php', 0, '%ذ3g&', '%ذ3g&', ')j҃{[j)SRhXiC;', '', 0, '?'),
 ('~I9ToCAr', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-blog-categories.php', 0, '+v,RW64\\nύ', '+v,RW64\\nύ', 'Fӧ6FiH?*$R\ZO', '', 0, '?'),
 ('}_	,	V', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-contact-details.php', 0, 'd@)D#;', 'd@)D#;', ',Ǉ-ߠ]XAwC\rvj(\0', '', 0, '?'),
 ('x&&Cc ]', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-flickr.php', 0, ':\nn\0X', ':\nn\0X', 'Tr=rL[vɃd5D', '', 0, '?'),
 ('l\'Z|G', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-latest_posts.php', 0, 'p2Jϣ', 'p2Jϣ', 'x*N2&VFln:b8', '', 0, '?'),
 ('@N6\0@l@', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-mailchimp.php', 0, '-qsU_a@k\\', '-qsU_a@k\\', '!:J9I*8wPGx\r\ZN&', '', 0, '?'),
 (';n`iɤ_,', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-menu.php', 0, '{:G\\3쪐', '{:G\\3쪐', 'N8y[r#^B1e_B$', '', 0, '?'),
 ('=)߿G`vʏ', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-social_buttons.php', 0, 'lG=49$p', 'lG=49$p', 'IAj6z܈Dlb	,y|Lr', '', 0, '?'),
 ('NI[2ΪZO', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-tag-cloud.php', 0, 'ɲQZy`x:', 'ɲQZy`x:', '}cop%!m}T~H>{', '', 0, '?'),
 ('1_P8K3sUo2hQ', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-twitter.php', 0, 'fyS-z', 'fyS-z', 'X-Zs$\'9?U3', '', 0, '?'),
 ('ZJnMvIҸ,', 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widgets.php', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('nX2V$mz`[', 'wp-content/updraft/themes-old/kallyas/template_helpers/zion-integration/class_kallyas_integration.php', 0, '}j2.\\', '}j2.\\', 'lχŧsw$5a\Z\"Ӯ0u-', '', 0, '?'),
 (':FAƞ:V', 'wp-content/updraft/themes-old/kallyas/template_helpers/zion-integration/kallyas-element-base.php', 0, 'o;Gm#', 'o;Gm#', '/r3Y`t#ީDkt', '', 0, '?'),
 ('3FDUU', 'wp-content/updraft/themes-old/kallyas/th-action-hooks.php', 0, '\nZO9\'', '\nZO9\'', 'xaTif26\0w}A@B<', '', 0, '?'),
 ('[ܱl$粫\0', 'wp-content/updraft/themes-old/kallyas/th-custom-hooks.php', 0, '0:\'0qSψG!', '0:\'0qSψG!', 'U2S%(>݋M1>ՋM', '', 0, '?'),
 ('ISp4y0uqS=', 'wp-content/updraft/themes-old/kallyas/th-filter-hooks.php', 0, 'W0t;qolHw', 'W0t;qolHw', '\ZjآN\\crijgjɚ', '', 0, '?'),
 ('E	%\"t', 'wp-content/updraft/themes-old/kallyas/theme-functions-override.php', 0, 'b hnr', 'b hnr', 'Z<n\'i:6oI\"gR\Z:I', '', 0, '?'),
 ('[g4sS1*,<V', 'wp-content/updraft/themes-old/kallyas/woocommerce/product-searchform.php', 0, 'Ɩ7ls|', 'Ɩ7ls|', 'l9CqȪhPw]NsJO}x+h', '', 0, '?'),
 ('?JcȌ*i^|NF', 'wp-content/updraft/themes-old/kallyas/woocommerce/product_gallery_v2/product_gallery.js', 0, 'K\r(ʛX', 'K\r(ʛX', 'R``\'>虧\rv؛\Zl_f', '', 0, '?'),
 ('K&+;_D', 'wp-content/updraft/themes-old/kallyas/woocommerce/single-product-default.php', 0, '=Uqpe+$', '=Uqpe+$', '}y<}XKW_XJ$}\0OO5', '', 0, '?'),
 ('k0ӑ', 'wp-content/updraft/themes-old/kallyas/woocommerce/single-product-style3.php', 0, 'lbę\'C{j', 'lbę\'C{j', 'm=i!91ɵ,~P\r0<f,x+', '', 0, '?'),
 ('4:WxM#>0', 'wp-content/updraft/themes-old/kallyas/woocommerce/woo_options.php', 0, 'W\rU%,RMJP', 'W\rU%,RMJP', '{}oSmXIr\rn', '', 0, '?'),
 ('SM/yu', 'wp-content/updraft/themes-old/kallyas/woocommerce/zn-woocommerce-init.php', 0, 'AK,.g\'|$z', 'AK,.g\'|$z', 'ʌ\n&6Q:TBݖv', '', 0, '?'),
 ('N\"S3bIM', 'wp-content/updraft/themes-old/kallyas/woocommerce/zn-woocommerce-v2.php', 0, '@F`78S^w?hV', '@F`78S^w?hV', '̔<3Rk*f #ۂhT%X&', '', 0, '?'),
 ('W-\'~&ސg\n', 'wp-content/updraft/themes-old/kallyas/woocommerce/zn-woocommerce-v3.php', 0, 'M8~?5pK', 'M8~?5pK', 'TcP/j`E/brR(n{', '', 0, '?'),
 ('Q)\"}w\"߉', 'wp-content/updraft/themes-old/kallyas-child/functions.php', 0, 'zqaP#	0-', 'zqaP#	0-', '-U&NSL$nA-*\0Ƭќ', '', 0, '?'),
 ('ovSK', 'wp-content/updraft/themes-old/kallyas-child/js/zn_script_child.js', 0, 'JR0«8N', 'JR0«8N', '[s4Fݑ7ևbW', '', 0, '?'),
 ('	ɛqb)ewC', 'wp-content/updraft/uploads-old/2017/03/client_01c.svg', 0, '4?)<CP', '4?)<CP', '8^8szS!TPH;g\nv', '', 0, '?'),
 ('=p?+NmڢA@`إ(', 'wp-content/updraft/uploads-old/2017/03/client_02c.svg', 0, '*<_jԍY', '*<_jԍY', 'G\rSƩ&QlO?l', '', 0, '?'),
 (':Ŝ}o_QӋ', 'wp-content/updraft/uploads-old/2017/03/client_03c.svg', 0, 'K\0(!&T$', 'K\0(!&T$', 'v\ni9Q8\08e\Z$X۠', '', 0, '?'),
 (']EBb', 'wp-content/updraft/uploads-old/2017/03/client_04c.svg', 0, '+υg-8`Ip', '+υg-8`Ip', 'EF<A25vl,b˰i|{D', '', 0, '?'),
 ('\\ei:	o', 'wp-content/updraft/uploads-old/2017/03/client_05c.svg', 0, 'h[IqBi->', 'h[IqBi->', 'M1+ 7ce=ҷ0甈{\Z', '', 0, '?'),
 ('\'cfTOG', 'wp-content/updraft/uploads-old/wc-logs/index.html', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('|Zk)6ؿ', 'wp-content/updraft/uploads-old/woocommerce_uploads/index.html', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('A[*w?#E5', 'wp-content/updraft/uploads-old/zion-builder/cache/index.html', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('%и4ȣp', 'wp-content/updraft/uploads-old/zn_fonts/icomoon/icomoon.svg', 0, 'HVx%I\n\r9', 'HVx%I\n\r9', '8l.go\"h\'Qk8#A\n.#', '', 0, '?'),
 ('~JկjLtB', 'wp-content/updraft/uploads-old/zn_fonts/icomoon/icon_list.php', 0, '\'+{|׹BJX?6', '\'+{|׹BJX?6', 'B\0M&U1ю\nTň+(d\n$', '', 0, '?'),
 ('\n-p7;a', 'wp-content/uploads/zion-builder/cache/index.html', 0, 'ُ\0	B~', 'ُ\0	B~', 'Bșo$\'AdLxRU', '', 0, '?'),
 ('&	PshcusS', 'wp-content/wflogs/attack-data.php', 0, '#ح\nyIb\r\r', '#ح\nyIb\r\r', 'l4Eq{\'wg31cw:', '', 0, '?'),
 ('5#t5RшK', 'wp-content/wflogs/config-livewaf.php', 0, 'wm;f)o7$', 'wm;f)o7$', 'S/8T&EHɼSu\\&C]M?', '', 0, '?'),
 ('8?6B\rpl2Rx', 'wp-content/wflogs/config-synced.php', 0, '7r !zb', '7r !zb', ';Yǧb\"t<YIszuw', '', 0, '?'),
 ('_V#Bt', 'wp-content/wflogs/config-transient.php', 0, 'jFd.M7', 'jFd.M7', '.A\0UE$U	pD{F*S8', '', 0, '?'),
 ('Un/|r@ڪ', 'wp-content/wflogs/config.php', 0, '<1G\0·Í', '<1G\0·Í', 'y\Z_{ipAcyF\"0', '', 0, '?'),
 ('Ao!Vų`v', 'wp-content/wflogs/ips.php', 0, 'lCdb.˴v', 'lCdb.˴v', 'Z][WP},7*q\nƑ', '', 0, '?'),
 ('!ES7x', 'wp-content/wflogs/rules.php', 0, 'dmk0g', 'dmk0g', 'X!I)7hwPD', '', 0, '?'),
 ('5#\"8%`}', 'wp-content/wflogs/template.php', 0, 'lCdb.˴v', 'lCdb.˴v', 'Z][WP},7*q\nƑ', '', 0, '?'),
 ('|\0J.Q\"cBWK+', 'wp-content/wflogs-old/attack-data.php', 0, '#ح\nyIb\r\r', '#ح\nyIb\r\r', 'l4Eq{\'wg31cw:', '', 0, '?'),
 ('ɮ@e#', 'wp-content/wflogs-old/config-livewaf.php', 0, 'wǳȿ#3$`', 'wǳȿ#3$`', '}`hR\")Lui5q^Fh', '', 0, '?'),
 ('՜T-', 'wp-content/wflogs-old/config-synced.php', 0, '7r !zb', '7r !zb', ';Yǧb\"t<YIszuw', '', 0, '?'),
 ('0Mij(', 'wp-content/wflogs-old/config-transient.php', 0, '_~k\'$J%', '_~k\'$J%', 'y]Sg4xBotP\0_W\n?', '', 0, '?'),
 ('o	,m7tD^L', 'wp-content/wflogs-old/config.php', 0, '<1G\0·Í', '<1G\0·Í', 'y\Z_{ipAcyF\"0', '', 0, '?'),
 ('^EOCBr', 'wp-content/wflogs-old/ips.php', 0, 'lCdb.˴v', 'lCdb.˴v', 'Z][WP},7*q\nƑ', '', 0, '?'),
 ('X1.y<$Vr', 'wp-content/wflogs-old/rules.php', 0, '\\aìw-HzB', '\\aìw-HzB', 'يU@\0oMД-ɦH*%[4', '', 0, '?'),
 ('xw&K3\"TO', 'wp-content/wflogs-old/template.php', 0, 'lCdb.˴v', 'lCdb.˴v', 'Z][WP},7*q\nƑ', '', 0, '?'),
 ('aOj\'ŻD*ցV4', 'wp-cron.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!qYS2N', 'x8	p5(#AM', '', 0, '?'),
 ('vόY9', 'wp-includes/ID3/getid3.lib.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.ҁ0(~H6', '#Bŗ,n!6;\nX~\ZO0', '', 0, '?'),
 ('d:wOІ', 'wp-includes/ID3/getid3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"{\'/\'P', '\\Md8^kL)JYЯ\'', '', 0, '?'),
 ('9ՍҢ9d\rY', 'wp-includes/ID3/license.commercial.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n;gJgxA', 't_2x<-˜wqIg', '', 0, '?'),
 ('}Ȑ\\L`i)', 'wp-includes/ID3/license.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GؐV%P_շ', 'I>a*R8?)p1U͔?2=o', '', 0, '?'),
 ('D.:\0SR8', 'wp-includes/ID3/module.audio-video.asf.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N~I6¦\rj', ';xy\\LU!eT4wz', '', 0, '?'),
 ('x	G!N$.dTb', 'wp-includes/ID3/module.audio-video.flv.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W/bם', '6\ZBpzw@0EvmC81', '', 0, '?'),
 ('oҨ*Ko7{ <', 'wp-includes/ID3/module.audio-video.matroska.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.kӟS[	', 'fvHc7UfHW`nkM^ֈ5+>', '', 0, '?'),
 ('Tvm?,aT4', 'wp-includes/ID3/module.audio-video.quicktime.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'O2PIuzM', '@Nzj.q/\Z\n]60c78^f4', '', 0, '?'),
 ('\ZvI:wm\'~K-', 'wp-includes/ID3/module.audio-video.riff.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^o\\ez4', 'Q&IW>JH껷^`rz[E+E', '', 0, '?'),
 ('L6	׳', 'wp-includes/ID3/module.audio.ac3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZtYLm', 'ҷP5Є^nbҎ(Iw', '', 0, '?'),
 ('ǳ\\_L-YŌ%$', 'wp-includes/ID3/module.audio.dts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|tTF8\0\n', 'ǎ:ǔ%(3z\0?lik-p', '', 0, '?'),
 ('@+T΄\'٤', 'wp-includes/ID3/module.audio.flac.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XåE>%uX', 'C_zyƞv_\r_(N2QcԢ*؉', '', 0, '?'),
 ('N@(3', 'wp-includes/ID3/module.audio.mp3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xn=	&-)\0 \Z', '۫-l0I7=h=\"Z_Q6', '', 0, '?'),
 (':|LH6(cg', 'wp-includes/ID3/module.audio.ogg.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S(Y՘ŧR', '52p,ae4nhvNOb:', '', 0, '?'),
 ('_)-]ˌkO	', 'wp-includes/ID3/module.tag.apetag.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'it-%', ' 0cڈd\"9_mZbו', '', 0, '?'),
 ('2zs4xEB', 'wp-includes/ID3/module.tag.id3v1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U.hwӪ', 'Hޒgߠi`Gܽ!٢h&)Mr', '', 0, '?'),
 (',@hjqrޒ', 'wp-includes/ID3/module.tag.id3v2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LÙR 0vg9)', 'k/T!	&pyxKhTxAGKz', '', 0, '?'),
 ('?8ZN', 'wp-includes/ID3/module.tag.lyrics3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7-r~>{', 'd:,P]\\1=cRźt%lz\0', '', 0, '?'),
 ('(~6vqV0{\"', 'wp-includes/ID3/readme.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݣzeѧѥk58', 'lrp4FBܢ7\"Z:Wv', '', 0, '?'),
 ('i;&o?', 'wp-includes/IXR/class-IXR-base64.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*6DTe', '?F]L2}\rS@b2OouU\'O', '', 0, '?'),
 ('	ӭgȱ!nP', 'wp-includes/IXR/class-IXR-client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QģKAϲ]ڎuYQ', 'UF\"GM|L&8K::Dot', '', 0, '?'),
 ('dxeBݙϟ5', 'wp-includes/IXR/class-IXR-clientmulticall.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3@S\n_', '!YMxmՒO', '', 0, '?'),
 ('Z=ӧrc\"y', 'wp-includes/IXR/class-IXR-date.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IVdB+AJ?#', '{~(#\Z6u,?jk2`', '', 0, '?'),
 ('^H\0B|4@z', 'wp-includes/IXR/class-IXR-error.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g6\"u\\\'3b', '*?ۧU=?,]0=CZ-6Dq.G', '', 0, '?'),
 ('$ϫ/!C', 'wp-includes/IXR/class-IXR-introspectionserver.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2Uaw<IwpO7-', '\nCPEQ%D\rk*Xo', '', 0, '?'),
 ('~%B\0z?o', 'wp-includes/IXR/class-IXR-message.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|Ln}D14', 'ly}z.jxm:Ul`', '', 0, '?'),
 ('w\ZdϢ\ruD\"', 'wp-includes/IXR/class-IXR-request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%p.<Sǡz1Ϣ', 'Q*k_}2>Tq<_S:Qh', '', 0, '?'),
 ('alV?f\Zё', 'wp-includes/IXR/class-IXR-server.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E]Բ[̌}[X', '5T4]\ZH~6,tt', '', 0, '?'),
 ('3ng\0\\\0	W', 'wp-includes/IXR/class-IXR-value.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f>5lj\0f', '?h͇ XUPO|H$1', '', 0, '?'),
 ('\\MMF/I', 'wp-includes/Requests/Auth/Basic.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gx̄	4U	k!C', '.йhdBiHɀns᝗\\O', '', 0, '?'),
 ('J>\"/', 'wp-includes/Requests/Auth.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1RWÔO[J', 'bOQwùLѠâ9Qlrl', '', 0, '?'),
 ('i1E~NIA͔', 'wp-includes/Requests/Cookie/Jar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0_&p\"4\\', 'c!#Bi*+\"\rnIƈXÉw', '', 0, '?'),
 ('S^7jK5I6K2!', 'wp-includes/Requests/Cookie.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']4GFdW(', '1׋0*E3:/2pկ\0K2^(', '', 0, '?'),
 ('O­\n	URb', 'wp-includes/Requests/Exception/HTTP/304.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';F4AIT', 'vC	a\'F;z(eJL', '', 0, '?'),
 (' <@s\rF/', 'wp-includes/Requests/Exception/HTTP/305.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X\0K/`,&', 'HƎ+@Ib^=QvM6_iL', '', 0, '?'),
 ('8P֧\ZHGE}8', 'wp-includes/Requests/Exception/HTTP/306.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WszuNPjXu', '4UQ\r1#_fH*Idl', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('HYfUHupd', 'wp-includes/Requests/Exception/HTTP/400.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QnVJRx5', 'd>	iHb$&n6p\Z', '', 0, '?'),
 ('/}㦿L;?w\\', 'wp-includes/Requests/Exception/HTTP/401.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';*?d@', 'YV$/@=V-dc', '', 0, '?'),
 ('*\\Tҝ)%]yiD+', 'wp-includes/Requests/Exception/HTTP/402.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`YQP\nzG', 'gNQ	/	y5θc', '', 0, '?'),
 ('l3.	XN', 'wp-includes/Requests/Exception/HTTP/403.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`\rok31', 'IlEKѦ?Z0JTU', '', 0, '?'),
 (';#	n%\"', 'wp-includes/Requests/Exception/HTTP/404.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cY\0ys<M', '-!V>d*jPF	;QƵN1aG(', '', 0, '?'),
 ('Ybڧ,J', 'wp-includes/Requests/Exception/HTTP/405.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8тm!Ҭ', 'jb횄^Usv8$bM3y', '', 0, '?'),
 ('Fj]p Ac\rp', 'wp-includes/Requests/Exception/HTTP/406.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Klhr9\"\0', ',aY}PR6`)Kfism ', '', 0, '?'),
 ('NtKU', 'wp-includes/Requests/Exception/HTTP/407.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vj&Ƶ', '>\Z]ƚB̏Xvذc.N2NҹЯ', '', 0, '?'),
 ('\0n:Tq}K @', 'wp-includes/Requests/Exception/HTTP/408.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@>1dIXOȷv', 'q*lmKңk\"MQ?pa؂4', '', 0, '?'),
 ('Xv\Zƒ\"$', 'wp-includes/Requests/Exception/HTTP/409.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Zi~*=', '_M8U.pFw:E`MB', '', 0, '?'),
 ('T양:t[', 'wp-includes/Requests/Exception/HTTP/410.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qO47ߺݥ/8X!', '9f/3MM;#GڪWO&tSO\ZƘ', '', 0, '?'),
 (')|{4+]X(', 'wp-includes/Requests/Exception/HTTP/411.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'RM.Z`G', 'U^9p&`nM{ nL', '', 0, '?'),
 (')Yh.;š', 'wp-includes/Requests/Exception/HTTP/412.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%Iܷ=7V', 'SA4c\\D56-#d*ҽӾR', '', 0, '?'),
 ('	.5uaWkJ', 'wp-includes/Requests/Exception/HTTP/413.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<]ɐYXL', '\r}䟹-V\'eCCʅe-2,0', '', 0, '?'),
 ('[Y44Orl0', 'wp-includes/Requests/Exception/HTTP/414.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']U@)#h', 'Hic!I).eh', '', 0, '?'),
 ('}^72', 'wp-includes/Requests/Exception/HTTP/415.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XTb̮JU', 'v%_\0b$m&`(=m<b\Zo0p', '', 0, '?'),
 ('gK;qFVI}Q', 'wp-includes/Requests/Exception/HTTP/416.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1N9ɪaDx', '(mybVaIjWp(!A<(X', '', 0, '?'),
 ('P&_#\'zTs', 'wp-includes/Requests/Exception/HTTP/417.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BpjhO^c\\G #', 'LTҘ$xDs^h_!kC\"1\'_', '', 0, '?'),
 ('DCF}', 'wp-includes/Requests/Exception/HTTP/418.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J![4', '4 6鎬M&$!2d<\\	|\\?g\n', '', 0, '?'),
 (']PJQƀ6o֢;', 'wp-includes/Requests/Exception/HTTP/428.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iB}^t*', 'COW%tߏY|&0V\\', '', 0, '?'),
 ('O/ì`|g_\0', 'wp-includes/Requests/Exception/HTTP/429.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S%|F.àZd', '!Tuwmt5o\n2A\"kߚz', '', 0, '?'),
 ('ʚ{(\\i7.', 'wp-includes/Requests/Exception/HTTP/431.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's|b$ѓ<', 'ꅱ/Y6_wpkw0', '', 0, '?'),
 ('\rfh8!', 'wp-includes/Requests/Exception/HTTP/500.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'km\n	HM', 'FOV3\"!kP', '', 0, '?'),
 ('l;ao~G', 'wp-includes/Requests/Exception/HTTP/501.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eڸ04-?ב5', 'kG寲\n΃CD#6u\ZքEڣ@K1', '', 0, '?'),
 ('bm%ڭ֫', 'wp-includes/Requests/Exception/HTTP/502.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|:lz!{Gi', '/~UJO.ŀ#E5*\'Cq', '', 0, '?'),
 ('nŢ)cq^\"', 'wp-includes/Requests/Exception/HTTP/503.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9RaßC`\0UT', '}=3xA9lp\0ư9e.O', '', 0, '?'),
 ('Oy}Ma_I', 'wp-includes/Requests/Exception/HTTP/504.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm̪Db *', '<!B|$k݈# ei%0', '', 0, '?'),
 (' \r$	Q^C(', 'wp-includes/Requests/Exception/HTTP/505.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']A	3[/Cd', '⭛ i{PA͆kdM\n', '', 0, '?'),
 ('uG#)|^6', 'wp-includes/Requests/Exception/HTTP/511.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'unN<KwЛ@', 'I}7+ƕAl欿Bt\'st', '', 0, '?'),
 ('>2\\o)', 'wp-includes/Requests/Exception/HTTP/Unknown.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dl᫁2A\nW', '@3#\Zж/*t\r6<X\rIF', '', 0, '?'),
 ('W>ҟ[', 'wp-includes/Requests/Exception/HTTP.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hRlr', 'oE²tQQbo\nrQq\"/', '', 0, '?'),
 ('Iy-\nń', 'wp-includes/Requests/Exception/Transport/cURL.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6Tg*\Z:	x7', ']0֙8p#~\\oӁ=1', '', 0, '?'),
 ('rIɀ5 F', 'wp-includes/Requests/Exception/Transport.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lz J^', 'ĺ̌&ֳ4@78p', '', 0, '?'),
 ('TĘ5VHP{', 'wp-includes/Requests/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\03\ZRI', '-@g %uON\\}@lf\'', '', 0, '?'),
 ('.Q}3T', 'wp-includes/Requests/Hooker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@%a[ў/4', 't\r{k?ikC\nLḃWy', '', 0, '?'),
 ('XMxڳJ', 'wp-includes/Requests/Hooks.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ', gxi', '՚ Q憐DP؂_?y`', '', 0, '?'),
 (' \\Tn]', 'wp-includes/Requests/IDNAEncoder.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}2Pر', 'M?~\"u%[,l+?F-}M)', '', 0, '?'),
 ('TB3G{', 'wp-includes/Requests/IPv6.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KNknT', '=ln&ăJӗ~l', '', 0, '?'),
 ('}z#\Z', 'wp-includes/Requests/IRI.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '52]{}	`X', 'I?~4]4KF\"vI(', '', 0, '?'),
 ('w\'PeF+V\0', 'wp-includes/Requests/Proxy/HTTP.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/2)', 'J6dAl{Й\0Jh', '', 0, '?'),
 ('#yt($NTt', 'wp-includes/Requests/Proxy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@k7\0t\\*G', 'w<PBZCkSIQ!\n}i', '', 0, '?'),
 ('G Xexw0\\o8', 'wp-includes/Requests/Response/Headers.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZÂҶA->c`', 'E\nF		M%{a`,', '', 0, '?'),
 ('Yf/pw', 'wp-includes/Requests/Response.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pR櫷\'G', 'WwYKL\n	-*^e\"e(_,g', '', 0, '?'),
 ('U $A=He|zȖ(', 'wp-includes/Requests/SSL.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&Pg\'A6(07TO', '\nQ4Hw@8<Sn-GaMRAӯ', '', 0, '?'),
 ('c42jxcd', 'wp-includes/Requests/Session.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7݆Ζ}l', 'e`݆.΃:jE\ZҰ5\Z)', '', 0, '?'),
 ('`@YE!', 'wp-includes/Requests/Transport/cURL.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '87a`CZ', 'hI x<%ji$', '', 0, '?'),
 ('fBDFr\r\r', 'wp-includes/Requests/Transport/fsockopen.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>rQHˆV', 'XicR)RǠ.#`jjŏ3?', '', 0, '?'),
 ('.IOIP%)', 'wp-includes/Requests/Transport.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';kK\\Vl', 'ɯO3eF㛆v+.r/>,', '', 0, '?'),
 ('~AHgKT', 'wp-includes/Requests/Utility/CaseInsensitiveDictionary.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':RKroH2z', '9yԆ&/AXHi{b7frw=m', '', 0, '?'),
 ('/?U', 'wp-includes/Requests/Utility/FilteredIterator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ax%Ay', 'LCUhU;4n}Rmx;Č', '', 0, '?'),
 ('k5SHЫ', 'wp-includes/SimplePie/Author.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4q_A%Nw1', 'n#O/jbwP&i#_`YО', '', 0, '?'),
 ('U\\p{JOQ&', 'wp-includes/SimplePie/Cache/Base.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C2]]#|j', 'ookj\\0[-d8;\Z3', '', 0, '?'),
 (',hɃs?4B[^՝', 'wp-includes/SimplePie/Cache/DB.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YOU.b', 'd*Y®s<!)܃J¬', '', 0, '?'),
 ('V,E@Xy', 'wp-includes/SimplePie/Cache/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=@B[	S', '9!+Y6L$-fq&趇kh', '', 0, '?'),
 ('I:4PU', 'wp-includes/SimplePie/Cache/Memcache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JU1SQ?', '}kJ?dA<aC3:[', '', 0, '?'),
 ('<)8T*.SuSĺ', 'wp-includes/SimplePie/Cache/MySQL.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BC\ZHxV', 'tAB٠B=)RhO\"g;', '', 0, '?'),
 ('Y֝U}r/', 'wp-includes/SimplePie/Cache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y:oMhvL4', 'w!ے?ERS^RLKA', '', 0, '?'),
 ('\"ܒnzD', 'wp-includes/SimplePie/Caption.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BjMg[', 'Ab\'L?QLrt\"2Ϋ', '', 0, '?'),
 ('qKUj', 'wp-includes/SimplePie/Category.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~?.\nܯd*', ';е=S@dc]rRּn <6', '', 0, '?'),
 ('l&*&', 'wp-includes/SimplePie/Content/Type/Sniffer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|riUblw3', '6%\"\\\\4N*F`Γ\rL*=', '', 0, '?'),
 ('anV=Ty X', 'wp-includes/SimplePie/Copyright.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hT	Ùj', 'b_$4_m2BJ\\5ߏ\"%	N', '', 0, '?'),
 ('oǣ	ףf0Y', 'wp-includes/SimplePie/Core.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#\Z', 'K 5(Їϻ\n-\"}x$f]. b', '', 0, '?'),
 ('ͽ3=OG|~', 'wp-includes/SimplePie/Credit.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M猋*>\n|', 'N3$Z,!<!9\"', '', 0, '?'),
 ('POf;/', 'wp-includes/SimplePie/Decode/HTML/Entities.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E^/\rBZ#%/a', '\0+0ߨP;PO\'^p|NsN6d', '', 0, '?'),
 ('2^(ʭ-^x', 'wp-includes/SimplePie/Enclosure.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.Bn΍Ks]', 'MHڋTYQ6cf|h', '', 0, '?'),
 ('\nfv81-I', 'wp-includes/SimplePie/Exception.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	Kv&<\\ڏS5', 'w\'TOE[q:Sk! ˎ\\', '', 0, '?'),
 ('4r%j', 'wp-includes/SimplePie/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kU6\n+)%', 'a.%e5+p3d^bLLT', '', 0, '?'),
 ('Pط悇̺ƴ$@', 'wp-includes/SimplePie/HTTP/Parser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W%466	', 'E@̣Bnb8ϜNW%', '', 0, '?'),
 ('oZ0<c0', 'wp-includes/SimplePie/IRI.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n 憒;a{_6', '`VCS5Iٮ\Z;&>x$-&z+', '', 0, '?'),
 ('feR)', 'wp-includes/SimplePie/Item.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E!Cz\0c<ܧ', '1K6]Lݲ]`rS{Ul', '', 0, '?'),
 ('TBO>v2}Ea', 'wp-includes/SimplePie/Locator.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's;uvf^', '<Ό:9/(\\֎tl]ǳ^82', '', 0, '?'),
 ('FFvV;v8/\r', 'wp-includes/SimplePie/Misc.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y-^\ZK', '[JKǺn3`,\0d,m', '', 0, '?'),
 ('MjAMO\"If', 'wp-includes/SimplePie/Net/IPv6.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Fy!jـ', 'i*8.yPB\ZYe', '', 0, '?'),
 ('Bهv<Sv稳', 'wp-includes/SimplePie/Parse/Date.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')K(a7XȫP', 'Jc=[)K5\0,S*:F\0', '', 0, '?'),
 ('tfF	r{܇_Ix', 'wp-includes/SimplePie/Parser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R.b~+', 'J22<c8ezdK^đr<T{#w', '', 0, '?'),
 ('dhħ{q42K\"', 'wp-includes/SimplePie/Rating.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=pm	Kدat', '\r[jjՂrVh`FrES{b', '', 0, '?'),
 ('}7 ޘDHDPl', 'wp-includes/SimplePie/Registry.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ȣ1v9d\0ٸ', '٘Ǎ++NTbRs', '', 0, '?'),
 ('\0`YϭrG', 'wp-includes/SimplePie/Restriction.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*qhds;y', 'u\\Qi窍gDH	;\0', '', 0, '?'),
 ('[1YAdk,', 'wp-includes/SimplePie/Sanitize.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BظFإHu', 'D>Ι+N\ZF|#4m=9cu', '', 0, '?'),
 ('0lj0+%', 'wp-includes/SimplePie/Source.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S{*', '47Mj9|\0i&ĨLu!J', '', 0, '?'),
 ('\'g!:H),', 'wp-includes/SimplePie/XML/Declaration/Parser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p(ÅBs#b', 'v_6+q)ź(1),', '', 0, '?'),
 ('ZҌ[\nv	F', 'wp-includes/SimplePie/gzdecode.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8aal4', '\Z93Euf\0/\\Tk&oH', '', 0, '?'),
 ('OhuG&\0L', 'wp-includes/Text/Diff/Engine/native.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S\r$T', 'S\04v@ű`DG VueRB竇3', '', 0, '?'),
 ('ǂ-i).\\z^a', 'wp-includes/Text/Diff/Engine/shell.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z޵Ҷ_OoUC', 'uN/I$>ggIA$', '', 0, '?'),
 (' @;*|', 'wp-includes/Text/Diff/Engine/string.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':=M\0i)', 'd[%nZR`', '', 0, '?'),
 ('e^#|ۍTЩz', 'wp-includes/Text/Diff/Engine/xdiff.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ֹbtX8GX', '[<0ąaD)tJh(C[uH}sҘi', '', 0, '?'),
 ('&Rw?~jhJD', 'wp-includes/Text/Diff/Renderer/inline.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nn5PB\'', 'XU.k⻺@-(5NV', '', 0, '?'),
 ('3fQ3h5[W<', 'wp-includes/Text/Diff/Renderer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' C0Y7O@GS', 'EWj+\\=}.1\r|', '', 0, '?'),
 (']B#2zbU/', 'wp-includes/Text/Diff.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lp՞n7q*', '7	iHꗓM233} E҈', '', 0, '?'),
 ('-kdϯXw\\7', 'wp-includes/admin-bar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=?Z;w', 'KjO \"_v7<=7\nZn', '', 0, '?'),
 ('Otg\02\\B', 'wp-includes/assets/script-loader-packages.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '򨁁mHAhB?', 'E\"=.kS5D4j9.]\rYllM', '', 0, '?'),
 ('Gu^/1ՁS7', 'wp-includes/atomlib.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>B/ݯAz)AM', 'HLƻӛv$qD$dt', '', 0, '?'),
 ('&S짿o$0n', 'wp-includes/author-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'sn	Cd:', 'iNz	&a^RJ.1', '', 0, '?'),
 ('>6bYAUF.', 'wp-includes/blocks/archives.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '鼥Q&75', '\r+yry ?t{', '', 0, '?'),
 ('>5ˏ.y2Q[ڣ1', 'wp-includes/blocks/block.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7wեm`\nw', ',,}\'\\OnCG|	7ޛC', '', 0, '?'),
 ('SzWNKUS', 'wp-includes/blocks/calendar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nMdmh\n', '-rlvXֲyFW\0R5[', '', 0, '?'),
 ('(ЊQB&Q?', 'wp-includes/blocks/categories.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C *=/J3:}zy', '[`G!=at\rA)))2ŉ;', '', 0, '?'),
 ('u${ܨv', 'wp-includes/blocks/latest-comments.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~tŗ LO', 'A}@Xvު>_68/5<', '', 0, '?'),
 ('1\nx', 'wp-includes/blocks/latest-posts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '],j\r-0', '57\'$1ǹtXBS', '', 0, '?'),
 ('4B\07qoBo6', 'wp-includes/blocks/rss.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ш-p*8@', '\0\0Qw>K+r8DZ3/ң<V', '', 0, '?'),
 ('^}R	V7{WI\rH', 'wp-includes/blocks/search.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'ԐNfc', 'TPBvE:R7-A=\\áF	Wt', '', 0, '?'),
 ('苼3', 'wp-includes/blocks/shortcode/block.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sc', ']ج{?HĊl4v9%?]/', '', 0, '?'),
 ('NFVYC', 'wp-includes/blocks/shortcode.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3]6>', 'T/%^)FM..e5 3hu', '', 0, '?'),
 ('L\r%{', 'wp-includes/blocks/social-link/block.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n`p0', '᎟\0lyä\0V5&Ab\nS\'	6Vc', '', 0, '?'),
 ('K>^[PF1h:', 'wp-includes/blocks/social-link.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_^1#\0%;', 'Tu\\DK\"ЇkFu\r`F', '', 0, '?'),
 ('u:z2DQ4', 'wp-includes/blocks/tag-cloud.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Tźi|.#p', '#5UHXhN7ň0}', '', 0, '?'),
 ('dAuh041', 'wp-includes/blocks.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wrm0D٨', 's0X:-ϑǽB&XD', '', 0, '?'),
 ('>slWD7M', 'wp-includes/bookmark-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&]*Q\"P', '{\0&*77?eNm{w\"ot{dm~}', '', 0, '?'),
 ('\0>#z(', 'wp-includes/bookmark.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Sp-T', 'F&;f4h\n\Z=k%', '', 0, '?'),
 ('ǅ99:\Z', 'wp-includes/cache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1~@,Ԓl`Y.', 'lz.mՌb\"(ق:?8_H\r', '', 0, '?'),
 ('2G?_\\-B', 'wp-includes/canonical.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2f![꽶>', 'L-y[TQ)Rl}%O[', '', 0, '?'),
 ('YCooR亞', 'wp-includes/capabilities.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pqJk', 'b?+(IUB/jIVlGqBE	', '', 0, '?'),
 ('jI<꟟iU', 'wp-includes/category-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UOѬL;8lV?', 'KSsC91*W#ô#', '', 0, '?'),
 ('D5\n\'\\~W', 'wp-includes/category.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6\nwN\nx', 'Ȉ^4\rڍu\\u/ ', '', 0, '?'),
 ('mDTmsA}', 'wp-includes/certificates/ca-bundle.crt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Gt5G}@', '~y>=w˃\089cS$y', '', 0, '?'),
 ('Jy0m`/', 'wp-includes/class-IXR.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0C`qx', ']zpqN\"CKW鴛cM', '', 0, '?'),
 (':<$0,w\"&e({', 'wp-includes/class-feed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>yܫ]T', '8j2yN!qʩpt\0A2\\Y', '', 0, '?'),
 ('!@|4n', 'wp-includes/class-http.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R[JPls', 'ȋ|\ZZ	w۱|֘X', '', 0, '?'),
 ('&Zh$Éo', 'wp-includes/class-json.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.t$]N[', 'G/U/INX.Ps7W;Hj)(', '', 0, '?'),
 ('EQ?	(', 'wp-includes/class-oembed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j,;\Z3x', '0v!vv7HlVdi\'K', '', 0, '?'),
 ('	QW~-\0d', 'wp-includes/class-phpass.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_͂tWQ1aL', '@FYvG^\n}/$O~;a\0M', '', 0, '?'),
 ('8ڧs}նNi', 'wp-includes/class-phpmailer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')Jr>I\\9@', '\\9sQǀ!%^K5;*', '', 0, '?'),
 ('\"u>17', 'wp-includes/class-pop3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U$C;Gp', 'zSI~3oM8#>', '', 0, '?'),
 ('*7\r?', 'wp-includes/class-requests.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h̵	&|e', '1oXHwۦG~z', '', 0, '?'),
 ('\\ Iѻ,', 'wp-includes/class-simplepie.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '02jtH9v', 'A~Hn36S6hzFegĠ	ziZ', '', 0, '?'),
 ('Κ,Qagl\Z', 'wp-includes/class-smtp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eE4ĎZE2', '-c9do-qmJvP3', '', 0, '?'),
 ('e__%x', 'wp-includes/class-snoopy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's\\Ņϼ.	`', '4	*\0\n;0rɷw', '', 0, '?'),
 (')ũ2[	4_a', 'wp-includes/class-walker-category-dropdown.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ap-6?!G', '+_0^%2\n {#)&w', '', 0, '?'),
 ('cnxԺ|', 'wp-includes/class-walker-category.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HK\'D\'X', '׹9l&A*.ڛA}6TZ', '', 0, '?'),
 ('KK+2	aeZe', 'wp-includes/class-walker-comment.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j%ӻ:36Je', '6S\"UJ\0uki', '', 0, '?'),
 ('(觨:pR/', 'wp-includes/class-walker-nav-menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(T	i', 'z8ED:Ƥ̽׍¢\0Gb', '', 0, '?'),
 ('J\rӷG>', 'wp-includes/class-walker-page-dropdown.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tBB2[eJ5a', 'YDs4I<Atȃ\ZG.', '', 0, '?'),
 ('5S{TƁe/', 'wp-includes/class-walker-page.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^s9Ϻ', '&n\rnX<ڠsRuQf=fNi', '', 0, '?'),
 ('ֶ9؞fpo3t', 'wp-includes/class-wp-admin-bar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j^@x0', 'u<JF\Z=N&e[oOPK', '', 0, '?'),
 ('ֻE\n<B[,', 'wp-includes/class-wp-ajax-response.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TQJtr\0', 'cub6(	Y8$_̾y]S]ͧ;', '', 0, '?'),
 ('Z)_w\'$X', 'wp-includes/class-wp-block-parser.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LxH,', 'R>oұz\\9	V', '', 0, '?'),
 ('@k&XItǜ', 'wp-includes/class-wp-block-styles-registry.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h<,e^X', 'qE-%3螔vL._]wsac', '', 0, '?'),
 ('4l!r؄', 'wp-includes/class-wp-block-type-registry.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$E6oa#', '$\'<EN0HO5$:}', '', 0, '?'),
 ('gزh/ḮON', 'wp-includes/class-wp-block-type.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T]x', 'urrcm ONr#^X\'3', '', 0, '?'),
 ('\nӛIQED	', 'wp-includes/class-wp-comment-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4JTԀ\\E', 'v/ւtP\r& \'	O\"(V|ib', '', 0, '?'),
 ('Tr~W]', 'wp-includes/class-wp-comment.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>۴w1P[gD', 'MmFwIH\nsBQu C0', '', 0, '?'),
 ('ȍP 3\n', 'wp-includes/class-wp-customize-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l\0zHPQom', 'm$;6\Zh\":wT9ZE)', '', 0, '?'),
 ('h\ZOhl_Lm/', 'wp-includes/class-wp-customize-manager.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TqT3\rzAz', '_{pɼ\r1*6\nGQ|GyH', '', 0, '?'),
 ('`U2mdW', 'wp-includes/class-wp-customize-nav-menus.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JH_#&L~y{Z<Q', 'tdv86Nf{C&x\"x%+x', '', 0, '?'),
 ('\rҧxOzzh', 'wp-includes/class-wp-customize-panel.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')VI^	R(r', '=ȓ/ع,XY4|	x', '', 0, '?'),
 ('-x(EoI=', 'wp-includes/class-wp-customize-section.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`;V\'()', '<sJmha!U\0(0D\'F', '', 0, '?'),
 ('fu3\nM\\}6*0', 'wp-includes/class-wp-customize-setting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^5Ed%', '꺻Hz\n5~Re', '', 0, '?'),
 ('Jёe\rXd$', 'wp-includes/class-wp-customize-widgets.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`\Zs=)r', '+?M w~ZDh\n~\'N?\\N', '', 0, '?'),
 ('Za9Uzն', 'wp-includes/class-wp-date-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dA>yo:zf', 'ac#z{﹥偱SdOs', '', 0, '?'),
 ('jgs66$8*E', 'wp-includes/class-wp-dependency.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n43Y\\#', 'I>|~[te_OeĬ%*', '', 0, '?'),
 ('ɱ%a{Zj	%', 'wp-includes/class-wp-editor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '週B>XQI', '\n@o\Z\'<7L.W\"tХj', '', 0, '?'),
 ('5`]\\ͭi\0\ZJT', 'wp-includes/class-wp-embed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e\ZL#eSշ[ƕ', '#	F?tVbSZDNޠip:', '', 0, '?'),
 ('k{&x\n', 'wp-includes/class-wp-error.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=[^#_I\rHk', 'eq3XlniSvT1\"6xL', '', 0, '?'),
 ('0xhͭK3T', 'wp-includes/class-wp-fatal-error-handler.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2qPV', '\\oa} ,&d\nJۿOY', '', 0, '?'),
 ('O =(:<	1F', 'wp-includes/class-wp-feed-cache-transient.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x?^>O', ':;h!xEzP+dV0D', '', 0, '?'),
 ('֌qóX[', 'wp-includes/class-wp-feed-cache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z-}w@', '/ jZU7fnY[', '', 0, '?'),
 ('#Dń5%', 'wp-includes/class-wp-hook.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Np}f$l', '\rO=X	ǍJU-#rtumW', '', 0, '?'),
 ('&B5VAUU,', 'wp-includes/class-wp-http-cookie.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ϴB', '#dgt](Kh\Z`{%:r]y', '', 0, '?'),
 ('#iJH?@', 'wp-includes/class-wp-http-curl.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ӄ>_2', 'J<uF9F{|挷l', '', 0, '?'),
 ('MO,s\r', 'wp-includes/class-wp-http-encoding.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R.u*#<D', 'F4HҒD<Ukd\\c/', '', 0, '?'),
 ('uXݼ#-', 'wp-includes/class-wp-http-ixr-client.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.5v@]bڏ', 'sKƣ{mr6\n>dnm', '', 0, '?'),
 ('gf1۶y;_', 'wp-includes/class-wp-http-proxy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?!^3\"', 'bmVhA/^n=Q\'5Bd', '', 0, '?'),
 ('@M]\"iNJ', 'wp-includes/class-wp-http-requests-hooks.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lf	=oUN\'d', 'x\"\r6<ϣ1 \08*u42Ń^-', '', 0, '?'),
 ('B yw+|t', 'wp-includes/class-wp-http-requests-response.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OTP^rbb!d', '\Z[Щǩ{S.Ws:e\"#z[N', '', 0, '?'),
 ('ڷtgZgE', 'wp-includes/class-wp-http-response.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4yKߕ', 'Ι	[{\0If\0tv\n9dx', '', 0, '?'),
 ('߰Sh[۳', 'wp-includes/class-wp-http-streams.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eB<zV%ấ Qo/c', 'iC\"j@a?|Z NM?', '', 0, '?'),
 ('>X\rbڟ$W', 'wp-includes/class-wp-image-editor-gd.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S$FPKu~', 'G]({ܻœV:9o.\\', '', 0, '?'),
 ('^bRSI!?', 'wp-includes/class-wp-image-editor-imagick.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Wn;Ǎb ', '߁H_FWkmCDܷu', '', 0, '?'),
 ('T\ne.(', 'wp-includes/class-wp-image-editor.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C<%58s,$?)', '.#vSaq\\)=a*', '', 0, '?'),
 ('`Sk7TtvX', 'wp-includes/class-wp-list-util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=:WE^=`', 'Ū\\ͷb4t}fuN', '', 0, '?'),
 ('LzZ#<', 'wp-includes/class-wp-locale-switcher.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"?Fw,T', '!@B<6ꁒKuPm=+/c_', '', 0, '?'),
 ('1l< t~LUw', 'wp-includes/class-wp-locale.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r13P{>B\'', '[?1\0ͽ!I,̃6', '', 0, '?'),
 ('\"qUy9%Q', 'wp-includes/class-wp-matchesmapregex.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4Ѯ_Z', 'F0~uAG\Zh2rkI)Ьc!', '', 0, '?'),
 ('Guʭ', 'wp-includes/class-wp-meta-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tBh)ZX*-鏼', '0&_^w)xySֳa5Y', '', 0, '?'),
 ('\Z\Z:\\RfP~3', 'wp-includes/class-wp-metadata-lazyloader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rLӏ..+d', 'rkΩכ?ir A:$TvG6[d', '', 0, '?'),
 ('wh]á&wM', 'wp-includes/class-wp-network-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IwM햰QVTr', '\"zϞ\"rԋr{p&G$u', '', 0, '?'),
 ('8ܞt\ZwNxa', 'wp-includes/class-wp-network.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'sMyc5`', '*&5=V<̱hQ\'G_ʖ', '', 0, '?'),
 ('U}B	Js', 'wp-includes/class-wp-object-cache.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vhp0qe@c`rn', ',?*`)Q}W AΡ', '', 0, '?'),
 ('P@;b<\nc', 'wp-includes/class-wp-oembed-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F', '>Q`S+<n\'M3д7P 媺}R', '', 0, '?'),
 ('CMp<E', 'wp-includes/class-wp-oembed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{T/;y|lt', 'cpRNȑ%Y01yfJ=\" -}', '', 0, '?'),
 ('@AO=	yA', 'wp-includes/class-wp-paused-extensions-storage.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%\n)&\"24NXQ', 'ٱ#qf~y&tcWq', '', 0, '?'),
 ('~VXa]7p|R', 'wp-includes/class-wp-post-type.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dsK|\\`T,BЖJ', 'O.!>\0Pn\n\\`(+2virR', '', 0, '?'),
 ('~ReOXf2`', 'wp-includes/class-wp-post.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OP/\r?Sޤ	', '[?>C=FQ6.Doh*^', '', 0, '?'),
 ('-h\n\r`ýەC/s', 'wp-includes/class-wp-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0>_yr4HSW', 'XP{>#E]	y_e', '', 0, '?'),
 ('t/Ji6WX', 'wp-includes/class-wp-recovery-mode-cookie-service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|p-No!H{', ';竿SgmX\"AM5U<Fbse*', '', 0, '?'),
 ('m|yb', 'wp-includes/class-wp-recovery-mode-email-service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']3x,4', '1&!.D=^-:_o׃ UN', '', 0, '?'),
 ('y&EzݜZy׺ڲ', 'wp-includes/class-wp-recovery-mode-key-service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ͻ}PZ:?', '}lfT|YsYUσ#', '', 0, '?'),
 ('qLILc', 'wp-includes/class-wp-recovery-mode-link-service.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@9%![', 'aУ+(|sѠ3n=~igR', '', 0, '?'),
 ('`,}D@', 'wp-includes/class-wp-recovery-mode.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6xW3Ң	', 'U>I*fF}`b\r@', '', 0, '?'),
 ('M\ZH?ͲZ', 'wp-includes/class-wp-rewrite.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|~&B6v=', 'P13^,wURfU?', '', 0, '?'),
 ('\nfӅ;{t', 'wp-includes/class-wp-role.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '܈@(/Yn', '\n~`t+ \rp<g\\x\"y;', '', 0, '?'),
 ('ǀ3<&YĆ', 'wp-includes/class-wp-roles.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[aG5>yjW', ';.\\51NKޤ~B~\r<ż', '', 0, '?'),
 ('x(ťܺ.Շ', 'wp-includes/class-wp-session-tokens.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TeÜ)u6', 'ۘ\\1ZA8T%h0.7n1', '', 0, '?'),
 ('ސqic=', 'wp-includes/class-wp-simplepie-file.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"@9,i', 'HC!AMI$۷r7=:E8ѹc', '', 0, '?'),
 ('<.4vc\"`t', 'wp-includes/class-wp-simplepie-sanitize-kses.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Rɔz-*X{<', '%%w\n븘N*$aԀ(\\', '', 0, '?'),
 ('W=ԘHdz', 'wp-includes/class-wp-site-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ќ+Ԥ=|', 'WP{ˏuME \"1*I', '', 0, '?'),
 ('b~5aI@)*', 'wp-includes/class-wp-site.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y\0$~aa', '՚=p\Zy*\'e <kJ(CJ\0%\0Fe', '', 0, '?'),
 ('\\SՇ8;2', 'wp-includes/class-wp-tax-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#oNԒzv', ':/mAn\ns\'iWeo', '', 0, '?'),
 ('~QԁŴFp', 'wp-includes/class-wp-taxonomy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C\\ `4?!w', 'H>ωF׻b\r9e#ajܶ', '', 0, '?'),
 ('I0B,hʛp', 'wp-includes/class-wp-term-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '((), ', 'M\"խGvby	qVtj', '', 0, '?'),
 ('ݖ\'\"|3_t|', 'wp-includes/class-wp-term.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';pL>c&\r', '; .aO4,>k&܀%', '', 0, '?'),
 ('ǢBմ(\\0J', 'wp-includes/class-wp-text-diff-renderer-inline.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8l_\ru', 'פme,V9}	yv', '', 0, '?'),
 ('J%.~ql', 'wp-includes/class-wp-text-diff-renderer-table.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xN6\0	m', '_Kp9y]t9\"\0ӡR', '', 0, '?'),
 ('#?Gc	¯l1e', 'wp-includes/class-wp-theme.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z.j', '\ZVnOZ|S\Z2#iQC', '', 0, '?'),
 ('絛zy>_+t', 'wp-includes/class-wp-user-meta-session-tokens.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8/\'\0\0vSL-G\0', '8bYB&?6o>', '', 0, '?'),
 ('9lן? rq', 'wp-includes/class-wp-user-query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$7ɫo)c', '5B;\n[Qԍ`b^\n', '', 0, '?'),
 ('|l+F#ڟ', 'wp-includes/class-wp-user-request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x`}b}', '8z9,Q\0RW`8ݛǝU', '', 0, '?'),
 ('R\\&T	|`', 'wp-includes/class-wp-user.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.>IʍJ+', '\rIt\"sAoX7()i', '', 0, '?'),
 ('\0]avCY', 'wp-includes/class-wp-walker.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kue0', '/;\\=oU2lN\" ̉.(oNN', '', 0, '?'),
 ('{1\"^.', 'wp-includes/class-wp-widget-factory.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'եᡵ|I ', '(He3aZ]t\\\'dp', '', 0, '?'),
 ('Djמ8]fД_', 'wp-includes/class-wp-widget.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tܕAd_yqq', 'Esʌ7[6?~0GfbݒL', '', 0, '?'),
 ('j䱋%]', 'wp-includes/class-wp-xmlrpc-server.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5,[6N', '<Gs\Zko\'ix֧ó{\\5', '', 0, '?'),
 ('$C/9', 'wp-includes/class-wp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uMQjJn7', '<G135ħ~D#*4l2#M@;Q(', '', 0, '?'),
 ('yEa:[\0', 'wp-includes/class.wp-dependencies.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T\"', 'IY\0s2A~9iTwMr-', '', 0, '?'),
 (';~ӷR>', 'wp-includes/class.wp-scripts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j-w!	d', 'X~\ZK*~@jד\Z\Z\"', '', 0, '?'),
 ('9ψ[1d{@', 'wp-includes/class.wp-styles.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'у9ݳ@:;i', ',\'j́M}q#', '', 0, '?'),
 ('=k[4 =', 'wp-includes/comment-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_X2gm&`', 'Z֡Z[=^`w\nv+\n', '', 0, '?'),
 ('SKK2iɈ', 'wp-includes/comment.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')K֏mgh[', '}PFJ_NE$ARU', '', 0, '?'),
 ('_\\c9mLv1', 'wp-includes/compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Mr.Am\0\n', 'ŤYU\\}L&\0+', '', 0, '?'),
 ('-\"DʹD5a/', 'wp-includes/cron.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~`uaV/^yb', 'McbѾr4>n]ڧ_h', '', 0, '?'),
 ('=֬H@-i', 'wp-includes/css/admin-bar-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yڽZH', 'a5Z/O7,rGZzmw', '', 0, '?'),
 ('{ڭd3TXy7;', 'wp-includes/css/admin-bar-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd jb7M', '-tN5k~`QvҮ՞o\0e', '', 0, '?'),
 ('Ȇp]4Lq', 'wp-includes/css/admin-bar.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>Ƌ̤J_', 'GO]˶\'\rHz=6E`N#', '', 0, '?'),
 ('I\"ptQ[Z6x', 'wp-includes/css/admin-bar.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')1(9o=&', '(:Gt_߸>)29rm', '', 0, '?'),
 ('t8p̋z{jDp', 'wp-includes/css/buttons-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{:jYK', 'EN\r(Em%`U\06㣺I', '', 0, '?'),
 ('Ul1ȕDbmg', 'wp-includes/css/buttons-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{^hσSC', '\\nl]>\r}IuSG\0ʧ', '', 0, '?'),
 (';^𩸴8c', 'wp-includes/css/buttons.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~R	R5\'', '`03iciB!LUbPЇ Zc{0', '', 0, '?'),
 ('з&L۽¨VN', 'wp-includes/css/buttons.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=(؞*Yŭ', '$rAiURL5#@܄zQb\Z', '', 0, '?'),
 ('F\\C?Z', 'wp-includes/css/customize-preview-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2)\rfGb0},', 'u2(5_oUb0nÕ', '', 0, '?'),
 ('Ư0~\rjA4u', 'wp-includes/css/customize-preview-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']gxKv+Э9', 'rڵJPu(ZۇU%', '', 0, '?'),
 ('gVHIw!', 'wp-includes/css/customize-preview.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LIu.q~<+O', 'S\0 T.C)0K\0\ZD', '', 0, '?'),
 ('ylsU><', 'wp-includes/css/customize-preview.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zg$ \\XC@', '\rB6_`yH~\0Iw[q8N', '', 0, '?'),
 ('pS`]T]D', 'wp-includes/css/dashicons.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\N2۫r', '>RXz$l4Q[9Ị6k', '', 0, '?'),
 ('LyE{f', 'wp-includes/css/dashicons.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȕdc8SdWV', 'F}\'\')\0Ts\'', '', 0, '?'),
 ('pKb\0!(', 'wp-includes/css/dist/block-directory/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XcnGGItuB}', 'A4*WF,z2:ћ|', '', 0, '?'),
 ('2Zs+z', 'wp-includes/css/dist/block-directory/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	ϛF쥟Щ8+2', '\\Yёo\nXSΊVB23|*', '', 0, '?'),
 ('B\\u}L,', 'wp-includes/css/dist/block-directory/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',+m', 'Xe/dL{8 t<Z8x', '', 0, '?'),
 ('St J9G', 'wp-includes/css/dist/block-directory/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2F0Տ', '4TO쩩lߍ\\2!+`', '', 0, '?'),
 ('ډx`9LťM,L', 'wp-includes/css/dist/block-editor/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wh\\66', 'uTVl?3*A	zou', '', 0, '?'),
 ('i4ZlЃ @', 'wp-includes/css/dist/block-editor/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{-', '>MN_,A{?\\L:PKpGuy0', '', 0, '?'),
 ('psZZ#N7e', 'wp-includes/css/dist/block-editor/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aM', 'syp$/J^:VE@5\rl', '', 0, '?'),
 ('RBpmZ;', 'wp-includes/css/dist/block-editor/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w5?Mۂ', 'a3\rPJIGSt.,AF}4g*/', '', 0, '?'),
 ('X*VL	_', 'wp-includes/css/dist/block-library/editor-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1d{{', '8#^)x`I#8-ubوAhLo', '', 0, '?'),
 ('\nRbxg', 'wp-includes/css/dist/block-library/editor-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y.g\"6P', 'x\"/s;vC>НŜo1ZzU', '', 0, '?'),
 ('̆lҘ\\4,C-m', 'wp-includes/css/dist/block-library/editor.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CCG|f0AP', 'f#[7Q}A9+H\r\0>\n<诋4_5', '', 0, '?'),
 ('[4?s', 'wp-includes/css/dist/block-library/editor.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#sATː_趜C|e', 'wY\\W&q^~iR\Z)	D', '', 0, '?'),
 ('SK547S', 'wp-includes/css/dist/block-library/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ty5:>`', '_Fx(]V27  n\"_M*', '', 0, '?'),
 (')!)6>}74', 'wp-includes/css/dist/block-library/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʇ+,|#i', '$V7ҮcRcǠ\0{', '', 0, '?'),
 ('z6+PH\rtU', 'wp-includes/css/dist/block-library/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E&xt;7G', 'Mp&qWb	5]', '', 0, '?'),
 ('QF0t+', 'wp-includes/css/dist/block-library/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '} Qş5xwAc~', '4#NPAuvJoٜvmȌ', '', 0, '?'),
 ('m֙7,}ov', 'wp-includes/css/dist/block-library/theme-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',#~},r', 'ZLtXa{3ν)YB>f', '', 0, '?'),
 ('Cas]n/', 'wp-includes/css/dist/block-library/theme-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i+p^3xg', '^*{HK1Ad@^It', '', 0, '?'),
 ('Oxرc5(', 'wp-includes/css/dist/block-library/theme.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UT%=Y-]D:', '{ueuM\0foGe8+;g', '', 0, '?'),
 ('m5u1}', 'wp-includes/css/dist/block-library/theme.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't/uSC\"0', '(PG4$v؞', '', 0, '?'),
 (';ܒscF!', 'wp-includes/css/dist/components/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rzl`)O1UQj\0', 'T~a|qb|%~7bl<', '', 0, '?'),
 ('V܂0\0U`5C>', 'wp-includes/css/dist/components/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OFGa?IAjX', '\0NF5ݸe/zb\n3x\Zl', '', 0, '?'),
 ('j^SN-O ', 'wp-includes/css/dist/components/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʐ_s4', 'lFd#Ƙ1utGQP\n', '', 0, '?'),
 ('M1/n̖Q', 'wp-includes/css/dist/components/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AÕ1(ն(+!', 'A2!\rW?p\"\\fw%', '', 0, '?'),
 ('0,X', 'wp-includes/css/dist/edit-post/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GP]ƦV', '\0+ey o!	F MCVOPJ5c_', '', 0, '?'),
 ('d%3Z4_+', 'wp-includes/css/dist/edit-post/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ͯ@c*GG6j', '%0!b3\"&Chg]eMIB', '', 0, '?'),
 ('RKQ5v-	', 'wp-includes/css/dist/edit-post/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '͓{r!_\n', '>Ѓg!)ʙ{)R஡O5', '', 0, '?'),
 ('Kv$TMR=', 'wp-includes/css/dist/edit-post/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Mi*kw)r', 'q[/ӡ>\rn |ѪԈuuXų#', '', 0, '?'),
 ('cVs9o', 'wp-includes/css/dist/editor/editor-styles-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~Km9}	q', '(}6͛\"$#', '', 0, '?'),
 (',lSr', 'wp-includes/css/dist/editor/editor-styles-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EAA@v9', ' h%\nfJ(UZu@DRzC', '', 0, '?'),
 ('mH:M*^', 'wp-includes/css/dist/editor/editor-styles.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e8KQ^', '$HKAhɍr\0aF1mԍ', '', 0, '?'),
 ('1`B¡]s', 'wp-includes/css/dist/editor/editor-styles.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0~N	~O', 'Kk$Ht80%\Z\'%  	uj', '', 0, '?'),
 ('qfEH7d', 'wp-includes/css/dist/editor/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{L34S͔՗', 'TeD678෗׌\0~0a`', '', 0, '?'),
 ('ւxRaǜ@', 'wp-includes/css/dist/editor/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8A~{x\\@', 'jDGkOK^^M_HiubP%', '', 0, '?'),
 ('OҽPT^4~B', 'wp-includes/css/dist/editor/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~DbbW\"P/', 'k\\fMRGg#Kx97˂;DPgy', '', 0, '?'),
 ('cQiQv', 'wp-includes/css/dist/editor/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C&&2W2[', ';?ݍ瘒\Z=RNa|2rN', '', 0, '?'),
 ('ZRr(&b:-', 'wp-includes/css/dist/format-library/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '쏊.-]Hfȱ', 'J`B)Xv F2R', '', 0, '?'),
 ('C/@lY2}', 'wp-includes/css/dist/format-library/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_ĕP_ڢ9H/', 'pBgl8Odo&', '', 0, '?'),
 ('\n{X%N8w2?M4C', 'wp-includes/css/dist/format-library/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n9*q6|$', '\r:m\r^&qgJGO/7v', '', 0, '?'),
 ('.z&.1y', 'wp-includes/css/dist/format-library/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-Fg@Kv@`', 'o3)\\F8!yP߇vf', '', 0, '?'),
 ('3-f\n', 'wp-includes/css/dist/list-reusable-blocks/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wJbfz|', 'szȯj>*5,Bvk YoQnB', '', 0, '?'),
 ('r)el', 'wp-includes/css/dist/list-reusable-blocks/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	w`bG3Y', ':^7\0N!b⦐#G*yzL', '', 0, '?'),
 ('t(iltY/', 'wp-includes/css/dist/list-reusable-blocks/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@a^\\Zt5gl\\', 'eTp(ҁ`ǾQEҒ$N{', '', 0, '?'),
 ('\rx+Uڜ', 'wp-includes/css/dist/list-reusable-blocks/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'#-5(D!', ')dg&8H[[3G¶^}Lmh', '', 0, '?'),
 ('^0pkM', 'wp-includes/css/dist/nux/style-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9?U*Դ<!J', '7]U/\Z\na`$/', '', 0, '?'),
 ('{jɏ|n	^<WH', 'wp-includes/css/dist/nux/style-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	mXcV)+6', 'BSSE\nQ rGw<sd', '', 0, '?'),
 ('2|?]ϸ', 'wp-includes/css/dist/nux/style.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?71%JЀ@', ':_GkH/TB~um', '', 0, '?'),
 ('Rv5W6`ھ', 'wp-includes/css/dist/nux/style.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lݫ1|', '4\0b3ߒZ\00oSp|3U	J1', '', 0, '?'),
 ('poX0%', 'wp-includes/css/editor-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xq0肌', 'Gѧ4ȢmRh]٫1T⣒Z', '', 0, '?'),
 ('ꍥ2jEbg؈Wx', 'wp-includes/css/editor-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4!܍&=', '	fƘPԒıTB\078J1', '', 0, '?'),
 ('LsЇś\nc}>K', 'wp-includes/css/editor.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@ϯSxGC', 'i\Z@D_[_RL&\n):أE{p8l', '', 0, '?'),
 ('_|TM^J', 'wp-includes/css/editor.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r%BmRWv', ';OgS	T3\\`Wޥdy', '', 0, '?'),
 (' c̫)I\np,͑', 'wp-includes/css/jquery-ui-dialog-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QTx_|d5$8J', '\ZwI]w\r׺P)X3{I', '', 0, '?'),
 ('~F㫎>dyj', 'wp-includes/css/jquery-ui-dialog-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8Y$D', ')\ZpCtpЀ\r\Ze%!TaHh', '', 0, '?'),
 ('iPÙld\0', 'wp-includes/css/jquery-ui-dialog.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n\'$?U&c?', 'TŇ.-\nq\'M6jO&(ZY0V', '', 0, '?'),
 ('@V$K<1*', 'wp-includes/css/jquery-ui-dialog.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',!b( ]Fg', 'b&N?;;?\"y	ܹuI\\', '', 0, '?'),
 ('\05g꫔c0\"D', 'wp-includes/css/media-views-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dHe\"', '8BBQ%\nHi@jjx~', '', 0, '?'),
 ('_8}?', 'wp-includes/css/media-views-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YW[$M227m', 'Y ̹j917cF	AYLښyׇ:', '', 0, '?'),
 ('SڰpGMǯl', 'wp-includes/css/media-views.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rpL{*LIf9\\', 'CAmxNTiɀaXxe\0o', '', 0, '?'),
 ('4%IHOʰL', 'wp-includes/css/media-views.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' ;Iv&WW', 'n\ro.62R/qޕ', '', 0, '?'),
 ('Ǥ>zԄ!J]>', 'wp-includes/css/wp-auth-check-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o3b{I}', 'kxufAwTt&%hMU', '', 0, '?'),
 ('Y$\'o', 'wp-includes/css/wp-auth-check-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	_Jܜ&g ', 'FIY>Sd&+e+aHso', '', 0, '?'),
 (',CUU9i-', 'wp-includes/css/wp-auth-check.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h\r]K', 'ІH4TaQ\'35շr%Ue7', '', 0, '?'),
 ('Y68H;%,_c\n', 'wp-includes/css/wp-auth-check.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7\ZCt\0', 'K$ЫVar@ذNrI[u', '', 0, '?'),
 ('w5)', 'wp-includes/css/wp-embed-template-ie.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')6	؞мq ', 'o+8]SuH.CgR9&+\\W', '', 0, '?'),
 ('ynm;/UsK	', 'wp-includes/css/wp-embed-template-ie.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7{WPL{HI', '\\aWq1+ЯoLY\0K%<', '', 0, '?'),
 ('/ɘ]^W\\q', 'wp-includes/css/wp-embed-template.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kӽQK6ʴt', 'bb,Ƣ\n/MjDT\rN', '', 0, '?'),
 ('zQ<\'U~R\\', 'wp-includes/css/wp-embed-template.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$4vׁ	;af!', 'QygA&TcjS8\nx.=D', '', 0, '?'),
 ('\\[i%Ͱ<e>', 'wp-includes/css/wp-pointer-rtl.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'{+D,ϵH', 'T6@UPe*RR-B\\VQ6', '', 0, '?'),
 ('jQe;e', 'wp-includes/css/wp-pointer-rtl.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$hF?n\0U', '%K\ZG3,lieqB\n\\W', '', 0, '?'),
 ('sC4M**B)', 'wp-includes/css/wp-pointer.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P9!;^<*/', '^IT\\sGHd_|\0Xa', '', 0, '?'),
 ('-藂Y{]ns', 'wp-includes/css/wp-pointer.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']:?9.', ')cg-[L*\niz>|Ԑ', '', 0, '?'),
 ('xW2euvL', 'wp-includes/customize/class-wp-customize-background-image-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{f&E\\$sX', 'Rv3~|.OLtN`Ѯ', '', 0, '?'),
 ('V^3m6._P', 'wp-includes/customize/class-wp-customize-background-image-setting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')@tj23W', '40^+u*:ޓ4q[#Om&', '', 0, '?'),
 ('D6S/cQ?', 'wp-includes/customize/class-wp-customize-background-position-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QJt\"!!_^	', '릟/ԤokroQ|EQZ݁\ro', '', 0, '?'),
 ('賮]', 'wp-includes/customize/class-wp-customize-code-editor-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B%3$~ܭ*sq', '\nA%,MQ!%X-d\riz.]', '', 0, '?'),
 ('MYG\\tX/', 'wp-includes/customize/class-wp-customize-color-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&S?|G', 'h	3|:Q9z4Y1[{^	$;#q', '', 0, '?'),
 ('\'T́YǙ', 'wp-includes/customize/class-wp-customize-cropped-image-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Gp[q}y1', 'x\r:}gR)`kM%', '', 0, '?'),
 ('Ns', 'wp-includes/customize/class-wp-customize-custom-css-setting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%؊@\09d', ';kCKQ\r~`K)ß+', '', 0, '?'),
 ('\Zlm@', 'wp-includes/customize/class-wp-customize-date-time-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'eyżO;QIh>', 'ao\r2Dl2F[%W$SbL', '', 0, '?'),
 ('Y\0)\r/j)Ar', 'wp-includes/customize/class-wp-customize-filter-setting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M`f\0iu', '\0<\nj:YFdw	', '', 0, '?'),
 ('Zx12KZ,', 'wp-includes/customize/class-wp-customize-header-image-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bNI]w', '_1poDbi݌e:+T', '', 0, '?'),
 ('\'Kzf', 'wp-includes/customize/class-wp-customize-header-image-setting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y$+q?U', '9@mrܵ\"+BVK.uB\"', '', 0, '?'),
 ('>\n5Z', 'wp-includes/customize/class-wp-customize-image-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H߇oNN<', 'a\n\r$۱yq*$q{', '', 0, '?'),
 ('*Oi', 'wp-includes/customize/class-wp-customize-media-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3ˆG\'H|Z', 'QB/szatޝSnQC', '', 0, '?'),
 ('hS:`', 'wp-includes/customize/class-wp-customize-nav-menu-auto-add-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N+C#+|fZ]', 'kn\Zy&_[Igl(g\'^G', '', 0, '?'),
 ('3ƹܕjbiΥ', 'wp-includes/customize/class-wp-customize-nav-menu-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@V{R#87nn\n', 'aHMuyw?h:B<=,##', '', 0, '?'),
 ('CؚTR!vF{', 'wp-includes/customize/class-wp-customize-nav-menu-item-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*:UțJ>hz', '=C\0\"ȗgp{KϮD\'', '', 0, '?'),
 ('{	\n|p٤', 'wp-includes/customize/class-wp-customize-nav-menu-item-setting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<sB0', '^Ysg9yu\rژWm%D4p,', '', 0, '?'),
 ('b+ƴݟ3', 'wp-includes/customize/class-wp-customize-nav-menu-location-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U!s^7L', ';lϓb^0(@L#B', '', 0, '?'),
 ('tDXm\0#(', 'wp-includes/customize/class-wp-customize-nav-menu-locations-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H.% Fr', 'iA}݅괻Z', '', 0, '?'),
 ('G ~`', 'wp-includes/customize/class-wp-customize-nav-menu-name-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7fW՚7', 'pvw ܪ9?az', '', 0, '?'),
 ('-B|tS^', 'wp-includes/customize/class-wp-customize-nav-menu-section.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bT	O9.6\n-', 'l	@Xn0f^Wq', '', 0, '?'),
 ('k0Ba`', 'wp-includes/customize/class-wp-customize-nav-menu-setting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Œ2%tM\0_μ', 'sr%Zm(	ѐ83%xMw*U', '', 0, '?'),
 ('xm\0~', 'wp-includes/customize/class-wp-customize-nav-menus-panel.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$K͞u	Q p', '/\'V\ZVtb\"ds\"e@I<', '', 0, '?'),
 ('@}&J~¾&\0', 'wp-includes/customize/class-wp-customize-new-menu-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NpaCqk', 'F0HyceLuQ&LiH\nDũK', '', 0, '?'),
 ('2㺨a|Fl3]', 'wp-includes/customize/class-wp-customize-new-menu-section.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	sL2/B', 'H\'sӽI$ӦͤX!', '', 0, '?'),
 ('Yq', 'wp-includes/customize/class-wp-customize-partial.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[\\i', '{>xH\n|AE|ScOs/', '', 0, '?'),
 ('y\n,\nC|[i', 'wp-includes/customize/class-wp-customize-selective-refresh.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Kl\0ٕcm', 'אCT8k3p]8Tfjb\np..7霱', '', 0, '?'),
 ('T6K?s 7(', 'wp-includes/customize/class-wp-customize-sidebar-section.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VjBرq', '{#i`\0j` pǍ+fF', '', 0, '?'),
 (' ,eOzÑ', 'wp-includes/customize/class-wp-customize-site-icon-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$0V<', '(V+g]!i}wš)5m>-', '', 0, '?'),
 ('?Ǆ:\nX', 'wp-includes/customize/class-wp-customize-theme-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Mf&vfL', '{rMn9}\n\\k?^HrU', '', 0, '?'),
 ('<g=C״qD', 'wp-includes/customize/class-wp-customize-themes-panel.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uZ7ѳU', 'aMkM.ݚfJ>{V>v2U', '', 0, '?'),
 ('XQd9rڼ', 'wp-includes/customize/class-wp-customize-themes-section.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tísԗX\0>', 'rr,\'tVTӴQTFH̘Zs', '', 0, '?'),
 ('e\\kcXf', 'wp-includes/customize/class-wp-customize-upload-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Hﻇy¿u&9', '~Wb@X|DSBq.6.', '', 0, '?'),
 ('[5YNhKM', 'wp-includes/customize/class-wp-widget-area-customize-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u͹7sq', '<vD~%纙X<', '', 0, '?'),
 ('\nT/\\9$YU\n͌', 'wp-includes/customize/class-wp-widget-form-customize-control.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{D*@6{τ}', '+֓zi@^F%5qZg<', '', 0, '?'),
 ('\0.}fwA', 'wp-includes/date.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n[*(Ҿw.myz', '.\0qB_]\0a}\0', '', 0, '?'),
 ('}{RҢ\"', 'wp-includes/default-constants.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W3]X=Z$', '|̪mLyӯTij텶^wH', '', 0, '?'),
 ('R,A\ZGJ\'-', 'wp-includes/default-filters.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nz1', 'huFٔ{Gژ)&i1_', '', 0, '?'),
 ('VL67G^l%D5z3', 'wp-includes/default-widgets.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0t<޸!', '^\'U9;dOˊSz!Sm>I5\'e', '', 0, '?'),
 ('p.а[ÍD', 'wp-includes/deprecated.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{pݬCE', '/PN؉)@#F):Υ+leW', '', 0, '?'),
 (')]Z$P%', 'wp-includes/embed-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UzA>z\'!f*', '*xJ\"t\r^K$U09ZиCru', '', 0, '?'),
 ('9ekkRoS', 'wp-includes/embed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KAyuC)@=', 'x-XB A\n/\"a#', '', 0, '?'),
 ('&MXWO', 'wp-includes/error-protection.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|˖eO\"\0', ')+|}}g\\=^N$Q4', '', 0, '?'),
 ('\"b9e|_', 'wp-includes/feed-atom-comments.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\I6bJi\"m', '+.40Ig(b}yтKkb5', '', 0, '?'),
 ('2@kw>K2', 'wp-includes/feed-atom.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{\rg\'SkIfep', '!Im\nYf+̕P\013\\=', '', 0, '?'),
 ('ȼ؟\'\r`', 'wp-includes/feed-rdf.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xG7%\0b', 'p=m=GlhnhV]-+1a', '', 0, '?'),
 ('])	{?R}', 'wp-includes/feed-rss.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iJ?YC>^f', 'flPf52tY3xDׄ', '', 0, '?'),
 ('߲;0', 'wp-includes/feed-rss2-comments.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-|AGM', '\n(K]%)3&`AMUYbFФ', '', 0, '?'),
 ('_*⽞L0>\r', 'wp-includes/feed-rss2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lN+5	O?', '@!`C*Mezj@	@Ljw', '', 0, '?'),
 ('{RC\Z.*\"Q', 'wp-includes/feed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')z\ZG4\\i', 'JLOCYT=KLv\0ۘ>\'', '', 0, '?'),
 ('\Z5o#R\'/l', 'wp-includes/fonts/dashicons.eot', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_ՙe|', '.}6`87Ja!e97D\"l[Z#', '', 0, '?'),
 ('΢S˪\nBV\"', 'wp-includes/fonts/dashicons.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g-QiF?h ', '\rq\ncB\nn.!', '', 0, '?'),
 ('<kUJv%1', 'wp-includes/fonts/dashicons.ttf', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',eM:wS', '6&>bk	sV4-ԣ| *$', '', 0, '?'),
 ('f0ͭ~)', 'wp-includes/fonts/dashicons.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Z_rY+ʂ;', 'yU]f8tlL.', '', 0, '?'),
 ('L+qV;hY', 'wp-includes/fonts/dashicons.woff2', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>J(#@\Z', ')x_\n`TǬO^^hnU', '', 0, '?'),
 ('ŉ	i/Э', 'wp-includes/formatting.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[d ?', '9Z-tkILqPo=sJC', '', 0, '?'),
 ('\Z)qtsCI9', 'wp-includes/functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qq4\Z	B|{x]', 'ʋG|+ӊ+Npٕ;DC#Y', '', 0, '?'),
 ('b`K\'컜K', 'wp-includes/functions.wp-scripts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z0f^?}', '̽\nBL<pwւ.6\n', '', 0, '?'),
 ('h d껅2_r', 'wp-includes/functions.wp-styles.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6̢e\"07B', '90<#&OlA :', '', 0, '?'),
 ('0RJ{yˣ', 'wp-includes/general-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F7$a\0ڋ', 'z\r,[4lLg\0h	a (', '', 0, '?'),
 ('/&2ѡ\rgDs', 'wp-includes/http.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YĦhY	i', '/ѳPi;?Hj=m4Щ', '', 0, '?'),
 ('.IhU3+B\Z', 'wp-includes/images/admin-bar-sprite-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q8o', '*ETsal^pXZ\0', '', 0, '?'),
 ('Ư	\'CԻګ\Z', 'wp-includes/images/admin-bar-sprite.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S:W^', 'rN!`VOcKviՀ{Fn\Zle', '', 0, '?'),
 ('r_/HG=%<', 'wp-includes/images/arrow-pointer-blue-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%mrތ]49c', '{&DOzAf/gáA]~(', '', 0, '?'),
 ('@̘9#Ly(', 'wp-includes/images/arrow-pointer-blue.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wb·*L[', 'fbZD1.Vaw4l?pG^{', '', 0, '?'),
 ('G5@07', 'wp-includes/images/blank.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ʟghkKf', '>EGL EJQ|Bij', '', 0, '?'),
 ('>M8 ٵ|', 'wp-includes/images/crystal/archive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SI0An', 'L%XO+Aa!S\\܉&', '', 0, '?'),
 ('J\'#rN0a\r', 'wp-includes/images/crystal/audio.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nV:ωG-#k', '~B\Z-׼of|Wx\\|M)ˢ', '', 0, '?'),
 ('wL0]r.', 'wp-includes/images/crystal/code.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`119', ';67\r!x\Z_@H&C-', '', 0, '?'),
 ('!ެ߳p', 'wp-includes/images/crystal/default.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A>)*/!-', 'n$_u	$Q3E׏r|Jm', '', 0, '?'),
 ('Dm\nzHS', 'wp-includes/images/crystal/document.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'^csD3T\\', 'gt( Ŏk`5͒JM5:j', '', 0, '?'),
 ('j5F+o', 'wp-includes/images/crystal/interactive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Rm``9', '$멘<x1ՓIRV-VZ\\jg.', '', 0, '?'),
 ('ǊEvc,صyS^', 'wp-includes/images/crystal/license.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']LciGfQ\r', 'vpmc6Y~\",!VEXll\"z', '', 0, '?'),
 ('^Ð+y|', 'wp-includes/images/crystal/spreadsheet.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '59Т1Tn', 'e\rCi0[R8@GaJN', '', 0, '?'),
 ('\"RŜ', 'wp-includes/images/crystal/text.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' Ѳ#d%[', 'n10<;\nIp~f⠸z', '', 0, '?'),
 ('U$i\"u&9', 'wp-includes/images/crystal/video.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lڤ;=', 'S\rIU9_<f`&HYwu', '', 0, '?'),
 ('*-3uE[O#', 'wp-includes/images/down_arrow-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']Mf', 'w\0qpq5T#\\', '', 0, '?'),
 ('\nO_;]/^', 'wp-includes/images/down_arrow.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V~oYnG~_u', 'h8ɧpu{9J', '', 0, '?'),
 ('Ҟǟ	Ks', 'wp-includes/images/icon-pointer-flag-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2b&Zr', '4Bȥ\'x+chҠVn5I>j', '', 0, '?'),
 ('Z	r!ޏf	', 'wp-includes/images/icon-pointer-flag.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',E^j`\'', 'oq9a{)h}=#Tק', '', 0, '?'),
 ('Y,eAw`', 'wp-includes/images/media/archive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9h\0ìu', '\0Bb3\'\')JG ](G9Pr2 s', '', 0, '?'),
 (':n̣RMti#=', 'wp-includes/images/media/audio.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'taCA.Z', 'L>$\noixoj-\nL]G;q', '', 0, '?'),
 ('3\"(za48', 'wp-includes/images/media/code.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-oUʓUU_', '\'eM a[R#q2kz+*<7\0j', '', 0, '?'),
 ('(?>SN揚&', 'wp-includes/images/media/default.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-IBh@b', ':oLJDj$->i\'6n֠Ui', '', 0, '?'),
 ('/<ا^ɼf}\"$', 'wp-includes/images/media/document.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v48Αy6d', 'ø`f	I$ _ZX\"0\r,', '', 0, '?'),
 ('rYSxwDY˚J[', 'wp-includes/images/media/interactive.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R׬˂ôŉhH', '{ [K\0!긽/\\lw.', '', 0, '?'),
 ('HVեdpVp', 'wp-includes/images/media/spreadsheet.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4\0Ṫ?', 'v)\n6Zl2В1!+	', '', 0, '?'),
 ('9s3SZ,p8g', 'wp-includes/images/media/text.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zs0ȝQK', 'g?[D*p8qVѓ>N', '', 0, '?'),
 ('\n%f[!aErtgi', 'wp-includes/images/media/video.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uhq', 'DBUMiOb,e=W{', '', 0, '?'),
 ('k/y&G', 'wp-includes/images/rss-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ya[Qrj', 'yS0c`\n7as#nY', '', 0, '?'),
 ('r؁=Ԓ', 'wp-includes/images/rss.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[(.*NZ', 'j(-9_E-#we$]o01u', '', 0, '?'),
 ('{\r-}^', 'wp-includes/images/smilies/frownie.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q', 'r~Dzoh߱ػ\">E+Ke', '', 0, '?'),
 ('Т펹|@', 'wp-includes/images/smilies/icon_arrow.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' 	J<go9:x', 'ncx0ĥtN޾Y2X\0!', '', 0, '?'),
 ('㯩	\'ިV', 'wp-includes/images/smilies/icon_biggrin.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KJr:]kI|', ':ٔMX%	<8g4', '', 0, '?'),
 ('$͓bHn,\0-', 'wp-includes/images/smilies/icon_confused.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/#	Ӣww$x꾓Y', 'U0\\LXfXƦG\0T$a5UB', '', 0, '?'),
 ('X,ECj$_8I0', 'wp-includes/images/smilies/icon_cool.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n`ivj.', '事F9;2_	$$~LOa6_', '', 0, '?'),
 ('ĔԼpPZ	H', 'wp-includes/images/smilies/icon_cry.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+`ŮdW]h', '[<qwf)rZ(=#;answ9', '', 0, '?'),
 ('!_輵p3pnL', 'wp-includes/images/smilies/icon_eek.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/I x)(\"', '8K҇4!:ʰ', '', 0, '?'),
 ('Obc\" |J(', 'wp-includes/images/smilies/icon_evil.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^M>z', 'Q|x>@VЛ_/\"W%S', '', 0, '?'),
 ('JBGT;,lT', 'wp-includes/images/smilies/icon_exclaim.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':\\>5\0rsg', 'LɵHA(xʓ2EP%	##5', '', 0, '?'),
 ('\"u@TS5', 'wp-includes/images/smilies/icon_idea.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<]W3tށ', '{2^4STlIJQ\"', '', 0, '?'),
 (' n$q^qf', 'wp-includes/images/smilies/icon_lol.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n:ѷ&(', 'l1Hq.2x󢾉$Y\Z8', '', 0, '?'),
 ('(הWh@=a', 'wp-includes/images/smilies/icon_mad.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V!@c0S', 'd[O:Ǉjl}q', '', 0, '?'),
 ('\ZUEs(#Ep', 'wp-includes/images/smilies/icon_mrgreen.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$_uX|I%~$', '!BI1mV-|јX5D8h', '', 0, '?'),
 ('ki.\\', 'wp-includes/images/smilies/icon_neutral.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VM3HU1!v', 'Ois8\0|z6]e@Ym49', '', 0, '?'),
 ('7M3$', 'wp-includes/images/smilies/icon_question.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[-\0\'WF', '7b|6#9/?x~[%t', '', 0, '?'),
 (':[&b[hY', 'wp-includes/images/smilies/icon_razz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9[wDAMA', ';P1]fUE;`Qڮ\neZ\0@4aA', '', 0, '?'),
 ('$0S\rr', 'wp-includes/images/smilies/icon_redface.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'UE', '>DC9McJ\Z+UL1f+g', '', 0, '?'),
 ('B]nȄ87g', 'wp-includes/images/smilies/icon_rolleyes.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_56IĔE', 'b;SG`JL4;ͮ1;\\;xl', '', 0, '?'),
 ('HPw%8', 'wp-includes/images/smilies/icon_sad.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IxoTMzD-', 'b5yh9}oWInn', '', 0, '?'),
 ('e97aJS', 'wp-includes/images/smilies/icon_smile.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3.)2p', 'ˠ\",RʨTr=orЗ:', '', 0, '?'),
 (';Wct*+Br', 'wp-includes/images/smilies/icon_surprised.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U-#+0?', 'cuyXؓAd5[=w>*Spwe._', '', 0, '?'),
 ('\\:ڈ)g,\\', 'wp-includes/images/smilies/icon_twisted.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lv[?+*8;', 'VHhK\np;.&/E', '', 0, '?'),
 ('8P5aĨ	', 'wp-includes/images/smilies/icon_wink.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e?2i', '(V{VBko(`ZV	6', '', 0, '?'),
 ('g|y_o4\"XN', 'wp-includes/images/smilies/mrgreen.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-5^Jj', 'Mg$+;\05H&\\E6%w', '', 0, '?'),
 ('{Y\\z錿}c', 'wp-includes/images/smilies/rolleyes.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' O2Ofݣi', 'fK)\nd!]\r)\\}זl^', '', 0, '?'),
 ('ջZml4ˮU', 'wp-includes/images/smilies/simple-smile.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K{fwh', '?Yag\\<y0\0183Hg', '', 0, '?'),
 ('}`g\"P2V', 'wp-includes/images/spinner-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '12^#8', '#˒=$c6	B46', '', 0, '?'),
 (':XqݝJ\\5P4', 'wp-includes/images/spinner.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L\nD\noًj˲', 'zƄ\Z\"n\Zs(U/~7F^', '', 0, '?'),
 ('}ĉ=t', 'wp-includes/images/toggle-arrow-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'F\\CDr', '-N7~@}_=V_@A', '', 0, '?'),
 ('ܵ[Ҳm%6S8:D', 'wp-includes/images/toggle-arrow.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '·a;d*', '[b\Z;]f0s|:%', '', 0, '?'),
 ('/鹠ΰ1iw', 'wp-includes/images/uploader-icons-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&-OÕ~', 'r\0\'_>6QW4ڠR', '', 0, '?'),
 ('_43=', 'wp-includes/images/uploader-icons.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\Mm', 'p+/i!Zţ6m', '', 0, '?'),
 ('x9@^6ߑo', 'wp-includes/images/w-logo-blue.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[NW_pw0', 'ޣ^Qt3HunU❻~\'T2', '', 0, '?'),
 ('hFuQe ', 'wp-includes/images/wlw/wp-comments.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L6]P.s', 'zl\ZCD#aN3\'XZ', '', 0, '?'),
 ('Pq-t@l', 'wp-includes/images/wlw/wp-icon.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1	ʚ7w3K*', '5 }x(r:a,zmKH1|/+', '', 0, '?'),
 ('6bg>_', 'wp-includes/images/wlw/wp-watermark.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';uMmܭD|wD', 'SnR\'X^khɑi7', '', 0, '?'),
 ('~U\"&', 'wp-includes/images/wpicons-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nVo$Of~7', ']کA=ђ%q%aMBUp', '', 0, '?'),
 ('g$G\\;r1X', 'wp-includes/images/wpicons.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'dSuqV_a', 'cZ_?n_K61\\}r', '', 0, '?'),
 ('\rEU̈́', 'wp-includes/images/wpspin-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mSy\"C', '66SX6O}4>p\"\'1', '', 0, '?'),
 ('Rx4Mp@9u\n֊ p', 'wp-includes/images/wpspin.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hkuR\r@9k', '!Fױ(#1:', '', 0, '?'),
 ('N\\|`*,)@4', 'wp-includes/images/xit-2x.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ӂu:@4\rz<5', 'S\r}@~Q:Sc*d+Z_{R', '', 0, '?'),
 ('\n\\ɶ.5', 'wp-includes/images/xit.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	3Xī9+6n~', ' sۨS,md\\YbƇo', '', 0, '?'),
 ('|/ڒ\0[*4x', 'wp-includes/js/admin-bar.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4`#&\\4', '!QȿqzI*^C҉Za', '', 0, '?'),
 ('MР\0A9Q+', 'wp-includes/js/admin-bar.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lo̭tG2Z', '\rȑڵ3ՊvW\0hLNkR]J', '', 0, '?'),
 ('-c<@VsZ', 'wp-includes/js/api-request.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',fv1<$c', 'Ķ,y;%LSڮt\Z', '', 0, '?'),
 ('e\rZfޞ|', 'wp-includes/js/api-request.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y[y<', '{Yp)8Q#k?%	Kt+u§', '', 0, '?'),
 ('R3Us3}T', 'wp-includes/js/autosave.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E6y4uWoN', 'O׃˯c|z	\Z;c_\Z\\pY', '', 0, '?'),
 ('wul|pQ', 'wp-includes/js/autosave.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^$@)u|\Z', '+z,9}0If@[|v', '', 0, '?'),
 ('eMy*Ҟ', 'wp-includes/js/backbone.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"$2hj32U', 'cBCP\0F!vy6Ku*<cf', '', 0, '?'),
 ('PE۫7r|oI6>', 'wp-includes/js/backbone.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ܾcum܊e\'d', '8դi`e~3	LQĞ', '', 0, '?'),
 ('3h\"I+[E', 'wp-includes/js/clipboard.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_Ƀ{ӭv$k', '{cXrq;[7V]\\&)G(', '', 0, '?'),
 ('2bU\0spd0', 'wp-includes/js/clipboard.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(xhn|rbm', 'gUjIi%-[GZ\\\nxH_a', '', 0, '?'),
 ('D=K49', 'wp-includes/js/codemirror/codemirror.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '23j1(D', 'Ό,au@sY%K-on\r', '', 0, '?'),
 ('}eC!*', 'wp-includes/js/codemirror/codemirror.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	fh;fq', 'u*Q6Ƅdvdȇ_\0', '', 0, '?'),
 ('\nUN~\0m', 'wp-includes/js/codemirror/csslint.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M_ϱIl', ']ih4Fò\rUWEK(Pd', '', 0, '?'),
 ('VBǡ\ZB\"\0', 'wp-includes/js/codemirror/esprima.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd_ Sgٛ', '];%JslxFqBH\ZU8', '', 0, '?'),
 ('׵(KB', 'wp-includes/js/codemirror/fakejshint.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5v,ROlx]J\')K', '-6$$;}ptO4]2ТR5֡', '', 0, '?'),
 ('T!ة7l<', 'wp-includes/js/codemirror/htmlhint-kses.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[k[#cLf{', 'N&V\ZA/R#~բ_J*Ї', '', 0, '?'),
 ('ƞׅ\ZXX]YF', 'wp-includes/js/codemirror/htmlhint.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2|џGMtP5', '\0U[\0M\'mCռ55k`5ё', '', 0, '?'),
 ('z.[D8R', 'wp-includes/js/codemirror/jsonlint.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I)fykT+<՟', '$D;;0F~pGғFˁ', '', 0, '?'),
 ('\npGnu:', 'wp-includes/js/colorpicker.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V g-', 'Vw%%:3CQ#+g	e}', '', 0, '?'),
 ('0E\00XH', 'wp-includes/js/colorpicker.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Uy{[M,7Ax', 'q-DaCdw8\Z[F)V@t=HҘ', '', 0, '?'),
 ('pUya	bva;8', 'wp-includes/js/comment-reply.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'KuTp?e/i', ']Et^Jr˞xYtTCt$', '', 0, '?'),
 ('1X/t60^Ҁ!7', 'wp-includes/js/comment-reply.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P7K@91ޢ', 'ԖI<OUw\0;&GO/̽d', '', 0, '?'),
 ('bY,ϥYr۝;', 'wp-includes/js/crop/cropper.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ky5ni*M(', 'ٸTޝOwLy=}gTl', '', 0, '?'),
 ('\r%%yS`', 'wp-includes/js/crop/cropper.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H.so', 'py,BG-t=s', '', 0, '?'),
 ('(|nsARF+', 'wp-includes/js/crop/marqueeHoriz.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '̮;Lo\n', '|Se|./QYW}(', '', 0, '?'),
 ('Z\0Y æfg', 'wp-includes/js/crop/marqueeVert.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\09R', 'Kcg$e2\\p$1z`CkJ', '', 0, '?'),
 ('r\\jA$', 'wp-includes/js/customize-base.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kxx(7_MGG', '@vE$Nw*d?.', '', 0, '?'),
 ('V\nU`_58', 'wp-includes/js/customize-base.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@׻P^P', '	VԿEb<d\'B', '', 0, '?'),
 ('V}Pm/|I*', 'wp-includes/js/customize-loader.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c\'Cw\"Tԉ%', 'G?~D,(F]IbNEpcv:z', '', 0, '?'),
 ('bҌ &?{', 'wp-includes/js/customize-loader.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';faMAbJ', 'Aݻ}h+n\"MaѺ\n3w', '', 0, '?'),
 ('xЙ)DC<', 'wp-includes/js/customize-models.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}5||p<', 'ܠ}6F%;uV^<v0sT', '', 0, '?'),
 ('\nNNMۑ4;p4', 'wp-includes/js/customize-models.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Cna', '>G`Y*V)t65ZtZ', '', 0, '?'),
 ('\Z{:\Z4f', 'wp-includes/js/customize-preview-nav-menus.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1g:#>͎f', 'AKlܰsg<53ὀnY', '', 0, '?'),
 ('F~yc7v-', 'wp-includes/js/customize-preview-nav-menus.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j`Wr=0!u', '\nY<yKTsjofBz', '', 0, '?'),
 ('9\r5\'X>?', 'wp-includes/js/customize-preview-widgets.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TM.c', 'STȸ[\'Oh~x̮	j\r', '', 0, '?'),
 ('9rMԧ', 'wp-includes/js/customize-preview-widgets.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5	;\"rP', '@sR/\ZU~uω8Նſ!$', '', 0, '?'),
 ('42)A.;4', 'wp-includes/js/customize-preview.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']`-1. ', 'R/o)@D#άkz@kJ6#/6', '', 0, '?'),
 ('>ql+m\05Ħ\"^', 'wp-includes/js/customize-preview.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BN@y_', 'J|cG[JP?Y/HdE^wvM', '', 0, '?'),
 ('UNEAgt', 'wp-includes/js/customize-selective-refresh.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$ygϷ', 'z,jm%U;ceӈi\Zhd', '', 0, '?'),
 ('0jVƽf:5`\\', 'wp-includes/js/customize-selective-refresh.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4\0ʬL&', ':z^m8[su}.T\npw', '', 0, '?'),
 ('QY1TlVr<', 'wp-includes/js/customize-views.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"r<`D', 'b2M!o;-veq\\f]l:', '', 0, '?'),
 ('Y^~5~pG-', 'wp-includes/js/customize-views.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zf>b&7f', ')8\\N<88=\nG#+d&', '', 0, '?'),
 ('2Jy*m]W', 'wp-includes/js/dist/a11y.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ɫ,mv,', '\Z\\RYh\Z</_L)6yC', '', 0, '?'),
 ('|0O+]lU', 'wp-includes/js/dist/a11y.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q\"\r~U[}', 'qB/˜nZfU:3(KqG=', '', 0, '?'),
 (',]\'N%ݑUeT)', 'wp-includes/js/dist/annotations.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"dӜwFtSy', 'ojD.!q+&=	\\n٦&-NݛO*', '', 0, '?'),
 ('Y(Kg\0_', 'wp-includes/js/dist/annotations.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(Z4RČ', 'Q)Ih^hݤZ#i)AV~K', '', 0, '?'),
 ('EȖqȊ?2H', 'wp-includes/js/dist/api-fetch.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6=pC', '$E)]o\ZA/euiQ&0`', '', 0, '?'),
 ('(NL;	', 'wp-includes/js/dist/api-fetch.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E>M(RG', '\'#4\Z-[8yn!J	', '', 0, '?'),
 ('/*:o>t', 'wp-includes/js/dist/autop.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qv?1gv˕', 'B*qb=eskdVٖ94', '', 0, '?'),
 ('k4c5<\"', 'wp-includes/js/dist/autop.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.wx/H', '+˥޴LTJ\noKS\"M', '', 0, '?'),
 ('Ϛ\"jy^', 'wp-includes/js/dist/blob.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'oDO:\0\n,\ZP', '`l},P)[\0NlqX\nĕ', '', 0, '?'),
 ('ä]0`AS:D', 'wp-includes/js/dist/blob.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')IOo', 'EFW,lj`ͅvB\Z', '', 0, '?'),
 ('|vP0fhT', 'wp-includes/js/dist/block-directory.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{w@T|', '4`gQXX}z14_;cm8', '', 0, '?'),
 ('(Y\'^kz!q', 'wp-includes/js/dist/block-directory.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2͋ڕ؄c', 'T,ta/a,1yԷ<{,5`t', '', 0, '?'),
 (';!1>YxQ', 'wp-includes/js/dist/block-editor.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_p*ڿh4L', 'WJsU!JdIn`xCU$XQLT', '', 0, '?'),
 ('v6Z\'OIL\"ݕM', 'wp-includes/js/dist/block-editor.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'fF	2x', '(5QGV/1GAb`˻.', '', 0, '?'),
 ('ĩ}x(T', 'wp-includes/js/dist/block-library.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'voaSncdm', 'O5-(5my?:։]vMUde', '', 0, '?'),
 ('N3M\nS0j', 'wp-includes/js/dist/block-library.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lWH|?EX', '\n⸰&5?Ǜ({Qwt', '', 0, '?'),
 ('CǴkq{.L', 'wp-includes/js/dist/block-serialization-default-parser.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l0{@%4+j', '0drms5\\z6L@^\Z', '', 0, '?'),
 ('S8MC>', 'wp-includes/js/dist/block-serialization-default-parser.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w;hG}', 'nGa|Nlu/ROY򔧇_', '', 0, '?'),
 ('\Z֧\\\Zhi', 'wp-includes/js/dist/blocks.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`vxΨsj', '\\;:1Rg/ʦ7ҏAaa{v', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('7:b\r,ja', 'wp-includes/js/dist/blocks.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_9ͷݣ$Gg~W', '\rl5zȋ4:ax[v\ZQ', '', 0, '?'),
 ('ldKм', 'wp-includes/js/dist/components.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\nj	&\\ʅ', 'T@eK+^mjMJ$a', '', 0, '?'),
 ('NZNDN>Y	', 'wp-includes/js/dist/components.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':k[', '^\Zf>V}UrZMfc#2jN', '', 0, '?'),
 ('وTĖhx~Dt>l', 'wp-includes/js/dist/compose.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OƩZO5z', 'dyIOiy5M%:k^Y>_P', '', 0, '?'),
 ('5قaܨϘ	#bu', 'wp-includes/js/dist/compose.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R\"iq׳', 'tq)l=+ƪ?#\'B˫/[R}\Z', '', 0, '?'),
 ('IԬlv0O', 'wp-includes/js/dist/core-data.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'0jz\nT>3gM', 'K(x)2|z%9uOO¬ɴ', '', 0, '?'),
 ('x2_.~$)', 'wp-includes/js/dist/core-data.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'JЉ( u/1g5', 'nax-mPZk=9d)b7ZNc', '', 0, '?'),
 ('\n /Y', 'wp-includes/js/dist/data-controls.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uǠQ_?˫', 'a1ouj\Z\nfMb1 ', '', 0, '?'),
 ('!>лӊ^[U}', 'wp-includes/js/dist/data-controls.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+M]4;v', '@Ȅidސ.&u#-ẻ', '', 0, '?'),
 ('gֿm㋣I', 'wp-includes/js/dist/data.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Jd}2E_t', 'p*\\^\\hYZ(Ᏼg\\=z.dz', '', 0, '?'),
 ('\"NMkVO', 'wp-includes/js/dist/data.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!s\'', 'Jc<Kf*M}}У$lFz', '', 0, '?'),
 ('Glݠ_', 'wp-includes/js/dist/date.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hVbئkJs', 'X:Gʰ}$D\\hUQ\'u', '', 0, '?'),
 ('\"J2\rߤ-H&', 'wp-includes/js/dist/date.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TVz`nmcY?$', '-f%YrXo9ʱ=', '', 0, '?'),
 (';Wl', 'wp-includes/js/dist/deprecated.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2\'Л偠4$8', 'WH|S\0$k+,/bb\r', '', 0, '?'),
 ('ϋД\'OtʗM;', 'wp-includes/js/dist/deprecated.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'o6$7d(9W[ׂ', 'eֻ\0.jHJ]\\', '', 0, '?'),
 ('k\'\n+&=n`3', 'wp-includes/js/dist/dom-ready.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ք|byl', '\ZhY0ϲ)96HBC-t_', '', 0, '?'),
 ('ҡK%^', 'wp-includes/js/dist/dom-ready.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[э9(7*2', '4<nw..#jp(g	BI', '', 0, '?'),
 ('B\"^I\nhƜ', 'wp-includes/js/dist/dom.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>4zyg', '\"ɈN{(tqXjNn', '', 0, '?'),
 ('{xZc\"hb?', 'wp-includes/js/dist/dom.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'M0j:?k+', 'uF:K\'TBm\'OGRʉ!a', '', 0, '?'),
 ('` ƢXv{;', 'wp-includes/js/dist/edit-post.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zjHq-Hɤ[<', 'R+I\'|sbh]#L', '', 0, '?'),
 ('qR+q\Z2', 'wp-includes/js/dist/edit-post.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{k\ZRu', '[^2>jlr&ueCfhv', '', 0, '?'),
 ('	Ieԩ[G_6', 'wp-includes/js/dist/editor.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ƻ-C܋9RĹ', '`vmNEGO9RޱE5G', '', 0, '?'),
 ('͌%+e@uQ(', 'wp-includes/js/dist/editor.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+䱒S5$՚', '@a2?GV\nL\\,.EJX', '', 0, '?'),
 ('8R6>G\"', 'wp-includes/js/dist/element.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zq!a\0k()', '՗ݡeExc%E', '', 0, '?'),
 ('E5;tR$L', 'wp-includes/js/dist/element.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'IK3vc;x', 'cyoNZۥb!7pA', '', 0, '?'),
 ('Y/ޑ	\Z', 'wp-includes/js/dist/escape-html.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۓp[m9&=\r', '	kAhR=|\'`E)\0D0|', '', 0, '?'),
 ('	Ӱꅑc', 'wp-includes/js/dist/escape-html.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{\0KvMjm', 'Bl2=!C)', '', 0, '?'),
 ('hQKV<r:Mg_', 'wp-includes/js/dist/format-library.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'P÷*cʄ', '+9YY){dFB?', '', 0, '?'),
 ('&k\0v_fcbv', 'wp-includes/js/dist/format-library.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y U)t~j	l', 'x]3{<-r0@M7*4Z7PQ', '', 0, '?'),
 ('Ӏ9[M-g', 'wp-includes/js/dist/hooks.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ǣڮ!Tl	^', 'Jkme󥄃SϪ2&WAϕQu', '', 0, '?'),
 ('!w<A\n@O', 'wp-includes/js/dist/hooks.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7\'OˣVB\\', '$Q}mw	+ҽ:á2', '', 0, '?'),
 ('`a(g\"', 'wp-includes/js/dist/html-entities.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0R[Z=Ag7ΰ9', 'Sޤamj\n+}%wŮ%O>x', '', 0, '?'),
 ('?=@M$#P7', 'wp-includes/js/dist/html-entities.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pJ^.X', '\nVj8웾G=|GN>aE$', '', 0, '?'),
 ('#u0c}', 'wp-includes/js/dist/i18n.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@d;W>c', 'a\nMX|\'b_\Zts=', '', 0, '?'),
 ('inj/r', 'wp-includes/js/dist/i18n.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\']5ԃ', 'sL$Tc)P/?#lxѶYT(0Ul', '', 0, '?'),
 ('gU)\rR(', 'wp-includes/js/dist/is-shallow-equal.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#~7Ѭt', '/{߁\Z\0T&m2Fğ>', '', 0, '?'),
 ('r=cMz', 'wp-includes/js/dist/is-shallow-equal.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b|w&z,Z', 'E:YDng[C-k#', '', 0, '?'),
 ('!ہIǵ`8t', 'wp-includes/js/dist/keyboard-shortcuts.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v4ceu§zv', '.Hjqp]o	k,2սrd!', '', 0, '?'),
 ('=噄\nAK(l', 'wp-includes/js/dist/keyboard-shortcuts.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GJ13DK', ' )M.+Rn;Bk*we,Õ2߫u\'\\', '', 0, '?'),
 (']ǿ|IC', 'wp-includes/js/dist/keycodes.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	3G^TC	繥В', '\0(.ged,!,氟4NQ', '', 0, '?'),
 ('*V.XZ_C[AԀC3', 'wp-includes/js/dist/keycodes.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{ѸPxLj>', 'vijG!\0#-7z/NsYۍ', '', 0, '?'),
 ('(Օ)(pwBl', 'wp-includes/js/dist/list-reusable-blocks.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-xrd$PG', 'iV	.m̈́ؕ#xجg,>', '', 0, '?'),
 ('!xx+![(', 'wp-includes/js/dist/list-reusable-blocks.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+O\Z1[F', 'g=\0R-Ws5FY6', '', 0, '?'),
 ('JB&9:VF[', 'wp-includes/js/dist/media-utils.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1Q{)', '\n\nԕ$S\"qH^4꼉\\', '', 0, '?'),
 ('ܟҿB∶', 'wp-includes/js/dist/media-utils.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0CzthgF', '/%꤁#R0]\r^=_', '', 0, '?'),
 ('Kȁ;$z', 'wp-includes/js/dist/notices.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f@@-=z/', '^qZ۵߸N_aPd[sE\'', '', 0, '?'),
 ('lZq#eS%s7Y', 'wp-includes/js/dist/notices.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vCOE]ݣ', 'PkzXA\01/YR]҂E;8', '', 0, '?'),
 ('ZuiigԄ', 'wp-includes/js/dist/nux.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D?n}', 'ܧS>G1`CyO̲ͩ˚u', '', 0, '?'),
 ('Asvg4U', 'wp-includes/js/dist/nux.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '98nD-Ҝi', '0]yZWk)}/R1j@hmD,;', '', 0, '?'),
 ('ƬSXZ3', 'wp-includes/js/dist/plugins.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's:;F~\'', '@zt`YwsuL\0,nLS', '', 0, '?'),
 ('Hr #w/:4', 'wp-includes/js/dist/plugins.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ߧ˕su8', '\nWrEGg+Ґn', '', 0, '?'),
 ('W:]', 'wp-includes/js/dist/primitives.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[km2dwK@H', 'jVnT+ěZj륔;l~d', '', 0, '?'),
 ('L,\Z\"\0Cʡ8y', 'wp-includes/js/dist/primitives.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'J7\ZS', ':!uKG.\"O%gHG+\"ujPx', '', 0, '?'),
 ('y52m\0l\"e', 'wp-includes/js/dist/priority-queue.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8%2M\"&x_', 'IYiZ\'b50VyQ\nMZ$l', '', 0, '?'),
 ('ۋ{S0\0\0=1_ئ\r5', 'wp-includes/js/dist/priority-queue.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c5/\\\Z', '@h<~ٟGa{WqǾҳ^7ۉ', '', 0, '?'),
 ('fk[x \\/Y', 'wp-includes/js/dist/redux-routine.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'iwSQ#݌', 'ArawXɆŌR`|	4ָ^g(', '', 0, '?'),
 ('7[*wJ\nn>', 'wp-includes/js/dist/redux-routine.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!@AKe;\"', '<S-r?yD)TU!fqq\ZQD\Z', '', 0, '?'),
 ('_)0d|6_;n', 'wp-includes/js/dist/rich-text.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pp^fk`', '	Hk x1\'nC}dK', '', 0, '?'),
 ('--ü$);J5', 'wp-includes/js/dist/rich-text.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vM_Sc', 'v\'U_eĕ\'ctq1|', '', 0, '?'),
 ('y0H#;e\n\"+', 'wp-includes/js/dist/server-side-render.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~%m*==`', 'D캰E8)fxyDXt=(/', '', 0, '?'),
 ('$c{97^ІJg', 'wp-includes/js/dist/server-side-render.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`豋RJ^XL3', 'gH/z0I¿1Vʕu\Zڱ-', '', 0, '?'),
 ('oS]~(7;\r', 'wp-includes/js/dist/shortcode.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\T{>p[c', 'y91h^-YOY\n\n5)NA\r', '', 0, '?'),
 ('fR/1< PC', 'wp-includes/js/dist/shortcode.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0ɥj_FDQ', 'F88_zNdJ	n\nr^j睟', '', 0, '?'),
 ('H~\nx|', 'wp-includes/js/dist/token-list.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cE0R{,!R0', 'l<JRADmRN#&LůhX}Udaj', '', 0, '?'),
 ('&[>j/GU', 'wp-includes/js/dist/token-list.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'agVI9Č', '\0lxVlzJCzVzQ', '', 0, '?'),
 ('1pa`H0ߢe', 'wp-includes/js/dist/url.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vz%lH?', 'U# ~KR%/@H5', '', 0, '?'),
 ('oRb', 'wp-includes/js/dist/url.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tjљ_', ' H7Qzm_fCy]kZCP', '', 0, '?'),
 ('䑖w7:\'h*', 'wp-includes/js/dist/vendor/lodash.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(]uV;', '@W0BɷI\01MŗVs', '', 0, '?'),
 (',5XpBFdcj+', 'wp-includes/js/dist/vendor/lodash.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DPh9z', '[L3Y2R%\n$JbdĳQ5I', '', 0, '?'),
 ('&	AH)I&', 'wp-includes/js/dist/vendor/moment.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g\"[ewC081U', 'ynX$\",Dce~9c$', '', 0, '?'),
 (']숊YTXm+%', 'wp-includes/js/dist/vendor/moment.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~`wZƼ)h', '%}-)~MwT=gH!', '', 0, '?'),
 ('Lap8gV,g', 'wp-includes/js/dist/vendor/react-dom.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"I;', ')ͮzI}/?/+1k\n', '', 0, '?'),
 ('A`k{n/*ScN', 'wp-includes/js/dist/vendor/react-dom.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YFx6\"hE', 's\0+,]4jӡ]+l', '', 0, '?'),
 ('|X%jgu@CJM', 'wp-includes/js/dist/vendor/react.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<vyzp', '_/qAI1H\n)5/ƒ4', '', 0, '?'),
 ('W31Ngפ', 'wp-includes/js/dist/vendor/react.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xp\nmt5r/', ';D)=L:#w>K	<sEcEo', '', 0, '?'),
 ('䆮G*~5HI', 'wp-includes/js/dist/vendor/wp-polyfill-dom-rect.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lS?,ra4;^F', 'D;䏑eHib\Z?b', '', 0, '?'),
 ('0$X8FnŃk', 'wp-includes/js/dist/vendor/wp-polyfill-dom-rect.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%y徎:', '뚦:4*y|¿j~Υka\r`@', '', 0, '?'),
 ('۝w6Uu%', 'wp-includes/js/dist/vendor/wp-polyfill-element-closest.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<j <Yt#&', 'yNOBӻ]&6M-J.:.{', '', 0, '?'),
 ('#6K%#f\r', 'wp-includes/js/dist/vendor/wp-polyfill-element-closest.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H0c;`W&', '2A]ڛ\\eWߦkZsc<`d)', '', 0, '?'),
 ('7kXfXmS', 'wp-includes/js/dist/vendor/wp-polyfill-fetch.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'El*IeNZaK', 'K+|̫M5Jy0Itlol', '', 0, '?'),
 ('w]cIwȰH', 'wp-includes/js/dist/vendor/wp-polyfill-fetch.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	E&\'ҩ;@kZ', 'Lݏq;FX:tB7vGqn3ÐkI', '', 0, '?'),
 ('ve׶\\l.х{', 'wp-includes/js/dist/vendor/wp-polyfill-formdata.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '883x\r', 'Xrq-N)nhlL$', '', 0, '?'),
 ('g+wJoG{b', 'wp-includes/js/dist/vendor/wp-polyfill-formdata.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.2ңA!V0I', '\"CG9^ȷ1a?auk`', '', 0, '?'),
 ('=Ѷ8$', 'wp-includes/js/dist/vendor/wp-polyfill-node-contains.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w%[U3', 'EtzfD:x?ocڋ	8P', '', 0, '?'),
 ('~qIPIr', 'wp-includes/js/dist/vendor/wp-polyfill-node-contains.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-\\doG\n2', 'Sa)ʗn&BV~11\'w(', '', 0, '?'),
 ('|G$k', 'wp-includes/js/dist/vendor/wp-polyfill-url.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>dKP\'IC38', 'kz:_sDpxe%J	ST_', '', 0, '?'),
 ('\\]^Tꥊ', 'wp-includes/js/dist/vendor/wp-polyfill-url.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rt\0XdxR`', 'bՔW?gtRċ\\}DETӇ=', '', 0, '?'),
 ('e:֬p6', 'wp-includes/js/dist/vendor/wp-polyfill.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YA\"ZqUq', '\rڃ?HOzDr\n\\d܈_qC', '', 0, '?'),
 ('2\\17Հwi{', 'wp-includes/js/dist/vendor/wp-polyfill.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}.$K>8-', '.C\\\rǅ#gLK0Ĳ', '', 0, '?'),
 ('/8&Dg|#', 'wp-includes/js/dist/viewport.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Nc#i%;ܳ\0', '0]^Fl6\npuY4:A', '', 0, '?'),
 ('	hXk%>{NB', 'wp-includes/js/dist/viewport.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1=gh_', 'ygz7l4o )4|rbu\rP', '', 0, '?'),
 ('n,Q3bO', 'wp-includes/js/dist/warning.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*E<4`9^r', 'AU)]⦧S70', '', 0, '?'),
 ('qsAtd\\', 'wp-includes/js/dist/warning.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۄUQWs	', 'BNJ砫M~&%k#K+^k', '', 0, '?'),
 ('2D%J?\Z', 'wp-includes/js/dist/wordcount.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9||s\'W', 'A\0rf_\'u(\'\05ngg', '', 0, '?'),
 ('&@pɗ', 'wp-includes/js/dist/wordcount.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l\"71F!', 'NMZJ\'Zh\'.K< }:', '', 0, '?'),
 ('!(t<Թ', 'wp-includes/js/heartbeat.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x-`v$6oh', 'ܳ5 \n8RǚfK9X', '', 0, '?'),
 ('n97I.Oҝ޿', 'wp-includes/js/heartbeat.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Xa+h%\"7', 'eY9x(<,ŁЉx', '', 0, '?'),
 ('ygzaU\"	XKG', 'wp-includes/js/hoverIntent.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z/Pꮱ<	', 'tneTR/77@\Zҧ0gǌ', '', 0, '?'),
 ('S.FȫAj(:', 'wp-includes/js/hoverIntent.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3\"~V&l', 'e8+\0SRӍoաcݝǫSuP', '', 0, '?'),
 ('nNd', 'wp-includes/js/hoverintent-js.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' p.`u76?', 'Y!:\nAː	ګZg,=|', '', 0, '?'),
 ('^^\\Q=(w', 'wp-includes/js/imagesloaded.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bAd2', 'MD;1g$u\ZGMAb$M.t', '', 0, '?'),
 ('%bQbM<x', 'wp-includes/js/imgareaselect/border-anim-h.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z,ntZ^6{Lp4', 'qschm-%x\ZBx\'E:', '', 0, '?'),
 ('F\"vh$Lb', 'wp-includes/js/imgareaselect/border-anim-v.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' z!<7*', '>d:j1<!46g', '', 0, '?'),
 ('<FPz22~', 'wp-includes/js/imgareaselect/imgareaselect.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}(()3󵕯', 'q!ݿJӇi\nE5s!\r%', '', 0, '?'),
 ('8/B$8`m', 'wp-includes/js/imgareaselect/jquery.imgareaselect.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XCJa_M', 'nP>o~Q^d|	Q[AHbBlB', '', 0, '?'),
 ('ͤ6\0/k', 'wp-includes/js/imgareaselect/jquery.imgareaselect.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-16	ߨۈ)', '3ٽ*wfqxraVQ', '', 0, '?'),
 ('SX+71?-', 'wp-includes/js/jcrop/Jcrop.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z7eQ%K', '!@X7JŃp3K;S*!L', '', 0, '?'),
 ('g\"}_7J5', 'wp-includes/js/jcrop/jquery.Jcrop.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V̞/Kx', '2S[6Dv5bs=NLw', '', 0, '?'),
 ('T.o@Ψ2wvX', 'wp-includes/js/jcrop/jquery.Jcrop.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/aLru4\Z', 'Ϸydix{p+neځf', '', 0, '?'),
 ('vޣR', 'wp-includes/js/jquery/jquery-migrate.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5	\"\02', 'Oͭz%(s!?,e\n\'\Zɀ+', '', 0, '?'),
 ('a@o\'kb', 'wp-includes/js/jquery/jquery-migrate.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q!NS XdcQ', '|\02+Audm5ǉ', '', 0, '?'),
 ('ʙ\0}甠K.', 'wp-includes/js/jquery/jquery.color.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rq*XgqO(͈', 'x2<kQݯ{', '', 0, '?'),
 ('vҸ);D~J\"q', 'wp-includes/js/jquery/jquery.form.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Њn=if5]', '5\\\'=\'*m%,kC!<2m=', '', 0, '?'),
 ('&=\Z+t\"/k\'\n', 'wp-includes/js/jquery/jquery.form.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`vwP5Q4!)', '9^ɸIok{ژ2oxz_;CL ', '', 0, '?'),
 ('P\Z/l%', 'wp-includes/js/jquery/jquery.hotkeys.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '┃&݋\rFư', ']!G3[#:L\r:vC>', '', 0, '?'),
 ('-plEk/', 'wp-includes/js/jquery/jquery.hotkeys.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S!}EU\\bgh=', '\ZJ]x ծTc0n9  +Vk', '', 0, '?'),
 ('g#,vM:', 'wp-includes/js/jquery/jquery.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I.{ܛS', 'g/igEȯ]3v6E\'Dd4gf;', '', 0, '?'),
 ('c,[xޫ3\n@', 'wp-includes/js/jquery/jquery.masonry.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@`&n|}A', '\\ۙ	}Mg $0 [B', '', 0, '?'),
 ('{)4e4p:fW', 'wp-includes/js/jquery/jquery.query.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';XzǰwC', 'ug^+imG\rFxiX', '', 0, '?'),
 ('(g%\04l>', 'wp-includes/js/jquery/jquery.schedule.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&Tkf؞', '?vEʔwjCP՝_', '', 0, '?'),
 ('qh665y|=?S	', 'wp-includes/js/jquery/jquery.serialize-object.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\)Jl<\"', 'D{zp\r]<@7>0(h', '', 0, '?'),
 ('0<PsמH22', 'wp-includes/js/jquery/jquery.table-hotkeys.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '֔#tgPg', ':Afxׂd7#', '', 0, '?'),
 ('򱠭BRzY', 'wp-includes/js/jquery/jquery.table-hotkeys.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ogo~iI	', '<=;:t_,wăI,,', '', 0, '?'),
 ('mY}ɽ?', 'wp-includes/js/jquery/jquery.ui.touch-punch.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LmQ4փ]', 'k>jT@z՜.OBj0\'t', '', 0, '?'),
 ('Ƭ+\ZId^i <\0', 'wp-includes/js/jquery/suggest.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':$tVEʿ', 'r,Kpŗrq^b\\=rZ]6+', '', 0, '?'),
 ('3Ƈe(ú9', 'wp-includes/js/jquery/suggest.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's\\+A)n.;', 'I<{\04`<!jZ8돲DHW', '', 0, '?'),
 ('6٨	:{^D', 'wp-includes/js/jquery/ui/accordion.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|BI`-~H	f>', '^e@Å>}ZT6L1\\', '', 0, '?'),
 ('gEd1D}', 'wp-includes/js/jquery/ui/autocomplete.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0f\"i!', '&\nstϛ@#NgC;a:7^PX', '', 0, '?'),
 (']/~qXŎE', 'wp-includes/js/jquery/ui/button.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a`v,L*	ҹAi', '0xWb[v*,2\'u4{jxȆ', '', 0, '?'),
 ('%y>}Ho(6', 'wp-includes/js/jquery/ui/core.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'e%>Nx+', '5{`9GR\ripYiwEt\Z', '', 0, '?'),
 ('@k/I?T,', 'wp-includes/js/jquery/ui/datepicker.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'p\rQS3V', 'B3e3g+=\"\"gSOf&BĴ', '', 0, '?'),
 ('Fe}(', 'wp-includes/js/jquery/ui/dialog.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Г?[U^!~/', '2>nZ\\F]gO{Q6cK_', '', 0, '?'),
 ('p7uL_{2Û', 'wp-includes/js/jquery/ui/draggable.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'WfոܗT<', '}a)˨Ͻj|{', '', 0, '?'),
 ('z|zxv', 'wp-includes/js/jquery/ui/droppable.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@@^Ӟ٠', 'k|=NRPC\0b(=TԈJ.8$', '', 0, '?'),
 ('&cYD#P{+', 'wp-includes/js/jquery/ui/effect-blind.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Li1\0qo', '-`tYx:1/\'|xǭ\'', '', 0, '?'),
 ('a5[45MepC', 'wp-includes/js/jquery/ui/effect-bounce.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rؙ!bt(w', '\'1|\r?PJnZ	TK w6', '', 0, '?'),
 ('U$\\*1^S', 'wp-includes/js/jquery/ui/effect-clip.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')K[stskB?3', 'H,,\'4EIyRrv=', '', 0, '?'),
 ('D\rh}!\n', 'wp-includes/js/jquery/ui/effect-drop.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ym*0OX^|', 'N<_/R,^f\nBwV', '', 0, '?'),
 ('ϊ=XbBz\' ', 'wp-includes/js/jquery/ui/effect-explode.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/h	(ً+V', '皴$e]~LTܥU0`', '', 0, '?'),
 ('AG,<', 'wp-includes/js/jquery/ui/effect-fade.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '04Uw Z+1V', 'A-yJ6{G2G@r!\ZDp', '', 0, '?'),
 ('P\0\'0lv#J<', 'wp-includes/js/jquery/ui/effect-fold.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ޖj0', 'FI3 ũ<TƌA\"S8+YT', '', 0, '?'),
 ('{Mii2n6', 'wp-includes/js/jquery/ui/effect-highlight.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Bp+I؎\nu_', '\'#l\0DȒ݁\Z*va', '', 0, '?'),
 ('8`9?BbБ', 'wp-includes/js/jquery/ui/effect-puff.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G;Lws', 'H.lq7L`im^', '', 0, '?'),
 ('8(\ZjZ]}', 'wp-includes/js/jquery/ui/effect-pulsate.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '抨$rk3E`', 'eCxv[a	A4n', '', 0, '?'),
 ('4;V\'/f', 'wp-includes/js/jquery/ui/effect-scale.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a\"b', '\Z;][.\nV>DAM', '', 0, '?'),
 ('NVԱzZ', 'wp-includes/js/jquery/ui/effect-shake.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R|Ta*r\\', 'FGa?Mo̄>l\"4\'Pl]D!', '', 0, '?'),
 ('~w`5;F㮮', 'wp-includes/js/jquery/ui/effect-size.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pk.Ǔ@.', '3\075IqBg}҃Tc:', '', 0, '?'),
 ('Y]ŞI', 'wp-includes/js/jquery/ui/effect-slide.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!bY.H;er', '}<fB*#@^SH4Vx', '', 0, '?'),
 ('l.H|S{', 'wp-includes/js/jquery/ui/effect-transfer.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-TmƦ', 'EڼPJtqrcIa,.1nVH', '', 0, '?'),
 ('ݙP(O\'Ee', 'wp-includes/js/jquery/ui/effect.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1G\'3+ʆBB	', '@ 7e(,<0F\nV@U\'5', '', 0, '?'),
 ('7c¢)Seb', 'wp-includes/js/jquery/ui/menu.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+34M	`', '1D\'eC$;wkG0fs', '', 0, '?'),
 (':x=}', 'wp-includes/js/jquery/ui/mouse.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ɪ9r\'rf', '\0&BIrh&FBW3p^b|', '', 0, '?'),
 ('nefA@R?', 'wp-includes/js/jquery/ui/position.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4oM)EξuS#/~', '6]pt=VXڦfY', '', 0, '?'),
 ('=fuA><Th@', 'wp-includes/js/jquery/ui/progressbar.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4ǌ3~ei7=', 'Fd62l(A/[=o.*~o', '', 0, '?'),
 ('-i>bs1', 'wp-includes/js/jquery/ui/resizable.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D\Z`^0Gtc6٩S', 'uuu4EIx&HngoNCݝ', '', 0, '?'),
 ('v\r&X', 'wp-includes/js/jquery/ui/selectable.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'z1/|۶!', ',jf+a`#*kۦ\ri', '', 0, '?'),
 ('S0־K/17u', 'wp-includes/js/jquery/ui/selectmenu.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NW#뙂ߊk{zu', 'Ye\Zp+RT[?(I2W~@\'L	', '', 0, '?'),
 ('\\AV*籿', 'wp-includes/js/jquery/ui/slider.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lU򳥝', '2?L+p@7X5E', '', 0, '?'),
 ('m-\Zm1w', 'wp-includes/js/jquery/ui/sortable.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"&\"\04	]I', 'P̓YlMy\Zj_A3v', '', 0, '?'),
 ('mE\\)o', 'wp-includes/js/jquery/ui/spinner.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '֋XKe,', 'M- LhsJ͍CB', '', 0, '?'),
 ('(5aHyo,X', 'wp-includes/js/jquery/ui/tabs.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ѵz,W1>B9/yU', 'Џ~c)8y5]c?', '', 0, '?'),
 ('-_+YnS', 'wp-includes/js/jquery/ui/tooltip.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&A ~ǔ', '@jsĵMBx\"rY*', '', 0, '?'),
 ('!&i)^WR', 'wp-includes/js/jquery/ui/widget.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0V2M:;,<', '5<8SIR\rAssf[HD3', '', 0, '?'),
 ('*\Z07ѥ1Oَ8', 'wp-includes/js/json2.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's{N|EO0', 'q3..j G\\RnݼI/T-', '', 0, '?'),
 (')(<', 'wp-includes/js/json2.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's>O%	Nqf', '=`H#e>Oꥧqj}ŋ', '', 0, '?'),
 ('| ', 'wp-includes/js/masonry.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Տzq|*zV@', '`\r$#+\njK=n~_u U+', '', 0, '?'),
 ('rr(Jg(yt', 'wp-includes/js/mce-view.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BN>r&D', 'yaBN0O/3չu^TH\'', '', 0, '?'),
 ('f%uP', 'wp-includes/js/mce-view.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~LIj}', 'ji@߄۬d1ij͔.b\0	P', '', 0, '?'),
 ('{0l(Ʋu9,wSu', 'wp-includes/js/media-audiovideo.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'жt\Z', 's<~d;lLn_u+1jDO\\\0', '', 0, '?'),
 ('GV\\z#!;', 'wp-includes/js/media-audiovideo.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ޖ*x!w*', '?kE>5r:;6k$Oq|L\Z', '', 0, '?'),
 ('uN.A__', 'wp-includes/js/media-editor.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'q!h_0i', '0zw\ZV@YF-B!qk;^e|G', '', 0, '?'),
 ('	,/Օ!gyd', 'wp-includes/js/media-editor.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_5Jy]5d', '*a^#@rG<Cpp\ZJ', '', 0, '?'),
 ('R\\SC|ju9A', 'wp-includes/js/media-grid.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gW]ݬ08)', '=b.^98ɸP}7K}觇', '', 0, '?'),
 ('YRYi/l@HX', 'wp-includes/js/media-grid.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '?E\ZZ\\', '1*!Htw~|?1', '', 0, '?'),
 (')_J', 'wp-includes/js/media-models.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L FǙTEAj', '⟼\0YUU:AU', '', 0, '?'),
 ('F GJBs7', 'wp-includes/js/media-models.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nX\0䛜', 'n&\'oU_=&%9\0GZV;', '', 0, '?'),
 ('ȉV?	])A', 'wp-includes/js/media-views.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I0ėy', 'eO1߻&9wF\0#|5', '', 0, '?'),
 ('E?Юᾠ', 'wp-includes/js/media-views.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wYZ* qAE&~', '$_4~0oמIo<S߾3r>', '', 0, '?'),
 ('.xϮ7_', 'wp-includes/js/mediaelement/mediaelement-and-player.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2=XIC', '`RQ(2h>ru9Y߭ێ	', '', 0, '?'),
 ('y!\0pZ[A', 'wp-includes/js/mediaelement/mediaelement-and-player.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4221M?', 'STS؅׳#~*:w(', '', 0, '?'),
 ('|BlIHҼOSƱ', 'wp-includes/js/mediaelement/mediaelement-migrate.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<C_hz3<7', ',b#0!aOVc,ؕSԏIл%p)', '', 0, '?'),
 (']L0eE\"u ', 'wp-includes/js/mediaelement/mediaelement-migrate.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Re#B-{:', 'aI&CX\\;⩄\nC%;', '', 0, '?'),
 ('zZfip^2׎', 'wp-includes/js/mediaelement/mediaelement.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LXsįOS', ':^5[ߖvb`Yi', '', 0, '?'),
 ('OOwTM\rY!d', 'wp-includes/js/mediaelement/mediaelement.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(6DEaM\r', 'U82hPGrKƌ81E!Z', '', 0, '?'),
 ('^U.iypG', 'wp-includes/js/mediaelement/mediaelementplayer-legacy.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'AVtFƣ', '2q{Y*lX[qkd}Jp', '', 0, '?'),
 ('nQʒ\'k\"%', 'wp-includes/js/mediaelement/mediaelementplayer-legacy.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '</M0F!\'Gw ', ']O?ո>Xzb%أ', '', 0, '?'),
 ('Ws$8~Nȁ-@', 'wp-includes/js/mediaelement/mediaelementplayer.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1ĪL5!\n', 'o^:v\\mocTW[k', '', 0, '?'),
 ('	?quM', 'wp-includes/js/mediaelement/mediaelementplayer.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#\'\r', 'ۖ:8l B?q+6yq=5Uq:bbۺ82', '', 0, '?'),
 ('d@!dJ', 'wp-includes/js/mediaelement/mejs-controls.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '.۷Z#e0<l', 'X*\ZX(Z!ȽD2aB', '', 0, '?'),
 ('bz/T7aHy', 'wp-includes/js/mediaelement/mejs-controls.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^yq+S%y', 'hA3L:\'1ꁠ\\', '', 0, '?'),
 ('\";+\rxuw', 'wp-includes/js/mediaelement/renderers/vimeo.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Nѝhsl-a', 'V%y4!6n5s\'TY', '', 0, '?'),
 ('T܌7`\0(', 'wp-includes/js/mediaelement/renderers/vimeo.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gx`\Zg, }', 'Csd,,;ͅqmu', '', 0, '?'),
 ('ShS%Tz', 'wp-includes/js/mediaelement/wp-mediaelement.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%/NqORg+\\', 'F}\Z\nvn`Z!TWs', '', 0, '?'),
 ('D]|߼$', 'wp-includes/js/mediaelement/wp-mediaelement.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(Dq|', 'PE+#Ms;agLeSMNr=', '', 0, '?'),
 ('M~\nT|', 'wp-includes/js/mediaelement/wp-mediaelement.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ꕂvEK?\r~_', '!?[_r=&\n-%!y\r', '', 0, '?'),
 ('N9{;', 'wp-includes/js/mediaelement/wp-mediaelement.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U)zCss2N\r', 'y	Н>~%\Z<#U>&', '', 0, '?'),
 ('6X/HL', 'wp-includes/js/mediaelement/wp-playlist.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xl\"o', '/=àBAo&I1]k~N', '', 0, '?'),
 ('ˤԐ{%k#f', 'wp-includes/js/mediaelement/wp-playlist.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3|G^cKT\"', '\'e\"ʌ_(nfww\ZN2+ ', '', 0, '?'),
 ('JE[7U\Z~', 'wp-includes/js/plupload/handlers.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qtaha&*:>', 'SV7WH+^\nt\ZTׂQ', '', 0, '?'),
 (';(Xp`ҙpݷ', 'wp-includes/js/plupload/handlers.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n#\0(mklA', 'rI\ni6w\Z=eM(', '', 0, '?'),
 ('VڮMjӁ', 'wp-includes/js/plupload/license.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u&\nTIz+', '\0v1sN>cID٦I0-', '', 0, '?'),
 ('a)6ю', 'wp-includes/js/plupload/moxie.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#C\r5Ǳǒ', 'I9_/xt5(.gtT\Z}&', '', 0, '?'),
 ('LVY*', 'wp-includes/js/plupload/moxie.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[n/v5px', '0,],\ZZ7~3@', '', 0, '?'),
 ('ߔHu&', 'wp-includes/js/plupload/plupload.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ݠ$pZR>\'|', '\"8[J%.˚cV\r\rE)\'', '', 0, '?'),
 ('v:DYG', 'wp-includes/js/plupload/plupload.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%ǿ\nMaco|', 'R:K2c~nvB\r(Rh', '', 0, '?'),
 ('5C)\nWu꽝/FcK', 'wp-includes/js/plupload/wp-plupload.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!l0QW*+', 'Pf7\'q*Tg.u\\<)FRMq', '', 0, '?'),
 ('Le5x?e=&', 'wp-includes/js/plupload/wp-plupload.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '̓~ʲ[=~8\\GVT', '_7 aXb&h~o\0{2l', '', 0, '?'),
 ('?h;', 'wp-includes/js/quicktags.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':}҈P٭', '=/f2A|d<zNK=', '', 0, '?'),
 ('ߌ(2', 'wp-includes/js/quicktags.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G8 Hߊnv:c', 'YWpt\r`0O\"ɚNf@kuoy', '', 0, '?'),
 ('ˍG䯀oeo', 'wp-includes/js/shortcode.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@P}SΊ', 'yaeaKR\0%xyuy↢', '', 0, '?'),
 ('g]bR% ZE', 'wp-includes/js/shortcode.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[7YO\nC', 'cJaSϟ?_%', '', 0, '?'),
 ('Or#TG!', 'wp-includes/js/swfobject.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',I}pe~2q', '?Lw.4MՒFJ>fI鴆', '', 0, '?'),
 ('M٦M/`', 'wp-includes/js/swfupload/handlers.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*#0-Ճp', 'H#a:1߯orrjuzzV', '', 0, '?'),
 ('`#GbC֊', 'wp-includes/js/swfupload/handlers.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'jڙK~q	c=', 'T򌿑dTy~#jI\"++3ɉ', '', 0, '?'),
 ('\Z-x7(A4', 'wp-includes/js/swfupload/license.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[`^-oQWz', ':)6a\"3r\rP\rN4yJַUq', '', 0, '?'),
 ('$xM1>_8P\0', 'wp-includes/js/swfupload/swfupload.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#9>&YRg', 'ݙRYY-ҕ&qW1(K', '', 0, '?'),
 ('	1А々S:(', 'wp-includes/js/thickbox/loadingAnimation.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"h\rc&', 'BF`F-lڛRT6Յ', '', 0, '?'),
 ('tZO\' \n', 'wp-includes/js/thickbox/macFFBgHack.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ȰgW,/u', 'Rw/h&q]Z_Ngy', '', 0, '?'),
 ('v{LJlōYz`(', 'wp-includes/js/thickbox/thickbox.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i֪[-G', '1\rcE^eAB4xz[', '', 0, '?'),
 ('AE[`', 'wp-includes/js/thickbox/thickbox.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HsTX{B$٭6', ';@0({oifKϤEQ', '', 0, '?'),
 ('9:do\np`Ry', 'wp-includes/js/tinymce/langs/wp-langs-en.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 's/q', 'Ts%SZ', '', 0, '?'),
 ('	vO.|ߤҵ', 'wp-includes/js/tinymce/license.txt', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ox:`', 'Y#wOg^\'b:^	=跨|', '', 0, '?'),
 ('\n$zX`1Bw', 'wp-includes/js/tinymce/plugins/charmap/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\5^', '[B\Z,;jfeMUj|)rv>UF', '', 0, '?'),
 ('k$6O-Nx', 'wp-includes/js/tinymce/plugins/charmap/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=B쟄P\rL', 'x[G-90b.zGaz>r', '', 0, '?'),
 ('Aa@JŁ', 'wp-includes/js/tinymce/plugins/colorpicker/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' Cȭ?d{׭V', 'BR\0!䄚Q\'5w', '', 0, '?'),
 (',< ?C]0A', 'wp-includes/js/tinymce/plugins/colorpicker/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ͶU裦h', 'ehӧ&έA3+WTh\n\Z)?', '', 0, '?'),
 ('HC!\"(', 'wp-includes/js/tinymce/plugins/compat3x/css/dialog.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '11h+ezKk\Z\"', '*3U#\n]]uho\rβ\r;5j', '', 0, '?'),
 ('gosV;\n$', 'wp-includes/js/tinymce/plugins/compat3x/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ߔOQKQu>', 'bIQLF?>G3I[\\y߈kg2', '', 0, '?'),
 ('0]qK\'fx', 'wp-includes/js/tinymce/plugins/compat3x/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'L{p׶Ҡ', 'm澑[S3\'J*Stsj', '', 0, '?'),
 ('!#I|F', 'wp-includes/js/tinymce/plugins/directionality/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '&\"X	& )=ʀ$', '&[@5(cvLYI6B;)-', '', 0, '?'),
 ('&]0W\n)=', 'wp-includes/js/tinymce/plugins/directionality/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ErHDD3@', '<o@:-Eg)6^Ѽ\'', '', 0, '?'),
 ('Pw0h9', 'wp-includes/js/tinymce/plugins/fullscreen/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y2İ\rm}%', '3].BCBeʢS( ?Z{', '', 0, '?'),
 ('sŏU\'e@d', 'wp-includes/js/tinymce/plugins/fullscreen/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ғ:K[Iw\\g', '`e	nOJM%NhA{ghf', '', 0, '?'),
 ('\\9ã>Iz4c', 'wp-includes/js/tinymce/plugins/hr/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k+%5l3!-', '2`RiL#e؄46gpo~', '', 0, '?'),
 ('v\\Q-', 'wp-includes/js/tinymce/plugins/hr/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	%>);', '؃FS[k&f 6+b>', '', 0, '?'),
 ('πtGȩD', 'wp-includes/js/tinymce/plugins/image/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B\n4\\0=', 'QvSI>;41%rf$@p\\j', '', 0, '?'),
 ('	Em[l<', 'wp-includes/js/tinymce/plugins/image/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-ZCl­}莐', 'yTNz+⃆\'%Y', '', 0, '?'),
 ('Ebl8y}', 'wp-includes/js/tinymce/plugins/link/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*NȒmQ', '`3cYQ9Wޭ#lpS+G4', '', 0, '?'),
 ('Xډ|8}B', 'wp-includes/js/tinymce/plugins/link/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V\\\n]Ks\'', '\Z>ISеv,qU^', '', 0, '?'),
 ('!RpnLwm7', 'wp-includes/js/tinymce/plugins/lists/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n:CB\"|s', '1+%cH񟳜?!#u', '', 0, '?'),
 ('J0jYgh', 'wp-includes/js/tinymce/plugins/lists/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mZu`]lg', 'TH\'d?\0O)\0D]', '', 0, '?'),
 ('`;\"-+~;', 'wp-includes/js/tinymce/plugins/media/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ujjEv\Z);', '+$e\"D%\\Xũ*?Fsvm', '', 0, '?'),
 ('ƅ|_i/y	', 'wp-includes/js/tinymce/plugins/media/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\RoeIT', '\06үbSR\Z?EOO#bI', '', 0, '?'),
 ('ƪq悳', 'wp-includes/js/tinymce/plugins/paste/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'mN9PM<I`O\0', 'qthWrrWd%mʿՃN+(-', '', 0, '?'),
 (',(i7:^^#', 'wp-includes/js/tinymce/plugins/paste/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'kkߵ,AcC;Bi', '`EnpGl\\@7GX$', '', 0, '?'),
 ('x덂@}Yi+', 'wp-includes/js/tinymce/plugins/tabfocus/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ώ@/@MmN', 'xM\'Ȥ=ڷ?$S,Fy֥', '', 0, '?'),
 ('v|-', 'wp-includes/js/tinymce/plugins/tabfocus/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!<]r', 'p[L7F|˖ZBR', '', 0, '?'),
 ('?]P.12b', 'wp-includes/js/tinymce/plugins/textcolor/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%i3f', '(ELb[K!sӊnĲ', '', 0, '?'),
 ('͓Y36lY', 'wp-includes/js/tinymce/plugins/textcolor/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v<hp', '!/[I+\rG Dխ7=\'', '', 0, '?'),
 ('G!#h9	&', 'wp-includes/js/tinymce/plugins/wordpress/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Fo5ָFNM2', '78APjn^\'NGR', '', 0, '?'),
 ('usy6\'v,=', 'wp-includes/js/tinymce/plugins/wordpress/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I浃', '\'tC6,fh&a)]', '', 0, '?'),
 ('. \0_oE]A_0PJ', 'wp-includes/js/tinymce/plugins/wpautoresize/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K.Aj_mr#i', '\'Cb\"B\\NN*r&.XJ', '', 0, '?'),
 ('}PÛP\\\Z', 'wp-includes/js/tinymce/plugins/wpautoresize/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Tcnwk$ҹ', ',@\ZG扆MWET-', '', 0, '?'),
 ('	P=N>b\"j:~[Q{', 'wp-includes/js/tinymce/plugins/wpdialogs/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'We⎆?Nt', 'n4<Fz_5kig', '', 0, '?'),
 ('3\'RKBf', 'wp-includes/js/tinymce/plugins/wpdialogs/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'QO1/<>%\"X', '6r*IY\0C9<Jږ J*xD', '', 0, '?'),
 ('<u꿖\ZܜY^', 'wp-includes/js/tinymce/plugins/wpeditimage/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j<]@	4', '\r]\"!\'sg=zķQ2NK', '', 0, '?'),
 ('6<C﮿V:(r', 'wp-includes/js/tinymce/plugins/wpeditimage/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|F&fZ', '3~鮖DZI	Ar', '', 0, '?'),
 ('%\0zfNpS', 'wp-includes/js/tinymce/plugins/wpemoji/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SEx=d~eM', '\"w%%{=L(hK\rƢHP', '', 0, '?'),
 ('@,n\\+k', 'wp-includes/js/tinymce/plugins/wpemoji/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{SmdodKs', 'x)EpNwge묀<DcMca', '', 0, '?'),
 ('u3!pAf)RM', 'wp-includes/js/tinymce/plugins/wpgallery/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_vQ8_$?', '<A06kJX\nvA/%O-v_\'pA@ئ', '', 0, '?'),
 ('Oӿ;=\\Jzy', 'wp-includes/js/tinymce/plugins/wpgallery/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '撨PHSl', 'y\n\"mc@Y)\n1Fi', '', 0, '?'),
 ('kbgS', 'wp-includes/js/tinymce/plugins/wplink/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6lUOaDQ', 'jTqTI:KZa\n6U7e-', '', 0, '?'),
 ('L)a$D-ӮJ', 'wp-includes/js/tinymce/plugins/wplink/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z{3E\'*\\7', '}2gx­	Lb8P?wّa.\0', '', 0, '?'),
 ('\"Etys\Z|g', 'wp-includes/js/tinymce/plugins/wptextpattern/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']xΑݿJ4(', '|Wy/Tu132ɖ\r7', '', 0, '?'),
 ('3+z.6Q~]y[', 'wp-includes/js/tinymce/plugins/wptextpattern/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	щ;yA \n<', '\r,]m.0MExz1p8U9', '', 0, '?'),
 ('q82v&#M', 'wp-includes/js/tinymce/plugins/wpview/plugin.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j5qS\rXi', 'Ej\Z\ZI3JGjVݒ6<S9P', '', 0, '?'),
 ('Wly:\0Vn`d\0', 'wp-includes/js/tinymce/plugins/wpview/plugin.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EY`,?J', 'l@|<ϰzb]=TQdN\0', '', 0, '?'),
 ('Z(>(1bޫZ', 'wp-includes/js/tinymce/skins/lightgray/content.inline.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\reL͸xP', '.Fx#ʬ!vې', '', 0, '?'),
 ('7&Ȁ', 'wp-includes/js/tinymce/skins/lightgray/content.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{~_I˵OK@', '%\\.\"UҚV&9\\]^d%zg$', '', 0, '?'),
 ('>/ᡇ_', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.eot', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l([qאD#', '\\sٶhb2.;m`Fr^&H-w	yV~', '', 0, '?'),
 (':X2M~', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '24vLhN!2|', '3iA(pGDڔ', '', 0, '?'),
 ('`S`NI^G', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.ttf', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(i@Gg0p', 'G</14ŅL5!', '', 0, '?'),
 ('t0ga/', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~-x\'	', '{ڋNo#X+Xe\'_>\Z', '', 0, '?'),
 ('vڴVKP', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.eot', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PNڡ\'f', '\r]~[_˳PBTA`*,O', '', 0, '?'),
 ('Qԁ27uL', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.svg', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '13y1', '	}N	<vBS%s\\S', '', 0, '?'),
 ('P0aRz= ', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.ttf', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3gkeͿݾ|h', 'Hzj鞨%p=ZiNAZ', '', 0, '?'),
 ('\Zl3Ȋ', 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.woff', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PUՒJLm8`v', 'ӛvQk\nl]`Ε۷+}kO', '', 0, '?'),
 ('>+ܞL[m', 'wp-includes/js/tinymce/skins/lightgray/img/anchor.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a5qȑ_4@', '(afoxDpaQ6mtk,V^', '', 0, '?'),
 ('L<#\Z}', 'wp-includes/js/tinymce/skins/lightgray/img/loader.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9KM:Tf9', ';TO`(6,skZcR+', '', 0, '?'),
 ('oPco.r', 'wp-includes/js/tinymce/skins/lightgray/img/object.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rdPE}u\n/MA ', '#;!I.>uʍSVm{|e-', '', 0, '?'),
 ('Xg5(=c', 'wp-includes/js/tinymce/skins/lightgray/img/trans.gif', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7I 1FGuj^', ' ûͥJOmO:ϙlW5', '', 0, '?'),
 ('>~!gq', 'wp-includes/js/tinymce/skins/lightgray/skin.min.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZP߇@X', '7>xV&v|­U& ݷ\"ǥz9jF%ѽKV', '', 0, '?'),
 ('Ĉ^A+lod', 'wp-includes/js/tinymce/skins/wordpress/images/audio.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7~!\0\"w', 'gz.gV:[ЙH)Ȟ', '', 0, '?'),
 ('FH30m:s', 'wp-includes/js/tinymce/skins/wordpress/images/dashicon-edit.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'xR	YXݤ', 'm\Zcĭ][^Pw', '', 0, '?'),
 ('c.Dr |', 'wp-includes/js/tinymce/skins/wordpress/images/dashicon-no.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'RZ?f.8	', '.c%c*G~բ>Yd:7j', '', 0, '?'),
 ('Ȅxy', 'wp-includes/js/tinymce/skins/wordpress/images/embedded.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pNy~n\"', '{ux\'Jº@i\"H;]6h', '', 0, '?'),
 ('FÃ\\Ofg', 'wp-includes/js/tinymce/skins/wordpress/images/gallery-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1vR', 'N3G\'`+R>P]Eγg/b?UX', '', 0, '?'),
 ('_f;waځ', 'wp-includes/js/tinymce/skins/wordpress/images/gallery.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_PwPU4', '<W~ض+hN91_3ws', '', 0, '?'),
 ('FHȝle#', 'wp-includes/js/tinymce/skins/wordpress/images/more-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l,r%^x%', 'Y=_b|ʧ&f,<', '', 0, '?'),
 ('N3j@pu5^', 'wp-includes/js/tinymce/skins/wordpress/images/more.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\n\nm\0;˫z', '$vo^U A\0:\\Cu', '', 0, '?'),
 ('~a%!P', 'wp-includes/js/tinymce/skins/wordpress/images/pagebreak-2x.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{6#UQ:|>#', '([\n̻oRAo3^', '', 0, '?'),
 ('#	>7', 'wp-includes/js/tinymce/skins/wordpress/images/pagebreak.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ImLWyݓH', '\rflդ/;l\\\\.6r#P[', '', 0, '?'),
 ('@{J5䷴X', 'wp-includes/js/tinymce/skins/wordpress/images/playlist-audio.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U,:)؋\"QqY', '\"Ooۈ<oES-MO÷YN!', '', 0, '?'),
 ('7%Wy~׹P?x', 'wp-includes/js/tinymce/skins/wordpress/images/playlist-video.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lzV6`wmZBs', '\r 8&J34бǽ', '', 0, '?'),
 ('3^PMYHD', 'wp-includes/js/tinymce/skins/wordpress/images/video.png', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '¶B=\rz3j', 'iI/=MMX:MApv\r', '', 0, '?'),
 ('۪	.ո\\', 'wp-includes/js/tinymce/skins/wordpress/wp-content.css', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '`Un\0\r', '>@:soX=Kdku{', '', 0, '?'),
 ('ah#8c', 'wp-includes/js/tinymce/themes/inlite/theme.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wZ.>%', 'zfl \0q9wޯ', '', 0, '?'),
 ('	#A\n#b#=', 'wp-includes/js/tinymce/themes/inlite/theme.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{HHfX	', 'F\r?)Ւ_\nn\"VCQ/I(Ӎ', '', 0, '?'),
 ('r+zk; 4WI', 'wp-includes/js/tinymce/themes/modern/theme.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/o푭f', '\n;~&խH9ēm_݉k3', '', 0, '?'),
 ('n#t=\'b]{', 'wp-includes/js/tinymce/themes/modern/theme.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'u橲^r', 'M/oX#^Փ2܇<.SK8{c', '', 0, '?'),
 ('(tTlDά7&MP.', 'wp-includes/js/tinymce/tiny_mce_popup.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B7I10d', '\'З/!\Za!~)1D', '', 0, '?'),
 ('	9fވUf', 'wp-includes/js/tinymce/tinymce.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B,:+.1]շ꾎', 'l1M7Ӯ]{e20}+', '', 0, '?'),
 ('Gm:MľVLЉ', 'wp-includes/js/tinymce/utils/editable_selects.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Jq2I\'J9E', 'vGjsf	ed&g+', '', 0, '?'),
 ('*Lm&&2\nb', 'wp-includes/js/tinymce/utils/form_utils.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lUTLi', 'vLus<*rWҪ.\0|Rg', '', 0, '?'),
 ('츃v6;~', 'wp-includes/js/tinymce/utils/mctabs.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '끡\"Y>xU季', '%Y}ڿ&)MaYgЍ*l', '', 0, '?'),
 ('4AIn097c`', 'wp-includes/js/tinymce/utils/validate.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'CL1?o+;{Y', 'kH;\0kCs	\'K#45+eE|0', '', 0, '?'),
 ('Tw=+6', 'wp-includes/js/tinymce/wp-tinymce.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2kF@Qf', '!6Kc4:eb]P,', '', 0, '?'),
 ('HԹfk', 'wp-includes/js/tinymce/wp-tinymce.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1_H0US@h', '_ؕN͞1*ǜ', '', 0, '?'),
 ('p۞2N<:Z7r', 'wp-includes/js/tw-sack.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9>', '{n]\0ֈn\r<w˷X):', '', 0, '?'),
 ('h+B', 'wp-includes/js/tw-sack.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7XwOqa', 'k\r<I-Vsp6gb4ebfsҸ', '', 0, '?'),
 ('鋭{^MU*_', 'wp-includes/js/twemoji.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!#wt+', '\Z[;βp3PKhvPs=./\\', '', 0, '?'),
 ('M;C8Yyﲏ', 'wp-includes/js/twemoji.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ǶCoYusVIT', '4\'!ë#	xW͑gnf	q[P!$', '', 0, '?'),
 ('3F<8', 'wp-includes/js/underscore.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '$bZC', '8A2xz\0<G-E	r쇮?R', '', 0, '?'),
 ('u<ex@ֈ>', 'wp-includes/js/underscore.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd&8\'V', '^\\>j\'+Xr\07ƷY', '', 0, '?'),
 ('<hj	44a2', 'wp-includes/js/utils.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '2![pNI5', 'iII4*{FZanǠ)J,T&g', '', 0, '?'),
 ('&UX\rL4{', 'wp-includes/js/utils.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R7I\ZzhZ', '*D^T>U.[yFDs0X', '', 0, '?'),
 ('](R&!1;3', 'wp-includes/js/wp-ajax-response.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0ƐJ</,', 'lݼ^0_.~pyK{g=-ԸV', '', 0, '?'),
 ('u)8FG9C(', 'wp-includes/js/wp-ajax-response.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zG[Ç2\ZS', '\\\nUs\n̬úJRkXLZw/M', '', 0, '?'),
 ('!|(yW*1Oo2Cu', 'wp-includes/js/wp-api.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f}+[}/8n', 'Dt\r)tcrQqslu\\/<', '', 0, '?'),
 ('ӟmy+\nf:', 'wp-includes/js/wp-api.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'tS.', 'G+PvKQe43\n\ZA2C', '', 0, '?'),
 ('.v8-rJŕqQ', 'wp-includes/js/wp-auth-check.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'vV`I˓f\Z9', 'kA5$\r{}F2;L2ɐ', '', 0, '?'),
 ('tU/DsIڤst', 'wp-includes/js/wp-auth-check.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ř9芀uqU', '`(9ZĞ˃BԢj&tC', '', 0, '?'),
 ('j8ď\Z', 'wp-includes/js/wp-backbone.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'bgWf.+X\\p', '\nTxN@s_L`E*dHc?', '', 0, '?'),
 ('0<lڿJ', 'wp-includes/js/wp-backbone.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SfKD-)', 'w\\dn§Ί3r\0ҍ6n>', '', 0, '?'),
 ('ԒAr^', 'wp-includes/js/wp-custom-header.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'c<n xFqa', 'tl<F;1oUk8*͐', '', 0, '?'),
 ('Z_\"~J', 'wp-includes/js/wp-custom-header.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y\\PHUs', 'ְNX\nv:Po#҅b2fk', '', 0, '?'),
 ('=-Xԍn{]pf', 'wp-includes/js/wp-embed-template.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Y,.n2Q', 'S|l>\nwwZhGՔe?o<@?', '', 0, '?'),
 ('Z Og\nWW2', 'wp-includes/js/wp-embed-template.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ީ2~\'7', '`40^c$bSzڎ	!T22h', '', 0, '?'),
 ('sSki<4\'c-6', 'wp-includes/js/wp-embed.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#NO8L^sWkJ<', ' E>@_0!B5', '', 0, '?'),
 ('J~_ofk', 'wp-includes/js/wp-embed.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']b8\r*h@', 'zO间 ^7%n\"\0H', '', 0, '?'),
 ('trεF_ ', 'wp-includes/js/wp-emoji-loader.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YNkľ$=>', ';чhz#a\"7K. ):x<', '', 0, '?'),
 (';*1\Zn4', 'wp-includes/js/wp-emoji-loader.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '<>|6S xU', '|!xXшV$~/Kê\"\Z', '', 0, '?'),
 ('	b8[y', 'wp-includes/js/wp-emoji-release.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3-Gg', '˸b\Z<7Y2|g7ji%', '', 0, '?'),
 ('\0;fQ=*Ǖ', 'wp-includes/js/wp-emoji.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*׶H;q.', 'O)`5gD?5F!', '', 0, '?'),
 ('[>x;wn/tH', 'wp-includes/js/wp-emoji.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-k&|6S\Z', '8IWY8Գ)_]F-=', '', 0, '?'),
 ('=V;N.K', 'wp-includes/js/wp-list-revisions.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PbOPxOrs72', '#;w1.B3f_;Pf', '', 0, '?'),
 ('E4fu\r#R:k!jgh', 'wp-includes/js/wp-list-revisions.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'PztPFhHy', '.mOi$g.oV~%', '', 0, '?'),
 ('bvEH΄', 'wp-includes/js/wp-lists.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V@N:\rD``E$|', '`ĉAo/~Cg䰐A', '', 0, '?'),
 ('9eEbݾl3', 'wp-includes/js/wp-lists.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Q^aiq', 'zRH!1[VK;E`DQPU', '', 0, '?'),
 ('#AuI.F/', 'wp-includes/js/wp-pointer.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'uh N+\0g', '^HH9cbnLlɃ!i/', '', 0, '?'),
 ('Ǉ4˓T`k', 'wp-includes/js/wp-pointer.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wL\'', 'j8/UҒ?Vjy[<46S]Ĭ', '', 0, '?'),
 (']jl\'/x5', 'wp-includes/js/wp-sanitize.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':kEt6Q', 'yΦV }ɛqK>ۈP6*C\ns}', '', 0, '?'),
 ('&}?\Zs`', 'wp-includes/js/wp-sanitize.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^뽍Lhc+h', 'cTTl+ALo^\"օ9U7\0%{H~', '', 0, '?'),
 ('??n_2gj', 'wp-includes/js/wp-util.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'w;Y6	', 'y{;-ռ%MVW_1aO', '', 0, '?'),
 ('H+E~}1Q', 'wp-includes/js/wp-util.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V>Qo6', ',ͫp;IrA/ׇ9~j', '', 0, '?'),
 ('A4e{^Z', 'wp-includes/js/wpdialog.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ʒy\n	 epԩf', '!/Af0=G7h/uU&g', '', 0, '?'),
 ('ߗQu!ٶx[', 'wp-includes/js/wpdialog.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=nR-KP=<', 'wڇEÞ\0vӭk^Mn', '', 0, '?'),
 ('wtH-s\0n', 'wp-includes/js/wplink.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U.a;gJ\'ڹ.r', 'ZE\\G.Rb\'\0~$pl ', '', 0, '?'),
 ('\"c)j\"', 'wp-includes/js/wplink.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ygx؂Y', 'Hd\Z[\0`v%r1M', '', 0, '?'),
 ('\'B7S', 'wp-includes/js/zxcvbn-async.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=$a[ZF)^\n~', 'uQ9ҫ{7o}`-nW', '', 0, '?'),
 ('L(n9[2C6', 'wp-includes/js/zxcvbn-async.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_ɬA:tE$&', '0^BMՒŗ+W\\<', '', 0, '?'),
 ('J򾁬OhsDؾ', 'wp-includes/js/zxcvbn.min.js', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|	#PV	/{M_', 'vXI9n1e6C\\.p+\"K', '', 0, '?'),
 ('іqSGKy(', 'wp-includes/kses.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@\Z8{\r[', 'vaD]DJ3}K', '', 0, '?'),
 (':m[ݢ:#', 'wp-includes/l10n.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'DC;5xK9', 'Mc4tz{к;%v#rM+z*', '', 0, '?'),
 ('vE,-O{', 'wp-includes/link-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[S-F', 'eD|E\\_Uͅ|\',L(0Gz', '', 0, '?'),
 ('_j_/yӱ', 'wp-includes/load.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Lx:@', '^:6[\'?5zɂbpJO', '', 0, '?'),
 ('D6mer{pKO', 'wp-includes/locale.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ʋ\04)oybU^', '<6n\'J_	S%GVJ', '', 0, '?'),
 ('a(mEBl', 'wp-includes/media-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h&\"ȷdB+', 'NZsvJQMBf	[/', '', 0, '?'),
 ('){jW-_Q=?GlҢ', 'wp-includes/media.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Da\'nf', 'mfg&W.2TA](6M', '', 0, '?'),
 ('KQ}U&;&Q', 'wp-includes/meta.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\=MyI](n~S', 'fD;-2D/쮧{N7%Q\0', '', 0, '?'),
 ('gI!٭_', 'wp-includes/ms-blogs.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qgqe܍ӧ>e', '#DRΪmþX[DHdP,', '', 0, '?'),
 ('mAYRb|S', 'wp-includes/ms-default-constants.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'K~p4߀A6', 'i|ZIe\ZEV%6OJ', '', 0, '?'),
 ('.݁BxKY', 'wp-includes/ms-default-filters.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b5k,qa!', 'J7\0r.A˵ß8\0\Z', '', 0, '?'),
 ('[nG{\'q:', 'wp-includes/ms-deprecated.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-m=q\n', 'sSz=)=k$8n>\0>', '', 0, '?'),
 ('뭷\r!z}MLKE', 'wp-includes/ms-files.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z]Gy2D', 'Zhx^/#Z^N_\Z', '', 0, '?'),
 ('v%S[̪Ѿ', 'wp-includes/ms-functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nћz\rn{3O', 'ɏ*\\`=8wC:dw\0', '', 0, '?'),
 ('_jSX2QQ=', 'wp-includes/ms-load.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x4,\ZEo,K', 'f`85#<\ru݁?vMN6_8^', '', 0, '?'),
 ('x9p2wB', 'wp-includes/ms-network.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'cQ', 'L@wmm>e', '', 0, '?'),
 ('j&^b', 'wp-includes/ms-settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' F,ons-%', '0y\nMI?<9D^', '', 0, '?'),
 ('\'^DIG1!', 'wp-includes/ms-site.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"]2', '\0}<{^ű÷p\\;s', '', 0, '?'),
 ('{Amm*K', 'wp-includes/nav-menu-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6q_Szyr', '.Gqqѽ\\$sޕnSͶor}+y', '', 0, '?'),
 ('[Hn[P.~FU|', 'wp-includes/nav-menu.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zg3=r`lh', '%Zf1yc>|:NB', '', 0, '?'),
 ('MRlBFu', 'wp-includes/option.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'N3X?B,Ig(', '@ٝ6|Y-R3,-F2\nMR', '', 0, '?'),
 ('N|Jвznsw', 'wp-includes/pluggable-deprecated.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@\"j2ߖ', 'U=co=t1-\\\r=', '', 0, '?'),
 ('h0X-i^G`8', 'wp-includes/pluggable.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'S\0Ev~&75}F', 'a-K6zxɦ*RxUtOM/', '', 0, '?'),
 ('\00qĊNy)', 'wp-includes/plugin.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(P9orK', '{ͼ\\x*edMlE֔', '', 0, '?'),
 (' CY', 'wp-includes/pomo/entry.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HBTEY#\nnx', 'W4tA!G9', '', 0, '?'),
 ('48Vt+^X', 'wp-includes/pomo/mo.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0	](DFya5', 'FM.APMi#', '', 0, '?'),
 ('A)͹D4', 'wp-includes/pomo/plural-forms.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Eܔ,;', 'H.l~c5b#q@j;)\0UێU3', '', 0, '?'),
 ('[Kb28', 'wp-includes/pomo/po.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a!Gxg', 'o>q:nථi٥<ppϠ>', '', 0, '?'),
 ('1W;cN\"u', 'wp-includes/pomo/streams.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v\0[V', 'т|xecd/^7~4w+\nKj', '', 0, '?'),
 ('?ڟE$PF', 'wp-includes/pomo/translations.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|8Va񳰬y', 'LâDwL7', '', 0, '?'),
 ('atUq^!0ƣl', 'wp-includes/post-formats.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}ORVZZD	', ' fIq\ZRʜha?ք%4.fd', '', 0, '?'),
 ('MIMrD-', 'wp-includes/post-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=9	', 'Kmj .O%.8Q1_Rtl', '', 0, '?'),
 ('iY\0\nR)', 'wp-includes/post-thumbnail-template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Gf/Qb%', '^EfY)t>y\ZlI ^FEyC', '', 0, '?'),
 ('0jlSK', 'wp-includes/post.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '#G~^J\0', ')Uy`mifb+~/;', '', 0, '?'),
 (' A$ۤfCN37', 'wp-includes/query.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GZ]=gn(', 'b\Zf~KF\r%S?	bHH!g;R', '', 0, '?'),
 ('KF\nOi},w', 'wp-includes/random_compat/byte_safe_strings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[BңJԈ;', ']Q˄=PݵuQ{>ϐ', '', 0, '?'),
 ('owЎ696I', 'wp-includes/random_compat/cast_to_int.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!>=IO', 'p>2xtntqb', '', 0, '?'),
 ('v9b$L', 'wp-includes/random_compat/error_polyfill.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'X:,t]7=QE', ',t\0_gX%4.tP]>JT4', '', 0, '?'),
 ('jZ;\nlГ', 'wp-includes/random_compat/random.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5&}k!6$', 'X8P_9kQa[-mS\'<@!V:', '', 0, '?'),
 ('t.Õ81', 'wp-includes/random_compat/random_bytes_com_dotnet.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'nM@<A6@!Y', '.#$.N.\\\"Cuj%HEJֈ^a', '', 0, '?'),
 ('?2yT!s|tu}', 'wp-includes/random_compat/random_bytes_dev_urandom.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd\ZHr', '\nDfdvPfOn:aгX', '', 0, '?'),
 ('[D?_[', 'wp-includes/random_compat/random_bytes_libsodium.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '4Տd', 'In6_ga8y].', '', 0, '?'),
 ('N iiڭ', 'wp-includes/random_compat/random_bytes_libsodium_legacy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[q7dvz', '\'֪*	[\0EE*JrVsc?', '', 0, '?'),
 ('%I}PzW', 'wp-includes/random_compat/random_bytes_mcrypt.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'TԦʙ`PL', 'b=-.XTYnP', '', 0, '?'),
 ('3I98\\֛[t', 'wp-includes/random_compat/random_int.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*RXǠͤBn6', '8-%s`NaL	LMʫ)', '', 0, '?'),
 ('E-j1j\rE', 'wp-includes/registration-functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+go\\=', 'Zd_v~R͝H:|T\"?ۯv', '', 0, '?'),
 ('5\\h>w	N', 'wp-includes/registration.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'GNPw7\r\n', 'jX%NhA3Cݷ{N', '', 0, '?'),
 ('Ѝ3>#.', 'wp-includes/rest-api/class-wp-rest-request.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rh!', '&Grb܄6Lή\'YPhk', '', 0, '?'),
 ('V+@0pɏhi', 'wp-includes/rest-api/class-wp-rest-response.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!}S', 'Ԍ\'MSgϾ*ñ/{ȐnDA#', '', 0, '?'),
 (':뭲cRPe(', 'wp-includes/rest-api/class-wp-rest-server.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3\rcF:,]WR', '<SȰk`;$/(B<K\"bz|', '', 0, '?'),
 ('aaiG}\Z ', 'wp-includes/rest-api/endpoints/class-wp-rest-attachments-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+wdG.\'n+`', '<Wed-2cGb\\m[<LdT', '', 0, '?'),
 ('/5SQU۶v+', 'wp-includes/rest-api/endpoints/class-wp-rest-autosaves-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'n\'d]\0', 'S푄i\'[`r&F', '', 0, '?'),
 ('2[v\\)IQ', 'wp-includes/rest-api/endpoints/class-wp-rest-block-renderer-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'rЉ0>;', 'ѹ=^B)U\\_g', '', 0, '?'),
 (' zz{LH', 'wp-includes/rest-api/endpoints/class-wp-rest-blocks-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7-~?zz', '|\\-_Q_pZUI>6.', '', 0, '?'),
 ('k\0\Z{ ݛ6', 'wp-includes/rest-api/endpoints/class-wp-rest-comments-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hCc_B', 'T?P*%zw;CS7', '', 0, '?'),
 ('.xQ}t\np', 'wp-includes/rest-api/endpoints/class-wp-rest-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '49?&ii', '! Cwyht\\eb|D', '', 0, '?'),
 ('}Ua&gli)!', 'wp-includes/rest-api/endpoints/class-wp-rest-post-statuses-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5GblNv<\r', 'nW#g!\\>>,zgCkg', '', 0, '?'),
 ('qsƞù', 'wp-includes/rest-api/endpoints/class-wp-rest-post-types-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@hB8r9', 'Aen7(̖H>\\9|#R8@4d', '', 0, '?'),
 ('3z\'OvJ& ', 'wp-includes/rest-api/endpoints/class-wp-rest-posts-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'BqQ\';r0P', 'l^%֮cSNN\royFW', '', 0, '?'),
 ('L#aW ', 'wp-includes/rest-api/endpoints/class-wp-rest-revisions-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Fgp~~[P*', 'HBN\\VxQ\0HYc4D!ES~', '', 0, '?'),
 ('gQir똿/!', 'wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'LKē.', '*YeVC)<%[dgW1d\0&', '', 0, '?'),
 ('CciFh.n7', 'wp-includes/rest-api/endpoints/class-wp-rest-settings-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'FS\":H3', ' E]dk`?f0[6*\0\Z8', '', 0, '?'),
 ('q_\"1F', 'wp-includes/rest-api/endpoints/class-wp-rest-taxonomies-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'C_n4]hc3?', 'wDZsJdӚKN҇', '', 0, '?'),
 ('\Z,zҐU', 'wp-includes/rest-api/endpoints/class-wp-rest-terms-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Xw;\r\"l{1R', '䜬{MTڢ|+8ty2 ŞM', '', 0, '?'),
 ('wesi<OJ%', 'wp-includes/rest-api/endpoints/class-wp-rest-themes-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '6\rK[]\0.U', 'h(淖9Y>=8+bƨPi*p', '', 0, '?'),
 ('Ȧ0 $7O>', 'wp-includes/rest-api/endpoints/class-wp-rest-users-controller.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ks-kVqN', '#F.qˌ,CNMBʘLL$O', '', 0, '?'),
 (',f', 'wp-includes/rest-api/fields/class-wp-rest-comment-meta-fields.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ZƾB,J)Tcx', '\0IM|%ct\0Φqs5', '', 0, '?'),
 ('ͪuowsFCG[c', 'wp-includes/rest-api/fields/class-wp-rest-meta-fields.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i88v?-+', '.BRrI\0[а~aįFt', '', 0, '?'),
 ('\njݍea!\ZWdq', 'wp-includes/rest-api/fields/class-wp-rest-post-meta-fields.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"<8.K\'', ' \ZYӵ˼*,QLY{㬣p\rh', '', 0, '?'),
 ('WMF`3$', 'wp-includes/rest-api/fields/class-wp-rest-term-meta-fields.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y^', 'Y	QFX22FW)fKSf', '', 0, '?'),
 ('I6.:\n(i\0B', 'wp-includes/rest-api/fields/class-wp-rest-user-meta-fields.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'H\r\r0X/^0R', 'O1-pQۊ8Z+$[jK', '', 0, '?'),
 ('Gu5aԯ', 'wp-includes/rest-api/search/class-wp-rest-post-search-handler.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'B/\'j@H', 'W\nN &@%mI1q>t', '', 0, '?'),
 ('YUL5Jޔv[', 'wp-includes/rest-api/search/class-wp-rest-search-handler.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '9}}F&{OJϛ', '<=2Z~wtmp-?kVRNC', '', 0, '?'),
 ('Ú2d=', 'wp-includes/rest-api.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wC.c\"` BC)Kt', '6Z\nܙ$QUPM+h-', '', 0, '?'),
 ('_\0d MP~D', 'wp-includes/revision.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'qirr_(\"', ';iQ&#]hu\"J`<', '', 0, '?'),
 (')Oz=u˷', 'wp-includes/rewrite.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U`-`Dے', 'AnN}+_|]', '', 0, '?'),
 ('w\'6)', 'wp-includes/rss-functions.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڨ%= Q)	y', '@^dzRiJ$\\*\ZCAMF}f}', '', 0, '?'),
 ('A1\Z;', 'wp-includes/rss.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm[\0lJ;', '^]\"ˌ|a>|Ī.pNX', '', 0, '?'),
 ('9} B^?	\"', 'wp-includes/script-loader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']n]wU', '@?R`Uzh\rN as', '', 0, '?'),
 ('Eh@aq', 'wp-includes/session.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'NRM<\\>', '}k+8MU=<;tI*,4#', '', 0, '?'),
 ('Vne!z0u1?', 'wp-includes/shortcodes.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',Q0?&&i', 'ɳI1呮+I!etQD{', '', 0, '?'),
 ('1БY4I^p', 'wp-includes/sodium_compat/LICENSE', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x6F\0f', 'N^qyqܯ\r]S\\[C{Vyw', '', 0, '?'),
 ('ýP7&ݣ`)', 'wp-includes/sodium_compat/autoload.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'DB[', 'yP2Ǫz_V$\0YNvQZu`', '', 0, '?'),
 ('V\r3#J{', 'wp-includes/sodium_compat/composer.json', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'E+5Cο}', '@U&1wНE⎙#90heh', '', 0, '?'),
 ('A;ت\Zܦz', 'wp-includes/sodium_compat/lib/constants.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{#l>m', 'ٹmc(l\'mtˣ[gW', '', 0, '?'),
 ('\0?H\0E}\"', 'wp-includes/sodium_compat/lib/namespaced.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '01vnG\r', ']/r~ʺOCcxBj/oUI*', '', 0, '?'),
 ('P\neu\"', 'wp-includes/sodium_compat/lib/php72compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'a Q8Ǳ', '!\nKka{\"+NZDL', '', 0, '?'),
 ('ÂuJM/ wy', 'wp-includes/sodium_compat/lib/php72compat_const.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XPsHG/nw', '-ܙ_P^C`ֵ.FIf', '', 0, '?'),
 (',!#QP[;', 'wp-includes/sodium_compat/lib/sodium_compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'A\'I5xN$', 'm<	p(t)P7r~^闦', '', 0, '?'),
 ('zmSA}I)', 'wp-includes/sodium_compat/namespaced/Compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Aik/j\rn3', '1\'ջ.O}5Afi~>:}s', '', 0, '?'),
 ('wj067@T', 'wp-includes/sodium_compat/namespaced/Core/BLAKE2b.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\"2s7\\i#E', 'atW	3N\Z`xhI`', '', 0, '?'),
 ('vifuP0^>d', 'wp-includes/sodium_compat/namespaced/Core/ChaCha20/Ctx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'SG˺F', '[(R$2otb', '', 0, '?'),
 ('B^tpk!', 'wp-includes/sodium_compat/namespaced/Core/ChaCha20/IetfCtx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R*LTG4%P', '-nFJ&TPo\\ϓ\\2', '', 0, '?'),
 ('K\r\\Uz\Z:\'', 'wp-includes/sodium_compat/namespaced/Core/ChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'V*F谯<l', '®RlUwzankGt3', '', 0, '?'),
 ('7o^l:B', 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Fe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '	Iݶ3S', '!MڒޫDwwe(!=ިd,GW', '', 0, '?'),
 ('ǝ^xJB\Z3-6', 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/Cached.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G5]{\"V', 'CJr~WOY*[:[j)GЄe', '', 0, '?'),
 ('\Z) %iyδ', 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/P1p1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}+#z,erEJ-', 'sfq@8!yW&ڔA+/uY44G', '', 0, '?'),
 ('ΝP|ڒ\\o', 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/P2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' w^]緣M', 'ZEO7(nYh˨', '', 0, '?'),
 ('h~cTOoy4|', 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/P3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'f\"#6${ JL\'\"', 'eŇ6\Z(q&ڶ]\nCliީ', '', 0, '?'),
 ('峳$ @z6\0`/', 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/Precomp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ջ}BH71', '\"beTb$׉\n~ln', '', 0, '?'),
 (';v0BK1д', 'wp-includes/sodium_compat/namespaced/Core/Curve25519/H.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '+o~Xݓ\0', 'xXѹ$6UdZ$x&3', '', 0, '?'),
 ('431@*r8', 'wp-includes/sodium_compat/namespaced/Core/Curve25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'śL\\PڜU', 'c>5o𽃐_T9L~;e7', '', 0, '?'),
 ('kIKV[	5', 'wp-includes/sodium_compat/namespaced/Core/Ed25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v>#!n(', 'DFUu|v/]2x_ERL2QlP93s	15', '', 0, '?'),
 ('ب&G)k{', 'wp-includes/sodium_compat/namespaced/Core/HChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hP', 'Kd%.RAOFjo-', '', 0, '?'),
 ('O忯uRc[j', 'wp-includes/sodium_compat/namespaced/Core/HSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[clru	Сu^', '6p\'`+*[AG4^6Ŋ%C', '', 0, '?'),
 ('r@DZ䯩', 'wp-includes/sodium_compat/namespaced/Core/Poly1305/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!K	5yS*', 'TyO%u;U}g1)Z', '', 0, '?'),
 ('70,		M', 'wp-includes/sodium_compat/namespaced/Core/Poly1305.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Qy?;8V\n', '\0-]뮳XEt)`1C}Mr2/', '', 0, '?'),
 ('rtIg[;?', 'wp-includes/sodium_compat/namespaced/Core/Salsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\rVNck0}/Ճ', 'nKkZ	 N$  EКe$', '', 0, '?'),
 ('6?^o#', 'wp-includes/sodium_compat/namespaced/Core/SipHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'r-er^!~', '`RlԥLz?iāACH󞮣Pyn', '', 0, '?'),
 ('3p\\8lDq', 'wp-includes/sodium_compat/namespaced/Core/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ';*kLwBd=', 'ec[dM?H|KY\04@ QA:FF ', '', 0, '?'),
 ('5Vx,$>7dk', 'wp-includes/sodium_compat/namespaced/Core/X25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ڸb9M', 'F/\'M%9}@fW>S*m', '', 0, '?'),
 ('xz#]ru?0O', 'wp-includes/sodium_compat/namespaced/Core/XChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'hg`ɸ:ڕ^', 'F/QH\0^l 0BΓի6S@Ph', '', 0, '?'),
 ('2:', 'wp-includes/sodium_compat/namespaced/Core/Xsalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b4\'&', 'ۼ4P\'hNa>E5ఛ', '', 0, '?'),
 ('iBj]', 'wp-includes/sodium_compat/namespaced/Crypto.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'G8J+	z', '>8\'XiUbGн,<T`64Ѝ', '', 0, '?'),
 ('0Jfx#X{', 'wp-includes/sodium_compat/namespaced/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ']mw/\\y5', 'ɐtd7H}=.tCw$`c\'', '', 0, '?'),
 ('*1G鍫vLߟn', 'wp-includes/sodium_compat/src/Compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k\'9L&۔Al+', '<wWr2IMO+`@u', '', 0, '?'),
 ('QS2#]srt', 'wp-includes/sodium_compat/src/Core/BLAKE2b.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' 9-K9,', '断8Z.8gKl2&.MO', '', 0, '?'),
 ('*&C:[r9N', 'wp-includes/sodium_compat/src/Core/Base64/Common.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Pefi\'jW', '6UmЖ%?MSA^=X|U', '', 0, '?'),
 ('\'7b~ 6', 'wp-includes/sodium_compat/src/Core/Base64/Original.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ң-с', '9\0zotID:\0g I%~ަ$o', '', 0, '?'),
 ('=Jǰja}LIZ', 'wp-includes/sodium_compat/src/Core/Base64/UrlSafe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pFt1+', ';}\0[\'\rqĥd;#.', '', 0, '?'),
 ('0ܚZI丱N', 'wp-includes/sodium_compat/src/Core/ChaCha20/Ctx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\'U巃 qDFH', 'Ԧ!ӢtLk.\"1CmKg', '', 0, '?'),
 ('ISU`uTF', 'wp-includes/sodium_compat/src/Core/ChaCha20/IetfCtx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'l{bOs_a>', 'mn5ߐ֞βgJ\\3', '', 0, '?'),
 ('&DQRw]', 'wp-includes/sodium_compat/src/Core/ChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-rjiIأeb', 'bE&q*', '', 0, '?'),
 ('$[tCŤIw', 'wp-includes/sodium_compat/src/Core/Curve25519/Fe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'W	,~r', 'L>eh\rF$CV7', '', 0, '?'),
 ('D=SC', 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/Cached.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%X`йKZ', 'SW,fK{\\^Y/', '', 0, '?'),
 ('zL5	g5Ď', 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/P1p1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'trIbw\'-7', 'uS{<n\r߅+-#;᷃QЮ', '', 0, '?'),
 ('yO\0yjeB\nVp', 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/P2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Eƀkvk\r', 'iiLMP4ިO_!iN	', '', 0, '?'),
 ('U\\aE', 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/P3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'wͱr0؅=', '?E%+w\r^֗.$i$[W', '', 0, '?'),
 ('uRlt\"', 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/Precomp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7֊i[L9ƁH	', '߹{8(Ïat\0Cn3Qڤ\nl?$y', '', 0, '?'),
 ('RjqIӏ\ZY&', 'wp-includes/sodium_compat/src/Core/Curve25519/H.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ădO[S\nc\0', '^o&[l2Zg/?>P~CIȗ', '', 0, '?'),
 (']R>w.EQ', 'wp-includes/sodium_compat/src/Core/Curve25519/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yϛvj\n', 'Sx^V>m!-qDeV', '', 0, '?'),
 ('ᕵ7\\F|[El', 'wp-includes/sodium_compat/src/Core/Curve25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '0s0C{[[t7', 'Zz`}JGN]lQ8H', '', 0, '?'),
 ('5.=d)<peus^', 'wp-includes/sodium_compat/src/Core/Ed25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'd/큱jfrh(', '֍Wt*v)gDfݙ', '', 0, '?'),
 ('ii\"oC`', 'wp-includes/sodium_compat/src/Core/HChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[Rz@MMQmr', 'qX9Oa4A\'̾e', '', 0, '?'),
 ('lt:{0+79C', 'wp-includes/sodium_compat/src/Core/HSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Hx+07`}', '@qzjI \0DaW6n{y', '', 0, '?'),
 ('9ksB=}TŃc7', 'wp-includes/sodium_compat/src/Core/Poly1305/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'VzȒ`(lE', '⯠盍ԵJ\\_z[', '', 0, '?'),
 ('.I\nfqM9', 'wp-includes/sodium_compat/src/Core/Poly1305.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '!iLV=X+	v0~', '4-<4,\"VȱXʘîhR	KFk', '', 0, '?'),
 ('Ѻɩuy}', 'wp-includes/sodium_compat/src/Core/Salsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'b5lJ#v', 'c=0-#-TSX&4\0K8\r', '', 0, '?'),
 ('sC<:<A', 'wp-includes/sodium_compat/src/Core/SecretStream/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ':Z{5o', '<s6\0,	RauhXc', '', 0, '?'),
 ('%..Ct=\\`', 'wp-includes/sodium_compat/src/Core/SipHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%VxE1N', '!3|@0X1>\'[U', '', 0, '?'),
 ('J-狁\\\"ץ&', 'wp-includes/sodium_compat/src/Core/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~XZe&OagAc', 'ADg9\'c$?ٵC/', '', 0, '?'),
 ('\0GM(YlWz!', 'wp-includes/sodium_compat/src/Core/X25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pZ:!ټ', '3l@o-3SՏ&!', '', 0, '?'),
 ('ǝQ_yd+', 'wp-includes/sodium_compat/src/Core/XChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'XU iU0ll9c', '_v$U7_*\r?+^≾Ā', '', 0, '?'),
 ('ρXn\r?', 'wp-includes/sodium_compat/src/Core/XSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'pƮuo7;~z', ' %ly\'#[_{E]8%', '', 0, '?'),
 ('ЬpIYR', 'wp-includes/sodium_compat/src/Core32/BLAKE2b.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'zħ7	7V\Z', 'p#4opp8^۰^F+ף)l', '', 0, '?'),
 ('g\ZŞ|q(', 'wp-includes/sodium_compat/src/Core32/ChaCha20/Ctx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'R<nI<', 'e}]TY(u&\r90+aDϮ#', '', 0, '?'),
 ('e-\nyV', 'wp-includes/sodium_compat/src/Core32/ChaCha20/IetfCtx.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|Wwb>EyJ', '\'~6ȝ\nBagzdQ', '', 0, '?'),
 ('v#qȃ', 'wp-includes/sodium_compat/src/Core32/ChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'EOxٕX2떭؃', 'xaJN!e\"\"Nq}AMC1){j', '', 0, '?');
INSERT INTO `wp8b_wffilemods` VALUES('I	2RNjY', 'wp-includes/sodium_compat/src/Core32/Curve25519/Fe.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'v\rs*\\', 'OZ=<3StQ_u;	m8', '', 0, '?'),
 ('=}LsQ\n`q&', 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/Cached.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '[M/*E<sWRG', '\n\\Xΰ֨PA\nXj\';q{a', '', 0, '?'),
 ('S>sU)H', 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/P1p1.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'y$NXll', '[-v5<M\n+Bu.,5g', '', 0, '?'),
 ('PUac', 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/P2.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'YAG=bu', 'z,ͥt	<{@Y{iysc(SL', '', 0, '?'),
 ('ĵ>#Bb', 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/P3.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ۓGc,=c^', 'Gct(5\n,9%)e', '', 0, '?'),
 ('!h>iq8tn', 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/Precomp.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\0>@UeU', 'țp˄o<O\nOo{w=S', '', 0, '?'),
 ('Q10G,', 'wp-includes/sodium_compat/src/Core32/Curve25519/H.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'x} pcKO', '(H>0}8:e)ＴN/z', '', 0, '?'),
 ('nۗvXH)', 'wp-includes/sodium_compat/src/Core32/Curve25519/README.md', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yϛvj\n', 'Sx^V>m!-qDeV', '', 0, '?'),
 ('\09k5&ٙ 7N', 'wp-includes/sodium_compat/src/Core32/Curve25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'MkݢAD5zyj', 'BQe!RilsnqR41xxQ!', '', 0, '?'),
 ('I/\ZN2p', 'wp-includes/sodium_compat/src/Core32/Ed25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ',Krz-YPSӠ', 'ߔT\Zq3O,wJ<j', '', 0, '?'),
 ('\"0\0L\'M', 'wp-includes/sodium_compat/src/Core32/HChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '95ef#ϝ', 'i\rC\"Գ\r48cS', '', 0, '?'),
 ('*`Uz]\"L%1', 'wp-includes/sodium_compat/src/Core32/HSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '/Dzxǂ', ',E{0/maXi', '', 0, '?'),
 ('Z|075o', 'wp-includes/sodium_compat/src/Core32/Int32.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '3NM[/\r~H', 'rWQ@x[1 *o9$', '', 0, '?'),
 ('(LS[Wl#', 'wp-includes/sodium_compat/src/Core32/Int64.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '%mS,\\', 'U!6/Ucqn@+', '', 0, '?'),
 ('ue{X1', 'wp-includes/sodium_compat/src/Core32/Poly1305/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'D5$ý\n	\'q0', '\\\"ԯ-\r6eNIDzB\r\0', '', 0, '?'),
 ('V\ZF\0|', 'wp-includes/sodium_compat/src/Core32/Poly1305.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '@BgEJƽH', 'i|\\IE_X綈j', '', 0, '?'),
 ('|~', 'wp-includes/sodium_compat/src/Core32/Salsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ')6):', 'H0Lї?㞹.1MIe٣', '', 0, '?'),
 ('w+\02R', 'wp-includes/sodium_compat/src/Core32/SecretStream/State.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\Zjo\0y,*}c', '2p\"Wjslf&S@[\\\"W', '', 0, '?'),
 ('q05', 'wp-includes/sodium_compat/src/Core32/SipHash.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '5O&?E	%', '^%%hT,k2Ȯn=n%:', '', 0, '?'),
 ('`}+6L-q[$', 'wp-includes/sodium_compat/src/Core32/Util.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1`0', 'qƖ%/ygrwÛ\rLR>=Y', '', 0, '?'),
 ('@}~4Gv<m', 'wp-includes/sodium_compat/src/Core32/X25519.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gbf>=', 'ߺ`\'盱Жx#i#', '', 0, '?'),
 ('U6υsd~x', 'wp-includes/sodium_compat/src/Core32/XChaCha20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\r*unrdug', 'ҷ<hbo>W\ZN eia', '', 0, '?'),
 ('hZ[=wr', 'wp-includes/sodium_compat/src/Core32/XSalsa20.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\:R/+', 'ɫ:jNmmR[', '', 0, '?'),
 ('K=Xa:\'5', 'wp-includes/sodium_compat/src/Crypto.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-p\0Ecbc', '\"̘L!{rDnPz^XjLk', '', 0, '?'),
 ('elsUO|R}ܝi', 'wp-includes/sodium_compat/src/Crypto32.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'I\r}jǊQX]m', 'ɱ䱃Fn2c.nMڣ A', '', 0, '?'),
 ('`~|D%EHwO', 'wp-includes/sodium_compat/src/File.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'yr.N(}', 'ol=+DCĸ)l)$tC', '', 0, '?'),
 ('xOW\r', 'wp-includes/sodium_compat/src/PHP52/SplFixedArray.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '1`-p1', '\'V+?<!C\ZƾQUߢ', '', 0, '?'),
 ('um-O\'ߝ]#', 'wp-includes/sodium_compat/src/SodiumException.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'HDfaezR', '㶜\\L>LN-@G\'tmGikR߮g\0', '', 0, '?'),
 ('X=2h4/{+', 'wp-includes/spl-autoload-compat.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'h#9P$3Xsäf', '0<lYw<5OȴfF-%:J', '', 0, '?'),
 ('X=UpfpZ', 'wp-includes/taxonomy.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 't.uXx\n', 'YG)vmPyl^F', '', 0, '?'),
 (':+[gCZ', 'wp-includes/template-loader.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '-ģ`', '(@\0Y!|Ht\"N,T$=̌p{', '', 0, '?'),
 (':=%M۵', 'wp-includes/template.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'g.\Zq>z', ';vѴQW){ \'~?%@%ywe', '', 0, '?'),
 ('>hЩXX*v1', 'wp-includes/theme-compat/comments.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\ZۼmSQK', '=\0ѷx-0F2c9ujJϊ', '', 0, '?'),
 ('\"8A\n=ᇼfp5', 'wp-includes/theme-compat/embed-404.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7[R+SA-\Za*e', '}pN\0K6%),o`)1\08', '', 0, '?'),
 ('fֈVԹ)9', 'wp-includes/theme-compat/embed-content.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm\'牉TeD]pCA', 'Jϑ߷`š+,jr#eQ䫖 ', '', 0, '?'),
 ('+q^eguF6\n', 'wp-includes/theme-compat/embed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ţs^qcb', 'W5Tp;-n0aO\n', '', 0, '?'),
 ('mL0N\"T~b', 'wp-includes/theme-compat/footer-embed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Z.+j', 'iDAJψ;v,gc%	^#', '', 0, '?'),
 ('Qֿ6yq88', 'wp-includes/theme-compat/footer.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Yu|f$', '\n*r-ω^ߣHDbߚ', '', 0, '?'),
 ('&vAQcqw8,', 'wp-includes/theme-compat/header-embed.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Omz8F', '})d!q	,@,jv	E', '', 0, '?'),
 ('LbP-I׭1f', 'wp-includes/theme-compat/header.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\#eua', 'ws<#7JG4X\\8=o۞!', '', 0, '?'),
 ('0;-,AEy', 'wp-includes/theme-compat/sidebar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '(S;I(', 'UkxrLb\"JAF(u;	\0&', '', 0, '?'),
 ('XVטO|8}', 'wp-includes/theme.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T\n%i6#', '\'pauEzf~DXmud', '', 0, '?'),
 ('+qpW', 'wp-includes/update.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'T:[K/6A', 'l1M[(LrEc>#\n', '', 0, '?'),
 ('kB˞b=y', 'wp-includes/user.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'aT\rWZE', 'f5s[VFr\n=\re&6E', '', 0, '?'),
 ('g+yrqD/', 'wp-includes/vars.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '**O$2', 'zZ4\Z[A5EEFB', '', 0, '?'),
 ('5ZSμv`69', 'wp-includes/version.php', 0, '!},{jq+', '!},{jq+', '\"	[\"6[z\\&.?M&s@\Z\"', '', 0, '?'),
 ('Y,Qpgmu#e~', 'wp-includes/widgets/class-wp-nav-menu-widget.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'gx4hX>9', '/(&UyML_-`S\0KE', '', 0, '?'),
 ('TYPpEw', 'wp-includes/widgets/class-wp-widget-archives.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_vjC>a\'', 'ҀQ)W$@N|,CO', '', 0, '?'),
 ('I0S$2TB*', 'wp-includes/widgets/class-wp-widget-calendar.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OP\\Pt|-', 'M>f(Er_hXoۃ8@+O', '', 0, '?'),
 ('RH\r0!d?c&', 'wp-includes/widgets/class-wp-widget-categories.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '28?\00S`y^MJ ', 'N&RXoLVzax sFPʔ1>', '', 0, '?'),
 ('j\\Ħ<yp', 'wp-includes/widgets/class-wp-widget-custom-html.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '|MX\'پPy', '×Xd_mn\"GM9\\)w#x@', '', 0, '?'),
 ('&饱W؀|', 'wp-includes/widgets/class-wp-widget-links.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '\\Ҷ.)]*^', 'V.ZAzNKS)lv׊Ϟ', '', 0, '?'),
 ('Ὀ5f?hk', 'wp-includes/widgets/class-wp-widget-media-audio.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'OP/:#A', 'P!𴴨jzF#dĚMP', '', 0, '?'),
 ('v\'j@-*', 'wp-includes/widgets/class-wp-widget-media-gallery.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7_^\\fSɉ]6n#\Z', '>@ΡD&{(DγiO#', '', 0, '?'),
 ('PJ~]; `y', 'wp-includes/widgets/class-wp-widget-media-image.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '7βps,I', 'CyGn$FpTC', '', 0, '?'),
 ('_wƌ', 'wp-includes/widgets/class-wp-widget-media-video.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}◷>yOG', '10*uۤy[\\,/76\r', '', 0, '?'),
 (']NJjӎe', 'wp-includes/widgets/class-wp-widget-media.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'U1$+z.u', 'Գ82\"ڍ5Ѣ*un7@\"i', '', 0, '?'),
 ('n֢\rV5,', 'wp-includes/widgets/class-wp-widget-meta.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '8Lʵ&X[', '0w\nU%4X<(}{4|>I^l', '', 0, '?'),
 ('Kc#2s/(\"', 'wp-includes/widgets/class-wp-widget-pages.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '>Ч\"8uu(5', 'cv{{`n$@/?$n', '', 0, '?'),
 ('6~e{\".w', 'wp-includes/widgets/class-wp-widget-recent-comments.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '=Gq]n!', 'i^|}8̣ /\n', '', 0, '?'),
 ('l/\nԀWͱ-c', 'wp-includes/widgets/class-wp-widget-recent-posts.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'm|d1i', 'Zφ^w3-Jo׮}\r', '', 0, '?'),
 ('y7MA@', 'wp-includes/widgets/class-wp-widget-rss.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '_.hL)IhO G', 'Oq(-y\0<\0	k6w', '', 0, '?'),
 ('F\rxw~\rܱ\n', 'wp-includes/widgets/class-wp-widget-search.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}#KDt', 'W{ߒtZM1THNp2,', '', 0, '?'),
 ('-[ip\\^]', 'wp-includes/widgets/class-wp-widget-tag-cloud.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'k<fhm', 'O.;BU\Z~=j13\"$RIi9', '', 0, '?'),
 ('\0 k~U5T', 'wp-includes/widgets/class-wp-widget-text.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '}.Saa:e)', '5%7jU}	fj]?j9', '', 0, '?'),
 ('S&az8Jض9', 'wp-includes/widgets.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '*T|AÊnȻ|', '{Qݬ\0fPw|$9r', '', 0, '?'),
 ('@sB0<{l3', 'wp-includes/wlwmanifest.xml', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'Ԑi^', 'ƤJľ**X|icy-u6pC-$*\n', '', 0, '?'),
 ('Let\"pc(	e', 'wp-includes/wp-db.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '{!U7)Bt-', 'ZdFWɨ[_=T0c=', '', 0, '?'),
 ('(^3N3', 'wp-includes/wp-diff.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', ' -x<z^Wet', 'a;ɺ*2Zf1\"\nNt~>', '', 0, '?'),
 ('^\'q0', 'wp-links-opml.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'lnj\\wX=7I', '7\"1jL?9Y\"&kŌVD|', '', 0, '?'),
 ('$jX])D:', 'wp-load.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'i4Fֿ', ']o{ٷ	Wted', '', 0, '?'),
 ('\r\0FJBe', 'wp-login.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~\\Z%WE8', '=K̜&/wGgDkY<*;ĩ3', '', 0, '?'),
 ('3T.^ƙ<', 'wp-mail.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '^pC!Ԑ,', '\0\nIPt}3RΘ/#A', '', 0, '?'),
 (';1ы#Y_Nt', 'wp-settings.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '~O̠t N', 'y;ȓ[3ٙd.GkgE	FL5)\'d', '', 0, '?'),
 (',4#(#', 'wp-signup.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', '47VI', '=\"+O{eE}\'iT8ܒE', '', 0, '?'),
 ('o㮚-;?X:pҡ', 'wp-trackback.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'ewoRdF', '\Z\0[O٭FA\"woĬ?o\\ܦ', '', 0, '?'),
 ('4ڂL$,K[u', 'xmlrpc.php', 1, '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0', 'j	܉QO9hc', 'G#+utpO<r`H=w', '', 0, '?');

/* INSERT TABLE DATA: wp8b_wfhits */
INSERT INTO `wp8b_wfhits` VALUES(19, '0.000000', '1597070519.700471', '\0\0\0\0\0\0\0\0\0\0E.$', 0, 200, 0, 0, 0, 'https://modelox.vico.digital/?_wfsf=detectProxy', '', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.82 Safari/537.1', 'scan:detectproxy', NULL, NULL),
 (20, '0.000000', '1597070585.076229', '\0\0\0\0\0\0\0\0\0\0', 0, 302, 0, 1, 0, 'https://modelox.vico.digital/wp-login.php', 'https://modelox.vico.digital/wp-login.php', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36', 'loginOK', NULL, NULL),
 (21, '0.000000', '1597160239.587957', '\0\0\0\0\0\0\0\0\0\0KS', 0, 302, 0, 1, 0, 'https://modelox.vico.digital/wp-login.php', 'https://modelox.vico.digital/wp-login.php?redirect_to=https%3A%2F%2Fmodelox.vico.digital%2Fwp-admin%2F&reauth=1', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36', 'loginOK', NULL, NULL);

/* INSERT TABLE DATA: wp8b_wfknownfilelist */
INSERT INTO `wp8b_wfknownfilelist` VALUES(1, 'index.php'),
 (2, 'license.txt'),
 (3, 'readme.html'),
 (4, 'wp-activate.php'),
 (5, 'wp-admin/about.php'),
 (6, 'wp-admin/admin-ajax.php'),
 (7, 'wp-admin/admin-footer.php'),
 (8, 'wp-admin/admin-functions.php'),
 (9, 'wp-admin/admin-header.php'),
 (10, 'wp-admin/admin-post.php'),
 (11, 'wp-admin/admin.php'),
 (12, 'wp-admin/async-upload.php'),
 (13, 'wp-admin/comment.php'),
 (14, 'wp-admin/credits.php'),
 (15, 'wp-admin/css/about-rtl.css'),
 (16, 'wp-admin/css/about-rtl.min.css'),
 (17, 'wp-admin/css/about.css'),
 (18, 'wp-admin/css/about.min.css'),
 (19, 'wp-admin/css/admin-menu-rtl.css'),
 (20, 'wp-admin/css/admin-menu-rtl.min.css'),
 (21, 'wp-admin/css/admin-menu.css'),
 (22, 'wp-admin/css/admin-menu.min.css'),
 (23, 'wp-admin/css/code-editor-rtl.css'),
 (24, 'wp-admin/css/code-editor-rtl.min.css'),
 (25, 'wp-admin/css/code-editor.css'),
 (26, 'wp-admin/css/code-editor.min.css'),
 (27, 'wp-admin/css/color-picker-rtl.css'),
 (28, 'wp-admin/css/color-picker-rtl.min.css'),
 (29, 'wp-admin/css/color-picker.css'),
 (30, 'wp-admin/css/color-picker.min.css'),
 (31, 'wp-admin/css/colors/_admin.scss'),
 (32, 'wp-admin/css/colors/_mixins.scss'),
 (33, 'wp-admin/css/colors/_variables.scss'),
 (34, 'wp-admin/css/colors/blue/colors-rtl.css'),
 (35, 'wp-admin/css/colors/blue/colors-rtl.min.css'),
 (36, 'wp-admin/css/colors/blue/colors.css'),
 (37, 'wp-admin/css/colors/blue/colors.min.css'),
 (38, 'wp-admin/css/colors/blue/colors.scss'),
 (39, 'wp-admin/css/colors/coffee/colors-rtl.css'),
 (40, 'wp-admin/css/colors/coffee/colors-rtl.min.css'),
 (41, 'wp-admin/css/colors/coffee/colors.css'),
 (42, 'wp-admin/css/colors/coffee/colors.min.css'),
 (43, 'wp-admin/css/colors/coffee/colors.scss'),
 (44, 'wp-admin/css/colors/ectoplasm/colors-rtl.css'),
 (45, 'wp-admin/css/colors/ectoplasm/colors-rtl.min.css'),
 (46, 'wp-admin/css/colors/ectoplasm/colors.css'),
 (47, 'wp-admin/css/colors/ectoplasm/colors.min.css'),
 (48, 'wp-admin/css/colors/ectoplasm/colors.scss'),
 (49, 'wp-admin/css/colors/light/colors-rtl.css'),
 (50, 'wp-admin/css/colors/light/colors-rtl.min.css'),
 (51, 'wp-admin/css/colors/light/colors.css'),
 (52, 'wp-admin/css/colors/light/colors.min.css'),
 (53, 'wp-admin/css/colors/light/colors.scss'),
 (54, 'wp-admin/css/colors/midnight/colors-rtl.css'),
 (55, 'wp-admin/css/colors/midnight/colors-rtl.min.css'),
 (56, 'wp-admin/css/colors/midnight/colors.css'),
 (57, 'wp-admin/css/colors/midnight/colors.min.css'),
 (58, 'wp-admin/css/colors/midnight/colors.scss'),
 (59, 'wp-admin/css/colors/ocean/colors-rtl.css'),
 (60, 'wp-admin/css/colors/ocean/colors-rtl.min.css'),
 (61, 'wp-admin/css/colors/ocean/colors.css'),
 (62, 'wp-admin/css/colors/ocean/colors.min.css'),
 (63, 'wp-admin/css/colors/ocean/colors.scss'),
 (64, 'wp-admin/css/colors/sunrise/colors-rtl.css'),
 (65, 'wp-admin/css/colors/sunrise/colors-rtl.min.css'),
 (66, 'wp-admin/css/colors/sunrise/colors.css'),
 (67, 'wp-admin/css/colors/sunrise/colors.min.css'),
 (68, 'wp-admin/css/colors/sunrise/colors.scss'),
 (69, 'wp-admin/css/common-rtl.css'),
 (70, 'wp-admin/css/common-rtl.min.css'),
 (71, 'wp-admin/css/common.css'),
 (72, 'wp-admin/css/common.min.css'),
 (73, 'wp-admin/css/customize-controls-rtl.css'),
 (74, 'wp-admin/css/customize-controls-rtl.min.css'),
 (75, 'wp-admin/css/customize-controls.css'),
 (76, 'wp-admin/css/customize-controls.min.css'),
 (77, 'wp-admin/css/customize-nav-menus-rtl.css'),
 (78, 'wp-admin/css/customize-nav-menus-rtl.min.css'),
 (79, 'wp-admin/css/customize-nav-menus.css'),
 (80, 'wp-admin/css/customize-nav-menus.min.css'),
 (81, 'wp-admin/css/customize-widgets-rtl.css'),
 (82, 'wp-admin/css/customize-widgets-rtl.min.css'),
 (83, 'wp-admin/css/customize-widgets.css'),
 (84, 'wp-admin/css/customize-widgets.min.css'),
 (85, 'wp-admin/css/dashboard-rtl.css'),
 (86, 'wp-admin/css/dashboard-rtl.min.css'),
 (87, 'wp-admin/css/dashboard.css'),
 (88, 'wp-admin/css/dashboard.min.css'),
 (89, 'wp-admin/css/deprecated-media-rtl.css'),
 (90, 'wp-admin/css/deprecated-media-rtl.min.css'),
 (91, 'wp-admin/css/deprecated-media.css'),
 (92, 'wp-admin/css/deprecated-media.min.css'),
 (93, 'wp-admin/css/edit-rtl.css'),
 (94, 'wp-admin/css/edit-rtl.min.css'),
 (95, 'wp-admin/css/edit.css'),
 (96, 'wp-admin/css/edit.min.css'),
 (97, 'wp-admin/css/farbtastic-rtl.css'),
 (98, 'wp-admin/css/farbtastic-rtl.min.css'),
 (99, 'wp-admin/css/farbtastic.css'),
 (100, 'wp-admin/css/farbtastic.min.css'),
 (101, 'wp-admin/css/forms-rtl.css'),
 (102, 'wp-admin/css/forms-rtl.min.css'),
 (103, 'wp-admin/css/forms.css'),
 (104, 'wp-admin/css/forms.min.css'),
 (105, 'wp-admin/css/ie-rtl.css'),
 (106, 'wp-admin/css/ie-rtl.min.css'),
 (107, 'wp-admin/css/ie.css'),
 (108, 'wp-admin/css/ie.min.css'),
 (109, 'wp-admin/css/install-rtl.css'),
 (110, 'wp-admin/css/install-rtl.min.css'),
 (111, 'wp-admin/css/install.css'),
 (112, 'wp-admin/css/install.min.css'),
 (113, 'wp-admin/css/l10n-rtl.css'),
 (114, 'wp-admin/css/l10n-rtl.min.css'),
 (115, 'wp-admin/css/l10n.css'),
 (116, 'wp-admin/css/l10n.min.css'),
 (117, 'wp-admin/css/list-tables-rtl.css'),
 (118, 'wp-admin/css/list-tables-rtl.min.css'),
 (119, 'wp-admin/css/list-tables.css'),
 (120, 'wp-admin/css/list-tables.min.css'),
 (121, 'wp-admin/css/login-rtl.css'),
 (122, 'wp-admin/css/login-rtl.min.css'),
 (123, 'wp-admin/css/login.css'),
 (124, 'wp-admin/css/login.min.css'),
 (125, 'wp-admin/css/media-rtl.css'),
 (126, 'wp-admin/css/media-rtl.min.css'),
 (127, 'wp-admin/css/media.css'),
 (128, 'wp-admin/css/media.min.css'),
 (129, 'wp-admin/css/nav-menus-rtl.css'),
 (130, 'wp-admin/css/nav-menus-rtl.min.css'),
 (131, 'wp-admin/css/nav-menus.css'),
 (132, 'wp-admin/css/nav-menus.min.css'),
 (133, 'wp-admin/css/revisions-rtl.css'),
 (134, 'wp-admin/css/revisions-rtl.min.css'),
 (135, 'wp-admin/css/revisions.css'),
 (136, 'wp-admin/css/revisions.min.css'),
 (137, 'wp-admin/css/site-health-rtl.css'),
 (138, 'wp-admin/css/site-health-rtl.min.css'),
 (139, 'wp-admin/css/site-health.css'),
 (140, 'wp-admin/css/site-health.min.css'),
 (141, 'wp-admin/css/site-icon-rtl.css'),
 (142, 'wp-admin/css/site-icon-rtl.min.css'),
 (143, 'wp-admin/css/site-icon.css'),
 (144, 'wp-admin/css/site-icon.min.css'),
 (145, 'wp-admin/css/themes-rtl.css'),
 (146, 'wp-admin/css/themes-rtl.min.css'),
 (147, 'wp-admin/css/themes.css'),
 (148, 'wp-admin/css/themes.min.css'),
 (149, 'wp-admin/css/widgets-rtl.css'),
 (150, 'wp-admin/css/widgets-rtl.min.css'),
 (151, 'wp-admin/css/widgets.css'),
 (152, 'wp-admin/css/widgets.min.css'),
 (153, 'wp-admin/css/wp-admin-rtl.css'),
 (154, 'wp-admin/css/wp-admin-rtl.min.css'),
 (155, 'wp-admin/css/wp-admin.css'),
 (156, 'wp-admin/css/wp-admin.min.css'),
 (157, 'wp-admin/custom-background.php'),
 (158, 'wp-admin/custom-header.php'),
 (159, 'wp-admin/customize.php'),
 (160, 'wp-admin/edit-comments.php'),
 (161, 'wp-admin/edit-form-advanced.php'),
 (162, 'wp-admin/edit-form-blocks.php'),
 (163, 'wp-admin/edit-form-comment.php'),
 (164, 'wp-admin/edit-link-form.php'),
 (165, 'wp-admin/edit-tag-form.php'),
 (166, 'wp-admin/edit-tags.php'),
 (167, 'wp-admin/edit.php'),
 (168, 'wp-admin/erase-personal-data.php'),
 (169, 'wp-admin/error_log'),
 (170, 'wp-admin/export-personal-data.php'),
 (171, 'wp-admin/export.php'),
 (172, 'wp-admin/freedoms.php'),
 (173, 'wp-admin/images/align-center-2x.png'),
 (174, 'wp-admin/images/align-center.png'),
 (175, 'wp-admin/images/align-left-2x.png'),
 (176, 'wp-admin/images/align-left.png'),
 (177, 'wp-admin/images/align-none-2x.png'),
 (178, 'wp-admin/images/align-none.png'),
 (179, 'wp-admin/images/align-right-2x.png'),
 (180, 'wp-admin/images/align-right.png'),
 (181, 'wp-admin/images/arrows-2x.png'),
 (182, 'wp-admin/images/arrows.png'),
 (183, 'wp-admin/images/browser-rtl.png'),
 (184, 'wp-admin/images/browser.png'),
 (185, 'wp-admin/images/bubble_bg-2x.gif'),
 (186, 'wp-admin/images/bubble_bg.gif'),
 (187, 'wp-admin/images/comment-grey-bubble-2x.png'),
 (188, 'wp-admin/images/comment-grey-bubble.png'),
 (189, 'wp-admin/images/date-button-2x.gif'),
 (190, 'wp-admin/images/date-button.gif'),
 (191, 'wp-admin/images/generic.png'),
 (192, 'wp-admin/images/icons32-2x.png'),
 (193, 'wp-admin/images/icons32-vs-2x.png'),
 (194, 'wp-admin/images/icons32-vs.png'),
 (195, 'wp-admin/images/icons32.png'),
 (196, 'wp-admin/images/imgedit-icons-2x.png'),
 (197, 'wp-admin/images/imgedit-icons.png'),
 (198, 'wp-admin/images/list-2x.png'),
 (199, 'wp-admin/images/list.png'),
 (200, 'wp-admin/images/loading.gif'),
 (201, 'wp-admin/images/marker.png'),
 (202, 'wp-admin/images/mask.png'),
 (203, 'wp-admin/images/media-button-2x.png'),
 (204, 'wp-admin/images/media-button-image.gif'),
 (205, 'wp-admin/images/media-button-music.gif'),
 (206, 'wp-admin/images/media-button-other.gif'),
 (207, 'wp-admin/images/media-button-video.gif'),
 (208, 'wp-admin/images/media-button.png'),
 (209, 'wp-admin/images/menu-2x.png'),
 (210, 'wp-admin/images/menu-vs-2x.png'),
 (211, 'wp-admin/images/menu-vs.png'),
 (212, 'wp-admin/images/menu.png'),
 (213, 'wp-admin/images/no.png'),
 (214, 'wp-admin/images/post-formats-vs.png'),
 (215, 'wp-admin/images/post-formats.png'),
 (216, 'wp-admin/images/post-formats32-vs.png'),
 (217, 'wp-admin/images/post-formats32.png'),
 (218, 'wp-admin/images/resize-2x.gif'),
 (219, 'wp-admin/images/resize-rtl-2x.gif'),
 (220, 'wp-admin/images/resize-rtl.gif'),
 (221, 'wp-admin/images/resize.gif'),
 (222, 'wp-admin/images/se.png'),
 (223, 'wp-admin/images/sort-2x.gif'),
 (224, 'wp-admin/images/sort.gif'),
 (225, 'wp-admin/images/spinner-2x.gif'),
 (226, 'wp-admin/images/spinner.gif'),
 (227, 'wp-admin/images/stars-2x.png'),
 (228, 'wp-admin/images/stars.png'),
 (229, 'wp-admin/images/w-logo-blue.png'),
 (230, 'wp-admin/images/w-logo-white.png'),
 (231, 'wp-admin/images/wheel.png'),
 (232, 'wp-admin/images/wordpress-logo-white.svg'),
 (233, 'wp-admin/images/wordpress-logo.png'),
 (234, 'wp-admin/images/wordpress-logo.svg'),
 (235, 'wp-admin/images/wpspin_light-2x.gif'),
 (236, 'wp-admin/images/wpspin_light.gif'),
 (237, 'wp-admin/images/xit-2x.gif'),
 (238, 'wp-admin/images/xit.gif'),
 (239, 'wp-admin/images/yes.png'),
 (240, 'wp-admin/import.php'),
 (241, 'wp-admin/includes/admin-filters.php'),
 (242, 'wp-admin/includes/admin.php'),
 (243, 'wp-admin/includes/ajax-actions.php'),
 (244, 'wp-admin/includes/bookmark.php'),
 (245, 'wp-admin/includes/class-automatic-upgrader-skin.php'),
 (246, 'wp-admin/includes/class-bulk-plugin-upgrader-skin.php'),
 (247, 'wp-admin/includes/class-bulk-theme-upgrader-skin.php'),
 (248, 'wp-admin/includes/class-bulk-upgrader-skin.php'),
 (249, 'wp-admin/includes/class-core-upgrader.php'),
 (250, 'wp-admin/includes/class-custom-background.php'),
 (251, 'wp-admin/includes/class-custom-image-header.php'),
 (252, 'wp-admin/includes/class-file-upload-upgrader.php'),
 (253, 'wp-admin/includes/class-ftp-pure.php'),
 (254, 'wp-admin/includes/class-ftp-sockets.php'),
 (255, 'wp-admin/includes/class-ftp.php'),
 (256, 'wp-admin/includes/class-language-pack-upgrader-skin.php'),
 (257, 'wp-admin/includes/class-language-pack-upgrader.php'),
 (258, 'wp-admin/includes/class-pclzip.php'),
 (259, 'wp-admin/includes/class-plugin-installer-skin.php'),
 (260, 'wp-admin/includes/class-plugin-upgrader-skin.php'),
 (261, 'wp-admin/includes/class-plugin-upgrader.php'),
 (262, 'wp-admin/includes/class-theme-installer-skin.php'),
 (263, 'wp-admin/includes/class-theme-upgrader-skin.php'),
 (264, 'wp-admin/includes/class-theme-upgrader.php'),
 (265, 'wp-admin/includes/class-walker-category-checklist.php'),
 (266, 'wp-admin/includes/class-walker-nav-menu-checklist.php'),
 (267, 'wp-admin/includes/class-walker-nav-menu-edit.php'),
 (268, 'wp-admin/includes/class-wp-ajax-upgrader-skin.php'),
 (269, 'wp-admin/includes/class-wp-automatic-updater.php'),
 (270, 'wp-admin/includes/class-wp-comments-list-table.php'),
 (271, 'wp-admin/includes/class-wp-community-events.php'),
 (272, 'wp-admin/includes/class-wp-debug-data.php'),
 (273, 'wp-admin/includes/class-wp-filesystem-base.php'),
 (274, 'wp-admin/includes/class-wp-filesystem-direct.php'),
 (275, 'wp-admin/includes/class-wp-filesystem-ftpext.php'),
 (276, 'wp-admin/includes/class-wp-filesystem-ftpsockets.php'),
 (277, 'wp-admin/includes/class-wp-filesystem-ssh2.php'),
 (278, 'wp-admin/includes/class-wp-importer.php'),
 (279, 'wp-admin/includes/class-wp-internal-pointers.php'),
 (280, 'wp-admin/includes/class-wp-links-list-table.php'),
 (281, 'wp-admin/includes/class-wp-list-table-compat.php'),
 (282, 'wp-admin/includes/class-wp-list-table.php'),
 (283, 'wp-admin/includes/class-wp-media-list-table.php'),
 (284, 'wp-admin/includes/class-wp-ms-sites-list-table.php'),
 (285, 'wp-admin/includes/class-wp-ms-themes-list-table.php'),
 (286, 'wp-admin/includes/class-wp-ms-users-list-table.php'),
 (287, 'wp-admin/includes/class-wp-plugin-install-list-table.php'),
 (288, 'wp-admin/includes/class-wp-plugins-list-table.php'),
 (289, 'wp-admin/includes/class-wp-post-comments-list-table.php'),
 (290, 'wp-admin/includes/class-wp-posts-list-table.php'),
 (291, 'wp-admin/includes/class-wp-privacy-data-export-requests-list-table.php'),
 (292, 'wp-admin/includes/class-wp-privacy-data-removal-requests-list-table.php'),
 (293, 'wp-admin/includes/class-wp-privacy-policy-content.php'),
 (294, 'wp-admin/includes/class-wp-privacy-requests-table.php'),
 (295, 'wp-admin/includes/class-wp-screen.php'),
 (296, 'wp-admin/includes/class-wp-site-health-auto-updates.php'),
 (297, 'wp-admin/includes/class-wp-site-health.php'),
 (298, 'wp-admin/includes/class-wp-site-icon.php'),
 (299, 'wp-admin/includes/class-wp-terms-list-table.php'),
 (300, 'wp-admin/includes/class-wp-theme-install-list-table.php'),
 (301, 'wp-admin/includes/class-wp-themes-list-table.php'),
 (302, 'wp-admin/includes/class-wp-upgrader-skin.php'),
 (303, 'wp-admin/includes/class-wp-upgrader-skins.php'),
 (304, 'wp-admin/includes/class-wp-upgrader.php'),
 (305, 'wp-admin/includes/class-wp-users-list-table.php'),
 (306, 'wp-admin/includes/comment.php'),
 (307, 'wp-admin/includes/continents-cities.php'),
 (308, 'wp-admin/includes/credits.php'),
 (309, 'wp-admin/includes/dashboard.php'),
 (310, 'wp-admin/includes/deprecated.php'),
 (311, 'wp-admin/includes/edit-tag-messages.php'),
 (312, 'wp-admin/includes/export.php'),
 (313, 'wp-admin/includes/file.php'),
 (314, 'wp-admin/includes/image-edit.php'),
 (315, 'wp-admin/includes/image.php'),
 (316, 'wp-admin/includes/import.php'),
 (317, 'wp-admin/includes/list-table.php'),
 (318, 'wp-admin/includes/media.php'),
 (319, 'wp-admin/includes/menu.php'),
 (320, 'wp-admin/includes/meta-boxes.php'),
 (321, 'wp-admin/includes/misc.php'),
 (322, 'wp-admin/includes/ms-admin-filters.php'),
 (323, 'wp-admin/includes/ms-deprecated.php'),
 (324, 'wp-admin/includes/ms.php'),
 (325, 'wp-admin/includes/nav-menu.php'),
 (326, 'wp-admin/includes/network.php'),
 (327, 'wp-admin/includes/noop.php'),
 (328, 'wp-admin/includes/options.php'),
 (329, 'wp-admin/includes/plugin-install.php'),
 (330, 'wp-admin/includes/plugin.php'),
 (331, 'wp-admin/includes/post.php'),
 (332, 'wp-admin/includes/privacy-tools.php'),
 (333, 'wp-admin/includes/revision.php'),
 (334, 'wp-admin/includes/schema.php'),
 (335, 'wp-admin/includes/screen.php'),
 (336, 'wp-admin/includes/taxonomy.php'),
 (337, 'wp-admin/includes/template.php'),
 (338, 'wp-admin/includes/theme-install.php'),
 (339, 'wp-admin/includes/theme.php'),
 (340, 'wp-admin/includes/translation-install.php'),
 (341, 'wp-admin/includes/update-core.php'),
 (342, 'wp-admin/includes/update.php'),
 (343, 'wp-admin/includes/upgrade.php'),
 (344, 'wp-admin/includes/user.php'),
 (345, 'wp-admin/includes/widgets.php'),
 (346, 'wp-admin/index.php'),
 (347, 'wp-admin/install-helper.php'),
 (348, 'wp-admin/install.php'),
 (349, 'wp-admin/js/accordion.js'),
 (350, 'wp-admin/js/accordion.min.js'),
 (351, 'wp-admin/js/code-editor.js'),
 (352, 'wp-admin/js/code-editor.min.js'),
 (353, 'wp-admin/js/color-picker.js'),
 (354, 'wp-admin/js/color-picker.min.js'),
 (355, 'wp-admin/js/comment.js'),
 (356, 'wp-admin/js/comment.min.js'),
 (357, 'wp-admin/js/common.js'),
 (358, 'wp-admin/js/common.min.js'),
 (359, 'wp-admin/js/custom-background.js'),
 (360, 'wp-admin/js/custom-background.min.js'),
 (361, 'wp-admin/js/custom-header.js'),
 (362, 'wp-admin/js/customize-controls.js'),
 (363, 'wp-admin/js/customize-controls.min.js'),
 (364, 'wp-admin/js/customize-nav-menus.js'),
 (365, 'wp-admin/js/customize-nav-menus.min.js'),
 (366, 'wp-admin/js/customize-widgets.js'),
 (367, 'wp-admin/js/customize-widgets.min.js'),
 (368, 'wp-admin/js/dashboard.js'),
 (369, 'wp-admin/js/dashboard.min.js'),
 (370, 'wp-admin/js/edit-comments.js'),
 (371, 'wp-admin/js/edit-comments.min.js'),
 (372, 'wp-admin/js/editor-expand.js'),
 (373, 'wp-admin/js/editor-expand.min.js'),
 (374, 'wp-admin/js/editor.js'),
 (375, 'wp-admin/js/editor.min.js'),
 (376, 'wp-admin/js/farbtastic.js'),
 (377, 'wp-admin/js/gallery.js'),
 (378, 'wp-admin/js/gallery.min.js'),
 (379, 'wp-admin/js/image-edit.js'),
 (380, 'wp-admin/js/image-edit.min.js'),
 (381, 'wp-admin/js/inline-edit-post.js'),
 (382, 'wp-admin/js/inline-edit-post.min.js'),
 (383, 'wp-admin/js/inline-edit-tax.js'),
 (384, 'wp-admin/js/inline-edit-tax.min.js'),
 (385, 'wp-admin/js/iris.min.js'),
 (386, 'wp-admin/js/language-chooser.js'),
 (387, 'wp-admin/js/language-chooser.min.js'),
 (388, 'wp-admin/js/link.js'),
 (389, 'wp-admin/js/link.min.js'),
 (390, 'wp-admin/js/media-gallery.js'),
 (391, 'wp-admin/js/media-gallery.min.js'),
 (392, 'wp-admin/js/media-upload.js'),
 (393, 'wp-admin/js/media-upload.min.js'),
 (394, 'wp-admin/js/media.js'),
 (395, 'wp-admin/js/media.min.js'),
 (396, 'wp-admin/js/nav-menu.js'),
 (397, 'wp-admin/js/nav-menu.min.js'),
 (398, 'wp-admin/js/password-strength-meter.js'),
 (399, 'wp-admin/js/password-strength-meter.min.js'),
 (400, 'wp-admin/js/plugin-install.js'),
 (401, 'wp-admin/js/plugin-install.min.js'),
 (402, 'wp-admin/js/post.js'),
 (403, 'wp-admin/js/post.min.js'),
 (404, 'wp-admin/js/postbox.js'),
 (405, 'wp-admin/js/postbox.min.js'),
 (406, 'wp-admin/js/privacy-tools.js'),
 (407, 'wp-admin/js/privacy-tools.min.js'),
 (408, 'wp-admin/js/revisions.js'),
 (409, 'wp-admin/js/revisions.min.js'),
 (410, 'wp-admin/js/set-post-thumbnail.js'),
 (411, 'wp-admin/js/set-post-thumbnail.min.js'),
 (412, 'wp-admin/js/site-health.js'),
 (413, 'wp-admin/js/site-health.min.js'),
 (414, 'wp-admin/js/svg-painter.js'),
 (415, 'wp-admin/js/svg-painter.min.js'),
 (416, 'wp-admin/js/tags-box.js'),
 (417, 'wp-admin/js/tags-box.min.js'),
 (418, 'wp-admin/js/tags-suggest.js'),
 (419, 'wp-admin/js/tags-suggest.min.js'),
 (420, 'wp-admin/js/tags.js'),
 (421, 'wp-admin/js/tags.min.js'),
 (422, 'wp-admin/js/theme-plugin-editor.js'),
 (423, 'wp-admin/js/theme-plugin-editor.min.js'),
 (424, 'wp-admin/js/theme.js'),
 (425, 'wp-admin/js/theme.min.js'),
 (426, 'wp-admin/js/updates.js'),
 (427, 'wp-admin/js/updates.min.js'),
 (428, 'wp-admin/js/user-profile.js'),
 (429, 'wp-admin/js/user-profile.min.js'),
 (430, 'wp-admin/js/user-suggest.js'),
 (431, 'wp-admin/js/user-suggest.min.js'),
 (432, 'wp-admin/js/widgets/custom-html-widgets.js'),
 (433, 'wp-admin/js/widgets/custom-html-widgets.min.js'),
 (434, 'wp-admin/js/widgets/media-audio-widget.js'),
 (435, 'wp-admin/js/widgets/media-audio-widget.min.js'),
 (436, 'wp-admin/js/widgets/media-gallery-widget.js'),
 (437, 'wp-admin/js/widgets/media-gallery-widget.min.js'),
 (438, 'wp-admin/js/widgets/media-image-widget.js'),
 (439, 'wp-admin/js/widgets/media-image-widget.min.js'),
 (440, 'wp-admin/js/widgets/media-video-widget.js'),
 (441, 'wp-admin/js/widgets/media-video-widget.min.js'),
 (442, 'wp-admin/js/widgets/media-widgets.js'),
 (443, 'wp-admin/js/widgets/media-widgets.min.js'),
 (444, 'wp-admin/js/widgets/text-widgets.js'),
 (445, 'wp-admin/js/widgets/text-widgets.min.js'),
 (446, 'wp-admin/js/widgets.js'),
 (447, 'wp-admin/js/widgets.min.js'),
 (448, 'wp-admin/js/word-count.js'),
 (449, 'wp-admin/js/word-count.min.js'),
 (450, 'wp-admin/js/xfn.js'),
 (451, 'wp-admin/js/xfn.min.js'),
 (452, 'wp-admin/link-add.php'),
 (453, 'wp-admin/link-manager.php'),
 (454, 'wp-admin/link-parse-opml.php'),
 (455, 'wp-admin/link.php'),
 (456, 'wp-admin/load-scripts.php'),
 (457, 'wp-admin/load-styles.php'),
 (458, 'wp-admin/maint/repair.php'),
 (459, 'wp-admin/media-new.php'),
 (460, 'wp-admin/media-upload.php'),
 (461, 'wp-admin/media.php'),
 (462, 'wp-admin/menu-header.php'),
 (463, 'wp-admin/menu.php'),
 (464, 'wp-admin/moderation.php'),
 (465, 'wp-admin/ms-admin.php'),
 (466, 'wp-admin/ms-delete-site.php'),
 (467, 'wp-admin/ms-edit.php'),
 (468, 'wp-admin/ms-options.php'),
 (469, 'wp-admin/ms-sites.php'),
 (470, 'wp-admin/ms-themes.php'),
 (471, 'wp-admin/ms-upgrade-network.php'),
 (472, 'wp-admin/ms-users.php'),
 (473, 'wp-admin/my-sites.php'),
 (474, 'wp-admin/nav-menus.php'),
 (475, 'wp-admin/network/about.php'),
 (476, 'wp-admin/network/admin.php'),
 (477, 'wp-admin/network/credits.php'),
 (478, 'wp-admin/network/edit.php'),
 (479, 'wp-admin/network/freedoms.php'),
 (480, 'wp-admin/network/index.php'),
 (481, 'wp-admin/network/menu.php'),
 (482, 'wp-admin/network/plugin-editor.php'),
 (483, 'wp-admin/network/plugin-install.php'),
 (484, 'wp-admin/network/plugins.php'),
 (485, 'wp-admin/network/privacy.php'),
 (486, 'wp-admin/network/profile.php'),
 (487, 'wp-admin/network/settings.php'),
 (488, 'wp-admin/network/setup.php'),
 (489, 'wp-admin/network/site-info.php'),
 (490, 'wp-admin/network/site-new.php'),
 (491, 'wp-admin/network/site-settings.php'),
 (492, 'wp-admin/network/site-themes.php'),
 (493, 'wp-admin/network/site-users.php'),
 (494, 'wp-admin/network/sites.php'),
 (495, 'wp-admin/network/theme-editor.php'),
 (496, 'wp-admin/network/theme-install.php'),
 (497, 'wp-admin/network/themes.php'),
 (498, 'wp-admin/network/update-core.php'),
 (499, 'wp-admin/network/update.php'),
 (500, 'wp-admin/network/upgrade.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(501, 'wp-admin/network/user-edit.php'),
 (502, 'wp-admin/network/user-new.php'),
 (503, 'wp-admin/network/users.php'),
 (504, 'wp-admin/network.php'),
 (505, 'wp-admin/options-discussion.php'),
 (506, 'wp-admin/options-general.php'),
 (507, 'wp-admin/options-head.php'),
 (508, 'wp-admin/options-media.php'),
 (509, 'wp-admin/options-permalink.php'),
 (510, 'wp-admin/options-privacy.php'),
 (511, 'wp-admin/options-reading.php'),
 (512, 'wp-admin/options-writing.php'),
 (513, 'wp-admin/options.php'),
 (514, 'wp-admin/plugin-editor.php'),
 (515, 'wp-admin/plugin-install.php'),
 (516, 'wp-admin/plugins.php'),
 (517, 'wp-admin/post-new.php'),
 (518, 'wp-admin/post.php'),
 (519, 'wp-admin/press-this.php'),
 (520, 'wp-admin/privacy-policy-guide.php'),
 (521, 'wp-admin/privacy.php'),
 (522, 'wp-admin/profile.php'),
 (523, 'wp-admin/revision.php'),
 (524, 'wp-admin/setup-config.php'),
 (525, 'wp-admin/site-health-info.php'),
 (526, 'wp-admin/site-health.php'),
 (527, 'wp-admin/term.php'),
 (528, 'wp-admin/theme-editor.php'),
 (529, 'wp-admin/theme-install.php'),
 (530, 'wp-admin/themes.php'),
 (531, 'wp-admin/tools.php'),
 (532, 'wp-admin/update-core.php'),
 (533, 'wp-admin/update.php'),
 (534, 'wp-admin/upgrade-functions.php'),
 (535, 'wp-admin/upgrade.php'),
 (536, 'wp-admin/upload.php'),
 (537, 'wp-admin/user/about.php'),
 (538, 'wp-admin/user/admin.php'),
 (539, 'wp-admin/user/credits.php'),
 (540, 'wp-admin/user/freedoms.php'),
 (541, 'wp-admin/user/index.php'),
 (542, 'wp-admin/user/menu.php'),
 (543, 'wp-admin/user/privacy.php'),
 (544, 'wp-admin/user/profile.php'),
 (545, 'wp-admin/user/user-edit.php'),
 (546, 'wp-admin/user-edit.php'),
 (547, 'wp-admin/user-new.php'),
 (548, 'wp-admin/users.php'),
 (549, 'wp-admin/widgets.php'),
 (550, 'wp-blog-header.php'),
 (551, 'wp-comments-post.php'),
 (552, 'wp-config-sample.php'),
 (553, 'wp-config.php'),
 (554, 'wp-content/backups-dup-pro/20200208_frander_f6bb1414fce13c949773_20200208040505_installer.php'),
 (555, 'wp-content/backups-dup-pro/20200209_main_c11a2dc19e35635d1153_20200209133358_installer.php'),
 (556, 'wp-content/backups-dup-pro/20200210_katysoccer_af4e5f31b5eb57e01658_20200210202208_installer.php'),
 (557, 'wp-content/backups-dup-pro/20200211_kmikzeca_4184a572cd7a22612393_20200211203233_installer.php'),
 (558, 'wp-content/backups-dup-pro/20200211_lentes_d2b436c271b854844092_20200211191546_installer.php'),
 (559, 'wp-content/backups-dup-pro/20200211_pizzeria_2cde327abf1ddb494204_20200211184356_installer.php'),
 (560, 'wp-content/backups-dup-pro/20200212_alcaldiatomaslander_98d304ca2d1c4e5b5117_20200212155937_installer.php'),
 (561, 'wp-content/backups-dup-pro/20200212_asgo_cf9c79d958c039736352_20200212141130_installer.php'),
 (562, 'wp-content/backups-dup-pro/20200218_insumosmedicos_b8f42bfefe12554c3364_20200218171440_installer.php'),
 (563, 'wp-content/backups-dup-pro/20200218_sitiodemo_24e790569362645b8626_20200218190134_installer.php'),
 (564, 'wp-content/backups-dup-pro/20200222_posadaeldoral_63437ef7253f3ad94829_20200222023647_installer.php'),
 (565, 'wp-content/backups-dup-pro/20200226_sitiodemo_753e55be1db2088e7340_20200226061206_installer.php'),
 (566, 'wp-content/backups-dup-pro/20200227_beachtourmc_4e1e3fbd8d600e9c9692_20200227192539_installer.php'),
 (567, 'wp-content/backups-dup-pro/20200227_fr8_8798135c5d576e5d1400_20200227110512_installer.php'),
 (568, 'wp-content/backups-dup-pro/20200229_yates_7ee293fdb94d8d394049_20200229174222_installer.php'),
 (569, 'wp-content/backups-dup-pro/20200306_ssmadrerafols_77b17023f35b347e3834_20200306140338_installer.php'),
 (570, 'wp-content/backups-dup-pro/20200307_cargo_a20ee371ee5f686c4354_20200307033049_installer.php'),
 (571, 'wp-content/backups-dup-pro/20200311_tienda1_d133a3763f0571ba4547_20200311201812_installer.php'),
 (572, 'wp-content/backups-dup-pro/20200313_ssmadrerafols_4f02eeb96652c45b5118_20200313184439_installer.php'),
 (573, 'wp-content/backups-dup-pro/dtoken.php'),
 (574, 'wp-content/backups-dup-pro/index.php'),
 (575, 'wp-content/backups-dup-pro/pizpa_60a6320ddb33add24042_20200210151611_installer.php'),
 (576, 'wp-content/index.php'),
 (577, 'wp-content/plugins/akismet/.htaccess'),
 (578, 'wp-content/plugins/akismet/LICENSE.txt'),
 (579, 'wp-content/plugins/akismet/_inc/akismet.css'),
 (580, 'wp-content/plugins/akismet/_inc/akismet.js'),
 (581, 'wp-content/plugins/akismet/_inc/form.js'),
 (582, 'wp-content/plugins/akismet/_inc/img/logo-full-2x.png'),
 (583, 'wp-content/plugins/akismet/akismet.php'),
 (584, 'wp-content/plugins/akismet/class.akismet-admin.php'),
 (585, 'wp-content/plugins/akismet/class.akismet-cli.php'),
 (586, 'wp-content/plugins/akismet/class.akismet-rest-api.php'),
 (587, 'wp-content/plugins/akismet/class.akismet-widget.php'),
 (588, 'wp-content/plugins/akismet/class.akismet.php'),
 (589, 'wp-content/plugins/akismet/index.php'),
 (590, 'wp-content/plugins/akismet/readme.txt'),
 (591, 'wp-content/plugins/akismet/views/activate.php'),
 (592, 'wp-content/plugins/akismet/views/config.php'),
 (593, 'wp-content/plugins/akismet/views/connect-jp.php'),
 (594, 'wp-content/plugins/akismet/views/enter.php'),
 (595, 'wp-content/plugins/akismet/views/get.php'),
 (596, 'wp-content/plugins/akismet/views/notice.php'),
 (597, 'wp-content/plugins/akismet/views/predefined.php'),
 (598, 'wp-content/plugins/akismet/views/setup.php'),
 (599, 'wp-content/plugins/akismet/views/start.php'),
 (600, 'wp-content/plugins/akismet/views/stats.php'),
 (601, 'wp-content/plugins/akismet/views/title.php'),
 (602, 'wp-content/plugins/akismet/wrapper.php'),
 (603, 'wp-content/plugins/duplicator-pro/assets/css/images/index.php'),
 (604, 'wp-content/plugins/duplicator-pro/assets/css/index.php'),
 (605, 'wp-content/plugins/duplicator-pro/assets/img/index.php'),
 (606, 'wp-content/plugins/duplicator-pro/assets/img/logo-menu.svg'),
 (607, 'wp-content/plugins/duplicator-pro/assets/index.php'),
 (608, 'wp-content/plugins/duplicator-pro/assets/js/dp-kick.js'),
 (609, 'wp-content/plugins/duplicator-pro/assets/js/formstone/bundle.js'),
 (610, 'wp-content/plugins/duplicator-pro/assets/js/formstone/index.php'),
 (611, 'wp-content/plugins/duplicator-pro/assets/js/handlebars.min.js'),
 (612, 'wp-content/plugins/duplicator-pro/assets/js/index.php'),
 (613, 'wp-content/plugins/duplicator-pro/assets/js/javascript.php'),
 (614, 'wp-content/plugins/duplicator-pro/assets/js/jquery.qtip/index.php'),
 (615, 'wp-content/plugins/duplicator-pro/assets/js/jquery.qtip/jquery.qtip.min.js'),
 (616, 'wp-content/plugins/duplicator-pro/assets/js/jstree/index.php'),
 (617, 'wp-content/plugins/duplicator-pro/assets/js/jstree/jstree.js'),
 (618, 'wp-content/plugins/duplicator-pro/assets/js/jstree/jstree.min.js'),
 (619, 'wp-content/plugins/duplicator-pro/assets/js/parsley.min.js'),
 (620, 'wp-content/plugins/duplicator-pro/assets/webfonts/index.php'),
 (621, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Aws.php'),
 (622, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/AbstractClient.php'),
 (623, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/AwsClientInterface.php'),
 (624, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/ClientBuilder.php'),
 (625, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/DefaultClient.php'),
 (626, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/ExpiredCredentialsChecker.php'),
 (627, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/ThrottlingErrorChecker.php'),
 (628, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/UploadBodyListener.php'),
 (629, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/UserAgentListener.php'),
 (630, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Client/index.php'),
 (631, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/AwsQueryVisitor.php'),
 (632, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/JsonCommand.php'),
 (633, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/QueryCommand.php'),
 (634, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/XmlResponseLocationVisitor.php'),
 (635, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Command/index.php'),
 (636, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/AbstractCredentialsDecorator.php'),
 (637, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/AbstractRefreshableCredentials.php'),
 (638, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/CacheableCredentials.php'),
 (639, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/Credentials.php'),
 (640, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/CredentialsInterface.php'),
 (641, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/NullCredentials.php'),
 (642, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php'),
 (643, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Credentials/index.php'),
 (644, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/ClientOptions.php'),
 (645, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/DateFormat.php'),
 (646, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/Region.php'),
 (647, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/Size.php'),
 (648, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/Time.php'),
 (649, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/UaString.php'),
 (650, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum/index.php'),
 (651, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Enum.php'),
 (652, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/AwsExceptionInterface.php'),
 (653, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/BadMethodCallException.php'),
 (654, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/DomainException.php'),
 (655, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/ExceptionFactoryInterface.php'),
 (656, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/ExceptionListener.php'),
 (657, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/InstanceProfileCredentialsException.php'),
 (658, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/InvalidArgumentException.php'),
 (659, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/LogicException.php'),
 (660, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/MultipartUploadException.php'),
 (661, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/NamespaceExceptionFactory.php'),
 (662, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/OutOfBoundsException.php'),
 (663, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/OverflowException.php'),
 (664, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php'),
 (665, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php'),
 (666, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/ExceptionParserInterface.php'),
 (667, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php'),
 (668, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonRestExceptionParser.php'),
 (669, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/Parser/index.php'),
 (670, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/RequiredExtensionNotLoadedException.php'),
 (671, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/RuntimeException.php'),
 (672, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/ServiceResponseException.php'),
 (673, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/TransferException.php'),
 (674, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/UnexpectedValueException.php'),
 (675, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Exception/index.php'),
 (676, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/Facade.php'),
 (677, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/FacadeInterface.php'),
 (678, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/facade-classes.php'),
 (679, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Facade/index.php'),
 (680, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/ChunkHash.php'),
 (681, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/ChunkHashInterface.php'),
 (682, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/HashUtils.php'),
 (683, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/TreeHash.php'),
 (684, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Hash/index.php'),
 (685, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/HostNameUtils.php'),
 (686, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/InstanceMetadataClient.php'),
 (687, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php'),
 (688, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/index.php'),
 (689, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/InstanceMetadata/index.php'),
 (690, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIterator.php'),
 (691, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIteratorFactory.php'),
 (692, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Iterator/index.php'),
 (693, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransfer.php'),
 (694, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransferState.php'),
 (695, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php'),
 (696, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadId.php'),
 (697, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php'),
 (698, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferInterface.php'),
 (699, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferStateInterface.php'),
 (700, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadIdInterface.php'),
 (701, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadPartInterface.php'),
 (702, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/index.php'),
 (703, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Model/index.php'),
 (704, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/aws-config.php'),
 (705, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/index.php'),
 (706, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/public-endpoints.php'),
 (707, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Resources/sdk1-config.php'),
 (708, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/RulesEndpointProvider.php'),
 (709, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/AbstractSignature.php'),
 (710, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/EndpointSignatureInterface.php'),
 (711, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureInterface.php'),
 (712, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureListener.php'),
 (713, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureV2.php'),
 (714, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureV3Https.php'),
 (715, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/SignatureV4.php'),
 (716, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Signature/index.php'),
 (717, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/AbstractResourceWaiter.php'),
 (718, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/AbstractWaiter.php'),
 (719, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/CallableWaiter.php'),
 (720, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/CompositeWaiterFactory.php'),
 (721, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/ConfigResourceWaiter.php'),
 (722, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/ResourceWaiterInterface.php'),
 (723, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterClassFactory.php'),
 (724, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfig.php'),
 (725, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfigFactory.php'),
 (726, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterFactoryInterface.php'),
 (727, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/WaiterInterface.php'),
 (728, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/Waiter/index.php'),
 (729, 'wp-content/plugins/duplicator-pro/aws/Aws/Common/index.php'),
 (730, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/AcpListener.php'),
 (731, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/BucketStyleListener.php'),
 (732, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Command/S3Command.php'),
 (733, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Command/index.php'),
 (734, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/CannedAcl.php'),
 (735, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/EncodingType.php'),
 (736, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Event.php'),
 (737, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/GranteeType.php'),
 (738, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Group.php'),
 (739, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/MFADelete.php'),
 (740, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/MetadataDirective.php'),
 (741, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Payer.php'),
 (742, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Permission.php'),
 (743, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Protocol.php'),
 (744, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/ServerSideEncryption.php'),
 (745, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Status.php'),
 (746, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/Storage.php'),
 (747, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/StorageClass.php'),
 (748, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Enum/index.php'),
 (749, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/AccessDeniedException.php'),
 (750, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/AccountProblemException.php'),
 (751, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php'),
 (752, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BadDigestException.php'),
 (753, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyExistsException.php'),
 (754, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php'),
 (755, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/BucketNotEmptyException.php'),
 (756, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/CredentialsNotSupportedException.php'),
 (757, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php'),
 (758, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/DeleteMultipleObjectsException.php'),
 (759, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/EntityTooLargeException.php'),
 (760, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/EntityTooSmallException.php'),
 (761, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ExpiredTokenException.php'),
 (762, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/IllegalVersioningConfigurationException.php'),
 (763, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/IncompleteBodyException.php'),
 (764, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php'),
 (765, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InlineDataTooLargeException.php'),
 (766, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InternalErrorException.php'),
 (767, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidAccessKeyIdException.php'),
 (768, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidAddressingHeaderException.php'),
 (769, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidArgumentException.php'),
 (770, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketNameException.php'),
 (771, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketStateException.php'),
 (772, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidDigestException.php'),
 (773, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidLocationConstraintException.php'),
 (774, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPartException.php'),
 (775, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPartOrderException.php'),
 (776, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPayerException.php'),
 (777, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidPolicyDocumentException.php'),
 (778, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidRangeException.php'),
 (779, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidRequestException.php'),
 (780, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidSOAPRequestException.php'),
 (781, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidSecurityException.php'),
 (782, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidStorageClassException.php'),
 (783, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidTagErrorException.php'),
 (784, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php'),
 (785, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidTokenException.php'),
 (786, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/InvalidURIException.php'),
 (787, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/KeyTooLongException.php'),
 (788, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MalformedACLErrorException.php'),
 (789, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MalformedPOSTRequestException.php'),
 (790, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MalformedXMLException.php'),
 (791, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MaxMessageLengthExceededException.php'),
 (792, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php'),
 (793, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MetadataTooLargeException.php'),
 (794, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MethodNotAllowedException.php'),
 (795, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingAttachmentException.php'),
 (796, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingContentLengthException.php'),
 (797, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingRequestBodyErrorException.php'),
 (798, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityElementException.php'),
 (799, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityHeaderException.php'),
 (800, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoLoggingStatusForKeyException.php'),
 (801, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketException.php'),
 (802, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketPolicyException.php'),
 (803, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchCORSConfigurationException.php'),
 (804, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchKeyException.php'),
 (805, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php'),
 (806, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchTagSetException.php'),
 (807, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchUploadException.php'),
 (808, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchVersionException.php'),
 (809, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php'),
 (810, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NotImplementedException.php'),
 (811, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NotSignedUpException.php'),
 (812, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/NotSuchBucketPolicyException.php'),
 (813, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php'),
 (814, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php'),
 (815, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/OperationAbortedException.php'),
 (816, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/Parser/S3ExceptionParser.php'),
 (817, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/Parser/index.php'),
 (818, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/PermanentRedirectException.php'),
 (819, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/PreconditionFailedException.php'),
 (820, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RedirectException.php'),
 (821, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestIsNotMultiPartContentException.php'),
 (822, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestTimeTooSkewedException.php'),
 (823, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestTimeoutException.php'),
 (824, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php'),
 (825, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/S3Exception.php'),
 (826, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/ServiceUnavailableException.php'),
 (827, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/SignatureDoesNotMatchException.php'),
 (828, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/SlowDownException.php'),
 (829, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/TemporaryRedirectException.php'),
 (830, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/TokenRefreshRequiredException.php'),
 (831, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/TooManyBucketsException.php'),
 (832, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/UnexpectedContentException.php'),
 (833, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php'),
 (834, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php'),
 (835, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Exception/index.php'),
 (836, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/IncompleteMultipartUploadChecker.php'),
 (837, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListBucketsIterator.php'),
 (838, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListMultipartUploadsIterator.php'),
 (839, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListObjectVersionsIterator.php'),
 (840, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/ListObjectsIterator.php'),
 (841, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/OpendirIterator.php'),
 (842, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Iterator/index.php'),
 (843, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/Acp.php'),
 (844, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/AcpBuilder.php'),
 (845, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/ClearBucket.php'),
 (846, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsBatch.php'),
 (847, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsTransfer.php'),
 (848, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/Grant.php'),
 (849, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/Grantee.php'),
 (850, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/AbstractTransfer.php'),
 (851, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/ParallelTransfer.php'),
 (852, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/SerialTransfer.php'),
 (853, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/TransferState.php'),
 (854, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadBuilder.php'),
 (855, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadId.php'),
 (856, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadPart.php'),
 (857, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/index.php'),
 (858, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/PostObject.php'),
 (859, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Model/index.php'),
 (860, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Resources/index.php'),
 (861, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Resources/s3-2006-03-01.php'),
 (862, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/ResumableDownload.php'),
 (863, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3Client.php'),
 (864, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3Md5Listener.php'),
 (865, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3Signature.php'),
 (866, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3SignatureInterface.php'),
 (867, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/S3SignatureV4.php'),
 (868, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/SocketTimeoutChecker.php'),
 (869, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/SseCpkListener.php'),
 (870, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/StreamWrapper.php'),
 (871, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/AbstractSync.php'),
 (872, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/AbstractSyncBuilder.php'),
 (873, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/ChangedFilesIterator.php'),
 (874, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/DownloadSync.php'),
 (875, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/DownloadSyncBuilder.php'),
 (876, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/FilenameConverterInterface.php'),
 (877, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/KeyConverter.php'),
 (878, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/UploadSync.php'),
 (879, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/UploadSyncBuilder.php'),
 (880, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/Sync/index.php'),
 (881, 'wp-content/plugins/duplicator-pro/aws/Aws/S3/index.php'),
 (882, 'wp-content/plugins/duplicator-pro/aws/Aws/index.php'),
 (883, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/AbstractHasDispatcher.php'),
 (884, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Collection.php'),
 (885, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Event.php'),
 (886, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/BadMethodCallException.php'),
 (887, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/ExceptionCollection.php'),
 (888, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/GuzzleException.php'),
 (889, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/InvalidArgumentException.php'),
 (890, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/RuntimeException.php'),
 (891, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/UnexpectedValueException.php'),
 (892, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Exception/index.php'),
 (893, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/FromConfigInterface.php'),
 (894, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/HasDispatcherInterface.php'),
 (895, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/ToArrayInterface.php'),
 (896, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/Version.php'),
 (897, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Common/index.php'),
 (898, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/AbstractEntityBodyDecorator.php'),
 (899, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/CachingEntityBody.php'),
 (900, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Client.php'),
 (901, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/ClientInterface.php'),
 (902, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlHandle.php'),
 (903, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlMulti.php'),
 (904, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiInterface.php'),
 (905, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiProxy.php'),
 (906, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/CurlVersion.php'),
 (907, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/RequestMediator.php'),
 (908, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Curl/index.php'),
 (909, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/EntityBody.php'),
 (910, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/EntityBodyInterface.php'),
 (911, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/BadResponseException.php'),
 (912, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/ClientErrorResponseException.php'),
 (913, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/CouldNotRewindStreamException.php'),
 (914, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/CurlException.php'),
 (915, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/HttpException.php'),
 (916, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/MultiTransferException.php'),
 (917, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/RequestException.php'),
 (918, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/ServerErrorResponseException.php'),
 (919, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/TooManyRedirectsException.php'),
 (920, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Exception/index.php'),
 (921, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/IoEmittingEntityBody.php'),
 (922, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/AbstractMessage.php'),
 (923, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequest.php'),
 (924, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequestInterface.php'),
 (925, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/CacheControl.php'),
 (926, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderCollection.php'),
 (927, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactory.php'),
 (928, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactoryInterface.php'),
 (929, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderInterface.php'),
 (930, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/Link.php'),
 (931, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header/index.php'),
 (932, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Header.php'),
 (933, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/MessageInterface.php'),
 (934, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/PostFile.php'),
 (935, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/PostFileInterface.php'),
 (936, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Request.php'),
 (937, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/RequestFactory.php'),
 (938, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/RequestFactoryInterface.php'),
 (939, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/RequestInterface.php'),
 (940, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/Response.php'),
 (941, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Message/index.php'),
 (942, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Mimetypes.php'),
 (943, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/CommaAggregator.php'),
 (944, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/DuplicateAggregator.php'),
 (945, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/PhpAggregator.php'),
 (946, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php'),
 (947, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryAggregator/index.php'),
 (948, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/QueryString.php'),
 (949, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/ReadLimitEntityBody.php'),
 (950, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/RedirectPlugin.php'),
 (951, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Resources/index.php'),
 (952, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/StaticClient.php'),
 (953, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/Url.php'),
 (954, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Http/index.php'),
 (955, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/Inflector.php'),
 (956, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/InflectorInterface.php'),
 (957, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/MemoizingInflector.php'),
 (958, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/PreComputedInflector.php'),
 (959, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Inflection/index.php'),
 (960, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParser.php'),
 (961, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParserInterface.php'),
 (962, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Cookie/index.php'),
 (963, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/AbstractMessageParser.php'),
 (964, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/MessageParser.php'),
 (965, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/MessageParserInterface.php'),
 (966, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/PeclHttpMessageParser.php'),
 (967, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Message/index.php'),
 (968, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/ParserRegistry.php'),
 (969, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/PeclUriTemplate.php'),
 (970, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplate.php'),
 (971, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplateInterface.php'),
 (972, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/UriTemplate/index.php'),
 (973, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Url/UrlParser.php'),
 (974, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Url/UrlParserInterface.php'),
 (975, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/Url/index.php'),
 (976, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Parser/index.php'),
 (977, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php'),
 (978, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php'),
 (979, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffLogger.php'),
 (980, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffPlugin.php'),
 (981, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php'),
 (982, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php'),
 (983, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php'),
 (984, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php'),
 (985, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php'),
 (986, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php'),
 (987, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php'),
 (988, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php'),
 (989, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php'),
 (990, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Plugin/Backoff/index.php'),
 (991, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/AbstractConfigLoader.php'),
 (992, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilder.php'),
 (993, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderInterface.php'),
 (994, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderLoader.php'),
 (995, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Builder/index.php'),
 (996, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/CachingConfigLoader.php'),
 (997, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Client.php'),
 (998, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/ClientInterface.php'),
 (999, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/AbstractCommand.php'),
 (1000, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/ClosureCommand.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(1001, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/CommandInterface.php'),
 (1002, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/CreateResponseClassEvent.php'),
 (1003, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/DefaultRequestSerializer.php'),
 (1004, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/DefaultResponseParser.php'),
 (1005, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/AliasFactory.php'),
 (1006, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/CompositeFactory.php'),
 (1007, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/ConcreteClassFactory.php'),
 (1008, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/FactoryInterface.php'),
 (1009, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/MapFactory.php'),
 (1010, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php'),
 (1011, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/Factory/index.php'),
 (1012, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php'),
 (1013, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php'),
 (1014, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php'),
 (1015, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php'),
 (1016, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php'),
 (1017, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php'),
 (1018, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php'),
 (1019, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php'),
 (1020, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php'),
 (1021, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php'),
 (1022, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/index.php'),
 (1023, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php'),
 (1024, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php'),
 (1025, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php'),
 (1026, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php'),
 (1027, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php'),
 (1028, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php'),
 (1029, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php'),
 (1030, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php'),
 (1031, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/index.php'),
 (1032, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php'),
 (1033, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/index.php'),
 (1034, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/OperationCommand.php'),
 (1035, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/OperationResponseParser.php'),
 (1036, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/RequestSerializerInterface.php'),
 (1037, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/ResponseClassInterface.php'),
 (1038, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/ResponseParserInterface.php'),
 (1039, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Command/index.php'),
 (1040, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/ConfigLoaderInterface.php'),
 (1041, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/Operation.php'),
 (1042, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/OperationInterface.php'),
 (1043, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/Parameter.php'),
 (1044, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/SchemaFormatter.php'),
 (1045, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/SchemaValidator.php'),
 (1046, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescription.php'),
 (1047, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionInterface.php'),
 (1048, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionLoader.php'),
 (1049, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/ValidatorInterface.php'),
 (1050, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Description/index.php'),
 (1051, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/CommandException.php'),
 (1052, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/CommandTransferException.php'),
 (1053, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/DescriptionBuilderException.php'),
 (1054, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/InconsistentClientTransferException.php'),
 (1055, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ResponseClassException.php'),
 (1056, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ServiceBuilderException.php'),
 (1057, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ServiceNotFoundException.php'),
 (1058, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/ValidationException.php'),
 (1059, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Exception/index.php'),
 (1060, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php'),
 (1061, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php'),
 (1062, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/MapResourceIteratorFactory.php'),
 (1063, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/Model.php'),
 (1064, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIterator.php'),
 (1065, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php'),
 (1066, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorClassFactory.php'),
 (1067, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php'),
 (1068, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorInterface.php'),
 (1069, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/Resource/index.php'),
 (1070, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Service/index.php'),
 (1071, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/PhpStreamRequestFactory.php'),
 (1072, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/Stream.php'),
 (1073, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/StreamInterface.php'),
 (1074, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/StreamRequestFactoryInterface.php'),
 (1075, 'wp-content/plugins/duplicator-pro/aws/Guzzle/Stream/index.php'),
 (1076, 'wp-content/plugins/duplicator-pro/aws/Guzzle/index.php'),
 (1077, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/ContainerAwareEventDispatcher.php'),
 (1078, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/RegisterListenersPass.php'),
 (1079, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/index.php'),
 (1080, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/Event.php'),
 (1081, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcher.php'),
 (1082, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcherInterface.php'),
 (1083, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventSubscriberInterface.php'),
 (1084, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/GenericEvent.php'),
 (1085, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/ImmutableEventDispatcher.php'),
 (1086, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/EventDispatcher/index.php'),
 (1087, 'wp-content/plugins/duplicator-pro/aws/Symfony/Component/index.php'),
 (1088, 'wp-content/plugins/duplicator-pro/aws/Symfony/index.php'),
 (1089, 'wp-content/plugins/duplicator-pro/aws/aws-autoloader.php'),
 (1090, 'wp-content/plugins/duplicator-pro/aws/index.php'),
 (1091, 'wp-content/plugins/duplicator-pro/classes/class.archive.config.php'),
 (1092, 'wp-content/plugins/duplicator-pro/classes/class.constants.php'),
 (1093, 'wp-content/plugins/duplicator-pro/classes/class.crypt.blowfish.php'),
 (1094, 'wp-content/plugins/duplicator-pro/classes/class.crypt.custom.php'),
 (1095, 'wp-content/plugins/duplicator-pro/classes/class.db.php'),
 (1096, 'wp-content/plugins/duplicator-pro/classes/class.enhanced.plugin.updater.php'),
 (1097, 'wp-content/plugins/duplicator-pro/classes/class.exceptions.php'),
 (1098, 'wp-content/plugins/duplicator-pro/classes/class.io.php'),
 (1099, 'wp-content/plugins/duplicator-pro/classes/class.logging.php'),
 (1100, 'wp-content/plugins/duplicator-pro/classes/class.package.pagination.php'),
 (1101, 'wp-content/plugins/duplicator-pro/classes/class.password.php'),
 (1102, 'wp-content/plugins/duplicator-pro/classes/class.php.log.php'),
 (1103, 'wp-content/plugins/duplicator-pro/classes/class.scan.check.php'),
 (1104, 'wp-content/plugins/duplicator-pro/classes/class.server.php'),
 (1105, 'wp-content/plugins/duplicator-pro/classes/class.system.checker.php'),
 (1106, 'wp-content/plugins/duplicator-pro/classes/class.wp.list.table.php'),
 (1107, 'wp-content/plugins/duplicator-pro/classes/entities/class.brand.entity.php'),
 (1108, 'wp-content/plugins/duplicator-pro/classes/entities/class.duparchive.expandstate.entity.php'),
 (1109, 'wp-content/plugins/duplicator-pro/classes/entities/class.global.entity.php'),
 (1110, 'wp-content/plugins/duplicator-pro/classes/entities/class.json.entity.base.php'),
 (1111, 'wp-content/plugins/duplicator-pro/classes/entities/class.package.template.entity.php'),
 (1112, 'wp-content/plugins/duplicator-pro/classes/entities/class.profilelogs.entity.php'),
 (1113, 'wp-content/plugins/duplicator-pro/classes/entities/class.schedule.entity.php'),
 (1114, 'wp-content/plugins/duplicator-pro/classes/entities/class.secure.global.entity.php'),
 (1115, 'wp-content/plugins/duplicator-pro/classes/entities/class.storage.entity.php'),
 (1116, 'wp-content/plugins/duplicator-pro/classes/entities/class.system.global.entity.php'),
 (1117, 'wp-content/plugins/duplicator-pro/classes/entities/class.verifiers.php'),
 (1118, 'wp-content/plugins/duplicator-pro/classes/entities/index.php'),
 (1119, 'wp-content/plugins/duplicator-pro/classes/environment/class.db.checker.php'),
 (1120, 'wp-content/plugins/duplicator-pro/classes/environment/class.environment.checker.php'),
 (1121, 'wp-content/plugins/duplicator-pro/classes/environment/index.php'),
 (1122, 'wp-content/plugins/duplicator-pro/classes/environment/interface.checker.php'),
 (1123, 'wp-content/plugins/duplicator-pro/classes/index.php'),
 (1124, 'wp-content/plugins/duplicator-pro/classes/net/class.ftp.chunker.php'),
 (1125, 'wp-content/plugins/duplicator-pro/classes/net/class.u.gdrive.php'),
 (1126, 'wp-content/plugins/duplicator-pro/classes/net/class.u.onedrive.php'),
 (1127, 'wp-content/plugins/duplicator-pro/classes/net/class.u.s3.php'),
 (1128, 'wp-content/plugins/duplicator-pro/classes/net/index.php'),
 (1129, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.available.php'),
 (1130, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.filters.php'),
 (1131, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.php'),
 (1132, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.shellzip.php'),
 (1133, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.archive.zip.php'),
 (1134, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.database.php'),
 (1135, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.installer.php'),
 (1136, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.multisite.php'),
 (1137, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.php'),
 (1138, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.runner.php'),
 (1139, 'wp-content/plugins/duplicator-pro/classes/package/class.pack.upload.info.php'),
 (1140, 'wp-content/plugins/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.php'),
 (1141, 'wp-content/plugins/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.create.php'),
 (1142, 'wp-content/plugins/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.expand.php'),
 (1143, 'wp-content/plugins/duplicator-pro/classes/package/duparchive/index.php'),
 (1144, 'wp-content/plugins/duplicator-pro/classes/package/index.php'),
 (1145, 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.alert.php'),
 (1146, 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.dialog.php'),
 (1147, 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.messages.php'),
 (1148, 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.notice.php'),
 (1149, 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.php'),
 (1150, 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.screen.base.php'),
 (1151, 'wp-content/plugins/duplicator-pro/classes/ui/class.ui.viewstate.php'),
 (1152, 'wp-content/plugins/duplicator-pro/classes/ui/index.php'),
 (1153, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.date.php'),
 (1154, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.import.php'),
 (1155, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.json.php'),
 (1156, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.license.php'),
 (1157, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.low.php'),
 (1158, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.multisite.php'),
 (1159, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.php'),
 (1160, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.settings.php'),
 (1161, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.shell.php'),
 (1162, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.string.php'),
 (1163, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.tree.files.php'),
 (1164, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.upgrade.php'),
 (1165, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.validator.php'),
 (1166, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.wp.php'),
 (1167, 'wp-content/plugins/duplicator-pro/classes/utilities/class.u.zip.php'),
 (1168, 'wp-content/plugins/duplicator-pro/classes/utilities/index.php'),
 (1169, 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.test.debug.php'),
 (1170, 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.test.package.build.php'),
 (1171, 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.u.test.abstract.php'),
 (1172, 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.u.test.result.php'),
 (1173, 'wp-content/plugins/duplicator-pro/classes/utilities/tests/class.u.tests.manager.php'),
 (1174, 'wp-content/plugins/duplicator-pro/classes/utilities/wordpress.core.files.php'),
 (1175, 'wp-content/plugins/duplicator-pro/ctrls/class.web.services.php'),
 (1176, 'wp-content/plugins/duplicator-pro/ctrls/ctrl.base.php'),
 (1177, 'wp-content/plugins/duplicator-pro/ctrls/ctrl.package.php'),
 (1178, 'wp-content/plugins/duplicator-pro/ctrls/ctrl.schedule.php'),
 (1179, 'wp-content/plugins/duplicator-pro/ctrls/ctrl.tools.php'),
 (1180, 'wp-content/plugins/duplicator-pro/ctrls/index.php'),
 (1181, 'wp-content/plugins/duplicator-pro/debug/index.php'),
 (1182, 'wp-content/plugins/duplicator-pro/debug/main.php'),
 (1183, 'wp-content/plugins/duplicator-pro/debug/tst.packages.php'),
 (1184, 'wp-content/plugins/duplicator-pro/debug/tst.tools.php'),
 (1185, 'wp-content/plugins/duplicator-pro/define.php'),
 (1186, 'wp-content/plugins/duplicator-pro/duplicator-pro.php'),
 (1187, 'wp-content/plugins/duplicator-pro/index.php'),
 (1188, 'wp-content/plugins/duplicator-pro/installer/dtoken.php'),
 (1189, 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/class.api.php'),
 (1190, 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/class.cpnl.base.php'),
 (1191, 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/class.cpnl.ctrl.php'),
 (1192, 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/index.php'),
 (1193, 'wp-content/plugins/duplicator-pro/installer/dup-installer/api/router.php'),
 (1194, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/font-awesome/css/index.php'),
 (1195, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/font-awesome/index.php'),
 (1196, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/font-awesome/webfonts/index.php'),
 (1197, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/images/index.php'),
 (1198, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.css.php'),
 (1199, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.js.php'),
 (1200, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.libs.css.php'),
 (1201, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/inc.libs.js.php'),
 (1202, 'wp-content/plugins/duplicator-pro/installer/dup-installer/assets/index.php'),
 (1203, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/EventIterator.php'),
 (1204, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/GenericSeekableIterator.php'),
 (1205, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/class.s3.iterator.php'),
 (1206, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunk.s3.manager.php'),
 (1207, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager.php'),
 (1208, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager_file.php'),
 (1209, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Crypt/Base.php'),
 (1210, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Crypt/Random.php'),
 (1211, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/Crypt/Rijndael.php'),
 (1212, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.crypt.php'),
 (1213, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.csrf.php'),
 (1214, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.db.php'),
 (1215, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.engine.php'),
 (1216, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.http.php'),
 (1217, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.installer.state.php'),
 (1218, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.logging.php'),
 (1219, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.password.php'),
 (1220, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.s3.func.php'),
 (1221, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.server.php'),
 (1222, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/class.view.php'),
 (1223, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.archive.config.php'),
 (1224, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.boot.php'),
 (1225, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.conf.srv.php'),
 (1226, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.conf.wp.php'),
 (1227, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/class.constants.php'),
 (1228, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/config/index.php'),
 (1229, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/index.php'),
 (1230, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.exceptions.php'),
 (1231, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.html.php'),
 (1232, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.multisite.php'),
 (1233, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.notices.manager.php'),
 (1234, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.php'),
 (1235, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.remove.redundant.data.php'),
 (1236, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/class.u.search.reaplce.manager.php'),
 (1237, 'wp-content/plugins/duplicator-pro/installer/dup-installer/classes/utilities/index.php'),
 (1238, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.base.php'),
 (1239, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.extraction.php'),
 (1240, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.php'),
 (1241, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.base.php'),
 (1242, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbinstall.php'),
 (1243, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbtest.php'),
 (1244, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/ctrl.s3.php'),
 (1245, 'wp-content/plugins/duplicator-pro/installer/dup-installer/ctrls/index.php'),
 (1246, 'wp-content/plugins/duplicator-pro/installer/dup-installer/index.php'),
 (1247, 'wp-content/plugins/duplicator-pro/installer/dup-installer/main.installer.php'),
 (1248, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/index.php'),
 (1249, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.api.php'),
 (1250, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.exception.php'),
 (1251, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.help.php'),
 (1252, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.init1.php'),
 (1253, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s1.base.php'),
 (1254, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s1.terms.php'),
 (1255, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.base.php'),
 (1256, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.basic.php'),
 (1257, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.cpnl.php'),
 (1258, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s2.dbtest.php'),
 (1259, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s3.php'),
 (1260, 'wp-content/plugins/duplicator-pro/installer/dup-installer/views/view.s4.php'),
 (1261, 'wp-content/plugins/duplicator-pro/installer/index.php'),
 (1262, 'wp-content/plugins/duplicator-pro/lang/index.php'),
 (1263, 'wp-content/plugins/duplicator-pro/lib/DropPHP/DropboxClient.php'),
 (1264, 'wp-content/plugins/duplicator-pro/lib/DropPHP/DropboxV2Client.php'),
 (1265, 'wp-content/plugins/duplicator-pro/lib/DropPHP/OAuthSimple.php'),
 (1266, 'wp-content/plugins/duplicator-pro/lib/DropPHP/index.php'),
 (1267, 'wp-content/plugins/duplicator-pro/lib/ca/index.php'),
 (1268, 'wp-content/plugins/duplicator-pro/lib/certificates/index.php'),
 (1269, 'wp-content/plugins/duplicator-pro/lib/config/class.wp.config.tranformer.php'),
 (1270, 'wp-content/plugins/duplicator-pro/lib/config/class.wp.config.tranformer.src.php'),
 (1271, 'wp-content/plugins/duplicator-pro/lib/cron/csd_parser.php'),
 (1272, 'wp-content/plugins/duplicator-pro/lib/cron/index.php'),
 (1273, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.constants.php'),
 (1274, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.engine.php'),
 (1275, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.loggerbase.php'),
 (1276, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.mini.expander.php'),
 (1277, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/class.duparchive.processing.failure.php'),
 (1278, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.directory.php'),
 (1279, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.file.php'),
 (1280, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.glob.php'),
 (1281, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.php'),
 (1282, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.u.php'),
 (1283, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/headers/index.php'),
 (1284, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/index.php'),
 (1285, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.directory.php'),
 (1286, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.file.php'),
 (1287, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/processors/index.php'),
 (1288, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.base.php'),
 (1289, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.create.php'),
 (1290, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.expand.php'),
 (1291, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simplecreate.php'),
 (1292, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simpleexpand.php'),
 (1293, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/states/index.php'),
 (1294, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.u.json.php'),
 (1295, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.php'),
 (1296, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.scan.php'),
 (1297, 'wp-content/plugins/duplicator-pro/lib/dup_archive/classes/util/index.php'),
 (1298, 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/class.daws.constants.php'),
 (1299, 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/class.daws.state.expand.php'),
 (1300, 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/daws.php'),
 (1301, 'wp-content/plugins/duplicator-pro/lib/dup_archive/daws/index.php'),
 (1302, 'wp-content/plugins/duplicator-pro/lib/dup_archive/define.php'),
 (1303, 'wp-content/plugins/duplicator-pro/lib/dup_archive/index.php'),
 (1304, 'wp-content/plugins/duplicator-pro/lib/edd/EDD_SL_Plugin_Updater.php'),
 (1305, 'wp-content/plugins/duplicator-pro/lib/edd/index.php'),
 (1306, 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.constants.php'),
 (1307, 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.state.php'),
 (1308, 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.u.delete.php'),
 (1309, 'wp-content/plugins/duplicator-pro/lib/fileops/class.fileops.u.move.php'),
 (1310, 'wp-content/plugins/duplicator-pro/lib/fileops/fileops.php'),
 (1311, 'wp-content/plugins/duplicator-pro/lib/fileops/index.php'),
 (1312, 'wp-content/plugins/duplicator-pro/lib/forceutf8/index.php'),
 (1313, 'wp-content/plugins/duplicator-pro/lib/forceutf8/src/Encoding.php'),
 (1314, 'wp-content/plugins/duplicator-pro/lib/forceutf8/src/index.php'),
 (1315, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/Abstract.php'),
 (1316, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/Exception.php'),
 (1317, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/OAuth2.php'),
 (1318, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Auth/index.php'),
 (1319, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/Abstract.php'),
 (1320, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/Exception.php'),
 (1321, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/File.php'),
 (1322, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/Null.php'),
 (1323, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Cache/index.php'),
 (1324, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Client.php'),
 (1325, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Collection.php'),
 (1326, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Config.php'),
 (1327, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Exception.php'),
 (1328, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/Batch.php'),
 (1329, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/CacheParser.php'),
 (1330, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/MediaFileUpload.php'),
 (1331, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/REST.php'),
 (1332, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/Request.php'),
 (1333, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Http/index.php'),
 (1334, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Abstract.php'),
 (1335, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Curl.php'),
 (1336, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Exception.php'),
 (1337, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/Stream.php'),
 (1338, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/IO/index.php'),
 (1339, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/Abstract.php'),
 (1340, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/Exception.php'),
 (1341, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/File.php'),
 (1342, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/Null.php'),
 (1343, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Logger/index.php'),
 (1344, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Model.php'),
 (1345, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Drive.php'),
 (1346, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Exception.php'),
 (1347, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Oauth2.php'),
 (1348, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/Resource.php'),
 (1349, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service/index.php'),
 (1350, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Service.php'),
 (1351, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/Exception.php'),
 (1352, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/Retryable.php'),
 (1353, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/Runner.php'),
 (1354, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Task/index.php'),
 (1355, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Utils/URITemplate.php'),
 (1356, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Utils/index.php'),
 (1357, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/Utils.php'),
 (1358, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/autoload.php'),
 (1359, 'wp-content/plugins/duplicator-pro/lib/google/apiclient/index.php'),
 (1360, 'wp-content/plugins/duplicator-pro/lib/google/class.enhanced.google.media.file.upload.php'),
 (1361, 'wp-content/plugins/duplicator-pro/lib/google/index.php'),
 (1362, 'wp-content/plugins/duplicator-pro/lib/index.php'),
 (1363, 'wp-content/plugins/duplicator-pro/lib/onedrive/autoload.php'),
 (1364, 'wp-content/plugins/duplicator-pro/lib/onedrive/index.php'),
 (1365, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Client.php'),
 (1366, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/DriveItem.php'),
 (1367, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/File.php'),
 (1368, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Folder.php'),
 (1369, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehavior.php'),
 (1370, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehaviorParameterizer.php'),
 (1371, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/ResumableUploader.php'),
 (1372, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamBackEnd.php'),
 (1373, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamOpener.php'),
 (1374, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/index.php'),
 (1375, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/Krizalys/index.php'),
 (1376, 'wp-content/plugins/duplicator-pro/lib/onedrive/src/index.php'),
 (1377, 'wp-content/plugins/duplicator-pro/lib/pcrypt/cipher/blowfish.php'),
 (1378, 'wp-content/plugins/duplicator-pro/lib/pcrypt/cipher/index.php'),
 (1379, 'wp-content/plugins/duplicator-pro/lib/pcrypt/class.pcrypt.php'),
 (1380, 'wp-content/plugins/duplicator-pro/lib/pcrypt/example.php'),
 (1381, 'wp-content/plugins/duplicator-pro/lib/pcrypt/index.php'),
 (1382, 'wp-content/plugins/duplicator-pro/lib/phpseclib/autoload.php'),
 (1383, 'wp-content/plugins/duplicator-pro/lib/phpseclib/class.phpseclib.php'),
 (1384, 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/ClassLoader.php'),
 (1385, 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_classmap.php'),
 (1386, 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_namespaces.php'),
 (1387, 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_psr4.php'),
 (1388, 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_real.php'),
 (1389, 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/autoload_static.php'),
 (1390, 'wp-content/plugins/duplicator-pro/lib/phpseclib/composer/include_paths.php'),
 (1391, 'wp-content/plugins/duplicator-pro/lib/phpseclib/index.php'),
 (1392, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/AES.php'),
 (1393, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Base.php'),
 (1394, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Blowfish.php'),
 (1395, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/DES.php'),
 (1396, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Hash.php'),
 (1397, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC2.php'),
 (1398, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC4.php'),
 (1399, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RSA.php'),
 (1400, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Random.php'),
 (1401, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Rijndael.php'),
 (1402, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/TripleDES.php'),
 (1403, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Twofish.php'),
 (1404, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Crypt/index.php'),
 (1405, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ANSI.php'),
 (1406, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/Element.php'),
 (1407, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/index.php'),
 (1408, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1.php'),
 (1409, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/X509.php'),
 (1410, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/File/index.php'),
 (1411, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Math/BigInteger.php'),
 (1412, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Math/index.php'),
 (1413, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SCP.php'),
 (1414, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/Stream.php'),
 (1415, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/index.php'),
 (1416, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP.php'),
 (1417, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH1.php'),
 (1418, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH2.php'),
 (1419, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/Net/index.php'),
 (1420, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent/Identity.php'),
 (1421, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent.php'),
 (1422, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/index.php'),
 (1423, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/System/index.php'),
 (1424, 'wp-content/plugins/duplicator-pro/lib/phpseclib/phpseclib/index.php'),
 (1425, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.exceptions.php'),
 (1426, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.logger.php'),
 (1427, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.io.php'),
 (1428, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.net.php'),
 (1429, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.os.php'),
 (1430, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.stream.php'),
 (1431, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.string.php'),
 (1432, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.ui.php'),
 (1433, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.url.php'),
 (1434, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.util.php'),
 (1435, 'wp-content/plugins/duplicator-pro/lib/snaplib/class.snaplib.u.wp.php'),
 (1436, 'wp-content/plugins/duplicator-pro/lib/snaplib/index.php'),
 (1437, 'wp-content/plugins/duplicator-pro/lib/snaplib/snaplib.all.php'),
 (1438, 'wp-content/plugins/duplicator-pro/lib/snaplib/wordpress.core.files.php'),
 (1439, 'wp-content/plugins/duplicator-pro/tools/da-installer-extractor.php'),
 (1440, 'wp-content/plugins/duplicator-pro/tools/db-test.php'),
 (1441, 'wp-content/plugins/duplicator-pro/tools/file-renamer.php'),
 (1442, 'wp-content/plugins/duplicator-pro/tools/index.php'),
 (1443, 'wp-content/plugins/duplicator-pro/uninstall.php'),
 (1444, 'wp-content/plugins/duplicator-pro/views/inc.header.php'),
 (1445, 'wp-content/plugins/duplicator-pro/views/index.php'),
 (1446, 'wp-content/plugins/duplicator-pro/views/packages/controller.php'),
 (1447, 'wp-content/plugins/duplicator-pro/views/packages/details/controller.php'),
 (1448, 'wp-content/plugins/duplicator-pro/views/packages/details/detail.php'),
 (1449, 'wp-content/plugins/duplicator-pro/views/packages/details/index.php'),
 (1450, 'wp-content/plugins/duplicator-pro/views/packages/details/transfer.php'),
 (1451, 'wp-content/plugins/duplicator-pro/views/packages/index.php'),
 (1452, 'wp-content/plugins/duplicator-pro/views/packages/main/controller.php'),
 (1453, 'wp-content/plugins/duplicator-pro/views/packages/main/index.php'),
 (1454, 'wp-content/plugins/duplicator-pro/views/packages/main/packages.php'),
 (1455, 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup0.base.php'),
 (1456, 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup1.reqs.php'),
 (1457, 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup2.store.php'),
 (1458, 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup3.archive.php'),
 (1459, 'wp-content/plugins/duplicator-pro/views/packages/main/s1.setup4.install.php'),
 (1460, 'wp-content/plugins/duplicator-pro/views/packages/main/s2.scan1.base.php'),
 (1461, 'wp-content/plugins/duplicator-pro/views/packages/main/s2.scan2.server.php'),
 (1462, 'wp-content/plugins/duplicator-pro/views/packages/main/s2.scan3.archive.php'),
 (1463, 'wp-content/plugins/duplicator-pro/views/packages/screen.php'),
 (1464, 'wp-content/plugins/duplicator-pro/views/schedules/controller.php'),
 (1465, 'wp-content/plugins/duplicator-pro/views/schedules/index.php'),
 (1466, 'wp-content/plugins/duplicator-pro/views/schedules/schedule.controller.php'),
 (1467, 'wp-content/plugins/duplicator-pro/views/schedules/schedule.edit.php'),
 (1468, 'wp-content/plugins/duplicator-pro/views/schedules/schedule.list.php'),
 (1469, 'wp-content/plugins/duplicator-pro/views/settings/controller.php'),
 (1470, 'wp-content/plugins/duplicator-pro/views/settings/general/inc.feature.php'),
 (1471, 'wp-content/plugins/duplicator-pro/views/settings/general/inc.general.php'),
 (1472, 'wp-content/plugins/duplicator-pro/views/settings/general/inc.migrate.php'),
 (1473, 'wp-content/plugins/duplicator-pro/views/settings/general/index.php'),
 (1474, 'wp-content/plugins/duplicator-pro/views/settings/general/main.php'),
 (1475, 'wp-content/plugins/duplicator-pro/views/settings/index.php'),
 (1476, 'wp-content/plugins/duplicator-pro/views/settings/licensing.php'),
 (1477, 'wp-content/plugins/duplicator-pro/views/settings/package/inc.advanced.php'),
 (1478, 'wp-content/plugins/duplicator-pro/views/settings/package/inc.basic.php'),
 (1479, 'wp-content/plugins/duplicator-pro/views/settings/package/inc.brand.edit.php'),
 (1480, 'wp-content/plugins/duplicator-pro/views/settings/package/inc.brand.list.php'),
 (1481, 'wp-content/plugins/duplicator-pro/views/settings/package/index.php'),
 (1482, 'wp-content/plugins/duplicator-pro/views/settings/package/main.php'),
 (1483, 'wp-content/plugins/duplicator-pro/views/settings/schedule.php'),
 (1484, 'wp-content/plugins/duplicator-pro/views/settings/storage.php'),
 (1485, 'wp-content/plugins/duplicator-pro/views/storage/controller.php'),
 (1486, 'wp-content/plugins/duplicator-pro/views/storage/index.php'),
 (1487, 'wp-content/plugins/duplicator-pro/views/storage/storage.controller.php'),
 (1488, 'wp-content/plugins/duplicator-pro/views/storage/storage.edit.default.php'),
 (1489, 'wp-content/plugins/duplicator-pro/views/storage/storage.edit.php'),
 (1490, 'wp-content/plugins/duplicator-pro/views/storage/storage.list.php'),
 (1491, 'wp-content/plugins/duplicator-pro/views/tools/controller.php'),
 (1492, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/diagnostic.php'),
 (1493, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.data.php'),
 (1494, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.phpinfo.php'),
 (1495, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.settings.php'),
 (1496, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/inc.validator.php'),
 (1497, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/index.php'),
 (1498, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/log.php'),
 (1499, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/main.php'),
 (1500, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/phplogs.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(1501, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/support.php'),
 (1502, 'wp-content/plugins/duplicator-pro/views/tools/diagnostics/tests.php'),
 (1503, 'wp-content/plugins/duplicator-pro/views/tools/import.php'),
 (1504, 'wp-content/plugins/duplicator-pro/views/tools/index.php'),
 (1505, 'wp-content/plugins/duplicator-pro/views/tools/support.php'),
 (1506, 'wp-content/plugins/duplicator-pro/views/tools/templates/index.php'),
 (1507, 'wp-content/plugins/duplicator-pro/views/tools/templates/main.php'),
 (1508, 'wp-content/plugins/duplicator-pro/views/tools/templates/template.edit.php'),
 (1509, 'wp-content/plugins/duplicator-pro/views/tools/templates/template.list.php'),
 (1510, 'wp-content/plugins/hello.php'),
 (1511, 'wp-content/plugins/index.php'),
 (1512, 'wp-content/plugins/login-customizer/CHANGELOG.md'),
 (1513, 'wp-content/plugins/login-customizer/assets/logo.png'),
 (1514, 'wp-content/plugins/login-customizer/assets/orbit-fox.png'),
 (1515, 'wp-content/plugins/login-customizer/assets/templates/dark.png'),
 (1516, 'wp-content/plugins/login-customizer/assets/templates/material.png'),
 (1517, 'wp-content/plugins/login-customizer/assets/templates/original.png'),
 (1518, 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/alpha-control.php'),
 (1519, 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/assets/css/alpha-control.css'),
 (1520, 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/assets/img/transparency-grid.png'),
 (1521, 'wp-content/plugins/login-customizer/inc/customizer/controls/alpha/assets/js/alpha-control.js'),
 (1522, 'wp-content/plugins/login-customizer/inc/customizer/controls/cool-stuff/assets/css/cool-stuff-control.css'),
 (1523, 'wp-content/plugins/login-customizer/inc/customizer/controls/cool-stuff/cool-stuff-control.php'),
 (1524, 'wp-content/plugins/login-customizer/inc/customizer/controls/padding/assets/css/padding-control.css'),
 (1525, 'wp-content/plugins/login-customizer/inc/customizer/controls/padding/assets/js/padding-control.js'),
 (1526, 'wp-content/plugins/login-customizer/inc/customizer/controls/padding/padding-control.php'),
 (1527, 'wp-content/plugins/login-customizer/inc/customizer/controls/radio-images/assets/css/radio-images-control.css'),
 (1528, 'wp-content/plugins/login-customizer/inc/customizer/controls/radio-images/radio-images-control.php'),
 (1529, 'wp-content/plugins/login-customizer/inc/customizer/controls/range-slider/assets/css/range-slider-control.css'),
 (1530, 'wp-content/plugins/login-customizer/inc/customizer/controls/range-slider/assets/js/range-slider-control.js'),
 (1531, 'wp-content/plugins/login-customizer/inc/customizer/controls/range-slider/range-slider-control.php'),
 (1532, 'wp-content/plugins/login-customizer/inc/customizer/controls/toggle/assets/css/toggle-control.css'),
 (1533, 'wp-content/plugins/login-customizer/inc/customizer/controls/toggle/assets/js/toggle-control.js'),
 (1534, 'wp-content/plugins/login-customizer/inc/customizer/controls/toggle/toggle-control.php'),
 (1535, 'wp-content/plugins/login-customizer/inc/customizer/css/customizer.css'),
 (1536, 'wp-content/plugins/login-customizer/inc/customizer/custom-code.php'),
 (1537, 'wp-content/plugins/login-customizer/inc/customizer/customizer.php'),
 (1538, 'wp-content/plugins/login-customizer/inc/customizer/functions.php'),
 (1539, 'wp-content/plugins/login-customizer/inc/customizer/js/customizer-preview.js'),
 (1540, 'wp-content/plugins/login-customizer/inc/customizer/js/customizer.js'),
 (1541, 'wp-content/plugins/login-customizer/inc/customizer/sanitizers.php'),
 (1542, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-background.php'),
 (1543, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-button.php'),
 (1544, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-code.php'),
 (1545, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-fields.php'),
 (1546, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-form.php'),
 (1547, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-logo.php'),
 (1548, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-more.php'),
 (1549, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-other.php'),
 (1550, 'wp-content/plugins/login-customizer/inc/customizer/sections/section-templates.php'),
 (1551, 'wp-content/plugins/login-customizer/inc/include-page-template.php'),
 (1552, 'wp-content/plugins/login-customizer/inc/initial-setup.php'),
 (1553, 'wp-content/plugins/login-customizer/inc/mailin.php'),
 (1554, 'wp-content/plugins/login-customizer/inc/template-login-customizer.php'),
 (1555, 'wp-content/plugins/login-customizer/index.php'),
 (1556, 'wp-content/plugins/login-customizer/languages/login-customizer.pot'),
 (1557, 'wp-content/plugins/login-customizer/login-customizer.php'),
 (1558, 'wp-content/plugins/login-customizer/readme.md'),
 (1559, 'wp-content/plugins/login-customizer/readme.txt'),
 (1560, 'wp-content/plugins/login-customizer/screenshot-1.png'),
 (1561, 'wp-content/plugins/login-customizer/screenshot-2.png'),
 (1562, 'wp-content/plugins/login-customizer/setup.php'),
 (1563, 'wp-content/plugins/login-customizer/themeisle-hash.json'),
 (1564, 'wp-content/plugins/login-customizer/vendor/autoload.php'),
 (1565, 'wp-content/plugins/login-customizer/vendor/autoload_52.php'),
 (1566, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/LICENSE'),
 (1567, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-endpoints.php'),
 (1568, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-deactivate.php'),
 (1569, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-factory.php'),
 (1570, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-review.php'),
 (1571, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-translate.php'),
 (1572, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback.php'),
 (1573, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-licenser.php'),
 (1574, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-loader.php'),
 (1575, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-logger.php'),
 (1576, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-notification-manager.php'),
 (1577, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-product.php'),
 (1578, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-rollback.php'),
 (1579, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget-dashboard-blog.php'),
 (1580, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget.php'),
 (1581, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widgets-factory.php'),
 (1582, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/composer.json'),
 (1583, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/index.php'),
 (1584, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/load.php'),
 (1585, 'wp-content/plugins/login-customizer/vendor/codeinwp/themeisle-sdk/start.php'),
 (1586, 'wp-content/plugins/login-customizer/vendor/composer/ClassLoader.php'),
 (1587, 'wp-content/plugins/login-customizer/vendor/composer/ClassLoader52.php'),
 (1588, 'wp-content/plugins/login-customizer/vendor/composer/LICENSE'),
 (1589, 'wp-content/plugins/login-customizer/vendor/composer/autoload_classmap.php'),
 (1590, 'wp-content/plugins/login-customizer/vendor/composer/autoload_files.php'),
 (1591, 'wp-content/plugins/login-customizer/vendor/composer/autoload_namespaces.php'),
 (1592, 'wp-content/plugins/login-customizer/vendor/composer/autoload_psr4.php'),
 (1593, 'wp-content/plugins/login-customizer/vendor/composer/autoload_real.php'),
 (1594, 'wp-content/plugins/login-customizer/vendor/composer/autoload_real_52.php'),
 (1595, 'wp-content/plugins/login-customizer/vendor/composer/installed.json'),
 (1596, 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/LICENSE'),
 (1597, 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/README.md'),
 (1598, 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/composer.json'),
 (1599, 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/AutoloadGenerator.php'),
 (1600, 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/ClassLoader.php'),
 (1601, 'wp-content/plugins/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/Generator.php'),
 (1602, 'wp-content/plugins/revslider/admin/assets/css/index.php'),
 (1603, 'wp-content/plugins/revslider/admin/assets/icons/MaterialIcons-Regular.svg'),
 (1604, 'wp-content/plugins/revslider/admin/assets/images/sources/index.php'),
 (1605, 'wp-content/plugins/revslider/admin/assets/index.php'),
 (1606, 'wp-content/plugins/revslider/admin/assets/js/modules/admin.min.js'),
 (1607, 'wp-content/plugins/revslider/admin/assets/js/modules/editor.min.js'),
 (1608, 'wp-content/plugins/revslider/admin/assets/js/modules/help.js'),
 (1609, 'wp-content/plugins/revslider/admin/assets/js/modules/overview.min.js'),
 (1610, 'wp-content/plugins/revslider/admin/assets/js/modules/tooltip.js'),
 (1611, 'wp-content/plugins/revslider/admin/assets/js/plugins/codemirror.js'),
 (1612, 'wp-content/plugins/revslider/admin/assets/js/plugins/penner-easing.js'),
 (1613, 'wp-content/plugins/revslider/admin/assets/js/plugins/utils.min.js'),
 (1614, 'wp-content/plugins/revslider/admin/assets/js/plugins/wavesurfer.js'),
 (1615, 'wp-content/plugins/revslider/admin/assets/js/shortcode_generator/shortcode_generator.js'),
 (1616, 'wp-content/plugins/revslider/admin/assets/js/shortcode_generator/tinymce.js'),
 (1617, 'wp-content/plugins/revslider/admin/assets/js/shortcode_generator/vc.js'),
 (1618, 'wp-content/plugins/revslider/admin/includes/addons.class.php'),
 (1619, 'wp-content/plugins/revslider/admin/includes/debug.php'),
 (1620, 'wp-content/plugins/revslider/admin/includes/export-html.class.php'),
 (1621, 'wp-content/plugins/revslider/admin/includes/export.class.php'),
 (1622, 'wp-content/plugins/revslider/admin/includes/folder.class.php'),
 (1623, 'wp-content/plugins/revslider/admin/includes/functions-admin.class.php'),
 (1624, 'wp-content/plugins/revslider/admin/includes/help.class.php'),
 (1625, 'wp-content/plugins/revslider/admin/includes/import.class.php'),
 (1626, 'wp-content/plugins/revslider/admin/includes/license.class.php'),
 (1627, 'wp-content/plugins/revslider/admin/includes/loadbalancer.class.php'),
 (1628, 'wp-content/plugins/revslider/admin/includes/newsletter.class.php'),
 (1629, 'wp-content/plugins/revslider/admin/includes/plugin-update.class.php'),
 (1630, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/elementor/elementor-widget.class.php'),
 (1631, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/elementor/elementor.class.php'),
 (1632, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/dist/blocks.build.js'),
 (1633, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/gutenberg-block.php'),
 (1634, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/plugin.php'),
 (1635, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/assets/images/js-wapuu.svg'),
 (1636, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/blocks.js'),
 (1637, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/gutenberg-block.php'),
 (1638, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/deprecated.js'),
 (1639, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/index.js'),
 (1640, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revSliderImage.js'),
 (1641, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revslider.js'),
 (1642, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/shortcode_generator.class.php'),
 (1643, 'wp-content/plugins/revslider/admin/includes/shortcode_generator/wpbakery/wpbakery.class.php'),
 (1644, 'wp-content/plugins/revslider/admin/includes/template.class.php'),
 (1645, 'wp-content/plugins/revslider/admin/includes/tooltips.class.php'),
 (1646, 'wp-content/plugins/revslider/admin/includes/widget.class.php'),
 (1647, 'wp-content/plugins/revslider/admin/index.php'),
 (1648, 'wp-content/plugins/revslider/admin/revslider-admin.class.php'),
 (1649, 'wp-content/plugins/revslider/admin/views/builder-layer-forms.php'),
 (1650, 'wp-content/plugins/revslider/admin/views/builder-nav-forms.php'),
 (1651, 'wp-content/plugins/revslider/admin/views/builder-slide-forms.php'),
 (1652, 'wp-content/plugins/revslider/admin/views/builder-slider-forms.php'),
 (1653, 'wp-content/plugins/revslider/admin/views/builder-timeline.php'),
 (1654, 'wp-content/plugins/revslider/admin/views/builder.php'),
 (1655, 'wp-content/plugins/revslider/admin/views/features/add_ons.php'),
 (1656, 'wp-content/plugins/revslider/admin/views/features/index.php'),
 (1657, 'wp-content/plugins/revslider/admin/views/features/layer_animations.php'),
 (1658, 'wp-content/plugins/revslider/admin/views/features/object_library.php'),
 (1659, 'wp-content/plugins/revslider/admin/views/features/premade_template.php'),
 (1660, 'wp-content/plugins/revslider/admin/views/features/support.php'),
 (1661, 'wp-content/plugins/revslider/admin/views/footer.php'),
 (1662, 'wp-content/plugins/revslider/admin/views/header.php'),
 (1663, 'wp-content/plugins/revslider/admin/views/index.php'),
 (1664, 'wp-content/plugins/revslider/admin/views/modals-builder.php'),
 (1665, 'wp-content/plugins/revslider/admin/views/modals-copyright.php'),
 (1666, 'wp-content/plugins/revslider/admin/views/modals-general.php'),
 (1667, 'wp-content/plugins/revslider/admin/views/modals-overview.php'),
 (1668, 'wp-content/plugins/revslider/admin/views/overview.php'),
 (1669, 'wp-content/plugins/revslider/backup/index.php'),
 (1670, 'wp-content/plugins/revslider/includes/InstagramScraper/Endpoints.php'),
 (1671, 'wp-content/plugins/revslider/includes/InstagramScraper/Exception/InstagramAuthException.php'),
 (1672, 'wp-content/plugins/revslider/includes/InstagramScraper/Exception/InstagramException.php'),
 (1673, 'wp-content/plugins/revslider/includes/InstagramScraper/Exception/InstagramNotFoundException.php'),
 (1674, 'wp-content/plugins/revslider/includes/InstagramScraper/Instagram.php'),
 (1675, 'wp-content/plugins/revslider/includes/InstagramScraper/InstagramQueryId.php'),
 (1676, 'wp-content/plugins/revslider/includes/InstagramScraper/Instagram_old.php'),
 (1677, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/AbstractModel.php'),
 (1678, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Account.php'),
 (1679, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/CarouselMedia.php'),
 (1680, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Comment.php'),
 (1681, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Like.php'),
 (1682, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Location.php'),
 (1683, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Media.php'),
 (1684, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Story.php'),
 (1685, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/Tag.php'),
 (1686, 'wp-content/plugins/revslider/includes/InstagramScraper/Model/UserStories.php'),
 (1687, 'wp-content/plugins/revslider/includes/InstagramScraper/Traits/ArrayLikeTrait.php'),
 (1688, 'wp-content/plugins/revslider/includes/InstagramScraper/Traits/InitializerTrait.php'),
 (1689, 'wp-content/plugins/revslider/includes/InstagramScraper.php'),
 (1690, 'wp-content/plugins/revslider/includes/Unirest/Exception.php'),
 (1691, 'wp-content/plugins/revslider/includes/Unirest/Method.php'),
 (1692, 'wp-content/plugins/revslider/includes/Unirest/Request/Body.php'),
 (1693, 'wp-content/plugins/revslider/includes/Unirest/Request.php'),
 (1694, 'wp-content/plugins/revslider/includes/Unirest/Response.php'),
 (1695, 'wp-content/plugins/revslider/includes/Unirest.php'),
 (1696, 'wp-content/plugins/revslider/includes/aq-resizer.class.php'),
 (1697, 'wp-content/plugins/revslider/includes/backwards.php'),
 (1698, 'wp-content/plugins/revslider/includes/basic-css.php'),
 (1699, 'wp-content/plugins/revslider/includes/coloreasing.class.php'),
 (1700, 'wp-content/plugins/revslider/includes/colorpicker.class.php'),
 (1701, 'wp-content/plugins/revslider/includes/cssparser.class.php'),
 (1702, 'wp-content/plugins/revslider/includes/data.class.php'),
 (1703, 'wp-content/plugins/revslider/includes/em-integration.class.php'),
 (1704, 'wp-content/plugins/revslider/includes/extension.class.php'),
 (1705, 'wp-content/plugins/revslider/includes/external-sources.class.php'),
 (1706, 'wp-content/plugins/revslider/includes/favorite.class.php'),
 (1707, 'wp-content/plugins/revslider/includes/functions.class.php'),
 (1708, 'wp-content/plugins/revslider/includes/googlefonts.php'),
 (1709, 'wp-content/plugins/revslider/includes/navigation.class.php'),
 (1710, 'wp-content/plugins/revslider/includes/navigations.php'),
 (1711, 'wp-content/plugins/revslider/includes/object-library.class.php'),
 (1712, 'wp-content/plugins/revslider/includes/output.class.php'),
 (1713, 'wp-content/plugins/revslider/includes/page-template.class.php'),
 (1714, 'wp-content/plugins/revslider/includes/slide.class.php'),
 (1715, 'wp-content/plugins/revslider/includes/slider.class.php'),
 (1716, 'wp-content/plugins/revslider/includes/update.class.php'),
 (1717, 'wp-content/plugins/revslider/includes/woocommerce.class.php'),
 (1718, 'wp-content/plugins/revslider/includes/wpml.class.php'),
 (1719, 'wp-content/plugins/revslider/index.php'),
 (1720, 'wp-content/plugins/revslider/languages/index.php'),
 (1721, 'wp-content/plugins/revslider/public/assets/assets/index.php'),
 (1722, 'wp-content/plugins/revslider/public/assets/assets/sources/index.php'),
 (1723, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_3d_rotation_24px.svg'),
 (1724, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_accessibility_24px.svg'),
 (1725, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_accessible_24px.svg'),
 (1726, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_balance_24px.svg'),
 (1727, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_balance_wallet_24px.svg'),
 (1728, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_box_24px.svg'),
 (1729, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_account_circle_24px.svg'),
 (1730, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_add_shopping_cart_24px.svg'),
 (1731, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_24px.svg'),
 (1732, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_add_24px.svg'),
 (1733, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_off_24px.svg'),
 (1734, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_alarm_on_24px.svg'),
 (1735, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_all_out_24px.svg'),
 (1736, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_android_24px.svg'),
 (1737, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_announcement_24px.svg'),
 (1738, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_aspect_ratio_24px.svg'),
 (1739, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assessment_24px.svg'),
 (1740, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_24px.svg'),
 (1741, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_ind_24px.svg'),
 (1742, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_late_24px.svg'),
 (1743, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_return_24px.svg'),
 (1744, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_returned_24px.svg'),
 (1745, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_assignment_turned_in_24px.svg'),
 (1746, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_autorenew_24px.svg'),
 (1747, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_backup_24px.svg'),
 (1748, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_book_24px.svg'),
 (1749, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_bookmark_24px.svg'),
 (1750, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_bookmark_border_24px.svg'),
 (1751, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_bug_report_24px.svg'),
 (1752, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_build_24px.svg'),
 (1753, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_cached_24px.svg'),
 (1754, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_camera_enhance_24px.svg'),
 (1755, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_card_giftcard_24px.svg'),
 (1756, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_card_membership_24px.svg'),
 (1757, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_card_travel_24px.svg'),
 (1758, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_change_history_24px.svg'),
 (1759, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_check_circle_24px.svg'),
 (1760, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_chrome_reader_mode_24px.svg'),
 (1761, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_class_24px.svg'),
 (1762, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_code_24px.svg'),
 (1763, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_compare_arrows_24px.svg'),
 (1764, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_copyright_24px.svg'),
 (1765, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_credit_card_24px.svg'),
 (1766, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_dashboard_24px.svg'),
 (1767, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_date_range_24px.svg'),
 (1768, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_delete_24px.svg'),
 (1769, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_description_24px.svg'),
 (1770, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_dns_24px.svg'),
 (1771, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_done_24px.svg'),
 (1772, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_done_all_24px.svg'),
 (1773, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_donut_large_24px.svg'),
 (1774, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_donut_small_24px.svg'),
 (1775, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_eject_24px.svg'),
 (1776, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_event_24px.svg'),
 (1777, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_event_seat_24px.svg'),
 (1778, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_exit_to_app_24px.svg'),
 (1779, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_explore_24px.svg'),
 (1780, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_extension_24px.svg'),
 (1781, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_face_24px.svg'),
 (1782, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_favorite_24px.svg'),
 (1783, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_favorite_border_24px.svg'),
 (1784, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_feedback_24px.svg'),
 (1785, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_find_in_page_24px.svg'),
 (1786, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_find_replace_24px.svg'),
 (1787, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_fingerprint_24px.svg'),
 (1788, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flight_land_24px.svg'),
 (1789, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flight_takeoff_24px.svg'),
 (1790, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flip_to_back_24px.svg'),
 (1791, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_flip_to_front_24px.svg'),
 (1792, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_gavel_24px.svg'),
 (1793, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_get_app_24px.svg'),
 (1794, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_gif_24px.svg'),
 (1795, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_grade_24px.svg'),
 (1796, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_group_work_24px.svg'),
 (1797, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_help_24px.svg'),
 (1798, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_help_outline_24px.svg'),
 (1799, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_highlight_off_24px.svg'),
 (1800, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_history_24px.svg'),
 (1801, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_home_24px.svg'),
 (1802, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_hourglass_empty_24px.svg'),
 (1803, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_hourglass_full_24px.svg'),
 (1804, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_http_24px.svg'),
 (1805, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_https_24px.svg'),
 (1806, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_important_devices_24px.svg'),
 (1807, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_info_24px.svg'),
 (1808, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_info_outline_24px.svg'),
 (1809, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_input_24px.svg'),
 (1810, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_invert_colors_24px.svg'),
 (1811, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_label_24px.svg'),
 (1812, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_label_outline_24px.svg'),
 (1813, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_language_24px.svg'),
 (1814, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_launch_24px.svg'),
 (1815, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lightbulb_outline_24px.svg'),
 (1816, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_line_style_24px.svg'),
 (1817, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_line_weight_24px.svg'),
 (1818, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_list_24px.svg'),
 (1819, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lock_24px.svg'),
 (1820, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lock_open_24px.svg'),
 (1821, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_lock_outline_24px.svg'),
 (1822, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_loyalty_24px.svg'),
 (1823, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_markunread_mailbox_24px.svg'),
 (1824, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_motorcycle_24px.svg'),
 (1825, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_note_add_24px.svg'),
 (1826, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_offline_pin_24px.svg'),
 (1827, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_opacity_24px.svg'),
 (1828, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_open_in_browser_24px.svg'),
 (1829, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_open_in_new_24px.svg'),
 (1830, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_open_with_24px.svg'),
 (1831, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pageview_24px.svg'),
 (1832, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pan_tool_24px.svg'),
 (1833, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_payment_24px.svg'),
 (1834, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_camera_mic_24px.svg'),
 (1835, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_contact_calendar_24px.svg'),
 (1836, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_data_setting_24px.svg'),
 (1837, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_device_information_24px.svg'),
 (1838, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_identity_24px.svg'),
 (1839, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_media_24px.svg'),
 (1840, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_phone_msg_24px.svg'),
 (1841, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_perm_scan_wifi_24px.svg'),
 (1842, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pets_24px.svg'),
 (1843, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_picture_in_picture_24px.svg'),
 (1844, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_picture_in_picture_alt_24px.svg'),
 (1845, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_play_for_work_24px.svg'),
 (1846, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_polymer_24px.svg'),
 (1847, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_power_settings_new_24px.svg'),
 (1848, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_pregnant_woman_24px.svg'),
 (1849, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_print_24px.svg'),
 (1850, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_query_builder_24px.svg'),
 (1851, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_question_answer_24px.svg'),
 (1852, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_receipt_24px.svg'),
 (1853, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_record_voice_over_24px.svg'),
 (1854, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_redeem_24px.svg'),
 (1855, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_reorder_24px.svg'),
 (1856, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_report_problem_24px.svg'),
 (1857, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_restore_24px.svg'),
 (1858, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_room_24px.svg'),
 (1859, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_rounded_corner_24px.svg'),
 (1860, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_rowing_24px.svg'),
 (1861, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_schedule_24px.svg'),
 (1862, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_search_24px.svg'),
 (1863, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_24px.svg'),
 (1864, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_applications_24px.svg'),
 (1865, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_backup_restore_24px.svg'),
 (1866, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_bluetooth_24px.svg'),
 (1867, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_brightness_24px.svg'),
 (1868, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_cell_24px.svg'),
 (1869, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_ethernet_24px.svg'),
 (1870, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_antenna_24px.svg'),
 (1871, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_component_24px.svg'),
 (1872, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_composite_24px.svg'),
 (1873, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_hdmi_24px.svg'),
 (1874, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_input_svideo_24px.svg'),
 (1875, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_overscan_24px.svg'),
 (1876, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_phone_24px.svg'),
 (1877, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_power_24px.svg'),
 (1878, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_remote_24px.svg'),
 (1879, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_settings_voice_24px.svg'),
 (1880, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shop_24px.svg'),
 (1881, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shop_two_24px.svg'),
 (1882, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shopping_basket_24px.svg'),
 (1883, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_shopping_cart_24px.svg'),
 (1884, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_speaker_notes_24px.svg'),
 (1885, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_spellcheck_24px.svg'),
 (1886, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_stars_24px.svg'),
 (1887, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_store_24px.svg'),
 (1888, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_subject_24px.svg'),
 (1889, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_supervisor_account_24px.svg'),
 (1890, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_swap_horiz_24px.svg'),
 (1891, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_swap_vert_24px.svg'),
 (1892, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_swap_vertical_circle_24px.svg'),
 (1893, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_system_update_alt_24px.svg'),
 (1894, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_tab_24px.svg'),
 (1895, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_tab_unselected_24px.svg'),
 (1896, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_theaters_24px.svg'),
 (1897, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_thumb_down_24px.svg'),
 (1898, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_thumb_up_24px.svg'),
 (1899, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_thumbs_up_down_24px.svg'),
 (1900, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_timeline_24px.svg'),
 (1901, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_toc_24px.svg'),
 (1902, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_today_24px.svg'),
 (1903, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_toll_24px.svg'),
 (1904, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_touch_app_24px.svg'),
 (1905, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_track_changes_24px.svg'),
 (1906, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_translate_24px.svg'),
 (1907, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_trending_down_24px.svg'),
 (1908, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_trending_flat_24px.svg'),
 (1909, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_trending_up_24px.svg'),
 (1910, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_turned_in_24px.svg'),
 (1911, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_turned_in_not_24px.svg'),
 (1912, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_update_24px.svg'),
 (1913, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_verified_user_24px.svg'),
 (1914, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_agenda_24px.svg'),
 (1915, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_array_24px.svg'),
 (1916, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_carousel_24px.svg'),
 (1917, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_column_24px.svg'),
 (1918, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_day_24px.svg'),
 (1919, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_headline_24px.svg'),
 (1920, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_list_24px.svg'),
 (1921, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_module_24px.svg'),
 (1922, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_quilt_24px.svg'),
 (1923, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_stream_24px.svg'),
 (1924, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_view_week_24px.svg'),
 (1925, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_visibility_24px.svg'),
 (1926, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_visibility_off_24px.svg'),
 (1927, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_watch_later_24px.svg'),
 (1928, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_work_24px.svg'),
 (1929, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_youtube_searched_for_24px.svg'),
 (1930, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_zoom_in_24px.svg'),
 (1931, 'wp-content/plugins/revslider/public/assets/assets/svg/action/ic_zoom_out_24px.svg'),
 (1932, 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_add_alert_24px.svg'),
 (1933, 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_error_24px.svg'),
 (1934, 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_error_outline_24px.svg'),
 (1935, 'wp-content/plugins/revslider/public/assets/assets/svg/alert/ic_warning_24px.svg'),
 (1936, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_add_to_queue_24px.svg'),
 (1937, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_airplay_24px.svg'),
 (1938, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_album_24px.svg'),
 (1939, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_art_track_24px.svg'),
 (1940, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_av_timer_24px.svg'),
 (1941, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_closed_caption_24px.svg'),
 (1942, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_equalizer_24px.svg'),
 (1943, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_explicit_24px.svg'),
 (1944, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fast_forward_24px.svg'),
 (1945, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fast_rewind_24px.svg'),
 (1946, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_dvr_24px.svg'),
 (1947, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_manual_record_24px.svg'),
 (1948, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_new_24px.svg'),
 (1949, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_pin_24px.svg'),
 (1950, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_fiber_smart_record_24px.svg'),
 (1951, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_forward_10_24px.svg'),
 (1952, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_forward_30_24px.svg'),
 (1953, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_forward_5_24px.svg'),
 (1954, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_games_24px.svg'),
 (1955, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_hd_24px.svg'),
 (1956, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_hearing_24px.svg'),
 (1957, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_high_quality_24px.svg'),
 (1958, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_library_add_24px.svg'),
 (1959, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_library_books_24px.svg'),
 (1960, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_library_music_24px.svg'),
 (1961, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_loop_24px.svg'),
 (1962, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_mic_24px.svg'),
 (1963, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_mic_none_24px.svg'),
 (1964, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_mic_off_24px.svg'),
 (1965, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_movie_24px.svg'),
 (1966, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_music_video_24px.svg'),
 (1967, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_new_releases_24px.svg'),
 (1968, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_not_interested_24px.svg'),
 (1969, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_pause_24px.svg'),
 (1970, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_pause_circle_filled_24px.svg'),
 (1971, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_pause_circle_outline_24px.svg'),
 (1972, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_play_arrow_24px.svg'),
 (1973, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_play_circle_filled_24px.svg'),
 (1974, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_play_circle_outline_24px.svg'),
 (1975, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_playlist_add_24px.svg'),
 (1976, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_playlist_add_check_24px.svg'),
 (1977, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_playlist_play_24px.svg'),
 (1978, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_queue_24px.svg'),
 (1979, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_queue_music_24px.svg'),
 (1980, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_queue_play_next_24px.svg'),
 (1981, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_radio_24px.svg'),
 (1982, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_recent_actors_24px.svg'),
 (1983, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_remove_from_queue_24px.svg'),
 (1984, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_repeat_24px.svg'),
 (1985, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_repeat_one_24px.svg'),
 (1986, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_10_24px.svg'),
 (1987, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_24px.svg'),
 (1988, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_30_24px.svg'),
 (1989, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_replay_5_24px.svg'),
 (1990, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_shuffle_24px.svg'),
 (1991, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_skip_next_24px.svg'),
 (1992, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_skip_previous_24px.svg'),
 (1993, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_slow_motion_video_24px.svg'),
 (1994, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_snooze_24px.svg'),
 (1995, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_sort_by_alpha_24px.svg'),
 (1996, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_stop_24px.svg'),
 (1997, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_subscriptions_24px.svg'),
 (1998, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_subtitles_24px.svg'),
 (1999, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_surround_sound_24px.svg'),
 (2000, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_video_library_24px.svg');
INSERT INTO `wp8b_wfknownfilelist` VALUES(2001, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_videocam_24px.svg'),
 (2002, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_videocam_off_24px.svg'),
 (2003, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_down_24px.svg'),
 (2004, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_mute_24px.svg'),
 (2005, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_off_24px.svg'),
 (2006, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_volume_up_24px.svg'),
 (2007, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_web_24px.svg'),
 (2008, 'wp-content/plugins/revslider/public/assets/assets/svg/av/ic_web_asset_24px.svg'),
 (2009, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/NewTux.svg'),
 (2010, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/abacus.svg'),
 (2011, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/address-book.svg'),
 (2012, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/address-book2.svg'),
 (2013, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/aim.svg'),
 (2014, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/alarm.svg'),
 (2015, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/apple.svg'),
 (2016, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/arrow-left.svg'),
 (2017, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/arrow-right.svg'),
 (2018, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/arrows-updown.svg'),
 (2019, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/atm-cash.svg'),
 (2020, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award1.svg'),
 (2021, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award2.svg'),
 (2022, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award3.svg'),
 (2023, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award4.svg'),
 (2024, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/award5.svg'),
 (2025, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/badge01.svg'),
 (2026, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/badge02.svg'),
 (2027, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bank.svg'),
 (2028, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bank2.svg'),
 (2029, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bell.svg'),
 (2030, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/binoculars.svg'),
 (2031, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bomb.svg'),
 (2032, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bonsai.svg'),
 (2033, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/book-apple.svg'),
 (2034, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/book.svg'),
 (2035, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/bookmark.svg'),
 (2036, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/box.svg'),
 (2037, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/brain.svg'),
 (2038, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/briefcase.svg'),
 (2039, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/browser01.svg'),
 (2040, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/browser02.svg'),
 (2041, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/buildings.svg'),
 (2042, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/buy-sign.svg'),
 (2043, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calculator1.svg'),
 (2044, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calculator2.svg'),
 (2045, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calculator3.svg'),
 (2046, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar1.svg'),
 (2047, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar2.svg'),
 (2048, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar3.svg'),
 (2049, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar4.svg'),
 (2050, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/calendar5.svg'),
 (2051, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/certificate.svg'),
 (2052, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/champagne.svg'),
 (2053, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character01.svg'),
 (2054, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character02.svg'),
 (2055, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character03.svg'),
 (2056, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character04.svg'),
 (2057, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character05.svg'),
 (2058, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character06.svg'),
 (2059, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character07.svg'),
 (2060, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/character08.svg'),
 (2061, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart-analysis.svg'),
 (2062, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart-board.svg'),
 (2063, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart-pyramid.svg'),
 (2064, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart01.svg'),
 (2065, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart02.svg'),
 (2066, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart03.svg'),
 (2067, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart04.svg'),
 (2068, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart05.svg'),
 (2069, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart06.svg'),
 (2070, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart07.svg'),
 (2071, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart08.svg'),
 (2072, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart09.svg'),
 (2073, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart10.svg'),
 (2074, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart11.svg'),
 (2075, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart12.svg'),
 (2076, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart13.svg'),
 (2077, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart14.svg'),
 (2078, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart15.svg'),
 (2079, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart16.svg'),
 (2080, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart17.svg'),
 (2081, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart18.svg'),
 (2082, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart19.svg'),
 (2083, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart20.svg'),
 (2084, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chart21.svg'),
 (2085, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chat.svg'),
 (2086, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/checklist.svg'),
 (2087, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/checklist2.svg'),
 (2088, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/checklist3.svg'),
 (2089, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chemistry.svg'),
 (2090, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chess-knight.svg'),
 (2091, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chess-rook.svg'),
 (2092, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/chess.svg'),
 (2093, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/clock.svg'),
 (2094, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/closed-sign.svg'),
 (2095, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/cloud-coins.svg'),
 (2096, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/cloud-down.svg'),
 (2097, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/cloud-up.svg'),
 (2098, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/coffee.svg'),
 (2099, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/conference.svg'),
 (2100, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/contact-book.svg'),
 (2101, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/coupon.svg'),
 (2102, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/credit-card.svg'),
 (2103, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/crown.svg'),
 (2104, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/currencies.svg'),
 (2105, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/database.svg'),
 (2106, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/delivery.svg'),
 (2107, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/diagram-hierarchy.svg'),
 (2108, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/diamond.svg'),
 (2109, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/dollar.svg'),
 (2110, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/drawer.svg'),
 (2111, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/egg.svg'),
 (2112, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/emblem.svg'),
 (2113, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/envelope-money.svg'),
 (2114, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/envelopes.svg'),
 (2115, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/euro.svg'),
 (2116, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/exchange.svg'),
 (2117, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/exit.svg'),
 (2118, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/factory.svg'),
 (2119, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/fax.svg'),
 (2120, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file01.svg'),
 (2121, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file02.svg'),
 (2122, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file03.svg'),
 (2123, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file04.svg'),
 (2124, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file05.svg'),
 (2125, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file06.svg'),
 (2126, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file07.svg'),
 (2127, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file08.svg'),
 (2128, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file09.svg'),
 (2129, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/file10.svg'),
 (2130, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/files.svg'),
 (2131, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/fire.svg'),
 (2132, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/fish.svg'),
 (2133, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/flag.svg'),
 (2134, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-add.svg'),
 (2135, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-delete.svg'),
 (2136, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-online.svg'),
 (2137, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-private.svg'),
 (2138, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder-remove.svg'),
 (2139, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folder.svg'),
 (2140, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/folders.svg'),
 (2141, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/funnel-money.svg'),
 (2142, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/funnel.svg'),
 (2143, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gauge.svg'),
 (2144, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gauge2.svg'),
 (2145, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gears1.svg'),
 (2146, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/gears2.svg'),
 (2147, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/glasses-moustache.svg'),
 (2148, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/globe-money.svg'),
 (2149, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/globe.svg'),
 (2150, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/globe2.svg'),
 (2151, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/graduation-hat.svg'),
 (2152, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-globe.svg'),
 (2153, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-key.svg'),
 (2154, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-money.svg'),
 (2155, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hand-money2.svg'),
 (2156, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/handshake.svg'),
 (2157, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hat-moustache.svg'),
 (2158, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hat.svg'),
 (2159, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-arrows.svg'),
 (2160, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-battery.svg'),
 (2161, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-check.svg'),
 (2162, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-compass.svg'),
 (2163, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-dollar.svg'),
 (2164, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-exclamation.svg'),
 (2165, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-flash.svg'),
 (2166, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-gauge.svg'),
 (2167, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-gears.svg'),
 (2168, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-hourglass.svg'),
 (2169, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-idea.svg'),
 (2170, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-question.svg'),
 (2171, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head-structure.svg'),
 (2172, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/head.svg'),
 (2173, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/headquarters.svg'),
 (2174, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hourglass.svg'),
 (2175, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/hours.svg'),
 (2176, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/incoming.svg'),
 (2177, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/ingots.svg'),
 (2178, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/key.svg'),
 (2179, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/key2.svg'),
 (2180, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/keyboard.svg'),
 (2181, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/label.svg'),
 (2182, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lamp.svg'),
 (2183, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-article.svg'),
 (2184, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-cart.svg'),
 (2185, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart.svg'),
 (2186, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart2.svg'),
 (2187, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-diagram.svg'),
 (2188, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-envelope.svg'),
 (2189, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-finance.svg'),
 (2190, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-privacy.svg'),
 (2191, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-settings.svg'),
 (2192, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop-user.svg'),
 (2193, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/laptop.svg'),
 (2194, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb-green.svg'),
 (2195, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb.svg'),
 (2196, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lightning.svg'),
 (2197, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/like.svg'),
 (2198, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/lock.svg'),
 (2199, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/magnet-money.svg'),
 (2200, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/magnifying-glass.svg'),
 (2201, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager-globe.svg'),
 (2202, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager-idea.svg'),
 (2203, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager01.svg'),
 (2204, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/manager02.svg'),
 (2205, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/meditation.svg'),
 (2206, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/megaphone.svg'),
 (2207, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money-growth.svg'),
 (2208, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money-scales.svg'),
 (2209, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money.svg'),
 (2210, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money2.svg'),
 (2211, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money3.svg'),
 (2212, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money4.svg'),
 (2213, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money5.svg'),
 (2214, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/money6.svg'),
 (2215, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/monitor.svg'),
 (2216, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/mouse.svg'),
 (2217, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/nest-money.svg'),
 (2218, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-jobs.svg'),
 (2219, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-pen.svg'),
 (2220, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/newspaper.svg'),
 (2221, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/note-paper.svg'),
 (2222, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/office-chair.svg'),
 (2223, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/open-sign.svg'),
 (2224, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/outgoing.svg'),
 (2225, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/paper-clip.svg'),
 (2226, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/paper-plane.svg'),
 (2227, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pen.svg'),
 (2228, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pen2.svg'),
 (2229, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pencil.svg'),
 (2230, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pens-pencils.svg'),
 (2231, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-arrows06.svg'),
 (2232, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-gears.svg'),
 (2233, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-handshake.svg'),
 (2234, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-idea.svg'),
 (2235, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting.svg'),
 (2236, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting02.svg'),
 (2237, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-search01.svg'),
 (2238, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-search02.svg'),
 (2239, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure.svg'),
 (2240, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure01.svg'),
 (2241, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure02.svg'),
 (2242, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure03.svg'),
 (2243, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure04.svg'),
 (2244, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure05.svg'),
 (2245, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure06.svg'),
 (2246, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/people-structure07.svg'),
 (2247, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/percent.svg'),
 (2248, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/periscopemoney.svg'),
 (2249, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows01.svg'),
 (2250, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows012.svg'),
 (2251, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows02.svg'),
 (2252, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows022.svg'),
 (2253, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows03.svg'),
 (2254, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-checkmark.svg'),
 (2255, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-cross.svg'),
 (2256, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-data.svg'),
 (2257, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-dollar.svg'),
 (2258, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-finance.svg'),
 (2259, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-flag.svg'),
 (2260, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-globe.svg'),
 (2261, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-idea02.svg'),
 (2262, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-info.svg'),
 (2263, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-puzzle.svg'),
 (2264, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-scales.svg'),
 (2265, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-time.svg'),
 (2266, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/person-umbrella.svg'),
 (2267, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/phone.svg'),
 (2268, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart01.svg'),
 (2269, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart02.svg'),
 (2270, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/piggy-bank.svg'),
 (2271, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pin.svg'),
 (2272, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/plant-money.svg'),
 (2273, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/plant.svg'),
 (2274, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pound.svg'),
 (2275, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/presentation.svg'),
 (2276, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/presentation02.svg'),
 (2277, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart02.svg'),
 (2278, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart03.svg'),
 (2279, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart04.svg'),
 (2280, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-laurels.svg'),
 (2281, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-megaphone.svg'),
 (2282, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/preson-stairs.svg'),
 (2283, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/printer.svg'),
 (2284, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/profile.svg'),
 (2285, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/pulse.svg'),
 (2286, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/puzzle.svg'),
 (2287, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/quill.svg'),
 (2288, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/recycle.svg'),
 (2289, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/rocket.svg'),
 (2290, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/rocket2.svg'),
 (2291, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/ruble.svg'),
 (2292, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/ruler-compasses.svg'),
 (2293, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/safe.svg'),
 (2294, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/sale-sign.svg'),
 (2295, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/satellite-dish.svg'),
 (2296, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/scales.svg'),
 (2297, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/scissors.svg'),
 (2298, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/security.svg'),
 (2299, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/send.svg'),
 (2300, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/shield.svg'),
 (2301, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/shopping-cart.svg'),
 (2302, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/sign.svg'),
 (2303, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-chart.svg'),
 (2304, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-exclamation.svg'),
 (2305, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-gears.svg'),
 (2306, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-growth.svg'),
 (2307, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-money.svg'),
 (2308, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-user.svg'),
 (2309, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/smartphone.svg'),
 (2310, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/speaker.svg'),
 (2311, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/speaker02.svg'),
 (2312, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/speech-bubble.svg'),
 (2313, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/stamp.svg'),
 (2314, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/star.svg'),
 (2315, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/steering-wheel.svg'),
 (2316, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/strategy03.svg'),
 (2317, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/strategy1.svg'),
 (2318, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/strategy2.svg'),
 (2319, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/support-person.svg'),
 (2320, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-article.svg'),
 (2321, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart.svg'),
 (2322, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart2.svg'),
 (2323, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart3.svg'),
 (2324, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart.svg'),
 (2325, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart2.svg'),
 (2326, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tablet.svg'),
 (2327, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/target.svg'),
 (2328, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/team.svg'),
 (2329, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/telescope.svg'),
 (2330, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tie.svg'),
 (2331, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tools.svg'),
 (2332, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/tools2.svg'),
 (2333, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/trash-bin.svg'),
 (2334, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/umbrella.svg'),
 (2335, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user01.svg'),
 (2336, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user02.svg'),
 (2337, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user03.svg'),
 (2338, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user04.svg'),
 (2339, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user05.svg'),
 (2340, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user06.svg'),
 (2341, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user07.svg'),
 (2342, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user08.svg'),
 (2343, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/user09.svg'),
 (2344, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/users.svg'),
 (2345, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/venn-diagram.svg'),
 (2346, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/wallet.svg'),
 (2347, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/wrench.svg'),
 (2348, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/yen.svg'),
 (2349, 'wp-content/plugins/revslider/public/assets/assets/svg/busy-icons-svg/yinyang.svg'),
 (2350, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_business_24px.svg'),
 (2351, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_24px.svg'),
 (2352, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_end_24px.svg'),
 (2353, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_made_24px.svg'),
 (2354, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_merge_24px.svg'),
 (2355, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_missed_24px.svg'),
 (2356, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_missed_outgoing_24px.svg'),
 (2357, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_received_24px.svg'),
 (2358, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_call_split_24px.svg'),
 (2359, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_chat_24px.svg'),
 (2360, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_chat_bubble_24px.svg'),
 (2361, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_chat_bubble_outline_24px.svg'),
 (2362, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_clear_all_24px.svg'),
 (2363, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_comment_24px.svg'),
 (2364, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_contact_mail_24px.svg'),
 (2365, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_contact_phone_24px.svg'),
 (2366, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_contacts_24px.svg'),
 (2367, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_dialer_sip_24px.svg'),
 (2368, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_dialpad_24px.svg'),
 (2369, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_email_24px.svg'),
 (2370, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_forum_24px.svg'),
 (2371, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_import_contacts_24px.svg'),
 (2372, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_import_export_24px.svg'),
 (2373, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_invert_colors_off_24px.svg'),
 (2374, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_live_help_24px.svg'),
 (2375, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_location_off_24px.svg'),
 (2376, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_location_on_24px.svg'),
 (2377, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_mail_outline_24px.svg'),
 (2378, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_message_24px.svg'),
 (2379, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_no_sim_24px.svg'),
 (2380, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phone_24px.svg'),
 (2381, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_erase_24px.svg'),
 (2382, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_lock_24px.svg'),
 (2383, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_ring_24px.svg'),
 (2384, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_phonelink_setup_24px.svg'),
 (2385, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_portable_wifi_off_24px.svg'),
 (2386, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_present_to_all_24px.svg'),
 (2387, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_ring_volume_24px.svg'),
 (2388, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_screen_share_24px.svg'),
 (2389, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_speaker_phone_24px.svg'),
 (2390, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_current_landscape_24px.svg'),
 (2391, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_current_portrait_24px.svg'),
 (2392, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_primary_landscape_24px.svg'),
 (2393, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stay_primary_portrait_24px.svg'),
 (2394, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_stop_screen_share_24px.svg'),
 (2395, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_swap_calls_24px.svg'),
 (2396, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_textsms_24px.svg'),
 (2397, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_voicemail_24px.svg'),
 (2398, 'wp-content/plugins/revslider/public/assets/assets/svg/communication/ic_vpn_key_24px.svg'),
 (2399, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_24px.svg'),
 (2400, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_box_24px.svg'),
 (2401, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_circle_24px.svg'),
 (2402, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_add_circle_outline_24px.svg'),
 (2403, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_archive_24px.svg'),
 (2404, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_backspace_24px.svg'),
 (2405, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_block_24px.svg'),
 (2406, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_clear_24px.svg'),
 (2407, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_content_copy_24px.svg'),
 (2408, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_content_cut_24px.svg'),
 (2409, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_content_paste_24px.svg'),
 (2410, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_create_24px.svg'),
 (2411, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_drafts_24px.svg'),
 (2412, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_filter_list_24px.svg'),
 (2413, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_flag_24px.svg'),
 (2414, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_font_download_24px.svg'),
 (2415, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_forward_24px.svg'),
 (2416, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_gesture_24px.svg'),
 (2417, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_inbox_24px.svg'),
 (2418, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_link_24px.svg'),
 (2419, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_mail_24px.svg'),
 (2420, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_markunread_24px.svg'),
 (2421, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_move_to_inbox_24px.svg'),
 (2422, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_next_week_24px.svg'),
 (2423, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_redo_24px.svg'),
 (2424, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_remove_24px.svg'),
 (2425, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_remove_circle_24px.svg'),
 (2426, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_remove_circle_outline_24px.svg'),
 (2427, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_reply_24px.svg'),
 (2428, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_reply_all_24px.svg'),
 (2429, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_report_24px.svg'),
 (2430, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_save_24px.svg'),
 (2431, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_select_all_24px.svg'),
 (2432, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_send_24px.svg'),
 (2433, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_sort_24px.svg'),
 (2434, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_text_format_24px.svg'),
 (2435, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_unarchive_24px.svg'),
 (2436, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_undo_24px.svg'),
 (2437, 'wp-content/plugins/revslider/public/assets/assets/svg/content/ic_weekend_24px.svg'),
 (2438, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_access_alarm_24px.svg'),
 (2439, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_access_alarms_24px.svg'),
 (2440, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_access_time_24px.svg'),
 (2441, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_add_alarm_24px.svg'),
 (2442, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_airplanemode_active_24px.svg'),
 (2443, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_airplanemode_inactive_24px.svg'),
 (2444, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_20_24px.svg'),
 (2445, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_30_24px.svg'),
 (2446, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_50_24px.svg'),
 (2447, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_60_24px.svg'),
 (2448, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_80_24px.svg'),
 (2449, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_90_24px.svg'),
 (2450, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_alert_24px.svg'),
 (2451, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_20_24px.svg'),
 (2452, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_30_24px.svg'),
 (2453, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_50_24px.svg'),
 (2454, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_60_24px.svg'),
 (2455, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_80_24px.svg'),
 (2456, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_90_24px.svg'),
 (2457, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_charging_full_24px.svg'),
 (2458, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_full_24px.svg'),
 (2459, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_std_24px.svg'),
 (2460, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_battery_unknown_24px.svg'),
 (2461, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_24px.svg'),
 (2462, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_connected_24px.svg'),
 (2463, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_disabled_24px.svg'),
 (2464, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_bluetooth_searching_24px.svg'),
 (2465, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_auto_24px.svg'),
 (2466, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_high_24px.svg'),
 (2467, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_low_24px.svg'),
 (2468, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_brightness_medium_24px.svg'),
 (2469, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_data_usage_24px.svg'),
 (2470, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_developer_mode_24px.svg'),
 (2471, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_devices_24px.svg'),
 (2472, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_dvr_24px.svg'),
 (2473, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_gps_fixed_24px.svg'),
 (2474, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_gps_not_fixed_24px.svg'),
 (2475, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_gps_off_24px.svg'),
 (2476, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_graphic_eq_24px.svg'),
 (2477, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_location_disabled_24px.svg'),
 (2478, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_location_searching_24px.svg'),
 (2479, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_network_cell_24px.svg'),
 (2480, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_network_wifi_24px.svg'),
 (2481, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_nfc_24px.svg'),
 (2482, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_lock_landscape_24px.svg'),
 (2483, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_lock_portrait_24px.svg'),
 (2484, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_lock_rotation_24px.svg'),
 (2485, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_screen_rotation_24px.svg'),
 (2486, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_sd_storage_24px.svg'),
 (2487, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_settings_system_daydream_24px.svg'),
 (2488, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_0_bar_24px.svg'),
 (2489, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_1_bar_24px.svg'),
 (2490, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_2_bar_24px.svg'),
 (2491, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_3_bar_24px.svg'),
 (2492, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_4_bar_24px.svg'),
 (2493, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_0_bar_24px.svg'),
 (2494, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_1_bar_24px.svg'),
 (2495, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_2_bar_24px.svg'),
 (2496, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_3_bar_24px.svg'),
 (2497, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_4_bar_24px.svg'),
 (2498, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_no_sim_24px.svg'),
 (2499, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_null_24px.svg'),
 (2500, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_cellular_off_24px.svg');
INSERT INTO `wp8b_wfknownfilelist` VALUES(2501, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_0_bar_24px.svg'),
 (2502, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_24px.svg'),
 (2503, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_lock_24px.svg'),
 (2504, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_24px.svg'),
 (2505, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_lock_24px.svg'),
 (2506, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_24px.svg'),
 (2507, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_lock_24px.svg'),
 (2508, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_24px.svg'),
 (2509, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_lock_24px.svg'),
 (2510, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_off_24px.svg'),
 (2511, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_1_bar_26x24px.svg'),
 (2512, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_2_bar_26x24px.svg'),
 (2513, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_3_bar_26x24px.svg'),
 (2514, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_4_bar_26x24px.svg'),
 (2515, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_1_26x24px.svg'),
 (2516, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_26x24px.svg'),
 (2517, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_2_26x24px.svg'),
 (2518, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_3_26x24px.svg'),
 (2519, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_4_26x24px.svg'),
 (2520, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_not_connected_26x24px.svg'),
 (2521, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_null_26x24px.svg'),
 (2522, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_storage_24px.svg'),
 (2523, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_usb_24px.svg'),
 (2524, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_wallpaper_24px.svg'),
 (2525, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_widgets_24px.svg'),
 (2526, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_wifi_lock_24px.svg'),
 (2527, 'wp-content/plugins/revslider/public/assets/assets/svg/device/ic_wifi_tethering_24px.svg'),
 (2528, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_attach_file_24px.svg'),
 (2529, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_attach_money_24px.svg'),
 (2530, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_all_24px.svg'),
 (2531, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_bottom_24px.svg'),
 (2532, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_clear_24px.svg'),
 (2533, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_color_24px.svg'),
 (2534, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_horizontal_24px.svg'),
 (2535, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_inner_24px.svg'),
 (2536, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_left_24px.svg'),
 (2537, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_outer_24px.svg'),
 (2538, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_right_24px.svg'),
 (2539, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_style_24px.svg'),
 (2540, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_top_24px.svg'),
 (2541, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_border_vertical_24px.svg'),
 (2542, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_drag_handle_24px.svg'),
 (2543, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_center_24px.svg'),
 (2544, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_justify_24px.svg'),
 (2545, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_left_24px.svg'),
 (2546, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_align_right_24px.svg'),
 (2547, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_bold_24px.svg'),
 (2548, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_clear_24px.svg'),
 (2549, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_color_fill_24px.svg'),
 (2550, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_color_reset_24px.svg'),
 (2551, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_color_text_24px.svg'),
 (2552, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_indent_decrease_24px.svg'),
 (2553, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_indent_increase_24px.svg'),
 (2554, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_italic_24px.svg'),
 (2555, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_line_spacing_24px.svg'),
 (2556, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_list_bulleted_24px.svg'),
 (2557, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_list_numbered_24px.svg'),
 (2558, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_paint_24px.svg'),
 (2559, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_quote_24px.svg'),
 (2560, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_shapes_24px.svg'),
 (2561, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_size_24px.svg'),
 (2562, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_strikethrough_24px.svg'),
 (2563, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_textdirection_l_to_r_24px.svg'),
 (2564, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_textdirection_r_to_l_24px.svg'),
 (2565, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_format_underlined_24px.svg'),
 (2566, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_functions_24px.svg'),
 (2567, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_highlight_24px.svg'),
 (2568, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_chart_24px.svg'),
 (2569, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_comment_24px.svg'),
 (2570, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_drive_file_24px.svg'),
 (2571, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_emoticon_24px.svg'),
 (2572, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_invitation_24px.svg'),
 (2573, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_link_24px.svg'),
 (2574, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_insert_photo_24px.svg'),
 (2575, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_linear_scale_24px.svg'),
 (2576, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_merge_type_24px.svg'),
 (2577, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_mode_comment_24px.svg'),
 (2578, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_mode_edit_24px.svg'),
 (2579, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_money_off_24px.svg'),
 (2580, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_publish_24px.svg'),
 (2581, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_short_text_24px.svg'),
 (2582, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_space_bar_24px.svg'),
 (2583, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_strikethrough_s_24px.svg'),
 (2584, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_text_fields_24px.svg'),
 (2585, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_vertical_align_bottom_24px.svg'),
 (2586, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_vertical_align_center_24px.svg'),
 (2587, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_vertical_align_top_24px.svg'),
 (2588, 'wp-content/plugins/revslider/public/assets/assets/svg/editor/ic_wrap_text_24px.svg'),
 (2589, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_attachment_24px.svg'),
 (2590, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_24px.svg'),
 (2591, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_circle_24px.svg'),
 (2592, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_done_24px.svg'),
 (2593, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_download_24px.svg'),
 (2594, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_off_24px.svg'),
 (2595, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_queue_24px.svg'),
 (2596, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_cloud_upload_24px.svg'),
 (2597, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_create_new_folder_24px.svg'),
 (2598, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_file_download_24px.svg'),
 (2599, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_file_upload_24px.svg'),
 (2600, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_folder_24px.svg'),
 (2601, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_folder_open_24px.svg'),
 (2602, 'wp-content/plugins/revslider/public/assets/assets/svg/file/ic_folder_shared_24px.svg'),
 (2603, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_cast_24px.svg'),
 (2604, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_cast_connected_24px.svg'),
 (2605, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_computer_24px.svg'),
 (2606, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_desktop_mac_24px.svg'),
 (2607, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_desktop_windows_24px.svg'),
 (2608, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_developer_board_24px.svg'),
 (2609, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_device_hub_24px.svg'),
 (2610, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_devices_other_24px.svg'),
 (2611, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_dock_24px.svg'),
 (2612, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_gamepad_24px.svg'),
 (2613, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_headset_24px.svg'),
 (2614, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_headset_mic_24px.svg'),
 (2615, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_24px.svg'),
 (2616, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_down_24px.svg'),
 (2617, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_left_24px.svg'),
 (2618, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_right_24px.svg'),
 (2619, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_up_24px.svg'),
 (2620, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_backspace_24px.svg'),
 (2621, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_capslock_24px.svg'),
 (2622, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_hide_24px.svg'),
 (2623, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_return_24px.svg'),
 (2624, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_tab_24px.svg'),
 (2625, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_keyboard_voice_24px.svg'),
 (2626, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_24px.svg'),
 (2627, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_chromebook_24px.svg'),
 (2628, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_mac_24px.svg'),
 (2629, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_laptop_windows_24px.svg'),
 (2630, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_memory_24px.svg'),
 (2631, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_mouse_24px.svg'),
 (2632, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phone_android_24px.svg'),
 (2633, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phone_iphone_24px.svg'),
 (2634, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phonelink_24px.svg'),
 (2635, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_phonelink_off_24px.svg'),
 (2636, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_power_input_24px.svg'),
 (2637, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_router_24px.svg'),
 (2638, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_scanner_24px.svg'),
 (2639, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_security_24px.svg'),
 (2640, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_sim_card_24px.svg'),
 (2641, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_smartphone_24px.svg'),
 (2642, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_speaker_24px.svg'),
 (2643, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_speaker_group_24px.svg'),
 (2644, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tablet_24px.svg'),
 (2645, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tablet_android_24px.svg'),
 (2646, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tablet_mac_24px.svg'),
 (2647, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_toys_24px.svg'),
 (2648, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_tv_24px.svg'),
 (2649, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_videogame_asset_24px.svg'),
 (2650, 'wp-content/plugins/revslider/public/assets/assets/svg/hardware/ic_watch_24px.svg'),
 (2651, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_add_a_photo_24px.svg'),
 (2652, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_add_to_photos_24px.svg'),
 (2653, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_adjust_24px.svg'),
 (2654, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_assistant_24px.svg'),
 (2655, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_assistant_photo_24px.svg'),
 (2656, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_audiotrack_24px.svg'),
 (2657, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_circular_24px.svg'),
 (2658, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_linear_24px.svg'),
 (2659, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_off_24px.svg'),
 (2660, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_blur_on_24px.svg'),
 (2661, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_1_24px.svg'),
 (2662, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_2_24px.svg'),
 (2663, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_3_24px.svg'),
 (2664, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_4_24px.svg'),
 (2665, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_5_24px.svg'),
 (2666, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_6_24px.svg'),
 (2667, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brightness_7_24px.svg'),
 (2668, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_broken_image_24px.svg'),
 (2669, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_brush_24px.svg'),
 (2670, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_24px.svg'),
 (2671, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_alt_24px.svg'),
 (2672, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_front_24px.svg'),
 (2673, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_rear_24px.svg'),
 (2674, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_camera_roll_24px.svg'),
 (2675, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_center_focus_strong_24px.svg'),
 (2676, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_center_focus_weak_24px.svg'),
 (2677, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_collections_24px.svg'),
 (2678, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_collections_bookmark_24px.svg'),
 (2679, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_color_lens_24px.svg'),
 (2680, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_colorize_24px.svg'),
 (2681, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_compare_24px.svg'),
 (2682, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_control_point_24px.svg'),
 (2683, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_control_point_duplicate_24px.svg'),
 (2684, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_16_9_24px.svg'),
 (2685, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_24px.svg'),
 (2686, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_3_2_24px.svg'),
 (2687, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_5_4_24px.svg'),
 (2688, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_7_5_24px.svg'),
 (2689, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_din_24px.svg'),
 (2690, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_free_24px.svg'),
 (2691, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_landscape_24px.svg'),
 (2692, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_original_24px.svg'),
 (2693, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_portrait_24px.svg'),
 (2694, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_rotate_24px.svg'),
 (2695, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_crop_square_24px.svg'),
 (2696, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_dehaze_24px.svg'),
 (2697, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_details_24px.svg'),
 (2698, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_edit_24px.svg'),
 (2699, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_24px.svg'),
 (2700, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_neg_1_24px.svg'),
 (2701, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_neg_2_24px.svg'),
 (2702, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_plus_1_24px.svg'),
 (2703, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_plus_2_24px.svg'),
 (2704, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_exposure_zero_24px.svg'),
 (2705, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_1_24px.svg'),
 (2706, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_24px.svg'),
 (2707, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_2_24px.svg'),
 (2708, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_3_24px.svg'),
 (2709, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_4_24px.svg'),
 (2710, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_5_24px.svg'),
 (2711, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_6_24px.svg'),
 (2712, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_7_24px.svg'),
 (2713, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_8_24px.svg'),
 (2714, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_9_24px.svg'),
 (2715, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_9_plus_24px.svg'),
 (2716, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_b_and_w_24px.svg'),
 (2717, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_center_focus_24px.svg'),
 (2718, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_drama_24px.svg'),
 (2719, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_frames_24px.svg'),
 (2720, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_hdr_24px.svg'),
 (2721, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_none_24px.svg'),
 (2722, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_tilt_shift_24px.svg'),
 (2723, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_filter_vintage_24px.svg'),
 (2724, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flare_24px.svg'),
 (2725, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flash_auto_24px.svg'),
 (2726, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flash_off_24px.svg'),
 (2727, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flash_on_24px.svg'),
 (2728, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_flip_24px.svg'),
 (2729, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_gradient_24px.svg'),
 (2730, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_grain_24px.svg'),
 (2731, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_grid_off_24px.svg'),
 (2732, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_grid_on_24px.svg'),
 (2733, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_off_24px.svg'),
 (2734, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_on_24px.svg'),
 (2735, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_strong_24px.svg'),
 (2736, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_hdr_weak_24px.svg'),
 (2737, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_healing_24px.svg'),
 (2738, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_image_24px.svg'),
 (2739, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_image_aspect_ratio_24px.svg'),
 (2740, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_iso_24px.svg'),
 (2741, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_landscape_24px.svg'),
 (2742, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_leak_add_24px.svg'),
 (2743, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_leak_remove_24px.svg'),
 (2744, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_lens_24px.svg'),
 (2745, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_linked_camera_24px.svg'),
 (2746, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_24px.svg'),
 (2747, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_3_24px.svg'),
 (2748, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_4_24px.svg'),
 (2749, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_5_24px.svg'),
 (2750, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_6_24px.svg'),
 (2751, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_one_24px.svg'),
 (2752, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_looks_two_24px.svg'),
 (2753, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_loupe_24px.svg'),
 (2754, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_monochrome_photos_24px.svg'),
 (2755, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_movie_creation_24px.svg'),
 (2756, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_movie_filter_24px.svg'),
 (2757, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_music_note_24px.svg'),
 (2758, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_nature_24px.svg'),
 (2759, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_nature_people_24px.svg'),
 (2760, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_navigate_before_24px.svg'),
 (2761, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_navigate_next_24px.svg'),
 (2762, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_palette_24px.svg'),
 (2763, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_24px.svg'),
 (2764, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_fish_eye_24px.svg'),
 (2765, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_horizontal_24px.svg'),
 (2766, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_vertical_24px.svg'),
 (2767, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_panorama_wide_angle_24px.svg'),
 (2768, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_24px.svg'),
 (2769, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_album_24px.svg'),
 (2770, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_camera_24px.svg'),
 (2771, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_filter_24px.svg'),
 (2772, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_library_24px.svg'),
 (2773, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_size_select_actual_24px.svg'),
 (2774, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_size_select_large_24px.svg'),
 (2775, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_photo_size_select_small_24px.svg'),
 (2776, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_picture_as_pdf_24px.svg'),
 (2777, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_portrait_24px.svg'),
 (2778, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_remove_red_eye_24px.svg'),
 (2779, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_rotate_90_degrees_ccw_24px.svg'),
 (2780, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_rotate_left_24px.svg'),
 (2781, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_rotate_right_24px.svg'),
 (2782, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_slideshow_24px.svg'),
 (2783, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_straighten_24px.svg'),
 (2784, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_style_24px.svg'),
 (2785, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_switch_camera_24px.svg'),
 (2786, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_switch_video_24px.svg'),
 (2787, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_tag_faces_24px.svg'),
 (2788, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_texture_24px.svg'),
 (2789, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timelapse_24px.svg'),
 (2790, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_10_24px.svg'),
 (2791, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_24px.svg'),
 (2792, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_3_24px.svg'),
 (2793, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_timer_off_24px.svg'),
 (2794, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_tonality_24px.svg'),
 (2795, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_transform_24px.svg'),
 (2796, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_tune_24px.svg'),
 (2797, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_view_comfy_24px.svg'),
 (2798, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_view_compact_24px.svg'),
 (2799, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_vignette_24px.svg'),
 (2800, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_auto_24px.svg'),
 (2801, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_cloudy_24px.svg'),
 (2802, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_incandescent_24px.svg'),
 (2803, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_iridescent_24px.svg'),
 (2804, 'wp-content/plugins/revslider/public/assets/assets/svg/image/ic_wb_sunny_24px.svg'),
 (2805, 'wp-content/plugins/revslider/public/assets/assets/svg/index.php'),
 (2806, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_add_location_24px.svg'),
 (2807, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_beenhere_24px.svg'),
 (2808, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_24px.svg'),
 (2809, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_bike_24px.svg'),
 (2810, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_boat_24px.svg'),
 (2811, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_bus_24px.svg'),
 (2812, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_car_24px.svg'),
 (2813, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_railway_24px.svg'),
 (2814, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_run_24px.svg'),
 (2815, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_subway_24px.svg'),
 (2816, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_transit_24px.svg'),
 (2817, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_directions_walk_24px.svg'),
 (2818, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_edit_location_24px.svg'),
 (2819, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_flight_24px.svg'),
 (2820, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_hotel_24px.svg'),
 (2821, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_layers_24px.svg'),
 (2822, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_layers_clear_24px.svg'),
 (2823, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_activity_24px.svg'),
 (2824, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_airport_24px.svg'),
 (2825, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_atm_24px.svg'),
 (2826, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_bar_24px.svg'),
 (2827, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_cafe_24px.svg'),
 (2828, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_car_wash_24px.svg'),
 (2829, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_convenience_store_24px.svg'),
 (2830, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_dining_24px.svg'),
 (2831, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_drink_24px.svg'),
 (2832, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_florist_24px.svg'),
 (2833, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_gas_station_24px.svg'),
 (2834, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_grocery_store_24px.svg'),
 (2835, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_hospital_24px.svg'),
 (2836, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_hotel_24px.svg'),
 (2837, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_laundry_service_24px.svg'),
 (2838, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_library_24px.svg'),
 (2839, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_mall_24px.svg'),
 (2840, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_movies_24px.svg'),
 (2841, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_offer_24px.svg'),
 (2842, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_parking_24px.svg'),
 (2843, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_pharmacy_24px.svg'),
 (2844, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_phone_24px.svg'),
 (2845, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_pizza_24px.svg'),
 (2846, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_play_24px.svg'),
 (2847, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_post_office_24px.svg'),
 (2848, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_printshop_24px.svg'),
 (2849, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_see_24px.svg'),
 (2850, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_shipping_24px.svg'),
 (2851, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_local_taxi_24px.svg'),
 (2852, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_map_24px.svg'),
 (2853, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_my_location_24px.svg'),
 (2854, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_navigation_24px.svg'),
 (2855, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_near_me_24px.svg'),
 (2856, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_person_pin_24px.svg'),
 (2857, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_person_pin_circle_24px.svg'),
 (2858, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_pin_drop_24px.svg'),
 (2859, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_place_24px.svg'),
 (2860, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_rate_review_24px.svg'),
 (2861, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_restaurant_menu_24px.svg'),
 (2862, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_satellite_24px.svg'),
 (2863, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_store_mall_directory_24px.svg'),
 (2864, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_terrain_24px.svg'),
 (2865, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_traffic_24px.svg'),
 (2866, 'wp-content/plugins/revslider/public/assets/assets/svg/maps/ic_zoom_out_map_24px.svg'),
 (2867, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_apps_24px.svg'),
 (2868, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_apps_36px.svg'),
 (2869, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_back_24px.svg'),
 (2870, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_back_36px.svg'),
 (2871, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_downward_24px.svg'),
 (2872, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_24px.svg'),
 (2873, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_36px.svg'),
 (2874, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_circle_24px.svg'),
 (2875, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_24px.svg'),
 (2876, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_36px.svg'),
 (2877, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_24px.svg'),
 (2878, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_36px.svg'),
 (2879, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_arrow_upward_24px.svg'),
 (2880, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_cancel_24px.svg'),
 (2881, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_cancel_36px.svg'),
 (2882, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_check_24px.svg'),
 (2883, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_check_36px.svg'),
 (2884, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_left_24px.svg'),
 (2885, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_left_36px.svg'),
 (2886, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_right_24px.svg'),
 (2887, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_chevron_right_36px.svg'),
 (2888, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_close_24px.svg'),
 (2889, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_close_36px.svg'),
 (2890, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_less_24px.svg'),
 (2891, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_less_36px.svg'),
 (2892, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_more_24px.svg'),
 (2893, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_expand_more_36px.svg'),
 (2894, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_24px.svg'),
 (2895, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_36px.svg'),
 (2896, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_24px.svg'),
 (2897, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_36px.svg'),
 (2898, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_menu_24px.svg'),
 (2899, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_menu_36px.svg'),
 (2900, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_horiz_24px.svg'),
 (2901, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_horiz_36px.svg'),
 (2902, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_vert_24px.svg'),
 (2903, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_more_vert_36px.svg'),
 (2904, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_refresh_24px.svg'),
 (2905, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_refresh_36px.svg'),
 (2906, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_left_24px.svg'),
 (2907, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_right_24px.svg'),
 (2908, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_less_24px.svg'),
 (2909, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_less_36px.svg'),
 (2910, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_more_24px.svg'),
 (2911, 'wp-content/plugins/revslider/public/assets/assets/svg/navigation/ic_unfold_more_36px.svg'),
 (2912, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_adb_24px.svg'),
 (2913, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_24px.svg'),
 (2914, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_angled_24px.svg'),
 (2915, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_individual_suite_24px.svg'),
 (2916, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_extra_24px.svg'),
 (2917, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_normal_24px.svg'),
 (2918, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_reduced_24px.svg'),
 (2919, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_extra_24px.svg'),
 (2920, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_normal_24px.svg'),
 (2921, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_bluetooth_audio_24px.svg'),
 (2922, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_confirmation_number_24px.svg'),
 (2923, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_disc_full_24px.svg'),
 (2924, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_24px.svg'),
 (2925, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_alt_24px.svg'),
 (2926, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_drive_eta_24px.svg'),
 (2927, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_enhanced_encryption_24px.svg'),
 (2928, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_event_available_24px.svg'),
 (2929, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_event_busy_24px.svg'),
 (2930, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_event_note_24px.svg'),
 (2931, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_folder_special_24px.svg'),
 (2932, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_live_tv_24px.svg'),
 (2933, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_mms_24px.svg'),
 (2934, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_more_24px.svg'),
 (2935, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_network_check_24px.svg'),
 (2936, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_network_locked_24px.svg'),
 (2937, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_no_encryption_24px.svg'),
 (2938, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_ondemand_video_24px.svg'),
 (2939, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_personal_video_24px.svg'),
 (2940, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_bluetooth_speaker_24px.svg'),
 (2941, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_forwarded_24px.svg'),
 (2942, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_in_talk_24px.svg'),
 (2943, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_locked_24px.svg'),
 (2944, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_missed_24px.svg'),
 (2945, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_phone_paused_24px.svg'),
 (2946, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_power_24px.svg'),
 (2947, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_rv_hookup_24px.svg'),
 (2948, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sd_card_24px.svg'),
 (2949, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sim_card_alert_24px.svg'),
 (2950, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sms_24px.svg'),
 (2951, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sms_failed_24px.svg'),
 (2952, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sync_24px.svg'),
 (2953, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sync_disabled_24px.svg'),
 (2954, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_sync_problem_24px.svg'),
 (2955, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_system_update_24px.svg'),
 (2956, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_tap_and_play_24px.svg'),
 (2957, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_time_to_leave_24px.svg'),
 (2958, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_vibration_24px.svg'),
 (2959, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_voice_chat_24px.svg'),
 (2960, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_vpn_lock_24px.svg'),
 (2961, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_wc_24px.svg'),
 (2962, 'wp-content/plugins/revslider/public/assets/assets/svg/notification/ic_wifi_24px.svg'),
 (2963, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_ac_unit_24px.svg'),
 (2964, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_airport_shuttle_24px.svg'),
 (2965, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_all_inclusive_24px.svg'),
 (2966, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_beach_access_24px.svg'),
 (2967, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_business_center_24px.svg'),
 (2968, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_casino_24px.svg'),
 (2969, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_child_care_24px.svg'),
 (2970, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_child_friendly_24px.svg'),
 (2971, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_fitness_center_24px.svg'),
 (2972, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_free_breakfast_24px.svg'),
 (2973, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_golf_course_24px.svg'),
 (2974, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_hot_tub_24px.svg'),
 (2975, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_kitchen_24px.svg'),
 (2976, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_pool_24px.svg'),
 (2977, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_room_service_24px.svg'),
 (2978, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_smoke_free_24px.svg'),
 (2979, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_smoking_rooms_24px.svg'),
 (2980, 'wp-content/plugins/revslider/public/assets/assets/svg/places/ic_spa_24px.svg'),
 (2981, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_cake_24px.svg'),
 (2982, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_domain_24px.svg'),
 (2983, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_group_24px.svg'),
 (2984, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_group_add_24px.svg'),
 (2985, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_location_city_24px.svg'),
 (2986, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_mood_24px.svg'),
 (2987, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_mood_bad_24px.svg'),
 (2988, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_24px.svg'),
 (2989, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_active_24px.svg'),
 (2990, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_none_24px.svg'),
 (2991, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_off_24px.svg'),
 (2992, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_notifications_paused_24px.svg'),
 (2993, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_pages_24px.svg'),
 (2994, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_party_mode_24px.svg'),
 (2995, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_people_24px.svg'),
 (2996, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_people_outline_24px.svg'),
 (2997, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_person_24px.svg'),
 (2998, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_person_add_24px.svg'),
 (2999, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_person_outline_24px.svg'),
 (3000, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_plus_one_24px.svg');
INSERT INTO `wp8b_wfknownfilelist` VALUES(3001, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_poll_24px.svg'),
 (3002, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_public_24px.svg'),
 (3003, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_school_24px.svg'),
 (3004, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_share_24px.svg'),
 (3005, 'wp-content/plugins/revslider/public/assets/assets/svg/social/ic_whatshot_24px.svg'),
 (3006, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_check_box_24px.svg'),
 (3007, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_check_box_outline_blank_24px.svg'),
 (3008, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_indeterminate_check_box_24px.svg'),
 (3009, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_radio_button_checked_24px.svg'),
 (3010, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_radio_button_unchecked_24px.svg'),
 (3011, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_star_24px.svg'),
 (3012, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_star_border_24px.svg'),
 (3013, 'wp-content/plugins/revslider/public/assets/assets/svg/toggle/ic_star_half_24px.svg'),
 (3014, 'wp-content/plugins/revslider/public/assets/css/index.php'),
 (3015, 'wp-content/plugins/revslider/public/assets/fonts/font-awesome/fonts/fontawesome-webfont.svg'),
 (3016, 'wp-content/plugins/revslider/public/assets/fonts/font-awesome/index.php'),
 (3017, 'wp-content/plugins/revslider/public/assets/fonts/index.php'),
 (3018, 'wp-content/plugins/revslider/public/assets/fonts/material/MaterialIcons-Regular.svg'),
 (3019, 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/css/index.php'),
 (3020, 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.svg'),
 (3021, 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/index.php'),
 (3022, 'wp-content/plugins/revslider/public/assets/fonts/pe-icon-7-stroke/index.php'),
 (3023, 'wp-content/plugins/revslider/public/assets/fonts/revicons/index.php'),
 (3024, 'wp-content/plugins/revslider/public/assets/fonts/revicons/revicons.svg'),
 (3025, 'wp-content/plugins/revslider/public/assets/index.php'),
 (3026, 'wp-content/plugins/revslider/public/assets/js/index.php'),
 (3027, 'wp-content/plugins/revslider/public/assets/js/rbtools.min.js'),
 (3028, 'wp-content/plugins/revslider/public/assets/js/rs6.min.js'),
 (3029, 'wp-content/plugins/revslider/public/includes/functions-public.class.php'),
 (3030, 'wp-content/plugins/revslider/public/index.php'),
 (3031, 'wp-content/plugins/revslider/public/revslider-front.class.php'),
 (3032, 'wp-content/plugins/revslider/public/views/revslider-page-template.php'),
 (3033, 'wp-content/plugins/revslider/release_log.html'),
 (3034, 'wp-content/plugins/revslider/revslider.php'),
 (3035, 'wp-content/plugins/revslider/uninstall.php'),
 (3036, 'wp-content/plugins/revslider/welcome.html'),
 (3037, 'wp-content/plugins/updraftplus/admin.php'),
 (3038, 'wp-content/plugins/updraftplus/backup.php'),
 (3039, 'wp-content/plugins/updraftplus/central/bootstrap.php'),
 (3040, 'wp-content/plugins/updraftplus/central/classes/automatic-upgrader-skin-compatibility.php'),
 (3041, 'wp-content/plugins/updraftplus/central/classes/class-automatic-upgrader-skin.php'),
 (3042, 'wp-content/plugins/updraftplus/central/commands.php'),
 (3043, 'wp-content/plugins/updraftplus/central/listener.php'),
 (3044, 'wp-content/plugins/updraftplus/central/modules/analytics.php'),
 (3045, 'wp-content/plugins/updraftplus/central/modules/comments.php'),
 (3046, 'wp-content/plugins/updraftplus/central/modules/core.php'),
 (3047, 'wp-content/plugins/updraftplus/central/modules/media.php'),
 (3048, 'wp-content/plugins/updraftplus/central/modules/plugin.php'),
 (3049, 'wp-content/plugins/updraftplus/central/modules/posts.php'),
 (3050, 'wp-content/plugins/updraftplus/central/modules/theme.php'),
 (3051, 'wp-content/plugins/updraftplus/central/modules/updates.php'),
 (3052, 'wp-content/plugins/updraftplus/central/modules/users.php'),
 (3053, 'wp-content/plugins/updraftplus/changelog.txt'),
 (3054, 'wp-content/plugins/updraftplus/class-updraftplus.php'),
 (3055, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-fix.css'),
 (3056, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-fix.min.css'),
 (3057, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-plain-buttons.css'),
 (3058, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows-plain-buttons.min.css'),
 (3059, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows.css'),
 (3060, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-arrows.min.css'),
 (3061, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-dark.css'),
 (3062, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-dark.min.css'),
 (3063, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-default.css'),
 (3064, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-default.min.css'),
 (3065, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square-dark.css'),
 (3066, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square-dark.min.css'),
 (3067, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square.css'),
 (3068, 'wp-content/plugins/updraftplus/css/tether-shepherd/shepherd-theme-square.min.css'),
 (3069, 'wp-content/plugins/updraftplus/css/updraftplus-admin.css'),
 (3070, 'wp-content/plugins/updraftplus/css/updraftplus-admin.min.css'),
 (3071, 'wp-content/plugins/updraftplus/css/updraftplus-admin.min.css.map'),
 (3072, 'wp-content/plugins/updraftplus/css/updraftplus-notices.css'),
 (3073, 'wp-content/plugins/updraftplus/css/updraftplus-notices.min.css'),
 (3074, 'wp-content/plugins/updraftplus/css/updraftplus-notices.min.css.map'),
 (3075, 'wp-content/plugins/updraftplus/css/updraftplus-tour.css'),
 (3076, 'wp-content/plugins/updraftplus/css/updraftplus-tour.min.css'),
 (3077, 'wp-content/plugins/updraftplus/css/updraftplus-tour.min.css.map'),
 (3078, 'wp-content/plugins/updraftplus/css/updraftplus-tour.scss'),
 (3079, 'wp-content/plugins/updraftplus/example-decrypt.php'),
 (3080, 'wp-content/plugins/updraftplus/images/addons-images/all.png'),
 (3081, 'wp-content/plugins/updraftplus/images/addons-images/autobackup.png'),
 (3082, 'wp-content/plugins/updraftplus/images/addons-images/azure.png'),
 (3083, 'wp-content/plugins/updraftplus/images/addons-images/backblaze.png'),
 (3084, 'wp-content/plugins/updraftplus/images/addons-images/cloudfiles-enhanced.png'),
 (3085, 'wp-content/plugins/updraftplus/images/addons-images/dropbox-folders.png'),
 (3086, 'wp-content/plugins/updraftplus/images/addons-images/fixtime.png'),
 (3087, 'wp-content/plugins/updraftplus/images/addons-images/google-enhanced.png'),
 (3088, 'wp-content/plugins/updraftplus/images/addons-images/googlecloud.png'),
 (3089, 'wp-content/plugins/updraftplus/images/addons-images/importer.png'),
 (3090, 'wp-content/plugins/updraftplus/images/addons-images/incremental.png'),
 (3091, 'wp-content/plugins/updraftplus/images/addons-images/lockadmin.png'),
 (3092, 'wp-content/plugins/updraftplus/images/addons-images/migrator.png'),
 (3093, 'wp-content/plugins/updraftplus/images/addons-images/moredatabase.png'),
 (3094, 'wp-content/plugins/updraftplus/images/addons-images/morefiles.png'),
 (3095, 'wp-content/plugins/updraftplus/images/addons-images/morestorage.png'),
 (3096, 'wp-content/plugins/updraftplus/images/addons-images/multisite.png'),
 (3097, 'wp-content/plugins/updraftplus/images/addons-images/noadverts.png'),
 (3098, 'wp-content/plugins/updraftplus/images/addons-images/onedrive.png'),
 (3099, 'wp-content/plugins/updraftplus/images/addons-images/reporting.png'),
 (3100, 'wp-content/plugins/updraftplus/images/addons-images/s3-enhanced.png'),
 (3101, 'wp-content/plugins/updraftplus/images/addons-images/sftp.png'),
 (3102, 'wp-content/plugins/updraftplus/images/addons-images/webdav.png'),
 (3103, 'wp-content/plugins/updraftplus/images/addons-images/wp-cli.png'),
 (3104, 'wp-content/plugins/updraftplus/images/automaticbackup.png'),
 (3105, 'wp-content/plugins/updraftplus/images/aws_logo.png'),
 (3106, 'wp-content/plugins/updraftplus/images/azure.png'),
 (3107, 'wp-content/plugins/updraftplus/images/backblaze.png'),
 (3108, 'wp-content/plugins/updraftplus/images/dashicon.png'),
 (3109, 'wp-content/plugins/updraftplus/images/dreamobjects_logo-horiz-2013.png'),
 (3110, 'wp-content/plugins/updraftplus/images/dropbox-logo.png'),
 (3111, 'wp-content/plugins/updraftplus/images/googlecloud.png'),
 (3112, 'wp-content/plugins/updraftplus/images/googledrive_logo.png'),
 (3113, 'wp-content/plugins/updraftplus/images/icons/azure.png'),
 (3114, 'wp-content/plugins/updraftplus/images/icons/backblaze.png'),
 (3115, 'wp-content/plugins/updraftplus/images/icons/cloudfiles.png'),
 (3116, 'wp-content/plugins/updraftplus/images/icons/dreamobjects.png'),
 (3117, 'wp-content/plugins/updraftplus/images/icons/dropbox.png'),
 (3118, 'wp-content/plugins/updraftplus/images/icons/email.png'),
 (3119, 'wp-content/plugins/updraftplus/images/icons/folder.png'),
 (3120, 'wp-content/plugins/updraftplus/images/icons/googlecloud.png'),
 (3121, 'wp-content/plugins/updraftplus/images/icons/googledrive.png'),
 (3122, 'wp-content/plugins/updraftplus/images/icons/lock.png'),
 (3123, 'wp-content/plugins/updraftplus/images/icons/onedrive.png'),
 (3124, 'wp-content/plugins/updraftplus/images/icons/openstack.png'),
 (3125, 'wp-content/plugins/updraftplus/images/icons/s3.png'),
 (3126, 'wp-content/plugins/updraftplus/images/icons/updraftvault.png'),
 (3127, 'wp-content/plugins/updraftplus/images/icons/webdav.png'),
 (3128, 'wp-content/plugins/updraftplus/images/notices/black_friday.png'),
 (3129, 'wp-content/plugins/updraftplus/images/notices/christmas.png'),
 (3130, 'wp-content/plugins/updraftplus/images/notices/keyy_logo.png'),
 (3131, 'wp-content/plugins/updraftplus/images/notices/locksettings.png'),
 (3132, 'wp-content/plugins/updraftplus/images/notices/metaslider_logo.png'),
 (3133, 'wp-content/plugins/updraftplus/images/notices/new_year.png'),
 (3134, 'wp-content/plugins/updraftplus/images/notices/reporting.png'),
 (3135, 'wp-content/plugins/updraftplus/images/notices/spring.png'),
 (3136, 'wp-content/plugins/updraftplus/images/notices/summer.png'),
 (3137, 'wp-content/plugins/updraftplus/images/notices/support.png'),
 (3138, 'wp-content/plugins/updraftplus/images/notices/updraft_logo.png'),
 (3139, 'wp-content/plugins/updraftplus/images/notices/wp_optimize_logo.png'),
 (3140, 'wp-content/plugins/updraftplus/images/onedrive.png'),
 (3141, 'wp-content/plugins/updraftplus/images/other-plugins/keyy.png'),
 (3142, 'wp-content/plugins/updraftplus/images/other-plugins/meta-slider.png'),
 (3143, 'wp-content/plugins/updraftplus/images/other-plugins/updraft-central.png'),
 (3144, 'wp-content/plugins/updraftplus/images/other-plugins/wp-optimize.png'),
 (3145, 'wp-content/plugins/updraftplus/images/padlock-150.png'),
 (3146, 'wp-content/plugins/updraftplus/images/rackspacecloud-logo.png'),
 (3147, 'wp-content/plugins/updraftplus/images/ud-logo-150.png'),
 (3148, 'wp-content/plugins/updraftplus/images/ud-logo.png'),
 (3149, 'wp-content/plugins/updraftplus/images/udlogo-rotating.gif'),
 (3150, 'wp-content/plugins/updraftplus/images/udp-logo-white.png'),
 (3151, 'wp-content/plugins/updraftplus/images/updraft_central_logo.png'),
 (3152, 'wp-content/plugins/updraftplus/images/updraft_cross.png'),
 (3153, 'wp-content/plugins/updraftplus/images/updraft_freev.png'),
 (3154, 'wp-content/plugins/updraftplus/images/updraft_premv.png'),
 (3155, 'wp-content/plugins/updraftplus/images/updraft_tick.png'),
 (3156, 'wp-content/plugins/updraftplus/images/updraft_vault_logo.png'),
 (3157, 'wp-content/plugins/updraftplus/images/updraftcentral_cloud.png'),
 (3158, 'wp-content/plugins/updraftplus/images/updraftclone_logo_white.png'),
 (3159, 'wp-content/plugins/updraftplus/images/updraftvault-150.png'),
 (3160, 'wp-content/plugins/updraftplus/images/upraftplus-clone-screenshot.jpg'),
 (3161, 'wp-content/plugins/updraftplus/includes/Dropbox2/API.php'),
 (3162, 'wp-content/plugins/updraftplus/includes/Dropbox2/Exception.php'),
 (3163, 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Consumer/ConsumerAbstract.php'),
 (3164, 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Consumer/Curl.php'),
 (3165, 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Consumer/WordPress.php'),
 (3166, 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Storage/Encrypter.php'),
 (3167, 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Storage/StorageInterface.php'),
 (3168, 'wp-content/plugins/updraftplus/includes/Dropbox2/OAuth/Storage/WordPress.php'),
 (3169, 'wp-content/plugins/updraftplus/includes/Google/Auth/Abstract.php'),
 (3170, 'wp-content/plugins/updraftplus/includes/Google/Auth/AppIdentity.php'),
 (3171, 'wp-content/plugins/updraftplus/includes/Google/Auth/AssertionCredentials.php'),
 (3172, 'wp-content/plugins/updraftplus/includes/Google/Auth/ComputeEngine.php'),
 (3173, 'wp-content/plugins/updraftplus/includes/Google/Auth/Exception.php'),
 (3174, 'wp-content/plugins/updraftplus/includes/Google/Auth/LoginTicket.php'),
 (3175, 'wp-content/plugins/updraftplus/includes/Google/Auth/OAuth2.php'),
 (3176, 'wp-content/plugins/updraftplus/includes/Google/Auth/Simple.php'),
 (3177, 'wp-content/plugins/updraftplus/includes/Google/Cache/Abstract.php'),
 (3178, 'wp-content/plugins/updraftplus/includes/Google/Cache/Apc.php'),
 (3179, 'wp-content/plugins/updraftplus/includes/Google/Cache/Exception.php'),
 (3180, 'wp-content/plugins/updraftplus/includes/Google/Cache/File.php'),
 (3181, 'wp-content/plugins/updraftplus/includes/Google/Cache/Memcache.php'),
 (3182, 'wp-content/plugins/updraftplus/includes/Google/Cache/Null.php'),
 (3183, 'wp-content/plugins/updraftplus/includes/Google/Client.php'),
 (3184, 'wp-content/plugins/updraftplus/includes/Google/Collection.php'),
 (3185, 'wp-content/plugins/updraftplus/includes/Google/Config.php'),
 (3186, 'wp-content/plugins/updraftplus/includes/Google/Exception.php'),
 (3187, 'wp-content/plugins/updraftplus/includes/Google/Http/Batch.php'),
 (3188, 'wp-content/plugins/updraftplus/includes/Google/Http/CacheParser.php'),
 (3189, 'wp-content/plugins/updraftplus/includes/Google/Http/MediaFileUpload.php'),
 (3190, 'wp-content/plugins/updraftplus/includes/Google/Http/REST.php'),
 (3191, 'wp-content/plugins/updraftplus/includes/Google/Http/Request.php'),
 (3192, 'wp-content/plugins/updraftplus/includes/Google/IO/Abstract.php'),
 (3193, 'wp-content/plugins/updraftplus/includes/Google/IO/Curl.php'),
 (3194, 'wp-content/plugins/updraftplus/includes/Google/IO/Exception.php'),
 (3195, 'wp-content/plugins/updraftplus/includes/Google/IO/Stream.php'),
 (3196, 'wp-content/plugins/updraftplus/includes/Google/IO/cacerts.pem'),
 (3197, 'wp-content/plugins/updraftplus/includes/Google/Logger/Abstract.php'),
 (3198, 'wp-content/plugins/updraftplus/includes/Google/Logger/Exception.php'),
 (3199, 'wp-content/plugins/updraftplus/includes/Google/Logger/File.php'),
 (3200, 'wp-content/plugins/updraftplus/includes/Google/Logger/Null.php'),
 (3201, 'wp-content/plugins/updraftplus/includes/Google/Logger/Psr.php'),
 (3202, 'wp-content/plugins/updraftplus/includes/Google/Model.php'),
 (3203, 'wp-content/plugins/updraftplus/includes/Google/Service/Audit.php'),
 (3204, 'wp-content/plugins/updraftplus/includes/Google/Service/Container.php'),
 (3205, 'wp-content/plugins/updraftplus/includes/Google/Service/Datastore.php'),
 (3206, 'wp-content/plugins/updraftplus/includes/Google/Service/Directory.php'),
 (3207, 'wp-content/plugins/updraftplus/includes/Google/Service/Dns.php'),
 (3208, 'wp-content/plugins/updraftplus/includes/Google/Service/Drive.php'),
 (3209, 'wp-content/plugins/updraftplus/includes/Google/Service/Exception.php'),
 (3210, 'wp-content/plugins/updraftplus/includes/Google/Service/GroupsMigration.php'),
 (3211, 'wp-content/plugins/updraftplus/includes/Google/Service/Groupssettings.php'),
 (3212, 'wp-content/plugins/updraftplus/includes/Google/Service/IdentityToolkit.php'),
 (3213, 'wp-content/plugins/updraftplus/includes/Google/Service/Licensing.php'),
 (3214, 'wp-content/plugins/updraftplus/includes/Google/Service/Logging.php'),
 (3215, 'wp-content/plugins/updraftplus/includes/Google/Service/Oauth2.php'),
 (3216, 'wp-content/plugins/updraftplus/includes/Google/Service/Reports.php'),
 (3217, 'wp-content/plugins/updraftplus/includes/Google/Service/Resource.php'),
 (3218, 'wp-content/plugins/updraftplus/includes/Google/Service/Resourceviews.php'),
 (3219, 'wp-content/plugins/updraftplus/includes/Google/Service/Storage.php'),
 (3220, 'wp-content/plugins/updraftplus/includes/Google/Service/Tasks.php'),
 (3221, 'wp-content/plugins/updraftplus/includes/Google/Service.php'),
 (3222, 'wp-content/plugins/updraftplus/includes/Google/Signer/Abstract.php'),
 (3223, 'wp-content/plugins/updraftplus/includes/Google/Signer/P12.php'),
 (3224, 'wp-content/plugins/updraftplus/includes/Google/Task/Exception.php'),
 (3225, 'wp-content/plugins/updraftplus/includes/Google/Task/Retryable.php'),
 (3226, 'wp-content/plugins/updraftplus/includes/Google/Task/Runner.php'),
 (3227, 'wp-content/plugins/updraftplus/includes/Google/Utils/URITemplate.php'),
 (3228, 'wp-content/plugins/updraftplus/includes/Google/Utils.php'),
 (3229, 'wp-content/plugins/updraftplus/includes/Google/Verifier/Abstract.php'),
 (3230, 'wp-content/plugins/updraftplus/includes/Google/Verifier/Pem.php'),
 (3231, 'wp-content/plugins/updraftplus/includes/Google/autoload.php'),
 (3232, 'wp-content/plugins/updraftplus/includes/S3.php'),
 (3233, 'wp-content/plugins/updraftplus/includes/S3compat.php'),
 (3234, 'wp-content/plugins/updraftplus/includes/cacert.pem'),
 (3235, 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/loader.svg'),
 (3236, 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.css'),
 (3237, 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.js'),
 (3238, 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.css'),
 (3239, 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.css.map'),
 (3240, 'wp-content/plugins/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.js'),
 (3241, 'wp-content/plugins/updraftplus/includes/checkout-embed/class-udp-checkout-embed.php'),
 (3242, 'wp-content/plugins/updraftplus/includes/checkout-embed/products.json'),
 (3243, 'wp-content/plugins/updraftplus/includes/checkout-embed/readme.md'),
 (3244, 'wp-content/plugins/updraftplus/includes/class-backup-history.php'),
 (3245, 'wp-content/plugins/updraftplus/includes/class-commands.php'),
 (3246, 'wp-content/plugins/updraftplus/includes/class-database-utility.php'),
 (3247, 'wp-content/plugins/updraftplus/includes/class-filesystem-functions.php'),
 (3248, 'wp-content/plugins/updraftplus/includes/class-job-scheduler.php'),
 (3249, 'wp-content/plugins/updraftplus/includes/class-manipulation-functions.php'),
 (3250, 'wp-content/plugins/updraftplus/includes/class-partialfileservlet.php'),
 (3251, 'wp-content/plugins/updraftplus/includes/class-remote-send.php'),
 (3252, 'wp-content/plugins/updraftplus/includes/class-semaphore.php'),
 (3253, 'wp-content/plugins/updraftplus/includes/class-storage-methods-interface.php'),
 (3254, 'wp-content/plugins/updraftplus/includes/class-udrpc.php'),
 (3255, 'wp-content/plugins/updraftplus/includes/class-updraft-dashboard-news.php'),
 (3256, 'wp-content/plugins/updraftplus/includes/class-updraftcentral-updraftplus-commands.php'),
 (3257, 'wp-content/plugins/updraftplus/includes/class-updraftplus-encryption.php'),
 (3258, 'wp-content/plugins/updraftplus/includes/class-wpadmin-commands.php'),
 (3259, 'wp-content/plugins/updraftplus/includes/class-zip.php'),
 (3260, 'wp-content/plugins/updraftplus/includes/cloudfiles/cloudfiles.php'),
 (3261, 'wp-content/plugins/updraftplus/includes/cloudfiles/cloudfiles_exceptions.php'),
 (3262, 'wp-content/plugins/updraftplus/includes/cloudfiles/cloudfiles_http.php'),
 (3263, 'wp-content/plugins/updraftplus/includes/ftp.class.php'),
 (3264, 'wp-content/plugins/updraftplus/includes/get-cpanel-quota-usage.pl'),
 (3265, 'wp-content/plugins/updraftplus/includes/google-extensions.php'),
 (3266, 'wp-content/plugins/updraftplus/includes/handlebars/LICENSE'),
 (3267, 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.js'),
 (3268, 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.min.js'),
 (3269, 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.runtime.js'),
 (3270, 'wp-content/plugins/updraftplus/includes/handlebars/handlebars.runtime.min.js'),
 (3271, 'wp-content/plugins/updraftplus/includes/images/ui-bg_diagonals-thick_18_b81900_40x40.png'),
 (3272, 'wp-content/plugins/updraftplus/includes/images/ui-bg_diagonals-thick_20_666666_40x40.png'),
 (3273, 'wp-content/plugins/updraftplus/includes/images/ui-bg_flat_10_000000_40x100.png'),
 (3274, 'wp-content/plugins/updraftplus/includes/images/ui-bg_glass_100_f6f6f6_1x400.png'),
 (3275, 'wp-content/plugins/updraftplus/includes/images/ui-bg_glass_100_fdf5ce_1x400.png'),
 (3276, 'wp-content/plugins/updraftplus/includes/images/ui-bg_glass_65_ffffff_1x400.png'),
 (3277, 'wp-content/plugins/updraftplus/includes/images/ui-bg_gloss-wave_35_f6a828_500x100.png'),
 (3278, 'wp-content/plugins/updraftplus/includes/images/ui-bg_highlight-soft_100_eeeeee_1x100.png'),
 (3279, 'wp-content/plugins/updraftplus/includes/images/ui-bg_highlight-soft_75_ffe45c_1x100.png'),
 (3280, 'wp-content/plugins/updraftplus/includes/images/ui-icons_222222_256x240.png'),
 (3281, 'wp-content/plugins/updraftplus/includes/images/ui-icons_228ef1_256x240.png'),
 (3282, 'wp-content/plugins/updraftplus/includes/images/ui-icons_ef8c08_256x240.png'),
 (3283, 'wp-content/plugins/updraftplus/includes/images/ui-icons_ffd27a_256x240.png'),
 (3284, 'wp-content/plugins/updraftplus/includes/images/ui-icons_ffffff_256x240.png'),
 (3285, 'wp-content/plugins/updraftplus/includes/jquery-ui.custom.css'),
 (3286, 'wp-content/plugins/updraftplus/includes/jquery-ui.custom.min.css'),
 (3287, 'wp-content/plugins/updraftplus/includes/jquery-ui.custom.min.css.map'),
 (3288, 'wp-content/plugins/updraftplus/includes/jquery.blockUI.js'),
 (3289, 'wp-content/plugins/updraftplus/includes/jquery.blockUI.min.js'),
 (3290, 'wp-content/plugins/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.js'),
 (3291, 'wp-content/plugins/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.min.js'),
 (3292, 'wp-content/plugins/updraftplus/includes/jstree/jstree.js'),
 (3293, 'wp-content/plugins/updraftplus/includes/jstree/jstree.min.js'),
 (3294, 'wp-content/plugins/updraftplus/includes/jstree/themes/default/32px.png'),
 (3295, 'wp-content/plugins/updraftplus/includes/jstree/themes/default/40px.png'),
 (3296, 'wp-content/plugins/updraftplus/includes/jstree/themes/default/style.css'),
 (3297, 'wp-content/plugins/updraftplus/includes/jstree/themes/default/style.min.css'),
 (3298, 'wp-content/plugins/updraftplus/includes/jstree/themes/default/throbber.gif'),
 (3299, 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/32px.png'),
 (3300, 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/40px.png'),
 (3301, 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/style.css'),
 (3302, 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/style.min.css'),
 (3303, 'wp-content/plugins/updraftplus/includes/jstree/themes/default-dark/throbber.gif'),
 (3304, 'wp-content/plugins/updraftplus/includes/labelauty/LICENSE'),
 (3305, 'wp-content/plugins/updraftplus/includes/labelauty/images/input-checked.png'),
 (3306, 'wp-content/plugins/updraftplus/includes/labelauty/images/input-unchecked.png'),
 (3307, 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.css'),
 (3308, 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.js'),
 (3309, 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.min.css'),
 (3310, 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.min.css.map'),
 (3311, 'wp-content/plugins/updraftplus/includes/labelauty/jquery-labelauty.min.js'),
 (3312, 'wp-content/plugins/updraftplus/includes/tether/LICENSE'),
 (3313, 'wp-content/plugins/updraftplus/includes/tether/tether.js'),
 (3314, 'wp-content/plugins/updraftplus/includes/tether/tether.min.js'),
 (3315, 'wp-content/plugins/updraftplus/includes/tether-shepherd/LICENSE'),
 (3316, 'wp-content/plugins/updraftplus/includes/tether-shepherd/shepherd.js'),
 (3317, 'wp-content/plugins/updraftplus/includes/tether-shepherd/shepherd.min.js'),
 (3318, 'wp-content/plugins/updraftplus/includes/tether-shepherd/tether.js'),
 (3319, 'wp-content/plugins/updraftplus/includes/updraft-admin-common.js'),
 (3320, 'wp-content/plugins/updraftplus/includes/updraft-admin-common.min.js'),
 (3321, 'wp-content/plugins/updraftplus/includes/updraft-notices.php'),
 (3322, 'wp-content/plugins/updraftplus/includes/updraft-restorer-skin-compatibility.php'),
 (3323, 'wp-content/plugins/updraftplus/includes/updraft-restorer-skin.php'),
 (3324, 'wp-content/plugins/updraftplus/includes/updraftcentral.php'),
 (3325, 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-auto-login.php'),
 (3326, 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-dash-notice.php'),
 (3327, 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-restore.php'),
 (3328, 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-status.php'),
 (3329, 'wp-content/plugins/updraftplus/includes/updraftclone/temporary-clone-user-notice.php'),
 (3330, 'wp-content/plugins/updraftplus/includes/updraftplus-clone.php'),
 (3331, 'wp-content/plugins/updraftplus/includes/updraftplus-login.php'),
 (3332, 'wp-content/plugins/updraftplus/includes/updraftplus-notices.php'),
 (3333, 'wp-content/plugins/updraftplus/includes/updraftplus-tour.php'),
 (3334, 'wp-content/plugins/updraftplus/includes/updraftvault.php'),
 (3335, 'wp-content/plugins/updraftplus/index.html'),
 (3336, 'wp-content/plugins/updraftplus/js/tour.js'),
 (3337, 'wp-content/plugins/updraftplus/js/tour.min.js'),
 (3338, 'wp-content/plugins/updraftplus/js/updraft-admin-restore.js'),
 (3339, 'wp-content/plugins/updraftplus/js/updraft-admin-restore.min.js'),
 (3340, 'wp-content/plugins/updraftplus/languages/updraftplus-af.mo'),
 (3341, 'wp-content/plugins/updraftplus/languages/updraftplus-af.po'),
 (3342, 'wp-content/plugins/updraftplus/languages/updraftplus-ar.mo'),
 (3343, 'wp-content/plugins/updraftplus/languages/updraftplus-ar.po'),
 (3344, 'wp-content/plugins/updraftplus/languages/updraftplus-bg_BG.mo'),
 (3345, 'wp-content/plugins/updraftplus/languages/updraftplus-bg_BG.po'),
 (3346, 'wp-content/plugins/updraftplus/languages/updraftplus-bn_BD.mo'),
 (3347, 'wp-content/plugins/updraftplus/languages/updraftplus-bn_BD.po'),
 (3348, 'wp-content/plugins/updraftplus/languages/updraftplus-bs_BA.mo'),
 (3349, 'wp-content/plugins/updraftplus/languages/updraftplus-bs_BA.po'),
 (3350, 'wp-content/plugins/updraftplus/languages/updraftplus-ca.mo'),
 (3351, 'wp-content/plugins/updraftplus/languages/updraftplus-ca.po'),
 (3352, 'wp-content/plugins/updraftplus/languages/updraftplus-da_DK.mo'),
 (3353, 'wp-content/plugins/updraftplus/languages/updraftplus-da_DK.po'),
 (3354, 'wp-content/plugins/updraftplus/languages/updraftplus-el.mo'),
 (3355, 'wp-content/plugins/updraftplus/languages/updraftplus-el.po'),
 (3356, 'wp-content/plugins/updraftplus/languages/updraftplus-es_AR.mo'),
 (3357, 'wp-content/plugins/updraftplus/languages/updraftplus-es_AR.po'),
 (3358, 'wp-content/plugins/updraftplus/languages/updraftplus-es_CO.mo'),
 (3359, 'wp-content/plugins/updraftplus/languages/updraftplus-es_CO.po'),
 (3360, 'wp-content/plugins/updraftplus/languages/updraftplus-es_MX.mo'),
 (3361, 'wp-content/plugins/updraftplus/languages/updraftplus-es_MX.po'),
 (3362, 'wp-content/plugins/updraftplus/languages/updraftplus-es_VE.mo'),
 (3363, 'wp-content/plugins/updraftplus/languages/updraftplus-es_VE.po'),
 (3364, 'wp-content/plugins/updraftplus/languages/updraftplus-eu.mo'),
 (3365, 'wp-content/plugins/updraftplus/languages/updraftplus-eu.po'),
 (3366, 'wp-content/plugins/updraftplus/languages/updraftplus-fa_IR.mo'),
 (3367, 'wp-content/plugins/updraftplus/languages/updraftplus-fa_IR.po'),
 (3368, 'wp-content/plugins/updraftplus/languages/updraftplus-fi.mo'),
 (3369, 'wp-content/plugins/updraftplus/languages/updraftplus-fi.po'),
 (3370, 'wp-content/plugins/updraftplus/languages/updraftplus-fr_CA.mo'),
 (3371, 'wp-content/plugins/updraftplus/languages/updraftplus-fr_CA.po'),
 (3372, 'wp-content/plugins/updraftplus/languages/updraftplus-he_IL.mo'),
 (3373, 'wp-content/plugins/updraftplus/languages/updraftplus-he_IL.po'),
 (3374, 'wp-content/plugins/updraftplus/languages/updraftplus-hi_IN.mo'),
 (3375, 'wp-content/plugins/updraftplus/languages/updraftplus-hi_IN.po'),
 (3376, 'wp-content/plugins/updraftplus/languages/updraftplus-hu_HU.mo'),
 (3377, 'wp-content/plugins/updraftplus/languages/updraftplus-hu_HU.po'),
 (3378, 'wp-content/plugins/updraftplus/languages/updraftplus-id_ID.mo'),
 (3379, 'wp-content/plugins/updraftplus/languages/updraftplus-id_ID.po'),
 (3380, 'wp-content/plugins/updraftplus/languages/updraftplus-ja.mo'),
 (3381, 'wp-content/plugins/updraftplus/languages/updraftplus-ja.po'),
 (3382, 'wp-content/plugins/updraftplus/languages/updraftplus-ko_KR.mo'),
 (3383, 'wp-content/plugins/updraftplus/languages/updraftplus-ko_KR.po'),
 (3384, 'wp-content/plugins/updraftplus/languages/updraftplus-lt_LT.mo'),
 (3385, 'wp-content/plugins/updraftplus/languages/updraftplus-lt_LT.po'),
 (3386, 'wp-content/plugins/updraftplus/languages/updraftplus-nl_NL.mo'),
 (3387, 'wp-content/plugins/updraftplus/languages/updraftplus-nl_NL.po'),
 (3388, 'wp-content/plugins/updraftplus/languages/updraftplus-no.mo'),
 (3389, 'wp-content/plugins/updraftplus/languages/updraftplus-no.po'),
 (3390, 'wp-content/plugins/updraftplus/languages/updraftplus-pt_BR.mo'),
 (3391, 'wp-content/plugins/updraftplus/languages/updraftplus-pt_BR.po'),
 (3392, 'wp-content/plugins/updraftplus/languages/updraftplus-ru_RU.mo'),
 (3393, 'wp-content/plugins/updraftplus/languages/updraftplus-ru_RU.po'),
 (3394, 'wp-content/plugins/updraftplus/languages/updraftplus-sk_SK.mo'),
 (3395, 'wp-content/plugins/updraftplus/languages/updraftplus-sk_SK.po'),
 (3396, 'wp-content/plugins/updraftplus/languages/updraftplus-sl_SI.mo'),
 (3397, 'wp-content/plugins/updraftplus/languages/updraftplus-sl_SI.po'),
 (3398, 'wp-content/plugins/updraftplus/languages/updraftplus-sr_RS.mo'),
 (3399, 'wp-content/plugins/updraftplus/languages/updraftplus-sr_RS.po'),
 (3400, 'wp-content/plugins/updraftplus/languages/updraftplus-te.mo'),
 (3401, 'wp-content/plugins/updraftplus/languages/updraftplus-te.po'),
 (3402, 'wp-content/plugins/updraftplus/languages/updraftplus-th.mo'),
 (3403, 'wp-content/plugins/updraftplus/languages/updraftplus-th.po'),
 (3404, 'wp-content/plugins/updraftplus/languages/updraftplus-tl.mo'),
 (3405, 'wp-content/plugins/updraftplus/languages/updraftplus-tl.po'),
 (3406, 'wp-content/plugins/updraftplus/languages/updraftplus-tr_TR.mo'),
 (3407, 'wp-content/plugins/updraftplus/languages/updraftplus-tr_TR.po'),
 (3408, 'wp-content/plugins/updraftplus/languages/updraftplus-ur.mo'),
 (3409, 'wp-content/plugins/updraftplus/languages/updraftplus-ur.po'),
 (3410, 'wp-content/plugins/updraftplus/languages/updraftplus-vi.mo'),
 (3411, 'wp-content/plugins/updraftplus/languages/updraftplus-vi.po'),
 (3412, 'wp-content/plugins/updraftplus/languages/updraftplus-zh_CN.mo'),
 (3413, 'wp-content/plugins/updraftplus/languages/updraftplus-zh_CN.po'),
 (3414, 'wp-content/plugins/updraftplus/languages/updraftplus-zh_HK.mo'),
 (3415, 'wp-content/plugins/updraftplus/languages/updraftplus-zh_HK.po'),
 (3416, 'wp-content/plugins/updraftplus/languages/updraftplus-zh_TW.mo'),
 (3417, 'wp-content/plugins/updraftplus/languages/updraftplus-zh_TW.po'),
 (3418, 'wp-content/plugins/updraftplus/languages/updraftplus.pot'),
 (3419, 'wp-content/plugins/updraftplus/methods/addon-base-v2.php'),
 (3420, 'wp-content/plugins/updraftplus/methods/addon-not-yet-present.php'),
 (3421, 'wp-content/plugins/updraftplus/methods/azure.php'),
 (3422, 'wp-content/plugins/updraftplus/methods/backblaze.php'),
 (3423, 'wp-content/plugins/updraftplus/methods/backup-module.php'),
 (3424, 'wp-content/plugins/updraftplus/methods/cloudfiles-new.php'),
 (3425, 'wp-content/plugins/updraftplus/methods/cloudfiles.php'),
 (3426, 'wp-content/plugins/updraftplus/methods/dreamobjects.php'),
 (3427, 'wp-content/plugins/updraftplus/methods/dropbox.php'),
 (3428, 'wp-content/plugins/updraftplus/methods/email.php'),
 (3429, 'wp-content/plugins/updraftplus/methods/ftp.php'),
 (3430, 'wp-content/plugins/updraftplus/methods/googlecloud.php'),
 (3431, 'wp-content/plugins/updraftplus/methods/googledrive.php'),
 (3432, 'wp-content/plugins/updraftplus/methods/insufficient.php'),
 (3433, 'wp-content/plugins/updraftplus/methods/onedrive.php'),
 (3434, 'wp-content/plugins/updraftplus/methods/openstack-base.php'),
 (3435, 'wp-content/plugins/updraftplus/methods/openstack.php'),
 (3436, 'wp-content/plugins/updraftplus/methods/openstack2.php'),
 (3437, 'wp-content/plugins/updraftplus/methods/remotesend.php'),
 (3438, 'wp-content/plugins/updraftplus/methods/s3.php'),
 (3439, 'wp-content/plugins/updraftplus/methods/s3generic.php'),
 (3440, 'wp-content/plugins/updraftplus/methods/sftp.php'),
 (3441, 'wp-content/plugins/updraftplus/methods/template.php'),
 (3442, 'wp-content/plugins/updraftplus/methods/updraftvault.php'),
 (3443, 'wp-content/plugins/updraftplus/methods/webdav.php'),
 (3444, 'wp-content/plugins/updraftplus/options.php'),
 (3445, 'wp-content/plugins/updraftplus/readme.txt'),
 (3446, 'wp-content/plugins/updraftplus/restorer.php'),
 (3447, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/advanced-tools.php'),
 (3448, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/export-settings.php'),
 (3449, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/lock-admin.php'),
 (3450, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/search-replace.php'),
 (3451, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/site-info.php'),
 (3452, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/tools-menu.php'),
 (3453, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/total-size.php'),
 (3454, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/updraftcentral.php'),
 (3455, 'wp-content/plugins/updraftplus/templates/wp-admin/advanced/wipe-settings.php'),
 (3456, 'wp-content/plugins/updraftplus/templates/wp-admin/notices/autobackup-notice.php'),
 (3457, 'wp-content/plugins/updraftplus/templates/wp-admin/notices/bottom-notice.php'),
 (3458, 'wp-content/plugins/updraftplus/templates/wp-admin/notices/horizontal-notice.php'),
 (3459, 'wp-content/plugins/updraftplus/templates/wp-admin/notices/report-plain.php'),
 (3460, 'wp-content/plugins/updraftplus/templates/wp-admin/notices/report.php'),
 (3461, 'wp-content/plugins/updraftplus/templates/wp-admin/notices/thanks-for-using-main-dash.php'),
 (3462, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/backupnow-modal.php'),
 (3463, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/delete-and-restore-modals.php'),
 (3464, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/downloading-and-restoring.php'),
 (3465, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/exclude-modal.php'),
 (3466, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-heading.php'),
 (3467, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-submit.php'),
 (3468, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/existing-backups-table.php'),
 (3469, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/file-backup-exclude.php'),
 (3470, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/footer.php'),
 (3471, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/form-contents.php'),
 (3472, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/header.php'),
 (3473, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/migrator-no-migrator.php'),
 (3474, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/tab-addons.php'),
 (3475, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/tab-backups.php'),
 (3476, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/tab-bar.php'),
 (3477, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/take-backup.php'),
 (3478, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/temporary-clone.php'),
 (3479, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/updraftcentral-connect.php'),
 (3480, 'wp-content/plugins/updraftplus/templates/wp-admin/settings/upload-backups-modal.php'),
 (3481, 'wp-content/plugins/updraftplus/updraftplus.php'),
 (3482, 'wp-content/plugins/updraftplus/vendor/autoload.php'),
 (3483, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/LICENSE.md'),
 (3484, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/NOTICE.md'),
 (3485, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/composer.json'),
 (3486, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Aws.php'),
 (3487, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AbstractClient.php'),
 (3488, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AwsClientInterface.php'),
 (3489, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ClientBuilder.php'),
 (3490, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/DefaultClient.php'),
 (3491, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ExpiredCredentialsChecker.php'),
 (3492, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ThrottlingErrorChecker.php'),
 (3493, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UploadBodyListener.php'),
 (3494, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UserAgentListener.php'),
 (3495, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/AwsQueryVisitor.php'),
 (3496, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/JsonCommand.php'),
 (3497, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/QueryCommand.php'),
 (3498, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/XmlResponseLocationVisitor.php'),
 (3499, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractCredentialsDecorator.php'),
 (3500, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractRefreshableCredentials.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(3501, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CacheableCredentials.php'),
 (3502, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/Credentials.php'),
 (3503, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CredentialsInterface.php'),
 (3504, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/NullCredentials.php'),
 (3505, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php'),
 (3506, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/ClientOptions.php'),
 (3507, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/DateFormat.php'),
 (3508, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Region.php'),
 (3509, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Size.php'),
 (3510, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Time.php'),
 (3511, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/UaString.php'),
 (3512, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum.php'),
 (3513, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/AwsExceptionInterface.php'),
 (3514, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/BadMethodCallException.php'),
 (3515, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/DomainException.php'),
 (3516, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionFactoryInterface.php'),
 (3517, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionListener.php'),
 (3518, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InstanceProfileCredentialsException.php'),
 (3519, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InvalidArgumentException.php'),
 (3520, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/LogicException.php'),
 (3521, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/MultipartUploadException.php'),
 (3522, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/NamespaceExceptionFactory.php'),
 (3523, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OutOfBoundsException.php'),
 (3524, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OverflowException.php'),
 (3525, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php'),
 (3526, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php'),
 (3527, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/ExceptionParserInterface.php'),
 (3528, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php'),
 (3529, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonRestExceptionParser.php'),
 (3530, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RequiredExtensionNotLoadedException.php'),
 (3531, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RuntimeException.php'),
 (3532, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ServiceResponseException.php'),
 (3533, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/TransferException.php'),
 (3534, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/UnexpectedValueException.php'),
 (3535, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/Facade.php'),
 (3536, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/FacadeInterface.php'),
 (3537, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/facade-classes.php'),
 (3538, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHash.php'),
 (3539, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHashInterface.php'),
 (3540, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/HashUtils.php'),
 (3541, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/TreeHash.php'),
 (3542, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/HostNameUtils.php'),
 (3543, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/InstanceMetadataClient.php'),
 (3544, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php'),
 (3545, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIterator.php'),
 (3546, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIteratorFactory.php'),
 (3547, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransfer.php'),
 (3548, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransferState.php'),
 (3549, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php'),
 (3550, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadId.php'),
 (3551, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php'),
 (3552, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferInterface.php'),
 (3553, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferStateInterface.php'),
 (3554, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadIdInterface.php'),
 (3555, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadPartInterface.php'),
 (3556, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/aws-config.php'),
 (3557, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/public-endpoints.php'),
 (3558, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/sdk1-config.php'),
 (3559, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/RulesEndpointProvider.php'),
 (3560, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/AbstractSignature.php'),
 (3561, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/EndpointSignatureInterface.php'),
 (3562, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureInterface.php'),
 (3563, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureListener.php'),
 (3564, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV2.php'),
 (3565, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV3Https.php'),
 (3566, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV4.php'),
 (3567, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractResourceWaiter.php'),
 (3568, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractWaiter.php'),
 (3569, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CallableWaiter.php'),
 (3570, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CompositeWaiterFactory.php'),
 (3571, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ConfigResourceWaiter.php'),
 (3572, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ResourceWaiterInterface.php'),
 (3573, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterClassFactory.php'),
 (3574, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfig.php'),
 (3575, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfigFactory.php'),
 (3576, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterFactoryInterface.php'),
 (3577, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterInterface.php'),
 (3578, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/AcpListener.php'),
 (3579, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/BucketStyleListener.php'),
 (3580, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Command/S3Command.php'),
 (3581, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/CannedAcl.php'),
 (3582, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/EncodingType.php'),
 (3583, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Event.php'),
 (3584, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/GranteeType.php'),
 (3585, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Group.php'),
 (3586, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MFADelete.php'),
 (3587, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MetadataDirective.php'),
 (3588, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Payer.php'),
 (3589, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Permission.php'),
 (3590, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Protocol.php'),
 (3591, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/ServerSideEncryption.php'),
 (3592, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Status.php'),
 (3593, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Storage.php'),
 (3594, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/StorageClass.php'),
 (3595, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccessDeniedException.php'),
 (3596, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccountProblemException.php'),
 (3597, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php'),
 (3598, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BadDigestException.php'),
 (3599, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyExistsException.php'),
 (3600, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php'),
 (3601, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketNotEmptyException.php'),
 (3602, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CredentialsNotSupportedException.php'),
 (3603, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php'),
 (3604, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/DeleteMultipleObjectsException.php'),
 (3605, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooLargeException.php'),
 (3606, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooSmallException.php'),
 (3607, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ExpiredTokenException.php'),
 (3608, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IllegalVersioningConfigurationException.php'),
 (3609, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncompleteBodyException.php'),
 (3610, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php'),
 (3611, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InlineDataTooLargeException.php'),
 (3612, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InternalErrorException.php'),
 (3613, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAccessKeyIdException.php'),
 (3614, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAddressingHeaderException.php'),
 (3615, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidArgumentException.php'),
 (3616, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketNameException.php'),
 (3617, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketStateException.php'),
 (3618, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidDigestException.php'),
 (3619, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidLocationConstraintException.php'),
 (3620, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartException.php'),
 (3621, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartOrderException.php'),
 (3622, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPayerException.php'),
 (3623, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPolicyDocumentException.php'),
 (3624, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRangeException.php'),
 (3625, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRequestException.php'),
 (3626, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSOAPRequestException.php'),
 (3627, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSecurityException.php'),
 (3628, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidStorageClassException.php'),
 (3629, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTagErrorException.php'),
 (3630, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php'),
 (3631, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTokenException.php'),
 (3632, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidURIException.php'),
 (3633, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/KeyTooLongException.php'),
 (3634, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedACLErrorException.php'),
 (3635, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedPOSTRequestException.php'),
 (3636, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedXMLException.php'),
 (3637, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxMessageLengthExceededException.php'),
 (3638, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php'),
 (3639, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MetadataTooLargeException.php'),
 (3640, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MethodNotAllowedException.php'),
 (3641, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingAttachmentException.php'),
 (3642, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingContentLengthException.php'),
 (3643, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingRequestBodyErrorException.php'),
 (3644, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityElementException.php'),
 (3645, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityHeaderException.php'),
 (3646, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoLoggingStatusForKeyException.php'),
 (3647, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketException.php'),
 (3648, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketPolicyException.php'),
 (3649, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchCORSConfigurationException.php'),
 (3650, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchKeyException.php'),
 (3651, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php'),
 (3652, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetErrorException.php'),
 (3653, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetException.php'),
 (3654, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchUploadException.php'),
 (3655, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchVersionException.php'),
 (3656, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php'),
 (3657, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotImplementedException.php'),
 (3658, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSignedUpException.php'),
 (3659, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSuchBucketPolicyException.php'),
 (3660, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php'),
 (3661, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php'),
 (3662, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/OperationAbortedException.php'),
 (3663, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/Parser/S3ExceptionParser.php'),
 (3664, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PermanentRedirectException.php'),
 (3665, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PreconditionFailedException.php'),
 (3666, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RedirectException.php'),
 (3667, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestIsNotMultiPartContentException.php'),
 (3668, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeTooSkewedException.php'),
 (3669, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeoutException.php'),
 (3670, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php'),
 (3671, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/S3Exception.php'),
 (3672, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ServiceUnavailableException.php'),
 (3673, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SignatureDoesNotMatchException.php'),
 (3674, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SlowDownException.php'),
 (3675, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TemporaryRedirectException.php'),
 (3676, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TokenRefreshRequiredException.php'),
 (3677, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TooManyBucketsException.php'),
 (3678, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnexpectedContentException.php'),
 (3679, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php'),
 (3680, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php'),
 (3681, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/IncompleteMultipartUploadChecker.php'),
 (3682, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListBucketsIterator.php'),
 (3683, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListMultipartUploadsIterator.php'),
 (3684, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectVersionsIterator.php'),
 (3685, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectsIterator.php'),
 (3686, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/OpendirIterator.php'),
 (3687, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Acp.php'),
 (3688, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/AcpBuilder.php'),
 (3689, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/ClearBucket.php'),
 (3690, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsBatch.php'),
 (3691, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsTransfer.php'),
 (3692, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grant.php'),
 (3693, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grantee.php'),
 (3694, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/AbstractTransfer.php'),
 (3695, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/ParallelTransfer.php'),
 (3696, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/SerialTransfer.php'),
 (3697, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/TransferState.php'),
 (3698, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadBuilder.php'),
 (3699, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadId.php'),
 (3700, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadPart.php'),
 (3701, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/PostObject.php'),
 (3702, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Resources/s3-2006-03-01.php'),
 (3703, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/ResumableDownload.php'),
 (3704, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Client.php'),
 (3705, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Md5Listener.php'),
 (3706, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Signature.php'),
 (3707, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureInterface.php'),
 (3708, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureV4.php'),
 (3709, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SocketTimeoutChecker.php'),
 (3710, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SseCpkListener.php'),
 (3711, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/StreamWrapper.php'),
 (3712, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSync.php'),
 (3713, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSyncBuilder.php'),
 (3714, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/ChangedFilesIterator.php'),
 (3715, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSync.php'),
 (3716, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSyncBuilder.php'),
 (3717, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/FilenameConverterInterface.php'),
 (3718, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/KeyConverter.php'),
 (3719, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSync.php'),
 (3720, 'wp-content/plugins/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSyncBuilder.php'),
 (3721, 'wp-content/plugins/updraftplus/vendor/composer/ClassLoader.php'),
 (3722, 'wp-content/plugins/updraftplus/vendor/composer/LICENSE'),
 (3723, 'wp-content/plugins/updraftplus/vendor/composer/autoload_classmap.php'),
 (3724, 'wp-content/plugins/updraftplus/vendor/composer/autoload_files.php'),
 (3725, 'wp-content/plugins/updraftplus/vendor/composer/autoload_namespaces.php'),
 (3726, 'wp-content/plugins/updraftplus/vendor/composer/autoload_psr4.php'),
 (3727, 'wp-content/plugins/updraftplus/vendor/composer/autoload_real.php'),
 (3728, 'wp-content/plugins/updraftplus/vendor/composer/autoload_static.php'),
 (3729, 'wp-content/plugins/updraftplus/vendor/composer/include_paths.php'),
 (3730, 'wp-content/plugins/updraftplus/vendor/composer/installed.json'),
 (3731, 'wp-content/plugins/updraftplus/vendor/eher/oauth/README.md'),
 (3732, 'wp-content/plugins/updraftplus/vendor/eher/oauth/composer.json'),
 (3733, 'wp-content/plugins/updraftplus/vendor/eher/oauth/phpunit.xml.dist'),
 (3734, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Consumer.php'),
 (3735, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/HmacSha1.php'),
 (3736, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthDataStore.php'),
 (3737, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthException.php'),
 (3738, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthServer.php'),
 (3739, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/PlainText.php'),
 (3740, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Request.php'),
 (3741, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/RsaSha1.php'),
 (3742, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/SignatureMethod.php'),
 (3743, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Token.php'),
 (3744, 'wp-content/plugins/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Util.php'),
 (3745, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/CHANGELOG.md'),
 (3746, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/LICENSE'),
 (3747, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/README.md'),
 (3748, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/UPGRADING.md'),
 (3749, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/build.xml'),
 (3750, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/composer.json'),
 (3751, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/phar-stub.php'),
 (3752, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/phpunit.xml.dist'),
 (3753, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/AbstractBatchDecorator.php'),
 (3754, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Batch.php'),
 (3755, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchBuilder.php'),
 (3756, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureDivisor.php'),
 (3757, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureTransfer.php'),
 (3758, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchCommandTransfer.php'),
 (3759, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchDivisorInterface.php'),
 (3760, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchInterface.php'),
 (3761, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchRequestTransfer.php'),
 (3762, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchSizeDivisor.php'),
 (3763, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchTransferInterface.php'),
 (3764, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Exception/BatchTransferException.php'),
 (3765, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/ExceptionBufferingBatch.php'),
 (3766, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/FlushingBatch.php'),
 (3767, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/HistoryBatch.php'),
 (3768, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/NotifyingBatch.php'),
 (3769, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/composer.json'),
 (3770, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/AbstractCacheAdapter.php'),
 (3771, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterFactory.php'),
 (3772, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterInterface.php'),
 (3773, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/ClosureCacheAdapter.php'),
 (3774, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/DoctrineCacheAdapter.php'),
 (3775, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/NullCacheAdapter.php'),
 (3776, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf1CacheAdapter.php'),
 (3777, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf2CacheAdapter.php'),
 (3778, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/composer.json'),
 (3779, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/AbstractHasDispatcher.php'),
 (3780, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Collection.php'),
 (3781, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Event.php'),
 (3782, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/BadMethodCallException.php'),
 (3783, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/ExceptionCollection.php'),
 (3784, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/GuzzleException.php'),
 (3785, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/InvalidArgumentException.php'),
 (3786, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/RuntimeException.php'),
 (3787, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/UnexpectedValueException.php'),
 (3788, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/FromConfigInterface.php'),
 (3789, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/HasDispatcherInterface.php'),
 (3790, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/ToArrayInterface.php'),
 (3791, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Version.php'),
 (3792, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/composer.json'),
 (3793, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/AbstractEntityBodyDecorator.php'),
 (3794, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/CachingEntityBody.php'),
 (3795, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Client.php'),
 (3796, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ClientInterface.php'),
 (3797, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlHandle.php'),
 (3798, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMulti.php'),
 (3799, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiInterface.php'),
 (3800, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiProxy.php'),
 (3801, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlVersion.php'),
 (3802, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/RequestMediator.php'),
 (3803, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBody.php'),
 (3804, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBodyInterface.php'),
 (3805, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/BadResponseException.php'),
 (3806, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ClientErrorResponseException.php'),
 (3807, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CouldNotRewindStreamException.php'),
 (3808, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CurlException.php'),
 (3809, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/HttpException.php'),
 (3810, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/MultiTransferException.php'),
 (3811, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/RequestException.php'),
 (3812, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ServerErrorResponseException.php'),
 (3813, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/TooManyRedirectsException.php'),
 (3814, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/IoEmittingEntityBody.php'),
 (3815, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/AbstractMessage.php'),
 (3816, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequest.php'),
 (3817, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequestInterface.php'),
 (3818, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/CacheControl.php'),
 (3819, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderCollection.php'),
 (3820, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactory.php'),
 (3821, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactoryInterface.php'),
 (3822, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderInterface.php'),
 (3823, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/Link.php'),
 (3824, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header.php'),
 (3825, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/MessageInterface.php'),
 (3826, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFile.php'),
 (3827, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFileInterface.php'),
 (3828, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Request.php'),
 (3829, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactory.php'),
 (3830, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactoryInterface.php'),
 (3831, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestInterface.php'),
 (3832, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Response.php'),
 (3833, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Mimetypes.php'),
 (3834, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/CommaAggregator.php'),
 (3835, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/DuplicateAggregator.php'),
 (3836, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/PhpAggregator.php'),
 (3837, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php'),
 (3838, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryString.php'),
 (3839, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ReadLimitEntityBody.php'),
 (3840, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/RedirectPlugin.php'),
 (3841, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Resources/cacert.pem'),
 (3842, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/StaticClient.php'),
 (3843, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Url.php'),
 (3844, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/composer.json'),
 (3845, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/Inflector.php'),
 (3846, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/InflectorInterface.php'),
 (3847, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/MemoizingInflector.php'),
 (3848, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/PreComputedInflector.php'),
 (3849, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/composer.json'),
 (3850, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/AppendIterator.php'),
 (3851, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/ChunkedIterator.php'),
 (3852, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/FilterIterator.php'),
 (3853, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MapIterator.php'),
 (3854, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MethodProxyIterator.php'),
 (3855, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/README.md'),
 (3856, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/composer.json'),
 (3857, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/AbstractLogAdapter.php'),
 (3858, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ArrayLogAdapter.php'),
 (3859, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ClosureLogAdapter.php'),
 (3860, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/LogAdapterInterface.php'),
 (3861, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MessageFormatter.php'),
 (3862, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MonologLogAdapter.php'),
 (3863, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/PsrLogAdapter.php'),
 (3864, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf1LogAdapter.php'),
 (3865, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf2LogAdapter.php'),
 (3866, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/composer.json'),
 (3867, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParser.php'),
 (3868, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParserInterface.php'),
 (3869, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/AbstractMessageParser.php'),
 (3870, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParser.php'),
 (3871, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParserInterface.php'),
 (3872, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/PeclHttpMessageParser.php'),
 (3873, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/ParserRegistry.php'),
 (3874, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/PeclUriTemplate.php'),
 (3875, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplate.php'),
 (3876, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplateInterface.php'),
 (3877, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParser.php'),
 (3878, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParserInterface.php'),
 (3879, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/composer.json'),
 (3880, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Async/AsyncPlugin.php'),
 (3881, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Async/composer.json'),
 (3882, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php'),
 (3883, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php'),
 (3884, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffLogger.php'),
 (3885, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffPlugin.php'),
 (3886, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php'),
 (3887, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php'),
 (3888, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php'),
 (3889, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php'),
 (3890, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php'),
 (3891, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php'),
 (3892, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php'),
 (3893, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php'),
 (3894, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php'),
 (3895, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/composer.json'),
 (3896, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheKeyProviderInterface.php'),
 (3897, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CachePlugin.php'),
 (3898, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheStorageInterface.php'),
 (3899, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CallbackCanCacheStrategy.php'),
 (3900, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CanCacheStrategyInterface.php'),
 (3901, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheKeyProvider.php'),
 (3902, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheStorage.php'),
 (3903, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCanCacheStrategy.php'),
 (3904, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultRevalidation.php'),
 (3905, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DenyRevalidation.php'),
 (3906, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/RevalidationInterface.php'),
 (3907, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/SkipRevalidation.php'),
 (3908, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/composer.json'),
 (3909, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Cookie.php'),
 (3910, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/ArrayCookieJar.php'),
 (3911, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/CookieJarInterface.php'),
 (3912, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/FileCookieJar.php'),
 (3913, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookiePlugin.php'),
 (3914, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Exception/InvalidCookieException.php'),
 (3915, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/composer.json'),
 (3916, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/CurlAuth/CurlAuthPlugin.php'),
 (3917, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/CurlAuth/composer.json'),
 (3918, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponseExceptionInterface.php'),
 (3919, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponsePlugin.php'),
 (3920, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/Exception/ErrorResponseException.php'),
 (3921, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/composer.json'),
 (3922, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/History/HistoryPlugin.php'),
 (3923, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/History/composer.json'),
 (3924, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Log/LogPlugin.php'),
 (3925, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Log/composer.json'),
 (3926, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/CommandContentMd5Plugin.php'),
 (3927, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/Md5ValidatorPlugin.php'),
 (3928, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/composer.json'),
 (3929, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Mock/MockPlugin.php'),
 (3930, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Mock/composer.json'),
 (3931, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Oauth/OauthPlugin.php'),
 (3932, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Oauth/composer.json'),
 (3933, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/composer.json'),
 (3934, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/AbstractConfigLoader.php'),
 (3935, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilder.php'),
 (3936, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderInterface.php'),
 (3937, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderLoader.php'),
 (3938, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/CachingConfigLoader.php'),
 (3939, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Client.php'),
 (3940, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ClientInterface.php'),
 (3941, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/AbstractCommand.php'),
 (3942, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ClosureCommand.php'),
 (3943, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CommandInterface.php'),
 (3944, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CreateResponseClassEvent.php'),
 (3945, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultRequestSerializer.php'),
 (3946, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultResponseParser.php'),
 (3947, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/AliasFactory.php'),
 (3948, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/CompositeFactory.php'),
 (3949, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ConcreteClassFactory.php'),
 (3950, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/FactoryInterface.php'),
 (3951, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/MapFactory.php'),
 (3952, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php'),
 (3953, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php'),
 (3954, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php'),
 (3955, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php'),
 (3956, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php'),
 (3957, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php'),
 (3958, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php'),
 (3959, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php'),
 (3960, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php'),
 (3961, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php'),
 (3962, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php'),
 (3963, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php'),
 (3964, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php'),
 (3965, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php'),
 (3966, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php'),
 (3967, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php'),
 (3968, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php'),
 (3969, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php'),
 (3970, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php'),
 (3971, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php'),
 (3972, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationCommand.php'),
 (3973, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationResponseParser.php'),
 (3974, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/RequestSerializerInterface.php'),
 (3975, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseClassInterface.php'),
 (3976, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseParserInterface.php'),
 (3977, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ConfigLoaderInterface.php'),
 (3978, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Operation.php'),
 (3979, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/OperationInterface.php'),
 (3980, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Parameter.php'),
 (3981, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaFormatter.php'),
 (3982, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaValidator.php'),
 (3983, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescription.php'),
 (3984, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionInterface.php'),
 (3985, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionLoader.php'),
 (3986, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ValidatorInterface.php'),
 (3987, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandException.php'),
 (3988, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandTransferException.php'),
 (3989, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/DescriptionBuilderException.php'),
 (3990, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/InconsistentClientTransferException.php'),
 (3991, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ResponseClassException.php'),
 (3992, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceBuilderException.php'),
 (3993, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceNotFoundException.php'),
 (3994, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ValidationException.php'),
 (3995, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php'),
 (3996, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php'),
 (3997, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/MapResourceIteratorFactory.php'),
 (3998, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/Model.php'),
 (3999, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIterator.php'),
 (4000, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(4001, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorClassFactory.php'),
 (4002, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php'),
 (4003, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorInterface.php'),
 (4004, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/composer.json'),
 (4005, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/PhpStreamRequestFactory.php'),
 (4006, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/Stream.php'),
 (4007, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamInterface.php'),
 (4008, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamRequestFactoryInterface.php'),
 (4009, 'wp-content/plugins/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/composer.json'),
 (4010, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/CHANGELOG-1.0.md'),
 (4011, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/CHANGELOG-1.1.md'),
 (4012, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/CHANGELOG-1.2.md'),
 (4013, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/Gemfile'),
 (4014, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/LICENSE'),
 (4015, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/README.md'),
 (4016, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/composer.json'),
 (4017, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/package.json'),
 (4018, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCache.php'),
 (4019, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollection.php'),
 (4020, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollectionInterface.php'),
 (4021, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetInterface.php'),
 (4022, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetReference.php'),
 (4023, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/BaseAsset.php'),
 (4024, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/FileAsset.php'),
 (4025, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/GlobAsset.php'),
 (4026, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/HttpAsset.php'),
 (4027, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionFilterIterator.php'),
 (4028, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionIterator.php'),
 (4029, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/StringAsset.php'),
 (4030, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetManager.php'),
 (4031, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetWriter.php'),
 (4032, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ApcCache.php'),
 (4033, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ArrayCache.php'),
 (4034, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/CacheInterface.php'),
 (4035, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ConfigCache.php'),
 (4036, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ExpiringCache.php'),
 (4037, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/FilesystemCache.php'),
 (4038, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/Exception.php'),
 (4039, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/FilterException.php'),
 (4040, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticExtension.php'),
 (4041, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterFunction.php'),
 (4042, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterInvoker.php'),
 (4043, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterNode.php'),
 (4044, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticNode.php'),
 (4045, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticTokenParser.php'),
 (4046, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigFormulaLoader.php'),
 (4047, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigResource.php'),
 (4048, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/ValueContainer.php'),
 (4049, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/AssetFactory.php'),
 (4050, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/LazyAssetManager.php'),
 (4051, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/BasePhpFormulaLoader.php'),
 (4052, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/CachedFormulaLoader.php'),
 (4053, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FormulaLoaderInterface.php'),
 (4054, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FunctionCallsFormulaLoader.php'),
 (4055, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/CoalescingDirectoryResource.php'),
 (4056, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/DirectoryResource.php'),
 (4057, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/FileResource.php'),
 (4058, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/IteratorResourceInterface.php'),
 (4059, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/ResourceInterface.php'),
 (4060, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/CacheBustingWorker.php'),
 (4061, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/EnsureFilterWorker.php'),
 (4062, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/WorkerInterface.php'),
 (4063, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/AutoprefixerFilter.php'),
 (4064, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseCssFilter.php'),
 (4065, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseNodeFilter.php'),
 (4066, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseProcessFilter.php'),
 (4067, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CallablesFilter.php'),
 (4068, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CleanCssFilter.php'),
 (4069, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CoffeeScriptFilter.php'),
 (4070, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CompassFilter.php'),
 (4071, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssCacheBustingFilter.php'),
 (4072, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssEmbedFilter.php'),
 (4073, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssImportFilter.php'),
 (4074, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssMinFilter.php'),
 (4075, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssRewriteFilter.php'),
 (4076, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DartFilter.php'),
 (4077, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DependencyExtractorInterface.php'),
 (4078, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/EmberPrecompileFilter.php'),
 (4079, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterCollection.php'),
 (4080, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterInterface.php'),
 (4081, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/BaseCompilerFilter.php'),
 (4082, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerApiFilter.php'),
 (4083, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerJarFilter.php'),
 (4084, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GssFilter.php'),
 (4085, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HandlebarsFilter.php'),
 (4086, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HashableInterface.php'),
 (4087, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinFilter.php'),
 (4088, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinPlusFilter.php'),
 (4089, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSqueezeFilter.php'),
 (4090, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegoptimFilter.php'),
 (4091, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegtranFilter.php'),
 (4092, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessFilter.php'),
 (4093, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessphpFilter.php'),
 (4094, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/MinifyCssCompressorFilter.php'),
 (4095, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/OptiPngFilter.php'),
 (4096, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackagerFilter.php'),
 (4097, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackerFilter.php'),
 (4098, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PhpCssEmbedFilter.php'),
 (4099, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PngoutFilter.php'),
 (4100, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ReactJsxFilter.php'),
 (4101, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/RooleFilter.php'),
 (4102, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/BaseSassFilter.php'),
 (4103, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/SassFilter.php'),
 (4104, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/ScssFilter.php'),
 (4105, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SassphpFilter.php'),
 (4106, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ScssphpFilter.php'),
 (4107, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SeparatorFilter.php'),
 (4108, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SprocketsFilter.php'),
 (4109, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/StylusFilter.php'),
 (4110, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/TypeScriptFilter.php'),
 (4111, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyCssFilter.php'),
 (4112, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJs2Filter.php'),
 (4113, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJsFilter.php'),
 (4114, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/BaseCompressorFilter.php'),
 (4115, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/CssCompressorFilter.php'),
 (4116, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/JsCompressorFilter.php'),
 (4117, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/FilterManager.php'),
 (4118, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/CssUtils.php'),
 (4119, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/FilesystemUtils.php'),
 (4120, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/LessUtils.php'),
 (4121, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/SassUtils.php'),
 (4122, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/TraversableString.php'),
 (4123, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/VarUtils.php'),
 (4124, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/ValueSupplierInterface.php'),
 (4125, 'wp-content/plugins/updraftplus/vendor/kriswallsmith/assetic/src/functions.php'),
 (4126, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/AUTHORS'),
 (4127, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/BACKERS.md'),
 (4128, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/LICENSE'),
 (4129, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/README.md'),
 (4130, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/appveyor.yml'),
 (4131, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/composer.json'),
 (4132, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/AES.php'),
 (4133, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Base.php'),
 (4134, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Blowfish.php'),
 (4135, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/DES.php'),
 (4136, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Hash.php'),
 (4137, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC2.php'),
 (4138, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC4.php'),
 (4139, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RSA.php'),
 (4140, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Random.php'),
 (4141, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Rijndael.php'),
 (4142, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/TripleDES.php'),
 (4143, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Twofish.php'),
 (4144, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ANSI.php'),
 (4145, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ASN1.php'),
 (4146, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/X509.php'),
 (4147, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Math/BigInteger.php'),
 (4148, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SCP.php'),
 (4149, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP/Stream.php'),
 (4150, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP.php'),
 (4151, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH1.php'),
 (4152, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH2.php'),
 (4153, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH/Agent.php'),
 (4154, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH_Agent.php'),
 (4155, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/bootstrap.php'),
 (4156, 'wp-content/plugins/updraftplus/vendor/phpseclib/phpseclib/phpseclib/openssl.cnf'),
 (4157, 'wp-content/plugins/updraftplus/vendor/psr/log/LICENSE'),
 (4158, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/AbstractLogger.php'),
 (4159, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/InvalidArgumentException.php'),
 (4160, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LogLevel.php'),
 (4161, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareInterface.php'),
 (4162, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareTrait.php'),
 (4163, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerInterface.php'),
 (4164, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/LoggerTrait.php'),
 (4165, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/NullLogger.php'),
 (4166, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/Test/LoggerInterfaceTest.php'),
 (4167, 'wp-content/plugins/updraftplus/vendor/psr/log/Psr/Log/Test/TestLogger.php'),
 (4168, 'wp-content/plugins/updraftplus/vendor/psr/log/README.md'),
 (4169, 'wp-content/plugins/updraftplus/vendor/psr/log/composer.json'),
 (4170, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/CONTRIBUTING.md'),
 (4171, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/LICENSE'),
 (4172, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/README.md'),
 (4173, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/apigen.neon'),
 (4174, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/composer.json'),
 (4175, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/ArrayAccess.php'),
 (4176, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Base.php'),
 (4177, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ArrayCollection.php'),
 (4178, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/PaginatedIterator.php'),
 (4179, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ResourceIterator.php'),
 (4180, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection.php'),
 (4181, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Datetime.php'),
 (4182, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Header.php'),
 (4183, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Mime.php'),
 (4184, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Service.php'),
 (4185, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Size.php'),
 (4186, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/State.php'),
 (4187, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncError.php'),
 (4188, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncHttpError.php'),
 (4189, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncTimeoutError.php'),
 (4190, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AttributeError.php'),
 (4191, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AuthenticationError.php'),
 (4192, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/BaseException.php'),
 (4193, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnError.php'),
 (4194, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnHttpError.php'),
 (4195, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnNotAvailableError.php'),
 (4196, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnTtlError.php'),
 (4197, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CollectionException.php'),
 (4198, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerCreateError.php'),
 (4199, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerDeleteError.php'),
 (4200, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerError.php'),
 (4201, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNameError.php'),
 (4202, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotEmptyError.php'),
 (4203, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotFoundError.php'),
 (4204, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateError.php'),
 (4205, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateUpdateError.php'),
 (4206, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CredentialError.php'),
 (4207, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseCreateError.php'),
 (4208, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseDeleteError.php'),
 (4209, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseListError.php'),
 (4210, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseNameError.php'),
 (4211, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseUpdateError.php'),
 (4212, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DeleteError.php'),
 (4213, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DocumentError.php'),
 (4214, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DomainError.php'),
 (4215, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EmptyResponseError.php'),
 (4216, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EndpointError.php'),
 (4217, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/FlavorError.php'),
 (4218, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ForbiddenOperationException.php'),
 (4219, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpError.php'),
 (4220, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpForbiddenError.php'),
 (4221, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpOverLimitError.php'),
 (4222, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpResponseException.php'),
 (4223, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpRetryError.php'),
 (4224, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpTimeoutError.php'),
 (4225, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUnauthorizedError.php'),
 (4226, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUrlError.php'),
 (4227, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IOError.php'),
 (4228, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IdRequiredError.php'),
 (4229, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ImageError.php'),
 (4230, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceCreateError.php'),
 (4231, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceDeleteError.php'),
 (4232, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceError.php'),
 (4233, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceFlavorError.php'),
 (4234, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceNotFound.php'),
 (4235, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceUpdateError.php'),
 (4236, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidArgumentError.php'),
 (4237, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIdTypeError.php'),
 (4238, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIpTypeError.php'),
 (4239, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidParameterError.php'),
 (4240, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidRequestError.php'),
 (4241, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidTemplateError.php'),
 (4242, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/JsonError.php'),
 (4243, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/LoggingException.php'),
 (4244, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataCreateError.php'),
 (4245, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataDeleteError.php'),
 (4246, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataError.php'),
 (4247, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataJsonError.php'),
 (4248, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataKeyError.php'),
 (4249, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataPrefixError.php'),
 (4250, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataUpdateError.php'),
 (4251, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MisMatchedChecksumError.php'),
 (4252, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MissingValueError.php'),
 (4253, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NameError.php'),
 (4254, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkCreateError.php'),
 (4255, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkDeleteError.php'),
 (4256, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkError.php'),
 (4257, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUpdateError.php'),
 (4258, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUrlError.php'),
 (4259, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoContentTypeError.php'),
 (4260, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoNameError.php'),
 (4261, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjFetchError.php'),
 (4262, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectCopyError.php'),
 (4263, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectError.php'),
 (4264, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RebuildError.php'),
 (4265, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RecordTypeError.php'),
 (4266, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceBucketException.php'),
 (4267, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceNotFoundException.php'),
 (4268, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RuntimeException.php'),
 (4269, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerActionError.php'),
 (4270, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerCreateError.php'),
 (4271, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerDeleteError.php'),
 (4272, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerImageScheduleError.php'),
 (4273, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerIpsError.php'),
 (4274, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerJsonError.php'),
 (4275, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUpdateError.php'),
 (4276, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUrlError.php'),
 (4277, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServiceException.php'),
 (4278, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/SnapshotError.php'),
 (4279, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/TempUrlMethodError.php'),
 (4280, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownError.php'),
 (4281, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownParameterError.php'),
 (4282, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnrecognizedServiceError.php'),
 (4283, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedExtensionError.php'),
 (4284, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedFeatureExtension.php'),
 (4285, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedVersionError.php'),
 (4286, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UpdateError.php'),
 (4287, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UrlError.php'),
 (4288, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserCreateError.php'),
 (4289, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserDeleteError.php'),
 (4290, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserListError.php'),
 (4291, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserNameError.php'),
 (4292, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserUpdateError.php'),
 (4293, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeError.php'),
 (4294, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeTypeError.php'),
 (4295, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Client.php'),
 (4296, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/Formatter.php'),
 (4297, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/RequestSubscriber.php'),
 (4298, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Lang.php'),
 (4299, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Log/Logger.php'),
 (4300, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Metadata.php'),
 (4301, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/PersistentObject.php'),
 (4302, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/BaseResource.php'),
 (4303, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/NovaResource.php'),
 (4304, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/PersistentResource.php'),
 (4305, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/ReadOnlyResource.php'),
 (4306, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/AbstractService.php'),
 (4307, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Catalog.php'),
 (4308, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogItem.php'),
 (4309, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogService.php'),
 (4310, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Endpoint.php'),
 (4311, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/NovaService.php'),
 (4312, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceBuilder.php'),
 (4313, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceInterface.php'),
 (4314, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Constants/User.php'),
 (4315, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Role.php'),
 (4316, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Tenant.php'),
 (4317, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Token.php'),
 (4318, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/User.php'),
 (4319, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Service.php'),
 (4320, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/AbstractService.php'),
 (4321, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/CDNService.php'),
 (4322, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/Header.php'),
 (4323, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/UrlType.php'),
 (4324, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Enum/ReturnType.php'),
 (4325, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/BulkOperationException.php'),
 (4326, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ContainerException.php'),
 (4327, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ObjectNotFoundException.php'),
 (4328, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/StreamException.php'),
 (4329, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/UploadException.php'),
 (4330, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractContainer.php'),
 (4331, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractResource.php'),
 (4332, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Account.php'),
 (4333, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/CDNContainer.php'),
 (4334, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Container.php'),
 (4335, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/ContainerMetadata.php'),
 (4336, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/DataObject.php'),
 (4337, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Service.php'),
 (4338, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/AbstractTransfer.php'),
 (4339, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConcurrentTransfer.php'),
 (4340, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConsecutiveTransfer.php'),
 (4341, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ContainerMigration.php'),
 (4342, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/DirectorySync.php'),
 (4343, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferBuilder.php'),
 (4344, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferPart.php'),
 (4345, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferState.php'),
 (4346, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/OpenStack.php'),
 (4347, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Rackspace.php'),
 (4348, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Version.php'),
 (4349, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/lib/php-opencloud.php'),
 (4350, 'wp-content/plugins/updraftplus/vendor/rackspace/php-opencloud/phpunit.xml.dist'),
 (4351, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/CHANGELOG.md'),
 (4352, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/ContainerAwareEventDispatcher.php'),
 (4353, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcher.php'),
 (4354, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcherInterface.php'),
 (4355, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Debug/WrappedListener.php'),
 (4356, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/DependencyInjection/RegisterListenersPass.php'),
 (4357, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/Event.php'),
 (4358, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/EventDispatcher.php'),
 (4359, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/EventDispatcherInterface.php'),
 (4360, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/EventSubscriberInterface.php'),
 (4361, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/GenericEvent.php'),
 (4362, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/ImmutableEventDispatcher.php'),
 (4363, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/LICENSE'),
 (4364, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/README.md'),
 (4365, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/composer.json'),
 (4366, 'wp-content/plugins/updraftplus/vendor/symfony/event-dispatcher/phpunit.xml.dist'),
 (4367, 'wp-content/plugins/updraftplus/vendor/symfony/process/CHANGELOG.md'),
 (4368, 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/ExceptionInterface.php'),
 (4369, 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/InvalidArgumentException.php'),
 (4370, 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/LogicException.php'),
 (4371, 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/ProcessFailedException.php'),
 (4372, 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/ProcessTimedOutException.php'),
 (4373, 'wp-content/plugins/updraftplus/vendor/symfony/process/Exception/RuntimeException.php'),
 (4374, 'wp-content/plugins/updraftplus/vendor/symfony/process/ExecutableFinder.php'),
 (4375, 'wp-content/plugins/updraftplus/vendor/symfony/process/InputStream.php'),
 (4376, 'wp-content/plugins/updraftplus/vendor/symfony/process/LICENSE'),
 (4377, 'wp-content/plugins/updraftplus/vendor/symfony/process/PhpExecutableFinder.php'),
 (4378, 'wp-content/plugins/updraftplus/vendor/symfony/process/PhpProcess.php'),
 (4379, 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/AbstractPipes.php'),
 (4380, 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/PipesInterface.php'),
 (4381, 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/UnixPipes.php'),
 (4382, 'wp-content/plugins/updraftplus/vendor/symfony/process/Pipes/WindowsPipes.php'),
 (4383, 'wp-content/plugins/updraftplus/vendor/symfony/process/Process.php'),
 (4384, 'wp-content/plugins/updraftplus/vendor/symfony/process/ProcessBuilder.php'),
 (4385, 'wp-content/plugins/updraftplus/vendor/symfony/process/ProcessUtils.php'),
 (4386, 'wp-content/plugins/updraftplus/vendor/symfony/process/README.md'),
 (4387, 'wp-content/plugins/updraftplus/vendor/symfony/process/composer.json'),
 (4388, 'wp-content/plugins/updraftplus/vendor/symfony/process/phpunit.xml.dist'),
 (4389, 'wp-content/plugins/wordfence/crypto/vendor/autoload.php'),
 (4390, 'wp-content/plugins/wordfence/crypto/vendor/composer/ClassLoader.php'),
 (4391, 'wp-content/plugins/wordfence/crypto/vendor/composer/LICENSE'),
 (4392, 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_classmap.php'),
 (4393, 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_files.php'),
 (4394, 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_namespaces.php'),
 (4395, 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_psr4.php'),
 (4396, 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_real.php'),
 (4397, 'wp-content/plugins/wordfence/crypto/vendor/composer/autoload_static.php'),
 (4398, 'wp-content/plugins/wordfence/crypto/vendor/composer/installed.json'),
 (4399, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/LICENSE'),
 (4400, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/dist/random_compat.phar.pubkey'),
 (4401, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/dist/random_compat.phar.pubkey.asc'),
 (4402, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/byte_safe_strings.php'),
 (4403, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/cast_to_int.php'),
 (4404, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/error_polyfill.php'),
 (4405, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random.php'),
 (4406, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_com_dotnet.php'),
 (4407, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_dev_urandom.php'),
 (4408, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium.php'),
 (4409, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium_legacy.php'),
 (4410, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_mcrypt.php'),
 (4411, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/random_compat/lib/random_int.php'),
 (4412, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/LICENSE'),
 (4413, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-fast.php'),
 (4414, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-pedantic.php'),
 (4415, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/autoload.php'),
 (4416, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/constants.php'),
 (4417, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/namespaced.php'),
 (4418, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/php72compat.php'),
 (4419, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/lib/sodium_compat.php'),
 (4420, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Compat.php'),
 (4421, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/BLAKE2b.php'),
 (4422, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/Ctx.php'),
 (4423, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/IetfCtx.php'),
 (4424, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20.php'),
 (4425, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Fe.php'),
 (4426, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Cached.php'),
 (4427, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P1p1.php'),
 (4428, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P2.php'),
 (4429, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P3.php'),
 (4430, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Precomp.php'),
 (4431, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/H.php'),
 (4432, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519.php'),
 (4433, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Ed25519.php'),
 (4434, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HChaCha20.php'),
 (4435, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HSalsa20.php'),
 (4436, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305/State.php'),
 (4437, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305.php'),
 (4438, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Salsa20.php'),
 (4439, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/SipHash.php'),
 (4440, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Util.php'),
 (4441, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/X25519.php'),
 (4442, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/XChaCha20.php'),
 (4443, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Xsalsa20.php'),
 (4444, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Crypto.php'),
 (4445, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/File.php'),
 (4446, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Compat.php'),
 (4447, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/BLAKE2b.php'),
 (4448, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/Ctx.php'),
 (4449, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/IetfCtx.php'),
 (4450, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20.php'),
 (4451, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Fe.php'),
 (4452, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Cached.php'),
 (4453, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P1p1.php'),
 (4454, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P2.php'),
 (4455, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P3.php'),
 (4456, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Precomp.php'),
 (4457, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/H.php'),
 (4458, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519.php'),
 (4459, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Ed25519.php'),
 (4460, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HChaCha20.php'),
 (4461, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HSalsa20.php'),
 (4462, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305/State.php'),
 (4463, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305.php'),
 (4464, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Salsa20.php'),
 (4465, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/SipHash.php'),
 (4466, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Util.php'),
 (4467, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/X25519.php'),
 (4468, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XChaCha20.php'),
 (4469, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XSalsa20.php'),
 (4470, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/BLAKE2b.php'),
 (4471, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/Ctx.php'),
 (4472, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/IetfCtx.php'),
 (4473, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20.php'),
 (4474, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Fe.php'),
 (4475, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Cached.php'),
 (4476, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P1p1.php'),
 (4477, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P2.php'),
 (4478, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P3.php'),
 (4479, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Precomp.php'),
 (4480, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/H.php'),
 (4481, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519.php'),
 (4482, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Ed25519.php'),
 (4483, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HChaCha20.php'),
 (4484, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HSalsa20.php'),
 (4485, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int32.php'),
 (4486, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int64.php'),
 (4487, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305/State.php'),
 (4488, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305.php'),
 (4489, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Salsa20.php'),
 (4490, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/SipHash.php'),
 (4491, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Util.php'),
 (4492, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/X25519.php'),
 (4493, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XChaCha20.php'),
 (4494, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XSalsa20.php'),
 (4495, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto.php'),
 (4496, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto32.php'),
 (4497, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/File.php'),
 (4498, 'wp-content/plugins/wordfence/crypto/vendor/paragonie/sodium_compat/src/SodiumException.php'),
 (4499, 'wp-content/plugins/wordfence/css/activity-report-widget.1587658822.css'),
 (4500, 'wp-content/plugins/wordfence/css/diff.1587658822.css');
INSERT INTO `wp8b_wfknownfilelist` VALUES(4501, 'wp-content/plugins/wordfence/css/dt_table.1587658822.css'),
 (4502, 'wp-content/plugins/wordfence/css/fullLog.1587658822.css'),
 (4503, 'wp-content/plugins/wordfence/css/images/ui-icons_444444_256x240.png'),
 (4504, 'wp-content/plugins/wordfence/css/images/ui-icons_555555_256x240.png'),
 (4505, 'wp-content/plugins/wordfence/css/images/ui-icons_777620_256x240.png'),
 (4506, 'wp-content/plugins/wordfence/css/images/ui-icons_777777_256x240.png'),
 (4507, 'wp-content/plugins/wordfence/css/images/ui-icons_cc0000_256x240.png'),
 (4508, 'wp-content/plugins/wordfence/css/images/ui-icons_ffffff_256x240.png'),
 (4509, 'wp-content/plugins/wordfence/css/iptraf.1587658822.css'),
 (4510, 'wp-content/plugins/wordfence/css/jquery-ui-timepicker-addon.1587658822.css'),
 (4511, 'wp-content/plugins/wordfence/css/jquery-ui.min.1587658822.css'),
 (4512, 'wp-content/plugins/wordfence/css/jquery-ui.structure.min.1587658822.css'),
 (4513, 'wp-content/plugins/wordfence/css/jquery-ui.theme.min.1587658822.css'),
 (4514, 'wp-content/plugins/wordfence/css/main.1587658822.css'),
 (4515, 'wp-content/plugins/wordfence/css/phpinfo.1587658822.css'),
 (4516, 'wp-content/plugins/wordfence/css/wf-adminbar.1587658822.css'),
 (4517, 'wp-content/plugins/wordfence/css/wf-colorbox.1587658822.css'),
 (4518, 'wp-content/plugins/wordfence/css/wf-font-awesome.1587658822.css'),
 (4519, 'wp-content/plugins/wordfence/css/wf-global.1587658822.css'),
 (4520, 'wp-content/plugins/wordfence/css/wf-ionicons.1587658822.css'),
 (4521, 'wp-content/plugins/wordfence/css/wf-onboarding.1587658822.css'),
 (4522, 'wp-content/plugins/wordfence/css/wf-roboto-font.1587658822.css'),
 (4523, 'wp-content/plugins/wordfence/css/wfselect2.min.1587658822.css'),
 (4524, 'wp-content/plugins/wordfence/css/wordfenceBox.1587658822.css'),
 (4525, 'wp-content/plugins/wordfence/fonts/fontawesome-webfont.woff'),
 (4526, 'wp-content/plugins/wordfence/fonts/ionicons.woff'),
 (4527, 'wp-content/plugins/wordfence/fonts/roboto-KFOkCnqEu92Fr1Mu51xGIzQXKMnyrYk.woff'),
 (4528, 'wp-content/plugins/wordfence/fonts/roboto-KFOkCnqEu92Fr1Mu51xIIzQXKMny.woff'),
 (4529, 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmEU9fBBc-AMP6lQ.woff'),
 (4530, 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmEU9fChc-AMP6lbBP.woff'),
 (4531, 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmSU5fBBc-AMP6lQ.woff'),
 (4532, 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmSU5fChc-AMP6lbBP.woff'),
 (4533, 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmWUlfBBc-AMP6lQ.woff'),
 (4534, 'wp-content/plugins/wordfence/fonts/roboto-KFOlCnqEu92Fr1MmWUlfChc-AMP6lbBP.woff'),
 (4535, 'wp-content/plugins/wordfence/fonts/roboto-KFOmCnqEu92Fr1Mu4mxMKTU1Kg.woff'),
 (4536, 'wp-content/plugins/wordfence/fonts/roboto-KFOmCnqEu92Fr1Mu7GxMKTU1Kvnz.woff'),
 (4537, 'wp-content/plugins/wordfence/images/2fa-whole.svg'),
 (4538, 'wp-content/plugins/wordfence/images/2fa1.svg'),
 (4539, 'wp-content/plugins/wordfence/images/2fa2.svg'),
 (4540, 'wp-content/plugins/wordfence/images/back_disabled.jpg'),
 (4541, 'wp-content/plugins/wordfence/images/back_enabled.jpg'),
 (4542, 'wp-content/plugins/wordfence/images/blocking.svg'),
 (4543, 'wp-content/plugins/wordfence/images/button-grad-grey.png'),
 (4544, 'wp-content/plugins/wordfence/images/checkbox.png'),
 (4545, 'wp-content/plugins/wordfence/images/flags.png'),
 (4546, 'wp-content/plugins/wordfence/images/forward_disabled.jpg'),
 (4547, 'wp-content/plugins/wordfence/images/forward_enabled.jpg'),
 (4548, 'wp-content/plugins/wordfence/images/help.png'),
 (4549, 'wp-content/plugins/wordfence/images/icons/ajax24.gif'),
 (4550, 'wp-content/plugins/wordfence/images/icons/ajax3.gif'),
 (4551, 'wp-content/plugins/wordfence/images/icons/ajaxRed16.gif'),
 (4552, 'wp-content/plugins/wordfence/images/icons/ajaxScan.gif'),
 (4553, 'wp-content/plugins/wordfence/images/icons/ajaxWhite32x32.gif'),
 (4554, 'wp-content/plugins/wordfence/images/icons/arrow_refresh.png'),
 (4555, 'wp-content/plugins/wordfence/images/icons/bullet_yellow.png'),
 (4556, 'wp-content/plugins/wordfence/images/icons/email_go.png'),
 (4557, 'wp-content/plugins/wordfence/images/icons/error128.png'),
 (4558, 'wp-content/plugins/wordfence/images/icons/magnifier.png'),
 (4559, 'wp-content/plugins/wordfence/images/icons/tick128.png'),
 (4560, 'wp-content/plugins/wordfence/images/icons/warning128.png'),
 (4561, 'wp-content/plugins/wordfence/images/icons/working-indicator.gif'),
 (4562, 'wp-content/plugins/wordfence/images/lightbox-controls.png'),
 (4563, 'wp-content/plugins/wordfence/images/loading.gif'),
 (4564, 'wp-content/plugins/wordfence/images/loading_background.png'),
 (4565, 'wp-content/plugins/wordfence/images/loading_large.gif'),
 (4566, 'wp-content/plugins/wordfence/images/logo.png'),
 (4567, 'wp-content/plugins/wordfence/images/options.svg'),
 (4568, 'wp-content/plugins/wordfence/images/ratelimiting.svg'),
 (4569, 'wp-content/plugins/wordfence/images/sort_asc.gif'),
 (4570, 'wp-content/plugins/wordfence/images/sort_asc.png'),
 (4571, 'wp-content/plugins/wordfence/images/sort_asc_disabled.gif'),
 (4572, 'wp-content/plugins/wordfence/images/sort_asc_disabled.png'),
 (4573, 'wp-content/plugins/wordfence/images/sort_both.gif'),
 (4574, 'wp-content/plugins/wordfence/images/sort_both.png'),
 (4575, 'wp-content/plugins/wordfence/images/sort_desc.gif'),
 (4576, 'wp-content/plugins/wordfence/images/sort_desc.png'),
 (4577, 'wp-content/plugins/wordfence/images/sort_desc_disabled.gif'),
 (4578, 'wp-content/plugins/wordfence/images/sort_desc_disabled.png'),
 (4579, 'wp-content/plugins/wordfence/images/support.svg'),
 (4580, 'wp-content/plugins/wordfence/images/tools.svg'),
 (4581, 'wp-content/plugins/wordfence/images/wf-central-logo.svg'),
 (4582, 'wp-content/plugins/wordfence/images/wf-error-badge.svg'),
 (4583, 'wp-content/plugins/wordfence/images/wf-horizontal.svg'),
 (4584, 'wp-content/plugins/wordfence/images/wordfence-logo.svg'),
 (4585, 'wp-content/plugins/wordfence/index.php'),
 (4586, 'wp-content/plugins/wordfence/js/Chart.bundle.min.1587658822.js'),
 (4587, 'wp-content/plugins/wordfence/js/admin.1587658822.js'),
 (4588, 'wp-content/plugins/wordfence/js/admin.ajaxWatcher.1587658822.js'),
 (4589, 'wp-content/plugins/wordfence/js/admin.liveTraffic.1587658822.js'),
 (4590, 'wp-content/plugins/wordfence/js/date.1587658822.js'),
 (4591, 'wp-content/plugins/wordfence/js/jquery-ui-timepicker-addon.1587658822.js'),
 (4592, 'wp-content/plugins/wordfence/js/jquery.colorbox-min.1587658822.js'),
 (4593, 'wp-content/plugins/wordfence/js/jquery.colorbox.1587658822.js'),
 (4594, 'wp-content/plugins/wordfence/js/jquery.dataTables.min.1587658822.js'),
 (4595, 'wp-content/plugins/wordfence/js/jquery.qrcode.min.1587658822.js'),
 (4596, 'wp-content/plugins/wordfence/js/jquery.tmpl.min.1587658822.js'),
 (4597, 'wp-content/plugins/wordfence/js/jquery.tools.min.1587658822.js'),
 (4598, 'wp-content/plugins/wordfence/js/knockout-3.3.0.1587658822.js'),
 (4599, 'wp-content/plugins/wordfence/js/wfdashboard.1587658822.js'),
 (4600, 'wp-content/plugins/wordfence/js/wfdropdown.1587658822.js'),
 (4601, 'wp-content/plugins/wordfence/js/wfglobal.1587658822.js'),
 (4602, 'wp-content/plugins/wordfence/js/wfpopover.1587658822.js'),
 (4603, 'wp-content/plugins/wordfence/js/wfselect2.min.1587658822.js'),
 (4604, 'wp-content/plugins/wordfence/lib/.htaccess'),
 (4605, 'wp-content/plugins/wordfence/lib/Diff/Renderer/Abstract.php'),
 (4606, 'wp-content/plugins/wordfence/lib/Diff/Renderer/Html/Array.php'),
 (4607, 'wp-content/plugins/wordfence/lib/Diff/Renderer/Html/SideBySide.php'),
 (4608, 'wp-content/plugins/wordfence/lib/Diff/SequenceMatcher.php'),
 (4609, 'wp-content/plugins/wordfence/lib/Diff.php'),
 (4610, 'wp-content/plugins/wordfence/lib/GeoLite2-Country.mmdb'),
 (4611, 'wp-content/plugins/wordfence/lib/IPTraf.php'),
 (4612, 'wp-content/plugins/wordfence/lib/IPTrafList.php'),
 (4613, 'wp-content/plugins/wordfence/lib/WFLSPHP52Compatability.php'),
 (4614, 'wp-content/plugins/wordfence/lib/compat.php'),
 (4615, 'wp-content/plugins/wordfence/lib/conntest.php'),
 (4616, 'wp-content/plugins/wordfence/lib/cronview.php'),
 (4617, 'wp-content/plugins/wordfence/lib/dashboard/widget_content_countries.php'),
 (4618, 'wp-content/plugins/wordfence/lib/dashboard/widget_content_ips.php'),
 (4619, 'wp-content/plugins/wordfence/lib/dashboard/widget_content_logins.php'),
 (4620, 'wp-content/plugins/wordfence/lib/dashboard/widget_countries.php'),
 (4621, 'wp-content/plugins/wordfence/lib/dashboard/widget_ips.php'),
 (4622, 'wp-content/plugins/wordfence/lib/dashboard/widget_localattacks.php'),
 (4623, 'wp-content/plugins/wordfence/lib/dashboard/widget_logins.php'),
 (4624, 'wp-content/plugins/wordfence/lib/dashboard/widget_networkattacks.php'),
 (4625, 'wp-content/plugins/wordfence/lib/dashboard/widget_notifications.php'),
 (4626, 'wp-content/plugins/wordfence/lib/dashboard/widget_tdf.php'),
 (4627, 'wp-content/plugins/wordfence/lib/dbview.php'),
 (4628, 'wp-content/plugins/wordfence/lib/diffResult.php'),
 (4629, 'wp-content/plugins/wordfence/lib/email_genericAlert.php'),
 (4630, 'wp-content/plugins/wordfence/lib/email_newIssues.php'),
 (4631, 'wp-content/plugins/wordfence/lib/email_unlockRequest.php'),
 (4632, 'wp-content/plugins/wordfence/lib/email_unsubscribeRequest.php'),
 (4633, 'wp-content/plugins/wordfence/lib/flags.php'),
 (4634, 'wp-content/plugins/wordfence/lib/live_activity.php'),
 (4635, 'wp-content/plugins/wordfence/lib/menu_dashboard.php'),
 (4636, 'wp-content/plugins/wordfence/lib/menu_dashboard_options.php'),
 (4637, 'wp-content/plugins/wordfence/lib/menu_firewall.php'),
 (4638, 'wp-content/plugins/wordfence/lib/menu_firewall_blocking.php'),
 (4639, 'wp-content/plugins/wordfence/lib/menu_firewall_blocking_options.php'),
 (4640, 'wp-content/plugins/wordfence/lib/menu_firewall_waf.php'),
 (4641, 'wp-content/plugins/wordfence/lib/menu_firewall_waf_options.php'),
 (4642, 'wp-content/plugins/wordfence/lib/menu_options.php'),
 (4643, 'wp-content/plugins/wordfence/lib/menu_scanner.php'),
 (4644, 'wp-content/plugins/wordfence/lib/menu_scanner_credentials.php'),
 (4645, 'wp-content/plugins/wordfence/lib/menu_scanner_options.php'),
 (4646, 'wp-content/plugins/wordfence/lib/menu_support.php'),
 (4647, 'wp-content/plugins/wordfence/lib/menu_tools.php'),
 (4648, 'wp-content/plugins/wordfence/lib/menu_tools_diagnostic.php'),
 (4649, 'wp-content/plugins/wordfence/lib/menu_tools_importExport.php'),
 (4650, 'wp-content/plugins/wordfence/lib/menu_tools_livetraffic.php'),
 (4651, 'wp-content/plugins/wordfence/lib/menu_tools_twoFactor.php'),
 (4652, 'wp-content/plugins/wordfence/lib/menu_tools_whois.php'),
 (4653, 'wp-content/plugins/wordfence/lib/menu_wordfence_central.php'),
 (4654, 'wp-content/plugins/wordfence/lib/noc1.key'),
 (4655, 'wp-content/plugins/wordfence/lib/rest-api/wfRESTAuthenticationController.php'),
 (4656, 'wp-content/plugins/wordfence/lib/rest-api/wfRESTBaseController.php'),
 (4657, 'wp-content/plugins/wordfence/lib/rest-api/wfRESTConfigController.php'),
 (4658, 'wp-content/plugins/wordfence/lib/rest-api/wfRESTScanController.php'),
 (4659, 'wp-content/plugins/wordfence/lib/sysinfo.php'),
 (4660, 'wp-content/plugins/wordfence/lib/unknownFiles.php'),
 (4661, 'wp-content/plugins/wordfence/lib/viewFullActivityLog.php'),
 (4662, 'wp-content/plugins/wordfence/lib/wf503.php'),
 (4663, 'wp-content/plugins/wordfence/lib/wfAPI.php'),
 (4664, 'wp-content/plugins/wordfence/lib/wfActivityReport.php'),
 (4665, 'wp-content/plugins/wordfence/lib/wfAdminNoticeQueue.php'),
 (4666, 'wp-content/plugins/wordfence/lib/wfAlerts.php'),
 (4667, 'wp-content/plugins/wordfence/lib/wfArray.php'),
 (4668, 'wp-content/plugins/wordfence/lib/wfBrowscap.php'),
 (4669, 'wp-content/plugins/wordfence/lib/wfBrowscapCache.php'),
 (4670, 'wp-content/plugins/wordfence/lib/wfBulkCountries.php'),
 (4671, 'wp-content/plugins/wordfence/lib/wfCache.php'),
 (4672, 'wp-content/plugins/wordfence/lib/wfCentralAPI.php'),
 (4673, 'wp-content/plugins/wordfence/lib/wfConfig.php'),
 (4674, 'wp-content/plugins/wordfence/lib/wfCrawl.php'),
 (4675, 'wp-content/plugins/wordfence/lib/wfCredentialsController.php'),
 (4676, 'wp-content/plugins/wordfence/lib/wfCrypt.php'),
 (4677, 'wp-content/plugins/wordfence/lib/wfDB.php'),
 (4678, 'wp-content/plugins/wordfence/lib/wfDashboard.php'),
 (4679, 'wp-content/plugins/wordfence/lib/wfDateLocalization.php'),
 (4680, 'wp-content/plugins/wordfence/lib/wfDiagnostic.php'),
 (4681, 'wp-content/plugins/wordfence/lib/wfDict.php'),
 (4682, 'wp-content/plugins/wordfence/lib/wfDirectoryIterator.php'),
 (4683, 'wp-content/plugins/wordfence/lib/wfHelperBin.php'),
 (4684, 'wp-content/plugins/wordfence/lib/wfHelperString.php'),
 (4685, 'wp-content/plugins/wordfence/lib/wfIPWhitelist.php'),
 (4686, 'wp-content/plugins/wordfence/lib/wfImportExportController.php'),
 (4687, 'wp-content/plugins/wordfence/lib/wfIssues.php'),
 (4688, 'wp-content/plugins/wordfence/lib/wfJWT.php'),
 (4689, 'wp-content/plugins/wordfence/lib/wfLockedOut.php'),
 (4690, 'wp-content/plugins/wordfence/lib/wfLog.php'),
 (4691, 'wp-content/plugins/wordfence/lib/wfMD5BloomFilter.php'),
 (4692, 'wp-content/plugins/wordfence/lib/wfModuleController.php'),
 (4693, 'wp-content/plugins/wordfence/lib/wfNotification.php'),
 (4694, 'wp-content/plugins/wordfence/lib/wfOnboardingController.php'),
 (4695, 'wp-content/plugins/wordfence/lib/wfPersistenceController.php'),
 (4696, 'wp-content/plugins/wordfence/lib/wfRESTAPI.php'),
 (4697, 'wp-content/plugins/wordfence/lib/wfScan.php'),
 (4698, 'wp-content/plugins/wordfence/lib/wfScanEngine.php'),
 (4699, 'wp-content/plugins/wordfence/lib/wfSchema.php'),
 (4700, 'wp-content/plugins/wordfence/lib/wfStyle.php'),
 (4701, 'wp-content/plugins/wordfence/lib/wfSupportController.php'),
 (4702, 'wp-content/plugins/wordfence/lib/wfUnlockMsg.php'),
 (4703, 'wp-content/plugins/wordfence/lib/wfUpdateCheck.php'),
 (4704, 'wp-content/plugins/wordfence/lib/wfUtils.php'),
 (4705, 'wp-content/plugins/wordfence/lib/wfVersionCheckController.php'),
 (4706, 'wp-content/plugins/wordfence/lib/wfView.php'),
 (4707, 'wp-content/plugins/wordfence/lib/wfViewResult.php'),
 (4708, 'wp-content/plugins/wordfence/lib/wordfenceClass.php'),
 (4709, 'wp-content/plugins/wordfence/lib/wordfenceConstants.php'),
 (4710, 'wp-content/plugins/wordfence/lib/wordfenceHash.php'),
 (4711, 'wp-content/plugins/wordfence/lib/wordfenceScanner.php'),
 (4712, 'wp-content/plugins/wordfence/lib/wordfenceURLHoover.php'),
 (4713, 'wp-content/plugins/wordfence/models/.htaccess'),
 (4714, 'wp-content/plugins/wordfence/models/block/wfBlock.php'),
 (4715, 'wp-content/plugins/wordfence/models/block/wfRateLimit.php'),
 (4716, 'wp-content/plugins/wordfence/models/common/wfGeoIP2.php'),
 (4717, 'wp-content/plugins/wordfence/models/common/wfTab.php'),
 (4718, 'wp-content/plugins/wordfence/models/firewall/wfFirewall.php'),
 (4719, 'wp-content/plugins/wordfence/models/page/wfPage.php'),
 (4720, 'wp-content/plugins/wordfence/models/scanner/wfScanner.php'),
 (4721, 'wp-content/plugins/wordfence/modules/login-security/classes/.htaccess'),
 (4722, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/ajax.php'),
 (4723, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/captcha.php'),
 (4724, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/cron.php'),
 (4725, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/db.php'),
 (4726, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/notices.php'),
 (4727, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/permissions.php'),
 (4728, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/settings.php'),
 (4729, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/support.php'),
 (4730, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/time.php'),
 (4731, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/totp.php'),
 (4732, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/users.php'),
 (4733, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/whitelist.php'),
 (4734, 'wp-content/plugins/wordfence/modules/login-security/classes/controller/wordfencels.php'),
 (4735, 'wp-content/plugins/wordfence/modules/login-security/classes/model/asset.php'),
 (4736, 'wp-content/plugins/wordfence/modules/login-security/classes/model/compat.php'),
 (4737, 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto/base2n.php'),
 (4738, 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto/jwt.php'),
 (4739, 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto/symmetric.php'),
 (4740, 'wp-content/plugins/wordfence/modules/login-security/classes/model/crypto.php'),
 (4741, 'wp-content/plugins/wordfence/modules/login-security/classes/model/ip.php'),
 (4742, 'wp-content/plugins/wordfence/modules/login-security/classes/model/notice.php'),
 (4743, 'wp-content/plugins/wordfence/modules/login-security/classes/model/request.php'),
 (4744, 'wp-content/plugins/wordfence/modules/login-security/classes/model/settings/db.php'),
 (4745, 'wp-content/plugins/wordfence/modules/login-security/classes/model/settings/wpoptions.php'),
 (4746, 'wp-content/plugins/wordfence/modules/login-security/classes/model/settings.php'),
 (4747, 'wp-content/plugins/wordfence/modules/login-security/classes/model/text/html.php'),
 (4748, 'wp-content/plugins/wordfence/modules/login-security/classes/model/text/javascript.php'),
 (4749, 'wp-content/plugins/wordfence/modules/login-security/classes/model/tokenbucket.php'),
 (4750, 'wp-content/plugins/wordfence/modules/login-security/classes/model/view/tab.php'),
 (4751, 'wp-content/plugins/wordfence/modules/login-security/classes/model/view/title.php'),
 (4752, 'wp-content/plugins/wordfence/modules/login-security/classes/model/view.php'),
 (4753, 'wp-content/plugins/wordfence/modules/login-security/css/admin-global.1587658822.css'),
 (4754, 'wp-content/plugins/wordfence/modules/login-security/css/admin.1587658822.css'),
 (4755, 'wp-content/plugins/wordfence/modules/login-security/css/colorbox.1587658822.css'),
 (4756, 'wp-content/plugins/wordfence/modules/login-security/css/font-awesome.1587658822.css'),
 (4757, 'wp-content/plugins/wordfence/modules/login-security/css/ionicons.1587658822.css'),
 (4758, 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui-timepicker-addon.1587658822.css'),
 (4759, 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui.min.1587658822.css'),
 (4760, 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui.structure.min.1587658822.css'),
 (4761, 'wp-content/plugins/wordfence/modules/login-security/css/jquery-ui.theme.min.1587658822.css'),
 (4762, 'wp-content/plugins/wordfence/modules/login-security/css/login.1587658822.css'),
 (4763, 'wp-content/plugins/wordfence/modules/login-security/img/header.svg'),
 (4764, 'wp-content/plugins/wordfence/modules/login-security/img/lightbox-controls.png'),
 (4765, 'wp-content/plugins/wordfence/modules/login-security/img/loading.gif'),
 (4766, 'wp-content/plugins/wordfence/modules/login-security/img/loading_background.png'),
 (4767, 'wp-content/plugins/wordfence/modules/login-security/img/menu.svg'),
 (4768, 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_444444_256x240.png'),
 (4769, 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_555555_256x240.png'),
 (4770, 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_777620_256x240.png'),
 (4771, 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_777777_256x240.png'),
 (4772, 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_cc0000_256x240.png'),
 (4773, 'wp-content/plugins/wordfence/modules/login-security/img/ui-icons_ffffff_256x240.png'),
 (4774, 'wp-content/plugins/wordfence/modules/login-security/js/admin-global.1587658822.js'),
 (4775, 'wp-content/plugins/wordfence/modules/login-security/js/admin.1587658822.js'),
 (4776, 'wp-content/plugins/wordfence/modules/login-security/js/jquery-ui-timepicker-addon.1587658822.js'),
 (4777, 'wp-content/plugins/wordfence/modules/login-security/js/jquery.colorbox.1587658822.js'),
 (4778, 'wp-content/plugins/wordfence/modules/login-security/js/jquery.colorbox.min.1587658822.js'),
 (4779, 'wp-content/plugins/wordfence/modules/login-security/js/jquery.qrcode.min.1587658822.js'),
 (4780, 'wp-content/plugins/wordfence/modules/login-security/js/jquery.tmpl.min.1587658822.js'),
 (4781, 'wp-content/plugins/wordfence/modules/login-security/js/login.1587658822.js'),
 (4782, 'wp-content/plugins/wordfence/modules/login-security/views/.htaccess'),
 (4783, 'wp-content/plugins/wordfence/modules/login-security/views/common/modal-prompt.php'),
 (4784, 'wp-content/plugins/wordfence/modules/login-security/views/email/login-verification.php'),
 (4785, 'wp-content/plugins/wordfence/modules/login-security/views/manage/activate.php'),
 (4786, 'wp-content/plugins/wordfence/modules/login-security/views/manage/code.php'),
 (4787, 'wp-content/plugins/wordfence/modules/login-security/views/manage/deactivate.php'),
 (4788, 'wp-content/plugins/wordfence/modules/login-security/views/manage/regenerate.php'),
 (4789, 'wp-content/plugins/wordfence/modules/login-security/views/onboarding/standalone-header.php'),
 (4790, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-captcha-threshold.php'),
 (4791, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-captcha.php'),
 (4792, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-ip-source.php'),
 (4793, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-label.php'),
 (4794, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-require-2fa.php'),
 (4795, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-select.php'),
 (4796, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-switch.php'),
 (4797, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-text.php'),
 (4798, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-textarea.php'),
 (4799, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-boolean-switch.php'),
 (4800, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-multiple.php'),
 (4801, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-segmented.php'),
 (4802, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-select.php'),
 (4803, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-sub.php'),
 (4804, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled-textarea.php'),
 (4805, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-toggled.php'),
 (4806, 'wp-content/plugins/wordfence/modules/login-security/views/options/option-token.php'),
 (4807, 'wp-content/plugins/wordfence/modules/login-security/views/page/manage.php'),
 (4808, 'wp-content/plugins/wordfence/modules/login-security/views/page/page.php'),
 (4809, 'wp-content/plugins/wordfence/modules/login-security/views/page/section-title.php'),
 (4810, 'wp-content/plugins/wordfence/modules/login-security/views/page/settings.php'),
 (4811, 'wp-content/plugins/wordfence/modules/login-security/views/page/tabbar.php'),
 (4812, 'wp-content/plugins/wordfence/modules/login-security/views/settings/options.php'),
 (4813, 'wp-content/plugins/wordfence/modules/login-security/views/settings/user-stats.php'),
 (4814, 'wp-content/plugins/wordfence/modules/login-security/wordfence-login-security.php'),
 (4815, 'wp-content/plugins/wordfence/readme.txt'),
 (4816, 'wp-content/plugins/wordfence/tmp/.htaccess'),
 (4817, 'wp-content/plugins/wordfence/vendor/.htaccess'),
 (4818, 'wp-content/plugins/wordfence/vendor/autoload.php'),
 (4819, 'wp-content/plugins/wordfence/vendor/composer/ClassLoader.php'),
 (4820, 'wp-content/plugins/wordfence/vendor/composer/LICENSE'),
 (4821, 'wp-content/plugins/wordfence/vendor/composer/autoload_classmap.php'),
 (4822, 'wp-content/plugins/wordfence/vendor/composer/autoload_namespaces.php'),
 (4823, 'wp-content/plugins/wordfence/vendor/composer/autoload_psr4.php'),
 (4824, 'wp-content/plugins/wordfence/vendor/composer/autoload_real.php'),
 (4825, 'wp-content/plugins/wordfence/vendor/composer/autoload_static.php'),
 (4826, 'wp-content/plugins/wordfence/vendor/composer/ca-bundle/LICENSE'),
 (4827, 'wp-content/plugins/wordfence/vendor/composer/ca-bundle/res/cacert.pem'),
 (4828, 'wp-content/plugins/wordfence/vendor/composer/ca-bundle/src/CaBundle.php'),
 (4829, 'wp-content/plugins/wordfence/vendor/composer/installed.json'),
 (4830, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/.gitmodules'),
 (4831, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/.php_cs'),
 (4832, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/LICENSE'),
 (4833, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Database/Reader.php'),
 (4834, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/AddressNotFoundException.php'),
 (4835, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/AuthenticationException.php'),
 (4836, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/GeoIp2Exception.php'),
 (4837, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/HttpException.php'),
 (4838, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/InvalidRequestException.php'),
 (4839, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Exception/OutOfQueriesException.php'),
 (4840, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/AbstractModel.php'),
 (4841, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/AnonymousIp.php'),
 (4842, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Asn.php'),
 (4843, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/City.php'),
 (4844, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/ConnectionType.php'),
 (4845, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Country.php'),
 (4846, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Domain.php'),
 (4847, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Enterprise.php'),
 (4848, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Insights.php'),
 (4849, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Model/Isp.php'),
 (4850, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/ProviderInterface.php'),
 (4851, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/AbstractPlaceRecord.php'),
 (4852, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/AbstractRecord.php'),
 (4853, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/City.php'),
 (4854, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Continent.php'),
 (4855, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Country.php'),
 (4856, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Location.php'),
 (4857, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/MaxMind.php'),
 (4858, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Postal.php'),
 (4859, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/RepresentedCountry.php'),
 (4860, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Subdivision.php'),
 (4861, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/Record/Traits.php'),
 (4862, 'wp-content/plugins/wordfence/vendor/geoip2/geoip2/src/WebService/Client.php'),
 (4863, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/LICENSE'),
 (4864, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/AuthenticationException.php'),
 (4865, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/HttpException.php'),
 (4866, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/InsufficientFundsException.php'),
 (4867, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidInputException.php'),
 (4868, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidRequestException.php'),
 (4869, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/IpAddressNotFoundException.php'),
 (4870, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/PermissionRequiredException.php'),
 (4871, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/Exception/WebServiceException.php'),
 (4872, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Client.php'),
 (4873, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/CurlRequest.php'),
 (4874, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/Request.php'),
 (4875, 'wp-content/plugins/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/RequestFactory.php'),
 (4876, 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/LICENSE'),
 (4877, 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/autoload.php'),
 (4878, 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Decoder.php'),
 (4879, 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/InvalidDatabaseException.php'),
 (4880, 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Metadata.php'),
 (4881, 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Util.php'),
 (4882, 'wp-content/plugins/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader.php'),
 (4883, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/cacert.pem'),
 (4884, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/falsepositive.key'),
 (4885, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/init.php'),
 (4886, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/config.php'),
 (4887, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/http.php'),
 (4888, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/json.php'),
 (4889, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/parser/lexer.php'),
 (4890, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/parser/parser.php'),
 (4891, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/parser/sqli.php'),
 (4892, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/request.php'),
 (4893, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/rules.php'),
 (4894, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/storage/file.php'),
 (4895, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/storage/mysql.php'),
 (4896, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/storage.php'),
 (4897, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/utils.php'),
 (4898, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/view.php'),
 (4899, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/waf.php'),
 (4900, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/lib/xmlrpc.php'),
 (4901, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/rules.key'),
 (4902, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/403-blacklist.php'),
 (4903, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/403-roadblock.php'),
 (4904, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/403.php'),
 (4905, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/503-lockout.php'),
 (4906, 'wp-content/plugins/wordfence/vendor/wordfence/wf-waf/src/views/503.php'),
 (4907, 'wp-content/plugins/wordfence/views/.htaccess'),
 (4908, 'wp-content/plugins/wordfence/views/blocking/block-list.php'),
 (4909, 'wp-content/plugins/wordfence/views/blocking/blocking-create.php'),
 (4910, 'wp-content/plugins/wordfence/views/blocking/blocking-status.php'),
 (4911, 'wp-content/plugins/wordfence/views/blocking/country-block-map.php'),
 (4912, 'wp-content/plugins/wordfence/views/blocking/country-modal.php'),
 (4913, 'wp-content/plugins/wordfence/views/blocking/option-bypass-cookie.php'),
 (4914, 'wp-content/plugins/wordfence/views/blocking/option-bypass-redirect.php'),
 (4915, 'wp-content/plugins/wordfence/views/blocking/options-group-advanced-country.php'),
 (4916, 'wp-content/plugins/wordfence/views/common/block-navigation-option.php'),
 (4917, 'wp-content/plugins/wordfence/views/common/indeterminate-progress.php'),
 (4918, 'wp-content/plugins/wordfence/views/common/license.php'),
 (4919, 'wp-content/plugins/wordfence/views/common/modal-prompt.php'),
 (4920, 'wp-content/plugins/wordfence/views/common/page-fixed-tabbar.php'),
 (4921, 'wp-content/plugins/wordfence/views/common/page-help.php'),
 (4922, 'wp-content/plugins/wordfence/views/common/page-tabbar.php'),
 (4923, 'wp-content/plugins/wordfence/views/common/page-title.php'),
 (4924, 'wp-content/plugins/wordfence/views/common/section-subtitle.php'),
 (4925, 'wp-content/plugins/wordfence/views/common/section-title.php'),
 (4926, 'wp-content/plugins/wordfence/views/common/status-circular.php'),
 (4927, 'wp-content/plugins/wordfence/views/common/status-critical.php'),
 (4928, 'wp-content/plugins/wordfence/views/common/status-detail.php'),
 (4929, 'wp-content/plugins/wordfence/views/common/status-tooltip.php'),
 (4930, 'wp-content/plugins/wordfence/views/common/status-warning.php'),
 (4931, 'wp-content/plugins/wordfence/views/common/unsubscribe.php'),
 (4932, 'wp-content/plugins/wordfence/views/dashboard/global-status.php'),
 (4933, 'wp-content/plugins/wordfence/views/dashboard/option-howgetips.php'),
 (4934, 'wp-content/plugins/wordfence/views/dashboard/options-group-alert.php'),
 (4935, 'wp-content/plugins/wordfence/views/dashboard/options-group-dashboard.php'),
 (4936, 'wp-content/plugins/wordfence/views/dashboard/options-group-email-summary.php'),
 (4937, 'wp-content/plugins/wordfence/views/dashboard/options-group-general.php'),
 (4938, 'wp-content/plugins/wordfence/views/dashboard/options-group-import.php'),
 (4939, 'wp-content/plugins/wordfence/views/dashboard/options-group-license.php'),
 (4940, 'wp-content/plugins/wordfence/views/dashboard/options-group-view-customization.php'),
 (4941, 'wp-content/plugins/wordfence/views/dashboard/status-payment-expiring.php'),
 (4942, 'wp-content/plugins/wordfence/views/dashboard/status-renewing.php'),
 (4943, 'wp-content/plugins/wordfence/views/gdpr/banner.php'),
 (4944, 'wp-content/plugins/wordfence/views/gdpr/disabled-overlay.php'),
 (4945, 'wp-content/plugins/wordfence/views/onboarding/banner.php'),
 (4946, 'wp-content/plugins/wordfence/views/onboarding/disabled-overlay.php'),
 (4947, 'wp-content/plugins/wordfence/views/onboarding/fresh-install.php'),
 (4948, 'wp-content/plugins/wordfence/views/onboarding/modal-final-attempt.php'),
 (4949, 'wp-content/plugins/wordfence/views/onboarding/overlay.php'),
 (4950, 'wp-content/plugins/wordfence/views/onboarding/plugin-header.php'),
 (4951, 'wp-content/plugins/wordfence/views/onboarding/tour-overlay.php'),
 (4952, 'wp-content/plugins/wordfence/views/options/block-all-options-controls.php'),
 (4953, 'wp-content/plugins/wordfence/views/options/block-controls.php'),
 (4954, 'wp-content/plugins/wordfence/views/options/option-label.php'),
 (4955, 'wp-content/plugins/wordfence/views/options/option-select.php'),
 (4956, 'wp-content/plugins/wordfence/views/options/option-switch.php'),
 (4957, 'wp-content/plugins/wordfence/views/options/option-text.php'),
 (4958, 'wp-content/plugins/wordfence/views/options/option-textarea.php'),
 (4959, 'wp-content/plugins/wordfence/views/options/option-toggled-boolean-switch.php'),
 (4960, 'wp-content/plugins/wordfence/views/options/option-toggled-multiple.php'),
 (4961, 'wp-content/plugins/wordfence/views/options/option-toggled-segmented.php'),
 (4962, 'wp-content/plugins/wordfence/views/options/option-toggled-select.php'),
 (4963, 'wp-content/plugins/wordfence/views/options/option-toggled-sub.php'),
 (4964, 'wp-content/plugins/wordfence/views/options/option-toggled-textarea.php'),
 (4965, 'wp-content/plugins/wordfence/views/options/option-toggled.php'),
 (4966, 'wp-content/plugins/wordfence/views/options/option-token.php'),
 (4967, 'wp-content/plugins/wordfence/views/options/options-title.php'),
 (4968, 'wp-content/plugins/wordfence/views/reports/activity-report-email-inline.php'),
 (4969, 'wp-content/plugins/wordfence/views/reports/activity-report.php'),
 (4970, 'wp-content/plugins/wordfence/views/scanner/issue-base.php'),
 (4971, 'wp-content/plugins/wordfence/views/scanner/issue-checkGSB.php'),
 (4972, 'wp-content/plugins/wordfence/views/scanner/issue-checkHowGetIPs.php'),
 (4973, 'wp-content/plugins/wordfence/views/scanner/issue-checkSpamIP.php'),
 (4974, 'wp-content/plugins/wordfence/views/scanner/issue-commentBadURL.php'),
 (4975, 'wp-content/plugins/wordfence/views/scanner/issue-configReadable.php'),
 (4976, 'wp-content/plugins/wordfence/views/scanner/issue-control-edit-comment.php'),
 (4977, 'wp-content/plugins/wordfence/views/scanner/issue-control-edit-post.php'),
 (4978, 'wp-content/plugins/wordfence/views/scanner/issue-control-edit-user.php'),
 (4979, 'wp-content/plugins/wordfence/views/scanner/issue-control-hide-file.php'),
 (4980, 'wp-content/plugins/wordfence/views/scanner/issue-control-ignore.php'),
 (4981, 'wp-content/plugins/wordfence/views/scanner/issue-control-repair.php'),
 (4982, 'wp-content/plugins/wordfence/views/scanner/issue-control-show-details.php'),
 (4983, 'wp-content/plugins/wordfence/views/scanner/issue-coreUnknown.php'),
 (4984, 'wp-content/plugins/wordfence/views/scanner/issue-database.php'),
 (4985, 'wp-content/plugins/wordfence/views/scanner/issue-diskSpace.php'),
 (4986, 'wp-content/plugins/wordfence/views/scanner/issue-easyPassword.php'),
 (4987, 'wp-content/plugins/wordfence/views/scanner/issue-file.php'),
 (4988, 'wp-content/plugins/wordfence/views/scanner/issue-geoipSupport.php'),
 (4989, 'wp-content/plugins/wordfence/views/scanner/issue-knownfile.php'),
 (4990, 'wp-content/plugins/wordfence/views/scanner/issue-optionBadURL.php'),
 (4991, 'wp-content/plugins/wordfence/views/scanner/issue-postBadTitle.php'),
 (4992, 'wp-content/plugins/wordfence/views/scanner/issue-postBadURL.php'),
 (4993, 'wp-content/plugins/wordfence/views/scanner/issue-publiclyAccessible.php'),
 (4994, 'wp-content/plugins/wordfence/views/scanner/issue-skippedPaths.php'),
 (4995, 'wp-content/plugins/wordfence/views/scanner/issue-spamvertizeCheck.php'),
 (4996, 'wp-content/plugins/wordfence/views/scanner/issue-suspiciousAdminUsers.php'),
 (4997, 'wp-content/plugins/wordfence/views/scanner/issue-timelimit.php'),
 (4998, 'wp-content/plugins/wordfence/views/scanner/issue-wafStatus.php'),
 (4999, 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginAbandoned.php'),
 (5000, 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginRemoved.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(5001, 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginUpgrade.php'),
 (5002, 'wp-content/plugins/wordfence/views/scanner/issue-wfPluginVulnerable.php'),
 (5003, 'wp-content/plugins/wordfence/views/scanner/issue-wfThemeUpgrade.php'),
 (5004, 'wp-content/plugins/wordfence/views/scanner/issue-wfUpgrade.php'),
 (5005, 'wp-content/plugins/wordfence/views/scanner/issue-wpscan_directoryList.php'),
 (5006, 'wp-content/plugins/wordfence/views/scanner/issue-wpscan_fullPathDiscl.php'),
 (5007, 'wp-content/plugins/wordfence/views/scanner/no-issues.php'),
 (5008, 'wp-content/plugins/wordfence/views/scanner/option-scan-signatures.php'),
 (5009, 'wp-content/plugins/wordfence/views/scanner/options-group-advanced.php'),
 (5010, 'wp-content/plugins/wordfence/views/scanner/options-group-basic.php'),
 (5011, 'wp-content/plugins/wordfence/views/scanner/options-group-general.php'),
 (5012, 'wp-content/plugins/wordfence/views/scanner/options-group-performance.php'),
 (5013, 'wp-content/plugins/wordfence/views/scanner/options-group-scan-schedule.php'),
 (5014, 'wp-content/plugins/wordfence/views/scanner/scan-failed.php'),
 (5015, 'wp-content/plugins/wordfence/views/scanner/scan-progress-detailed.php'),
 (5016, 'wp-content/plugins/wordfence/views/scanner/scan-progress-element.php'),
 (5017, 'wp-content/plugins/wordfence/views/scanner/scan-progress.php'),
 (5018, 'wp-content/plugins/wordfence/views/scanner/scan-results.php'),
 (5019, 'wp-content/plugins/wordfence/views/scanner/scan-scheduling.php'),
 (5020, 'wp-content/plugins/wordfence/views/scanner/scan-starter.php'),
 (5021, 'wp-content/plugins/wordfence/views/scanner/scan-type.php'),
 (5022, 'wp-content/plugins/wordfence/views/scanner/scanner-status.php'),
 (5023, 'wp-content/plugins/wordfence/views/scanner/site-cleaning-beta-sigs.php'),
 (5024, 'wp-content/plugins/wordfence/views/scanner/site-cleaning-bottom.php'),
 (5025, 'wp-content/plugins/wordfence/views/scanner/site-cleaning-high-sense.php'),
 (5026, 'wp-content/plugins/wordfence/views/scanner/site-cleaning.php'),
 (5027, 'wp-content/plugins/wordfence/views/tools/options-group-2fa.php'),
 (5028, 'wp-content/plugins/wordfence/views/tools/options-group-live-traffic.php'),
 (5029, 'wp-content/plugins/wordfence/views/tours/login-security.php'),
 (5030, 'wp-content/plugins/wordfence/views/waf/debug.php'),
 (5031, 'wp-content/plugins/wordfence/views/waf/firewall-status.php'),
 (5032, 'wp-content/plugins/wordfence/views/waf/option-rate-limit.php'),
 (5033, 'wp-content/plugins/wordfence/views/waf/option-rules.php'),
 (5034, 'wp-content/plugins/wordfence/views/waf/option-whitelist.php'),
 (5035, 'wp-content/plugins/wordfence/views/waf/options-group-advanced-firewall.php'),
 (5036, 'wp-content/plugins/wordfence/views/waf/options-group-basic-firewall.php'),
 (5037, 'wp-content/plugins/wordfence/views/waf/options-group-brute-force.php'),
 (5038, 'wp-content/plugins/wordfence/views/waf/options-group-rate-limiting.php'),
 (5039, 'wp-content/plugins/wordfence/views/waf/options-group-whitelisted.php'),
 (5040, 'wp-content/plugins/wordfence/views/waf/status-tooltip-learning-mode.php'),
 (5041, 'wp-content/plugins/wordfence/views/waf/waf-install-manual.php'),
 (5042, 'wp-content/plugins/wordfence/views/waf/waf-install-success.php'),
 (5043, 'wp-content/plugins/wordfence/views/waf/waf-install.php'),
 (5044, 'wp-content/plugins/wordfence/views/waf/waf-modal-wrapper.php'),
 (5045, 'wp-content/plugins/wordfence/views/waf/waf-uninstall-success.php'),
 (5046, 'wp-content/plugins/wordfence/views/waf/waf-uninstall.php'),
 (5047, 'wp-content/plugins/wordfence/waf/.htaccess'),
 (5048, 'wp-content/plugins/wordfence/waf/bootstrap.php'),
 (5049, 'wp-content/plugins/wordfence/waf/wfWAFGeoIP2.php'),
 (5050, 'wp-content/plugins/wordfence/waf/wfWAFIPBlocksController.php'),
 (5051, 'wp-content/plugins/wordfence/waf/wfWAFUserIPRange.php'),
 (5052, 'wp-content/plugins/wordfence/wordfence.php'),
 (5053, 'wp-content/plugins/wp-cerber/admin/cerber-settings.php'),
 (5054, 'wp-content/plugins/wp-cerber/assets/admin.css'),
 (5055, 'wp-content/plugins/wp-cerber/assets/admin.js'),
 (5056, 'wp-content/plugins/wp-cerber/assets/ajax-loader.gif'),
 (5057, 'wp-content/plugins/wp-cerber/assets/bgwidget.png'),
 (5058, 'wp-content/plugins/wp-cerber/assets/bn2ra.png'),
 (5059, 'wp-content/plugins/wp-cerber/assets/bn3ra.png'),
 (5060, 'wp-content/plugins/wp-cerber/assets/flags/ad.gif'),
 (5061, 'wp-content/plugins/wp-cerber/assets/flags/ae.gif'),
 (5062, 'wp-content/plugins/wp-cerber/assets/flags/af.gif'),
 (5063, 'wp-content/plugins/wp-cerber/assets/flags/ag.gif'),
 (5064, 'wp-content/plugins/wp-cerber/assets/flags/ai.gif'),
 (5065, 'wp-content/plugins/wp-cerber/assets/flags/al.gif'),
 (5066, 'wp-content/plugins/wp-cerber/assets/flags/am.gif'),
 (5067, 'wp-content/plugins/wp-cerber/assets/flags/an.gif'),
 (5068, 'wp-content/plugins/wp-cerber/assets/flags/ao.gif'),
 (5069, 'wp-content/plugins/wp-cerber/assets/flags/aq.gif'),
 (5070, 'wp-content/plugins/wp-cerber/assets/flags/ar.gif'),
 (5071, 'wp-content/plugins/wp-cerber/assets/flags/as.gif'),
 (5072, 'wp-content/plugins/wp-cerber/assets/flags/at.gif'),
 (5073, 'wp-content/plugins/wp-cerber/assets/flags/au.gif'),
 (5074, 'wp-content/plugins/wp-cerber/assets/flags/aw.gif'),
 (5075, 'wp-content/plugins/wp-cerber/assets/flags/ax.gif'),
 (5076, 'wp-content/plugins/wp-cerber/assets/flags/az.gif'),
 (5077, 'wp-content/plugins/wp-cerber/assets/flags/ba.gif'),
 (5078, 'wp-content/plugins/wp-cerber/assets/flags/bb.gif'),
 (5079, 'wp-content/plugins/wp-cerber/assets/flags/bd.gif'),
 (5080, 'wp-content/plugins/wp-cerber/assets/flags/be.gif'),
 (5081, 'wp-content/plugins/wp-cerber/assets/flags/bf.gif'),
 (5082, 'wp-content/plugins/wp-cerber/assets/flags/bg.gif'),
 (5083, 'wp-content/plugins/wp-cerber/assets/flags/bh.gif'),
 (5084, 'wp-content/plugins/wp-cerber/assets/flags/bi.gif'),
 (5085, 'wp-content/plugins/wp-cerber/assets/flags/bj.gif'),
 (5086, 'wp-content/plugins/wp-cerber/assets/flags/bl.gif'),
 (5087, 'wp-content/plugins/wp-cerber/assets/flags/bm.gif'),
 (5088, 'wp-content/plugins/wp-cerber/assets/flags/bn.gif'),
 (5089, 'wp-content/plugins/wp-cerber/assets/flags/bo.gif'),
 (5090, 'wp-content/plugins/wp-cerber/assets/flags/bq.gif'),
 (5091, 'wp-content/plugins/wp-cerber/assets/flags/br.gif'),
 (5092, 'wp-content/plugins/wp-cerber/assets/flags/bs.gif'),
 (5093, 'wp-content/plugins/wp-cerber/assets/flags/bt.gif'),
 (5094, 'wp-content/plugins/wp-cerber/assets/flags/bv.gif'),
 (5095, 'wp-content/plugins/wp-cerber/assets/flags/bw.gif'),
 (5096, 'wp-content/plugins/wp-cerber/assets/flags/by.gif'),
 (5097, 'wp-content/plugins/wp-cerber/assets/flags/bz.gif'),
 (5098, 'wp-content/plugins/wp-cerber/assets/flags/ca.gif'),
 (5099, 'wp-content/plugins/wp-cerber/assets/flags/cc.gif'),
 (5100, 'wp-content/plugins/wp-cerber/assets/flags/cd.gif'),
 (5101, 'wp-content/plugins/wp-cerber/assets/flags/cf.gif'),
 (5102, 'wp-content/plugins/wp-cerber/assets/flags/cg.gif'),
 (5103, 'wp-content/plugins/wp-cerber/assets/flags/ch.gif'),
 (5104, 'wp-content/plugins/wp-cerber/assets/flags/ci.gif'),
 (5105, 'wp-content/plugins/wp-cerber/assets/flags/ck.gif'),
 (5106, 'wp-content/plugins/wp-cerber/assets/flags/cl.gif'),
 (5107, 'wp-content/plugins/wp-cerber/assets/flags/cm.gif'),
 (5108, 'wp-content/plugins/wp-cerber/assets/flags/cn.gif'),
 (5109, 'wp-content/plugins/wp-cerber/assets/flags/co.gif'),
 (5110, 'wp-content/plugins/wp-cerber/assets/flags/cr.gif'),
 (5111, 'wp-content/plugins/wp-cerber/assets/flags/cs.gif'),
 (5112, 'wp-content/plugins/wp-cerber/assets/flags/cu.gif'),
 (5113, 'wp-content/plugins/wp-cerber/assets/flags/cv.gif'),
 (5114, 'wp-content/plugins/wp-cerber/assets/flags/cw.gif'),
 (5115, 'wp-content/plugins/wp-cerber/assets/flags/cx.gif'),
 (5116, 'wp-content/plugins/wp-cerber/assets/flags/cy.gif'),
 (5117, 'wp-content/plugins/wp-cerber/assets/flags/cz.gif'),
 (5118, 'wp-content/plugins/wp-cerber/assets/flags/de.gif'),
 (5119, 'wp-content/plugins/wp-cerber/assets/flags/dj.gif'),
 (5120, 'wp-content/plugins/wp-cerber/assets/flags/dk.gif'),
 (5121, 'wp-content/plugins/wp-cerber/assets/flags/dm.gif'),
 (5122, 'wp-content/plugins/wp-cerber/assets/flags/do.gif'),
 (5123, 'wp-content/plugins/wp-cerber/assets/flags/dz.gif'),
 (5124, 'wp-content/plugins/wp-cerber/assets/flags/ec.gif'),
 (5125, 'wp-content/plugins/wp-cerber/assets/flags/ee.gif'),
 (5126, 'wp-content/plugins/wp-cerber/assets/flags/eg.gif'),
 (5127, 'wp-content/plugins/wp-cerber/assets/flags/eh.gif'),
 (5128, 'wp-content/plugins/wp-cerber/assets/flags/er.gif'),
 (5129, 'wp-content/plugins/wp-cerber/assets/flags/es.gif'),
 (5130, 'wp-content/plugins/wp-cerber/assets/flags/et.gif'),
 (5131, 'wp-content/plugins/wp-cerber/assets/flags/eu.gif'),
 (5132, 'wp-content/plugins/wp-cerber/assets/flags/ez.gif'),
 (5133, 'wp-content/plugins/wp-cerber/assets/flags/fi.gif'),
 (5134, 'wp-content/plugins/wp-cerber/assets/flags/fj.gif'),
 (5135, 'wp-content/plugins/wp-cerber/assets/flags/fk.gif'),
 (5136, 'wp-content/plugins/wp-cerber/assets/flags/fm.gif'),
 (5137, 'wp-content/plugins/wp-cerber/assets/flags/fo.gif'),
 (5138, 'wp-content/plugins/wp-cerber/assets/flags/fr.gif'),
 (5139, 'wp-content/plugins/wp-cerber/assets/flags/ga.gif'),
 (5140, 'wp-content/plugins/wp-cerber/assets/flags/gb.gif'),
 (5141, 'wp-content/plugins/wp-cerber/assets/flags/gd.gif'),
 (5142, 'wp-content/plugins/wp-cerber/assets/flags/ge.gif'),
 (5143, 'wp-content/plugins/wp-cerber/assets/flags/gf.gif'),
 (5144, 'wp-content/plugins/wp-cerber/assets/flags/gg.gif'),
 (5145, 'wp-content/plugins/wp-cerber/assets/flags/gh.gif'),
 (5146, 'wp-content/plugins/wp-cerber/assets/flags/gi.gif'),
 (5147, 'wp-content/plugins/wp-cerber/assets/flags/gl.gif'),
 (5148, 'wp-content/plugins/wp-cerber/assets/flags/gm.gif'),
 (5149, 'wp-content/plugins/wp-cerber/assets/flags/gn.gif'),
 (5150, 'wp-content/plugins/wp-cerber/assets/flags/gp.gif'),
 (5151, 'wp-content/plugins/wp-cerber/assets/flags/gq.gif'),
 (5152, 'wp-content/plugins/wp-cerber/assets/flags/gr.gif'),
 (5153, 'wp-content/plugins/wp-cerber/assets/flags/gs.gif'),
 (5154, 'wp-content/plugins/wp-cerber/assets/flags/gt.gif'),
 (5155, 'wp-content/plugins/wp-cerber/assets/flags/gu.gif'),
 (5156, 'wp-content/plugins/wp-cerber/assets/flags/gw.gif'),
 (5157, 'wp-content/plugins/wp-cerber/assets/flags/gy.gif'),
 (5158, 'wp-content/plugins/wp-cerber/assets/flags/hk.gif'),
 (5159, 'wp-content/plugins/wp-cerber/assets/flags/hm.gif'),
 (5160, 'wp-content/plugins/wp-cerber/assets/flags/hn.gif'),
 (5161, 'wp-content/plugins/wp-cerber/assets/flags/hr.gif'),
 (5162, 'wp-content/plugins/wp-cerber/assets/flags/ht.gif'),
 (5163, 'wp-content/plugins/wp-cerber/assets/flags/hu.gif'),
 (5164, 'wp-content/plugins/wp-cerber/assets/flags/id.gif'),
 (5165, 'wp-content/plugins/wp-cerber/assets/flags/ie.gif'),
 (5166, 'wp-content/plugins/wp-cerber/assets/flags/il.gif'),
 (5167, 'wp-content/plugins/wp-cerber/assets/flags/im.gif'),
 (5168, 'wp-content/plugins/wp-cerber/assets/flags/in.gif'),
 (5169, 'wp-content/plugins/wp-cerber/assets/flags/io.gif'),
 (5170, 'wp-content/plugins/wp-cerber/assets/flags/iq.gif'),
 (5171, 'wp-content/plugins/wp-cerber/assets/flags/ir.gif'),
 (5172, 'wp-content/plugins/wp-cerber/assets/flags/is.gif'),
 (5173, 'wp-content/plugins/wp-cerber/assets/flags/it.gif'),
 (5174, 'wp-content/plugins/wp-cerber/assets/flags/je.gif'),
 (5175, 'wp-content/plugins/wp-cerber/assets/flags/jm.gif'),
 (5176, 'wp-content/plugins/wp-cerber/assets/flags/jo.gif'),
 (5177, 'wp-content/plugins/wp-cerber/assets/flags/jp.gif'),
 (5178, 'wp-content/plugins/wp-cerber/assets/flags/ke.gif'),
 (5179, 'wp-content/plugins/wp-cerber/assets/flags/kg.gif'),
 (5180, 'wp-content/plugins/wp-cerber/assets/flags/kh.gif'),
 (5181, 'wp-content/plugins/wp-cerber/assets/flags/ki.gif'),
 (5182, 'wp-content/plugins/wp-cerber/assets/flags/km.gif'),
 (5183, 'wp-content/plugins/wp-cerber/assets/flags/kn.gif'),
 (5184, 'wp-content/plugins/wp-cerber/assets/flags/kp.gif'),
 (5185, 'wp-content/plugins/wp-cerber/assets/flags/kr.gif'),
 (5186, 'wp-content/plugins/wp-cerber/assets/flags/kw.gif'),
 (5187, 'wp-content/plugins/wp-cerber/assets/flags/ky.gif'),
 (5188, 'wp-content/plugins/wp-cerber/assets/flags/kz.gif'),
 (5189, 'wp-content/plugins/wp-cerber/assets/flags/la.gif'),
 (5190, 'wp-content/plugins/wp-cerber/assets/flags/lb.gif'),
 (5191, 'wp-content/plugins/wp-cerber/assets/flags/lc.gif'),
 (5192, 'wp-content/plugins/wp-cerber/assets/flags/li.gif'),
 (5193, 'wp-content/plugins/wp-cerber/assets/flags/lk.gif'),
 (5194, 'wp-content/plugins/wp-cerber/assets/flags/lr.gif'),
 (5195, 'wp-content/plugins/wp-cerber/assets/flags/ls.gif'),
 (5196, 'wp-content/plugins/wp-cerber/assets/flags/lt.gif'),
 (5197, 'wp-content/plugins/wp-cerber/assets/flags/lu.gif'),
 (5198, 'wp-content/plugins/wp-cerber/assets/flags/lv.gif'),
 (5199, 'wp-content/plugins/wp-cerber/assets/flags/ly.gif'),
 (5200, 'wp-content/plugins/wp-cerber/assets/flags/ma.gif'),
 (5201, 'wp-content/plugins/wp-cerber/assets/flags/mc.gif'),
 (5202, 'wp-content/plugins/wp-cerber/assets/flags/md.gif'),
 (5203, 'wp-content/plugins/wp-cerber/assets/flags/me.gif'),
 (5204, 'wp-content/plugins/wp-cerber/assets/flags/mf.gif'),
 (5205, 'wp-content/plugins/wp-cerber/assets/flags/mg.gif'),
 (5206, 'wp-content/plugins/wp-cerber/assets/flags/mh.gif'),
 (5207, 'wp-content/plugins/wp-cerber/assets/flags/mk.gif'),
 (5208, 'wp-content/plugins/wp-cerber/assets/flags/ml.gif'),
 (5209, 'wp-content/plugins/wp-cerber/assets/flags/mm.gif'),
 (5210, 'wp-content/plugins/wp-cerber/assets/flags/mn.gif'),
 (5211, 'wp-content/plugins/wp-cerber/assets/flags/mo.gif'),
 (5212, 'wp-content/plugins/wp-cerber/assets/flags/mp.gif'),
 (5213, 'wp-content/plugins/wp-cerber/assets/flags/mq.gif'),
 (5214, 'wp-content/plugins/wp-cerber/assets/flags/mr.gif'),
 (5215, 'wp-content/plugins/wp-cerber/assets/flags/ms.gif'),
 (5216, 'wp-content/plugins/wp-cerber/assets/flags/mt.gif'),
 (5217, 'wp-content/plugins/wp-cerber/assets/flags/mu.gif'),
 (5218, 'wp-content/plugins/wp-cerber/assets/flags/mv.gif'),
 (5219, 'wp-content/plugins/wp-cerber/assets/flags/mw.gif'),
 (5220, 'wp-content/plugins/wp-cerber/assets/flags/mx.gif'),
 (5221, 'wp-content/plugins/wp-cerber/assets/flags/my.gif'),
 (5222, 'wp-content/plugins/wp-cerber/assets/flags/mz.gif'),
 (5223, 'wp-content/plugins/wp-cerber/assets/flags/na.gif'),
 (5224, 'wp-content/plugins/wp-cerber/assets/flags/nc.gif'),
 (5225, 'wp-content/plugins/wp-cerber/assets/flags/ne.gif'),
 (5226, 'wp-content/plugins/wp-cerber/assets/flags/nf.gif'),
 (5227, 'wp-content/plugins/wp-cerber/assets/flags/ng.gif'),
 (5228, 'wp-content/plugins/wp-cerber/assets/flags/ni.gif'),
 (5229, 'wp-content/plugins/wp-cerber/assets/flags/nl.gif'),
 (5230, 'wp-content/plugins/wp-cerber/assets/flags/no.gif'),
 (5231, 'wp-content/plugins/wp-cerber/assets/flags/np.gif'),
 (5232, 'wp-content/plugins/wp-cerber/assets/flags/nr.gif'),
 (5233, 'wp-content/plugins/wp-cerber/assets/flags/nu.gif'),
 (5234, 'wp-content/plugins/wp-cerber/assets/flags/nz.gif'),
 (5235, 'wp-content/plugins/wp-cerber/assets/flags/om.gif'),
 (5236, 'wp-content/plugins/wp-cerber/assets/flags/pa.gif'),
 (5237, 'wp-content/plugins/wp-cerber/assets/flags/pe.gif'),
 (5238, 'wp-content/plugins/wp-cerber/assets/flags/pf.gif'),
 (5239, 'wp-content/plugins/wp-cerber/assets/flags/pg.gif'),
 (5240, 'wp-content/plugins/wp-cerber/assets/flags/ph.gif'),
 (5241, 'wp-content/plugins/wp-cerber/assets/flags/pk.gif'),
 (5242, 'wp-content/plugins/wp-cerber/assets/flags/pl.gif'),
 (5243, 'wp-content/plugins/wp-cerber/assets/flags/pm.gif'),
 (5244, 'wp-content/plugins/wp-cerber/assets/flags/pn.gif'),
 (5245, 'wp-content/plugins/wp-cerber/assets/flags/pr.gif'),
 (5246, 'wp-content/plugins/wp-cerber/assets/flags/ps.gif'),
 (5247, 'wp-content/plugins/wp-cerber/assets/flags/pt.gif'),
 (5248, 'wp-content/plugins/wp-cerber/assets/flags/pw.gif'),
 (5249, 'wp-content/plugins/wp-cerber/assets/flags/py.gif'),
 (5250, 'wp-content/plugins/wp-cerber/assets/flags/qa.gif'),
 (5251, 'wp-content/plugins/wp-cerber/assets/flags/re.gif'),
 (5252, 'wp-content/plugins/wp-cerber/assets/flags/ro.gif'),
 (5253, 'wp-content/plugins/wp-cerber/assets/flags/rs.gif'),
 (5254, 'wp-content/plugins/wp-cerber/assets/flags/ru.gif'),
 (5255, 'wp-content/plugins/wp-cerber/assets/flags/rw.gif'),
 (5256, 'wp-content/plugins/wp-cerber/assets/flags/sa.gif'),
 (5257, 'wp-content/plugins/wp-cerber/assets/flags/sb.gif'),
 (5258, 'wp-content/plugins/wp-cerber/assets/flags/sc.gif'),
 (5259, 'wp-content/plugins/wp-cerber/assets/flags/sd.gif'),
 (5260, 'wp-content/plugins/wp-cerber/assets/flags/se.gif'),
 (5261, 'wp-content/plugins/wp-cerber/assets/flags/sg.gif'),
 (5262, 'wp-content/plugins/wp-cerber/assets/flags/sh.gif'),
 (5263, 'wp-content/plugins/wp-cerber/assets/flags/si.gif'),
 (5264, 'wp-content/plugins/wp-cerber/assets/flags/sj.gif'),
 (5265, 'wp-content/plugins/wp-cerber/assets/flags/sk.gif'),
 (5266, 'wp-content/plugins/wp-cerber/assets/flags/sl.gif'),
 (5267, 'wp-content/plugins/wp-cerber/assets/flags/sm.gif'),
 (5268, 'wp-content/plugins/wp-cerber/assets/flags/sn.gif'),
 (5269, 'wp-content/plugins/wp-cerber/assets/flags/so.gif'),
 (5270, 'wp-content/plugins/wp-cerber/assets/flags/sr.gif'),
 (5271, 'wp-content/plugins/wp-cerber/assets/flags/ss.gif'),
 (5272, 'wp-content/plugins/wp-cerber/assets/flags/st.gif'),
 (5273, 'wp-content/plugins/wp-cerber/assets/flags/sv.gif'),
 (5274, 'wp-content/plugins/wp-cerber/assets/flags/sx.gif'),
 (5275, 'wp-content/plugins/wp-cerber/assets/flags/sy.gif'),
 (5276, 'wp-content/plugins/wp-cerber/assets/flags/sz.gif'),
 (5277, 'wp-content/plugins/wp-cerber/assets/flags/tc.gif'),
 (5278, 'wp-content/plugins/wp-cerber/assets/flags/td.gif'),
 (5279, 'wp-content/plugins/wp-cerber/assets/flags/tf.gif'),
 (5280, 'wp-content/plugins/wp-cerber/assets/flags/tg.gif'),
 (5281, 'wp-content/plugins/wp-cerber/assets/flags/th.gif'),
 (5282, 'wp-content/plugins/wp-cerber/assets/flags/tj.gif'),
 (5283, 'wp-content/plugins/wp-cerber/assets/flags/tk.gif'),
 (5284, 'wp-content/plugins/wp-cerber/assets/flags/tl.gif'),
 (5285, 'wp-content/plugins/wp-cerber/assets/flags/tm.gif'),
 (5286, 'wp-content/plugins/wp-cerber/assets/flags/tn.gif'),
 (5287, 'wp-content/plugins/wp-cerber/assets/flags/to.gif'),
 (5288, 'wp-content/plugins/wp-cerber/assets/flags/tr.gif'),
 (5289, 'wp-content/plugins/wp-cerber/assets/flags/tt.gif'),
 (5290, 'wp-content/plugins/wp-cerber/assets/flags/tv.gif'),
 (5291, 'wp-content/plugins/wp-cerber/assets/flags/tw.gif'),
 (5292, 'wp-content/plugins/wp-cerber/assets/flags/tz.gif'),
 (5293, 'wp-content/plugins/wp-cerber/assets/flags/ua.gif'),
 (5294, 'wp-content/plugins/wp-cerber/assets/flags/ug.gif'),
 (5295, 'wp-content/plugins/wp-cerber/assets/flags/um.gif'),
 (5296, 'wp-content/plugins/wp-cerber/assets/flags/us.gif'),
 (5297, 'wp-content/plugins/wp-cerber/assets/flags/uy.gif'),
 (5298, 'wp-content/plugins/wp-cerber/assets/flags/uz.gif'),
 (5299, 'wp-content/plugins/wp-cerber/assets/flags/va.gif'),
 (5300, 'wp-content/plugins/wp-cerber/assets/flags/vc.gif'),
 (5301, 'wp-content/plugins/wp-cerber/assets/flags/ve.gif'),
 (5302, 'wp-content/plugins/wp-cerber/assets/flags/vg.gif'),
 (5303, 'wp-content/plugins/wp-cerber/assets/flags/vi.gif'),
 (5304, 'wp-content/plugins/wp-cerber/assets/flags/vn.gif'),
 (5305, 'wp-content/plugins/wp-cerber/assets/flags/vu.gif'),
 (5306, 'wp-content/plugins/wp-cerber/assets/flags/wf.gif'),
 (5307, 'wp-content/plugins/wp-cerber/assets/flags/ws.gif'),
 (5308, 'wp-content/plugins/wp-cerber/assets/flags/ye.gif'),
 (5309, 'wp-content/plugins/wp-cerber/assets/flags/yt.gif'),
 (5310, 'wp-content/plugins/wp-cerber/assets/flags/za.gif'),
 (5311, 'wp-content/plugins/wp-cerber/assets/flags/zm.gif'),
 (5312, 'wp-content/plugins/wp-cerber/assets/flags/zw.gif'),
 (5313, 'wp-content/plugins/wp-cerber/assets/fonts/cerber.eot'),
 (5314, 'wp-content/plugins/wp-cerber/assets/fonts/cerber.ttf'),
 (5315, 'wp-content/plugins/wp-cerber/assets/fonts/cerber.woff'),
 (5316, 'wp-content/plugins/wp-cerber/assets/fonts/roboto/LICENSE.txt'),
 (5317, 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Bold.woff'),
 (5318, 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Light.woff'),
 (5319, 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Medium.woff'),
 (5320, 'wp-content/plugins/wp-cerber/assets/fonts/roboto/Roboto-Regular.woff'),
 (5321, 'wp-content/plugins/wp-cerber/assets/goo-translate.png'),
 (5322, 'wp-content/plugins/wp-cerber/assets/icon-128x128.png'),
 (5323, 'wp-content/plugins/wp-cerber/assets/icon-256x256.png'),
 (5324, 'wp-content/plugins/wp-cerber/assets/icons/fonts/crb.svg'),
 (5325, 'wp-content/plugins/wp-cerber/assets/icons/fonts/crb.ttf'),
 (5326, 'wp-content/plugins/wp-cerber/assets/icons/fonts/crb.woff'),
 (5327, 'wp-content/plugins/wp-cerber/assets/icons/style.css'),
 (5328, 'wp-content/plugins/wp-cerber/assets/inspector.png'),
 (5329, 'wp-content/plugins/wp-cerber/assets/magnific/LICENSE'),
 (5330, 'wp-content/plugins/wp-cerber/assets/magnific/jquery.magnific-popup.min.js'),
 (5331, 'wp-content/plugins/wp-cerber/assets/magnific/magnific-popup.css'),
 (5332, 'wp-content/plugins/wp-cerber/assets/multi/license.txt'),
 (5333, 'wp-content/plugins/wp-cerber/assets/multi/multi.css'),
 (5334, 'wp-content/plugins/wp-cerber/assets/multi/multi.js'),
 (5335, 'wp-content/plugins/wp-cerber/assets/multi/multi.min.js'),
 (5336, 'wp-content/plugins/wp-cerber/assets/nexus.css'),
 (5337, 'wp-content/plugins/wp-cerber/assets/rateit.png'),
 (5338, 'wp-content/plugins/wp-cerber/assets/rateit2.png'),
 (5339, 'wp-content/plugins/wp-cerber/assets/scanner.js'),
 (5340, 'wp-content/plugins/wp-cerber/assets/select2/LICENSE.md'),
 (5341, 'wp-content/plugins/wp-cerber/assets/select2/dist/css/select2.min.css'),
 (5342, 'wp-content/plugins/wp-cerber/assets/select2/dist/js/select2.min.js'),
 (5343, 'wp-content/plugins/wp-cerber/assets/sh/scripts/shBrushPhp.js'),
 (5344, 'wp-content/plugins/wp-cerber/assets/sh/scripts/shCore.js'),
 (5345, 'wp-content/plugins/wp-cerber/assets/sh/styles/shCore.css'),
 (5346, 'wp-content/plugins/wp-cerber/assets/sh/styles/shThemeDefault.css'),
 (5347, 'wp-content/plugins/wp-cerber/assets/tpicker/jquery.timepicker.min.css'),
 (5348, 'wp-content/plugins/wp-cerber/assets/tpicker/jquery.timepicker.min.js'),
 (5349, 'wp-content/plugins/wp-cerber/assets/wp-admin.js'),
 (5350, 'wp-content/plugins/wp-cerber/assets/wrench.png'),
 (5351, 'wp-content/plugins/wp-cerber/cerber-2fa.php'),
 (5352, 'wp-content/plugins/wp-cerber/cerber-addons.php'),
 (5353, 'wp-content/plugins/wp-cerber/cerber-ds.php'),
 (5354, 'wp-content/plugins/wp-cerber/cerber-lab.php'),
 (5355, 'wp-content/plugins/wp-cerber/cerber-load.php'),
 (5356, 'wp-content/plugins/wp-cerber/cerber-maintenance.php'),
 (5357, 'wp-content/plugins/wp-cerber/cerber-news.php'),
 (5358, 'wp-content/plugins/wp-cerber/cerber-pluggable.php'),
 (5359, 'wp-content/plugins/wp-cerber/cerber-request.php'),
 (5360, 'wp-content/plugins/wp-cerber/cerber-scanner.php'),
 (5361, 'wp-content/plugins/wp-cerber/cerber-tools.php'),
 (5362, 'wp-content/plugins/wp-cerber/cerber-users.php'),
 (5363, 'wp-content/plugins/wp-cerber/changelog.txt'),
 (5364, 'wp-content/plugins/wp-cerber/common.php'),
 (5365, 'wp-content/plugins/wp-cerber/dashboard.php'),
 (5366, 'wp-content/plugins/wp-cerber/index.php'),
 (5367, 'wp-content/plugins/wp-cerber/jetflow.php'),
 (5368, 'wp-content/plugins/wp-cerber/languages/wp-cerber-bs_BA.mo'),
 (5369, 'wp-content/plugins/wp-cerber/languages/wp-cerber-bs_BA.po'),
 (5370, 'wp-content/plugins/wp-cerber/languages/wp-cerber-cs_CZ.mo'),
 (5371, 'wp-content/plugins/wp-cerber/languages/wp-cerber-cs_CZ.po'),
 (5372, 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_CH.mo'),
 (5373, 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_CH.po'),
 (5374, 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_DE.mo'),
 (5375, 'wp-content/plugins/wp-cerber/languages/wp-cerber-de_DE.po'),
 (5376, 'wp-content/plugins/wp-cerber/languages/wp-cerber-es_ES.mo'),
 (5377, 'wp-content/plugins/wp-cerber/languages/wp-cerber-es_ES.po'),
 (5378, 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_CA.mo'),
 (5379, 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_CA.po'),
 (5380, 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_FR.mo'),
 (5381, 'wp-content/plugins/wp-cerber/languages/wp-cerber-fr_FR.po'),
 (5382, 'wp-content/plugins/wp-cerber/languages/wp-cerber-it_IT.mo'),
 (5383, 'wp-content/plugins/wp-cerber/languages/wp-cerber-it_IT.po'),
 (5384, 'wp-content/plugins/wp-cerber/languages/wp-cerber-lt_LT.mo'),
 (5385, 'wp-content/plugins/wp-cerber/languages/wp-cerber-lt_LT.po'),
 (5386, 'wp-content/plugins/wp-cerber/languages/wp-cerber-nb_NO.mo'),
 (5387, 'wp-content/plugins/wp-cerber/languages/wp-cerber-nb_NO.po'),
 (5388, 'wp-content/plugins/wp-cerber/languages/wp-cerber-nl_NL.mo'),
 (5389, 'wp-content/plugins/wp-cerber/languages/wp-cerber-nl_NL.po'),
 (5390, 'wp-content/plugins/wp-cerber/languages/wp-cerber-pl_PL.mo'),
 (5391, 'wp-content/plugins/wp-cerber/languages/wp-cerber-pl_PL.po'),
 (5392, 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_BR.mo'),
 (5393, 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_BR.po'),
 (5394, 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_PT.mo'),
 (5395, 'wp-content/plugins/wp-cerber/languages/wp-cerber-pt_PT.po'),
 (5396, 'wp-content/plugins/wp-cerber/languages/wp-cerber-ru_RU.mo'),
 (5397, 'wp-content/plugins/wp-cerber/languages/wp-cerber-ru_RU.po'),
 (5398, 'wp-content/plugins/wp-cerber/languages/wp-cerber-sr_RS.mo'),
 (5399, 'wp-content/plugins/wp-cerber/languages/wp-cerber-sr_RS.po'),
 (5400, 'wp-content/plugins/wp-cerber/languages/wp-cerber-sv_SE.mo'),
 (5401, 'wp-content/plugins/wp-cerber/languages/wp-cerber-sv_SE.po'),
 (5402, 'wp-content/plugins/wp-cerber/languages/wp-cerber-uk.mo'),
 (5403, 'wp-content/plugins/wp-cerber/languages/wp-cerber-uk.po'),
 (5404, 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_CN.mo'),
 (5405, 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_CN.po'),
 (5406, 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_TW.mo'),
 (5407, 'wp-content/plugins/wp-cerber/languages/wp-cerber-zh_TW.po'),
 (5408, 'wp-content/plugins/wp-cerber/languages/wp-cerber.pot'),
 (5409, 'wp-content/plugins/wp-cerber/modules/aaa-wp-cerber.php'),
 (5410, 'wp-content/plugins/wp-cerber/nexus/cerber-nexus-master.php'),
 (5411, 'wp-content/plugins/wp-cerber/nexus/cerber-nexus-slave.php'),
 (5412, 'wp-content/plugins/wp-cerber/nexus/cerber-nexus.php'),
 (5413, 'wp-content/plugins/wp-cerber/nexus/cerber-slave-list.php'),
 (5414, 'wp-content/plugins/wp-cerber/readme.txt'),
 (5415, 'wp-content/plugins/wp-cerber/ripe.php'),
 (5416, 'wp-content/plugins/wp-cerber/settings.php'),
 (5417, 'wp-content/plugins/wp-cerber/whois.php'),
 (5418, 'wp-content/plugins/wp-cerber/wp-cerber.php'),
 (5419, 'wp-content/themes/index.php'),
 (5420, 'wp-content/themes/kallyas/404-smart-area.php'),
 (5421, 'wp-content/themes/kallyas/404-standard.php'),
 (5422, 'wp-content/themes/kallyas/404.php'),
 (5423, 'wp-content/themes/kallyas/addons/countdown/jquery.countdown.min.js'),
 (5424, 'wp-content/themes/kallyas/addons/flickrfeed/jquery.jflickrfeed.min.js'),
 (5425, 'wp-content/themes/kallyas/addons/isotope-addons/packery-mode.pkgd.min.js'),
 (5426, 'wp-content/themes/kallyas/addons/jquery_loupe/jquery.loupe.js'),
 (5427, 'wp-content/themes/kallyas/addons/kl_socialicons_font/kl-social-icons.svg'),
 (5428, 'wp-content/themes/kallyas/addons/raphael_diagram/init.js'),
 (5429, 'wp-content/themes/kallyas/addons/raphael_diagram/raphael.js'),
 (5430, 'wp-content/themes/kallyas/addons/sc_weather/fonts/icomoon.svg'),
 (5431, 'wp-content/themes/kallyas/addons/scrollmagic/debug.addIndicators.min.js'),
 (5432, 'wp-content/themes/kallyas/addons/scrollmagic/scrollMagic-fullPacked.js'),
 (5433, 'wp-content/themes/kallyas/addons/scrollmagic/scrollmagic-tweenlite.js'),
 (5434, 'wp-content/themes/kallyas/addons/scrollmagic/scrollmagic.js'),
 (5435, 'wp-content/themes/kallyas/addons/slick/slick.js'),
 (5436, 'wp-content/themes/kallyas/addons/slick/slick.min.js'),
 (5437, 'wp-content/themes/kallyas/addons/smooth_scroll/SmoothScroll.js'),
 (5438, 'wp-content/themes/kallyas/addons/smooth_scroll/SmoothScroll.min.js'),
 (5439, 'wp-content/themes/kallyas/addons/wowjs/wow.js'),
 (5440, 'wp-content/themes/kallyas/archive-documentation.php'),
 (5441, 'wp-content/themes/kallyas/archive-portfolio.php'),
 (5442, 'wp-content/themes/kallyas/archive.php'),
 (5443, 'wp-content/themes/kallyas/blog-columns.php'),
 (5444, 'wp-content/themes/kallyas/blog-default.php'),
 (5445, 'wp-content/themes/kallyas/comments.php'),
 (5446, 'wp-content/themes/kallyas/components/blog/blog-default-def_classic.php'),
 (5447, 'wp-content/themes/kallyas/components/blog/blog-default-def_modern.php'),
 (5448, 'wp-content/themes/kallyas/components/blog/blog-item-comments.php'),
 (5449, 'wp-content/themes/kallyas/components/blog/blog-links.php'),
 (5450, 'wp-content/themes/kallyas/components/blog/blog-meta.php'),
 (5451, 'wp-content/themes/kallyas/components/blog/blog-noposts.php'),
 (5452, 'wp-content/themes/kallyas/components/blog/blog-pagination.php'),
 (5453, 'wp-content/themes/kallyas/components/blog/default-classic/blog-bottom.php'),
 (5454, 'wp-content/themes/kallyas/components/blog/default-classic/blog-content.php'),
 (5455, 'wp-content/themes/kallyas/components/blog/default-modern/blog-footer.php'),
 (5456, 'wp-content/themes/kallyas/components/blog/default-modern/blog-header.php'),
 (5457, 'wp-content/themes/kallyas/components/blog/default-modern/blog-img.php'),
 (5458, 'wp-content/themes/kallyas/components/blog/default-modern/blog-readmore.php'),
 (5459, 'wp-content/themes/kallyas/components/blog/default-modern/blog-title.php'),
 (5460, 'wp-content/themes/kallyas/components/blog/default-single-classic/single-author.php'),
 (5461, 'wp-content/themes/kallyas/components/blog/default-single-classic/single-content.php'),
 (5462, 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details-author.php'),
 (5463, 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details-category.php'),
 (5464, 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details-date.php'),
 (5465, 'wp-content/themes/kallyas/components/blog/default-single-classic/single-details.php'),
 (5466, 'wp-content/themes/kallyas/components/blog/default-single-classic/single-main.php'),
 (5467, 'wp-content/themes/kallyas/components/blog/default-single-common/single-pagelinks.php'),
 (5468, 'wp-content/themes/kallyas/components/blog/default-single-common/single-related-item.php'),
 (5469, 'wp-content/themes/kallyas/components/blog/default-single-common/single-related-title.php'),
 (5470, 'wp-content/themes/kallyas/components/blog/default-single-common/single-related.php'),
 (5471, 'wp-content/themes/kallyas/components/blog/default-single-common/single-social-custom.php'),
 (5472, 'wp-content/themes/kallyas/components/blog/default-single-common/single-social-generic.php'),
 (5473, 'wp-content/themes/kallyas/components/blog/default-single-common/single-social.php'),
 (5474, 'wp-content/themes/kallyas/components/blog/default-single-common/single-tags.php'),
 (5475, 'wp-content/themes/kallyas/components/blog/default-single-modern/single-content.php'),
 (5476, 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details-author.php'),
 (5477, 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details-category.php'),
 (5478, 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details-date.php'),
 (5479, 'wp-content/themes/kallyas/components/blog/default-single-modern/single-details.php'),
 (5480, 'wp-content/themes/kallyas/components/blog/default-single-modern/single-main.php'),
 (5481, 'wp-content/themes/kallyas/components/blog/multicolumns/blog-content.php'),
 (5482, 'wp-content/themes/kallyas/components/blog/multicolumns/blog-media.php'),
 (5483, 'wp-content/themes/kallyas/components/blog/multicolumns/blog-tags.php'),
 (5484, 'wp-content/themes/kallyas/components/masks/mask3.php'),
 (5485, 'wp-content/themes/kallyas/components/masks/mask4.php'),
 (5486, 'wp-content/themes/kallyas/components/masks/mask5.php'),
 (5487, 'wp-content/themes/kallyas/components/masks/mask6.php'),
 (5488, 'wp-content/themes/kallyas/components/masks/mask7.php'),
 (5489, 'wp-content/themes/kallyas/components/masks/mask8.php'),
 (5490, 'wp-content/themes/kallyas/components/masks/masks-functions.php'),
 (5491, 'wp-content/themes/kallyas/components/theme-header/header-components.php'),
 (5492, 'wp-content/themes/kallyas/components/theme-header/header-main.php'),
 (5493, 'wp-content/themes/kallyas/components/theme-header/header-markup-bottom.php'),
 (5494, 'wp-content/themes/kallyas/components/theme-header/header-markup-main.php'),
 (5495, 'wp-content/themes/kallyas/components/theme-header/header-markup-topbar.php'),
 (5496, 'wp-content/themes/kallyas/components/theme-header/header-markup.php'),
 (5497, 'wp-content/themes/kallyas/components/theme-header/header-style-default.php'),
 (5498, 'wp-content/themes/kallyas/components/theme-header/header-style1.php'),
 (5499, 'wp-content/themes/kallyas/components/theme-header/header-style10.php'),
 (5500, 'wp-content/themes/kallyas/components/theme-header/header-style11.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(5501, 'wp-content/themes/kallyas/components/theme-header/header-style12.php'),
 (5502, 'wp-content/themes/kallyas/components/theme-header/header-style13.php'),
 (5503, 'wp-content/themes/kallyas/components/theme-header/header-style14.php'),
 (5504, 'wp-content/themes/kallyas/components/theme-header/header-style15.php'),
 (5505, 'wp-content/themes/kallyas/components/theme-header/header-style16.php'),
 (5506, 'wp-content/themes/kallyas/components/theme-header/header-style17.php'),
 (5507, 'wp-content/themes/kallyas/components/theme-header/header-style2.php'),
 (5508, 'wp-content/themes/kallyas/components/theme-header/header-style3.php'),
 (5509, 'wp-content/themes/kallyas/components/theme-header/header-style4.php'),
 (5510, 'wp-content/themes/kallyas/components/theme-header/header-style5.php'),
 (5511, 'wp-content/themes/kallyas/components/theme-header/header-style6.php'),
 (5512, 'wp-content/themes/kallyas/components/theme-header/header-style7.php'),
 (5513, 'wp-content/themes/kallyas/components/theme-header/header-style8.php'),
 (5514, 'wp-content/themes/kallyas/components/theme-header/header-style9.php'),
 (5515, 'wp-content/themes/kallyas/components/theme-subheader/subheader-default.php'),
 (5516, 'wp-content/themes/kallyas/components/theme-subheader/subheader-documentation.php'),
 (5517, 'wp-content/themes/kallyas/css/dynamic_css.php'),
 (5518, 'wp-content/themes/kallyas/deprecated.php'),
 (5519, 'wp-content/themes/kallyas/fonts/glyphicons-halflings-regular.svg'),
 (5520, 'wp-content/themes/kallyas/footer.php'),
 (5521, 'wp-content/themes/kallyas/framework/class-gdpr.php'),
 (5522, 'wp-content/themes/kallyas/framework/compatibility/config.php'),
 (5523, 'wp-content/themes/kallyas/framework/compatibility/framework.php'),
 (5524, 'wp-content/themes/kallyas/framework/compatibility/metafields.php'),
 (5525, 'wp-content/themes/kallyas/framework/compatibility/shortcodes.php'),
 (5526, 'wp-content/themes/kallyas/framework/compatibility/termmeta.php'),
 (5527, 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/admin-mega-menu.js'),
 (5528, 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/html.js'),
 (5529, 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/zn_modal.js'),
 (5530, 'wp-content/themes/kallyas/framework/hg-theme-framework/assets/js/zn_theme_ajax_callback.js'),
 (5531, 'wp-content/themes/kallyas/framework/hg-theme-framework/hg-theme-framework.php'),
 (5532, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/addons_manager/class-addons-manager.php'),
 (5533, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/addons_manager/ui/tmpl-addons-list.php'),
 (5534, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_about.js'),
 (5535, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_theme_check.js'),
 (5536, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/class-zn-admin.php'),
 (5537, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_DemoImportHelper.php'),
 (5538, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_ThemeDemoImporter.php'),
 (5539, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-init.js'),
 (5540, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-manager.js'),
 (5541, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/content-tmpl.php'),
 (5542, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/dummy_data-tmpl.php'),
 (5543, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/footer-tmpl.php'),
 (5544, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/form-register-theme-tmpl.php'),
 (5545, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/header-tmpl.php'),
 (5546, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/register-tmpl.php'),
 (5547, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check-amazon.php'),
 (5548, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check.php'),
 (5549, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/api/ZN_HogashDashboard.php'),
 (5550, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/components/ajax-load-more.php'),
 (5551, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/components/index.php'),
 (5552, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/dependency-management/class-dependency-management.php'),
 (5553, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/dependency-management/ui/frontend-notice.php'),
 (5554, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-backend.php'),
 (5555, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-frontend.php'),
 (5556, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-helper.php'),
 (5557, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/functions-image-helpers.php'),
 (5558, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/helpers/theme_ajax.php'),
 (5559, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/html/class-html-integration.php'),
 (5560, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/html/fields/theme_import_export.php'),
 (5561, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/installer/class-theme-install.php'),
 (5562, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-about.php'),
 (5563, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-update.php'),
 (5564, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/integrations/admin-bar.php'),
 (5565, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/integrations/rev-slider-integration.php'),
 (5566, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/integrations/znhgfw_integration.php'),
 (5567, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu-admin.php'),
 (5568, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu.php'),
 (5569, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/options-exporter/ZnThemeImportExport.php'),
 (5570, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/scripts-manager/class-scripts-manager.php'),
 (5571, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/updater/class-theme-updater.php'),
 (5572, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/updater/inc/options.php'),
 (5573, 'wp-content/themes/kallyas/framework/hg-theme-framework/inc/utility/class-utility.php'),
 (5574, 'wp-content/themes/kallyas/framework/hogash-mailchimp/assets/js/hg-mailchimp.js'),
 (5575, 'wp-content/themes/kallyas/framework/hogash-mailchimp/hogash-mailchimp.php'),
 (5576, 'wp-content/themes/kallyas/framework/hogash-mailchimp/includes/options.php'),
 (5577, 'wp-content/themes/kallyas/framework/hogash-mailchimp/lib/HG_MCAPI.php'),
 (5578, 'wp-content/themes/kallyas/framework/hogash-mailchimp/lib/class_gdpr.php'),
 (5579, 'wp-content/themes/kallyas/framework/hogash-mailchimp/pb_element/newsletter/newsletter.php'),
 (5580, 'wp-content/themes/kallyas/framework/hogash-mailchimp/widget/widget-mailchimp.php'),
 (5581, 'wp-content/themes/kallyas/framework/zion-builder/assets/icons/zn-framework.svg'),
 (5582, 'wp-content/themes/kallyas/framework/zion-builder/assets/img/pb_col_plus_x.svg'),
 (5583, 'wp-content/themes/kallyas/framework/zion-builder/assets/img/pb_col_plus_y.svg'),
 (5584, 'wp-content/themes/kallyas/framework/zion-builder/assets/img/svg-icons.svg'),
 (5585, 'wp-content/themes/kallyas/framework/zion-builder/assets/js/admin/edit-screen.js'),
 (5586, 'wp-content/themes/kallyas/framework/zion-builder/assets/js/admin/yoast-integration.js'),
 (5587, 'wp-content/themes/kallyas/framework/zion-builder/dist/gutenberg_integration.bundle.js'),
 (5588, 'wp-content/themes/kallyas/framework/zion-builder/dist/znpb_editor.bundle.js'),
 (5589, 'wp-content/themes/kallyas/framework/zion-builder/dist/znpb_frontend.bundle.js'),
 (5590, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/img/select-arrow.svg'),
 (5591, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.js'),
 (5592, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.min.js'),
 (5593, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.js'),
 (5594, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.min.js'),
 (5595, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.isotope.min.js'),
 (5596, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.timepicker.min.js'),
 (5597, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/ace.js'),
 (5598, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-css.js'),
 (5599, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-html.js'),
 (5600, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-javascript.js'),
 (5601, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/theme-chrome.js'),
 (5602, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-css.js'),
 (5603, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-html.js'),
 (5604, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-javascript.js'),
 (5605, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/wp-color-picker-alpha.js'),
 (5606, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_html_script.js'),
 (5607, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_media.js'),
 (5608, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_modal.js'),
 (5609, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/class-znhgfw.php'),
 (5610, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/hg-framework.php'),
 (5611, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/font-manager/ZnTypekitClient.php'),
 (5612, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/font-manager/class-font-manager.php'),
 (5613, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/font-manager/google_fonts.php'),
 (5614, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-color-helpers.php'),
 (5615, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-helpers.php'),
 (5616, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/helpers/loader.php'),
 (5617, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-data-source.php'),
 (5618, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-field.php'),
 (5619, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-form.php'),
 (5620, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/class-html.php'),
 (5621, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/data_source/class-pages-data-source.php'),
 (5622, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/background.php'),
 (5623, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/boxmodel.php'),
 (5624, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/buttons.php'),
 (5625, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/checkbox.php'),
 (5626, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/colorpicker.php'),
 (5627, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_format.php'),
 (5628, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_picker.php'),
 (5629, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/day_picker.php'),
 (5630, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/font.php'),
 (5631, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/gallery.php'),
 (5632, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group.php'),
 (5633, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_select.php'),
 (5634, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_text.php'),
 (5635, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/hidden.php'),
 (5636, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/icon_list.php'),
 (5637, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/image_size.php'),
 (5638, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/link.php'),
 (5639, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/media.php'),
 (5640, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/options_wrapper.php'),
 (5641, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/radio_image.php'),
 (5642, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/select.php'),
 (5643, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/sidebar.php'),
 (5644, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/slider.php'),
 (5645, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_select.php'),
 (5646, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_slider.php'),
 (5647, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/tabbed_form.php'),
 (5648, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/text.php'),
 (5649, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/textarea.php'),
 (5650, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle.php'),
 (5651, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle2.php'),
 (5652, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/upload.php'),
 (5653, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/visual_editor.php'),
 (5654, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/widget_positions.php'),
 (5655, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_ajax_call.php'),
 (5656, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_google_fonts_setup.php'),
 (5657, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_message.php'),
 (5658, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_radio.php'),
 (5659, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_title.php'),
 (5660, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/html/forms/theme_form.php'),
 (5661, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/icon-manager/class-icon-manager.php'),
 (5662, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/image-resizer/class-image-resize.php'),
 (5663, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/metaboxes/class-metabox.php'),
 (5664, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/permalinks/class-permalinks.php'),
 (5665, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/scripts-manager/class-scripts-manager.php'),
 (5666, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/HG_Shortcode.php'),
 (5667, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/class-shortcodes-manager.php'),
 (5668, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/taxonomies/class-termmeta.php'),
 (5669, 'wp-content/themes/kallyas/framework/zion-builder/hg-framework/inc/utility/class-utility.php'),
 (5670, 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionElement.php'),
 (5671, 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionElementsManager.php'),
 (5672, 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionPageBuilderCustomCode.php'),
 (5673, 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionPageBuilderFrontend.php'),
 (5674, 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionScriptsManager.php'),
 (5675, 'wp-content/themes/kallyas/framework/zion-builder/inc/ZionWordPressSearch.php'),
 (5676, 'wp-content/themes/kallyas/framework/zion-builder/inc/admin/ZionPageBuilderAdmin.php'),
 (5677, 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/ZionEditor.php'),
 (5678, 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/ZionPageBuilderExportHelper.php'),
 (5679, 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/ZionTemplateSystem.php'),
 (5680, 'wp-content/themes/kallyas/framework/zion-builder/inc/editor/class-page-builder-ajax.php'),
 (5681, 'wp-content/themes/kallyas/framework/zion-builder/inc/helpers/helpers-frontend.php'),
 (5682, 'wp-content/themes/kallyas/framework/zion-builder/inc/helpers/helpers-help.php'),
 (5683, 'wp-content/themes/kallyas/framework/zion-builder/inc/index-page-builder.php'),
 (5684, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/class-base-integration.php'),
 (5685, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/class-integration-manager.php'),
 (5686, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg.php'),
 (5687, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg_integration.php'),
 (5688, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_nextgengallery_integration.php'),
 (5689, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_paid_membership_integration.php'),
 (5690, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_polylang_integration.php'),
 (5691, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_woocommerce_integration.php'),
 (5692, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_revisions.php'),
 (5693, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_widgets.php'),
 (5694, 'wp-content/themes/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_yoast_integration.php'),
 (5695, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/accordion/accordion.php'),
 (5696, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/anchor_point/anchor_point.php'),
 (5697, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/button/button.php'),
 (5698, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/column/column.php'),
 (5699, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/contact_form/cf-template.php'),
 (5700, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/contact_form/contact_form.php'),
 (5701, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/custom_html/custom_html.php'),
 (5702, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/google_map/assets/gmaps.js'),
 (5703, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/google_map/google_map.php'),
 (5704, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/heading/heading.php'),
 (5705, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/icon/icon.php'),
 (5706, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/icon_list/icon_list.php'),
 (5707, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/image/image.php'),
 (5708, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/revolution_slider/revolution_slider.php'),
 (5709, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/section/section.php'),
 (5710, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/separator/separator.php'),
 (5711, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/sidebar/sidebar.php'),
 (5712, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/smart_area/smart_area.php'),
 (5713, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/smart_container/smart_container.php'),
 (5714, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/spacer/spacer.php'),
 (5715, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/tabs/tabs.php'),
 (5716, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/text_box/text_box.php'),
 (5717, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/video/video.php'),
 (5718, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/widget/options.php'),
 (5719, 'wp-content/themes/kallyas/framework/zion-builder/inc/modules/widget/widget.php'),
 (5720, 'wp-content/themes/kallyas/framework/zion-builder/inc/smart_areas/ZionSmartArea.php'),
 (5721, 'wp-content/themes/kallyas/framework/zion-builder/inc/utility/ZionUtility.php'),
 (5722, 'wp-content/themes/kallyas/framework/zion-builder/zion-builder.php'),
 (5723, 'wp-content/themes/kallyas/framework/zn-framework.php'),
 (5724, 'wp-content/themes/kallyas/functions.php'),
 (5725, 'wp-content/themes/kallyas/header.php'),
 (5726, 'wp-content/themes/kallyas/images/admin/header-styles/style1.svg'),
 (5727, 'wp-content/themes/kallyas/images/admin/header-styles/style10.svg'),
 (5728, 'wp-content/themes/kallyas/images/admin/header-styles/style2.svg'),
 (5729, 'wp-content/themes/kallyas/images/admin/header-styles/style3.svg'),
 (5730, 'wp-content/themes/kallyas/images/admin/header-styles/style4.svg'),
 (5731, 'wp-content/themes/kallyas/images/admin/header-styles/style5.svg'),
 (5732, 'wp-content/themes/kallyas/images/admin/header-styles/style6.svg'),
 (5733, 'wp-content/themes/kallyas/images/admin/header-styles/style7.svg'),
 (5734, 'wp-content/themes/kallyas/images/admin/header-styles/style8.svg'),
 (5735, 'wp-content/themes/kallyas/images/admin/header-styles/style9.svg'),
 (5736, 'wp-content/themes/kallyas/images/admin/product-styles/product-style-01.svg'),
 (5737, 'wp-content/themes/kallyas/images/admin/product-styles/product-style-02.svg'),
 (5738, 'wp-content/themes/kallyas/images/admin/product-styles/product-style-more.svg'),
 (5739, 'wp-content/themes/kallyas/images/admin/site-layout/boxed.svg'),
 (5740, 'wp-content/themes/kallyas/images/admin/site-layout/fullwidth.svg'),
 (5741, 'wp-content/themes/kallyas/images/circle-arr-hover.svg'),
 (5742, 'wp-content/themes/kallyas/images/devices/iphone6.svg'),
 (5743, 'wp-content/themes/kallyas/images/devices/macbook-air.svg'),
 (5744, 'wp-content/themes/kallyas/images/devices/macbook.svg'),
 (5745, 'wp-content/themes/kallyas/images/index.html'),
 (5746, 'wp-content/themes/kallyas/images/kallyas-logo-dark.svg'),
 (5747, 'wp-content/themes/kallyas/images/kallyas-logo-sticky.svg'),
 (5748, 'wp-content/themes/kallyas/images/kallyas-logo.svg'),
 (5749, 'wp-content/themes/kallyas/images/macbook-air.svg'),
 (5750, 'wp-content/themes/kallyas/images/macbook.svg'),
 (5751, 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-added-listing-dark.svg'),
 (5752, 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-added-listing-light.svg'),
 (5753, 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-listing-dark.svg'),
 (5754, 'wp-content/themes/kallyas/images/products_listing_icons/ico-cart-listing-light.svg'),
 (5755, 'wp-content/themes/kallyas/images/products_listing_icons/ico-more-listing-dark.svg'),
 (5756, 'wp-content/themes/kallyas/images/products_listing_icons/ico-more-listing-light.svg'),
 (5757, 'wp-content/themes/kallyas/images/ring-alt.svg'),
 (5758, 'wp-content/themes/kallyas/images/select-arrow-dark.svg'),
 (5759, 'wp-content/themes/kallyas/images/select-arrow.svg'),
 (5760, 'wp-content/themes/kallyas/images/step-separator-dark.svg'),
 (5761, 'wp-content/themes/kallyas/images/step-separator.svg'),
 (5762, 'wp-content/themes/kallyas/inc/details-portfolio-fields.php'),
 (5763, 'wp-content/themes/kallyas/inc/details-portfolio-related.php'),
 (5764, 'wp-content/themes/kallyas/inc/details-portfolio.php'),
 (5765, 'wp-content/themes/kallyas/inc/loop-portfolio-media.php'),
 (5766, 'wp-content/themes/kallyas/inc/loop-portfolio_carousel.php'),
 (5767, 'wp-content/themes/kallyas/inc/loop-portfolio_category.php'),
 (5768, 'wp-content/themes/kallyas/inc/loop-portfolio_category_item.php'),
 (5769, 'wp-content/themes/kallyas/inc/loop-portfolio_sortable.php'),
 (5770, 'wp-content/themes/kallyas/inc/loop-portfolio_sortable_content.php'),
 (5771, 'wp-content/themes/kallyas/inc/page-content-view-page.inc.php'),
 (5772, 'wp-content/themes/kallyas/inc/page-content-view-portfolio.inc.php'),
 (5773, 'wp-content/themes/kallyas/inc/page-content-view-post.inc.php'),
 (5774, 'wp-content/themes/kallyas/inc/password-protected.inc.php'),
 (5775, 'wp-content/themes/kallyas/inc/single-product-template.php'),
 (5776, 'wp-content/themes/kallyas/index.php'),
 (5777, 'wp-content/themes/kallyas/js/plugins-src/debouncedresize.js'),
 (5778, 'wp-content/themes/kallyas/js/plugins-src/echo.js'),
 (5779, 'wp-content/themes/kallyas/js/plugins-src/fitvids.js'),
 (5780, 'wp-content/themes/kallyas/js/plugins-src/imagesloaded.pkgd.min.js'),
 (5781, 'wp-content/themes/kallyas/js/plugins-src/jquery.easing.js'),
 (5782, 'wp-content/themes/kallyas/js/plugins-src/magnificPopup.js'),
 (5783, 'wp-content/themes/kallyas/js/plugins.min.js'),
 (5784, 'wp-content/themes/kallyas/js/znscript.js'),
 (5785, 'wp-content/themes/kallyas/js/znscript.min.js'),
 (5786, 'wp-content/themes/kallyas/page-coming-soon.php'),
 (5787, 'wp-content/themes/kallyas/page.php'),
 (5788, 'wp-content/themes/kallyas/pagebuilder/elements/TH_3DCuteSlider/TH_3DCuteSlider.php'),
 (5789, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Accordion/TH_Accordion.php'),
 (5790, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Accordion/inc/ui.inc.php'),
 (5791, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ActionBox/TH_ActionBox.php'),
 (5792, 'wp-content/themes/kallyas/pagebuilder/elements/TH_BigSocial/TH_BigSocial.php'),
 (5793, 'wp-content/themes/kallyas/pagebuilder/elements/TH_BlogArchive/TH_BlogArchive.php'),
 (5794, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Buttons/TH_Buttons.php'),
 (5795, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CSS3Panels/TH_CSS3Panels.php'),
 (5796, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CallOutBanner/TH_CallOutBanner.php'),
 (5797, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircleTitleTextBox/TH_CircleTitleTextBox.php'),
 (5798, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularCatalogueCarousel/TH_CircularCatalogueCarousel.php'),
 (5799, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle1/TH_CircularContentStyle1.php'),
 (5800, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle1/inc/ui.inc.php'),
 (5801, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle2/TH_CircularContentStyle2.php'),
 (5802, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CircularContentStyle2/inc/ui.inc.php'),
 (5803, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Comments/TH_Comments.php'),
 (5804, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Countdown/TH_Countdown.php'),
 (5805, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CustomMenu/TH_CustomMenu.php'),
 (5806, 'wp-content/themes/kallyas/pagebuilder/elements/TH_CustomSubHeaderLayout/TH_CustomSubHeaderLayout.php'),
 (5807, 'wp-content/themes/kallyas/pagebuilder/elements/TH_DevicesImages/TH_DevicesImages.php'),
 (5808, 'wp-content/themes/kallyas/pagebuilder/elements/TH_DevicesImages/style.php'),
 (5809, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Documentation/TH_Documentation.php'),
 (5810, 'wp-content/themes/kallyas/pagebuilder/elements/TH_DocumentationHeader/TH_DocumentationHeader.php'),
 (5811, 'wp-content/themes/kallyas/pagebuilder/elements/TH_FancySlider/TH_FancySlider.php'),
 (5812, 'wp-content/themes/kallyas/pagebuilder/elements/TH_FeaturesBoxes/TH_FeaturesBoxes.php'),
 (5813, 'wp-content/themes/kallyas/pagebuilder/elements/TH_FeaturesBoxes/inc/ui.inc.php'),
 (5814, 'wp-content/themes/kallyas/pagebuilder/elements/TH_FeaturesBoxes2/TH_FeaturesBoxes2.php'),
 (5815, 'wp-content/themes/kallyas/pagebuilder/elements/TH_FlexSlider/TH_FlexSlider.php'),
 (5816, 'wp-content/themes/kallyas/pagebuilder/elements/TH_FlickrFeed/TH_FlickrFeed.php'),
 (5817, 'wp-content/themes/kallyas/pagebuilder/elements/TH_GridPhotoGallery/TH_GridPhotoGallery.php'),
 (5818, 'wp-content/themes/kallyas/pagebuilder/elements/TH_HistoricElement/TH_HistoricElement.php'),
 (5819, 'wp-content/themes/kallyas/pagebuilder/elements/TH_HorizontalTabs/TH_HorizontalTabs.php'),
 (5820, 'wp-content/themes/kallyas/pagebuilder/elements/TH_HoverBox/TH_HoverBox.php'),
 (5821, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/TH_ICarousel.php'),
 (5822, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/assets/icarousel.packed.js'),
 (5823, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/assets/jquery.mousewheel.js'),
 (5824, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ICarousel/assets/raphael-min.js'),
 (5825, 'wp-content/themes/kallyas/pagebuilder/elements/TH_IconBox/TH_IconBox.php'),
 (5826, 'wp-content/themes/kallyas/pagebuilder/elements/TH_IconBoxesGrid/TH_IconBoxesGrid.php'),
 (5827, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ImageBox/TH_ImageBox.php'),
 (5828, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ImageBox2/TH_ImageBox2.php'),
 (5829, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ImageGallery/TH_ImageGallery.php'),
 (5830, 'wp-content/themes/kallyas/pagebuilder/elements/TH_InfoBox/TH_InfoBox.php'),
 (5831, 'wp-content/themes/kallyas/pagebuilder/elements/TH_InfoBox2/TH_InfoBox2.php'),
 (5832, 'wp-content/themes/kallyas/pagebuilder/elements/TH_IosSlider/TH_IosSlider.php'),
 (5833, 'wp-content/themes/kallyas/pagebuilder/elements/TH_IosSlider/inc/ui.inc.php'),
 (5834, 'wp-content/themes/kallyas/pagebuilder/elements/TH_IosSlider2/TH_IosSlider2.php'),
 (5835, 'wp-content/themes/kallyas/pagebuilder/elements/TH_KeywordsElement/TH_KeywordsElement.php'),
 (5836, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LaptopSlider/TH_LaptopSlider.php'),
 (5837, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LaptopSlider/assets/macbook-air.svg'),
 (5838, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LaptopSlider/style.php'),
 (5839, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts/TH_LatestPosts.php'),
 (5840, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts2/TH_LatestPosts2.php'),
 (5841, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts3/TH_LatestPosts3.php'),
 (5842, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts4/TH_LatestPosts4.php'),
 (5843, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/default-style.php'),
 (5844, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/kl-style-2.php'),
 (5845, 'wp-content/themes/kallyas/pagebuilder/elements/TH_LatestPostsCarousel/TH_LatestPostsCarousel.php'),
 (5846, 'wp-content/themes/kallyas/pagebuilder/elements/TH_MediaContainer/TH_MediaContainer.php'),
 (5847, 'wp-content/themes/kallyas/pagebuilder/elements/TH_NewsletterBox/TH_NewsletterBox.php'),
 (5848, 'wp-content/themes/kallyas/pagebuilder/elements/TH_NivoSlider/TH_NivoSlider.php'),
 (5849, 'wp-content/themes/kallyas/pagebuilder/elements/TH_NivoSlider/assets/jquery.nivo.slider.pack.js'),
 (5850, 'wp-content/themes/kallyas/pagebuilder/elements/TH_NivoSlider/style.php'),
 (5851, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PageContent/TH_PageContent.php'),
 (5852, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PartnersLogos/TH_PartnersLogos.php'),
 (5853, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PartnersTestimonials/TH_PartnersTestimonials.php'),
 (5854, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/TH_PhotoGallery.php'),
 (5855, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/images/album-gallery.svg'),
 (5856, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/images/normal-gallery.svg'),
 (5857, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhotoGallery/images/slideshow-gallery.svg'),
 (5858, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PhpCode/TH_PhpCode.php'),
 (5859, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PortfolioArchive/TH_PortfolioArchive.php'),
 (5860, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PortfolioContent/TH_PortfolioContent.php'),
 (5861, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PortfolioSlider/TH_PortfolioSlider.php'),
 (5862, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PostContent/TH_PostContent.php'),
 (5863, 'wp-content/themes/kallyas/pagebuilder/elements/TH_PricingTable/TH_PricingTable.php'),
 (5864, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ProductArchive/TH_ProductArchive.php'),
 (5865, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ProductContent/TH_ProductContent.php'),
 (5866, 'wp-content/themes/kallyas/pagebuilder/elements/TH_RecentWork/TH_RecentWork.php'),
 (5867, 'wp-content/themes/kallyas/pagebuilder/elements/TH_RecentWork2/TH_RecentWork2.php'),
 (5868, 'wp-content/themes/kallyas/pagebuilder/elements/TH_RecentWork3/TH_RecentWork3.php'),
 (5869, 'wp-content/themes/kallyas/pagebuilder/elements/TH_RevolutionSlider/TH_RevolutionSlider.php'),
 (5870, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ScreenshotsBox/TH_ScreenshotsBox.php'),
 (5871, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ScreenshotsBox/style.php'),
 (5872, 'wp-content/themes/kallyas/pagebuilder/elements/TH_SearchBox/TH_SearchBox.php'),
 (5873, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ServiceBox/TH_ServiceBox.php'),
 (5874, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ServicesElement/TH_ServicesElement.php'),
 (5875, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ShopFeatures/TH_ShopFeatures.php'),
 (5876, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ShopLimitedOffers/TH_ShopLimitedOffers.php'),
 (5877, 'wp-content/themes/kallyas/pagebuilder/elements/TH_ShopProductsPresentation/TH_ShopProductsPresentation.php'),
 (5878, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Sidebar/TH_Sidebar.php'),
 (5879, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Skills/TH_Skills.php'),
 (5880, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Skills/diagram_el.js'),
 (5881, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Skills/raphael-min.js'),
 (5882, 'wp-content/themes/kallyas/pagebuilder/elements/TH_SocialIcons/TH_SocialIcons.php'),
 (5883, 'wp-content/themes/kallyas/pagebuilder/elements/TH_SpacerElement/TH_SpacerElement.php'),
 (5884, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StageImageBox/TH_StageImageBox.php'),
 (5885, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentBoxes/TH_StaticContentBoxes.php'),
 (5886, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentDefault/TH_StaticContentDefault.php'),
 (5887, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentEventCountdown/TH_StaticContentEventCountdown.php'),
 (5888, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentProductLoupe/TH_StaticContentProductLoupe.php'),
 (5889, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentReservationForm/TH_StaticContentReservationForm.php'),
 (5890, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentShowroomCarousel/TH_StaticContentShowroomCarousel.php'),
 (5891, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentSimpleText/TH_StaticContentSimpleText.php'),
 (5892, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentSimpleTextFullWidth/TH_StaticContentSimpleTextFullWidth.php'),
 (5893, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentTextAndRegister/TH_StaticContentTextAndRegister.php'),
 (5894, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentTextAndVideo/TH_StaticContentTextAndVideo.php'),
 (5895, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentTextPop/TH_StaticContentTextPop.php'),
 (5896, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentVideo/TH_StaticContentVideo.php'),
 (5897, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentVideoBackground/TH_StaticContentVideoBackground.php'),
 (5898, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/TH_StaticContentWeatherBox.php'),
 (5899, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/scwb.js'),
 (5900, 'wp-content/themes/kallyas/pagebuilder/elements/TH_Statistics/TH_Statistics.php'),
 (5901, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StatsBox/TH_StatsBox.php'),
 (5902, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox/TH_StepsBox.php'),
 (5903, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox2/TH_StepsBox2.php'),
 (5904, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox3/TH_StepsBox3.php'),
 (5905, 'wp-content/themes/kallyas/pagebuilder/elements/TH_StepsBox4/TH_StepsBox4.php'),
 (5906, 'wp-content/themes/kallyas/pagebuilder/elements/TH_TeamBox/TH_TeamBox.php'),
 (5907, 'wp-content/themes/kallyas/pagebuilder/elements/TH_TestimonialBox/TH_TestimonialBox.php'),
 (5908, 'wp-content/themes/kallyas/pagebuilder/elements/TH_TestimonialFader/TH_TestimonialFader.php'),
 (5909, 'wp-content/themes/kallyas/pagebuilder/elements/TH_TestimonialSlider/TH_TestimonialSlider.php'),
 (5910, 'wp-content/themes/kallyas/pagebuilder/elements/TH_TextBox/TH_TextBox.php'),
 (5911, 'wp-content/themes/kallyas/pagebuilder/elements/TH_TitleElement/TH_TitleElement.php'),
 (5912, 'wp-content/themes/kallyas/pagebuilder/elements/TH_VerticalTabs/TH_VerticalTabs.php'),
 (5913, 'wp-content/themes/kallyas/pagebuilder/elements/TH_VideoBox/TH_VideoBox.php'),
 (5914, 'wp-content/themes/kallyas/pagebuilder/elements/TH_WowSlider/TH_WowSlider.php'),
 (5915, 'wp-content/themes/kallyas/pagebuilder/elements/TH_WowSlider/assets/wowslider.js'),
 (5916, 'wp-content/themes/kallyas/pagebuilder/elements/TH_WowSlider/style.php'),
 (5917, 'wp-content/themes/kallyas/pagebuilder/elements/anchor_point/anchor_point.php'),
 (5918, 'wp-content/themes/kallyas/pagebuilder/elements/button/button.php'),
 (5919, 'wp-content/themes/kallyas/pagebuilder/elements/column/column.php'),
 (5920, 'wp-content/themes/kallyas/pagebuilder/elements/contact_form/cf-template.php'),
 (5921, 'wp-content/themes/kallyas/pagebuilder/elements/contact_form/contact_form.php'),
 (5922, 'wp-content/themes/kallyas/pagebuilder/elements/custom_container/custom_container.php'),
 (5923, 'wp-content/themes/kallyas/pagebuilder/elements/custom_html/custom_html.php'),
 (5924, 'wp-content/themes/kallyas/pagebuilder/elements/google_map/assets/gmaps.js'),
 (5925, 'wp-content/themes/kallyas/pagebuilder/elements/google_map/assets/markerclusterer.js'),
 (5926, 'wp-content/themes/kallyas/pagebuilder/elements/google_map/google_map.php'),
 (5927, 'wp-content/themes/kallyas/pagebuilder/elements/list/list.php'),
 (5928, 'wp-content/themes/kallyas/pagebuilder/elements/multi_layered/multi_layered.php'),
 (5929, 'wp-content/themes/kallyas/pagebuilder/elements/pb_template/pb_template.php'),
 (5930, 'wp-content/themes/kallyas/pagebuilder/elements/price_list/price_list.php'),
 (5931, 'wp-content/themes/kallyas/pagebuilder/elements/section/section.php'),
 (5932, 'wp-content/themes/kallyas/pagebuilder/elements/separator/separator.php'),
 (5933, 'wp-content/themes/kallyas/pagebuilder/elements/skill-bars/skill-bars.php'),
 (5934, 'wp-content/themes/kallyas/pagebuilder/elements/smart_carousel/smart_carousel.php'),
 (5935, 'wp-content/themes/kallyas/pagebuilder/elements/smart_slider/options.inc.php'),
 (5936, 'wp-content/themes/kallyas/pagebuilder/elements/smart_slider/smart_slider.php'),
 (5937, 'wp-content/themes/kallyas/pagebuilder/elements/sticky_section_lite/sticky_section_lite.php'),
 (5938, 'wp-content/themes/kallyas/pagebuilder/elements/tweetbox/tweetbox.php'),
 (5939, 'wp-content/themes/kallyas/pagebuilder/elements/widget/options.php'),
 (5940, 'wp-content/themes/kallyas/pagebuilder/elements/widget/widget.php'),
 (5941, 'wp-content/themes/kallyas/search.php'),
 (5942, 'wp-content/themes/kallyas/searchform.php'),
 (5943, 'wp-content/themes/kallyas/sidebar.php'),
 (5944, 'wp-content/themes/kallyas/single-documentation.php'),
 (5945, 'wp-content/themes/kallyas/single-portfolio.php'),
 (5946, 'wp-content/themes/kallyas/single.php'),
 (5947, 'wp-content/themes/kallyas/taxonomy-documentation_category.php'),
 (5948, 'wp-content/themes/kallyas/taxonomy-project_category.php'),
 (5949, 'wp-content/themes/kallyas/template_helpers/helper-functions.php'),
 (5950, 'wp-content/themes/kallyas/template_helpers/icons/glyphicons_halflingsregular/glyphicons_halflingsregular.svg'),
 (5951, 'wp-content/themes/kallyas/template_helpers/icons/glyphicons_halflingsregular/icon_list.php'),
 (5952, 'wp-content/themes/kallyas/template_helpers/icons/kl-social-icons/icon_list.php'),
 (5953, 'wp-content/themes/kallyas/template_helpers/icons/kl-social-icons/kl-social-icons.svg'),
 (5954, 'wp-content/themes/kallyas/template_helpers/metaboxes/metaboxes.php'),
 (5955, 'wp-content/themes/kallyas/template_helpers/metaboxes/metaboxes_locations.php'),
 (5956, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/404-page-options.php'),
 (5957, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/advanced-options.php'),
 (5958, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/blog-options/archive-options.php'),
 (5959, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/blog-options/single-blog-item-options.php'),
 (5960, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/color-options/color-options-palette.php'),
 (5961, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/color-options/color-options.php'),
 (5962, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/coming-soon-options.php'),
 (5963, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/documentation-options.php'),
 (5964, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/alternative-font-options.php'),
 (5965, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/body-fonts-options.php'),
 (5966, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/general-font-options.php'),
 (5967, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/headings-options.php'),
 (5968, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/font-options/main-menu-font-options.php'),
 (5969, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/cta-options.php'),
 (5970, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/default-header-options.php'),
 (5971, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/footer-options.php'),
 (5972, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/general-options.php'),
 (5973, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/google-analytics-options.php'),
 (5974, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/google-maps-options.php'),
 (5975, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/header-advanced-options.php'),
 (5976, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/header-options.php'),
 (5977, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/infocard-options.php'),
 (5978, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/logo-options.php'),
 (5979, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/nav-options.php'),
 (5980, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/general-options/recaptcha-options.php'),
 (5981, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/layout-options.php'),
 (5982, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/pb-templates.php'),
 (5983, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/portfolio-options.php'),
 (5984, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/unlimited-headers-options.php'),
 (5985, 'wp-content/themes/kallyas/template_helpers/options/theme-options-pages/unlimited-sidebars.php'),
 (5986, 'wp-content/themes/kallyas/template_helpers/options/theme-options.php'),
 (5987, 'wp-content/themes/kallyas/template_helpers/options/theme-pages.php'),
 (5988, 'wp-content/themes/kallyas/template_helpers/pagebuilder/page_options.php'),
 (5989, 'wp-content/themes/kallyas/template_helpers/pagebuilder/pagebuilder-animations.php'),
 (5990, 'wp-content/themes/kallyas/template_helpers/pagebuilder/pagebuilder-functions.php'),
 (5991, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/ht_year.php'),
 (5992, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_accordion.php'),
 (5993, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_accordion_container.php'),
 (5994, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_accordion_panel.php'),
 (5995, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_script_shortcode.php'),
 (5996, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_blockquote.php'),
 (5997, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_buttons.php'),
 (5998, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_code.php'),
 (5999, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_column.php'),
 (6000, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h1a.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(6001, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h2a.php'),
 (6002, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h3a.php'),
 (6003, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h4a.php'),
 (6004, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h5a.php'),
 (6005, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h6a.php'),
 (6006, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_icons.php'),
 (6007, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_list.php'),
 (6008, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_one_fourth_columns.php'),
 (6009, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_caption.php'),
 (6010, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_column.php'),
 (6011, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_table.php'),
 (6012, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_qr.php'),
 (6013, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_row.php'),
 (6014, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_sitemap.php'),
 (6015, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skill.php'),
 (6016, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skills.php'),
 (6017, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_social_share_icons.php'),
 (6018, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_subtitle.php'),
 (6019, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tab.php'),
 (6020, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_table.php'),
 (6021, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tabs.php'),
 (6022, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_columns.php'),
 (6023, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_fourth_columns.php'),
 (6024, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tooltip.php'),
 (6025, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_columns.php'),
 (6026, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_third_columns.php'),
 (6027, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/zn_shortcode_znhg_qr.php'),
 (6028, 'wp-content/themes/kallyas/template_helpers/shortcodes/classes/znhg_alternative_header.php'),
 (6029, 'wp-content/themes/kallyas/template_helpers/shortcodes/shortcodes.php'),
 (6030, 'wp-content/themes/kallyas/template_helpers/termmeta/termoptions.php'),
 (6031, 'wp-content/themes/kallyas/template_helpers/theme_layout_manager.php'),
 (6032, 'wp-content/themes/kallyas/template_helpers/tweeter-helper.php'),
 (6033, 'wp-content/themes/kallyas/template_helpers/update/scripts/kallyas-update-4.0.0.php'),
 (6034, 'wp-content/themes/kallyas/template_helpers/update/update_config.php'),
 (6035, 'wp-content/themes/kallyas/template_helpers/vendors/general/general-vendor.php'),
 (6036, 'wp-content/themes/kallyas/template_helpers/vendors/geo-directory/functions-geo-directory.php'),
 (6037, 'wp-content/themes/kallyas/template_helpers/vendors/hogash-post-love/config.php'),
 (6038, 'wp-content/themes/kallyas/template_helpers/vendors/sensei/functions-sensei.php'),
 (6039, 'wp-content/themes/kallyas/template_helpers/vendors/simple-job-board/functions-sjb.php'),
 (6040, 'wp-content/themes/kallyas/template_helpers/vendors/wp-hotel-booking/wp-hotel-booking.php'),
 (6041, 'wp-content/themes/kallyas/template_helpers/widgets/twitter/OAuth.php'),
 (6042, 'wp-content/themes/kallyas/template_helpers/widgets/twitter/twitteroauth.php'),
 (6043, 'wp-content/themes/kallyas/template_helpers/widgets/widget-archive.php'),
 (6044, 'wp-content/themes/kallyas/template_helpers/widgets/widget-blog-categories.php'),
 (6045, 'wp-content/themes/kallyas/template_helpers/widgets/widget-contact-details.php'),
 (6046, 'wp-content/themes/kallyas/template_helpers/widgets/widget-flickr.php'),
 (6047, 'wp-content/themes/kallyas/template_helpers/widgets/widget-latest_posts.php'),
 (6048, 'wp-content/themes/kallyas/template_helpers/widgets/widget-mailchimp.php'),
 (6049, 'wp-content/themes/kallyas/template_helpers/widgets/widget-menu.php'),
 (6050, 'wp-content/themes/kallyas/template_helpers/widgets/widget-social_buttons.php'),
 (6051, 'wp-content/themes/kallyas/template_helpers/widgets/widget-tag-cloud.php'),
 (6052, 'wp-content/themes/kallyas/template_helpers/widgets/widget-twitter.php'),
 (6053, 'wp-content/themes/kallyas/template_helpers/widgets/widgets.php'),
 (6054, 'wp-content/themes/kallyas/template_helpers/zion-integration/class_kallyas_integration.php'),
 (6055, 'wp-content/themes/kallyas/template_helpers/zion-integration/kallyas-element-base.php'),
 (6056, 'wp-content/themes/kallyas/th-action-hooks.php'),
 (6057, 'wp-content/themes/kallyas/th-custom-hooks.php'),
 (6058, 'wp-content/themes/kallyas/th-filter-hooks.php'),
 (6059, 'wp-content/themes/kallyas/theme-functions-override.php'),
 (6060, 'wp-content/themes/kallyas/woocommerce/product-searchform.php'),
 (6061, 'wp-content/themes/kallyas/woocommerce/product_gallery_v2/product_gallery.js'),
 (6062, 'wp-content/themes/kallyas/woocommerce/single-product-default.php'),
 (6063, 'wp-content/themes/kallyas/woocommerce/single-product-style3.php'),
 (6064, 'wp-content/themes/kallyas/woocommerce/woo_options.php'),
 (6065, 'wp-content/themes/kallyas/woocommerce/zn-woocommerce-init.php'),
 (6066, 'wp-content/themes/kallyas/woocommerce/zn-woocommerce-v2.php'),
 (6067, 'wp-content/themes/kallyas/woocommerce/zn-woocommerce-v3.php'),
 (6068, 'wp-content/themes/kallyas-child/functions.php'),
 (6069, 'wp-content/themes/kallyas-child/js/zn_script_child.js'),
 (6070, 'wp-content/updraft/index.html'),
 (6071, 'wp-content/updraft/plugins-old/akismet/_inc/akismet.js'),
 (6072, 'wp-content/updraft/plugins-old/akismet/_inc/form.js'),
 (6073, 'wp-content/updraft/plugins-old/akismet/akismet.php'),
 (6074, 'wp-content/updraft/plugins-old/akismet/class.akismet-admin.php'),
 (6075, 'wp-content/updraft/plugins-old/akismet/class.akismet-cli.php'),
 (6076, 'wp-content/updraft/plugins-old/akismet/class.akismet-rest-api.php'),
 (6077, 'wp-content/updraft/plugins-old/akismet/class.akismet-widget.php'),
 (6078, 'wp-content/updraft/plugins-old/akismet/class.akismet.php'),
 (6079, 'wp-content/updraft/plugins-old/akismet/index.php'),
 (6080, 'wp-content/updraft/plugins-old/akismet/views/activate.php'),
 (6081, 'wp-content/updraft/plugins-old/akismet/views/config.php'),
 (6082, 'wp-content/updraft/plugins-old/akismet/views/connect-jp.php'),
 (6083, 'wp-content/updraft/plugins-old/akismet/views/enter.php'),
 (6084, 'wp-content/updraft/plugins-old/akismet/views/get.php'),
 (6085, 'wp-content/updraft/plugins-old/akismet/views/notice.php'),
 (6086, 'wp-content/updraft/plugins-old/akismet/views/predefined.php'),
 (6087, 'wp-content/updraft/plugins-old/akismet/views/setup.php'),
 (6088, 'wp-content/updraft/plugins-old/akismet/views/start.php'),
 (6089, 'wp-content/updraft/plugins-old/akismet/views/stats.php'),
 (6090, 'wp-content/updraft/plugins-old/akismet/views/title.php'),
 (6091, 'wp-content/updraft/plugins-old/akismet/wrapper.php'),
 (6092, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-admin-js.js'),
 (6093, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-public-js.js'),
 (6094, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-timecircles.js'),
 (6095, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/assets/js/wpcdt-ui-timepicker-addon.js'),
 (6096, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/countdown-timer.php'),
 (6097, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/class-wpcdt-admin.php'),
 (6098, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/metabox/wpcdt-sett-metabox.php'),
 (6099, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/settings/hire-us.php'),
 (6100, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/settings/premium.php'),
 (6101, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/admin/wpcdt-how-it-work.php'),
 (6102, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/class-wpcdt-script.php'),
 (6103, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/shortcode/wpcdt-shortcode.php'),
 (6104, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/wpcdt-functions.php'),
 (6105, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/includes/wpcdt-post-types.php'),
 (6106, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/assets/js/wpos-anylc-admin.js'),
 (6107, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/includes/class-anylc-admin.php'),
 (6108, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/includes/class-anylc-script.php'),
 (6109, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/includes/wpos-anylc-function.php'),
 (6110, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/templates/analytic.php'),
 (6111, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/templates/offers.php'),
 (6112, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/templates/optout-popup.php'),
 (6113, 'wp-content/updraft/plugins-old/countdown-timer-ultimate/wpos-analytics/wpos-analytics.php'),
 (6114, 'wp-content/updraft/plugins-old/duplicator-pro/assets/css/images/index.php'),
 (6115, 'wp-content/updraft/plugins-old/duplicator-pro/assets/css/index.php'),
 (6116, 'wp-content/updraft/plugins-old/duplicator-pro/assets/img/index.php'),
 (6117, 'wp-content/updraft/plugins-old/duplicator-pro/assets/img/logo-menu.svg'),
 (6118, 'wp-content/updraft/plugins-old/duplicator-pro/assets/index.php'),
 (6119, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/dp-kick.js'),
 (6120, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/formstone/bundle.js'),
 (6121, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/formstone/index.php'),
 (6122, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/handlebars.min.js'),
 (6123, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/index.php'),
 (6124, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/javascript.php'),
 (6125, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jquery.qtip/index.php'),
 (6126, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jquery.qtip/jquery.qtip.min.js'),
 (6127, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jstree/index.php'),
 (6128, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jstree/jstree.js'),
 (6129, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/jstree/jstree.min.js'),
 (6130, 'wp-content/updraft/plugins-old/duplicator-pro/assets/js/parsley.min.js'),
 (6131, 'wp-content/updraft/plugins-old/duplicator-pro/assets/webfonts/index.php'),
 (6132, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Aws.php'),
 (6133, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/AbstractClient.php'),
 (6134, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/AwsClientInterface.php'),
 (6135, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/ClientBuilder.php'),
 (6136, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/DefaultClient.php'),
 (6137, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/ExpiredCredentialsChecker.php'),
 (6138, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/ThrottlingErrorChecker.php'),
 (6139, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/UploadBodyListener.php'),
 (6140, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/UserAgentListener.php'),
 (6141, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Client/index.php'),
 (6142, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/AwsQueryVisitor.php'),
 (6143, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/JsonCommand.php'),
 (6144, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/QueryCommand.php'),
 (6145, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/XmlResponseLocationVisitor.php'),
 (6146, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Command/index.php'),
 (6147, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/AbstractCredentialsDecorator.php'),
 (6148, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/AbstractRefreshableCredentials.php'),
 (6149, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/CacheableCredentials.php'),
 (6150, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/Credentials.php'),
 (6151, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/CredentialsInterface.php'),
 (6152, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/NullCredentials.php'),
 (6153, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php'),
 (6154, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Credentials/index.php'),
 (6155, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/ClientOptions.php'),
 (6156, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/DateFormat.php'),
 (6157, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/Region.php'),
 (6158, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/Size.php'),
 (6159, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/Time.php'),
 (6160, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/UaString.php'),
 (6161, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum/index.php'),
 (6162, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Enum.php'),
 (6163, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/AwsExceptionInterface.php'),
 (6164, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/BadMethodCallException.php'),
 (6165, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/DomainException.php'),
 (6166, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/ExceptionFactoryInterface.php'),
 (6167, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/ExceptionListener.php'),
 (6168, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/InstanceProfileCredentialsException.php'),
 (6169, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/InvalidArgumentException.php'),
 (6170, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/LogicException.php'),
 (6171, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/MultipartUploadException.php'),
 (6172, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/NamespaceExceptionFactory.php'),
 (6173, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/OutOfBoundsException.php'),
 (6174, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/OverflowException.php'),
 (6175, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php'),
 (6176, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php'),
 (6177, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/ExceptionParserInterface.php'),
 (6178, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php'),
 (6179, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/JsonRestExceptionParser.php'),
 (6180, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/Parser/index.php'),
 (6181, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/RequiredExtensionNotLoadedException.php'),
 (6182, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/RuntimeException.php'),
 (6183, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/ServiceResponseException.php'),
 (6184, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/TransferException.php'),
 (6185, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/UnexpectedValueException.php'),
 (6186, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Exception/index.php'),
 (6187, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/Facade.php'),
 (6188, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/FacadeInterface.php'),
 (6189, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/facade-classes.php'),
 (6190, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Facade/index.php'),
 (6191, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/ChunkHash.php'),
 (6192, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/ChunkHashInterface.php'),
 (6193, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/HashUtils.php'),
 (6194, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/TreeHash.php'),
 (6195, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Hash/index.php'),
 (6196, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/HostNameUtils.php'),
 (6197, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/InstanceMetadataClient.php'),
 (6198, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php'),
 (6199, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/Waiter/index.php'),
 (6200, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/InstanceMetadata/index.php'),
 (6201, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIterator.php'),
 (6202, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Iterator/AwsResourceIteratorFactory.php'),
 (6203, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Iterator/index.php'),
 (6204, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransfer.php'),
 (6205, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractTransferState.php'),
 (6206, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php'),
 (6207, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadId.php'),
 (6208, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php'),
 (6209, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferInterface.php'),
 (6210, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/TransferStateInterface.php'),
 (6211, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadIdInterface.php'),
 (6212, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/UploadPartInterface.php'),
 (6213, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/MultipartUpload/index.php'),
 (6214, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Model/index.php'),
 (6215, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/aws-config.php'),
 (6216, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/index.php'),
 (6217, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/public-endpoints.php'),
 (6218, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Resources/sdk1-config.php'),
 (6219, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/RulesEndpointProvider.php'),
 (6220, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/AbstractSignature.php'),
 (6221, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/EndpointSignatureInterface.php'),
 (6222, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureInterface.php'),
 (6223, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureListener.php'),
 (6224, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureV2.php'),
 (6225, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureV3Https.php'),
 (6226, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/SignatureV4.php'),
 (6227, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Signature/index.php'),
 (6228, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/AbstractResourceWaiter.php'),
 (6229, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/AbstractWaiter.php'),
 (6230, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/CallableWaiter.php'),
 (6231, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/CompositeWaiterFactory.php'),
 (6232, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/ConfigResourceWaiter.php'),
 (6233, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/ResourceWaiterInterface.php'),
 (6234, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterClassFactory.php'),
 (6235, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfig.php'),
 (6236, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterConfigFactory.php'),
 (6237, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterFactoryInterface.php'),
 (6238, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/WaiterInterface.php'),
 (6239, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/Waiter/index.php'),
 (6240, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/Common/index.php'),
 (6241, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/AcpListener.php'),
 (6242, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/BucketStyleListener.php'),
 (6243, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Command/S3Command.php'),
 (6244, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Command/index.php'),
 (6245, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/CannedAcl.php'),
 (6246, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/EncodingType.php'),
 (6247, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Event.php'),
 (6248, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/GranteeType.php'),
 (6249, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Group.php'),
 (6250, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/MFADelete.php'),
 (6251, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/MetadataDirective.php'),
 (6252, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Payer.php'),
 (6253, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Permission.php'),
 (6254, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Protocol.php'),
 (6255, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/ServerSideEncryption.php'),
 (6256, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Status.php'),
 (6257, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/Storage.php'),
 (6258, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/StorageClass.php'),
 (6259, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Enum/index.php'),
 (6260, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/AccessDeniedException.php'),
 (6261, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/AccountProblemException.php'),
 (6262, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php'),
 (6263, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BadDigestException.php'),
 (6264, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyExistsException.php'),
 (6265, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php'),
 (6266, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/BucketNotEmptyException.php'),
 (6267, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/CredentialsNotSupportedException.php'),
 (6268, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php'),
 (6269, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/DeleteMultipleObjectsException.php'),
 (6270, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/EntityTooLargeException.php'),
 (6271, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/EntityTooSmallException.php'),
 (6272, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ExpiredTokenException.php'),
 (6273, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/IllegalVersioningConfigurationException.php'),
 (6274, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/IncompleteBodyException.php'),
 (6275, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php'),
 (6276, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InlineDataTooLargeException.php'),
 (6277, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InternalErrorException.php'),
 (6278, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidAccessKeyIdException.php'),
 (6279, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidAddressingHeaderException.php'),
 (6280, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidArgumentException.php'),
 (6281, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketNameException.php'),
 (6282, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidBucketStateException.php'),
 (6283, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidDigestException.php'),
 (6284, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidLocationConstraintException.php'),
 (6285, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPartException.php'),
 (6286, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPartOrderException.php'),
 (6287, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPayerException.php'),
 (6288, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidPolicyDocumentException.php'),
 (6289, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidRangeException.php'),
 (6290, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidRequestException.php'),
 (6291, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidSOAPRequestException.php'),
 (6292, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidSecurityException.php'),
 (6293, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidStorageClassException.php'),
 (6294, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidTagErrorException.php'),
 (6295, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php'),
 (6296, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidTokenException.php'),
 (6297, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/InvalidURIException.php'),
 (6298, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/KeyTooLongException.php'),
 (6299, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MalformedACLErrorException.php'),
 (6300, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MalformedPOSTRequestException.php'),
 (6301, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MalformedXMLException.php'),
 (6302, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MaxMessageLengthExceededException.php'),
 (6303, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php'),
 (6304, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MetadataTooLargeException.php'),
 (6305, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MethodNotAllowedException.php'),
 (6306, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingAttachmentException.php'),
 (6307, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingContentLengthException.php'),
 (6308, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingRequestBodyErrorException.php'),
 (6309, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityElementException.php'),
 (6310, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/MissingSecurityHeaderException.php'),
 (6311, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoLoggingStatusForKeyException.php'),
 (6312, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketException.php'),
 (6313, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchBucketPolicyException.php'),
 (6314, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchCORSConfigurationException.php'),
 (6315, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchKeyException.php'),
 (6316, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php'),
 (6317, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchTagSetException.php'),
 (6318, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchUploadException.php'),
 (6319, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchVersionException.php'),
 (6320, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php'),
 (6321, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NotImplementedException.php'),
 (6322, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NotSignedUpException.php'),
 (6323, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/NotSuchBucketPolicyException.php'),
 (6324, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php'),
 (6325, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php'),
 (6326, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/OperationAbortedException.php'),
 (6327, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/Parser/S3ExceptionParser.php'),
 (6328, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/Parser/index.php'),
 (6329, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/PermanentRedirectException.php'),
 (6330, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/PreconditionFailedException.php'),
 (6331, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RedirectException.php'),
 (6332, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestIsNotMultiPartContentException.php'),
 (6333, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestTimeTooSkewedException.php'),
 (6334, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestTimeoutException.php'),
 (6335, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php'),
 (6336, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/S3Exception.php'),
 (6337, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/ServiceUnavailableException.php'),
 (6338, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/SignatureDoesNotMatchException.php'),
 (6339, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/SlowDownException.php'),
 (6340, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/TemporaryRedirectException.php'),
 (6341, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/TokenRefreshRequiredException.php'),
 (6342, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/TooManyBucketsException.php'),
 (6343, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/UnexpectedContentException.php'),
 (6344, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php'),
 (6345, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php'),
 (6346, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Exception/index.php'),
 (6347, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/IncompleteMultipartUploadChecker.php'),
 (6348, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListBucketsIterator.php'),
 (6349, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListMultipartUploadsIterator.php'),
 (6350, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListObjectVersionsIterator.php'),
 (6351, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/ListObjectsIterator.php'),
 (6352, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/OpendirIterator.php'),
 (6353, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Iterator/index.php'),
 (6354, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/Acp.php'),
 (6355, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/AcpBuilder.php'),
 (6356, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/ClearBucket.php'),
 (6357, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsBatch.php'),
 (6358, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/DeleteObjectsTransfer.php'),
 (6359, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/Grant.php'),
 (6360, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/Grantee.php'),
 (6361, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/AbstractTransfer.php'),
 (6362, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/ParallelTransfer.php'),
 (6363, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/SerialTransfer.php'),
 (6364, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/TransferState.php'),
 (6365, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadBuilder.php'),
 (6366, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadId.php'),
 (6367, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/UploadPart.php'),
 (6368, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/MultipartUpload/index.php'),
 (6369, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/PostObject.php'),
 (6370, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Model/index.php'),
 (6371, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Resources/index.php'),
 (6372, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Resources/s3-2006-03-01.php'),
 (6373, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/ResumableDownload.php'),
 (6374, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3Client.php'),
 (6375, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3Md5Listener.php'),
 (6376, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3Signature.php'),
 (6377, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3SignatureInterface.php'),
 (6378, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/S3SignatureV4.php'),
 (6379, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/SocketTimeoutChecker.php'),
 (6380, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/SseCpkListener.php'),
 (6381, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/StreamWrapper.php'),
 (6382, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/AbstractSync.php'),
 (6383, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/AbstractSyncBuilder.php'),
 (6384, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/ChangedFilesIterator.php'),
 (6385, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/DownloadSync.php'),
 (6386, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/DownloadSyncBuilder.php'),
 (6387, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/FilenameConverterInterface.php'),
 (6388, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/KeyConverter.php'),
 (6389, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/UploadSync.php'),
 (6390, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/UploadSyncBuilder.php'),
 (6391, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/Sync/index.php'),
 (6392, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/S3/index.php'),
 (6393, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Aws/index.php'),
 (6394, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/AbstractHasDispatcher.php'),
 (6395, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Collection.php'),
 (6396, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Event.php'),
 (6397, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/BadMethodCallException.php'),
 (6398, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/ExceptionCollection.php'),
 (6399, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/GuzzleException.php'),
 (6400, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/InvalidArgumentException.php'),
 (6401, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/RuntimeException.php'),
 (6402, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/UnexpectedValueException.php'),
 (6403, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Exception/index.php'),
 (6404, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/FromConfigInterface.php'),
 (6405, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/HasDispatcherInterface.php'),
 (6406, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/ToArrayInterface.php'),
 (6407, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/Version.php'),
 (6408, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Common/index.php'),
 (6409, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/AbstractEntityBodyDecorator.php'),
 (6410, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/CachingEntityBody.php'),
 (6411, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Client.php'),
 (6412, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/ClientInterface.php'),
 (6413, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlHandle.php'),
 (6414, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlMulti.php'),
 (6415, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiInterface.php'),
 (6416, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlMultiProxy.php'),
 (6417, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/CurlVersion.php'),
 (6418, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/RequestMediator.php'),
 (6419, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Curl/index.php'),
 (6420, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/EntityBody.php'),
 (6421, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/EntityBodyInterface.php'),
 (6422, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/BadResponseException.php'),
 (6423, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/ClientErrorResponseException.php'),
 (6424, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/CouldNotRewindStreamException.php'),
 (6425, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/CurlException.php'),
 (6426, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/HttpException.php'),
 (6427, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/MultiTransferException.php'),
 (6428, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/RequestException.php'),
 (6429, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/ServerErrorResponseException.php'),
 (6430, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/TooManyRedirectsException.php'),
 (6431, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Exception/index.php'),
 (6432, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/IoEmittingEntityBody.php'),
 (6433, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/AbstractMessage.php'),
 (6434, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequest.php'),
 (6435, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/EntityEnclosingRequestInterface.php'),
 (6436, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/CacheControl.php'),
 (6437, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderCollection.php'),
 (6438, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactory.php'),
 (6439, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderFactoryInterface.php'),
 (6440, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/HeaderInterface.php'),
 (6441, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/Link.php'),
 (6442, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header/index.php'),
 (6443, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Header.php'),
 (6444, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/MessageInterface.php'),
 (6445, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/PostFile.php'),
 (6446, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/PostFileInterface.php'),
 (6447, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Request.php'),
 (6448, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/RequestFactory.php'),
 (6449, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/RequestFactoryInterface.php'),
 (6450, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/RequestInterface.php'),
 (6451, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/Response.php'),
 (6452, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Message/index.php'),
 (6453, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Mimetypes.php'),
 (6454, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/CommaAggregator.php'),
 (6455, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/DuplicateAggregator.php'),
 (6456, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/PhpAggregator.php'),
 (6457, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php'),
 (6458, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryAggregator/index.php'),
 (6459, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/QueryString.php'),
 (6460, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/ReadLimitEntityBody.php'),
 (6461, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/RedirectPlugin.php'),
 (6462, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Resources/index.php'),
 (6463, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/StaticClient.php'),
 (6464, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/Url.php'),
 (6465, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Http/index.php'),
 (6466, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/Inflector.php'),
 (6467, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/InflectorInterface.php'),
 (6468, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/MemoizingInflector.php'),
 (6469, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/PreComputedInflector.php'),
 (6470, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Inflection/index.php'),
 (6471, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParser.php'),
 (6472, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Cookie/CookieParserInterface.php'),
 (6473, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Cookie/index.php'),
 (6474, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/AbstractMessageParser.php'),
 (6475, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/MessageParser.php'),
 (6476, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/MessageParserInterface.php'),
 (6477, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/PeclHttpMessageParser.php'),
 (6478, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Message/index.php'),
 (6479, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/ParserRegistry.php'),
 (6480, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/PeclUriTemplate.php'),
 (6481, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplate.php'),
 (6482, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/UriTemplateInterface.php'),
 (6483, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/UriTemplate/index.php'),
 (6484, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Url/UrlParser.php'),
 (6485, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Url/UrlParserInterface.php'),
 (6486, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/Url/index.php'),
 (6487, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Parser/index.php'),
 (6488, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php'),
 (6489, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php'),
 (6490, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffLogger.php'),
 (6491, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffPlugin.php'),
 (6492, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php'),
 (6493, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php'),
 (6494, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php'),
 (6495, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php'),
 (6496, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php'),
 (6497, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php'),
 (6498, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php'),
 (6499, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php'),
 (6500, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(6501, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Plugin/Backoff/index.php'),
 (6502, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/AbstractConfigLoader.php'),
 (6503, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilder.php'),
 (6504, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderInterface.php'),
 (6505, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/ServiceBuilderLoader.php'),
 (6506, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Builder/index.php'),
 (6507, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/CachingConfigLoader.php'),
 (6508, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Client.php'),
 (6509, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/ClientInterface.php'),
 (6510, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/AbstractCommand.php'),
 (6511, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/ClosureCommand.php'),
 (6512, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/CommandInterface.php'),
 (6513, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/CreateResponseClassEvent.php'),
 (6514, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/DefaultRequestSerializer.php'),
 (6515, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/DefaultResponseParser.php'),
 (6516, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/AliasFactory.php'),
 (6517, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/CompositeFactory.php'),
 (6518, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/ConcreteClassFactory.php'),
 (6519, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/FactoryInterface.php'),
 (6520, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/MapFactory.php'),
 (6521, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php'),
 (6522, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/Factory/index.php'),
 (6523, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php'),
 (6524, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php'),
 (6525, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php'),
 (6526, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php'),
 (6527, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php'),
 (6528, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php'),
 (6529, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php'),
 (6530, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php'),
 (6531, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php'),
 (6532, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php'),
 (6533, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Request/index.php'),
 (6534, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php'),
 (6535, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php'),
 (6536, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php'),
 (6537, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php'),
 (6538, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php'),
 (6539, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php'),
 (6540, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php'),
 (6541, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php'),
 (6542, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/Response/index.php'),
 (6543, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php'),
 (6544, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/LocationVisitor/index.php'),
 (6545, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/OperationCommand.php'),
 (6546, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/OperationResponseParser.php'),
 (6547, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/RequestSerializerInterface.php'),
 (6548, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/ResponseClassInterface.php'),
 (6549, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/ResponseParserInterface.php'),
 (6550, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Command/index.php'),
 (6551, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/ConfigLoaderInterface.php'),
 (6552, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/Operation.php'),
 (6553, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/OperationInterface.php'),
 (6554, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/Parameter.php'),
 (6555, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/SchemaFormatter.php'),
 (6556, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/SchemaValidator.php'),
 (6557, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescription.php'),
 (6558, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionInterface.php'),
 (6559, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ServiceDescriptionLoader.php'),
 (6560, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/ValidatorInterface.php'),
 (6561, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Description/index.php'),
 (6562, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/CommandException.php'),
 (6563, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/CommandTransferException.php'),
 (6564, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/DescriptionBuilderException.php'),
 (6565, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/InconsistentClientTransferException.php'),
 (6566, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ResponseClassException.php'),
 (6567, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ServiceBuilderException.php'),
 (6568, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ServiceNotFoundException.php'),
 (6569, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/ValidationException.php'),
 (6570, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Exception/index.php'),
 (6571, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php'),
 (6572, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php'),
 (6573, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/MapResourceIteratorFactory.php'),
 (6574, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/Model.php'),
 (6575, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIterator.php'),
 (6576, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php'),
 (6577, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorClassFactory.php'),
 (6578, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php'),
 (6579, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/ResourceIteratorInterface.php'),
 (6580, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/Resource/index.php'),
 (6581, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Service/index.php'),
 (6582, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/PhpStreamRequestFactory.php'),
 (6583, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/Stream.php'),
 (6584, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/StreamInterface.php'),
 (6585, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/StreamRequestFactoryInterface.php'),
 (6586, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/Stream/index.php'),
 (6587, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Guzzle/index.php'),
 (6588, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/ContainerAwareEventDispatcher.php'),
 (6589, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/RegisterListenersPass.php'),
 (6590, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/DependencyInjection/index.php'),
 (6591, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/Event.php'),
 (6592, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcher.php'),
 (6593, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventDispatcherInterface.php'),
 (6594, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/EventSubscriberInterface.php'),
 (6595, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/GenericEvent.php'),
 (6596, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/ImmutableEventDispatcher.php'),
 (6597, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/EventDispatcher/index.php'),
 (6598, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/Component/index.php'),
 (6599, 'wp-content/updraft/plugins-old/duplicator-pro/aws/Symfony/index.php'),
 (6600, 'wp-content/updraft/plugins-old/duplicator-pro/aws/aws-autoloader.php'),
 (6601, 'wp-content/updraft/plugins-old/duplicator-pro/aws/index.php'),
 (6602, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.archive.config.php'),
 (6603, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.constants.php'),
 (6604, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.crypt.blowfish.php'),
 (6605, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.crypt.custom.php'),
 (6606, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.db.php'),
 (6607, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.enhanced.plugin.updater.php'),
 (6608, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.exceptions.php'),
 (6609, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.io.php'),
 (6610, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.logging.php'),
 (6611, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.package.pagination.php'),
 (6612, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.password.php'),
 (6613, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.php.log.php'),
 (6614, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.scan.check.php'),
 (6615, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.server.php'),
 (6616, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.system.checker.php'),
 (6617, 'wp-content/updraft/plugins-old/duplicator-pro/classes/class.wp.list.table.php'),
 (6618, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.brand.entity.php'),
 (6619, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.duparchive.expandstate.entity.php'),
 (6620, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.global.entity.php'),
 (6621, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.json.entity.base.php'),
 (6622, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.package.template.entity.php'),
 (6623, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.profilelogs.entity.php'),
 (6624, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.schedule.entity.php'),
 (6625, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.secure.global.entity.php'),
 (6626, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.storage.entity.php'),
 (6627, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.system.global.entity.php'),
 (6628, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/class.verifiers.php'),
 (6629, 'wp-content/updraft/plugins-old/duplicator-pro/classes/entities/index.php'),
 (6630, 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/class.db.checker.php'),
 (6631, 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/class.environment.checker.php'),
 (6632, 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/index.php'),
 (6633, 'wp-content/updraft/plugins-old/duplicator-pro/classes/environment/interface.checker.php'),
 (6634, 'wp-content/updraft/plugins-old/duplicator-pro/classes/index.php'),
 (6635, 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.ftp.chunker.php'),
 (6636, 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.u.gdrive.php'),
 (6637, 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.u.onedrive.php'),
 (6638, 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/class.u.s3.php'),
 (6639, 'wp-content/updraft/plugins-old/duplicator-pro/classes/net/index.php'),
 (6640, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.available.php'),
 (6641, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.filters.php'),
 (6642, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.php'),
 (6643, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.shellzip.php'),
 (6644, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.archive.zip.php'),
 (6645, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.database.php'),
 (6646, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.installer.php'),
 (6647, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.multisite.php'),
 (6648, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.php'),
 (6649, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.runner.php'),
 (6650, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/class.pack.upload.info.php'),
 (6651, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.php'),
 (6652, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.create.php'),
 (6653, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/class.pack.archive.duparchive.state.expand.php'),
 (6654, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/duparchive/index.php'),
 (6655, 'wp-content/updraft/plugins-old/duplicator-pro/classes/package/index.php'),
 (6656, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.alert.php'),
 (6657, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.dialog.php'),
 (6658, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.messages.php'),
 (6659, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.notice.php'),
 (6660, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.php'),
 (6661, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.screen.base.php'),
 (6662, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/class.ui.viewstate.php'),
 (6663, 'wp-content/updraft/plugins-old/duplicator-pro/classes/ui/index.php'),
 (6664, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.date.php'),
 (6665, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.import.php'),
 (6666, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.json.php'),
 (6667, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.license.php'),
 (6668, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.low.php'),
 (6669, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.multisite.php'),
 (6670, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.php'),
 (6671, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.settings.php'),
 (6672, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.shell.php'),
 (6673, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.string.php'),
 (6674, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.tree.files.php'),
 (6675, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.upgrade.php'),
 (6676, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.validator.php'),
 (6677, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.wp.php'),
 (6678, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/class.u.zip.php'),
 (6679, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/index.php'),
 (6680, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.test.debug.php'),
 (6681, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.test.package.build.php'),
 (6682, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.u.test.abstract.php'),
 (6683, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.u.test.result.php'),
 (6684, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/tests/class.u.tests.manager.php'),
 (6685, 'wp-content/updraft/plugins-old/duplicator-pro/classes/utilities/wordpress.core.files.php'),
 (6686, 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/class.web.services.php'),
 (6687, 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.base.php'),
 (6688, 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.package.php'),
 (6689, 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.schedule.php'),
 (6690, 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/ctrl.tools.php'),
 (6691, 'wp-content/updraft/plugins-old/duplicator-pro/ctrls/index.php'),
 (6692, 'wp-content/updraft/plugins-old/duplicator-pro/debug/index.php'),
 (6693, 'wp-content/updraft/plugins-old/duplicator-pro/debug/main.php'),
 (6694, 'wp-content/updraft/plugins-old/duplicator-pro/debug/tst.packages.php'),
 (6695, 'wp-content/updraft/plugins-old/duplicator-pro/debug/tst.tools.php'),
 (6696, 'wp-content/updraft/plugins-old/duplicator-pro/define.php'),
 (6697, 'wp-content/updraft/plugins-old/duplicator-pro/duplicator-pro.php'),
 (6698, 'wp-content/updraft/plugins-old/duplicator-pro/index.php'),
 (6699, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dtoken.php'),
 (6700, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/class.api.php'),
 (6701, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/class.cpnl.base.php'),
 (6702, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/class.cpnl.ctrl.php'),
 (6703, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/index.php'),
 (6704, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/api/router.php'),
 (6705, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/font-awesome/css/index.php'),
 (6706, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/font-awesome/index.php'),
 (6707, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/font-awesome/webfonts/index.php'),
 (6708, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/images/index.php'),
 (6709, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.css.php'),
 (6710, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.js.php'),
 (6711, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.libs.css.php'),
 (6712, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/inc.libs.js.php'),
 (6713, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/assets/index.php'),
 (6714, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/EventIterator.php'),
 (6715, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/Interfaces/GenericSeekableIterator.php'),
 (6716, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/Iterators/class.s3.iterator.php'),
 (6717, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunk.s3.manager.php'),
 (6718, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager.php'),
 (6719, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Chunk/class.chunkingmanager_file.php'),
 (6720, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Crypt/Base.php'),
 (6721, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Crypt/Random.php'),
 (6722, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/Crypt/Rijndael.php'),
 (6723, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.crypt.php'),
 (6724, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.csrf.php'),
 (6725, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.db.php'),
 (6726, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.engine.php'),
 (6727, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.http.php'),
 (6728, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.installer.state.php'),
 (6729, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.logging.php'),
 (6730, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.password.php'),
 (6731, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.s3.func.php'),
 (6732, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.server.php'),
 (6733, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/class.view.php'),
 (6734, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.archive.config.php'),
 (6735, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.boot.php'),
 (6736, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.conf.srv.php'),
 (6737, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.conf.wp.php'),
 (6738, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/class.constants.php'),
 (6739, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/config/index.php'),
 (6740, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/index.php'),
 (6741, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.exceptions.php'),
 (6742, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.html.php'),
 (6743, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.multisite.php'),
 (6744, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.notices.manager.php'),
 (6745, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.php'),
 (6746, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.remove.redundant.data.php'),
 (6747, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/class.u.search.reaplce.manager.php'),
 (6748, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/classes/utilities/index.php'),
 (6749, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.base.php'),
 (6750, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.extraction.php'),
 (6751, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s1.php'),
 (6752, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.base.php'),
 (6753, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbinstall.php'),
 (6754, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s2.dbtest.php'),
 (6755, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/ctrl.s3.php'),
 (6756, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/ctrls/index.php'),
 (6757, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/index.php'),
 (6758, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/main.installer.php'),
 (6759, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/index.php'),
 (6760, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.api.php'),
 (6761, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.exception.php'),
 (6762, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.help.php'),
 (6763, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.init1.php'),
 (6764, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s1.base.php'),
 (6765, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s1.terms.php'),
 (6766, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.base.php'),
 (6767, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.basic.php'),
 (6768, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.cpnl.php'),
 (6769, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s2.dbtest.php'),
 (6770, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s3.php'),
 (6771, 'wp-content/updraft/plugins-old/duplicator-pro/installer/dup-installer/views/view.s4.php'),
 (6772, 'wp-content/updraft/plugins-old/duplicator-pro/installer/index.php'),
 (6773, 'wp-content/updraft/plugins-old/duplicator-pro/lang/index.php'),
 (6774, 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/DropboxClient.php'),
 (6775, 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/DropboxV2Client.php'),
 (6776, 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/OAuthSimple.php'),
 (6777, 'wp-content/updraft/plugins-old/duplicator-pro/lib/DropPHP/index.php'),
 (6778, 'wp-content/updraft/plugins-old/duplicator-pro/lib/ca/index.php'),
 (6779, 'wp-content/updraft/plugins-old/duplicator-pro/lib/certificates/index.php'),
 (6780, 'wp-content/updraft/plugins-old/duplicator-pro/lib/config/class.wp.config.tranformer.php'),
 (6781, 'wp-content/updraft/plugins-old/duplicator-pro/lib/config/class.wp.config.tranformer.src.php'),
 (6782, 'wp-content/updraft/plugins-old/duplicator-pro/lib/cron/csd_parser.php'),
 (6783, 'wp-content/updraft/plugins-old/duplicator-pro/lib/cron/index.php'),
 (6784, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.constants.php'),
 (6785, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.engine.php'),
 (6786, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.loggerbase.php'),
 (6787, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.mini.expander.php'),
 (6788, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/class.duparchive.processing.failure.php'),
 (6789, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.directory.php'),
 (6790, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.file.php'),
 (6791, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.glob.php'),
 (6792, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.php'),
 (6793, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/class.duparchive.header.u.php'),
 (6794, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/headers/index.php'),
 (6795, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/index.php'),
 (6796, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.directory.php'),
 (6797, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/processors/class.duparchive.processor.file.php'),
 (6798, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/processors/index.php'),
 (6799, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.base.php'),
 (6800, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.create.php'),
 (6801, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.expand.php'),
 (6802, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simplecreate.php'),
 (6803, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/class.duparchive.state.simpleexpand.php'),
 (6804, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/states/index.php'),
 (6805, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.u.json.php'),
 (6806, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.php'),
 (6807, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/class.duparchive.util.scan.php'),
 (6808, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/classes/util/index.php'),
 (6809, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/class.daws.constants.php'),
 (6810, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/class.daws.state.expand.php'),
 (6811, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/daws.php'),
 (6812, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/daws/index.php'),
 (6813, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/define.php'),
 (6814, 'wp-content/updraft/plugins-old/duplicator-pro/lib/dup_archive/index.php'),
 (6815, 'wp-content/updraft/plugins-old/duplicator-pro/lib/edd/EDD_SL_Plugin_Updater.php'),
 (6816, 'wp-content/updraft/plugins-old/duplicator-pro/lib/edd/index.php'),
 (6817, 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.constants.php'),
 (6818, 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.state.php'),
 (6819, 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.u.delete.php'),
 (6820, 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/class.fileops.u.move.php'),
 (6821, 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/fileops.php'),
 (6822, 'wp-content/updraft/plugins-old/duplicator-pro/lib/fileops/index.php'),
 (6823, 'wp-content/updraft/plugins-old/duplicator-pro/lib/forceutf8/index.php'),
 (6824, 'wp-content/updraft/plugins-old/duplicator-pro/lib/forceutf8/src/Encoding.php'),
 (6825, 'wp-content/updraft/plugins-old/duplicator-pro/lib/forceutf8/src/index.php'),
 (6826, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/Abstract.php'),
 (6827, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/Exception.php'),
 (6828, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/OAuth2.php'),
 (6829, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Auth/index.php'),
 (6830, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/Abstract.php'),
 (6831, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/Exception.php'),
 (6832, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/File.php'),
 (6833, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/Null.php'),
 (6834, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Cache/index.php'),
 (6835, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Client.php'),
 (6836, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Collection.php'),
 (6837, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Config.php'),
 (6838, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Exception.php'),
 (6839, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/Batch.php'),
 (6840, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/CacheParser.php'),
 (6841, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/MediaFileUpload.php'),
 (6842, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/REST.php'),
 (6843, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/Request.php'),
 (6844, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Http/index.php'),
 (6845, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Abstract.php'),
 (6846, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Curl.php'),
 (6847, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Exception.php'),
 (6848, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/Stream.php'),
 (6849, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/IO/index.php'),
 (6850, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/Abstract.php'),
 (6851, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/Exception.php'),
 (6852, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/File.php'),
 (6853, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/Null.php'),
 (6854, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Logger/index.php'),
 (6855, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Model.php'),
 (6856, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Drive.php'),
 (6857, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Exception.php'),
 (6858, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Oauth2.php'),
 (6859, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/Resource.php'),
 (6860, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service/index.php'),
 (6861, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Service.php'),
 (6862, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/Exception.php'),
 (6863, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/Retryable.php'),
 (6864, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/Runner.php'),
 (6865, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Task/index.php'),
 (6866, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Utils/URITemplate.php'),
 (6867, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Utils/index.php'),
 (6868, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/Utils.php'),
 (6869, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/autoload.php'),
 (6870, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/apiclient/index.php'),
 (6871, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/class.enhanced.google.media.file.upload.php'),
 (6872, 'wp-content/updraft/plugins-old/duplicator-pro/lib/google/index.php'),
 (6873, 'wp-content/updraft/plugins-old/duplicator-pro/lib/index.php'),
 (6874, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/autoload.php'),
 (6875, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/index.php'),
 (6876, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Client.php'),
 (6877, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/DriveItem.php'),
 (6878, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/File.php'),
 (6879, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/Folder.php'),
 (6880, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehavior.php'),
 (6881, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/NameConflictBehaviorParameterizer.php'),
 (6882, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/ResumableUploader.php'),
 (6883, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamBackEnd.php'),
 (6884, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/StreamOpener.php'),
 (6885, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/Onedrive/index.php'),
 (6886, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/Krizalys/index.php'),
 (6887, 'wp-content/updraft/plugins-old/duplicator-pro/lib/onedrive/src/index.php'),
 (6888, 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/cipher/blowfish.php'),
 (6889, 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/cipher/index.php'),
 (6890, 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/class.pcrypt.php'),
 (6891, 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/example.php'),
 (6892, 'wp-content/updraft/plugins-old/duplicator-pro/lib/pcrypt/index.php'),
 (6893, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/autoload.php'),
 (6894, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/class.phpseclib.php'),
 (6895, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/ClassLoader.php'),
 (6896, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_classmap.php'),
 (6897, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_namespaces.php'),
 (6898, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_psr4.php'),
 (6899, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_real.php'),
 (6900, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/autoload_static.php'),
 (6901, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/composer/include_paths.php'),
 (6902, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/index.php'),
 (6903, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/AES.php'),
 (6904, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Base.php'),
 (6905, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Blowfish.php'),
 (6906, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/DES.php'),
 (6907, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Hash.php'),
 (6908, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC2.php'),
 (6909, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RC4.php'),
 (6910, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/RSA.php'),
 (6911, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Random.php'),
 (6912, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Rijndael.php'),
 (6913, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/TripleDES.php'),
 (6914, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/Twofish.php'),
 (6915, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Crypt/index.php'),
 (6916, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ANSI.php'),
 (6917, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/Element.php'),
 (6918, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1/index.php'),
 (6919, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/ASN1.php'),
 (6920, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/X509.php'),
 (6921, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/File/index.php'),
 (6922, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Math/BigInteger.php'),
 (6923, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Math/index.php'),
 (6924, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SCP.php'),
 (6925, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/Stream.php'),
 (6926, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP/index.php'),
 (6927, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SFTP.php'),
 (6928, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH1.php'),
 (6929, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/SSH2.php'),
 (6930, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/Net/index.php'),
 (6931, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent/Identity.php'),
 (6932, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/Agent.php'),
 (6933, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/SSH/index.php'),
 (6934, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/System/index.php'),
 (6935, 'wp-content/updraft/plugins-old/duplicator-pro/lib/phpseclib/phpseclib/index.php'),
 (6936, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.exceptions.php'),
 (6937, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.logger.php'),
 (6938, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.io.php'),
 (6939, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.net.php'),
 (6940, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.os.php'),
 (6941, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.stream.php'),
 (6942, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.string.php'),
 (6943, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.ui.php'),
 (6944, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.url.php'),
 (6945, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.util.php'),
 (6946, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/class.snaplib.u.wp.php'),
 (6947, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/index.php'),
 (6948, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/snaplib.all.php'),
 (6949, 'wp-content/updraft/plugins-old/duplicator-pro/lib/snaplib/wordpress.core.files.php'),
 (6950, 'wp-content/updraft/plugins-old/duplicator-pro/tools/da-installer-extractor.php'),
 (6951, 'wp-content/updraft/plugins-old/duplicator-pro/tools/db-test.php'),
 (6952, 'wp-content/updraft/plugins-old/duplicator-pro/tools/file-renamer.php'),
 (6953, 'wp-content/updraft/plugins-old/duplicator-pro/tools/index.php'),
 (6954, 'wp-content/updraft/plugins-old/duplicator-pro/uninstall.php'),
 (6955, 'wp-content/updraft/plugins-old/duplicator-pro/views/inc.header.php'),
 (6956, 'wp-content/updraft/plugins-old/duplicator-pro/views/index.php'),
 (6957, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/controller.php'),
 (6958, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/controller.php'),
 (6959, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/detail.php'),
 (6960, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/index.php'),
 (6961, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/details/transfer.php'),
 (6962, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/index.php'),
 (6963, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/controller.php'),
 (6964, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/index.php'),
 (6965, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/packages.php'),
 (6966, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup0.base.php'),
 (6967, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup1.reqs.php'),
 (6968, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup2.store.php'),
 (6969, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup3.archive.php'),
 (6970, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s1.setup4.install.php'),
 (6971, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s2.scan1.base.php'),
 (6972, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s2.scan2.server.php'),
 (6973, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/main/s2.scan3.archive.php'),
 (6974, 'wp-content/updraft/plugins-old/duplicator-pro/views/packages/screen.php'),
 (6975, 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/controller.php'),
 (6976, 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/index.php'),
 (6977, 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/schedule.controller.php'),
 (6978, 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/schedule.edit.php'),
 (6979, 'wp-content/updraft/plugins-old/duplicator-pro/views/schedules/schedule.list.php'),
 (6980, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/controller.php'),
 (6981, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/inc.feature.php'),
 (6982, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/inc.general.php'),
 (6983, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/inc.migrate.php'),
 (6984, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/index.php'),
 (6985, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/general/main.php'),
 (6986, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/index.php'),
 (6987, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/licensing.php'),
 (6988, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.advanced.php'),
 (6989, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.basic.php'),
 (6990, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.brand.edit.php'),
 (6991, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/inc.brand.list.php'),
 (6992, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/index.php'),
 (6993, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/package/main.php'),
 (6994, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/schedule.php'),
 (6995, 'wp-content/updraft/plugins-old/duplicator-pro/views/settings/storage.php'),
 (6996, 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/controller.php'),
 (6997, 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/index.php'),
 (6998, 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.controller.php'),
 (6999, 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.edit.default.php'),
 (7000, 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.edit.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(7001, 'wp-content/updraft/plugins-old/duplicator-pro/views/storage/storage.list.php'),
 (7002, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/controller.php'),
 (7003, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/diagnostic.php'),
 (7004, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.data.php'),
 (7005, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.phpinfo.php'),
 (7006, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.settings.php'),
 (7007, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/inc.validator.php'),
 (7008, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/index.php'),
 (7009, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/log.php'),
 (7010, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/main.php'),
 (7011, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/phplogs.php'),
 (7012, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/support.php'),
 (7013, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/diagnostics/tests.php'),
 (7014, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/import.php'),
 (7015, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/index.php'),
 (7016, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/support.php'),
 (7017, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/index.php'),
 (7018, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/main.php'),
 (7019, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/template.edit.php'),
 (7020, 'wp-content/updraft/plugins-old/duplicator-pro/views/tools/templates/template.list.php'),
 (7021, 'wp-content/updraft/plugins-old/hello.php'),
 (7022, 'wp-content/updraft/plugins-old/index.php'),
 (7023, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/alpha/alpha-control.php'),
 (7024, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/alpha/assets/js/alpha-control.js'),
 (7025, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/cool-stuff/cool-stuff-control.php'),
 (7026, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/padding/assets/js/padding-control.js'),
 (7027, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/padding/padding-control.php'),
 (7028, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/radio-images/radio-images-control.php'),
 (7029, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/range-slider/assets/js/range-slider-control.js'),
 (7030, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/range-slider/range-slider-control.php'),
 (7031, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/toggle/assets/js/toggle-control.js'),
 (7032, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/controls/toggle/toggle-control.php'),
 (7033, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/custom-code.php'),
 (7034, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/customizer.php'),
 (7035, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/functions.php'),
 (7036, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/js/customizer-preview.js'),
 (7037, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/js/customizer.js'),
 (7038, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sanitizers.php'),
 (7039, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-background.php'),
 (7040, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-button.php'),
 (7041, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-code.php'),
 (7042, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-fields.php'),
 (7043, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-form.php'),
 (7044, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-logo.php'),
 (7045, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-more.php'),
 (7046, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-other.php'),
 (7047, 'wp-content/updraft/plugins-old/login-customizer/inc/customizer/sections/section-templates.php'),
 (7048, 'wp-content/updraft/plugins-old/login-customizer/inc/include-page-template.php'),
 (7049, 'wp-content/updraft/plugins-old/login-customizer/inc/initial-setup.php'),
 (7050, 'wp-content/updraft/plugins-old/login-customizer/inc/mailin.php'),
 (7051, 'wp-content/updraft/plugins-old/login-customizer/inc/template-login-customizer.php'),
 (7052, 'wp-content/updraft/plugins-old/login-customizer/index.php'),
 (7053, 'wp-content/updraft/plugins-old/login-customizer/login-customizer.php'),
 (7054, 'wp-content/updraft/plugins-old/login-customizer/setup.php'),
 (7055, 'wp-content/updraft/plugins-old/login-customizer/vendor/autoload.php'),
 (7056, 'wp-content/updraft/plugins-old/login-customizer/vendor/autoload_52.php'),
 (7057, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-endpoints.php'),
 (7058, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-deactivate.php'),
 (7059, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-factory.php'),
 (7060, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-review.php'),
 (7061, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback-translate.php'),
 (7062, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-feedback.php'),
 (7063, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-licenser.php'),
 (7064, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-loader.php'),
 (7065, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-logger.php'),
 (7066, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-notification-manager.php'),
 (7067, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-product.php'),
 (7068, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-rollback.php'),
 (7069, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget-dashboard-blog.php'),
 (7070, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widget.php'),
 (7071, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/class-themeisle-sdk-widgets-factory.php'),
 (7072, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/index.php'),
 (7073, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/load.php'),
 (7074, 'wp-content/updraft/plugins-old/login-customizer/vendor/codeinwp/themeisle-sdk/start.php'),
 (7075, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/ClassLoader.php'),
 (7076, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/ClassLoader52.php'),
 (7077, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_classmap.php'),
 (7078, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_files.php'),
 (7079, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_namespaces.php'),
 (7080, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_psr4.php'),
 (7081, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_real.php'),
 (7082, 'wp-content/updraft/plugins-old/login-customizer/vendor/composer/autoload_real_52.php'),
 (7083, 'wp-content/updraft/plugins-old/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/AutoloadGenerator.php'),
 (7084, 'wp-content/updraft/plugins-old/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/ClassLoader.php'),
 (7085, 'wp-content/updraft/plugins-old/login-customizer/vendor/xrstf/composer-php52/lib/xrstf/Composer52/Generator.php'),
 (7086, 'wp-content/updraft/plugins-old/post-types-order/compatibility/LiteSpeed_Cache.php'),
 (7087, 'wp-content/updraft/plugins-old/post-types-order/compatibility/the-events-calendar.php'),
 (7088, 'wp-content/updraft/plugins-old/post-types-order/include/class.cpto.php'),
 (7089, 'wp-content/updraft/plugins-old/post-types-order/include/class.functions.php'),
 (7090, 'wp-content/updraft/plugins-old/post-types-order/include/class.options.php'),
 (7091, 'wp-content/updraft/plugins-old/post-types-order/include/class.walkers.php'),
 (7092, 'wp-content/updraft/plugins-old/post-types-order/js/cpt.js'),
 (7093, 'wp-content/updraft/plugins-old/post-types-order/post-types-order.php'),
 (7094, 'wp-content/updraft/plugins-old/revslider/admin/assets/css/index.php'),
 (7095, 'wp-content/updraft/plugins-old/revslider/admin/assets/icons/MaterialIcons-Regular.svg'),
 (7096, 'wp-content/updraft/plugins-old/revslider/admin/assets/images/sources/index.php'),
 (7097, 'wp-content/updraft/plugins-old/revslider/admin/assets/index.php'),
 (7098, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/admin.min.js'),
 (7099, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/editor.min.js'),
 (7100, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/help.js'),
 (7101, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/overview.min.js'),
 (7102, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/modules/tooltip.js'),
 (7103, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/codemirror.js'),
 (7104, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/penner-easing.js'),
 (7105, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/utils.min.js'),
 (7106, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/plugins/wavesurfer.js'),
 (7107, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/shortcode_generator/shortcode_generator.js'),
 (7108, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/shortcode_generator/tinymce.js'),
 (7109, 'wp-content/updraft/plugins-old/revslider/admin/assets/js/shortcode_generator/vc.js'),
 (7110, 'wp-content/updraft/plugins-old/revslider/admin/includes/addons.class.php'),
 (7111, 'wp-content/updraft/plugins-old/revslider/admin/includes/debug.php'),
 (7112, 'wp-content/updraft/plugins-old/revslider/admin/includes/export-html.class.php'),
 (7113, 'wp-content/updraft/plugins-old/revslider/admin/includes/export.class.php'),
 (7114, 'wp-content/updraft/plugins-old/revslider/admin/includes/folder.class.php'),
 (7115, 'wp-content/updraft/plugins-old/revslider/admin/includes/functions-admin.class.php'),
 (7116, 'wp-content/updraft/plugins-old/revslider/admin/includes/help.class.php'),
 (7117, 'wp-content/updraft/plugins-old/revslider/admin/includes/import.class.php'),
 (7118, 'wp-content/updraft/plugins-old/revslider/admin/includes/license.class.php'),
 (7119, 'wp-content/updraft/plugins-old/revslider/admin/includes/loadbalancer.class.php'),
 (7120, 'wp-content/updraft/plugins-old/revslider/admin/includes/newsletter.class.php'),
 (7121, 'wp-content/updraft/plugins-old/revslider/admin/includes/plugin-update.class.php'),
 (7122, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/elementor/elementor-widget.class.php'),
 (7123, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/elementor/elementor.class.php'),
 (7124, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/dist/blocks.build.js'),
 (7125, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/gutenberg-block.php'),
 (7126, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/plugin.php'),
 (7127, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/assets/images/js-wapuu.svg'),
 (7128, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/blocks.js'),
 (7129, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/gutenberg-block.php'),
 (7130, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/deprecated.js'),
 (7131, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/index.js'),
 (7132, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revSliderImage.js'),
 (7133, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/gutenberg/src/revslider/revslider.js'),
 (7134, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/shortcode_generator.class.php'),
 (7135, 'wp-content/updraft/plugins-old/revslider/admin/includes/shortcode_generator/wpbakery/wpbakery.class.php'),
 (7136, 'wp-content/updraft/plugins-old/revslider/admin/includes/template.class.php'),
 (7137, 'wp-content/updraft/plugins-old/revslider/admin/includes/tooltips.class.php'),
 (7138, 'wp-content/updraft/plugins-old/revslider/admin/includes/widget.class.php'),
 (7139, 'wp-content/updraft/plugins-old/revslider/admin/index.php'),
 (7140, 'wp-content/updraft/plugins-old/revslider/admin/revslider-admin.class.php'),
 (7141, 'wp-content/updraft/plugins-old/revslider/admin/views/builder-layer-forms.php'),
 (7142, 'wp-content/updraft/plugins-old/revslider/admin/views/builder-nav-forms.php'),
 (7143, 'wp-content/updraft/plugins-old/revslider/admin/views/builder-slide-forms.php'),
 (7144, 'wp-content/updraft/plugins-old/revslider/admin/views/builder-slider-forms.php'),
 (7145, 'wp-content/updraft/plugins-old/revslider/admin/views/builder-timeline.php'),
 (7146, 'wp-content/updraft/plugins-old/revslider/admin/views/builder.php'),
 (7147, 'wp-content/updraft/plugins-old/revslider/admin/views/features/add_ons.php'),
 (7148, 'wp-content/updraft/plugins-old/revslider/admin/views/features/index.php'),
 (7149, 'wp-content/updraft/plugins-old/revslider/admin/views/features/layer_animations.php'),
 (7150, 'wp-content/updraft/plugins-old/revslider/admin/views/features/object_library.php'),
 (7151, 'wp-content/updraft/plugins-old/revslider/admin/views/features/premade_template.php'),
 (7152, 'wp-content/updraft/plugins-old/revslider/admin/views/features/support.php'),
 (7153, 'wp-content/updraft/plugins-old/revslider/admin/views/footer.php'),
 (7154, 'wp-content/updraft/plugins-old/revslider/admin/views/header.php'),
 (7155, 'wp-content/updraft/plugins-old/revslider/admin/views/index.php'),
 (7156, 'wp-content/updraft/plugins-old/revslider/admin/views/modals-builder.php'),
 (7157, 'wp-content/updraft/plugins-old/revslider/admin/views/modals-copyright.php'),
 (7158, 'wp-content/updraft/plugins-old/revslider/admin/views/modals-general.php'),
 (7159, 'wp-content/updraft/plugins-old/revslider/admin/views/modals-overview.php'),
 (7160, 'wp-content/updraft/plugins-old/revslider/admin/views/overview.php'),
 (7161, 'wp-content/updraft/plugins-old/revslider/backup/index.php'),
 (7162, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Endpoints.php'),
 (7163, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Exception/InstagramAuthException.php'),
 (7164, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Exception/InstagramException.php'),
 (7165, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Exception/InstagramNotFoundException.php'),
 (7166, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Instagram.php'),
 (7167, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/InstagramQueryId.php'),
 (7168, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Instagram_old.php'),
 (7169, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/AbstractModel.php'),
 (7170, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Account.php'),
 (7171, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/CarouselMedia.php'),
 (7172, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Comment.php'),
 (7173, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Like.php'),
 (7174, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Location.php'),
 (7175, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Media.php'),
 (7176, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Story.php'),
 (7177, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/Tag.php'),
 (7178, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Model/UserStories.php'),
 (7179, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Traits/ArrayLikeTrait.php'),
 (7180, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper/Traits/InitializerTrait.php'),
 (7181, 'wp-content/updraft/plugins-old/revslider/includes/InstagramScraper.php'),
 (7182, 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Exception.php'),
 (7183, 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Method.php'),
 (7184, 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Request/Body.php'),
 (7185, 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Request.php'),
 (7186, 'wp-content/updraft/plugins-old/revslider/includes/Unirest/Response.php'),
 (7187, 'wp-content/updraft/plugins-old/revslider/includes/Unirest.php'),
 (7188, 'wp-content/updraft/plugins-old/revslider/includes/aq-resizer.class.php'),
 (7189, 'wp-content/updraft/plugins-old/revslider/includes/backwards.php'),
 (7190, 'wp-content/updraft/plugins-old/revslider/includes/basic-css.php'),
 (7191, 'wp-content/updraft/plugins-old/revslider/includes/coloreasing.class.php'),
 (7192, 'wp-content/updraft/plugins-old/revslider/includes/colorpicker.class.php'),
 (7193, 'wp-content/updraft/plugins-old/revslider/includes/cssparser.class.php'),
 (7194, 'wp-content/updraft/plugins-old/revslider/includes/data.class.php'),
 (7195, 'wp-content/updraft/plugins-old/revslider/includes/em-integration.class.php'),
 (7196, 'wp-content/updraft/plugins-old/revslider/includes/extension.class.php'),
 (7197, 'wp-content/updraft/plugins-old/revslider/includes/external-sources.class.php'),
 (7198, 'wp-content/updraft/plugins-old/revslider/includes/favorite.class.php'),
 (7199, 'wp-content/updraft/plugins-old/revslider/includes/functions.class.php'),
 (7200, 'wp-content/updraft/plugins-old/revslider/includes/googlefonts.php'),
 (7201, 'wp-content/updraft/plugins-old/revslider/includes/navigation.class.php'),
 (7202, 'wp-content/updraft/plugins-old/revslider/includes/navigations.php'),
 (7203, 'wp-content/updraft/plugins-old/revslider/includes/object-library.class.php'),
 (7204, 'wp-content/updraft/plugins-old/revslider/includes/output.class.php'),
 (7205, 'wp-content/updraft/plugins-old/revslider/includes/page-template.class.php'),
 (7206, 'wp-content/updraft/plugins-old/revslider/includes/slide.class.php'),
 (7207, 'wp-content/updraft/plugins-old/revslider/includes/slider.class.php'),
 (7208, 'wp-content/updraft/plugins-old/revslider/includes/update.class.php'),
 (7209, 'wp-content/updraft/plugins-old/revslider/includes/woocommerce.class.php'),
 (7210, 'wp-content/updraft/plugins-old/revslider/includes/wpml.class.php'),
 (7211, 'wp-content/updraft/plugins-old/revslider/index.php'),
 (7212, 'wp-content/updraft/plugins-old/revslider/languages/index.php'),
 (7213, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/index.php'),
 (7214, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/sources/index.php'),
 (7215, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_3d_rotation_24px.svg'),
 (7216, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_accessibility_24px.svg'),
 (7217, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_accessible_24px.svg'),
 (7218, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_balance_24px.svg'),
 (7219, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_balance_wallet_24px.svg'),
 (7220, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_box_24px.svg'),
 (7221, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_account_circle_24px.svg'),
 (7222, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_add_shopping_cart_24px.svg'),
 (7223, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_24px.svg'),
 (7224, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_add_24px.svg'),
 (7225, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_off_24px.svg'),
 (7226, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_alarm_on_24px.svg'),
 (7227, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_all_out_24px.svg'),
 (7228, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_android_24px.svg'),
 (7229, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_announcement_24px.svg'),
 (7230, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_aspect_ratio_24px.svg'),
 (7231, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assessment_24px.svg'),
 (7232, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_24px.svg'),
 (7233, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_ind_24px.svg'),
 (7234, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_late_24px.svg'),
 (7235, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_return_24px.svg'),
 (7236, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_returned_24px.svg'),
 (7237, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_assignment_turned_in_24px.svg'),
 (7238, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_autorenew_24px.svg'),
 (7239, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_backup_24px.svg'),
 (7240, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_book_24px.svg'),
 (7241, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_bookmark_24px.svg'),
 (7242, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_bookmark_border_24px.svg'),
 (7243, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_bug_report_24px.svg'),
 (7244, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_build_24px.svg'),
 (7245, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_cached_24px.svg'),
 (7246, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_camera_enhance_24px.svg'),
 (7247, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_card_giftcard_24px.svg'),
 (7248, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_card_membership_24px.svg'),
 (7249, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_card_travel_24px.svg'),
 (7250, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_change_history_24px.svg'),
 (7251, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_check_circle_24px.svg'),
 (7252, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_chrome_reader_mode_24px.svg'),
 (7253, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_class_24px.svg'),
 (7254, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_code_24px.svg'),
 (7255, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_compare_arrows_24px.svg'),
 (7256, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_copyright_24px.svg'),
 (7257, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_credit_card_24px.svg'),
 (7258, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_dashboard_24px.svg'),
 (7259, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_date_range_24px.svg'),
 (7260, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_delete_24px.svg'),
 (7261, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_description_24px.svg'),
 (7262, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_dns_24px.svg'),
 (7263, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_done_24px.svg'),
 (7264, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_done_all_24px.svg'),
 (7265, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_donut_large_24px.svg'),
 (7266, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_donut_small_24px.svg'),
 (7267, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_eject_24px.svg'),
 (7268, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_event_24px.svg'),
 (7269, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_event_seat_24px.svg'),
 (7270, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_exit_to_app_24px.svg'),
 (7271, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_explore_24px.svg'),
 (7272, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_extension_24px.svg'),
 (7273, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_face_24px.svg'),
 (7274, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_favorite_24px.svg'),
 (7275, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_favorite_border_24px.svg'),
 (7276, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_feedback_24px.svg'),
 (7277, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_find_in_page_24px.svg'),
 (7278, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_find_replace_24px.svg'),
 (7279, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_fingerprint_24px.svg'),
 (7280, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flight_land_24px.svg'),
 (7281, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flight_takeoff_24px.svg'),
 (7282, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flip_to_back_24px.svg'),
 (7283, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_flip_to_front_24px.svg'),
 (7284, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_gavel_24px.svg'),
 (7285, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_get_app_24px.svg'),
 (7286, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_gif_24px.svg'),
 (7287, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_grade_24px.svg'),
 (7288, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_group_work_24px.svg'),
 (7289, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_help_24px.svg'),
 (7290, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_help_outline_24px.svg'),
 (7291, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_highlight_off_24px.svg'),
 (7292, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_history_24px.svg'),
 (7293, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_home_24px.svg'),
 (7294, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_hourglass_empty_24px.svg'),
 (7295, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_hourglass_full_24px.svg'),
 (7296, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_http_24px.svg'),
 (7297, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_https_24px.svg'),
 (7298, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_important_devices_24px.svg'),
 (7299, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_info_24px.svg'),
 (7300, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_info_outline_24px.svg'),
 (7301, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_input_24px.svg'),
 (7302, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_invert_colors_24px.svg'),
 (7303, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_label_24px.svg'),
 (7304, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_label_outline_24px.svg'),
 (7305, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_language_24px.svg'),
 (7306, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_launch_24px.svg'),
 (7307, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lightbulb_outline_24px.svg'),
 (7308, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_line_style_24px.svg'),
 (7309, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_line_weight_24px.svg'),
 (7310, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_list_24px.svg'),
 (7311, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lock_24px.svg'),
 (7312, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lock_open_24px.svg'),
 (7313, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_lock_outline_24px.svg'),
 (7314, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_loyalty_24px.svg'),
 (7315, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_markunread_mailbox_24px.svg'),
 (7316, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_motorcycle_24px.svg'),
 (7317, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_note_add_24px.svg'),
 (7318, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_offline_pin_24px.svg'),
 (7319, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_opacity_24px.svg'),
 (7320, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_open_in_browser_24px.svg'),
 (7321, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_open_in_new_24px.svg'),
 (7322, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_open_with_24px.svg'),
 (7323, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pageview_24px.svg'),
 (7324, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pan_tool_24px.svg'),
 (7325, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_payment_24px.svg'),
 (7326, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_camera_mic_24px.svg'),
 (7327, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_contact_calendar_24px.svg'),
 (7328, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_data_setting_24px.svg'),
 (7329, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_device_information_24px.svg'),
 (7330, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_identity_24px.svg'),
 (7331, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_media_24px.svg'),
 (7332, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_phone_msg_24px.svg'),
 (7333, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_perm_scan_wifi_24px.svg'),
 (7334, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pets_24px.svg'),
 (7335, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_picture_in_picture_24px.svg'),
 (7336, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_picture_in_picture_alt_24px.svg'),
 (7337, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_play_for_work_24px.svg'),
 (7338, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_polymer_24px.svg'),
 (7339, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_power_settings_new_24px.svg'),
 (7340, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_pregnant_woman_24px.svg'),
 (7341, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_print_24px.svg'),
 (7342, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_query_builder_24px.svg'),
 (7343, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_question_answer_24px.svg'),
 (7344, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_receipt_24px.svg'),
 (7345, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_record_voice_over_24px.svg'),
 (7346, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_redeem_24px.svg'),
 (7347, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_reorder_24px.svg'),
 (7348, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_report_problem_24px.svg'),
 (7349, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_restore_24px.svg'),
 (7350, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_room_24px.svg'),
 (7351, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_rounded_corner_24px.svg'),
 (7352, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_rowing_24px.svg'),
 (7353, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_schedule_24px.svg'),
 (7354, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_search_24px.svg'),
 (7355, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_24px.svg'),
 (7356, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_applications_24px.svg'),
 (7357, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_backup_restore_24px.svg'),
 (7358, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_bluetooth_24px.svg'),
 (7359, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_brightness_24px.svg'),
 (7360, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_cell_24px.svg'),
 (7361, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_ethernet_24px.svg'),
 (7362, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_antenna_24px.svg'),
 (7363, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_component_24px.svg'),
 (7364, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_composite_24px.svg'),
 (7365, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_hdmi_24px.svg'),
 (7366, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_input_svideo_24px.svg'),
 (7367, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_overscan_24px.svg'),
 (7368, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_phone_24px.svg'),
 (7369, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_power_24px.svg'),
 (7370, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_remote_24px.svg'),
 (7371, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_settings_voice_24px.svg'),
 (7372, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shop_24px.svg'),
 (7373, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shop_two_24px.svg'),
 (7374, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shopping_basket_24px.svg'),
 (7375, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_shopping_cart_24px.svg'),
 (7376, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_speaker_notes_24px.svg'),
 (7377, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_spellcheck_24px.svg'),
 (7378, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_stars_24px.svg'),
 (7379, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_store_24px.svg'),
 (7380, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_subject_24px.svg'),
 (7381, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_supervisor_account_24px.svg'),
 (7382, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_swap_horiz_24px.svg'),
 (7383, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_swap_vert_24px.svg'),
 (7384, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_swap_vertical_circle_24px.svg'),
 (7385, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_system_update_alt_24px.svg'),
 (7386, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_tab_24px.svg'),
 (7387, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_tab_unselected_24px.svg'),
 (7388, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_theaters_24px.svg'),
 (7389, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_thumb_down_24px.svg'),
 (7390, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_thumb_up_24px.svg'),
 (7391, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_thumbs_up_down_24px.svg'),
 (7392, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_timeline_24px.svg'),
 (7393, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_toc_24px.svg'),
 (7394, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_today_24px.svg'),
 (7395, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_toll_24px.svg'),
 (7396, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_touch_app_24px.svg'),
 (7397, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_track_changes_24px.svg'),
 (7398, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_translate_24px.svg'),
 (7399, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_trending_down_24px.svg'),
 (7400, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_trending_flat_24px.svg'),
 (7401, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_trending_up_24px.svg'),
 (7402, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_turned_in_24px.svg'),
 (7403, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_turned_in_not_24px.svg'),
 (7404, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_update_24px.svg'),
 (7405, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_verified_user_24px.svg'),
 (7406, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_agenda_24px.svg'),
 (7407, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_array_24px.svg'),
 (7408, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_carousel_24px.svg'),
 (7409, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_column_24px.svg'),
 (7410, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_day_24px.svg'),
 (7411, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_headline_24px.svg'),
 (7412, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_list_24px.svg'),
 (7413, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_module_24px.svg'),
 (7414, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_quilt_24px.svg'),
 (7415, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_stream_24px.svg'),
 (7416, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_view_week_24px.svg'),
 (7417, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_visibility_24px.svg'),
 (7418, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_visibility_off_24px.svg'),
 (7419, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_watch_later_24px.svg'),
 (7420, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_work_24px.svg'),
 (7421, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_youtube_searched_for_24px.svg'),
 (7422, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_zoom_in_24px.svg'),
 (7423, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/action/ic_zoom_out_24px.svg'),
 (7424, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_add_alert_24px.svg'),
 (7425, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_error_24px.svg'),
 (7426, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_error_outline_24px.svg'),
 (7427, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/alert/ic_warning_24px.svg'),
 (7428, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_add_to_queue_24px.svg'),
 (7429, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_airplay_24px.svg'),
 (7430, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_album_24px.svg'),
 (7431, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_art_track_24px.svg'),
 (7432, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_av_timer_24px.svg'),
 (7433, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_closed_caption_24px.svg'),
 (7434, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_equalizer_24px.svg'),
 (7435, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_explicit_24px.svg'),
 (7436, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fast_forward_24px.svg'),
 (7437, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fast_rewind_24px.svg'),
 (7438, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_dvr_24px.svg'),
 (7439, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_manual_record_24px.svg'),
 (7440, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_new_24px.svg'),
 (7441, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_pin_24px.svg'),
 (7442, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_fiber_smart_record_24px.svg'),
 (7443, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_forward_10_24px.svg'),
 (7444, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_forward_30_24px.svg'),
 (7445, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_forward_5_24px.svg'),
 (7446, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_games_24px.svg'),
 (7447, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_hd_24px.svg'),
 (7448, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_hearing_24px.svg'),
 (7449, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_high_quality_24px.svg'),
 (7450, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_library_add_24px.svg'),
 (7451, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_library_books_24px.svg'),
 (7452, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_library_music_24px.svg'),
 (7453, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_loop_24px.svg'),
 (7454, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_mic_24px.svg'),
 (7455, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_mic_none_24px.svg'),
 (7456, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_mic_off_24px.svg'),
 (7457, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_movie_24px.svg'),
 (7458, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_music_video_24px.svg'),
 (7459, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_new_releases_24px.svg'),
 (7460, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_not_interested_24px.svg'),
 (7461, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_pause_24px.svg'),
 (7462, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_pause_circle_filled_24px.svg'),
 (7463, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_pause_circle_outline_24px.svg'),
 (7464, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_play_arrow_24px.svg'),
 (7465, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_play_circle_filled_24px.svg'),
 (7466, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_play_circle_outline_24px.svg'),
 (7467, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_playlist_add_24px.svg'),
 (7468, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_playlist_add_check_24px.svg'),
 (7469, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_playlist_play_24px.svg'),
 (7470, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_queue_24px.svg'),
 (7471, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_queue_music_24px.svg'),
 (7472, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_queue_play_next_24px.svg'),
 (7473, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_radio_24px.svg'),
 (7474, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_recent_actors_24px.svg'),
 (7475, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_remove_from_queue_24px.svg'),
 (7476, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_repeat_24px.svg'),
 (7477, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_repeat_one_24px.svg'),
 (7478, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_10_24px.svg'),
 (7479, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_24px.svg'),
 (7480, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_30_24px.svg'),
 (7481, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_replay_5_24px.svg'),
 (7482, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_shuffle_24px.svg'),
 (7483, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_skip_next_24px.svg'),
 (7484, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_skip_previous_24px.svg'),
 (7485, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_slow_motion_video_24px.svg'),
 (7486, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_snooze_24px.svg'),
 (7487, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_sort_by_alpha_24px.svg'),
 (7488, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_stop_24px.svg'),
 (7489, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_subscriptions_24px.svg'),
 (7490, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_subtitles_24px.svg'),
 (7491, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_surround_sound_24px.svg'),
 (7492, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_video_library_24px.svg'),
 (7493, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_videocam_24px.svg'),
 (7494, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_videocam_off_24px.svg'),
 (7495, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_down_24px.svg'),
 (7496, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_mute_24px.svg'),
 (7497, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_off_24px.svg'),
 (7498, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_volume_up_24px.svg'),
 (7499, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_web_24px.svg'),
 (7500, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/av/ic_web_asset_24px.svg');
INSERT INTO `wp8b_wfknownfilelist` VALUES(7501, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/NewTux.svg'),
 (7502, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/abacus.svg'),
 (7503, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/address-book.svg'),
 (7504, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/address-book2.svg'),
 (7505, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/aim.svg'),
 (7506, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/alarm.svg'),
 (7507, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/apple.svg'),
 (7508, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/arrow-left.svg'),
 (7509, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/arrow-right.svg'),
 (7510, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/arrows-updown.svg'),
 (7511, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/atm-cash.svg'),
 (7512, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award1.svg'),
 (7513, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award2.svg'),
 (7514, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award3.svg'),
 (7515, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award4.svg'),
 (7516, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/award5.svg'),
 (7517, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/badge01.svg'),
 (7518, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/badge02.svg'),
 (7519, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bank.svg'),
 (7520, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bank2.svg'),
 (7521, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bell.svg'),
 (7522, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/binoculars.svg'),
 (7523, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bomb.svg'),
 (7524, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bonsai.svg'),
 (7525, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/book-apple.svg'),
 (7526, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/book.svg'),
 (7527, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/bookmark.svg'),
 (7528, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/box.svg'),
 (7529, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/brain.svg'),
 (7530, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/briefcase.svg'),
 (7531, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/browser01.svg'),
 (7532, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/browser02.svg'),
 (7533, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/buildings.svg'),
 (7534, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/buy-sign.svg'),
 (7535, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calculator1.svg'),
 (7536, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calculator2.svg'),
 (7537, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calculator3.svg'),
 (7538, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar1.svg'),
 (7539, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar2.svg'),
 (7540, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar3.svg'),
 (7541, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar4.svg'),
 (7542, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/calendar5.svg'),
 (7543, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/certificate.svg'),
 (7544, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/champagne.svg'),
 (7545, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character01.svg'),
 (7546, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character02.svg'),
 (7547, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character03.svg'),
 (7548, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character04.svg'),
 (7549, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character05.svg'),
 (7550, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character06.svg'),
 (7551, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character07.svg'),
 (7552, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/character08.svg'),
 (7553, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart-analysis.svg'),
 (7554, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart-board.svg'),
 (7555, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart-pyramid.svg'),
 (7556, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart01.svg'),
 (7557, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart02.svg'),
 (7558, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart03.svg'),
 (7559, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart04.svg'),
 (7560, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart05.svg'),
 (7561, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart06.svg'),
 (7562, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart07.svg'),
 (7563, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart08.svg'),
 (7564, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart09.svg'),
 (7565, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart10.svg'),
 (7566, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart11.svg'),
 (7567, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart12.svg'),
 (7568, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart13.svg'),
 (7569, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart14.svg'),
 (7570, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart15.svg'),
 (7571, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart16.svg'),
 (7572, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart17.svg'),
 (7573, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart18.svg'),
 (7574, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart19.svg'),
 (7575, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart20.svg'),
 (7576, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chart21.svg'),
 (7577, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chat.svg'),
 (7578, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/checklist.svg'),
 (7579, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/checklist2.svg'),
 (7580, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/checklist3.svg'),
 (7581, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chemistry.svg'),
 (7582, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chess-knight.svg'),
 (7583, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chess-rook.svg'),
 (7584, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/chess.svg'),
 (7585, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/clock.svg'),
 (7586, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/closed-sign.svg'),
 (7587, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/cloud-coins.svg'),
 (7588, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/cloud-down.svg'),
 (7589, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/cloud-up.svg'),
 (7590, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/coffee.svg'),
 (7591, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/conference.svg'),
 (7592, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/contact-book.svg'),
 (7593, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/coupon.svg'),
 (7594, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/credit-card.svg'),
 (7595, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/crown.svg'),
 (7596, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/currencies.svg'),
 (7597, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/database.svg'),
 (7598, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/delivery.svg'),
 (7599, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/diagram-hierarchy.svg'),
 (7600, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/diamond.svg'),
 (7601, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/dollar.svg'),
 (7602, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/drawer.svg'),
 (7603, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/egg.svg'),
 (7604, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/emblem.svg'),
 (7605, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/envelope-money.svg'),
 (7606, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/envelopes.svg'),
 (7607, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/euro.svg'),
 (7608, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/exchange.svg'),
 (7609, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/exit.svg'),
 (7610, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/factory.svg'),
 (7611, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/fax.svg'),
 (7612, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file01.svg'),
 (7613, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file02.svg'),
 (7614, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file03.svg'),
 (7615, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file04.svg'),
 (7616, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file05.svg'),
 (7617, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file06.svg'),
 (7618, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file07.svg'),
 (7619, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file08.svg'),
 (7620, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file09.svg'),
 (7621, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/file10.svg'),
 (7622, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/files.svg'),
 (7623, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/fire.svg'),
 (7624, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/fish.svg'),
 (7625, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/flag.svg'),
 (7626, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-add.svg'),
 (7627, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-delete.svg'),
 (7628, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-online.svg'),
 (7629, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-private.svg'),
 (7630, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder-remove.svg'),
 (7631, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folder.svg'),
 (7632, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/folders.svg'),
 (7633, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/funnel-money.svg'),
 (7634, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/funnel.svg'),
 (7635, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gauge.svg'),
 (7636, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gauge2.svg'),
 (7637, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gears1.svg'),
 (7638, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/gears2.svg'),
 (7639, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/glasses-moustache.svg'),
 (7640, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/globe-money.svg'),
 (7641, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/globe.svg'),
 (7642, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/globe2.svg'),
 (7643, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/graduation-hat.svg'),
 (7644, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-globe.svg'),
 (7645, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-key.svg'),
 (7646, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-money.svg'),
 (7647, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hand-money2.svg'),
 (7648, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/handshake.svg'),
 (7649, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hat-moustache.svg'),
 (7650, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hat.svg'),
 (7651, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-arrows.svg'),
 (7652, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-battery.svg'),
 (7653, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-check.svg'),
 (7654, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-compass.svg'),
 (7655, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-dollar.svg'),
 (7656, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-exclamation.svg'),
 (7657, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-flash.svg'),
 (7658, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-gauge.svg'),
 (7659, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-gears.svg'),
 (7660, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-hourglass.svg'),
 (7661, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-idea.svg'),
 (7662, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-question.svg'),
 (7663, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head-structure.svg'),
 (7664, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/head.svg'),
 (7665, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/headquarters.svg'),
 (7666, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hourglass.svg'),
 (7667, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/hours.svg'),
 (7668, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/incoming.svg'),
 (7669, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/ingots.svg'),
 (7670, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/key.svg'),
 (7671, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/key2.svg'),
 (7672, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/keyboard.svg'),
 (7673, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/label.svg'),
 (7674, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lamp.svg'),
 (7675, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-article.svg'),
 (7676, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-cart.svg'),
 (7677, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart.svg'),
 (7678, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-chart2.svg'),
 (7679, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-diagram.svg'),
 (7680, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-envelope.svg'),
 (7681, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-finance.svg'),
 (7682, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-privacy.svg'),
 (7683, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-settings.svg'),
 (7684, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop-user.svg'),
 (7685, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/laptop.svg'),
 (7686, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb-green.svg'),
 (7687, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lightbulb.svg'),
 (7688, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lightning.svg'),
 (7689, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/like.svg'),
 (7690, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/lock.svg'),
 (7691, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/magnet-money.svg'),
 (7692, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/magnifying-glass.svg'),
 (7693, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager-globe.svg'),
 (7694, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager-idea.svg'),
 (7695, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager01.svg'),
 (7696, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/manager02.svg'),
 (7697, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/meditation.svg'),
 (7698, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/megaphone.svg'),
 (7699, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money-growth.svg'),
 (7700, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money-scales.svg'),
 (7701, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money.svg'),
 (7702, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money2.svg'),
 (7703, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money3.svg'),
 (7704, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money4.svg'),
 (7705, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money5.svg'),
 (7706, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/money6.svg'),
 (7707, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/monitor.svg'),
 (7708, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/mouse.svg'),
 (7709, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/nest-money.svg'),
 (7710, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-jobs.svg'),
 (7711, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/newspaper-pen.svg'),
 (7712, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/newspaper.svg'),
 (7713, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/note-paper.svg'),
 (7714, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/office-chair.svg'),
 (7715, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/open-sign.svg'),
 (7716, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/outgoing.svg'),
 (7717, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/paper-clip.svg'),
 (7718, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/paper-plane.svg'),
 (7719, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pen.svg'),
 (7720, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pen2.svg'),
 (7721, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pencil.svg'),
 (7722, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pens-pencils.svg'),
 (7723, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-arrows06.svg'),
 (7724, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-gears.svg'),
 (7725, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-handshake.svg'),
 (7726, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-idea.svg'),
 (7727, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting.svg'),
 (7728, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-meeting02.svg'),
 (7729, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-search01.svg'),
 (7730, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-search02.svg'),
 (7731, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure.svg'),
 (7732, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure01.svg'),
 (7733, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure02.svg'),
 (7734, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure03.svg'),
 (7735, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure04.svg'),
 (7736, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure05.svg'),
 (7737, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure06.svg'),
 (7738, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/people-structure07.svg'),
 (7739, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/percent.svg'),
 (7740, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/periscopemoney.svg'),
 (7741, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows01.svg'),
 (7742, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows012.svg'),
 (7743, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows02.svg'),
 (7744, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows022.svg'),
 (7745, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-arrows03.svg'),
 (7746, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-checkmark.svg'),
 (7747, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-cross.svg'),
 (7748, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-data.svg'),
 (7749, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-dollar.svg'),
 (7750, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-finance.svg'),
 (7751, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-flag.svg'),
 (7752, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-globe.svg'),
 (7753, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-idea02.svg'),
 (7754, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-info.svg'),
 (7755, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-puzzle.svg'),
 (7756, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-scales.svg'),
 (7757, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-time.svg'),
 (7758, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/person-umbrella.svg'),
 (7759, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/phone.svg'),
 (7760, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart01.svg'),
 (7761, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pie-chart02.svg'),
 (7762, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/piggy-bank.svg'),
 (7763, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pin.svg'),
 (7764, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/plant-money.svg'),
 (7765, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/plant.svg'),
 (7766, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pound.svg'),
 (7767, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/presentation.svg'),
 (7768, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/presentation02.svg'),
 (7769, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart02.svg'),
 (7770, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart03.svg'),
 (7771, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-chart04.svg'),
 (7772, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-laurels.svg'),
 (7773, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-megaphone.svg'),
 (7774, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/preson-stairs.svg'),
 (7775, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/printer.svg'),
 (7776, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/profile.svg'),
 (7777, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/pulse.svg'),
 (7778, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/puzzle.svg'),
 (7779, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/quill.svg'),
 (7780, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/recycle.svg'),
 (7781, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/rocket.svg'),
 (7782, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/rocket2.svg'),
 (7783, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/ruble.svg'),
 (7784, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/ruler-compasses.svg'),
 (7785, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/safe.svg'),
 (7786, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/sale-sign.svg'),
 (7787, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/satellite-dish.svg'),
 (7788, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/scales.svg'),
 (7789, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/scissors.svg'),
 (7790, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/security.svg'),
 (7791, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/send.svg'),
 (7792, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/shield.svg'),
 (7793, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/shopping-cart.svg'),
 (7794, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/sign.svg'),
 (7795, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-chart.svg'),
 (7796, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-exclamation.svg'),
 (7797, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-gears.svg'),
 (7798, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-growth.svg'),
 (7799, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-money.svg'),
 (7800, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone-user.svg'),
 (7801, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/smartphone.svg'),
 (7802, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/speaker.svg'),
 (7803, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/speaker02.svg'),
 (7804, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/speech-bubble.svg'),
 (7805, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/stamp.svg'),
 (7806, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/star.svg'),
 (7807, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/steering-wheel.svg'),
 (7808, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/strategy03.svg'),
 (7809, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/strategy1.svg'),
 (7810, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/strategy2.svg'),
 (7811, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/support-person.svg'),
 (7812, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-article.svg'),
 (7813, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart.svg'),
 (7814, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart2.svg'),
 (7815, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-chart3.svg'),
 (7816, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart.svg'),
 (7817, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet-pie-chart2.svg'),
 (7818, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tablet.svg'),
 (7819, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/target.svg'),
 (7820, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/team.svg'),
 (7821, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/telescope.svg'),
 (7822, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tie.svg'),
 (7823, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tools.svg'),
 (7824, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/tools2.svg'),
 (7825, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/trash-bin.svg'),
 (7826, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/umbrella.svg'),
 (7827, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user01.svg'),
 (7828, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user02.svg'),
 (7829, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user03.svg'),
 (7830, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user04.svg'),
 (7831, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user05.svg'),
 (7832, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user06.svg'),
 (7833, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user07.svg'),
 (7834, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user08.svg'),
 (7835, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/user09.svg'),
 (7836, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/users.svg'),
 (7837, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/venn-diagram.svg'),
 (7838, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/wallet.svg'),
 (7839, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/wrench.svg'),
 (7840, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/yen.svg'),
 (7841, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/busy-icons-svg/yinyang.svg'),
 (7842, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_business_24px.svg'),
 (7843, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_24px.svg'),
 (7844, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_end_24px.svg'),
 (7845, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_made_24px.svg'),
 (7846, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_merge_24px.svg'),
 (7847, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_missed_24px.svg'),
 (7848, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_missed_outgoing_24px.svg'),
 (7849, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_received_24px.svg'),
 (7850, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_call_split_24px.svg'),
 (7851, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_chat_24px.svg'),
 (7852, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_chat_bubble_24px.svg'),
 (7853, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_chat_bubble_outline_24px.svg'),
 (7854, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_clear_all_24px.svg'),
 (7855, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_comment_24px.svg'),
 (7856, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_contact_mail_24px.svg'),
 (7857, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_contact_phone_24px.svg'),
 (7858, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_contacts_24px.svg'),
 (7859, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_dialer_sip_24px.svg'),
 (7860, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_dialpad_24px.svg'),
 (7861, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_email_24px.svg'),
 (7862, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_forum_24px.svg'),
 (7863, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_import_contacts_24px.svg'),
 (7864, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_import_export_24px.svg'),
 (7865, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_invert_colors_off_24px.svg'),
 (7866, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_live_help_24px.svg'),
 (7867, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_location_off_24px.svg'),
 (7868, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_location_on_24px.svg'),
 (7869, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_mail_outline_24px.svg'),
 (7870, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_message_24px.svg'),
 (7871, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_no_sim_24px.svg'),
 (7872, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phone_24px.svg'),
 (7873, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_erase_24px.svg'),
 (7874, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_lock_24px.svg'),
 (7875, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_ring_24px.svg'),
 (7876, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_phonelink_setup_24px.svg'),
 (7877, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_portable_wifi_off_24px.svg'),
 (7878, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_present_to_all_24px.svg'),
 (7879, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_ring_volume_24px.svg'),
 (7880, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_screen_share_24px.svg'),
 (7881, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_speaker_phone_24px.svg'),
 (7882, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_current_landscape_24px.svg'),
 (7883, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_current_portrait_24px.svg'),
 (7884, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_primary_landscape_24px.svg'),
 (7885, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stay_primary_portrait_24px.svg'),
 (7886, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_stop_screen_share_24px.svg'),
 (7887, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_swap_calls_24px.svg'),
 (7888, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_textsms_24px.svg'),
 (7889, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_voicemail_24px.svg'),
 (7890, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/communication/ic_vpn_key_24px.svg'),
 (7891, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_24px.svg'),
 (7892, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_box_24px.svg'),
 (7893, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_circle_24px.svg'),
 (7894, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_add_circle_outline_24px.svg'),
 (7895, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_archive_24px.svg'),
 (7896, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_backspace_24px.svg'),
 (7897, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_block_24px.svg'),
 (7898, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_clear_24px.svg'),
 (7899, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_content_copy_24px.svg'),
 (7900, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_content_cut_24px.svg'),
 (7901, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_content_paste_24px.svg'),
 (7902, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_create_24px.svg'),
 (7903, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_drafts_24px.svg'),
 (7904, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_filter_list_24px.svg'),
 (7905, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_flag_24px.svg'),
 (7906, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_font_download_24px.svg'),
 (7907, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_forward_24px.svg'),
 (7908, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_gesture_24px.svg'),
 (7909, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_inbox_24px.svg'),
 (7910, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_link_24px.svg'),
 (7911, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_mail_24px.svg'),
 (7912, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_markunread_24px.svg'),
 (7913, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_move_to_inbox_24px.svg'),
 (7914, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_next_week_24px.svg'),
 (7915, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_redo_24px.svg'),
 (7916, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_remove_24px.svg'),
 (7917, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_remove_circle_24px.svg'),
 (7918, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_remove_circle_outline_24px.svg'),
 (7919, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_reply_24px.svg'),
 (7920, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_reply_all_24px.svg'),
 (7921, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_report_24px.svg'),
 (7922, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_save_24px.svg'),
 (7923, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_select_all_24px.svg'),
 (7924, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_send_24px.svg'),
 (7925, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_sort_24px.svg'),
 (7926, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_text_format_24px.svg'),
 (7927, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_unarchive_24px.svg'),
 (7928, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_undo_24px.svg'),
 (7929, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/content/ic_weekend_24px.svg'),
 (7930, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_access_alarm_24px.svg'),
 (7931, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_access_alarms_24px.svg'),
 (7932, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_access_time_24px.svg'),
 (7933, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_add_alarm_24px.svg'),
 (7934, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_airplanemode_active_24px.svg'),
 (7935, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_airplanemode_inactive_24px.svg'),
 (7936, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_20_24px.svg'),
 (7937, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_30_24px.svg'),
 (7938, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_50_24px.svg'),
 (7939, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_60_24px.svg'),
 (7940, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_80_24px.svg'),
 (7941, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_90_24px.svg'),
 (7942, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_alert_24px.svg'),
 (7943, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_20_24px.svg'),
 (7944, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_30_24px.svg'),
 (7945, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_50_24px.svg'),
 (7946, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_60_24px.svg'),
 (7947, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_80_24px.svg'),
 (7948, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_90_24px.svg'),
 (7949, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_charging_full_24px.svg'),
 (7950, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_full_24px.svg'),
 (7951, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_std_24px.svg'),
 (7952, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_battery_unknown_24px.svg'),
 (7953, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_24px.svg'),
 (7954, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_connected_24px.svg'),
 (7955, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_disabled_24px.svg'),
 (7956, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_bluetooth_searching_24px.svg'),
 (7957, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_auto_24px.svg'),
 (7958, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_high_24px.svg'),
 (7959, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_low_24px.svg'),
 (7960, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_brightness_medium_24px.svg'),
 (7961, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_data_usage_24px.svg'),
 (7962, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_developer_mode_24px.svg'),
 (7963, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_devices_24px.svg'),
 (7964, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_dvr_24px.svg'),
 (7965, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_gps_fixed_24px.svg'),
 (7966, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_gps_not_fixed_24px.svg'),
 (7967, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_gps_off_24px.svg'),
 (7968, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_graphic_eq_24px.svg'),
 (7969, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_location_disabled_24px.svg'),
 (7970, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_location_searching_24px.svg'),
 (7971, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_network_cell_24px.svg'),
 (7972, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_network_wifi_24px.svg'),
 (7973, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_nfc_24px.svg'),
 (7974, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_lock_landscape_24px.svg'),
 (7975, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_lock_portrait_24px.svg'),
 (7976, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_lock_rotation_24px.svg'),
 (7977, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_screen_rotation_24px.svg'),
 (7978, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_sd_storage_24px.svg'),
 (7979, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_settings_system_daydream_24px.svg'),
 (7980, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_0_bar_24px.svg'),
 (7981, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_1_bar_24px.svg'),
 (7982, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_2_bar_24px.svg'),
 (7983, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_3_bar_24px.svg'),
 (7984, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_4_bar_24px.svg'),
 (7985, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_0_bar_24px.svg'),
 (7986, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_1_bar_24px.svg'),
 (7987, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_2_bar_24px.svg'),
 (7988, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_3_bar_24px.svg'),
 (7989, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_connected_no_internet_4_bar_24px.svg'),
 (7990, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_no_sim_24px.svg'),
 (7991, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_null_24px.svg'),
 (7992, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_cellular_off_24px.svg'),
 (7993, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_0_bar_24px.svg'),
 (7994, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_24px.svg'),
 (7995, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_1_bar_lock_24px.svg'),
 (7996, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_24px.svg'),
 (7997, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_2_bar_lock_24px.svg'),
 (7998, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_24px.svg'),
 (7999, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_3_bar_lock_24px.svg'),
 (8000, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_24px.svg');
INSERT INTO `wp8b_wfknownfilelist` VALUES(8001, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_4_bar_lock_24px.svg'),
 (8002, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_off_24px.svg'),
 (8003, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_1_bar_26x24px.svg'),
 (8004, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_2_bar_26x24px.svg'),
 (8005, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_3_bar_26x24px.svg'),
 (8006, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_4_bar_26x24px.svg'),
 (8007, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_1_26x24px.svg'),
 (8008, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_26x24px.svg'),
 (8009, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_2_26x24px.svg'),
 (8010, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_3_26x24px.svg'),
 (8011, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_connected_no_internet_4_26x24px.svg'),
 (8012, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_not_connected_26x24px.svg'),
 (8013, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_signal_wifi_statusbar_null_26x24px.svg'),
 (8014, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_storage_24px.svg'),
 (8015, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_usb_24px.svg'),
 (8016, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_wallpaper_24px.svg'),
 (8017, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_widgets_24px.svg'),
 (8018, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_wifi_lock_24px.svg'),
 (8019, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/device/ic_wifi_tethering_24px.svg'),
 (8020, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_attach_file_24px.svg'),
 (8021, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_attach_money_24px.svg'),
 (8022, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_all_24px.svg'),
 (8023, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_bottom_24px.svg'),
 (8024, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_clear_24px.svg'),
 (8025, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_color_24px.svg'),
 (8026, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_horizontal_24px.svg'),
 (8027, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_inner_24px.svg'),
 (8028, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_left_24px.svg'),
 (8029, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_outer_24px.svg'),
 (8030, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_right_24px.svg'),
 (8031, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_style_24px.svg'),
 (8032, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_top_24px.svg'),
 (8033, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_border_vertical_24px.svg'),
 (8034, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_drag_handle_24px.svg'),
 (8035, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_center_24px.svg'),
 (8036, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_justify_24px.svg'),
 (8037, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_left_24px.svg'),
 (8038, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_align_right_24px.svg'),
 (8039, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_bold_24px.svg'),
 (8040, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_clear_24px.svg'),
 (8041, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_color_fill_24px.svg'),
 (8042, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_color_reset_24px.svg'),
 (8043, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_color_text_24px.svg'),
 (8044, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_indent_decrease_24px.svg'),
 (8045, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_indent_increase_24px.svg'),
 (8046, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_italic_24px.svg'),
 (8047, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_line_spacing_24px.svg'),
 (8048, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_list_bulleted_24px.svg'),
 (8049, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_list_numbered_24px.svg'),
 (8050, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_paint_24px.svg'),
 (8051, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_quote_24px.svg'),
 (8052, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_shapes_24px.svg'),
 (8053, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_size_24px.svg'),
 (8054, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_strikethrough_24px.svg'),
 (8055, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_textdirection_l_to_r_24px.svg'),
 (8056, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_textdirection_r_to_l_24px.svg'),
 (8057, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_format_underlined_24px.svg'),
 (8058, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_functions_24px.svg'),
 (8059, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_highlight_24px.svg'),
 (8060, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_chart_24px.svg'),
 (8061, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_comment_24px.svg'),
 (8062, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_drive_file_24px.svg'),
 (8063, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_emoticon_24px.svg'),
 (8064, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_invitation_24px.svg'),
 (8065, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_link_24px.svg'),
 (8066, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_insert_photo_24px.svg'),
 (8067, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_linear_scale_24px.svg'),
 (8068, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_merge_type_24px.svg'),
 (8069, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_mode_comment_24px.svg'),
 (8070, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_mode_edit_24px.svg'),
 (8071, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_money_off_24px.svg'),
 (8072, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_publish_24px.svg'),
 (8073, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_short_text_24px.svg'),
 (8074, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_space_bar_24px.svg'),
 (8075, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_strikethrough_s_24px.svg'),
 (8076, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_text_fields_24px.svg'),
 (8077, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_vertical_align_bottom_24px.svg'),
 (8078, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_vertical_align_center_24px.svg'),
 (8079, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_vertical_align_top_24px.svg'),
 (8080, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/editor/ic_wrap_text_24px.svg'),
 (8081, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_attachment_24px.svg'),
 (8082, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_24px.svg'),
 (8083, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_circle_24px.svg'),
 (8084, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_done_24px.svg'),
 (8085, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_download_24px.svg'),
 (8086, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_off_24px.svg'),
 (8087, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_queue_24px.svg'),
 (8088, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_cloud_upload_24px.svg'),
 (8089, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_create_new_folder_24px.svg'),
 (8090, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_file_download_24px.svg'),
 (8091, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_file_upload_24px.svg'),
 (8092, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_folder_24px.svg'),
 (8093, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_folder_open_24px.svg'),
 (8094, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/file/ic_folder_shared_24px.svg'),
 (8095, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_cast_24px.svg'),
 (8096, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_cast_connected_24px.svg'),
 (8097, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_computer_24px.svg'),
 (8098, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_desktop_mac_24px.svg'),
 (8099, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_desktop_windows_24px.svg'),
 (8100, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_developer_board_24px.svg'),
 (8101, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_device_hub_24px.svg'),
 (8102, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_devices_other_24px.svg'),
 (8103, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_dock_24px.svg'),
 (8104, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_gamepad_24px.svg'),
 (8105, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_headset_24px.svg'),
 (8106, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_headset_mic_24px.svg'),
 (8107, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_24px.svg'),
 (8108, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_down_24px.svg'),
 (8109, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_left_24px.svg'),
 (8110, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_right_24px.svg'),
 (8111, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_arrow_up_24px.svg'),
 (8112, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_backspace_24px.svg'),
 (8113, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_capslock_24px.svg'),
 (8114, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_hide_24px.svg'),
 (8115, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_return_24px.svg'),
 (8116, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_tab_24px.svg'),
 (8117, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_keyboard_voice_24px.svg'),
 (8118, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_24px.svg'),
 (8119, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_chromebook_24px.svg'),
 (8120, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_mac_24px.svg'),
 (8121, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_laptop_windows_24px.svg'),
 (8122, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_memory_24px.svg'),
 (8123, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_mouse_24px.svg'),
 (8124, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phone_android_24px.svg'),
 (8125, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phone_iphone_24px.svg'),
 (8126, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phonelink_24px.svg'),
 (8127, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_phonelink_off_24px.svg'),
 (8128, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_power_input_24px.svg'),
 (8129, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_router_24px.svg'),
 (8130, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_scanner_24px.svg'),
 (8131, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_security_24px.svg'),
 (8132, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_sim_card_24px.svg'),
 (8133, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_smartphone_24px.svg'),
 (8134, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_speaker_24px.svg'),
 (8135, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_speaker_group_24px.svg'),
 (8136, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tablet_24px.svg'),
 (8137, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tablet_android_24px.svg'),
 (8138, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tablet_mac_24px.svg'),
 (8139, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_toys_24px.svg'),
 (8140, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_tv_24px.svg'),
 (8141, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_videogame_asset_24px.svg'),
 (8142, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/hardware/ic_watch_24px.svg'),
 (8143, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_add_a_photo_24px.svg'),
 (8144, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_add_to_photos_24px.svg'),
 (8145, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_adjust_24px.svg'),
 (8146, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_assistant_24px.svg'),
 (8147, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_assistant_photo_24px.svg'),
 (8148, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_audiotrack_24px.svg'),
 (8149, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_circular_24px.svg'),
 (8150, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_linear_24px.svg'),
 (8151, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_off_24px.svg'),
 (8152, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_blur_on_24px.svg'),
 (8153, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_1_24px.svg'),
 (8154, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_2_24px.svg'),
 (8155, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_3_24px.svg'),
 (8156, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_4_24px.svg'),
 (8157, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_5_24px.svg'),
 (8158, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_6_24px.svg'),
 (8159, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brightness_7_24px.svg'),
 (8160, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_broken_image_24px.svg'),
 (8161, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_brush_24px.svg'),
 (8162, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_24px.svg'),
 (8163, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_alt_24px.svg'),
 (8164, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_front_24px.svg'),
 (8165, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_rear_24px.svg'),
 (8166, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_camera_roll_24px.svg'),
 (8167, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_center_focus_strong_24px.svg'),
 (8168, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_center_focus_weak_24px.svg'),
 (8169, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_collections_24px.svg'),
 (8170, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_collections_bookmark_24px.svg'),
 (8171, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_color_lens_24px.svg'),
 (8172, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_colorize_24px.svg'),
 (8173, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_compare_24px.svg'),
 (8174, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_control_point_24px.svg'),
 (8175, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_control_point_duplicate_24px.svg'),
 (8176, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_16_9_24px.svg'),
 (8177, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_24px.svg'),
 (8178, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_3_2_24px.svg'),
 (8179, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_5_4_24px.svg'),
 (8180, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_7_5_24px.svg'),
 (8181, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_din_24px.svg'),
 (8182, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_free_24px.svg'),
 (8183, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_landscape_24px.svg'),
 (8184, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_original_24px.svg'),
 (8185, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_portrait_24px.svg'),
 (8186, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_rotate_24px.svg'),
 (8187, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_crop_square_24px.svg'),
 (8188, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_dehaze_24px.svg'),
 (8189, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_details_24px.svg'),
 (8190, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_edit_24px.svg'),
 (8191, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_24px.svg'),
 (8192, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_neg_1_24px.svg'),
 (8193, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_neg_2_24px.svg'),
 (8194, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_plus_1_24px.svg'),
 (8195, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_plus_2_24px.svg'),
 (8196, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_exposure_zero_24px.svg'),
 (8197, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_1_24px.svg'),
 (8198, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_24px.svg'),
 (8199, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_2_24px.svg'),
 (8200, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_3_24px.svg'),
 (8201, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_4_24px.svg'),
 (8202, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_5_24px.svg'),
 (8203, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_6_24px.svg'),
 (8204, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_7_24px.svg'),
 (8205, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_8_24px.svg'),
 (8206, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_9_24px.svg'),
 (8207, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_9_plus_24px.svg'),
 (8208, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_b_and_w_24px.svg'),
 (8209, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_center_focus_24px.svg'),
 (8210, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_drama_24px.svg'),
 (8211, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_frames_24px.svg'),
 (8212, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_hdr_24px.svg'),
 (8213, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_none_24px.svg'),
 (8214, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_tilt_shift_24px.svg'),
 (8215, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_filter_vintage_24px.svg'),
 (8216, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flare_24px.svg'),
 (8217, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flash_auto_24px.svg'),
 (8218, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flash_off_24px.svg'),
 (8219, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flash_on_24px.svg'),
 (8220, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_flip_24px.svg'),
 (8221, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_gradient_24px.svg'),
 (8222, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_grain_24px.svg'),
 (8223, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_grid_off_24px.svg'),
 (8224, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_grid_on_24px.svg'),
 (8225, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_off_24px.svg'),
 (8226, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_on_24px.svg'),
 (8227, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_strong_24px.svg'),
 (8228, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_hdr_weak_24px.svg'),
 (8229, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_healing_24px.svg'),
 (8230, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_image_24px.svg'),
 (8231, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_image_aspect_ratio_24px.svg'),
 (8232, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_iso_24px.svg'),
 (8233, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_landscape_24px.svg'),
 (8234, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_leak_add_24px.svg'),
 (8235, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_leak_remove_24px.svg'),
 (8236, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_lens_24px.svg'),
 (8237, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_linked_camera_24px.svg'),
 (8238, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_24px.svg'),
 (8239, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_3_24px.svg'),
 (8240, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_4_24px.svg'),
 (8241, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_5_24px.svg'),
 (8242, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_6_24px.svg'),
 (8243, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_one_24px.svg'),
 (8244, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_looks_two_24px.svg'),
 (8245, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_loupe_24px.svg'),
 (8246, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_monochrome_photos_24px.svg'),
 (8247, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_movie_creation_24px.svg'),
 (8248, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_movie_filter_24px.svg'),
 (8249, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_music_note_24px.svg'),
 (8250, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_nature_24px.svg'),
 (8251, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_nature_people_24px.svg'),
 (8252, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_navigate_before_24px.svg'),
 (8253, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_navigate_next_24px.svg'),
 (8254, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_palette_24px.svg'),
 (8255, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_24px.svg'),
 (8256, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_fish_eye_24px.svg'),
 (8257, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_horizontal_24px.svg'),
 (8258, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_vertical_24px.svg'),
 (8259, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_panorama_wide_angle_24px.svg'),
 (8260, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_24px.svg'),
 (8261, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_album_24px.svg'),
 (8262, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_camera_24px.svg'),
 (8263, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_filter_24px.svg'),
 (8264, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_library_24px.svg'),
 (8265, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_size_select_actual_24px.svg'),
 (8266, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_size_select_large_24px.svg'),
 (8267, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_photo_size_select_small_24px.svg'),
 (8268, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_picture_as_pdf_24px.svg'),
 (8269, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_portrait_24px.svg'),
 (8270, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_remove_red_eye_24px.svg'),
 (8271, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_rotate_90_degrees_ccw_24px.svg'),
 (8272, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_rotate_left_24px.svg'),
 (8273, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_rotate_right_24px.svg'),
 (8274, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_slideshow_24px.svg'),
 (8275, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_straighten_24px.svg'),
 (8276, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_style_24px.svg'),
 (8277, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_switch_camera_24px.svg'),
 (8278, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_switch_video_24px.svg'),
 (8279, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_tag_faces_24px.svg'),
 (8280, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_texture_24px.svg'),
 (8281, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timelapse_24px.svg'),
 (8282, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_10_24px.svg'),
 (8283, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_24px.svg'),
 (8284, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_3_24px.svg'),
 (8285, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_timer_off_24px.svg'),
 (8286, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_tonality_24px.svg'),
 (8287, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_transform_24px.svg'),
 (8288, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_tune_24px.svg'),
 (8289, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_view_comfy_24px.svg'),
 (8290, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_view_compact_24px.svg'),
 (8291, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_vignette_24px.svg'),
 (8292, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_auto_24px.svg'),
 (8293, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_cloudy_24px.svg'),
 (8294, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_incandescent_24px.svg'),
 (8295, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_iridescent_24px.svg'),
 (8296, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/image/ic_wb_sunny_24px.svg'),
 (8297, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/index.php'),
 (8298, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_add_location_24px.svg'),
 (8299, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_beenhere_24px.svg'),
 (8300, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_24px.svg'),
 (8301, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_bike_24px.svg'),
 (8302, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_boat_24px.svg'),
 (8303, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_bus_24px.svg'),
 (8304, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_car_24px.svg'),
 (8305, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_railway_24px.svg'),
 (8306, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_run_24px.svg'),
 (8307, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_subway_24px.svg'),
 (8308, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_transit_24px.svg'),
 (8309, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_directions_walk_24px.svg'),
 (8310, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_edit_location_24px.svg'),
 (8311, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_flight_24px.svg'),
 (8312, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_hotel_24px.svg'),
 (8313, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_layers_24px.svg'),
 (8314, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_layers_clear_24px.svg'),
 (8315, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_activity_24px.svg'),
 (8316, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_airport_24px.svg'),
 (8317, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_atm_24px.svg'),
 (8318, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_bar_24px.svg'),
 (8319, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_cafe_24px.svg'),
 (8320, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_car_wash_24px.svg'),
 (8321, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_convenience_store_24px.svg'),
 (8322, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_dining_24px.svg'),
 (8323, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_drink_24px.svg'),
 (8324, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_florist_24px.svg'),
 (8325, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_gas_station_24px.svg'),
 (8326, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_grocery_store_24px.svg'),
 (8327, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_hospital_24px.svg'),
 (8328, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_hotel_24px.svg'),
 (8329, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_laundry_service_24px.svg'),
 (8330, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_library_24px.svg'),
 (8331, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_mall_24px.svg'),
 (8332, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_movies_24px.svg'),
 (8333, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_offer_24px.svg'),
 (8334, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_parking_24px.svg'),
 (8335, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_pharmacy_24px.svg'),
 (8336, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_phone_24px.svg'),
 (8337, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_pizza_24px.svg'),
 (8338, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_play_24px.svg'),
 (8339, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_post_office_24px.svg'),
 (8340, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_printshop_24px.svg'),
 (8341, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_see_24px.svg'),
 (8342, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_shipping_24px.svg'),
 (8343, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_local_taxi_24px.svg'),
 (8344, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_map_24px.svg'),
 (8345, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_my_location_24px.svg'),
 (8346, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_navigation_24px.svg'),
 (8347, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_near_me_24px.svg'),
 (8348, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_person_pin_24px.svg'),
 (8349, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_person_pin_circle_24px.svg'),
 (8350, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_pin_drop_24px.svg'),
 (8351, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_place_24px.svg'),
 (8352, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_rate_review_24px.svg'),
 (8353, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_restaurant_menu_24px.svg'),
 (8354, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_satellite_24px.svg'),
 (8355, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_store_mall_directory_24px.svg'),
 (8356, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_terrain_24px.svg'),
 (8357, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_traffic_24px.svg'),
 (8358, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/maps/ic_zoom_out_map_24px.svg'),
 (8359, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_apps_24px.svg'),
 (8360, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_apps_36px.svg'),
 (8361, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_back_24px.svg'),
 (8362, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_back_36px.svg'),
 (8363, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_downward_24px.svg'),
 (8364, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_24px.svg'),
 (8365, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_36px.svg'),
 (8366, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_down_circle_24px.svg'),
 (8367, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_24px.svg'),
 (8368, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_drop_up_36px.svg'),
 (8369, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_24px.svg'),
 (8370, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_forward_36px.svg'),
 (8371, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_arrow_upward_24px.svg'),
 (8372, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_cancel_24px.svg'),
 (8373, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_cancel_36px.svg'),
 (8374, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_check_24px.svg'),
 (8375, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_check_36px.svg'),
 (8376, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_left_24px.svg'),
 (8377, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_left_36px.svg'),
 (8378, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_right_24px.svg'),
 (8379, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_chevron_right_36px.svg'),
 (8380, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_close_24px.svg'),
 (8381, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_close_36px.svg'),
 (8382, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_less_24px.svg'),
 (8383, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_less_36px.svg'),
 (8384, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_more_24px.svg'),
 (8385, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_expand_more_36px.svg'),
 (8386, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_24px.svg'),
 (8387, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_36px.svg'),
 (8388, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_24px.svg'),
 (8389, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_fullscreen_exit_36px.svg'),
 (8390, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_menu_24px.svg'),
 (8391, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_menu_36px.svg'),
 (8392, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_horiz_24px.svg'),
 (8393, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_horiz_36px.svg'),
 (8394, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_vert_24px.svg'),
 (8395, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_more_vert_36px.svg'),
 (8396, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_refresh_24px.svg'),
 (8397, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_refresh_36px.svg'),
 (8398, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_left_24px.svg'),
 (8399, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_subdirectory_arrow_right_24px.svg'),
 (8400, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_less_24px.svg'),
 (8401, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_less_36px.svg'),
 (8402, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_more_24px.svg'),
 (8403, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/navigation/ic_unfold_more_36px.svg'),
 (8404, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_adb_24px.svg'),
 (8405, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_24px.svg'),
 (8406, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_flat_angled_24px.svg'),
 (8407, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_individual_suite_24px.svg'),
 (8408, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_extra_24px.svg'),
 (8409, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_normal_24px.svg'),
 (8410, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_legroom_reduced_24px.svg'),
 (8411, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_extra_24px.svg'),
 (8412, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_airline_seat_recline_normal_24px.svg'),
 (8413, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_bluetooth_audio_24px.svg'),
 (8414, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_confirmation_number_24px.svg'),
 (8415, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_disc_full_24px.svg'),
 (8416, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_24px.svg'),
 (8417, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_do_not_disturb_alt_24px.svg'),
 (8418, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_drive_eta_24px.svg'),
 (8419, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_enhanced_encryption_24px.svg'),
 (8420, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_event_available_24px.svg'),
 (8421, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_event_busy_24px.svg'),
 (8422, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_event_note_24px.svg'),
 (8423, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_folder_special_24px.svg'),
 (8424, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_live_tv_24px.svg'),
 (8425, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_mms_24px.svg'),
 (8426, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_more_24px.svg'),
 (8427, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_network_check_24px.svg'),
 (8428, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_network_locked_24px.svg'),
 (8429, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_no_encryption_24px.svg'),
 (8430, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_ondemand_video_24px.svg'),
 (8431, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_personal_video_24px.svg'),
 (8432, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_bluetooth_speaker_24px.svg'),
 (8433, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_forwarded_24px.svg'),
 (8434, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_in_talk_24px.svg'),
 (8435, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_locked_24px.svg'),
 (8436, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_missed_24px.svg'),
 (8437, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_phone_paused_24px.svg'),
 (8438, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_power_24px.svg'),
 (8439, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_rv_hookup_24px.svg'),
 (8440, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sd_card_24px.svg'),
 (8441, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sim_card_alert_24px.svg'),
 (8442, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sms_24px.svg'),
 (8443, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sms_failed_24px.svg'),
 (8444, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sync_24px.svg'),
 (8445, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sync_disabled_24px.svg'),
 (8446, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_sync_problem_24px.svg'),
 (8447, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_system_update_24px.svg'),
 (8448, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_tap_and_play_24px.svg'),
 (8449, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_time_to_leave_24px.svg'),
 (8450, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_vibration_24px.svg'),
 (8451, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_voice_chat_24px.svg'),
 (8452, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_vpn_lock_24px.svg'),
 (8453, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_wc_24px.svg'),
 (8454, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/notification/ic_wifi_24px.svg'),
 (8455, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_ac_unit_24px.svg'),
 (8456, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_airport_shuttle_24px.svg'),
 (8457, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_all_inclusive_24px.svg'),
 (8458, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_beach_access_24px.svg'),
 (8459, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_business_center_24px.svg'),
 (8460, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_casino_24px.svg'),
 (8461, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_child_care_24px.svg'),
 (8462, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_child_friendly_24px.svg'),
 (8463, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_fitness_center_24px.svg'),
 (8464, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_free_breakfast_24px.svg'),
 (8465, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_golf_course_24px.svg'),
 (8466, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_hot_tub_24px.svg'),
 (8467, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_kitchen_24px.svg'),
 (8468, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_pool_24px.svg'),
 (8469, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_room_service_24px.svg'),
 (8470, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_smoke_free_24px.svg'),
 (8471, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_smoking_rooms_24px.svg'),
 (8472, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/places/ic_spa_24px.svg'),
 (8473, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_cake_24px.svg'),
 (8474, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_domain_24px.svg'),
 (8475, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_group_24px.svg'),
 (8476, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_group_add_24px.svg'),
 (8477, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_location_city_24px.svg'),
 (8478, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_mood_24px.svg'),
 (8479, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_mood_bad_24px.svg'),
 (8480, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_24px.svg'),
 (8481, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_active_24px.svg'),
 (8482, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_none_24px.svg'),
 (8483, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_off_24px.svg'),
 (8484, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_notifications_paused_24px.svg'),
 (8485, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_pages_24px.svg'),
 (8486, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_party_mode_24px.svg'),
 (8487, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_people_24px.svg'),
 (8488, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_people_outline_24px.svg'),
 (8489, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_person_24px.svg'),
 (8490, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_person_add_24px.svg'),
 (8491, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_person_outline_24px.svg'),
 (8492, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_plus_one_24px.svg'),
 (8493, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_poll_24px.svg'),
 (8494, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_public_24px.svg'),
 (8495, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_school_24px.svg'),
 (8496, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_share_24px.svg'),
 (8497, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/social/ic_whatshot_24px.svg'),
 (8498, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_check_box_24px.svg'),
 (8499, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_check_box_outline_blank_24px.svg'),
 (8500, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_indeterminate_check_box_24px.svg');
INSERT INTO `wp8b_wfknownfilelist` VALUES(8501, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_radio_button_checked_24px.svg'),
 (8502, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_radio_button_unchecked_24px.svg'),
 (8503, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_star_24px.svg'),
 (8504, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_star_border_24px.svg'),
 (8505, 'wp-content/updraft/plugins-old/revslider/public/assets/assets/svg/toggle/ic_star_half_24px.svg'),
 (8506, 'wp-content/updraft/plugins-old/revslider/public/assets/css/index.php'),
 (8507, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/font-awesome/fonts/fontawesome-webfont.svg'),
 (8508, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/font-awesome/index.php'),
 (8509, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/index.php'),
 (8510, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/material/MaterialIcons-Regular.svg'),
 (8511, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/css/index.php'),
 (8512, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/Pe-icon-7-stroke.svg'),
 (8513, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/fonts/index.php'),
 (8514, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/pe-icon-7-stroke/index.php'),
 (8515, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/revicons/index.php'),
 (8516, 'wp-content/updraft/plugins-old/revslider/public/assets/fonts/revicons/revicons.svg'),
 (8517, 'wp-content/updraft/plugins-old/revslider/public/assets/index.php'),
 (8518, 'wp-content/updraft/plugins-old/revslider/public/assets/js/index.php'),
 (8519, 'wp-content/updraft/plugins-old/revslider/public/assets/js/rbtools.min.js'),
 (8520, 'wp-content/updraft/plugins-old/revslider/public/assets/js/rs6.min.js'),
 (8521, 'wp-content/updraft/plugins-old/revslider/public/includes/functions-public.class.php'),
 (8522, 'wp-content/updraft/plugins-old/revslider/public/index.php'),
 (8523, 'wp-content/updraft/plugins-old/revslider/public/revslider-front.class.php'),
 (8524, 'wp-content/updraft/plugins-old/revslider/public/views/revslider-page-template.php'),
 (8525, 'wp-content/updraft/plugins-old/revslider/release_log.html'),
 (8526, 'wp-content/updraft/plugins-old/revslider/revslider.php'),
 (8527, 'wp-content/updraft/plugins-old/revslider/uninstall.php'),
 (8528, 'wp-content/updraft/plugins-old/revslider/welcome.html'),
 (8529, 'wp-content/updraft/plugins-old/updraftplus/admin.php'),
 (8530, 'wp-content/updraft/plugins-old/updraftplus/backup.php'),
 (8531, 'wp-content/updraft/plugins-old/updraftplus/central/bootstrap.php'),
 (8532, 'wp-content/updraft/plugins-old/updraftplus/central/classes/automatic-upgrader-skin-compatibility.php'),
 (8533, 'wp-content/updraft/plugins-old/updraftplus/central/classes/class-automatic-upgrader-skin.php'),
 (8534, 'wp-content/updraft/plugins-old/updraftplus/central/commands.php'),
 (8535, 'wp-content/updraft/plugins-old/updraftplus/central/listener.php'),
 (8536, 'wp-content/updraft/plugins-old/updraftplus/central/modules/analytics.php'),
 (8537, 'wp-content/updraft/plugins-old/updraftplus/central/modules/comments.php'),
 (8538, 'wp-content/updraft/plugins-old/updraftplus/central/modules/core.php'),
 (8539, 'wp-content/updraft/plugins-old/updraftplus/central/modules/media.php'),
 (8540, 'wp-content/updraft/plugins-old/updraftplus/central/modules/plugin.php'),
 (8541, 'wp-content/updraft/plugins-old/updraftplus/central/modules/posts.php'),
 (8542, 'wp-content/updraft/plugins-old/updraftplus/central/modules/theme.php'),
 (8543, 'wp-content/updraft/plugins-old/updraftplus/central/modules/updates.php'),
 (8544, 'wp-content/updraft/plugins-old/updraftplus/central/modules/users.php'),
 (8545, 'wp-content/updraft/plugins-old/updraftplus/class-updraftplus.php'),
 (8546, 'wp-content/updraft/plugins-old/updraftplus/example-decrypt.php'),
 (8547, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/API.php'),
 (8548, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/Exception.php'),
 (8549, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Consumer/ConsumerAbstract.php'),
 (8550, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Consumer/Curl.php'),
 (8551, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Consumer/WordPress.php'),
 (8552, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Storage/Encrypter.php'),
 (8553, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Storage/StorageInterface.php'),
 (8554, 'wp-content/updraft/plugins-old/updraftplus/includes/Dropbox2/OAuth/Storage/WordPress.php'),
 (8555, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/Abstract.php'),
 (8556, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/AppIdentity.php'),
 (8557, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/AssertionCredentials.php'),
 (8558, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/ComputeEngine.php'),
 (8559, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/Exception.php'),
 (8560, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/LoginTicket.php'),
 (8561, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/OAuth2.php'),
 (8562, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Auth/Simple.php'),
 (8563, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Abstract.php'),
 (8564, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Apc.php'),
 (8565, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Exception.php'),
 (8566, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/File.php'),
 (8567, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Memcache.php'),
 (8568, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Cache/Null.php'),
 (8569, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Client.php'),
 (8570, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Collection.php'),
 (8571, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Config.php'),
 (8572, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Exception.php'),
 (8573, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/Batch.php'),
 (8574, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/CacheParser.php'),
 (8575, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/MediaFileUpload.php'),
 (8576, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/REST.php'),
 (8577, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Http/Request.php'),
 (8578, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Abstract.php'),
 (8579, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Curl.php'),
 (8580, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Exception.php'),
 (8581, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/IO/Stream.php'),
 (8582, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Abstract.php'),
 (8583, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Exception.php'),
 (8584, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/File.php'),
 (8585, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Null.php'),
 (8586, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Logger/Psr.php'),
 (8587, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Model.php'),
 (8588, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Audit.php'),
 (8589, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Container.php'),
 (8590, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Datastore.php'),
 (8591, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Directory.php'),
 (8592, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Dns.php'),
 (8593, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Drive.php'),
 (8594, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Exception.php'),
 (8595, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/GroupsMigration.php'),
 (8596, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Groupssettings.php'),
 (8597, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/IdentityToolkit.php'),
 (8598, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Licensing.php'),
 (8599, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Logging.php'),
 (8600, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Oauth2.php'),
 (8601, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Reports.php'),
 (8602, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Resource.php'),
 (8603, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Resourceviews.php'),
 (8604, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Storage.php'),
 (8605, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service/Tasks.php'),
 (8606, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Service.php'),
 (8607, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Signer/Abstract.php'),
 (8608, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Signer/P12.php'),
 (8609, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Task/Exception.php'),
 (8610, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Task/Retryable.php'),
 (8611, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Task/Runner.php'),
 (8612, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Utils/URITemplate.php'),
 (8613, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Utils.php'),
 (8614, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Verifier/Abstract.php'),
 (8615, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/Verifier/Pem.php'),
 (8616, 'wp-content/updraft/plugins-old/updraftplus/includes/Google/autoload.php'),
 (8617, 'wp-content/updraft/plugins-old/updraftplus/includes/S3.php'),
 (8618, 'wp-content/updraft/plugins-old/updraftplus/includes/S3compat.php'),
 (8619, 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/assets/loader.svg'),
 (8620, 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.js'),
 (8621, 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/assets/udp-checkout-embed.min.js'),
 (8622, 'wp-content/updraft/plugins-old/updraftplus/includes/checkout-embed/class-udp-checkout-embed.php'),
 (8623, 'wp-content/updraft/plugins-old/updraftplus/includes/class-backup-history.php'),
 (8624, 'wp-content/updraft/plugins-old/updraftplus/includes/class-commands.php'),
 (8625, 'wp-content/updraft/plugins-old/updraftplus/includes/class-database-utility.php'),
 (8626, 'wp-content/updraft/plugins-old/updraftplus/includes/class-filesystem-functions.php'),
 (8627, 'wp-content/updraft/plugins-old/updraftplus/includes/class-job-scheduler.php'),
 (8628, 'wp-content/updraft/plugins-old/updraftplus/includes/class-manipulation-functions.php'),
 (8629, 'wp-content/updraft/plugins-old/updraftplus/includes/class-partialfileservlet.php'),
 (8630, 'wp-content/updraft/plugins-old/updraftplus/includes/class-remote-send.php'),
 (8631, 'wp-content/updraft/plugins-old/updraftplus/includes/class-semaphore.php'),
 (8632, 'wp-content/updraft/plugins-old/updraftplus/includes/class-storage-methods-interface.php'),
 (8633, 'wp-content/updraft/plugins-old/updraftplus/includes/class-udrpc.php'),
 (8634, 'wp-content/updraft/plugins-old/updraftplus/includes/class-updraft-dashboard-news.php'),
 (8635, 'wp-content/updraft/plugins-old/updraftplus/includes/class-updraftcentral-updraftplus-commands.php'),
 (8636, 'wp-content/updraft/plugins-old/updraftplus/includes/class-updraftplus-encryption.php'),
 (8637, 'wp-content/updraft/plugins-old/updraftplus/includes/class-wpadmin-commands.php'),
 (8638, 'wp-content/updraft/plugins-old/updraftplus/includes/class-zip.php'),
 (8639, 'wp-content/updraft/plugins-old/updraftplus/includes/cloudfiles/cloudfiles.php'),
 (8640, 'wp-content/updraft/plugins-old/updraftplus/includes/cloudfiles/cloudfiles_exceptions.php'),
 (8641, 'wp-content/updraft/plugins-old/updraftplus/includes/cloudfiles/cloudfiles_http.php'),
 (8642, 'wp-content/updraft/plugins-old/updraftplus/includes/ftp.class.php'),
 (8643, 'wp-content/updraft/plugins-old/updraftplus/includes/google-extensions.php'),
 (8644, 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.js'),
 (8645, 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.min.js'),
 (8646, 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.runtime.js'),
 (8647, 'wp-content/updraft/plugins-old/updraftplus/includes/handlebars/handlebars.runtime.min.js'),
 (8648, 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.blockUI.js'),
 (8649, 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.blockUI.min.js'),
 (8650, 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.js'),
 (8651, 'wp-content/updraft/plugins-old/updraftplus/includes/jquery.serializeJSON/jquery.serializejson.min.js'),
 (8652, 'wp-content/updraft/plugins-old/updraftplus/includes/jstree/jstree.js'),
 (8653, 'wp-content/updraft/plugins-old/updraftplus/includes/jstree/jstree.min.js'),
 (8654, 'wp-content/updraft/plugins-old/updraftplus/includes/labelauty/jquery-labelauty.js'),
 (8655, 'wp-content/updraft/plugins-old/updraftplus/includes/labelauty/jquery-labelauty.min.js'),
 (8656, 'wp-content/updraft/plugins-old/updraftplus/includes/tether/tether.js'),
 (8657, 'wp-content/updraft/plugins-old/updraftplus/includes/tether/tether.min.js'),
 (8658, 'wp-content/updraft/plugins-old/updraftplus/includes/tether-shepherd/shepherd.js'),
 (8659, 'wp-content/updraft/plugins-old/updraftplus/includes/tether-shepherd/shepherd.min.js'),
 (8660, 'wp-content/updraft/plugins-old/updraftplus/includes/tether-shepherd/tether.js'),
 (8661, 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-admin-common.js'),
 (8662, 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-admin-common.min.js'),
 (8663, 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-notices.php'),
 (8664, 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-restorer-skin-compatibility.php'),
 (8665, 'wp-content/updraft/plugins-old/updraftplus/includes/updraft-restorer-skin.php'),
 (8666, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftcentral.php'),
 (8667, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-auto-login.php'),
 (8668, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-dash-notice.php'),
 (8669, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-restore.php'),
 (8670, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-status.php'),
 (8671, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftclone/temporary-clone-user-notice.php'),
 (8672, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-clone.php'),
 (8673, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-login.php'),
 (8674, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-notices.php'),
 (8675, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftplus-tour.php'),
 (8676, 'wp-content/updraft/plugins-old/updraftplus/includes/updraftvault.php'),
 (8677, 'wp-content/updraft/plugins-old/updraftplus/index.html'),
 (8678, 'wp-content/updraft/plugins-old/updraftplus/js/tour.js'),
 (8679, 'wp-content/updraft/plugins-old/updraftplus/js/tour.min.js'),
 (8680, 'wp-content/updraft/plugins-old/updraftplus/js/updraft-admin-restore.js'),
 (8681, 'wp-content/updraft/plugins-old/updraftplus/js/updraft-admin-restore.min.js'),
 (8682, 'wp-content/updraft/plugins-old/updraftplus/methods/addon-base-v2.php'),
 (8683, 'wp-content/updraft/plugins-old/updraftplus/methods/addon-not-yet-present.php'),
 (8684, 'wp-content/updraft/plugins-old/updraftplus/methods/azure.php'),
 (8685, 'wp-content/updraft/plugins-old/updraftplus/methods/backblaze.php'),
 (8686, 'wp-content/updraft/plugins-old/updraftplus/methods/backup-module.php'),
 (8687, 'wp-content/updraft/plugins-old/updraftplus/methods/cloudfiles-new.php'),
 (8688, 'wp-content/updraft/plugins-old/updraftplus/methods/cloudfiles.php'),
 (8689, 'wp-content/updraft/plugins-old/updraftplus/methods/dreamobjects.php'),
 (8690, 'wp-content/updraft/plugins-old/updraftplus/methods/dropbox.php'),
 (8691, 'wp-content/updraft/plugins-old/updraftplus/methods/email.php'),
 (8692, 'wp-content/updraft/plugins-old/updraftplus/methods/ftp.php'),
 (8693, 'wp-content/updraft/plugins-old/updraftplus/methods/googlecloud.php'),
 (8694, 'wp-content/updraft/plugins-old/updraftplus/methods/googledrive.php'),
 (8695, 'wp-content/updraft/plugins-old/updraftplus/methods/insufficient.php'),
 (8696, 'wp-content/updraft/plugins-old/updraftplus/methods/onedrive.php'),
 (8697, 'wp-content/updraft/plugins-old/updraftplus/methods/openstack-base.php'),
 (8698, 'wp-content/updraft/plugins-old/updraftplus/methods/openstack.php'),
 (8699, 'wp-content/updraft/plugins-old/updraftplus/methods/openstack2.php'),
 (8700, 'wp-content/updraft/plugins-old/updraftplus/methods/remotesend.php'),
 (8701, 'wp-content/updraft/plugins-old/updraftplus/methods/s3.php'),
 (8702, 'wp-content/updraft/plugins-old/updraftplus/methods/s3generic.php'),
 (8703, 'wp-content/updraft/plugins-old/updraftplus/methods/sftp.php'),
 (8704, 'wp-content/updraft/plugins-old/updraftplus/methods/template.php'),
 (8705, 'wp-content/updraft/plugins-old/updraftplus/methods/updraftvault.php'),
 (8706, 'wp-content/updraft/plugins-old/updraftplus/methods/webdav.php'),
 (8707, 'wp-content/updraft/plugins-old/updraftplus/options.php'),
 (8708, 'wp-content/updraft/plugins-old/updraftplus/restorer.php'),
 (8709, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/advanced-tools.php'),
 (8710, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/export-settings.php'),
 (8711, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/lock-admin.php'),
 (8712, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/search-replace.php'),
 (8713, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/site-info.php'),
 (8714, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/tools-menu.php'),
 (8715, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/total-size.php'),
 (8716, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/updraftcentral.php'),
 (8717, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/advanced/wipe-settings.php'),
 (8718, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/autobackup-notice.php'),
 (8719, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/bottom-notice.php'),
 (8720, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/horizontal-notice.php'),
 (8721, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/report-plain.php'),
 (8722, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/report.php'),
 (8723, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/notices/thanks-for-using-main-dash.php'),
 (8724, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/backupnow-modal.php'),
 (8725, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/delete-and-restore-modals.php'),
 (8726, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/downloading-and-restoring.php'),
 (8727, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/exclude-modal.php'),
 (8728, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-heading.php'),
 (8729, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/exclude-settings-modal/exclude-panel-submit.php'),
 (8730, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/existing-backups-table.php'),
 (8731, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/file-backup-exclude.php'),
 (8732, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/footer.php'),
 (8733, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/form-contents.php'),
 (8734, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/header.php'),
 (8735, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/migrator-no-migrator.php'),
 (8736, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/tab-addons.php'),
 (8737, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/tab-backups.php'),
 (8738, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/tab-bar.php'),
 (8739, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/take-backup.php'),
 (8740, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/temporary-clone.php'),
 (8741, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/updraftcentral-connect.php'),
 (8742, 'wp-content/updraft/plugins-old/updraftplus/templates/wp-admin/settings/upload-backups-modal.php'),
 (8743, 'wp-content/updraft/plugins-old/updraftplus/updraftplus.php'),
 (8744, 'wp-content/updraft/plugins-old/updraftplus/vendor/autoload.php'),
 (8745, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Aws.php'),
 (8746, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AbstractClient.php'),
 (8747, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/AwsClientInterface.php'),
 (8748, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ClientBuilder.php'),
 (8749, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/DefaultClient.php'),
 (8750, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ExpiredCredentialsChecker.php'),
 (8751, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/ThrottlingErrorChecker.php'),
 (8752, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UploadBodyListener.php'),
 (8753, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Client/UserAgentListener.php'),
 (8754, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/AwsQueryVisitor.php'),
 (8755, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/JsonCommand.php'),
 (8756, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/QueryCommand.php'),
 (8757, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Command/XmlResponseLocationVisitor.php'),
 (8758, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractCredentialsDecorator.php'),
 (8759, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/AbstractRefreshableCredentials.php'),
 (8760, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CacheableCredentials.php'),
 (8761, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/Credentials.php'),
 (8762, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/CredentialsInterface.php'),
 (8763, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/NullCredentials.php'),
 (8764, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Credentials/RefreshableInstanceProfileCredentials.php'),
 (8765, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/ClientOptions.php'),
 (8766, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/DateFormat.php'),
 (8767, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Region.php'),
 (8768, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Size.php'),
 (8769, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/Time.php'),
 (8770, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum/UaString.php'),
 (8771, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Enum.php'),
 (8772, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/AwsExceptionInterface.php'),
 (8773, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/BadMethodCallException.php'),
 (8774, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/DomainException.php'),
 (8775, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionFactoryInterface.php'),
 (8776, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ExceptionListener.php'),
 (8777, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InstanceProfileCredentialsException.php'),
 (8778, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/InvalidArgumentException.php'),
 (8779, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/LogicException.php'),
 (8780, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/MultipartUploadException.php'),
 (8781, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/NamespaceExceptionFactory.php'),
 (8782, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OutOfBoundsException.php'),
 (8783, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/OverflowException.php'),
 (8784, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/AbstractJsonExceptionParser.php'),
 (8785, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/DefaultXmlExceptionParser.php'),
 (8786, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/ExceptionParserInterface.php'),
 (8787, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonQueryExceptionParser.php'),
 (8788, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/Parser/JsonRestExceptionParser.php'),
 (8789, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RequiredExtensionNotLoadedException.php'),
 (8790, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/RuntimeException.php'),
 (8791, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/ServiceResponseException.php'),
 (8792, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/TransferException.php'),
 (8793, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Exception/UnexpectedValueException.php'),
 (8794, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/Facade.php'),
 (8795, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/FacadeInterface.php'),
 (8796, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Facade/facade-classes.php'),
 (8797, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHash.php'),
 (8798, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/ChunkHashInterface.php'),
 (8799, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/HashUtils.php'),
 (8800, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Hash/TreeHash.php'),
 (8801, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/HostNameUtils.php'),
 (8802, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/InstanceMetadataClient.php'),
 (8803, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/InstanceMetadata/Waiter/ServiceAvailable.php'),
 (8804, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIterator.php'),
 (8805, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Iterator/AwsResourceIteratorFactory.php'),
 (8806, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransfer.php'),
 (8807, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractTransferState.php'),
 (8808, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadBuilder.php'),
 (8809, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadId.php'),
 (8810, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/AbstractUploadPart.php'),
 (8811, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferInterface.php'),
 (8812, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/TransferStateInterface.php'),
 (8813, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadIdInterface.php'),
 (8814, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Model/MultipartUpload/UploadPartInterface.php'),
 (8815, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/aws-config.php'),
 (8816, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/public-endpoints.php'),
 (8817, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Resources/sdk1-config.php'),
 (8818, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/RulesEndpointProvider.php'),
 (8819, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/AbstractSignature.php'),
 (8820, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/EndpointSignatureInterface.php'),
 (8821, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureInterface.php'),
 (8822, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureListener.php'),
 (8823, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV2.php'),
 (8824, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV3Https.php'),
 (8825, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Signature/SignatureV4.php'),
 (8826, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractResourceWaiter.php'),
 (8827, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/AbstractWaiter.php'),
 (8828, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CallableWaiter.php'),
 (8829, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/CompositeWaiterFactory.php'),
 (8830, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ConfigResourceWaiter.php'),
 (8831, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/ResourceWaiterInterface.php'),
 (8832, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterClassFactory.php'),
 (8833, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfig.php'),
 (8834, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterConfigFactory.php'),
 (8835, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterFactoryInterface.php'),
 (8836, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/Common/Waiter/WaiterInterface.php'),
 (8837, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/AcpListener.php'),
 (8838, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/BucketStyleListener.php'),
 (8839, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Command/S3Command.php'),
 (8840, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/CannedAcl.php'),
 (8841, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/EncodingType.php'),
 (8842, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Event.php'),
 (8843, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/GranteeType.php'),
 (8844, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Group.php'),
 (8845, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MFADelete.php'),
 (8846, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/MetadataDirective.php'),
 (8847, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Payer.php'),
 (8848, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Permission.php'),
 (8849, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Protocol.php'),
 (8850, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/ServerSideEncryption.php'),
 (8851, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Status.php'),
 (8852, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/Storage.php'),
 (8853, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Enum/StorageClass.php'),
 (8854, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccessDeniedException.php'),
 (8855, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AccountProblemException.php'),
 (8856, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/AmbiguousGrantByEmailAddressException.php'),
 (8857, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BadDigestException.php'),
 (8858, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyExistsException.php'),
 (8859, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketAlreadyOwnedByYouException.php'),
 (8860, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/BucketNotEmptyException.php'),
 (8861, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CredentialsNotSupportedException.php'),
 (8862, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/CrossLocationLoggingProhibitedException.php'),
 (8863, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/DeleteMultipleObjectsException.php'),
 (8864, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooLargeException.php'),
 (8865, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/EntityTooSmallException.php'),
 (8866, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ExpiredTokenException.php'),
 (8867, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IllegalVersioningConfigurationException.php'),
 (8868, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncompleteBodyException.php'),
 (8869, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/IncorrectNumberOfFilesInPostRequestException.php'),
 (8870, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InlineDataTooLargeException.php'),
 (8871, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InternalErrorException.php'),
 (8872, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAccessKeyIdException.php'),
 (8873, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidAddressingHeaderException.php'),
 (8874, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidArgumentException.php'),
 (8875, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketNameException.php'),
 (8876, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidBucketStateException.php'),
 (8877, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidDigestException.php'),
 (8878, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidLocationConstraintException.php'),
 (8879, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartException.php'),
 (8880, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPartOrderException.php'),
 (8881, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPayerException.php'),
 (8882, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidPolicyDocumentException.php'),
 (8883, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRangeException.php'),
 (8884, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidRequestException.php'),
 (8885, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSOAPRequestException.php'),
 (8886, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidSecurityException.php'),
 (8887, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidStorageClassException.php'),
 (8888, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTagErrorException.php'),
 (8889, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTargetBucketForLoggingException.php'),
 (8890, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidTokenException.php'),
 (8891, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/InvalidURIException.php'),
 (8892, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/KeyTooLongException.php'),
 (8893, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedACLErrorException.php'),
 (8894, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedPOSTRequestException.php'),
 (8895, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MalformedXMLException.php'),
 (8896, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxMessageLengthExceededException.php'),
 (8897, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MaxPostPreDataLengthExceededErrorException.php'),
 (8898, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MetadataTooLargeException.php'),
 (8899, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MethodNotAllowedException.php'),
 (8900, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingAttachmentException.php'),
 (8901, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingContentLengthException.php'),
 (8902, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingRequestBodyErrorException.php'),
 (8903, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityElementException.php'),
 (8904, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/MissingSecurityHeaderException.php'),
 (8905, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoLoggingStatusForKeyException.php'),
 (8906, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketException.php'),
 (8907, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchBucketPolicyException.php'),
 (8908, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchCORSConfigurationException.php'),
 (8909, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchKeyException.php'),
 (8910, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchLifecycleConfigurationException.php'),
 (8911, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetErrorException.php'),
 (8912, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchTagSetException.php'),
 (8913, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchUploadException.php'),
 (8914, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchVersionException.php'),
 (8915, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NoSuchWebsiteConfigurationException.php'),
 (8916, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotImplementedException.php'),
 (8917, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSignedUpException.php'),
 (8918, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/NotSuchBucketPolicyException.php'),
 (8919, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectAlreadyInActiveTierErrorException.php'),
 (8920, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ObjectNotInActiveTierErrorException.php'),
 (8921, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/OperationAbortedException.php'),
 (8922, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/Parser/S3ExceptionParser.php'),
 (8923, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PermanentRedirectException.php'),
 (8924, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/PreconditionFailedException.php'),
 (8925, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RedirectException.php'),
 (8926, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestIsNotMultiPartContentException.php'),
 (8927, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeTooSkewedException.php'),
 (8928, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTimeoutException.php'),
 (8929, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/RequestTorrentOfBucketErrorException.php'),
 (8930, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/S3Exception.php'),
 (8931, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/ServiceUnavailableException.php'),
 (8932, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SignatureDoesNotMatchException.php'),
 (8933, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/SlowDownException.php'),
 (8934, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TemporaryRedirectException.php'),
 (8935, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TokenRefreshRequiredException.php'),
 (8936, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/TooManyBucketsException.php'),
 (8937, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnexpectedContentException.php'),
 (8938, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UnresolvableGrantByEmailAddressException.php'),
 (8939, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Exception/UserKeyMustBeSpecifiedException.php'),
 (8940, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/IncompleteMultipartUploadChecker.php'),
 (8941, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListBucketsIterator.php'),
 (8942, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListMultipartUploadsIterator.php'),
 (8943, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectVersionsIterator.php'),
 (8944, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/ListObjectsIterator.php'),
 (8945, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Iterator/OpendirIterator.php'),
 (8946, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Acp.php'),
 (8947, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/AcpBuilder.php'),
 (8948, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/ClearBucket.php'),
 (8949, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsBatch.php'),
 (8950, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/DeleteObjectsTransfer.php'),
 (8951, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grant.php'),
 (8952, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/Grantee.php'),
 (8953, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/AbstractTransfer.php'),
 (8954, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/ParallelTransfer.php'),
 (8955, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/SerialTransfer.php'),
 (8956, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/TransferState.php'),
 (8957, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadBuilder.php'),
 (8958, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadId.php'),
 (8959, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/MultipartUpload/UploadPart.php'),
 (8960, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Model/PostObject.php'),
 (8961, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Resources/s3-2006-03-01.php'),
 (8962, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/ResumableDownload.php'),
 (8963, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Client.php'),
 (8964, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Md5Listener.php'),
 (8965, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3Signature.php'),
 (8966, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureInterface.php'),
 (8967, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/S3SignatureV4.php'),
 (8968, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SocketTimeoutChecker.php'),
 (8969, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/SseCpkListener.php'),
 (8970, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/StreamWrapper.php'),
 (8971, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSync.php'),
 (8972, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/AbstractSyncBuilder.php'),
 (8973, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/ChangedFilesIterator.php'),
 (8974, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSync.php'),
 (8975, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/DownloadSyncBuilder.php'),
 (8976, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/FilenameConverterInterface.php'),
 (8977, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/KeyConverter.php'),
 (8978, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSync.php'),
 (8979, 'wp-content/updraft/plugins-old/updraftplus/vendor/aws/aws-sdk-php/src/Aws/S3/Sync/UploadSyncBuilder.php'),
 (8980, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/ClassLoader.php'),
 (8981, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_classmap.php'),
 (8982, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_files.php'),
 (8983, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_namespaces.php'),
 (8984, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_psr4.php'),
 (8985, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_real.php'),
 (8986, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/autoload_static.php'),
 (8987, 'wp-content/updraft/plugins-old/updraftplus/vendor/composer/include_paths.php'),
 (8988, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Consumer.php'),
 (8989, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/HmacSha1.php'),
 (8990, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthDataStore.php'),
 (8991, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthException.php'),
 (8992, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/OAuthServer.php'),
 (8993, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/PlainText.php'),
 (8994, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Request.php'),
 (8995, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/RsaSha1.php'),
 (8996, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/SignatureMethod.php'),
 (8997, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Token.php'),
 (8998, 'wp-content/updraft/plugins-old/updraftplus/vendor/eher/oauth/src/Eher/OAuth/Util.php'),
 (8999, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/phar-stub.php'),
 (9000, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/AbstractBatchDecorator.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(9001, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Batch.php'),
 (9002, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchBuilder.php'),
 (9003, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureDivisor.php'),
 (9004, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchClosureTransfer.php'),
 (9005, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchCommandTransfer.php'),
 (9006, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchDivisorInterface.php'),
 (9007, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchInterface.php'),
 (9008, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchRequestTransfer.php'),
 (9009, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchSizeDivisor.php'),
 (9010, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/BatchTransferInterface.php'),
 (9011, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/Exception/BatchTransferException.php'),
 (9012, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/ExceptionBufferingBatch.php'),
 (9013, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/FlushingBatch.php'),
 (9014, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/HistoryBatch.php'),
 (9015, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Batch/NotifyingBatch.php'),
 (9016, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/AbstractCacheAdapter.php'),
 (9017, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterFactory.php'),
 (9018, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/CacheAdapterInterface.php'),
 (9019, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/ClosureCacheAdapter.php'),
 (9020, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/DoctrineCacheAdapter.php'),
 (9021, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/NullCacheAdapter.php'),
 (9022, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf1CacheAdapter.php'),
 (9023, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Cache/Zf2CacheAdapter.php'),
 (9024, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/AbstractHasDispatcher.php'),
 (9025, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Collection.php'),
 (9026, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Event.php'),
 (9027, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/BadMethodCallException.php'),
 (9028, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/ExceptionCollection.php'),
 (9029, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/GuzzleException.php'),
 (9030, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/InvalidArgumentException.php'),
 (9031, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/RuntimeException.php'),
 (9032, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Exception/UnexpectedValueException.php'),
 (9033, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/FromConfigInterface.php'),
 (9034, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/HasDispatcherInterface.php'),
 (9035, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/ToArrayInterface.php'),
 (9036, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Common/Version.php'),
 (9037, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/AbstractEntityBodyDecorator.php'),
 (9038, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/CachingEntityBody.php'),
 (9039, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Client.php'),
 (9040, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ClientInterface.php'),
 (9041, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlHandle.php'),
 (9042, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMulti.php'),
 (9043, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiInterface.php'),
 (9044, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlMultiProxy.php'),
 (9045, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/CurlVersion.php'),
 (9046, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Curl/RequestMediator.php'),
 (9047, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBody.php'),
 (9048, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/EntityBodyInterface.php'),
 (9049, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/BadResponseException.php'),
 (9050, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ClientErrorResponseException.php'),
 (9051, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CouldNotRewindStreamException.php'),
 (9052, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/CurlException.php'),
 (9053, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/HttpException.php'),
 (9054, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/MultiTransferException.php'),
 (9055, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/RequestException.php'),
 (9056, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/ServerErrorResponseException.php'),
 (9057, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Exception/TooManyRedirectsException.php'),
 (9058, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/IoEmittingEntityBody.php'),
 (9059, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/AbstractMessage.php'),
 (9060, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequest.php'),
 (9061, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/EntityEnclosingRequestInterface.php'),
 (9062, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/CacheControl.php'),
 (9063, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderCollection.php'),
 (9064, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactory.php'),
 (9065, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderFactoryInterface.php'),
 (9066, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/HeaderInterface.php'),
 (9067, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header/Link.php'),
 (9068, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Header.php'),
 (9069, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/MessageInterface.php'),
 (9070, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFile.php'),
 (9071, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/PostFileInterface.php'),
 (9072, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Request.php'),
 (9073, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactory.php'),
 (9074, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestFactoryInterface.php'),
 (9075, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/RequestInterface.php'),
 (9076, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Message/Response.php'),
 (9077, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Mimetypes.php'),
 (9078, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/CommaAggregator.php'),
 (9079, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/DuplicateAggregator.php'),
 (9080, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/PhpAggregator.php'),
 (9081, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryAggregator/QueryAggregatorInterface.php'),
 (9082, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/QueryString.php'),
 (9083, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/ReadLimitEntityBody.php'),
 (9084, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/RedirectPlugin.php'),
 (9085, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/StaticClient.php'),
 (9086, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Http/Url.php'),
 (9087, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/Inflector.php'),
 (9088, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/InflectorInterface.php'),
 (9089, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/MemoizingInflector.php'),
 (9090, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Inflection/PreComputedInflector.php'),
 (9091, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/AppendIterator.php'),
 (9092, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/ChunkedIterator.php'),
 (9093, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/FilterIterator.php'),
 (9094, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MapIterator.php'),
 (9095, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Iterator/MethodProxyIterator.php'),
 (9096, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/AbstractLogAdapter.php'),
 (9097, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ArrayLogAdapter.php'),
 (9098, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/ClosureLogAdapter.php'),
 (9099, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/LogAdapterInterface.php'),
 (9100, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MessageFormatter.php'),
 (9101, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/MonologLogAdapter.php'),
 (9102, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/PsrLogAdapter.php'),
 (9103, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf1LogAdapter.php'),
 (9104, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Log/Zf2LogAdapter.php'),
 (9105, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParser.php'),
 (9106, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Cookie/CookieParserInterface.php'),
 (9107, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/AbstractMessageParser.php'),
 (9108, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParser.php'),
 (9109, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/MessageParserInterface.php'),
 (9110, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Message/PeclHttpMessageParser.php'),
 (9111, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/ParserRegistry.php'),
 (9112, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/PeclUriTemplate.php'),
 (9113, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplate.php'),
 (9114, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/UriTemplate/UriTemplateInterface.php'),
 (9115, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParser.php'),
 (9116, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Parser/Url/UrlParserInterface.php'),
 (9117, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Async/AsyncPlugin.php'),
 (9118, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractBackoffStrategy.php'),
 (9119, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/AbstractErrorCodeBackoffStrategy.php'),
 (9120, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffLogger.php'),
 (9121, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffPlugin.php'),
 (9122, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/BackoffStrategyInterface.php'),
 (9123, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CallbackBackoffStrategy.php'),
 (9124, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ConstantBackoffStrategy.php'),
 (9125, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/CurlBackoffStrategy.php'),
 (9126, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ExponentialBackoffStrategy.php'),
 (9127, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/HttpBackoffStrategy.php'),
 (9128, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/LinearBackoffStrategy.php'),
 (9129, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/ReasonPhraseBackoffStrategy.php'),
 (9130, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Backoff/TruncatedBackoffStrategy.php'),
 (9131, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheKeyProviderInterface.php'),
 (9132, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CachePlugin.php'),
 (9133, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CacheStorageInterface.php'),
 (9134, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CallbackCanCacheStrategy.php'),
 (9135, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/CanCacheStrategyInterface.php'),
 (9136, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheKeyProvider.php'),
 (9137, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCacheStorage.php'),
 (9138, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultCanCacheStrategy.php'),
 (9139, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DefaultRevalidation.php'),
 (9140, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/DenyRevalidation.php'),
 (9141, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/RevalidationInterface.php'),
 (9142, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cache/SkipRevalidation.php'),
 (9143, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Cookie.php'),
 (9144, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/ArrayCookieJar.php'),
 (9145, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/CookieJarInterface.php'),
 (9146, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookieJar/FileCookieJar.php'),
 (9147, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/CookiePlugin.php'),
 (9148, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Cookie/Exception/InvalidCookieException.php'),
 (9149, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/CurlAuth/CurlAuthPlugin.php'),
 (9150, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponseExceptionInterface.php'),
 (9151, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/ErrorResponsePlugin.php'),
 (9152, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/ErrorResponse/Exception/ErrorResponseException.php'),
 (9153, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/History/HistoryPlugin.php'),
 (9154, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Log/LogPlugin.php'),
 (9155, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/CommandContentMd5Plugin.php'),
 (9156, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Md5/Md5ValidatorPlugin.php'),
 (9157, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Mock/MockPlugin.php'),
 (9158, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Plugin/Oauth/OauthPlugin.php'),
 (9159, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/AbstractConfigLoader.php'),
 (9160, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilder.php'),
 (9161, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderInterface.php'),
 (9162, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Builder/ServiceBuilderLoader.php'),
 (9163, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/CachingConfigLoader.php'),
 (9164, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Client.php'),
 (9165, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ClientInterface.php'),
 (9166, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/AbstractCommand.php'),
 (9167, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ClosureCommand.php'),
 (9168, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CommandInterface.php'),
 (9169, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/CreateResponseClassEvent.php'),
 (9170, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultRequestSerializer.php'),
 (9171, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/DefaultResponseParser.php'),
 (9172, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/AliasFactory.php'),
 (9173, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/CompositeFactory.php'),
 (9174, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ConcreteClassFactory.php'),
 (9175, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/FactoryInterface.php'),
 (9176, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/MapFactory.php'),
 (9177, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/Factory/ServiceDescriptionFactory.php'),
 (9178, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/AbstractRequestVisitor.php'),
 (9179, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/BodyVisitor.php'),
 (9180, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/HeaderVisitor.php'),
 (9181, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/JsonVisitor.php'),
 (9182, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFieldVisitor.php'),
 (9183, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/PostFileVisitor.php'),
 (9184, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/QueryVisitor.php'),
 (9185, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/RequestVisitorInterface.php'),
 (9186, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/ResponseBodyVisitor.php'),
 (9187, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Request/XmlVisitor.php'),
 (9188, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/AbstractResponseVisitor.php'),
 (9189, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/BodyVisitor.php'),
 (9190, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/HeaderVisitor.php'),
 (9191, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/JsonVisitor.php'),
 (9192, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ReasonPhraseVisitor.php'),
 (9193, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/ResponseVisitorInterface.php'),
 (9194, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/StatusCodeVisitor.php'),
 (9195, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/Response/XmlVisitor.php'),
 (9196, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/LocationVisitor/VisitorFlyweight.php'),
 (9197, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationCommand.php'),
 (9198, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/OperationResponseParser.php'),
 (9199, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/RequestSerializerInterface.php'),
 (9200, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseClassInterface.php'),
 (9201, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Command/ResponseParserInterface.php'),
 (9202, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/ConfigLoaderInterface.php'),
 (9203, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Operation.php'),
 (9204, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/OperationInterface.php'),
 (9205, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/Parameter.php'),
 (9206, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaFormatter.php'),
 (9207, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/SchemaValidator.php'),
 (9208, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescription.php'),
 (9209, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionInterface.php'),
 (9210, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ServiceDescriptionLoader.php'),
 (9211, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Description/ValidatorInterface.php'),
 (9212, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandException.php'),
 (9213, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/CommandTransferException.php'),
 (9214, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/DescriptionBuilderException.php'),
 (9215, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/InconsistentClientTransferException.php'),
 (9216, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ResponseClassException.php'),
 (9217, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceBuilderException.php'),
 (9218, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ServiceNotFoundException.php'),
 (9219, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Exception/ValidationException.php'),
 (9220, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/AbstractResourceIteratorFactory.php'),
 (9221, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/CompositeResourceIteratorFactory.php'),
 (9222, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/MapResourceIteratorFactory.php'),
 (9223, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/Model.php'),
 (9224, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIterator.php'),
 (9225, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorApplyBatched.php'),
 (9226, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorClassFactory.php'),
 (9227, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorFactoryInterface.php'),
 (9228, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Service/Resource/ResourceIteratorInterface.php'),
 (9229, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/PhpStreamRequestFactory.php'),
 (9230, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/Stream.php'),
 (9231, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamInterface.php'),
 (9232, 'wp-content/updraft/plugins-old/updraftplus/vendor/guzzle/guzzle/src/Guzzle/Stream/StreamRequestFactoryInterface.php'),
 (9233, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCache.php'),
 (9234, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollection.php'),
 (9235, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetCollectionInterface.php'),
 (9236, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetInterface.php'),
 (9237, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/AssetReference.php'),
 (9238, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/BaseAsset.php'),
 (9239, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/FileAsset.php'),
 (9240, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/GlobAsset.php'),
 (9241, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/HttpAsset.php'),
 (9242, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionFilterIterator.php'),
 (9243, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/Iterator/AssetCollectionIterator.php'),
 (9244, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Asset/StringAsset.php'),
 (9245, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetManager.php'),
 (9246, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/AssetWriter.php'),
 (9247, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ApcCache.php'),
 (9248, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ArrayCache.php'),
 (9249, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/CacheInterface.php'),
 (9250, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ConfigCache.php'),
 (9251, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/ExpiringCache.php'),
 (9252, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Cache/FilesystemCache.php'),
 (9253, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/Exception.php'),
 (9254, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Exception/FilterException.php'),
 (9255, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticExtension.php'),
 (9256, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterFunction.php'),
 (9257, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterInvoker.php'),
 (9258, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticFilterNode.php'),
 (9259, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticNode.php'),
 (9260, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/AsseticTokenParser.php'),
 (9261, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigFormulaLoader.php'),
 (9262, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/TwigResource.php'),
 (9263, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Extension/Twig/ValueContainer.php'),
 (9264, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/AssetFactory.php'),
 (9265, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/LazyAssetManager.php'),
 (9266, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/BasePhpFormulaLoader.php'),
 (9267, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/CachedFormulaLoader.php'),
 (9268, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FormulaLoaderInterface.php'),
 (9269, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Loader/FunctionCallsFormulaLoader.php'),
 (9270, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/CoalescingDirectoryResource.php'),
 (9271, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/DirectoryResource.php'),
 (9272, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/FileResource.php'),
 (9273, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/IteratorResourceInterface.php'),
 (9274, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Resource/ResourceInterface.php'),
 (9275, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/CacheBustingWorker.php'),
 (9276, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/EnsureFilterWorker.php'),
 (9277, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Factory/Worker/WorkerInterface.php'),
 (9278, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/AutoprefixerFilter.php'),
 (9279, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseCssFilter.php'),
 (9280, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseNodeFilter.php'),
 (9281, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/BaseProcessFilter.php'),
 (9282, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CallablesFilter.php'),
 (9283, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CleanCssFilter.php'),
 (9284, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CoffeeScriptFilter.php'),
 (9285, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CompassFilter.php'),
 (9286, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssCacheBustingFilter.php'),
 (9287, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssEmbedFilter.php'),
 (9288, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssImportFilter.php'),
 (9289, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssMinFilter.php'),
 (9290, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/CssRewriteFilter.php'),
 (9291, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DartFilter.php'),
 (9292, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/DependencyExtractorInterface.php'),
 (9293, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/EmberPrecompileFilter.php'),
 (9294, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterCollection.php'),
 (9295, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/FilterInterface.php'),
 (9296, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/BaseCompilerFilter.php'),
 (9297, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerApiFilter.php'),
 (9298, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GoogleClosure/CompilerJarFilter.php'),
 (9299, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/GssFilter.php'),
 (9300, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HandlebarsFilter.php'),
 (9301, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/HashableInterface.php'),
 (9302, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinFilter.php'),
 (9303, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSMinPlusFilter.php'),
 (9304, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JSqueezeFilter.php'),
 (9305, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegoptimFilter.php'),
 (9306, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/JpegtranFilter.php'),
 (9307, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessFilter.php'),
 (9308, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/LessphpFilter.php'),
 (9309, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/MinifyCssCompressorFilter.php'),
 (9310, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/OptiPngFilter.php'),
 (9311, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackagerFilter.php'),
 (9312, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PackerFilter.php'),
 (9313, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PhpCssEmbedFilter.php'),
 (9314, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/PngoutFilter.php'),
 (9315, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ReactJsxFilter.php'),
 (9316, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/RooleFilter.php'),
 (9317, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/BaseSassFilter.php'),
 (9318, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/SassFilter.php'),
 (9319, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Sass/ScssFilter.php'),
 (9320, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SassphpFilter.php'),
 (9321, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/ScssphpFilter.php'),
 (9322, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SeparatorFilter.php'),
 (9323, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/SprocketsFilter.php'),
 (9324, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/StylusFilter.php'),
 (9325, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/TypeScriptFilter.php'),
 (9326, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyCssFilter.php'),
 (9327, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJs2Filter.php'),
 (9328, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/UglifyJsFilter.php'),
 (9329, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/BaseCompressorFilter.php'),
 (9330, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/CssCompressorFilter.php'),
 (9331, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Filter/Yui/JsCompressorFilter.php'),
 (9332, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/FilterManager.php'),
 (9333, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/CssUtils.php'),
 (9334, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/FilesystemUtils.php'),
 (9335, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/LessUtils.php'),
 (9336, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/SassUtils.php'),
 (9337, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/TraversableString.php'),
 (9338, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/Util/VarUtils.php'),
 (9339, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/Assetic/ValueSupplierInterface.php'),
 (9340, 'wp-content/updraft/plugins-old/updraftplus/vendor/kriswallsmith/assetic/src/functions.php'),
 (9341, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/AES.php'),
 (9342, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Base.php'),
 (9343, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Blowfish.php'),
 (9344, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/DES.php'),
 (9345, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Hash.php'),
 (9346, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC2.php'),
 (9347, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RC4.php'),
 (9348, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/RSA.php'),
 (9349, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Random.php'),
 (9350, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Rijndael.php'),
 (9351, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/TripleDES.php'),
 (9352, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Crypt/Twofish.php'),
 (9353, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ANSI.php'),
 (9354, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/ASN1.php'),
 (9355, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/File/X509.php'),
 (9356, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Math/BigInteger.php'),
 (9357, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SCP.php'),
 (9358, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP/Stream.php'),
 (9359, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SFTP.php'),
 (9360, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH1.php'),
 (9361, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/Net/SSH2.php'),
 (9362, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH/Agent.php'),
 (9363, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/System/SSH_Agent.php'),
 (9364, 'wp-content/updraft/plugins-old/updraftplus/vendor/phpseclib/phpseclib/phpseclib/bootstrap.php'),
 (9365, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/AbstractLogger.php'),
 (9366, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/InvalidArgumentException.php'),
 (9367, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LogLevel.php'),
 (9368, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareInterface.php'),
 (9369, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerAwareTrait.php'),
 (9370, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerInterface.php'),
 (9371, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/LoggerTrait.php'),
 (9372, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/NullLogger.php'),
 (9373, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/Test/LoggerInterfaceTest.php'),
 (9374, 'wp-content/updraft/plugins-old/updraftplus/vendor/psr/log/Psr/Log/Test/TestLogger.php'),
 (9375, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/ArrayAccess.php'),
 (9376, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Base.php'),
 (9377, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ArrayCollection.php'),
 (9378, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/PaginatedIterator.php'),
 (9379, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection/ResourceIterator.php'),
 (9380, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Collection.php'),
 (9381, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Datetime.php'),
 (9382, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Header.php'),
 (9383, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Mime.php'),
 (9384, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Service.php'),
 (9385, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/Size.php'),
 (9386, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Constants/State.php'),
 (9387, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncError.php'),
 (9388, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncHttpError.php'),
 (9389, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AsyncTimeoutError.php'),
 (9390, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AttributeError.php'),
 (9391, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/AuthenticationError.php'),
 (9392, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/BaseException.php'),
 (9393, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnError.php'),
 (9394, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnHttpError.php'),
 (9395, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnNotAvailableError.php'),
 (9396, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CdnTtlError.php'),
 (9397, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CollectionException.php'),
 (9398, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerCreateError.php'),
 (9399, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerDeleteError.php'),
 (9400, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerError.php'),
 (9401, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNameError.php'),
 (9402, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotEmptyError.php'),
 (9403, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ContainerNotFoundError.php'),
 (9404, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateError.php'),
 (9405, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CreateUpdateError.php'),
 (9406, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/CredentialError.php'),
 (9407, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseCreateError.php'),
 (9408, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseDeleteError.php'),
 (9409, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseListError.php'),
 (9410, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseNameError.php'),
 (9411, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DatabaseUpdateError.php'),
 (9412, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DeleteError.php'),
 (9413, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DocumentError.php'),
 (9414, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/DomainError.php'),
 (9415, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EmptyResponseError.php'),
 (9416, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/EndpointError.php'),
 (9417, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/FlavorError.php'),
 (9418, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ForbiddenOperationException.php'),
 (9419, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpError.php'),
 (9420, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpForbiddenError.php'),
 (9421, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpOverLimitError.php'),
 (9422, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpResponseException.php'),
 (9423, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpRetryError.php'),
 (9424, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpTimeoutError.php'),
 (9425, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUnauthorizedError.php'),
 (9426, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/HttpUrlError.php'),
 (9427, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IOError.php'),
 (9428, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/IdRequiredError.php'),
 (9429, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ImageError.php'),
 (9430, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceCreateError.php'),
 (9431, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceDeleteError.php'),
 (9432, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceError.php'),
 (9433, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceFlavorError.php'),
 (9434, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceNotFound.php'),
 (9435, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InstanceUpdateError.php'),
 (9436, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidArgumentError.php'),
 (9437, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIdTypeError.php'),
 (9438, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidIpTypeError.php'),
 (9439, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidParameterError.php'),
 (9440, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidRequestError.php'),
 (9441, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/InvalidTemplateError.php'),
 (9442, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/JsonError.php'),
 (9443, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/LoggingException.php'),
 (9444, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataCreateError.php'),
 (9445, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataDeleteError.php'),
 (9446, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataError.php'),
 (9447, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataJsonError.php'),
 (9448, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataKeyError.php'),
 (9449, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataPrefixError.php'),
 (9450, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MetadataUpdateError.php'),
 (9451, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MisMatchedChecksumError.php'),
 (9452, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/MissingValueError.php'),
 (9453, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NameError.php'),
 (9454, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkCreateError.php'),
 (9455, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkDeleteError.php'),
 (9456, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkError.php'),
 (9457, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUpdateError.php'),
 (9458, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NetworkUrlError.php'),
 (9459, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoContentTypeError.php'),
 (9460, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/NoNameError.php'),
 (9461, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjFetchError.php'),
 (9462, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectCopyError.php'),
 (9463, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ObjectError.php'),
 (9464, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RebuildError.php'),
 (9465, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RecordTypeError.php'),
 (9466, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceBucketException.php'),
 (9467, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ResourceNotFoundException.php'),
 (9468, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/RuntimeException.php'),
 (9469, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerActionError.php'),
 (9470, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerCreateError.php'),
 (9471, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerDeleteError.php'),
 (9472, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerImageScheduleError.php'),
 (9473, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerIpsError.php'),
 (9474, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerJsonError.php'),
 (9475, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUpdateError.php'),
 (9476, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServerUrlError.php'),
 (9477, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/ServiceException.php'),
 (9478, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/SnapshotError.php'),
 (9479, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/TempUrlMethodError.php'),
 (9480, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownError.php'),
 (9481, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnknownParameterError.php'),
 (9482, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnrecognizedServiceError.php'),
 (9483, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedExtensionError.php'),
 (9484, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedFeatureExtension.php'),
 (9485, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UnsupportedVersionError.php'),
 (9486, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UpdateError.php'),
 (9487, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UrlError.php'),
 (9488, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserCreateError.php'),
 (9489, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserDeleteError.php'),
 (9490, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserListError.php'),
 (9491, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserNameError.php'),
 (9492, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/UserUpdateError.php'),
 (9493, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeError.php'),
 (9494, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Exceptions/VolumeTypeError.php'),
 (9495, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Client.php'),
 (9496, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/Formatter.php'),
 (9497, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Http/Message/RequestSubscriber.php'),
 (9498, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Lang.php'),
 (9499, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Log/Logger.php'),
 (9500, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Metadata.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(9501, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/PersistentObject.php'),
 (9502, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/BaseResource.php'),
 (9503, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/NovaResource.php'),
 (9504, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/PersistentResource.php'),
 (9505, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Resource/ReadOnlyResource.php'),
 (9506, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/AbstractService.php'),
 (9507, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Catalog.php'),
 (9508, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogItem.php'),
 (9509, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/CatalogService.php'),
 (9510, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/Endpoint.php'),
 (9511, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/NovaService.php'),
 (9512, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceBuilder.php'),
 (9513, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Common/Service/ServiceInterface.php'),
 (9514, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Constants/User.php'),
 (9515, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Role.php'),
 (9516, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Tenant.php'),
 (9517, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/Token.php'),
 (9518, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Resource/User.php'),
 (9519, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Identity/Service.php'),
 (9520, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/AbstractService.php'),
 (9521, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/CDNService.php'),
 (9522, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/Header.php'),
 (9523, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Constants/UrlType.php'),
 (9524, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Enum/ReturnType.php'),
 (9525, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/BulkOperationException.php'),
 (9526, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ContainerException.php'),
 (9527, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/ObjectNotFoundException.php'),
 (9528, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/StreamException.php'),
 (9529, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Exception/UploadException.php'),
 (9530, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractContainer.php'),
 (9531, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/AbstractResource.php'),
 (9532, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Account.php'),
 (9533, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/CDNContainer.php'),
 (9534, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/Container.php'),
 (9535, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/ContainerMetadata.php'),
 (9536, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Resource/DataObject.php'),
 (9537, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Service.php'),
 (9538, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/AbstractTransfer.php'),
 (9539, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConcurrentTransfer.php'),
 (9540, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ConsecutiveTransfer.php'),
 (9541, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/ContainerMigration.php'),
 (9542, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/DirectorySync.php'),
 (9543, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferBuilder.php'),
 (9544, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferPart.php'),
 (9545, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/ObjectStore/Upload/TransferState.php'),
 (9546, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/OpenStack.php'),
 (9547, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Rackspace.php'),
 (9548, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/OpenCloud/Version.php'),
 (9549, 'wp-content/updraft/plugins-old/updraftplus/vendor/rackspace/php-opencloud/lib/php-opencloud.php'),
 (9550, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/ContainerAwareEventDispatcher.php'),
 (9551, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcher.php'),
 (9552, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Debug/TraceableEventDispatcherInterface.php'),
 (9553, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Debug/WrappedListener.php'),
 (9554, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/DependencyInjection/RegisterListenersPass.php'),
 (9555, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/Event.php'),
 (9556, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/EventDispatcher.php'),
 (9557, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/EventDispatcherInterface.php'),
 (9558, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/EventSubscriberInterface.php'),
 (9559, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/GenericEvent.php'),
 (9560, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/event-dispatcher/ImmutableEventDispatcher.php'),
 (9561, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/ExceptionInterface.php'),
 (9562, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/InvalidArgumentException.php'),
 (9563, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/LogicException.php'),
 (9564, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/ProcessFailedException.php'),
 (9565, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/ProcessTimedOutException.php'),
 (9566, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Exception/RuntimeException.php'),
 (9567, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/ExecutableFinder.php'),
 (9568, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/InputStream.php'),
 (9569, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/PhpExecutableFinder.php'),
 (9570, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/PhpProcess.php'),
 (9571, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/AbstractPipes.php'),
 (9572, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/PipesInterface.php'),
 (9573, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/UnixPipes.php'),
 (9574, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Pipes/WindowsPipes.php'),
 (9575, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/Process.php'),
 (9576, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/ProcessBuilder.php'),
 (9577, 'wp-content/updraft/plugins-old/updraftplus/vendor/symfony/process/ProcessUtils.php'),
 (9578, 'wp-content/updraft/plugins-old/woo-lucky-wheel/admin/admin.php'),
 (9579, 'wp-content/updraft/plugins-old/woo-lucky-wheel/admin/mailchimp.php'),
 (9580, 'wp-content/updraft/plugins-old/woo-lucky-wheel/fonts/semantic/icons.svg'),
 (9581, 'wp-content/updraft/plugins-old/woo-lucky-wheel/fonts/woocommerce-lucky-wheel.svg'),
 (9582, 'wp-content/updraft/plugins-old/woo-lucky-wheel/frontend/frontend.php'),
 (9583, 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/data.php'),
 (9584, 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/functions.php'),
 (9585, 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/includes.php'),
 (9586, 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/mobile_detect.php'),
 (9587, 'wp-content/updraft/plugins-old/woo-lucky-wheel/includes/support.php'),
 (9588, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/admin-javascript.js'),
 (9589, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/checkbox.js'),
 (9590, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/dropdown.min.js'),
 (9591, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/form.js'),
 (9592, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/jquery.address-1.6.min.js'),
 (9593, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/jquery.fontselect.min.js'),
 (9594, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/select2.js'),
 (9595, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/tab.js'),
 (9596, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/transition.min.js'),
 (9597, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/woocommerce-lucky-wheel-mobile.js'),
 (9598, 'wp-content/updraft/plugins-old/woo-lucky-wheel/js/woocommerce-lucky-wheel.js'),
 (9599, 'wp-content/updraft/plugins-old/woo-lucky-wheel/woo-lucky-wheel.php'),
 (9600, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/admin.js'),
 (9601, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/admin.min.js'),
 (9602, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/bluebird.js'),
 (9603, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/bluebird.min.js'),
 (9604, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/divi_woo_layout_injector.js'),
 (9605, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/divi_woo_layout_injector.min.js'),
 (9606, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/form-field-dependency.js'),
 (9607, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/form-field-dependency.min.js'),
 (9608, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/frontend.js'),
 (9609, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/frontend.min.js'),
 (9610, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-admin.js'),
 (9611, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-admin.min.js'),
 (9612, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-backbone-modal.js'),
 (9613, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/gwp-backbone-modal.min.js'),
 (9614, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wp-color-picker-alpha.js'),
 (9615, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wp-color-picker-alpha.min.js'),
 (9616, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wvs-customize-alpha-color-control.js'),
 (9617, 'wp-content/updraft/plugins-old/woo-variation-swatches/assets/js/wvs-customize-alpha-color-control.min.js'),
 (9618, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-woo-variation-swatches-export-import.php'),
 (9619, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-customize-alpha-color-control.php'),
 (9620, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-customize-heading.php'),
 (9621, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-customizer.php'),
 (9622, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-settings-api.php'),
 (9623, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/class-wvs-term-meta.php'),
 (9624, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/deactive-feedback-dialog.php'),
 (9625, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/functions.php'),
 (9626, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/hooks.php'),
 (9627, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/stylesheet.php'),
 (9628, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/themes-support.php'),
 (9629, 'wp-content/updraft/plugins-old/woo-variation-swatches/includes/tutorials.php'),
 (9630, 'wp-content/updraft/plugins-old/woo-variation-swatches/uninstall.php'),
 (9631, 'wp-content/updraft/plugins-old/woo-variation-swatches/webpack.mix.js'),
 (9632, 'wp-content/updraft/plugins-old/woo-variation-swatches/woo-variation-swatches.php'),
 (9633, 'wp-content/updraft/plugins-old/woocommerce/assets/css/photoswipe/default-skin/default-skin.svg'),
 (9634, 'wp-content/updraft/plugins-old/woocommerce/assets/fonts/WooCommerce.svg'),
 (9635, 'wp-content/updraft/plugins-old/woocommerce/assets/fonts/star.svg'),
 (9636, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/amex.svg'),
 (9637, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/diners.svg'),
 (9638, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/discover.svg'),
 (9639, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/jcb.svg'),
 (9640, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/laser.svg'),
 (9641, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/maestro.svg'),
 (9642, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/mastercard.svg'),
 (9643, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/credit-cards/visa.svg'),
 (9644, 'wp-content/updraft/plugins-old/woocommerce/assets/images/icons/loader.svg'),
 (9645, 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-facebook-icon.svg'),
 (9646, 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-mailchimp-icon.svg'),
 (9647, 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-storefront-icon.svg'),
 (9648, 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-taxes-icon.svg'),
 (9649, 'wp-content/updraft/plugins-old/woocommerce/assets/images/obw-woocommerce-admin-icon.svg'),
 (9650, 'wp-content/updraft/plugins-old/woocommerce/assets/images/woocommerce_logo.svg'),
 (9651, 'wp-content/updraft/plugins-old/woocommerce/assets/js/accounting/accounting.js'),
 (9652, 'wp-content/updraft/plugins-old/woocommerce/assets/js/accounting/accounting.min.js'),
 (9653, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/api-keys.js'),
 (9654, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/api-keys.min.js'),
 (9655, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/backbone-modal.js'),
 (9656, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/backbone-modal.min.js'),
 (9657, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/marketplace-suggestions.js'),
 (9658, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/marketplace-suggestions.min.js'),
 (9659, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-coupon.js'),
 (9660, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-coupon.min.js'),
 (9661, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-order.js'),
 (9662, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-order.min.js'),
 (9663, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product-variation.js'),
 (9664, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product-variation.min.js'),
 (9665, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product.js'),
 (9666, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes-product.min.js'),
 (9667, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes.js'),
 (9668, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/meta-boxes.min.js'),
 (9669, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/network-orders.js'),
 (9670, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/network-orders.min.js'),
 (9671, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/product-ordering.js'),
 (9672, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/product-ordering.min.js'),
 (9673, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/quick-edit.js'),
 (9674, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/quick-edit.min.js'),
 (9675, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/reports.js'),
 (9676, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/reports.min.js'),
 (9677, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings-views-html-settings-tax.js'),
 (9678, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings-views-html-settings-tax.min.js'),
 (9679, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings.js'),
 (9680, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/settings.min.js'),
 (9681, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/system-status.js'),
 (9682, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/system-status.min.js'),
 (9683, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/term-ordering.js'),
 (9684, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/term-ordering.min.js'),
 (9685, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/users.js'),
 (9686, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/users.min.js'),
 (9687, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-clipboard.js'),
 (9688, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-clipboard.min.js'),
 (9689, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-enhanced-select.js'),
 (9690, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-enhanced-select.min.js'),
 (9691, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-orders.js'),
 (9692, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-orders.min.js'),
 (9693, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-export.js'),
 (9694, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-export.min.js'),
 (9695, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-import.js'),
 (9696, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-product-import.min.js'),
 (9697, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-setup.js'),
 (9698, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-setup.min.js'),
 (9699, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-classes.js'),
 (9700, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-classes.min.js'),
 (9701, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zone-methods.js'),
 (9702, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zone-methods.min.js'),
 (9703, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zones.js'),
 (9704, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/wc-shipping-zones.min.js'),
 (9705, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/woocommerce_admin.js'),
 (9706, 'wp-content/updraft/plugins-old/woocommerce/assets/js/admin/woocommerce_admin.min.js'),
 (9707, 'wp-content/updraft/plugins-old/woocommerce/assets/js/flexslider/jquery.flexslider.js'),
 (9708, 'wp-content/updraft/plugins-old/woocommerce/assets/js/flexslider/jquery.flexslider.min.js'),
 (9709, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-payment-method.js'),
 (9710, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-payment-method.min.js'),
 (9711, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart-variation.js'),
 (9712, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart-variation.min.js'),
 (9713, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart.js'),
 (9714, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/add-to-cart.min.js'),
 (9715, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/address-i18n.js'),
 (9716, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/address-i18n.min.js'),
 (9717, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart-fragments.js'),
 (9718, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart-fragments.min.js'),
 (9719, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart.js'),
 (9720, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/cart.min.js'),
 (9721, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/checkout.js'),
 (9722, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/checkout.min.js'),
 (9723, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/country-select.js'),
 (9724, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/country-select.min.js'),
 (9725, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/credit-card-form.js'),
 (9726, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/credit-card-form.min.js'),
 (9727, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/geolocation.js'),
 (9728, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/geolocation.min.js'),
 (9729, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/lost-password.js'),
 (9730, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/lost-password.min.js'),
 (9731, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/password-strength-meter.js'),
 (9732, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/password-strength-meter.min.js'),
 (9733, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/price-slider.js'),
 (9734, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/price-slider.min.js'),
 (9735, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/single-product.js'),
 (9736, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/single-product.min.js'),
 (9737, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/tokenization-form.js'),
 (9738, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/tokenization-form.min.js'),
 (9739, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/woocommerce.js'),
 (9740, 'wp-content/updraft/plugins-old/woocommerce/assets/js/frontend/woocommerce.min.js'),
 (9741, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-blockui/jquery.blockUI.js'),
 (9742, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-blockui/jquery.blockUI.min.js'),
 (9743, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-cookie/jquery.cookie.js'),
 (9744, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-cookie/jquery.cookie.min.js'),
 (9745, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.js'),
 (9746, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.min.js'),
 (9747, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.pie.js'),
 (9748, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.pie.min.js'),
 (9749, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.resize.js'),
 (9750, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.resize.min.js'),
 (9751, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.stack.js'),
 (9752, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.stack.min.js'),
 (9753, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.time.js'),
 (9754, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-flot/jquery.flot.time.min.js'),
 (9755, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-payment/jquery.payment.js'),
 (9756, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-payment/jquery.payment.min.js'),
 (9757, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-qrcode/jquery.qrcode.js'),
 (9758, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-qrcode/jquery.qrcode.min.js'),
 (9759, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-serializejson/jquery.serializejson.js'),
 (9760, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-serializejson/jquery.serializejson.min.js'),
 (9761, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-tiptip/jquery.tipTip.js'),
 (9762, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-tiptip/jquery.tipTip.min.js'),
 (9763, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-ui-touch-punch/jquery-ui-touch-punch.js'),
 (9764, 'wp-content/updraft/plugins-old/woocommerce/assets/js/jquery-ui-touch-punch/jquery-ui-touch-punch.min.js'),
 (9765, 'wp-content/updraft/plugins-old/woocommerce/assets/js/js-cookie/js.cookie.js'),
 (9766, 'wp-content/updraft/plugins-old/woocommerce/assets/js/js-cookie/js.cookie.min.js'),
 (9767, 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe-ui-default.js'),
 (9768, 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe-ui-default.min.js'),
 (9769, 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe.js'),
 (9770, 'wp-content/updraft/plugins-old/woocommerce/assets/js/photoswipe/photoswipe.min.js'),
 (9771, 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.init.js'),
 (9772, 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.init.min.js'),
 (9773, 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.js'),
 (9774, 'wp-content/updraft/plugins-old/woocommerce/assets/js/prettyPhoto/jquery.prettyPhoto.min.js'),
 (9775, 'wp-content/updraft/plugins-old/woocommerce/assets/js/round/round.js'),
 (9776, 'wp-content/updraft/plugins-old/woocommerce/assets/js/round/round.min.js'),
 (9777, 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.full.js'),
 (9778, 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.full.min.js'),
 (9779, 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.js'),
 (9780, 'wp-content/updraft/plugins-old/woocommerce/assets/js/select2/select2.min.js'),
 (9781, 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.full.js'),
 (9782, 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.full.min.js'),
 (9783, 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.js'),
 (9784, 'wp-content/updraft/plugins-old/woocommerce/assets/js/selectWoo/selectWoo.min.js'),
 (9785, 'wp-content/updraft/plugins-old/woocommerce/assets/js/stupidtable/stupidtable.js'),
 (9786, 'wp-content/updraft/plugins-old/woocommerce/assets/js/stupidtable/stupidtable.min.js'),
 (9787, 'wp-content/updraft/plugins-old/woocommerce/assets/js/zeroclipboard/jquery.zeroclipboard.js'),
 (9788, 'wp-content/updraft/plugins-old/woocommerce/assets/js/zeroclipboard/jquery.zeroclipboard.min.js'),
 (9789, 'wp-content/updraft/plugins-old/woocommerce/assets/js/zoom/jquery.zoom.js'),
 (9790, 'wp-content/updraft/plugins-old/woocommerce/assets/js/zoom/jquery.zoom.min.js'),
 (9791, 'wp-content/updraft/plugins-old/woocommerce/i18n/continents.php'),
 (9792, 'wp-content/updraft/plugins-old/woocommerce/i18n/countries.php'),
 (9793, 'wp-content/updraft/plugins-old/woocommerce/i18n/locale-info.php'),
 (9794, 'wp-content/updraft/plugins-old/woocommerce/i18n/phone.php'),
 (9795, 'wp-content/updraft/plugins-old/woocommerce/i18n/states.php'),
 (9796, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-data.php'),
 (9797, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-deprecated-hooks.php'),
 (9798, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-integration.php'),
 (9799, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-log-handler.php'),
 (9800, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-object-query.php'),
 (9801, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-order.php'),
 (9802, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-payment-gateway.php'),
 (9803, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-payment-token.php'),
 (9804, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-privacy.php'),
 (9805, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-product.php'),
 (9806, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-session.php'),
 (9807, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-settings-api.php'),
 (9808, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-shipping-method.php'),
 (9809, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/abstract-wc-widget.php'),
 (9810, 'wp-content/updraft/plugins-old/woocommerce/includes/abstracts/class-wc-background-process.php'),
 (9811, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-addons.php'),
 (9812, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-api-keys-table-list.php'),
 (9813, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-api-keys.php'),
 (9814, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-assets.php'),
 (9815, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-attributes.php'),
 (9816, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-customize.php'),
 (9817, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-dashboard.php'),
 (9818, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-duplicate-product.php'),
 (9819, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-exporters.php'),
 (9820, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-help.php'),
 (9821, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-importers.php'),
 (9822, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-log-table-list.php'),
 (9823, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-menus.php'),
 (9824, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-meta-boxes.php'),
 (9825, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-notices.php'),
 (9826, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-permalink-settings.php'),
 (9827, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-pointers.php'),
 (9828, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-post-types.php'),
 (9829, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-profile.php'),
 (9830, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-reports.php'),
 (9831, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-settings.php'),
 (9832, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-setup-wizard.php'),
 (9833, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-status.php'),
 (9834, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-taxonomies.php'),
 (9835, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-webhooks-table-list.php'),
 (9836, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin-webhooks.php'),
 (9837, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/class-wc-admin.php'),
 (9838, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-api.php'),
 (9839, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-compat.php'),
 (9840, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-options.php'),
 (9841, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-plugin-info.php'),
 (9842, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper-updater.php'),
 (9843, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/class-wc-helper.php'),
 (9844, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-helper-compat.php'),
 (9845, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-main.php'),
 (9846, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-oauth-start.php'),
 (9847, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-section-account.php'),
 (9848, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-section-nav.php'),
 (9849, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/helper/views/html-section-notices.php'),
 (9850, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/class-wc-product-csv-importer-controller.php'),
 (9851, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/class-wc-tax-rate-importer.php'),
 (9852, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/default.php'),
 (9853, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/generic.php'),
 (9854, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/mappings.php'),
 (9855, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/shopify.php'),
 (9856, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/mappings/wordpress.php'),
 (9857, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-done.php'),
 (9858, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-footer.php'),
 (9859, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-header.php'),
 (9860, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-mapping.php'),
 (9861, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-progress.php'),
 (9862, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-csv-import-steps.php'),
 (9863, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/importers/views/html-product-csv-import-form.php'),
 (9864, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/abstract-class-wc-admin-list-table.php'),
 (9865, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/class-wc-admin-list-table-coupons.php'),
 (9866, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/class-wc-admin-list-table-orders.php'),
 (9867, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/list-tables/class-wc-admin-list-table-products.php'),
 (9868, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/class-wc-marketplace-suggestions.php'),
 (9869, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/class-wc-marketplace-updater.php'),
 (9870, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/templates/html-product-data-extensions.php'),
 (9871, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/marketplace-suggestions/views/container.php'),
 (9872, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-coupon-data.php'),
 (9873, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-actions.php'),
 (9874, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-data.php'),
 (9875, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-downloads.php'),
 (9876, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-items.php'),
 (9877, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-order-notes.php'),
 (9878, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-data.php'),
 (9879, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-images.php'),
 (9880, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-reviews.php'),
 (9881, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/class-wc-meta-box-product-short-description.php'),
 (9882, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-download-permission.php'),
 (9883, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-fee.php'),
 (9884, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-item-meta.php'),
 (9885, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-item.php'),
 (9886, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-items.php'),
 (9887, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-notes.php'),
 (9888, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-refund.php'),
 (9889, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-order-shipping.php'),
 (9890, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-attribute.php'),
 (9891, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-advanced.php'),
 (9892, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-attributes.php'),
 (9893, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-general.php'),
 (9894, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-inventory.php'),
 (9895, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-linked-products.php'),
 (9896, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-panel.php'),
 (9897, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-shipping.php'),
 (9898, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-data-variations.php'),
 (9899, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-download.php'),
 (9900, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-product-variation-download.php'),
 (9901, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/meta-boxes/views/html-variation-admin.php'),
 (9902, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/notes/class-wc-notes-run-db-update.php'),
 (9903, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/class-wc-plugin-updates.php'),
 (9904, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/class-wc-plugins-screen-updates.php'),
 (9905, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/class-wc-updates-screen-updates.php'),
 (9906, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/views/html-notice-untested-extensions-inline.php'),
 (9907, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/plugin-updates/views/html-notice-untested-extensions-modal.php'),
 (9908, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-admin-report.php'),
 (9909, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-coupon-usage.php'),
 (9910, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-customer-list.php'),
 (9911, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-customers.php'),
 (9912, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-downloads.php'),
 (9913, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-low-in-stock.php'),
 (9914, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-most-stocked.php'),
 (9915, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-out-of-stock.php'),
 (9916, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-sales-by-category.php'),
 (9917, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-sales-by-date.php'),
 (9918, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-sales-by-product.php'),
 (9919, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-stock.php'),
 (9920, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-taxes-by-code.php'),
 (9921, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/reports/class-wc-report-taxes-by-date.php'),
 (9922, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-accounts.php'),
 (9923, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-advanced.php'),
 (9924, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-checkout.php'),
 (9925, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-emails.php'),
 (9926, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-general.php'),
 (9927, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-integrations.php'),
 (9928, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-page.php'),
 (9929, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-payment-gateways.php'),
 (9930, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-products.php'),
 (9931, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-shipping.php'),
 (9932, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/class-wc-settings-tax.php'),
 (9933, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/class-wc-settings-rest-api.php'),
 (9934, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-classes.php'),
 (9935, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-zone-methods.php'),
 (9936, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-zones-instance.php'),
 (9937, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-admin-page-shipping-zones.php'),
 (9938, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-keys-edit.php'),
 (9939, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-settings-tax.php'),
 (9940, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/html-webhooks-edit.php'),
 (9941, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/settings/views/settings-tax.php'),
 (9942, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-addons.php'),
 (9943, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-product-export.php'),
 (9944, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-reports.php'),
 (9945, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-logs-db.php'),
 (9946, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-logs.php'),
 (9947, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-report.php'),
 (9948, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status-tools.php'),
 (9949, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-page-status.php'),
 (9950, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-admin-settings.php'),
 (9951, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-bulk-edit-product.php'),
 (9952, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-email-template-preview.php'),
 (9953, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-custom.php'),
 (9954, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-install.php'),
 (9955, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-legacy-shipping.php'),
 (9956, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-maxmind-license-key.php'),
 (9957, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-no-shipping-methods.php'),
 (9958, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-redirect-only-download.php'),
 (9959, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-regenerating-lookup-table.php'),
 (9960, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-regenerating-thumbnails.php'),
 (9961, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-secure-connection.php'),
 (9962, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-template-check.php'),
 (9963, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-update.php'),
 (9964, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-updated.php'),
 (9965, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-updating.php'),
 (9966, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-notice-wp-php-minimum-requirements.php'),
 (9967, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-quick-edit-product.php'),
 (9968, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/views/html-report-by-date.php'),
 (9969, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/wc-admin-functions.php'),
 (9970, 'wp-content/updraft/plugins-old/woocommerce/includes/admin/wc-meta-box-functions.php'),
 (9971, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-ajax.php'),
 (9972, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-api.php'),
 (9973, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-auth.php'),
 (9974, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-autoloader.php'),
 (9975, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-background-emailer.php'),
 (9976, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-background-updater.php'),
 (9977, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-breadcrumb.php'),
 (9978, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cache-helper.php'),
 (9979, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart-fees.php'),
 (9980, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart-session.php'),
 (9981, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart-totals.php'),
 (9982, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cart.php'),
 (9983, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-checkout.php'),
 (9984, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-cli.php'),
 (9985, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-comments.php'),
 (9986, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-countries.php'),
 (9987, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-coupon.php'),
 (9988, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-customer-download-log.php'),
 (9989, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-customer-download.php'),
 (9990, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-customer.php'),
 (9991, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-data-exception.php'),
 (9992, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-data-store.php'),
 (9993, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-datetime.php'),
 (9994, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-deprecated-action-hooks.php'),
 (9995, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-deprecated-filter-hooks.php'),
 (9996, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-discounts.php'),
 (9997, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-download-handler.php'),
 (9998, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-emails.php'),
 (9999, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-embed.php'),
 (10000, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-form-handler.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(10001, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-frontend-scripts.php'),
 (10002, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-geo-ip.php'),
 (10003, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-geolite-integration.php'),
 (10004, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-geolocation.php'),
 (10005, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-https.php'),
 (10006, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-install.php'),
 (10007, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-integrations.php'),
 (10008, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-log-levels.php'),
 (10009, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-logger.php'),
 (10010, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-meta-data.php'),
 (10011, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-factory.php'),
 (10012, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-coupon.php'),
 (10013, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-fee.php'),
 (10014, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-meta.php'),
 (10015, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-product.php'),
 (10016, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-shipping.php'),
 (10017, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item-tax.php'),
 (10018, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-item.php'),
 (10019, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-query.php'),
 (10020, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order-refund.php'),
 (10021, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-order.php'),
 (10022, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-payment-gateways.php'),
 (10023, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-payment-tokens.php'),
 (10024, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-post-data.php'),
 (10025, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-post-types.php'),
 (10026, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy-background-process.php'),
 (10027, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy-erasers.php'),
 (10028, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy-exporters.php'),
 (10029, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-privacy.php'),
 (10030, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-attribute.php'),
 (10031, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-download.php'),
 (10032, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-external.php'),
 (10033, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-factory.php'),
 (10034, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-grouped.php'),
 (10035, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-query.php'),
 (10036, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-simple.php'),
 (10037, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-variable.php'),
 (10038, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-product-variation.php'),
 (10039, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-query.php'),
 (10040, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-rate-limiter.php'),
 (10041, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-regenerate-images-request.php'),
 (10042, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-regenerate-images.php'),
 (10043, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-register-wp-admin-settings.php'),
 (10044, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-rest-authentication.php'),
 (10045, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-rest-exception.php'),
 (10046, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-session-handler.php'),
 (10047, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping-rate.php'),
 (10048, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping-zone.php'),
 (10049, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping-zones.php'),
 (10050, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shipping.php'),
 (10051, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-shortcodes.php'),
 (10052, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-structured-data.php'),
 (10053, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-tax.php'),
 (10054, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-template-loader.php'),
 (10055, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-tracker.php'),
 (10056, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-validation.php'),
 (10057, 'wp-content/updraft/plugins-old/woocommerce/includes/class-wc-webhook.php'),
 (10058, 'wp-content/updraft/plugins-old/woocommerce/includes/class-woocommerce.php'),
 (10059, 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-rest-command.php'),
 (10060, 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-runner.php'),
 (10061, 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-tool-command.php'),
 (10062, 'wp-content/updraft/plugins-old/woocommerce/includes/cli/class-wc-cli-update-command.php'),
 (10063, 'wp-content/updraft/plugins-old/woocommerce/includes/customizer/class-wc-customizer-control-cropping.php'),
 (10064, 'wp-content/updraft/plugins-old/woocommerce/includes/customizer/class-wc-shop-customizer.php'),
 (10065, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/abstract-wc-order-data-store-cpt.php'),
 (10066, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/abstract-wc-order-item-type-data-store.php'),
 (10067, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-coupon-data-store-cpt.php'),
 (10068, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-data-store-session.php'),
 (10069, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-data-store.php'),
 (10070, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-download-data-store.php'),
 (10071, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-customer-download-log-data-store.php'),
 (10072, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-data-store-wp.php'),
 (10073, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-data-store-cpt.php'),
 (10074, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-coupon-data-store.php'),
 (10075, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-data-store.php'),
 (10076, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-fee-data-store.php'),
 (10077, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-product-data-store.php'),
 (10078, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-shipping-data-store.php'),
 (10079, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-item-tax-data-store.php'),
 (10080, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-order-refund-data-store-cpt.php'),
 (10081, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-payment-token-data-store.php'),
 (10082, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-data-store-cpt.php'),
 (10083, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-grouped-data-store-cpt.php'),
 (10084, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-variable-data-store-cpt.php'),
 (10085, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-product-variation-data-store-cpt.php'),
 (10086, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-shipping-zone-data-store.php'),
 (10087, 'wp-content/updraft/plugins-old/woocommerce/includes/data-stores/class-wc-webhook-data-store.php'),
 (10088, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-cancelled-order.php'),
 (10089, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-completed-order.php'),
 (10090, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-invoice.php'),
 (10091, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-new-account.php'),
 (10092, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-note.php'),
 (10093, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-on-hold-order.php'),
 (10094, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-processing-order.php'),
 (10095, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-refunded-order.php'),
 (10096, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-customer-reset-password.php'),
 (10097, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-failed-order.php'),
 (10098, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email-new-order.php'),
 (10099, 'wp-content/updraft/plugins-old/woocommerce/includes/emails/class-wc-email.php'),
 (10100, 'wp-content/updraft/plugins-old/woocommerce/includes/export/abstract-wc-csv-batch-exporter.php'),
 (10101, 'wp-content/updraft/plugins-old/woocommerce/includes/export/abstract-wc-csv-exporter.php'),
 (10102, 'wp-content/updraft/plugins-old/woocommerce/includes/export/class-wc-product-csv-exporter.php'),
 (10103, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/bacs/class-wc-gateway-bacs.php'),
 (10104, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/cheque/class-wc-gateway-cheque.php'),
 (10105, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/class-wc-payment-gateway-cc.php'),
 (10106, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/class-wc-payment-gateway-echeck.php'),
 (10107, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/cod/class-wc-gateway-cod.php'),
 (10108, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/assets/js/paypal-admin.js'),
 (10109, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/assets/js/paypal-admin.min.js'),
 (10110, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/class-wc-gateway-paypal.php'),
 (10111, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-api-handler.php'),
 (10112, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-ipn-handler.php'),
 (10113, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-pdt-handler.php'),
 (10114, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-request.php'),
 (10115, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/class-wc-gateway-paypal-response.php'),
 (10116, 'wp-content/updraft/plugins-old/woocommerce/includes/gateways/paypal/includes/settings-paypal.php'),
 (10117, 'wp-content/updraft/plugins-old/woocommerce/includes/import/abstract-wc-product-importer.php'),
 (10118, 'wp-content/updraft/plugins-old/woocommerce/includes/import/class-wc-product-csv-importer.php'),
 (10119, 'wp-content/updraft/plugins-old/woocommerce/includes/integrations/maxmind-geolocation/class-wc-integration-maxmind-database-service.php'),
 (10120, 'wp-content/updraft/plugins-old/woocommerce/includes/integrations/maxmind-geolocation/class-wc-integration-maxmind-geolocation.php'),
 (10121, 'wp-content/updraft/plugins-old/woocommerce/includes/integrations/maxmind-geolocation/views/html-admin-options.php'),
 (10122, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-abstract-order-data-store-interface.php'),
 (10123, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-coupon-data-store-interface.php'),
 (10124, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-customer-data-store-interface.php'),
 (10125, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-customer-download-data-store-interface.php'),
 (10126, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-customer-download-log-data-store-interface.php'),
 (10127, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-importer-interface.php'),
 (10128, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-log-handler-interface.php'),
 (10129, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-logger-interface.php'),
 (10130, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-object-data-store-interface.php'),
 (10131, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-data-store-interface.php'),
 (10132, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-item-data-store-interface.php'),
 (10133, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-item-product-data-store-interface.php'),
 (10134, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-item-type-data-store-interface.php'),
 (10135, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-order-refund-data-store-interface.php'),
 (10136, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-payment-token-data-store-interface.php'),
 (10137, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-product-data-store-interface.php'),
 (10138, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-product-variable-data-store-interface.php'),
 (10139, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-queue-interface.php'),
 (10140, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-shipping-zone-data-store-interface.php'),
 (10141, 'wp-content/updraft/plugins-old/woocommerce/includes/interfaces/class-wc-webhooks-data-store-interface.php'),
 (10142, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/abstract-wc-legacy-order.php'),
 (10143, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/abstract-wc-legacy-payment-token.php'),
 (10144, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/abstract-wc-legacy-product.php'),
 (10145, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/class-wc-rest-legacy-coupons-controller.php'),
 (10146, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/class-wc-rest-legacy-orders-controller.php'),
 (10147, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/class-wc-rest-legacy-products-controller.php'),
 (10148, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-authentication.php'),
 (10149, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-coupons.php'),
 (10150, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-customers.php'),
 (10151, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-json-handler.php'),
 (10152, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-orders.php'),
 (10153, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-products.php'),
 (10154, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-reports.php'),
 (10155, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-resource.php'),
 (10156, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-server.php'),
 (10157, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/class-wc-api-xml-handler.php'),
 (10158, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v1/interface-wc-api-handler.php'),
 (10159, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-authentication.php'),
 (10160, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-coupons.php'),
 (10161, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-customers.php'),
 (10162, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-exception.php'),
 (10163, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-json-handler.php'),
 (10164, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-orders.php'),
 (10165, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-products.php'),
 (10166, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-reports.php'),
 (10167, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-resource.php'),
 (10168, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-server.php'),
 (10169, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/class-wc-api-webhooks.php'),
 (10170, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v2/interface-wc-api-handler.php'),
 (10171, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-authentication.php'),
 (10172, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-coupons.php'),
 (10173, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-customers.php'),
 (10174, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-exception.php'),
 (10175, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-json-handler.php'),
 (10176, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-orders.php'),
 (10177, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-products.php'),
 (10178, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-reports.php'),
 (10179, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-resource.php'),
 (10180, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-server.php'),
 (10181, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-taxes.php'),
 (10182, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/class-wc-api-webhooks.php'),
 (10183, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/api/v3/interface-wc-api-handler.php'),
 (10184, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-api.php'),
 (10185, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-cart.php'),
 (10186, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-coupon.php'),
 (10187, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-customer.php'),
 (10188, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-shipping-zone.php'),
 (10189, 'wp-content/updraft/plugins-old/woocommerce/includes/legacy/class-wc-legacy-webhook.php'),
 (10190, 'wp-content/updraft/plugins-old/woocommerce/includes/libraries/class-wc-eval-math.php'),
 (10191, 'wp-content/updraft/plugins-old/woocommerce/includes/libraries/wp-async-request.php'),
 (10192, 'wp-content/updraft/plugins-old/woocommerce/includes/libraries/wp-background-process.php'),
 (10193, 'wp-content/updraft/plugins-old/woocommerce/includes/log-handlers/class-wc-log-handler-db.php'),
 (10194, 'wp-content/updraft/plugins-old/woocommerce/includes/log-handlers/class-wc-log-handler-email.php'),
 (10195, 'wp-content/updraft/plugins-old/woocommerce/includes/log-handlers/class-wc-log-handler-file.php'),
 (10196, 'wp-content/updraft/plugins-old/woocommerce/includes/payment-tokens/class-wc-payment-token-cc.php'),
 (10197, 'wp-content/updraft/plugins-old/woocommerce/includes/payment-tokens/class-wc-payment-token-echeck.php'),
 (10198, 'wp-content/updraft/plugins-old/woocommerce/includes/queue/class-wc-action-queue.php'),
 (10199, 'wp-content/updraft/plugins-old/woocommerce/includes/queue/class-wc-queue.php'),
 (10200, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/flat-rate/class-wc-shipping-flat-rate.php'),
 (10201, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/flat-rate/includes/settings-flat-rate.php'),
 (10202, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/free-shipping/class-wc-shipping-free-shipping.php'),
 (10203, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-flat-rate/class-wc-shipping-legacy-flat-rate.php'),
 (10204, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-flat-rate/includes/settings-flat-rate.php'),
 (10205, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-free-shipping/class-wc-shipping-legacy-free-shipping.php'),
 (10206, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-international-delivery/class-wc-shipping-legacy-international-delivery.php'),
 (10207, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-local-delivery/class-wc-shipping-legacy-local-delivery.php'),
 (10208, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/legacy-local-pickup/class-wc-shipping-legacy-local-pickup.php'),
 (10209, 'wp-content/updraft/plugins-old/woocommerce/includes/shipping/local-pickup/class-wc-shipping-local-pickup.php'),
 (10210, 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-cart.php'),
 (10211, 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-checkout.php'),
 (10212, 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-my-account.php'),
 (10213, 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-order-tracking.php'),
 (10214, 'wp-content/updraft/plugins-old/woocommerce/includes/shortcodes/class-wc-shortcode-products.php'),
 (10215, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-eleven.php'),
 (10216, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-fifteen.php'),
 (10217, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-fourteen.php'),
 (10218, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-nineteen.php'),
 (10219, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-seventeen.php'),
 (10220, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-sixteen.php'),
 (10221, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-ten.php'),
 (10222, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-thirteen.php'),
 (10223, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-twelve.php'),
 (10224, 'wp-content/updraft/plugins-old/woocommerce/includes/theme-support/class-wc-twenty-twenty.php'),
 (10225, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-site-tracking.php'),
 (10226, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks-client.php'),
 (10227, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks-event.php'),
 (10228, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks-footer-pixel.php'),
 (10229, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/class-wc-tracks.php'),
 (10230, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-admin-setup-wizard-tracking.php'),
 (10231, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-coupons-tracking.php'),
 (10232, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-extensions-tracking.php'),
 (10233, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-importer-tracking.php'),
 (10234, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-orders-tracking.php'),
 (10235, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-products-tracking.php'),
 (10236, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-settings-tracking.php'),
 (10237, 'wp-content/updraft/plugins-old/woocommerce/includes/tracks/events/class-wc-status-tracking.php'),
 (10238, 'wp-content/updraft/plugins-old/woocommerce/includes/traits/trait-wc-item-totals.php'),
 (10239, 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-product-cat-dropdown-walker.php'),
 (10240, 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-product-cat-list-walker.php'),
 (10241, 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-wc-product-cat-dropdown-walker.php'),
 (10242, 'wp-content/updraft/plugins-old/woocommerce/includes/walkers/class-wc-product-cat-list-walker.php'),
 (10243, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-account-functions.php'),
 (10244, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-attribute-functions.php'),
 (10245, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-cart-functions.php'),
 (10246, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-conditional-functions.php'),
 (10247, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-core-functions.php'),
 (10248, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-coupon-functions.php'),
 (10249, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-deprecated-functions.php'),
 (10250, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-formatting-functions.php'),
 (10251, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-notice-functions.php'),
 (10252, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-order-functions.php'),
 (10253, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-order-item-functions.php'),
 (10254, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-page-functions.php'),
 (10255, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-product-functions.php'),
 (10256, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-rest-functions.php'),
 (10257, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-stock-functions.php'),
 (10258, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-template-functions.php'),
 (10259, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-template-hooks.php'),
 (10260, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-term-functions.php'),
 (10261, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-update-functions.php'),
 (10262, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-user-functions.php'),
 (10263, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-webhook-functions.php'),
 (10264, 'wp-content/updraft/plugins-old/woocommerce/includes/wc-widget-functions.php'),
 (10265, 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/class-wc-wccom-site-installer-requirements-check.php'),
 (10266, 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/class-wc-wccom-site-installer.php'),
 (10267, 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/class-wc-wccom-site.php'),
 (10268, 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/rest-api/class-wc-rest-wccom-site-installer-errors.php'),
 (10269, 'wp-content/updraft/plugins-old/woocommerce/includes/wccom-site/rest-api/endpoints/class-wc-rest-wccom-site-installer-controller.php'),
 (10270, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-cart.php'),
 (10271, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-layered-nav-filters.php'),
 (10272, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-layered-nav.php'),
 (10273, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-price-filter.php'),
 (10274, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-product-categories.php'),
 (10275, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-product-search.php'),
 (10276, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-product-tag-cloud.php'),
 (10277, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-products.php'),
 (10278, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-rating-filter.php'),
 (10279, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-recent-reviews.php'),
 (10280, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-recently-viewed.php'),
 (10281, 'wp-content/updraft/plugins-old/woocommerce/includes/widgets/class-wc-widget-top-rated-products.php'),
 (10282, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/action-scheduler.php'),
 (10283, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_ActionClaim.php'),
 (10284, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_ActionFactory.php'),
 (10285, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_AdminView.php'),
 (10286, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_AsyncRequest_QueueRunner.php'),
 (10287, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_Compatibility.php'),
 (10288, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_DataController.php'),
 (10289, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_DateTime.php'),
 (10290, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_Exception.php'),
 (10291, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_FatalErrorMonitor.php'),
 (10292, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_InvalidActionException.php'),
 (10293, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_ListTable.php'),
 (10294, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_LogEntry.php'),
 (10295, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_NullLogEntry.php'),
 (10296, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_OptionLock.php'),
 (10297, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_QueueCleaner.php'),
 (10298, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_QueueRunner.php'),
 (10299, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_Versions.php'),
 (10300, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_WPCommentCleaner.php'),
 (10301, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/ActionScheduler_wcSystemStatus.php'),
 (10302, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/ActionScheduler_WPCLI_QueueRunner.php'),
 (10303, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/ActionScheduler_WPCLI_Scheduler_command.php'),
 (10304, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/Migration_Command.php'),
 (10305, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/WP_CLI/ProgressBar.php'),
 (10306, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler.php'),
 (10307, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_ListTable.php'),
 (10308, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_QueueRunner.php'),
 (10309, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_RecurringSchedule.php'),
 (10310, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_Schedule.php'),
 (10311, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Abstract_Schema.php'),
 (10312, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Lock.php'),
 (10313, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Logger.php'),
 (10314, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_Store.php'),
 (10315, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/abstracts/ActionScheduler_TimezoneHelper.php'),
 (10316, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_Action.php'),
 (10317, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_CanceledAction.php'),
 (10318, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_FinishedAction.php'),
 (10319, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/actions/ActionScheduler_NullAction.php'),
 (10320, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_DBLogger.php'),
 (10321, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_DBStore.php'),
 (10322, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_HybridStore.php'),
 (10323, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpCommentLogger.php'),
 (10324, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore.php'),
 (10325, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore_PostStatusRegistrar.php'),
 (10326, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore_PostTypeRegistrar.php'),
 (10327, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/data-stores/ActionScheduler_wpPostStore_TaxonomyRegistrar.php'),
 (10328, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/ActionMigrator.php'),
 (10329, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/ActionScheduler_DBStoreMigrator.php'),
 (10330, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/BatchFetcher.php'),
 (10331, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Config.php'),
 (10332, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Controller.php'),
 (10333, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/DryRun_ActionMigrator.php'),
 (10334, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/DryRun_LogMigrator.php'),
 (10335, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/LogMigrator.php'),
 (10336, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Runner.php'),
 (10337, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/migration/Scheduler.php'),
 (10338, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_CanceledSchedule.php'),
 (10339, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_CronSchedule.php'),
 (10340, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_IntervalSchedule.php'),
 (10341, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_NullSchedule.php'),
 (10342, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_Schedule.php'),
 (10343, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schedules/ActionScheduler_SimpleSchedule.php'),
 (10344, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schema/ActionScheduler_LoggerSchema.php'),
 (10345, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/classes/schema/ActionScheduler_StoreSchema.php'),
 (10346, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_Abstract_QueueRunner_Deprecated.php'),
 (10347, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_AdminView_Deprecated.php'),
 (10348, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_Schedule_Deprecated.php'),
 (10349, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/ActionScheduler_Store_Deprecated.php'),
 (10350, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/deprecated/functions.php'),
 (10351, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/functions.php'),
 (10352, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/WP_Async_Request.php'),
 (10353, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression.php'),
 (10354, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_AbstractField.php'),
 (10355, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_DayOfMonthField.php'),
 (10356, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_DayOfWeekField.php'),
 (10357, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_FieldFactory.php'),
 (10358, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_FieldInterface.php'),
 (10359, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_HoursField.php'),
 (10360, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_MinutesField.php'),
 (10361, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_MonthField.php'),
 (10362, 'wp-content/updraft/plugins-old/woocommerce/packages/action-scheduler/lib/cron-expression/CronExpression_YearField.php'),
 (10363, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/app/index.js'),
 (10364, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/components/index.js'),
 (10365, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/csv-export/index.js'),
 (10366, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/currency/index.js'),
 (10367, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/date/index.js'),
 (10368, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/navigation/index.js'),
 (10369, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/number/index.js'),
 (10370, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-homepage-notice.js'),
 (10371, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-product-import-notice.js'),
 (10372, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-product-notice.js'),
 (10373, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/dist/wp-admin-scripts/onboarding-tax-notice.js'),
 (10374, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/images/empty-content.svg'),
 (10375, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/connect-existing-pages.php'),
 (10376, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/core-functions.php'),
 (10377, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/emails/html-admin-report-export-download.php'),
 (10378, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/emails/plain-admin-report-export-download.php'),
 (10379, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/feature-config.php'),
 (10380, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/page-controller-functions.php'),
 (10381, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/includes/wc-admin-update-functions.php'),
 (10382, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Coupons.php'),
 (10383, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Customers.php'),
 (10384, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Data.php'),
 (10385, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/DataCountries.php'),
 (10386, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/DataDownloadIPs.php'),
 (10387, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Init.php'),
 (10388, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Leaderboards.php'),
 (10389, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/NoteActions.php'),
 (10390, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Notes.php'),
 (10391, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingPlugins.php'),
 (10392, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingProfile.php'),
 (10393, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingTasks.php'),
 (10394, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/OnboardingThemes.php'),
 (10395, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Options.php'),
 (10396, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Orders.php'),
 (10397, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/ProductCategories.php'),
 (10398, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/ProductReviews.php'),
 (10399, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/ProductVariations.php'),
 (10400, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Products.php'),
 (10401, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Cache.php'),
 (10402, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Categories/Controller.php'),
 (10403, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Categories/DataStore.php'),
 (10404, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Categories/Query.php'),
 (10405, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Controller.php'),
 (10406, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Controller.php'),
 (10407, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/DataStore.php'),
 (10408, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Query.php'),
 (10409, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/Controller.php'),
 (10410, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/DataStore.php'),
 (10411, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/Query.php'),
 (10412, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Coupons/Stats/Segmenter.php'),
 (10413, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Controller.php'),
 (10414, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/DataStore.php'),
 (10415, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Query.php'),
 (10416, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Stats/Controller.php'),
 (10417, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Stats/DataStore.php'),
 (10418, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Customers/Stats/Query.php'),
 (10419, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/DataStore.php'),
 (10420, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/DataStoreInterface.php'),
 (10421, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Controller.php'),
 (10422, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/DataStore.php'),
 (10423, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Files/Controller.php'),
 (10424, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Query.php'),
 (10425, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Stats/Controller.php'),
 (10426, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Stats/DataStore.php'),
 (10427, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Downloads/Stats/Query.php'),
 (10428, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Export/Controller.php'),
 (10429, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/ExportableInterface.php'),
 (10430, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/ExportableTraits.php'),
 (10431, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Import/Controller.php'),
 (10432, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Controller.php'),
 (10433, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/DataStore.php'),
 (10434, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Query.php'),
 (10435, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/Controller.php'),
 (10436, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/DataStore.php'),
 (10437, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/Query.php'),
 (10438, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Orders/Stats/Segmenter.php'),
 (10439, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/ParameterException.php'),
 (10440, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/PerformanceIndicators/Controller.php'),
 (10441, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Controller.php'),
 (10442, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/DataStore.php'),
 (10443, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Query.php'),
 (10444, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/Controller.php'),
 (10445, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/DataStore.php'),
 (10446, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/Query.php'),
 (10447, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Products/Stats/Segmenter.php'),
 (10448, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Query.php'),
 (10449, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Revenue/Query.php'),
 (10450, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Revenue/Stats/Controller.php'),
 (10451, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Segmenter.php'),
 (10452, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/SqlQuery.php'),
 (10453, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Controller.php'),
 (10454, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Stats/Controller.php'),
 (10455, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Stats/DataStore.php'),
 (10456, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Stock/Stats/Query.php'),
 (10457, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Controller.php'),
 (10458, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/DataStore.php'),
 (10459, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Query.php'),
 (10460, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/Controller.php'),
 (10461, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/DataStore.php'),
 (10462, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/Query.php'),
 (10463, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Taxes/Stats/Segmenter.php'),
 (10464, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/TimeInterval.php'),
 (10465, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Variations/Controller.php'),
 (10466, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Variations/DataStore.php'),
 (10467, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Reports/Variations/Query.php'),
 (10468, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/SettingOptions.php'),
 (10469, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Taxes.php'),
 (10470, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/API/Themes.php'),
 (10471, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/CategoryLookup.php'),
 (10472, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Events.php'),
 (10473, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/FeaturePlugin.php'),
 (10474, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/ActivityPanels.php'),
 (10475, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/Analytics.php'),
 (10476, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/AnalyticsDashboard.php'),
 (10477, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/Onboarding.php'),
 (10478, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Features/OnboardingTasks.php'),
 (10479, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Install.php'),
 (10480, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Loader.php'),
 (10481, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/DataStore.php'),
 (10482, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/NoteTraits.php'),
 (10483, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Note.php'),
 (10484, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes.php'),
 (10485, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Add_First_Product.php'),
 (10486, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Deactivate_Plugin.php'),
 (10487, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Facebook_Extension.php'),
 (10488, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Giving_Feedback_Notes.php'),
 (10489, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Historical_Data.php'),
 (10490, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Mobile_App.php'),
 (10491, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_New_Sales_Record.php'),
 (10492, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Onboarding.php'),
 (10493, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Onboarding_Email_Marketing.php'),
 (10494, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Onboarding_Profiler.php'),
 (10495, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Order_Milestones.php'),
 (10496, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Settings_Notes.php'),
 (10497, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Tracking_Opt_In.php'),
 (10498, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Welcome_Message.php'),
 (10499, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Notes/WC_Admin_Notes_Woo_Subscriptions_Notes.php'),
 (10500, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/Order.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(10501, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/OrderRefund.php'),
 (10502, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/OrderTraits.php'),
 (10503, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/ThemeUpgrader.php'),
 (10504, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Overrides/ThemeUpgraderSkin.php'),
 (10505, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Package.php'),
 (10506, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/PageController.php'),
 (10507, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportCSVEmail.php'),
 (10508, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportCSVExporter.php'),
 (10509, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportExporter.php'),
 (10510, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/ReportsSync.php'),
 (10511, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/CustomersScheduler.php'),
 (10512, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/ImportInterface.php'),
 (10513, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/ImportScheduler.php'),
 (10514, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/OrdersScheduler.php'),
 (10515, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/src/Schedulers/SchedulerTraits.php'),
 (10516, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/uninstall.php'),
 (10517, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/autoload.php'),
 (10518, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/autoload_packages.php'),
 (10519, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/automattic/jetpack-autoloader/src/AutoloadGenerator.php'),
 (10520, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/automattic/jetpack-autoloader/src/CustomAutoloaderPlugin.php'),
 (10521, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/automattic/jetpack-autoloader/src/autoload.php'),
 (10522, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/ClassLoader.php'),
 (10523, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_classmap.php'),
 (10524, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_classmap_package.php'),
 (10525, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_namespaces.php'),
 (10526, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_psr4.php'),
 (10527, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_real.php'),
 (10528, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/autoload_static.php'),
 (10529, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AglInstaller.php'),
 (10530, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AimeosInstaller.php'),
 (10531, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AnnotateCmsInstaller.php'),
 (10532, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AsgardInstaller.php'),
 (10533, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/AttogramInstaller.php'),
 (10534, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/BaseInstaller.php'),
 (10535, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/BitrixInstaller.php'),
 (10536, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/BonefishInstaller.php'),
 (10537, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CakePHPInstaller.php'),
 (10538, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ChefInstaller.php'),
 (10539, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CiviCrmInstaller.php'),
 (10540, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ClanCatsFrameworkInstaller.php'),
 (10541, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CockpitInstaller.php'),
 (10542, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CodeIgniterInstaller.php'),
 (10543, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Concrete5Installer.php'),
 (10544, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CraftInstaller.php'),
 (10545, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/CroogoInstaller.php'),
 (10546, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DecibelInstaller.php'),
 (10547, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DframeInstaller.php'),
 (10548, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DokuWikiInstaller.php'),
 (10549, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DolibarrInstaller.php'),
 (10550, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/DrupalInstaller.php'),
 (10551, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ElggInstaller.php'),
 (10552, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/EliasisInstaller.php'),
 (10553, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ExpressionEngineInstaller.php'),
 (10554, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/EzPlatformInstaller.php'),
 (10555, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/FuelInstaller.php'),
 (10556, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/FuelphpInstaller.php'),
 (10557, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/GravInstaller.php'),
 (10558, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/HuradInstaller.php'),
 (10559, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ImageCMSInstaller.php'),
 (10560, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Installer.php'),
 (10561, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ItopInstaller.php'),
 (10562, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/JoomlaInstaller.php'),
 (10563, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KanboardInstaller.php'),
 (10564, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KirbyInstaller.php'),
 (10565, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KnownInstaller.php'),
 (10566, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KodiCMSInstaller.php'),
 (10567, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/KohanaInstaller.php'),
 (10568, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LanManagementSystemInstaller.php'),
 (10569, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LaravelInstaller.php'),
 (10570, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LavaLiteInstaller.php'),
 (10571, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/LithiumInstaller.php'),
 (10572, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MODULEWorkInstaller.php'),
 (10573, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MODXEvoInstaller.php'),
 (10574, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MagentoInstaller.php'),
 (10575, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MajimaInstaller.php'),
 (10576, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MakoInstaller.php'),
 (10577, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MauticInstaller.php'),
 (10578, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MayaInstaller.php'),
 (10579, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MediaWikiInstaller.php'),
 (10580, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MicroweberInstaller.php'),
 (10581, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ModxInstaller.php'),
 (10582, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/MoodleInstaller.php'),
 (10583, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OctoberInstaller.php'),
 (10584, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OntoWikiInstaller.php'),
 (10585, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OsclassInstaller.php'),
 (10586, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/OxidInstaller.php'),
 (10587, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PPIInstaller.php'),
 (10588, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PhiftyInstaller.php'),
 (10589, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PhpBBInstaller.php'),
 (10590, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PimcoreInstaller.php'),
 (10591, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PiwikInstaller.php'),
 (10592, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PlentymarketsInstaller.php'),
 (10593, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Plugin.php'),
 (10594, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PortoInstaller.php'),
 (10595, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PrestashopInstaller.php'),
 (10596, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PuppetInstaller.php'),
 (10597, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/PxcmsInstaller.php'),
 (10598, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/RadPHPInstaller.php'),
 (10599, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ReIndexInstaller.php'),
 (10600, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Redaxo5Installer.php'),
 (10601, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/RedaxoInstaller.php'),
 (10602, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/RoundcubeInstaller.php'),
 (10603, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SMFInstaller.php'),
 (10604, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ShopwareInstaller.php'),
 (10605, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SilverStripeInstaller.php'),
 (10606, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SiteDirectInstaller.php'),
 (10607, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/SyDESInstaller.php'),
 (10608, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/Symfony1Installer.php'),
 (10609, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TYPO3CmsInstaller.php'),
 (10610, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TYPO3FlowInstaller.php'),
 (10611, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TaoInstaller.php'),
 (10612, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TheliaInstaller.php'),
 (10613, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/TuskInstaller.php'),
 (10614, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/UserFrostingInstaller.php'),
 (10615, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/VanillaInstaller.php'),
 (10616, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/VgmcpInstaller.php'),
 (10617, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/WHMCSInstaller.php'),
 (10618, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/WolfCMSInstaller.php'),
 (10619, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/WordPressInstaller.php'),
 (10620, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/YawikInstaller.php'),
 (10621, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ZendInstaller.php'),
 (10622, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/Composer/Installers/ZikulaInstaller.php'),
 (10623, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/vendor/composer/installers/src/bootstrap.php'),
 (10624, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-admin/woocommerce-admin.php'),
 (10625, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/block-error.svg'),
 (10626, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/grid.svg'),
 (10627, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/no-matching-products.svg'),
 (10628, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/img/no-products.svg'),
 (10629, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/button/index.js'),
 (10630, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/image/index.js'),
 (10631, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/index.js'),
 (10632, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/price/index.js'),
 (10633, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/rating/index.js'),
 (10634, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/sale-badge/index.js'),
 (10635, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/shared-config.js'),
 (10636, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/summary/index.js'),
 (10637, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/blocks/product/title/index.js'),
 (10638, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/button/index.js'),
 (10639, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/image/index.js'),
 (10640, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/index.js'),
 (10641, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/price/index.js'),
 (10642, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/rating/index.js'),
 (10643, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/sale-badge/index.js'),
 (10644, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/summary/index.js'),
 (10645, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/atomic/components/product/title/index.js'),
 (10646, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/block-error-boundary/block-error.js'),
 (10647, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/block-error-boundary/index.js'),
 (10648, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/checkbox-list/index.js'),
 (10649, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/checkout/form-step/index.js'),
 (10650, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/label/index.js'),
 (10651, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/label/test/__snapshots__/index.js.snap'),
 (10652, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/label/test/index.js'),
 (10653, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/load-more-button/index.js'),
 (10654, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/pagination/index.js'),
 (10655, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/pagination/test/index.js'),
 (10656, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/pagination/utils.js'),
 (10657, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/constrain-range-slider-values.js'),
 (10658, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/index.js'),
 (10659, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/price-input.js'),
 (10660, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/price-label.js'),
 (10661, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/submit-button.js'),
 (10662, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/price-slider/test/constrain-range-slider-values.js'),
 (10663, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/container.js'),
 (10664, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/index.js'),
 (10665, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/no-matching-products.js'),
 (10666, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list/no-products.js'),
 (10667, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list-item/index.js'),
 (10668, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-list-item/utils.js'),
 (10669, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/product-sort-select/index.js'),
 (10670, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/read-more/index.js'),
 (10671, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/read-more/test/index.js'),
 (10672, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/read-more/utils.js'),
 (10673, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/review-list/index.js'),
 (10674, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/review-list-item/index.js'),
 (10675, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/review-sort-select/index.js'),
 (10676, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/components/sort-select/index.js'),
 (10677, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/inner-block-configuration-context.js'),
 (10678, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/product-layout-context.js'),
 (10679, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/query-state-context.js'),
 (10680, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/test/utils.js'),
 (10681, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/context/utils.js'),
 (10682, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/test/with-component-id.js'),
 (10683, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/test/with-products.js'),
 (10684, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/test/with-reviews.js'),
 (10685, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/utils.js'),
 (10686, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-component-id.js'),
 (10687, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-products.js'),
 (10688, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-reviews.js'),
 (10689, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-scroll-to-top/index.js'),
 (10690, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hocs/with-scroll-to-top/test/index.js'),
 (10691, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/index.js'),
 (10692, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-collection.js'),
 (10693, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-previous.js'),
 (10694, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-query-state.js'),
 (10695, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-shallow-equal.js'),
 (10696, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/test/use-store-products.js'),
 (10697, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-collection-data.js'),
 (10698, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-collection-header.js'),
 (10699, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-collection.js'),
 (10700, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-previous.js'),
 (10701, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-query-state.js'),
 (10702, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-shallow-equal.js'),
 (10703, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/hooks/use-store-products.js'),
 (10704, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/errors.js'),
 (10705, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/index.js'),
 (10706, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/price.js'),
 (10707, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/test/errors.js'),
 (10708, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/base/utils/test/price.js'),
 (10709, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/active-attribute-filters.js'),
 (10710, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/block.js'),
 (10711, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/edit.js'),
 (10712, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/frontend.js'),
 (10713, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/index.js'),
 (10714, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/active-filters/utils.js'),
 (10715, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/block.js'),
 (10716, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/edit.js'),
 (10717, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/frontend.js'),
 (10718, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/attribute-filter/index.js'),
 (10719, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/block.js'),
 (10720, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/example.js'),
 (10721, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/index.js'),
 (10722, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-category/utils.js'),
 (10723, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/block.js'),
 (10724, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/example.js'),
 (10725, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/index.js'),
 (10726, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/featured-product/utils.js'),
 (10727, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/handpicked-products/block.js'),
 (10728, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/handpicked-products/index.js'),
 (10729, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/block.js'),
 (10730, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/constants.js'),
 (10731, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/edit.js'),
 (10732, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/frontend.js'),
 (10733, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/index.js'),
 (10734, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/test/use-price-constraints.js'),
 (10735, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/price-filter/use-price-constraints.js'),
 (10736, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-best-sellers/block.js'),
 (10737, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-best-sellers/index.js'),
 (10738, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-categories/block.js'),
 (10739, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-categories/index.js'),
 (10740, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-category/block.js'),
 (10741, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-category/index.js'),
 (10742, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-new/block.js'),
 (10743, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-new/index.js'),
 (10744, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-on-sale/block.js'),
 (10745, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-on-sale/index.js'),
 (10746, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-search/block.js'),
 (10747, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-search/edit.js'),
 (10748, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-search/index.js'),
 (10749, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-tag/block.js'),
 (10750, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-tag/index.js'),
 (10751, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-top-rated/block.js'),
 (10752, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/product-top-rated/index.js'),
 (10753, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/block.js'),
 (10754, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/edit.js'),
 (10755, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/frontend.js'),
 (10756, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/all-products/index.js'),
 (10757, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/attributes.js'),
 (10758, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/base-utils.js'),
 (10759, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/edit.js'),
 (10760, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products/utils.js'),
 (10761, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products-by-attribute/block.js'),
 (10762, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/products-by-attribute/index.js'),
 (10763, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/all-reviews/edit.js'),
 (10764, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/all-reviews/index.js'),
 (10765, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/all-reviews/no-reviews-placeholder.js'),
 (10766, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/attributes.js'),
 (10767, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/edit-utils.js'),
 (10768, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/editor-block.js'),
 (10769, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/editor-container-block.js'),
 (10770, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/example.js'),
 (10771, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/frontend-block.js'),
 (10772, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/frontend-container-block.js'),
 (10773, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/frontend.js'),
 (10774, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-category/edit.js'),
 (10775, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-category/index.js'),
 (10776, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-category/no-reviews-placeholder.js'),
 (10777, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-product/edit.js'),
 (10778, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-product/index.js'),
 (10779, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/reviews-by-product/no-reviews-placeholder.js'),
 (10780, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/save.js'),
 (10781, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks/reviews/utils.js'),
 (10782, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/get-registered-inner-blocks.js'),
 (10783, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/index.js'),
 (10784, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/register-inner-block.js'),
 (10785, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/registered-blocks-init.js'),
 (10786, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/blocks-registry/test/index.js'),
 (10787, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/block-title/index.js'),
 (10788, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/error-placeholder/error-message.js'),
 (10789, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/error-placeholder/index.js'),
 (10790, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/grid-content-control/index.js'),
 (10791, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/grid-layout-control/index.js'),
 (10792, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/heading-toolbar/heading-level-icon.js'),
 (10793, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/heading-toolbar/index.js'),
 (10794, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/all-reviews.js'),
 (10795, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/checkbox-checked.js'),
 (10796, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/checkbox-unchecked.js'),
 (10797, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/external.js'),
 (10798, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/folder-star.js'),
 (10799, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/folder.js'),
 (10800, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/index.js'),
 (10801, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/money.js'),
 (10802, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/new-releases.js'),
 (10803, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/product-on-sale.js'),
 (10804, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/product-search.js'),
 (10805, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/product-tag.js'),
 (10806, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/radio-selected.js'),
 (10807, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/radio-unselected.js'),
 (10808, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/reviews-by-category.js'),
 (10809, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/reviews-by-product.js'),
 (10810, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/widgets.js'),
 (10811, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/icons/woo.js'),
 (10812, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-attribute-term-control/index.js'),
 (10813, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-category-control/index.js'),
 (10814, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-control/index.js'),
 (10815, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-orderby-control/index.js'),
 (10816, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-preview/index.js'),
 (10817, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-preview/test/__snapshots__/index.js.snap'),
 (10818, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-preview/test/index.js'),
 (10819, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/product-tag-control/index.js'),
 (10820, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/products-control/index.js'),
 (10821, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/toggle-button-control/index.js'),
 (10822, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/components/utils/index.js'),
 (10823, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/action-types.js'),
 (10824, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/actions.js'),
 (10825, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/constants.js'),
 (10826, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/controls.js'),
 (10827, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/index.js'),
 (10828, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/reducers.js'),
 (10829, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/resolvers.js'),
 (10830, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/selectors.js'),
 (10831, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/test/reducers.js'),
 (10832, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/test/resolvers.js'),
 (10833, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/collections/test/selectors.js'),
 (10834, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/constants.js'),
 (10835, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/index.js'),
 (10836, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/action-types.js'),
 (10837, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/actions.js'),
 (10838, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/constants.js'),
 (10839, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/index.js'),
 (10840, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/reducers.js'),
 (10841, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/selectors.js'),
 (10842, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/test/reducers.js'),
 (10843, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/test/selectors.js'),
 (10844, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/query-state/utils.js'),
 (10845, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/action-types.js'),
 (10846, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/actions.js'),
 (10847, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/constants.js'),
 (10848, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/index.js'),
 (10849, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/reducers.js'),
 (10850, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/resolvers.js'),
 (10851, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/selectors.js'),
 (10852, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/reducers.js'),
 (10853, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/resolvers.js'),
 (10854, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/selectors.js'),
 (10855, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/test/utils.js'),
 (10856, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/schema/utils.js'),
 (10857, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/utils/has-in-state.js'),
 (10858, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/utils/index.js'),
 (10859, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/data/utils/update-state.js'),
 (10860, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/index.js'),
 (10861, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-attributes.js'),
 (10862, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-categories.js'),
 (10863, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-category.js'),
 (10864, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-product-variations.js'),
 (10865, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-product.js'),
 (10866, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-searched-products.js'),
 (10867, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/test/with-transform-single-select-to-multiple-select.js'),
 (10868, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-attributes.js'),
 (10869, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-categories.js'),
 (10870, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-category.js'),
 (10871, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-product-variations.js'),
 (10872, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-product.js'),
 (10873, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-rest-api-hydration.js'),
 (10874, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-searched-products.js'),
 (10875, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/hocs/with-transform-single-select-to-multiple-select.js'),
 (10876, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/index.js'),
 (10877, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/categories.js'),
 (10878, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/grid-block.js'),
 (10879, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/index.js'),
 (10880, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/products.js'),
 (10881, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/previews/reviews.js'),
 (10882, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/blocks/constants.js'),
 (10883, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/blocks/endpoints.js'),
 (10884, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/blocks/index.js'),
 (10885, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/default-constants.js'),
 (10886, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/get-setting.js'),
 (10887, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/index.js'),
 (10888, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/set-setting.js'),
 (10889, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/settings-init.js'),
 (10890, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/test/compare-with-wp-version.js'),
 (10891, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/test/get-setting.js'),
 (10892, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/settings/shared/test/set-setting.js'),
 (10893, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/attributes-query.js'),
 (10894, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/attributes.js'),
 (10895, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/deprecations.js'),
 (10896, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/get-query.js'),
 (10897, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/get-shortcode.js'),
 (10898, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/products.js'),
 (10899, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/render-frontend.js'),
 (10900, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/shared-attributes.js'),
 (10901, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/test/get-query.js'),
 (10902, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/assets/js/utils/test/products.js'),
 (10903, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/active-filters-frontend.js'),
 (10904, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/active-filters.js'),
 (10905, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-products-frontend.js'),
 (10906, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-products.js'),
 (10907, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-reviews-legacy.js'),
 (10908, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/all-reviews.js'),
 (10909, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/attribute-filter-frontend.js'),
 (10910, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/attribute-filter.js'),
 (10911, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/block-error-boundary-legacy.js'),
 (10912, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/block-error-boundary.js'),
 (10913, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/blocks-legacy.js'),
 (10914, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/blocks.js'),
 (10915, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-category-legacy.js'),
 (10916, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-category.js'),
 (10917, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-product-legacy.js'),
 (10918, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/featured-product.js'),
 (10919, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/handpicked-products-legacy.js'),
 (10920, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/handpicked-products.js'),
 (10921, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/price-filter-frontend.js'),
 (10922, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/price-filter.js'),
 (10923, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-best-sellers-legacy.js'),
 (10924, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-best-sellers.js'),
 (10925, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-categories-legacy.js'),
 (10926, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-categories.js'),
 (10927, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-category-legacy.js'),
 (10928, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-category.js'),
 (10929, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-new-legacy.js'),
 (10930, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-new.js'),
 (10931, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-on-sale-legacy.js'),
 (10932, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-on-sale.js'),
 (10933, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-search-legacy.js'),
 (10934, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-search.js'),
 (10935, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-tag-legacy.js'),
 (10936, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-tag.js'),
 (10937, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-top-rated-legacy.js'),
 (10938, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/product-top-rated.js'),
 (10939, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/products-by-attribute-legacy.js'),
 (10940, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/products-by-attribute.js'),
 (10941, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-category-legacy.js'),
 (10942, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-category.js'),
 (10943, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-product-legacy.js'),
 (10944, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-by-product.js'),
 (10945, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-frontend-legacy.js'),
 (10946, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/reviews-frontend.js'),
 (10947, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/vendors-legacy.js'),
 (10948, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/vendors.js'),
 (10949, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/wc-blocks-data.js'),
 (10950, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/wc-blocks-registry.js'),
 (10951, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/build/wc-settings.js'),
 (10952, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets/Api.php'),
 (10953, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets/AssetDataRegistry.php'),
 (10954, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets/BackCompatAssetDataRegistry.php'),
 (10955, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Assets.php'),
 (10956, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AbstractBlock.php'),
 (10957, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AbstractDynamicBlock.php'),
 (10958, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AbstractProductGrid.php'),
 (10959, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ActiveFilters.php'),
 (10960, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AllProducts.php'),
 (10961, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AllReviews.php'),
 (10962, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/AttributeFilter.php'),
 (10963, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/FeaturedCategory.php'),
 (10964, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/FeaturedProduct.php'),
 (10965, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/HandpickedProducts.php'),
 (10966, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/PriceFilter.php'),
 (10967, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductBestSellers.php'),
 (10968, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductCategories.php'),
 (10969, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductCategory.php'),
 (10970, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductNew.php'),
 (10971, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductOnSale.php'),
 (10972, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductSearch.php'),
 (10973, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductTag.php'),
 (10974, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductTopRated.php'),
 (10975, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ProductsByAttribute.php'),
 (10976, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ReviewsByCategory.php'),
 (10977, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/BlockTypes/ReviewsByProduct.php'),
 (10978, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Domain/Bootstrap.php'),
 (10979, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Domain/Package.php'),
 (10980, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Library.php'),
 (10981, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Package.php'),
 (10982, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/AbstractDependencyType.php'),
 (10983, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/Container.php'),
 (10984, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/FactoryType.php'),
 (10985, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Registry/SharedType.php'),
 (10986, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/Cart.php'),
 (10987, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductAttributeTerms.php'),
 (10988, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductAttributes.php'),
 (10989, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductCategories.php'),
 (10990, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductReviews.php'),
 (10991, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/ProductTags.php'),
 (10992, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/Products.php'),
 (10993, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Controllers/Variations.php'),
 (10994, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/Cart.php'),
 (10995, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/CartItems.php'),
 (10996, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/ProductAttributeTerms.php'),
 (10997, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/ProductAttributes.php'),
 (10998, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/ProductCollectionData.php'),
 (10999, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Controllers/Products.php'),
 (11000, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/AbstractSchema.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(11001, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/CartItemSchema.php'),
 (11002, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/CartSchema.php'),
 (11003, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/ProductAttributeSchema.php'),
 (11004, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/ProductSchema.php'),
 (11005, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Schemas/TermSchema.php'),
 (11006, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/CartController.php'),
 (11007, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/Pagination.php'),
 (11008, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/ProductFiltering.php'),
 (11009, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/ProductQuery.php'),
 (11010, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/StoreApi/Utilities/TermQuery.php'),
 (11011, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi/Utilities/ProductImages.php'),
 (11012, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/RestApi.php'),
 (11013, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/src/Utils/BlocksWpQuery.php'),
 (11014, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/autoload.php'),
 (11015, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/autoload_packages.php'),
 (11016, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/automattic/jetpack-autoloader/src/AutoloadGenerator.php'),
 (11017, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/automattic/jetpack-autoloader/src/CustomAutoloaderPlugin.php'),
 (11018, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/automattic/jetpack-autoloader/src/autoload.php'),
 (11019, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/ClassLoader.php'),
 (11020, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_classmap.php'),
 (11021, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_classmap_package.php'),
 (11022, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_namespaces.php'),
 (11023, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_psr4.php'),
 (11024, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_real.php'),
 (11025, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/autoload_static.php'),
 (11026, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AglInstaller.php'),
 (11027, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AimeosInstaller.php'),
 (11028, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AnnotateCmsInstaller.php'),
 (11029, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AsgardInstaller.php'),
 (11030, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/AttogramInstaller.php'),
 (11031, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/BaseInstaller.php'),
 (11032, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/BitrixInstaller.php'),
 (11033, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/BonefishInstaller.php'),
 (11034, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CakePHPInstaller.php'),
 (11035, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ChefInstaller.php'),
 (11036, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CiviCrmInstaller.php'),
 (11037, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ClanCatsFrameworkInstaller.php'),
 (11038, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CockpitInstaller.php'),
 (11039, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CodeIgniterInstaller.php'),
 (11040, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Concrete5Installer.php'),
 (11041, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CraftInstaller.php'),
 (11042, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/CroogoInstaller.php'),
 (11043, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DecibelInstaller.php'),
 (11044, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DframeInstaller.php'),
 (11045, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DokuWikiInstaller.php'),
 (11046, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DolibarrInstaller.php'),
 (11047, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/DrupalInstaller.php'),
 (11048, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ElggInstaller.php'),
 (11049, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/EliasisInstaller.php'),
 (11050, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ExpressionEngineInstaller.php'),
 (11051, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/EzPlatformInstaller.php'),
 (11052, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/FuelInstaller.php'),
 (11053, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/FuelphpInstaller.php'),
 (11054, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/GravInstaller.php'),
 (11055, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/HuradInstaller.php'),
 (11056, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ImageCMSInstaller.php'),
 (11057, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Installer.php'),
 (11058, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ItopInstaller.php'),
 (11059, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/JoomlaInstaller.php'),
 (11060, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KanboardInstaller.php'),
 (11061, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KirbyInstaller.php'),
 (11062, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KnownInstaller.php'),
 (11063, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KodiCMSInstaller.php'),
 (11064, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/KohanaInstaller.php'),
 (11065, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LanManagementSystemInstaller.php'),
 (11066, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LaravelInstaller.php'),
 (11067, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LavaLiteInstaller.php'),
 (11068, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/LithiumInstaller.php'),
 (11069, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MODULEWorkInstaller.php'),
 (11070, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MODXEvoInstaller.php'),
 (11071, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MagentoInstaller.php'),
 (11072, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MajimaInstaller.php'),
 (11073, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MakoInstaller.php'),
 (11074, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MauticInstaller.php'),
 (11075, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MayaInstaller.php'),
 (11076, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MediaWikiInstaller.php'),
 (11077, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MicroweberInstaller.php'),
 (11078, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ModxInstaller.php'),
 (11079, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/MoodleInstaller.php'),
 (11080, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OctoberInstaller.php'),
 (11081, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OntoWikiInstaller.php'),
 (11082, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OsclassInstaller.php'),
 (11083, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/OxidInstaller.php'),
 (11084, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PPIInstaller.php'),
 (11085, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PhiftyInstaller.php'),
 (11086, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PhpBBInstaller.php'),
 (11087, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PimcoreInstaller.php'),
 (11088, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PiwikInstaller.php'),
 (11089, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PlentymarketsInstaller.php'),
 (11090, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Plugin.php'),
 (11091, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PortoInstaller.php'),
 (11092, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PrestashopInstaller.php'),
 (11093, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PuppetInstaller.php'),
 (11094, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/PxcmsInstaller.php'),
 (11095, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/RadPHPInstaller.php'),
 (11096, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ReIndexInstaller.php'),
 (11097, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Redaxo5Installer.php'),
 (11098, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/RedaxoInstaller.php'),
 (11099, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/RoundcubeInstaller.php'),
 (11100, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SMFInstaller.php'),
 (11101, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ShopwareInstaller.php'),
 (11102, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SilverStripeInstaller.php'),
 (11103, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SiteDirectInstaller.php'),
 (11104, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/SyDESInstaller.php'),
 (11105, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/Symfony1Installer.php'),
 (11106, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TYPO3CmsInstaller.php'),
 (11107, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TYPO3FlowInstaller.php'),
 (11108, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TaoInstaller.php'),
 (11109, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TheliaInstaller.php'),
 (11110, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/TuskInstaller.php'),
 (11111, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/UserFrostingInstaller.php'),
 (11112, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/VanillaInstaller.php'),
 (11113, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/VgmcpInstaller.php'),
 (11114, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/WHMCSInstaller.php'),
 (11115, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/WolfCMSInstaller.php'),
 (11116, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/WordPressInstaller.php'),
 (11117, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/YawikInstaller.php'),
 (11118, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ZendInstaller.php'),
 (11119, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/Composer/Installers/ZikulaInstaller.php'),
 (11120, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/vendor/composer/installers/src/bootstrap.php'),
 (11121, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-blocks/woocommerce-gutenberg-products-block.php'),
 (11122, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-coupons-v1-controller.php'),
 (11123, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-customer-downloads-v1-controller.php'),
 (11124, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-customers-v1-controller.php'),
 (11125, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-order-notes-v1-controller.php'),
 (11126, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-order-refunds-v1-controller.php'),
 (11127, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-orders-v1-controller.php'),
 (11128, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-attribute-terms-v1-controller.php'),
 (11129, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-attributes-v1-controller.php'),
 (11130, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-categories-v1-controller.php'),
 (11131, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-reviews-v1-controller.php'),
 (11132, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-shipping-classes-v1-controller.php'),
 (11133, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-product-tags-v1-controller.php'),
 (11134, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-products-v1-controller.php'),
 (11135, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-report-sales-v1-controller.php'),
 (11136, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-report-top-sellers-v1-controller.php'),
 (11137, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-reports-v1-controller.php'),
 (11138, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-tax-classes-v1-controller.php'),
 (11139, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-taxes-v1-controller.php'),
 (11140, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-webhook-deliveries-v1-controller.php'),
 (11141, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version1/class-wc-rest-webhooks-v1-controller.php'),
 (11142, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-coupons-v2-controller.php'),
 (11143, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-customer-downloads-v2-controller.php'),
 (11144, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-customers-v2-controller.php'),
 (11145, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-network-orders-v2-controller.php'),
 (11146, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-order-notes-v2-controller.php'),
 (11147, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-order-refunds-v2-controller.php'),
 (11148, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-orders-v2-controller.php'),
 (11149, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-payment-gateways-v2-controller.php'),
 (11150, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-attribute-terms-v2-controller.php'),
 (11151, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-attributes-v2-controller.php'),
 (11152, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-categories-v2-controller.php'),
 (11153, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-reviews-v2-controller.php'),
 (11154, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-shipping-classes-v2-controller.php'),
 (11155, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-tags-v2-controller.php'),
 (11156, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-product-variations-v2-controller.php'),
 (11157, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-products-v2-controller.php'),
 (11158, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-report-sales-v2-controller.php'),
 (11159, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-report-top-sellers-v2-controller.php'),
 (11160, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-reports-v2-controller.php'),
 (11161, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-setting-options-v2-controller.php'),
 (11162, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-settings-v2-controller.php'),
 (11163, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-methods-v2-controller.php'),
 (11164, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-zone-locations-v2-controller.php'),
 (11165, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-zone-methods-v2-controller.php'),
 (11166, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-shipping-zones-v2-controller.php'),
 (11167, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-system-status-tools-v2-controller.php'),
 (11168, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-system-status-v2-controller.php'),
 (11169, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-tax-classes-v2-controller.php'),
 (11170, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-taxes-v2-controller.php'),
 (11171, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-webhook-deliveries-v2-controller.php'),
 (11172, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version2/class-wc-rest-webhooks-v2-controller.php'),
 (11173, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-controller.php'),
 (11174, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-coupons-controller.php'),
 (11175, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-crud-controller.php'),
 (11176, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-customer-downloads-controller.php'),
 (11177, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-customers-controller.php'),
 (11178, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-continents-controller.php'),
 (11179, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-controller.php'),
 (11180, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-countries-controller.php'),
 (11181, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-data-currencies-controller.php'),
 (11182, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-network-orders-controller.php'),
 (11183, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-order-notes-controller.php'),
 (11184, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-order-refunds-controller.php'),
 (11185, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-orders-controller.php'),
 (11186, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-payment-gateways-controller.php'),
 (11187, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-posts-controller.php'),
 (11188, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-attribute-terms-controller.php'),
 (11189, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-attributes-controller.php'),
 (11190, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-categories-controller.php'),
 (11191, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-reviews-controller.php'),
 (11192, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-shipping-classes-controller.php'),
 (11193, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-tags-controller.php'),
 (11194, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-product-variations-controller.php'),
 (11195, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-products-controller.php'),
 (11196, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-coupons-totals-controller.php'),
 (11197, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-customers-totals-controller.php'),
 (11198, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-orders-totals-controller.php'),
 (11199, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-products-totals-controller.php'),
 (11200, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-reviews-totals-controller.php'),
 (11201, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-sales-controller.php'),
 (11202, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-report-top-sellers-controller.php'),
 (11203, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-reports-controller.php'),
 (11204, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-setting-options-controller.php'),
 (11205, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-settings-controller.php'),
 (11206, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-methods-controller.php'),
 (11207, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zone-locations-controller.php'),
 (11208, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zone-methods-controller.php'),
 (11209, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zones-controller-base.php'),
 (11210, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-shipping-zones-controller.php'),
 (11211, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-system-status-controller.php'),
 (11212, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-system-status-tools-controller.php'),
 (11213, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-tax-classes-controller.php'),
 (11214, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-taxes-controller.php'),
 (11215, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-terms-controller.php'),
 (11216, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Controllers/Version3/class-wc-rest-webhooks-controller.php'),
 (11217, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Package.php'),
 (11218, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Server.php'),
 (11219, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Utilities/ImageAttachment.php'),
 (11220, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/src/Utilities/SingletonTrait.php'),
 (11221, 'wp-content/updraft/plugins-old/woocommerce/packages/woocommerce-rest-api/woocommerce-rest-api.php'),
 (11222, 'wp-content/updraft/plugins-old/woocommerce/src/Autoloader.php'),
 (11223, 'wp-content/updraft/plugins-old/woocommerce/src/Packages.php'),
 (11224, 'wp-content/updraft/plugins-old/woocommerce/templates/archive-product.php'),
 (11225, 'wp-content/updraft/plugins-old/woocommerce/templates/auth/footer.php'),
 (11226, 'wp-content/updraft/plugins-old/woocommerce/templates/auth/form-grant-access.php'),
 (11227, 'wp-content/updraft/plugins-old/woocommerce/templates/auth/form-login.php'),
 (11228, 'wp-content/updraft/plugins-old/woocommerce/templates/auth/header.php'),
 (11229, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-empty.php'),
 (11230, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-item-data.php'),
 (11231, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-shipping.php'),
 (11232, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart-totals.php'),
 (11233, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cart.php'),
 (11234, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/cross-sells.php'),
 (11235, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/mini-cart.php'),
 (11236, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/proceed-to-checkout-button.php'),
 (11237, 'wp-content/updraft/plugins-old/woocommerce/templates/cart/shipping-calculator.php'),
 (11238, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/cart-errors.php'),
 (11239, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-billing.php'),
 (11240, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-checkout.php'),
 (11241, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-coupon.php'),
 (11242, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-login.php'),
 (11243, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-pay.php'),
 (11244, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/form-shipping.php'),
 (11245, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/order-receipt.php'),
 (11246, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/payment-method.php'),
 (11247, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/payment.php'),
 (11248, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/review-order.php'),
 (11249, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/terms.php'),
 (11250, 'wp-content/updraft/plugins-old/woocommerce/templates/checkout/thankyou.php'),
 (11251, 'wp-content/updraft/plugins-old/woocommerce/templates/content-product.php'),
 (11252, 'wp-content/updraft/plugins-old/woocommerce/templates/content-product_cat.php'),
 (11253, 'wp-content/updraft/plugins-old/woocommerce/templates/content-single-product.php'),
 (11254, 'wp-content/updraft/plugins-old/woocommerce/templates/content-widget-price-filter.php'),
 (11255, 'wp-content/updraft/plugins-old/woocommerce/templates/content-widget-product.php'),
 (11256, 'wp-content/updraft/plugins-old/woocommerce/templates/content-widget-reviews.php'),
 (11257, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/admin-cancelled-order.php'),
 (11258, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/admin-failed-order.php'),
 (11259, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/admin-new-order.php'),
 (11260, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-completed-order.php'),
 (11261, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-invoice.php'),
 (11262, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-new-account.php'),
 (11263, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-note.php'),
 (11264, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-on-hold-order.php'),
 (11265, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-processing-order.php'),
 (11266, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-refunded-order.php'),
 (11267, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/customer-reset-password.php'),
 (11268, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-addresses.php'),
 (11269, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-customer-details.php'),
 (11270, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-downloads.php'),
 (11271, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-footer.php'),
 (11272, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-header.php'),
 (11273, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-order-details.php'),
 (11274, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-order-items.php'),
 (11275, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/email-styles.php'),
 (11276, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/admin-cancelled-order.php'),
 (11277, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/admin-failed-order.php'),
 (11278, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/admin-new-order.php'),
 (11279, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-completed-order.php'),
 (11280, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-invoice.php'),
 (11281, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-new-account.php'),
 (11282, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-note.php'),
 (11283, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-on-hold-order.php'),
 (11284, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-processing-order.php'),
 (11285, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-refunded-order.php'),
 (11286, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/customer-reset-password.php'),
 (11287, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-addresses.php'),
 (11288, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-customer-details.php'),
 (11289, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-downloads.php'),
 (11290, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-order-details.php'),
 (11291, 'wp-content/updraft/plugins-old/woocommerce/templates/emails/plain/email-order-items.php'),
 (11292, 'wp-content/updraft/plugins-old/woocommerce/templates/global/breadcrumb.php'),
 (11293, 'wp-content/updraft/plugins-old/woocommerce/templates/global/form-login.php'),
 (11294, 'wp-content/updraft/plugins-old/woocommerce/templates/global/quantity-input.php'),
 (11295, 'wp-content/updraft/plugins-old/woocommerce/templates/global/sidebar.php'),
 (11296, 'wp-content/updraft/plugins-old/woocommerce/templates/global/wrapper-end.php'),
 (11297, 'wp-content/updraft/plugins-old/woocommerce/templates/global/wrapper-start.php'),
 (11298, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/add-to-cart.php'),
 (11299, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/loop-end.php'),
 (11300, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/loop-start.php'),
 (11301, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/no-products-found.php'),
 (11302, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/orderby.php'),
 (11303, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/pagination.php'),
 (11304, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/price.php'),
 (11305, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/rating.php'),
 (11306, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/result-count.php'),
 (11307, 'wp-content/updraft/plugins-old/woocommerce/templates/loop/sale-flash.php'),
 (11308, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/dashboard.php'),
 (11309, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/downloads.php'),
 (11310, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-add-payment-method.php'),
 (11311, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-edit-account.php'),
 (11312, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-edit-address.php'),
 (11313, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-login.php'),
 (11314, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-lost-password.php'),
 (11315, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/form-reset-password.php'),
 (11316, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/lost-password-confirmation.php'),
 (11317, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-account.php'),
 (11318, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-address.php'),
 (11319, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-downloads.php'),
 (11320, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/my-orders.php'),
 (11321, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/navigation.php'),
 (11322, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/orders.php'),
 (11323, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/payment-methods.php'),
 (11324, 'wp-content/updraft/plugins-old/woocommerce/templates/myaccount/view-order.php'),
 (11325, 'wp-content/updraft/plugins-old/woocommerce/templates/notices/error.php'),
 (11326, 'wp-content/updraft/plugins-old/woocommerce/templates/notices/notice.php'),
 (11327, 'wp-content/updraft/plugins-old/woocommerce/templates/notices/success.php'),
 (11328, 'wp-content/updraft/plugins-old/woocommerce/templates/order/form-tracking.php'),
 (11329, 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-again.php'),
 (11330, 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-details-customer.php'),
 (11331, 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-details-item.php'),
 (11332, 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-details.php'),
 (11333, 'wp-content/updraft/plugins-old/woocommerce/templates/order/order-downloads.php'),
 (11334, 'wp-content/updraft/plugins-old/woocommerce/templates/order/tracking.php'),
 (11335, 'wp-content/updraft/plugins-old/woocommerce/templates/product-searchform.php'),
 (11336, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/external.php'),
 (11337, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/grouped.php'),
 (11338, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/simple.php'),
 (11339, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/variable.php'),
 (11340, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/variation-add-to-cart-button.php'),
 (11341, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/add-to-cart/variation.php'),
 (11342, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/meta.php'),
 (11343, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/photoswipe.php'),
 (11344, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/price.php'),
 (11345, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/product-attributes.php'),
 (11346, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/product-image.php'),
 (11347, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/product-thumbnails.php'),
 (11348, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/rating.php'),
 (11349, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/related.php'),
 (11350, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/review-meta.php'),
 (11351, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/review-rating.php'),
 (11352, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/review.php'),
 (11353, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/sale-flash.php'),
 (11354, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/share.php'),
 (11355, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/short-description.php'),
 (11356, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/stock.php'),
 (11357, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/tabs/additional-information.php'),
 (11358, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/tabs/description.php'),
 (11359, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/tabs/tabs.php'),
 (11360, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/title.php'),
 (11361, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product/up-sells.php'),
 (11362, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product-reviews.php'),
 (11363, 'wp-content/updraft/plugins-old/woocommerce/templates/single-product.php'),
 (11364, 'wp-content/updraft/plugins-old/woocommerce/templates/taxonomy-product_cat.php'),
 (11365, 'wp-content/updraft/plugins-old/woocommerce/templates/taxonomy-product_tag.php'),
 (11366, 'wp-content/updraft/plugins-old/woocommerce/uninstall.php'),
 (11367, 'wp-content/updraft/plugins-old/woocommerce/vendor/autoload.php'),
 (11368, 'wp-content/updraft/plugins-old/woocommerce/vendor/autoload_packages.php'),
 (11369, 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-autoloader/src/AutoloadGenerator.php'),
 (11370, 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-autoloader/src/CustomAutoloaderPlugin.php'),
 (11371, 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-autoloader/src/autoload.php'),
 (11372, 'wp-content/updraft/plugins-old/woocommerce/vendor/automattic/jetpack-constants/src/class-constants.php'),
 (11373, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/ClassLoader.php'),
 (11374, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_classmap.php'),
 (11375, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_classmap_package.php'),
 (11376, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_namespaces.php'),
 (11377, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_psr4.php'),
 (11378, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_real.php'),
 (11379, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/autoload_static.php'),
 (11380, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AglInstaller.php'),
 (11381, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AimeosInstaller.php'),
 (11382, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AnnotateCmsInstaller.php'),
 (11383, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AsgardInstaller.php'),
 (11384, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/AttogramInstaller.php'),
 (11385, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/BaseInstaller.php'),
 (11386, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/BitrixInstaller.php'),
 (11387, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/BonefishInstaller.php'),
 (11388, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CakePHPInstaller.php'),
 (11389, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ChefInstaller.php'),
 (11390, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CiviCrmInstaller.php'),
 (11391, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ClanCatsFrameworkInstaller.php'),
 (11392, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CockpitInstaller.php'),
 (11393, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CodeIgniterInstaller.php'),
 (11394, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Concrete5Installer.php'),
 (11395, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CraftInstaller.php'),
 (11396, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/CroogoInstaller.php'),
 (11397, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DecibelInstaller.php'),
 (11398, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DframeInstaller.php'),
 (11399, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DokuWikiInstaller.php'),
 (11400, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DolibarrInstaller.php'),
 (11401, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/DrupalInstaller.php'),
 (11402, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ElggInstaller.php'),
 (11403, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/EliasisInstaller.php'),
 (11404, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ExpressionEngineInstaller.php'),
 (11405, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/EzPlatformInstaller.php'),
 (11406, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/FuelInstaller.php'),
 (11407, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/FuelphpInstaller.php'),
 (11408, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/GravInstaller.php'),
 (11409, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/HuradInstaller.php'),
 (11410, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ImageCMSInstaller.php'),
 (11411, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Installer.php'),
 (11412, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ItopInstaller.php'),
 (11413, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/JoomlaInstaller.php'),
 (11414, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KanboardInstaller.php'),
 (11415, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KirbyInstaller.php'),
 (11416, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KnownInstaller.php'),
 (11417, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KodiCMSInstaller.php'),
 (11418, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/KohanaInstaller.php'),
 (11419, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LanManagementSystemInstaller.php'),
 (11420, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LaravelInstaller.php'),
 (11421, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LavaLiteInstaller.php'),
 (11422, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/LithiumInstaller.php'),
 (11423, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MODULEWorkInstaller.php'),
 (11424, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MODXEvoInstaller.php'),
 (11425, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MagentoInstaller.php'),
 (11426, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MajimaInstaller.php'),
 (11427, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MakoInstaller.php'),
 (11428, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MauticInstaller.php'),
 (11429, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MayaInstaller.php'),
 (11430, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MediaWikiInstaller.php'),
 (11431, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MicroweberInstaller.php'),
 (11432, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ModxInstaller.php'),
 (11433, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/MoodleInstaller.php'),
 (11434, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OctoberInstaller.php'),
 (11435, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OntoWikiInstaller.php'),
 (11436, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OsclassInstaller.php'),
 (11437, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/OxidInstaller.php'),
 (11438, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PPIInstaller.php'),
 (11439, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PhiftyInstaller.php'),
 (11440, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PhpBBInstaller.php'),
 (11441, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PimcoreInstaller.php'),
 (11442, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PiwikInstaller.php'),
 (11443, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PlentymarketsInstaller.php'),
 (11444, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Plugin.php'),
 (11445, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PortoInstaller.php'),
 (11446, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PrestashopInstaller.php'),
 (11447, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PuppetInstaller.php'),
 (11448, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/PxcmsInstaller.php'),
 (11449, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/RadPHPInstaller.php'),
 (11450, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ReIndexInstaller.php'),
 (11451, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Redaxo5Installer.php'),
 (11452, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/RedaxoInstaller.php'),
 (11453, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/RoundcubeInstaller.php'),
 (11454, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SMFInstaller.php'),
 (11455, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ShopwareInstaller.php'),
 (11456, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SilverStripeInstaller.php'),
 (11457, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SiteDirectInstaller.php'),
 (11458, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/SyDESInstaller.php'),
 (11459, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/Symfony1Installer.php'),
 (11460, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TYPO3CmsInstaller.php'),
 (11461, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TYPO3FlowInstaller.php'),
 (11462, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TaoInstaller.php'),
 (11463, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TheliaInstaller.php'),
 (11464, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/TuskInstaller.php'),
 (11465, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/UserFrostingInstaller.php'),
 (11466, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/VanillaInstaller.php'),
 (11467, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/VgmcpInstaller.php'),
 (11468, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/WHMCSInstaller.php'),
 (11469, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/WolfCMSInstaller.php'),
 (11470, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/WordPressInstaller.php'),
 (11471, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/YawikInstaller.php'),
 (11472, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ZendInstaller.php'),
 (11473, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/Composer/Installers/ZikulaInstaller.php'),
 (11474, 'wp-content/updraft/plugins-old/woocommerce/vendor/composer/installers/src/bootstrap.php'),
 (11475, 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/autoload.php'),
 (11476, 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Decoder.php'),
 (11477, 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/InvalidDatabaseException.php'),
 (11478, 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Metadata.php'),
 (11479, 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Util.php'),
 (11480, 'wp-content/updraft/plugins-old/woocommerce/vendor/maxmind-db/reader/src/MaxMind/Db/Reader.php'),
 (11481, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/CssInliner.php'),
 (11482, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/AbstractHtmlProcessor.php'),
 (11483, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/CssToAttributeConverter.php'),
 (11484, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/HtmlNormalizer.php'),
 (11485, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/HtmlProcessor/HtmlPruner.php'),
 (11486, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/Utilities/ArrayIntersector.php'),
 (11487, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier/Utilities/CssConcatenator.php'),
 (11488, 'wp-content/updraft/plugins-old/woocommerce/vendor/pelago/emogrifier/src/Emogrifier.php'),
 (11489, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/CssSelectorConverter.php'),
 (11490, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/ExceptionInterface.php'),
 (11491, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/ExpressionErrorException.php'),
 (11492, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/InternalErrorException.php'),
 (11493, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/ParseException.php'),
 (11494, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Exception/SyntaxErrorException.php'),
 (11495, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/AbstractNode.php'),
 (11496, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/AttributeNode.php'),
 (11497, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/ClassNode.php'),
 (11498, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/CombinedSelectorNode.php'),
 (11499, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/ElementNode.php'),
 (11500, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/FunctionNode.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(11501, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/HashNode.php'),
 (11502, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/NegationNode.php'),
 (11503, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/NodeInterface.php'),
 (11504, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/PseudoNode.php'),
 (11505, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/SelectorNode.php'),
 (11506, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Node/Specificity.php'),
 (11507, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/CommentHandler.php'),
 (11508, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/HandlerInterface.php'),
 (11509, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/HashHandler.php'),
 (11510, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/IdentifierHandler.php'),
 (11511, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/NumberHandler.php'),
 (11512, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/StringHandler.php'),
 (11513, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Handler/WhitespaceHandler.php'),
 (11514, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Parser.php'),
 (11515, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/ParserInterface.php'),
 (11516, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Reader.php'),
 (11517, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/ClassParser.php'),
 (11518, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/ElementParser.php'),
 (11519, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/EmptyStringParser.php'),
 (11520, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Shortcut/HashParser.php'),
 (11521, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Token.php'),
 (11522, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/TokenStream.php'),
 (11523, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Tokenizer/Tokenizer.php'),
 (11524, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Tokenizer/TokenizerEscaping.php'),
 (11525, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Parser/Tokenizer/TokenizerPatterns.php'),
 (11526, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/CssSelectorConverterTest.php'),
 (11527, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/AbstractNodeTest.php'),
 (11528, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/AttributeNodeTest.php'),
 (11529, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/ClassNodeTest.php'),
 (11530, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/CombinedSelectorNodeTest.php'),
 (11531, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/ElementNodeTest.php'),
 (11532, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/FunctionNodeTest.php'),
 (11533, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/HashNodeTest.php'),
 (11534, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/NegationNodeTest.php'),
 (11535, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/PseudoNodeTest.php'),
 (11536, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/SelectorNodeTest.php'),
 (11537, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Node/SpecificityTest.php'),
 (11538, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/AbstractHandlerTest.php'),
 (11539, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/CommentHandlerTest.php'),
 (11540, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/HashHandlerTest.php'),
 (11541, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/IdentifierHandlerTest.php'),
 (11542, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/NumberHandlerTest.php'),
 (11543, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/StringHandlerTest.php'),
 (11544, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Handler/WhitespaceHandlerTest.php'),
 (11545, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/ParserTest.php'),
 (11546, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/ReaderTest.php'),
 (11547, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/ClassParserTest.php'),
 (11548, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/ElementParserTest.php'),
 (11549, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/EmptyStringParserTest.php'),
 (11550, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/Shortcut/HashParserTest.php'),
 (11551, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/Parser/TokenStreamTest.php'),
 (11552, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/XPath/Fixtures/ids.html'),
 (11553, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/XPath/Fixtures/shakespear.html'),
 (11554, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/Tests/XPath/TranslatorTest.php'),
 (11555, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/AbstractExtension.php'),
 (11556, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/AttributeMatchingExtension.php'),
 (11557, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/CombinationExtension.php'),
 (11558, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/ExtensionInterface.php'),
 (11559, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/FunctionExtension.php'),
 (11560, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/HtmlExtension.php'),
 (11561, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/NodeExtension.php'),
 (11562, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Extension/PseudoClassExtension.php'),
 (11563, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/Translator.php'),
 (11564, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/TranslatorInterface.php'),
 (11565, 'wp-content/updraft/plugins-old/woocommerce/vendor/symfony/css-selector/XPath/XPathExpr.php'),
 (11566, 'wp-content/updraft/plugins-old/woocommerce/woocommerce.php'),
 (11567, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/autoload.php'),
 (11568, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/ClassLoader.php'),
 (11569, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_classmap.php'),
 (11570, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_files.php'),
 (11571, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_namespaces.php'),
 (11572, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_psr4.php'),
 (11573, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_real.php'),
 (11574, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/composer/autoload_static.php'),
 (11575, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/byte_safe_strings.php'),
 (11576, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/cast_to_int.php'),
 (11577, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/error_polyfill.php'),
 (11578, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random.php'),
 (11579, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_com_dotnet.php'),
 (11580, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_dev_urandom.php'),
 (11581, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium.php'),
 (11582, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_libsodium_legacy.php'),
 (11583, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_bytes_mcrypt.php'),
 (11584, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/random_compat/lib/random_int.php'),
 (11585, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-fast.php'),
 (11586, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/autoload-pedantic.php'),
 (11587, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/autoload.php'),
 (11588, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/constants.php'),
 (11589, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/namespaced.php'),
 (11590, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/php72compat.php'),
 (11591, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/lib/sodium_compat.php'),
 (11592, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Compat.php'),
 (11593, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/BLAKE2b.php'),
 (11594, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/Ctx.php'),
 (11595, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20/IetfCtx.php'),
 (11596, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/ChaCha20.php'),
 (11597, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Fe.php'),
 (11598, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Cached.php'),
 (11599, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P1p1.php'),
 (11600, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P2.php'),
 (11601, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/P3.php'),
 (11602, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/Ge/Precomp.php'),
 (11603, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519/H.php'),
 (11604, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Curve25519.php'),
 (11605, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Ed25519.php'),
 (11606, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HChaCha20.php'),
 (11607, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/HSalsa20.php'),
 (11608, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305/State.php'),
 (11609, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Poly1305.php'),
 (11610, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Salsa20.php'),
 (11611, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/SipHash.php'),
 (11612, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Util.php'),
 (11613, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/X25519.php'),
 (11614, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/XChaCha20.php'),
 (11615, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Core/Xsalsa20.php'),
 (11616, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/Crypto.php'),
 (11617, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/namespaced/File.php'),
 (11618, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Compat.php'),
 (11619, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/BLAKE2b.php'),
 (11620, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/Ctx.php'),
 (11621, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20/IetfCtx.php'),
 (11622, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/ChaCha20.php'),
 (11623, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Fe.php'),
 (11624, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Cached.php'),
 (11625, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P1p1.php'),
 (11626, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P2.php'),
 (11627, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/P3.php'),
 (11628, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/Ge/Precomp.php'),
 (11629, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519/H.php'),
 (11630, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Curve25519.php'),
 (11631, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Ed25519.php'),
 (11632, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HChaCha20.php'),
 (11633, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/HSalsa20.php'),
 (11634, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305/State.php'),
 (11635, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Poly1305.php'),
 (11636, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Salsa20.php'),
 (11637, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/SipHash.php'),
 (11638, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/Util.php'),
 (11639, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/X25519.php'),
 (11640, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XChaCha20.php'),
 (11641, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core/XSalsa20.php'),
 (11642, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/BLAKE2b.php'),
 (11643, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/Ctx.php'),
 (11644, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20/IetfCtx.php'),
 (11645, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/ChaCha20.php'),
 (11646, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Fe.php'),
 (11647, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Cached.php'),
 (11648, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P1p1.php'),
 (11649, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P2.php'),
 (11650, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/P3.php'),
 (11651, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/Ge/Precomp.php'),
 (11652, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519/H.php'),
 (11653, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Curve25519.php'),
 (11654, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Ed25519.php'),
 (11655, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HChaCha20.php'),
 (11656, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/HSalsa20.php'),
 (11657, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int32.php'),
 (11658, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Int64.php'),
 (11659, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305/State.php'),
 (11660, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Poly1305.php'),
 (11661, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Salsa20.php'),
 (11662, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/SipHash.php'),
 (11663, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/Util.php'),
 (11664, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/X25519.php'),
 (11665, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XChaCha20.php'),
 (11666, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Core32/XSalsa20.php'),
 (11667, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto.php'),
 (11668, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/Crypto32.php'),
 (11669, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/File.php'),
 (11670, 'wp-content/updraft/plugins-old/wordfence/crypto/vendor/paragonie/sodium_compat/src/SodiumException.php'),
 (11671, 'wp-content/updraft/plugins-old/wordfence/images/2fa-whole.svg'),
 (11672, 'wp-content/updraft/plugins-old/wordfence/images/2fa1.svg'),
 (11673, 'wp-content/updraft/plugins-old/wordfence/images/2fa2.svg'),
 (11674, 'wp-content/updraft/plugins-old/wordfence/images/blocking.svg'),
 (11675, 'wp-content/updraft/plugins-old/wordfence/images/options.svg'),
 (11676, 'wp-content/updraft/plugins-old/wordfence/images/ratelimiting.svg'),
 (11677, 'wp-content/updraft/plugins-old/wordfence/images/support.svg'),
 (11678, 'wp-content/updraft/plugins-old/wordfence/images/tools.svg'),
 (11679, 'wp-content/updraft/plugins-old/wordfence/images/wf-central-logo.svg'),
 (11680, 'wp-content/updraft/plugins-old/wordfence/images/wf-horizontal.svg'),
 (11681, 'wp-content/updraft/plugins-old/wordfence/images/wordfence-logo.svg'),
 (11682, 'wp-content/updraft/plugins-old/wordfence/index.php'),
 (11683, 'wp-content/updraft/plugins-old/wordfence/js/Chart.bundle.min.1581523568.js'),
 (11684, 'wp-content/updraft/plugins-old/wordfence/js/admin.1581523568.js'),
 (11685, 'wp-content/updraft/plugins-old/wordfence/js/admin.ajaxWatcher.1581523568.js'),
 (11686, 'wp-content/updraft/plugins-old/wordfence/js/admin.liveTraffic.1581523568.js'),
 (11687, 'wp-content/updraft/plugins-old/wordfence/js/date.1581523568.js'),
 (11688, 'wp-content/updraft/plugins-old/wordfence/js/jquery-ui-timepicker-addon.1581523568.js'),
 (11689, 'wp-content/updraft/plugins-old/wordfence/js/jquery.colorbox-min.1581523568.js'),
 (11690, 'wp-content/updraft/plugins-old/wordfence/js/jquery.colorbox.1581523568.js'),
 (11691, 'wp-content/updraft/plugins-old/wordfence/js/jquery.dataTables.min.1581523568.js'),
 (11692, 'wp-content/updraft/plugins-old/wordfence/js/jquery.qrcode.min.1581523568.js'),
 (11693, 'wp-content/updraft/plugins-old/wordfence/js/jquery.tmpl.min.1581523568.js'),
 (11694, 'wp-content/updraft/plugins-old/wordfence/js/jquery.tools.min.1581523568.js'),
 (11695, 'wp-content/updraft/plugins-old/wordfence/js/knockout-3.3.0.1581523568.js'),
 (11696, 'wp-content/updraft/plugins-old/wordfence/js/wfdashboard.1581523568.js'),
 (11697, 'wp-content/updraft/plugins-old/wordfence/js/wfdropdown.1581523568.js'),
 (11698, 'wp-content/updraft/plugins-old/wordfence/js/wfglobal.1581523568.js'),
 (11699, 'wp-content/updraft/plugins-old/wordfence/js/wfpopover.1581523568.js'),
 (11700, 'wp-content/updraft/plugins-old/wordfence/js/wfselect2.min.1581523568.js'),
 (11701, 'wp-content/updraft/plugins-old/wordfence/lib/Diff/Renderer/Abstract.php'),
 (11702, 'wp-content/updraft/plugins-old/wordfence/lib/Diff/Renderer/Html/Array.php'),
 (11703, 'wp-content/updraft/plugins-old/wordfence/lib/Diff/Renderer/Html/SideBySide.php'),
 (11704, 'wp-content/updraft/plugins-old/wordfence/lib/Diff/SequenceMatcher.php'),
 (11705, 'wp-content/updraft/plugins-old/wordfence/lib/Diff.php'),
 (11706, 'wp-content/updraft/plugins-old/wordfence/lib/IPTraf.php'),
 (11707, 'wp-content/updraft/plugins-old/wordfence/lib/IPTrafList.php'),
 (11708, 'wp-content/updraft/plugins-old/wordfence/lib/WFLSPHP52Compatability.php'),
 (11709, 'wp-content/updraft/plugins-old/wordfence/lib/compat.php'),
 (11710, 'wp-content/updraft/plugins-old/wordfence/lib/conntest.php'),
 (11711, 'wp-content/updraft/plugins-old/wordfence/lib/cronview.php'),
 (11712, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_content_countries.php'),
 (11713, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_content_ips.php'),
 (11714, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_content_logins.php'),
 (11715, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_countries.php'),
 (11716, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_ips.php'),
 (11717, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_localattacks.php'),
 (11718, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_logins.php'),
 (11719, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_networkattacks.php'),
 (11720, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_notifications.php'),
 (11721, 'wp-content/updraft/plugins-old/wordfence/lib/dashboard/widget_tdf.php'),
 (11722, 'wp-content/updraft/plugins-old/wordfence/lib/dbview.php'),
 (11723, 'wp-content/updraft/plugins-old/wordfence/lib/diffResult.php'),
 (11724, 'wp-content/updraft/plugins-old/wordfence/lib/email_genericAlert.php'),
 (11725, 'wp-content/updraft/plugins-old/wordfence/lib/email_newIssues.php'),
 (11726, 'wp-content/updraft/plugins-old/wordfence/lib/email_unlockRequest.php'),
 (11727, 'wp-content/updraft/plugins-old/wordfence/lib/email_unsubscribeRequest.php'),
 (11728, 'wp-content/updraft/plugins-old/wordfence/lib/flags.php'),
 (11729, 'wp-content/updraft/plugins-old/wordfence/lib/live_activity.php'),
 (11730, 'wp-content/updraft/plugins-old/wordfence/lib/menu_dashboard.php'),
 (11731, 'wp-content/updraft/plugins-old/wordfence/lib/menu_dashboard_options.php'),
 (11732, 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall.php'),
 (11733, 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_blocking.php'),
 (11734, 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_blocking_options.php'),
 (11735, 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_waf.php'),
 (11736, 'wp-content/updraft/plugins-old/wordfence/lib/menu_firewall_waf_options.php'),
 (11737, 'wp-content/updraft/plugins-old/wordfence/lib/menu_options.php'),
 (11738, 'wp-content/updraft/plugins-old/wordfence/lib/menu_scanner.php'),
 (11739, 'wp-content/updraft/plugins-old/wordfence/lib/menu_scanner_credentials.php'),
 (11740, 'wp-content/updraft/plugins-old/wordfence/lib/menu_scanner_options.php'),
 (11741, 'wp-content/updraft/plugins-old/wordfence/lib/menu_support.php'),
 (11742, 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools.php'),
 (11743, 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_diagnostic.php'),
 (11744, 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_importExport.php'),
 (11745, 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_livetraffic.php'),
 (11746, 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_twoFactor.php'),
 (11747, 'wp-content/updraft/plugins-old/wordfence/lib/menu_tools_whois.php'),
 (11748, 'wp-content/updraft/plugins-old/wordfence/lib/menu_wordfence_central.php'),
 (11749, 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTAuthenticationController.php'),
 (11750, 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTBaseController.php'),
 (11751, 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTConfigController.php'),
 (11752, 'wp-content/updraft/plugins-old/wordfence/lib/rest-api/wfRESTScanController.php'),
 (11753, 'wp-content/updraft/plugins-old/wordfence/lib/sysinfo.php'),
 (11754, 'wp-content/updraft/plugins-old/wordfence/lib/unknownFiles.php'),
 (11755, 'wp-content/updraft/plugins-old/wordfence/lib/viewFullActivityLog.php'),
 (11756, 'wp-content/updraft/plugins-old/wordfence/lib/wf503.php'),
 (11757, 'wp-content/updraft/plugins-old/wordfence/lib/wfAPI.php'),
 (11758, 'wp-content/updraft/plugins-old/wordfence/lib/wfActivityReport.php'),
 (11759, 'wp-content/updraft/plugins-old/wordfence/lib/wfAdminNoticeQueue.php'),
 (11760, 'wp-content/updraft/plugins-old/wordfence/lib/wfAlerts.php'),
 (11761, 'wp-content/updraft/plugins-old/wordfence/lib/wfArray.php'),
 (11762, 'wp-content/updraft/plugins-old/wordfence/lib/wfBrowscap.php'),
 (11763, 'wp-content/updraft/plugins-old/wordfence/lib/wfBrowscapCache.php'),
 (11764, 'wp-content/updraft/plugins-old/wordfence/lib/wfBulkCountries.php'),
 (11765, 'wp-content/updraft/plugins-old/wordfence/lib/wfCache.php'),
 (11766, 'wp-content/updraft/plugins-old/wordfence/lib/wfCentralAPI.php'),
 (11767, 'wp-content/updraft/plugins-old/wordfence/lib/wfConfig.php'),
 (11768, 'wp-content/updraft/plugins-old/wordfence/lib/wfCrawl.php'),
 (11769, 'wp-content/updraft/plugins-old/wordfence/lib/wfCredentialsController.php'),
 (11770, 'wp-content/updraft/plugins-old/wordfence/lib/wfCrypt.php'),
 (11771, 'wp-content/updraft/plugins-old/wordfence/lib/wfDB.php'),
 (11772, 'wp-content/updraft/plugins-old/wordfence/lib/wfDashboard.php'),
 (11773, 'wp-content/updraft/plugins-old/wordfence/lib/wfDateLocalization.php'),
 (11774, 'wp-content/updraft/plugins-old/wordfence/lib/wfDiagnostic.php'),
 (11775, 'wp-content/updraft/plugins-old/wordfence/lib/wfDict.php'),
 (11776, 'wp-content/updraft/plugins-old/wordfence/lib/wfDirectoryIterator.php'),
 (11777, 'wp-content/updraft/plugins-old/wordfence/lib/wfHelperBin.php'),
 (11778, 'wp-content/updraft/plugins-old/wordfence/lib/wfHelperString.php'),
 (11779, 'wp-content/updraft/plugins-old/wordfence/lib/wfIPWhitelist.php'),
 (11780, 'wp-content/updraft/plugins-old/wordfence/lib/wfImportExportController.php'),
 (11781, 'wp-content/updraft/plugins-old/wordfence/lib/wfIssues.php'),
 (11782, 'wp-content/updraft/plugins-old/wordfence/lib/wfJWT.php'),
 (11783, 'wp-content/updraft/plugins-old/wordfence/lib/wfLockedOut.php'),
 (11784, 'wp-content/updraft/plugins-old/wordfence/lib/wfLog.php'),
 (11785, 'wp-content/updraft/plugins-old/wordfence/lib/wfMD5BloomFilter.php'),
 (11786, 'wp-content/updraft/plugins-old/wordfence/lib/wfModuleController.php'),
 (11787, 'wp-content/updraft/plugins-old/wordfence/lib/wfNotification.php'),
 (11788, 'wp-content/updraft/plugins-old/wordfence/lib/wfOnboardingController.php'),
 (11789, 'wp-content/updraft/plugins-old/wordfence/lib/wfPersistenceController.php'),
 (11790, 'wp-content/updraft/plugins-old/wordfence/lib/wfRESTAPI.php'),
 (11791, 'wp-content/updraft/plugins-old/wordfence/lib/wfScan.php'),
 (11792, 'wp-content/updraft/plugins-old/wordfence/lib/wfScanEngine.php'),
 (11793, 'wp-content/updraft/plugins-old/wordfence/lib/wfSchema.php'),
 (11794, 'wp-content/updraft/plugins-old/wordfence/lib/wfStyle.php'),
 (11795, 'wp-content/updraft/plugins-old/wordfence/lib/wfSupportController.php'),
 (11796, 'wp-content/updraft/plugins-old/wordfence/lib/wfUnlockMsg.php'),
 (11797, 'wp-content/updraft/plugins-old/wordfence/lib/wfUpdateCheck.php'),
 (11798, 'wp-content/updraft/plugins-old/wordfence/lib/wfUtils.php'),
 (11799, 'wp-content/updraft/plugins-old/wordfence/lib/wfVersionCheckController.php'),
 (11800, 'wp-content/updraft/plugins-old/wordfence/lib/wfView.php'),
 (11801, 'wp-content/updraft/plugins-old/wordfence/lib/wfViewResult.php'),
 (11802, 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceClass.php'),
 (11803, 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceConstants.php'),
 (11804, 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceHash.php'),
 (11805, 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceScanner.php'),
 (11806, 'wp-content/updraft/plugins-old/wordfence/lib/wordfenceURLHoover.php'),
 (11807, 'wp-content/updraft/plugins-old/wordfence/models/block/wfBlock.php'),
 (11808, 'wp-content/updraft/plugins-old/wordfence/models/block/wfRateLimit.php'),
 (11809, 'wp-content/updraft/plugins-old/wordfence/models/common/wfGeoIP2.php'),
 (11810, 'wp-content/updraft/plugins-old/wordfence/models/common/wfTab.php'),
 (11811, 'wp-content/updraft/plugins-old/wordfence/models/firewall/wfFirewall.php'),
 (11812, 'wp-content/updraft/plugins-old/wordfence/models/page/wfPage.php'),
 (11813, 'wp-content/updraft/plugins-old/wordfence/models/scanner/wfScanner.php'),
 (11814, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/ajax.php'),
 (11815, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/captcha.php'),
 (11816, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/cron.php'),
 (11817, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/db.php'),
 (11818, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/notices.php'),
 (11819, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/permissions.php'),
 (11820, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/settings.php'),
 (11821, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/support.php'),
 (11822, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/time.php'),
 (11823, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/totp.php'),
 (11824, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/users.php'),
 (11825, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/whitelist.php'),
 (11826, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/controller/wordfencels.php'),
 (11827, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/asset.php'),
 (11828, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/compat.php'),
 (11829, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto/base2n.php'),
 (11830, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto/jwt.php'),
 (11831, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto/symmetric.php'),
 (11832, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/crypto.php'),
 (11833, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/ip.php'),
 (11834, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/notice.php'),
 (11835, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/request.php'),
 (11836, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/settings/db.php'),
 (11837, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/settings/wpoptions.php'),
 (11838, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/settings.php'),
 (11839, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/text/html.php'),
 (11840, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/text/javascript.php'),
 (11841, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/tokenbucket.php'),
 (11842, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/view/tab.php'),
 (11843, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/view/title.php'),
 (11844, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/classes/model/view.php'),
 (11845, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/img/header.svg'),
 (11846, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/img/menu.svg'),
 (11847, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/admin-global.1581523568.js'),
 (11848, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/admin.1581523568.js'),
 (11849, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery-ui-timepicker-addon.1581523568.js'),
 (11850, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.colorbox.1581523568.js'),
 (11851, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.colorbox.min.1581523568.js'),
 (11852, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.qrcode.min.1581523568.js'),
 (11853, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/jquery.tmpl.min.1581523568.js'),
 (11854, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/js/login.1581523568.js'),
 (11855, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/common/modal-prompt.php'),
 (11856, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/email/login-verification.php'),
 (11857, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/activate.php'),
 (11858, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/code.php'),
 (11859, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/deactivate.php'),
 (11860, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/manage/regenerate.php'),
 (11861, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/onboarding/standalone-header.php'),
 (11862, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-captcha-threshold.php'),
 (11863, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-captcha.php'),
 (11864, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-ip-source.php'),
 (11865, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-label.php'),
 (11866, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-require-2fa.php'),
 (11867, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-select.php'),
 (11868, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-switch.php'),
 (11869, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-text.php'),
 (11870, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-textarea.php'),
 (11871, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-boolean-switch.php'),
 (11872, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-multiple.php'),
 (11873, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-segmented.php'),
 (11874, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-select.php'),
 (11875, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-sub.php'),
 (11876, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled-textarea.php'),
 (11877, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-toggled.php'),
 (11878, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/options/option-token.php'),
 (11879, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/manage.php'),
 (11880, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/page.php'),
 (11881, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/section-title.php'),
 (11882, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/settings.php'),
 (11883, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/page/tabbar.php'),
 (11884, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/settings/options.php'),
 (11885, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/views/settings/user-stats.php'),
 (11886, 'wp-content/updraft/plugins-old/wordfence/modules/login-security/wordfence-login-security.php'),
 (11887, 'wp-content/updraft/plugins-old/wordfence/vendor/autoload.php'),
 (11888, 'wp-content/updraft/plugins-old/wordfence/vendor/composer/ClassLoader.php'),
 (11889, 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_classmap.php'),
 (11890, 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_namespaces.php'),
 (11891, 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_psr4.php'),
 (11892, 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_real.php'),
 (11893, 'wp-content/updraft/plugins-old/wordfence/vendor/composer/autoload_static.php'),
 (11894, 'wp-content/updraft/plugins-old/wordfence/vendor/composer/ca-bundle/src/CaBundle.php'),
 (11895, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Database/Reader.php'),
 (11896, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/AddressNotFoundException.php'),
 (11897, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/AuthenticationException.php'),
 (11898, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/GeoIp2Exception.php'),
 (11899, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/HttpException.php'),
 (11900, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/InvalidRequestException.php'),
 (11901, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Exception/OutOfQueriesException.php'),
 (11902, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/AbstractModel.php'),
 (11903, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/AnonymousIp.php'),
 (11904, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Asn.php'),
 (11905, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/City.php'),
 (11906, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/ConnectionType.php'),
 (11907, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Country.php'),
 (11908, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Domain.php'),
 (11909, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Enterprise.php'),
 (11910, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Insights.php'),
 (11911, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Model/Isp.php'),
 (11912, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/ProviderInterface.php'),
 (11913, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/AbstractPlaceRecord.php'),
 (11914, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/AbstractRecord.php'),
 (11915, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/City.php'),
 (11916, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Continent.php'),
 (11917, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Country.php'),
 (11918, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Location.php'),
 (11919, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/MaxMind.php'),
 (11920, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Postal.php'),
 (11921, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/RepresentedCountry.php'),
 (11922, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Subdivision.php'),
 (11923, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/Record/Traits.php'),
 (11924, 'wp-content/updraft/plugins-old/wordfence/vendor/geoip2/geoip2/src/WebService/Client.php'),
 (11925, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/AuthenticationException.php'),
 (11926, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/HttpException.php'),
 (11927, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/InsufficientFundsException.php'),
 (11928, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidInputException.php'),
 (11929, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/InvalidRequestException.php'),
 (11930, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/IpAddressNotFoundException.php'),
 (11931, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/PermissionRequiredException.php'),
 (11932, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/Exception/WebServiceException.php'),
 (11933, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Client.php'),
 (11934, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/CurlRequest.php'),
 (11935, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/Request.php'),
 (11936, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind/web-service-common/src/WebService/Http/RequestFactory.php'),
 (11937, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/autoload.php'),
 (11938, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Decoder.php'),
 (11939, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/InvalidDatabaseException.php'),
 (11940, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Metadata.php'),
 (11941, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Util.php'),
 (11942, 'wp-content/updraft/plugins-old/wordfence/vendor/maxmind-db/reader/src/MaxMind/Db/Reader.php'),
 (11943, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/init.php'),
 (11944, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/config.php'),
 (11945, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/http.php'),
 (11946, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/json.php'),
 (11947, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/parser/lexer.php'),
 (11948, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/parser/parser.php'),
 (11949, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/parser/sqli.php'),
 (11950, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/request.php'),
 (11951, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/rules.php'),
 (11952, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/storage/file.php'),
 (11953, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/storage/mysql.php'),
 (11954, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/storage.php'),
 (11955, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/utils.php'),
 (11956, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/view.php'),
 (11957, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/waf.php'),
 (11958, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/lib/xmlrpc.php'),
 (11959, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/403-blacklist.php'),
 (11960, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/403-roadblock.php'),
 (11961, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/403.php'),
 (11962, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/503-lockout.php'),
 (11963, 'wp-content/updraft/plugins-old/wordfence/vendor/wordfence/wf-waf/src/views/503.php'),
 (11964, 'wp-content/updraft/plugins-old/wordfence/views/blocking/block-list.php'),
 (11965, 'wp-content/updraft/plugins-old/wordfence/views/blocking/blocking-create.php'),
 (11966, 'wp-content/updraft/plugins-old/wordfence/views/blocking/blocking-status.php'),
 (11967, 'wp-content/updraft/plugins-old/wordfence/views/blocking/country-block-map.php'),
 (11968, 'wp-content/updraft/plugins-old/wordfence/views/blocking/country-modal.php'),
 (11969, 'wp-content/updraft/plugins-old/wordfence/views/blocking/option-bypass-cookie.php'),
 (11970, 'wp-content/updraft/plugins-old/wordfence/views/blocking/option-bypass-redirect.php'),
 (11971, 'wp-content/updraft/plugins-old/wordfence/views/blocking/options-group-advanced-country.php'),
 (11972, 'wp-content/updraft/plugins-old/wordfence/views/common/block-navigation-option.php'),
 (11973, 'wp-content/updraft/plugins-old/wordfence/views/common/indeterminate-progress.php'),
 (11974, 'wp-content/updraft/plugins-old/wordfence/views/common/license.php'),
 (11975, 'wp-content/updraft/plugins-old/wordfence/views/common/modal-prompt.php'),
 (11976, 'wp-content/updraft/plugins-old/wordfence/views/common/page-fixed-tabbar.php'),
 (11977, 'wp-content/updraft/plugins-old/wordfence/views/common/page-help.php'),
 (11978, 'wp-content/updraft/plugins-old/wordfence/views/common/page-tabbar.php'),
 (11979, 'wp-content/updraft/plugins-old/wordfence/views/common/page-title.php'),
 (11980, 'wp-content/updraft/plugins-old/wordfence/views/common/section-subtitle.php'),
 (11981, 'wp-content/updraft/plugins-old/wordfence/views/common/section-title.php'),
 (11982, 'wp-content/updraft/plugins-old/wordfence/views/common/status-circular.php'),
 (11983, 'wp-content/updraft/plugins-old/wordfence/views/common/status-critical.php'),
 (11984, 'wp-content/updraft/plugins-old/wordfence/views/common/status-detail.php'),
 (11985, 'wp-content/updraft/plugins-old/wordfence/views/common/status-tooltip.php'),
 (11986, 'wp-content/updraft/plugins-old/wordfence/views/common/status-warning.php'),
 (11987, 'wp-content/updraft/plugins-old/wordfence/views/common/unsubscribe.php'),
 (11988, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/global-status.php'),
 (11989, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/option-howgetips.php'),
 (11990, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-alert.php'),
 (11991, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-dashboard.php'),
 (11992, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-email-summary.php'),
 (11993, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-general.php'),
 (11994, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-import.php'),
 (11995, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-license.php'),
 (11996, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/options-group-view-customization.php'),
 (11997, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/status-payment-expiring.php'),
 (11998, 'wp-content/updraft/plugins-old/wordfence/views/dashboard/status-renewing.php'),
 (11999, 'wp-content/updraft/plugins-old/wordfence/views/gdpr/banner.php'),
 (12000, 'wp-content/updraft/plugins-old/wordfence/views/gdpr/disabled-overlay.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(12001, 'wp-content/updraft/plugins-old/wordfence/views/onboarding/banner.php'),
 (12002, 'wp-content/updraft/plugins-old/wordfence/views/onboarding/disabled-overlay.php'),
 (12003, 'wp-content/updraft/plugins-old/wordfence/views/onboarding/fresh-install.php'),
 (12004, 'wp-content/updraft/plugins-old/wordfence/views/onboarding/modal-final-attempt.php'),
 (12005, 'wp-content/updraft/plugins-old/wordfence/views/onboarding/overlay.php'),
 (12006, 'wp-content/updraft/plugins-old/wordfence/views/onboarding/plugin-header.php'),
 (12007, 'wp-content/updraft/plugins-old/wordfence/views/onboarding/tour-overlay.php'),
 (12008, 'wp-content/updraft/plugins-old/wordfence/views/options/block-all-options-controls.php'),
 (12009, 'wp-content/updraft/plugins-old/wordfence/views/options/block-controls.php'),
 (12010, 'wp-content/updraft/plugins-old/wordfence/views/options/option-label.php'),
 (12011, 'wp-content/updraft/plugins-old/wordfence/views/options/option-select.php'),
 (12012, 'wp-content/updraft/plugins-old/wordfence/views/options/option-switch.php'),
 (12013, 'wp-content/updraft/plugins-old/wordfence/views/options/option-text.php'),
 (12014, 'wp-content/updraft/plugins-old/wordfence/views/options/option-textarea.php'),
 (12015, 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-boolean-switch.php'),
 (12016, 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-multiple.php'),
 (12017, 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-segmented.php'),
 (12018, 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-select.php'),
 (12019, 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-sub.php'),
 (12020, 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled-textarea.php'),
 (12021, 'wp-content/updraft/plugins-old/wordfence/views/options/option-toggled.php'),
 (12022, 'wp-content/updraft/plugins-old/wordfence/views/options/option-token.php'),
 (12023, 'wp-content/updraft/plugins-old/wordfence/views/options/options-title.php'),
 (12024, 'wp-content/updraft/plugins-old/wordfence/views/reports/activity-report-email-inline.php'),
 (12025, 'wp-content/updraft/plugins-old/wordfence/views/reports/activity-report.php'),
 (12026, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-base.php'),
 (12027, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-checkGSB.php'),
 (12028, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-checkHowGetIPs.php'),
 (12029, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-checkSpamIP.php'),
 (12030, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-commentBadURL.php'),
 (12031, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-configReadable.php'),
 (12032, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-edit-comment.php'),
 (12033, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-edit-post.php'),
 (12034, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-edit-user.php'),
 (12035, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-hide-file.php'),
 (12036, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-ignore.php'),
 (12037, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-repair.php'),
 (12038, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-control-show-details.php'),
 (12039, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-coreUnknown.php'),
 (12040, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-database.php'),
 (12041, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-diskSpace.php'),
 (12042, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-easyPassword.php'),
 (12043, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-file.php'),
 (12044, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-geoipSupport.php'),
 (12045, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-knownfile.php'),
 (12046, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-optionBadURL.php'),
 (12047, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-postBadTitle.php'),
 (12048, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-postBadURL.php'),
 (12049, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-publiclyAccessible.php'),
 (12050, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-skippedPaths.php'),
 (12051, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-spamvertizeCheck.php'),
 (12052, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-suspiciousAdminUsers.php'),
 (12053, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-timelimit.php'),
 (12054, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wafStatus.php'),
 (12055, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginAbandoned.php'),
 (12056, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginRemoved.php'),
 (12057, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginUpgrade.php'),
 (12058, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfPluginVulnerable.php'),
 (12059, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfThemeUpgrade.php'),
 (12060, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wfUpgrade.php'),
 (12061, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wpscan_directoryList.php'),
 (12062, 'wp-content/updraft/plugins-old/wordfence/views/scanner/issue-wpscan_fullPathDiscl.php'),
 (12063, 'wp-content/updraft/plugins-old/wordfence/views/scanner/no-issues.php'),
 (12064, 'wp-content/updraft/plugins-old/wordfence/views/scanner/option-scan-signatures.php'),
 (12065, 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-advanced.php'),
 (12066, 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-basic.php'),
 (12067, 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-general.php'),
 (12068, 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-performance.php'),
 (12069, 'wp-content/updraft/plugins-old/wordfence/views/scanner/options-group-scan-schedule.php'),
 (12070, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-failed.php'),
 (12071, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-progress-detailed.php'),
 (12072, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-progress-element.php'),
 (12073, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-progress.php'),
 (12074, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-results.php'),
 (12075, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-scheduling.php'),
 (12076, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-starter.php'),
 (12077, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scan-type.php'),
 (12078, 'wp-content/updraft/plugins-old/wordfence/views/scanner/scanner-status.php'),
 (12079, 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning-beta-sigs.php'),
 (12080, 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning-bottom.php'),
 (12081, 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning-high-sense.php'),
 (12082, 'wp-content/updraft/plugins-old/wordfence/views/scanner/site-cleaning.php'),
 (12083, 'wp-content/updraft/plugins-old/wordfence/views/tools/options-group-2fa.php'),
 (12084, 'wp-content/updraft/plugins-old/wordfence/views/tools/options-group-live-traffic.php'),
 (12085, 'wp-content/updraft/plugins-old/wordfence/views/tours/login-security.php'),
 (12086, 'wp-content/updraft/plugins-old/wordfence/views/waf/debug.php'),
 (12087, 'wp-content/updraft/plugins-old/wordfence/views/waf/firewall-status.php'),
 (12088, 'wp-content/updraft/plugins-old/wordfence/views/waf/option-rate-limit.php'),
 (12089, 'wp-content/updraft/plugins-old/wordfence/views/waf/option-rules.php'),
 (12090, 'wp-content/updraft/plugins-old/wordfence/views/waf/option-whitelist.php'),
 (12091, 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-advanced-firewall.php'),
 (12092, 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-basic-firewall.php'),
 (12093, 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-brute-force.php'),
 (12094, 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-rate-limiting.php'),
 (12095, 'wp-content/updraft/plugins-old/wordfence/views/waf/options-group-whitelisted.php'),
 (12096, 'wp-content/updraft/plugins-old/wordfence/views/waf/status-tooltip-learning-mode.php'),
 (12097, 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-install-manual.php'),
 (12098, 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-install-success.php'),
 (12099, 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-install.php'),
 (12100, 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-modal-wrapper.php'),
 (12101, 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-uninstall-success.php'),
 (12102, 'wp-content/updraft/plugins-old/wordfence/views/waf/waf-uninstall.php'),
 (12103, 'wp-content/updraft/plugins-old/wordfence/waf/bootstrap.php'),
 (12104, 'wp-content/updraft/plugins-old/wordfence/waf/wfWAFGeoIP2.php'),
 (12105, 'wp-content/updraft/plugins-old/wordfence/waf/wfWAFIPBlocksController.php'),
 (12106, 'wp-content/updraft/plugins-old/wordfence/waf/wfWAFUserIPRange.php'),
 (12107, 'wp-content/updraft/plugins-old/wordfence/wordfence.php'),
 (12108, 'wp-content/updraft/plugins-old/wp-cerber/admin/cerber-settings.php'),
 (12109, 'wp-content/updraft/plugins-old/wp-cerber/assets/admin.js'),
 (12110, 'wp-content/updraft/plugins-old/wp-cerber/assets/icons/fonts/crb.svg'),
 (12111, 'wp-content/updraft/plugins-old/wp-cerber/assets/magnific/jquery.magnific-popup.min.js'),
 (12112, 'wp-content/updraft/plugins-old/wp-cerber/assets/multi/multi.js'),
 (12113, 'wp-content/updraft/plugins-old/wp-cerber/assets/multi/multi.min.js'),
 (12114, 'wp-content/updraft/plugins-old/wp-cerber/assets/scanner.js'),
 (12115, 'wp-content/updraft/plugins-old/wp-cerber/assets/select2/dist/js/select2.min.js'),
 (12116, 'wp-content/updraft/plugins-old/wp-cerber/assets/sh/scripts/shBrushPhp.js'),
 (12117, 'wp-content/updraft/plugins-old/wp-cerber/assets/sh/scripts/shCore.js'),
 (12118, 'wp-content/updraft/plugins-old/wp-cerber/assets/tpicker/jquery.timepicker.min.js'),
 (12119, 'wp-content/updraft/plugins-old/wp-cerber/assets/wp-admin.js'),
 (12120, 'wp-content/updraft/plugins-old/wp-cerber/cerber-2fa.php'),
 (12121, 'wp-content/updraft/plugins-old/wp-cerber/cerber-addons.php'),
 (12122, 'wp-content/updraft/plugins-old/wp-cerber/cerber-ds.php'),
 (12123, 'wp-content/updraft/plugins-old/wp-cerber/cerber-lab.php'),
 (12124, 'wp-content/updraft/plugins-old/wp-cerber/cerber-load.php'),
 (12125, 'wp-content/updraft/plugins-old/wp-cerber/cerber-maintenance.php'),
 (12126, 'wp-content/updraft/plugins-old/wp-cerber/cerber-news.php'),
 (12127, 'wp-content/updraft/plugins-old/wp-cerber/cerber-pluggable.php'),
 (12128, 'wp-content/updraft/plugins-old/wp-cerber/cerber-request.php'),
 (12129, 'wp-content/updraft/plugins-old/wp-cerber/cerber-scanner.php'),
 (12130, 'wp-content/updraft/plugins-old/wp-cerber/cerber-tools.php'),
 (12131, 'wp-content/updraft/plugins-old/wp-cerber/cerber-users.php'),
 (12132, 'wp-content/updraft/plugins-old/wp-cerber/common.php'),
 (12133, 'wp-content/updraft/plugins-old/wp-cerber/dashboard.php'),
 (12134, 'wp-content/updraft/plugins-old/wp-cerber/index.php'),
 (12135, 'wp-content/updraft/plugins-old/wp-cerber/jetflow.php'),
 (12136, 'wp-content/updraft/plugins-old/wp-cerber/modules/aaa-wp-cerber.php'),
 (12137, 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-nexus-master.php'),
 (12138, 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-nexus-slave.php'),
 (12139, 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-nexus.php'),
 (12140, 'wp-content/updraft/plugins-old/wp-cerber/nexus/cerber-slave-list.php'),
 (12141, 'wp-content/updraft/plugins-old/wp-cerber/ripe.php'),
 (12142, 'wp-content/updraft/plugins-old/wp-cerber/settings.php'),
 (12143, 'wp-content/updraft/plugins-old/wp-cerber/whois.php'),
 (12144, 'wp-content/updraft/plugins-old/wp-cerber/wp-cerber.php'),
 (12145, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith-infs.js'),
 (12146, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith-infs.min.js'),
 (12147, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith.infinitescroll.js'),
 (12148, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/assets/js/yith.infinitescroll.min.js'),
 (12149, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/class.yith-infs-admin.php'),
 (12150, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/class.yith-infs-frontend.php'),
 (12151, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/class.yith-infs.php'),
 (12152, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/includes/functions.yith-infs.php'),
 (12153, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/init.php'),
 (12154, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/fonts/yith-icon.svg'),
 (12155, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/images/arrow_down.svg'),
 (12156, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/images/yith-icon.svg'),
 (12157, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/codemirror/codemirror.js'),
 (12158, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/codemirror/javascript.js'),
 (12159, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/how-to.js'),
 (12160, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/how-to.min.js'),
 (12161, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/javascript-md5/md5.min.js'),
 (12162, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/jquery.colorbox.js'),
 (12163, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/jquery.colorbox.min.js'),
 (12164, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/metabox.js'),
 (12165, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/metabox.min.js'),
 (12166, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/multisite-updater.js'),
 (12167, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/multisite-updater.min.js'),
 (12168, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/wp-pages.js'),
 (12169, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/wp-pages.min.js'),
 (12170, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-cpt-unlimited.js'),
 (12171, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-cpt-unlimited.min.js'),
 (12172, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-plugin-panel.js'),
 (12173, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-plugin-panel.min.js'),
 (12174, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-wp-pointer.js'),
 (12175, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yit-wp-pointer.min.js'),
 (12176, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-colorpicker.min.js'),
 (12177, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-dashboard.js'),
 (12178, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-dashboard.min.js'),
 (12179, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select-wc-2.6.js'),
 (12180, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select-wc-2.6.min.js'),
 (12181, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select.js'),
 (12182, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-enhanced-select.min.js'),
 (12183, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-fields.js'),
 (12184, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-fields.min.js'),
 (12185, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-gutenberg.js'),
 (12186, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-gutenberg.min.js'),
 (12187, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-promo.js'),
 (12188, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-promo.min.js'),
 (12189, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-system-info.js'),
 (12190, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-system-info.min.js'),
 (12191, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-update-plugins.js'),
 (12192, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/assets/js/yith-update-plugins.min.js'),
 (12193, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/init.php'),
 (12194, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/privacy/yit-privacy-plugin-abstract.php'),
 (12195, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/privacy/yit-privacy.php'),
 (12196, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/promo/yith-promo.php'),
 (12197, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-ajax.php'),
 (12198, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-assets.php'),
 (12199, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-cpt-unlimited.php'),
 (12200, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-debug.php'),
 (12201, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-icons.php'),
 (12202, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-metabox.php'),
 (12203, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-common.php'),
 (12204, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-gradients.php'),
 (12205, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-licence.php'),
 (12206, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-panel-wc.php'),
 (12207, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-panel.php'),
 (12208, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-plugin-subpanel.php'),
 (12209, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-pointers.php'),
 (12210, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-theme-licence.php'),
 (12211, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-upgrade.php'),
 (12212, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yit-video.php'),
 (12213, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yith-dashboard.php'),
 (12214, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yith-gutenberg.php'),
 (12215, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/lib/yith-system-status.php'),
 (12216, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-customers.php'),
 (12217, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-posts.php'),
 (12218, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-products.php'),
 (12219, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/ajax-terms.php'),
 (12220, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/buttons.php'),
 (12221, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/checkbox-array.php'),
 (12222, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/checkbox.php'),
 (12223, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/colorpicker.php'),
 (12224, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/country-select.php'),
 (12225, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/custom.php'),
 (12226, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/customtabs.php'),
 (12227, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/date-format.php'),
 (12228, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/datepicker.php'),
 (12229, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/hidden.php'),
 (12230, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/html.php'),
 (12231, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/icons.php'),
 (12232, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/image-gallery.php'),
 (12233, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/list-table.php'),
 (12234, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/multi-colorpicker.php'),
 (12235, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/multi-select.php'),
 (12236, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/number.php'),
 (12237, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/onoff.php'),
 (12238, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/password.php'),
 (12239, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/preview.php'),
 (12240, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/radio.php'),
 (12241, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/resources/select2-wc-2.6.php'),
 (12242, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/resources/select2.php'),
 (12243, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select-buttons.php'),
 (12244, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select-images.php'),
 (12245, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select-mailchimp.php'),
 (12246, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/select.php'),
 (12247, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/sep.php'),
 (12248, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/sidebarlist.php'),
 (12249, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/sidebars.php'),
 (12250, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/simple-text.php'),
 (12251, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/slider.php'),
 (12252, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/text-array.php'),
 (12253, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/text-button.php'),
 (12254, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/text.php'),
 (12255, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/textarea-codemirror.php'),
 (12256, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/textarea-editor.php'),
 (12257, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/textarea.php'),
 (12258, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/title.php'),
 (12259, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/toggle-element-fixed.php'),
 (12260, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/toggle-element.php'),
 (12261, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/fields/upload.php'),
 (12262, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/metaboxes/field-row.php'),
 (12263, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/metaboxes/tab.php'),
 (12264, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/metaboxes/types/icon-list.php'),
 (12265, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/infobox.php'),
 (12266, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/panel-field-container.php'),
 (12267, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/sub-tabs-nav.php'),
 (12268, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-form.php'),
 (12269, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-option-row.php'),
 (12270, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-panel.php'),
 (12271, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/panel/woocommerce/woocommerce-upload.php'),
 (12272, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/privacy/html-policy-content.php'),
 (12273, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/sysinfo/system-information-panel.php'),
 (12274, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/upgrade/changelog.php'),
 (12275, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/templates/upgrade/error.php'),
 (12276, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-deactive-plugin.php'),
 (12277, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-functions.php'),
 (12278, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-plugin-registration-hook.php'),
 (12279, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-plugin.php'),
 (12280, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-fw/yit-woocommerce-compatibility.php'),
 (12281, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-options/general-options.php'),
 (12282, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-options/premium-options.php'),
 (12283, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/plugin-options/video-box.php'),
 (12284, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/templates/admin/premium.php'),
 (12285, 'wp-content/updraft/plugins-old/yith-infinite-scrolling/uninstall.php'),
 (12286, 'wp-content/updraft/themes-old/index.php'),
 (12287, 'wp-content/updraft/themes-old/kallyas/404-smart-area.php'),
 (12288, 'wp-content/updraft/themes-old/kallyas/404-standard.php'),
 (12289, 'wp-content/updraft/themes-old/kallyas/404.php'),
 (12290, 'wp-content/updraft/themes-old/kallyas/addons/countdown/jquery.countdown.min.js'),
 (12291, 'wp-content/updraft/themes-old/kallyas/addons/flickrfeed/jquery.jflickrfeed.min.js'),
 (12292, 'wp-content/updraft/themes-old/kallyas/addons/isotope-addons/packery-mode.pkgd.min.js'),
 (12293, 'wp-content/updraft/themes-old/kallyas/addons/jquery_loupe/jquery.loupe.js'),
 (12294, 'wp-content/updraft/themes-old/kallyas/addons/kl_socialicons_font/kl-social-icons.svg'),
 (12295, 'wp-content/updraft/themes-old/kallyas/addons/raphael_diagram/init.js'),
 (12296, 'wp-content/updraft/themes-old/kallyas/addons/raphael_diagram/raphael.js'),
 (12297, 'wp-content/updraft/themes-old/kallyas/addons/sc_weather/fonts/icomoon.svg'),
 (12298, 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/debug.addIndicators.min.js'),
 (12299, 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/scrollMagic-fullPacked.js'),
 (12300, 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/scrollmagic-tweenlite.js'),
 (12301, 'wp-content/updraft/themes-old/kallyas/addons/scrollmagic/scrollmagic.js'),
 (12302, 'wp-content/updraft/themes-old/kallyas/addons/slick/slick.js'),
 (12303, 'wp-content/updraft/themes-old/kallyas/addons/slick/slick.min.js'),
 (12304, 'wp-content/updraft/themes-old/kallyas/addons/smooth_scroll/SmoothScroll.js'),
 (12305, 'wp-content/updraft/themes-old/kallyas/addons/smooth_scroll/SmoothScroll.min.js'),
 (12306, 'wp-content/updraft/themes-old/kallyas/addons/wowjs/wow.js'),
 (12307, 'wp-content/updraft/themes-old/kallyas/archive-documentation.php'),
 (12308, 'wp-content/updraft/themes-old/kallyas/archive-portfolio.php'),
 (12309, 'wp-content/updraft/themes-old/kallyas/archive.php'),
 (12310, 'wp-content/updraft/themes-old/kallyas/blog-columns.php'),
 (12311, 'wp-content/updraft/themes-old/kallyas/blog-default.php'),
 (12312, 'wp-content/updraft/themes-old/kallyas/comments.php'),
 (12313, 'wp-content/updraft/themes-old/kallyas/components/blog/blog-default-def_classic.php'),
 (12314, 'wp-content/updraft/themes-old/kallyas/components/blog/blog-default-def_modern.php'),
 (12315, 'wp-content/updraft/themes-old/kallyas/components/blog/blog-item-comments.php'),
 (12316, 'wp-content/updraft/themes-old/kallyas/components/blog/blog-links.php'),
 (12317, 'wp-content/updraft/themes-old/kallyas/components/blog/blog-meta.php'),
 (12318, 'wp-content/updraft/themes-old/kallyas/components/blog/blog-noposts.php'),
 (12319, 'wp-content/updraft/themes-old/kallyas/components/blog/blog-pagination.php'),
 (12320, 'wp-content/updraft/themes-old/kallyas/components/blog/default-classic/blog-bottom.php'),
 (12321, 'wp-content/updraft/themes-old/kallyas/components/blog/default-classic/blog-content.php'),
 (12322, 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-footer.php'),
 (12323, 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-header.php'),
 (12324, 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-img.php'),
 (12325, 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-readmore.php'),
 (12326, 'wp-content/updraft/themes-old/kallyas/components/blog/default-modern/blog-title.php'),
 (12327, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-author.php'),
 (12328, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-content.php'),
 (12329, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details-author.php'),
 (12330, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details-category.php'),
 (12331, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details-date.php'),
 (12332, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-details.php'),
 (12333, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-classic/single-main.php'),
 (12334, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-pagelinks.php'),
 (12335, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-related-item.php'),
 (12336, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-related-title.php'),
 (12337, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-related.php'),
 (12338, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-social-custom.php'),
 (12339, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-social-generic.php'),
 (12340, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-social.php'),
 (12341, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-common/single-tags.php'),
 (12342, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-content.php'),
 (12343, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details-author.php'),
 (12344, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details-category.php'),
 (12345, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details-date.php'),
 (12346, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-details.php'),
 (12347, 'wp-content/updraft/themes-old/kallyas/components/blog/default-single-modern/single-main.php'),
 (12348, 'wp-content/updraft/themes-old/kallyas/components/blog/multicolumns/blog-content.php'),
 (12349, 'wp-content/updraft/themes-old/kallyas/components/blog/multicolumns/blog-media.php'),
 (12350, 'wp-content/updraft/themes-old/kallyas/components/blog/multicolumns/blog-tags.php'),
 (12351, 'wp-content/updraft/themes-old/kallyas/components/masks/mask3.php'),
 (12352, 'wp-content/updraft/themes-old/kallyas/components/masks/mask4.php'),
 (12353, 'wp-content/updraft/themes-old/kallyas/components/masks/mask5.php'),
 (12354, 'wp-content/updraft/themes-old/kallyas/components/masks/mask6.php'),
 (12355, 'wp-content/updraft/themes-old/kallyas/components/masks/mask7.php'),
 (12356, 'wp-content/updraft/themes-old/kallyas/components/masks/mask8.php'),
 (12357, 'wp-content/updraft/themes-old/kallyas/components/masks/masks-functions.php'),
 (12358, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-components.php'),
 (12359, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-main.php'),
 (12360, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup-bottom.php'),
 (12361, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup-main.php'),
 (12362, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup-topbar.php'),
 (12363, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-markup.php'),
 (12364, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style-default.php'),
 (12365, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style1.php'),
 (12366, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style10.php'),
 (12367, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style11.php'),
 (12368, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style12.php'),
 (12369, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style13.php'),
 (12370, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style14.php'),
 (12371, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style15.php'),
 (12372, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style16.php'),
 (12373, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style17.php'),
 (12374, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style2.php'),
 (12375, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style3.php'),
 (12376, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style4.php'),
 (12377, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style5.php'),
 (12378, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style6.php'),
 (12379, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style7.php'),
 (12380, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style8.php'),
 (12381, 'wp-content/updraft/themes-old/kallyas/components/theme-header/header-style9.php'),
 (12382, 'wp-content/updraft/themes-old/kallyas/components/theme-subheader/subheader-default.php'),
 (12383, 'wp-content/updraft/themes-old/kallyas/components/theme-subheader/subheader-documentation.php'),
 (12384, 'wp-content/updraft/themes-old/kallyas/css/dynamic_css.php'),
 (12385, 'wp-content/updraft/themes-old/kallyas/deprecated.php'),
 (12386, 'wp-content/updraft/themes-old/kallyas/fonts/glyphicons-halflings-regular.svg'),
 (12387, 'wp-content/updraft/themes-old/kallyas/footer.php'),
 (12388, 'wp-content/updraft/themes-old/kallyas/framework/class-gdpr.php'),
 (12389, 'wp-content/updraft/themes-old/kallyas/framework/compatibility/config.php'),
 (12390, 'wp-content/updraft/themes-old/kallyas/framework/compatibility/framework.php'),
 (12391, 'wp-content/updraft/themes-old/kallyas/framework/compatibility/metafields.php'),
 (12392, 'wp-content/updraft/themes-old/kallyas/framework/compatibility/shortcodes.php'),
 (12393, 'wp-content/updraft/themes-old/kallyas/framework/compatibility/termmeta.php'),
 (12394, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/admin-mega-menu.js'),
 (12395, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/html.js'),
 (12396, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/zn_modal.js'),
 (12397, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/assets/js/zn_theme_ajax_callback.js'),
 (12398, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/hg-theme-framework.php'),
 (12399, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/addons_manager/class-addons-manager.php'),
 (12400, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/addons_manager/ui/tmpl-addons-list.php'),
 (12401, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_about.js'),
 (12402, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/assets/js/zn_theme_check.js'),
 (12403, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/class-zn-admin.php'),
 (12404, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_DemoImportHelper.php'),
 (12405, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/ZN_ThemeDemoImporter.php'),
 (12406, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-init.js'),
 (12407, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/importer/assets/znde-manager.js'),
 (12408, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/content-tmpl.php'),
 (12409, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/dummy_data-tmpl.php'),
 (12410, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/footer-tmpl.php'),
 (12411, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/form-register-theme-tmpl.php'),
 (12412, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/header-tmpl.php'),
 (12413, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/register-tmpl.php'),
 (12414, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check-amazon.php'),
 (12415, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/admin/tmpl/server-check.php'),
 (12416, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/api/ZN_HogashDashboard.php'),
 (12417, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/components/ajax-load-more.php'),
 (12418, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/components/index.php'),
 (12419, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/dependency-management/class-dependency-management.php'),
 (12420, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/dependency-management/ui/frontend-notice.php'),
 (12421, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-backend.php'),
 (12422, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-frontend.php'),
 (12423, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-helper.php'),
 (12424, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/functions-image-helpers.php'),
 (12425, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/helpers/theme_ajax.php'),
 (12426, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/html/class-html-integration.php'),
 (12427, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/html/fields/theme_import_export.php'),
 (12428, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/installer/class-theme-install.php'),
 (12429, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-about.php'),
 (12430, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/installer/ui/html-page-update.php'),
 (12431, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/integrations/admin-bar.php'),
 (12432, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/integrations/rev-slider-integration.php'),
 (12433, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/integrations/znhgfw_integration.php'),
 (12434, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu-admin.php'),
 (12435, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/mega-menu/class-mega-menu.php'),
 (12436, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/options-exporter/ZnThemeImportExport.php'),
 (12437, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/scripts-manager/class-scripts-manager.php'),
 (12438, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/updater/class-theme-updater.php'),
 (12439, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/updater/inc/options.php'),
 (12440, 'wp-content/updraft/themes-old/kallyas/framework/hg-theme-framework/inc/utility/class-utility.php'),
 (12441, 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/assets/js/hg-mailchimp.js'),
 (12442, 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/hogash-mailchimp.php'),
 (12443, 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/includes/options.php'),
 (12444, 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/lib/HG_MCAPI.php'),
 (12445, 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/lib/class_gdpr.php'),
 (12446, 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/pb_element/newsletter/newsletter.php'),
 (12447, 'wp-content/updraft/themes-old/kallyas/framework/hogash-mailchimp/widget/widget-mailchimp.php'),
 (12448, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/icons/zn-framework.svg'),
 (12449, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/img/pb_col_plus_x.svg'),
 (12450, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/img/pb_col_plus_y.svg'),
 (12451, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/img/svg-icons.svg'),
 (12452, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/js/admin/edit-screen.js'),
 (12453, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/assets/js/admin/yoast-integration.js'),
 (12454, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/dist/gutenberg_integration.bundle.js'),
 (12455, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/dist/znpb_editor.bundle.js'),
 (12456, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/dist/znpb_frontend.bundle.js'),
 (12457, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/img/select-arrow.svg'),
 (12458, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.js'),
 (12459, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/options/options.min.js'),
 (12460, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.js'),
 (12461, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/admin/shortcodes/shortcodes.min.js'),
 (12462, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.isotope.min.js'),
 (12463, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/jquery.timepicker.min.js'),
 (12464, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/ace.js'),
 (12465, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-css.js'),
 (12466, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-html.js'),
 (12467, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/mode-javascript.js'),
 (12468, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/theme-chrome.js'),
 (12469, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-css.js'),
 (12470, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-html.js'),
 (12471, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/src-min-noconflict/worker-javascript.js'),
 (12472, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/wp-color-picker-alpha.js'),
 (12473, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_html_script.js'),
 (12474, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_media.js'),
 (12475, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/assets/dist/js/zn_modal.js'),
 (12476, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/class-znhgfw.php'),
 (12477, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/hg-framework.php'),
 (12478, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/font-manager/ZnTypekitClient.php'),
 (12479, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/font-manager/class-font-manager.php'),
 (12480, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/font-manager/google_fonts.php'),
 (12481, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-color-helpers.php'),
 (12482, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/helpers/functions-helpers.php'),
 (12483, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/helpers/loader.php'),
 (12484, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-data-source.php'),
 (12485, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-field.php'),
 (12486, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-base-form.php'),
 (12487, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/class-html.php'),
 (12488, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/data_source/class-pages-data-source.php'),
 (12489, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/background.php'),
 (12490, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/boxmodel.php'),
 (12491, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/buttons.php'),
 (12492, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/checkbox.php'),
 (12493, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/colorpicker.php'),
 (12494, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_format.php'),
 (12495, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/date_picker.php'),
 (12496, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/day_picker.php'),
 (12497, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/font.php'),
 (12498, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/gallery.php'),
 (12499, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group.php'),
 (12500, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_select.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(12501, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/group_text.php'),
 (12502, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/hidden.php'),
 (12503, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/icon_list.php'),
 (12504, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/image_size.php'),
 (12505, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/link.php'),
 (12506, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/media.php'),
 (12507, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/options_wrapper.php'),
 (12508, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/radio_image.php'),
 (12509, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/select.php'),
 (12510, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/sidebar.php'),
 (12511, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/slider.php'),
 (12512, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_select.php'),
 (12513, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/smart_slider.php'),
 (12514, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/tabbed_form.php'),
 (12515, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/text.php'),
 (12516, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/textarea.php'),
 (12517, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle.php'),
 (12518, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/toggle2.php'),
 (12519, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/upload.php'),
 (12520, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/visual_editor.php'),
 (12521, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/widget_positions.php'),
 (12522, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_ajax_call.php'),
 (12523, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_google_fonts_setup.php'),
 (12524, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_message.php'),
 (12525, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_radio.php'),
 (12526, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/fields/zn_title.php'),
 (12527, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/html/forms/theme_form.php'),
 (12528, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/icon-manager/class-icon-manager.php'),
 (12529, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/image-resizer/class-image-resize.php'),
 (12530, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/metaboxes/class-metabox.php'),
 (12531, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/permalinks/class-permalinks.php'),
 (12532, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/scripts-manager/class-scripts-manager.php'),
 (12533, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/HG_Shortcode.php'),
 (12534, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/shortcodes/class-shortcodes-manager.php'),
 (12535, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/taxonomies/class-termmeta.php'),
 (12536, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/hg-framework/inc/utility/class-utility.php'),
 (12537, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionElement.php'),
 (12538, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionElementsManager.php'),
 (12539, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionPageBuilderCustomCode.php'),
 (12540, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionPageBuilderFrontend.php'),
 (12541, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionScriptsManager.php'),
 (12542, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/ZionWordPressSearch.php'),
 (12543, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/admin/ZionPageBuilderAdmin.php'),
 (12544, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/ZionEditor.php'),
 (12545, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/ZionPageBuilderExportHelper.php'),
 (12546, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/ZionTemplateSystem.php'),
 (12547, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/editor/class-page-builder-ajax.php'),
 (12548, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/helpers/helpers-frontend.php'),
 (12549, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/helpers/helpers-help.php'),
 (12550, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/index-page-builder.php'),
 (12551, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/class-base-integration.php'),
 (12552, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/class-integration-manager.php'),
 (12553, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg.php'),
 (12554, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_gutenberg_integration.php'),
 (12555, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_nextgengallery_integration.php'),
 (12556, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_paid_membership_integration.php'),
 (12557, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_polylang_integration.php'),
 (12558, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_woocommerce_integration.php'),
 (12559, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_revisions.php'),
 (12560, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_wordpress_widgets.php'),
 (12561, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/integration_manager/integrations/class_yoast_integration.php'),
 (12562, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/accordion/accordion.php'),
 (12563, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/anchor_point/anchor_point.php'),
 (12564, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/button/button.php'),
 (12565, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/column/column.php'),
 (12566, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/contact_form/cf-template.php'),
 (12567, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/contact_form/contact_form.php'),
 (12568, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/custom_html/custom_html.php'),
 (12569, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/google_map/assets/gmaps.js'),
 (12570, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/google_map/google_map.php'),
 (12571, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/heading/heading.php'),
 (12572, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/icon/icon.php'),
 (12573, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/icon_list/icon_list.php'),
 (12574, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/image/image.php'),
 (12575, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/revolution_slider/revolution_slider.php'),
 (12576, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/section/section.php'),
 (12577, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/separator/separator.php'),
 (12578, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/sidebar/sidebar.php'),
 (12579, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/smart_area/smart_area.php'),
 (12580, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/smart_container/smart_container.php'),
 (12581, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/spacer/spacer.php'),
 (12582, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/tabs/tabs.php'),
 (12583, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/text_box/text_box.php'),
 (12584, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/video/video.php'),
 (12585, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/widget/options.php'),
 (12586, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/modules/widget/widget.php'),
 (12587, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/smart_areas/ZionSmartArea.php'),
 (12588, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/inc/utility/ZionUtility.php'),
 (12589, 'wp-content/updraft/themes-old/kallyas/framework/zion-builder/zion-builder.php'),
 (12590, 'wp-content/updraft/themes-old/kallyas/framework/zn-framework.php'),
 (12591, 'wp-content/updraft/themes-old/kallyas/functions.php'),
 (12592, 'wp-content/updraft/themes-old/kallyas/header.php'),
 (12593, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style1.svg'),
 (12594, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style10.svg'),
 (12595, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style2.svg'),
 (12596, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style3.svg'),
 (12597, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style4.svg'),
 (12598, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style5.svg'),
 (12599, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style6.svg'),
 (12600, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style7.svg'),
 (12601, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style8.svg'),
 (12602, 'wp-content/updraft/themes-old/kallyas/images/admin/header-styles/style9.svg'),
 (12603, 'wp-content/updraft/themes-old/kallyas/images/admin/product-styles/product-style-01.svg'),
 (12604, 'wp-content/updraft/themes-old/kallyas/images/admin/product-styles/product-style-02.svg'),
 (12605, 'wp-content/updraft/themes-old/kallyas/images/admin/product-styles/product-style-more.svg'),
 (12606, 'wp-content/updraft/themes-old/kallyas/images/admin/site-layout/boxed.svg'),
 (12607, 'wp-content/updraft/themes-old/kallyas/images/admin/site-layout/fullwidth.svg'),
 (12608, 'wp-content/updraft/themes-old/kallyas/images/circle-arr-hover.svg'),
 (12609, 'wp-content/updraft/themes-old/kallyas/images/devices/iphone6.svg'),
 (12610, 'wp-content/updraft/themes-old/kallyas/images/devices/macbook-air.svg'),
 (12611, 'wp-content/updraft/themes-old/kallyas/images/devices/macbook.svg'),
 (12612, 'wp-content/updraft/themes-old/kallyas/images/index.html'),
 (12613, 'wp-content/updraft/themes-old/kallyas/images/kallyas-logo-dark.svg'),
 (12614, 'wp-content/updraft/themes-old/kallyas/images/kallyas-logo-sticky.svg'),
 (12615, 'wp-content/updraft/themes-old/kallyas/images/kallyas-logo.svg'),
 (12616, 'wp-content/updraft/themes-old/kallyas/images/macbook-air.svg'),
 (12617, 'wp-content/updraft/themes-old/kallyas/images/macbook.svg'),
 (12618, 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-added-listing-dark.svg'),
 (12619, 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-added-listing-light.svg'),
 (12620, 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-listing-dark.svg'),
 (12621, 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-cart-listing-light.svg'),
 (12622, 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-more-listing-dark.svg'),
 (12623, 'wp-content/updraft/themes-old/kallyas/images/products_listing_icons/ico-more-listing-light.svg'),
 (12624, 'wp-content/updraft/themes-old/kallyas/images/ring-alt.svg'),
 (12625, 'wp-content/updraft/themes-old/kallyas/images/select-arrow-dark.svg'),
 (12626, 'wp-content/updraft/themes-old/kallyas/images/select-arrow.svg'),
 (12627, 'wp-content/updraft/themes-old/kallyas/images/step-separator-dark.svg'),
 (12628, 'wp-content/updraft/themes-old/kallyas/images/step-separator.svg'),
 (12629, 'wp-content/updraft/themes-old/kallyas/inc/details-portfolio-fields.php'),
 (12630, 'wp-content/updraft/themes-old/kallyas/inc/details-portfolio-related.php'),
 (12631, 'wp-content/updraft/themes-old/kallyas/inc/details-portfolio.php'),
 (12632, 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio-media.php'),
 (12633, 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_carousel.php'),
 (12634, 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_category.php'),
 (12635, 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_category_item.php'),
 (12636, 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_sortable.php'),
 (12637, 'wp-content/updraft/themes-old/kallyas/inc/loop-portfolio_sortable_content.php'),
 (12638, 'wp-content/updraft/themes-old/kallyas/inc/page-content-view-page.inc.php'),
 (12639, 'wp-content/updraft/themes-old/kallyas/inc/page-content-view-portfolio.inc.php'),
 (12640, 'wp-content/updraft/themes-old/kallyas/inc/page-content-view-post.inc.php'),
 (12641, 'wp-content/updraft/themes-old/kallyas/inc/password-protected.inc.php'),
 (12642, 'wp-content/updraft/themes-old/kallyas/inc/single-product-template.php'),
 (12643, 'wp-content/updraft/themes-old/kallyas/index.php'),
 (12644, 'wp-content/updraft/themes-old/kallyas/js/plugins-src/debouncedresize.js'),
 (12645, 'wp-content/updraft/themes-old/kallyas/js/plugins-src/echo.js'),
 (12646, 'wp-content/updraft/themes-old/kallyas/js/plugins-src/fitvids.js'),
 (12647, 'wp-content/updraft/themes-old/kallyas/js/plugins-src/imagesloaded.pkgd.min.js'),
 (12648, 'wp-content/updraft/themes-old/kallyas/js/plugins-src/jquery.easing.js'),
 (12649, 'wp-content/updraft/themes-old/kallyas/js/plugins-src/magnificPopup.js'),
 (12650, 'wp-content/updraft/themes-old/kallyas/js/plugins.min.js'),
 (12651, 'wp-content/updraft/themes-old/kallyas/js/znscript.js'),
 (12652, 'wp-content/updraft/themes-old/kallyas/js/znscript.min.js'),
 (12653, 'wp-content/updraft/themes-old/kallyas/page-coming-soon.php'),
 (12654, 'wp-content/updraft/themes-old/kallyas/page.php'),
 (12655, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_3DCuteSlider/TH_3DCuteSlider.php'),
 (12656, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Accordion/TH_Accordion.php'),
 (12657, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Accordion/inc/ui.inc.php'),
 (12658, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ActionBox/TH_ActionBox.php'),
 (12659, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_BigSocial/TH_BigSocial.php'),
 (12660, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_BlogArchive/TH_BlogArchive.php'),
 (12661, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Buttons/TH_Buttons.php'),
 (12662, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CSS3Panels/TH_CSS3Panels.php'),
 (12663, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CallOutBanner/TH_CallOutBanner.php'),
 (12664, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircleTitleTextBox/TH_CircleTitleTextBox.php'),
 (12665, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularCatalogueCarousel/TH_CircularCatalogueCarousel.php'),
 (12666, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle1/TH_CircularContentStyle1.php'),
 (12667, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle1/inc/ui.inc.php'),
 (12668, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle2/TH_CircularContentStyle2.php'),
 (12669, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CircularContentStyle2/inc/ui.inc.php'),
 (12670, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Comments/TH_Comments.php'),
 (12671, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Countdown/TH_Countdown.php'),
 (12672, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CustomMenu/TH_CustomMenu.php'),
 (12673, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_CustomSubHeaderLayout/TH_CustomSubHeaderLayout.php'),
 (12674, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_DevicesImages/TH_DevicesImages.php'),
 (12675, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_DevicesImages/style.php'),
 (12676, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Documentation/TH_Documentation.php'),
 (12677, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_DocumentationHeader/TH_DocumentationHeader.php'),
 (12678, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FancySlider/TH_FancySlider.php'),
 (12679, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FeaturesBoxes/TH_FeaturesBoxes.php'),
 (12680, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FeaturesBoxes/inc/ui.inc.php'),
 (12681, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FeaturesBoxes2/TH_FeaturesBoxes2.php'),
 (12682, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FlexSlider/TH_FlexSlider.php'),
 (12683, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_FlickrFeed/TH_FlickrFeed.php'),
 (12684, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_GridPhotoGallery/TH_GridPhotoGallery.php'),
 (12685, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_HistoricElement/TH_HistoricElement.php'),
 (12686, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_HorizontalTabs/TH_HorizontalTabs.php'),
 (12687, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_HoverBox/TH_HoverBox.php'),
 (12688, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/TH_ICarousel.php'),
 (12689, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/assets/icarousel.packed.js'),
 (12690, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/assets/jquery.mousewheel.js'),
 (12691, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ICarousel/assets/raphael-min.js'),
 (12692, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IconBox/TH_IconBox.php'),
 (12693, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IconBoxesGrid/TH_IconBoxesGrid.php'),
 (12694, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ImageBox/TH_ImageBox.php'),
 (12695, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ImageBox2/TH_ImageBox2.php'),
 (12696, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ImageGallery/TH_ImageGallery.php'),
 (12697, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_InfoBox/TH_InfoBox.php'),
 (12698, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_InfoBox2/TH_InfoBox2.php'),
 (12699, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IosSlider/TH_IosSlider.php'),
 (12700, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IosSlider/inc/ui.inc.php'),
 (12701, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_IosSlider2/TH_IosSlider2.php'),
 (12702, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_KeywordsElement/TH_KeywordsElement.php'),
 (12703, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LaptopSlider/TH_LaptopSlider.php'),
 (12704, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LaptopSlider/assets/macbook-air.svg'),
 (12705, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LaptopSlider/style.php'),
 (12706, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts/TH_LatestPosts.php'),
 (12707, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts2/TH_LatestPosts2.php'),
 (12708, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts3/TH_LatestPosts3.php'),
 (12709, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts4/TH_LatestPosts4.php'),
 (12710, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/default-style.php'),
 (12711, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPosts4/inc/kl-style-2.php'),
 (12712, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_LatestPostsCarousel/TH_LatestPostsCarousel.php'),
 (12713, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_MediaContainer/TH_MediaContainer.php'),
 (12714, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NewsletterBox/TH_NewsletterBox.php'),
 (12715, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NivoSlider/TH_NivoSlider.php'),
 (12716, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NivoSlider/assets/jquery.nivo.slider.pack.js'),
 (12717, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_NivoSlider/style.php'),
 (12718, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PageContent/TH_PageContent.php'),
 (12719, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PartnersLogos/TH_PartnersLogos.php'),
 (12720, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PartnersTestimonials/TH_PartnersTestimonials.php'),
 (12721, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/TH_PhotoGallery.php'),
 (12722, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/images/album-gallery.svg'),
 (12723, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/images/normal-gallery.svg'),
 (12724, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhotoGallery/images/slideshow-gallery.svg'),
 (12725, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PhpCode/TH_PhpCode.php'),
 (12726, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PortfolioArchive/TH_PortfolioArchive.php'),
 (12727, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PortfolioContent/TH_PortfolioContent.php'),
 (12728, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PortfolioSlider/TH_PortfolioSlider.php'),
 (12729, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PostContent/TH_PostContent.php'),
 (12730, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_PricingTable/TH_PricingTable.php'),
 (12731, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ProductArchive/TH_ProductArchive.php'),
 (12732, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ProductContent/TH_ProductContent.php'),
 (12733, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RecentWork/TH_RecentWork.php'),
 (12734, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RecentWork2/TH_RecentWork2.php'),
 (12735, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RecentWork3/TH_RecentWork3.php'),
 (12736, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_RevolutionSlider/TH_RevolutionSlider.php'),
 (12737, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ScreenshotsBox/TH_ScreenshotsBox.php'),
 (12738, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ScreenshotsBox/style.php'),
 (12739, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_SearchBox/TH_SearchBox.php'),
 (12740, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ServiceBox/TH_ServiceBox.php'),
 (12741, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ServicesElement/TH_ServicesElement.php'),
 (12742, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ShopFeatures/TH_ShopFeatures.php'),
 (12743, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ShopLimitedOffers/TH_ShopLimitedOffers.php'),
 (12744, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_ShopProductsPresentation/TH_ShopProductsPresentation.php'),
 (12745, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Sidebar/TH_Sidebar.php'),
 (12746, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Skills/TH_Skills.php'),
 (12747, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Skills/diagram_el.js'),
 (12748, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Skills/raphael-min.js'),
 (12749, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_SocialIcons/TH_SocialIcons.php'),
 (12750, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_SpacerElement/TH_SpacerElement.php'),
 (12751, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StageImageBox/TH_StageImageBox.php'),
 (12752, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentBoxes/TH_StaticContentBoxes.php'),
 (12753, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentDefault/TH_StaticContentDefault.php'),
 (12754, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentEventCountdown/TH_StaticContentEventCountdown.php'),
 (12755, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentProductLoupe/TH_StaticContentProductLoupe.php'),
 (12756, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentReservationForm/TH_StaticContentReservationForm.php'),
 (12757, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentShowroomCarousel/TH_StaticContentShowroomCarousel.php'),
 (12758, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentSimpleText/TH_StaticContentSimpleText.php'),
 (12759, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentSimpleTextFullWidth/TH_StaticContentSimpleTextFullWidth.php'),
 (12760, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentTextAndRegister/TH_StaticContentTextAndRegister.php'),
 (12761, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentTextAndVideo/TH_StaticContentTextAndVideo.php'),
 (12762, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentTextPop/TH_StaticContentTextPop.php'),
 (12763, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentVideo/TH_StaticContentVideo.php'),
 (12764, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentVideoBackground/TH_StaticContentVideoBackground.php'),
 (12765, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/TH_StaticContentWeatherBox.php'),
 (12766, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StaticContentWeatherBox/scwb.js'),
 (12767, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_Statistics/TH_Statistics.php'),
 (12768, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StatsBox/TH_StatsBox.php'),
 (12769, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox/TH_StepsBox.php'),
 (12770, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox2/TH_StepsBox2.php'),
 (12771, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox3/TH_StepsBox3.php'),
 (12772, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_StepsBox4/TH_StepsBox4.php'),
 (12773, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TeamBox/TH_TeamBox.php'),
 (12774, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TestimonialBox/TH_TestimonialBox.php'),
 (12775, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TestimonialFader/TH_TestimonialFader.php'),
 (12776, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TestimonialSlider/TH_TestimonialSlider.php'),
 (12777, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TextBox/TH_TextBox.php'),
 (12778, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_TitleElement/TH_TitleElement.php'),
 (12779, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_VerticalTabs/TH_VerticalTabs.php'),
 (12780, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_VideoBox/TH_VideoBox.php'),
 (12781, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_WowSlider/TH_WowSlider.php'),
 (12782, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_WowSlider/assets/wowslider.js'),
 (12783, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/TH_WowSlider/style.php'),
 (12784, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/anchor_point/anchor_point.php'),
 (12785, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/button/button.php'),
 (12786, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/column/column.php'),
 (12787, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/contact_form/cf-template.php'),
 (12788, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/contact_form/contact_form.php'),
 (12789, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/custom_container/custom_container.php'),
 (12790, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/custom_html/custom_html.php'),
 (12791, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/google_map/assets/gmaps.js'),
 (12792, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/google_map/assets/markerclusterer.js'),
 (12793, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/google_map/google_map.php'),
 (12794, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/list/list.php'),
 (12795, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/multi_layered/multi_layered.php'),
 (12796, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/pb_template/pb_template.php'),
 (12797, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/price_list/price_list.php'),
 (12798, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/section/section.php'),
 (12799, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/separator/separator.php'),
 (12800, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/skill-bars/skill-bars.php'),
 (12801, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/smart_carousel/smart_carousel.php'),
 (12802, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/smart_slider/options.inc.php'),
 (12803, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/smart_slider/smart_slider.php'),
 (12804, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/sticky_section_lite/sticky_section_lite.php'),
 (12805, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/tweetbox/tweetbox.php'),
 (12806, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/widget/options.php'),
 (12807, 'wp-content/updraft/themes-old/kallyas/pagebuilder/elements/widget/widget.php'),
 (12808, 'wp-content/updraft/themes-old/kallyas/search.php'),
 (12809, 'wp-content/updraft/themes-old/kallyas/searchform.php'),
 (12810, 'wp-content/updraft/themes-old/kallyas/sidebar.php'),
 (12811, 'wp-content/updraft/themes-old/kallyas/single-documentation.php'),
 (12812, 'wp-content/updraft/themes-old/kallyas/single-portfolio.php'),
 (12813, 'wp-content/updraft/themes-old/kallyas/single.php'),
 (12814, 'wp-content/updraft/themes-old/kallyas/taxonomy-documentation_category.php'),
 (12815, 'wp-content/updraft/themes-old/kallyas/taxonomy-project_category.php'),
 (12816, 'wp-content/updraft/themes-old/kallyas/template_helpers/helper-functions.php'),
 (12817, 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/glyphicons_halflingsregular/glyphicons_halflingsregular.svg'),
 (12818, 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/glyphicons_halflingsregular/icon_list.php'),
 (12819, 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/kl-social-icons/icon_list.php'),
 (12820, 'wp-content/updraft/themes-old/kallyas/template_helpers/icons/kl-social-icons/kl-social-icons.svg'),
 (12821, 'wp-content/updraft/themes-old/kallyas/template_helpers/metaboxes/metaboxes.php'),
 (12822, 'wp-content/updraft/themes-old/kallyas/template_helpers/metaboxes/metaboxes_locations.php'),
 (12823, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/404-page-options.php'),
 (12824, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/advanced-options.php'),
 (12825, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/blog-options/archive-options.php'),
 (12826, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/blog-options/single-blog-item-options.php'),
 (12827, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/color-options/color-options-palette.php'),
 (12828, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/color-options/color-options.php'),
 (12829, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/coming-soon-options.php'),
 (12830, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/documentation-options.php'),
 (12831, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/alternative-font-options.php'),
 (12832, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/body-fonts-options.php'),
 (12833, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/general-font-options.php'),
 (12834, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/headings-options.php'),
 (12835, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/font-options/main-menu-font-options.php'),
 (12836, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/cta-options.php'),
 (12837, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/default-header-options.php'),
 (12838, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/footer-options.php'),
 (12839, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/general-options.php'),
 (12840, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/google-analytics-options.php'),
 (12841, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/google-maps-options.php'),
 (12842, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/header-advanced-options.php'),
 (12843, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/header-options.php'),
 (12844, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/infocard-options.php'),
 (12845, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/logo-options.php'),
 (12846, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/nav-options.php'),
 (12847, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/general-options/recaptcha-options.php'),
 (12848, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/layout-options.php'),
 (12849, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/pb-templates.php'),
 (12850, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/portfolio-options.php'),
 (12851, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/unlimited-headers-options.php'),
 (12852, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options-pages/unlimited-sidebars.php'),
 (12853, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-options.php'),
 (12854, 'wp-content/updraft/themes-old/kallyas/template_helpers/options/theme-pages.php'),
 (12855, 'wp-content/updraft/themes-old/kallyas/template_helpers/pagebuilder/page_options.php'),
 (12856, 'wp-content/updraft/themes-old/kallyas/template_helpers/pagebuilder/pagebuilder-animations.php'),
 (12857, 'wp-content/updraft/themes-old/kallyas/template_helpers/pagebuilder/pagebuilder-functions.php'),
 (12858, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/ht_year.php'),
 (12859, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_accordion.php'),
 (12860, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_accordion_container.php'),
 (12861, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_accordion_panel.php'),
 (12862, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_script_shortcode.php'),
 (12863, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_blockquote.php'),
 (12864, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_buttons.php'),
 (12865, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_code.php'),
 (12866, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_column.php'),
 (12867, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h1a.php'),
 (12868, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h2a.php'),
 (12869, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h3a.php'),
 (12870, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h4a.php'),
 (12871, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h5a.php'),
 (12872, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_h6a.php'),
 (12873, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_icons.php'),
 (12874, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_list.php'),
 (12875, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_one_fourth_columns.php'),
 (12876, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_caption.php'),
 (12877, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_column.php'),
 (12878, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_pricing_table.php'),
 (12879, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_qr.php'),
 (12880, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_row.php'),
 (12881, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_sitemap.php'),
 (12882, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skill.php'),
 (12883, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_skills.php'),
 (12884, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_social_share_icons.php'),
 (12885, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_subtitle.php'),
 (12886, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tab.php'),
 (12887, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_table.php'),
 (12888, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tabs.php'),
 (12889, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_columns.php'),
 (12890, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_three_fourth_columns.php'),
 (12891, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_tooltip.php'),
 (12892, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_columns.php'),
 (12893, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_two_third_columns.php'),
 (12894, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/zn_shortcode_znhg_qr.php'),
 (12895, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/classes/znhg_alternative_header.php'),
 (12896, 'wp-content/updraft/themes-old/kallyas/template_helpers/shortcodes/shortcodes.php'),
 (12897, 'wp-content/updraft/themes-old/kallyas/template_helpers/termmeta/termoptions.php'),
 (12898, 'wp-content/updraft/themes-old/kallyas/template_helpers/theme_layout_manager.php'),
 (12899, 'wp-content/updraft/themes-old/kallyas/template_helpers/tweeter-helper.php'),
 (12900, 'wp-content/updraft/themes-old/kallyas/template_helpers/update/scripts/kallyas-update-4.0.0.php'),
 (12901, 'wp-content/updraft/themes-old/kallyas/template_helpers/update/update_config.php'),
 (12902, 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/general/general-vendor.php'),
 (12903, 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/geo-directory/functions-geo-directory.php'),
 (12904, 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/hogash-post-love/config.php'),
 (12905, 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/sensei/functions-sensei.php'),
 (12906, 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/simple-job-board/functions-sjb.php'),
 (12907, 'wp-content/updraft/themes-old/kallyas/template_helpers/vendors/wp-hotel-booking/wp-hotel-booking.php'),
 (12908, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/twitter/OAuth.php'),
 (12909, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/twitter/twitteroauth.php'),
 (12910, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-archive.php'),
 (12911, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-blog-categories.php'),
 (12912, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-contact-details.php'),
 (12913, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-flickr.php'),
 (12914, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-latest_posts.php'),
 (12915, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-mailchimp.php'),
 (12916, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-menu.php'),
 (12917, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-social_buttons.php'),
 (12918, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-tag-cloud.php'),
 (12919, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widget-twitter.php'),
 (12920, 'wp-content/updraft/themes-old/kallyas/template_helpers/widgets/widgets.php'),
 (12921, 'wp-content/updraft/themes-old/kallyas/template_helpers/zion-integration/class_kallyas_integration.php'),
 (12922, 'wp-content/updraft/themes-old/kallyas/template_helpers/zion-integration/kallyas-element-base.php'),
 (12923, 'wp-content/updraft/themes-old/kallyas/th-action-hooks.php'),
 (12924, 'wp-content/updraft/themes-old/kallyas/th-custom-hooks.php'),
 (12925, 'wp-content/updraft/themes-old/kallyas/th-filter-hooks.php'),
 (12926, 'wp-content/updraft/themes-old/kallyas/theme-functions-override.php'),
 (12927, 'wp-content/updraft/themes-old/kallyas/woocommerce/product-searchform.php'),
 (12928, 'wp-content/updraft/themes-old/kallyas/woocommerce/product_gallery_v2/product_gallery.js'),
 (12929, 'wp-content/updraft/themes-old/kallyas/woocommerce/single-product-default.php'),
 (12930, 'wp-content/updraft/themes-old/kallyas/woocommerce/single-product-style3.php'),
 (12931, 'wp-content/updraft/themes-old/kallyas/woocommerce/woo_options.php'),
 (12932, 'wp-content/updraft/themes-old/kallyas/woocommerce/zn-woocommerce-init.php'),
 (12933, 'wp-content/updraft/themes-old/kallyas/woocommerce/zn-woocommerce-v2.php'),
 (12934, 'wp-content/updraft/themes-old/kallyas/woocommerce/zn-woocommerce-v3.php'),
 (12935, 'wp-content/updraft/themes-old/kallyas-child/functions.php'),
 (12936, 'wp-content/updraft/themes-old/kallyas-child/js/zn_script_child.js'),
 (12937, 'wp-content/updraft/uploads-old/2017/03/client_01c.svg'),
 (12938, 'wp-content/updraft/uploads-old/2017/03/client_02c.svg'),
 (12939, 'wp-content/updraft/uploads-old/2017/03/client_03c.svg'),
 (12940, 'wp-content/updraft/uploads-old/2017/03/client_04c.svg'),
 (12941, 'wp-content/updraft/uploads-old/2017/03/client_05c.svg'),
 (12942, 'wp-content/updraft/uploads-old/wc-logs/index.html'),
 (12943, 'wp-content/updraft/uploads-old/woocommerce_uploads/index.html'),
 (12944, 'wp-content/updraft/uploads-old/zion-builder/cache/index.html'),
 (12945, 'wp-content/updraft/uploads-old/zn_fonts/icomoon/icomoon.svg'),
 (12946, 'wp-content/updraft/uploads-old/zn_fonts/icomoon/icon_list.php'),
 (12947, 'wp-content/uploads/zion-builder/cache/index.html'),
 (12948, 'wp-content/wflogs/attack-data.php'),
 (12949, 'wp-content/wflogs/config-livewaf.php'),
 (12950, 'wp-content/wflogs/config-synced.php'),
 (12951, 'wp-content/wflogs/config-transient.php'),
 (12952, 'wp-content/wflogs/config.php'),
 (12953, 'wp-content/wflogs/ips.php'),
 (12954, 'wp-content/wflogs/rules.php'),
 (12955, 'wp-content/wflogs/template.php'),
 (12956, 'wp-content/wflogs-old/attack-data.php'),
 (12957, 'wp-content/wflogs-old/config-livewaf.php'),
 (12958, 'wp-content/wflogs-old/config-synced.php'),
 (12959, 'wp-content/wflogs-old/config-transient.php'),
 (12960, 'wp-content/wflogs-old/config.php'),
 (12961, 'wp-content/wflogs-old/ips.php'),
 (12962, 'wp-content/wflogs-old/rules.php'),
 (12963, 'wp-content/wflogs-old/template.php'),
 (12964, 'wp-cron.php'),
 (12965, 'wp-includes/ID3/getid3.lib.php'),
 (12966, 'wp-includes/ID3/getid3.php'),
 (12967, 'wp-includes/ID3/license.commercial.txt'),
 (12968, 'wp-includes/ID3/license.txt'),
 (12969, 'wp-includes/ID3/module.audio-video.asf.php'),
 (12970, 'wp-includes/ID3/module.audio-video.flv.php'),
 (12971, 'wp-includes/ID3/module.audio-video.matroska.php'),
 (12972, 'wp-includes/ID3/module.audio-video.quicktime.php'),
 (12973, 'wp-includes/ID3/module.audio-video.riff.php'),
 (12974, 'wp-includes/ID3/module.audio.ac3.php'),
 (12975, 'wp-includes/ID3/module.audio.dts.php'),
 (12976, 'wp-includes/ID3/module.audio.flac.php'),
 (12977, 'wp-includes/ID3/module.audio.mp3.php'),
 (12978, 'wp-includes/ID3/module.audio.ogg.php'),
 (12979, 'wp-includes/ID3/module.tag.apetag.php'),
 (12980, 'wp-includes/ID3/module.tag.id3v1.php'),
 (12981, 'wp-includes/ID3/module.tag.id3v2.php'),
 (12982, 'wp-includes/ID3/module.tag.lyrics3.php'),
 (12983, 'wp-includes/ID3/readme.txt'),
 (12984, 'wp-includes/IXR/class-IXR-base64.php'),
 (12985, 'wp-includes/IXR/class-IXR-client.php'),
 (12986, 'wp-includes/IXR/class-IXR-clientmulticall.php'),
 (12987, 'wp-includes/IXR/class-IXR-date.php'),
 (12988, 'wp-includes/IXR/class-IXR-error.php'),
 (12989, 'wp-includes/IXR/class-IXR-introspectionserver.php'),
 (12990, 'wp-includes/IXR/class-IXR-message.php'),
 (12991, 'wp-includes/IXR/class-IXR-request.php'),
 (12992, 'wp-includes/IXR/class-IXR-server.php'),
 (12993, 'wp-includes/IXR/class-IXR-value.php'),
 (12994, 'wp-includes/Requests/Auth/Basic.php'),
 (12995, 'wp-includes/Requests/Auth.php'),
 (12996, 'wp-includes/Requests/Cookie/Jar.php'),
 (12997, 'wp-includes/Requests/Cookie.php'),
 (12998, 'wp-includes/Requests/Exception/HTTP/304.php'),
 (12999, 'wp-includes/Requests/Exception/HTTP/305.php'),
 (13000, 'wp-includes/Requests/Exception/HTTP/306.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(13001, 'wp-includes/Requests/Exception/HTTP/400.php'),
 (13002, 'wp-includes/Requests/Exception/HTTP/401.php'),
 (13003, 'wp-includes/Requests/Exception/HTTP/402.php'),
 (13004, 'wp-includes/Requests/Exception/HTTP/403.php'),
 (13005, 'wp-includes/Requests/Exception/HTTP/404.php'),
 (13006, 'wp-includes/Requests/Exception/HTTP/405.php'),
 (13007, 'wp-includes/Requests/Exception/HTTP/406.php'),
 (13008, 'wp-includes/Requests/Exception/HTTP/407.php'),
 (13009, 'wp-includes/Requests/Exception/HTTP/408.php'),
 (13010, 'wp-includes/Requests/Exception/HTTP/409.php'),
 (13011, 'wp-includes/Requests/Exception/HTTP/410.php'),
 (13012, 'wp-includes/Requests/Exception/HTTP/411.php'),
 (13013, 'wp-includes/Requests/Exception/HTTP/412.php'),
 (13014, 'wp-includes/Requests/Exception/HTTP/413.php'),
 (13015, 'wp-includes/Requests/Exception/HTTP/414.php'),
 (13016, 'wp-includes/Requests/Exception/HTTP/415.php'),
 (13017, 'wp-includes/Requests/Exception/HTTP/416.php'),
 (13018, 'wp-includes/Requests/Exception/HTTP/417.php'),
 (13019, 'wp-includes/Requests/Exception/HTTP/418.php'),
 (13020, 'wp-includes/Requests/Exception/HTTP/428.php'),
 (13021, 'wp-includes/Requests/Exception/HTTP/429.php'),
 (13022, 'wp-includes/Requests/Exception/HTTP/431.php'),
 (13023, 'wp-includes/Requests/Exception/HTTP/500.php'),
 (13024, 'wp-includes/Requests/Exception/HTTP/501.php'),
 (13025, 'wp-includes/Requests/Exception/HTTP/502.php'),
 (13026, 'wp-includes/Requests/Exception/HTTP/503.php'),
 (13027, 'wp-includes/Requests/Exception/HTTP/504.php'),
 (13028, 'wp-includes/Requests/Exception/HTTP/505.php'),
 (13029, 'wp-includes/Requests/Exception/HTTP/511.php'),
 (13030, 'wp-includes/Requests/Exception/HTTP/Unknown.php'),
 (13031, 'wp-includes/Requests/Exception/HTTP.php'),
 (13032, 'wp-includes/Requests/Exception/Transport/cURL.php'),
 (13033, 'wp-includes/Requests/Exception/Transport.php'),
 (13034, 'wp-includes/Requests/Exception.php'),
 (13035, 'wp-includes/Requests/Hooker.php'),
 (13036, 'wp-includes/Requests/Hooks.php'),
 (13037, 'wp-includes/Requests/IDNAEncoder.php'),
 (13038, 'wp-includes/Requests/IPv6.php'),
 (13039, 'wp-includes/Requests/IRI.php'),
 (13040, 'wp-includes/Requests/Proxy/HTTP.php'),
 (13041, 'wp-includes/Requests/Proxy.php'),
 (13042, 'wp-includes/Requests/Response/Headers.php'),
 (13043, 'wp-includes/Requests/Response.php'),
 (13044, 'wp-includes/Requests/SSL.php'),
 (13045, 'wp-includes/Requests/Session.php'),
 (13046, 'wp-includes/Requests/Transport/cURL.php'),
 (13047, 'wp-includes/Requests/Transport/fsockopen.php'),
 (13048, 'wp-includes/Requests/Transport.php'),
 (13049, 'wp-includes/Requests/Utility/CaseInsensitiveDictionary.php'),
 (13050, 'wp-includes/Requests/Utility/FilteredIterator.php'),
 (13051, 'wp-includes/SimplePie/Author.php'),
 (13052, 'wp-includes/SimplePie/Cache/Base.php'),
 (13053, 'wp-includes/SimplePie/Cache/DB.php'),
 (13054, 'wp-includes/SimplePie/Cache/File.php'),
 (13055, 'wp-includes/SimplePie/Cache/Memcache.php'),
 (13056, 'wp-includes/SimplePie/Cache/MySQL.php'),
 (13057, 'wp-includes/SimplePie/Cache.php'),
 (13058, 'wp-includes/SimplePie/Caption.php'),
 (13059, 'wp-includes/SimplePie/Category.php'),
 (13060, 'wp-includes/SimplePie/Content/Type/Sniffer.php'),
 (13061, 'wp-includes/SimplePie/Copyright.php'),
 (13062, 'wp-includes/SimplePie/Core.php'),
 (13063, 'wp-includes/SimplePie/Credit.php'),
 (13064, 'wp-includes/SimplePie/Decode/HTML/Entities.php'),
 (13065, 'wp-includes/SimplePie/Enclosure.php'),
 (13066, 'wp-includes/SimplePie/Exception.php'),
 (13067, 'wp-includes/SimplePie/File.php'),
 (13068, 'wp-includes/SimplePie/HTTP/Parser.php'),
 (13069, 'wp-includes/SimplePie/IRI.php'),
 (13070, 'wp-includes/SimplePie/Item.php'),
 (13071, 'wp-includes/SimplePie/Locator.php'),
 (13072, 'wp-includes/SimplePie/Misc.php'),
 (13073, 'wp-includes/SimplePie/Net/IPv6.php'),
 (13074, 'wp-includes/SimplePie/Parse/Date.php'),
 (13075, 'wp-includes/SimplePie/Parser.php'),
 (13076, 'wp-includes/SimplePie/Rating.php'),
 (13077, 'wp-includes/SimplePie/Registry.php'),
 (13078, 'wp-includes/SimplePie/Restriction.php'),
 (13079, 'wp-includes/SimplePie/Sanitize.php'),
 (13080, 'wp-includes/SimplePie/Source.php'),
 (13081, 'wp-includes/SimplePie/XML/Declaration/Parser.php'),
 (13082, 'wp-includes/SimplePie/gzdecode.php'),
 (13083, 'wp-includes/Text/Diff/Engine/native.php'),
 (13084, 'wp-includes/Text/Diff/Engine/shell.php'),
 (13085, 'wp-includes/Text/Diff/Engine/string.php'),
 (13086, 'wp-includes/Text/Diff/Engine/xdiff.php'),
 (13087, 'wp-includes/Text/Diff/Renderer/inline.php'),
 (13088, 'wp-includes/Text/Diff/Renderer.php'),
 (13089, 'wp-includes/Text/Diff.php'),
 (13090, 'wp-includes/admin-bar.php'),
 (13091, 'wp-includes/assets/script-loader-packages.php'),
 (13092, 'wp-includes/atomlib.php'),
 (13093, 'wp-includes/author-template.php'),
 (13094, 'wp-includes/blocks/archives.php'),
 (13095, 'wp-includes/blocks/block.php'),
 (13096, 'wp-includes/blocks/calendar.php'),
 (13097, 'wp-includes/blocks/categories.php'),
 (13098, 'wp-includes/blocks/latest-comments.php'),
 (13099, 'wp-includes/blocks/latest-posts.php'),
 (13100, 'wp-includes/blocks/rss.php'),
 (13101, 'wp-includes/blocks/search.php'),
 (13102, 'wp-includes/blocks/shortcode/block.json'),
 (13103, 'wp-includes/blocks/shortcode.php'),
 (13104, 'wp-includes/blocks/social-link/block.json'),
 (13105, 'wp-includes/blocks/social-link.php'),
 (13106, 'wp-includes/blocks/tag-cloud.php'),
 (13107, 'wp-includes/blocks.php'),
 (13108, 'wp-includes/bookmark-template.php'),
 (13109, 'wp-includes/bookmark.php'),
 (13110, 'wp-includes/cache.php'),
 (13111, 'wp-includes/canonical.php'),
 (13112, 'wp-includes/capabilities.php'),
 (13113, 'wp-includes/category-template.php'),
 (13114, 'wp-includes/category.php'),
 (13115, 'wp-includes/certificates/ca-bundle.crt'),
 (13116, 'wp-includes/class-IXR.php'),
 (13117, 'wp-includes/class-feed.php'),
 (13118, 'wp-includes/class-http.php'),
 (13119, 'wp-includes/class-json.php'),
 (13120, 'wp-includes/class-oembed.php'),
 (13121, 'wp-includes/class-phpass.php'),
 (13122, 'wp-includes/class-phpmailer.php'),
 (13123, 'wp-includes/class-pop3.php'),
 (13124, 'wp-includes/class-requests.php'),
 (13125, 'wp-includes/class-simplepie.php'),
 (13126, 'wp-includes/class-smtp.php'),
 (13127, 'wp-includes/class-snoopy.php'),
 (13128, 'wp-includes/class-walker-category-dropdown.php'),
 (13129, 'wp-includes/class-walker-category.php'),
 (13130, 'wp-includes/class-walker-comment.php'),
 (13131, 'wp-includes/class-walker-nav-menu.php'),
 (13132, 'wp-includes/class-walker-page-dropdown.php'),
 (13133, 'wp-includes/class-walker-page.php'),
 (13134, 'wp-includes/class-wp-admin-bar.php'),
 (13135, 'wp-includes/class-wp-ajax-response.php'),
 (13136, 'wp-includes/class-wp-block-parser.php'),
 (13137, 'wp-includes/class-wp-block-styles-registry.php'),
 (13138, 'wp-includes/class-wp-block-type-registry.php'),
 (13139, 'wp-includes/class-wp-block-type.php'),
 (13140, 'wp-includes/class-wp-comment-query.php'),
 (13141, 'wp-includes/class-wp-comment.php'),
 (13142, 'wp-includes/class-wp-customize-control.php'),
 (13143, 'wp-includes/class-wp-customize-manager.php'),
 (13144, 'wp-includes/class-wp-customize-nav-menus.php'),
 (13145, 'wp-includes/class-wp-customize-panel.php'),
 (13146, 'wp-includes/class-wp-customize-section.php'),
 (13147, 'wp-includes/class-wp-customize-setting.php'),
 (13148, 'wp-includes/class-wp-customize-widgets.php'),
 (13149, 'wp-includes/class-wp-date-query.php'),
 (13150, 'wp-includes/class-wp-dependency.php'),
 (13151, 'wp-includes/class-wp-editor.php'),
 (13152, 'wp-includes/class-wp-embed.php'),
 (13153, 'wp-includes/class-wp-error.php'),
 (13154, 'wp-includes/class-wp-fatal-error-handler.php'),
 (13155, 'wp-includes/class-wp-feed-cache-transient.php'),
 (13156, 'wp-includes/class-wp-feed-cache.php'),
 (13157, 'wp-includes/class-wp-hook.php'),
 (13158, 'wp-includes/class-wp-http-cookie.php'),
 (13159, 'wp-includes/class-wp-http-curl.php'),
 (13160, 'wp-includes/class-wp-http-encoding.php'),
 (13161, 'wp-includes/class-wp-http-ixr-client.php'),
 (13162, 'wp-includes/class-wp-http-proxy.php'),
 (13163, 'wp-includes/class-wp-http-requests-hooks.php'),
 (13164, 'wp-includes/class-wp-http-requests-response.php'),
 (13165, 'wp-includes/class-wp-http-response.php'),
 (13166, 'wp-includes/class-wp-http-streams.php'),
 (13167, 'wp-includes/class-wp-image-editor-gd.php'),
 (13168, 'wp-includes/class-wp-image-editor-imagick.php'),
 (13169, 'wp-includes/class-wp-image-editor.php'),
 (13170, 'wp-includes/class-wp-list-util.php'),
 (13171, 'wp-includes/class-wp-locale-switcher.php'),
 (13172, 'wp-includes/class-wp-locale.php'),
 (13173, 'wp-includes/class-wp-matchesmapregex.php'),
 (13174, 'wp-includes/class-wp-meta-query.php'),
 (13175, 'wp-includes/class-wp-metadata-lazyloader.php'),
 (13176, 'wp-includes/class-wp-network-query.php'),
 (13177, 'wp-includes/class-wp-network.php'),
 (13178, 'wp-includes/class-wp-object-cache.php'),
 (13179, 'wp-includes/class-wp-oembed-controller.php'),
 (13180, 'wp-includes/class-wp-oembed.php'),
 (13181, 'wp-includes/class-wp-paused-extensions-storage.php'),
 (13182, 'wp-includes/class-wp-post-type.php'),
 (13183, 'wp-includes/class-wp-post.php'),
 (13184, 'wp-includes/class-wp-query.php'),
 (13185, 'wp-includes/class-wp-recovery-mode-cookie-service.php'),
 (13186, 'wp-includes/class-wp-recovery-mode-email-service.php'),
 (13187, 'wp-includes/class-wp-recovery-mode-key-service.php'),
 (13188, 'wp-includes/class-wp-recovery-mode-link-service.php'),
 (13189, 'wp-includes/class-wp-recovery-mode.php'),
 (13190, 'wp-includes/class-wp-rewrite.php'),
 (13191, 'wp-includes/class-wp-role.php'),
 (13192, 'wp-includes/class-wp-roles.php'),
 (13193, 'wp-includes/class-wp-session-tokens.php'),
 (13194, 'wp-includes/class-wp-simplepie-file.php'),
 (13195, 'wp-includes/class-wp-simplepie-sanitize-kses.php'),
 (13196, 'wp-includes/class-wp-site-query.php'),
 (13197, 'wp-includes/class-wp-site.php'),
 (13198, 'wp-includes/class-wp-tax-query.php'),
 (13199, 'wp-includes/class-wp-taxonomy.php'),
 (13200, 'wp-includes/class-wp-term-query.php'),
 (13201, 'wp-includes/class-wp-term.php'),
 (13202, 'wp-includes/class-wp-text-diff-renderer-inline.php'),
 (13203, 'wp-includes/class-wp-text-diff-renderer-table.php'),
 (13204, 'wp-includes/class-wp-theme.php'),
 (13205, 'wp-includes/class-wp-user-meta-session-tokens.php'),
 (13206, 'wp-includes/class-wp-user-query.php'),
 (13207, 'wp-includes/class-wp-user-request.php'),
 (13208, 'wp-includes/class-wp-user.php'),
 (13209, 'wp-includes/class-wp-walker.php'),
 (13210, 'wp-includes/class-wp-widget-factory.php'),
 (13211, 'wp-includes/class-wp-widget.php'),
 (13212, 'wp-includes/class-wp-xmlrpc-server.php'),
 (13213, 'wp-includes/class-wp.php'),
 (13214, 'wp-includes/class.wp-dependencies.php'),
 (13215, 'wp-includes/class.wp-scripts.php'),
 (13216, 'wp-includes/class.wp-styles.php'),
 (13217, 'wp-includes/comment-template.php'),
 (13218, 'wp-includes/comment.php'),
 (13219, 'wp-includes/compat.php'),
 (13220, 'wp-includes/cron.php'),
 (13221, 'wp-includes/css/admin-bar-rtl.css'),
 (13222, 'wp-includes/css/admin-bar-rtl.min.css'),
 (13223, 'wp-includes/css/admin-bar.css'),
 (13224, 'wp-includes/css/admin-bar.min.css'),
 (13225, 'wp-includes/css/buttons-rtl.css'),
 (13226, 'wp-includes/css/buttons-rtl.min.css'),
 (13227, 'wp-includes/css/buttons.css'),
 (13228, 'wp-includes/css/buttons.min.css'),
 (13229, 'wp-includes/css/customize-preview-rtl.css'),
 (13230, 'wp-includes/css/customize-preview-rtl.min.css'),
 (13231, 'wp-includes/css/customize-preview.css'),
 (13232, 'wp-includes/css/customize-preview.min.css'),
 (13233, 'wp-includes/css/dashicons.css'),
 (13234, 'wp-includes/css/dashicons.min.css'),
 (13235, 'wp-includes/css/dist/block-directory/style-rtl.css'),
 (13236, 'wp-includes/css/dist/block-directory/style-rtl.min.css'),
 (13237, 'wp-includes/css/dist/block-directory/style.css'),
 (13238, 'wp-includes/css/dist/block-directory/style.min.css'),
 (13239, 'wp-includes/css/dist/block-editor/style-rtl.css'),
 (13240, 'wp-includes/css/dist/block-editor/style-rtl.min.css'),
 (13241, 'wp-includes/css/dist/block-editor/style.css'),
 (13242, 'wp-includes/css/dist/block-editor/style.min.css'),
 (13243, 'wp-includes/css/dist/block-library/editor-rtl.css'),
 (13244, 'wp-includes/css/dist/block-library/editor-rtl.min.css'),
 (13245, 'wp-includes/css/dist/block-library/editor.css'),
 (13246, 'wp-includes/css/dist/block-library/editor.min.css'),
 (13247, 'wp-includes/css/dist/block-library/style-rtl.css'),
 (13248, 'wp-includes/css/dist/block-library/style-rtl.min.css'),
 (13249, 'wp-includes/css/dist/block-library/style.css'),
 (13250, 'wp-includes/css/dist/block-library/style.min.css'),
 (13251, 'wp-includes/css/dist/block-library/theme-rtl.css'),
 (13252, 'wp-includes/css/dist/block-library/theme-rtl.min.css'),
 (13253, 'wp-includes/css/dist/block-library/theme.css'),
 (13254, 'wp-includes/css/dist/block-library/theme.min.css'),
 (13255, 'wp-includes/css/dist/components/style-rtl.css'),
 (13256, 'wp-includes/css/dist/components/style-rtl.min.css'),
 (13257, 'wp-includes/css/dist/components/style.css'),
 (13258, 'wp-includes/css/dist/components/style.min.css'),
 (13259, 'wp-includes/css/dist/edit-post/style-rtl.css'),
 (13260, 'wp-includes/css/dist/edit-post/style-rtl.min.css'),
 (13261, 'wp-includes/css/dist/edit-post/style.css'),
 (13262, 'wp-includes/css/dist/edit-post/style.min.css'),
 (13263, 'wp-includes/css/dist/editor/editor-styles-rtl.css'),
 (13264, 'wp-includes/css/dist/editor/editor-styles-rtl.min.css'),
 (13265, 'wp-includes/css/dist/editor/editor-styles.css'),
 (13266, 'wp-includes/css/dist/editor/editor-styles.min.css'),
 (13267, 'wp-includes/css/dist/editor/style-rtl.css'),
 (13268, 'wp-includes/css/dist/editor/style-rtl.min.css'),
 (13269, 'wp-includes/css/dist/editor/style.css'),
 (13270, 'wp-includes/css/dist/editor/style.min.css'),
 (13271, 'wp-includes/css/dist/format-library/style-rtl.css'),
 (13272, 'wp-includes/css/dist/format-library/style-rtl.min.css'),
 (13273, 'wp-includes/css/dist/format-library/style.css'),
 (13274, 'wp-includes/css/dist/format-library/style.min.css'),
 (13275, 'wp-includes/css/dist/list-reusable-blocks/style-rtl.css'),
 (13276, 'wp-includes/css/dist/list-reusable-blocks/style-rtl.min.css'),
 (13277, 'wp-includes/css/dist/list-reusable-blocks/style.css'),
 (13278, 'wp-includes/css/dist/list-reusable-blocks/style.min.css'),
 (13279, 'wp-includes/css/dist/nux/style-rtl.css'),
 (13280, 'wp-includes/css/dist/nux/style-rtl.min.css'),
 (13281, 'wp-includes/css/dist/nux/style.css'),
 (13282, 'wp-includes/css/dist/nux/style.min.css'),
 (13283, 'wp-includes/css/editor-rtl.css'),
 (13284, 'wp-includes/css/editor-rtl.min.css'),
 (13285, 'wp-includes/css/editor.css'),
 (13286, 'wp-includes/css/editor.min.css'),
 (13287, 'wp-includes/css/jquery-ui-dialog-rtl.css'),
 (13288, 'wp-includes/css/jquery-ui-dialog-rtl.min.css'),
 (13289, 'wp-includes/css/jquery-ui-dialog.css'),
 (13290, 'wp-includes/css/jquery-ui-dialog.min.css'),
 (13291, 'wp-includes/css/media-views-rtl.css'),
 (13292, 'wp-includes/css/media-views-rtl.min.css'),
 (13293, 'wp-includes/css/media-views.css'),
 (13294, 'wp-includes/css/media-views.min.css'),
 (13295, 'wp-includes/css/wp-auth-check-rtl.css'),
 (13296, 'wp-includes/css/wp-auth-check-rtl.min.css'),
 (13297, 'wp-includes/css/wp-auth-check.css'),
 (13298, 'wp-includes/css/wp-auth-check.min.css'),
 (13299, 'wp-includes/css/wp-embed-template-ie.css'),
 (13300, 'wp-includes/css/wp-embed-template-ie.min.css'),
 (13301, 'wp-includes/css/wp-embed-template.css'),
 (13302, 'wp-includes/css/wp-embed-template.min.css'),
 (13303, 'wp-includes/css/wp-pointer-rtl.css'),
 (13304, 'wp-includes/css/wp-pointer-rtl.min.css'),
 (13305, 'wp-includes/css/wp-pointer.css'),
 (13306, 'wp-includes/css/wp-pointer.min.css'),
 (13307, 'wp-includes/customize/class-wp-customize-background-image-control.php'),
 (13308, 'wp-includes/customize/class-wp-customize-background-image-setting.php'),
 (13309, 'wp-includes/customize/class-wp-customize-background-position-control.php'),
 (13310, 'wp-includes/customize/class-wp-customize-code-editor-control.php'),
 (13311, 'wp-includes/customize/class-wp-customize-color-control.php'),
 (13312, 'wp-includes/customize/class-wp-customize-cropped-image-control.php'),
 (13313, 'wp-includes/customize/class-wp-customize-custom-css-setting.php'),
 (13314, 'wp-includes/customize/class-wp-customize-date-time-control.php'),
 (13315, 'wp-includes/customize/class-wp-customize-filter-setting.php'),
 (13316, 'wp-includes/customize/class-wp-customize-header-image-control.php'),
 (13317, 'wp-includes/customize/class-wp-customize-header-image-setting.php'),
 (13318, 'wp-includes/customize/class-wp-customize-image-control.php'),
 (13319, 'wp-includes/customize/class-wp-customize-media-control.php'),
 (13320, 'wp-includes/customize/class-wp-customize-nav-menu-auto-add-control.php'),
 (13321, 'wp-includes/customize/class-wp-customize-nav-menu-control.php'),
 (13322, 'wp-includes/customize/class-wp-customize-nav-menu-item-control.php'),
 (13323, 'wp-includes/customize/class-wp-customize-nav-menu-item-setting.php'),
 (13324, 'wp-includes/customize/class-wp-customize-nav-menu-location-control.php'),
 (13325, 'wp-includes/customize/class-wp-customize-nav-menu-locations-control.php'),
 (13326, 'wp-includes/customize/class-wp-customize-nav-menu-name-control.php'),
 (13327, 'wp-includes/customize/class-wp-customize-nav-menu-section.php'),
 (13328, 'wp-includes/customize/class-wp-customize-nav-menu-setting.php'),
 (13329, 'wp-includes/customize/class-wp-customize-nav-menus-panel.php'),
 (13330, 'wp-includes/customize/class-wp-customize-new-menu-control.php'),
 (13331, 'wp-includes/customize/class-wp-customize-new-menu-section.php'),
 (13332, 'wp-includes/customize/class-wp-customize-partial.php'),
 (13333, 'wp-includes/customize/class-wp-customize-selective-refresh.php'),
 (13334, 'wp-includes/customize/class-wp-customize-sidebar-section.php'),
 (13335, 'wp-includes/customize/class-wp-customize-site-icon-control.php'),
 (13336, 'wp-includes/customize/class-wp-customize-theme-control.php'),
 (13337, 'wp-includes/customize/class-wp-customize-themes-panel.php'),
 (13338, 'wp-includes/customize/class-wp-customize-themes-section.php'),
 (13339, 'wp-includes/customize/class-wp-customize-upload-control.php'),
 (13340, 'wp-includes/customize/class-wp-widget-area-customize-control.php'),
 (13341, 'wp-includes/customize/class-wp-widget-form-customize-control.php'),
 (13342, 'wp-includes/date.php'),
 (13343, 'wp-includes/default-constants.php'),
 (13344, 'wp-includes/default-filters.php'),
 (13345, 'wp-includes/default-widgets.php'),
 (13346, 'wp-includes/deprecated.php'),
 (13347, 'wp-includes/embed-template.php'),
 (13348, 'wp-includes/embed.php'),
 (13349, 'wp-includes/error-protection.php'),
 (13350, 'wp-includes/feed-atom-comments.php'),
 (13351, 'wp-includes/feed-atom.php'),
 (13352, 'wp-includes/feed-rdf.php'),
 (13353, 'wp-includes/feed-rss.php'),
 (13354, 'wp-includes/feed-rss2-comments.php'),
 (13355, 'wp-includes/feed-rss2.php'),
 (13356, 'wp-includes/feed.php'),
 (13357, 'wp-includes/fonts/dashicons.eot'),
 (13358, 'wp-includes/fonts/dashicons.svg'),
 (13359, 'wp-includes/fonts/dashicons.ttf'),
 (13360, 'wp-includes/fonts/dashicons.woff'),
 (13361, 'wp-includes/fonts/dashicons.woff2'),
 (13362, 'wp-includes/formatting.php'),
 (13363, 'wp-includes/functions.php'),
 (13364, 'wp-includes/functions.wp-scripts.php'),
 (13365, 'wp-includes/functions.wp-styles.php'),
 (13366, 'wp-includes/general-template.php'),
 (13367, 'wp-includes/http.php'),
 (13368, 'wp-includes/images/admin-bar-sprite-2x.png'),
 (13369, 'wp-includes/images/admin-bar-sprite.png'),
 (13370, 'wp-includes/images/arrow-pointer-blue-2x.png'),
 (13371, 'wp-includes/images/arrow-pointer-blue.png'),
 (13372, 'wp-includes/images/blank.gif'),
 (13373, 'wp-includes/images/crystal/archive.png'),
 (13374, 'wp-includes/images/crystal/audio.png'),
 (13375, 'wp-includes/images/crystal/code.png'),
 (13376, 'wp-includes/images/crystal/default.png'),
 (13377, 'wp-includes/images/crystal/document.png'),
 (13378, 'wp-includes/images/crystal/interactive.png'),
 (13379, 'wp-includes/images/crystal/license.txt'),
 (13380, 'wp-includes/images/crystal/spreadsheet.png'),
 (13381, 'wp-includes/images/crystal/text.png'),
 (13382, 'wp-includes/images/crystal/video.png'),
 (13383, 'wp-includes/images/down_arrow-2x.gif'),
 (13384, 'wp-includes/images/down_arrow.gif'),
 (13385, 'wp-includes/images/icon-pointer-flag-2x.png'),
 (13386, 'wp-includes/images/icon-pointer-flag.png'),
 (13387, 'wp-includes/images/media/archive.png'),
 (13388, 'wp-includes/images/media/audio.png'),
 (13389, 'wp-includes/images/media/code.png'),
 (13390, 'wp-includes/images/media/default.png'),
 (13391, 'wp-includes/images/media/document.png'),
 (13392, 'wp-includes/images/media/interactive.png'),
 (13393, 'wp-includes/images/media/spreadsheet.png'),
 (13394, 'wp-includes/images/media/text.png'),
 (13395, 'wp-includes/images/media/video.png'),
 (13396, 'wp-includes/images/rss-2x.png'),
 (13397, 'wp-includes/images/rss.png'),
 (13398, 'wp-includes/images/smilies/frownie.png'),
 (13399, 'wp-includes/images/smilies/icon_arrow.gif'),
 (13400, 'wp-includes/images/smilies/icon_biggrin.gif'),
 (13401, 'wp-includes/images/smilies/icon_confused.gif'),
 (13402, 'wp-includes/images/smilies/icon_cool.gif'),
 (13403, 'wp-includes/images/smilies/icon_cry.gif'),
 (13404, 'wp-includes/images/smilies/icon_eek.gif'),
 (13405, 'wp-includes/images/smilies/icon_evil.gif'),
 (13406, 'wp-includes/images/smilies/icon_exclaim.gif'),
 (13407, 'wp-includes/images/smilies/icon_idea.gif'),
 (13408, 'wp-includes/images/smilies/icon_lol.gif'),
 (13409, 'wp-includes/images/smilies/icon_mad.gif'),
 (13410, 'wp-includes/images/smilies/icon_mrgreen.gif'),
 (13411, 'wp-includes/images/smilies/icon_neutral.gif'),
 (13412, 'wp-includes/images/smilies/icon_question.gif'),
 (13413, 'wp-includes/images/smilies/icon_razz.gif'),
 (13414, 'wp-includes/images/smilies/icon_redface.gif'),
 (13415, 'wp-includes/images/smilies/icon_rolleyes.gif'),
 (13416, 'wp-includes/images/smilies/icon_sad.gif'),
 (13417, 'wp-includes/images/smilies/icon_smile.gif'),
 (13418, 'wp-includes/images/smilies/icon_surprised.gif'),
 (13419, 'wp-includes/images/smilies/icon_twisted.gif'),
 (13420, 'wp-includes/images/smilies/icon_wink.gif'),
 (13421, 'wp-includes/images/smilies/mrgreen.png'),
 (13422, 'wp-includes/images/smilies/rolleyes.png'),
 (13423, 'wp-includes/images/smilies/simple-smile.png'),
 (13424, 'wp-includes/images/spinner-2x.gif'),
 (13425, 'wp-includes/images/spinner.gif'),
 (13426, 'wp-includes/images/toggle-arrow-2x.png'),
 (13427, 'wp-includes/images/toggle-arrow.png'),
 (13428, 'wp-includes/images/uploader-icons-2x.png'),
 (13429, 'wp-includes/images/uploader-icons.png'),
 (13430, 'wp-includes/images/w-logo-blue.png'),
 (13431, 'wp-includes/images/wlw/wp-comments.png'),
 (13432, 'wp-includes/images/wlw/wp-icon.png'),
 (13433, 'wp-includes/images/wlw/wp-watermark.png'),
 (13434, 'wp-includes/images/wpicons-2x.png'),
 (13435, 'wp-includes/images/wpicons.png'),
 (13436, 'wp-includes/images/wpspin-2x.gif'),
 (13437, 'wp-includes/images/wpspin.gif'),
 (13438, 'wp-includes/images/xit-2x.gif'),
 (13439, 'wp-includes/images/xit.gif'),
 (13440, 'wp-includes/js/admin-bar.js'),
 (13441, 'wp-includes/js/admin-bar.min.js'),
 (13442, 'wp-includes/js/api-request.js'),
 (13443, 'wp-includes/js/api-request.min.js'),
 (13444, 'wp-includes/js/autosave.js'),
 (13445, 'wp-includes/js/autosave.min.js'),
 (13446, 'wp-includes/js/backbone.js'),
 (13447, 'wp-includes/js/backbone.min.js'),
 (13448, 'wp-includes/js/clipboard.js'),
 (13449, 'wp-includes/js/clipboard.min.js'),
 (13450, 'wp-includes/js/codemirror/codemirror.min.css'),
 (13451, 'wp-includes/js/codemirror/codemirror.min.js'),
 (13452, 'wp-includes/js/codemirror/csslint.js'),
 (13453, 'wp-includes/js/codemirror/esprima.js'),
 (13454, 'wp-includes/js/codemirror/fakejshint.js'),
 (13455, 'wp-includes/js/codemirror/htmlhint-kses.js'),
 (13456, 'wp-includes/js/codemirror/htmlhint.js'),
 (13457, 'wp-includes/js/codemirror/jsonlint.js'),
 (13458, 'wp-includes/js/colorpicker.js'),
 (13459, 'wp-includes/js/colorpicker.min.js'),
 (13460, 'wp-includes/js/comment-reply.js'),
 (13461, 'wp-includes/js/comment-reply.min.js'),
 (13462, 'wp-includes/js/crop/cropper.css'),
 (13463, 'wp-includes/js/crop/cropper.js'),
 (13464, 'wp-includes/js/crop/marqueeHoriz.gif'),
 (13465, 'wp-includes/js/crop/marqueeVert.gif'),
 (13466, 'wp-includes/js/customize-base.js'),
 (13467, 'wp-includes/js/customize-base.min.js'),
 (13468, 'wp-includes/js/customize-loader.js'),
 (13469, 'wp-includes/js/customize-loader.min.js'),
 (13470, 'wp-includes/js/customize-models.js'),
 (13471, 'wp-includes/js/customize-models.min.js'),
 (13472, 'wp-includes/js/customize-preview-nav-menus.js'),
 (13473, 'wp-includes/js/customize-preview-nav-menus.min.js'),
 (13474, 'wp-includes/js/customize-preview-widgets.js'),
 (13475, 'wp-includes/js/customize-preview-widgets.min.js'),
 (13476, 'wp-includes/js/customize-preview.js'),
 (13477, 'wp-includes/js/customize-preview.min.js'),
 (13478, 'wp-includes/js/customize-selective-refresh.js'),
 (13479, 'wp-includes/js/customize-selective-refresh.min.js'),
 (13480, 'wp-includes/js/customize-views.js'),
 (13481, 'wp-includes/js/customize-views.min.js'),
 (13482, 'wp-includes/js/dist/a11y.js'),
 (13483, 'wp-includes/js/dist/a11y.min.js'),
 (13484, 'wp-includes/js/dist/annotations.js'),
 (13485, 'wp-includes/js/dist/annotations.min.js'),
 (13486, 'wp-includes/js/dist/api-fetch.js'),
 (13487, 'wp-includes/js/dist/api-fetch.min.js'),
 (13488, 'wp-includes/js/dist/autop.js'),
 (13489, 'wp-includes/js/dist/autop.min.js'),
 (13490, 'wp-includes/js/dist/blob.js'),
 (13491, 'wp-includes/js/dist/blob.min.js'),
 (13492, 'wp-includes/js/dist/block-directory.js'),
 (13493, 'wp-includes/js/dist/block-directory.min.js'),
 (13494, 'wp-includes/js/dist/block-editor.js'),
 (13495, 'wp-includes/js/dist/block-editor.min.js'),
 (13496, 'wp-includes/js/dist/block-library.js'),
 (13497, 'wp-includes/js/dist/block-library.min.js'),
 (13498, 'wp-includes/js/dist/block-serialization-default-parser.js'),
 (13499, 'wp-includes/js/dist/block-serialization-default-parser.min.js'),
 (13500, 'wp-includes/js/dist/blocks.js');
INSERT INTO `wp8b_wfknownfilelist` VALUES(13501, 'wp-includes/js/dist/blocks.min.js'),
 (13502, 'wp-includes/js/dist/components.js'),
 (13503, 'wp-includes/js/dist/components.min.js'),
 (13504, 'wp-includes/js/dist/compose.js'),
 (13505, 'wp-includes/js/dist/compose.min.js'),
 (13506, 'wp-includes/js/dist/core-data.js'),
 (13507, 'wp-includes/js/dist/core-data.min.js'),
 (13508, 'wp-includes/js/dist/data-controls.js'),
 (13509, 'wp-includes/js/dist/data-controls.min.js'),
 (13510, 'wp-includes/js/dist/data.js'),
 (13511, 'wp-includes/js/dist/data.min.js'),
 (13512, 'wp-includes/js/dist/date.js'),
 (13513, 'wp-includes/js/dist/date.min.js'),
 (13514, 'wp-includes/js/dist/deprecated.js'),
 (13515, 'wp-includes/js/dist/deprecated.min.js'),
 (13516, 'wp-includes/js/dist/dom-ready.js'),
 (13517, 'wp-includes/js/dist/dom-ready.min.js'),
 (13518, 'wp-includes/js/dist/dom.js'),
 (13519, 'wp-includes/js/dist/dom.min.js'),
 (13520, 'wp-includes/js/dist/edit-post.js'),
 (13521, 'wp-includes/js/dist/edit-post.min.js'),
 (13522, 'wp-includes/js/dist/editor.js'),
 (13523, 'wp-includes/js/dist/editor.min.js'),
 (13524, 'wp-includes/js/dist/element.js'),
 (13525, 'wp-includes/js/dist/element.min.js'),
 (13526, 'wp-includes/js/dist/escape-html.js'),
 (13527, 'wp-includes/js/dist/escape-html.min.js'),
 (13528, 'wp-includes/js/dist/format-library.js'),
 (13529, 'wp-includes/js/dist/format-library.min.js'),
 (13530, 'wp-includes/js/dist/hooks.js'),
 (13531, 'wp-includes/js/dist/hooks.min.js'),
 (13532, 'wp-includes/js/dist/html-entities.js'),
 (13533, 'wp-includes/js/dist/html-entities.min.js'),
 (13534, 'wp-includes/js/dist/i18n.js'),
 (13535, 'wp-includes/js/dist/i18n.min.js'),
 (13536, 'wp-includes/js/dist/is-shallow-equal.js'),
 (13537, 'wp-includes/js/dist/is-shallow-equal.min.js'),
 (13538, 'wp-includes/js/dist/keyboard-shortcuts.js'),
 (13539, 'wp-includes/js/dist/keyboard-shortcuts.min.js'),
 (13540, 'wp-includes/js/dist/keycodes.js'),
 (13541, 'wp-includes/js/dist/keycodes.min.js'),
 (13542, 'wp-includes/js/dist/list-reusable-blocks.js'),
 (13543, 'wp-includes/js/dist/list-reusable-blocks.min.js'),
 (13544, 'wp-includes/js/dist/media-utils.js'),
 (13545, 'wp-includes/js/dist/media-utils.min.js'),
 (13546, 'wp-includes/js/dist/notices.js'),
 (13547, 'wp-includes/js/dist/notices.min.js'),
 (13548, 'wp-includes/js/dist/nux.js'),
 (13549, 'wp-includes/js/dist/nux.min.js'),
 (13550, 'wp-includes/js/dist/plugins.js'),
 (13551, 'wp-includes/js/dist/plugins.min.js'),
 (13552, 'wp-includes/js/dist/primitives.js'),
 (13553, 'wp-includes/js/dist/primitives.min.js'),
 (13554, 'wp-includes/js/dist/priority-queue.js'),
 (13555, 'wp-includes/js/dist/priority-queue.min.js'),
 (13556, 'wp-includes/js/dist/redux-routine.js'),
 (13557, 'wp-includes/js/dist/redux-routine.min.js'),
 (13558, 'wp-includes/js/dist/rich-text.js'),
 (13559, 'wp-includes/js/dist/rich-text.min.js'),
 (13560, 'wp-includes/js/dist/server-side-render.js'),
 (13561, 'wp-includes/js/dist/server-side-render.min.js'),
 (13562, 'wp-includes/js/dist/shortcode.js'),
 (13563, 'wp-includes/js/dist/shortcode.min.js'),
 (13564, 'wp-includes/js/dist/token-list.js'),
 (13565, 'wp-includes/js/dist/token-list.min.js'),
 (13566, 'wp-includes/js/dist/url.js'),
 (13567, 'wp-includes/js/dist/url.min.js'),
 (13568, 'wp-includes/js/dist/vendor/lodash.js'),
 (13569, 'wp-includes/js/dist/vendor/lodash.min.js'),
 (13570, 'wp-includes/js/dist/vendor/moment.js'),
 (13571, 'wp-includes/js/dist/vendor/moment.min.js'),
 (13572, 'wp-includes/js/dist/vendor/react-dom.js'),
 (13573, 'wp-includes/js/dist/vendor/react-dom.min.js'),
 (13574, 'wp-includes/js/dist/vendor/react.js'),
 (13575, 'wp-includes/js/dist/vendor/react.min.js'),
 (13576, 'wp-includes/js/dist/vendor/wp-polyfill-dom-rect.js'),
 (13577, 'wp-includes/js/dist/vendor/wp-polyfill-dom-rect.min.js'),
 (13578, 'wp-includes/js/dist/vendor/wp-polyfill-element-closest.js'),
 (13579, 'wp-includes/js/dist/vendor/wp-polyfill-element-closest.min.js'),
 (13580, 'wp-includes/js/dist/vendor/wp-polyfill-fetch.js'),
 (13581, 'wp-includes/js/dist/vendor/wp-polyfill-fetch.min.js'),
 (13582, 'wp-includes/js/dist/vendor/wp-polyfill-formdata.js'),
 (13583, 'wp-includes/js/dist/vendor/wp-polyfill-formdata.min.js'),
 (13584, 'wp-includes/js/dist/vendor/wp-polyfill-node-contains.js'),
 (13585, 'wp-includes/js/dist/vendor/wp-polyfill-node-contains.min.js'),
 (13586, 'wp-includes/js/dist/vendor/wp-polyfill-url.js'),
 (13587, 'wp-includes/js/dist/vendor/wp-polyfill-url.min.js'),
 (13588, 'wp-includes/js/dist/vendor/wp-polyfill.js'),
 (13589, 'wp-includes/js/dist/vendor/wp-polyfill.min.js'),
 (13590, 'wp-includes/js/dist/viewport.js'),
 (13591, 'wp-includes/js/dist/viewport.min.js'),
 (13592, 'wp-includes/js/dist/warning.js'),
 (13593, 'wp-includes/js/dist/warning.min.js'),
 (13594, 'wp-includes/js/dist/wordcount.js'),
 (13595, 'wp-includes/js/dist/wordcount.min.js'),
 (13596, 'wp-includes/js/heartbeat.js'),
 (13597, 'wp-includes/js/heartbeat.min.js'),
 (13598, 'wp-includes/js/hoverIntent.js'),
 (13599, 'wp-includes/js/hoverIntent.min.js'),
 (13600, 'wp-includes/js/hoverintent-js.min.js'),
 (13601, 'wp-includes/js/imagesloaded.min.js'),
 (13602, 'wp-includes/js/imgareaselect/border-anim-h.gif'),
 (13603, 'wp-includes/js/imgareaselect/border-anim-v.gif'),
 (13604, 'wp-includes/js/imgareaselect/imgareaselect.css'),
 (13605, 'wp-includes/js/imgareaselect/jquery.imgareaselect.js'),
 (13606, 'wp-includes/js/imgareaselect/jquery.imgareaselect.min.js'),
 (13607, 'wp-includes/js/jcrop/Jcrop.gif'),
 (13608, 'wp-includes/js/jcrop/jquery.Jcrop.min.css'),
 (13609, 'wp-includes/js/jcrop/jquery.Jcrop.min.js'),
 (13610, 'wp-includes/js/jquery/jquery-migrate.js'),
 (13611, 'wp-includes/js/jquery/jquery-migrate.min.js'),
 (13612, 'wp-includes/js/jquery/jquery.color.min.js'),
 (13613, 'wp-includes/js/jquery/jquery.form.js'),
 (13614, 'wp-includes/js/jquery/jquery.form.min.js'),
 (13615, 'wp-includes/js/jquery/jquery.hotkeys.js'),
 (13616, 'wp-includes/js/jquery/jquery.hotkeys.min.js'),
 (13617, 'wp-includes/js/jquery/jquery.js'),
 (13618, 'wp-includes/js/jquery/jquery.masonry.min.js'),
 (13619, 'wp-includes/js/jquery/jquery.query.js'),
 (13620, 'wp-includes/js/jquery/jquery.schedule.js'),
 (13621, 'wp-includes/js/jquery/jquery.serialize-object.js'),
 (13622, 'wp-includes/js/jquery/jquery.table-hotkeys.js'),
 (13623, 'wp-includes/js/jquery/jquery.table-hotkeys.min.js'),
 (13624, 'wp-includes/js/jquery/jquery.ui.touch-punch.js'),
 (13625, 'wp-includes/js/jquery/suggest.js'),
 (13626, 'wp-includes/js/jquery/suggest.min.js'),
 (13627, 'wp-includes/js/jquery/ui/accordion.min.js'),
 (13628, 'wp-includes/js/jquery/ui/autocomplete.min.js'),
 (13629, 'wp-includes/js/jquery/ui/button.min.js'),
 (13630, 'wp-includes/js/jquery/ui/core.min.js'),
 (13631, 'wp-includes/js/jquery/ui/datepicker.min.js'),
 (13632, 'wp-includes/js/jquery/ui/dialog.min.js'),
 (13633, 'wp-includes/js/jquery/ui/draggable.min.js'),
 (13634, 'wp-includes/js/jquery/ui/droppable.min.js'),
 (13635, 'wp-includes/js/jquery/ui/effect-blind.min.js'),
 (13636, 'wp-includes/js/jquery/ui/effect-bounce.min.js'),
 (13637, 'wp-includes/js/jquery/ui/effect-clip.min.js'),
 (13638, 'wp-includes/js/jquery/ui/effect-drop.min.js'),
 (13639, 'wp-includes/js/jquery/ui/effect-explode.min.js'),
 (13640, 'wp-includes/js/jquery/ui/effect-fade.min.js'),
 (13641, 'wp-includes/js/jquery/ui/effect-fold.min.js'),
 (13642, 'wp-includes/js/jquery/ui/effect-highlight.min.js'),
 (13643, 'wp-includes/js/jquery/ui/effect-puff.min.js'),
 (13644, 'wp-includes/js/jquery/ui/effect-pulsate.min.js'),
 (13645, 'wp-includes/js/jquery/ui/effect-scale.min.js'),
 (13646, 'wp-includes/js/jquery/ui/effect-shake.min.js'),
 (13647, 'wp-includes/js/jquery/ui/effect-size.min.js'),
 (13648, 'wp-includes/js/jquery/ui/effect-slide.min.js'),
 (13649, 'wp-includes/js/jquery/ui/effect-transfer.min.js'),
 (13650, 'wp-includes/js/jquery/ui/effect.min.js'),
 (13651, 'wp-includes/js/jquery/ui/menu.min.js'),
 (13652, 'wp-includes/js/jquery/ui/mouse.min.js'),
 (13653, 'wp-includes/js/jquery/ui/position.min.js'),
 (13654, 'wp-includes/js/jquery/ui/progressbar.min.js'),
 (13655, 'wp-includes/js/jquery/ui/resizable.min.js'),
 (13656, 'wp-includes/js/jquery/ui/selectable.min.js'),
 (13657, 'wp-includes/js/jquery/ui/selectmenu.min.js'),
 (13658, 'wp-includes/js/jquery/ui/slider.min.js'),
 (13659, 'wp-includes/js/jquery/ui/sortable.min.js'),
 (13660, 'wp-includes/js/jquery/ui/spinner.min.js'),
 (13661, 'wp-includes/js/jquery/ui/tabs.min.js'),
 (13662, 'wp-includes/js/jquery/ui/tooltip.min.js'),
 (13663, 'wp-includes/js/jquery/ui/widget.min.js'),
 (13664, 'wp-includes/js/json2.js'),
 (13665, 'wp-includes/js/json2.min.js'),
 (13666, 'wp-includes/js/masonry.min.js'),
 (13667, 'wp-includes/js/mce-view.js'),
 (13668, 'wp-includes/js/mce-view.min.js'),
 (13669, 'wp-includes/js/media-audiovideo.js'),
 (13670, 'wp-includes/js/media-audiovideo.min.js'),
 (13671, 'wp-includes/js/media-editor.js'),
 (13672, 'wp-includes/js/media-editor.min.js'),
 (13673, 'wp-includes/js/media-grid.js'),
 (13674, 'wp-includes/js/media-grid.min.js'),
 (13675, 'wp-includes/js/media-models.js'),
 (13676, 'wp-includes/js/media-models.min.js'),
 (13677, 'wp-includes/js/media-views.js'),
 (13678, 'wp-includes/js/media-views.min.js'),
 (13679, 'wp-includes/js/mediaelement/mediaelement-and-player.js'),
 (13680, 'wp-includes/js/mediaelement/mediaelement-and-player.min.js'),
 (13681, 'wp-includes/js/mediaelement/mediaelement-migrate.js'),
 (13682, 'wp-includes/js/mediaelement/mediaelement-migrate.min.js'),
 (13683, 'wp-includes/js/mediaelement/mediaelement.js'),
 (13684, 'wp-includes/js/mediaelement/mediaelement.min.js'),
 (13685, 'wp-includes/js/mediaelement/mediaelementplayer-legacy.css'),
 (13686, 'wp-includes/js/mediaelement/mediaelementplayer-legacy.min.css'),
 (13687, 'wp-includes/js/mediaelement/mediaelementplayer.css'),
 (13688, 'wp-includes/js/mediaelement/mediaelementplayer.min.css'),
 (13689, 'wp-includes/js/mediaelement/mejs-controls.png'),
 (13690, 'wp-includes/js/mediaelement/mejs-controls.svg'),
 (13691, 'wp-includes/js/mediaelement/renderers/vimeo.js'),
 (13692, 'wp-includes/js/mediaelement/renderers/vimeo.min.js'),
 (13693, 'wp-includes/js/mediaelement/wp-mediaelement.css'),
 (13694, 'wp-includes/js/mediaelement/wp-mediaelement.js'),
 (13695, 'wp-includes/js/mediaelement/wp-mediaelement.min.css'),
 (13696, 'wp-includes/js/mediaelement/wp-mediaelement.min.js'),
 (13697, 'wp-includes/js/mediaelement/wp-playlist.js'),
 (13698, 'wp-includes/js/mediaelement/wp-playlist.min.js'),
 (13699, 'wp-includes/js/plupload/handlers.js'),
 (13700, 'wp-includes/js/plupload/handlers.min.js'),
 (13701, 'wp-includes/js/plupload/license.txt'),
 (13702, 'wp-includes/js/plupload/moxie.js'),
 (13703, 'wp-includes/js/plupload/moxie.min.js'),
 (13704, 'wp-includes/js/plupload/plupload.js'),
 (13705, 'wp-includes/js/plupload/plupload.min.js'),
 (13706, 'wp-includes/js/plupload/wp-plupload.js'),
 (13707, 'wp-includes/js/plupload/wp-plupload.min.js'),
 (13708, 'wp-includes/js/quicktags.js'),
 (13709, 'wp-includes/js/quicktags.min.js'),
 (13710, 'wp-includes/js/shortcode.js'),
 (13711, 'wp-includes/js/shortcode.min.js'),
 (13712, 'wp-includes/js/swfobject.js'),
 (13713, 'wp-includes/js/swfupload/handlers.js'),
 (13714, 'wp-includes/js/swfupload/handlers.min.js'),
 (13715, 'wp-includes/js/swfupload/license.txt'),
 (13716, 'wp-includes/js/swfupload/swfupload.js'),
 (13717, 'wp-includes/js/thickbox/loadingAnimation.gif'),
 (13718, 'wp-includes/js/thickbox/macFFBgHack.png'),
 (13719, 'wp-includes/js/thickbox/thickbox.css'),
 (13720, 'wp-includes/js/thickbox/thickbox.js'),
 (13721, 'wp-includes/js/tinymce/langs/wp-langs-en.js'),
 (13722, 'wp-includes/js/tinymce/license.txt'),
 (13723, 'wp-includes/js/tinymce/plugins/charmap/plugin.js'),
 (13724, 'wp-includes/js/tinymce/plugins/charmap/plugin.min.js'),
 (13725, 'wp-includes/js/tinymce/plugins/colorpicker/plugin.js'),
 (13726, 'wp-includes/js/tinymce/plugins/colorpicker/plugin.min.js'),
 (13727, 'wp-includes/js/tinymce/plugins/compat3x/css/dialog.css'),
 (13728, 'wp-includes/js/tinymce/plugins/compat3x/plugin.js'),
 (13729, 'wp-includes/js/tinymce/plugins/compat3x/plugin.min.js'),
 (13730, 'wp-includes/js/tinymce/plugins/directionality/plugin.js'),
 (13731, 'wp-includes/js/tinymce/plugins/directionality/plugin.min.js'),
 (13732, 'wp-includes/js/tinymce/plugins/fullscreen/plugin.js'),
 (13733, 'wp-includes/js/tinymce/plugins/fullscreen/plugin.min.js'),
 (13734, 'wp-includes/js/tinymce/plugins/hr/plugin.js'),
 (13735, 'wp-includes/js/tinymce/plugins/hr/plugin.min.js'),
 (13736, 'wp-includes/js/tinymce/plugins/image/plugin.js'),
 (13737, 'wp-includes/js/tinymce/plugins/image/plugin.min.js'),
 (13738, 'wp-includes/js/tinymce/plugins/link/plugin.js'),
 (13739, 'wp-includes/js/tinymce/plugins/link/plugin.min.js'),
 (13740, 'wp-includes/js/tinymce/plugins/lists/plugin.js'),
 (13741, 'wp-includes/js/tinymce/plugins/lists/plugin.min.js'),
 (13742, 'wp-includes/js/tinymce/plugins/media/plugin.js'),
 (13743, 'wp-includes/js/tinymce/plugins/media/plugin.min.js'),
 (13744, 'wp-includes/js/tinymce/plugins/paste/plugin.js'),
 (13745, 'wp-includes/js/tinymce/plugins/paste/plugin.min.js'),
 (13746, 'wp-includes/js/tinymce/plugins/tabfocus/plugin.js'),
 (13747, 'wp-includes/js/tinymce/plugins/tabfocus/plugin.min.js'),
 (13748, 'wp-includes/js/tinymce/plugins/textcolor/plugin.js'),
 (13749, 'wp-includes/js/tinymce/plugins/textcolor/plugin.min.js'),
 (13750, 'wp-includes/js/tinymce/plugins/wordpress/plugin.js'),
 (13751, 'wp-includes/js/tinymce/plugins/wordpress/plugin.min.js'),
 (13752, 'wp-includes/js/tinymce/plugins/wpautoresize/plugin.js'),
 (13753, 'wp-includes/js/tinymce/plugins/wpautoresize/plugin.min.js'),
 (13754, 'wp-includes/js/tinymce/plugins/wpdialogs/plugin.js'),
 (13755, 'wp-includes/js/tinymce/plugins/wpdialogs/plugin.min.js'),
 (13756, 'wp-includes/js/tinymce/plugins/wpeditimage/plugin.js'),
 (13757, 'wp-includes/js/tinymce/plugins/wpeditimage/plugin.min.js'),
 (13758, 'wp-includes/js/tinymce/plugins/wpemoji/plugin.js'),
 (13759, 'wp-includes/js/tinymce/plugins/wpemoji/plugin.min.js'),
 (13760, 'wp-includes/js/tinymce/plugins/wpgallery/plugin.js'),
 (13761, 'wp-includes/js/tinymce/plugins/wpgallery/plugin.min.js'),
 (13762, 'wp-includes/js/tinymce/plugins/wplink/plugin.js'),
 (13763, 'wp-includes/js/tinymce/plugins/wplink/plugin.min.js'),
 (13764, 'wp-includes/js/tinymce/plugins/wptextpattern/plugin.js'),
 (13765, 'wp-includes/js/tinymce/plugins/wptextpattern/plugin.min.js'),
 (13766, 'wp-includes/js/tinymce/plugins/wpview/plugin.js'),
 (13767, 'wp-includes/js/tinymce/plugins/wpview/plugin.min.js'),
 (13768, 'wp-includes/js/tinymce/skins/lightgray/content.inline.min.css'),
 (13769, 'wp-includes/js/tinymce/skins/lightgray/content.min.css'),
 (13770, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.eot'),
 (13771, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.svg'),
 (13772, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.ttf'),
 (13773, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce-small.woff'),
 (13774, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.eot'),
 (13775, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.svg'),
 (13776, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.ttf'),
 (13777, 'wp-includes/js/tinymce/skins/lightgray/fonts/tinymce.woff'),
 (13778, 'wp-includes/js/tinymce/skins/lightgray/img/anchor.gif'),
 (13779, 'wp-includes/js/tinymce/skins/lightgray/img/loader.gif'),
 (13780, 'wp-includes/js/tinymce/skins/lightgray/img/object.gif'),
 (13781, 'wp-includes/js/tinymce/skins/lightgray/img/trans.gif'),
 (13782, 'wp-includes/js/tinymce/skins/lightgray/skin.min.css'),
 (13783, 'wp-includes/js/tinymce/skins/wordpress/images/audio.png'),
 (13784, 'wp-includes/js/tinymce/skins/wordpress/images/dashicon-edit.png'),
 (13785, 'wp-includes/js/tinymce/skins/wordpress/images/dashicon-no.png'),
 (13786, 'wp-includes/js/tinymce/skins/wordpress/images/embedded.png'),
 (13787, 'wp-includes/js/tinymce/skins/wordpress/images/gallery-2x.png'),
 (13788, 'wp-includes/js/tinymce/skins/wordpress/images/gallery.png'),
 (13789, 'wp-includes/js/tinymce/skins/wordpress/images/more-2x.png'),
 (13790, 'wp-includes/js/tinymce/skins/wordpress/images/more.png'),
 (13791, 'wp-includes/js/tinymce/skins/wordpress/images/pagebreak-2x.png'),
 (13792, 'wp-includes/js/tinymce/skins/wordpress/images/pagebreak.png'),
 (13793, 'wp-includes/js/tinymce/skins/wordpress/images/playlist-audio.png'),
 (13794, 'wp-includes/js/tinymce/skins/wordpress/images/playlist-video.png'),
 (13795, 'wp-includes/js/tinymce/skins/wordpress/images/video.png'),
 (13796, 'wp-includes/js/tinymce/skins/wordpress/wp-content.css'),
 (13797, 'wp-includes/js/tinymce/themes/inlite/theme.js'),
 (13798, 'wp-includes/js/tinymce/themes/inlite/theme.min.js'),
 (13799, 'wp-includes/js/tinymce/themes/modern/theme.js'),
 (13800, 'wp-includes/js/tinymce/themes/modern/theme.min.js'),
 (13801, 'wp-includes/js/tinymce/tiny_mce_popup.js'),
 (13802, 'wp-includes/js/tinymce/tinymce.min.js'),
 (13803, 'wp-includes/js/tinymce/utils/editable_selects.js'),
 (13804, 'wp-includes/js/tinymce/utils/form_utils.js'),
 (13805, 'wp-includes/js/tinymce/utils/mctabs.js'),
 (13806, 'wp-includes/js/tinymce/utils/validate.js'),
 (13807, 'wp-includes/js/tinymce/wp-tinymce.js'),
 (13808, 'wp-includes/js/tinymce/wp-tinymce.php'),
 (13809, 'wp-includes/js/tw-sack.js'),
 (13810, 'wp-includes/js/tw-sack.min.js'),
 (13811, 'wp-includes/js/twemoji.js'),
 (13812, 'wp-includes/js/twemoji.min.js'),
 (13813, 'wp-includes/js/underscore.js'),
 (13814, 'wp-includes/js/underscore.min.js'),
 (13815, 'wp-includes/js/utils.js'),
 (13816, 'wp-includes/js/utils.min.js'),
 (13817, 'wp-includes/js/wp-ajax-response.js'),
 (13818, 'wp-includes/js/wp-ajax-response.min.js'),
 (13819, 'wp-includes/js/wp-api.js'),
 (13820, 'wp-includes/js/wp-api.min.js'),
 (13821, 'wp-includes/js/wp-auth-check.js'),
 (13822, 'wp-includes/js/wp-auth-check.min.js'),
 (13823, 'wp-includes/js/wp-backbone.js'),
 (13824, 'wp-includes/js/wp-backbone.min.js'),
 (13825, 'wp-includes/js/wp-custom-header.js'),
 (13826, 'wp-includes/js/wp-custom-header.min.js'),
 (13827, 'wp-includes/js/wp-embed-template.js'),
 (13828, 'wp-includes/js/wp-embed-template.min.js'),
 (13829, 'wp-includes/js/wp-embed.js'),
 (13830, 'wp-includes/js/wp-embed.min.js'),
 (13831, 'wp-includes/js/wp-emoji-loader.js'),
 (13832, 'wp-includes/js/wp-emoji-loader.min.js'),
 (13833, 'wp-includes/js/wp-emoji-release.min.js'),
 (13834, 'wp-includes/js/wp-emoji.js'),
 (13835, 'wp-includes/js/wp-emoji.min.js'),
 (13836, 'wp-includes/js/wp-list-revisions.js'),
 (13837, 'wp-includes/js/wp-list-revisions.min.js'),
 (13838, 'wp-includes/js/wp-lists.js'),
 (13839, 'wp-includes/js/wp-lists.min.js'),
 (13840, 'wp-includes/js/wp-pointer.js'),
 (13841, 'wp-includes/js/wp-pointer.min.js'),
 (13842, 'wp-includes/js/wp-sanitize.js'),
 (13843, 'wp-includes/js/wp-sanitize.min.js'),
 (13844, 'wp-includes/js/wp-util.js'),
 (13845, 'wp-includes/js/wp-util.min.js'),
 (13846, 'wp-includes/js/wpdialog.js'),
 (13847, 'wp-includes/js/wpdialog.min.js'),
 (13848, 'wp-includes/js/wplink.js'),
 (13849, 'wp-includes/js/wplink.min.js'),
 (13850, 'wp-includes/js/zxcvbn-async.js'),
 (13851, 'wp-includes/js/zxcvbn-async.min.js'),
 (13852, 'wp-includes/js/zxcvbn.min.js'),
 (13853, 'wp-includes/kses.php'),
 (13854, 'wp-includes/l10n.php'),
 (13855, 'wp-includes/link-template.php'),
 (13856, 'wp-includes/load.php'),
 (13857, 'wp-includes/locale.php'),
 (13858, 'wp-includes/media-template.php'),
 (13859, 'wp-includes/media.php'),
 (13860, 'wp-includes/meta.php'),
 (13861, 'wp-includes/ms-blogs.php'),
 (13862, 'wp-includes/ms-default-constants.php'),
 (13863, 'wp-includes/ms-default-filters.php'),
 (13864, 'wp-includes/ms-deprecated.php'),
 (13865, 'wp-includes/ms-files.php'),
 (13866, 'wp-includes/ms-functions.php'),
 (13867, 'wp-includes/ms-load.php'),
 (13868, 'wp-includes/ms-network.php'),
 (13869, 'wp-includes/ms-settings.php'),
 (13870, 'wp-includes/ms-site.php'),
 (13871, 'wp-includes/nav-menu-template.php'),
 (13872, 'wp-includes/nav-menu.php'),
 (13873, 'wp-includes/option.php'),
 (13874, 'wp-includes/pluggable-deprecated.php'),
 (13875, 'wp-includes/pluggable.php'),
 (13876, 'wp-includes/plugin.php'),
 (13877, 'wp-includes/pomo/entry.php'),
 (13878, 'wp-includes/pomo/mo.php'),
 (13879, 'wp-includes/pomo/plural-forms.php'),
 (13880, 'wp-includes/pomo/po.php'),
 (13881, 'wp-includes/pomo/streams.php'),
 (13882, 'wp-includes/pomo/translations.php'),
 (13883, 'wp-includes/post-formats.php'),
 (13884, 'wp-includes/post-template.php'),
 (13885, 'wp-includes/post-thumbnail-template.php'),
 (13886, 'wp-includes/post.php'),
 (13887, 'wp-includes/query.php'),
 (13888, 'wp-includes/random_compat/byte_safe_strings.php'),
 (13889, 'wp-includes/random_compat/cast_to_int.php'),
 (13890, 'wp-includes/random_compat/error_polyfill.php'),
 (13891, 'wp-includes/random_compat/random.php'),
 (13892, 'wp-includes/random_compat/random_bytes_com_dotnet.php'),
 (13893, 'wp-includes/random_compat/random_bytes_dev_urandom.php'),
 (13894, 'wp-includes/random_compat/random_bytes_libsodium.php'),
 (13895, 'wp-includes/random_compat/random_bytes_libsodium_legacy.php'),
 (13896, 'wp-includes/random_compat/random_bytes_mcrypt.php'),
 (13897, 'wp-includes/random_compat/random_int.php'),
 (13898, 'wp-includes/registration-functions.php'),
 (13899, 'wp-includes/registration.php'),
 (13900, 'wp-includes/rest-api/class-wp-rest-request.php'),
 (13901, 'wp-includes/rest-api/class-wp-rest-response.php'),
 (13902, 'wp-includes/rest-api/class-wp-rest-server.php'),
 (13903, 'wp-includes/rest-api/endpoints/class-wp-rest-attachments-controller.php'),
 (13904, 'wp-includes/rest-api/endpoints/class-wp-rest-autosaves-controller.php'),
 (13905, 'wp-includes/rest-api/endpoints/class-wp-rest-block-renderer-controller.php'),
 (13906, 'wp-includes/rest-api/endpoints/class-wp-rest-blocks-controller.php'),
 (13907, 'wp-includes/rest-api/endpoints/class-wp-rest-comments-controller.php'),
 (13908, 'wp-includes/rest-api/endpoints/class-wp-rest-controller.php'),
 (13909, 'wp-includes/rest-api/endpoints/class-wp-rest-post-statuses-controller.php'),
 (13910, 'wp-includes/rest-api/endpoints/class-wp-rest-post-types-controller.php'),
 (13911, 'wp-includes/rest-api/endpoints/class-wp-rest-posts-controller.php'),
 (13912, 'wp-includes/rest-api/endpoints/class-wp-rest-revisions-controller.php'),
 (13913, 'wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php'),
 (13914, 'wp-includes/rest-api/endpoints/class-wp-rest-settings-controller.php'),
 (13915, 'wp-includes/rest-api/endpoints/class-wp-rest-taxonomies-controller.php'),
 (13916, 'wp-includes/rest-api/endpoints/class-wp-rest-terms-controller.php'),
 (13917, 'wp-includes/rest-api/endpoints/class-wp-rest-themes-controller.php'),
 (13918, 'wp-includes/rest-api/endpoints/class-wp-rest-users-controller.php'),
 (13919, 'wp-includes/rest-api/fields/class-wp-rest-comment-meta-fields.php'),
 (13920, 'wp-includes/rest-api/fields/class-wp-rest-meta-fields.php'),
 (13921, 'wp-includes/rest-api/fields/class-wp-rest-post-meta-fields.php'),
 (13922, 'wp-includes/rest-api/fields/class-wp-rest-term-meta-fields.php'),
 (13923, 'wp-includes/rest-api/fields/class-wp-rest-user-meta-fields.php'),
 (13924, 'wp-includes/rest-api/search/class-wp-rest-post-search-handler.php'),
 (13925, 'wp-includes/rest-api/search/class-wp-rest-search-handler.php'),
 (13926, 'wp-includes/rest-api.php'),
 (13927, 'wp-includes/revision.php'),
 (13928, 'wp-includes/rewrite.php'),
 (13929, 'wp-includes/rss-functions.php'),
 (13930, 'wp-includes/rss.php'),
 (13931, 'wp-includes/script-loader.php'),
 (13932, 'wp-includes/session.php'),
 (13933, 'wp-includes/shortcodes.php'),
 (13934, 'wp-includes/sodium_compat/LICENSE'),
 (13935, 'wp-includes/sodium_compat/autoload.php'),
 (13936, 'wp-includes/sodium_compat/composer.json'),
 (13937, 'wp-includes/sodium_compat/lib/constants.php'),
 (13938, 'wp-includes/sodium_compat/lib/namespaced.php'),
 (13939, 'wp-includes/sodium_compat/lib/php72compat.php'),
 (13940, 'wp-includes/sodium_compat/lib/php72compat_const.php'),
 (13941, 'wp-includes/sodium_compat/lib/sodium_compat.php'),
 (13942, 'wp-includes/sodium_compat/namespaced/Compat.php'),
 (13943, 'wp-includes/sodium_compat/namespaced/Core/BLAKE2b.php'),
 (13944, 'wp-includes/sodium_compat/namespaced/Core/ChaCha20/Ctx.php'),
 (13945, 'wp-includes/sodium_compat/namespaced/Core/ChaCha20/IetfCtx.php'),
 (13946, 'wp-includes/sodium_compat/namespaced/Core/ChaCha20.php'),
 (13947, 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Fe.php'),
 (13948, 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/Cached.php'),
 (13949, 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/P1p1.php'),
 (13950, 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/P2.php'),
 (13951, 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/P3.php'),
 (13952, 'wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge/Precomp.php'),
 (13953, 'wp-includes/sodium_compat/namespaced/Core/Curve25519/H.php'),
 (13954, 'wp-includes/sodium_compat/namespaced/Core/Curve25519.php'),
 (13955, 'wp-includes/sodium_compat/namespaced/Core/Ed25519.php'),
 (13956, 'wp-includes/sodium_compat/namespaced/Core/HChaCha20.php'),
 (13957, 'wp-includes/sodium_compat/namespaced/Core/HSalsa20.php'),
 (13958, 'wp-includes/sodium_compat/namespaced/Core/Poly1305/State.php'),
 (13959, 'wp-includes/sodium_compat/namespaced/Core/Poly1305.php'),
 (13960, 'wp-includes/sodium_compat/namespaced/Core/Salsa20.php'),
 (13961, 'wp-includes/sodium_compat/namespaced/Core/SipHash.php'),
 (13962, 'wp-includes/sodium_compat/namespaced/Core/Util.php'),
 (13963, 'wp-includes/sodium_compat/namespaced/Core/X25519.php'),
 (13964, 'wp-includes/sodium_compat/namespaced/Core/XChaCha20.php'),
 (13965, 'wp-includes/sodium_compat/namespaced/Core/Xsalsa20.php'),
 (13966, 'wp-includes/sodium_compat/namespaced/Crypto.php'),
 (13967, 'wp-includes/sodium_compat/namespaced/File.php'),
 (13968, 'wp-includes/sodium_compat/src/Compat.php'),
 (13969, 'wp-includes/sodium_compat/src/Core/BLAKE2b.php'),
 (13970, 'wp-includes/sodium_compat/src/Core/Base64/Common.php'),
 (13971, 'wp-includes/sodium_compat/src/Core/Base64/Original.php'),
 (13972, 'wp-includes/sodium_compat/src/Core/Base64/UrlSafe.php'),
 (13973, 'wp-includes/sodium_compat/src/Core/ChaCha20/Ctx.php'),
 (13974, 'wp-includes/sodium_compat/src/Core/ChaCha20/IetfCtx.php'),
 (13975, 'wp-includes/sodium_compat/src/Core/ChaCha20.php'),
 (13976, 'wp-includes/sodium_compat/src/Core/Curve25519/Fe.php'),
 (13977, 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/Cached.php'),
 (13978, 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/P1p1.php'),
 (13979, 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/P2.php'),
 (13980, 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/P3.php'),
 (13981, 'wp-includes/sodium_compat/src/Core/Curve25519/Ge/Precomp.php'),
 (13982, 'wp-includes/sodium_compat/src/Core/Curve25519/H.php'),
 (13983, 'wp-includes/sodium_compat/src/Core/Curve25519/README.md'),
 (13984, 'wp-includes/sodium_compat/src/Core/Curve25519.php'),
 (13985, 'wp-includes/sodium_compat/src/Core/Ed25519.php'),
 (13986, 'wp-includes/sodium_compat/src/Core/HChaCha20.php'),
 (13987, 'wp-includes/sodium_compat/src/Core/HSalsa20.php'),
 (13988, 'wp-includes/sodium_compat/src/Core/Poly1305/State.php'),
 (13989, 'wp-includes/sodium_compat/src/Core/Poly1305.php'),
 (13990, 'wp-includes/sodium_compat/src/Core/Salsa20.php'),
 (13991, 'wp-includes/sodium_compat/src/Core/SecretStream/State.php'),
 (13992, 'wp-includes/sodium_compat/src/Core/SipHash.php'),
 (13993, 'wp-includes/sodium_compat/src/Core/Util.php'),
 (13994, 'wp-includes/sodium_compat/src/Core/X25519.php'),
 (13995, 'wp-includes/sodium_compat/src/Core/XChaCha20.php'),
 (13996, 'wp-includes/sodium_compat/src/Core/XSalsa20.php'),
 (13997, 'wp-includes/sodium_compat/src/Core32/BLAKE2b.php'),
 (13998, 'wp-includes/sodium_compat/src/Core32/ChaCha20/Ctx.php'),
 (13999, 'wp-includes/sodium_compat/src/Core32/ChaCha20/IetfCtx.php'),
 (14000, 'wp-includes/sodium_compat/src/Core32/ChaCha20.php');
INSERT INTO `wp8b_wfknownfilelist` VALUES(14001, 'wp-includes/sodium_compat/src/Core32/Curve25519/Fe.php'),
 (14002, 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/Cached.php'),
 (14003, 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/P1p1.php'),
 (14004, 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/P2.php'),
 (14005, 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/P3.php'),
 (14006, 'wp-includes/sodium_compat/src/Core32/Curve25519/Ge/Precomp.php'),
 (14007, 'wp-includes/sodium_compat/src/Core32/Curve25519/H.php'),
 (14008, 'wp-includes/sodium_compat/src/Core32/Curve25519/README.md'),
 (14009, 'wp-includes/sodium_compat/src/Core32/Curve25519.php'),
 (14010, 'wp-includes/sodium_compat/src/Core32/Ed25519.php'),
 (14011, 'wp-includes/sodium_compat/src/Core32/HChaCha20.php'),
 (14012, 'wp-includes/sodium_compat/src/Core32/HSalsa20.php'),
 (14013, 'wp-includes/sodium_compat/src/Core32/Int32.php'),
 (14014, 'wp-includes/sodium_compat/src/Core32/Int64.php'),
 (14015, 'wp-includes/sodium_compat/src/Core32/Poly1305/State.php'),
 (14016, 'wp-includes/sodium_compat/src/Core32/Poly1305.php'),
 (14017, 'wp-includes/sodium_compat/src/Core32/Salsa20.php'),
 (14018, 'wp-includes/sodium_compat/src/Core32/SecretStream/State.php'),
 (14019, 'wp-includes/sodium_compat/src/Core32/SipHash.php'),
 (14020, 'wp-includes/sodium_compat/src/Core32/Util.php'),
 (14021, 'wp-includes/sodium_compat/src/Core32/X25519.php'),
 (14022, 'wp-includes/sodium_compat/src/Core32/XChaCha20.php'),
 (14023, 'wp-includes/sodium_compat/src/Core32/XSalsa20.php'),
 (14024, 'wp-includes/sodium_compat/src/Crypto.php'),
 (14025, 'wp-includes/sodium_compat/src/Crypto32.php'),
 (14026, 'wp-includes/sodium_compat/src/File.php'),
 (14027, 'wp-includes/sodium_compat/src/PHP52/SplFixedArray.php'),
 (14028, 'wp-includes/sodium_compat/src/SodiumException.php'),
 (14029, 'wp-includes/spl-autoload-compat.php'),
 (14030, 'wp-includes/taxonomy.php'),
 (14031, 'wp-includes/template-loader.php'),
 (14032, 'wp-includes/template.php'),
 (14033, 'wp-includes/theme-compat/comments.php'),
 (14034, 'wp-includes/theme-compat/embed-404.php'),
 (14035, 'wp-includes/theme-compat/embed-content.php'),
 (14036, 'wp-includes/theme-compat/embed.php'),
 (14037, 'wp-includes/theme-compat/footer-embed.php'),
 (14038, 'wp-includes/theme-compat/footer.php'),
 (14039, 'wp-includes/theme-compat/header-embed.php'),
 (14040, 'wp-includes/theme-compat/header.php'),
 (14041, 'wp-includes/theme-compat/sidebar.php'),
 (14042, 'wp-includes/theme.php'),
 (14043, 'wp-includes/update.php'),
 (14044, 'wp-includes/user.php'),
 (14045, 'wp-includes/vars.php'),
 (14046, 'wp-includes/version.php'),
 (14047, 'wp-includes/widgets/class-wp-nav-menu-widget.php'),
 (14048, 'wp-includes/widgets/class-wp-widget-archives.php'),
 (14049, 'wp-includes/widgets/class-wp-widget-calendar.php'),
 (14050, 'wp-includes/widgets/class-wp-widget-categories.php'),
 (14051, 'wp-includes/widgets/class-wp-widget-custom-html.php'),
 (14052, 'wp-includes/widgets/class-wp-widget-links.php'),
 (14053, 'wp-includes/widgets/class-wp-widget-media-audio.php'),
 (14054, 'wp-includes/widgets/class-wp-widget-media-gallery.php'),
 (14055, 'wp-includes/widgets/class-wp-widget-media-image.php'),
 (14056, 'wp-includes/widgets/class-wp-widget-media-video.php'),
 (14057, 'wp-includes/widgets/class-wp-widget-media.php'),
 (14058, 'wp-includes/widgets/class-wp-widget-meta.php'),
 (14059, 'wp-includes/widgets/class-wp-widget-pages.php'),
 (14060, 'wp-includes/widgets/class-wp-widget-recent-comments.php'),
 (14061, 'wp-includes/widgets/class-wp-widget-recent-posts.php'),
 (14062, 'wp-includes/widgets/class-wp-widget-rss.php'),
 (14063, 'wp-includes/widgets/class-wp-widget-search.php'),
 (14064, 'wp-includes/widgets/class-wp-widget-tag-cloud.php'),
 (14065, 'wp-includes/widgets/class-wp-widget-text.php'),
 (14066, 'wp-includes/widgets.php'),
 (14067, 'wp-includes/wlwmanifest.xml'),
 (14068, 'wp-includes/wp-db.php'),
 (14069, 'wp-includes/wp-diff.php'),
 (14070, 'wp-links-opml.php'),
 (14071, 'wp-load.php'),
 (14072, 'wp-login.php'),
 (14073, 'wp-mail.php'),
 (14074, 'wp-settings.php'),
 (14075, 'wp-signup.php'),
 (14076, 'wp-trackback.php'),
 (14077, 'xmlrpc.php');

/* INSERT TABLE DATA: wp8b_wflocs */
INSERT INTO `wp8b_wflocs` VALUES('\0\0\0\0\0\0\0\0\0\0KS', 1597160244, 0, 'Bachaquero', 'Miranda', 'Venezuela', 'VE', '10.2616997', '-66.6889038');

/* INSERT TABLE DATA: wp8b_wflogins */
INSERT INTO `wp8b_wflogins` VALUES(1, 1, '1581253106.271224', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.130 Safari/537.36'),
 (2, 4, '1583409905.788661', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0J', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36'),
 (3, 5, '1583633209.778444', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0J', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.132 Safari/537.36'),
 (4, 6, '1583633212.027343', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0J', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.132 Safari/537.36'),
 (5, 7, '1585834273.652143', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0\'1', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.132 Safari/537.36'),
 (6, 11, '1586499441.847534', 1, 'loginFailInvalidUsername', '[login]', 0, '\0\0\0\0\0\0\0\0\0\0xO', 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0'),
 (7, 14, '1588106973.031917', 1, 'loginFailInvalidUsername', 'admin', 0, '\0\0\0\0\0\0\0\0\0\0=^', 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0'),
 (8, 15, '1588141877.036290', 1, 'loginFailInvalidUsername', 'admin', 0, '\0\0\0\0\0\0\0\0\0\0', 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:62.0) Gecko/20100101 Firefox/62.0'),
 (9, 17, '1588675170.055885', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0IL', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.129 Safari/537.36'),
 (10, 18, '1592976347.902099', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0Jw$', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36'),
 (11, 20, '1597070586.002481', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.163 Safari/537.36'),
 (12, 21, '1597160241.999940', 0, 'loginOK', 'demoweb', 1, '\0\0\0\0\0\0\0\0\0\0KS', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36');

/* INSERT TABLE DATA: wp8b_wfls_settings */
INSERT INTO `wp8b_wfls_settings` VALUES('allow-xml-rpc', '1', 'yes'),
 ('captcha-stats', '{\"counts\":[0,0,0,0,0,0,0,0,0,0,0],\"avg\":0}', 'yes'),
 ('delete-deactivation', '', 'yes'),
 ('enable-auth-captcha', '', 'yes'),
 ('global-notices', '[]', 'yes'),
 ('ip-source', '', 'yes'),
 ('ip-trusted-proxies', '', 'yes'),
 ('last-secret-refresh', '1580358269', 'yes'),
 ('ntp-offset', '0.60852646827698', 'yes'),
 ('recaptcha-threshold', '0.5', 'yes'),
 ('remember-device', '', 'yes'),
 ('remember-device-duration', '2592000', 'yes'),
 ('require-2fa-grace-period-enabled', '', 'yes'),
 ('require-2fa.administrator', '', 'yes'),
 ('shared-hash-secret', '70438de0c992bf7b9ecc148ee41bc93e7cf882abd810d694802ded30118f0179', 'yes'),
 ('shared-symmetric-secret', '6ec532ace6e05022f8770d73027f8279d96e45fe438ff73250ffd51ba390fcda', 'yes'),
 ('use-ntp', '', 'yes'),
 ('whitelisted', '', 'yes'),
 ('xmlrpc-enabled', '1', 'yes');

/* INSERT TABLE DATA: wp8b_wfnotifications */
INSERT INTO `wp8b_wfnotifications` VALUES('site-AEAAAAA', 0, 'wfplugin_scan', 502, 1580384422, '<a href=\"https://modelox.vico.digital/wp-admin/admin.php?page=WordfenceScan\">1 issue found in most recent scan</a>', '[]'),
 ('site-BQAAAAA', 0, 'wfplugin_scan', 502, 1581253109, '<a href=\"https://modelox.vico.digital/wp-admin/admin.php?page=WordfenceScan\">1 issue found in most recent scan</a>', '[]'),
 ('site-CEAAAAA', 0, 'wfplugin_updates', 502, 1583410094, '<a href=\"https://modelox.vico.digital/wp-admin/update-core.php\">Updates are available for 3 plugins</a>', '[]'),
 ('site-CYAAAAA', 0, 'wfplugin_updates', 502, 1585836593, '<a href=\"https://modelox.vico.digital/wp-admin/update-core.php\">An update is available for 1 plugin</a>', '[]'),
 ('site-DAAAAAA', 0, 'wfplugin_scan', 502, 1585835450, '<a href=\"https://modelox.vico.digital/wp-admin/admin.php?page=WordfenceScan\">3 issues found in most recent scan</a>', '[]'),
 ('site-DYAAAAA', 0, 'wfplugin_updates', 502, 1587780761, '<a href=\"http://modelox.vico.digital/wp-admin/update-core.php\">An update is available for 1 plugin</a>', '[]'),
 ('site-D4AAAAA', 0, 'wfplugin_updates', 502, 1592976487, '<a href=\"https://modelox.vico.digital/wp-admin/update-core.php\">An update is available for 1 plugin</a>', '[]'),
 ('site-EAAAAAA', 0, 'wfplugin_scan', 502, 1588173307, '<a href=\"https://modelox.vico.digital/wp-admin/admin.php?page=WordfenceScan\">2 issues found in most recent scan</a>', '[]'),
 ('site-FAAAAAA', 0, 'wfplugin_scan', 502, 1588675147, '<a href=\"https://modelox.vico.digital/wp-admin/admin.php?page=WordfenceScan\">2 issues found in most recent scan</a>', '[]'),
 ('site-GEAAAAA', 0, 'wfplugin_updates', 502, 1597070706, '<a href=\"https://modelox.vico.digital/wp-admin/update-core.php\">An update is available for 1 plugin</a>', '[]'),
 ('site-GQAAAAA', 0, 'wfplugin_scan', 502, 1597070622, '<a href=\"https://modelox.vico.digital/wp-admin/admin.php?page=WordfenceScan\">2 issues found in most recent scan</a>', '[]');

/* INSERT TABLE DATA: wp8b_wfreversecache */
INSERT INTO `wp8b_wfreversecache` VALUES('\0\0\0\0\0\0\0\0\0\0KS', '190.75-83-206.dyn.dsl.cantv.net', 1597160243);

/* INSERT TABLE DATA: wp8b_wfstatus */
INSERT INTO `wp8b_wfstatus` VALUES(6010, '1588471188.849736', 2, 'info', 'Scanned contents of 12 additional files at 2.66 per second'),
 (6011, '1588471189.923902', 2, 'info', 'Scanned contents of 14 additional files at 2.51 per second'),
 (6012, '1588471191.053140', 2, 'info', 'Scanned contents of 16 additional files at 2.38 per second'),
 (6013, '1588471192.332738', 2, 'info', 'Scanned contents of 18 additional files at 2.25 per second'),
 (6014, '1588471193.413847', 2, 'info', 'Scanned contents of 20 additional files at 2.20 per second'),
 (6015, '1588471194.555241', 2, 'info', 'Scanned contents of 22 additional files at 2.15 per second'),
 (6016, '1588471195.667415', 2, 'info', 'Scanned contents of 26 additional files at 2.29 per second'),
 (6017, '1588471196.675087', 2, 'info', 'Scanned contents of 66 additional files at 5.35 per second'),
 (6018, '1588471197.681606', 2, 'info', 'Scanned contents of 138 additional files at 10.34 per second'),
 (6019, '1588471198.682959', 2, 'info', 'Scanned contents of 213 additional files at 14.85 per second'),
 (6020, '1588471202.613395', 2, 'info', 'Scanned contents of 240 additional files at 13.13 per second'),
 (6021, '1588471203.618128', 2, 'info', 'Scanned contents of 263 additional files at 13.64 per second'),
 (6022, '1588471204.994061', 2, 'info', 'Scanned contents of 285 additional files at 13.80 per second'),
 (6023, '1588471205.996817', 2, 'info', 'Scanned contents of 312 additional files at 14.40 per second'),
 (6024, '1588471207.032770', 2, 'info', 'Scanned contents of 360 additional files at 15.86 per second'),
 (6025, '1588471208.034953', 2, 'info', 'Scanned contents of 420 additional files at 17.72 per second'),
 (6026, '1588471209.042672', 2, 'info', 'Scanned contents of 486 additional files at 19.67 per second'),
 (6027, '1588471210.099790', 2, 'info', 'Scanned contents of 533 additional files at 20.69 per second'),
 (6028, '1588471211.106480', 2, 'info', 'Scanned contents of 558 additional files at 20.84 per second'),
 (6029, '1588471212.112797', 2, 'info', 'Scanned contents of 591 additional files at 21.28 per second'),
 (6030, '1588471213.146704', 2, 'info', 'Scanned contents of 615 additional files at 21.35 per second'),
 (6031, '1588471214.490723', 2, 'info', 'Scanned contents of 625 additional files at 20.73 per second'),
 (6032, '1588471215.493669', 2, 'info', 'Scanned contents of 647 additional files at 20.76 per second'),
 (6033, '1588471216.501215', 2, 'info', 'Scanned contents of 667 additional files at 20.74 per second'),
 (6034, '1588471217.575732', 2, 'info', 'Scanned contents of 687 additional files at 20.67 per second'),
 (6035, '1588471218.578488', 2, 'info', 'Scanned contents of 737 additional files at 21.52 per second'),
 (6036, '1588471219.595902', 2, 'info', 'Scanned contents of 771 additional files at 21.87 per second'),
 (6037, '1588471220.736506', 2, 'info', 'Scanned contents of 813 additional files at 22.33 per second'),
 (6038, '1588471221.738878', 2, 'info', 'Scanned contents of 828 additional files at 22.14 per second'),
 (6039, '1588471222.765225', 2, 'info', 'Scanned contents of 840 additional files at 21.86 per second'),
 (6040, '1588471223.827530', 2, 'info', 'Scanned contents of 872 additional files at 22.08 per second'),
 (6041, '1588471224.839528', 2, 'info', 'Scanned contents of 896 additional files at 22.12 per second'),
 (6042, '1588471225.840594', 2, 'info', 'Scanned contents of 917 additional files at 22.09 per second'),
 (6043, '1588471226.883046', 2, 'info', 'Scanned contents of 938 additional files at 22.05 per second'),
 (6044, '1588471227.971761', 2, 'info', 'Scanned contents of 946 additional files at 21.68 per second'),
 (6045, '1588471228.978774', 2, 'info', 'Scanned contents of 958 additional files at 21.46 per second'),
 (5618, '1588233614.246679', 2, 'info', 'Scanned contents of 3665 additional files at 36.52 per second'),
 (5647, '1588233649.412374', 2, 'info', 'Scanned contents of 5195 additional files at 38.33 per second'),
 (5648, '1588233650.415089', 2, 'info', 'Scanned contents of 5323 additional files at 38.99 per second'),
 (5649, '1588233651.417284', 2, 'info', 'Scanned contents of 5457 additional files at 39.68 per second'),
 (5650, '1588233652.469432', 2, 'info', 'Scanned contents of 5478 additional files at 39.53 per second'),
 (6046, '1588471232.172879', 2, 'info', 'Scanned contents of 959 additional files at 20.05 per second'),
 (6047, '1588471233.174709', 2, 'info', 'Scanned contents of 968 additional files at 19.82 per second'),
 (6048, '1588471234.264672', 2, 'info', 'Scanned contents of 985 additional files at 19.73 per second'),
 (6049, '1588471235.283898', 2, 'info', 'Scanned contents of 1003 additional files at 19.69 per second'),
 (6050, '1588471236.284962', 2, 'info', 'Scanned contents of 1040 additional files at 20.02 per second'),
 (6051, '1588471237.522317', 2, 'info', 'Scanned contents of 1047 additional files at 19.69 per second'),
 (6052, '1588471238.525412', 2, 'info', 'Scanned contents of 1121 additional files at 20.69 per second'),
 (6053, '1588471239.531847', 2, 'info', 'Scanned contents of 1247 additional files at 22.59 per second'),
 (6054, '1588471240.535490', 2, 'info', 'Scanned contents of 1371 additional files at 24.39 per second'),
 (6055, '1588471241.535628', 2, 'info', 'Scanned contents of 1466 additional files at 25.63 per second'),
 (6056, '1588471242.537927', 2, 'info', 'Scanned contents of 1561 additional files at 26.82 per second'),
 (6057, '1588471243.545914', 2, 'info', 'Scanned contents of 1635 additional files at 27.61 per second'),
 (6058, '1588471244.554324', 2, 'info', 'Scanned contents of 1736 additional files at 28.83 per second'),
 (6059, '1588471245.567386', 2, 'info', 'Scanned contents of 1852 additional files at 30.25 per second'),
 (6060, '1588471246.568881', 2, 'info', 'Scanned contents of 1967 additional files at 31.61 per second'),
 (6061, '1588471247.571394', 2, 'info', 'Scanned contents of 2085 additional files at 32.97 per second'),
 (6062, '1588471249.804908', 2, 'info', 'Scanned contents of 2130 additional files at 32.53 per second'),
 (6063, '1588471250.805883', 2, 'info', 'Scanned contents of 2251 additional files at 33.86 per second'),
 (6064, '1588471251.901065', 2, 'info', 'Scanned contents of 2350 additional files at 34.78 per second'),
 (6065, '1588471252.904125', 2, 'info', 'Scanned contents of 2377 additional files at 34.67 per second'),
 (6066, '1588471253.911605', 2, 'info', 'Scanned contents of 2418 additional files at 34.75 per second'),
 (6067, '1588471254.931082', 2, 'info', 'Scanned contents of 2470 additional files at 34.99 per second'),
 (6068, '1588471255.934238', 2, 'info', 'Scanned contents of 2508 additional files at 35.03 per second'),
 (6069, '1588471257.225561', 2, 'info', 'Scanned contents of 2541 additional files at 34.86 per second'),
 (6070, '1588471258.271069', 2, 'info', 'Scanned contents of 2556 additional files at 34.57 per second'),
 (6071, '1588471259.277656', 2, 'info', 'Scanned contents of 2577 additional files at 34.39 per second'),
 (6159, '1588471358.864968', 2, 'info', 'Scanned contents of 6533 additional files at 37.43 per second'),
 (6160, '1588471359.946693', 2, 'info', 'Scanned contents of 6555 additional files at 37.33 per second'),
 (6161, '1588471360.975634', 2, 'info', 'Scanned contents of 6587 additional files at 37.29 per second'),
 (6162, '1588471361.986645', 2, 'info', 'Scanned contents of 6665 additional files at 37.52 per second'),
 (5628, '1588233624.991474', 2, 'info', 'Scanned contents of 3953 additional files at 35.58 per second'),
 (5629, '1588233625.997394', 2, 'info', 'Scanned contents of 3999 additional files at 35.67 per second'),
 (6163, '1588471362.992470', 2, 'info', 'Scanned contents of 6730 additional files at 37.67 per second'),
 (6164, '1588471363.999005', 2, 'info', 'Scanned contents of 6749 additional files at 37.56 per second'),
 (6165, '1588471365.006966', 2, 'info', 'Scanned contents of 6777 additional files at 37.51 per second'),
 (6166, '1588471366.044221', 2, 'info', 'Scanned contents of 6803 additional files at 37.44 per second'),
 (6167, '1588471367.046411', 2, 'info', 'Scanned contents of 6847 additional files at 37.47 per second'),
 (6173, '1588471373.155048', 2, 'info', 'Scanned contents of 7048 additional files at 37.33 per second'),
 (6174, '1588471374.155101', 2, 'info', 'Scanned contents of 7088 additional files at 37.34 per second'),
 (6175, '1588471375.170123', 2, 'info', 'Scanned contents of 7118 additional files at 37.30 per second'),
 (6176, '1588471376.194839', 2, 'info', 'Scanned contents of 7143 additional files at 37.23 per second'),
 (6177, '1588471377.224603', 2, 'info', 'Scanned contents of 7196 additional files at 37.31 per second'),
 (6178, '1588471378.260786', 2, 'info', 'Scanned contents of 7211 additional files at 37.18 per second'),
 (5967, '1588471154.090409', 2, 'info', 'Analyzed 11000 files containing 120.51 MB of data so far'),
 (5966, '1588471150.387611', 2, 'info', 'Analyzed 10900 files containing 116.67 MB of data so far'),
 (5964, '1588471149.784421', 2, 'info', 'Analyzed 10700 files containing 116.05 MB of data so far'),
 (5965, '1588471150.051365', 2, 'info', 'Analyzed 10800 files containing 116.26 MB of data so far'),
 (6250, '1588471457.149300', 2, 'info', 'Done host key check.'),
 (6249, '1588471456.400901', 2, 'info', 'Checking 5039 host keys against Wordfence scanning servers.'),
 (6248, '1588471456.355989', 2, 'info', 'Asking Wordfence to check URLs against malware list.'),
 (6247, '1588471456.355636', 2, 'info', 'Scanned contents of 9917 additional files at 36.46 per second'),
 (6246, '1588471455.886033', 2, 'info', 'Scanned contents of 9912 additional files at 36.50 per second'),
 (6245, '1588471453.684803', 2, 'info', 'Scanned contents of 9904 additional files at 36.77 per second'),
 (6244, '1588471450.941040', 2, 'info', 'Scanned contents of 9866 additional files at 37.01 per second'),
 (6243, '1588471449.924713', 2, 'info', 'Scanned contents of 9813 additional files at 36.95 per second'),
 (6242, '1588471448.916663', 2, 'info', 'Scanned contents of 9771 additional files at 36.93 per second'),
 (6241, '1588471447.902146', 2, 'info', 'Scanned contents of 9741 additional files at 36.96 per second'),
 (6240, '1588471446.841993', 2, 'info', 'Scanned contents of 9713 additional files at 37.00 per second'),
 (6239, '1588471445.829863', 2, 'info', 'Scanned contents of 9687 additional files at 37.04 per second'),
 (6238, '1588471444.813999', 2, 'info', 'Scanned contents of 9654 additional files at 37.06 per second'),
 (6237, '1588471443.751034', 2, 'info', 'Scanned contents of 9628 additional files at 37.11 per second'),
 (6236, '1588471442.746004', 2, 'info', 'Scanned contents of 9602 additional files at 37.16 per second'),
 (6235, '1588471441.735629', 2, 'info', 'Scanned contents of 9548 additional files at 37.09 per second'),
 (6234, '1588471440.730857', 2, 'info', 'Scanned contents of 9520 additional files at 37.13 per second'),
 (6233, '1588471439.657918', 2, 'info', 'Scanned contents of 9487 additional files at 37.16 per second'),
 (6232, '1588471437.389818', 2, 'info', 'Scanned contents of 9455 additional files at 37.36 per second'),
 (6231, '1588471436.371819', 2, 'info', 'Scanned contents of 9424 additional files at 37.39 per second'),
 (6230, '1588471435.274625', 2, 'info', 'Scanned contents of 9408 additional files at 37.49 per second'),
 (6229, '1588471433.915499', 2, 'info', 'Scanned contents of 9362 additional files at 37.51 per second'),
 (6228, '1588471432.888094', 2, 'info', 'Scanned contents of 9326 additional files at 37.52 per second'),
 (6227, '1588471431.874741', 2, 'info', 'Scanned contents of 9261 additional files at 37.41 per second'),
 (6226, '1588471430.863910', 2, 'info', 'Scanned contents of 9222 additional files at 37.41 per second'),
 (6225, '1588471429.852405', 2, 'info', 'Scanned contents of 9160 additional files at 37.31 per second'),
 (6224, '1588471428.824664', 2, 'info', 'Scanned contents of 9123 additional files at 37.31 per second'),
 (6223, '1588471427.823703', 2, 'info', 'Scanned contents of 9086 additional files at 37.32 per second'),
 (6222, '1588471426.530838', 2, 'info', 'Scanned contents of 9077 additional files at 37.48 per second'),
 (6221, '1588471425.110484', 2, 'info', 'Scanned contents of 9045 additional files at 37.57 per second'),
 (6220, '1588471424.048497', 2, 'info', 'Scanned contents of 8993 additional files at 37.52 per second'),
 (6219, '1588471423.031736', 2, 'info', 'Scanned contents of 8944 additional files at 37.47 per second'),
 (6218, '1588471422.009909', 2, 'info', 'Scanned contents of 8914 additional files at 37.51 per second'),
 (6217, '1588471420.993952', 2, 'info', 'Scanned contents of 8899 additional files at 37.60 per second'),
 (6216, '1588471419.956028', 2, 'info', 'Scanned contents of 8838 additional files at 37.51 per second'),
 (6215, '1588471418.949412', 2, 'info', 'Scanned contents of 8789 additional files at 37.46 per second'),
 (6214, '1588471417.940042', 2, 'info', 'Scanned contents of 8757 additional files at 37.49 per second'),
 (6213, '1588471416.938661', 2, 'info', 'Scanned contents of 8752 additional files at 37.63 per second'),
 (6212, '1588471415.919906', 2, 'info', 'Scanned contents of 8735 additional files at 37.72 per second'),
 (6211, '1588471414.905173', 2, 'info', 'Scanned contents of 8716 additional files at 37.80 per second'),
 (6210, '1588471413.685347', 2, 'info', 'Scanned contents of 8687 additional files at 37.88 per second'),
 (6209, '1588471412.680575', 2, 'info', 'Scanned contents of 8641 additional files at 37.84 per second'),
 (6208, '1588471411.632999', 2, 'info', 'Scanned contents of 8608 additional files at 37.87 per second'),
 (6207, '1588471410.622326', 2, 'info', 'Scanned contents of 8582 additional files at 37.93 per second'),
 (6206, '1588471409.560284', 2, 'info', 'Scanned contents of 8527 additional files at 37.86 per second'),
 (6205, '1588471408.557241', 2, 'info', 'Scanned contents of 8465 additional files at 37.75 per second'),
 (6204, '1588471407.545822', 2, 'info', 'Scanned contents of 8409 additional files at 37.67 per second'),
 (6203, '1588471406.539017', 2, 'info', 'Scanned contents of 8328 additional files at 37.48 per second'),
 (6202, '1588471405.497797', 2, 'info', 'Scanned contents of 8272 additional files at 37.40 per second'),
 (6201, '1588471404.492085', 2, 'info', 'Scanned contents of 8217 additional files at 37.32 per second'),
 (6200, '1588471403.477606', 2, 'info', 'Scanned contents of 8175 additional files at 37.30 per second'),
 (6199, '1588471402.474321', 2, 'info', 'Scanned contents of 8131 additional files at 37.27 per second'),
 (6198, '1588471401.443180', 2, 'info', 'Scanned contents of 8099 additional files at 37.30 per second'),
 (6197, '1588471400.440640', 2, 'info', 'Scanned contents of 8074 additional files at 37.36 per second'),
 (6196, '1588471399.419318', 2, 'info', 'Scanned contents of 8010 additional files at 37.24 per second'),
 (6195, '1588471398.394132', 2, 'info', 'Scanned contents of 7954 additional files at 37.16 per second'),
 (6194, '1588471397.383439', 2, 'info', 'Scanned contents of 7901 additional files at 37.09 per second'),
 (6193, '1588471395.542785', 2, 'info', 'Scanned contents of 7899 additional files at 37.40 per second'),
 (6192, '1588471394.528188', 2, 'info', 'Scanned contents of 7869 additional files at 37.44 per second'),
 (6191, '1588471393.445330', 2, 'info', 'Scanned contents of 7830 additional files at 37.44 per second'),
 (6190, '1588471392.438509', 2, 'info', 'Scanned contents of 7738 additional files at 37.18 per second'),
 (6189, '1588471389.824921', 2, 'info', 'Scanned contents of 7725 additional files at 37.59 per second'),
 (6188, '1588471388.823829', 2, 'info', 'Scanned contents of 7653 additional files at 37.43 per second'),
 (6187, '1588471387.814405', 2, 'info', 'Scanned contents of 7576 additional files at 37.23 per second'),
 (6186, '1588471386.801927', 2, 'info', 'Scanned contents of 7493 additional files at 37.01 per second'),
 (6185, '1588471385.800159', 2, 'info', 'Scanned contents of 7436 additional files at 36.91 per second'),
 (6184, '1588471384.777115', 2, 'info', 'Scanned contents of 7398 additional files at 36.91 per second'),
 (6183, '1588471383.764832', 2, 'info', 'Scanned contents of 7365 additional files at 36.93 per second'),
 (6182, '1588471382.735550', 2, 'info', 'Scanned contents of 7317 additional files at 36.88 per second'),
 (6181, '1588471381.702857', 2, 'info', 'Scanned contents of 7316 additional files at 37.07 per second'),
 (6180, '1588471380.273298', 2, 'info', 'Scanned contents of 7306 additional files at 37.29 per second'),
 (6179, '1588471379.260951', 2, 'info', 'Scanned contents of 7252 additional files at 37.20 per second'),
 (6072, '1588471260.290253', 2, 'info', 'Scanned contents of 2623 additional files at 34.53 per second'),
 (5652, '1588233654.769081', 2, 'info', 'Scanned contents of 5498 additional files at 39.03 per second'),
 (5651, '1588233653.543773', 2, 'info', 'Scanned contents of 5483 additional files at 39.26 per second'),
 (5653, '1588233655.820606', 2, 'info', 'Scanned contents of 5542 additional files at 39.05 per second'),
 (5654, '1588233656.859427', 2, 'info', 'Scanned contents of 5554 additional files at 38.85 per second'),
 (5655, '1588233657.897465', 2, 'info', 'Scanned contents of 5578 additional files at 38.73 per second'),
 (5656, '1588233658.913242', 2, 'info', 'Scanned contents of 5596 additional files at 38.59 per second'),
 (5657, '1588233659.936265', 2, 'info', 'Scanned contents of 5614 additional files at 38.44 per second'),
 (6073, '1588471261.374677', 2, 'info', 'Scanned contents of 2653 additional files at 34.44 per second'),
 (6074, '1588471262.406731', 2, 'info', 'Scanned contents of 2677 additional files at 34.29 per second'),
 (5619, '1588233615.248248', 2, 'info', 'Scanned contents of 3688 additional files at 36.39 per second'),
 (5620, '1588233616.336080', 2, 'info', 'Scanned contents of 3715 additional files at 36.26 per second'),
 (5621, '1588233617.338489', 2, 'info', 'Scanned contents of 3738 additional files at 36.13 per second'),
 (5622, '1588233618.347498', 2, 'info', 'Scanned contents of 3788 additional files at 36.26 per second'),
 (5623, '1588233619.424754', 2, 'info', 'Scanned contents of 3829 additional files at 36.28 per second'),
 (6075, '1588471263.455828', 2, 'info', 'Scanned contents of 2736 additional files at 34.58 per second'),
 (5658, '1588233660.966245', 2, 'info', 'Scanned contents of 5645 additional files at 38.38 per second'),
 (5659, '1588233662.090579', 2, 'info', 'Scanned contents of 5661 additional files at 38.20 per second'),
 (5660, '1588233663.097840', 2, 'info', 'Scanned contents of 5716 additional files at 38.31 per second'),
 (5661, '1588233664.108628', 2, 'info', 'Scanned contents of 5780 additional files at 38.48 per second'),
 (5662, '1588233665.117615', 2, 'info', 'Scanned contents of 5853 additional files at 38.70 per second'),
 (6076, '1588471264.466509', 2, 'info', 'Scanned contents of 2757 additional files at 34.41 per second'),
 (6077, '1588471265.478684', 2, 'info', 'Scanned contents of 2779 additional files at 34.25 per second'),
 (6078, '1588471266.509448', 2, 'info', 'Scanned contents of 2806 additional files at 34.15 per second'),
 (5663, '1588233666.359921', 2, 'info', 'Scanned contents of 5914 additional files at 38.79 per second'),
 (6079, '1588471267.552949', 2, 'info', 'Scanned contents of 2837 additional files at 34.09 per second'),
 (5624, '1588233620.548697', 2, 'info', 'Scanned contents of 3857 additional files at 36.16 per second'),
 (5978, '1588471160.189597', 2, 'info', 'Analyzed 12100 files containing 128.81 MB of data so far'),
 (5979, '1588471161.269524', 2, 'info', 'Analyzed 12200 files containing 130.64 MB of data so far'),
 (5980, '1588471161.865572', 2, 'info', 'Analyzed 12300 files containing 131.51 MB of data so far'),
 (5981, '1588471162.295375', 2, 'info', 'Analyzed 12400 files containing 132.11 MB of data so far'),
 (5982, '1588471163.689107', 2, 'info', 'Analyzed 12500 files containing 134.55 MB of data so far'),
 (5983, '1588471164.174414', 2, 'info', 'Analyzed 12600 files containing 135.19 MB of data so far'),
 (5984, '1588471164.838857', 2, 'info', 'Analyzed 12700 files containing 136.26 MB of data so far'),
 (5985, '1588471165.672668', 2, 'info', 'Analyzed 12800 files containing 137.7 MB of data so far'),
 (5646, '1588233648.404548', 2, 'info', 'Scanned contents of 5076 additional files at 37.74 per second'),
 (5989, '1588471168.954282', 2, 'info', 'Analyzed 13200 files containing 145.89 MB of data so far'),
 (5990, '1588471170.354468', 2, 'info', 'Analyzed 13300 files containing 148.75 MB of data so far'),
 (5991, '1588471170.771461', 2, 'info', 'Analyzed 13400 files containing 150.13 MB of data so far'),
 (5992, '1588471173.623345', 2, 'info', 'Analyzed 13500 files containing 155.35 MB of data so far'),
 (5993, '1588471177.799515', 2, 'info', 'Analyzed 13600 files containing 163.46 MB of data so far'),
 (5994, '1588471178.852436', 2, 'info', 'Analyzed 13700 files containing 165.34 MB of data so far'),
 (5995, '1588471180.157873', 2, 'info', 'Analyzed 13800 files containing 167.56 MB of data so far'),
 (5996, '1588471181.554458', 2, 'info', 'Analyzed 13900 files containing 171.18 MB of data so far'),
 (5997, '1588471181.907606', 2, 'info', 'Analyzed 14000 files containing 172.46 MB of data so far'),
 (5998, '1588471182.345379', 2, 'info', 'Analyzed 14077 files containing 173.85 MB of data.'),
 (5999, '1588471182.345640', 10, 'info', 'SUM_ENDOK:Comparing core WordPress files against originals in repository'),
 (6000, '1588471182.350356', 10, 'info', 'SUM_ENDOK:Scanning for unknown files in wp-admin and wp-includes'),
 (6001, '1588471182.354782', 10, 'info', 'SUM_ENDOK:Scanning for known malware files'),
 (6002, '1588471182.363241', 10, 'info', 'SUM_START:Check for publicly accessible configuration files, backup files and logs'),
 (6003, '1588471183.020263', 10, 'info', 'SUM_ENDOK:Check for publicly accessible configuration files, backup files and logs'),
 (6004, '1588471183.028358', 10, 'info', 'SUM_START:Scanning file contents for infections and vulnerabilities'),
 (6005, '1588471183.030735', 10, 'info', 'SUM_START:Scanning file contents for URLs on a domain blacklist'),
 (6006, '1588471184.333897', 2, 'info', 'Starting scan of file contents'),
 (6007, '1588471185.590540', 2, 'info', 'Scanned contents of 6 additional files at 4.78 per second'),
 (6008, '1588471186.669167', 2, 'info', 'Scanned contents of 8 additional files at 3.43 per second'),
 (6009, '1588471187.750675', 2, 'info', 'Scanned contents of 10 additional files at 2.93 per second'),
 (6168, '1588471368.049541', 2, 'info', 'Scanned contents of 6885 additional files at 37.48 per second'),
 (6169, '1588471369.069008', 2, 'info', 'Scanned contents of 6925 additional files at 37.49 per second'),
 (6170, '1588471370.114896', 2, 'info', 'Scanned contents of 6951 additional files at 37.42 per second'),
 (6171, '1588471371.137033', 2, 'info', 'Scanned contents of 6982 additional files at 37.38 per second'),
 (6172, '1588471372.140689', 2, 'info', 'Scanned contents of 7014 additional files at 37.35 per second'),
 (5630, '1588233627.001211', 2, 'info', 'Scanned contents of 4039 additional files at 35.71 per second'),
 (5631, '1588233628.122651', 2, 'info', 'Scanned contents of 4056 additional files at 35.51 per second'),
 (5632, '1588233631.913513', 2, 'info', 'Scanned contents of 4069 additional files at 34.48 per second'),
 (5633, '1588233632.916945', 2, 'info', 'Scanned contents of 4079 additional files at 34.27 per second'),
 (5634, '1588233633.969178', 2, 'info', 'Scanned contents of 4095 additional files at 34.10 per second'),
 (5781, '1588233777.207219', 10, 'info', 'SUM_START:Scanning for weak passwords'),
 (5780, '1588233777.198930', 10, 'info', 'SUM_ENDOK:Scanning comments for URLs on a domain blacklist'),
 (5975, '1588471158.478461', 2, 'info', 'Analyzed 11800 files containing 126.27 MB of data so far'),
 (5976, '1588471159.234421', 2, 'info', 'Analyzed 11900 files containing 127.37 MB of data so far'),
 (5977, '1588471159.871374', 2, 'info', 'Analyzed 12000 files containing 128.39 MB of data so far'),
 (5917, '1588471122.073768', 2, 'info', 'Analyzed 6000 files containing 76.39 MB of data so far'),
 (5918, '1588471122.526953', 2, 'info', 'Analyzed 6100 files containing 77.16 MB of data so far'),
 (5919, '1588471123.115612', 2, 'info', 'Analyzed 6200 files containing 77.99 MB of data so far'),
 (5920, '1588471123.347361', 2, 'info', 'Analyzed 6300 files containing 78.15 MB of data so far'),
 (5921, '1588471123.738428', 2, 'info', 'Analyzed 6400 files containing 78.64 MB of data so far'),
 (5922, '1588471124.080371', 2, 'info', 'Analyzed 6500 files containing 78.99 MB of data so far'),
 (5923, '1588471124.393290', 2, 'info', 'Analyzed 6600 files containing 79.31 MB of data so far'),
 (5924, '1588471125.133718', 2, 'info', 'Analyzed 6700 files containing 80.46 MB of data so far'),
 (5925, '1588471126.293340', 2, 'info', 'Analyzed 6800 files containing 82.32 MB of data so far'),
 (5926, '1588471126.823282', 2, 'info', 'Analyzed 6900 files containing 83.06 MB of data so far'),
 (5927, '1588471127.866498', 2, 'info', 'Analyzed 7000 files containing 84.87 MB of data so far'),
 (5928, '1588471128.810770', 2, 'info', 'Analyzed 7100 files containing 86.44 MB of data so far'),
 (5929, '1588471130.562917', 2, 'info', 'Analyzed 7200 files containing 89.72 MB of data so far'),
 (5930, '1588471131.194403', 2, 'info', 'Analyzed 7300 files containing 90.39 MB of data so far'),
 (5931, '1588471131.406492', 2, 'info', 'Analyzed 7400 files containing 90.42 MB of data so far'),
 (5932, '1588471131.705297', 2, 'info', 'Analyzed 7500 files containing 90.45 MB of data so far'),
 (5933, '1588471132.227566', 2, 'info', 'Analyzed 7600 files containing 91.26 MB of data so far'),
 (5934, '1588471132.675303', 2, 'info', 'Analyzed 7700 files containing 91.96 MB of data so far'),
 (5935, '1588471133.132511', 2, 'info', 'Analyzed 7800 files containing 92.66 MB of data so far'),
 (5936, '1588471133.435501', 2, 'info', 'Analyzed 7900 files containing 92.93 MB of data so far'),
 (5937, '1588471133.646385', 2, 'info', 'Analyzed 8000 files containing 92.95 MB of data so far'),
 (5938, '1588471133.885412', 2, 'info', 'Analyzed 8100 files containing 92.98 MB of data so far'),
 (5939, '1588471134.098626', 2, 'info', 'Analyzed 8200 files containing 93.01 MB of data so far'),
 (5940, '1588471134.304660', 2, 'info', 'Analyzed 8300 files containing 93.04 MB of data so far'),
 (5941, '1588471134.499549', 2, 'info', 'Analyzed 8400 files containing 93.07 MB of data so far'),
 (5942, '1588471134.711423', 2, 'info', 'Analyzed 8500 files containing 93.1 MB of data so far'),
 (5943, '1588471136.441525', 2, 'info', 'Analyzed 8600 files containing 96.1 MB of data so far'),
 (5944, '1588471137.805925', 2, 'info', 'Analyzed 8700 files containing 98.59 MB of data so far'),
 (5945, '1588471138.245410', 2, 'info', 'Analyzed 8800 files containing 99.14 MB of data so far'),
 (5946, '1588471138.463606', 2, 'info', 'Analyzed 8900 files containing 99.31 MB of data so far'),
 (5947, '1588471138.849359', 2, 'info', 'Analyzed 9000 files containing 99.81 MB of data so far'),
 (5948, '1588471139.230634', 2, 'info', 'Analyzed 9100 files containing 100.16 MB of data so far'),
 (5949, '1588471139.598487', 2, 'info', 'Analyzed 9200 files containing 100.42 MB of data so far'),
 (5950, '1588471139.878371', 2, 'info', 'Analyzed 9300 files containing 100.71 MB of data so far'),
 (5951, '1588471140.720409', 2, 'info', 'Analyzed 9400 files containing 102.11 MB of data so far'),
 (5952, '1588471140.939371', 2, 'info', 'Analyzed 9500 files containing 102.18 MB of data so far'),
 (5953, '1588471141.794767', 2, 'info', 'Analyzed 9600 files containing 103.53 MB of data so far'),
 (5954, '1588471142.490350', 2, 'info', 'Analyzed 9700 files containing 104.53 MB of data so far'),
 (5955, '1588471143.669255', 2, 'info', 'Analyzed 9800 files containing 106.47 MB of data so far'),
 (5956, '1588471144.308489', 2, 'info', 'Analyzed 9900 files containing 107.47 MB of data so far'),
 (5957, '1588471144.943368', 2, 'info', 'Analyzed 10000 files containing 108.5 MB of data so far'),
 (5958, '1588471145.620652', 2, 'info', 'Analyzed 10100 files containing 109.64 MB of data so far'),
 (5959, '1588471146.343441', 2, 'info', 'Analyzed 10200 files containing 110.73 MB of data so far'),
 (5960, '1588471146.944418', 2, 'info', 'Analyzed 10300 files containing 111.61 MB of data so far'),
 (5961, '1588471148.532435', 2, 'info', 'Analyzed 10400 files containing 114.43 MB of data so far'),
 (5962, '1588471149.071525', 2, 'info', 'Analyzed 10500 files containing 115.24 MB of data so far'),
 (5963, '1588471149.343368', 2, 'info', 'Analyzed 10600 files containing 115.44 MB of data so far'),
 (6288, '1588675147.864713', 1, 'info', '-------------------'),
 (6289, '1588675147.865254', 2, 'info', 'Wordfence used 0 B of memory for scan. Server peak memory usage was: 80.5 MB'),
 (6251, '1588471457.151310', 2, 'info', 'Checking 7 URLs from 7 sources.'),
 (6290, '1588675147.865437', 1, 'info', 'Quick Scan Complete. Scanned in less than 1 second.'),
 (6291, '1588675147.865597', 10, 'info', 'SUM_FINAL:Scan complete. You have 2 new issues to fix. See below.'),
 (5986, '1588471166.206922', 2, 'info', 'Analyzed 12900 files containing 138.53 MB of data so far'),
 (5987, '1588471167.951391', 2, 'info', 'Analyzed 13000 files containing 143.06 MB of data so far'),
 (5604, '1588233598.837153', 2, 'info', 'Scanned contents of 3059 additional files at 36.01 per second'),
 (5988, '1588471168.332083', 2, 'info', 'Analyzed 13100 files containing 143.72 MB of data so far'),
 (5605, '1588233599.837557', 2, 'info', 'Scanned contents of 3098 additional files at 36.04 per second'),
 (5606, '1588233600.844735', 2, 'info', 'Scanned contents of 3168 additional files at 36.43 per second'),
 (5607, '1588233601.909444', 2, 'info', 'Scanned contents of 3229 additional files at 36.68 per second'),
 (5608, '1588233602.917788', 2, 'info', 'Scanned contents of 3251 additional files at 36.52 per second'),
 (5609, '1588233603.934712', 2, 'info', 'Scanned contents of 3291 additional files at 36.55 per second'),
 (5610, '1588233605.198215', 2, 'info', 'Scanned contents of 3325 additional files at 36.41 per second'),
 (5611, '1588233606.200035', 2, 'info', 'Scanned contents of 3369 additional files at 36.50 per second'),
 (5612, '1588233607.208376', 2, 'info', 'Scanned contents of 3420 additional files at 36.65 per second'),
 (5613, '1588233608.220124', 2, 'info', 'Scanned contents of 3490 additional files at 37.00 per second'),
 (5614, '1588233609.280695', 2, 'info', 'Scanned contents of 3553 additional files at 37.25 per second'),
 (5615, '1588233610.283375', 2, 'info', 'Scanned contents of 3584 additional files at 37.18 per second'),
 (5616, '1588233611.297663', 2, 'info', 'Scanned contents of 3604 additional files at 37.00 per second'),
 (5617, '1588233612.310445', 2, 'info', 'Scanned contents of 3639 additional files at 36.97 per second'),
 (5645, '1588233647.399346', 2, 'info', 'Scanned contents of 4944 additional files at 37.03 per second'),
 (5644, '1588233646.392330', 2, 'info', 'Scanned contents of 4809 additional files at 36.29 per second'),
 (5643, '1588233645.385323', 2, 'info', 'Scanned contents of 4706 additional files at 35.79 per second'),
 (5642, '1588233644.383739', 2, 'info', 'Scanned contents of 4614 additional files at 35.36 per second'),
 (5641, '1588233641.405029', 2, 'info', 'Scanned contents of 4559 additional files at 35.75 per second'),
 (5640, '1588233640.398068', 2, 'info', 'Scanned contents of 4468 additional files at 35.32 per second'),
 (5639, '1588233639.392096', 2, 'info', 'Scanned contents of 4349 additional files at 34.65 per second'),
 (5638, '1588233638.389564', 2, 'info', 'Scanned contents of 4226 additional files at 33.94 per second'),
 (5637, '1588233637.386690', 2, 'info', 'Scanned contents of 4157 additional files at 33.66 per second'),
 (5636, '1588233636.042231', 2, 'info', 'Scanned contents of 4150 additional files at 33.97 per second'),
 (5635, '1588233634.996199', 2, 'info', 'Scanned contents of 4115 additional files at 33.98 per second'),
 (5480, '1588233485.523784', 2, 'info', 'Analyzed 9800 files containing 106.47 MB of data so far'),
 (5479, '1588233484.304837', 2, 'info', 'Analyzed 9700 files containing 104.53 MB of data so far'),
 (5478, '1588233483.449822', 2, 'info', 'Analyzed 9600 files containing 103.53 MB of data so far'),
 (5477, '1588233482.386898', 2, 'info', 'Analyzed 9500 files containing 102.18 MB of data so far'),
 (5476, '1588233482.142742', 2, 'info', 'Analyzed 9400 files containing 102.11 MB of data so far'),
 (5475, '1588233481.271669', 2, 'info', 'Analyzed 9300 files containing 100.71 MB of data so far'),
 (5345, '1588233413.388808', 10, 'info', 'SUM_START:Fetching list of known malware files from Wordfence'),
 (5346, '1588233413.391930', 10, 'info', 'SUM_ENDSUCCESS:Fetching list of known malware files from Wordfence'),
 (5347, '1588233413.396559', 10, 'info', 'SUM_START:Fetching list of known core files from Wordfence'),
 (5348, '1588233413.397818', 10, 'info', 'SUM_ENDSUCCESS:Fetching list of known core files from Wordfence'),
 (5349, '1588233413.401906', 10, 'info', 'SUM_START:Comparing core WordPress files against originals in repository'),
 (5350, '1588233413.404796', 10, 'info', 'SUM_DISABLED:Skipping theme scan'),
 (5351, '1588233413.405294', 10, 'info', 'SUM_DISABLED:Skipping plugin scan'),
 (5352, '1588233413.407495', 10, 'info', 'SUM_START:Scanning for known malware files'),
 (5353, '1588233413.412060', 10, 'info', 'SUM_START:Scanning for unknown files in wp-admin and wp-includes'),
 (5364, '1588233414.365056', 2, 'info', '5500 files indexed'),
 (5365, '1588233414.444499', 2, 'info', '6000 files indexed'),
 (5366, '1588233414.849484', 2, 'info', '6500 files indexed'),
 (5367, '1588233415.049027', 2, 'info', '7000 files indexed'),
 (5368, '1588233415.514313', 2, 'info', '7500 files indexed'),
 (5369, '1588233415.647295', 2, 'info', '8000 files indexed'),
 (5370, '1588233415.675341', 2, 'info', '8500 files indexed'),
 (5371, '1588233415.972740', 2, 'info', '9000 files indexed'),
 (5372, '1588233416.303105', 2, 'info', '9500 files indexed'),
 (5373, '1588233416.723444', 2, 'info', '10000 files indexed'),
 (5374, '1588233417.115700', 2, 'info', '10500 files indexed'),
 (5375, '1588233417.663051', 2, 'info', '11000 files indexed'),
 (5376, '1588233417.791211', 2, 'info', '11500 files indexed'),
 (5377, '1588233418.297607', 2, 'info', '12000 files indexed'),
 (5378, '1588233418.899462', 2, 'info', '12500 files indexed'),
 (5379, '1588233419.962907', 2, 'info', '13000 files indexed'),
 (5380, '1588233419.976517', 2, 'info', '13500 files indexed'),
 (5381, '1588233419.991120', 2, 'info', '14000 files indexed'),
 (5382, '1588233419.993687', 2, 'info', '14077 files indexed'),
 (5383, '1588233420.141632', 2, 'info', 'Analyzed 100 files containing 1.46 MB of data so far'),
 (5384, '1588233420.311276', 2, 'info', 'Analyzed 200 files containing 2.55 MB of data so far'),
 (5385, '1588233420.431991', 2, 'info', 'Analyzed 300 files containing 3.88 MB of data so far'),
 (5386, '1588233420.574020', 2, 'info', 'Analyzed 400 files containing 6.35 MB of data so far'),
 (5387, '1588233420.690737', 2, 'info', 'Analyzed 500 files containing 7.16 MB of data so far'),
 (5388, '1588233423.187066', 2, 'info', 'Analyzed 600 files containing 12.19 MB of data so far'),
 (5389, '1588233423.795682', 2, 'info', 'Analyzed 700 files containing 12.99 MB of data so far'),
 (5390, '1588233424.063642', 2, 'info', 'Analyzed 800 files containing 13.13 MB of data so far'),
 (5391, '1588233424.563972', 2, 'info', 'Analyzed 900 files containing 13.63 MB of data so far'),
 (5392, '1588233424.969649', 2, 'info', 'Analyzed 1000 files containing 14 MB of data so far'),
 (5393, '1588233425.233300', 2, 'info', 'Analyzed 1100 files containing 14.32 MB of data so far'),
 (5394, '1588233425.539363', 2, 'info', 'Analyzed 1200 files containing 15.59 MB of data so far'),
 (5395, '1588233426.460290', 2, 'info', 'Analyzed 1300 files containing 17.31 MB of data so far'),
 (5396, '1588233427.105935', 2, 'info', 'Analyzed 1400 files containing 18.38 MB of data so far'),
 (5397, '1588233427.982123', 2, 'info', 'Analyzed 1500 files containing 19.92 MB of data so far'),
 (5398, '1588233428.690782', 2, 'info', 'Analyzed 1600 files containing 21.1 MB of data so far'),
 (5399, '1588233430.438573', 2, 'info', 'Analyzed 1700 files containing 25.04 MB of data so far'),
 (5400, '1588233430.769666', 2, 'info', 'Analyzed 1800 files containing 26.01 MB of data so far'),
 (5401, '1588233430.981720', 2, 'info', 'Analyzed 1900 files containing 26.04 MB of data so far'),
 (5402, '1588233431.176639', 2, 'info', 'Analyzed 2000 files containing 26.06 MB of data so far'),
 (5403, '1588233431.715756', 2, 'info', 'Analyzed 2100 files containing 26.83 MB of data so far'),
 (5404, '1588233432.156642', 2, 'info', 'Analyzed 2200 files containing 27.52 MB of data so far'),
 (5405, '1588233432.617858', 2, 'info', 'Analyzed 2300 files containing 28.24 MB of data so far'),
 (5406, '1588233432.921100', 2, 'info', 'Analyzed 2400 files containing 28.55 MB of data so far'),
 (5407, '1588233433.193646', 2, 'info', 'Analyzed 2500 files containing 28.57 MB of data so far'),
 (5408, '1588233433.414692', 2, 'info', 'Analyzed 2600 files containing 28.6 MB of data so far'),
 (5409, '1588233433.653710', 2, 'info', 'Analyzed 2700 files containing 28.63 MB of data so far'),
 (5410, '1588233433.856663', 2, 'info', 'Analyzed 2800 files containing 28.66 MB of data so far'),
 (5411, '1588233434.086671', 2, 'info', 'Analyzed 2900 files containing 28.69 MB of data so far'),
 (5412, '1588233434.286809', 2, 'info', 'Analyzed 3000 files containing 28.72 MB of data so far'),
 (5413, '1588233435.584721', 2, 'info', 'Analyzed 3100 files containing 31.6 MB of data so far'),
 (5414, '1588233436.072670', 2, 'info', 'Analyzed 3200 files containing 32.3 MB of data so far'),
 (5415, '1588233437.458742', 2, 'info', 'Analyzed 3300 files containing 34.87 MB of data so far'),
 (5416, '1588233442.916054', 2, 'info', 'Analyzed 3400 files containing 45.49 MB of data so far'),
 (5417, '1588233444.946712', 2, 'info', 'Analyzed 3500 files containing 49.1 MB of data so far'),
 (5418, '1588233445.214640', 2, 'info', 'Analyzed 3600 files containing 49.33 MB of data so far'),
 (5419, '1588233445.421712', 2, 'info', 'Analyzed 3700 files containing 49.45 MB of data so far'),
 (5420, '1588233445.919152', 2, 'info', 'Analyzed 3800 files containing 50.09 MB of data so far'),
 (5421, '1588233446.345637', 2, 'info', 'Analyzed 3900 files containing 50.62 MB of data so far'),
 (5422, '1588233446.612682', 2, 'info', 'Analyzed 4000 files containing 50.91 MB of data so far'),
 (5423, '1588233446.859654', 2, 'info', 'Analyzed 4100 files containing 51.16 MB of data so far'),
 (5424, '1588233447.672642', 2, 'info', 'Analyzed 4200 files containing 52.55 MB of data so far'),
 (5425, '1588233447.869656', 2, 'info', 'Analyzed 4300 files containing 52.63 MB of data so far'),
 (5426, '1588233448.209852', 2, 'info', 'Analyzed 4400 files containing 52.99 MB of data so far'),
 (5427, '1588233448.955715', 2, 'info', 'Analyzed 4500 files containing 54.09 MB of data so far'),
 (5428, '1588233450.037764', 2, 'info', 'Analyzed 4600 files containing 55.92 MB of data so far'),
 (5429, '1588233455.672786', 2, 'info', 'Analyzed 4700 files containing 61.14 MB of data so far'),
 (5430, '1588233456.187850', 2, 'info', 'Analyzed 4800 files containing 62.7 MB of data so far'),
 (5431, '1588233456.693529', 2, 'info', 'Analyzed 4900 files containing 63.83 MB of data so far'),
 (5432, '1588233457.152671', 2, 'info', 'Analyzed 5000 files containing 64.55 MB of data so far'),
 (5433, '1588233457.511710', 2, 'info', 'Analyzed 5100 files containing 65.01 MB of data so far'),
 (5434, '1588233457.736955', 2, 'info', 'Analyzed 5200 files containing 65.04 MB of data so far'),
 (5435, '1588233457.957632', 2, 'info', 'Analyzed 5300 files containing 65.07 MB of data so far'),
 (5436, '1588233459.480808', 2, 'info', 'Analyzed 5400 files containing 68.48 MB of data so far'),
 (5437, '1588233460.351777', 2, 'info', 'Analyzed 5500 files containing 69.81 MB of data so far'),
 (5438, '1588233461.424023', 2, 'info', 'Analyzed 5600 files containing 71.71 MB of data so far'),
 (5439, '1588233461.985712', 2, 'info', 'Analyzed 5700 files containing 72.91 MB of data so far'),
 (5440, '1588233462.435540', 2, 'info', 'Analyzed 5800 files containing 73.71 MB of data so far'),
 (5441, '1588233462.735620', 2, 'info', 'Analyzed 5900 files containing 75.18 MB of data so far'),
 (5442, '1588233463.150289', 2, 'info', 'Analyzed 6000 files containing 76.39 MB of data so far'),
 (5443, '1588233463.598579', 2, 'info', 'Analyzed 6100 files containing 77.16 MB of data so far'),
 (5444, '1588233464.220688', 2, 'info', 'Analyzed 6200 files containing 77.99 MB of data so far'),
 (5445, '1588233464.480920', 2, 'info', 'Analyzed 6300 files containing 78.15 MB of data so far'),
 (5446, '1588233464.940291', 2, 'info', 'Analyzed 6400 files containing 78.63 MB of data so far'),
 (5447, '1588233465.310701', 2, 'info', 'Analyzed 6500 files containing 78.99 MB of data so far'),
 (5448, '1588233465.603529', 2, 'info', 'Analyzed 6600 files containing 79.31 MB of data so far'),
 (5449, '1588233466.355464', 2, 'info', 'Analyzed 6700 files containing 80.46 MB of data so far'),
 (5450, '1588233467.426762', 2, 'info', 'Analyzed 6800 files containing 82.31 MB of data so far'),
 (5451, '1588233467.949411', 2, 'info', 'Analyzed 6900 files containing 83.06 MB of data so far'),
 (5452, '1588233468.991663', 2, 'info', 'Analyzed 7000 files containing 84.87 MB of data so far'),
 (5453, '1588233469.974097', 2, 'info', 'Analyzed 7100 files containing 86.44 MB of data so far'),
 (5454, '1588233471.770183', 2, 'info', 'Analyzed 7200 files containing 89.71 MB of data so far'),
 (5455, '1588233472.325924', 2, 'info', 'Analyzed 7300 files containing 90.39 MB of data so far'),
 (5456, '1588233472.548883', 2, 'info', 'Analyzed 7400 files containing 90.42 MB of data so far'),
 (5457, '1588233472.778815', 2, 'info', 'Analyzed 7500 files containing 90.44 MB of data so far'),
 (5458, '1588233473.298816', 2, 'info', 'Analyzed 7600 files containing 91.25 MB of data so far'),
 (5459, '1588233473.755261', 2, 'info', 'Analyzed 7700 files containing 91.96 MB of data so far'),
 (5460, '1588233474.248833', 2, 'info', 'Analyzed 7800 files containing 92.66 MB of data so far'),
 (5461, '1588233474.559739', 2, 'info', 'Analyzed 7900 files containing 92.93 MB of data so far'),
 (5462, '1588233474.797074', 2, 'info', 'Analyzed 8000 files containing 92.95 MB of data so far'),
 (5463, '1588233475.003821', 2, 'info', 'Analyzed 8100 files containing 92.98 MB of data so far'),
 (5464, '1588233475.230832', 2, 'info', 'Analyzed 8200 files containing 93.01 MB of data so far'),
 (5465, '1588233475.429858', 2, 'info', 'Analyzed 8300 files containing 93.04 MB of data so far'),
 (5466, '1588233475.629793', 2, 'info', 'Analyzed 8400 files containing 93.07 MB of data so far'),
 (5467, '1588233475.843614', 2, 'info', 'Analyzed 8500 files containing 93.1 MB of data so far'),
 (5468, '1588233477.580923', 2, 'info', 'Analyzed 8600 files containing 96.1 MB of data so far'),
 (5469, '1588233478.983275', 2, 'info', 'Analyzed 8700 files containing 98.59 MB of data so far'),
 (5470, '1588233479.434950', 2, 'info', 'Analyzed 8800 files containing 99.14 MB of data so far'),
 (5471, '1588233479.684077', 2, 'info', 'Analyzed 8900 files containing 99.31 MB of data so far'),
 (5472, '1588233480.072787', 2, 'info', 'Analyzed 9000 files containing 99.81 MB of data so far'),
 (5473, '1588233480.527853', 2, 'info', 'Analyzed 9100 files containing 100.16 MB of data so far'),
 (5474, '1588233480.903750', 2, 'info', 'Analyzed 9200 files containing 100.42 MB of data so far'),
 (5770, '1588233776.577327', 10, 'info', 'SUM_ENDOK:Scanning file contents for URLs on a domain blacklist'),
 (5769, '1588233776.570976', 10, 'info', 'SUM_ENDOK:Scanning file contents for infections and vulnerabilities'),
 (5768, '1588233776.569734', 2, 'info', 'Done file contents scan'),
 (5767, '1588233776.563968', 2, 'info', 'Done URL check.'),
 (5766, '1588233775.982152', 2, 'info', 'Checking 7 URLs from 7 sources.'),
 (5765, '1588233775.979936', 2, 'info', 'Done host key check.'),
 (5764, '1588233775.179732', 2, 'info', 'Checking 5037 host keys against Wordfence scanning servers.'),
 (5763, '1588233775.152598', 2, 'info', 'Asking Wordfence to check URLs against malware list.'),
 (5762, '1588233775.152249', 2, 'info', 'Scanned contents of 9917 additional files at 37.96 per second'),
 (5761, '1588233774.691832', 2, 'info', 'Scanned contents of 9912 additional files at 38.01 per second'),
 (5760, '1588233772.493298', 2, 'info', 'Scanned contents of 9904 additional files at 38.30 per second'),
 (5759, '1588233770.904750', 2, 'info', 'Scanned contents of 9903 additional files at 38.53 per second'),
 (5758, '1588233769.903133', 2, 'info', 'Scanned contents of 9863 additional files at 38.53 per second'),
 (5757, '1588233768.895848', 2, 'info', 'Scanned contents of 9811 additional files at 38.47 per second'),
 (5756, '1588233767.893700', 2, 'info', 'Scanned contents of 9770 additional files at 38.46 per second'),
 (5755, '1588233766.873822', 2, 'info', 'Scanned contents of 9741 additional files at 38.50 per second'),
 (5754, '1588233765.860544', 2, 'info', 'Scanned contents of 9714 additional files at 38.55 per second'),
 (5753, '1588233764.851131', 2, 'info', 'Scanned contents of 9687 additional files at 38.60 per second'),
 (5752, '1588233763.819705', 2, 'info', 'Scanned contents of 9653 additional files at 38.62 per second'),
 (5751, '1588233762.804159', 2, 'info', 'Scanned contents of 9626 additional files at 38.67 per second'),
 (5750, '1588233761.735420', 2, 'info', 'Scanned contents of 9590 additional files at 38.69 per second'),
 (5749, '1588233760.724334', 2, 'info', 'Scanned contents of 9529 additional files at 38.60 per second'),
 (5748, '1588233759.721169', 2, 'info', 'Scanned contents of 9498 additional files at 38.64 per second'),
 (5747, '1588233758.699627', 2, 'info', 'Scanned contents of 9443 additional files at 38.57 per second'),
 (5746, '1588233757.696571', 2, 'info', 'Scanned contents of 9419 additional files at 38.63 per second'),
 (5745, '1588233756.677908', 2, 'info', 'Scanned contents of 9402 additional files at 38.72 per second'),
 (5744, '1588233755.675962', 2, 'info', 'Scanned contents of 9358 additional files at 38.70 per second'),
 (5743, '1588233754.666442', 2, 'info', 'Scanned contents of 9322 additional files at 38.72 per second'),
 (5742, '1588233753.654332', 2, 'info', 'Scanned contents of 9256 additional files at 38.60 per second'),
 (5741, '1588233752.631692', 2, 'info', 'Scanned contents of 9216 additional files at 38.60 per second'),
 (5740, '1588233751.630733', 2, 'info', 'Scanned contents of 9160 additional files at 38.53 per second'),
 (5739, '1588233750.630345', 2, 'info', 'Scanned contents of 9122 additional files at 38.53 per second'),
 (5738, '1588233749.624607', 2, 'info', 'Scanned contents of 9086 additional files at 38.54 per second'),
 (5737, '1588233748.350734', 2, 'info', 'Scanned contents of 9077 additional files at 38.71 per second'),
 (5736, '1588233746.982162', 2, 'info', 'Scanned contents of 9051 additional files at 38.83 per second'),
 (5735, '1588233745.978414', 2, 'info', 'Scanned contents of 9003 additional files at 38.79 per second'),
 (5734, '1588233744.977590', 2, 'info', 'Scanned contents of 8948 additional files at 38.72 per second'),
 (5733, '1588233743.957588', 2, 'info', 'Scanned contents of 8916 additional files at 38.75 per second'),
 (5732, '1588233742.936841', 2, 'info', 'Scanned contents of 8899 additional files at 38.85 per second'),
 (5731, '1588233741.933915', 2, 'info', 'Scanned contents of 8838 additional files at 38.76 per second'),
 (5730, '1588233740.923292', 2, 'info', 'Scanned contents of 8782 additional files at 38.68 per second'),
 (5729, '1588233739.904217', 2, 'info', 'Scanned contents of 8755 additional files at 38.74 per second'),
 (5728, '1588233736.630450', 2, 'info', 'Scanned contents of 8751 additional files at 39.29 per second'),
 (5727, '1588233735.503804', 2, 'info', 'Scanned contents of 8726 additional files at 39.37 per second'),
 (5726, '1588233734.362787', 2, 'info', 'Scanned contents of 8711 additional files at 39.51 per second'),
 (5725, '1588233733.294680', 2, 'info', 'Scanned contents of 8681 additional files at 39.57 per second'),
 (5724, '1588233732.280773', 2, 'info', 'Scanned contents of 8637 additional files at 39.55 per second'),
 (5723, '1588233731.261303', 2, 'info', 'Scanned contents of 8606 additional files at 39.59 per second'),
 (5722, '1588233730.071512', 2, 'info', 'Scanned contents of 8571 additional files at 39.65 per second'),
 (5721, '1588233728.888080', 2, 'info', 'Scanned contents of 8507 additional files at 39.57 per second'),
 (5720, '1588233727.873416', 2, 'info', 'Scanned contents of 8441 additional files at 39.45 per second'),
 (5719, '1588233726.834326', 2, 'info', 'Scanned contents of 8381 additional files at 39.36 per second'),
 (5718, '1588233725.825447', 2, 'info', 'Scanned contents of 8320 additional files at 39.26 per second'),
 (5717, '1588233724.818291', 2, 'info', 'Scanned contents of 8255 additional files at 39.14 per second'),
 (5716, '1588233723.809637', 2, 'info', 'Scanned contents of 8194 additional files at 39.03 per second'),
 (5715, '1588233722.803059', 2, 'info', 'Scanned contents of 8144 additional files at 38.98 per second'),
 (5714, '1588233721.786205', 2, 'info', 'Scanned contents of 8109 additional files at 39.00 per second'),
 (5713, '1588233720.761078', 2, 'info', 'Scanned contents of 8083 additional files at 39.07 per second'),
 (5712, '1588233719.744702', 2, 'info', 'Scanned contents of 8028 additional files at 39.00 per second'),
 (5711, '1588233718.743591', 2, 'info', 'Scanned contents of 7958 additional files at 38.85 per second'),
 (5710, '1588233717.739303', 2, 'info', 'Scanned contents of 7901 additional files at 38.76 per second'),
 (5709, '1588233716.062086', 2, 'info', 'Scanned contents of 7898 additional files at 39.07 per second');
INSERT INTO `wp8b_wfstatus` VALUES(5708, '1588233715.046144', 2, 'info', 'Scanned contents of 7868 additional files at 39.11 per second'),
 (5707, '1588233713.948686', 2, 'info', 'Scanned contents of 7801 additional files at 38.99 per second'),
 (5706, '1588233712.945816', 2, 'info', 'Scanned contents of 7689 additional files at 38.63 per second'),
 (5705, '1588233711.942218', 2, 'info', 'Scanned contents of 7578 additional files at 38.26 per second'),
 (5704, '1588233710.923958', 2, 'info', 'Scanned contents of 7508 additional files at 38.10 per second'),
 (5703, '1588233709.918684', 2, 'info', 'Scanned contents of 7450 additional files at 38.00 per second'),
 (5702, '1588233708.902582', 2, 'info', 'Scanned contents of 7407 additional files at 37.98 per second'),
 (5701, '1588233707.883363', 2, 'info', 'Scanned contents of 7369 additional files at 37.99 per second'),
 (5700, '1588233706.851295', 2, 'info', 'Scanned contents of 7319 additional files at 37.93 per second'),
 (5699, '1588233705.844787', 2, 'info', 'Scanned contents of 7316 additional files at 38.11 per second'),
 (5698, '1588233704.336411', 2, 'info', 'Scanned contents of 7282 additional files at 38.24 per second'),
 (5697, '1588233703.334390', 2, 'info', 'Scanned contents of 7237 additional files at 38.20 per second'),
 (5696, '1588233702.316104', 2, 'info', 'Scanned contents of 7208 additional files at 38.25 per second'),
 (5695, '1588233701.245998', 2, 'info', 'Scanned contents of 7181 additional files at 38.33 per second'),
 (5694, '1588233700.229573', 2, 'info', 'Scanned contents of 7135 additional files at 38.29 per second'),
 (5693, '1588233699.218755', 2, 'info', 'Scanned contents of 7117 additional files at 38.40 per second'),
 (5692, '1588233698.105730', 2, 'info', 'Scanned contents of 7075 additional files at 38.41 per second'),
 (5691, '1588233697.104057', 2, 'info', 'Scanned contents of 7039 additional files at 38.42 per second'),
 (5690, '1588233696.088962', 2, 'info', 'Scanned contents of 7009 additional files at 38.47 per second'),
 (5689, '1588233695.074101', 2, 'info', 'Scanned contents of 6976 additional files at 38.50 per second'),
 (5688, '1588233694.069555', 2, 'info', 'Scanned contents of 6950 additional files at 38.57 per second'),
 (5687, '1588233693.024067', 2, 'info', 'Scanned contents of 6924 additional files at 38.65 per second'),
 (5686, '1588233691.869509', 2, 'info', 'Scanned contents of 6885 additional files at 38.68 per second'),
 (5685, '1588233689.045735', 2, 'info', 'Scanned contents of 6850 additional files at 39.11 per second'),
 (5684, '1588233688.045288', 2, 'info', 'Scanned contents of 6803 additional files at 39.06 per second'),
 (5683, '1588233687.025336', 2, 'info', 'Scanned contents of 6778 additional files at 39.15 per second'),
 (5682, '1588233685.996070', 2, 'info', 'Scanned contents of 6757 additional files at 39.26 per second'),
 (5681, '1588233684.994632', 2, 'info', 'Scanned contents of 6736 additional files at 39.37 per second'),
 (5680, '1588233683.851406', 2, 'info', 'Scanned contents of 6702 additional files at 39.43 per second'),
 (5679, '1588233682.842166', 2, 'info', 'Scanned contents of 6628 additional files at 39.23 per second'),
 (5678, '1588233681.838631', 2, 'info', 'Scanned contents of 6576 additional files at 39.15 per second'),
 (5677, '1588233680.825029', 2, 'info', 'Scanned contents of 6539 additional files at 39.17 per second'),
 (5676, '1588233679.624014', 2, 'info', 'Scanned contents of 6525 additional files at 39.37 per second'),
 (5675, '1588233678.621487', 2, 'info', 'Scanned contents of 6472 additional files at 39.29 per second'),
 (5674, '1588233677.605064', 2, 'info', 'Scanned contents of 6408 additional files at 39.14 per second'),
 (5673, '1588233676.600816', 2, 'info', 'Scanned contents of 6332 additional files at 38.92 per second'),
 (5672, '1588233675.593139', 2, 'info', 'Scanned contents of 6311 additional files at 39.03 per second'),
 (5671, '1588233674.549728', 2, 'info', 'Scanned contents of 6303 additional files at 39.23 per second'),
 (5670, '1588233673.444190', 2, 'info', 'Scanned contents of 6288 additional files at 39.41 per second'),
 (5669, '1588233672.430766', 2, 'info', 'Scanned contents of 6228 additional files at 39.28 per second'),
 (5668, '1588233671.412479', 2, 'info', 'Scanned contents of 6181 additional files at 39.24 per second'),
 (5667, '1588233670.392182', 2, 'info', 'Scanned contents of 6134 additional files at 39.19 per second'),
 (5666, '1588233669.382368', 2, 'info', 'Scanned contents of 6083 additional files at 39.12 per second'),
 (5665, '1588233668.381579', 2, 'info', 'Scanned contents of 6028 additional files at 39.02 per second'),
 (5664, '1588233667.376183', 2, 'info', 'Scanned contents of 5970 additional files at 38.90 per second'),
 (6149, '1588471348.443277', 2, 'info', 'Scanned contents of 6107 additional files at 37.21 per second'),
 (6148, '1588471347.437475', 2, 'info', 'Scanned contents of 6041 additional files at 37.04 per second'),
 (6147, '1588471346.430867', 2, 'info', 'Scanned contents of 6004 additional files at 37.04 per second'),
 (6146, '1588471345.429240', 2, 'info', 'Scanned contents of 5940 additional files at 36.87 per second'),
 (6145, '1588471344.421526', 2, 'info', 'Scanned contents of 5913 additional files at 36.94 per second'),
 (6144, '1588471341.301651', 2, 'info', 'Scanned contents of 5861 additional files at 37.34 per second'),
 (6143, '1588471340.293498', 2, 'info', 'Scanned contents of 5779 additional files at 37.05 per second'),
 (6142, '1588471339.283950', 2, 'info', 'Scanned contents of 5716 additional files at 36.89 per second'),
 (6141, '1588471338.275590', 2, 'info', 'Scanned contents of 5661 additional files at 36.77 per second'),
 (6140, '1588471337.091857', 2, 'info', 'Scanned contents of 5643 additional files at 36.94 per second'),
 (6139, '1588471336.084078', 2, 'info', 'Scanned contents of 5615 additional files at 37.00 per second'),
 (6138, '1588471335.015114', 2, 'info', 'Scanned contents of 5595 additional files at 37.13 per second'),
 (6137, '1588471334.013713', 2, 'info', 'Scanned contents of 5577 additional files at 37.26 per second'),
 (6136, '1588471332.945467', 2, 'info', 'Scanned contents of 5554 additional files at 37.37 per second'),
 (6135, '1588471331.941806', 2, 'info', 'Scanned contents of 5542 additional files at 37.55 per second'),
 (6134, '1588471330.934790', 2, 'info', 'Scanned contents of 5498 additional files at 37.50 per second'),
 (6133, '1588471329.392990', 2, 'info', 'Scanned contents of 5482 additional files at 37.79 per second'),
 (6132, '1588471327.753536', 2, 'info', 'Scanned contents of 5458 additional files at 38.06 per second'),
 (6131, '1588471326.753085', 2, 'info', 'Scanned contents of 5334 additional files at 37.45 per second'),
 (6130, '1588471325.752771', 2, 'info', 'Scanned contents of 5213 additional files at 36.86 per second'),
 (6129, '1588471324.750892', 2, 'info', 'Scanned contents of 5106 additional files at 36.36 per second'),
 (6128, '1588471323.742820', 2, 'info', 'Scanned contents of 4983 additional files at 35.74 per second'),
 (6127, '1588471322.738005', 2, 'info', 'Scanned contents of 4881 additional files at 35.27 per second'),
 (6126, '1588471321.735068', 2, 'info', 'Scanned contents of 4803 additional files at 34.96 per second'),
 (6125, '1588471320.727829', 2, 'info', 'Scanned contents of 4713 additional files at 34.55 per second'),
 (6124, '1588471319.720947', 2, 'info', 'Scanned contents of 4624 additional files at 34.15 per second'),
 (6123, '1588471318.718104', 2, 'info', 'Scanned contents of 4532 additional files at 33.72 per second'),
 (6122, '1588471317.715777', 2, 'info', 'Scanned contents of 4455 additional files at 33.40 per second'),
 (6121, '1588471316.707669', 2, 'info', 'Scanned contents of 4343 additional files at 32.81 per second'),
 (6120, '1588471315.702780', 2, 'info', 'Scanned contents of 4220 additional files at 32.12 per second'),
 (6119, '1588471314.696401', 2, 'info', 'Scanned contents of 4157 additional files at 31.89 per second'),
 (6118, '1588471313.293577', 2, 'info', 'Scanned contents of 4150 additional files at 32.18 per second'),
 (6117, '1588471312.185472', 2, 'info', 'Scanned contents of 4111 additional files at 32.15 per second'),
 (6116, '1588471311.184366', 2, 'info', 'Scanned contents of 4095 additional files at 32.28 per second'),
 (6115, '1588471310.138490', 2, 'info', 'Scanned contents of 4078 additional files at 32.42 per second'),
 (6114, '1588471309.127348', 2, 'info', 'Scanned contents of 4069 additional files at 32.61 per second'),
 (6113, '1588471305.403967', 2, 'info', 'Scanned contents of 4056 additional files at 33.50 per second'),
 (6112, '1588471304.388230', 2, 'info', 'Scanned contents of 4041 additional files at 33.66 per second'),
 (6111, '1588471303.387356', 2, 'info', 'Scanned contents of 3997 additional files at 33.57 per second'),
 (6110, '1588471302.377513', 2, 'info', 'Scanned contents of 3953 additional files at 33.49 per second'),
 (6109, '1588471301.225152', 2, 'info', 'Scanned contents of 3922 additional files at 33.55 per second'),
 (6108, '1588471300.167702', 2, 'info', 'Scanned contents of 3882 additional files at 33.51 per second'),
 (6107, '1588471299.135794', 2, 'info', 'Scanned contents of 3873 additional files at 33.74 per second'),
 (6106, '1588471297.845831', 2, 'info', 'Scanned contents of 3857 additional files at 33.98 per second'),
 (6105, '1588471296.825153', 2, 'info', 'Scanned contents of 3835 additional files at 34.09 per second'),
 (6104, '1588471294.049666', 2, 'info', 'Scanned contents of 3795 additional files at 34.59 per second'),
 (6103, '1588471293.035559', 2, 'info', 'Scanned contents of 3740 additional files at 34.41 per second'),
 (6102, '1588471292.006751', 2, 'info', 'Scanned contents of 3715 additional files at 34.50 per second'),
 (6101, '1588471290.907580', 2, 'info', 'Scanned contents of 3689 additional files at 34.61 per second'),
 (6100, '1588471289.890278', 2, 'info', 'Scanned contents of 3665 additional files at 34.72 per second'),
 (6099, '1588471288.355244', 2, 'info', 'Scanned contents of 3652 additional files at 35.11 per second'),
 (6098, '1588471287.343080', 2, 'info', 'Scanned contents of 3623 additional files at 35.17 per second'),
 (6097, '1588471286.327437', 2, 'info', 'Scanned contents of 3600 additional files at 35.30 per second'),
 (6096, '1588471285.322106', 2, 'info', 'Scanned contents of 3579 additional files at 35.44 per second'),
 (6095, '1588471284.119043', 2, 'info', 'Scanned contents of 3545 additional files at 35.53 per second'),
 (6094, '1588471283.112072', 2, 'info', 'Scanned contents of 3495 additional files at 35.38 per second'),
 (6093, '1588471282.096176', 2, 'info', 'Scanned contents of 3432 additional files at 35.11 per second'),
 (6092, '1588471281.094562', 2, 'info', 'Scanned contents of 3374 additional files at 34.87 per second'),
 (6091, '1588471280.090805', 2, 'info', 'Scanned contents of 3325 additional files at 34.72 per second'),
 (6090, '1588471278.771941', 2, 'info', 'Scanned contents of 3264 additional files at 34.56 per second'),
 (6089, '1588471277.770175', 2, 'info', 'Scanned contents of 3195 additional files at 34.19 per second'),
 (6088, '1588471276.752944', 2, 'info', 'Scanned contents of 3137 additional files at 33.94 per second'),
 (6087, '1588471275.743649', 2, 'info', 'Scanned contents of 3082 additional files at 33.72 per second'),
 (6086, '1588471274.637728', 2, 'info', 'Scanned contents of 3059 additional files at 33.87 per second'),
 (5627, '1588233623.825317', 2, 'info', 'Scanned contents of 3922 additional files at 35.68 per second'),
 (5626, '1588233622.808532', 2, 'info', 'Scanned contents of 3885 additional files at 35.67 per second'),
 (6085, '1588471273.636415', 2, 'info', 'Scanned contents of 3030 additional files at 33.93 per second'),
 (6084, '1588471272.625292', 2, 'info', 'Scanned contents of 3004 additional files at 34.02 per second'),
 (5625, '1588233621.787993', 2, 'info', 'Scanned contents of 3873 additional files at 35.89 per second'),
 (6083, '1588471271.609083', 2, 'info', 'Scanned contents of 2961 additional files at 33.93 per second'),
 (6082, '1588471270.603028', 2, 'info', 'Scanned contents of 2914 additional files at 33.78 per second'),
 (6080, '1588471268.558731', 2, 'info', 'Scanned contents of 2858 additional files at 33.93 per second'),
 (6081, '1588471269.569863', 2, 'info', 'Scanned contents of 2881 additional files at 33.80 per second'),
 (5786, '1588471048.007217', 10, 'info', 'SUM_PREP:Preparing a new scan.'),
 (5790, '1588471048.025993', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (5789, '1588471048.022028', 10, 'info', 'SUM_ENDOK:Checking Web Application Firewall status'),
 (5787, '1588471048.009689', 1, 'info', 'Initiating quick scan'),
 (5788, '1588471048.021618', 10, 'info', 'SUM_START:Checking Web Application Firewall status'),
 (5791, '1588471048.051507', 10, 'info', 'SUM_ENDBAD:Scanning for old themes, plugins and core files'),
 (5792, '1588471048.054027', 1, 'info', '-------------------'),
 (5793, '1588471048.054601', 2, 'info', 'Wordfence used 0 B of memory for scan. Server peak memory usage was: 80.5 MB'),
 (5794, '1588471048.054787', 1, 'info', 'Quick Scan Complete. Scanned in less than 1 second.'),
 (6155, '1588471354.841582', 2, 'info', 'Scanned contents of 6335 additional files at 37.15 per second'),
 (6154, '1588471353.833848', 2, 'info', 'Scanned contents of 6312 additional files at 37.24 per second'),
 (6259, '1588471457.762316', 2, 'info', 'Examining URLs found in posts we scanned for dangerous websites'),
 (5322, '1588233404.540765', 10, 'info', 'SUM_PREP:Preparing a new scan.'),
 (5320, '1588173278.632743', 10, 'info', 'SUM_FINAL:Scan complete. You have 2 new issues to fix. See below.'),
 (6258, '1588471457.753512', 10, 'info', 'SUM_START:Scanning posts for URLs on a domain blacklist'),
 (6257, '1588471457.747085', 10, 'info', 'SUM_ENDOK:Scanning for publicly accessible quarantined files'),
 (5771, '1588233776.586653', 10, 'info', 'SUM_START:Scanning for publicly accessible quarantined files'),
 (5772, '1588233776.590234', 10, 'info', 'SUM_ENDOK:Scanning for publicly accessible quarantined files'),
 (5773, '1588233776.599817', 10, 'info', 'SUM_START:Scanning posts for URLs on a domain blacklist'),
 (5774, '1588233776.614954', 2, 'info', 'Examining URLs found in posts we scanned for dangerous websites'),
 (5775, '1588233776.615456', 2, 'info', 'Done examining URLs'),
 (5776, '1588233776.616742', 10, 'info', 'SUM_ENDOK:Scanning posts for URLs on a domain blacklist'),
 (5777, '1588233776.626223', 10, 'info', 'SUM_START:Scanning comments for URLs on a domain blacklist'),
 (5778, '1588233776.636626', 2, 'info', 'Checking 4 host keys against Wordfence scanning servers.'),
 (5779, '1588233777.197586', 2, 'info', 'Done host key check.'),
 (6158, '1588471357.860568', 2, 'info', 'Scanned contents of 6514 additional files at 37.54 per second'),
 (6157, '1588471356.849219', 2, 'info', 'Scanned contents of 6475 additional files at 37.53 per second'),
 (6156, '1588471355.841842', 2, 'info', 'Scanned contents of 6415 additional files at 37.40 per second'),
 (5525, '1588233511.761166', 10, 'info', 'SUM_ENDOK:Scanning for unknown files in wp-admin and wp-includes'),
 (5526, '1588233511.766382', 10, 'info', 'SUM_ENDOK:Scanning for known malware files'),
 (5527, '1588233511.775701', 10, 'info', 'SUM_START:Check for publicly accessible configuration files, backup files and logs'),
 (5528, '1588233512.555139', 10, 'info', 'SUM_ENDOK:Check for publicly accessible configuration files, backup files and logs'),
 (5529, '1588233512.566138', 10, 'info', 'SUM_START:Scanning file contents for infections and vulnerabilities'),
 (5530, '1588233512.568702', 10, 'info', 'SUM_START:Scanning file contents for URLs on a domain blacklist'),
 (5531, '1588233513.886400', 2, 'info', 'Starting scan of file contents'),
 (5532, '1588233515.547426', 2, 'info', 'Scanned contents of 6 additional files at 3.62 per second'),
 (5533, '1588233517.206259', 2, 'info', 'Scanned contents of 8 additional files at 2.41 per second'),
 (5534, '1588233518.302144', 2, 'info', 'Scanned contents of 10 additional files at 2.27 per second'),
 (5535, '1588233519.498142', 2, 'info', 'Scanned contents of 12 additional files at 2.14 per second'),
 (5536, '1588233520.887257', 2, 'info', 'Scanned contents of 14 additional files at 2.00 per second'),
 (5537, '1588233522.102195', 2, 'info', 'Scanned contents of 16 additional files at 1.95 per second'),
 (5538, '1588233523.308970', 2, 'info', 'Scanned contents of 18 additional files at 1.91 per second'),
 (5539, '1588233524.522598', 2, 'info', 'Scanned contents of 20 additional files at 1.88 per second'),
 (5540, '1588233525.654874', 2, 'info', 'Scanned contents of 22 additional files at 1.87 per second'),
 (5541, '1588233526.760605', 2, 'info', 'Scanned contents of 26 additional files at 2.02 per second'),
 (5542, '1588233527.763315', 2, 'info', 'Scanned contents of 67 additional files at 4.83 per second'),
 (5543, '1588233528.772224', 2, 'info', 'Scanned contents of 135 additional files at 9.07 per second'),
 (5544, '1588233529.780092', 2, 'info', 'Scanned contents of 202 additional files at 12.71 per second'),
 (5545, '1588233530.794676', 2, 'info', 'Scanned contents of 275 additional files at 16.27 per second'),
 (5546, '1588233531.804123', 2, 'info', 'Scanned contents of 307 additional files at 17.14 per second'),
 (5547, '1588233532.812211', 2, 'info', 'Scanned contents of 364 additional files at 19.24 per second'),
 (5548, '1588233533.823825', 2, 'info', 'Scanned contents of 428 additional files at 21.47 per second'),
 (5549, '1588233534.840252', 2, 'info', 'Scanned contents of 495 additional files at 23.63 per second'),
 (5550, '1588233535.842736', 2, 'info', 'Scanned contents of 536 additional files at 24.41 per second'),
 (5551, '1588233536.907882', 2, 'info', 'Scanned contents of 559 additional files at 24.28 per second'),
 (5552, '1588233538.011735', 2, 'info', 'Scanned contents of 598 additional files at 24.79 per second'),
 (5553, '1588233540.086722', 2, 'info', 'Scanned contents of 625 additional files at 23.86 per second'),
 (5554, '1588233541.094463', 2, 'info', 'Scanned contents of 646 additional files at 23.74 per second'),
 (5555, '1588233542.104136', 2, 'info', 'Scanned contents of 669 additional files at 23.71 per second'),
 (5556, '1588233543.106505', 2, 'info', 'Scanned contents of 692 additional files at 23.68 per second'),
 (5557, '1588233544.154607', 2, 'info', 'Scanned contents of 748 additional files at 24.71 per second'),
 (5558, '1588233545.217022', 2, 'info', 'Scanned contents of 789 additional files at 25.18 per second'),
 (5559, '1588233546.275190', 2, 'info', 'Scanned contents of 817 additional files at 25.23 per second'),
 (5560, '1588233547.578541', 2, 'info', 'Scanned contents of 833 additional files at 24.73 per second'),
 (5561, '1588233549.947680', 2, 'info', 'Scanned contents of 840 additional files at 23.30 per second'),
 (5562, '1588233550.964653', 2, 'info', 'Scanned contents of 863 additional files at 23.28 per second'),
 (5563, '1588233551.979997', 2, 'info', 'Scanned contents of 893 additional files at 23.44 per second'),
 (5564, '1588233552.995393', 2, 'info', 'Scanned contents of 923 additional files at 23.60 per second'),
 (5565, '1588233554.199388', 2, 'info', 'Scanned contents of 942 additional files at 23.37 per second'),
 (5566, '1588233555.372404', 2, 'info', 'Scanned contents of 958 additional files at 23.09 per second'),
 (5567, '1588233559.350918', 2, 'info', 'Scanned contents of 959 additional files at 21.09 per second'),
 (5568, '1588233560.461378', 2, 'info', 'Scanned contents of 964 additional files at 20.70 per second'),
 (5569, '1588233561.671326', 2, 'info', 'Scanned contents of 984 additional files at 20.59 per second'),
 (6153, '1588471352.672266', 2, 'info', 'Scanned contents of 6307 additional files at 37.47 per second'),
 (6152, '1588471351.642451', 2, 'info', 'Scanned contents of 6295 additional files at 37.63 per second'),
 (6256, '1588471457.744794', 10, 'info', 'SUM_START:Scanning for publicly accessible quarantined files'),
 (6283, '1588675147.823160', 1, 'info', 'Initiating quick scan'),
 (6282, '1588675147.820939', 10, 'info', 'SUM_PREP:Preparing a new scan.'),
 (5316, '1588173278.628284', 10, 'info', 'SUM_ENDBAD:Scanning for old themes, plugins and core files'),
 (6284, '1588675147.832913', 10, 'info', 'SUM_START:Checking Web Application Firewall status'),
 (6285, '1588675147.833308', 10, 'info', 'SUM_ENDOK:Checking Web Application Firewall status'),
 (6286, '1588675147.837211', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (6287, '1588675147.862193', 10, 'info', 'SUM_ENDBAD:Scanning for old themes, plugins and core files'),
 (5570, '1588233562.795152', 2, 'info', 'Scanned contents of 999 additional files at 20.43 per second'),
 (6255, '1588471457.738710', 10, 'info', 'SUM_ENDOK:Scanning file contents for URLs on a domain blacklist'),
 (6254, '1588471457.734382', 10, 'info', 'SUM_ENDOK:Scanning file contents for infections and vulnerabilities'),
 (6151, '1588471350.452488', 2, 'info', 'Scanned contents of 6233 additional files at 37.52 per second'),
 (6150, '1588471349.444641', 2, 'info', 'Scanned contents of 6164 additional files at 37.33 per second'),
 (6253, '1588471457.733588', 2, 'info', 'Done file contents scan'),
 (5571, '1588233563.804194', 2, 'info', 'Scanned contents of 1038 additional files at 20.80 per second'),
 (5572, '1588233565.213434', 2, 'info', 'Scanned contents of 1047 additional files at 20.40 per second'),
 (5573, '1588233566.222212', 2, 'info', 'Scanned contents of 1118 additional files at 21.36 per second'),
 (6252, '1588471457.728770', 2, 'info', 'Done URL check.'),
 (5603, '1588233597.834942', 2, 'info', 'Scanned contents of 3018 additional files at 35.95 per second'),
 (5574, '1588233567.229765', 2, 'info', 'Scanned contents of 1244 additional files at 23.32 per second'),
 (5575, '1588233568.230913', 2, 'info', 'Scanned contents of 1364 additional files at 25.10 per second'),
 (5576, '1588233569.236688', 2, 'info', 'Scanned contents of 1448 additional files at 26.16 per second'),
 (5577, '1588233570.245149', 2, 'info', 'Scanned contents of 1542 additional files at 27.36 per second'),
 (5578, '1588233571.245411', 2, 'info', 'Scanned contents of 1625 additional files at 28.33 per second'),
 (5579, '1588233572.249674', 2, 'info', 'Scanned contents of 1723 additional files at 29.52 per second'),
 (5580, '1588233573.251729', 2, 'info', 'Scanned contents of 1852 additional files at 31.20 per second'),
 (5581, '1588233574.255353', 2, 'info', 'Scanned contents of 1969 additional files at 32.62 per second'),
 (5582, '1588233575.257490', 2, 'info', 'Scanned contents of 2080 additional files at 33.89 per second'),
 (5583, '1588233576.260923', 2, 'info', 'Scanned contents of 2213 additional files at 35.48 per second'),
 (5584, '1588233577.262700', 2, 'info', 'Scanned contents of 2333 additional files at 36.81 per second'),
 (5585, '1588233578.264403', 2, 'info', 'Scanned contents of 2367 additional files at 36.77 per second'),
 (5586, '1588233579.266845', 2, 'info', 'Scanned contents of 2414 additional files at 36.92 per second'),
 (5587, '1588233580.269123', 2, 'info', 'Scanned contents of 2469 additional files at 37.19 per second'),
 (5588, '1588233581.302587', 2, 'info', 'Scanned contents of 2502 additional files at 37.11 per second'),
 (5589, '1588233582.520581', 2, 'info', 'Scanned contents of 2541 additional files at 37.02 per second'),
 (5590, '1588233583.536232', 2, 'info', 'Scanned contents of 2559 additional files at 36.74 per second'),
 (5591, '1588233584.539977', 2, 'info', 'Scanned contents of 2607 additional files at 36.90 per second'),
 (5592, '1588233585.549290', 2, 'info', 'Scanned contents of 2651 additional files at 36.99 per second'),
 (5593, '1588233586.557090', 2, 'info', 'Scanned contents of 2690 additional files at 37.02 per second'),
 (5594, '1588233587.608734', 2, 'info', 'Scanned contents of 2748 additional files at 37.28 per second'),
 (5595, '1588233588.630121', 2, 'info', 'Scanned contents of 2778 additional files at 37.17 per second'),
 (5596, '1588233589.654799', 2, 'info', 'Scanned contents of 2806 additional files at 37.04 per second'),
 (5597, '1588233590.681997', 2, 'info', 'Scanned contents of 2839 additional files at 36.97 per second'),
 (5598, '1588233591.689105', 2, 'info', 'Scanned contents of 2864 additional files at 36.81 per second'),
 (5599, '1588233592.741258', 2, 'info', 'Scanned contents of 2888 additional files at 36.63 per second'),
 (5600, '1588233593.763650', 2, 'info', 'Scanned contents of 2928 additional files at 36.66 per second'),
 (5601, '1588233594.812719', 2, 'info', 'Scanned contents of 2984 additional files at 36.87 per second'),
 (5602, '1588233596.744177', 2, 'info', 'Scanned contents of 2988 additional files at 36.06 per second'),
 (5481, '1588233486.295094', 2, 'info', 'Analyzed 9900 files containing 107.47 MB of data so far'),
 (5482, '1588233486.972455', 2, 'info', 'Analyzed 10000 files containing 108.5 MB of data so far'),
 (5483, '1588233487.677787', 2, 'info', 'Analyzed 10100 files containing 109.64 MB of data so far'),
 (5484, '1588233488.414800', 2, 'info', 'Analyzed 10200 files containing 110.73 MB of data so far'),
 (5485, '1588233489.032336', 2, 'info', 'Analyzed 10300 files containing 111.61 MB of data so far'),
 (5486, '1588233490.621816', 2, 'info', 'Analyzed 10400 files containing 114.43 MB of data so far'),
 (5487, '1588233491.239702', 2, 'info', 'Analyzed 10500 files containing 115.24 MB of data so far'),
 (5488, '1588233491.565631', 2, 'info', 'Analyzed 10600 files containing 115.44 MB of data so far'),
 (5489, '1588233492.014794', 2, 'info', 'Analyzed 10700 files containing 116.05 MB of data so far'),
 (5490, '1588233492.264682', 2, 'info', 'Analyzed 10800 files containing 116.26 MB of data so far'),
 (5491, '1588233492.600639', 2, 'info', 'Analyzed 10900 files containing 116.67 MB of data so far'),
 (5492, '1588233494.675689', 2, 'info', 'Analyzed 11000 files containing 120.51 MB of data so far'),
 (5493, '1588233494.939187', 2, 'info', 'Analyzed 11100 files containing 120.69 MB of data so far'),
 (5974, '1588471157.467282', 2, 'info', 'Analyzed 11700 files containing 124.65 MB of data so far'),
 (5973, '1588471156.380589', 2, 'info', 'Analyzed 11600 files containing 122.78 MB of data so far'),
 (5970, '1588471155.413547', 2, 'info', 'Analyzed 11300 files containing 121.96 MB of data so far'),
 (5971, '1588471155.740426', 2, 'info', 'Analyzed 11400 files containing 122.26 MB of data so far'),
 (5972, '1588471156.020312', 2, 'info', 'Analyzed 11500 files containing 122.48 MB of data so far'),
 (5915, '1588471121.433255', 2, 'info', 'Analyzed 5800 files containing 73.71 MB of data so far'),
 (5916, '1588471121.679808', 2, 'info', 'Analyzed 5900 files containing 75.18 MB of data so far'),
 (5914, '1588471121.005510', 2, 'info', 'Analyzed 5700 files containing 72.91 MB of data so far'),
 (5913, '1588471120.463786', 2, 'info', 'Analyzed 5600 files containing 71.71 MB of data so far'),
 (5795, '1588471048.054960', 10, 'info', 'SUM_FINAL:Scan complete. You have 2 new issues to fix. See below.'),
 (5796, '1588471054.164289', 1, 'info', 'Scheduled Wordfence scan starting at Sunday 3rd of May 2020 01:57:34 AM'),
 (5797, '1588471057.191031', 10, 'info', 'SUM_PREP:Preparing a new scan.'),
 (5798, '1588471057.194690', 1, 'info', 'Contacting Wordfence to initiate scan'),
 (5799, '1588471058.409044', 10, 'info', 'SUM_PAIDONLY:Check if your site is being Spamvertized is for paid members only'),
 (5800, '1588471060.411247', 10, 'info', 'SUM_PAIDONLY:Checking if your IP is generating spam is for paid members only'),
 (5801, '1588471062.413372', 10, 'info', 'SUM_PAIDONLY:Checking if your site is on a domain blacklist is for paid members only'),
 (5802, '1588471064.418484', 10, 'info', 'SUM_START:Checking for the most secure way to get IPs'),
 (5803, '1588471064.422727', 10, 'info', 'SUM_ENDOK:Checking for the most secure way to get IPs'),
 (5804, '1588471064.430951', 10, 'info', 'SUM_START:Scanning to check available disk space'),
 (5805, '1588471064.433785', 2, 'info', 'Total disk space: 3.58 TB -- Free disk space: 3.1 TB'),
 (5806, '1588471064.434083', 2, 'info', 'The disk has 3247639.13 MB available'),
 (5807, '1588471064.434326', 10, 'info', 'SUM_ENDOK:Scanning to check available disk space'),
 (5808, '1588471064.441303', 10, 'info', 'SUM_START:Checking Web Application Firewall status'),
 (5809, '1588471064.444079', 10, 'info', 'SUM_ENDOK:Checking Web Application Firewall status'),
 (5810, '1588471064.451050', 10, 'info', 'SUM_START:Checking for future GeoIP support'),
 (5811, '1588471064.453750', 10, 'info', 'SUM_ENDOK:Checking for future GeoIP support'),
 (5812, '1588471064.460889', 10, 'info', 'SUM_START:Checking for paths skipped due to scan settings'),
 (5813, '1588471064.494961', 10, 'info', 'SUM_ENDOK:Checking for paths skipped due to scan settings'),
 (5814, '1588471064.500354', 2, 'info', 'Getting plugin list from WordPress'),
 (5815, '1588471064.515632', 2, 'info', 'Found 7 plugins'),
 (5816, '1588471064.515907', 2, 'info', 'Getting theme list from WordPress'),
 (5817, '1588471064.516915', 2, 'info', 'Found 2 themes'),
 (5818, '1588471064.532716', 10, 'info', 'SUM_START:Fetching core, theme and plugin file signatures from Wordfence'),
 (5819, '1588471066.054935', 10, 'info', 'SUM_ENDSUCCESS:Fetching core, theme and plugin file signatures from Wordfence'),
 (5820, '1588471066.061596', 10, 'info', 'SUM_START:Fetching list of known malware files from Wordfence'),
 (5821, '1588471066.065616', 10, 'info', 'SUM_ENDSUCCESS:Fetching list of known malware files from Wordfence'),
 (5822, '1588471066.072364', 10, 'info', 'SUM_START:Fetching list of known core files from Wordfence'),
 (5823, '1588471067.046494', 10, 'info', 'SUM_ENDSUCCESS:Fetching list of known core files from Wordfence'),
 (5824, '1588471067.050861', 10, 'info', 'SUM_START:Comparing core WordPress files against originals in repository'),
 (5825, '1588471067.053951', 10, 'info', 'SUM_DISABLED:Skipping theme scan'),
 (5826, '1588471067.054537', 10, 'info', 'SUM_DISABLED:Skipping plugin scan'),
 (5827, '1588471067.056841', 10, 'info', 'SUM_START:Scanning for known malware files'),
 (5828, '1588471067.061644', 10, 'info', 'SUM_START:Scanning for unknown files in wp-admin and wp-includes'),
 (5829, '1588471067.130298', 2, 'info', '500 files indexed'),
 (5830, '1588471067.701767', 2, 'info', '1000 files indexed'),
 (5831, '1588471067.787899', 2, 'info', '1500 files indexed'),
 (5832, '1588471067.873287', 2, 'info', '2000 files indexed'),
 (5833, '1588471068.030690', 2, 'info', '2500 files indexed'),
 (5834, '1588471068.123852', 2, 'info', '3000 files indexed'),
 (5835, '1588471068.518862', 2, 'info', '3500 files indexed'),
 (5836, '1588471068.747563', 2, 'info', '4000 files indexed'),
 (5837, '1588471068.984456', 2, 'info', '4500 files indexed'),
 (5838, '1588471069.091200', 2, 'info', '5000 files indexed'),
 (5839, '1588471069.184006', 2, 'info', '5500 files indexed'),
 (5840, '1588471069.466890', 2, 'info', '6000 files indexed'),
 (5841, '1588471071.283231', 2, 'info', '6500 files indexed'),
 (5842, '1588471071.523471', 2, 'info', '7000 files indexed'),
 (5843, '1588471071.999529', 2, 'info', '7500 files indexed'),
 (5844, '1588471072.133902', 2, 'info', '8000 files indexed'),
 (5845, '1588471072.163438', 2, 'info', '8500 files indexed'),
 (5846, '1588471072.619481', 2, 'info', '9000 files indexed'),
 (5847, '1588471073.088724', 2, 'info', '9500 files indexed'),
 (5848, '1588471073.710922', 2, 'info', '10000 files indexed'),
 (5849, '1588471073.994520', 2, 'info', '10500 files indexed'),
 (5850, '1588471074.551864', 2, 'info', '11000 files indexed'),
 (5851, '1588471074.679760', 2, 'info', '11500 files indexed'),
 (5852, '1588471075.212206', 2, 'info', '12000 files indexed'),
 (5853, '1588471075.815557', 2, 'info', '12500 files indexed'),
 (5854, '1588471076.958795', 2, 'info', '13000 files indexed'),
 (5855, '1588471077.038789', 2, 'info', '13500 files indexed'),
 (5856, '1588471077.188679', 2, 'info', '14000 files indexed'),
 (5857, '1588471077.198657', 2, 'info', '14077 files indexed'),
 (5858, '1588471078.165424', 2, 'info', 'Analyzed 100 files containing 1.46 MB of data so far'),
 (5859, '1588471078.863439', 2, 'info', 'Analyzed 200 files containing 2.55 MB of data so far'),
 (5860, '1588471079.380658', 2, 'info', 'Analyzed 300 files containing 3.89 MB of data so far'),
 (5861, '1588471080.329419', 2, 'info', 'Analyzed 400 files containing 6.35 MB of data so far'),
 (5862, '1588471080.917682', 2, 'info', 'Analyzed 500 files containing 7.16 MB of data so far'),
 (5863, '1588471083.615520', 2, 'info', 'Analyzed 600 files containing 12.19 MB of data so far'),
 (5864, '1588471084.191567', 2, 'info', 'Analyzed 700 files containing 12.99 MB of data so far'),
 (5865, '1588471084.484329', 2, 'info', 'Analyzed 800 files containing 13.13 MB of data so far'),
 (5866, '1588471084.958955', 2, 'info', 'Analyzed 900 files containing 13.63 MB of data so far'),
 (5867, '1588471085.331780', 2, 'info', 'Analyzed 1000 files containing 14 MB of data so far'),
 (5868, '1588471085.635835', 2, 'info', 'Analyzed 1100 files containing 14.32 MB of data so far'),
 (5869, '1588471085.925867', 2, 'info', 'Analyzed 1200 files containing 15.59 MB of data so far'),
 (5870, '1588471086.853567', 2, 'info', 'Analyzed 1300 files containing 17.31 MB of data so far'),
 (5871, '1588471087.501524', 2, 'info', 'Analyzed 1400 files containing 18.38 MB of data so far'),
 (5872, '1588471088.377993', 2, 'info', 'Analyzed 1500 files containing 19.92 MB of data so far'),
 (5873, '1588471089.094612', 2, 'info', 'Analyzed 1600 files containing 21.1 MB of data so far'),
 (5874, '1588471090.921071', 2, 'info', 'Analyzed 1700 files containing 25.04 MB of data so far'),
 (5875, '1588471091.165320', 2, 'info', 'Analyzed 1800 files containing 26.01 MB of data so far'),
 (5876, '1588471091.377359', 2, 'info', 'Analyzed 1900 files containing 26.04 MB of data so far'),
 (5877, '1588471091.573297', 2, 'info', 'Analyzed 2000 files containing 26.07 MB of data so far'),
 (5878, '1588471092.099306', 2, 'info', 'Analyzed 2100 files containing 26.83 MB of data so far'),
 (5879, '1588471092.560345', 2, 'info', 'Analyzed 2200 files containing 27.52 MB of data so far'),
 (5880, '1588471093.053444', 2, 'info', 'Analyzed 2300 files containing 28.24 MB of data so far'),
 (5881, '1588471093.366241', 2, 'info', 'Analyzed 2400 files containing 28.55 MB of data so far'),
 (5882, '1588471093.647474', 2, 'info', 'Analyzed 2500 files containing 28.57 MB of data so far'),
 (5883, '1588471093.849300', 2, 'info', 'Analyzed 2600 files containing 28.6 MB of data so far'),
 (5884, '1588471094.135486', 2, 'info', 'Analyzed 2700 files containing 28.63 MB of data so far'),
 (5885, '1588471094.359324', 2, 'info', 'Analyzed 2800 files containing 28.66 MB of data so far'),
 (5886, '1588471094.590075', 2, 'info', 'Analyzed 2900 files containing 28.69 MB of data so far'),
 (5887, '1588471094.786365', 2, 'info', 'Analyzed 3000 files containing 28.72 MB of data so far'),
 (5888, '1588471096.105452', 2, 'info', 'Analyzed 3100 files containing 31.6 MB of data so far'),
 (5889, '1588471096.584436', 2, 'info', 'Analyzed 3200 files containing 32.3 MB of data so far'),
 (5890, '1588471097.972418', 2, 'info', 'Analyzed 3300 files containing 34.87 MB of data so far'),
 (5891, '1588471103.436527', 2, 'info', 'Analyzed 3400 files containing 45.49 MB of data so far'),
 (5892, '1588471107.618466', 2, 'info', 'Analyzed 3500 files containing 49.11 MB of data so far'),
 (5893, '1588471107.859512', 2, 'info', 'Analyzed 3600 files containing 49.33 MB of data so far'),
 (5894, '1588471108.066488', 2, 'info', 'Analyzed 3700 files containing 49.45 MB of data so far'),
 (5895, '1588471108.553382', 2, 'info', 'Analyzed 3800 files containing 50.09 MB of data so far'),
 (5896, '1588471108.965370', 2, 'info', 'Analyzed 3900 files containing 50.62 MB of data so far'),
 (5897, '1588471109.236660', 2, 'info', 'Analyzed 4000 files containing 50.91 MB of data so far'),
 (5898, '1588471109.491478', 2, 'info', 'Analyzed 4100 files containing 51.17 MB of data so far'),
 (5899, '1588471110.326378', 2, 'info', 'Analyzed 4200 files containing 52.55 MB of data so far'),
 (5900, '1588471110.549660', 2, 'info', 'Analyzed 4300 files containing 52.63 MB of data so far'),
 (5901, '1588471110.946984', 2, 'info', 'Analyzed 4400 files containing 52.99 MB of data so far'),
 (5902, '1588471111.709412', 2, 'info', 'Analyzed 4500 files containing 54.09 MB of data so far'),
 (5903, '1588471112.751774', 2, 'info', 'Analyzed 4600 files containing 55.92 MB of data so far'),
 (5904, '1588471114.926333', 2, 'info', 'Analyzed 4700 files containing 61.14 MB of data so far'),
 (5905, '1588471115.465456', 2, 'info', 'Analyzed 4800 files containing 62.7 MB of data so far'),
 (5906, '1588471115.892194', 2, 'info', 'Analyzed 4900 files containing 63.83 MB of data so far'),
 (5907, '1588471116.350343', 2, 'info', 'Analyzed 5000 files containing 64.55 MB of data so far'),
 (5908, '1588471116.814325', 2, 'info', 'Analyzed 5100 files containing 65.01 MB of data so far'),
 (5909, '1588471117.040283', 2, 'info', 'Analyzed 5200 files containing 65.04 MB of data so far'),
 (5910, '1588471117.250288', 2, 'info', 'Analyzed 5300 files containing 65.07 MB of data so far'),
 (5911, '1588471118.745563', 2, 'info', 'Analyzed 5400 files containing 68.48 MB of data so far'),
 (5912, '1588471119.520840', 2, 'info', 'Analyzed 5500 files containing 69.81 MB of data so far'),
 (5969, '1588471155.049392', 2, 'info', 'Analyzed 11200 files containing 121.73 MB of data so far'),
 (5968, '1588471154.367619', 2, 'info', 'Analyzed 11100 files containing 120.69 MB of data so far'),
 (5524, '1588233511.755268', 10, 'info', 'SUM_ENDOK:Comparing core WordPress files against originals in repository'),
 (5523, '1588233511.755009', 2, 'info', 'Analyzed 14077 files containing 173.85 MB of data.'),
 (5522, '1588233511.643160', 2, 'info', 'Analyzed 14000 files containing 172.46 MB of data so far'),
 (5521, '1588233511.513985', 2, 'info', 'Analyzed 13900 files containing 171.17 MB of data so far'),
 (5520, '1588233511.358286', 2, 'info', 'Analyzed 13800 files containing 167.56 MB of data so far'),
 (5519, '1588233511.215181', 2, 'info', 'Analyzed 13700 files containing 165.33 MB of data so far'),
 (5518, '1588233511.074569', 2, 'info', 'Analyzed 13600 files containing 163.45 MB of data so far'),
 (5517, '1588233510.833762', 2, 'info', 'Analyzed 13500 files containing 155.35 MB of data so far'),
 (5516, '1588233510.630960', 2, 'info', 'Analyzed 13400 files containing 150.13 MB of data so far'),
 (5515, '1588233510.453356', 2, 'info', 'Analyzed 13300 files containing 148.75 MB of data so far'),
 (5514, '1588233510.268636', 2, 'info', 'Analyzed 13200 files containing 145.88 MB of data so far'),
 (5513, '1588233510.082652', 2, 'info', 'Analyzed 13100 files containing 143.71 MB of data so far'),
 (5512, '1588233509.919236', 2, 'info', 'Analyzed 13000 files containing 143.05 MB of data so far'),
 (5511, '1588233508.573507', 2, 'info', 'Analyzed 12900 files containing 138.53 MB of data so far'),
 (5510, '1588233507.952904', 2, 'info', 'Analyzed 12800 files containing 137.7 MB of data so far'),
 (5509, '1588233507.113230', 2, 'info', 'Analyzed 12700 files containing 136.26 MB of data so far'),
 (5508, '1588233506.421754', 2, 'info', 'Analyzed 12600 files containing 135.19 MB of data so far'),
 (5507, '1588233505.889725', 2, 'info', 'Analyzed 12500 files containing 134.55 MB of data so far'),
 (5506, '1588233504.484672', 2, 'info', 'Analyzed 12400 files containing 132.11 MB of data so far'),
 (5505, '1588233504.008887', 2, 'info', 'Analyzed 12300 files containing 131.51 MB of data so far'),
 (5504, '1588233503.349440', 2, 'info', 'Analyzed 12200 files containing 130.64 MB of data so far'),
 (5503, '1588233500.653768', 2, 'info', 'Analyzed 12100 files containing 128.81 MB of data so far'),
 (5502, '1588233500.301045', 2, 'info', 'Analyzed 12000 files containing 128.39 MB of data so far'),
 (5501, '1588233499.656667', 2, 'info', 'Analyzed 11900 files containing 127.37 MB of data so far'),
 (5500, '1588233498.905847', 2, 'info', 'Analyzed 11800 files containing 126.27 MB of data so far'),
 (5499, '1588233497.963443', 2, 'info', 'Analyzed 11700 files containing 124.65 MB of data so far'),
 (5498, '1588233496.860306', 2, 'info', 'Analyzed 11600 files containing 122.78 MB of data so far'),
 (5497, '1588233496.518703', 2, 'info', 'Analyzed 11500 files containing 122.48 MB of data so far'),
 (5496, '1588233496.236610', 2, 'info', 'Analyzed 11400 files containing 122.26 MB of data so far'),
 (5344, '1588233413.383735', 10, 'info', 'SUM_ENDSUCCESS:Fetching core, theme and plugin file signatures from Wordfence'),
 (5343, '1588233412.036510', 10, 'info', 'SUM_START:Fetching core, theme and plugin file signatures from Wordfence'),
 (5338, '1588233412.010017', 10, 'info', 'SUM_ENDOK:Checking for paths skipped due to scan settings'),
 (5335, '1588233411.995534', 10, 'info', 'SUM_START:Checking for future GeoIP support'),
 (5336, '1588233411.998338', 10, 'info', 'SUM_ENDOK:Checking for future GeoIP support'),
 (5337, '1588233412.005557', 10, 'info', 'SUM_START:Checking for paths skipped due to scan settings'),
 (5334, '1588233411.988399', 10, 'info', 'SUM_ENDOK:Checking Web Application Firewall status'),
 (5333, '1588233411.985579', 10, 'info', 'SUM_START:Checking Web Application Firewall status'),
 (5332, '1588233411.978441', 10, 'info', 'SUM_ENDOK:Scanning to check available disk space'),
 (5329, '1588233411.975008', 10, 'info', 'SUM_START:Scanning to check available disk space'),
 (5328, '1588233411.966794', 10, 'info', 'SUM_ENDOK:Checking for the most secure way to get IPs'),
 (5326, '1588233409.956185', 10, 'info', 'SUM_PAIDONLY:Checking if your site is on a domain blacklist is for paid members only'),
 (5327, '1588233411.962205', 10, 'info', 'SUM_START:Checking for the most secure way to get IPs'),
 (5325, '1588233407.953809', 10, 'info', 'SUM_PAIDONLY:Checking if your IP is generating spam is for paid members only'),
 (5494, '1588233495.587796', 2, 'info', 'Analyzed 11200 files containing 121.73 MB of data so far'),
 (5495, '1588233495.939868', 2, 'info', 'Analyzed 11300 files containing 121.96 MB of data so far'),
 (5324, '1588233405.951783', 10, 'info', 'SUM_PAIDONLY:Check if your site is being Spamvertized is for paid members only'),
 (6260, '1588471457.762641', 2, 'info', 'Done examining URLs'),
 (6261, '1588471457.763483', 10, 'info', 'SUM_ENDOK:Scanning posts for URLs on a domain blacklist'),
 (5782, '1588233777.210546', 2, 'info', 'Starting password strength check on 1 users.'),
 (5783, '1588233777.218377', 10, 'info', 'SUM_ENDOK:Scanning for weak passwords'),
 (5784, '1588233777.226147', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (5785, '1588233806.349031', 1, 'error', '<br />\n<b>Notice</b>:  Ha ocurrido un error inesperado. Puede que algo vaya mal con WordPress.org o la configuración de este servidor. Si sigues teniendo problemas, por favor, prueba en los <a href=\"https://es.wordpress.org/support/\">foros de soporte</a>. (WordPress no ha podido establecer una conexión segura con WordPress.org. Por favor, contacta con el administrador de tu servidor). in <b>/home/vicodigi/public_html/modelox/wp-includes/update.php</b> on line <b>162</b><br />\n'),
 (6262, '1588471457.769477', 10, 'info', 'SUM_START:Scanning comments for URLs on a domain blacklist'),
 (6263, '1588471457.775997', 2, 'info', 'Checking 4 host keys against Wordfence scanning servers.'),
 (6264, '1588471458.328311', 2, 'info', 'Done host key check.'),
 (6265, '1588471458.329861', 10, 'info', 'SUM_ENDOK:Scanning comments for URLs on a domain blacklist'),
 (6266, '1588471458.340774', 10, 'info', 'SUM_START:Scanning for weak passwords'),
 (6267, '1588471458.343423', 2, 'info', 'Starting password strength check on 1 users.'),
 (6268, '1588471458.351061', 10, 'info', 'SUM_ENDOK:Scanning for weak passwords'),
 (6269, '1588471458.357379', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (6270, '1588471460.927046', 10, 'info', 'SUM_ENDBAD:Scanning for old themes, plugins and core files'),
 (6271, '1588471460.934241', 10, 'info', 'SUM_START:Scanning for admin users not created through WordPress'),
 (6272, '1588471460.938817', 10, 'info', 'SUM_ENDOK:Scanning for admin users not created through WordPress'),
 (6273, '1588471460.946039', 10, 'info', 'SUM_START:Scanning for suspicious site options'),
 (6274, '1588471460.952309', 2, 'info', 'Examining URLs found in the options we scanned for dangerous websites'),
 (6275, '1588471460.952744', 2, 'info', 'Done examining URLs'),
 (6276, '1588471460.953753', 10, 'info', 'SUM_ENDOK:Scanning for suspicious site options'),
 (6277, '1588471460.959157', 1, 'info', '-------------------'),
 (6278, '1588471460.959646', 2, 'info', 'Wordfence used 14.46 MB of memory for scan. Server peak memory usage was: 94.96 MB'),
 (6279, '1588471460.959906', 1, 'info', 'Scan Complete. Scanned 14077 files, 8 plugins, 2 themes, 3 posts, 1 comments and 14017 URLs in 6 minutes 42 seconds.'),
 (6280, '1588471460.960149', 10, 'info', 'SUM_FINAL:Scan complete. You have 2 new issues to fix. See below.'),
 (6281, '1588471461.564521', 1, 'error', '<br />\n<b>Warning</b>:  Invalid argument supplied for foreach() in <b>/home/vicodigi/public_html/modelox/wp-content/plugins/duplicator-pro/lib/edd/EDD_SL_Plugin_Updater.php</b> on line <b>294</b><br />\n0'),
 (6292, '1592977515.218644', 10, 'info', 'SUM_PREP:Preparing a new scan.'),
 (6293, '1592977515.221052', 1, 'info', 'Initiating quick scan'),
 (6294, '1592977515.223863', 10, 'info', 'SUM_START:Checking Web Application Firewall status'),
 (6295, '1592977515.224377', 10, 'info', 'SUM_ENDOK:Checking Web Application Firewall status'),
 (6296, '1592977515.229782', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (6297, '1592977515.257502', 10, 'info', 'SUM_ENDOK:Scanning for old themes, plugins and core files'),
 (6298, '1592977515.260962', 1, 'info', '-------------------'),
 (6299, '1592977515.261812', 2, 'info', 'Wordfence used 0 B of memory for scan. Server peak memory usage was: 80.5 MB'),
 (6300, '1592977515.262103', 1, 'info', 'Quick Scan Complete. Scanned in less than 1 second.'),
 (6301, '1592977515.262385', 10, 'info', 'SUM_FINAL:Scan complete. Congratulations, no new problems found.'),
 (6302, '1597070483.569949', 2, 'info', 'Scanned contents of 511 additional files at 8.95 per second'),
 (6303, '1597070483.570664', 2, 'info', 'Asking Wordfence to check URLs against malware list.'),
 (6304, '1597070483.571493', 2, 'info', 'Checking 4 host keys against Wordfence scanning servers.'),
 (6305, '1597070484.066377', 2, 'info', 'Done host key check.'),
 (6306, '1597070484.069884', 2, 'info', 'Done file contents scan'),
 (6307, '1597070484.070852', 10, 'info', 'SUM_ENDOK:Scanning file contents for infections and vulnerabilities'),
 (6308, '1597070484.077920', 10, 'info', 'SUM_ENDOK:Scanning file contents for URLs on a domain blacklist'),
 (6309, '1597070484.094845', 10, 'info', 'SUM_START:Scanning for publicly accessible quarantined files'),
 (6310, '1597070484.097621', 10, 'info', 'SUM_ENDOK:Scanning for publicly accessible quarantined files'),
 (6311, '1597070484.128342', 10, 'info', 'SUM_START:Scanning posts for URLs on a domain blacklist'),
 (6312, '1597070484.316475', 2, 'info', 'Examining URLs found in posts we scanned for dangerous websites'),
 (6313, '1597070484.317112', 2, 'info', 'Done examining URLs'),
 (6314, '1597070484.318526', 10, 'info', 'SUM_ENDOK:Scanning posts for URLs on a domain blacklist'),
 (6315, '1597070484.330722', 10, 'info', 'SUM_START:Scanning comments for URLs on a domain blacklist'),
 (6316, '1597070484.342661', 2, 'info', 'Checking 4 host keys against Wordfence scanning servers.'),
 (6317, '1597070484.778431', 2, 'info', 'Done host key check.'),
 (6318, '1597070484.780255', 10, 'info', 'SUM_ENDOK:Scanning comments for URLs on a domain blacklist'),
 (6319, '1597070484.851268', 10, 'info', 'SUM_START:Scanning for weak passwords'),
 (6320, '1597070484.856079', 2, 'info', 'Starting password strength check on 1 users.'),
 (6321, '1597070485.223280', 10, 'info', 'SUM_ENDOK:Scanning for weak passwords'),
 (6322, '1597070485.413214', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (6323, '1597070539.249264', 1, 'error', 'Scan Engine Error: The signature on the request to start a scan is invalid. Please try again.'),
 (6324, '1597070618.004886', 10, 'info', 'SUM_PREP:Preparing a new scan.'),
 (6325, '1597070618.008696', 1, 'info', 'Initiating quick scan'),
 (6326, '1597070618.013328', 10, 'info', 'SUM_START:Checking Web Application Firewall status'),
 (6327, '1597070618.014143', 10, 'info', 'SUM_ENDOK:Checking Web Application Firewall status'),
 (6328, '1597070618.022796', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (6329, '1597070618.061799', 10, 'info', 'SUM_ENDBAD:Scanning for old themes, plugins and core files'),
 (6330, '1597070618.066807', 1, 'info', '-------------------'),
 (6331, '1597070618.068559', 2, 'info', 'Wordfence used 0 B of memory for scan. Server peak memory usage was: 80.5 MB'),
 (6332, '1597070618.068877', 1, 'info', 'Quick Scan Complete. Scanned in less than 1 second.'),
 (6333, '1597070618.069137', 10, 'info', 'SUM_FINAL:Scan complete. You have 2 new issues to fix. See below.'),
 (6334, '1597160015.367011', 10, 'info', 'SUM_PREP:Preparing a new scan.'),
 (6335, '1597160015.371420', 1, 'info', 'Initiating quick scan'),
 (6336, '1597160015.390600', 10, 'info', 'SUM_START:Checking Web Application Firewall status');
INSERT INTO `wp8b_wfstatus` VALUES(6337, '1597160015.391465', 10, 'info', 'SUM_ENDOK:Checking Web Application Firewall status'),
 (6338, '1597160015.400134', 10, 'info', 'SUM_START:Scanning for old themes, plugins and core files'),
 (6339, '1597160015.466564', 10, 'info', 'SUM_ENDOK:Scanning for old themes, plugins and core files'),
 (6340, '1597160015.472192', 1, 'info', '-------------------'),
 (6341, '1597160015.473355', 2, 'info', 'Wordfence used 0 B of memory for scan. Server peak memory usage was: 80.5 MB'),
 (6342, '1597160015.473735', 1, 'info', 'Quick Scan Complete. Scanned in less than 1 second.'),
 (6343, '1597160015.474116', 10, 'info', 'SUM_FINAL:Scan complete. Congratulations, no new problems found.');

/* INSERT TABLE DATA: wp8b_woocommerce_sessions */
INSERT INTO `wp8b_woocommerce_sessions` VALUES(5, '1', 'a:7:{s:4:\"cart\";s:6:\"a:0:{}\";s:11:\"cart_totals\";s:367:\"a:15:{s:8:\"subtotal\";i:0;s:12:\"subtotal_tax\";i:0;s:14:\"shipping_total\";i:0;s:12:\"shipping_tax\";i:0;s:14:\"shipping_taxes\";a:0:{}s:14:\"discount_total\";i:0;s:12:\"discount_tax\";i:0;s:19:\"cart_contents_total\";i:0;s:17:\"cart_contents_tax\";i:0;s:19:\"cart_contents_taxes\";a:0:{}s:9:\"fee_total\";i:0;s:7:\"fee_tax\";i:0;s:9:\"fee_taxes\";a:0:{}s:5:\"total\";i:0;s:9:\"total_tax\";i:0;}\";s:15:\"applied_coupons\";s:6:\"a:0:{}\";s:22:\"coupon_discount_totals\";s:6:\"a:0:{}\";s:26:\"coupon_discount_tax_totals\";s:6:\"a:0:{}\";s:21:\"removed_cart_contents\";s:6:\"a:0:{}\";s:8:\"customer\";s:715:\"a:26:{s:2:\"id\";s:1:\"1\";s:13:\"date_modified\";s:0:\"\";s:8:\"postcode\";s:0:\"\";s:4:\"city\";s:0:\"\";s:9:\"address_1\";s:0:\"\";s:7:\"address\";s:0:\"\";s:9:\"address_2\";s:0:\"\";s:5:\"state\";s:0:\"\";s:7:\"country\";s:2:\"GB\";s:17:\"shipping_postcode\";s:0:\"\";s:13:\"shipping_city\";s:0:\"\";s:18:\"shipping_address_1\";s:0:\"\";s:16:\"shipping_address\";s:0:\"\";s:18:\"shipping_address_2\";s:0:\"\";s:14:\"shipping_state\";s:0:\"\";s:16:\"shipping_country\";s:2:\"GB\";s:13:\"is_vat_exempt\";s:0:\"\";s:19:\"calculated_shipping\";s:0:\"\";s:10:\"first_name\";s:0:\"\";s:9:\"last_name\";s:0:\"\";s:7:\"company\";s:0:\"\";s:5:\"phone\";s:0:\"\";s:5:\"email\";s:27:\"vicosolutions.com@gmail.com\";s:19:\"shipping_first_name\";s:0:\"\";s:18:\"shipping_last_name\";s:0:\"\";s:16:\"shipping_company\";s:0:\"\";}\";}', 1579900095);

 /* SQL Chunk Footer Index 1 */ 

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2020-08-11 16:31:36*/
/* DUPLICATOR_PRO_MYSQLDUMP_EOF */
